#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <random>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long

mt19937 rnd(random_device);

struct vec {
    using num = int;
    int x = 0, y = 0;

    vec() {}

    vec(num X, num Y) : x(X), y(Y) {}

    vec operator+(const vec &oth) const {
        return {x + oth.x, y + oth.y};
    }

    vec operator-(const vec &oth) const {
        return {x - oth.x, y - oth.y};
    }

    num operator*(const vec &oth) const {
        return x * oth.x + y * oth.y;
    }

    num operator%(const vec &oth) const {
        return x * oth.y - y * oth.x;
    }
};

vector<vec> a;

signed main() {
    fast_in_out();
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    if (group == 1) {
        for (int i = 0; i < n / 2; ++i) {
            cout << i + 1 << ' ' << n - i << ' ';
        }
        if (n & 1) {
            cout << n / 2 + 1;
        }
    } else if (task == 1 && n <= 10) {
        vector<int> b, Ans;
        for (int i = 0; i < n; ++i) {
            b.emplace_back(i);
        }
        Ans = b;
        int ans = 0;
        do {
            int ans1 = 0;
            for (int i = 1; i < n - 1; ++i) {
                if ((a[b[i - 1]] - a[b[i]]) * (a[b[i + 1]] - a[b[i]]) > 0) {
                    ++ans1;
                }
            }
            if (ans1 >= ans) {
                ans = ans1;
                Ans = b;
            }

        } while (next_permutation(b.begin(), b.end()));
        for (auto it: Ans) {
            cout << it + 1 << ' ';
        }
    } else {
        vector<int> b, Ans;
        for (int i = 0; i < n; ++i) {
            b.emplace_back(i);
        }
        Ans = b;
        int ans = 0;
        int I = 20000;
        do {
            int ans1 = 0;
            for (int i = 1; i < n - 1; ++i) {
                if ((a[b[i - 1]] - a[b[i]]) * (a[b[i + 1]] - a[b[i]]) > 0) {
                    ++ans1;
                }
            }
            if (ans1 >= ans) {
                ans = ans1;
                Ans = b;
            }
            shuffle(b.begin(), b.end(), mt19937(random_device()()));
        } while (I--);
        for (auto it: Ans) {
            cout << it + 1 << ' ';
        }
    }
    cout << endl;
    return 0;
}
