#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <ctime>

#define int long long
#define x first
#define y second

std::mt19937 rnd(std::time(nullptr));
const int INF = 1e9;
const int MAXN = 1e5;
int MAXW = 0;

std::vector<std::pair<int, int>> p;

int check(std::vector<int> &a) {
    int cnt = 0;
    for (int i = 1; i + 1 < a.size(); i++) {
        if ((p[a[i]].x - p[a[i - 1]].x) * (p[a[i]].x - p[a[i + 1]].x) + (p[a[i]].y - p[a[i - 1]].y) * (p[a[i]].y - p[a[i + 1]].y) > 0) {
            cnt++;
        }
    }
    return cnt;
}

int n;
int max = 0;
std::vector<int> ans;
std::vector<int> a;
std::vector<bool> used;

void gen(int idx) {
    if (idx == n) {
        int c = check(a);
        if (c > max) {
            max = c;
            ans = a;
        }
        return;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            a[idx] = i;
            used[i] = true;
            gen(idx + 1);
            used[i] = false;
        }
    }
}

void solve() {
    int t, g;
    std::cin >> t >> g >> n;
    p.resize(n);
    a.resize(n);
    used.resize(n);
    for (auto &[x, y] : p) {
        std::cin >> x >> y;
    }
    if (t == 1) {
        if (g == 1) {
            int i = 0;
            std::vector<bool> used(n, false);
            while (true) {
                if (used[i]) {
                    break;
                }
                used[i] = true;
                std::cout << i + 1 << ' ';
                if (i > n / 2) {
                    i--;
                }
                i = n - i - 1;
            }
        }
        if (g == 2 || g == 0) {
            gen(0);
            for (auto e : ans) {
                std::cout << e + 1 << ' ';
            }
        }
    }
}

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
//    std::cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}
