//#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;
using ll = long long;
using ull = unsigned long long;

const int nMax = 3e5 + 228;


using dd = tree<pair<int, int>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using num = ll;

struct vec {
    num x, y;

    vec(num x = 0, num y = 0) : x(x), y(y) {}

    vec &operator+=(vec oth) {
        x += oth.x;
        y += oth.y;
        return *this;
    }

    vec operator+(vec oth) {
        return oth += *this;
    }

    vec &operator-=(vec oth) {
        x -= oth.x;
        y -= oth.y;
        return *this;
    }

    vec operator-(vec oth) {
        auto t = *this;
        return t -= oth;
    }

    num operator*(vec oth) {
        return x * oth.x + y * oth.y;
    }
};

vec pts[nMax];
int order[nMax];
int bestOrd[nMax];

void solve() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        num x, y;
        cin >> x >> y;
        pts[i] = vec(x, y);
    }
    mt19937 kek(228);
    if (task == 1) {
        int ans = 0;
        for (int i = 0; i < n; i++)order[i] = i;
        for (ll i = 0; i < n * 3; i++) {
            shuffle(order, order + n, kek);
            int counter = 0;
            for (int i = 1; i + 1 < n; i++) {
                if ((pts[order[i]] - pts[order[i - 1]]) * (pts[order[i]] - pts[order[i + 1]]) > 0)counter++;
            }
            if (counter > ans) {
                copy(order, order + n, bestOrd);
                ans = counter;
            }
        }
        cout << bestOrd[0] + 1;
        for (int i = 1; i < n; i++) {
            cout << ' ' << bestOrd[i] + 1;
        }
        cout << endl;
        return;
    }

    if (true) {
        int c;
        cin >> c;
        //c = 25;
        for (int i = 0; i < n; i++)order[i] = i;
        for (ll i = 0; i < 300000000ll; i++) {
            shuffle(order, order + n, kek);
            int counter = 0;
            for (int i = 1; i + 1 < n; i++) {
                if ((pts[order[i]] - pts[order[i - 1]]) * (pts[order[i]] - pts[order[i + 1]]) > 0)counter++;
            }
            if (counter <= c) {
                cout << order[0] + 1;
                set<int> o = {order[0]};
                for (int i = 1; i < n; i++) {
                    if (o.count(order[i]))assert(0);
                    o.insert(order[i]);
                    cout << ' ' << order[i] + 1;
                }
                cout << endl;
                return;
            }
        }
        return;
    }
}

int main() {
#ifdef VANT
    freopen("output.txt", "w", stdout);
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int q = 1;
    //cin>>q;
    while (q--) {
        solve();
        //    cout << '\n';
    }
}
