#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;
using ll = long long;
using ull = unsigned long long;

const int nMax = 3e5 + 228;


using dd = tree<pair<int, int>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

using num = ll;

struct vec {
    num x, y;

    vec(num x = 0, num y = 0) : x(x), y(y) {}

    vec &operator+=(vec oth) {
        x += oth.x;
        y += oth.y;
        return *this;
    }

    vec operator+(vec oth) {
        return oth += *this;
    }

    vec &operator-=(vec oth) {
        x -= oth.x;
        y -= oth.y;
        return *this;
    }

    vec operator-(vec oth) {
        auto t = *this;
        return t -= oth;
    }

    num operator*(vec oth) {
        return x * oth.x + y * oth.y;
    }
};

vector<pair<int, int>> g[5001][5001];
vec pts[nMax];
int ans = 5001;
int cur = 0;
int uC = 0;
int curT[5001];
int bestT[5001];
bool used[5001];
int n;
int c;
bool have = false;
int task, group;

void dfs(int u1, int u2) {
    if (cur > c)return;
    if (ans <= c && task == 1)return;
    if (ans == c)return;
    curT[uC] = u2;
    if (uC + 1 == n) {
        if ((cur == c && cur <= ans) || (cur < ans && task == 1)) {
            have = true;
            copy(curT, curT + n, bestT);
            ans = cur;
        }
        return;
    }
    used[u2] = true;

    uC++;
    for (auto [u3, w]: g[u1][u2]) {
        if (used[u3])continue;
        cur += w;
        dfs(u2, u3);
        cur -= w;
    }
    used[u2] = false;
    uC--;
}

void solve() {

    cin >> task >> group;

    cin >> n;
    for (int i = 0; i < n; i++) {
        bestT[i] = i;
        num x, y;
        cin >> x >> y;
        pts[i] = vec(x, y);
    }
    if (task != 1)
        cin >> c;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (j == i)continue;
            for (int k = 0; k < n; k++) {
                if (k == j)continue;
                bool sharp = ((pts[j] - pts[i]) * (pts[j] - pts[k])) > 0;
                g[i][j].push_back({k, sharp ^ (task == 1)});
            }
        }
    }
    int q = 1;
    if (task == 3)
        cin >> q;
    for (int i = 0; i < q; i++) {
        int t = c;
        if (task == 3)
            cin >> t;
        c = t;
        uC = 1;
        ans = 5001;
        for (int i = 0; i < n; i++) {
            used[i] = true;
            curT[0] = i;
            for (int j = 0; j < n; j++) {
                if (i == j)continue;
                dfs(i, j);
            }
            used[i] = false;
        }
        //if (!have)assert(0);
        for (int i = 0; i < n; i++) {
            cout << bestT[i] + 1;
            if (i + 1 < n)cout << ' ';
        }
        cout << endl;
    }

}

int main() {
#ifdef VANT
    freopen("output.txt", "w", stdout);
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int q = 1;
    //cin>>q;
    while (q--) {
        solve();
        //    cout << '\n';
    }
}
