#pragma GCC optimize("O3,Ofast,inline,unroll-loops")

#include<bits/stdc++.h>
#define ft first
#define sc second
#define all(x) x.begin(),x.end()
using ll = long long;
using ld = long double;
using ul = unsigned long long;
using li = __int128;
using ui = unsigned;
using namespace std;
const ll inf = 1e18, mod = 1e9+7;
struct vect {
    ll x, y;
    vect(ll x_ = 0, ll y_ = 0) {x = x_; y = y_;}
    ll lensq() {
        return x*x+y*y;
    }
};
vect operator - (vect a, vect b) {
    return vect(a.x-b.x, a.y-b.y);
}
inline array<int, 4> merge(const array<int, 4> &a, const array<int, 4> &b){
    array<int, 4> ret;
    if (a[0] > b[0]) {
        ret[0] = a[0];
        ret[1] = a[1];
    } else {
        ret[0] = b[0];
        ret[1] = b[1];
    }
    if (a[2] > b[2]) {
        ret[2] = a[2];
        ret[3] = a[3];
    } else {
        ret[2] = b[2];
        ret[3] = b[3];
    }
    return ret;
};
vector<array<int, 4>> tr;
void upd (int i, int l, int r, int j, array<int, 4> val){
    if (j < l || r <= j) return;
    if (l+1 == r) {
        tr[i] = val;
    } else {
        int k = (l+r)/2;
        upd(2*i+1, l, k, j, val);
        upd(2*i+2, k, r, j, val);
        tr[i] = merge(tr[2*i+1], tr[2*i+2]);
    }
};
array<int, 4> get(int i, int l, int r, int ql, int qr){
    if (qr <= l || r <= ql) return {0, -1, 0, -1};
    if (ql <= l && r <= qr) return tr[i];
    int k = (l+r)/2;
    return merge(get(2*i+1, l, k, ql, qr), get(2*i+2, k, r, ql, qr));
};
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());
    int task, gr, n;
    cin >> task >> gr >> n;
    vector<vect> v(n);
    for (int i = 0; i < n; i++) cin >> v[i].x >> v[i].y;
    if (task == 1) {
        return 0;
        vector<int> used(n, 0);
        int i = 0; used[i] = 1;
        cout << "1 ";
        for (int _ = 0; _ < n-1; _++) {
            int j = i; ll vj = 0;
            for (int y = 0; y < n; y++) {
                if (!used[y] && (v[y]-v[i]).lensq() > vj) {
                    j = y;
                    vj = (v[y]-v[i]).lensq();
                }
            }
            used[j] = 1;
            i = j;
            cout << j+1 << " ";
        }
        cout << endl;
        return 0;
    } else if (task == 2) {
        vector<array<int, 4>> dp(n);
        vector<pair<int, int>> v2(n);
        vector<int> used(n, 0);
        map<int, int> mp;
        for (int i = 0; i < n; i++) {
            v2[i] = {v[i].x, v[i].y};
            mp[v[i].y] = 0;
        }
        int cnt = 0; for (auto &[x, y] : mp) y = cnt++;
        for (int i = 0; i < n; i++) v2[i].sc = mp[v2[i].sc];
        sort(all(v2));

        while (1) {
            int curv = -1, cur = -1, curb;
            tr.assign(4*n, {0, -1, 0, -1});
            for (int i = 0; i < n; i++) {
                if (used[i]) continue;
                auto d = get(0, 0, n, 0, v2[i].sc);
                auto u = get(0, 0, n, v2[i].sc+1, n);
                dp[i] = {d[0]+1, d[1], u[2]+1, u[3]};
                if (dp[i][0] > curv) {
                    curv = dp[i][0];
                    cur = i;
                    curb = 0;
                }
                if (dp[i][2] > curv) {
                    curv = dp[i][2];
                    cur = i;
                    curb = 1;
                }
                upd(0, 0, n, v2[i].sc, {dp[i][0], i, dp[i][2], i});
            }
            if (cur == -1) break;
            while (cur != -1) {
                cout << cur+1 << " ";
                used[cur] = 1;
                cur = (curb ? dp[cur][3] : dp[cur][1]);
            }
        }
        cout << endl;
    }
}
