#pragma GCC optimize("O3,Ofast,inline,unroll-loops")

#include<bits/stdc++.h>
#define ft first
#define sc second
#define all(x) x.begin(),x.end()
using ll = long long;
using ld = long double;
using ul = unsigned long long;
using li = __int128;
using ui = unsigned;
using namespace std;
const ll inf = 1e18, mod = 1e9+7;
struct vect {
    ll x, y;
    vect(ll x_ = 0, ll y_ = 0) {x = x_; y = y_;}
    ll lensq() {
        return x*x+y*y;
    }
};
vect operator - (vect a, vect b) {
    return vect(a.x-b.x, a.y-b.y);
}
vector<pair<int, int>> tru, trd;
void upd(vector<pair<int, int>> &tr, int i, pair<int, int> val, int n){
    for (int j = i; j <= n; j += (j&-j)) tr[j] = max(tr[j], val);
}
pair<int, int> get(vector<pair<int, int>> &tr, int i){
    pair<int, int> ret = {0, -1};
    for (int j = i; j > 0; j -= (j&-j)) ret = max(ret, tr[j]);
    return ret;
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());
    int task, gr, n;
    cin >> task >> gr >> n;
    vector<vect> v(n);
    for (int i = 0; i < n; i++) cin >> v[i].x >> v[i].y;
    if (task == 1) {
        vector<int> used(n, 0);
        int i = 0; used[i] = 1;
        cout << "1 ";
        for (int _ = 0; _ < n-1; _++) {
            int j = i; ll vj = 0;
            for (int y = 0; y < n; y++) {
                if (!used[y] && (v[y]-v[i]).lensq() > vj) {
                    j = y;
                    vj = (v[y]-v[i]).lensq();
                }
            }
            used[j] = 1;
            i = j;
            cout << j+1 << " ";
        }
        cout << endl;
        return 0;
    } else if (task == 2) {
        int analhui; cin >> analhui;
        vector<array<int, 4>> dp(n);
        vector<array<ll, 3>> v2(n);
        vector<int> used(n, 0);
        map<int, int> mp;
        for (int i = 0; i < n; i++) {
            v2[i] = {v[i].x, v[i].y, i};
            mp[v[i].y] = 0;
        }
        int cnt = 0; for (auto &[x, y] : mp) y = cnt++;
        for (int i = 0; i < n; i++) v2[i][1] = mp[v2[i][1]];
        sort(all(v2));
        while (1) {
            int curv = -1, cur = -1, curb;
            tru.assign(n+1, {0, -1});
            trd.assign(n+1, {0, -1});
            for (int i = 0; i < n; i++) {
                if (used[v2[i][2]]) continue;
                auto d = get(trd, v2[i][1]);
                auto u = get(tru, n-v2[i][1]-1);
                dp[i] = {d.ft+1, d.sc, u.ft+1, u.sc};
                if (dp[i][0] > curv) {
                    curv = dp[i][0];
                    cur = i;
                    curb = 0;
                }
                if (dp[i][2] > curv) {
                    curv = dp[i][2];
                    cur = i;
                    curb = 1;
                }
                upd(trd, v2[i][1]+1, {dp[i][0], i}, n);
                upd(tru, n-v2[i][1], {dp[i][2], i}, n);
                //upd(0, 0, n, v2[i][1], {{dp[i][0], i}, {dp[i][2], i}});
            }
            if (cur == -1) break;
            while (cur != -1) {
                cout << v2[cur][2]+1 << " ";
                used[v2[cur][2]] = 1;
                cur = (curb ? dp[cur][3] : dp[cur][1]);
            }
        }
        cout << endl;
    }
}
