#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ordered_set = tree<ll, less<>, null_type, tree_tag, tree_order_statistics_node_update>;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    // cin >> t;
    while (t--)
        solve();
}

void solve() {
    ll task, g, n;
    cin >> task >> g >> n;
    vector<pair<ll, ll>> v(n);
    for (auto &[x, y]: v)
        cin >> x >> y;
    if (task == 1) {
        if (n > 10) {
            sort(all(v));
            for (ll i = 1; i <= n - i + 1; i++) {
                cout << i << ' ';
                if (n - i + 1 != i)
                    cout << n - i + 1 << ' ';
            }
            return;
        }
        vector<ll> ndx(n);
        for (ll i = 0; i < n; i++)
            ndx[i] = i;
        vector<ll> mx(n);
        ll ans = 0;
        while (1) {
            ll cnt = 0;
            for (ll i = 1; i < n - 1; i++) {
                auto [x, y] = v[ndx[i]];
                auto [x1, y1] = v[ndx[i - 1]];
                auto [x2, y2] = v[ndx[i + 1]];

                ll l1 = (x - x1) * (x - x1) + (y - y1) * (y - y1);
                ll l2 = (x - x2) * (x - x2) + (y - y2) * (y - y2);
                ll l3 = (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
                if (l1 + l2 > l3)
                    cnt++;
            }
            if (ans < cnt) {
                ans = cnt;
                mx = ndx;
            }
            if (!next_permutation(all(ndx)))
                break;
        }
        for (ll i: mx)
            cout << i + 1 << '\n';
    } else if (task == 2) {
        int c;
        cin >> c;
        vector<ll> ndx(n);
        for (ll i = 0; i < n; i++)
            ndx[i] = i;
        vector<ll> mx(n);
        mt19937 rnd(1);
        while (1) {
            ll cnt = 0;
            for (ll i = 1; i < n - 1; i++) {
                auto [x, y] = v[ndx[i]];
                auto [x1, y1] = v[ndx[i - 1]];
                auto [x2, y2] = v[ndx[i + 1]];

                ll l1 = (x - x1) * (x - x1) + (y - y1) * (y - y1);
                ll l2 = (x - x2) * (x - x2) + (y - y2) * (y - y2);
                ll l3 = (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
                if (l1 + l2 > l3)
                    cnt++;
            }
            if (c >= cnt) {
                mx = ndx;
                break;
            }
            shuffle(all(ndx), rnd);
        }
        for (ll i: mx)
            cout << i + 1 << '\n';
    }
}