#include <bits/extc++.h>

using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ordered_set = tree<int, null_type, std::less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define ff first
#define ss second
//#define int ll

struct point {
    int x, y;

    point operator-(const point p) {
        return {x - p.x, y - p.y};
    }
};

ll dot_pr(const point v, const point u) {
    return v.x * u.x + v.y * u.y;
}

ll dist(const point u, const point v) {
    return (u.x - v.x) * (u.x - v.x) + (u.y - v.y) * (u.y - v.y);
}

void solve() {
    int task, g; std::cin >> task >> g;
    int n; std::cin >> n;
    if (task == 1) {
        std::vector<point>a(n);
        for (int i = 0; i < n; ++i) std::cin >> a[i].x >> a[i].y;
        int cur = 0;
        std::cout << cur + 1 << ' ';
        std::vector<int>used(n);
        used[cur] = 1;
        for (int i = 0; i < n - 1; ++i) {
            int can = cur;
            for (int j = 0; j < n; ++j) {
                if (used[j]) continue;
                if (can == cur || dist(a[can], a[cur]) < dist(a[j], a[cur])) {
                    can = j;
                }
            }
            used[can] = 1;
            std::cout << can + 1 << ' ';
            cur = can;
        }
        std::cout << '\n';
        return;
    }
    exit(1);
}

int32_t main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);

    int T = 1;
//    std::cin >> T;
    while(T--) {
        solve();
    }

    return 0;
}