#include <iostream>
#include <algorithm>
#include <numeric>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <cctype>
#include <iomanip>
#include <queue>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pri = pair<int, int>;

const int inf = 1e9 + 100;
const int mod = 1e9 + 9;

int add(int a, int b) {
	return a + b < mod ? a + b : a + b - mod;
}

int rem(int a, int b) {
	return a - b >= 0  ? a - b : a - b + mod;
}

int mul(int a, int b) {
	return 1ll * a * b % mod;
}

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int bin_pow(int a, int b) {
	if (b == 0) return 1;
	if (b % 2) return 1ll * a * bin_pow(a, b - 1) % mod;
	ll z = bin_pow(a, b / 2);
	return z * z % mod;
}

istream& operator>>(istream& in, vector<int>& a) {
	for (auto& i : a) {
		in >> i;
	}
	return in;
}

ostream& operator >>(ostream& out, vector<int>& a) {
	for (auto& i : a) {
		out << i << ' ';
	}
	out << '\n';
	return out;
}

struct Point {
	int x, y, num;
	Point() {}
};

bool operator <(const Point& a, const Point& b) {
	return a.x < b.x;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int task, group;
	cin >> task >> group;
	int n;
	cin >> n;
	vector<Point> vec(n);
	for (int i = 0; i < n; i++) {
		cin >> vec[i].x >> vec[i].y;
		vec[i].num = i;
	}
	sort(vec.begin(), vec.end());
	for (int i = 1; i <= n; i += 2) {
		cout << i << ' ';
	}
	for (int i = 0; i <= n; i += 2) {
		cout << i << ' ';
	}

	
}