#include <bits/stdc++.h>

using namespace std;

using ll = long long;

ll val(ll x1, ll y1, ll x2, ll y2) {

    return x1 * y2 - x2 * y1;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int task, gr; cin >> task >> gr;
    int n; cin >> n;
    vector <pair <pair <int, int>, int>> a(n);

    int I = 1;
    for (auto &x : a)
        cin >> x.first.first >> x.first.second, x.second = I++;

    if (gr == 1) {
        int l = 1, r = n;
        for (int i = 0; i < n; i++) {
            if (i & 1) cout << r-- << " ";
            else cout << l++ << " ";
        }
        cout << endl;
        return 0;
    }

    sort(a.begin(), a.end());

    int mx = -1;
    vector <int> ans;

    do {
        int res = 0;
        for (int i = 1; i < n - 1; i++) {
            int x1 = a[i - 1].first.first - a[i].first.first;
            int y1 = a[i - 1].first.second - a[i].first.second;
            int x2 = a[i + 1].first.first - a[i].first.first;
            int y2 = a[i + 1].first.second - a[i].first.second;
            res += val(x1, y1, x2, y2) > 0;
        }
        if (res > mx) {
            mx = res;
            ans.clear();
            for (auto x : a) ans.push_back(x.second);
        }
    } while(next_permutation(a.begin(), a.end()));

    for (auto x : ans) cout << x << " ";
    cout << "\n";

    return 0;
}
