#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define ll long long
#define int ll
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int maxn = 1e5 + 10;

int T, G, n;
pii a[maxn];

bool is(pii p1, pii p2, pii p3) {
    pii v1 = {p1.X - p2.X, p1.Y - p2.Y};
    pii v2 = {p3.X - p2.X, p3.Y - p2.Y};
    int dot_prod = v1.X * v2.X + v1.Y * v2.Y;
    return dot_prod > 0;
}

void solve() {
    cin >> T >> G >> n;
    for(int i = 0; i < n; ++i) cin >> a[i].X >> a[i].Y;
    if(T == 1) {
        if(n <= 10) {
            vector<int> inds(n);
            iota(all(inds), 0);
            int mx = 0;
            vector<int> ans = inds;
            do {
                int cnt = 0;
                for(int i = 1; i < n - 1; ++i) {
                    pii p1 = a[inds[i - 1]], p2 = a[inds[i]], p3 = a[inds[i + 1]];
                    if(is(p1, p2, p3)) ++cnt;
                }
                if(cnt > mx) {
                    mx = cnt;
                    ans = inds;
                }
            } while(next_permutation(all(inds)));
            for(auto to : ans) cout << to + 1 <<  " ";
        }
        else if(G == 1) {
            vector<int> ans;
            ans.pb(1);
            ans.pb(n);
            int x = n;
            while(x - 2 > 1) {
                if(x - 2 > 1) {
                    ans.pb(x - 2);
                    ans.pb(x - 1);
                }
                x -= 2;
            }
            if(n % 2) ans.pb(2);
            for(int i = 0; i < n; ++i) cout << ans[i] << " ";
        }
    } else if(T == 3) {
        int c, q;
        cin >> c >> q;
        vector<int> ans;
        ans.pb(1);
        ans.pb(n);
        int x = n;
        while(x - 2 > 1) {
            if(x - 2 > 1) {
                ans.pb(x - 2);
                ans.pb(x - 1);
            }
            x -= 2;
        }
        if(n % 2) ans.pb(2);
        while(q--) {
            int k;
            cin >> k;
            vector<int> ans1 = ans;
            for(int cnt = 0; cnt < n - 3 - k; ++cnt) {
                swap(ans1[2 * (cnt + 1)], ans1[2 * (cnt + 1) + 1]);
            }
            for(auto i : ans1) cout << i << " ";
            cout << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
    return 0;
}
