//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
//typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define all(a) a.begin(), a.end()
#define rd(a) for (auto &i: a) cin >> i;

ll INF = 1e13;
ll MOD = 1e9 + 7;


ld angle(pair<ld, ld> x) {
    return atan2(x.second, x.first);
}

void solve() {

    ll task, group;
    cin >> task >> group;
    ll n;
    cin >> n;
    pair<ll, ll> l, r;

    vector<pair<ld, ld>> w;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        w.push_back({x, y});
    }
    if (task == 1) {
        vector<ll> ans;
        vector<ll> per(n);
        for (int i = 0; i < n; i++) {
            per[i] = i;
        }
        ll mx = 0;
        vector<ll> itog;
        do {

            ll cnt = 0;
            for (int i = 2; i < n; i++) {
                l = w[per[i - 2]];
                r = w[per[i - 1]];
                auto [x, y] = w[per[i]];
                pair<ll, ll> BA = {l.first - r.first, l.second - r.second};
                pair<ll, ll> CB = {x - r.first, y - r.second};
                ld a1 = angle(BA);
                ld a2 = angle(CB);

                ld ang = a1 - a2;
                while (ang < 0) {
                    ang += 2 * M_PI;
                }
                while (ang >= 2 * M_PI) {
                    ang -= 2 * M_PI;
                }
                if (ang >= M_PI) {
                    ang -= M_PI;
                }
                if (ang < M_PI / 2) cnt++;
            }
            if (cnt >= mx) {
                mx = cnt;
                itog = per;
            }

        } while (next_permutation(all(per)));
        for (auto c: itog) {
            cout << c + 1 << " ";
        }
        cout << endl;
    } else {
        ll mx;
        cin >> mx;
        bool f = true;
        for (int i = 1; i < n; i++) {
            if (w[i].first < w[i - 1].first || w[i].second < w[i - 1].second) {
                f = false;
                break;
            }
        }
        if (f) {
            vector<ll> ans;
            for (int i = 0; i < n; i++) {
                ans.push_back(i);
            }
            for (auto c: ans) {
                cout << c + 1 << " ";
            }
            cout << endl;
        } else {
            vector<ll> per(n);
            for (int i = 0; i < n; i++) {
                per[i] = i;
            }
            while (true) {
                std::random_shuffle(per.begin(), per.end());
                ll cnt = 0;
                for (int i = 2; i < n; i++) {
                    l = w[per[i - 2]];
                    r = w[per[i - 1]];
                    auto [x, y] = w[per[i]];
                    pair<ll, ll> BA = {l.first - r.first, l.second - r.second};
                    pair<ll, ll> CB = {x - r.first, y - r.second};
                    ld a1 = angle(BA);
                    ld a2 = angle(CB);

                    ld ang = a1 - a2;
                    while (ang < 0) {
                        ang += 2 * M_PI;
                    }
                    while (ang >= 2 * M_PI) {
                        ang -= 2 * M_PI;
                    }
                    if (ang >= M_PI) {
                        ang -= M_PI;
                    }
                    if (ang < M_PI / 2) cnt++;
                }
                if (cnt <= mx) {
                    break;
                }
            }
            for (auto c: per) {
                cout << c + 1 << " ";
            }
            cout << endl;
        }
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    //ll t; for (cin >> t; t--;) solve();
    solve();

}

//void operator delete(void*) {};
//const int MAX_MEM = 3 * 1e8;
//int pos = 0;
//char buf[MAX_MEM];
//void* operator new(size_t x) {
//    void* pointer = (void*)(buf + pos);
//    pos += x;
//    if (pos >= MAX_MEM) {
//        pos = 1e6;
//    }
//    return pointer;
//
//}


