#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <deque>

typedef long long ll;

using namespace std;

ll angle(ll x1, ll y1, ll x2, ll y2){
    return x2 * x1 + y2 * y1;
}

int main(){
    int task, g, n;
    cin >> task >> g >> n;
    vector <int> x(n), y(n);
    for(int i = 0; i < n; i++){
        cin >> x[i] >> y[i];
    }
    if(task == 1){
        vector <int> ans;
        deque <int> d;
        for(int i = 2; i < n; i++){
            d.push_back(i);
        }
        ans.push_back(0), ans.push_back(1);
        while(!d.empty()){
            int cur = d.front();
            d.pop_front();
            while(ans.size() >= 2 && angle(x[ans.size() - 2] - x[ans.back()], y[ans.size() - 2] - y[ans.back()], x[cur] - x[ans.back()], y[cur] - y[ans.back()]) <= 0){
                d.push_front(ans.back()), ans.pop_back();
            }
            ans.push_back(cur);
        }
        for(int i = 0; i < ans.size(); i++){
            cout << ans[i] + 1 << " ";
        }
    }
}