#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

struct dot
{
    ll x, y;

    dot(ll _x, ll _y)
    {
        x = _x;
        y = _y;
    }
    dot()
    {
        x = 0;
        y = 0;
    }

    dot operator+(dot o)
    {
        return dot(x + o.x, y + o.y);
    }
    dot operator*(int k)
    {
        return dot(x * k, y * k);
    }
    dot operator-(dot o)
    {
        return (*this) + (o * -1);
    }

    ll operator*(dot o)
    {
        return x * o.x + y * o.y;
    }

    ll operator%(dot o)
    {
        return x * o.y - y * o.x;
    }

};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int task, group;
    cin >> task >> group;

    vector<dot> v;
    int n;
    cin >> n;
    for(int i = 0; i < n; ++i)
    {
        int x, y;
        cin >> x >> y;
        v.emplace_back(x, y);
    }

    if(task == 1)
    {
        vector<int> ans(n);
        for(int i = 0; i < n; ++i)
        {
            ans[i] = i + 1;
        }
        for(int i = 1; i < n - 1; ++i)
        {
            if(i == 0)
            {
                continue;
            }
            if(((v[i] - v[i-1]) * -1)  * (v[i + 1] - v[i]) <= 0)
            {
                swap(v[i], v[i + 1]);
                swap(ans[i], ans[i + 1]);
                i -= 2;
            }
        }

        for(int i = 0; i < n; ++i)
        {
            cout << ans[i] << ' ';
        }
        cout << endl;
    }

}