#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

struct dot
{
    ll x, y;

    dot(ll _x, ll _y)
    {
        x = _x;
        y = _y;
    }
    dot()
    {
        x = 0;
        y = 0;
    }

    dot operator+(dot o)
    {
        return dot(x + o.x, y + o.y);
    }
    dot operator*(int k)
    {
        return dot(x * k, y * k);
    }
    dot operator-(dot o)
    {
        return (*this) + (o * -1);
    }

    ll operator*(dot o)
    {
        return x * o.x + y * o.y;
    }

    ll operator%(dot o)
    {
        return x * o.y - y * o.x;
    }

};

int main()
{

    int task, group;
    cin >> task >> group;

    vector<pair<dot, int>> v;
    int n;
    cin >> n;
    for(int i = 0; i < n; ++i)
    {
        int x, y;
        cin >> x >> y;
        v.emplace_back(dot(x, y), i + 1);
    }

    random_shuffle(v.begin(), v.end());

    if(task == 1)
    {

        for(int i = 1; i < n - 1; ++i)
        {
            if(i == 0)
            {
                continue;
            }
            if(((v[i].first - v[i-1].first) * -1)  * (v[i + 1].first - v[i].first) <= 0)
            {
                swap(v[i], v[i + 1]);
                i -= 2;
            }
        }

        for(int i = 0; i < n; ++i)
        {
            cout << v[i].second << ' ';
        }
        cout << endl;
        return 0;
    }
    if(task == 2)
    {
        int c;
        cin >> c;

        for(int i = 2; i < n; ++i)
        {
            for(int j = i; j < n; ++j)
            {
                if((v[i-2].second - v[i-1].second)*(v[j].second - v[i-1].second) <= 0)
                {
                    swap(v[i], v[j]);
                    break;
                }
            }
        }
        
        for(int i = 0; i < n; ++i)
        {
            cout << v[i].second << ' ';
        }
        cout << endl;
    }

}