#include <bits/stdc++.h>

#pragma GCC optimize("03")
#pragma GCC target("avx2")

using namespace std;

using ll = long long;
using ld = long double;

using pld = pair<ld, ld>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using vin = vector<int>;
using vll = vector<ll>;
using vld = vector<ld>;
using vbo = vector<bool>;
using vpl = vector<pll>;
using vpi = vector<pii>;
using vpd = vector<pld>;

using vvi = vector<vin>;
using vvl = vector<vll>;
using vvo = vector<vbo>;

#define sz(a) (ll)a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for(int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for (auto &i : a)

#define fastio ios_base::sync_with_stdio(false);cin.tie(0)

ll n;
vvl points;
mt19937 rnd(7867342);

bool check(pll p1, pll p2, pll p3) {
    ll d1 = (p1.first - p3.first) * (p1.first - p3.first) + (p1.second - p3.second) * (p1.second - p3.second);
    ll d2 = (p2.first - p3.first) * (p2.first - p3.first) + (p2.second - p3.second) * (p2.second - p3.second);
    ll d3 = (p1.first - p2.first) * (p1.first - p2.first) + (p1.second - p2.second) * (p1.second - p2.second);
    return d1 < d2 + d3;
}

void solve1() {
    auto t = clock();
    ll best_ans = 0;
    vll best_seq;
    vll used(n, 0);
    ll timer = 0;
    while ((ld) (clock() - t) / (ld) CLOCKS_PER_SEC < 1.8) {
        timer++;
        shuffle(all(points), rnd);

        vll seq;
        seq.pub(points[0][2]);
        seq.pub(points[1][2]);
        ll cnt = 0;
        used[0] = timer;
        used[1] = timer;
        pll p1 = {points[0][0], points[0][1]};
        pll p2 = {points[1][0], points[1][1]};
        pll p3;
        F0R(i, n - 2) {
            bool found = false;
            F0R(j, n) {
                if (used[j] != timer) {
                    p3 = {points[j][0], points[j][1]};
                    if (check(p1, p2, p3)) {
                        used[j] = timer;
                        found = true;
                        p1 = p2;
                        p2 = p3;
                        cnt++;
                        seq.pub(points[j][2]);
                    }
                }
                if (found) {
                    break;
                }
            }
            if (found) {
                continue;
            }
            F0R(j, n) {
                if (used[j] != timer) {
                    p3 = {points[j][0], points[j][1]};
                    used[j] = timer;
                    p1 = p2;
                    p2 = p3;
                    seq.pub(points[j][2]);
                    break;
                }
            }
        }
        if (cnt > best_ans) {
            best_ans = cnt;
            best_seq = seq;
            if (best_ans == n - 2) {
                break;
            }
        }
    }
    F0R(i, n) {
        cout << best_seq[i] + 1 << ' ';
    }
    cout.flush();
}

void solve2() {
    auto t = clock();
    vll best_seq;
    vll used(n, 0);
    ll timer = 0;
    ll c;
    cin >> c;
    while ((ld) (clock() - t) / (ld) CLOCKS_PER_SEC < 1.8) {
        timer++;
        shuffle(all(points), rnd);
        vll seq;
        seq.pub(points[0][2]);
        seq.pub(points[1][2]);
        ll cnt = 0;
        used[0] = timer;
        used[1] = timer;
        pll p1 = {points[0][0], points[0][1]};
        pll p2 = {points[1][0], points[1][1]};
        pll p3;
        F0R(i, n - 2) {
            if (cnt > c) {
                break;
            }
            bool found = false;
            F0R(j, n) {
                if (used[j] != timer) {
                    p3 = {points[j][0], points[j][1]};
                    if (cnt < c && check(p1, p2, p3)) {
                        used[j] = timer;
                        found = true;
                        p1 = p2;
                        p2 = p3;
                        cnt++;
                        seq.pub(points[j][2]);
                    } else if (!check(p1, p2, p3)) {
                        used[j] = timer;
                        found = true;
                        p1 = p2;
                        p2 = p3;
                        seq.pub(points[j][2]);
                    }
                }
                if (found) {
                    break;
                }
            }
            if (found) {
                continue;
            }
            F0R(j, n) {
                if (used[j] != timer) {
                    p3 = {points[j][0], points[j][1]};
                    used[j] = timer;
                    cnt += check(p1, p2, p3);
                    p1 = p2;
                    p2 = p3;
                    seq.pub(points[j][2]);
                    break;
                }
            }
        }
        if (cnt == c) {
            best_seq = seq;
            break;
        }
    }
    F0R(i, n) {
        cout << best_seq[i] + 1 << ' ';
    }
    cout.flush();
}

void solve3() {
    auto t = clock();
    vll best_seq;
    vll used(n, 0);
    ll timer = 0;
    ll qc;
    cin >> qc;
    ll q;
    cin >> q;
    F0R(temp, q) {
        ll c;
        cin >> c;
        while ((ld) (clock() - t) / (ld) CLOCKS_PER_SEC < 1.8) {
            timer++;
            shuffle(all(points), rnd);
            vll seq;
            seq.pub(points[0][2]);
            seq.pub(points[1][2]);
            ll cnt = 0;
            used[0] = timer;
            used[1] = timer;
            pll p1 = {points[0][0], points[0][1]};
            pll p2 = {points[1][0], points[1][1]};
            pll p3;
            F0R(i, n - 2) {
                if (cnt > c) {
                    break;
                }
                bool found = false;
                F0R(j, n) {
                    if (used[j] != timer) {
                        p3 = {points[j][0], points[j][1]};
                        if (cnt < c && check(p1, p2, p3)) {
                            used[j] = timer;
                            found = true;
                            p1 = p2;
                            p2 = p3;
                            cnt++;
                            seq.pub(points[j][2]);
                        } else if (!check(p1, p2, p3)) {
                            used[j] = timer;
                            found = true;
                            p1 = p2;
                            p2 = p3;
                            seq.pub(points[j][2]);
                        }
                    }
                    if (found) {
                        break;
                    }
                }
                if (found) {
                    continue;
                }
                F0R(j, n) {
                    if (used[j] != timer) {
                        p3 = {points[j][0], points[j][1]};
                        used[j] = timer;
                        cnt += check(p1, p2, p3);
                        p1 = p2;
                        p2 = p3;
                        seq.pub(points[j][2]);
                        break;
                    }
                }
            }
            if (cnt == c) {
                best_seq = seq;
                break;
            }
        }
        F0R(i, n) {
            cout << best_seq[i] + 1 << ' ';
        }
        cout << '\n';
        cout.flush();
    }
}

void solve37() {
    ll qc;
    cin >> qc;
    ll q;
    cin >> q;
    F0R(i, q){
        ll c;
        cin >> c;
        if (c == 0){
            F0R(j, n){
                cout << j + 1 << ' ';
            }
            cout << '\n';
            cout.flush();
            continue;
        }
        cout << 1 << ' ' << n << ' ';
        ll l = 2, r = n - 1;
        ll t = 0;
        while (c != 1){
            if (t == 0){
                cout << l << ' ';
                l++;
            } else {
                cout << r << ' ';
                r--;
            }
            c--;
            t ^= 1;
        }
        if (t == 0){
            while (r != l){
                cout << r << ' ';
                r--;
            }
            cout << r << ' ';
        } else {
            while (l != r){
                cout << l << ' ';
                l++;
            }
            cout << l << ' ';
        }
        cout << '\n';
        cout.flush();
    }
}

int main() {
    fastio;
    ll task, group;
    cin >> task >> group;
    cin >> n;
    points.resize(n);
    F0R(i, n) {
        ll x, y;
        cin >> x >> y;
        points[i] = {x, y, i};
    }
    if (task == 1) {
        solve1();
    }
    if (task == 2) {
        solve2();
    }
    if (task == 3 && group != 7) {
        solve3();
    }
    if (task == 3 && group == 7){
        solve37();
    }
    return 0;
}
