#include <bits/stdc++.h>

using namespace std;
using ll = long long;


mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct fast {
    ll n;
    vector<pair<ll, ll>> points;
    ll mx_cnt = -1;
    vector<ll> best_pr;

    void check(vector<ll> &pr) {
        ll cnt = 0;
        for (int i = 1; i < n - 1; i++) {
            ll x1 = points[pr[i - 1]].first - points[pr[i]].first;
            ll y1 = points[pr[i - 1]].second - points[pr[i]].second;
            ll x2 = points[pr[i + 1]].first - points[pr[i]].first;
            ll y2 = points[pr[i + 1]].second - points[pr[i]].second;
            if (x1 * x2 + y1 * y2 > 0) {
                cnt++;
            }
        }
        if (cnt > mx_cnt) {
            mx_cnt = cnt;
            best_pr = pr;
        }
    }

    ll good(pair<ll, ll> f, pair<ll, ll> s, pair<ll, ll> t) {
        ll x1 = f.first - s.first;
        ll y1 = f.second - s.second;
        ll x2 = t.first - s.first;
        ll y2 = t.second - s.second;
        return (x1 * x2 + y1 * y2 > 0 ? 1 : 0);
    }

    void solve() {
        ll task, group;
        cin >> task >> group >> n;
        points.resize(n);
        for (int i = 0; i < n; i++) {
            cin >> points[i].first >> points[i].second;
        }
        if (task == 1 && group == 1) {
            for (int i = 0; i < n; i++) {
                if (i % 2 == 0) {
                    cout << (i / 2) + 1 << ' ';
                } else {
                    cout << n - (i / 2) << ' ';
                }
            }
            cout << endl;
        } else if (task == 1 && group == 2) {
            vector<ll> pr(n);
            for (int i = 0; i < n; i++) {
                pr[i] = i;
            }
            check(pr);
            while (next_permutation(pr.begin(), pr.end())) { check(pr); }
            for (auto el: best_pr) {
                cout << el + 1 << ' ';
            }
            cout << endl;
        } else if (group == 7) {
            ll c, q;
            cin >> c >> q;
            while (q--) {
                ll k;
                cin >> k;
                ll cnt = 0;
                ll last_l = 0, last_r = n - 1;
                ll last = 0;
                ll it = 0;
                while (cnt < k - 1) {
                    if (it % 2 == 0) {
                        cout << last_l + 1 << ' ';
                        last_l++;
                        last = 0;
                    } else {
                        cout << last_r + 1 << ' ';
                        last_r--;
                        last = 1;
                    }
                    if (it > 1) {
                        cnt++;
                    }
                    it++;
                }
                if (last == 0) {
                    for (int i = last_l; i <= last_r; i++) {
                        cout << i + 1 << ' ';
                    }
                } else {
                    for (int i = last_r; i >= last_l; i--) {
                        cout << i + 1 << ' ';
                    }
                }
                cout << endl;
            }
        } else if (group <= 5) {
            ll best_res = -1;
            vector<ll> best_p;
            for (int pp = 0; pp < n; pp++) {
                vector<vector<ll>> f;
                vector<vector<ll>> s;
                for (int i = 0; i < n; i++) {
                    if (points[i].second >= points[pp].second) {
                        f.push_back({points[i].first, points[i].second, i});
                    } else {
                        s.push_back({points[i].first, points[i].second, i});
                    }
                }
                sort(f.begin(), f.end());
                sort(s.begin(), s.end());
                ll it1 = 0;
                ll it2 = 0;
                vector<ll> curr;
                for (int i = 0; i < n; i++) {
                    if (i % 2) {
                        if (it1 == ll(f.size())) break;
                        curr.push_back(f[it1][2]);
                        it1++;
                    } else {
                        if (it2 == ll(s.size())) break;
                        curr.push_back(s[it2][2]);
                        it2++;
                    }
                }
                for (int i = it1; i < ll(f.size()); i++) curr.push_back(f[i][2]);
                for (int i = it2; i < ll(s.size()); i++) curr.push_back(s[i][2]);
                ll cnt = 0;
                for (int i = 1; i < n - 1; i++) {
                    cnt += good(points[curr[i - 1]], points[curr[i]], points[curr[i + 1]]);
                }
                if (cnt > best_res) {
                    best_res = cnt;
                    best_p = curr;
                }
            }
            for (auto el: best_p) {
                cout << el + 1 << ' ';
            }
            cout << endl;
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    bool stress = false;
    int times = 1;
//    cin >> times;
    if (stress) times = 1e9;
    while (times--) {
        fast f;
        f.solve();
    }
    return 0;
}
