#include <bits/stdc++.h>

using namespace std;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct fast {
    struct Point {
        int x, y, id;

        bool operator<(const Point &p) const {
            return tie(x, y, id) < tie(p.x, p.y, p.id);
        }
    };

    static bool comp(Point f, Point s) {
        return tie(f.y, f.x, f.id) < tie(s.y, s.x, s.id);
    }

    int n;
    vector<Point> points;

    void solve() {
        int task, group;
        cin >> task >> group >> n;
        points.resize(n);
        for (int i = 0; i < n; i++) {
            cin >> points[i].x >> points[i].y;
            points[i].id = i;
        }
        if (group <= 5) {
            sort(points.rbegin(), points.rend(), comp);
            int best_res = -1;
            vector<Point> best_p;
            set<Point> f;
            set<Point> s;
            for (auto el: points) {
                s.insert(el);
            }
            for (int pp = n - 1; pp >= 0; pp--) {
                if (pp < n - 1) {
                    s.erase(points[pp + 1]);
                    f.insert(points[pp + 1]);
                }
                auto it1 = f.begin();
                auto it2 = s.begin();
                vector<Point> curr;
                int sz = -1;
                int cnt = 0;
                for (int i = 0; i < n; i++) {
                    if (i % 2) {
                        if (it1 == f.end()) break;
                        curr.push_back(*it1);
                        it1++;
                        sz++;
                    } else {
                        if (it2 == s.end()) break;
                        curr.push_back(*it2);
                        it2++;
                        sz++;
                    }
                    if (sz >= 3) {
                        long long x1 = curr[sz - 2].x - curr[sz - 1].x;
                        long long y1 = curr[sz - 2].y - curr[sz - 1].y;
                        long long x2 = curr[sz].x - curr[sz - 1].x;
                        long long y2 = curr[sz].y - curr[sz - 1].y;
                        if (x1 * x2 + y1 * y2 > 0) cnt++;
                    }
                }
                for (; it1 != f.end(); it1++) {
                    curr.push_back(*it1);
                    sz++;
                    if (sz >= 3) {
                        long long x1 = curr[sz - 2].x - curr[sz - 1].x;
                        long long y1 = curr[sz - 2].y - curr[sz - 1].y;
                        long long x2 = curr[sz].x - curr[sz - 1].x;
                        long long y2 = curr[sz].y - curr[sz - 1].y;
                        if (x1 * x2 + y1 * y2 > 0) cnt++;
                    }
                }
                for (; it2 != s.end(); it2++) {
                    curr.push_back(*it2);
                    sz++;
                    if (sz >= 3) {
                        long long x1 = curr[sz - 2].x - curr[sz - 1].x;
                        long long y1 = curr[sz - 2].y - curr[sz - 1].y;
                        long long x2 = curr[sz].x - curr[sz - 1].x;
                        long long y2 = curr[sz].y - curr[sz - 1].y;
                        if (x1 * x2 + y1 * y2 > 0) cnt++;
                    }
                }
                if (cnt > best_res) {
                    best_res = cnt;
                    best_p = curr;
                }
            }
            for (auto el: best_p) {
                cout << el.id + 1 << ' ';
            }
            cout << endl;
        }
//        else if (group == 7){
//            ll c, q;
//            cin >> c >> q;
//            while (q--) {
//                ll k;
//                cin >> k;
//                ll cnt = 0;
//                ll last_l = 0, last_r = n - 1;
//                ll last = 0;
//                ll it = 0;
//                while (cnt < k - 1) {
//                    if (it % 2 == 0) {
//                        cout << last_l + 1 << ' ';
//                        last_l++;
//                        last = 0;
//                    } else {
//                        cout << last_r + 1 << ' ';
//                        last_r--;
//                        last = 1;
//                    }
//                    if (it > 1) {
//                        cnt++;
//                    }
//                    it++;
//                }
//                if (last == 0) {
//                    for (int i = last_l; i <= last_r; i++) {
//                        cout << i + 1 << ' ';
//                    }
//                } else {
//                    for (int i = last_r; i >= last_l; i--) {
//                        cout << i + 1 << ' ';
//                    }
//                }
//                cout << endl;
//            }
//        } else if (group <= 5) {

//        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    bool stress = false;
    int times = 1;
//    cin >> times;
    if (stress) times = 1e9;
    while (times--) {
        fast f;
        f.solve();
    }
    return 0;
}
