#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("popcnt")

//#define int long long
using ll = long long;
#define forn(i,n) for(int i=0; i<n; ++i)
#define pb push_back
#define all(x) x.begin(),x.end()
#define pi pair<int,int>
#define f first
#define s second
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];

const ll inf = 1e18;

struct point {
	int x,y,i;
};
bool foo(point a, point b) {
	return a.x < b.x;
}

struct BIT {
	vector<int> t,a; int n;
	BIT(int n) {
		this->n=n;
		a.assign(n,0);
		t.assign(n,0);
		forn(i,n) {
			for(int j=i; j<n; j=j|(j+1)) t[j]=i;
		}
	}
	int mrg(int i, int j) {
		if (a[i]>a[j]) return i;
		return j;
	}
	void upd(int i, int x) {
		a[i]=x;
		for(int j=i;j<n;j=j|(j+1)) t[j]=mrg(t[j],i);
	}
	int query(int r) {
		int ret=0;
		for(;r>=0;r=(r&(r+1))-1) ret=mrg(ret,t[r]);
		return ret;
	}
	void clear() {
		a.assign(n,0);
		forn(i,n) {
			for(int j=i; j<n; j=j|(j+1)) t[j]=i;
		}
	}
};

const int N=8e4+5;
bitset<N> vis;

void solve() {

	int n; cin>>n;
	vector<point> a(n);
	map<int,int> cpx,cpy; int mx=0,my=0;
	set<int> sx,sy; sx.insert(-2e9); sy.insert(-2e9);
	forn(i,n) {
		cin>>a[i].x>>a[i].y; a[i].i=i;
		sx.insert(a[i].x);
		sy.insert(a[i].y);
	}
	int c; cin>>c;
	sort(all(a),foo);
	for(auto&x:sx) cpx[x]=mx++;
	for(auto&x:sy) cpy[x]=my++;
	forn(i,n) a[i].x=cpx[a[i].x], a[i].y=cpy[a[i].y];
	exit(0);
	//forn(i,n) cout<<a[i].x<<' '<<a[i].y<<' '<<a[i].i<<'\n'; return;
	
	BIT ft(my+5),rft(my+5);
	vector<int> ans;
	vector<int> dp(my+5,0);
	vector<int> rdp(my+5,0);
	while (a.size()) {
		forn(i,my+5) dp[i]=rdp[i]=0;
		ft.clear(); rft.clear();
		n=a.size();
		forn(i,n) {
			int z=ft.query(a[i].y);
			dp[a[i].y]=dp[z]+1;
			ft.upd(a[i].y,dp[z]+1);
		}
		int z1 = ft.query(my);
		reverse(all(a));
		forn(i,n) {
			int z=rft.query(a[i].y);
			rdp[a[i].y]=rdp[z]+1;
			rft.upd(a[i].y,rdp[z]+1);
		}
		int z2 = rft.query(my);

		vector<point> b;

		if (dp[z1]>=rdp[z2]) {
			int zzz=dp[z1];
			for(int i=0; i<n; ++i) {
				if (dp[a[i].y]==zzz) {
					ans.pb(a[i].i);
					--zzz;
				} else b.pb(a[i]);
			}
		} else {
			int zzz=rdp[z2];
			for(int i=n-1; i>=0; --i) {
				if (rdp[a[i].y]==zzz) {
					ans.pb(a[i].i);
					--zzz;
				} else b.pb(a[i]);
			}
		}
		a=b;
	}

	for(auto&x:ans) cout<<x+1<<' '; cout.flush();

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int p,g; cin>>p>>g;
	if (p==2)
	solve();
}