#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <iomanip>
#include <random>
#include <deque>

using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

const ll MOD = 1e9 + 7;
const ll inf = 1e18;

mt19937 rnd(45);

int n, c;
vector<ll> x, y;

int cho(int a, int b, int c) {
	ll s1 = (x[b] - x[a]) * (x[b] - x[a]) + (y[b] - y[a]) * (y[b] - y[a]);
	ll s2 = (x[b] - x[c]) * (x[b] - x[c]) + (y[b] - y[c]) * (y[b] - y[c]);
	ll s3 = (x[c] - x[a]) * (x[c] - x[a]) + (y[c] - y[a]) * (y[c] - y[a]);
	if (s3 >= s1 + s2) {
		return 0;
	}
	return 1;
}

void slv11() {
	cout << "1 ";
	for (int i = 1; i + 1 < n; i += 2) {
		cout << i + 2 << ' ' << i + 1 << ' ';
	}
	if (n % 2 == 0) {
		cout << n << ' ';
	}
	cout << '\n'; cout.flush();
}

void slv1(int g) {
	if (g == 1) {
		slv11();
		return;
	}
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		p[i] = i;
	}
	shuffle(all(p), rnd);
	int sh = min(5, n);
	for (int _ = 0; _ < 7; ++_) {
		for (int i = 0; i + sh <= n; ++i) {
			vector<int> per(sh, 0);
			for (int j = 0; j < sh; ++j) {
				per[j] = j;
			}
			vector<int> ws(sh);
			for (int j = 0; j < sh; ++j) {
				ws[j] = p[i + j];
			}
			do {
				int nw = 0;
				for (int j = 0; j + 2 < sh; ++j) {
					nw += cho(p[i + j], p[i + j + 1], p[i + j + 2]);
				}
				if (i != 0) {
					nw += cho(p[i - 1], p[i], p[i + 1]);
				}
				if (i + sh != n) {
					nw += cho(p[i + sh - 2], p[i + sh - 1], p[i + sh]);
				}
				if (i > 1) {
					nw += cho(p[i - 2], p[i - 1], p[i]);
				}
				if (i + sh + 1 < n) {
					nw += cho(p[i + sh - 1], p[i + sh], p[i + sh + 1]);
				}
				int nw2 = 0;
				for (int j = 0; j + 2 < sh; ++j) {
					nw2 += cho(ws[per[j]], ws[per[j + 1]], ws[per[j + 2]]);
				}
				if (i != 0) {
					nw2 += cho(p[i - 1], ws[per[0]], ws[per[1]]);
				}
				if (i + sh != n) {
					nw2 += cho(ws[per[sh - 2]], ws[per[sh - 1]], p[i + sh]);
				}
				if (i > 1) {
					nw2 += cho(p[i - 2], p[i - 1], ws[per[0]]);
				}
				if (i + sh + 1 < n) {
					nw2 += cho(ws[per[sh - 1]], p[i + sh], p[i + sh + 1]);
				}
				if (nw2 > nw) {
					for (int j = 0; j < sh; ++j) {
						p[i + j] = ws[per[j]];
					}
				}
			} while (next_permutation(all(per)));
		}
	}
	for (int i = 0; i < n; ++i) {
		cout << p[i] + 1 << ' ';
	}
	cout << '\n'; cout.flush();
}

void slv37() {
	int q; cin >> q;
	for (int _ = 0; _ < q; ++_) {
		int m; cin >> m;
		vector<int> ans;
		ans.push_back(0);
		for (int i = 1; i + 1 < m + 2; i += 2) {
			ans.push_back(i + 1);
			ans.push_back(i);
		}
		if (m % 2 == 0) {
			ans.push_back(m + 1);
		}
		for (int i = 0; i + m + 2 < n; ++i) {
			cout << i + 1 << ' ';
		}
		for (int i : ans) {
			cout << i + n - m - 1 << ' ';
		}
		cout << '\n'; cout.flush();
	}
}

void slv3(int g) {
	if (g == 7) {
		slv37();
		return;
	}
	int q; cin >> q;
	for (int u = 0; u < q; ++u) {
		int m; cin >> m;
		vector<int> p(n);
		for (int i = 0; i < n; ++i) {
			p[i] = i;
		}
		shuffle(all(p), rnd);
		int CNT = 0;
		for (int i = 0; i + 2 < n; ++i) {
			CNT += cho(p[i], p[i + 1], p[i + 2]);
		}
		int sh = min(5, n);
		for (int _ = 0; _ < 100; ++_) {
			if (CNT == m) {
				break;
			}
			for (int i = 0; i + sh <= n; ++i) {
				vector<int> per(sh, 0);
				for (int j = 0; j < sh; ++j) {
					per[j] = j;
				}
				vector<int> ws(sh);
				for (int j = 0; j < sh; ++j) {
					ws[j] = p[i + j];
				}
				do {
					int nw = 0;
					for (int j = 0; j + 2 < sh; ++j) {
						nw += cho(p[i + j], p[i + j + 1], p[i + j + 2]);
					}
					if (i != 0) {
						nw += cho(p[i - 1], p[i], p[i + 1]);
					}
					if (i + sh != n) {
						nw += cho(p[i + sh - 2], p[i + sh - 1], p[i + sh]);
					}
					if (i > 1) {
						nw += cho(p[i - 2], p[i - 1], p[i]);
					}
					if (i + sh + 1 < n) {
						nw += cho(p[i + sh - 1], p[i + sh], p[i + sh + 1]);
					}
					int nw2 = 0;
					for (int j = 0; j + 2 < sh; ++j) {
						nw2 += cho(ws[per[j]], ws[per[j + 1]], ws[per[j + 2]]);
					}
					if (i != 0) {
						nw2 += cho(p[i - 1], ws[per[0]], ws[per[1]]);
					}
					if (i + sh != n) {
						nw2 += cho(ws[per[sh - 2]], ws[per[sh - 1]], p[i + sh]);
					}
					if (i > 1) {
						nw2 += cho(p[i - 2], p[i - 1], ws[per[0]]);
					}
					if (i + sh + 1 < n) {
						nw2 += cho(ws[per[sh - 1]], p[i + sh], p[i + sh + 1]);
					}
					if (abs(CNT - m) > abs(CNT - nw + nw2 - m)) {
						for (int j = 0; j < sh; ++j) {
							p[i + j] = ws[per[j]];
						}
						CNT = CNT - nw + nw2;
					}

				} while (next_permutation(all(per)));
			}
		}
		for (int i = 0; i < n; ++i) {
			cout << p[i] + 1 << ' ';
		}
		cout << '\n'; cout.flush();
	}
}

void solve() {
	int t, g; cin >> t >> g;
	cin >> n;
	x.resize(n);
	y.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> y[i];
	}
	if (t == 1) {
		slv1(g);
	} else if (t == 2) {
		cin >> c;
	} else if (t == 3) {
		cin >> c;
		slv3(g);
	} else {
		cin >> c;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}