#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

struct point {
    ll x, y;
    int idx;

    point() {
        x = y = 0;
    }
    point(ll _x, ll _y) {
        x = _x;
        y = _y;
    }

    ll operator%(point a) {
        return x * a.y - y * a.x;
    }
    ll operator*(point a) {
        return x * a.x + y * a.y;
    }
    point operator-(point a) {
        return point(x - a.x, y - a.y);
    }
};

bool ang(point v1, point v2) {
    return v1 * v2;
}

bool cmp(point a, point b) {
    return a.x < b.x;
}

mt19937 rnd(179);

void solve() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<point> pts;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        pts.push_back(point(x, y));
        pts.back().idx = i + 1;
    }
    shuffle(pts.begin(), pts.end(), rnd);
    if (task == 1) {
        sort(pts.begin(), pts.end(), cmp);
        vector<int> p;
        for (int i = 0; i < n; i += 2) {
            if (i + 1 < n) {
                swap(pts[i], pts[i + 1]);
            }
        }
        for (auto e : pts) {
            cout << e.idx << ' ';
        }
        cout << '\n';
    } else if (task == 3) {
        int c, q;
        cin >> c >> q;
        for (int j = 0; j < q; j++) {
            int k;
            cin >> k;
            sort(pts.begin(), pts.end(), cmp);
            if (k % 2) {
                swap(pts[0], pts[1]);
                k--;
                for (int i = 2; k > 0; i += 2) {
                    if (i + 1 < n) {
                        swap(pts[i], pts[i + 2]);
                    }
                    k -= 2;
                }
            } else {
                for (int i = 0; k > 0; i += 2) {
                    if (i + 1 < n) {
                        swap(pts[i], pts[i + 2]);
                    }
                    k -= 2;
                }
            }
            for (auto e : pts) {
                cout << e.idx << ' ';
            }
            cout << '\n';
        }
    } else {
        exit(1);
    }
}

int main() {
    int t = 1;
    for (int i = 0; i < t; i++) solve();
}
