#pragma optimize("Ofast,unroll-loops");
#pragma target("avx2");

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define endl '\n'
#define pint pair<int, int>
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

void solve() {
    srand(time(0));

    auto st = clock(), fn = clock();

    int task, group;
    cin >> task >> group;

    int n;
    cin >> n;
    vector<pair<double, double>> a(n);
    forn(i, 0, n) {
        cin >> a[i].first >> a[i].second;
    }

    auto cmp = [&](pair<double, double> f, pair<double, double> s, pair<double, double> curr) {
        double fa = atan2(curr.first * f.second - curr.second * f.first, curr.first * f.first + curr.second * f.second);
        double sa = atan2(curr.first * s.second - curr.second * s.first, curr.first * s.first + curr.second * s.second);
        return rand() % 2 == 0;
    };

    vector<int> verts(n);
    iota(all(verts), 0);
    vector<int> ord = { 1 };
    unordered_set<int> used = { 0 };

    auto f = [&](vector<int>& curr) {
        int res = n;
        forn(i, 1, n) {
            auto ang = atan2(a[curr[i - 1] - 1].first * a[curr[i] - 1].second - a[curr[i - 1] - 1].second * a[curr[i] - 1].first,
                             a[curr[i - 1] - 1].first * a[curr[i] - 1].first + a[curr[i - 1] - 1].second * a[curr[i] - 1].second);
            res -= fabs(ang) < asin(1);
        }
        return res;
    };

    auto best = verts;
    auto best_val = f(verts);
    do {
        auto curr_val = f(verts);
        if (curr_val < best_val) {
            best_val = curr_val;
            best = verts;
        }
    } while (next_permutation(all(verts)));

    cout.flush();
    forn(i, 0, n) {
        cout << best[i] << " ";
    }
    cout.flush();
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
