#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <iomanip>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

const long long INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

void solve1() {
	ll n;
	cin >> n;
	ll x, y;
	for (ll i = 0; i < n; i++) cin >> x >> y;
	for (ll i = 0; i < n; i++) {
		if (i % 2 == 0) cout << (i / 2 + 1) << " ";
		else cout << n - (i / 2) << " ";
	}
	cout << endl;
}

void solve7() {
	ll n;
	cin >> n;
	ll x, y;
	for (ll i = 0; i < n; i++) cin >> x >> y;
	ll c;
	cin >> c;
	ll q;
	cin >> q;
	while (q--) {
		ll k;
		cin >> k;
		ll l = 1, r = n;
		for (ll i = 0; i < k + 1; i++) {
			if (i % 2 == 0) cout << (i / 2 + 1) << " ", l++;
			else cout << n - (i / 2) << " ", r--;
		}
		if (k % 2 == 1) {
			for (ll x = r; x >= l; x--) cout << x << " ";
		} else {
			for (ll x = l; x <= r; x++) cout << x << " ";
		}
		cout << endl;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll task, gr;
	cin >> task >> gr;
	if (gr == 1) solve1();
	if (gr == 7) solve7();
	return 0;
}