#include <bits/stdc++.h>
using namespace std;

using ll = long long;

/*
void add(int x, int pos) {
    for (int i = pos; i < n; i |= (i + 1)) {
        f[i] += x;
    }
}

int get(int pos) {
    int ans = 0;
    for (int i = pos; i > 0; i &= (i - 1)) {
        ans += f[i];
    }
    return ans;
}
 */

struct Vec {
    ll x, y;
    Vec(){}
    Vec (ll _x, ll _y) {
        x = _x;
        y = _y;
    }
    ll operator*(Vec a) {
        return x * a.x + y * a.y;
    }
    Vec operator-(Vec a) {
        return {x - a.x, y - a.y};
    }
};

Vec &operator>>(istream &in, Vec &a) {
    in >> a.x >> a.y;
    return a;
}

ostream &operator<<(ostream &out, Vec a) {
    out << a.x << " " << a.y;
    return out;
}

vector <Vec> a;

vector <int> ord, ans, vis;
int n, best = 0;

void find_best(int i, int cnt) {
    if (i == n) {
        if (cnt > best) {
            best = cnt;
            ans = ord;
        }
        return;
    }
    for (int nx = 0; nx < n; ++nx) {
        if (vis[nx]) continue;
        ord.push_back(nx);
        vis[nx] = 1;
        if (ord.size() > 2 && (a[ord[ord.size() - 2]] - a[ord[ord.size() - 3]]) * (a[ord[ord.size() - 2]] - a[nx]) > 0) {
            find_best(i + 1, cnt + 1);
        } else {
            find_best(i + 1, cnt);
        }
        ord.pop_back();
        vis[nx] = 0;
    }
}

int main() {
    int task, group, c;
    cin >> task >> group >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    if (task != 1) cin >> c;
    else c = n - 2;
    if (task <= 2 && group != 2) {
        for (int i = 0; i < (n - 2) - c; ++i) cout << i + 1 << " ";
        int i = n - 2 - c, j = n - 1;
        while (i < j) {
            cout << i + 1 << " " << j + 1 << " ";
            i++;
            j--;
        }
        if (i == j) cout << i + 1 << " ";
        cout << endl;
    }
    if (group == 2) {
        vis.resize(n, 0);
        find_best(0, 0);
        for (auto x : ans) cout << x + 1 << " ";
        cout << endl;
    }
    if (task == 3) {
        int q;
        cin >> q;
        for (int k = 0; k < q; ++k) {
            cin >> c;
            for (int i = 0; i < (n - 2) - c; ++i) cout << i + 1 << " ";
            int i = n - 2 - c, j = n - 1;
            while (i < j) {
                cout << i + 1 << " " << j + 1 << " ";
                i++;
                j--;
            }
            if (i == j) cout << i + 1 << " ";
            cout << endl;
        }
    }
}
