#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//template<class c, class cmp = less<c>> using ordered_set = tree<c,null_type,cmp,rb_tree_tag,tree_order_statistics_node_update>;

#define int long long
#define ll long long
#define str string
#define ff first
#define ss second
#define db double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()
mt19937 rnd(time(0));

const ll INF = 1e18;
const db EPS = 1e-6;
const int MOD = 1e9 + 7;
const int MAXN = 1e5 + 10;

void solve();

void fastios() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

signed main() {
//    fastios();
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    double start = clock();
#endif
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
#ifdef LOCAL
        cout << "--------------------------\n";
#endif
    }
#ifdef LOCAL
    cerr << "Time: " << (clock() - start) / CLOCKS_PER_SEC << '\n';
#endif
}

int task, n, group;
int x[MAXN], y[MAXN];

bool check(pair<int,int> p1, pair<int,int> p2, pair<int,int> p3){
    pair<int,int> v1 = {p1.ff - p2.ff, p1.ss - p2.ss};
    pair<int,int> v2 = {p3.ff - p2.ff, p3.ss - p2.ss};
    int tmp = v1.ff * v2.ff + v1.ss * v2.ss;
    return tmp > 0;
}

int f(vector<int> &p) {
    int res = 0;
    for (int i = 1; i < n - 1; ++i) {
        pair<int, int> p1 = {x[i - 1], y[i - 1]};
        pair<int, int> p2 = {x[i], y[i]};
        pair<int, int> p3 = {x[i + 1], y[i + 1]};
        res += check(p1,p2,p3);
    }
    return res;
}

void solve() {
    cin >> task >> group >> n;
    for (int i = 0; i < n; ++i)
        cin >> x[i] >> y[i];
    if (group == 1 && task == 1) {
        int l = 1, r = n;
        for (int i = 0; i < n; ++i) {
            if (i % 2 == 0)
                cout << l << ' ', l++;
            else
                cout << r << ' ', r--;
        }
        cout << endl;
        return;
    } else if (group <= 2 && task == 1) {
        vector<int> p(n);
        iota(all(p), 0);
        int ans = 0;
        vector<int> pans = p;
        do {
            int res = f(p);
            if (res > ans) {
                ans = res;
                pans = p;
            }
        } while (next_permutation(all(p)));
        for (int cur: pans)
            cout << cur + 1 << ' ';
        cout << endl;
        return;
    }
}