#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)x.size()
#define all(x) (x).begin(),(x).end()
using ll = long long;
const int N = 80000 + 5;
pair<ll, ll> a[N];
int ord[N];
double rnd(){
    return (double)(rand()) / RAND_MAX;
}
int task, group, n;

pair<ll, ll> operator - (pair<ll, ll> A, pair<ll, ll> B){
    return  make_pair(A.first - B.first, A.second - B.second);
}

ll dp(pair<ll, ll> A, pair<ll, ll> B){
    return  A.first * B.first + A.second * B.second;
}
int f(){
    int as = 0;
    for(int i =0; i + 2 < n; i++){
            auto [I, J, K] = make_tuple(ord[i], ord[i + 1], ord[i + 2]);
        if(dp(a[I] - a[J], a[K] - a[J]) > 0)
            as++;
    }
    return as;
}
void solve(){

    cin >> task >> group >> n;
    mt19937 gen(228);
    if(task == 1){
        for(int i =0; i < n; i++){
            cin >> a[i].first >> a[i].second;
        }
        iota(ord, ord + n, 0);
        double start = clock();
        double t = 1;
        int bs = 0;
        while((clock() - start) / CLOCKS_PER_SEC < 1.98){
            t *= 0.99;
            int l = gen() % n;
            int r = gen() % n;
            swap(ord[l], ord[r]);
            int nw = f();
            if(bs < nw || rnd() < exp((double)(nw - bs) / t)){
                bs = nw;
            }else{
                swap(ord[l], ord[r]);
            }
        }
        for(int i =0; i < n; i++){
            cout << ord[i] + 1 << ' ';
        }
        cout << endl;
    }else if(task == 2){
        for(int i =0; i < n; i++){
            cin >> a[i].first >> a[i].second;
        }
        int c;
        cin >> c;
        iota(ord, ord + n, 0);
        double start = clock();
        double t = 1;
        int bs = 0;
        while((clock() - start) / CLOCKS_PER_SEC < 1.98){
            t *= 0.99;
            int l = gen() % n;
            int r = gen() % n;
            swap(ord[l], ord[r]);
            int nw = f();
            if(bs > nw || rnd() < exp((double)(-nw + bs) / t)){
                bs = nw;
            }else{
                swap(ord[l], ord[r]);
            }
        }
        for(int i =0; i < n; i++){
            cout << ord[i] + 1 << ' ';
        }
        cout << endl;
    }

}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    //cin.tie(0)->sync_with_stdio(false);
#endif
    solve();
    return 0;
}
