#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;
const int INF = 1e9;

struct point {
	ll x, y;
};
vector<point> mas;
struct Vector {
	ll x, y;
	Vector(point a, point b) : x(b.x - a.x), y(b.y - a.y) {};
};
ll dot_prod(Vector a, Vector b) {
	return a.x * b.x + a.y * b.y;
}

int check(vector<int> posl) {
	int cnt = 0;
	for (int i = 1; i < posl.size() - 1; ++i) {
		point a = mas[posl[i - 1]];
		point b = mas[posl[i]];
		point c = mas[posl[i + 1]];
		Vector ba(b, a), bc(b, c);
		if (dot_prod(ba, bc) > 0)
			cnt++;
	}
	return cnt;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int task, group;
	cin >> task >> group;
	int n; cin >> n;
	mas.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> mas[i].x >> mas[i].y;
	if (group == 1) {
		int l = 1, r = n;
		while (l <= r) {
			cout << r << " ";
			r--;
			if (l > r) break;
			cout << l << " ";
			l++;
		}
	}
	else if (task == 1) {
		vector<int> posl(n);
		for (int i = 0; i < n; ++i)
			posl[i] = i;
		vector<int> ans;
		int maxc = 0;
		do {
			if (check(posl) > maxc) {
				maxc = check(posl);
				ans = posl;
			}
		} while (next_permutation(posl.begin(), posl.end()));
		for (int el : ans)
			cout << el + 1 << " ";
	}
	else {
		int c; cin >> c;
		int q;
		cin >> q;
		for (int _ = 0; _ < q; ++_) {
			int k;
			cin >> k;
			k--;
			cout << n << " " << 1 << " ";
			int l = 2, r = n - 1;
			int cnt = 0;
			bool wasl = true;
			while (cnt < k) {
				if (wasl) {
					cout << r << " ";
					r--;
					wasl = false;
				}
				else {
					cout << l << " ";
					l++;
					wasl = true;
				}
				cnt++;
			}
			if (wasl) {
				for (int i = l; i <= r; ++i)
					cout << i << " ";
			}
			else {
				for (int i = r; i >= l; --i)
					cout << i << " ";
			}
			cout << endl;
		}
	}


	return 0;
}