#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <deque>
#include <queue>
#include <assert.h>
#include <random>
#include <math.h>
#include <bitset>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define all(a) a.begin(), a.end()
#define ff first
#define ss second
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

mt19937 rnd(time(0));
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

#define int long long
vector<pii> a;
int n;

void solve1() {
    int ans = 0;
    vi anss;
    vi now(n);
    for (int i = 0; i < n; ++i) {
        now[i] = i;
    }

    for (int t = 0; t < 1000; ++t) {
        random_shuffle(all(now));
        int k = 0;
        for (int i = 0; i < n - 2; ++i) {
            int i0 = now[i], i1 = now[i + 1], i2 = now[i + 2];
            int x0 = a[i0].ff, y0 = a[i0].ss;
            int x1 = a[i1].ff, y1 = a[i1].ss;
            int x2 = a[i2].ff, y2 = a[i2].ss;

            int px = x0 - x1, py = y0 - y1;
            int sx = x2 - x1, sy = y2 - y1;
            if (px * sx + py * sy > 0) {
                k++;
            }
        }
        if (k > ans) {
            ans = k;
            anss = now;
        }

        if (ans == n - 2) break;
    }

    for (auto& i : anss) cout << i + 1 << " ";
    cout << endl;
}
signed main()
{
    fast;
    
    int task, group;
    cin >> task >> group;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        a[i] = { x, y };
    }
    if (task == 1) {
        solve1();
    }
}
