#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <random>
#include <chrono>
#include <deque>


using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define MNOGO int __t; cin>>__t; while(__t--)
//#define endl "\n"

void build(int n) {
    cout << 1 << " ";
    for (int i = 0; i < (n - 1) / 2; i++) {
        cout << 2 * (i + 1) + 1 << " " << 2 * (i + 1) << " ";
    }
    if (n % 2 == 0) {
        cout << n << " ";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    mt19937 rng(std::chrono::steady_clock::now().time_since_epoch().count());

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int task, group;
    cin >> task >> group;

    int n;
    cin >> n;

    vector<pair<int, int>> points(n, {0, 0});

    for (int i = 0; i < n; i++) {
        cin >> points[i].ff >> points[i].ss;
    }

    if (task == 1) {
        if (group == 1) {
            cout << 1 << " ";
            for (int i = 0; i < (n - 1) / 2; i++) {
                cout << 2 * (i + 1) + 1 << " " << 2 * (i + 1) << " ";
            }
            if (n % 2 == 0) {
                cout << n;
            }
            cout << endl;
            return 0;
        }
    }

    int c;
    cin >> c;

    int q;
    cin >> q;

    if (task == 3) {
        if (group == 7) {
            while (q--) {
                int k;
                cin >> k;
                if ((k + 2) % 2 == 0) {
                    build(k + 2);
                    for (int i = k + 3; i <= n; i++) {
                        cout << i << " ";
                    }
                    cout << endl;
                } else {
                    build(k + 1);
                    for (int i = k + 2; i <= n - 2; i++) {
                        cout << i << " ";
                    }
                    cout << n << " " << n - 1 << endl;
                }
            }
        }
    }

}