#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long

#ifdef LOCAL
constexpr int MAXN = 100, LG = 5;
#else
constexpr int MAXN = 200010, LG = 60;
#endif

pii arr[MAXN];
int n;

mt19937 rnd(228);

bool check(int a, int b, int c) {
    pii p1 = { arr[b].F - arr[a].F, arr[b].S - arr[a].S };
    pii p2 = { arr[b].F - arr[c].F, arr[b].S - arr[c].S };
    return (p1.F * 1ll * p2.F + p1.S * 1ll * p2.S) > 0;
}

void solve1() {
    vector<int> ord(n);
    iota(all(ord), 0);
    shuffle(all(ord), rnd);
    int cur = 0;
    for (int i = 0; i < n - 2; i++) {
        cur += check(ord[i], ord[i + 1], ord[i + 2]);
    }
    for (int ind = 0; ind < 10000000; ind++) {
        int a = rnd() % (n - 1);
        int was = cur;
        for (int i = max(0, a - 2); i <= min(a, n - 3); i++) {
            cur -= check(ord[i], ord[i + 1], ord[i + 2]);
        }
        swap(ord[a], ord[a + 1]);
        for (int i = max(0, a - 2); i <= min(a, n - 3); i++) {
            cur += check(ord[i], ord[i + 1], ord[i + 2]);
        }
        if (cur < was) {
            cur = was;
            swap(ord[a], ord[a + 1]);
        }
    }
    for (int v : ord)
        cout << v + 1 << ' ';
    cout << endl;
}

void solve2() {
    int c;
    cin >> c;
    vector<int> ord(n);
    iota(all(ord), 0);
    shuffle(all(ord), rnd);
    int cur = 0;
    for (int i = 0; i < n - 2; i++) {
        cur += check(ord[i], ord[i + 1], ord[i + 2]);
    }
    while (cur > c) {
        int a = rnd() % (n - 1);
        int was = cur;
        for (int i = max(0, a - 2); i <= min(a, n - 3); i++) {
            cur -= check(ord[i], ord[i + 1], ord[i + 2]);
        }
        swap(ord[a], ord[a + 1]);
        for (int i = max(0, a - 2); i <= min(a, n - 3); i++) {
            cur += check(ord[i], ord[i + 1], ord[i + 2]);
        }
        if (cur > was) {
            cur = was;
            swap(ord[a], ord[a + 1]);
        }
    }
    for (int v : ord)
        cout << v + 1 << ' ';
    cout << endl;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int task, group;
    cin >> task >> group >> n;
    for (int i = 0; i < n; i++)
        cin >> arr[i].F >> arr[i].S;
    if (task == 1)
        solve1();
    if (task == 2)
        solve2();
    
    return 0;
}
