#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

void solve() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    struct Point {
        int x, y;
        Point() {}
        Point(int _x, int _y) : x(_x), y(_y) {}
        int operator*(Point p) {
            return p.y * x - p.x * y;
        }
        int operator%(Point p) {
            return p.x * x + p.y * y;
        }
        Point operator-(Point p) {
            return Point(x - p.x, y - p.y);
        }
    };
    vector<Point> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    auto check = [&](vector<int>& p) -> int {
        int cur = 0;
        for (int i = 1; i < n - 1; ++i) {
            Point prv = a[p[i - 1]] - a[p[i]];
            Point nxt = a[p[i + 1]] - a[p[i]];
            if (nxt * prv > 0 && nxt % prv > 0) {
                ++cur;
            }
        }
        return cur;
    };
    if (task != 1) {
        int c;
        cin >> c;

    }
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    int ans = check(p);
    for (int it = 0; it < 5000; ++it) {
        int f = rnd() % n, s = rnd() % n;
        swap(p[f], p[s]);
        int cur = check(p);
        if (cur > ans) {
            ans = cur;
        } else {
            swap(p[f], p[s]);
        }
    }
    cerr << ans << '\n';
    for (auto& x : p) cout << x + 1 << ' ';
    cout << endl;
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
