#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int task, group;
  cin >> task >> group;
  assert(task == 1);
  int n;
  cin >> n;
  vector<ll> x(n), y(n);
  for (int i = 0; i < n; ++i) {
    cin >> x[i] >> y[i];
  }
  /*int l = 1, r = n;
  for (int i = 0; i < n; ++i) {
    if (i % 2 == 0) {
      cout << l++ << ' ';
    } else {
      cout << r-- << ' ';
    }
  }
  cout << endl;*/
  int s = 0;
  for (int i = 1; i < n; ++i) {
    if (y[i] < y[s]) {
      s = i;
    }
  }
  vector<int> order(n);
  iota(order.begin(), order.end(), 0);
  order.erase(order.begin() + s);
  for (int i = 0; i < n; ++i) {
    if (i != s) {
      x[i] -= x[s];
      y[i] -= y[s];
    }
  }

  auto Vect = [&](int i, int j) {
    return x[i] * y[j] - x[j] * y[i];
  };

  sort(order.begin(), order.end(), [&](int i, int j) {
    return Vect(i, j) > 0 || (Vect(i, j) == 0 && x[i] * x[i] + y[i] * y[i] < x[j] * x[j] + y[j] * y[j]);
  });
  int l = 0, r = n - 2;
  cout << s + 1 << ' ';
  for (int i = 0; i < n - 1; ++i) {
    if (i % 2 == 0) {
      cout << order[l++] + 1 << ' ';
    } else {
      cout << order[r--] + 1 << ' ';
    }
  }
  cout << endl;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
