#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int task, group;
  cin >> task >> group;
  int n;
  cin >> n;
  vector<ll> x(n), y(n);
  for (int i = 0; i < n; ++i) {
    cin >> x[i] >> y[i];
  }
  if (group == 1) {
    int l = 1, r = n;
    for (int i = 0; i < n; ++i) {
      if (i % 2 == 0) cout << l++ << ' ';
      else cout << r-- << ' ';
    }
    cout << endl;
  }
  if (group == 2) {
    vector<int> order(n);
    iota(order.begin(), order.end(), 0);
    vector<int> best;
    int best_cnt = 0;
    do {
      int cur = 0;
      for (int i = 0; i < n - 2; ++i) {
        ll v1x = x[order[i + 1]] - x[order[i]];
        ll v1y = y[order[i + 1]] - y[order[i]];
        ll v2x = x[order[i + 2]] - x[order[i + 1]];
        ll v2y = y[order[i + 2]] - y[order[i + 1]];
        if (v1x * v2x + v1y * v2y > 0) {
          cur += 1;
        }
      }
      if (cur > best_cnt) {
        best_cnt = cur;
        best = order;
      }
    } while (next_permutation(order.begin(), order.end()));
    for (int i : best) {
      cout << i + 1 << ' ';
    }
    cout << endl;
  }
  if (group == 7) {
    int c;
    cin >> c;
    int q;
    cin >> q;
    while (q--) {
      int k;
      cin >> k;
      //cerr << k << endl;
      for (int i = 1; i <= n - k - 2; ++i) {
        cout << i << ' ';
      }
      int l = n - k - 1, r = n;
      for (int i = 0; i < k + 2; ++i) {
        if (i % 2 == 0) {
          cout << l++ << ' ';
        } else {
          cout << r-- << ' ';
        }
      }
      cout << endl;
    }
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
