#include <bits/stdc++.h>
using namespace std;
using ll = long long;

mt19937 rnd(time(0));

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
  int task, group;
  cin >> task >> group;
  int n;
  cin >> n;
  vector<ll> x(n), y(n);
  for (int i = 0; i < n; ++i) {
    cin >> x[i] >> y[i];
  }
  if (group == 1) {
    int l = 1, r = n;
    for (int i = 0; i < n; ++i) {
      if (i % 2 == 0) cout << l++ << ' ';
      else cout << r-- << ' ';
    }
    cout << endl;
    return;
  }
  if (group == 2) {
    vector<int> order(n);
    iota(order.begin(), order.end(), 0);
    vector<int> best;
    int best_cnt = 0;
    do {
      int cur = 0;
      for (int i = 0; i < n - 2; ++i) {
        ll v1x = x[order[i + 1]] - x[order[i]];
        ll v1y = y[order[i + 1]] - y[order[i]];
        ll v2x = x[order[i + 2]] - x[order[i + 1]];
        ll v2y = y[order[i + 2]] - y[order[i + 1]];
        if (v1x * v2x + v1y * v2y < 0) {
          cur += 1;
        }
      }
      if (cur > best_cnt) {
        best_cnt = cur;
        best = order;
      }
    } while (next_permutation(order.begin(), order.end()));
    for (int i : best) {
      cout << i + 1 << ' ';
    }
    cout << endl;
    return;
  }
  if (group < 6) {
    vector<int> best;
    int best_cnt = 0;
    for (int T = 0; T < 100; ++T) {
      int prv = rnd() % n;
      int cur = rnd() % n;
      while (cur == prv) cur = rnd() % n;
      vector<int> cur_ans = {prv, cur};
      int cur_cnt = 0;
      ordered_set s;
      for (int i = 0; i < n; ++i) {
        if (i != prv && i != cur) {
          s.insert(i);
        }
      }
      for (int t = 0; t < n - 2; ++t) {
        int nxt = -1;
        for (int TT = 0; TT <= 10; ++TT) {
          int who = rnd() % (int)s.size();
          int id = *s.find_by_order(who);
          ll v1x = x[cur] - x[prv];
          ll v1y = y[cur] - y[prv];
          ll v2x = x[id] - x[cur];
          ll v2y = y[id] - y[cur];
          if (TT == 10 || v1x * v2x + v1y * v2y < 0) {
            if (v1x * v2x + v1y * v2y < 0) cur_cnt += 1;
            nxt = id;
            s.erase(id);
            break;
          }
        }
        cur_ans.push_back(nxt);
        prv = cur;
        cur = nxt;
      }
      if (cur_cnt > best_cnt) {
        best_cnt = cur_cnt;
        best = cur_ans;
      }
    }
    for (int i : best) {
      cout << i + 1 << ' ';
    }
    cout << endl;
  }
  if (group == 7) {
    int c;
    cin >> c;
    int q;
    cin >> q;
    while (q--) {
      int k;
      cin >> k;
      //cerr << k << endl;
      for (int i = 1; i <= n - k - 2; ++i) {
        cout << i << ' ';
      }
      int l = n - k - 1, r = n;
      for (int i = 0; i < k + 2; ++i) {
        if (i % 2 == 0) {
          cout << l++ << ' ';
        } else {
          cout << r-- << ' ';
        }
      }
      cout << endl;
    }
  }
  if (group == 6) {
    ordered_set s;
    for (int i = 2; i < n; ++i) {
      s.insert(i);
    }
    int prv = 0, cur = 1;
    cout << 1 << ' ' << 2 << ' ';
    for (int t = 0; t < n - 2; ++t) {
      int nxt = -1;
      for (int T = 0; T <= 100; ++T) {
        int who = rnd() % (int)s.size();
        int id = *s.find_by_order(who);
        ll v1x = x[cur] - x[prv];
        ll v1y = y[cur] - y[prv];
        ll v2x = x[id] - x[cur];
        ll v2y = y[id] - y[cur];
        if (T == 10 || v1x * v2x + v1y * v2y >= 0) {
          nxt = id;
          s.erase(id);
          break;
        }
      }
      cout << nxt + 1 << ' ';
      prv = cur;
      cur = nxt;
    }
    cout << endl;
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
