#pragma GCC ("03, unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second

const ll inf = 1e9 + 7;

struct pnt {
    ll x, y;
    pnt operator -(pnt oth) {
        return {x - oth.x, y - oth.y};
    }
};
ll ps(pnt a, pnt b) {
    return a.x * b.y - a.y * b.x;
}
ll s(pnt a, pnt b) {
    return a.x * a.y + b.y * b.x;
}

bool cmp(pair<pnt, ll> a, pair<pnt, ll> b) {
    return ps(a.fi, b.fi) > 0;
}


void solve() {
    ll tsk, gr;
    cin >> tsk >> gr;
    ll n;
    cin >> n;
    vector<pair<pnt, ll>> p(n);
    for(int i = 0; i < n; ++i) {
        cin >> p[i].fi.x >> p[i].fi.y;
        p[i].se = i;
    }
    if (tsk == 1) {
        if (gr == 1) {
            for(int i = 0; i < n / 2; ++i) {
                cout << i + 1 << ' ' << n - i << ' ';
            }
            if (n % 2) {
                cout << n / 2 + 1;
            }
        } else {
            vector<ll> a(n);
            for(int i = 0; i < n; ++i) {
                a[i] = i;
            }
            ll cnt = 0;
            vector<ll> ans = a;
            do {
                ll ch = 0;
                for(int i = 2; i < n - 1; ++i) {
                    if (s(p[a[i]].fi - p[a[i - 1]].fi, p[a[i - 1]].fi - p[a[i - 2]].fi) < 0) {
                        ch++;
                    }
                }
                if (ch > cnt) {
                    ans = a;
                    cnt = ch;
                }
            }while(next_permutation(a.begin(), a.end()));
            for(auto it : ans) {
                cout << it + 1 << ' ';
            }
        }

    } else {
        ll c;
        cin >> c;
        sort(p.begin(), p.end(), cmp);
        for(auto it : p) {
            cout << it.se + 1 << ' ';
        }
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T = 1;
    //cin >> T;
    while(T--) {
        solve();
        //cout << '\n';
    }
    return 0;
}
