#pragma GCC optimize("Ofast")
#pragma GCC optimize("avx")
#pragma GCC optimize("avx2")
#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <unordered_map>

using namespace std;


struct point {
	int x, y;
};

long long dist(point a, point b) {
	return pow(a.x - b.x, 2) + pow(a.y - b.y, 2);
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int task, group;
	cin >> task >> group;
	if (task != 1) {
		cout << 1 / 0;
	}
	int n;
	cin >> n;
	vector<point> l(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i].x >> l[i].y;
	}
	if (task == 1) {
		vector<bool> used(n, true);
		vector<int> ans = { 0 };
		used[0] = false;
		for (int i = 1; i < n; i++) {
			long long ma = 0;
			int ma2 = -1;
			for (int j = 0; j < n; j++) {
				if (!used[j]) continue;
				long long u = dist(l[j], l[ans[i - 1]]);
				if (ma2 == -1 or u > ma) {
					ma2 = j;
					ma = u;
				}
			}
			used[ma2] = false;
			ans.push_back(ma2);
		}
		for (int i : ans) cout << i + 1 << " ";
	}
	else if (task == 2) {
		int c;
		cin >> c;
		vector<bool> used(n, true);
		vector<int> ans = { 0 };
		used[0] = false;
		for (int i = 1; i < n; i++) {
			int ma2 = 0;
			while (!used[ma2]) {
				ma2 = rand() % n;
			}
			used[ma2] = false;
			ans.push_back(ma2);
		}
		for (int i : ans) cout << i + 1 << " ";
	}




}

/*

Левая и правая границы отрезка оставшихся - 4 * 1e6
Сколько им осталось есть - 4 * 1e8

2 дп

1) Алиса поела

2) Боб поел

n^2 * Wi * 2

*/
