#define _USE_MATH_DEFINES
#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define ff first
#define sc second

struct V {
    double x, y;
    V() = default;
    V(double x_, double y_) {
        x = x_;
        y =y_;
    }
};

V operator-(V a, V b) {
    return V(a.x - b.x, a.y - b.y);
}

double operator%(V a, V b) {
    return a.x * b.y - a.y * b.x;
}

double operator*(V a, V b) {
    return a.x * b.x + a.y * b.y;
}

double angle(V a, V b) {
    double ans = atan2(a % b, a * b) * 180 / M_PI;
    if (ans < 0) ans += 360;
    return min(ans, 360 - ans);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);

    int task, group; cin >> task >> group;
    int n; cin >> n;
    vector<pair<int, int>> pts(n);
    vector<V> a(n);
    for (int i = 0; i < n; i++) {
        cin >> pts[i].ff >> pts[i].sc;
        a[i] = V(pts[i].ff, pts[i].sc);
    }
    if (task == 1) {
        if (group == 1) {
            for (int i = 0; i < n; i++) {
                if (i % 2 == 0) {
                    cout << i / 2 + 1 << ' ';
                } else {
                    cout << n - i / 2 << ' ';
                }
            }
            cout << endl;
            return 0;
        }
        string s;
        for (int i = 0; i < n; i++) s += char('a' + i); 
        string ans;
        int A = -1;
        do {
            int cnt = 0;
            for (int i =1; i < n - 1;i++) {
                cnt += (angle(a[s[i - 1] - 'a'] - a[s[i] - 'a'], a[s[i + 1] - 'a'] - a[s[i] -'a']) < 90);
            }
            if (cnt > A) {
                A = cnt;
                ans = s;
            }
        } while (next_permutation(all(s)));
        for (int i = 0; i < n; i++) cout << ans[i] - 'a' + 1 << ' ';
        cout << endl;
     } else if (task == 3) {
        int c; cin >> c;
        int q; cin >> q;
        if (group == 7) {
        while (q--) {
            int k; cin >> k;
            int N = k + 1;
            for (int i = n - 1; i >= N; i--) cout << i + 1 << ' ';
            for (int i = 0; i < N; i++) {
                if (i % 2 == 0) {
                    cout << i / 2 + 1 << ' ';
                } else {
                    cout << N - i / 2 << ' ';
                }
            }
            cout << endl;
        }
        } else if (group == 8) {

        }
    }
}