#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long double ld;
typedef long long ll;

//#pragma GCC optnimize("Ofast")
//#pragma GCC target("avx2")

struct point {
    int x, y;
};

point operator-(point a, point b) {
    return {a.x - b.x, a.y - b.y};
}

int scl(point a, point b) {
    return a.x * b.x + a.y * b.y;
}

bool check(point a, point b, point c) {
    return scl(b - a, c - b) <= 0;
}

mt19937 rnd(1);

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<pair<point, int>> w(n);
    for (int i = 0; i < n; i++) cin >> w[i].first.x >> w[i].first.y, w[i].second = i;
    vector<int> ans(n);
    int res = 0;
    for (int _ = 0; _ < 1000; _++) {
        int cnt = 0;
        for (int i = 1; i < n - 1; i++) {
            if (check(w[i - 1].first, w[i].first, w[i + 1].first)) cnt++;
        }
        if (cnt > res) {
            res = cnt;
            for (int i = 0; i < n; i++) {
                ans[i] = w[i].second;
            }
        }
        random_shuffle(w.begin(), w.end());
    }
//    cout << res << '\n';
    for (int i = 0; i < n; i++) {
        cout << ans[i] + 1 << ' ';
    }
}