#ifdef LOCAl
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

#define x first
#define y second

using namespace std;

using ll = long long;

mt19937_64 mt(100);

void solve();

int main() {
#ifndef LOCAL
	cin.tie(nullptr)->sync_with_stdio(false);
#endif
	cout << fixed << setprecision(30);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

ll dist(const pair<int, int>& a, const pair<int, int>& b) {
	return 1ll * (a.x - b.x) * (a.x - b.x) + 1ll * (a.y - b.y) * (a.y - b.y);
}

void solve() {
	int task, gr, n;
	cin >> task >> gr >> n;
	if (task == 1) {
		vector<pair<int, int>> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i].x >> a[i].y;
		}
		vector<int> ans, ind(n);
		for (int i = 0; i < n; i++) {
			ind[i] = i;
		}
		ans.push_back(n - 1);
		while (a.size() != 1) {
			ll mx = 0;
			int mxi = -1;
			for (int i = 0; i < a.size() - 1; i++) {
				ll d = dist(a.back(), a[i]);
				if (mx < d) {
					mx = d;
					mxi = i;
				}
			}
			a.pop_back();
			swap(a[a.size() - 1], a[mxi]);
			ans.push_back(ind[mxi]);
			swap(ind[a.size() - 1], ind[mxi]);
		}
		for (int i = 0; i < n; i++) {
			cout << ans[i] + 1 << ' ';
		}
		cout << endl;
	} else if (task == 2) {
		int c;
		vector<pair<int, int>> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i].x >> a[i].y;
		}
		cin >> c;
		vector<int> ans, ind(n);
		for (int i = 0; i < n; i++) {
			ind[i] = i;
		}
		ans.push_back(n - 1);
		while (a.size() != 1) {
			ll mx = INT64_MAX;
			int mxi = -1;
			for (int i = 0; i < a.size() - 1; i++) {
				ll d = dist(a.back(), a[i]);
				if (mx > d) {
					mx = d;
					mxi = i;
				}
			}
			a.pop_back();
			swap(a[a.size() - 1], a[mxi]);
			ans.push_back(ind[mxi]);
			swap(ind[a.size() - 1], ind[mxi]);
		}
		for (int i = 0; i < n; i++) {
			cout << ans[i] + 1 << ' ';
		}
		cout << endl;
	}
}