#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cstdio>
#include <stack>
#include <stdlib.h>
#include <fstream>
#include <random>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define PI 3.14159265
#define inf 1000000000000000009
#define int ll
#define mod 998244353
mt19937 rnd(2);
class mc2
{
public:
	int first, second, i;
};

void build_treex(std::vector<pair<int,int>>& V)
{
	int n = pow(2, int(log(V.size()) / log(2) + 1));
	V.resize(2 * n, {inf,0});
	for (int i = n; i < 2 * n; i++)
	{
		V[i] = V[i - n];
		V[i].second = i - n;
	}
	for (int i = n - 1; i > 0; i--)
	{
		if (V[2 * i].first <= V[2 * i + 1].first)
			V[i] = V[2 * i];
		else
			V[i] = V[2 * i + 1];
	}
}
ll rmq_upx(vector<pair<int,int>>& T, int l, int r)
{
	int ans = inf + 1,pos = -1;
	int n = T.size() / 2;
	l += n, r += n;
	while (l <= r)
	{
		if (l % 2 == 1 && T[l].first < ans)
		{
			ans = T[l].first;
			pos = T[l].second;
		}
		if (r % 2 == 0 && T[r].first < ans)
		{
			ans = T[r].first;
			pos = T[r].second;
		}
		l = (l + 1) / 2, r = (r - 1) / 2;
	}
	return pos;
}
int get_zn(vector<pair<int,int>>& T, int i)
{
	int n = T.size() / 2;
	return T[i + n].first;
}
void updatex(vector<pair<int,int>>& T, int i, int x)
{
	int n = T.size() / 2;
	i = i + n;
	T[i].first = x;
	i = i / 2;
	while (i > 0) {
		if (T[2 * i].first <= T[2 * i + 1].first)
			T[i] = T[2 * i];
		else
			T[i] = T[2 * i + 1];
		i = i / 2;
	}
}
signed main()
{
#ifndef ONLINE_JUDGE
	//FILE* stream1;	freopen_s(&stream1, "input.txt", "r", stdin);
#endif
	//FILE* stream1;	freopen_s(&stream1, "robots.in", "r", stdin);
	//FILE* stream2;	freopen_s(&stream2, "o.out", "w", stdout);
	ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);srand(time(0));
	//**************************************************
	int n, k, t;
	cin >> n >> k >> t;
	vector<int> rb(n);
	{
		vector<int> a(n);
		map<int, int> mp2;
		for (int i = 0;i < n;i++)
		{
			cin >> a[i];
			mp2[a[i]]++;
		}
		if (int(mp2.size()) <= t)
		{
			cout << 1;
			exit(0);
		}
		for (int i = 0;i < n;i++)
			a.push_back(a[i]);
		map<int, int> mp;
		int kol = 0,r = 2*n-1;
		for (int i = 2 * n - 1;i >= 0;i--)
		{
			mp[a[i]]++;
			if (mp[a[i]] == 1)
				kol++;
			while (kol > t)
			{
				mp[a[r]]--;
				if (mp[a[r]] == 0)
					kol--;
				r--;
			}
			if (i < n)
				rb[i] = (r+1) % n;
		}
	}
	int otv = 0;
	vector<int> used(n),pos(n),kord(n);
	int now = 0,poss = 1,nkord = 0;
	//
	int st_kord, dl_k, kol_u;
	//
	while (true)
	{
		used[now] = 1;pos[now] = poss;kord[now] = nkord;
		poss++;
		if (rb[now] > now)
			nkord += rb[now] - now;
		else
			nkord += n - (now - rb[now]);
		now = rb[now];
		if (nkord >= n * k)
		{
			cout << poss-1;
			exit(0);
		}
		//if (rb[now] < now && otv == -1)
		//	otv = poss - 1;
		if (used[now])
		{
			otv += pos[now] - 1;
			st_kord = kord[now];
			dl_k = nkord - st_kord;
			kol_u = poss - pos[now];
			//otv += (k - 1) * (poss - pos[now]);
			break;
		}
	}
	int a = (n * k - st_kord) / dl_k;
	otv += a * kol_u;
	int now_kord = st_kord + dl_k * a;
	while (now_kord < n * k)
	{
		otv++;
		int nowx = now_kord % n;
		if (rb[nowx] > nowx)
			now_kord += rb[nowx] - nowx;
		else
			now_kord += n - (nowx - rb[nowx]);
	}
	cout << otv;
	//**************************************************
}