#include <bits/stdc++.h>
#define int long long
#define all(a) a.begin(), a.end()
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/hash_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T>
//using ordered_set = tree<T, null_type, less<T>>;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

constexpr int p = 1'000'000 + 3, mod = 1'000'000'000 + 7;
vector<int> h[3];

void calc_zig_zag_hash(int n) {
    h[0].assign(n + 1, 0);
    h[1].assign(n + 1, 0);
    h[2].assign(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        int x = 0;
        if (i % 2 == 0) x = i / 2 + 1;
        else x = n - i / 2;
        h[0][i + 1] = (h[0][i] * p + x) % mod;
        h[1][i + 1] = (h[1][i] * p + i + 1) % mod;
        h[2][i + 1] = (h[2][i] * p + n - i) % mod;
    }
}

void solve() {
    int task, group, n;
    cin >> task >> group >> n;
    for (int _ = 0; _ < n; ++_) {
        int _x, _y;
        cin >> _x >> _y;
    }
    calc_zig_zag_hash(n);
    if (task == 1) {
        for (int i = 0; i < n; ++i) {
            int x = 0;
            if (i % 2 == 0) x = i / 2 + 1;
            else x = n - i / 2;
            cout << x << ' ';
        }
        cout << endl;
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/a.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
    cin >> _t;
#endif
    while (_t--) solve();
}