#include <bits/stdc++.h>
#define int long long
#define all(a) a.begin(), a.end()
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/hash_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T>
//using ordered_set = tree<T, null_type, less<T>>;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

constexpr int p = 1'000'000 + 3, mod = 1'000'000'000 + 7, maxp = 1'000'000;
vector<int> h[3];
int pws[maxp];

void pre_calc() {
    pws[0] = 1;
    for (int i = 1; i < maxp; ++i) pws[i] = pws[i - 1] * p % mod;
}

void calc_zig_zag_hash(int n) {
    h[0].assign(n + 1, 0);
    h[1].assign(n + 1, 0);
    h[2].assign(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        int x = (i % 2 == 0) ? (i / 2 + 1): (n - i / 2);
        h[0][i + 1] = (h[0][i] * p + x) % mod;
        h[1][i + 1] = (h[1][i] * p + i + 1) % mod;
        h[2][i + 1] = (h[2][i] * p + n - i) % mod;
    }
}

void solve() {
    int task, group, n;
    cin >> task >> group >> n;
    for (int _ = 0; _ < n; ++_) {
        int _x, _y;
        cin >> _x >> _y;
    }
    calc_zig_zag_hash(n);
    if (task == 1) {
        for (int i = 0; i < n; ++i) {
            int x = (i % 2 == 0) ? (i / 2 + 1): (n - i / 2);
            cout << x << ' ';
        }
        cout << endl;
        return;
    } else if (task != 2) {
        int c; cin >> c;
        if (task == 4) {
            for (int k = c; k <= n - c; ++k) {
                int hp1 = h[0][k + 1];
                int last = (k % 2 == 0) ? (k / 2 + 1): (n - k / 2), hp2 = 0;
                if (k % 2 == 0) hp2 = (h[1][last + n - k - 1] - h[1][last] * pws[n - k - 1] % mod + mod) % mod;
                else hp2 = (h[2][n - (last - (n - k - 1)) + 1] - h[2][n - last + 1] * pws[n - k - 1] % mod + mod) % mod;
                cout << (hp1 * pws[n - k - 1] + hp2) % mod << ' ';
            }
            cout << endl;
        }
        int q; cin >> q;
        for (int _ = 0; _ < q; ++_) {
            int k; cin >> k;
            vector<int> r;
            for (int i = 0; i <= k; ++i) {
                int x = (i % 2 == 0) ? (i / 2 + 1): (n - i / 2);
                r.push_back(x);
            }
            int last = (k % 2 == 0) ? (k / 2 + 1): (n - k / 2);
            for (int i = 1; i <= n - k - 1; ++i) {
                int x = (k % 2 != 0) ? last - i: last + i;
                r.push_back(x);
            }
            reverse(all(r));
            for (auto e: r) cout << e << ' ';
            cout << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/a.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
    cin >> _t;
#endif
    pre_calc();
    while (_t--) solve();
}