#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <tuple>
using namespace std;
using ll = long long;
const int INF = 1e9 + 7;
struct Point
{
	ll x, y;
	Point(int _x=0, int _y = 0) : x(_x), y(_y) {}
	Point operator-(Point oth)
	{
		return Point(x - oth.x, y - oth.y);
	}
	ll operator*(Point oth)
	{
		return x * oth.x + y * oth.y;
	}
};
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int task, group;
	cin >> task >> group;
	int n;
	cin >> n;
	vector<Point> a(n);
	for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].y;
	if (group == 2)
	{
		vector<int> p(n);
		for (int i = 0; i < n; i++) p[i] = i;
		int anss = -INF;
		do
		{
			int ans = 0;
			for (int i = 2; i < n; i++)
			{
				ans += (a[p[i]] - a[p[i - 1]]) * (a[p[i - 1]] - a[p[i - 2]]) < 0;
			}
			if (ans > anss)
			{
				anss = ans;
			}
		} while (next_permutation(p.begin(), p.end()));
		for (int i = 0; i < n; i++) p[i] = i;
		do
		{
			int ans = 0;
			for (int i = 2; i < n; i++)
			{
				ans += (a[p[i]] - a[p[i - 1]]) * (a[p[i - 1]] - a[p[i - 2]]) < 0;
			}
			if (ans == anss)
			{
				for (int i = 0; i < n; i++) cout << p[i] + 1 << ' ';
				cout << endl;
				break;
			}
		} while (next_permutation(p.begin(), p.end()));
	}
	else if (group == 1)
	{
		for (int i = 0; i*3+3<=n;i++)
		{
			cout << 3*i + 1 << ' ';
			cout << 3*i + 3 << ' ';
			cout << 3 * i + 2 << ' ';
		}
		if (n % 3 > 0)
		{
			cout << n << ' ';
		}
		if (n % 3 > 1)
		{
			cout << n - 1 << ' ';
		}
		cout << endl;
	}
}