#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

const int INF = 1e9;
const int N = 2005;
const int MOD = 1e9 + 7;
const int M = 10005; // !!!!!!!!!!!!!!!!!!!!!!!1

mt19937 gen(time(0));

struct point {
    ll x, y, i;
    
    point() {}
    
    point(ll xx, ll yy, ll ii) {
        x = xx;
        y = yy;
        i = ii;
    }
    
    bool operator<(const point& oth) const {
        return tie(x, y, i) < tie(oth.x, oth.y, oth.i);
    }

//    point operator-(const point& oth) const {
//        return point(x - oth.x, y - oth.y);
//    }

//    ll operator+(const point& oth) const {
//        return x * oth.x + y * oth.y;
//    }
    
};

ll find(ll n, set<ll>& has) {
    ll idx = gen() % (ll)has.size();
    
    ll num = 0;
    for (auto i : has) {
        if (num == idx) {
            return i;
        }
        num++;
    }
}

void solve() {
    ll task, group; cin >> task >> group;
    ll n; cin >> n;
    if (task != 1) {
        ll c; cin >> c;
    }
    vector<point> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        a[i].i = i;
    }
    sort(a.begin(),a.end());
    ll l = 0, r = n - 1;
    for (int i = 0; i < n; i++) {
        if (i % 2 == 0) {
            cout << a[l].i + 1 << " ";
            l++;
        } else {
            cout << a[r].i + 1 << " ";
            r--;
        }
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    int tst = 1;
    while (tst--) {
        solve();
    }
}