#include <bits/stdc++.h>
#define int long long
typedef long long ll;
typedef __int128 ull;
using namespace std;

struct point{
    int x, y;

    point (int _x, int _y) {
        x = _x;
        y = _y;
    }

    int scal(point b) {
        return x * b.x + y * b.y;
    }
};

vector<point> v;
int n;

void task1() {
    vector<int> ord={0, 1};
    for (int i = 2; i < n; i++) {

        ord.push_back(i);
//       cout << v1.x << " " << v1.y << " " << v2.x << " " << v2.y << endl;
//       cout << v1.scal(v2) << endl;
        for (int j = i; j >= 2; j--) {
            int a = ord[j - 2];
            int b = ord[j - 1];
            int c = ord[j];
            point v1 = {v[c].x - v[b].x, v[c].y - v[b].y};
            point v2 = {v[a].x - v[b].x, v[a].y - v[b].y};
            if (v1.scal(v2) <= 0) {
                swap(ord[j], ord[j - 1]);
            }
        }

    }

    for (int i : ord) {
        cout << i + 1 << " ";
    }
    cout << endl;
}

mt19937 mt1(1329);

void task2() {
    int C;
    cin >> C;
    vector<int> ord;
    for (int i = 0; i < n; i++) {
        ord.push_back(i);
    }

    while (true) {
        shuffle(ord.begin(), ord.end(), mt1);
        int cnt = 0;
        for (int i = 2; i < n; i++) {
            int a = ord[i - 2];
            int b = ord[i - 1];
            int c = ord[i];
            point v1 = {v[c].x - v[b].x, v[c].y - v[b].y};
            point v2 = {v[a].x - v[b].x, v[a].y - v[b].y};
            if (v1.scal(v2) > 0) {
                cnt++;
            }
        }

        if (cnt <= C) {
            for (int i: ord) {
                cout << i << " ";
            }
            cout << endl;
            exit(0);
        }
    }



}

void solve() {
   int task, group;
   cin >> task >> group;

   cin >> n;
   v.resize(n, {0, 0});
   for (int i = 0; i < n; i++) {
       cin >> v[i].x >> v[i].y;
   }

   if (task == 1) task1();
   else if (task == 2) task2();
   else {
       exit(1);
   }

}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}
