
#include <bits/stdc++.h>

using namespace std;
//set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined,bounds,address")
#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;

int n, task, group;
struct p {
    int x, y, i;
};

int d(p a, p b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

p operator-(p a, p b) {
    return {a.x - b.x, a.y - b.y, 0};
}

int good(p a, p b) {
    return a.x * b.y > b.x * a.y;
}

int pos(const vector<p> &a, int lim) {
    for (int i = 1; i + 1 < n; i++) {
        int l = i - 1, r = i + 1;
        if (good(a[l] - a[i], a[r] - a[i])) lim--;
        if (lim < 0) return 0;
    }
    return !lim;
}

int get_hash(const vector<int> &a) {
    int b = 1e6 + 3;
    int x = 1;
    int h = 0;
    for (int r: a) {
        h = (h + r * x) % mod;
        x = x * b % mod;
    }
    return h;
}

void solve() {
    cin >> task >> group >> n;
    vector<p> a(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, y, i + 1};
    }
    if (task == 1) {
        shuffle(all(a), rnd);
        vector<int> used(n);
        p st = a[0];
        used[0] = 1;
        int ost = n - 1;
        cout << st.i << ' ';
        while (ost) {
            int best = n, res = 0;
            for (int i = 1; i < n; i++) {
                if (!used[i] && res < d(st, a[i])) {
                    best = i;
                    res = d(st, a[i]);
                }
            }
            used[best] = 1;
            st = a[best];
            cout << st.i << ' ';
            ost--;
        }
        cout << endl;
        return;
    }
    int c;
    cin >> c;
    if (task == 3) {
        int q;
        cin >> q;
        while (q--) {
            cin >> c;
            vector<int> p;
            for (int i = 0; i < c - 1; i++) {
                p.push_back(i + 1);
                p.push_back(n - i);
            }
            for (int i = c; i <= n - c; i++) {
                p.push_back(i);
            }
            for (int i: p) cout << i << endl;
            cout.flush();
        }
        return;
    }
    if (task == 4) {
        int cc = c;
        vector<int> rem(n);
        for (; c <= n - cc; c++) {
            vector<int> p;
            for (int i = 0; i < c - 1; i++) {
                p.push_back(i + 1);
                p.push_back(n - i);
            }
            for (int i = c; i <= n - c; i++) {
                p.push_back(i);
            }
            rem[c] = get_hash(p);
        }
        int q;
        cin >> q;
        while (q--) {
            cin >> c;
            cout << rem[c] << endl;
        }
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    while (_--) {
        solve();
        // cout << '\n';
    }
    return 0;
}
