//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <vector>
#include <deque>
#include <ctime>
#include <unordered_set>
#include <iomanip>
#include <algorithm>
using namespace std;
#define double long double
//#define int long long
#define ll long long
#define debug(x) cerr << (#x) << ": " << x << endl;
#define get_time (double)(clock()) / (double)(CLOCKS_PER_SEC)
const int INF = 1e18 + 7;
const int mod = 1e9 + 7;
const int MAXN = 2e5 + 10;
//#pragma GCC optimize("avx2")
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
int make_add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
int mul(int a, int b) {
    return (a * b) % mod;
}
struct point {
    int x, y;
};
point make_vector_from_two_point(point a, point b) {
    return { b.x - a.x, b.y - a.y };
}
int scalar_mul(point a, point b) {
    return a.x * b.x + a.y * b.y;
}
const int B = 1000;
int task, group, n, q;
vector<point> points;
void ask(vector<int> x) {
    for (auto c : x) cout << c + 1 << " ";
    cout << endl;
}
int make_cnt(vector<int> p) {
    int res = 0;
    for (int i = 1; i < n - 1; i++) {
        point ab = make_vector_from_two_point(points[p[i]], points[p[i - 1]]), ac = make_vector_from_two_point(points[p[i]], points[p[i + 1]]);
        int sc = scalar_mul(ab, ac);
        if (sc >= 0) res++;
    }
    return res;
}
void solve_task_1() {
    vector<int> p;
    for (int i = 0; i < n; i++) p.push_back(i);
    int best = -1;
    vector<int> out;
    for (int it = 0; it < B; it++) {
        random_shuffle(p.begin(), p.end());
        int may = make_cnt(p);
        if (may > best) {
            best = may;
            out = p;
        }
    }
    ask(out);
}
void solve_g_1_7() {
    vector<int> ans;
    ans.push_back(0);
    int i = 1;
    while (i + 1 < n) {
        ans.push_back(i + 1);
        ans.push_back(i);
        i += 2;
    }
    if (n % 2 == 0) ans.push_back(n - 1);
    if (task == 1) {
        ask(ans);
        return;
    }
    int c;
    cin >> c;
    ans.clear(); for (int i = 0; i < n; i++) ans.push_back(i);
   // ask(ans); 
    cin >> q;
    for (int it = 0; it < q; it++) {
        int k;
        cin >> k;
        ans.clear();
        int ind = 0, must_p = n - k - 1;
        for (int i = 0; i < must_p; i++) {
            ans.push_back(i);
            ind++;
        }
        int i = ind;
        while (i + 1 < n) {
            ans.push_back(i + 1);
            ans.push_back(i);
            i += 2;
        }
        if (i == n - 1) ans.push_back(n - 1);
        ask(ans);
    }
}
void solve() {
    cin >> task >> group >> n;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        points.push_back({ x, y });
    }
    if (group == 1 || group == 7) {
        solve_g_1_7();
    } else {
        solve_task_1();
    }
}
signed main() {
    cout << fixed << setprecision(20);
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
/*
3 1 5
1 2
2 5
4 6
7 8
9 11
*/