#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(1337);

struct Point {
    int x, y;

    int operator*(Point other) {
        return x * other.x + y * other.y;
    }

    Point operator-(Point other) {
        return Point(x - other.x, y - other.y);
    }
};

inline void solve() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<Point> a(n);
    for (auto& i : a)
        cin >> i.x >> i.y;
    if (task == 3) {
        int c;
        cin >> c;
        int q;
        cin >> q;
        unordered_map<int, vector<int>> anses;
        for (int i = 0; i < q; ++i) {
            int k;
            cin >> k;
            if (!anses[k].empty()) {
                for (auto j : anses[k])
                    cout << j + 1 << ' ';
                cout << endl;
                continue;
            }
            vector<int> p(n);
            iota(p.begin(), p.end(), 0);
            while (true) {
                shuffle(p.begin(), p.end(),rnd);
                int check = 0;
                for (int j = 1; j < n - 1; ++j) {
                    check += ((a[p[j - 1]] - a[p[j]]) * (a[p[j + 1]] - a[p[j]])) >= 0;
                    if (check > k)
                        break;
                }
                if (check == k)
                    break;
            }
            anses[k] = p;
            for (auto j : p)
                cout << j + 1 << ' ';
            cout << endl;
        }
    }
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
#ifdef LOCAL
//    auto f1 = freopen("input.txt", "r", stdin);
//    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test)
        solve();
    return 0;
}
