#include <bits/stdc++.h>

using namespace std;

using ll = long long;

mt19937 rnd(time(0));

struct point {
    ll x, y;
};

ll dp(point a, point b){
    return a.x * b.x + a.y * b.y;
}

bool check(point a, point b, point c){
    point d = {a.x - b.x, a.y - b.y}, e = {c.x - b.x, c.y - b.y};
    if(dp(d, e) > 0){
        return true;
    } else {
        return false;
    }
}

void solve(){
    ll task, group;
    cin >> task >> group;
    ll n, fl = true;
    cin >> n;
    vector<point> a(n);
    for(ll i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        if(i > 0 && (a[i].x <= a[i - 1].x || a[i].y <= a[i - 1].y)){
            fl = false;
        }
    }
    if(fl){
        ll l = 1, r = n;
        for(ll i = 1; i <= n; i++){
            if(i % 2){
                cout << l << ' ';
                l--;
            } else {
                cout << r << ' ';
                r--;
            }
        }
        return;
    }
    vector<ll> p;
    for(ll i = 0; i < n; i++){
        p.push_back(i);
    }
    ll ans = 0;
    vector<ll> best;
    for(ll it = 0; it < (ll)7e3; it++){
        shuffle(p.begin(), p.end(), rnd);
        ll cnt = 0;
        for(ll i = 1; i < n - 1; i++){
            point a1 = a[p[i - 1]], a2 = a[p[i]], a3 = a[p[i + 1]];
            if(check(a1, a2, a3)){
                cnt++;
            }
        }
        if(ans < cnt){
            ans = cnt;
            best = p;
        }
    }
    for(auto u : best){
        cout << u + 1 << ' ';
    }

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
