#include <bits/stdc++.h>

using namespace std;

using ll = long long;

mt19937 rnd(time(0));

struct point {
    ll x, y;
};

ll dp(point a, point b){
    return a.x * b.x + a.y * b.y;
}

bool check(point a, point b, point c){
    point d = {a.x - b.x, a.y - b.y}, e = {c.x - b.x, c.y - b.y};
    if(dp(d, e) > 0){
        return true;
    } else {
        return false;
    }
}

ll cp(point a, point b){
    return a.x * b.y - a.y * b.x;
}

ll len(point a){
    return a.x * a.x + a.y * a.y;
}

point mn;

bool cmp(const point& a, const point& b){
    point c = {a.x - mn.x, a.y - mn.y};
    point d = {b.x - mn.x, b.y - mn.y};
    if(cp(c, d) == 0){
        return len(c) < len(d);
    }
    return cp(c, d) > 0;
}

void solve(){
    ll task, group;
    cin >> task >> group;
    ll n, fl = true;
    cin >> n;
    vector<point> a(n);
    map<ll, ll> mp;
    for(ll i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        mp[a[i].x] = i + 1;
        if(i > 0 && (a[i].x <= a[i - 1].x || a[i].y <= a[i - 1].y)){
            fl = false;
        }
    }
    if(fl && task == 1){
        ll l = 1, r = n;
        for(ll i = 1; i <= n; i++){
            if(i % 2){
                cout << l << ' ';
                l++;
            } else {
                cout << r << ' ';
                r--;
            }
        }
        return;
    }
    if(task == 2){
        ll c;
        cin >> c;
        ll id = 0;
        for(ll i = 1; i < n; i++){
            if(a[i].x < a[id].x || (a[i].x == a[id].x && a[i].y < a[id].y)){
                id = i;
            }
        }
        mn = a[id];
        swap(a[0], a[id]);
        sort(a.begin() + 1, a.end(), cmp);
        for(auto u : a){
            cout << mp[u.x] << ' ';
        }
        return;
    }

    vector<ll> p;
    for(ll i = 0; i < n; i++){
        p.push_back(i);
    }
    ll ans = 0;
    vector<ll> best;
    for(ll it = 0; it < (ll)1e5; it++){
        shuffle(p.begin(), p.end(), rnd);
        ll cnt = 0;
        for(ll i = 1; i < n - 1; i++){
            point a1 = a[p[i - 1]], a2 = a[p[i]], a3 = a[p[i + 1]];
            if(check(a1, a2, a3)){
                cnt++;
            }
        }
        if(ans < cnt){
            ans = cnt;
            best = p;
        }
    }
    for(auto u : best){
        cout << u + 1 << ' ';
    }

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
