#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>
#include <random>

using namespace std;

typedef long long ll;

mt19937 rnd(847923);

struct point {
	ll x, y;
};

struct point1 {
	ll x, y;
};

ll operator%(point a, point b) { return a.x * b.x + a.y * b.y; }
ll operator*(point a, point b) { return a.x * b.y - a.y * b.x; }

point mv(point a, point b) { return {b.x - a.x, b.y - a.y}; }

bool check(point a, point b) {
	return a % b > 0;
}

bool operator<(point a, point b) { return tie(a.x, a.y) < tie(b.x, b.y); }

bool operator<(point1 a, point1 b) { return tie(a.y, a.x) < tie(b.y, b.x); }

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	int task, gr; cin >> task >> gr;
	int n; cin >> n;
	vector <point> a(n);
	for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].y;
	if (gr == 1) {
		cout << "1 ";
		for (int i = 2; i < n; i += 2) {
			cout << i + 1 << ' ' << i << ' ';
		}
		if (n % 2 == 0) cout << n;
		return 0;
	}
	if (gr == 2) {
		vector <int> ind;
		for (int i = 0; i < n; i++) ind.push_back(i);
		vector <int> indans;
		int ans = 0;
		for (int _ = 0; _ < 200000; _++) {
			shuffle(ind.begin(), ind.end(), rnd);
			int cnt = 0;
			for (int i = 1; i < n - 1; i++) {
				if (check(mv(a[ind[i]], a[ind[i - 1]]), mv(a[ind[i]], a[ind[i + 1]]))) cnt++;
			}
			if (cnt > ans) {
				ans = cnt;
				indans = ind;
			}
		}
		for (auto i : indans) cout << i + 1 << ' ';
		return 0;
	}
	set <pair <point, int>> indx, indy, indx1, indy1;
	vector <int> ind;
	for (int i = 0; i < n; i++) indx.insert({ a[i], i }), indy.insert({ a[i], i });
	indx1 = indx, indy1 = indy;
	int ans = 0;
	vector <int> indans;
	for (int _ = 0; _ < 2000; _++) {
		while (indx.size()) {
			int c = rnd() % 4;
			if (!c) {
				ind.push_back((*indx.begin()).second);
				pair <point, int> p = *indx.begin();
				indy.erase(p);
				indx.erase(indx.begin());
			}
			else if (c == 1) {
				ind.push_back((*--indx.end()).second);
				pair <point, int> p = *--indx.end();
				indy.erase(p);
				indx.erase(--indx.end());
			}
			else if (c == 2) {
				ind.push_back((*indy.begin()).second);
				pair <point, int> p = *indy.begin();
				indx.erase(p);
				indy.erase(indy.begin());
			}
			else {
				ind.push_back((*--indy.end()).second);
				pair <point, int> p = *--indy.end();
				indx.erase(p);
				indy.erase(--indy.end());
			}
		}
		indx = indx1, indy = indy1;
		int cnt = 0;
		for (int i = 1; i < n - 1; i++) {
			if (check(mv(a[ind[i]], a[ind[i - 1]]), mv(a[ind[i]], a[ind[i + 1]]))) cnt++;
		}
		if (cnt > ans) {
			ans = cnt;
			indans = ind;
		}
	}
	for (auto i : indans) cout << i + 1 << ' ';
	return 0;
}