#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
//#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e6+2;

struct pt
{
    ll x,y;
};

ll line_eq(pt a, pt b, pt c)
{
    return (c.x-a.x)*(b.y-a.y)-(c.y-a.y)*(b.x-a.x);
}

bool good(pt a, pt b, pt c)
{
    pt d=b;
    d.x+=abs(a.y-b.y);
    d.y+=abs(a.x-b.x);
    ll e1=line_eq(b,d,a),e2=line_eq(b,d,c);
    return (e1>0&&e2>0)||(e1<0&&e2<0);
}

pt arr[N];
ll n,group,tl=1.9*CLOCKS_PER_SEC;

namespace task1
{
    pt arr[N];

    void solve()
    {
        ve<ll> p(n),best(n);
        iota(all(p),0);
        ll ans=-INF;

        while(clock()<tl)
        {
            shuffle(all(p),gen);
            ll cur=0;

            for(ll i=0;i<n-2;i++)
            {
                if(good(arr[p[i]],arr[p[i+1]],arr[p[i+2]]))
                    cur++;
            }

            if(cur>ans)
            {
                ans=cur;
                best=p;
            }
        }

        for(ll i=0;i<n;i++)
            cout<<best[i]+1<<' ';
    }
}

void solve()
{
    ll task;
    cin>>task>>group>>n;

    for(ll i=0;i<n;i++)
        cin>>arr[i].x>>arr[i].y;

    if(task==1) task1::solve();
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
