#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
//#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e6+2;

struct pt
{
    ll x,y;
};

ll line_eq(pt a, pt b, pt c)
{
    return (c.x-a.x)*(b.y-a.y)-(c.y-a.y)*(b.x-a.x);
}

ll dist(pt a, pt b)
{
    return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}

bool good(pt a, pt b, pt c)
{
    pt d=b;
    d.x+=b.y-a.y;
    d.y+=a.x-b.x;
    ll e1=line_eq(b,d,a),e2=line_eq(b,d,c);
    return (e1>0&&e2>0)||(e1<0&&e2<0);
}

void test_good()
{
    assert(!good({0,0},{2,3},{4,2}));
    assert(!good({0,0},{2,3},{1,8}));
    assert(good({0,0},{1,8},{2,3}));
    assert(!good({1,8},{2,3},{4,2}));
}

pt arr[N];
ll n,group,tl=1.9*CLOCKS_PER_SEC;

namespace task1
{
    void solve()
    {
        ve<ll> p(n),best(n);
        iota(all(p),0);
        ll ans=-INF;

        while(clock()<tl)
        {
            shuffle(all(p),gen);
            ll cur=0;

            for(ll i=0;i<n-2;i++)
            {
                for(ll it=0;it<1000&&!good(arr[p[i]],arr[p[i+1]],arr[p[i+2]]);it++)
                    swap(p[i+2],p[i+2+gen()%(n-i-2)]);

                if(good(arr[p[i]],arr[p[i+1]],arr[p[i+2]]))
                    cur++;
            }

            if(cur>ans)
            {
                ans=cur;
                best=p;
            }
        }

        for(ll i=0;i<n;i++)
            cout<<best[i]+1<<' ';

        cout<<endl;
    }
}

namespace task2
{
    void solve()
    {
        ll c;
        cin>>c;
        ve<ll> p(n);
        iota(all(p),0);

        while(clock()<tl)
        {
            shuffle(all(p),gen);
            ll cur=0;

            for(ll i=0;i<n-2;i++)
            {
                if(good(arr[p[i]],arr[p[i+1]],arr[p[i+2]]))
                    cur++;
            }

            if(cur<=c)
            {
                for(ll i=0;i<n;i++)
                    cout<<p[i]+1<<' ';

                cout<<endl;
                return;
            }
        }
    }
}

void solve()
{
    ll task;
    cin>>task>>group>>n;

    for(ll i=0;i<n;i++)
        cin>>arr[i].x>>arr[i].y;

    if(task==1) task1::solve();
    else if(task==2) task2::solve();
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //test_good();
    solve();
    return 0;
}
