#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>
#include <map>

#define int long long

using namespace std;

struct jackfreska{
    int x;
    int y;
    jackfreska(){
        x=-1e10;
        y=-1e10;
    }
};


jackfreska operator-(jackfreska a, jackfreska b){
    jackfreska c;
    c.x=a.x-b.x;
    c.y=a.y-b.y;
    return c;
}
int operator*(jackfreska a,jackfreska b){
    return a.x*b.x+a.y*b.y;
}

int operator%(jackfreska a,jackfreska b){
    return a.x*b.y-a.y*b.x;
}

jackfreska x0;
bool comp(jackfreska a,jackfreska b){
    int x=(a-x0)%(b-x0);
    if(x!=0){
        return x>0;
    }
    return (a-x0)*(a-x0)<(b-x0)*(b-x0);
}

int32_t main(){
    int t,g;
    cin>>t>>g;
    int n;
    cin>>n;
    map<int,int>m;
    vector<jackfreska>v(n);
    for(int i=0;i<n;++i){
        cin>>v[i].x>>v[i].y;
        m[v[i].x]=i;
        if(v[i].x<v[0].x||(v[i].x==v[0].x&&v[i].y<v[0].y)){
            swap(v[i],v[0]);
        }

    }
    for(int i=1;i<n;++i){
        x0=v[i-1];
        sort(v.begin()+i,v.end(),comp);;
    }
    for(int i=0;i<n;++i){
        cout<<m[v[i].x]+1<<' ';
    }

    return 0;
}