#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;
using ll = long long;

const ll mod = 1e9 + 7;

bool check(pair<double, double> a, pair<double, double> b, pair<double, double> c) {
	double x1 = a.first - b.first, y1 = a.second - b.second;
	double x2 = c.first - b.first, y2 = c.second - b.second;
	return (x1 * x2 + y1 * y2) / (sqrt(x1 * x1 + y1 * y1) * sqrt(x2 * x2 + y2 * y2)) > 0;
}

int main()
{
	int t, g;
	cin >> t >> g;
	int n;
	cin >> n;
	vector<pair<double, double>> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i].first >> v[i].second;
	}
	sort(v.begin(), v.end());
	int m = 0;
	vector<int> per(n);
	for (int i = 0; i < n; i++) per[i] = i;
	vector<int> ans = per;
	do {
		for (auto x : per) cout << x << " ";
		int loc = 0;
		for (int i = 1; i < n - 1; i++) {
			if (check(v[per[i - 1]], v[per[i]], v[per[i + 1]])) {
				loc++;
			}
		}
		if (loc > m) {
			ans = per;
			m = loc;
		}
	} while (next_permutation(per.begin(), per.end()));
	for (auto& x : ans) cout << x + 1 << " ";
}