/*
⣿⢟⣿⣻⢟⣿⣻⢟⣿⣻⢟⣿⣻⢟⣟⣟⢟⣟⢟⣟⣟⣻⡻⣻⡻⣻⡻⣻⢟⣿⡻⣟⢿⢿⡿⣿⢿⡿⣿⣿⣿⣿⣿⡿⢟⠟⢟⠿⣿⣿⠿⠋⠝⣥⣡⢭⣨⣣⢭⢮⢵⡭⣪⡡⣩⡈⡧⢱⠥⢅⢍⡙⠛⠟⢛⢋⢍⣍⣬⡵⣝⢾⣝⣯⣻⡻⣻⢟⡿⣻⡻⣟⢟⣟⢿⡻⣿⢿⡿⣿⢿⡿⣿⡻⣟⢨⣿⣿⣿⣿
⣯⡻⣮⢷⣻⡵⣯⣻⢮⣯⣻⢮⡷⣻⡵⣏⡿⣪⣟⢾⣪⢷⣝⡽⣝⢷⣝⢯⣻⢮⡿⣝⣟⣿⣺⢯⡿⣾⣻⣞⣷⢟⠬⣂⣱⢞⣦⡢⠴⡌⠠⢈⠂⢞⢑⢳⡳⢕⢋⠕⡡⡑⢅⢊⢂⠳⢈⠢⠑⡂⢂⡩⡜⡴⢥⢣⢝⢦⡻⣺⣝⢷⡵⣳⣝⡽⣝⡽⣞⡽⣞⡽⣝⣽⢽⡽⢯⢷⡛⣙⡕⡿⣽⣻⠃⣼⣿⣿⣿⣿
⢮⡿⣵⢟⣵⢟⣞⢷⣻⣮⢡⣭⣭⡍⣺⢟⣞⢷⡝⡷⡽⡎⣬⣬⣥⣅⢫⢷⣝⢃⣭⣭⣭⣌⢻⡯⢩⣭⣬⣭⠑⣣⢞⡮⣗⢟⠎⣩⣥⣴⣦⣤⣅⢊⢂⠣⢑⣠⣥⣴⣬⣬⣁⡣⣅⣓⡢⡥⣃⠪⠚⣨⣬⣤⣥⣤⣕⡱⡹⡧⣯⡇⣭⣥⣭⡌⢟⡾⣵⡋⣬⣭⣬⣥⣥⣔⣓⢿⡍⡔⣽⢪⣿⡏⢸⣾⣿⣿⣿⣿
⡻⣞⣽⣫⡯⣿⢽⡯⣷⣻⢠⣿⣿⡇⣽⣫⢞⡷⣝⣟⠾⢡⣿⣿⣿⣿⡌⣷⡻⢄⣿⣿⣿⣿⡘⢇⣿⣿⣿⣿⠐⣯⢫⣮⢹⡁⣾⣿⣿⠉⠛⡿⡿⠇⠹⢡⣿⣿⡿⢛⠻⢿⣿⣷⡜⣽⣪⣛⢖⡑⢼⣿⣿⡋⠝⢿⠿⠷⢘⡝⡮⣰⣿⣿⣿⣿⡘⣟⣾⠕⣿⣿⡿⢛⠿⣿⣿⣦⠸⣜⢧⣿⡞⣢⣿⣿⣿⣿⣿⣿
⣝⢷⡽⣮⣻⣗⡿⣽⣞⣿⢐⣿⣿⡇⢾⢵⢯⡻⡮⣯⢃⣿⣿⢇⢹⣿⣷⡘⣿⠄⣿⣿⡝⣿⣇⢹⣿⠇⣿⣿⠐⢃⠅⠄⠢⠠⠹⢿⣿⣿⣿⣶⣦⡑⢍⣾⣿⣿⢰⡟⣷⠈⣿⣿⣧⢸⢮⣝⢵⣫⡘⢿⣿⣿⣿⣶⣶⣅⢫⡺⢠⣿⣿⠃⢻⣿⣧⢙⣴⡎⣿⣿⡗⣿⣷⢹⣿⣿⡆⣿⣟⡾⣨⣾⣿⣿⣿⣿⢿⣿
⡺⣯⡻⣾⢵⣯⣻⣗⢿⣺⢐⣿⣿⡇⣻⡳⣏⣟⢾⠃⣾⣿⣿⣦⣼⣿⣿⣇⢻⠌⣿⣿⠆⢿⣿⣿⣿⠀⣿⣿⡁⡶⡜⢋⡐⡁⣦⣤⡍⣍⡙⢿⣿⣿⢀⢻⣿⣿⡜⠽⠮⣡⣿⣿⡇⡜⢳⣕⢷⡅⣩⣤⣌⢩⡙⢻⣿⣿⡆⢁⣾⣿⣿⣬⣾⣿⣿⣇⢻⡇⣿⣿⣏⠿⠟⣸⣿⣿⢡⣿⠞⢴⣿⣿⣿⣿⣿⣿⣿⣿
⣝⡷⣻⣵⣟⡷⣻⣞⢯⡿⢐⣿⣿⡇⣝⣮⣣⢟⡏⣼⣿⣿⠛⡛⣛⠻⣿⣿⣎⠃⣿⣿⡛⠸⣿⣿⡇⡄⣿⣿⡐⠏⡠⣷⢹⢂⠻⣿⣿⣶⣶⣿⣿⠏⣼⣈⠻⣿⣿⣷⣾⣿⣿⠟⣴⣻⣔⠬⡣⢧⡹⢿⣿⣷⣶⣾⣿⠟⡐⣾⣿⣿⢛⣛⣛⢻⣿⣿⡎⢗⣿⣿⣿⣿⣿⣿⡿⢋⣮⢟⣨⣿⣿⣿⣿⣿⣯⣿⣿⣿
⢮⣻⢽⣞⡷⣻⡯⣾⣫⢿⢦⣭⣭⢵⣛⣎⣝⣍⡦⡭⣭⡥⡾⡶⡶⣤⣭⣭⣥⣬⡭⡭⢔⢧⡩⣍⠔⣤⠭⡩⡀⣱⡻⢎⢇⢜⠷⣦⢭⣩⣍⡭⣴⠺⡵⣽⡱⢦⡭⣍⡍⠭⣔⢟⢮⢖⡽⣲⡕⢕⢝⢦⣭⡭⣭⣭⣴⢾⣅⢭⣭⢡⣿⡽⣿⣦⣭⣭⣵⣦⣭⣭⣭⡭⣩⣴⢞⣯⠏⢤⣿⣿⣿⣿⣿⣽⣿⣿⡿⣿
⡽⣳⣟⢮⡿⣽⠞⣡⢦⡳⡳⣮⢺⢧⣫⢞⡮⣞⢾⢕⢷⣝⣞⢟⣞⢗⡷⡺⡶⣕⢯⡺⡱⡣⡞⣰⢾⡑⡡⢊⢤⢯⡫⣺⢁⣏⡳⡳⢯⡰⣧⢻⣞⢥⡛⣾⣕⡳⣹⢎⡿⣪⡪⣗⢟⣮⡻⣮⣫⡧⡱⡱⣣⢿⣞⢮⣟⡷⡻⢮⣳⡧⢿⣿⣹⣿⣿⢟⣯⣻⣿⣿⢟⣰⢯⣞⢯⠎⣲⣿⣿⣿⣿⣿⢿⣿⣿⢿⣿⣿
⣝⢷⣝⣟⢾⣻⡕⢝⢮⣹⢝⡮⣫⣗⢽⣣⢟⣼⡳⣽⡳⡽⣮⡻⣮⢯⣫⣟⡽⣺⢇⢯⢺⢁⣾⢙⢃⠔⣡⠃⣾⢣⣏⢷⠡⣏⢾⣑⠧⣝⣞⢷⡽⡠⣇⠘⣮⢳⣌⢳⣝⢷⢽⣌⢻⡮⣻⡺⡮⡷⣕⠵⢌⢗⣽⣟⣵⣻⢟⣎⡻⣻⢚⣿⣿⢋⣶⣿⣷⣝⢿⡭⣲⢯⢷⡝⠣⣼⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣺⡻⣮⢯⣻⣮⢿⣌⠳⡱⡇⡯⡺⣪⢷⡭⣫⢾⣝⢮⣯⢻⣎⢿⣪⢷⣳⣝⢞⢵⡱⡣⢃⢜⢡⠊⢎⢼⡣⡸⣳⢕⣯⣻⢘⣧⣫⡲⢱⡯⣺⡳⣽⠂⡮⡱⡈⢷⡻⣆⠙⣷⣫⢾⣆⡙⢷⡽⣺⢯⡻⡷⣝⢮⡦⣻⡼⣗⣿⡉⣯⣕⣝⣾⣥⣿⣻⣷⣻⡧⢿⣞⣯⣻⠏⢌⣿⣿⣿⣿⣿⣿⣿⣽⣿⣿⣽⣿⣿⣿
⢮⣻⡳⣟⣵⢯⡿⣽⣧⢙⢜⢮⢬⢮⣬⣮⣭⣕⡙⠳⢝⠗⡽⡳⡝⢷⢵⣫⢞⣕⡕⢁⣮⢃⠇⡘⣜⢗⢆⡽⣪⢗⢷⢵⠸⢼⡵⣍⢼⣝⡽⣝⡽⡅⢺⠀⣿⡈⢿⡽⡄⢆⠹⣳⣝⢷⡐⢝⢝⢯⣻⣝⣯⢷⣎⠘⠿⣽⣟⣎⠿⣿⣽⣯⡿⣷⣟⣾⣽⣿⣾⣮⣮⡱⡡⣻⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⣿⡿⣿⣿
⣝⢷⡻⣽⡺⣗⡿⣾⣝⣷⣅⠳⡕⣝⢺⡳⣯⢾⡻⣻⡳⣻⢖⡾⣲⢗⡶⡼⡧⡵⢀⡿⣊⡜⡐⢜⣭⣫⢢⢯⢏⣝⢗⢯⢸⢪⣟⠆⡾⣪⢟⡮⣳⢭⠘⡄⢷⣿⡌⢻⣽⡘⣦⢊⠚⣯⢿⣕⡱⣣⢝⡳⡽⣯⢿⣷⣕⠤⣙⠺⣻⢜⣷⣿⣻⢿⡾⣿⣾⢷⣿⣽⣟⢏⠢⣿⣿⣿⣿⣿⣾⣿⣿⣿⣿⣾⣿⣿⣿⣿
⡺⣯⣻⢽⡽⣽⢽⣞⡷⣽⣟⣷⣎⡪⡣⣟⢞⣗⢿⡽⣯⢯⣯⣻⣭⡻⣞⡽⣞⠢⡽⡎⢾⠌⢰⡻⣔⢷⢸⡗⠕⣮⡛⣼⢨⡎⡾⢱⡏⢾⣫⢾⣝⠷⡅⡹⢼⣾⣿⣆⠻⣧⠸⡷⣍⠦⣙⢯⣷⣬⢳⣭⡺⢔⡛⢮⣟⢷⣵⣍⢮⢻⣯⣿⣽⣿⣟⣿⣽⣟⣿⡢⡦⣫⡓⠸⣿⣿⣿⢿⣿⡿⣿⣾⣿⣿⢿⣿⣿⣿
⣽⡺⣗⢿⡺⣗⣟⢾⡽⣷⣽⣻⣞⢿⣜⡮⡫⣞⢷⢝⣯⣻⢽⣯⣻⣟⣮⣻⡎⢼⡫⣴⡻⢠⢹⣝⢞⡧⣻⢘⢕⠮⣱⣻⡐⢧⢃⡿⣝⠼⣳⢯⡞⣿⡱⣘⢾⡷⣿⣭⣵⡸⣶⠸⣿⣿⣦⡕⣌⠳⢇⢻⣟⣷⣬⣕⣨⠒⡑⣎⡗⣿⣿⣻⣷⣿⢾⣟⣯⣿⣿⢎⡾⣆⢻⡔⢩⡻⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿
⢮⣟⣽⣫⣟⡽⣞⣯⡻⡾⣾⢵⣟⣯⢿⡽⣶⣮⡑⢯⣞⢮⡷⣫⢿⢾⣯⣿⢀⣿⢢⢟⡜⢰⢹⣎⢟⡎⣾⠨⡪⡑⡷⣝⣦⡙⡌⣟⣾⠀⢻⣗⢟⣞⢷⢨⢾⣿⣻⡿⣿⣿⣮⣥⡙⣿⣿⢿⣯⢿⣦⢅⣍⢨⣃⢍⣋⡫⡩⡬⢷⣜⣋⢭⢦⡵⣋⡻⣿⣿⡏⣺⣝⣿⡺⣿⠄⣷⣎⠻⣿⣿⢿⣿⣷⣿⣿⡿⣿⣿
⣳⡽⣮⢷⡽⣞⣯⣞⡽⣝⣷⡻⣷⢽⣯⣻⢷⣽⣻⣦⣌⡓⠝⡽⡳⣏⢶⡹⢀⠏⣼⡳⡕⡱⢕⣽⡹⡣⣯⢘⠌⣼⡹⢮⡟⣔⢻⡌⣿⠆⣇⢿⡽⣺⣻⣇⠻⣟⣿⣿⣟⣿⡿⡿⣟⡮⡋⠽⠊⠡⠺⠗⠸⢑⣎⢿⡹⣯⣲⣚⠶⣨⣥⡕⣪⣗⠭⣪⣌⡻⡸⣕⣽⡯⣇⢟⣷⢹⣿⣧⢹⣿⣿⣿⣿⢿⣿⣿⣿⣿
⢮⡻⣞⢷⣻⢞⣮⢞⣽⡺⡮⡿⣽⣳⡯⣷⢿⡺⡷⡽⣯⢿⣻⣦⡙⢮⡳⡻⡌⢣⡿⡵⡇⣜⢕⣧⣻⣕⢷⠨⡂⣾⠝⡽⣸⣿⡕⢿⡌⣷⢹⡎⣿⢽⣮⣻⣪⢻⣿⣯⣿⣿⢍⠊⡈⠄⢐⣤⢪⣷⣶⡠⡔⠇⡞⢦⣝⡤⢅⣹⣾⣿⣿⡿⣺⡧⡳⢨⢎⢕⢎⠰⣿⡽⣫⡪⣿⣸⣿⣿⠢⣿⣿⣿⣿⣿⣿⡿⣿⣿
⡵⣻⣝⢗⣿⣻⣮⡻⣮⡻⣞⣽⣫⢾⡯⣿⡵⣻⢞⣽⡺⣗⡽⣮⣏⠸⢪⢛⢞⢸⡯⡞⡡⢸⡪⡾⢮⣞⣽⡘⢄⡣⡾⣱⣿⣽⣿⡜⣿⡜⣇⢿⣮⢳⡷⡽⣮⢳⣝⢿⣿⢓⣴⣁⡐⡁⢊⡉⡸⣞⣿⣟⣗⠡⣹⣧⣭⠄⣾⣿⡿⣷⢿⡇⣿⡣⣫⠰⡕⢭⣎⢘⣿⡺⡿⡌⣿⠜⣿⣿⢑⣿⣿⣿⣯⣿⣿⣿⣿⣿
⣺⢧⣯⡻⣾⢵⣯⣟⣮⡻⡮⡾⣕⢿⡽⣾⢯⣷⡻⣮⢻⣎⢿⣪⡾⣶⣁⠱⡅⣻⢞⡕⣅⠸⡕⣟⢷⡳⡵⢇⢕⢝⣼⣟⡿⣾⣯⣷⣹⣿⣞⢎⣿⡗⢿⡽⣷⢇⢿⣿⣽⣿⣿⣥⢀⢌⠦⡑⢎⡻⡙⢝⡎⠰⡰⣽⢾⢨⣿⣿⢯⣟⣿⡊⣿⡇⡽⡨⡪⣒⣷⠐⣿⣽⢿⡣⣻⣍⣿⡧⣽⣿⣿⣿⣿⣿⣟⣿⣿⣿
⣝⡿⣾⣽⣻⣯⢷⡿⣮⣟⢾⣝⡽⣳⡽⣺⢟⣾⢯⣞⢷⣹⡳⣿⢿⡺⡇⠒⠠⣯⡻⡆⡪⡈⣗⢯⣫⡯⣻⢸⠸⣎⢷⠯⣻⠛⡞⠟⣷⢿⣿⣷⡹⣿⣎⡻⣽⣿⡘⣿⣿⣿⣿⡿⢦⣠⣰⣾⣶⣞⣿⢮⡿⡐⡕⢺⣿⣺⣿⡟⢼⣯⣿⢌⣿⡆⣙⡮⡢⣵⢿⡈⣿⣯⢿⣏⠼⡇⢾⢒⣿⣿⣿⣿⣽⣿⣿⣿⣿⣿
⢾⣽⣗⡿⣾⡽⣟⣽⡻⣞⢷⡽⣝⣷⣫⣯⢯⣯⣻⣽⣗⢽⡺⡵⣯⡻⢨⢁⢪⢒⢽⡣⡂⢵⡘⢽⢮⡻⣵⢱⠈⣏⠙⢁⠄⠄⡘⢰⣬⣝⣯⣿⣿⣟⣿⣮⡱⢿⣷⡹⣿⣿⣿⣿⣿⣞⣿⣿⣻⣷⢻⣝⡿⡄⣻⡈⣿⣿⣿⣿⣘⣷⢿⠣⣿⡆⡱⣟⢾⡳⣿⡑⣿⢯⡿⣇⣻⣫⢌⣿⣿⣿⣿⢿⣿⣿⣻⣿⣾⣿
⣻⢾⣽⣻⢾⣻⢯⡾⣝⣯⣗⡿⣽⢮⡷⡽⡾⣮⢾⢶⢯⢷⡝⡾⡕⢅⠳⡄⡕⡕⣸⣇⠆⢸⣧⡙⢗⣯⣻⠰⠁⡁⣨⣶⣔⠠⠂⢌⠠⡜⣿⣿⣿⣿⣿⣿⣿⣮⡻⢷⣽⣿⣿⣿⣿⣷⣽⣿⣟⣿⡽⣿⣝⠦⣸⡇⢿⣿⣷⣿⣷⡟⢑⡵⢿⡇⢜⣯⢿⣝⣿⢸⡯⣿⢽⡗⢼⡇⠴⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣽⣻⢷⣯⣟⣽⡳⣯⢿⣮⣟⢾⡯⣷⣻⣝⣟⢾⡳⣯⡻⣳⢟⢽⣰⢝⢮⡪⣊⠎⣼⢷⠀⢹⡮⣷⢌⠳⣝⡇⡃⢶⢾⡿⣿⠧⠑⠅⣃⣸⣼⣿⣿⣽⣿⣟⣿⣿⣿⣯⣻⣽⣿⣿⣿⣿⡾⣯⣿⣿⣗⢿⡇⡗⡬⣟⡸⢟⢞⠿⠑⢤⢪⡟⣾⢇⢪⣟⣿⡺⡯⢸⡯⡻⣽⣟⢸⣷⢱⢹⣿⣿⣽⣿⣯⣿⣿⣽⣿⣿
⢾⡽⣳⢷⡽⣞⣯⣟⣷⣳⡯⣿⠽⡳⡛⣬⢵⢵⢞⡶⣳⡳⣻⢧⡫⣗⢯⠂⣕⠱⣯⣻⠀⢸⢯⡞⣷⡑⢮⡎⢎⠜⢳⢿⢨⣢⡘⣦⣽⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣾⣿⣿⣽⣿⣾⣿⡍⡧⡣⣿⢸⡇⢤⠙⣮⠣⡁⣿⣝⡎⣷⢘⡷⣯⣻⡓⡈⢟⡼⡱⣿⢨⣿⡘⣦⠿⣿⣿⣿⣿⣿⣿⣿⡿⣿
⣳⣝⡷⣻⡽⣫⣺⣗⡯⢞⣹⡦⢳⡴⣻⡪⣗⡽⣳⣝⠗⢿⢘⣇⡫⠔⡡⢠⡑⣝⢷⡭⠀⡱⣻⢮⣫⢧⠘⢧⠫⡖⡄⠻⣮⡷⣯⢿⣿⣟⣿⣿⣿⣽⣿⣟⣿⣿⣿⣿⣿⣿⡿⣿⣿⢿⣿⣷⣿⣿⡟⡥⣓⠕⣿⢐⣿⠰⣹⡇⡇⢸⡿⣮⢐⣿⡁⣿⢿⡕⡭⡌⢺⡪⣓⣿⠢⣿⡇⢺⡽⣚⣿⣿⣽⣷⣿⣿⣿⣿
⢵⣯⢛⣵⢾⣻⢕⢥⡾⣾⡝⢜⡷⣝⡮⣻⠜⣋⣮⣦⠿⢚⡩⣡⣺⡖⢔⢎⡾⣹⡳⠸⡀⠸⣯⢷⡸⣇⢙⢦⡙⢾⡘⣧⡸⣟⣿⣟⣿⣿⣹⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⢝⣾⣿⢕⠩⣿⢀⣿⢸⡻⣎⢢⣟⢿⡖⠠⡿⣧⢸⣟⢮⡃⣿⣐⢯⣪⣿⡑⢾⣻⡐⣟⢷⡜⢿⣿⣿⣿⡿⣿⣿
⡗⣱⣟⣯⢏⡵⢭⣾⣻⣾⠁⣟⢾⣪⢟⣼⣟⡿⡓⠡⣒⣵⡿⣽⢏⢜⡮⣳⢝⡮⠃⡽⠀⡪⣷⡳⢵⡇⢸⡕⣽⠷⣦⠨⣧⠭⣷⣿⡾⣿⣿⣿⣿⣾⣿⣿⣿⢿⣿⣿⣿⣾⣾⣿⣿⣿⣿⣻⣾⣿⣿⣿⡙⠌⡗⢤⣿⢸⣿⣕⣯⣾⣿⢁⠂⢿⣻⡄⣿⢴⢣⣿⣿⡜⣾⢷⡝⢺⣟⣧⠸⣿⣞⣕⢻⣿⣿⣿⣿⣿
⢧⡨⢛⠝⠰⣯⠸⣷⣻⡇⢸⣫⢳⢵⣿⣳⠟⡡⢊⡞⢿⣽⢟⢥⣞⢵⡫⣞⠕⡡⢜⠎⣸⠰⣿⡵⣿⠁⣪⠎⣾⣛⢾⡄⢿⡧⡜⢿⣿⡝⣿⣿⣟⣿⣿⣷⣿⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⢻⢟⣋⡊⡝⣸⡿⣸⡷⣿⣸⣯⠗⡨⡃⢸⣿⡇⣻⣮⠸⣿⣿⡇⣿⣻⣎⢹⣯⢿⡆⢽⣿⣞⣧⡻⣿⣿⣻⣿
⣻⣟⣿⣻⣮⣙⡦⢍⡘⢧⠘⢧⣻⡷⢋⣭⡕⣹⣯⣇⠸⣯⣞⢗⡷⣹⢮⠳⡜⡕⡝⣰⡏⢼⣷⣟⡯⠠⡧⢹⣯⣻⣵⢇⣌⠻⡼⣎⡛⢿⣮⡻⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣟⣿⣿⣿⣿⠛⣋⢊⡾⡽⡆⡱⣸⡯⢺⡿⣇⢿⡾⠡⡣⡑⢘⣷⣗⢹⣯⢧⡹⣿⡗⣿⣵⢧⢹⣷⡻⣿⡠⣻⣿⣿⢯⠺⣿⣿⣿
⣽⡾⣽⣽⢯⣟⡿⣻⢏⣮⢛⣶⡷⣴⢿⡛⢵⢿⡝⣧⠘⣿⢮⢛⣩⣛⠕⡭⣪⠊⣰⢿⢬⡿⣮⢿⠠⡞⢰⣿⣳⣟⡾⢰⡿⣎⠦⡧⢝⢶⣩⣃⢛⠿⠿⢯⣿⣿⢿⣿⣿⡿⣿⣿⣿⢿⣺⢟⣾⣫⢗⣽⠻⡀⠳⢸⣿⠸⣿⡅⡿⣟⠨⡃⢜⠀⣿⣧⢹⣿⢖⢕⢿⡯⣺⣯⡗⢹⣞⢝⣯⣷⠨⣿⣿⣿⡑⢿⣿⣿
⣞⣿⣻⢾⢿⡝⢨⣗⢡⡷⣸⡯⡷⢹⣏⢫⡹⣣⣽⢇⢪⣧⣾⣿⡋⡕⢎⠎⣠⡼⠯⢋⣴⢿⢮⣣⢟⢆⣟⢷⣻⡵⢃⣿⣻⢾⣅⢏⢞⢵⢜⢵⢍⡞⣚⠶⣢⢕⡍⢧⠬⣩⢝⣏⣵⣾⣯⣟⣮⡷⠗⢃⠨⠰⠘⠾⢎⡇⢿⡸⠜⡷⢈⠇⡪⢀⣿⡞⢽⣿⢸⡡⡫⡗⣽⡷⣏⠸⣇⢧⢻⡾⣆⢚⣿⣯⡇⣻⣿⣿
⢉⣎⠷⠝⠕⡙⠸⢆⢌⡷⣯⢞⡕⣽⢯⣸⣷⢟⣮⣽⢾⣟⡷⣑⠋⣉⣠⣲⡭⠀⢢⣿⣝⣵⡯⡯⣫⣽⣽⣫⣾⠡⣽⡳⣿⣹⡮⢆⢫⡳⡱⡳⣕⡇⢸⡕⣗⢵⡹⡢⣳⠑⠇⣈⠉⡚⢉⢉⠄⢔⢐⠅⡑⣜⡜⣆⢢⡌⡌⡺⡡⠺⡄⢃⠆⠠⡿⡋⣼⡷⠐⡥⡫⢌⣿⣽⢧⠐⡗⡵⣙⣯⣿⡀⢻⣿⠇⣽⣿⣿
⣫⠇⡑⡡⣸⣞⣿⢾⢢⡟⡞⢥⡟⣼⢱⣟⡾⣻⣮⣿⣻⡏⠼⠿⠿⢟⡛⣭⡖⣱⢿⢮⣟⡾⡩⢞⡶⣻⣮⢿⢁⡾⣿⣝⡾⣽⢁⡾⠈⡓⡙⢚⠞⣔⠞⠮⢎⢐⣉⣤⢶⡾⣥⢄⠸⠄⢣⠐⣄⣅⢮⣼⢣⣿⡣⢹⣶⣬⡲⢌⢣⠊⠸⡣⢊⠐⣯⡀⣿⢏⢨⢢⡫⢰⡿⣞⢷⠀⢺⢪⠆⣻⣞⣿⡈⢿⣣⣿⣿⣿
⠀⣱⠈⣼⣯⡿⣽⠇⣺⣅⣣⣟⢷⢶⡟⣷⡽⣿⢾⣯⣟⢸⣿⣷⣿⣷⢿⣫⡶⣟⣽⢫⢎⢞⡸⣎⡯⣿⠎⣵⠫⣜⣷⢯⡟⡡⠎⣠⡶⣾⣾⣿⣷⠮⡔⢲⣺⢿⡿⣽⣗⣿⢿⣯⢓⢱⣷⣿⣷⣾⣿⡿⣼⣿⡱⠹⣿⣿⣿⣷⣾⣬⣅⡛⠦⡙⠦⣫⣞⢕⢸⢢⢑⡿⣽⡯⣷⠀⣣⢫⡣⡸⣷⢯⣟⢌⢿⣿⣿⣿
⡘⣼⡅⣿⣟⣾⡟⣠⣿⢽⡯⣾⠏⣵⣿⣽⣻⣟⡿⡷⣹⣿⡿⢾⣣⡷⣿⢱⠟⢝⠪⣡⡶⣿⢹⡮⡳⣣⣾⠯⡱⣽⡽⡋⣜⢕⣾⣿⠟⣾⣿⣿⡟⣜⢸⣲⣯⣟⣿⣽⣯⡛⣭⣣⣿⣦⡻⡛⣿⣿⣿⢧⣿⣿⢸⢃⣿⢿⡿⣿⣿⣿⣿⣿⣿⣿⣷⣯⣵⣅⣛⠥⣫⡼⣷⣻⣮⠀⣽⡔⣝⠔⣿⣝⡿⣦⢙⣿⣿⣿
⢘⣞⢷⣝⢿⣾⢡⡿⣷⣻⣽⣻⡼⣿⢾⡷⣿⣻⡿⣱⣿⡟⠵⣫⣭⣮⠖⠠⡑⠄⣡⣿⣽⣫⡗⢃⣼⠛⡜⣎⡺⡺⢃⡞⣴⣿⢟⢣⣿⣿⣿⢟⠼⢢⣻⣿⣿⣿⣿⣿⣿⣿⢔⣿⠷⣯⣏⣾⣾⣿⣿⢸⣿⡗⡯⢴⢽⣮⢿⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣶⣾⣙⠻⢞⣽⣗⠀⣽⣷⢱⡃⢺⣯⣟⢾⡆⣻⣿⣿
⠪⡪⠷⠽⠶⣝⠇⢿⣻⣗⣿⣞⣿⣽⣿⣻⣿⡽⣃⣿⠋⢔⣮⣾⡿⠃⢠⠙⡌⣼⣟⢷⢳⡎⠰⡱⢃⢝⢬⣟⢼⢣⢏⣾⢟⢱⣵⣿⣿⡿⡩⡺⢁⣿⣿⣿⣿⣿⣿⣿⢿⣿⣕⣵⣷⣭⣣⣿⣿⣿⡏⣾⣿⣹⠇⣿⡚⣿⡞⣿⣿⣿⣿⣿⣻⣿⣿⣿⣿⣿⣿⣿⣿⣧⡪⠱⣯⠀⣟⣿⣧⢫⢸⣿⢞⡿⣇⢪⣿⣿
⢛⣚⣷⣻⣵⡱⣫⠘⣻⣞⡷⣻⢞⣷⣻⣯⠚⣬⡾⢡⢊⣾⡿⢋⠔⡢⢑⣱⣾⡻⣞⠷⠋⣰⢁⢂⢗⡱⢰⣯⠟⢌⢣⣔⣾⣿⣿⣿⡟⡰⡑⢅⣿⣿⣿⣿⣿⣯⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⡇⣿⢏⣾⠁⢼⡇⣿⣿⣹⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⣿⣿⣗⢧⡸⢰⡇⣿⣿⣧⡸⣯⣯⣻⡏⡮⣿⣿
⢿⢝⡯⣷⢻⢿⠔⡡⡀⢿⡽⣯⢿⡵⣿⢾⡄⣻⣇⠥⢼⣵⣴⣤⣷⣾⢿⢝⣭⡩⢠⢒⢝⢔⡁⢔⢕⢵⢈⢏⡆⣳⣿⣿⣿⠿⡾⡟⡰⡑⢡⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣯⡟⢢⡟⣰⠸⣗⢼⣿⡎⣿⣿⣿⣯⣿⣷⣿⣿⡿⣿⣷⣿⣿⢿⣿⡎⣇⢸⣷⢹⣿⣿⢸⣗⢷⣽⡊⣯⣿⣿
⢒⠎⣃⣑⣁⣂⠑⠌⣂⣙⣙⣓⣋⣛⠛⣙⣂⡹⢀⠏⣒⣉⠮⣙⣛⣙⣃⣛⠯⣿⣦⠑⣕⢕⠆⢈⣊⣐⣑⡈⣲⢟⣋⣛⢳⣉⣊⣘⡈⣊⣙⣛⣛⣛⣙⣛⢚⣙⣋⣓⣛⣛⡋⣿⣿⣿⡟⣙⣋⣛⣙⣃⢸⠃⣛⣈⠳⡪⡿⢃⣛⣋⣛⠿⣿⡿⢛⣙⣛⣙⠿⣿⣿⣿⣿⣇⠗⣘⣛⣀⣛⠷⣹⢋⣓⣙⣁⣛⣚⢻
⡅⣾⣿⡛⠻⠿⠷⡀⣿⣿⠟⠛⠛⢛⡄⢿⣿⣷⣄⠑⣿⣿⠠⣻⣿⡟⠻⢿⣷⡜⣿⣿⣤⠃⣼⣿⡿⠛⢿⣿⠜⢼⣿⣿⢸⡏⣿⣿⡇⣛⣛⢻⣿⡟⣛⣛⢸⣿⣿⠛⠛⠛⣃⣿⣿⣿⡇⣿⣿⠛⡻⣿⣷⠀⣿⣿⠅⣃⣾⣿⢟⡻⢿⡷⠙⣴⣿⡟⠙⠿⠷⢸⣿⣿⣿⢢⣾⣿⢟⡻⣿⣷⡙⢜⣿⣿⠛⣛⢛⣸
⣤⡙⠿⢿⣿⣷⣎⠃⣿⣿⡿⠿⠿⠇⡁⢿⣿⠻⣿⣮⣿⡿⠠⣽⣿⡇⣯⢸⣿⡇⣽⣿⣿⡇⣿⣿⠰⡑⠔⠶⢿⢺⣿⣿⠸⣁⣿⣿⡇⣿⣿⢸⣿⡇⣿⣿⢳⣿⣿⠿⠿⠿⢪⣿⣿⣿⡇⣿⣿⣶⣾⡿⠟⡄⣿⣿⡃⢸⣿⣯⢸⣿⠶⠿⢿⢌⠻⢿⣿⣷⣮⢻⣿⣿⣯⢸⣿⡇⣿⡿⢸⣿⡇⢸⣿⣿⢷⡾⡆⣿
⡇⢾⣿⣔⣢⣿⡿⠀⣿⣿⣦⣤⣥⣥⠁⣿⣿⢅⡙⣿⣿⣟⠐⢾⣿⣧⣤⣾⣿⢣⣿⣾⣽⣧⠻⣿⣦⣬⣾⣿⢃⠎⢿⣿⣤⣥⣿⡿⢡⡈⣄⢸⣿⡏⣿⣿⡳⣿⣿⣬⣭⣭⡍⣿⣿⣿⡇⣿⣿⢠⣶⠀⣾⡇⣿⣿⢆⣌⢿⣿⣬⣥⣾⡿⢂⢻⣿⣆⣢⣿⣿⢱⣿⣿⣿⡘⢿⣷⣬⣥⣿⡿⢣⡱⣿⣿⢀⣾⡖⣿
⢛⣢⡭⣩⢋⡍⢖⢧⠉⡉⣍⢭⢍⡭⡤⣩⡩⡴⣏⢌⡉⢭⣜⣭⣍⢩⣭⣭⣶⣷⣭⣻⣿⣿⣷⣭⣽⣭⣭⡁⠢⢈⢤⢍⣙⢍⢭⢔⠵⡱⣌⢬⠍⡭⣿⣿⣭⣭⣭⣭⣭⣭⣥⣿⣿⣿⣧⣭⣭⣴⡿⠀⡿⢅⠉⠭⣴⣿⣷⣬⣽⣭⣽⣶⢣⣶⣭⣭⣫⣭⣴⣿⣿⣿⣿⠃⡴⣭⣽⣭⣩⣶⣿⣬⣭⡍⣔⣿⢇⣿
⢏⠎⡢⡱⢔⢎⡾⢮⡖⢐⢜⠦⡳⢜⡪⣆⢳⡱⡱⢆⢜⠰⣮⣟⡿⢸⣝⣛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⡀⢮⢢⡑⡬⣣⣛⢜⡕⡳⡜⣬⢃⢗⢸⣿⣿⣿⣿⣿⣿⡿⣿⣿⣿⣿⣿⣿⠟⢋⢙⡄⡳⣀⡁⡲⣄⢭⢐⣉⠻⣿⢿⣧⣾⣿⣿⣿⣿⣿⣿⣿⣿⣿⡏⡰⡨⣿⣿⠗⣼⣟⣾⣻⡞⢦⣹⣿⢸⣿
⠕⡸⡴⣻⢝⢋⢋⠕⡙⣀⣌⡑⣝⢊⣐⣁⠳⣈⣈⣊⣠⣃⣙⢻⣗⡐⣿⣿⠿⢛⣉⣍⣙⡻⢿⣋⣋⣋⣋⣛⣛⠢⡃⣉⣈⣑⣉⣑⣈⢳⢈⣂⣅⣙⣀⡻⢿⡟⣉⣋⠛⣘⣛⣙⣋⣋⣙⡁⠂⡔⢡⠃⠸⣀⣭⣨⣐⡑⠕⠭⡲⣁⣄⣘⠿⠟⠟⣙⣙⣙⣋⣛⡛⠻⢁⣌⣘⣋⣋⣊⠿⣮⣳⡟⡐⣮⣿⢇⣿⣿
⣸⣝⢾⡑⢔⠅⡕⢌⡂⢽⣿⡇⢈⠰⣿⣿⠨⣸⣿⡟⠛⢻⣿⡇⣿⢧⣜⠏⣼⣿⡟⣛⠿⠿⠎⣺⣿⣿⠛⢻⣿⣷⢸⢽⣿⡟⠛⠛⠛⡸⢼⣿⡟⡛⢿⣿⡆⡇⣿⣿⠀⡛⡛⢻⣿⡟⢛⣃⢜⢕⠱⢡⣾⣿⢟⡛⠿⠷⢘⡕⢰⣿⣿⣿⡆⢺⠂⣿⣿⡛⠛⣿⣿⠆⢸⣿⣿⠛⢿⣿⣦⢳⡟⡠⣹⣾⢏⣼⣿⣿
⢧⡻⣎⢆⢕⠌⢊⣤⡅⢾⣿⡇⢨⢐⣿⣿⢀⢺⣿⡿⢿⣿⡟⢁⢿⣝⣿⡆⣿⣿⢈⠫⣓⡻⠿⢺⣿⣿⢿⣿⣟⢣⡾⣹⣿⡿⠿⠿⠟⢼⢸⣿⡇⢌⢸⣿⡧⠐⣿⣿⠀⢎⠀⣹⣿⡇⡣⡕⡕⢭⡊⢸⣿⣯⢈⢟⢒⡛⠧⢃⣾⣿⡀⣿⣿⡰⡇⣿⣿⠿⣿⣿⡋⣼⢸⣿⣿⢸⢅⣿⣿⠘⠄⣾⣿⢋⣼⣿⣿⣿
⡳⣝⢾⠆⣢⣼⣿⣿⣿⡸⣿⣷⣦⣾⣿⠏⡄⣹⣿⡇⢌⢿⣿⣎⠢⣯⢺⠃⠹⣿⣷⣵⣾⡿⢃⢾⣿⣿⢠⠻⣿⣧⡙⣽⣿⣷⣵⣾⣶⢩⢺⣿⣷⣶⣾⡿⢃⢈⣿⣿⠈⠮⡅⢸⣿⡇⢎⠎⡪⠡⡊⢄⢻⣿⣦⣷⣿⡿⠁⣾⣿⠟⠻⠻⣿⣧⠁⣿⣿⡱⡜⣿⣿⡜⢸⣿⣷⣶⣾⣿⠏⣈⢾⡟⣡⣿⣿⣿⣿⣿
⣝⢷⡙⣼⣿⢿⣿⣽⣿⢷⣶⡍⢉⢍⠤⡪⡒⡌⡍⣡⢎⠦⡩⡩⡰⣄⢑⡑⡣⡈⢍⢉⠡⠒⡳⣄⠥⠥⠾⠷⠭⣭⣤⣬⣭⣬⣥⣭⣬⣴⣬⣉⢉⠅⠡⠠⡈⢀⣉⡉⡀⠣⠢⢌⢉⠡⡂⢕⠨⡢⢑⠌⠔⣮⣍⠩⢤⠲⡅⢉⠌⡜⠿⢓⠍⠩⠴⣭⣭⣼⣿⣬⣥⣥⣬⡭⢥⢩⢤⣦⢜⠣⣵⣾⣿⣿⣿⣿⣿⣿
⢞⢵⡃⣿⡽⢫⣥⣵⣥⣮⣰⣑⢠⡊⢎⢎⢜⠜⡔⢕⢕⠕⡕⡜⡢⢎⡄⢫⠰⡈⢢⠁⢎⠨⡂⢵⠀⢘⢖⢔⡄⠈⠛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣦⡝⡊⢖⢥⠄⡱⠠⡈⢕⠑⠔⡡⢑⢌⠢⡑⡬⡪⣣⡑⠘⢷⢽⣌⠣⡈⠢⡰⡨⡪⡢⡹⡰⡡⡈⠻⣿⣿⣿⢯⡷⣽⣶⣿⣿⣿⣷⡹⡝⣿⣿⣿⣿⣿⣿⣿⣿
*/

#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define pint pair<int, int>
#define gay MikeKalyzhnyy
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

#ifndef LOCAL
#pragma GCC optimize("unroll-loops,O3")
//#pragma GCC target("avx2")
#endif

inline void solve() {
    int task, g;
    cin >> task >> g;

    int n;
    cin >> n;
    vector<pint> v(n);
    for (auto& [a, b] : v) cin >> a >> b;
    if (task == 1) {
        if (g == 1) {
            vector<int> perm(n);
            if (n & 1) perm[n / 2] = n / 2 + 1;
            for (int i = 0; i < n / 2; ++i) {
                perm[2 * i] = i + 1;
                perm[2 * i + 1] = n - i;
            }
            for (auto &el: perm) cout << el << ' ';
            cout << endl;
            return;
        }
        vector<char> used(n, 0);
        int u = 0;
        auto sqr = [&](int x) {
            return (int64_t) x * x;
        };
        auto dist = [&](pint a, pint b) {
            return sqr(a.first - b.first) + sqr(a.second - b.second);
        };
        for (int i = 0; i < n; ++i) {
            cout << u + 1 << ' ';
            used[u] = 1;
            int best = u;
            for (int to = 0; to < n; ++to) {
                if (used[to]) continue;
                if (dist(v[u], v[to]) > dist(v[u], v[best])) best = to;
            }
            u = best;
        }
    }
    int c;
    cin >> c;
    if (task == 2) {
        vector<int> perm(n);
        iota(all(perm), 0);
        sort(all(perm), [&](int& a, int& b){return v[a] < v[b];});
        sort(1 + all(perm), [&](int& a, int& b){
           pint v1 = {v[a].first - v[perm[0]].first, v[a].second - v[perm[0]].second};
           pint v2 = {v[b].first - v[perm[0]].first, v[b].second - v[perm[0]].second};
           return v1.first * v2.second - v2.first * v1.second >= 0;
        });
        for (auto& el : perm) cout << el + 1 << ' ';
    }
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}
