#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define eb emplace_back
#define vec vector
#define read(x) for(auto &zu: (x))cin >> zu;
#define all(x) (x).begin(), (x).end()

using vi = vector<int>;
using str = string;
using ll = long long;
using pii = pair<int, int>;

template<typename A>
void print(A &a, str sep=" "){
    for(auto &i: a)cout << i << sep;
    cout << "\n";
}

struct Pnt{
    int x, y;
    Pnt(){}
    Pnt(int x, int y): x(x), y(y){}
};

int operator*(Pnt a, Pnt b){
    return a.x * b.x + a.y * b.y;
}

void solve(){
    int T, g; cin >> T >> g;
    int n; cin >> n;
    vec<pii> pnt(n);
    for(auto &i: pnt)
        cin >> i.first >> i.second;

    if(T == 1){
        vec<array<int, 3>> pn(n);
        for(int i = 0; i < n; ++i)
            pn[i] = {pnt[i].first, pnt[i].second, i};
        sort(all(pn));
        int l = 0, r = n - 1;
        bool lf = true;
        vi res;
        while(l != r){
            if(lf)res.pb(pn[l][2] + 1);
            else res.pb(pn[r][2] + 1);
            if(lf)l++;
            else r--;
            lf = !lf;
        }
        res.pb(pn[l][2] + 1);
        print(res);
        cout << endl;
    }
}


signed main() {
#ifdef LOCAL
    freopen("inp", "r", stdin);
#else
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#endif

    int TT = 1;
    //cin >> TT;
    while(TT--){
        solve();
    }
    return 0;
}
