#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define eb emplace_back
#define vec vector
#define read(x) for(auto &zu: (x))cin >> zu;
#define all(x) (x).begin(), (x).end()

using vi = vector<int>;
using str = string;
using ll = long long;
using pii = pair<int, int>;

template<typename A>
void print(A &a, str sep=" "){
    for(auto &i: a)cout << i << sep;
    cout << "\n";
}

struct Pnt{
    int x, y;
    int ind;
    Pnt(){}
    Pnt(int x, int y): x(x), y(y){}
    bool operator<(Pnt &s) const{
        if(s.x != x)return x < s.x;
        if(s.y != y)return y < s.y;
        return ind < s.ind;
    }
};

Pnt operator-(Pnt a, Pnt b){
    return {a.x - b.x, a.y - b.y};
}

int operator*(Pnt a, Pnt b){
    return a.x * b.x + a.y * b.y;
}

mt19937 rnd(3478293);

int calc(vi &p, vec<Pnt> &pn){
    int res = 0;
    for(int i = 1; i < p.size() - 1; ++i){
        Pnt s = pn[p[i - 1]] - pn[p[i]];
        Pnt f = pn[p[i + 2]] - pn[p[i]];
        if(f * s > 0)res++;
    }
    return res;
}

void solve(){
    int T, g; cin >> T >> g;
    int n; cin >> n;
    vec<Pnt> pnt(n);
    for(int i = 0; i < n; ++i){
        cin >> pnt[i].x >> pnt[i].y;
        pnt[i].ind = i;
    }

    if(T == 1){
        vec<Pnt> st = pnt;
        sort(all(pnt));
        int l = 0, r = n - 1;
        bool lf = true;
        vi res;
        while(l != r){
            if(lf)res.pb(pnt[l].ind);
            else res.pb(pnt[r].ind);
            if(lf)l++;
            else r--;
            lf = !lf;
        }
        res.pb(pnt[l].ind);
        vi nw = res;
        int best = calc(res, st);
        
        for(int tt = 0; tt < 1000000; ++tt){
            shuffle(all(nw), rnd);
            int cur = calc(nw, st);
            if(cur > best){
                res = nw;
                best = cur;
            }
        }
        for(auto &i: res)i++;
        print(res);
        cout << endl;
    }
}


signed main() {
#ifdef LOCAL
    freopen("inp", "r", stdin);
#else
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#endif

    int TT = 1;
    //cin >> TT;
    while(TT--){
        solve();
    }
    return 0;
}
