#include <bits/stdc++.h>

#include <random>

#define int long long
using namespace std;

struct point {
    int x, y;

    int operator*(point o) {
        return x * o.x - y * o.y;
    }

    point operator-(point o) {
        return {x - o.x, y - o.y};
    }
};

bool cmp(point a, point b) {
    if (a.x != b.x)return a.x < b.x;
    return a.y < b.y;
}

void solve() {
    int task, group, n;
    cin >> task >> group >> n;
    vector<pair<point, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.x >> a[i].first.y;
        a[i].second = i;
    }
    if (n <= 10) {
        vector<int> ans(n);
        int mx = 0;
        int o = 1 * 2 * 3 * 4 * 5 * 6 * 7 * 8;
        for (int i = 0; i < o; ++i) {
            int cn = 0;
            for (int j = 1; j < n - 1; ++j) {
                point a1 = a[j - 1].first - a[j].first;
                point a2 = a[j + 1].first - a[j].first;
                if (a1 * a2 > 0)cn++;
            }
            if (cn > mx) {
                mx = cn;
                for (int j = 0; j < n; ++j) {
                    ans[j] = a[j].second;
                }
                if (mx == n - 2)break;
            }
            std::shuffle(a.begin(), a.end(), std::mt19937(std::random_device()()));
        }
        for (int i = 0; i < n; ++i) {
            cout << ans[i] + 1 << " ";
        }
        cout << endl;
        return;
    }
    if (task == 1) {
        int l = 1, r = n;
        int i = 0;
        while (l <= r) {
            if (i) {
                cout << l++ << " ";
            } else {
                cout << r-- << " ";
            }
            i ^= 1;
        }
        cout << endl;
    }

}

signed main() {
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}