#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define debug(x) std::cerr << #x << ": " << x << '\n'

using namespace std;
typedef long long i64;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int task, group;
    cin >> task >> group;

    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    vector<int> ord(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].fi >> a[i].se;
        ord[i] = i;
    }

    sort(ord.begin(), ord.end(), [&] (int i, int j) {
        return a[i].fi < a[j].fi;
    });

    if (task == 1) {
        int l = 0, r = 0;
        while (l < n) {
            r = l;
            while (r + 1 < n && a[ord[r + 1]].se > a[ord[r]].se) ++r;
            for (int j = l; j <= (l + r) / 2; ++j) {
                cout << ord[j] + 1 << ' ';
                if (j < r - (j - l)) {
                    cout << ord[r - (j - l)] + 1 << ' ';
                }
            }
            l = r + 1;
        }
        cout << endl;
    }
}
