#pragma gcc optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
// #define int ll
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll mod = 998244353;
const ll inf = 1e18;
const int mxn = 1e9 + 7;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << a << endl;
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;

int task, group;

struct pt {
    ll x, y;
};

bool sharp (pt a, pt b, pt c) {
    pt v1 = {b.x - a.x, b.y - a.y}, v2 = {b.x - c.x, b.y - c.y};
    return v1.x * v2.x + v1.y * v2.y > 0;
}

bool cmpx (pt a, pt b) {
    return a.x < b.x;
}

void slv1() {
    int n; cin >> n;
    vector <pt> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }
    if (group == 1) {
        vector <int> ans;
        for (int i = 0; i < (n + 1) / 2; ++i) {
            ans.pb(i + 1);
            if (n - i - 1 != i) ans.pb(n - i);
        }
        vout(ans);
        return;
    }
    sort(all(a), cmpx);
    vector <int> ans {0, 1};
    for (int i = 2; i < n; ++i) {
        if (sharp(a[ans[ans.size() - 2]], a[ans[ans.size() - 1]], a[i])) {
            ans.push_back(i);
        }
        else if (sharp(a[ans[1]], a[ans[0]], a[i])) {
            reverse(all(ans)); ans.push_back(i);
        }
        else {
            exit(1);
        }
    }
    for (auto &i : ans) ++i;
    vout(ans);
}

void slv2() {

}

void slv3() {

}

void slv4() {

}

void solve() {
    cin >> task >> group;
    if (task == 1) slv1();
    else if (task == 2) slv2();
    else if (task == 3) slv3();
    else slv4();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> tt;
    while (tt--) solve();
}