﻿#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <random>

using namespace std;
typedef long long ll;

mt19937 rng(1315);

const int maxn = 8e4;

struct pt {
	ll x, y;
	pt(ll x_, ll y_) : x(x_), y(y_) {}
	pt() {}
	ll operator%(pt  oth) {
		return x * oth.y - y * oth.x;
	}
	ll operator*(pt oth) {
		return x * oth.x + y * oth.y;
	}
	pt operator-(pt oth) {
		return pt(x - oth.x, y - oth.y);
	}
};

vector<pt> a(maxn);

bool ch(pt a, pt b, pt c) {
	return (a - b) * (c - b) > 0;
}

int f(vector<int>& pr) {
	int ans = 0;
	for (int i = 0; i < pr.size() - 2; ++i) {
		ans += ch(a[pr[i]], a[pr[i + 1]], a[pr[i + 2]]);
	}
	return ans;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int t, g, n, c;
	cin >> t >> g >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
	}
	if (t == 1) {
		if (n <= 10) {
			vector<int> r(n);
			for (int i = 0; i < n; ++i) {
				r[i] = i;
			}
			vector<int> ib = r;
			int rs = f(ib);
			while (next_permutation(r.begin(), r.end())) {
				int u = f(r);
				if (u > rs) {
					rs = u;
					ib = r;
				}
			}
			for (int i = 0; i < n; ++i) {
				cout << ib[i] + 1 << ' ';
			}
			cout << endl;
		}
		else {
			for (int i = 0; i < n; ++i) {
				if (i % 2 == 0) {
					cout << i / 2 + 1 << ' ';
				}
				else {
					cout << n - i / 2 << ' ';
				}
			}
			cout << endl;
		}
	}
	else {
		cin >> c;
		if (t == 2) {
			for (int i = 1; i <= n; ++i) {
				cout << i << ' ';
			}
			cout << endl;
		}
		else if (t == 3) {

		}
		else {

		}
	}


	return 0;
}
