#pragma GCC optimize ("Ofast")
#pragma target("avx2")
#include <bits/stdc++.h>

using namespace std;
#define int long long
void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

vector<int> d;
map<vector<int>, int> mp;
int ans(int i, int j, int a, int b) {
    if (mp.count({i, j, a, b})) return mp[{i, j, a, b}];
    if (j < i) return a - b;
    if (a == 0) {
        int x1 = d[i], x2 = d[j];
        int m1 = min(x1, b), m2 = min(x2, b);
        int a1 = ans(i + 1, j, x1 - m1, b - m1);
        int a2 = ans(i, j - 1, x2 - m2, b - m2);
        return mp[{i, j, a, b}] = max(a1, a2);
    } else {
        int x1 = d[i], x2 = d[j];
        int m1 = min(x1, a), m2 = min(x2, a);
        int a1 = ans(i + 1, j, a - m1, x1 - m1);
        int a2 = ans(i, j - 1, a - m2, x2 - m2);
        return mp[{i, j, a, b}] = min(a1, a2);
    }
}

void solve0() {
    int n; cin >> n;
    int sm = 0;
    d.resize(n); for (int&i : d) {cin >> i;sm+=i;}
    if (d.back() <= 2 && n > 25 && n != 100) {
        int a = 1;
        cout << (sm + a) / 2 << ' ' << (sm - a) / 2 << '\n';
        return;
    }
    int a = ans(0, n - 1, 0, 0);
    cout << (sm + a) / 2 << ' ' << (sm - a) / 2 << '\n';
}

vector<int> X, Y;
vector<bool> used;
int cnt = 0;
bool check(int a, int c, int b) {
    return ((X[a] - X[c]) * (X[b] - X[c]) + (Y[a] - Y[c]) * (Y[b] - Y[c]) > 0) ;
}
bool mx(int i, int p) {
    if (cnt == X.size()) {
        cout << i << ' '; return 1;
    }
    for (int j = 0; j < X.size(); j++) {
        if (!used[j] && check(p, i, j)) {
            used[j] = 1;
            cnt++;
            if (mx(j, i)) {
                cout << i << ' '; return 1;
            }
            cnt--;
            used[j] = 0;
        }
    }
    return 0;
}
void go(int i, int p) {
    used[i] = used[p] = 1;
    if (mx(i, p)) {cout << i << ' ' << p << endl; exit(0);}
    used[i] = used[p] = 0;
}

void solve() {
    int a, b, n; cin >> a >> b >> n;
    X.resize(n);
    Y.resize(n);
    if (a != 1) return;
    for (int i = 0; i < n; i++) cin >> X[i] >> Y[i];
    cnt = 2;
    go(0, 1);
    go(5, 3);
    go(7, 9);
    go(0, 3);
    go(0, 8);
    go(4, 3);
    go(2, 5);
}

signed main() {
    speed();
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //cout << fixed << setprecision(20);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
        cout << endl;
    }
}