#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

//#pragma ("OFast")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct Point{
    ll x, y;
    Point(){};
    Point(ll x, ll y): x(x), y(y){};
};

struct Vector{
    ll x, y;
    Vector(){};
    Vector(ll x, ll y): x(x), y(y){};
    Vector(Point a, Point b){
        x = b.x - a.x;
        y = b.y - a.y;
    };
};

int mx = -1;
vector<vector<int>> mxp;
vector<Point> vec;

ll scal(Vector ab, Vector bc){
    return ab.x * bc.x + ab.y * bc.y;
}

ll vect(Vector ab, Vector bc){
    return ab.x * bc.y - ab.y * bc.x;
}

void getmx(int nw, int pr, int cnt, int s, int n, vector<bool>&used, vector<int> &p){
    if (cnt == n){
        if (s > mx){
            mx = s;
            mxp = {p};
        }
        //else if (s == mx){
        //    mxp.push_back(p);
        //}
        return;
    }
    for (int i = 0; i < n; i++){
        if (!used[i]){
            used[i] = true;
            int c = 0;
            if (nw != -1 and pr != -1){
                c = (scal(Vector(vec[nw], vec[pr]), Vector(vec[nw], vec[i])) > 0);
            }
            p.push_back(i);
            getmx(i, nw, cnt + 1, s + c, n, used, p);
            p.pop_back();
            used[i] = false;
        }
    }
}

void solve(){
    int task, group;
    cin >> task >> group;
    int n; cin >> n;
    vec.resize(n);
    Point pr(-1e9, -1e9);
    bool fl = true;
    for (int i = 0; i < n; i++){
        cin >> vec[i].x >> vec[i].y;
        if (pr.x > vec[i].x or pr.y > vec[i].y){
            fl = false;
        }
        pr = vec[i];
    }
    if (fl){
        for (int i = 1; i <= n / 2; i++){
            cout << i << " " << n - i + 1 << " ";
        }
        if (n % 2 == 1){
            cout << (n + 1) / 2;
        }
        cout << endl;
        return;
    }
    vector<bool> used(n, false);
    vector<int> p;
    getmx(-1, -1, 0, 0, n, used, p);
    //cout << mx << endl;
    //cout << scal(Vector(-2, 0), Vector(0, 3)) << endl;
    for (const auto& a : mxp){
        for (auto el : a){
            cout << el + 1 << " ";
        }
        cout << endl;
    }
    cout << endl;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--){
        solve();
    }
}
