#include <bits/stdc++.h>
#include <experimental/random>
using namespace std;
using ll = long long;
using ld = long double;
void solve();

int main() {
    ll q = 1;
    while (q--) {
        solve();
    }
}
struct p {
    ll x, y, ind;
};
bool comp1(p a, p b) {
    return a.y < b.y;
}
bool comp2(p a, p b) {
    return a.y > b.y;
}
struct vec {
    ll x, y;
    ll operator* (vec v) {
        return x * v.x + y * v.y;
    }
    ll operator% (vec v) {
        return x * v.y - y * v.x;
    }
};
ld angle(p a, p b, p c) {
    vec v1 = {b.x - a.x, b.y - a.y}, v2 = {b.x - c.x, b.y - c.y};
    return atan2(v1 * v2, v1 % v2);
}
void solve() {
    ll task, group;
    cin >> task >> group;
    ll n;
    cin >> n;
    vector<p> a1, a2, c;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        a1.push_back({x, y, i});
        a2.push_back({x, y, i});
        c.push_back({x, y, i});
    }
    vector<ll> used(n);
    sort(a1.begin(), a1.end(), comp1);
    sort(a2.begin(), a2.end(), comp2);
    vector<ll> ans, ans2;
    while (ans.size() != n) {
        while (!empty(a1) && used[a1.back().ind] == 1) {
            a1.pop_back();
        }
        ans.push_back(a1.back().ind);
        used[a1.back().ind] = 1;
        a1.pop_back();
        while (!empty(a2) && used[a2.back().ind] == 1) {
            a2.pop_back();
        }
        ans.push_back(a2.back().ind);
        used[a2.back().ind] = 1;
        a2.pop_back();
    }
    sort(a1.begin(), a1.end(), comp2);
    sort(a2.begin(), a2.end(), comp1);
    while (ans2.size() != n) {
        while (!empty(a1) && used[a1.back().ind] == 1) {
            a1.pop_back();
        }
        ans2.push_back(a1.back().ind);
        used[a1.back().ind] = 1;
        a1.pop_back();
        while (!empty(a2) && used[a2.back().ind] == 1) {
            a2.pop_back();
        }
        ans2.push_back(a2.back().ind);
        used[a2.back().ind] = 1;
        a2.pop_back();
    }
    ll cnt1 = 0, cnt2 = 0;
    for (int i = 1; i < n - 1; i++) {
        ld k = angle(c[ans[i - 1]], c[ans[i]], c[ans[i + 1]]);
        if (k >= 0 && k <= M_PI) {
            cnt1++;
        }
    }
    for (int i = 1; i < n - 1; i++) {
        ld k = angle(c[ans2[i - 1]], c[ans2[i]], c[ans2[i + 1]]);
        if (k >= 0 && k <= M_PI) {
            cnt2++;
        }
    }
    if (cnt1 > cnt2) {
        for (auto i : ans) {
            cout << i << ' ';
        }
    } else {
        for (auto i : ans2) {
            cout << i << ' ';
        }
    }
}
