#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<array<int, 3>> xy(n);
    for (int i = 0; i < n; ++i) {
        cin >> xy[i][0] >> xy[i][1];
        xy[i][2] = i;
    }
    sort(xy.begin(), xy.end(), [&](const array<int, 3> &a, const array<int, 3> &b){
        return a[0] < b[0] || (a[0] == b[0] && a[1] < b[1]);
    });
    for (int i = 0; i <= n - i - 1; ++i) {
        cout << xy[i][2] + 1 << " ";
        if (i != n - i - 1) {
            cout << xy[n - i - 1][2] + 1 << " ";
        }
    }
}
