#include <iostream>
#include <random>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

#define RANGE(i, n) for (int i = 0; i < n; i++)
#define LOOP(n) RANGE(_, n)
#define LOOP2(n) RANGE2(_, n)
#define elif else if

#ifdef LOCAL
#define ENDLINE endl
#define FLUSH flush
#define DEBUG(x) cerr << #x << ": " << x << endl;
#else
#define ENDLINE '\n'
#define FLUSH ""
#define DEBUG(x) ;
#endif

using ll = long long;
using uint = unsigned int;
using ull = unsigned long long;
using pii = pair<int, int>;
using pss = pair<short, short>;

template<typename T, typename V>
istream &operator>>(istream &in, pair<T, V> &v) {
    in >> v.first >> v.second;
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &val: v) {
        in >> val;
    }
    return in;
}


template<typename T, typename V>
ostream &operator<<(ostream &out, pair<T, V> v) {
    out << v.first << " " << v.second;
    return out;
}


template<typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &val: v) {
        out << val << " ";
    }
    return out;
}

int n;
vector<pair<int, int>> points;

int main() {
    int task, group;
    cin >> task >> group;
    cin >> n;
    points.resize(n);
    cin >> points;
    int i = 1, j = n;
    bool k = false;
    while (j >= i) {
        if (k) {
            cout << j << " ";
            j--;
        } else {
            cout << i << " ";
            i++;
        }
        k = !k;
    }
    cout << endl;
}
