#include <bits/stdc++.h>

using namespace std;

vector<vector<pair<int, int>>> g;
vector<vector<int>> stic;
vector<vector<pair<int, int>>> stic_sort;
vector<int> edge;
vector<vector<int>> g1;

int dfs(int v, int pred) {
    vector<pair<int, int>> nado;
    for (auto [u, i] : g[v]) {
        if (u != pred) {
            int x = dfs(u, v);
            int w = edge[i];
            nado.push_back({w - x, i});
        }
    }
    if (nado.size() == 0) {
        return stic[v][0];
    }

    sort(nado.begin(), nado.end());
    int j = 0, prop;
    bool flag = false;
    vector<pair<int, int>> sr_reb;
    for (int i = 0; i < stic[v].size(); ++i) {
        if (stic_sort[v][i].first >= nado[j].first) {
            sr_reb.push_back({stic_sort[v][i].second, nado[j].second});
            j++;
        } else {
            if (flag || pred == -1) {
                cout << "No";
                exit(0);
            } else {
                flag = true;
                prop = stic_sort[v][i].first;
            }
        }
    }
    sort(sr_reb.begin(), sr_reb.end());
    for (int i = 1; i < sr_reb.size(); ++i) {
        g1[sr_reb[i].second].push_back(sr_reb[i-1].second);
    }
    return prop;
}

vector<int> ans, used;

void dfs1(int v) {
    used[v] = 1;
    for (auto u : g1[v]) {
        if (!used[u]) {
            dfs1(u);
        }
    }
    ans.push_back(v);
}

int main() {
    int n, group;
    cin >> n >> group;
    g.resize(n + 1);
    g1.resize(n);
    stic.resize(n + 1);
    stic_sort.resize(n + 1);
    edge.resize(n);
    for (int i = 1; i < n; ++i) {
        int v, u, w; cin >> v >> u >> w;
        g[v].push_back({u, i});
        g[u].push_back({v, i});
        edge[i] = w;
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            int x; cin >> x;
            stic[i].push_back(x);
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < stic[i].size(); ++j) {
            stic_sort[i].push_back({stic[i][j], j});
        }
    }
    for (int i = 1; i <= n; ++i) {
        sort(stic_sort[i].begin(), stic_sort[i].end());
    }
    dfs(1, -1);
    used.resize(n);
    for (int i = 1; i < n; ++i) {
        if (!used[i]) {
            dfs1(i);
        }
    }
    cout << "Yes" << '\n';
    reverse(ans.begin(), ans.end());
    for (auto el : ans) {
        cout << el << ' ';
    }
}
