#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

//#define int long long
const int N = 2e5;
vector<pair<int, int>> g[N];
vector<int> f[N];
multiset<int> h[N];
set<pair<int, int>> st, gt[N];
int g1[N];
vector<vector<int>> ans;
map<vector<int>, int> mp;
map<pair<int, int>, set<int>> mp1;
map<int, set<int>> r[N];
vector<pair<int, int>> order;
set<pair<int, int>> st1;

inline void rec(int v, int pos) {
    if (st1.find({v, pos}) != st1.end()) {
        exit(1);
    }
    st1.insert({v, pos});
    if ((int) f[v].size() > pos + 1) {
        rec(v, pos + 1);
    }
    if (!order.empty() && order.back().first == v && order.back().second == pos) {
        return;
    }
    int z = *mp1[{v, f[v][pos]}].begin();
    vector<int> p = ans[z];
    if (p[0] != v) {
        swap(p[0], p[1]);
        swap(p[3], p[4]);
    }
    mp1[{v, f[v][pos]}].erase(z);
    mp1[{p[1], p[4]}].erase(z);
    order.emplace_back(p[1], *r[p[1]][p[4]].begin());
    rec(p[1], *r[p[1]][p[4]].begin());
    r[p[1]][p[4]].erase(r[p[1]][p[4]].begin());
    r[v][f[v][pos]].erase(pos);
    cout << mp[{v, p[1], p[2]}] + 1 << ' ';
    order.pop_back();
    f[v].pop_back();
    f[p[1]].pop_back();
}

signed main() {
    fast_in_out();
    int n, G;
    cin >> n >> G;
    for (int i = 0; i < n - 1; ++i) {
        int q, w, e;
        cin >> q >> w >> e;
        --q, --w;
        g[q].emplace_back(w, e);
        g[w].emplace_back(q, e);
        gt[q].insert({w, e});
        gt[w].insert({q, e});
        mp[{q, w, e}] = i;
        mp[{w, q, e}] = i;
    }
    string s;
    getline(cin, s);
    for (int i = 0; i < n; ++i) {
        getline(cin, s);
        stringstream ss(s);
        int x;
        while (ss >> x) {
            f[i].emplace_back(x);
            h[i].insert(x);
        }
    }
    for (int i = 0; i < n; ++i) {
        g1[i] = (int) g[i].size();
        st.insert({g1[i], i});
    }
    while (!st.empty()) {
        auto [deg, v] = *st.begin();
        if (deg == 0) {
            break;
        }
        auto [to, w] = *gt[v].begin();
        auto it = h[to].lower_bound(w - *h[v].begin());
        if (it == h[to].end()) {
            cout << "No";
            return 0;
        }
        ans.push_back({v, to, w, *h[v].begin(), *it});
        mp1[{v, *h[v].begin()}].insert((int) ans.size() - 1);
        mp1[{to, *it}].insert((int) ans.size() - 1);
        st.erase(st.begin());
        gt[v].clear();
        h[v].clear();
        h[to].extract(it);
        gt[to].erase({v, w});
        st.erase({g1[to], to});
        --g1[to];
        st.insert({g1[to], to});
    }
    if (n * n > 5e7) {
        return 1;
    }
    cout << "Yes\n";
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < (int) f[i].size(); ++j) {
            r[i][f[i][j]].insert(j);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!f[i].empty()) {
            rec(i, 0);
        }
    }
//    while (!ans.empty()) {
//        for (int i = 0; i < (int) ans.size(); ++i) {
//            auto vec = ans[i];
//            if (f[vec[0]].back() == vec[3] && f[vec[1]].back() == vec[4]) {
//                f[vec[0]].pop_back();
//                f[vec[1]].pop_back();
//                cout << mp[{vec[0], vec[1], vec[2]}] + 1 << ' ';
//                swap(ans[i], ans.back());
//                ans.pop_back();
//                break;
//            }
//        }
//    }
    return 0;
}
