#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

vector<vector<int>> gr;

vector<int> ans1;
vector<bool> vis;
vector<int> rk;

void dfs(int v){
    if (rk[v] || vis[v])
        return;
    vis[v] = 1;
    ans1.push_back(v);

    for (auto u : gr[v]) {
        rk[u]--;
        dfs(u);
    }
}


void solve() {
    int n, g;
    cin >> n >> g;
    vector<int> deg(n);
    vector<pair<int, int>> reb(n - 1);
    vector<set<int>> graph(n, set<int>());
    vector<int> ws(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        deg[a]++;
        deg[b]++;
        graph[a].insert(i);
        graph[b].insert(i);
        reb[i] = {a, b};
        ws[i] = w;
    }

    vector<set<pair<int, int>>> uliki(n, set<pair<int, int>>());
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < deg[i]; ++j) {
            int u;
            cin >> u;
            uliki[i].insert({u, j});
        }
    }

    set<pair<int, int>> q;
    for (int i = 0; i < n; ++i) {
        q.insert(make_pair(deg[i], i));
    }
    vector<vector<int>> ans(n);
    for (int i = 0; i < n; ++i) {
        vector<int> asdf(deg[i]);
        ans[i] = asdf;
    }
    bool ok = true;
    while(!q.empty()){

        int v = (*q.begin()).second;
        q.erase(q.begin());
        int a = (*uliki[v].begin()).first;
        int r1 = (*uliki[v].begin()).second;
        int r2;
        int i = *graph[v].begin();
        int to = (reb[i].first != v ? reb[i].first : reb[i].second);
        graph[to].erase(i);
        int w = ws[i];
        // a + b >= w
        // b => w - a
//         uliki[to].lowerbound(w - a)
        auto b = uliki[to].lower_bound({w - a, -1});
        if (b == uliki[to].end()){
            ok = false;
            break;
        } else {
            r2 = b->second;
            uliki[to].erase(b);
            ans[to][r2] = i;
            ans[v][r1] = i;
            q.erase(make_pair(deg[to], to));
            q.erase(make_pair(deg[v], v));
            deg[to]--;
            deg[v]--;
            if (deg[to])
                q.insert(make_pair(deg[to], to));
        }
    }
    if (!ok){
        cout << "No\n";
        return;
    }

    gr.resize(n - 1);
    rk.resize(n - 1);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < (int)ans[i].size(); ++j) {
            if (j != (int)ans[i].size() - 1)
                gr[ans[i][j]].push_back(ans[i][j + 1]);
            rk[ans[i][j]]+=(j != 0);
        }
    }

    cout << "Yes\n";
    vis.resize(n - 1, false);
    for (int i = 0; i < n - 1; ++i) {
        if (rk[i] == 0){
            dfs(i);
        }
    }
    reverse(ans1.begin(), ans1.end());
    for (auto i : ans1){
        cout << i + 1 << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    solve();
    return 0;
}
