#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <queue>
#include <deque>
#include <cassert>
using namespace std;
#define line cout << "\n"
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff first
#define ss second
#define pii pair<int, int>
#define sz(a) (int) a.size()
#define int long long
const int MAXN = 2e5 + 10;
vector<vector<pii>> g(MAXN);
vector<int> deg(MAXN);
vector<multiset<int>> b(MAXN);
vector<vector<int>> dd(MAXN);
vector<int> num(MAXN);
map<pii, int> want;
vector<int> h(MAXN);

void dfs(int v, int p, int d = 0) {
    h[v] = d;
    for (auto &u : g[v]) {
        if (u.first != p) {
            dfs(u.first, v, d + 1);
        }
    }
    if (sz(g[v]) == 1) {
        num[v] = *b[v].begin();
        return;
    }
    for (auto &u : g[v]) {
        if (u.first == p) {
            continue;
        }
        auto it = b[v].lower_bound(u.second - num[u.first]);
        if (it == b[v].end()) {
            cout << "No";
            exit(0);
        }
        want[{u.first, v}] = *it;
        b[v].erase(it);
    }
    num[v] = *b[v].begin();
}

void solve() {
    int n, gr;
    cin >> n >> gr;
    map<pii, int> find_edge;
    for (int i = 0; i < n - 1; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--; u--;
        deg[v]++;
        deg[u]++;
        g[v].pb({u, w});
        g[u].pb({v, w});
        find_edge[{v, u}] = find_edge[{u, v}] = i;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            int x;
            cin >> x;
            dd[i].pb(x);
            b[i].insert(x);
        }
    }
    int st = 0;
    for (int i = 0; i < n; i++) {
        if (deg[i] > 1) {
            st = i;
            break;
        }
    }
    dfs(st, -1);
    cout << "Yes"; line;
    map<pii, int> did;
    int calc = sz(want);
    while (calc) {
        for (auto u : want) {
            if (did[{u.first.first, u.first.second}]) {
                continue;
            }
            if (dd[u.first.first].back() == num[u.first.first] && dd[u.first.second].back() == u.second) {
                cout << find_edge[{u.first.first, u.first.second}] + 1 << " ";
                dd[u.first.first].pop_back();
                dd[u.first.second].pop_back();
                did[{u.first.first, u.first.second}] = true;
                calc--;
                break;
            }
        }
    }
}

signed main() {
    fast;


    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}