//#pragma GCC optimize("O3,Ofast,inline,unroll-loops")

#include<bits/stdc++.h>
#define ft first
#define sc second
#define all(x) x.begin(),x.end()
using ll = long long;
using ld = long double;
using ul = unsigned long long;
using li = __int128;
using ui = unsigned;
using namespace std;
const ll inf = 1e18, mod = 1e9+7;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());
    int n, g, u, v, w;
    cin >> n >> g;
    vector<vector<array<int, 3>>> rebra(n);
    for (int i = 0; i < n-1; i++) {
        cin >> u >> v >> w; u--; v--;
        rebra[u].push_back({v, w, i});
        rebra[v].push_back({u, w, i});
    }
    vector<vector<array<int, 3>>> s(n);
    for (int i = 0; i < n; i++) {
        s[i].assign(rebra[i].size(), {0, 1, 0});
        int cnt = 0;
        for (auto &j : s[i]) {
            cin >> j[0];
            j[2] = cnt++;
        }
    }
    vector<vector<int>> rebra2(n-1);
    auto dfs = [&](auto &dfs, int i, int prev)->int{
        int preve = -1, n2 = s[i].size();
        vector<int> b(n2, -1);
        for (auto [j, w, ind] : rebra[i]) {
            if (j == prev) preve = ind;
            else {
                s[i].push_back({w-dfs(dfs, j, i), 0, ind});
            }
        }
        sort(all(s[i]));
        vector<array<int, 3>> st;
        int bst = -1;
        for (auto [w, tp, ind] : s[i]) {
            if (tp == 0) {
                st.push_back({w, tp, ind});
            } else {
                if (st.size() == 0) {
                    bst = ind;
                    b[bst] = w;
                } else {
                    b[ind] = st.back()[2];
                    st.pop_back();
                }
            }
        }
        if (st.size() > 0 || (bst == -1 && prev != -1)) {
            cout << "No";
            exit(0);
        }
        bool flag = 0;
        for (int j = n2-1; j >= 0; j--) {
            if (j == bst) flag = 1;
            else if (!flag) {
                if (preve != -1) rebra2[preve].push_back(b[j]);
            } else if (flag) {
                if (preve != -1) rebra2[b[j]].push_back(preve);
            }
        }
        if (bst == -1) return 0;
        return b[bst];
    };
    dfs(dfs, 0, -1);
    cout << "Yes\n";
    vector<int> used(n-1, 0);
    auto dfs2 = [&](auto &dfs2, int i)->void{
        used[i] = 1;
        for (auto j : rebra2[i]) {
            if (!used[j]) dfs2(dfs2, j);
        }
        cout << i+1 << " ";
    };
    for (int i = 0; i < n-1; i++) {
        if (!used[i]) dfs2(dfs2, i);
    }
}
