#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, less<>, null_type, tree_tag, tree_order_statistics_node_update>;
using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

void solve() {
    int n, G;
    cin >> n >> G;
    vector<tuple<int, int, int, int>> e(n - 1);
    vector<vector<pair<int, int>>> g(n);
    vector<int> d(n);
    map<pair<int, int>, int> ind;
    int cnt = 1;
    for (auto &[a, b, c, ndx]: e) {
        cin >> a >> b >> c;
        a--;
        b--;
        d[a]++;
        d[b]++;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
        ndx = cnt++;
        ind[{a, b}] = ndx;
        ind[{b, a}] = ndx;
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        while (d[i]--) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
    }
    if (G <= 1 && !(G == 0 && n == 7)) {
        vector<int> ndx(n - 1);
        for (int i = 0; i < n - 1; i++)
            ndx[i] = i;
        while (1) {
            auto c1 = c;
            bool is = 1;
            for (int i: ndx) {
                auto [a, b, w, ind] = e[i];
                if (c1[a].back() + c1[b].back() < w)
                    is = 0;
                c1[a].pop_back();
                c1[b].pop_back();
            }
            if (is) {
                cout << "Yes\n";
                for (int i: ndx) {
                    cout << get<3>(e[i]) << ' ';
                }
                return;
            }
            if (!next_permutation(all(ndx)))
                break;
        }
        cout << "No\n";
        return;
    }
    if (G == 2) {
        vector<int> dp(n), dp1(n), go(n), go1(n);
        if (g[0][0].second <= c[0][0] + c[1][0])
            dp[1] = 1;
        if (g[0][0].second <= c[0][0] + c[1][1])
            dp1[1] = 1;
        for (int i = 2; i < n; i++) {
            int w = g[i][0].second;
            if (g[i][0].first != i - 1)
                w = g[i][1].second;
            if (dp[i - 1]) {
                if (w <= c[i - 1][1] + c[i][0]) {
                    dp[i] = 1;
                    go[i] = 1;
                }
                if ((i + 1) != n && w <= c[i - 1][1] + c[i][1]) {
                    dp1[i] = 1;
                    go1[i] = 1;
                }
            }
            if (dp1[i - 1]) {
                if (w <= c[i - 1][0] + c[i][0]) {
                    dp[i] = 1;
                    go[i] = 0;
                }
                if ((i + 1) != n && w <= c[i - 1][0] + c[i][1]) {
                    dp1[i] = 1;
                    go1[i] = 0;
                }
            }
        }
        if (!dp[n - 1]) {
            cout << "No\n";
            return;
        }
        deque<int> ans;
        int x = 1;
        for (int i = n - 1; i > 0; i--) {
            if (x) {
                x = go[i];
                ans.push_front(ind[{i, i - 1}]);
            } else {
                x = go1[i];
                ans.push_back(ind[{i, i - 1}]);
            }
        }
        cout << "Yes\n";
        reverse(all(ans));
        for (int i: ans)
            cout << i << ' ';
    }
    if (G == 3) {
        set<pair<int, int>> s;
        for (int i = 1; i < n; i++) {
            s.insert({g[i][0].second - c[i][0], i});
        }
        vector<int> ans;
        for (int i = n - 2; i >= 0; i--) {
            int x = c[0][i];
            if (s.begin()->first > x) {
                cout << "No\n";
                return;
            }
            auto it = --(s.upper_bound({x + 1, -1}));
            ans.push_back(it->second + 1);
            s.erase(it);
        }
        cout << "Yes\n";
        for (int i: ans)
            cout << i << ' ';
    }
}