#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<iomanip>
#include<algorithm>
using namespace std;
using ll = long long;
vector<vector<tuple<int,ll,int>>>g;
vector<map<int, bool>>used_edges;
vector<int>used_edges_cnt;
vector<int>used;
vector<vector<int>>g_e;
vector<int>top_sort;
void dfs(int v) {
    used[v] = true;
    for (auto u : g_e[v]) {
        if (!used[u])dfs(u);
    }
    top_sort.push_back(v);
}
int main()
{
    //freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    cin.tie(0)->sync_with_stdio(0);
    cout.tie(0)->sync_with_stdio(0);
    int n, group; cin >> n >> group;
    g.resize(n);
    g_e.resize(n - 1);
    used_edges.resize(n);
    for (int i = 0; i < n-1; ++i) {
        int v, u, w; cin >> v >> u >> w; --v, --u;
        g[v].push_back({ u,w,i });
        g[u].push_back({ v,w,i });
    }
    
    used_edges_cnt.resize(n, 0);
    
    vector<vector<ll>>ppr(n);
    for (int i = 0; i < n; ++i) {
        ppr[i].resize(g[i].size());
        for (int j = 0; j < g[i].size(); ++j)cin >> ppr[i][j];
    }
    vector<vector<pair<ll,int>>>cppr(n);
    for (int i = 0; i < n; ++i) {
        cppr[i].resize(ppr[i].size());
        for (int j = 0; j < ppr[i].size(); ++j) {
            cppr[i][j] = { ppr[i][j],j };
        }
        sort(cppr[i].begin(), cppr[i].end());
    }
    vector<vector<pair<ll, int>>>asks(n);
    
    set<pair<int, int>>ww;
    for (int v = 0; v < n; ++v) {
        ww.insert({ g[v].size(),v });
    }
    used.resize(n);
    while (!ww.empty()) {
        auto [cache, v] = *ww.begin();
        used[v] = true;
        ww.erase(ww.begin());
        sort(asks[v].begin(), asks[v].end());
        vector<int>fll(ppr[v].size());
        //
        bool can_skip = true;
        int j = 0;
        int lst = cppr[v].size() - 1;
        for (int i = 0; i < cppr[v].size(); ++i) {
            if (j == asks[v].size())break;
            auto [the_ask, ind] = asks[v][j];
            if (cppr[v][i].first >= the_ask) {
                fll[cppr[v][i].second] = ind;
                ++j;
            }
            else {
                if (can_skip) {
                    can_skip = false;
                    lst = i;
                    continue;
                }
                else {
                    cout << "No\n";
                    return 0;
                }
            }
        }
        
        //
        for (auto[u,w,i]:g[v]) {
            if (used_edges[v][u])continue;
            fll[cppr[v][lst].second] = i;
            used_edges[u][v] = true;
            used_edges[v][u] = true;
            ww.erase({ g[u].size() - used_edges_cnt[u],u });
            used_edges_cnt[u]++;
            if (g[u].size() - used_edges_cnt[u] > 0) {
                ww.insert({ g[u].size() - used_edges_cnt[u],u });
            }
            asks[u].push_back({ w - cppr[v][lst].first,i });
            break;
        }
        for (int i = 0; i + 1 < fll.size(); ++i) {
            g_e[fll[i + 1]].push_back(fll[i]);
        }

    }
    
    for (int v = 0; v < n; ++v) {
        if (used[v])continue;
        vector<int>fll(ppr[v].size());
        int j = 0;
        int lst = cppr[v].size() - 1;
        for (int i = 0; i < cppr[v].size(); ++i) {
            if (j == asks[v].size())break;
            auto [the_ask, ind] = asks[v][j];
            if (cppr[v][i].first >= the_ask) {
                fll[cppr[v][i].second] = ind;
                ++j;
            }
            else {
                cout << "No\n";
                return 0;
            }
        }
       
        for (int i = 0; i + 1 < fll.size(); ++i) {
            g_e[fll[i + 1]].push_back(fll[i]);
        }
        break;
    }
    used.assign(n - 1, 0);
    for (int i = 0; i + 1 < n; ++i) {
        if (!used[i])dfs(i);
    }
    reverse(top_sort.begin(), top_sort.end());
    cout << "Yes\n";
    for (auto c : top_sort)cout << c + 1 << " ";
}