#define _GLIBCXX_DEBUG
#include <bits/extc++.h>

using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ordered_set = tree<int, null_type, std::less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define ff first
#define ss second
//#define int ll

constexpr int MAXN = 2e5;
std::vector<std::pair<int, int>>g[MAXN];
std::vector<int>w[MAXN];
std::set<std::pair<int, int>>c[MAXN];
std::vector<std::pair<int, int>>num[MAXN]; // po nomeru nakl -> nmer nakl, vertex
std::vector<int>num_id[MAXN];
std::vector<int>ans;
int par_id[MAXN];
int nxt[MAXN];
bool f = 1;

void dfs(int v, int p = -1, int w1 = -1) {
    int j = 0;
    for (auto& i : g[v]) {
        if (i.ff != p) {
            par_id[i.ff] = i.ss;
            dfs(i.ff, v, w[v][j]);
        }
        ++j;
    }
    if (p != -1) {
        if (c[v].size() != 1) exit(1);
        auto it = c[p].lower_bound({w1 - (*c[v].begin()).ff, 0});
        if (it == c[p].end()) {
            f = 0;
            return;
        }
        num[v][(*c[v].begin()).ss] = {(*it).ss, p};
        num[p][(*it).ss] = {(*c[v].begin()).ss, v};
        num_id[v][(*c[v].begin()).ss] = par_id[v];
        num_id[p][(*it).ss] = par_id[v];
        c[p].erase(it);
    }
}

void dfs_ans(int v) {
    if (nxt[v] == g[v].size()) return;
    int u = num[v][nxt[v]].ss;
    if (num[u][nxt[u]].ss == v) {
//        std::cout << num_id[v][nxt[v]] << ' ';
//        if (std::find(ans.begin(), ans.end(), num_id[v][nxt[v]]) != ans.size()) exit(1);
        ans.push_back(num_id[v][nxt[v]]);
        ++nxt[v], ++nxt[u];
        dfs_ans(v);
        dfs_ans(u);
    }
}

void solve() {
    int n, G; std::cin >> n >> G;
    for (int i = 0; i < (n - 1); ++i) {
        int a, b, w1; std::cin >> a >> b >> w1;
        g[a - 1].push_back({b - 1, i + 1}), w[a - 1].push_back(w1);
        g[b - 1].push_back({a - 1, i + 1}), w[b - 1].push_back(w1);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            int a; std::cin >> a;
            c[i].insert({a, g[i].size() - j - 1});
        }
        num[i].resize(g[i].size());
        num_id[i].resize(g[i].size());
    }
    dfs(0);
//    for (int i = 0; i < n; ++i) {
//        std::cout << i + 1 << ": ";
//        for (const auto &item: num[i]) std::cout << item.ss << ' ' << item.ff << '\n';
//        std::cout << '\n';
//    }
    if (f) {
        for (int i = 0; i < n; ++i) {
            dfs_ans(i);
        }

        if (ans.size() == n - 1) {
            std::cout << "YES\n";
            for (const auto &item: ans) std::cout << item << ' ';
        } else {
            exit(1);
            std::cout << "NO\n";
        }
    } else {
        std::cout << "NO\n";
    }
}

int32_t main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);

    int T = 1;
//    std::cin >> T;
    while(T--) {
        solve();
    }

    return 0;
}