#include <bits/stdc++.h>
using namespace std;

void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

vector<vector<pair<int, int>>> g;

void solve1(int n) {
    g.resize(n);
    for(int i = 1; i < n; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        g[a - 1].emplace_back(b - 1, w);
        g[b - 1].emplace_back(a - 1, w);
    }
    vector<int> c(n);
    for(int i = 0; i < n; ++i) {
        cin >> c[i];
    }
}

void solve2(int n) {
    g.resize(n);
    for(int i = 1; i < n; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        g[a - 1].emplace_back(b - 1, w);
        g[b - 1].emplace_back(a - 1, w);
    }
    vector<int> c(n);
    for(int i = 0; i < n; ++i) {
        cin >> c[i];
    }
}


void solve3(int n) {
    vector<int> m(n - 1);
    for(int i = 1; i < n; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        m[i] = w;
    }
    vector<int> c(n);
    for(int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    int flag = -1;
    for(int i = 0; i < n - 1; ++i) {
        if(c[0] + c[i + 1] >= m[i]) {
            flag = i;
            break;
        }
    }
    if(flag == -1) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        for(int i = 0; i < n; ++i) {
            if(i == flag) continue;
            cout << i + 1 << " ";
        }
        cout << flag + 1 << '\n';
    }
}


signed main() {
    init();
    int n, g;
    cin >> n >> g;
    if(g <= 1) {
        solve1(n);
    } else if(g == 2) {
        solve2(n);
    } else if(g == 3) {
        solve3(n);
    }
}