#include "bits/stdc++.h"

using namespace std;

#define int long long
#define all(x) (x).begin() (x).end()


struct dsu {
    int count;
    vector<int> p;
    vector<int> sz;
    void init(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        sz.resize(n, 1);
        count = n;
    }
    int get(int x) {
        if (p[x] == x) {
            return p[x];
        }
        return p[x] = get(p[x]);
    }
    bool same(int a, int b) {
        return get(a) == get(b);
    }
    bool merge(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) {
            return false;
        }
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        p[b] = a;
        sz[a] += sz[b];
        count--;
        return true;
    }
};


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, gr;
    cin >> n >> gr;
    vector<array<int, 4>> arr(n - 1);
    vector<int> deg(n);
    for (int i = 0; i < n - 1; i++) {
        cin >> arr[i][0] >> arr[i][1] >> arr[i][2];
        arr[i][3] = i;
        arr[i][0]--;
        arr[i][1]--;
        deg[arr[i][0]]++;
        deg[arr[i][1]]++;
    }
    vector<vector<int>> st(n);
    vector<vector<int>> number(n);
    int it = 0;
    vector<int> gett;
    for (int i = 0; i < n; i++) {
        st[i].resize(deg[i]);
        number[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> st[i][j];
            number[i][j] = it++;
            gett.push_back(i);
        }
    }
    vector<set<pair<int, int>>> gg(it);
    for (auto [a, b, w, id] : arr) {
        for (int i = 0; i < st[a].size(); i++) {
            for (int j = 0; j < st[b].size(); j++) {
                if (st[a][i] + st[b][j] >= w) {
                    gg[number[a][i]].insert({number[b][j], id});
                    gg[number[b][j]].insert({number[a][i], id});
                }
            }
        }
    }
    dsu dsu;
    dsu.init(n);
    vector<int> ans;
    set<pair<int, int>> set;
    for (int i = 0; i < it; i++) {
        set.insert({gg[i].size(), i});
    }
    while (!set.empty()) {
        auto [_, i] = *set.begin();
        set.erase(set.begin());
        if (_ == 0) {
            continue;
        }
        assert(!gg[i].empty());
        auto iterator = gg[i].begin();
        auto [to, id] = *iterator;
        if (!dsu.same(gett[i], gett[to])) {
            ans.push_back(id);
            dsu.merge(gett[i], gett[to]);
        }
        if (set.count({gg[to].size(), to})) {
            set.erase({gg[to].size(), to});
            gg[to].erase({i, id});
            set.insert({gg[to].size(), to});
        } else {
            gg[to].erase({i, id});
        }
        gg[i].erase(gg[i].begin());
        set.insert({gg[i].size(), i});
    }
    if (ans.size() == n - 1 && dsu.count == 0) {
        reverse(ans.begin(), ans.end());
        cout << "Yes\n";
        for (int i : ans) {
            cout << i + 1 << ' ';
        }
    } else {
        cout << "No";
    }
    return 0;
}
