#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

using namespace std;
using ll = long long;

const ll INF = 1e18;

void solve() {
    ll n, G; cin >> n >> G;
    vector <tuple <ll, ll, ll>> edges(n - 1);
    vector <bool> live(n - 1, true);
    vector <ll> deg(n);
    for (auto& [a, b, w] : edges)
        cin >> a >> b >> w, a--, b--, deg[a]++, deg[b]++;
    vector <vector <ll>> stik(n);
    for (ll i = 0; i < n; i++) {
        stik[i].resize(deg[i]);
        for (auto& j : stik[i])
            cin >> j;
        reverse(stik[i].begin(), stik[i].end());
    }
    vector <ll> ans;
    bool f = true;
    while (f) {
        f = false;
        ll mn = INF, id = 0, mx = -INF;
        for (ll i = 0; i < n - 1; i++) {
            if (live[i]) {
                auto [a, b, w] = edges[i];
                ll sm = stik[a].back() + stik[b].back();
                if (sm >= w && (sm - w < mn || (sm - w == mn && w > mx))) {
                    mn = sm - w, id = i, mx = w;
                    f = true;
                }
            }
        }
        if (f) {
            live[id] = false;
            ans.emplace_back(id);
            auto [a, b, w] = edges[id];
            stik[a].pop_back(), stik[b].pop_back();
        }
    }
    if ((ll) ans.size() == n - 1) {
        reverse(ans.begin(), ans.end());
        cout << "Yes\n";
        for (auto i : ans)
            cout << i + 1 << ' ';
    } else {
        cout << "No\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    while (T--) {
        solve();
    }
    return 0;
}
