#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>

using namespace std;

#define ALL(x) x.begin(), x.end()
#define int long long
typedef long long ll;
typedef long double ld;

void solve1(int n, int k, int t)
{
	vector<int> a;
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		if (a.size() && a.back() == x)
		{
			continue;
		}
		a.push_back(x);
	}
	bool ban = false;
	if (a.back() == a[0])
	{
		a.pop_back();
		ban = true;
	}
	int count = 0;
	n = a.size();
	cout << n * k + ban;
}
void solve2(int n, int k, int t)
{
	vector<int> a;
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		if (a.size() && a.back() == x)
		{
			continue;
		}
		a.push_back(x);
	}
	n = a.size();
	int count = 0;
	int j = 0;
	set<int> now;
	for (int i = 0; i < k;)
	{
		while (i < k)
		{
			now.insert(a[j]);
			if (now.size() > t)
			{
				break;
			}
			j++;
			if (j == n)
			{
				j = 0;
				i++;
			}
		}
		count++;
		if (i >= k)
		{
			break;
		}
		/*if (i < k && j == 0)
		{
			int kolvo = (n - i) / i;
			count += count * kolvo;
			i += i * kolvo;
		}*/
		now.clear();
	}
	cout << count;
}


void solve()
{
	int n, g;
	cin >> n >> g; 
	vector<pair<pair<int, int>, pair<int, int>>> edges;
	vector<int> deg(n, 0);
	vector<int> temmp;
	vector<vector<int>> c(n, temmp);
	for (int i = 0; i < n - 1; i++)
	{
		int a, b, w;
		cin >> a >> b >> w;
		a--;
		b--;
		deg[a]++;
		deg[b]++;
		edges.push_back({ {a, b}, {w, i} });
	}
	sort(ALL(edges));
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < deg[i]; j++)
		{
			int x;
			cin >> x;
			c[i].push_back(x);
		}
	}
	vector<vector<int>> c1 = c;
	do
	{
		c1 = c;
		bool ban = true;
		for (auto [xy, ww] : edges)
		{
			auto [x, y] = xy;
			auto [w, ii] = ww;
			if (c1[x].back() + c1[y].back() < w)
			{
				ban = false;
				break;
			}
			c1[x].pop_back();
			c1[y].pop_back();
		}
		if (ban)
		{
			cout << "Yes\n";
			for (auto [xy, ww] : edges)
			{
				auto [x, y] = xy;
				auto [w, ii] = ww;
				cout << ii + 1 << ' ';
			}
			return;
		}
	} while (next_permutation(ALL(edges)));
	cout << "No";
}

int32_t main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}
}