#include<bits/stdc++.h>


using namespace std;
#define int long long
//#define ILOCAL
#ifdef ILOCAL
#define debug(x) cerr << (#x) << " = " << x << endl
#else
#define debug(x)
#endif


using ll = long long;
using vii = vector<int>;
using vll = vector<ll>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vpi = vector<pii>;
using vpl = vector<pll>;
using ull = unsigned long long;
using ld = long double;
using ql = __int128_t;
using uql = __uint128_t;

ostream &operator<<(ostream &out, const vii &a) {
    for(auto &x: a) {
        out << x << ' ';
    }
    return out;
}

void solve() {
    int n, g;
    cin >> n >> g;
    vector<tuple<int, int, int>> edges;
    vii c[n + 1];
    int deg[n + 1];
    fill(deg + 1, deg + n + 1, 0);
    for(int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        edges.emplace_back(a, b, w);
        ++deg[a];
        ++deg[b];
    }
    for(int i = 1; i <= n; ++i) {
        for(int j = 0; j < deg[i]; ++j) {
            int x;
            cin >> x;
            debug(x);
            c[i].emplace_back(x);
        }
    }
    if (g == 1 || g == 0) {
        vii perm(n - 1);
        iota(perm.begin(), perm.end(), 0);
        debug(perm);
        do {
            vii tmp[n + 1];
            for(int i = 1; i <= n; ++i) {
                for(auto &x: c[i]) {
                    tmp[i].emplace_back(x);
                }
            }
            bool fl = true;
            for(auto &x: perm) {
                auto &[a, b, w] = edges[x];
                debug(a);
                debug(b);
                debug(w);
                if (tmp[a].back() + tmp[b].back() < w) {
                    fl = false;
                    break;
                }
                tmp[a].pop_back();
                tmp[b].pop_back();
            }
            debug(perm);
            if (fl) {
                cout << "YES\n";
                for(auto &x: perm) {
                    cout << x + 1 << ' ';
                }
                return;
            }
            debug(-1);
        } while(next_permutation(perm.begin(), perm.end()));
        cout << "NO" << '\n';
        return;
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef ILOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
}