#include <bits/stdc++.h>

using namespace std;
#define pb push_back
#define ll long long
#define int ll
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int maxn = 2e5 + 10;

struct edg {
    int v, u, w;
    edg() {
        v = u = w = 0;
    }
    edg(int x, int y, int z) {
        v = x, u = y, w = z;
    }
};

int n, G;
vector<int> a[maxn], nxt[maxn];
vector<pii> g[maxn];
map<int, vector<int>> a1[maxn];
set<int> alive[maxn];
map<pii, int> id;

void place(int v, int p) {
    for(auto [to, w] : g[v]) {
        if(to == p) continue;
        place(to, v);
        int i1 = *alive[to].begin();
        alive[to].erase(i1);
        int x = a[to][i1];
        auto it = a1[v].lower_bound(w - x);
        if(it == a1[v].end()) {
            cout << "No";
            exit(0);
        }
        int y = (*it).X;
        nxt[v][a1[v][y].back()] = to;
        alive[v].erase(a1[v][y].back());
        a1[v][y].pop_back();
        if((int)a1[v][y].size() == 0) a1[v].erase(y);
    }
}

void anstq(int v, int p) {
    for(int to : nxt[v]) {
        if(to == -1) cout << id[{v, p}] << " ";
        else anstq(to, v);
    }
}

void solve() {
    cin >> n >> G;
    vector<int> sz(n, 0);
    vector<edg> tmr(n - 1);
    vector<int> inds(n - 1);
    iota(all(inds), 0);
    for(int i = 0; i < n - 1; ++i) {
        int x, y, z;
        cin >> x >> y >> z;
        --x, --y;
        g[x].pb({y, z});
        g[y].pb({x, z});
        id[{x, y}] = i + 1;
        id[{y, x}] = i + 1;
        tmr[i] = edg(x, y, z);
        ++sz[x];
        ++sz[y];
    }
    for(int i = 0; i < n; ++i) {
        nxt[i].resize(sz[i], -1);
        for(int k = 0; k < sz[i]; ++k) {
            int q;
            cin >> q;
            a[i].pb(q);
            a1[i][q].pb(sz[i] - k - 1);
            alive[i].insert(k);
        }
        reverse(all(a[i]));
    }
    if(n <= 1) {
        vector<int> lst(n);
        do {
            bool f = true;
            for(int i = 0; i < n; ++i) lst[i] = 0;
            for(int i : inds) {
                int v = tmr[i].v, u = tmr[i].u, w = tmr[i].w;
                if(w > a[v][lst[v]] + a[u][lst[u]]) {
                    f = false;
                    break;
                }
                ++lst[v];
                ++lst[u];
            }
            if(f) {
                cout << "Yes\n";
                for(int i : inds) cout << i + 1 << " ";
                cout << '\n';
                return;
            }
        } while(next_permutation(all(inds)));
        cout << "No";
    }
    else {
        place(0, -1);
        cout << "Yes\n";
        anstq(0, -1);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
    return 0;
}
