#include <bits/stdc++.h>

using namespace std;
#define pb push_back
#define ll long long
#define int ll
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int maxn = 2e5 + 10;

int n, G;
vector<int> a[maxn], nxt[maxn];
vector<pii> g[maxn];
map<int, vector<int>> a1[maxn];
set<int> alive[maxn];
map<pii, int> id;

void place(int v, int p) {
    for(auto [to, w] : g[v]) {
        if(to == p) continue;
        place(to, v);
        int i1 = *alive[to].begin();
        alive[to].erase(i1);
        int x = a[to][i1];
        auto it = a1[v].lower_bound(w - x);
        if(it == a1[v].end()) {
            cout << "No";
            exit(0);
        }
        int y = (*it).X;
        nxt[v][a1[v][y].back()] = to;
        alive[v].erase(a1[v][y].back());
        a1[v][y].pop_back();
        if((int)a1[v][y].size() == 0) a1[v].erase(y);
    }
}

void anstq(int v, int p) {
    for(int to : nxt[v]) {
        if(to == -1) cout << id[{v, p}] << " ";
        else anstq(to, v);
    }
}

void solve() {
    cin >> n >> G;
    vector<int> inds(n - 1);
    iota(all(inds), 0);
    for(int i = 0; i < n - 1; ++i) {
        int x, y, z;
        cin >> x >> y >> z;
        --x, --y;
        g[x].pb({y, z});
        g[y].pb({x, z});
        id[{x, y}] = i + 1;
        id[{y, x}] = i + 1;
    }
    for(int i = 0; i < n; ++i) {
        nxt[i].resize((int)g[i].size(), -1);
        for(int k = 0; k < (int)g[i].size(); ++k) {
            int q;
            cin >> q;
            a[i].pb(q);
            a1[i][q].pb((int)g[i].size() - k - 1);
            alive[i].insert(k);
        }
        reverse(all(a[i]));
    }
    place(0, -1);
    cout << "Yes\n";
    anstq(0, -1);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
    return 0;
}
