#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_map>
#include <iomanip>
#include <queue>
#include <climits>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef long double ld;
#define mid (r + l) / 2
#define lv (2 * v + 1)
#define rv (2 * v + 2)
#define all(x) x.begin(), x.end()
struct t {
    int u, v, w;
    t(int a, int b, int c) {
        u = a;
        v = b;
        w = c;
    }
    t() {
        u = 0;
        v = 0;
        w = 0;
    }
};
vector<t> p;
vector<int> cnt;
vector<int> per;
vector<vector<int>> is;

bool get() {
    for (int i = 0; i < is.size(); i++) cnt[i] = 0;
    for (int i : per) {
        if (is[p[i].u][cnt[p[i].u]] + is[p[i].v][cnt[p[i].v]] < p[i].w) {
            return false;
        }
        cnt[p[i].u]++;
        cnt[p[i].v]++;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    int n, g;
    cin >> n >> g;
    p.resize(n - 1);
    cnt.resize(n);
    is.resize(n);
    for (int i = 0; i < n - 1; i++) {
        cin >> p[i].u >> p[i].v >> p[i].w;
        p[i].u--;
        p[i].v--;
        cnt[p[i].u]++;
        cnt[p[i].v]++;
    }
    for (int i = 0; i < n - 1; i++) {
        per.push_back(i);
    }
    for (int i = 0; i < n; i++) {
        is[i].resize(cnt[i]);
        for (int j = 0; j < cnt[i]; j++) {
            cin >> is[i][j];
        }
        reverse(all(is[i]));
    }
    do {
        if (get()) {
            cout << "Yes\n";
            for (int i : per) {
                cout << i + 1 << " ";
            }
            return 0;
        }
    } while (next_permutation(all(per)));
    cout << "No\n";
    return 0;
}