#define _USE_MATH_DEFINES
#include <bits/extc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
typedef tree<pair<int, int>, null_type, less<pair<int ,int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
#define mid (r + l) / 2
#define lv (2 * v + 1)
#define rv (2 * v + 2)
#define all(x) x.begin(), x.end()

struct t {
    int u, v, w, i;
    t(int a, int b, int c, int i) {
        u = a;
        v = b;
        w = c;
        i = i;
    }
    t() {
        u = 0;
        v = 0;
        w = 0;
        i = 0;
    }
};
vector<t> p;
vector<int> cnt;
vector<int> per;
vector<vector<int>> is;

bool get() {
    for (int i = 0; i < is.size(); i++) cnt[i] = 0;
    for (int i : per) {
        if (is[p[i].u][cnt[p[i].u]] + is[p[i].v][cnt[p[i].v]] < p[i].w) {
            return false;
        }
        cnt[p[i].u]++;
        cnt[p[i].v]++;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    int n, g;
    cin >> n >> g;
    p.resize(n - 1);
    cnt.resize(n);
    is.resize(n);
    for (int i = 0; i < n - 1; i++) {
        cin >> p[i].u >> p[i].v >> p[i].w;
        p[i].u--;
        p[i].v--;
        if (p[i].v == 0) swap(p[i].v, p[i].u);
        cnt[p[i].u]++;
        cnt[p[i].v]++;
        p[i].i = i;
    }
    for (int i = 0; i < n - 1; i++) {
        per.push_back(i);
    }
    for (int i = 0; i < n; i++) {
        is[i].resize(cnt[i]);
        for (int j = 0; j < cnt[i]; j++) {
            cin >> is[i][j];
        }
        reverse(all(is[i]));
    }
    if (n <= 10) {
        do {
            if (get()) {
                cout << "Yes\n";
                for (int i : per) {
                    cout << i + 1 << " ";
                }
                return 0;
            }
        } while (next_permutation(all(per)));
        cout << "No\n";
        return 0;
    }
    else {
        vector<int> ans(n - 1);
        for (int i = 0; i < n; i++) cnt[i] = 0;
        sort(all(p), [](t a, t b) {return a.w < b.w; });
        for (int i = 0; i < n - 1; i++) {
            if (p[i].w  > is[p[i].v][cnt[p[i].v]] + is[p[i].u][cnt[p[i].u]]) {
                cout << "No\n";
                return 0;
            }
            ans[i] = p[i].i;
            cnt[p[i].u]++;
            cnt[p[i].v]++;
        }
        cout << "Yes\n";
        for (int i : ans) {
            cout << i + 1 << " ";
        }
    }
    return 0;
}