#ifndef SYSTY257
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using pii = pair <int, int>;

template<typename t1, typename t2>
void mnr(t1 &a, const t2 &b) {
    if (b < a) {
        a = b;
    }
}

template<typename t1, typename t2>
void mxr(t1 &a, const t2 &b) {
    if (b > a) {
        a = b;
    }
};

void g1(int n, const vector <tuple <int, int, int> >& edges, const vector <vector <int> >& cost) {
    vector <int> p(n - 1);
    iota(all(p), 0);
    do {
        auto v = cost;
        bool f = true;
        for (auto id : p) {
            auto [a, b, w] = edges[id];
            int sc = v[a].back() + v[b].back();
            if (sc < w) {
                f = false;
                break;
            }
            v[a].pop_back();
            v[b].pop_back();
        }
        if (f) {
            reverse(all(p));
            cout << "Yes\n";
            for (auto i : p) {
                cout << i + 1 << " ";
            }
            return;
        }
    } while (next_permutation(all(p)));
    cout << "No";
}

signed main() {
    cout << setprecision(15) << fixed;
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, GROUP;
    cin >> n >> GROUP;
    vector <tuple <int, int, int> > edges(n - 1);
    vector <vector <int> > cost(n);
    vector <int> deg(n);
    for (auto &[a, b, c] : edges) {
        cin >> a >> b >> c;
        --a, --b;
        ++deg[a], ++deg[b];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < deg[i]; ++j) {
            int cv;
            cin >> cv;
            cost[i].push_back(cv);
        }
    }
    g1(n, edges, cost);
}