#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

vector<vector<int>> g;
vector<pair<int, int>> e;
vector<int> pred;
vector<int> step;
set<pair<int, pair<int, int>>> lef;
vector<vector<int>> otv;


void mark(int v, int p) {
    step[v] = 0;
    pred[v] = p;
    for (auto i: g[v]) {
        int u = e[i].first ^ v, w = e[i].second;
        if (step[u] == -1) {
            mark(u, i);
            step[v]++;
        }
    }
    if (step[v] == 0) {
        lef.insert({e[p].second, {p, v}});
    }
}

vector<int> ans;
vector<int> was;

void dfs(int v) {
    was[v] = true;
    for (auto i: otv[v]) {
        int u = e[i].first ^ v;
        if (was[u]) {
            ans.push_back(i);
        } else {
            was[u] = true;
            dfs(u);
        }
    }
}

void solve() {
    int n, T;
    cin >> n >> T;
    g.resize(n);
    pred.resize(n);
    step.resize(n, -1);
    otv.resize(n);
    was.resize(n - 1, false);
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        --u;
        --v;
        g[u].push_back(i);
        g[v].push_back(i);
        e.emplace_back(u ^ v, w);
    }
    vector<set<pair<int, int>>> a(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int x;
            cin >> x;
            a[i].insert({x, g[i].size() - j - 1});
        }
        otv[i].resize(g[i].size());
    }
    int s = 0;
    for (int i = 0; i < n; i++) {
        if (g[i].size() > g[s].size()) {
            s = i;
        }
    }
    mark(s, -1);
    while (!lef.empty()) {
        auto k = *lef.begin();
        lef.erase(lef.begin());
        int w = k.first;
        int i = k.second.first;
        int v = k.second.second;
        int u = e[i].first ^ v;
        step[u]--;
        if (!step[u]) {
            if (pred[u] != -1) {
                lef.insert({e[pred[u]].second, {pred[u], u}});
            }
        }
        w -= (*a[v].begin()).first;
        auto x = a[u].lower_bound({w, -1});
        if (x == a[u].end()) {
            cout << "No\n";
            exit(0);
        }
        otv[v][(*a[v].begin()).second] = i;
        otv[u][(*x).second] = i;
        a[u].erase(x);
    }
    dfs(s);
    cout << "Yes\n";
    if(ans.empty()){
        for(int i = 0; i < 2; i++){
            i--;
        }
    }
    for (auto i: ans) {
        cout << i + 1 << ' ';
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
