#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 3e5;
const ld EPS = 1e-6;

void solve() {
    ll n, group;
    cin >> n >> group;
    vector<ll> deg(n);
    pair<pair<ll, ll>, ll> edges[n - 1];
    for (ll i = 0; i < n - 1; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        deg[u]++, deg[v]++;
        edges[i] = {{u, v}, w};
    }
    vector<ll> have[n];
    for (ll i = 0; i < n; ++i) {
        have[i].resize(deg[i]);
        for (ll j = 0; j < deg[i]; ++j) {
            cin >> have[i][j];
        }
        reverse(have[i].begin(), have[i].end());
    }
    vector<bool> used(n - 1);
    vector<ll> ord;
    for (int step = 0; step < n - 1; ++step) {
        for (ll i = 0; i < n - 1; ++i) {
            if (!used[i] && edges[i].second <= have[i].back() + have[i + 1].back()) {
                ord.emplace_back(i);
                used[i] = true;
                have[i].pop_back();
                have[i + 1].pop_back();
            }
        }
    }
    if ((ll)ord.size() == n - 1) {
        cout << "Yes" << '\n';
        for (ll x : ord) {
            cout << x + 1 << ' ';
        }
    } else {
        cout << "No" << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
