#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 3e5;
const ld EPS = 1e-6;

void solve() {
    ll n, group;
    cin >> n >> group;
    vector<ll> deg(n);
    pair<pair<ll, ll>, ll> edges[n - 1];
    for (ll i = 0; i < n - 1; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        deg[u]++, deg[v]++;
        edges[i] = {{u, v}, w};
    }
    vector<ll> have[n];
    for (ll i = 0; i < n; ++i) {
        have[i].resize(deg[i]);
        for (ll j = 0; j < deg[i]; ++j) {
            cin >> have[i][j];
        }
    }
    int per[n - 1];
    for (int i = 0; i < n - 1; ++i) {
        per[i] = i;
    }
    int cor_ord[n];
    for (int i = 0; i < n; ++i) {
        cor_ord[i] = -1;
    }
    for (int step = 0; step < 400000 && cor_ord[0] == -1; ++step) {
        vector<ll> probhave[n];
        for (int i = 0; i < n; ++i) {
            probhave[i] = have[i];
        }
        bool ok = true;
        for (int id : per) {
            if (probhave[edges[id].first.first].back() + probhave[edges[id].first.second].back() >= edges[id].second) {
                probhave[edges[id].first.first].pop_back();
                probhave[edges[id].first.second].pop_back();
            } else {
                ok = false;
                break;
            }
        }
        if (ok) {
            for (int i = 0; i < n; ++i) {
                cor_ord[i] = per[i];
            }
        }
        next_permutation(per, per + n);
    }
    if (cor_ord[0] == -1) {
        cout << "No" << '\n';
    } else {
        cout << "Yes" << '\n';
        for (int i = 0; i < n - 1; ++i) {
            cout << cor_ord[i] + 1 << ' ';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
