#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

vector<pair<pair<int, int>, int>> edges;
vector<ll> have[MAXN];
vector<ll> ord;

void rec(int ind) {
    int cur = have[ind].back();
    if (have[ind + 1].size() == 1) {
        if (cur + have[ind + 1][0] < edges[ind].second) {
            // bad
        } else {
            ord.emplace_back(ind);
        }
    } else {
        if (cur + max(have[ind + 1][0], have[ind + 1][1]) < edges[ind].second) {
            // bad
        } else {
            if (cur + min(have[ind + 1][0], have[ind + 1][1]) >= edges[ind].second) {
                if (have[ind + 1][0] >= have[ind + 1][1]) {
                    ord.emplace_back(ind);
                    have[ind].pop_back();
                    have[ind + 1].pop_back();
                } else {
                    ord.emplace_back(ind);
                    have[ind].pop_back();
                    have[ind + 1] = {have[ind + 1][1]};
                }
                rec(ind + 1);
            } else {
                if (have[ind + 1][0] < have[ind + 1][1]) {
                    ord.emplace_back(ind);
                    have[ind].pop_back();
                    have[ind + 1].pop_back();
                } else {
                    ord.emplace_back(ind);
                    have[ind].pop_back();
                    have[ind + 1] = {have[ind + 1][1]};
                }
                rec(ind + 1);
            }
        }
    }
}

void solve() {
    ll n, group;
    cin >> n >> group;
    vector<ll> deg(n);
    for (ll i = 0; i < n - 1; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        deg[u]++, deg[v]++;
        edges.emplace_back(make_pair(u, v), w);
    }
    for (ll i = 0; i < n; ++i) {
        have[i].resize(deg[i]);
        for (ll j = 0; j < deg[i]; ++j) {
            cin >> have[i][j];
        }
    }
    rec(0);
    if ((int)ord.size() == n - 1) {
        cout << "Yes" << '\n';
        for (int i : ord) {
            cout << i + 1 << ' ';
        }
    } else {
        cout << "No" << '\n';
    }
//    int per[n - 1];
//    for (int i = 0; i < n - 1; ++i) {
//        per[i] = i;
//    }
//    int cor_ord[n - 1];
//    for (int i = 0; i < n - 1; ++i) {
//        cor_ord[i] = -1;
//    }
//    for (int step = 0; step < 400000 && cor_ord[0] == -1; ++step) {
//        vector<ll> probhave[n];
//        for (int i = 0; i < n; ++i) {
//            probhave[i] = have[i];
//        }
//        bool ok = true;
//        for (int id : per) {
//            if (probhave[edges[id].first.first].back() + probhave[edges[id].first.second].back() >= edges[id].second) {
//                probhave[edges[id].first.first].pop_back();
//                probhave[edges[id].first.second].pop_back();
//            } else {
//                ok = false;
//                break;
//            }
//        }
//        if (ok) {
//            for (int i = 0; i < n - 1; ++i) {
//                cor_ord[i] = per[i];
//            }
//        }
//        next_permutation(per, per + n - 1);
//    }
//    if (cor_ord[0] == -1) {
//        cout << "No" << '\n';
//    } else {
//        cout << "Yes" << '\n';
//        for (int i = 0; i < n - 1; ++i) {
//            cout << cor_ord[i] + 1 << ' ';
//        }
//    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
