#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

vector<pair<pair<int, int>, int>> edges;
vector<ll> have[MAXN];
vector<ll> ord;

void rec(int ind) {
    int cur = have[ind].back();
    if (have[ind + 1].size() == 1) {
        if (cur + have[ind + 1][0] < edges[ind].second) {
            // bad
        } else {
            ord.emplace_back(ind);
        }
    } else {
        if (cur + max(have[ind + 1][0], have[ind + 1][1]) < edges[ind].second) {
            // bad
        } else {
            if (cur + min(have[ind + 1][0], have[ind + 1][1]) >= edges[ind].second) {
                if (have[ind + 1][0] >= have[ind + 1][1]) {
                    ord.emplace_back(ind);
                    have[ind].pop_back();
                    have[ind + 1].pop_back();
                    rec(ind + 1);
                } else {
                    have[ind].pop_back();
                    have[ind + 1] = {have[ind + 1][1]};
                    rec(ind + 1);
                    ord.emplace_back(ind);
                }
            } else {
                if (have[ind + 1][0] < have[ind + 1][1]) {
                    ord.emplace_back(ind);
                    have[ind].pop_back();
                    have[ind + 1].pop_back();
                    rec(ind + 1);
                } else {
                    have[ind].pop_back();
                    have[ind + 1] = {have[ind + 1][1]};
                    rec(ind + 1);
                    ord.emplace_back(ind);
                }
            }
        }
    }
}

void solve() {
    ll n, group;
    cin >> n >> group;
    vector<ll> deg(n);
    for (ll i = 0; i < n - 1; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        deg[u]++, deg[v]++;
        edges.emplace_back(make_pair(u, v), w);
    }
    for (ll i = 0; i < n; ++i) {
        have[i].resize(deg[i]);
        for (ll j = 0; j < deg[i]; ++j) {
            cin >> have[i][j];
        }
    }
    rec(0);
    if ((int)ord.size() == n - 1) {
        cout << "Yes" << '\n';
        for (int i : ord) {
            cout << i + 1 << ' ';
        }
    } else {
        cout << "No" << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
