#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define klm ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define pb(a) push_back(a)

struct edge{
    ll u, v, w;

    edge(){}

    edge(ll _u, ll _v, ll _w){
        u = _u;
        v = _v;
        w = _w;
    }
};

void solve(){
    ll n, gr, sm = 0;
    cin >> n >> gr;
    
    vector<vector<ll> >c(n);
    vector<edge>g(n - 1);
    vector<ll>cnt(n, 0);
    for(int i = 0; i < n - 1; ++i){
        cin >> g[i].u >> g[i].v >> g[i].w;
        sm -= g[i].w;
        --g[i].u;
        --g[i].v;
        cnt[g[i].u]++;
        cnt[g[i].v]++;
    }

    set<pair<ll, ll>>st;
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < cnt[i]; ++j){
            ll x;
            cin >> x;
            sm += x;
            c[i].push_back(x);
        }
        st.insert({-c[i].back(), i});
    }

    if (sm < 0){
        cout << "No\n";
        return;
    }

    if (gr <= 1){

        vector<ll>bro, brox = cnt;
        for(int i = 0; i < n; ++i){
            --brox[i];
        }
        ll bro1 = 1;
        for(int i = 0; i < n - 1; ++i){
            bro.push_back(i);
            bro1 *= (i + 1);
        }

        while(bro1--){
            bool ok = 1;
            vector<ll>cur = brox;

            for(int i = 0; i < n - 1; ++i){
                ll u = g[bro[i]].u, v = g[bro[i]].v, w = g[bro[i]].w;
                if (cur[g[bro[i]].u] < 0 || cur[g[bro[i]].v] < 0){
                    ok = 0;
                    break;
                }
                if (c[u][cur[u]] + c[v][cur[v]] < w){
                    ok = 0;
                    break;
                }
                --cur[u];
                --cur[v];
            }

            if (ok){
                cout << "Yes\n";
                for(int i = 0; i < n - 1; ++i){
                    cout << bro[i] + 1 << " ";
                }
                return;
            }
            next_permutation(all(bro));
        }

        cout << "No\n";
        return;
    }
    vector<ll>ans, used(n, 0);
    while (!st.empty()){
        auto gg = *st.begin();
        ll v1 = gg.second;
        st.erase(st.begin());
        bool ok = 0;
        for(int i = 0; i < n - 1; ++i){
            ll u = g[i].u, v = g[i].v, w = g[i].w;
            if (!used[i] && (u == v1 || v == v1) && c[u].back() + c[v].back() >= w){
                ok |= 1;
                used[i] = 1;
                ans.pb(i + 1);
                st.erase({-c[u].back(), u});
                st.erase({-c[v].back(), v});
                c[u].pop_back();
                c[v].pop_back();
                if (sz(c[u]) > 0){
                    st.insert({-c[u].back(), u});
                }
                if (sz(c[v]) > 0){
                    st.insert({-c[v].back(), v});
                }
                break;
            }
        }
        if (!ok){
            cout << "No\n";
            return;
        }
    }

    cout << "Yes\n";
    for(auto e: ans){
        cout << e << " ";
    }
}

int main(){
    ll t = 1;
    klm;
    //freopen("/home/olymp/Desktop/negr/input.txt", "r", stdin);
    //freopen("/home/olymp/Desktop/negr/output.txt", "w", stdout);

    //cin >> t;

    while(t--){
        solve();
    }
    return 0;
}