// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, gt;
    cin >> n >> gt;
    vector<pair<pair<int, int>, int>> edges(n - 1);
    vector<set<pair<int, int>>> g(n);
    map<pair<int, int>, int> ind;
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].first.first >> edges[i].first.second >> edges[i].second;
        edges[i].first.first--, edges[i].first.second--;
        ind[edges[i].first] = i;
        ind[make_pair(edges[i].first.second, edges[i].first.first)] = i;
        g[edges[i].first.first].emplace(edges[i].first.second, edges[i].second);
        g[edges[i].first.second].emplace(edges[i].first.first, edges[i].second);
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(g[i].size());
        for (int j = 0; j < (int)g[i].size(); ++j) {
            cin >> c[i][j];
        }
        // reverse(c[i].begin(), c[i].end());
    }
    vector<pair<int, int>> vls(n - 1);
    for (int _ = 0; _ < n - 1; ++_) {
        vector<pair<int, int>> vals;
        for (int i = 0; i < n; ++i) {
            if (g[i].size() == 1) {
                int vl = 0;
                for (int j = 0; j < (int)c[i].size(); ++j) {
                    if (c[i][j] != -1) {
                        vl = c[i][j];
                    }
                }
                vals.emplace_back(g[i].begin()->second - vl, i);
            }
        }
        if (vals.empty()) {
            cout << "No\n";
            return;
        }
        sort(vals.rbegin(), vals.rend());
        int v = vals[0].second;
        int u = g[v].begin()->first;
        int id = -1;
        for (int j = 0; j < (int)c[u].size(); ++j) {
            if (c[u][j] != -1 && c[u][j] >= vals[0].first && (id == -1 || c[u][j] < c[u][id])) {
                id = j;
            }
        }
        if (id == -1) {
            cout << "No\n";
            return;
        }
        int id2 = -1;
        for (int j = 0; j < (int)c[v].size(); ++j) {
            if (c[v][j] != -1) {
                id2 = j;
            }
        }
        // ans.emplace_back(max(id, id2), ind[make_pair(u, v)]);
        if (edges[ind[make_pair(u, v)]].first.first == v) {
            swap(u, v);
            swap(id, id2);
        }
        // cout << u << ' ' << v << ' ' << id << ' ' << id2 << ' ' << c[u].size() << ' ' << c[v].size() << endl;
        vls[ind[make_pair(u, v)]] = {id, id2};
        // cout << u << ' ' << v << ' ' << id << ' ' << id2 << '\n';
        c[u][id] = -1;
        c[v][id2] = -1;
        g[u].erase(g[u].lower_bound(make_pair(v, -1)));
        g[v].erase(g[v].lower_bound(make_pair(u, -1)));
        // cout << "!!!" << endl;
    }
    // sort(ans.rbegin(), ans.rend());
    vector<int> ans;
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            if (vls[j] == make_pair(0, 0)) {
                ans.push_back(j);
                for (int k = 0; k < n - 1; ++k) {
                    if (edges[k].first.first == edges[j].first.first || edges[k].first.first == edges[j].first.second) {
                        vls[k].first--;
                    }
                    if (edges[k].first.second == edges[j].first.first || edges[k].first.second == edges[j].first.second) {
                        vls[k].second--;
                    }
                }
                break;
            }
        }
    }
    reverse(ans.begin(), ans.end());
    cout << "Yes\n";
    for (int i = 0; i < n - 1; ++i) {
        cout << ans[i] + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
