#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
istream& operator >>(istream& in, pair<T, T1> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T, typename T1>
ostream& operator <<(ostream& out, pair<T, T1> &arr) {
    for (auto i : arr) out << i << " ";
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<T> &arr) {
    for (auto i : arr) out << i << " ";
    return out;
}

void solve() {
    int n, grup; cin >> n >> grup;

    if (grup <= 1) {
        vector<vector<int>> rb;
        vector<int> cnt(n);
        for (int i = 0; i < n - 1; i++) {
            int a, b, c; cin >> a >> b >> c;
            a--; b--;
            rb.pb({a, b, c});

            cnt[a]++, cnt[b]++;
        }

        vector<vector<int>> s(n);
        for (int i = 0; i < n; i++) {
            s[i].rs(cnt[i]);
            cin >> s[i];

            reverse(all(s[i]));
        }

        vector<int> used(1 << n, -1);
        used[0] = -2;
        for (int msk = 0; msk < (1LL << (n - 1)); msk++) {
            if (used[msk] == -1) continue;

            vector<int> cn(n);
            for (int i = 0; i < n - 1; i++) {
                if ((msk >> i) & 1) {
                    cn[rb[i][0]]++; cn[rb[i][1]]++;
                }
            }

            for (int i = 0; i < n - 1; i++) {
                if ((msk >> i) & 1) continue;

                int a = rb[i][0], b = rb[i][1], c = rb[i][2];
                if (s[a][cn[a]] + s[b][cn[b]] >= c) used[msk + (1 << i)] = msk;
            }
        }


        if (used[(1 << (n - 1)) - 1] == -1) {
            cout << "No\n";
            return;
        }

        int msk = (1 << (n - 1)) - 1;
        vector<int> ans;
        while (msk != 0) {
            int pr = used[msk];
            for (int i = 0; i < n - 1; i++) {
                if (((pr >> i) & 1) != ((msk >> i) & 1)) {
                    ans.pb(i + 1);
                    break;
                }
            }

            //cout << msk << " ";
            msk = pr;
        }
        //cout << "\n";

        assert(sz(ans) == n - 1);

        cout << "Yes\n";
        reverse(all(ans));
        cout << ans;

        return;
    }
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double time = clock();
#endif

    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "---------------\n";
#endif
    }
#ifdef LOCAL
    cout << "time:" << (clock() - time) / CLOCKS_PER_SEC << "\n";
#endif
}