#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
istream& operator >>(istream& in, pair<T, T1> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T, typename T1>
ostream& operator <<(ostream& out, pair<T, T1> &arr) {
    for (auto i : arr) out << i << " ";
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<T> &arr) {
    for (auto i : arr) out << i << " ";
    return out;
}

vector<vector<int>> p2;
vector<int> u2, a2;

void rec(int x) {
    u2[x] = 1;
    if (sz(p2[x]) == 0) {
        a2.pb(x);
        return;
    }
    
    for (auto i : p2[x]) {
        if (!u2[x]) rec(x);
    }
    a2.pb(x);
}

void solve() {
    int n, grup; cin >> n >> grup;

    if (grup <= 1) {
        vector<vector<int>> rb;
        vector<int> cnt(n);
        for (int i = 0; i < n - 1; i++) {
            int a, b, c; cin >> a >> b >> c;
            a--; b--;
            rb.pb({a, b, c});

            cnt[a]++, cnt[b]++;
        }

        vector<vector<int>> s(n);
        for (int i = 0; i < n; i++) {
            s[i].rs(cnt[i]);
            cin >> s[i];

            reverse(all(s[i]));
        }

        vector<int> used(1 << n, -1);
        used[0] = -2;
        for (int msk = 0; msk < (1LL << (n - 1)); msk++) {
            if (used[msk] == -1) continue;

            vector<int> cn(n);
            for (int i = 0; i < n - 1; i++) {
                if ((msk >> i) & 1) {
                    cn[rb[i][0]]++; cn[rb[i][1]]++;
                }
            }

            for (int i = 0; i < n - 1; i++) {
                if ((msk >> i) & 1) continue;

                int a = rb[i][0], b = rb[i][1], c = rb[i][2];
                if (s[a][cn[a]] + s[b][cn[b]] >= c) used[msk + (1 << i)] = msk;
            }
        }


        if (used[(1 << (n - 1)) - 1] == -1) {
            cout << "No\n";
            return;
        }

        int msk = (1 << (n - 1)) - 1;
        vector<int> ans;
        while (msk != 0) {
            int pr = used[msk];
            for (int i = 0; i < n - 1; i++) {
                if (((pr >> i) & 1) != ((msk >> i) & 1)) {
                    ans.pb(i + 1);
                    break;
                }
            }

            //cout << msk << " ";
            msk = pr;
        }
        //cout << "\n";

        //assert(sz(ans) == n - 1);

        cout << "Yes\n";
        reverse(all(ans));
        cout << ans;

        return;
    }
    if (grup == 2) {
        vector<int> vp(n), nz(n);

        for (int i = 0; i < n - 1; i++) {
            int a, b, c; cin >> a >> b >> c;
            vp[i] = c;
            nz[i + 1] = c;
        }

        vector<vector<int>> s(n);
        for (int i = 1; i < n - 1; i++) {
            s[i].rs(2);
            cin >> s[i];
        }
        s[0].rs(1); cin >> s[0];
        s[n - 1].rs(1); cin >> s[n - 1];

        p2.rs(n); u2.rs(n);
        for (int i = 0; i < n; i++) { 
            if (s[i + 1][0] < s[i + 1][1]) {
                if (s[i + 1][0] + s[i][0] >= vp[i]) {
                    p2[i + 1].pb(i);
                    swap(s[i + 1][0], s[i + 1][1]);
                } else if (s[i + 1][1] + s[i][0] >= vp[i]) {
                    p2[i].pb(i + 1);
                } else {
                    cout << "No\n";
                    return;
                }
            } else {
                if (s[i + 1][1] + s[i][0] >= vp[i]) {
                    p2[i].pb(i + 1);
                } else if (s[i + 1][0] + s[i][0] >= vp[i]) {
                    p2[i + 1].pb(i);
                    swap(s[i + 1][0], s[i + 1][1]);
                } else {
                    cout << "No\n";
                    return;
                }
            }
        }
        
        for (int i = 0; i < n - 1; i++) {
            if (!u2[i]) rec(i);
        }
        
        cout << "Yes\n" << a2;
        return;

    }
    if (grup == 3) {
        vector<int> c(n);
        for (int i = 0; i < n - 1; i++) {
            int a, b; cin >> a >> b >> c[i];
        }
        vector<int> s(n - 1);
        cin >> s;

        vector<int> vr(n - 1); cin >> vr;

        set<pii> s1;
        for (int i = 0; i < n - 1; i++) s1.insert({s[i], i});

        vector<int> ans(n - 1);
        for (int i = 0; i < n - 1; i++) {
            int a = c[i] - vr[i];
            auto cur = s1.lower_bound({a, -1});

            if (cur == s1.end()) {
                cout << "No\n";
                return;
            }

            ans[(*cur).ss] = i + 1;
            s1.erase(cur);
        }
        reverse(all(ans));
        cout << "Yes\n" << ans;
        return;
    }
    if (grup == 4) {
        vector<int> c(n), vb(n);
        int cn1 = 0, cn2 = 1;
        for (int i = 0; i < n - 1; i++) {
            int a, b; cin >> a >> b >> c[i];

            if (a == 1) {
                vb[b - 1] = 1;
                cn1++;
            } else {
                vb[b - 1] = 2;
                cn2++;
            }
        }
        vector<int> s1(cn1), s2(cn2);
        cin >> s1 >> s2;

        vector<int> vr(n - 2); cin >> vr;

        set<pii> st1, st2;
        for (int i = 0; i < cn1; i++) st1.insert({s1[i], i});
        for (int i = 0; i < cn2; i++) st2.insert({s2[i], i});

        //cout << s1 << "\n" << s2 << "\n" << vr << "\n\n";

        vector<int> a1(n - 1), a2(n - 1);
        for (int i = 2; i < n; i++) {
            if (vb[i] == 1) {
                int a = c[i - 1] - vr[i - 2];
                auto cur = st1.lower_bound({a, -1});

                if (cur == st1.end()) {
                    cout << "No\n";
                    return;
                }

                a1[(*cur).ss] = i;
                st1.erase(cur);
            }
            if (vb[i] == 2) {
                int a = c[i - 1] - vr[i - 2];
                auto cur = st2.lower_bound({a, -1});

                if (cur == st2.end()) {
                    cout << "No\n";
                    return;
                }

                a2[(*cur).ss] = i;
                st2.erase(cur);
            }
        }

        auto a = *st1.begin(), b = *st2.begin();

        if (a.ff + b.ff < c[0]) {
            cout << "No\n";
            return;
        }

        vector<int> ans;
        for (int i = 0; i < a.ss; i++) ans.pb(a1[i]);
        for (int i = 0; i < b.ss; i++) ans.pb(a2[i]);
        ans.pb(1);
        for (int i = a.ss + 1; i < cn1; i++) ans.pb(a1[i]);
        for (int i = b.ss + 1; i < cn2; i++) ans.pb(a2[i]);

        reverse(all(ans));
        cout << "Yes\n" << ans;
        return;
    }
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double time = clock();
#endif

    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "---------------\n";
#endif
    }
#ifdef LOCAL
    cout << "time:" << (clock() - time) / CLOCKS_PER_SEC << "\n";
#endif
}