#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

vector<int> ANS;

void fun(vector<int> &nab, set<int> &st, vector<vector<int>> &v, vector<vector<int>> &c)
{
    if(nab.size() == v.size())
    {
        vector<int> it(c.size());
        for(int i = 0; i < it.size(); ++i)
        {
            it[i] = c[i].size() - 1;
        }

        for(int i = 0; i < nab.size(); ++i)
        {
            int x = nab[i];
            int a = v[x][0];
            int b = v[x][1];
            int w = v[x][2];

            if(c[a][it[a]] + c[b][it[b]] < w)
            {
                return;
            }
            --it[a];
            --it[b];
        }

        ANS = nab;
        return;
    }

    set<int> buf = st;

    for(auto i : st)
    {
        buf.erase(i);
        nab.push_back(i);
        fun(nab, buf, v, c);
        nab.pop_back();
        buf.insert(i);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, g;

    cin >> n >> g;

    if(n <= 10)
    {
        vector<vector<int>> v(n-1);
        vector<int> deg(n);
        for(int i = 0; i < n-1; ++i)
        {
            int a, b, w;
            cin >> a >> b >> w;
            --a;
            --b;
            v[i] = {a, b, w};
            ++deg[a];
            ++deg[b];
        }
        vector<vector<int>> c(n);

        for(int i = 0; i < n; ++i)
        {
            c[i].resize(deg[i]);
            for(int j = 0; j < deg[i]; ++j)
            {
                cin >> c[i][j];
            }
        }

        set<int> st;
        for(int i = 0; i < n-1; ++i)
        {
            st.insert(i);
        }

        vector<int> buf;

        fun(buf, st, v, c);

        if(ANS.size() == 0)
        {
            cout << "No\n";
            return 0;
        }
        cout << "Yes\n";
        for(int i = 0; i < ANS.size(); ++i)
        {
            cout << ANS[i] + 1 << ' ';
        }
        cout << '\n';
        return 0;

    }

    if(g== 2)
    {
        vector<vector<int>> c(n);
        vector<int> w(n-1);
        vector<int> cnt(n-1);
        for(int i = 0; i < n -1; ++i)
        {
            int a, b;
            cin >> a >> b >> w[i];
        }

        c[0].resize(1);
        cin >> c[0][0];
        for(int i = 1; i < n-1; ++i)
        {
            c[i].resize(2);
            cin >> c[i][1] >> c[i][0];
        }
        c[n-1].resize(1);
        cin >> c[n-1][0];


        vector<bool> used(n-1);

        int pr = c[0][0];
        cnt[0] += 1;
        cnt.back() += 1;

        vector<int> pool;
        for(int i = 1; i < n-1; ++i)
        {
            if(c[i][0] <= c[i][1])
            {
                if(c[i][0] + pr >= w[i-1])
                {
                    cnt[i-1] += 1;
                    if(cnt[i-1] == 2)
                    {
                        pool.push_back(i-1);
                    }
                    pr = c[i][1];
                } else {
                    if(c[i][1] + pr < w[i-1])
                    {
                        cout << "No\n";
                        return 0;
                    }
                    cnt[i] += 1;
                    if(cnt[i] == 2)
                    {
                        pool.push_back(i);
                    }
                    pr = c[i][0];
                }
            } else {
                if(c[i][1] + pr >= w[i-1])
                {
                    cnt[i] += 1;
                    if(cnt[i] == 2)
                    {
                        pool.push_back(i);
                    }
                    pr = c[i][0];
                } else {
                    if(c[i][0] + pr < w[i-1])
                    {
                        cout << "No\n";
                        return 0;
                    }
                    cnt[i - 1] += 1;
                    if(cnt[i - 1] == 2)
                    {
                        pool.push_back(i - 1);
                    }
                    pr = c[i][1];
                }
            }
        }

        if(pr + c.back()[0] < w.back())
        {
            cout << "No\n";
            return 0;
        }

        while(pool.size() > 0)
        {
            ANS.push_back(pool.back());
            pool.pop_back();
            int x = ANS.back();

            if(x - 1>=0)
            {
                cnt[x-1] += 1;
                if(cnt[x-1] == 2)
                {
                    pool.push_back(x-1);
                }
            }

            if(x + 1 < n-1)
            {
                cnt[x + 1] += 1;
                if(cnt[x +1] == 2)
                {
                    pool.push_back(x + 1);
                }
            }
        }

        cout << "Yes\n";
        for(int i = 0; i < ANS.size(); ++i)
        {
            cout << ANS[i] + 1 << ' ';
        }
        cout << '\n';
        return 0;
    }


    vector<int> w(n-1);
    for(int i = 0; i < n-1; ++i)
    {
        int a, b;
        cin >> a >> b >> w[i];
    }

    vector<int> kek(n-1);
    for(int i = 0; i < n-1; ++i)
    {
        cin >> kek[i];
    }

    set<pair<int, int>> st;
    for(int i = 0; i < n-1; ++i)
    {
        int buf;
        cin >> buf;
        w[i] = buf - w[i];
        st.insert({w[i], i + 1});
    }

    
    while(kek.size() > 0)
    {
        int x = kek.back();
        kek.pop_back();
        auto buf = st.lower_bound({-x, -239});
        if(buf == st.end())
        {
            cout << "No\n";
            return 0;
        }
        ANS.push_back(buf->second);
        st.erase(buf);
    }

    cout << "Yes\n";

    for(int i = 0; i < ANS.size(); ++i)
    {
        cout << ANS[i] << ' ';
    }
    cout << '\n';


}

/*

4 3
1 2 3
1 3 3
1 4 
3
1 3 2
0 2 1

*/