#include <bits/stdc++.h>
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...) 52
#endif
using namespace std;

static constexpr int maxn = 300'000;

int w[maxn];
int from[maxn];
int to[maxn];

vector<pair<int, int>> g[maxn];

vector<int> c[maxn];
vector<int> d[maxn];

void dfs(int u, int p = -1) {
    for (auto &[v, i] : g[u]) {
        if (v == p) {
            continue;
        }

        if (g[v].size() != 1) {
            dfs(v, u);
        }

        int b = -1;

        for (int j = 0; j < (int)g[v].size(); j++) {
            if (d[v][j] == -1) {
                b = j;
                break;
            }
        }

        int a = -1;

        for (int j = 0; j < (int)g[u].size(); j++) {
            if (d[u][j] == -1 && c[u][j] + c[v][b] >= w[i]) {
                if (a == -1 || c[u][j] < c[u][a]) {
                    a = j;
                }
            }
        }

        if (a == -1) {
            cout << "No\n";
            exit(0);
        }

        d[u][a] = d[v][b] = i;
    }
}

vector<int> g2[maxn];
bool used2[maxn];

vector<int> ts;

void dfs2(int u) {
    used2[u] = true;
    for (int v : g2[u]) {
        if (!used2[v]) {
            dfs2(v);
        }
    }
    ts.push_back(u);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, group;
    cin >> n >> group;

    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v >> w[i];

        from[i] = u;
        to[i] = v;

        g[u].emplace_back(v, i);
        g[v].emplace_back(u, i);
    }

    for (int u = 1; u <= n; u++) {
        c[u].resize(g[u].size());
        d[u].resize(g[u].size(), -1);

        for (int &x : c[u]) {
            cin >> x;
        }
    }

    dfs(1);

    for (int u = 1; u <= n; u++) {
        for (int i = 0; i + 1 < (int)g[u].size(); i++) {
            g2[d[u][i]].push_back(d[u][i + 1]);
        }
    }

    cout << "Yes\n";

    for (int i = 0; i < n - 1; i++) {
        if (!used2[i]) {
            dfs2(i);
        }
    }

    for (int i : ts) {
        cout << i + 1 << ' ';
    }
    return 0;
}
