#include <bits/stdc++.h>
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...) 52
#endif
using namespace std;

static constexpr int maxn = 300'000;

int w[maxn];
int from[maxn];
int to[maxn];

vector<pair<int, int>> g[maxn];

vector<int> c[maxn];
set<pair<int, int>> c2[maxn];
vector<int> d[maxn];

void dfs(int u, int p = -1) {
    for (auto &[v, i] : g[u]) {
        if (v == p) {
            continue;
        }

        if (g[v].size() != 1) {
            dfs(v, u);
        }

        int b = c2[v].begin()->second;

        auto it = c2[u].lower_bound(pair(w[i] - c[v][b], 0));
        if (it == c2[u].end()) {
            cout << "No\n";
            exit(0);
        }

        int a = it->second;

        d[u][a] = d[v][b] = i;
        c2[v].erase(pair(c[v][b], b));
        c2[u].erase(pair(c[u][a], a));
    }
}

vector<int> g2[maxn];
bool used2[maxn];

vector<int> ts;

void dfs2(int u) {
    used2[u] = true;
    for (int v : g2[u]) {
        if (!used2[v]) {
            dfs2(v);
        }
    }
    ts.push_back(u);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, group;
    cin >> n >> group;

    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v >> w[i];

        from[i] = u;
        to[i] = v;

        g[u].emplace_back(v, i);
        g[v].emplace_back(u, i);
    }

    for (int u = 1; u <= n; u++) {
        c[u].resize(g[u].size());
        d[u].resize(g[u].size(), -1);

        for (int &x : c[u]) {
            cin >> x;
        }

        for (int i = 0; i < (int)c[u].size(); i++) {
            c2[u].emplace(c[u][i], i);
        }
    }

    dfs(1);

    for (int u = 1; u <= n; u++) {
        for (int i = 0; i + 1 < (int)g[u].size(); i++) {
            g2[d[u][i]].push_back(d[u][i + 1]);
        }
    }

    cout << "Yes\n";

    for (int i = 0; i < n - 1; i++) {
        if (!used2[i]) {
            dfs2(i);
        }
    }

    for (int i : ts) {
        cout << i + 1 << ' ';
    }
    return 0;
}
