#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = (int)2e5 + 5;

struct Edge {
    int v, w, num;
    Edge(int a, int b, int c) : v(a), w(b), num(c) {}
};

struct Point {
    int x, pos;
    Point(int a, int b) : x(a), pos(b) {}
};

vector<vector<Point>> a(MAXN);
vector<vector<Edge>> g(MAXN);

vector<int> dfs(int s, int p = -1) {
    for (auto i : g[s]) {
        if (i.v != p) {
            dfs(i.v, s);
        }
    }
    if (s != 0) {

    }
}

bool cmp(Point aaa, Point bbb) {
    return aaa.x < bbb.x;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, group;
    cin >> n >> group;
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].emplace_back(v, w, i + 1);
        g[v].emplace_back(u, w, i + 1);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            int x;
            cin >> x;
            a[i].emplace_back(x, j);
        }
    }
    vector<int> ans(n - 1);
    for (int i = 1; i < n; ++i) {
        int cnt = g[0][i].w;
        int x = a[i][0].x;
        int l = -1, r = a[0].size() - 1;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (x + a[0][mid].x >= cnt) {
                r = mid;
            } else {
                l = mid;
            }
        }
        ans[r] = g[0][i].num;
    }
    for (int i : ans) {
        cout << i + 1 << ' ';
    }
    return 0;
}
