#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
// #define int int64_t
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF = 1e9 + 117;

int n, gg;
vector<vector<pair<int, int>>> g;
vector<vector<int>> vals, svals;
vector<map<int, vector<int>>> gd;
vector<int> gow;
map<pair<int, int>, int> inds;

void upd(int i, int val, vector<int>& t) {
    for (; i < t.size(); i = (i | (i + 1))) t[i] += val;
}

int gtp(int i, vector<int>& t) {
    int res = 0;
    for (; i >= 0; i = (i & (i + 1)) - 1) res += t[i];
    return res;
}

void dfs_gow(int v, int p = -1) {
    vector<int> used(g[v].size(), 1);
    if (g[v].size() == 1) {
        gow[v] = vals[v].front();
        return;
    }
    vector<int> t(g[v].size() + 10, 0);
    for (auto& [e, w] : g[v]) {
        if (e == p) continue;
        dfs_gow(e, v);
        int ind = lower_bound(svals[v].begin(), svals[v].end(), w - gow[e]) - svals[v].begin();
        // ind = lower_bound(used.begin() + ind, used.end(), 0) - used.begin();
        // while (used[ind] == -1 && ind < used.size()) ind++;
        int l = ind - 1, r = used.size(), mid;
        while (r - l > 1) {
            mid = (l + r) / 2;
            if (gtp(mid, t) - gtp(ind - 1, t) == mid - ind + 1) l = mid;
            else r = mid;
        }
        ind = r;
        /*if (ind == used.size()) {
            cout << "No\n";
            exit(0);
        }*/
        if (gtp(mid, t) - gtp(ind - 1, t) == mid - ind + 1) {
            cout << "No\n";
            exit(0);
        }
        used[ind] = -1;
        upd(ind, 1, t);
        gd[v][svals[v][ind]].push_back(e);
    }
    for (int i = 0; i < g[v].size(); ++i) {
        if (used[i] == -1) continue;
        gow[v] = svals[v][i];
        break;
    }
}

vector<int> ans;

void draw(int v, int e) {
    int ind = 0;
    for (int i = 0; i < vals[e].size(); ++i) {
        int val = vals[e][i];
        if (gow[e] == val) {
            ind = i + 1;
            break;
        }
        int ee = gd[e][val].back();
        gd[e][val].pop_back();
        draw(e, ee);
    }

    ans.push_back(inds[{v, e}]);

    for (int i = ind; i < vals[e].size(); ++i) {
        int val = vals[e][i];
        int ee = gd[e][val].back();
        gd[e][val].pop_back();
        draw(e, ee);
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> gg;
    g.resize(n);
    vals.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w; cin >> u >> v >> w; --u; --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        inds[{u, v}] = i;
        inds[{v, u}] = i;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            int c; cin >> c;
            vals[i].push_back(c);
        }
    }
    if (n == 2) {
        if (g[0][0].second <= vals[0].front() + vals[1].front()) cout << "Yes\n1\n";
        else cout << "No\n";
        return 0;
    }
    svals = vals;
    for (auto& e : vals) reverse(e.begin(), e.end());
    for (auto& e : svals) sort(e.begin(), e.end());
    gow.resize(n);
    gd.resize(n);
    int root = 0;
    for (int i = 0; i < n; ++i) {
        if (g[i].size() > 1) {
            root = i;
            break;
        }
    }
    dfs_gow(root, -1);
    for (auto& val : vals[root]) {
        int e = gd[root][val].back();
        gd[root][val].pop_back();
        draw(root, e);
    }
    cout << "Yes\n";
    // reverse(ans.begin(), ans.end());
    for (auto& e : ans) cout << e + 1 << ' ';
    return 0;
}
