#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <algorithm>
#include <iomanip>
#include <random>
#include <deque>

using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

const ll MOD = 1e9 + 7;
const ll inf = 1e18;

mt19937 rnd(45);

void solve() {
	int n, g; cin >> n >> g;
	vector<int> u(n - 1), v(n - 1), used(n - 1, 0), w(n - 1);
	vector<int> CN(n, 0);
	for (int i = 0; i + 1 < n; ++i) {
		cin >> u[i] >> v[i] >> w[i]; --u[i]; --v[i];
		++CN[u[i]]; ++CN[v[i]];
	}
	vector<vector<int>> c(n);
	for (int i = 0; i < n; ++i) {
		int dg = CN[i];
		c[i].resize(dg);
		for (int j = 0; j < dg; ++j) {
			cin >> c[i][j];
		}
	}
	vector<int> ans;
	for (int i = 0; i + 1 < n; ++i) {
		int p = -1, mx = -1;
		for (int j = 0; j + 1 < n; ++j) {
			if (used[j]) {
				continue;
			}
			if (w[j] <= c[u[j]].back() + c[v[j]].back()) {
				if (w[j] > mx) {
					mx = w[j];
					p = j;
				}
			}
		}
		if (p == -1) {
			cout << "No\n";
			return;
		}
		ans.push_back(p);
		used[p] = 1;
		c[u[p]].pop_back();
		c[v[p]].pop_back();
	}
	cout << "Yes\n";
	for (int j : ans) {
		cout << j + 1 << ' ';
	}
	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}