#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//#define int long long
struct Edge {
    int u, v, w;
};

signed solve() {
    int n, g;
    cin >> n >> g;
    vector<int> gdeg(n);
    vector<Edge> edges(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        --edges[i].u;
        --edges[i].v;
        ++gdeg[edges[i].u];
        ++gdeg[edges[i].v];
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(gdeg[i]);
        for (int & j : c[i]) {
            cin >> j;
        }
        std::reverse(c[i].begin(), c[i].end());
    }
    if (g == 6) {
        vector<int> otvet;
        otvet.reserve(n - 1);
        vector<int> cur(n);
        vector<bool> used(n);
        for (int i = 0; i < n - 1; ++i) {
            int mins = 2e9 + 228;
            int opt = -1;
            for (int j = 0; j < n - 1; ++j) {
                if (!used[j]) {
                    int t = c[edges[j].u][cur[edges[j].u]] + c[edges[j].v][cur[edges[j].v]] - edges[j].w;
                    if ((opt == -1 || t < mins) && t >= 0) {
                        mins = t;
                        opt = j;
                    }
                }
            }
            if (opt == -1) {
                cout << "No\n";
                for (int now: otvet) {
                    cout << now << ' ';
                }
                return 0;
            }
            int j = opt;
            ++cur[edges[j].u];
            ++cur[edges[j].v];
            otvet.push_back(j + 1);
            used[j] = true;
        }
        cout << "Yes\n";
        for (int now: otvet) {
            cout << now << ' ';
        }
        cout << '\n';
    } else if (g == 1) {
        vector<int> perm;
        perm.resize(n - 1);
        std::iota(perm.begin(), perm.end(), 0);
        do {
//            vector<vector<int>> gc(n);
            bool ok = true;
            vector<int> cur(n, 0);
            for (int i = 0; i < n - 1; ++i) {
                int t = (c[edges[perm[i]].u][cur[edges[perm[i]].u]]) + (c[edges[perm[i]].v][cur[edges[perm[i]].v]]);
                cur[edges[perm[i]].v]++;
                cur[edges[perm[i]].u]++;

                if (t < edges[perm[i]].w) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                cout << "Yes\n";
                for (int now : perm) {
                    cout << now + 1 << ' ';
                }
                cout << '\n';
                return 0;
            }
        } while (next_permutation(perm.begin(), perm.end()));
        cout << "No\n";
    } else {
        vector<int> perm(n - 1);
        std::iota(perm.begin(), perm.end(), 1);
        std::sort(perm.begin(), perm.end(), [&](int u, int v) {
            return c[u][0] - edges[u - 1].w < c[v][0] - edges[v - 1].w;       
        });
        vector<int> perm2(n - 1);
        std::iota(perm2.begin(), perm2.end(), 0);
        std::sort(perm2.begin(), perm2.end(), [&](int u, int v) {
            return c[1][u] > c[1][v];
        });
        vector<int> res(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            res[perm2[i]] = perm[i];
        }
        perm = res;
        bool ok = true;
        vector<int> cur(n, 0);
        for (int i = 0; i < n - 1; ++i) {
            int t = (c[edges[perm[i]].u][cur[edges[perm[i]].u]]) + (c[edges[perm[i]].v][cur[edges[perm[i]].v]]);
            cur[edges[perm[i]].v]++;
            cur[edges[perm[i]].u]++;

            if (t < edges[perm[i]].w) {
                ok = false;
                break;
            }
        }
        if (ok) {
            cout << "Yes\n";
            for (int now : perm) {
                cout << now + 1 << ' ';
            }
            cout << '\n';
            return 0;
        }
        cout << "No\n";
    }
    return 0;
}

signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr)->sync_with_stdio(false);
    return solve();
}
