#include<bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 300031;

int deg[MAXN];

vector<int> ord[MAXN];
int ids[MAXN];

struct Edge{
    int a, b, w, id;
};

bool operator < (Edge a, Edge b){
    return a.id < b.id;
}

vector<Edge> edges;

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, g;
    cin >> n >> g;
    for(int i = 0; i < n-1; i++){
        int a, b, w;
        cin >> a >> b >> w;
        a--; b--;
        deg[a]++;
        deg[b]++;
        edges.push_back({a, b, w, i});
    }
    for(int i = 0; i < n; i++){
        for(int j = 0; j < deg[i]; j++){
            int x;
            cin >> x;
            ord[i].push_back(x);
        }
    }
    if(g <= 1){
        do{
            bool OK = 1;
            for(int i = 0; i < n; i++) ids[i] = 0;
            for(auto [a, b, w, id] : edges){
                //cerr << id << " " << ord[a][ids[a]] << " " << ord[b][ids[b]] << " " << w << " " << b << "\n";
                if(ord[a][ids[a]] + ord[b][ids[b]] < w){
                    OK = 0;
                    break;
                }
                ids[a]++;
                ids[b]++;
            }
            //cout << "\n";
            if(!OK) continue;
            vector<int> ans;
            for(auto [a, b, w, id] : edges){
                ans.push_back(id+1);
            }
            reverse(ans.begin(), ans.end());
            cout << "Yes\n";
            for(auto x : ans) cout << x << " ";
            return 0;
        } while(next_permutation(edges.begin(), edges.end()));
        cout << "No";
    }

}
