#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define sz(array) (int)array.size()
#define all(array) array.begin(), array.end()
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
struct quad{
    int x, y, w, us=0;
};
vector<int> ans;
bool try_c(vector<quad> &pot, vector<vector<int>> &used) {
    bool us = true;
    for (auto i : pot) {
        us = i.us;
        if (!us) break;
    }
    if (us) {
        return true;
    }
    for (int j = 0; j < sz(pot); ++j) {
        auto &i = pot[j];
        if (!i.us && used[i.x].back() + used[i.y].back() >= i.w) {
            i.us = 1;
            int k = used[i.x].back(), y = used[i.y].back();
            used[i.x].pop_back();
            used[i.y].pop_back();
            if (try_c(pot, used)) {
                ans.push_back(j+1);
                return true;
            }
            i.us = 0;
            used[i.x].push_back(k);
            used[i.y].push_back(y);
        }

    }
    return false;
}

void solve() {
    int n, ty;
    cin >> n >> ty;
    vector<quad> q;
    for (int i = 0; i < n-1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        q.push_back({--a, --b, w, 0});
    }
    vector<vector<int>> g(n);
    cin.get();
    for (int i = 0; i < n; ++i) {
        string now;

        while (true) {
            char x;
            cin.get(x);
            if (x == ' ') {
                g[i].push_back(stoi(now));
                now.clear();
            }
            else if (x == '\n') {
                g[i].push_back(stoi(now));
                break;
            }
            else now.push_back(x);
        }
        reverse(all(g[i]));
    }
    try_c(q, g);
    if (sz(ans) == 0) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    for (int i : ans) cout << i << ' ';
}

signed main() {
    int tc = 1;
    #ifdef LOCAL
        freopen("a.in", "r", stdin);
        cin >> tc;
    #endif
    while (tc--) {
        solve();
    }
    return 0;
}
