#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define pw(x) (1ll << x)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn (T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx (T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pii = pair < int , int >;

const int N = 1e6 + 5;
const int inf = 2e9;
const ll INF = 4e18;

int n, group;
int tp[N];
vector < array < int , 3 > > g[N];
vector < int > G[N];
set < pii > was[N];
vector < int > answer;
vector < pii > ans;
int nxt[N];
int prv[N];

bool have[N];
vector < array < int , 3 > > edge;

void dfs (int v, int p) {
    for (auto &to: g[v]) {
        if (to[0] != p) dfs(to[0], v);
    }

    ans.clear();
    for (auto [to, w, i]: g[v]) {
        if (to == p) continue;

        pii val = *was[to].begin();
        was[to].clear();

        auto it = was[v].lower_bound({w - val.fi, -1});
        if (it == was[v].end()) {
            cout << "No\n";
            exit(0);
        }

        edge.pb ({it->se, val.se, i});
        was[v].erase(it);
    }

    bool ok = true;
    while (ok) {
        ok = false;
        for (int ii = 0; ii < sz(edge); ++ ii) {
            int u = edge[ii][0];
            int v = edge[ii][1];
            int i = edge[ii][2];

            if (have[nxt[u]] && have[nxt[v]]) {
                ok = true;

                answer.pb (i);
                have[u] = have[v] = true;

                swap (edge[ii], edge.back());
                edge.pop_back();
                break;
            }
        }
    }

}

int main() {
#ifdef localy
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> group;
    for (int i = 1; i < n; ++ i) {
        int u, v, w;
        cin >> u >> v >> w;

        g[u].pb ({v, w, i});
        g[v].pb ({u, w, i});
    }

    int stn = 0;
    for (int i = 1; i <= n; ++ i) {

        for (int j = 1; j <= sz(g[i]); ++ j) {
            int x;
            cin >> x;

            ++ stn;

            if (j == 1) prv[stn] = 0;
            else prv[stn] = stn - 1;

            if (j == sz(g[i])) nxt[stn] = (int)1e6;
            else nxt[stn] = stn + 1;

            was[i].insert ({x, stn});
        }
    }

    have[(int)1e6] = true;

    dfs (1, 1);

    cout << "Yes\n";
    int last = answer.back();
    answer.pop_back();
    for (auto& it : answer) cout << it << " ";
    cout << last << "\n";

    return 0;
}
