#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define pw(x) (1ll << x)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn (T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx (T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pii = pair < int , int >;

const int N = 1e6 + 5;
const int inf = 2e9;
const ll INF = 4e18;

int n, group;
int tp[N];
vector < array < int , 3 > > g[N];
int par[N];
vector < int > G[N];
set < pii > was[N];
vector < int > answer;
vector < pii > ans;
int nxt[N];
int prv[N];

bool have[N];
queue < array < int , 3 > > q;

map < pii, int > mp;
bool used[N];
bool can[N];

void dfs (int v, int p) {
    for (auto &to: g[v]) {
        if (to[0] != p) dfs(to[0], v);
    }

    ans.clear();
    for (auto [to, w, i]: g[v]) {
        if (to == p) continue;

        pii val = *was[to].begin();
        was[to].clear();

        auto it = was[v].lower_bound({w - val.fi, -1});
        if (it == was[v].end()) {
            cout << "No\n";
            exit(0);
        }

        par[it->se] = val.se;
        par[val.se] = it->se;
        mp[{it->se, val.se}] = mp[{val.se, it->se}] = i;

        if (have[nxt[it->se]] && have[nxt[val.se]]) {
            can[it->se] = can[val.se] = true;
            q.push({it->se, val.se, i});
        }

        was[v].erase(it);
    }
}


int main() {
#ifdef localy
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> group;
    for (int i = 1; i < n; ++ i) {
        int u, v, w;
        cin >> u >> v >> w;

        g[u].pb ({v, w, i});
        g[v].pb ({u, w, i});
    }

    int stn = 0;
    for (int i = 1; i <= n; ++ i) {

        for (int j = 1; j <= sz(g[i]); ++ j) {
            int x;
            cin >> x;

            ++ stn;

            if (j == 1) prv[stn] = 0;
            else prv[stn] = stn - 1;

            if (j == sz(g[i])) nxt[stn] = (int)1e6;
            else nxt[stn] = stn + 1;

            was[i].insert ({x, stn});
        }
    }

    have[(int)1e6] = true;

    dfs (1, 1);

    while (!q.empty ()) {
        array < int , 3 > val = q.front();
        q.pop();

        answer.pb (val[2]);
        can[prv[val[0]]] = true;
        can[prv[val[1]]] = true;

        if (prv[val[0]] && can[par[val[0]]]) {
            val[0] = prv[val[0]];
            if (!used[mp[{val[0], par[val[0]]}]]) {
                used[mp[{val[0], par[val[0]]}]] = true;
                q.push({val[0], par[val[0]], mp[{val[0], par[val[0]]}]});
            }
        }

        if (prv[val[1]] && can[par[val[1]]]) {
            val[1] = prv[val[1]];
            if (!used[mp[{val[1], par[val[1]]}]]) {
                used[mp[{val[1], par[val[1]]}]] = true;
                q.push({val[1], par[val[1]], mp[{val[1], par[val[1]]}]});
            }
        }
    }


    cout << "Yes\n";
    int last = answer.back();
    answer.pop_back();
    for (auto& it : answer) cout << it << " ";
    cout << last << "\n";

    return 0;
}
