#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> ord, g, match, ed, nee;
vector<int> deg, need, now;
int flag = 1;

struct edge{
    int t, num, w;
};

vector <edge> edges;

bool cmp1(int x, int y) {
    return now[x] < now[y];
}

bool cmp2(int x, int y) {
    return need[x] < need[y];
}

int dfs(int cur, int prev) {
    vector <int> son, edg;
    for (auto x : g[cur]) {
        edge e = edges[x];
        int to = e.t, w = e.w;
        if (to == prev) continue;
        nee[cur].push_back(w - dfs(to, cur));
        son.push_back(to);
        edg.push_back(e.num);
    }
    vector <int> num1(deg[cur]), num2(nee[cur].size());
    for (int i = 0; i < deg[cur]; ++i) num1[i] = i;
    for (int i = 0; i < nee[cur].size(); ++i) num2[i] = i;
    for (auto x : ord[cur]) now.push_back(x);
    for (auto x : nee[cur]) need.push_back(x);
    sort(num1.begin(), num1.end(), cmp1);
    sort(num2.begin(), num2.end(), cmp2);
    int x = 0;
    int ind2 = 0, skip = 0;
    match[cur].resize(deg[cur], -1);
    ed[cur].resize(deg[cur], -1);
    for (int ind1 = 0; ind1 < deg[cur]; ++ind1) {
        if (ind2 < need.size() && need[num2[ind2]] <= now[num1[ind1]]) {
            match[cur][num1[ind1]] = son[num2[ind2]];
            ed[cur][num1[ind1]] = edg[num2[ind2]];
            ind2++;
        } else if (!skip && now.size() > need.size()) {
            skip = 1;
            x = now[num1[ind1]];
        } else {
            flag = 0;
        }
    }
    need.clear();
    now.clear();
    return x;
}

void print(int cur, int num) {
    for (int i = deg[cur] - 1; i >= 0; --i) {
        if (match[cur][i] == -1) cout << num << " ";
        else print(match[cur][i], ed[cur][i]);
    }
}

int main() {
    int n, t;
    cin >> n >> t;
    g.resize(n);
    ord.resize(n);
    deg.resize(n);
    nee.resize(n);
    for (int i = 1; i < n; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        g[a - 1].push_back((int)edges.size());
        edges.push_back({b - 1, i, w});
        g[b - 1].push_back((int)edges.size());
        edges.push_back({a - 1, i, w});
        deg[a - 1]++;
        deg[b - 1]++;
    }
    match.resize(n);
    ed.resize(n);
    for (int i = 0; i < n; ++i) {
        ord[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) cin >> ord[i][j];
    }
    dfs(0, -1);
    if (!flag) {
        cout << "No";
    } else {
        cout << "Yes\n";
        print(0, -1);
    }
    return 0;
}
/*
5 0
1 2 3
1 3 1
3 4 12
3 5 6
0 4
2
6 1 3
8
3


4 0
1 2 7
1 3 6
1 4 5
3 2 1
5
4
3


7 0
1 2 4
2 3 4
3 4 4
4 5 4
5 6 4
6 7 4
2
1 2
2 3
1 2
3 2
1 2
179

 */
