#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <iomanip>
#include <math.h>

using namespace std;

#define INF ((ll)1e18)
#define ll long long
#define db double
#define str string
#define vc vector
#define its(a) (a).begin(),(a).end()
#define itsr(a) (a).rbegin(),(a).rend()
#define sz(a) (a).size()
ll n;


void n10() {
	vc<vc<pair<ll, ll>>> g(n);
	vc<vc<ll>> cost(n, vc<ll>(n, -1));
	vc<pair<ll, ll>> lst;
	vc<ll> deg(n);
	for (int i = 0; i < n - 1; ++i) {
		ll u, v, w; cin >> u >> v >> w;
		--u, --v;
		deg[u]++, deg[v]++;
		lst.push_back({ u,v });
		cost[u][v] = w;
	}
	vc<vc<ll>> cst(n);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < deg[i]; ++j) {
			ll u; cin >> u;
			cst[i].push_back(u);
		}
	}

	vc<ll> p(n-1);
	for (int i = 0; i < n-1; ++i) p[i] = i;
	do {
		auto nlst = lst;
		auto ncst = cst;

		bool f = 1;
		for (int i = 0; i < n - 1; ++i) {
			auto [u, v] = lst[p[i]];
			if (cost[u][v] > ncst[u].back() + ncst[v].back()) {
				f = 0;
				break;
			}
			ncst[u].pop_back();
			ncst[v].pop_back();
		}
		if (f) {
			cout << "Yes\n";
			for (auto i : p) cout << i + 1 << ' ';
			return;
		}

	} while (next_permutation(its(p)));
	cout << "No";
}

void solve() {
	ll g; cin >> n >> g;
	if (g <= 1) n10();

}

int main()
{ 
	ios_base::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll _t = 1;
	//cin >> _t;
	while (_t--) solve();
}
