#include <bits/stdc++.h>

#define int int64_t
#define pii pair <int, int>
#define fi first
#define se second
#define pb push_back
#define TIME 1.0*clock()/CLOCKS_PER_SEC

using namespace std;

mt19937 gen(time(0));
const int INF = 1e18;

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, g;
    cin >> n >> g;
    int m = n - 1;
    vector <array <int, 4>> e(m);
    for (int i = 0; i < m; ++i) {
        cin >> e[i][0] >> e[i][1] >> e[i][2];
        e[i][0]--;
        e[i][1]--;
        e[i][3] = i;
    }
    vector <int> deg(n);
    for (auto to : e) {
        deg[to[0]]++;
        deg[to[1]]++;
    }
    vector <vector <int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            cin >> c[i][j];
        }
        reverse(c[i].begin(), c[i].end());
    }
    vector <vector <int>> have(n);
    for (int i = 0; i < n; ++i) {
        have[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            have[i][j] = c[i][j];
        }
        sort(have[i].rbegin(), have[i].rend());
    }
    if (g <= 1) {
        sort(e.begin(), e.end());
        int kol = 0;
        do {
            kol++;
            vector <vector <pii>> lol(n);
            for (int i = 0; i < m; ++i) {
                lol[e[i][0]].push_back({e[i][2], e[i][1]});
                lol[e[i][1]].push_back({e[i][2], e[i][0]});
            }
            bool ok = 1;
            for (int i = 0; i < n; ++i) {
                assert(lol[i].size() == deg[i]);
                for (int j = 0; j < deg[i]; ++j) {
                    int v = lol[i][j].se, cost = lol[i][j].fi;
                    int now = 0;
                    bool fnd = 0;
                    for (int id = 0; id < deg[v]; ++id) {
                        if (lol[v][id].se == i) {
                            now = c[v][id];
                            fnd = 1;
                            break;
                        }
                    }
                    assert(fnd == 1);
                    if (now + c[i][j] >= cost) {
                        continue;
                    }
                    ok = 0;
                    break;
                }
            }
            if (ok) {
                cout << "Yes" << endl;
                for (auto to : e) {
                    cout << to[3] + 1 << ' ';
                }
                exit(0);
            }
        } while (next_permutation(e.begin(), e.end()));
        cout << "No";
        exit(0);
    }
    if (g == 3) {
        for (int i = 0; i < m; ++i) {
            assert(e[i][0] == 0);
            e[i][2] -= c[e[i][1]][0];
        }
        sort(e.rbegin(), e.rend(), [&] (array <int, 4> A, array <int, 4> B) {
            return A[2] < B[2];
        });
        int uk = 0;
        bool can = 1;
        vector <int> ans(m);
        map <int, vector <int>> GO;
        assert(have[0].size() == m);
        for (auto to : have[0]) {
            if (to < e[uk][2]) {
                cout << "No";
                exit(0);
            }
            GO[to].pb(e[uk][3]);
            uk++;
        }
        cout << "Yes" << endl;
        for (int i = 0; i < m; ++i) {
            cout << GO[c[0][i]].back() + 1 << ' ';
            GO[c[0][i]].pop_back();
        }
        exit(0);
    }
    if (g <= 2) {
        vector <vector <int>> used(n, vector <int> (2, 0));
        for (int i = 0; i < m; ++i) {
            int nt = -1;
            for (int j = 0; j < deg[e[i][0]]; ++j) {
                if (!used[e[i][0]][j]) {
                    nt = j;
                    break;
                }
            }
            assert(nt != -1);
            int ps = -1;
            for (int j = 0; j < deg[e[i][1]]; ++j) {
                if (!used[e[i][1]][j] && c[e[i][1]][j] + c[e[i][0]][nt] >= e[i][2]) {
                    if (ps == -1 || c[e[i][1]][j] < c[e[i][1]][ps]) {
                        ps = j;
                    }
                }
            }
            if (ps == -1) {
                cout << "No";
                exit(0);
            }
            used[e[i][0]][nt] = e[i][3] + 1;
            used[e[i][1]][ps] = e[i][3] + 1;
        }
        cout << "Yes" << endl;
        vector <int> mt(m + 1, 0);
        vector <int> ans[2];
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < deg[i]; ++j) {
                if (!mt[used[i][j]]) {
                    mt[used[i][j]] = 1;
                    ans[j].pb(used[i][j]);
                }
            }
        }
        for (auto to : ans[0]) {
            cout << to << ' ';
        }
        for (auto to : ans[1]) {
            cout << to << ' ';
        }
        exit(0);
    }
}
