#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}
// графы(dfs bfs djikstra) дп конструктивы геома жадник
// линалг бинпоиск

#define int long long
#define endl '\n'
const int N = 2e5 + 10, INF = 2e15, MOD = 1e9 + 7;
struct Edge {
    int a, b, c;
};

vector<vector<int>> gr(N);
map<pair<int, int>, int> power, num;

void solve() {
    int n, g;
    cin >> n >> g;

    vector<Edge> e;
    for (int i = 0; i < n - 1; i++) {
        int a, b, v;
        cin >> a >> b >> v;
        a--;
        b--;
        power[{a, b}] = v;
        power[{b, a}] = v;
        num[{a, b}] = i + 1;
        num[{b, a}] = i + 1;
        gr[a].emplace_back(b);
        gr[b].emplace_back(a);
        e.push_back({a, b, v});
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(gr[i].size());
        for (int j = 0; j < gr[i].size(); j++) {
            cin >> c[i][j];
        }
    }
    if (g == 1 || g == 0) {
        vector<int> p(n - 1);
        iota(p.begin(), p.end(), 0);
        do {
            vector<vector<int>> nc = c;
            vector<int> pos(n, 0);
            bool err = false;
            for (int i = 0; i < n - 1; i++) {
                if (nc[e[p[i]].a].back() + nc[e[p[i]].b].back() < e[p[i]].c) {
                    err = true;
                    break;
                }
                nc[e[p[i]].a].pop_back();
                nc[e[p[i]].b].pop_back();
            }
            if (!err) {
                cout << "Yes" << endl;
                for (auto c: p) {
                    cout << c + 1 << " ";
                }
                cout << endl;
                return;
            }
        } while (next_permutation(p.begin(), p.end()));
        cout << "No" << endl;
    } else if (g == 2) {
        int pos = 0;
        vector<int> ans;
        int cur = 0;
        map<int, int> q;
        for (int i = 0; i < n - 1; i++) {
            int mval = c[i][cur];
            int nval = power[{i, i + 1}];
            if (c[i + 1].size() == 1) {
                if (mval + c[i + 1][0] < nval) {
                    cout << "No" << endl;
                    return;
                }
                ans.push_back(i + 1);
                int v = i + 1;
                while (q.count(v)) {
                    ans.push_back(q[v]);
                    int lv = v;
                    v = q[v];
                    q.erase(lv);
                }
                break;
            }
            if (mval + c[i + 1][0] >= nval && mval + c[i + 1][1] >= nval) {
                if (c[i + 1][0] > c[i + 1][1]) {
                    ans.push_back(i + 1);
                    int v = i + 1;
                    while (q.count(v)) {
                        ans.push_back(q[v]);
                        int lv = v;
                        v = q[v];
                        q.erase(lv);
                    }
                    cur = 0;
                } else {
                    q[i + 2] = i + 1;
                    cur = 1;
                }
            } else if (mval + c[i + 1][0] >= nval) {
                q[i + 2] = i + 1;
                cur = 1;
            } else if (mval + c[i + 1][1] >= nval) {
                ans.push_back(i + 1);
                int v = i + 1;
                while (q.count(v)) {
                    ans.push_back(q[v]);
                    int lv = v;
                    v = q[v];
                    q.erase(lv);
                }
                cur = 0;
            } else {
                cout << "No" << endl;
                return;
            }
        }
        cout << "Yes" << endl;
        for (auto c: ans) {
            cout << c << " ";
        }
        cout << endl;
    } else if (g == 3) {
        vector<pair<int, int>> cval;
        for (int i = 0; i < c[0].size(); i++) {
            cval.emplace_back(c[0][i], i);
        }
        vector<pair<int, int>> can;
        sort(cval.begin(), cval.end());
        for (int i = 1; i < n; i++) {
            int it = (lower_bound(cval.begin(), cval.end(), make_pair(power[{0, i}] - c[i][0], 0ll)) - cval.begin());
            if (it >= cval.size()) {
                cout << "No" << endl;
                return;
            }
            can.emplace_back(it, i);
        }
        sort(can.rbegin(), can.rend());
        vector<int> cur(n - 1);
        int cpos = cval.size() - 1;
        for (int i = 0; i < can.size(); i++) {
            if (cpos < can[i].first) {
                cout << "No" << endl;
                return;
            }
            cur[cpos] = can[i].second;
            cpos--;
        }
        cout << "Yes" << endl;
        for (auto c: cur) {
            cout << c << " ";
        }
        cout << endl;
    }
}