#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)x.size()
#define all(x) (x).begin(),(x).end()

using ll = long long;
const int N = 2e5 + 5;

vector<pair<int, pair<int, ll>>>gr[N];

vector<ll>c[N];
vector<int>ord[N];
vector<int>us[N];
vector<int>ordc[N];
int p[N];
ll pw[N];
int inv[N];
int pe[N];
ll dp[N];

bool check(int v, int forb){
    multiset<pair<int, ll>>q;
    for(int i =0; i < sz(c[v]); i++){
        if(i != forb)
            q.insert({c[v][i], i});
    }
    for(int i : ordc[v]){
        auto it = q.lower_bound({pw[i], -1});
        if(it == q.end())
            return false;
        inv[i] = it->second;
        q.erase(it);
    }
    return true;
}

void dfs(int v){
    dp[v] = -1;
    // delete root
    if(v != 0){
        for(int i =0; i < sz(gr[v]); i++){
            if(gr[v][i].first == p[v]){
                swap(gr[v][i], gr[v][sz(gr[v]) - 1]);
                break;
            }
        }
        gr[v].pop_back();
    }
    //

    for(auto [u, w] : gr[v]){
        ordc[v].push_back(u);
        p[u] = v;
        pe[u] = w.first;
        dfs(u);
        if(dp[u] == -1)
            return;
        pw[u] = w.second - c[u][dp[u]];
    }
    sort(all(ordc[v]), [&](int x, int y){
        return pw[x] < pw[y];
    });
    if(v == 0){
        if(check(v, -1))
            dp[v] = -2;
    }else{
       /* int l = -1;
        int r = sz(ord[v]);
        while(r - l > 1){
            int mid = (l + r) / 2;
            if(check(v, ord[v][mid]))
                r = mid;
            else
                l = mid;
        }
        if(r != sz(ord[v]))
            dp[v] = ord[v][r];*/
        for(int I : ord[v]){
            if(check(v, I)){
                dp[v] = I;
                return;
            }
        }
    }
}

vector<int>ans;
queue<int>Q;
int used[N];

bool cond(int v){
    return used[v] == 0 && sz(c[v]) - 1 == dp[v] && sz(c[p[v]]) - 1 == inv[v];
}
void chk(int v){
    if(cond(v)){
        used[v] = 1;
        ans.push_back(pe[v] + 1);
        c[v].pop_back();
        c[p[v]].pop_back();
        ord[p[v]].pop_back();
        for(auto [u, w] : gr[v]){
            if(cond(u))
                Q.push(u);
        }
        if(v != 0 && p[v] != 0 && cond(p[v]))
            Q.push(p[v]);
        /*if(v != 0)
        for(auto [u, w] : gr[p[v]])
            if(cond(u))
                Q.push(u);
        */
       if(v != 0 && !ord[p[v]].empty() && cond(ord[p[v]].back()))
            Q.push(ord[p[v]].back());
    }
}

void solve(){
    int n, g;
    cin >> n >> g;

    for(int i =0; i < n - 1; i++){
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        gr[u].push_back({v, {i,w}});
        gr[v].push_back({u, {i,w}});
    }

    for(int i = 0; i < n; i++){
        c[i].resize(sz(gr[i]));
        for(ll& j : c[i])
            cin >> j;

        ord[i].resize(sz(gr[i]));
        iota(all(ord[i]), 0);
        sort(all(ord[i]), [&](int x, int y){
            return c[i][x] > c[i][y];
        });
    }

    dfs(0);

    if(dp[0] == -1) {
        cout << "No\n";
        return;
    }

    for(int i = 1; i < n; i++){
        Q.push(i);
    }

    for(int i =0; i < n; i++){
        sort(all(ord[i]), [](int x, int y){
            return inv[x] > inv[y];
        });
    }
    while(!Q.empty()){
        int v = Q.front();
        Q.pop();
        chk(v);
    }

    //assert(sz(ans) == n - 1);

    cout << "Yes\n";

    for(int i : ans){
        cout << i << ' ';
    }
    cout << '\n';

}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(0)->sync_with_stdio(false);
#endif
    solve();
    return 0;
}
