//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
typedef long long ll;
typedef long double ld;
#define all(a) (a).begin(), (a).end()
#define pii pair<ll, ll>

using namespace std;

int main() {
#ifdef ZVEREV
    freopen("inputf.in", "r", stdin);
    freopen("outputf.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << fixed << setprecision(64);
    int n, g; cin >> n >> g;
    //map<pii, pii> mp;
    vector<int> deg(n, 0);
    vector<tuple<ll, ll, ll>> edges;
    for (int i = 0; i < n-1; i++) {
        ll u, v, w; cin >> u >> v >> w;
        u--; v--;
        edges.push_back({u, v, w});
        deg[u]++;
        deg[v]++;
        //mp[{u, v}] = {w, i};
    }
    vector<deque<ll>> stick(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            ll x; cin >> x;
            stick[i].push_back(x);
        }
    }
    unordered_map<ll, bool> used;
    vector<ll> ans;
    for (int i = 0; i < n-1; i++) {
        ll u_ = -1;
        ll v_ = -1;
        ll razn = 1e9;
        ll ind = -1;
        for (int j = 0; j < n-1; j++) {
            int u = get<0>(edges[j]);
            int v = get<1>(edges[j]);
            ll w = get<2>(edges[j]);
            //cout << stick[u][0] + stick[v][0] - w << endl;
            if (!used[u * 1001 + v] && stick[u][0] + stick[v][0] - w < razn && razn >= 0) {
                u_ = u;
                v_ = v;
                razn = stick[u][0] + stick[v][0] - w;
                ind = j;
            }
        }
        if (u_ == -1) {
            break;
        }
        used[u_ * 1001 + v_] = true;
        stick[u_].pop_front();
        stick[v_].pop_front();
        ans.push_back(ind);
    }
    if (ans.size() == n-1) {
        cout << "Yes\n";
        for (auto i : ans) {
            cout << i + 1 << ' ';
        }
        return 0;
    }
    cout << "No";
}
