//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
typedef long long ll;
typedef long double ld;
#define all(a) (a).begin(), (a).end()
#define pii pair<ll, ll>

using namespace std;
const ll inf = 2e13;

int main() {
#ifdef ZVEREV
    freopen("inputf.in", "r", stdin);
    freopen("outputf.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << fixed << setprecision(64);
    int n, g; cin >> n >> g;
    map<pii, pii> mp;
    vector<int> deg(n, 0);
    vector<tuple<ll, ll, ll>> edges;
    for (int i = 0; i < n-1; i++) {
        ll u, v, w; cin >> u >> v >> w;
        u--; v--;
        edges.push_back({u, v, w});
        deg[u]++;
        deg[v]++;
        mp[{u, v}] = {w, i};
    }
    vector<deque<ll>> stick(n);
    bool flag = true;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            ll x; cin >> x;
            stick[i].push_back(x);
            if (j >= 1 && x != 0) {
                flag = false;
            }
        }
    }
    if (n <= 10) {
        vector<int> p(n-1); iota(all(p), 0);
        do {
            vector<int> point(n, 0);
            bool can = true;
            for (int i = 0; i < n-1; i++) {
                ll u = get<0>(edges[p[i]]);
                ll v = get<1>(edges[p[i]]);
                ll w = get<2>(edges[p[i]]);
                if (stick[u][point[u]] + stick[v][point[v]] >= w) {
                    point[u]++;
                    point[v]++;
                } else {
                    can = false;
                    break;
                }
            }
            if (can) {
                cout << "Yes\n";
                reverse(all(p));
                for (auto i : p) {
                    cout << i + 1 << ' ';
                }
                return 0;
            }
        } while (next_permutation(all(p)));
        cout << "No";
        return 0;
    }
//    vector<vector<ll>> dp(n, vector<ll>(2, false));
//    stick[0].push_front(-inf);
//    stick[n-1].push_front(-inf);
//    dp[0][1] = true;
//    for (int i = 1; i < n; i++) {
//        ll w = mp[{i-1, i}].first;
//        if (stick[i-1][0] + stick[i][0] >= w) {
//            dp[i][0] |= dp[i-1][1];
//        }
//        if (stick[i-1][1] + stick[i][0] >= w) {
//            dp[i][0] |= dp[i-1][0];
//        }
//        if (stick[i-1][0] + stick[i][1] >= w) {
//            dp[i][1] |= dp[i-1][1];
//        }
//        if (stick[i-1][1] + stick[i][1] >= w) {
//            dp[i][1] |= dp[i-1][0];
//        }
//    }
//    cout << dp[n-1][1];
    sort(all(edges), [](tuple<ll, ll, ll> a, tuple<ll, ll, ll> b){
        return get<2>(a) > get<2>(b);
    });
    vector<int> ans;
    unordered_map<ll, bool> ban;
    if (flag) {
        for (int it = 0; it < n - 1; it++) {
            for (int i = 0; i < n - 1; i++) {
                ll u = get<0>(edges[i]);
                ll v = get<1>(edges[i]);
                ll w = get<2>(edges[i]);
                if (!ban[u * 200000 + v] && stick[u].back() + stick[v].back() >= w) {
                    stick[u].pop_back();
                    stick[v].pop_back();
                    ans.push_back(mp[{u, v}].second);
                    ban[u * 200000 + v] = true;
                    break;
                }
            }
        }
        if (ans.size() != n - 1) {
            cout << "No";
            return 0;
        }
        cout << "Yes\n";
        //reverse(all(ans));
        for (auto i: ans) {
            cout << i + 1 << ' ';
        }
        return 0;
    }
    for (int it = 0; it < n - 1; it++) {
        for (int i = 0; i < n - 1; i++) {
            ll u = get<0>(edges[i]);
            ll v = get<1>(edges[i]);
            ll w = get<2>(edges[i]);
            if (!ban[u * 200000 + v] && stick[u][0] + stick[v][0] >= w) {
                stick[u].pop_front();
                stick[v].pop_front();
                ans.push_back(mp[{u, v}].second);
                ban[u * 200000 + v] = true;
                break;
            }
        }
    }
    if (ans.size() != n - 1) {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    reverse(all(ans));
    for (auto i: ans) {
        cout << i + 1 << ' ';
    }
}
