#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;
const int INF = 1e9;

struct edge {
	int a, b, w;
};
struct edge2 {
	int w, c1, c2, i;
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, g;
	cin >> n >> g;
	vector<edge> mas(n - 1);
	vector<int> deg(n, 0);
	for (int i = 0; i < n - 1; ++i) {
		cin >> mas[i].a >> mas[i].b >> mas[i].w;
		mas[i].a--; mas[i].b--;
		deg[mas[i].a]++;
		deg[mas[i].b]++;
	}
	vector<vector<int>> c(n);
	for (int i = 0; i < n; ++i) {
		c[i].resize(deg[i]);
		for (int j = 0; j < deg[i]; ++j)
			cin >> c[i][j];
	}
	if (n <= 10) {
		vector<int> posl(n - 1);
		for (int i = 0; i < n - 1; ++i)
			posl[i] = i;
		do {
			vector<int> cur_ind(n);
			for (int i = 0; i < n; ++i)
				cur_ind[i] = deg[i] - 1;
			bool flag = true;
			for (int i : posl) {
				int u = mas[i].a, v = mas[i].b, w = mas[i].w;
				if (c[u][cur_ind[u]] + c[v][cur_ind[v]] < w) {
					flag = false;
					break;
				}
				cur_ind[u]--; cur_ind[v]--;
			}
			if (flag) {
				cout << "Yes\n";
				for (int el : posl) cout << el + 1 << " ";
				return 0;
			}
		} while (next_permutation(posl.begin(), posl.end()));
		cout << "No";
	}
	else {
		vector<edge2> gr(n);
		for (int i = 0; i < n - 1; ++i) {
			int u = mas[i].b;
			gr[u].w = mas[i].w;
			gr[u].i = i;
		}
		set<pair<int, int>> se;
		for (int i = 1; i < n; ++i) {
			int w = gr[i].w;
			se.insert({ w - c[i][0], gr[i].i });
			//cout << "    " << w - c[i][0] << "\n";
		}
		vector<int> ans;
		for (int i = 0; i < deg[0]; ++i) {
			int curc = c[0][i];
			if (se.upper_bound({ curc, INF }) == se.begin()) {
				//cout << curc << "\n";
				cout << "No";
				return 0;
			}
			ans.push_back(prev(se.upper_bound({ curc, INF }))->second);
			se.erase(prev(se.upper_bound({ curc, INF })));
		}
		reverse(ans.begin(), ans.end());
		cout << "Yes\n";
		for (int el : ans)
			cout << el + 1 << " ";
	}

	return 0;
}