#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
//#pragma GCC optimize("trapv")
#endif
#include <bits/stdc++.h>

const int MAX_N = (int)3e5+10;
const int INT_INF = (int)2e9;
const double pi = acos(-1);


using namespace std;
using ld = long double;
using ll = long long;

struct Rebr{
    int a,b,w;
};
vector<vector<int>>stickers;
vector<Rebr>e;
vector<int>deg;
int n,g;

bool check_for_permut(vector<int> permut){
    vector<vector<int>>stick =stickers;
//    for(auto&c:stick){
//        reverse(c.begin(), c.end());
//    }
    for(int &c:permut) c--;
    for(int i = 0;i<n-1;++i){
        if(stick[e[permut[i]].a].back()+stick[e[permut[i]].b].back()<e[permut[i]].w){
            return false;
        }
        stick[e[permut[i]].a].pop_back();
        stick[e[permut[i]].b].pop_back();
    }
    return true;
}

void solve_for_1(){
    vector<int>per(n-1);
    for(int i = 1;i<n;++i){
        per[i-1] = i;
    }
    while(true){
        if(check_for_permut(per)){
            cout<<"Yes\n";
            for(int i = 0;i<n-1;++i){
                cout<<per[i]<<" ";
            }
            return;
        }
         if(!next_permutation(per.begin(), per.end())){
            break;
        }
    }
    cout<<"No";
}

void input(){
    cin>>n>>g;
    stickers.resize(n+1);
    e.resize(n-1);
    deg.resize(n+1);
    for(int i = 0;i<n-1;++i){
        cin>>e[i].a>>e[i].b>>e[i].w;
        deg[e[i].a]++;
        deg[e[i].b]++;
    }
    for(int i = 1;i<=n;++i){
        int k = deg[i];
        stickers[i].resize(k);
        for(int j = 0;j<k;++j){
            cin>>stickers[i][j];
        }
    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
    input();
    solve_for_1();
    return 0;
}
