#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <algorithm>
#include <deque>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
//#define int ll

using namespace std;

mt19937 rnd(0);

vector<vector<int>> g;

void solve() {
    int n, group;
    cin >> n >> group;
    g.resize(n);
    vector<tuple<int, int, int>> ul(n - 1);
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
        ul[i] = { u, v, w };
    }
    vector<vector<int>> c(n);
    vector<vector<bool>> dp(n);
    vector<vector<int>> pre(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
        reverse(all(c[i]));
        dp[i].resize(2);
        pre[i].resize(2);
    }
    dp[0][1] = 1;
    for (int i = 1; i < n; i++) {
        for (int last = 0; last < c[i].size(); last++) {
            for (int pr = 0; pr < c[i - 1].size(); pr++) {
                if (dp[i - 1][1 - pr] && c[i - 1][pr] + c[i][last] >= get<2>(ul[i - 1])) {
                    dp[i][last] = 1;
                    pre[i][last] = pr;
                }
            }
        }
    }
    if (dp[n - 1][0]) {
        cout << "Yes\n";
        vector<int> ans;
        vector<int> last(n);
        for (int i = n - 1; i > 0; i--) {
            last[i - 1] = 1 - pre[i][last[i]];
        }
        for (int i = 1; i < n; i++) {
            if (last[i] == 0 && pre[i][last[i]] == 0) {
                ans.push_back(i);
            }
        }
        for (int i = 1; i < n; i++) {
            if (last[i] == 0 && pre[i][last[i]] == 1) {
                ans.push_back(i);
            }
        }
        for (int i = n - 1; i > 0; i--) {
            if (last[i] == 1 && pre[i][last[i]] == 0) {
                ans.push_back(i);
            }
        }
        for (int i = 1; i < n; i++) {
            if (last[i] && pre[i][last[i]]) {
                ans.push_back(i);
            }
        }
        for (auto i : ans) {
            cout << i << ' ';
        }
    }
    else {
        cout << "No";
    }
}


signed main() {
    cout.setf(ios_base::fixed);
    cout << fixed << std::setprecision(12);
    ios_base::sync_with_stdio(false);
    cin.tie(0);


#ifdef LOCAL
    auto f = freopen("input.txt", "r", stdin);
    auto f1 = freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}