#ifndef LOCAL
#pragma GCC optimize("03")
#pragma GCC optimize("O3")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ld = long double;
using dd = double;
using uint = unsigned int;
using i128 = __int128;

#define int ll


int gen(deque<int> v, int alice = 0, int bob = 0) {
    if (v.empty())
        return 0;
    deque<int> d1 = v, d2 = v;
    d1.pop_front();
    d2.pop_back();
    if (alice <= bob) {
        int a = v[0] + gen(d1, v[0], bob - alice);
        int b = v.back() + gen(d2, v.back(), bob - alice);
        return max(a, b);
    }
    int a = gen(d1, alice - bob, v[0]);
    int b = gen(d2, alice - bob, v.back());
    return min(a, b);
}

void solve() {
    int n;
    cin >> n;
    cout << "No\n";
    for (int i = 1; i < n; ++i) cout << i << " ";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(4);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin>>t;
    while (t--) solve();
}
