#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using db = long double;

void test_case() {
    int n, g;
    cin >> n >> g;
    vector<pair<pair<int, int>, int>> edges(n - 1);
    vector<vector<int>> ids(n);
    vector<int> deg(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        deg[u]++;
        deg[v]++;
        edges[i] = {{u, v}, w};
        ids[u].push_back(i);
        ids[v].push_back(i);
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> c[i][j];
        }
    }
    if (g == 0 || g == 1) {
        vector<int> cur;
        bool found = false;
        auto rec = [&](auto self, int used) -> void {
            // cout << bitset<20>(used) << endl;
            if ((int)cur.size() == n - 1) {
                vector<int> pos = deg;
                bool f = true;
                for (int i = 0; i < n - 1; i++) {
                    auto [u, v] = edges[cur[i]].first;
                    int w = edges[cur[i]].second;
                    if (c[u][pos[u] - 1] + c[v][pos[v] - 1] < w) {
                        f = false;
                        break;
                    } else {
                        pos[u]--;
                        pos[v]--;
                    }
                }
                if (f) {
                    found = true;
                }
            } else {
                for (int i = 0; i < n - 1; i++) {
                    if ((used & (1 << i)) == 0) {
                        cur.push_back(i);
                        self(self, used | (1 << i));
                        if (found) return;
                        cur.pop_back();
                    }
                }
            }
        };
        rec(rec, 0);
        // reverse(cur.begin(), cur.end());
        if (!found) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            for (int i = 0; i < n - 1; i++) {
                cout << cur[i] + 1 << ' ';
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int tests = 1;
    // cin >> tests;
    while (tests--) {
        test_case();
    }
    return 0;
}
