// clang-format off
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pii;
typedef vector<ll> d1;
typedef vector<d1> d2;
typedef vector<pii> d1p;
typedef vector<d1p> d2p;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

ostream& operator<<(ostream&cout, const pii&a){cout<<a.first<<","<<a.second;return cout;}
pii min(const pii &a, const pii &b){if(a.first<b.first) return a;else return b;}
pii max(const pii &a, const pii &b){if(a.first>b.first) return a;else return b;}
template<typename T> T min(vector<T> &a){return *min_element(a.begin(), a.end());}
template<typename T> T max(vector<T> &a){return *max_element(a.begin(), a.end());}
template<typename T> T sum(vector<T>&a){T m=0;for(T&i:a)m+=i;return m;}
template<typename T> void print(vector<T>&a){for(T&i:a)cout<<i<<" ";cout<<"\n";}
template<typename T> void print(vector<vector<T>>&a){for(vector<T>&i:a)print(i);}

#define stuff ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define fori(x, n) for(ll i = x; i < n; ++i)
#define forj(x, n) for(ll j = x; j < n; ++j)
#define fork(x, n) for(ll k = x; k < n; ++k)
#define foru(p, t) for(ll i = p; i < t.size(); i+=i&-i)
#define ford(r, t) for(ll i = r; i > 0; i-=i&-i)
#define all(a) a.begin(), a.end()
#define sort(a) sort(all(a))
#define reverse(a) reverse(all(a))
#define unique(a) a.erase(unique(all(a)), a.end());
#define wt ll _t; cin>>_t; while(_t--)
#define __lg(x) 63ll - __builtin_clzll(x)
#define pb push_back
#define pob pop_back
#define endl "\n"
#define F first
#define S second
#define B back()

signed main(){
    stuff;
    ll n, _g;
    cin >> n >> _g;
    d2 edges(n-1);
    fori(0, n-1){
        ll a, b, w;
        cin >> a >> b >> w;
        a--; b--;
        if(a > b) swap(a, b);
        edges[i] = {a, b, w};
    }
    d2 c(n);
    string s;
    getline(cin, s);
    fori(0, n){
        getline(cin, s);
        string tmp;
        for(char j:s){
            if(j == ' '){
                c[i].pb(stoi(tmp));
                tmp = "";
            }
            else{
                tmp+=j;
            }
        }
        if(tmp != "") c[i].pb(stoi(tmp));
        reverse(c[i]);
    }
    if(_g <= 1){
        d1 p;
        fori(0, n-1){
            p.pb(i);
        }
        do {
            d1 sz(n, 0);
            ll f = 1;
            fori(0, n-1){
                f&=c[edges[p[i]][0]][sz[edges[p[i]][0]]++]+c[edges[p[i]][1]][sz[edges[p[i]][1]]++] >= edges[p[i]][2];
            }
            if(f){
                cout << "Yes" << endl;
                for(ll i:p){
                    cout << i+1 << " ";
                }
                return 0;
            }
        } while(next_permutation(all(p)));
        cout << "No";
    }
    else if(_g == 2){

    }
    else if(_g == 3){
        set<pii> st;
        fori(0, n-1){
            st.insert({c[0][i], i});
        }
        d1 res(n-1);
        fori(0, n-1){
            if(st.lower_bound({edges[i][2]-c[edges[i][1]][0], -1}) != st.end()){
                pii x = *st.lower_bound({edges[i][2]-c[edges[i][1]][0], -1});
                res[x.S] = i+1;
                st.erase(x);
            }
            else{
                cout << "No";
                return 0;
            }
        }
        cout << "Yes" << endl;
        print(res);
    }
    else if(_g == 4){
        vector<set<pii>> st(2);
        fori(0, c[0].size()){
            st[0].insert({c[0][i], i});
        }
        fori(0, c[1].size()){
            st[1].insert({c[1][i], c[0].size()+i});
        }
        d1 res(n-1);
        ll M_EDGE = 0;
        fori(0, n-1){
            if(edges[i][0] == 0 and edges[i][1] == 1){
                M_EDGE = i;
                continue;
            }
            if(edges[i][0] == 0){
                if(st[0].lower_bound({edges[i][2]-c[edges[i][1]][0], -1}) != st[0].end()){
                    pii x = *st[0].lower_bound({edges[i][2]-c[edges[i][1]][0], -1});
                    res[x.S] = i+1;
                    st[0].erase(x);
                }
                else{
                    cout << "No";
                    return 0;
                }
            }
            else{
                if(st[1].lower_bound({edges[i][2]-c[edges[i][1]][0], -1}) != st[1].end()){
                    pii x = *st[1].lower_bound({edges[i][2]-c[edges[i][1]][0], -1});
                    res[x.S] = i+1;
                    st[1].erase(x);
                }
                else{
                    cout << "No";
                    return 0;
                }
            }
        }
        if(st[0].begin()->F+st[1].begin()->S >= edges[M_EDGE][2]){
            res[st[0].begin()->S] = M_EDGE+1;
        }
        cout << "Yes" << endl;
        print(res);
    }
}
