#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = 210000;

int ww[N];
bool used[N];
map<pair<int, int>, int> mp;
vector<pair<int, int>> g[N], c[N];
vector<int> gg[N];

bool check(vector<pair<int, int>> &ws, vector<pair<int, int>> &nc) {
	for (int i = 0; i < (int) ws.size(); i++)
		if (ws[i].first > nc[i].first)
			return false;
	return true;
}

int dfs(int v, int p = -1) {
	int pos = -1;
	for (int i = 0; i < (int) g[v].size(); i++)
		if (g[v][i].first == p)
			pos = i;
	if (pos != -1)
		swap(g[v][0], g[v][pos]);
	vector<pair<int, int>> ws;
	for (auto &[u, w] : g[v]) if (u != p) {
		w -= dfs(u, v);
		ws.push_back({w, u});
	}
	sort(begin(ws), end(ws));
	sort(begin(c[v]), end(c[v]));
	if (p == -1) {
		if (check(ws, c[v])) {
			for (int i = 0; i < (int) c[v].size(); i++)
				ww[c[v][i].second] = ws[i].second;
			for (int i = 0; i + 1 < (int) c[v].size(); i++)
				gg[mp[{v, ww[i]}]].push_back(mp[{v, ww[i + 1]}]);
			return -1;
		}
	} else {
		int i = -1;
		for (int u = 20; u >= 0; u--) {
			int ni = i + (1 << u);
			if (ni >= (int) c[v].size()) continue;
			vector<pair<int, int>> nc;
			for (int j = 0; j < (int) c[v].size(); j++) if (j != ni)
				nc.push_back(c[v][j]);
			if (check(ws, nc)) i = ni;
		}
		vector<pair<int, int>> nc;
		for (int j = 0; j < (int) c[v].size(); j++) if (j != i)
			nc.push_back(c[v][j]);
		if (check(ws, nc)) {
			for (int i = 0; i < (int) nc.size(); i++)
				ww[nc[i].second] = ws[i].second;
			ww[c[v][i].second] = p;
			for (int i = 0; i + 1 < (int) c[v].size(); i++)
				gg[mp[{v, ww[i]}]].push_back(mp[{v, ww[i + 1]}]);
			return c[v][i].first;
		}
	}
	cout << "No";
	exit(0);
}

void getans(int v) {
	used[v] = true;
	for (int u : gg[v])
		if (!used[u])
			getans(u);
	cout << v << ' ';
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
	int n, group; cin >> n >> group;
	for (int i = 1; i <= n - 1; i++) {
		int a, b, w; cin >> a >> b >> w;
		g[a].push_back({b, w});
		g[b].push_back({a, w});
		mp[{a, b}] = mp[{b, a}] = i;
	}
	for (int i = 1; i <= n; i++)
	for (int j = 0; j < (int) g[i].size(); j++) {
		int x; cin >> x;
		c[i].push_back({x, j});
	}
	dfs(1);
	cout << "Yes\n";
	for (int i = 1; i <= n - 1; i++)
		if (!used[i])
			getans(i);
}
