#include<bits/stdc++.h>

using namespace std;

#define ll long long 
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

const int N = 2e5 + 10;
vector<array<int, 3>> g[N];
vector<pair<int, int>> c[N];
vector<vector<int>> ind(N);

int dfs(int v, int p = -1) {
	if (g[v].size() == 1) {
		return 0;
	}
	vector<array<int, 4>> arr;
	for (auto [u, w, ind] : g[v]) {
		if (u != p) {
			int pos = dfs(u, v);
			arr.pb({w - c[u][pos].first, u, c[u][pos].second, ind});
		}
	}
	sort(all(arr));
	if (p != -1) {
		int l = -1, r = c[v].size(); 
		while (r - l > 1) {
			int mid = (r + l) / 2, j = 0;
			bool good = 1;
			for (int i = 0; i < c[v].size(); i++) {
				if (i == mid) {
					continue;
				}
				good &= arr[j][0] <= c[v][i].first;
				ind[v][c[v][i].second] = ind[arr[j][1]][arr[j][2]] = arr[j][3];
				j++;
			}
			if (good) {
				l = mid;
			} else {
				r = mid;
			}
		}
		if (l == -1) {
			cout << "No\n";
			exit(0);
		} else {
			return l;
		}
	} else {
		bool good = 1;
		for (int i = 0; i < c[v].size(); i++) {
			good &= arr[i][0] <= c[v][i].first;
			ind[v][c[v][i].second] = ind[arr[i][1]][arr[i][2]] = arr[i][3];
		}
		if (!good) {
			cout << "No\n";
			exit(0);
		}
		return -1;
	}
}

signed main () {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, group;
	cin >> n >> group;
	for (int i = 0; i < n - 1; i++) {
		int a, b, w;
		cin >> a >> b >> w;
		a--, b--;
		g[a].pb({b, w, i});
		g[b].pb({a, w, i});
	}
	for (int i = 0; i < n; i++) {
		c[i].resize(g[i].size());
		ind[i].resize(g[i].size());
		for (int j = 0; j < g[i].size(); j++) {
			cin >> c[i][j].first;
			c[i][j].second = j;
		}
		sort(all(c[i]));
	}
	int u = -1;
	for (int v = 0; v < n; v++) {
		if (g[v].size() >= 2) {
			u = v;
			break;
		}
	}
	if (u == -1) {
		if (g[0].back()[1] <= c[0][0].first + c[1][0].first) {
			cout << "Yes\n" << 1 << endl;
		} else {
			cout << "No\n";
		}
	} else { 
		dfs(u);
		vector<int> cur_pos(n);
		map<int, vector<int>> mas;
		deque<int> q;
		for (int i = 0; i < n; i++) {
			mas[ind[i][0]].pb(i);
			if (mas[ind[i][0]].size() == 2) {
				q.pb(ind[i][0]);
			}
		}
		vector<int> ans;
		while (q.size() > 0) {
			int j = q.front();
			q.pop_front();
			ans.pb(j + 1);
			for (int i : mas[j]) {
				cur_pos[i]++;
				if (cur_pos[i] < ind[i].size()) {
					int val = ind[i][cur_pos[i]];
					mas[val].pb(i);
					if (mas[val].size() == 2) {
						q.pb(val);
					}
				}
			}
		}
		reverse(all(ans));
		cout << "Yes\n";
		for (int i : ans) {
			cout << i << ' ';
		}
		cout << endl;
	}
	return 0;
}