#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
#define all(a) a.begin(), a.end()

struct edge {
    int u = 0, v = 0, w = 0;
};

int n, group;
vector<vector<pii>> g;
vector<vector<int>> c;
vector<edge> edges;
vector<int> order;
vector<int> usedEd, ptr;

void gen(int sz) {
    if (sz == n - 1) {
        for (int i = 0; i < n; ++i) {
            ptr[i] = c[i].size() - 1;
        }
        vector<int> ans;
        vector<bool> used(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            int mx = -1;
            if (edges[order[i]].w <= c[edges[order[i]].u][ptr[edges[order[i]].u]] + c[edges[order[i]].v][ptr[edges[order[i]].v]]) {
                    if (mx == -1 || edges[order[i]].w > edges[mx].w) mx = order[i];
                }
            if (mx == -1) {
                return;
            }
            ans.push_back(mx);
            used[mx] = true;
            --ptr[edges[mx].u];
            --ptr[edges[mx].v];
        }
        cout << "Yes\n";
        reverse(all(ans));
        for (auto el : ans) {
            cout << el + 1 << " ";
        }
        exit(0);
    }
    for (int i = 0; i < n - 1; ++i) {
        if (!usedEd[i]) {
            usedEd[i] = true;
            order.push_back(i);
            gen(sz + 1);
            order.pop_back();
            usedEd[i] = false;
        }
    }
}

void sub1() {
    usedEd.resize(n - 1);
    ptr.resize(n);
    gen(0);
    cout << "No\n";
    exit(0);
}

void sub2() {
    vector<vector<int>> dp(n, vector<int>(2));
}

void sub3() {
    vector<int> id(n);
    for (int i = 0; i < n - 1; ++i) {
        id[edges[i].v] = i;
    }
    order.resize(n);
    for (int i = 0; i < n; ++i) {
        order[i] = i;
    }
    sort(all(order), [&c](int u, int v) {
         if (u == 0) return true;
         if (v == 0) return false;
         return c[u][0] > c[v][0];
    });
    vector<int> ans;
    for (int i = 1; i < n; ++i) {
        if (edges[id[order[i]]].w > c[0].back() + c[order[i]].back()) {
            cout << "No";
            exit(0);
        }
        ans.push_back(id[order[i]]);
        c[0].pop_back();
    }
    cout << "Yes\n";
    reverse(all(ans));
    for (auto el : ans) {
        cout << el + 1 << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> group;
    g.resize(n);
    edges.resize(n - 1);
    c.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        --edges[i].u, --edges[i].v;
        g[edges[i].u].push_back({edges[i].v, edges[i].w});
        g[edges[i].v].push_back({edges[i].u, edges[i].w});
    }
    for (int i = 0; i < n; ++i) {
        c[i].resize(g[i].size());
        for (int j = 0; j < g[i].size(); ++j) {
            cin >> c[i][j];
        }
        reverse(all(c[i]));
    }
    if (group == 1) {
        sub1();
    }
    if (group == 3) {
        sub1();
    }
    vector<int> ans;
    vector<bool> used(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int mx = -1;
        for (int j = 0; j < n - 1; ++j) if (!used[j]) {
            if (edges[j].w <= c[edges[j].u].back() + c[edges[j].v].back()) {
                if (mx == -1 || edges[j].w > edges[mx].w) mx = j;
            }
        }
        if (mx == -1) {
            cout << "No\n";
            exit(0);
        }
        ans.push_back(mx);
        used[mx] = true;
        c[edges[mx].u].pop_back();
        c[edges[mx].v].pop_back();
    }
    cout << "Yes\n";
    reverse(all(ans));
    for (auto el : ans) {
        cout << el + 1 << " ";
    }
}
