#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

void solve() {
    int n, gr;
    cin >> n >> gr;
    struct edge {
        int v, u, w, i;
    };
    vector<edge> rb;
    vector<int> sz(n);
    for (int i = 1; i < n; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        --v, --u;
        rb.push_back({v, u, w, i});
        ++sz[v], ++sz[u];
    }
    sort(rb.rbegin(), rb.rend(), [&](edge& f, edge& s) {
        return f.w < s.w;
    });
    vector<multiset<int>> c(n);
    vector<vector<int>> lst(n);
    for (int v = 0; v < n; ++v) {
        for (int it = 0; it < sz[v]; ++it) {
            int x;
            cin >> x;
            c[v].insert(x);
            lst[v].push_back(x);
        }
    }
    vector<vector<int>> can;
    vector<int> used(n);
    for (auto& [v, u, w, id] : rb) {
        int bv = inf, bu = inf;
        for (auto& x : c[v]) {
            for (auto& y : c[u]) {
                if (x + y >= w && x + y < bv + bu) {
                    bv = x, bu = y;
                }
            }
        }
        if (bv == inf) {
            cout << "No\n";
            return;
        }
        c[v].erase(c[v].find(bv));
        c[u].erase(c[u].find(bu));
        can.push_back({v, u, bv, bu, id});
    }
    int cnt = 0;
    vector<int> res;
    while (cnt < n - 1) {
        for (int i = 0; i < n - 1; ++i) {
            if (used[i]) continue;
            int v = can[i][0];
            int u = can[i][1];
            int bv = can[i][2];
            int bu = can[i][3];
            if (lst[v].back() == bv && lst[u].back() == bu) {
                res.push_back(can[i][4]);
                used[i] = 1;
                lst[v].pop_back();
                lst[u].pop_back();
                ++cnt;
            }
        }
    }
    cout << "Yes\n";
    for (auto& x : res) cout << x << ' ';
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
