#include<bits/stdc++.h>

#define pii pair < int, int >
#define pb push_back
#define F first
#define S second
#define ins insert
#define int long long

using namespace std;


const int N = 2e3+ 10;
const int B = 50;


int n, group;

vector < pii > g[N];
int sz[N], s[N];
vector < int > c[N];



struct edge {
    int x, y, w;
    edge() {}
    edge(int x_, int y_, int w_) {
        x = x_, y = y_, w = w_;
    }
};

edge e[N];


bool check(vector < int > &p) {
          for(int i = 1; i <= n; i++) s[i] = sz[i] - 1;

              bool ok = 1;
              for(auto to : p) {
                  int i = e[to].x, j = e[to].y;

                  if(c[i][s[i]] + c[j][s[j]] < e[to].w) ok = 0;
                  s[i]--, s[j]--;
              }
              return ok;
}

void solve1() {
     vector < int > p;

        for(int i = 1; i <= n - 1; i++) p.pb(i);

        do {


              if(check(p)) {
                cout << "Yes" << endl;
                for(auto to : p) cout << to << ' ';
                return;
              }
        }
        while(next_permutation(p.begin(), p.end()));

        cout << "No";
        return;
}

void solve() {

     cin >> n >> group;

     for(int i = 1; i < n; i++) {
         int x, y, w;
         cin >> x >> y >> w;

         e[i] = edge(x, y, w);

         g[x].pb({y, w});
         g[y].pb({x, w});

         sz[x]++, sz[y]++;
     }



     for(int i = 1; i <= n; i++) {
         for(int j = 0; j < sz[i]; j++) {
             int x;
             cin >> x;

             c[i].pb(x);
         }
     }

     if(n <= 10) {
        solve1();
        return;
     }

     if(group == 5) {
        vector < int > p;
        for(int i = 1; i < n; i++) p.pb(i);

        sort(p.begin(), p.end(),
             [](const int &i, const int &j) {return e[i].w > e[j].w;});
        if(check(p)) {
            cout << "Yes" << endl;
            for(auto to : p) cout << to << ' ';
        }
        else cout << "No";
        return;


     }







}
int32_t main() {


//    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
//    #else
//
//    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    solve();

    return 0;
}

