#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef int ll;
typedef long double ld;

const ll inf = 1e9;

vector<vector<vector<ll>>> g;
vector<ll> was;
vector<vector<ll>> k1;
vector<set<ll>> k;
vector<ll> ans1;
vector<ll> p;
vector<vector<ll>> v2;
vector<vector<ll>> v3;
map<pair<ll, ll>, vector<ll>> mapa;

ll dfs(ll v) {
    was[v] = 1;
    ll col = 0;
    vector<ll> res3(k[v].size(), -1);
    vector<ll> res4(k[v].size(), -1);
    for(int i = 0; i < g[v].size(); i++) {
        if (was[g[v][i][0]] == 0) {
            p[g[v][i][0]] = g[v][i][2];
            col++;
            ll res1 = dfs(g[v][i][0]);
            ll need = g[v][i][1] - res1;
            auto it = lower_bound(k[v].begin(), k[v].end(), need);
            if (it == k[v].end()) {
                cout << "No";
                exit(0);
            }
            ll a1 = *it;
            k[v].erase(a1);
            res3[mapa[{v, a1}].back()] = g[v][i][0];
            res4[mapa[{v, a1}].back()] = g[v][i][2];
            mapa[{v, a1}].pop_back();
        }
    }
    v2[v] = res3;
    v3[v] = res4;
    return (*k[v].begin());
}

void dfs1(ll v, ll ind) {
    was[v] = 1;
    ll ok = 0;
    for(int i = 0; i < v2[v].size(); i++) {
        if (v2[v][i] == -1) {
            ok = 1;
            ans1.push_back(ind);
            continue;
        }
        if (was[v2[v][i]] == 0) {
            dfs1(v2[v][i], v3[v][i]);
        }
    }
    if (!ok && ind != -1) ans1.push_back(ind);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, g1; cin >> n >> g1;
    g.resize(n);
    was.resize(n);
    p.resize(n);
    v2.resize(n);
    v3.resize(n);
    for(int i = 0 ; i < n - 1; i++) {
        ll a, b, c; cin >> a >> b >> c;
        a--; b--;
        g[a].push_back({b, c, i});
        g[b].push_back({a, c, i});
    }
    k.resize(n);
    for(int i = 0; i < n; i++) {
        ll col = g[i].size();
        for(int j = 0; j < col; j++) {
            ll y1; cin >> y1;
            k[i].insert(y1);
            mapa[{i, y1}].push_back(col - j - 1);
        }
    }
    dfs(0);
    fill(was.begin(), was.end(), 0);
    dfs1(0, -1);
    cout << "Yes\n";
    for(ll el : ans1) {
        cout << el + 1 << " ";
    }
    return 0;
}
