#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n, G;
  cin >> n >> G;
  vector<int> x(n - 1), y(n - 1), z(n - 1);
  vector<int> deg(n);
  for (int i = 0; i < n - 1; ++i) {
    cin >> x[i] >> y[i] >> z[i];
    --x[i], --y[i];
    deg[x[i]] += 1;
    deg[y[i]] += 1;
  }
  vector<vector<int>> c(n);
  for (int i = 0 ; i < n; ++i) {
    c[i].resize(deg[i]);
    for (int j = 0; j < deg[i]; ++j) {
      cin >> c[i][j];
    }
    reverse(c[i].begin(), c[i].end());
  }
  vector<int> order(n - 1);
  iota(order.begin(), order.end(), 0);
  do {
    vector<int> ptr(n);
    bool ok = true;
    for (int i : order) {
      if (c[x[i]][ptr[x[i]]] + c[y[i]][ptr[y[i]]] < z[i]) {
        ok = false;
        break;
      }
      ptr[x[i]] += 1;
      ptr[y[i]] += 1;
    }
    if (ok) {
      cout << "Yes\n";
      for (int i : order) {
        cout << i + 1 << ' ';
      }
      return;
    }
  } while (next_permutation(order.begin(), order.end()));
  cout << "No";
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
