#include <bits/stdc++.h>
using namespace std;
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
using ll = long long;
using ld = long double;
#define int long long
vector<vector<pair<int, int>>>graph;
vector<vector<int>>c;
struct Edge{
    int a, b, w, i;
    Edge(int a, int b, int w, int i) : a(a), b(b), w(w), i(i) {};
    Edge() = default;
};
vector<int>up;
vector<deque<int>>otl;
vector<Edge>edges;
deque<int>ans;
void dfs(int start, int p){
    int sum_w = 0; vector<pair<int, int>>fc; int o = 0;
    for(auto [to, val]: graph[start]){
        if(to == p) {o = edges[val].i; continue;}
        dfs(to, start); sum_w += edges[val].w; sum_w -= up[to];
        fc.push_back({edges[val].w - up[to], edges[val].i});
    }
    if(p != -1 && graph[start].size() == 1){
        up[start] = c[start][0]; return;
    }
    if(p != -1){
        int sum = 0;
        for(int i = 0; i < c[start].size(); i++){
            sum += c[start][i];
        }
        int ind = -1;
        for(int i = 0; i < c[start].size(); i++){
            if(sum - c[start][i] == sum_w){
                ind = i;
            }
        }
        if(ind == -1){
            cout << "No"; exit(0);
        }
        up[start] = c[start][ind];
        vector<pair<int, int>>nc; int d = 0;
        for(int i = 0; i < c[start].size(); i++){
            if(i != ind) nc.push_back({c[start][i], i});
        }
        sort(nc.begin(), nc.end());
        sort(fc.begin(), fc.end());
        vector<int>s((int)c[start].size());
        for(int i = 0; i < nc.size(); i++){
            if(fc[i].first <= nc[i].first){
                s[(int)c[start].size() - 1 - nc[i].second] = fc[i].second;
            }else{
                cout << "No"; exit(0);
            }
        }
        for(int i = 0; i < (int)c[start].size() - ind - 1; i++){
            ans.push_back(s[i] + 1);
            while(!otl[s[i]].empty()){
                ans.push_back(otl[s[i]].front() + 1); otl[s[i]].pop_front();
            }
        }
        for(int i = (int)c[start].size() - ind; i < c[start].size(); i++){
            otl[o].push_back(s[i]);
        }
        return;
    }else{
        vector<pair<int, int>>nc;
        for(int i = 0; i < c[start].size(); i++){
            nc.emplace_back(c[start][i], i);
        }
        sort(nc.begin(), nc.end());
        sort(fc.begin(), fc.end());
        vector<int>s(c[start].size());
        for(int i = 0; i < c[start].size(); i++){
            if(fc[i].first <= nc[i].first){
                s[(int)c[start].size() - 1 - nc[i].second] = fc[i].second;
            }else{
                cout << "No"; exit(0);
            }
        }
        for(int i = 0; i < c[start].size(); i++){
            ans.push_back(s[i] + 1);
            while(!otl[s[i]].empty()){
                ans.push_back(otl[s[i]].front() + 1); otl[s[i]].pop_front();
            }
        }
    }
}
signed main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int n, g; cin >> n >> g; graph.resize(n); c.resize(n);
    vector<int>deg(n); otl.resize(n);
    for(int i = 0; i < n - 1; i++){
        int a, b, w; cin >> a >> b >> w; a--; b--;
        deg[a]++; deg[b]++;
        graph[a].push_back({b, i}); graph[b].push_back({a, i});
        edges.emplace_back(a, b, w, i);
    }
    for(int i = 0; i < n; i++){
        c[i].resize(deg[i]);
        for(int j = 0; j < deg[i]; j++) cin >> c[i][j];
    }
    if(g == 0 || g == 1){
        vector<int>ind;
        for(int i = 0; i < n - 1; i++) ind.push_back(i);
        do{
            vector<int>num(n);
            for(int i = 0; i < n; i++) num[i] = (int)c[i].size() - 1;
            bool good = true;
            for(auto val: ind){
                auto e = edges[val];
                if(e.w > c[e.a][num[e.a]] + c[e.b][num[e.b]]){
                    good = false; break;
                }else{
                    num[e.a]--; num[e.b]--;
                }
            }
            if(good){
                cout << "Yes\n";
                for(auto val: ind) cout << val + 1 << " ";
                return 0;
            }
        }while(next_permutation(ind.begin(), ind.end()));
        cout << "No";
        return 0;
    }
    if(g == 2){
        vector<vector<bool>>pref(n, vector<bool>(2));
        vector<vector<int>>pred(n, vector<int>(2, 0));
        pref[1][0] = (c[0][0] + c[1][0] >= edges[0].w);
        pref[1][1] = (c[0][0] + c[1][1] >= edges[0].w);
        for(int i = 2; i < n; i++){
            auto e = edges[i - 1];
            for(int j = 0; j < c[i].size(); j++){
                for(int z = 0; z < 2; z++){
                    bool yes = ((c[i][j] + c[i - 1][z]) >= e.w) & pref[i - 1][1 - z];
                    if(yes) {
                        pref[i][j] = yes; pred[i][j] = z;
                    }
                }
            }
        }
        if(pref[n - 1][0]){
            int i = n - 2; int j = 1 - pred[n - 1][0];
            deque<int>stack; int cur = n - 2;
            vector<int>ind(n - 1);
            while(i >= 0){
                if(j == 0) {stack.push_back(i);}
                else if(j == 1 || i == 0){
                    stack.push_back(i);
                    while(!stack.empty()){
                        ind[cur--] = stack.back(); stack.pop_back();
                    }
                }
                j = 1 - pred[i][j]; i--;
            }
            cout << "Yes\n";
            for(auto val: ind) cout << val + 1 << " ";
        }else{
            cout << "No"; return 0;
        }
        return 0;
    }
    if(g == 3){
        vector<pair<int, int>>fs;
        for(int i = 1; i < n; i++){
            fs.push_back({edges[i - 1].w - c[i][0], i - 1});
        }
        sort(fs.begin(), fs.end());
        vector<pair<int, int>>nc;
        for(int i = 0; i < n - 1; i++){
            nc.push_back({c[0][i], i});
        }
        sort(nc.begin(), nc.end());
        vector<int>ind(n - 1);
        for(int i = 0; i < fs.size(); i++){
            if(fs[i].first <= nc[i].first){
                ind[n - 2 - nc[i].second] = fs[i].second;
            }else{
                cout << "No"; return 0;
            }
        }
        cout << "Yes\n";
        for(auto val: ind) cout << val + 1 << " ";
        return 0;
    }
    if(g == 7){
        up.resize(n);
        dfs(0, -1);
        cout << "Yes\n";
        for(auto val: ans) cout << val << " ";
        vector<int>num(n);
        for(int i = 0; i < n; i++) num[i] = (int)c[i].size() - 1;
        bool good = true;
        for(auto val: ans){
            auto e = edges[val];
            if(e.w > c[e.a][num[e.a]] + c[e.b][num[e.b]]){
                good = false; break;
            }else{
                num[e.a]--; num[e.b]--;
            }
        }
        if(!good) return 1;
    }
    return 0;
}
