//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()

//#include <bits/extc++.h>
//using namespace __gnu_pbds;
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

mt19937_64 rd(chrono::steady_clock::now().time_since_epoch().count());

const int K = 30, MAXN = 2e5 + 1, INF = 1e18;

vector<int> g1[MAXN];
int used[MAXN] = {0};
vector<int> path;

void dfs(int u) {
    used[u] = 1;
    for (auto it: g1[u]) {
        if (used[it]) continue;
        dfs(it);
    }
    path.pb(u);
}

void solve() {
    int n, group;
    cin >> n >> group;
    vector<int> us(n - 1), vs(n - 1), ws(n - 1);
    vector<set<int>> g(n);
    vector<set<pair<int, int>>> degree(n);
    vector<vector<int>> ind(n);
    vector<int> deg(n);
    deque<int> q;
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u;--v;
        g[u].insert(i);
        g[v].insert(i);
        deg[u]++;
        deg[v]++;
        us[i] = u;
        vs[i] = v;
        ws[i] = w;
    }
    for (int i = 0; i < n; ++i) {
        ind[i].assign(deg[i], 0);
        for (int j = 0; j < deg[i]; ++j) {
            int t;
            cin >> t;
            degree[i].insert({t, j});
        }
        if (deg[i] == 1) q.pb(i);
    }
    while (!q.empty()) {
        int vertex = q[0], index = *g[vertex].begin(), u = us[index], v = vs[index], w = ws[index];
        q.pop_front();
        if (deg[vertex] == 0) continue;
        g[u].erase(index);
        g[v].erase(index);
        deg[u]--;
        deg[v]--;
        if (deg[u] == 1) q.pb(u);
        if (deg[v] == 1) q.pb(v);
        if (deg[v] == 0) swap(u, v);
        auto [a, b] = *degree[u].begin();
        degree[u].erase({a, b});
        ind[u][b] = index;
        if (degree[v].lower_bound({w - a, -INF}) == degree[v].end()) {
            cout << "No\n";
            return;
        }
        auto [a1, b1] = *degree[v].lower_bound({w - a, -INF});
        degree[v].erase({a1, b1});
        ind[v][b1] = index;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < ind[i].size() - 1; ++j) {
            g1[ind[i][j]].pb(ind[i][j + 1]);
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        if (used[i]) continue;
        dfs(i);
    }
    cout << "Yes\n";
    for (auto it: path) cout << it + 1 << " ";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
//    cin >> T;
    while (T--)
        solve();
}
