 #include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

using namespace __gnu_pbds;

template < typename T >
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
bool umx(T& a, T b) {
    return (a < b ? a = b, 1 : 0);
}

template<typename T>
bool umn(T& a, T b) {
    return (a > b ? a = b, 1 : 0);
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int N = 3e5 + 222;
const int mod = 1e9 + 7;

int n, g;
vector<vector<int>> ve;
int w[40][40];
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> g;
    vector<int> k(n + 1);

    if (g == 3) {
        set<array<ll,2>> st;
        vector<pair<ll,int>> weight(n + 1);
        for (int i = 0; i < n - 1; ++i) {
            int u, v, W;
            cin >> u >> v >> W;
            if (g == 3 && (u != 1 || v != i + 2)) assert(0);
            weight[v] = {W, i + 1};
            k[u]++, k[v]++;
        }
        vector<int> c;
        for (int i = 1; i <= n; ++i) {
            if (i == 1) {
                for (int j = 0; j < k[i]; ++j) {
                    int x;
                    cin >> x;
                    c.push_back(x);
                }
            }
            else {
                int x;
                cin >> x;
                st.insert({weight[i].first - x, weight[i].second});
            }
        }
        vector<int> ord;
        while ((int)st.size()) {
            auto it = st.lower_bound({c.back(), (int)-1e9});
            if (it == st.end()) {
                asset(0);
                cout << "No\n";
                exit(0);
            }
            ord.push_back((*it)[1]);
            st.erase(it);
            c.pop_back();
        }
        cout << "Yes\n";
        for (auto to : ord) cout << to << ' ';
        cout << '\n';
        return 0;
    }
    vector<pair<int,int>> edges;
    for (int i = 0; i < n - 1; ++i) {
        int u, v, W;
        cin >> u >> v >> W;
        w[u][v] = W;
        k[u]++, k[v]++;
        edges.push_back({u, v});
    }
    ve.resize(n + 1);
    for (int i = 1; i <= n; ++i) {
        ve[i].resize(k[i]);
        for (int j = 0; j < k[i]; ++j) cin >> ve[i][j];
    }
    vector<int> p(n - 1);
    iota(begin(p), end(p), 0);
    do {
        bool bad = 0;
        vector<vector<int>> last = ve;
        for (int i = 0; i < n - 1; ++i) {
            int u = edges[p[i]].first, v = edges[p[i]].second;
            int w1 = last[u].back(), w2 = last[v].back();
            last[u].pop_back(), last[v].pop_back();
            if (w1 + w2 < w[u][v]) {
                bad = 1;
                break;
            }
        }
        if (!bad) {
            cout << "Yes\n";
            for (auto to : p) cout << to + 1 << ' ';
            cout << endl;
            return 0;
        }
    } while (next_permutation(begin(p), end(p)));
    cout << "No\n";
    return 0;
}
