#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <deque>
#include <random>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e9 + 7;
const ll INFll = 1e18;
const ll M1 = 1e9 + 7, M2 = 1e9 + 9;
const ll P1 = 137, P2 = 239;
const ld PI = atan2(0, -1), EPS = 1e-10;

struct Node {
	int x, y, w;
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	//freopen("i.txt", "r", stdin), freopen("o.txt", "w", stdout);

	//cout << fixed << setprecision(20);

	int n, group;
	cin >> n >> group;
	vector<Node> e(n - 1);
	vector<int> deg(n);
	for (int i = 0; i < n - 1; ++i) {
		cin >> e[i].x >> e[i].y >> e[i].w;
		e[i].x--;
		e[i].y--;
		deg[e[i].x]++;
		deg[e[i].y]++;
	}
	vector<vector<int>> num(n);
	for (int i = 0; i < n; ++i) {
		num[i].resize(deg[i]);
		for (int j = 0; j < deg[i]; ++j) {
			cin >> num[i][j];
		}
		reverse(num[i].begin(), num[i].end());
	}
	if (group == 0 || group == 1) {
		vector<int> p(n - 1);
		for (int i = 0; i < n - 1; ++i) {
			p[i] = i;
		}
		do
		{
			vector<int> a(n, 0);
			bool f = true;
			for (auto i : p) {
				if (num[e[i].x][a[e[i].x]] + num[e[i].y][a[e[i].y]] < e[i].w) {
					f = false;
					break;
				}
				a[e[i].x]++;
				a[e[i].y]++;
			}
			if (f) {
				cout << "Yes" << '\n';
				for (auto i : p) {
					cout << i + 1 << " ";
				}
				return 0;
			}
		} while (next_permutation(p.begin(), p.end()));
		cout << "No";
		return 0;
	}
	if (group == 3) {
		vector<pair<int, int>> a(n - 1), b(n - 1);
		for (int i = 0; i < n - 1; ++i) {
			a[i].first = num[0][i];
			a[i].second = i;
			b[i].first = e[i].w - num[max(e[i].x, e[i].y)][0];
			b[i].second = i;
		}
		sort(a.begin(), a.end());
		sort(b.begin(), b.end());
		bool f = true;
		for (int i = 0; i < n - 1; ++i) {
			if (a[i] < b[i]) {
				f = false;
			}
		}
		if (f) {
			cout << "Yes" << '\n';
			vector<int> ans(n - 1);
			for (int i = 0; i < n - 1; ++i) {
				ans[a[i].second] = b[i].second + 1;
			}
			for (auto x : ans) {
				cout << x << " ";
			}
		}
		else {
			cout << "No";
		}
		return 0;
	}
	if (group == 2) {
		return 0;
	}
}