#include <bits/stdc++.h>

#define x first
#define y second

using namespace std;

using ll = long long;

mt19937_64 mt(100);

void solve();

int main() {
#ifndef LOCAL
	cin.tie(nullptr)->sync_with_stdio(false);
#endif
	cout << fixed << setprecision(30);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

const int N = 200200;
vector<int> g[N], to[N], c[N];
set<pair<int, int>> st[N];
map<pair<int, int>, int> ed, ind;

void dfs1(int s, int p = -1) {
	for (int i : g[s]) {
		if (i != p) {
			dfs1(i, s);
		}
	}
	if (p == -1) {
		return;
	}
	int hv = (*st[s].begin()).y;
	to[s][hv] = p;
	auto con1 = st[p].lower_bound({ed[{s, p}] - c[s][hv], -1});
	if (con1 == st[p].end()) {
		cout << "No\n";
		exit(0);
	}
	auto con = *con1;
	to[p][con.y] = s;
	st[p].erase(con);
}

void dfs2(int s, int p) {
	for (int i : to[s]) {
		if (i != p) {
			dfs2(i, s);
		} else {
			cout << ind[{s, p}] << ' ';
		}
	}
}

void solve() {
	int n, huinia;
	cin >> n >> huinia;
	for (int i = 0; i < n - 1; i++) {
		int u, v, w;
		cin >> u >> v >> w; u--; v--;
		ed[{u, v}] = w;
		ed[{v, u}] = w;
		ind[{u, v}] = i + 1;
		ind[{v, u}] = i + 1;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	for (int i = 0; i < n; i++) {
		int deg = g[i].size();
		// cin >> deg;
		c[i].resize(deg);
		to[i].resize(deg);
		for (int j = 0; j < deg; j++) {
			cin >> c[i][deg - j - 1];
		}
		for (int j = 0; j < deg; j++) {
			st[i].emplace(c[i][j], j);
			to[i][j] = -1;
		}
	}
	dfs1(0, -1);
	cout << "Yes\n";
	dfs2(0, -1);
	cout << '\n';
}