#include <bits/stdc++.h>

#define int long long

using namespace std;

int n, gr;
vector<vector<pair<int, int>>> g;
vector<unordered_map<int, deque<int>>> ind;
map<pair<int, int>, int> indreb;
vector<deque<int>> a;
vector<pair<pair<int, int>, int>> reb;
vector<int> indsave;
vector<pair<pair<int, int>, pair<int, int>>> gp;

int dfs(int u, int p) {
    vector<pair<int, int>> saved;
    for (auto [v, w] : g[u]) {
        if (v == p) {
            continue;
        }
        int x = dfs(v, u);
        saved.push_back({w - x, v});
    }
    sort(saved.begin(), saved.end());
    vector<pair<int, int>> sa;
    for (int i = 0; i < a[u].size(); i++) {
        sa.push_back({a[u][i], i});
    }
    sort(sa.begin(), sa.end());
    if (u == 1) {
        for (int i = 0; i < g[1].size(); i++) {
            gp.push_back({{1, sa[i].second}, {saved[i].second, indsave[saved[i].second]}});
            if (sa[i].first < saved[i].first) {
                cout << "No";
                exit(0);
            }
        }
        return 0;
    }
    for (int i = (int)g[u].size() - 1; i >= 0; i--) {
        int l = 0;
        bool can = true;
        for (int j = 0; j < g[u].size(); j++) {
            if (j == i) {
                continue;
            }
            if (sa[j].first < saved[l].first) {
                can = false;
                break;
            }
            l++;
        }
        if (can) {
            indsave[u] = sa[i].second;
            l = 0;
            for (int j = 0; j < g[u].size(); j++) {
                if (j == i) {
                    continue;
                }
                gp.push_back({{u, sa[j].second}, {saved[l].second, indsave[saved[l].second]}});
                l++;
            }
            return sa[i].first;
        }
    }
    cout << "No";
    exit(0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> gr;
    g.resize(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        indreb[{u, v}] = i + 1;
        indreb[{v, u}] = i + 1;
        reb.push_back({{u, v}, c});
        g[u].push_back({v, c});
        g[v].push_back({u, c});
    }
    ind.resize(n + 1);
    a.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int x;
            cin >> x;
            a[i].push_front(x);
        }
        for (int j = 0; j < g[i].size(); j++) {
            ind[i][a[i][j]].push_back(j);
        }
    }
    indsave.resize(n + 1);
    dfs(1, 0);
    cout << "Yes\n";
    vector<int> iii(n + 1);
    vector<int> kolgp(gp.size(), 2);
    map<pair<int, int>, int> ii;
    deque<int> que;
    for (int i = 0; i < gp.size(); i++) {
        auto [p1, p2] = gp[i];
        auto [u, iu] = p1;
        auto [v, iv] = p2;
        ii[p1] = i;
        ii[p2] = i;
        if (iu == 0) {
            kolgp[i]--;
        }
        if (iv == 0) {
            kolgp[i]--;
        }
        if (iu == 0 && iv == 0) {
            que.push_back(i);
        }
    }
    while (!que.empty()) {
        int i = que[0];
        que.pop_front();
        auto [p1, p2] = gp[i];
        auto [u, iu] = p1;
        auto [v, iv] = p2;
        cout << indreb[{u, v}] << ' ';
        if (iu + 1 < g[u].size()) {
            auto p11 = p1;
            p11.second++;
            int nowi = ii[p11];
            kolgp[nowi]--;
            if (kolgp[nowi] == 0) {
                que.push_back(nowi);
            }
        }
        if (iv + 1 < g[v].size()) {
            auto p11 = p2;
            p11.second++;
            int nowi = ii[p11];
            kolgp[nowi]--;
            if (kolgp[nowi] == 0) {
                que.push_back(nowi);
            }
        }
    }
}
