 #include <bits/stdc++.h>
using namespace std;
vector<vector<pair<int, int>>> g;

signed main() {
    int n, T; cin >> n >> T;
    g.resize(n);
    vector<vector<int>> edge;
    vector<int> deg(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, w; cin >> a >> b >> w;
        deg[a - 1]++;
        deg[b - 1]++;
        g[a - 1].push_back({b - 1, w});
        g[b - 1].push_back({a - 1, w});
        edge.push_back({a - 1, b - 1, w});
    }
    vector<vector<int>> elem(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            int x; cin >> x;
            elem[i].push_back(x);
        }
    }
    for (int i = 0; i < n; i++) reverse(elem[i].begin(), elem[i].end());
    vector<int> v(n - 1);
    for (int i = 0; i < n - 1; i++) v[i] = i;
    do {
        vector<int> uk(n);
        bool f = 0;
        for (int i = 0; i < n - 1; i++) {
            auto k = edge[v[i]];
            if (elem[k[0]][uk[k[0]]] + elem[k[1]][uk[k[1]]] >= k[2]) {
                uk[k[0]]++;
                uk[k[1]]++;
            } else {
                f = 1;
            }
        }
        if (f == 0) {
            cout << "Yes\n";
            for (auto u: v) cout << u + 1 << ' ';
            exit(0);
        }
    } while (next_permutation(v.begin(), v.end()));
    cout << "No\n";
    exit(0);

    vector<pair<int, int>> cost;
    for (int i = 0; i < edge.size(); i++) {
        auto u = edge[i];
        if (u[0] == 0) {
            cost.push_back({u[2] - elem[u[1]][0], i});
        } else {
            cost.push_back({u[2] - elem[u[0]][0], i});
        }
    }
    sort(cost.begin(), cost.end());
    vector<pair<int, int>> num;
    for (int i = 0; i < elem[0].size(); i++) {
        num.push_back({elem[0][i], i});
    }
    sort(num.rbegin(), num.rend());
    vector<pair<int, int>> ans;
    for (int i = 0; i < n - 1; i++) {
        if (num[i].first + cost[i].first < 0) {
            cout << "No\n";
            exit(0);
        }
        ans.push_back({num[i].second, cost[i].second});
    }
    sort(ans.begin(), ans.end());
    cout << "Yes\n";
    for (auto u : ans) cout << u.second + 1 << ' ';
    cout << '\n';
}

/*

 */