#ifndef locaL
#pragma GCC optimize("O3")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ld = long double;
using i128 = __int128;
using ord_set = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using h_map = gp_hash_table<ll, ll>;
using h_set = gp_hash_table<ll, null_type>;
#define fst first
#define snd second
auto sd = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(sd);
vector <pair <ll,ll>> e;
vector <ll> wei;
bool check(vector <vector <ll>> &dg2, vector <ll> &p){
    vector <vector <ll>> deg = dg2;
    bool f = true;
    for (auto i: p){
        ll a = e[i].fst;
        ll b = e[i].snd;
        ll w = wei[i];
        ll C_a = deg[a].back();
        ll C_b = deg[b].back();
        if (C_a +C_b < w){
            f = false;
            break;
        }
        deg[a].pop_back();
        deg[b].pop_back();
    }
    return f;
}
void sol1(){
    ll n, g;
    cin >> n >> g;
    vector <vector <pair <ll, ll>>> graph(n+1);
    e.resize(n);
    map <pair <ll, ll>, ll> nm;
    wei.resize(n);
    vector <ll> d(n+1);
    for (int i =0; i < n-1; i++){
        ll a, b, w;
        cin >> a >> b >> w;
        d[a]++;
        d[b]++;
        nm[{a, b}] = i+1;
        graph[a].emplace_back(b, w);
        graph[b].emplace_back(a, w);
        e[i+1] = {a, b};
        wei[i+1] = w;
    }
    vector <vector <ll>> deg(n+1);
    for (ll i =1; i <= n; i++){
        for (ll j = 0; j < d[i]; j++){
            ll k;cin>>k;
            deg[i].push_back(k);
        }
    }
    if (g <= 1){
        vector <ll> p(n-1);
        for (ll i =1; i <= n-1; i++){
            p[i-1] = i;
        }
        bool v = check(deg, p);

        if (v){
            cout << "Yes\n";
            for (auto l: p) cout << l << " ";
            return;
        }

        while (next_permutation(p.begin(), p.end())){
            v = check(deg, p);
            if (v){
                cout << "Yes\n";
                for (auto l: p) cout << l << " ";
                return;
            }
        }
        cout<<"No";
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(14);
#ifdef locaL
    freopen("inp.txt", "r", stdin);
    freopen("outp.txt", "w", stdout);
#endif
    int t = 1;
    //cin>>t;
    for (int o_ = 0; o_ < t; o_++){
        sol1();
    }

}
