#include <bits/stdc++.h>
#define int long long
#define all(a) a.begin(), a.end()
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/hash_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T>
//using ordered_set = tree<T, null_type, less<T>>;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

vector<int> t, used;
vector<vector<int>> ge;

void topsort(int v) {
    used[v] = true;
    for (auto u: ge[v]) {
        if (!used[u]) topsort(u);
    }
    t.push_back(v);
}

void solve() {
    int n, gr; cin >> n >> gr;
    vector<set<tuple<int, int, int>>> g(n);
    vector<set<pair<int, int>>> c(n);
    vector<vector<int>> ce(n);
    set<pair<int, int>> q;
    ge.assign(n - 1, {});
    for (int _ = 0; _ < n - 1; ++_) {
        int u, v, w; cin >> u >> v >> w;
        --u, --v;
        g[u].emplace(v, w, _);
        g[v].emplace(u, w, _);
    }
    for (int i = 0; i < n; ++i) {
        int sz = (int)g[i].size();
        for (int j = 0; j < sz; ++j) {
            int x; cin >> x;
            c[i].emplace(x, j);
        }
        ce[i].assign(sz, -1);
        q.emplace(sz, i);
    }
    while (!q.empty()) {
        auto [deg, v] = *q.begin();
        q.erase(q.begin());
        auto [u, w, ed] = *g[v].begin();
        auto [cv, cvi] = *c[v].begin();
        g[v].clear(); g[u].erase(make_tuple(v, w, ed));
        auto it = c[u].lower_bound(make_pair(w - cv, -1));
        if (it == c[u].end()) {
            cout << "No\n";
            return;
        }
        auto [cu, cui] = *it;
        c[v].clear(); c[u].erase(it);
        ce[v][cvi] = ce[u][cui] = ed;
        q.erase(make_pair((int)g[u].size() + 1, u));
        if (!g[u].empty()) q.emplace((int)g[u].size(), u);
    }
    ge.assign(n - 1, {});
    t.clear(); used.assign(n - 1, 0);
    for (int i = 0; i < n; ++i) {
        int sz = (int)ce[i].size();
        for (int j = 0; j < sz - 1; ++j) {
            ge[ce[i][j + 1]].push_back(ce[i][j]);
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        if (!used[i]) topsort(i);
    }
    reverse(all(t));
    cout << "Yes\n";
    for (auto v: t) cout << v + 1 << ' ';
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/b.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
    cin >> _t;
#endif
    while (_t--) solve();
}