#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll n;
vector<multiset<ll>> g;
vector<multiset<ll>> vec;
vector<ll> q; // вершины степени 1
map<pair<ll, ll>, ll> mp;
multiset<ll> ost;

struct node {
    ll x, y;
    ll w1, w2;

    node(ll X, ll Y, ll W1, ll W2) : x(X), y(Y), w1(W1), w2(W2) {};
};

vector<node> ans;

pair<ll, ll> para(ll a, ll b) {
    return make_pair(min(a, b), max(a, b));
}

void func() {
    while (q.size() != 0) {
        ll v = q.back();
        q.pop_back();
        if (ost.size() == 1) {
            break;
        }

        ll u = *g[v].begin();
        g[v].erase(g[v].begin());
        g[u].erase(g[u].find(v));
        ost.erase(ost.find(v));

        auto it = vec[u].lower_bound(mp[para(v, u)] - (*vec[v].begin()));

        if (it == vec[u].end()) {
            cout << "No";
            exit(0);
        } else {
            ll x = *it;
            ans.emplace_back(v, u, *vec[v].begin(), x);
            vec[u].erase(it);
            vec[v].clear();
        }

        if (g[u].size() == 1) {
            q.push_back(u);
        }
    }
}

int main() {
    ll group;
    cin >> n >> group;

    g.resize(n + 1);
    vec.resize(n + 1);

    map<pair<ll, ll>, ll> nomer;
    vector<vector<ll>> karts(n + 1);

    for (ll i = 1; i < n; i++) {
        ll a, b;
        ll w;
        cin >> a >> b >> w;
        mp[para(a, b)] = w;
        g[a].insert(b);
        g[b].insert(a);
        nomer[para(a, b)] = i;
    }

    for (ll i = 1; i <= n; i++) {
        ost.insert(i);
        for (ll j = 0; j < g[i].size(); j++) {
            ll a;
            cin >> a;
            vec[i].insert(a);
            karts[i].push_back(a);
        }
    }

    for (ll i = 1; i <= n; i++) {
        if (g[i].size() == 1) {
            q.push_back(i);
        }
    }

    func();
//    for (auto i : ans){
//        cout << i.x << ' ' << i.y << ' ' << i.w1 << ' ' << i.w2 << endl;
//    }cout << endl;

    cout << "Yes\n";
    for (ll _ = 0; _ < ans.size(); _++) {
        for (auto nd: ans) {
            if (karts[nd.x].back() == nd.w1 && karts[nd.y].back() == nd.w2) {
                cout << nomer[para(nd.x, nd.y)] << ' ';
                karts[nd.x].pop_back();
                karts[nd.y].pop_back();
            }
        }
    }
}
