#include<bits/stdc++.h>
using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(rd());

template<typename T>
bool assing_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

bool dfs(ll v, ll p, vector<vector<tuple<ll, ll, ll>>>& tree, vector<vector<ll>>& c, vector<ll>& as, vector<ll>& ae) {
	vector<pair<ll, ll>> now;
	for (auto[i, nc, num] : tree[v]) {
		if (i != p) {
			if (!dfs(i, v, tree, c, as, ae)) {
				return false;
			}
			ll x = nc - c[i][0];
			now.emplace_back(x, num);
		}
	}
	sort(now.rbegin(), now.rend());
	vector<ll> nums(c[v].size(), -1);
	vector<pair<ll, ll>> nc;
	for (ll i = 0; i < c[v].size(); i++) {
		nc.emplace_back(c[v][i], i);
	}
	sort(nc.rbegin(), nc.rend());
	c[v].clear();
	while (!nc.empty()) {
		if (now.empty() || nc.back().first < now.back().first) {
			c[v].push_back(nc.back().first);
			if (c[v].size() > 1 || v == p) {
				return false;
			}
		} else {
			nums[nc.back().second] = now.back().second;
			now.pop_back();
		}
		nc.pop_back();
	}
	bool b = false;
	for (ll i = 0; i < nums.size(); i++) {
		if (nums[i] == -1) {
			b = true;
			continue;
		}
		if (b) {
			ae.push_back(nums[i]);
		} else {
			as.push_back(nums[i]);
		}
	}
	return true;
}

void solve() {
	ll n, g;
	cin >> n >> g;
	vector<vector<tuple<ll, ll, ll>>> tree(n);
	for (ll i = 1; i < n; i++) {
		ll a, b, c;
		cin >> a >> b >> c;
		a--;
		b--;
		tree[a].emplace_back(b, c, i);
		tree[b].emplace_back(a, c, i);
	}
	vector<ll> as, ae;
	vector<vector<ll>> c(n);
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < tree[i].size(); j++) {
			ll x;
			cin >> x;
			c[i].push_back(x);
		}
	}
	if (dfs(0, 0, tree, c, as, ae)) {
		cout << "Yes\n";
		reverse(as.begin(), as.end());
		for (auto i : ae) {
			cout << i << ' ';
		}
		for (auto i : as) {
			cout << i << ' ';
		}
		cout << '\n';
	} else {
		cout << "No\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
