#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <unordered_map>
#include <set>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <cmath>
#include <random>

using namespace std;
typedef long long ll;
const ll inf = 1e18;

int main()
{
    ios::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    ll n, gr;
    cin >> n >> gr;
    map <pair <ll, ll> , ll> num;
    vector < vector <pair <ll, ll> > > g(n);
    vector <ll> deg(n, 0);
    vector <ll> edp(n);
    for (ll i = 0; i < n - 1; i++)
    {
        ll a, b, w;
        cin >> a >> b >> w;
        a--; b--;
        g[a].push_back({ b, w });
        g[b].push_back({ a, w });
        num[{a, b}] = i;
        edp[i] = w;
        deg[a]++;
        deg[b]++;
    }
    vector <vector <ll> > stick(n);
    for (ll i = 0; i < n; i++)
    {
        for (ll j = 0; j < deg[i]; j++)
        {
            ll a;
            cin >> a;
            stick[i].push_back(a);
        }
    }
    vector <ll> ans(n - 1, 0);
    if (gr == 3)
    {
        vector <pair <ll, ll> > sone;
        for (ll i = 0; i < deg[0]; i++) sone.push_back({ stick[0][i], i });
        sort(sone.begin(), sone.end());
        for (ll i = 1; i < n; i++)
        {
            ll add = edp[num[{0, i}]] - stick[i][0];
            ll l = 0, r = n - 2;
            while (l != r)
            {
                ll mid = (l + r) >> 1;
                if (sone[mid].first >= add) r = mid;
                else l = mid + 1;
            }
            if (sone[l].first < add)
            {
                cout << "No";
                return 0;
            }
            else
            {
                ans[n - 2 - l] = num[{0, i}];
            }
        }
        cout << "Yes" << '\n';
        for (auto i : ans) cout << i + 1 << " ";
        return 0;
    }
}

 