#include <bits/stdc++.h>

using namespace std;

#define int long long
#define fi first
#define se second
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define pw(x) (1LL << x)
#define mp make_pair

constexpr int N = 2e5 + 2;

struct Edge {
    int v, u, w, i;
};

int n, group, deg[N], cnt[N];
set<pair<int, int> > need;
Edge e[N];
vector<int> c[N];

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> group;
    for (int i = 0; i < n - 1; i ++) {
        cin >> e[i].v >> e[i].u >> e[i].w;
        e[i].v --; e[i].u --;
        deg[e[i].v] ++;
        deg[e[i].u] ++;
        e[i].i = i + 1;
    }

    for (int i = 0; i < n; i ++) {
        c[i].resize(deg[i]);
        for(int j = 0; j < deg[i]; j ++)
            cin >> c[i][j];
    }

    if (group <= 1) {
        vector<int> p(n - 1);
        iota(p.begin(), p.end(), 0);
        do {
            bool good = true;
            fill_n(cnt, n, 1);
            for (int i = 0; i < n - 1; i ++) {
                int v = e[p[i]].v, u = e[p[i]].u, w = e[p[i]].w;
                if (cnt[v] > deg[v] || cnt[u] > deg[u] || c[v][deg[v] - cnt[v]] + c[u][deg[u] - cnt[u]] < w) {
                    good = false;
                    break;
                }
                cnt[v] ++;
                cnt[u] ++;
            }

            if (good) {
                cout << "Yes\n";
                for (int i : p)
                    cout << e[i].i << ' ';
                return 0;
            }
        } while (next_permutation(all(p)));

        cout << "No";
        return 0;
    } else if (group == 3) {
        for (int i = 0; i < n - 1; i ++)
            need.insert(mp(e[i].w - c[e[i].u][0], e[i].i));
        vector<int> ans;
        for (int i = n - 2; i >= 0; i --) {
            int now = c[0][i];
            auto it = need.upper_bound(mp(now, N));
            if (it == need.begin())
                continue;
            it --;
//            cout << i << ' ' << now << ' ' << (*it).first << ' ' << (*it).second << '\n';
            if (it != need.end()) {
                ans.push_back((*it).se);
                need.erase(it);
            }
        }
        if (sz(ans) == n - 1) {
            cout << "Yes\n";
            for(int i : ans)
                cout << i << ' ';
        } else
            cout << "No";
        return 0;
    }



    return 0;
}

/*

4 3
1 2 7
1 3 6
1 4 5
3 2 1
5
4
4



 */