#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using str = string;

ll maxn = 2e5;
vector <vector <ll>> g(maxn);
vector <ll> used(maxn);
vector <ll> order;

void dfs(int v) {
	used[v] = 1;
	for (int u : g[v]) {
		if (used[u] == 0) {
			dfs(u);
		}
	}
	order.push_back(v);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n, gg;
	cin >> n >> gg;
	vector <vector <ll>> edg(n - 1, vector <ll>(4));
	vector <ll> cnt(n);
	for (int i = 0; i < n - 1; i++) {
		cin >> edg[i][1] >> edg[i][2] >> edg[i][0];
		edg[i][3] = i;
		cnt[edg[i][1] - 1]++;
		cnt[edg[i][2] - 1]++;
	}
	vector <vector <pair <ll, ll>>> v(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < cnt[i]; j++) {
			ll x;
			cin >> x;
			v[i].push_back({ x, j });
		}
	}
	if (gg == 3) {
		for (int i = 0; i < n - 1; i++) {
			edg[i][0] -= v[edg[i][2] - 1][0].first;
		}
		sort(edg.begin(), edg.end());
		sort(v[0].begin(), v[0].end());
		vector <ll> ans(n - 1);
		int f = 0;
		for (int i = 0; i < n - 1; i++) {
			if (v[0][i].first < edg[i][0]) {
				f = 1;
			}
			else {
				ans[v[0][i].second] = edg[i][3] + 1;
			}
		}
		reverse(ans.begin(), ans.end());
		if (f == 0) {
			cout << "Yes" << '\n';
			for (int i = 0; i < n - 1; i++) {
				cout << ans[i] << ' ';
			}
		}
		else {
			cout << "No";
		}
	}
	else if (gg == 2 || gg == 0) {
		ll now = 0;
		int f = 0;
		for (int i = 0; i < n - 2; i++) {
			if (v[i + 1][0].first > v[i + 1][1].first) {
				swap(v[i + 1][0], v[i + 1][1]);
			}
			if (v[i][now].first + v[i + 1][0].first >= edg[i][0]) {
				now = 1;
				if (v[i + 1][0].second == 1) {
					g[i].push_back(i + 1);
				}
				else {
					g[i + 1].push_back(i);
				}
			}
			else if (v[i][now].first + v[i + 1][1].first >= edg[i][0]) {
				now = 0;
				if (v[i + 1][1].second == 1) {
					g[i].push_back(i + 1);
				}
				else {
					g[i + 1].push_back(i);
				}
			}
			else {
				f = 1;
			}
		}
		if (f == 1) {
			cout << "No";
		}
		else {
			for (int i = 0; i < n - 1; i++) {
				if (used[i] == 0) {
					dfs(i);
				}
			}
			reverse(order.begin(), order.end());
			cout << "Yes" << '\n';
			for (int i = 0; i < n - 1; i++) {
				cout << order[i] + 1 << ' ';
			}
		}
	}
}