#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <complex>
#include <assert.h>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <immintrin.h>
using namespace std;

///*
//#define int long long
//#define INTLONGLONG
//*/

#define pi pair<int, int>
#define vi vector<int>
#define vvi vector<vector<int>>
#define vpi vector<pair<int, int>>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ff first
#define ss second

const int md = 998244353;
const int INF = 2e9;

vector<set<pi>> s;
vector<vector<pi>> graph;
vvi w;
vi idpar;
bool bad = 0;
vi fst;
vi scn;
vi par;
vvi ssil;
void dfs(int u, int p, int wpar) {
	par[u] = p;
	int cid = -1;
	for (pi v : graph[u]) {
		cid++;
		if (v.ff == p) continue;
		dfs(v.ff, u, w[u][cid]);
		idpar[v.ff] = v.ss;
		if (bad) return;
	}
	if (u == p) return;
	pi x = *s[u].begin();
	fst[u] = x.ss;
	pi your_mom = pi(wpar - x.ff, -INF);
	auto it = lower_bound(all(s[p]), your_mom);
	if (it == s[p].end()) {
		bad = 1;
		return;
	}
	scn[u] = it->ss;
	ssil[p][it->ss] = u;
	s[p].erase(it);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n, g;
	cin >> n >> g;
	graph.assign(n, vpi());
	s.assign(n, set<pi>());
	w = vvi(n);
	fst.assign(n, -1);
	par.assign(n, -0);
	scn.assign(n, -1);
	idpar.assign(n, -1);
	for (int i = 0; i < n - 1; i++) {
		int u, v, wt;
		cin >> u >> v >> wt;
		u--;
		v--;
		graph[u].push_back({ v, i });
		graph[v].push_back({ u, i });
		w[u].push_back(wt);
		w[v].push_back(wt);
	}
	ssil = vvi(n);
	for (int i = 0; i < n; i++) {
		ssil[i].assign(graph[i].size() + 1, -1);
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < graph[i].size(); j++) {
			int x;
			cin >> x;
			s[i].insert({ x, j });
		}
	}
	dfs(0, 0, -777);
	if (bad) {
		cout << "No" << endl;
		return 0;
	}
	cout << "Yes" << endl;
	deque<int> q;
	for (int i = 1; i < n; i++) {
		if (!fst[i] && !scn[i]) {
			q.push_back(i);
		}
	}
	vi tvec(n);
	vi ans;
	while (q.size()) {
		int x = q.front();
		q.pop_front();

		ans.push_back(idpar[x] + 1);

		tvec[x]++;
		tvec[par[x]]++;
		if (ssil[x][tvec[x]] != -1) {
			if (fst[ssil[x][tvec[x]]] == tvec[ssil[x][tvec[x]]]) {
				q.push_back(ssil[x][tvec[x]]);
			}
		}
		if (ssil[par[x]][tvec[par[x]]] != -1) {
			if (fst[ssil[par[x]][tvec[par[x]]]] == tvec[ssil[par[x]][tvec[par[x]]]]) {
				q.push_back(ssil[par[x]][tvec[par[x]]]);
			}
		}
		if (par[x] && fst[par[x]] == tvec[par[x]]) {
			if (scn[par[x]] == tvec[par[par[x]]]) {
				q.push_back(par[x]);
			}
		}
	}
	reverse(all(ans));
	for (int el : ans) cout << el << ' ';

	return 0;
}