#ifdef LOCAL
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#define _GLIBCXX_DEBUG
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<array>
#include<algorithm>
#include<set>

using namespace std;

typedef long long ll;

struct Edge {
	ll v,u,w;
};

const ll INF=1e9+9;

array<char,10000000> s;

signed main() {
	ll n,G;
	//iostream s;
	cin>>n>>G;
	debug(n)
	vector<Edge> es(n-1);
	vector<vector<ll>> nums(n),g(n);
	vector<set<pair<ll,ll>>> nums_s(n);
	vector<set<ll>> g_s(n);
	vector<vector<ll>> numstoes(n);
	vector<ll> cntbg(n);
	vector<ll> tbg;
	vector<ll> ans(n-1);
	for(ll i=0;i<n-1;i++) {
		ll v,u,w;
		cin>>v>>u>>w;
		v--;u--;
		es[i]={v,u,w};
		g[u].push_back(i);
		g[v].push_back(i);
		g_s[u].insert(i);
		g_s[v].insert(i);
	}
	cin.getline(&s[0], (streamsize)1000000,'\n');
	for(ll i=0;i<n;i++) {
		cin.getline(&s[0], (streamsize)1000000,'\n');
		ll res=0;
		for(auto j:s) {
			if(j==' ') {nums[i].push_back(res);res=0;}
			else if(!j) {break;}
			else {res*=10;res+=(ll)(j-'0');}
		}
		nums[i].push_back(res);
		reverse(nums[i].begin(),nums[i].end());
		for(ll j=0;j<nums[i].size();j++) {nums_s[i].insert({nums[i][j],j});}
		numstoes[i].resize(nums[i].size());
	}
	debug(1)
	vector<ll> vis,deg(n);
	vis.reserve(n);
	for(ll i=0;i<n;i++) {deg[i]=nums[i].size();if(deg[i]==1) {vis.push_back(i);}}
	bool ok=true;
	while(!vis.empty()) {
		ll v=vis.back();
		debug(v)
		ll vnum=nums_s[v].begin()->first;
		ll vnumind=nums_s[v].begin()->second;
		ll esn=*g_s[v].begin();
		ll u=es[esn].v+es[esn].u-v;
		ll w=es[esn].w;
		vis.pop_back();
		debug(u)
		debug(w)
		auto x=nums_s[u].lower_bound({w-vnum,-INF});
		if(x==nums_s[u].end()) {
			cout<<"No\n";return 0;
		} else {
			debug(vnum)
			debug(x->first)
			numstoes[u][x->second]=esn;
			if(x->second+1==numstoes[u].size()) {cntbg[esn]++;}
			if(cntbg[esn]==2) {tbg.push_back(esn);debug("tbg")debug(esn)}
			numstoes[v][vnumind]=esn;
			if(vnumind+1==numstoes[v].size()) {cntbg[esn]++;}
			if(cntbg[esn]==2) {tbg.push_back(esn);debug("tbg")debug(esn)}
			nums_s[u].erase(x);
			nums_s[v].clear();
			g_s[u].erase(esn);
			g_s[v].erase(esn);
		}
		if(nums_s[u].size()==1) {vis.push_back(u);}
		if(nums_s[u].size()==0) {break;}
	}
	debug("\n\n\n")
	ll tm=n-1;
	while(!tbg.empty() ) {
		ll esn=tbg.back();
		tbg.pop_back();
		debug(esn)
		ans[--tm]=esn+1;
		ll v=es[esn].v;
		ll u=es[esn].u;
		numstoes[v].pop_back();
		numstoes[u].pop_back();
		if(!numstoes[v].empty()) {cntbg[numstoes[v].back()]++;
		if(cntbg[numstoes[v].back()]==2) {tbg.push_back(numstoes[v].back());}}
		if(!numstoes[u].empty()) {cntbg[numstoes[u].back()]++;
		if(cntbg[numstoes[u].back()]==2) {tbg.push_back(numstoes[u].back());}}
	}
	//reverse(ans.begin(),ans.end());
	cout<<"Yes\n";
	for(auto i:ans) {cout<<i<<' ';}
	cout<<'\n';
	return 0;
}












