#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
//set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined,bounds,address")
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int n, group;
vector<tuple<int, int, int>> g[maxn];
tuple<int, int, int> e[maxn];
set<pii > c[maxn];
pii when[maxn];
vector<vector<int>> come[maxn];

void dfs(int v = 0, int p = -1) {
    for (auto [u, ei, wi]: g[v]) {
        if (p == u) continue;
        dfs(u, v);
        auto [xu, when_u] = *c[u].begin();
        auto it = c[v].lower_bound({wi - xu, 0});
        if (it == c[v].end()) {
            cout << "No";
            exit(0);
        }
        auto [xv, when_v] = *it;
        c[v].erase(it);
        when[ei] = {when_u, when_v};
        come[u][when_u].push_back(ei);
        come[v][when_v].push_back(ei);
    }
}

void solve() {
    cin >> n >> group;
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w, a--, b--;
        if (a > b) swap(a, b);
        g[a].push_back({b, i, w});
        g[b].push_back({a, i, w});
        e[i] = {a, b, w};
    }
    for (int i = 0; i < n; i++) {
        int deg = sz(g[i]);
        come[i].resize(deg);
        while (deg--) {
            int x;
            cin >> x;
            c[i].insert({x, deg});
        }
    }
    dfs();
    set<pii > edg;
    for (int i = 0; i < n - 1; i++) edg.insert({2, i});
    vector<int> val(n - 1, 2);
    for (int v = 0; v < n; v++) {
        for (int ei: come[v][0]) {
            edg.erase({val[ei], ei});
            val[ei]--;
            edg.insert({val[ei], ei});
        }
    }
    vector<int> wh(n);
    cout << "Yes\n";
    while (!edg.empty()) {
        auto [ost, ei] = *edg.begin();
        edg.erase(edg.begin());
        auto [u, v, w] = e[ei];
        wh[u]++;
        wh[v]++;
        if (wh[u] < sz(g[u])) {
            for (int I: come[u][wh[u]]) {
                edg.erase({val[I], I});
                val[I]--;
                edg.insert({val[I], I});
            }
        }
        if (wh[v] < sz(g[v])) {
            for (int I: come[v][wh[v]]) {
                edg.erase({val[I], I});
                val[I]--;
                edg.insert({val[I], I});
            }
        }
        cout << ei + 1 << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
