//#pragma GCC target("avx2", "avx")
//#pragma GCC optimize("Ofast", "inline", "unrool-loops", "sse", "sse2", "sse3", "ssse3", "sse4")

#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <unordered_map>
#include <set>
#include <string>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <random>

using namespace std;

#define int long long

static const int inf = 1e15 + 7, mod1 = 1e9 + 7;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin() (x).rend()

mt19937 rnd;

struct Edge {
    int u, v, w;

    Edge(int _u = 0, int _v = 0, int _w = 0) {
        u = _u;
        v = _v;
        w = _w;
    }
};

vector<vector<pair<int, int>>> g;
vector<vector<int>> c;
int n;

vector<int> ost;
vector<Edge> Edges;
int cnt = 0;

void f(int lenn) {
    if (lenn == n - 1) {
        if (ost[1] == 1 && ost[2] == 4 && ost[3] == 2 && ost[4] == 3) {
            int z = 0;
        }
        vector<int> pos(n + 1);
        for (int i = 1; i <= n; i++) {
            pos[i] = c[i].size() - 1;
        }
        for (int i = 1; i < n; i++) {
            for (int j = 1; j < n; j++) {
                if (ost[j] == i) {
                    int a = Edges[j].u, b = Edges[j].v, w = Edges[j].w;
                    if (w <= c[a][pos[a]] + c[b][pos[b]]) {
                        pos[a]--;
                        pos[b]--;
                        continue;
                    } else {
                        return;
                    }
                }
            }
        }
        cout << "YES\n";
        for (int i = 1; i < n; i++) {
            for (int j = 1; j < n; j++) {
                if (ost[j] == i) {
                    cout << j << ' ';
                    break;
                }
            }
        }
        exit(0);
    }
    for (int i = 1; i < n; i++) {
        if (!ost[i]) {
            cnt++;
            ost[i] = cnt;
            f(lenn + 1);
            ost[i] = 0;
            cnt--;
        }
    }
}

void solve() {
    int grupp;
    cin >> n >> grupp;
    g.resize(n + 1);
    Edges.push_back(Edge(0, 0, 0));
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        g[a].push_back(make_pair(b, w));
        g[b].push_back(make_pair(a, w));
        Edges.push_back(Edge(a, b, w));
    }
    c.resize(n + 1);
    for (int i = 1; i <= n; i++)  {
        for (int j = 0; j < g[i].size(); j++) {
            int push;
            cin >> push;
            c[i].push_back(push);
        }
    }
    ost.resize(n, 0);
    f(0);
    cout << "NO";
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
