#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,bmi,bmi2,lzcnt,popcnt")

// #define endl '\n'
#define F first
#define S second

typedef long long ll;
using namespace std;
using namespace __gnu_pbds;

mt19937 rng(time(nullptr));
mt19937_64 rngl(time(nullptr));

ll rnd(ll x) {
    uniform_int_distribution<ll> uid(0, x - 1);
    return uid(rngl);
}

int rnd(int x) {
    uniform_int_distribution<int> uid(0, x - 1);
    return uid(rng);
}

struct Point {
    ll x, y;

    explicit Point(ll x = 0, ll y = 0) : x(x), y(y) {}

    void in() {
        cin >> x >> y;
    }

    ll operator*(Point &other) {
        return x * other.x + y * other.y;
    }

    ll operator%(Point &other) {
        return x * other.y - y * other.x;
    }
};

int n, t;
vector <int> v[200010], d[200010];
map <pair <int, int>, int> mp;
set <pair <int, int>> g[200010];

void solve() {
    cin >> n >> t;
    for (int i = 0; i < n - 1; i++) {
        v[i].resize(3);
        for (auto& j : v[i])
            cin >> j;
        v[i][0]--, v[i][1]--;
        g[v[i][0]].insert({v[i][1], v[i][2]});
        g[v[i][1]].insert({v[i][0], v[i][2]});
        mp[{v[i][0], v[i][1]}] = mp[{v[i][1], v[i][0]}] = i;
        v[i].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        d[i].resize(g[i].size());
        for (auto& j : d[i])
            cin >> j;
    }
    set <vector <int>> st;
    for (int i = 0; i < n; i++)
        for (auto& [j, w] : g[i])
            if (i < j && !d[i].empty() && !d[j].empty() && w - d[i].back() - d[j].back() <= 0)
                st.insert({-w + d[i].back() + d[j].back(), -w, i, j, w});
    int ost = n - 1;
    vector <int> ans;
    while (ost--) {
        if (st.empty()) {
            cout << "No" << endl;
            return;
        }
        auto now = *st.begin();
        st.erase(st.begin());
        for (auto i : {now[2], now[3]})
            for (auto& [j, w] : g[i])
                if (!d[i].empty() && !d[j].empty() && w - d[i].back() - d[j].back() <= 0)
                    st.erase({-w + d[i].back() + d[j].back(), -w, min(i, j), max(i, j), w});
        g[now[2]].erase({now[3], now[4]});
        g[now[3]].erase({now[2], now[4]});
        ans.push_back(mp[{now[2], now[3]}]);
        // cout << ans.back() << endl;
        d[now[2]].pop_back();
        d[now[3]].pop_back();
        for (auto i : {now[2], now[3]})
            for (auto& [j, w] : g[i])
                if (!d[i].empty() && !d[j].empty() && w - d[i].back() - d[j].back() <= 0)
                    st.insert({-w + d[i].back() + d[j].back(), -w, min(i, j), max(i, j), w});
    }
    cout << "Yes" << endl;
    for (auto& i : ans)
        cout << i + 1 << ' ';
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll start = time(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    ll end = time(nullptr);
    cerr << "Ulyanovsk is the best!!!" << endl;
    cerr << "Execution time: " << end - start << " ms" << endl;
}
