#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

bool flag = true;
vector<vector<vector<int>>> graph;
vector<vector<vector<int>>> t;
vector<vector<vector<int>>> cnt;

int dfs(int v, int p) {
    //cout << v << ' ' << p << endl;
    vector<vector<int>> a;
    for (auto elem : graph[v]) {
        int w = elem[0], u = elem[1], id = elem[2];
        if (u != p)
            a.push_back({w - dfs(u, v), id, u});
    }
    t[v].resize(cnt[v].size(), {-1, -1});
    sort(a.begin(), a.end());
    vector<bool> used(cnt[v].size(), false);
    int j = 0;
    //cout << '+' << v << endl;
    for (int i = 0; i < a.size(); i++) {
        while (j < cnt[v].size() && a[i][0] - cnt[v][j][0] > 0)
            j++;
        if (j >= cnt[v].size()) {
            flag = false;
            return 0;
        }
        t[v][cnt[v][j][1]] = {a[i][1], a[i][2]};
        used[j] = true;
        //cout << v << ' ' << cnt[v][j][0] << " t[v] " << a[i][0] << ' ' << a[i][1] << ' ' << a[i][2] << endl;
        j++;
    }
    //cout << '#' << v << endl;
    if (p != 0) {
        for (int i = 0; i < cnt[v].size(); i++) {
            if (!used[i]) {
                //cout << v << ' ' << cnt[v][i][0] << endl;
                return cnt[v][i][0];
            }
        }
    }
    return 0;
}

void f(int v, int id = 0) {
    //cout << v << ' ' << id << endl;
    for (auto elem : t[v]) {
        int w = elem[0], u = elem[1];
        if (u != -1)
            f(u, w);
        else if (id > 0)
            cout << id << ' ';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, g, v, u, w, d;
    cin >> n >> g;
    graph.resize(n + 1);
    for (int i = 1; i < n; i++) {
        cin >> v >> u >> w;
        graph[v].push_back({w, u, i});
        graph[u].push_back({w, v, i});
    }
    t.resize(n + 1);
    cnt.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        //cout << "v: " << i << endl;
        d = graph[i].size();
        cnt[i].resize(d, {0, 0});
        for (int j = 0; j < d; j++) {
            cin >> cnt[i][j][0];
            cnt[i][j][1] = d - j - 1;
        }
        sort(cnt[i].begin(), cnt[i].end());
    }
    dfs(1, 0);
    if (!flag) {
        cout << "No";
        return 0;
    }
    cout << "Yes" << '\n';
    f(1);
}
