#include <bits/stdc++.h>
#define int long long

/* Using libraries */
using namespace std;

using ld = long double;
template <class T>
using vc = vector <T>;
using pii = pair <int, int>;
using pint = pair <int, int>;
template <class T>
int sz(vc <T> &a) {
    return (int)a.size();
}
int sz(string &a) {
    return (int)a.size();
}

template<class T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e18;
template<class T>
bool chmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
const int N = 2e5 + 100;
vc <vc <int>> g[N];
vc <int> c[N];
pii top[N];
int pr[N];
int dfs (int u, int p = -1) {
    vc <pii> b;
    for (int i = 0; i < c[u].size(); ++i)
        b.push_back({c[u][i], i});
    sort(b.begin(), b.end());
    vc <pii> tt;
    for (auto e : g[u]) {
        int v = e[0], w = e[1], i = e[2];
        if (v == p)
            continue;
        pr[v] = u;
        int ost = dfs(v, u);
        tt.push_back({w - ost, v});
    }
    sort(tt.begin(), tt.end());
    int j = 0;
    vc <int> cur;
    vc <pii> ost;
    for (int i = 0; i < b.size(); ++i) {
        while (j < tt.size() && tt[j].first <= b[i].first) {
            cur.push_back(tt[j].second);
            ++j;
        }
        if (!cur.empty()) {
            top[cur.back()].first = b[i].second;
            cur.pop_back();
        } else {
            ost.push_back(b[i]);
        }
    }
    if (ost.size() > 1 - (u == 0)) {
        cout << "No\n";
        exit(0);
    }
    if (u != 0) {
        top[u].second = ost[0].second;
        return ost[0].first;
    }
    return -1;
}

void solve() {
    int n, h;
    cin >> n >> h;
    vc <vc <int>> e;
    map <pii, int> mp;
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w; --u; --v;
        g[u].push_back({v, w, i});
        g[v].push_back({u, w, i});
        mp[{u, v}] = mp[{v, u}] = i + 1;
    }

    for (int i = 0; i < n; ++i) {
        int deg = g[i].size();
        c[i].resize(deg);
        for (int j = 0; j < deg; ++j) {
            cin >> c[i][j];
        }
    }
    dfs(0);
    set <pii> st;
    vc <int> cur(n);
    for (int i = 1; i < n; ++i) {
        int s1 = top[i].first;
        int s2 = top[i].second;
        cur[i] = s1 + s2;
        st.insert({s1 + s2, i});
    }
    vc <int> res;
    while (!st.empty() && st.begin()->first == 0) {
        int u = st.begin()->second; st.erase(st.begin());
        int v = pr[u];
        res.push_back(mp[{u, v}]);
        for (auto tt : g[u]) {
            int w = tt[0];
            if (cur[w] != 0) {
                st.erase({cur[w], w});
                --cur[w];
                st.insert({cur[w], w});
            }
        }
        for (auto tt : g[v]) {
            int w = tt[0];
            if (cur[w] != 0 && pr[w] == v) {
                st.erase({cur[w], w});
                --cur[w];
                st.insert({cur[w], w});
            }
        }
    }
    if (!st.empty()) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    reverse(res.begin(), res.end());
    for (int i : res)
        cout << i << ' ';
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}
//set PATH=%PATH%;C:\mingw64\bin