#include <iostream>
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
*/
#include <bits/stdc++.h>
using namespace std;

/*
#include <bits/extc++.h>
using namespace __gnu_pbds;
typedef tree<
        int,
        null_type,
        less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
 */

#define int long long
#define ll long long
#define fi first
#define se second
#define eb emplace_back
#define lwb lower_bound
#define upb upper_bound
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define ld long double
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
const int INF = 1e18, N = 300300, K = 26, C = 700, P = 1e9 + 7;
const ld EPS = 1e-5, pi = 3.1415926535;

vector<vector<pair<int, int>>> g;
vector<int> deg;
vector<vector<int>> c, num;
vector<int> rev, muv, used, ost;
int timer = 1;

void solve() {
    int n, gg;
    cin >> n >> gg;
    deg.resize(n + 1);
    vector<pair<int, int>> edges(n - 1);
    map<pair<int, int>, int> mp;
    g.resize(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        deg[v]++, deg[u]++;
        mp[{v, u}] = i;
        mp[{u, v}] = i;
        g[v].eb(u, w);
        g[u].eb(v, w);
    }

    c.resize(n + 1);
    num.resize(n + 1);
    int tmp = 0;
    for (int i = 1; i <= n; i++) {
        c[i].resize(deg[i]);
        num[i].resize(deg[i]);
        vector<int> inp(deg[i]);
        for (auto &it : inp)
            cin >> it;
        reverse(all(inp));
        for (int j = 0; j < deg[i]; j++) {
            c[i][j] = inp[j];
            num[i][j] = tmp++;
        }
    }

    rev.resize(tmp);
    muv.resize(tmp);
    ost.resize(tmp);
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            rev[num[i][j]] = i;
            muv[num[i][j]] = j;
            ost[num[i][j]] = j;
        }
    }

    set<pair<int, int>> st;
    for (int i = 1; i <= n; i++) {
        deg[i]--;
        st.insert({deg[i], i});
    }
    vector<bool> ban(n + 1);
    vector<int> match(tmp);
    used.resize(tmp);
    while (!st.empty()) {
        auto [dg, v] = *st.begin();
        st.erase(st.begin());
        if (dg > 0) {
            cout << "No" << endl;
            return;
        }
        if (st.empty())
            break;
        ban[v] = true;
        for (auto [to, w] : g[v]) {
            if (ban[to])
                continue;
            int x = -1;
            for (int j = 0; j < g[v].size(); j++) {
                if (used[num[v][j]] != timer) {
                    x = j;
                    break;
                }
            }
            int mini = INF, y = -1;
            for (int j = 0; j < g[to].size(); j++) {
                if (used[num[to][j]] == timer)
                    continue;
                if (c[v][x] + c[to][j] >= w && c[to][j] < mini) {
                    mini = c[to][j];
                    y = j;
                }
            }
            if (x == -1 || y == -1) {
                cout << "No" << endl;
                return;
            }
            match[num[v][x]] = num[to][y];
            match[num[to][y]] = num[v][x];
            used[num[v][x]] = timer;
            used[num[to][y]] = timer;
            st.erase({deg[to], to});
            deg[to]--;
            st.insert({deg[to], to});
        }
    }
    cout << "Yes" << endl;
    for (int i = 1; i <= n; i++) {
        deg[i] = (int) g[i].size();
    }
    timer++;
    used.assign(tmp, 0);
    vector<int> ansik;
    deque<pair<int, int>> q;
    vector<int> sus(n + 1);
    set<pair<int, int>> us;
    for (int i = 0; i < tmp; i++) {
        int to = match[i];
        if (ost[i] + ost[to] == 0 && us.find({i, to}) == us.end()) {
            q.eb(i, to);
            us.insert({i, to});
            us.insert({to, i});
        }
    }
    while (!q.empty()) {
        auto [v, u] = q.front();
        q.pop_front();
        ansik.eb(mp[{rev[v], rev[u]}]);
        sus[rev[v]]++;
        sus[rev[u]]++;
        if (muv[v] + 1 < deg[rev[v]]) {
            int v1 = v + 1;
            int to1 = match[v1];
            if (us.find({v1, to1}) == us.end()) {
                if (ost[to1] - sus[rev[to1]] <= 0 && ost[v1] - sus[rev[v1]] <= 0) {
                    q.eb(v1, to1);
                    us.insert({v1, to1});
                    us.insert({to1, v1});
                }
            }
        }
        if (muv[u] + 1 < deg[rev[u]]) {
            int v1 = u + 1;
            int to1 = match[v1];
            if (us.find({v1, to1}) == us.end()) {
                if (ost[to1] - sus[rev[to1]] <= 0 && ost[v1] - sus[rev[v1]] <= 0) {
                    q.eb(v1, to1);
                    us.insert({v1, to1});
                    us.insert({to1, v1});
                }
            }
        }
    }


    for (auto it : ansik) {
        cout << it + 1 << " ";
    }
    cout << endl;
}

signed main() {
    //cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    //cin >> T;
    while (T--)
        solve();
    return 0;
}