#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>

using namespace std;

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;

struct jet{
    ll to, cost;
};


void solve(){
    ll group;
    ll n, t1, t2, t3;
    cin >> n >> group;
    vector<vector<jet>> v(n);
    for (int i = 0; i < n - 1; ++i) {
        cin >> t1 >> t2 >> t3;
        t1--;
        t2--;
        jet nn, nn2;
        nn.to = t2;
        nn.cost = t3;
        nn2.to = t1;
        nn2.cost = t3;
        v[t1].push_back(nn);
        v[t2].push_back(nn2);
    }
    vector<vll> s(n);
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < v[k].size(); ++i) {
            cin >> t1;
            s[k].push_back(t1);
        }
    }
    if (group == 3){
        vpll diff;
        for (int i = 1; i < n; ++i) {
            diff.push_back({max(0ll, v[i][0].cost - s[i][0]), i});
        }
        sort(diff.begin(), diff.end());
        vpll base;
        for (int j = 0; j < s[0].size(); ++j) {
            base.push_back({s[0][j], j});
        }
        bool ans = true;
        vll ans_nums(n - 1);
        sort(base.begin(), base.end());
        for (int k = n - 2; k >= 0; --k) {
            if (diff[k].first > base[k].first){
                ans = false;
                break;
            }
            ans_nums[base[k].second] = diff[k].second;
        }
        if (ans){
            cout << "YES\n";
            for (int i = 0; i < ans_nums.size(); ++i) {
                cout << ans_nums[i] << " ";
            }
            cout << "\n";
        }
        else{
            cout << "NO\n";
        }
        return;
    }
}



int main(){
    /*ll task, group;
    cin >> task >> group;
    */
    solve();
}
