#include <bits/stdc++.h>

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC ("avx,bmi2")

#define int long long

using namespace std;

struct st {
    int u, w, i;
};

vector<vector<pair<int, int>>> answe;
vector<int> pr;
vector<pair<int, int>> s;
vector<int> sum;
map<pair<int, int>, int> mp;


void dfs(int v, vector<vector<st>> &gr, vector<int> &answ, vector<vector<int>> &c, vector<bool> &used) {
    used[v] = true;
    int r = 0;
    for (auto x : gr[v]) {
        if (!used[x.u]) {
            pr[x.u] = v;
            dfs(x.u, gr, answ, c, used);
            answe[v].push_back({x.w - answ[x.u], x.i});
            sum[v] += 1;
        } else {
            r = x.i;
        }
    }
    sort(answe[v].begin(), answe[v].end());
    int l = 0;
    int cnt = 0;
    for (int i = 0; i < answe[v].size(); i++) {
        if (l >= c[v].size()) {
            cout << "No";
            exit(0);
        }
        if (c[v][l].first >= answe[v][i].first) {
            l++;
        } else {
            cnt++;
            answ[v] = c[v][l].first;
            s[v] = {l, r};
            if (cnt == 2) {
                cout << "No";
                exit(0);
            }
            l++;
            if (l >= c[v].size() || c[v][l].first < answe[v][i].first) {
                cout << "No";
                exit(0);
            }
            l++;
        }
    }
    if (cnt == 0) {
        answ[v] = c[v][c[v].size() - 1].first;
        s[v] = {c[v].size() - 1, r};
    }
}

vector<int> answer;

void sd(int u, vector<vector<int>> &gr, vector<bool> &usd) {
    usd[u] = true;
    for (auto x : gr[u]) {
        if (!usd[x]) {
            sd(x, gr, usd);
        }
    }
    answer.push_back(u);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, g;
    cin >> n >> g;
    sum.resize(n);
    s.resize(n);
    answe.resize(n);
    pr.resize(n);
    vector<vector<st>> gr(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        gr[a].push_back({b, w, i});
        gr[b].push_back({a, w, i});
    }
    vector<vector<pair<int, int>>> c(n);
    for (int i = 0; i < n; i++) {
        for (int y = 0; y < gr[i].size(); y++) {
            int x;
            cin >> x;
            c[i].push_back({x, y});
        }
        sort(c[i].begin(), c[i].end());
    }
    vector<bool> used(n);
    vector<int> answ(n);
    dfs(0, gr, answ, c, used);
    vector<vector<int>> gra(n);
    for (int i = 0; i < n - 1; i++) {
        if (sum[i] != 0) {
            for (int y = 0; y < answe[i].size() - 1; y++) {
                gra[answe[i][y].second].push_back(answe[i][y + 1].second);
            }
            int k = s[i].first;
            int k2 = s[i].second;
            if (k > 0) {
                gra[answe[i][k - 1].second].push_back(k2);
            }
            if (k < answe[i].size() - 1 && k >= -1) {
                gra[k2].push_back(answe[i][k + 1].second);
            }
        }
    }
    vector<bool> usd(n);
    for (int i = 0; i < n - 1; i++) {
        if (!usd[i]) {
            sd(i, gra, usd);
        }
    }
    cout << "Yes" << endl;
    for (auto x : answer) {
        cout << x + 1 << " ";
    }
}
