#include <bits/stdc++.h>
using namespace std;
#define int long long
struct edge {
    int to, w, i;
};
main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, gg;
    cin >> n >> gg;
    vector < vector < edge > > G(n);
    for (int i = 1; i < n; i++) {
        int x, y, w;
        cin >> x >> y >> w;
        x--; y--;
        G[x].push_back({y, w, i});
        G[y].push_back({x, w, i});
    }
    set < pair < int , pair < int , int > > > a[n];
    vector < vector < int > > A(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < G[i].size(); j++) {
            int x;
            cin >> x;
            a[i].insert({x, {i, j}});
            A[i].push_back(x);
        }
    }
    vector < int > por;
    function < int(int, int) > getv = [&](int x, int y) {
        return x * n + y;
    };
    map < int , pair < int , int > > g;
    function < void(int, int, edge) > dfs = [&](int v, int p, edge e) {
        for (auto u : G[v]) if (u.to != p) {
            dfs(u.to, v, u);
        }
        if (e.to != -1) {
            auto x = *a[v].begin(); a[v].erase(x);
            auto it = a[p].lower_bound({e.w - x.first, {0LL, 0LL}});
            if (it == a[p].end()) {
                cout << "No";
                exit(0);
            }
            a[p].erase(it);
            int X = getv(x.second.first, x.second.second);
            int Y = getv(it -> second.first, it -> second.second);
            g[X] = {Y, e.i};
            g[Y] = {X, e.i};
        }
    };
    dfs(0, 0, {-1, -1, -1});
    cout << "Yes\n";
    map < int , bool > gd;
    for (int i = 0; i < n; i++) gd[getv(i, G[i].size()-1)] = 1;
    queue < int > q;
    for (int i = 0; i < n; i++) q.push(getv(i, G[i].size() - 1));
    vector < bool > was(n);
    while (!q.empty()) {
        auto X = q.front(); q.pop();
        int Y = g[X].first, E = g[X].second;
        if (was[E]) continue;
        if (gd[X] && gd[Y]) {
            por.push_back(E);
            was[E] = 1;
            if (X % n != 0) {
                gd[X-1] = 1;
                q.push(X-1);
            }
            if (Y % n != 0) {
                gd[Y-1] = 1;
                q.push(Y-1);
            }
        }
    }
    for (auto u : por) cout << u << " ";
}
