#include <bits/stdc++.h>
long long mod = 998244353;

using namespace std;

#pragma GCC optimize("O3,03,unroll_loops")

using ll = long long;
using ld = long double;
#define vl vector<ll>
#define vct vector
#define vll vct<vl>
#define pl pair<ll, ll>
#define vpl vct<pl>

#define fi first
#define se second
#define coutt cout <<
#define el << "\n"
#define sp << " "
#define all(a) a.begin(), a.end()
#define testy() \
ll Tests; cin >> Tests; while(Tests--)
#define pb push_back

template <typename T>
istream& operator>>(istream& in, pair<T, T>& a) {
    in >> a.fi >> a.se;
    return in;
}
template <typename T>
istream& operator>>(istream& in, vct<T>& a) {
    for (int i = 0; i < a.size(); ++i) in >> a[i];
    return in;
}

ll myLog2(ll a) {
    if (a <= 0) return -1;
    ll ans = 0;
    while (a > 1) {
        ++ans; a >>= 1;
    }
    return ans;
}
ll gcd(ll a, ll b) {
    if (a < b) swap(a, b);
    while (b > 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}
ll myPow(ll a, ll k) {
    if (k == 0) return 1;
    if (k == 1) return a;
    ll b = myPow(a, k / 2);
    b = (b * b) % mod;
    if (k & 1) b = (b * a) % mod;
    return b;
}

vl F;

void add(ll i, ll x){
    while (i < F.size()) {
        F[i] += x;
        i = i | (i + 1);
    }
}

ll SumPr(ll i) {
    ll res = 0;
    while (i >= 0) {
        res += F[i];
        i = (i & (i + 1)) - 1;
    }
    return res;
}

struct point {
    ll x, y;

    point(): x(0), y(0) {}
    point(ll _x, ll _y): x(_x), y(_y) {}

    point operator+(point other) { return point(x + other.x, y + other.y); }
    point operator-(point other) { return point(x - other.x, y - other.y); }
    ll operator*(point other) {return x * other.x + y * other.y; }
    ll operator%(point other) {return x * other.y - y * other.x; }
    ld len2() {return x * x + y * y;}
    ld len() { return sqrtl(len2()); }
    ll R(point other) {return abs(x - other.x) + abs(y - other.y); }
};

ll n, m, k, q;
// mt19927
vct<vll> g, r_rev;
vl a, p;

vct<vpl> stic;
vll ps, dsu, rb;

ll GET(ll v, ll i) {
    if (!ps[v][i]) return i;
    return dsu[v][i] = GET(v, dsu[v][i]);
}

void dfs(ll v, ll w, ll i, ll par) {
    p[v] = 1;
    for (vl &data: g[v]) {
        ll u = data[0], _w = data[1], _i = data[2];
        if (!p[u]) {
            dfs(u, _w, _i, v);
        }
    }

    if (i != -1) {
        ll t = GET(v, 0);
        if (t >= stic[v].size()) {
            coutt "No" el;
            exit(0);
        }
        ll cur = w - stic[v][t].fi;

        ll l = -1, r = stic[par].size() - 1;
        while (r - l > 1) {
            ll m = (l + r) / 2;
            if (stic[par][m].fi >= cur) r = m;
            else l = m;
        }
        r = GET(par, r);
        if (r >= stic[par].size() || stic[par][r].fi < cur) {
            coutt "No" el;
            exit(0);
        }

        rb[v][t] = rb[par][r] = i;
        ps[v][t] = ps[par][r] = 1;
    }
}

vll pr;
vl Y;

void dfs2(ll v) {
    Y[v] = 1;
    for (ll u : pr[v]) {
        if (!Y[u]) dfs2(u);
    }
    coutt v + 1 sp;
}

signed main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    // IN
    ll group;
    cin >> n >> group;

    {
        g.resize(n + 1);
        vl len(n + 1);
        for (int i = 0; i < n - 1; ++i) {
            ll v, u, w;
            cin >> v >> u >> w;
            g[v].pb({u, w, i});
            g[u].pb({v, w, i});
            len[v]++; len[u]++;
        };
        stic.resize(n + 1);
        ps.resize(n + 1);
        dsu.resize(n + 1);
        rb.resize(n + 1);
        for (int i = 1; i <= n; ++i) {
            stic[i].resize(len[i]);
            ps[i].resize(len[i] + 1);

            for (int j = 0; j < len[i]; ++j) {
                cin >> stic[i][j].fi; stic[i][j].se = len[i] - j - 1;
            }
            sort(all(stic[i]));

            dsu[i].resize(len[i] + 1);
            iota(all(dsu[i]), 1);
            rb[i].resize(len[i] + 1);
        }
    }

    // dfs
    p.resize(n + 1);
    dfs(1, -1, -1, -1);


    // 2
    pr.resize(n);
    auto cmp = [](pl& a, pl &b) {return a.se < b.se; };
    for (int i = 1; i <= n; ++i) {
        vpl now(stic[i].size());
        for (int j = 0; j < stic[i].size(); ++j) {
            now[j] = {rb[i][j], stic[i][j].se};
        }
        sort(all(now), cmp);
        for (int j = 1; j < stic[i].size(); ++j) {
            pr[now[j].fi].pb(now[j - 1].fi);
        }
    }

    // 3
    Y.resize(n);
    coutt "Yes" el;
    for (int i = 0; i < n - 1; ++i) {
        if (!Y[i]) dfs2(i);
    }
}




/*
7 1
1 2 9
1 3 5
2 4 12
2 5 20
2 6 8
6 7 10
5 3
11 4 1 3
4
11
9
4 5
5

*/
