// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long ll;
typedef long double ld;

const long long INF = 1e18;
const int inf = 2e9;
const int MOD = 1e9 + 7;

void solve() {
    int n, g, x;
    cin >> n >> g;
    vector<pair<int, int>> edges(n + 1);
    for (int i = 0; i < n - 1; ++i) {
        cin >> x >> x;
        cin >> edges[x].first;
        edges[x].second = x;
    }
    vector<int> c(n + 1);
    for (int i = 2; i <= n; ++i) {
        cin >> c[i];
    }
    for (int i = 2; i <= n; ++i) {
        cin >> x;
        edges[i].first -= x;
    }
    set<pair<int, int>> s;
    vector<int> ans(n - 1);
    for (auto e : edges) s.insert(e);
    for (int i = 2; i <= n; ++i) {
        auto it = s.upper_bound({ c[i] + 1, 0 });
        if (it == s.begin()) {
            cout << "No\n";
            return;
        }
        ans[(--it)->second - 2] = i - 1;
        s.erase(it);
    }
    cout << "Yes\n";
    for (int e : ans) cout << e << ' ';
}

signed main() {
#ifdef erytw
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
