#include <bits/stdc++.h>
using namespace std;

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

using ll = long long;

const int MAX = 3e5 + 7;

void solve() {
    int n, gg;
    cin >> n >> gg;
    vector<array<int, 4>> ed(n);
    vector<int> deg(n + 1, 0);
    for (int i = 1; i < n; i++) {
        cin >> ed[i][0] >> ed[i][1] >> ed[i][2];
        ed[i][3] = i;
        deg[ed[i][0]]++;
        deg[ed[i][1]]++;
    }
    vector<int> res;
    vector<bool> was(n, false);
    vector<vector<int>> st(n + 1);
    bool flag = true;
    for (int i = 1; i <= n; i++) {
        for (int j = 1, x; j <= deg[i]; j++) {
            cin >> x;
            if (j > 1 && st[i][j - 2] > x) {
                flag = false;
            }
            st[i].push_back(x);
        }
    }
    if (n <= 10) flag = true;
    for (int i = 1; i <= n; i++) {
        if (flag) {
            reverse(st[i].begin(), st[i].end());
        }
    }
    for (int it = 1; it < n; it++) {
        int mx = -1;
        for (int i = 1; i < n; i++) {
            if (!was[i]) {
                int v = ed[i][0];
                int u = ed[i][1];
                int w = ed[i][2];
                if (w <= st[v].back() + st[u].back() && (mx == -1 || st[v].back() + st[u].back() - w <= st[ed[mx][0]].back() + st[ed[mx][1]].back() - ed[mx][2])) {
                    mx = i;
                }
            }
        }
        if (mx == -1) {
            cout << "No";
            return;
        } else {
            int v = ed[mx][0];
            int u = ed[mx][1];
            st[v].pop_back();
            st[u].pop_back();
            was[mx] = true;
            res.push_back(mx);
        }
    }
    cout << "Yes\n";
    if (flag) reverse(res.begin(), res.end());
    for (auto i : res) cout << i << ' ';
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}