//#pragma GCC optimize("o-fast", "unroll-loops", "fast-math")
//#pragma GCC target("avx", "avx2", "bmi", "bmi2")

#include <bits/stdc++.h>

#include <random>

using namespace std;
#define int long long
#define ll long long
#define ld long double
#define sz(a) (int)a.size()

const int mod = 1e9 - 7;
const ld eps = 1e-12;

mt19937 rng(time(0));

int rnd(int n) {
    uniform_int_distribution<int> uid(0, n - 1);
    return uid(rng);
}
vector<int> ans;
vector<vector<pair<int,pair<int,int>>>> g;
vector<vector<pair<int,int>>> mas;
vector<int> up;
int cur = 0;
int get(int v, int p){
    if(up[v]!=-1){
        return up[v];
    }
    vector<pair<int, int>> edges;
    for(int i = 0; i < sz(g[v]); i++){
        if(g[v][i].first==p){
            continue;
        }
        edges.push_back({g[v][i].second.first - get(g[v][i].first, v), g[v][i].first});
    }
    sort(edges.begin(), edges.end());
    vector<pair<int,int>> old = mas[v];

    sort(mas[v].begin(), mas[v].end());
    int e = 0;
    for(int i = 0; i < sz(mas[v]); i++){
        if(e==sz(edges) || edges[e].first > mas[v][i].first){
            if(up[v]==-1){
                up[v]=mas[v][i].first;
            }
            else{
                cout<<"NO"<<endl;
                exit(0);
            }
        }
        else{
            e++;
        }
    }
    mas[v]=old;
    for(int i = 0; i < sz(g[v]); i++){
        if(g[v][i].first == p){
            continue;
        }
        get(g[v][i].first, v);
    }
    return up[v];
}
void dfs(int v, int p, int edge){
    vector<pair<int, int>> edges;
    for(int i = 0; i < sz(g[v]); i++){
        if(g[v][i].first==p){
            continue;
        }
        edges.push_back({g[v][i].second.first - get(g[v][i].first, v), i});
    }
    sort(edges.begin(), edges.end());
    vector<pair<int,int>> old = mas[v];
    sort(mas[v].begin(), mas[v].end());
    map<pair<int,int>, int> dop;
    int e = 0;
    for(int i = 0; i < sz(mas[v]); i++){
        if(mas[v][i].first==up[v]){
            continue;
        }
        dop[mas[v][i]] = edges[e].second;
        e++;
    }

    for(int i = 0; i < sz(old); i++){
        if(old[i].first==up[v]){
            ans[cur]=edge;
            cur++;
        }
        else{
            int to = dop[old[i]];
            dfs(g[v][to].first, v, g[v][to].second.second);
        }
    }
}
void solve1() {
    int n;
    int gr;
    cin>>n>>gr;
    ans.resize(n);
    g.resize(n);
    up.resize(n, -1);
    for(int i = 0; i < n-1; i++){
        int a,b,c;
        cin>>a>>b>>c;
        a--;
        b--;
        g[b].push_back({a,{c,i}});
        g[a].push_back({b,{c,i}});
    }
    mas.resize(n);
    for(int i = 0; i < n; i++){
        for(int j = 0; j < sz(g[i]); j++){
            int a;
            cin>>a;
            mas[i].push_back({a,j});
        }
        reverse(mas[i].begin(), mas[i].end());
    }
    int a = get(0,-1);
    dfs(0,-1, -1);
    cout<<"YES"<<endl;
    for(int i = 0; i < n-1; i++){
        cout<<ans[i] + 1 << " ";
    }
    cout<<endl;
}

signed main() {
    cout.tie(nullptr);
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int n = 1;
    //cin >> n;
    int test;
    //cin>>test;
    while (n--) {
        solve1();
    }
}
