#include <bits/stdc++.h>
using namespace std;

#define int long long

const int maxn = 200005;

int n, gr, deg[maxn], uu[maxn], vv[maxn], ww[maxn];
bool used[maxn];
vector<array<int, 3>> g[maxn];
vector<int> c[maxn], ans;

int32_t main() {
      ios::sync_with_stdio(false); cin.tie(0);
      cin >> n >> gr;
      for (int i = 1; i < n; i++) {
            cin >> uu[i] >> vv[i] >> ww[i];
            g[uu[i]].push_back({vv[i], ww[i], i});
            g[vv[i]].push_back({uu[i], ww[i], i});
            deg[uu[i]]++;
            deg[vv[i]]++;
      }
      for (int i = 1; i <= n; i++) {
            c[i].resize(deg[i]);
            for (auto &u : c[i])
                  cin >> u;
      }
      if (gr == 1) {
            vector<int> nms(n - 1);
            iota(begin(nms), end(nms), 1);
            do {
                  int cc[n + 1] = {};
                  for (int i = 1; i <= n; i++)
                        cc[i] = c[i].size() - 1;
                  bool bad = false;
                  for (auto u : nms) {
                        if (c[uu[u]][cc[uu[u]]] + c[vv[u]][cc[vv[u]]] >=
                            ww[u]) {
                                    cc[uu[u]]--;
                                    cc[vv[u]]--;
                            }
                        else
                              bad = true;
                        if (bad)
                              break;
                  }
                  if (!bad) {
                        cout << "Yes" << '\n';
                        for (auto u : nms)
                              cout << u << ' ';
                        cout << '\n';
                        return 0;
                  }
            } while (next_permutation(begin(nms), end(nms)));
            cout << "No" << '\n';
            return 0;
      }
      for (int it = 1; it < n; it++) {
            int dif = 2e18, av, au, an;
            for (int v = 1; v <= n; v++) {
                  for (auto [u, w, nm] : g[v])
                        if (!used[nm] && (int)c[v].back() + (int)c[u].back() >= w) {
                                    if ((int)c[v].back() + (int)c[u].back() - w < dif){
                                          dif = (int)c[v].back() + (int)c[u].back() - w;
                                          av = v;
                                          au = u;
                                          an = nm;
                                    }
                            }
            }
            if (dif == 2e18) {
                  cout << "No" << '\n';
                  return 0;
            }
            c[av].pop_back();
            c[au].pop_back();
            used[an] = true;
            ans.push_back(an);
      }
      cout << "Yes" << '\n';
      for (auto u : ans)
            cout << u << ' ';
      cout << '\n';
}
