#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

signed main() {
    ll n, g;
    cin >> n >> g;
    if (g <= 1) {
        vector<pair<Pair, ll>> all;
        vector<ll> deg(n);
        map<Pair, ll> ind;
        for (ll i = 0; i < n - 1; i++) {
            ll u, v, w;
            cin >> u >> v >> w;
            u--, v--;
            deg[u]++, deg[v]++;
            ind[{u, v}] = i;
            all.push_back({{u, v}, w});
        }
        vector<vector<ll>> c(n);
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < deg[i]; j++) {
                ll cur;
                cin >> cur;
                c[i].push_back(cur);
            }
            reverse(c[i].begin(), c[i].end());
        }
        sort(all.begin(), all.end());
        do {
            bool flag = true;
            vector<vector<ll>> cost = c;
            for (pair<Pair, ll> cur : all) {
                auto[u, v] = cur.first;
                ll w = cur.second;
                if (w <= cost[u].back() + cost[v].back()) {
                    cost[u].pop_back(), cost[v].pop_back();
                } else {
                    flag = false;
                    break;
                }
            }
            if (flag) {
                cout << "Yes\n";
                reverse(all.begin(), all.end());
                for (pair<Pair, ll> cur : all) {
                    cout << ind[cur.first] + 1 << " ";
                }
                cout << endl;
                return 0;
            }
        } while (next_permutation(all.begin(), all.end()));
        cout << "No\n";
    }
    if (g == 3) {
        vector<vector<ll>> c(n);
        vector<ll> val(n), weight(n);
        for (ll i = 0; i < n - 1; i++) {
            ll u, v, w;
            cin >> u >> v >> w;
            u--, v--;
            weight[v] = w;
        }
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < (i == 0 ? n - 1 : 1); j++) {
                ll cur;
                cin >> cur;
                c[i].push_back(cur);
            }
            if (i) val[i] = weight[i] - c[i][0];
            else reverse(c[0].begin(), c[0].end());
        }
        multiset<Pair> all;
        for (ll i = 1; i < n; i++) all.insert({val[i], i});
        bool flag = true;
        vector<ll> ans;
        while (!c[0].empty()) {
            ll cur = c[0].back();
            auto it = all.upper_bound({cur, -1});
            if (it != all.begin()) {
                it--;
                ans.push_back(it->second);
            } else {
                flag = false;
            }
            c[0].pop_back();
        }
        if (flag) {
            cout << "Yes\n";
            reverse(ans.begin(), ans.end());
            for (ll index : ans) cout << index << " ";
            cout << endl;
        } else {
            cout << "No\n";
        }
    }
    return 0;
}
