#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

mt19937 gen(-572);

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
    ll n, gr;
    cin >> n >> gr;
    vector<vector<Pair>> g(n);
    vector<pair<Pair, ll>> all;
    vector<ll> deg(n, 0LL);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        deg[u]++, deg[v]++;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        all.push_back({{u, v}, w});
    }
    vector<vector<ll>> c(n);
    for (ll v = 0; v < n; v++) {
        for (ll step = 0; step < deg[v]; step++) {
            ll cur;
            cin >> cur;
            c[v].push_back(cur);
        }
        reverse(c[v].begin(), c[v].end());
    }
    vector<bool> used(n - 1, false);
    vector<ll> ans;
    for (ll step = 0; step < n - 1; step++) {
        ll mn = INF;
        ll ind = -1;
        for (ll i = 0; i < n - 1; i++) {
            if (!used[i]) {
                if (c[all[i].first.first].back() + c[all[i].first.second].back() >= all[i].second) {
                    ll cnt = c[all[i].first.first].back() + c[all[i].first.second].back() - all[i].second;
                    if (cnt < mn) {
                        mn = cnt, ind = i;
                    } else if (cnt == mn) {
                        if (all[ind].second < all[i].second) {
                            mn = cnt, ind = i;
                        } else if (all[ind].second == all[i].second) {
                            if (!(c[all[ind].first.first].empty() || c[all[ind].first.second].empty())) {
                                if (c[all[i].first.first].empty() || c[all[i].first.second].empty() || c[all[i].first.first][c[all[i].first.first].size() - 2] + c[all[i].first.second][c[all[i].first.second].size() - 2] < c[all[ind].first.first][c[all[ind].first.first].size() - 2] + c[all[ind].first.second][c[all[ind].first.second].size() - 2]) {
                                    mn = cnt, ind = i;
                                }
                            }
                        }
                    }
                }
            }
        }
        if (ind == -1) {
            cout << "No\n";
            return 0;
        }
        used[ind] = true;
        c[all[ind].first.first].pop_back(), c[all[ind].first.second].pop_back();
        ans.push_back(ind + 1);
    }
    cout << "Yes\n";
    reverse(ans.begin(), ans.end());
    for (ll index : ans) cout << index << " ";
    cout << endl;
    return 0;
}
