#include <bits/stdc++.h>
#include <bits/extc++.h>
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define sz(v) (int)(v).size()
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld  = long double;
mt19937 Rand(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());
const int inf = 1e9;
const ll INF = 1e18;

struct edge {
    int a, b, c;
};

const int N = 2e5 + 1;
int n, G;
vector <pair <int, int>> g[N];
vector <int> c[N];
edge e[N];

void solve() {
    cin >> n >> G;
    for (int i = 1; i < n; ++i) {
        cin >> e[i].a >> e[i].b >> e[i].c;
        g[e[i].a].emplace_back(e[i].b, e[i].c);
        g[e[i].b].emplace_back(e[i].a, e[i].c);
    }
    for (int i = 1; i <= n; ++i) {
        c[i].resize(sz(g[i]));
        for (int &el : c[i]) {
            cin >> el;
        }
    }
    if (G == 0 || G == 1) {
        vector <int> v(n - 1);
        iota(all(v), 1);
        for (int i = 1; i <= n; ++i) {
            reverse(all(c[i]));
        }
        do {
            int ok = 1;
            vector <int> ptr(n + 1);
            for (int p : v) {
                int a = e[p].a, b = e[p].b, w = e[p].c;
                if (c[a][ptr[a]] + c[b][ptr[b]] < w) {
                    ok = 0;
                    break;
                }
                ++ptr[a], ++ptr[b];
            }
            if (ok) {
                cout << "Yes\n";
                for (int el : v) {
                    cout << el << ' ';
                }
                return;
            }
        } while (next_permutation(all(v)));
        cout << "No";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    int tt = 1;
    while (tt--) {
        solve();
    }
}
