#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve(){
    int n, G;
    cin >> n >> G;
    vector<pair<int, pair<int, int>>> edg;
    vector<int> deg(n, 0);
    for (int i = 1; i < n; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        a-- ;b--;
        edg.push_back({w, {a, b}});
        deg[a]++;
        deg[b]++;
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            cin >> c[i][j];
        }
        std::reverse(c[i].begin(), c[i].end());
    }
    for (int i = 0; i < n; ++i) {
        deg[i] = 0;
    }
    std::sort(edg.rbegin(), edg.rend());
    vector<char> u(n);
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n-1; ++j) {
            if(u[j]) continue;
            int a = edg[j].second.first, b = edg[j].second.second, w = edg[j].first;
            if (c[a][deg[a]] + c[b][deg[b]] >= w){
                ans.push_back(j+1);
                u[j] = 1;
                deg[a]++;
                deg[b]++;
                break;
            }
        }
        if(ans.size() == n-1)
            break;
    }
    if(ans.size() == n-1)
    {
        cout << "Yes\n";
        for (int i = 0; i < n-1; ++i) {
            cout << ans[i] << ' ';
        }
        return;
    }
    cout << "No";
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while(_--){
        solve();
    }
    return 0;
}
/*


 */