//
// Created by olymp on 3/8/24.
//
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using oset = tree<
        ll,
        null_type,
        less<>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

struct Edge {
    int a, b, w;
};

vector<Edge> ed;
vector<int> deg;
vector<vector<int>> st;

void check(vector<int> &res, int n) {
    vector<int> uk(n + 1);
    bool ok = true;
    for (auto &i : res) {
        auto &[a, b, w] = ed[i];
        if (w > st[a][uk[a]] + st[b][uk[b]])
            ok = false;
        uk[a]++, uk[b]++;
    }
    if (!ok)
        return;
    cout << "Yes\n";
    for (auto &i : res) {
        cout << i + 1 << " ";
    }
    exit(0);
    // 3214
}

void gen(vector<int> &res, int n, vector<bool> &used) {
    if (res.size() == n) {
        check(res, n + 1);
        return;
    }
    for (int i = 0; i < res.size(); i++) {
        if (!used[i]) {
            used[i] = true;
            res[n] = i;
            gen(res, n + 1, used);
            used[i] = false;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr),
            cout.tie(nullptr);
    int n, test;
    cin >> n >> test;
    deg.resize(n + 1);
    ed.resize(n - 1);
    for (int i = 0; i < n - 1; i++) {
        auto &[a, b, w] = ed[i];
        cin >> a >> b >> w;
        deg[a]++, deg[b]++;
    }
    st.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        st[i].resize(deg[i]);
        for (auto &j : st[i])
            cin >> j;
        reverse(st[i].begin(), st[i].end());
    }
    vector<int> res(n - 1);
    vector<bool> used(n - 1);
    gen(res, 0, used);
    cout << "No";
}
