#include <bits/stdc++.h>
using namespace std;
vector<vector<pair<int, int>>> graph;
vector<set<pair<int, int>>> stickers;
vector<vector<int>> stickers2;
vector<int> cnt;
vector<int> wss;
void dfs(int x, int p = -1) {
    for (auto &[i, num] : graph[x]) {
        if (i == p) {
            continue;
        }
        dfs(i, x);
        pair<int, int> need = make_pair(wss[num] - (stickers[i].begin()->first), 0);
        auto cur = stickers[x].lower_bound(need);
        if (cur == stickers[x].end()) {
            cout << "No\n";
            exit(0);
        } else {
            stickers2[i][stickers[i].begin()->second] = num;
            stickers2[x][cur->second] = num;
            stickers[x].erase(cur);
        }
    }
}
int main() {
    //cin.tie(0);
    //ios::sync_with_stdio(false);
    int n, g;
    cin >> n >> g;
    graph.resize(n);
    wss.resize(n);
    cnt.resize(n - 1);
    vector<pair<int, int>> edges;
    for (int i = 0; i < n - 1; ++i) {
        int one, two, w;
        cin >> one >> two >> w;
        one--;
        two--;
        edges.push_back({one, two});
        graph[one].push_back({two, i});
        graph[two].push_back({one, i});
        wss[i] = w;
    }
    stickers.resize(n);
    stickers2.resize(n);
    for (int i = 0; i < n; ++i) {
        stickers2[i].resize(graph[i].size());
        for (int j = 0; j < graph[i].size(); ++j) {
            int now;
            cin >> now;
            stickers[i].insert({now, j});
        }
    }
    dfs(0);
    vector<int> topp(n, 0);
    vector<int> now;
    queue<int> q;
    for (int i = 0; i < n; ++i) {
        cnt[stickers2[i][0]]++;
        if (cnt[stickers2[i][0]] == 2) {
            q.push(stickers2[i][0]);
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        int cur = q.front();
        now.push_back(cur);
        q.pop();
        int one = edges[cur].first;
        int two = edges[cur].second;
        topp[one]++;
        if (topp[one] < graph[one].size()) {
            cnt[stickers2[one][topp[one]]]++;
            if (cnt[stickers2[one][topp[one]]] == 2) {
                q.push(stickers2[one][topp[one]]);
            }
        }
        topp[two]++;
        if (topp[two] < graph[two].size()) {
            cnt[stickers2[two][topp[two]]]++;
            if (cnt[stickers2[two][topp[two]]] == 2) {
                q.push(stickers2[two][topp[two]]);
            }
        }
    }
    reverse(now.begin(), now.end());
    cout << "Yes\n";
    for (auto &i : now) {
        cout << i + 1 << " ";
    }
}
