#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

void solve() {
    int n;
    cin >> n;
    int group;
    cin >> group;
    vector<vector<int>> g(n);
    vector<int> need(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].push_back(v);
        g[v].push_back(u);
        int w;
        cin >> w;
        need[v] = w;
    }
    vector<vector<int>> deg(n);
    vector<pair<int, int>> q(n), q2, has;
    for (int i = 0; i < n; ++i) {
        int cnt;
        cin >> cnt;
        deg[i].resize(cnt);
        for (auto &j : deg[i]) {
            cin >> j;
        }
    }
    for (int i = 1; i < n; ++i) {
        q.emplace_back(need[i] - deg[i][0], i);
    }
    for (int i = 0; i < deg[0].size(); ++i) {
        q2.emplace_back(deg[0][i], i);
    }
    std::sort(q.begin(), q.end());
    std::sort(q2.begin(), q2.end());
    int l = n - 2, r = 0;
    vector<int> ans(n);
    while (l > -1) {
        if (q2[r].first + q[l].first < 0) {
            cout << "No";
            return;
        }
        ans[q2[r].second] = q[l].second;
        --l;
        --r;
    }
    cout << "Yes\n";
    for (int i = 0; i < n - 1; ++i) {
        cout << 1 << ' ' << ans[i] + 1 << ' ';
    }
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
    return 0;
}
