#include <iostream>

#include <vector>
#include <set>
#include <map>

#include <algorithm>
#include <numeric>
#include <cmath>


#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int vs, tq;
    cin >> vs >> tq;
    if (tq <= 1) {
        vector<tuple<int, int, int>> ej;
        vector<vector<int>>x(vs);
        for (int i = vs - 1; i--;) {
            int f, t;
            cin >> f >> t;
            f--, t--;
            x[f].push_back(0);
            x[t].push_back(0);
            int w;
            cin >> w;
            ej.push_back({f, t, w});
        }
        for (int v = 0; v < vs; v++) {
            for (int &i : x[v])
                cin >> i;
            x[v] = {rall(x[v])};
        }

        vector<int>ord(vs - 1);
        iota(all(ord), 0);

        do {
            vector<int>ind(vs);
            bool chk = 1;
            for (int i : ord) {
                auto [f, t, w] = ej[i];
                chk &= x[f][ind[f]] + x[t][ind[t]] >= w;
                ind[f]++;
                ind[t]++;
            }
            if (chk) {
                cout << "Yes\n";
                for (int i : ord)
                    cout << i + 1 << ' ';
                return 0;
            }
        } while (next_permutation(all(ord)));
        cout << "No";
    }

    if (tq == 3) {
        vector<int>ej;
        for (int t = 1; t < vs; t++) {
            int f, tq;
            cin >> f >> tq;
            int w;
            cin >> w;
            ej.push_back(w);
        }
        vector<int>xf(vs - 1);
        for (int &i : xf)
            cin >> i;

        for (int di = 0; di < vs - 1; di++) {
            int d;
            cin >> d;
            ej[di] -= d;
        }

        vector<int>orde(vs - 1);
        iota(all(orde), 0);
        sort(all(orde), [&](int l, int r) {return ej[l] < ej[r];});
        vector<int>ordx(vs - 1);
        iota(all(ordx), 0);
        sort(all(ordx), [&](int l, int r) {return xf[l] < xf[r];});

        vector<int>ans(vs - 1);
        for (int i = 0; i < vs; i++) {
            if (xf[ordx[i]] < ej[orde[i]]) {
                cout << "No";
                return 0;
            } else {
                ans[ordx[i]] = orde[i];
            }
        }
        cout << "Yes\n";
        for (int i : ans)
            cout << i + 1 << ' ';
    }

}