/*
⣿⢟⣿⣻⢟⣿⣻⢟⣿⣻⢟⣿⣻⢟⣟⣟⢟⣟⢟⣟⣟⣻⡻⣻⡻⣻⡻⣻⢟⣿⡻⣟⢿⢿⡿⣿⢿⡿⣿⣿⣿⣿⣿⡿⢟⠟⢟⠿⣿⣿⠿⠋⠝⣥⣡⢭⣨⣣⢭⢮⢵⡭⣪⡡⣩⡈⡧⢱⠥⢅⢍⡙⠛⠟⢛⢋⢍⣍⣬⡵⣝⢾⣝⣯⣻⡻⣻⢟⡿⣻⡻⣟⢟⣟⢿⡻⣿⢿⡿⣿⢿⡿⣿⡻⣟⢨⣿⣿⣿⣿
⣯⡻⣮⢷⣻⡵⣯⣻⢮⣯⣻⢮⡷⣻⡵⣏⡿⣪⣟⢾⣪⢷⣝⡽⣝⢷⣝⢯⣻⢮⡿⣝⣟⣿⣺⢯⡿⣾⣻⣞⣷⢟⠬⣂⣱⢞⣦⡢⠴⡌⠠⢈⠂⢞⢑⢳⡳⢕⢋⠕⡡⡑⢅⢊⢂⠳⢈⠢⠑⡂⢂⡩⡜⡴⢥⢣⢝⢦⡻⣺⣝⢷⡵⣳⣝⡽⣝⡽⣞⡽⣞⡽⣝⣽⢽⡽⢯⢷⡛⣙⡕⡿⣽⣻⠃⣼⣿⣿⣿⣿
⢮⡿⣵⢟⣵⢟⣞⢷⣻⣮⢡⣭⣭⡍⣺⢟⣞⢷⡝⡷⡽⡎⣬⣬⣥⣅⢫⢷⣝⢃⣭⣭⣭⣌⢻⡯⢩⣭⣬⣭⠑⣣⢞⡮⣗⢟⠎⣩⣥⣴⣦⣤⣅⢊⢂⠣⢑⣠⣥⣴⣬⣬⣁⡣⣅⣓⡢⡥⣃⠪⠚⣨⣬⣤⣥⣤⣕⡱⡹⡧⣯⡇⣭⣥⣭⡌⢟⡾⣵⡋⣬⣭⣬⣥⣥⣔⣓⢿⡍⡔⣽⢪⣿⡏⢸⣾⣿⣿⣿⣿
⡻⣞⣽⣫⡯⣿⢽⡯⣷⣻⢠⣿⣿⡇⣽⣫⢞⡷⣝⣟⠾⢡⣿⣿⣿⣿⡌⣷⡻⢄⣿⣿⣿⣿⡘⢇⣿⣿⣿⣿⠐⣯⢫⣮⢹⡁⣾⣿⣿⠉⠛⡿⡿⠇⠹⢡⣿⣿⡿⢛⠻⢿⣿⣷⡜⣽⣪⣛⢖⡑⢼⣿⣿⡋⠝⢿⠿⠷⢘⡝⡮⣰⣿⣿⣿⣿⡘⣟⣾⠕⣿⣿⡿⢛⠿⣿⣿⣦⠸⣜⢧⣿⡞⣢⣿⣿⣿⣿⣿⣿
⣝⢷⡽⣮⣻⣗⡿⣽⣞⣿⢐⣿⣿⡇⢾⢵⢯⡻⡮⣯⢃⣿⣿⢇⢹⣿⣷⡘⣿⠄⣿⣿⡝⣿⣇⢹⣿⠇⣿⣿⠐⢃⠅⠄⠢⠠⠹⢿⣿⣿⣿⣶⣦⡑⢍⣾⣿⣿⢰⡟⣷⠈⣿⣿⣧⢸⢮⣝⢵⣫⡘⢿⣿⣿⣿⣶⣶⣅⢫⡺⢠⣿⣿⠃⢻⣿⣧⢙⣴⡎⣿⣿⡗⣿⣷⢹⣿⣿⡆⣿⣟⡾⣨⣾⣿⣿⣿⣿⢿⣿
⡺⣯⡻⣾⢵⣯⣻⣗⢿⣺⢐⣿⣿⡇⣻⡳⣏⣟⢾⠃⣾⣿⣿⣦⣼⣿⣿⣇⢻⠌⣿⣿⠆⢿⣿⣿⣿⠀⣿⣿⡁⡶⡜⢋⡐⡁⣦⣤⡍⣍⡙⢿⣿⣿⢀⢻⣿⣿⡜⠽⠮⣡⣿⣿⡇⡜⢳⣕⢷⡅⣩⣤⣌⢩⡙⢻⣿⣿⡆⢁⣾⣿⣿⣬⣾⣿⣿⣇⢻⡇⣿⣿⣏⠿⠟⣸⣿⣿⢡⣿⠞⢴⣿⣿⣿⣿⣿⣿⣿⣿
⣝⡷⣻⣵⣟⡷⣻⣞⢯⡿⢐⣿⣿⡇⣝⣮⣣⢟⡏⣼⣿⣿⠛⡛⣛⠻⣿⣿⣎⠃⣿⣿⡛⠸⣿⣿⡇⡄⣿⣿⡐⠏⡠⣷⢹⢂⠻⣿⣿⣶⣶⣿⣿⠏⣼⣈⠻⣿⣿⣷⣾⣿⣿⠟⣴⣻⣔⠬⡣⢧⡹⢿⣿⣷⣶⣾⣿⠟⡐⣾⣿⣿⢛⣛⣛⢻⣿⣿⡎⢗⣿⣿⣿⣿⣿⣿⡿⢋⣮⢟⣨⣿⣿⣿⣿⣿⣯⣿⣿⣿
⢮⣻⢽⣞⡷⣻⡯⣾⣫⢿⢦⣭⣭⢵⣛⣎⣝⣍⡦⡭⣭⡥⡾⡶⡶⣤⣭⣭⣥⣬⡭⡭⢔⢧⡩⣍⠔⣤⠭⡩⡀⣱⡻⢎⢇⢜⠷⣦⢭⣩⣍⡭⣴⠺⡵⣽⡱⢦⡭⣍⡍⠭⣔⢟⢮⢖⡽⣲⡕⢕⢝⢦⣭⡭⣭⣭⣴⢾⣅⢭⣭⢡⣿⡽⣿⣦⣭⣭⣵⣦⣭⣭⣭⡭⣩⣴⢞⣯⠏⢤⣿⣿⣿⣿⣿⣽⣿⣿⡿⣿
⡽⣳⣟⢮⡿⣽⠞⣡⢦⡳⡳⣮⢺⢧⣫⢞⡮⣞⢾⢕⢷⣝⣞⢟⣞⢗⡷⡺⡶⣕⢯⡺⡱⡣⡞⣰⢾⡑⡡⢊⢤⢯⡫⣺⢁⣏⡳⡳⢯⡰⣧⢻⣞⢥⡛⣾⣕⡳⣹⢎⡿⣪⡪⣗⢟⣮⡻⣮⣫⡧⡱⡱⣣⢿⣞⢮⣟⡷⡻⢮⣳⡧⢿⣿⣹⣿⣿⢟⣯⣻⣿⣿⢟⣰⢯⣞⢯⠎⣲⣿⣿⣿⣿⣿⢿⣿⣿⢿⣿⣿
⣝⢷⣝⣟⢾⣻⡕⢝⢮⣹⢝⡮⣫⣗⢽⣣⢟⣼⡳⣽⡳⡽⣮⡻⣮⢯⣫⣟⡽⣺⢇⢯⢺⢁⣾⢙⢃⠔⣡⠃⣾⢣⣏⢷⠡⣏⢾⣑⠧⣝⣞⢷⡽⡠⣇⠘⣮⢳⣌⢳⣝⢷⢽⣌⢻⡮⣻⡺⡮⡷⣕⠵⢌⢗⣽⣟⣵⣻⢟⣎⡻⣻⢚⣿⣿⢋⣶⣿⣷⣝⢿⡭⣲⢯⢷⡝⠣⣼⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣺⡻⣮⢯⣻⣮⢿⣌⠳⡱⡇⡯⡺⣪⢷⡭⣫⢾⣝⢮⣯⢻⣎⢿⣪⢷⣳⣝⢞⢵⡱⡣⢃⢜⢡⠊⢎⢼⡣⡸⣳⢕⣯⣻⢘⣧⣫⡲⢱⡯⣺⡳⣽⠂⡮⡱⡈⢷⡻⣆⠙⣷⣫⢾⣆⡙⢷⡽⣺⢯⡻⡷⣝⢮⡦⣻⡼⣗⣿⡉⣯⣕⣝⣾⣥⣿⣻⣷⣻⡧⢿⣞⣯⣻⠏⢌⣿⣿⣿⣿⣿⣿⣿⣽⣿⣿⣽⣿⣿⣿
⢮⣻⡳⣟⣵⢯⡿⣽⣧⢙⢜⢮⢬⢮⣬⣮⣭⣕⡙⠳⢝⠗⡽⡳⡝⢷⢵⣫⢞⣕⡕⢁⣮⢃⠇⡘⣜⢗⢆⡽⣪⢗⢷⢵⠸⢼⡵⣍⢼⣝⡽⣝⡽⡅⢺⠀⣿⡈⢿⡽⡄⢆⠹⣳⣝⢷⡐⢝⢝⢯⣻⣝⣯⢷⣎⠘⠿⣽⣟⣎⠿⣿⣽⣯⡿⣷⣟⣾⣽⣿⣾⣮⣮⡱⡡⣻⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⣿⡿⣿⣿
⣝⢷⡻⣽⡺⣗⡿⣾⣝⣷⣅⠳⡕⣝⢺⡳⣯⢾⡻⣻⡳⣻⢖⡾⣲⢗⡶⡼⡧⡵⢀⡿⣊⡜⡐⢜⣭⣫⢢⢯⢏⣝⢗⢯⢸⢪⣟⠆⡾⣪⢟⡮⣳⢭⠘⡄⢷⣿⡌⢻⣽⡘⣦⢊⠚⣯⢿⣕⡱⣣⢝⡳⡽⣯⢿⣷⣕⠤⣙⠺⣻⢜⣷⣿⣻⢿⡾⣿⣾⢷⣿⣽⣟⢏⠢⣿⣿⣿⣿⣿⣾⣿⣿⣿⣿⣾⣿⣿⣿⣿
⡺⣯⣻⢽⡽⣽⢽⣞⡷⣽⣟⣷⣎⡪⡣⣟⢞⣗⢿⡽⣯⢯⣯⣻⣭⡻⣞⡽⣞⠢⡽⡎⢾⠌⢰⡻⣔⢷⢸⡗⠕⣮⡛⣼⢨⡎⡾⢱⡏⢾⣫⢾⣝⠷⡅⡹⢼⣾⣿⣆⠻⣧⠸⡷⣍⠦⣙⢯⣷⣬⢳⣭⡺⢔⡛⢮⣟⢷⣵⣍⢮⢻⣯⣿⣽⣿⣟⣿⣽⣟⣿⡢⡦⣫⡓⠸⣿⣿⣿⢿⣿⡿⣿⣾⣿⣿⢿⣿⣿⣿
⣽⡺⣗⢿⡺⣗⣟⢾⡽⣷⣽⣻⣞⢿⣜⡮⡫⣞⢷⢝⣯⣻⢽⣯⣻⣟⣮⣻⡎⢼⡫⣴⡻⢠⢹⣝⢞⡧⣻⢘⢕⠮⣱⣻⡐⢧⢃⡿⣝⠼⣳⢯⡞⣿⡱⣘⢾⡷⣿⣭⣵⡸⣶⠸⣿⣿⣦⡕⣌⠳⢇⢻⣟⣷⣬⣕⣨⠒⡑⣎⡗⣿⣿⣻⣷⣿⢾⣟⣯⣿⣿⢎⡾⣆⢻⡔⢩⡻⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿
⢮⣟⣽⣫⣟⡽⣞⣯⡻⡾⣾⢵⣟⣯⢿⡽⣶⣮⡑⢯⣞⢮⡷⣫⢿⢾⣯⣿⢀⣿⢢⢟⡜⢰⢹⣎⢟⡎⣾⠨⡪⡑⡷⣝⣦⡙⡌⣟⣾⠀⢻⣗⢟⣞⢷⢨⢾⣿⣻⡿⣿⣿⣮⣥⡙⣿⣿⢿⣯⢿⣦⢅⣍⢨⣃⢍⣋⡫⡩⡬⢷⣜⣋⢭⢦⡵⣋⡻⣿⣿⡏⣺⣝⣿⡺⣿⠄⣷⣎⠻⣿⣿⢿⣿⣷⣿⣿⡿⣿⣿
⣳⡽⣮⢷⡽⣞⣯⣞⡽⣝⣷⡻⣷⢽⣯⣻⢷⣽⣻⣦⣌⡓⠝⡽⡳⣏⢶⡹⢀⠏⣼⡳⡕⡱⢕⣽⡹⡣⣯⢘⠌⣼⡹⢮⡟⣔⢻⡌⣿⠆⣇⢿⡽⣺⣻⣇⠻⣟⣿⣿⣟⣿⡿⡿⣟⡮⡋⠽⠊⠡⠺⠗⠸⢑⣎⢿⡹⣯⣲⣚⠶⣨⣥⡕⣪⣗⠭⣪⣌⡻⡸⣕⣽⡯⣇⢟⣷⢹⣿⣧⢹⣿⣿⣿⣿⢿⣿⣿⣿⣿
⢮⡻⣞⢷⣻⢞⣮⢞⣽⡺⡮⡿⣽⣳⡯⣷⢿⡺⡷⡽⣯⢿⣻⣦⡙⢮⡳⡻⡌⢣⡿⡵⡇⣜⢕⣧⣻⣕⢷⠨⡂⣾⠝⡽⣸⣿⡕⢿⡌⣷⢹⡎⣿⢽⣮⣻⣪⢻⣿⣯⣿⣿⢍⠊⡈⠄⢐⣤⢪⣷⣶⡠⡔⠇⡞⢦⣝⡤⢅⣹⣾⣿⣿⡿⣺⡧⡳⢨⢎⢕⢎⠰⣿⡽⣫⡪⣿⣸⣿⣿⠢⣿⣿⣿⣿⣿⣿⡿⣿⣿
⡵⣻⣝⢗⣿⣻⣮⡻⣮⡻⣞⣽⣫⢾⡯⣿⡵⣻⢞⣽⡺⣗⡽⣮⣏⠸⢪⢛⢞⢸⡯⡞⡡⢸⡪⡾⢮⣞⣽⡘⢄⡣⡾⣱⣿⣽⣿⡜⣿⡜⣇⢿⣮⢳⡷⡽⣮⢳⣝⢿⣿⢓⣴⣁⡐⡁⢊⡉⡸⣞⣿⣟⣗⠡⣹⣧⣭⠄⣾⣿⡿⣷⢿⡇⣿⡣⣫⠰⡕⢭⣎⢘⣿⡺⡿⡌⣿⠜⣿⣿⢑⣿⣿⣿⣯⣿⣿⣿⣿⣿
⣺⢧⣯⡻⣾⢵⣯⣟⣮⡻⡮⡾⣕⢿⡽⣾⢯⣷⡻⣮⢻⣎⢿⣪⡾⣶⣁⠱⡅⣻⢞⡕⣅⠸⡕⣟⢷⡳⡵⢇⢕⢝⣼⣟⡿⣾⣯⣷⣹⣿⣞⢎⣿⡗⢿⡽⣷⢇⢿⣿⣽⣿⣿⣥⢀⢌⠦⡑⢎⡻⡙⢝⡎⠰⡰⣽⢾⢨⣿⣿⢯⣟⣿⡊⣿⡇⡽⡨⡪⣒⣷⠐⣿⣽⢿⡣⣻⣍⣿⡧⣽⣿⣿⣿⣿⣿⣟⣿⣿⣿
⣝⡿⣾⣽⣻⣯⢷⡿⣮⣟⢾⣝⡽⣳⡽⣺⢟⣾⢯⣞⢷⣹⡳⣿⢿⡺⡇⠒⠠⣯⡻⡆⡪⡈⣗⢯⣫⡯⣻⢸⠸⣎⢷⠯⣻⠛⡞⠟⣷⢿⣿⣷⡹⣿⣎⡻⣽⣿⡘⣿⣿⣿⣿⡿⢦⣠⣰⣾⣶⣞⣿⢮⡿⡐⡕⢺⣿⣺⣿⡟⢼⣯⣿⢌⣿⡆⣙⡮⡢⣵⢿⡈⣿⣯⢿⣏⠼⡇⢾⢒⣿⣿⣿⣿⣽⣿⣿⣿⣿⣿
⢾⣽⣗⡿⣾⡽⣟⣽⡻⣞⢷⡽⣝⣷⣫⣯⢯⣯⣻⣽⣗⢽⡺⡵⣯⡻⢨⢁⢪⢒⢽⡣⡂⢵⡘⢽⢮⡻⣵⢱⠈⣏⠙⢁⠄⠄⡘⢰⣬⣝⣯⣿⣿⣟⣿⣮⡱⢿⣷⡹⣿⣿⣿⣿⣿⣞⣿⣿⣻⣷⢻⣝⡿⡄⣻⡈⣿⣿⣿⣿⣘⣷⢿⠣⣿⡆⡱⣟⢾⡳⣿⡑⣿⢯⡿⣇⣻⣫⢌⣿⣿⣿⣿⢿⣿⣿⣻⣿⣾⣿
⣻⢾⣽⣻⢾⣻⢯⡾⣝⣯⣗⡿⣽⢮⡷⡽⡾⣮⢾⢶⢯⢷⡝⡾⡕⢅⠳⡄⡕⡕⣸⣇⠆⢸⣧⡙⢗⣯⣻⠰⠁⡁⣨⣶⣔⠠⠂⢌⠠⡜⣿⣿⣿⣿⣿⣿⣿⣮⡻⢷⣽⣿⣿⣿⣿⣷⣽⣿⣟⣿⡽⣿⣝⠦⣸⡇⢿⣿⣷⣿⣷⡟⢑⡵⢿⡇⢜⣯⢿⣝⣿⢸⡯⣿⢽⡗⢼⡇⠴⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣽⣻⢷⣯⣟⣽⡳⣯⢿⣮⣟⢾⡯⣷⣻⣝⣟⢾⡳⣯⡻⣳⢟⢽⣰⢝⢮⡪⣊⠎⣼⢷⠀⢹⡮⣷⢌⠳⣝⡇⡃⢶⢾⡿⣿⠧⠑⠅⣃⣸⣼⣿⣿⣽⣿⣟⣿⣿⣿⣯⣻⣽⣿⣿⣿⣿⡾⣯⣿⣿⣗⢿⡇⡗⡬⣟⡸⢟⢞⠿⠑⢤⢪⡟⣾⢇⢪⣟⣿⡺⡯⢸⡯⡻⣽⣟⢸⣷⢱⢹⣿⣿⣽⣿⣯⣿⣿⣽⣿⣿
⢾⡽⣳⢷⡽⣞⣯⣟⣷⣳⡯⣿⠽⡳⡛⣬⢵⢵⢞⡶⣳⡳⣻⢧⡫⣗⢯⠂⣕⠱⣯⣻⠀⢸⢯⡞⣷⡑⢮⡎⢎⠜⢳⢿⢨⣢⡘⣦⣽⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣾⣿⣿⣽⣿⣾⣿⡍⡧⡣⣿⢸⡇⢤⠙⣮⠣⡁⣿⣝⡎⣷⢘⡷⣯⣻⡓⡈⢟⡼⡱⣿⢨⣿⡘⣦⠿⣿⣿⣿⣿⣿⣿⣿⡿⣿
⣳⣝⡷⣻⡽⣫⣺⣗⡯⢞⣹⡦⢳⡴⣻⡪⣗⡽⣳⣝⠗⢿⢘⣇⡫⠔⡡⢠⡑⣝⢷⡭⠀⡱⣻⢮⣫⢧⠘⢧⠫⡖⡄⠻⣮⡷⣯⢿⣿⣟⣿⣿⣿⣽⣿⣟⣿⣿⣿⣿⣿⣿⡿⣿⣿⢿⣿⣷⣿⣿⡟⡥⣓⠕⣿⢐⣿⠰⣹⡇⡇⢸⡿⣮⢐⣿⡁⣿⢿⡕⡭⡌⢺⡪⣓⣿⠢⣿⡇⢺⡽⣚⣿⣿⣽⣷⣿⣿⣿⣿
⢵⣯⢛⣵⢾⣻⢕⢥⡾⣾⡝⢜⡷⣝⡮⣻⠜⣋⣮⣦⠿⢚⡩⣡⣺⡖⢔⢎⡾⣹⡳⠸⡀⠸⣯⢷⡸⣇⢙⢦⡙⢾⡘⣧⡸⣟⣿⣟⣿⣿⣹⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⢝⣾⣿⢕⠩⣿⢀⣿⢸⡻⣎⢢⣟⢿⡖⠠⡿⣧⢸⣟⢮⡃⣿⣐⢯⣪⣿⡑⢾⣻⡐⣟⢷⡜⢿⣿⣿⣿⡿⣿⣿
⡗⣱⣟⣯⢏⡵⢭⣾⣻⣾⠁⣟⢾⣪⢟⣼⣟⡿⡓⠡⣒⣵⡿⣽⢏⢜⡮⣳⢝⡮⠃⡽⠀⡪⣷⡳⢵⡇⢸⡕⣽⠷⣦⠨⣧⠭⣷⣿⡾⣿⣿⣿⣿⣾⣿⣿⣿⢿⣿⣿⣿⣾⣾⣿⣿⣿⣿⣻⣾⣿⣿⣿⡙⠌⡗⢤⣿⢸⣿⣕⣯⣾⣿⢁⠂⢿⣻⡄⣿⢴⢣⣿⣿⡜⣾⢷⡝⢺⣟⣧⠸⣿⣞⣕⢻⣿⣿⣿⣿⣿
⢧⡨⢛⠝⠰⣯⠸⣷⣻⡇⢸⣫⢳⢵⣿⣳⠟⡡⢊⡞⢿⣽⢟⢥⣞⢵⡫⣞⠕⡡⢜⠎⣸⠰⣿⡵⣿⠁⣪⠎⣾⣛⢾⡄⢿⡧⡜⢿⣿⡝⣿⣿⣟⣿⣿⣷⣿⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⢻⢟⣋⡊⡝⣸⡿⣸⡷⣿⣸⣯⠗⡨⡃⢸⣿⡇⣻⣮⠸⣿⣿⡇⣿⣻⣎⢹⣯⢿⡆⢽⣿⣞⣧⡻⣿⣿⣻⣿
⣻⣟⣿⣻⣮⣙⡦⢍⡘⢧⠘⢧⣻⡷⢋⣭⡕⣹⣯⣇⠸⣯⣞⢗⡷⣹⢮⠳⡜⡕⡝⣰⡏⢼⣷⣟⡯⠠⡧⢹⣯⣻⣵⢇⣌⠻⡼⣎⡛⢿⣮⡻⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣟⣿⣿⣿⣿⠛⣋⢊⡾⡽⡆⡱⣸⡯⢺⡿⣇⢿⡾⠡⡣⡑⢘⣷⣗⢹⣯⢧⡹⣿⡗⣿⣵⢧⢹⣷⡻⣿⡠⣻⣿⣿⢯⠺⣿⣿⣿
⣽⡾⣽⣽⢯⣟⡿⣻⢏⣮⢛⣶⡷⣴⢿⡛⢵⢿⡝⣧⠘⣿⢮⢛⣩⣛⠕⡭⣪⠊⣰⢿⢬⡿⣮⢿⠠⡞⢰⣿⣳⣟⡾⢰⡿⣎⠦⡧⢝⢶⣩⣃⢛⠿⠿⢯⣿⣿⢿⣿⣿⡿⣿⣿⣿⢿⣺⢟⣾⣫⢗⣽⠻⡀⠳⢸⣿⠸⣿⡅⡿⣟⠨⡃⢜⠀⣿⣧⢹⣿⢖⢕⢿⡯⣺⣯⡗⢹⣞⢝⣯⣷⠨⣿⣿⣿⡑⢿⣿⣿
⣞⣿⣻⢾⢿⡝⢨⣗⢡⡷⣸⡯⡷⢹⣏⢫⡹⣣⣽⢇⢪⣧⣾⣿⡋⡕⢎⠎⣠⡼⠯⢋⣴⢿⢮⣣⢟⢆⣟⢷⣻⡵⢃⣿⣻⢾⣅⢏⢞⢵⢜⢵⢍⡞⣚⠶⣢⢕⡍⢧⠬⣩⢝⣏⣵⣾⣯⣟⣮⡷⠗⢃⠨⠰⠘⠾⢎⡇⢿⡸⠜⡷⢈⠇⡪⢀⣿⡞⢽⣿⢸⡡⡫⡗⣽⡷⣏⠸⣇⢧⢻⡾⣆⢚⣿⣯⡇⣻⣿⣿
⢉⣎⠷⠝⠕⡙⠸⢆⢌⡷⣯⢞⡕⣽⢯⣸⣷⢟⣮⣽⢾⣟⡷⣑⠋⣉⣠⣲⡭⠀⢢⣿⣝⣵⡯⡯⣫⣽⣽⣫⣾⠡⣽⡳⣿⣹⡮⢆⢫⡳⡱⡳⣕⡇⢸⡕⣗⢵⡹⡢⣳⠑⠇⣈⠉⡚⢉⢉⠄⢔⢐⠅⡑⣜⡜⣆⢢⡌⡌⡺⡡⠺⡄⢃⠆⠠⡿⡋⣼⡷⠐⡥⡫⢌⣿⣽⢧⠐⡗⡵⣙⣯⣿⡀⢻⣿⠇⣽⣿⣿
⣫⠇⡑⡡⣸⣞⣿⢾⢢⡟⡞⢥⡟⣼⢱⣟⡾⣻⣮⣿⣻⡏⠼⠿⠿⢟⡛⣭⡖⣱⢿⢮⣟⡾⡩⢞⡶⣻⣮⢿⢁⡾⣿⣝⡾⣽⢁⡾⠈⡓⡙⢚⠞⣔⠞⠮⢎⢐⣉⣤⢶⡾⣥⢄⠸⠄⢣⠐⣄⣅⢮⣼⢣⣿⡣⢹⣶⣬⡲⢌⢣⠊⠸⡣⢊⠐⣯⡀⣿⢏⢨⢢⡫⢰⡿⣞⢷⠀⢺⢪⠆⣻⣞⣿⡈⢿⣣⣿⣿⣿
⠀⣱⠈⣼⣯⡿⣽⠇⣺⣅⣣⣟⢷⢶⡟⣷⡽⣿⢾⣯⣟⢸⣿⣷⣿⣷⢿⣫⡶⣟⣽⢫⢎⢞⡸⣎⡯⣿⠎⣵⠫⣜⣷⢯⡟⡡⠎⣠⡶⣾⣾⣿⣷⠮⡔⢲⣺⢿⡿⣽⣗⣿⢿⣯⢓⢱⣷⣿⣷⣾⣿⡿⣼⣿⡱⠹⣿⣿⣿⣷⣾⣬⣅⡛⠦⡙⠦⣫⣞⢕⢸⢢⢑⡿⣽⡯⣷⠀⣣⢫⡣⡸⣷⢯⣟⢌⢿⣿⣿⣿
⡘⣼⡅⣿⣟⣾⡟⣠⣿⢽⡯⣾⠏⣵⣿⣽⣻⣟⡿⡷⣹⣿⡿⢾⣣⡷⣿⢱⠟⢝⠪⣡⡶⣿⢹⡮⡳⣣⣾⠯⡱⣽⡽⡋⣜⢕⣾⣿⠟⣾⣿⣿⡟⣜⢸⣲⣯⣟⣿⣽⣯⡛⣭⣣⣿⣦⡻⡛⣿⣿⣿⢧⣿⣿⢸⢃⣿⢿⡿⣿⣿⣿⣿⣿⣿⣿⣷⣯⣵⣅⣛⠥⣫⡼⣷⣻⣮⠀⣽⡔⣝⠔⣿⣝⡿⣦⢙⣿⣿⣿
⢘⣞⢷⣝⢿⣾⢡⡿⣷⣻⣽⣻⡼⣿⢾⡷⣿⣻⡿⣱⣿⡟⠵⣫⣭⣮⠖⠠⡑⠄⣡⣿⣽⣫⡗⢃⣼⠛⡜⣎⡺⡺⢃⡞⣴⣿⢟⢣⣿⣿⣿⢟⠼⢢⣻⣿⣿⣿⣿⣿⣿⣿⢔⣿⠷⣯⣏⣾⣾⣿⣿⢸⣿⡗⡯⢴⢽⣮⢿⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣶⣾⣙⠻⢞⣽⣗⠀⣽⣷⢱⡃⢺⣯⣟⢾⡆⣻⣿⣿
⠪⡪⠷⠽⠶⣝⠇⢿⣻⣗⣿⣞⣿⣽⣿⣻⣿⡽⣃⣿⠋⢔⣮⣾⡿⠃⢠⠙⡌⣼⣟⢷⢳⡎⠰⡱⢃⢝⢬⣟⢼⢣⢏⣾⢟⢱⣵⣿⣿⡿⡩⡺⢁⣿⣿⣿⣿⣿⣿⣿⢿⣿⣕⣵⣷⣭⣣⣿⣿⣿⡏⣾⣿⣹⠇⣿⡚⣿⡞⣿⣿⣿⣿⣿⣻⣿⣿⣿⣿⣿⣿⣿⣿⣧⡪⠱⣯⠀⣟⣿⣧⢫⢸⣿⢞⡿⣇⢪⣿⣿
⢛⣚⣷⣻⣵⡱⣫⠘⣻⣞⡷⣻⢞⣷⣻⣯⠚⣬⡾⢡⢊⣾⡿⢋⠔⡢⢑⣱⣾⡻⣞⠷⠋⣰⢁⢂⢗⡱⢰⣯⠟⢌⢣⣔⣾⣿⣿⣿⡟⡰⡑⢅⣿⣿⣿⣿⣿⣯⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⡇⣿⢏⣾⠁⢼⡇⣿⣿⣹⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⣿⣿⣗⢧⡸⢰⡇⣿⣿⣧⡸⣯⣯⣻⡏⡮⣿⣿
⢿⢝⡯⣷⢻⢿⠔⡡⡀⢿⡽⣯⢿⡵⣿⢾⡄⣻⣇⠥⢼⣵⣴⣤⣷⣾⢿⢝⣭⡩⢠⢒⢝⢔⡁⢔⢕⢵⢈⢏⡆⣳⣿⣿⣿⠿⡾⡟⡰⡑⢡⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣯⡟⢢⡟⣰⠸⣗⢼⣿⡎⣿⣿⣿⣯⣿⣷⣿⣿⡿⣿⣷⣿⣿⢿⣿⡎⣇⢸⣷⢹⣿⣿⢸⣗⢷⣽⡊⣯⣿⣿
⢒⠎⣃⣑⣁⣂⠑⠌⣂⣙⣙⣓⣋⣛⠛⣙⣂⡹⢀⠏⣒⣉⠮⣙⣛⣙⣃⣛⠯⣿⣦⠑⣕⢕⠆⢈⣊⣐⣑⡈⣲⢟⣋⣛⢳⣉⣊⣘⡈⣊⣙⣛⣛⣛⣙⣛⢚⣙⣋⣓⣛⣛⡋⣿⣿⣿⡟⣙⣋⣛⣙⣃⢸⠃⣛⣈⠳⡪⡿⢃⣛⣋⣛⠿⣿⡿⢛⣙⣛⣙⠿⣿⣿⣿⣿⣇⠗⣘⣛⣀⣛⠷⣹⢋⣓⣙⣁⣛⣚⢻
⡅⣾⣿⡛⠻⠿⠷⡀⣿⣿⠟⠛⠛⢛⡄⢿⣿⣷⣄⠑⣿⣿⠠⣻⣿⡟⠻⢿⣷⡜⣿⣿⣤⠃⣼⣿⡿⠛⢿⣿⠜⢼⣿⣿⢸⡏⣿⣿⡇⣛⣛⢻⣿⡟⣛⣛⢸⣿⣿⠛⠛⠛⣃⣿⣿⣿⡇⣿⣿⠛⡻⣿⣷⠀⣿⣿⠅⣃⣾⣿⢟⡻⢿⡷⠙⣴⣿⡟⠙⠿⠷⢸⣿⣿⣿⢢⣾⣿⢟⡻⣿⣷⡙⢜⣿⣿⠛⣛⢛⣸
⣤⡙⠿⢿⣿⣷⣎⠃⣿⣿⡿⠿⠿⠇⡁⢿⣿⠻⣿⣮⣿⡿⠠⣽⣿⡇⣯⢸⣿⡇⣽⣿⣿⡇⣿⣿⠰⡑⠔⠶⢿⢺⣿⣿⠸⣁⣿⣿⡇⣿⣿⢸⣿⡇⣿⣿⢳⣿⣿⠿⠿⠿⢪⣿⣿⣿⡇⣿⣿⣶⣾⡿⠟⡄⣿⣿⡃⢸⣿⣯⢸⣿⠶⠿⢿⢌⠻⢿⣿⣷⣮⢻⣿⣿⣯⢸⣿⡇⣿⡿⢸⣿⡇⢸⣿⣿⢷⡾⡆⣿
⡇⢾⣿⣔⣢⣿⡿⠀⣿⣿⣦⣤⣥⣥⠁⣿⣿⢅⡙⣿⣿⣟⠐⢾⣿⣧⣤⣾⣿⢣⣿⣾⣽⣧⠻⣿⣦⣬⣾⣿⢃⠎⢿⣿⣤⣥⣿⡿⢡⡈⣄⢸⣿⡏⣿⣿⡳⣿⣿⣬⣭⣭⡍⣿⣿⣿⡇⣿⣿⢠⣶⠀⣾⡇⣿⣿⢆⣌⢿⣿⣬⣥⣾⡿⢂⢻⣿⣆⣢⣿⣿⢱⣿⣿⣿⡘⢿⣷⣬⣥⣿⡿⢣⡱⣿⣿⢀⣾⡖⣿
⢛⣢⡭⣩⢋⡍⢖⢧⠉⡉⣍⢭⢍⡭⡤⣩⡩⡴⣏⢌⡉⢭⣜⣭⣍⢩⣭⣭⣶⣷⣭⣻⣿⣿⣷⣭⣽⣭⣭⡁⠢⢈⢤⢍⣙⢍⢭⢔⠵⡱⣌⢬⠍⡭⣿⣿⣭⣭⣭⣭⣭⣭⣥⣿⣿⣿⣧⣭⣭⣴⡿⠀⡿⢅⠉⠭⣴⣿⣷⣬⣽⣭⣽⣶⢣⣶⣭⣭⣫⣭⣴⣿⣿⣿⣿⠃⡴⣭⣽⣭⣩⣶⣿⣬⣭⡍⣔⣿⢇⣿
⢏⠎⡢⡱⢔⢎⡾⢮⡖⢐⢜⠦⡳⢜⡪⣆⢳⡱⡱⢆⢜⠰⣮⣟⡿⢸⣝⣛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⡀⢮⢢⡑⡬⣣⣛⢜⡕⡳⡜⣬⢃⢗⢸⣿⣿⣿⣿⣿⣿⡿⣿⣿⣿⣿⣿⣿⠟⢋⢙⡄⡳⣀⡁⡲⣄⢭⢐⣉⠻⣿⢿⣧⣾⣿⣿⣿⣿⣿⣿⣿⣿⣿⡏⡰⡨⣿⣿⠗⣼⣟⣾⣻⡞⢦⣹⣿⢸⣿
⠕⡸⡴⣻⢝⢋⢋⠕⡙⣀⣌⡑⣝⢊⣐⣁⠳⣈⣈⣊⣠⣃⣙⢻⣗⡐⣿⣿⠿⢛⣉⣍⣙⡻⢿⣋⣋⣋⣋⣛⣛⠢⡃⣉⣈⣑⣉⣑⣈⢳⢈⣂⣅⣙⣀⡻⢿⡟⣉⣋⠛⣘⣛⣙⣋⣋⣙⡁⠂⡔⢡⠃⠸⣀⣭⣨⣐⡑⠕⠭⡲⣁⣄⣘⠿⠟⠟⣙⣙⣙⣋⣛⡛⠻⢁⣌⣘⣋⣋⣊⠿⣮⣳⡟⡐⣮⣿⢇⣿⣿
⣸⣝⢾⡑⢔⠅⡕⢌⡂⢽⣿⡇⢈⠰⣿⣿⠨⣸⣿⡟⠛⢻⣿⡇⣿⢧⣜⠏⣼⣿⡟⣛⠿⠿⠎⣺⣿⣿⠛⢻⣿⣷⢸⢽⣿⡟⠛⠛⠛⡸⢼⣿⡟⡛⢿⣿⡆⡇⣿⣿⠀⡛⡛⢻⣿⡟⢛⣃⢜⢕⠱⢡⣾⣿⢟⡛⠿⠷⢘⡕⢰⣿⣿⣿⡆⢺⠂⣿⣿⡛⠛⣿⣿⠆⢸⣿⣿⠛⢿⣿⣦⢳⡟⡠⣹⣾⢏⣼⣿⣿
⢧⡻⣎⢆⢕⠌⢊⣤⡅⢾⣿⡇⢨⢐⣿⣿⢀⢺⣿⡿⢿⣿⡟⢁⢿⣝⣿⡆⣿⣿⢈⠫⣓⡻⠿⢺⣿⣿⢿⣿⣟⢣⡾⣹⣿⡿⠿⠿⠟⢼⢸⣿⡇⢌⢸⣿⡧⠐⣿⣿⠀⢎⠀⣹⣿⡇⡣⡕⡕⢭⡊⢸⣿⣯⢈⢟⢒⡛⠧⢃⣾⣿⡀⣿⣿⡰⡇⣿⣿⠿⣿⣿⡋⣼⢸⣿⣿⢸⢅⣿⣿⠘⠄⣾⣿⢋⣼⣿⣿⣿
⡳⣝⢾⠆⣢⣼⣿⣿⣿⡸⣿⣷⣦⣾⣿⠏⡄⣹⣿⡇⢌⢿⣿⣎⠢⣯⢺⠃⠹⣿⣷⣵⣾⡿⢃⢾⣿⣿⢠⠻⣿⣧⡙⣽⣿⣷⣵⣾⣶⢩⢺⣿⣷⣶⣾⡿⢃⢈⣿⣿⠈⠮⡅⢸⣿⡇⢎⠎⡪⠡⡊⢄⢻⣿⣦⣷⣿⡿⠁⣾⣿⠟⠻⠻⣿⣧⠁⣿⣿⡱⡜⣿⣿⡜⢸⣿⣷⣶⣾⣿⠏⣈⢾⡟⣡⣿⣿⣿⣿⣿
⣝⢷⡙⣼⣿⢿⣿⣽⣿⢷⣶⡍⢉⢍⠤⡪⡒⡌⡍⣡⢎⠦⡩⡩⡰⣄⢑⡑⡣⡈⢍⢉⠡⠒⡳⣄⠥⠥⠾⠷⠭⣭⣤⣬⣭⣬⣥⣭⣬⣴⣬⣉⢉⠅⠡⠠⡈⢀⣉⡉⡀⠣⠢⢌⢉⠡⡂⢕⠨⡢⢑⠌⠔⣮⣍⠩⢤⠲⡅⢉⠌⡜⠿⢓⠍⠩⠴⣭⣭⣼⣿⣬⣥⣥⣬⡭⢥⢩⢤⣦⢜⠣⣵⣾⣿⣿⣿⣿⣿⣿
⢞⢵⡃⣿⡽⢫⣥⣵⣥⣮⣰⣑⢠⡊⢎⢎⢜⠜⡔⢕⢕⠕⡕⡜⡢⢎⡄⢫⠰⡈⢢⠁⢎⠨⡂⢵⠀⢘⢖⢔⡄⠈⠛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣦⡝⡊⢖⢥⠄⡱⠠⡈⢕⠑⠔⡡⢑⢌⠢⡑⡬⡪⣣⡑⠘⢷⢽⣌⠣⡈⠢⡰⡨⡪⡢⡹⡰⡡⡈⠻⣿⣿⣿⢯⡷⣽⣶⣿⣿⣿⣷⡹⡝⣿⣿⣿⣿⣿⣿⣿⣿
*/

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pint pair<int, int>
#define gay MikeKalyzhnyy
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

#ifndef LOCAL
#pragma GCC optimize("unroll-loops,O3")
//#pragma GCC target("avx2")
#endif

void dumb_1(int n) {
    vector<pair<pint, int>> e;
    vector<int> deg(n);
    for (int i = 1; i < n; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        deg[a]++, deg[b]++;
        e.emplace_back(make_pair(a, b), c);
    }
    vector<vector<int>> vals(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < deg[i]; ++j){
            int x;
            cin >> x;
            vals[i].push_back(x);
        }
    }
    vector<int> ind(n - 1);
    iota(all(ind), 0);
    do {
        vector<int> j(n);
        for (int i = 0; i < n; ++i) {
            j[i] = deg[i] - 1;
        }
        bool bad = false;
        for (auto& i : ind) {
            auto [a, b] = e[i].first;
            int c = e[i].second;
            if (vals[a][j[a]] + vals[b][j[b]] >= c) {
                j[a]--;
                j[b]--;
            } else {
                bad = true;
            }
        }
        if (!bad) {
            cout << "YES\n";
            for (auto& el : ind) cout << el + 1 << ' ';
            return;
        }
    } while (next_permutation(all(ind)));
    cout << "NO\n";
}

vector<vector<pint>> graph;
vector<vector<int>> v;
vector<vector<pint>> TO;
vector<vector<char>> used;
vector<int> parent;

void dfs(int u, int p) {
    parent[u] = p;
    for (auto& [to, w] : graph[u]) {
        if (to == p) continue;
        dfs(to, u);
        int left = 0;
        while (used[to][left]) left++;
        int z = v[to][left];
        int mn = -1;
        for (int j = 0; j < graph[u].size(); ++j) {
            if (used[u][j]) continue;
            if (z + v[u][j] >= w) {
                if (mn == - 1 || v[u][mn] > v[u][j]) mn = j;
            }
        }
        if (mn == -1) {
            cout << "NO\n";
            exit(0);
        }
        TO[u][mn] = {to, left};
        TO[to][left] = {u, mn};
        used[to][left] = 1;
        used[u][mn] = 1;
    }
}

inline void solve() {
    int n;
    cin >> n;
    int g;
    cin >> g;
    if (g == 1) {
        dumb_1(n);
        return;
    }
    graph.resize(n);
    v.resize(n);
    map<pint, int> IND;
    for (int i = 1; i < n; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        graph[a].emplace_back(b, c);
        graph[b].emplace_back(a, c);
        IND[{min(a, b), max(a, b)}] = i;
    }
    parent.resize(n);
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < graph[i].size(); ++j) {
            int x;
            cin >> x;
            v[i].push_back(x);
        }
    }
    TO.resize(n);
    used.resize(n);
    for (int i = 0; i < n; ++i) TO[i].resize(graph[i].size());
    for (int i = 0; i < n; ++i) used[i].resize(graph[i].size());
    dfs(0, 0);
    cout << "YES\n";
    vector<int> ind(n);
    for (int i = 1; i < n; ++i) {
        for (int u = 0; u < n; ++u) {
            if (ind[u] == graph[u].size()) continue;
            int to = TO[u][ind[u]].first;
            if (ind[to] == graph[to].size()) continue;
            if (TO[u][ind[u]].second == ind[to]) {
                ans.push_back(IND[{min(to, u), max(to, u)}]);
                ind[u]++;
                ind[to]++;
                break;
            }
        }
    }
    reverse(all(ans));
    for (auto& el : ans) cout << el << ' ';
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}
