//#pragma GCC optimize("Ofast, inline, unroll-loops")
#include <bits/stdc++.h>


using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

using ll = long long;

const int inf = 2e9 + 2000;
const ll infll = 2e18 + 2000;
const ll modll = 2286661337;
const int R = (1 << 19);

template<typename T>
void sort(T &s) {
    sort(all(s));
}

template<typename T>
void rsort(T &s) {
    sort(rall(s));
}

mt19937 rnd(124);


struct Elem{
    int a, b, w;

    Elem(int a, int b, int w) : a(a), b(b), w(w) {}
};


vector<vector<int> > g;
vector<int> pair2;
vector<int> used;

int t = 0;
bool dfs(int v) {
    used[v] = t;

    for (auto u : g[v]) {
        if (pair2[u] == -1 || (used[pair2[u]] < t && dfs(pair2[u]))) {
            pair2[u] = v;
            return true;
        }
    }

    return false;
}


vector<vector<int> > ng;
vector<int> ts;
vector<bool> nused;

void ndfs(int v) {
    nused[v] = true;

    for (auto u : ng[v]) {
        if (!nused[u]) {
            ndfs(u);
        }
    }

    ts.push_back(v);
}

signed main() {
    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout << setprecision(20) << fixed;

    int n, group;
    cin >> n >> group;


    vector<Elem> reb;
    vector<int> deg(n);
    map<pair<int, int>, int> ind;

    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;

        deg[a - 1]++;
        deg[b - 1]++;

        reb.emplace_back(a - 1, b - 1, w);
        ind[{a - 1, b - 1}] = i + 1;
    }


    vector<vector<pair<int, int> > > st(n);
    vector<int> wv;
    int ko = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < deg[i]; ++j) {
            int c;
            cin >> c;

            st[i].emplace_back(c, ko);
            wv.push_back(i);
            ++ko;
        }
    }

    g.resize(ko);
    used.resize(ko, -1);
    pair2.resize(ko, -1);


    for (auto [a, b, w] : reb) {
        for (int i = 0; i < deg[a]; ++i) {
            for (int j = 0; j < deg[b]; ++j) {
//                cout << st[a][i].first << ' ' << st[b][j].first;
                if (w <= st[a][i].first + st[b][j].first) {
                    g[st[a][i].second].push_back(st[b][j].second);
                    g[st[b][j].second].push_back(st[a][i].second);
//                    cout << "A";
                }
//                cout << "\n";
            }
        }
    }

    for (int i = 0; i < ko; ++i) {
        if (dfs(i)) {
            ++t;
        }
    }

//    for (auto i : g) {
//        for (auto j : i) {
//            cout << j << ' ';
//        }
//        cout << "\n";
//    }


    vector<pair<int, int> > pa;
    vector<int> wpa(ko);
    vector<bool> us(ko);

    int kol = 0;

    for (int i = 0; i < ko; ++i) {
        if (pair2[i] != -1) {
            us[i] = true;
            us[pair2[i]] = true;

            if (ind[{wv[pair2[i]], wv[i]}] != 0) {
                ++kol;
                pa.emplace_back(pair2[i], i);
                wpa[i] = sz(pa) - 1;
                wpa[pair2[i]] = sz(pa) - 1;
            }
        }
    }

    if (kol != n - 1) {
        cout << "No";
        exit(0);
    }

    cout << "Yes\n";

    ng.resize(n - 1);
    nused.resize(n - 1);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < deg[i] - 1; ++j) {
//            cout << wpa[st[i][j].second] << ' ' << wpa[st[i][j + 1].second] << "\n";
            ng[wpa[st[i][j].second]].push_back(wpa[st[i][j + 1].second]);
        }
    }

//    for (auto i : ng) {
//        for (auto j : i) {
//            cout << j << ' ';
//        }
//        cout << "\n";
//    }

    for (int i = 0; i < n - 1; ++i) {
        if (!nused[i]) {
            ndfs(i);
        }
    }


    for (auto i : ts) {
        cout << ind[{wv[pa[i].first], wv[pa[i].second]}] << " ";
    }
}
