#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <random>

using namespace std;

typedef long long ll;
typedef string str;
typedef long double ld;
mt19937 rnd(157);

#define all(a) a.begin(), a.end()
// #define int long long

vector<vector<vector<int>>> g;
vector<vector<pair<int, int>>> pap;
vector<vector<int>> ans_for_v;
map<pair<int, int>, int> edges;
vector<int> hah;
vector<int> ans;
bool flag = true;

void dfs(int v, int p) {
    vector<pair<int, int>> haha2;
    for(auto el : g[v]) {
        int u = el[0];
        if(u != p) {
            dfs(u, v);
            int w = el[1];
            int ind = el[2];
            haha2.emplace_back(w - hah[u], u);
        }
    }
    sort(all(haha2));
    int i = 0;
    int j = 0;
    while(i < haha2.size() && j < pap[v].size()) {
        // auto[w1, u] = haha2[i];
        // auto[w2, ind2] = pap[v][j];
        int w1 = haha2[i].first;
        int u = haha2[i].second;
        int w2 = pap[v][j].first;
        int ind2 = pap[v][j].second;
        if(w2 >= w1) {
            ans_for_v[v][ind2] = u;
            i++;
            j++;
        } else {
            ans_for_v[v][ind2] = p;
            hah[v] = w2;
            j++;
        }
    }
    if(i < haha2.size()) {
        flag = false;
    }
    if(j < pap[v].size()) {
        ans_for_v[v][pap[v][j].second] = p;
        hah[v] = pap[v][j].first;
    }
}

void dfs2(int v, int p) {
    for(auto u : ans_for_v[v]) {
        if(u != p) {
            dfs2(u, v);  
        } else {
            ans.push_back(edges[{v, p}]);
        }
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, trash;
    cin >> n >> trash;
    g.resize(n);
    hah.resize(n, 0);
    pap.resize(n);
    ans_for_v.resize(n);
    vector<int> deg(n, 0);
    for(int i = 1; i <= n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[v].push_back({u, w, i});
        g[u].push_back({v, w, i});
        deg[u]++;
        deg[v]++;
        edges[{u, v}] = i;
        edges[{v, u}] = i;
    }
    for(int i = 0; i < n; i++) {
        ans_for_v[i].resize(deg[i], 0);
        for(int j = 0; j < deg[i]; j++) {
            int c;
            cin >> c;
            pap[i].emplace_back(c, deg[i] - j - 1);
        }
        sort(all(pap[i]));
    }

    dfs(0, 0);
    if(!flag) {
        cout << "No";
    } else {
        cout << "Yes\n";
        dfs2(0, 0);
        for(auto el : ans) {
            cout << el << ' ';
        }
    }
}