#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

using ll = long long;
using lll = __int128_t;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using dui = pair<int, int>;
using dul = pair<long, long>;
using vi = vector<int>;
using vll = vector<long long>;
using ld = long double;

constexpr int MX = 2'000'000'000;
constexpr long long MXL = 4'000'000'000'000'000'000;

struct rebro {
    int u, v, w;
};

bool dfs(vi &ans, vi &used, vector<rebro> &r, vi &pos, vector<vi> &a) {
    if (count(used.begin(), used.end(), 1) == used.size()) {
        return 1;
    }
    for (int i = 0; i < used.size(); i++) {
        if (used[i]) continue;
        rebro cur = r[i];
        if (cur.w <= a[cur.u][pos[cur.u]] + a[cur.v][pos[cur.v]]) {
            pos[cur.u]++;
            pos[cur.v]++;
            used[i] = 1;
            ans.push_back(i + 1);
            if (dfs(ans, used, r, pos, a)) {
                return 1;
            }
            ans.pop_back();
            pos[cur.u]--;
            pos[cur.v]--;
            used[i] = 0;
        }
    }
    return 0;
}

void solve1(int n) {
    vector<rebro> r;
    vi sz(n + 1);
    for (int i = 1; i < n; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        sz[u]++;
        sz[v]++;
        r.push_back({u, v, w});
    }
    vector<vi> a(n + 1);
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < sz[i]; j++) {
            int k;
            cin >> k;
            a[i].push_back(k);
        }
        reverse(a[i].begin(), a[i].end());
    }
    vi ans;
    vi used(n - 1);
    vi pos(n + 1);
    if (dfs(ans, used, r, pos, a)) {
        cout << "YES\n";
        for (auto i: ans) cout << i << ' ';
    } else {
        cout << "NO\n";
    }
}

void solve2(int n) {
    vector<rebro> nen;
    vi we;
    for (int i = 1; i < n; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        nen.push_back({u, v, w});
        we.push_back(w);
    }
    vector<vi> a(n + 1);
    for (int i = 1; i <= n; i++) {
        if (i == 1 or i == n) {
            int k;
            cin >> k;
            a[i].push_back(k);
        } else {
            int k;
            cin >> k;
            a[i].push_back(k);
            cin >> k;
            a[i].push_back(k);
        }
    }
    vector<vector<vi>> dp(n + 1, vector<vi>(2, vi(2)));
    if (a[1][0] + a[2][0] >= we[0]) {
        dp[2][0][1] = 1;
    }
    if (a[1][0] + a[2][1] >= we[0]) {
        dp[2][1][1] = 1;
    }
    for (int v = 3; v <= n; v++) {
        if (a[v][0] + a[v - 1][0] >= we[v - 2]) {
            dp[v][0][0] = dp[v - 1][1][0] or dp[v - 1][1][1];
        }
        if (a[v][1] + a[v - 1][0] >= we[v - 2]) {
            dp[v][1][0] = dp[v - 1][0][0] or dp[v - 1][0][1];
        }
        if (a[v][1] + a[v - 1][1] >= we[v - 2]) {
            dp[v][1][1] = dp[v - 1][0][0] or dp[v - 1][0][1];
        }
        if (a[v][0] + a[v - 1][1] >= we[v - 2]) {
            dp[v][0][1] = dp[v - 1][1][0] or dp[v - 1][1][1];
        }
    }
    vi ans;
    vector<rebro> por;
    auto vosst = [&](int v, int f, int s) {
        por.push_back({v, f, s});
        while(v != 2) {
            v--;
            if (f == 1) {
                if (dp[v][0][0]) f = 0, s = 0;
                else if (dp[v][0][1]) f = 0, s = 1;
                else exit(3);
            }
            else {
                if (dp[v][1][0]) f = 1, s = 0;
                else if (dp[v][1][1]) f = 1, s = 1;
                else exit(3);
            }
            por.push_back({v, f, s});
        }
        sort(por.begin(), por.end(), [](const rebro &a, const rebro &b) {
           return a.v + a.w > b.v + b.w;
        });
        for (int i=0;i<por.size();i++) {
            ans.push_back(por[i].u - 1);
        }
    };
    if (dp[n][0][0] + dp[n][0][1] + dp[n][1][0] + dp[n][1][1] != 0) {
        if (dp[n][0][0]) vosst(n, 0, 0);
        else if (dp[n][1][0]) vosst(n, 1, 0);
        else if (dp[n][1][1]) vosst(n, 1, 1);
        else vosst(n, 0, 1);
        cout << "YES\n";
        for (auto i : ans) cout << i << ' ';
    }
    else {
        cout << "NO\n";
    }
}

void solve() {
    int n, g;
    cin >> n >> g;
    if (g == 1) {
        solve1(n);
    }
    else if (g == 2 or g == 0) {
        solve2(n);
    }
}

int main() {
#ifdef LOCAL
    freopen("inputf.txt", "r", stdin);
    freopen("outputf.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
