#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
const ll INF = 2e9, MOD = 1e9 + 7, N = 2e5 + 100, K = 26;
mt19937 rnd(24246);
vector<tuple<int, int, int>> g[N];
vector<set<pair<int, int>>> st(N);
vector<vector<int>> c(N), pr(N), pr2(N);
vector<int> s(N);
vector<int> ans;

void dfs2(int v) {
    while (s[v] < g[v].size() && pr[v][s[v]] != -1) {
        ans.push_back(pr[v][s[v]]);
        int to = pr2[v][s[v]];
        s[to]++;
        s[v]++;
        dfs2(to);
    }

}


void dfs(int v, int p, int wp, int wid) {
    for (auto [to, w, id] : g[v]) {
        if (to == p) continue;
        dfs(to, v, w, id);
    }
    while (s[v] < g[v].size() && pr[v][s[v]] != -1) {
        ans.push_back(pr[v][s[v]]);
        int to = pr2[v][s[v]];
        s[to]++;
        s[v]++;
        dfs2(to);
    }
    if (v == 1) return;
    auto it = st[p].lower_bound({wp - c[v][s[v]], -1});
    if (it == st[p].end()) {
        cout << "No";
        exit(0);
    }

    pr[p][it->second] = wid;
    pr2[p][it->second] = v;
    st[p].erase(it);
}




void solve() {
    int n, gr;
    cin >> n >> gr;
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        g[a].push_back({b, w, i + 1});
        g[b].push_back({a, w, i + 1});
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int x;
            cin >> x;
            c[i].push_back(x);
            pr[i].push_back(-1);
            pr2[i].push_back(-1);
            st[i].insert({x, j});
        }
    }
    dfs(1, 0, -1, -1);
    cout << "Yes\n";
    std::reverse(ans.begin(), ans.end());
    for (auto to : ans) {
        cout << to << " ";
    }




}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
