#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define ll int64_t
#define lol(a, val) memset(a, val, sizeof(a))
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld double
#define double long double
#define pb push_back
#define F first
#define S second

int mod = 1e9 + 7;
int const maxn = 2e5;
int const inf = 1e18;
int const LOG = 20;
ld const eps = 1e-9;
int const N = 2e3 + 10;


pair<int, int> best[maxn];
vector<pair<int, int>> edges;
int w[maxn];
vector<pair<int, int>> g[maxn];
vector<pair<int, int>> a[maxn];
int global = 0;

void dfs(int v, int p = -1) {
    if (g[v].size() == 1 && p != -1) {
        best[v] = a[v][0];
        return;
    }
    vector<pair<pair<int, int>, int>> t;
    for (auto [u, ind]: g[v]) {
        if (u == p) continue;
        dfs(u, v);
        t.pb({{w[ind] - best[u].F, best[u].S}, ind});
    }
    sort(all(t));
    int bst = t.size();
    if (p == -1) {
        for (int i = 0; i < t.size(); i++) {
            if (t[i].F.F > a[v][i].F) {
                global = 1;
            }
        }
        for (int i = 0; i < t.size(); i++) {
            edges[t[i].S].F = max(a[v][i].S, t[i].F.S);
        }
        return;
    }
    for (int i = 0; i < t.size(); i++) {
        if (t[i].F.F > a[v][i + 1].F) {
            global = 1;
        }
    }

    for (int i = 0; i < t.size(); i++) {
        if (t[i].F.F <= a[v][i].F) {
            continue;
        }
        bst = i;
        break;
    }

    best[v] = a[v][bst];
    for (int i = 0; i < bst; i++) {
        edges[t[i].S].F = max(a[v][i].S, t[i].F.S);
    }
    for (int i = bst; i < t.size(); i++) {
        edges[t[i].S].F = max(a[v][i + 1].S, t[i].F.S);
    }
}

void solve() {
    int n, gol;
    cin >> n >> gol;
    edges.resize(n - 1);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v >> w[i];
        u--, v--;
        g[u].pb({v, i});
        g[v].pb({u, i});
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int x;
            cin >> x;
            a[i].pb({x, g[i].size() - j});
        }
        sort(all(a[i]));
    }
    dfs(0);
    for (int i = 0; i + 1 < n; i++) {
        edges[i].S = i;
    }
    sort(all(edges));
    if (global) {
        cout << "No\n";
        return;
    } else {
        cout << "Yes\n";
        for (int i = 0; i + 1 < n; i++) {
            cout << edges[i].S + 1 << ' ';
        }
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int tt;
    tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
