#include <bits/stdc++.h>

using namespace std;
vector<vector<int>> g;
vector<int> tops;
vector<bool> used;

void dfs(int v) {
    used[v] = true;
    for (int to: g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    tops.push_back(v);
}

void solve() {
    int n, gr;
    cin >> n >> gr;
    vector<pair<int, int>> z1(n - 1);
    vector<int> w1(n - 1);
    vector<int> cnt(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        z1[i] = {u, v};
        w1[i] = w;
        cnt[u]++;
        cnt[v]++;
    }
    vector<vector<int>> z(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < cnt[i]; ++j) {
            int x;
            cin >> x;
            z[i].push_back(x);
        }
    }
    if (n <= 10) {
        vector<int> ans(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            ans[i] = i;
        }
        int o = 1 * 2 * 3 * 4 * 5 * 6 * 7 * 8 * 9;
        vector<int> ids(n, 0);
        for (int i = 0; i < o; ++i) {
            for (int j = 0; j < n; ++j) {
                ids[j] = 0;
            }
            bool e = true;
            for (int j = 0; j < ans.size(); ++j) {
                int id = ans[j];
                int u = z1[id].first, v = z1[id].second;
                if (z[u][ids[u]] + z[v][ids[v]] < w1[id]) {
                    e = false;
                    break;
                }
                ids[u]++;
                ids[v]++;
            }
            if (e) {
                cout << "Yes\n";
                std::reverse(ans.begin(), ans.end());
                for (int j = 0; j < n - 1; ++j) {
                    cout << ans[j] + 1 << " ";
                }
                return;
            }
            std::next_permutation(ans.begin(), ans.end());
        }
        cout << "No";
    } else {
        vector<vector<pair<int, int>>> x1(n);
        for (int i = 0; i < n; ++i) {
            x1[i].resize(z[i].size());
            for (int j = 0; j < z[i].size(); ++j) {
                if (i == 0 || i == n - 1) {
                    x1[i][j] = {z[i][j], 1};
                } else {
                    if (j == 0) {
                        x1[i][j] = {z[i][j], 2};
                    } else {
                        x1[i][j] = {z[i][j], 1};
                    }
                }
            }
            std::sort(x1[i].begin(), x1[i].end());
        }
        bool e = true;
        g.resize(n - 1);
        vector<bool> rev(n, false);
        for (int i = 0; i < n - 1; ++i) {
            auto c1 = x1[i].back();
            auto c2 = x1[i + 1].back();
            if (c1.first + c2.first >= w1[i]) {
                if (c1.second == 2) {
                    g[i].push_back(i - 1);
                }
                x1[i].pop_back();
                x1[i + 1].pop_back();
                continue;
            }
            if (i == n - 2) {
                e = false;
                break;
            }
            swap(x1[i + 1][0], x1[i + 1][1]);
            c1 = x1[i].back();
            c2 = x1[i + 1].back();
            if (c1.first + c2.first >= w1[i]) {
                if (c1.second == 2) {
                    g[i].push_back(i - 1);
                }
                if (c2.second == 2) {
                    g[i].push_back(i + 1);
                }
                x1[i].pop_back();
                x1[i + 1].pop_back();
                continue;
            }
            e = false;
            break;
        }
        if (!e) {
            cout << "No";
        } else {
            cout << "Yes\n";
            tops.clear();
            used.assign(n - 1, false);
            for (int i = 0; i < n - 1; ++i) {
                if (!used[i])dfs(i);
            }
            for (int i = 0; i < n - 1; ++i) {
                cout << tops[i] + 1 << " ";
            }
        }
    }
}

signed main() {
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}