//#define GLIBCXX_DEBUG
#include <bits/stdc++.h>

#define int long long
#define ld long double
#define F first
#define S second
using namespace std;
int n, g;
struct ed {
    int a, b, w;
};
vector<ed> e;
vector<int> cnt;
vector<int> per;
vector<bool> used;
vector<vector<int>> cs;

void rec(int now) {
    if (now == n - 1) {
        vector<int> nid(n, 0);
        bool ch = 1;
        for (int id: per) {
            if (cs[e[id].a][nid[e[id].a]] + cs[e[id].b][nid[e[id].b]] < e[id].w) {
                ch = 0;
                break;
            }
            nid[e[id].a]++;
            nid[e[id].b]++;
        }
        if (ch) {
            cout << "Yes\n";
            reverse(per.begin(), per.end());
            for (int i = 0; i < n - 1; ++i) {
                cout << per[i] + 1 << " ";
            }
            exit(0);
        }
        return;
    }
    for (int i = 0; i < n - 1; ++i) {
        if (!used[i]) {
            used[i] = 1;
            per.push_back(i);
            rec(now + 1);
            per.pop_back();
            used[i] = 0;
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> g;
    if (n <= 10) {
        cnt.resize(n);
        for (int i = 0; i < n - 1; ++i) {
            int v, u, w;
            cin >> v >> u >> w;
            v--;
            u--;
            cnt[v]++;
            cnt[u]++;
            e.push_back({v, u, w});
        }
        cs.resize(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < cnt[i]; ++j) {
                int c;
                cin >> c;
                cs[i].push_back(c);
            }
        }
        used.resize(n - 1);
        rec(0);
        cout << "No";
        return 0;
    }
    cnt.resize(n);
    int r = 0;
    for (int i = 0; i < n - 1; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        cnt[v]++;
        cnt[u]++;
        e.push_back({v, u, w});
        if (cnt[u] > 1) {
            r = u;
        }
        if (cnt[v] > 1) {
            r = v;
        }
    }
    cs.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < cnt[i]; ++j) {
            int c;
            cin >> c;
            cs[i].push_back(c);
        }
    }
    vector<pair<int, int>> id;
    for (int i = 0; i < n - 1; ++i) {
        if (cnt[e[i].a] == 1) {
            id.push_back({e[i].w - cs[e[i].a][0], i});
        }
        if (cnt[e[i].b] == 1) {
            id.push_back({e[i].w - cs[e[i].b][0], i});
        }
    }
    sort(id.begin(), id.end());
    vector<pair<int, int>> o(cs[r].size());
    for (int i = 0; i < cs[r].size(); ++i) {
        o[i] = {cs[r][i], cs[r].size() - i - 1};
    }
    sort(o.begin(), o.end());
    bool e = 1;
    vector<int> ans(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        if (o[i].F > id[i].F) {
            e = 0;
            break;
        }
        ans[o[i].S] = id[i].S;
    }
    if (!e) {
        cout << "No";
    } else {
        cout << "Yes\n";
        vector<int> obr(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            obr[ans[i]] = i;
        }
        for (int i = 0; i < n - 1; ++i) {
            cout << obr[i] + 1 << " ";
        }
    }
    return 0;
}
