//#define GLIBCXX_DEBUG
#include <bits/stdc++.h>

#define int long long
#define ld long double
#define F first
#define S second
using namespace std;
struct ed {
    int u, w, id;
};
int n, G;
vector<vector<ed>> g;

vector<multiset<pair<int, int>>> cs;
vector<pair<int, pair<int, int>>> ans;
vector<int> depth;

void dfs(int v, int p) {
    for (auto i: g[v]) {
        if (i.u != p) {
            depth[i.u] = depth[v] + 1;
            dfs(i.u, v);
            for (auto [x, id]: cs[i.u]) {
                int need = i.w - x;
                auto it = cs[v].lower_bound(make_pair(need, -1));
                if (it == cs[v].end()) {
                    cout << "No";
                    exit(0);
                }
                ans.push_back({i.id, {it->S, id}});
                cs[v].erase(it);
            }
        }
    }
}

bool cmp(pair<int, pair<int, int>> a, pair<int, pair<int, int>> b) {
    return max(a.S.F, a.S.S) < max(b.S.F, b.S.S);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> G;
    g.resize(n);
    depth.resize(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        g[v].push_back({u, w, i});
        g[u].push_back({v, w, i});
    }
    cs.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            int c;
            cin >> c;
            cs[i].insert({c, g[i].size() - j});
        }
    }
    dfs(0, -1);
    sort(ans.begin(), ans.end(), cmp);
    cout << "Yes\n";
    for (auto i: ans) {
        cout << i.F + 1 << " ";
    }
    return 0;
}
