//#define GLIBCXX_DEBUG
#include <bits/stdc++.h>

#define int long long
#define ld long double
#define F first
#define S second
using namespace std;
struct ed {
    int u, w, id;
};
int n, G;
vector<vector<ed>> g;

vector<multiset<pair<int, int>>> cs;
vector<pair<int, pair<int, int>>> ans;
vector<int> depth;

void dfs(int v, int p) {
    for (auto i: g[v]) {
        if (i.u != p) {
            depth[i.u] = depth[v] + 1;
            dfs(i.u, v);
            for (auto [x, id]: cs[i.u]) {
                int need = i.w - x;
                auto it = cs[v].lower_bound(make_pair(need, -1));
                if (it == cs[v].end()) {
                    cout << "No";
                    exit(0);
                }
                ans.push_back({i.id, {it->S, id}});
                cs[v].erase(it);
            }
        }
    }
}

bool cmp(pair<int, pair<int, int>> a, pair<int, pair<int, int>> b) {
    return max(a.S.F, a.S.S) < max(b.S.F, b.S.S);
}

struct ed1 {
    int a, b, w;
};
vector<ed1> e;
vector<int> cnt;
vector<int> per;
vector<bool> used;
vector<vector<int>> cs1;

void rec(int now) {
    if (now == n - 1) {
        vector<int> nid(n, 0);
        bool ch = 1;
        for (int id: per) {
            if (cs1[e[id].a][nid[e[id].a]] + cs1[e[id].b][nid[e[id].b]] < e[id].w) {
                ch = 0;
                break;
            }
            nid[e[id].a]++;
            nid[e[id].b]++;
        }
        if (ch) {
            cout << "Yes\n";
            reverse(per.begin(), per.end());
            for (int i = 0; i < n - 1; ++i) {
                cout << per[i] + 1 << " ";
            }
            exit(0);
        }
        return;
    }
    for (int i = 0; i < n - 1; ++i) {
        if (!used[i]) {
            used[i] = 1;
            per.push_back(i);
            rec(now + 1);
            per.pop_back();
            used[i] = 0;
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> G;
    if (0) {
        cnt.resize(n);
        for (int i = 0; i < n - 1; ++i) {
            int v, u, w;
            cin >> v >> u >> w;
            v--;
            u--;
            cnt[v]++;
            cnt[u]++;
            e.push_back({v, u, w});
        }
        cs1.resize(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < cnt[i]; ++j) {
                int c;
                cin >> c;
                cs1[i].push_back(c);
            }
        }
        used.resize(n - 1);
        rec(0);
        cout << "No";
        return 0;
    }
    g.resize(n);
    depth.resize(n, 0);
    vector<pair<int, int>> e;
    for (int i = 0; i < n - 1; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        g[v].push_back({u, w, i});
        g[u].push_back({v, w, i});
        e.push_back({v, u});
    }
    cs.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            int c;
            cin >> c;
            cs[i].insert({c, g[i].size() - j - 1});
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        if (depth[e[i].F] > depth[e[i].S]) {
            swap(e[i].F, e[i].S);
        }
    }
    dfs(0, -1);
    cout << "Yes\n";
    sort(ans.begin(), ans.end(), cmp);
    vector<int> cnt(n);
    while (!ans.empty()) {
        for (int i = 0; i < ans.size(); ++i) {
            if (cnt[e[ans[i].F].F] >= ans[i].S.F && cnt[e[ans[i].F].S] >= ans[i].S.S) {
                cout << ans[i].F + 1 << " ";
                cnt[e[ans[i].F].F]++;
                cnt[e[ans[i].F].S]++;
                ans[i] = {-1, {-1, -1}};
            }
        }
        vector<pair<int, pair<int, int>>> ne;
        for (int i = 0; i < ans.size(); ++i) {
            if (ans[i].F != -1) {
                ne.push_back(ans[i]);
            }
        }
        ans = ne;
    }
    return 0;
}
