#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()


mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int n;
vector<pair<int, int>> e;
vector<int> w, deg;
vector<vector<int>> c;

void solve1() {
    vector<int> ord(n - 1);
    iota(all(ord), 0);
    do {
        vector<int> p(n);
        bool good = true;
        for (int i = 0; i < n - 1; i++) {
            auto [a, b] = e[ord[i]];
            if (w[ord[i]] > c[a][p[a]++] + c[b][p[b]++]) {
                good = false;
                break;
            }
        }
        if (good) {
            cout << "Yes\n";
            for (int x : ord) cout << x + 1 << " ";
            return;
        }
    } while (next_permutation(all(ord)));
    cout << "No\n";
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int G;
    cin >> n >> G;
    deg.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, W;
        cin >> a >> b >> W;
        a--, b--;
        e.emplace_back(a, b);
        w.push_back(W);
        deg[a]++;
        deg[b]++;
    }
    c.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
    }

    if (G == 0 || G == 1) solve1();
}