﻿#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <random>

using namespace std;
typedef long long ll;

//mt19937 rng(1315);

const int maxn = 2e5;
vector<vector<ll>> e(maxn);
vector<vector<int>> gr(maxn);
vector<vector<pair<int, int>>> gg(maxn);
vector<vector<ll>> c(maxn);
int n;
vector<int> dp(maxn);
vector<vector<int>> ff;

bool ch(vector<int>& p) {
	vector<int> cn(n);
	for (int i = 0; i < n - 1; ++i) {
		int jj = e[p[i]][0], pp = e[p[i]][1];
		if (e[p[i]][2] > c[jj][cn[jj]] + c[pp][cn[pp]]) return 0;
		++cn[jj];
		++cn[pp];
	}
	return 1;
}

void co(vector<int>& p) {
	cout << "Yes\n";
	for (auto i : p) {
		cout << i + 1 << ' ';
	}
	exit(0);
}

void dfs(int v, int p = -1) {
	if (gr[v].size() == 1 && p != -1) {
		dp[v] = 0;
		return;
	}
	set<pair<int, int>> st;
	for (int i = 0; i < gr[v].size(); ++i) {
		st.insert({ c[v][i], i });
	}
	for (auto u : gr[v]) {
		int x = e[u][0];
		if (x == v) {
			x = e[u][1];
		}
		if (x == p) continue;
		dfs(x, v);
		if (st.lower_bound({ e[u][2] - c[x][dp[x]], -1 }) == st.end()) {
			cout << "No";
			exit(0);
		}
		ff.push_back({x, v, dp[x], (*st.lower_bound({ e[u][2] - c[x][dp[x]], -1 })).second, u });
		st.erase(st.lower_bound({ e[u][2] - c[x][dp[x]], -1 }));
	}
	if (p != -1) {
		dp[v] = (*st.begin()).second;
	}
}

bool kp(vector<int>& z, vector<int>& h) {
	if (z[0] == h[0]) {
		return z[2] < h[2];
	}
	else if (z[0] == h[1]) {
		return z[2] < h[3];
	}
	else if (z[1] == h[0]) {
		return z[3] < h[2];
	}
	else if (z[1] == h[1]) {
		return z[3] < h[3];
	}
	else {
		return z < h;
	}
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int g;
	cin >> n >> g;
	for (int i = 0; i < n - 1; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u;
		--v;
		e[i] = { u, v, w };
		gr[u].push_back(i);
		gr[v].push_back(i);
		gg[u].push_back({ v, i });
		gg[v].push_back({ u, i });
	}
	for (int i = 0; i < n; ++i) {
		c[i].resize(gr[i].size());
		for (int j = 0; j < c[i].size(); ++j) {
			cin >> c[i][j];
		}
		reverse(c[i].begin(), c[i].end());
	}
	if (n <= 10 && 0) {
		vector<int> p(n-1);
		for (int i = 0; i < n-1; ++i) {
			p[i] = i;
		}
		if (ch(p)) {
			co(p);
		}
		while (next_permutation(p.begin(), p.end())) {
			if (ch(p)) {
				co(p);
			}
		}
		cout << "No";
	}
	else {
		dfs(0);
		cout << "Yes\n";
		vector<int> rs;
		sort(ff.begin(), ff.end(), kp);
		for (int i = 0; i < n - 1; ++i) {
			cout << ff[i][4] + 1 << ' ';
		}
	}

	return 0;
}
