#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

//#pragma ("OFast")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<vector<int>> ans;

void dfs(int v, int pr, int prw, int pri, vector<vector<array<int, 3>>> &g, vector<set<pair<int, int>>> &c){
    for (auto [to, w, i] : g[v]){
        if (to == pr){
            continue;
        }
        dfs(to, v, w, i, g, c);
    }
    if (!c[v].empty()){
        auto it = c[pr].lower_bound({prw - (*c[v].begin()).first, -1});
        if (it == c[pr].end()){
            cout << "No";
            exit(0);
        }
        auto [i, j] = *it;
        c[pr].erase(it);
        ans[j].push_back(pri + 1);
    }
}

void getans(int cnt, int n, vector<array<int, 3>> &g, vector<int> &ind, vector<vector<int>> &c, vector<bool> &used, vector<int> &p){
    if (cnt == n - 1){
        cout << "Yes\n";
        for (auto el : p){
            cout << el + 1 << " ";
        }
        cout << endl;
        exit(0);
    }
    for (int i = 0; i < n - 1; i++){
        if (!used[i]){
            auto [a, b, w] = g[i];
            if (c[a][ind[a]] + c[b][ind[b]] >= w){
                used[i] = true;
                p.push_back(i);
                ind[a]++;
                ind[b]++;
                getans(cnt + 1, n, g, ind, c, used, p);
                p.pop_back();
                ind[a]--;
                ind[b]--;
                used[i] = false;
            }
        }
    }
}

void solve(){
    int n, gr;
    cin >> n >> gr;
    vector<array<int, 3>> g(n - 1);
    vector<vector<array<int, 3>>> g3(n);
    vector<int> deg(n);
    for (int i = 0; i < n - 1; i++){
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        g[i] = {u, v, w};
        g3[v].push_back({u, w, i});
        g3[u].push_back({v, w, i});
        deg[u]++;
        deg[v]++;
    }
    vector<vector<int>> c(n);
    vector<set<pair<int, int>>> c2(n);
    for (int i = 0; i < n; i++){
        int degi = deg[i];
        c[i].resize(degi);
        for (int j = 0; j < degi; j++){
            cin >> c[i][j];
            c2[i].insert({c[i][j], j});
        }
        reverse(c[i].begin(), c[i].end());
    }
    if (n < 11){
        vector<int> ind(n, 0);
        vector<bool> used(n - 1, false);
        vector<int> p;
        getans(0, n, g, ind, c, used, p);
        cout << "No\n";
        return;
    }
    ans.resize(n);
    dfs(0, -1, -1, -1, g3, c2);
    cout << "Yes\n";
    //reverse(ans.begin(), ans.end());
    for (auto &a : ans){
        for (auto el : a){
            cout << el << " ";
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--){
        solve();
    }
}
