#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <algorithm>
#include <map>
#include<tuple>
#include <sstream>
#include <string>
using namespace std;
using ll = long long;
const ll INF = 1e9;

vector<tuple<int, int, int>>g;
vector<vector<int>>c;

void solve1(int n) {
	vector<int>p(n - 1);
	for (int i = 0; i < n - 1; ++i) p[i] = i;
	while (next_permutation(p.begin(), p.end())) {
		vector<vector<int>>d = c;
		bool ok = true;
		for (int i : p) {
			auto [a, b, w] = g[i];
			if (d[a].back() + d[b].back() < w) {
				ok = false;
				break;
			}
			d[a].pop_back();
			d[b].pop_back();
		}
		if (ok) {
			cout << "Yes\n";
			for (auto x : p) cout << x + 1 << ' ';
			return;
		}
		
	}
	cout << "No\n";
}
void solve2(int n) {

}
void solve3(int n) {

}
void solve() {
	int n, t;
	cin >> n >> t;
	g.resize(n - 1);
	c.resize(n);
	for (int i = 0; i < n - 1; ++i) {
		int a, b, w;
		cin >> a >> b >> w;
		--a; --b;
		g[i] = { a, b, w };
	}
	string s;
	getline(cin, s);
	for (int i = 0; i < n; ++i) {
		string s;
		getline(cin, s);
		int x = 0;
		for (int j = 0; j < s.size(); ++j) {
			if (s[j] == ' ') {
				c[i].push_back(x);
				x = 0;
			}
			else {
				x = x * 10 + (s[j] - '0');
			}
		}
		if (x) c[i].push_back(x);
	}
	if (t == 1) {
		solve1(n);
		return;
	}
	if (t == 2) {
		solve2(n);
		return;
	}
	if (t == 3) {
		solve3(n);
		return;
	}

}
int main() {
	ll t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}


}