#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <algorithm>
#include <map>
#include<tuple>
#include <sstream>
#include <string>
using namespace std;
using ll = long long;
const ll INF = 1e9;

vector<tuple<ll, ll, ll>>g;
vector<vector<ll>>c;
vector<ll>cnt;

void solve1(ll n) {
	vector<ll>p(n - 1);
	
	for (ll i = 0; i < n - 1; ++i) p[i] = i + 1;
	if (n == 2) {
		if (c[0][0] + c[1][0] >= get<2>(g[0])) {
			cout << "Yes\n1";
		}
		else cout << "No\n";
		return;
	}
	while (next_permutation(p.begin(), p.end())) {
		vector<vector<ll>>d = c;
		bool ok = true;
		for (ll t : p) {
			int i = t - 1;
			auto [a, b, w] = g[i];
			if (d[a].back() + d[b].back() < w) {
				//cout << d[a].back() << ' ' << d[b].back() << ' ' << w << "\n";
				ok = false;
				break;
			}
			d[a].pop_back();
			d[b].pop_back();
		}
		if (ok) {
			cout << "Yes\n";
			//reverse(p.begin(), p.end());
			for (auto x : p) cout << x  << ' ';
			return;
		}
		
	}
	cout << "No\n";
	return;
}

void solve() {
	ll n, t;
	cin >> n >> t;
	g.resize(n - 1);
	cnt.resize(n);
	c.resize(n);
	
	for (ll i = 0; i < n - 1; ++i) {
		ll a, b, w;
		cin >> a >> b >> w;
		--a; --b;
		++cnt[a]; ++cnt[b];
		g[i] = { a, b, w };
	}

	for (ll i = 0; i < n; ++i) {
		c[i].resize(cnt[i]);
		for (ll j = 0; j < cnt[i]; ++j) cin >> c[i][j];
	}
	if (t <= 1) {
		solve1(n);
		return;
	}


}
int main() {
	ll t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}


}