#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, group;
    cin >> n >> group;
    
    vector<int> w(n), deg(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b >> w[i];
        a--, b--;
        deg[a]++;
        deg[b]++;
    }
    
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(deg[i]);
        for (auto &j : c[i]) {
            cin >> j;
        }
    }
    
    if (group == 0 || group == 2) {
        vector<int> ans;
        auto dfs = [&](auto self, int v) -> void {
            if (v == n - 2) {
                ans.push_back(v);
                return;
            }
            if (c[v][0] + min(c[v + 1][0], c[v + 1][1]) >= w[v]) {
                if (c[v + 1][0] < c[v + 1][1]) {
                    swap(c[v + 1][0], c[v + 1][0]);
                    c[v + 1].pop_back();
                    self(self, v + 1);
                    ans.push_back(v);
                } else {
                    ans.push_back(v);
                    c[v + 1].pop_back();
                    self(self, v + 1);
                }
            } else if (c[v][0] + c[v + 1][0] >= w[v]) {
                swap(c[v + 1][0], c[v + 1][1]);
                c[v + 1].pop_back();
                self(self, v + 1);
                ans.push_back(v);
            } else if (c[v][0] + c[v + 1][1] >= w[v]) {
                ans.push_back(v);
                c[v + 1].pop_back();
                self(self, v + 1);
            } else {
                cout << "No\n";
                exit(0);
            }
        };
        dfs(dfs, 0);
        
        cout << "Yes\n";
        for (auto i : ans) cout << i + 1 << ' ';
        cout << '\n';
        return;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    
    return 0;
}