#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, G;
    cin >> n >> G;
    vector<vector<pair<int, int>>> g(n);
    vector<array<int, 3>> ed(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        g[u].push_back({v, i});
        g[v].push_back({u, i});
        ed[i] = {u, v, w};
    }
    vector<vector<int>> cc(n);
    vector<set<pair<int, int>>> ccc(n);
    for (int i = 0; i < n; ++i) {
        int d = g[i].size();
        cc[i].resize(d);
        cin >> cc[i];
        for (int j = 0; j < d; ++j) {
            ccc[i].insert({cc[i][j], j});
        }
    }
    bool f = 1;
    vector<pair<int, int>> mt(n, {-1, -1});
    auto dfs = [&](auto dfs, int v, int p, int i) -> void {
        if (!f) {
            return;
        }
        for (auto [u, j] : g[v]) {
            if (u != p) {
                dfs(dfs, u, v, j);
            }
        }
        if (p == -1 || !f) {
            return;
        }
        assert(ccc[v].size() == 1);
        auto &[_u, _v, w] = ed[i];
        if (_u != p) {
            swap(_u, _v);
        }
        auto [c, ci] = *ccc[v].begin();
        auto it = ccc[p].lower_bound(pair(w - c, -1));
        if (it == ccc[p].end()) {
            f = 0;
            return;
        }
        mt[i] = {it->second, ci};
        ccc[p].erase(it);
    };
    dfs(dfs, 0, -1, -1);
    if (!f) {
        cout << "No\n";
    }
    vector<vector<int>> gg(n);
    for (int i = 0; i < n; ++i) {
        gg[i].resize(g[i].size());
    }
    for (int i = 0; i < n - 1; ++i) {
        auto [c1, c2] = mt[i];
        auto [u, v, _] = ed[i];
        gg[u][c1] = i;
        gg[v][c2] = i;
    }
    vector<vector<int>> gr(n - 1);
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < (int) g[i].size(); ++j) {
            gr[gg[i][j]].push_back(gg[i][j - 1]);
        }
    }
    vector<bool> used(n - 1);
    vector<int> topsort;
    auto dfs2 = [&](auto dfs2, int v) -> void {
        used[v] = 1;
        for (auto u : gr[v]) {
            if (!used[u]) {
                dfs2(dfs2, u);
            }
        }
        topsort.push_back(v);
    };
    for (int i = 0; i < n - 1; ++i) {
        if (!used[i]) {
            dfs2(dfs2, i);
        }
    }
    reverse(topsort.begin(), topsort.end());
    cout << "Yes\n";
    for (int i : topsort) {
        cout << i + 1 << " ";
    }
}