#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

struct Edge {
    int u, v, w;
};

int32_t main() {
#ifdef LOCAL
    freopen("D:\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, _;
    cin >> n >> _;
    vector<Edge> edg(n - 1);
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        edg[i] = {u, v, w};
        g[u].push_back({v, i});
        g[v].push_back({u, i});
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
        reverse(c[i].begin(), c[i].end());
    }
    vector<int> p(n - 1);
    iota(p.begin(), p.end(), 0);
    do {
        bool ok = true;
        vector<int> ind(n);
        for (int i = 0; i < n - 1; ++i) {
            auto [u, v, w] = edg[p[i]];
            if (w > c[u][ind[u]] + c[v][ind[v]]) {
                ok = false;
                break;
            }
            ++ind[u];
            ++ind[v];
        }
        if (ok) {
            cout << "Yes\n";
            for (auto i : p) {
                cout << i + 1 << " ";
            }
            cout << "\n";
            return 0;
        }
    } while (next_permutation(p.begin(), p.end()));
    cout << "No\n";
    return 0;
}