#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#pragma pack(push, 1)

#define int long long

using namespace std;
//using namespace __gnu_pbds;

//using ordered_multiset = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;
using lll = __int128;
using lld = __float128;

mt19937_64 gen(time(nullptr));

const int MAX_N = 2e5;

bool flag = false;

vector<int> node(MAX_N, 0);
vector<vector<int>> edges, c(MAX_N), g(MAX_N);

void check(vector<int> &arr) {
    vector<int> arrr = {0, 3, 1, 2};
    if (arr == arrr) {
        int u = 1;
    }
    node.assign(arr.size() + 1, 0);
    for (int i = 0; i < arr.size(); i++) {
        int a = edges[arr[i]][0], b = edges[arr[i]][1], w = edges[arr[i]][2];
        if (c[a][node[a]] + c[b][node[b]] < w) {
            return;
        }
        node[a]++, node[b]++;
    }
    flag = true;
    cout << "Yes\n";
    for (int i = 0; i < arr.size(); i++) {
        cout << arr[i] + 1 << ' ';
    }
}

void brute_force(int i, vector<int> &arr) {
    if (flag) {
        return;
    }
    if (i == arr.size()) {
        check(arr);
        return;
    }
    for (int j = i; j < arr.size(); j++) {
        swap(arr[i], arr[j]);
        brute_force(i + 1, arr);
        swap(arr[i], arr[j]);
    }
}

bool cmp(vector<int> &a, vector<int> &b) {
    return a[2] > b[2];
}

signed main() {
#ifdef LOCAL
    freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, group, i, a, j = 0, b, w, in;
    cin >> n >> group;
    if (group == 3) {
        vector<int> is_in(n, 0), ans(n - 1), arr(n - 1);
        set<pair<int, int>> se;
        vector<pair<int, int>> g, edges;
        for (i = 0; i < n - 1; i++) {
            cin >> a >> b >> w;
            edges.push_back({b - 1, w});
        }
        for (i = 0; i < n - 1; i++) {
            cin >> arr[i];
        }
        reverse(arr.begin(), arr.end());
        for (i = 0; i < n - 1; i++) {
            se.insert({arr[i], i});
        }
        for (i = 1; i < n; i++) {
            cin >> in;
            g.push_back({edges[i - 1].second - in, i});
        }
        sort(g.begin(), g.end());
        while (!se.empty()) {
            auto [c, num] = *se.begin();
            se.erase(se.begin());
            if (g[j].first > c) {
                cout << "No";
                return 0;
            }
            ans[num] = g[j].second;
            j++;
        }
        cout << "Yes\n";
        for (i = 0; i < n - 1; i++) {
            cout << ans[i] << ' ';
        }
        return 0;
    }
    for (i = 0; i < n - 1; i++) {
        cin >> a >> b >> w;
        edges.push_back({a - 1, b - 1, w, i});
        g[a - 1].push_back(b - 1), g[b - 1].push_back(a - 1);
    }
    for (i = 0; i < n; i++) {
        c[i].resize(g[i].size());
        for (j = 0; j < g[i].size(); j++) {
            cin >> c[i][j];
        }
        reverse(c[i].begin(), c[i].end());
    }
    if (group < 2) {
        vector<int> arr(n - 1);
        for (i = 0; i < n - 1; i++) {
            arr[i] = i;
        }
        brute_force(0, arr);
        if (!flag) {
            cout << "No";
        }
        return 0;
    }
    vector<int> ans;
    sort(edges.begin(), edges.end(), cmp);
    for (i = 0; i < n - 1; i++) {
        a = edges[i][0], b = edges[i][1], w = edges[i][2];
        if (c[a][node[a]] + c[b][node[b]] < w) {
            cout << "No";
            return 0;
        }
        node[a]++, node[b]++;
        ans[i] = edges[i][3];
    }
    cout << "Yes\n";
    for (i = 0; i < n - 1; i++) {
        cout << ans[i] + 1 << ' ';
    }
}