#include <bits/stdc++.h>

using namespace std;

int n, type;

const int N = 2e5 + 10;

vector<int> c[N];
int deg[N];

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> type;
    if (type != 2) {
        exit(0);
    }
    int w[n];
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        cin >> w[i];
        deg[a]++, deg[b]++;
    }
    
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
    }
    w[1] -= c[1].back();
    bool us[n + 1] = {};
    us[1] = true;
    for (int i = 2; i <= n; i++) {
        int k = deg[i];
        if (c[i].back() < w[i - 1]) {
            cout << "No\n";
            return 0;
        }
        vector<int> ord(k);
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&](int x, int y) {
            return c[i][x] < c[i][y];
        });
        int l = 0;
        while (l < k && c[i][ord[l]] < w[i - 1]) l++;
        us[i] = (ord[l] == 0);
        // cout << c[i][ord[l]] << ' ' << ord[l] << '\n';
        if (k == 1) continue;
        if (ord[l]) w[i] -= c[i][0];
        else w[i] -= c[i][1]; 
    }
    // cout << '\n'; 

    // for (int i = 1; i <= n; i++)
    //     cout << us[i] << ' ';
    // cout << '\n'; 
    // return 0;
    vector<int> res;
    for (int i = 1; i < n; i++) {
        res.push_back(i);
    }
    auto type = [&](int i) {
        return (((int)us[i + 1] << 1) | !us[i]);
    };

    // for (int i = 1; i < n; i++) 
    //     cout << type(i) << ' ';
    // cout << '\n';
    sort(res.begin(), res.end(), [&](int a, int b) {
        if (type(a) == type(b)) {
            return (us[a] ? a > b : a < b);
        }
        return (type(a) < type(b));
    });
    cout << "Yes\n";
    for (int c : res) {
        cout << c << ' ';
    }
}