#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ve vector
#define sz(x) (int)x.size()
#define link lnk
#define pb push_back
#define fi first
#define se second
#define all(x) x.begin(), x.end()
typedef pair<ll, ll> pii;
const int N = 2e5+10;
int deg[N];
ve<int>c[N];
ve<int>ed[N];
ve<int>g2[N];
ve<int>g[N];

set<pii> st[N];

map<int, ve<pii>>mp[N];

bool ok = 1;

int used[N];
ve<int>arr;

void dfs2(int v, int an = -1){
    used[v] = 1;
    for(auto son : g2[v]){
        if(!used[son]){
            dfs2(son, v);
        }
    }
    arr.pb(v);
}

void dfs(int v, int an = -1){
    bool leaf = 0;
    for(auto son : g[v])if(son != an){
        leaf = 1;
        dfs(son, v);
        if(!ok)return;
        int j = 0;
        for(auto [w, id_edge] : mp[v][son]){
            auto [ca, florson] = *st[son].begin();
            st[son].erase(st[son].begin());

            int cb = w - ca;
            auto it = st[v].lower_bound(make_pair(cb, -1));
            if(it==st[v].end()){
                ok = 0;
                return;
            }
            int florv = (*it).se;
            st[v].erase(it);
            ed[v][florv] = ed[son][florson] = id_edge;
        }
        st[son].clear();
    }
}

int main()
{
//    ios_base::sync_with_stdio(0);cin.tie(0);

    int n, G;
    cin>>n>>G;
    ve<array<int, 3>>edges(n-1);
    for(int i =0;i<n-1;i++){
        int v, u, w;
        cin>>v>>u>>w;
        v--;u--;
        mp[v][u].pb({w, i});
        mp[u][v].pb({w, i});
        g[v].pb(u);
        g[u].pb(v);
        deg[v]++;
        deg[u]++;
        edges[i] = {v, u, w};
    }
    for(int i = 0;i<n;i++){
        for(auto& j : mp[i]){
            sort(all(j.se));
        }
    }


    for(int i = 0;i<n;i++){
        c[i].resize(deg[i]);
        ed[i].resize(deg[i]);
        for(int j = 0;j<deg[i];j++){
            cin>>c[i][j];
            st[i].insert({c[i][j], j});
        }
    }

    if(G<=1){
        ve<int>ans(n-1);
        iota(all(ans), 0);

        do{
            ve<int>uk(n, 0);
            bool ok = 1;
            for(auto id : ans){
                auto [v, u, w] = edges[id];
                if(c[v][uk[v]] + c[u][uk[u]] < w){
                    ok = 0;
                    break;
                }
                    uk[v]++;
                    uk[u]++;
            }
            if(ok){
                reverse(all(ans));
                cout<<"Yes\n";
                for(auto i : ans)cout<<i+1<<' ';
                return 0;
            }
        }
        while(next_permutation(all(ans)));

        cout<<"No\n";
    }
    else{
        dfs(0);
        if(!ok){
            cout<<"No";
            return 0;
        }
        for(int i = 0;i<n;i++){
            for(int j = 1;j<deg[i];j++){
                g2[ed[i][j]].pb(ed[i][j-1]);
            }
        }
        for(int i = 0;i<n-1;i++)if(!used[i]){
            dfs2(i);
        }
        reverse(all(arr));
        cout<<"Yes\n";
        for(auto i : arr)cout<<i+1<<' ';
    }





    return 0;
}
