// In the name of Allah

#include <bits/stdc++.h>
using namespace std;

typedef		long long			ll;
typedef		long double			ld;
typedef		pair<int, int>		pii;
typedef		pair<ll, ll>		pll;

#define		endl				'\n'
#define		sep					' '
#define		all(x)				(x).begin(),(x).end()
#define		len(x)				((ll) (x).size())
#define		F					first
#define		S					second
#define		Mp					make_pair
#define		pb					push_back

const int maxn = 4 * 2e5 + 7;
const ll oo = 1e9 + 7;

int n, sz;
vector<pll> adj[maxn];
vector<pair<pii, ll>> E; map<pii, int> Ex;
vector<pll> ls[maxn]; int ind[maxn], Mx[maxn];
vector<int> ans; pair<ll, pii> dp[maxn];
vector<pair<ll, pii>> vc1, vc2;

int GI(int i, int j) {
	return ind[i] + ls[i][j].S;
}

bool cmp(pii i, pii j) {
	return (i.S > j.S);
}

bool f(int x, bool F) {
	int j2 = len(vc2) - 1;
	for (int j1 = 0; j1 < len(vc1); j1++) {
		if (j2 == x) j2--;
		if (j2 < 0) return 0;
		if (vc1[j1].F + vc2[j2].F < 0) return 0;
		j2--;
	}

	if (F) {
		j2 = len(vc2) - 1;
		for (int j1 = 0; j1 < len(vc1); j1++) {
			if (j2 == x) j2--;
			int u = GI(vc1[j1].S.F, vc1[j1].S.S);
			int v = GI(vc2[j2].S.F, vc2[j2].S.S);
			Mx[u] = v; Mx[v] = u;
			j2--;
		}
	}

	return 1;
}

void dfs(int v, int p = -1) {
	for (auto f : adj[v]) {
		int u = f.F; ll w = f.S;
		if (u == p) continue;
		dfs(u, v);
	}

	vc1.clear(); vc2.clear();
	for (auto f : adj[v]) {
		int u = f.F; ll w = f.S;
		if (u == p) continue;
		if (dp[u].F == oo) {
			dp[v] = Mp(oo, Mp(-1, -1));
			return ;
		}
		else {
			auto g = dp[u]; g.F -= w;
			vc1.pb(g);
		}
	}
	sort(all(vc1));

	for (int j = 0; j < len(ls[v]); j++) {
		vc2.pb(Mp(ls[v][j].F, Mp(v, j)));
	}

	if (p != -1) {
		int l = -1, r = len(vc2);
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (f(mid, 0)) l = mid;
			else r = mid;
		}

		if (l == -1) dp[v] = Mp(oo, Mp(-1, -1));
		else {
			dp[v] = Mp(vc2[l].F, Mp(v, l));
			f(l, 1);
		}
	}
	else {
		if (f(-1, 0)) {
			dp[v] = Mp(0, Mp(-1, -1));
			f(-1, 1);
		}
		else dp[v] = Mp(oo, Mp(-1, -1));
	}
}

void res_dfs(int v, int p = -1) {
	for (int j = 0; j < len(ls[v]); j++) {
		int vx = GI(v, j), ux = Mx[vx];
		int u = upper_bound(ind, ind + n, ux) - ind - 1;
		if (u == p) ans.pb(Ex[Mp(u, v)]);
		else res_dfs(u, v);
	}
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	int g;
	cin >> n >> g;

	for (int i = 0; i < n - 1; i++) {
		int u, v; ll w;
		cin >> u >> v >> w; u--; v--;
		adj[u].pb(Mp(v, w)); adj[v].pb(Mp(u, w));
		E.pb(Mp(Mp(u, v), w)); Ex[Mp(u, v)] = i; Ex[Mp(v, u)] = i;
	}

	for (int i = 0; i < n; i++) {
		ls[i].resize(len(adj[i]));
		for (int j = 0; j < len(adj[i]); j++) {
			cin >> ls[i][j].F; ls[i][j].S = j;
		}
		sort(all(ls[i]));
	}
	for (int i = 1; i < n; i++) {
		ind[i] = ind[i - 1] + len(ls[i - 1]);
	}

	dfs(0);
	if (dp[0].F == oo) {
		cout << "No" << endl;
		return 0;
	}

	for (int i = 0; i < n; i++) sort(all(ls[i]), cmp);
	res_dfs(0);
	
	cout << "Yes" << endl;
	for (int i : ans) cout << i + 1 << sep;
	cout << endl;

	return 0;
}