#include <bits/stdc++.h>
#define F first
#define S second
using namespace std;

const int N = 2e5 + 10;
int n , g , mx[N] , par[N] , ans[N] , deg[N] , res[N];
vector <pair<int , int>> adj[N] , sall[N];
vector <int> all[N] , G[N];
bool flg;

void Dfs(int v , int p = 0)
{
	int deg = adj[v].size();
	par[v] = p;
	vector <pair<int , int>> child;
	bool leaf = true;
	for(auto u : adj[v])  if(u.F != p)
	{
		leaf = false;
		Dfs(u.F , v);
		child.push_back({u.S - mx[u.F] , u.F});
	}
	if(leaf)
	{
		mx[v] = all[v][0];
		//cout << v << " " << mx[v] << endl;
		return;
	}
	sort(child.begin() , child.end());
	int pos = 0;
	vector <int> vec(deg);
	int now = 0;
	int tmp = child.size();
	while(now < tmp)
	{
		auto u = child[now];
		//cout << pos << " " << sall[v][pos].F << " " << sall[v][pos].S << " WTF " << now << endl;
		if(pos >= deg)
		{
			flg = false;
			break;
		}
		if(sall[v][pos].F >= u.F)
		{
			vec[sall[v][pos].S] = u.S;
			now++;
		}
		else
		{
			vec[sall[v][pos].S] = v;
			mx[v] = sall[v][pos].F;
		}
		pos++;
	}
	//cout << "KING" << endl;
	if(!flg)
		return;
	if(pos < deg)
	{
		vec[sall[v][pos].S] = v;
		mx[v] = sall[v][pos].F;
	}
	for(int i = 1 ; i < deg ; i++)
		G[vec[i - 1]].push_back(vec[i]);
	//cout << v << " " << mx[v] << endl;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);  cout.tie(0);
	cin >> n >> g;
	vector <pair<int , int>> E;
	flg = true;
	for(int i = 0 ; i < n - 1 ; i++)
	{
		int a , b , w; cin >> a >> b >> w;
		adj[a].push_back({b , w});
		adj[b].push_back({a , w});
		E.push_back({a , b});
	}
	for(int i = 1 ; i <= n ; i++)
	{
		int m = adj[i].size();
		for(int j = 0 ; j < m ; j++)
		{
			int x;  cin >> x;
			all[i].push_back(x);
		}
		reverse(all[i].begin() , all[i].end());
		for(int j = 0 ; j < m ; j++)
			sall[i].push_back({all[i][j] , j});
		sort(sall[i].begin() , sall[i].end());
	}
	Dfs(1);
	if(!flg)
	{
		cout << "No" << '\n';
		return 0;
	}
	for(int i = 2 ; i <= n ; i++)  for(auto u : G[i])
		deg[u]++;
	vector <int> cand , ord;
	for(int i = 2 ; i <= n ; i++)  if(deg[i] == 0)
		cand.push_back(i);
	while(!cand.empty())
	{
		auto v = cand.back();  cand.pop_back();  ans[v] = ord.size();  ord.push_back(v);
		for(auto u : G[v])
		{
			deg[u]--;
			if(deg[u] == 0)
				cand.push_back(u);
		}
	}
	for(int i = 0 ; i < n - 1 ; i++)
	{
		int u = E[i].F , v = E[i].S;
		if(par[u] == v)
			swap(v , u);
		res[ans[v]] = i + 1;
	}
	cout << "Yes" << '\n';
	for(int i = 0 ; i < n - 1 ; i++)
		cout << res[i] << " ";
	cout << '\n';
	return 0;
}