#include<bits/stdc++.h>
using namespace std;
#define pb push_back
#define fi first
#define se second
#define mp make_pair
typedef long long ll;
const int N = 2e5 + 5;
int n, g;
vector<int> adj[N];
vector<pair<pair<int, int>, int> > E;
vector<int> vec[N], G[N];
int lst[N], f[N];

int to(int i, int v) {
	return E[i].fi.fi == v ? E[i].fi.se : E[i].fi.fi;
}	

bool check(vector<pair<int, int> >& U, vector<pair<int, int> >& V, int k) {
	int szu = U.size(), szv = V.size();
	fill(f, f + szu + 1, -1);
	int j = 0;
	for (int i = 0; i < szv; i++) {
		if (j == k) j++;
		if (U[j].fi < V[i].fi)
			return false;
		f[U[j].se] = V[i].se;
		j++;
	}
	return true;
}

void dfs(int v, int p) {
	vector<pair<int, int> > D, U;
	for (int i = 0; i < (int)vec[v].size(); i++) {
		U.pb(mp(vec[v][i], i));
	}

	int ip = -1;
	for (auto i : adj[v]) {
		int u = to(i, v), w = E[i].se;
		if (u == p) {
			ip = i;
			continue;
		}

		dfs(u, v);
		D.pb(mp(w - lst[u], i));
	}
	sort(U.begin(), U.end(), greater<pair<int, int> >());
	sort(D.begin(), D.end(), greater<pair<int, int> >());


	int lt = -1, rt = (int)U.size();
	if (p) {
		while (rt - lt > 1) {
			int mid = (lt + rt) >> 1;
			if (check(U, D, mid)) 
				rt = mid;
			else
				lt = mid;
		}	
	}
	else
		rt = n + 1;

	if (!check(U, D, rt)) {
		cout << "No" << '\n';
		exit(0);
	}


	int prv = -1;
	for (int i = 0; i < (int)U.size(); i++) {
		if (f[i] == -1) {
			lst[v] = vec[v][i];
			f[i] = ip;
		}
		if (prv != -1) {
			G[prv].pb(f[i]);
		}
		prv = f[i];
	}
}
bool vis[N];
vector<int> ans;
void dfs2(int v) {
	vis[v] = true;
	for (auto u : G[v]) {
		if (!vis[u]) dfs2(u);
	}
	ans.pb(v);
}

void solve() {
	cin >> n >> g;
	for (int i = 0; i < n - 1; ++i) {
		int v, u, w; cin >> v >> u >> w;
		E.pb(mp(mp(v, u), w));
		adj[v].pb(i);
		adj[u].pb(i);
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 0; j < (int)adj[i].size(); j++) {
			int x; cin >> x;
			vec[i].pb(x);
		}
		reverse(vec[i].begin(), vec[i].end());
	}

	dfs(1, 0);
	for (int i = 0; i < n - 1; i++) {
		if (!vis[i])
			dfs2(i);
	}
	cout << "Yes" << '\n';
	reverse(ans.begin(), ans.end());
	for (auto x : ans) cout << 1 + x << ' ';
	cout << endl;
}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int tc = 1; // cin >> tc;

	while (tc--) {
		solve();


	}
	return 0;
}
