#include <bits/stdc++.h>
#define FOR(a, b, c) for (int (a) = (b); a < (c); ++a)
#define int long long
using namespace std;
using ar = array<int, 2>;

const int N = 2e5 + 50;
const long long INF = 1ll << 60;

vector<ar> adj[N], C[N];
int n, g, deg[N];
bool mark[N];
vector<array<int, 4>> ans;

ar dfs(int v, int p) {
	vector<array<int, 3>> V;
	for (auto [u, w]: adj[v]) if (u != p) {
		auto [x, id] = dfs(u, v);
		//cout << "ANS OF DFS " << u + 1 << " IS " << x << endl;
		V.push_back({w - x, u, id});
	}
	sort(V.begin(), V.end());
	int ptr = 0;
	vector<bool> mark(C[v].size(), 0);
	for (auto [x, u, id]: V) {
		while (ptr < C[v].size() && C[v][ptr][0] < x)
			++ptr;
		if (ptr == C[v].size()) {
			cout << "No\n";
			exit(0);
		}
		mark[ptr] = true;
		ans.push_back({v, C[v][ptr][1], u, id});
		++ptr;
	}
	FOR(i, 0, C[v].size()) if (!mark[i]) return C[v][i];
	return {-1, -1};
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	map<ar, int> id;
	cin >> n >> g;
	FOR(i, 1, n) {
		int u, v, w;
		cin >> u >> v >> w;
		--u, --v;
		adj[v].push_back({u, w});
		adj[u].push_back({v, w});
		id[{u, v}] = id[{v, u}] = i;
	}
	FOR(i, 0, n) {
		int d = adj[i].size();
		deg[i] = d - 1;
		C[i].resize(d);
		FOR(j, 0, d) {
			cin >> C[i][j][0];
			C[i][j][1] = j;
		}
		sort(C[i].begin(), C[i].end());
	}
	dfs(0, 0);
	cout << "Yes\n";

	bool f = true;
	while (f) {
		f = false;
		FOR(i, 0, ans.size()) if (!mark[i]) {
			auto [v, vi, u, ui] = ans[i];
			if (vi == deg[v] && ui == deg[u]) {
				--deg[u];
				--deg[v];
				cout << id[{u, v}] << ' ';
				mark[i] = true;
				f = true;
			}
		}
	}

	return 0;
}

