#include <iostream>
#include <chrono>
#include <vector>

#define maxn 300005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;

#pragma GCC optimize("O3" , "Ofast" , "unroll-loops" , "fast-math")
#pragma GCC target("avx2")

using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}

struct edge
{
    int from, to, w;

    edge() {};
    edge(int _from, int _to, int _w)
    {
        from = _from;
        to = _to;
        w = _w;
    }
};

int deg[maxn];
int n, g;

vector <edge> edges;
vector <int> v[maxn];

int nx[maxn];

void read()
{
    cin >> n >> g;

    int from, to, w;
    for(int i = 0; i < n - 1; i++)
    {
        cin >> from >> to >> w;

        deg[from]++;
        deg[to]++;

        edges.push_back({from, to, w});
    }

    for(int i = 1; i <= n; i++)
    {
        int x;

        for(int j = 1; j <= deg[i]; j++)
        {
            cin >> x;
            v[i].pb(x);
        }
    }
    
    if(g != 2)
        cout << "No" << endl;
    
    if(g == 2)
    {
        for(int i = 1; i <= n - 1; i++)
        {
            if(edges[i].w > v[edges[i].from][nx[edges[i].from]] + v[edges[i].to][nx[edges[i].to]])
            {
                cout << "No" << endl;
                exit(0);
            }

            nx[edges[i].from]++;
            nx[edges[i].to]++;
        }
    }




}



void solve2()
{
    cout << "Yes" << endl;

    for(int i = 1; i <= n - 1; i++)
        cout << i << " ";
    cout << endl;

}





int main()
{

    /*#ifdef ONLINE_JUDGE /// promeni
        freopen("taxi.in", "r", stdin);
        freopen("taxi.out", "w", stdout);
    #endif*/

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    startT = std::chrono::high_resolution_clock::now();


    read();

    if(g == 2)
    {
        solve2();
        return 0;
    }

    return 0;
}
