#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k, t;
    cin >> n >> k >> t;

    vector<int> a(2 * n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    copy(a.begin(), a.begin() + n, a.begin() + n);

    vector<int> nxt(n);
    vector<int> yy = a;
    sort(yy.begin(), yy.end());
    yy.resize(unique(yy.begin(), yy.end()) - yy.begin());
    set<int> alive;
    map<int, int> cn;
    for (int i = 2 * n - 1, r = 2 * n; i >= 0; --i) {
        int x = a[i];
        alive.insert(x);
        cn[x] += 1;
        while (alive.size() > t) {
            if (--cn[a[--r]] == 0) {
                alive.extract(a[r]);
            }
        }
        if (i < n) {
            nxt[i] = r == 2 * n ? -1 : r;
            nxt[i] %= n;
        }
    }

    if (yy.size() <= t) {
        cout << "1\n";
        return 0;
    }

//    for (int i = 0; i < n; ++i) {
//        cout << nxt[i] << " ";
//    }
//    cout << endl;

    vector<int> used(n, -1), cnt(n);
    int layer = 1, fi = -1, x = 0, T = 0;
    for (; used[x] == -1;) {
        used[x] = layer;
        cnt[x] = ++T;
        if (nxt[x] < x) {
            layer += 1;
            if (layer > k) {
                cout << cnt[x] << '\n';
                return 0;
            }
        }
        x = nxt[x];
    }

    int add = layer - used[x];
    int c = T - cnt[x] + 1;
    ll ans = T;
    ans += ll(k - layer) / add * c;
    layer = (k - layer) / add * add + layer;
    while (true) {
        ans += 1;
        if (nxt[x] < x) {
            layer += 1;
            if (layer > k) {
                cout << ans << '\n';
                return 0;
            }
        }
        x = nxt[x];
    }

    return 0;
}