#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

//using namespace __gnu_pbds;
using namespace std;

const int N = 3e5 + 10;
int tree1[N * 4], tree2[N * 4];

void update_1(int v, int l, int r, int pos, int val) {
    if (r - l == 1) {
        tree1[v] = val;
    } else {
        int mid = (l + r) >> 1;
        if (pos >= mid) {
            update_1(v * 2 + 2, mid, r, pos, val);
        } else {
            update_1(v * 2 + 1, l, mid, pos, val);
        }
        tree1[v] = tree1[v * 2 + 1] + tree1[v * 2 + 2];
    }
}

int get_1(int v, int l, int r, int val) {
    if (r - l == 1) {
        return r;
    } else {
        int mid = (l + r) >> 1;
        if (tree1[v] < val) {
            return -1;
        }
        if (tree1[v * 2 + 1] < val) {
            return get_1(v * 2 + 2, mid, r, val - tree1[v * 2 + 1]);
        } else {
            return get_1(v * 2 + 1, l, mid, val);
        }
    }
}

void update_2(int v, int l, int r, int pos, int val) {
    if (r - l == 1) {
        tree2[v] = val;
    } else {
        int mid = (l + r) >> 1;
        if (pos >= mid) {
            update_2(v * 2 + 2, mid, r, pos, val);
        } else {
            update_2(v * 2 + 1, l, mid, pos, val);
        }
        tree2[v] = tree2[v * 2 + 1] + tree2[v * 2 + 2];
    }
}

int get_2(int v, int l, int r, int val) {
    if (r - l == 1) {
        return r;
    } else {
        int mid = (l + r) >> 1;
        if (tree2[v] < val) {
            return -1;
        }
        if (tree2[v * 2 + 1] < val) {
            return get_2(v * 2 + 2, mid, r, val - tree2[v * 2 + 1]);
        } else {
            return get_2(v * 2 + 1, l, mid, val);
        }
    }
}

signed main() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    vector<int> nxt(n), prev(n);
    map<int, int> last;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        last[a[i]] = -1;
    }
    for (int i = 0; i < n; i++) {
        prev[i] = last[a[i]];
        last[a[i]] = i;
    }
    for (int i = 0; i < n; i++) {
        last[a[i]] = -1;
    }
    for (int i = n - 1; i >= 0; i--) {
        nxt[i] = last[a[i]];
        last[a[i]] = i;
    }
    for (int i = 0; i < n; i++) {
        last[a[i]] = -1;
    }
    for (int i = 0; i < n; i++) {
        if (last[a[i]] == -1) {
            last[a[i]] = i;
        }
    }
    for (int i = 0; i < n; i++) {
        if (nxt[i] == -1) {
            nxt[i] = last[a[i]];
        }
    }
    for(int i = n - 1; i >= 0; i--){
        update_1(0, 0, n, nxt[i], 0);
        update_1(0, 0, n, i, 1);
    }
    vector<pair<int, int>> to(n);
    for(int i = 0; i < n; i++){
        int id1 = get_1(0, 0, n,t);
        if(id1 == -1){
            int id2 = get_2(0, 0, n, t - tree1[0]);
            if(id2 == -1){
                cout << 1;
                return 0;
            }else{
                to[i] = {id2, 1};
            }
        }else{
            to[i] = {id1, 0};
        }
        update_1(0, 0, n, i, 0);
        if(nxt[i] <= i){
            update_2(0, 0, n, nxt[i], 1);
        }else{
            update_1(0, 0, n, nxt[i], 1);
        }
    }
    int ans = 0;
    if(to[0].first == -1){
        cout << 1;
        return 0;
    }
    int cur = 0;
    while(k){
        k -= to[cur].second;
        cur = to[cur].first;
        ans++;
    }
    cout << ans;
}