#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<cassert>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define girlfriend friend

template<typename T>
bool assign_min(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream& out, std::pair<T, F> a) {
    return out << a.first << " " << a.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, b1 = 31, b2 = 29, MAXN = 1e5;
const long double eps = 1e-9;

void solve() {
    int n, k, t; cin >> n >> k >> t;
    vector<int> a(n); input(a);
    set<int> s;
    for (auto elem : a) s.insert(elem);
    if (t >= (int)s.size()) {
        cout << "1\n";
        return;
    }
    vector<int> b = a;
    for (auto elem : a) b.emplace_back(elem);
    vector<int> nx(n);
    int cur = 0;
    map<int, int> cnt;
    int r = 2*n-1;
    for (int i = 2*n-1; i >= 0; --i) {
        if (!cnt[b[i]]) cur++;
        cnt[b[i]]++;
        while (r >= i && cur > t) {
            cnt[b[r]]--;
            if (!cnt[b[r]]) cur--;
            r--;
        }
        assert(r >= i);
        if (i < n) nx[i] = r+1;
    }
    vector<int> usd(n), dist(n), ans(n);
    int now = 0, need = k*n, dst = 0, res = 0;
    while (need > 0 && !usd[now]) {
        res++;
        ans[now] = res;
        usd[now] = 1;
        dist[now] = dst;
        dst += nx[now] - now;
        need -= nx[now] - now;
        now = nx[now]%n;
    }
    if (need <= 0) {
        cout << res << '\n';
        return;
    }
    int q = need / (dst - dist[now]);
    res += (res - ans[now]) * q;
    need %= (dst - dist[now]);
    while (need > 0) {
        res++;
        need -= nx[now] - now;
        now = nx[now]%n;
    }
    cout << res << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}

//fft