//#include <iostream>
//#include <map>
//#include <vector>

#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

int p[1];
int rk[1];

int par(int a){
    if (a != p[a])
        return p[a] = par(p[a]);
    return p[a];
}

void merge(int a, int b){
    a = par(a);
    b = par(b);
    if (a == b)
        return;
    if (rk[a] < rk[b])
        swap(a, b);
    p[b] = a;
    if (rk[a] == rk[b])
        rk[a]++;

}

int st[1];
int afaf[1];
void build(int v, int l, int r){
    if (l + 1 == r){
        st[v] = afaf[l];
        return;
    }
    int m = (l + r) >> 1;
    build(v << 1, l, m);
    build(v << 1 | 1, m, r);
    st[v] = st[v << 1] + st[v << 1 | 1];
}

void add(int v, int l, int r, int pos, int x){
    if (l + 1 == r){
        st[v] += x;
        return;
    }
    int m = (l + r) >> 1;
    if (pos >= m)
        add(v << 1 | 1, m, r, pos, x);
    else
        add(v << 1, l, m, pos, x);
    st[v] = st[v << 1] + st[v << 1 | 1];
}

int get(int v, int l, int r, int lq, int rq){
    if (lq <= l && r <= rq){
        return st[v];
    }
    if (l >= rq || lq >= r)
        return 0;

    int m = (l + r) >> 1;
    int f = get(v << 1, l, m, lq, rq);
    int g = get(v << 1 | 1, m, r, lq, rq);
    return f + g;
}


void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a;
    set<int> col;
    for (int i = 0; i < n; ++i) {
        int c;
        cin >> c;
        col.insert(c);
        if (a.empty() || a.back() != c)
            a.push_back(c);
    }
    n = (int)a.size();
    if (col.size() <= t){
        cout << "1\n";
        return;
    }
    int h[31][(int)a.size()];
    int r = -1;
    map<int, int> cnt;
    int cur = 0;
    int crpos = -1;
    int ps[31][n];
    for (int l = 0; l < n; l++){
        if (l) {
            cnt[a[l - 1]]--;
            if (!cnt[a[l - 1]])
                cur--;
        }
        while (cur <= t){
            if (cur == t && cnt[a[(r + 1) % n]] == 0)
                break;
            crpos++;
            r++;
            if (r >= n)
                r -= n;
            cnt[a[r]]++;
            if (cnt[a[r]] == 1)
                cur++;
        }
        h[0][l] = r;
        ps[0][l] = crpos - l + 1;
    }
    for (int s = 1; s <= 30; s++){
        for (int i = 0; i < (int)a.size(); i++){
            h[s][i] = h[s - 1][(h[s - 1][i] + 1) % n];
            ps[s][i] = ps[s - 1][i] + ps[s - 1][(h[s - 1][i] + 1) % n];
        }
    }
    // h[i][j] = h[h[i][j - 1][j - 1];
    int ans1 = 1e9;
    for (int need = n * k; need <= n * k - 1 + n; need++) {
        ll pos = 0;
        int ans = 0;
        while (pos < need) {
            for (int s = 0; s <= 30; s++) {
                if (ps[s + 1][pos % n] + pos > need) {
                    pos += ps[s][pos % n];
                    ans += (1 << s);
                    break;
                }
            }
        }
        ans1 = min(ans, ans1);
    }
    cout << ans1 << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--)
        solve();
    return 0;
}
