#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define int long long

vector<int> CountNode(vector<int> &n1, vector<int> &n2) {
    vector<int> c = n1;
    for (auto i: n2) {
        c.push_back(i);
    }
    std::sort(c.begin(), c.end());
    return c;
}

pair<int, int> get(vector<vector<int>> &t, int ind, int l, int r, int ql, int qr, int x, int cnt) {
    if (l >= ql and r <= qr) {
        int d = std::lower_bound(t[ind].begin(), t[ind].end(), x) - t[ind].begin();
        if (d <= cnt) {
            return {d, r};
        } else {
            if (l + 1 == r) {
                return {0, -1};
            }
            int mid = (l + r) / 2;
            pair<int, int> o = get(t, ind * 2, l, mid, ql, qr, x, cnt);
            if (o.second == mid) {
                pair<int, int> o2 = get(t, ind * 2 + 1, mid, r, ql, qr, x, cnt - o.first);
                return {o.first + o2.first, max(o2.second, o.second)};
            } else {
                return o;
            }
        }
    }
    if (l >= qr or r <= ql) {
        return {0, -1};
    }
    int mid = (l + r) / 2;
    pair<int, int> ans1 = get(t, ind * 2, l, mid, ql, qr, x, cnt);
    if (ans1.second == mid or ans1.second == -1) {
        pair<int, int> ans2 = get(t, ind * 2 + 1, mid, r, ql, qr, x, cnt - ans1.first);
        return {ans1.first + ans2.first, max(ans2.second, ans1.second)};
    } else {
        return ans1;
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cout << fixed << setprecision(12);
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    set<int> s;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        s.insert(a[i]);
    }
    if (s.size() <= t) {
        cout << 1 << '\n';
        return 0;
    }
    if (t == 1) {
        vector<int> ids(n);
        vector<int> b = a;
        for (int i = 0; i < n; i++) {
            b.push_back(a[i]);
        }
        vector<int> last(2 * n);
        map<int, int> mp;
        for (int i = 0; i < 2 * n; i++) {
            if (mp.find(b[i]) != mp.end()) {
                last[i] = mp[b[i]];
            } else {
                last[i] = -1e18;
            }
            mp[b[i]] = i;
        }
        int h = 0;
        while (1 << (++h) < 2 * n);
        vector<vector<int>> tree(1 << (h + 1));
        for (int i = 0; i < 2 * n; i++) {
            tree[i + (1 << h)].push_back(last[i]);
        }
        for (int i = (1 << h) - 1; i > 0; i--) {
            tree[i] = CountNode(tree[i * 2], tree[i * 2 + 1]);
        }
        for (int i = 0; i < n; i++) {
            pair<int, int> cnt = get(tree, 1, 0, 1 << h, i, 2 * n + 1, i, t);
            ids[i] = cnt.second - i;
        }
        int ans = 1;
        int id_now = 0;
        vector<bool> used(n);
        vector<pair<int, int>> cnt(n);
        while (true) {
            if (id_now + ids[id_now % n] >= n * k) {
                break;
            }
            used[id_now % n] = true;
            cnt[id_now % n] = {id_now, ans - 1};
            id_now += ids[id_now % n];
            if (used[id_now % n]) {
                break;
            }
            ans++;
        }
        if (id_now + ids[id_now % n] >= n * k) {
            cout << ans;
            return 0;
        }
        int d = n * k;
        d -= cnt[id_now % n].first;
        int d2 = d / (id_now - cnt[id_now % n].first);
        int id_next = cnt[id_now % n].first + d2 * (id_now - cnt[id_now % n].first);
        int ans2 = cnt[id_now % n].second + d2 * (ans - cnt[id_now % n].second);
        id_now = id_next;
        if (id_now < n * k) {
            ans2++;
        }
        ans = ans2;
        while (true) {
            if (id_now + ids[id_now % n] >= n * k) {
                break;
            }
            id_now += ids[id_now % n];
            ans++;
        }
        cout << ans << '\n';
    } else {
        vector<int> ids(n);
        vector<int> b = a;
        for (int i = 0; i < n; i++) {
            b.push_back(a[i]);
        }
        vector<int> last(2 * n);
        map<int, int> mp;
        for (int i = 0; i < 2 * n; i++) {
            if (mp.find(b[i]) != mp.end()) {
                last[i] = mp[b[i]];
            } else {
                last[i] = -1e18;
            }
            mp[b[i]] = i;
        }
        int h = 0;
        while (1 << (++h) < 2 * n);
        vector<vector<int>> tree(1 << (h + 1));
        for (int i = 0; i < 2 * n; i++) {
            tree[i + (1 << h)].push_back(last[i]);
        }
        for (int i = (1 << h) - 1; i > 0; i--) {
            tree[i] = CountNode(tree[i * 2], tree[i * 2 + 1]);
        }
        for (int i = 0; i < n; i++) {
            set<int> s;
            for (int j = i; j < i + n; j++) {
                s.insert(b[j]);
                if (s.size() > t) break;
                ids[i] = j - i + 1;
            }
        }
        int ans = 1;
        int id_now = 0;
        vector<bool> used(n);
        vector<pair<int, int>> cnt(n);
        while (true) {
            if (id_now + ids[id_now % n] >= n * k) {
                break;
            }
            used[id_now % n] = true;
            cnt[id_now % n] = {id_now, ans - 1};
            id_now += ids[id_now % n];
            if (used[id_now % n]) {
                break;
            }
            ans++;
        }
        if (id_now + ids[id_now % n] >= n * k) {
            cout << ans;
            return 0;
        }
        int d = n * k;
        d -= cnt[id_now % n].first;
        int d2 = d / (id_now - cnt[id_now % n].first);
        int id_next = cnt[id_now % n].first + d2 * (id_now - cnt[id_now % n].first);
        int ans2 = cnt[id_now % n].second + d2 * (ans - cnt[id_now % n].second);
        id_now = id_next;
        if (id_now < n * k) {
            ans2++;
        }
        ans = ans2;
        while (true) {
            if (id_now + ids[id_now % n] >= n * k) {
                break;
            }
            id_now += ids[id_now % n];
            ans++;
        }
        cout << ans << '\n';
    }

}


