#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <numeric>
#include <chrono>
#include <random>
#include <bitset>
#include <immintrin.h>
#include <assert.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<ll, ll>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

ll ceil(ll a, ll b) {
    return (a - 1) / b + 1;
}

const int N = 3e5;
int used[N];
int dif = 0;

void add(int v) {
    used[v]++;
    if (used[v] == 1)
        dif++;
}

void del(int v) {
    used[v]--;
    if (used[v] == 0)
        dif--;
}

inline void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    vector<int> c;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        c.push_back(a[i]);
    }
    sort(all(c));
    c.erase(unique(all(c)), c.end());
    for (int& i : a)
        i = lower_bound(all(c), i) - c.begin();
    vector<int> b{ a[0] };
    for (int i = 1; i < n; i++)
        if (a[i] != a[i - 1])
            b.push_back(a[i]);
    if (t >= c.size()) {
        cout << 1 << '\n';
        return;
    }
    ll sz = b.size();
    vector<int> bb = b;
    for (int i = 0; i < sz; i++)
        bb.push_back(b[i]);
    vector<int> to(sz);
    int r = -1;
    for (int l = 0; l < sz; l++) {
        while (r < 2 * sz && dif <= t) {
            r++;
            if (r == 2 * sz)
                break;
            add(bb[r]);
            if (dif > t)
                break;
        }
        to[l] = r % sz;
        del(b[l]);
    }
    int mx = 0;
    vector<vector<pll>> up(60, vector<pll>(sz));
    for (int i = 0; i < sz; i++) {
        if (to[i] < i)
            up[0][i] = { to[i] - i + sz, to[i] };
        else
            up[0][i] = { to[i] - i, to[i] };
    }
    for (int i = 1; i < 60; i++) {
        for (int j = 0; j < sz; j++) {
            ll cnt;
            int ptr;
            cnt = up[i - 1][j].first + up[i - 1][up[i - 1][j].second].first;
            ptr = up[i - 1][up[i - 1][j].second].second;
            up[i][j] = { cnt, ptr };
        }
        if (up[i][0].first >= sz * j) {
            mx = i;
            break;
        }
    }
    ll ans = 0;
    ll cur = 0;
    int ptr = 0;
    for (int i = mx; i > -1; i--)
        if (cur + up[i][ptr].first < sz * k) {
            ans += 1ll << i;
            cur += up[i][ptr].first;
            ptr = up[i][ptr].second;
        }
    cout << ans + 1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("01.dat", "r", stdin);
#endif
    int tt = 1;
#ifdef DEBUG
    cin >> tt;
#endif
    while (tt--) {
#ifdef DEBUG
        cout << "Testcase#\n";
#endif
        solve();
    }
    return 0;
}
