#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include <iomanip>
using namespace std;


#define int long long



void sdv_l(int& l, int& r, vector <int>& a, int& cnt, unordered_map<int, int>& mp) {
	mp[a[l]]--;
	if (mp[a[l]] == 0) {
		--cnt;
	}
	++l;
}

void sdv_r(int& l, int& r, int t, vector <int>& a, int& cnt, unordered_map <int, int>& mp) {
	while (cnt <= t) {
		if (mp[a[r]] == 0) {
			cnt++;
		}
		mp[a[r]]++;
		++r;
	}

}

void solve() {
	int n, k, t;
	cin >> n >> k >> t;
	vector <int> a(1);
	cin >> a[0];
	unordered_set<int> all;
	all.insert(a[0]);
	for (int i = 1; i < n; ++i) {
		int nw;
		cin >> nw;
		if (nw != a[a.size() - 1]) a.push_back(nw);
		all.insert(nw);
	}

	if (t >= all.size()) {
		cout << 1 << "\n";
		return;
	}
	n = a.size();
	vector <int> a2;
	for (int o = 0; o < 2; ++o) {
		for (int i = 0; i < n; ++i) a2.push_back(a[i]);
	}

	vector <int> gr(n);
	int l = 0, r = 0;
	int cnt = 0;
	unordered_map<int, int>mp;
	sdv_r(l, r, t, a2, cnt, mp);
	gr[0] = (r-1)%n;
	for (int i = 1; i < n; ++i) {
		sdv_l(l, r, a2, cnt, mp);
		sdv_r(l, r, t, a2, cnt, mp);
		gr[i] = (r-1) % n;
	}

	vector <int> used(n, 0);
	int nw = 0;
	int allused = 0;
	int allusedlen = 0;
	while (!used[nw]) {
		++allused;
		if (gr[nw] < nw) {
			allusedlen+= gr[nw] + n - nw;
		}
		else {
			allusedlen += gr[nw] - nw;
		}

		used[nw] = 1;
		nw = gr[nw];
	}

	int cylcest = nw;
	int csz = 0;
	int cl = 0;
	while (used[nw] == 1){
		used[nw] = 2;
		if (gr[nw] < nw) {
			cl += gr[nw] + n - nw;
		}
		else {
			cl += gr[nw] - nw;
		}
		++csz;
		nw = gr[nw];
	}

	int ans = allused - csz;

	int szost = n * k - allusedlen + cl;

	ans += csz * (szost / cl);

	int ostl = szost - (szost / cl) * cl;
	nw = cylcest;
	while (ostl > 0) {
		ans++;
		if (gr[nw] < nw) {
			ostl -= gr[nw] + n - nw;
		}
		else {
			ostl -= gr[nw] - nw;
		}
		nw = gr[nw];
	}
	cout << ans;
}


int32_t main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}
}

