#include "bits/stdc++.h"

using namespace std;
#define int long long


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    int lim = n * k * 2;
    vector<int> a(n);
    set<int> st;
    for (int &i: a) {
        cin >> i;
        st.insert(i);
    }
    if (st.size() <= t) {
        cout << 1 << '\n';
        return 0;
    }
    for (int i = 0; i < n; i++) {
        a.push_back(a[i]);
    }
    vector<int> border(n, -1);
    map<int, int> mp;
    int j = 1;
    mp[a[0]]++;
    for (int i = 0; i < n; i++) {
        if (i > 0) {
            mp[a[i - 1]]--;
            if (mp[a[i - 1]] == 0) {
                mp.erase(a[i - 1]);
            }
        }
        while (mp.size() <= t && j < 2 * n) {
            mp[a[j]]++;
            j++;
        }
        border[i] = (j - 1);
    }
    vector<int> go(n);
    for (int i = 0; i < n; i++) {
        go[i] = border[i] - i;
    }
    int need = n * k;
    const int log = 62;
    vector<vector<int>> up(log, vector<int>(n));
    vector<vector<int>> cost(log, vector<int>(n));
    for (int i = 0; i < n; i++) {
        up[0][i] = (i + go[i]) % n;
        cost[0][i] = go[i];
    }
    for (int lg = 1; lg < log; lg++) {
        for (int i = 0; i < n; i++) {
            up[lg][i] = up[lg - 1][up[lg - 1][i]];
            cost[lg][i] = cost[lg - 1][i] + cost[lg - 1][up[lg - 1][i]];
            cost[lg][i] = min(cost[lg][i], lim);
        }
    }
    int ans = 0;
    int i = 0;
    vector<vector<int>> suf(log, vector<int>(n));
    for (int j = 0; j < log; j++) {
        for (int i = 0; i < n; i++) {
            suf[j][i] = cost[j][i] + (j - 1 >= 0 ? suf[j - 1][up[j][i]] : 0);
            suf[j][i] = min(suf[j][i], lim);
        }
    }
    for (int lg = log - 1; lg >= 1; lg--) {
        if ((suf[lg - 1][i] < need)) {
            ans += (1 << lg);
            need -= cost[lg][i];
            i = up[lg][i];
        }
    }
    assert(need <= cost[0][i]);
    ans += (need > 0);
    cout << ans;
    return 0;
}
