#include <iostream>
#include <vector>
#include <set>
#include <map>
using namespace std;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    set<int> d;
    for (auto u : a) {
        d.insert(u);
    }
    if ((int)d.size() <= t) {
        cout << 1 << endl;
        exit(0);
    }
    int calc = 0;
    map<int, int> cnt;
    int cur = 0;
    vector<int> nxt(n);
    for (int i = 0; i < n; ++i) {
        while (calc <= t) {
            if (cnt[a[cur]] == 0) {
                calc++;
            }
            cnt[a[cur]]++;
            cur = (cur + 1) % n;
        }
        nxt[i] = (n + cur - 1) % n;
        if (cnt[a[i]] == 1) {
            calc--;
        }
        cnt[a[i]]--;
    }
    vector<int> been(n, -1);
    int step = 0;
    int pos = 0;
    int already = 0;
    while (true) {
        if (already == k) {
            cout << step << endl;
            exit(0);
        }
        if (been[pos] == -1) {
            been[pos] = step;
        } else {
            cout << step + (step - been[pos]) * (k - already) << endl;
            exit(0);
        }
        step++;
        if (nxt[pos] < pos) {
            already++;
        }
        pos = nxt[pos];
    }
    return 0;
}
