#include <iostream>
#include <vector>
#include <set>
#include <map>

using ll = long long;
using ld = long double;

using namespace std;

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> v(n);
    for (int& x : v)
        cin >> x;
    vector<int> to(n);
    set<int> st;
    for (int x : v)
        st.insert(x);
    if (st.size() <= t) {
        cout << 1;
        return;
    }
    int j = 0;
    map<int, int> mp;
    for (int i = 0; i < n; i++) {
        if (i) {
            mp[v[i - 1]]--;
            if (!mp[v[i - 1]])
                mp.erase(v[i - 1]);
        }
        while (mp.size() <= t) {
            mp[v[j]]++;
            j++;
            if (j == n)
                j = 0;
        }
        if (j)
            to[i] = j - 1;
        else
            to[i] = n - 1;
    }
    int i = 0;
    ll boxes = 0, cnt = 1;
    map<int, int> cost, b;
    while (cost.find(to[i]) == cost.end()) {
        cost[i] = (int)cnt - 1;
        b[i] = (int)boxes;
        if (to[i] <= i)
            boxes++;
        i = to[i];
        cnt++;
    }
    if (to[i] <= i)
        boxes++;
    i = to[i];
    boxes -= b[i];
    ll ans = cost[i] + (ll)(k - 1 - b[i]) / boxes * (cnt - cost[i]);
    ll r = (ll)(k - 1 - b[i]) % boxes + 1;
    boxes = 0;
    while (boxes < r) {
        if (to[i] <= i)
            boxes++;
        i = to[i];
        ans++;
    }
    cout << ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
