#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

pair <int, bool> to[20][400000];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k, t; cin >> n >> k >> t;
    vector <int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    gp_hash_table <int, int> mp;
    bool flag = false;
    int r = 0;
    for (; r < n; r++) {
        mp[a[r]]++;
        if (mp.size() > t) {
            mp.erase(a[r]);
            r--;
            flag = true;
            break;
        }
    }

    if (!flag) {
        cout << "1\n";
        return 0;
    }

    for (int l = n - 1; l >= 0; l--) {
        mp[a[l]]++;
        while (mp.size() > t) {
            mp[a[r]]--;
            if (!mp[a[r]]) mp.erase(a[r]);
            r--;
            if (r < 0) r += n;
        }
        to[0][l] = {(r + 1) % n, (r + 1) >= n || (l > r)};
    }

    for (int bit = 0; bit < 19; bit++) {
        for (int i = 0; i < n; i++) {
            to[bit + 1][i].first = to[bit][to[bit][i].first].first;
            to[bit + 1][i].second = to[bit][i].second | to[bit][to[bit][i].first].second;
        }
    }

    int ind = 0;
    ll ans = 0;
    for (int i = 0; i < k; i++) {
        for (int bit = 19; bit >= 0; bit--) {
            if (!to[bit][ind].second) {
                ans += 1 << bit;
                ind = to[bit][ind].first;
            }
        }
        ans++;
        ind = to[0][ind].first;
    }

    cout << ans << "\n";

    return 0;
}
