#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

pair <int, bool> to[20][400000];
pair <int, int> to2[400000];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k, t; cin >> n >> k >> t;
    vector <int> a(n);
    set <int> st;
    for (int i = 0; i < n; i++) cin >> a[i], st.insert(a[i]);

    if (st.size() <= t) {
        cout << "1\n";
        return 0;
    }

    gp_hash_table <int, int> mp;
    bool flag = false;
    int r = 0;
    for (; r < n; r++) {
        mp[a[r]]++;
        if (mp.size() > t) {
            mp.erase(a[r]);
            r--;
            flag = true;
            break;
        }
    }

    for (int l = n - 1; l >= 0; l--) {
        mp[a[l]]++;
        while (mp.size() > t) {
            mp[a[r]]--;
            if (!mp[a[r]]) mp.erase(a[r]);
            r--;
            if (r < 0) r += n;
        }
        to[0][l] = {(r + 1) % n, (r + 1) >= n || (l > r)};
    }

    for (int bit = 0; bit < 19; bit++) {
        for (int i = 0; i < n; i++) {
            to[bit + 1][i].first = to[bit][to[bit][i].first].first;
            to[bit + 1][i].second = to[bit][i].second | to[bit][to[bit][i].first].second;
        }
    }

    for (int i = 0; i < n; i++) {
        int ind = i, res = 0;
        for (int bit = 19; bit >= 0; bit--) {
            if (!to[bit][ind].second) {
                res += 1 << bit;
                ind = to[bit][ind].first;
            }
        }
        res++;
        ind = to[0][ind].first;
        to2[i] = {res, ind};
    }

    ll ans = 0;
    int ind = 0;
    vector <int> used(n, -1);
    vector <ll> res(5 * n, 0);
    flag = false;
    for (int i = 0; i < k; i++) {
        if (used[ind] != -1 && !flag) {
            flag = true;
            ll f = res[i - 1] - (used[ind] ? res[used[ind] - 1] : 0);
            int cnt = i - used[ind];
            int m = (k - i - 1) / cnt;
            ans += f * m;
            i += m * cnt;
        }
        used[ind] = i;
        ans += to2[ind].first;
        ind = to2[ind].second;
        res[i] = ans;
    }

    cout << ans << "\n";

    return 0;
}
