#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

using namespace std;
using ll = long long;

const ll INF = 1e18;
const ll LG = 50, N = 3e5;

pair <ll, ll> dp[LG][N];

void solve() {
    ll n, lvl, t; cin >> n >> lvl >> t;
    vector <ll> a(n);
    gp_hash_table <ll, ll> vals;
    for (auto& i : a)
        cin >> i, vals[i]++;
    if (t >= (ll) vals.size()) {
        cout << "1\n";
        return;
    }
    if (t == 1) {
        ll ans = 0;
        for (ll i = 0; i + 1 < n; i++)
            if (a[i] != a[i + 1])
                ans++;
        ans++;
        ans *= lvl;
        if (a[0] == a.back())
            ans -= lvl - 1;
        cout << ans;
        return;
    }
    gp_hash_table <ll, ll> now;
    ll u = 0;
    for (ll st = 0; st < n; st++) {
        while ((ll) now.size() <= t) {
            if ((ll) now.size() < t || ((ll) now.size() == t && now.find(a[u]) != now.end())) {
                now[a[u]]++;
                u = (u + 1) % n;
            } else {
                break;
            }
        }
        dp[0][st] = {bool(u < st), u};
        now[a[st]]--;
        if (now[a[st]] == 0)
            now.erase(a[st]);
    }
    for (ll k = 0; k + 1 < LG; k++) {
        for (ll i = 0; i < n; i++) {
            dp[k + 1][i] = {dp[k][i].first + dp[k][dp[k][i].second].first, dp[k][dp[k][i].second].second};
        }
    }
    ll ans = 0, i = 0;
    for (ll k = LG - 1; k >= 0; k--) {
        if (dp[k][i].first < lvl) {
            lvl -= dp[k][i].first;
            ans += (1ll << k);
            i = dp[k][i].second;
        }
    }
    cout << ans + 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    while (T--) {
        solve();
    }
    return 0;
}
