#include <iostream>
#include <vector>
#include <unordered_map>
#include <set>

using namespace std;

unordered_map<int, int> mp;
int cnt = 0;

void add(int x) {
    int c = mp[x];
    if (c == 0) {
        cnt++;
    }
    mp[x] = c + 1;
}

void del(int x) {
    int c = mp[x];
    if (c == 1) {
        cnt--;
    }
    mp[x] = c - 1;
}

int main()
{
    long long n, k, t;
    cin >> n >> k >> t;
    vector<int> v;
    int pr = -1;
    set<int> st;
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        st.insert(a);
        if (a != pr) {
            v.push_back(a);
            pr = a;
        }
    }
    if (st.size() <= t) {
        cout << "1";
        return 0;
    }
    int tmp = v.size();
    for (int i = 0; i < tmp; i++) {
        v.push_back(v[i]);
    }
    int id = 0;
    while(id < v.size() && cnt <= t) {
        add(v[id++]);
    }
    del(v[id - 1]);
    id--;
    vector<int> dp(v.size() / 2);
    dp[0] = id;
    for (int i = 1; i < v.size() / 2; i++) {
        del(v[i - 1]);
        while(id < v.size() && cnt <= t) {
            add(v[id++]);
        }
        del(v[id - 1]);
        id--;
        dp[i] = id;
    }
    long long sz = 0, cur = 0, ans = 0;
    while (sz < k * v.size() / 2) {
        sz += (dp[cur] - cur);
        cur = dp[cur];
        ans++;
        if (cur >= v.size() / 2) {
            cur -= (v.size() / 2);
        }
        //cout << cur << " " << sz << endl;
    }
    cout << ans << endl;
    return 0;
}
