#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_map>
#include <iomanip>
#include <queue>
#include <climits>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef long double ld;
#define mid (r + l) / 2
#define lv (2 * v + 1)
#define rv (2 * v + 2)
#define all(x) x.begin(), x.end()
int tree[2400000], pu[2400000];
int pereh[600000], last[600000];
int t;

void push(int l, int r, int v) {
    if (pu[v] == 0) return;
    tree[v] += pu[v];
    if (r - l > 1) {
        pu[lv] += pu[v];
        pu[rv] += pu[v];
    }
    pu[v] = 0;
}

void up_one(int l, int r, int v, int to) {
    push(l, r, v);
    if (r - l == 1) {
        tree[v] = INT_MIN + 10;
        pereh[l] = to;
        return;
    }
    if (tree[lv] + pu[lv] > t) up_one(l, mid, lv, to);
    if (tree[rv] + pu[rv] > t) up_one(mid, r, rv, to);
    tree[v] = max(tree[lv] + pu[lv], tree[rv] + pu[rv]);
}

void upd(int l, int r, int v, int lq, int rq, int to) {
    push(l, r, v);
    if (l >= lq && r <= rq) {
        pu[v]++;
        push(l, r, v);
        if (tree[v] > t) up_one(l, r, v, to);
        return;
    }
    if (l >= rq || r <= lq) return;
    upd(l, mid, lv, lq, rq, to);
    upd(mid, r, rv, lq, rq, to);
    tree[v] = max(tree[lv], tree[rv]);
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    ll n, k, cnt = 0, cnt2 = 0;
    cin >> n >> k >> t;
    vector<int> a(n), alv;
    set<int> s;
    unordered_map<int, int> al;
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        s.insert(a[i]);
    }
    for (int i : s) alv.push_back(i);
    for (int i = 0; i < alv.size(); i++) al[alv[i]] = i;
    a.erase(unique(all(a)), a.end());
    for (int i = 0; i < a.size(); i++) a[i] = al[a[i]];
    vector<int> is(s.size());
    n = a.size();
    for (int i = 0; i < n; i++) a.push_back(a[i]);
    n *= 2;
    for (int i = 0; i < n; i++) last[i] = -1;
    for (int i = 0; i < n; i++) {
        upd(0, n, 0, last[a[i]] + 1, i + 1, i);
        last[a[i]] = i;
    }
    if (pereh[0] == 0) {
        cout << 1 << "\n";
        return 0;
    }
    n /= 2;
    int ans = 0;
    for (int v = 0, cnt = 0;;) {
        if (cnt == k) {
            cout << ans << '\n';
            break;
        }
        cnt += (pereh[v] >= n);
        v = (pereh[v] % n);
        ans++;
    }
    return 0;
}