#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_map>
#include <iomanip>
#include <queue>
#include <climits>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef long double ld;
#define mid (r + l) / 2
#define lv (2 * v + 1)
#define rv (2 * v + 2)
#define all(x) x.begin(), x.end()
ll tree[2400000], pu[2400000];
ll pereh[600000], last[600000], ansi[300000];
ll t;

void push(ll l, ll r, ll v) {
    if (pu[v] == 0) return;
    tree[v] += pu[v];
    if (r - l > 1) {
        pu[lv] += pu[v];
        pu[rv] += pu[v];
    }
    pu[v] = 0;
}

void up_one(ll l, ll r, ll v, ll to) {
    push(l, r, v);
    if (r - l == 1) {
        tree[v] = LLONG_MIN + 10;
        pereh[l] = to;
        return;
    }
    if (tree[lv] + pu[lv] > t) up_one(l, mid, lv, to);
    if (tree[rv] + pu[rv] > t) up_one(mid, r, rv, to);
    tree[v] = max(tree[lv] + pu[lv], tree[rv] + pu[rv]);
}

void upd(ll l, ll r, ll v, ll lq, ll rq, ll to) {
    push(l, r, v);
    if (l >= lq && r <= rq) {
        pu[v]++;
        push(l, r, v);
        if (tree[v] > t) up_one(l, r, v, to);
        return;
    }
    if (l >= rq || r <= lq) return;
    upd(l, mid, lv, lq, rq, to);
    upd(mid, r, rv, lq, rq, to);
    tree[v] = max(tree[lv], tree[rv]);
}

ll main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    ll n, k, cnt = 0, cnt2 = 0;
    cin >> n >> k >> t;
    vector<ll> a(n), alv;
    set<ll> s;
    unordered_map<ll, ll> al;
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        s.insert(a[i]);
    }
    for (ll i : s) alv.push_back(i);
    for (ll i = 0; i < alv.size(); i++) al[alv[i]] = i;
    for (ll i = 0; i < a.size(); i++) a[i] = al[a[i]];
    vector<ll> is(s.size());
    n = a.size();
    for (ll i = 0; i < n; i++) a.push_back(a[i]);
    n *= 2;
    for (ll i = 0; i < n; i++) last[i] = -1, ansi[i] = -1;
    for (ll i = 0; i < n; i++) {
        upd(0, n, 0, last[a[i]] + 1, i + 1, i);
        last[a[i]] = i;
    }
    if (pereh[0] == 0) {
        cout << 1 << "\n";
        return 0;
    }
    n /= 2;
    ll ans = 0;
    for (ll v = 0, cnt = 0;;) {
        if (cnt == k) {
            cout << ans << '\n';
            break;
        }
        if (ansi[v] != -1) {
            ans += (k - cnt - 1) * (ans - ansi[v]);
            cnt = k - 1;
        }
        cnt += (pereh[v] >= n);
        ansi[v] = ans;
        v = (pereh[v] % n);
        ans++;
    }
    return 0;
}