#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 3e5;
const ld EPS = 1e-6;

ll cnt[MAXN];
ll sz = 0;

void add(ll x) {
    if (cnt[x] == 0) sz++;
    cnt[x]++;
}

void del(ll x) {
    cnt[x]--;
    if (cnt[x] == 0) sz--;
}

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    ll a[n];
    vector<ll> alla;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        alla.emplace_back(a[i]);
    }
    sort(alla.begin(), alla.end());
    alla.erase(unique(alla.begin(), alla.end()), alla.end());
    for (ll i = 0; i < n; ++i) {
        a[i] = lower_bound(alla.begin(), alla.end(), a[i]) - alla.begin();
    }
    for (ll i = 0; i < n; ++i) {
        add(a[i]);
    }
    if (sz <= t) {
        cout << 1 << '\n';
    } else {
        for (ll i = 0; i < n; ++i) {
            del(a[i]);
        }
        ll aa[2 * n];
        for (ll i = 0; i < 2 * n; ++i) {
            aa[i] = a[i % n];
        }
        ll len[2 * n];
        ll r = 2 * n - 1;
        for (ll i = 2 * n - 1; i > -1; --i) {
            add(aa[i]);
            while (sz > t) {
                del(aa[r]);
                r--;
            }
            len[i] = r - i + 1;
        }
        ll to[62][n];
        ll lento[62][n];
        for (ll i = 0; i < n; ++i) {
            to[0][i] = (i + len[i]) % n;
            lento[0][i] = len[i];
        }
        for (ll i = 1; i < 62; ++i) {
            for (ll j = 0; j < n; ++j) {
                to[i][j] = to[i - 1][to[i - 1][j]];
                lento[i][j] = min((ll)1e18 + 100, lento[i - 1][j] + lento[i - 1][to[i - 1][j]]);
            }
        }
        ll mest = 0, ans = 0, ost = n * k;
        for (ll i = 61; i > -1; --i) {
            if (lento[i][mest] <= ost) {
                ost -= lento[i][mest];
                ans += (1LL << i);
                mest = to[i][mest];
            }
        }
        cout << ans + (ost > 0) << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
