#include <bits/stdc++.h>


using namespace std;


const long long inf = 1e18 + 7;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


bool Check(long long pl, long long all, const vector<long long> &rightpos) {
    long long n = (long long)(rightpos.size());
    vector<bool> used(n, 0);
    vector<long long> poses(n);
    vector<long long> kol;
    long long pos = 0;
    while (!used.at(pos)) {
        used.at(pos) = 1;
        kol.push_back(rightpos.at(pos) - pos + 1);
        poses.at(pos) = (long long)(kol.size()) - 1LL;
        pos = (rightpos.at(pos) + 1) % n;
    }
    long long cycle = poses.at(pos);
    long long given = 0;
    for (int i = 0; i < cycle && pl > 0; i++) {
        given += kol.at(i);
        pl--;
    }
    long long len = (long long)(kol.size()) - cycle;
    long long val = 0;
    for (int i = cycle; i < int(kol.size()); i++) {
        val += kol.at(i);
    }
    long long repeat = pl / len;
    given += val * repeat;
    for (int i = cycle; i < cycle + pl % len; i++) {
        given += kol.at(i);
    }
    return given >= all;
}


long long bs(long long l, long long r, long long all, const vector<long long> &rightpos) {
    while (l < r) {
        long long m = l + (r - l) / 2;
        if (Check(m, all, rightpos)) {
            r = m;
        } else {
            l = m + 1;
        }
    }
    return l;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    long long n, k, t;
    cin >> n >> k >> t;
    vector<long long> a(n * 2);
    for (int i = 0; i < n; i++) {
        cin >> a.at(i);
        a.at(i + n) = a.at(i);
    }
    map<long long, int> m;
    int l = 0, r = 0;
    vector<long long> rightPos(n, inf);
    while (l < n && r < 2 * n) {
        if (m.find(a.at(r)) == m.end()) {
            m.insert({a.at(r), 1});
        } else {
            m[a.at(r)]++;
        }
        while (l < n && int(m.size()) == t + 1) {
            rightPos.at(l) = r - 1;
            m[a.at(l)]--;
            if (m[a.at(l)] == 0) {
                m.erase(a.at(l));
            }
            l++;
        }
        r++;
    }
    if (l < n) {
        cout << 1;
        exit(0);
    }
    cout << bs(0, (n * k + t - 1) / t + 1, n * k, rightPos);
    return 0;
}