#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("Input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}


void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    set<int> d;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        d.insert(a[i]);
    }
    if (d.size() <= t) {
        cout << 1;
        return;
    }
    vector<int> skok(n);
    int j = 0;
    gp_hash_table<int, int> st;
    for (int i = 0; i < n; ++i) {
        while (st.size() <= t) {
            st[a[j % n]]++;
            j++;
        }
        j--;
        st.erase(a[j % n]);
        skok[i] = j - i;
        st[a[i]]--;
        if (st[a[i]] == 0) {
            st.erase(a[i]);
        }
    }
    vector<vector<int>> up(n, vector<int>(60));
    vector<vector<__int128>> ans(n, vector<__int128>(60));
    for (int i = 0; i < n; ++i) {
        up[i][0] = (i + skok[i]) % n;
        ans[i][0] = skok[i];
    }
    for (int i = 1; i < 60; ++i) {
        for (int l = 0; l < n; ++l) {
            up[l][i] = up[up[l][i - 1]][i - 1];
            ans[l][i] = ans[l][i - 1] + ans[up[l][i - 1]][i - 1];
        }
    }
    ll sum = n * k, an = 0, ver = 0;
    for (ll i = 59; i >= 0; --i) {
        if (sum >= ans[ver][i]) {
            sum -= ans[ver][i];
            an += (1ll << i);
            ver = up[ver][i];
        }
    }
    if (sum > 0) an++;
    cout << an << '\n';
}