// sleepwalker*_*ksu

#include <bits/stdc++.h>
#include <experimental/random>

using namespace std;

using ld = long double;
using ll = long long;
#define int long long
#define all(a) a.begin(), a.end()
using pii = pair<ll, ll>;
const ll N = 1e5 + 1;
const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ld EPS = 0.000001;

int solve1(int n, int k, int t, vector<int> &a);

int solve2(int n, int k, int t, vector<int> &a);

void solve3();

void solve4();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve4();
    }
}

void solve4() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cout << solve1(n, k, t, a);
}

void solve3() {
    for (int n = 1; n <= 10; n++) {
        for (int k = 1; k <= 10; k++) {
            for (int t = 1; t <= n; t++) {
                vector<int> a(n);
                for (int i = 0; i < n; i++) {
                    a[i] = experimental::randint(1, 20);
                }
                int fir = solve2(n, k, t, a);
                int sec = solve1(n, k, t, a);
                if (fir != sec) {
                    cout << n << ' ' << k << ' ' << t << '\n';
                    for (int i = 0; i < n; i++) {
                        cout << a[i] << ' ';
                    }
                    return;
                }
            }
        }
    }
}

int solve2(int n, int k, int t, vector<int> &a) {
    vector<int> b;
    for (int i = 0; i < k; i++) {
        for (int j: a) {
            b.push_back(j);
        }
    }
    int ans = 1;
    map<int, int> mp;
    n = (ll) b.size();
    for (int i = 0; i < n; i++) {
        mp[b[i]]++;
        if (mp.size() > t) {
            mp.clear();
            mp[b[i]]++;
            ans++;
        }
    }
    return ans;
}

int solve1(int n, int k, int t, vector<int> &a) {
    //cout << experimental::randint(1, 10) << '\n';
    set<int> st;
    for (int i = 0; i < n; i++) {
        st.insert(a[i]);
    }
    vector<int> b;
    if (st.size() <= t) {
        return 1;
    }
    for (int i = 0; i < n; i++) {
        if (a[i] != a[(i + 1) % n]) {
            b.push_back(a[i]);
        }
    }
    int nn = b.size();
    return (nn * k + t - 1) / t + (a[n - 1] != b[nn - 1]);
}