#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
using ll = long long;

const int lo = 50;
int n, k, t;

int main()
{
    cin >> n >> k >> t;
    int *a = new int[n];
    int *b = new int[n];
    for(int i = 0; i < n; ++i){
        cin >> a[i];
        b[i] = a[i];
    }
    sort(b, b + n);
    vector<int> c;
    c.push_back(b[0]);
    for(int i = 1; i < n; ++i){
        if(b[i] != b[i - 1]) c.push_back(b[i]);
    }
    int d = c.size();
    if(d <= t){
        cout << 1 << endl;
        return 0;
    }
    for(int i = 0; i < n; ++i){
        int l = 0, r = d - 1;
        while(l != r){
            int m = (l + r)/2;
            if(c[m] < a[i]) l = m + 1;
            else r = m;
        }
        a[i] = l;
    }
    int *x[lo];
    ll *y[lo];
    for(int i = 0; i < lo; ++i){
        x[i] = new int[n];
        y[i] = new ll[n];
    }
    int *cnt = new int[d];
    for(int i = 0; i < d; ++i) cnt[i] = 0;
    int j = 0, z = 0;
    for(int i = 0; i < n; ++i){
        while(z < t || (z == t && cnt[a[j]] > 0)){
            if(cnt[a[j]] == 0) ++z;
            ++cnt[a[j]];
            ++j;
            j %= n;
        }
        x[0][i] = j;
        if(j < i) y[0][i] = 1;
        else y[0][i] = 0;
        --cnt[a[i]];
        if(cnt[a[i]] == 0) --z;
    }
    
    // for(int i = 0; i < n; ++i) cout << x[0][i] << ' ' << y[0][i] << endl;

    for(int i = 0; i < lo - 1; ++i){
        for(int j = 0; j < n; ++j){
            x[i + 1][j] = x[i][x[i][j]];
            y[i + 1][j] = y[i][j] + y[i][x[i][j]];
        }
    }
    int ans = 1, p = 0;
    ll s = 0;
    for(int i = lo - 1; i >= 0; --i){
        if(s + y[i][p] < k){
            s += y[i][p];
            p = x[i][p];
            ans += (1<<i);
        }
    }
    cout << ans << endl;
    return 0;
}