#include <bits/stdc++.h>

using namespace std;
using ll = long long;


mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll mx_p = 50;

struct fast {
    void solve() {
        ll n, k, t;
        cin >> n >> k >> t;
        vector<ll> a;
        vector<ll> tr;
        for (ll i = 0; i < n; i++) {
            ll el;
            cin >> el;
            if (a.empty() || a.back() != el) {
                a.push_back(el);
            }
            tr.push_back(el);
        }
        sort(tr.begin(), tr.end());
        tr.erase(unique(tr.begin(), tr.end()), tr.end());
        for (auto &el: a) {
            el = lower_bound(tr.begin(), tr.end(), el) - tr.begin();
        }
        ll sz = ll(tr.size());
        if (sz <= t) {
            cout << 1;
            return;
        }
        n = ll(a.size());
        vector<vector<pair<ll, ll>>> up(n, vector<pair<ll, ll>>(mx_p));
        ll l = 0, r = -1;
        vector<ll> cnt(sz, 0);
        ll els = 0;
        for (ll i = 0; i < n; i++) {
            while (l < i) {
                cnt[a[l]]--;
                if (cnt[a[l]] == 0) els--;
                l++;
                if (l == n) l -= n;
            }
            while (els < t + 1) {
                r++;
                if (r == n) r -= n;
                cnt[a[r]]++;
                if (cnt[a[r]] == 1) els++;

            }
            while (els > t + 1) {

                cnt[a[r]]--;
                if (cnt[a[r]] == 0) els--;
                r--;
                if (r < 0) r += n;
            }
            up[i][0].first = r;
            if (r < i) up[i][0].second = 1;
        }
        for (ll pw = 1; pw < mx_p; pw++) {
            for (ll v = 0; v < n; v++) {
                up[v][pw].first = up[up[v][pw - 1].first][pw - 1].first;
                up[v][pw].second = up[up[v][pw - 1].first][pw - 1].second + up[v][pw - 1].second;
            }
        }
        l = 0, r = 4e14;
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            ll cnt = 0;
            ll pr = 0;
            ll v = 0;
            for (ll pw = mx_p - 1; pw >= 0; pw--) {
                if ((1ll << pw) + pr < mid) {
                    cnt += up[v][pw].second;
                    v = up[v][pw].first;
                    pr += (1ll << pw);
                }
            }
            cnt += up[v][0].second;
            if (cnt >= k) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cout << r;
    }

};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    bool stress = false;
    int times = 1;
//    cin >> times;
    if (stress) times = 1e9;
    while (times--) {
        fast f;
        f.solve();
    }
    return 0;
}
