#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
// #define int int64_t
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF = 1e9 + 117;

int cnt_diff_stup(vector<int>& a, int l, int r, int t) { // [l, r)
    unordered_set<int> cur;
    for (int i = l; i < r; ++i) {
        cur.insert(a[i]);
        if (cur.size() > t) break;
    }
    return cur.size();
}

vector<int> nxt;
vector<vector<int>> t;

void build(int v, int l, int r) {
    if (l + 1 == r) {
        t[v].push_back(nxt[l]);
        return;
    }
    int m = (l + r) / 2;
    build(2*v + 1, l, m);
    build(2*v + 2, m, r);
    vector<int> tmp;
    merge(t[2*v + 1].begin(), t[2*v + 1].end(), t[2*v + 2].begin(), t[2*v + 2].end(), back_inserter(tmp));
    t[v] = tmp;
}

int cnt_diff(int v, int l, int r, int fl, int fr) {
    if (l >= fr || r <= fl) return 0;
    if (l >= fl && r <= fr) {
        int res = t[v].end() - lower_bound(t[v].begin(), t[v].end(), fr);
        return res;
    }
    int m = (l + r) / 2;
    return cnt_diff(2*v + 1, l, m, fl, fr) + cnt_diff(2*v + 2, m, r, fl, fr);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, k, tt; cin >> n >> k >> tt;
    vector<int> a(n);
    for (auto& e : a) cin >> e;
    unordered_set<int> cur;
    for (auto& e : a) cur.insert(e);
    if (cur.size() <= tt) {
        cout << "1\n";
        return 0;
    }
    vector<int> pole;
    for (auto& e : a) pole.push_back(e);
    for (auto& e : a) pole.push_back(e);
    nxt.resize(pole.size(), pole.size() + 100);
    map<int, deque<int>> inds;
    for (int i = 0; i < pole.size(); ++i) {
        inds[pole[i]].push_back(i);
    }
    nxt.resize(pole.size(), pole.size() + 100);
    for (int i = 0; i < pole.size(); ++i) {
        inds[pole[i]].pop_front();
        if (!inds[pole[i]].empty()) nxt[i] = inds[pole[i]].front();
    }
    t.resize(4*pole.size());
    build(0, 0, pole.size());
    vector<int> p(n, -1);
    int64_t ind = 0;
    for (int i = 0; i < n; ++i) {
        if (p[ind] != -1) break;
        int l = ind + tt - 1, r = 2 * n, mid;
        while (r - l > 1) {
            mid = (l + r) / 2;
            if (cnt_diff(0, 0, pole.size(), ind, mid + 1) <= tt) l = mid;
            else r = mid;
        }
        p[ind] = r % n;
        ind = r % n;
    }
    unordered_set<int> used;
    ind = 0;
    int64_t tp = 0, ans = 0, ci = 0;
    while (!used.count(ind)) {
        used.insert(ind);
        ans++;
        if (p[ind] < ind) {
            tp++;
            if (tp == k) break;
        }
        if (p[ind] < ind) ci += n - ind + p[ind];
        else ci += p[ind] - ind;
        ind = p[ind];
    }
    if (tp == k) {
        cout << ans << '\n';
        return 0;
    }
    int64_t cycle = 0;
    used.clear();
    int64_t cc = 0;
    while (!used.count(ind)) {
        used.insert(ind);
        cycle++;
        if (p[ind] < ind) cc += n - ind + p[ind];
        else cc += p[ind] - ind;
        ind = p[ind];
    }
    ans = ans + ((n*k - ci) / cc) * cycle;
    ci = ci + cc * ((n*k - ci) / cc) ;
    while (ci < n*k) {
        ans++;
        if (p[ind] < ind) ci += n - ind + p[ind];
        else ci += p[ind] - ind;
        ind = p[ind];
    }
    cout << ans << '\n';
    return 0;
}
