#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    vector<int> comp;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        comp.push_back(a[i]);
    }
    sort(comp.begin(), comp.end());
    map<int, int> mp;
    for (auto e : comp) {
        if (!mp.count(e)) {
            mp[e] = mp.size();
        }
    }
    for (auto &e : a) {
        e = mp[e];
    }
    if ((int)mp.size() <= t) {
        cout << 1 << '\n';
        return;
    }
    vector<int> b = a;
    for (auto e : a) {
        b.push_back(e);
    }
    vector<int> mxd(n);
    vector<int> cnt(n);
    int i1 = 0, uniq = 0;
    for (int i = 0; i < n; i++) {
        while (uniq + (!cnt[b[i1]]) <= t) {
            if (!cnt[b[i1]]) uniq++;
            cnt[b[i1]]++;
            i1++;
        }
        mxd[i] = i1 - i;
        cnt[b[i]]--;
        if (cnt[b[i]] == 0) {
            uniq--;
        }
    }
    vector<int> cycle;
    vector<bool> used(n);
    int now = 0;
    while (!used[now]) {
        used[now] = true;
        cycle.push_back(mxd[now]);
        now = (now + mxd[now]) % n;
    }
    ll ans = 0;
    ll need = n * k;
    for (auto e : cycle) {
        ans++;
        if (need <= e) {
            need = 0;
            break;
        } else {
            need -= e;
        }
    }
    vector<int> truecycle;
    ll sum = 0;
    bool push = false;
    for (auto e : cycle) {
        if (sum == now) {
            push = true;
        }
        if (push) {
            truecycle.push_back(e);
        }
        sum += e;
        sum %= n;
    }
    cycle = truecycle;
    vector<ll> cyclepref(cycle.size() + 1);
    for (int i = 1; i <= (int) cycle.size(); i++) {
        cyclepref[i] = cyclepref[i - 1] + cycle[i - 1];
    }
    ll l = -1, r = (need / cyclepref.back() + 1) * cycle.size();
    while (r - l > 1) {
        ll m = (l + r) / 2;
        ll full = m / (int) cycle.size();
        ll cost = cyclepref.back() * full + cyclepref[m % (int) cycle.size()];
        if (cost >= need) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << ans + r << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    for (int i = 0; i < t; i++) solve();
}
