#pragma once

#include <bits/stdc++.h>

#define int int_fast64_t
//
#pragma GCC optimize("O3")

using namespace std;

const int INF = 1e9;

vector<int> a;
vector<vector<int>> te;
vector<int> nxt;

void build(int v, int l, int r) {
    if (l == r) {
        te[v] = {nxt[l]};
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m + 1, r);
    for (int i = 0; i < te[v * 2].size(); i++) {
        te[v].emplace_back(te[v * 2][i]);
    }
    for (int i = 0; i < te[v * 2 + 1].size(); i++) {
        te[v].emplace_back(te[v * 2 + 1][i]);
    }
    sort(te[v].begin(), te[v].end());
}

int cat(int v, int l, int r, int tl, int tr) {
    if (tl > r || tr < l) {
        return 0;
    }
    if (tl >= l && tr <= r) {
        int l_ = -1, r_ = te[v].size(), mid;
        while (l_ + 1 < r_) {
            mid = (l_ + r_) / 2;
            if (te[v][mid] <= r) {
                l_ = mid;
            } else {
                r_ = mid;
            }
        }
        return te[v].size() - r_;
    }
    int tm = (tl + tr) / 2;
    return cat(v * 2, l, r, tl, tm) + cat(v * 2 + 1, l, r, tm + 1, tr);
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k, t;
    cin >> n >> k >> t;
    a.resize(2 * n);
    nxt.resize(2 * n, 2 * n);
    te.resize(2 * n * 4);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = n; i < 2 * n; i++) {
        a[i] = a[i - n];
    }
    map<int, int> last;
    for (int i = 0; i < n; i++) {
        last[a[i]] = INF;
    }
    for (int i = 0; i < n * 2; i++) {
        if (last[a[i]] < i) {
            nxt[last[a[i]]] = i;
        }
        last[a[i]] = i;
    }
    build(1, 0, 2 * n - 1);
    vector<int> was(n, -1);
    vector<int> cnt(n, 0);
    vector<int> zalupa(n, -1);
    for (int now = 0; now < n; now++) {
        int l = 1, r = n + 1;
        int tc;
        while (l + 1 < r) {
            int m = (l + r) / 2;
            tc = cat(1, now, now + m - 1, 0, 2 * n - 1);
            if (tc <= t) {
                l = m;
            } else {
                r = m;
            }
        }
        zalupa[now] = l;
    }
    int now = 0;
    int ans = 0;
    int ost = n * k;
    if (cat(1, 0, n - 1, 0, 2 * n - 1) <= t) {
        cout << 1;
        return 0;
    }
    while (ost) {
        if (was[now] - ost < ost && was[now] != -1) {
            ans += (ans - cnt[now]) * (ost / (was[now] - ost));
            ost %= (was[now] - ost);
        }
        if (!ost) break;

        int l = zalupa[now];
        l = min(l, ost);
        zalupa[now] = l;
        was[now] = ost;
        cnt[now] = ans;
        now = (now + l) % n;
        ost -= l;
        ans++;
    }
    cout << ans;
}
