#include<bits/stdc++.h>

#define x first
#define y second
#define int long long
#define endl "\n"

using namespace std;

int n, k, t;
vector<int> b, tree[(1 << 21)];

void build(int v, int l, int r)
{
    if(l == r)
        tree[v] = {b[l]};
    else
    {
        int m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m + 1, r);
        int i = 0, j = 0;
        while(true)
        {
            if(i == tree[2 * v + 1].size() && j == tree[2 * v + 2].size())
                break;
            else if(i == tree[2 * v + 1].size())
                tree[v].push_back(tree[2 * v + 2][j]), j++;
            else if(j == tree[2 * v + 2].size())
                tree[v].push_back(tree[2 * v + 1][i]), i++;
            else
            {
                if(tree[2 * v + 1][i] <= tree[2 * v + 2][j])
                    tree[v].push_back(tree[2 * v + 1][i]), i++;
                else tree[v].push_back(tree[2 * v + 2][j]), j++;
            }
        }
    }
}

int get(int v, int l, int r, int ql, int qr, int x)
{
    if(ql <= l && r <= qr)
    {
        /*for(int i : tree[v])
            cout << i << " ";
        cout << "\t\t" << lower_bound(tree[v].begin(), tree[v].end(), x) - tree[v].begin() << endl;*/
        return lower_bound(tree[v].begin(), tree[v].end(), x) - tree[v].begin();
    }
    else if(r < ql || qr < l)
        return 0;
    else
    {
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, ql, qr, x)
            + get(2 * v + 2, m + 1, r, ql, qr, x);
    }
}

inline int get(int l, int r)
{
    if(r >= 3 * n)
        r = r % n + 2 * n;
    return get(0, 0, 3 * n - 1, l, r, l);
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k >> t;
    vector<int> a(n);
    for(int i = 0; i < n; i++)
        cin >> a[i];
    map<int, int> mp;
    b.resize(3 * n);
    for(int i = 0; i < n * 3; i++)
        b[i] = mp[a[i % n]] - 1, mp[a[i % n]] = i + 1;
    build(0, 0, 3 * n - 1);
    vector<pair<int, int>> nxt(n);
    for(int i = 0; i < n; i++)
    {
        int l = i, r = n * k - 1;
        while(l < r)
        {
            int m = (l + r + 1) / 2;
            if(get(i, m) <= t)
                l = m;
            else r = m - 1;
        }
        l++;
        nxt[i] = {l % n, l - i};
    }
    vector<bool> used(n);
    int p = 0;
    while(!used[p])
    {
        used[p] = true;
        p = nxt[p].x;
    }
    int c = p, cnt = 0, len = 0;
    while(true)
    {
        len += nxt[p].y;
        cnt++;
        p = nxt[p].x;
        if(p == c)
            break;
    }
    p = 0;
    int ans = 0, sum = 0;
    while(p != c)
    {
        if(sum >= n * k)
            break;
        sum += nxt[p].y;
        p = nxt[p].x;
        ans++;
    }
    sum = min(sum, n * k);
    int rem = n * k - sum;
    int CNT = rem / len;
    ans += CNT * cnt;
    sum += CNT * len;
    while(sum < n * k)
    {
        sum += nxt[p].y;
        p = nxt[p].x;
        ans++;
    }
    cout << ans;
    return 0;
}