#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(time(0));

struct Node {
    Node *L, *R;
    ll v;
    int y, c;

    Node() {
        L = R = 0;
        y = rnd();
        c = 1;
    }

    Node(ll _v) {
        v = _v;
        L = R = 0;
        y = rnd();
        c = 1;
    }
};

int sz(Node *r) {
    return r == 0 ? 0 : r->c;
}

void update(Node *r) {
    r->c = sz(r->L) + 1 + sz(r->R);
}

pair<Node *, Node *> split(Node *r, ll x) {
    if (r == 0)
        return {0, 0};
    else if (sz(r->L) >= x) {
        auto p = split(r->L, x);
        r->L = p.S;
        update(r);
        return {p.F, r};
    } else {
        auto p = split(r->R, x - sz(r->L) - 1);
        r->R = p.F;
        update(r);
        return {r, p.S};
    }
}

pair<Node *, Node *> val_split(Node *r, ll x) {
    if (r == 0)
        return {0, 0};
    else if (r->v > x) {
        auto p = val_split(r->L, x);
        r->L = p.S;
        update(r);
        return {p.F, r};
    } else {
        auto p = val_split(r->R, x);
        r->R = p.F;
        update(r);
        return {r, p.S};
    }
}

Node *merge(Node *r1, Node *r2) {
    if (r1 == 0)
        return r2;
    else if (r2 == 0)
        return r1;
    else if (r1->y > r2->y) {
        r1->R = merge(r1->R, r2);
        update(r1);
        return r1;
    } else {
        r2->L = merge(r1, r2->L);
        update(r2);
        return r2;
    }
}

struct bor {
    bool term;
    unordered_map<char, bor *> g;

    bor(bool b) {
        term = b;
    }

    bor() {}
};

bor *Broot = new bor();

bor *go(string &s) {
    bor *pos = Broot;
    for (char c: s)
        pos = pos->g[c];
    return pos;
}

void add(string &s) {
    bor *pos = go(s);
    pos->term = 1;
}

bool check(string &s) {
    bor *pos = go(s);
    return pos->term;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> arr(n);
    set<ll> h;
    for (ll &i: arr)
        cin >> i, h.insert(i);
    if (h.size() <= t) {
        cout << 1;
        return 0;
    }

    ll pos1 = 0, pos2 = 0, ans = 1;
    h.clear();
    while (pos1 < k) {
        if (h.size() == t && !h.count(arr[pos2])) {
            h.clear();
            ans++;
        }
        h.insert(arr[pos2]);

        if (++pos2 == n)
            pos2 = 0, pos1++;
    }

    cout << ans;
}
/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

*/
/*

*/
/*

*/
/*
Вроде это жадность.
Сначала тупняк для проверки напишу.
*/
/*

*/
