#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(100);

struct mst {
    vector<vector<ll>> arr;
    ll sz;

    mst(vector<ll> &inp) {
        ll k = 1;
        while (k < inp.size())
            k *= 2;

        sz = k * 2;
        arr.resize(sz);
        unordered_map<ll, ll> last;
        for (int i = inp.size() - 1; i >= 0; --i) {
            if (!last.count(inp[i]))
                arr[i + k] = {(ll) inp.size()};
            else
                arr[i + k] = {last[inp[i]]};
            last[inp[i]] = i;
        }

        while (--k)
            merge(k);
    }

    void merge(ll x) {
        ll s1 = arr[x * 2].size();
        ll s2 = arr[x * 2 + 1].size();
        ll p1 = 0, p2 = 0;
        arr[x].resize(s1 + s2);
        while (p1 + p2 < s1 + s2)
            if (p2 == s2 || p1 != s1 && arr[x * 2][p1] < arr[x * 2 + 1][p2]) {
                arr[x][p1 + p2] = arr[x * 2][p1];
                p1++;
            } else {
                arr[x][p1 + p2] = arr[x * 2 + 1][p2];
                p2++;
            }
    }

    ll ost, l, r, ret;

    ll ask1(ll from, ll to, ll _o) {
        ost = _o, l = from, r = to, ret == -1;
        return ask(0, sz / 2, 1);
    }

    ll ask(ll L, ll R, ll now) {
        if (L >= l && R <= r) {
            ll l1 = -1, r1 = arr[now].size(), m;
            while (r1 - l1 > 1) {
                m = (r1 + l1) / 2;
                if (arr[now][m] >= r)
                    r1 = m;
                else
                    l1 = m;
            }
            ll x = arr[now].size() - r1;
            return x;
        } else if (R <= l || L >= r)
            return 0;
        else {
            ll a = ask(L, (R + L) / 2, now * 2);
            ll b = ask((R + L) / 2, R, now * 2 + 1);
            return a + b;
        }
    }
};

ll n, k, t;
vector<ll> arr;

ll solve() {
    set<ll> h;
    for (ll &i: arr)
        h.insert(i);
    if (h.size() <= t)
        return 1;
    h.clear();

    for (int i = 0; i < n; ++i)
        arr.push_back(arr[i]);

    mst MST = *new mst(arr);

    ll pos1 = 0, pos2 = 0, ans = 0;
    while (pos1 < k) {
        ans++;

        ll l = pos2 + 1, r = n * 2, m;
        while (r - l > 1) {
            m = (r + l) / 2;
            ll x = MST.ask1(pos2, m, t);
            if (x <= t)
                l = m;
            else
                r = m;
        }
        if (l >= n)
            pos1++, l -= n;
        pos2 = l;
    }
    return ans;
}

ll stup() {
    set<ll> h;
    for (ll &i: arr)
        h.insert(i);
    if (h.size() <= t)
        return 1;
    h.clear();

    ll pos1 = 0, pos2 = 0, ans = 1;
    while (pos1 < k) {
        if (h.size() == t && !h.count(arr[pos2])) {
            h.clear();
            ans++;
        }
        h.insert(arr[pos2]);

        if (++pos2 == n)
            pos2 = 0, pos1++;
    }

    return ans;
}

void gen() {
    n = rnd() % 4 + 1;
    k = 1;
    t = rnd() % 2 + 1;
    arr.resize(n);
    for (ll &i: arr)
        i = rnd() % 3 + 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);


    cin >> n >> k >> t;
    arr.resize(n);
    set<ll> h;
    for (ll &i: arr)
        cin >> i, h.insert(i);
    if (h.size() <= t)
        return 1;
    cout << solve();
    return 0;

    ll _ = 0;
    while (cout << (++_) << endl) {
        gen();
        ll b = stup();
        ll a = solve();
        if (a != b) {
            cout << n << ' ' << k << ' ' << t << endl;
            for (int i = 0; i < n; ++i)
                cout << arr[i] << ' ';
            cout << "\n\n" << a << ' ' << b << endl;
            return 0;
        }
    }
}
/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7


*/
/*
4 1 1
1 1 1 2

*/
/*

*/
/*
Вроде это жадность.
Сначала тупняк для проверки напишу.

Написал, работает но долго.

Напишу дерево сортировки слиянием для новой жадности.
Бинпоиск по нему не зайдет, сделаю спуск наверное.
Вот так и знал что нужно будет.


Как там количество различных на отрезке...
 Для каждого числа узнаем следующее такое же (индекс) и потом берем длинну отрезка минус количество следующих равных индексов входящих в этот отрезок.

Наверное сначала напишу бинпоиск а потом переделаю в спуск.

Условно, на массиве есть левая граница, хотя пусть будет начало.
Надо найти наибольший преффикс такой, что чисел на этом преффиксе не более правых чем правая граница не больше икса.


 ААа, так.
 Количество различных = длинна - количество одинаковых пар подрят.
 Это значит что нужно взять наибольший отрезок такой, что элементов без пары в нем не более скольки-то.

 Ладно, пофиг, бинпоиск так бинпоиск.
*/
/*

*/
