#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(101);

struct mst {
    vector<vector<int>> arr;
    int sz;

    mst(vector<int> &inp) {
        int k = 1;
        while (k < inp.size())
            k *= 2;

        sz = k * 2;
        arr.resize(sz);
        unordered_map<int, int> last;
        for (int i = inp.size() - 1; i >= 0; --i) {
            if (!last.count(inp[i]))
                arr[i + k] = {(int) inp.size()};
            else
                arr[i + k] = {last[inp[i]]};
            last[inp[i]] = i;
        }

        while (--k)
            merge(k);
    }

    void merge(int x) {
        int s1 = arr[x * 2].size();
        int s2 = arr[x * 2 + 1].size();
        int p1 = 0, p2 = 0;
        arr[x].resize(s1 + s2);
        while (p1 + p2 < s1 + s2)
            if (p2 == s2 || p1 != s1 && arr[x * 2][p1] < arr[x * 2 + 1][p2]) {
                arr[x][p1 + p2] = arr[x * 2][p1];
                p1++;
            } else {
                arr[x][p1 + p2] = arr[x * 2 + 1][p2];
                p2++;
            }
    }

    int l, r;

    int ask1(int _l, int _r) {
        l = _l, r = _r;
        return ask(0, sz / 2, 1);
    }

    int ask(int L, int R, int now) {
        if (L >= l && R <= r) {
            int l1 = -1, r1 = arr[now].size(), m;
            while (r1 - l1 > 1) {
                m = (r1 + l1) / 2;
                if (arr[now][m] >= r)
                    r1 = m;
                else
                    l1 = m;
            }
            return arr[now].size() - r1;
        } else if (R <= l || L >= r)
            return 0;
        else {
            int a = ask(L, (R + L) / 2, now * 2);
            int b = ask((R + L) / 2, R, now * 2 + 1);
            return a + b;
        }
    }
};

int n, k, t;
vector<int> arr;

int solve() {
    set<int> h;
    for (int &i: arr)
        h.insert(i);
    if (h.size() <= t)
        return 1;
    h.clear();

    for (int i = 0; i < n; ++i)
        arr.push_back(arr[i]);

    mst MST = *new mst(arr);

    vector<int> dp(n);
    map<ll, ll> ma;
    ll x;
    for (int i = 0; i < n * 2; ++i)
        if (!ma.count(arr[i]) && ma.size() == t) {
            x = i;
            break;
        } else
            ma[arr[i]]++;
    dp[0] = x;
    for (int i = 1; i < n; ++i) {
        ma[arr[i - 1]]--;
        if (ma[arr[i - 1]] == 0)
            ma.erase(arr[i - 1]);
        while (1) {
            if (!ma.count(arr[x]) && ma.size() == t)
                break;
            else
                ma[arr[x]]++, x++;
        }
        dp[i] = x;
    }

    int pos1 = 0, pos2 = 0, ans = 0;
    while (pos1 < k) {
        ans++;

        int l = dp[pos2];
        if (l >= n)
            pos1++, l -= n;
        pos2 = l;
    }
    return ans;
}

int stup() {
    set<int> h;
    for (int &i: arr)
        h.insert(i);
    if (h.size() <= t)
        return 1;
    h.clear();

    int pos1 = 0, pos2 = 0, ans = 1;
    while (pos1 < k) {
        if (h.size() == t && !h.count(arr[pos2])) {
            h.clear();
            ans++;
        }
        h.insert(arr[pos2]);

        if (++pos2 == n)
            pos2 = 0, pos1++;
    }

    return ans;
}

void gen() {
    n = rnd() % 100 + 1;
    k = rnd() % 10 + 1;
    t = rnd() % 100 + 1;
    arr.resize(n);
    for (int &i: arr)
        i = rnd() % 100 + 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);


    cin >> n >> k >> t;
    arr.resize(n);
    for (int &i: arr)
        cin >> i;
    cout << solve();
    return 0;

    int _ = 0;
    while (cout << (++_) << endl) {
        gen();
        int b = stup();
        int a = solve();
        if (a != b) {
            cout << n << ' ' << k << ' ' << t << endl;
            for (int i = 0; i < n; ++i)
                cout << arr[i] << ' ';
            cout << "\n\n" << a << ' ' << b << endl;
            return 0;
        }
    }
}
/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7


*/
/*
4 1 1
1 1 1 2

*/
/*

*/
/*
Вроде это жадность.
Сначала тупняк для проверки напишу.

Написал, работает но долго.

Напишу дерево сортировки слиянием для новой жадности.
Бинпоиск по нему не зайдет, сделаю спуск наверное.
Вот так и знал что нужно будет.


Как там количество различных на отрезке...
 Для каждого числа узнаем следующее такое же (индекс) и потом берем длинну отрезка минус количество следующих равных индексов входящих в этот отрезок.

Наверное сначала напишу бинпоиск а потом переделаю в спуск.

Условно, на массиве есть левая граница, хотя пусть будет начало.
Надо найти наибольший преффикс такой, что чисел на этом преффиксе не более правых чем правая граница не больше икса.


 ААа, так.
 Количество различных = длинна - количество одинаковых пар подрят.
 Это значит что нужно взять наибольший отрезок такой, что элементов без пары в нем не более скольки-то.

 Ладно, пофиг, бинпоиск так бинпоиск.
*/
/*

*/
