#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <iomanip>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

const long long INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll n, k, t;
	cin >> n >> k >> t;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++) cin >> a[i];
	set<ll> st0(all(a));
	if (st0.size() <= t) { 
		cout << "1\n"; 
		return 0; 
	}
	ll i = 0, j = 0;
	map<ll, ll> mp;
	vector<ll> go(n);
	for (; i < n; i++) {
		while (true) {
			ll nxt = (j + 1) % n;
			mp[a[j]]++;
			if (mp.size() > t) {
				mp[a[j]]--;
				if (mp[a[j]] == 0) mp.erase(a[j]);
				break;
			} else {
				j = nxt;
			}
		}
		go[i] = (j - i + n) % n;
		mp[a[i]]--;
		if (mp[a[i]] == 0) mp.erase(a[i]);
	}
	ll cnt = k * n;
	ll ans = 0, v = 0;
	vector<bool> used(n, 0);
	while (cnt > 0) {
		ans++;
		used[v] = 1;
		cnt -= go[v];
		v = (v + go[v]) % n;
		if (used[v]) break;
	}
	ll ansc = 0, cntc = 0;
	ll u = v;
	do {
		ansc++;
		cntc += go[v];
		v = (v + go[v]) % n;
	} while (u != v);
	ll f = (cnt / cntc);
	ans += f * ansc;
	cnt -= f * cntc;

	while (cnt > 0) {
		ans++;
		cnt -= go[v];
		v = (v + go[v]) % n;
	}
	cout << ans << "\n";
	return 0;
}