#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define pw(x) (1ll << x)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn (T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx (T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pii = pair < int , int >;

const int N = 1e6 + 5;
const int inf = 2e9;
const ll INF = 4e18;

int n, k, t;
int a[N];

struct fenwick {
    vector < int > t;
    void init (int _n) {
        t.resize (_n + 1);
        fill (all (t), 0);
    }

    void upd (int v, int val) {
        for (; v < sz(t); v = (v | (v + 1))) t[v] += val;
    }

    int get (int v) {
        int res = 0;
        for (;v >= 0; v = (v & (v + 1)) - 1) res += t[v];
        return res;
    }

    int get (int l, int r) {
        return get (r) - get (l - 1);
    }
} tt;

map < int , int > last;
int to[N];

set < int > st;

bool used[N];
vector < pii > order;

int main() {
#ifdef localy
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> k >> t;
    for (int i = 1; i <= n; ++ i) cin >> a[i], st.insert (a[i]);

    if (t >= sz(st)) {
        cout << 1 << "\n";
        return 0;
    }

    for (int i = n + 1; i <= 2 * n; ++ i) a[i] = a[i - n];

    tt.init (2 * n);

    int r = 0;
    for (int l = 1; l <= n; ++ l) {
        while (r < 2 * n && tt.get (l, r) <= t) {
            ++ r;
            if (last.find (a[r]) != last.end()) tt.upd (last[a[r]], -1);
            last[a[r]] = r;
            tt.upd (r, 1);
        }

        to[l] = r;
    }

    ll cnt = 0;
    int pos = 1;
    int s = 0;
    int b = 1;

    while (true) {

        if (used[pos]) {
            s = pos;
            break;
        }

        used[pos] = true;

        if (to[pos] > n) {
            if (b == k) {
                s = -1;
                break;
            }
            order.pb ({pos, 1});
            ++ cnt;
            ++ b;
            pos = to[pos] - n;
        } else {
            order.pb ({pos, 0});
            ++ cnt;
            pos = to[pos];
        }
    }

    k -= b - 1;
    
    if (s == -1) {
        cout << cnt + 1 << "\n";
        return 0;
    }

    assert (0);

    reverse (all (order));
    while (order.back().fi != s) order.pop_back();
    reverse (all (order));

    int block = 0;
    for (auto[val, tp] : order) {
        block += tp;
    }

    cnt += 1ll * sz(order) * (k / block);
    k %= block;

    for (auto[val, tp] : order) {
        if (!k) break;
        ++ cnt;
        k -= tp;
    }

    cout << cnt << "\n";
    return 0;
}
