#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <deque>
#include <queue>
#include <assert.h>
#include <random>
#include <math.h>
#include <bitset>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define all(a) a.begin(), a.end()
#define ff first
#define ss second
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

mt19937 rnd(time(0));
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

#define int long long
vi a;
int n, k, t;

void solve1() {
    vi b(n);
    unordered_set<int> s;
    for (auto& x : a) s.insert(x);
    if (s.size() <= t) {
        cout << 1;
        return;
    }
    int r = 0;
    unordered_map<int, int> used;
    s.clear();
    s.insert(a[r]);
    used[a[0]] = 1;
    while (s.size() < t || s.size() == t && s.find(a[(r + 1) % n]) != s.end()) {
        r = (r + 1) % n;
        s.insert(a[r]);
        used[a[r]]++;
    }
    r = (r + 1) % n;
    b[0] = r;
    for (int st = 1; st < n; ++st) {
        if (a[st - 1] == a[st]) {
            b[st] = r;
            used[a[st]]--;
            continue;
        }
        int x = a[st - 1];
        if (used[x] > 1) {
            b[st] = r;
            used[x]--;
            continue;
        }
        s.erase(x);
        used[x] = 0;
        s.insert(a[r]);
        used[a[r]] = 1;
        while (s.size() < t || s.size() == t && s.find(a[(r + 1) % n]) != s.end()) {
            r = (r + 1) % n;
            s.insert(a[r]);
            used[a[r]]++;
        }
        r = (r + 1) % n;
        b[st] = r;
    }

    vector<pii> next(n);
    for (int st = n - 1; st >= 0; --st) {
        int r = b[st];
        if (r > st)
            next[st] = { next[r].ff, next[r].ss + 1 };
        else
            next[st] = { r, 1 };
    }
    
    vi used_id(n, 0);
    int i = 0;
    used_id[i] = 1;

    int id_st = -1;
    vi v_id;
    while (true) {
        i = next[i].ff;
        if (used_id[i]) {
            id_st = i;
            break;
        }
        used_id[i] = 1;
    }
    i = id_st;
    int cnt1 = next[i].ss;
    v_id.push_back(i);
    i = next[i].ff;
    while (i != id_st) {
        v_id.push_back(i);
        cnt1 += next[i].ss;
        i = next[i].ff;
    }

    int sz = v_id.size();
    int cnt0 = 0;
    i = 0;
    int sz0 = 0;
    while (i != id_st) {
        sz0++;
        cnt0 += next[i].ss;
        i = next[i].ff;
        if (sz0 == k) {
            cout << cnt0;
            return;
        }
    }

    int k0 = k - sz0;
    int lol = k0 / sz, ost = k0 % sz;
    i = v_id[0];
    int cnt2 = 0;
    for (int j = 0; j < ost; ++j) {
        cnt2 += next[i].ss;
        i = next[i].ff;
    }

    int ans = cnt0 + cnt1 * lol + cnt2;
    cout << ans;
}

void solve2() {
    int cnt = 0;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] != a[i + 1]) {
            cnt++;
        }
    }
    if (cnt == 0) {
        cout << 1;
        return;
    }

    bool f = 0;
    while (a[n - 1] == a[0]) {
        a.pop_back();
        n--;
        f = 1;
    }

    int ans;
    if (f) ans = cnt * k + 1;
    else ans = (cnt + 1) * k;
    cout << ans;
}

signed main()
{
    fast;
    
    cin >> n >> k >> t;
    a.resize(n);
    for (auto& i : a) cin >> i;

    if (t == 0) solve2();
    else solve1();
    
}
