#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
//#pragma GCC optimize("trapv")
#endif
#include <bits/stdc++.h>

const int MAX_N = (int)3e5+10;
const int INT_INF = (int)2e9;
const double pi = acos(-1);


using namespace std;
using ld = long double;
using ll = long long;

int bin[55][MAX_N];
__int128 cnt[55][MAX_N];

void build_bin(int n){
    for(int i = 1;i<55;++i){
        for(int j = 0;j<n;++j){
            bin[i][j] = bin[i-1][bin[i-1][j]];
            cnt[i][j] = cnt[i-1][j]+cnt[i-1][bin[i-1][j]];
        }
    }
}

ll calc(__int128 n){
    int ind = 0;
    ll ans = 0;
    for(int i = 55;i>=0;--i){
        if((1ll<<i)&n){
            ans+=cnt[i][ind];
            ind = bin[i][ind];
        }
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
    int n;
    ll k,t;
    cin>>n>>k>>t;
    vector<int>a(n);
    for(auto &c:a) cin>>c;
    vector<int>v(2*n);
    for(int i = 0;i<n;++i){
        v[i] = a[i];
        v[i+n] = a[i];
    }
    set<int>st;
    for(int i = 0;i<n;++i){
        st.insert(a[i]);
    }
    if(st.size()<=t){
        cout<<1;
        return 0;
    }
    set<pair<int,int>>st2;
    st.clear();
    int u = 0;
    for(int i = 0;i<n;++i){
        while(u<(int)v.size() && st.size()<=t){
            if(st.find(v[u])==st.end()){
                st2.insert({v[u],1});
                st.insert(v[u]);
            }
            else{
                auto it = st2.lower_bound({v[u],0});
                pair<int,int>pn = *it;
                pn.second++;
                st2.erase(it);
                st2.insert(pn);
            }
            ++u;
        }
        --u;
        auto it = st2.find({v[u],1});
        st2.erase(it);
        st.erase(v[u]);
        bin[0][i] = u%n;
        cnt[0][i] = u-i;
        it = st2.lower_bound({v[i],0});
        pair<int,int>pn = *it;
        st2.erase(it);
        pn.second--;
        if(pn.second == 0){
            st.erase(pn.first);
        }
        else{
            st2.insert(pn);
        }
    }
    build_bin(n);
    __int128 l = 0;
    __int128 r = 1e15;
    while(l+1!=r){
        __int128 mid = (l+r)/2;
        ll c = calc(mid);
        if(c>=n*k){
            r=mid;
        }
        else l = mid;
    }
    cout<<(ll)r;
    return 0;
}
