//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ll = long long;
using ld = long double;

const ll INF = 2e18;
const int MOD = 1e9 + 7, N = 1e5 + 1, MAXN = 5e5 + 1, K = 26, INFi = 2e9;
const ld EPS = 1e-12, PI = acos(-1);

random_device rd;
mt19937_64 rnd(rd());

int n, k, t;
vector<int> a;

void gen() {
    n = abs((int)rnd()) % 10 + 1;
    k = abs((int)rnd()) % 10 + 1;
    t = abs((int)rnd()) % 10 + 1;
    a.resize(n);
    for (int &e : a) {
        e = abs((int)rnd()) % 100 + 1;
    }
}

int stupid() {
    vector<int> v;
    for (int i = 0; i < k; i++) {
        for (int &e : a) {
            v.push_back(e);
        }
    }
    int ans = 0;
    set<int> st;
    for (int &e : v) {
        st.insert(e);
        if (st.size() > t) {
            st.clear();
            ans++;
            st.insert(e);
        }
    }
    return ans + !st.empty();
}

bool check() {
    set<int> st;
    for (int &e : a) {
        st.insert(e);
    }
    return st.size() <= t;
}

void solve() {
    cin >> n >> k >> t;
    a.resize(n);
    for (int &e : a) {
        cin >> e;
    }
    if (check()) {
//        return 1;
        cout << 1;
        return;
    }
    vector<int> b = a;
    for (int &e : a) {
        b.push_back(e);
    }

    int m = (int)b.size();
    vector<int> jump(m);
    jump[m - 1] = n - 1;
    set<int> st;
    int last = m - 1;
    st.insert(b[m - 1]);
    gp_hash_table<int, int> gp;
    gp[b[m - 1]] = 1;
    for (int i = m - 2; i >= 0; i--) {
        st.insert(b[i]);
        gp[b[i]]++;
        for (; st.size() > t && last >= i; last--) {
            gp[b[last]]--;
            if (!gp[b[last]]) {
                gp.erase(b[last]);
                st.erase(b[last]);
            }
        }
        jump[i] = last % n;
    }

//    for (int i = 0; i < n; i++) {
//        cout << jump[i] << ' ';
//    } cout << '\n';

    int ans = 0, cnt = n * k, cur = 0;
    vector<bool> used(n);
    while (cnt > 0) {
//        cout << cnt << ' ' << cur << '\n';
        if (used[cur]) {
            break;
        }
        used[cur] = true;
        ans++;
        int diff = jump[cur] - cur + 1;
        if (jump[cur] < cur) {
            diff = n - cur + jump[cur] + 1;
        }
        cnt -= diff;
        cur = (cur + diff) % n;
//        cout << cur << ' ' << cnt << '\n';
    }
//    cout << ans << ' ' << cur << ' ' << cnt << '\n';
    int circle = 0, prev = cur, count = 0;
    while (cnt > 0 && (cur != prev || circle == 0)) {
        ans++;
        int diff = jump[cur] - cur + 1;
        if (jump[cur] < cur) {
            diff = n - cur + jump[cur] + 1;
        }
        count++;
        cnt -= diff;
        cur = (cur + diff) % n;
        circle += diff;
    }
//    cout << '\n';
//    cout << ans << ' ' << cnt <<  ' ' << circle << ' ' << count << ' ' << cur << '\n';
    if (cnt >= circle && cnt > 0) {
        ans += (cnt / circle) * count;
        cnt %= circle;
    }
    while (cnt > 0) {
        ans++;
        int diff = jump[cur] - cur + 1;
        if (jump[cur] < cur) {
            diff = n - cur + jump[cur] + 1;
        }
        cnt -= diff;
        cur = (cur + diff) % n;
    }
//    return ans;
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int T = 1;
//    cin >> T;
    while (T--) {
//        gen();
//        int a1 = solve(), a2 = stupid();
//        if (a1 != a2) {
//            cout << "solution: " << a1 << '\n';
//            cout << "OK: " << a2 << '\n';
//            cout << n << ' ' << k << ' ' << t << '\n';
//            for (int &e : a) {
//                cout << e << ' ';
//            }
//            exit(0);
//        }
        solve();
    }
    return 0;
}
