#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9 + 1;
const int mod = inf + 6;
const ll infll = 1ll * (inf - 1) * (inf - 1);
mt19937_64 rnd(time(0));
const int N = 3e5 + 100, lg = 52;
ll up[N][lg];
void solve_case() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(3 * n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<int> all;
    for (int i = 0; i < n; i++) all.push_back(a[i]);
    sort(all.begin(), all.end());
    all.erase(unique(all.begin(), all.end()), all.end());
    for (int i = 0; i < n; i++) a[i] = lower_bound(all.begin(), all.end(), a[i]) - all.begin();
    for (int i = 0; i < 2 * n; i++) a[i + n] = a[i];
    if (all.size() <= t) {
        cout << 1 << "\n";
        return;
    }
    vector<int> nxt(n);
    {
        int ptr = 0;
        vector<int> cnt(n);
        int in = 0;
        for (int i = 0; i < n; i++) {
            while (ptr != a.size() && in + (cnt[a[ptr]] == 0) <= t) {
                cnt[a[ptr]]++;
                in += cnt[a[ptr]] == 1;
                ptr++;
            }
            nxt[i] = ptr;
            cnt[a[i]]--;
            if (cnt[a[i]] == 0) in--;
        }
    }
    for (int i = 0; i < n; i++) {
        up[i][0] = nxt[i];
    }
    for (int bit = 1; bit < lg; bit++) {
        for (int i = 0; i < n; i++) {
            ll f1 = up[i][bit - 1];
            if (f1 > 1ll * n * k) {
                up[i][bit] = f1;
            } else {
                up[i][bit] = up[f1 % n][bit - 1] + (f1 - f1 % n);
            }
        }
    }
    ll ans = 0;
    ll v = 0;
    for (int bit = lg - 1; bit >= 0; bit--) {
        if (up[v % n][bit] + (v - v % n) <= 1ll * n * k) {
            ans += 1ll << bit;
            v = up[v % n][bit] + v - v % n;
        }
    }
    if (v != 1ll * n * k) ans++;
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve_case();
    }
}
