#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define ll long long
#define F first
#define S second

#ifdef LOCAL
constexpr int MAXN = 100, LG = 10;
#else
constexpr int MAXN = 300010, LG = 60;
#endif

int cnt[MAXN], curcnt = 0;
pair<ll, ll> binup[LG][MAXN];

void add(int x) {
    curcnt += !cnt[x];
    cnt[x]++;
}

void del(int x) {
    cnt[x]--;
    curcnt -= !cnt[x];
}

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(2 * n), nxt(n), bin;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        bin.push_back(a[i]);
    }
    sort(all(bin));
    bin.erase(unique(all(bin)), bin.end());
    int sz = bin.size();
    if (sz <= t) {
        cout << 1;
        return;
    }
    for (int i = 0; i < n; i++) {
        a[i] = a[i + n] = lower_bound(all(bin), a[i]) - bin.begin();
    }
    int cur = -1;
    for (int i = 0; i < n; i++) {
        while (curcnt <= t) {
            add(a[++cur]);
        }
        binup[0][i] = { nxt[i] = cur - i, 1 };
        del(a[i]);
    }

    for (int bit = 1; bit < LG; bit++) {
        for (int i = 0; i < n; i++) {
            binup[bit][i].F = binup[bit - 1][i].F + binup[bit - 1][(i + binup[bit - 1][i].F) % n].F;
            binup[bit][i].S = binup[bit - 1][i].S + binup[bit - 1][(i + binup[bit - 1][i].S) % n].S;
        }
    }
    ll cm = k * 1ll * n, st = 0, ans = 1;
    for (int bit = LG - 1; bit >= 0; --bit) {
        if (st + binup[bit][st % n].F >= cm)
            continue;
        ans += binup[bit][st % n].S;
        st += binup[bit][st % n].F;
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("D:\\lion1\\input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
    return 0;
}
