// clang-format off
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pii;
typedef vector<ll> d1;
typedef vector<d1> d2;
typedef vector<pii> d1p;
typedef vector<d1p> d2p;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

ostream& operator<<(ostream&cout, const pii&a){cout<<a.first<<","<<a.second;return cout;}
pii min(const pii &a, const pii &b){if(a.first<b.first) return a;else return b;}
pii max(const pii &a, const pii &b){if(a.first>b.first) return a;else return b;}
template<typename T> T min(vector<T> &a){return *min_element(a.begin(), a.end());}
template<typename T> T max(vector<T> &a){return *max_element(a.begin(), a.end());}
template<typename T> T sum(vector<T>&a){T m=0;for(T&i:a)m+=i;return m;}
template<typename T> void print(vector<T>&a){for(T&i:a)cout<<i<<" ";cout<<"\n";}
template<typename T> void print(vector<vector<T>>&a){for(vector<T>&i:a)print(i);}

#define stuff ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define fori(x, n) for(ll i = x; i < n; ++i)
#define forj(x, n) for(ll j = x; j < n; ++j)
#define fork(x, n) for(ll k = x; k < n; ++k)
#define foru(p, t) for(ll i = p; i < t.size(); i+=i&-i)
#define ford(r, t) for(ll i = r; i > 0; i-=i&-i)
#define all(a) a.begin(), a.end()
#define sort(a) sort(all(a))
#define reverse(a) reverse(all(a))
#define unique(a) a.erase(unique(all(a)), a.end());
#define wt ll _t; cin>>_t; while(_t--)
#define __lg(x) 63ll - __builtin_clzll(x)
#define pb push_back
#define pob pop_back
#define endl "\n"
#define F first
#define S second
#define B back()

d1 seen;
ll _cnt = 0, _up_cnt = 0;

void __cnt(ll v, d1 &nxt, d1 &up){
    _cnt++;
    _up_cnt+=up[nxt[v]];
    seen[v] = 1;
    if(!seen[nxt[v]]){
        __cnt(nxt[v], nxt, up);
    }
}

signed main(){
    stuff;
    ll n, k, t;
    cin >> n >> k >> t;
    d1 a(n);
    fori(0, n) cin >> a[i];
    unordered_set<ll> _st(all(a));
    if(_st.size() <= t){
        cout << 1;
        return 0;
    }
    unordered_map<ll, ll> mp;
    d1 b = a;
    b.insert(b.end(), all(a));
    ll r = 2*n-1;
    d1 nxt(n), up(n);
    for(ll i = 2*n-1; i >= 0; --i){
        mp[b[i]]++;
        while(mp.size() > t){
            mp[b[r]]--;
            if(mp[b[r]] == 0) mp.erase(b[r]);
            r--;
        }
        if(i < n){
            nxt[i] = (r+1)%n;
            up[i] = (r+1 >= n);
        }
    }
    seen = d1(n);
    ll res = 0;
    ll v = 0;
    while(k and !seen[nxt[v]]){
        res++;
        k-=up[v];
        v = nxt[v];
        seen[v] = 1;
    }
    seen = d1(n);
    __cnt(v, nxt, up);
    ll tmp = (k-1)/_up_cnt;
    k-=tmp*_up_cnt;
    res+=tmp*_cnt;
    while(k){
        res++;
        k-=up[v];
        v = nxt[v];
    }
    cout << res;
}