#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

typedef long long ll;

const ll MOD = 1e9 + 7;
const ll INF = 1e18 + 9;

#pragma GCC optimize("unroll-loops,inline,02,03,Ofast")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,fma,mmx,sse,sse2,sse3,sse4,ssse3")

void solve() {

    ll n = 0, k = 0, t = 0;
    cin >> n >> k >> t;
    vector<ll> a, ans(n);
    set<ll> s;

    for (int i = 0; i < n; i++) {
        ll x = 0;
        cin >> x;
        s.insert(x);
        a.push_back(x);
    }

    if (s.size() <= t) {
        cout << 1;
        return;
    }

    unordered_map<ll, ll> cntType;
    ll ft = t;
    ll r = 0;

    for (int i = 0; i < n; i++) {
        if (i) {
            cntType[a[i - 1]]--;
            if (cntType[a[i - 1]] == 0) {
                ft++;
            }
        }
        while (ft > 0 && cntType[a[r]] == 0 || cntType[a[r]] > 0) {
            if (cntType[a[r]] == 0) {
                ft--;
            }
            cntType[a[r]]++;
            r++;
            r %= n;
        }
        ans[i] = r;
    }
    ll l = 0, pe = 0, gft = 0;
    bool f = false;
    while (!f && gft < n * k) {
        pe++;
        ll l1 = l;
        l = ans[l];
        if (l1 > l) {
            gft += n + l - l1;
        }
        else {
            gft += l - l1;
        }
        if (l == 0) {
            f = true;
        }
    }
    if (gft + gft < n * k) {
        ll mlt = n * k / gft;
        gft *= mlt;
        pe *= mlt;
    }
    while (gft < n * k) {
        pe++;
        ll l1 = l;
        l = ans[l];
        if (l1 > l) {
            gft += n + l - l1;
        }
        else {
            gft += l - l1;
        }
    }
    cout << pe;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}
