// JafoNoksy's code
#include <bits/stdc++.h>

#pragma GCC optimize "O2"
using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define F first
#define S second
#define int ll
#define ve vector
mt19937 rnd(4732);

template<class A>
istream &operator>>(istream &in, ve<A> &x) {
    for (auto &c: x)
        in >> c;
    return in;
}

template<class A>
ostream &operator<<(ostream &out, ve<A> &x) {
    for (auto &c: x)
        out << c << ' ';
    return out << '\n';
}

struct segtree {
    ve<int> t;
    int n = 0;

    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    int get(int v, int l, int r, int _l, int _r) {
        if (l >= _r || _l >= r)
            return 0;
        if (_l <= l && r <= _r)
            return t[v];
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, _l, _r) + get(2 * v + 2, m, r, _l, _r);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }

    segtree(ve<int> a = {1}) {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n, a);
    }
};

struct mst {
    ve<ve<int>> t;

    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = {a[l]};
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v].resize(t[2 * v + 1].size() + t[2 * v + 2].size());
        merge(t[2 * v + 1].begin(), t[2 * v + 1].end(), t[2 * v + 2].begin(), t[2 * v + 2].end(), t[v].begin());
    }

    void get(int v, int l, int r, int i, int s) {
        int m = (l + r) / 2;
    }
};

ve<pll> ext(ve<pll> a, ve<pll> b) {
    int n = a.size();
    ve<pll> c(n);
    for (int i = 0; i < n; ++i) {
        c[i] = {a[b[i].F].F, a[b[i].F].S + b[i].S};
    }
    return c;
}

ve<pll> fpow(ve<pll> &a, int d) {
    if (d == 1)
        return a;
    if (d & 1)
        return ext(fpow(a, d - 1), a);
    auto c = fpow(a, d / 2);
    return ext(c, c);
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k, t;
    cin >> n >> k >> t;
    ve<int> a(n);
    cin >> a;
    if (t == 1) {
        ve<int> b;
        for (int i = 0; i < n; ++i) {
            if (i == 0 || a[i] != a[i - 1])
                b.pb(a[i]);
        }
        n = b.size();
        if (b[0] != b.back()) {
            cout << (n * k + t - 1) / t;
            return 0;
        }
        n--;
        for (int i = 0; i < n; ++i) {
            b[i] = b[i + 1];
        }
        b.pop_back();
        cout << (n * k + t - 1) / t + 1;
        return 0;
    }
    ve<int> b;
    for (int i = 0; i < n; ++i) {
        if (i == 0 || a[i] != a[i - 1])
            b.pb(a[i]);
    }
    n = b.size();
    int ans = 0;
    int x = 0;
    if (b[0] == b.back()) {
        n--;
        ans++;
        for (int i = 0; i < n; ++i) {
            b[i] = b[i + 1];
        }
        b.pop_back();
    }
    set<int> diff;
    for (int i = 0; i < n; ++i)
        diff.insert(b[i]);
    if (diff.size() <= t) {
        cout << 1;
        return 0;
    }

    ve<int> c(n);
    for (int i = 0; i < n; ++i) {
        set<int> tmp;
        int j = i;
        for (; tmp.size() <= t; j = (j + 1) % n) {
            tmp.insert(b[j]);
        }
        j = ((j - 1) + n) % n;
        c[i] = j;
    }
    ve<pll> d(n);
    for (int i = n - 1; i >= 0; --i) {
        if (c[i] > i)
            d[i] = {d[c[i]].F, d[c[i]].S + 1};
        else
            d[i] = {c[i], 1};
    }
    int j = 0;
    if (ans == 1) {
        set<int> tmp_diff;
        tmp_diff.insert(b.back());
        while (tmp_diff.size() <= t) {
            tmp_diff.insert(b[j]);
            j++;
        }
        j--;
    }
    for (int i = 0; i < k; ++i) {
        ans += d[j].S;
        j = d[j].F;
    }
    cout << ans;

}