#include<bits/stdc++.h>

using namespace std;

#define ll long long 
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()
#define int long long 

const ll INF = 1e18;
const int N = 6e5 + 10;
int t[N];

void inc(int i, int val) {
	for (; i < N; i = (i | (i + 1))) {
		t[i] += val;
	}
}

int get(int r) {
	int ans = 0;
	for (; r >= 0; r = (r & (r + 1)) - 1) {
		ans += t[r];
	}
	return ans;
}

signed main () {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	int n, k, t;
	cin >> n >> k >> t;
	vector<int> a(2 * n);
	set<int> st;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		st.insert(a[i]);
	}
	if (st.size() <= t) {
		cout << 1 << endl;
	} else {
		map<int, int> last;
		vector<int> go(n);
		for (int i = n; i < 2 * n; i++) {
			a[i] = a[i - n];
		}
		for (int i = 2 * n - 1; i >= 0; i--) {
			inc(i, 1);
			if (last.count(a[i])) {
				inc(last[a[i]], -1); 
			}
			last[a[i]] = i;
			if (i < n) {
				int l = i, r = 2 * n;
				while (r - l > 1) {
					int mid = (r + l) / 2;
					if (get(mid) <= t) {
						l = mid;
					} else {
						r = mid;
					}
				}
				go[i] = l - i + 1; 
			}
		}
		vector<vector<ll>> po(60, vector<ll>(n));
		for (int i = 0; i < n; i++) {
			po[0][i] = go[i];
		}
		for (int i = 1; i < 60; i++) {
			for (int j = 0; j < n; j++) {
				int k = (j + po[i - 1][j]) % n;
				po[i][j] = min(INF, po[i - 1][j] + po[i - 1][k]);
			}
		}
		int pos = 0, ans = 1;
		ll need = 1ll * n * k;
		for (int j = 59; j >= 0; j--) {
			if (po[j][pos] < need) {
				ans += (1 << j);
				need -= po[j][pos];
				pos = (pos + po[j][pos]) % n;			
			}
		}
		cout << ans << endl;
	}
	return 0;
}