#include <bits/stdc++.h>

using namespace std;

#define int long long

using ll = long long;
using ld = long double;
using li = __int128;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int inf = 1e18;
const int maxn = 2e5 + 10;
const int mod = 1e9 + 7;

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n), vals;
    for (int &x : a) {
        cin >> x;
        vals.push_back(x);
    }
    sort(vals.begin(), vals.end());
    vals.erase(unique(vals.begin(), vals.end()), vals.end());
    for (int &x : a) {
        x = lower_bound(vals.begin(), vals.end(), x) - vals.begin();
    }
    if (vals.size() <= t) {
        cout << 1;
        return;
    }
    vector<int> next(n, 0);
    for (int i = 0; i < n; ++i) {
        next[i] = i;
    }
    vector<int> cnt(2 * n, 0);
    int c = 0;
    for (int i = 0; i < n; ++i) {
        int r = -1;
        if (i != 0) {
            r = next[i - 1];
            cnt[a[i - 1]]--;
            if (cnt[a[i - 1]] == 0) c--;
        }
        while (c <= t) {
            //cout << r << " ";
            r++;
            r %= n;
            cnt[a[r]]++;
            if (cnt[a[r]] == 1) c++;
        }
        c--;
        cnt[a[r]]--;
        r--;
        if (r < 0) r += n;
        next[i] = r;
        //cout << endl;
    }
    vector<bool> used(n, false);
    int ind = 0;
    while (!used[ind]) {
        used[ind] = true;
        ind = next[ind] + 1;
        ind %= n;
    }
    int st = ind;
    int c1 = 0;
    int ans1 = 0;
    ind = st;
    used.assign(n, false);
    while (!used[ind]) {
        used[ind] = true;
        int prev = ind;
        ind = next[ind] + 1;
        ind %= n;
        if (ind <= prev) c1++;

        ans1++;
    }
    int c2 = 0;
    int ans2 = 0;
    ind = 0;
    while (!used[ind]) {
        int prev = ind;
        ind = next[ind] + 1;
        ind %= n;
        if (ind <= prev) c2++;

        ans2++;
    }
   // cout << st << " " << ans1 << " " << ans2 << " " << c1 << " " << c2;
    if (c2 >= k) {
        c = 0;
        int ans = 0;
        int cur = 0;
        while (c < k) {
            cout << 1;
            int prev = cur;
            cur = next[cur] + 1;
            cur %= n;
            if (cur <= prev) c++;

            ans++;
        }
        cout << ans;
        return;
    }
    k -= c2;
    int ans = 0;
    ans += ans2;
    if (k > 4 * c1) {
        ans += ans1 * ((k - 3 * c1) / c1);
        k -= ((k - 3 * c1) / c1) * c1;
    }
    ind = st;
    used.assign(n, false);
    while (k > 0) {
        //cout << 1;
        int prev = ind;
        ind = next[ind] + 1;
        ind %= n;
        if (ind <= prev) k--;
        ans++;
    }

    cout << ans;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int ttp = 1;
    //cin >> ttp;
    while (ttp--) {
        solve();
        cout << endl;
    }
}
