// #pragma GCC optimize("O3")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("D:\\work2\\input.txt", "r", stdin);
#define file_out freopen("D:\\work2\\output.txt", "w", stdout);
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define str string
#define pb push_back
#define ff first
#define sc second
#define all(a) a.begin(), a.end()
#define sz(a) (int(a.size()))
#define int ll

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2> istream& operator>>(istream &in, pair<T1, T2> &a) { in >> a.ff >> a.sc; return in; }
template<typename T1, typename T2> ostream& operator<<(ostream &out, const pair<T1, T2> &a) { out << a.ff << " " << a.sc; return out; }
template<typename T> istream& operator>>(istream &in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const set<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const multiset<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
mt19937_64 genom(mt_seed); ll randint(ll a, ll b) { uniform_int_distribution<ll> r(a, b); return r(genom); }
const int RANDOM = mt_seed; struct chash { int operator()(int x) const { return x ^ RANDOM; } };
struct pair_hash { ll operator()(pii x) const { return 1ll * x.ff * 31 + x.sc; } };

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    cin >> a;

    vector<int> c = a;
    sort(all(c));
    c.erase(unique(all(c)), c.end());

    if (sz(c) <= t) { cout << 1; return 0; }
    for (auto &el : a) el = lower_bound(all(c), el) - c.begin();

    vector<int> b = a;
    for (auto el : b) a.pb(el);

    vector<int> next_pos(n, -1);
    int j = 1, cur = 1;
    vector<int> cnt(n);
    cnt[a[0]] = 1;
    for (int i = 0; i < n; ++i) {
        while (cnt[a[j]] != 0 || cur < t) {
            if (cnt[a[j]] == 0) ++cur;
            ++cnt[a[j]];
            ++j;
        }
        next_pos[i] = j;
        --cnt[a[i]];
        if (cnt[a[i]] == 0) --cur;
    }

    // cout << next_pos << endl;

    vector<pii> ord;
    vector<bool> used(n);

    int v = 0;
    int ans = 0, res = 0;
    while (true) {
        // cout << "ORD: " << ord << endl;
        v %= n;
        if (used[v]) {
            int cnt_r = 0, sum = 0;
            int found = -1;
            for (int i = 0; i < sz(ord); ++i) {
                if (ord[i].ff == v) {
                    found = i;
                    break;
                }
            }
            sum = res - ord[found].sc;
            cnt_r = sz(ord) - found;

            // cout << "LOL: " << found << " " << sum << " " << cnt_r << endl;

            int remain = n * k - res;

            // cout << remain / sum * cnt_r << " | " << remain << endl;

            ans += remain / sum * cnt_r;
            remain %= sum;

            // cout << remain << endl;

            // cout << "ANS: " << ans << endl;

            if (remain == 0) break;

            ord.pb({v, res});
            for (int i = found + 1; i < sz(ord); ++i) {
                if (ord[i].sc - ord[found].sc >= remain) {
                    ans += i - found;
                    break;
                }
            }

            break;
        }
        ++ans;
        used[v] = 1;
        ord.pb({v, res});
        res += next_pos[v] - v;        
        if (res >= n * k)
            break;
        v = next_pos[v];
    }
    cout << ans;

    return 0;
}
