#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()

const ll INF = 1e18;

ll n, k, t;
vector<vector<ll>> dp, go;

inline ll sub(ll a, ll b) {
    ll res = a - b;
    if (res < 0) res += n;
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k >> t;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    ll r = -1;
    unordered_map<ll, bool> used;
    unordered_map<ll, ll> cnt;
    vector<ll> nxt(n, -1);
    ll diff = 0;
    for (ll l = 0; l < n; ++l) {
        ll tmp = 0;
        while (diff <= t) {
            if (tmp == n) {
                cout << 1 << "\n";
                return 0;
            }
            ++tmp;
            ++r;
            if (r == n) r = 0;
            ++cnt[a[r]];
            if (cnt[a[r]] == 1) {
                used[a[r]] = true;
                ++diff;
            }
        }
        nxt[l] = r;
        --cnt[a[l]];
        if (cnt[a[l]] == 0) {
            used[a[l]] = false;
            --diff;
        }
    }
    dp.resize(n, vector<ll>(60));
    go.resize(n, vector<ll>(60));
    for (ll i = 0; i < n; ++i) {
        dp[i][0] = sub(nxt[i], i);
        go[i][0] = nxt[i];
    }
    for (ll j = 1; j < 60; ++j) {
        for (ll i = 0; i < n; ++i) {
            go[i][j] = go[go[i][j - 1]][j - 1];
            if (dp[i][j - 1] == INF || dp[go[i][j - 1]][j - 1] == INF) {
                dp[i][j] = INF;
            } else {
                dp[i][j] = dp[i][j - 1] + dp[go[i][j - 1]][j - 1];
                if (dp[i][j] >= k * n) dp[i][j] = INF;
            }
        }
    }
    ll left = k * n;
    ll ans = 0;
    ll cur = 0;
    for (ll i = 59; i >= 0; --i) {
        if (dp[cur][i] <= left) {
            ans += (1ll << i);
            left -= dp[cur][i];
            cur = go[cur][i];
        }
    }
    if (left != 0) ++ans;
    cout << ans;
}
