#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (auto& x : a) cin >> x;
    vector<int> nxt(n);
    for (int i = 0; i < n; ++i) {
        set<int> q;
        int j;
        for (j = i; j < i + n; ++j) {
            q.insert(a[j % n]);
            if (q.size() > t) {
                break;
            }
        }
        nxt[i] = j;
    }
    int ans = 0;
    int v = 0, cnt = 0;
    while (cnt < n*k) {
        ++ans;
        if (nxt[v] == v + n) break;
        cnt += nxt[v] - v;
        v = nxt[v] % n;
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
