#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops", "inline", "fast-math")
#pragma GCC target("avx", "avx2", "popcnt", "sse3", "ssse3", "sse4.2", "fma", "tune=native")
using namespace std;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, k, t;
    cin >> n >> k >> t;
    vector<int> A(n), next(n, -1);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    if (set<int>(A.begin(), A.end()).size() <= t) {
        cout << 1;
        return 0;
    }

    for (int start = 0; start < n; start++) {
        set<int> used;
        for (int i = 0; i < n; i++) {
            if (!used.contains(A[(start + i) % n]) && used.size() + 1 > t) {
                next[start] = i;
                break;
            }
            used.insert(A[(start + i) % n]);
        }
    }

    int result = 0;
    for (int i = 0; i < n * k; i += next[i % n]) {
        result++;
    }

    cout << result;
    return 0;
}
/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7
*/