#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

int main() {
//    ios::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
    ll n, k, t; cin >> n >> k >> t;
    vector<ll> a(n);
    set<ll> s;
    for(int i = 0; i < n; i++) {
        cin >> a[i];
        s.insert(a[i]);
    }
    if (s.size() <= t) {
        cout << 1;
        return 0;
    }
    vector<pair<ll, ll>> dp(n, {-1, -1});
    ll pos = 0, col = 0, res = 0;
    while(col != n * k) {
        map<ll, ll> mapa;
        while(1) {
            if (col == n * k) break;
            if (mapa.size() == t && mapa[a[pos]] == 0) break;
            mapa[a[pos]]++;
            pos = (pos + 1) % n;
            col++;
        }
        res++;
        if (dp[pos] != pair<ll, ll>{-1, -1}) {
            if (col + dp[pos].first <= n * k) {
                col += dp[pos].first;
                res += dp[pos].second;
            }
        }
        dp[pos] = {col, res};
    }
    cout << res;
    return 0;
}
