#include <iostream>
#include <vector>
#include <algorithm>
// #define fastio


using namespace std;

#ifdef fastio
#define endl '\n'
#endif

#define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

int n, k, t;
vector<int> arr;

void solve2() {

    int unique_cnt = 1;
    for (int i = 1; i < arr.size(); ++i) {
        if (arr[i] != arr[i - 1]) ++unique_cnt;
    }
    int total_cnt = unique_cnt * k;
    if (arr[0] == arr[n - 1]) {
        total_cnt -= k - 1;
    }
    cout << total_cnt << endl;
}

signed main() {
    #ifdef fastio
    cin.tie(0);
    ios::sync_with_stdio(0);
    #endif
    #ifdef ROMALOCAL
        freopen("/mnt/commons/code/in.txt", "r", stdin);
    #endif

    cin >> n >> k >> t;

    arr.resize(n);
    for (int i = 0; i < n; ++i) cin >> arr[i];

    if (t == 1) {
        solve2();
    }

    return 0;
}