#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <queue>

using namespace std;

#define int long long

struct node {
	int li, ri, val;
};

vector<node> t(3000000);
int maxNode = 0;
int newNode() {
	t[maxNode] = {-1, -1, 0};
	return maxNode++;
}

void update(int now, int left, int right, int ind, int val) {
	if (left == right) {
		t[now].val = val;
		return;
	}
	if (t[now].li == -1) t[now].li = newNode();
	if (t[now].ri == -1) t[now].ri = newNode();
	int mid = (left + right) / 2;
	if (ind <= mid) {
		update(t[now].li, left, mid, ind, val);
	}
	else {
		update(t[now].ri, mid + 1, right, ind, val);
	}
	t[now].val = t[t[now].li].val + t[t[now].ri].val;
}
int n, k, m;

int sum(int now, int left, int right, int k2) {
	if (left == right) {
		return left;
	}
	if (t[now].li == -1) t[now].li = newNode();
	if (t[now].ri == -1) t[now].ri = newNode();
	int mid = (left + right) / 2;
	if (t[t[now].li].val >= k2) return sum(t[now].li, left, mid, k2);
	else return sum(t[now].ri, mid + 1, right, k2 - t[t[now].li].val);
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> k >> m;
	vector<int> l(n);
	set<int> s;
	for (int i = 0; i < n; i++) cin >> l[i];
	vector<int> l2(n * 2);
	for (int i = 0; i < n; i++) {
		l.push_back(l[i]);
		s.insert(l[i]);
	}
	if (s.size() <= m) {
		cout << 1;
		return 0;
	}
	map<int, int> d;
	vector<int> l3(n);
	newNode();
	for (int i = 0; i <= 2 * n; i++) {
		update(0, 0, n * 2, i, 0);
	}
	for (int i = n * 2 - 1; i >= 0; i--) {
		l2[d[l[i]]] = 0;
		update(0, 0, n * 2, d[l[i]], 0);
		l2[i] = 1;
		update(0, 0, n * 2, i, 1);
		if (i < n) {
			int u = sum(0, 0, n * 2, m + 1);
			l3[i] = u % n;
		}
		d[l[i]] = i;
	}
	int now = 0;
	int pers = 0;
	int ans = 0;
	map<int, int> d2;
	int timer = 0;
	int prev = 0;
	while (d2.count(now) == 0 and k > 0) {
		//cout << now << " ehehe\n";
		d2[now] = timer++;
		ans++;
		prev = now;
		now = l3[now];
		if (now <= prev) {
			pers++;
			k--;
		}
	}
	int cycleStart = d2[now];
	int cycleSize = timer - d2[now];
	//cout << cycleStart << " " << ans << " " << k << " hehe\n";
	ans += cycleSize * (k / pers);
	//cout << ans << " hehe\n";
	k %= pers;
	while (k > 0) {
		ans++;
		prev = now;
		now = l3[now];
		if (prev >= now) {
			k--;
		}
	}
	cout << ans;
	
	




}

/*

6 4 3
1 2 3 4 1 2


*/
