//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()

//#include <bits/extc++.h>
//using namespace __gnu_pbds;
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

mt19937_64 rd(chrono::steady_clock::now().time_since_epoch().count());

const int K = 30;

vector<int> cnt;
int currsz = 0;

void add(int type) {
    cnt[type]++;
    if (cnt[type] == 1) currsz++;
}

void del(int type) {
    cnt[type]--;
    if (cnt[type] == 0) currsz--;
}

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (auto &it: a) cin >> it;
    vector<int> b = a, dp(n);
    for (auto it: a) b.pb(it);
    sort(all(a));
    a.resize(unique(all(a)) - a.begin());
    for (auto &it: b) it = lower_bound(all(a), it) - a.begin();
    vector<vector<int>> binup(K, vector<int> (n)), cntup(K, vector<int> (n));
    cnt.assign(a.size(), 0);
    int r = 2 * n - 1;
    for (int i = 2 * n - 1; i >= 0; --i) {
        add(b[i]);
        while (currsz > t) del(b[r--]);
        if (i < n) {
            dp[i] = r + 1;
            if (dp[i] >= n) {
                binup[0][i] = (r + 1) % n;
                cntup[0][i] = 1;
            } else {
                binup[0][i] = binup[0][dp[i]];
                cntup[0][i] = 1 + cntup[0][dp[i]];
            }
        }
    }
    for (int i = 1; i < K; ++i) {
        for (int j = 0; j < n; ++j) {
            int where = binup[i - 1][j];
            binup[i][j] = binup[i - 1][where];
            cntup[i][j] = cntup[i - 1][j] + cntup[i - 1][where];
        }
    }
    if (a.size() <= t) {
        cout << "1\n";
        return;
    }
    int pos = 0, answer = 0, count = 0;
    for (int i = K - 1; i >= 0; --i) {
        if (count + (1 << i) <= k) {
            answer += cntup[i][pos];
            pos = binup[i][pos];
            count += (1 << i);
        }
    }
    cout << answer << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
//    cin >> T;
    while (T--)
        solve();
}
