#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

void solve() {
    int n, k, t;
    cin >> n >> k >> t;

    vector<ll> a(n);
    for (auto &x : a) cin >> x;

    if (t == 1) {
        vector<ll> b;
        for (int i = 0; i < n; i++) {
            if (b.empty() || b.back() != a[i]) {
                b.push_back(a[i]);
            }
        }
        ll ans = (ll)b.size() * k;
        if (b.back() == b[0]) ans -= k - 1;
        cout << ans << '\n';
        return;
    }

    a.resize(n*k);
    for (int i = n; i < n*k; i++) {
        a[i] = a[i % n];
    }


    set<ll> st;
    int ans = 0;
    for (int i = 0; i < n*k; i++) {
        st.insert(a[i]);
        if (st.size() > t) {
            ans++;
            st.clear();
            st.insert(a[i]);
        }
    }
    if (!st.empty()) ans++;

    cout << ans << '\n';
}

int st;
vector<ll> cicle, cw, color;
vector<vector<pair<int, int>>> g;

bool dfs(int v) {
    color[v] = 1;
    for (auto to : g[v]) {
        if (color[to.first] == 1) {
            st = to.first;
            cicle.push_back(to.second);
            return true;
        }
        if (color[to.first]) return false;
        if (dfs(to.first)) {
            if (st == -1) {
                cw.push_back(to.second);
            } else {
                cicle.push_back(to.second);
            }
            if (v == st) st = -1;
            return true;
        }
    }
    color[v] = 1;
    return false;
}

ll n, k, t;

bool OK(ll x) {
    if (x <= (int)cw.size()) {
        return cw[x-1] >= n*k;
    }
    x -= (int)cw.size();
    ll res = 0;
    if (!cw.empty()) res += cw.back();
    if (!cicle.empty()) {
        ll cnt = x / (ll)cicle.size();
        ll ost = x % (ll)cicle.size();
        if ((ld)cicle.back() > (ld)n / cnt * k) return 1;
        res += cicle.back() * cnt + (ost == 0 ? 0 : cicle[ost - 1]);
    }

    return res >= n*k;
}

void solve2() {
    cin >> n >> k >> t;

    vector<ll> a(n);

    set<ll> st;
    for (auto &x : a) {
        cin >> x;
        st.insert(x);
    }

    if (st.size() <= t) {
        cout << 1;
        return;
    }

    g.resize(n);
    color.resize(n);

    map<int, int> mp;
    st.clear();
    for (int l = 0, r = 0; l < n; l++) {
        if (l != 0) {
            mp[a[l-1]]--;
            if (!mp[a[l-1]]) {
                auto it  = st.lower_bound(a[l-1]);
                st.erase(it);
            }
        }
        while ((int)st.size() <= t) {
            mp[a[r % n]]++;
            st.insert(a[r % n]);
            r++;
        }
        r--;
        mp[a[r % n]]--;
        if (!mp[a[r % n]]) {
            auto it  = st.lower_bound(a[r % n]);
            st.erase(it);
        }
        g[l].push_back({r % n, r - l});
    }

    dfs(0);

    reverse(cicle.begin(), cicle.end());
    reverse(cw.begin(), cw.end());

    for (int i = 1; i < (int)cw.size(); i++) {
        cw[i] += cw[i-1];
    }
    for (int i = 1; i < (int)cicle.size(); i++) {
        cicle[i] += cicle[i-1];
    }

    ll L = 0, R = 1e16;
    while (R - L > 1) {
        ll m = (L + R) / 2;
        if (OK(m)) R = m;
        else L = m;
    }

    cout << R;
}

void fromFile() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0); cout.tie(0);

    //fromFile();

    int gg = 1;
//    cin >> gg;

    while (gg--) {
        solve2();
    }

    return 0;
}