#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<ll, ll>;
using ld = long double;

template<typename T, typename F>
istream &operator>>(istream &s, pair<T, F> &a) {
    s >> a.first >> a.second;
    return s;
}

template<typename T, typename F>
ostream &operator<<(ostream &s, pair<T, F> &a) {
    s << a.first << ' ' << a.second << '\n';
    return s;
}

template<typename T>
istream &operator>>(istream &s, vector<T> &a) {
    for (T &el: a) {
        s >> el;
    }
    return s;
}

template<typename T>
ostream &operator<<(ostream &s, vector<T> &a) {
    for (T el: a) {
        s << el << ' ';
    }
    s << '\n';
    return s;
}

ll dvup(ll a, ll b) {
    if (a % b == 0) {
        return a / b;
    }
    return a / b + 1;
}

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> arr(n);
    cin >> arr;
    set<ll> tmp(arr.begin(), arr.end());
    if (tmp.size() <= t) {
        cout << 1;
        return;
    }
    vector<ll> nxt(n);
    ll r = 0;
    map<ll, ll> cnt;
    cnt[arr[0]]++;

    for (ll l = 0; l < n; l++) {
        while (true) {
            if (cnt.size() > t) {
                break;
            }
            r = (r + 1) % n;
            cnt[arr[r]]++;
            if (cnt.size() > t) {
                break;
            }
        }
        nxt[l] = r;
        cnt[arr[l]]--;
        if (cnt[arr[l]] == 0) {
            cnt.erase(arr[l]);
        }
    }
    vector<bool> used(n);
    ll pos = 0;
    ll ans = 0;
    ll done_over = 0;
    vector<ll> st;
    bool been_cycle = false;
    while (true) {
        if (used[pos] && !been_cycle) {
            vector<ll> cycle = {pos};
            while (st.back() != pos) {
                cycle.push_back(st.back());
                st.pop_back();
            }
            //cout << cycle;
            ll num_times = (k - 1) - done_over;
            done_over += num_times;
            ans += (ll)(cycle.size()) * num_times;
            been_cycle = true;
        }
        st.push_back(pos);
        used[pos] = true;
        ans++;
        if (nxt[pos] < pos) {
            if (done_over == k - 1) {
                break;
            }
            done_over++;
        }
        pos = nxt[pos];
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
