#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long double ld;
typedef long long ll;

//#pragma GCC optnimize("Ofast");
//#pragma GCC target("avx2");

//#define int long long

vector<vector<int>> t;
vector<int> w;
int n, k, cnt;

void build(int v, int l, int r) {
    if (l == r) {
        t[v] = {w[l]};
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m + 1, r);
    t[v].resize(r - l + 1);
    merge(t[v * 2].begin(), t[v * 2].end(), t[v * 2 + 1].begin(), t[v * 2 + 1].end(), t[v].begin());
}

int find(int ind) {
    unordered_set<int> was;
    for (int i = 0; i < n; i++) {
        was.insert(w[i + ind]);
        if (was.size() == cnt + 1) {
            return i + ind;
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k >> cnt;
    unordered_set<int> s;
    w.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        s.insert(w[i]);
    }
    if (s.size() <= cnt) {
        cout << 1;
        return 0;
    }
    for (int i = 0; i < n; i++) {
        w.push_back(w[i]);
    }
    vector<int> q(2 * n);
    unordered_map<int, int> last;
    for (int i = 0; i < 2 * n; i++) {
        if (last.count(w[i]) == 0) {
            q[i] = -1;
        } else q[i] = last[w[i]];
        last[w[i]] = i;
    }
    n *= 2;
    t.resize(4 * n + 1);
    build(1, 0, n - 1);
    int ind = 0;
    vector<int> next(n / 2);
    for (int i = 0; i < n / 2; i++) {
        int ind1 = find(ind);
        next[ind] = ind1;
        ind = ind1;
        if (ind1 >= n / 2) ind -= n / 2;
    }
    ind = 0;
    vector<int> len(n / 2), par(n / 2);
    for (int i = n / 2 - 1; i >= 0; i--) {
        if (next[i] >= n / 2) len[i] = 1, par[i] = next[i];
        else len[i] = len[next[i]] + 1, par[i] = par[next[i]];
    }
    ll ans = 0;
    ind = 0;
    while (k > 0) {
        ans += len[ind];
        k--;
        ind = par[ind] - n / 2;
    }
    cout << ans;
}
