//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_map>
using namespace std;

using ll = long long;

#define int ll
#define vec vector
#define eb emplace_back
#define endl "\n"
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define all(x) (x.begin(), x.end())


const int N = 3e6 + 10;

int n, k, t;
int a[N], b[N];



void input() {
    cin >> n >> k >> t;
    for (int i = 0; i < n; ++i) cin >> a[i];
}



void superSlow() {
    for (int i = 0; i < n * k; ++i) b[i] = a[i % n];

    int ans = 1;
    set<int> se;
    for (int i = 0; i < n * k; ++i) {
        int x = b[i];
        se.insert(x);
        if (sz(se) == t + 1) {
            se.erase(x);
            ++ans;
            se = {x};
        }
    }

    cout << ans << endl;
    exit(0);
}


void t1() {
    int c = 1;
    for (int i = 1; i < n; ++i)
        if (a[i] != a[i - 1]) ++c;

    int ans = 1LL * c * k;
    if (a[0] == a[n - 1]) ans -= (k - 1);
    cout << ans << endl;
    exit(0);
}



int nxt[N];


void findJumpes() {
    map<int, int> cnt;
    int cntDiff = 0;

    auto add = [&](int x, int dx) {
        cnt[x] += dx;
        if (cnt[x] == 0 && dx == -1) {
            --cntDiff;
        }
        if (cnt[x] == 1 && dx == 1) ++cntDiff;
    };

    for (int i = n; i < 2 * n; ++i)
        a[i] = a[i - n];


    for (int l = 0, r = -1; l < 2 * n; ++l) {
        if (r < l) {
            r = l;
            add(a[l], 1);
        }

//        cout << "----------------------" << endl;
//
//
//
//        cout << cntDiff << " cnt : ";
//        for (auto& [x, c] : cnt) cout << x << " " << c << endl;
//        cout << endl;
        while (r + 1 < 2 * n && cntDiff <= t)
            ++r, add(a[r], 1);
        // cout << r << " " << cntDiff << endl;
        if (cntDiff > t) add(a[r], -1), --r;

//        cout << cntDiff << " cnt : ";
//        for (auto& [x, c] : cnt) cout << x << " " << c << endl;
//        cout << endl;

        nxt[l] = r;
        // cout << "l : " << l << " r : " << r << endl;

        add(a[l], -1);

//        cout << cntDiff << " cnt : ";
//        for (auto& [x, c] : cnt) cout << x << " " << c << endl;
//        cout << endl;
    }
}

void solve() {
    set<int> se;
    for (int i = 0; i < n; ++i)
        se.insert(a[i]);

    if (sz(se) <= t) {
        cout << 1 << endl;
        exit(0);
    }

    int ans = 0, len = 0, cur = 0;
    while (true) {
        int to = nxt[cur];
        len += to - cur + 1;
        ++ans;
        if (len >= n * k) break;
        cur = (to + 1) % n;
    }

    cout << ans << endl;
}


signed main() {
#ifdef RODYA
    freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\bigTest.in", "r", stdin);
#else
    cin.tie(0), ios_base::sync_with_stdio(false);
#endif



    input();
//    if (t == 1) t1();
//    if (n * k <= 1e6) superSlow();


    findJumpes();
    solve();



}
