#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_map>
using namespace std;

using ll = long long;

//#define int ll
#define vec vector
#define eb emplace_back
#define endl "\n"
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define all(x) (x.begin(), x.end())


const int N = 3e5 + 10, LOG = 40;
const ll INF = 1e16;

using pii = pair<int, ll>;



pii up[LOG][N];
int n, k, t;
int a[2 * N];
int nxt[N];



void input() {
    cin >> n >> k >> t;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
}

void findJumpes() {
    unordered_map<int, int> cnt;
    int cntDiff = 0;

    auto add = [&](int x, int dx) {
        cnt[x] += dx;
        if (cnt[x] == 0 && dx == -1) --cntDiff;
        if (cnt[x] == 1 && dx == 1) ++cntDiff;
    };
    for (int i = n; i < 2 * n; ++i)
        a[i] = a[i - n];

    for (int l = 0, r = -1; l < n; ++l) {
        if (r < l) {
            r = l;
            add(a[l], 1);
        }

        while (r + 1 < 2 * n && cntDiff <= t)
            ++r, add(a[r], 1);
        if (cntDiff > t) add(a[r], -1), --r;
        nxt[l] = r;
        add(a[l], -1);
    }
}


void buildBinUps() {
    for (int i = 0; i < n; ++i)
        up[0][i] = {(nxt[i] + 1) % n, nxt[i] - i + 1};

    for (int j = 1; j < LOG; ++j) {
        for (int i = 0; i < n; ++i) {
            auto [to1, len1] = up[j - 1][i];
            auto [to2, len2] = up[j - 1][to1];
            up[j][i] = {to2, min(len1 + len2, INF)};
        }
    }
}

void solve() {
    set<int> se;
    for (int i = 0; i < n; ++i)
        se.insert(a[i]);

    if (sz(se) <= t) {
        cout << 1 << endl;
        exit(0);
    }

    ll need = 1LL * n * k;
    int v = 0; ll sum = 0, ans = 0;
    for (int i = LOG - 1; i >= 0; --i) {
        auto [to, len] = up[i][v];
        if (sum + len >= need) continue;
        // cout << v << " to : " << to << " len : " << len << " i : " << i << endl;
        v = to;
        sum += len;
        ans += (1LL << i);
    }

    cout << ans + 1 << endl;
}




signed main() {
#ifdef RODYA
    freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\bigTest.in", "r", stdin);
#else
    cin.tie(0), ios_base::sync_with_stdio(false);
#endif




    input();
    findJumpes();
    buildBinUps();
    solve();



}
