#include <bits/extc++.h>
#include <memory>
#include <unordered_set>
#include <vector>

using namespace std;
namespace pbds {
    using namespace __gnu_pbds;
}

using ll = long long;
using fl = long double;
using ull = unsigned long long;
using li = __int128;

template <typename K, typename V>
using otree = pbds::tree<K, V, less<K>, pbds::splay_tree_tag, pbds::tree_order_statistics_node_update>;

ll mod(ll x, ll m) {
    return ((x % m) + m) % m;
}

ll k, n, t;
vector<ll> a;

struct fgraph {
    vector<ll> next, len;

    fgraph(): next(n, -1), len(n, 0) {}
};

fgraph precalc_dumb() {
    fgraph f;
    for (ll i = 0; i < n; i++) {
        unordered_set<ll> st;
        ll j = i, cnt = 0;
        while (st.size() <= t) {
            st.insert(a[j]);
            j = mod(j + 1, n), cnt++;
        }
        f.next[i] = mod(j-1,n);
        f.len[i] = cnt - 1;
    }
    return f;
}

void solve_1() {
    
}

void solve() {
    cin >> n >> k >> t;

    a.resize(n);
    for (ll &i: a) {
        cin >> i;
    }

    auto f = precalc_dumb();

    ll cnt = 0, i = 0, ans = 0;
    while (cnt < n * k) {
        cnt += f.len[i];
        i = f.next[i];
        ans++;
    }

    cout << ans << endl;    
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    // ll t; cin >> t; while (t--)
    solve();
}