#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")
//#pragma GCC optimize("unroll-loops")

using namespace std;

using ll = long long;
const char endc = '\n';

using namespace std;

vector<int> uniqued;

int get_uni(vector<int> elements) {
    uniqued = elements;
    sort(uniqued.begin(), uniqued.end());
    uniqued.resize(unique(uniqued.begin(), uniqued.end()) - uniqued.begin());
    return int(uniqued.size());
}

vector<pair<int, ll>> g;
deque<int> inCycle;
vector<bool> used;
ll n, k, t, r;

void dfs(int v = 0) {
    used[v] = 1;
    inCycle.push_back(v);
    if (used[g[v].first]) {
        deque<int> prefix;
        while (inCycle.front() != g[v].first) {
            prefix.push_back(inCycle.front());
            inCycle.pop_front();
        }
        ll cycleCost = 0;
        int cycleStart = g[v].first, cycLen = int(inCycle.size()), now = cycleStart;
        for (int i = 0; i < cycLen; ++i) {
            cycleCost += g[now].second;
            now = g[now].first;
        }
        ll globalCost = 0, globalAnswer = 0;
        for (int i = 0; i < prefix.size(); ++i) {
            if (globalCost + g[prefix[i]].second >= k*n) {
                cout << i+1 << endc;
                exit(0);
            } else {
                globalCost += g[prefix[i]].second;
                globalAnswer++;
            }
        }
        ll ost = n * k - globalCost;
        ll fullCycCount = ost / cycleCost;
        globalCost += cycleCost * fullCycCount;
        globalAnswer += cycLen * fullCycCount;
        while (globalCost < n*k) {
            globalCost += g[now].second;
            now = g[now].first;
            globalAnswer++;
        }
        cout << globalAnswer << endc;
    } else {
        dfs(g[v].first);
    }
}

inline void work() {
    cin >> n >> k >> t;
    vector<int> gifts(n);
    for (int i = 0; i < gifts.size(); ++i) cin >> gifts[i];
    r = get_uni(gifts);
    if (t >= r) {
        cout << 1 << endc;
    } else {
        for (auto& e : gifts)
            e = int(lower_bound(uniqued.begin(), uniqued.end(), e) - uniqued.begin());
        vector<int> to(n, -1);
        int pointer = 0;
        map<int, int> already;
        for (int i = 0; i < n; ++i) {
            if (i > 0) {
                already[gifts[i-1]]--;
                if (already[gifts[i-1]] == 0) already.erase(gifts[i-1]);
            }
            while (already.size() < t) {
                already[gifts[pointer % n]]++;
                pointer++;
            }
            while (already.size() == t) {
                if (already.count(gifts[pointer % n])) {
                    already[gifts[pointer % n]]++;
                    pointer++;
                } else {
                    break;
                }
            }
            to[i] = pointer - i;
        }
        used.resize(n, 0);
        g.resize(n);
        for (int i = 0; i < n; ++i) g[i] = {(i + to[i]) % n, to[i]};
        dfs();
        /*ll giftsUsed = 0;
        int posNow = 0, answer = 0;

        while (giftsUsed < n*k) {
            giftsUsed += to[posNow];
            posNow += to[posNow];
            posNow %= n;
            answer++;
        }
        cout << answer << endc;*/
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    srand(int(time(nullptr)));
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    while (t-- > 0) work();
}


/*vector<int> goods;
for (int i = 0; i < n; ++i) {
    if (goods.empty() || goods.back() != gifts[i]) goods.push_back(gifts[i]);
}
m = int(goods.size());*/