#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int DEG = 30;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k, t;
    cin >> n >> k >> t;
    vector <int> a(n);
    int up[n][DEG];
    ll sum[n][DEG];
    int l = 0;
    int col = 0;
    map <int, int> cnt;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (cnt[a[i]] == 0) {
            col++;
        }
        cnt[a[i]]++;
        while (col > t) {
            up[l][0] = i;
            cnt[a[l]]--;
            if (cnt[a[l]] == 0) {
                col--;
            }
            l++;
        }
    }
    for (int i = 0; i < n; i++) {
        if (cnt[a[i]] == 0) {
            col++;
        }
        cnt[a[i]]++;
        while (col > t && l < n) {
            up[l][0] = i;
            cnt[a[l]]--;
            if (cnt[a[l]] == 0) {
                col--;
            }
            l++;
        }
        if (l == n) {
            break;
        }
    }
    if (up[0][0] == 0) {
        cout << 1 << "\n";
        return 0;
    }
    for (int i = 0; i < n; i++) {
        if (up[i][0] < i) {
            sum[i][0] = 1;
        } else {
            sum[i][0] = 0;
        }
    }

    for (int j = 1; j < DEG; j++) {
        for (int i = 0; i < n; i++) {
            up[i][j] = up[up[i][j - 1]][j - 1];
            sum[i][j] = sum[up[i][j - 1]][j - 1] + sum[i][j - 1];
        }
    }
    int s = 0;
    ll ans = 0;
    for (int i = DEG - 1; i >= 0; i--) {
        if (sum[s][i] < k) {
            k -= sum[s][i];
            ans += (1 << i);
            s = up[s][i];
        }
    }
    cout << ans + 1;
}
