#include <bits/stdc++.h>

using ll = long long int;
using ull = unsigned long long int;
using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void solve()
{
    int n, k, t;
    cin >> n >> k >> t;

    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    unordered_map<int, int> cnt;
    int r;
    int uni = 0;
    for (r = 0; r < n && uni <= t; r++)
    {
        ++cnt[a[r]];
        if (cnt[a[r]] == 1)
            ++uni;
    }
    --r;
    if (uni <= t)
        return void(cout << 1 << '\n');
    --cnt[a[r]];
    --uni;

    vector<int> x(a);
    x.insert(x.end(), all(a));
    vector<int> max_move(n);
    max_move[0] = r;
    for (int i = 1; i < n; i++)
    {
        --cnt[x[i - 1]];
        if (cnt[x[i - 1]] == 0)
            --uni; 
        while (uni <= t)
        {
            ++cnt[x[r]];
            if (cnt[x[r]] == 1)
                ++uni;
            ++r;
        }
        --r;
        --cnt[x[r]];
        --uni;
        max_move[i] = r - i;
    }

    vector<bool> used(n);
    int idx = 0;
    while (!used[idx])
    {
        used[idx] = true;
        idx += max_move[idx];
        idx %= n;
    }

    ll sum = 1ll * k * n;
    ll ans = 0;
    for (int i = 0; i != idx; i = (i + max_move[i]) % n)
    {
        sum -= max_move[i];
        ++ans;
        if (sum <= 0)
            break;
    }
    if (sum <= 0)
        return void(cout << ans << '\n');

    vector<ll> pref = {0};
    int pr;
    for (pr = idx; (pr + max_move[pr]) % n != idx; pr = (pr + max_move[pr]) % n)
        pref.push_back(pref.back() + max_move[pr]);
    pref.push_back(pref.back() + max_move[pr]);
    int len = pref.size() - 1;
    ans += (sum / pref.back()) * len;
    sum %= pref.back();
    for (int i = 0; i <= n; i++)
    {
        if (sum <= pref[i])
        {
            ans += i;
            break;
        }
    }
    cout << ans << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("D:/olymp/Day 1/in.txt", "r", stdin);
    freopen("D:/olymp/Day 1/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif
    while (t--)
        solve();
    return 0;
}