#include <iostream>
#include <set>
#include <vector>

using namespace std;
using ll = long long;

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> src(n);
    for (auto &item: src) {
        cin >> item;
    }

    ll res = 1;
    set<ll> got;
    for (int I = 0; I < n * k; ++I) {
        if (ll(got.size()) == t && got.find(src[I % n]) == got.end()) {
            got.clear();
            ++res;
        }

        got.insert(src[I % n]);
    }

    cout << res << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
