#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using str = string;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n, k, t;
	cin >> n >> k >> t;
	if (t > n) {
		t = n;
	}
	vector <ll> a(n * k);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 1; i < k; i++) {
		for (int j = 0; j < n; j++) {
			a[i * n + j] = a[j];
		}
	}
	ll ans = 0;
	set <ll> st;
	for (int i = 0; i < n * k; i++) {
		if (st.count(a[i]) == 0) {
			if (st.size() == t) {
				ans++;
				st.clear();
			}
			st.insert(a[i]);
		}
	}
	cout << ans + 1;
}