#include <iostream>
#include <vector>

#pragma target('avx2')
#pragma target('O3')

#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

#define int long long

signed main() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> A(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    vector<int> B = A;
    for (int e: A) {
        B.push_back(e);
    }
    vector<int> st(n, -1);
    int l = 0, r = 0;
    map<int, int> count;
    while (r != 2 * n) {
        if (count.find(B[r]) == count.end() and count.size() == t) {
            count[A[l]]--;
            if (count[A[l]] == 0) {
                count.erase(A[l]);
            }
            l++;
            if (l == n)
                break;
        } else {
            count[B[r]]++;
            r++;
        }
        st[l] = r % n;
    }
    if (l == 0) {
        cout << 1;
        exit(0);
    } else {
        vector<pair<int, int>> index(n, {-1, -1});
        int ind = 0, ans = 0, cnt = 0;
        while(index[ind].first == -1 and cnt < k){
            index[ind].first = ans;
            index[ind].second = cnt;
            ans++;
            if (st[ind] < ind){
                cnt++;
            }
            ind = st[ind];
        }
        if (k == cnt) {
            cout << ans;
            exit(0);
        }
        ans += ((k - cnt) * n - ind - 1) / ((cnt - index[ind].second) * n) * (ans - index[ind].first);
        while(st[ind] > ind){
            ind = st[ind];
            ans++;
        }
        cout << ans + 1;
    }
}
