#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <complex>
#include <assert.h>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <immintrin.h>
using namespace std;

///*
#define int long long
#define INTLONGLONG
//*/

#define pi pair<int, int>
#define vi vector<int>
#define vvi vector<vector<int>>
#define vpi vector<pair<int, int>>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ff first
#define ss second

const int md = 998244353;
const int INF = 1e18;

#ifndef INTLONGLONG
#include <chrono>
mt19937 mt(chrono::steady_clock::now().time_since_epoch().count());
#endif
#ifdef INTLONGLONG
mt19937 mt (1);
#endif
int rnd(int mx) {
	int a = mt();
	return abs(a) % mx;
}

int cur = 0;
int n, k, t;
struct gay {
	int val;
	int id;
	gay(int id, int val) : id(id), val(val) {}
};
bool operator<(gay a, gay b) {
	int x = a.val;
	int y = b.val;
	if (x < cur) x += n;
	if (y < cur) y += n;
	return x < y;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> k >> t;
	vi vec(n);
	set<int> tset;
	map<int, vi> mp;
	vi curid(n);
	for (int i = 0; i < n; i++) {
		cin >> vec[i];
		curid[i] = mp[vec[i]].size();
		mp[vec[i]].push_back(i);
		tset.insert(vec[i]); 
	}
	if (tset.size() <= t) {
		cout << 1 << endl;
		return 0;
	}
	map<int, int> nextid;
	vi go(n);
	int fst = 0;

	
	for (int i = 0; i < n; i++) {
		cur = (i - 1 + n) % n;
		set<int> cset;
		while (cset.size() <= t) {
			if (cset.count(vec[(cur + 1) % n])) {
				cur++;
				nextid[vec[(cur + 1) % n]]++;
				nextid[vec[(cur + 1) % n]] %= mp[vec[(cur + 1) % n]].size();
				continue;
			}
			if (cset.size() == t) {
				break;
			}
			cset.insert(vec[(cur + 1) % n]);
			nextid[vec[(cur + 1) % n]]++;
			nextid[vec[(cur + 1) % n]] %= mp[vec[(cur + 1) % n]].size();
			cur++;
			if (cur == n) cur = 0;
		}

		go[i] = (cur + 1) % n;
	}

	int cans = 1;
	int ans = 0;
	vi h(n);
	vi ht(n);
	vi used(n);
	int s = 0;
	bool cycle = 0;
	int cstart = -1;
	int cend = -1;
	while (1) {
		used[s] = 1;
		ans++;
		if (cans == k && go[s] <= s) break;
		if (used[go[s]]) {
			cycle = 1;
			cstart = go[s];
			cend = s;
			cans++;
			break;
		}
		h[go[s]] = h[s] + 1;
		ht[go[s]] = ht[s];
		if (go[s] <= s) {
			ht[go[s]]++;
			cans++;
		}
		s = go[s];
	}
	if (cycle) {
		int dx = h[cend] - h[cstart] + 1;
		int dy = ht[cend] - ht[cstart];
		if (cstart <= cend) dy++;
		ans -= dx;
		cans -= dy;
		int y = k - cans;
		int x = y / dy;
		ans += dx * x;
		cans += dy * x;
		used.assign(n, 0);
		s = cstart;
		while (1) {
			used[s] = 1;
			ans++;
			if (cans == k && go[s] <= s) break;
			if (used[go[s]]) {
				assert(false);
			}
			h[go[s]] = h[s] + 1;
			ht[go[s]] = ht[s];
			if (go[s] <= s) {
				ht[go[s]]++;
				cans++;
			}
			s = go[s];
		}
	}
	cout << ans << endl;
	return 0;
};