#ifdef LOCAL
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#define _GLIBCXX_DEBUG
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<array>
#include<algorithm>
#include<set>
#include<map>

using namespace std;

typedef long long ll;

struct Edge {
	ll v,u,w;
};

const ll INF=1e17+9;

signed main() {
	ll n,k,t;
	cin>>n>>k>>t;
	vector<ll> a(n);
	map<ll,ll> av;
	for(auto &i:a) {
		cin>>i;
		if(av.find(i)==av.end()) {
			av[i]=av.size();
		}
		i=av[i];
	}
	for(auto i:a) {debug(i)}
	vector<ll> cnta(n);
	vector<ll> al(n*2);
	vector<ll> step(n);
	for(int i=0;i<n*2;i++) {al[i]=a[i%n];}
	ll j=0,cnt=0;
	for(int i=0;i<n;i++) {
		while(j<2*n && cnt<t) {
			if(cnta[al[j]]++==0) {cnt++;}
			j++;
		}
		if(cnta[a[i]]--==1) {cnt--;}
		if(j==2*n) {step[i]=INF;}
		else {step[i]=j-i;}
		debug(step[i])
	}
	ll ans=0;
	for(ll pos=0;pos<k*n;pos+=step[pos%n]) {ans++;}
	cout<<ans<<'\n';
	return 0;
}








