    #include "bits/stdc++.h"
    
    #define int long long
    #define ull unsigned long long
    #define ld long doublt
    #define sz(x) (int)x.size()
    #define all(x) x.begin(), x.end()
    #define rall(x) x.rbegin(), x.rend()
    
    using namespace std;
    
    void solve() {
        int n, k, t;
        cin >> n >> k >> t;
        vector<int> a(n);
        set<int> b;
        for (int &i : a) {
            cin >> i;
            b.insert(i);
        }
        if (t >= sz(b)) {
            cout << 1;
            return;
        }
        vector<int> cnt(n);
        vector<bool> used(n, false);
        for (int i = 0; i < n; ++i) {
            set<int> now;
            for (int j = 0; j < n; ++j) {
                now.insert(a[(i + j) % n]);
                if (sz(now) > t) {
                    cnt[i] = j;
                    break;
                }
            }
        }
        int index = 0;
        vector<int> cur;
        while (!used[index]) {
            used[index] = true;
            cur.emplace_back(index);
            index = (index + cnt[index]) % n;
        }
        int need = n * k, ans = 0, i = 0;
        for (; i < sz(cur) && need > 0; ++i) {
            if (cur[i] == (cur.back() + cnt[cur.back()]) % n) {
                break;
            }
            need -= cnt[cur[i]];
            ++ans;
        }
        if (need <= 0) {
            cout << ans;
            return;
        }
        int sum = 0;
        for (int j = i; j < sz(cur); ++j) {
            sum += cnt[cur[j]];
        }
        ans += need / sum * (sz(cur) - i);
        need %= sum;
        for (int j = i; j < sz(cur) && need > 0; ++j) {
            need -= cnt[cur[j]];
            ++ans;
        }
        cout << ans;
    }
    
    signed main() {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
        int tt = 1;
        //cin >> tt;
        while (tt--) {
            solve();
        }
    }