#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve()
{
    ll n, k, t;
    cin >> n >> k >> t;
    vector <ll> a(n);
    for(ll i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    vector <ll> _a(n);
    for(ll i = 0; i < n; i++)
    {
        _a[i] = a[i];
    }
    sort(_a.begin(), _a.end());
    vector <ll> num;
    num.push_back(_a[0]);
    for(ll i = 1; i < n; i++)
    {
        if(_a[i] != _a[i - 1])
        {
            num.push_back(_a[i]);
        }
    }
    if(t >= num.size())
    {
        cout << 1;
        return;
    }
    ll cnt_seg = 1;
    for(ll i = 0; i < n; i++)
    {
        a[i] = (lower_bound(num.begin(), num.end(), a[i]) - num.begin());
        if(i > 0 && a[i] != a[i - 1])
        {
            cnt_seg++;
        }
    }
    if(t == 1)
    {
        if(a[0] == a[n - 1])
        {
            cout << (cnt_seg - 1) * k + 1;
        }
        else
        {
            cout << cnt_seg * k;
        }
        return;
    }
    vector <ll> prev(n, -1);
    vector <ll> last_seen(num.size(), -1);
    for(ll i = 0; i < n; i++)
    {
        if(last_seen[a[i]] == -1)
        {
            prev[i] = -1;
        }
        else
        {
            prev[i] = last_seen[a[i]];
        }
        last_seen[a[i]] = i;
    }
    vector <ll> next(n, -1);
    for(ll i = 0; i < num.size(); i++)
    {
        last_seen[i] = -1;
    }
    for(ll i = n - 1; i >= 0; i--)
    {
        if(last_seen[a[i]] == -1)
        {
            next[i] = -1;
        }
        else
        {
            next[i] = last_seen[a[i]];
        }
        last_seen[a[i]] = i;
    }
    vector <ll> frst(num.size());
    for(ll i = 0; i < n; i++)
    {
        if(prev[i] == -1)
        {
            frst[a[i]] = i;
        }
    }
    for(ll i = 0; i < n; i++)
    {
        if(next[i] == -1)
        {
            next[i] = frst[a[i]] + n;
            prev[frst[a[i]]] = i;
        }
    }
    set <ll> st;
    for(ll i = 0; i < num.size(); i++)
    {
        st.insert(frst[i]);
    }
    vector <ll> jump(n);
    for(ll i = 0; i < t; i++)
    {
        st.erase(*st.begin());
    }
    jump[0] = (*st.begin());
    for(ll i = 1; i < n; i++)
    {
        if(a[i] == a[i - 1])
        {
            jump[i] = jump[i - 1];
        }
        else if(i - 1 < next[i - 1] && next[i - 1] <= jump[i - 1])
        {
            jump[i] = jump[i - 1];
        }
        else
        {
            st.insert(next[i - 1]);
            st.erase(*st.begin());
            jump[i] = *st.begin();
        }
    }
    for(ll i = 0; i < n; i++)
    {
        jump[i] %= n;
    }
    vector <ll> ult_jump(n);
    vector <ll> cnt(n);
    for(ll i = n - 1; i >= 0; i--)
    {
        if(jump[i] < i)
        {
            ult_jump[i] = jump[i];
            cnt[i] = 1;
        }
        else
        {
            ult_jump[i] = ult_jump[jump[i]];
            cnt[i] = cnt[jump[i]] + 1;
        }
    }
    ll ans = 0, cur_pos = 0;
    for(ll i = 0; i < k; i++)
    {
        ans += cnt[cur_pos];
        cur_pos = ult_jump[cur_pos];
    }
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    ll t = 1;
    //cin >> t;
    for(ll i = 0; i < t; i++)
    {
        solve();
    }
    return 0;
}
