#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <cmath>
#include <unordered_map>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <iomanip>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using vi = vector <int>;
using vll = vector <ll>;
using vpii = vector <pii>;
using vvi = vector <vi>;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) (int)_x.size()
#define ff first
#define ss second
#define pb push_back
#define display(_x) for (auto val : _x) cout << val << ' '; cout << '\n';
#define cin_arr(_x) for (auto &val : _x) cin >> val;
#define fast_input ios_base::sync_with_stdio(0); cin.tie(0);

const int INF = 1e9;
const ll INFLL = 1e18;
const int MOD = 1e9 + 7;
const double EPS = 1e-9;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int MAXN = 3e5;
int n, k, t;
int a[MAXN * 2];
int s[MAXN * 2];
int ans = 0;
int cnt[MAXN];

bool check() {
    unordered_set<int> q;
    for (int i = 0; i < n; i++)
        q.insert(a[i]);
    if (sz(q) <= t)
        return true;
    else
        return false;
}
void compress() {
    vi temp(a, a + n);
    sort(all(temp));
    temp.erase(unique(all(temp)), temp.end());
    for (int i = 0; i < n; i++)
        a[i] = int(lower_bound(all(temp), a[i]) - temp.begin());
}
void make_longer() {
    for (int i = 0; i < n; i++)
        a[i + n] = a[i];
}

void add(int x) {
    if (cnt[x] == 0)
        ans++;
    cnt[x]++;
}
void rem(int x) {
    if (cnt[x] == 1)
        ans--;
    cnt[x]--;
}

void solve() {
    cin >> n >> k >> t;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    if (check()) {
        cout << 1 << '\n';
        return;
    }

    compress();
    make_longer();

    for (int l = 0, r = 0; l < n; l++) {
        while (ans <= t && r < 2 * n)
            add(a[r++]);
        if (r < 2 * n)
            rem(a[--r]);
        s[l] = r - l;
        rem(a[l]);
    }

    ll res = 0;
    ll cur_pos = 0;
    while (cur_pos < 1LL * n * k) {
        res++;
        cur_pos += s[cur_pos % n];
        if (cur_pos > 1LL * n * k)
            break;
    }
    cout << res << '\n';
}

int main() {
    fast_input;
    cout << setprecision(7) << fixed;
    solve();
}