#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
#define ll long long
#define nl '\n'
#define emp emplace_back
#define all(x) x.begin(), x.end()

using namespace std;
//using namespace __gnu_pbds;
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto x : a) {
        out << x << ' ';
    }
    out << '\n';
    return out;
}

mt19937 rnd(time(nullptr));

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> a(n);
    cin >> a;
    vector<ll> p;
    set<ll> st;
    for (auto x : a) {
        st.insert(x);
    }
    if ((ll)st.size() <= t) {
        cout << 1;
        return;
    }
    for (ll i = 0; i < n; ) {
        ll j = i + 1;
        while (j < n && a[j] == a[i]) {
            ++j;
        }
        p.emp(a[i]);
        i = j;
    }
    n = (ll)p.size();
    for (ll i = 0; i < n; ++i) {
        p.emp(p[i]);
    }
    ll u = 1;
    map<ll, ll> mp;
    for (ll i = 0; i < 2 * n; ++i) {
        if (mp[p[i]] == 0) {
            mp[p[i]] = u++;
        }
        p[i] = mp[p[i]];
    }
    vector<ll> nxt(n);
    for (ll i = 0; i < n; ++i) {
        ll j = i;
        vector<ll> h(u);
        ll kol = 0;
        while (j < 2 * n) {
            ++h[p[j]];
            if (h[p[j]] == 1) {
                ++kol;
            }
            ++j;
            if (kol > t) {
                --j;
                break;
            }
        }
        nxt[i] = j - i;
    }
    ll sum = 0;
    ll i = 0;
    ll cnt = 0;
    while (sum < n * k) {
        sum += nxt[i];
        ++cnt;
        i += nxt[i];
        i %= n;
    }
    cout << cnt;
}

int main() {
#ifdef CLOCK
    ll time1 = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    cin >> tpk;
#endif

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef CLOCK
    cout << clock() - time1 << " ms";
#endif
}
