#pragma target("Ofast, unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

using namespace std;

#define debug(x) cout << #x << " = " << x << endl;

const int N = 3e5 + 228, MUL = 50;

int A[N], B[MUL * N], C[MUL * N], RES_R[MUL * N], RES_L[MUL * N], WAS[N];

void solve() {
    fill(WAS, WAS + N, -1);
    int n, k, t;
    cin >> n >> k >> t;
    if (true) {
        set<int> ss;
        for (int i = 0; i < n; ++i) {
            cin >> A[i];
            ss.insert(A[i]);
        }
        if (ss.size() <= t) {
            cout << 1;
            return;
        }
        for (int i = 0; i < MUL * n; ++i) {
            B[i] = A[i % n];
        }
        for (int i = 0; i < MUL * n; ++i) {
            C[i] = A[i % n];
        }
        int l_ans = 0;
        for (int i = MUL * n - 1; i >= 0; --i) {
            set<int> st;
            st.insert(B[i]);
            int at = i;
            while (at - 1 >= 0 && !(st.size() == t && st.find(B[at - 1]) == st.end())) {
                st.insert(B[at - 1]);
                at--;
            }
            l_ans++;
            for (int j = at; j <= i; ++j) {
                RES_R[j] = l_ans;
            }
            i = at;
        }
        l_ans = 0;
        for (int i = 0; i < MUL * n; ++i) {
            set<int> st;
            st.insert(B[i]);
            int at = i;
            while (at + 1 < MUL * n && !(st.size() == t && st.find(B[at + 1]) == st.end())) {
                st.insert(B[at + 1]);
                at++;
            }
            l_ans++;
            for (int j = i; j <= at; ++j) {
                RES_L[j] = l_ans;
            }
            i = at;
        }
        int ans = 0;
        for (int i = 0; i < min(MUL, k) * n; ++i) {
            set<int> st;
            st.insert(C[i]);
            int at = i;
            while (at + 1 < min(MUL, k) * n && !(st.size() == t && st.find(C[at + 1]) == st.end())) {
                st.insert(C[at + 1]);
                at++;
            }
            i = at;
            ans++;
            if (i == n - 1) {
                cout << k * ans;
                return;
            }
            if (WAS[i % n] == -1) {
                WAS[i % n] = i;
            } else {
                int cycle_len = i - WAS[i % n];
                int left_l = WAS[i % n] + 1;
                int left_r = (n * k - i - 1) % cycle_len;
                ans = (ans - RES_L[WAS[i % n]]) * ((n * k - left_l - left_r) / cycle_len);
                if (left_l != 0) {
                    ans += RES_L[left_l - 1];
                }
                ans += RES_R[MUL * n - left_r];
                cout << ans;
                return;
            }
        }
        cout << ans;
    } else {
        for (int i = 0; i < n; ++i) {
            cin >> A[i];
        }
        vector<int> a;
        for (int i = 0; i < k; ++i) {
            for (int j = 0; j < n; ++j) {
                a.push_back(A[j]);
            }
        }
        int ans = 0;
        for (int i = 0; i < a.size(); ++i) {
            set<int> st;
            st.insert(a[i]);
            int r = i;
            while (r + 1 < a.size() && !(st.size() == t && st.find(a[r + 1]) == st.end())) {
                st.insert(a[r + 1]);
                r++;
            }
            ans++;
            i = r;
        }
        cout << ans;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
