#pragma target("Ofast, unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

using namespace std;

#define debug(x) cout << #x << " = " << x << endl;

const int N = 3e5 + 228;

int A[N];
int WAS[N];

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    for (int i = 0; i < n; ++i) {
        WAS[i] = -1;
    }
    if (k < n) {
        for (int i = 0; i < n; ++i) {
            cin >> A[i];
        }
        vector<int> a;
        for (int i = 0; i < k; ++i) {
            for (int j = 0; j < n; ++j) {
                a.push_back(A[j]);
            }
        }
        int ans = 0;
        for (int i = 0; i < a.size(); ++i) {
            set<int> st;
            st.insert(a[i]);
            int r = i;
            while (r + 1 < a.size() && !(st.size() == t && st.find(a[r + 1]) == st.end())) {
                st.insert(a[r + 1]);
                r++;
            }
            ans++;
            i = r;
        }
        cout << ans;
        return;
    }
    vector<int> a(n);
    for (int &el : a) cin >> el;
    set<int> sexy;
    for (int i = 0; i < n; ++i) {
        sexy.insert(a[i]);
    }
    if (sexy.size() <= t) {
        cout << 1;
        return;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            a.push_back(a[j]);
        }
    }
    vector<int> cnt_l(n * n), cnt_r(n * n);
    int ans_l = 0;
    for (int i = 0; i < n * n; ++i) {
        set<int> setik;
        setik.insert(a[i]);
        int at = i;
        while (at + 1 < n * n && !(setik.size() == t && setik.find(a[at + 1]) == setik.end())) {
            at++;
            setik.insert(a[at]);
        }
        ans_l++;
        for (int j = i; j <= at; ++j) {
            cnt_l[j] = ans_l;
        }
        i = at;
    }
    int ans_r = 0;
    for (int i = n * n - 1; i >= 0; --i) {
        set<int> setik;
        setik.insert(a[i]);
        int at = i;
        while (at - 1 >= 0 && !(setik.size() == t && setik.find(a[at - 1]) == setik.end())) {
            at--;
            setik.insert(a[at]);
        }
        ans_r++;
        for (int q = at; q <= i; ++q) {
            cnt_r[q] = ans_r;
        }
        i = at;
    }
    int ans = 0;
    for (int i = 0; i < n * n; ++i) {
        set<int> setik;
        setik.insert(a[i]);
        int at = i;
        while (at + 1 < n * n && !(setik.size() == t && setik.find(a[at + 1]) == setik.end())) {
            at++;
            setik.insert(a[at]);
        }
        ans++;
        i = at;
        if (i == n - 1) {
            cout << ans * k;
            return;
        }
        if (WAS[i % n] == -1) {
            WAS[i % n] = i;
        } else {
            int cycle_len = i - WAS[i % n];
            int left_l = WAS[i % n] + 1;
            int left_r = (n * k - 1 - i) % cycle_len;
            int ANS = (cnt_l[i] - cnt_l[WAS[i % n]]) * ((n * k - left_l - left_r) / cycle_len);
            ANS += cnt_l[left_l - 1];
            ANS += cnt_r[n * n - left_r];
            cout << ANS;
            return;
        }
        i = at;
    }
    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
