#include <bits/stdc++.h>

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n, k, t;
    std::cin >> n >> k >> t;
    std::vector<int> input(n);
    for (auto& i : input) {
        std::cin >> i;
    }

    if (std::set<int>(input.begin(), input.end()).size() <= t) {
        std::cout << 1 << std::endl;
        return 0;
    }

    std::map<int, int> map;
    std::vector<int> next(n);
    for (int i = 0, j = 0; i < n; i++) {
        while (map.size() <= t) {
            map[input[j++ % n]]++;
        }
        next[i] = j - 1;
        assert(j < 2 * n);
        map[input[i]]--;
        if (map[input[i]] == 0) {
            map.erase(input[i]);
        }
    }

    constexpr int LG = 60;
    std::array<std::vector<std::pair<int, int>>, LG> bj;
    bj.fill(std::vector<std::pair<int, int>>(n, std::pair{-1, -1}));

    for (int i = 0; i < n; i++) {
        bj[0][i] = {next[i] % n, next[i] >= n};
    }
    for (int k = 0; k < LG - 1; k++) {
        for (int i = 0; i < n; i++) {
            auto [t, c] = bj[k][i];
            auto [t2, c2] = bj[k][t];
            bj[k + 1][i] = {t2, std::min<int>(1.01e9, c + c2)};
        }
    }

    int64_t cnt = 0;
    int cur = 0;
    for (int lg = LG - 1; lg >= 0; lg--) {
        auto [to, c] = bj[lg][cur];
        if (c < k) {
            k -= c;
            cur = to;
            cnt += 1LL << lg;
        }
    }
    auto [to, c] = bj[0][cur];
    k -= c;
    cur = to;
    cnt += 1;
    assert(k == 0);

    std::cout << cnt << "\n";

    return 0;
}
