#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    set<int> s;
    for (int &i : a) {
        cin >> i;
        s.insert(i);
    }
    if ((int) s.size() <= t) {
        cout << 1;
        return 0;
    }
    vector<int> b(2 * n);
    for (int i = 0; i < 2 * n; ++i) {
        b[i] = a[i % n];
    }
    vector<pair<int, int>> to(n, {-1, 0});
    int l = 0;
    map<int, int> mp;
    for (int r = 0; r < 2 * n && l < n; ++r) {
        mp[b[r]]++;
        while (l < n && (int) mp.size() > t) {
            to[l] = {r % n, r - l};
            mp[b[l]]--;
            if (mp[b[l]] == 0) {
                mp.erase(b[l]);
            }
            l++;
        }
    }
    /*for (auto [i, j] : to) {
        cout << i << ',' << j << ' ';
    }
    cout << endl;*/

    ll len = k * n;
    ll ans = 0;
    vector<int> used(n);
    vector<int> st, w;
    int v = 0;
    while (!used[v] && len > 0) {
        used[v] = 1;
        st.push_back(v);
        len -= to[v].second;
        w.push_back(to[v].second);
        ans++;
        v = to[v].first;
    }
    //cout << len << endl;
    if (len > 0) {
        ll len_cycle = 0;
        int u = v, q = 1;
        vector<int> c;
        while (st.back() != v) {
            q++;
            len_cycle += w.back();
            c.push_back(w.back());
            w.pop_back();
            st.pop_back();
        }
        //cout << len_cycle << endl;
        c.push_back(w.back());
        /*for (auto i : c) {
            cout << i << ' ';
        }
        cout << endl;*/
        len_cycle += w.back();
        ans += ll(len / len_cycle) * q;
        len %= len_cycle;
        reverse(c.begin(), c.end());
        int i = 0;
        while (len > 0) {
            len -= c[i];
            ans++;
            i++;
        }
    }
    cout << ans;
}