// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <numeric>

using namespace std;
using ll = long long;
using ld = long double;

int main()
{
	//std::cout << "Hello World!\n";
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	cout.tie(NULL);
	int n, k, t;
	cin >> n >> k >> t;
	vector <int> a(n);
	unordered_map<int, int>dpt(n);
	for (auto& i : a)
	{
		cin >> i;
		dpt[i]++;
	}
	if (t >= dpt.size())
	{
		cout << 1;
		return 0;
	}
	vector <int> link(n);
	int ct = -1;
	dpt.clear();
	for (size_t i = 0; i < n; i++)
	{
		//dpt.clear();
		while (dpt.size() <= t)
		{
			ct++;
			if (ct >= n)
				ct -= n;
			dpt[a[ct]]++;
		}
		link[i] = ct;
		dpt[a[i]]--;
		if (dpt[a[i]] == 0)
			dpt.erase(a[i]);
	}
	for (size_t i = 1; i < n; i++)
	{
		link[i] = max((link[i] <= i ? n + link[i] : link[i]), link[i - 1]);
		if (link[i] >= n)
			link[i] -= n;
	}
	vector <int>cnt(n), go(n);
	iota(go.begin(), go.end(), 0);
	for (int i = n - 1; i >= 0; i--)
	{
		cnt[i] = cnt[link[i]] + 1;
		go[i] = go[link[i]];
	}
	/*int v = 0;
	int c = 0;
	int ans = 0;
	while (c < k)
	{
		int to = link[v];
		if (to <= v)
			c++;
		ans++;
		v = to;
	}
	cout << ans << '\n';*/
	vector <int> p(n);
	vector <bool>used(n);
	int v = 0;
	int c = 0;
	ll ans = 0;
	while (c < k)
	{
		if (used[v])
		{
			int cyclesz = 0;
			ll cyclecost = 0;
			int cv = v;
			do
			{
				cyclesz++;
				cyclecost += cnt[v];
				cv = go[cv];
			} while (cv != v);
			while (c + cyclesz < k)
			{
				c += cyclesz;
				ans += cyclecost;
			}
		}
		used[v] = 1;
		c++;
		ans += 1ll * cnt[v];
		v = go[v];
	}
	cout << ans << '\n';
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
