// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long ll;
typedef long double ld;
typedef tree<
    int,
    null_type,
    less<int>,
    rb_tree_tag,
    tree_order_statistics_node_update>
    ordered_set;

const long long INF = 1e18;
const int inf = 2e9;
const int MOD = 1e9 + 7;

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int& e : a) {
        cin >> e;
    }
    a.resize(n * 2);
    for (int i = n; i < n * 2; ++i) {
        a[i] = a[i - n];
    }
    vector<int> add(n);
    map<int, int> mp;
    int r = 0;
    for (int l = 0; l < n; ++l) {
        if (l > 0) {
            mp[a[l - 1]]--;
            if (mp[a[l - 1]] == 0)
                mp.erase(a[l - 1]);
        }
        while (r < 2 * n && (mp.size() < t || mp.contains(a[r]))) {
            mp[a[r++]]++;
        }
        add[l] = r - l;
    }
    int left = n * k, pos = 0, ans = 0;
    while (left > 0) {
        left -= add[pos];
        pos = (pos + add[pos]) % n;
        ans++;
    }
    cout << ans << '\n';
}

signed main() {
#ifdef erytw
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
