//#pragma GCC optimize("o-fast", "unroll-loops", "fast-math")
//#pragma GCC target("avx", "avx2", "bmi", "bmi2")

#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define ld long double
#define sz(a) (int)a.size()

const int mod = 1e9 - 7;
const ld eps = 1e-12;

mt19937 rng(time(0));

int rnd(int n) {
    uniform_int_distribution<int> uid(0, n - 1);
    return uid(rng);
}

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> mas(n);
    for (int i = 0; i < n; i++) {
        cin >> mas[i];
    }
    set<int> cnt1;
    for (int i = 0; i < n; i++) {
        cnt1.insert(mas[i]);
    }
    if (t >= sz(cnt1)) {
        cout << 1 << endl;
        return;
    }
    vector<int> dp(n);
    for (int i = 0; i < n; i++) {
        mas.push_back(mas[i]);
    }
    for (int i = 0; i < n; i++) {
        set<int> cur;
        for (int j = i; j < 2 * n; j++) {
            cur.insert(mas[j]);
            if (sz(cur) > t) {
                dp[i] = j;
                dp[i] %= n;
                break;
            }
        }
    }
    int cnt_c = 0;
    int cnt_p = 0;
    vector<pair<int, int>> tin(n, {-1, -1});
    int cur = 0;
    int ans = 0;
    while(cnt_p < n * k) {
        int to = dp[cur];
        cnt_c++;
        cnt_p += (n + to - cur) % n;
        if (tin[to].first != -1) {
            ans = tin[to].first + (n * k - tin[to].second) / (cnt_p - tin[to].second) * (cnt_c - tin[to].first);
            ans++;
            cur=to;
            while(dp[cur]>cur){
                cur=dp[cur];
                ans++;
            }
            cout<<ans<<endl;
            return;
        }
        else{
            tin[to]={cnt_c, cnt_p};
        }
        cur = to;
    }
    cout<<cnt_c<<endl;
}

signed main() {
    cout.tie(nullptr);
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int n = 1;
    //cin >> n;
    while (n--) {
        solve();
    }
}
