#include <bits/stdc++.h>
#define int long long

using namespace std;

// c = C(2n,n)/(n+1)
// x = y' - (b/a) * x'
// y = x'
// ob[i] = (mod - (m / i) * ob[m % i] % mod + mod) % mod
// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct dif {
  map<int, int> cnt;
  int d = 0;
  void add(int x) {
    if (cnt[x] == 0) d++;
    cnt[x]++;
  }
  void del(int x) {
    if (cnt[x] == 1) d--;
    cnt[x]--;
  }
};

int ans = 0;

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int n, k, t;
  cin >> n >> k >> t;
  vector<int> a(n);
  auto dist = [&](int i, int j) {
    if (i <= j) {
      return j - i;
    } else {
      return j + (n - i);
    }
  };
  int need = n * k;
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  {
    set<int> q(a.begin(), a.end());
    if ((int) q.size() <= t) {
      assert(0);
      cout << 1 << '\n';
      return 0;
    }
  }
  vector<int> to(2 * n);
  dif d;
  int ptr = 2 * n - 1;
  for (int i = 2 * n - 1; i >= 0; i--) {
    d.add(a[i % n]);
    while (d.d > t) {
      d.del(a[(ptr--) % n]);
    }
    to[i] = (ptr + 1) % n;
  }
  int pos = 0;
  set<int> was;
  int st_cyc = -1;
  while (true) {
    ans++;
    need -= dist(pos, to[pos]);
    if (need <= 0) {
      cout << ans << '\n';
      return 0;
    }
    if (was.contains(to[pos])) {
      st_cyc = to[pos];
      break;
    }
    was.insert(to[pos]);
    pos = to[pos];
  }
  int len_of_cyc = 0;
  int num_of_cyc = 0;
  {
    was.clear();
    pos = st_cyc;
    while (true) {
      num_of_cyc++;
      len_of_cyc += dist(pos, to[pos]);
      if (was.contains(to[pos])) {
        break;
      }
      was.insert(to[pos]);
      pos = to[pos];
    }
  }
  int cnt_cyc = need / len_of_cyc;
  ans += num_of_cyc * cnt_cyc;
  need -= cnt_cyc * len_of_cyc;
  pos = st_cyc;
  while (true) {
    ans++;
    need -= dist(pos, to[pos]);
    if (need <= 0) {
      break;
    }
    pos = to[pos];
  }
  cout << ans << '\n';
}