#include <bits/stdc++.h>

#pragma GCC optimize("unroll-loops,O3")
#pragma GCC target("lzcnt,popcnt,avx2,avx,sse4")

using namespace std;

#define all(vc) vc.begin(), vc.end()
#define fi first
#define se second
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;

ll solve3(ll n, ll k, ll t, vector<ll> &vc)
{
    // vector <ll> vc(n);
    ll sz = 0;
    ll prev = -1;
    vector <ll> vc2;
    for (int i = 0; i < n; i++)
    {
        ll x = vc[i];
        if (x != prev)
        {
            sz++;
            prev = x;
            vc2.pb(prev);
        }
    }
    ll tmp = unique(all(vc2)) - vc2.begin();
    if (t >= tmp)
    {
        return 1;
    }
    set <ll> st;
    ll ans = 0;
    for (ll i = 0; i < vc2.size() * k; i++)
    {
        ll ind = i % vc2.size();
        st.insert(vc2[ind]);
        if (st.size() > t)
        {
            ans++;
            st.clear();
            st.insert(vc2[ind]);
        }
    }
    if (st.size() > 0)
    {
        ans++;
    }
    return ans;
}

ll solve(ll n, ll k, ll t, vector<ll> &vc)
{
    // vector <ll> vc(n);
    ll sz = 0;
    ll prev = -1;
    ll st = -1;
    vector <ll> vc2;
    for (int i = 0; i < n; i++)
    {
        ll x = vc[i];
        if (x != prev)
        {
            sz++;
            prev = x;
            vc2.pb(prev);
        }
        if (st == -1)
        {
            st = x;
        }
    }
    ll tmp = unique(all(vc2)) - vc2.begin();
    if (t >= tmp)
    {
        return 1;
    }
    ll sz2 = sz * k;
    if (st == prev)
    {
        sz2 -= k - 1;
    }
    ll ans = sz2 / t;
    if (sz2 % t > 0)
    {
        ans++;
    }
    return ans;
}

ll solve2(ll n, ll k, ll t, vector<ll> &vc)
{
    set <ll> st;
    ll ans = 0;
    ll pr = 0;
    for (ll i = 0; i < n * k; i++)
    {
        ll ind = i % n;
        st.insert(vc[ind]);
        if (st.size() > t)
        {
            ans++;
            st.clear();
            st.insert(vc[ind]);
        }
    }
    if (st.size() > 0)
    {
        ans++;
    }
    return ans;
}

/**
2 4 1
1 2
*/

/**
4 3 1
1 1 2 1
*/

/**
7 2 3
1 2 3 4 5 6 7
*/

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1;
    // cin >> t;

    while (tt--)
    {
        ll n, k, t;
        cin >> n >> k >> t;
        vector <ll> vc(n);
        for (auto& i: vc) cin >> i;
        if (t == 1)
        {
            cout << solve(n, k, t, vc);
            break;
        }
        cout << solve3(n, k, t, vc);
    }
    return 0;
}
