#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <random>

using namespace std;
using ll = long long;
const ll INF = 3e18;
#define endl "\n"
mt19937 rnd(2);

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    
    ll n, k, t; cin >> n >> k >> t;
    vector<ll> vec(n);
    for (ll i = 0; i < n; i++) cin >> vec[i];
    vector<ll> v = vec;
    sort(v.begin(), v.end());
    v.erase(unique(v.begin(), v.end()), v.end());
    unordered_map<ll, ll> um;
    for (ll i = 0; i < v.size(); i++) um[v[i]] = i;
    for (ll i = 0; i < n; i++) vec[i] = um[vec[i]];
    if (t >= v.size()) {
        cout << 1 << endl;
        return 0;
    }
    vector<ll> to(n, -1);
    ll i2 = n;
    vector<ll> cnt(n);
    ll cur = 0;
    for (ll i = 0; i < n; i++) {
        while (cur <= t) {
            if (i2 == n) i2 = 0;
            if (cur == t && cnt[vec[i2]] == 0) break;
            cnt[vec[i2]]++;
            if (cnt[vec[i2]] == 1) cur++;
            i2++;
        }
        to[i] = i2;
        cnt[vec[i]]--;
        if (cnt[vec[i]] == 0) cur--;
    }

    ll bcnt = k * n;
    ll sz = 0;
    ll sz2 = 0;
    vector<bool> was(n);
    ll i = 0;
    while (!was[i]) {
        was[i] = true;
        i = to[i];
    }
    ll id = i;
    do {
        ll lsz = to[i] - i;
        if (lsz < 0) lsz += n;
        //lsz++;
        sz += lsz;
        sz2++;
        i = to[i];
    } while (id != i);
    i = 0;
    ll ans = 0;
    while (true) {
        if (i == id) {
            ll c = bcnt / sz;
            ans += sz2 * c;
            bcnt -= c * sz;
        }
        if (bcnt <= 0) break;
        ans++;
        ll lsz = to[i] - i;
        if (lsz < 0) lsz += n;
        //lsz++;
        bcnt -= lsz;
        i = to[i];
    }
    cout << ans << endl;
}