#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

signed main() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];
    set<ll> in(a.begin(), a.end());
    if ((ll) in.size() <= t) {
        cout << "1\n";
        return 0;
    }
    vector<ll> cur;
    for (ll x : a) cur.push_back(x);
    for (ll x : a) cur.push_back(x);
    ll right = 0;
    map<ll, ll> cnt;
    ll current = 0;
    auto check = [&] (ll x) {
        if (current < t) return true;
        return (cnt[x] > 0);
    };
    auto add = [&] (ll x) {
        if (cnt[x] == 0) current++;
        cnt[x]++;
    };
    auto del = [&] (ll x) {
        if (cnt[x] == 1) current--;
        cnt[x]--;
    };
    vector<ll> to(n);
    for (ll left = 0; left < n; left++) {
        while (right < 2 * n && check(cur[right])) {
            add(cur[right]);
            right++;
        }
        to[left] = right;
        del(cur[left]);
    }
    ll cur_ind = 0, need = -1;
    vector<ll> mem;
    map<ll, bool> used;
    while (true) {
        mem.push_back(cur_ind);
        used[cur_ind] = true;
        cur_ind = to[cur_ind];
        cur_ind %= n;
        if (used[cur_ind]) {
//            cout << "d: " << cur_ind << endl;
            need = cur_ind;
            break;
        }
    }
//    for (ll index : mem) cout << index << " ";
//    cout << endl;
    ll was = 0, ans = 0;
    for (ll i = 0; i < (ll) mem.size() - 1; i++) {
        if (mem[i] == need) break;
        ans++;
        if (mem[i] > mem[i + 1]) {
            if (was == k - 1) {
                cout << ans << endl;
                return 0;
            }
            was++;
        }
        if (mem[i + 1] == need) break;
    }
    vector<ll> cycle;
    for (ll i = 0; i < (ll) mem.size(); i++) {
        if (mem[i] == need) {
            for (ll j = i; j < (ll) mem.size(); j++) cycle.push_back(mem[j]);
            break;
        }
    }
    ll jumps = 0;
    for (ll i = 0; i < (ll) cycle.size(); i++) {
        if (cycle[i] < cycle[(i - 1 + (ll) cycle.size()) % (ll) cycle.size()]) {
            jumps++;
        }
    }
//    cout << "jumps: " << jumps << endl;
//    cout << "was: " << was << endl;
//    cout << "k: " << k << endl;
    ans += ((k - 1 - was) / jumps) * (ll) cycle.size();
    ll ost = ((k - 1 - was) % jumps);
//    cout << ans << " " << ost << endl;
    for (ll i = 0; i < (ll) cycle.size() && ost >= 0; i++) {
        ans++;
        if (cycle[i] > cycle[(i + 1) % (ll) cycle.size()]) {
            ost--;
        }
    }
    cout << ans << endl;
    return 0;
}
