#include <bits/stdc++.h>
#include <bits/extc++.h>
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define sz(v) (int)(v).size()
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld  = long double;
mt19937 Rand(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());
const int inf = 1e9;
const ll INF = 1e18;

const int N = 3e5 + 1;
ll a[N], go[N], n, k, t;
ll vis[N], sum[N];

void solve() {
    cin >> n >> k >> t;
    set <ll> s;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        s.insert(a[i]);
    }
    if (sz(s) <= t) {
        cout << "! " << 1;
        return;
    }
    map <ll, int> c;
    int cur = 0, j = -1;
    for (int i = 0; i < n; ++i) {
        while (cur <= t) {
            j = (j == n - 1? 0 : j + 1);
            cur += (c[a[j]] == 0);
            ++c[a[j]];
        }
        go[i] = j;
        --c[a[i]];
        cur -= (c[a[i]] == 0);
    }
    auto f = [&](ll i) {
        return (i < go[i]? go[i] - i : go[i] - i + n);
    };
    ll p = 0, cur_sum = 0, step = 0, mem;
    while (!vis[p]) {
        vis[p] = ++step;
        cur_sum += f(p);
        p = go[p];
        mem = sum[p];
        sum[p] = cur_sum;
    }
    ll cycle_sum = sum[p] - mem, cycle_sz = step - vis[p] + 1;
    ll l = 0, r = INF / 100;
    while (r - l > 1) {
        ll m = (l + r) / 2, cnt = 0;
        ll left = m, tmp = 0;
        if (left > vis[p] - 1) {
            cnt += mem;
            left -= vis[p] - 1;
            cnt += (left / cycle_sz) * cycle_sum;
            left %= cycle_sz;
            tmp = p;
        }
        for (int i = 0; i < left; ++i) {
            cnt += f(tmp);
            tmp = go[tmp];
        }
        if (cnt >= k * n) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    int tt = 1;
    while (tt--) {
        solve();
    }
}
