#include <bits/stdc++.h>

using namespace std;

using ll = long long;

ll n0, k0, t0;
vector<ll> a0;

ll ansSmart, ansStupid;

void smart() {
    vector<ll> a;
    unordered_set<ll> all;
    ll n = n0;
    ll t = t0;
    ll k = k0;
    for (ll i = 0; i < n; ++i) {
        ll val;
        val = a0[i];
        if (a.empty() || val != a.back()) {
            a.push_back(val);
            all.insert(val);
        }
    }
    if (all.size() <= t) {
        // cout << 1 << endl;
        ansSmart = 1;
        return;
    }
    n = a.size();

    vector<ll> len(n);

    ll r = 0;
    unordered_map<ll, ll> m;
    for (ll l = 0; l < n; ++l) {
        for (;;) {
            ++m[a[r % n]];
            if (m.size() > t) {
                m.erase(a[r % n]);
                break;
            }
            ++r;
        }
        len[l] = r - l;
        // cout << "len " << l << " = " << len[l] << endl;
        --m[a[l % n]];
        if (!m[a[l % n]]) {
            m.erase(a[l % n]);
        }
    }

    // for (ll i = 0; i < n; ++i) {
    //     unordered_set<ll> used;
    //     ll l = 0;
    //     for (;; ++l) {
    //         used.insert(a[(i + l) % n]);
    //         if (used.size() > t) {
    //             break;
    //         }
    //     }
    //     len[i] = l;
    //     // cout << "len " << i << " = " << len[i] << endl;
    // }

    unordered_set<ll> used;
    vector<ll> pos;
    set<ll> posSet;
    ll loopLen;
    ll loopAdd = 0;
    ll ans = 0;
    ll start = 0;
    for (ll i = 0;;) {
        // cout << "pos " << i << endl;
        if (posSet.count(i % n)) {
            ll j = 0;
            for (; j < n; ++j) {
                if (pos[j] % n == i % n) {
                    break;
                }
            }
            ans += j;
            start = pos[j];
            loopAdd = pos.size() - j;
            loopLen = i - pos[j];
            break;
        }
        pos.push_back(i);
        posSet.insert(i % n);
        i += len[i % n];
    }
    // cout << "looplen " << loopLen << endl;
    
    ans += (n * k - start) / loopLen * loopAdd;
    for (ll i = start + (n * k - start) / loopLen * loopLen; i < n * k;) {
        i += len[i % n];
        ++ans;
    }
    ansSmart = ans;
}

void stupid() {
    ll n, k, t;
    n = n0;
    k = k0;
    t = t0;
    vector<ll> a;
    for (ll i = 0; i < n; ++i) {
        ll val;
        val = a0[i];
        // if (a.empty() || val != a.back()) {
            a.push_back(val);
        // }
    }
    n = a.size();
    unordered_set<ll> used;
    ll ans = 1;
    for (ll i = 0; i < n * k; ++i) {
        used.insert(a[i % n]);
        if (used.size() > t) {
            ++ans;
            used.clear();
            used.insert(a[i % n]);
        }
    }
    ansStupid = ans;
}

void stress() {
    for (;;) {
        a0.clear();
        n0 = 4;
        k0 = 1;
        t0 = 2;
        a0.resize(n0);
        for (ll i = 0; i < n0; ++i) {
            a0[i] = rand() % 5 + 1;
        }
        cout << "test: ";
        for (ll val : a0) {
            cout << val << ' ';
        }
        cout << endl;
        smart();
        stupid();
        if (ansSmart != ansStupid) {
            cout << "BAD" << endl;
            cout << ansSmart << ' ' << ansStupid << endl;
            return;
        }
        // cout << "good" << endl;
    }
}

void solve() {
    cin >> n0 >> k0 >> t0;
    a0.resize(n0);
    for (ll i = 0; i < n0; ++i) {
        cin >> a0[i];
    }
    smart();
    cout << ansSmart << endl;
}

signed main() {
    // stress();
    solve();
}
