#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>


typedef long long ll;
using namespace std;

pair<ll, ll> Buravchik(ll tb, ll ta, ll sumb, ll suma, vector<ll>& vec, ll l, ll r) {
	if (l > r) {
		return { suma, sumb };
	}
	pair<ll, ll> out;
	ll minimum = INT64_MAX;
	if (ta <= 0 && tb >= 0) {
		pair<ll, ll> version1 = Buravchik(tb - 1, ta + vec[r] - 1, sumb, suma + vec[r], vec, l, r - 1);
		pair<ll, ll> version2 = Buravchik(tb - 1, ta + vec[l] - 1, sumb, suma + vec[l], vec, l + 1, r);
		if (abs(version1.first - version1.second) < minimum) {
			minimum = abs(version1.first - version1.second);
			out = version1;
		}
		if (abs(version2.first - version2.second) < minimum) {
			minimum = abs(version2.first - version2.second);
			out = version2;
		}
	}
	else if (tb <= 0) {
		pair<ll, ll> version1 = Buravchik(tb + vec[r] - 1, ta - 1, sumb + vec[r], suma, vec, l, r - 1);
		pair<ll, ll> version2 = Buravchik(tb + vec[l] - 1, ta - 1, sumb + vec[l], suma, vec, l + 1, r);
		if (abs(version1.first - version1.second) < minimum) {
			minimum = abs(version1.first - version1.second);
			out = version1;
		}
		if (abs(version2.first - version2.second) < minimum) {
			minimum = abs(version2.first - version2.second);
			out = version2;
		}
	}
	else {
		out = Buravchik(tb - min(tb, ta), ta - min(tb, ta), sumb, suma, vec, l, r);
	}
	return out;
}

int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr); cout.tie(nullptr);

	ll n, k, t;
	cin >> n >> k >> t;
	vector<ll> vec;
	map<ll, ll> counts;
	ll count = 0;
	ll new_ = 0;
	ll now_new = 0;
	for (ll i = 0; i < n; i++) {
		ll b;
		cin >> b;
		vec.push_back(b);
		if (counts[b] == 0) count++;
		counts[b]++;
		if (i > 0 && vec[i - 1] == b) {
			now_new++;
		}
		if (now_new == t) {
			new_++;
			now_new = 0;
		}
	}
	if (count <= t) {
		cout << 1 << endl;
		return 0;
	}
	if (t == 1) {
		if (vec[0] == vec.back()) {
			new_++;
			cout << (n - new_) * k + 1 << endl;
			return 0;
		}
		cout << (n - new_) * k << endl;
		return 0;
	}

	if (false && vec[0] == vec.back()) {
		now_new++;
		if (now_new == t) {
			new_++;
			cout << (n - new_) * k + 1 << endl;
			return 0;
		}
	}
	if (true) {
		now_new = 0;
		map<ll, ll> countss;
		ll out = 1;
		map<ll, ll> cicles;
		for (ll i = 0; i < n * k; i++) {
			if (i % n == 0 && i > 0 && now_new == 0) {
				ll now_k = i / n;
				out += k / now_k;
				out += cicles[k % now_k];
				break;
			}
			if (i % n == 0 && i > 0) {
				cicles[i / n] = out;
			}
			if (countss[vec[i % n]] == 0) now_new++;
			if (now_new > t) {
				out++;
				now_new = 1;
				countss.clear();
			}
			countss[vec[i % n]]++;
		}
		cout << out << endl;
		return 0;
	}
	cout << (n - new_) * k << endl;
}
