#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
        >;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<int> srt = a;
    sort(all(srt));
    srt.resize(unique(all(srt)) - srt.begin());

    if (srt.size() <= t) {
        cout << 1 << '\n';
        return 0;
    }

    for (auto& el : a) el = lower_bound(all(srt), el) - srt.begin();

    for (int i = 0; i < n; i++) a.push_back(a[i]);

    vector<int> mx(n);
    vector<int> cnt(n);
    int j = 0;
    int cur = 0;
    for (int i = 0; i < n; i++) {
        while (j < 2 * n) {
            int nxt = a[j];
            if (cnt[nxt] > 0 || cur < t && cnt[nxt] == 0) {
                if (cnt[nxt] == 0) cur++;
                cnt[nxt]++;
                j++;
            } else {
                break;
            }
        }

        mx[i] = j;

        if (cnt[a[i]] == 1) cur--;
        cnt[a[i]]--;
    }

    int ans = 0;
    int id = 0;
    ll x = k * n;
    while (x > 0) {
        ans++;
        x -= mx[id] - id;
        id = mx[id] % n;
    }

    cout << ans << '\n';

    return 0;
}
