#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define p_b push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template<class T> using oset =
tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using pq =
priority_queue<T>;
template<class T> using pqg =
priority_queue<T, vector<T>, greater<T>>;

template<class T> void amin(T &a, T b) {a = a < b ? a : b;}
template<class T> void amax(T &a, T b) {a = a > b ? a : b;}

const int N = 3e5 + 5;

int a[N];

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    unordered_map<int, int> was;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        was[a[i]] = 1;
    }
    if ((int)was.size() <= t) {
        cout << 1;
        return;
    }
    was.clear();
    if (1LL * n * k <= 1e8) {
        int ans = 0;
        int cur = 0;
        int pos = 0;
        for (int i = 0; i < k * n; i++, pos++) {
            if (pos == n)
                pos = 0;
            if (!was[a[pos]]) {
                cur++;
            }
            if (cur == t + 1) {
                ans++;
                cur = 1;
                was.clear();
            }
            was[a[pos]] = 1;
        }
        cout << ans + 1 << '\n';
        return;
    }
//    for (int i = n; i < 3 * n; i++)
//        a[i] = a[i - n];
    int cur = 0;
    int cnt = 0;
    ll ans = 0;
    for (int it = 0; it < 200; it++) {
        for (int i = 0; i < n; i++) {
            if (!was[a[i]]) {
                cur++;
            }
            if (cur == t + 1) {
                cnt++;
                cur = 1;
                was.clear();
            }
            was[a[i]] = 1;
        }
        ans += cnt;
        if (it == 199) {
            ans += 1LL * cnt * (k - 201);
//            cout << cnt << '\n';
        }
        cnt = 0;
    }
    cout << ans + 1;
}

int32_t main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // LOCAL
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    #ifdef LOCAL
        cout << "\n===\n\n\nTime : " << clock() / CLOCKS_PER_SEC << '\n';
    #endif // LOCAL
}
