#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define p_b push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template<class T> using oset =
tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using pq =
priority_queue<T>;
template<class T> using pqg =
priority_queue<T, vector<T>, greater<T>>;

template<class T> void amin(T &a, T b) {a = a < b ? a : b;}
template<class T> void amax(T &a, T b) {a = a > b ? a : b;}

const int N = 3e5 + 5;

int a[2 * N];
int to[N][2];
ll cnt[N][2];

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    gp_hash_table<int, int> was;
    int rn = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        was[a[i]] = 1;
    }
    if ((int)was.size() <= t) {
        cout << 1;
        return;
    }
    for (int i = n; i < 2 * n; i++) {
        a[i] = a[i - n];
    }
    was.clear();
    int l = 0, r = -1;
    int cur = 0;
//    cout << n << '\n';
    while (l < n) {
        was[a[++r]]++;
        if (was[a[r]] == 1)
            cur++;
        while (l < n && cur == t + 1) {
            to[l][0] = r % n;
            cnt[l][0] = 1;
            was[a[l]]--;
            if (!was[a[l++]])
                cur--;
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        if (to[i][0] > i) {
            cnt[i][0] += cnt[to[i][0]][0];
            to[i][0] = to[to[i][0]][0];
        }
//        cout << to[i][0] << ' ' << cnt[i][0] << '\n';
    }
    cur = 0;
    ll ans = 0;
    if (k & 1) {
        cur = to[0][0];
        ans = cnt[0][0];
        k--;
    }
    for (int j = 1; j < 30; j++) {
        for (int i = 0; i < n; i++) {
            cnt[i][1] = cnt[i][0] + cnt[to[i][0]][0];
            to[i][1] = to[to[i][0]][0];
        }
        for (int i = 0; i < n; i++) {
            to[i][0] = to[i][1];
            cnt[i][0] = cnt[i][1];
        }
        if (k & (1LL << j)) {
            k -= (1LL << j);
            ans += cnt[cur][0];
            cur = to[cur][0];
        }
    }
    cout << ans;
}

int32_t main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // LOCAL
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    #ifdef LOCAL
        cout << "\n===\n\n\nTime : " << clock() / CLOCKS_PER_SEC << '\n';
    #endif // LOCAL
}
