#include<iostream>
#include<vector>
#include<string>
#include<sstream>
#include<cmath>
#include<algorithm>
#include<stdio.h>
#include<random>
#include<ctime>
#include<iomanip>
#include<memory.h>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<stack>
#include<deque>
#include<queue>
#define int long long
#define pii pair<int, int>
#define pb push_back
#define fir first
#define sec second
#define endl '/n'
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

mt19937 rnd(228);

int begcyc = -1;

void dfs(vector<int>& gr, int v, vector<int>& used) {
	used[v] = 1;
	if (used[gr[v]])
		begcyc = gr[v];
	else
		dfs(gr, gr[v], used);
	return;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n, k, t;
	cin >> n >> k >> t;

	vector<int> vc(n);
	for (int& i : vc)
		cin >> i;

	unordered_set<int> rz;
	for (int i : vc) {
		rz.insert(i);
	}
	if (rz.size() <= t) {
		cout << 1;
		return 0;
	}

	for (int i = 0; i < n; i++)
		vc.pb(vc[i]);

	vector<int> gr(n, -1);
	int id = 0;
	while (gr[id] == -1) {
		int l = 0, r = n + 1;
		while (r - l > 1) {
			int m = (r + l) / 2;
			unordered_set<int> st;
			for (int i = id; i - id < m; i++) {
				st.insert(vc[i]);
			}
			if (st.size() > t)
				r = m;
			else
				l = m;
		}
		gr[id] = (id + l) % n;
		id = (id + l) % n;
	}
	vector<int> used(n);
	dfs(gr, 0, used);

	vector<int> cycle;
	int inv = 0;
	id = begcyc;

	do {
		cycle.pb(id);
		id = gr[id];
	} while (id != begcyc);

	for (int i = 0; i < cycle.size(); i++) {
		inv += (vc[cycle[i]] > vc[cycle[(i + 1) % (int)(cycle.size())]]);
	}

	int ans = 0;
	id = 0;
	while (id != begcyc && k > 0) {
		ans++;
		int nid = gr[id];
		if (nid < id) {
			k--;
		}
		id = nid;
	}

	ans += k / inv * cycle.size();
	k -= k / inv * inv;

	id = begcyc;
	while (k > 0) {
		ans++;
		int nid = gr[id];
		if (nid < id) {
			k--;
		}
		id = nid;
	}

	cout << ans;
	return 0;
}