#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

//#define int ll
#define all(x) x.begin(), x.end()
//#pragma GCC optimize("Ofast")

int a[600005];
//vector<int> t[1 << 23];
//
//void build(int v, int l, int r) {
//	if (l == r - 1) {
//		t[v] = { a[l] };
//		return;
//	}
//	int m = (l + r) / 2;
//	build(2 * v + 1, l, m);
//	build(2 * v + 2, m, r);
//	t[v].resize(r - l);
//	merge(all(t[2 * v + 1]), all(t[2 * v + 2]), t[v].begin());
//}
//
//int ask(int v, int l, int r, int askl, int askr, int x) {
//	if (r <= askl || askr <= l)return 0;
//	if (askl <= l && r <= askr)return upper_bound(all(t[v]), x) - t[v].begin();
//	int m = (l + r) / 2;
//	return ask(2 * v + 1, l, m, askl, askr, x) + ask(2 * v + 2, m, r, askl, askr, x);
//}

/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7
*/

void solve() {
	int n, k, t;
	cin >> n >> k >> t;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	if (t == 1) {
		for (int i = 0; i < n; ++i)a[n + i] = (a[i]);
		ll r = 1;
		ll tmp = (a[0] == a[2 * n - 1]);
		for (int i = 1; i < 2 * n; ++i) {
			if (a[i] != a[i - 1]) {
				r++;
			}
		}
		ll w = 0;
		for (int i = n; i < 2 * n; ++i) {
			if (a[i] != a[i - 1]) {
				w++;
			}
		}
		cout << 1ll * (r - tmp) * 1ll * (k / 2) + (k % 2 ? w : 0) + tmp << '\n';
		return;
	}
	vector<int> b;
	for (int i = 0; i < n; ++i)b.push_back(a[i]);
	sort(b.begin(), b.end());
	b.resize(unique(b.begin(), b.end()) - b.begin());
	for (int& i : a) {
		i = lower_bound(b.begin(), b.end(), i) - b.begin();
	}
	if (b.size() <= t) {
		cout << "1\n";
		return;
	}
	vector<int> m(b.size() + 1, -1);
	vector<int> to(n, n);
	vector<int> sz(n, 0);
	multiset<int> s;
	int cnt = 0;
	int p = 0;
	for (int i = 0; i < n && cnt <= t; ++i) {
		if (s.count(a[i]) == 0) {
			if (cnt + 1 > t)
				break;
			cnt++;
		}
		p = i;
		s.insert(a[i]);
	}
	to[0] = p + 1;
	sz[0] = s.size();
	for (int i = 1; i < n; ++i) {
		s.erase(s.find(a[i - 1]));
		if (s.count(a[i - 1]) == 0) {
			cnt--;
		}
		p = to[i - 1] - 1;
		for (int j = to[i - 1]; j < n && cnt <= t; ++j) {
			if (s.count(a[j]) == 0) {
				if (cnt + 1 > t)
					break;
				cnt++;
			}
			s.insert(a[j]);
			p = j;
		}
		to[i] = p + 1;
		sz[i] = s.size();
	}
	vector<pair<int, int>> dp(n + 1);
	dp[n - 1] = { 1, 1 };
	for (int i = n - 2; i > -1; --i) {
		auto c = dp[to[i]];
		dp[i].first = c.first + 1;
		dp[i].second = (c.second + sz[i]) % t;
	}
	vector<pair<int, int>> w(n);
	int it = 0;
	s.clear();
	cnt = 0;
	for (int i = n - 1; i > 0; --i) {
		if (s.count(a[i]) == 0 && cnt == t)
			break;
		if(!s.count(a[i]))
			cnt++;
		p = i;
		s.insert(a[i]);
	}
	for (int i = n - p; i > -1; --i) {
		for (int j = it; j < n; ++j) {
			it = j;
			if (s.count(a[j]) == 0){
				if (cnt == t)
					break;
				cnt++;
			}
			s.insert(a[j]);
		}
		w[i].first = dp[it].first + (i == 0);
		w[i].second = dp[it].second;
        if(i){
		s.erase(s.find(a[n - i]));
		if (s.count(a[n - i]) == 0) {
			cnt--;
		}
        }
	}
	ll ans = 0;
	int r = 0;
	for (int i = 0; i < k; ++i) {
		ans += w[r].first;
		r = w[r].second;	
	}
	cout << ans << '\n';
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	//cin >> t;

	for (int _ = 0; _ < t; ++_) {
		solve();
	}

}
