#include <bits/stdc++.h>

using namespace std;

#define int long long


void normal_sol(int n, int k, int t, vector<int> & lst) {
    vector<int> where_we_should_start_next(n, -1);
    set<int> all;
    int right = 0;
    all.insert(lst[0]);
    for (int left = 0; left < n; left++) {
        all.insert(lst[left]);
        while (all.size() <= t) {
            right++;
            right %= n;
            all.insert(lst[right]);
        }
        where_we_should_start_next[left] = right;
        all.erase(lst[right]);
        right = (right - 1 + n) % n;
        all.erase(lst[left]);
    }
    int ans = 0, ind = 0;
    while (k > 0) {
        if (where_we_should_start_next[ind] < ind) {
            k--;
        }
        ind = where_we_should_start_next[ind];
        ans++;
    }
    cout << ans << endl;
    exit(0);
}

void sol_for_t_1(int n, int k, int t, vector<int> & lst) {
    int cou_diff = 0;
    for (int i = 0; i + 1 < n; i++) {
        if (lst[i] != lst[i + 1]) {
            cou_diff++;
        }
    }
    if (lst[0] != lst[n - 1]) {
        cou_diff++;
        cou_diff *= k;
    } else {
        cou_diff *= k;
        cou_diff++;
    }
    int ans = cou_diff / t;
    if (cou_diff % t != 0) {
        ans++;
    }
    cout << ans << endl;
    exit(0);
}



void slow_solution(int n, int k, int t, vector<int> & lst) {
    int ans = 1;
    set<int> el;
    int ind = 0;
    for (int i = 0; i < n * k; i++) {
        el.insert(lst[ind]);
        if (el.size() > t) {
            ans++;
            el.clear();
            el.insert(lst[ind]);
        }
        ind++;
        ind %= n;
    }
    cout << ans << endl;
    exit(0);
}




signed main() {
    cout.precision(15);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> lst(n, 0);
    set<int> set_of_all;
    for (int i = 0; i < n; i++) {
        cin >> lst[i];
        set_of_all.insert(lst[i]);
    }
    if (set_of_all.size() <= t) {
        cout << 1;
        exit(0);
    }
    slow_solution(n, k, t, lst);
}

