#include <iostream>

#include <vector>
#include <set>

#include <algorithm>
#include <cmath>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int vs, ks, mx;
    cin >> vs >> ks >> mx;
    vector<int> v(vs);
    for (int &i: v)
        cin >> i;

    vector<pair<int, int>>cnt(vs * 2 + 1);
    set<int>x;

    for (int i = vs * 2 - 1; i >= 0; i--) {
        x.insert(v[i % vs]);
        cnt[i].first = cnt[i + 1].first;
        if (x.size() > mx) {
            cnt[i].first++;
            x.clear();
            x.insert(v[i % vs]);
        }
        cnt[i].second = x.size();
    }

    if (cnt[0].first == 0) {
        cout << 1;
        return 0;
    }

    x.clear();
    vector<int>l(mx + 1);

    for (int i = vs - 1; i >= 0 && x.size() <= mx; i--) {
        if (!x.contains(v[i]))
            l[x.size()] = i + 1;
        x.insert(v[i]);
    }


    ll ans = 0;
    int pr = 0;
    for (int ki = 0; ki < ks; ki++) {
        ans += cnt[l[pr]].first;
        pr = cnt[l[pr]].second;
    }

    cout << ans + !!pr;
}