#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <iomanip>
#include <numeric>
#include <fstream>
#include <map>
#include <random>

using namespace std;

void solve();

int n, k, t;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif

	int tt = 1;
	cin >> n >> k >> t;
	while (tt--) {
		solve();
	}
}

using ll = long long;

random_device rd;
mt19937 rnd(rd());

#define int ll


//int my(vector<int>& a) {
//	vector<int> c;
//	for (int i = 0; i < k; i++) {
//		for (auto& x : a) {
//			c.push_back(x);
//		}
//	}
//
//	int ans = 1;
//	map<int, int> mp;
//	for (int i = 0; i < c.size(); i++) {
//		if (mp.find(c[i]) == mp.end()) {
//			if (mp.size() == t) {
//				mp.clear();
//				mp[c[i]] = 1;
//				ans += 1;
//			}
//			else {
//				mp[c[i]] = 1;
//			}
//		}
//	}
//	return ans;
//}

void solve() {
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		//a[i] = rnd() % 10 + 1;
		cin >> a[i];
	}
	

	vector<int> c = a;
	for (auto& x : a) {
		c.push_back(x);
	}
	
	vector<int> nxt(n);
	int l = 0, r = 0;
	map<int, int> cnt;
	int cur = 0;
	while (l < n) {
		while ((r - l) <= n && cur <= t) {
			cnt[c[r]] += 1;
			if (cnt[c[r]] == 1) {
				cur += 1;
			}
			r += 1;
		}

		nxt[l] = (r - 1) % n;
		if (nxt[l] == l) {
			cout << 1;
			return;
		}
		cnt[c[l]] -= 1;
		if (cnt[c[l]] == 0) {
			cur -= 1;
		}
		l += 1;
	}

	int kk = k;
	int ans = 0;
	int pos = 0;
	while (true) {
		int x = nxt[pos];
		if (x <= pos) {
			kk -= 1;
		}
		if (x != pos) {
			ans += 1;
		}
		pos = x;
		if (kk == 0) {
			break;
		}
	}
	if (ans == 0) {
		ans = 1;
	}
	cout << ans;
	//if (ans != my(a)) {
	//	cout << "wa\n";
	//	cout << ans << ' ' << my(a) << '\n';
	//	for (auto& x : a) {
	//		cout << x << ' ';
	//	}
	//	cout << '\n';
	//}
}
