#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <iomanip>
#include <numeric>
#include <fstream>
#include <unordered_map>
#include <random>

using namespace std;

void solve();

int n, k, t;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif

	int tt = 1;
	cin >> n >> k >> t;
	while (tt--) {
		solve();
	}
}

using ll = long long;

random_device rd;
mt19937 rnd(rd());

#define int ll


//int my(vector<int>& a) {
//	vector<int> c;
//	for (int i = 0; i < k; i++) {
//		for (auto& x : a) {
//			c.push_back(x);
//		}
//	}
//
//	int ans = 1;
//	unordered_map<int, int> mp;
//	for (int i = 0; i < c.size(); i++) {
//		if (mp.find(c[i]) == mp.end()) {
//			if (mp.size() == t) {
//				mp.clear();
//				mp[c[i]] = 1;
//				ans += 1;
//			}
//			else {
//				mp[c[i]] = 1;
//			}
//		}
//	}
//	return ans;
//}

void solve() {
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		//a[i] = rnd() % 10 + 1;
		cin >> a[i];
	}
	if (t == 1) {
		vector<int> c;
		for (int i = 0; i < n; i++) {
			if (!c.empty() && a[i] == c.back()) {
				continue;
			}
			c.push_back(a[i]);
		}

		if (c[0] == c.back()) {
			cout << (k - 1) * (c.size() - 1) + c.size();
		}
		else {
			cout << k * c.size();
		}

		return;
	}

	vector<int> p = a;
	sort(p.begin(), p.end());
	p.resize(unique(p.begin(), p.end()) - p.begin());
	for (int i = 0; i < n; i++) {
		a[i] = lower_bound(p.begin(), p.end(), a[i]) - p.begin();
	}

	vector<int> c = a;
	for (auto& x : a) {
		c.push_back(x);
	}
	
	vector<int> nxt(n);
	int l = 0, r = 0;
	vector<int> cnt(n);
	int cur = 0;
	while (l < n) {
		while ((r - l) <= n && cur <= t) {
			cnt[c[r]] += 1;
			if (cnt[c[r]] == 1) {
				cur += 1;
			}
			r += 1;
		}

		nxt[l] = (r - 1) % n;
		if (nxt[l] == l) {
			cout << 1;
			return;
		}
		cnt[c[l]] -= 1;
		if (cnt[c[l]] == 0) {
			cur -= 1;
		}
		l += 1;
	}
	
	vector<pair<int, int>> s(n);
	for (int i = n - 1; i >= 0; i--) {
		if (nxt[i] < i) {
			s[i] = { 1, nxt[i] };
		}
		else {
			s[i] = { s[nxt[i]].first + 1, s[nxt[i]].second };
		}
	}

	int kk = k;
	int ans = 0;
	int pos = 0;
	vector<pair<int, int>> add(n);
	vector<pair<int, int>> fir(n);
	int op = 0;
	int win = 0;
	while (kk--) {
		op += 1;
		win += 1;
		if (win >= 700000000) {
			int xx = 0;
			cout << 123 / xx;
		}
		if (fir[pos].first == 0 && fir[pos].second == 0) {
			fir[pos] = { kk, ans };
		}
		add[pos] = { fir[pos].first - kk, ans - fir[pos].second };
		if (kk >= add[pos].first) {
			win += add[pos].first;
			kk -= add[pos].first;
			ans += add[pos].second;
		}
		int x = s[pos].second;
		ans += s[pos].first;
		pos = x;
	}
	cout << ans;
	//if (ans != my(a)) {
	//	cout << "wa\n";
	//	cout << ans << ' ' << my(a) << '\n';
	//	for (auto& x : a) {
	//		cout << x << ' ';
	//	}
	//	cout << '\n';
	//}
}
