#include "bits/stdc++.h"

using namespace std;
#define vecout(a) for (auto i: a) cout << i << ' '; cout << '\n'
#define int long long

//struct Node {
//	int val;
//
//	Node(): val(0) {}
//	Node(int val): val(val) {}
//	friend Node operator+(Node x, Node y) {
//		return x + y;
//	}
//};
//
//struct Segtree {
//	int sz;
//	vector<Node> tree;
//
//	Segtree(int n) {
//		sz = 1;
//		while (sz < n) sz <<= 1;
//		tree.assign(sz << 1, Node());
//
//		for (int i = 0; i < n; ++i) tree[i + sz] = {(int)g[i].size(), i};
//		for (int i = sz - 1; i > 0; --i) tree[i] = tree[i << 1] + tree[i << 1 | 1];
//	}
//
//	void set(int i, int v) {
//		tree[i += sz].val += v;
//		for (i >>= 1; i > 0; i >>= 1) tree[i] = tree[i << 1] + tree[i << 1 | 1];
//	}
//
//	int get(int l) {
//
//	}
//};

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#endif
	int n, k, t;
	cin >> n >> k >> t;
	
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		a.push_back(a[i]);
	}
	
	map<int,int> last;
	
	for (int i = n + n - 1; i >= n; --i) last[a[i]] = i;
	vector<int> uni(n + n);
	for (auto [x, y]: last) uni[y] = 1;
	int r = n + n - 1, curr = last.size();

	vector<int> cnt(n);
	
	for (int l = n - 1; l >= 0; --l) {
		uni[last[a[l]]] = 0, uni[l] = 1, curr++;
		if (last[a[l]] <= r) curr--;
		
		while (l <= r and curr > t) curr -= uni[r--];
		
		if (last.size() <= t) cnt[l] = 1e9;
		else cnt[l] = r - l + 1;
		
		last[a[l]] = l;
	}
	
	vector<vector<int> > dp(60, vector<int> (n)), p(60, vector<int>(n));
	dp[0] = cnt;
	for (int i = 0; i < n; ++i) p[0][i] = (i + cnt[i]) % n;
	
	for (int bit = 1; bit < 60; ++bit) {
		for (int i = 0; i < n; ++i) {
			dp[bit][i] = dp[bit - 1][i] + dp[bit - 1][p[bit - 1][i]];
			p[bit][i] = p[bit - 1][p[bit - 1][i]];
		}
	}
	
	auto check = [&](int x) {
		int ans = 0, now = 0;
		for (int bit = 0; bit < 60; ++bit) {
			if ((x >> bit) & 1) {
				ans += dp[bit][now];
				now = p[bit][now];
			}
		}
		
		return ans >= n * k;
	};
	
	int l = -1;
	r = n * k;
	
	while (r - l > 1) {
		int mid = (l + r) >> 1;
		
		if (check(mid)) r = mid;
		else l = mid;
	}
	
	cout << r << "\n";
}