#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

using ll = long long;
using lll = __int128_t;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using dui = pair<int, int>;
using dul = pair<long, long>;
using vi = vector<int>;
using vll = vector<long long>;
using ld = long double;

constexpr int MX = 2'000'000'000;
constexpr long long MXL = 4'000'000'000'000'000'000;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

vi gen() {
    uniform_int_distribution<int> x(1, 10);
    int n = x(rnd), k = x(rnd), t = x(rnd);
    vi a = {n, k, t};
    for (int i=0;i<n;i++) {
        a.push_back(x(rnd));
    }
    return a;
}

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vi a(n);
    set<int> el;
    for (int &i: a) cin >> i, el.insert(i);
    if (el.size() <= t) {
        cout << 1;
        return;
    }
    int i = 0, j = 0;
    map<int, int> s;
    vi ans(n);
    for (i = 0; i < n; i++) {
        while (s.size() <= t) {
            s[a[j]]++;
            j++;
            if (j == n) j = 0;
        }
        ans[i] = j - 1;
        if (ans[i] == -1) ans[i] += n;
        s[a[i]]--;
        if (s[a[i]] == 0) s.erase(a[i]);
    }
    vi was(n);
    int ind = 0;
    was[ind] = 1;
    int cnt = 1;
    while (!was[ans[ind]]) {
        cnt++;
        ind = ans[ind];
        was[ind] = 1;
    }
    was.assign(n, 0);
    int dobr = cnt;
    cnt = 0;
    int krugs = 0;
    vi verts;
    while (!was[ans[ind]]) {
        cnt++;
        verts.push_back(ind);
        if (ans[ind] < ind) krugs++;
        ind = ans[ind];
        was[ind] = 1;
    }
    int res = 0;
    /*res =
            ((k) / (krugs)) * cnt + dobr - cnt;
    k = ((k) % krugs);
    ind = *min_element(verts.begin(),verts.end());*/
    ind = 0;
    while (k) {
        res++;
        if (ans[ind] < ind) k--;
        ind = ans[ind];
    }
    cout << res;
}

void solve_fast() {
    int n, k, t;
    cin >> n >> k >> t;
    vi a(n);
    set<int> el;
    for (int &i: a) cin >> i, el.insert(i);
    if (el.size() <= t) {
        cout << 1;
        return;
    }
    int i = 0, j = 0;
    map<int, int> s;
    vi ans(n);
    for (i = 0; i < n; i++) {
        while (s.size() <= t) {
            s[a[j]]++;
            j++;
            if (j == n) j = 0;
        }
        ans[i] = j - 1;
        if (ans[i] == -1) ans[i] += n;
        s[a[i]]--;
        if (s[a[i]] == 0) s.erase(a[i]);
    }
    vi was(n);
    int ind = 0;
    was[ind] = 1;
    int cnt = 1;
    while (!was[ans[ind]]) {
        cnt++;
        ind = ans[ind];
        was[ind] = 1;
    }
    was.assign(n, 0);
    int dobr = cnt;
    cnt = 0;
    int krugs = 0;
    vi verts(n);
    while (!was[ans[ind]]) {
        cnt++;
        if (ans[ind] < ind) krugs++;
        verts[ind] = 1;
        ind = ans[ind];
        was[ind] = 1;
    }
    ind = 0;
    dobr = 0;
    while(ind < ans[ind]) {
        if (ans[ind] < ind) k--;
        dobr++;
        ind = ans[ind];
    }
    if (ans[ind] < ind) k--;
    dobr++;
    ind = ans[ind];
    int res = 0;
    res =
            ((k) / (krugs)) * cnt + dobr;
    k = ((k) % krugs);
    while (k) {
        res++;
        if (ans[ind] < ind) k--;
        ind = ans[ind];
    }
    cout << res;
}

void solve_stress(vi &zapr) {
    int n, k, t;
    //cin >> n >> k >> t;
    n = zapr[0], k = zapr[1], t = zapr[2];
    vi a(n);
    set<int> el;
    for (int i=0;i<n;i++) {
        el.insert(zapr[i + 3]);
        a[i] = zapr[i + 3];
    }
    if (el.size() <= t) {
        cout << 1;
        return;
    }
    int i = 0, j = 0;
    map<int, int> s;
    vi ans(n);
    for (i = 0; i < n; i++) {
        while (s.size() <= t) {
            s[a[j]]++;
            j++;
            if (j == n) j = 0;
        }
        ans[i] = j - 1;
        if (ans[i] == -1) ans[i] += n;
        s[a[i]]--;
        if (s[a[i]] == 0) s.erase(a[i]);
    }
    vi was(n);
    int ind = 0;
    was[ind] = 1;
    int cnt = 1;
    while (!was[ans[ind]]) {
        cnt++;
        ind = ans[ind];
        was[ind] = 1;
    }
    was.assign(n, 0);
    int dobr = cnt;
    cnt = 0;
    int krugs = 0;
    vi verts;
    while (!was[ans[ind]]) {
        cnt++;
        verts.push_back(ind);
        if (ans[ind] < ind) krugs++;
        ind = ans[ind];
        was[ind] = 1;
    }
    int res = 0;
    /*res =
            ((k) / (krugs)) * cnt + dobr - cnt;
    k = ((k) % krugs);
    ind = *min_element(verts.begin(),verts.end());*/
    ind = 0;
    while (k) {
        res++;
        if (ans[ind] < ind) k--;
        ind = ans[ind];
    }
    cout << res;
}

void solve_fast_stress(vi &zapr) {
    int n, k, t;
    //cin >> n >> k >> t;
    n = zapr[0], k = zapr[1], t = zapr[2];
    vi a(n);
    set<int> el;
    for (int i=0;i<n;i++) {
        el.insert(zapr[i + 3]);
        a[i] = zapr[i + 3];
    }
    if (el.size() <= t) {
        cout << 1;
        return;
    }
    int i = 0, j = 0;
    map<int, int> s;
    vi ans(n);
    for (i = 0; i < n; i++) {
        while (s.size() <= t) {
            s[a[j]]++;
            j++;
            if (j == n) j = 0;
        }
        ans[i] = j - 1;
        if (ans[i] == -1) ans[i] += n;
        s[a[i]]--;
        if (s[a[i]] == 0) s.erase(a[i]);
    }
    vi was(n);
    int ind = 0;
    was[ind] = 1;
    int cnt = 1;
    while (!was[ans[ind]]) {
        cnt++;
        ind = ans[ind];
        was[ind] = 1;
    }
    was.assign(n, 0);
    int dobr = cnt;
    cnt = 0;
    int krugs = 0;
    vi verts(n);
    while (!was[ans[ind]]) {
        cnt++;
        verts.push_back(ind);
        if (ans[ind] < ind) krugs++;
        verts[ind] = 1;
        ind = ans[ind];
        was[ind] = 1;
    }
    int res = 0;
    res =
            ((k) / (krugs)) * cnt + dobr - cnt;
    k = ((k) % krugs);
    ind = 0;
    while(!verts[ind]) {
        ind = ans[ind];
    }
    while (k) {
        res++;
        if (ans[ind] < ind) k--;
        ind = ans[ind];
    }
    cout << res;
}

int32_t main() {
#ifdef LOCAL
    freopen("inputf.txt", "r", stdin);
    freopen("outputf.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        /*vi z = gen();
        solve_stress(z);
        cout << '\n';
        solve_fast_stress(z);
        cout << '\n';
        for (auto i :z) cout << i << ' ';
        cout << '\n';*/
        solve_fast();
    }
    return 0;
}
