#include <bits/stdc++.h>


using namespace std;


//#define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
const ll INF = 2e9, MOD = 1e9 + 7, N = 6e5 + 100, K = 26;
mt19937 rnd(24246);
vector<int> b(N), nx(N, -1), prv(N);
vector<int> tree(4 * N);
void upd(int v, int tl, int tr, int pos, int x) {
    if (tl + 1 == tr) {
        tree[v] += x;
        return;
    }
    int tm = (tl + tr) >> 1;
    if (pos < tm)
        upd(v << 1, tl, tm, pos, x);
    else
        upd(v << 1 | 1, tm, tr, pos, x);
    tree[v] = tree[v << 1] + tree[v << 1 | 1];
}

int mx;

int get(int v, int tl, int tr, int l, int r) {
    if (l <= tl && tr <= r) {
        if (mx == 0) return -1;
        if (tree[v] < mx) {
            mx -= tree[v];
            return tr - 1;
        }
        if (tl + 1 == tr) {
            mx -= tree[v];
            return tl;
        }
        if (tree[v << 1] < mx) {
            mx -= tree[v << 1];
            return get(v << 1 | 1, (tl + tr) >> 1, tr, l, r);
        } else {
            return get(v << 1, tl, (tl + tr) >> 1, l, r);
        }
    }
    if (tl >= r || tr <= l) return -1;
    int tm = (tl + tr) >> 1;
    int mx1 = get(v << 1, tl, tm, l, r);
    return max(mx1, get(v << 1 | 1, tm, tr, l, r));
}




void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n + 1);
    set<int> ss;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        if (ss.find(a[i]) == ss.end()) {
            ss.insert(a[i]);
        }
    }

    if (ss.size() <= t) {
        cout << 1; return;
    }
    for (int i = 1; i <= n; i++) {
        a.push_back(a[i]);
    }
    map<int, int> last;
    for (int i = a.size() - 1; i > 0; i--) {
        if (last[a[i]] == 0)
            nx[i] = -1;
        else
            nx[i] = last[a[i]];
        last[a[i]] = i;
    }
    last.clear();
    for (int i = 1; i <= 2 * n; i++) {
        if (last[a[i]] == 0)
            prv[i] = -1;
        else
            prv[i] = last[a[i]];
        last[a[i]] = i;
    }
    vector<pair<int, int>> dp(2 * n + 2);
    dp[2 * n + 1] = {0, 2 * n + 1};
    for (int i = n; i <= 2 * n; i++) {
        if (prv[i] < n) {
            upd(1, 1, N, i, 1);
        }
    }

    for (int i = n; i > 0; i--) {
        mx = t + 1;
        int l = get(1, 1, N, i, 2 * n + 1) - 1;
        if (l + 1 > n) {
            dp[i] = {1, l + 1};
        } else {
            dp[i] = dp[l + 1];
            dp[i].first++;
        }
        if (nx[i - 1] != -1) {
            upd(1, 1, N, nx[i - 1], -1);
        }
        if (i != 1)
            upd(1, 1, N, i - 1, 1);
    }

    ll ans = 0, j = 1, i = 1;
    vector<int> used(n + 1);
    while (j <= k) {
        ans += dp[i].first;
        i = dp[i].second - n;
        j++;
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
