#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define debug(x) std::cerr << #x << ": " << x << '\n'

using namespace std;
typedef long long i64;

const int B = 20;

struct uniqueSet {
    set<int> s;
    multiset<int> ms;
    void add(int x) {
        s.insert(x);
        ms.insert(x);
    }
    void rem(int x) {
        ms.erase(ms.find(x));
        if (ms.find(x) == ms.end()) s.erase(x);
    }
    bool can(int x, int mxLen) {
        add(x);
        if (getLen() > mxLen) {
            rem(x);
            return false;
        }
        return true;
    }
    int getLen() {
        return (int)s.size();
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    i64 n, k, t;
    cin >> n >> k >> t;

    vector<int> a(2 * n);
    vector<int> mnt(n);
    set<int> tmp;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        tmp.insert(a[i]);
        a[i + n] = a[i];
    }

    if (tmp.size() <= t) {
        cout << "1\n";
        return 0;
    }
    uniqueSet st;
    int ptr = -1;
    vector<pair<int, int>> go(n);
    for (int i = n - 1; i > -1; --i) {
        ptr = max(ptr, i);
        st.add(a[i]);
        while (ptr + 1 < 2 * n && st.can(a[ptr + 1], t)) ++ptr;
        while (st.getLen() > t) st.rem(a[ptr--]);
        if (ptr + 1 >= n) {
            go[i] = {1, (ptr + 1) % n};
        } else {
            go[i] = {1 + go[ptr + 1].fi, go[ptr + 1].se};
        }
    }

//    for (int i = 0; i < n; ++i) {
//        debug(go[i].fi); debug(go[i].se);
//    }

//    vector<vector<pair<i64, i64>>> up(n, vector<pair<i64, i64>> (B, {0, 0}));
//    i64 ans = 0;
//    for (int i = n - 1; i > -1; --i) {
//        up[i][0] = go[i];
//        for (int j = 1; j < B; ++j) {
//            int s = up[i][j - 1].se;
//        }
//    }

    vector<bool> vis(n, 0);
    int s = 0;
    i64 ans = 0;
    int visVertices = 0;
    while (!vis[s]) {
        vis[s] = 1;
        ++visVertices;
        ans += go[s].fi;
        s = go[s].se;
    }
    ans *= (k / visVertices);
    k %= visVertices;
    for (int i = 0; i < k; ++i) {
        auto [cnt, where] = go[s];
        s = where;
        ans += cnt;
    }
    cout << ans << '\n';
}
