#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vec vector
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)x.size()
#define f first
#define s second

using pii = pair<int, int>;

const int N = 3e5 + 5;
int n, k, t, a[2 * N];
pii to[2 * N];
int uniq;
map<int, bool> was;

int T[2 * N];
map<int, int> last;

void upd(int i, int x) {
    while (i < 2 * N) {
        T[i] += x;
        i |= i + 1;
    }
}

int get(int i) {
    int res = 0;
    for (; i >= 0; i = (i & (i + 1)) - 1) {
        res += T[i];
    }
    return res;
}

void solve() {
    cin >> n >> k >> t;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (!was[a[i]]) {
            was[a[i]] = true;
            uniq++;
        }
    }
    for (int i = n; i < 2 * n; i++) {
        a[i] = a[i - n];
    }

    if (uniq <= t) {
        cout << 1;
        return;
    }

    for (int i = 2 * n - 1; i >= 0; i--) {
        if (last.find(a[i]) != last.end()) {
            upd(last[a[i]], -1);
        }
        upd(i, +1);

        int l = i, r = 2 * n;
        while (l < r) {
            int m = l + r + 1 >> 1;
            if (get(m) <= t) {
                l = m;
            } else {
                r = m - 1;
            }
        }
        to[i].s = l - i + 1;
        to[i].f = (l + 1) % n;

        last[a[i]] = i;
    }

    int p = 0;
    map<int, int> position;
    position[p] = 0;

    int cnt = -1;
    int cycle = -1;
    int idx = 0;
    while (true) {
        idx++;
        p = to[p].f;

        if (position.find(p) == position.end()) {
            position[p] = idx;
        } else {
            cnt = position[p];
            cycle = idx - position[p];
            break;
        }
    }

    int need = n * k;
    int ans = 0;
    p = 0;
    while (need > 0 && cnt > 0) {
        cnt--;
        need -= to[p].s;
        p = to[p].f;
        ans++;
    }

    if (need > 0) {
        int cnt_cycle = 0;
        int tmp = p;
        for (int i = 0; i < cycle; i++) {
            cnt_cycle += to[tmp].s;
            tmp = to[tmp].f;
        }

        int cycles = need / cnt_cycle;
        ans += cycles * cycle;
        need -= cycles * cnt_cycle;

        while (need > 0) {
            need -= to[tmp].s;
            tmp = to[tmp].f;
            ans++;
        }
    }

    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
