#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <algorithm>
#include <map>
using namespace std;
using ll = long long;
const ll INF = 1e9;
int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}
void solve() {
	ll n, k, t;
	cin >> n >> k >> t;
	vector<int>a(1);
	vector<int>h;
	set<int>dif;
	cin >> a[0];
	dif.insert(a[0]);
	for (int i = 1; i < n; ++i) {
		int x;
		cin >> x;
		if (x == a.back()) continue;
		a.push_back(x);
		h.push_back(x);
		dif.insert(x);
	}
	n = a.size();
	if (dif.size() <= t) {
		cout << "1\n";
		return;
	}
	vector<int>dist(n);
	map<int,int>cnt;
	//cout << "a: ";
	for (int i = 0; i < n; ++i) {
		cnt[a[i]]++;
		//cout << a[i] << ' ';
	}
	//cout << "\n";
	int CNT = dif.size();
	int l = n - 1, r = n - 2;
	while (l >= 0) {
		//cout << l << "   "   << r << "\n";
		while (cnt[a[r]] > 1 || CNT > t) {
			cnt[a[r]]--;
			if (cnt[a[r]] == 0) --CNT;
			--r;
			r = (r + n) % n;
			//cout << "!! "<<r << ' ' << CNT << "\n";
		}
		dist[l] = r;
		--l;
		if (l >= 0) {
			cnt[a[l]]++;
			if (cnt[a[l]] == 1) ++CNT;
		}
	}
	if (a[n - 1] == a[0]) dist[n - 1] = dist[0];
	vector<int>used(n);
	vector<int>C(n);
	int cur = 0;
	int c = 0;
	int point = 1;
	int ans = 0;
	/*cout << "dist "; for (auto x : dist) cout << x << ' ';
	cout << "\n";*/
	while (c < k && !used[cur]) {
		//cout << cur << ' ' << c << "\n";
		
		used[cur] = point++;
		C[cur] = c;
		if ((dist[cur] + 1) % n < cur) {
			++c;
		}
		cur = (dist[cur] + 1) % n;
	}
	
	/*cout << "used "; for (auto x : used) cout << x << ' ';
	cout << "\n";
	cout << "C "; for (auto x : C) cout << x << ' ';
	cout << "\n";
	cout << cur << ' ' << point << "\n";*/
	if (c == k) {
		cout << point - 1;
	}
	else {
		cout << point - 1 + (k - c) * (point - used[cur]) / (c - C[cur]) << "\n";
		
	}

}

int main() {
	int t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}

	
}
