#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <algorithm>
#include <map>
using namespace std;
using ll = long long;
const ll INF = 1e9;
ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}
void solve() {
	ll n, k, t;
	cin >> n >> k >> t;
	vector<ll>a(1);
	vector<ll>h;
	set<ll>dif;
	cin >> a[0];
	dif.insert(a[0]);
	for (ll i = 1; i < n; ++i) {
		ll x;
		cin >> x;
		if (x == a.back()) continue;
		a.push_back(x);
		h.push_back(x);
		dif.insert(x);
	}
	n = a.size();
	if (dif.size() <= t) {
		cout << "1\n";
		return;
	}
	vector<ll>dist(n);
	map<ll,ll>cnt;
	//cout << "a: ";
	for (ll i = 0; i < n; ++i) {
		cnt[a[i]]++;
		//cout << a[i] << ' ';
	}
	//cout << "\n";
	ll CNT = dif.size();
	ll l = n - 1, r = n - 2;
	while (l >= 0) {
		//cout << l << "   "   << r << "\n";
		while (cnt[a[r]] > 1 || CNT > t) {
			cnt[a[r]]--;
			if (cnt[a[r]] == 0) --CNT;
			--r;
			r = (r + n) % n;
			//cout << "!! "<<r << ' ' << CNT << "\n";
		}
		dist[l] = r;
		--l;
		if (l >= 0) {
			cnt[a[l]]++;
			if (cnt[a[l]] == 1) ++CNT;
		}
	}
	if (a[n - 1] == a[0]) {
		dist[n - 1] = dist[0];
		for (ll i = n - 1; i >= 0; --i) {
			if (dist[i] == n - 1) dist[i] = 0;
		}
	}
	vector<ll>used(n);
	vector<ll>C(n);
	ll cur = 0;
	ll c = 0;
	ll poll = 1;
	ll ans = 0;
	//cout << "dist "; for (auto x : dist) cout << x << ' ';
	//cout << "\n";
	while (c < k && !used[cur]) {
		//cout << cur << ' ' << c << "\n";
		
		used[cur] = poll++;
		C[cur] = c;
		if ((dist[cur] + 1) % n <= cur) {
			++c;
		}
		cur = (dist[cur] + 1) % n;
	}
	
	//cout << "used "; for (auto x : used) cout << x << ' ';
	//cout << "\n";
	//cout << "C "; for (auto x : C) cout << x << ' ';
	//cout << "\n";
	//cout << cur << ' ' << poll << ' '<<c<<"\n";
	if (c == k) {
		cout << poll - 1;
	}
	else {
		cout << poll - 1 + (k - c) * (poll - used[cur]) / (c - C[cur]) << "\n";
		
	}

}

int main() {
	ll t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}

	
}
