#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    cin >> a;
    set<int> aa(a.begin(), a.end());
    if (t >= aa.size()) {
        cout << "1\n";
        return 0;
    }
    vector<pair<int, int>> nxt(n);
    for (int i = 0; i < n; ++i) {
        int j = i;
        set<int> cur;
        while (true) {
            cur.insert(a[j]);
            if (cur.size() > t) {
                break;
            }
            ++j;
            j %= n;
        }
        if (j < i) {
            ++nxt[i].second;
        }
        nxt[i].first = j;
    }
    int ans = 0;
    int cur = 0;
    int i = 0;
    while (cur < k) {
        cur += nxt[i].second;
        i = nxt[i].first;
        ++ans;
    }
    cout << ans << "\n";
}
