#define _CRT_SECURE_NO_WARNINGS

#pragma gcc optimise("Ofast")
#pragma gcc optimise("unswith-loops")
#pragma gcc optimise("unroll-loops")
#pragma gcc optimise("no-stack-protector")
#pragma gcc optimise("fast-math")
#pragma gcc optimise("rename-registers")

#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cassert>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

#define walk(v) v.begin(), v.end()
#define sz(v) (int)v.size()

vector<int> arr;

void solve_t_one(int n, int k, int t) {
	vector<int> uniq;
	uniq.push_back(arr[0]);
	for (int i = 1; i < n; i++)
		if (uniq.back() != arr[i])
			uniq.push_back(arr[i]);
	n = sz(uniq);
	if (uniq[0] == uniq.back())
		cout << (k - 1) * (n - 1) + n;
	else
		cout << n * k;
}

void solve_nk(int n, int k, int t) {
	vector<int> full;
	for (int i = 0; i < k; i++)
		for (int j = 0; j < n; j++)
			full.push_back(arr[j]);
	set<int> cur;
	int ans = 0;
	for (int i : full) {
		cur.insert(i);
		if (sz(cur) > t) {
			ans++;
			cur.clear();
			cur.insert(i);
		}
	}
	ans++;
	cout << ans;
}

void solve() {
	int n, k, t;
	cin >> n >> k >> t;
	arr.resize(n);
	for (int i = 0; i < n; i++)
		cin >> arr[i];
	if (n == 1) {
		cout << 1;
		return;
	}
	if (t == 1)
		solve_t_one(n, k, t);
	else
		solve_nk(n, k, t);

}

signed main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	ios_base::sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	solve();
}