//#pragma GCC optimize("03,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve() {
    int n, k, t;
    std::cin >> n >> k >> t;
    std::vector<int> a(n);
    std::unordered_set<int> nums;
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
        nums.insert(a[i]);
    }
    if (int(nums.size()) <= t) {
        std::cout << 1 << "\n";
        return;
    }
    std::vector<int> next(n, -1);
    std::unordered_map<int, int> cnt;
    int r = -1;
    for (int l = 0; l < n; l++) {
        while (int(cnt.size()) <= t) {
            r = (r + 1) % n;
            cnt[a[r]]++;
            if (int(cnt.size()) > t) {
                cnt[a[r]]--;
                if (!cnt[a[r]]) {
                    cnt.erase(a[r]);
                }
                r = (r - 1 + n) % n;
                break;
            }
        }
        next[l] = r;
        cnt[a[l]]--;
        if (!cnt[a[l]]) {
            cnt.erase(a[l]);
        }
    }
    std::vector<i64> ans(n, -1);
    std::vector<int> lap(n, -1);
    i64 cur_ans = 0;
    int pos = 0, cur_lap = 0;
    while (true) {
        if (ans[pos] == -1) {
            ans[pos] = cur_ans;
            lap[pos] = cur_lap;
            int next_pos = (next[pos] + 1) % n;
            cur_ans++;
            if (next_pos <= pos && cur_lap == k - 1) {
                std::cout << cur_ans << "\n";
                return;
            }
            if (next_pos <= pos) {
                cur_lap++;
            }
            pos = next_pos;
        } else {
            i64 per_lap = cur_ans - ans[pos];
            int laps = (k - 1 - cur_lap) / (cur_lap - lap[pos]);
            int after_lap = cur_lap + (k - 1 - cur_lap) / (cur_lap - lap[pos]) * (cur_lap - lap[pos]);
            cur_ans += per_lap * laps;
            cur_lap = after_lap;
            break;
        }
    }
    while (true) {
        int next_pos = (next[pos] + 1) % n;
        cur_ans++;
        if (next_pos <= pos && cur_lap == k - 1) {
            std::cout << cur_ans << "\n";
            return;
        }
        if (next_pos <= pos) {
            cur_lap++;
        }
        pos = next_pos;
    }
}

signed main() {
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);

    int t = 1;
//    std::cin >> t;

    while (t--) {
        solve();
    }
}