#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;
//--------------------------------------------------------------//
#define int long long
#define pii pair<int, int>
#define ft first
#define sd second
/*
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimization("Ofast")
*/
#define file_in freopen("input.txt", "r", stdin)
#define file_out freopen("output.txt", "w", stdout)
#define fast                      \
    ios_base::sync_with_stdio(0); \
    cin.tie(0);                   \
    cout.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(15)
//-------------------------------------------------------------------//
typedef long long ll;
typedef long double ld;
typedef tree<int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update> ordered_set;
//--------------------------------------------------------------------//

const int MAX = 3e5 + 10;
vector<int> cnt(MAX, 0);
int ans = 0;

void add(int val) {
    if (cnt[val] == 0) ++ans;
    ++cnt[val];
}

void del(int val) {
    if (cnt[val] == 1) --ans;
    --cnt[val];
}

signed main() {
    fast;
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    set<int> alltypes;
    for (int i = 0; i < n; ++i) alltypes.insert(a[i]);
    if ((int)alltypes.size() <= t) {
        cout << "1\n";
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        a[i] = distance(alltypes.begin(), lower_bound(alltypes.begin(), alltypes.end(), a[i]));
    }
    vector<int> b(2 * n);
    for (int i = 0; i < n; ++i) {
        b[i] = a[i];
        b[n + i] = a[i];
    }

    vector<int> follower(n);
    int left = 0, right = 1;
    add(b[0]);
    for (int i = 0; i < n; ++i) {
        if (i != 0) {
            del(b[left]);
            ++left;
        }
        while (ans <= t) {
            add(b[right]);
            ++right;
        }
        del(b[right - 1]);
        --right;
        follower[i] = right;
    }

    set<int> travels;
    int cur_top = 1;
    int cur_x = 0;
    int am = 0;
    while (cur_top <= k && travels.find(cur_x) == travels.end()) {
        travels.insert(cur_x);
        ++am;
        if (follower[cur_x] >= n) {
            ++cur_top;
            cur_x = follower[cur_x] - n;
        } else {
            cur_x = follower[cur_x];
        }
    }
    if (cur_top > k) {
        cout << am << "\n";
        return 0;
    }

    int cctop = 1;
    int ccam = 0;
    int ccx = 0;
    while (ccx != cur_x) {
        ++ccam;
        if (follower[ccx] >= n) {
            ++cctop;
            ccx = follower[ccx] - n;
        } else {
            ccx = follower[ccx];
        }
    }
    int delta_top = cur_top - cctop;
    int delta_am = am - ccam;
    int Cycles = (k - cctop) / delta_top;
    int ans = ccam + delta_am * Cycles;


    int FFtop = Cycles * delta_top + cctop;
    int FFam = 0;
    int FFx = cur_x;
    while (FFtop <= k) {
        ++FFam;
        if (follower[FFx] >= n) {
            ++FFtop;
            FFx = follower[FFx] - n;
        } else {
            FFx = follower[FFx];
        }
    }
    ans += FFam;
    cout << ans << "\n";

    return 0;
}
