// #define __GLIBCXX_DEBUG
// #pragma target("avx,avx2,bmi,bmi2,lzcnt,popcnt")
// #pragma optimize("unroll-loops,O3")

#include <vector>
#include <set>
#include <map>
#include <functional>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <iostream>
#include <algorithm>
#include <array>
#include <string>
#include <tuple>
#include <random>
#include <numeric>
#include <mutex>
#include <memory>
#include <locale>
#include <list>
#include <limits>
#include <iterator>
#include <functional>
#include <format>
#include <exception>
#include <ctime>
#include <ctgmath>
#include <cwchar>
#include <complex>
#include <bit>
#include <bitset>
#include <cassert>
#include <chrono>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
const int MAXLG = 50;
mt19937_64 rnd(179);

signed main() {
    // ios_base::sync_with_stdio(false);
    // cin.tie(nullptr);

    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int& i : a) cin >> i;
    vector<int> b = a;
    sort(b.begin(), b.end());
    b.resize(unique(b.begin(), b.end()) - b.begin());
    for (int i = 0; i < n; i++) {
        a[i] = lower_bound(b.begin(), b.end(), a[i]) - b.begin();
    }

    // cout << "A: ";
    // for (int i = 0; i < n; i++) cout << a[i] << " ";
    // cout << endl << endl;

    if (b.size() <= t) {
        cout << 1;
        return 0;
    }

    vector<int> cntEl(b.size(), 0);
    vector<int> next(n, -1);
    int cntDif = 0;
    int fl = 0;
    for (int i = 0; i < n; i++) {
        while (cntDif <= t) {
            cntEl[a[fl]]++;
            if (cntEl[a[fl]] == 1) cntDif++;
            fl = (fl + 1) % n;
        }
        next[i] = (fl + n - 1) % n;
        cntEl[a[i]]--;
        if (cntEl[a[i]] == 0) cntDif--;
    }

    vector<vector<pair<int, ll>>> binUp(MAXLG, vector<pair<int, ll>> (n, {-1, -1}));
    for (int i = 0; i < n; i++) {
        if (next[i] <= i) binUp[0][i].second = 1;
        else binUp[0][i].second = 0;
        binUp[0][i].first = next[i];
    }
    for (int lg = 1; lg < MAXLG; lg++) {
        for (int i = 0; i < n; i++) {
            binUp[lg][i].second = binUp[lg - 1][i].second + binUp[lg - 1][binUp[lg - 1][i].first].second;
            binUp[lg][i].first = binUp[lg - 1][binUp[lg - 1][i].first].first;
            // if (binUp[lg - 1][i].first >= binUp[lg - 1][i].first) binUp[lg][i].second++;
        }
    }

    // for (int lg = 0; (1 << lg) <= n; lg++) {
    //     cout << "lg " << lg << ": ";
    //     for (int i = 0; i < n; i++) {
    //         cout << binUp[lg][i].first << " " << binUp[lg][i].second << "  ";
    //     }
    //     cout << endl;
    // }
    // return 0;


    ll l = 0, r = 1ll * n * k + 100;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        ll cnt = 0;
        ll mm = m;
        int v = 0;
        for (int lg = MAXLG - 1; lg >= 0; lg--) {
            if ((1ll << lg) <= mm) {
                cnt += binUp[lg][v].second;
                v = binUp[lg][v].first;
                mm -= (1ll << lg);
            }
        }
        if (cnt >= k) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r;
}