// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx,avx2")

#include <bits/stdc++.h>
using namespace std;

#define int long long

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    set<int> st;
    for (int i = 0; i < n; i++) cin >> a[i], st.insert(a[i]);
    if (st.size() <= t) {
        cout << 1;
        return;
    }

    a.insert(a.end(), a.begin(), a.end());
    vector<int> to(n);
    vector<vector<int>> in(n);
    for (int i = 0; i < n; i++) {
        st.clear();
        for (int j = i; j < 2*n; j++) {
            st.insert(a[j]);
            if (st.size() > t) {
                to[i] = j;
                if (to[i] >= n) to[i] -= n;
                in[to[i]].push_back(i);
                break;
            }
        }
    }

    vector<int> d(n, -1);
    queue<int> q;
    for (int i = 0; i < n; i++) {
        if (to[i] < i) {
            q.push(i);
            d[i] = 1;
        }
    }

    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u : in[v]) {
            if (d[u] != -1) continue;
            d[u] = d[v] + 1;
            to[u] = to[v];
            q.push(u);
        }
    }

    int cur = 0;
    int ans = 0;
    for (int i = 0; i < k; i++) {
        ans += d[cur];
        cur = to[cur];
    }

    cout << ans;
}

signed main() {
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve(), cout << '\n';
}