#pragma GCC optimize("03")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-online")
#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <random>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<long long, long long>;

struct el {
    int v, l, r;
    explicit el(int v1 = 0, int l1 = 0, int r1 = 0) {
        v = v1, l = l1, r = r1;
    }
};

vector<el> segs;

const int max_n = 3e5;

vector<int> tv[max_n * 8 + 10];

struct mst {
    // vector<vector<int>> tree;
    vector<int> a;
    mst(vector<int> a1) {
        a = a1;
        //tree.resize(4 * a.size() + 3);
    }
    void build(int v, int l, int r) {
        if (r - l == 1) {
            tv[v] = {a[l]};
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        int id1 = 0, id2 = 0;
        int sz1 = tv[2 * v + 1].size(), sz2 = tv[2 * v + 2].size();
        while (id1 < sz1 && id2 < sz2) {
            if (tv[2 * v + 1][id1] < tv[2 * v + 2][id2]) {
                tv[v].push_back(tv[2 * v + 1][id1]);
                id1++;
            } else {
                tv[v].push_back(tv[2 * v + 2][id2]);
                id2++;
            }
        }
        for (int i = id1; i < sz1; i++) {
            tv[v].push_back(tv[2 * v + 1][i]);
        }
        for (int i = id2; i < sz2; i++) {
            tv[v].push_back(tv[2 * v + 2][i]);
        }
    }
    void split(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) {
            segs.emplace_back(v, l, r);
            return;
        }
        if (qr <= l || r <= ql) {
            return;
        }
        int m = (l + r) / 2;
        if (!(m <= ql))
            split(2 * v + 1, l, m, ql, qr);
        if (!(qr <= m))
            split(2 * v + 2, m, r, ql, qr);
    }
    int calc(int v, int x) {
        int l = -1, r = tv[v].size();
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (tv[v][m] <= x) {
                l = m;
            } else {
                r = m;
            }
        }
        return r;
    }
    int spusk(int v, int l, int r, int mn, int x) {
        if (r - l == 1) {
            return l;
        }
        int m = (l + r) / 2;
        int temp = calc(2 * v + 1, mn);
        if (temp >= x) {
            return spusk(2 * v + 1, l, m, mn, x);
        } else {
            return spusk(2 * v + 2, m, r, mn, x - temp);
        }
    }
};

vector<int> compr(vector<int> a) {
    int n = a.size();
    vector<int> b = a;
    std::sort(b.begin(), b.end());
    vector<int> res;
    for (int i = 0; i < n; i++) {
        int l = -1, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (b[m] <= a[i]) {
                l = m;
            } else {
                r = m;
            }
        }
        res.push_back(l);
    }
    return res;
}

void solve() {
    ll n, k, t; cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (1) {
        vector<int> b = {a[0]};
        for (int i = 1; i < n; i++) {
            if (a[i] != b.back()) {
                b.push_back(a[i]);
            }
        }
        a = b;
        n = a.size();
    }
    for (int i = 0; i < n; i++) {
        a.push_back(a[i]);
    }
    if (1) {
        set<int> s;
        for (int i = 0; i < n; i++) {
            s.insert(a[i]);
        }
        if (s.size() <= t) {
            cout << 1;
            return;
        }
    }
    a = compr(a);
    vector<int> pr(2 * n);
    int pos[2 * n + 10];
    for (int i = 0; i < 2 * n + 10; i++) {
        pos[i] = -1;
    }
    for (int i = 0; i < 2 * n; i++) {
        pr[i] = pos[a[i]];
        pos[a[i]] = i;
    }
    mst tree(pr);
    tree.build(0, 0, 2 * n);
    pll id[n];
    for (int i = 0; i < n; i++) {
        id[i] = {-2, -2};
    }
    int temp = 0;
    id[0] = {0, 0};
    ll cnt = 0;
    ll len = 0;
    int opr = 0;
    int biba = 0;
    id[0] = {-1, 0};
    for (ll i = 0; i > -1; i++) {
        opr++;
        if (opr > 4 * n) throw;
        int ql = temp, qr = temp + n;
        segs = {};
        tree.split(0, 0, 2 * n, ql, qr);
        int x = t + 1;
        for (auto j : segs) {
            int y = tree.calc(j.v, temp - 1);
            if (y >= x) {
                int oc = temp;
                int b = tree.spusk(j.v, j.l, j.r, temp - 1, x);
                len += b - temp;
                temp = b % n;
                if (len >= n * k) {
                    cout << i + 1;
                    return;
                }
                if (id[temp].first != -2 && biba < 1) {
                    biba++;
                    ll res = i;
                    ll tl = len - id[temp].second;
                    ll tfoppers = i - id[temp].first;
                    res += max(((k * n - len) / tl) - 0, 1ll * 0) * tfoppers;
                    len += max(((k * n - len) / tl) - 0, 1ll * 0) * tl;
                    if (len >= k * n) {
                        cout << res + 1;
                        return;
                    }
                    i = res;
                } else {
                    id[temp] = {i, len};
                }
                break;
            }
            x -= y;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
