#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize "O3"
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <random>
#include <time.h>
#define all(a) a.begin(), a.end()
#define int long long
#define endl '\n'

using namespace std;

int prb(int n, int k, int t, vector<int> &L){
    if (n == 0 || k == 0 || t == 0)return 1;
    set<int> unq;
    vector<int> nw = {L[0]};
    for (auto &i : L){
        unq.insert(i);
        if (i == nw.back())continue;
        nw.push_back(i);
    }
    map<pair<int, int>, int> hd;
    int l = 0, r = 0;
    set<int> qw;
    if (unq.size() <= t){
        return 1;
    }
    n = signed(nw.size());
    vector<int> tg(n);
    map<int, int> cnt;
    int res = 0;
    int ind = 0;
    for (int i = 0; i < n; i++){
        while (res <= t){
            if (cnt[nw[ind]] == 0){
                res++;
            }
            cnt[nw[ind]]++;
            ind++;
            if (ind == n)ind = 0;
        }
        tg[i] = ind - 1;
        if (tg[i] == -1)tg[i] = n - 1;
        cnt[nw[i]]--;
        if (cnt[nw[i]] == 0)res--;
    }
    map<int, pair<int, int>> us;
    int cn = 0;
    int ans = 0;
    bool fl = 1;
    while (k != 0){
        int nx = tg[cn];
        if (cn > nx) {
            k--;
        }
        cn = nx;
        ans++;
    }
    return ans;
}

int solve(int n, int k, int t, vector<int> &L){
    if (n == 0 || k == 0 || t == 0)return 1;
    set<int> unq;
    vector<int> nw = {L[0]};
    for (auto &i : L){
        unq.insert(i);
        if (i == nw.back())continue;
        nw.push_back(i);
    }
    map<pair<int, int>, int> hd;
    int l = 0, r = 0;
    set<int> qw;
    if (unq.size() <= t){
        return 1;
    }
    n = signed(nw.size());
    vector<int> tg(n);
    map<int, int> cnt;
    int res = 0;
    int ind = 0;
    for (int i = 0; i < n; i++){
        while (res <= t){
            if (cnt[nw[ind]] == 0){
                res++;
            }
            cnt[nw[ind]]++;
            ind++;
            if (ind == n)ind = 0;
        }
        tg[i] = ind - 1;
        if (tg[i] == -1)tg[i] = n - 1;
        cnt[nw[i]]--;
        if (cnt[nw[i]] == 0)res--;
    }
    map<pair<int, int>, pair<int, int>> us;
    int cn = 0;
    int ans = 0;
    bool fl = 1;
    int st = k;
    int fr = -1;
    while (k != 0){
        int nx = tg[cn];
        if (us.find({fr, cn}) != us.end() && fl && us[{fr, cn}].first != st) {
            int dl = us[{fr, cn}].first - k;
            int db = ans - us[{fr, cn}].second;
            //cout << cn << ' ' << dl << ' ' << db << ' ' << ans << ' ' << k << endl;
            if (k > dl) {
                ans += (k / dl) * db;
                k %= dl;
                fl = 0;
                if (k == 0)break;
            }
        }
        us[{fr, cn}] = {k, ans};
        if (cn > nx) {
            k--;
        }
        fr = cn;
        cn = nx;
        ans++;
    }
    return ans;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
    //cin >> tt;
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> L(n);
    for (auto &i : L)cin >> i;
    if (t == 1){
        cout << solve(n, k, t, L);
    }
    else{
        cout << prb(n, k, t, L);
    }
}