// In the name of Allah

#include <bits/stdc++.h>
using namespace std;

typedef		long long			ll;
typedef		long double			ld;
typedef		pair<int, int>		pii;
typedef		pair<ll, ll>		pll;

#define		endl				'\n'
#define		sep					' '
#define		all(x)				(x).begin(),(x).end()
#define		len(x)				((ll) (x).size())
#define		F					first
#define		S					second
#define		Mp					make_pair
#define		pb					push_back

int n; ll kx, tx;
const int maxn = 3e5 + 4;
const int maxs = (1 << 20) + 4;
const int maxlg = 60;
const ll oo = 1e18 + 7;
ll a[maxs]; vector<ll> arr;
int ind[maxs], val[maxs]; ll t[2 * maxs];
__int128 res[maxlg][maxn];
ll ans = 0; __int128 A[maxn];

int GI(ll x) {
	return lower_bound(all(arr), x) - arr.begin();
}

void add_val(int v, int tl, int tr, int i, ll x) {
	if (i >= tr || i < tl) return ;
	if (tr - tl == 1) {
		t[v] += x;
		return ;
	}
	int mid = (tl + tr) / 2;
	if (i < mid) add_val(2 * v + 1, tl, mid, i, x);
	else add_val(2 * v + 2, mid, tr, i, x);
	t[v] = t[2 * v + 1] + t[2 * v + 2];
}

int get_ind(int v, int tl, int tr, ll x) {
	if (t[v] < x) return tr;
	if (tr - tl == 1) return tl;

	int mid = (tl + tr) / 2;
	if (t[2 * v + 1] >= x) return get_ind(2 * v + 1, tl, mid, x);
	else return get_ind(2 * v + 2, mid, tr, x - t[2 * v + 1]);
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	cin >> n >> kx >> tx;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		arr.pb(a[i]);
	}
	sort(all(arr)); arr.resize(unique(all(arr)) - arr.begin());

	for (int i = 0; i < n; i++) a[i] = GI(a[i]);
	for (int i = n; i < 2 * n; i++) a[i] = a[i - n];

	fill(ind, ind + n, -1);
	for (int i = 2 * n - 1; i >= 0; i--) {
		if (ind[a[i]] != -1) add_val(0, 0, 2 * n, ind[a[i]], -1);
		ind[a[i]] = i;
		add_val(0, 0, 2 * n, ind[a[i]], 1);
		if (i < n) {
			val[i] = get_ind(0, 0, 2 * n, tx + 1);
			if (val[i] == 2 * n) {
				cout << 1 << endl;
				return 0;
			}
			val[i] -= i;
		}
	}

	for (int i = 0; i < n; i++) res[0][i] = val[i];
	for (int j = 1; j < maxlg; j++) {
		for (int i = 0; i < n; i++) {
			int r = (i + res[j - 1][i]) % n;
			res[j][i] = (res[j - 1][i] + res[j - 1][r]);
		}
	}

	ans = 1;
	for (int i = 0; i < n; i++) A[i] = 0;
	for (int j = maxlg - 1; j >= 0; j--) {
		int r = A[0] % n;
		if (A[0] + res[j][r] >= kx * n) continue;

		ans += (1ll << j);
		for (int i = 0; i < n; i++) {
			int r = (i + A[i]) % n;
			A[i] = (A[i] + res[j][r]);
		}
	}
	cout << ans << endl;

	return 0;
}