#include <bits/stdc++.h>
#define FOR(a, b, c) for (int a = (b); a < (c); ++a)
#define int long long
using namespace std;

const int N = 3e5 + 50, LG = 60;
const long long INF = 1ll << 60;

int t, n, k, a[2 * N], b[N], ed[LG][N], W[LG][N], cnt[N];


signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> k >> t;
	FOR(i, 0, n) cin >> a[i];

	copy(a, a + n, b);
	sort(b, b + n);
	FOR(i, 0, n) a[i] = lower_bound(b, b + n, a[i]) - b;
	FOR(i, n, 2 * n) a[i] = a[i - n];

	int dist = 0, ptr = 2 * n - 1;
	FOR(i, n, 2 * n) {
		dist += !cnt[a[i]];
		++cnt[a[i]];
	}
	if (dist <= t) {
		cout << 1 << '\n';
		return 0;
	}
	for (int i = n - 1; i >= 0; --i) {
		dist += !cnt[a[i]];
		++cnt[a[i]];
		while (dist > t) {
			--cnt[a[ptr]];
			dist -= !cnt[a[ptr]];
			--ptr;
		}
		ed[0][i] = (ptr + 1) % n;
		W[0][i] = ptr - i + 1;
	}

	FOR(l, 0, LG - 1) {
		FOR(i, 0, n) {
			W[l + 1][i] = min(INF, W[l][i] + W[l][ed[l][i]]);
			ed[l + 1][i] = ed[l][ed[l][i]];
		}
	}

	int total = n * k, ans = 0, cur = 0;
	for (int l = LG - 1; l >= 0; --l) {
		if (W[l][cur] < total) {
			total -= W[l][cur];
			cur = ed[l][cur];
			ans += 1ll << l;
		}
	}
	while (total > 0) {
		total -= W[0][cur];
		cur = ed[0][cur];
		++ans;
	}
	cout << ans << '\n';

	return 0;
}

