#include <algorithm>
#include <assert.h>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <deque>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;

void solve() {
	int n;
	cin >> n;

	vector<int> w(n);
	for (int i = 0; i < n; i++)
		cin >> w[i];

	if (n == 3) {
		if (w[2] >= w[0] + w[1]) {
			cout << w[2] << ' ' << w[0] + w[1];
		}
		else {
			cout << w[0] + w[1] << ' ' << w[2];
		}
		return;
	}

	int a = 0, b = 0, ta = 0, tb = 0;
	for (int i = n - 1; i >= 0; i--) {
		if (ta == 0) {
			a += w[i];
			ta += w[i];
		}
		else if (tb == 0) {
			b += w[i];
			tb += w[i];
		}
		else {
			if (ta == tb) {
				a += w[i];
				ta = w[i];
				tb = 0;
			}
			else if (ta > tb) {
				ta -= tb;
				tb = w[i];
				b += w[i];
			}
			else {
				tb -= ta;
				ta = w[i];
				a += w[i];
			}
		}
	}

	cout << a << ' ' << b;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	srand(time(0));
	ignore = rand();
	random_device rd;
	mt19937 gen(rd());
	uniform_int_distribution<> ran(1, INT_MAX);
	ignore = ran(gen);

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}
