#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<cassert>
#include<unordered_map>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define girlfriend friend

template<typename T>
bool assign_min(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream& out, std::pair<T, F> a) {
    return out << a.first << " " << a.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, b1 = 31, b2 = 29, MAXN = 1e5;
const long double eps = 1e-9;

void solve() {
    int n; cin >> n;
    vector<int> a(n); input(a);
    vector<vector<vector<vector<pair<int, int>>>>> dp(n, vector<vector<vector<pair<int, int>>>> (n, vector<vector<pair<int, int>>> (20001, vector<pair<int, int>> (2, {-inf, -inf}))));
    for (int l = 0; l<n; ++l) {
        for (int i = 0; i<=20000; ++i) {
            dp[l][l][i][0] = {a[l], 0};
            dp[l][l][i][1] = {0, a[l]};
        }
        for (int r = l+1; r<n; ++r) {
            for (int i = 0; i<=20000; ++i) {
                if (i > a[r]) {
                    pair<int, int> p1 = dp[l][r-1][i-a[r]][0], p2 = dp[l][r-1][i-a[r]][1];
                    dp[l][r][i][0] = {p1.first + a[r], p1.second};
                    dp[l][r][i][1] = {p2.first, p2.second + a[r]};
                } else if (i < a[r]) {
                    pair<int, int> p1 = dp[l][r-1][a[r]-i][1], p2 = dp[l][r-1][a[r]-i][0];
                    dp[l][r][i][0] = {p1.first + a[r], p1.second};
                    dp[l][r][i][1] = {p2.first, p2.second + a[r]};
                } else {
                    pair<int, int> p = dp[l][r-1][0][0];
                    dp[l][r][i][0] = {p.first + a[r], p.second};
                    dp[l][r][i][1] = {p.first, p.second + a[r]};
                }
                if (i > a[l]) {
                    pair<int, int> p1 = dp[l+1][r][i-a[l]][0], p2 = dp[l+1][r][i-a[l]][1];
                    if (p1.first + a[l] > dp[l][r][i][0].first) {
                        dp[l][r][i][0] = {p1.first + a[l], p1.second};
                    }
                    if (p2.second + a[l] > dp[l][r][i][1].second) {
                        dp[l][r][i][1] = {p2.first, p2.second + a[l]};
                    }
                } else if (i < a[l]) {
                    pair<int, int> p1 = dp[l+1][r][a[l]-i][1], p2 = dp[l+1][r][a[l]-i][0];
                    if (p1.first + a[l] > dp[l][r][i][0].first) {
                        dp[l][r][i][0] = {p1.first + a[l], p1.second};
                    }
                    if (p2.second + a[l] > dp[l][r][i][1].second) {
                        dp[l][r][i][1] = {p2.first, p2.second + a[l]};
                    }
                } else {
                    pair<int, int> p = {dp[l+1][r][0][0]};
                    if (p.first + a[l] > dp[l][r][i][0].first) {
                        dp[l][r][i][0] = {p.first + a[l], p.second};
                    }
                    if (p.second + a[l] > dp[l][r][i][1].second) {
                        dp[l][r][i][1] = {p.first, p.second + a[l]};
                    }
                }
            }
        }
    }
    cout << dp[0][n-1][0][0] << '\n';
}

void stupid_solve() {
    int n; cin >> n;
    vector<int> a(n); input(a);
    if (a[2] > a[0] + a[1]) {
        cout << a[2] << " " << a[0] + a[1] << '\n';
    } else {
        cout << a[0] + a[1] << " " << a[2] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; //cin >> t;
    while (t--) stupid_solve();
    return 0;
}

//fft