#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

//#define int long long
const int N = 2000;
int M = 20000;
unordered_map<int, pair<int, int>> dp[N][N];
pair<int, int> g;
vector<int> a;
int n;

void rec(int l, int r, int w) {
    if (dp[l][r][w] != g || l - 1 == r) {
        return;
    }
    if (l == r) {
        if (w <= M) {
            dp[l][r][w] = {a[l], 0};
        } else {
            dp[l][r][w] = {0, a[l]};
        }
        return;
    }
    if (w <= M) {
        rec(l + 1, r, w + a[l]);
        rec(l, r - 1, w + a[r]);
        if (dp[l + 1][r][w + a[l]].first + a[l] > dp[l][r - 1][w + a[r]].first + a[r] ||
            (dp[l + 1][r][w + a[l]].first + a[l] == dp[l][r - 1][w + a[r]].first + a[r] &&
             dp[l + 1][r][w + a[l]].second >= dp[l][r - 1][w + a[r]].second)) {
            dp[l][r][w] = {dp[l + 1][r][w + a[l]].first + a[l], dp[l + 1][r][w + a[l]].second};
        } else {
            dp[l][r][w] = {dp[l][r - 1][w + a[r]].first + a[r], dp[l][r - 1][w + a[r]].second};
        }
    } else {
        rec(l + 1, r, w - a[l]);
        rec(l, r - 1, w - a[r]);
        if (dp[l + 1][r][w - a[l]].second + a[l] > dp[l][r - 1][w - a[r]].second + a[r] ||
            (dp[l + 1][r][w - a[l]].second + a[l] == dp[l][r - 1][w - a[r]].second + a[r] &&
             dp[l + 1][r][w - a[l]].first >= dp[l][r - 1][w - a[r]].first)) {
            dp[l][r][w] = {dp[l + 1][r][w - a[l]].first, dp[l + 1][r][w - a[l]].second + a[l]};
        } else {
            dp[l][r][w] = {dp[l][r - 1][w - a[r]].first, dp[l][r - 1][w - a[r]].second + a[r]};
        }
    }
}

signed main() {
    fast_in_out();
    cin >> n;
    a.resize(n);
    int W = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        W += a[i];
    }
    M = W;
    rec(0, n - 1, M);
    cout << dp[0][n - 1][M].first << ' ' << dp[0][n - 1][M].second;
    return 0;
}
