#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;
using ll = long long;
using ull = unsigned long long;

const int nMax = 3e5 + 228;


using dd = tree<pair<int, int>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
ll a[nMax];
unordered_map<int, pair<int, int>> dp[2001][2001][2];

pair<int, int> solve(int l, int r, int al, int t) {
    if (l > r)return {0, 0};
    auto it = dp[l][r][al].find(t);
    if (it != dp[l][r][al].end())return it->second;
    int best = l - 1;
    ll tryS = 0;
    while (best + 1 <= r && (tryS + a[best + 1] < t || (tryS + a[best + 1] <= t && !al))) {
        tryS += a[++best];
    }
    if (best != r)tryS += a[++best];
    if (best == r) {
        return {tryS, 0};
    }
    pair<int, int> bestt = {0, 0};
    {
        int t2 = t - a[l];
        pair<int, int> rr;
        if (t2 > 0 || (t2 == 0 && al == 0)) {
            rr = solve(l + 1, r, al, t2);
        } else {
            rr = solve(l + 1, r, al ^ 1, -t2);
            swap(rr.first, rr.second);
        }
        rr.first += a[l];
        if (bestt.first <= rr.first)bestt = rr;
    }
    {
        int t2 = t - a[r];
        pair<int, int> rr;
        if (t2 > 0 || (t2 == 0 && al == 0)) {
            rr = solve(l, r - 1, al, t2);
        } else {
            rr = solve(l, r - 1, al ^ 1, -t2);
            swap(rr.first, rr.second);
        }
        rr.first += a[r];
        if (bestt.first <= rr.first)bestt = rr;
    }
    return dp[l][r][al][t] = bestt;
}

void solve() {
    ll n;
    cin >> n;
    for (int i = 0; i < n; i++)cin >> a[i];
    auto res = solve(0, n - 1, 0, 0);
    cout << res.first << ' ' << res.second;
}

int main() {
#ifdef VANT
    freopen("output.txt", "w", stdout);
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int q = 1;
    //cin>>q;
    while (q--) {
        solve();
        //    cout << '\n';
    }
}
