#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define int long long
struct node {
    int u, v, w;
};
bool ANS = false;
vector<int> por;

void rec(int n, int i, vector<node> &g, vector<int> &a, vector<vector<int>> &degs, vector<bool> &used) {
    if (i == n) {
        vector<vector<int>> cop = degs;
        int it = 0;
        for (auto j: a) {
            it++;
            if(it == a.size()) break;
            if (cop[g[j].u].empty() or cop[g[j].v].empty()) {
                return;
            }
            if (cop[g[j].u].back() + cop[g[j].v].back() >= g[j].w) {
                cop[g[j].u].pop_back();
                cop[g[j].v].pop_back();
            } else {
                return;
            }
        }
        ANS = true;
        por = a;
        por.pop_back();
        return;
    }
    for (int j = 0; j < n; j++) {
        if (!used[j]) {
            used[j] = true;
            a[i] = j;
            rec(n, i + 1, g, a, degs, used);
            used[j] = false;
        }
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cout << fixed << setprecision(12);
    int n, gr;
    cin >> n >> gr;
    if (gr <= 1) {
        vector<node> g(n);
        for (int i = 0; i < n - 1; i++) {
            int u, v, c;
            cin >> u >> v >> c;
            u--, v--;
            g[i] = {u, v, c};
        }
        vector<vector<int>> degs(n);
        string s;
        getline(cin, s);

        for (int i = 0; i < n; i++) {
            getline(cin, s);
            int now = 0;
            for (int j = 0; j < s.size(); j++) {
                if (s[j] >= '0' and s[j] <= '9') {
                    now *= 10;
                    now += (s[j] - '0');
                } else {
                    degs[i].push_back(now);
                    now = 0;
                }
            }
            degs[i].push_back(now);
        }
        vector<int> a(n);
        vector<bool> used(n);
        rec(n - 1, 0, g, a, degs, used);
        if (ANS) {
            cout << "YES\n";
            for (auto i: por) {
                cout << i + 1 << " ";
            }
            return 0;
        } else {
            cout << "NO\n";
            return 0;
        }
    }

}


