#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct Vect {
    ll x, y;

    Vect() = default;

    Vect(ll x, ll y) : x(x), y(y) {}

    Vect(Vect a, Vect b) : x(b.x - a.x), y(b.y - a.y) {}

    ll len2() {
        return x * x + y * y;
    }
};

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n;
    cin >> n;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (n == 3) {
        ll res = a[0] + a[1];
        res = max(res, a[2]);
        if (a[1] == a[2]) {
            res = max(res, a[2] + a[0]);
        }
        cout << res << " " << accumulate(a.begin(), a.end(), 0) - res << "\n";
        return 0;
    }
    ll cnt1 = 0;
    for (auto el : a) {
        if (el == 1) {
            cnt1++;
        }
    }
    ll cnt2 = n - cnt1;
    ll sum = accumulate(a.begin(), a.end(), 0);
    if (cnt1 % 2 == 1 && cnt2 % 1 == 1) {
        cout << sum / 2 + 1 << " " << sum / 2;
    } else if (cnt1 % 2 == 1 && cnt2 % 2 == 0) {
        cout << sum / 2 + 1 << " " << sum / 2;
    } else if (cnt1 % 2 == 0 && cnt2 % 2 == 1) {
        cout << sum / 2 + 1 << " " << sum / 2 - 1;
    } else {
        cout << sum / 2 + 1 << " " << sum / 2 - 1;
    }

    return 0;
}
