#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> w(n), pref(n + 1);
    int W = 0;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        W += w[i];
        pref[i + 1] = pref[i] + w[i];
    }
    vector<vector<int>> dpCur(n + 1, vector<int>(W + 1)), dpPrev(n + 1, vector<int>(W + 1));
    for (int len = 1; len <= n; ++len) {
        swap(dpCur, dpPrev);
        for (int l = 0; l + len <= n; ++l) {
            int r = l + len, nxtw1, nxtw2, cost;
            for (int w1 = 0; w1 <= W; ++w1) {
                dpCur[l][w1] = 0;
                int w2 = pref[l] + pref[n] - pref[r] - w1;
                if (w1 <= w2) {
                    // step 1
                    nxtw1 = w1 + w[l], nxtw2 = w2;
                    if (nxtw1 <= nxtw2) {
                        cost = dpPrev[l + 1][nxtw1];
                    } else {
                        cost = pref[r] - pref[l + 1] - dpPrev[l + 1][nxtw1];
                    }
                    dpCur[l][w1] = max(dpCur[l][w1], cost + w[l]);
                    nxtw1 = w1 + w[r - 1], nxtw2 = w2;
                    if (nxtw1 <= nxtw2) {
                        cost = dpPrev[l][nxtw1];
                    } else {
                        cost = pref[r - 1] - pref[l] - dpPrev[l][nxtw1];
                    }
                    dpCur[l][w1] = max(dpCur[l][w1], cost + w[r - 1]);
                } else {
                    // step 2
                    nxtw1 = w1, nxtw2 = w2 + w[l];
                    if (nxtw1 <= nxtw2) {
                        cost = pref[r] - pref[l + 1] - dpPrev[l + 1][nxtw1];
                    } else {
                        cost = dpPrev[l + 1][nxtw1];
                    }
                    dpCur[l][w1] = max(dpCur[l][w1], cost + w[l]);
                    nxtw1 = w1, nxtw2 = w2 + w[r - 1];
                    if (nxtw1 <= nxtw2) {
                        cost = pref[r - 1] - pref[l] - dpPrev[l][nxtw1];
                    } else {
                        cost = dpPrev[l][nxtw1];
                    }
                    dpCur[l][w1] = max(dpCur[l][w1], cost + w[r - 1]);
                }
            }
        }
    }
    cout << dpCur[0][0] << ' ' << pref[n] - dpCur[0][0] << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cout << "--------\n";
        cerr << "--------\n";
    }
    #else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    #endif

    return 0;
}