#include <iostream>
#include <vector>
#include <set>
#include <map>
#define int long long
using namespace std;

map<vector<int>, pair<int, int>> d;

vector<int> w;

void calc(int a, int b, int l, int r) {
    if (d.find({a, b, l, r}) != d.end()) {
        return;
    }
    if (l > r) {
        d[{a, b, l, r}] = {0, 0};
        return;
    }
    if (a <= b) {
        calc(a + w[l], b, l + 1, r);
        calc(a + w[r], b, l, r - 1);
        if (w[l] + d[{a + w[l], b, l + 1, r}].first >= w[r] + d[{a + w[r], b, l, r - 1}].first) {
            d[{a, b, l, r}] = d[{a + w[l], b, l + 1, r}];
            d[{a, b, l, r}].first += w[l];
        } else {
            d[{a, b, l, r}] = d[{a + w[r], b, l, r - 1}];
            d[{a, b, l, r}].first += w[r];
        }
    } else {
        calc(a, b + w[l], l + 1, r);
        calc(a, b + w[r], l, r - 1);
        if (w[l] + d[{a, b + w[l], l + 1, r}].second >= w[r] + d[{a, b + w[r], l, r - 1}].second) {
            d[{a, b, l, r}] = d[{a, b + w[l], l + 1, r}];
            d[{a, b, l, r}].second += w[l];
        } else {
            d[{a, b, l, r}] = d[{a, b + w[r], l, r - 1}];
            d[{a, b, l, r}].second += w[r];
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    w.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    calc(0, 0, 0, n - 1);
    cout << d[{0, 0, 0, n - 1}].first << " " << d[{0, 0, 0, n - 1}].second << endl;
    return 0;
}
