#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define all(a) a.begin(), a.end()

//constexpr int inf = 2e9;

template<class T>
struct negative_vector {
    vector<T> v;
    int sz;

    negative_vector(int size, T def = T()) {
        sz = size;
        v.resize(2 * sz + 1, def);
    }

    T &operator[](int i) {
        return v[i + sz];
    }
};

gp_hash_table<short, int> dp[2000][2000];
void solve() {
    int n;
    cin >> n;
    vector<int> aa(n);
    for (int &i : aa)
        cin >> i;
    map<int, int> cnt;
    for (int i : aa)
        ++cnt[i];
    vector<pair<int, int>> a(all(cnt));
    int mx = *max_element(all(aa));
    n = a.size();
    vector<vector<negative_vector<int>>> dp(n, vector<negative_vector<int>> (n, negative_vector<int>(mx, -1))); // alisa - bob
        for (int i = 0; i < n; ++i) {
        for (int time = -mx; time <= mx; ++time) {
            if (time <= 0)
                dp[i][i][time] = a[i].first * (a[i].second / 2 + a[i].second % 2);
            else
                dp[i][i][time] = a[i].first * (a[i].second / 2);
        }
    }
    for (int len = 2; len <= n; ++len) {
        for (int l = 0; l < n; ++l) {
            int r = l + len - 1;
            if (r >= n)
                continue;
            for (int time = -mx; time <= mx; ++time) {
                if (time <= 0)
                    dp[l][r][time] = max(dp[l + 1][r][time + a[l].first * (a[l].second % 2)] + a[l].first * (a[l].second / 2 + a[l].second % 2), dp[l][r - 1][time + a[r].first * (a[r].second % 2)] + a[r].first * (a[r].second / 2 + a[r].second % 2));
                else
                    dp[l][r][time] = min(dp[l + 1][r][time - a[l].first * (a[l].second % 2)] + a[l].first * (a[l].second / 2), dp[l][r - 1][time - a[r].first * (a[r].second % 2)] + a[r].first * (a[r].second / 2));
            }
        }
    }
    int x = dp[0][n - 1][0];
    cout << x << ' ' << accumulate(all(aa), 0) - x;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
