#include <iostream>
#include <vector>
#include <map>

using namespace std;

map<tuple<int, int, int, int>, pair<int, int>> mp;
vector<int> v;

pair<int, int> rec(int l, int r, int a, int b) {
    if (r == l - 1) {
        return {0, 0};
    }
    int c = min(a, b);
    a -= c;
    b -= c;
    if (mp.find({l, r, a, b}) != mp.end()) {
        return mp[{l, r, a, b}];
    }

    if (a == 0) {
        pair<int, int> res1 = rec(l + 1, r, v[l], b);
        pair<int, int> res2 = rec(l, r - 1, v[r], b);
        if (res1.first + v[l] > res2.first + v[r]) {
            mp[{l, r, a, b}] = {res1.first + v[l], res1.second};
        } else {
            mp[{l, r, a, b}] = {res2.first + v[r], res2.second};
        }
    } else {
        pair<int, int> res1 = rec(l + 1, r, a, v[l]);
        pair<int, int> res2 = rec(l, r - 1, a, v[r]);
        if (res1.second + v[l] > res2.second + v[r]) {
            mp[{l, r, a, b}] = {res1.first, res1.second + v[l]};
        } else {
            mp[{l, r, a, b}] = {res2.first, res2.second + v[r]};
        }

    }

    return mp[{l, r, a, b}];
}

int main()
{
    int n;
    cin >> n;
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    auto [a, b] = rec(0, n - 1, 0, 0);
    cout << a << " " << b << endl;
    return 0;
}
