#include<bits/stdc++.h>

using namespace std;

const int MAX = 2e3, MAX2 = 300, MAX3 = 1003;
vector<int> w(MAX), pref(MAX + 1);
vector<vector<vector<int>>> dp;
int dp2[MAX2][MAX2][MAX3];
int c;

int recs(int l, int r, int del) {
    //cout << l << " " << r << " " << del << endl;
    if (l > r) return del;
    if (del <= 0) {
        int ch1 = dp[l + 1][r][del + w[l] + c];
        if (ch1 == 1e9) {
            ch1 = recs(l + 1, r, del + w[l]);
        }
        int ch2 = dp[l + 1][r][del + w[r] + c];
        if (ch2 == 1e9) {
            ch2 = recs(l, r - 1, del + w[r]);
        }
        dp[l][r][del + c] = max(ch1, ch2);
    } else {
        int ch1 = dp[l + 1][r][del - w[l] + c];
        if (ch1 == 1e9) {
            ch1 = recs(l + 1, r, del - w[l]);
        }
        int ch2 = dp[l + 1][r][del - w[r] + c];
        if (ch2 == 1e9) {
            ch2 = recs(l, r - 1, del - w[r]);
        }
        dp[l][r][del + c] = min(ch1, ch2);
    }
    return dp[l][r][del + c];
}

int recs2(int l, int r, int del) {
    //cout << l << " " << r << " " << del << endl;
    if (l > r) return del;
    if (del <= 0) {
        int ch1 = dp2[l + 1][r][del + w[l] + c];
        if (ch1 == 1e9) {
            ch1 = recs2(l + 1, r, del + w[l]);
        }
        int ch2 = dp2[l + 1][r][del + w[r] + c];
        if (ch2 == 1e9) {
            ch2 = recs2(l, r - 1, del + w[r]);
        }
        dp2[l][r][del + c] = max(ch1, ch2);
    } else {
        int ch1 = dp2[l + 1][r][del - w[l] + c];
        if (ch1 == 1e9) {
            ch1 = recs2(l + 1, r, del - w[l]);
        }
        int ch2 = dp2[l + 1][r][del - w[r] + c];
        if (ch2 == 1e9) {
            ch2 = recs2(l, r - 1, del - w[r]);
        }
        dp2[l][r][del + c] = min(ch1, ch2);
    }
    return dp2[l][r][del + c];
}

signed main() {
    int n;
    cin >> n;
    int maxm = 0;
    pref[0] = 0;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        pref[i + 1] = pref[i] + w[i];
    }
    c = w[n - 1];
    if (n > 200) {
        dp.resize(n + 1);
        for (int i = 0; i < n + 1; ++i) {
            dp[i].resize(n + 1);
            for (int j = 0; j < n + 1; ++j) {
                dp[i][j].assign(w[n - 1] * 2 + 3, 1e9);
            }
        }
    } else {
        for (int i = 0; i < MAX2; ++i) {
            for (int j = 0; j < MAX2; ++j) {
                for (int l = 0; l < MAX3; ++l) {
                    dp2[i][j][l] = 1e9;
                }
            }
        }
    }
    if (n == 3) {
        if (w[2] >= w[1] + w[0]) {
            cout << w[2] << " " << w[1] + w[0] << endl;
            return 0;
        }
        cout << w[0] + w[1] << " " << w[2] << endl;
    } else if (n > 200) {
        int ans = recs(0, n - 1, 0);
        //cout << ans << endl;
        cout << (pref[n] - ans) / 2 + ans << " " << (pref[n] - ans) / 2 << endl;
    } else {
        int ans = recs2(0, n - 1, 0);
        //cout << ans << endl;
        cout << (pref[n] - ans) / 2 + ans << " " << (pref[n] - ans) / 2 << endl;
    }
}
