#ifndef SYSTY257
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

template<typename t1, typename t2>
void mnr(t1 &a, const t2 &b) {
    if (b < a) {
        a = b;
    }
}

template<typename t1, typename t2>
void mxr(t1 &a, const t2 &b) {
    if (b > a) {
        a = b;
    }
}

void g1(int n, const vector <int>& w) {
    cout << max(w[0] + w[1], w[2]) << " " << min(w[0] + w[1], w[2]) << "\n";
}

void g2(int n, const vector <int>& w) {
    int s = accumulate(all(w), 0ll);
    int t = (s + 1) / 2;
    cout << t << " " << s - t << "\n";
}

signed main() {
    cout << setprecision(15) << fixed;
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector <int> w(n);
    for (auto &i : w) {
        cin >> i;
    }
    if (n == 3) {
        g1(n, w);
        return 0;
    }
    g2(n, w);
}