#ifndef SYSTY257
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

template<typename t1, typename t2>
void mnr(t1 &a, const t2 &b) {
    if (b < a) {
        a = b;
    }
}

template<typename t1, typename t2>
void mxr(t1 &a, const t2 &b) {
    if (b > a) {
        a = b;
    }
}

constexpr int INF = 1e12;

void g1(int n, const vector <int>& w) {
    cout << max(w[0] + w[1], w[2]) << " " << min(w[0] + w[1], w[2]) << "\n";
}

void g2(int n, const vector <int>& w) {
    int maxw = *max_element(all(w));
    vector <vector <vector <int> > > dp(n, vector <vector <int> > (n, vector <int> (2 * maxw + 1, -INF)));
    for (int i = 0; i < n; ++i) {
        for (int t = 0; t <= 2 * maxw; ++t) {
            dp[i][i][t] = w[i];
        }
    }
    vector <vector <int> > sum(n, vector <int> (n));
    for (int i = 0; i < n; ++i) {
        sum[i][i] = w[i];
        for (int j = i + 1; j < n; ++j) {
            sum[i][j] = sum[i][j - 1] + w[j];
        }
    }
    for (int len = 2; len <= n; ++len) {
        for (int i = 0; i + len <= n; ++i) {
            int j = i + len - 1;
            for (int t = 0; t <= 2 * maxw; ++t) {
                if (t >= maxw) {
                    {
                        int nt = t - w[i];
                        if (nt >= maxw) {
                            mxr(dp[i][j][t], dp[i + 1][j][nt] + w[i]);
                        } else {
                            mxr(dp[i][j][t], (sum[i + 1][j] - dp[i + 1][j][nt]) + w[i]);
                        }
                    }
                    {
                        int nt = t - w[j];
                        if (nt >= maxw) {
                            mxr(dp[i][j][t], dp[i][j - 1][nt] + w[j]);
                        } else {
                            mxr(dp[i][j][t], (sum[i][j - 1] - dp[i][j - 1][nt]) + w[j]);
                        }
                    }
                } else {
                    {
                        int nt = t + w[i];
                        if (nt < maxw) {
                            mxr(dp[i][j][t], dp[i + 1][j][nt] + w[i]);
                        } else {
                            mxr(dp[i][j][t], (sum[i + 1][j] - dp[i + 1][j][nt]) + w[i]);
                        }
                    }
                    {
                        int nt = t + w[j];
                        if (nt < maxw) {
                            mxr(dp[i][j][t], dp[i][j - 1][nt] + w[j]);
                        } else {
                            mxr(dp[i][j][t], (sum[i][j - 1] - dp[i][j - 1][nt]) + w[j]);
                        }
                    }
                }
            }
        }
    }
    cout << dp[0][n - 1][maxw] << " " << sum[0][n - 1] - dp[0][n - 1][maxw] << "\n";
}

signed main() {
    cout << setprecision(15) << fixed;
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector <int> w(n);
    for (auto &i : w) {
        cin >> i;
    }
    if (n == 3) {
        g1(n, w);
        return 0;
    }
    g2(n, w);
}