#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign
#define vec vector

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

const int INF = (int)(1e18) + 42;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;

    sort(all(a));

    vector<int> pr(n + 1);
    for (int i = 1; i <= n; ++i)
        pr[i] = pr[i - 1] + a[i - 1];

    int sw = 0;
    for (auto i : a)
        sw += i;

    map<tii, int> m;

    auto dfs = [&](auto dfs, int l, int r, int t)->void {
        int t1 = pr[l] + pr[n] - pr[r + 1] - t;
        if (t1 < 0)
            return;

        if (r == l) {
            m[{l, r, t}] = t <= t1 ? a[l] : 0;
            return;
        }

        if (t <= t1) {
            dfs(dfs, l + 1, r, t + a[l]);
            dfs(dfs, l, r - 1, t + a[r]);
            m[{l, r, t}] = max(m[{l + 1, r, t + a[l]}] + a[l], m[{l, r - 1, t + a[r]}] + a[r]);
        } else {
            dfs(dfs, l + 1, r, t);
            dfs(dfs, l, r - 1, t);
            m[{l, r, t}] = min(m[{l + 1, r, t}], m[{l, r - 1, t}]);
        }
    };

    dfs(dfs, 0, n - 1, 0);

    int ans = m[{0, n - 1, 0}];
    cout << ans << " " << pr[n] - ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}