#include <bits/stdc++.h>


using namespace std;


map<tuple<int, int, int>, int> memoize;


int Calc(const vector<int> &a, int l, int r, int timer) {
    if (l > r) {
        return timer;
    }
    if (memoize.find(make_tuple(timer, l, r)) != memoize.end()) {
        return memoize[make_tuple(timer, l, r)];
    }
    if (timer <= 0) {
        int buf1 = Calc(a, l + 1, r, timer + a.at(l));
        int buf2 = Calc(a, l, r - 1, timer + a.at(r));
        memoize[make_tuple(timer, l, r)] = max(buf1, buf2);
        return max(buf1, buf2);
    } else {
        int buf1 = Calc(a, l + 1, r, timer - a.at(l));
        int buf2 = Calc(a, l, r - 1, timer - a.at(r));
        memoize[make_tuple(timer, l, r)] = min(buf1, buf2);
        return min(buf1, buf2);
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    int sum = 0;
    for (int i = 0; i < n; i++) {
        cin >> a.at(i);
        sum += a.at(i);
    }
    int res = Calc(a, 0, n - 1, 0);
    cout << (sum + res) / 2 << " " << sum - (sum + res) / 2;
    return 0;
}
