#include <bits/stdc++.h>

using namespace std;

constexpr int maxn = 2005, inf = 1e9 + 7;

// int _dp[maxn][maxn][maxd * 2 + 10];

int mx_diff[maxn][maxn];

int *dp[maxn][maxn];

void solve() {
    // for (int i = 0; i < maxn; ++i) {
    //     for (int j = 0; j < maxn; ++j) {
    //         dp[i][j] = _dp[i][j] + maxd;
    //     }
    // }
    int n;
    cin >> n;
    vector<int> w(n);
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        sum += w[i];
    }
    mx_diff[0][n] = 0;
    for (int len = n - 1; len >= 1; --len) {
        for (int l = 0; l + len <= n; ++l) {
            int r = l + len;
            mx_diff[l][r] = 0;
            if (l > 0) {
                mx_diff[l][r] = max(mx_diff[l][r], max(w[l - 1], mx_diff[l - 1][r] - w[l - 1]));
            }
            if (r < n) {
                mx_diff[l][r] = max(mx_diff[l][r], max(w[r], mx_diff[l][r + 1] - w[r]));
            }
            // cout << l << ' ' << r << ' ' << mx_diff[l][r] << '\n';
        }
    }
    int val = w[n - 1];
    for (int l = 0; l < n; ++l) {
        for (int r = l + 1; r <= n; ++r) {
            dp[l][r] = (new int[mx_diff[l][r] * 2 + 5]) + mx_diff[l][r] + 1;
        }
    }
    for (int l = 0; l < n; ++l) {
        for (int r = l + 1; r <= n; ++r) {
            for (int vl = -mx_diff[l][r]; vl <= mx_diff[l][r]; ++vl) {
                dp[l][r][vl] = inf;
            }
        }
    }
    // cout << dp[0][n][0] << '\n';
    for (int l = 0; l < n; ++l) {
        for (int vl = -mx_diff[l][l + 1]; vl <= mx_diff[l][l + 1]; ++vl) {
            if (vl <= 0) {
                dp[l][l + 1][vl] = vl + w[l];
            } else {
                dp[l][l + 1][vl] = vl - w[l];
            }
        }
    }
    for (int len = 2; len <= n; ++len) {
        for (int l = 0; l + len <= n; ++l) {
            int r = l + len;
            // cout << l << ' ' << r << ' ' << n << '\n';
            for (int vl = -mx_diff[l][r]; vl <= mx_diff[l][r]; ++vl) {
                if (vl <= 0) {
                    dp[l][r][vl] = -inf;
                    // if (l == 0 && r == n) {
                    //     cout << "!" << dp[l][r][vl] << '\n';
                    // }
                    if (dp[l + 1][r][vl + w[l]] != inf) {
                        // if (l == 0 && r == n) {
                        //     cout << dp[l + 1][r][vl + w[l]] << '\n';
                        // }
                        dp[l][r][vl] = max(dp[l][r][vl], dp[l + 1][r][vl + w[l]]);
                    }
                    if (dp[l][r - 1][vl + w[r - 1]] != inf) {
                        // if (l == 0 && r == n) {
                        //     cout << dp[l][r - 1][vl + w[r - 1]] << '\n';
                        // }
                        dp[l][r][vl] = max(dp[l][r][vl], dp[l][r - 1][vl + w[r - 1]]);
                    }
                    if (dp[l][r][vl] == -inf) {
                        dp[l][r][vl] = inf;
                    }
                } else {
                    if (dp[l + 1][r][vl - w[l]] != inf) {
                        dp[l][r][vl] = min(dp[l][r][vl], dp[l + 1][r][vl - w[l]]);
                    }
                    if (dp[l][r - 1][vl - w[r - 1]] != inf) {
                        dp[l][r][vl] = min(dp[l][r][vl], dp[l][r - 1][vl - w[r - 1]]);
                    }
                }
            }
        }
    }
    cout << (sum + dp[0][n][0]) / 2 << ' ' << (sum - dp[0][n][0]) / 2 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
