#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

vector<int> w;

map<vector<int>, int> mp;

int dfs(int l, int r, int d)
{
    if(l > r)
    {
        return d;
    }

    if(mp.find({l, r, d}) != mp.end())
    {
        return mp[{l, r, d}];
    }

    if(d <= 0)
    {
        int ans1 = dfs(l + 1, r, d + w[l]);
        int ans2 = dfs(l, r - 1, d + w[r]);
        mp[{l, r, d}] = max(ans1, ans2);
        return max(ans1, ans2);
    } else {
        int ans1 = dfs(l + 1, r, d - w[l]);
        int ans2 = dfs(l, r - 1, d - w[r]);
        mp[{l, r, d}] = min(ans1, ans2);
        return min(ans1, ans2);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;

    cin >> n;

    w.resize(n);

    int W = 0;

    for(int i = 0; i < n; ++i)
    {
        cin >> w[i];
        W += w[i];
    }

    sort(w.begin(), w.end());

    int d = dfs(0, n-1, 0);
    cout << (W + d) / 2 << ' ' << (W - d) / 2 << '\n';

}