#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<int> w;

struct st{
    int l, r, cond, wt;
};

bool operator < (st a, st b) {
    return a.l < b.l || a.l == b.l && a.r < b.r || a.l == b.l && a.r == b.r && a.cond < b.cond ||
            a.l == b.l && a.r == b.r && a.cond == b.cond && a.wt < b.wt;
}

map<st, int> dp;

int rec(int l, int r, int cond, int wt) {
    if (dp.find({l, r, cond, wt}) != dp.end()) {
        return dp[{l, r, cond, wt}];
    }
    if (l == r) {
        int i = l;
        if (cond == 0) {
            return dp[{i, i, 0, wt}] = w[i];
        }
        if (wt == 0) {
            return dp[{i, i, 1, wt}] = w[i];
        } else {
            return dp[{i, i, 1, wt}] = 0;
        }
    }
    if (cond == 1) {
        dp[{l, r, 1, wt}] = 1e9;
    }
    if (wt > w[l]) {
        if (cond == 0)
            dp[{l, r, 0, wt}] = max(dp[{l, r, 0, wt}], rec(l + 1, r, 0, wt - w[l]) + w[l]);
        if (cond == 1)
            dp[{l, r, 1, wt}] = min(dp[{l, r, 1, wt}], rec(l + 1, r, 1, wt - w[l]));
    } else {
        if (cond == 0) {
            if (w[l] == wt) {
                dp[{l, r, 0, wt}] = max(dp[{l, r, 0, wt}], rec(l + 1, r, 0, w[l] - wt) + w[l]);
            } else {
                dp[{l, r, 0, wt}] = max(dp[{l, r, 0, wt}], rec(l + 1, r, 1, w[l] - wt) + w[l]);
            }
        }
        if (cond == 1)
            dp[{l, r, 1, wt}] = min(dp[{l, r, 1, wt}], rec(l + 1, r, 0, w[l] - wt));
    }
    if (wt > w[r]) {
        if (cond == 0)
            dp[{l, r, 0, wt}] = max(dp[{l, r, 0, wt}], rec(l, r - 1, 0, wt - w[r]) + w[r]);
        if (cond == 1)
            dp[{l, r, 1, wt}] = min(dp[{l, r, 1, wt}], rec(l, r - 1, 1, wt - w[r]));
    } else {
        if (cond == 0) {
            if (wt == w[r]) {
                dp[{l, r, 0, wt}] = max(dp[{l, r, 0, wt}], rec(l, r - 1, 0, w[r] - wt) + w[r]);
            } else {
                dp[{l, r, 0, wt}] = max(dp[{l, r, 0, wt}], rec(l, r - 1, 1, w[r] - wt) + w[r]);
            }
        }
        if (cond == 1)
        dp[{l, r, 1, wt}] = min(dp[{l, r, 1, wt}], rec(l, r - 1, 0, w[r] - wt));
    }
    if (cond == 0) {
        return dp[{l, r, 0, wt}];
    }
    return dp[{l, r, 1, wt}];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    w.assign(n, 0);
    int sum = 0;
    int mxw = 0;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        sum += w[i];
        mxw = max(mxw, w[i]);
    }
//    vector<vector<vector<vector<int>>>> dp(n, vector<vector<vector<int>>>(n, vector<vector<int>>(
//            2, vector<int>(mxw + 1))));
//    for (int i = 0; i < n; ++i) {
//        for (int wt = 0; wt <= mxw; ++wt) {
//            dp[i][i][0][wt] = w[i];
//            if (wt == 0) {
//                dp[i][i][1][wt] = w[i];
//            } else {
//                dp[i][i][1][wt] = 0;
//            }
//        }
//    }
//    for (int len = 2; len <= n; ++len) {
//        for (int l = 0; l <= n - len; ++l) {
//            int r = l + len - 1;
//            for (int wt = 0; wt <= mxw; ++wt) {
//                dp[l][r][1][wt] = 1e9;
//                if (wt > w[l]) {
//                    dp[l][r][0][wt] = max(dp[l][r][0][wt], dp[l + 1][r][0][wt - w[l]] + w[l]);
//                    dp[l][r][1][wt] = min(dp[l][r][1][wt], dp[l + 1][r][1][wt - w[l]]);
//                } else {
//                    if (w[l] == wt) {
//                        dp[l][r][0][wt] = max(dp[l][r][0][wt], dp[l + 1][r][0][w[l] - wt] + w[l]);
//                    } else {
//                        dp[l][r][0][wt] = max(dp[l][r][0][wt], dp[l + 1][r][1][w[l] - wt] + w[l]);
//                    }
//                    dp[l][r][1][wt] = min(dp[l][r][1][wt], dp[l + 1][r][0][w[l] - wt]);
//                }
//                if (wt > w[r]) {
//                    dp[l][r][0][wt] = max(dp[l][r][0][wt], dp[l][r - 1][0][wt - w[r]] + w[r]);
//                    dp[l][r][1][wt] = min(dp[l][r][1][wt], dp[l][r - 1][1][wt - w[r]]);
//                } else {
//                    if (wt == w[r]) {
//                        dp[l][r][0][wt] = max(dp[l][r][0][wt], dp[l][r - 1][0][w[r] - wt] + w[r]);
//                    } else {
//                        dp[l][r][0][wt] = max(dp[l][r][0][wt], dp[l][r - 1][1][w[r] - wt] + w[r]);
//                    }
//                    dp[l][r][1][wt] = min(dp[l][r][1][wt], dp[l][r - 1][0][w[r] - wt]);
//                }
////                cout << l << " " << r << " " << wt << " " << dp[l][r][0][wt] << " " << dp[l][r][1][wt] << "\n";
//            }
//        }
//    }
int res = rec(0, n - 1, 0, 0);
    cout << res << " " << sum - res << "\n";
}
