#include <bits/stdc++.h>

using namespace std;
using ll = long long;


mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct fast {
    ll n;
    vector<ll> a;

    pair<ll, ll> rec(ll l, ll r, ll v1, ll v2, ll turn = 0) {
        if (l > r) {
            return {v1, v2};
        }
        pair<ll, ll> best_res = {-1, -1};
        if (turn == 0) {
            ll v3 = v1 + a[l];
            pair<ll, ll> curr = rec(l + 1, r, v3, v2, (v3 <= v2 ? 0 : 1));
            if (curr.first > best_res.first) {
                best_res = curr;
            }
            v3 = v1 + a[r];
            curr = rec(l, r - 1, v3, v2, (v3 <= v2 ? 0 : 1));
            if (curr.first > best_res.first) {
                best_res = curr;
            }
        } else {
            ll v3 = v2 + a[l];
            pair<ll, ll> curr = rec(l + 1, r, v1, v3, (v1 <= v3 ? 0 : 1));
            if (curr.second > best_res.second) {
                best_res = curr;
            }
            v3 = v2 + a[r];
            curr = rec(l, r - 1, v1, v3, (v1 <= v3 ? 0 : 1));
            if (curr.second > best_res.second) {
                best_res = curr;
            }
        }
        return best_res;
    }

    void solve() {
        cin >> n;
        a.resize(n);
        ll sum = 0;
        ll f = 0, s = 0;
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            sum += a[i];
            if (a[i] == 1) f++;
            else if (a[i] == 2) s++;
        }
        if (f + s == n) {
            if (f == 0) {
                cout << (s + 1) / 2 * 2 << ' ' << s / 2 * 2;
            } else {
                cout << (sum + 1) / 2 << ' ' << sum / 2;
            }
            return;
        } else {
            pair<ll, ll> res = rec(0, n - 1, 0, 0, 0);
            cout << res.first << ' ' << res.second << ' ';
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    bool stress = false;
    int times = 1;
//    cin >> times;
    if (stress) times = 1e9;
    while (times--) {
        fast f;
        f.solve();
    }
    return 0;
}
