#pragma optimize("Ofast,unroll-loops");
#pragma target("avx2");

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define endl '\n'
#define pint pair<int, int>
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

struct hasher {
    size_t operator()(const pair<pint, int>& a) const {
        return a.first.first + a.first.second * 31 + a.second * 31 * 31;
    }
};

map<int, int> suffs;
unordered_map<pair<pint, int>, pint, hasher> mem;
vector<int> prefs;
int n;
vector<int> a;
int sum = 0;

void dfs(int s1, int s2, int pref) {
    auto hate1 = mp(mp(s1, s2), pref);
    if (mem.count(hate1)) return;
    int suff = suffs[s1 + s2 - prefs[pref]];
    if (suff + pref == n) {
        mem[mp(mp(s1, s2), pref)] = mp(s1, s2);
        return;
    }
    if (abs(s1 - s2) > sum / 10) {
        mem[mp(mp(s1, s2), pref)] = mp(-1, -1);
        return;
    }
    if (s1 <= s2) {
        dfs(s1 + a[pref], s2, pref + 1);
        dfs(s1 + a[n - suff - 1], s2, pref);
        if (mem[mp(mp(s1 + a[pref], s2), pref + 1)].first > mem[mp(mp(s1 + a[n - suff - 1], s2), pref)].first) {
            mem[mp(mp(s1, s2), pref)] = mem[mp(mp(s1 + a[pref], s2), pref + 1)];
        } else {
            mem[mp(mp(s1, s2), pref)] = mem[mp(mp(s1 + a[n - suff - 1], s2), pref)];
        }
    } else {
        dfs(s1, s2 + a[pref], pref + 1);
        dfs(s1, s2 + a[n - suff - 1], pref);
        if (mem[mp(mp(s1, s2 + a[pref]), pref + 1)].second > mem[mp(mp(s1, s2 + a[n - suff - 1]), pref)].second) {
            mem[mp(mp(s1, s2), pref)] = mem[mp(mp(s1, s2 + a[pref]), pref + 1)];
        } else {
            mem[mp(mp(s1, s2), pref)] = mem[mp(mp(s1, s2 + a[n - suff - 1]), pref)];
        }
    }
}

void solve() {
    cin >> n;
    a.resize(n);
    forn(i, 0, n) {
        cin >> a[i];
        sum += a[i];
    }
    sort(all(a));

    if (a.back() <= 2 && n >= 1000) {
        cout << (sum + 1) / 2 << " " << sum / 2;
        return;
    }

    suffs[0] = 0;
    int sm = 0;
    forn(i, 0, n) {
        sm += a[n - i - 1];
        suffs[sm] = i + 1;
    }

    prefs.assign(n + 1, 0);
    forn(i, 0, n) {
        prefs[i + 1] = prefs[i] + a[i];
    }

    dfs(0, 0, 0);
    cout << mem[mp(mp(0, 0), 0)].first << " " << mem[mp(mp(0, 0), 0)].second;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
