#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define pw(x) (1ll << x)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn (T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx (T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pii = pair < int , int >;

const int N = 1e6 + 5;
const int inf = 2e9;
const ll INF = 4e18;

int n;
int a[N];

array < int , 4 > dp[N];

int main() {
#ifdef localy
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for (int i = 1; i <= n; ++ i) cin >> a[i];

    if (n == 3) {
        if (a[n] >= a[1] + a[2]) {
            cout << a[n] << " " << a[1] + a[2] << "\n";
            return 0;
        }
        cout << a[1] + a[2] << " " << a[n] << "\n";
        return 0;
    }


    int sa = 0, sb = 0;
    int resa = 0, resb = 0;

    int l = 1, r = n;
    while (l <= r) {
        int mn = min (sa, sb);
        sa -= mn;
        sb -= mn;

        if (l == r) {
            if (!sa) resa += a[l];
            else resb += a[l];
            break;
        }

        int L = inf, R = inf;
        if (!sa && !sb) {

            // to l
            int ss = a[l], l1 = l + 2;
            int mnl = inf, mnr = inf;
            while (l1 <= r && ss < a[l + 1]) ss += a[l1 ++];
            mnl = a[l + 1] - ss;

            ss = 0, l1 = l;
            while (l1 < r && ss < a[r]) ss += a[l1 ++];
            mnr = a[r] - ss;
            L = max (mnl, mnr);

            // to r
            ss = 0, l1 = r - 1;
            mnl = inf, mnr = inf;
            while (l1 >= l && ss < a[r]) ss += a[l1 --];
            mnl = ss - a[r];

            ss = 0, l1 = l;
            while (l1 < r && ss < a[r]) ss += a[l1 ++];
            mnr = ss - a[r];

            R = max (mnl, mnr);
        } else {
            int val = max (sa, sb);

            int ss = 0, l1 = l;
            while (l1 <= r && ss < val) ss += a[l1 ++];
            L = val - ss;

            ss = 0;
            int r1 = r;
            while (r1 >= l && ss < val) ss += a[r1 --];
            R = val - ss;
        }
        
        if (!sa) {
            if (L < R) resa += a[l], sa = a[l], ++ l;
            else resa += a[r], sa = a[r], -- r;
        } else {
            if (L < R) resb += a[l], sb = a[l], ++ l;
            else resb += a[r], sb = a[r], -- r;
        }
    }

    cout << resa << " " << resb << "\n";
    return 0;
}
