#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;
const int sz = 500;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	vector<int> w(n);
	ll W = 0;
	int cnt2 = 0;
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
		if (w[i] == 2) cnt2++;
		W += w[i];
	}
	if (n == 3) {
		sort(w.begin(), w.end());
		if (n == 1) {
			cout << w[0] << " " << 0;
		}
		else if (n == 2) {
			cout << w[1] << " " << w[0];
		}
		else {
			if (w[0] == w[2]) {
				cout << w[0] + w[1] << " " << w[2];
			}
			else {
				ll a = w[0] + w[1], b = w[2];
				ll a2 = w[2], b2 = w[0] + w[1];
				if (a > a2)
					cout << a << " " << b << "\n";
				else
					cout << a2 << " " << b2 << "\n";
			}

		}
	}
	else if (n <= 200) {
		sort(w.begin(), w.end());
		vector<vector<vector<int>>> dp(n, vector<vector<int>>(n, vector<int>(2 * sz + 1, 0)));
		for (int i = 0; i < n; ++i) {
			for (int t = -sz; t <= sz; ++t) {
				if (t >= 0)
					dp[i][i][t + sz] = w[i];
			}
		}
		for (int k = 1; k < n; ++k) {
			for (int l = 0; l + k < n; ++l) {
				for (int t = -sz; t <= sz; ++t) {
					int r = l + k;
					if (t >= 0) {
						dp[l][r][t + sz] = dp[l + 1][r][t - w[l] + sz] + w[l];
						dp[l][r][t + sz] = max(dp[l][r][t + sz], dp[l][r - 1][t - w[r] + sz] + w[r]);    
					}
					else {
						dp[l][r][t + sz] = dp[l + 1][r][t + w[l] + sz];
						dp[l][r][t + sz] = min(dp[l][r][t + sz], dp[l][r - 1][t + w[r] + sz]);
					}
				}
			}
		}
		int ali = dp[0][n - 1][sz];
		int bob = W - ali;
		cout << ali << " " << bob;
	}
	else {
		ll ali = (W + 1) / 2;
		ll bob = W - ali;
		if (cnt2 % 2 == 0)
			ali = W / 2;
		else
			ali = W / 2 + 1;
		bob = W - ali;
		cout << ali << " " << bob;
	}

	return 0;
}