#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <deque>
#include <queue>
#include <assert.h>
#include <random>
#include <math.h>
#include <bitset>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define all(a) a.begin(), a.end()
#define ff first
#define ss second
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

mt19937 rnd(time(0));
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

#define int long long
int n;
vi a;

void solve1() {
    int s1 = a[2], s2 = a[0] + a[1];
    cout << max(s1, s2) << " " << min(s1, s2);
}

void solve2() {
    int x = 0, y = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] == 1) x++;
        else y++;
    }

    int sm = x + y * 2;
    if (x % 2 == 0 && y % 2 == 1) {
        cout << sm / 2 + 1 << " " << sm / 2 - 1;
    }
    else {
        cout << sm - sm / 2 << " " << sm / 2;
    }

}

void solve3() {
    int W = 0;
    for (auto& x : a) W += x;
    int S = W / 2;
    vi dp(S + 1, 0);
    dp[0] = 1;
    for (int i = 0; i < n; ++i) {
        int x = a[i];
        for (int w = S - x; w >= 0; --w) {
            if (dp[w]) dp[w + x] = 1;
        }
    }

    for (int i = S; i >= 0; --i) {
        if (dp[i]) {
            cout << W - i << " " << i;
            break;
        }
    }
}
signed main()
{
    fast;
    
    cin >> n;
    a.resize(n);
    for (auto& i : a) cin >> i;

    if (n == 3) solve1();
    else solve3();
}
