#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
//#define int ll

using namespace std;

mt19937 rnd(0);

vector<vector<vector<pair<int, int>>>> dp;
vector<int> a;

int rec(int l, int r, int bal) {  // ta - tb -> <= 0 : al 
    if (l == r) {
        return bal <= 0 ? a[l] : 0;
    }
    auto it = lower_bound(all(dp[l][r]), pair<int, int>{ bal, -1e9});
    if (it != dp[l][r].end() && it->first == bal) {
        return it->second;
    }
    int res;
    if (bal <= 0) {
        res = max(a[l] + rec(l + 1, r, bal + a[l]), a[r] + rec(l, r - 1, bal + a[r]));
        dp[l][r].insert(it, { bal, res });
    } else {
        res = min(rec(l + 1, r, bal - a[l]), rec(l, r - 1, bal - a[r]));
        dp[l][r].insert(it, { bal, res });
    }
    return res;
}

void solve() {
    int n;
    cin >> n;
    a.resize(n);
    int s = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        //a[i] = rnd() % min(10000, 20000 - s - (n-i)) + 1;
        s += a[i];
    }
    //sort(all(a));
    dp.resize(n, vector<vector<pair<int, int>>>(n));
    rec(0, n - 1, 0);
    cout << rec(0, n - 1, 0) << ' ' << s - rec(0, n - 1, 0);
}


signed main() {
    cout.setf(ios_base::fixed);
    cout << fixed << std::setprecision(12);
    ios_base::sync_with_stdio(false);
    cin.tie(0);


#ifdef LOCAL
    auto f = freopen("input.txt", "r", stdin);
    auto f1 = freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}