#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <deque>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
//#define int ll

using namespace std;

mt19937 rnd(0);

vector<vector<deque<int>>> dp;
vector<int> a;
vector<vector<int>> sh;

int rec(int l, int r, int bal) {  // ta - tb -> <= 0 : al 
    if (l == r) {
        return bal <= 0 ? a[l] : 0;
    }
    while (bal + sh[l][r] < 0) {
        dp[l][r].push_front(1e9);
        sh[l][r]++;
    }
    while (bal + sh[l][r] >= dp[l][r].size()) {
        dp[l][r].push_back(1e9);
    }
    if (dp[l][r][bal + sh[l][r]] != 1e9) {
        return dp[l][r][bal + sh[l][r]];
    }
    if (bal <= 0) {
        return dp[l][r][bal + sh[l][r]] = max(a[l] + rec(l + 1, r, bal + a[l]), a[r] + rec(l, r - 1, bal + a[r]));
    } else {
        return dp[l][r][bal + sh[l][r]] = min(rec(l + 1, r, bal - a[l]), rec(l, r - 1, bal - a[r]));
    }
}

void solve() {
    int n;
    cin >> n;
    a.resize(n);
    int s = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        //a[i] = rnd() % min(10000, 20000 - s - (n-i)) + 1;
        s += a[i];
    }
    //sort(all(a));
    dp.resize(n, vector<deque<int>>(n));
    sh.resize(n, vector<int>(n, 0));
    rec(0, n - 1, 0);
    cout << rec(0, n - 1, 0) << ' ' << s - rec(0, n - 1, 0);
}


signed main() {
    cout.setf(ios_base::fixed);
    cout << fixed << std::setprecision(12);
    ios_base::sync_with_stdio(false);
    cin.tie(0);


#ifdef LOCAL
    auto f = freopen("input.txt", "r", stdin);
    auto f1 = freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}