#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <random>
#include <chrono>
#include <deque>


using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define MNOGO int __t; cin>>__t; while(__t--)
#define endl "\n"


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    mt19937 rng(std::chrono::steady_clock::now().time_since_epoch().count());

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;

    deque<int> samp;

    int sum = 0;

    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        sum += x;
        samp.push_back(x);
    }

    if (n >= 250) {
        cout << (sum + 1) / 2 << " " << (sum + 0) / 2 << endl;
        return 0;
    }

    int amax = 0;
    for (int alice = 0; alice <= 1; alice++) {
        for (int i = 0; i <= n; i++) {
            int nmin = 1e9;
            for (int bob = 0; bob <= 1; bob++) {
                for (int j = 0; j <= n; j++) {
                    auto a = samp;
                    int ans_a = 0;
                    int ans_b = 0;
                    int c_a = 0;
                    int c_b = 0;
                    set<pair<int, int>> st = {{0, 0},
                                              {0, 1}};
                    while (c_a + c_b < n) {
                        auto now = *(st.begin());
                        st.erase(now);
                        int p = now.ss;
                        if (p == 0) {
                            if (((c_a >= i) ^ alice) == 1) {
                                ans_a += a.back();
                                st.insert({now.ff + a.back(), 0});
                                a.pop_back();
                            } else {
                                ans_a += a.front();
                                st.insert({now.ff + a.front(), 0});
                                a.pop_front();
                            }
                            c_a++;
                        } else {
                            if (((c_b >= j) ^ bob) == 1) {
                                ans_b += a.back();
                                st.insert({now.ff + a.back(), 1});
                                a.pop_back();
                            } else {
                                ans_b += a.front();
                                st.insert({now.ff + a.front(), 1});
                                a.pop_front();
                            }
                            c_b++;
                        }
                    }
                    nmin = min(nmin, ans_a);
                }
            }
            amax = max(amax, nmin);
        }
    }

    cout << amax << " " << sum - amax << endl;

}
