#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9 + 1;
const int mod = inf + 6;
const ll infll = 1ll * (inf - 1) * (inf - 1);
mt19937_64 rnd(time(0));
const int N = 2052, W = N * 10;
vector<int> pdp[N][N][2], sdp[N][N][2];
void solve_case() {
    int n;
    cin >> n;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    vector<int> pw(n + 1);
    for (int i = 0; i < n; i++) pw[i + 1] = pw[i] + w[i];
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            for (int x = 0; x < 2; x++) {
                int need = (j == n - 1) ? 0 : w[j + 1];
                sdp[i][j][x].assign(2 * need + 1, -inf);
                need = (j == 0) ? 0 : w[j - 1];
                pdp[i][j][x].assign(2 * need + 1, -inf);
            }
        }
    }
    for (int len = 0; len < n; len++) {
        for (int l = 0, r = len; r < n; l++, r++) {
            if (l == r) {
                for (int x = 0; x < pdp[l][r][0].size(); x++) {
                    chmax(pdp[l][r][0][x], w[l]);
                    if (x != 0) {
                        chmax(pdp[l][r][1][x], w[l]);
                    } else {
                        chmax(pdp[l][r][1][x], 0);
                    }
                }
                for (int x = 0; x < sdp[l][r][0].size(); x++) {
                    chmax(sdp[l][r][0][x], w[l]);
                    if (x != 0) {
                        chmax(sdp[l][r][1][x], w[l]);
                    } else {
                        chmax(sdp[l][r][1][x], 0);
                    }
                }
                continue;
            }
            for (int x = 0; x < pdp[l][r][0].size(); x++) {
                auto &f = pdp[l][r][0][x];
                auto &s = pdp[l][r][1][x];
                if (w[l] == x) {
                    chmax(f, w[l] + pdp[l + 1][r][0][0]);
                    chmax(s, w[l] + pw[r + 1] - pw[l + 1] - pdp[l + 1][r][0][0]);
                } else if (w[l] > x){
                    chmax(f, w[l] + pw[r + 1] - pw[l + 1] - pdp[l + 1][r][1][w[l] - x]);
                    chmax(s, w[l] + pw[r + 1] - pw[l + 1] - pdp[l + 1][r][0][w[l] - x]);
                } else {
                    chmax(f, w[l] + pdp[l + 1][r][0][x - w[l]]);
                    chmax(s, w[l] + pdp[l + 1][r][1][x - w[l]]);
                }
                if (w[r] == x) {
                    chmax(f, w[r] + sdp[l][r - 1][0][0]);
                    chmax(s, w[r] + pw[r] - pw[l] - sdp[l][r - 1][0][0]);
                } else if (w[r] > x) {
                    chmax(f, w[r] + pw[r] - pw[l] - sdp[l][r - 1][1][w[r] - x]);
                    chmax(s, w[r] + pw[r] - pw[l] - sdp[l][r - 1][0][w[r] - x]);
                } else {
                    chmax(f, w[r] + sdp[l][r - 1][0][x - w[r]]);
                    chmax(s, w[r] + sdp[l][r - 1][1][x - w[r]]);
                }
            }
            int ptr0 = r;
            int s0 = 0;
            for (int x = 0; x < sdp[l][r][0].size(); x++) {
                auto &f = sdp[l][r][0][x];
                auto &s = sdp[l][r][1][x];
                if (w[l] == x) {
                    chmax(f, w[l] + sdp[l + 1][r][0][0]);
                    chmax(s, w[l] + pw[r + 1] - pw[l + 1] - sdp[l + 1][r][0][0]);
                } else if (w[l] < x) {
                    chmax(f, w[l] + sdp[l + 1][r][0][x - w[l]]);
                    chmax(s, w[l] + sdp[l + 1][r][1][x - w[l]]);
                } else {
                    chmax(f, w[l] + pw[r + 1] - pw[l + 1] - pdp[l + 1][r][1][w[l] - x]);
                    chmax(s, w[l] + pw[r + 1] - pw[l + 1] - pdp[l + 1][r][0][w[l] - x]);
                }
                if (w[r] == x) {
                    chmax(f, w[r] + sdp[l][r - 1][0][0]);
                    chmax(s, w[r] + pw[r] - pw[l] - sdp[l][r - 1][0][0]);
                } else if (w[r] > x) {
                    chmax(f, w[r] + pw[r] - pw[l] - sdp[l][r - 1][1][w[r] - x]);
                    chmax(s, w[r] + pw[r] - pw[l] - sdp[l][r - 1][0][w[r] - x]);
                }
                while (ptr0 >= l && s0 + w[ptr0] <= x) {
                    s0 += w[ptr0];
                    ptr0--;
                }
                if (ptr0 == l - 1) {
                    chmax(f, s0);
                    chmax(s, s0);
                } else {
                    assert(x - s0 < sdp[l][ptr0][0].size());
                    chmax(f, s0 + sdp[l][ptr0][0][x - s0]);
                    if (x == s0) {
                        chmax(s, s0 - sdp[l][ptr0][0][x - s0] + pw[ptr0 + 1] - pw[l]);
                    } else {
                        chmax(s, s0 + sdp[l][ptr0][1][x - s0]);
                    }
                    /*
                    if (ptr0 != r) {
                        s0 -= w[ptr0];
                        ptr0++;
                        ptr0--;
                        chmax(f, s0 + sdp[l][ptr0][0][x - s0]);
                        if (x == s0) {
                            chmax(s, s0 - sdp[l][ptr0][0][x - s0] + pw[ptr0 + 1] - pw[l]);
                        } else {
                            chmax(s, s0 + sdp[l][ptr0][1][x - s0]);
                        }
                        s0 += w[ptr0];
                    }
                     */
                }
            }
        }
    }
    cout << pdp[0][n - 1][0][0] << " " << pw[n] - pdp[0][n - 1][0][0] << "\n";
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve_case();
    }
}
