#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using db = long double;

constexpr int N = 2000;

unordered_map<int, int> mp[N][N][2];

void test_case() {
    int n;
    cin >> n;
    vector<int> ws(n);
    for (int i = 0; i < n; i++) {
        cin >> ws[i];
    }
    vector<int> pw(n + 1);
    for (int i = 1; i <= n; i++) {
        pw[i] = pw[i - 1] + ws[i - 1];
    }
    auto get = [&](int l, int r) -> int {
        return pw[r + 1] - pw[l];
    };
    auto calc = [&](auto self, int l, int r, int w, bool f) -> int {
        if (l == r) return ws[l];
        if (mp[l][r][f].contains(w)) return mp[l][r][f][w];
        { // l++
            int nl = l, nr = r, nw = w;
            bool nf = f;
            nl++;
            if (ws[l] < w) {
                nw -= ws[l];
            } else if (ws[l] > w) {
                nw = ws[l] - w;
                nf = !f;
            } else if (ws[l] == w) {
                nw = 0;
                nf = 0;
            }
            mp[l][r][f][w] = ws[l] + (f == nf ? self(self, nl, nr, nw, nf) : get(nl, nr) - self(self, nl, nr, nw, nf));
        }
//        { // r--
//            int nl = l, nr = r, nw = w;
//            bool nf = f;
//            nr--;
//            if (ws[r] < w) {
//                nw -= ws[r];
//            } else if (ws[r] > w) {
//                nw = ws[r] - w;
//                nf = !f;
//            } else if (ws[r] == w) {
//                nw = 0;
//                nf = 0;
//            }
//            mp[l][r][f][w] = max(mp[l][r][f][w], ws[r] + (f == nf ? self(self, nl, nr, nw, nf) : get(nl, nr) - self(self, nl, nr, nw, nf)));
//        }
        return mp[l][r][f][w];
    };
    cout << calc(calc, 0, n - 1, 0, 0) << ' ' << pw[n] - calc(calc, 0, n - 1, 0, 0);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int tests = 1;
    // cin >> tests;
    while (tests--) {
        test_case();
    }
    return 0;
}
