#include <bits/stdc++.h>
#define allv(x) (x).begin(), (x).end()
#define sz(x) ((int)(x).size())
using namespace std;
using ll = long long;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

#ifdef DEBUG
const ll MAXN = 20, INF = 1e5;
#else
const ll MAXN = 1e5 + 10, INF = 1e9 + 57;
#endif

int w[MAXN];
int wpref[MAXN];
vector<int> dp[MAXN][MAXN][2];
int main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        wpref[i + 1] = wpref[i] + w[i];
    }
    for (int l = 0; l < n; l++) {
        for (int r = l; r < n; r++) {
            dp[l][r][0].resize(max(l == 0 ? 0 : w[l - 1], r == n - 1 ? 0 : w[r + 1]) + 1);
            dp[l][r][1].resize(max(l == 0 ? 0 : w[l - 1], r == n - 1 ? 0 : w[r + 1]) + 1);
        }
    }
    for (int i = 0; i < n; i++) {
        fill(allv(dp[i][i][0]), w[i]);
        fill(allv(dp[i][i][1]), w[i]);
    }
    for (int len = 2; len <= n; len++) {
        for (int l = 0, r; (r = l + len - 1) < n; l++) {
            for (int t = 0; t < sz(dp[l][r][0]); t++) {
                int W = wpref[r + 1] - wpref[l];
                dp[l][r][0][t] = max(w[l] <= t ? w[l] + dp[l + 1][r][0][t - w[l]] : W - dp[l + 1][r][1][w[l] - t],
                                     w[r] <= t ? w[r] + dp[l][r - 1][0][t - w[r]] : W - dp[l][r - 1][1][w[r] - t]);
                if (t == 0) {
                    dp[l][r][1][0] = -INF;
                    continue;
                }
                dp[l][r][1][t] = max(w[l] <  t ? w[l] + dp[l + 1][r][1][t - w[l]] : W - dp[l + 1][r][0][w[l] - t],
                                     w[r] <  t ? w[r] + dp[l][r - 1][1][t - w[r]] : W - dp[l][r - 1][0][w[r] - t]);

            }
        }
    }
    cout << dp[0][n - 1][0][0] << ' ' << wpref[n] - dp[0][n - 1][0][0] << endl;
	return 0;
}

