#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

typedef long long ll;

const ll MOD = 1e9 + 7;
const ll INF = 1e18 + 9;

//#pragma GCC optimize("unroll-loops,inline,02,03,Ofast")
//#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,fma,mmx,sse,sse2,sse3,sse4,ssse3")

void solve1(ll n, vector<ll> &a) {

    sort(a.begin(), a.end());

    if (n == 1) {
        cout << a[0] << " " << 0;
    }
    if (n == 2) {
        cout << a[1] << " " << a[0];
    }
    if (n == 3) {
        if (a[2] > a[0] + a[1]) {
            cout << a[2] << " " << a[0] + a[1];
        }
        else {
            cout << a[0] + a[1] << " " << a[2];
        }
    }
}

void solve2(ll n, vector<ll> &a) {

    ll cnt2 = 0, cnt1 = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == 1) {
            cnt1++;
        }
        else {
            cnt2++;
        }
    }
    ll ans1 = 0, ans2 = 0;
    if (cnt2 % 2 == 0) {
        ans1 += cnt2;
        ans2 += cnt2;
        if (cnt1 % 2 == 0) {
            ans1 += cnt1 / 2;
            ans2 += cnt1 / 2;
        }
        else {
            ans1 += cnt1 / 2 + 1;
            ans2 += cnt1 / 2;
        }
    }
    else {
        ans1 += cnt2 + 2;
        ans2 += cnt2;
        if (cnt1 % 2 == 0) {
            ans1 += cnt1 / 2;
            ans2 += cnt1 / 2;
        }
        else {
            ans1 += cnt1 / 2;
            ans2 += cnt1 / 2 + 1;
        }
    }
    cout << ans1 << " " << ans2;
}

void solve() {

    bool flag2 = true;
    ll n = 0;
    cin >> n;
    vector<ll> a;

    for (int i = 0; i < n; i++) {
        ll x = 0;
        cin >> x;
        if (x > 2) {
            flag2 = false;
        }
        a.push_back(x);
    }

    if (n <= 3) {
        solve1(n, a);
        return;
    }
    if (flag2) {
        solve2(n, a);
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}
