#include <bits/stdc++.h>

using namespace std;

//#define int long long

using ll = long long;
using ld = long double;
using li = __int128;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int inf = 1e18;
const int maxn = 2e5 + 10;
const int mod = 1e9 + 7;
const int maxs = 1e4 + 10;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &x : a) cin >> x;
    vector<vector<vector<pii>>> dp(n, vector<vector<pii>> (n, vector<pii> (2 * maxs, {0, 0})));

    for (int i = 0; i < n; ++i) {
        for (int g = 0; g < 2 * maxs; ++g) {
            if (g > maxs) {
                dp[i][i][g] = {0, a[i]};
            } else {
                dp[i][i][g] = {a[i], 0};
            }
        }
    }

    for (int len = 2; len <= n; ++len) {
        for (int i = 0; i + len - 1 < n; ++i) {
            for (int g = max(a[i + len - 1], a[i]); g + max(a[i], a[i + len - 1]) < 2 * maxs; ++g) {
                //cout << i << " " << i + len - 1 << " " << g << endl;
                if (g > maxs) {
                    int v1 = dp[i][i + len - 2][g - a[i + len - 1]].second;
                    int v2 = dp[i + 1][i + len - 1][g - a[i]].second;
                    if (v1 + a[i + len - 1] > v2 + a[i]) {
                        dp[i][i + len - 1][g] = {dp[i][i + len - 2][g - a[i + len - 1]].first, v1 + a[i + len - 1]};
                    } else {
                        dp[i][i + len - 1][g] = {dp[i + 1][i + len - 1][g - a[i]].first, v2 + a[i]};
                    }
                } else {
                    int v1 = dp[i][i + len - 2][g + a[i + len - 1]].first;
                    int v2 = dp[i + 1][i + len - 1][g + a[i]].first;
                    if (v1 + a[i + len - 1] > v2 + a[i]) {
                        dp[i][i + len - 1][g] = {v1 + a[i + len - 1], dp[i][i + len - 2][g + a[i + len - 1]].second};
                    } else {
                        dp[i][i + len - 1][g] = {v2 + a[i], dp[i + 1][i + len - 1][g + a[i]].second};
                    }
                }
                //cout << dp[i][len + i - 1][g].first << " " << dp[i][len + i - 1][g].second << endl;
            }
        }
    }
    cout << dp[0][n - 1][maxs].first << " " << dp[0][n - 1][maxs].second;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int ttp = 1;
    //cin >> ttp;
    while (ttp--) {
        solve();
        cout << endl;
    }
}