#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
#define all(a) a.begin(), a.end()

const ll L = 1e14, R = 1e10, A = 1e5;

int n;
vector<int> w;

void sub1() {
    if (w[0] + w[1] <= w[2]) {
        cout << w[2] << " " << w[1] + w[0];
    } else {
        cout << w[0] + w[1] << " " << w[2];
    }
    exit(0);
}

unordered_map<ll, pii> mp;

inline ll getHash(int l, int r, int a, int b) {
    return L * l + R * r + A * a + b;
}

pii solve(int l, int r, int a, int b) {
    ll h = getHash(l, r, a, b);
    if (mp.find(h) == mp.end()) {
        if (a > 0 && b > 0) {
            mp[h] = solve(l, r, a - min(a, b), b - min(a, b));
        } else if (l == r) {
            if (a == 0) mp[h] = {w[l], 0};
            else mp[h] = {0, w[l]};
        } else if (a == 0) {
            auto [a1, b1] = solve(l + 1, r, w[l], b);
            auto [a2, b2] = solve(l, r - 1, w[r], b);
            if (a1 + w[l] > a2 + w[r]) mp[h] = {a1 + w[l], b1};
            else mp[h] = {a2 + w[r], b2};
        } else if (b == 0) {
            auto [a1, b1] = solve(l + 1, r, a, w[l]);
            auto [a2, b2] = solve(l, r - 1, a, w[r]);
            if (b1 + w[l] > b2 + w[r]) mp[h] = {a1, b1 + w[l]};
            else mp[h] = {a2, b2 + w[r]};
        }
    }
    return mp[h];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    w.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    if (n == 3) {
        sub1();
    }
    auto [a, b] = solve(0, n - 1, 0, 0);
    cout << a << " " << b;
}
