#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

// #pragma GCC optimize("O3")

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int>& a) {
    out << "| " << a.first << " " << a.second << " | ";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
constexpr long long N = 6e5 + 556;
constexpr long long T = 20;
constexpr long long A = 26;
constexpr double eps = 1e-9;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int ans1 = 0, ans2 = 0;
    int t1 = 0, t2 = 0;

    for (int i = n - 1; i >= 0; i--) {
        if (t1 <= t2) {
            t1 += a[i];
        } else {
            t2 += a[i];
        }
    }

    cout << t1 << " " << t2 << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}