#pragma GCC optimize("Ofast")
#pragma GCC optimize("avx")
#pragma GCC optimize("avx2")
#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <unordered_map>

using namespace std;


vector<int> l;
vector<vector<unordered_map<int, pair<int, int>>>> a0;
vector<vector<unordered_map<int, pair<int, int>>>> b0;

int max1 = 0;
int max2 = 0;

pair<int, int> operator + (pair<int, int> a, pair<int, int> b) {
	return { a.first + b.first, a.second + b.second };
}

pair<int, int> solve(int left, int right, int aChewing, int bChewing) {
	if (left > right) return { 0, 0 };
	if (aChewing <= bChewing) {
		bChewing -= aChewing;
		aChewing = 0;
		if (a0[left][right].count(bChewing) == 1) return a0[left][right][bChewing];
	}
	else {
		aChewing -= bChewing;
		bChewing = 0;
		if (b0[left][right].count(aChewing) == 1) return b0[left][right][aChewing];
	}
	pair<int, int> u;
	if (aChewing == 0) {
		pair<int, int> u1 = solve(left + 1, right, l[left], bChewing);
		u1.first += l[left];
		pair<int, int> u2 = solve(left, right - 1, l[right], bChewing);
		u2.first += l[right];
		if (u1.first >= u2.first) u = u1;
		else u = u2;
		a0[left][right][bChewing] = u;
	}
	else if (bChewing == 0) {
		pair<int, int> u1 = solve(left + 1, right, aChewing, l[left]);
		u1.second += l[left];
		pair<int, int> u2 = solve(left, right - 1, aChewing, l[right]);
		u2.second += l[right];
		if (u1.second >= u2.second) u = u1;
		else u = u2;
		b0[left][right][aChewing] = u;
	}
	return u;
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	l = vector<int>(n);
	for (int i = 0; i < n; i++) cin >> l[i];
	a0 = vector<vector<unordered_map<int, pair<int, int>>>>(n, vector<unordered_map<int, pair<int, int>>>(n));
	b0 = vector<vector<unordered_map<int, pair<int, int>>>>(n, vector<unordered_map<int, pair<int, int>>>(n));

	sort(l.begin(), l.end());
	pair<int, int> u = solve(0, n - 1, 0, 0);
	cout << u.first << " " << u.second;




}

/*

Левая и правая границы отрезка оставшихся - 4 * 1e6
Сколько им осталось есть - 4 * 1e8

2 дп

1) Алиса поела

2) Боб поел

n^2 * Wi * 2

*/
