#include <bits/stdc++.h>

#define fi first
#define se second  

#define pb push_back
#define sz(x) (int)x.size()

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, a) for(auto& x: a)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int N = 2e3 + 1;

int a[N];
int sum = 0;

int diff = 1e9;
pii ans;

vector<int> path1;
vector<int> path2;

void rec1(int sum1, int sum2, int l, int r) {
    if(l > r) {
        if(sum1 == ans.fi && sum2 == ans.se) {
            fe (x, path1) {
                cout << x << " ";
            }
            cout << endl;

            fe(x, path2) {
                cout << x << " ";
            }
            cout << endl;
            cout << endl;
        }
        return;
    }

    if(sum1 <= sum2) {
        path1.pb(a[l]);
        rec1(sum1 + a[l], sum2, l + 1, r);
        path1.pop_back();
        path1.pb(a[r]);
        rec1(sum1 + a[r], sum2, l, r - 1);
        path1.pop_back();
    } else {
        path2.pb(a[l]);
        rec1(sum1, sum2 + a[l], l + 1, r);
        path2.pop_back();
        path2.pb(a[r]);
        rec1(sum1, sum2 + a[r], l, r - 1);
        path2.pop_back();
    }
}

void rec(int sum1, int sum2, int l, int r) {
    if(l > r) {
        if(abs(sum1 - sum2) < diff || (abs(sum1 - sum2) == diff && sum1 - sum2 > ans.fi - ans.se)) {
            diff = abs(sum1 - sum2);
            ans = {sum1, sum2};
        }
        return;
    }

    if(sum1 <= sum2) {
        rec(sum1 + a[l], sum2, l + 1, r);
        rec(sum1 + a[r], sum2, l, r - 1);
    } else {
        rec(sum1, sum2 + a[l], l + 1, r);
        rec(sum1, sum2 + a[r], l, r - 1);
    }
}

int main() {
    int n;
    cin >> n;

    fr (i, 0, n - 1) {
        cin >> a[i];
        sum += a[i];
    }

    if(n == 3) {
        rec(0, 0, 0, n - 1);
        rec1(0, 0, 0, n - 1);

        cout << ans.fi << " " << ans.se << endl;
    } else {
        int sum1 = 0, sum2 = 0;
        int r = n - 2;
    sum1 = a[n - 1];

    while(r >= 0) {
        if(sum1 <= sum2) {
            sum1 += a[r--];
        } else {
            sum2 += a[r--];
        }
    }

    cout << sum1 << " " << sum2 << endl;
    }

    return 0;
}