#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int W = 20005;

void solve() {
    int n; cin >> n;
    vector<ll> a(n);
    for (auto &x : a) cin >> x;

    vector<vector<bool>> dp(n+1, vector<bool> (W));
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = a[i-1]; j < W; j++) {
            dp[i][j] = dp[i][j] | dp[i-1][j - a[i-1]];
        }
        for (int j = 0; j < W; j++) {
            dp[i][j] = dp[i][j] | dp[i-1][j];
        }
    }

    int allW = accumulate(a.begin(), a.end(), 0);
    int abest = -(int)1e9, bbest = (int)1e9;
    for (int i = 0; i <= allW; i++) {
        if (dp[n][i] && dp[n][allW - i] && abs(abest - bbest) > abs(allW - 2*i)) {
            abest = i;
            bbest = allW - i;
        }
    }

    cout << min(abest, bbest) << " " << max(abest, bbest);
}

void fromFile() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0); cout.tie(0);

  //  fromFile();

    int gg = 1;
//    cin >> gg;

    while (gg--) {
        solve();
    }

    return 0;
}