#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock::now().time_since_epoch().count()
//#define int long long

using namespace std;
typedef long double ld;

constexpr uint8_t STEP = 17;
constexpr uint32_t MAXN = 2E3, BL_SZ = 316, CNT_BL = (MAXN + BL_SZ - 1) / BL_SZ;
constexpr uint32_t MAXC = 2E4;
constexpr int32_t INF = 1E9;
constexpr int64_t INFl = 1E18;

constexpr uint32_t RND_SEED = 7200;
mt19937_64 rnd(RND_SEED);

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

uint16_t n;
uint16_t mas[MAXN], pref[MAXN + 1];
unordered_map <uint64_t, uint16_t> dp;
uint64_t unite(uint16_t len_pref, uint16_t len_suf, uint16_t ost_tm, bool bob_turn)
{
	return (uint64_t(len_pref) << 49) ^ (uint64_t(len_suf) << 33) ^ (uint64_t(ost_tm) << 17) ^ bob_turn;
}
uint16_t get_val(uint16_t len_pref, uint16_t len_suf, uint16_t ost_tm, bool bob_turn)
{
	uint64_t cd = unite(len_pref, len_suf, ost_tm, bob_turn);
	if (!dp.count(cd))
	{
		if (len_pref + len_suf == n)
		{
			return dp[cd] = 0;
		}
		uint16_t val_pref, val_suf;
		if (bob_turn)
		{
			if (mas[len_pref] < ost_tm)
			{
				val_pref = get_val(len_pref + 1, len_suf, ost_tm - mas[len_pref], true);
			}
			else
				val_pref = (pref[n - len_suf] - pref[len_pref + 1]) - get_val(len_pref + 1, len_suf, mas[len_pref] - ost_tm, false);
			if (mas[n - len_suf - 1] < ost_tm)
			{
				val_suf = get_val(len_pref, len_suf + 1, ost_tm - mas[n - len_suf - 1], true);
			}
			else
			{
				val_suf = (pref[n - len_suf - 1] - pref[len_pref]) - get_val(len_pref, len_suf + 1, mas[n - len_suf - 1] - ost_tm, false);
			}
		}
		else
		{
			if (mas[len_pref] <= ost_tm)
			{
				val_pref = get_val(len_pref + 1, len_suf, ost_tm - mas[len_pref], false);
			}
			else
				val_pref = (pref[n - len_suf] - pref[len_pref + 1]) - get_val(len_pref + 1, len_suf, mas[len_pref] - ost_tm, true);
			if (mas[n - len_suf - 1] <= ost_tm)
			{
				val_suf = get_val(len_pref, len_suf + 1, ost_tm - mas[n - len_suf - 1], false);
			}
			else
			{
				val_suf = (pref[n - len_suf - 1] - pref[len_pref]) - get_val(len_pref, len_suf + 1, mas[n - len_suf - 1] - ost_tm, true);
			}
		}
		dp[cd] = max(mas[len_pref] + val_pref, mas[n - len_suf - 1] + val_suf);
	}
	return dp[cd];
}

void solve()
{
	cin >> n;
	for (uint16_t i = 0; i < n; i++)
	{
		cin >> mas[i];
		pref[i + 1] = pref[i] + mas[i];
	}

	uint16_t win_al = get_val(0, 0, 0, false);
	cout << win_al << ' ' << pref[n] - win_al;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
		cout << endl;
	}
}