#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<ll, ll>;
using ld = long double;

template<typename T, typename F>
istream &operator>>(istream &s, pair<T, F> &a) {
    s >> a.first >> a.second;
    return s;
}

template<typename T, typename F>
ostream &operator<<(ostream &s, pair<T, F> &a) {
    s << a.first << ' ' << a.second << '\n';
    return s;
}

template<typename T>
istream &operator>>(istream &s, vector<T> &a) {
    for (T &el: a) {
        s >> el;
    }
    return s;
}

template<typename T>
ostream &operator<<(ostream &s, vector<T> &a) {
    for (T el: a) {
        s << el << ' ';
    }
    s << '\n';
    return s;
}

const int maxn = 211, maxval = 1011, maxval1 = 40011, maxval2 = 5;
int dp[maxn][maxn][maxval * 2];
int pref[2011], suff[2011], w[2011];
int dp1[4][4][maxval1 * 2];
int dp2[2011][2011][maxval2 * 2];

int sum(int l, int r) {
    if (r == -1) {
        return 0;
    }
    return pref[r] - (l > 0 ? pref[l - 1] : 0);
}

void solve() {
    int n;
    cin >> n;
    int mxwg = 0;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        mxwg = max(mxwg, w[i]);
    }
    pref[0] = w[0];
    for (int i = 1; i < n; i++) {
        pref[i] = pref[i - 1] + w[i];
    }
    suff[n - 1] = w[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        suff[i] = suff[i + 1] + w[i];
    }
    if (mxwg <= 2) {
        for (int lg = 1; lg <= n; lg++) {
            for (int l = 0; l + lg - 1 < n; l++) {
                int r = l + lg - 1;
                for (int delta = -2; delta <= 2; delta++) {
                    if (delta <= 0) {
                        //first selects now
                        //use arr[l]
                        if (delta + w[l] > 0) {
                            //second selects then
                            dp2[l][r][delta + maxval2] = max(dp2[l][r][delta + maxval2],
                                                             w[l] + sum(l + 1, r) -
                                                             dp2[l + 1][r][(delta + w[l]) + maxval2]);
                        } else {
                            dp2[l][r][delta + maxval2] = max(dp2[l][r][delta + maxval2],
                                                             w[l] + dp2[l + 1][r][(delta + w[l]) + maxval2]);
                        }
                        //use arr[r]

                        if (delta + w[r] > 0) {
                            //second selects then
                            dp2[l][r][delta + maxval2] = max(dp2[l][r][delta + maxval2],
                                                             w[r] + sum(l, r - 1) -
                                                             (r > 0 ? dp2[l][r - 1][(delta + w[r]) + maxval2] : 0));
                        } else {
                            dp2[l][r][delta + maxval2] = max(dp2[l][r][delta + maxval2],
                                                             w[r] +
                                                             (r > 0 ? dp2[l][r - 1][(delta + w[r]) + maxval2] : 0));
                        }
                    } else {
                        //second selects now
                        //use arr[l]

                        if (delta - w[l] > 0) {
                            //second selects then
                            dp2[l][r][delta + maxval2] = max(dp2[l][r][delta + maxval2],
                                                             w[l] + dp2[l + 1][r][(delta - w[l]) + maxval2]);
                        } else {
                            //first selects then
                            dp2[l][r][delta + maxval2] = max(dp2[l][r][delta + maxval2], w[l] + sum(l + 1, r) -
                                                                                         dp2[l + 1][r][(delta - w[l]) +
                                                                                                       maxval2]);
                        }

                        //use arr[r]
                        if (delta - w[r] > 0) {
                            //second selects then
                            dp2[l][r][delta + maxval2] = max(dp2[l][r][delta + maxval2],
                                                             w[r] +
                                                             (r > 0 ? dp2[l][r - 1][(delta - w[r]) + maxval2] : 0));
                        } else {
                            //first selects then
                            dp2[l][r][delta + maxval2] = max(dp2[l][r][delta + maxval2], w[r] + sum(l, r - 1) -
                                                                                         (r > 0 ? dp2[l][r - 1][
                                                                                                 (delta - w[r]) +
                                                                                                 maxval2] : 0));
                        }
                    }

                }
            }
        }
        cout << dp2[0][n - 1][0 + maxval2] << ' ' << pref[n - 1] - dp2[0][n - 1][0 + maxval2];
        return;
    } else if (n == 3) {
        for (int lg = 1; lg <= n; lg++) {
            for (int l = 0; l + lg - 1 < n; l++) {
                int r = l + lg - 1;
                for (int delta = -20000; delta <= 20000; delta++) {
                    if (delta <= 0) {
                        //first selects now
                        //use arr[l]
                        if (delta + w[l] > 0) {
                            //second selects then
                            dp1[l][r][delta + maxval1] = max(dp1[l][r][delta + maxval1],
                                                             w[l] + sum(l + 1, r) -
                                                             dp1[l + 1][r][(delta + w[l]) + maxval1]);
                        } else {
                            dp1[l][r][delta + maxval1] = max(dp1[l][r][delta + maxval1],
                                                             w[l] + dp1[l + 1][r][(delta + w[l]) + maxval1]);
                        }
                        //use arr[r]

                        if (delta + w[r] > 0) {
                            //second selects then
                            dp1[l][r][delta + maxval1] = max(dp1[l][r][delta + maxval1],
                                                             w[r] + sum(l, r - 1) -
                                                             (r > 0 ? dp1[l][r - 1][(delta + w[r]) + maxval1] : 0));
                        } else {
                            dp1[l][r][delta + maxval1] = max(dp1[l][r][delta + maxval1],
                                                             w[r] +
                                                             (r > 0 ? dp1[l][r - 1][(delta + w[r]) + maxval1] : 0));
                        }
                    } else {
                        //second selects now
                        //use arr[l]

                        if (delta - w[l] > 0) {
                            //second selects then
                            dp1[l][r][delta + maxval1] = max(dp1[l][r][delta + maxval1],
                                                             w[l] + dp1[l + 1][r][(delta - w[l]) + maxval1]);
                        } else {
                            //first selects then
                            dp1[l][r][delta + maxval1] = max(dp1[l][r][delta + maxval1], w[l] + sum(l + 1, r) -
                                                                                         dp1[l + 1][r][(delta - w[l]) +
                                                                                                       maxval1]);
                        }

                        //use arr[r]
                        if (delta - w[r] > 0) {
                            //second selects then
                            dp1[l][r][delta + maxval1] = max(dp1[l][r][delta + maxval1],
                                                             w[r] +
                                                             (r > 0 ? dp1[l][r - 1][(delta - w[r]) + maxval1] : 0));
                        } else {
                            //first selects then
                            dp1[l][r][delta + maxval1] = max(dp1[l][r][delta + maxval1], w[r] + sum(l, r - 1) -
                                                                                         (r > 0 ? dp1[l][r - 1][
                                                                                                 (delta - w[r]) +
                                                                                                 maxval1] : 0));
                        }
                    }

                }
            }
        }
        cout << dp1[0][n - 1][0 + maxval1] << ' ' << pref[n - 1] - dp1[0][n - 1][0 + maxval1];
        return;
    }
    for (int lg = 1; lg <= n; lg++) {
        for (int l = 0; l + lg - 1 < n; l++) {
            int r = l + lg - 1;
            for (int delta = -500; delta <= 500; delta++) {
                if (delta <= 0) {
                    //first selects now
                    //use arr[l]
                    if (delta + w[l] > 0) {
                        //second selects then
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[l] + sum(l + 1, r) - dp[l + 1][r][(delta + w[l]) + maxval]);
                    } else {
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[l] + dp[l + 1][r][(delta + w[l]) + maxval]);
                    }
                    //use arr[r]

                    if (delta + w[r] > 0) {
                        //second selects then
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[r] + sum(l, r - 1) - dp[l][r - 1][(delta + w[r]) + maxval]);
                    } else {
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[r] + dp[l][r - 1][(delta + w[r]) + maxval]);
                    }
                } else {
                    //second selects now
                    //use arr[l]

                    if (delta - w[l] > 0) {
                        //second selects then
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[l] + dp[l + 1][r][(delta - w[l]) + maxval]);
                    } else {
                        //first selects then
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[l] + sum(l + 1, r) - dp[l + 1][r][(delta - w[l]) + maxval]);
                    }

                    //use arr[r]
                    if (delta - w[r] > 0) {
                        //second selects then
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[r] + dp[l][r - 1][(delta - w[r]) + maxval]);
                    } else {
                        //first selects then
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[r] + sum(l, r - 1) - dp[l][r - 1][(delta - w[r]) + maxval]);
                    }
                }

            }
        }
    }
    cout << dp[0][n - 1][0 + maxval] << ' ' << pref[n - 1] - dp[0][n - 1][0 + maxval];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
