#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

const int MAXN = 503, LOGN = 18, LOGV = 30;

const ll INF = 1ll << 30;

map<int, int> mem[MAXN][MAXN];

int a[MAXN];

ll calc(int l, int r, int sl) {
    if (l == r) {
        return a[l] - sl;
    }
    if (mem[l][r].find(sl) != mem[l][r].end())
        return mem[l][r][sl];
    int al = a[l], ar = a[r];
    ll ans = -INF;
    if (sl >= ar)
        ans = max(ans, calc(l, r - 1, sl - ar));
    else
        ans = max(ans, -calc(l, r - 1, ar - sl));

    if (sl >= al)
        ans = max(ans, calc(l + 1, r, sl - al));
    else
        ans = max(ans, -calc(l + 1, r, al - sl));
    mem[l][r][sl] = ans;
    return ans;
}

void solve() {
    ll n;
    cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i] *= 2;
    }

    ll dif = calc(0, n - 1, 1);
    dif = (dif + 1) / 2;
    ll sum = 0;
    for (int i = 0; i < n; ++i)
        sum += a[i];
    sum /= 2;
    ll ta = (dif + sum) / 2, tb = sum - ta;
    //cout << dif << endl;
    cout << ta << ' ' << tb << endl;


}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
