//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#define fast ios_base::sync_with_stdio(0); cin.tie(0)
#pragma GCC optimize("unroll-loops,O3")
#pragma GCC optimize("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
typedef tree<int, null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

/*
struct chash {
    size_t operator()(const point &key) const {
        return key.x * key.x;
    }
};
*/

void solve3(int n, vector<int> a) {
    int ans = a.back();
    int ans2 = 0;
    for (int i = 0; i < n - 1; ++i) ans2 += a[i];
    cout << max(ans, ans2) << " " << min(ans, ans2);
    exit(0);
}

void solve2(int n, vector<int> &a) {
    int sum1 = 0, sum2 = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] == 1) sum1 += 1;
        else sum2 += 2;
    }
    int ans2 = sum2 / 4 * 2;
    sum2 -= ans2;
    int ans1 = sum2;
    int x = min(ans1 - ans2, sum1);
    ans2 += x;
    sum1 -= x;
    ans2 += sum1 / 2;
    ans1 += (sum1 + 1) / 2;
    cout << ans1 << " " << ans2 << endl;
    exit(0);
}

signed main() {
    fast;
    int n;
    cin >> n;
    vector<int> a(n);
    bool ok = true;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (a[i] > 2) ok = false;
    }
    if (n <= 3) solve3(n, a);
    if (ok) solve2(n, a);
    int maxw = 2000;
    vector<vector<vector<int>>> can(maxw + 1, vector<vector<int>> (maxw + 1, vector<int> (n + 1)));
    can[0][0][0] = true;
    sort(a.begin(), a.end(), greater<>());
    for (int i = 0; i <= maxw; ++i) {
        for (int j = 0; j <= maxw; ++j) {
            for (int k = 0; k < n; ++k) {
                if (i + a[k] <= maxw && i <= j) {
                    can[i + a[k]][j][k + 1] |= can[i][j][k];
                }
                if (j + a[k] <= maxw && i > j) {
                    can[i][j + a[k]][k + 1] |= can[i][j][k];
                }
            }
        }
    }
    int ans1 = 0, ans2 = 0;
    for (int i = 0; i <= maxw; ++i) {
        for (int j = 0; j <= maxw; ++j) {
            if (can[i][j][n]) {
                if (i > ans1) {
                    ans1 = i, ans2 = j;
                } else if (i == ans1 && j > ans2) {
                    ans2 = j;
                }
            }
        }
    }
    cout << ans1 << " " << ans2;
    return 0;
}
