#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")
//#pragma GCC optimize("unroll-loops")

using namespace std;

using ll = long long;
const char endc = '\n';

using namespace std;

// dp[in left][int right][alice time]
int n;
vector<int> pieces, pref, suf;
map<tuple<short, short, short>, int> mem;

int fillDp(int left, int right, int aliceTime) {
    int summary = pref[left] + suf[right];
    int bobTime = summary - aliceTime;
    if (left + right == n) return aliceTime;
    if (aliceTime <= bobTime) {
        auto resA = fillDp(left+1, right, aliceTime + pieces[left]);
        auto resB = fillDp(left, right+1, aliceTime + pieces[n-right-1]);
        return max(resA, resB);
    } else {
        auto resA = fillDp(left+1, right, aliceTime);
        auto resB = fillDp(left, right+1, aliceTime);
        return min(resA, resB);
    }
}

inline void work() {
    cin >> n;
    pieces.resize(n);
    for (auto& e : pieces) cin >> e;
    pref.resize(n+1, 0);
    suf.resize(n+1, 0);
    for (int i = 0; i < n; ++i) {
        int revInd = n-i-1;
        pref[i+1] = pref[i] + pieces[i];
        suf[i+1] = suf[i] + pieces[revInd];
    }
    auto ans = fillDp(0, 0, 0);
    cout << ans << ' ' << pref.back() - ans << endc;
}

signed main() {
    ios_base::sync_with_stdio(false);
    srand(int(time(nullptr)));
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    while (t-- > 0) work();
}