#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(a) a.begin(), a.end()

int mxW = 20'001;

enum {GIRL, BOY};

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int n;
    cin >> n;
    vector<int> w(n);
    mxW = 0;
    for (int i = 0; i< n; ++i) {
        cin >> w[i];
        mxW = max(mxW, w[i] + 1);
    }
    // sort(in(w));
    array<pair<ll, ll>, 2> defa{pair<ll, ll>{0, 0}, pair<ll, ll>{0, 0}};
    vector<vector<vector<array<pair<ll, ll>, 2>>>> 
    dp(n, vector<vector<array<pair<ll, ll>, 2>>>(n, vector<array<pair<ll, ll>, 2>>(mxW, defa)));
    
    for (int i = 0; i < n; ++i) {
        for (int wait = 0; wait < mxW; ++wait) {
            dp[i][i][wait][GIRL] = dp[i][i][wait][BOY] = {w[i], 0};
        }
    }
    for (int d = 2; d <= n; ++d) {
        for (int l = 0; l + d <= n; ++l) {
            int r = l + d - 1;
            for (int wait = 0; wait < mxW; ++wait) {
                // debug << l << ' ' << r << ' ' << wait << endl;
                for (int pers : {GIRL, BOY}) {
                    { // take w[l]
                        if (w[l] < wait || (w[l] == wait && pers == GIRL)) {
                            // dp[..][..][wait - w[i]]
                            auto val = dp[l + 1][r][wait - w[l]][pers];
                            val.first += w[l];

                            if (val.first > dp[l][r][wait][pers].first) {
                                dp[l][r][wait][pers] = val;
                            }
                        } 
                        else {
                            auto val = dp[l + 1][r][w[l] - wait][pers ^ 1];
                            swap(val.first, val.second);
                            val.first += w[l];

                            if (val.first > dp[l][r][wait][pers].first) {
                                dp[l][r][wait][pers] = val;
                            }
                        }
                    }
                    { // take w[r]
                        if (w[r] < wait || (w[r] == wait && pers == GIRL)) {
                            // dp[..][..][wait - w[i]]
                            auto val = dp[l][r - 1][wait - w[r]][pers];
                            val.first += w[r];

                            if (val.first > dp[l][r][wait][pers].first) {
                                dp[l][r][wait][pers] = val;
                            }
                        }
                        else {
                            auto val = dp[l][r - 1][w[r] - wait][pers ^ 1];
                            swap(val.first, val.second);
                            val.first += w[r];

                            if (val.first > dp[l][r][wait][pers].first) {
                                dp[l][r][wait][pers] = val;
                            }
                        }
                    }
                }
                 
            }
        }
    }
    // for (int l = 0; l <n ;++l) {
    //     for (int r = l; r < n; ++r) {
    //         debug << "(" << dp[l][r].first << ", " << dp[l][r].second << ") ";
    //     }
    //     debug << endl;
    // }
    cout << dp[0][n - 1][0][GIRL].first << ' ' << dp[0][n - 1][0][GIRL].second;
    return 0;
}