#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdint>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <numbers>
#include <bit>

using namespace std;

#define int int64_t

using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;


void operator %= (pii & a, pii b) {
    if (a.first != b.first) {
        if (a.first < b.first) {
            a = b;
        }
        return;
    }
    if (a.second < b.second) {
        a = b;
    }
}

void operator ^= (pii & a, pii b) {
    if (a.second != b.second) {
        if (a.second < b.second) {
            a = b;
        }
        return;
    }
    if (a.first < b.first) {
        a = b;
    }
}


pii operator + (pii a, pii b) {
    return {a.first + b.first, a.second + b.second};
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);



    int n;
    cin >> n;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    auto rw = w;
    reverse(rw.begin(), rw.end());

    if (w[2] > w[0] + w[1]) {
        cout << w[2] << " " << w[0] + w[1];
    } else {
        cout << w[0] + w[1] << " " << w[2];
    }



    return 0;

    const int MAXDIFF = 500;
    vector<vector<vector<vector<pii>>>> dp(n + 1, vector<vector<vector<pii>>> (n + 1,
                                                                               vector<vector<pii>> (MAXDIFF, vector<pii> (2, {-1e18, -1e18}))));

    dp[0][0][0][0] = {0, 0};
    dp[0][0][0][1] = {0, 0};
    for (int l = 0; l <= n; l++) {
        for (int r = 0; r + l <= n; r++) {
            /*
            if (l + 2 + r <= n) {
                dp[l + 2][r][w[l + 1] - w[l]][0] %= dp[l][r][0][0] + pii{w[l], w[l + 1]};
                dp[l + 2][r][w[l + 1] - w[l]][0] %= dp[l][r][0][1] + pii{w[l], w[l + 1]};
            }
            if (l + 2 + r <= n) {
                dp[l][r + 2][rw[r] - rw[r + 1]][1] %= dp[l][r][0][0] + pii{rw[r], rw[r + 1]};
                dp[l][r + 2][rw[r] - rw[r + 1]][1] %= dp[l][r][0][1] + pii{rw[r], rw[r + 1]};
            }
            if (l + 2 + r <= n) {
                dp[l + 1][r + 1][rw[r] - w[l]][0] %= dp[l][r][0][0] + pii{w[l], rw[r]};
                dp[l + 1][r + 1][rw[r] - w[l]][0] %= dp[l][r][0][1] + pii{w[l], rw[r]};
            }
            if (l + 2 + r <= n) {
                dp[l + 1][r + 1][rw[r] - w[l]][1] %= dp[l][r][0][0] + pii{rw[r], w[l]};
                dp[l + 1][r + 1][rw[r] - w[l]][1] %= dp[l][r][0][1] + pii{rw[r], w[l]};
            }
             */
            for (int d = 1; d < MAXDIFF; d++) {
                for (int win = 0; win < 2; win++) {
                    pii curl = {w[l], 0}, curr = {rw[r], 0};
                    if (win == 1) {
                        curl = {0, w[l]};
                        curr = {0, rw[r]};
                    }
                    if (win == 0) {
                        if (r + l + 1 <= n) {
                            if (d > w[l]) {
                                dp[l + 1][r][d - w[l]][win] %= dp[l][r][d][win] + curl;
                            } else if (d < w[l]) {
                                dp[l + 1][r][w[l] - d][1 - win] %= dp[l][r][d][win] + curl;
                            } else {
                                dp[l + 1][r][0][0] %= dp[l][r][d][win] + curl;
                            }
                            if (d > rw[r]) {
                                dp[l][r + 1][d - rw[r]][win] %= dp[l][r][d][win] + curr;
                            } else if (d < rw[r]) {
                                dp[l][r + 1][rw[r] - d][1 - win] %= dp[l][r][d][win] + curr;
                            } else {
                                dp[l][r + 1][0][0] %= dp[l][r][d][win] + curl;
                            }
                        }
                    } else {
                        if (r + l + 1 <= n) {
                            if (d > w[l]) {
                                dp[l + 1][r][d - w[l]][win] ^= dp[l][r][d][win] + curl;
                            } else if (d < w[l]) {
                                dp[l + 1][r][w[l] - d][1 - win] ^= dp[l][r][d][win] + curl;
                            } else {
                                dp[l + 1][r][0][0] ^= dp[l][r][d][win] + curl;
                            }
                            if (d > rw[r]) {
                                dp[l][r + 1][d - rw[r]][win] ^= dp[l][r][d][win] + curr;
                            } else if (d < rw[r]) {
                                dp[l][r + 1][rw[r] - d][1 - win] ^= dp[l][r][d][win] + curr;
                            } else {
                                dp[l][r + 1][0][0] ^= dp[l][r][d][win] + curl;
                            }
                        }
                    }
                }
            }
        }
    }

    pii ans = {0, 0};
    for (int l = 0; l <= n; l++) {
        int r = n - l;
        for (int d = 0; d < MAXDIFF; d++) {
            if (dp[l][r][d][1] == pii{15, 9}) {
                cout << l << " " << r << " " << d << "\n";
            }
            ans = max(ans, dp[l][r][d][0]);
            ans = max(ans, dp[l][r][d][1]);
        }
    }

    cout << ans.first << " " << ans.second << "\n";








    return 0;
}
