#pragma GCC optimize("Ofast, no-stack-protector")
#pragma GCC target("avx")
#pragma GCC target("sse")
#pragma GCC target("sse2")
#pragma GCC target("sse3")
#pragma GCC target("popcnt")
#pragma GCC target("abm")
#pragma GCC target("avx2")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("rename-registers")
#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 2000;
map <int, int> dp[MAXN][MAXN];
vector <int> w(MAXN);
int sum = 0;

int resh(int l, int r, int ost) {
    if (l == r) {
        if (ost >= 0) {
            return w[l];
        }
        return 0;
    }
    if (dp[l][r][ost] != 0) {
        return dp[l][r][ost];
    }
    if (ost >= 0) {
        dp[l][r][ost] = max(w[l] + resh(l + 1, r, ost - w[l]), w[r] + resh(l, r - 1, ost - w[r]));
    } else {
        dp[l][r][ost] = min(resh(l + 1, r, ost + w[l]), resh(l, r - 1, ost + w[r]));
    }
    return dp[l][r][ost];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        sum += w[i];
    }
    int ans = resh(0, n - 1, 0);
    cout << ans << " " << sum - ans << "\n";
}
