#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector <int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    vector <vector <vector <vector <pair <int, int>>>>> dp(2, vector <vector <vector <pair <int, int>>>> (n, vector <vector <pair <int, int>>> (2 * w[n - 1] + 1, vector <pair <int, int>> (2, {0, 0}))));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= w[n - 1]; ++j) {
            dp[0][i][j][0] = {w[i], 0};
            if (j != 0) {
                dp[0][i][j][1] = {w[i], 0};
            }
        }
    }
    int t1 = 1;
    int t2 = 0;
    for (int len = 2; len <= n; ++len) {
        for (int l = 0; l < n - len + 1; ++l) {
            for (int j = 0; j <= w[n - 1]; ++j) {
                pair <int, int> d1;
                if (w[l] <= j) {
                    d1 = dp[t2][l + 1][j - w[l]][0];
                    d1.first += w[l];
                } else {
                    d1 = {dp[t2][l + 1][w[l] - j][1].second, dp[t2][l + 1][w[l] - j][1].first};
                    d1.first += w[l];
                }

                pair <int, int> d2;
                if (w[l + len - 1] <= j) {
                    d2 = dp[t2][l][j - w[l + len - 1]][0];
                    d2.first += w[l + len - 1];
                } else {
                    d2 = {dp[t2][l][w[l + len - 1] - j][1].second, dp[t2][l][w[l + len - 1] - j][1].first};
                    d2.first += w[l + len - 1];
                }

                if (d1.first > d2.first) {
                    dp[t1][l][j][0] = d1;
                } else {
                    dp[t1][l][j][0] = d2;
                }
                //cout << " ok " << endl;

                ///
                if (j == 0) {
                    continue;
                }
                if (w[l] < j) {
                    d1 = dp[t2][l + 1][j - w[l]][1];
                    d1.first += w[l];
                } else {
                    d1 = {dp[t2][l + 1][w[l] - j][0].second, dp[t2][l + 1][w[l] - j][0].first};
                    d1.first += w[l];
                }

                if (w[l + len - 1] < j) {
                    d2 = dp[t2][l][j - w[l + len - 1]][1];
                    d2.first += w[l + len - 1];
                } else {
                    d2 = {dp[t2][l][w[l + len - 1] - j][0].second, dp[t2][l][w[l + len - 1] - j][0].first};
                    d2.first += w[l + len - 1];
                }

                if (d1.first > d2.first) {
                    dp[t1][l][j][1] = d1;
                } else {
                    dp[t1][l][j][1] = d2;
                }
                //cout << len << " len " << l << " l " << j << " j " << endl;
                //cout << dp[t1][l][j][0].first << " dp0 " << dp[t1][l][j][0].second << endl;
                //cout << dp[t1][l][j][1].first << " dp1 " << dp[t1][l][j][1].second << endl;
            }
        }
        swap(t1, t2);
    }
    cout << dp[t2][0][0][0].first << " " << dp[t2][0][0][0].second;
}

int main() {
    solve();
}
