#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend

mt19937 rnd(228);
//mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int hs(int l, int r, int d) {
    d += 20000;
    return l * 2000 * 20000 + r * 20000 + d;
}

void solve() {
    int n; cin >> n;
    vector <int> v(n);
    for (auto& x : v) cin >> x;

    int sm = accumulate(all(v), 0ll);
    int mx = *max_element(all(v));

    unordered_map <int, int> mp;
    function <int(int, int, int, int, int)> func = [&](int l, int r, int d, int a, int b) {
        if (r == l) return d;
        if (mp.count(hs(l, r, d))) return mp[hs(l, r, d)];

        if (d <= 0) {
            if (rnd() % 2) {
                int c = func(l + 1, r, d + v[l], a, b);
                if (c >= b) return mp[hs(l, r, d)] = c;
                c = max(c, func(l, r - 1, d + v[r - 1], c, b));
                return mp[hs(l, r, d)] = c;
            }
            else {
                int c = func(l, r - 1, d + v[r - 1], a, b);
                if (c >= b) return mp[hs(l, r, d)] = c;
                c = max(c, func(l + 1, r, d + v[l], c, b));
                return mp[hs(l, r, d)] = c;
            }
        }
        else {
            if (rnd() % 2) {
                int c = func(l + 1, r, d - v[l], a, b);
                if (c <= a) return mp[hs(l, r, d)] = c;
                c = min(c, func(l, r - 1, d - v[r - 1], a, c));
                return mp[hs(l, r, d)] = c;
            }
            else {
                int c = func(l, r - 1, d - v[r - 1], a, b);
                if (c <= a) return mp[hs(l, r, d)] = c;
                c = min(c, func(l + 1, r, d - v[l], a, c));
                return mp[hs(l, r, d)] = c;
            }
        }
    };
    int ans = func(0, n, 0, -mx, mx);

    if (ans >= 0) {
        int a = (sm - ans) / 2 + ans;
        cout << a << ' ' << sm - a << '\n';
    }
    else {
        int a = (sm + ans) / 2;
        cout << a << ' ' << sm - a << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }

    return 0;
}
