#ifdef LOCAL
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#define _GLIBCXX_DEBUG
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<array>
#include<algorithm>
#include<set>
#include<map>

using namespace std;

typedef long long ll;

struct Edge {
	ll v,u,w;
};

const ll INF=1e17+9;

ll ab(ll a,ll b,ll c) {
	if(a<=b) {return a+c;}
	else return a;
}

signed main() {
	ll n;
	cin>>n;
	if(n==3) {
		ll a,b,c;
		cin>>a>>b>>c;
		ll ares=max(min(ab(a,b,c),ab(a,c,b)),min(ab(c,a,b),ab(c,b,a)));
		cout<<ares<<' '<<a+b+c-ares;
		return 0;
	}
	vector<ll> w(n);
	ll cnt1=0,cnt2=0;
	for(auto &i:w) {
		cin>>i;
		if(i==1) {++cnt1;}
		else {++cnt2;}
	}
	ll sum=cnt1+cnt2*2;
	if(cnt1%2==1) {cout<<sum/2+1<<' '<<sum/2;return 0;}
	else if(cnt1==0 && cnt2%2==1) { cout<<sum/2+1<<' '<<sum/2-1;}
	else {cout<<sum/2<<' '<<sum/2;}
	return 0;
}








