#include <bits/stdc++.h>
using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream& cin, ostream& cout);


int test_cnt = 1, group, cur_test;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    // cin >> test_cnt;
    // cin >> group;
    for (cur_test = 0; cur_test < test_cnt; ++cur_test)
        solve(cin, cout);
}


map<ll, ll> hsh;
multiset<ll> a;
ll n, sum, hash_sum;


map<tuple<ll, ll, ll>, pair<ll, ll>> cc;
pair<ll, ll> dfs(const ll tm_a, const ll tm_b) {
    if (a.empty())
        return {tm_a, tm_b};
    if (cc.find(make_tuple(hash_sum, tm_a, tm_b)) != cc.end())
        return cc[make_tuple(hash_sum, tm_a, tm_b)];
    auto& zn = cc[make_tuple(hash_sum, tm_a, tm_b)];


    ll w1 = *a.begin();
    ll w2 = *(--a.end());
    if (a.size() == 2)
        return (tm_a <= tm_b) ? make_pair(tm_a + w2, tm_b + w1) : make_pair(tm_a + w1, tm_b + w2);


    if (tm_a <= tm_b) {
        sum -= w1;
        hash_sum -= hsh[w1];
        a.erase(a.begin());
        auto [a1, b1] = dfs(tm_a + w1, tm_b);
        a.insert(w1);
        hash_sum += hsh[w1];
        sum += w1;

        sum -= w2;
        hash_sum -= hsh[w2];
        a.erase(--a.end());
        auto [a2, b2] = dfs(tm_a + w2, tm_b);
        a.insert(w2);
        hash_sum += hsh[w2];
        sum += w2;

        return zn = (a1 >= a2) ? make_pair(a1, b1) : make_pair(a2, b2);
    } else {
        sum -= w1;
        hash_sum -= hsh[w1];
        a.erase(a.begin());
        auto [a1, b1] = dfs(tm_a, tm_b + w1);
        a.insert(w1);
        hash_sum += hsh[w1];
        sum += w1;

        sum -= w2;
        hash_sum -= hsh[w2];
        a.erase(--a.end());
        auto [a2, b2] = dfs(tm_a, tm_b + w2);
        a.insert(w2);
        hash_sum += hsh[w2];
        sum += w2;

        return zn = (b1 >= b2) ? make_pair(a1, b1) : make_pair(a2, b2);
    }
}


pair<ll, ll> dfs_old(const ll tm_a, const ll tm_b) {
    if (a.empty())
        return {tm_a, tm_b};


    ll w1 = *a.begin();
    ll w2 = *(--a.end());
    if (a.size() == 2)
        return (tm_a <= tm_b) ? make_pair(tm_a + w2, tm_b + w1) : make_pair(tm_a + w1, tm_b + w2);


    if (tm_a <= tm_b) {
        sum -= w1;
        a.erase(a.begin());
        auto [a1, b1] = dfs(tm_a + w1, tm_b);
        a.insert(w1);
        sum += w1;

        sum -= w2;
        a.erase(--a.end());
        auto [a2, b2] = dfs(tm_a + w2, tm_b);
        a.insert(w2);
        sum += w2;

        return (a1 >= a2) ? make_pair(a1, b1) : make_pair(a2, b2);
    } else {
        sum -= w1;
        a.erase(a.begin());
        auto [a1, b1] = dfs(tm_a, tm_b + w1);
        a.insert(w1);
        sum += w1;

        sum -= w2;
        a.erase(--a.end());
        auto [a2, b2] = dfs(tm_a, tm_b + w2);
        a.insert(w2);
        sum += w2;

        return (b1 >= b2) ? make_pair(a1, b1) : make_pair(a2, b2);
    }
}


mt19937 rnd(643643632);
void solve(istream& cin, ostream& cout) {
    cin >> n;
    for (ll i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        a.insert(x);
        sum += x;

        if (hsh.find(x) == hsh.end())
            hsh[x] = rnd();
        hash_sum += hsh[x];
    }

    if (n == 3) {
        auto [a1, b1] = dfs_old(0, 0);
        cout << a1 << ' ' << b1 << '\n';
        return;
    }

    auto [a1, b2] = dfs(0, 0);
    cout << a1 << ' ' << b2 << '\n';
}
