#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <assert.h>

#define ll int
#define all(x) x.begin(), x.end()
#define fi first
#define se second
#define ve vector

using namespace std;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int MAXN = 512, MAXW = 5012, MAXN2 = 2048, MAXW2 = 3;

ll dp[MAXN][MAXW][2];
ll pdp[MAXN][MAXW][2];
ll dp2[MAXN2][MAXN2][MAXW2][2];

int main() {
    int n;
    cin >> n;
    ve<ll> v(n);
    for (auto& i : v)
        cin >> i;
    sort(all(v));
    if (n == 3) {
        ll res = max(v[0] + v[1], v[2]);
        cout << res << " " << v[0] + v[1] + v[2] - res;
        return 0;
    }
    ve<ll> pref(n + 1, 0);
    for (int i = 1; i <= n; i++)
        pref[i] = pref[i - 1] + v[i - 1];
    if (v.back() <= 2) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j <= v.back(); j++)
                for (int k = 0; k < 2; k++)
                    dp2[i][i][j][k] = v[i];
            dp2[i][i][0][0] = 0;
        }
        for (int len = 1; len < n; len++)
            for (int l = 0; l + len < n; l++) {
                int r = l + len;
                ll res1 = pref[r + 1] - pref[l] - dp2[l + 1][r][v[l]][0];
                ll res2 = pref[r + 1] - pref[l] - dp2[l][r - 1][v[r]][0];
                dp2[l][r][0][1] = max(res1, res2);
                dp2[l][r][0][0] = pref[r + 1] - pref[l] - dp2[l][r][0][1];
                for (int k = 1; k <= v.back(); k++) {
                    for (int m = 0; m < 2; m++) {
                        ll res1 = 0;
                        if (k >= v[l])
                            res1 = v[l] + dp2[l + 1][r][k - v[l]][m];
                        else res1 = pref[r + 1] - pref[l] - dp2[l + 1][r][v[l] - k][1 - m];
                        ll res2 = 0;
                        if (k >= v[r])
                            res2 = v[r] + dp2[l][r - 1][k - v[r]][m];
                        else res2 = pref[r + 1] - pref[l] - dp2[l][r - 1][v[r] - k][1 - m];
                        dp2[l][r][k][m] = max(res1, res2);
                    }
                }
            }
        cout << dp2[0][n - 1][0][1] << " " << pref.back() - dp2[0][n - 1][0][1];
        return 0;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= v.back(); j++)
            for(int k = 0; k < 2; k++)
            pdp[i][j][k] = v[i];
        pdp[i][0][0]  = 0;
    }
    for (int len = 1; len < n; len++) {
        for (int l = 0; l + len < n; l++) {
            int r = l + len;
            ll res1 = pref[r + 1] - pref[l] - pdp[l + 1][v[l]][0];
            ll res2 = pref[r + 1] - pref[l] - pdp[l][v[r]][0];
            dp[l][0][1] = max(res1, res2);
            dp[l][0][0] = pref[r + 1] - pref[l] - dp[l][0][1];
            for (int k = 1; k <= v.back(); k++) {
                for (int m = 0; m < 2; m++) {
                    ll res1 = 0;
                    if (k >= v[l]) {
                        res1 = v[l] + pdp[l + 1][k - v[l]][m];
                    }
                    else res1 = pref[r + 1] - pref[l] - pdp[l + 1][v[l] - k][1 - m];
                    ll res2 = 0;
                    if (k >= v[r])
                        res2 = v[r] + pdp[l][k - v[r]][m];
                    else res2 = pref[r + 1] - pref[l] - pdp[l][v[r] - k][1 - m];
                    dp[l][k][m] = max(res1, res2);
                }
            }
        }
        for (int l = 0; l + len < n; l++) {
            for (int k = 0; k <= v.back(); k++) {
                for (int m = 0; m < 2; m++) {
                    pdp[l][k][m] = dp[l][k][m];
                }
            }
        }
    }
    cout << dp[0][0][1] << " " << pref.back() - dp[0][0][1];
}