#include <iostream>
#include <array>
#include <unordered_map>
using namespace std;

const long long l1 = 1e5, l2 = 1e10, l3 = 1e14;
array<int, 2000> v;
unordered_map<long long, int> mem;

int f(int l, int r, int t1, int t2) {
    if (r < l)
        return 0;
    long long h = (long long)t1 + (long long)t2 * l1 + (long long)l * l2 + (long long)r * l3;
    //cout << h << endl;
    if (mem.find(h) != mem.end())
        return mem[h];
    int d1, d2;
    if (t1 <= t2) {
        d1 = v[l] + f(l + 1, r, t1 + v[l], t2);
        d2 = v[r] + f(l, r - 1, t1 + v[r], t2);
        return mem[h] = max(d1, d2);
    } else {
        d1 = f(l + 1, r, t1, t2 + v[l]) - v[l];
        d2 = f(l, r - 1, t1, t2 + v[r]) - v[r];
        return mem[h] = min(d1, d2);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, sum = 0, ans = 0;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        sum += v[i];
    }
    ans = f(0, n - 1, 0, 0);
    cout << (sum - ans) / 2 + ans << ' ' << (sum - ans) / 2;
}
