//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt,fma")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const long long RANDOM = chrono::high_resolution_clock::now().time_since_epoch().count();
constexpr int MAXN = 1 << 20;
constexpr long long mod = 1e9 + 7;
mt19937 rnd(RANDOM);

void sol10() {
    int a, b, c;
    cin >> a >> b >> c;
    cout << max(a + b, c) << ' ' << min(c, a + b);
}

void solve() {
    int n;
    cin >> n;
    if (n == 3) {
        sol10();
        return;
    }
    vector<int> a(n);
    for (auto &i: a) {
        cin >> i;
    }
    std::sort(a.begin(), a.end());
    if (a[0] == a.back()) {
        cout << a[0] * ((n + 1) / 2) << ' ' << a[0] * (n / 2);
        return;
    }
    int c1 = 0, c2 = 0;
    for (int i: a) {
        if (i == 1) {
            c1++;
        } else {
            c2++;
        }
    }
    int t1 = 0, t2 = 0;
    int a1 = 0, a2 = 0;
    while (c1 || c2) {
        if (t1 <= t2) {
            if (c1 && c2) {
                c1--;
                c2--;
                a1 += 3;
                t1 += 3;
            } else {
                if (c2) {
                    c2--;
                    a1 += 2;
                    t1 += 2;
                } else {
                    c1--;
                    a1 += 1;
                    t1 += 1;
                }
            }
        } else {
            if (c1 && c2) {
                c1--;
                c2--;
                a2 += 3;
                t2 += 3;
            } else {
                if (c2) {
                    c2--;
                    a2 += 2;
                    t2 += 2;
                } else {
                    c1--;
                    a2 += 1;
                    t2 += 1;
                }
            }
        }
    }
    cout << a1 << ' ' << a2;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
//    cin>>q;
    while (q--) {
        solve();
    }
}
