#include <iostream>
#include <vector>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }

    auto calc = [&] (auto self, int l, int r) -> pair<int, int> {
        if (l + 1 == r) {
            return {a[l], r};
        }
        auto [ans1, ans2] = self(self, l + 1, r);

    };

    if (n == 3) {
        cout << a[0] + a[1] << ' ' << a[2];
        return 0;
    }

    if (a[n - 1] <= 2) {
        int k1 = 0, k2 = 0;
        for (int x : a) {
            k1 += (x == 1);
            k2 += (x == 2);
        }
        if (k1 % 2 == 0) {
            if (k1 == 0) {
                cout << k2 * ((n + 1) / 2) << ' ' << k2 * (n / 2);
                return 0;
            }
            cout << k1 / 2 + k2 << ' ' << k1 / 2 + k2;
        } else if (k1 % 2 == 1 && k2 % 2 == 0) {
            k1 -= k1 % 2;
            cout << k1 / 2 + k2 + 1 << ' ' << k1 / 2 + k2;
        } else {
            k1 -= k1 % 2;
            k2 -= k2 % 2;
            cout << k1 / 2 + k2 + 2 << ' ' << k1 / 2 + k2 + 1;
        }
        return 0;
    }
}