// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#include <cstring>
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>

using namespace std;
using ll = long long;
using ld = long double;

#ifndef _DEBUG
const int MAXN = 501, MAXW = 5010;
#else
const int MAXN = 10, MAXW = 100;
#endif
int dp[MAXN][MAXN][MAXW][2], w[MAXN];

int calc(int l, int r, int bob, int alice);

int lazy(int l, int r, int oth, bool who)
{
	if (l > r)
		return 0;
	if (dp[l][r][oth][who] != -1)
		return dp[l][r][oth][who];
	if (who) // Alice
		return dp[l][r][oth][who] = max(calc(l + 1, r, oth, w[l]) + w[l], calc(l, r - 1, oth, w[r]) + w[r]);
	else
		return dp[l][r][oth][who] = min(calc(l + 1, r, w[l], oth), calc(l, r - 1, w[r], oth));
}

int calc(int l, int r, int bob, int alice)
{
	if (bob < alice)
		return lazy(l, r, alice - bob, 0);
	return lazy(l, r, bob - alice, 1);
}

int main()
{
	//std::cout << "Hello World!\n";
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	cout.tie(NULL);
	memset(dp, -1, sizeof(dp));
	int n;
	cin >> n;
	for (size_t i = 0; i < n; i++)
	{
		cin >> w[i];
	}
	int alice = calc(0, n - 1, 0, 0), bob = -alice;
	for (size_t i = 0; i < n; i++)
	{
		bob += w[i];
	}
	cout << alice << ' ' << bob << '\n';
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
