#pragma optimize O3
#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using lll = __int128;
using ld = long double;

int sum = 0;
void answ(int x) {
    cout << x << " " << sum - x << "\n";
}

vi v, v2;
int sumOn(int l, int r) {
    return v2[r+1] - v2[l];
}

map<pair<pi, pi>, int> mp;
int calc0(int l, int r, int d1, int d2, int now);
int calc(int l, int r, int d1, int d2, int now) {
    int d0 = min(d1, d2);
    d1 -= d0; d2 -= d0;

    pair<pi, pi> p = {{l, r}, {d1, d2}};
    if (mp.find(p) != mp.end()) return mp[p];
    int x = calc0(l, r, d1, d2, now);
    mp[p] = x;
    return x;
}
int calc0(int l, int r, int d1, int d2, int now) {
    if (l > r) {
        return 0;
    }

    if (d1 > 0) {
        int best = 1e9;
        best = min(best, calc(l+1, r, d1, v[l], now));
        best = min(best, calc(l, r-1, d1, v[r], now));
        return best;
    } else if (d2 > 0) {
        int best = 0;
        best = max(best, v[r]+calc(l, r-1, v[r], d2, now+v[r]));
        best = max(best, v[l]+calc(l+1, r, v[l], d2, now+v[l]));
        return best;
    } else {
        if (l + 1 == r) {
            return v[r];
        }
        int best1 = 1e9;
        best1 = min(best1, v[l]+calc(l+2, r, v[l], v[l+1], now+v[l]));
        best1 = min(best1, v[l]+calc(l+1, r-1, v[l], v[r], now+v[l]));

        int best2 = 1e9;
        best2 = min(best2, v[r]+calc(l+1, r-1, v[r], v[l], now+v[r]));
        best2 = min(best2, v[r]+calc(l, r-2, v[r], v[r-1], now+v[r]));
        return max(best1, best2);
    }
}

void solve() {
    int n; cin >> n;
    v.resize(n);
    v2.assign(1, 0);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        sum += v[i];
        v2.push_back(v2.back() + v[i]);
    }
    answ(calc(0, n-1, 0, 0, 0));
//    for (int l = 0; l < n; l++) {
//        for (int r = l; r < n; r++) {
//            cout << "[" << l << "," << r << "]";
//            cout << calc(l, r, 0, 0, 0) << "\n";
//        }
//    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    solve();
}
