#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define fast(); ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define pb push_back;
#define all(a) a.begin(), a.end();
#define ccin(a) for(int s = 0; s < a.size(); s++) {cin >> a[s];}
#define ccout(a) for(int s = 0; s < a.size(); s++) {cout << a[s] << " ";}

struct elem {
    ll al, bob;
};

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n + 1);
    a[0] = 0;
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    bool two = true;
    for(int i = 1; i <= n; i++) {
        if(a[i] > 2) {
            two = false;
        }
    }
    if(two) {
        vector<vector<elem>> dp(n + 1, vector<elem> (n + 1));
        for(int sum = 0; sum <= n; sum++) {
            for(int pref = 0; pref <= sum; pref++) {
                ll suf = sum - pref;
                if(sum == 0) {
                    dp[pref][suf] = {0, 0};
                } else if(pref == 0) {
                    if(dp[pref][suf - 1].al > dp[pref][suf - 1].bob) {
                        dp[pref][suf] = {dp[pref][suf - 1].al, dp[pref][suf - 1].bob + a[n - suf + 1]};
                    } else {
                        dp[pref][suf] = {dp[pref][suf - 1].al + a[n - suf + 1], dp[pref][suf - 1].bob};
                    }
                } else if(suf == 0) {
                    if(dp[pref - 1][suf].al > dp[pref - 1][suf].bob) {
                        dp[pref][suf] = {dp[pref - 1][suf].al, dp[pref - 1][suf].bob + a[pref]};
                    } else {
                        dp[pref][suf] = {dp[pref - 1][suf].al + a[pref], dp[pref - 1][suf].bob};
                    }
                } else {
                    ll wait1 = min(abs(dp[pref][suf - 1].al - (dp[pref][suf - 1].bob + a[n - suf + 1])), abs(dp[pref][suf - 1].al + a[n - suf + 1] - dp[pref][suf - 1].bob));
                    ll wait2 = min(abs(dp[pref - 1][suf].al - (dp[pref - 1][suf].bob + a[pref])), (dp[pref - 1][suf].al + a[pref] - dp[pref - 1][suf].bob));
                    if(wait1 <= wait2) {
                        if(dp[pref][suf - 1].al > dp[pref][suf - 1].bob) {
                            dp[pref][suf] = {dp[pref][suf - 1].al, dp[pref][suf - 1].bob + a[n - suf + 1]};
                        } else {
                            dp[pref][suf] = {dp[pref][suf - 1].al + a[n - suf + 1], dp[pref][suf - 1].bob};
                        }
                    } else {
                        if(dp[pref - 1][suf].al > dp[pref - 1][suf].bob) {
                            dp[pref][suf] = {dp[pref - 1][suf].al, dp[pref - 1][suf].bob + a[pref]};
                        } else {
                            dp[pref][suf] = {dp[pref - 1][suf].al + a[pref], dp[pref - 1][suf].bob};
                        }
                    }
                }
            }
        }
        pair<ll, ll> ans = {1e9, -1e9};
        for(int sum = n; sum <= n; sum++) {
            for(int pref = 0; pref <= sum; pref++) {
                ll suf = sum - pref;
                if(abs(dp[pref][suf].al - dp[pref][suf].bob) < (abs(ans.first - ans.second))) {
                    ans.first = dp[pref][suf].al;
                    ans.second = dp[pref][suf].bob;
                }
            }
        }
        cout << ans.first << " " << ans.second;
    } else if(n == 3) {
        pair<ll, ll> ans1;
        if(a[1] > a[2] || a[1] > a[3]) {
            ans1 = {a[1], a[2] + a[3]};
        } else {
            ans1 = {a[1] + min(a[2], a[3]), max(a[2], a[3])};
        }
        pair<ll, ll> ans2;
        if(a[2] > a[1] || a[2] > a[3]) {
            ans2 = {a[2], a[1] + a[3]};
        } else {
            ans2 = {a[2] + min(a[1], a[3]), max(a[1], a[3])};
        }
        pair<ll, ll> ans3;
        if(a[3] > a[2] || a[3] > a[1]) {
            ans3 = {a[3], a[1] + a[2]};
        } else {
            ans3 = {a[3] + min(a[1], a[2]), max(a[2], a[1])};
        }
        if(ans1.first > ans2.first && ans1.first > ans3.first) {
            cout << ans1.first << " " << ans1.second << "\n";
        } else if(ans2.first > ans1.first && ans2.first > ans3.first) {
            cout << ans2.first << " " << ans2.second << "\n";
        } else {
            cout << ans3.first << " " << ans3.second << "\n";
        }
    } else {
        vector<vector<elem>> dp(n + 1, vector<elem> (n + 1));
        for(int sum = 0; sum <= n; sum++) {
            for(int pref = 0; pref <= sum; pref++) {
                ll suf = sum - pref;
                if(sum == 0) {
                    dp[pref][suf] = {0, 0};
                } else if(pref == 0) {
                    if(dp[pref][suf - 1].al > dp[pref][suf - 1].bob) {
                        dp[pref][suf] = {dp[pref][suf - 1].al, dp[pref][suf - 1].bob + a[n - suf + 1]};
                    } else {
                        dp[pref][suf] = {dp[pref][suf - 1].al + a[n - suf + 1], dp[pref][suf - 1].bob};
                    }
                } else if(suf == 0) {
                    if(dp[pref - 1][suf].al > dp[pref - 1][suf].bob) {
                        dp[pref][suf] = {dp[pref - 1][suf].al, dp[pref - 1][suf].bob + a[pref]};
                    } else {
                        dp[pref][suf] = {dp[pref - 1][suf].al + a[pref], dp[pref - 1][suf].bob};
                    }
                } else {
                    ll wait1 = min(abs(dp[pref][suf - 1].al - (dp[pref][suf - 1].bob + a[n - suf + 1])), abs(dp[pref][suf - 1].al + a[n - suf + 1] - dp[pref][suf - 1].bob));
                    ll wait2 = min(abs(dp[pref - 1][suf].al - (dp[pref - 1][suf].bob + a[pref])), (dp[pref - 1][suf].al + a[pref] - dp[pref - 1][suf].bob));
                    if(wait1 <= wait2) {
                        if(dp[pref][suf - 1].al > dp[pref][suf - 1].bob) {
                            dp[pref][suf] = {dp[pref][suf - 1].al, dp[pref][suf - 1].bob + a[n - suf + 1]};
                        } else {
                            dp[pref][suf] = {dp[pref][suf - 1].al + a[n - suf + 1], dp[pref][suf - 1].bob};
                        }
                    } else {
                        if(dp[pref - 1][suf].al > dp[pref - 1][suf].bob) {
                            dp[pref][suf] = {dp[pref - 1][suf].al, dp[pref - 1][suf].bob + a[pref]};
                        } else {
                            dp[pref][suf] = {dp[pref - 1][suf].al + a[pref], dp[pref - 1][suf].bob};
                        }
                    }
                }
            }
        }
        pair<ll, ll> ans = {1e9, -1e9};
        for(int sum = n; sum <= n; sum++) {
            for(int pref = 0; pref <= sum; pref++) {
                ll suf = sum - pref;
                if(abs(dp[pref][suf].al - dp[pref][suf].bob) < (abs(ans.first - ans.second))) {
                    ans.first = dp[pref][suf].al;
                    ans.second = dp[pref][suf].bob;
                }
            }
        }
        cout << ans.first << " " << ans.second;
    }

}

int main() {
    fast();
    solve();
}
