#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map
//#define mp make_pair

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;
typedef vector<si> vsi;
typedef vector<spi> vspi;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

mt19937 rnd(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());

const int MAXN = 2000 + 10;

umap<int, int> dp[MAXN][MAXN][2];
int a[MAXN], p[MAXN];

int f(int l, int r, int pl, int x) {
	if (dp[l][r][pl].count(x))
		return dp[l][r][pl][x];
	if (r < l) {
		dp[l][r][pl][x] = 0;
		return 0;
	}
	if (pl == 0)
		dp[l][r][pl][x] = 0;
	else
		dp[l][r][pl][x] = p[r] - p[l - 1];
	if (pl == 0) {
		if (a[l] <= x)
			maxravno(dp[l][r][pl][x], f(l + 1, r, 0, x - a[l]) + a[l]);
		else
			maxravno(dp[l][r][pl][x], f(l + 1, r, 1, a[l] - x) + a[l]);
		if (a[r] <= x)
			maxravno(dp[l][r][pl][x], f(l, r - 1, 0, x - a[r]) + a[r]);
		else
			maxravno(dp[l][r][pl][x], f(l, r - 1, 1, a[r] - x) + a[r]);

	}
	else {
		if (a[l] < x)
			minravno(dp[l][r][pl][x], f(l + 1, r, 1, x - a[l]));
		else
			minravno(dp[l][r][pl][x], f(l + 1, r, 0, a[l] - x));
		if (a[r] < x)
			minravno(dp[l][r][pl][x], f(l, r - 1, 1, x - a[r]));
		else
			minravno(dp[l][r][pl][x], f(l, r - 1, 0, a[r] - x));
	}
	return dp[l][r][pl][x];
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		p[i] = p[i - 1] + a[i];
	}
	cout << f(1, n, 0, 0) << ' ' << p[n] - f(1, n, 0, 0);

	return 0;
}