#ifndef LOCALEGOR
#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,sse2,bmi2")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ld PI = acosl(-1.0);

mt19937 rnd(3105);

const int maxn = 2000;

gp_hash_table<int, gp_hash_table<int, int>> dp[maxn][maxn];
int n;
vector<int> w;

inline int max(int a, int b) {
    return a > b ? a : b;
}

int calc(int l, int r, int a, int b) {
    if (dp[l][r].find(a) != dp[l][r].end() && dp[l][r][a].find(b) != dp[l][r][a].end()) {
        return dp[l][r][a][b];
    }
    if (a == 0) {
            if (l == r) {
                dp[l][r][a][b] = w[l];
            } else {
                int na = a + w[l];
                int nb = b;
                int mn = min(na, nb);
                na -= mn;
                nb -= mn;
                dp[l][r][a][b] = calc(l + 1, r, na, nb) + w[l];
                na = a + w[r];
                nb = b;
                mn = min(na, nb);
                na -= mn;
                nb -= mn;
                dp[l][r][a][b] = min(dp[l][r][a][b], calc(l, r - 1, na, nb) + w[r]);
            }
    } else {
        if (l == r) {
            dp[l][r][a][b] = 0;
        } else {
            int na = a;
            int nb = b + w[l];
            int mn = min(na, nb);
            na -= mn;
            nb -= mn;
            dp[l][r][a][b] = calc(l + 1, r, na, nb);
            na = a;
            nb = b + w[r];
            mn = min(na, nb);
            na -= mn;
            nb -= mn;
            dp[l][r][a][b] = max(dp[l][r][a][b], calc(l, r - 1, na, nb));
        }
    }
    return dp[l][r][a][b];
}

void solve() {
    cin >> n;
    w.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    int a = calc(0, n - 1, 0, 0);
    int b = accumulate(all(w), 0) - a;
    cout << a << ' ' << b;
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen(R"(C:\Users\olymp\CLionProjects\main\INPUT.txt)", "r", stdin);
#endif
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}