#ifndef LOCALEGOR
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse,bmi")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int short

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ld PI = acosl(-1.0);

mt19937 rnd(3105);

const int maxn = 2000;

gp_hash_table<int, int> dp[maxn][maxn];
int n;
vector<int> w;

inline int min(const int a, const int b) {
    return a < b ? a : b;
}

inline int max(const int a, const int b) {
    return a > b ? a : b;
}

int calc(int l, int r, int t) {
    if (dp[l][r].find(t) != dp[l][r].end()) {
        return dp[l][r][t];
    }
    if (t >= 0) {
        if (l == r) {
            dp[l][r][t] = w[l];
        } else {
            int na = w[l];
            int nb = t;
            int mn = min(na, nb);
            na -= mn;
            nb -= mn;
            if (na == 0) {
                dp[l][r][t] = calc(l + 1, r, nb) + w[l];
            } else {
                dp[l][r][t] = calc(l + 1, r, -na) + w[l];
            }
            na = w[r];
            nb = t;
            mn = min(na, nb);
            na -= mn;
            nb -= mn;
            if (na == 0) {
                dp[l][r][t] = max(dp[l][r][t], calc(l, r - 1, nb) + w[r]);
            } else {
                dp[l][r][t] = max(dp[l][r][t], calc(l, r - 1, -na) + w[r]);
            }
        }
    } else {
        if (l == r) {
            dp[l][r][t] = 0;
        } else {
            int na = -t;
            int nb = w[l];
            int mn = min(na, nb);
            na -= mn;
            nb -= mn;
            if (na == 0) {
                dp[l][r][t] = calc(l + 1, r, nb);
            } else {
                dp[l][r][t] = calc(l + 1, r, -na);
            }
            na = -t;
            nb = w[r];
            mn = min(na, nb);
            na -= mn;
            nb -= mn;
            if (na == 0) {
                dp[l][r][t] = min(dp[l][r][t], calc(l, r - 1, nb));
            } else {
                dp[l][r][t] = min(dp[l][r][t], calc(l, r - 1, -na));
            }
        }
    }
    return dp[l][r][t];
}

void solve() {
    cin >> n;
    w.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    int a = calc(0, n - 1, 0);
    int b = accumulate(all(w), 0) - a;
    cout << a << ' ' << b;
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen(R"(C:\Users\olymp\CLionProjects\main\INPUT.txt)", "r", stdin);
#endif
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}