#include <bits/stdc++.h>
#include <bits/extc++.h>
#pragma GCC optimize("03")
#pragma GCC target("avx2")
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define sz(v) (int)(v).size()
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld  = long double;
mt19937 Rand(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());
const int inf = 1e9;
const ll INF = 1e18;

void solve() {
    int n;
    cin >> n;
    vector <int> w(n + 1);
    int mx = 0;
    for (int i = 1; i <= n; ++i) {
        cin >> w[i];
        mx = max(mx, w[i]);
    }
    vector <vector <vector <int>>> dp(n + 1, vector <vector <int>> (n + 1, vector <int> (2 * mx + 1)));
    for (int i = 1; i <= n; ++i) {
        for (int d = 0; d <= 2 * mx; ++d) {
            dp[i][i][d] = (d <= mx? w[i] : 0);
        }
    }
    for (int len = 2; len <= n; ++len) {
        for (int l = 1; l + len - 1 <= n; ++l) {
            int r = l + len - 1;
            for (int d = 0; d <= 2 * mx; ++d) {
                if (d <= mx) {
                    dp[l][r][d] = max(dp[l + 1][r][d + w[l]] + w[l], dp[l][r - 1][d + w[r]] + w[r]);
                } else {
                    dp[l][r][d] = min(dp[l + 1][r][d - w[l]], dp[l][r - 1][d - w[r]]);
                }
            }
        }
    }
    cout << dp[1][n][mx] << ' ' << accumulate(all(w), 0) - dp[1][n][mx];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    int tt = 1;
    while (tt--) {
        solve();
    }
}
