#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math,inline")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e6+2;

ll arr[N],pref[N];
ll n;

ll sum(ll l, ll r)
{
    if(l==0) return pref[n-1]-pref[r];
    return pref[n-1]-(pref[r]-pref[l-1]);
}

gp_hash_table<ll,ll> mp;

ll rec(ll l, ll r, ll x)
{
    auto it=mp.find(l*N*N+r*N+x);
    if(it!=mp.end()) return (*it).S;
    ll y=sum(l,r)-x,res=0;

    if(x<=y)
    {
        if(l==r) res=arr[l];
        else res=max(rec(l+1,r,x+arr[l])+arr[l],rec(l,r-1,x+arr[r])+arr[r]);
    }

    else
    {
        if(l==r) res=0;
        else res=min(rec(l+1,r,x),rec(l,r-1,x));
    }

    return mp[l*N*N+r*N+x]=res;
}

void solve()
{
    cin>>n;

    for(ll i=0;i<n;i++)
        cin>>arr[i];

    pref[0]=arr[0];

    for(ll i=1;i<n;i++)
        pref[i]=pref[i-1]+arr[i];

    ll x=rec(0,n-1,0);
    cout<<x<<' '<<pref[n-1]-x;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
