#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define p_b push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template<class T> using oset =
tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using pq =
priority_queue<T>;
template<class T> using pqg =
priority_queue<T, vector<T>, greater<T>>;

template<class T> void amin(T &a, T b) {a = a < b ? a : b;}
template<class T> void amax(T &a, T b) {a = a > b ? a : b;}

const int N = 2000 + 5;

int a[N];
int suf[N];
int pref[N];
int W;
int pr[N][10 * N];
//bitset<20001> can[N];

//unordered_map<int, int> dp[N][N];
int dp[N][N][2];

int get(int l, int r, int x) {
    if (l > r)
        return 0;
    int y = W - pref[r] + pref[l - 1] - x;
    int who = x >= y;
    if (dp[l][r][who] != -1)
        return dp[l][r][who];
    if (x <= y) {
//        dp[l][r][x] = get(l, r - 1, x + a[r]) + a[r];
        dp[l][r][who] = max(get(l + 1, r, x + a[l]) + a[l], get(l, r - 1, x + a[r]) + a[r]);
    } else {
        dp[l][r][who] = min(get(l + 1, r, x), get(l, r - 1, x));
    }
    return dp[l][r][who];
}

void solve() {
    int n;
    cin >> n;
    W = 0;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        W += a[i];
        pref[i] = a[i] + pref[i - 1];
//        dp[i][i][a[i]] = a[i];
    }
    for (int i = n; i; i--)
        suf[i] = suf[i + 1] + a[i];
    for (int i = 0; i <= n; i++)
        for (int j = i; j <= n; j++)
            for (int who = 0; who < 2; who++)
                dp[i][j][who] = -1;
    int ans = get(1, n, 0);
    cout << ans << ' ' << W - ans;
//    pr[1][a[1]] = 1;
//    for (int i = 1; i < n; i++) {
//        for (int j = 0; j <= W; j++) {
//            int sf = i - pr[i][j];
//            if (suf[n - sf + 1] + pref[pr[i][j]] != j)
//                continue;
//            amax(pr[i + 1][j + a[pr[i][j] + 1]], pr[i][j] + 1);
//            amax(pr[i + 1][j + a[n - sf]], pr[i][j]);
//        }
//    }
//    amax(dp[1][a[1]], a[1]);
//    amax(dp[1][a[n]], a[n]);
//    can[1][a[1]] = can[1][a[n]] = 1;
//    for (int i = 1; i < n; i++) {
//        for (int j = can[i]._Find_first(); j <= W; j = can[i]._Find_next(j)) {
//            int bob = j - dp[i][j];
//            int l = pr[i][j];
//            int r = i - pr[i][j];
//            cout << i << ' ' << j << ' ' << l << ' ' << r << ' ' << bob << ' ' << dp[i][j] << '\n';
//            if (bob < dp[i][j]) {
//                    if (!dp[i + 1][j + a[n - r]])
//                        dp[i + 1][j + a[n - r]] = dp[i][j];
//                    else
//                        amin(dp[i + 1][j + a[n - r]], dp[i][j]);
//                    can[i + 1][j + a[n - r]] = 1;
//                    if (!dp[i + 1][j + a[l + 1]])
//                        dp[i + 1][j + a[l + 1]] = dp[i][j];
//                    else
//                        amin(dp[i + 1][j + a[l + 1]], dp[i][j]);
//                    can[i + 1][j + a[l + 1]] = 1;
//            } else if (bob > dp[i][j]) {
//                amax(dp[i + 1][j + a[l + 1]], dp[i][j] + a[l + 1]);
//                amax(dp[i + 1][j + a[n - r]], dp[i][j] + a[n - r - 1]);
//                can[i + 1][j + a[l + 1]] = can[i + 1][j + a[n - r]] = 1;
//            } else {
//                if (l + 1 != n - r) {
//                    amax(dp[i + 1][j + a[l + 1] + a[n - r]], dp[i][j] + a[l + 1]);
//                    amax(dp[i + 1][j + a[l + 1] + a[n - r]], dp[i][j] + a[n - r]);
//                    can[i + 1][j + a[l + 1] + a[n - r]] = 1;
//                } else {
//                    amax(dp[i + 1][j + a[l + 1]], dp[i][j] + a[l + 1]);
//                }
//            }
//        }
//    }
//    for (int i = 1; i <= n; i++)
//        dp[i][i][1] = a[i];
//    cout << dp[1][n][1] << ' ' << W - dp[1][n][1];
}

int32_t main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // LOCAL
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    #ifdef LOCAL
        cout << "\n===\n\n\nTime : " << clock() / CLOCKS_PER_SEC << '\n';
    #endif // LOCAL
}
