#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;
using ll = long long;

const ll mod = 1e9 + 7;
vector<vector<vector<vector<ll>>>> dp;
vector<ll> inf;

int main()
{
	ll n;
	cin >> n;
	ll w = 0;
	inf.resize(n);
	ll s = 0;
	for (auto& x : inf) {
		cin >> x;
		s += x;
		w = max(w, x);
	}
	dp.resize(2, vector<vector<vector<ll>>>(n + 1, vector<vector<ll>>(n + 1, vector<ll>(w + 1))));
		for (ll len = 1; len <= n; len++) {
			for (ll l = 0; l + len <= n; l++) {
				ll r = l + len - 1;
				for (ll left = 0; left <= w; left++) {
					if (l < 0 || l > n || r < 0 || r > n || left > w || left < 0) {
						cout << "1 2";
						return 0;
					}
					dp[0][l][r][left] = 0;
					dp[1][l][r][left] = 1e9;
					if (l == r) {
						dp[0][l][r][left] = inf[l];
						dp[1][l][r][left] = 0;
						continue;
					}
					if (inf[l] <= left) {
						dp[0][l][r][left] = max(dp[0][l][r][left], dp[0][l + 1][r][left - inf[l]] + inf[l]);
					}
					else {
						dp[0][l][r][left] = max(dp[0][l][r][left], dp[1][l + 1][r][inf[l] - left] + inf[l]);
					}
					if (inf[r] <= left) {
						dp[0][l][r][left] = max(dp[0][l][r][left], dp[0][l][r - 1][left - inf[r]] + inf[r]);
					}
					else {
						dp[0][l][r][left] = max(dp[0][l][r][left], dp[1][l][r - 1][inf[r] - left] + inf[r]);
					}


					if (inf[l] < left) {
						dp[1][l][r][left] = min(dp[1][l][r][left], dp[1][l + 1][r][left - inf[l]]);
					}
					else {
						dp[1][l][r][left] = min(dp[1][l][r][left], dp[0][l + 1][r][inf[l] - left]);
					}
					if (inf[r] < left) {
						dp[1][l][r][left] = min(dp[1][l][r][left], dp[1][l][r - 1][left - inf[r]]);
					}
					else {
						dp[1][l][r][left] = min(dp[1][l][r][left], dp[0][l][r - 1][inf[r] - left]);
					}
				}
			}
		}
	cout << dp[0][0][n - 1][0] << " " << s - dp[0][0][n - 1][0];
}