#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>
#include <array>
using namespace std;
using ll = long long;
map<array<int, 3>, pair<int, int>> dp;
vector<int> v; int W;
void calc(int l, int r, int i) {
	if (dp.find({ l, r, i }) != dp.end()) return;
	if (l == r) {
		if (i < W) {
			dp[{l, r, i}] = { 0, v[l] };
		} else {
			dp[{l, r, i}] = { v[l], 0 };
		}
		return;
	}
	if (i < W) {
		int i1 = v[l] + i, i2 = v[r] + i;
		calc(l + 1, r, i1); calc(l, r - 1, i2);
		int a = dp[{l + 1, r, i1}].second;
		int b = dp[{l, r - 1, i2}].second;
		if (a + v[l] >= b + v[r]) {
			dp[{l, r, i}] = { dp[{l + 1, r, i1}].first, a + v[l] };
		} else {
			dp[{l, r, i}] = { dp[{l, r - 1, i2}].first, b + v[r] };
		}
	} else {
		int i1 = i - v[l], i2 = i - v[r];
		calc(l + 1, r, i1); calc(l, r - 1, i2);
		int a = dp[{l + 1, r, i1}].first;
		int b = dp[{l, r - 1, i2}].first;
		if (a + v[l] >= b + v[r]) {
			dp[{l, r, i}] = { a + v[l], dp[{l + 1, r, i1}].second };
		} else {
			dp[{l, r, i}] = { b + v[r], dp[{l, r - 1, i2}].second };
		}
	}
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n; cin >> n; v.resize(n);
	for (auto& i : v) cin >> i;
	if (n == 3) {
		if (v[0] == v[2]) {
			cout << v[0] + v[2] << " " << v[1]; exit(0);
		}
		if (v[2] >= v[0] + v[1]) {
			cout << v[2] << " " << v[0] + v[1]; exit(0);
		}
		cout << v[0] + v[1] << " " << v[2]; exit(0);
	}
	W = v.back(); calc(0, n - 1, W);
	cout << dp[{0, n - 1, W}].first << " " << dp[{0, n - 1, W}].second;
	return 0;
}
