/*
⣿⢟⣿⣻⢟⣿⣻⢟⣿⣻⢟⣿⣻⢟⣟⣟⢟⣟⢟⣟⣟⣻⡻⣻⡻⣻⡻⣻⢟⣿⡻⣟⢿⢿⡿⣿⢿⡿⣿⣿⣿⣿⣿⡿⢟⠟⢟⠿⣿⣿⠿⠋⠝⣥⣡⢭⣨⣣⢭⢮⢵⡭⣪⡡⣩⡈⡧⢱⠥⢅⢍⡙⠛⠟⢛⢋⢍⣍⣬⡵⣝⢾⣝⣯⣻⡻⣻⢟⡿⣻⡻⣟⢟⣟⢿⡻⣿⢿⡿⣿⢿⡿⣿⡻⣟⢨⣿⣿⣿⣿
⣯⡻⣮⢷⣻⡵⣯⣻⢮⣯⣻⢮⡷⣻⡵⣏⡿⣪⣟⢾⣪⢷⣝⡽⣝⢷⣝⢯⣻⢮⡿⣝⣟⣿⣺⢯⡿⣾⣻⣞⣷⢟⠬⣂⣱⢞⣦⡢⠴⡌⠠⢈⠂⢞⢑⢳⡳⢕⢋⠕⡡⡑⢅⢊⢂⠳⢈⠢⠑⡂⢂⡩⡜⡴⢥⢣⢝⢦⡻⣺⣝⢷⡵⣳⣝⡽⣝⡽⣞⡽⣞⡽⣝⣽⢽⡽⢯⢷⡛⣙⡕⡿⣽⣻⠃⣼⣿⣿⣿⣿
⢮⡿⣵⢟⣵⢟⣞⢷⣻⣮⢡⣭⣭⡍⣺⢟⣞⢷⡝⡷⡽⡎⣬⣬⣥⣅⢫⢷⣝⢃⣭⣭⣭⣌⢻⡯⢩⣭⣬⣭⠑⣣⢞⡮⣗⢟⠎⣩⣥⣴⣦⣤⣅⢊⢂⠣⢑⣠⣥⣴⣬⣬⣁⡣⣅⣓⡢⡥⣃⠪⠚⣨⣬⣤⣥⣤⣕⡱⡹⡧⣯⡇⣭⣥⣭⡌⢟⡾⣵⡋⣬⣭⣬⣥⣥⣔⣓⢿⡍⡔⣽⢪⣿⡏⢸⣾⣿⣿⣿⣿
⡻⣞⣽⣫⡯⣿⢽⡯⣷⣻⢠⣿⣿⡇⣽⣫⢞⡷⣝⣟⠾⢡⣿⣿⣿⣿⡌⣷⡻⢄⣿⣿⣿⣿⡘⢇⣿⣿⣿⣿⠐⣯⢫⣮⢹⡁⣾⣿⣿⠉⠛⡿⡿⠇⠹⢡⣿⣿⡿⢛⠻⢿⣿⣷⡜⣽⣪⣛⢖⡑⢼⣿⣿⡋⠝⢿⠿⠷⢘⡝⡮⣰⣿⣿⣿⣿⡘⣟⣾⠕⣿⣿⡿⢛⠿⣿⣿⣦⠸⣜⢧⣿⡞⣢⣿⣿⣿⣿⣿⣿
⣝⢷⡽⣮⣻⣗⡿⣽⣞⣿⢐⣿⣿⡇⢾⢵⢯⡻⡮⣯⢃⣿⣿⢇⢹⣿⣷⡘⣿⠄⣿⣿⡝⣿⣇⢹⣿⠇⣿⣿⠐⢃⠅⠄⠢⠠⠹⢿⣿⣿⣿⣶⣦⡑⢍⣾⣿⣿⢰⡟⣷⠈⣿⣿⣧⢸⢮⣝⢵⣫⡘⢿⣿⣿⣿⣶⣶⣅⢫⡺⢠⣿⣿⠃⢻⣿⣧⢙⣴⡎⣿⣿⡗⣿⣷⢹⣿⣿⡆⣿⣟⡾⣨⣾⣿⣿⣿⣿⢿⣿
⡺⣯⡻⣾⢵⣯⣻⣗⢿⣺⢐⣿⣿⡇⣻⡳⣏⣟⢾⠃⣾⣿⣿⣦⣼⣿⣿⣇⢻⠌⣿⣿⠆⢿⣿⣿⣿⠀⣿⣿⡁⡶⡜⢋⡐⡁⣦⣤⡍⣍⡙⢿⣿⣿⢀⢻⣿⣿⡜⠽⠮⣡⣿⣿⡇⡜⢳⣕⢷⡅⣩⣤⣌⢩⡙⢻⣿⣿⡆⢁⣾⣿⣿⣬⣾⣿⣿⣇⢻⡇⣿⣿⣏⠿⠟⣸⣿⣿⢡⣿⠞⢴⣿⣿⣿⣿⣿⣿⣿⣿
⣝⡷⣻⣵⣟⡷⣻⣞⢯⡿⢐⣿⣿⡇⣝⣮⣣⢟⡏⣼⣿⣿⠛⡛⣛⠻⣿⣿⣎⠃⣿⣿⡛⠸⣿⣿⡇⡄⣿⣿⡐⠏⡠⣷⢹⢂⠻⣿⣿⣶⣶⣿⣿⠏⣼⣈⠻⣿⣿⣷⣾⣿⣿⠟⣴⣻⣔⠬⡣⢧⡹⢿⣿⣷⣶⣾⣿⠟⡐⣾⣿⣿⢛⣛⣛⢻⣿⣿⡎⢗⣿⣿⣿⣿⣿⣿⡿⢋⣮⢟⣨⣿⣿⣿⣿⣿⣯⣿⣿⣿
⢮⣻⢽⣞⡷⣻⡯⣾⣫⢿⢦⣭⣭⢵⣛⣎⣝⣍⡦⡭⣭⡥⡾⡶⡶⣤⣭⣭⣥⣬⡭⡭⢔⢧⡩⣍⠔⣤⠭⡩⡀⣱⡻⢎⢇⢜⠷⣦⢭⣩⣍⡭⣴⠺⡵⣽⡱⢦⡭⣍⡍⠭⣔⢟⢮⢖⡽⣲⡕⢕⢝⢦⣭⡭⣭⣭⣴⢾⣅⢭⣭⢡⣿⡽⣿⣦⣭⣭⣵⣦⣭⣭⣭⡭⣩⣴⢞⣯⠏⢤⣿⣿⣿⣿⣿⣽⣿⣿⡿⣿
⡽⣳⣟⢮⡿⣽⠞⣡⢦⡳⡳⣮⢺⢧⣫⢞⡮⣞⢾⢕⢷⣝⣞⢟⣞⢗⡷⡺⡶⣕⢯⡺⡱⡣⡞⣰⢾⡑⡡⢊⢤⢯⡫⣺⢁⣏⡳⡳⢯⡰⣧⢻⣞⢥⡛⣾⣕⡳⣹⢎⡿⣪⡪⣗⢟⣮⡻⣮⣫⡧⡱⡱⣣⢿⣞⢮⣟⡷⡻⢮⣳⡧⢿⣿⣹⣿⣿⢟⣯⣻⣿⣿⢟⣰⢯⣞⢯⠎⣲⣿⣿⣿⣿⣿⢿⣿⣿⢿⣿⣿
⣝⢷⣝⣟⢾⣻⡕⢝⢮⣹⢝⡮⣫⣗⢽⣣⢟⣼⡳⣽⡳⡽⣮⡻⣮⢯⣫⣟⡽⣺⢇⢯⢺⢁⣾⢙⢃⠔⣡⠃⣾⢣⣏⢷⠡⣏⢾⣑⠧⣝⣞⢷⡽⡠⣇⠘⣮⢳⣌⢳⣝⢷⢽⣌⢻⡮⣻⡺⡮⡷⣕⠵⢌⢗⣽⣟⣵⣻⢟⣎⡻⣻⢚⣿⣿⢋⣶⣿⣷⣝⢿⡭⣲⢯⢷⡝⠣⣼⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣺⡻⣮⢯⣻⣮⢿⣌⠳⡱⡇⡯⡺⣪⢷⡭⣫⢾⣝⢮⣯⢻⣎⢿⣪⢷⣳⣝⢞⢵⡱⡣⢃⢜⢡⠊⢎⢼⡣⡸⣳⢕⣯⣻⢘⣧⣫⡲⢱⡯⣺⡳⣽⠂⡮⡱⡈⢷⡻⣆⠙⣷⣫⢾⣆⡙⢷⡽⣺⢯⡻⡷⣝⢮⡦⣻⡼⣗⣿⡉⣯⣕⣝⣾⣥⣿⣻⣷⣻⡧⢿⣞⣯⣻⠏⢌⣿⣿⣿⣿⣿⣿⣿⣽⣿⣿⣽⣿⣿⣿
⢮⣻⡳⣟⣵⢯⡿⣽⣧⢙⢜⢮⢬⢮⣬⣮⣭⣕⡙⠳⢝⠗⡽⡳⡝⢷⢵⣫⢞⣕⡕⢁⣮⢃⠇⡘⣜⢗⢆⡽⣪⢗⢷⢵⠸⢼⡵⣍⢼⣝⡽⣝⡽⡅⢺⠀⣿⡈⢿⡽⡄⢆⠹⣳⣝⢷⡐⢝⢝⢯⣻⣝⣯⢷⣎⠘⠿⣽⣟⣎⠿⣿⣽⣯⡿⣷⣟⣾⣽⣿⣾⣮⣮⡱⡡⣻⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⣿⡿⣿⣿
⣝⢷⡻⣽⡺⣗⡿⣾⣝⣷⣅⠳⡕⣝⢺⡳⣯⢾⡻⣻⡳⣻⢖⡾⣲⢗⡶⡼⡧⡵⢀⡿⣊⡜⡐⢜⣭⣫⢢⢯⢏⣝⢗⢯⢸⢪⣟⠆⡾⣪⢟⡮⣳⢭⠘⡄⢷⣿⡌⢻⣽⡘⣦⢊⠚⣯⢿⣕⡱⣣⢝⡳⡽⣯⢿⣷⣕⠤⣙⠺⣻⢜⣷⣿⣻⢿⡾⣿⣾⢷⣿⣽⣟⢏⠢⣿⣿⣿⣿⣿⣾⣿⣿⣿⣿⣾⣿⣿⣿⣿
⡺⣯⣻⢽⡽⣽⢽⣞⡷⣽⣟⣷⣎⡪⡣⣟⢞⣗⢿⡽⣯⢯⣯⣻⣭⡻⣞⡽⣞⠢⡽⡎⢾⠌⢰⡻⣔⢷⢸⡗⠕⣮⡛⣼⢨⡎⡾⢱⡏⢾⣫⢾⣝⠷⡅⡹⢼⣾⣿⣆⠻⣧⠸⡷⣍⠦⣙⢯⣷⣬⢳⣭⡺⢔⡛⢮⣟⢷⣵⣍⢮⢻⣯⣿⣽⣿⣟⣿⣽⣟⣿⡢⡦⣫⡓⠸⣿⣿⣿⢿⣿⡿⣿⣾⣿⣿⢿⣿⣿⣿
⣽⡺⣗⢿⡺⣗⣟⢾⡽⣷⣽⣻⣞⢿⣜⡮⡫⣞⢷⢝⣯⣻⢽⣯⣻⣟⣮⣻⡎⢼⡫⣴⡻⢠⢹⣝⢞⡧⣻⢘⢕⠮⣱⣻⡐⢧⢃⡿⣝⠼⣳⢯⡞⣿⡱⣘⢾⡷⣿⣭⣵⡸⣶⠸⣿⣿⣦⡕⣌⠳⢇⢻⣟⣷⣬⣕⣨⠒⡑⣎⡗⣿⣿⣻⣷⣿⢾⣟⣯⣿⣿⢎⡾⣆⢻⡔⢩⡻⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿
⢮⣟⣽⣫⣟⡽⣞⣯⡻⡾⣾⢵⣟⣯⢿⡽⣶⣮⡑⢯⣞⢮⡷⣫⢿⢾⣯⣿⢀⣿⢢⢟⡜⢰⢹⣎⢟⡎⣾⠨⡪⡑⡷⣝⣦⡙⡌⣟⣾⠀⢻⣗⢟⣞⢷⢨⢾⣿⣻⡿⣿⣿⣮⣥⡙⣿⣿⢿⣯⢿⣦⢅⣍⢨⣃⢍⣋⡫⡩⡬⢷⣜⣋⢭⢦⡵⣋⡻⣿⣿⡏⣺⣝⣿⡺⣿⠄⣷⣎⠻⣿⣿⢿⣿⣷⣿⣿⡿⣿⣿
⣳⡽⣮⢷⡽⣞⣯⣞⡽⣝⣷⡻⣷⢽⣯⣻⢷⣽⣻⣦⣌⡓⠝⡽⡳⣏⢶⡹⢀⠏⣼⡳⡕⡱⢕⣽⡹⡣⣯⢘⠌⣼⡹⢮⡟⣔⢻⡌⣿⠆⣇⢿⡽⣺⣻⣇⠻⣟⣿⣿⣟⣿⡿⡿⣟⡮⡋⠽⠊⠡⠺⠗⠸⢑⣎⢿⡹⣯⣲⣚⠶⣨⣥⡕⣪⣗⠭⣪⣌⡻⡸⣕⣽⡯⣇⢟⣷⢹⣿⣧⢹⣿⣿⣿⣿⢿⣿⣿⣿⣿
⢮⡻⣞⢷⣻⢞⣮⢞⣽⡺⡮⡿⣽⣳⡯⣷⢿⡺⡷⡽⣯⢿⣻⣦⡙⢮⡳⡻⡌⢣⡿⡵⡇⣜⢕⣧⣻⣕⢷⠨⡂⣾⠝⡽⣸⣿⡕⢿⡌⣷⢹⡎⣿⢽⣮⣻⣪⢻⣿⣯⣿⣿⢍⠊⡈⠄⢐⣤⢪⣷⣶⡠⡔⠇⡞⢦⣝⡤⢅⣹⣾⣿⣿⡿⣺⡧⡳⢨⢎⢕⢎⠰⣿⡽⣫⡪⣿⣸⣿⣿⠢⣿⣿⣿⣿⣿⣿⡿⣿⣿
⡵⣻⣝⢗⣿⣻⣮⡻⣮⡻⣞⣽⣫⢾⡯⣿⡵⣻⢞⣽⡺⣗⡽⣮⣏⠸⢪⢛⢞⢸⡯⡞⡡⢸⡪⡾⢮⣞⣽⡘⢄⡣⡾⣱⣿⣽⣿⡜⣿⡜⣇⢿⣮⢳⡷⡽⣮⢳⣝⢿⣿⢓⣴⣁⡐⡁⢊⡉⡸⣞⣿⣟⣗⠡⣹⣧⣭⠄⣾⣿⡿⣷⢿⡇⣿⡣⣫⠰⡕⢭⣎⢘⣿⡺⡿⡌⣿⠜⣿⣿⢑⣿⣿⣿⣯⣿⣿⣿⣿⣿
⣺⢧⣯⡻⣾⢵⣯⣟⣮⡻⡮⡾⣕⢿⡽⣾⢯⣷⡻⣮⢻⣎⢿⣪⡾⣶⣁⠱⡅⣻⢞⡕⣅⠸⡕⣟⢷⡳⡵⢇⢕⢝⣼⣟⡿⣾⣯⣷⣹⣿⣞⢎⣿⡗⢿⡽⣷⢇⢿⣿⣽⣿⣿⣥⢀⢌⠦⡑⢎⡻⡙⢝⡎⠰⡰⣽⢾⢨⣿⣿⢯⣟⣿⡊⣿⡇⡽⡨⡪⣒⣷⠐⣿⣽⢿⡣⣻⣍⣿⡧⣽⣿⣿⣿⣿⣿⣟⣿⣿⣿
⣝⡿⣾⣽⣻⣯⢷⡿⣮⣟⢾⣝⡽⣳⡽⣺⢟⣾⢯⣞⢷⣹⡳⣿⢿⡺⡇⠒⠠⣯⡻⡆⡪⡈⣗⢯⣫⡯⣻⢸⠸⣎⢷⠯⣻⠛⡞⠟⣷⢿⣿⣷⡹⣿⣎⡻⣽⣿⡘⣿⣿⣿⣿⡿⢦⣠⣰⣾⣶⣞⣿⢮⡿⡐⡕⢺⣿⣺⣿⡟⢼⣯⣿⢌⣿⡆⣙⡮⡢⣵⢿⡈⣿⣯⢿⣏⠼⡇⢾⢒⣿⣿⣿⣿⣽⣿⣿⣿⣿⣿
⢾⣽⣗⡿⣾⡽⣟⣽⡻⣞⢷⡽⣝⣷⣫⣯⢯⣯⣻⣽⣗⢽⡺⡵⣯⡻⢨⢁⢪⢒⢽⡣⡂⢵⡘⢽⢮⡻⣵⢱⠈⣏⠙⢁⠄⠄⡘⢰⣬⣝⣯⣿⣿⣟⣿⣮⡱⢿⣷⡹⣿⣿⣿⣿⣿⣞⣿⣿⣻⣷⢻⣝⡿⡄⣻⡈⣿⣿⣿⣿⣘⣷⢿⠣⣿⡆⡱⣟⢾⡳⣿⡑⣿⢯⡿⣇⣻⣫⢌⣿⣿⣿⣿⢿⣿⣿⣻⣿⣾⣿
⣻⢾⣽⣻⢾⣻⢯⡾⣝⣯⣗⡿⣽⢮⡷⡽⡾⣮⢾⢶⢯⢷⡝⡾⡕⢅⠳⡄⡕⡕⣸⣇⠆⢸⣧⡙⢗⣯⣻⠰⠁⡁⣨⣶⣔⠠⠂⢌⠠⡜⣿⣿⣿⣿⣿⣿⣿⣮⡻⢷⣽⣿⣿⣿⣿⣷⣽⣿⣟⣿⡽⣿⣝⠦⣸⡇⢿⣿⣷⣿⣷⡟⢑⡵⢿⡇⢜⣯⢿⣝⣿⢸⡯⣿⢽⡗⢼⡇⠴⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣽⣻⢷⣯⣟⣽⡳⣯⢿⣮⣟⢾⡯⣷⣻⣝⣟⢾⡳⣯⡻⣳⢟⢽⣰⢝⢮⡪⣊⠎⣼⢷⠀⢹⡮⣷⢌⠳⣝⡇⡃⢶⢾⡿⣿⠧⠑⠅⣃⣸⣼⣿⣿⣽⣿⣟⣿⣿⣿⣯⣻⣽⣿⣿⣿⣿⡾⣯⣿⣿⣗⢿⡇⡗⡬⣟⡸⢟⢞⠿⠑⢤⢪⡟⣾⢇⢪⣟⣿⡺⡯⢸⡯⡻⣽⣟⢸⣷⢱⢹⣿⣿⣽⣿⣯⣿⣿⣽⣿⣿
⢾⡽⣳⢷⡽⣞⣯⣟⣷⣳⡯⣿⠽⡳⡛⣬⢵⢵⢞⡶⣳⡳⣻⢧⡫⣗⢯⠂⣕⠱⣯⣻⠀⢸⢯⡞⣷⡑⢮⡎⢎⠜⢳⢿⢨⣢⡘⣦⣽⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣾⣿⣿⣽⣿⣾⣿⡍⡧⡣⣿⢸⡇⢤⠙⣮⠣⡁⣿⣝⡎⣷⢘⡷⣯⣻⡓⡈⢟⡼⡱⣿⢨⣿⡘⣦⠿⣿⣿⣿⣿⣿⣿⣿⡿⣿
⣳⣝⡷⣻⡽⣫⣺⣗⡯⢞⣹⡦⢳⡴⣻⡪⣗⡽⣳⣝⠗⢿⢘⣇⡫⠔⡡⢠⡑⣝⢷⡭⠀⡱⣻⢮⣫⢧⠘⢧⠫⡖⡄⠻⣮⡷⣯⢿⣿⣟⣿⣿⣿⣽⣿⣟⣿⣿⣿⣿⣿⣿⡿⣿⣿⢿⣿⣷⣿⣿⡟⡥⣓⠕⣿⢐⣿⠰⣹⡇⡇⢸⡿⣮⢐⣿⡁⣿⢿⡕⡭⡌⢺⡪⣓⣿⠢⣿⡇⢺⡽⣚⣿⣿⣽⣷⣿⣿⣿⣿
⢵⣯⢛⣵⢾⣻⢕⢥⡾⣾⡝⢜⡷⣝⡮⣻⠜⣋⣮⣦⠿⢚⡩⣡⣺⡖⢔⢎⡾⣹⡳⠸⡀⠸⣯⢷⡸⣇⢙⢦⡙⢾⡘⣧⡸⣟⣿⣟⣿⣿⣹⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⢝⣾⣿⢕⠩⣿⢀⣿⢸⡻⣎⢢⣟⢿⡖⠠⡿⣧⢸⣟⢮⡃⣿⣐⢯⣪⣿⡑⢾⣻⡐⣟⢷⡜⢿⣿⣿⣿⡿⣿⣿
⡗⣱⣟⣯⢏⡵⢭⣾⣻⣾⠁⣟⢾⣪⢟⣼⣟⡿⡓⠡⣒⣵⡿⣽⢏⢜⡮⣳⢝⡮⠃⡽⠀⡪⣷⡳⢵⡇⢸⡕⣽⠷⣦⠨⣧⠭⣷⣿⡾⣿⣿⣿⣿⣾⣿⣿⣿⢿⣿⣿⣿⣾⣾⣿⣿⣿⣿⣻⣾⣿⣿⣿⡙⠌⡗⢤⣿⢸⣿⣕⣯⣾⣿⢁⠂⢿⣻⡄⣿⢴⢣⣿⣿⡜⣾⢷⡝⢺⣟⣧⠸⣿⣞⣕⢻⣿⣿⣿⣿⣿
⢧⡨⢛⠝⠰⣯⠸⣷⣻⡇⢸⣫⢳⢵⣿⣳⠟⡡⢊⡞⢿⣽⢟⢥⣞⢵⡫⣞⠕⡡⢜⠎⣸⠰⣿⡵⣿⠁⣪⠎⣾⣛⢾⡄⢿⡧⡜⢿⣿⡝⣿⣿⣟⣿⣿⣷⣿⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⢻⢟⣋⡊⡝⣸⡿⣸⡷⣿⣸⣯⠗⡨⡃⢸⣿⡇⣻⣮⠸⣿⣿⡇⣿⣻⣎⢹⣯⢿⡆⢽⣿⣞⣧⡻⣿⣿⣻⣿
⣻⣟⣿⣻⣮⣙⡦⢍⡘⢧⠘⢧⣻⡷⢋⣭⡕⣹⣯⣇⠸⣯⣞⢗⡷⣹⢮⠳⡜⡕⡝⣰⡏⢼⣷⣟⡯⠠⡧⢹⣯⣻⣵⢇⣌⠻⡼⣎⡛⢿⣮⡻⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣟⣿⣿⣿⣿⠛⣋⢊⡾⡽⡆⡱⣸⡯⢺⡿⣇⢿⡾⠡⡣⡑⢘⣷⣗⢹⣯⢧⡹⣿⡗⣿⣵⢧⢹⣷⡻⣿⡠⣻⣿⣿⢯⠺⣿⣿⣿
⣽⡾⣽⣽⢯⣟⡿⣻⢏⣮⢛⣶⡷⣴⢿⡛⢵⢿⡝⣧⠘⣿⢮⢛⣩⣛⠕⡭⣪⠊⣰⢿⢬⡿⣮⢿⠠⡞⢰⣿⣳⣟⡾⢰⡿⣎⠦⡧⢝⢶⣩⣃⢛⠿⠿⢯⣿⣿⢿⣿⣿⡿⣿⣿⣿⢿⣺⢟⣾⣫⢗⣽⠻⡀⠳⢸⣿⠸⣿⡅⡿⣟⠨⡃⢜⠀⣿⣧⢹⣿⢖⢕⢿⡯⣺⣯⡗⢹⣞⢝⣯⣷⠨⣿⣿⣿⡑⢿⣿⣿
⣞⣿⣻⢾⢿⡝⢨⣗⢡⡷⣸⡯⡷⢹⣏⢫⡹⣣⣽⢇⢪⣧⣾⣿⡋⡕⢎⠎⣠⡼⠯⢋⣴⢿⢮⣣⢟⢆⣟⢷⣻⡵⢃⣿⣻⢾⣅⢏⢞⢵⢜⢵⢍⡞⣚⠶⣢⢕⡍⢧⠬⣩⢝⣏⣵⣾⣯⣟⣮⡷⠗⢃⠨⠰⠘⠾⢎⡇⢿⡸⠜⡷⢈⠇⡪⢀⣿⡞⢽⣿⢸⡡⡫⡗⣽⡷⣏⠸⣇⢧⢻⡾⣆⢚⣿⣯⡇⣻⣿⣿
⢉⣎⠷⠝⠕⡙⠸⢆⢌⡷⣯⢞⡕⣽⢯⣸⣷⢟⣮⣽⢾⣟⡷⣑⠋⣉⣠⣲⡭⠀⢢⣿⣝⣵⡯⡯⣫⣽⣽⣫⣾⠡⣽⡳⣿⣹⡮⢆⢫⡳⡱⡳⣕⡇⢸⡕⣗⢵⡹⡢⣳⠑⠇⣈⠉⡚⢉⢉⠄⢔⢐⠅⡑⣜⡜⣆⢢⡌⡌⡺⡡⠺⡄⢃⠆⠠⡿⡋⣼⡷⠐⡥⡫⢌⣿⣽⢧⠐⡗⡵⣙⣯⣿⡀⢻⣿⠇⣽⣿⣿
⣫⠇⡑⡡⣸⣞⣿⢾⢢⡟⡞⢥⡟⣼⢱⣟⡾⣻⣮⣿⣻⡏⠼⠿⠿⢟⡛⣭⡖⣱⢿⢮⣟⡾⡩⢞⡶⣻⣮⢿⢁⡾⣿⣝⡾⣽⢁⡾⠈⡓⡙⢚⠞⣔⠞⠮⢎⢐⣉⣤⢶⡾⣥⢄⠸⠄⢣⠐⣄⣅⢮⣼⢣⣿⡣⢹⣶⣬⡲⢌⢣⠊⠸⡣⢊⠐⣯⡀⣿⢏⢨⢢⡫⢰⡿⣞⢷⠀⢺⢪⠆⣻⣞⣿⡈⢿⣣⣿⣿⣿
⠀⣱⠈⣼⣯⡿⣽⠇⣺⣅⣣⣟⢷⢶⡟⣷⡽⣿⢾⣯⣟⢸⣿⣷⣿⣷⢿⣫⡶⣟⣽⢫⢎⢞⡸⣎⡯⣿⠎⣵⠫⣜⣷⢯⡟⡡⠎⣠⡶⣾⣾⣿⣷⠮⡔⢲⣺⢿⡿⣽⣗⣿⢿⣯⢓⢱⣷⣿⣷⣾⣿⡿⣼⣿⡱⠹⣿⣿⣿⣷⣾⣬⣅⡛⠦⡙⠦⣫⣞⢕⢸⢢⢑⡿⣽⡯⣷⠀⣣⢫⡣⡸⣷⢯⣟⢌⢿⣿⣿⣿
⡘⣼⡅⣿⣟⣾⡟⣠⣿⢽⡯⣾⠏⣵⣿⣽⣻⣟⡿⡷⣹⣿⡿⢾⣣⡷⣿⢱⠟⢝⠪⣡⡶⣿⢹⡮⡳⣣⣾⠯⡱⣽⡽⡋⣜⢕⣾⣿⠟⣾⣿⣿⡟⣜⢸⣲⣯⣟⣿⣽⣯⡛⣭⣣⣿⣦⡻⡛⣿⣿⣿⢧⣿⣿⢸⢃⣿⢿⡿⣿⣿⣿⣿⣿⣿⣿⣷⣯⣵⣅⣛⠥⣫⡼⣷⣻⣮⠀⣽⡔⣝⠔⣿⣝⡿⣦⢙⣿⣿⣿
⢘⣞⢷⣝⢿⣾⢡⡿⣷⣻⣽⣻⡼⣿⢾⡷⣿⣻⡿⣱⣿⡟⠵⣫⣭⣮⠖⠠⡑⠄⣡⣿⣽⣫⡗⢃⣼⠛⡜⣎⡺⡺⢃⡞⣴⣿⢟⢣⣿⣿⣿⢟⠼⢢⣻⣿⣿⣿⣿⣿⣿⣿⢔⣿⠷⣯⣏⣾⣾⣿⣿⢸⣿⡗⡯⢴⢽⣮⢿⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣶⣾⣙⠻⢞⣽⣗⠀⣽⣷⢱⡃⢺⣯⣟⢾⡆⣻⣿⣿
⠪⡪⠷⠽⠶⣝⠇⢿⣻⣗⣿⣞⣿⣽⣿⣻⣿⡽⣃⣿⠋⢔⣮⣾⡿⠃⢠⠙⡌⣼⣟⢷⢳⡎⠰⡱⢃⢝⢬⣟⢼⢣⢏⣾⢟⢱⣵⣿⣿⡿⡩⡺⢁⣿⣿⣿⣿⣿⣿⣿⢿⣿⣕⣵⣷⣭⣣⣿⣿⣿⡏⣾⣿⣹⠇⣿⡚⣿⡞⣿⣿⣿⣿⣿⣻⣿⣿⣿⣿⣿⣿⣿⣿⣧⡪⠱⣯⠀⣟⣿⣧⢫⢸⣿⢞⡿⣇⢪⣿⣿
⢛⣚⣷⣻⣵⡱⣫⠘⣻⣞⡷⣻⢞⣷⣻⣯⠚⣬⡾⢡⢊⣾⡿⢋⠔⡢⢑⣱⣾⡻⣞⠷⠋⣰⢁⢂⢗⡱⢰⣯⠟⢌⢣⣔⣾⣿⣿⣿⡟⡰⡑⢅⣿⣿⣿⣿⣿⣯⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⡇⣿⢏⣾⠁⢼⡇⣿⣿⣹⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⣿⣿⣗⢧⡸⢰⡇⣿⣿⣧⡸⣯⣯⣻⡏⡮⣿⣿
⢿⢝⡯⣷⢻⢿⠔⡡⡀⢿⡽⣯⢿⡵⣿⢾⡄⣻⣇⠥⢼⣵⣴⣤⣷⣾⢿⢝⣭⡩⢠⢒⢝⢔⡁⢔⢕⢵⢈⢏⡆⣳⣿⣿⣿⠿⡾⡟⡰⡑⢡⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣯⡟⢢⡟⣰⠸⣗⢼⣿⡎⣿⣿⣿⣯⣿⣷⣿⣿⡿⣿⣷⣿⣿⢿⣿⡎⣇⢸⣷⢹⣿⣿⢸⣗⢷⣽⡊⣯⣿⣿
⢒⠎⣃⣑⣁⣂⠑⠌⣂⣙⣙⣓⣋⣛⠛⣙⣂⡹⢀⠏⣒⣉⠮⣙⣛⣙⣃⣛⠯⣿⣦⠑⣕⢕⠆⢈⣊⣐⣑⡈⣲⢟⣋⣛⢳⣉⣊⣘⡈⣊⣙⣛⣛⣛⣙⣛⢚⣙⣋⣓⣛⣛⡋⣿⣿⣿⡟⣙⣋⣛⣙⣃⢸⠃⣛⣈⠳⡪⡿⢃⣛⣋⣛⠿⣿⡿⢛⣙⣛⣙⠿⣿⣿⣿⣿⣇⠗⣘⣛⣀⣛⠷⣹⢋⣓⣙⣁⣛⣚⢻
⡅⣾⣿⡛⠻⠿⠷⡀⣿⣿⠟⠛⠛⢛⡄⢿⣿⣷⣄⠑⣿⣿⠠⣻⣿⡟⠻⢿⣷⡜⣿⣿⣤⠃⣼⣿⡿⠛⢿⣿⠜⢼⣿⣿⢸⡏⣿⣿⡇⣛⣛⢻⣿⡟⣛⣛⢸⣿⣿⠛⠛⠛⣃⣿⣿⣿⡇⣿⣿⠛⡻⣿⣷⠀⣿⣿⠅⣃⣾⣿⢟⡻⢿⡷⠙⣴⣿⡟⠙⠿⠷⢸⣿⣿⣿⢢⣾⣿⢟⡻⣿⣷⡙⢜⣿⣿⠛⣛⢛⣸
⣤⡙⠿⢿⣿⣷⣎⠃⣿⣿⡿⠿⠿⠇⡁⢿⣿⠻⣿⣮⣿⡿⠠⣽⣿⡇⣯⢸⣿⡇⣽⣿⣿⡇⣿⣿⠰⡑⠔⠶⢿⢺⣿⣿⠸⣁⣿⣿⡇⣿⣿⢸⣿⡇⣿⣿⢳⣿⣿⠿⠿⠿⢪⣿⣿⣿⡇⣿⣿⣶⣾⡿⠟⡄⣿⣿⡃⢸⣿⣯⢸⣿⠶⠿⢿⢌⠻⢿⣿⣷⣮⢻⣿⣿⣯⢸⣿⡇⣿⡿⢸⣿⡇⢸⣿⣿⢷⡾⡆⣿
⡇⢾⣿⣔⣢⣿⡿⠀⣿⣿⣦⣤⣥⣥⠁⣿⣿⢅⡙⣿⣿⣟⠐⢾⣿⣧⣤⣾⣿⢣⣿⣾⣽⣧⠻⣿⣦⣬⣾⣿⢃⠎⢿⣿⣤⣥⣿⡿⢡⡈⣄⢸⣿⡏⣿⣿⡳⣿⣿⣬⣭⣭⡍⣿⣿⣿⡇⣿⣿⢠⣶⠀⣾⡇⣿⣿⢆⣌⢿⣿⣬⣥⣾⡿⢂⢻⣿⣆⣢⣿⣿⢱⣿⣿⣿⡘⢿⣷⣬⣥⣿⡿⢣⡱⣿⣿⢀⣾⡖⣿
⢛⣢⡭⣩⢋⡍⢖⢧⠉⡉⣍⢭⢍⡭⡤⣩⡩⡴⣏⢌⡉⢭⣜⣭⣍⢩⣭⣭⣶⣷⣭⣻⣿⣿⣷⣭⣽⣭⣭⡁⠢⢈⢤⢍⣙⢍⢭⢔⠵⡱⣌⢬⠍⡭⣿⣿⣭⣭⣭⣭⣭⣭⣥⣿⣿⣿⣧⣭⣭⣴⡿⠀⡿⢅⠉⠭⣴⣿⣷⣬⣽⣭⣽⣶⢣⣶⣭⣭⣫⣭⣴⣿⣿⣿⣿⠃⡴⣭⣽⣭⣩⣶⣿⣬⣭⡍⣔⣿⢇⣿
⢏⠎⡢⡱⢔⢎⡾⢮⡖⢐⢜⠦⡳⢜⡪⣆⢳⡱⡱⢆⢜⠰⣮⣟⡿⢸⣝⣛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⡀⢮⢢⡑⡬⣣⣛⢜⡕⡳⡜⣬⢃⢗⢸⣿⣿⣿⣿⣿⣿⡿⣿⣿⣿⣿⣿⣿⠟⢋⢙⡄⡳⣀⡁⡲⣄⢭⢐⣉⠻⣿⢿⣧⣾⣿⣿⣿⣿⣿⣿⣿⣿⣿⡏⡰⡨⣿⣿⠗⣼⣟⣾⣻⡞⢦⣹⣿⢸⣿
⠕⡸⡴⣻⢝⢋⢋⠕⡙⣀⣌⡑⣝⢊⣐⣁⠳⣈⣈⣊⣠⣃⣙⢻⣗⡐⣿⣿⠿⢛⣉⣍⣙⡻⢿⣋⣋⣋⣋⣛⣛⠢⡃⣉⣈⣑⣉⣑⣈⢳⢈⣂⣅⣙⣀⡻⢿⡟⣉⣋⠛⣘⣛⣙⣋⣋⣙⡁⠂⡔⢡⠃⠸⣀⣭⣨⣐⡑⠕⠭⡲⣁⣄⣘⠿⠟⠟⣙⣙⣙⣋⣛⡛⠻⢁⣌⣘⣋⣋⣊⠿⣮⣳⡟⡐⣮⣿⢇⣿⣿
⣸⣝⢾⡑⢔⠅⡕⢌⡂⢽⣿⡇⢈⠰⣿⣿⠨⣸⣿⡟⠛⢻⣿⡇⣿⢧⣜⠏⣼⣿⡟⣛⠿⠿⠎⣺⣿⣿⠛⢻⣿⣷⢸⢽⣿⡟⠛⠛⠛⡸⢼⣿⡟⡛⢿⣿⡆⡇⣿⣿⠀⡛⡛⢻⣿⡟⢛⣃⢜⢕⠱⢡⣾⣿⢟⡛⠿⠷⢘⡕⢰⣿⣿⣿⡆⢺⠂⣿⣿⡛⠛⣿⣿⠆⢸⣿⣿⠛⢿⣿⣦⢳⡟⡠⣹⣾⢏⣼⣿⣿
⢧⡻⣎⢆⢕⠌⢊⣤⡅⢾⣿⡇⢨⢐⣿⣿⢀⢺⣿⡿⢿⣿⡟⢁⢿⣝⣿⡆⣿⣿⢈⠫⣓⡻⠿⢺⣿⣿⢿⣿⣟⢣⡾⣹⣿⡿⠿⠿⠟⢼⢸⣿⡇⢌⢸⣿⡧⠐⣿⣿⠀⢎⠀⣹⣿⡇⡣⡕⡕⢭⡊⢸⣿⣯⢈⢟⢒⡛⠧⢃⣾⣿⡀⣿⣿⡰⡇⣿⣿⠿⣿⣿⡋⣼⢸⣿⣿⢸⢅⣿⣿⠘⠄⣾⣿⢋⣼⣿⣿⣿
⡳⣝⢾⠆⣢⣼⣿⣿⣿⡸⣿⣷⣦⣾⣿⠏⡄⣹⣿⡇⢌⢿⣿⣎⠢⣯⢺⠃⠹⣿⣷⣵⣾⡿⢃⢾⣿⣿⢠⠻⣿⣧⡙⣽⣿⣷⣵⣾⣶⢩⢺⣿⣷⣶⣾⡿⢃⢈⣿⣿⠈⠮⡅⢸⣿⡇⢎⠎⡪⠡⡊⢄⢻⣿⣦⣷⣿⡿⠁⣾⣿⠟⠻⠻⣿⣧⠁⣿⣿⡱⡜⣿⣿⡜⢸⣿⣷⣶⣾⣿⠏⣈⢾⡟⣡⣿⣿⣿⣿⣿
⣝⢷⡙⣼⣿⢿⣿⣽⣿⢷⣶⡍⢉⢍⠤⡪⡒⡌⡍⣡⢎⠦⡩⡩⡰⣄⢑⡑⡣⡈⢍⢉⠡⠒⡳⣄⠥⠥⠾⠷⠭⣭⣤⣬⣭⣬⣥⣭⣬⣴⣬⣉⢉⠅⠡⠠⡈⢀⣉⡉⡀⠣⠢⢌⢉⠡⡂⢕⠨⡢⢑⠌⠔⣮⣍⠩⢤⠲⡅⢉⠌⡜⠿⢓⠍⠩⠴⣭⣭⣼⣿⣬⣥⣥⣬⡭⢥⢩⢤⣦⢜⠣⣵⣾⣿⣿⣿⣿⣿⣿
⢞⢵⡃⣿⡽⢫⣥⣵⣥⣮⣰⣑⢠⡊⢎⢎⢜⠜⡔⢕⢕⠕⡕⡜⡢⢎⡄⢫⠰⡈⢢⠁⢎⠨⡂⢵⠀⢘⢖⢔⡄⠈⠛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣦⡝⡊⢖⢥⠄⡱⠠⡈⢕⠑⠔⡡⢑⢌⠢⡑⡬⡪⣣⡑⠘⢷⢽⣌⠣⡈⠢⡰⡨⡪⡢⡹⡰⡡⡈⠻⣿⣿⣿⢯⡷⣽⣶⣿⣿⣿⣷⡹⡝⣿⣿⣿⣿⣿⣿⣿⣿
*/

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pint pair<int, int>
#define gay MikeKalyzhnyy
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

#ifndef LOCAL
#pragma GCC optimize("unroll-loops,Ofast,inline")
#pragma GCC target("avx2")
#endif

void dumb_1(int n) {
    vector<pair<pint, int>> e;
    vector<int> deg(n);
    for (int i = 1; i < n; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        deg[a]++, deg[b]++;
        e.emplace_back(make_pair(a, b), c);
    }
    vector<vector<int>> vals(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < deg[i]; ++j){
            int x;
            cin >> x;
            vals[i].push_back(x);
        }
    }
    vector<int> ind(n - 1);
    iota(all(ind), 0);
    do {
        vector<int> j(n);
        for (int i = 0; i < n; ++i) {
            j[i] = deg[i] - 1;
        }
        bool bad = false;
        for (auto& i : ind) {
            auto [a, b] = e[i].first;
            int c = e[i].second;
            if (vals[a][j[a]] + vals[b][j[b]] >= c) {
                j[a]--;
                j[b]--;
            } else {
                bad = true;
            }
        }
        if (!bad) {
            cout << "YES\n";
            for (auto& el : ind) cout << el + 1 << ' ';
            return;
        }
    } while (next_permutation(all(ind)));
    cout << "NO\n";
}

inline void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (auto& el : v) cin >> el;
    vector<int> pref(n + 1);
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + v[i];
    }
    int l1 = 0, l2 = 0;
    int l = 0, r = n - 1;
    int w1 = 0, w2 = 0;
    while (l <= r) {
        int mn = min(l1, l2);
        l1 -= mn, l2 -= mn;
        if (l1 == 0) {
            int last = v[r];
            int plus = *lower_bound(pref.begin() + l, pref.begin() + r, last + pref[l] + l2) - pref[l];
            if (plus >= last) {
                w1 += v[l];
                l1 = v[l];
                l++;
//                cout << "l1\n";
            } else {
                w1 += v[r];
                l1 = v[r];
                r--;
//                cout << "r1\n";
            }
        } else if (l2 == 0) {
            int last = v[r];
            int plus = *lower_bound(pref.begin() + l, pref.begin() + r, last + pref[l] + l1) - pref[l];
            if (plus >= last) {
                w2 += v[l];
                l2 = v[l];
                l++;
//                cout << "l2\n";
            } else {
                w2 += v[r];
                l2 = v[r];
                r--;
//                cout << "r2\n";
            }
        }
    }
    cout << w1 << ' ' << w2 << endl;
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}
