#include <vector>
#include <algorithm>
#include <iostream>
#include <string>
#include <map>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	vector<int>w(n);
	long long summ = 0;
	for (int i = 0; i < n; i++) {
		cin >> w[i];
		summ += w[i];
	}
	if (n < 4) {
		vector<vector<vector<int>>>dp1(n + 1, vector<vector<int>>(n + 1, vector<int>(summ + 1)));
		vector<vector<vector<int>>>dp2(n + 1, vector<vector<int>>(n + 1, vector<int>(summ + 1)));
		for (int i = 0; i <= n; i++) {
			for (int j = 0; j <= n; j++) {
				for (int y = 0; y < dp1[i][j].size(); y++) {
					dp1[i][j][y] = -1e9;
					dp2[i][j][y] = -1e9;
				}
			}
		}
		for (int k = 0; k <= n; k++) {
			for (int i = 0; i <= n - k; i++) {
				for (int j = 0; j <= summ; j++) {
					if (k == 0) {
						dp1[i][i][j] = -j;
						dp2[i][i][j] = -j;
					}
					else {
						if (j >= w[i]) {
							dp1[i][i + k][j] = max(dp1[i][i + k][j], dp1[i + 1][i + k][j - w[i]]);
							if (j > w[i]) {
								dp2[i][i + k][j] = max(dp2[i][i + k][j], dp2[i + 1][i + k][j - w[i]]);
							}
							else {
								dp2[i][i + k][j] = max(dp2[i][i + k][j], -dp1[i + 1][i + k][0]);
							}
						}
						else {
							dp1[i][i + k][j] = max(dp1[i][i + k][j], -dp2[i + 1][i + k][w[i] - j]);
							dp2[i][i + k][j] = max(dp2[i][i + k][j], -dp1[i + 1][i + k][w[i] - j]);
						}
						if (j >= w[i + k - 1]) {
							dp1[i][i + k][j] = max(dp1[i][i + k][j], dp1[i][i + k - 1][j - w[i + k - 1]]);
							if (j > w[i + k - 1]) {
								dp2[i][i + k][j] = max(dp2[i][i + k][j], dp2[i][i + k - 1][j - w[i + k - 1]]);
							}
							else {
								dp2[i][i + k][j] = max(dp2[i][i + k][j], -dp1[i][i + k - 1][0]);
							}
						}
						else {
							dp1[i][i + k][j] = max(dp1[i][i + k][j], -dp2[i][i + k - 1][w[i + k - 1] - j]);
							dp2[i][i + k][j] = max(dp2[i][i + k][j], -dp1[i][i + k - 1][w[i + k - 1] - j]);
						}
					}
				}
			}
		}
		int se = (summ - dp1[0][n][0]) / 2;
		cout << se + dp1[0][n][0] << " " << se;
	}
	int cnt = 0;
	for (int i = 0; i < n; i++) {
		if (w[i] == 1) {
			cnt++;
		}
	}
	if (cnt % 2 == 0 && n % 2 == 0) {
		cout << summ / 2 << " " << summ / 2;
	}
	else {
		cout << summ / 2 + 1 << " " << summ / 2;
	}
}