#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

using ll = long long;
using lll = __int128_t;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using dui = pair<int, int>;
using dul = pair<long, long>;
using vi = vector<int>;
using vll = vector<long long>;
using ld = long double;

constexpr int MX = 2'000'000'000;
constexpr long long MXL = 4'000'000'000'000'000'000;

int mxa = 0, mxb = 10000000;
void dfs(vi &a, vi &used, int cura, int curb) {
    if (count(used.begin(), used.end(), 1) == used.size()) {
        if (abs(mxa - mxb) > abs(cura - curb)) {
            mxa = cura;
            mxb = curb;
        }
    }
    int n = a.size();
    if (cura <= curb) {
        for (int i=0;i<n;i++) {
            if (used[i]) continue;
            used[i] = 1;
            dfs(a, used, cura + a[i], curb);
            used[i] = 0;
        }
    }
    else {
        for (int i=0;i<n;i++) {
            if (used[i]) continue;
            used[i] = 1;
            dfs(a, used, cura, curb + a[i]);
            used[i] = 0;
        }
    }
}

void solve() {
    int n;
    cin >> n;
    vi a(n);
    for (int &i : a) cin >> i;
    vi used(n);
    dfs(a, used, 0, 0);
    cout << mxa << ' ' << mxb;
}

int32_t main() {
#ifdef LOCAL
    freopen("inputf.txt", "r", stdin);
    freopen("outputf.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
