//#define GLIBCXX_DEBUG
#include <bits/stdc++.h>

//#define int long long
#define ld long double
#define F first
#define S second
using namespace std;
const int inf = 1e9;
map<vector<int>, vector<vector<int>>> g;
map<vector<int>, pair<int, int>> dp;
vector<vector<int>> ord;

void dfs(vector<int> v) {
    ord.push_back(v);
    for (auto i: g[v]) {
        dfs(i);
    }
    ord.push_back(v);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> w(n);
    int mxw = 0;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        mxw = max(mxw, w[i]);
    }
    dp[{0, n - 1, 0, 0}] = {0, 0};
    queue<vector<int>> q;
    q.push({0, n - 1, 0, 0});
    while (!q.empty()) {
        auto sost = q.front();
        q.pop();
        if (sost[0] > sost[1]) {
            continue;
        }
        if (w[sost[0]] > sost[2]) {
            if (sost[3] == 0) {
                if (!dp.count({sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]})) {
                    dp[{sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]}] = {-inf, -inf};
                }
                if (dp[{sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]}].F < dp[sost].F + sost[2] ||
                    (dp[{sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]}].F == dp[sost].F + sost[2] &&
                     dp[{sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]}].S > dp[sost].S + sost[2])) {
                    dp[{sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]}] = {dp[sost].F + sost[2],
                                                                                     dp[sost].S + sost[2]};
                    g[sost].push_back({sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]});
                    q.push({sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]});
                }
            } else {
                if (!dp.count({sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]})) {
                    dp[{sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]}] = {-inf, -inf};
                }
                if (dp[{sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]}].S < dp[sost].S + sost[2] ||
                    (dp[{sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]}].S == dp[sost].S + sost[2] &&
                     dp[{sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]}].F > dp[sost].F + sost[2])) {
                    dp[{sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]}] = {dp[sost].F + sost[2],
                                                                                     dp[sost].S + sost[2]};
                    g[sost].push_back({sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]});

                    q.push({sost[0] + 1, sost[1], w[sost[0]] - sost[2], 1 - sost[3]});

                }
            }
        } else if (w[sost[0]] == sost[2]) {
            if (sost[3] == 0) {
                if (!dp.count({sost[0] + 1, sost[1], 0, 0})) {
                    dp[{sost[0] + 1, sost[1], 0, 0}] = {-inf, -inf};
                }
                if (dp[{sost[0] + 1, sost[1], 0, 0}].F < dp[sost].F + sost[2] ||
                    (dp[{sost[0] + 1, sost[1], 0, 0}].F == dp[sost].F + sost[2] &&
                     dp[{sost[0] + 1, sost[1], 0, 0}].S > dp[sost].S + sost[2])) {
                    dp[{sost[0] + 1, sost[1], 0, 0}] = {dp[sost].F + sost[2], dp[sost].S + sost[2]};
                    g[sost].push_back({sost[0] + 1, sost[1], 0, 0});
                    q.push({sost[0] + 1, sost[1], 0, 0});
                }
            } else {
                if (!dp.count({sost[0] + 1, sost[1], 0, 0})) {
                    dp[{sost[0] + 1, sost[1], 0, 0}] = {-inf, -inf};
                }
                if (dp[{sost[0] + 1, sost[1], 0, 0}].S < dp[sost].S + sost[2] ||
                    (dp[{sost[0] + 1, sost[1], 0, 0}].S == dp[sost].S + sost[2] &&
                     dp[{sost[0] + 1, sost[1], 0, 0}].F > dp[sost].F + sost[2])) {
                    dp[{sost[0] + 1, sost[1], 0, 0}] = {dp[sost].F + sost[2], dp[sost].S + sost[2]};
                    g[sost].push_back({sost[0] + 1, sost[1], 0, 0});
                    q.push({sost[0] + 1, sost[1], 0, 0});
                }
            }
        } else {
            if (sost[3] == 0) {
                if (!dp.count({sost[0] + 1, sost[1], sost[2] - w[sost[0]], 0})) {
                    dp[{sost[0] + 1, sost[1], sost[2] - w[sost[0]], 0}] = {-inf, -inf};
                }
                if (dp[{sost[0] + 1, sost[1], sost[2] - w[sost[0]], 0}].S < dp[sost].S + w[sost[0]] ||
                    (dp[{sost[0] + 1, sost[1], sost[2] - w[sost[0]], 0}].S == dp[sost].S + w[sost[0]] &&
                     dp[{sost[0] + 1, sost[1], sost[2] - w[sost[0]], 0}].F > dp[sost].F + w[sost[0]])) {
                    dp[{sost[0] + 1, sost[1], sost[2] - w[sost[0]], 0}] = {dp[sost].F + w[sost[0]],
                                                                           dp[sost].S + w[sost[0]]};
                    g[sost].push_back({sost[0] + 1, sost[1], sost[2] - w[sost[0]], 0});
                    q.push({sost[0] + 1, sost[1], sost[2] - w[sost[0]], 0});
                }
            } else {
                if (!dp.count({sost[0] + 1, sost[1], sost[2] - w[sost[0]], 1})) {
                    dp[{sost[0] + 1, sost[1], sost[2] - w[sost[0]], 1}] = {-inf, -inf};
                }
                if (dp[{sost[0] + 1, sost[1], sost[2] - w[sost[0]], 1}].S < dp[sost].F + w[sost[0]] ||
                    (dp[{sost[0] + 1, sost[1], sost[2] - w[sost[0]], 1}].F == dp[sost].F + w[sost[0]] &&
                     dp[{sost[0] + 1, sost[1], sost[2] - w[sost[0]], 1}].S > dp[sost].S + w[sost[0]])) {
                    dp[{sost[0] + 1, sost[1], sost[2] - w[sost[0]], 1}] = {dp[sost].F + w[sost[0]],
                                                                           dp[sost].S + w[sost[0]]};
                    g[sost].push_back({sost[0] + 1, sost[1], sost[2] - w[sost[0]], 1});
                    q.push({sost[0] + 1, sost[1], sost[2] - w[sost[0]], 1});
                }
            }
        }


        if (w[sost[1]] > sost[2]) {
            if (sost[3] == 0) {
                if (!dp.count({sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]})) {
                    dp[{sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]}] = {-inf, -inf};
                }
                if (dp[{sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]}].F < dp[sost].F + sost[2] ||
                    (dp[{sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]}].F == dp[sost].F + sost[2] &&
                     dp[{sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]}].S > dp[sost].S + sost[2])) {
                    dp[{sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]}] = {dp[sost].F + sost[2],
                                                                                     dp[sost].S + sost[2]};
                    g[sost].push_back({sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]});
                    q.push({sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]});
                }
            } else {
                if (!dp.count({sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]})) {
                    dp[{sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]}] = {-inf, -inf};
                }
                if (dp[{sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]}].S < dp[sost].S + sost[2] ||
                    (dp[{sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]}].S == dp[sost].S + sost[2] &&
                     dp[{sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]}].F > dp[sost].F + sost[2])) {
                    dp[{sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]}] = {dp[sost].F + sost[2],
                                                                                     dp[sost].S + sost[2]};
                    g[sost].push_back({sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]});
                    q.push({sost[0], sost[1] - 1, w[sost[1]] - sost[2], 1 - sost[3]});

                }
            }
        } else if (w[sost[1]] == sost[2]) {
            if (sost[3] == 0) {
                if (!dp.count({sost[0], sost[1] - 1, 0, 0})) {
                    dp[{sost[0], sost[1] - 1, 0, 0}] = {-inf, -inf};
                }
                if (dp[{sost[0], sost[1] - 1, 0, 0}].F < dp[sost].F + sost[2] ||
                    (dp[{sost[0], sost[1] - 1, 0, 0}].F == dp[sost].F + sost[2] &&
                     dp[{sost[0], sost[1] - 1, 0, 0}].S > dp[sost].S + sost[2])) {
                    dp[{sost[0], sost[1] - 1, 0, 0}] = {dp[sost].F + sost[2], dp[sost].S + sost[2]};
                    g[sost].push_back({sost[0], sost[1] - 1, 0, 0});
                    q.push({sost[0], sost[1] - 1, 0, 0});
                }
            } else {
                if (!dp.count({sost[0], sost[1] - 1, 0, 0})) {
                    dp[{sost[0], sost[1] - 1, 0, 0}] = {-inf, -inf};
                }
                if (dp[{sost[0], sost[1] - 1, 0, 0}].S < dp[sost].S + sost[2] ||
                    (dp[{sost[0], sost[1] - 1, 0, 0}].S == dp[sost].S + sost[2] &&
                     dp[{sost[0], sost[1] - 1, 0, 0}].F > dp[sost].F + sost[2])) {
                    dp[{sost[0], sost[1] - 1, 0, 0}] = {dp[sost].F + sost[2], dp[sost].S + sost[2]};
                    g[sost].push_back({sost[0], sost[1] - 1, 0, 0});
                    q.push({sost[0], sost[1] - 1, 0, 0});
                }
            }
        } else {
            if (sost[3] == 0) {
                if (!dp.count({sost[0], sost[1] - 1, sost[2] - w[sost[1]], 0})) {
                    dp[{sost[0], sost[1] - 1, sost[2] - w[sost[1]], 0}] = {-inf, -inf};
                }
                if (dp[{sost[0], sost[1] - 1, sost[2] - w[sost[1]], 0}].S < dp[sost].S + w[sost[1]] ||
                    (dp[{sost[0], sost[1] - 1, sost[2] - w[sost[1]], 0}].S == dp[sost].S + w[sost[1]] &&
                     dp[{sost[0], sost[1] - 1, sost[2] - w[sost[1]], 0}].F > dp[sost].F + w[sost[1]])) {
                    dp[{sost[0], sost[1] - 1, sost[2] - w[sost[1]], 0}] = {dp[sost].F + w[sost[1]],
                                                                           dp[sost].S + w[sost[1]]};
                    g[sost].push_back({sost[0], sost[1] - 1, sost[2] - w[sost[1]], 0});
                    q.push({sost[0], sost[1] - 1, sost[2] - w[sost[1]], 0});
                }
            } else {
                if (!dp.count({sost[0], sost[1] - 1, sost[2] - w[sost[1]], 1})) {
                    dp[{sost[0], sost[1] - 1, sost[2] - w[sost[1]], 1}] = {-inf, -inf};
                }
                if (dp[{sost[0], sost[1] - 1, sost[2] - w[sost[1]], 1}].S < dp[sost].F + w[sost[1]] ||
                    (dp[{sost[0], sost[1] - 1, sost[2] - w[sost[1]], 1}].F == dp[sost].F + w[sost[1]] &&
                     dp[{sost[0], sost[1] - 1, sost[2] - w[sost[1]], 1}].S > dp[sost].S + w[sost[1]])) {
                    dp[{sost[0], sost[1] - 1, sost[2] - w[sost[1]], 1}] = {dp[sost].F + w[sost[1]],
                                                                           dp[sost].S + w[sost[1]]};
                    g[sost].push_back({sost[0], sost[1] - 1, sost[2] - w[sost[1]], 1});
                    q.push({sost[0], sost[1] - 1, sost[2] - w[sost[1]], 1});
                }
            }
        }
    }
    for (auto &[key, val]: dp) {
        if (key[0] > key[1]) {
            if (key[3] == 0) {
                val.S += key[2];
            } else {
                val.F += key[2];
            }
        }
    }
    dfs({0, n - 1, 0, 0});
    for (auto i: ord) {
        pair<int, int> oo = {-inf, -inf};
        if (g[i].empty()) {
            oo = dp[i];
        }
        if (i[3] == 0) {
            for (auto j: g[i]) {
                if (dp[j].F > oo.F) {
                    oo = dp[j];
                }
            }
        } else {
            for (auto j: g[i]) {
                if (dp[j].S > oo.S) {
                    oo = dp[j];
                }
            }
        }
        dp[i] = oo;

    }
    cout << dp[{0, n - 1, 0, 0}].F << " " << dp[{0, n - 1, 0, 0}].S;
    return 0;
}
