#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define debug(x) std::cerr << #x << ": " << x << '\n'

using namespace std;
typedef long long i64;

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());
const i64 inf = 2e18;

i64 rnd() {
    return rng() % inf;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n; cin >> n;
    vector<int> a(n), p(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        p[i] = a[i];
        if (i) p[i] += p[i - 1];
    }
    unordered_map<i64, pair<int, int>> mp;
    unordered_map<int, i64> hsh;
    for (int i = 0; i < n; ++i) {
        hsh[i] = rnd();
    }
    auto f = [&] (auto self, int A, int l, int r) -> pair<int, int> {
        if (l > r) {
            return {A, p[n - 1] - A};
        }
        if (hsh.find(A + n) == hsh.end()) {
            hsh[A + n] = rnd();
        }
        int H = (hsh[A + n] + hsh[l] + hsh[r]);
        if (mp.find(H) != mp.end()) {
            return mp[H];
        }
        int B = (l ? p[l - 1] : 0);
        B += p[n - 1] - p[r];
        B -= A;
        if (A <= B) {
            auto p1 = self(self, A + a[l], l + 1, r);
            auto p2 = self(self, A + a[r], l, r - 1);
            if (p1.fi > p2.fi || (p1.fi == p2.fi && p1.se < p2.se)) {
                mp[H] = p1;
                return p1;
            } else {
                mp[H] = p2;
                return p2;
            }
        }
        auto p1 = self(self, A, l + 1, r);
        auto p2 = self(self, A, l, r - 1);
        if (p1.se > p2.se || (p1.se == p2.se && p1.fi < p2.fi)) {
            mp[H] = p1;
            return p1;
        } else {
            mp[H] = p2;
            return p2;
        }
    };

    auto res = f(f, 0, 0, n - 1);
    cout << res.fi << ' ' << res.se << '\n';
}
