#pragma gcc optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
// #define int ll
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll mod = 998244353;
const ll inf = 1e18;
const int mxn = 1e9 + 7;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << a << endl;
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;

const int N = 2e3 + 1, W = 2e4 + 1;
int n, w[N], pref[N], maxi = 0;
unordered_map <int, int> DP[2][200], DP1[2][200];

void solve() {
    cin >> n;
    int sum = 0, ones = 0, twos = 0;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        // w[i] = rand() % 500;
        maxi = max(w[i], maxi);
        ones += (w[i] == 1); twos += (w[i] == 2);
        sum += w[i];
        pref[i + 1] = pref[i] + w[i];
    }
    if (ones + twos == n) {
        if (!(ones % 2) && !(twos % 2)) {
            cout << sum / 2 << ' ' << sum / 2 << endl;
        }
        else if (!(ones % 2) && (twos % 2)) {
            cout << ones / 2 + (twos + 1) / 2 * 2 << ' ' << ones / 2 + (twos - 1) / 2 * 2 << endl;
        }
        else if ((ones % 2) && !(twos % 2)) {
            cout << (sum + 1) / 2 << ' ' << (sum - 1) / 2 << endl;
        }
        else {
            cout << (sum + 1) / 2 << ' ' << (sum - 1) / 2 << endl;
        }
        exit(0);
    }
    if (n <= 3) {
        vector<vector<vector<int>>> dp0(n, vector<vector<int>>(n, vector<int>(sum + 1, 0)));
        vector<vector<vector<int>>> dp1(n, vector<vector<int>>(n, vector<int>(sum + 1, 0)));
        for (int len = 1; len <= n; ++len) {
            for (int l = 0; l + len - 1 < n; ++l) {
                int r = l + len - 1;
                for (int i = 0; i <= sum - (pref[r + 1] - pref[l]); ++i) {
                    if (len == 1) {
                        if (2 * i <= sum - (pref[r + 1] - pref[l])) {
                            dp0[l][r][i] = i + w[l];
                        }
                        else {
                            dp0[l][r][i] = sum - dp1[l][r][sum - (pref[r + 1] - pref[l]) - i];
                        }
                        if (2 * i < sum - (pref[r + 1] - pref[l])) {
                            dp1[l][r][i] = i + w[l];
                        }
                        else {
                            dp1[l][r][i] = sum - dp0[l][r][sum - (pref[r + 1] - pref[l]) - i];
                        }
                    }
                    else {
                        if (2 * i <= sum - (pref[r + 1] - pref[l])) {
                            dp0[l][r][i] = max(dp0[l + 1][r][i + w[l]], dp0[l][r - 1][i + w[r]]);
                        }
                        else {
                            dp0[l][r][i] = sum - dp1[l][r][sum - (pref[r + 1] - pref[l]) - i];
                        }
                        if (2 * i < sum - (pref[r + 1] - pref[l])) {
                            dp1[l][r][i] = max(dp1[l + 1][r][i + w[l]], dp1[l][r - 1][i + w[r]]);
                        }
                        else {
                            dp1[l][r][i] = sum - dp0[l][r][sum - (pref[r + 1] - pref[l]) - i];
                        }
                    }
                }
            }
        }
        cout << dp0[0][n - 1][0] << ' ' << sum - dp0[0][n - 1][0] << endl;
        exit(0);
    }
    if (maxi <= 500) {
        for (int l = 0; l < n; ++l) {
            for (int d = -500; d <= 500; ++d) {
                DP[0][l].reserve(1001); DP[1][l].reserve(1001);
                if (d <= 0) {
                    DP[0][l][d] = w[l];
                }
                else {
                    DP[0][l][d] = 0;
                }
                if (d < 0) {
                    DP[1][l][d] = w[l];
                }
                else {
                    DP[1][l][d] = 0;
                }
            }
        }
        for (int len = 2; len <= n; ++len) {
            for (int l = 0; l + len - 1 < n; ++l) {
                int r = l + len - 1;
                for (int d = -500; d <= 500; ++d) {
                    if (d <= 0) {
                        DP1[0][l][d] = max(w[l] + DP[0][l + 1][d + w[l]], w[r] + DP[0][l][d + w[r]]);
                    }
                    else {
                        DP1[0][l][d] = (pref[r + 1] - pref[l]) - DP1[1][l][-d];
                    }
                    if (d < 0) {
                        DP1[1][l][d] = max(w[l] + DP[1][l + 1][d + w[l]], w[r] + DP[1][l][d + w[r]]);
                    }
                    else {
                        DP1[1][l][d] = (pref[r + 1] - pref[l]) - DP1[0][l][-d];
                    }
                }
            }
            for (int i = 0; i < 2; ++i) {
                for (int j = 0; j < n; ++j) {
                    DP[i][j] = DP1[i][j];
                }
            }
        }
        cout << DP[0][0][0] << ' ' << sum - DP[0][0][0] << endl;
        exit(0);
    }
    int a = 0, b = 0;
    for (int i = n - 1; i >= 0; --i) {
        if (a <= b) a += w[i];
        else b += w[i];
    }
    cout << a << ' ' << b << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> tt;
    while (tt--) solve();
}