#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int& x : v) cin >> x;

    int W = 0;
    for (int x : v) W += x;

    vector<int> pref(n + 1), suff(n + 1);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + v[i - 1];
    }
    for (int i = 1; i <= n; i++) {
        suff[i] = suff[i - 1] + v[n - i];
    }

//    vector<vector<bool>> can(n + 1, vector<bool>(W + 1));
//    can[0][0] = true;
//    for (int i = 1; i <= n; i++) {
//        for (int j = W; j >= 0; j--) {
//            can[i][j] = can[i - 1][j] || (j >= v[i - 1] ? can[i - 1][j - v[i - 1]] : false);
//        }
//    }

    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n + 1, vector<int>(W + 1)));
    for (int i = n; i >= 0; i--) {
        for (int j = n - i; j >= 0; j--) {
            for (int c = 0; c <= W; c++) {
                if (i + j == n) {
                    dp[i][j][c] = c;
                } else {
                    int s = pref[i] + suff[j];
                    if (s < c) continue;
                    if (c <= s - c) {
                        dp[i][j][c] = max(dp[i + 1][j][c + v[i]], dp[i][j + 1][c + v[n - j - 1]]);
                    } else {
                        dp[i][j][c] = min(dp[i + 1][j][c], dp[i][j + 1][c]);
                    }
                }
            }
        }
    }

//    for (int i = 0; i <= n; i++) {
//        for (int j = 0; j <= n; j++) {
//            for (int c = 0; c <= W; c++) {
//                cout << i << " " << j << " " << c << ": " << dp[i][j][c] << "\n";
//            }
//        }
//    }

    cout << dp[0][0][0] << " " << W - dp[0][0][0] << "\n";

//    for (int i = W; i >= 0; i--) {
//        if (dp[0][0][i]) {
//            cout << i << " " << W - i;
//            return;
//        }
//    }
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) solve();
}