#include <iostream>
#include <map>
using namespace std;

const int MAXN = 2000;
int a[MAXN];
map<int, int> dp[MAXN][MAXN];

int get_ans(int l, int r, int t) {
    if (r < l)
        return 0;
    if (dp[l][r].find(t) != dp[l][r].end())
        return dp[l][r][t];
    int ans = 0;
    if (t >= 0) {
        ans = max(get_ans(l + 1, r, t - a[l]) + a[l], get_ans(l, r - 1, t - a[r]) + a[r]);
    } else {
        ans = min(get_ans(l + 1, r, t + a[l]), get_ans(l, r - 1, t + a[r]));
    }
    //cout << l << ' ' << r << ' ' << t << ": " << ans << endl;
    dp[l][r][t] = ans;
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    int sm = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sm += a[i];
    }
    int ans = get_ans(0, n - 1, 0);
    cout << ans << ' ' << sm - ans << endl;
}
