#include <iostream>
#include <map>
using namespace std;

const int INF = 1e8 + 177013;
const int MAXN = 2000;
int a[MAXN];
map<int, int> dp[MAXN][MAXN];

int get_ans(int l, int r, int t, int alpha, int beta) {
    if (r < l)
        return 0;
    if (alpha >= beta) {
        if (t >= 0)
            return -INF;
        else
            return INF;
    }

    if (dp[l][r].find(t) != dp[l][r].end())
        return dp[l][r][t];
    int ans = 0;
    if (t >= 0) {
        ans = get_ans(l + 1, r, t - a[l], alpha - a[l], beta - a[l]) + a[l];
        alpha = max(alpha, ans);
        ans = max(ans, get_ans(l, r - 1, t - a[r], alpha - a[r], beta - a[r]) + a[r]);
    } else {
        ans = get_ans(l + 1, r, t + a[l], alpha, beta);
        beta = min(beta, ans);
        ans = min(ans, get_ans(l, r - 1, t + a[r], alpha, beta));
    }
    dp[l][r][t] = ans;
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    int sm = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sm += a[i];
    }
    int ans = get_ans(0, n - 1, 0, -INF, INF);
    cout << ans << ' ' << sm - ans << endl;
}
