#include <iostream>
#include <map>
using namespace std;

const int INF = 1e8 + 177013;
const int MAXN = 2003;
int a[MAXN];
int psm_[MAXN];
int* psm = psm_ + 1;
map<int, int> dp[MAXN][MAXN];

int get_ans(int l, int r, int t) {
    if (r < l)
        return 0;
    if (abs(t) > psm[r] - psm[l - 1]) {
        return int(t > 0) * (psm[r] - psm[l - 1]);
    }
    if (dp[l][r].find(t) != dp[l][r].end())
        return dp[l][r][t];
    int ans = 0;
    if (t >= 0) {
        ans = max(get_ans(l + 1, r, t - a[l]) + a[l], get_ans(l, r - 1, t - a[r]) + a[r]);
    } else {
        ans = min(get_ans(l + 1, r, t + a[l]), get_ans(l, r - 1, t + a[r]));
    }
    dp[l][r][t] = ans;
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        psm[i] = psm[i - 1] + a[i];
    }
    int ans = get_ans(0, n - 1, 0);
    cout << ans << ' ' << psm[n - 1] - ans << endl;
}
