#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
using namespace std;

int n;
vector<int> w;
map<tuple<int, int, int>, int> dp;

int solve(int l, int r, int diff) {
  if (dp.count({l, r, diff})) {
    return dp[{l, r, diff}];
  }
  if (diff <= 0) {
    if (r - l == 1) {
      return dp[{l, r, diff}] = w[l];
    }
    return dp[{l, r, diff}] = max(solve(l + 1, r, diff + w[l]) + w[l], solve(l, r - 1, diff + w[r - 1]) + w[r - 1]);
  } else {
    if (r - l == 1) {
      return dp[{l, r, diff}] = 0;
    }
    return dp[{l, r, diff}] = min(solve(l + 1, r, diff - w[l]), solve(l, r - 1, diff - w[r - 1]));
  }
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n;
  cin >> n;
  w.resize(n);
  for (int &value : w) {
    cin >> value;
  }
  int answer = solve(0, n, 0);
  cout << answer << " " << accumulate(w.begin(), w.end(), 0) - answer << "\n";
}
