#define _CRT_SECURE_NO_WARNINGS

#pragma gcc optimise("Ofast")
#pragma gcc optimise("unswith-loops")
#pragma gcc optimise("unroll-loops")
#pragma gcc optimise("no-stack-protector")
#pragma gcc optimise("fast-math")
#pragma gcc optimise("rename-registers")

#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <cassert>

using namespace std;


typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

#define walk(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const int N = 210, W = 510;

//int dpa[N][N][W], dpb[N][N][W];
//int pref[N];
vector<int> pref;
vector<vector<vector<int>>> dpa, dpb;

int sum(int l, int r) {
	return pref[r] - (l - 1 >= 0 ? pref[l - 1] : 0);
}

void solve() {
	int n;
	cin >> n;
	pref.resize(n);
	if (n <= 3) {
		dpa.assign(n, vector<vector<int>>(n, vector<int>(20010)));
		dpb.assign(n, vector<vector<int>>(n, vector<int>(20010)));
	}
	else {
		dpa.assign(n, vector<vector<int>>(n, vector<int>(510)));
		dpb.assign(n, vector<vector<int>>(n, vector<int>(510)));
	}
	vector<int> arr(n);
	for (int i = 0; i < n; i++)
		cin >> arr[i];
	pref[0] = arr[0];
	for (int i = 1; i < n; i++)
		pref[i] = pref[i - 1] + arr[i];
	for (int i = 0; i < n; i++)
		for (int j = 0; j < sz(dpa[i][i]); j++)
			dpa[i][i][j] = dpb[i][i][j] = arr[i];
	for (int len = 2; len <= n; len++) {
		for (int i = 0; i + len - 1 < n; i++) {
			int j = i + len - 1;
			for (int k = 0; k < sz(dpa[i][j]); k++) {
				int f = 0, s = 0;
				if (arr[i] <= k)
					f = dpa[i + 1][j][k - arr[i]] + arr[i];
				else
					f = sum(i, j) - dpb[i + 1][j][arr[i] - k];
				if (arr[j] <= k)
					s = dpa[i][j - 1][k - arr[j]] + arr[j];
				else
					s = sum(i, j) - dpb[i][j - 1][arr[j] - k];
				dpa[i][j][k] = max(f, s);
				if (arr[i] < k)
					f = dpb[i + 1][j][k - arr[i]] + arr[i];
				else
					f = sum(i, j) - dpa[i + 1][j][arr[i] - k];
				if (arr[j] < k)
					s = dpb[i][j - 1][k - arr[j]] + arr[j];
				else
					s = sum(i, j) - dpa[i][j - 1][arr[j] - k];
				dpb[i][j][k] = max(f, s);
			}
		}
	}
	//for (int len = 1; len <= n; len++) {
	//	for (int i = 0; i + len - 1 < n; i++) {
	//		int j = i + len - 1;
	//		cout << dpa[i][j][0] << " ";
	//	}
	//	cout << "\n";
	//}
	//cout << "\n\n";
	//for (int len = 1; len <= n; len++) {
	//	for (int i = 0; i + len - 1 < n; i++) {
	//		int j = i + len - 1;
	//		cout << dpa[i][j][1] << " ";
	//	}
	//	cout << "\n";
	//}
	//cout << "\n\n";
	//for (int i = 0; i + 3 < n; i++)
	//	cout << dpb[i][i + 3][1] << " ";
	//cout << "\n";
	cout << dpa[0][n - 1][0] << " " << sum(0, n - 1) - dpa[0][n - 1][0];
}

signed main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	ios_base::sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	solve();
}