#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#pragma pack(push, 1)

#define int long long

using namespace std;
//using namespace __gnu_pbds;

//using ordered_multiset = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;
using lll = __int128;
using lld = __float128;

mt19937_64 gen(time(nullptr));

const int MAX_N = 2e5;

bool flag = false;
vector<int> c[MAX_N], node(MAX_N, 0);
vector<pair<int, int>> g[MAX_N];
vector<vector<int>> edges;

void check(vector<int> &arr) {
    for (int i = 0; i < arr.size(); i++) {
        int a = edges[arr[i]][0], b = edges[arr[i]][1], w = edges[arr[i]][2];
        if (c[a][node[a]] + c[b][node[b]] < w) {
            return;
        }
        node[a]++, node[b]++;
    }
    flag = true;
    cout << "Yes\n";
    for (int i = 0; i < arr.size(); i++) {
        cout << arr[i] + 1 << ' ';
    }
}

void brute_force(int i, vector<int> &arr) {
    if (flag) {
        return;
    }
    if (i == arr.size()) {
        check(arr);
        return;
    }
    for (int j = i; j < arr.size(); j++) {
        swap(arr[i], arr[j]);
        brute_force(i + 1, arr);
        swap(arr[i], arr[j]);
    }
}

signed main() {
#ifdef LOCAL
    freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, group, i, j, a, b, w;
    cin >> n >> group;
    for (i = 0; i < n - 1; i++) {
        cin >> a >> b >> w;
        g[a - 1].push_back({b - 1, w}), g[b - 1].push_back({a - 1, w});
        edges.push_back({a - 1, b - 1, w});
    }
    for (i = 0; i < n; i++) {
        c[i].resize(g[i].size());
        for (j = 0; j < g[i].size(); j++) {
            cin >> c[i][j];
        }
        reverse(c[i].begin(), c[i].end());
    }
    if (group <= 1) {
        vector<int> arr(n - 1);
        iota(arr.begin(), arr.end(), 0);
        brute_force(0, arr);
        if (!flag) {
            cout << "No";
        }
    }
}