#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2")
#include <bits/stdc++.h>
#define FOR(a, b, c) for (int a = (b); a < (c); ++a) 
#define int long long
using namespace std;

const int N = 2000 + 50;
const long long INF = 1ll << 60;
unordered_map<int, int> dp[N][N];
int n, W[N];

int DP(int l, int r, int T) {
	if (r < l) return 0;
	if (dp[l][r].count(T)) return dp[l][r][T];

	int d;
	if (T >= 0) {
		d = max(DP(l + 1, r, T - W[l]) + W[l], DP(l, r - 1, T - W[r]) + W[r]);
	}
	else {
		d = min(DP(l + 1, r, T + W[l]) - W[l], DP(l, r - 1, T + W[r]) - W[r]);
	}
	dp[l][r][T] = d;
	return d;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	FOR(i, 0, n) cin >> W[i];

	int d = DP(0, n - 1, 0), s = accumulate(W, W + n, 0ll);
	cout << (d + s) / 2 << ' ' << (s - d) / 2 << '\n';
	return 0;
}

