#include <iostream>
#include <chrono>
#include <vector>
#include <algorithm>

#define maxn 20005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;

#pragma GCC optimize("O3" , "Ofast" , "unroll-loops" , "fast-math")
#pragma GCC target("avx2")

using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}


vector <int> w;
int n;

bool t[maxn];

void read()
{
    cin >> n;

    bool lamp2 = true;

    w.resize(n + 1);

    for(int i = 1; i <= n; i++)
        cin >> w[i];

    sort(w.begin() + 1 , w.end());

    if(w.back() > 2)
        lamp2 = false;

    t[0] = true;

    for(int i = 1; i <= n; i++)
        for(int j = maxn - 1; j >= 0; j--)
            if(j - w[i] >= 0 && t[j - w[i]] == true)
                t[j] = true;

    int ans = 0;

    int sum = 0;

    for(int i = 1; i <= n; i++)
        sum += w[i];




    for(int i = 0; i <= sum / 2; i++)
        if(t[i] == true)
            ans = i;

    cout << ans << " " << sum - ans << endl;


}






int main()
{

/**#ifdef ONLINE_JUDGE /// promeni
    freopen("taxi.in", "r", stdin);
    freopen("taxi.out", "w", stdout);
#endif*/

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    startT = std::chrono::high_resolution_clock::now();


    read();

    return 0;
}
