#include <bits/stdc++.h>

#define int long long
#define endl '\n'

using namespace std;

vector<vector<int>> g1, g2;
vector<int> comp[2], d, h;
vector<bool> used;
set<pair<int, int>> briges;
int temp = 0;

void dfs(int v){
    used[v] = true;
    comp[temp].push_back(v);
    for(auto u : g1[v]){
        if(!used[u]){
            dfs(u);
        }
    }
}

void bridges_scan(int v, int p = -1){
    used[v] = true;
    d[v] = h[v] = (p == -1 ? 0 : h[p] + 1);
    for(auto u : g2[v]){
        if(u != p){
            if(used[u]){
                d[v] = min(d[v], h[u]);
            }else{
                bridges_scan(u, v);
                d[v] = min(d[v], d[u]);
                if(d[u] > h[v]){
                    briges.insert({u, v});
                }
            }
        }
    }
}

void solve(){
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g1.resize(n);
    g2.resize(n);
    h.resize(n);
    d.resize(n);
    used.resize(n);
    for(int i = 0; i < m1; i++){
        int v, u;
        cin >> v >> u;
        v--, u--;
        g1[u].push_back(v);
        g1[v].push_back(u);
    }
    for(int i = 0; i < m2; i++){
        int a, b;
        a--, b--;
        cin >> a >> b;
        g2[a].push_back(b);
        g2[b].push_back(a);
    }
    for(int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
            temp++;
        }
    }
    fill(used.begin(), used.end(), false);
    bridges_scan(0);
    for(auto i : comp[0]){
        for(auto j : comp[1]){
            if(!briges.count({i, j}) && !briges.count({j, i})){
                cout << "YES" << endl << 1 << endl << i << ' ' << j;
                return;
            }
        }
    }
    cout << "NO";
    g1.clear();
    g2.clear();
    h.clear();
    d.clear();
    briges.clear();
    used.clear();
    comp[1].clear();
    comp[0].clear();
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, g;
    cin >> t >> g;
    while(t--){
        solve();
        cout << endl;
    }
}