#include <bits/stdc++.h>
      
using ld = long double;
using ll = long long;
using ull = unsigned long long;
      
#define int long long
#define double long double
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define repr(i, n) for (int i = (n) - 1; i >= 0; --i)
#define fir first
#define sec second
#define pb push_back
#define mp make_pair
#define ALL(v) begin(v), end(v)
#define current_time chrono::steady_clock::now().time_since_epoch().count()
   
ll TL = 1e9 / 15;
ll INF = 1e18;
ll MOD2 = 1e9 + 7;
ll MOD = 1e9 + 1000 - 7;
ll p2 = 101;
ll p = 593;
ld eps = 1e-10;
      
const double PI = 3.141592653589793238463;
const ll pw = 1e12;
      
using namespace std;
      
ll powmod(ll a, ll b, ll mod) {ll res = 1;a %= mod; assert(b >= 0); for(; b; b >>= 1){if(b & 1) res = res * a % mod;a = a * a % mod;}return res;}
ll gcd(ll a, ll b) {return b ? gcd(b,a % b):a;}
mt19937_64 rnd(current_time);
mt19937 rndd(rnd());
uniform_real_distribution <ld> rnddbl(0, 1);

const ll MAXN = 100000;

struct SNM {
    int n;
    vector <int> pred;

    SNM(int n) {
        pred.resize(n);
        rep(i, n) pred[i] = i;
    }

    int getpr(int ver) {
        while (pred[ver] != ver) ver = pred[ver];
        return ver;
    }

    void ves(int a, int b) {
        pred[a] = b;
    }

    void uddateall() {
        rep(i, n) pred[i] = getpr(i);
    }
};

struct spo {
    int el, nxt, f;
};

void solve() {
    int n, m1, m2; cin >> n >> m1 >> m2;
    SNM cher = SNM(n), ber = SNM(n);
    vector <map <int, bool>> forbid(n);
    vector <spo> allg(n);
    set <int> unused;
    rep(i, n) unused.insert(i);
    rep(i, n) allg[i] = {i, -1, i};
    int cnt = 1;
    rep(i, m1) {
        int u, v; cin >> u >> v;
        --u; --v;
        if (u > v) swap(u, v);
        int pru = ber.getpr(u), prv = ber.getpr(v);
        if (pru != prv) {
            ber.ves(pru, prv);
            allg[pru].nxt = allg[prv].f;
            allg[prv].f = allg[pru].f;
            unused.erase(pru);
        }
        ++cnt;
        if (cnt == 100000) {
            cnt = 0;
            ber.uddateall();
        }
    }
    cnt = 1;
    rep(i, m2) {
        int u, v; cin >> u >> v;
        --u; --v;
        if (u > v) swap(u, v);
        int pru = cher.getpr(u), prv = cher.getpr(v);
        if (pru != prv) {
            cher.ves(pru, prv);
            forbid[u][v] = 1;
        }
        ++cnt;
        if (cnt == 100000) {
            cnt = 0;
            cher.uddateall();
        }
    }
    /*int ii = 0;
    for (auto el : forbid) {
        for (auto ell : el) {
            cout << ii + 1 << ' ' << ell.fir + 1 << endl;
        }
        ++ii;
    }*/
    vector <pair <int, int>> op;
    cnt = 0;
    while (unused.size() > 1) {
        if (cnt == 100000) {
            cnt = 0;
            ber.uddateall();
        }
        int curr = *unused.begin(), lst = -1;
        unused.erase(unused.begin());
        int cu = allg[curr].f;
        while (cu != -1) {
            for (auto el : unused) {
                int f = allg[el].f;
                while (f != -1) {
                    int e = allg[f].el;
                    int u = allg[cu].el, v = e;
                    if (!forbid[min(u, v)][max(u, v)]) {
                        if (lst == -1) lst = el;
                        else {
                            ber.ves(el, lst);
                            allg[el].nxt = allg[lst].f;
                            allg[lst].f = allg[el].f;
                            unused.erase(el);
                        }
                        op.pb({u, v});
                    }
                    f = allg[f].nxt;
                }
            }
            cu = allg[cu].nxt;
        }
        if (lst == -1) {
            cout << "No" << endl;
            return;
        }
    }
    cout << "Yes" << endl;
    cout << op.size() << endl;
    for (auto el : op) {
        cout << el.fir + 1 << ' ' << el.sec + 1 << endl;
    }
}
      
signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}