#include<iostream>
#include <random>
#include<vector>
#include<set>
#include<map>
#include<cassert>
#include<unordered_map>
#include<algorithm>
#include<iomanip>
#include<numeric>
#include<deque>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define girlfriend friend

template<typename T>
bool assign_min(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream& out, std::pair<T, F> a) {
    return out << a.first << " " << a.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, b1 = 31, b2 = 29, MAXN = 1e5, MAXC = 1e9;
const long double eps = 1e-9;

void solve() {
    int n, m1, m2; cin >> n >> m1 >> m2;
    vector<vector<int>> g1(n), g2(n), g3(n);
    set<pair<int, int>> s, q;
    for (int i = 0; i<m1; ++i) {
        int u, v; cin >> u >> v; u--; v--;
        q.insert({u, v});
        q.insert({v, u});
        g1[u].emplace_back(v);
        g1[v].emplace_back(u);
    }
    for (int i = 0; i<m2; ++i) {
        int u, v; cin >> u >> v; u--; v--;
        g2[u].emplace_back(v);
        g2[v].emplace_back(u);
    }
    vector<int> usd(n), col(n);
    vector<vector<int>> a(2);
    auto dfs = [&](auto dfs, int u) -> void {
        usd[u] = 1;
        a[col[u]].emplace_back(u);
        for (auto v : g2[u]) {
            if (!usd[v]) {
                col[v] = col[u] ^ 1;
                s.insert({u, v});
                s.insert({v, u});
                g3[u].emplace_back(v);
                g3[v].emplace_back(u);
                dfs(dfs, v);
            }
        }
    };
    dfs(dfs, 0);
    for (int i = 0; i<n; ++i) usd[i] = 0;
    vector<int> dist(n);
    auto dfs2 = [&](auto dfs2, int u, int dst) -> void {
        usd[u] = 1;
        dist[u] = dst;
        for (auto v : g3[u]) {
            if (!usd[v]) dfs2(dfs2, v, dst+1);
        }
    };
    dfs2(dfs2, 0, 0);
    int st = 0;
    for (int i = 0; i<n; ++i) {
        if (dist[i] > dist[st]) st = i;
    }
    for (int i = 0; i<n; ++i) usd[i] = 0;
    dfs2(dfs2, st, 0);
    int mx = 0;
    for (int i = 0; i<n; ++i) assign_max(mx, dist[i]);
    vector<pair<int, int>> res;
    if (mx > 2) {
        for (int j = 0; j<2; ++j) {
            for (int i = 0; i<(int)a[j].size()-1; ++i) {
                if (q.find({a[j][i], a[j][i+1]}) == q.end()) {
                    res.emplace_back(a[j][i]+1, a[j][i+1]+1);
                }
            }
        }
        int f = 0;
        while (dist[f] != 3) f++;
        if (q.find({st, f}) == q.end()) {
            res.emplace_back(st+1, f+1);
        }
    } else {
        int c = 0;
        while (dist[c] != 1) c++;
        vector<int> ost;
        for (int i = 0; i<n; ++i) {
            if (i != c) ost.emplace_back(i);
        }
        set<pair<int, int>> s2;
        for (int i = 0; i<(int)ost.size()-1; ++i) {
            s2.insert({ost[i], ost[i+1]});
            s2.insert({ost[i+1], ost[i]});
            if (q.find({ost[i], ost[i+1]}) == q.end()) {
                res.emplace_back(ost[i]+1, ost[i+1]+1);
            }
        }
        bool fl = true;
        for (int i = 0; i<n; ++i) {
            for (int j = i+1; j<n; ++j) {
                if (s2.find({i, j}) != s2.end()) continue;
                if (s.find({i, j}) != s.end()) continue;
                res.emplace_back(i+1, j+1);
                res.emplace_back(c+1, i+1);
                fl = false;
                break;
            }
            if (!fl) break;
        }
        if (fl) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
    cout << (int)res.size() << '\n';
    for (auto elem : res) cout << elem << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1, g; cin >> t >> g;
    while (t--) solve();
    return 0;
}

//fft