#include<bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define int long long
bool ans = false;
vector<pair<int, int>> ANS;

void dfs2(vector<vector<bool>> &g, vector<bool> &used, int u, int n) {
    used[u] = true;
    for (int i = 0; i < n; i++) {
        if (!used[i] and g[u][i]) {
            dfs2(g, used, i, n);
        }
    }
}

void rec(int cnt, int i, vector<bool> &used, vector<pair<int, int>> &edgs, vector<vector<bool>> &mt1,
         vector<vector<bool>> &mt2, int n) {
    if (i == cnt) {
        vector<vector<bool>> cop1 = mt1, cop2 = mt2;
        for (int i = 0; i < cnt; i++) {
            if (used[i]) {
                int u = edgs[i].first, v = edgs[i].second;
                cop1[u][v] = cop1[v][u] = !cop1[u][v];
                cop2[u][v] = cop2[v][u] = !cop2[u][v];
            }
        }
        vector<bool> us1(n), us2(n);
        dfs2(cop1, us1, 0, n);
        dfs2(cop2, us2, 0, n);
        bool check = true;
        for (int i = 0; i < n; i++) {
            if (!us1[i] or !us2[i]) return;
        }
        ans = true;
        ANS.clear();
        for (int i = 0; i < cnt; i++) {
            if (used[i]) {
                ANS.push_back(edgs[i]);
            }
        }
        return;
    }
    used[i] = true;
    rec(cnt, i + 1, used, edgs, mt1, mt2, n);
    used[i] = false;
    rec(cnt, i + 1, used, edgs, mt1, mt2, n);

}

void dfs(vector<vector<int>> &g, vector<int> &colors, int u, int col) {
    colors[u] = col;
    for (auto v: g[u]) {
        if (colors[v] == 0) {
            dfs(g, colors, v, col);
        }
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int q, g;
    cin >> q >> g;
    if (g <= 2) {
        while (q--) {
            int n, m1, m2;
            cin >> n >> m1 >> m2;
            if (n <= 5) {
                vector<vector<int>> g(n);
                vector<vector<bool>> mt1(n, vector<bool>(n));
                for (int i = 0; i < m1; i++) {
                    int u, v;
                    cin >> u >> v;
                    u--, v--;
                    mt1[u][v] = true;
                    mt1[v][u] = true;
                }
                vector<vector<int>> g2(n);
                vector<vector<bool>> mt2(n, vector<bool>(n));

                for (int i = 0; i < m2; i++) {
                    int u, v;
                    cin >> u >> v;
                    u--, v--;
                    g[u].push_back(v);
                    g[v].push_back(u);
                    mt2[u][v] = mt2[v][u] = true;
                }
                vector<pair<int, int>> edgs;
                for (int i = 0; i < n; i++) {
                    for (int j = i + 1; j < n; j++) {
                        edgs.push_back({i, j});
                    }
                }
                vector<bool> used(edgs.size());
                rec(edgs.size(), 0, used, edgs, mt1, mt2, n);
                if (ans) {
                    cout << "Yes\n" << ANS.size() << '\n';
                    for (auto [u, v]: ANS) {
                        cout << u + 1 << " " << v + 1 << '\n';
                    }
                    ans = false;
                    ANS.clear();
                } else {
                    cout << "No\n";
                }
                continue;
            }
            vector<vector<int>> g(n);
            for (int i = 0; i < m1; i++) {
                int u, v;
                cin >> u >> v;
                u--, v--;
            }
            vector<vector<int>> g2(n);
            for (int i = 0; i < m2; i++) {
                int u, v;
                cin >> u >> v;
                u--, v--;
                g[u].push_back(v);
                g[v].push_back(u);
            }
            vector<int> colors(n);
            vector<int> cls;
            int col = 1;
            for (int i = 0; i < n; i++) {
                if (colors[i] == 0) {
                    dfs(g, colors, i, col++);
                    cls.push_back(i);
                }
            }
            if (n == 2) {
                cout << "No\n";
                continue;
            }
            if (cls.size() - 1 < n) {
                cout << "Yes\n";
                cout << cls.size() - 1 << '\n';
                for (int i = 1; i < cls.size(); i++) {
                    cout << cls[i] + 1 << " " << cls[i - 1] + 1 << '\n';
                }
            } else {
                cout << "No\n";
            }
        }
    }
}