#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

ll n, m1, m2;
vector <vector<ll>> g1, g2;
set <pair<ll, ll>> v1, v2;

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll t, group;
    cin >> t >> group;
    while (t--) {
        cin >> n >> m1 >> m2;
        g1.resize(n);
        g2.resize(n);
        for (ll i = 0; i < m1; ++i) {
            ll x, y;
            cin >> x >> y;
            x--, y--;
            v1.insert({x, y});
            v1.insert({y, x});
            g1[x].emplace_back(y);
            g1[y].emplace_back(x);
        }
        for (ll i = 0; i < m2; ++i) {
            ll x, y;
            cin >> x >> y;
            x--, y--;
            v2.insert({x, y});
            v2.insert({y, x});
            g2[x].emplace_back(y);
            g2[y].emplace_back(x);
        }
        set <pair<ll, ll>> ans;
        if (group == 9) {
            for (ll i = 2; i < n; ++i) {
                ans.insert({0, i});
            }
            ans.insert({1, n - 1});
            ll sz = 0;
            for (auto el: ans) {
                if (v1.find(el) == v1.end()) {
                    sz++;
                }
            }
            cout << "Yes\n";
            cout << sz << "\n";
            for (auto el : ans) {
                if (v1.find(el) == v1.end()) {
                    auto [x, y] = el;
                    cout << x + 1 << " " << y + 1 << "\n";
                }
            }
        } else if (group == 5) {
            for (ll i = 1; i < n - 1; ++i) {
                ans.insert({i, i + 1});
            }
            ans.insert({0, n - 1});
            ll sz = 0;
            for (auto el: ans) {
                if (v1.find(el) == v1.end()) {
                    sz++;
                }
            }
            cout << "Yes\n";
            cout << sz << "\n";
            for (auto el : ans) {
                if (v1.find(el) == v1.end()) {
                    auto [x, y] = el;
                    cout << x + 1 << " " << y + 1 << "\n";
                }
            }
        }
    }

    return 0;
}
