#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

inline void solve1() {
	int n, m1, m2;
	cin >> n >> m1 >> m2;
}

inline void solve2() {
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	vector<bool> un(n);
	for (int i = 0; i < m1; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		if (v > u)
			swap(v, u);
		if (u == v + 1)
			un[v] = true;
	}
	for (int i = 0; i < m2; i++) {
		int v, u;
		cin >> v >> u;
	}
	vector<pii> ans;
	for (int i = 0; i < n - 1; i++)
		if (!un[i])
			ans.push_back({ i, i + 1 });
	cout << "Yes\n";
	cout << ans.size() << '\n';
	for (pii e : ans)
		cout << e.first + 1 << ' ' << e.second + 1 << '\n';
}

inline void solve() {

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
	cin >> tt;
	int group;
	cin >> group;
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		if (group == 1)
			solve1();
		else if (group == 2)
			solve2();
		else
			solve();
	}
	return 0;
}
