#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, less<>, null_type, tree_tag, tree_order_statistics_node_update>;
using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    int g;
    cin >> g;
    while (t--)
        solve();
}

void dfs(int s, vector<int> &u, vector<vector<int>> &g, vector<vector<int>> &g1) {
    u[s] = 1;
    for (int i: g[s]) {
        if (!u[i]) {
            g1[s].push_back(i);
            g1[i].push_back(s);
            dfs(i, u, g, g1);
        }
    }
}

void dfs(int s, vector<int> &u, vector<vector<int>> &g) {
    u[s] = 1;
    for (int i: g[s]) {
        if (!u[i]) {
            dfs(i, u, g);
        }
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g1(n), g2(n);
    set<pair<int, int>> f, s;

    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g1[a].push_back(b);
        g1[b].push_back(a);
        if (a > b)
            swap(a, b);
        f.insert({a, b});
        f.insert({b, a});
    }

    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g2[a].push_back(b);
        g2[b].push_back(a);
        s.insert({a, b});
        s.insert({b, a});
    }

    vector<pair<int, int>> e;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++)
            e.push_back({i, j});
    }
    vector<int> ndx(e.size());
    for (int i = 0; i < e.size(); i++)
        ndx[i] = i;
    auto s1 = s, f1 = f;
    while (1) {
        s = s1;
        f = f1;
        vector<pair<int, int>> ans;
        bool is = 0;
        if (ndx[0] == 4){
            int o = 0;
        }
        for (int i = 0; i <= n; i++) {
            vector<int> u;
            g1.clear();
            g1.resize(n);
            for (auto [x, y]: s) {
                g1[x].push_back(y);
            }

            u.clear();
            u.resize(n);

            dfs(0, u, g1);

            if (*min_element(all(u)) == 0) {
                break;
            }

            g2.clear();
            g2.resize(n);
            for (auto [x, y]: f) {
                g2[x].push_back(y);
            }

            u.clear();
            u.resize(n);

            dfs(0, u, g2);

            if (*min_element(all(u)) == 0) {
                if (i < e.size()) {
                    auto [x, y] = e[ndx[i]];
                    ans.push_back({x, y});
                    if (s.find({x, y}) != s.end()) {
                        s.erase({x, y});
                        s.erase({y, x});
                    } else {
                        s.insert({x, y});
                        s.insert({y, x});
                    }
                    if (f.find({x, y}) != f.end()) {
                        f.erase({x, y});
                        f.erase({y, x});
                    } else {
                        f.insert({x, y});
                        f.insert({y, x});
                    }
                }
                continue;
            }

            cout << "Yes\n";

            cout << ans.size() << '\n';
            for (auto [x, y]: ans)
                cout << x + 1 << ' ' << y + 1 << '\n';
            return;
        }
        if (!next_permutation(all(ndx)))
            break;
    }
    cout << "No\n";
}