#include<bits/stdc++.h>
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define F first
#define S second
#define pb push_back

typedef long long ll;
using namespace std;
const int N = 3e5+100;
vector< int > g[N];
vector< int > comp[N];

bool used[N];
void dfs(int v, int k)
{
    comp[k].pb(v);
    used[v]=1;
    for(auto to : g[v])
        if(!used[to])dfs(to,k);
}

pair< int , int > get(int i, int j)
{
    for(auto x : comp[i])
        for(auto y : comp[j])
            if(x!=y+1 && y!=x+1)return {x,y};
    return {-1,-1};
}

void solve()
{
    int n,m1,m2;
    cin>>n>>m1>>m2;

    for(int i=1;i<=n;++i)
        g[i].clear(),used[i]=0;

    for(int i=0;i<m1;++i)
    {
        int x,y;
        cin>>x>>y;

        g[x].pb(y);
        g[y].pb(x);
    }

    for(int i=0;i<m2;++i)
    {
        int x,y;
        cin>>x>>y;
    }

    int k=0;
    for(int i=1;i<=n;++i)
        if(!used[i])dfs(i,k++);

    vector< pair< int , int > > ans;
    for(int i=1;i<k;++i)
    {
        pair< int , int > x=get(i-1,i);
        if(x.F==-1)
        {
            cout<<"No\n";
            return ;
        }
        ans.pb(x);
    }
    cout<<"Yes\n";
    for(auto to : ans)
        cout<<to.F<<' '<<to.S<<'\n';
    cout<<'\n';
    return ;
}
int main()
{
    #ifdef ROADTOBELEGEND
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // ROADTOBELEGEND

    fast_io;

    int t,gnom;
    cin>>t>>gnom;

    if(gnom==9)
    {
        while(t--)
            solve();
    }

    return 0;
}

