#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define deb(x) cerr << #x << '\t' << x << '\n';

constexpr ll INF = 1e18;

vector<vector<ll>>g;
vector<ll>pr;

ll st = 0;

void dfs(ll v, ll p = -1) {
	pr[v] = p;
	if (g[v].size() == 1 && p != -1) {
		st = v;
	}
	for (auto to : g[v]) {
		if (to == p) {
			continue;
		}
		dfs(to, v);
	}
}

void solve() {
	ll n, m1, m2; cin >> n >> m1 >> m2;
	g.assign(n, {});
	set<pair<ll, ll>>ed1;
	for (int i = 0; i < m1; i++) {
		ll u, v; cin >> u >> v; u--, v--;
		ed1.insert({u, v});
		ed1.insert({v, u});
	}
	for (int i = 0; i < m2; i++) {
		ll u, v; cin >> u >> v;
		g[--u].emplace_back(--v);
		g[v].emplace_back(u);
	}
	dfs(0);
	vector<ll>add;
	for (int i = 0; i < n; i++) {
		if (i == st) {
			continue;
		}
		if (ed.find({i, st}) == ed.end()) {
			add.emplace_back(i);
		}
	}
	cout << "Yes\n";
	cout << add.size() << '\n';
	for (auto i : add) {
		cout << st + 1 << ' ' << i + 1;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int T = 1;
	cin >> T;
	while (T--)	{
		solve();
		cout << '\n';
	}
	return 0;
}
