#include "bits/stdc++.h"
#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(x) (x).begin(), (x).end()

struct dsu {
    vector<int> p;
    vector<int> sz;
    void init(int n) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        sz.resize(n, 1);
    }
    int get(int x) {
        if (p[x] == x) {
            return p[x];
        }
        return p[x] = get(p[x]);
    }
    bool same(int a, int b) {
        return get(a) == get(b);
    }
    bool merge(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) {
            return false;
        }
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        p[b] = a;
        sz[a] += sz[b];
        return true;
    }
};


void solve(int gr) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> sta;
    set<pair<int, int>> stb;
    for (int i = 0; i < m1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        if (x > y) {
            swap(x, y);
        }
        sta.insert({x, y});
    }
    for (int i = 0; i < m2; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        if (x > y) {
            swap(x, y);
        }
        stb.insert({x, y});
    }

    int ii = -1;
    int jj = -1;
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
           if ((sta.count({i, j}) && stb.count({i, j}))) {
               ii = i;
               jj = j;
               break;
           }
            if ((!sta.count({i, j}) && !stb.count({i, j}))) {
                ans.emplace_back(i, j);
                sta.insert({i, j});
                stb.insert({i, j});
                ii = i;
                jj = j;
                break;
            }
        }
        if (ii != -1) {
            break;
        }
    }
    if (ii != -1) {
        for (int i = 0; i < n; i++) {
            if (i == ii || i == jj) {
                continue;
            }
            if (sta.count(minmax(i, ii)) || sta.count(minmax(i, jj))) {
                continue;
            }
            if (!stb.count(minmax(i, ii))) {
                ans.emplace_back(i, ii);
                continue;
            }
            if (!stb.count(minmax(i, jj))) {
                ans.emplace_back(i, jj);
                continue;
            }
            ans.emplace_back(i, ii);
        }

        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto [i, j] : ans) {
            cout << i + 1 << ' ' << j + 1 << '\n';
        }
    } else {
        cout << "No" << '\n';
    }
    return;
    dsu d;
    d.init(n);
    for (auto e : sta) {
        if (stb.count(e)) {
            d.merge(e.first, e.second);
        }
    }
    vector<pair<int, int>> st;
    for (int i = 0; i < n; i++) {
        for (int j  = i + 1; j < n; j++) {
            if (!sta.count({i, j}) && !stb.count({i, j})) {
                st.emplace_back(i, j);
                d.merge(i, j);
            }
        }
    }

}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, g;
    cin >> t >> g;
    while (t--) {
        solve(g);
    }
    return 0;
}

/*
3 0
3 0 3
1 2
2 3
1 3
4 2 3
1 2
3 4
1 3
1 4
2 3
4 3 3
1 2
2 3
1 3
1 4
2 4
3 4
 */