#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

ll G;

vector <vector <ll>> g1, g2;

void solve() {
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    g1.clear(), g2.clear();
    g1.resize(n), g2.resize(n);
    vector <bool> have(n - 1);
    for (ll i = 0; i < m1; i++) {
        ll a, b; cin >> a >> b; a--, b--;
        if (a > b)
            swap(a, b);
        if (a + 1 == b)
            have[a] = true;
        g1[a].emplace_back(b);
        g1[b].emplace_back(a);
    }
    for (ll i = 0; i < m2; i++) {
        ll a, b; cin >> a >> b; a--, b--;
        g2[a].emplace_back(b);
        g2[b].emplace_back(a);
    }
    if (n == 3 && m1 == 0) {
        cout << "No\n";
        return;
    }
    if (n == 3 && m1 == 1 && !g1[0].empty() && g1[0][0] == 2) {
        cout << "Yes\n";
        cout << "1 2\n";
        return;
    }
    vector <ll> ans;
    for (ll i = 0; i < n - 1; i++)
        if (!have[i])
            ans.emplace_back(i);
    cout << "Yes\n" << (ll) ans.size() << '\n';
    for (auto i : ans)
        cout << i + 1 << ' ' << i + 2 << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    cin >> G;
    while (T--) {
        solve();
    }
    return 0;
}
