#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_map>
#include <iomanip>
#include <queue>
#include <random>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef long double ld;
#define mid (r + l) / 2
#define lv (2 * v + 1)
#define rv (2 * v + 2)
#define all(x) x.begin(), x.end()
unordered_map<ll, bool> mp1, mp2;
vector<ll> g[300000], g2[300000];
bool used[300000];

void dfs(ll v) {
    used[v] = true;
    for (ll to : g[v]) {
        if (!used[to]) {
            mp2[v * 300000 + to] = true;
            mp2[to * 300000 + v] = true;
            dfs(to);
        }
    }
}
vector<pair<ll, ll>> ans;
set<ll> s;

void dfs2(ll v) {
    used[v] = true;
    s.erase(v);
    for (ll to : g2[v]) {
        if (!used[to]) {
            dfs2(to);
        }
    }
    for (ll i : s) {
        if (!mp2[v * 300000 + i]) {
            ans.push_back({ v, i });
            dfs2(i);
            break;
        }
    }
}

void solve() {
    ll n, m1, m2;
    ll u, v;
    cin >> n >> m1 >> m2;
    mp1.clear();
    mp2.clear();
    ans.clear();
    s.clear();
    for (ll i = 0; i < n; i++) {
        s.insert(i);
        g[i].clear();
        g2[i].clear();
        used[i] = false;
    }
    for (ll i = 0; i < m1; i++) {
        cin >> u >> v;
        if (u == v) continue;
        g2[--u].push_back(--v);
        g2[v].push_back(u);
        mp1[u * 300000 + v] = true;
        mp1[v * 300000 + u] = true;
    }
    for (ll i = 0; i < m2; i++) {
        cin >> u >> v;
        if (u == v) continue;
        g[--u].push_back(--v); 
        g[v].push_back(u);
        mp2[u * 300000 + v] = true;
        mp2[v * 300000 + u] = true;
    }
    if (n == 3) {
        if (m2 == 3) {
            if (m1 == 0) cout << "No\n";
            else if (m1 == 1) {
                if (mp1[1]) cout << "Yes\n1\n1 3\n";
                else cout << "Yes\n1\n1 2\n";
            }
            else cout << "Yes\n0\n";
        }
        else {
            if (m1 == 0) {
                if (!mp2[1]) cout << "Yes\n2\n1 2\n1 3\n";
                else cout << "Yes\n2\n1 3\n2 3\n";
            }
            else if (m1 == 1) {
                set<pair<ll, ll>> s;
                s.insert({ 0, 1 });
                s.insert({ 0, 2 });
                s.insert({ 1, 2 });
                if (mp1[1] || mp2[1]) s.erase({ 0, 1 });
                if (mp1[2] || mp2[2]) s.erase({ 0, 2 });
                if (mp1[300002] || mp2[300002]) s.erase({ 1, 2 });
                if (s.size() == 0) cout << "No\n";
                else cout << "Yes\n1\n" << (*s.begin()).first + 1 << " " << (*s.begin()).second + 1 << "\n";
            }
            else cout << "Yes\n0\n";
        }
        return;
    }
    mp2.clear();
    for (ll j = 0; j < n; j++) {
        if (g[j].size() == n - 1) {
            bool ok = false;
            for (ll i = 0; i < n; i++) {
                if (i != j) {
                    if (mp1[i * 300000 + j]) {
                        ok = true;
                        break;
                    }
                }
            }
            if (ok) continue;
            for (ll i = j + 1; i < n; i++) {
                if (i != j && i != g[j].back()) {
                    ans.push_back({ g[j].back(), i });
                    ans.push_back({ j, g[j].back() });
                    mp1[g[j].back() * 300000 + i] ^= 1;
                    mp1[g[j].back() * 300000 + j] ^= 1;
                    mp1[i * 300000 + g[j].back()] ^= 1;
                    mp1[j * 300000 + g[j].back()] ^= 1;
                    g[g[j].back()].clear();
                    g[g[j].back()].push_back(i);
                    g2[j].push_back(g[j].back());
                    g2[g[j].back()].push_back(j);
                    bool del = true;
                    for (ll& to : g2[g[j].back()]) {
                        if (to == i) {
                            swap(to, g2[g[j].back()].back()), g2[g[j].back()].pop_back();
                            del = false;
                            break;
                        }
                    }
                    if (del) g2[g[j].back()].push_back(i);
                    del = true;
                    for (ll& to : g2[i]) {
                        if (to == g[j].back()) {
                            swap(to, g2[i].back()), g2[i].pop_back();
                            del = false;
                            break;
                        }
                    }
                    if (del) g2[i].push_back(g[j].back());
                    g[i].push_back(g[j].back());
                    g[j].pop_back();
                    break;
                }
            }
        }
    }
    dfs(0);
    for (ll i = 0; i < n; i++) used[i] = false;
    dfs2(0);
    cout << "Yes\n" << ans.size() << "\n";
    for (auto [f, l] : ans) {
        cout << f + 1 << " " << l + 1 << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    ll t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}