#ifndef BUY
#pragma GCC optimize("Ofast")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;
#define int long long
using pii = pair <int, int>;
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define ff first
#define ss second

template <typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
}

template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
};

constexpr int INF = 1e9;

struct DSU {
private:
    vector <int> p, r;
    int n;

public:
    int comp;
    explicit DSU(int n1) {
        n = n1;
        comp = n;
        p.resize(n);
        r.resize(n);
        iota(all(p), 0ll);
    }

    int get(int a) {
        return (a == p[a] ? a : p[a] = get(p[a]));
    }

    void unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) {
            return;
        }
        --comp;
        p[a] = b;
    }
};

void solve1(int n, int m1, int m2, const vector <pii>& e1, const vector <pii>& e2) {
    vector <pii> alle;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            alle.emplace_back(i, j);
        }
    }
    vector <vector <int> > d1(n, vector <int> (n)), d2 = d1;
    for (auto [a, b] : e1) {
        d1[a][b] ^= 1;
        d1[b][a] ^= 1;
    }
    for (auto [a, b] : e2) {
        d2[a][b] ^= 1;
        d2[b][a] ^= 1;
    }
    auto check = [&]() {
        
        DSU dsu1(n), dsu2(n);
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (d1[i][j]) {
                    dsu1.unite(i, j);
                }
                if (d2[i][j]) {
                    dsu2.unite(i, j);
                }
            }
        }
        return dsu1.comp == 1 && dsu2.comp == 1;
    };
    for (int mask = 0; mask < (1 << sz(alle)); ++mask) {
        vector <int> ids;
        for (int i = 0; i < sz(alle); ++i) {
            if (mask >> i & 1) {
                ids.push_back(i);
            }
        }
        do {
            for (auto i : ids) {
                auto [a, b] = alle[i];
                d1[a][b] ^= 1;
                d1[b][a] ^= 1;
                d2[a][b] ^= 1;
                d2[b][a] ^= 1;
            }
            if (check()) {
                cout << "Yes\n";
                cout << __builtin_popcount(mask) << "\n";
                for (auto i : ids) {
                    if (mask >> i & 1) {
                        cout << alle[i].ff + 1 << " " << alle[i].ss + 1 << "\n";
                    }
                }
                return;
            }
            for (auto i : ids) {
                auto [a, b] = alle[i];
                d1[a][b] ^= 1;
                d1[b][a] ^= 1;
                d2[a][b] ^= 1;
                d2[b][a] ^= 1;
            }
        } while (next_permutation(all(ids)));
    }
    cout << "No\n";
}

void solve(int g = 0) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector <pii> e1(m1), e2(m2);
    for (auto& [a, b] : e1) {
        cin >> a >> b;
        --a, --b;
    }
    for (auto& [a, b] : e2) {
        cin >> a >> b;
        --a, --b;
    }
    if (n <= 5) {
        solve1(n, m1, m2, e1, e2);
    } else {

    }
}

signed main() {
    cout << setprecision(15) << fixed;
#ifdef BUY
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1, g;
    cin >> t >> g;
    while (t--) {
        solve(g);
    }
#ifdef BUY
    cerr << "\n";
#endif
}