#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
using namespace __gnu_pbds;

#define int long long

map<pair<int, int>, int> e;
vector<int> p;
vector<int> w;
vector<pair<int, int>> c;
int comps = 0;

int lead(int a) {
    if (p[a] == -1) {
        return a;
    }
    return p[a] = lead(p[a]);
}

void unite(int a, int b) {
    a = lead(a);
    b = lead(b);
    if (a == b) {
        return;
    }
    if (w[a] > w[b]) {
        swap(a, b);
    }
    p[a] = b;
    if (c[b].second == -1) {
        c[b].second = a;
    }
    comps--;
    w[b] += w[a];
}

void print(pair<int, int> a) {
    cout << a.first << ' ' << a.second << '\n';
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    p.resize(n, -1);
    w.resize(n, 1);
    c.resize(n, {});
    map<pair<int, int>, int> fys;
    for (int i = 0; i < n; i++) {
        c[i] = {i, -1};
    }
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        unite(u, v);
        fys[{u, v}] = 1;
        fys[{v, u}] = 1;
    }
    vector<int> cam(n, 0);
    pair<int, int> maxcum = {-1, -1};
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        cam[u]++;
        cam[v]++;
        maxcum = max({maxcum, {cam[u], u}, {cam[v], v}});
        e[{u, v}] = 1;
        e[{v, u}] = 1;
    }
    vector<pair<int, int>> otv;
    int s = lead(0);
    if (m2 == n - 1) {
        if (maxcum.first == n - 1) {
            cout << "Yes\n";
            for (int i = 0; i < n; i++) {
                if (fys.count({(maxcum.second + i) % n, (maxcum.second + i + 1) % n}) == 0) {
                    otv.emplace_back((maxcum.second + i) % n + 1, (maxcum.second + i + 1) % n + 1);
                }
            }
            cout << otv.size() << '\n';
            for (auto i: otv) {
                print(i);
            }
            return;
        }
        while (comps != 1) {
            set<int> unused;
            for (int i = 0; i < n; i++) {
                if (lead(s) != lead(i)) {
                    unused.insert(i);
                }
            }
            while (!unused.empty()) {

            }

        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1, G;
    cin >> tt >> G;
    while (tt--) {
        solve();
        cout << '\n';
    }
}