#include <bits/extc++.h>

using namespace std;
template<class t> using vc = std::vector<t>;
typedef long long ll;

const int N = 3e5 + 5;
set<int> g1[N], g2[N];

bool u[N];


void fs2(int v) {
    u[v] = true;
    for (auto u: g2[v]) if (!::u[u]) fs2(u);
}

int n, m1, m2;
bool c2() {
    memset(u, 0, sizeof u);
    fs2(1);
    bool fl = true;
    for (int v = 1; v <= n; ++v) if (!u[v]) return false;
    return true;
}

void fs(int v) {
    u[v] = true;
    for (auto u: g1[v]) if (!::u[u]) fs(u);
}

bool used[N];
int d[N], up[N];
set<pair<int, int>> b;

void mfs(int v, int p = -1) {
    used[v] = true;
    up[v] = d[v];
    for (auto u: g2[v]) {
        if (u == p) continue;
        if (!used[u] && p != v) {
            d[u] = d[v] + 1, mfs(u), up[v] = min(up[v], up[u]);
            if (up[u] > d[v]) {
                b.insert({min(v, u), max(v, u)});
            }
        } else up[v] = min(up[v], d[u]);
    }
}

void cr() {
    memset(used, 0, sizeof used);
    b.clear();
    mfs(1);
}


bool c() {
    memset(u, 0, sizeof u);
    fs(1);
    bool fl = true;
    for (int v = 1; v <= n; ++v) if (!u[v]) return false;
    return true;
}

int p[N];

int get(int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

void un(int v, int u) {
    p[v] = u;
}

bool of(int v, int u) { return get(v) == get(u); }

int main() {
#ifndef _GLIBCXX_DEBUG
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t, g;
    cin >> t >> g;
    while (t--) {
        cin >> n >> m1 >> m2;
        for (int v = 1; v <= n; ++v) g1[v].clear(), g2[v].clear(), p[v] = v;
        set<pair<int, int>> o;
        for (int v = 1; v <= n; ++v) for (int u = v + 1; u <= n; ++u) o.insert({v, u});
        for (int i = 0; i < m1; ++i) {
            int v, u;
            cin >> v >> u;
            if (v > u) swap(v, u);
            o.erase({v, u});
            g1[v].insert(u);
            g1[u].insert(v);
            un(v, u);
        }

        for (int i = 0; i < m2; ++i) {
            int v, u;
            cin >> v >> u;
            g2[v].insert(u);
            g2[u].insert(v);
        }

        vc<pair<int, int>> ans;
        while (!c()) {
            if (!c2()) break;
            bool fl = false;
            cr();
            vc<pair<int, int>> del;
            for (auto [v, u]: o) {
                if (of(v, u)) del.push_back({v, u});
                else {
                    if (!b.count({v, u})) {
                        fl = true;
                        ans.push_back({v, u});
                        g1[v].insert(u);
                        g2[v].erase(u);
                        un(v, u);
                        g2[u].erase(v);
                        g1[u].insert(v);
                        break;
                    }
                }
            }
            if (!fl) break;
            for (auto x: del) o.erase(x);
        }
        if (!c() || !c2()) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            cout << ans.size() << '\n';
            for (auto [v, u] : ans) cout << v << ' ' << u << '\n';
        }
    }
}

