//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>

#include <random>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
//typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define all(a) a.begin(), a.end()
#define rd(a) for (auto &i: a) cin >> i;

ll INF = 1e13;
ll MOD = 1e9 + 7;


ll g;

vector<vector<ll>> g1, g2;
vector<bool> used1, used2;

void dfs1(int u) {
    used1[u] = true;
    for (ll v: g1[u]) {
        if (used1[v]) continue;
        dfs1(v);
    }
}

void dfs2(int u) {
    used2[u] = true;
    for (ll v: g2[u]) {
        if (used2[v]) continue;
        dfs2(v);
    }
}
void solve() {
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<pair<ll, ll>> edges;
    vector<vector<bool>> a1(n, vector<bool>(n, false));
    vector<vector<bool>> a2(n, vector<bool>(n, false));
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            edges.push_back({i, j});
        }
    }
    for (int i = 0; i < m1; i++) {
        ll u, v;
        cin >> u >> v;
        u--;
        v--;
        a1[u][v] = true;
        a1[v][u] = true;
    }

    for (int i = 0; i < m2; i++) {
        ll u, v;
        cin >> u >> v;
        u--;
        v--;
        a2[u][v] = true;
        a2[v][u] = true;
    }
    for (int mask = 0; mask < (1 << (ll(edges.size()))); mask++) {
        g1 = vector<vector<ll>>(n);
        g2 = vector<vector<ll>>(n);
        for (int i = 0; i < edges.size(); i++) {
            if (mask & (1 << i)) {
                auto [u, v] = edges[i];
                if (!a1[u][v]) {
                    g1[u].push_back(v);
                    g1[v].push_back(u);
                }
                if (!a2[u][v]) {
                    g2[u].push_back(v);
                    g2[v].push_back(u);
                }
            } else {
                auto [u, v] = edges[i];
                if (a1[u][v]) {
                    g1[u].push_back(v);
                    g1[v].push_back(u);
                }
                if (a2[u][v]) {
                    g2[u].push_back(v);
                    g2[v].push_back(u);
                }
            }
        }
        used1 = vector<bool>(n, false);
        used2 = vector<bool>(n, false);
        dfs1(0);
        dfs2(0);
        bool f = true;
        for (int i = 0; i < n; i++) {
            if (!used1[i] || !used2[i]) {
                f = false;
                break;
            }
        }
        if (f) {
            cout << "Yes\n";
            vector<pair<ll, ll>> ans;
            for (int i = 0; i < edges.size(); i++) {
                if (mask & (1 << i)) {
                    ans.push_back(edges[i]);
                }
            }
            cout << ans.size() << "\n";
            for (auto [x, y]: ans) {
                cout << x + 1 << " " << y + 1 << "\n";
            }
            return;
        }
    }
    cout << "No\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t; for (cin >> t >> g; t--;) solve();
//    solve();

}

//void operator delete(void*) {};
//const int MAX_MEM = 3 * 1e8;
//int pos = 0;
//char buf[MAX_MEM];
//void* operator new(size_t x) {
//    void* pointer = (void*)(buf + pos);
//    pos += x;
//    if (pos >= MAX_MEM) {
//        pos = 1e6;
//    }
//    return pointer;
//
//}


