#include <bits/stdc++.h>

using namespace std;

void dfs(int v, vector <vector <int>> & g, set <int> & was) {
    was.insert(v);
    for (auto n : g[v]) {
        if (was.find(n) == was.end()) {
            dfs(n, g, was);
        }
    }
}

int main() {
    ios::sync_with_stdio();
    cin.tie();
    cout.tie();
    int test, group; cin >> test >> group;
    while (test--) {
        int n, m1, m2; cin >> n >> m1 >> m2;
        set <pair <int, int>> e1, e2;
        for (int i=0; i < m1; ++i) {
            int u, v; cin >> u >> v;
            if (u > v) swap(u, v);
            e1.insert({u, v});
        }
        for (int i=0; i < m2; ++i) {
            int a, b; cin >> a >> b;
            if (a > b) swap(a, b);
            e2.insert({a, b});
        }
        if (group <= 1) {
            vector <pair <int, int>> edges;
            vector <bool> svet1, svet2;
            for (int i=1; i < n; ++i) {
                for (int j=i+1; j <= n; ++j) {
                    if (e1.find({i, j}) != e1.end()) {
                        svet1.push_back(1);
                    } else {
                        svet1.push_back(0);
                    }
                    if (e2.find({i, j}) != e2.end()) {
                        svet2.push_back(1);
                    } else {
                        svet2.push_back(0);
                    }
                    edges.push_back({i, j});
                }
            }
            bool good = 0;
            for (int mask=0; mask < (1 << (n*(n-1)/2)) && !good; ++mask) {
                vector <vector <int>> g1(n + 1), g2(n + 1);
                vector <pair <int, int>> delta;
                for (int i=0; i < n*(n-1)/2; ++i) {
                    if (mask & (1 << i)) {
                        delta.push_back(edges[i]);
                    }
                    if (((mask & (1 << i)) >= 1) ^ svet1[i]) {
                        g1[edges[i].first].push_back(edges[i].second);
                        g1[edges[i].second].push_back(edges[i].first);
                    }
                    if (((mask & (1 << i)) >= 1) ^ svet2[i]) {
                        g2[edges[i].first].push_back(edges[i].second);
                        g2[edges[i].second].push_back(edges[i].first);
                    }
                }
                if (delta.size() <= n) {
                    set <int> was1, was2;
                    dfs(1, g1, was1);
                    dfs(1, g2, was2);
                    if (was1.size() == n && was2.size() == n) {
                        good = 1;
                        cout << "Yes\n" << delta.size() << "\n";
                        for (auto & p : delta) {
                            cout << p.first << " " << p.second << "\n";
                        }
                    }
                }
            }
            if (!good) {
                cout << "No\n";
            }
        } else if (group == 5 || group == 9) {
            vector <pair <int, int>> ans;
            for (int i=2; i < n; ++i) {
                if (e1.find({i, i+1}) == e1.end()) {
                    ans.push_back({i, i+1});
                }
            }
            if (e1.find({2, n}) == e1.end()) {
                ans.push_back({2, n});
            }
            bool fi = 0;
            for (auto & e : e1) {
                if (e.first == 1 && e.second != 1) {
                    fi = 1;
                }
            }
            if (!ans.empty() && !fi) {
                ans.push_back({ans[0].first, 1});
            } else {
                if (!fi) {
                    ans.push_back({2, 1});
                    ans.push_back({2, 3});
                }
            }
            cout << "Yes\n" << ans.size() << "\n";
            for (auto & p : ans) {
                cout << p.first << " " << p.second << "\n";
            }
        }
    }
    return 0;
}
