#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>
#include <iomanip>
#include <stack>
#include <deque>
#include <algorithm>
#include <queue>
#include <random>

typedef long long ll;

using namespace std;

const ll INF = 1e9;
const ll MAXN = 1e5 + 5;

using t3 = tuple<int, int, int>;

int g;
int n, m1, m2;
vector<vector<int>> g1, g2;
void solve56() {
    set<int> kids;
    for (auto to : g2[0]) {
        kids.insert(to);
    }

    set<pair<int, int>> ans;
    for (int to = 1; to < n; ++to) {
        if (kids.find(to) != kids.end()) {
            continue;
        }

        ans.insert({0, to});
    }

    vector<int> tmp;
    for (auto to : kids) {
        tmp.push_back(to);
    }

    for (int i = 0; i < (int)tmp.size() - 1; ++i) {
        ans.insert({tmp[i], tmp[i + 1]});
    }

    ans.insert({0, tmp[0]});
    cout << "Yes\n";
    for (auto [x, y] : ans) {
        cout << x + 1 << ' ' << y + 1 << '\n';
    }
}

void start() {
    cin >> n >> m1 >> m2;
    g1.assign(n, {});
    g2.assign(n, {});

    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g1[a].push_back(b);
        g1[b].push_back(a);
    }

    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g2[a].push_back(b);
        g2[b].push_back(a);
    }

    if (g == 5 || g == 6) {
        solve56();
    }

    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("in", "r", stdin);
#endif

    ll T = 1;
    cin >> T >> g;

    while (T --> 0) {
        start();
    }

    return 0;
}
