#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;

struct ev
{
    int i, u, v;
};

bool operator<(ev a, ev b)
{
    return a.i > b.i;
}

int n, m1, m2;
vector<int> *b;
vector<int> *c;
bool *us;
vector<vector<int>> col;
vector<ev> ans;
bool **ed;
bool **ed1;

void dfs(int v, int i)
{
    if(us[v]) return;
    us[v] = 1;
    col[i].push_back(v);
    for(int u : b[v]) dfs(u, i);
}

void upd(int u, int v)
{
    // cout << "upd " << u << ' ' << v << endl;
    if(ed[u][v]){
        --m2;
        ans.push_back({-1, u, v});
        for(int i = 0; i < c[u].size(); ++i) if(c[u][i] == v){
            c[u].erase(c[u].begin() + i);
            break;
        }
        for(int i = 0; i < c[v].size(); ++i) if(c[v][i] == u){
            c[v].erase(c[v].begin() + i);
            break;
        }
    }
    else{
        ++m2;
        ans.push_back({1, u, v});
        c[u].push_back(v);
        c[v].push_back(u);
    }
    ed[u][v] = !ed[u][v];
    ed[v][u] = !ed[v][u];    
    if(ed1[u][v]){
        --m1;
        for(int i = 0; i < b[u].size(); ++i) if(b[u][i] == v){
            b[u].erase(b[u].begin() + i);
            break;
        }
        for(int i = 0; i < b[v].size(); ++i) if(b[v][i] == u){
            b[v].erase(b[v].begin() + i);
            break;
        }
    }
    else{
        ++m1;
        b[v].push_back(u);
        b[u].push_back(v);
    }
    ed1[u][v] = !ed1[u][v];
    ed1[v][u] = !ed1[v][u];
}

bool f()
{
    us = new bool[n];
    for(int i = 0; i < n; ++i) us[i] = 0;
    col.clear();
    int k = 0;
    for(int i = 0; i < n; ++i) if(!us[i]){
        col.push_back({});
        dfs(i, k);
        ++k;
    }
    // cout << "+++++++++++" << endl;
    // for(int i = 0; i < col.size(); ++i){
    //     for(int j : col[i]) cout << j << ' ';
    //     cout << endl;
    // }
    // cout << "-----------" << endl;
    if(k == 1) return 0;
    for(int x = 0; x < k; ++x) for(int y = x + 1; y < k; ++y){
        for(int u : col[x]) for(int v : col[y]){
            if(!ed[u][v]){
                upd(u, v);
                return 1;
            }
        }
    }
    if(k > 2 || (col[0].size() > 1 && col[1].size() > 1)){
        upd(col[0][0], col[1][0]);
        return 1;
    }
    if(col[1].size() == 1) swap(col[0], col[1]);
    int r = col[0][0];
    if(m2 == n - 1){
        if(m1 < (n - 1)*(n - 2)/2){
            for(int u = 0; u < n; ++u) if(u != r){
                for(int v = u + 1; v < n; ++v) if(v != r){
                    if(!ed1[u][v]){
                        upd(u, v);
                        upd(u, r);
                        return 1;
                    }
                }
            }
        }
    }
    else{
        for(int v = 0; v < n; ++v) if(v != r){
            bool z = 0;
            for(int u : c[v]) if(u != r){
                z = 1;
                break;
            }
            if(z){
                upd(v, r);
                return 1;
            }
        }
    }
    return 1;
}

void solve()
{
    cin >> n >> m1 >> m2;
    b = new vector<int>[n];
    c = new vector<int>[n];
    ed = new bool*[n];
    ed1 = new bool*[n];
    for(int i = 0; i < n; ++i){
        ed[i] = new bool[n];
        ed1[i] = new bool[n];
        for(int j = 0; j < n; ++j){
            ed[i][j] = 0;
            ed1[i][j] = 0;
        }
    }
    for(int i = 0; i < m1; ++i){
        int u, v;
        cin >> u >> v;
        --u; --v;
        ed1[u][v] = ed1[v][u] = 1;
        b[u].push_back(v);
        b[v].push_back(u);
    }
    for(int i = 0; i < m2; ++i){
        int u, v;
        cin >> u >> v;
        --u; --v;
        ed[u][v] = ed[v][u] = 1;
        c[u].push_back(v);
        c[v].push_back(u);
    }
    if(n == 3){
        bool no = 1;
        for(int i = 0; i < 3; ++i) if(b[i].size() + c[i].size() != 2) no = 0;
        if(no){
            cout << "No" << endl;
            return;
        }
    }
    cout << "Yes" << endl;
    ans.clear();
    while(f()){}
    cout << ans.size() << endl;
    sort(ans.begin(), ans.end());
    for(ev e : ans){
        cout << e.u + 1 << ' ' << e.v + 1 << endl;
    }
}

int main()
{
    int t, g;
    cin >> t >> g;
    for(int i = 0; i < t; ++i) solve();
}