#pragma GCC optimize("-Ofast")
#pragma GCC optimize("-03")
#pragma GCC optimize("-unroll-loops")
#pragma GCC optimize("avx2")
#include <bits/stdc++.h>
#define int long long

using namespace std;

void dfs(int u, vector<vector<int>>& g, vector<int>& was) {
    if (was[u]) return;
    was[u] = 1;
    for (int i = 0; i < g.size(); ++i) {
        if (g[u][i]) {
            dfs(i, g, was);
        }
    }
}

void solve1() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g(n, vector<int>(n));
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u][v] = g[v][u] = 1;
    }
    vector<vector<int>> g2(n, vector<int>(n));
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g2[u][v] = g2[v][u] = 1;
    }
    for (int mask = 0; mask < (1ll << (n * (n - 1) / 2)); ++mask) {
        if (mask >= 5e6) break;
        vector<pair<int, int>> s;
        int cnt = 0, op = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (mask & (1ll << (cnt))) {
                    g[i][j] = g[j][i] = g[i][j] ^ 1;
                    if (g2[i][j] == 1) {
                        s.push_back({i, j});
                        g2[i][j] = g2[j][i] = g2[i][j] ^ 1;
                    } else {
                        g2[i][j] = g2[j][i] = g2[i][j] ^ 1;
                    }
                    ++op;
                }
                ++cnt;
            }
        }
        vector<int> was1(n), was2(n);
        dfs(0, g, was1);
        dfs(0, g2, was2);
        bool nw = false;
        for (int i = 0; i < n; ++i) {
            nw |= !was1[i];
            nw |= !was2[i];
        }
        if (!nw && op <= n) {
            cout << "Yes\n";
            cout << op << "\n";
            cnt = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = i + 1; j < n; ++j) {
                    if (mask & (1ll << (cnt))) {
                        if (g2[i][j] != 0) {
                            cout << i + 1 << " " << j + 1 << "\n";
                        }
                    }
                    ++cnt;
                }
            }
            cnt = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = i + 1; j < n; ++j) {
                    if (mask & (1ll << (cnt))) {
                        if (g2[i][j] == 0) {
                            cout << i + 1 << " " << j + 1 << "\n";
                        }
                    }
                    ++cnt;
                }
            }
            return;
        }
        cnt = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (mask & (1ll << (cnt))) {
                    g[i][j] = g[j][i] = g[i][j] ^ 1;
                    g2[i][j] = g2[j][i] = g2[i][j] ^ 1;
                }
                ++cnt;
            }
        }
    }
    cout << "No\n";
}

void solve2() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g(n, vector<int>(n));
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u][v] = g[v][u] = 1;
    }
    vector<vector<int>> g2(n, vector<int>(n));
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g2[u][v] = g2[v][u] = 1;
    }
    if (n == 3 && m1 == 0) {
        cout << "No\n";
        return;
    } else {
        cout << "Yes\n";
        int cnt = 0;
        int beg = 0;
        for (int i = 1; i < n; ++i) {
            if (g[i - 1][i]) {
                beg = i - 1;
                break;
            }
        }
        for (int i = 1; i < n; ++i) {
            if (!g[(beg + i - 1) % n][(beg + i) % n]) {
                ++cnt;
            }
        }
        for (int i = 1; i < n; ++i) {
            if (!g[(beg + i - 1) % n][(beg + i) % n]) {
                cout << ((beg + i) % n == 0 ? n : (beg + i) % n) << " " << ((i + 1) % n == 0 ? n : (i + 1) % n) << "\n";
            }
        }
    }
}

void solve3() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g(n, vector<int>(n));
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u][v] = g[v][u] = 1;
    }
    vector<vector<int>> g2(n, vector<int>(n));
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g2[u][v] = g2[v][u] = 1;
    }
    vector<pair<int, int>> res;
    vector<vector<int>> comp;
    vector<int> was(n), was2(n);
    for (int i = 0; i < n; ++i) {
        if (!was[i]) {
            dfs(i, g, was);
            comp.emplace_back();
            for (int j = 0; j < n; ++j) {
                if (was[j] && !was2[j]) {
                    comp.back().push_back(j);
                    was2[j] = 1;
                }
            }
        }
    }
    for (int i = 1; i < (int)comp.size(); ++i) {
        bool b = false;
        for (auto& u : comp[i]) {
            for (auto& v : comp[i - 1]) {
                if (!g2[u][v]) {
                    res.push_back({u, v});
                    g2[u][v] = g2[v][u] = 1;
                    b = true;
                    break;
                }
            }
            if (b) break;
        }
        if (!b) {
            if (comp[0].size() == 1 || comp[1].size() == 1) {

                cout << "No\n";
                return;
            }
            res.push_back({comp[i].back(), comp[i - 1].back()});
            g2[comp[i].back()][comp[i - 1].back()] = g2[comp[i - 1].back()][comp[i].back()] = 0;
        }
    }
    cout << "Yes\n";
    cout << res.size() << "\n";
    for (auto& [u, v] : res) cout << u + 1 << " " << v + 1 << "\n";
}

void solve4() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g(n, vector<int>(n));
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u][v] = g[v][u] = 1;
    }
    vector<vector<int>> g2(n, vector<int>(n));
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g2[u][v] = g2[v][u] = 1;
    }
    vector<vector<int>> comp;
    vector<int> was(n), was2(n);
    for (int i = 0; i < n; ++i) {
        if (!was[i]) {
            dfs(i, g, was);
            comp.emplace_back();
            for (int j = 0; j < n; ++j) {
                if (was[j] && !was2[j]) {
                    comp.back().push_back(j);
                    was2[j] = 1;
                }
            }
        }
    }
    vector<pair<int, int>> res;
    for (int i = 1; i < (int)comp.size(); ++i) {
        bool b = false;
        for (auto& u : comp[i]) {
            for (auto& v : comp[i - 1]) {
                if (!g2[u][v]) {
                    res.push_back({u, v});
                    g2[u][v] = g2[v][u] = 1;
                    b = true;
                    break;
                }
            }
            if (b) break;
        }
        if (!b) {
            res.push_back({comp[i].back(), comp[i - 1].back()});
            g2[comp[i].back()][comp[i - 1].back()] = g2[comp[i - 1].back()][comp[i].back()] = 0;
        }
    }
    cout << "Yes\n";
    cout << res.size() << "\n";
    for (auto& [u, v] : res) cout << u + 1 << " " << v + 1 << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, g;
    cin >> t >> g;
    while (t--) {
        if (g <= 1)
            solve1();
        else if (g == 2)
            solve2();
        else if (g == 3)
            solve3();
        else if (g == 4) {
            solve4();
        }
    }
}
