#include <bits/stdc++.h>
using namespace std;

#define int long long
using ll = long long;
#define forn(i,n) for(int i=0;i<n;++i)
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];
#define pb push_back
#define all(x) x.begin(),x.end()
#define pi pair<int,int>
#define f first
#define s second

const ll inf = 1e18;

int n,g;

struct DSU {
	vector<int> p,sz;
	DSU(int n) {
		forn(i,n) p.pb(i),sz.pb(1);
	}
	int get(int u) {
		return p[u]==u?u:get(p[u]);
	}
	void uni(int u, int v) {
		u=get(u),v=get(v);
		if (u==v) return;
		if (sz[u]<sz[v]) swap(u,v);
		p[v]=u;
		sz[u]+=sz[v];
	}
};

void solve() {

	cin>>n;
	if (g==2) {
		int m1,m2; cin>>m1>>m2;
		DSU dsu(n);
		forn(i,m1) {
			int u,v; cin>>u>>v; --u, --v;
			dsu.uni(u,v);
		}
		forn(i,m2) {
			int a,b; cin>>a>>b;
		}
		if (m1==0) {
			if (n==3) {
				cout<<"No\n"; return;
			}
			cout<<"Yes\n";
			cout<<n+1<<'\n';
			forn(i,n-2) cout<<1<<' '<<i+2<<'\n';
			cout<<2<<' '<<n<<'\n';
		} else {
			cout<<"Yes\n";
			vector<pi> ans;
			for(int i=1; i<n; ++i) {
				if (dsu.get(0)==dsu.get(i)) continue;
				dsu.uni(0,i);
				ans.pb({1,i+1});
			}
			cout<<ans.size()<<'\n';
			for(auto&x:ans) cout<<x.f<<' '<<x.s<<'\n';
		}
		return;
	}

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	int g;
	cin>>t>>g;
	while (t--) solve();
}