#pragma GCC optimize("Ofast,inline")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define fi first
#define se second
#define int ll
mt19937 gen(time(0));

const int N = 3e5 + 12;
int sz[N], p[N];
int get_p(int v) {
    if(p[v] == v)
        return v;
    return p[v] = get_p(p[v]);
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector <pair<int,int>> e1;
    for(int i = 0; i < m1; ++i) {
        int v, u;
        cin >> v >> u;
        if(v > u)
            swap(v, u);
        e1.push_back({v, u});
    }
    vector <pair<int,int>> e2;
    for(int i = 0; i < m2; ++i) {
        int v, u;
        cin >> v >> u;
        if(v > u)
            swap(v, u);
        e2.push_back({v, u});
    }
    if(n <= 5) {
//        cout << "@\n";
        map <pair<int,int>,bool> mp1, mp2;
        for(auto to : e1) {
            mp1[to] = 1;
        }
        for(auto to : e2) {
            mp2[to] = 1;
        }
        vector <pair<int,int>> e;
        e.push_back({1, 2});
        e.push_back({1, 3});
        e.push_back({2, 3});
        for(int msk = 0; msk < (1 << 3); ++msk) {
            for(int i = 0; i < 3; ++i) {
                if(msk & (1 << i)) {
                    mp1[e[i]] ^= 1;
                    mp2[e[i]] ^= 1;
                }
            }
            bool f1 = 0;
            if(mp1[ {1,2}] == 1 && mp1[ {2,3}] == 1)
                f1 = 1;
            if(mp1[ {1,2}] == 1 && mp1[ {1,3}] == 1)
                f1 = 1;
            if(mp1[ {1,3}] == 1 && mp1[ {2,3}] == 1)
                f1 = 1;
            bool f2 = 0;
            if(mp2[ {1,2}] == 1 && mp2[ {2,3}] == 1)
                f2 = 1;
            if(mp2[ {1,2}] == 1 && mp2[ {1,3}] == 1)
                f2 = 1;
            if(mp2[ {1,3}] == 1 && mp2[ {2,3}] == 1)
                f2 = 1;
            if(f1 && f2) {
                cout << "Yes\n";
                cout << __builtin_popcount(msk) << '\n';
                for(int i = 0; i < 3; ++i) {
                    if(msk & (1 << i))
                        cout << e[i].fi << ' ' << e[i].se << '\n';
                }
                return;
            }
        }
        cout << "No\n";
        return;
    }
    for(int i = 1; i <= n; ++i) {
        sz[i] = 1;
        p[i] = i;
    }
    shuffle(e2.begin(), e2.end(), gen);
    map <pair<int,int>,bool> ban;
    for(auto [v, u] : e2) {
        int V = get_p(v);
        int U = get_p(u);
        if(V == U)
            continue;
        ban[{v,u}] = 1;
//        cout << "! " << v << ' ' << u << '\n';
        if(sz[V] < sz[U])
            swap(V, U);
        p[U] = V;
        sz[V] += sz[U];
    }
    vector <int> ve;
    for(int i = 1; i <= n; ++i) {
        ve.push_back(i);
    }
    while(true) {
        shuffle(ve.begin(), ve.end(), gen);
        bool ok = 1;
        for(int i = 1; i < ve.size(); ++i) {
            int v = ve[i-1], u = ve[i];
            if(v > u)
                swap(v, u);
            if(ban[{v,u}] == 1) {
                ok = 0;
                break;
            }
        }
        if(!ok)
            continue;
        cout << "Yes\n";
        cout << n - 1 << '\n';
        for(int i = 1; i < ve.size(); ++i) {
            int v = ve[i-1], u = ve[i];
            if(v > u)
                swap(v, u);
            cout << v << ' ' << u << '\n';
        }
        return;
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int qq, G;
    cin >> qq >> G;
    while(qq--) {
        solve();
    }
    return 0;
}
