#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int inf = 1e9;

int gr;

vector<vector<int>> g1, g2;

vector<bool> used;

void dfs(int u, vector<vector<int>> & g) {
    used[u] = true;
    for (auto v : g[u]) {
        if (used[v]) continue;
        dfs(v, g);
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g1.assign(n, {});
    g2.assign(n, {});
    map<pair<int, int>, int> mp1;
    map<pair<int, int>, int> mp2;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g1[u].push_back(v);
        g1[v].push_back(u);
        mp1[{min(u, v), max(u, v)}]++;
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g2[u].push_back(v);
        g2[v].push_back(u);
        mp2[{min(u, v), max(u, v)}]++;
    }
    auto pmp1 = mp1;
    auto pmp2 = mp2;
    if (1) {
        vector<pair<int, int>> edges;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                edges.push_back({i, j});
            }
        }
        int cnte = edges.size();
        for (int i = 0; i < (1 << cnte); i++) {
            mp1 = pmp1;
            mp2 = pmp2;
            int cbits = 0;
            g1.assign(n, {});
            g2.assign(n, {});
            for (int j = 0; j < cnte; j++) {
                if (!((i >> j) & 1)) continue;
                cbits++;
                if (cbits >= n) break;
                auto ed = edges[j];
                mp1[ed]++;
                mp2[ed]++;
            }
            if (cbits >= n) continue;
            for (auto ed : edges) {
                if (mp1[ed] % 2) {
                    g1[ed.first].push_back(ed.second);
                    g1[ed.second].push_back(ed.first);
                }
                if (mp2[ed] % 2) {
                    g2[ed.first].push_back(ed.second);
                    g2[ed.second].push_back(ed.first);
                }
            }
            used.assign(n, false);
            dfs(0, g1);
            bool good = true;
            for (auto e : used) {
                if (!e) good = false;
            }
            if (!good) continue;
            used.assign(n, false);
            dfs(0, g2);
            for (auto e : used) {
                if (!e) good = false;
            }
            if (good) {
                cout << "Yes\n";
                cout << cbits << '\n';
                for (int j = 0; j < cnte; j++) {
                    if (!((i >> j) & 1)) continue;
                    cout << edges[j].first + 1 << ' ' << edges[j].second + 1 << '\n';
                }
                return;
            }
        }
        cout << "No\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t >> gr;
    for (int i = 0; i < t; i++) solve();
}
