#include <bits/stdc++.h>
#define forn(i, n) for (long long i = 0; i < n; i++)
#define ff first
#define ss second

using namespace std;
using ll = long long;

const ll N = 3e3 + 10, INF = 0x3f3f3f3f3f3f3f3f;
mt19937 rnd(228);


ll t, tt, n, m1, m2, p[N], sz[N];
ll e2[N][N];

vector<ll> g[N];
vector<pair<ll, ll>> ee, ans;

ll get(ll x) {
    if (p[x] == x)
        return x;
    p[x] = get(p[x]);
    return p[x];
}

void merge(ll x, ll y) {
    x = get(x);
    y = get(y);
    if (x == y)
        return;
    if (rnd() % 2)
        swap(x, y);
    p[y] = x;
    sz[x] += sz[y];
}

ll cnt;
ll used[N];

void dfs(ll v) {
    used[v] = true;
    cnt++;
    for (auto u : g[v]) {
        if (e2[v][u] && !used[u])
            dfs(u);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef HOME_ZHEGLOV
    freopen("inp.txt", "r", stdin);
#endif
    cin >> t >> tt;
    while (t--) {
        cin >> n >> m1 >> m2;
        forn(i, n) {
            p[i] = i;
            sz[i] = 1;
            forn(j, n)
                e2[i][j] = false;
            g[i].clear();
        }
        ee.clear();
        ans.clear();
        forn(i, m1) {
            ll x, y;
            cin >> x >> y; x--; y--;
            ee.push_back({x, y});
            merge(x, y);
        }
        forn(i, m2) {
            ll x, y;
            cin >> x >> y; x--; y--;
            e2[x][y] = true;
            e2[y][x] = false;
            g[x].push_back(y);
            g[y].push_back(x);
        }
        bool ok = true;
        while (true) {
            if (sz[get(0)] == n)
                break;

            ll x = rnd() % n, y = rnd() % n;
            while (get(x) == get(y)) {
                x = rnd() % n, y = rnd() % n;
            }
            merge(x, y);
            ans.push_back({x, y});
            e2[x][y] = !e2[x][y];
            g[x].push_back(y);
            g[y].push_back(x);
            forn(i, n)
                used[i] = false;
            cnt = 0;
            dfs(0);
            if (cnt != n) {
                ok = false;
                break;
            }
        }
        if (ok) {
            cout << "YES\n" << ans.size() << "\n";
            for (auto v : ans)
                cout << v.ff << " " << v.ss << "\n";
        }
        else {
            cout << "NO\n";
        }
    }
    return 0;
}