#include <bits/stdc++.h>
using namespace std;

using ll = long long;

vector<vector<int>> g1, g2, a;
vector <int> used;
int n, m1, m2, c = 1;

void dfs1(int cur) {
    used[cur] = c;
    for (int x = 0; x < n; ++x) {
        if (!used[x] && a[cur][x]) dfs1(x);
    }
}

void solve() {
    a.assign(n, vector<int> (n, 0));
    for (int i = 0; i < n; ++i) {
        for (auto x : g1[i]) a[i][x] = 1;
    }
    cout << "Yes" << "\n";
    vector <int> ord;
    used.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs1(i);
            ord.push_back(i);
            c++;
        }
    }
    cout << c - 1 << "\n";
    for (int i = 1; i < ord.size(); ++i) {
        cout << ord[i - 1] + 1 << " " << ord[i] + 1 << "\n";
    }
}

int main() {
    int t, gr;
    cin >> t >> gr;
    for (int i = 0; i < t; ++i) {
        cin >> n >> m1 >> m2;
        g1.resize(n);
        g2.resize(n);
        for (int j = 0; j < m1; ++j) {
            int u, v;
            cin >> u >> v;
            g1[u - 1].push_back(v - 1);
            g1[v - 1].push_back(u - 1);
        }
        for (int j = 0; j < m2; ++j) {
            int u, v;
            cin >> u >> v;
            g2[u - 1].push_back(v - 1);
            g2[v - 1].push_back(u - 1);
        }
        if (n <= 3) cout << "No\n";
        else if (gr <= 8) solve();
        g1.clear();
        g2.clear();
    }
}

/*
3 0
3 0 3
1 2
2 3
1 3
4 2 3
1 2
3 4
1 3
1 4
2 3
4 3 3
1 2
2 3
1 3
1 4
2 4
3 4

 */