#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <iomanip>
#include <math.h>
#include <queue>

//#pragma target("ofast, o3, avx2")

using namespace std;

#define INF ((ll)1e18)
#define ll long long
#define db double
#define str string
#define vc vector
#define its(a) (a).begin(),(a).end()
#define itsr(a) (a).rbegin(),(a).rend()
#define sz(a) (a).size()


void g1() {
	ll n, m1, m2; cin >> n >> m1 >> m2;
	vc<vc<bool>> g1(n, vc<bool>(n)), g2(n, vc<bool>(n));
	for (int i = 0; i < m1; ++i) {
		ll u, v; cin >> u >> v;
		--u, --v;
		g1[u][v] = 1;
		g1[v][u] = 1;
	}
	for (int i = 0; i < m2; ++i) {
		ll u, v; cin >> u >> v;
		--u, --v;
		g2[u][v] = 1;
		g2[v][u] = 1;
	}
	vc<pair<ll, ll>> p;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			p.push_back({ i,j });
		}
	}
	vc<pair<ll, ll>> cur;
	vc<vc<pair<ll, ll>>> v;
	auto gen = [&](auto gen, int i, int j)->void {
		if (i > n) {
			return;
		}
		if (j == sz(p)) {
			v.push_back(cur);
			return;
		}
		cur.push_back(p[j]);
		gen(gen, i + 1, j + 1);
		cur.pop_back();
		gen(gen, i, j + 1);
	};
	gen(gen, 0, 0);


	for (auto com:v){
			vc<vc<bool>> ng1 = g1, ng2 = g2;
			vc<bool> used(n);
			auto dfs = [&](auto dfs, int u) -> void {
				used[u] = 1;
				for (int i = 0; i < n; ++i) {
					if (ng2[u][i] and !used[i]) {
						dfs(dfs, i);
					}
				}
			};
			auto dfs2 = [&](auto dfs2, int u) -> void {
				used[u] = 1;
				for (int i = 0; i < n; ++i) {
					if (ng1[u][i] and !used[i]) {
						dfs2(dfs2, i);
					}
				}
				};
			bool val = 1;
			for (auto [u, v] : com) {
				ng2[u][v] = !ng2[u][v];
				ng2[v][u] = !ng2[v][u];
				used.assign(n, 0);
				dfs(dfs, 0);
				if (used != vc<bool>(n, 1)) val = 0;
				ng1[u][v] = !ng1[u][v];
				ng1[v][u] = !ng1[v][u];
			}
			used.assign(n, 0);
			dfs2(dfs2, 0);
			if (used == vc<bool>(n, 1) and val) {
				cout << "Yes\n";
				cout << sz(com) << '\n';
				for (auto [u, v] : com) cout << u + 1 << " " << v + 1 << '\n';
				return;
			}
		
	} 
	cout << "No\n";
}


void solve() {
	ll n; cin >> n;
	vc<ll> d(n), l(n), r(n);
	for (auto& i : d) cin >> i;
	for (auto& i : l) cin >> i;
	for (auto& i : r) cin >> i;
	ll a0, b0; cin >> a0 >> b0;
	ll bst = -INF;
	for (int msk = 0; msk < (1 << n); ++msk) {
		ll ac = a0, bc = b0;
		for (int i = 0; i < n; ++i) {
			if ((msk >> i) & 1) {
				ac = min(ac + d[i], l[i]);
				bc += d[i];
			}else {
				ac += d[i];
				bc = min(bc + d[i], r[i]);
			}
		}
		bst = max(bst, ac + bc);
	}
	cout << bst;
}

int main()
{
	ios_base::sync_with_stdio(0); 
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll _t = 1, g;
	cin >> _t >> g;
	while (_t--) {
		if (g <= 1) {
			g1();
		}
	}
}
