#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//template<class c, class cmp = less<c>> using ordered_set = tree<c,null_type,cmp,rb_tree_tag,tree_order_statistics_node_update>;

#define int long long
#define ll long long
#define str string
#define ff first
#define ss second
#define db double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()
mt19937 rnd(time(0));

const ll INF = 1e18;
const db EPS = 1e-6;
const int MOD = 1e9 + 7;
const int MAXN = 1e5 + 10;

void solve();

void fastios() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

signed main() {
    fastios();
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    double start = clock();
#endif
    int ttt = 1;
    cin >> ttt;
    while (ttt--) {
        solve();
#ifdef LOCAL
        cout << "--------------------------\n";
#endif
    }
#ifdef LOCAL
    cerr << "Time: " << (clock() - start) / CLOCKS_PER_SEC << '\n';
#endif
}

int G, n, m1, m2;
set<int> g1[MAXN], g2[MAXN];
int used1[MAXN];

void dfs1(int v, int c) {
    used1[v] = c;
    for (int to: g1[v])
        if (!used1[to])
            dfs1(to, c);
}

void init() {
    for (int i = 0; i < n; ++i) {
        used1[i] = 0;
        g1[i].clear();
        g2[i].clear();
    }
}

void solve() {
    cin >> G >> n >> m1 >> m2;
    init();
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g1[a].insert(b);
        g1[b].insert(a);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g2[a].insert(b);
        g2[b].insert(a);
    }
    if (G == 3) {
        int c = 0;
        for (int i = 0; i < n; ++i)
            if (!used1[i]) {
                c++;
                dfs1(i, c);
            }
        pair<int,int> tmp = {-1,-1};
        for (int i = 0; i < n; ++i)
            if (used1[0] != used1[i]){
                tmp = {0,i};
                if (g2[0].find(i) == g2[0].end())
                    break;
            }
        cout << "Yes\n1\n";
        cout << tmp.ff + 1 << ' ' << tmp.ss + 1 << endl;
        return;
    }
}