#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
//#pragma GCC optimize("trapv")
#endif
#include <bits/stdc++.h>

const int MAX_N = (int)3e5+10;
const int INT_INF = (int)2e9;
const double pi = acos(-1);


using namespace std;
using ld = long double;
using ll = long long;

int graph1[3010][3010];
int graph2[3010][3010];
vector<int>comp1;
vector<int>comp2;
bool used[3010];
int n,m1,m2;
void dfs(int v, int c){
    used[v] = true;
    if(c==1){
        comp1.push_back(v);
    }
    else comp2.push_back(v);
    for(int i = 1;i<=n;++i){
        if(graph1[v][i]){
            if(!used[i]){
                dfs(i,c);
            }
        }
    }
}

void fast_solve(){
    cin>>n>>m1>>m2;
    for(int i = 1;i<=n;++i){
        for(int j = 1;j<=n;++j){
            graph1[i][j] = 0;
            graph2[i][j] = 0;
        }
    }
    for(int i = 0;i<m1;++i){
        int a,b;
        cin>>a>>b;
        graph1[a][b] = 1;
        graph1[b][a] = 1;
    }
    for(int i = 0;i<m2;++i){
        int a,b;
        cin>>a>>b;
        graph2[a][b] = 1;
        graph2[b][a] = 1;
    }
    dfs(1,1);
    for(int i = 1;i<=n;++i){
        if(!used[i]){
            dfs(i,2);
            break;
        }
    }
    for(int i = 0;i<comp1.size();++i){
        for(int j = 0;j<comp2.size();++j){
            if(!graph2[comp1[i]][comp2[j]]){
                cout<<"Yes\n";
                cout<<1<<"\n";
                cout<<comp1[i]<<" "<<comp2[j];
                return;
            }
        }
    }
    cout<<"No";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
    int t, g;
    cin>>t>>g;
    while(t--){
        fast_solve();
        cout<<"\n";
    }
    return 0;
}
