// JafoNoksy's code
#include <bits/stdc++.h>

#pragma GCC optimize "O2"
using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define F first
#define S second
#define int ll
#define ve vector
mt19937 rnd(4732);

template<class A>
istream &operator>>(istream &in, ve<A> &x) {
    for (auto &c: x)
        in >> c;
    return in;
}

template<class A>
ostream &operator<<(ostream &out, ve<A> &x) {
    for (auto &c: x)
        out << c << ' ';
    return out << '\n';
}

struct segtree {
    ve<int> t;
    int n = 0;

    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    int get(int v, int l, int r, int _l, int _r) {
        if (l >= _r || _l >= r)
            return 0;
        if (_l <= l && r <= _r)
            return t[v];
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, _l, _r) + get(2 * v + 2, m, r, _l, _r);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }

    segtree(ve<int> a = {1}) {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n, a);
    }
};

struct mst {
    ve<ve<int>> t;

    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = {a[l]};
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v].resize(t[2 * v + 1].size() + t[2 * v + 2].size());
        merge(t[2 * v + 1].begin(), t[2 * v + 1].end(), t[2 * v + 2].begin(), t[2 * v + 2].end(), t[v].begin());
    }

    void get(int v, int l, int r, int i, int s) {
        int m = (l + r) / 2;
    }
};

void dfs(int v, ve<int> &comp, ve<ve<int>> &g, ve<ve<int>> &c) {
    c.back().pb(v);
    for (auto &u : g[v]) {
        if (comp[u] == -1) {
            comp[u] = comp[v];
            dfs(u, comp, g, c);
        }
    }
}

void dfss(int v, ve<ve<pair<int, pll>>> &g, ve<bool> &used, ve<pll> &ans) {
    used[v] = 1;
    for (auto &&[u, x] : g[v]) {
        if (!used[u]) {
            ans.pb(x);
            dfss(u, g, used, ans);
        }
    }
}

void dfsssssss(int v, ve<bool> &used, ve<ve<int>> &g, ve<pll> &ans) {
    used[v] = 1;
    for (auto &u : g[v]) {
        if (!used[u]) {
            ans.pb({min(u, v), max(u, v)});
            dfsssssss(u, used, g, ans);
        }
    }
}


pair<int, ve<pll>> do_something(ve<ve<int>> &g, int n) {
    int v = 0;
    for (int i = 0; i < n; ++i) {
        if (g[i].size() > g[v].size())
            v = i;
    }
    ve<bool> used(n, 0);
    ve<pll> ans;
    dfsssssss(v, used, g, ans);
    return {v, ans};
}

void sol(int test_group) {
    int n;
    cin >> n;
    int m1, m2;
    cin >> m1 >> m2;
    ve<pll> E1, E2;
    ve<ve<int>> g1(n), g2(n);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        g1[u - 1].pb(v - 1);
        g1[v - 1].pb(u - 1);
        E1.pb({min(u - 1, v - 1), max(u - 1, v - 1)});
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        g2[u - 1].pb(v - 1);
        g2[v - 1].pb(u - 1);
        E2.pb({min(u - 1, v - 1), max(u - 1, v - 1)});
    }
    sort(all(E1));
    sort(all(E2));  // Для поиска ребра в дереве
    auto find = [&](int u, int v) {
        return binary_search(all(E2), pll{min(u, v), max(u, v)});
    };
    if (n == 3 && m1 == 0 && find(0, 1) && find(1, 2) && find(0, 2)) {
        cout << "No\n";
        return;
    } if (n == 3 && m2 == 3) {
        if (m1 == 1) {
            cout << "Yes\n";
            if (E1[0] == pll{0, 1})
                cout << "1\n2 3\n";
            else
                cout << "1\n1 2\n";
            return;
        } else {
            cout << "Yes\n0\n";
        }
        return;
    }
    // у нас либо m1 еж, либо нет. От этого сильно зависит ответ
    // todo проверить на ежа
    if (true) { // не еж, но вообще надо оставить остов, котоырй не еж
        // считаем что в Е2 только дерево, отличное от ежа. Это надо сделать, но мне впадлу)
        auto [V, _E2] = do_something(g2, n);
        E2 = _E2;
        ve<pll> ans;
        /*if (m2 == n-1 && g2[V].size() == n-1) {
            for (int i = 0; i < n; ++i) {
                for (int j = i+1; j < n; ++j) {
                    if (i != V && j != V) {
                        ans.pb({i, j});

                    }
                }
            }
        }*/
        sort(all(E2));
        ve<ve<int>> c;
        ve<int> comp(n, -1);
        for (int i = 0; i < n; ++i) {
            if (comp[i] == -1) {
                comp[i] = c.size();
                c.pb({});
                dfs(i, comp, g1, c);
            }
        }
        ve<ve<pair<int, pll>>> g3(c.size());
        for (int i = 0; i < c.size(); ++i) {
            for (int j = i+1; j < c.size(); ++j) {
                pll best = {-1, -1};
                for (auto &v : c[i]) {
                    for (auto &u : c[j]) {
                        if (!find(u, v)) {
                            best = {u, v};
                        }
                    }
                }
                if (best.F != -1) {
                    g3[i].pb({j, best});
                    g3[j].pb({i, best});
                }
            }
        }

        ve<bool> used(c.size(), 0);
        dfss(0, g3, used, ans);
        for (int i = 0; i < c.size(); ++i) {
            if (!used[i]) {
                cout << "No\n";
                return;
            }
        }
        cout << "Yes\n" << ans.size() << '\n';
        for (auto &&[u, v] : ans)
            cout << u+1 << ' '  << v+1 << '\n';
        return;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t, g;
    cin >> t >> g;
    while (t--)
        sol(g);
}