#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

int gr;

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> has;
    for (int i = 0; i < m1; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        has.insert({v, u});
        has.insert({u, v});
    }
    set<pair<int, int>> has2;
    for (int i = 0; i < m2; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        has2.insert({v, u});
        has2.insert({u, v});
    }
    vector<pair<int, int>> ans;
    int fl = 1;
    for (int i = 2; i < n; ++i) {
        if (has.count({i, i + 1})) continue;
        ans.push_back({i, i + 1});

    }
    if (!has.count({1, 2})) {
        ans.push_back({1, 2});
    }
    cout << "Yes\n" << ans.size() << '\n';
    for (auto& e : ans) cout << e.first << ' ' << e.second << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;
    cin >> gr;
    while (t--) {
        solve();
    }
}
