#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

int gr;

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> has;
    for (int i = 0; i < m1; ++i) {
        int v, u;
        cin >> v >> u;
        has.insert({v, u});
        has.insert({u, v});
    }
    set<pair<int, int>> has2;
    for (int i = 0; i < m2; ++i) {
        int v, u;
        cin >> v >> u;
        has2.insert({v, u});
        has2.insert({u, v});
    }
    auto check = [&](set<pair<int, int>>& h) -> bool {
        vector<vector<int>> g2(n);
        for (auto& [x, y] : h) {
            g2[x - 1].push_back(y - 1);
        }
        vector<int> used(n);
        queue<int> q;
        q.push(0);
        int cnt = 1;
        used[0] = 1;
        while (q.size()) {
            int v = q.front();
            q.pop();
            for (auto& u : g2[v]) {
                if (!used[u]) {
                    q.push(u);
                    used[u] = 1;
                    ++cnt;
                }
            }
        }
        return cnt == n;
    };
    vector<pair<int, int>> ans;
    int fl = 1, fl1 = 0;
    for (int i = 2; i < n; ++i) {
        if (check(has)) {
            fl1 = 1;
            break;
        }
        if (has.count({i, i + 1})) continue;
        ans.push_back({i, i + 1});
        has.insert({i, i + 1});
        has.insert({i + 1, i});
        if (has2.count({i, i + 1})) {
            has2.erase({i, i + 1});
            has2.erase({i + 1, i});
        } else {
            has2.insert({i, i + 1});
            has2.insert({i + 1, i});
        }
        fl &= check(has2);
        if (check(has)) {
            fl1 = 1;
            break;
        }
    }
    if (!fl1) {
        if (!has.count({1, 2})) {
            ans.push_back({1, 2});
            has.insert({1, 2});
            has.insert({2, 1});
            if (!has2.count({1, 2})) {
                has2.insert({1, 2});
                has2.insert({2, 1});
            } else {
                has2.erase({1, 2});
                has2.erase({2, 1});
            }
            fl &= check(has2);
        }
    }
    if (!fl) {
        cout << "No\n";
        cout << 1 / 0;
        return;
    }
    cout << "Yes\n" << ans.size() << '\n';
    for (auto& e : ans) cout << e.first << ' ' << e.second << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;
    cin >> gr;
    while (t--) {
        solve();
    }
}
