#include<bits/stdc++.h>

#define pii pair < int, int >
#define pb push_back
#define int long long
#define F first
#define S second
#define endl "\n"
#define ins insert

using namespace std;


const int N = 3e3 + 10;
const int inf = 1e18;

int group;

struct DSU {
    int ind[N], sz[N];
    int e[N];
    set < pii > st[N];

    void init(int n) {
        for(int i = 1; i <= n; i++) {
            ind[i] = i, sz[i] = 1;
            st[i].clear();
            st[i].ins({1, i});
            e[i] = 1;
        }
    }
    int fnd(int x) {
        if(x == ind[x]) return x;
        else return ind[x] = fnd(ind[x]);
    }

    void unt(int x, int y) {
        int X = x, Y =y;

        x = fnd(x), y = fnd(y);
        if(x == y) return;

        st[x].erase({e[X], X});
        st[y].erase({e[Y], Y});

        e[X]++, e[Y]++;
        st[x].ins({e[X], X});
        st[y].ins({e[Y], Y});

        if(sz[x] < sz[y]) swap(x, y);
        sz[x] += sz[y];
        ind[y] = x;

        for(auto to : st[y]) st[x].ins(to);
        st[y].clear();


    }

    int get(int v) {
        v = fnd(v);
        return (*st[v].begin()).S;
    }
};
DSU d;
bool c1[N][N], c2[N][N];


void solve() {

     int n, m1, m2;
     cin >> n >> m1 >> m2;

     for(int i = 1; i <= n; i++)
        for(int j = 1; j <= n; j++)
        c1[i][j] = c2[i][j] = 0;
     vector < pii > p;
     for(int i = 1; i <= m1; i++) {
         int x, y;
         cin >> x >> y;

        if(x > y) swap(x, y);
        c1[x][y] = 1;
        p.pb({x, y});
     }

     for(int i = 1; i <= m2; i++) {
         int x, y;
         cin >> x >> y;

         if(x > y) swap(x, y);
         c2[x][y] = 1;
     }

     if(n == 3) {
         if(m1 >= 2 ){
            cout << "Yes" << endl;
            cout << 0 << endl;
            return;
         }

         if(m1 == 0) {
            cout << "No" << endl;
            return;
         }

         if(m2 == 3) {
            cout << "Yes" <<  endl << 1 << endl;
            cout << p[0].F << ' ' << 6 - p[0].F - p[0].S << endl;
            return;
         }

         if(!c2[p[0].F][p[0].S]) {
            cout << "No" << endl;
            return;
         }
    //     cout << c2[2][3] << ' '<< n << endl;
         cout << "Yes" << endl;
         cout << 1 << endl;
         for(int i = 1; i <= n; i++)
            for(int j = i + 1; j <= n; j++) {
    //                cerr << i << ' ' << j << ' ' << c2[i][j] << endl;
            if(!c2[i][j]) {
            cout << i << ' ' << j << endl;
            return;
         }
            }

         return;
     }
  if(group == 5) {
        vector < pii > op;


        op.pb({2, 4});

        for(int i = 2; i <= n; i++)
        if(!c1[i - 1][i]) {
            op.pb({i - 1, i});
        }

        cout << "Yes" << endl;
        cout << op.size() << endl;

        for(auto to : op) cout << to.F << ' ' << to.S << endl;
     }



     if(group == 2) {
    vector < pii > op;

     for(int i = 2; i <= n; i++)
     if(!c1[i - 1][i]) {
        op.pb({i - 1, i});
     }

     cout << "Yes" << endl;
     cout << op.size() << endl;

     for(auto to : op) cout << to.F << ' ' << to.S << endl;
     return;
     }





}
int32_t main() {

    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #else

    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int test;
    cin >> test >> group;

    while(test--)  solve();

    return 0;
}

