#include "bits/stdc++.h"

std::vector<int> used;
std::vector<std::vector<int>> g;
std::vector<int> comp;

void dfs(int v) {
    used[v] = true;
    for (auto &i : g[v]) {
        if (!used[i]) {
            dfs(i);
        }
    }
}

void not_main() {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    g.resize(n);
    used.resize(n);
    for (int i = 0; i < m1; ++i) {
        int a, b;
        std::cin >> a >> b;
        --a, --b;
        g[a].emplace_back(b);
        g[b].emplace_back(a);
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        std::cin >> a >> b;
        --a, --b;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            comp.emplace_back(i + 1);
            dfs(i);
        }
    }
    std::cout << "Yes\n" << (int) comp.size() - 1 << '\n';
    for (int i = 0; i < (int) comp.size() - 1; ++i) {
        std::cout << comp[i] << ' ' << comp[i + 1] << '\n';
    }
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
    int tests = 1, gr;
    std::cin >> tests >> gr;
    while (tests--) {
        not_main();
        used.clear();
        g.clear();
        comp.clear();
    }
    return 0;
}
