#include <bits/stdc++.h>
#define int long long
using namespace std;
auto sd = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(sd);

vector<vector<int>> g1, g2;
vector<int> used1, used2;

void dfs1(int v, int n) {
    used1[v] = 1;
    for (int i = 0; i < n; i++) {
        if (g1[v][i] == 1 && !used1[i]) dfs1(i, n);
    }
}
void dfs2(int v, int n) {
    used2[v] = 1;
    for (int i = 0; i < n; i++) {
        if (g2[v][i] == 1 && !used2[i]) dfs2(i, n);
    }
}
void solve(int g) {
    if (g == 1) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        g1 = g2 = vector<vector<int>> (n, vector<int> (n, 0));
        used1 = used2 = vector<int> (n, 0);
        for (int i = 0; i < m1; i++) {
            int u, v;
            cin >> u >> v;
            g1[u - 1][v - 1] = 1;
            g1[v - 1][u - 1] = 1;
        }
        for (int i = 0; i < m2; i++) {
            int u, v;
            cin >> u >> v;
            g2[u - 1][v - 1] = 1;
            g2[v - 1][u - 1] = 1;
        }
        int m = n * (n - 1) / 2;
        map<int, pair<int, int>> c;
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                c[cnt] = {i, j};
                cnt++;
            }
        }
        for (int i = 0; i < (1 << m); i++) {
            for (int j = 0; j < m; j++) {
                if ((i >> j) & 1) {
                    g1[c[j].first][c[j].second] = 1 - g1[c[j].first][c[j].second];
                    g2[c[j].first][c[j].second] = 1 - g2[c[j].first][c[j].second];
                    g1[c[j].second][c[j].first] = 1 - g1[c[j].second][c[j].first];
                    g2[c[j].second][c[j].first] = 1 - g2[c[j].second][c[j].first];
                }
            }
            used1.assign(n, 0);
            used2.assign(n, 0);
            dfs1(0, n);
            dfs2(0, n);
            bool flag = true;
            for (int j = 0; j < n; j++) {
                if (!used1[j] || !used2[j]) {
                    flag = false;
                    break;
                }
            }
            for (int j = 0; j < m; j++) {
                if ((i >> j) & 1) {
                    g1[c[j].first][c[j].second] = 1 - g1[c[j].first][c[j].second];
                    g2[c[j].first][c[j].second] = 1 - g2[c[j].first][c[j].second];
                    g1[c[j].second][c[j].first] = 1 - g1[c[j].second][c[j].first];
                    g2[c[j].second][c[j].first] = 1 - g2[c[j].second][c[j].first];
                }
            }
            if (flag) {
                cout << "Yes\n";
                int count = 0;
                for (int j = 0; j < m; j++) {
                    if ((i >> j) & 1) count++;
                }
                cout << count << '\n';
                while (i != 0) {
                    for (int j = 0; j < m; j++) {
                        if ((i >> j) & 1) {
                            g2[c[j].first][c[j].second] = 1 - g2[c[j].first][c[j].second];
                            g2[c[j].second][c[j].first] = 1 - g2[c[j].second][c[j].first];
                            used2.assign(n, 0);
                            dfs2(0, n);
                            bool flag2 = true;
                            for (int k = 0; k < n; k++) {
                                if (!used2[k]) {
                                    flag2 = false;
                                    break;
                                }
                            }
                            if (flag2) {
                                cout << c[j].first + 1 << ' ' << c[j].second + 1 << '\n';
                                i -= (1 << j);
                            }
                        }
                    }
                }
                return;
            }
        }
        cout << "No\n";
        return;
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, g;
    cin >> t >> g;
    while (t--) {
        solve(g);
    }
    return 0;
}
