#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <algorithm>
#include <random>
#include <iomanip>
#include <cmath>
#include <tuple>



using namespace std;
typedef long long ll;
typedef long double ld;

mt19937 rnd('c' + 'r' + 'i' + 'n' + 'g' + 'e');

#define int long long

void solveB() {
    int n; cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n; i++) cin >> d[i];
    for (int i = 0; i < n; i++) cin >> l[i];
    for (int i = 0; i < n; i++) cin >> r[i];
    int a0, b0; cin >> a0 >> b0;
    if (n <= 15) {
        int ans = 0;
        for (int i = 0; i < (1 << (n + 1)); i++) {
            vector<int> a(n + 1), b(n + 1);
            a[0] = a0, b[0] = b0;
            for (int j = 1; j <= n; j++) {
                a[j] = a[j - 1] + d[j - 1], b[j] = b[j - 1] + d[j - 1];

                if ((i >> j) & 1) a[j] = min(a[j], l[j - 1]);
                else b[j] = min(b[j], r[j - 1]);
            }
            ans = max(ans, a[n] + b[n]);
        }
        cout << ans;
    } else {
        vector<int> a(n + 1), b(n + 1);
        a[0] = a0, b[0] = b0;

    }
}

vector<set<int>> g1, g2;
vector<int> color, sz;
vector<bool> used;

void dfs(int u, int c) {
    used[u] = true; color[u] = c;
    for (int v : g1[u]) {
        if (!used[v]) dfs(v, c);
    }
 }

void solveA(int g) {
    int n, m1, m2; cin >> n >> m1 >> m2;
    g1.assign(n, {}), g2.assign(n, {});
    for (int i = 0; i < m1; i++) {
        int u, v; cin >> u >> v;
        u--, v--; g1[u].insert(v), g1[v].insert(u);
    }
    for (int i = 0; i < m2; i++) {
        int u, v; cin >> u >> v;
        u--, v--; g2[u].insert(v), g2[v].insert(u);
    }
    color.assign(n, 0), used.assign(n, false);
    int c = 1;

    vector<pair<int, int>> ans;
    for (int v = 0; v < n; v++) {
        if (!used[v]) dfs(v, c), c++;
    }
    int u1 = -1, u2 = -1;
    for (int j = 0; j < n; j++) {
        if (color[j] == 1 && u1 == -1) u1 = j;
        else if (color[j] == 1 && u2 == -1) u2 = j;
    }

    for (int i = 2; i < c; i++) {
        int v1 = -1, v2 = -1;
        for (int j = 0; j < n; j++) {
            if (color[j] == i && v1 == -1) v1 = j;
            else if (color[j] == i && v2 == -1) v2 = j;
        }
        if (g2[u1].find(v1) == g2[u1].end())  ans.push_back({u1,  v1});
        else if (g2[u1].find(v2) == g2[u1].end())  ans.push_back({u1,  v2});
        else if (g2[u2].find(v2) == g2[u2].end())  ans.push_back({u2,  v2});
        else ans.push_back({u2,  v1});
    }

    cout << ans.size() << endl;
    for (auto [u, v] : ans) cout << u + 1 << " " << v + 1 << endl;
}


void solveD() {
    int n; cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int t = 1, g; cin >> t >> g;
    while (t--) solveA(g);
}
