#include<bits/stdc++.h>
#define sz(a) (int)a.size()
//#define int long long

using namespace std;

int G;

vector<int> pr;

int get(int x) {
    if (pr[x] == x) {
        return x;
    }
    return pr[x] = get(pr[x]);
}

void unite(int a, int b) {
    a = get(a);
    b = get(b);
    if (a == b) return;
    pr[b] = a;
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    pr.clear();
    pr.resize(n);
    iota(pr.begin(), pr.end(), 0);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        unite(u, v);
    }
    vector<vector<int>> g(n, vector<int> (n));
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u][v] = g[v][u] = 1;
    }
    set<int> s;
    vector<int> idtc(n);
    for (int i = 0; i < n; ++i) {
        s.insert(get(i));
    }
    int id = 0;
    for (int i : s) {
        idtc[i] = id;
        ++id;
    }
    vector<vector<int>> comps(id);
    for (int i = 0; i < n; ++i) {
        comps[idtc[get(i)]].push_back(i);
    }
    vector<pair<int, int>> ans;
    int A = comps[0][0], B = comps[0][1];
    for (int i = 1; i < id; ++i) {
        int C = comps[i][0], D = comps[i][1];
        if (g[A][C] && g[A][D] && g[B][C] && g[B][D]) {
            ans.push_back({A, C});
            g[A][C] = g[C][A] = 0;
        }
        else {
            if (!g[A][C]) {
                ans.push_back({A, C});
                g[A][C] = g[C][A] = 1;
            }
            else if (!g[A][D]) {
                ans.push_back({A, D});
                g[A][D] = g[D][A] = 1;
            }
            else if (!g[B][C]) {
                ans.push_back({B, C});
                g[B][C] = g[C][B] = 1;
            }
            else {
                ans.push_back({B, D});
                g[B][D] = g[D][B] = 1;
            }
        }
    }
    cout << "Yes" << '\n';
    cout << sz(ans) << '\n';
    for (auto i : ans) {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t >> G;
    while (t--) {
        solve();
    }
}
