#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long double ld;
typedef long long ll;

#define int long long

//#pragma GCC optnimize("Ofast")
//#pragma GCC target("avx2")

void solve2() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> s;
    for (int i = 0; i < m1; i++) {
        int x, y;
        cin >> x >> y;
        s.insert({x, y});
        s.insert({y, x});
    }
    for (int i = 0; i < m2; i++) {
        int x, y;
        cin >> x >> y;
    }
    if (n == 2) {
        if (m1 == 1) {
            cout << "Yes\n0\n";
            return;
        } else {
            cout << "No\n";
            return;
        }
    }
    if (n == 3) {
        if (m1 == 0) {
            cout << "No\n";
            return;
        }
        if (m1 >= 2) {
            cout << "Yes\n" << 0 << '\n';
            return;
        }
        cout << "Yes\n";
        cout << 1 << '\n';
        for (int i = 1; i <= n; i++) {
            for (int j = i + 1; j <= n; j++) {
                if (s.count({i, j}) == 0) {
                    cout << i << ' ' << j << '\n';
                    return;
                }
            }
        }
    }
    cout << "Yes\n";
    vector<pair<int, int>> ans;
    for (int i = 1; i < n; i++) {
        if (s.count({i, i + 1}) == 0) {
            ans.push_back({i, i + 1});
        }
    }
    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i].first << ' ' << ans[i].second << '\n';
    }
}

vector<set<int>> g1, g2;
vector<int> par, ran;

int get(int v) {
    if (par[v] == v) return v;
    return par[v] = get(par[v]);
}

void merge(int v, int u) {
    v = get(v);
    u = get(u);
    if (u == v) return;
    if (ran[v] < ran[u]) swap(v, u);
    par[u] = v;
    if (ran[v] == ran[u]) ran[v]++;
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    par.assign(n, 0);
    ran.assign(n, 0);
    g1.assign(n, {});
    g2.assign(n, {});
    for (int i = 0; i < n; i++) par[i] = i;
    for (int i = 0; i < m1; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        g1[x].insert(y);
        g1[y].insert(x);
        merge(x, y);
    }
    for (int i = 0; i < m2; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        g2[x].insert(y);
        g2[y].insert(x);
    }
    if (n == 2) {
        if (m1 == 1) {
            cout << "Yes\n0\n";
        } else cout << "No\n";
        return;
    }
    vector<pair<int, int>> ans;
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (get(i) == get(j)) continue;
            if (g2[i].count(j) == 0) {
                merge(i, j);
                g1[i].insert(j);
                g1[j].insert(i);
                g2[i].insert(j);
                g2[j].insert(i);
                ans.push_back({i, j});
                cnt++;
            }
        }
    }
    unordered_set<int> s;
    for (int i = 0; i < n; i++) {
        s.insert(get(i));
    }
    if (s.size() == 1) {
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto [a, b]: ans) {
            cout << a + 1 << ' ' << b + 1 << '\n';
        }
        return;
    }
    if (s.size() > 3) {
        vector<int> q;
        for (int i = 0; i < n; i++) {
            q.push_back(get(i));
        }
        std::sort(q.begin(), q.end());
        set<pair<int, int>> need;
        for (int i = 0; i < s.size() - 1; i++) {
            need.insert({q[i], q[i + 1]});
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (need.count({get(i), get(j)})) {
                    ans.push_back({i, j});
                    need.erase({get(i), get(j)});
                }
            }
        }
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto [a, b]: ans) {
            cout << a + 1 << ' ' << b + 1 << '\n';
        }
        return;
    }
    if (s.size() == 2) {
        map<int, int> sz;
        for (int i = 0; i < n; i++) {
            sz[get(i)]++;
        }
        int ind = -1;
        for (auto [a, b]: sz) {
            if (b == 1) {
                ind = a;
                break;
            }
        }
        if (ind == -1) {
            bool find = 0;
            for (int i = 0; i < n; i++) {
                if (find) break;
                for (int j = 0; j < n; j++) {
                    if (get(i) != get(j)) {
                        ans.push_back({i, j});
                        find = 1;
                        break;
                    }
                }
            }
            cout << "Yes\n";
            cout << ans.size() << '\n';
            for (auto [a, b]: ans) {
                cout << a + 1 << ' ' << b + 1 << '\n';
            }
            return;
        }
        if (n == 3) {
            cout << "No\n";
            return;
        }
        int con = -1;
        for (int i = 0; i < n; i++) {
            if (con != -1) break;
            for (int j = 0; j < n; j++) {
                if (get(i) == get(j) && i != j) {
                    if (g1[i].count(j) + g2[i].count(j) == 0) {
                        con = i;
                        ans.push_back({i, j});
                        break;
                    }
                    if (g2[i].count(j) != 0) {
                        con = i;
                        break;
                    }
                }
            }
        }
        if (con == -1) {
            for (int i = 0; i < n; i++) {
                if (con != -1) break;
                for (int j = 0; j < n; j++) {
                    if (get(i) == get(j) && i != j) {
                        ans.push_back({i, j});
                        con = i;
                        break;
                    }
                }
            }
        }
        for (int i = 0; i < n; i++) {
            if (sz[get(i)] == 1) {
                ans.push_back({con, i});
                break;
            }
        }
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto [a, b]: ans) {
            cout << a + 1 << ' ' << b + 1 << '\n';
        }
        return;
    }
}

signed main() {
//    ios::sync_with_stdio(0);
//    cin.tie(0);
    int t, g;
    cin >> t >> g;
    while (t--) {
        if (g == 2) solve2();
        else solve();
    }
}