//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <vector>
#include <bits/stdc++.h>
using namespace std;




using ll = long long;


int bubble = 0;
#ifdef RODYA
#include "Templates/Debug Template.cpp"
#else
#define dbg(...) ++bubble;
#endif


#define int ll
#define vec vector
#define endl "\n"
#define eb emplace_back
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define all(x) x.begin(), x.end()

using pii = pair<int, int>;



const int N = 3e5 + 10;

int group;
int n, m1, m2;
vec<int> g2[N];
map<pii, bool> used;
bitset<N> is;



struct DSU {
    int pr[N];
    DSU() {
    }
    void init() {
        for (int i = 1; i <= n; ++i) pr[i] = i;
    }
    int getPr(int v) {
        if (v == pr[v]) return v;
        return pr[v] = getPr(pr[v]);
    }
    bool unite(int x, int y) {
        x = getPr(x), y = getPr(y);
        if (x == y) return false;
        pr[y] = x;
        return true;
    }
} dsu;





void input() {
    cin >> n >> m1 >> m2;


    for (int i = 1; i <= n; ++i)
        is[i] = false;
    dsu.init();
    used.clear();
    for (int i = 1; i <= n; ++i)
        g2[i].clear();


    for (int i = 0; i < m1; ++i) {
        int x, y; cin >> x >> y;
        dsu.unite(x, y);
        used[mp(x, y)] = used[mp(y, x)] = true;
    }

    for (int i = 0; i < m2; ++i) {
        int x, y; cin >> x >> y;
        g2[x].eb(y); g2[y].eb(x);
    }
}



void dfs(int v, int pr) {
    is[v] = true;
    for (auto& to : g2[v]) {
        if (is[to]) continue;
        used[mp(v, to)] = used[mp(to, v)] = true;
        dbg(v, to);
        dfs(to, v);
    }
}




void solve() {
    vec<pii> ans;
    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            if (used.find(mp(i, j)) != used.end()) continue;
            if (dsu.unite(i, j)) {
                ans.eb(i, j);
            }
        }
    }

    int cnt = 0;
    for (int i = 1; i <= n; ++i)
        if (dsu.getPr(i) == i) ++cnt;

    if (cnt != 1) {
        cout << "No" << endl;
        return;
    }


    cout << "Yes" << endl;
    cout << sz(ans) << endl;
    for (auto& [x, y] : ans) cout << x << " " << y << endl;
}


void test() {
    input();
    dfs(1, -1);
    solve();
}


signed main() {
#ifdef RODYA
    freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\bigTest.in", "r", stdin);
#else
    cin.tie(0), ios_base::sync_with_stdio(false);
#endif


    int t; cin >> t >> group;
    while (t--) test();

}
