#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define int long long
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/hash_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T>
//using ordered_set = tree<T, null_type, less<T>>;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

int n, m1, m2;
vector<int> used;
vector<vector<int>> g1, g2;

void dfs(int v, vector<vector<int>>& g) {
    used[v] = true;
    for (auto u: g[v]) {
        if (!used[u]) dfs(u, g);
    }
}

int calc_cs(set<pair<int, int>>& s) {
    g1.assign(n, {});
    for (auto [u, v]: s) {
        g1[u].push_back(v);
        g1[v].push_back(u);
    }
    used.assign(n, false); int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, g1), cnt++;
        }
    }
    return cnt;
}

bool isbr(set<pair<int, int>>& s, pair<int, int> e, int cs) {
    g1.assign(n, {});
    for (auto [u, v]: s) {
        if (u != e.first || v != e.second) {
            g1[u].push_back(v);
            g1[v].push_back(u);
        }
    }
    used.assign(n, false); int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            if (cnt >= cs) return true;
            dfs(i, g1), cnt++;
        }
    }
    return false;
}

void solve(int g) {
    cin >> n >> m1 >> m2;
    set<pair<int, int>> t1, t2, t3;
    for (int i = 0; i < m1; ++i) {
        int u, v; cin >> u >> v;
        --u, --v;
        if (u > v) swap(u, v);
        t1.emplace(u, v);
    }
    for (int i = 0; i < m2; ++i) {
        int u, v; cin >> u >> v;
        --u, --v;
        if (u > v) swap(u, v);
        t2.emplace(u, v);
    }
    for (int u = 0; u < n; ++u) {
        for (int v = u + 1; v < n; ++v) {
            if (t2.find({u, v}) == t2.end()) t3.emplace(u, v);
        }
    }
    if (g == 2) {
        if (n == 3 && m1 == 0) {
            cout << "No\n";
            return;
        }
        cout << "Yes\n";
        if (n == 3 && m1 == 2) {
            cout << "0\n";
            return;
        }
        else if (n == 3 && m1 == 1) {
            if (t1.find({0, 1}) == t1.end()) {
                cout << "1\n1 2\n";
            } else {
                cout << "1\n2 3\n";
            }
            return;
        }
        else {
            vector<pair<int, int>> res;
            for (int i = 0; i < n - 1; ++i) {
                if (t1.find({i, i + 1}) == t1.end()) {
                    res.emplace_back(i + 1, i + 2);
                }
            }
            cout << (int)res.size() << '\n';
            for (auto [u, v]: res) cout << u << ' ' << v << '\n';
            return;
        }
    } else if (g <= 1) {
        int e = n * (n - 1) / 2;
        bool flag = false;
        for (int i = 0; i < (1 << e); ++i) {
            g1.assign(n, {});
            g2.assign(n, {});
            int ts = 0;
            vector<pair<int, int>> res1, res2;
            for (int u = 0; u < n; ++u) {
                for (int v = u + 1; v < n; ++v) {
                    int x = ((i >> (ts + v - u - 1)) & 1);
                    int y = (t1.find({u, v}) != t1.end()) ? 1: 0;
                    int z = (t2.find({u, v}) != t2.end()) ? 1: 0;
                    if ((x ^ y) == 1) {
                        g1[v].push_back(u);
                        g1[u].push_back(v);
                    }
                    if ((x ^ z) == 1) {
                        g2[v].push_back(u);
                        g2[u].push_back(v);
                    }
                    if (x == 1 && z == 0) res1.emplace_back(u + 1, v + 1);
                    else if (x == 1) res2.emplace_back(u + 1, v + 1);
                }
                ts += n - u - 1;
            }
            int cnt1 = 0, cnt2 = 0;
            used.assign(n, false);
            for (int v = 0; v < n; ++v) {
                if (!used[v]) {
                    dfs(v, g1);
                    cnt1++;
                }
            }
            used.assign(n, false);
            for (int v = 0; v < n; ++v) {
                if (!used[v]) {
                    dfs(v, g2);
                    cnt2++;
                }
            }
            if (cnt1 == 1 && cnt2 == 1 && (int)res1.size() + (int)res2.size() <= n) {
                cout << "Yes\n" << (int)res1.size() + (int)res2.size() << '\n';
                for (auto [u, v]: res1) cout << u << ' ' << v << '\n';
                for (auto [u, v]: res2) cout << u << ' ' << v << '\n';
                flag = true;
                break;
            }
        }
        if (!flag) {
            cout << "No\n";
        }
        return;
    } else if (g == 3) {
        g1.assign(n, {});
        for (auto [u, v]: t1) {
            g1[u].push_back(v);
            g1[v].push_back(u);
        }
        used.assign(n, false);
        dfs(0, g1);
        auto cc = used;
        vector<pair<int, int>> br1, br2, nbr1, nbr2;
        int ccc = calc_cs(t1);
        for (auto [u, v]: t1) {
            if (isbr(t1, {u, v}, ccc)) br1.emplace_back(u, v);
            else nbr1.emplace_back(u, v);
        }
        int cccc = calc_cs(t2);
        for (auto [u, v]: t2) {
            if (isbr(t2, {u, v}, cccc)) br2.emplace_back(u, v);
            else nbr2.emplace_back(u, v);
        }
        for (auto [u, v]: nbr2) {
            if (cc[u] != cc[v]) {
                cout << "Yes\n1\n" << u + 1 << ' ' << v + 1 << '\n';
                return;
            }
        }
        for (auto [u, v]: t3) {
            if (cc[u] != cc[v]) {
                cout << "Yes\n1\n" << u + 1 << ' ' << v + 1 << '\n';
                return;
            }
        }
        for (auto [u, v]: br2) {
            if (cc[u] == cc[v]) continue;
            isbr(t2, {u, v}, cccc);
            auto cc2 = used;
            for (auto [uu, vv]: nbr1) {
                if (cc2[uu] != cc2[vv]) {
                    cout << "Yes\n2\n" << uu + 1 << ' ' << vv + 1 << '\n' << u + 1 << ' ' << v + 1 << '\n';
                    return;
                }
            }
        }
        cout << "No\n";
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/d.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
#endif
    int g; cin >> _t >> g;
    while (_t--) solve(g);
}