#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(x) x.begin(), x.end()


mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

double gen_real() {
    return rnd() % 100'000 / (double)100'000;
}

const int mxN = 3001; //3e5 + 500;
int mat1[mxN][mxN], mat2[mxN][mxN];
bool vis1[mxN], vis2[mxN];
int n;
void dfs1(int v) {
    vis1[v] = true;
    for (int u = 0; u < n; ++u) {
        if (!vis1[u] && mat1[u][v]) {
            dfs1(u);
        }
    }
}

void dfs2(int v) {
    vis2[v] = true;
    for (int u = 0; u < n; ++u) {
        if (!vis2[u] && mat2[u][v]) {
            dfs2(u);
        }
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int tt, g;
    cin >> tt >> g;
    while (tt --> 0) {
        int m1, m2;
        cin >> n >> m1 >> m2;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                mat1[i][j] = mat2[i][j] = 0;
            }
        }
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v, --u, --v;
            mat1[u][v] = mat1[v][u] = 1;
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v, --u, --v;
            mat2[u][v] = mat2[v][u] = 1;
        }
        auto Rev1 = [&](int i, int j) {
 mat1[i][j] ^= 1;
                                mat1[j][i] = mat1[i][j];
        };
        auto Rev2 = [&](int i, int j) {
 mat2[i][j] ^= 1;
                                mat2[j][i] = mat2[i][j];
        };
        auto Rev = [&](int i, int j) {
            Rev1(i, j); Rev2(i, j);
        };
        auto Count1 = [&]() {
            fill(vis1, vis1 + n, false);
            dfs1(0);
            return count(vis1, vis1 + n, true);
        };
        
        auto Count2 = [&]() {
            fill(vis2, vis2 + n, false);
            dfs2(0);
            return count(vis2, vis2 + n, true);
        };
        vector<pair<int, int>> res(n);
        for (int i = 0; i < n; ++i) {
            do {
                res[i] = {rnd() % n, rnd() % n};
            } while (res[i].first == res[i].second);

        }
        for (int iter = 0; iter < 5000; ++iter) {
            for (int i = 0; i < n; ++i) {
                do {
                    res[i] = {rnd() % n, rnd() % n};
                } while (res[i].first == res[i].second);

            }
            bool ok = true;
            for (int i = 0; i < n; ++i) {
                Rev(res[i].first, res[i].second);
                if (Count2() < n) {
                    ok = false;
                }
            }
            if (!ok) {
                for (int i = 0; i < n; ++i) {
                    Rev(res[i].first, res[i].second);
                }
                continue;
            }
            if (Count1() == n) {
                break;
            }
            for (int i = 0; i < n; ++i) {
                Rev(res[i].first, res[i].second);
            }
        }

        if (Count1() == n) {
            cout << "Yes\n";
            cout << res.size() << '\n';
            for (auto e : res) {
                cout << e.first + 1 << ' ' << e.second + 1 << '\n';
            }
        } else {
            cout << "No\n";
        }
    }
    return 0;
}