#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const ll INF = 1e9;
const ll N = 2005;
const ll MOD = 1e9 + 7;
const ll M = 10005; // !!!!!!!!!!!!!!!!!!!!!!!1

mt19937 gen(time(0));

ll group;

set<pair<ll, ll>> e1, e2;
vector<set<ll>> g1, g2;

void add(ll u, ll v) {
    if (e1.find({u, v}) != e1.end()) {
        e1.erase({u, v});
        e1.erase({v, u});
        g1[u].erase(v);
        g1[v].erase(u);
    } else {
        g1[u].insert(v);
        g1[v].insert(u);
        e1.insert({u, v});
        e1.insert({v, u});
    }
    if (e2.find({u, v}) != e2.end()) {
        e2.erase({u, v});
        e2.erase({v, u});
        g2[u].erase(v);
        g2[v].erase(u);
    } else {
        g2[u].insert(v);
        g2[v].insert(u);
        e2.insert({u, v});
        e2.insert({v, u});
    }
}

void dfs(ll v, vector<bool>& used, vector<ll>& comp) {
    used[v] = true;
    comp.push_back(v);
    for (auto to : g1[v]) {
        if (!used[to]) {
            dfs(to, used, comp);
        }
    }
}

void solve() {
    ll n, m1, m2; cin >> n >> m1 >> m2;
    e1.clear();
    e2.clear();
    g1.assign(n, {}); g2.assign(n, {});
    for (int i = 0; i < m1; i++) {
        ll u, v; cin >> u >> v;
        u--; v--;
        g1[u].insert(v);
        g1[v].insert(u);
        e1.insert({u, v});
        e1.insert({v, u});
    }
    for (int i = 0; i < m2; i++) {
        ll a, b; cin >> a >> b;
        a-- ;b--;
        g2[a].insert(b);
        g2[b].insert(a);
        e2.insert({a, b});
        e2.insert({b, a});
    }


    if (group == 2) {
        if (n == 3) {
            bool ok = false;
            vector<pair<ll, ll>> good, bad, all;
            for (int i = 0; i < n; i++) {
                for (int j = i + 1; j < n; j++) {
                    ll val1 = (e1.find({i, j}) != e1.end());
                    ll val2 = (e2.find({i, j}) != e2.end());
                    if (val1 + val2 != 1) {
                        good.push_back({i, j});
                        ok = true;
                    } else {
                        bad.push_back({i, j});
                    }
                    all.push_back({i, j});
                }
            }
            if (!ok) {
                cout << "No" << '\n';
            } else {
                if (m1 >= 2) {
                    cout << "Yes" << '\n';
                    cout << 0 << '\n';
                } else if (m1 == 1) {
                    cout << "Yes" << '\n';
                    if (m2 == 3) {
                        cout << 1 << '\n';
                        cout << bad[0].first + 1 << " " << bad[0].second + 1 << '\n';
                    } else {
                        cout << 2 << '\n';
                        cout << bad[0].first + 1 << " " << bad[0].second + 1 << '\n';
                        if (e1.find({good[0].first, good[0].second}) == e1.end()) {
                            cout << good[0].first + 1 << " " << good[0].second + 1 << '\n';
                        } else {
                            cout << good[1].first + 1 << " " << good[1].second + 1 << '\n';
                        }
                    }
                } else {
                    cout << "Yes" << '\n';
                    cout << 2 << '\n';
                    cout << good[0].first + 1 << " " << good[0].second + 1 << '\n';
                    cout << bad[0].first + 1 << " " << bad[0].second + 1 << '\n';
                }
            }

            return;
        }

        cout << "Yes" << '\n';
        vector<pair<ll, ll>> ans;
        for (int i = 1; i < n - 1; i++) {
            if (e1.find({0, i}) == e1.end()) {
                ans.push_back({0, i});
            }
        }
        if (e1.find({n - 2, n - 1}) == e1.end()) {
            ans.push_back({n - 2, n - 1});
        }
        cout << ans.size() << '\n';
        for (auto [u, v] : ans) {
            cout << u + 1 << " " << v + 1 << '\n';
        }
    } else if (group == 3) {
        if (n == 3) {
            bool ok = false;
            vector<pair<ll, ll>> good, bad, all;
            for (int i = 0; i < n; i++) {
                for (int j = i + 1; j < n; j++) {
                    ll val1 = (e1.find({i, j}) != e1.end());
                    ll val2 = (e2.find({i, j}) != e2.end());
                    if (val1 + val2 != 1) {
                        good.push_back({i, j});
                        ok = true;
                    } else {
                        bad.push_back({i, j});
                    }
                    all.push_back({i, j});
                }
            }
            if (!ok) {
                cout << "No" << '\n';
            } else {
                if (m1 >= 2) {
                    cout << "Yes" << '\n';
                    cout << 0 << '\n';
                } else if (m1 == 1) {
                    cout << "Yes" << '\n';
                    if (m2 == 3) {
                        cout << 1 << '\n';
                        cout << bad[0].first + 1 << " " << bad[0].second + 1 << '\n';
                    } else {
                        cout << 2 << '\n';
                        cout << bad[0].first + 1 << " " << bad[0].second + 1 << '\n';
                        if (e1.find({good[0].first, good[0].second}) == e1.end()) {
                            cout << good[0].first + 1 << " " << good[0].second + 1 << '\n';
                        } else {
                            cout << good[1].first + 1 << " " << good[1].second + 1 << '\n';
                        }
                    }
                } else {
                    exit(-1);
                    cout << "Yes" << '\n';
                    cout << 2 << '\n';
                    cout << good[0].first + 1 << " " << good[0].second + 1 << '\n';
                    cout << bad[0].first + 1 << " " << bad[0].second + 1 << '\n';
                }
            }

            return;
        }

        vector<bool> used(n, false);
        vector<vector<ll>> cmp;
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                vector<ll> cur;
                dfs(i, used, cur);
                cmp.push_back(cur);
            }
        }
        assert(cmp.size() == 2);
        for (auto u : cmp[0]) {
            for (auto v : cmp[1]) {
                if (e2.find({u, v}) == e2.end()) {
                    cout << "Yes" << '\n';
                    cout << 1 << '\n';
                    cout << u + 1 << " " << v + 1 << '\n';
                    return;
                }
            }
        }
        if (cmp[0].size() > cmp[1].size()) swap(cmp[0], cmp[1]);
        if (cmp[0].size() != 1) {
            cout << "Yes" << '\n';
            cout << 1 << '\n';
            cout << cmp[0][0] + 1 << " " << cmp[1][0] + 1 << '\n';
        } else {
            vector<pair<ll, ll>> ans;
            if (m2 >= n) {
                for (auto [u, v]: e2) {
                    if (u != cmp[0][0] && v != cmp[0][0]) {
                        cout << "Yes" << '\n';
                        cout << 1 << '\n';
                        cout << u + 1 << " " << cmp[0][0] + 1 << '\n';
                        return;
                    }
                }
            } else {
                for (int i = 0; i < 3; i++) {
                    for (int j = i + 1; j < 3; j++) {
                        if (e1.find({cmp[1][i], cmp[1][j]}) == e1.end()) {
                            cout << "Yes" << '\n';
                            cout << 2 << '\n';
                            cout << cmp[1][i] + 1 << " " << cmp[1][j] + 1 << '\n';
                            cout << cmp[0][0] + 1 << " " << cmp[1][i] + 1 << '\n';
                            return;
                        }
                    }
                }
                cout << "Yes" << '\n';
                cout << 2 << '\n';
                cout << cmp[1][0] + 1 << " " << cmp[1][1] + 1 << '\n';
                cout << cmp[0][0] + 1 << " " << cmp[1][0] + 1 << '\n';
            }

        }

    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    ll tst; cin >> tst;
    cin >> group;
    while (tst--) {
        solve();
    }
}