#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target_tbl("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

#define int long long
#define ll long long
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define line cout << '\n'

#define sz(v) ((int)(v).size())
const double pi = 3.1415926535897932384626433832795;

const long long mod = 1e9 + 7;
const long long inf = 1099999999999999999;
const long long nmax = 2e3 + 100;
const long long Q = 100;

random_device rd;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

//clock_t start;
//while ((ld)(clock() - start) / CLOCKS_PER_SEC < 0.00001) {
//cout << "amogus\n";
//}
//start = clock();

int G;
vector<vector<int>> g1(nmax), g2(nmax);
vector<vector<int>> s1(nmax), s2(nmax);

vector<bool> used1(nmax), used2(nmax);

void check1(int v) {
    used1[v] = true;
    for (auto to : s1[v])
        if (!used1[to])
            check1(to);
}

void check2(int v) {
    used2[v] = true;
    for (auto to : s2[v])
        if (!used2[to])
            check2(to);
}

void runtimeerror() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    int pairr1 = 0, pairr2 = 0;
    set<pair<int, int>> st1, st2;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        st1.insert({ min(u, v), max(u, v) });
        pairr1 = u, pairr2 = v;
        g1[u].emplace_back(v);
        g1[v].emplace_back(u);
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        st2.insert({ min(u, v), max(u, v) });
        g2[u].emplace_back(v);
        g2[v].emplace_back(u);
    }

    if (G == 1) {
        vector<pair<int, int>> p;
        for (int i = 1; i < n; i++)
            for (int j = i + 1; j <= n; j++)
                p.emplace_back(i, j);
        for (int mask = 0; mask < (1LL << sz(p)); mask++) {
            vector<pair<int, int>> p1, p2;
            for (int i = 0; i < sz(p); i++) {
                if ((mask >> i) & 1) {
                    if (st2.find(p[i]) == st2.end())
                        p1.emplace_back(p[i]);
                    else
                        p2.emplace_back(p[i]);
                }
            }
            if (sz(p1) + sz(p2) > n) continue;
            
            for (int i = 1; i <= n; i++) {
                used1[i] = used2[i] = false;
                s1[i].clear();
                s2[i].clear();
            }
            for (int i = 0; i < sz(p1); i++) {
                if (st1.find(p1[i]) == st1.end()) {
                    s1[p1[i].first].emplace_back(p1[i].second);
                    s1[p1[i].second].emplace_back(p1[i].first);
                }
                s2[p1[i].first].emplace_back(p1[i].second);
                s2[p1[i].second].emplace_back(p1[i].first);
            }
            for (int i = 0; i < sz(p2); i++) {
                if (st1.find(p2[i]) == st1.end()) {
                    s1[p2[i].first].emplace_back(p2[i].second);
                    s1[p2[i].second].emplace_back(p2[i].first);
                }
            }

            check1(1);
            check2(1);
            
            bool flag = true;
            for (int i = 1; i <= n; i++) {
                if (!used1[i] || !used2[i]) {
                    flag = false;
                    break;
                }
            }
            
            if (flag) {
                cout << "Yes" << '\n';
                cout << sz(p1) + sz(p2) << '\n';
                for (auto e : p1)
                    cout << e.first << ' ' << e.second << '\n';
                for (auto e : p2)
                    cout << e.first << ' ' << e.second << '\n';
                line;
                return;
            }
        }
        cout << "No" << '\n';
        return;
    }
    if (G == 2) {
        if (n > 3) {
            cout << "Yes" << '\n';
            vector<pair<int, int>> ans;
            for (int i = 1; i < n; i++)
                if (st1.find({ i, i + 1 }) == st1.end())
                    ans.emplace_back(i, i + 1);
            cout << sz(ans) << '\n';
            for (auto e: ans)
                cout << e.first << ' ' << e.second << '\n';
            line;
        } else {
            if (m1 == 0) {
                cout << "No" << '\n';
            } else if (m1 >= 2) {
                cout << "Yes" << '\n';
                cout << 0 << '\n';
            } else {
                cout << "Yes" << '\n';
                cout << 1 << '\n';
                if (pairr1 > pairr2) swap(pairr1, pairr2);
                if (pairr1 == 1 && pairr2 == 2) cout << "1 3\n";
                else if (pairr1 == 1 && pairr2 == 3) cout << "1 2\n";
                else cout << "1 2\n";
            }
        }
        return;
    }
    cout << "No" << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t_ = 1;
    cin >> t_ >> G;
    while (t_--)
        runtimeerror();
    //  cout << "WINNER";
    //  I'm stupid man
}
