#pragma GCC optimize("avx2")
#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
using namespace __gnu_pbds;

// #define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

typedef long long ll;

struct DSU {
    int n, ct;
    vector<int> sz, p;
    DSU (int n) : n(n) {
        ct = n;
        sz.resize(n, 1);
        p.resize(n);
        iota(all(p), 0);
    }

    int gt(int a) {
        if (p[a] == a) return a;
        p[a] = gt(p[a]);
        return p[a];
    }

    void merge(int a, int b) {
        a = gt(a);
        b = gt(b);
        if (a == b) return;
        ct--;
        if (sz[a] > sz[b]) {
            sz[a] += sz[b];
            p[b] = a;
        }
        else {
            sz[b] += sz[a];
            p[a] = b;
        }
    }

    bool check(int a, int b) {
        return gt(a) == gt(b);
    }
};

mt19937 rnd(1329);


void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    map<pair<int, int>, int> au;
    vector<pair<int, int>> edges;
    DSU frst(n);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        edges.push_back({u, v});
        if (frst.check(u, v)) continue;
        frst.merge(u, v);
        au[{u, v}] += 1;
        au[{v, u}] += 1;
    }
    DSU secnd(n);
    map<int, int> ctt;
    int fuckedd = -1;
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        edges.push_back({u, v});
        if (secnd.check(u, v)) continue;
        ctt[u]++;
        ctt[v]++;
        if (ctt[u] == n - 1) fuckedd = u;
        if (ctt[v] == n - 1) fuckedd = v;
        secnd.merge(u, v);
        au[{u, v}] += 2;
        au[{v, u}] += 2;
    }
    if (n == 3 && m1 + m2 == 3) {
        sort(all(edges));
        vector<pair<int, int>> fucked = {{0, 1}, {0, 2}, {1, 2}};
        if (edges == fucked) {
            cout << "No\n";
            return;
        }
    }
    vector<pair<int, int>> ans;
    if (fuckedd != -1) {
        bool ok = 0;
        for (int i = 0; i < n; ++i) {
            if (i == fuckedd) continue;
            if (au[{i, fuckedd}] == 3) {
                ok = 1;
            }
        }
        if (!ok) {
            if (m2 >= n) {
                for (int i = m1; i < m1 + m2; ++i) {
                    if (edges[i].first != fuckedd && edges[i].second != fuckedd) {
                        au[{fuckedd, edges[i].first}] -= 2;
                        au[{edges[i].first, fuckedd}] -= 2;
                        au[{edges[i].first, edges[i].second}] += 2;
                        au[{edges[i].second, edges[i].first}] += 2;
                        break;
                    }
                }
            }
            else {
                for (int u = 0; u < n; ++u) {
                    bool breakk = 0;
                    for (int v = 0; v < n; ++v) {
                    if (u == v) continue;
                    if (u == fuckedd || v == fuckedd) continue;
                    if (au[{u, v}] == 1) continue;
                    au[{fuckedd, u}] -= 2;
                    au[{u, fuckedd}] -= 2;
                    au[{u, v}] += 2;
                    au[{v, u}] += 2;
                    ans.push_back({u, v});
                    frst.merge(u, v);
                    breakk = 1;
                    break;
                    }
                    if (breakk) break;
                }
            }
        }
    }
    vector<int> ord(n);
    iota(all(ord), 0);
    shuffle(all(ord), rnd);
    for (auto u : ord) {for (int v = 0; v < n; ++v) {
        if (frst.check(u, v) || au[{u, v}] == 2) continue;
        ans.push_back({u, v});
        frst.merge(u, v);
    }
    if (frst.ct == 1) break;
    }
    if ((ans.size() > n || frst.ct > 1)) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto e : ans) cout << e.first + 1 << ' ' << e.second + 1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int t, g;
    cin >> t >> g;
    while (t--) solve();
}