nclude <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using str = string;

ll maxn = 3e5 + 1;
vector <vector <ll>> g1(maxn);
vector <vector <ll>> g2(maxn);

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll tt, gg;
	cin >> tt >> gg;
	if (gg == 9) {
		while (tt > 0) {
			ll n, m1, m2;
			cin >> n >> m1 >> m2;
			set <pair <ll, ll>> st;
			for (int i = 0; i < m1; i++) {
				ll v, u;
				cin >> v >> u;
				st.insert({ min(v, u), max(v, u) });
				g1[v].push_back(u);
				g1[u].push_back(v);
			}
			for (int i = 0; i < m2; i++) {
				ll v, u;
				cin >> v >> u;
				g2[v].push_back(u);
				g2[u].push_back(v);
			}
			vector <pair <ll, ll>> ans;
			for (int i = 1; i <= n - 2; i += 2) {
				if (st.count({ i, i + 2 }) == 0) {
					ans.push_back({ i, i + 2 });
				}
			}
			for (int i = 2; i <= n - 2; i += 2) {
				if (st.count({ i, i + 2 }) == 0) {
					ans.push_back({ i, i + 2 });
				}
			}
			if (st.count({ 1, 2 }) == 0) {
				ans.push_back({ 1, 2 });
			}
			cout << ans.size() << '\n';
			for (int i = 0; i < ans.size(); i++) {
				cout << ans[i].first << ' ' << ans[i].second << '\n';
			}
			st.clear();
		}
	}
}