#include <bits/stdc++.h>
#define int long long
typedef long long ll;
typedef __int128 ull;
using namespace std;

vector<vector<int>> g1, g2;
vector<int> used;
int n, m1, m2;

void dfs1(int v) {
    used[v] = 1;
    for (int u = 0; u < n; u++) {
        if (g1[v][u] && !used[u]) dfs1(u);
    }
}

void dfs2(int v) {
    used[v] = 1;
    for (int u = 0; u < n; u++) {
        if (g2[v][u] && !used[u]) dfs2(u);
    }
}

mt19937 mt1(1329);

void stupid_solve() {
    cin >> n >> m1 >> m2;
//    cout << n << endl;
    g1.assign(n, vector<int> (n, 0));
    g2.assign(n, vector<int> (n, 0));
    used.assign(n, 0);
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g1[u][v] = 1;
        g1[v][u] = 1;
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g2[u][v] = 1;
        g2[v][u] = 1;
    }


//    used.assign(n, 0);
//    dfs1(0);
//    int mn1 = *min_element(used.begin(), used.end());
//    used.assign(n, 0);
//    dfs2(0);
//    int mn2 = *min_element(used.begin(), used.end());
//
//    if (mn1 + mn2 == 2) {
//        cout << "Yes\n0\n";
//        return;
//    }


    vector<pair<int, int>> roots;
    shuffle(roots.begin(), roots.end(), mt1);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            roots.emplace_back(i, j);
        }
    }

//    cout
//    ze() << endl;
    vector<int> ans(100, -1);
    for (int msk = 0; msk < (1ll << roots.size()); msk++) {
        //cout << msk << endl;
        bitset<30> b(msk);
        for (int i = 0; i < roots.size(); i++) {
            if (b[i]) {
                auto [x, y] = roots[i];
                g1[x][y] = !g1[x][y];
                g2[x][y] = !g2[x][y];

                g1[y][x] = !g1[y][x];
                g2[y][x] = !g2[y][x];
            }
        }
        used.assign(n, 0);
        dfs1(0);
        if (*min_element(used.begin(), used.end()) == 0) {

            for (int i = 0; i < roots.size(); i++) {
                if (b[i]) {
                    auto [x, y] = roots[i];
                    g1[x][y] = !g1[x][y];
                    g2[x][y] = !g2[x][y];

                    g1[y][x] = !g1[y][x];
                    g2[y][x] = !g2[y][x];
                }
            }
            continue;
        }
        used.assign(n, 0);
        dfs2(0);
        if (*min_element(used.begin(), used.end()) == 1) {
            vector<int> loc_ans;
            for (int i = 0; i < roots.size(); i++) {
                if (b[i]) {
                    loc_ans.push_back(i);
                }
            }
            if (ans.size() > loc_ans.size()) {
                ans = loc_ans;
            }
        }
        for (int i = 0; i < roots.size(); i++) {
            if (b[i]) {
                auto [x, y] = roots[i];
                g1[x][y] = !g1[x][y];
                g2[x][y] = !g2[x][y];

                g1[y][x] = !g1[y][x];
                g2[y][x] = !g2[y][x];
            }
        }
    }

    if (ans.size() > n) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n" << ans.size() << "\n";
    for (int i : ans) {
        cout << roots[i].first + 1 << " " << roots[i].second + 1 << "\n";
    }
}


signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt, g;
    cin >> tt >> g;


    while (tt--) {
        if (g <= 1) stupid_solve();
    }
}
