#include "bits/stdc++.h"

#define int long long
#define ull unsigned long long
#define ld long doublt
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

int g;

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<bool>> used1(n, vector<bool> (n, false)),
                         used2(n, vector<bool> (n, false));
    for (int i = 0; i < m1; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        used1[v][u] = used1[u][v] = true;
    }
    for (int i = 0; i < m2; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        used2[v][u] = used2[u][v] = true;
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < n - 1; ++i) {
        if (!used1[i][i + 1]) {
            ans.emplace_back(i + 1, i + 2);
        }
    }
    cout << "Yes\n" << sz(ans) << '\n';
    for (pair<int, int> i : ans) {
        cout << i.first << ' ' << i.second << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    cin >> tt >> g;
    while (tt--) {
        solve();
    }
}