#include <bits/stdc++.h>
#define ll long long
using namespace std;
ll n;
vector<unordered_set<ll>>G1;
vector<unordered_set<ll>>G2;
vector<vector<ll>>Tr;
vector<pair<ll,ll>>Ans;
vector<pair<bool,vector<ll>>>megaAns;
vector<bool>used;
void makeAns(){
    megaAns.push_back({true,{}});
    megaAns[megaAns.size()-1].second.push_back(Ans.size());
    for(auto elem:Ans){
        megaAns[megaAns.size()-1].second.push_back(elem.first+1);
        megaAns[megaAns.size()-1].second.push_back(elem.second+1);
    }
    Ans.clear();
}
void dfs(ll v){
    used[v]=true;
    for(auto t:G2[v]){
        if(!used[t]){
            Tr[v].push_back(t);
            Tr[t].push_back(v);
            dfs(t);
        }
    }
}
bool checkez(){
    for(ll i=0;i<n;i++){
        if(Tr[i].size()!=1 and Tr[i].size()!=n-1){
            return false;
        }
    }
    return true;
}
void solveez(){
    for(ll i=1;i<n-1;i++){
        if(!G1[i].count(i+1)) {
            Ans.push_back({i, i+1});
        }
    }
    if(!G1[0].count(1)) {
        Ans.push_back({0,1});
    }
}
void solve3(){
    if(G2[0].size()==2 and G2[1].size()==2){
        if(G1[0].empty() and G1[1].empty()){
            megaAns.push_back({false,{}});
            return;
        }
        else{
            if(G1[0].count(1)){
                if(!G1[0].count(2)){
                    megaAns.push_back({true,{1,1,3}});
                }
                else{
                    megaAns.push_back({true,{0}});
                }
            }
            else{
                megaAns.push_back({true,{1,1,2}});
            }
        }
    }
    else{
        if(G2[0].size()==2 and G2[1].size()==1){
            if(!G1[1].count(2)) {
                G1[1].insert(2);
                G1[2].insert(1);
                Ans.push_back({1, 2});
            }
        }
        else if(G2[0].size()==1 and G2[1].size()==2){
            if(G1[0].count(2)) {
                G1[0].insert(2);
                G1[2].insert(0);
                Ans.push_back({0, 2});
            }
        }
        else if(G2[0].size()==1 and G2[1].size()==1){
            if(!G1[0].count(1)) {
                G1[0].insert(1);
                G1[1].insert(0);
                Ans.push_back({0, 1});
            }
        }
        if(min(G1[0].size(),G1[1].size()) and !G1[2].empty()){
            makeAns();
        }
        else{
            megaAns.push_back({false,{}});
        }
    }
}
void solve(){
    ll m1,m2,a,b;
    cin>>n>>m1>>m2;
    G1.clear();
    G1.resize(n,{});
    G2.clear();
    G2.resize(n,{});
    Tr.clear();
    Tr.resize(n,{});
    used.clear();
    used.resize(n,false);
    Ans.clear();
    for(ll i=0;i<m1;i++){
        cin>>a>>b;
        a--,b--;
        G1[a].insert(b);
        G1[b].insert(a);
    }
    for(ll i=0;i<m2;i++){
        cin>>a>>b;
        a--,b--;
        G2[a].insert(b);
        G2[b].insert(a);
    }
    if(n==3){
        solve3();
        return;
    }
    dfs(0);
    solveez();
    makeAns();
    return;
    ll list;
    for(ll i=0;i<n;i++){
        if(Tr[i].size()==1){
            list=i;
            break;
        }
    }
    ll bd=Tr[list][0];
    for(ll i=0;i<n;i++){
        if(i!=list and bd!=i){
            if(!G1[list].count(i)) {
                Ans.push_back({list, i});
            }
        }
    }
    vector<bool>A(n);
    for(auto elem:Tr[bd]){
        A[elem]=true;
    }
    for(ll i=0;i<n;i++){
        if(!A[i] and i!=bd){
            if(!G1[i].count(bd)){
                Ans.push_back({i,bd});
                break;
            }
        }
    }
    makeAns();
}
int main() {
    //freopen("in.txt","r",stdin);
    //freopen("out.txt","w",stdout);
    ll t,g;
    cin>>t>>g;
    for(ll i=0;i<t;i++){
        //solve();
        ll m1,m2,a,b;
        cin>>n>>m1>>m2;
        G1.clear();
        G1.resize(n,{});
        G2.clear();
        G2.resize(n,{});
        for(ll j=0;i<m1;i++){
            cin>>a>>b;
            a--,b--;
            G1[a].insert(b);
            G1[b].insert(a);
        }
        for(ll j=0;i<m2;i++){
            cin>>a>>b;
            a--,b--;
            G2[a].insert(b);
            G2[b].insert(a);
        }
        if(n==3){
            if(G1[0].empty()){
                cout<<"No"<<"\n";
                continue;
            }
        }
        vector<pair<ll,ll>>preAns;
        for(ll j=1;j<n-1;j++){
            if(!G1[j].count(j+1)){
                preAns.push_back({j,j+1});
            }
        }
        if(!G1[1].count(0)){
            preAns.push_back({0,1});
        }
        if(!G1[2].count(0)){
            preAns.push_back({0,2});
        }
        cout<<"Yes"<<"\n";
        cout<<preAns.size()<<"\n";
        for(auto elem:preAns){
            cout<<elem.first<<" "<<elem.second<<"\n";
        }
    }
}
