//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <vector>
#include <deque>
#include <ctime>
#include <unordered_set>
#include <iomanip>
#include <algorithm>
using namespace std;
#define double long double
#define int long long
#define ll long long
#define debug(x) cerr << (#x) << ": " << x << endl;
#define get_time (double)(clock()) / (double)(CLOCKS_PER_SEC)
const int INF = 1e17 + 7;
const int mod = 1e9 + 7;
const int MAXN = 2e5 + 10;
//#pragma GCC optimize("avx2")
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
int make_add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int n, m1, m2, g;
set<pair<int, int> > edges;
vector<set<int> > gr1, gr2;
vector<vector<int> > comps;
void solve() {
    edges.clear();
    comps.clear();
    cin >> n >> m1 >> m2;
    gr1 = vector<set<int> >(n);
    gr2 = vector<set<int> >(n);
    for (int i = 0; i < m1; i++) {
        int u, v;cin >> u >> v;u--;v--;
        gr1[u].insert(v);
        gr1[v].insert(u);
        edges.insert({ min(u, v), max(u, v) });
    }
    for (int i = 0; i < m2; i++) {
        int u, v;cin >> u >> v; u--; v--;
        gr2[u].insert(v);
        gr2[v].insert(u);
    }
    cout << "Yes" << endl;
    vector<pair<int, int> > ans;
    for (int i = 1; i < n - 1; i++) {
        int u = i, v = i + 1;
        if (edges.count({ u, v })) continue;
        ans.push_back({ u, v });
    }
    cout << ans.size() << '\n';
    for (auto c : ans) cout << c.first + 1 << " " << c.second + 1 << '\n';
}
signed main() {
    cout << fixed << setprecision(20);
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t >> g;
    while (t--) {
        solve();
    }
}
/*
4
3
11 17 14
1 13 10

*/