//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt,fma")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const long long RANDOM = chrono::high_resolution_clock::now().time_since_epoch().count();
constexpr int MAXN = 1 << 20;
constexpr long long mod = 1e9 + 7;
mt19937 rnd(RANDOM);

void dfs(int s, vector<bool> &u, vector<set<int>> &g) {
    u[s] = 1;
    for (auto i: g[s]) {
        if (!u[i]) {
            dfs(i, u, g);
        }
    }
}


void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<set<int>> g1(n), g2(n);
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g1[u].insert(v);
        g1[v].insert(u);
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g2[u].insert(v);
        g2[v].insert(u);
    }
    vector<pair<int, int>> g;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            g.push_back({i, j});
        }
    }
    for (int i = 0; i < (1 << (int) g.size()); i++) {
        vector<set<int>> gg1, gg2;
        gg1 = g1, gg2 = g2;
        bool flag = 0;
        int cnt = 0;
        for (int j = 0; j < g.size(); j++) {
            if ((1 << j) & i) {
                cnt++;
                int u = g[j].first, v = g[j].second;
                if (gg1[u].count(v)) {
                    gg1[u].erase(v);
                    gg1[v].erase(u);
                } else {
                    gg1[u].insert(v);
                    gg1[v].insert(u);
                }
                if (gg2[u].count(v)) {
                    gg2[u].erase(v);
                    gg2[v].erase(u);
                } else {
                    gg2[u].insert(v);
                    gg2[v].insert(u);
                }
            }
        }
        vector<bool> u1(n), u2(n);
        dfs(0, u1, gg1);
        dfs(0, u2, gg2);
        bool f1 = 0, f2 = 0;
        for (auto j: u1) {
            if (!j) {
                f1 = 1;
            }
        }
        for (auto j: u2) {
            if (!j) {
                f2 = 1;
            }
        }
        if (!f1 && !f2) {
            cout << "Yes\n";
            cout << cnt << '\n';
            for (int j = 0; j < g.size(); j++) {
                if ((1 << j) & i) {
                    cnt++;
                    int u = g[j].first, v = g[j].second;
                    cout << u + 1 << ' ' << v + 1 << '\n';
                }
            }
            return;
        }
    }
    cout << "No\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
    cin >> q;
    int xr;
    cin >> xr;
    while (q--) {
        solve();
    }
}
