
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <algorithm>
#include <climits>

using namespace std;

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;



void solve(ll group){
    ll n, m1, m2, t1, t2;
    cin >> n >> m1 >> m2;
    vector<map<ll, ll>> g1(n);
    vector<map<ll, ll>> g2(n);
    for (int i = 0; i < m1; ++i) {
        cin >> t1 >> t2;
        t1--;
        t2--;
        g1[t1][t2] = 1;
        g1[t2][t1] = 1;
    }
    for (int i = 0; i < m2; ++i) {
        cin >> t1 >> t2;
        t1--;
        t2--;
        g2[t1][t2] = 1;
        g2[t2][t1] = 1;
    }
    if (group == 5 || group == 6 || group == 9){
        vll color(n);
        set<ll> tobeat;
        for (int i = 0; i < n; ++i) {
            color[i] = i;
            if (i != 0) {
                tobeat.insert(i);
            }
        }
        vector<pll> tans;
        for (int i = 0; i < n; ++i) {
            if (color[i] == 0){
                vll ans;
                for (auto item : tobeat){
                    if (g1[i][item]){
                        ans.push_back(item);
                        color[item] = 0;
                        continue;
                    }
                    if (!g2[i][item]){
                        ans.push_back(item);
                        tans.push_back({i, item});
                        color[item] = 0;
                    }
                    //cout << item << " ";
                }
                //cout << " rt\n";
                for (int j = 0; j < ans.size(); ++j) {
                    tobeat.erase(ans[j]);
                }
                ans.clear();
            }
        }
        if (n == 3){
            if (tans[0] == (pll){0, 2}){
                tans.push_back({1, 2});
            }
            if (tans[0] == (pll){1, 2} || tans[0] == (pll){2, 1}){
                tans.push_back({0, 2});
            }
            if (tans[0] == (pll){0, 1}){
                tans.push_back({0, 2});
            }
        }
        cout << "YES\n";
        cout << tans.size() << "\n";
        for (int i = 0; i < tans.size(); ++i) {
            cout << tans[i].first + 1 << " " << tans[i].second + 1 << "\n";
        }
        return;
    }
}



int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll t, g;
    cin >> t >> g;
    while (t--) {
        solve(g);
    }
}
