#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl '\n'

typedef long long ll;
typedef long double ld;

typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 2e15 + 1;
const int MOD = 1e9 + 7;

mt19937 rnd(time(0));

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector <vector <int>> sm;
vector <int> l, sz;

int find(int a){
    if (a == l[a])
        return a;
    return l[a] = find(l[a]);
}

bool same(int a, int b){
    return find(a) == find(b);
}

void unite(int a, int b){
    a = find(a), b = find(b);
    if (same(a, b))
        return;
    if (sz[a] < sz[b])
        swap(a, b);
    l[b] = a;
    sz[a] += sz[b];
}

signed main() {
    Fast();
    int t, g;
    cin >> t >> g;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        l.assign(n, 0);
        sz.assign(n, 1);
        for (int i = 0; i < n; i++)
            l[i] = i;
        for (int i = 0; i < m1; i++) {
            int v, u;
            cin >> v >> u;
            v--, u--;
            unite(v, u);
        }
        set <pair <int, int>> e;
        for (int i = 0; i < m2; i++){
            int a, b;
            cin >> a >> b;
            a--, b--;
            e.insert({min(a, b), max(a, b)});
        }
        if (g == 2){
            vector <pair <int, int>> ans;
            vector <int> cnt(n);
            for (int i = 0; i < n; i++)
                cnt[i] = n - 1;
            for (int i = 0; i < n; i++){
                for (int j = 0; j < n; j++){
                    if (!same(i, j) && cnt[i] > 1 && cnt[j] > 1)
                        ans.push_back({i, j}), unite(i, j), cnt[i]--, cnt[j]--;
                }
            }
            set <int> s;
            for (int i = 0; i < n; i++)
                s.insert(find(i));
            if ((int)s.size() == 1) {
                cout << "Yes" << endl;
                cout << (int)ans.size() << endl;
                for (auto i:ans)
                    cout << i.first + 1 << " " << i.second + 1 << endl;
            }else{
                cout << "No" << endl;
            }
        }
        if (g == 7){
            vector <pair <int, int>> ans;
            for (int i = 2; i < n; i++){
                if (same(0, i))
                    continue;
                if (!e.count({0, i})){
                    ans.push_back({0, i});
                }else if (!e.count({1, i})){
                    ans.push_back({1, i});
                }else{
                    ans.push_back({0, i});
                }
            }
            cout << "Yes" << endl;
            cout << (int)ans.size() << endl;
            for (auto i:ans)
                cout << i.first + 1 << " " << i.second + 1 << endl;
        }
    }
    return 0;
}

/*
3
0 5 5
0 9 3
5 9 8
2 5
 */