#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<vector<int>> g;
vector<int> used;

void dfs(int v) {
    used[v] = true;
    for (auto to : g[v]) {
        if (used[to])
            continue;
        dfs(to);
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g.assign(n, {}), used.assign(n, 0);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
    }
    vector<int> compheads;
    for (int i = 0; i < n; ++i) {
        if (used[i])
            continue;
        dfs(i);
        compheads.push_back(i);
    }
    if (n == 3 && compheads.size() > 2) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    cout << compheads.size() - 1 << "\n";
    for (int i = 1; i < compheads.size(); ++i) {
        cout << compheads[i - 1] + 1 << ' ' << compheads[i] + 1 << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc, gr;
    cin >> tc >> gr;
    while (tc--)
        solve();
}
