#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using lll = __int128;
using ld = long double;
using vp = vector<pi>;
using vpl = vector<pl>;

int n, m1, m2;
vector<vi> g1, g2;

void yes(vp &ans) {
    if (ans.size() > n) {
        while (true) {}
    }
    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto[a, b] : ans)
        cout << a+1 << " " << b+1 << "\n";
}
void no() {
    cout << "No\n";
}

void solve3() { // n = 3
    vi v1(3, 0), v2(3, 0);
    for (int i = 0; i < n; i++) {
        for (int to : g1[i]) {
            if (to < i) continue;
            v1[i+to-1]++;
        }
        for (int to : g2[i]) {
            if (to < i) continue;
            v2[i+to-1]++;
        }
    }
    bool b1 = false;
    bool b2 = false;
    vp ans;
    for (int i = 0; i < 3; i++) {
        if (v1[i] == 1 && v2[i] == 1) continue;
        if (v1[i] == 0 && v2[i] == 0) {
            ans.emplace_back(0, 1);
            continue;
        }
        if (v1[i] == 1) {
            if (b1 == false)
                b1 = true;
            else if (b2 == false) {
                b2 = true;
                ans.emplace_back(0, 1);
            } else {
                no(); return;
            }
        } else {
            if (b2 == false)
                b2 = true;
            else if (b1 == false) {
                b1 = true;
                ans.emplace_back(0, 1);
            } else {
                no(); return;
            }
        }
    }
    yes(ans);
}

vp anses;
pair<vp, vp> getEdges() {
    vector<vi> g;
    vp e1, e2;
    for (int i = 0; i < m1; i++) {
        int a, b; cin >> a >> b; a--, b--;
        if (a > b) swap(a, b);
        e1.emplace_back(a, b);
        g1[a].push_back(b);
        g1[b].push_back(a);
    }
    vi ch2(n, 0);
    for (int i = 0; i < m2; i++) {
        int a, b; cin >> a >> b; a--, b--;
        if (a > b) swap(a, b);
        e2.emplace_back(a, b);
        ch2[a]++;
        ch2[b]++;
    }
    if (n == 3) return {e1, e2};

    auto addEdge = [](vp &e, int i, int j) {
        if (i > j) swap(i, j);
        e.emplace_back(i, j);
    };
    auto remEdge = [](vp &e, int i, int j) {
        if (i > j) swap(i, j);
        pi p = {i, j};
        e.erase(find(e.begin(), e.end(), p));
    };
    auto contEdge = [](vp &e, int i, int j) {
        if (i > j) swap(i, j);
        pi p = {i, j};
        return find(e.begin(), e.end(), p) != e.end();
    };

    for (int i = 0; i < n; i++) {
        if (ch2[i] == n-1) {
            if (!g1[i].empty()) break;
            int j1 = (i+1)%n;
            int j2 = (i+2)%n;

            if (!contEdge(e2, j1, j2)) {
                anses.emplace_back(j1, j2);
                addEdge(e2, j1, j2);
                if (contEdge(e1, j1, j2))
                    remEdge(e1, j1, j2);
                else
                    addEdge(e1, j1, j2);
            }
            anses.emplace_back(i, j1);
            remEdge(e2, i, j1);
            addEdge(e1, i, j1);
            break;
        }
    }
    return {e1, e2};
}

map<pi, int> getOst() {
    map<pi, int> mp2;
    vector<char> used2(n, 0);
    function<void(int)> dfs1;
    dfs1 = [&](int v) {
        used2[v] = 1;
        for (int to : g2[v]) {
            if (used2[to] == 1) continue;
            mp2[{v, to}] = 1;
            mp2[{to, v}] = 1;
            dfs1(to);
        }
    };
    dfs1(0);
    return mp2;
}

void solve() {
    anses.clear();
    cin >> n >> m1 >> m2;
    g1.assign(n, vi());
    g2.assign(n, vi());

    auto[e1, e2] = getEdges();
    map<pi, int> ed1, ed2;
    for (auto[a, b] : e1) {
        g1[a].push_back(b);
        g1[b].push_back(a);
        ed1[{a, b}] = 1;
        ed1[{b, a}] = 1;
    }
    for (auto[a, b] : e2) {
        g2[a].push_back(b);
        g2[b].push_back(a);
        ed2[{a, b}] = 1;
        ed2[{b, a}] = 1;
    }
    if (n == 3) { solve3(); return; }

    map<pi, int> mp2 = getOst();
    // now mp2 has ostov from g2

    int vv0 = rand() % n;

    set<int> need;
    for (int i = 0; i < n; i++) need.insert(i);
    need.erase(vv0);

    set<int> stack;
    stack.insert(vv0);

    vi used(n, 0);

    function<void(int)> dfs1;
    dfs1 = [&](int v) {
        for (int to : g1[v]) {
            if (need.count(to) == 0) continue;
            need.erase(to);
            if (used[to] == 0)
                stack.insert(to);
            dfs1(to);
        }
    };
    dfs1(vv0);
    while (!stack.empty()) {
        int v = *stack.begin();
        stack.erase(stack.begin());
        if (used[v]) continue;
        used[v] = 1;

        vi add;
        for (int to : need) {
            if (mp2.find({v, to}) == mp2.end()) {
                add.push_back(to);
            }
        }
        for (int i : add) {
            if (need.count(i) == 0) continue;
            need.erase(i);
            anses.emplace_back(v, i);
            dfs1(i);
        }
    }
    yes(anses);
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);
    int t, g; cin >> t >> g;
    while (t--)
        solve();
}
