#include <bits/stdc++.h>
using namespace std;
#define all(a) a.begin(), a.end()
#define int long long
#define rall(a) a.rbegin(), a.rend()
#define gen(a, b) uniform_int_distribution<int>(a, b)(rnd)
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
const int N = 3010;
int G1[N][N];
int G2[N][N];
int used[N];
int n;
void dfs(int v) {
    used[v]  =1;
    for(int i = 0; i < n; i++) {
        if(used[i]) continue;
        if(G2[v][i]) {
            dfs(i);
        }
    }
}
void dfs2(int v) {
    used[v]  =1;
    for(int i = 0; i < n; i++) {
        if(used[i]) continue;
        if(G1[v][i]) {
            dfs2(i);
        }
    }
}
pair<bool,bool> ch() {
    dfs2(0);
    bool ok1 = true, ok2 = true;
    for(int i = 0; i < n; i++) {
        if(!used[i]) ok1 = false;
        used[i] = 0;
    }
    dfs(0);
    for(int i = 0; i < n; i++) {
        if(!used[i]) ok2 = false;
        used[i] = 0;
    }
    return {ok1,ok2};
} 
vector<pair<int,int>> ans;
bool rec(vector<pair<int,int>> cur) {
    if(cur.size() > n) return 0;
    for(auto [x,y] : cur) {
        G1[x][y]^=1;
        G1[y][x]^=1;
        G2[x][y]^=1;
        G2[y][x]^=1;
    }
    pair<int,int> sp= ch();
    if(sp.first == 1 && sp.second == 1)  {
        ans = cur;
        return 1;
    }
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < i; j++) {
            if(i ==j)continue;
            cur.push_back({i,j});
            bool s = rec(cur);
            if(s)return s;
            cur.pop_back();
        }
    }
}
void solve() {
    int m1,m2;
    cin >> n >> m1 >> m2;
    for(int i = 0; i < n; i++) {
        for(int j = 0;j < n; j++) {
            G1[i][j] = 0;
            G2[i][j] = 0;
        }
    }
    for(int i = 0; i < m1; i++) {
        int u,v;
        cin >> u >>v;
        G1[u][v] = 1;
        G1[v][u] = 1;
    }
    for(int i = 0; i < m2; i++) {
        int u,v;
        cin >> u >> v;
        G2[u][v] = 1;
        G2[v][u] = 1;
    }
    if(rec({})) {
        cout << "Yes" << endl;
        cout << ans.size() << endl;
        for(auto [u, v] : ans) {
            cout << u << " " << v <<endl;
        }
    } else {
        cout << "No" << endl;
    }

    
}
signed main() {
#ifdef LOCAL
    freopen("test.txt", "r", stdin);
#endif
    int t,g;
    cin >> t >> g;
    while(t--) solve();
}