//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("avx,avx2,sse,sse2,sse3,ssse3")
#include <bits/stdc++.h>

using namespace std;

//#define int int_fast32_t
#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map
//#define mp make_pair

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;
typedef vector<si> vsi;
typedef vector<spi> vspi;
typedef tuple<int, int, int> ti;
typedef vector<ti> vti;
typedef vector<bool> vb;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

mt19937 rnd(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());

const int MAXN = 2e5 + 10;

vsi g1, g2, gost;
vpi gost2;
vb used;
si unused;
vi last;

void dfs(int v) {
	used[v] = true;
	for (auto u : g2[v]) {
		if (!used[u]) {
			gost[v].insert(u);
			gost[u].insert(v);
			dfs(u);
		}
	}
}

void dfs2(int v) {
	used[v] = true;
	unused.erase(v);
	while (unused.size() && *unused.rbegin() > last[v]) {
		int u = *unused.upper_bound(last[v]);
		last[v] = u;
		if (!gost[v].count(u)) {
			gost2.push_back({u, v});
			dfs2(u);
		}
	}
}

void solve() {
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	g1.assign(n + 1, {});
	g2.assign(n + 1, {});
	gost.assign(n + 1, {});
	gost2.clear();
	used.assign(n + 1, false);
	unused.clear();
	for (int i = 1; i <= n; ++i)
		unused.insert(i);
	last.assign(n + 1, 0);
	vpi e1, e2;
	for (int i = 0; i < m1; ++i) {
		int u, v;
		cin >> u >> v;
		e1.push_back({min(u, v), max(u, v)});
		g1[u].insert(v);
		g1[v].insert(u);
	}
	for (int i = 0; i < m2; ++i) {
		int u, v;
		cin >> u >> v;
		e2.push_back({min(u, v), max(u, v)});
		g2[u].insert(v);
		g2[v].insert(u);
	}
	if (n == 3) {
		if (m1 == 0) {
			if (m2 == 3)
				cout << "No\n";
			else {
				cout << "Yes\n2\n";
				cout << "1 2\n";
				if (e2[0] == make_pair(1ll, 3ll) || e2[1] == make_pair(1ll, 3ll))
					cout << "2 3\n";
				else
					cout << "1 3\n";
			}
		}
		else if (m1 == 1) {
			if (m2 == 3) {
				cout << "Yes\n1\n";
				if (e1[0] == make_pair(1ll, 2ll))
					cout << "2 3\n";
				else
					cout << "1 2\n";
			}
			else {
				if (e1[0] == e2[0] || e1[0] == e2[1]) {
					cout << "Yes\n1\n";
					spi s;
					s.insert({1, 2});
					s.insert({1, 3});
					s.insert({2, 3});
					s.erase(e2[0]);
					s.erase(e2[1]);
					cout << s.begin()->first << ' ' << s.begin()->second << '\n';
				}
				else
					cout << "No\n";
			}
		}
		else
			cout << "Yes\n0\n";
		return;
	}
	dfs(1);
	int v = 1;
	for (int i = 2; i <= n; ++i) {
		if (gost[i].size() > gost[v].size())
			v = i;
	}
	vpi ans;
	if (gost[v].size() == n - 1) {
		int u = 1;
		if (v == 1)
			u = 2;
		int k = 1;
		if (v == 1 || u == 1) {
			k = 2;
			if (v == 2 || u == 2)
				k = 3;
		}
		gost[u].erase(v);
		gost[v].erase(u);
		gost[k].insert(u);
		gost[u].insert(k);
		if (!g2[k].count(u)) {
			ans.push_back({k, u});
			g2[k].insert(u);
			g2[u].insert(k);
			if (g1[k].count(u)) {
				g1[k].erase(u);
				g1[u].erase(k);
			}
			else {
				g1[k].insert(u);
				g1[u].insert(k);
			}
		}
	}
	used.assign(n + 1, false);
	dfs2(1);
	for (auto [u, v] : gost2) {
		if (!g1[u].count(v))
			ans.push_back({u, v});
	}
	cout << "Yes\n" << ans.size() << "\n";
	for (auto [u, v] : ans)
		cout << u << ' ' << v << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t, g;
	cin >> t >> g;
	while (t--)
		solve();

	return 0;
}