#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

mt19937 gen(-572);

vector<vector<ll>> g1, g2;

vector<ll> cur;
vector<bool> used;

void dfs(ll v) {
    used[v] = true;
    cur.push_back(v);
    for (ll u : g1[v]) {
        if (!used[u]) dfs(u);
    }
}

ll cnt = 0;
set<Pair> block;

void check(ll v) {
    used[v] = true;
    cnt++;
    for (ll u : g2[v]) {
        if (!block.count({min(u, v), max(u, v)}) && !used[u]) {
            check(u);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
    ll t, g;
    cin >> t >> g;
    while (t--) {
        g1.clear(), g2.clear(), cur.clear(), used.clear(), block.clear();
        ll n, m1, m2;
        cin >> n >> m1 >> m2;
        g1.resize(n), g2.resize(n);
        for (ll i = 0; i < m1; i++) {
            ll u, v;
            cin >> u >> v;
            u--, v--;
            g1[u].push_back(v);
            g1[v].push_back(u);
        }
        map<Pair, bool> in;
        for (ll i = 0; i < m2; i++) {
            ll u, v;
            cin >> u >> v;
            u--, v--;
            g2[u].push_back(v);
            g2[v].push_back(u);
            in[{min(u, v), max(u, v)}] = true;
        }
        vector<vector<ll>> all;
        used.resize(n, false);
        for (ll i = 0; i < n; i++) {
            if (!used[i]) {
                cur.clear();
                dfs(i);
                all.push_back(cur);
            }
        }
        vector<Pair> ans;
        bool fl = true;
        while (all.size() > 1) {
         //   cout << "sz: " << all.size() << endl;
            for (ll j = 0; j < (ll) all.size(); j++)
            for (ll i = j + 1; i < (ll) all.size(); i++) {
                bool was = false;
                for (ll fir: all[i]) {
                    for (ll sec: all[j]) {
                        if (!was && !in[{min(fir, sec), max(fir, sec)}]) {
                 //           cout << "d: " << fir << " " << sec << endl;
                            g2[fir].push_back(sec);
                            g2[sec].push_back(fir);
                            g1[fir].push_back(sec);
                            g1[sec].push_back(fir);
                            ans.push_back({fir + 1, sec + 1});
                            in[{min(fir, sec), max(fir, sec)}] = true;
                            was = true;
                        }
                    }
                }
                if (was) continue;
                for (ll fir: all[i]) {
                    if (was) continue;
                    for (ll sec: all[j]) {
                        if (was) continue;
                        fill(used.begin(), used.end(), false);
                        block.insert({min(fir, sec), max(fir, sec)});
                        cnt = 0;
                        check(0);
                        if (cnt == n) {
                            was = true;
                            ans.push_back({fir + 1, sec + 1});
                            g1[fir].push_back(sec);
                            g1[sec].push_back(fir);
                        } else {
                            block.erase({min(fir, sec), max(fir, sec)});
                        }
                    }
                }
            }
            if (ans.size() > n) {
                cout << "No\n";
                fl = false;
                break;
            }
            ll was = all.size();
            fill(used.begin(), used.end(), false);
            all.clear();
            for (ll i = 0; i < n; i++) {
                if (!used[i]) {
                    cur.clear();
                    dfs(i);
                    all.push_back(cur);
                }
            }
            if (was == all.size()) {
                cout << "No\n";
                fl = false;
                break;
            }
        }
        if (fl) {
            cout << "Yes\n";
            cout << ans.size() << endl;
            for (auto [u, v]: ans) cout << u << " " << v << endl;
        }
    }
    return 0;
}
