#include <bits/stdc++.h>

using namespace std;

struct Sp1 {
    int n, m1, m2;
    set<pair<int, int>> s1, s2;
    vector<vector<int>> g1, g2;

    Sp1() {
        cin >> n >> m1 >> m2;
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            s1.emplace(u, v);
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            --u; --v;
            s2.emplace(u, v);
        }

        int m = n * (n - 1) / 2;
        vector<pair<int, int>> edges;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i == j) {
                    continue;
                }
                edges.emplace_back(i, j);
            }
        }
        for (int mask = 0; mask < 1 << m; ++mask) {
            auto t1 = s1, t2 = s2;
            for (int i = 0; i < m; ++i) {
                if ((mask >> i) & 1) {
                    if (t1.count(edges[i])) {
                        t1.erase(edges[i]);
                    } else {
                        t1.insert(edges[i]);
                    }
                    if (t2.count(edges[i])) {
                        t2.erase(edges[i]);
                    } else {
                        t2.insert(edges[i]);
                    }
                }
            }
            g1.clear();
            g2.clear();
            g1.resize(n);
            g2.resize(n);
            for (int i = 0; i < m; ++i) {
                if (t1.count(edges[i])) {
                    g1[edges[i].first].push_back(edges[i].second);
                    g1[edges[i].second].push_back(edges[i].first);
                }
                if (t2.count(edges[i])) {
                    g2[edges[i].first].push_back(edges[i].second);
                    g2[edges[i].second].push_back(edges[i].first);
                }
            }
            used.clear();
            dfs(g1);
            if (used.size() != n) {
                continue;
            }
            used.clear();
            dfs(g2);
            if (used.size() != n) {
                continue;
            }
            cout << "Yes" << endl;
            vector<pair<int, int>> ans;
            for (int i = 0; i < m; ++i) {
                if ((mask >> i) & 1) {
                    ans.emplace_back(edges[i].first + 1, edges[i].second + 1);
                }
            }
            cout << ans.size() << endl;
            for (auto& val : ans) {
                cout << val.first << ' ' << val.second << endl;
            }
            return;
        }
        cout << "No" << endl;
    }

    unordered_set<int> used;

    void dfs(const vector<vector<int>>& g, int v = 0) {
        used.insert(v);
        for (int child : g[v]) {
            if (!used.count(child)) {
                dfs(g, child);
            }
        }
    }
};

signed main() {
    int t, g;
    cin >> t >> g;
    while (t--) {
        if (g <= 1) {
            Sp1();
        }
    }
}
