#include <bits/stdc++.h>

using namespace std;

struct Sp2 {
    int n, m1, m2;
    set<pair<int, int>> s1;

    Sp2() {
        cin >> n >> m1 >> m2;
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            --u; --v;
            if (u > v) swap(u, v);
            s1.emplace(u, v);
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
        }

        cout << "Yes" << endl;
        vector<pair<int, int>> ans;
        for (int i = 0; i < n - 1; ++i) {
            if (!s1.count({ i, i + 1 })) {
                ans.emplace_back(i + 1, i + 2);
            }
        }

        cout << ans.size() << endl;
        for (auto& val : ans) {
            cout << val.first << ' ' << val.second << endl;
        }
    }

    unordered_set<int> used;

    void dfs(const vector<vector<int>>& g, int v = 0) {
        // cout << "visit " << v + 1 << endl;
        used.insert(v);
        for (int child : g[v]) {
            if (!used.count(child)) {
                dfs(g, child);
            }
        }
    }
};

signed main() {
    int t, g;
    cin >> t >> g;
    while (t--) {
        if (g == 2) {
            Sp2();
        }
    }
}
