#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve(){
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<pair<int, int>> edg;
    set<pair<int, int>> edg1, edg2;
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        if(a > b)
            swap(a, b);
        edg1.insert({--a, --b});
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        if(a > b)
            swap(a, b);
        edg2.insert({--a, --b});
    }
    for (int i = 1; i < n-1; ++i) {
        if(!edg1.count({i, i+1}))
            edg.emplace_back(i, i+1);
    }
    bool flag = 0;
    for (int i = 1; i < n; ++i) {
        flag|=edg1.count({0, i});
    }
    if(!flag){
        cout<< "No\n";
        return;
    }
    cout << "Yes\n";
    cout << edg.size() << '\n';
    for(auto [x, y] : edg)
        cout << x+1 << ' ' << y+1 <<'\n';

}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1, _G;
    cin >> _ >> _G;
    while(_--){
        if(_G == 5)
            solve();
    }
    return 0;
}
/*

3 0
3 0 3
1 2
2 3
1 3
4 2 3
1 2
3 4
1 3
1 4
2 3
4 3 3
1 2
2 3
1 3
1 4
2 4
3 4
 */