#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e6+2;

struct dsu
{
    ve<ll> link,sz;
    ll cnt=0;

    void init(ll n)
    {
        link.assign(n,0);
        iota(all(link),0);
        sz.assign(n,1);
        cnt=n;
    }

    ll fset(ll x)
    {
        if(x==link[x]) return x;
        return link[x]=fset(link[x]);
    }

    void unite(ll a, ll b)
    {
        a=fset(a);
        b=fset(b);
        if(a==b) return;
        if(sz[a]>sz[b]) swap(a,b);
        link[b]=a;
        sz[a]+=sz[b];
        cnt--;
    }
};

char arr[N];

void solve()
{
    ll n,m1,m2;
    cin>>n>>m1>>m2;
    set<pll> st1,st2;

    for(ll i=0;i<m1;i++)
    {
        ll a,b;
        cin>>a>>b;
        a--, b--;
        if(a>b) swap(a,b);
        st1.insert({a,b});
    }

    for(ll i=0;i<m2;i++)
    {
        ll a,b;
        cin>>a>>b;
        a--, b--;
        if(a>b) swap(a,b);
        st2.insert({a,b});
    }

    dsu d;
    d.init(n);
    ve<pll> ans;

    for(ll a=0;a<n;a++)
    {
        for(ll b=a+1;b<n;b++)
        {
            if(st1.count({a,b})&&st2.count({a,b}))
                d.unite(a,b);

            else if(!st1.count({a,b})&&!st2.count({a,b})&&d.fset(a)!=d.fset(b))
            {
                d.unite(a,b);
                ans.PB({a,b});
            }

            if(d.cnt==1) break;
        }

        if(d.cnt==1) break;
    }

    if(d.cnt==1)
    {
        cout<<"Yes"<<endl<<sz(ans)<<endl;
        for(pll p:ans) cout<<p.F+1<<' '<<p.S+1<<endl;
        return;
    }

    ve<pll> v;

    for(pll p:st1)
    {
        if(!st2.count(p))
            v.PB(p);
    }

    for(pll p:st2)
    {
        if(!st1.count(p))
            v.PB(p);
    }

    for(ll it=0;it<100000;it++)
    {
        shuffle(all(v),gen);
        dsu d1=d,d2=d;

        for(ll i=0;i<sz(v);i++)
        {
            ll a,b;
            tie(a,b)=v[i];

            if(d1.fset(a)!=d1.fset(b))
            {
                d1.unite(a,b);
                arr[i]=0;
            }

            else if(d2.fset(a)!=d2.fset(b))
            {
                d2.unite(a,b);
                arr[i]=1;
            }

            else arr[i]=(st1.count(v[i])? 1:0);
        }

        if(d1.cnt==1&&d2.cnt==1)
        {
            ll cnt=sz(ans);

            for(ll i=0;i<sz(v);i++)
            {
                if(arr[i]!=st1.count(v[i]))
                    cnt++;
            }

            if(cnt<=n)
            {
                for(ll i=0;i<sz(v);i++)
                {
                    if(arr[i]!=st1.count(v[i]))
                        ans.PB(v[i]);
                }

                cout<<"Yes"<<endl<<sz(ans)<<endl;
                for(pll p:ans) cout<<p.F+1<<' '<<p.S+1<<endl;
                return;
            }
        }
    }

    cout<<"No"<<endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll q,g;
    cin>>q>>g;

    while(q--)
        solve();

    return 0;
}
