//save tasks
#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define endl '\n'
#define F first
#define S second
#define int long long
#define ios ios_base::sync_with_stdio(false); cin.tie(0);
using namespace __gnu_pbds;
using namespace std;
int G;
vector<vector<int>> edge;
set<pair<int, int>> edges;
vector<pair<int, int>> ans;
inline void add(int u, int v) {
    if (u == v)
        return;
    if (u > v)
        swap(u, v);
    edges.insert({u, v});
}
inline bool upd(int u, int v){
    if(u == v)
        return false;
    if(u > v)
        swap(u, v);
    if(edges.count({u, v}))
        return false;
    ans.emplace_back(u, v);
    edges.insert({u, v});
    return true;
}
inline void updh(int u, int v){
    if(u > v)
        swap(u, v);
    ans.emplace_back(u, v);
    if(edges.count({u, v}))
        edges.erase({u, v});
    else
        edges.insert({u, v});
    return;
}
vector<bool> used;
vector<vector<int>> redge;
int n, C = 0;
void dfs(int v){
    used[v] = true;
    for(auto i : edge[v]){
        if(!used[i]) {
            dfs(i);
            redge[v].push_back(i);
            redge[i].push_back(v);
        }
    }
}
void rdfs(int v, vector<vector<bool>> &sedge){
    used[v] = true;
    for(int i = 0; i < n ;i ++){
        if(!used[i] && sedge[v][i])
            rdfs(i, sedge);
    }
    C++;
}
inline void solve() {
    int m1, m2;
    cin >> n >> m1 >> m2;
    edge.clear();
    edges.clear();
    used.clear();
    redge.clear();
    ans.clear();
    edge.resize(n);
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        add(u - 1, v - 1);
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        if(u == v)
            continue;
        edge[u].push_back(v);
        edge[v].push_back(u);
    }
    if(n <= 5){
        used.resize(n);
        vector<vector<bool>> a(n, vector<bool> (n)), b(n, vector<bool> (n)), a1, b1;
        for(int i = 0; i < n ;i ++){
            for(auto j : edge[i])
                a[i][j] = a[j][i] = true;
        }
        for(auto j : edges)
            b[j.F][j.S] = b[j.S][j.F] = true;
        a1 = a, b1 = b;
        int sz = n * (n - 1) / 2;
        for(int mask = 0; mask < (1<<sz); mask++){
            int cnt = 0, res = 0;
            for(int i = 0; i < n; i ++){
                for(int j = i + 1; j < n ; j ++){
                    if(mask & (1<<cnt)){
                        a1[i][j] = a1[j][i] = !a[i][j];
                        b1[i][j] = b1[j][i] = !b[i][j];
                        res++;
                    }else {
                        a1[i][j] = a1[j][i] = a[i][j];
                        b1[i][j] = b1[j][i] = b[i][j];
                    }
                    cnt++;
                }
            }
            if(res > n)
                continue;
            fill(used.begin(), used.end(), false);
            C = 0;
            rdfs(0, a1);
            if(C != n)
                continue;
            fill(used.begin(), used.end(), false);
            C = 0;
            rdfs(0, b1);
            if(C != n)
                continue;
            cout<<"Yes"<<endl<<res<<endl;
            cnt = 0;
            for(int i = 0; i < n; i ++){
                for(int j = i + 1; j < n ; j ++){
                    if(mask & (1<<cnt))
                        cout<<i + 1<<" "<<j + 1<<endl;
                    cnt++;
                }
            }
            return;
        }
        cout<<"No"<<endl;
        return;
    }
    exit(-1);
    int num = -1;
    for(int i = 0; i < n ;i ++){
        if(edge[i].size() == n - 1){
            num = i;
            break;
        }
    }
    cout<<"Yes"<<endl;
    if(num != -1){
        bool was = false;
        int f, s, t;
        if(num == 0)
            f = 1, s = 2, t = 3;
        else{
            if(num == 1)
                f = 0, s = 2, t = 3;
            else{
                if(num == 2)
                    f = 0, s = 1, t = 3;
                else
                    f = 0, s = 1, t = 2;
            }
        }
        for(auto j : edge[f]){
            if(j == s)
                was = true;
        }
        if(!was)
            updh(f, s);
        upd(f, num);
        for(int i = 0; i < n ; i ++){
            if(i != num)
                upd(i, t);
        }
        cout<<ans.size()<<endl;
        for(auto i : ans)
            cout<<i.F + 1<<" "<<i.S + 1<<endl;
        cout<<endl;
        return;
    }
    redge.resize(n);
    used.resize(n, false);
    dfs(0);
    num = -1;
    for(int i = 0; i < n ;i ++){
        if(redge[i].size() == 1){
            num = i;
            for(int j = 0; j < n ;j ++) {
                if(j != redge[i][0])
                    upd(i, j);
            }
            break;
        }
    }
    for(int i = 0; i < n ;i ++){
        bool was = false;
        for(auto j : redge[i]){
            if(j == redge[num][0])
                was = true;
        }
        if(!was){
            upd(i, redge[num][0]);
            break;
        }
    }
    cout<<ans.size()<<endl;
    for(auto j : ans)
        cout<<j.F + 1<<" "<<j.S + 1<<endl;
}

signed main() {
    ios
    int T = 1;
    cin >> T >> G;
    while (T--)
        solve();
}