#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
vector<bool> vis1;
vector<bool> vis2;
vector<vector<int>> graph1(4);
vector<vector<int>> graph2(4);
void dfs1(int x) {
    vis1[x] = true;
    for (auto &i : graph1[x]) {
        if (!vis1[i]) {
            dfs1(i);
        }
    }
}
void dfs2(int x) {
    vis2[x] = true;
    for (auto &i : graph2[x]) {
        if (!vis2[i]) {
            dfs2(i);
        }
    }
}
int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t, g;
    cin >> t >> g;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        map<pair<int, int>, int> mp;
        for (int i = 0; i < m1; ++i) {
            int one, two;
            cin >> one >> two;
            one--;
            two--;
            if (one > two) {
                swap(one, two);
            }
            mp[{one, two}] ^= 1;
        }
        for (int i = 0; i < m2; ++i) {
            int one, two;
            cin >> one >> two;
            one--;
            two--;
            if (one > two) {
                swap(one, two);
            }
            mp[{one, two}] ^= 2;
        }
        if (n < 4) {
            vector<pair<int, int>> ans;
            if (mp[{0, 1}] == 0) {
                mp[{0, 1}] = 3;
                m1++;
                m2++;
                ans.push_back({0, 1});
            }
            if (mp[{1, 2}] == 0) {
                mp[{1, 2}] = 3;
                m1++;
                m2++;
                ans.push_back({1, 2});
            }
             if (mp[{0, 2}] == 0) {
                mp[{0, 2}] = 3;
                m1++;
                m2++;
                ans.push_back({0, 2});
            }
            if (m2 < n - 1 && m1 == n && mp[{0, 1}] == 1) {
                    ans.push_back({0, 1});
                    m1--;
                    m2++;
            } else if (m2 < n - 1 && m1 == n && mp[{0, 2}] == 1) {
                    ans.push_back({0, 2});
                    m1--;
                    m2++;
            } else if (m2 < n - 1 && m1 == n && mp[{1, 2}] == 1) {
                    ans.push_back({1, 2});
                    m1--;
                    m2++;
            }
            if (m1 < n - 1 && m2 == n && mp[{0, 1}] == 2) {
                ans.push_back({0, 1});
                    m2--;
                    m1++;
                } else if (m1 < n - 1 && m2 == n && mp[{0, 2}] == 2) {
                    ans.push_back({0, 2});
                    m2--;
                    m1++;
                } else if (m1 < n - 1 && m2 == n && mp[{1, 2}] == 2) {
                    ans.push_back({1, 2});
                    m2--;
                    m1++;
                }
            if (m1 >= n - 1 && m2 >= n - 1) {
                cout << "Yes\n";
                cout << ans.size() << '\n';
                assert(ans.size() <= n);
                for (auto &i : ans) {
                    cout << i.first + 1 << " " << i.second + 1 << '\n';
                }
            } else {
                cout << "No\n";
            }
            continue;
        }
        vector<pair<int, int>> roads = {{0, 1}, {1, 2}, {2, 3}, {0, 2}, {0, 3}, {1, 3}};
        vector<pair<int, int>> ans;
        bool wasfine = false;
        for (int i = 0; i < (1 << 6); ++i) {
            int cnt = 0;
            vector<int> use;
            for (int j = 0; j < 6; ++j) {
                if (i & (1 << j)) {
                    cnt++;
                    use.push_back(j);
                }
            }
            if (cnt > 4) {
                continue;
            }
            vector<int> cur;
            if (use.size() > 0) {
            do {
                bool fine = true;
                vector<bool> changed(6, false);
                for (int j = 0; j < use.size(); ++j) {
                    graph2.assign(4, {});
                    changed[use[j]] = true;
                    for (int u = 0; u < 6; ++u) {
                        int num = mp[roads[u]];
                        int cng = (3 * ((i >> u) & 1));
                        if (!changed[u]) {
                            cng = 0;
                        }
                        if ((num ^ cng) & 2) {
                            graph2[roads[u].first].push_back(roads[u].second);
                            graph2[roads[u].second].push_back(roads[u].first);
                        }
                    }
                    vis2.assign(4, false);
                    dfs2(0);
                    for (int f = 0; f < 4; ++f) {
                        if (!vis2[f]) {
                            fine = false;
                        }
                    }
                }
                if (fine) {
                    cur = use;
                }
                if (!cur.empty()) {
                    break;
                }
            } while (next_permutation(use.begin(), use.end()));
            }
            if (cur.empty() && i != 0) {
                continue;
            }
            graph1.assign(4, {});
            graph2.assign(4, {});
            for (int j = 0; j < 6; ++j) {
                int num = mp[roads[j]];
                int cng = (3 * ((i >> j) & 1));
                if ((num ^ cng) & 1) {
                    graph1[roads[j].first].push_back(roads[j].second);
                    graph1[roads[j].second].push_back(roads[j].first);
                }
                if ((num ^ cng) & 2) {
                    graph2[roads[j].first].push_back(roads[j].second);
                    graph2[roads[j].second].push_back(roads[j].first);
                }
            }
            vis1.assign(4, false);
            vis2.assign(4, false);
            dfs1(0);
            dfs2(0);
            bool okay = true;
            for (int j = 0; j < 4; ++j) {
                if (!vis1[j] || !vis2[j]) {
                    okay = false;
                }
            }
            if (okay) {
                wasfine = true;
                for (auto &i : cur) {
                    ans.push_back(roads[i]);
                }
                break;
            }
        }
        if (!wasfine) {
            cout << "No\n";
            continue;
        }
        for (int i = 4; i < n; ++i) {
            int last = 3;
            int preflast = 2;
            if (mp[{last, i}] == 3 || mp[{preflast, i}] == 3) {

            } else if (mp[{last, i}] == 0) {
                ans.push_back({last, i});
            } else if (mp[{preflast, i}] == 0) {
                ans.push_back({preflast, i});
            } else if (mp[{last, i}] == mp[{preflast, i}]) {
                ans.push_back({last, i});
            } else {
                }
        }
        cout << "Yes\n";
        assert(ans.size() <= n);
        cout << ans.size() << '\n';
        for (auto &i : ans) {
            cout << i.first + 1 << " " << i.second + 1 << '\n';
        }
    }
}
