#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

int group;

const int N = 300300;
int used[N], used2[N];

vector<int> lst;

void dfs(int v, vector<vector<int>> &g) {
    int chld = 0;
    used[v] = 1;
    for (auto &u: g[v]) {
        if (!used[u]) {
            dfs(u, g);
            ++chld;
        }
    }
    if (chld == 0 || (v == 0 && chld == 1)) {
        lst.push_back(v);
    }
}

void dfs2(int v, vector<vector<int>> &g) {
    used2[v] = 1;
    for (auto &u: g[v]) {
        if (!used2[u]) {
            dfs2(u, g);
        }
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> q1, q2;
    vector<vector<int>> g(n), g2(n);
    vector<int> cnt(n), cnt0(n);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        q1.insert({u, v});
        q1.insert({v, u});
        cnt0[v]++;
        cnt0[u]++;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    pair<int, int> odin{-1, -1};
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        cnt[u]++;
        cnt[v]++;
        q2.insert({u, v});
        q2.insert({v, u});
        if (q1.find({u, v}) != q1.end()) {
            odin = {u, v};
        }
        g2[u].push_back(v);
        g2[v].push_back(u);
    }
    if (odin.first != -1) {
        deque<pair<int, int>> ans;
        for (int i = 0; i < n; ++i) {
            if (i == odin.first || i == odin.second) {
                continue;
            }
            if (q1.find({i, odin.first}) == q1.end() && q1.find({i, odin.second}) == q1.end()) {
                if (q2.find({i, odin.first}) == q2.end()) {
                    ans.emplace_front(i, odin.first);
                } else {
                    ans.emplace_back(i, odin.second);
                }
            }
        }
        cout << "Yes\n" << ans.size() << '\n';
        for (auto &[i, j]: ans) cout << i + 1 << ' ' << j + 1 << '\n';
        return;
    }
    deque<pair<int, int>> ans;

    if (1ll * m2 == 1ll * n * (n - 1) / 2) {
        if (m1 == 0 && n == 3) {
            cout << "No\n";
            return;
        }
        for (int i = 0; i < n - 1; ++i) {
            if (q1.find({i, i + 1}) == q1.end()) {
                if (q2.find({i, i + 1}) == q2.end()) {
                    ans.emplace_front(i, i + 1);
                } else {
                    ans.emplace_back(i, i + 1);
                }
            }
        }
        cout << "Yes\n" << ans.size() << '\n';
        for (auto &[i, j]: ans) cout << i + 1 << ' ' << j + 1 << '\n';
        return;
    }

    for (int i = 0; i < n; ++i) {
        used[i] = 0;
        used2[i] = 0;
    }
    dfs2(0, g);
    bool f = true;
    for (int i = 1; i < n; ++i) {
        if (used2[i] == 0) {
            f = false;
            break;
        }
    }
    if (f) {
        cout << "Yes\n0\n";
        return;
    }
    lst.clear();
    dfs(0, g2);
    int v = -1;
    for (int i = 0; i < lst.size(); ++i) {
        if (cnt0[lst[i]] != n - 2) {
            v = lst[i];
            break;
        }
    }
    if (v == -1) {
        v = lst[0];
        int v2 = 0;
        for (int i = 0; i < n; ++i) {
            if (i == v) {
                continue;
            } else if (q1.find({i, v}) == q1.end()) {
                v2 = i;
                break;
            }
        }
        vector<int> vec;
        for (int i = 0; i < n; ++i) {
            if (i == v2) {
                continue;
            } else if (q2.find({i, v2}) != q2.end()) {
                vec.push_back(i);
                continue;
            }
            ans.emplace_front(i, v);
            break;
        }
        if (!ans.empty()) {
            cout << "Yes\n" << ans.size() << '\n';
            for (auto &[i, j]: ans) cout << i + 1 << ' ' << j + 1 << '\n';
            return;
        }
        ans.emplace_front(vec[0], vec[1]);
        ans.emplace_back(v2, vec[0]);
        cout << "Yes\n" << ans.size() << '\n';
        for (auto &[i, j]: ans) cout << i + 1 << ' ' << j + 1 << '\n';
        return;
    }

    for (int i = 0; i < n; ++i) {
        if (i == v || q1.find({i, v}) != q1.end()) {
            continue;
        }
        if (q2.find({i, v}) == q2.end()) {
            ans.emplace_front(i, v);
        } else {
            ans.emplace_back(i, v);
        }
    }
    cout << "Yes\n" << ans.size() << '\n';
    for (auto &[i, j]: ans) cout << i + 1 << ' ' << j + 1 << '\n';
    /* vector<pair<int, int>> cnt1;
   for (int i = 0; i < n; ++i) {
       cnt1.emplace_back(cnt[i], i);
   }
   std::sort(cnt1.begin(), cnt1.end());;
   int v = -1;
   for (int i = 0; i < n; ++i) {
       if (cnt0[cnt1[i].second] == n - 1) {
           cout << "Yes\n";
           cout << 0;
           return;
       } else if (cnt0[cnt1[i].second] < n - 2) {
           v = cnt1[i].second;
           break;
       } else if (cnt[cnt1[i].second] >= 2) {
           v = cnt1[i].second;
           break;
       }
   }
   if (v == -1) {
       cout << "Yes\n";
       cout << 0;
       return;
   }
   for (int i = 0; i < n; ++i) {
       if (i == v || q1.find({i, v}) != q1.end()) {
           continue;
       }
       ans.emplace_back(i, v);
   }
   cout << "Yes\n" << ans.size() << '\n';
   for (auto &[i, j] : ans) cout << i + 1 << ' ' << j + 1 << '\n';
//    return;*/
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t >> group;
    while (t--) {
        solve();
    }
    return 0;
}
