#ifdef Local
#include "debug.h"
#else
#include <bits/stdc++.h>
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

template<class A, class B>
bool smin(A& x, B&& y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}

template<class A, class B>
bool smax(A& x, B&& y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

const int maxn = 3e5 + 10;
set<int> g1[maxn], g2[maxn];

void solve() {
	int n, m1, m2;
	cin >> n >> m1 >> m2;
	fill(g1, g1 + n + 1, set<int>{});
	fill(g2, g2 + n + 1, set<int>{});
	for (int i = 0, v, u; i < m1; ++i) {
		cin >> v >> u;
		g1[v].insert(u);
		g1[u].insert(v);
	}
	for (int i = 0, v, u; i < m2; ++i) {
		cin >> v >> u;
		g2[v].insert(u);
		g2[u].insert(v);
	}
	vector<pair<int, int>> ans;
	for (int v = 3; v <= n; ++v) {
		if (g1[1].count(v) || g1[2].count(v))
			continue;
		if (g2[1].count(v))
			ans.emplace_back(2, v);
		else
			ans.emplace_back(1, v);
	}
	cout << sz(ans) << endl;
	for (auto& [a, b] : ans)
		cout << a << ' ' << b << endl;
}

/* 

3 0

3 0 3
1 2
2 3
1 3

4 2 3
1 2
3 4
1 3
1 4
2 3

4 3 3
1 2
2 3
1 3
1 4
2 4
3 4

*/

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int _t = 1, _g;
	cin >> _t >> _g;
	while (_t--)
		solve();

	return 0;
}
