#ifdef Local

#include "debug.h"

#else
#include <bits/stdc++.h>
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

template<class A, class B>
bool smin(A &x, B &&y) {
        if (x > y) {
                x = y;
                return true;
        }
        return false;
}

template<class A, class B>
bool smax(A &x, B &&y) {
        if (x < y) {
                x = y;
                return true;
        }
        return false;
}

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

const int maxn = 3e5 + 10;
set<int> g1[maxn], g2[maxn];

void solve() {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        fill(g1, g1 + n + 1, set<int>{});
        fill(g2, g2 + n + 1, set<int>{});
        for (int i = 0, v, u; i < m1; ++i) {
                cin >> v >> u;
                g1[v].insert(u);
                g1[u].insert(v);
        }
        for (int i = 0, v, u; i < m2; ++i) {
                cin >> v >> u;
                g2[v].insert(u);
                g2[u].insert(v);
        }
        int a = -1, b = -1;
        for (int v = 1; v <= n; ++v) {
                for (int u: g1[v]) {
                        if (g2[v].count(u)) {
                                a = v, b = u;
                                break;
                        }
                }
                if (a != -1)
                        break;
        }
        vector<pair<int, int>> ans;
        if (a == -1) {
                for (int v = 1; v <= n; ++v) {
                        set<int> s = g1[v];
                        for (int i: g2[v])
                                s.insert(i);
                        if (sz(s) == n - 1)
                                continue;
                        a = v;
                        for (b = 1; b <= n; ++b)
                                if (!s.count(b) && b != v)
                                        break;
                        break;
                }
                ans.emplace_back(a, b);
        }
        debug(a);
        debug(b);
        for (int v = 1; v <= n; ++v) {
                if (v == a || v == b)
                        continue;
                if (g1[a].count(v) || g1[b].count(v))
                        continue;
                if (g2[a].count(v))
                        ans.emplace_back(b, v);
                else
                        ans.emplace_back(a, v);
        }
        cout << "Yes" << endl;
        cout << sz(ans) << endl;
        for (auto &[x, y]: ans)
                cout << x << ' ' << y << endl;
}

/* 

3 0

3 0 3
1 2
2 3
1 3

4 2 3
1 2
3 4
1 3
1 4
2 3

4 3 3
1 2
2 3
1 3
1 4
2 4
3 4

*/

signed main() {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);

        int _t = 1, _g;
        cin >> _t >> _g;
        while (_t--)
                solve();

        return 0;
}
