#ifdef Local

#include "debug.h"

#else
#include <bits/stdc++.h>
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

template<class A, class B>
bool smin(A &x, B &&y) {
        if (x > y) {
                x = y;
                return true;
        }
        return false;
}

template<class A, class B>
bool smax(A &x, B &&y) {
        if (x < y) {
                x = y;
                return true;
        }
        return false;
}

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

const int maxn = 3e5 + 10;
set<int> g1[maxn], g2[maxn];

int a, b;

int used[maxn], cnt;

void dfs0(int v) {
        used[v] = 1;
        for (int u: g1[v])
                if (!used[u])
                        dfs0(u);
}

void dfs1(int v) {
        used[v] = 1;
        for (int u: g2[v])
                if (!used[u])
                        dfs1(u);
}

void solve() {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        fill(g1, g1 + n + 1, set<int>{});
        fill(g2, g2 + n + 1, set<int>{});
        for (int i = 0, v, u; i < m1; ++i) {
                cin >> v >> u;
                g1[v].insert(u);
                g1[u].insert(v);
        }
        for (int i = 0, v, u; i < m2; ++i) {
                cin >> v >> u;
                g2[v].insert(u);
                g2[u].insert(v);
        }
        fill(used, used + n + 1, 0ll);
        cnt = 0;
        dfs0(1);
        if (cnt == n) {
                cout << "Yes" << endl;
                cout << 0 << endl;
                return;
        }
        a = -1, b = -1;
        for (int v = 1; v <= n; ++v) {
                for (int u: g1[v]) {
                        if (g2[v].count(u)) {
                                a = v, b = u;
                                break;
                        }
                }
                if (a != -1)
                        break;
        }
        vector<pair<int, int>> ans;
        if (a == -1) {
                for (int v = 1; v <= n; ++v) {
                        set<int> s = g1[v];
                        for (int i: g2[v])
                                s.insert(i);
                        if (sz(s) == n - 1)
                                continue;
                        a = v;
                        for (b = 1; b <= n; ++b)
                                if (!s.count(b) && b != v)
                                        break;
                        break;
                }
                if (a != -1)
                        ans.emplace_back(a, b);
        }
        debug(a);
        debug(b);
        if (a == -1) {
                if (n == 3) {
                        cout << "No" << endl;
                        return;
                } // ???
                if (m1 == 0) {
                        cout << "Yes" << endl;
                        cout << n - 1 << endl;
                        for (int i = 2; i < n; ++i)
                                cout << 1 << ' ' << i << endl;
                        cout << 2 << ' ' << n << endl;
                        return;
                }
                for (int v = 1; v <= n; ++v) {
                        if (sz(g1[v])) {
                                a = v, b = *g1[v].begin();
                                break;
                        }
                }
                for (int c = 1; c <= n; ++c) {
                        if (c == a || c == b)
                                continue;
                        if (g2[a].count(b) && g2[b].count(b)) {
                                g2[a].erase(c);
                                fill(used, used + n + 1, 0ll);
                                cnt = 0;
                                dfs1(1);
                                if (cnt != n) {
                                        g2[a].insert(c);
                                        g2[b].erase(c);
                                        fill(used, used + n + 1, 0ll);
                                        cnt = 0;
                                        dfs1(1);
                                        if (cnt != n) {
                                                g2[b].insert(c);
                                                continue;
                                        }
                                        g1[b].insert(c);
                                } else
                                        g1[a].insert(c);
                        }
                        vector<pair<int, int>> ans;
                        if (!g2[a].count(c))
                                ans.emplace_back(a, c);
                        for (int v = 1; v <= n; ++v) {
                                if (v == a || v == b || v == c)
                                        continue;
                                if (g1[a].count(v) || g1[b].count(v) || g1[c].count(v))
                                        continue;
                                if (g2[a].count(v)) {
                                        if (g2[b].count(v)) {
                                                ans.emplace_back(c, v);
                                        } else
                                                ans.emplace_back(b, v);
                                } else
                                        ans.emplace_back(a, v);
                        }
                        cout << "Yes" << endl;
                        cout << sz(ans) << endl;
                        assert(sz(ans) <= n);
                        for (auto &[x, y]: ans)
                                cout << x << ' ' << y << endl;
                        return;
                }
                cout << "No" << endl;
                return;
        }
        for (int v = 1; v <= n; ++v) {
                if (v == a || v == b)
                        continue;
                if (g1[a].count(v) || g1[b].count(v))
                        continue;
                if (g2[a].count(v))
                        ans.emplace_back(b, v);
                else
                        ans.emplace_back(a, v);
        }
        cout << "Yes" << endl;
        cout << sz(ans) << endl;
        assert(sz(ans) <= n);
        for (auto &[x, y]: ans)
                cout << x << ' ' << y << endl;
}

/* 

3 0

3 0 3
1 2
2 3
1 3

4 2 3
1 2
3 4
1 3
1 4
2 3

4 3 3
1 2
2 3
1 3
1 4
2 4
3 4

*/

signed main() {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);

        int _t = 1, _g;
        cin >> _t >> _g;
        while (_t--)
                solve();

        return 0;
}
