#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
using namespace std;
vector<vector<int>> g1, g2;
vector<int>col;
int timer = 0;
void pokras(int v){
    col[v] = timer;
    for(auto& to : g1[v]){
        if(col[to] != -1) continue;
        pokras(to);
    }
}

vector<int>dp, tin;
set<pii>br;
void find_b(int v, int p){
    tin[v] = ++timer;
    dp[v] = tin[v];
    for(auto& to : g2[v]){
        if(to == p) continue;
        if(tin[to] != -1){
            dp[v] = min(dp[v], tin[to]);
            continue;
        }
        find_b(to, v);
        dp[v] = min(dp[v], dp[to]);
        if(dp[to] > tin[v]){
            br.insert({min(v, to), max(v, to)});
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t, gr;
    cin >> t >> gr;

    while(t--){
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        g1.assign(n, {});
        g2.assign(n, {});
        for(int i = 0; i < m1; i++){
            int u, v;
            cin >> u >> v;
            u--; v--;
            g1[u].push_back(v);
            g1[v].push_back(u);
        }

        for(int i = 0; i < m2; i++){
            int u, v;
            cin >> u >> v;
            u--; v--;
            g2[u].push_back(v);
            g2[v].push_back(u);
        }

        col.assign(n, -1ll);
        timer = 0;
        for(int i = 0; i < n; i++){
            if(col[i] == -1){
                pokras(i);
                ++timer;
            }
        }
        br.clear();
        if(gr == 3){
            dp.assign(n, -1ll);
            tin.assign(n, -1ll);
            find_b(0, -1);

            int res1 = -1, res2 = -1;
            for(int i = 0; i < n; i++){
                for(int j = i + 1; j < n; j++){
                    if(col[i] == col[j]) continue;
                    if(br.find({i, j}) == br.end()){
                        res1 = i;
                        res2 = j;
                        break;
                    }
                }
                if(res1 != -1) break;
            }
            if(res1 == -1) {
                cout << "No\n";
            } else {
                cout << "Yes\n";
                cout << 1 << '\n';
                cout << res1 + 1 << ' ' << res2 + 1 << '\n';
            }
        }
    }

    return 0;
}
