#include<iostream>
#include<vector>
#include<string>
#include<sstream>
#include<set>
#include<map>
#include<unordered_map>
#include<cmath>
#include<algorithm>
#include<stdio.h>
#include<random>
#include<ctime>
#include<memory.h>
#include<stack>
#include<deque>
#include<queue>
#include<cstdlib>
#include<iomanip>
#include<unordered_set>
#define int long long
#define pii pair<int, int>
#define pb push_back
#define fir first
#define sec second
#define endl '\n'
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

mt19937 rnd(228);

void dfs1(vector<int>& used, vector<vector<int>>& gr, int v) {
	used[v] = 1;
	for (int i = 0; i < gr.size(); i++) {
		if (gr[v][i] == 1 && !used[i]) {
			dfs1(used, gr, i);
		}
	}
}

bool check(vector<vector<int>> gr1, vector<vector<int>> gr2, vector<pii>& ed, vector<int>& pr) {
	for (int i : pr) {
		int a = ed[i].first, b = ed[i].second;
		gr1[a][b] = (gr1[a][b] + 1) % 2;
		gr1[b][a] = (gr1[b][a] + 1) % 2; 
		gr2[a][b] = (gr2[a][b] + 1) % 2; 
		gr2[b][a] = (gr2[b][a] + 1) % 2;
		vector<int> used(gr2.size(), 0);
		dfs1(used, gr2, 0);
		bool fl = 1;
		for (int i = 0; i < gr2.size(); i++) {
			if (!used[i])
				fl = 0;
		}
		if (!fl)
			return 0;
	} 
	vector<int> used(gr1.size(), 0);
	dfs1(used, gr1, 0);
	bool fl = 1;
	for (int i = 0; i < gr1.size(); i++) {
		if (!used[i])
			fl = 0;
	}
	if (!fl)
		return 0;
	return 1;
}


void solve1(int n, int m1, int m2, vector<vector<int>>& g1, vector<vector<int>>& g2) {
	vector<pii> ed;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++)
			ed.pb({ i,j });
	}

	for (int mask = 0; mask < (1LL << (n * (n - 1) / 2)); mask++) {
		vector<pii> ee;
		int msk = mask;
		for (int i = 0; i < n * (n - 1) / 2; i++) {
			if (msk & 1) {
				ee.pb(ed[i]);
			}
			msk >>= 1;
		}
		if (ee.size() > n)
			continue;

		vector<int> pr;
		for (int i = 0; i < ee.size(); i++)
			pr.pb(i);

		do {
			if (check(g1, g2, ee, pr)) {
				cout << "Yes" << endl;
				cout << ee.size() << endl;
				for (int i : pr)
					cout << ee[i].first + 1 << " " << ee[i].second + 1 << endl;
				return;
			}
		} while (next_permutation(all(pr)));
	}
	cout << "No" << endl;
	return;
}

signed main() { 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.precision(17);
	cout << fixed;

	int t, g;
	cin >> t >> g;

	while (t--) {
		int n, m1, m2;
		cin >> n >> m1 >> m2;
		vector<vector<int>> g1(n, vector<int>(n)), g2(n, vector<int>(n));
		for (int i = 0; i < m1; i++) {
			int a, b;
			cin >> a >> b;
			a--;
			b--;
			g1[a][b] = 1;
			g1[b][a] = 1;
		}
		for (int i = 0; i < m2; i++) {
			int a, b;
			cin >> a >> b;
			a--;
			b--;
			g2[a][b] = 1;
			g2[b][a] = 1;
		}

		if (g <= 1) {
			solve1(n, m1, m2, g1, g2);
		}
	}
}
