#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int ll
#define f first
#define s second
#define vec vector
#define ll long long
#define pb push_back
#define ld long double
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

using pii = pair < int, int >;
using pll = pair < ll, ll >; 

template < typename T>
bool umx (T &a, T b) { return (a < b ? (a = b, 1) : 0); }

template < typename T>
bool umn (T &a, T b) { return (a > b ? (a = b, 1) : 0); }

template < typename T>
using oset = tree < T, null_type, less < T > , rb_tree_tag, tree_order_statistics_node_update>;

const int N = 3e5;
const int oo = 1e9;
const ll OO = 1e18;

int gr;

int p[N], s[N];

int get (int v) {
    if (v == p[v]) return v;
    return (p[v] = get(p[v]));
}

bool merge (int u, int v) {
    u = get(u), v = get(v);
    if (u == v)
        return false;

    if (s[u] < s[v])
        swap(u, v);
    p[v] = u;
    s[u] += s[v];

    return true;
}

void solve () {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    if (gr == 5) {
        iota(p, p + N, 0);
        fill(s, s + N, 1);
        int c = n - 1;
        vec < bool > ok(n);
        set < pii > berl;
        for (int i = 0, u, v; i < m1; ++i) {
            cin >> u >> v;
            --u, --v;
            berl.insert({u, v});
            if (merge(u, v))
                c--;
        }
        vec < pii > ans;
        for (int i = 0, u, v; i < m2; ++i)
            cin >> u >> v;

        for (int u = 1; u < n; ++u) {
            for (int v = u + 1; v < n; ++v) {

                if (merge(u, v)) {
                    ans.pb({u, v});
                    berl.insert({u, v});
                    ok[u] = ok[v] = 1;
                }

            }
        }


        for (int i = 1; i < n; ++i) {
            if (ok[i] && merge(0, i)) {

                if (!ok[i]) {

                    for (int j = 1; j < n; ++j) {
                        if (j == i) continue;
                        if ((berl.find({i, j}) == berl.end()) && (berl.find({j, i}) == berl.end())) {
                            ans.pb({i, j});
                            ok[i] = 1;
                            break;
                        }
                    }
                    if (!ok[i]) {
                        cout << "No\n";
                        return;
                    }
                }
                ans.pb({0, i});
            }
        }

        for (int i = 1; i < n; ++i) {
            if (merge(0, i)) {

                for (int j = 1; j < n; ++j) {
                    if (j == i) continue;
                    if ((berl.find({i, j}) == berl.end()) && (berl.find({j, i}) == berl.end()) || rand() % 3) {
                        ans.pb({i, j});
                        ok[i] = 1;
                        break;
                    }
                }
                if (!ok[i]) {
                    cout << "No\n";
                    return;
                }
                ans.pb({0, i});
            }
        }
        if (sz(ans) > n - 1) {
            cout << "No\n";
            return;
        }
        cout << "Yes\n";
        cout << sz(ans) << "\n";
        for (auto [a, b] : ans)
            cout << a + 1 << " " << b + 1 << "\n";

    }
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t >> gr;
    while (t--)
        solve();
}
