#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3", "unroll-loops", "fast-math")
//#pragma GCC target("avx2")

#define int long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pb push_back
#define f first
#define s second

using namespace std;
using namespace __gnu_pbds;

using pii = pair <int, int>;
using oset = tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>;

const int INF = 1e16 + 1337;
const int N = 3e5 + 1337;
vector <int> g1[N], g2[N];
int a[N];
int g;

int pr[N], c[N];

int get(int u) {
    if (u == pr[u])
        return u;

    return pr[u] = get(pr[u]);
}

void mrg(int r1, int r2) {
    if (r1 == r2)
        return;

    if (c[r1] < c[r2])
        swap(r1, r2);

    c[r1] += c[r2];
    pr[r2] = r1;
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    for (int i = 0; i < n; i++)
        pr[i] = i, c[i] = 1;

    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        mrg(u, v);
        g1[u].pb(v);
        g1[v].pb(u);
    }

    bool gd[n][n];
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            gd[i][j] = true;

    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        gd[u][v] = gd[v][u] = false;
        g2[u].pb(v);
        g2[v].pb(u);
    }

    vector <pii> v;
    for (int u = 0; u < n; u++) {
        for (int vn = 0; vn < u; vn++)
            if (gd[u][vn])
                v.pb({u, vn});
    }

    for (auto& [u, v] : v) {
        if (get(u) == get(v))
            continue;

        cout << "YES\n1\n";
        cout << u + 1 << " " << v + 1 << "\n";
        return;
    }

    cout << "NO\n";


//    if (g == 3) {
//
//    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t >> g;
    while (t--)
        solve();
}
