#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vector deque



bool is_matrix_good(vector<vector<bool>> & matrix) {
    set<int> all;
    vector<int> ord;
    ord.push_back(1);
    all.insert(1);
    while (ord.size() > 0) {
        vector<int> new_ord;
        for (auto v : ord) {
            for (int u = 1; u < matrix.size(); u++) {
                if (all.find(u) == all.end() && matrix[v][u]) {
                    all.insert(u);
                    new_ord.push_back(u);
                }
            }
        }
        ord = new_ord;
    }
    if (all.size() == matrix.size() - 1) {
        return true;
    }
    return false;
}


bool protivopoloznoe(bool q) {
    if (q) {
        return false;
    }
    return true;
}

void slow_solution(int n, vector<vector<int>> edges_a, vector<vector<int>> edges_b) {
    vector<vector<bool>> matrix_a(n + 1, vector<bool>(n + 1, false));
    vector<vector<bool>> matrix_b(n + 1, vector<bool>(n + 1, false));
    for (int i = 1; i <= n; i++) {
        for (auto v : edges_a[i]) {
            matrix_a[i][v] = true;
            matrix_a[v][i] = true;
        }
        for (auto v : edges_b[i]) {
            matrix_b[i][v] = true;
            matrix_b[v][i] = true;
        }
    }
    vector<pair<int, int>> lst_of_could_edges;
    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            lst_of_could_edges.push_back({i, j});
        }
    }
    int siz = lst_of_could_edges.size();
    for (int mask = 0; mask < (1 << siz); mask++) {
        for (int i = 0; i < lst_of_could_edges.size(); i++) {
            int a = lst_of_could_edges[i].first, b = lst_of_could_edges[i].second;
            if ((mask >> i) & 1) {
                matrix_a[a][b] = protivopoloznoe(matrix_a[a][b]);
                matrix_a[b][a] = protivopoloznoe(matrix_a[b][a]);
                matrix_b[a][b] = protivopoloznoe(matrix_b[a][b]);
                matrix_b[b][a] = protivopoloznoe(matrix_b[b][a]);
            }
        }
        if (is_matrix_good(matrix_a) && is_matrix_good(matrix_b)) {
            int q = 0;
            for (int i = 0; i < lst_of_could_edges.size(); i++) {
                int a = lst_of_could_edges[i].first, b = lst_of_could_edges[i].second;
                if ((mask >> i) & 1) {
                    q++;
                }
            }
            if (q <= n) {
                cout << "Yes" << endl;
                cout << q << endl;
                for (int i = 0; i < lst_of_could_edges.size(); i++) {
                    int a = lst_of_could_edges[i].first, b = lst_of_could_edges[i].second;
                    if ((mask >> i) & 1) {
                        cout << a << " " << b << endl;
                    }
                }
                return;
            }
        }
        for (int i = 0; i < lst_of_could_edges.size(); i++) {
            int a = lst_of_could_edges[i].first, b = lst_of_could_edges[i].second;
            if ((mask >> i) & 1) {
                matrix_a[a][b] = protivopoloznoe(matrix_a[a][b]);
                matrix_a[b][a] = protivopoloznoe(matrix_a[b][a]);
                matrix_b[a][b] = protivopoloznoe(matrix_b[a][b]);
                matrix_b[b][a] = protivopoloznoe(matrix_b[b][a]);
            }
        }
    }
    cout << "No" << endl;
}


void enter(int g) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> edges_a(n + 1, vector<int>());
    vector<vector<int>> edges_b(n + 1, vector<int>());
    set<pair<int, int>> all_edges_a;
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        edges_a[a].push_back(b);
        edges_a[b].push_back(a);
        all_edges_a.insert({a, b});
        all_edges_a.insert({b, a});
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        edges_b[a].push_back(b);
        edges_b[b].push_back(a);
    }
    cout << "Yes" << endl;
    vector<pair<int, int>> lst;
    for (int i = 1; i + 1 <= n; i++) {
        if (all_edges_a.find({i, i + 1}) == all_edges_a.end()) {
            lst.push_back({i, i + 1});
        }
    }
    cout << lst.size() << endl;
    for (auto pai : lst) {
        cout << pai.first << " " << pai.second << endl;
    }

}


signed main() {
    cout.precision(15);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t, g;
    cin >> t >> g;
    for (; t > 0; --t) {
        enter(g);
    }

}



