#include<iostream>
#include<vector>
#include<map>
#include<set>
#include <algorithm>
#include <queue>
using namespace std;
using ll = long long; 
#define f(i, n) for(int i = 0; i < int(n); i++)

void solve() {
	ll n, m1, m2; 
	cin >> n >> m1 >> m2;
	map<pair<ll, ll>, bool> a, g; 
	set<pair<ll, ll>> all; 
	f(i, m1) {
		ll u, v;
		cin >> u >> v;
		if (u > v) swap(u, v);
		all.insert({ u, v }); 
		a[{u, v}] = true;
	}
	f(i, m2) {
		ll u, v;
		cin >> u >> v;
		if (u > v) swap(u, v); 
		g[{u, v}] = true; 
		all.insert({ u, v }); 
	}
	ll x = -1, y = -1; 
	for (auto i : all) {
		if(a[i] && g[i]) {
			x = i.first, y = i.second; 
		}
	}
	//cout << x << ' ' << y << '\n' << '\n';
	if (x != -1) {
		vector<pair<ll, ll>> ans;
		for (ll i = 1; i <= n; i++) {
			if (i != x && i != y) {
				/*
				if ((a[{min(x, i), max(x, i)}] && g[{min(y, i), max(y, i)}])
					|| (a[{min(y, i), max(y, i)}] && g[{min(x, i), max(x, i)}])
					|| (a[{min(x, i), max(x, i)}] && g[{min(x, i), max(x, i)}])
					|| (a[{min(y, i), max(y, i)}] && g[{min(y, i), max(y, i)}])) {
					continue; 
				}*/
				if (!a[{min(x, i), max(x, i)}] && !g[{min(x, i), max(x, i)}]) {
					ans.push_back({ i, x }); 
					continue; 
				}
				if (!a[{min(y, i), max(y, i)}] && !g[{min(y, i), max(y, i)}]) {
					ans.push_back({ i, y });
					continue;
				}
				if (!a[{min(y, i), max(y, i)}] && g[{min(x, i), max(x, i)}]) {
					ans.push_back({ i, y });
					continue;
				}
				if (!a[{min(x, i), max(x, i)}] && g[{min(y, i), max(y, i)}]) {
					ans.push_back({ i, x });
					continue;
				}
				if (!g[{min(y, i), max(y, i)}] && a[{min(x, i), max(x, i)}]) {
					ans.push_back({ i, y });
					continue;
				}
				if (!g[{min(x, i), max(x, i)}] && a[{min(y, i), max(y, i)}]) {
					ans.push_back({ i, x });
					continue;
				}
			}
		}
		cout << "Yes\n"; 
		cout << ans.size() << '\n'; 
		for (auto i : ans) {
			cout << i.first << ' ' << i.second << '\n';
		}
		return; 
	}
	cout << "No\n"; 
}

int main()
{	
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0); 
	ll t, g;
	cin >> t >> g;
	while (t--) {
		solve(); 
	}
}