//#pragma GCC optimize("O3", "unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define eb emplace_back
#define F first
#define S second
#define vec vector
#define all(x) (x).begin(), (x).end()

//#pragma GCC target("avx2")

using vi = vector<int>;
using str = string;
using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template<typename A>
void print(A &a, str sep=" "){
    for(auto &i: a)cout << i << sep;
    cout << "\n";
}
template<typename A>
void read(A &a){
    for(auto &i: a)cin >> i;
}

const int bs = 320;
const int inf = 1e18;

int T;
int n, m1, m2;
vec<vi> g1, g2;

void col1(int u, vi &used, vi &col){
    used[u] = 1;
    for(int v: g1[u])if(!used[v]){
        col[v] = col[u];
        col1(v, used, col);
    }
}

void solve(){
    cin >> n >> m1 >> m2;
    g1 = g2 = vec<vi>(n);
    for(int i = 0; i < m1; ++i){
        int u, v; cin >> u >> v;
        u--; v--;
        g1[u].pb(v);
        g1[v].pb(u);
    }
    for(int i = 0; i < m2; ++i){
        int u, v; cin >> u >> v;
        u--; v--;
        g2[u].pb(v);
        g2[v].pb(u);
    }

    if(T == 3){
        vi fst, sec;
        vi col(n, -1);
        vi used(n, 0);
        for(int i = 0; i < n; ++i)if(!used[i]){
            col[i] = (i == 0);
            col1(i, used, col);
        }

        for(int i = 0; i < n; ++i){
            if(col[i] == 0)fst.pb(i);
            else sec.pb(i);
        }
        set<pii> ed2;
        for(int i = 0; i < n; ++i){
            for(int v: g2[i]){
                if(v > i)ed2.emplace(i, v);
            }
        }
        for(int i: fst){
            for(int j: sec){
                pii cur = {min(i, j), max(i, j)};
                if(!ed2.count(cur)){
                    cout << "Yes\n";
                    cout << 1 << "\n";
                    cout << i + 1 << " " << j + 1 << "\n";
                    return;
                }
            }
        }
        cout << "No\n";
    }

}


signed main() {
#ifdef LOCAL
    freopen("inp", "r", stdin);
#else
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#endif

    //clock_t start = clock();
    int TT = 1;
    cin >> TT >> T;
    while(TT--){
        solve();
    }
//    clock_t end = clock();
//    cout.precision(16);
//    cout << fixed;
//    cout << (ld)(end - start) / CLOCKS_PER_SEC << "\n";
    return 0;
}
