//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
using ll = long long;
using ld = long double;
const ll INF = 2e9, MOD = 1e9 + 7, N = 2e5 + 10, K = 500 + 5;
mt19937 rnd(24246);


void solve() {

    int n, m1, m2;
    cin >> n >> m1 >> m2;

    set<pair<int, int>> ed;
    vector<int> g1[n + 1], g2[n + 1];
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        g1[a].push_back(b);
        g1[b].push_back(a);
        ed.insert({a, b});
        ed.insert({b, a});
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        g2[a].push_back(b);
        g2[b].push_back(a);
    }
    if (n == 1) {
        cout << "Yes\n0\n";
        return;
    }
    vector<pair<int, int>> ans;
    bool f = 0;
    for (int i = 2; i < n; i++) {
        if (ed.find({1, i}) != ed.end()) {
            f = 1;
            continue;
        }
        ans.push_back({1, i});
    }
    if (f) {
        if (ed.find({1, n}) == ed.end())
            ans.push_back({1, n});
    } else if (ed.find({2, n}) == ed.end())
        ans.push_back({2, n});
    if ((n == 3 && m1 == 0)) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    cout << ans.size() << endl;
    for (auto [u, v]: ans) {
        cout << u << " " << v << "\n";
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    cin >> tt;
    int gr;
    cin >> gr;
    while (tt--) {
        solve();
    }
    return 0;
}
