    //#pragma GCC optimize("O3")
    //#pragma GCC optimize("unroll-loops")

    #include <bits/stdc++.h>

    using namespace std;

    #define int long long
    using ll = long long;
    using ld = long double;
    const ll INF = 2e9, MOD = 1e9 + 7, N = 2e5 + 10, K = 500 + 5;
    mt19937 rnd(24246);


    void solve() {

        int n, m1, m2;
        cin >> n >> m1 >> m2;

        set<pair<int, int>> ed;
        vector<int> g1[n + 1], g2[n + 1];
        for (int i = 0; i < m1; i++) {
            int a, b;
            cin >> a >> b;
            g1[a].push_back(b);
            g1[b].push_back(a);
            ed.insert({a, b});
            ed.insert({b, a});
        }
        for (int i = 0; i < m2; i++) {
            int a, b;
            cin >> a >> b;
            g2[a].push_back(b);
            g2[b].push_back(a);
        }
        if (n == 1) {
            cout << "Yes\n0\n";
            return;
        }
        vector<pair<int, int>> ans;
        bool f = 0;
        for (int i = 2; i < n; i++) {
            if (ed.find({1, i}) != ed.end()) {
                f = 1;
                continue;
            }
            ans.push_back({1, i});
        }
        if (f || ed.find({1, n}) != ed.end()) {
            if (ed.find({1, n}) == ed.end())
                ans.push_back({1, n});
        } else if (ed.find({2, n}) == ed.end())
            ans.push_back({2, n});
        if ((n == 3 && m1 == 0)) {
            cout << "No\n";
            return;
        }
        cout << "Yes\n";
        cout << ans.size() << endl;
        for (auto [u, v]: ans) {
            cout << u << " " << v << "\n";
        }
    }

    vector<int> p, sz;

    int get_p(int v) {
        if (p[v] == v) return v;
        return p[v] = get_p(p[v]);
    }

    void merge(int v, int u) {
        v = get_p(v), u = get_p(u);
        if (v == u) return;
        p[u] = v;
        sz[v] += sz[u];
    }

    void solve2() {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        p.assign(n + 1, 0);
        sz.assign(n + 1, 1);
        for (int i = 1; i <= n; i++) {
            p[i] = i;
        }
        set<pair<int, int>> ed1, ed2;
        vector<int> g1[n + 1], g2[n + 1];
        for (int i = 0; i < m1; i++) {
            int a, b;
            cin >> a >> b;
            g1[a].push_back(b);
            g1[b].push_back(a);
    //        merge(a, b);
            ed1.insert({a, b});
            ed1.insert({b, a});
        }
        for (int i = 0; i < m2; i++) {
            int a, b;
            cin >> a >> b;
            g2[a].push_back(b);
            g2[b].push_back(a);
            ed2.insert({a, b});
            ed2.insert({b, a});
        }
        vector<pair<int, int>> ans;
        for (int i = 3; i <= n; i++) {
            if (ed1.find({1, i}) != ed1.end() || ed1.find({2, i}) != ed1.end()) continue;
            if (ed2.find({1, i}) != ed2.end() && ed2.find({2, i}) != ed2.end()) ans.push_back({1, i});
            else if (ed2.find({1, i}) != ed2.end()) ans.push_back({2, i});
            else ans.push_back({1, i});
        }

        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (auto [u, v] : ans) {
            cout << u << " " << v << "\n";
        }
    }

    void solve3() {
        int n, m1, m2;
        cin >> n >> m1 >> m2;

        set<pair<int, int>> ed;
        vector<int> g1[n + 1], g2[n + 1];
        for (int i = 0; i < m1; i++) {
            int a, b;
            cin >> a >> b;
            g1[a].push_back(b);
            g1[b].push_back(a);
            ed.insert({a, b});
            ed.insert({b, a});
        }
        for (int i = 0; i < m2; i++) {
            int a, b;
            cin >> a >> b;
            g2[a].push_back(b);
            g2[b].push_back(a);
        }
        if ((n == 3 && m1 == 0)) {
            cout << "No\n";
            return;
        }
        if (n == 3 && m1 == 1) {
            if (ed.find({2, 3}) != ed.end()) {
                cout << "No\n";
            } else {
                cout << "Yes\n1\n";
                cout << "2 3\n";
            }
            return;
        }
        vector<pair<int, int>> ans;


        bool f = 0;
        for (int i = 3; i <= n; i++) {
            if (ed.find({i - 1, i}) != ed.end()) {
                continue;
            }
            ans.push_back({i - 1, i});
        }
        bool f3 = 0;
        for (int i = 2; i <= n; i++) {
            if (ed.find({1, i}) != ed.end()) {
                f3 = 1;
                break;
            }
        }
        if (!f3) {
            for (int i = 2; i < n; i++) {
                if (ed.find({i, i + 1}) == ed.end()) {
                    ans.push_back({1, i});
                    f3 = 1;
                }
            }
        }
        if (!f3) {
            ans.push_back({1, 2});
            ans.push_back({1, 3});
        }
        cout << "Yes\n";

    }

    signed main() {
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
        int tt = 1;
        cin >> tt;
        int gr;
        cin >> gr;
        while (tt--) {
            if (gr == 2) {
                solve();
            } else if (gr == 7) {
                solve2();
            } else {
                solve3();
            }
        }
        return 0;
    }
