#include <bits/stdc++.h>

#define int long long
using namespace std;

void solve() {
    int n, d, gr;
    cin >> n >> d >> gr;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (a[i] > a[j])continue;
            if (j - i <= d) {
                g[i].push_back(j);
                continue;
            }
            vector<int> z;
            for (int k = i + 1; k < j; ++k) {
                if (a[k] < a[i])z.push_back(k);
            }
            if (z.empty())continue;
            int mx = z[0] - i;
            for (int k = 1; k < z.size(); ++k) {
                mx = max(mx, z[k] - z[k - 1]);
            }
            mx = max(mx, j - z.back());
            if (mx <= d) {
                g[i].push_back(j);
            }
        }
    }
    vector<vector<int>> dist(n, vector<int>(n, INT_MAX));
    for (int i = 0; i < n; ++i) {
        dist[i][i] = 0;
        queue<int> q;
        q.push(i);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int to: g[v]) {
                if (dist[i][to] == INT_MAX) {
                    dist[i][to] = dist[i][v] + 1;
                    q.push(to);
                }
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        u--;
        v--;
        if (dist[u][v] == INT_MAX) {
            cout << 0 << "\n";
            continue;
        }
        if (t == 1) {
            cout << 1 << "\n";
        } else {
            cout << dist[u][v] << "\n";
        }
    }
}

signed main() {
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}