#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define int long long

using namespace std;
typedef long long i64;

struct dsu {
    vector<int> p, sz;
    vector<vector<int>> c;
    dsu(int n) {
        p.assign(n, 0);
        sz.assign(n, 1);
        c.assign(n, {});
        for (int i = 0; i < n; ++i) {
            c[i] = {i};
            p[i] = i;
        }
    }
    int get(int x) {
        if (p[x] != x) {
            p[x] = get(p[x]);
        }
        return p[x];
    }
    bool unite(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) {
            return false;
        } else if (sz[u] > sz[v]) {
            swap(u, v);
        }
        sz[v] += sz[u];
        p[u] = v;
        for (int el : c[u]) {
            c[v].pb(el);
        }
        return true;
    }
    bool same(int u, int v) {
        u = get(u), v = get(v);
        return u == v;
    }
};

void solve() {

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T, g;
    cin >> T >> g;
    while (T--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;

        unordered_set<int> B[n + 1], C[n + 1];
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            B[v].insert(u);
            B[u].insert(v);
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            C[v].insert(u);
            C[u].insert(v);
        }
        vector<bool> used(n + 1, 0), usedd(n + 1, 0);
        int CMPS = 0, CMPSS = 0;
        auto okk = [&] (int V) -> void {
            queue<int> q;
            usedd.assign(n + 1, 0);
            q.push(V);
            CMPSS = 0;
            while (!q.empty()) {
                int v = q.front();
                usedd[v] = 1;
                q.pop();
                ++CMPSS;
                for (auto x : B[v]) {
                    if (!usedd[x]) usedd[x] = 1, q.push(x);
                }
            }
        };
        auto ok = [&] (int V) -> void {
            queue<int> q;
            q.push(V);
            CMPS = 0;
            used.assign(n + 1, 0);
            while (!q.empty()) {
                int v = q.front();
                used[v] = 1;
                q.pop();
                ++CMPS;
                for (auto x : C[v]) {
                    if (!used[x]) used[x] = 1, q.push(x);
                }
            }
        };

        vector<pair<int, int>> edges;
        vector<pair<int, int>> ans;
        for (int i = 1; i <= n; ++i) {
            for (int j = i + 1; j <= n; ++j) {
                edges.pb({i, j});
            }
        }
        for (int msk = 0; msk < (1 << (int)edges.size()); ++msk) {
            vector<pair<int, int>> cur;
            for (int i = 0; i < (int)edges.size(); ++i) {
                if (msk & (1 << i)) {
                    auto [u, v] = edges[i];
                    cur.pb({u, v});
                    if (B[u].find(v) != B[u].end()) B[u].erase(v), B[v].erase(u);
                    else B[u].insert(v), B[v].insert(u);
                    if (C[u].find(v) != C[u].end()) C[u].erase(v), C[v].erase(u);
                    else C[u].insert(v), C[v].insert(u);
                }
            }
            ok(1);
            okk(1);
            if (CMPS == n && CMPSS == n && cur.size() <= n) {
                ans = cur;
                break;
            }
            for (int i = 0; i < (int)edges.size(); ++i) {
                if (msk & (1 << i)) {
                    auto [u, v] = edges[i];
                    if (B[u].find(v) != B[u].end()) B[u].erase(v), B[v].erase(u);
                    else B[u].insert(v), B[v].insert(u);
                    if (C[u].find(v) != C[u].end()) C[u].erase(v), C[v].erase(u);
                    else C[u].insert(v), C[v].insert(u);
                }
            }
        }
        if (ans.empty()) {
            cout << "No\n";
            continue;
        }
        cout << "Yes\n";
        assert((int)ans.size() <= n);
        cout << ans.size() << '\n';
        for (auto [x, y] : ans) {
            cout << x << ' ' << y << '\n';
        }
    }
}
