// #define _GLIBCXX_DEBUG
// #include "bits/stdc++.h"
#include "iostream"
#include "vector"
#include "algorithm"
#include "iomanip"
#include "unordered_set"
#include "cmath"
#include "unordered_map"
#include "set"
#include "map"
#include "random"
#include "queue"
#include "deque"
#include "stack"
#include "numeric"
#include "ext/pb_ds/assoc_container.hpp"
//#pragma GCC optimize("O3,unroll-loops,fast-math,strict-overflow")
//#pragma GCC target("avx2,abm,bmi2,popcnt,lzcnt")
using namespace std;
using namespace __gnu_pbds;
typedef int64_t ll;
typedef uint64_t ull;
typedef __int128 lll;
typedef string str;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
typedef vector<ll> vll;
typedef vector<pll> vpll;
typedef vector<str> vstr;
typedef vector<vll> vvll;
typedef vector<vpll> vvpll;
typedef vector<vvll> vvvll;
using mordered_set = tree<ll, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>;
#define uset unordered_set
#define umap unordered_map
#define mset multiset
#define mp make_pair
#define log(n) __lg(n)
#define read(a) for (auto&  i : a) cin >> i
#define write(a) for (auto v : a) cout << v << " "
#define mod(n, m) ((((n)%(m))+m)%m)
#define min3(a, b, c) min(min(a, b), c)
#define max3(a, b, c) max(max(a, b), c)
#define min4(a, b, c, d) min(min(a, b), min(c, d))
#define max4(a, b, c, d) max(max(a, b), max(c, d))
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debag(x) cerr << (#x) << ": " << (x) << "\n";
#define Yes cout << "Yes" << "\n"
#define No cout << "No" << "\n"
#define YES cout << "YES" << "\n"
#define NO cout << "NO" << "\n"
const ld PI = acos(-1);
const ll mod = 1E9+7;
const ll mod2 = 998244353;
const ll mod3 = 2286661337;
const ll mod4 = 1E9+9;
const ll INF = 2E18;
const ld eps = 2E-8;
random_device rd;
mt19937_64 rnd(rd());
inline void fast() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}
struct dsu{
    ll n;
    vll len;
    vll pred;
    void build(ll x) {
        n = x;
        len.assign(n, 0);
        pred.assign(n, 0);
        for (ll i = 0; i < n; ++i) {
            pred[i] = i;
        }
    }
    ll get(ll x) {
        if (x == pred[x]) return x;
        return pred[x] = get(pred[x]);
    }
    void unite(ll x, ll y) {
        x = get(x);
        y = get(y);
        if (x == y) return;
        if (len[x] > len[y]) swap(x, y);
        if (y == 1) {
            swap(x, y);
        }
        len[y]+=len[x];
        pred[x] = y;
    }
};
void solve(ll g) {
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    vpll a(m1), b(m2);
    for (ll i = 0; i < m1; ++i) {
        cin >> a[i].first >> a[i].second;
        a[i].first--;
        a[i].second--;
    }
    for (ll i = 0; i < m2; ++i) {
        cin >> b[i].first >> b[i].second;
        b[i].first--;
        b[i].second--;
    }
    if (g == 5 || g == 9) {
        dsu q;
        q.build(n);
        for (auto v : a) {
            q.unite(v.first, v.second);
        }
        vll z;
        for (ll i = 0; i < n; ++i) {
            if (q.pred[i] == i) {
                z.push_back(i);
            }
        }
        if (z.size() == 1) {
            cout << "Yes\n";
            cout << 0;
            return;
        }
        if (z[0] != 0) {
            cout << "Yes\n";
            cout << z.size()-1 << "\n";
            for (ll i = 0; i < z.size()-1; ++i) {
                cout << z[i]+1 << " " << z[i+1]+1 << "\n";
            }
        } else {
            cout << "Yes\n";
            cout << z.size()-1 << "\n";
            for (ll i = z.size()-1; i > 0; --i) {
                cout << z[i]+1 << " " << z[i-1]+1 << "\n";
            }
        }
        return;
    }
}
int main() {
    fast();
    //freopen("C://Users//olymp//CLionProjects//untitled//input", "r", stdin);
    //freopen("C://Users//olymp//CLionProjects//untitled//output", "w", stdout);
    ll t, g;
    cin >> t >> g;
    while (t--) {
        solve(g);
        cout << "\n";
    }
    return 0;
}