#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using pii = pair<int, int>;

int t, G;
const int N = 3e5 + 10;
set<int> g1[N], g2[N];

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    for (int i = 1; i <= n; i++) {
        g1[i].clear();
        g2[i].clear();
    }

    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        g1[u].insert(v);
        g1[v].insert(u);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        g2[a].insert(b);
        g2[b].insert(a);
    }

    if (m2 == n * (n - 1) / 2) {
        vec<pii> res;

        int deleted = 0;
        for (int i = 2; i <= n; i++) {
            int cnt = 0;
            for (int j = 1; j < i; j++) {
                if (g1[j].find(i) == g1[j].end()) {
                    cnt++;
                }
            }

            if (cnt == i - 1) {
                g1[i - 1].insert(i);
                g1[i].insert(i - 1);
                res.pb({i - 1, i});
                deleted++;
            }
        }

        if (m2 - deleted < n - 1) {
            cout << "No\n";
            return;
        }

        cout << "Yes\n";
        cout << sz(res) << '\n';
        for (auto &p : res) {
            cout << p.f << ' ' << p.s << '\n';
        }

        return;
    }

    if (G == 5) {
        if (n == 2 && m1 == 0 && m2 == 1) {
            cout << "No\n";
            return;
        }

        vec<pii> res;

        for (int i = 2; i < n; i++) {
            if (g1[i].find(i + 1) == g1[i].end()) {
                g1[i].insert(i + 1);
                g1[i + 1].insert(i);
                res.pb({i, i + 1});
            }
        }


        if (g1[1].find(2) == g1[1].end()) {
            res.pb({1, 2});
        }


        cout << "Yes\n";
        cout << sz(res) << '\n';
        for (auto &p : res) {
            cout << p.f << ' ' << p.s << '\n';
        }

        return;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> t >> G;
    while (t--)
        solve();

    return 0;
}
