#include <bits/stdc++.h>
using namespace std;

void g() {
    int m1, m2, q, r;
    cin >> m1 >> m2;
    vector<int> u(3, 0), v(3, 0);
    for (int i = 0; i < m1; i++) {
        cin >> q >> r;
        u[(q + r) % 3] = 1;
    }
    for (int i = 0; i < m2; i++) {
        cin >> q >> r;
        v[(q + r) % 3] = 1;
    }
    for (int i = 0; i < 8; i++) {
        int k(0);
        for (int j = 0; j < 3; j++) {
            if (i & (1 << j) > 0) {
                k++;
                u[j] = 1 - u[j];
                v[j] = 1 - v[j];
            }
        }
        if (accumulate(u.begin(), u.end(), 0) * accumulate(v.begin(), v.end(), 0) >= 4) {
            cout << "Yes\n" << k << "\n";
            for (int j = 0; j < 3; j++) {
                if (i & (1 << j) > 0) {
                    u[j] = 1 - u[j];
                    v[j] = 1 - v[j];
                }
            }
            for (int j = 0; j < 3; j++) {
                if (i & (1 << j) > 0) {
                    if (v[j] == 0) {
                        cout << j + (j == 0) << " " << 3 - (j == 0) << "\n";
                    }
                }
            }
            for (int j = 0; j < 3; j++) {
                if (i & (1 << j) > 0) {
                    if (v[j] == 1) {
                        cout << j + (j == 0) << " " << 3 - (j == 0) << "\n";
                    }
                }
            }
            return;
        }
        for (int j = 0; j < 3; j++) {
            if (i & (1 << j) > 0) {
                u[j] = 1 - u[j];
                v[j] = 1 - v[j];
            }
        }
    }
    cout << "No\n";
}

void dfs(int x, vector<vector<int>>& g, set<pair<int, int>>& P, vector<bool>& used, vector<int>& cnt) {
    used[x] = true;
    for (auto i : g[x]) {
        if (!used[i]) {
            P.insert({x, i});
            P.insert({i, x});
            cnt[x]++;
            cnt[i]++;
            dfs(i, g, P, used, cnt);
        }
    }
}

void f() {
    int n;
    cin >> n;
    if (n == 3) {
        g();
        return;
    }
    int m1, m2, q, r;
    cin >> m1 >> m2;
    set<pair<int, int>> P{}, Q{}, R{};
    vector<vector<int>> g(n, vector<int>(0));
    for (int i = 0; i < m1; i++) {
        cin >> q >> r;
        q--;
        r--;
        P.insert({q, r});
        P.insert({r, q});
    }
    for (int i = 0; i < m2; i++) {
        cin >> q >> r;
        q--;
        r--;
        g[q].push_back(r);
        g[r].push_back(q);
        R.insert({q, r});
        R.insert({r, q});
    }
    vector<bool> used(n, false);
    vector<int> cnt(n, 0);
    dfs(0, g, Q, used, cnt);
    int often(-1);
    for (int i = 0; i < n; i++) {
        if (cnt[i] == n - 1) {
            often = i;
            break;
        }
    }
    set<int> not_connected{};
    vector<int> ccon{0};
    for (int i = 1; i < n; i++) {
        not_connected.insert(i);
    }
    vector<pair<int, int>> connections{};
    if (often == -1) {
        for (int i = 0; i < n; i++) {
            for (auto it = not_connected.begin(); it != not_connected.end();) {
                if (Q.count({ccon[i], *it}) == 0) {
                    ccon.push_back(*it);
                    connections.push_back({ccon[i], *it});
                    it = not_connected.erase(it);
                } else {
                    it++;
                }
            }
        }
        vector<pair<int, int>> connections2{};
        for (auto i : connections) {
            if (P.count(i) == 0) {
                connections2.push_back(i);
            }
        }
        cout << "Yes" << endl << connections2.size() << endl;
        for (auto i : connections2) {
            cout << i.first + 1 << " " << i.second + 1 << "\n";
        }
        return;
    }
    vector<pair<int, int>> conns{};
    int oft1((often + 1) % n), oft2((often + 2) % n), oft3((often + 3) % n);
    if (R.count({oft1, oft2}) == 0) {
        conns.push_back({oft1, oft2});
    }
    if (P.count({often, oft1}) == 0) {
        conns.push_back({often, oft1});
    }
    if (P.count({oft3, oft1}) == 0) {
        conns.push_back({oft3, oft1});
    }
    for (int i = 2; i < n - 1; i++) {
        if (P.count({(often + i) % n, (often + i + 1) % n}) == 0) {
            conns.push_back({(often + i) % n, (often + i + 1) % n});
        }
    }
    cout << "Yes\n" << conns.size() << "\n";
    for (int i = 0; i < conns.size(); i++) {
        cout << conns[i].first + 1 << " " << conns[i].second + 1 << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    int t, g;
    cin >> t >> g;
    for (int i = 0; i < t; i++) {
        f();
    }
}
