#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

//#pragma ("OFast")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct Node{
    int v = -1, rg = 1, p = -1;
};

int find_root(int v, vector<Node> &g){
    if (g[v].p == g[v].v){
        return g[v].v;
    }
    return g[v].p = find_root(g[v].p, g);
}

bool unite(int v, int u, vector<Node> &g){
    int pv = find_root(v, g);
    int pu = find_root(u, g);
    if (pv == pu){
        return false;
    }
    if (g[pv].rg < g[pu].rg){
        swap(pv, pu);
    }
    g[pu].p = pv;
    g[pv].rg += g[pu].rg;
    return true;
}

int check(vector<vector<int>> &g, int n){
    int ind = -1;
    for (int i = 0; i < n; i++){
        if (g[i].size() == n - 1){
            if (ind != -1){
                return -1;
            }
            ind = i;
        }
        else if (g[i].size() != 1){
            return -1;
        }
    }
    return ind;
}

void solve(int gr){
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> st1, st2;
    vector<vector<int>> g1(n), g2(n);
    vector<array<int, 2>> all1(m1), all2(m2);
    for (int i = 0; i < m1; i++){
        int v, u;
        cin >> v >> u;
        if (v > u){
            swap(v, u);
        }
        v--; u--;
        st1.insert({v, u});
        g1[v].push_back(u);
        g1[u].push_back(v);
        all1[i] = {v, u};
    }
    for (int i = 0; i < m2; i++){
        int v, u;
        cin >> v >> u;
        if (v > u){
            swap(v, u);
        }
        v--; u--;
        st2.insert({v, u});
        g2[v].push_back(u);
        g2[u].push_back(v);
        all2[i] = {v, u};
    }
    //if (n == 3){
    //    if (m1 >= 2 and m2 >= 2){
    //        cout << "Yes\n0\n";
    //        return;
    //    }
    //    else if (m1 == 0 and m2 == 3){
    //        cout << "No\n";
    //        return;
    //    }
    //    else if (m1 == 1 and m2 == 3){
    //        set<pair<int, int>> st = {{0, 1}, {0, 2}, {1, 2}};
    //        st.erase({all1[0][0], all1[0][1]});
    //        cout << "Yes\n1\n";
    //        cout << (*st.begin()).first << " " << (*st.begin()).second << "\n";
    //        return;
    //    }
    //    else if (m1 == 0 and m2 == 2){
    //        cout << "No\n";
    //    }
    //    else if (m1 == 1 and m2 == 2){
    //        if (all1[0] != all2[0] and all1[0] != all2[1]){
    //            cout << "No\n";
    //        }
    //        else{
    //            set<pair<int, int>> st = {{0, 1}, {0, 2}, {1, 2}};
    //            st.erase({all2[0][0], all2[0][1]});
    //            st.erase({all2[1][0], all2[1][1]});
    //            cout << "Yes\n1\n";
    //            cout << (*st.begin()).first << " " << (*st.begin()).second << "\n";
    //            return;
    //        }
    //    }
    //    return;
    //}
    if (gr == 2){
        if (m1 == 0){
            cout << "No\n";
            return;
        }
        pair<int, int> p = *st1.begin();
        vector<pair<int, int>> ans;
        for (int j = 0; j < n; j++){
            if (p.first == j){
                continue;
            }
            if (st1.find({min(p.first, j), max(p.first, j)}) == st1.end()){
                ans.emplace_back(p.first, j);
            }
        }
        cout << "Yes\n";
        cout << ans.size() << "\n";
        for (auto [a, b] : ans){
            cout << a + 1 << " " << b + 1 << "\n";
        }
        return;
    }
    if (gr == 0){
        if (n == 3){
            cout << "No\n";
        }
        else if (m1 == 2){
            cout << "Yes\n1\n2 4\nYes\n";
        }
        else{
            cout << "Yes\n2\n1 2\n4 2\n";
        }
        return;
    }
    int v = check(g2, n);
    if (v != -1 and m1 == 0){
        cout << "No\n";
        return;
    }
    if (v != -1){
        if (g1[v].empty()){
            cout << "No\n";
            return;
        }
        int u = -1;
        for (auto el : g1[v]){
            if (st2.find({min(el, v), max(el, v)}) != st2.end()){
                u = el;
                break;
            }
        }
        if (u != -1){
            vector<pair<int, int>> ans;
            set<int> st;
            for (int i = 0; i < n; i++){
                st.insert(i);
            }
            st.erase(u);
            for (auto [a, b] : st1){
                if (a == u){
                    st.erase(b);
                }
                if (b == u){
                    st.erase(a);
                }
            }
            for (auto el : st){
                ans.emplace_back(el, u);
            }
            cout << "Yes\n";
            cout << ans.size() << "\n";
            for (auto [a, b] : ans){
                cout << a + 1 << " " << b + 1 << "\n";
            }
            return;
        }

    }
    else{
        vector<Node> g(n);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1, gr;
    cin >> t >> gr;
    while (t--){
        solve(gr);
    }
}
