#include <bits/stdc++.h>
using namespace std;

int main() {
  int t, g;
  cin >> t >> g;
  while (t--) {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    if (n <= 5) {
      vector<vector<int>> adj1(n, vector<int>(n)), adj2(n, vector<int>(n));
      for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        adj1[u][v] = adj1[v][u] = true;
      }
      for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        adj2[u][v] = adj2[v][u] = true;
      }
      vector<int> perm(n * (n - 1) / 2);
      iota(perm.begin(), perm.end(), 0);
      mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
      vector<pair<int, int>> edges;
      for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
          edges.push_back({i, j});
        }
      }
      bool found = false;
      for (int i = 0; i < 100000 && !found; i++) {
        shuffle(perm.begin(), perm.end(), rng);
        vector<vector<int>> new_adj1 = adj1, new_adj2 = adj2;
        for (int j = 0; j <= n && !found; j++) {
          vector<bool> used1(n), used2(n);
          queue<int> q;
          q.push(0);
          used1[0] = true;
          while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (int v = 0; v < n; v++) {
              if (new_adj1[u][v] && !used1[v]) {
                used1[v] = true;
                q.push(v);
              }
            }
          }
          q.push(0);
          used2[0] = true;
          while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (int v = 0; v < n; v++) {
              if (new_adj2[u][v] && !used2[v]) {
                used2[v] = true;
                q.push(v);
              }
            }
          }
          if (count(used2.begin(), used2.end(), false) > 0) {
            break;
          }
          if (count(used1.begin(), used1.end(), false) == 0 && count(used2.begin(), used2.end(), false) == 0) {
            cout << "Yes\n";
            cout << j << "\n";
            for (int k = 0; k < j; k++) {
              cout << 1 + edges[perm[k]].first << " " << 1 + edges[perm[k]].second << "\n";
            }
            found = true;
            break;
          }
          if (j < n) {
            new_adj1[edges[perm[j]].first][edges[perm[j]].second] ^= 1; 
            new_adj1[edges[perm[j]].second][edges[perm[j]].first] ^= 1;
            new_adj2[edges[perm[j]].first][edges[perm[j]].second] ^= 1;
            new_adj2[edges[perm[j]].second][edges[perm[j]].first] ^= 1;
          }
        }
      }
      if (!found) {
        cout << "No\n";
      }
    }
  }
}
