#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve2() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    
    map<pair<int, int>, bool> edg;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        edg[{u, v}] = edg[{v, u}] = true;
    }
    
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
    }
    
    vector<pair<int, int>> ans;
    auto add = [&](int x, int y) {
        if (x > y) swap(x, y);
        if (!edg.count({x, y})) {
            edg[{x, y}] = edg[{y, x}] = true;
            ans.emplace_back(x, y);
        }
    };
    
    if (n == 3 && m1 == 0) {
        cout << "No\n";
    } else {
        for (int x = 0; x < n - 1; x++) {
            add(x, x + 1);
        }
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto [x, y] : ans) cout << x + 1 << ' ' << y + 1 << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    int t, group;
    cin >> t >> group;
    while (t--) {
        // if (group == 1) solve1();
        if (group == 2) solve2();
    }
    
    return 0;
}