//#pragma GCC optimize("03,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

struct Query {
    int o, y, id;

    Query() {}

    Query(int o, int y, int id) : o(o), y(y), id(id) {}
};

void solve() {
    int n, d, phonk;
    std::cin >> n >> d >> phonk;
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    if (phonk <= 2) {
        int q;
        std::cin >> q;
        std::vector<std::vector<bool>> ct(n, std::vector<bool>(n));
        auto can = [&](int x, int y) {
            return ct[x][y];
        };
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (a[j] < a[i]) {
                    continue;
                }
                std::vector<bool> ok(n, false);
                ok[i] = true;
                for (int k = i; k < j; k++) {
                    if (!ok[k]) {
                        continue;
                    }
                    for (int z = k + 1; z <= std::min(n - 1, k + d); z++) {
                        if (a[z] < a[i] || z == j) {
                            ok[z] = true;
                        }
                    }
                }
                ct[i][j] = ok[j];
            }
        }
        for (int _ = 0; _ < q; _++) {
            int o, x, y;
            std::cin >> o >> x >> y;
            x--, y--;
            if (a[x] > a[y]) {
                std::cout << 0 << "\n";
                continue;
            }
            std::vector<int> dp(n, 1e9);
            dp[x] = 0;
            for (int i = x + 1; i <= y; i++) {
                for (int k = i - 1; k >= x; k--) {
                    if (can(k, i)) {
                        dp[i] = std::min(dp[i], dp[k] + 1);
                    }
                }
            }
            if (dp[y] == 1e9) {
                std::cout << 0 << "\n";
            } else {
                if (o == 1) {
                    std::cout << 1 << "\n";
                } else {
                    std::cout << dp[y] << "\n";
                }
            }
        }
    } else if (phonk == 3) {

    } else if (phonk == 4) {

    } else {

    }
}

signed main() {
//    std::cin.tie(nullptr);
//    std::ios::sync_with_stdio(false);

    int t = 1;
//    std::cin >> t;

    while (t--) {
        solve();
    }
}