#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 10;

bool isPoss = true;
vector<pair<int, int>> res;

void change(int u, int v) {
    res.push_back({u, v});
}

int n;
vector<int> g[N];
set<pair<int, int>> e1;
set<pair<int, int>> e2;


void solve1(int u, int v) {
    // cout << "solve1\n";
    // cout << u << ' ' << v << '\n';
    if (!e1.count({u, v})) {
        change(u, v);
        e1.insert({u, v});
        e2.insert({u, v});
    }
    for (int i = 1; i <= n; i++) {
        if (i == u || i == v) continue;
        if (e1.count({i, u}) || e1.count({i, v})) continue;
        if (!e2.count({i, u})) {
            change(i, u);
            continue;
        }
        if (!e2.count({i, v})) {
            change(i, v);
            continue;
        }
        change(i, u);
    }
    cout << "Yes\n";
    cout << (int)res.size() << '\n';
    for (auto [x, y] : res)
        cout << x << ' ' << y << '\n';
}

void test_case() {
    res.clear();
    e1.clear();
    e2.clear();
    for (int i = 1; i <= n; i++) {
        g[i].clear();
    }
    cin >> n;
    int m1, m2;
    cin >> m1 >> m2;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        if (u == v) continue;
        e1.insert({u, v});
        e1.insert({v, u});
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        if (u == v) continue;
        g[u].push_back(v);
        g[v].push_back(u);
        e2.insert({u, v});
        e2.insert({v, u});
    }
    
    /* find an edge that both graphs contains*/ {
        for (auto c : e1) {
            if (e2.count(c)) {
                solve1(c.first, c.second);
                return;
            }
        }

    }

    if (n == 3) {
        cout << "No\n";
        return;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = i + 2; j <= n; j++) {
            change(i, j);
        }
    }
    cout << "Yes\n";
    cout << (int)res.size() << '\n';
    for (auto [x, y] : res)
        cout << x << ' ' << y << '\n';
}   

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    // freopen("test.txt", "r", stdin);
    int t, type;
    cin >> t >> type;

    while (t--) {
        res.clear();
        test_case();
    }
}