// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx,avx2")

#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ld long double

int _g;
const int maxn = 300005;

vector<vector<int>> g;
bool used[maxn];

int dfs(int v = 1) {
    used[v] = true;
    int cur = 1;
    for (int u : g[v]) {
        if (used[u]) continue;
        cur += dfs(u);
    }
    return cur;
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g.clear();
    g.resize(n+1);
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
    }
    memset(used, 0, n+1);
    int q = dfs();
    if (q == n) {
        cout << "Yes\n0";
    } else {
        cout << "No";
    }
}

signed main() {
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t >> _g;
    while (t--) solve();
}