// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx,avx2")

#include <bits/stdc++.h>
using namespace std;

#define int long long
#define ld long double

int _g;
const int maxn = 300005;

vector<set<int>> g1;
vector<set<int>> g2;

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g1.clear();
    g1.resize(n+1);
    g2.clear();
    g2.resize(n+1);
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        g1[u].insert(v);
        g1[v].insert(u);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        g2[a].insert(b);
        g2[b].insert(a);
    }
    
    vector<pair<int, int>> ops;

    for (int i = 3; i <= n; i++) {
        if (g1[1].count(i) || g1[2].count(i)) continue;
        if (g2[1].count(i)) {
            g1[2].insert(i);
            g1[i].insert(2);
            ops.emplace_back(2, i);
            if (g2[2].count(i)) {
                g2[2].erase(i);
                g2[i].erase(2);
            } else {
                g2[2].insert(i);
                g2[i].insert(2);
            }
        } else if (g2[2].count(i)) {
            g1[1].insert(i);
            g1[i].insert(1);
            ops.emplace_back(1, i);
            if (g2[1].count(i)) {
                g2[1].erase(i);
                g2[i].erase(1);
            } else {
                g2[1].insert(i);
                g2[i].insert(1);
            }
        } else {
            g1[2].insert(i);
            g1[i].insert(2);
            ops.emplace_back(2, i);
            if (g2[2].count(i)) {
                g2[2].erase(i);
                g2[i].erase(2);
            } else {
                g2[2].insert(i);
                g2[i].insert(2);
            }
        }
    }

    cout << "Yes\n";
    cout << ops.size() << '\n';
    for (auto [u, v] : ops) cout << u << ' ' << v << '\n';
}

signed main() {
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t >> _g;
    while (t--) solve();
}