#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ve vector
#define all(x) x.begin(), x.end()
#define fi first
#define se second
#define sz(x) (int)x.size()
#define pb push_back
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int N = 3e5+10;
ve<int>g1[N];
ve<int>g2[N];
int mas[N];
int used[N];


int gmas(int v){
    if(mas[v]==v)return v;
    mas[v] = gmas(mas[v]);
    return mas[v];
}

int T = 0;
void dfs1(int v, ve<ve<int>>&G1){
    used[v]=T;
    for(int j= 0;j<sz(G1); j++)if(G1[v][j] && used[j] != T){
        dfs1(j, G1);
    }
}
void unite(int v, int u){
    v = gmas(v);
    u = gmas(u);
    mas[v] = u;
}


void solve(int G){
    int n, m1, m2;
    cin>>n>>m1>>m2;
    set<pii>s1, s2;
    for(int i=0;i<n;i++){
        g1[i].clear();
        g2[i].clear();
    }
    iota(mas, mas+n, 0);
    for(int i = 0;i<m1;i++){
        int v, u;
        cin>>v>>u;v--;u--;
        s1.insert({v, u});
        g1[v].pb(u);
        g1[u].pb(v);
        unite(v, u);
    }
    for(int i = 0;i<m2;i++){
        int v, u;
        cin>>v>>u;v--;u--;
        s2.insert({v, u});
        g2[v].pb(u);
        g2[u].pb(v);
    }
    if(G==2){

    if(n==2 && gmas(0) != gmas(1) || n==3 && gmas(0)!=gmas(1) && gmas(1)!=gmas(2) && gmas(2) != gmas(0)){
        cout<<"No\n";
        return;
    }

    cout<<"Yes\n";
    ve<pii>ans;
    for(int i = 1;i<n-1;i++){
        if(gmas(i) != gmas(0)){
            unite(i, 0);
            ans.pb({i, 0});
        }
    }
    if(n>2 && gmas(1)!=gmas(n-1)){
        ans.pb({1, n-1});
    }

    cout<<sz(ans)<<'\n';
    for(auto [x, y] : ans)cout<<x+1<<' '<<y+1<<'\n';
    }
    else{
        map<int, ve<int>>mp;
        int F = -1, S = -1;
        for(int i = 0;i<n;i++){
            mp[gmas(i)].pb(i);
            if(F==-1)F = gmas(i);
            else if(F!=gmas(i))S = gmas(i);
        }
        for(auto i : mp[F]){
            for(auto j : mp[S]){
                if(s2.find(make_pair(i, j)) == s2.end() && s2.find(make_pair(j, i))==s2.end()){
                    cout<<"Yes\n";
                    cout<<1<<endl;
                    cout<<i+1<<' '<<j+1<<endl;
                    return;
                }
            }
        }
        cout<<"No\n";

    }
}

int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);


    int t=1, G=0;
    cin>>t>>G;
    while(t--){
        solve(G);
    }

    return 0;
}
