#include <bits/stdc++.h>
using namespace std;

vector<vector<bool>> matrix1;
vector<vector<bool>> matrix2;
vector<int> used;
int timer = 1;
int max_v;
void dfs1(int v) {
	used[v] = timer;
	for (int u = 0; u < max_v; u++) {
		if (u == v) continue;
		if (used[u] == timer) continue;
		if (matrix1[v][u]) dfs1(u);
	}
}
void dfs2(int v) {
	used[v] = timer;
	for (int u = 0; u < max_v; u++) {
		if (u == v) continue;
		if (used[u] == timer) continue;
		if (matrix2[v][u]) dfs2(u);
	}
}

vector<pair<int, int>> answers;

bool gen(int v, int u, int uses) {
	if (v == max_v) {
		bool debug = false;
		int c1 = 0;
		int c2 = 0;
		timer++;
		for (int i = 0; i < max_v; i++) {
			if (used[i] == timer) continue;
			if (debug) cerr << i << " ";
			c1++;
			dfs1(i);
		}
		if (debug)
		cerr << "\n";
		timer++;
		for (int i = 0; i < max_v; i++) {
			if (used[i] == timer) continue;
			if (debug) cerr << i << " ";
			c2++;
			dfs2(i);
		}
		if (debug)
		cerr << "\n================\n";
		timer++;
		if (c1 == 1 && c2 == 1) return true;
		return false;
	}
	if (u == v) return gen(v+1, 0, uses);
	if (uses != 0) {
		matrix1[v][u] = !matrix1[v][u];
		matrix1[u][v] = matrix1[v][u];
		matrix2[v][u] = !matrix2[v][u];
		matrix2[u][v] = matrix2[v][u];
		answers.emplace_back(u, v);
		if (gen(v, u+1, uses-1)) return true;
		matrix1[v][u] = !matrix1[v][u];
		matrix1[u][v] = matrix1[v][u];
		matrix2[v][u] = !matrix2[v][u];
		matrix2[u][v] = matrix2[v][u];
		answers.pop_back();
	}
	if (gen(v, u+1, uses)) return true;
	return false;
}

int main() {
	int t, g;
	cin >> t >> g;
	assert(g == 1);
	while (t--) {
		int n, m1, m2;
		cin >> n >> m1 >> m2;
		matrix1.resize(n, vector<bool>(n, false));
		matrix2.resize(n, vector<bool>(n, false));
		used.resize(n, -1);
		for (int i = 0; i < m1; i++) {
			int u, v;
			cin >> u >> v;
			u--, v--;
			matrix1[u][v] = true;
			matrix1[v][u] = true;
		}
		for (int i = 0; i < m2; i++) {
			int u, v;
			cin >> u >> v;
			u--, v--;
			matrix2[u][v] = true;
			matrix2[v][u] = true;
		}
		max_v = n;
		if (gen(0, 0, n)) {
			cout << "Yes\n";
			cout << answers.size() << "\n";
			for (auto [u, v]: answers) {
				if (matrix2[u][v]) cout << u+1 << " " << v+1 << "\n";
			}
			for (auto [u, v]: answers) {
				if (!matrix2[u][v]) cout << u+1 << " " << v+1 << "\n";
			}
		}
		else {
			cout << "No\n";
			assert(n == 3);
		}
		answers.clear();
		matrix1.clear();
		matrix2.clear();
		used.clear();
	}
}