#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define fast_io     ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#define F           first
#define S           second
#define all(e)      e.begin(), e.end()
#define Sz(e)       (int)e.size()
#define endll       "\n"
#define pb          push_back

const ll MAXN =  3e5 + 10;


int n, m1, m2, cnt[MAXN];
map<pii, int> type; //01 = 1, 00 = 0, 11 = 3, 10 = 2
vector<int> adj[MAXN];
bool mark[MAXN];
int vis[MAXN];
vector<pii> edges, edg2;
vector<pii> ans;

void dfs(int v){
    if (v > 1) vis[v]++;
    for (auto u : adj[v]){
        if (vis[u]) continue;
        type[{v, u}] ++, type[{u, v}] ++;
        vis[v]++;
        dfs(u);
    }
}

void find_tree1(){
    dfs(1);
    for (int i = 1; i <= n; i++){
        if (vis[i] == n - 1){
            // cout << "shit" << endl;
            if (i == 1){
                type[{1, 2}]--, type[{2, 1}]--;
                type[{2, 3}]++, type[{3, 2}]++;
                bool check = 0;
                for (int i = 0; i < m2; i++){
                    if ((edges[i].F == 2 && edges[i].S == 3) || (edges[i].F == 3 && edges[i].S == 2)) check = 1;
                }
                if (!check){
                    ans.pb({2, 3});
                    if (type[{2, 3}] == 3) type[{2, 3}] = type[{3, 2}] = 1;
                }
            }
            else{
                type[{1, i}]--, type[{i, 1}]--;
                type[{1, 2}]++, type[{2, 1}]++;
                bool check = 0;
                for (int i = 0; i < m2; i++){
                    if ((edges[i].F == 2 && edges[i].S == 1) || (edges[i].F == 1 && edges[i].S == 2)) check = 1;
                }
                if (!check){
                    ans.pb({2, 1});
                    if (type[{2, 1}] == 3) type[{2, 1}] = type[{1, 2}] = 1;
                }
            }
        } 
    }
}

void dfs2(int v){
    vis[v] = 1;
    for (auto u : adj[v]){
        // cout << v << ' ' << u << ' ' << vis[u] << ' ' << type[{v, u}] << endl;
        if (!vis[u] && type[{v, u}] != 1){
            // cout << v << ' ' << u << endl;
            if (type[{v, u}] < 2) ans.pb({v, u});
            dfs2(u);
        }
    }
}

void find_tree2(){
    dfs2(1);
}

void pre(){
    fill(cnt, cnt + n + 1, 0);
    type.clear();
    for (int i = 0; i <= n; i++){
        adj[i].clear();
        mark[i] = 0, vis[i] = 0;
    }
    ans.clear();
    edges.clear();
    edg2.clear();
}
void solve3(){
    for (auto i : edges){
        type[{i.F, i.S}] ++,  type[{i.S, i.F}]++;
    }
    if (m1 == 0 && m2 == 3) cout << "No" << endl;
    else if (m1 == 0 && m2 == 2){
        cout << "Yes" << endll;
        cout << 2 << endl;
        for (int i = 1; i <= 3; i++){
            for (int j = i + 1; j <= 3; j++){
                if (type[{i, j}] == 0){
                    cout << i << ' ' << j << endl;
                }
            }
        }
        for (int i = 1; i <= 3; i++){
            for (int j = i + 1; j <= 3; j++){
                if (type[{i, j}] == 1){
                    cout << i << ' ' << j << endl;
                    return;
                }
            }
        }
    }
    else if (m1 == 1 && m2 == 3){
        cout << "Yes" << endl;
        if (type[{1, 2}] != 3) cout << 1 << endl << 1 << ' ' << 2 << endl;
        else if (type[{1, 3}] != 3) cout << 1 << endl << 1 << ' ' << 3 << endl;
        else cout << 1 << endl << 2 << ' ' << 3 << endl;
    }
    else if (m1 == 1){
        if (type[{1, 2}] == 3 || type[{2, 3}] == 3 || type[{1, 3}] == 3){
            cout << "No" << endl;
        }
        else{
            cout << "Yes" << endll;
            for (int i = 1; i <= 3; i++){
                for (int j = i + 1; j <= 3; j++){
                    if (type[{i, j}] == 0){
                        cout << 1 << endl << i << ' ' << j << endl;
                        return;
                    }
                }
            }
        }
    }
    else cout << "Yes" << endl << 0 << endl;
}

int main(){ 
    fast_io;
    int t, g;
    cin >> t >> g;
    while(t--){
        cin >> n >> m1 >> m2;
        pre();
        for (int i = 0; i < m1; i++){
            int v, u;
            cin >> v >> u;
            type[{v, u}] = type[{u, v}] = 2;
            edg2.pb({v, u});
        }
        for (int i = 0; i < m2; i++){
            int v, u;
            cin >> v >> u;
            adj[v].pb(u);
            adj[u].pb(v);
            edges.pb({v, u});
        }
        if (n == 3){
            solve3();
            continue;
        }
        find_tree1();
        // cout << type[{1, 4}] << endl;
        for (int i = 1; i <= n; i++) adj[i].clear(), vis[i] = 0;
        for (int i = 1; i <= 3; i++){
            for (int j = 1; j <= n; j++){
                if (i != j){
                    adj[i].pb(j);
                    adj[j].pb(i);
                }
            }
        }
        find_tree2();
        bool check = 0;
        for (int i = 1; i <= n; i++){
            if (!vis[i]){
                check = 1;
            }
        }
        if (check){
            cout << "No" << endl;
            continue;
        }
        cout << "Yes" << endl;
        cout << (Sz(ans)) << endll;
        for (auto i : ans) cout << i.F << ' ' << i.S << endll;
    }

}