// theevilbird_n2_lazha.cpp
#include <bits/stdc++.h>

using namespace std;

const char en = '\n';
using ll = long long;

#ifdef LOCAL
#include "debug.h"
#endif

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<ll> d(n + 1), l(n + 1), r(n + 1);
    ll a0, b0;
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    cin >> a0 >> b0;
    vector<array<pair<ll, ll>, 2>> dp(n + 1);
    dp[0][0] = dp[0][1] = {a0, b0};
    for (int i = 0; i < n; ++i) {

        pair<ll, ll> cur_a = dp[i][0];
        pair<ll, ll> cur_b = dp[i][0];
        for (int j = i + 1; j <= n; ++j) {
            cur_a.first += d[i];
            cur_a.second += d[i];

            cur_a.first = min(cur_a.first, l[i]);
            if (cur_a.first + cur_a.second > dp[j][0].first + dp[j][0].second) {
                dp[j][0] = cur_a;
            }

            cur_b.first += d[i];
            cur_b.second += d[i];

            cur_b.first = min(cur_b.first, l[i]);
            if (cur_b.first + cur_b.second > dp[j][0].first + dp[j][0].second) {
                dp[j][0] = cur_b;
            }
        }

        cur_a = dp[i][0];
        cur_b = dp[i][0];
        for (int j = i + 1; j <= n; ++j) {
            cur_a.first += d[i];
            cur_a.second += d[i];

            cur_a.second = min(cur_a.second, r[i]);
            if (cur_a.first + cur_a.second > dp[j][0].first + dp[j][0].second) {
                dp[j][1] = cur_a;
            }

            cur_b.first += d[i];
            cur_b.second += d[i];

            cur_b.second = min(cur_b.second, r[i]);
            if (cur_b.first + cur_b.second > dp[j][0].first + dp[j][0].second) {
                dp[j][1] = cur_b;
            }
        }
    }
    cout << max(dp[n][0].first + dp[n][0].second,
                dp[n][1].first + dp[n][1].second) << en;
}