// lepeshov_lazha.cpp
#include <bits/stdc++.h>

using namespace std;
#define int long long
typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define ar(x) array<ll, x>
const int M = (int) 1e9 + 7;

mt19937_64 rng(14);

void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> r[i];
    }
    int a0, b0;
    cin >> a0 >> b0;

    auto dumb = [&] {
        int yo = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            vector<int> a(n + 1), b(n + 1);
            a[0] = a0, b[0] = b0;
            for (int i = 1; i <= n; i++) {
                a[i] = a[i - 1] + d[i], b[i] = b[i - 1] + d[i];
                if ((mask >> (i - 1)) & 1) {
                    a[i] = min(a[i], l[i]);
                } else {
                    b[i] = min(b[i], r[i]);
                }
            }
            yo = max(yo, a[n] + b[n]);
        }
        return yo;
    };


    {
        bool ok = true;
        int ax = a0, bx = b0;
        for (int i = 1; i <= n; i++) {
            ax += d[i];
            bx += d[i];
            if (ax <= l[i] || bx <= r[i]) {
            } else {
                ok = false;
                break;
            }
        }
        if (ok) {
            //cout<<"jackpot\n";
            cout << ax + bx << '\n';
            return;
        }
    }

    int ans = 0;

    auto relax = [&](int xx) {
        ans = max(ans, xx);
    };

    for (int _ = 0; _ < 2; _++) {
        int lim = max(1ll, n - 200);;
        if (n <= 5000)lim = 1;
        for (int i = lim; i <= n; i++) {
            vector<bool> onb(n + 1);
            int goal = l[i];
            for (int j = i; j >= 1; j--) {
                if (goal > l[j]) {
                    onb[j] = true;
                }
                goal -= d[j];
            }
            int aval = a0;
            for (int j = 1; j <= n; j++) {
                aval += d[j];
                if (j <= i) {
                    if (!onb[j]) {
                        aval = min(aval, l[j]);
                    }
                } else {
                    if (aval <= l[j]) {
                    } else {
                        onb[j] = true;
                    }
                }
            }
            int bval = b0;
            for (int j = 1; j <= n; j++) {
                bval += d[j];
                if (onb[j]) {
                    bval = min(bval, r[j]);
                }
            }
            relax(aval + bval);
        }
        swap(l, r);
        swap(a0, b0);

    }
    cout << ans << '\n';

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
}
