#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <set>
#include <random>
#include <ctime>
#include <queue>
#include <unordered_map>
#include <cassert>

#define Cout cout << fixed << setprecision(15) 

using namespace std;

using ll = long long;
using ld = long double;

mt19937 gen(time(0));
const ll INF = 2e18, M = 1e9 + 7;

void solve() {
	ll n;
	cin >> n;
	vector<ll> d(n), l(n), r(n);
	for (ll& elem : d) {
		cin >> elem;
	}
	for (ll& elem : l) {
		cin >> elem;
	}
	for (ll& elem : r) {
		cin >> elem;
	}
	ll a0, b0;
	cin >> a0 >> b0;
	ll ans = -INF;
	for (ll mask = 0; mask < (1 << n); mask++) {
		
		ll a_cur = a0, b_cur = b0;
		for (ll i = 0; i < n; i++) {
			if (mask & (1 << i)) {
				a_cur = min(a_cur + d[i], l[i]);
				b_cur = b_cur + d[i];
			}
			else {
				a_cur = a_cur + d[i];
				b_cur = min(b_cur + d[i], r[i]);
			}
		}
		ans = max(ans, a_cur + b_cur);
	}
	cout << ans;
}


int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	int t = 1;
	while (t--) {
		solve();
	}
}

/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

60

*/