#include<iostream>
#include <random>
#include<vector>
#include<set>
#include<map>
#include<cassert>
#include<unordered_map>
#include<algorithm>
#include<iomanip>
#include<numeric>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define girlfriend friend

template<typename T>
bool assign_min(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream& out, std::pair<T, F> a) {
    return out << a.first << " " << a.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, b1 = 31, b2 = 29, MAXN = 1e5;
const long double eps = 1e-9;

pair<pair<int, int>, pair<int, int>> f(int a0, int b0, vector<int> &d, vector<int> &l, vector<int> &r, int L, int R) {
    if (L == R) {
        pair<int, int> p = {a0 + d[L], b0 + d[L]};
        pair<int, int> p1 = {min(p.first, l[L]), p.second}, p2 = {p.first, min(p.second, r[L])};
        pair<int, int> p1rev = {p1.second, p1.first}, p2rev = {p2.second, p2.first};
        pair<int, int> res1 = max(p1, p2);
        pair<int, int> res2rev = max(p1rev, p2rev);
        pair<int, int> res2 = {res2rev.second, res2rev.first};
        return {res1, res2};
    }
    int M = (L+R)/2;
    auto [p1, p2] = f(a0, b0, d, l, r, L, M);
    auto [pl1, pl2] = f(p1.first, p1.second, d, l, r, M+1, R);
    auto [pr1, pr2] = f(p2.first, p2.second, d, l, r, M+1, R);
    pair<int, int> res1 = max({pl1, pl2, pr1, pr2});
    pair<int, int> pl1rev = {pl1.second, pl1.first};
    pair<int, int> pl2rev = {pl2.second, pl2.first};
    pair<int, int> pr1rev = {pr1.second, pr1.first};
    pair<int, int> pr2rev = {pr2.second, pr2.first};
    pair<int, int> res2rev = max({pl1rev, pl2rev, pr1rev, pr2rev});
    pair<int, int> res2 = {res2rev.second, res2rev.first};
    return {res1, res2};
}

void solve() {
    int n; cin >> n;
    vector<int> d(n), l(n), r(n);
    input(d); input(l); input(r);
    int a0, b0; cin >> a0 >> b0;
    auto [p1, p2] = f(a0, b0, d, l, r, 0, n-1);
    cout << max(p1.first + p1.second, p2.first + p2.second) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}

//fft