#include<iostream>
#include <random>
#include<vector>
#include<set>
#include<map>
#include<cassert>
#include<unordered_map>
#include<algorithm>
#include<iomanip>
#include<numeric>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define girlfriend friend

template<typename T>
bool assign_min(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream& out, std::pair<T, F> a) {
    return out << a.first << " " << a.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, b1 = 31, b2 = 29, MAXN = 1e5;
const long double eps = 1e-9;

void solve() {
    int n; cin >> n;
    vector<int> d(n), l(n), r(n);
    input(d); input(l); input(r);
    int a0, b0; cin >> a0 >> b0;
    bool fl = true;
    for (auto elem : d) {
        if (elem) fl = false;
    }
    if (fl) {
        vector<pair<int, int>> srt(n);
        for (int i = 0; i<n; ++i) srt[i] = {r[i], i};
        sort(rall(srt));
        multiset<int> m;
        m.insert(a0);
        for (auto elem : l) m.insert(elem);
        int res = b0 + *m.begin();
        for (auto [val, ind] : srt) {
            m.erase(m.find(l[ind]));
            assign_max(res, min(val, b0) + *m.begin());
        }
        cout << res << '\n';
        return;
    }
    vector<int> l2(n+1), r2(n+1);
    for (int i = 0; i<n; ++i) {
        l2[i+1] = l[i];
        r2[i+1] = r[i];
    }
    l2[0] = a0; r2[0] = b0;
    vector<int> dp(n+1, -inf);
    dp[0] = b0;
    int res = 0;
    for (int i = 0; i<n; ++i) {
        int val1 = l2[i], val2 = dp[i];
        for (int j = i+1; j<=n; ++j) {
            val1 += d[j-1];
            val2 += d[j-1];
            if (l2[j] > val1) continue;
            assign_max(dp[j], val2);
            val2 = min(val2, r2[j]);
        }
        assign_max(res, val1 + val2);
    }
    cout << max(res, l2[n] + dp[n]) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}

//fft