#include <iostream>
#include <cstdint>
#include <vector>

using namespace std;

void sol() {
    int64_t n;
    cin >> n;
    vector<int64_t> d(n), l(n), r(n);
    for (auto &v: d) cin >> v;
    for (auto &v: l) cin >> v;
    for (auto &v: r) cin >> v;
    int64_t a0, b0;
    cin >> a0 >> b0;
    vector<vector<pair<int64_t, int64_t>>> tr(n + 1);
    tr[0].emplace_back(a0, b0);
    for (int32_t i = 0; i < n; ++i) {
        tr[i + 1].reserve(tr[i].size() * 2);
        for (auto [a, b]: tr[i]) {
            tr[i + 1].emplace_back(min(a + d[i], l[i]), b + d[i]);
            tr[i + 1].emplace_back(a + d[i], min(b + d[i], r[i]));
        }
    }
    int64_t res = 0;
    for (auto [a, b]: tr[n]) res = max(res, a + b);
    cout << res;
//    for (int32_t i = 1; i <= n; ++i) {
//        ai += d[i - 1], bi += d[i - 1];
//        if (ai - min(ai, l[i - 1]) < bi - min(bi, r[i - 1])) ai = min(ai, l[i - 1]);
//        else bi = min(bi, r[i - 1]);
//    }
//    cout << ai + bi;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    uint64_t t = 1;
#else
    uint64_t t = 1;
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    while (t--) {
        sol();
        cout << "\n";
    }
    return 0;
}
