    #include <iostream>
    #include <vector>
    #include <algorithm>
    #include <map>
    #include <set>
    #include <unordered_map>
    #include <unordered_set>
    #include <random>
    #include <queue>
    #include <deque>
    #include <cassert>
    using namespace std;
    #define line cout << "\n"
    #define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
    #define pb push_back
    #define ppb pop_back
    #define all(a) a.begin(), a.end()
    #define rall(a) a.rbegin(), a.rend()
    #define ff first
    #define ss second
    #define pii pair<int, int>
    #define sz(a) (int) a.size()
    #define int long long

    bool cmp(pii &a, pii &b) {
        if (a.first == b.first) {
            return a.second > b.second;
        }
        return a.first < b.first;
    }

    void solve() {
        int n;
        cin >> n;
        vector<int> d(n), l(n), r(n);
        for (int i = 0; i < n; i++) {
            cin >> d[i];
        }
        for (int i = 0; i < n; i++) {
            cin >> l[i];
        }
        for (int i = 0; i < n; i++) {
            cin >> r[i];
        }
        int a, b;
        cin >> a >> b;
        int ans = 0;
        int fa = a, fb = b;
        if (n > 15) {
            vector<pii> rofl(n);
            for (int i = 0; i < n; i++) {
                rofl[i] = {l[i], r[i]};
            }
            sort(all(rofl), cmp);
            int cur_min = b;
            for (int i = 0; i < n; i++) {
                ans = max(ans, min(rofl[i].first, a) + cur_min);
                cur_min = min(cur_min, rofl[i].second);
            }
            cout << ans; line;
            return;
        }
        for (int mask = 0; mask < (1 << n) && mask * n < 1e8; mask++) {
            a = fa;
            b = fb;
            for (int i = 0; i < n; i++) {
                a += d[i];
                b += d[i];
                if (mask & (1 << i)) {
                    a = min(a, l[i]);
                } else {
                    b = min(b, r[i]);
                }
            }
            ans = max(ans, a + b);
        }
        cout << ans; line;
    }

    signed main() {
        fast;


        int t = 1;
        //cin >> t;
        while (t--) {
            solve();
        }
    }