
#include <bits/stdc++.h>
using namespace std;

const long long inf = 1e18;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    vector<long long> prefd(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
        if (i != 0) {
            prefd[i] += prefd[i - 1];
        }
        prefd[i] += d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    int a0, b0;
    cin >> a0 >> b0;
    long long cura = a0, curb = b0;
    bool able = true;
    vector<char> bada(n), badb(n);
    for (int i = 0; i < n; ++i) {
        cura += d[i], curb += d[i];
        if (cura > l[i]) {
            bada[i] = true;
        }
        if (curb > r[i]) {
            badb[i] = true;
        }
        if (bada[i] && badb[i]) {
            able = false;
        }
    }
    if (able) {
        cout << cura + curb << '\n';
        return;
    }
    vector<pair<long long, int>> sb(n), sa(n);
    for (int i = 0; i < n; ++i) {
        sa[i] = {l[i] - prefd[i], i};
        sb[i] = {r[i] - prefd[i], i};
    }
    sort(sa.begin(), sa.end());
    sort(sb.begin(), sb.end());
    set<pair<long long, int>> alive;
    vector<pair<long long, int>> tmp;
    long long ans = -inf;
    for (int iter = 0; iter < 2; ++iter) {
        // filter on b
        alive.clear();
        for (int i = 0; i < n; ++i) {
            if (a0 + prefd[i] >= l[i]) {
                alive.emplace(l[i] - prefd[i], i);
            }
        }
        tmp.clear();
        long long lastval = -inf;
        bool omita = true;
        for (const auto& [val, i] : sb) {
            if (lastval < val) {
                while (!tmp.empty()) {
                    while (!alive.empty() && alive.rbegin()->first > tmp.back().first) {
                        alive.erase(--alive.end());
                    }
                    if (bada[tmp.back().second]) {
                        omita = false;
                    }
                    tmp.pop_back();
                }
            }
            if (b0 + prefd[i] >= r[i]) {
                long long cand = -inf;
                if (omita) {
                    cand = a0;
                }
                if (!alive.empty()) {
                    auto it = --alive.end();
                    if (it->second == i && it != alive.begin()) {
                        --it;
                    }
                    if (it->second != i) {
                        cand = max(cand, it->first);
                    }
                }
                ans = max(ans, cand + val + 2 * prefd[n - 1]);
            }
            tmp.emplace_back(l[i] - prefd[i], i);
            lastval = val;
        }
        swap(l, r);
        swap(a0, b0);
        swap(bada, badb);
        swap(sa, sb);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cout << "--------\n";
        cerr << "--------\n";
    }
    #else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    #endif

    return 0;
}