#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ordered_set = tree<ll, less<>, null_type, tree_tag, tree_order_statistics_node_update>;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    // cin >> t;
    while (t--)
        solve();
}

void solve() {
    int n;
    cin >> n;
    vector<int> l(n), r(n), d(n);
    for (int &i: d)
        cin >> i;
    for (int &i: l)
        cin >> i;
    for (int &i: r)
        cin >> i;
    vector<int> dp(n + 1, -1e9), dp1(n + 1, -1e9);
    int a, b;
    cin >> a >> b;
    dp[0] = b;
    dp1[0] = a;
    reverse(all(l));
    reverse(all(r));
    l.push_back(a);
    r.push_back(b);
    reverse(all(l));
    reverse(all(r));
    int ans = 0;
    for (int i = 0; i < n; i++) {
        int s = d[i];
        int j = i + 1;
        while (j <= n && s + dp[i] <= r[j]) {
            if (j < n)
                s += d[j];
            j++;
        }
        if (dp[i] > 0) {
            if (j <= n)
                dp1[j] = max(dp1[j], s + l[i]);
            else
                ans = max(ans, l[i] + dp[i] + s * 2);
        }

        s = d[i];
        j = i + 1;
        while (j <= n && s + dp1[i] <= l[j]) {
            if (j < n)
                s += d[j];
            j++;
        }
        if (dp1[i] > 0) {
            if (j <= n)
                dp[j] = max(dp[j], s + r[i]);
            else
                ans = max(ans, r[i] + dp1[i] + s * 2);
        }

        s = d[i];
        j = i + 1;
        while (j <= n && s + r[i] <= r[j]) {
            if (j < n)
                s += d[j];
            j++;
        }
        if (j <= n)
            dp1[j] = max(dp1[j], s + dp1[i]);
        else
            ans = max(ans, r[i] + dp1[i] + s * 2);

        s = d[i];
        j = i + 1;
        while (j <= n && s + l[i] <= l[j]) {
            if (j < n)
                s += d[j];
            j++;
        }
        if (j <= n)
            dp[j] = max(dp[j], s + dp[i]);
        else
            ans = max(ans, l[i] + dp[i] + s * 2);
    }
//    cout << ans << '\n';
//    for (int i: dp)
//        cout << i << ' ';
//    cout << '\n';
//    for (int i: dp1)
//        cout << i << ' ';
//    cout << '\n';
    ans = max(ans, dp[n] + l[n]);
    ans = max(ans, dp1[n] + r[n]);
    cout << ans << '\n';
}