#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

using ordered_set = tree<pair<ll, ll>,
                         null_type,
                         less<pair<ll, ll>>,
                         rb_tree_tag,
                         tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

void solve() {
    ll n;
    cin >> n;

    vector<ll> d(n + 1), left(n + 1), right(n + 1);
    for (ll i = 0; i < n; ++i) cin >> d[i + 1];
    for (ll i = 0; i < n; ++i) cin >> left[i + 1];
    for (ll i = 0; i < n; ++i) cin >> right[i + 1];

    ll a0, b0;
    cin >> a0 >> b0;

    vector<map<ll, ll>> dp(n + 1);
    dp[0][a0] = b0;

    for (ll i = 0; i < n; ++i) {
        for (auto j : dp[i]) {
            ll a = j.first, b = j.second;

            dp[i + 1][min(left[i + 1], a + d[i + 1])] = max(dp[i + 1][min(left[i + 1], a)], b + d[i + 1]);
            dp[i + 1][a + d[i + 1]] = max(dp[i + 1][a + d[i + 1]], min(right[i + 1], b + d[i + 1]));
        }

        dp[i].clear();
    }

    ll ans = 0;

    for (auto i : dp[n]) {
        ans = max(ans, i.first + i.second);
    }

    cout << ans;
}

int main() {
    fast_stream();

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}
