#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>
#define int long long

using namespace std;


bool comp(vector<int> &a, vector<int> &b) {
    return a[0] + a[1] < b[0] + b[1] || a[0] + a[1] == b[0] + b[1] && a[2] < b[2];
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, a, b;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    cin >> a >> b;
    int cur = 0;
    for (int i = 0; i < n; ++i) {
        cur += d[i];
        l[i] -= cur;
        r[i] -= cur;
    }
    vector<vector<int>> s(n);
    for (int i = 0; i < n; ++i) {
        s[i] = {min(0ll, l[i] - a), min(0ll, r[i] - b), i};
    }
    sort(s.begin(), s.end(), comp);
    int da = 0, db = 0;
    for (int i = 0; i < n; ++i) {
        if (min(da, s[i][0]) + db >= da + min(db, s[i][1])) {
            da = min(da, s[i][0]);
        } else {
            db = min(db, s[i][1]);
        }
    }
    cout << a + b + da + db + 2 * cur << endl;
}
