#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>
#define int long long

using namespace std;


bool comp(vector<int> &a, vector<int> &b) {
    return a[0] + a[1] < b[0] + b[1] || a[0] + a[1] == b[0] + b[1] && a[2] < b[2];
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, a, b;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    cin >> a >> b;
    int cur = 0;
    for (int i = 0; i < n; ++i) {
        cur += d[i];
        l[i] -= cur;
        r[i] -= cur;
    }
    vector<bool> used(n, false);
    vector<int> ll(n), rr(n);
    for (int i = 0; i < n; ++i) {
        ll[i] = min(0ll, l[i] - a);
        rr[i] = min(0ll, r[i] - b);
    }
    pair<int, int> cur1 = {0, 0}, cur2 = {0, 0};
    for (int i = 0; i < n; ++i) {
        pair<int, int> n1 = {min(cur1.first, ll[i]), cur1.second}, n2 = {cur1.first, min(cur1.second, rr[i])};
        pair<int, int> n3 = {min(cur2.first, ll[i]), cur2.second}, n4 = {cur2.first, min(cur2.second, rr[i])};
        pair<int, int> nxt1, nxt2;
        if (n1.first + n1.second >= n3.first + n3.second) {
            nxt1 = n1;
        } else {
            nxt1 = n3;
        }
        if (n2.first + n2.second >= n4.first + n4.second) {
            nxt2 = n2;
        } else {
            nxt2 = n4;
        }
        cur1 = nxt1;
        cur2 = nxt2;
    }
    cout << a + b + min(cur1.first + cur1.second, cur2.first + cur2.second) + 2 * cur << endl;
}
