#include <iostream>
#include <vector>

using ll = long long;
using ld = long double;

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int& x : d)
        cin >> x;
    for (int& x : l)
        cin >> x;
    for (int& x : r)
        cin >> x;
    ll a, b;
    cin >> a >> b;
    vector<vector<pair<ll, ll>>> dp(n + 1, vector<pair<ll, ll>> (2, {a, b}));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 2; j++) {
            dp[i + 1][j].first = dp[i][j].first + d[i];
            dp[i + 1][j].second = dp[i][j].second + d[i];
            if ((ll)l[i] >= dp[i + 1][j].first)
                continue;
            if ((ll)r[i] >= dp[i + 1][j].second)
                continue;
            if (j)
                dp[i + 1][j].first = (ll)l[i];
            else
                dp[i + 1][j].second = (ll)r[i];
        }
    }
    cout << max(dp[n][0].first + dp[n][0].second, dp[n][1].first + dp[n][1].second);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
