#include <iostream>
#include <vector>

using ll = long long;
using ld = long double;

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int& x : d)
        cin >> x;
    for (int& x : l)
        cin >> x;
    for (int& x : r)
        cin >> x;
    ll a, b;
    cin >> a >> b;
    ll ans = 0;
    for (int i = 0; i <= n; i++) {
        ll x = a, y = b;
        for (int j = 0; j < i; j++) {
            x += d[j];
            y += d[j];
            if ((ll)l[j] >= x || (ll)r[j] >= y)
                continue;
            x = (ll)l[j];
        }
        for (int j = i; j < n; j++) {
            x += d[j];
            y += d[j];
            if ((ll)l[j] >= x || (ll)r[j] >= y)
                continue;
            y = (ll)r[j];
        }
        ans = max(ans, x + y);
    }
    for (int i = 0; i <= n; i++) {
        ll x = a, y = b;
        for (int j = 0; j < i; j++) {
            x += d[j];
            y += d[j];
            if ((ll)l[j] >= x || (ll)r[j] >= y)
                continue;
            y = (ll)r[j];
        }
        for (int j = i; j < n; j++) {
            x += d[j];
            y += d[j];
            if ((ll)l[j] >= x || (ll)r[j] >= y)
                continue;
            x = (ll)l[j];
        }
        ans = max(ans, x + y);
    }
    cout << ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
