#include <iostream>
#include <vector>
#include <algorithm>

using ll = long long;
using ld = long double;

using namespace std;

bool cmp(pair<int, int> a, pair<int, int> b) {
    if (a.first == b.first) {
        return a.second > b.second;
    } else {
        return a < b;
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int& x : d)
        cin >> x;
    for (int& x : l)
        cin >> x;
    for (int& x : r)
        cin >> x;
    ll a, b;
    cin >> a >> b;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++) {
        v[i] = {l[i], r[i]};
    }
    sort(v.begin(), v.end(), cmp);
    ll ans = 0, mn = 1e18;
    for (int i = 0; i < n; i++) {
        if (i)
            mn = min(mn, (ll)v[i - 1].second);
        ans = max(ans, min(a, (ll)v[i].first) + min(b, mn));
    }
    mn = min(mn, (ll)v[n - 1].second);
    ans = max(ans, a + min(b, mn));
    cout << ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
