#include <iostream>
#include <vector>
#include <algorithm>

using ll = long long;
using ld = long double;

using namespace std;

bool cmp(pair<int, int> a, pair<int, int> b) {
    if (a.first == b.first) {
        return a.second > b.second;
    } else {
        return a < b;
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int& x : d)
        cin >> x;
    for (int& x : l)
        cin >> x;
    for (int& x : r)
        cin >> x;
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; i++)
        pref[i + 1] = pref[i] + d[i];
    ll a, b;
    cin >> a >> b;
    vector<pair<pair<ll, ll>, int>> v(n);
    for (int i = 0; i < n; i++)
        v[i] = {{l[i] + pref[n] - pref[i + 1], r[i] + pref[n] - pref[i + 1]}, i};
    sort(v.begin(), v.end());
    ll ans = 0, mn = b + pref[n], idx = 0;
    for (int i = 0; i < n; i++) {
        if (i) {
            if (v[i - 1].first.second < mn) {
                mn = v[i - 1].first.second;
                idx = v[i - 1].second;
            }
            //mn = min(mn, (ll) v[i - 1].second);
        }
        ans = max(ans, min(a + pref[n], v[i].first.first) + min(b + pref[n], mn));
    }
    if (v[n - 1].first.second < mn) {
        mn = v[n - 1].first.second;
        idx = v[n - 1].second;
    }
    //mn = min(mn, (ll)v[n - 1].second);
    ans = max(ans, a + pref[n] + min(b + pref[n], mn));
    cout << ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
