#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve() {
    int n; cin >> n;
    vector <int> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 1; i <= n; i++) cin >> d[i];
    for (int i = 1; i <= n; i++) cin >> l[i];
    for (int i = 1; i <= n; i++) cin >> r[i];
    vector <ll> a(n + 1), b(n + 1);
    cin >> a[0] >> b[0];
    for (int i = 1; i <= n; i++) {
        a[i] = a[i - 1] + d[i];
        b[i] = b[i - 1] + d[i];
    }

    vector <array <ll, 2>> dp(n + 1, array <ll, 2>{(ll)-1e18, (ll)-1e18});

    dp[0][0] = b[0];
    l[0] = a[0];

    dp[0][1] = a[0];
    r[0] = b[0];

    for (int i = 0; i < n; i++) {
        ll valA = l[i], valB = dp[i][0];
        bool flag = false;
        for (int j = i + 1; j <= n; j++) {
            valA += d[j], valB += d[j];
            if (valA >= l[j]) {
                dp[j][0] = max(dp[j][0], valB);
                flag = true;
            }
            if (valB >= r[j]) {
                dp[j][1] = max(dp[j][1], valA);
                flag = true;
            }
            if (flag) break;
        }
        valA = dp[i][1], valB = r[i];
        flag = false;
        for (int j = i + 1; j <= n; j++) {
            valA += d[j], valB += d[j];
            if (valA >= l[j]) {
                dp[j][0] = max(dp[j][0], valB);
                flag = true;
            }
            if (valB >= r[j]) {
                dp[j][1] = max(dp[j][1], valA);
                flag = true;
            }
            if (flag) break;
        }
    }

    ll ans = 0;
    for (int i = 0; i <= n; i++) {
        ll valA = l[i], valB = dp[i][0];
        for (int j = i + 1; j <= n; j++) {
            valA += d[j], valB += d[j];
            if (valA > l[j]) valB = min(valB, (ll)r[j]);
        }
        ans = max(ans, valA + valB);
    }

    for (int i = 0; i <= n; i++) {
        ll valA = dp[i][1], valB = r[i];
        for (int j = i + 1; j <= n; j++) {
            valA += d[j], valB += d[j];
            if (valB > r[j]) valA = min(valA, (ll)l[j]);
        }
        ans = max(ans, valA + valB);
    }

    cout << ans << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int test = 1;// cin >> test;
    while (test--) solve();

    return 0;
}
