#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;


void solve() {
    ll n; cin >> n;
    vector <ll> d(n + 1), l(n + 1), r(n + 1), a(n + 1), b(n + 1);
    for (ll i = 1; i <= n; i++)
        cin >> d[i];
    ll mnl = INF;
    for (ll i = 1; i <= n; i++)
        cin >> l[i], mnl = min(mnl, l[i]);
    ll mnr = INF;
    for (ll i = 1; i <= n; i++)
        cin >> r[i], mnr = min(mnr, r[i]);
    cin >> a[0] >> b[0];
    vector <vector <pair <ll, ll>>> dp(n + 1, vector <pair <ll, ll>> (2, {-INF, -INF}));
//    dp[1][0] = {min(a[0] + d[1], l[1]), b[0] + d[1]};
//    dp[1][1] = {a[0] + d[1], min(b[0] + d[1], r[1])};
    dp[0][0] = dp[0][1] = {a[0], b[0]};
    for (ll i = 1; i <= n; i++) {
        auto [x1, y1] = dp[i - 1][0];
        auto [x2, y2] = dp[i - 1][1];
        if (min(l[i], x1 + d[i]) + y1 + d[i] >= min(l[i], x2 + d[i]) + y2 + d[i])
            dp[i][0] = {min(l[i], x1 + d[i]), y1 + d[i]};
        else
            dp[i][0] = {min(l[i], x2 + d[i]), y2 + d[i]};
        if (x1 + d[i] + min(r[i], y1 + d[i]) >= x2 + d[i] + min(r[i], y2 + d[i]))
            dp[i][1] = {x1 + d[i], min(r[i], y1 + d[i])};
        else
            dp[i][1] = {x2 + d[i], min(r[i], y2 + d[i])};
    }
    cout << max(dp[n][0].first + dp[n][0].second, dp[n][1].first + dp[n][1].second) << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
//    cin >> T;
//    cin >> G;
    while (T--) {
        solve();
    }
    return 0;
}