//#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 2e18;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int &i : d)
        cin >> i;
    for (int &i : l)
        cin >> i;
    for (int &i : r)
        cin >> i;
    int a0, b0;
    cin >> a0 >> b0;
    vector<pair<int, int>> ok = {{a0, b0}};
    for (int i = 0; i < n; ++i) {
        vector<pair<int, int>> now;
        for (auto j : ok) {
            now.push_back({min(l[i], j.first + d[i]), j.second + d[i]});
            now.push_back({j.first + d[i], min(r[i], j.second + d[i])});
        }
        ok = now;
    }
    pair<int, int> sum = {0, 0};
    for (auto j : ok)
        if (j.first + j.second >= sum.first + sum.second)
            sum = j;
    cout << sum.first + sum.second;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
