#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
#define int long long

istream &operator>>(istream&in, pair<int, int>&p) {
    return in >> p.first >> p.second;
}

istream &operator>>(istream&in, vector<int> &p) {
    for (int &i : p) in >> i;
    return in;
}

ostream &operator<<(ostream &out, pair<int, int> p) {
    return out << p.first << p.second;
}

ostream &operator<<(ostream &out, vector<int> p) {
    for (int i : p) out << i;
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    cin >> d >> l >> r;
    int a0, b0;
    cin >> a0 >> b0;
    if (n <= 15) {
        int ans = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            int a = a0, b = b0;
            for (int i = 0; i < n; ++i) {
                a += d[i];
                b += d[i];
                if (mask >> i & 1) a = min(a, l[i]);
                else b = min(b, r[i]);
            }
            ans = max(ans, a + b);
        }
        cout << ans;
        return;
    }
    int ans = 0;
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j){
        return l[i] < l[j] || (l[i] == l[j] && r[i] > r[j]);
    });
    int val2 = b0;
    for (int v : ord) {
        int val1 = min(l[v], a0);
        val2 = min(val2, r[v]);
        ans = max(ans, val1 + val2);
    }
    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return r[i] < r[j] || (r[i] == r[j] && l[i] > l[j]);
    });
    int v1 = a0;
    for (int v : ord) {
        int v2 = min(r[v], b0);
        v1 = min(v1, l[v]);
        ans = max(ans, v1 + v2);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
}
