#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
#define int long long

istream &operator>>(istream&in, pair<int, int>&p) {
    return in >> p.first >> p.second;
}

istream &operator>>(istream&in, vector<int> &p) {
    for (int &i : p) in >> i;
    return in;
}

ostream &operator<<(ostream &out, pair<int, int> p) {
    return out << p.first << ' ' << p.second;
}

ostream &operator<<(ostream &out, vector<int> p) {
    for (int i : p) out << i << ' ';
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    cin >> d >> l >> r;
    int a0, b0;
    cin >> a0 >> b0;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        sum += d[i];
        l[i] -= sum;
        r[i] -= sum;
    }
    /*
     * 38 -> sum -4
     */
    int ans = min(a0, *min_element(l.begin(), l.end())) + min(b0, *min_element(r.begin(), r.end()));
    l.push_back(a0);
    r.push_back(b0);
    vector<int> ord(n + 1);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j){
        return l[i] < l[j] || (l[i] == l[j] && r[i] < r[j]);
    });
    int v2 = b0;
    for (int i = 0; i <= n; ++i) {
        int pr = r[ord[i]];
        while (i + 1 <= n && l[ord[i + 1]] == l[ord[i]]) i++;
        int v1 = min(a0, l[ord[i]]);
        ans = max(ans, v1 + v2);
        v2 = min(v2, pr);
    }
    cout << ans + 2 * sum;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
}
