#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>


using namespace std;

#define ALL(x) x.begin(), x.end()
#define int long long
typedef long long ll;
typedef long double ld;

const int MAXN = 1e5 + 5;
const int INF = 1e10;

int n;
vector<int> l;
vector<int> r;
vector<int> d;
set<int> ffg;
int a0, b0;

void solve1()
{
    vector<int> pref;
    pref.push_back(0);
    for (auto i : d)
    {
        pref.push_back(pref.back() + i);
    }
    int ans = 0;
    for (int gh = 0; gh < n; gh++)
    {
        vector<int> a;
        vector<int> b;
        a.push_back(a0);
        b.push_back(b0);
        for (int j = 0; j < n; j++)
        {
            a.push_back(a.back() + d[j]);
            b.push_back(b.back() + d[j]);
            if (j < gh)
            {
                if (l[j] >= l[gh])
                {
                    a.back() = min(a.back(), l[j]);
                }
                else if (l[j] + pref[gh + 1] - pref[j + 1] >= l[gh])
                {
                    a.back() = min(a.back(), l[j]);
                }
                else
                {
                    b.back() = min(b.back(), r[j]);
                }
            }
            else if (j == gh || l[j] >= a.back())
            {
                a.back() = min(a.back(), l[j]);
            }
            else
            {
                b.back() = min(b.back(), r[j]);
            }
        }
        ans = max(ans, b.back() + a.back());
    }
    vector<int> a, b;
    a.push_back(a0);
    b.push_back(b0);
    for (int j = 0; j < n; j++)
    {
        a.push_back(a.back() + d[j]);
        b.push_back(b.back() + d[j]);
        if (l[j] >= a.back())
        {
            a.back() = min(a.back(), l[j]);
        }
        else
        {
            b.back() = min(b.back(), r[j]);
        }
    }
    ans = max(ans, b.back() + a.back());
    cout << ans;
}

void solve2()
{
    map<int, int> sz;
    int timer = 1;
    for (auto i : ffg)
    {
        if (!sz.count(i))
        {
            sz[i] = timer++;
        }
    }
    int ggh[MAXN];
    fill(ggh, ggh + MAXN, INF);
    for (int i = 0; i < n; i++)
    {
        ggh[sz[l[i]]] = min(ggh[sz[l[i]]], r[i]);
    }
    for (int i = 1; i < n; i++)
    {
        ggh[i] = min(ggh[i], ggh[i - 1]);
    }

    int ans = 0;

    for (auto mid : ffg)
    {
        int a = min(mid, a0);
        int b = min(ggh[sz[mid] - 1], b0);
        ans = max(ans, a + b);
    }
    int mid = a0;
    vector<int> a;
    vector<int> b;
    a.push_back(a0);
    b.push_back(b0);
    for (int i = 0; i < n; i++)
    {
        a.push_back(a.back() + d[i]);
        b.push_back(b.back() + d[i]);
        if (l[i] < mid)
        {
            b.back() = min(b.back(), r[i]);
        }
        else
        {
            a.back() = min(a.back(), l[i]);
        }
    }
    ans = max(ans, a.back() + b.back());
    cout << ans;
}

void solve()
{
    
    cin >> n;
    int summ = 0;
    for (int i = 0; i < n; i++)
    {
        int x; cin >> x;
        d.push_back(x);
        summ += x;
    }
  
    for (int i = 0; i < n; i++)
    {
        int x; cin >> x;
        l.push_back(x);
        ffg.insert(x);
    }
    for (int i = 0; i < n; i++)
    {
        int x; cin >> x;
        r.push_back(x);
    }
    
    cin >> a0 >> b0;
    if (summ == 0)
    {
        solve2();
    }
    else
    {
        solve1();
        return;
    }
    
    
}

int32_t main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
}