#include <bits/stdc++.h>
using namespace std;

template <typename T>
istream &operator>>(istream &in, vector <T> &vec) {
    for (auto &el : vec) {
        in >> el;
    }
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector <T> &vec) {
    for (auto el : vec) {
        out << el << ' ';
    }
    out << '\n';
    return out;
}

using ll = long long;
using pll = pair <long long, long long>;
using ull = unsigned long long;

#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

void solution() {
    ll n;
    cin >> n;
    vector <ll> d(n), l(n), r(n);
    cin >> d >> l >> r;
    ll a0, b0;
    cin >> a0 >> b0;

    ll ml = l[0], mr = r[0], md = d[0];
    for (ll i = 0; i < n; ++i) {
        ml = min(ml, l[i]);
        mr = min(mr, r[i]);
        md = max(md, d[i]);
    }

    ll ans;
    if (md == 0) {
        ans = a0 + mr;
        for (ll i = 0; i < n; ++i) {
            ll min_l = l[i], a = a0, b = b0;
            for (ll j = 0; j < n; ++j) {
                if (l[j] >= min_l) {
                    a = min(a, l[j]);
                } else {
                    b = min(b, r[j]);
                }
            }

            ans = max(ans, a + b);
        }
    }

    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solution();

    return 0;
}
