#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <math.h>
#include <algorithm>
#include <queue>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;
const ll mod = 1000000007;
vector <ll> d;
vector <ll> l;
vector <ll> r;
ll ans = 0, n;

void rdp(ll i, ll a, ll b) {
	ll na, nb;
	if (i == n - 1) {
		na = min(a + d[i], l[i]);
		nb = b + d[i];
		ans = max(ans, na + nb);
		na = a + d[i];
		nb = min(b + d[i], r[i]);
		ans = max(ans, na + nb);
		return;
	}
	na = min(a + d[i], l[i]);
	nb = b + d[i];
	rdp(i + 1, na, nb);
	na = a + d[i];
	nb = min(b + d[i], r[i]);
	rdp(i + 1, na, nb);
}

void solve() {
	ll i, a0, b0, a1, b1, j, dp = 1;
	cin >> n;
	d.resize(n);
	l.resize(n);
	r.resize(n);
	for (i = 0; i < n; i++) {
		cin >> d[i];
		if (d[i] != 0) dp = 0;
	}
	for (i = 0; i < n; i++) cin >> l[i];
	for (i = 0; i < n; i++) cin >> r[i];
	cin >> a0 >> b0;
	

	if (dp == 1) {
		a1 = a0;
		b1 = b0;
		for (i = 0; i < n; i++) if (l[i] < a1) b1 = min(b1, r[i]);
		ans = max(ans, a1 + b1);
		vector <pair<ll, ll> > c;
		for (i = 0; i < n; i++) {
			c[i] = { l[i], r[i] };
		}
		sort(c.begin(), c.end());
		vector <ll> suf(n);
		suf[n - 1] = c[n - 1].second;
		for (i = n - 1; i >= 0; i--) {
			suf[i] = min(suf[i + 1], c[i].second);
		}
		for (i = 0; i < n; i++) {
			if (a0 >= c[i].first) {
				a1 = c[i].first;
				b1 = b0;
				if (i+1<n) b1 = min(b0, suf[i + 1]);
			}
		}
		cout << ans;
	}
	else {
		rdp(0, a0, b0);
		cout << ans;
	}
}

int main() {
	ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
	ll t = 1;
	//cin >> t;
	while (t--) solve();
}