#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 2e5;
const int INF = 2e9;
const int mod = 1e9 + 7;

vector<ll> d(N), l(N), r(N);
int n;
ll get(int i, ll a, ll b) {
    if (i == n) {
        return a + b;
    }
    a += d[i], b += d[i];
    return max(get(i + 1, min(a, l[i]), b), get(i + 1, a, min(b, r[i])));
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    vector<ll> a(n + 1), b(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> r[i];
    }
    cin >> a[0] >> b[0];
    if (n <= 15) {
        cout << get(0, a[0], b[0]);
        return 0;
    }
    ll ans = 0;
    l[n] = INF;
    r[n] = INF;
    for (int mnl = 0; mnl < n + 1; mnl++) {
        ll a0 = a[0], b0 = b[0];
        for (int j = 0; j < n + 1; j++) {
            if (l[j] < l[mnl]) {
                b0 = min(b0, r[j]);
            }
        }
        a0 = min(a0, l[mnl]);
        ans = max(ans, a0 + b0);
    }
    cout << ans;
}
