#ifndef BUY
#pragma GCC optimize("Ofast")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;
#define int long long
using pii = pair <int, int>;
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define ff first
#define ss second

template <typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
}

template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
};

void solve(int g = 0) {
    int n;
    cin >> n;
    vector <int> d(n), l(n), r(n);
    for (auto &i : d) {
        cin >> i;
    }
    for (auto &i : l) {
        cin >> i;
    }
    for (auto &i : r) {
        cin >> i;
    }
    int a0, b0;
    cin >> a0 >> b0;
    constexpr int INF = 1e15;
    vector <int> dp(n + 1, -INF);
    vector <int> pp = d;
    for (int i = 1; i < n; ++i) {
        pp[i] += pp[i - 1];
    }
    auto gets = [&](int l, int r) {
        return pp[r] - (l ? pp[l - 1] : 0);
    };
    dp[0] = b0;
    for (int i = 1; i <= n; ++i) {
        vector <int> dp2(n + 1, -INF);
        for (int k = 0; k < i; ++k) {
            int curb = dp[k] + d[i - 1];
            int cura = (k == 0 ? a0 : l[k - 1]);
            cura += gets(k, i - 1);
            if (cura >= l[i - 1]) {
                mxr(dp2[i],  curb);
            } else {
                mxr(dp2[k], curb);
            }
            mxr(dp2[k], min(curb, r[i - 1]));
        }
        dp2.swap(dp);
    }
    int res = 0;
    for (int i = 0; i <= n; ++i) {
        int curb = dp[i];
        int cura = (i == 0 ? a0 : l[i - 1]);
        cura += gets(i, n - 1);
        mxr(res, curb + cura);
    }
    cout << res;
}

signed main() {
    cout << setprecision(15) << fixed;
#ifdef BUY
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
#ifdef BUY
    cerr << "\n";
#endif
}