#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())
const ll INF = LLONG_MAX;

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> &a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

template<typename T>
void print(vector<T> &a, const string &s) {
    for (int i = 0; i < sz(a); ++i) {
        cout << a;
        if (i < sz(a) - 1) {
            cout << s;
        }
    }
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    ll a0, b0;
    cin >> a0 >> b0;
//    ll ans = 0;
//    for (int i = 0; i < (1ll << n); ++i) {
//        ll a = a0, b = b0;
//        for (int j = 0; j < n; ++j) {
//            if (i & (1ll << j)) {
//#ifdef LOCAL
//                cout << 1;
//#endif
//                a = min(a + d[j + 1], l[j + 1]);
//                b += d[j + 1];
//            } else {
//#ifdef LOCAL
//                cout << 0;
//#endif
//                a += d[j + 1];
//                b = min(b + d[j + 1], r[j + 1]);
//            }
//        }
//#ifdef LOCAL
//        cout << ' ' << a + b << '\n';
//#endif
//        ans = max(ans, a + b);
//    }
//    cout << ans;
    ll a = a0, b = b0;
    for (int i = 1; i <= n; ++i) {
        a += d[i];
        b += d[i];
        a = min(a, l[i]);
    }
    ll ans = a + b;
    a = a0, b = b0;
    for (int i = 1; i <= n; ++i) {
        a += d[i];
        b += d[i];
        b = min(b, r[i]);
    }
    ans = max(ans, a + b);
    vector<ll> suf(n + 2), suf_min(n + 2, INF);
    for (int i = n; i >= 0; --i) {
        suf[i] = suf[i + 1] + d[i];
    }
    for (int i = n; i >= 0; --i) {
        suf_min[i] = min(suf_min[i + 1], r[i]);
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
