#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

int t[4 * MAXN];
int addplus[4 * MAXN];
int addmin[4 * MAXN];

void push(int v, int l, int r) {
    if (addplus[v] != 0) {
        t[v] += addplus[v];
        if (l + 1 != r) {
            int m = (l + r) / 2;
            addplus[2 * v + 1] += t[v];
            addplus[2 * v + 2] += t[v];
        }
    }
    addplus[v] = 0;
    if (addmin[v] != -INF) {
        t[v] = min(t[v], addmin[v]);
        if (l + 1 != r) {
            int m = (l + r) / 2;
            addmin[2 * v + 1] = min(addmin[2 * v + 1], addmin[v]);
            addmin[2 * v + 2] = min(addmin[2 * v + 1], addmin[v]);
        }
    }
    addmin[v] = -INF;
}

//void upd(int v, int l, int r, int ql, int qr, int val) {
//    push(v, l, r);
//    if (l + 1 != r) {
//        int m = (l + r) / 2;
//        push(2 * v + 1, l, m);
//        push(2 * v + 2, m, r);
//    }
//    if (r <= ql || l >= qr) {
//        return;
//    } else if (ql <= l && r <= qr) {
//        add[v] += val;
//        push(v, l, r);
//    } else {
//        int m = (l + r) / 2;
//        upd(2 * v + 1, l, m, ql, qr, val);
//        upd(2 * v + 2, m, r, ql, qr, val);
//        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
//    }
//}
//
//int get(int v, int l, int r, int ql, int qr) {
//    push(v, l, r);
//    if (r <= ql || l >= qr) {
//        return -INF;
//    } else if (ql <= l && r <= qr) {
//        return t[v];
//    } else {
//        int m = (l + r) / 2;
//        return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
//    }
//}

void solve() {
    ll n;
    cin >> n;
    ll d[n + 1];
    for (ll i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    ll l[n + 1], r[n + 1];
    for (ll i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (ll i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    ll prefd[n + 1];
    prefd[0] = 0;
    for (ll i = 1; i <= n; ++i) {
        prefd[i] = prefd[i - 1] + d[i];
    }
    vector<int> ind(n + 1);
    for (int i = 0; i <= n; ++i) {
        ind[i] = i;
    }
    sort(ind.begin(), ind.end(), [&](int i, int j) {
        if (l[i] - prefd[i] == l[j] - prefd[j]) {
            return i > j;
        }
        return l[i] - prefd[i] < l[j] < prefd[j];
    });
    vector<int> mest(n + 1);
    for (int i = 0; i <= n; ++i) {
        mest[ind[i]] = i;
    }
    cin >> l[0] >> r[0];
//    upd(0, 0, n + 1, 0, n + 1, -INF);
//    upd(0, 0, n + 1, mest[0], mest[0] + 1, r[0] + INF);
    vector<ll> dp(n + 1, -INF);
    dp[0] = r[0];
    for (ll step = 1; step <= n; ++step) {
//        int m = mest[step];
//        upd(0, 0, n + 1, 0, m, d[step]);
//        int mx = get(0, 0, n + 1, m + 1, n + 1);
//        if (mx != -INF) {
//            upd(0, 0, n + 1, m, m + 1, mx + d[step]);
//        }
//        upd(0, 0, n + 1, m + 1, n + 1, d[step]);
//        updmin(0, 0, n + 1, m + 1, n + 1, r[step]);
        for (ll i = 0; i < step; ++i) {
            if (l[i] - prefd[i] >= l[step] - prefd[step]) {
                dp[step] = max(dp[step], dp[i] + d[step]);
                dp[i] = min(dp[i] + d[step], r[step]);
            } else {
                dp[i] = dp[i] + d[step];
            }
        }
    }
    ll ans = -INF;
    for (ll i = 0; i <= n; ++i) {
        ans = max(ans, dp[i] + l[i] + prefd[n] - prefd[i]);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
