#include <bits/stdc++.h>


using namespace std;


istream & operator >>(istream &in, vector<long long> &a) {
    for (int i = 1; i < int(a.size()); i++) {
        in >> a.at(i);
    }
    return in;
}


set<pair<long long, long long>> s;


void Calc(long long a, long long b, int pos, int n, long long &ans,
          const vector<long long> &d, const vector<long long> &l, const vector<long long> &r) {
    if (pos == n) {
        ans = max(ans, a + b);
        return;
    }
    if (s.find(make_pair(a, b)) != s.end()) {
        return;
    }
    pos++;
    a = a + d.at(pos);
    b = b + d.at(pos);
    if (a <= l.at(pos) || b <= r.at(pos)) {
        Calc(a, b, pos, n, ans, d, l, r);
    } else {
        Calc(min(a, l.at(pos)), b, pos, n, ans, d, l, r);
        Calc(a, min(b, r.at(pos)), pos, n, ans, d, l, r);
    }
    s.insert({a, b});
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<long long> d(n + 1);
    vector<long long> l(n + 1);
    vector<long long> r(n + 1);
    cin >> d >> l >> r;
    long long a0, b0;
    cin >> a0 >> b0;
    long long ans = 0;
    Calc(a0, b0, 0, n, ans, d, l, r);
    cout << ans;
    return 0;
}
