//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>

#include <random>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
//typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define all(a) a.begin(), a.end()
#define rd(a) for (auto &i: a) cin >> i;

ll INF = 1e13;
ll MOD = 1e9 + 7;

bool cmp(pair<ll, ll> l, pair<ll, ll> r) {
    if (l.first + l.second > r.first + r.second || (l.first + l.second < r.first + r.second && max(l.first, l.second) < max(r.first, r.second))) {
        return true;
    } else {
        return false;
    }
}

void solve() {

    ll n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    rd(d);
    rd(l);
    rd(r);
    ll a0 = 0, b0 = 0;
    cin >> a0 >> b0;
    vector<vector<pair<ll, ll>>> dp(n);
    dp[0].push_back({min(l[0], a0 + d[0]), b0 + d[0]});
    dp[0].push_back({a0 + d[0], min(r[0], b0 + d[0])});
    for (int i = 1; i < n; i++) {
        vector<pair<ll, ll>> can;
        for (auto [x, y]: dp[i - 1]) {
            can.push_back({min(l[i], x + d[i]), y + d[i]});
            can.push_back({ x + d[i], min(r[i], y + d[i])});
        }
        sort(all(can), cmp);
        set<pair<ll, ll>> w;
        for (auto [x, y]: can) {
            if (w.find({x, y}) != w.end()) continue;
            dp[i].push_back({x, y});
            if (dp[i].size() > 1000) break;
            w.insert({x, y});
        }

    }
    ll ans = 0;
    for (auto [x, y]: dp[n - 1]) {
        ans = max(ans, x + y);
    }
    cout << ans;

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    //ll t; for (cin >> t; t--;) solve();
    solve();

}

//void operator delete(void*) {};
//const int MAX_MEM = 3 * 1e8;
//int pos = 0;
//char buf[MAX_MEM];
//void* operator new(size_t x) {
//    void* pointer = (void*)(buf + pos);
//    pos += x;
//    if (pos >= MAX_MEM) {
//        pos = 1e6;
//    }
//    return pointer;
//
//}


