#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <deque>

typedef long long ll;

using namespace std;

int main(){
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    ll n, a, b, ans = 0;
    cin >> n;
    vector <ll> d(n), l(n), r(n);
    for(int i = 0; i < n; i++) cin >> d[i];
    for(int i = 0; i < n; i++) cin >> l[i];
    for(int i = 0; i < n; i++) cin >> r[i];
    cin >> a >> b;
    for(int mask = 0; mask < (1 << n); mask++){
        ll cura = a, curb = b;
        for(int i = 0; i < n; i++){
            cura += d[i], curb += d[i];
            if(mask & (1 << i)){
                cura = min(cura, l[i]);
            }
            else{
                curb = min(curb, r[i]);
            }
        }
        ans = max(ans, cura + curb);
    }
    cout << ans;
}