#define debug(x) cout<<(#x)<<" = "<<x;
#define all(x) (x).begin(),(x).end()
#include <cstring>
#include <random>
#include <chrono>
#include <cmath>
#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <numeric>
#include <cstdint>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
using namespace std;
using ll = int64_t;
using ull = uint64_t;

const int N = 1e5;
ll d[N], l[N], r[N];
ll a0, b0;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    cin >> a0 >> b0;
    if (n <= 15) {
        int mask = (1 << n);
        ll best = 0;
        for (int i = 0; i < mask; ++i) {
            ll acur = a0, bcur = b0;
            for (int j = 0; j < n; ++j) {
                acur += d[j];
                bcur += d[j];
                if (i >> j & 1) {
                    acur = min(acur, l[j]);
                } else {
                    bcur = min(bcur, r[j]);
                }
            }
            best = max(best, acur + bcur);
        }
        cout << best;
    } else if (all_of(d, d + n, [&](int k){return k == 0;})) {
        ll acur = a0, bcur = b0;
        for (int i = 0; i < n; ++i) {
            ll da = acur - min(acur, l[i]);
            ll db = bcur - min(bcur, r[i]);
            if (da < db) {
                acur = min(acur, l[i]);
            } else {
                bcur = min(bcur, r[i]);
            }
        }
        cout << acur + bcur << "\n";
    }
}
