#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>
#include <iomanip>
#include <stack>
#include <deque>
#include <algorithm>
#include <random>

typedef long long ll;

using namespace std;

const ll INF = 2e18;
const ll MAXN = 1e5 + 5;

using t3 = tuple<ll, ll, ll>;

ll n;
vector<ll> d, l, r;
ll a0, b0;

void solve01() {
    ll ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        ll A = a0, B = b0;
        for (int i = 0; i < n; ++i) {
            A += d[i];
            B += d[i];

            if ((mask >> i) & 1) {
                B = min(B, r[i]);
            } else {
                A = min(A, l[i]);
            }
        }

        ans = max(ans, A + B);
    }
    cout << ans << '\n';
}

void solve3() {
    ll ans = 0;
    ll kek = INF;
    for (int i = 0; i < n; ++i) {
        kek = min(kek, r[i]);
    }
    ans = a0 + min(kek, b0);
    for (int i = 0; i < n; ++i) {
        ll mn = INF;
        for (int j = 0; j < n; ++j) {
            if (l[j] >= l[i]) {
                continue;
            }

            mn = min(mn, r[j]);
        }
        ans = max(ans, min(a0, l[i]) + min(b0, mn));
    }
    cout << ans << '\n';
}

void start() {
    cin >> n;
    d.assign(n, 0);
    l.assign(n, 0);
    r.assign(n, 0);

    for (ll i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> r[i];
    }

    cin >> a0 >> b0;

    if (n <= 15) {
        solve01();
    } else {
        solve3();
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("in", "r", stdin);
#endif

    ll T = 1;
#ifdef WIN32
    cin >> T;
#endif

    while (T --> 0) {
        start();
    }

    return 0;
}
