#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = 1e18;

mt19937_64 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

struct Fast {

    void solve() {
        ll n;
        cin >> n;
        bool D0 = true;
        vector<ll> d(n), l(n), r(n);
        for (auto &i: d) {
            cin >> i;
            if (i != 0) D0 = false;
        }
        if (D0) {
            multiset<ll> mn;
            vector<pair<ll, ll>> og;
            for (int i = 0; i < n; i++) {
                cin >> l[i];
                og.push_back({l[i], i});
            }
            sort(og.begin(), og.end());
            for (auto &j: r) cin >> j, mn.insert(j);
            ll a, b;
            cin >> a >> b;
            ll mn_a = inf;
            ll mx_res = 0;
            for (int i = 0; i < n + 1; i++) {
                ll f = min(a, mn_a);
                ll s = min(b, (mn.empty() ? inf : *mn.begin()));
                mx_res = max(mx_res, f + s);
                if (!og.empty()) {
                    ll pos = og.back().second;
                    mn_a = og.back().first;
                    mn.erase(mn.find(r[pos]));
                    og.pop_back();
                }
            }
            cout << mx_res;
        } else {
            vector<pair<ll, ll>> og;
            for (int i = 0; i < n; i++) {
                cin >> l[i];
                og.push_back({l[i], i});
            }
            sort(og.begin(), og.end());
            for (auto &j: r) cin >> j;
            ll a, b;
            cin >> a >> b;
            ll mx_res = 0;
            ll a_o = inf;
            for (int i = 0; i < n + 2; i++) {
                ll first_need = a_o;
                vector<bool> first(n, true);
                for (int j = n - 1; j >= 0; j--) {
                    if (l[j] < first_need) {
                        first[j] = false;
                    }
                    first_need -= d[j];
                }
                ll aa = a;
                ll bb = b;
                for (int j = 0; j < n; j++) {
                    aa += d[j];
                    bb += d[j];
                    if (first[j]) aa = min(aa, l[j]);
                    else bb = min(bb, r[j]);
                }
                mx_res = max(mx_res, aa + bb);
                if (!og.empty()) {
                    a_o = og.back().first;
                    og.pop_back();
                }
            }
            cout << mx_res;
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll times = 1;
    bool stres = false;
    if (stres) times = 1e9;
//    else cin >> times;
    while (times--) {
        if (!stres) {
            Fast f;
            f.solve();
        }
    }
    return 0;
}
