#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
#define int int64_t
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF = 1e18 + 117;
vector<int> d, l, r, pd;

bool cmpr(int fs, int sc) {
    return l[fs] < l[sc];
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n; cin >> n;
    d.resize(n);
    l.resize(n);
    r.resize(n);
    pd.resize(n + 1);
    for (auto& e : d) cin >> e;
    for (auto& e : l) cin >> e;
    for (auto& e : r) cin >> e;
    for (int i = 1; i <= n; ++i) {
        pd[i] = pd[i - 1] + d[i - 1];
    }
    int a, b; cin >> a >> b;
    bool fl = true;
    for (int i = 0; i < n; ++i) {
        if (d[i] != 0) fl = false;
    }
    if (fl) {
        vector<int> ir(n);
        iota(ir.begin(), ir.end(), 0);
        sort(ir.begin(), ir.end(), cmpr);
        sort(l.begin(), l.end());
        int ans = 0, mnr = INF;
        for (int i = 0; i < n; ++i) {
            ans = max(ans, min(a, l[i]) + min(b, mnr));
            mnr = min(mnr, r[ir[i]]);
        }
        ans = max(ans, a + min(b, mnr));
        cout << ans << '\n';
        return 0;
    }
    if (n <= 20) {
        int ans = 0;
        for (int mask = 0; mask < (1ll << n); ++mask) {
            int cura = a, curb = b;
            for (int i = 0; i < n; ++i) {
                if ((mask >> i) & 1) {
                    cura = min(cura + d[i], l[i]);
                    curb += d[i];
                } else {
                    cura += d[i];
                    curb = min(curb + d[i], r[i]);
                }
            }
            ans = max(ans, cura + curb);
        }
        cout << ans << '\n';
        return 0;
    }

    vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>> (2, {-INF, -INF}));
    vector<vector<int>> aa(n + 1, vector<int> (n + 1));
    vector<vector<int>> bb(n + 1, vector<int> (n + 1));
    dp[0][0] = dp[0][1] = {a, b};
    aa[0][0] = a;
    bb[0][0] = b;
    for (int i = 1; i <= n; ++i) {
        aa[0][i] = min(aa[0][i - 1] + d[i - 1], l[i - 1]);
        bb[0][i] = min(bb[0][i - 1] + d[i - 1], r[i - 1]);
    }
    for (int i = 1; i <= n; ++i) {
        // lst min(ai, li)
        int sm = d[i - 1];
        for (int j = i - 1; j >= 0; --j) {
            if (dp[i][0].second < dp[j][1].second + sm || (dp[i][0].second == dp[j][1].second + sm && dp[i][0].first < aa[j][i])) {
                dp[i][0].first = aa[j][i];
                dp[i][0].second = dp[j][1].second + sm;
            }
            if (j - 1 >= 0) sm += d[j - 1];
        }
        // lst min(bi, ri)
        sm = d[i - 1];
        for (int j = i - 1; j >= 0; --j) {
            if (dp[i][1].first < dp[j][0].first + sm || (dp[i][1].first == dp[j][0].first + sm && dp[i][1].second < bb[j][i])) {
                dp[i][1].first = dp[j][0].first + sm;
                dp[i][1].second = bb[j][i];
            }
            if (j - 1 >= 0) sm += d[j - 1];
        }
        aa[i][i] = dp[i][1].first;
        bb[i][i] = dp[i][0].second;
        for (int j = i + 1; j <= n; ++j) {
            aa[i][j] = min(aa[i][j - 1] + d[j - 1], l[j - 1]);
            bb[i][j] = min(bb[i][j - 1] + d[j - 1], r[j - 1]);
        }
    }
    cout << max(dp[n][0].first + dp[n][0].second, dp[n][1].first + dp[n][1].second) << '\n';
    return 0;
}
