#include <iostream>
#include <vector>
#include <random>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

mt19937 rnd(45);

const ll MOD = 1e9 + 7;
const ll inf = 1e18;
#define all(x) x.begin(), x.end()

inline void solve() {
    int n; cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    ll A, B; cin >> A >> B;
    vector<ll> dp0(n, -inf), dp1(n, -inf);
    ll ans = 0;
    ll a = A;
    ll b = B;
    for (int i = 0; i <= n; ++i) {
        if (i == n) {
            ans = max(ans, a + b);
            break;
        }
        a += d[i];
        b += d[i];
        if (a > l[i]) {
            dp0[i] = max(dp0[i], b);
            break;
        }
    }
    a = A;
    b = B;
    for (int i = 0; i <= n; ++i) {
        if (i == n) {
            ans = max(ans, a + b);
            break;
        }
        a += d[i];
        b += d[i];
        if (b > r[i]) {
            dp1[i] = max(dp1[i], a);
            break;
        }
    }
    for (int j = 0; j < n; ++j) {
        a = l[j];
        b = dp0[j];
        for (int i = j + 1; i <= n; ++i) {
            if (i == n) {
                ans = max(ans, a + b);
                break;
            }
            a += d[i];
            b += d[i];
            if (a > l[i]) {
                dp0[i] = max(dp0[i], b);
                break;
            }
        }
        a = l[j];
        b = dp0[j];
        for (int i = j + 1; i <= n; ++i) {
            if (i == n) {
                ans = max(ans, a + b);
                break;
            }
            a += d[i];
            b += d[i];
            if (b > r[i]) {
                dp1[i] = max(dp1[i], a);
                break;
            }
        }
        a = dp1[j];
        b = r[j];
        for (int i = j + 1; i <= n; ++i) {
            if (i == n) {
                ans = max(ans, a + b);
                break;
            }
            a += d[i];
            b += d[i];
            if (a > l[i]) {
                dp0[i] = max(dp0[i], b);
                break;
            }
        }
        a = dp1[j];
        b = r[j];
        for (int i = j + 1; i <= n; ++i) {
            if (i == n) {
                ans = max(ans, a + b);
                break;
            }
            a += d[i];
            b += d[i];
            if (b > r[i]) {
                dp1[i] = max(dp1[i], a);
                break;
            }
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}