#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int inf = 1e9;

void solve() {
    int n;
    cin >> n;
    vector<ll> d(n), l(n + 1), r(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    vector<ll> prefd(n + 1);
    for (int i = 1; i <= n; i++) {
        prefd[i] = prefd[i - 1] + d[i - 1];
    }
    for (int i = 1; i <= n; i++) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> r[i];
    }
    cin >> l[0] >> r[0];
    if (n > 5000) {
        int ans = 0;
        vector<pair<int, int>> a;
        for (int i = 0; i < n; i++) {
            a.push_back({l[i + 1], i});
        }
        a.push_back({l[0], -1});
        sort(a.begin(), a.end());
        set<int> b;
        b.insert(r[0]);
        for (auto [val, idx] : a) {
            ans = max(ans, val + *b.begin());
            if (idx == -1) break;
            b.insert(r[idx + 1]);
        }
        cout << ans << '\n';
        return;
    }
    ll ans = 0;
    for (int i = 0; i <= n; i++) {
        vector<bool> onlyr(n + 1);
        ll sumd = 0;
        for (int j = i; j < n; j++) {
            sumd += d[j];
            if (sumd + l[i] > l[j + 1]) {
                onlyr[j + 1] = true;
            }
        }
        for (int j = 0; j < i; j++) {
            if (l[j] + prefd[i] - prefd[j] < l[i]) {
                onlyr[j] = true;
            }
        }
        if (onlyr[0]) continue;
        ll suma = l[0], sumb = r[0];
        for (int j = 1; j <= n; j++) {
            suma += d[j - 1];
            sumb += d[j - 1];
            if (onlyr[j]) {
                sumb = min(sumb, r[j]);
            } else {
                suma = min(suma, l[j]);
            }
        }
        ans = max(ans, sumb + suma);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; i++) solve();
}
