#include<bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 300031;

int d[MAXN];
vector<int> l;
vector<int> r;
int n;
int na, nb;

int solve(){
    int res = 0;
    for(int edge1 = 0; edge1 <= n; edge1++){
        for(int edge2 = edge1; edge2 <= n; edge2++) {
            int a = na;
            int b = nb;
            for (int i = 0; i < n; i++) {
                a += d[i];
                b += d[i];
                if (a <= l[i] || b <= r[i]) continue;
                if (i >= edge1 && i <= edge2) b = r[i];
                else a = l[i];
            }
            res = max(res, a + b);
        }
    }
    for(int edge1 = 0; edge1 <= n; edge1++){
        for(int edge2 = edge1; edge2 <= n; edge2++) {
            int a = na;
            int b = nb;
            for (int i = 0; i < n; i++) {
                a += d[i];
                b += d[i];
                if (a <= l[i] || b <= r[i]) continue;
                if (i >= edge1 && i <= edge2) a = l[i];
                else b = r[i];
            }
            res = max(res, a + b);
        }
    }
    return res;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    l.resize(n);
    r.resize(n);
    for(int i = 0; i < n; i++) cin >> d[i];
    for(int i = 0; i < n; i++) cin >> l[i];
    for(int i = 0; i < n; i++) cin >> r[i];
    int ans = 0;
    cin >> na >> nb;
    for(int mask = 0; mask < (1<<n); mask++){
        int a = na;
        int b = nb;
        for(int i = 0; i < n; i++){
            a += d[i];
            b += d[i];
            if((mask>>i)&1) a = min(a, l[i]);
            else b = min(b, l[i]);
        }
        ans = max(ans, a+b);
    }
    cout << ans;
}
