#include<bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 300031, INF = (1e18)+31;

int d[MAXN];
vector<int> l;
vector<int> r;
int n;
int na, nb;

int dp[331];

int solve(){
    int res = 0;
    for(int edge1 = 0; edge1 <= n; edge1++){
        for(int edge2 = edge1; edge2 <= n; edge2++) {
            int a = na;
            int b = nb;
            for (int i = 0; i < n; i++) {
                a += d[i];
                b += d[i];
                if (a <= l[i] || b <= r[i]) continue;
                if (i >= edge1 && i <= edge2) b = r[i];
                else a = l[i];
            }
            res = max(res, a + b);
        }
    }
    for(int edge1 = 0; edge1 <= n; edge1++){
        for(int edge2 = edge1; edge2 <= n; edge2++) {
            int a = na;
            int b = nb;
            for (int i = 0; i < n; i++) {
                a += d[i];
                b += d[i];
                if (a <= l[i] || b <= r[i]) continue;
                if (i >= edge1 && i <= edge2) a = l[i];
                else b = r[i];
            }
            res = max(res, a + b);
        }
    }
    return res;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    if(n <= 300){
        l.resize(n+2);
        r.resize(n+2);
        l[n+1] = INF;
        r[n+1] = INF;
        for(int i = 0; i < n; i++) cin >> d[i+1];
        for(int i = 0; i < n; i++) cin >> l[i+1];
        for(int i = 0; i < n; i++) cin >> r[i+1];
        int ans = 0;
        cin >> na >> nb;
        l[0] = na;
        r[0] = nb;
        dp[0] = nb;
        for(int i = 1; i <= n; i++){
            dp[i] = -INF;
            for(int j = 0; j < i; j++){
                int a = l[j];
                int b = dp[j];
                for(int k = j+1; k < i; k++){
                    a += d[k];
                    b += d[k];
                    if(a <= l[k]) continue;
                    if(b <= r[k]) continue;
                    b = r[k];
                }
                a += d[i];
                b += d[i];
                if(a < l[i]) continue;
                a = l[i];
                dp[i] = max(dp[i], b);
            }
        }
        //for(int i = 0; i <= n; i++) cout << dp[i] << " ";
        for(int i = 0; i <= n; i++){
            int a = l[i];
            int b = dp[i];
            for(int j = i+1; j <= n; j++){
                a += d[j];
                b += d[j];
                if(a <= l[j]) continue;
                if(b <= r[j]) continue;
                b = r[j];
            }
            ans = max(ans, a+b);
        }
        cout << ans;
        return 0;
    }
    l.resize(n);
    r.resize(n);
    for(int i = 0; i < n; i++) cin >> d[i];
    for(int i = 0; i < n; i++) cin >> l[i];
    for(int i = 0; i < n; i++) cin >> r[i];
    int ans = 0;
    cin >> na >> nb;
    if(n <= 15) {
        for (int mask = 0; mask < (1ll << n); mask++) {
            int a = na;
            int b = nb;
            for (int i = 0; i < n; i++) {
                a += d[i];
                b += d[i];
                if ((mask >> i) & 1) a = min(a, l[i]);
                else b = min(b, r[i]);
            }
            ans = max(ans, a + b);
        }
        cout << ans;
    }
    else{
        for(int edge = 0; edge <= n; edge++){
            int a = na;
            int b = nb;
            int mn = (1e9)+7;
            if(edge != n) mn = l[edge];
            for(int i = 0; i < n; i++){
                a += d[i];
                b += d[i];
                if(l[i] >= mn) a = min(a, l[i]);
                else b = min(b, r[i]);
            }
            ans = max(ans, a+b);
        }
        for(int edge = 0; edge <= n; edge++){
            int a = na;
            int b = nb;
            int mn = (1e9)+7;
            if(edge != n) mn = l[edge];
            for(int i = 0; i < n; i++){
                a += d[i];
                b += d[i];
                if(l[i] >= mn) b = min(b, r[i]);
                else a = min(a, l[i]);
            }
            ans = max(ans, a+b);
        }
        cout << ans;
    }
}
