//#pragma optimize("Ofast,unroll-loops");
//#pragma target("avx2");

#include <bits/stdc++.h>
#include <bits/extc++.h>


using namespace std;
using namespace __gnu_pbds;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define endl '\n'
#define pint pair<int, int>
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    forn(i, 0, n) {
        cin >> d[i];
    }
    forn(i, 0, n) {
        cin >> l[i];
    }
    forn(i, 0, n) {
        cin >> r[i];
    }

    int a0, b0;
    cin >> a0 >> b0;
    set<pint> vals ={ { a0, b0 } };

    forn(i, 1, n + 1) {
        set<pint> nxt;
        for(auto& [u, v] : vals) {
            nxt.insert({ min(l[i - 1], u + d[i - 1]), min(r[i - 1], v + d[i - 1]) });
        }
        vals = nxt;
    }
    int ans = 0;
    for(auto& [u, v] : vals) {
        ans = max(ans, u + v);
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
