#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define pw(x) (1ll << x)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn (T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx (T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pii = pair < int , int >;

const int N = 1e6 + 5;
const int inf = 2e9;
const ll INF = 4e18;

int n, l[N], r[N], d[N];
ll a[N], b[N];
map < ll, int > mp;
int stn = 0;

struct fenwick {
    vector < ll > t;
    void init (int _n) {
        t.resize(_n + 1);
        fill(all (t), INF);
    }

    void upd (int v, ll val) {
        for (;v < sz(t); v = v | (v + 1)) umn (t[v], val);
    }

    ll get (int v) {
        ll res = INF;
        for (; v >= 0; v = (v & (v + 1)) - 1) umn (res, t[v]);
        return res;
    }
} t;

int main() {
#ifdef localy
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for (int i = 1; i <= n; ++ i) cin >> d[i];
    for (int i = 1; i <= n; ++ i) cin >> l[i];
    for (int i = 1; i <= n; ++ i) cin >> r[i];

    cin >> a[0] >> b[0];
    for (int i = 1; i <= n; ++ i) a[i] = a[i - 1] + d[i], b[i] = b[i - 1] + d[i];

    vector < ll > order;
    ll s = 0;
    for (int i = n; i >= 1; -- i) {
        r[i] += s;
        l[i] += s;
        s += d[i];

        order.pb(l[i]);
    }
    order.pb (a[n]);

    sort (all (order));
    for (int i = 1; i < sz(order); ++ i) {
        if (order[i] != order[i - 1]) {
            mp[order[i - 1]] = ++ stn;
        }
    } mp[order.back()] = ++ stn;

    t.init(stn);
    for (int i = 1; i <= n; ++ i) {
        t.upd (mp[l[i]], r[i]);
    }

    ll mx = 0;
    for (int i = 1; i <= n; ++ i) {
        umx (mx, a[n] + min (b[n], t.get (mp[a[n]] - 1)));
        if (a[n] < l[i]) continue;
        umx (mx, l[i] + min (b[n], t.get (mp[l[i]] - 1)));
    }

    cout << mx << "\n";
    return 0;
}
