//#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define int ll
typedef long long ll;
#define all(x) x.begin(), x.end()
#define vec vector

vec<int> L, R;
vec<int> D;
vec<int> pr;
int a0, b0;

void solve() {
    int n; cin >> n;
    D.resize(n);
    L.resize(n);
    R.resize(n);
    pr.assign(n + 1, 0);
    for (auto& it : D)
        cin >> it;
    for (auto& it : L)
        cin >> it;
    for (auto& it : R)
        cin >> it;
    for (int i = 0; i < n; i++)
        pr[i + 1] = pr[i] + D[i];
    cin >> a0 >> b0;
    deque<vec<int>> q = {{a0, b0, 0}};
    vec<pair<int, int>> cn(n + 1, {0, 0});
    int ans = 0;
    while (!q.empty()) {
        auto v = q.front();
        auto l = v[2];
        q.pop_front();
        if (v[0] + v[1] < pr[l])
            continue;
        if (cn[l].first > v[0] && cn[l].second > v[1])
            continue;
        cn[l] = {v[0], v[1]};
        if (v[2] == n) {
            ans = max(ans, v[0] + v[1]);
            continue;
        }
        q.push_back({min(v[0] + D[l], L[l]), v[1] + D[l], l + 1});
        q.push_back({v[0] + D[l], min(v[1] + D[l], R[l]), l + 1});
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

//    auto start = std::chrono::steady_clock::now();

    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }

//    auto end = std::chrono::steady_clock::now();
//    std::chrono::duration<double> elapsed_seconds = end - start;
//    cout << endl << elapsed_seconds << endl;
}