#include <bits/stdc++.h>
#pragma GCC optimize("O3")
typedef long long ll;
typedef long double ld;
#define all(a) (a).begin(), (a).end()
#define pii pair<ll, ll>

using namespace std;
mt19937 rnd(238);

ld rand01() {
    ll mod = 1e9;
    ll t = rnd()%mod;
    return (ld)t / (ld)mod;
}

int main() {
#ifdef ZVEREV
    freopen("inputf.in", "r", stdin);
    freopen("outputf.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << fixed << setprecision(64);
    int n; cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (auto& i : d) cin >> i;
    for (auto& i : l) cin >> i;
    for (auto& i : r) cin >> i;
    ll a, b; cin >> a >> b;
    ll maxd = *max_element(all(d));
    if (maxd == 0) {
        ll mna = 1e9;
        ll mnb = 1e9;
        for (int i = 0; i < n; i++) {
            mna = min(mna, l[i]);
            mnb = min(mnb, r[i]);
        }
        ll ans = max(a + min(mnb, b), b + min(mna, a));
        vector<pii > q;
        for (int i = 0; i < n; i++) {
            q.push_back({l[i], r[i]});
        }
        sort(all(q));
        ll mn = 1e9;
        for (int i = 0; i < n; i++) {
            ll cura = min(a, q[i].first);
            if (i > 0) {
                mn = min(mn, q[i - 1].second);
            }
            ans = max(ans, cura + min(mn, b));
        }
        cout << ans;
        return 0;
    }
    if (n <= 15) {
        ll ans = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            ll cura = a;
            ll curb = b;
            for (int i = 0; i < n; i++) {
                if ((1 << i) & mask) {
                    cura = min(cura + d[i], l[i]);
                    curb += d[i];
                } else {
                    curb = min(curb + d[i], r[i]);
                    cura += d[i];
                }
            }
            ans = max(ans, cura + curb);
        }
        cout << ans;
        return 0;
    }
    ll ans = 0;
    ll izna = a;
    ll iznb = b;
    vector<int> p(n, 0);
    for (int i = 0; i < n; i++) {
        if (p[i]) {
            a = min(a + d[i], l[i]);
            b += d[i];
        } else {
            b = min(b + d[i], r[i]);
            a += d[i];
        }
    }
    ll q = a + b;
    ld t = 100;
    auto start = clock();
    while (clock() - start <= 0.96 * CLOCKS_PER_SEC) {
        a = izna;
        b = iznb;
        vector<int> newp = p;
        int ri = rnd()%n;
        newp[ri] = (newp[ri] + 1)%2;
        for (int i = 0; i < n; i++) {
            if (p[i]) {
                a = min(a + d[i], l[i]);
                b += d[i];
            } else {
                b = min(b + d[i], r[i]);
                a += d[i];
            }
        }
        ll newq = a + b;
        if (newq > q) {
            p = newp;
            q = newq;
        } else {
            if (rand01() < exp((ld)(newq - q)/t)) {
                p = newp;
                q = newq;
            }
        }
        t *= 0.99;
    }
    cout << q;
}
