#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <cmath>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;
const ll INF = 1e18;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n; cin >> n;
	vector<ll> d(n + 1), l(n + 1), r(n + 1);
	ll a0, b0;
	for (int i = 1; i <= n; ++i)
		cin >> d[i];
	for (int i = 1; i <= n; ++i)
		cin >> l[i];
	for (int i = 1; i <= n; ++i)
		cin >> r[i];
	cin >> a0 >> b0;
	ll ans = 0;
	for (int mask = 0; mask < (1 << n); ++mask) {
		ll a = a0, b = b0;
		for (int i = 1; i <= n; ++i) {
			a += d[i]; b += d[i];
			if ((mask >> (i - 1)) & 1) {
				a = min(a, l[i]);
			}
			else {
				b = min(b, r[i]);
			}
		}
		ans = max(ans, a + b);
	}
	cout << ans;

	return 0;
}