//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ll = long long;
using ld = long double;

const ll INF = 2e18;
const int MOD = 1e9 + 7, N = 1e5 + 1, MAXN = 5e5 + 1, K = 26, INFi = 2e9;
const ld EPS = 1e-12, PI = acos(-1);

random_device rd;
mt19937_64 rnd(rd());

struct lr{
    int l, r, id;
};

bool cmp(lr a, lr b) {
    return a.l > b.l;
}

int n, a0, b0;
vector<int> d;
vector<lr> v;

void d0() {
    sort(v.begin() + 1, v.end(), cmp);
    int ans = 0;
    set<pair<int, int>> st;
    v[0] = {INF, INF, INF};
    for (int i = 0; i <= n; i++) {
        st.insert({v[i].r, v[i].id});
    }
    for (int i = 0; i < n; i++) {
        st.erase({v[i].r, v[i].id});
        auto it = st.begin();
        ans = max(ans, min(b0, it->first) + min(a0, v[i].l));
    }
    ans = max(ans, min(a0, v[n].l) + a0);
    cout << ans;
}

void solve() {
    cin >> n;
    d.resize(n + 1);
    v.resize(n + 1);
    bool fl = true;
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
        if (d[i] > 0) {
            fl = false;
        }
    }
    for (int i = 1; i <= n; i++) {
        cin >> v[i].l;
    }
    for (int i = 1; i <= n; i++) {
        cin >> v[i].r;
        v[i].id = i;
    }
    cin >> a0 >> b0;
    if (fl) {
        d0();
        return;
    }
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        int cura = a0, curb = b0;
        for (int j = 0; j < n; j++) {
            cura += d[j + 1], curb += d[j + 1];
            if (mask & (1 << j)) {
                cura = min(cura, v[j + 1].l);
            } else {
                curb = min(curb, v[j + 1].r);
            }
        }
        ans = max(ans, cura + curb);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
