#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long

#ifdef LOCAL
constexpr int MAXN = 100, LG = 5;
#else
constexpr int MAXN = 300010, LG = 60;
#endif

void solve() {
    int n;
    cin >> n;
    vector<ll> pref(n + 1), l(n), r(n);
    for (int i = 0; i < n; i++)
        cin >> pref[i];
    for (int i = n - 1; i >= 0; --i)
        pref[i] += pref[i + 1];
    for (int i = 0; i < n; i++) {
        cin >> l[i];
        l[i] += pref[i + 1];
    }
    for (int i = 0; i < n; i++){
        cin >> r[i];
        r[i] += pref[i + 1];
    }

    ll a0, b0;
    cin >> a0 >> b0;
    a0 += pref[0];
    b0 += pref[0];
    set<pair<ll, int>> sl;
    multiset<ll> sr;
    for (int i = 0; i < n; i++) {
        sl.insert({ l[i], i });
        sr.insert(r[i]);
    }
    ll ans = max(a0 + *min_element(all(r)), b0 + *min_element(all(l)));
    for (int i = 0; i < n - 1; i++) {
        int a = prev(sl.end())->S;
        sl.erase(prev(sl.end()));
        sr.erase(sr.find(r[a]));
        ans = max(ans, min(a0, l[a]) + min(b0, *sr.begin()));
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
    
    return 0;
}
