#ifndef LOCAL
#pragma GCC optimize("03")
#pragma GCC optimize("O3")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ld = long double;
using dd = double;
using uint = unsigned int;
using i128 = __int128;

#define int ll

struct hs {
    int a, b;

    int operator()() {
        return a + b;
    }
};


void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    int a, b;
    cin >> a >> b;
    vector<vector<hs>> dp(2, vector<hs>(n));
    dp[0][0] = {min(a, l[0]), b};
    dp[1][0] = {a, min(b, r[0])};
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            for (int k = 0; k < 2; ++k) {
                hs w = dp[k][j];
                for (int t = j + 1; t < i; ++t) {
                    w.a += d[t];
                    w.b += d[t];
                    if (k == 0) w.b = min(w.b, r[t]);
                    else w.a = min(w.a, l[t]);
                }
                w.a += d[i];
                w.b += d[i];
                if (k == 1) w.b = min(w.b, r[i]);
                else w.a = min(w.a, l[i]);
                if (dp[k][i]() < w()) dp[k][i] = w;
            }
        }
    }
    cout << max(dp[0][n - 1](), dp[1][n - 1]());
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(4);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
