#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using db = long double;

#define int long long

void test_case() {
    int n;
    cin >> n;
    vector<int> D(n + 1), L(n + 1), R(n + 1);
    vector<int> pd(n + 2);
    for (int i = 1; i <= n; i++) {
        cin >> D[i];
        pd[i + 1] = pd[i] + D[i];
    }
    vector<int> pl(n + 1), pr(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> L[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> R[i];
    }
    int a0, b0;
    cin >> a0 >> b0;
    L[0] = a0;
    R[0] = b0;
    for (int i = n; i >= 0; i--) {
        pl[i] = L[i] + pd[n + 1] - pd[i + 1];
        pr[i] = R[i] + pd[n + 1] - pd[i + 1];
    }
    vector<int> order(n + 1);
    iota(order.begin(), order.end(), 0);
    sort(order.begin(), order.end(), [&](int i, int j) {
        return pl[i] < pl[j];
    });
    vector<int> mn(n + 1);
    mn[0] = pr[order[0]];
    for (int j = 1; j <= n; j++) {
        mn[j] = min(mn[j - 1], pr[order[j]]);
    }
    int ans = 0;
    for (int k = 0; k <= n; k++) {
        int i = order[k];
        if (pl[0] < pl[i]) continue;
        int B = min(pr[0], (k == 0 ? LLONG_MAX : mn[k - 1]));
//        for (int j = 1; j <= n; j++) {
//            if (pl[j] >= pl[i]) continue;
//            B = min(B, pr[j]);
//        }
        ans = max(ans, B + pl[i]);
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int tests = 1;
    // cin >> tests;
    while (tests--) {
        test_case();
    }
    return 0;
}
