#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (auto& x : d) cin >> x;
    for (auto& x : l) cin >> x;
    for (auto& x : r) cin >> x;
    int sx, sy;
    cin >> sx >> sy;
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int x = sx, y = sy;
        for (int i = 0; i < n; ++i) {
            x += d[i];
            y += d[i];
            if (mask >> i & 1) {
                y = min(y, r[i]);
            } else {
                x = min(x, l[i]);
            }
        }
        ans = max(ans, x + y);
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
