#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (auto& x : d) cin >> x;
    for (auto& x : l) cin >> x;
    for (auto& x : r) cin >> x;
    auto cmp = [&](pair<int, int>& f, pair<int, int>& s) -> bool {
        if (f.first + f.second == s.first + s.second) return f.first > s.first;
        return f.first + f.second > s.first + s.second;
    };
    int stx, sty;
    cin >> stx >> sty;
    vector<unordered_map<int, int>> dp(n + 1);
    dp[0][stx] = sty;
    for (int i = 0; i < n; ++i) {
        for (auto& [x, y] : dp[i]) {
            dp[i + 1][x + d[i]] = max(dp[i + 1][x + d[i]], min(y + d[i], r[i]));
            dp[i + 1][min(x + d[i], l[i])] = max(dp[i + 1][min(x + d[i], l[i])], y + d[i]);
        }
        vector<pair<int, int>> vc;
        for (auto& [x, y] : dp[i + 1]) {
            vc.push_back({x, y});
        }
        dp[i + 1].clear();
        sort(vc.begin(), vc.end(), cmp);
        for (int j = 0; j < 50 && j < vc.size(); ++j) {
            dp[i + 1].insert(vc[j]);
        }
    }
    int ans = 0;
    for (auto& [x, y] : dp[n]) {
        ans = max(ans, x + y);
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
