#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

const int N = 1e5 + 5;
int d[N], l[N], r[N];
unordered_map<int, int> dp[N];

const int MAXN = 3e7 + 5;
pair<int, int> vc[MAXN];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < n; ++i) cin >> l[i];
    for (int i = 0; i < n; ++i) cin >> r[i];
    auto cmpx = [&](pair<int, int>& f, pair<int, int>& s) -> bool {
        if (f.first + f.second == s.first + s.second) return f.first > s.first;
        return f.first + f.second > s.first + s.second;
    };
    int stx, sty;
    cin >> stx >> sty;
    dp[0][stx] = sty;
    int S = 0;
    for (int i = 0; i < n; ++i) {
        int st = S;
        for (auto& [x, y] : dp[i]) {
            vc[S++] = {x + d[i], min(y + d[i], r[i])};
            vc[S++] = {min(x + d[i], l[i]), y + d[i]};
//            dp[i + 1][x + d[i]] = max(dp[i + 1][x + d[i]], min(y + d[i], r[i]));
//            dp[i + 1][min(x + d[i], l[i])] = max(dp[i + 1][min(x + d[i], l[i])], y + d[i]);
        }
        sort(vc + st, vc + S, cmpx);
        for (int j = st; j < st + 60 && j < S; ++j) {
            dp[i + 1].insert(vc[j]);
        }
    }
    int ans = 0;
    for (auto& [x, y] : dp[n]) {
        ans = max(ans, x + y);
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
