#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops", "inline")
#pragma GCC target("popcnt")
using namespace std;
#define int long long

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    auto start = clock();
    mt19937 rnd(42);

    int n, a0, b0;
    cin >> n;
    vector<int> D(n), L(n), R(n);
    for (int &x: D) cin >> x;
    for (int &x: L) cin >> x;
    for (int &x: R) cin >> x;
    cin >> a0 >> b0;

    int best = 0, a, b;
    a = a0, b = b0;
    for (int i = 0; i < n; i++) {
        a += D[i], b += D[i];
        if (R[i] >= b) continue;
        a = min(a, L[i]);
    }
    best = max(best, a + b);
    a = a0, b = b0;
    for (int i = 0; i < n; i++) {
        a += D[i], b += D[i];
        if (L[i] >= a) continue;
        b = min(b, R[i]);
    }
    best = max(best, a + b);
    a = a0, b = b0;
    for (int i = 0; i < n; i++) {
        a += D[i], b += D[i];
        if (L[i] >= a) continue;
        if (R[i] >= b) continue;
        if (a - min(a, L[i]) < b - min(b, R[i])) {
            a = min(a, L[i]);
        } else {
            b = min(b, R[i]);
        }
    }
    best = max(best, a + b);
    while (clock() - start < 0.95 * CLOCKS_PER_SEC) {
        a = a0, b = b0;
        for (int i = 0; i < n; i++) {
            a += D[i], b += D[i];
            if (L[i] >= a) continue;
            if (R[i] >= b) continue;
            if (rnd() % 2) {
                a = min(a, L[i]);
            } else {
                b = min(b, R[i]);
            }
        }
        best = max(best, a + b);
    }
    cout << best;
    return 0;
}