#include<bits/stdc++.h>

#define pii pair < int, int >
#define pb push_back
#define int long long
#define F first
#define S second

using namespace std;


const int N = 3e5 + 10;
const int inf = 1e18;


int l[N], r[N], d[N];
int dp[5003][5003][2];
int prefs[N];

int n, a, b;

int solve_mask() {
     int ans = 0;
     for(int msk = 0; msk < (1 << n); msk++) {
         int A = a, B = b;
         for(int i = 0; i < n; i++) {
             A = A + d[i + 1];
             B = B + d[i + 1];

             if((1 & (msk >> i))) A = min(A, l[i + 1]);
             else B = min(B, r[i + 1]);
         }

         ans = max(ans, A + B);
     }
     return ans;

}

int solve35() {
      vector < pii > p;

        for(int i = 1; i <= n; i++) {
            p.pb({l[i], i});
        }

        sort(p.begin(), p.end(),
             [](const pii &x, const pii &y) {return (x.F < y.F || (x.F == y.F && r[x.S] > r[y.S]));});

        int ans = 0;
        int nb = b;

        for(auto to : p) {
//            cout << "!! " << to.F << ' ' << to.S << ' ' << nb << endl;
//            if(to.F > a) break;
            ans = max(ans, min(a, to.F) + nb);

            if(to.F < a) nb = min(nb, r[to.S]);

        }

        ans = max(ans, nb + a);

        return ans;
}
int sum(int l, int r) {
    return prefs[r] - prefs[l - 1];
}
int solve_cube() {
        for(int pref = 0; pref <= n; pref++)
        for(int i = 0; i <= n; i++)
        for(int j = 0; j <= 1; j++)
        dp[pref][i][j] = -inf;


        dp[0][0][0] = dp[0][0][1] = a + b;
        l[0] = a, r[0] = b;

        for(int pref = 0; pref < n; pref++)
            for(int i = 0; i <= pref; i++) {

                    int A = l[i], B = dp[pref][i][0] - A;

                    int sa = i, difa = d[pref + 1];
                    if(l[i] + sum(i + 1, pref + 1) > l[pref + 1]) {
                            sa = pref + 1;
                            difa = -l[i] - sum(i + 1, pref) + l[pref + 1];
                    }
                    dp[pref + 1][sa][0] = max(dp[pref + 1][sa][0], dp[pref][i][0]  + difa + d[pref + 1]);

                    if(B + d[pref + 1] >= r[pref + 1]) {
                        dp[pref + 1][pref + 1][1] = max(dp[pref + 1][pref + 1][1], dp[pref][i][0] + d[pref + 1] - B + r[pref + 1]);
                    }
                    else {
                        dp[pref + 1][i][0] = max(dp[pref + 1][i][0], dp[pref][i][0] + d[pref + 1]);
                    }

                    int sb = i, difb = d[pref + 1];
                    B = r[i], A = dp[pref][i][1] - B;

                    if(r[i] + sum(i + 1, pref + 1) >= r[pref + 1]) {
                            sb = pref + 1;
                            difb = -r[i] - sum(i + 1, pref) + r[pref + 1];
                    }

                    dp[pref + 1][sb][1] = max(dp[pref + 1][sb][1], dp[pref][i][1] + difb + d[pref + 1]);
                    if(A + d[pref + 1] >= l[pref + 1]) {
                        dp[pref + 1][pref + 1][0] = max(dp[pref + 1][pref + 1][0], dp[pref][i][1] + d[pref + 1] - A + l[pref + 1]);
                    }
                    else {
                        dp[pref + 1][i][1] = max(dp[pref + 1][i][1], dp[pref][i][1] + d[pref + 1]);
                    }
                }

         int ans = 0;

         for(int i = 0; i <= n; i++)
            for(int j = 0; j <= 1; j++) {
            ans = max(ans, dp[n][i][j]);
//            if(dp[n][i][j] == ans) cout << "! " << i << ' ' << j << endl;
            }

         return ans;
}
void solve() {

//     int n;
     cin >> n;

     int cnt = 0;

     for(int i = 1; i <= n; i++) {
         cin >> d[i];
         cnt += (d[i] == 0);
         prefs[i] = prefs[i - 1] + d[i];
     }
     for(int i = 1; i <= n; i++) {
         cin >> l[i];
     }
     for(int i = 1;  i <= n; i++) {
         cin >> r[i];
     }
//     int a, b;
     cin >> a >> b;



     if(n <= 15) {
         cout << solve_mask();
         return;
     }

     if(cnt == n) {
        cout << solve35();
        return;
     }

     if(n <= 5000) {
         cout << solve_cube();
         return;
     }






}
int32_t main() {

    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #else

    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    solve();

    return 0;
}

