#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

mt19937 rnd(14);

typedef long long ll;
typedef long double ld;

const ll inf = 1e18;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    vector<ll> d(n + 1);
    vector<ll> l(n + 1);
    vector<ll> r(n + 1);
    for(int i = 1; i <= n; i++) cin >> d[i];
    for(int i = 1; i <= n; i++) cin >> l[i];
    for(int i = 1; i <= n; i++) cin >> r[i];
    ll a0, b0; cin >> a0 >> b0;
    d[0] = 0;
    l[0] = a0;
    r[0] = b0;
    vector<vector<ll>> dp(n + 1, {-inf, -inf});
    dp[0][0] = b0;
    dp[0][1] = a0;
    for(int i = 1; i <= n; i++) {
        ll res = dp[i - 1][0], sum = 0;
        for(int j = i; j <= n; j++) {
            res += d[j];
            sum += d[j];
            if (res >= r[j]) {
                res = r[j];
                dp[j][1] = max(dp[j][1], l[i - 1] + sum);
            }
        }
        res = dp[i - 1][1], sum = 0;
        for(int j = i; j <= n; j++) {
            res += d[j];
            sum += d[j];
            if (res >= l[j]) {
                res = l[j];
                dp[j][0] = max(dp[j][0], r[i - 1] + sum);
            }
        }
    }
    ll res = 0;
    for(int i = 0; i <= n; i++) {
        ll k2 = dp[i][0], k1 = dp[i][1], sum = 0;
        for(int j = i + 1; j <= n; j++) {
            k1 += d[i];
            k2 += d[i];
            if (k1 > l[i]) k1 = l[i];
            if (k2 > r[i]) k2 = r[i];
            sum += d[i];
        }
        res = max(res, k1 + l[i] + sum);
        res = max(res, k2 + r[i] + sum);
    }
    cout << res;
    return 0;
}
