#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

using namespace __gnu_pbds;

template < typename T >
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
bool umx(T& a, T b) {
    return (a < b ? a = b, 1 : 0);
}

template<typename T>
bool umn(T& a, T b) {
    return (a > b ? a = b, 1 : 0);
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int N = 3e5 + 222;
const int mod = 1e9 + 7;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 1; i <= n; ++i) cin >> d[i];
    for (int i = 1; i <= n; ++i) cin >> l[i];
    for (int i = 1; i <= n; ++i) cin >> r[i];
    vector<ll> a(n + 1), b(n + 1);
    cin >> a[0] >> b[0];
    for (int i = 1; i <= n; ++i) {
        a[i] = a[i - 1] + d[i], b[i] = b[i - 1] + d[i];
        if (a[i] <= l[i] || b[i] <= r[i]) continue;
        ll delta1 = a[i] - l[i], delta2 = b[i] - r[i];
        if (delta1 < delta2) a[i] = l[i];
        else b[i] = r[i];
    }

    cout << a[n] + b[n] << endl;


    return 0;
}
