#include <bits/stdc++.h>

using namespace std;
namespace rng = ranges;
namespace viu = views;

typedef int64_t ll;

#define INF ((int)1e9 + 1329)
#define INF_LL ((int64_t)1e18)

#ifndef ILKRAS
#define ent "\n"
#else
#define ent endl
#endif

struct Solution {
    int TEST = -1;

    signed operator()() {
        int n;
        cin >> n;
        vector<ll> dr(n);
        for (auto &it: dr) cin >> it;
        vector<ll> pr(n + 1, 0ll);
        for (int i = n - 1; i >= 0; --i) {
            pr[i] = pr[i + 1] + dr[i];
        }
        vector<ll> lr(n), rr(n);
        for (auto &it: lr) cin >> it;
        for (auto &it: rr) cin >> it;
        ll a, b;
        cin >> a >> b;
        vector<int> opers(n);
        iota(opers.begin(), opers.end(), 0);
        sort(opers.begin(), opers.end(), [&](int l, int r) -> bool {
            return lr[l] + pr[l + 1] > lr[r] + pr[r + 1];
        });
        vector<bool> tkb(n, true);
        auto evaluate = [&]() -> ll {
            ll pa = a, pb = b;
            for (int i = 0; i < n; ++i) {
                pa += dr[i];
                pb += dr[i];
                if (!tkb[i]) {
                    pa = min(pa, lr[i]);
                } else {
                    pb = min(pb, rr[i]);
                }
            }
            return pa + pb;
        };
        ll ans = evaluate();
        for (auto& it : opers) {
            tkb[it] = false;
            ans = max(ans, evaluate());
        }
        cout << ans << "\n";
        return 0;
    }

    Solution(int TEST = -1) : TEST(TEST) {}
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    for (int TEST: viu::iota(1, t + 1)) {
        int res = Solution(TEST)();
        if (res != 0)
            return res;
    }
    return 0;
}