#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()

using namespace std;
using ll = long long;

const ll INF = 1e9 + 7, MAXN = 10, MAXA = 10;

template <typename T>
ostream &operator<<(ostream &out, vector<T> &v) {
    for (auto &item : v) cout << item << ' ';
    return out;
}

ll n;
vector<ll> d, l, r;
vector<pair<ll, ll>> lst;

ll rec(ll a, ll b, ll m, ll ind = 0) {
    if (ind == m) return a + b;

    a += d[ind];
    b += d[ind];

    return max(rec(min(a, l[ind]), b, m, ind + 1), rec(a, min(b, r[ind]), m, ind + 1));
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n;

    d.resize(n);
    l.resize(n);
    r.resize(n);

    for (ll i = 0; i < n; i++) cin >> d[i];
    for (ll i = 0; i < n; i++) cin >> l[i];
    for (ll i = 0; i < n; i++) cin >> r[i];

    ll a, b; cin >> a >> b;

    if (n <= 15 and false) {
        cout << rec(a, b, n) << endl;
        return 0;
    }

    for (ll i = 0; i < n; i++) lst.emplace_back(l[i], r[i]);

    sort(all(lst));

    vector<ll> pref(n, INF), suf(n, 0);
    for (ll i = 0; i < n - 1; i++) pref[i + 1] = min(pref[i], lst[i].second);
    for (ll i = n - 1; i; i--) suf[i - 1] = max(suf[i], lst[i].second);

    ll ans = 0;
    for (ll i = 0; i < n; i++) ans = max(ans, min(a, lst[i].first) + min(b, min(pref[i], suf[i])));

    cout << ans << endl;

//    mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
//    ll t = 100;
//    while (t--) {
//        n = gen() % MAXN + 1;
//        ll a = gen() % MAXA + 1, b = gen() % MAXA + 1;
//
//        d.resize(n);
//        l.resize(n);
//        r.resize(n);
//
//        for (ll i = 0; i < n; i++) {
//            d[i] = gen() % MAXA;
//            l[i] = gen() % MAXA;
//            r[i] = gen() % MAXA;
//        }
//
//        ll ans1 = solve(a, b, n), ans2 = rec(a, b, n);
//        if (ans1 == ans2) continue;
//
//        cout << "!WRONG!" << endl;
//        cout << n << endl;
//        cout << d << endl << l << endl << r << endl;
//        cout << a << " " << b << endl;
//        cout << "clever: " << ans1 << endl;
//        cout << "stupid: " << ans2 << endl;
//    }
}
