#include <bits/stdc++.h>
using namespace std;
using ll = long long;
struct seg {
    int G;
    vector<ll> t;
    seg (int n) {
        G = (1 << (__lg(n) + 1));
        t.resize(2 * G, 1e18);
    }
    void upd(int id, int val) {
        for (id += G, t[id] = val, id >>=1; id; id >= 1) t[id] = min(t[id << 1], t[id << 1 | 1]); 
    }
    ll get(int ql, int qr) {
        ll ans = 1e18;
        for (ql += G, qr += G; ql <= qr; ql >>= 1, qr >>= 1) {
            if (ql & 1) ans = min(ans, t[ql++]);
            if (~qr & 1) ans = min(ans, t[qr--]);
        }
        return ans;
    }
};
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    vector<ll> d(n + 1);
    vector<ll> l(n + 1), r(n + 1);
    for (int i = 1; i <= n; i++) cin >> d[i];
    for (int i = 1; i <= n; i++) cin >> l[i];
    for (int i = 1; i <= n; i++) cin >> r[i];
    vector<ll> sum(n+1);
    for (int i = 1; i <= n; i++) sum[i] = d[i] + sum[i-1];
    ll a, b;
    cin >> a >> b;
    vector<vector<pair<ll, ll>>> dp(n + 1, vector<pair<ll, ll>>(2, {-1, -1}));
    dp[0][0] = {a, b};
    dp[0][1] = {a, b};
    ll ans = 0;
    vector<vector<int>> point(n + 1, vector<int> (2, 0));
    seg mnl(n+1);
    seg mnr(n+1);
    for (int i = 1; i <= n; i++) {
        mnl.upd(i, l[i] - sum[i]);
        mnr.upd(i, r[i] - sum[i]);
    }
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j < 2; j++) {
            ll mf = dp[i][j].first;
            ll ms = dp[i][j].second;
            int lo = i + 1;
            int ro = n + 1;
            while (ro - lo > 1) {
                int mid = lo + ro >> 1;
                if (mnl.get(i+1, mid) <= mf - sum[i]) ro = mid;
                else lo = mid;
            }
            int st = lo;
            lo = i + 1;
            ro = n + 1;
            while (ro - lo > 1) {
                int mid = lo + ro >> 1;
                if (mnr.get(i+1, mid) <= ms - sum[i]) ro = mid;
                else lo = mid;
            }
            st = max(st, lo);
            for (int k = max(1, st - 10); k <= n + 1; k++) {
                if (k == n + 1) {
                    ll f = mf + sum[k-1] - sum[i];
                    ll s = ms + sum[k-1] - sum[i];
                    ans = max(ans, f + s);
                    break;
                }
                ll f = mf + sum[k] - sum[i];
                ll s = ms + sum[k] - sum[i];
                if (f > l[k] && s > r[k]) {
                    if (f >= l[k]) {
                        dp[k][0] = max(make_pair(l[k], s), dp[k][0]);
                        if (s >= r[k]) dp[k][1] = max(make_pair(f, r[k]), dp[k][1]);
                    }
                    if (s >= r[k]) {
                        if (f >= l[k]) dp[k][0] = max(make_pair(l[k], s), dp[k][0]);
                        dp[k][1] = max(make_pair(f, r[k]), dp[k][1]);
                    }
                    if (f > l[k] && s > r[k]) break;
                }
                if (point[i][j] != k) continue;
                if (!j && s < r[k]) point[i][j]++;
                else if(j && f < l[k]) point[i][j]++;
            }
        }
    }
    cout << ans << "\n";
}