#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(x) x.begin(), x.end()

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int n;
    cin >> n;
    vector<int> D(n + 1), L(n + 1), R(n + 1);
    int a0, b0;
    for (int i = 1; i <= n; ++i) {
        cin >> D[i];
    }
    
    for (int i = 1; i <= n; ++i) {
        cin >> L[i];
    }
    
    for (int i = 1; i <= n; ++i) {
        cin >> R[i];
    }
    cin >> a0 >> b0;




    const int oo = 2e9;
    
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + D[i + 1];
    }

    ll ans = -oo;
    auto Solve = [&](){
        ll A = a0;
        bool reached_limit = false;
        for (int i = 1; i <= n; ++i) {
            A = A + D[i];
            if (A > L[i]) {
                reached_limit = true;
            }
        }
        if (!reached_limit) {
            ans = max(ans, A + (A - a0 + b0));
            return;
        }
        for (int i = n; i >= 1; --i) {
            bool can = true;
            // touches i-th limit
            for (int j = i + 1; j <= n; ++j) {
                if (pref[j] - pref[i] + L[i] > L[j]) {
                    can = false;
                }
            }
            if (!can) continue;
            // now A is >= L[i]
            ll sm = 0;
            vector<bool> ops(n + 1, 0);
            for (int j = i; j > 0; --j) {
                if (L[i] - sm > L[j]) {
                    ops[j] = 1;
                }
                sm += D[j];
            }

            if (L[i] - sm <= a0) {
                ll A = a0, B = b0;
                for (int i = 1; i <= n; ++i) {
                    A = A + D[i];
                    B = B + D[i];
                    if (ops[i] == 0) A = min(A, (ll)L[i]);
                    else B = min(B, (ll)R[i]);
                }
                ans = max(ans, A + B);
            }
        }
    };
    Solve();
    swap(L, R);
    swap(a0, b0);
    Solve();
    cout << ans;
    return 0;
}