#include <algorithm>
#include <iostream>
#include <vector>

#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> r[i];
    }
    int a0, b0;
    cin >> a0 >> b0;
    if (n <= 15) {
        int ans = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            vector<int> a(n + 1), b(n + 1);
            a[0] = a0;
            b[0] = b0;
            for (int i = 1; i <= n; i++) {
                a[i] = a[i - 1] + d[i - 1];
                b[i] = b[i - 1] + d[i - 1];
                if (mask & (1 << (i - 1))) {
                    a[i] = min(a[i], l[i - 1]);
                } else {
                    b[i] = min(b[i], r[i - 1]);
                }
            }
            ans = max(ans, a[n] + b[n]);
        }
        cout << ans << '\n';
        return 0;
    }
    int ans = 0;
    vector<pair<int, int>> x(n);
    for (int i = 0; i < n; i++) {
        x[i] = make_pair(l[i], -r[i]);
    }
    sort(x.begin(), x.end());
    int minn = 1e10;
    ans = max(ans, b0 + min(a0, x[0].first));
    for (int i = 0; i < n; i++) {
        minn = min(minn, -x[i].second);
        ans = max(ans, min(a0, x[i].first) + min(b0, minn));
    }
    cout << ans << '\n';
    return 0;
}
