#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <stack>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <string>
#include <random>

using namespace std;
typedef long long ll;
const ll inf = 1e18;
vector <ll> d, l, r;
vector <ll> a, b;
ll ans = 0;
ll n;
void rec(ll ind)
{
    if (ind == n)
    {
        ans = max(ans, a.back() + b.back());
        /*cout << ans << endl;
        for (auto i : a) cout << i << " ";
        cout << endl;
        for (auto i : b) cout << i << " ";
        cout << endl;*/
        return;
    }
    ll an = a[ind] + d[ind];
    ll bn = b[ind] + d[ind];
    a.push_back(an);
    b.push_back(min(bn, r[ind]));
    rec(ind + 1);
    a.pop_back();
    b.pop_back();
    a.push_back(min(an, l[ind]));
    b.push_back(bn);
    rec(ind + 1);
    a.pop_back();
    b.pop_back();
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    //vector <ll> l(n), r(n), d(n);
    l.resize(n);
    r.resize(n);
    d.resize(n);
    bool d0 = 1;
    for (ll i = 0; i < n; i++)
    {
        cin >> d[i];
        if (d[i] != 0) d0 = 0;
    }
    for (ll i = 0; i < n; i++) cin >> l[i];
    for (ll i = 0; i < n; i++) cin >> r[i];
    ll a0, b0;
    cin >> a0 >> b0;
    //vector <ll> a, b;
    a.push_back(a0);
    b.push_back(b0);
    
    if (d0)
    {
        vector <ll> ind;
        ll ans = 0;
        for (ll i = 0; i < n; i++)
        {
            ll mina = l[i], minb = b0;
            for (ll j = 0; j < n; j++)
            {
                if (j != i)
                {
                    if (l[j] < mina) minb = min(r[j], minb);
                }
            }
            ans = max(ans, mina + minb);
        }
        ll mina = a0, minb = b0;
        for (ll i = 0; i < n; i++) minb = min(r[i], minb);
        ans = max(ans, mina + minb);
        cout << ans;
        return 0;
    }
    /*
    for (ll i = 0; i < n; i++)
    {
        ll an = a[i] + d[i];
        ll bn = b[i] + d[i];
        if (l[i] >= an || r[i] >= bn)
        {
            a.push_back(an);
            b.push_back(bn);
        }
        
        else
        {
            ll ai = an - l[i];
            ll bi = bn - r[i];
            if (an < bn)
            {
                a.push_back(l[i]);
                b.push_back(bn);
            }
            else
            {
                a.push_back(an);
                b.push_back(r[i]);
            }
        } 
    }
    //for (auto i : a) cout << i << " ";
    //cout << endl;
    //for (auto i : b) cout << i << " ";
    //cout << endl;
    cout << a.back() + b.back();
    */
    rec(0);
    cout << ans;
}

