#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

void solve() {
    ll n;
    cin >> n;
    vector<ll> D(n);
    vector<ll> L(n);
    vector<ll> R(n);
    for (auto &item: D) {
        cin >> item;
    }

    for (auto &item: L) {
        cin >> item;
    }

    for (auto &item: R) {
        cin >> item;
    }

    ll a0, b0;
    cin >> a0 >> b0;
    vector<ll> aVal;
    aVal.push_back(a0);
    set<ll> was;
    for (const auto &item: L) {
        if (item < a0 && was.find(item) == was.end()) {
            aVal.push_back(item);
            was.insert(item);
        }
    }

    sort(aVal.begin(), aVal.end());
    ll M = ll(aVal.size());

    vector<ll> minFrom(M);
    for (ll i = 0; i < n; ++i) {
        ll from = upper_bound(aVal.begin(), aVal.end(), L[i]) - aVal.begin();
        if (from < M) {
            minFrom[from] = R[i];
        }
    }

    ll mn = 1e18;
    ll res = 0;
    for (ll i = 0; i < M; ++i) {
        mn = min(mn, minFrom[i]);
        res = max(res, aVal[i] + mn);
    }

    cout << res << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
