#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using str = string;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	vector <ll> d(n);
	vector <ll> l(n);
	vector <ll> r(n);
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> l[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> r[i];
	}
	ll a0, b0;
	cin >> a0 >> b0;
	vector <ll> dp1a(n + 1);
	vector <ll> dp1b(n + 1);
	vector <ll> dp2a(n + 1);
	vector <ll> dp2b(n + 1);
	dp1a[0] = a0;
	dp1b[0] = b0;
	dp2a[0] = a0;
	dp2b[0] = b0;
	for (int i = 0; i < n; i++) {
		ll a1 = dp1a[i] + d[i];
		ll b1 = dp1b[i] + d[i];
		ll a2 = dp2a[i] + d[i];
		ll b2 = dp2b[i] + d[i];
		if (min(l[i], a1) + b1 > min(l[i], a2) + b2) {
			dp1a[i + 1] = min(l[i], a1);
			dp1b[i + 1] = b1;
		}
		else {
			dp1a[i + 1] = min(l[i], a2);
			dp1b[i + 1] = b2;
		}
		if (min(r[i], b1) + a1 > min(r[i], b2) + a2) {
			dp2b[i + 1] = min(r[i], b1);
			dp2a[i + 1] = a1;
		}
		else {
			dp2b[i + 1] = min(r[i], b2);
			dp2a[i + 1] = a2;
		}
	}
	cout << max(dp1a[n] + dp1b[n], dp2a[n] + dp2b[n]);
}