#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

using int64 = long long;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {
    int n; cin >> n;
    vector <int> d(n), l(n), r(n);
    for (auto& x : d) cin >> x;
    for (auto& x : l) cin >> x;
    for (auto& x : r) cin >> x;
    int a, b; cin >> a >> b;

    vector <int> prs(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        prs[i + 1] = prs[i] + d[i];
    }


    vector <int> dp(n + 1, -1e18);
    dp[0] = b;
    for (int i = 0; i < n; ++i) {
        vector <int> dp1(n + 1, -1e18);
        for (int j = 0; j <= i; ++j) {
            int f = a;
            if (j > 0) f = l[j - 1];
            f += prs[i + 1] - prs[j];

            if (f <= l[i]) {
                dp1[j] = dp[j] + d[i];
            }
            else {
                dp1[j] = min(dp[j] + d[i], r[i]);
            }
        }

        for (int j = 0; j <= i; ++j) {
            int f = a;
            if (j > 0) f = l[j - 1];
            f += prs[i + 1] - prs[j];

            if (f >= l[i]) {
                dp1[i + 1] = max(dp1[i + 1], dp[j] + d[i]);
            }
        }

        dp = dp1;
    }

    int ans = 0;
    for (int j = 0; j <= n; ++j) {
        int f = a;
        if (j > 0) f = l[j - 1];
        f += prs[n] - prs[j];

        ans = max(ans, f + dp[j]);
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }

    return 0;
}
