#include <iostream>
#include <vector>

#pragma target('avx2')

#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<int> D(n), L(n), R(n);
    for (int i = 0; i < n; i++) {
        cin >> D[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> L[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> R[i];
    }
    int a, b;
    cin >> a >> b;
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        int at = a, bt = b;
        for (int i = 0; i < n; i++) {
            at += D[i];
            bt += D[i];
            if (mask & (1 << i)) {
                at = min(at, L[i]);
            }else{
                bt = min(bt, R[i]);
            }
        }
        ans = max(ans, at + bt);
    }
    cout << ans;
}
