#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <cmath>
#include <unordered_map>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <iomanip>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using vi = vector <int>;
using vll = vector <ll>;
using vpii = vector <pii>;
using vvi = vector <vi>;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) (int)_x.size()
#define ff first
#define ss second
#define pb push_back
#define display(_x) for (auto val : _x) cout << val << ' '; cout << '\n';
#define cin_arr(_x) for (auto &val : _x) cin >> val;
#define fast_input ios_base::sync_with_stdio(0); cin.tie(0);

const int INF = 1e9;
const ll INFLL = 1e18;
const int MOD = 1e9 + 7;
const double EPS = 1e-9;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int MAXN = 1e5;
int n;
ll L[MAXN], R[MAXN];
ll D[MAXN];
set <pair <pair <ll, ll>, int>> dp;

void calc(ll a, ll b, int i) {
    if (i == n + 1) {
        return;
    }
    if (dp.count({{a, b}, i}))
        return;
    dp.insert({{a, b}, i});
    calc(a + D[i], min(b + D[i], R[i]), i + 1);
    calc(min(a + D[i], L[i]), b + D[i], i + 1);
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> D[i];
    for (int i = 0; i < n; i++)
        cin >> L[i];
    for (int i = 0; i < n; i++)
        cin >> R[i];
    ll a0, b0;
    cin >> a0 >> b0;
    calc(a0, b0, 0);
    ll max_ans = 0;
    for (auto v : dp) {
        if (v.ss == n) {
            max_ans = max(max_ans, v.ff.ff + v.ff.ss);
        }
    }
    cout << max_ans << '\n';
}

int main() {
    fast_input;
    solve();
}