#ifdef local
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define ve vector
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pb push_back
#define eb emplace_back
#define INF1 INT32_MAX
#define INF2 INT64_MAX
#define sz(a) (int)(a).size()

using namespace std;
using namespace __gnu_pbds;
random_device rd;
mt19937_64 rnd(rd());

template<typename key, typename cmp = less<key>>
using pbds = tree<key, null_type, cmp, rb_tree_tag, tree_order_statistics_node_update>;

const int maxn = (int)1e5+1;

pair<int, int> dp[maxn][2];

void solve() {
    int n; cin >> n;
    ve<int> d(n);
    for (int &i : d) cin >> i;
    ve<int> l(n), r(n);
    for (int &i : l) cin >> i;
    for (int &i : r) cin >> i;

    int a, b; cin >> a >> b;

    dp[0][0] = {a, b};
    dp[0][1] = {a, b};

    for (int i = 1; i <= n; ++i) {
        auto [ap1, bp1] = dp[i - 1][0];
        auto [ap2, bp2] = dp[i - 1][1];
        int val1 = min(ap1 + d[i - 1], l[i - 1]) + bp1 + d[i - 1];
        int val2 = min(ap2 + d[i - 1], l[i - 1]) + bp2 + d[i - 1];

        if (val1 > val2) dp[i][0] = {min(ap1 + d[i - 1], l[i - 1]), bp1 + d[i - 1]};
        else dp[i][0] = {min(ap2 + d[i - 1], l[i - 1]), bp2 + d[i - 1]};

        val1 = min(bp1 + d[i - 1], r[i - 1]) + ap1 + d[i - 1];
        val2 = min(bp2 + d[i - 1], r[i - 1]) + ap2 + d[i - 1];

        if (val1 > val2) dp[i][1] = { ap1 + d[i - 1],  min(bp1 + d[i - 1], r[i - 1])};
        else dp[i][1] = { ap2 + d[i - 1],  min(bp2 + d[i - 1], r[i - 1])};
    }
    cout << max(dp[n][0].first + dp[n][0].second, dp[n][1].first + dp[n][1].second);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--) solve();
}




