#ifdef local
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define ve vector
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pb push_back
#define eb emplace_back
#define INF1 INT32_MAX
#define INF2 INT64_MAX
#define sz(a) (int)(a).size()

using namespace std;
using namespace __gnu_pbds;
random_device rd;
mt19937_64 rnd(rd());

template<typename key, typename cmp = less<key>>
using pbds = tree<key, null_type, cmp, rb_tree_tag, tree_order_statistics_node_update>;

const int maxn = (int)1e5+1;

pair<int, int> dp[maxn][2];

void solve() {
    int n; cin >> n;
    ve<int> d(n);
    for (int &i : d) cin >> i;
    ve<int> l(n), r(n);
    for (int &i : l) cin >> i;
    for (int &i : r) cin >> i;

    int a, b; cin >> a >> b;

    int sum = accumulate(all(d), 0ll), ans = 0;

    int ap = a, bp = b;
    for (int i = 0; i < n; ++i) {
        ap += d[i];
        bp += d[i];
        if (ap > l[i]) bp = min(bp, r[i]);
    }
    ans = ap+bp;

    for (int i = 0; i < n; ++i) {
        sum -= d[i];
        int last = l[i] + sum;
        int cur = 0;
        ve<int> is(n);
        for (int j = n-1; j >= 0; --j) {
            if (l[j] + cur >= last) {
                is[j] = 1;
                last = l[j];
            }
            cur += d[j];
        }
        ap = a, bp = b;
        for (int j = 0; j < n; ++j) {
            ap += d[j];
            bp += d[j];
            if (is[j]) ap = min(ap, l[j]);
            else bp = min(bp, r[j]);
        }
        ans = max(ans, ap+bp);
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--) solve();
}




