#include <bits/stdc++.h>
using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream& cin, ostream& cout);


int test_cnt = 1, group, cur_test;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    // cin >> test_cnt;
    // cin >> group;
    for (cur_test = 0; cur_test < test_cnt; ++cur_test)
        solve(cin, cout);
}


vector<ll> d, l, r;
ll n, a0, b0;
ll res = -INF;


void dfs(const ll i, ll a, ll b) {
    if (i == n) {
        res = max(res, a + b);
        return;
    }
    a += d[i];
    b += d[i];
    dfs(i + 1, min(a, l[i]), b);
    dfs(i + 1, a, min(b, r[i]));
}


ll fn_a() {
    ll a = a0;
    ll b = b0;
    for (ll i = 0; i < n; ++i) {
        a += d[i];
        b += d[i];
        if (b <= r[i])
            b = min(b, r[i]);
        else
            a = min(a, l[i]);
    }
    return a + b;
}


ll fn_b() {
    ll a = a0;
    ll b = b0;
    for (ll i = 0; i < n; ++i) {
        a += d[i];
        b += d[i];
        if (a <= l[i])
            a = min(a, l[i]);
        else
            b = min(b, r[i]);
    }
    return a + b;
}


ll fn_dp() {
    vector<pair<ll, ll>> dp[2];
    dp[0].resize(n);
    dp[1].resize(n);
    dp[0][0] = make_pair(min(l[0], a0 + d[0]), b0 + d[0]);
    dp[0][1] = make_pair(a0 + d[0], min(r[0], b0 + d[0]));

    auto cmp = [](pair<ll, ll> a, pair<ll, ll> b) { return (a.first + a.second >= b.first + b.second) ? a : b; };
    auto fn = [](pair<ll, ll> a, ll d) { return make_pair(a.first + d, a.second + d); };
    auto ogr = [](pair<ll, ll> a, ll r) { return make_pair(a.first, min(a.second, r)); };
    auto ogl = [](pair<ll, ll> a, ll l) { return make_pair(min(l, a.first), a.second); };

    for (ll i = 1; i < n; ++i) {
        dp[0][i] = cmp(ogl(fn(dp[0][i - 1], d[i]), l[i]), ogl(fn(dp[1][i - 1], d[i]), l[i]));
        dp[1][i] = cmp(ogr(fn(dp[0][i - 1], d[i]), r[i]), ogr(fn(dp[1][i - 1], d[i]), r[i]));
    }

    auto [a1, b1] = dp[0].back();
    auto [a2, b2] = dp[1].back();
    return max(a1 + b1, a2 + b2);
}


void solve(istream& cin, ostream& cout) {
    cin >> n;
    d.resize(n);
    l.resize(n);
    r.resize(n);
    for (auto& t : d)
        cin >> t;
    for (auto& t : l)
        cin >> t;
    for (auto& t : r)
        cin >> t;
    cin >> a0 >> b0;

    res = max(fn_a(), fn_b());
    res = max(res, fn_dp());
    cout << res << '\n';
}
