#include <bits/stdc++.h>

#define ll long long
#define all(x) x.begin(), x.end()
#define fi first
#define se second
#define ve vector

using namespace std;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int MAXN = 256, MAXW = 512, MAXN2 = 2048, MAXW2 = 3;

#pragma GCC optimize("Ofast")

ll solve(ll a, ll b, ve<ll>& d, ve<ll>& l, ve<ll>& r){
    int n = d.size();
    ve<bool> ok(n);
    ok[n - 1] = 1;
    ll cur = r.back();
    for(int i = n - 1; i >= 0; i--){
        cur -= d[i];
        if(cur <= r[i])
            ok[i] = 1;
    }
    for(int i = 0; i < n; i++){
        a += d[i];
        b += d[i];
        if(ok[i])
            b = min(b, r[i]);
        else a = min(a, l[i]);
    }
    return a + b;
}

int main() {
    int n;
    cin >> n;
    ve<ll> d(n);
    for(auto& i : d)
        cin >> i;
    ve<ll> l(n), r(n);
    for(auto& i : l)
        cin >> i;
    for(auto& i : r)
        cin >> i;
    ll a, b;
    cin >> a >> b;
    cout << max(solve(a, b, d, l, r), solve(b, a, d, r, l));
}
