#include<iostream>
#include<vector>
#include<string>
#include<map>
#include<set>
#include<deque>
#include<stack>
#include<queue>
#include<bitset>
#include<iomanip>
#include<cmath>
#include<algorithm>
using namespace std;

const int INF = 1e9;

struct DP {
	int a, b;

	DP operator+(const int& x) const {
		return { a + x, b + x };
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	//КЛОУНАДА



	int n, a0, b0;
	cin >> n;

	vector<int> d(n), l(n), r(n);

	for (int i = 0; i < n; ++i) {
		cin >> d[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> r[i];
	}
	cin >> a0 >> b0;

	vector<vector<DP>> dp(n + 1, vector<DP>(2));
	dp[0] = { {a0, b0}, {a0, b0} };
	for (int len = 1; len <= n; ++len) {
		DP x = dp[len - 1][0] + d[len - 1], y = dp[len - 1][1] + d[len - 1];
		if (x.b + min(x.a, l[len - 1]) > y.b + min(y.a, l[len - 1])) {
			dp[len][0] = { min(x.a, l[len - 1]), x.b };
		}
		else {
			dp[len][0] = { min(y.a, l[len - 1]), y.b };
		}
		if (x.a + min(x.b, r[len - 1]) > y.a + min(y.b, r[len - 1])) {
			dp[len][1] = { x.a, min(x.b, r[len - 1]) };
		}
		else {
			dp[len][1] = { y.a, min(y.b, r[len - 1]) };
		}
	}

	cout << max(dp[n][0].a + dp[n][0].b, dp[n][1].a + dp[n][1].b);

	return 0;
}