#include <bits/stdc++.h>
#define int long long

/* Using libraries */
using namespace std;

using ld = long double;
template <class T>
using vc = vector <T>;
using pii = pair <int, int>;
using pint = pair <int, int>;
template <class T>
int sz(vc <T> &a) {
    return (int)a.size();
}
int sz(string &a) {
    return (int)a.size();
}

template<class T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9;
template<class T>
bool chmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

struct node {
    int suf = 0, pref = 0;
    int f = 1, sum = 0, len = 0;
    node () {}
};
int d;

node merge (node a, node b) {
    node c;
    c.sum = a.sum + b.sum;
    c.len = a.len + b.len;
    c.f = a.f && b.f;
    if (c.sum == 0) {
        c.pref = c.suf = c.len;
        return c;
    }
    if (a.sum == 0) {
        c.pref = b.pref + a.len;
        c.suf = b.suf;
        return c;
    }
    if (b.sum == 0) {
        c.pref = a.pref;
        c.suf = a.suf + b.len;
        return c;
    }
    c.pref = a.pref;
    c.suf = b.suf;
    if (a.suf + b.pref + 1 > d)
        c.f = 0;
    return c;
}

const int N = 3e5;
int t[N * 4];

void upd (int v, int tl, int tr, int i, int x) {
    if (tr - tl == 1) {
        t[v] = x;
    } else {
        int tm = (tl + tr) / 2;
        if (i < tm)
            upd(v << 1, tl, tm, i, x);
        else
            upd(v << 1 | 1, tm, tr, i, x);
        t[v] = max(t[v << 1], t[v << 1 | 1]);
    }
}

int get (int v, int tl, int tr, int l, int r) {
    if (tr <= l || r <= tl) return 0;
    if (l <= tl && tr <= r) return t[v];
    int tm = (tl + tr) / 2;
    return max(get(v << 1, tl, tm, l, r), get(v << 1 | 1, tm, tr, l, r));
}

void solve() {
    int n;
    cin >> n;
    vc <int> d(n), l(n), r(n), p(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
        p[i + 1] = p[i] + d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    int a0, b0;
    cin >> a0 >> b0;
    if (p[n] == 0) {
        for (int i = 0; i < n; ++i)
            chmin(l[i], a0);
        for (int i = 0; i < n; ++i) {
            chmin(r[i], b0);
        }
        int ans = 0;
        multiset <int> bb;
        for (int i = 0; i <= n; ++i) {
            int a = (i == 0 ? a0 : l[i - 1]);
            bb.insert(a);
        }
        map <int, vc <int>> chk;
        for (int i = 0; i <= n; ++i) {
            int b = (i == 0 ? b0 : r[i - 1]);
            chk[b].push_back(i);
        }
        for (auto [b, v] : chk) {
            if (bb.empty())
                break;
            chmax(ans, *bb.rbegin() + b);
            for (int i : v) {
                if (i != 0) {
                    while (!bb.empty() && *bb.rbegin() > l[i - 1]) {
                        bb.erase(*bb.rbegin());
                    }
                }
            }
        }
        cout << ans << '\n';
        return;
    }
    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            int a = (i == 0 ? a0 : min(a0 + p[i], l[i - 1]));
            int b = (j == 0 ? b0 : min(b0 + p[j], r[j - 1]));
            int bad = 0;
            for (int k = 0; k < n; ++k) {
                int f1 = 0, f2 = 0;
                f1 = l[k] - p[k + 1] >= a - p[i];
                f2 = r[k] - p[k + 1] >= b - p[j];
                if (!f1 && !f2) {
                    bad = 1;
                    break;
                }
            }
            if (!bad) {
                chmax(ans, a + p[n] - p[i] + b + p[n] - p[j]);
            }
        }
    }
    cout << ans << '\n';
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}