#include <iostream>
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
*/
#include <bits/stdc++.h>
using namespace std;

/*
#include <bits/extc++.h>
using namespace __gnu_pbds;
typedef tree<
        int,
        null_type,
        less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
 */

#define int long long
#define ll long long
#define fi first
#define se second
#define eb emplace_back
#define lwb lower_bound
#define upb upper_bound
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define ld long double
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
const int INF = 1e18, N = 300300, K = 26, C = 700, P = 1e9 + 7;
const ld EPS = 1e-5, pi = 3.1415926535;

int f(int n, vector<bool> &sus, int x, int y, vector<int> &l, vector<int> &r, vector<int> &d) {
    for (int i = 1; i <= n; i++) {
        x += d[i];
        y += d[i];
        if (!sus[i])
            x = min(x, l[i]);
        else
            y = min(y, r[i]);
    }
    return x + y;
}

void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1), l(n + 1), r(n + 1), a(n + 1), b(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> r[i];
    }
    cin >> a[0] >> b[0];
    l[0] = a[0];
    r[0] = b[0];
    int ans = 0;
    vector<int> dp(n + 1, -INF);
    dp[0] = b[0];
    vector<int> pref(n + 1);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + d[i];
    }
    for (int i = 0; i <= n; i++) {
        int maxi = -INF;
        for (int j = 0; j < i; j++) {
            if (dp[j] == -INF)
                continue;
            if (l[j] + pref[i] - pref[j] < l[i])
                continue;
            dp[j] += d[i];
            maxi = max(maxi, dp[j]);
            if (pref[i] - pref[j] + l[j] < l[i])
                dp[j] = min(dp[j], r[i]);
            dp[i] = max(dp[i], dp[j]);
        }
        int x = l[i], y = maxi;
        for (int j = i + 1; j <= n; j++) {
            x += d[j];
            y += d[j];
            if (x <= l[j])
                continue;
            y = min(y, r[j]);
        }
        ans = max(ans, x + y);
    }
    int x = a[0], y = b[0];
    for (int i = 1; i <= n; i++) {
        x += d[i];
        y += d[i];
        if (x <= l[i])
            continue;
        y = min(y, r[i]);
    }
    x = a[0], y = b[0];
    ans = max(ans, x + y);
    for (int i = 1; i <= n; i++) {
        x += d[i];
        y += d[i];
        if (y <= r[i])
            continue;
        x = min(x, l[i]);
    }
    ans = max(ans, x + y);
    cout << ans << endl;
}

signed main() {
    //cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    //cin >> T;
    while (T--)
        solve();
    return 0;
}