#include <iostream>
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
*/
#include <bits/stdc++.h>
using namespace std;

/*
#include <bits/extc++.h>
using namespace __gnu_pbds;
typedef tree<
        int,
        null_type,
        less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
 */

#define int long long
#define ll long long
#define fi first
#define se second
#define eb emplace_back
#define lwb lower_bound
#define upb upper_bound
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define ld long double
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
const int INF = 1e18, N = 300300, K = 26, C = 700, P = 1e9 + 7;
const ld EPS = 1e-5, pi = 3.1415926535;

int f(int n, vector<bool> &sus, int x, int y, vector<int> &l, vector<int> &r, vector<int> &d) {
    for (int i = 1; i <= n; i++) {
        x += d[i];
        y += d[i];
        if (!sus[i])
            x = min(x, l[i]);
        else
            y = min(y, r[i]);
    }
    return x + y;
}

void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1), l(n + 1), r(n + 1), a(n + 1), b(n + 1);
    int fin = 0;
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
        fin += d[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> r[i];
    }
    cin >> a[0] >> b[0];
    l[0] = a[0];
    r[0] = b[0];
    vector<bool> sost(n + 1);
    int ans = f(n, sost, a[0], b[0], l, r, d);
    sost.assign(n + 1, true);
    ans = max(ans, f(n, sost, a[0], b[0], l, r, d));
    if (fin == 0) {
        vector<pair<int, int>> t(n);
        for (int i = 1; i <= n; i++) {
            t[i - 1] = {l[i], i};
        }
        sort(all(t));
        int mini = INF;
        for (int i = 1; i <= n; i++) {
            mini = min(mini, r[t[i - 1].se]);
            ans = max(ans, min(a[0], t[i - 1].fi) + min(b[0], mini));
        }
        cout << ans << endl;
        return;
    }
    vector<int> dp(n + 1, -INF);
    dp[0] = b[0];
    vector<pair<int, int>> mem(n + 1);
    mem[0] = {a[0], b[0]};
    for (int i = 1; i <= n; i++) {
        int sum = d[i];
        for (int j = i - 1; j >= 0; j--) {
            if (dp[j] != -INF && l[j] + sum >= l[i]) {
                int x = mem[j].se;
                dp[i] = max(dp[i], x + d[i]);
            }
            sum += d[j];
        }
        mem[i] = {l[i], dp[i]};
        for (int j = 0; j < i; j++) {
            mem[j].fi += d[i];
            mem[j].se += d[i];
            if (mem[j].fi <= l[i])
                continue;
            mem[j].se = min(mem[j].se, r[i]);
        }
    }
    int sum = 0;
    for (int i = n; i >= 0; i--) {
        int alt = l[i] + sum, x = dp[i], y = l[i];
        for (int j = i + 1; j <= n; j++) {
            x += d[j];
            y += d[j];
            if (y <= l[j])
                continue;
            x = min(x, r[j]);
        }
        alt += x;
        ans = max(ans, alt);
        sum += d[i];
    }
    cout << ans << endl;
}

signed main() {
    //cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    //cin >> T;
    while (T--)
        solve();
    return 0;
}