//#pragma target("Ofast, unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

using namespace std;

#define debug(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()

void solve() {
    int n;
    cin >> n;
    vector<int> D(n + 1), L(n + 1), R(n + 1);
    int a0, b0;
    for (int i = 1; i <= n; ++i) {
        cin >> D[i];
    }
    vector<int> PD(n + 1);
    for (int i = 1; i <= n; ++i) {
        PD[i] = PD[i - 1] + D[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> L[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> R[i];
    }
    cin >> a0 >> b0;
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int ata = a0, atb = b0;
        for (int i = 1; i <= n; ++i) {
            ata += D[i];
            atb += D[i];
            if (mask & (1 << (i - 1))) {
                ata = min(ata, L[i]);
            } else {
                atb = min(atb, R[i]);
            }
        }
        ans = max(ans, ata + atb);
    }
    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
