#include <algorithm>
#include <iostream>
#include <vector>

int main() {
    int n;
    std::cin >> n;
    std::vector<long long> d(n + 1);
    std::vector<long long> l(n + 1);
    std::vector<long long> r(n + 1);
    std::vector<long long> a(n + 1);
    std::vector<long long> b(n + 1);
    for (int i = 0; i < n; i++) {
        std::cin >> d[i + 1];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> l[i + 1];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> r[i + 1];
    }
    std::vector<std::vector<std::pair<long long, long long>>> dp(n + 1, std::vector<std::pair<long long, long long>>(n + 1));
    std::cin >> dp[0][0].first >> dp[0][0].second;

    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= i; j++) {
            auto [pra, prb] = dp[i - 1][j];
            pra += d[i];
            prb += d[i];
            dp[i][j].first = pra;
            dp[i][j].second = std::min(prb, r[i]);
            if (j != 0) {
                auto [pra2, prb2] = dp[i - 1][j - 1];
                pra2 += d[i];
                prb2 += d[i];
                pra2 = std::min(pra2, l[i]);
                if (pra2 + prb2 > dp[i][j].first + dp[i][j].second) {
                    dp[i][j] = {pra2, prb2};
                }
            }
        }
    }
    long long maxres = 0;
    for (int i = 0; i <= n; i++) {
        maxres = std::max(maxres, dp[n][i].first + dp[n][i].second);
    }
    std::cout << maxres << '\n';
    return 0;
}