#include <algorithm>
#include <iostream>
#include <vector>

int main() {
    int n;
    std::cin >> n;
    std::vector<long long> d(n + 1);
    std::vector<long long> l(n + 1);
    std::vector<long long> r(n + 1);
    bool d0 = true;
    for (int i = 0; i < n; i++) {
        std::cin >> d[i + 1];
        if (d[i + 1] != 0) {
            d0 = false;
        }
    }
    if (!d0) {
        return 1;
    }
    for (int i = 0; i < n; i++) {
        std::cin >> l[i + 1];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> r[i + 1];
    }
    std::cin >> l[0] >> r[0];
    std::vector<std::pair<long long, int>> possl(n + 1);
    for (int i = 0; i <= n; i++) {
        possl[i].first = l[i];
        possl[i].second = i;
    }
    std::sort(possl.begin(), possl.end());
    long long minr = r[0];
    long long maxres = 0;
    for (int i = 0; i <= n; i++) {
        maxres = std::max(maxres, minr + std::min(l[0], possl[i].first));
        minr = std::min(minr, r[possl[i].second]);
    }
    std::cout << maxres << '\n';
    return 0;
}