#include <bits/stdc++.h>

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    std::cin >> n;
    std::vector<int64_t> D(n), L(n), R(n);
    for (auto& ptr : std::array{&D, &L, &R}) {
        for (auto& i : *ptr) {
            std::cin >> i;
        }
    }
    int64_t a0, b0;
    std::cin >> a0 >> b0;

    int64_t d = 0;
    for (int i = n - 1; i >= 0; i--) {
        L[i] += d;
        R[i] += d;
        d += D[i];
    }
    a0 += d;
    b0 += d;

    std::vector<int> p(n);
    std::iota(p.begin(), p.end(), 0);
    std::sort(p.begin(), p.end(), [&](int a, int b) { return L[a] < L[b]; });
    int64_t ans = -1e18;

    for (int i = 0; i <= n; i++) {
        ans = std::max(ans, (i == n ? a0 : std::min(a0, L[p[i]])) + b0);
        if (i != n) {
            b0 = std::min(b0, R[p[i]]);
        }
    }

    std::cout << ans << "\n";

    return 0;
}
