#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl '\n'

typedef long long ll;
typedef long double ld;

typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 2e15 + 1;
const int MOD = 1e9 + 7;

mt19937 rnd(time(0));

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int n;
vector <int> t1, t2;
int R = 1;

void build(vector <int> &t){
    for (int i = R - 1; i > 0; i--){
        t[i] = min(t[i * 2], t[i * 2 + 1]);
    }
}

int get(int ql, int qr, int nl, int nr, int node, vector <int> &t){
    if (ql >= nr || nl >= qr)
        return INF;
    if (nl >= ql && nr <= qr)
        return t[node];
    int nm = (nl + nr) / 2;
    return min(get(ql, qr, nl, nm, node * 2, t), get(ql, qr, nm, nr, node * 2 + 1, t));
}

void height(int n){
    while (R < n)
        R *= 2;
}

signed main() {
    Fast();
    int n;
    cin >> n;
    vector <int> d(n + 1);
    vector <int> l(n + 1), r(n + 1);
    int a, b;
    for (int i = 1; i <= n; i++)
        cin >> d[i];
    for (int i = 1; i <= n; i++)
        cin >> l[i];
    for (int i = 1; i <= n; i++)
        cin >> r[i];
    cin >> a >> b;
    l[0] = a, r[0] = b;
    height(n + 1);
    t1.resize(2 * R, INF);
    t2.resize(2 * R, INF);
    for (int i = 1; i <= n; i++){
        d[i] += d[i - 1];
        t1[i + R] = l[i] - d[i];
        t2[i + R] = r[i] - d[i];
    }
    build(t1);
    build(t2);
    vector <pair <int, int>> dp(n + 1, {-INF, -INF});
    dp[0] = {b, a};
    int sum = 0;
//    for (int i = 1; i <= n; i++)
//        cout << t1[i + R] << " ";
//    cout << endl;
//    for (int i = 1; i <= n; i++)
//        cout << t2[i + R] << " ";
//    cout << endl;
//    for (int i = 1; i <= n; i++)
//        cout << d[i] << " ";
//    cout << endl;
    for (int i = 0; i <= n; i++){
        int a = l[i], b = dp[i].first;
//        cout << i << endl;
        if (b != -INF){
            a -= d[i];
            b -= d[i];
            int l1 = i, r1 = n + 1;
            while (r1 - l1 > 1){
                int mid = (l1 + r1) / 2;
                int g = get(i + 1, mid + 1, 0, R, 1, t1);
                int g1 = get(i + 1, mid + 1, 0, R, 1, t2);
                if (g >= a || g1 >= b)
                    l1 = mid;
                else
                    r1 = mid;
            }
//            if (l1 == 4)
////                cout << 1 << " " << a + d[i] << " " << b + d[i] << " " << l1 << endl;
////            cout << l1 << endl;
            if (l1 + 1 <= n){
                dp[l1 + 1].first = max(dp[l1 + 1].first, b + d[l1 + 1]);
                dp[l1 + 1].second = max(dp[l1 + 1].second, a + d[l1 + 1]);
            }
            if (l1 == n)
                sum = max(sum, a + b + 2 * d[n]);
        }
        a = dp[i].second, b = r[i];
        if (a != -INF){
            a -= d[i];
            b -= d[i];
            int l1 = i, r1 = n + 1;
            while (r1 - l1 > 1){
                int mid = (l1 + r1) / 2;
                int g = get(i + 1, mid + 1, 0, R, 1, t1);
                int g1 = get(i + 1, mid + 1, 0, R, 1, t2);
                if (g >= a || g1 >= b)
                    l1 = mid;
                else
                    r1 = mid;
            }
//            if (l1 == 4)
//                cout << 2 << " " << a + d[i] << " " << b + d[i] << " " << l1 << endl;
            if (l1 + 1 <= n){
                dp[l1 + 1].first = max(dp[l1 + 1].first, b + d[l1 + 1]);
                dp[l1 + 1].second = max(dp[l1 + 1].second, a + d[l1 + 1]);
            }
            if (l1 == n)
                sum = max(sum, a + b + 2 * d[n]);
        }
    }
//    for (auto i:dp)
//        cout << i.first << " " << i.second << endl;
//    cout << endl;
    cout << max({sum, l[n] + dp[n].first, r[n] + dp[n].second});
    return 0;
}
