#include <bits/stdc++.h>

using namespace std;

const long long INF = 1e18;

inline void solve() {
    int n;
    cin >> n;
    vector<long long> d(n);
    for (auto& i : d)
        cin >> i;
    for (int i = 1; i < n; ++i)
        d[i] += d[i - 1];
    vector<long long> l(n);
    for (auto& i : l)
        cin >> i;
    vector<long long> r(n);
    for (auto& i : r)
        cin >> i;
    long long a0, b0;
    cin >> a0 >> b0;
    vector<pair<long long, long long>> segs;
    for (int i = 0; i < n; ++i)
        segs.emplace_back(l[i] - d[i], r[i] - d[i]);
    segs.emplace_back(INF, INF);
    sort(segs.begin(), segs.end());
    long long ans = -INF;
    long long mi = INF;
    for (auto i : segs) {
        ans = max(ans, min(a0, i.first) + min(b0, mi));
        mi = min(mi, i.second);
    }
    cout << ans + d[n - 1] * 2;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test)
        solve();
    return 0;
}
