#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct str {
    ll d, l, r;
};

bool cmp(const str& a, const str& b){
    return a.l < b.l;
}

void solve(){
    ll n;
    cin >> n;
    vector<str> a(n);
    for(ll i = 0; i < n; i++){
        cin >> a[i].d;
    }
    for(ll i = 0; i < n; i++){
        cin >> a[i].l;
    }
    for(ll i = 0; i < n; i++){
        cin >> a[i].r;
    }
    ll c, d;
    cin >> c >> d;
    if(n <= 15){
        ll ans = 0;
        for(ll mask = 0; mask < (1 << n); mask++){
            ll curc = c, curd = d;
            for(ll i = 0; i < n; i++){
                curc += a[i].d, curd += a[i].d;
                if((mask >> i) & 1){
                   curc = min(curc, a[i].l);
                } else {
                    curd = min(curd, a[i].r);
                }
            }
            ans = max(ans, curc + curd);
        }
        cout << ans;
    } else {
        sort(a.begin(), a.end(), cmp);
        vector<ll> pref(n);
        pref[0] = a[0].r;
        for(ll i = 1; i < n; i++){
            pref[i] = min(pref[i - 1], a[i].r);
        }
        ll ans = c + d;
        for(ll i = 1; i < n; i++){
            ll cc = min(c, a[i].l);
            ll dd = min(d, pref[i - 1]);
            ans = max(ans, cc + dd);
        }
        ans = max(ans, min(c, a[0].l) + d);
        cout << ans;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    while(t--){
        solve();
    }
}
