#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using lll = __int128;
using ld = long double;
using vp = vector<pi>;
using vpl = vector<pl>;

void solve() {
    int n; cin >> n;
    vl di(n), li(n), ri(n);
    ll a0, b0;
    for (auto &i : di) cin >> i;
    for (auto &i : li) cin >> i;
    for (auto &i : ri) cin >> i;
    cin >> a0 >> b0;

    set<pl, greater<>> maybe, next, good;
    maybe.emplace(a0, b0);
    for (int i = 0; i < n; i++) {
        next.clear();
        for (auto[ai, bi] : maybe) {
            ai += di[i];
            bi += di[i];
            next.emplace(ai, min(bi, ri[i]));
            next.emplace(min(ai, li[i]), bi);
        }
        good.clear();
        ll best = -1;
        for (const pl &p : next) {
            if (p.second < best) continue;
            best = p.second;
            good.insert(p);
        }
        swap(maybe, good);
    }
    ll mx = 0;
    for (auto[a, b] : maybe)
        mx = max(mx, a + b);
    cout << mx;
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);
    solve();
}
