// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long ll;
typedef long double ld;

const long long INF = 1e18;
const int inf = 2e9;
const int MOD = 1e9 + 7;

struct cmpa {
    bool operator()(const pair<int, int> a, const pair<int, int> b) const {
        return a.first < b.first || a.first == b.first && a.second < b.second;
    }
};

struct cmpb {
    bool operator()(const pair<int, int> a, const pair<int, int> b) const {
        return a.second < b.second || a.second == b.second && a.first < b.first;
    }
};

struct cmpall {
    bool operator()(const pair<int, int> a, const pair<int, int> b) const {
        return a.first + a.second < b.first + b.second || a.first + a.second == b.first + b.second && (a.second < b.second || a.second == b.second && a.first < b.first);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> D(n), L(n), R(n);
    for (int& e : D) cin >> e;
    for (int& e : L) cin >> e;
    for (int& e : R) cin >> e;
    vector<tuple<pair<int, int>, pair<int, int>, pair<int, int>>> dp(n + 1);
    for (int i = 0; i <= n; ++i) {
        auto& [mxa, mxb, mxall] = dp[i];
        if (i == 0) {
            cin >> mxa.first >> mxa.second;
            mxb = mxa;
            mxall = mxa;
            continue;
        }
        auto [mxaprev, mxbprev, mxallprev] = dp[i - 1];
        mxaprev.first += D[i - 1];
        mxaprev.second += D[i - 1];
        mxbprev.first += D[i - 1];
        mxbprev.second += D[i - 1];
        mxallprev.first += D[i - 1];
        mxallprev.second += D[i - 1];
        mxa = { min(L[i - 1], mxallprev.first), mxallprev.second };
        mxa = max(mxa, { min(L[i - 1], mxaprev.first), mxaprev.second }, cmpa());
        mxa = max(mxa, { min(L[i - 1], mxbprev.first), mxbprev.second }, cmpa());
        mxa = max(mxa, { mxallprev.first, min(R[i - 1], mxallprev.second) }, cmpa());
        mxa = max(mxa, { mxaprev.first, min(R[i - 1], mxaprev.second) }, cmpa());
        mxa = max(mxa, { mxbprev.first, min(R[i - 1], mxbprev.second) }, cmpa());

        mxb = { min(L[i - 1], mxallprev.first), mxallprev.second };
        mxb = max(mxb, { min(L[i - 1], mxaprev.first), mxaprev.second }, cmpb());
        mxb = max(mxb, { min(L[i - 1], mxbprev.first), mxbprev.second }, cmpb());
        mxb = max(mxb, { mxallprev.first, min(R[i - 1], mxallprev.second) }, cmpb());
        mxb = max(mxb, { mxaprev.first, min(R[i - 1], mxaprev.second) }, cmpb());
        mxb = max(mxb, { mxbprev.first, min(R[i - 1], mxbprev.second) }, cmpb());

        mxall = { min(L[i - 1], mxallprev.first), mxallprev.second };
        mxall = max(mxall, { min(L[i - 1], mxaprev.first), mxaprev.second }, cmpall());
        mxall = max(mxall, { min(L[i - 1], mxbprev.first), mxbprev.second }, cmpall());
        mxall = max(mxall, { mxallprev.first, min(R[i - 1], mxallprev.second) }, cmpall());
        mxall = max(mxall, { mxaprev.first, min(R[i - 1], mxaprev.second) }, cmpall());
        mxall = max(mxall, { mxbprev.first, min(R[i - 1], mxbprev.second) }, cmpall());
    }
    auto [mxa, mxb, mxall] = dp[n];
    cout << mxall.first + mxall.second << '\n';
}

signed main() {
#ifdef erytw
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
