// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long ll;
typedef long double ld;

const long long INF = 1e18;
const int inf = 2e9;
const int MOD = 1e9 + 7;

void solve() {
    int n;
    int n;
    cin >> n;
    vector<int> D(n), L(n), R(n);
    for (int& e : D) cin >> e;
    for (int& e : L) cin >> e;
    for (int& e : R) cin >> e;
    vector<int> a(n + 1), b(n + 1);
    cin >> a[0] >> b[0];
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        for (int i = 0; i < n; ++i) {
            a[i + 1] = a[i] + D[i];
            b[i + 1] = b[i] + D[i];
            if ((mask >> i) & 1) {
                a[i + 1] = min(a[i + 1], L[i]);
            } else {
                b[i + 1] = min(b[i + 1], R[i]);
            }
        }
        ans = max(ans, a[n] + b[n]);
    }
    cout << ans << '\n';
}

signed main() {
#ifdef erytw
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
