#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const int MAX = 1e5 + 7;
const int mod = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<ll> d(n + 1), l(n + 1), r(n + 1);
    vector<ll> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) cin >> d[i], pref[i] = pref[i - 1] + d[i];
    for (int i = 1; i <= n; i++) cin >> l[i];
    for (int i = 1; i <= n; i++) cin >> r[i];
    cin >> l[0] >> r[0];
    set<pair<int, int>> was;
    ll res = 0;
    set<pair<int, int>> st;
    st.insert({0, 0});
    while ((int)(st.size())) {
        auto [i, j] = *st.begin();
        st.erase(st.begin());
        if (was.find({i, j}) != was.end()) continue;
        was.insert({i, j});
        int mx = max(i, j);
        ll A = l[i], B = r[j];
        if (i + 1 <= mx) A += pref[mx] - pref[i];
        if (j + 1 <= mx) B += pref[mx] - pref[j];
        if (mx == n) res = max(res, A + B);
        for (int o = mx + 1; o <= n; o++) {
            A += d[o];
            B += d[o];
            if (A > l[o] && B > r[o]) {
                st.insert({o, j});
                st.insert({i, o});
                break;
            }
            if (o == n) {
                res = max(res, A + B);
            }
        }
    }
    cout << res;
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}