#include <bits/stdc++.h>
#include <bits/extc++.h>
//#pragma GCC optimize("03")
//#pragma GCC target("avx2")
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define sz(v) (int)(v).size()
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld  = long double;
mt19937 Rand(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());
const int inf = 1e9;
const ll INF = 1e18;

struct Node {
    int l, r, mn;
    Node() {
        l = r = -1;
        mn = inf;
    }
};

const int N = 1e5 + 1, A = 1e9;
ll n, d[N], l[N], r[N];
ll a0, b0;

vector <Node> t(2);

void upd(int v, int tl, int tr, int p, int x) {
    if (tl == tr) {
        t[v].mn = x;
        return;
    }
    int tm = (tl + tr) / 2;
    if (p <= tm) {
        if (t[v].l == -1) {
            t[v].l = sz(t);
            t.emplace_back();
        }
        upd(t[v].l, tl, tm, p, x);
    } else {
        if (t[v].r == -1) {
            t[v].r = sz(t);
            t.emplace_back();
        }
        upd(t[v].r, tm + 1, tr, p, x);
    }
    if (t[v].l == -1) {
        t[v].mn = t[t[v].r].mn;
    } else if (t[v].r == -1) {
        t[v].mn = t[t[v].l].mn;
    } else {
        t[v].mn = min(t[t[v].l].mn, t[t[v].r].mn);
    }
}

int get(int v, int tl, int tr, int ql, int qr) {
    if (qr < tl || tr < ql) {
        return inf;
    }
    if (ql <= tl && tr <= qr) {
        return t[v].mn;
    }
    int tm = (tl + tr) / 2, r1 = inf, r2 = inf;
    if (ql <= tm) {
        if (t[v].l == -1) {
            t[v].l = sz(t);
            t.emplace_back();
        }
        r1 = get(t[v].l, tl, tm, ql, qr);
    }
    if (qr > tm) {
        if (t[v].r == -1) {
            t[v].r = sz(t);
            t.emplace_back();
        }
        r2 = get(t[v].r, tm + 1, tr, ql, qr);
    }
    return min(r1, r2);
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    cin >> a0 >> b0;
    if (n <= 15) {
        ll mx = 0;
        for (int i = 0; i < (1 << n); ++i) {
            ll a = a0, b = b0;
            for (int j = 0; j < n; ++j) {
                a += d[j + 1], b += d[j + 1];
                if ((i >> j) & 1) {
                    a = min(a, l[j + 1]);
                } else {
                    b = min(b, r[j + 1]);
                }
            }
            mx = max(mx, a + b);
        }
        cout << mx;
    } else {
        t.reserve(100000);
        for (int i = 1; i <= n; ++i) {
            upd(1, 0, A, l[i], r[i]);
        }
        ll mx = 0;
        for (int i = 1; i <= n; ++i) {
            ll an = min(a0, l[i]);
            ll bn = min(b0, (ll)get(1, 0, A, 0, l[i] - 1));
            mx = max(mx, an + bn);
        }
        cout << mx;
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    freopen("input.txt", "r", stdin);
    int tt = 1;
    while (tt--) {
        solve();
    }
}
