#include <bits/stdc++.h>

using namespace std;

using ll = long long;

ll n;
vector<ll> l, r, d;
ll a0, b0;

ll ans0, ansmask;

void spd0() {
    ll ans = 0;

    vector<pair<ll, ll>> vals;
    for (ll i = 0; i < n; ++i) {
        vals.emplace_back(l[i], r[i]);
    }
    vector<ll> prefMin(n);
    prefMin[0] = vals[0].second;
    for (ll i = 1; i < n; ++i) {
        prefMin[i] = min(prefMin[i - 1], vals[i].second);
    }

    sort(vals.begin(), vals.end());
    for (ll i = 0; i <= n; ++i) {
        ll val = min(a0, i == n ? LLONG_MAX : l[i]);
        ll b = b0;
        
        ll k = lower_bound(vals.begin(), vals.end(), make_pair(val, LLONG_MIN)) - vals.begin();

        // if (k > 0) {
        //     b = min(b, prefMin[k - 1]);
        // }

        if (k > 0) {
            for (ll j = 0; j < k; ++j) {
                b = min(b, vals[j].second);
            }
        }

        ll a = a0;
        if (i != n) {
            a = min(a0, l[i]);
        }
        ans = max(ans, a + b);
    }
    // cout << ans << endl;

    ans0 = ans;
}

void masksol() {
    ll ans = 0;
    ll bestmask = 0;
    for (ll mask = 0; mask < 1 << n; ++mask) {
        ll a = a0, b = b0;
        for (ll i = 0; i < n; ++i) {
            a += d[i];
            b += d[i];
            if ((mask >> i) & 1) {
                a = min(a, l[i]);
            } else {
                b = min(b, r[i]);
            }
            // if (mask == 0) {
            //     cout << "ab " << a << ' ' << b << endl;
            // }
        }
        if (a + b > ans) {
            ans = a + b;
            bestmask = mask;
        }
    }
    // cout << ans << endl;
    ansmask = ans;
}

void stress() {
    for (;;) {
        n = 1;
        d.resize(n);
        l.resize(n);
        r.resize(n);
        a0 = 5;
        b0 = 5;
        for (ll i = 0; i < n; ++i) {
            l[i] = rand() % 6;
            r[i] = rand() % 6;
        }
        masksol();
        spd0();
        cout << "good " << ans0 << ' ' << ansmask << endl;
        if (ansmask != ans0) {
            cout << "BAD" << ' ' << ans0 << ' ' << ansmask << endl;
            for (ll i = 0; i < n; ++i) {
                cout << l[i] << ' ';
            }
            cout << endl;
            for (ll i = 0; i < n; ++i) {
                cout << r[i] << ' ';
            }
            cout << endl;
            return;
        }
    }
}

void solve() {
    cin >> n;
    l.resize(n);
    r.resize(n);
    d.resize(n);
    bool alld0 = true;
    for (ll i = 0; i < n; ++i) {
        cin >> d[i];
        if (d[i]) alld0 = false;
    }
    for (ll i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> r[i];
    }
    cin >> a0 >> b0;
    if (alld0) {
        spd0();
        cout << ans0 << endl;
        return;
    }

    masksol();
    cout << ansmask << endl;
}

signed main() {
    // stress();
    solve();
}
