#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<stack>
#include<algorithm>
#include<deque>
#include<queue>
#include<iomanip>
#include<random>
using namespace std;
#define int long long
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	cin >> n;
	vector <int> d(n);
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}
	vector <int> l(n);
	vector <int> r(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> r[i];
	}
	int a0, b0;
	cin >> a0 >> b0;
	if (n <= 15) {
		int otv = 0;
		for (int mask = 0; mask < (1ll << n); mask++) {
			int x = a0;
			int y = b0;
			for (int i = 0; i < n; i++) {
				if ((mask >> i) & 1) {
					x = min(x + d[i], l[i]);
					y += d[i];
				}
				else {
					y = min(y + d[i], r[i]);
					x += d[i];
				}
			}
			otv = max(otv, x + y);
		}
		cout << otv << "\n";
		return 0;
	}
	vector <int> suf(n + 1);
	suf[n] = 0;
	for (int i = n - 1; i >= 0; i--) {
		suf[i] = suf[i + 1] + d[i];
	}
	vector <pair <int, int>> la(n);
	vector <pair <int, int> > ra(n);
	for (int i = 0; i < n; i++) {
		la[i] = { l[i] + suf[i + 1], i};
		ra[i] = { r[i] + suf[i + 1], i};
	}
	sort(la.begin(), la.end());
	sort(ra.begin(), ra.end());
	int ans = 0;
	int mx = b0 + suf[0];
	for (int i = 0; i < n; i++) {
		ans = max(ans, la[i].first + mx);
		mx = min(mx, r[la[i].second] + suf[la[i].second + 1]);
	}
	mx = a0 + suf[0];
	for (int i = 0; i < n; i++) {
		ans = max(ans, ra[i].first + mx);
		mx = min(mx, l[ra[i].second] + suf[ra[i].second + 1]);
	}
	cout << ans << "\n";
	return 0;
}