#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>


typedef  unsigned long long ll;
using namespace std;


ll Buravchik(vector<ll>& a, vector<ll>& b, vector<ll>& d, vector<ll>& l, vector<ll>& r, ll i, ll n) {
	ll j = i - 1;
	if (i == n + 1) {
		return a[j] + b[j];
	}

	a[i] = a[j] + d[j];
	b[i] = b[j] + d[j];

	ll newa = min(a[i], l[j]);
	ll newb = min(b[i], r[j]);

	ll sa = a[i];
	ll sb = b[i];

	a[i] = newa;
	ll sum1 = Buravchik(a, b, d, l, r, i + 1, n);

	a[i] = sa;
	b[i] = newb;
	ll sum2 = Buravchik(a, b, d, l, r, i + 1, n);
	b[i] = sb;

	return max(sum1, sum2);
}

int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr); cout.tie(nullptr);


	ll n;
	cin >> n;
	vector<ll> d, l, r;
	d = l = r = vector<ll>(n);
	for (ll i = 0; i < n; i++) {
		cin >> d[i];
	}
	for (ll i = 0; i < n; i++) {
		cin >> l[i];
	}
	for (ll i = 0; i < n; i++) {
		cin >> r[i];
	}
	vector<ll> a, b;
	a = b = vector<ll>(n + 1);
	cin >> a[0] >> b[0];
	if (n < 16) {
		cout << Buravchik(a, b, d, l, r, 1, n) << endl;
		return 0;
	}

	for (ll i = 1; i < n + 1; i++) {
		ll j = i - 1;
		a[i] = a[j] + d[j];
		b[i] = b[j] + d[j];
		ll sum = a[i] + b[i];

		ll newa = min(a[i], l[j]);
		ll newb = min(b[i], r[j]);
		if (!(newb == b[i])) a[i] = newa;
	}

	ll sum1 = a[n] + b[n];

	for (ll i = 1; i < n + 1; i++) {
		ll j = i - 1;
		a[i] = a[j] + d[j];
		b[i] = b[j] + d[j];
		ll sum = a[i] + b[i];

		ll newa = min(a[i], l[j]);
		ll newb = min(b[i], r[j]);
		if (!(newa == a[i])) b[i] = newb;
	}

	ll sum2 = a[n] + b[n];

	cout << max(sum1, sum2) << endl;

}