#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18;

void solve() {
    int n;
    cin >> n;

    vector<ll> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }

    ll a0, b0;
    cin >> a0 >> b0;

    vector<ll> ssum(n + 1, 0);
    for (int i = n - 1; i >= 0; --i) {
        ssum[i] = ssum[i + 1] + d[i];
    }

    l.insert(l.begin(), a0);
    r.insert(r.begin(), b0);

    vector<pair<ll, ll>> v(n + 1);
    for (int i = 0; i <= n; ++i) {
        v[i] = { l[i] + ssum[i], r[i] + ssum[i] };
        if (i > 0) {
            v[i] = {min(v[i].first, v[0].first), min(v[i].second, v[0].second)};
        }
    }

    sort(v.begin(), v.end());

    vector<ll> pmin(n + 1), smax(n + 1);
    pmin[0] = v[0].second;
    for (int i = 1; i < n; ++i) {
        pmin[i] = min(pmin[i - 1], v[i].second);
    }
    smax[n] = v[n].second;
    for (int i = n - 1; i >= 0; --i) {
        smax[i] = max(smax[i + 1], v[i].second);
    }

//    for (int i = 0; i <= n; ++i) {
//        cout << v[i].first << " ";
//    }
//    cout << "\n";
//    for (int i = 0; i <= n; ++i) {
//        cout << v[i].second << " ";
//    }
//    cout << "\n";

    ll ans = max(v[0].first + smax[1], v[n].first + pmin[n - 1]);
    for (int i = 1; i < n; ++i) {
        ans = max(ans, v[i].first + min(pmin[i - 1], smax[i + 1]));
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(16);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
