#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
        >;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);

const int MAXN = 101010;
ll d[MAXN], l[MAXN], r[MAXN], a[MAXN], b[MAXN];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) cin >> d[i];
    for (int i = 1; i <= n; i++) cin >> l[i];
    for (int i = 1; i <= n; i++) cin >> r[i];
    cin >> a[0] >> b[0];

    ll ans = 0;
    int mx_mask = 1 << n;
    for (int mask = 0; mask < mx_mask; mask++) {
        for (int i = 1; i <= n; i++) {
            a[i] = a[i - 1] + d[i];
            b[i] = b[i - 1] + d[i];
            if ((mask >> (i - 1)) & 1) {
                a[i] = min(a[i], l[i]);
            } else {
                b[i] = min(b[i], r[i]);
            }
        }

        ans = max(ans, a[n] + b[n]);
    }

    cout << ans << '\n';

    return 0;
}
