#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <random>
#include <ctime>
#include <set>
#include <map>
#include <cassert>
using namespace std;

typedef long long ll;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../../input.txt", "r", stdin);
    freopen("../../output.txt", "w", stdout);
#endif
    int n; cin >> n;
    vector<ll> L(n, 0), D(n, 0), R(n, 0);
    for (int i = 0; i < n; i++)
        cin >> D[i];
    for (int i = 0; i < n; i++)
        cin >> L[i];
    for (int i = 0; i < n; i++)
        cin >> R[i];
    ll a, b; cin >> a >> b;
    ll res = 0;
    for (int i = 0; i < (1 << n); i++)
    {
        vector<ll> A(n + 1, a), B(n + 1, b);
        for (int j = 0; j < n; j++)
        {
            A[j + 1] = A[j] + D[j];
            B[j + 1] = B[j] + D[j];
            if (i & (1 << j))
                A[j + 1] = min(A[j + 1], L[j]);
            else
                B[j + 1] = min(B[j + 1], R[j]);
        }
        res = max(res, A[n] + B[n]);
    }
    cout << res << '\n';
    return 0;
}