#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

vector <vector <int>> res;
vector <int> suff;
vector <int> d, l, r;
int a0, b0;
int n;

//void dfs(vector <vector <int>>& gra, vector <vector <int>>& grb) {
//    int il = 0, ir = 0;
//    while (il < gra[va].size() && ir < grb[vb].size()) {
//        if (gra[va][il] == grb[vb][ir]) {
//            int u = gra[va][il];
//            if (res[va][u] == -1) {
//                dfs(va, u, gra, grb);
//            }
//            if (res[u][vb] == -1) {
//                dfs(u, vb, gra, grb);
//            }
//            res[va][vb] = max(res[va][u], res[u][vb]);
//            return;
//        } else if (gra[va][il] < grb[vb][ir]) {
//            il++;
//        } else {
//            ir++;
//        }
//    }
//    res[va][vb] = (va == 0 ? a0 : l[va - 1]) + suff[va] + (vb == 0 ? b0 : r[vb - 1]) + suff[vb];
//}

int rec(int va, int vb, int i) {
    int cura = (va == 0 ? a0 : l[va - 1]);
    int curb = (vb == 0 ? b0 : r[vb - 1]);
    for (int j = i; j < n; j++) {
        cura += d[j];
        curb += d[j];
        if (cura <= l[j] || curb <= r[j]) continue;
        return max(rec(j + 1, vb, j + 1), rec(va, j + 1, j + 1));
    }
    return cura + curb;
}

void solve() {
    mt19937 rnd(57);
    cin >> n;

    d.resize(n);
    l.resize(n);
    r.resize(n);
    for (int i = 0; i < n; i++) {
        d[i] = rnd() % 1000;
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        l[i] = rnd() % 3000;
        cin >> l[i];
    }
    for (int i = 0; i < n; i++) {
        r[i] = rnd() % 3000;
        cin >> r[i];
    }

    suff.resize(n + 1);
    suff[n] = 0;
    suff[n - 1] = d[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        suff[i] = suff[i + 1] + d[i];
    }

    a0 = rnd() % 1000;
    b0 = rnd() % 1000;
    cin >> a0 >> b0;

    if (n <= 15 && false) {
        int ans = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            int cura = a0, curb = b0;
            for (int i = 0; i < n; i++) {
                cura += d[i];
                curb += d[i];
                if (mask & (1 << i)) {
                    cura = min(cura, l[i]);
                } else {
                    curb = min(curb, r[i]);
                }
            }
            ans = max(ans, cura + curb);
        }
        cout << ans << "\n";
    }

    res.assign(n, vector <int> (n, -1));

    cout << rec(0, 0, 0) << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}