#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <chrono>
#include <numbers>
#include <numeric>

using namespace std;
using ll = long long;
using ld = long double;

#define int ll
#define all(x) x.begin(), x.end()
#pragma GCC optimize("Ofast")
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 1e5 + 5;
int l[N], r[N], d[N];
vector<int> dp[N];

vector<int> Max(const vector<int>& a, const vector<int>& b) {
	return (a[0] + a[1] > b[0] + b[1] ? a : b);
}


void solve() {
	int n;
	cin >> n;
	for(int i = 1; i <= n; ++i)cin >> d[i];
	for(int i = 1; i <= n; ++i)cin >> l[i];
	for(int i = 1; i <= n; ++i)cin >> r[i];
	dp[0].resize(2);
	cin >> dp[0][0] >> dp[0][1];
	for (int i = 1; i <= n; ++i) {
		dp[i].resize(2);
		for (int j = i; j > 0; --j) {
			int ka = dp[j - 1][0];
			int kb = dp[j - 1][1];
			for (int q = j; q <= i; ++q) {
				ka = min(l[q], ka + d[q]);
				kb += d[q];
			}
			dp[i] = Max(dp[i], { ka, kb });
			ka = dp[j - 1][0];
			kb = dp[j - 1][1];
			for (int q = j; q <= i; ++q) {
				ka = ka + d[q];
				kb = min(r[q], kb + d[q]);
			}
			dp[i] = Max(dp[i], { ka, kb });
		}
	}
	cout <<  dp[n][0] + dp[n][1];
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	//cin >> t;
	//cin >> g;

	for (int _ = 0; _ < t; ++_) {
		solve();
	}

}
