#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <chrono>
#include <numbers>
#include <numeric>

using namespace std;
using ll = long long;
using ld = long double;

#define int ll
#define all(x) x.begin(), x.end()
#pragma GCC optimize("Ofast")
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll N = 1e5 + 5;
ll l[N], r[N], d[N];
vector<vector<ll>> dp[N];
ll mx[N];

vector<ll> Max(const vector<ll>& a, const vector<ll>& b) {
	return (a[0] + a[1] > b[0] + b[1] ? a : b);
}

/*
4
10 5 10 10
100 15 100 33
100 13 100 35
0 0

*/

void solve() {
	ll n;
	cin >> n;
	for (ll i = 1; i <= n; ++i)cin >> d[i];
	for (ll i = 1; i <= n; ++i)cin >> l[i];
	for (ll i = 1; i <= n; ++i)cin >> r[i];
	int x, y;
	cin >> x >> y;
	dp[0] = { {x, y} };
	for (int i = 0; i <= n; ++i) {
		mx[i] = -10000000;
	}
	for (ll i = 1; i <= n; ++i) {
		for (ll j = i; j > 0; --j) {
			for (int w = 0; w < dp[j - 1].size(); ++w) {
				ll ka = dp[j - 1][w][0];
				ll kb = dp[j - 1][w][1];
				for (ll q = j; q <= i; ++q) {
					ka = min(l[q], ka + d[q]);
					kb += d[q];
				}
				if (mx[i] < ka + kb) {
					dp[i].clear();
					mx[i] = ka + kb;
					dp[i].push_back({ ka, kb });
				}
				else if (ka + kb == mx[i]) {
					dp[i].push_back({ ka, kb });
				}
				ka = dp[j - 1][w][0];
				kb = dp[j - 1][w][1];
				for (ll q = j; q <= i; ++q) {
					ka = ka + d[q];
					kb = min(r[q], kb + d[q]);
				}
				if (mx[i] < ka + kb) {
					dp[i].clear();
					mx[i] = ka + kb;
					dp[i].push_back({ ka, kb });
				}
				else if (ka + kb == mx[i]) {
					dp[i].push_back({ ka, kb });
				}
			}
		}
	}
	cout << dp[n][0][0] + dp[n][0][1] << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll t = 1;
	//cin >> t;
	//cin >> g;

	for (ll _ = 0; _ < t; ++_) {
		solve();
	}

}
