#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;
using ll = long long;

const ll mod = 1e9 + 7;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n;
    cin >> n;
    vector<ll> d(n);
    vector<ll> l(n);
    vector<ll> r(n);
    for (auto& x : d) cin >> x;
    for (auto& x : l) cin >> x;
    for (auto& x : r) cin >> x;
    vector<ll> a(n + 1);
    vector<ll> b(n + 1);
    cin >> a[0] >> b[0];
    for (ll i = 1; i <= n; i++) {
        a[i] = a[i - 1] + d[i - 1];
        b[i] = b[i - 1] + d[i - 1];
        if (a[i] - min(a[i], l[i - 1]) < b[i] - min(b[i], r[i - 1])) {
            a[i] = min(a[i], l[i - 1]);
        }
        else {
            b[i] = min(b[i], r[i - 1]);
        }
    }
    cout << a[n] + b[n];
}