#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3", "unroll-loops", "fast-math")
//#pragma GCC target("avx2")

#define int long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pb push_back
#define f first
#define s second

using namespace std;
using namespace __gnu_pbds;

using pii = pair <int, int>;
using oset = tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 2e5 + 1337;
const int INF = 1e16 + 1337;

void solve() {
    int n;
    cin >> n;
    int d[n];
    for (int i = 0; i < n; i++)
        cin >> d[i];

    set <int> st = {0, INF};
    int l[n];
    for (int i = 0; i < n; i++)
        cin >> l[i], st.insert(l[i]);
    int r[n];
    for (int i = 0; i < n; i++)
        cin >> r[i];

    int as, bs;
    cin >> as >> bs;

    int ans = 0;
    for (auto& mx : st) {
        int a = as, b = bs;
        for (int i = 0; i < n; i++) {
            a += d[i];
            b += d[i];

            if (a <= l[i])
                continue;

            if (b <= r[i])
                continue;

            if (mx <= l[i])
                a = min(a, l[i]);
            else
                b = min(b, r[i]);
        }

        ans = max(ans, a + b);
    }

    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}
