#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vector deque

const int maxn = 1e5 + 100;
vector<int> d(maxn, 0);
vector<int> left_lst(maxn, 0);
vector<int> right_lst(maxn, 0);



void slow_sol(int a, int b, int n) {
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        int ans_a = a + 1 - 1;
        int ans_b = b + 1 - 1;
        for (int i = 0; i < n; i++) {
            ans_a += d[i + 1];
            ans_b += d[i + 1];
            if ((mask >> i) & 1) {
                ans_a = min(ans_a, left_lst[i + 1]);
            } else {
                ans_b = min(ans_b, right_lst[i + 1]);
            }
        }
        ans = max(ans, ans_a + ans_b);
    }
    cout << ans << endl;
    exit(0);
}


signed main() {
    cout.precision(15);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> left_lst[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> right_lst[i];
    }
    int a, b;
    cin >> a >> b;
    slow_sol(a, b, n);
}
