#include <iostream>

#include <vector>
#include <set>
#include <map>

#include <algorithm>
#include <cmath>
#include <numeric>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const ll MD = 1e9 + 7;
const ll INF = MD * MD;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int xs;
    cin >> xs;
    vector<int>d(xs);
    for (int &i : d)
        cin >> i;
    vector<int>f(xs);
    for (int &i : f)
        cin >> i;
    vector<int>s(xs);
    for (int &i : s)
        cin >> i;

    ll sf, ss;
    cin >> sf >> ss;
    vector<pair<ll, ll>>q;
    for (int i = 0; i < xs; i++) {
        sf += d[i];
        ss += d[i];
        q.push_back({f[i] - sf, s[i] - ss});
    }

    sort(rall(q));
    vector<ll>mns(xs + 1);
    for (int i = xs - 1; i >= 0; i--) {
        mns[i] = min(mns[i + 1], q[i].second);
    }

    ll mx = mns[0];
    for (int i = 0; i < xs; i++) {
        mx = max(mx, min(0LL, mns[i + 1]) + min(0LL, q[i].first));
    }

    cout << sf + ss + min(0LL, mx);
}