#include <bits/stdc++.h>

#define int int64_t
//#define endl '\n'

using namespace std;

const int MAXN = 4e5;
const int MAXX = 20;
const int MOD = 998244353;
const int INF = 1e17;
const long double EPS = 1e-6;
const long double EPS1 = 1e-7;
const int LG = 50;
const int BS = 100;
const int DIS = 2e8;

int bp(int v, int p){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp(v, p - 1) * v % MOD;
    }
    int k = bp(v, p / 2);
    return k * k % MOD;
}

int bp_md(int v, int p, int md){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp_md(v, p - 1, md) * v % md;
    }
    int k = bp_md(v, p / 2, md);
    return k * k % md;
}

int nok(int a, int b){
    return a / __gcd(a, b) * b;
}

bool is_prime(int a){
    for(int i = 2; i * i <= a; i++){
        if(a % i == 0){
            return 0;
        }
    }
    return 1;
}

mt19937 rnd(121);
/*
int n;
    cin >> n;
    vector <int> a, b;
    bool flag = 1;
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        a.push_back(k);
    }
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        b.push_back(k);
    }
    for(int i = 0; i < n - 1; i++){
        flag = flag && b[i + 1] >= b[i];
        flag = flag && a[i + 1] >= a[i];
    }
    if(flag){
        vector <int> a1, b1;
        multiset <int> ms;
        int sm = 0;
        int mx = 0;
        int lst = -1;
        for(int i = 0; i < n; i++){
            sm += a[i];
            sm -= b[i];
            mx = max(mx, a[i] - b[i]);
            if(a1.size() && a1.back() >= b[i]){
                if(lst == -1){
                    lst = b1.back();
                }
            }
            a1.push_back(a[i]);
            b1.push_back(b[i]);
            if(lst != -1){
                mx = max(mx, a1.back() - lst);
            }
            if(i != n - 1 && a1.size() && a1.back() < b[i + 1]){
                lst = -1;
            }
            cout << sm - mx << ' ';
        }
        return;
    }
    multiset <int> a1, b1;
    int sm = 0;
    for(int i = 0; i < n; i++){
        a1.insert(a[i]);
        b1.insert(b[i]);
        sm += a[i];
        sm -= b[i];
        auto i1 = a1.begin();
        auto i2 = b1.begin();
        int mx = 0;
        int lst = -1;
        while(i1 != a1.end()){
            if(lst != -1){
                if(i1 == (--a1.end()) || *i1 < *(next(i2, 1))){
                    mx = max(mx, *i1 - lst);
                    lst = -1;
                }
            }
            else{
                if(i1 != (--a1.end())){
                    if(*(next(i2, 1)) <= *i1){
                        lst = *i2;
                    }
                }
            }
            mx = max(mx, *i1 - *i2);
            i1++;
            i2++;
        }
        cout << sm - mx << ' ';
    }
*/


vector <int> pref;

struct node{
    int sm = 0;
    int mn = INF;
    int tad = 0;
};

node tr[MAXX];
int a, b;

void build(int v, int l, int r, int t){
    tr[v].mn = INF;
    if(r - l == 1){
        if(!t){
            tr[v].sm = pref[r] + a;
        }
        else{
            tr[v].sm = pref[r] + b;
        }
        return;
    }
    build(2 * v, l, l + r >> 1, t);
    build(2 * v + 1, l + r >> 1, r, t);
    tr[v].sm = tr[2 * v].sm + tr[2 * v + 1].sm;
}

void push(int v, int l, int r){
    if(tr[v].tad != 0){
        tr[v].sm -= tr[v].tad * (r - l);
        tr[v].mn -= tr[v].tad;
        if(r - l != 1){
            tr[2 * v].tad += tr[v].tad;
            tr[2 * v + 1].tad += tr[v].tad;
        }
        tr[v].tad = 0;
    }
}

int get_zn(int v, int l, int r, int ps){
    push(v, l, r);
    if(l >= ps + 1 || r <= ps){
        return 0;
    }
    if(l >= ps && r <= ps + 1){
        return tr[v].sm;
    }
    return get_zn(2 * v, l, l + r >> 1, ps) + get_zn(2 * v + 1, l + r >> 1, r, ps);
}

int get_mn(int v, int l, int r, int ps){
    push(v, l, r);
    if(l >= ps + 1 || r <= ps){
        return INF;
    }
    if(l >= ps && r <= ps + 1){
        return tr[v].mn;
    }
    return min(get_mn(2 * v, l, l + r >> 1, ps), get_mn(2 * v + 1, l + r >> 1, r, ps));
}

int get_next(int v, int l, int r, int ll, int rr, int x){
    push(v, l, r);
    if(l >= rr || r <= ll){
        return -1;
    }
    if(l >= ll && r <= rr){
        if(r - l == 1){
            if(tr[v].mn >= x){
                return -1;
            }
            else{
                return l;
            }
        }
        push(2 * v, l, l + r >> 1);
        if(tr[2 * v].mn < x){
            return get_next(2 * v, l, l + r >> 1, ll, rr, x);
        }
        return get_next(2 * v + 1, l + r >> 1, r, ll, rr, x);
    }
    int k = get_next(2 * v, l, l + r >> 1, ll, rr, x);
    if(k == -1){
        return get_next(2 * v + 1, l + r >> 1, r, ll, rr, x);
    }
    return k;
}

void upd(int v, int l, int r, int ll, int rr, int x){
    push(v, l, r);
    if(l >= rr || r <= ll){
        return;
    }
    if(l >= ll && r <= rr){
        tr[v].tad += x;
        push(v, l, r);
        return;
    }
    upd(2 * v, l, l + r >> 1, ll, rr, x);
    upd(2 * v + 1, l + r >> 1, r, ll, rr, x);
}

void inser(int v, int l, int r, int ps, int x){
    push(v, l, r);
    if(l >= ps + 1 || r <= ps){
        return;
    }
    if(l >= ps && r <= ps + 1){
        tr[v].mn = x;
        return;
    }
    inser(2 * v, l, l + r >> 1, ps, x);
    inser(2 * v + 1, l + r >> 1, r, ps, x);
    tr[v].mn = min(tr[2 * v].mn, tr[2 * v + 1].mn);
}

void solve(){
    int n;
    cin >> n;
    vector <int> d, l, r;
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        d.push_back(k);
    }
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        l.push_back(k);
    }
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        r.push_back(k);
    }
    cin >> a >> b;
    multiset <pair<int, int>> msb;
    int ans = 0;
    pref.push_back(0);
    for(int i = 0; i < n; i++){
        pref.push_back(d[i] + pref[i]);
    }
    for(int i = 0; i < n; i++){
        msb.insert({r[i] + pref[n] - pref[i + 1], i});
    }
    vector <int> poss;
    for(auto [a, b]:msb){
        poss.push_back(b);
    }
    vector <int> zna(n + 1), znb(n + 1);
    build(1, 0, n, 0);
    for(int i = 0; i <= n; i++){
        zna[i] = get_zn(1, 0, n, n - 1);
        if(i == n){
            break;
        }
        int ps = poss[i];
        int nw = get_zn(1, 0, n, ps);
        int del = nw - l[ps];
        while(del > 0){
            int ps1 = get_next(1, 0, n, ps, n, del);
            if(ps1 == -1){
                upd(1, 0, n, ps, n, del);
                break;
            }
            upd(1, 0, n, ps, ps1, del);
            int zz = get_mn(1, 0, n, ps1);
            del -= zz;
            ps = ps1;
            inser(1, 0, n, ps, INF);
        }
        if(nw - l[ps] >= 0){
            inser(1, 0, n, poss[i], nw - l[ps]);
        }
    }
    build(1, 0, n, 1);
    for(int i = 0; i <= n; i++){
        znb[i] = get_zn(1, 0, n, n - 1);
        if(i == n){
            break;
        }
        int ps = poss[n - i - 1];
        int nw = get_zn(1, 0, n, ps);
        int del = nw - r[ps];
        while(del > 0){
            int ps1 = get_next(1, 0, n, ps, n, del);
            if(ps1 == -1){
                upd(1, 0, n, ps, n, del);
                break;
            }
            upd(1, 0, n, ps, ps1, del);
            int zz = get_mn(1, 0, n, ps1);
            del -= zz;
            ps = ps1;
            inser(1, 0, n, ps, INF);
        }
        if(nw - r[ps] >= 0){
            inser(1, 0, n, poss[i], nw - r[ps]);
        }
    }
    for(int i = 0; i <= n; i++){
        //cout << i << ' ' << zna[i] << ' ' << znb[n - i] << ' ' << (i == n ? -1 : poss[i]) << endl;
        ans = max(ans, zna[i] + znb[n - i]);
    }
    cout << ans;
}
/*
5
4 0 7 0 8
10 5 3 7 7
8 5 9 2 23
4 8
*/
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
        cout << endl;
    }
    return 0;
}
