/*
⣿⢟⣿⣻⢟⣿⣻⢟⣿⣻⢟⣿⣻⢟⣟⣟⢟⣟⢟⣟⣟⣻⡻⣻⡻⣻⡻⣻⢟⣿⡻⣟⢿⢿⡿⣿⢿⡿⣿⣿⣿⣿⣿⡿⢟⠟⢟⠿⣿⣿⠿⠋⠝⣥⣡⢭⣨⣣⢭⢮⢵⡭⣪⡡⣩⡈⡧⢱⠥⢅⢍⡙⠛⠟⢛⢋⢍⣍⣬⡵⣝⢾⣝⣯⣻⡻⣻⢟⡿⣻⡻⣟⢟⣟⢿⡻⣿⢿⡿⣿⢿⡿⣿⡻⣟⢨⣿⣿⣿⣿
⣯⡻⣮⢷⣻⡵⣯⣻⢮⣯⣻⢮⡷⣻⡵⣏⡿⣪⣟⢾⣪⢷⣝⡽⣝⢷⣝⢯⣻⢮⡿⣝⣟⣿⣺⢯⡿⣾⣻⣞⣷⢟⠬⣂⣱⢞⣦⡢⠴⡌⠠⢈⠂⢞⢑⢳⡳⢕⢋⠕⡡⡑⢅⢊⢂⠳⢈⠢⠑⡂⢂⡩⡜⡴⢥⢣⢝⢦⡻⣺⣝⢷⡵⣳⣝⡽⣝⡽⣞⡽⣞⡽⣝⣽⢽⡽⢯⢷⡛⣙⡕⡿⣽⣻⠃⣼⣿⣿⣿⣿
⢮⡿⣵⢟⣵⢟⣞⢷⣻⣮⢡⣭⣭⡍⣺⢟⣞⢷⡝⡷⡽⡎⣬⣬⣥⣅⢫⢷⣝⢃⣭⣭⣭⣌⢻⡯⢩⣭⣬⣭⠑⣣⢞⡮⣗⢟⠎⣩⣥⣴⣦⣤⣅⢊⢂⠣⢑⣠⣥⣴⣬⣬⣁⡣⣅⣓⡢⡥⣃⠪⠚⣨⣬⣤⣥⣤⣕⡱⡹⡧⣯⡇⣭⣥⣭⡌⢟⡾⣵⡋⣬⣭⣬⣥⣥⣔⣓⢿⡍⡔⣽⢪⣿⡏⢸⣾⣿⣿⣿⣿
⡻⣞⣽⣫⡯⣿⢽⡯⣷⣻⢠⣿⣿⡇⣽⣫⢞⡷⣝⣟⠾⢡⣿⣿⣿⣿⡌⣷⡻⢄⣿⣿⣿⣿⡘⢇⣿⣿⣿⣿⠐⣯⢫⣮⢹⡁⣾⣿⣿⠉⠛⡿⡿⠇⠹⢡⣿⣿⡿⢛⠻⢿⣿⣷⡜⣽⣪⣛⢖⡑⢼⣿⣿⡋⠝⢿⠿⠷⢘⡝⡮⣰⣿⣿⣿⣿⡘⣟⣾⠕⣿⣿⡿⢛⠿⣿⣿⣦⠸⣜⢧⣿⡞⣢⣿⣿⣿⣿⣿⣿
⣝⢷⡽⣮⣻⣗⡿⣽⣞⣿⢐⣿⣿⡇⢾⢵⢯⡻⡮⣯⢃⣿⣿⢇⢹⣿⣷⡘⣿⠄⣿⣿⡝⣿⣇⢹⣿⠇⣿⣿⠐⢃⠅⠄⠢⠠⠹⢿⣿⣿⣿⣶⣦⡑⢍⣾⣿⣿⢰⡟⣷⠈⣿⣿⣧⢸⢮⣝⢵⣫⡘⢿⣿⣿⣿⣶⣶⣅⢫⡺⢠⣿⣿⠃⢻⣿⣧⢙⣴⡎⣿⣿⡗⣿⣷⢹⣿⣿⡆⣿⣟⡾⣨⣾⣿⣿⣿⣿⢿⣿
⡺⣯⡻⣾⢵⣯⣻⣗⢿⣺⢐⣿⣿⡇⣻⡳⣏⣟⢾⠃⣾⣿⣿⣦⣼⣿⣿⣇⢻⠌⣿⣿⠆⢿⣿⣿⣿⠀⣿⣿⡁⡶⡜⢋⡐⡁⣦⣤⡍⣍⡙⢿⣿⣿⢀⢻⣿⣿⡜⠽⠮⣡⣿⣿⡇⡜⢳⣕⢷⡅⣩⣤⣌⢩⡙⢻⣿⣿⡆⢁⣾⣿⣿⣬⣾⣿⣿⣇⢻⡇⣿⣿⣏⠿⠟⣸⣿⣿⢡⣿⠞⢴⣿⣿⣿⣿⣿⣿⣿⣿
⣝⡷⣻⣵⣟⡷⣻⣞⢯⡿⢐⣿⣿⡇⣝⣮⣣⢟⡏⣼⣿⣿⠛⡛⣛⠻⣿⣿⣎⠃⣿⣿⡛⠸⣿⣿⡇⡄⣿⣿⡐⠏⡠⣷⢹⢂⠻⣿⣿⣶⣶⣿⣿⠏⣼⣈⠻⣿⣿⣷⣾⣿⣿⠟⣴⣻⣔⠬⡣⢧⡹⢿⣿⣷⣶⣾⣿⠟⡐⣾⣿⣿⢛⣛⣛⢻⣿⣿⡎⢗⣿⣿⣿⣿⣿⣿⡿⢋⣮⢟⣨⣿⣿⣿⣿⣿⣯⣿⣿⣿
⢮⣻⢽⣞⡷⣻⡯⣾⣫⢿⢦⣭⣭⢵⣛⣎⣝⣍⡦⡭⣭⡥⡾⡶⡶⣤⣭⣭⣥⣬⡭⡭⢔⢧⡩⣍⠔⣤⠭⡩⡀⣱⡻⢎⢇⢜⠷⣦⢭⣩⣍⡭⣴⠺⡵⣽⡱⢦⡭⣍⡍⠭⣔⢟⢮⢖⡽⣲⡕⢕⢝⢦⣭⡭⣭⣭⣴⢾⣅⢭⣭⢡⣿⡽⣿⣦⣭⣭⣵⣦⣭⣭⣭⡭⣩⣴⢞⣯⠏⢤⣿⣿⣿⣿⣿⣽⣿⣿⡿⣿
⡽⣳⣟⢮⡿⣽⠞⣡⢦⡳⡳⣮⢺⢧⣫⢞⡮⣞⢾⢕⢷⣝⣞⢟⣞⢗⡷⡺⡶⣕⢯⡺⡱⡣⡞⣰⢾⡑⡡⢊⢤⢯⡫⣺⢁⣏⡳⡳⢯⡰⣧⢻⣞⢥⡛⣾⣕⡳⣹⢎⡿⣪⡪⣗⢟⣮⡻⣮⣫⡧⡱⡱⣣⢿⣞⢮⣟⡷⡻⢮⣳⡧⢿⣿⣹⣿⣿⢟⣯⣻⣿⣿⢟⣰⢯⣞⢯⠎⣲⣿⣿⣿⣿⣿⢿⣿⣿⢿⣿⣿
⣝⢷⣝⣟⢾⣻⡕⢝⢮⣹⢝⡮⣫⣗⢽⣣⢟⣼⡳⣽⡳⡽⣮⡻⣮⢯⣫⣟⡽⣺⢇⢯⢺⢁⣾⢙⢃⠔⣡⠃⣾⢣⣏⢷⠡⣏⢾⣑⠧⣝⣞⢷⡽⡠⣇⠘⣮⢳⣌⢳⣝⢷⢽⣌⢻⡮⣻⡺⡮⡷⣕⠵⢌⢗⣽⣟⣵⣻⢟⣎⡻⣻⢚⣿⣿⢋⣶⣿⣷⣝⢿⡭⣲⢯⢷⡝⠣⣼⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣺⡻⣮⢯⣻⣮⢿⣌⠳⡱⡇⡯⡺⣪⢷⡭⣫⢾⣝⢮⣯⢻⣎⢿⣪⢷⣳⣝⢞⢵⡱⡣⢃⢜⢡⠊⢎⢼⡣⡸⣳⢕⣯⣻⢘⣧⣫⡲⢱⡯⣺⡳⣽⠂⡮⡱⡈⢷⡻⣆⠙⣷⣫⢾⣆⡙⢷⡽⣺⢯⡻⡷⣝⢮⡦⣻⡼⣗⣿⡉⣯⣕⣝⣾⣥⣿⣻⣷⣻⡧⢿⣞⣯⣻⠏⢌⣿⣿⣿⣿⣿⣿⣿⣽⣿⣿⣽⣿⣿⣿
⢮⣻⡳⣟⣵⢯⡿⣽⣧⢙⢜⢮⢬⢮⣬⣮⣭⣕⡙⠳⢝⠗⡽⡳⡝⢷⢵⣫⢞⣕⡕⢁⣮⢃⠇⡘⣜⢗⢆⡽⣪⢗⢷⢵⠸⢼⡵⣍⢼⣝⡽⣝⡽⡅⢺⠀⣿⡈⢿⡽⡄⢆⠹⣳⣝⢷⡐⢝⢝⢯⣻⣝⣯⢷⣎⠘⠿⣽⣟⣎⠿⣿⣽⣯⡿⣷⣟⣾⣽⣿⣾⣮⣮⡱⡡⣻⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⣿⡿⣿⣿
⣝⢷⡻⣽⡺⣗⡿⣾⣝⣷⣅⠳⡕⣝⢺⡳⣯⢾⡻⣻⡳⣻⢖⡾⣲⢗⡶⡼⡧⡵⢀⡿⣊⡜⡐⢜⣭⣫⢢⢯⢏⣝⢗⢯⢸⢪⣟⠆⡾⣪⢟⡮⣳⢭⠘⡄⢷⣿⡌⢻⣽⡘⣦⢊⠚⣯⢿⣕⡱⣣⢝⡳⡽⣯⢿⣷⣕⠤⣙⠺⣻⢜⣷⣿⣻⢿⡾⣿⣾⢷⣿⣽⣟⢏⠢⣿⣿⣿⣿⣿⣾⣿⣿⣿⣿⣾⣿⣿⣿⣿
⡺⣯⣻⢽⡽⣽⢽⣞⡷⣽⣟⣷⣎⡪⡣⣟⢞⣗⢿⡽⣯⢯⣯⣻⣭⡻⣞⡽⣞⠢⡽⡎⢾⠌⢰⡻⣔⢷⢸⡗⠕⣮⡛⣼⢨⡎⡾⢱⡏⢾⣫⢾⣝⠷⡅⡹⢼⣾⣿⣆⠻⣧⠸⡷⣍⠦⣙⢯⣷⣬⢳⣭⡺⢔⡛⢮⣟⢷⣵⣍⢮⢻⣯⣿⣽⣿⣟⣿⣽⣟⣿⡢⡦⣫⡓⠸⣿⣿⣿⢿⣿⡿⣿⣾⣿⣿⢿⣿⣿⣿
⣽⡺⣗⢿⡺⣗⣟⢾⡽⣷⣽⣻⣞⢿⣜⡮⡫⣞⢷⢝⣯⣻⢽⣯⣻⣟⣮⣻⡎⢼⡫⣴⡻⢠⢹⣝⢞⡧⣻⢘⢕⠮⣱⣻⡐⢧⢃⡿⣝⠼⣳⢯⡞⣿⡱⣘⢾⡷⣿⣭⣵⡸⣶⠸⣿⣿⣦⡕⣌⠳⢇⢻⣟⣷⣬⣕⣨⠒⡑⣎⡗⣿⣿⣻⣷⣿⢾⣟⣯⣿⣿⢎⡾⣆⢻⡔⢩⡻⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿
⢮⣟⣽⣫⣟⡽⣞⣯⡻⡾⣾⢵⣟⣯⢿⡽⣶⣮⡑⢯⣞⢮⡷⣫⢿⢾⣯⣿⢀⣿⢢⢟⡜⢰⢹⣎⢟⡎⣾⠨⡪⡑⡷⣝⣦⡙⡌⣟⣾⠀⢻⣗⢟⣞⢷⢨⢾⣿⣻⡿⣿⣿⣮⣥⡙⣿⣿⢿⣯⢿⣦⢅⣍⢨⣃⢍⣋⡫⡩⡬⢷⣜⣋⢭⢦⡵⣋⡻⣿⣿⡏⣺⣝⣿⡺⣿⠄⣷⣎⠻⣿⣿⢿⣿⣷⣿⣿⡿⣿⣿
⣳⡽⣮⢷⡽⣞⣯⣞⡽⣝⣷⡻⣷⢽⣯⣻⢷⣽⣻⣦⣌⡓⠝⡽⡳⣏⢶⡹⢀⠏⣼⡳⡕⡱⢕⣽⡹⡣⣯⢘⠌⣼⡹⢮⡟⣔⢻⡌⣿⠆⣇⢿⡽⣺⣻⣇⠻⣟⣿⣿⣟⣿⡿⡿⣟⡮⡋⠽⠊⠡⠺⠗⠸⢑⣎⢿⡹⣯⣲⣚⠶⣨⣥⡕⣪⣗⠭⣪⣌⡻⡸⣕⣽⡯⣇⢟⣷⢹⣿⣧⢹⣿⣿⣿⣿⢿⣿⣿⣿⣿
⢮⡻⣞⢷⣻⢞⣮⢞⣽⡺⡮⡿⣽⣳⡯⣷⢿⡺⡷⡽⣯⢿⣻⣦⡙⢮⡳⡻⡌⢣⡿⡵⡇⣜⢕⣧⣻⣕⢷⠨⡂⣾⠝⡽⣸⣿⡕⢿⡌⣷⢹⡎⣿⢽⣮⣻⣪⢻⣿⣯⣿⣿⢍⠊⡈⠄⢐⣤⢪⣷⣶⡠⡔⠇⡞⢦⣝⡤⢅⣹⣾⣿⣿⡿⣺⡧⡳⢨⢎⢕⢎⠰⣿⡽⣫⡪⣿⣸⣿⣿⠢⣿⣿⣿⣿⣿⣿⡿⣿⣿
⡵⣻⣝⢗⣿⣻⣮⡻⣮⡻⣞⣽⣫⢾⡯⣿⡵⣻⢞⣽⡺⣗⡽⣮⣏⠸⢪⢛⢞⢸⡯⡞⡡⢸⡪⡾⢮⣞⣽⡘⢄⡣⡾⣱⣿⣽⣿⡜⣿⡜⣇⢿⣮⢳⡷⡽⣮⢳⣝⢿⣿⢓⣴⣁⡐⡁⢊⡉⡸⣞⣿⣟⣗⠡⣹⣧⣭⠄⣾⣿⡿⣷⢿⡇⣿⡣⣫⠰⡕⢭⣎⢘⣿⡺⡿⡌⣿⠜⣿⣿⢑⣿⣿⣿⣯⣿⣿⣿⣿⣿
⣺⢧⣯⡻⣾⢵⣯⣟⣮⡻⡮⡾⣕⢿⡽⣾⢯⣷⡻⣮⢻⣎⢿⣪⡾⣶⣁⠱⡅⣻⢞⡕⣅⠸⡕⣟⢷⡳⡵⢇⢕⢝⣼⣟⡿⣾⣯⣷⣹⣿⣞⢎⣿⡗⢿⡽⣷⢇⢿⣿⣽⣿⣿⣥⢀⢌⠦⡑⢎⡻⡙⢝⡎⠰⡰⣽⢾⢨⣿⣿⢯⣟⣿⡊⣿⡇⡽⡨⡪⣒⣷⠐⣿⣽⢿⡣⣻⣍⣿⡧⣽⣿⣿⣿⣿⣿⣟⣿⣿⣿
⣝⡿⣾⣽⣻⣯⢷⡿⣮⣟⢾⣝⡽⣳⡽⣺⢟⣾⢯⣞⢷⣹⡳⣿⢿⡺⡇⠒⠠⣯⡻⡆⡪⡈⣗⢯⣫⡯⣻⢸⠸⣎⢷⠯⣻⠛⡞⠟⣷⢿⣿⣷⡹⣿⣎⡻⣽⣿⡘⣿⣿⣿⣿⡿⢦⣠⣰⣾⣶⣞⣿⢮⡿⡐⡕⢺⣿⣺⣿⡟⢼⣯⣿⢌⣿⡆⣙⡮⡢⣵⢿⡈⣿⣯⢿⣏⠼⡇⢾⢒⣿⣿⣿⣿⣽⣿⣿⣿⣿⣿
⢾⣽⣗⡿⣾⡽⣟⣽⡻⣞⢷⡽⣝⣷⣫⣯⢯⣯⣻⣽⣗⢽⡺⡵⣯⡻⢨⢁⢪⢒⢽⡣⡂⢵⡘⢽⢮⡻⣵⢱⠈⣏⠙⢁⠄⠄⡘⢰⣬⣝⣯⣿⣿⣟⣿⣮⡱⢿⣷⡹⣿⣿⣿⣿⣿⣞⣿⣿⣻⣷⢻⣝⡿⡄⣻⡈⣿⣿⣿⣿⣘⣷⢿⠣⣿⡆⡱⣟⢾⡳⣿⡑⣿⢯⡿⣇⣻⣫⢌⣿⣿⣿⣿⢿⣿⣿⣻⣿⣾⣿
⣻⢾⣽⣻⢾⣻⢯⡾⣝⣯⣗⡿⣽⢮⡷⡽⡾⣮⢾⢶⢯⢷⡝⡾⡕⢅⠳⡄⡕⡕⣸⣇⠆⢸⣧⡙⢗⣯⣻⠰⠁⡁⣨⣶⣔⠠⠂⢌⠠⡜⣿⣿⣿⣿⣿⣿⣿⣮⡻⢷⣽⣿⣿⣿⣿⣷⣽⣿⣟⣿⡽⣿⣝⠦⣸⡇⢿⣿⣷⣿⣷⡟⢑⡵⢿⡇⢜⣯⢿⣝⣿⢸⡯⣿⢽⡗⢼⡇⠴⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣽⣻⢷⣯⣟⣽⡳⣯⢿⣮⣟⢾⡯⣷⣻⣝⣟⢾⡳⣯⡻⣳⢟⢽⣰⢝⢮⡪⣊⠎⣼⢷⠀⢹⡮⣷⢌⠳⣝⡇⡃⢶⢾⡿⣿⠧⠑⠅⣃⣸⣼⣿⣿⣽⣿⣟⣿⣿⣿⣯⣻⣽⣿⣿⣿⣿⡾⣯⣿⣿⣗⢿⡇⡗⡬⣟⡸⢟⢞⠿⠑⢤⢪⡟⣾⢇⢪⣟⣿⡺⡯⢸⡯⡻⣽⣟⢸⣷⢱⢹⣿⣿⣽⣿⣯⣿⣿⣽⣿⣿
⢾⡽⣳⢷⡽⣞⣯⣟⣷⣳⡯⣿⠽⡳⡛⣬⢵⢵⢞⡶⣳⡳⣻⢧⡫⣗⢯⠂⣕⠱⣯⣻⠀⢸⢯⡞⣷⡑⢮⡎⢎⠜⢳⢿⢨⣢⡘⣦⣽⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣾⣿⣿⣽⣿⣾⣿⡍⡧⡣⣿⢸⡇⢤⠙⣮⠣⡁⣿⣝⡎⣷⢘⡷⣯⣻⡓⡈⢟⡼⡱⣿⢨⣿⡘⣦⠿⣿⣿⣿⣿⣿⣿⣿⡿⣿
⣳⣝⡷⣻⡽⣫⣺⣗⡯⢞⣹⡦⢳⡴⣻⡪⣗⡽⣳⣝⠗⢿⢘⣇⡫⠔⡡⢠⡑⣝⢷⡭⠀⡱⣻⢮⣫⢧⠘⢧⠫⡖⡄⠻⣮⡷⣯⢿⣿⣟⣿⣿⣿⣽⣿⣟⣿⣿⣿⣿⣿⣿⡿⣿⣿⢿⣿⣷⣿⣿⡟⡥⣓⠕⣿⢐⣿⠰⣹⡇⡇⢸⡿⣮⢐⣿⡁⣿⢿⡕⡭⡌⢺⡪⣓⣿⠢⣿⡇⢺⡽⣚⣿⣿⣽⣷⣿⣿⣿⣿
⢵⣯⢛⣵⢾⣻⢕⢥⡾⣾⡝⢜⡷⣝⡮⣻⠜⣋⣮⣦⠿⢚⡩⣡⣺⡖⢔⢎⡾⣹⡳⠸⡀⠸⣯⢷⡸⣇⢙⢦⡙⢾⡘⣧⡸⣟⣿⣟⣿⣿⣹⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⢝⣾⣿⢕⠩⣿⢀⣿⢸⡻⣎⢢⣟⢿⡖⠠⡿⣧⢸⣟⢮⡃⣿⣐⢯⣪⣿⡑⢾⣻⡐⣟⢷⡜⢿⣿⣿⣿⡿⣿⣿
⡗⣱⣟⣯⢏⡵⢭⣾⣻⣾⠁⣟⢾⣪⢟⣼⣟⡿⡓⠡⣒⣵⡿⣽⢏⢜⡮⣳⢝⡮⠃⡽⠀⡪⣷⡳⢵⡇⢸⡕⣽⠷⣦⠨⣧⠭⣷⣿⡾⣿⣿⣿⣿⣾⣿⣿⣿⢿⣿⣿⣿⣾⣾⣿⣿⣿⣿⣻⣾⣿⣿⣿⡙⠌⡗⢤⣿⢸⣿⣕⣯⣾⣿⢁⠂⢿⣻⡄⣿⢴⢣⣿⣿⡜⣾⢷⡝⢺⣟⣧⠸⣿⣞⣕⢻⣿⣿⣿⣿⣿
⢧⡨⢛⠝⠰⣯⠸⣷⣻⡇⢸⣫⢳⢵⣿⣳⠟⡡⢊⡞⢿⣽⢟⢥⣞⢵⡫⣞⠕⡡⢜⠎⣸⠰⣿⡵⣿⠁⣪⠎⣾⣛⢾⡄⢿⡧⡜⢿⣿⡝⣿⣿⣟⣿⣿⣷⣿⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⢻⢟⣋⡊⡝⣸⡿⣸⡷⣿⣸⣯⠗⡨⡃⢸⣿⡇⣻⣮⠸⣿⣿⡇⣿⣻⣎⢹⣯⢿⡆⢽⣿⣞⣧⡻⣿⣿⣻⣿
⣻⣟⣿⣻⣮⣙⡦⢍⡘⢧⠘⢧⣻⡷⢋⣭⡕⣹⣯⣇⠸⣯⣞⢗⡷⣹⢮⠳⡜⡕⡝⣰⡏⢼⣷⣟⡯⠠⡧⢹⣯⣻⣵⢇⣌⠻⡼⣎⡛⢿⣮⡻⣿⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣟⣿⣿⣿⣿⠛⣋⢊⡾⡽⡆⡱⣸⡯⢺⡿⣇⢿⡾⠡⡣⡑⢘⣷⣗⢹⣯⢧⡹⣿⡗⣿⣵⢧⢹⣷⡻⣿⡠⣻⣿⣿⢯⠺⣿⣿⣿
⣽⡾⣽⣽⢯⣟⡿⣻⢏⣮⢛⣶⡷⣴⢿⡛⢵⢿⡝⣧⠘⣿⢮⢛⣩⣛⠕⡭⣪⠊⣰⢿⢬⡿⣮⢿⠠⡞⢰⣿⣳⣟⡾⢰⡿⣎⠦⡧⢝⢶⣩⣃⢛⠿⠿⢯⣿⣿⢿⣿⣿⡿⣿⣿⣿⢿⣺⢟⣾⣫⢗⣽⠻⡀⠳⢸⣿⠸⣿⡅⡿⣟⠨⡃⢜⠀⣿⣧⢹⣿⢖⢕⢿⡯⣺⣯⡗⢹⣞⢝⣯⣷⠨⣿⣿⣿⡑⢿⣿⣿
⣞⣿⣻⢾⢿⡝⢨⣗⢡⡷⣸⡯⡷⢹⣏⢫⡹⣣⣽⢇⢪⣧⣾⣿⡋⡕⢎⠎⣠⡼⠯⢋⣴⢿⢮⣣⢟⢆⣟⢷⣻⡵⢃⣿⣻⢾⣅⢏⢞⢵⢜⢵⢍⡞⣚⠶⣢⢕⡍⢧⠬⣩⢝⣏⣵⣾⣯⣟⣮⡷⠗⢃⠨⠰⠘⠾⢎⡇⢿⡸⠜⡷⢈⠇⡪⢀⣿⡞⢽⣿⢸⡡⡫⡗⣽⡷⣏⠸⣇⢧⢻⡾⣆⢚⣿⣯⡇⣻⣿⣿
⢉⣎⠷⠝⠕⡙⠸⢆⢌⡷⣯⢞⡕⣽⢯⣸⣷⢟⣮⣽⢾⣟⡷⣑⠋⣉⣠⣲⡭⠀⢢⣿⣝⣵⡯⡯⣫⣽⣽⣫⣾⠡⣽⡳⣿⣹⡮⢆⢫⡳⡱⡳⣕⡇⢸⡕⣗⢵⡹⡢⣳⠑⠇⣈⠉⡚⢉⢉⠄⢔⢐⠅⡑⣜⡜⣆⢢⡌⡌⡺⡡⠺⡄⢃⠆⠠⡿⡋⣼⡷⠐⡥⡫⢌⣿⣽⢧⠐⡗⡵⣙⣯⣿⡀⢻⣿⠇⣽⣿⣿
⣫⠇⡑⡡⣸⣞⣿⢾⢢⡟⡞⢥⡟⣼⢱⣟⡾⣻⣮⣿⣻⡏⠼⠿⠿⢟⡛⣭⡖⣱⢿⢮⣟⡾⡩⢞⡶⣻⣮⢿⢁⡾⣿⣝⡾⣽⢁⡾⠈⡓⡙⢚⠞⣔⠞⠮⢎⢐⣉⣤⢶⡾⣥⢄⠸⠄⢣⠐⣄⣅⢮⣼⢣⣿⡣⢹⣶⣬⡲⢌⢣⠊⠸⡣⢊⠐⣯⡀⣿⢏⢨⢢⡫⢰⡿⣞⢷⠀⢺⢪⠆⣻⣞⣿⡈⢿⣣⣿⣿⣿
⠀⣱⠈⣼⣯⡿⣽⠇⣺⣅⣣⣟⢷⢶⡟⣷⡽⣿⢾⣯⣟⢸⣿⣷⣿⣷⢿⣫⡶⣟⣽⢫⢎⢞⡸⣎⡯⣿⠎⣵⠫⣜⣷⢯⡟⡡⠎⣠⡶⣾⣾⣿⣷⠮⡔⢲⣺⢿⡿⣽⣗⣿⢿⣯⢓⢱⣷⣿⣷⣾⣿⡿⣼⣿⡱⠹⣿⣿⣿⣷⣾⣬⣅⡛⠦⡙⠦⣫⣞⢕⢸⢢⢑⡿⣽⡯⣷⠀⣣⢫⡣⡸⣷⢯⣟⢌⢿⣿⣿⣿
⡘⣼⡅⣿⣟⣾⡟⣠⣿⢽⡯⣾⠏⣵⣿⣽⣻⣟⡿⡷⣹⣿⡿⢾⣣⡷⣿⢱⠟⢝⠪⣡⡶⣿⢹⡮⡳⣣⣾⠯⡱⣽⡽⡋⣜⢕⣾⣿⠟⣾⣿⣿⡟⣜⢸⣲⣯⣟⣿⣽⣯⡛⣭⣣⣿⣦⡻⡛⣿⣿⣿⢧⣿⣿⢸⢃⣿⢿⡿⣿⣿⣿⣿⣿⣿⣿⣷⣯⣵⣅⣛⠥⣫⡼⣷⣻⣮⠀⣽⡔⣝⠔⣿⣝⡿⣦⢙⣿⣿⣿
⢘⣞⢷⣝⢿⣾⢡⡿⣷⣻⣽⣻⡼⣿⢾⡷⣿⣻⡿⣱⣿⡟⠵⣫⣭⣮⠖⠠⡑⠄⣡⣿⣽⣫⡗⢃⣼⠛⡜⣎⡺⡺⢃⡞⣴⣿⢟⢣⣿⣿⣿⢟⠼⢢⣻⣿⣿⣿⣿⣿⣿⣿⢔⣿⠷⣯⣏⣾⣾⣿⣿⢸⣿⡗⡯⢴⢽⣮⢿⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣶⣾⣙⠻⢞⣽⣗⠀⣽⣷⢱⡃⢺⣯⣟⢾⡆⣻⣿⣿
⠪⡪⠷⠽⠶⣝⠇⢿⣻⣗⣿⣞⣿⣽⣿⣻⣿⡽⣃⣿⠋⢔⣮⣾⡿⠃⢠⠙⡌⣼⣟⢷⢳⡎⠰⡱⢃⢝⢬⣟⢼⢣⢏⣾⢟⢱⣵⣿⣿⡿⡩⡺⢁⣿⣿⣿⣿⣿⣿⣿⢿⣿⣕⣵⣷⣭⣣⣿⣿⣿⡏⣾⣿⣹⠇⣿⡚⣿⡞⣿⣿⣿⣿⣿⣻⣿⣿⣿⣿⣿⣿⣿⣿⣧⡪⠱⣯⠀⣟⣿⣧⢫⢸⣿⢞⡿⣇⢪⣿⣿
⢛⣚⣷⣻⣵⡱⣫⠘⣻⣞⡷⣻⢞⣷⣻⣯⠚⣬⡾⢡⢊⣾⡿⢋⠔⡢⢑⣱⣾⡻⣞⠷⠋⣰⢁⢂⢗⡱⢰⣯⠟⢌⢣⣔⣾⣿⣿⣿⡟⡰⡑⢅⣿⣿⣿⣿⣿⣯⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⡇⣿⢏⣾⠁⢼⡇⣿⣿⣹⣿⣿⣿⣿⣿⣿⣿⣷⣿⣿⣿⣿⣿⣿⣗⢧⡸⢰⡇⣿⣿⣧⡸⣯⣯⣻⡏⡮⣿⣿
⢿⢝⡯⣷⢻⢿⠔⡡⡀⢿⡽⣯⢿⡵⣿⢾⡄⣻⣇⠥⢼⣵⣴⣤⣷⣾⢿⢝⣭⡩⢠⢒⢝⢔⡁⢔⢕⢵⢈⢏⡆⣳⣿⣿⣿⠿⡾⡟⡰⡑⢡⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣯⡟⢢⡟⣰⠸⣗⢼⣿⡎⣿⣿⣿⣯⣿⣷⣿⣿⡿⣿⣷⣿⣿⢿⣿⡎⣇⢸⣷⢹⣿⣿⢸⣗⢷⣽⡊⣯⣿⣿
⢒⠎⣃⣑⣁⣂⠑⠌⣂⣙⣙⣓⣋⣛⠛⣙⣂⡹⢀⠏⣒⣉⠮⣙⣛⣙⣃⣛⠯⣿⣦⠑⣕⢕⠆⢈⣊⣐⣑⡈⣲⢟⣋⣛⢳⣉⣊⣘⡈⣊⣙⣛⣛⣛⣙⣛⢚⣙⣋⣓⣛⣛⡋⣿⣿⣿⡟⣙⣋⣛⣙⣃⢸⠃⣛⣈⠳⡪⡿⢃⣛⣋⣛⠿⣿⡿⢛⣙⣛⣙⠿⣿⣿⣿⣿⣇⠗⣘⣛⣀⣛⠷⣹⢋⣓⣙⣁⣛⣚⢻
⡅⣾⣿⡛⠻⠿⠷⡀⣿⣿⠟⠛⠛⢛⡄⢿⣿⣷⣄⠑⣿⣿⠠⣻⣿⡟⠻⢿⣷⡜⣿⣿⣤⠃⣼⣿⡿⠛⢿⣿⠜⢼⣿⣿⢸⡏⣿⣿⡇⣛⣛⢻⣿⡟⣛⣛⢸⣿⣿⠛⠛⠛⣃⣿⣿⣿⡇⣿⣿⠛⡻⣿⣷⠀⣿⣿⠅⣃⣾⣿⢟⡻⢿⡷⠙⣴⣿⡟⠙⠿⠷⢸⣿⣿⣿⢢⣾⣿⢟⡻⣿⣷⡙⢜⣿⣿⠛⣛⢛⣸
⣤⡙⠿⢿⣿⣷⣎⠃⣿⣿⡿⠿⠿⠇⡁⢿⣿⠻⣿⣮⣿⡿⠠⣽⣿⡇⣯⢸⣿⡇⣽⣿⣿⡇⣿⣿⠰⡑⠔⠶⢿⢺⣿⣿⠸⣁⣿⣿⡇⣿⣿⢸⣿⡇⣿⣿⢳⣿⣿⠿⠿⠿⢪⣿⣿⣿⡇⣿⣿⣶⣾⡿⠟⡄⣿⣿⡃⢸⣿⣯⢸⣿⠶⠿⢿⢌⠻⢿⣿⣷⣮⢻⣿⣿⣯⢸⣿⡇⣿⡿⢸⣿⡇⢸⣿⣿⢷⡾⡆⣿
⡇⢾⣿⣔⣢⣿⡿⠀⣿⣿⣦⣤⣥⣥⠁⣿⣿⢅⡙⣿⣿⣟⠐⢾⣿⣧⣤⣾⣿⢣⣿⣾⣽⣧⠻⣿⣦⣬⣾⣿⢃⠎⢿⣿⣤⣥⣿⡿⢡⡈⣄⢸⣿⡏⣿⣿⡳⣿⣿⣬⣭⣭⡍⣿⣿⣿⡇⣿⣿⢠⣶⠀⣾⡇⣿⣿⢆⣌⢿⣿⣬⣥⣾⡿⢂⢻⣿⣆⣢⣿⣿⢱⣿⣿⣿⡘⢿⣷⣬⣥⣿⡿⢣⡱⣿⣿⢀⣾⡖⣿
⢛⣢⡭⣩⢋⡍⢖⢧⠉⡉⣍⢭⢍⡭⡤⣩⡩⡴⣏⢌⡉⢭⣜⣭⣍⢩⣭⣭⣶⣷⣭⣻⣿⣿⣷⣭⣽⣭⣭⡁⠢⢈⢤⢍⣙⢍⢭⢔⠵⡱⣌⢬⠍⡭⣿⣿⣭⣭⣭⣭⣭⣭⣥⣿⣿⣿⣧⣭⣭⣴⡿⠀⡿⢅⠉⠭⣴⣿⣷⣬⣽⣭⣽⣶⢣⣶⣭⣭⣫⣭⣴⣿⣿⣿⣿⠃⡴⣭⣽⣭⣩⣶⣿⣬⣭⡍⣔⣿⢇⣿
⢏⠎⡢⡱⢔⢎⡾⢮⡖⢐⢜⠦⡳⢜⡪⣆⢳⡱⡱⢆⢜⠰⣮⣟⡿⢸⣝⣛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⡀⢮⢢⡑⡬⣣⣛⢜⡕⡳⡜⣬⢃⢗⢸⣿⣿⣿⣿⣿⣿⡿⣿⣿⣿⣿⣿⣿⠟⢋⢙⡄⡳⣀⡁⡲⣄⢭⢐⣉⠻⣿⢿⣧⣾⣿⣿⣿⣿⣿⣿⣿⣿⣿⡏⡰⡨⣿⣿⠗⣼⣟⣾⣻⡞⢦⣹⣿⢸⣿
⠕⡸⡴⣻⢝⢋⢋⠕⡙⣀⣌⡑⣝⢊⣐⣁⠳⣈⣈⣊⣠⣃⣙⢻⣗⡐⣿⣿⠿⢛⣉⣍⣙⡻⢿⣋⣋⣋⣋⣛⣛⠢⡃⣉⣈⣑⣉⣑⣈⢳⢈⣂⣅⣙⣀⡻⢿⡟⣉⣋⠛⣘⣛⣙⣋⣋⣙⡁⠂⡔⢡⠃⠸⣀⣭⣨⣐⡑⠕⠭⡲⣁⣄⣘⠿⠟⠟⣙⣙⣙⣋⣛⡛⠻⢁⣌⣘⣋⣋⣊⠿⣮⣳⡟⡐⣮⣿⢇⣿⣿
⣸⣝⢾⡑⢔⠅⡕⢌⡂⢽⣿⡇⢈⠰⣿⣿⠨⣸⣿⡟⠛⢻⣿⡇⣿⢧⣜⠏⣼⣿⡟⣛⠿⠿⠎⣺⣿⣿⠛⢻⣿⣷⢸⢽⣿⡟⠛⠛⠛⡸⢼⣿⡟⡛⢿⣿⡆⡇⣿⣿⠀⡛⡛⢻⣿⡟⢛⣃⢜⢕⠱⢡⣾⣿⢟⡛⠿⠷⢘⡕⢰⣿⣿⣿⡆⢺⠂⣿⣿⡛⠛⣿⣿⠆⢸⣿⣿⠛⢿⣿⣦⢳⡟⡠⣹⣾⢏⣼⣿⣿
⢧⡻⣎⢆⢕⠌⢊⣤⡅⢾⣿⡇⢨⢐⣿⣿⢀⢺⣿⡿⢿⣿⡟⢁⢿⣝⣿⡆⣿⣿⢈⠫⣓⡻⠿⢺⣿⣿⢿⣿⣟⢣⡾⣹⣿⡿⠿⠿⠟⢼⢸⣿⡇⢌⢸⣿⡧⠐⣿⣿⠀⢎⠀⣹⣿⡇⡣⡕⡕⢭⡊⢸⣿⣯⢈⢟⢒⡛⠧⢃⣾⣿⡀⣿⣿⡰⡇⣿⣿⠿⣿⣿⡋⣼⢸⣿⣿⢸⢅⣿⣿⠘⠄⣾⣿⢋⣼⣿⣿⣿
⡳⣝⢾⠆⣢⣼⣿⣿⣿⡸⣿⣷⣦⣾⣿⠏⡄⣹⣿⡇⢌⢿⣿⣎⠢⣯⢺⠃⠹⣿⣷⣵⣾⡿⢃⢾⣿⣿⢠⠻⣿⣧⡙⣽⣿⣷⣵⣾⣶⢩⢺⣿⣷⣶⣾⡿⢃⢈⣿⣿⠈⠮⡅⢸⣿⡇⢎⠎⡪⠡⡊⢄⢻⣿⣦⣷⣿⡿⠁⣾⣿⠟⠻⠻⣿⣧⠁⣿⣿⡱⡜⣿⣿⡜⢸⣿⣷⣶⣾⣿⠏⣈⢾⡟⣡⣿⣿⣿⣿⣿
⣝⢷⡙⣼⣿⢿⣿⣽⣿⢷⣶⡍⢉⢍⠤⡪⡒⡌⡍⣡⢎⠦⡩⡩⡰⣄⢑⡑⡣⡈⢍⢉⠡⠒⡳⣄⠥⠥⠾⠷⠭⣭⣤⣬⣭⣬⣥⣭⣬⣴⣬⣉⢉⠅⠡⠠⡈⢀⣉⡉⡀⠣⠢⢌⢉⠡⡂⢕⠨⡢⢑⠌⠔⣮⣍⠩⢤⠲⡅⢉⠌⡜⠿⢓⠍⠩⠴⣭⣭⣼⣿⣬⣥⣥⣬⡭⢥⢩⢤⣦⢜⠣⣵⣾⣿⣿⣿⣿⣿⣿
⢞⢵⡃⣿⡽⢫⣥⣵⣥⣮⣰⣑⢠⡊⢎⢎⢜⠜⡔⢕⢕⠕⡕⡜⡢⢎⡄⢫⠰⡈⢢⠁⢎⠨⡂⢵⠀⢘⢖⢔⡄⠈⠛⢿⣿⣿⣿⣿⣿⣿⣿⣿⣦⡝⡊⢖⢥⠄⡱⠠⡈⢕⠑⠔⡡⢑⢌⠢⡑⡬⡪⣣⡑⠘⢷⢽⣌⠣⡈⠢⡰⡨⡪⡢⡹⡰⡡⡈⠻⣿⣿⣿⢯⡷⣽⣶⣿⣿⣿⣷⡹⡝⣿⣿⣿⣿⣿⣿⣿⣿
*/

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define pint pair<int, int>
#define gay MikeKalyzhnyy
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

#ifndef LOCAL
#pragma GCC optimize("unroll-loops,O3")
//#pragma GCC target("avx2")
#endif

inline void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n), a(n + 1), b(n + 1);
    for (auto& el : d) cin >> el;
    for (auto& el : l) cin >> el;
    for (auto& el : r) cin >> el;
    cin >> a[0] >> b[0];
    if (n <= 15) {
        int best = 0;
        for (int mask = 0; mask < (1ll << n); ++mask) {
            fill(1 + all(a), 0);
            fill(1 + all(b), 0);
            for (int i = 0; i < n; ++i) {
                a[i + 1] = a[i] + d[i];
                b[i + 1] = b[i] + d[i];
                if ((mask >> i) & 1) {
                    a[i + 1] = min(a[i + 1], l[i]);
                } else {
                    b[i + 1] = min(b[i + 1], r[i]);
                }
            }
            best = max(best, a.back() + b.back());
        }
        cout << best << endl;
        return;
    }
    d.insert(d.begin(), 0);
    l.insert(d.begin(), 1e9);
    r.insert(d.begin(), 1e9);
    vector<vector<pint>> dp(n + 1, vector<pint>(n + 1));
    dp[0][0] = {a[0], b[0]};
    for (int i = 1; i <= n; ++i) {
        for (int prev = 0; prev < i; ++prev) {
            pint now = {dp[i - 1][prev].first + d[i], min(dp[i - 1][prev].second + d[i], r[i])};
                if (now.first + now.second > dp[i][prev].first + dp[i][prev].second) {
                    dp[i][prev] = now;
            }
        }
        for (int prev = 0; prev < i; ++prev) {
            pint now = {min(dp[i - 1][prev].first + d[i], l[i]), dp[i - 1][prev].second + d[i]};
            if (now.first + now.second > dp[i][i].first + dp[i][i].second) {
                dp[i][i] = now;
            }
        }
    }
    int best = 0;
    for (int prev = 0; prev <= n; ++prev) {
        best = max(best, dp.back()[prev].first + dp.back()[prev].second);
    }
    cout << best << endl;
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
    }
    return 0;
}
