//#pragma GCC optimize("Ofast, inline, unroll-loops")
#include <bits/stdc++.h>


using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

using ll = long long;

const int inf = 2e9 + 2000;
const ll infll = 2e18 + 2000;
const ll modll = 2286661337;
const int R = (1 << 19);

template<typename T>
void sort(T &s) {
    sort(all(s));
}

template<typename T>
void rsort(T &s) {
    sort(rall(s));
}

mt19937 rnd(124);



signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
//    cout << setprecision(20) << fixed;

    int n;
    cin >> n;
    
    vector<ll> d(n), l(n), r(n);
    
    for (auto &i : d) {
        cin >> i;
    }

    for (auto &i : l) {
        cin >> i;
    }

    for (auto &i : r) {
        cin >> i;
    }
    
    ll a0, b0;
    cin >> a0 >> b0;
    
    ll res = 0;
    
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<ll> a, b;
        a.push_back(a0);
        b.push_back(b0);
        
        for (int i = 0; i < n; ++i) {
            a.push_back(a.back() + d[i]);
            b.push_back(b.back() + d[i]);
            
            if (mask & (1 << i)) {
                a.back() = min(a.back(), l[i]);
            } else {
                b.back() = min(b.back(), r[i]);
            }
        }
        
        res = max(res, a.back() + b.back());
    }
    
    cout << res;
}
