#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <queue>
#include <random>

using namespace std;

typedef long long ll;
typedef string str;
typedef long double ld;
mt19937 rnd(157);

#define all(a) a.begin(), a.end()
// #define int long long

const int N = 1e5 + 1;

int d[N], l[N], r[N];
int n;

unordered_map<ll, ll> mem;

ll rec(ll a, ll b, int i) {
    if(i == n) {
        return a + b;
    }
    if(mem.find((i + 1) + (a + 1) * 357 + (b + 1) * 123) != mem.end()) {
        return mem[(i + 1) + (a + 1) * 357 + (b + 1) * 123];
    }
    a += d[i];
    b += d[i];
    ll ans = max(rec(min(a, (ll)l[i]), b, i + 1), rec(a, min(b, (ll)r[i]), i + 1));
    mem[(i + 1) + (a + 1) * 357 + (b + 1) * 123] = ans;
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
//    int n;
    cin >> n;
//    vector<int> d(n);
    for(int i = 0; i < n; i++) {
        cin >> d[i];
    }
 //   vector<int> l(n);
//    vector<int> r(n);
    for(int i = 0; i < n; i++) {
        cin >> l[i];
    }
    for(int i = 0; i < n; i++) {
        cin >> r[i];
    }
    int a, b;
    cin >> a >> b;
    cout << rec(a, b, 0);
}