#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

using ll = long long;
using lll = __int128_t;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using dui = pair<int, int>;
using dul = pair<long, long>;
using vi = vector<int>;
using vll = vector<long long>;
using ld = long double;

constexpr int MX = 2'000'000'000;
constexpr long long MXL = 4'000'000'000'000'000'000;

struct segtree_min {
    vi t;
    int n;

    segtree_min(int _n, vi &a) {
        n = _n;
        t.resize(n * 4);
        build(a, 0, n);
    }

    void build(vi &a, int l, int r, int p = 0) {
        if (l + 1 == r) {
            t[p] = a[l];
            return;
        }
        int m = (r + l) >> 1;
        build(a, l, m, p * 2 + 1);
        build(a, m, r, p * 2 + 2);
    }

    int get(int lx, int rx, int l, int r, int p = 0) {
        if (l >= rx or r <= lx) return MX;
        if (lx <= l and r <= rx) return t[p];
        int m = (r + l) >> 1;
        return min(get(lx, rx, l, m, p * 2 + 1),
                   get(lx, rx, m, r, p * 2 + 2));
    }
};

void solve() {
    int n;
    cin >> n;
    vi d(n), l(n), r(n), pre(n + 1);
    for (auto &i: d) cin >> i;
    for (auto &i: l) cin >> i;
    for (auto &i: r) cin >> i;
    for (int i = 1; i <= n; i++) {
        pre[i] = pre[i - 1] + d[i - 1];
    }
    vector<dui> dp(n + 1);
    int a0, b0;
    cin >> a0 >> b0;
    dp[0] = {a0, b0};
    for (int i = 1; i <= n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            int first;
            first = dp[j].first;
            int first_1 = dp[j].second + pre[i] - pre[j];
            int second;
            second = dp[j].second;
            int second_1 = dp[j].first + pre[i] - pre[j];
            for (int k = j + 1; k <= i; k++) {
                first += d[k - 1];
                second += d[k - 1];
                first = min(first, l[k - 1]);
                second = min(second, r[k - 1]);
            }
            if (first_1 + first > dp[i].first + dp[i].second) {
                dp[i].first = first, dp[i].second = first_1;
            }
            if (second + second_1 > dp[i].first + dp[i].second) {
                dp[i].first = second_1, dp[i].second = second;
            }
        }
    }
    cout << dp[n].first + dp[n].second;
}

int32_t main() {
#ifdef LOCAL
    freopen("inputf.txt", "r", stdin);
    freopen("outputf.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
