#include <bits/stdc++.h>

#define int long long
using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    vector<int> a(n + 1), b(n + 1);
    cin >> a[0] >> b[0];
    for (int i = 1; i < n + 1; ++i) {
        a[i] = a[i - 1] + d[i - 1];
        b[i] = b[i - 1] + d[i - 1];
    }
    vector<int> sufs(n + 1, 0);
    for (int i = n - 1; i >= 0; --i) {
        sufs[i] = sufs[i + 1] + d[i];
    }
    vector<pair<int, int>> z(n);
    for (int i = 0; i < n; ++i) {
        z[i] = {min(a[i + 1], l[i]) + sufs[i + 1], i};
    }
    std::sort(z.rbegin(), z.rend());
    vector<int> prefmn(n + 1, a[n]);
    for (int i = 0; i < n; ++i) {
        prefmn[i + 1] = min(prefmn[i], z[i].first);
    }
    vector<int> sufmn(n + 1, b[n]);
    for (int i = n - 1; i >= 0; --i) {
        sufmn[i] = min(sufmn[i + 1], min(b[z[i].second + 1], r[z[i].second]) + sufs[z[i].second + 1]);
    }
    int ans = 0;
    for (int i = 0; i < n + 1; ++i) {
        ans = max(ans, prefmn[i] + sufmn[i]);
    }
    cout << ans;
}

signed main() {
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}