//#define GLIBCXX_DEBUG
#include <bits/stdc++.h>

#define int long long
#define ld long double
#define F first
#define S second
using namespace std;
const int inf = 1e18;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> d[i + 1];
    }
    vector<int> pref(n + 2);
    for (int i = 0; i < n + 1; ++i) {
        pref[i + 1] = pref[i] + d[i + 1];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i + 1];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i + 1];
    }
    int a0, b0;
    cin >> a0 >> b0;
    l[0] = a0;
    r[0] = b0;
    map<pair<int, int>, int> dp;
    map<pair<int, int>, bool> used;
    dp[{0, 0}] = a0 + b0;
    queue<pair<int, int>> q;
    q.push({0, 0});
    int ans = 0;
    int cnt = 0;
    while (!q.empty() && cnt < 1e6) {
        cnt++;
        auto sost = q.front();
        q.pop();
        if (sost.F == n) {
            ans = max(ans, dp[sost]);
            continue;
        }
        int fir = l[sost.S] + pref[sost.F];
        fir -= pref[sost.S];
        int sec = dp[sost] - fir;
        map<pair<int, int>, int> add;
        if (fir + d[sost.F + 1] <= l[sost.F + 1]) {
            add[{sost.F + 1, sost.S}] = max(add[{sost.F + 1, sost.S}],
                                            sec + fir + d[sost.F + 1] * 2);
        }
        if (sec + d[sost.F + 1] <= r[sost.F + 1]) {
            add[{sost.F + 1, sost.S}] = max(add[{sost.F + 1, sost.S}],
                                            sec + fir + d[sost.F + 1] * 2);
        }
        if (fir + d[sost.F + 1] > l[sost.F + 1]) {
            add[{sost.F + 1, sost.F + 1}] = max(add[{sost.F + 1, sost.F + 1}],
                                                sec + d[sost.F + 1] + l[sost.F + 1]);
        }
        if (sec + d[sost.F + 1] > r[sost.F + 1]) {
            add[{sost.F + 1, sost.S}] = max(add[{sost.F + 1, sost.S}],
                                            fir + d[sost.F + 1] + r[sost.F + 1]);
        }
        for (auto &[k, v]: add) {
            dp[k] = max(dp[k], v);
            if (!used[k]) {
                q.push(k);
                used[k] = 1;
            }
        }
    }
    cout << ans;
    return 0;
}
