#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define int long long

using namespace std;
typedef long long i64;
const i64 inf = 1e18;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> D(n + 1), L(n + 1), R(n + 1);
    vector<int> a(n + 1), b(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> D[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> L[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> R[i];
    }
    i64 res = 0, md = inf;
    cin >> a[0] >> b[0];
    for (int i = 1; i <= n; ++i) {
        a[i] = a[i - 1] + D[i];
        b[i] = b[i - 1] + D[i];
    }
//    for (int msk = 0; msk < (1 << n); ++msk) {
//        i64 mxa = 0, mxb = 0;
//        for (int j = 0; j < n; ++j) {
//            if (msk & (1 << j)) {
//                mxa = max(mxa, a[j + 1] - L[j + 1]);
//            } else {
//                mxb = max(mxb, b[j + 1] - R[j + 1]);
//            }
//        }
//        md = min(md, mxa + mxb);
//    }
//    cout << res - md << '\n';

    vector<pair<int, int>> s;
    for (int i = 1; i <= n; ++i) {
        s.pb({max(0ll, a[i] - L[i]), max(0ll, b[i] - R[i])});
    }
    sort(s.begin(), s.end(), [&] (auto a1, auto a2) {
        return a1.fi < a2.fi;
    });
    int S = (int)s.size();
    vector<int> smax(S + 1, 0);
    for (int i = S - 1; i > -1; --i) {
        smax[i] = max(smax[i + 1], s[i].se);
    }
    md = smax[0];
    for (int i = 0; i < S; ++i) {
        md = min(md, s[i].fi + smax[i + 1]);
    }
    cout << a[n] + b[n] - md << '\n';
}
