#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (ll& x : d) cin >> x;
    for (ll& x : l) cin >> x;
    for (ll& x : r) cin >> x;
    ll a0, b0;
    cin >> a0 >> b0;

    set<pair<ll, ll>> s;
    s.emplace(a0, b0);
    for (int i = 0; i < n; i++) {
        set<pair<ll, ll>> ns;
        for (auto [a, b] : s) {
            ns.emplace(a + d[i], min(b + d[i], r[i]));
            ns.emplace(min(a + d[i], l[i]), b + d[i]);
        }
        s = ns;
    }

    ll mx = 0;
    for (auto [a, b] : s) {
        mx = max(mx, a + b);
    }

    cout << mx;
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) solve();
}