#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;

const ll OO = 1e18;

void solve() {
    int n;
    cin >> n;
    vec<int> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> l[i];
    }

    vec<pii> lr(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> r[i];
        lr[i] = {l[i], r[i]};
    }
    int a0, b0;
    cin >> a0 >> b0;

    sort(1 + all(lr));
    reverse(1 + all(lr));
    multiset<int> rs;
    for (int i = 1; i <= n; i++) {
        rs.insert(lr[i].s);
    }

    int ans = a0 + min(b0, *rs.begin());
    for (int minl = 1; minl <= n; minl++) {
        int ptr = minl;
        while (ptr <= n && lr[ptr].f == lr[minl].f) {
            rs.erase(rs.find(lr[ptr].s));
            ptr++;
        }

        ans = max(ans, min(a0, lr[minl].f) + min(b0, (!rs.empty() ? *rs.begin() : OO)));

        minl = ptr - 1;
    }

    cout << ans;

    /*
    vec<int> a(n + 1), b(n + 1);

    a[0] = a0;
    b[0] = b0;
    for (int i = 1; i <= n; i++) {
        a[i] = a[i - 1] + d[i];
        b[i] = b[i - 1] + d[i];

        if (a[i] - min(a[i], l[i]) < b[i] - min(b[i], r[i])) {
            a[i] = min(a[i], l[i]);
        } else {
            b[i] = min(b[i], r[i]);
        }
    }

    cout << a[n] + b[n];
    */
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
