﻿#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    
    int n;
    cin >> n;
    ll a0, b0;
    vector<ll> d(n), l(n), r(n), pr(n+1);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
        pr[i + 1] = pr[i] + d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    cin >> a0 >> b0;
    vector<pair<ll, ll>> ab;
    for (int i = 0; i < n; ++i) {
        ab.push_back({l[i] + pr[n] - pr[i+1], r[i] + pr[n] - pr[i+1] });
    }
    sort(ab.rbegin(), ab.rend());
    multiset<ll> sa, sb;
    sa.insert(pr[n] + a0);
    sb.insert(pr[n] + b0);
    for (int i = 0; i < n; ++i) {
        sb.insert(ab[i].second);
    }
    ll res = *sa.begin() + *sb.begin();
    for (int i = 0; i < n; ++i) {
        sa.insert(ab[i].first);
        sb.erase(sb.find(ab[i].second));
        res = max(res, *sa.begin() + *sb.begin());
    }
    cout << res;
    return 0;
}