#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <algorithm>
#include <map>
using namespace std;
using ll = long long;
const ll INF = 1e9;

void solve() {
	int n;
	cin >> n;
	vector<ll>d(n + 1), l(n + 1), r(n + 1);
	for (int i = 1; i <= n; ++i) {
		cin >> d[i];
	}
	for (int i = 1; i <= n; ++i) {
		cin >> l[i];
	}
	for (int i = 1; i <= n; ++i) {
		cin >> r[i];
	}
	ll a0, b0;
	cin >> a0 >> b0;

	for (int i = 1; i <= n; ++i) {
		a0 += d[i];
		b0 += d[i];
		//cout << a0 << ' ' << b0 << "\n";
		if (l[i] >= a0 || r[i] >= b0) continue;
		if (l[i] + b0 > r[i] + a0) {
			a0 = l[i];
		}
		else b0 = r[i];
		//cout << a0 << ' ' << b0 << "\n";
	}
	cout << a0 + b0;
	/*
	ll ans = 0;
	for (int i = 0; i < (1 << n); ++i) {
		ll a = a0, b = b0;
		for (int j = 0; j < n; ++j) {
			a += d[j + 1];
			b += d[j + 1];
			if ((i >> j) & 1) {
				a = min(a, l[j + 1]);
			}
			else {
				b = min(b, r[j + 1]);
			}
		}
		ans = max(ans, a + b);
	}
	cout << ans << "\n";*/
}

int main() {
	ll t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}


}