#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <algorithm>
#include <map>
using namespace std;
using ll = long long;
const ll INF = 1e9;

void solve() {
	int n;
	cin >> n;
	vector<ll>d(n + 1), l(n + 1), r(n + 1);
	for (int i = 1; i <= n; ++i) {
		cin >> d[i];
	}
	for (int i = 1; i <= n; ++i) {
		cin >> l[i];
	}
	for (int i = 1; i <= n; ++i) {
		cin >> r[i];
	}
	ll a0, b0;
	cin >> a0 >> b0;
	l[0] = a0;
	r[0] = b0;
	vector<pair<ll, ll>>c(n + 1);
	vector<ll>sum(n + 1);
	sum[0] = a0 + b0;
	c[0] = { a0, b0 };
	for (int i = 1; i <= n; ++i) {
		ll b = r[i];
		for (int j = i - 1; j >= 0; --j) {
			auto [A, B] = c[j];
			b = min(B, b);
			b = min(b, r[j]);
			if (b + A > sum[i]) {
				sum[i] = b + A;
				c[i] = { A, b };
				//cout << j<<" B\n";
			}

		}
		ll a = l[i];
		for (int j = i - 1; j >= 0; --j) {
			auto [A, B] = c[j];
			a = min(l[j], a);
			a = min(A, a);
			if (a + B > sum[i]) {
				sum[i] = a + B;
				c[i] = { a, B };
				//cout << j<<" A\n";
			}

		}
	}
	//for (auto x : c) cout << x.first<<' '<<x.second<<"\n" << " "; cout << "\n";
	cout << sum[n] << "\n";
	
	/*
	ll ans = 0;
	for (int i = 0; i < (1 << n); ++i) {
		ll a = a0, b = b0;
		for (int j = 0; j < n; ++j) {
			a += d[j + 1];
			b += d[j + 1];
			if ((i >> j) & 1) {
				a = min(a, l[j + 1]);
			}
			else {
				b = min(b, r[j + 1]);
			}
		}
		ans = max(ans, a + b);
	}
	cout << ans << "\n";*/
}

int main() {
	ll t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}


}