#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n;
    cin >> n;
    
    vector<ll> d(n), l(n), r(n);
    for (auto &i : d) cin >> i;
    for (auto &i : l) cin >> i;
    for (auto &i : r) cin >> i;
    
    ll pref = 0;
    for (int i = 0; i < n; i++) {
        pref += d[i];
        l[i] -= pref;
        r[i] -= pref;
    }
    
    ll a, b;
    cin >> a >> b;
    
    ll ans = max(a + min(b, *min_element(r.begin(), r.end())),
                 b + min(a, *min_element(l.begin(), l.end())));
    vector<pair<ll, int>> seg;
    for (int i = 0; i < n; i++) {
        seg.emplace_back(l[i], i);
    }
    sort(seg.begin(), seg.end());
    int j = 0;
    for (int i = 0; i < n; i++) {
        if (i > 0) {
            while (j < n && seg[j].first < seg[i].first) {
                b = min(b, r[seg[j++].second]);
            }
        }
        ans = max(ans, min(a, seg[i].first) + b);
    }
    cout << ans + 2ll * accumulate(d.begin(), d.end(), 0ll) << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    
    return 0;
}