#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int32_t main() {
#ifdef LOCAL
    freopen("D:\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    cin >> d >> l >> r;
    int a0, b0;
    cin >> a0 >> b0;
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> a(n), b(n);
        a[0] = a0;
        b[0] = b0;
        for (int i = 1; i < n; ++i) {
            a[i] = a[i - 1] + d[i];
            b[i] = b[i - 1] + d[i];
            if ((mask >> i) & 1) {
                a[i] = min(a[i], l[i]);
            } else {
                b[i] = min(b[i], r[i]);
            }
        }
        ans = max(ans, a[n - 1] + b[n - 1]);
    }
    cout << ans << "\n";
    return 0;
}