#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int32_t main() {
#ifdef LOCAL
    freopen("D:\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    cin >> d >> l >> r;
    ll a0, b0;
    cin >> a0 >> b0;
    if (all_of(d.begin(), d.end(), [](int x) { return x == 0; })) {
        vector<vector<pair<ll, ll>>> dp(n + 1, vector<pair<ll, ll>>(2));
        dp[0][0] = {a0, b0};
        dp[0][1] = {a0, b0};
        for (int i = 1; i <= n; ++i) {
            dp[i][0] = {min(max(dp[i - 1][0].first, dp[i - 1][1].first), l[i - 1]),
                        max(dp[i - 1][0].second, dp[i - 1][1].second)};
            dp[i][1] = {max(dp[i - 1][0].first, dp[i - 1][1].first),
                        min(max(dp[i - 1][0].second, dp[i - 1][1].second), r[i - 1])};
        }
        cout << max(dp[n][0].first + dp[n][0].second, dp[n][1].first + dp[n][1].second) << "\n";
        return 0;
    }
    ll ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<ll> a(n + 1), b(n + 1);
        a[0] = a0, b[0] = b0;
        for (int i = 1; i <= n; ++i) {
            if ((mask >> (i - 1)) & 1) {
                a[i] = min(a[i - 1] + d[i - 1], l[i - 1]);
                b[i] = b[i - 1] + d[i - 1];
            } else {
                a[i] = a[i - 1] + d[i - 1];
                b[i] = min(b[i - 1] + d[i - 1], r[i - 1]);
            }
        }
        ans = max(ans, a[n] + b[n]);
    }
    cout << ans << "\n";
    return 0;
}