//#pragma GCC optimize("03,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 0; i < n; i++) {
        std::cin >> d[i + 1];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> l[i + 1];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> r[i + 1];
    }
    i64 a, b;
    std::cin >> a >> b;
    l[0] = (int) a;
    r[0] = (int) b;
    std::vector<std::set<std::pair<i64, i64>>> dp(n + 1);
    std::vector<i64> max(n + 1, 0);
    auto add = [&](int i, i64 x, i64 y) {
        if (int(dp[i].size()) >= 2000) {
            if (x + y >= max[i]) {
                dp[i].insert(std::make_pair(x, -y));
                max[i] = x + y;
            }
            return;
        }
        max[i] = std::max(max[i], x + y);
        dp[i].insert(std::make_pair(x, -y));
        auto it = dp[i].lower_bound(std::make_pair(x, -y));
        if (it != dp[i].begin()) {
            auto it_ = it;
            --it_;
            auto [x_, y_] = *it_;
            y_ = -y_;
            if (x_ == x && y_ > y) {
                dp[i].erase(std::make_pair(x, y));
                return;
            }
        }
        auto itl = it;
        ++itl;
        std::vector<std::pair<i64, i64>> g;
        for (; itl != dp[i].end(); ++itl) {
            auto [x_, y_] = *itl;
            y_ = -y_;
            if (x != x_) {
                break;
            }
            g.emplace_back(x_, -y_);
        }
        auto itr = it;
        if (itr != dp[i].begin()) {
            while (true) {
                if (itr == dp[i].begin()) {
                    break;
                }
                --itr;
                auto [x_, y_] = *itr;
                y_ = -y_;
                if (x_ <= x && y_ < y) {
                    g.emplace_back(x_, -y_);
                } else {
                    break;
                }
            }
        }
        for (auto [x_, y_] : g) {
            dp[i].erase(std::make_pair(x_, y_));
        }
    };
    add(0, a, b);
    for (int i = 0; i < n; i++) {
        for (auto [x, y] : dp[i]) {
            if (rand() % 2) {
                add(i + 1, std::min(x + d[i + 1], (i64) l[i + 1]), -y + d[i + 1]);
                add(i + 1, x + d[i + 1], std::min(-y + d[i + 1], (i64) r[i + 1]));
            } else {
                add(i + 1, x + d[i + 1], std::min(-y + d[i + 1], (i64) r[i + 1]));
                add(i + 1, std::min(x + d[i + 1], (i64) l[i + 1]), -y + d[i + 1]);
            }
        }
    }
    i64 res = 0;
    for (auto [x, y] : dp[n]) {
        res = std::max(res, x - y);
    }
    std::cout << res << "\n";
}

signed main() {
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);

    int t = 1;
//    std::cin >> t;

    while (t--) {
        solve();
    }
}