#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx,avx2")

#include <bits/stdc++.h>
using namespace std;

#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n; i++) cin >> d[i];
    for (int i = 0; i < n; i++) cin >> l[i];
    for (int i = 0; i < n; i++) cin >> r[i];
    int a0, b0;
    cin >> a0 >> b0;

    bool fl = true;
    for (int i : d) if (i) {fl = false; break;}

    if (fl) {
        int ans = 0;
        vector<pair<int, int>> p;
        for (int i = 0; i < n; i++) {
            p.emplace_back(l[i], r[i]);
        }
        
        sort(p.begin(), p.end());
        ans = min(a0, p[0].first) + b0;
        int minb = p[0].second;
        for (int i = 0; i < n-1; i++) {
            minb = min(minb, p[i].second);
            ans = max(ans, min(a0, p[i+1].first) + min(b0, minb));
        }
        ans = max(ans, a0 + min(b0, minb));
        cout << ans;
        return;
    }

    vector<int> prefd(n+1);
    for (int i = 1; i <= n; i++) {
        prefd[i] = prefd[i-1] + d[i-1];
    }

    int ans = 0;

    for (int lst = 0; lst < n; lst++) {
        int a = a0, b = b0;
        for (int i = 0; i < n; i++) {
            a += d[i];
            b += d[i];
            if (min(b, r[i]) == b)
                b = min(b, r[i]);
            else if (min(a, l[i]) == a)
                a = min(a, l[i]);
            else if (i <= lst && l[i] + prefd[lst+1] - prefd[i] >= l[lst])
                a = min(a, l[i]);
            else
                b = min(b, r[i]); 
        }

        ans = max(ans, a + b);
    }
    int a = a0, b = b0;
    for (int i = 0; i < n; i++) {
        a += d[i];
        b += d[i];
        b = min(b, r[i]);
    }
    ans = max(ans, a + b);
    cout << ans;
}

signed main() {
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve(), cout << '\n';
}