#include <bits/stdc++.h>
using namespace std;
using ll = long long;

map<tuple<ll, ll, ll>, ll> answers;
map<tuple<ll, ll, ll>, int> side;
vector<ll> d;
vector<ll> l;
vector<ll> r;
int n;

ll f(ll a, ll b, ll i) {
	if (i == n) return a + b;
	if (answers.find({a, b, i}) != answers.end()) return answers[{a, b, i}];
	ll na = a + d[i];
	ll nb = b + d[i];
	if (na <= l[i]) answers[{a, b, i}] = f(na, nb, i+1), side[{a, b, i}] = -1;
	else if (nb <= r[i]) answers[{a, b, i}] = f(na, nb, i+1), side[{a, b, i}] = 1;
	else {
		ll ans1 = f(l[i], nb, i+1);
		ll ans2 = f(na, r[i], i+1);
		if (ans1 < ans2) {
			answers[{a, b, i}] = ans2;
			side[{a, b, i}] = 1;
		}
		else {
			answers[{a, b, i}] = ans1;
			side[{a, b, i}] = -1;
		}
	}
	return answers[{a, b, i}];
}

int main() {
	cin >> n;
	d.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> d[i];
		if (i != 0) d[i] += d[i-1];
	}
	l.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i];
		l[i] -= d[i];
	}
	r.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> r[i];
		r[i] -= d[i];
	}
	ll sum = d[n-1];
	for (int i = 0; i < n; i++) {
		d[i] = 0;
	}
	ll a, b;
	cin >> a >> b;
	bool found_answer = false;
	ll ans = -1e9;
	for (int k = 0; k < 2; k++) {
		vector<pair<ll, ll>> mins(n);
		for (int i = 0; i < n; i++) {
			mins[i] = {l[i], r[i]};
		}
		sort(mins.begin(), mins.end());
		vector<ll> prefs(1+n);
		prefs[0] = 1e9 + 1;
		for (int i = 1; i <= n; i++) {
			prefs[i] = min(prefs[i-1], mins[i-1].second);
		}
		if (!found_answer) {
			ans = a + min(prefs[n], b);
			found_answer = true;
		}
		ans = max(ans, a + min(prefs[n], b));
		for (int i = n-1; i >= 0; i--) {
			ans = max(ans, min(a, mins[i].first) + min(prefs[i], b));
		}
		swap(a, b);
		swap(l, r);
	}
	cout << ans + sum + sum << "\n";
}