#include <iostream>
#include <chrono>

#define maxn 200005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;

using namespace std;


int n;
long long l[maxn] , r[maxn] , d[maxn];
pair <long long , long long> dp[maxn][2];

long long a, b;

void read()
{
    cin >> n;

    for(int i = 1; i <= n; i++)
        cin >> d[i];

    for(int i = 1; i <= n; i++)
        cin >> l[i];

    for(int i = 1; i <= n; i++)
        cin >> r[i];

    cin >> a >> b;


}

void calc_dp()
{
    dp[0][0] = dp[0][1] = {a , b};

    for(int i = 1; i <= n; i++)
    {
        if(min(dp[i - 1][0].X + d[i] , l[i]) + dp[i - 1][0].Y + d[i] > min(dp[i - 1][1].X + d[i] , r[i]) + dp[i - 1][1].Y + d[i])
            dp[i][0] = {min(dp[i - 1][0].X + d[i] , l[i]) , dp[i - 1][0].Y + d[i]};
        else
            dp[i][0] = {min(dp[i - 1][1].X + d[i] , l[i]) , dp[i - 1][1].Y + d[i]};

        if(dp[i - 1][0].X + d[i] + min(dp[i - 1][0].Y + d[i] , r[i]) > dp[i - 1][1].X + d[i] + min(dp[i - 1][1].Y + d[i] , r[i]))
            dp[i][1] = {dp[i - 1][0].X + d[i] , min(dp[i - 1][0].Y + d[i] , r[i])};
        else
            dp[i][1] = {dp[i - 1][1].X + d[i] , min(dp[i - 1][1].Y + d[i] , r[i])};
    }

    cout << max(dp[n][0].X + dp[n][0].Y , dp[n][1].X + dp[n][1].Y) << endl;

}




int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);


    read();
    calc_dp();




    return 0;
}
