#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <random>
#include <chrono>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

const int inf = 1e9;
const int N = 100;
int matr[N][N];

inline void solve() {
	int n, dmax, group;
	cin >> n >> dmax >> group;
	vector<int> a(n);
	vector<int> ord(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
		ord[a[i]] = i;
	}
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			matr[i][j] = inf;
	for (int val = 0; val < n; val++) {
		int i = ord[val];
		int timer = dmax;
		int j = i;
		while (j < n - 1) {
			j++;
			timer--;
			if (a[j] < val)
				timer = dmax;
			else
				matr[i][j] = 1;
			if (!timer)
				break;
		}
	}
	for (int i = 0; i < n; i++)
		matr[i][i] = 0;
	for (int k = 0; k < n; k++)
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				matr[i][j] = min(matr[i][j], matr[i][k] + matr[k][j]);
	int q;
	cin >> q;
	while (q--) {
		int t, v, u;
		cin >> t >> v >> u;
		v--;
		u--;
		if (matr[v][u] == inf) {
			cout << 0 << '\n';
			continue;
		}
		if (t == 1)
			cout << 1 << '\n';
		else
			cout << matr[v][u] << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef DEBUG
	cin >> tt;
#endif
	while (tt--) {
#ifdef DEBUG
		cout << "Testcase#\n";
#endif
		solve();
	}
	return 0;
}
