#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, d, gr; cin >> n >> d >> gr;

    vector <int> a(n);
    for (auto &x : a) cin >> x;

    vector <vector <int>> g(n);
    for (int i = 0; i < n; i++) {
        int last = i;
        for (int j = i + 1; j < n; j++) {
            if (a[j] > a[i] && j - last <= d) g[i].push_back(j);
            if (j - last > d) break;
            if (a[j] < a[i]) last = j;
        }
    }

    vector <vector <int>> dist(n, vector <int> (n, -1));

    for (int i = 0; i < n; i++) {
        dist[i][i] = 0;
        queue <int> q;
        q.push(i);
        while (!q.empty()) {
            int v = q.front(); q.pop();
            for (auto to : g[v]) {
                if (dist[i][to] == -1) {
                    dist[i][to] = dist[i][v] + 1;
                    q.push(to);
                }
            }
        }
    }

    int q; cin >> q;
    while (q--) {
        int t, u, v; cin >> t >> u >> v, u--, v--;
        if (t == 1) {
            cout << (dist[u][v] == -1 ? 0 : 1) << "\n";
        } else {
            if (dist[u][v] == -1) cout << 0 << "\n";
            else cout << dist[u][v] << "\n";
        }
    }

    return 0;
}
