#include <bits/stdc++.h>

using namespace std;
#define pb push_back
#define ll long long
//#define int ll
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int maxn = 3e5 + 10;

int n, d, G, a[maxn], rgh[maxn];
pii tree[maxn * 4];

void build(int tind, int l, int r) {
    if(r - l == 1) {
        tree[tind] = {a[l], l};
        return;
    }
    int m = (r + l) >> 1;
    build(tind * 2 + 1, l, m);
    build(tind * 2 + 2, m, r);
    tree[tind] = min(tree[tind * 2 + 1], tree[tind * 2 + 2]);
}

pii get(int tind, int l, int r, int ql, int qr) {
    if(ql <= l && r <= qr) return tree[tind];
    if(ql >= r || l >= qr) return {INF, INF};
    int m = (r + l) >> 1;
    return min(get(tind * 2 + 1, l, m, ql, qr), get(tind * 2 + 2, m, r, ql, qr));
}

void solve() {
    cin >> n >> d >> G;
    for(int i = 0; i < n; ++i) cin >> a[i];
    for(int i = 0; i < n; ++i) {
        int x = i;
        int lst = i;
        while(x < n - 1) {
            if(x - lst > d) break;
            if(a[x] < a[i]) lst = x;
            ++x;
        }
        rgh[i] = lst;
    }
    int q;
    cin >> q;
    while(q--) {
        int t, i, j;
        cin >> t >> i >> j;
        --i, --j;
        if(a[j] < a[i]) {
            cout << 0 << '\n';
        } else {
            int ans = 0;
            int x = i;
            while(x < j) {
                if(rgh[x] + d >= j) {
                    ++ans;
                    break;
                } else {
                    int x1 = x;
                    for(int k = x + 1; k <= rgh[x] + d; ++k) {
                        if(a[k] > a[x] && a[k] < a[j]) {
                            if(x1 == x || a[k] > a[x1]) {
                                x1 = k;
                            }
                        }
                    }
                    if(x1 == x) {
                        ans = 0;
                        break;
                    } else {
                        ++ans;
                        x = x1;
                    }
                }
            }
            if(t == 1) cout << (ans == 0 ? 0 : 1) << '\n';
            else cout << ans << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}
