#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 2e5 + 10;
const int INF = 1e9;
const int mod = 1e9 + 7;



int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<vector<int>> ans(n, vector<int>(n, INF));
    for (int i = 0; i < n; i++) {
        int last = i;
        int j = i;
        for (int j = i + 1; j < n; j++) {
            if (j - last > d) {
                break;
            }
            if (a[j] < a[i]) {
                last = j;
            }
            if (a[j] > a[i]) {
                ans[i][j] = 1;
            }
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = i + 1; j < n; j++) {
            for (int w = j + 1; w < n; w++) {
                ans[i][w] = min(ans[i][w], ans[i][j] + ans[j][w]);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        u--, v--;
        if (t == 1) {
            if (ans[u][v] != INF) {
                cout << 1 << '\n';
            }
            else {
                cout << 0 << '\n';
            }
        }
        else {
            if (ans[u][v] != INF) {
                cout << ans[u][v] << '\n';
            }
            else {
                cout << 0 << '\n';
            }
        }
    }
}
