#include <bits/stdc++.h>

#define int long long
using namespace std;

void solve() {
    int n, d, gr;
    cin >> n >> d >> gr;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<int>> g(n);
    int pr;
    for (int i = 0; i < n; ++i) {
        pr = i;
        for (int j = i + 1; j < min(pr + d + 1, n); ++j) {
            if (a[i] < a[j]) {
                g[i].push_back(j);
            } else if (a[j] < a[i]) {
                pr = j;
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int t, s, f;
        cin >> t >> s >> f;
        --s, --f;
        int res = -1;
        queue<pair<int, int>> que;
        que.emplace(s, 0);
        while (!que.empty()) {
            auto [v, dist] = que.front();
            que.pop();
            if (v == f) {
                res = dist;
                break;
            }
            for (auto u: g[v]) {
                que.emplace(u, dist + 1);
            }
        }
        if (res == -1) {
            cout << 0 << " ";
        } else if (t == 1) {
            cout << 1 << " ";
        } else {
            cout << res << " ";
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

