#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    int a[n];
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    vector<int> gr[n];
    for (int i = 0; i < n; ++i) {
        vector<bool> can(n);
        can[i] = true;
        vector<int> query = {i};
        int uk = 0;
        vector<int> dist(n, INF);
        dist[i] = 0;
        while (uk < (int)query.size()) {
            int ver = query[uk];
            for (int j = ver + 1; j <= ver + d && j < n; ++j) {
                if (dist[j] > dist[ver] + 1 && a[j] < a[i]) {
                    query.emplace_back(j);
                    dist[j] = dist[ver] + 1;
                }
            }
            ++uk;
        }
        for (int j = i; j < n; ++j) {
            for (int to = j + 1; to < n && to <= j + d; ++to) {
                if (dist[j] != INF && a[to] > a[j]) {
                    gr[i].emplace_back(to);
                }
            }
        }
    }
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        u--, v--;
        vector<int> dist(n, INF);
        dist[u] = 0;
        vector<int> query = {u};
        int uk = 0;
        while (uk < (int)query.size()) {
            int ver = query[uk];
            for (int nxt : gr[ver]) {
                if (dist[nxt] > dist[ver] + 1) {
                    dist[nxt] = dist[ver] + 1;
                    query.emplace_back(nxt);
                }
            }
            ++uk;
        }
        if (dist[v] == INF) {
            cout << 0 << '\n';
        } else {
            cout << (t == 1 ? 1 : dist[v]) << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
