#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <deque>
#include <queue>

typedef long long ll;

using namespace std;

int main(){
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    ll n, d, g;
    cin >> n >> d >> g;
    vector <ll> a(n), b(n);
    for(int i = 0; i < n; i++){
       cin >> a[i];
       b[a[i] - 1] = i;
    } 
    ll q;
    cin >> q;
    if(n <= 1000){
        vector <vector <ll>> ans(n, vector <ll> (n, 1e18));
        for(int i = 0; i < n; i++){
            int prev = -1, pos = i, last = i + 1;
            while(pos != prev){
                for(int j = last; j < n && j <= pos + d; j++){
                    if(a[j] > a[i]) ans[i][j] = 1;
                    else pos = j;
                }
                last = pos + d + 1, prev = pos;
            }
        }
        for(int i = 0; i < n; i++){
            for(int j = i + 1; j < n; j++){
                for(int k = i + 1; k < j; k++){
                    ans[i][j] = min(ans[i][j], ans[i][k] + ans[k][j]);
                }
            }
        }
        for(int i = 0; i < q; i++){
            ll t, v, u;
            cin >> t >> v >> u;
            if(ans[v - 1][u - 1] == 1e18){
                cout << 0 << "\n";
            }
            else if(t == 1){
                cout << 1 << "\n";
            }
            else{
                cout << ans[v - 1][u - 1] << "\n";
            }
        }
    }
    else{
        int t, v, u, cnt = 0;
        cin >> t >> v >> u;
        v--, u--;
        ll pos = v, mx = a[v];
        if(a[v] > a[u]){
            cout << 0 << "\n";
            return 0;
        }
        while(pos < u){
            ll curm = mx, prev = pos;
            for(int i = pos; i <= pos + d && i < n; i++){
                if(a[i] < mx) pos = i;
                else curm = max(curm, a[i]);
            }
            if(pos == prev && pos + d < u){
                cout << 0 << "\n";
                return 0;
            }
            cnt++, mx = curm, pos += d;
        }
        cout << (t == 2 ? cnt : 1) << "\n";
        /*vector <vector <int>> gr(n);
        for(int i = 0; i < n; i++){
            int prev = -1, pos = i, last = i + 1;
            while(pos != prev){
                for(int j = last; j < n && j <= pos + d; j++){
                    if(a[j] > a[i]) gr[j].push_back(i);
                    else pos = j;
                }
                last = pos + d + 1, prev = pos;
            }
        }
        vector <int> dist(n, 1e9);
        dist[n - 1] = 0;
        queue <int> qu;
        qu.push(n - 1);
        while(!qu.empty()){
            int v = qu.front();
            qu.pop();
            for(int i = 0; i < gr[v].size(); i++){
                if(dist[gr[v][i]] == 1e9){
                    qu.push(gr[v][i]), dist[gr[v][i]] = dist[v] + 1;
                }
            }
        }
        for(int i = 0; i < n; i++){
            ll t, v, u;
            cin >> t >> v >> u;
            if(dist[v - 1] == 1e9){
                cout << 0 << "\n";
            }
            else if(t == 1){
                cout << 1 << "\n";
            }
            else{
                cout << dist[v] << "\n";
            }
        }*/
    }
}