#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int>> get_segms(int n, int d, vector<int> a) {
    vector<pair<int, int>> ans(n), ord(n);
    for (int i = 0; i < n; ++i) {
        ord[i] = {a[i], i};
    }
    sort(ord.begin(), ord.end());
    set<int> pos, pos2;
    pos2.insert(n);
    for (auto [vl, ind] : ord) {
        auto it = pos.lower_bound(ind);
        if (it != pos.begin()) {
            it--;
            if (ind - *it <= d && pos2.count(*it)) {
                pos2.erase(*it);
            }
            it++;
        }
        if (it == pos.end() || *it - ind > d) {
            pos2.insert(ind);
        }
        pos.insert(ind);
        ans[ind].first = ind + 1;
        ans[ind].second = min(n, *pos2.lower_bound(ind) + d + 1);
    }
    return ans;
}

vector<int> get_dist(int n, int d, vector<int> a, int v) {
    vector<int> ans(n, n);
    auto segms = get_segms(n, d, a);
    vector<pair<int, int>> ord(n);
    for (int i = 0; i < n; ++i) {
        ord[i] = {a[i], i};
    }
    sort(ord.rbegin(), ord.rend());
    for (auto [vl, ind] : ord) {
        if (ind == v) {
            ans[ind] = 0;
        }
        for (int i = segms[ind].first; i < segms[ind].second; ++i) {
            ans[ind] = min(ans[ind], ans[i] + 1);
        }
    }
    return ans;
}

void solve() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }
    // auto segms = get_segms(n, d, a);
    // for (int i = 0; i < n; ++i) {
    //     cout << segms[i].first << ' ' << segms[i].second << '\n';
    // }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        u--, v--;
        auto ans = get_dist(n, d, a, v);
        if (ans[u] == n) {
            cout << 0 << '\n';
        } else if (t == 1) {
            cout << 1 << '\n';
        } else {
            cout << ans[u] << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
