#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 7;

int main() {
    ios::sync_with_stdio();
    cin.tie();
    cout.tie();
    int n, d, group; cin >> n >> d >> group;
    vector <int> a(n);
    for (int i=0; i < n; ++i) {
        cin >> a[i];
    }
    vector <vector <int>> dp(n, vector <int> (n));
    for (int i=0; i < n; ++i) {
        deque <pair <int, int>> window;
        window.push_back({0, i});
        for (int j=i+1; j < n; ++j) {
            dp[i][j] = window.front().first + 1;
            if (window.front().second + d == j) {
                window.pop_front();
            }
            int to_add = dp[i][j];
            if (a[j] >= a[i]) {
                to_add = INF;
            }
            while (!window.empty() && window.back().first >= to_add) {
                window.pop_back();
            }
            window.push_back({to_add, j});
        }
    }
    int q; cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        if (a[u-1] >= a[v-1] || dp[u-1][v-1] >= INF) {
            cout << "0\n";
        } else {
            if (t == 1) {
                cout << t << "\n";
            } else {
                cout << dp[u-1][v-1] << "\n";
            }
        }
    }
    return 0;
}
