#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
istream& operator >>(istream& in, pair<T, T1> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T, typename T1>
ostream& operator <<(ostream& out, pair<T, T1> &arr) {
    for (auto i : arr) out << i << " ";
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<T> &arr) {
    for (auto i : arr) out << i << " ";
    return out;
}

void solve() {
    int n, d, gr; cin >> n >> d >> gr;
    vector<int> s(n); cin >> s;


    if (gr <= 2) {
        vector<vector<int>> g(n, vector<int>(n, 1e9));
        for (int i = n - 1; i > -1; i--) {
            set<int> trn;

            trn.insert(i);
            for (int j = i + 1; j < n; j++) {
                while (sz(trn) > 0 && *trn.begin() + d < j) {
                    trn.erase(trn.begin());
                }

                if (sz(trn) == 0) break;

                if (s[j] > s[i]) {
                    g[i][j] = 1;

                    for (int k = j + 1; k < n; k++) {
                        if (g[j][k] != (int)1e9) g[i][k] = min(g[i][k], g[i][j] + g[j][k]);
                    }
                } else {
                    trn.insert(j);
                }
            }
        }

        int q; cin >> q;
        while (q--) {
            int t, a, b; cin >> t >> a >> b;
            a--; b--;

            if (g[a][b] == (int)1e9) cout << "0\n";
            else if (t == 1) cout << "1\n";
            else cout << g[a][b] << "\n";
        }
    }
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double time = clock();
#endif

    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "---------------\n";
#endif
    }
#ifdef LOCAL
    cout << "time:" << (clock() - time) / CLOCKS_PER_SEC << "\n";
#endif
}