#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...) 52
#endif

using ll = long long;
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, d, G;
    cin >> n >> d >> G;

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<vector<int>> g(n);

    for (int i = 0; i < n; i++) {
        vector<int> t = {0};
        for (int j = 0; j < n; j++) {
            if (j - t.back() > d) {
                break;
            }

            if (a[j] > a[i]) {
                g[i].push_back(j);
            } else {
                t.push_back(j);
            }
        }
    }

    vector<vector<int>> dist(n, vector<int>(n, -1));

    for (int s = 0; s < n; s++) {
        auto &D = dist[s];
        D[s] = 0;
        vector<int> bfs = {s};
        for (int i = 0; i < (int)bfs.size(); i++) {
            int u = bfs[i];

            for (int v : g[u]) {
                if (D[v] == -1) {
                    D[v] = D[u] + 1;
                    bfs.push_back(v);
                }
            }
        }
    }

    int q;
    cin >> q;

    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        u--, v--;

        if (t == 1) {
            if (dist[u][v] == -1) {
                cout << 0 << '\n';
            } else {
                cout << 1 << '\n';
            }
        } else {
            if (dist[u][v] == -1) {
                cout << 0 << '\n';
            } else {
                cout << dist[u][v] << '\n';
            }
        }
    }
    return 0;
}
