#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = 1e18;

mt19937_64 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

struct Fast {

    void solve() {
        ll n, d, g;
        cin >> n >> d >> g;
        vector<ll> a(n);
        for (auto &i: a) cin >> i;
        vector<ll> mx(n);
        for (int i = 0; i < n; i++) {
            ll last = i;
            for (int pos = i + 1; pos < n; pos++) {
                if (a[pos] < a[i]) {
                    if (pos - last <= d) {
                        last = pos;
                    } else {
                        break;
                    }
                }
            }
            mx[i] = min(n - 1, last + d);
        }
        ll q;
        cin >> q;
        while (q--) {
            ll t, u, v;
            cin >> t >> u >> v, u--, v--;
            if (a[u] > a[v] || u > v) {
                cout << 0 << '\n';
                continue;
            }
            ll cnt = 0;
            ll curr_mx = mx[u];
            ll l = u;
            ll pos = u;
            while (v - curr_mx > d) {
                ll nx_mx = pos;
                for (; l <= curr_mx; l++) {
                    if (a[l] > a[pos] && a[l] < a[v]) {
                        if (mx[l] > mx[nx_mx]) {
                            nx_mx = l;
                        }
                    }
                }
                if (nx_mx == pos) {
                    break;
                }
                pos = nx_mx;
                curr_mx = mx[pos];
                cnt++;
            }
            if (v - curr_mx <= d) {
                if (t == 1) {
                    cout << 1 << '\n';
                } else {
                    if (v - pos <= d) {
                        cout << cnt + 1 << '\n';
                    } else {
                        cout << cnt + 2 << '\n';
                    }
                }
            } else {
                cout << 0 << '\n';
            }
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll times = 1;
    bool stres = false;
    if (stres) times = 1e9;
//    else cin >> times;
    while (times--) {
        if (!stres) {
            Fast f;
            f.solve();
        }
    }
    return 0;
}
