#include <bits/stdc++.h>
using namespace std;

#define int long long
using ll = long long;
#define forn(i,n) for(int i=0;i<n;++i)
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];
#define pb push_back
#define all(x) x.begin(),x.end()
#define pi pair<int,int>
#define f first
#define s second

const ll inf = 1e18;

const int N = 3e5+5;
int a[N];
int n,d,g; 

struct sgt {
	vector<int> t; int sz=1;
	sgt(int n) {
		while (sz<n) sz<<=1;
		t.assign(2*sz,inf);
	}
	void upd(int v, int l, int r, int i) {
		if (r-l==1) return;
		int m=(l+r)>>1;
		if (i<m) upd(2*v+1,l,m,i);
		else upd(2*v+2,m,r,i);
		t[v]=min(t[2*v+1],t[2*v+2]);
	}
	void set(int i, int x) {
		t[sz-1+i]=x;
		upd(0,0,sz,i);
	}
	int query(int v, int l, int r, int lx, int rx) {
		if (rx<=l || r<=lx) return inf;
		if (lx<=l && r<=rx) return t[v];
		int m=(l+r)>>1;
		int lq = query(2*v+1,l,m,lx,rx);
		int rq = query(2*v+2,m,r,lx,rx);
		return min(lq,rq);
	}
	int query(int l, int r) {
		return query(0,0,sz,l,r);
	}
};

int ans[105][105];
bitset<105> adj[105];

void n100() {
	for(int i=0; i<n; ++i) {
		int z=i;
		for(int j=i+1; j<n; ++j) {
			if (j-z>d) break;
			if (a[j]>a[i]) adj[i][j]=1;
			else z=j;
		}
	}
	forn(i,n) {
		ans[i][i]=1;
		for(int j=i; j<n; ++j) {
			if (!ans[i][j]) continue;
			forn(k,n) if (adj[j][k]) {
				if (!ans[i][k]) ans[i][k]=ans[i][j]+1;
				ans[i][k]=min(ans[i][k],ans[i][j]+1);
			}
		}
	}
	int q; cin>>q;
	while (q--) {
		int t,l,r; cin>>t>>l>>r; --l, --r;
		if (!ans[l][r]) {
			cout<<"0\n"; continue;
		}
		if (t&1) cout<<1<<'\n';
		else cout<<ans[l][r]-1<<'\n';
	}
}

int r1[N];
void vn() {

	vector<int> bg(n),en(n);
	set<int> s;
	vector<pi> v;
	forn(i,n) v.pb({a[i],i});
	sort(all(v));

	for(auto&x:v) {
		int i=x.s;
		r1[i]=i;
		s.insert(i);
		bg[i]=en[i]=1;
		if (s.size()) {
			auto it = s.upper_bound(i);
			//cout<<i<<' '<<a[i]<<": ";
			//for(auto&x:s) cout<<'('<<x<<','<<bg[x]<<','<<en[x]<<") "; cout<<'\n';
			if (it!=s.end()) {
				int j=*it;
				if (bg[j]) {
					if (j-i<=d) {
						if (en[j]) {
							r1[i]=j;
						} else {
							++it;
							assert(it!=s.end());
							j=*it;
							r1[i]=j;
						}
					}
				} else {
					assert(en[j]);
					r1[i]=j;
				}
			}
		}
		if (s.size()) {
			auto it = s.upper_bound(i);
			if (it==s.end()) {
				it = s.find(i);
				if (it!=s.begin()) {
					--it;
					int j=*it;
					assert(en[j]);
					if (i-j <= d) {
						en[j]=0;
						bg[i]=0;
						if (!bg[j]) s.erase(it);
					}
				}
			} else {
				int j=*it;
				if (!bg[j]) {
					s.erase(i); bg[i]=en[i]=0; continue;
				}
				if (j-i <= d) {
					bg[j]=0;
					en[i]=0;
					if (!en[j]) s.erase(it);
				}
				it = s.find(i);
				if (it!=s.begin()) {
					--it;
					int j=*it;
					assert(en[j]);
					if (i-j <= d) {
						en[j]=0;
						bg[i]=0;
						if (!bg[j]) s.erase(it);
					}
				}
			}
		}
		if ((bg[i]+en[i])==0) s.erase(i);
	}

	reverse(all(v));
	vector<int> ans(n,0);
	sgt st(n);
	st.set(n-1,0);
	for(auto&x:v) {
		int i=x.s;
		if (a[i]>=a[n-1]) continue;
		int r = min(n-1,r1[i]+d);
		int z = st.query(i,r+1);
		if (z!=inf) ans[i]=z+1;
		st.set(i,z+1);
	}

	int q; cin>>q;
	while (q--) {
		int t,l,r; cin>>t>>l>>r;
		--l, --r;
		if (a[l] > a[r]) {
			cout<<"0\n"; continue;
		}
		if (t&1) cout<<(ans[l]>0)<<'\n';
		else cout<<ans[l]<<'\n';
	}
	//forn(i,n) cout<<r1[i]<<' ';
}

void solve() {

	cin>>n>>d>>g;
	forn(i,n) cin>>a[i];
	if (n<=100) {
		n100(); return;
	}
	if (3<=g && g<=5) {
		vn(); return;
	}

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	//cin>>t;
	while (t--) solve();
}