#include <bits/stdc++.h>
using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t=1;
    while(t--) {
        solve();
    }
    return 0;
}
// графы(dfs bfs djikstra) дп конструктивы геома жадник
// линалг бинпоиск бинподьемы

#define int long long
#define endl '\n'
const int N=3e5+10,INF=2e18,MOD=1e9+7;
vector<vector<int>> gr(N);
vector<int> bfs(int s,int end,int n){
    vector<int> d(n,INF);
    queue<int> q;
    q.push(s);
    d[s]=0;
    while(!q.empty()){
        int v=q.front();
        q.pop();
        for(auto to:gr[v]){
            if(d[to]>d[v]+1){
                d[to]=d[v]+1;
                q.push(to);
            }
        }
    }
    return d;
}
void solve(){
    auto cgr=&gr;
    int n,d,g;
    cin>>n>>d>>g;
    vector<int> a(n);
    for(int i=0;i<n;i++){
        cin>>a[i];
    }
    for(int i=0;i<n;i++){
        int last=i;
        for(int j=i;j<n;j++){
            if(j-last>d)break;
            if(a[j]<a[i]){
                last=j;
            }else{
                gr[i].push_back(j);
            }
        }
    }
    vector<vector<int>> res(n,vector<int>(n));
    for(int i=0;i<n;i++){
        res[i]=bfs(i,i,n);
    }
    int q;
    cin>>q;
    while(q--){
        int t,u,v;
        cin>>t>>u>>v;
        u--;v--;
        int val=res[u][v];
        if(t==1){
            cout<<(val!=INF)<<endl;
        }else{
            if(val==INF){
                cout<<0<<endl;
            }else{
                cout<<val<<endl;
            }
        }
    }
}