

#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <stack>
#include <deque>
#include <assert.h>
#include <random>
#include <algorithm>
#include <string>
#include <iomanip>
#include <iostream>
#include <math.h>

using namespace std;

mt19937 rnd(0);
#define fast ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)

#define pii pair<int, int>
#define vi vector<int>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define ff first
#define ss second
#define int long long 

int INF = 1e9;
int n, d, g, q;
vi a, min_d;
vvi Q;

vi tree_a;

void build(int v, int tl, int tr) {
    if (tl == tr - 1) {
        tree_a[v] = tl;
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v + 1, tl, tm);
    build(2 * v + 2, tm, tr);
    if (a[tree_a[2 * v + 1]] < a[tree_a[2 * v + 2]])
        tree_a[v] = tree_a[2 * v + 1];
    else
        tree_a[v] = tree_a[2 * v + 2];
}

int get_min_a(int v, int tl, int tr, int l, int r) {
    if (l >= tr || r <= tl) return n;
    if (l <= tl && tr <= r) return tree_a[v];
    int tm = (tl + tr) / 2;
    int id1 = get_min_a(2 * v + 1, tl, tm, l, r);
    int id2 = get_min_a(2 * v + 2, tm, tr, l, r);

    if (id1 == n) return id2;
    if (id2 == n) return id1;
    if (a[id1] < a[id2]) return id1;
    else return id2;
}

void solve1() {
    vector<int> next(n);
    for (int i = 0; i < n; ++i) {
        int x = a[i];
        int id = i;
        while (min_d[id] < n && a[min_d[id]] < x)
            id = min_d[id];
        next[i] = id;
    }

    vi mini(n);
    for (auto& el : Q) {
        int v = el[0], u = el[1], t = el[2];
        if (a[v] > a[u]) {
            cout << "0\n";
            continue;
        }
        mini.assign(n, INF);
        mini[u] = 0;
        multiset<int> st;
        for (int s = u - 1; s >= v; --s) {
            int id = next[s];
            if (id >= u) {
                mini[s] = 1;
            }
            else {
                mini[s] = mini[id + 1] + 1;
            }

            if (id + d <= u) {
                st.erase(mini[id + d]);
            }
            st.insert(mini[s]);
            mini[s] = *st.begin();
        }

        if (mini[v] >= INF) {
            cout << "0\n";
            continue;
        }
        if (t == 1) cout << "1\n";
        else cout << mini[v] << "\n";
    }
}

signed main()
{
    fast;
    cin >> n >> d >> g;
    a.resize(n);
    for (auto& i : a) cin >> i;

    tree_a.resize(4 * n);
    build(0, 0, n);

    min_d.resize(n);
    for (int i = 0; i < n; ++i) {
        min_d[i] = get_min_a(0, 0, n, i + 1, min(n, i + d + 1));
    }

    //for (auto& i : min_d) cout << i << " ";

    cin >> q;
    Q.resize(q);
    for (int i = 0; i < q; ++i) {
        int v, u, t;
        cin >> t >> v >> u;
        v--; u--;
        Q[i] = { v, u, t };
    }

    if (n <= 1000) solve1();
}