#include <bits/stdc++.h>

using namespace std;
#define int long long

const int M = 310000;
const int N = 4100;
const int INF = (int)(1e18);

int n, d, g, a[M], r[M], ord[M], dst[N][N];
vector<pair<int, int>> gg[M];
set<pair<int, int>> st;

void addpos(int x) {
	auto pre = st.upper_bound({x, n});
	if (pre != st.begin()) {
		pre--;
		if (pre->second >= x) return;
	}
	auto it = st.upper_bound({x, n});
	int nl = x, nr = x;
	while (it != st.end() && it->first - d <= nr) {
		nr = it->second;
		it = st.erase(it);
	}
	while (it != st.begin() && (--it)->second + d >= nl) {
		nl = it->first;
		it = st.erase(it);
	}
	st.insert({nl, nr});
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> d >> g;
	for (int i = 1; i <= n; i++)
		cin >> a[i];
	for (int i = 1; i <= n; i++)
		ord[i] = i;
	sort(ord + 1, ord + 1 + n, [&](int i, int j){return a[i] < a[j];});
	for (int k = 1; k <= n; k++) {
		int i = ord[k];
		addpos(i);
		auto it = st.upper_bound({i, n});
		it--;
		r[i] = min(it->second + d, n);
	}
	for (int i = 1; i <= n; i++) {
		for (int j = i + 1; j <= r[i]; j++) {
			if (a[j] < a[i]) continue;
			gg[j].push_back({i, 1});
		}
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++)
			dst[i][j] = INF;
		deque<int> qq;
		dst[i][i] = 0;
		qq.push_back(i);
		while (!qq.empty()) {
			int v = qq.front();
			qq.pop_front();
			for (auto [u, w] : gg[v])
				if (dst[i][u] > dst[i][v] + w) {
					dst[i][u] = dst[i][v] + w;
					if (w == 0) qq.push_front(u);
					else qq.push_back(u);
				}
		}
	}
	int q; cin >> q;
	while (q--) {
		int u, v, t; cin >> t >> u >> v;
		int ans = dst[v][u];
		if (ans == INF) ans = 0;
		if (t == 1 && ans > 0) ans = 1;
		cout << ans << '\n';
	}
}
