#include<bits/stdc++.h>

using namespace std;

#define ll long long 
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, D, group;
	cin >> n >> D >> group;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<vector<int>> g(n);
	for (int i = 0; i < n; i++) {
		int last = i;
		for (int j = i; j < n; j++) {
			if (j - last > D) {
				break;
			}
			if (a[j] < a[i]) {
				last = j;
			}
			if (a[i] < a[j]) {
				g[i].pb(j);
			}
		}
	}
	vector<vector<int>> d(n, vector<int>(n, -1));
	for (int v = 0; v < n; v++) {
		deque<int> q{v};
		d[v][v] = 0;
		while (q.size() > 0) {
			int u = q.front();
			q.pop_front();
			for (auto x : g[u]) {
				if (d[v][x] == -1) {
					d[v][x] = d[v][u] + 1;
					q.pb(x);
				}
			}
		}

	}
	int q;
	cin >> q;
	while (q--) {
		int t, u, v;
		cin >> t >> u >> v;
		u--, v--;
		bool check = 1;
		if (a[u] > a[v]) {
			check = 0;
		}
		int cnt = 0;
		for (int i = u; i <= v; i++) {
			if (a[i] > a[v]) {
				cnt++;
			} else {
				cnt = 0;
			}
			if (cnt >= D) {
				check = 0;
			}
		}
		if (d[u][v] == -1) {
			assert(!check);
			cout << 0 << endl;
		} else if (t == 1) {
			cout << 1 << endl;
		} else {
			cout << d[u][v] << endl;
		}
	}
	return 0;
}