#include<bits/stdc++.h>

using namespace std;

#define ll long long 
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int INF = 1e9, N = 3e5 + 10;
set<pair<int, int>> st;
set<int> bad;
int n, D, group;

void add_seg(int l, int r) {
	if (r - l + 1 >= D) {
		bad.insert(l);
	}
	st.insert({l, r});
}

void del_element(int i) {
	auto seg = *prev(st.upper_bound({i, INF}));
	st.erase(seg);
	bad.erase(seg.first);
	if (seg.first != i) {
		add_seg(seg.first, i - 1);
	}
	if (i != seg.second) {
		add_seg(i + 1, seg.second);
	}
}

int po[20][N];

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> D >> group;
	vector<int> a(n);
	vector<int> pos(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
		pos[a[i]] = i;
	}
	vector<int> Right(n);	
	{
		for (int i = 0; i < n; i++) {
			Right[i] = n - 1;
			int last = i;
			for (int j = i; j < n; j++) {
				if (j - last > D) {
					Right[i] = j - 1;
					break;
				}
				if (a[j] < a[i]) {
					last = j;
				}
			}
		}
		/*add_seg(0, n - 1);
		bad.insert(INF);
		for (int i = 0; i < n; i++) {
			del_element(pos[i]);
			int j = pos[i];
			int k = *bad.lower_bound(j);
			if (k != INF) {
				Right[i] = k + D - 1;
			} else {
				Right[i] = n - 1;
			}
		}
		st.clear();
		bad.clear();*/
	}
	int q;
	cin >> q;
	vector<vector<array<int, 3>>> arr(n);
	vector<int> ans(q);
	for (int i = 0; i < q; i++) {
		int t, u, v;
		cin >> t >> u >> v;
		u--, v--;
		arr[a[v]].pb({a[u], t, i});
	}
	add_seg(0, n - 1);
	bad.insert(INF);
	for (int i = 0; i < n; i++) {
		del_element(pos[i]);
		if (arr[i].size() > 0) {
			vector<int> go(n, n - 1);
			for (int j = 0; j < n; j++) {
				for (int k = Right[j]; k >= j; k--) {
					if (a[k] > a[j] && a[k] <= i) {
						go[j] = k;
						break;
					}
				}
			}
			for (int i = 0; i <	n; i++) {
				po[0][i] = go[i];
			}
			for (int i = 1; i < 20; i++) {
				for (int j = 0; j < n; j++) {
					po[i][j] = po[i - 1][po[i - 1][j]];
				}
			}
			for (auto [j, type, ind] : arr[i]) {
				if (j > i || *bad.lower_bound(pos[j]) < pos[i]) {
					ans[ind] = 0;
				} else {
					int kek = pos[j], res = 0;
					while (kek < pos[i]) {
						res++;
						kek = go[kek];
					}
					if (type == 1) {
						ans[ind] = 1;
					} else {
						ans[ind] = res;
					}
				}
			}

		}
	}
	for (int i = 0; i < q; i++) {
		cout << ans[i] << '\n';
	}
	return 0;
}