#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree< ll , null_type , less< ll > , rb_tree_tag , tree_order_statistics_node_update > oset;
typedef long double ld;
typedef pair< int , int > pii;
typedef pair< ll , ll > pll;


#define pb push_back
#define S second
#define F first
#define all(x) x.begin() , x.end()
#define sz(x) x.size()
#define int ll
#define itn int
#define ve vector

const int N = 2000;
const int inf = 1e18 + 123;
const int mod = 1e9 + 7;
const int sqr = 500;

mt19937 gen( time( 0 ) );

ve< int > g[N];

int D[N][N];

void bfs( int s )
{
    D[s][s] = 0;

    queue< int > q;

    q.push( s );

    while( sz( q ) )
    {
        int v = q.front();

        q.pop();

        for( auto to : g[v] )
        {
            if( D[s][to] > D[s][v] + 1 )
            {
                D[s][to] = D[s][v] + 1;

                q.push( to );
            }
        }
    }
}

void solve()
{
    itn n , d , G;
    cin >> n >> d >> G;

    int a[n];

    for( int i = 0;i < n;++ i )
    {
        cin >> a[i];

        fill( D[i] , D[i] + n , inf );
    }

    for( int i = 0;i < n;++ i )
    {
        int l = i;

        for( itn j = i + 1;j < n;++ j )
        {
            if( j - l > d )
            {
                break;
            }

            if( a[j] < a[i] )
            {
                l = j;
            }

            if( a[j] > a[i] )
            {
                g[i].pb( j );
//                cout << i << ' ' << j << '\n';
            }
        }
    }

    for( int i = 0;i < n;++ i )
    {
        bfs( i );
    }

    int q;
    cin >> q;

    while( q -- )
    {
        int T , s , f;
        cin >> T >> s >> f;

        -- s , -- f;

        if( T == 1 )
        {
            if( D[s][f] == inf )
            {
                cout << 0 << '\n';
            }
            else
            {
                cout << 1 << '\n';
            }
        }
        else
        {
            if( D[s][f] == inf )
            {
                cout << 0 << '\n';
            }
            else
            {
                cout << D[s][f] << '\n';
            }
        }


    }

}


int32_t main()
{
    #ifdef LOCAL
        freopen( "input.txt" , "r" , stdin );
        freopen( "output.txt" , "w" , stdout );
    #endif // LOCAL

    ios_base::sync_with_stdio( 0 );
    cin.tie( 0 );
    cout.tie( 0 );

    int t = 1;
//    cin >> t;

    while( t -- )
    {
        solve();
    }
}
