#include<bits/stdc++.h>

using namespace std;

using ll = long long;

vector<vector<ll>> g;

ll const INF = 1e9;

void bfs(ll s, vector<ll> &dist) {
    deque<int> q;
    q.push_front(s);
    while (!q.empty()) {
        int v = q.back();
        q.pop_back();
        for (auto u : g[v]) {
            if (dist[v] + 1 < dist[u]) {
                dist[u] = dist[v] + 1;
                q.push_front(u);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll n, d, x;
    cin >> n >> d >> x;
    vector<ll> a(n);
    g.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (x <= 2) {
        for (ll i = 0; i < n; ++i) {
            ll f = 1, last = i;
            for (ll j = i + 1; j < n; ++j) {
                if (a[j] < a[i] && j - last <= d)
                    last = j;
                if (j - last > d)
                    f = 0;
                if (a[i] < a[j] && f)
                    g[i].push_back(j);
                if (f == 0)
                    break;
            }
        }
    //    for (ll i = 0; i < n; ++i) {
    //        cout << i + 1 << ": ";
    //        for (auto el : g[i])
    //            cout << el + 1 << " ";
    //        cout << endl;
    //    }
        ll q;
        cin >> q;
        vector<vector<ll>> dist(n, vector<ll> (n, INF));
        while (q--) {
            ll t, v, u;
            cin >> t >> v >> u;
            v--; u--;
            if (dist[v][v] == INF) {
                dist[v][v] = 0;
                bfs(v, dist[v]);
            }
            if (dist[v][u] == INF)
                cout << "0\n";
            else if (t == 2)
                cout << dist[v][u] << "\n";
            else
                cout << "1\n";
        }
    } else if (x == 4) {
        int q;
        cin >> q;
        while (q--) {
            ll t, v, u;
            cin >> t >> v >> u;
            v--; u--;
            for (ll i = v; i < n; ++i) {
                ll f = 1, last = i;
                for (ll j = i + 1; j < n; ++j) {
                    if (a[j] < a[i] && j - last <= d)
                        last = j;
                    if (j - last > d)
                        f = 0;
                    if (a[i] < a[j] && f)
                        g[i].push_back(j);
                    if (f == 0)
                        break;
                }
            }
            vector<ll> dist(n, INF);
            dist[u] = 0;
            bfs(v, dist);
            if (dist[u] == INF)
                cout << "0\n";
            else if (t == 2)
                cout << dist[u] << "\n";
            else
                cout << "1\n";
        }
    }

}


