#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const int INF = (int)1e9;

void solve() {
  int n, d, gg;
  cin >> n >> d >> gg;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    --a[i];
  }
  vector<vector<int>> g(n, vector<int>(n, INF));
  for (int i = 0; i < n; ++i) {
    g[i][i] = 0;
  }
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      if (a[i] > a[j]) {
        continue;
      }
      if (j - i <= d) {
        g[i][j] = 1;
        continue;
      }
      int prv = i;
      bool ok = true;
      for (int k = i + 1; k < j; ++k) {
        if (a[k] < a[i]) {
          if (k - prv > d) {
            ok = false;
            break;
          }
          prv = k;
        }
      }
      if (ok && j - prv <= d) {
        g[i][j] = 1;
      }
    }
  }
  for (int k = 0; k < n; ++k) {
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < n; ++j) {
        g[i][j] = min(g[i][j], g[i][k] + g[k][j]);
      }
    }
  }
  int q;
  cin >> q;
  while (q--) {
    int type, from, to;
    cin >> type >> from >> to;
    --from, --to;
    if (type == 1) {
      cout << (g[from][to] != INF) << '\n';
    } else {
      cout << (g[from][to] == INF ? 0 : g[from][to]) << '\n';
    }
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
