#include "bits/stdc++.h"

void not_main() {
    int n, d, gr;
    std::cin >> n >> d >> gr;
    std::vector<int> a(n);
    for (int &i : a) {
        std::cin >> i;
    }
    std::vector<std::vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n && (int) g[i].size() < d; ++j) {
            if (a[i] < a[j]) {
                g[i].emplace_back(j);
            }
        }
    }
    std::vector<std::vector<int>> dist(n, std::vector<int>(n));
    for (int i = 0; i < n; ++i) {
        std::vector<int> dst(n);
        dst[i] = 1;
        std::queue<int> q;
        q.emplace(i);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (auto &to : g[v]) {
                if (!dst[to]) {
                    dst[to] = dst[v] + 1;
                    q.emplace(to);
                }
            }
        }
        dist[i] = dst;
    }
    int q;
    std::cin >> q;
    while (q--) {
        int ti, v, u;
        std::cin >> ti >> v >> u;
        --u, --v;
        if (ti == 1) {
            std::cout << std::max(std::min(1, dist[v][u] - 1), 0) << '\n';
        } else {
            std::cout << std::max(dist[v][u] - 1, 0) << '\n';
        }
    }
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
    int tests = 1, gr;
    //std::cin >> tests;
    while (tests--) {
        not_main();
    }
    return 0;
}
