#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define ff first
#define sc second
#define sz(a) (int) (a).size()

struct segtree {
    int n;
    vector<int> a, t;
    segtree() = default;
    segtree(int n_, vector<int> a_) {
        n = n_;
        a = a_;
        t.assign(4 * n, 0);
        for (int i = 0; i < n; i++) upd(1, 0, n, i, a[i]);
    }        

    void upd(int v, int tl, int tr, int p, int vl) {
        if (tl + 1== tr) {
            t[v] =  vl;
            return;
        }
        int tm = (tl + tr) / 2;
        if (p < tm) upd(v * 2, tl, tm, p, vl);
        else upd(v * 2 + 1, tm, tr, p, vl);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }
    int get(int v, int tl, int tr, int l, int r) {
        if (l <= tl && tr<= r) return t[v];
        if (tr <= l || tl >= r) return 0;
        int tm= (tl+tr)/2;
        return max(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm, tr, l,r));
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);

    int n, d, ahah; cin >> n >> d >> ahah;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<int> R(n, -1);
    vector<int> pos(n + 1);
    for (int i = 0; i < n; i++) pos[a[i]] = i;
    R[pos[1]] = min(n - 1, pos[1] + d);
    set<pair<int, int>> deltas;
    set<int> cur, bigg;
    cur.insert(pos[1]);
    for (int val = 2; val <= n; val++) {
        int pp = pos[val], lf = -1, rg = -1;
        auto it = cur.lower_bound(pp);
        if (it != cur.end()) rg = *it;
        if (it != cur.begin()) {
            it--; 
            lf = *it;
        }
        if (lf != -1 && rg != -1) {
            if (rg - lf > d) bigg.erase(lf);
            deltas.erase({rg - lf, lf});
        }
        if (lf != -1) {
            if (pp - lf > d) bigg.insert(lf);
            deltas.insert({pp - lf, lf});
        }
        if (rg != -1) {
            if (rg - pp > d) bigg.insert(pp);
            deltas.insert({rg - pp, pp});
        }
        cur.insert(pp);
        auto itt = bigg.lower_bound(pp);
        if (itt != bigg.end()) {
            R[pp] = (*itt) + d;
        } else {
            R[pp] = min(n - 1, *(cur.rbegin()) + d);
        }
    }

    int q; cin >> q;
    while (q--) {
        int t, u, v; cin >> t >> u >> v;
        u--; v--;
        segtree sg(n, vector<int>(n, 0));
        vector<int> dp(n, 1e9);
        dp[v]= 0;
        sg.upd(1, 0, n, v, a[v]);
        for (int j = v - 1; j >= u; j--) {
            if (a[j] > a[v]) continue;
            sg.upd(1, 0, n, j, a[j]);
            int mx = sg.get(1, 0, n, j, R[j] + 1);
            if (mx == a[j]) continue;
            dp[j] = dp[pos[mx]] + 1;
        }
        if (dp[u] >= 1e9) cout << "0\n";
        else {
            cout << (t == 1 ? 1 : dp[u]) << '\n';
        }   
    }
}