#include <bits/stdc++.h>

using namespace std;
namespace rng = ranges;
namespace viu = views;

typedef int64_t ll;

#define INF ((int)1e9 + 1329)
#define INF_LL ((int64_t)1e18)

#ifndef ILKRAS
#define ent "\n"
#else
#define ent endl
#endif

struct Solution {
    int TEST = -1;

    signed operator()() {
        int n, d, g;
        cin >> n >> d >> g;
        vector<int> ar(n);
        for (auto &it: ar) cin >> it;
        int q; cin >> q;
        while (q--) {
            int t, l, r; cin >> t >> l >> r;
            l--; r--;
            int cnt = 0;
            while (l < r) {
                cnt++;
                int prev = l;
                int lok = l;
                for (int cur = l + 1; cur < n && cur - prev <= d; ++cur) {
                    if (ar[cur] < ar[l]) {
                        prev = cur;
                    }
                    if (ar[cur] > ar[lok] && ar[cur] <= ar[r]) {
                        lok = cur;
                    }
                }
                if (l == lok) {
                    cnt = 0;
                    break;
                }
                l = lok;
            }
            if (t == 1) {
                cout << min(1, cnt);
            } else {
                cout << cnt;
            }
            cout << ent;
        }

        return 0;
    }

    Solution(int TEST = -1) : TEST(TEST) {}
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    for (int TEST: viu::iota(1, t + 1)) {
        int res = Solution(TEST)();
        if (res != 0)
            return res;
    }
    return 0;
}