#include<bits/stdc++.h>
#define sz(a) (int)a.size()

using namespace std;

const int N = 3e5 + 10, INF = 1e8;
int n, d, G;

void solve1() {
    vector<int> a(n);
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int st = 0; st < n; ++st) {
        int last = st;
        for (int i = st + 1; i < n; ++i) {
            if (i - last > d) break;
            if (i - last <= d && a[i] > a[st]) {
                g[st].push_back(i);
            }
            if (a[i] < a[st]) {
                last = i;
            }
        }
    }
    vector<vector<int>> dp(n, vector<int> (n, INF));
    for (int st = 0; st < n; ++st) {
        dp[st][st] = 0;
        for (int i = st; i < n; ++i) {
            if (dp[st][i] == INF) continue;
            for (int j : g[i]) {
                dp[st][j] = min(dp[st][j], dp[st][i] + 1);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        --u;
        --v;
        if (dp[u][v] == INF) {
            cout << 0 << '\n';
            continue;
        }
        if (t == 1) {
            cout << 1 << '\n';
        }
        else {
            cout << dp[u][v] << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> d >> G;
    if (n <= 1000) {
        solve1();
        return 0;
    }
}
