#include <bits/stdc++.h>

#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, d, gr;
    cin >> n >> d >> gr;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    vector<vector<int>> g(n + 1);
    for (int i = 1; i <= n; i++) {
        int last = i;
        for (int j = i + 1; j <= n; j++) {
            if (j - last > d) {
                break;
            }
            if (a[j] > a[i]) {
                g[i].push_back(j);
            }
            else {
                last = j;
            }
        }
    }
    vector<vector<int>> dist(n + 1, vector<int> (n + 1, 1e18));
    for (int i = 1; i <= n; i++) {
        dist[i][i] = 0;
        set<pair<int, int>> q = {{0, i}};
        while (!q.empty()) {
            auto [d1, u] = *q.begin();
            q.erase(q.begin());
            if (dist[i][u] != d1) {
                continue;
            }
            for (auto v : g[u]) {
                if (dist[i][v] > d1 + 1) {
                    dist[i][v] = d1 + 1;
                    q.insert({d1 + 1, v});
                }
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        int ans = dist[u][v];
        if (ans == 1e18) {
            ans = 0;
        }
        if (t == 1) {
            cout << min(ans, 1ll) << "\n";
        }
        else {
            cout << ans << "\n";
        }
    }
}
