//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <vector>
#include <bits/stdc++.h>
using namespace std;




using ll = long long;


int bubble = 0;
#ifdef RODYA
#include "Templates/Debug Template.cpp"
#else
#define dbg(...) ++bubble;
#endif


#define int ll
#define vec vector
#define endl "\n"
#define eb emplace_back
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define all(x) x.begin(), x.end()

using pii = pair<int, int>;




const int N = 3e5 + 10, INF = 1e9 + 10;


int n, d, group, q;
int a[N];
int nxt[N];
vec<pii> be[N];



void input() {
    cin >> n >> d >> group;
    for (int i = 1; i <= n; ++i) cin >> a[i];
}




struct SegmentTree {
    int tree[N << 1];
    SegmentTree() {
        for (auto& it : tree)
            it = -INF;
    }
    void upd(int v, int x) {
        v += N;
        tree[v] = max(tree[v], x);
        for (v >>= 1; v; v >>= 1)
            tree[v] = max(tree[v << 1], tree[v << 1 | 1]);
    }
    int query(int l, int r) const {
        int res = -INF;
        for (l += N, r += N + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) res = max(res, tree[l++]);
            if (r & 1) res = max(res, tree[--r]);
        }
        return res;
    }
} tree;


void findNxt() {
    vec<int> numPos(n + 1);
    for (int i = 1; i <= n; ++i)
        numPos[a[i]] = i;
    for (int i = n; i >= 1; --i) {
        int pre = i;

        int e = i;
        for (int j = i + 1; j <= n; ++j) {
            if (a[j] < a[i]) {
                if (j - pre > d) break;
                pre = j;
            } else {
                if (a[j] > a[e] && j - pre <= d) {
                    be[i].eb(mp(a[j], j));
                }
            }
        }

        sort(all(be[i]));
//        for (int j = 1; j < sz(be[i]); ++j) {
//            be[i][j].second = max(be[i][j - 1].second, be[i][j].second);
//        }
    }
}




int dist[N];

void findDist(int start) {
    for (auto& it : dist) it = INF;
    dist[start] = 0;
    queue<int> qu;
    qu.push(start);

    while (!qu.empty()) {
        int v = qu.front(); qu.pop();
        dbg(v, dist[v]);
        for (auto& [x, to] : be[v]) {
            if (dist[to] != INF) continue;
            dist[to] = dist[v] + 1;
            qu.push(to);
        }
    }
}


void solve() {
    cin >> q;
    while (q--) {
        int typ, l, r; cin >> typ >> l >> r;


        findDist(l);
        int val = dist[r];


//        if (a[r] < a[l]) {
//            cout << 0 << endl;
//            continue;
//        }

//        int val = 0;
//        int i = l;
//        while (true) {
//            //dbg(i);
//            auto it = upper_bound(all(be[i]), mp(a[r], INF));
//            if (it == be[i].begin()) {
//                val = 0;
//                break;
//            }
//
//            --it;
//            //dbg(it->first, it->second);
//            int to = it->second;
//            i = to;
//            ++val;
//            if (i >= r) break;
//        }

        int ans = INF;
        if (val) ans = val;
        if (typ == 1 && ans != INF) ans = 1;
        cout << (ans == INF ? 0 : ans) << endl;
    }
}


signed main() {
#ifdef RODYA
    freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\bigTest.in", "r", stdin);
#else
    cin.tie(0), ios_base::sync_with_stdio(false);
#endif


    input();
    findNxt();
    solve();


}
