#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

long long INF = 1e18;

int main() {
    int t;
    cin >> t;
    for (int u = 0; u < t; ++u) {
        int n;
        cin >> n;
        vector <long long> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        vector <long long> b(n);
        for (int i = 0; i < n; ++i) {
            cin >> b[i];
        }
        vector <long long> Apref(n + 1, 0);
        for (int i = 0; i < n; ++i) {
            Apref[i + 1] = Apref[i] + a[i];
            cerr << Apref[i + 1] << " ";
        }
        cerr << endl;
        vector <long long> Bpref(n + 1, 0);
        for (int i = 0; i < n; ++i) {
            Bpref[i + 1] = Bpref[i] + b[i];
            cerr << Bpref[i + 1] << " ";
        }
        cerr << endl;
        for (int i = 0; i < n; ++i) {
            long long ans = INF;
            for (int j = 0; j <= i; ++j) {
                for (int k = 0; k <= i; ++k) {
                    long long S1 = Apref[i + 1] - a[j];
                    long long S2 = Bpref[i + 1] - b[k];
                    if (S1 < S2) {
                        continue;
                    }
                    ans = min(S1 - S2, ans);
                }
            }
            cout << ans << " ";
        }
    }
}
