#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <queue>
using namespace std;
long long n, d, g, q;
vector<long long> a;
vector<vector<long long>> gr;
long long bfs(long long s, long long f) {
	queue<long long> q;
	vector<long long> used(n, -1);
	used[s] = 0;
	q.push(s);
	while (!q.empty()) {
		long long v = q.front();
		q.pop();
		for (long long i = 0; i < gr[v].size(); i++)
			if (used[gr[v][i]] == -1) {
				q.push(gr[v][i]);
				used[gr[v][i]] = used[v] + 1;
			}
	}
	return used[f];
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> d >> g;
	a.resize(n);
	for (long long i = 0; i < n; i++)
		cin >> a[i];
	//if (n <= 100 && q <= 100) {
		gr.resize(n);
		for (long long i = 0; i < n; i++) {
			long long last = i;
			for (long long j = i + 1; j < n; j++) {
				if (j - last > d)
					break;
				if (a[j] > a[i])
					gr[i].push_back(j);
				if (a[j] < a[i])
					last = j;
			}
		}
	//}
	cin >> q;
	for (long long i = 0; i < q; i++) {
		long long t, u, v;
		cin >> t >> u >> v;
		u--;
		v--;
		long long x1 = bfs(u, v);
		if (x1 == -1)
			cout << "0\n";
		else if (t == 1)
			cout << "1\n";
		else
			cout << x1 << "\n";
	}
	return 0;
}
