#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e9;

ll n, d, g;
vector<ll> a;

ll valid[1000][1000];

int main() {
    cin >> n >> d >> g;
    a.resize(n);
    for (ll& i : a) cin >> i;
    for (ll i = 0; i < n; i++) {
        ll last = i;
        for (ll j = i + 1; j < n; j++) {
            if (a[i] < a[j] && j - last <= d) valid[i][j] = 1;
            if (a[i] > a[j]) last = j;
        }
    }
    ll q;
    cin >> q;
    while (q--) {
        ll t, a, b;
        cin >> t >> a >> b;
        a--;
        b--;
        vector<ll> dist(n, INF);
        dist[a] = 0;
        for (ll i = a + 1; i <= b; i++) {
            for (ll j = a; j < i; j++) {
                if (valid[j][i]) dist[i] = min(dist[i], dist[j] + 1);
            }
        }
        if (t == 1) {
            if (dist[b] == INF) cout << "0\n";
            else
                cout << "1\n";
        } else {
            if (dist[b] == INF) cout << "0\n";
            else
                cout << dist[b] << "\n";
        }
    }
}