#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define pb push_back
#define endl '\n'
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define vi vector<ll>
#define vii vector<vi>

ll inf = 1e10;

void solve() {
    ll n, d, g;
    cin >> n >> d >> g;
    //if (g != 1) return;
    vi a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    vii dp(n, vi(n, inf));
    for (ll len = 1; len <= n; len++) {
        for (ll l = 0; l + len - 1 < n; l++) {
            ll r = l + len - 1;
            if (len == 1) {
                dp[l][r] = 0;
                continue;
            }
            if (a[l] >= a[r]) continue;

            for (ll m = l + 1; m < r; m++) {
                if (dp[l][m] != inf && dp[m][r] != inf) {
                    dp[l][r] = min(dp[l][r], dp[l][m] + dp[m][r]);
                }
            }

            vi gg;
            for (ll u = l + 1; u < r; u++) {
                if (a[u] < a[l]) {
                    gg.pb(u);
                }
            }
            ll fl = 0;
            for (ll u = 1; u < gg.size(); u++) {
                if (gg[u] - gg[u - 1] > d) {
                    fl = 1;
                }
            }
            if (r - l > d && gg.size() == 0) {
                fl = 1;
            }
            if (gg.size() > 0 && (gg[0] - l > d || r - gg.back() > d)) {
                fl = 1;
            }
            if (fl == 0) {
                dp[l][r] = 1;
            }
            if (dp[l][r] != inf) {
                //cout << l + 1 << " " << r + 1 << " " << dp[l][r] << endl;
            }
        }
    }
    ll q;
    cin >> q;
    while (q--) {
        ll t;
        cin >> t;
        ll i, j;
        cin >> i >> j;
        i--, j--;
        if (t == 1) {
            if (dp[i][j] != inf) {
                cout << 1 << endl;
            } else {
                cout << 0 << endl;
            }
        } else {
            if (dp[i][j] != inf) {
                cout << dp[i][j] << endl;
            } else {
                cout << 0 << endl;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    clock_t timer = clock();
#endif
    ll t = 1;
    while (t--) {
        solve();
    }
#ifdef LOCAL
    // cout << endl << "time: " << (ld) (clock() - timer) / CLOCKS_PER_SEC;
#endif
}
