#include <iostream>
#include <vector>

#pragma target('avx2')

#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

int main() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> A(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    vector<vector<pair<int, int>>> st(n);
    for (int i = n - 1; i >= 0; i--) {
        vector<int> q = {i};
        for (int j = i + 1; j < n; j++) {
            if (j - q.back() > d) {
                break;
            }
            if (A[j] > A[i]) {
                st[i].push_back({j, 1});
                for (auto e: st[j]) {
                    st[i].push_back({e.first, e.second + 1});
                }
            }
            if (A[j] < A[i]) {
                while (q.size() >= 2 and j - q[q.size() - 2] <= d) {
                    q.pop_back();
                }
                q.push_back(j);
            }
        }
    }
    int q;
    cin >> q;
    for (int _ = 0; _ < q; _++) {
        int t, a, b;
        cin >> t >> a >> b;
        a--;
        b--;
        if (b > a and A[b] > A[a]) {
            bool flag = true;
            for (auto e: st[a]) {
                if (e.first == b) {
                    if (t == 1) {
                        cout << 1 << '\n';
                    } else {
                        cout << e.second << '\n';
                    }
                    flag = false;
                    break;
                }
            }
            if (flag)
                cout << 0 << '\n';
        } else {
            cout << 0 << '\n';
        }
    }

}
