#include <iostream>
#include <vector>

#pragma target('avx2')

#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

int main() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> A(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    vector<vector<int>> st(n, vector<int>(n, 1e9));
    for (int i = n - 1; i >= 0; i--) {
        vector<int> q = {i};
        for (int j = i + 1; j < n; j++) {
            if (j - q.back() > d) {
                break;
            }
            if (A[j] > A[i]) {
                st[i][j] = 1;
                for (int k = 0; k < n; k++) {
                    st[i][k] = min(st[i][k], st[j][k] + 1);
                }
            }
            if (A[j] < A[i]) {
                while (q.size() >= 2 and j - q[q.size() - 2] <= d) {
                    q.pop_back();
                }
                q.push_back(j);
            }
        }
    }
    int q;
    cin >> q;
    for (int _ = 0; _ < q; _++) {
        int t, a, b;
        cin >> t >> a >> b;
        a--;
        b--;
        if (st[a][b] < 1e9) {
            if (t == 1) {
                cout << 1 << '\n';
            } else {
                cout << st[a][b] << '\n';
            }
        } else
            cout << 0 << '\n';
    } 
}

