#include "bits/stdc++.h"
using namespace std;
#define int long long
const int maxn = 3e5 + 10;
int d;
vector <int> g[maxn];
int a[maxn];

const int inf = maxn;
int dist[1005][1005];
void dij(int s) {
    fill(dist[s], dist[s] + 1005, inf);
    dist[s][s] = 0;
    queue<int> q;
    q.push(s);

    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i : g[v]) {
            if (dist[s][i] == inf) {
                dist[s][i] = dist[s][v] + 1;
                q.push(i);
            }
        }
    }
}
void solve_tup(int n) {

    for (int from = 1; from <= n; from++) {
        int lst = from;
        for (int j = from + 1; j <= n; j++) {
            if (lst + d < j) break;
            if (a[from] < a[j]) g[from].push_back(j);
            else lst = j;
        }
    }

    for (int i = 1; i <= n; i++) {
        dij(i);
    }

    int q; cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        if (t == 1) {
            if (dist[u][v] != inf) cout << 1 << '\n';
            else cout << 0 << '\n';
        } else {
            if (dist[u][v] == inf) cout << 0 << '\n';
            else cout << dist[u][v] << '\n';

        }
    }
}
mt19937 rnd(228);
struct node{
    // декартач на минимум в поддереве и сплиты

    int x;
    int val;
    unsigned y;
    int mn;
    node* l = nullptr, *r = nullptr;
    node(int _x, int _val) {
        x = _x;
        y = rnd();
        val = _val;
        mn = _val;
    }
};

int get(node* v) {
    if (!v) return inf;
    return v -> mn;
}

void upd(node* v) {
    if (v) {
        v -> mn = min({v -> val, get(v -> l), get(v -> r)});
    }
}

node* merge(node* a, node* b) {
    if (!a) return b;
    if (!b) return a;
    if (a -> x > b -> x) swap(a, b);
    if (a -> y > b -> y) {
        a -> r = merge(a -> r, b);
        upd(a);
        return a;
    } else {
        b -> l = merge(a, b -> l);
        upd(b);
        return b;
    }
}

pair<node*, node*> split(node* v, int x) { // <x, >= x
    if (!v) return {0, 0};
    if (v -> x < x) {
        auto [s1, s2] = split(v -> r, x);
        v -> r = s1;
        upd(v);
        return {v, s2};
    } else {
        auto [s1, s2] = split(v -> l, x);
        v -> l = s2;
        upd(v);
        return {s1, v};
    }
}


int dd[maxn];
node* insert(node* v, int x, int val) {
    node* nn = new node(x, val);
    auto [s1, s2] = split(v, x);
    return merge(merge(s1, nn), s2);
}
node* erase(node* v, int x) {
    auto [s1, s2] = split(v, x);
    auto [s3, s4] = split(s2, x + 1);
    return merge(s1, s4);
}
void solve_34(int n) {
    dd[n] = 0;
    node* root = new node(a[n], 0);

    for (int i = n - 1; i >= n - d; i--) {
        int vall = (a[i] < a[n] ? 1 : inf);
        dd[i] = vall;
        root = insert(root, a[i], vall);
    }
    for (int i = n - d - 1; i >= 1; i--) {
        root = erase(root, a[i + d + 1]);
        auto [s1, s2] = split(root, a[i]);
        int vall = min(get(s1), get(s2) + 1);
        dd[i] = vall;
        node* t = new node(a[i], vall);
        root = merge(merge(s1, t), s2);
    }

    int q; cin >> q;
    while (q--) {
        int t; cin >> t;
        int from, to; cin >> from >> to;
        if (t == 1) {
            if (dd[from] >= inf) cout << 0;
            else cout << 1;
        } else {
            if (dd[from] >= inf) cout << 0;
            else cout << dd[from];
        }
        cout << '\n';
    }

}
signed main() {
    int n, _g;
    cin >> n >> d >> _g;
    for (int i = 1; i <= n; i++) cin >> a[i];
    if (_g == 1 || _g == 2) {
        solve_tup(n);
        return 0;
    }
    if (_g == 3 || _g == 4) {
        solve_34(n);
        return 0;
    }


}