#include <iostream>
#include <vector>
#include <set>
using namespace std;

int n, d;
const int INF = 1e9;
vector<int> v;
set<int> u;

int way(int s, int id, int f) {
    //cout << id << '\n';
    for (int i = 1; i <= d; i++) {
        if (id + d >= n)
            return INF;
        if (id + i == f)
            return 1;
        if (v[id + i] < v[s])
            return way(s, id + i, f);
        if (v[id + i] < v[f])
            u.insert(-(id + i));
    }
    if (u.empty())
        return INF;
    int v = -(*u.begin());
    return way(v, v, f) + 1;
}

int main() {
    int g, q, x, t, u1, u2;
    cin >> n >> d >> g;
    v.resize(n);
    for (int i = 0; i < n; i++)
        cin >> v[i];
    cin >> q;
    for (int i = 0; i < q; i++) {
        cin >> t >> u1 >> u2;
        if (v[u1 - 1] > v[u2 - 1])
            cout << 0 << '\n';
        else {
            u.clear();
            x = way(u1 - 1, u1 - 1, u2 - 1);
            if (x >= INF)
                x = 0;
            if (t == 1 && x != 0)
                x = 1;
            cout << x << '\n';
        }
    }
}

