#include <bits/stdc++.h>
#define int long long

/* Using libraries */
using namespace std;

using ld = long double;
template <class T>
using vc = vector <T>;
using pii = pair <int, int>;
using pint = pair <int, int>;
template <class T>
int sz(vc <T> &a) {
    return (int)a.size();
}
int sz(string &a) {
    return (int)a.size();
}

template<class T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9;
template<class T>
bool chmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

struct node {
    int suf = 0, pref = 0;
    int f = 1, sum = 0, len = 0;
    node () {}
};
int d;

node merge (node a, node b) {
    node c;
    c.sum = a.sum + b.sum;
    c.len = a.len + b.len;
    c.f = a.f && b.f;
    if (c.sum == 0) {
        c.pref = c.suf = c.len;
        return c;
    }
    if (a.sum == 0) {
        c.pref = b.pref + a.len;
        c.suf = b.suf;
        return c;
    }
    if (b.sum == 0) {
        c.pref = a.pref;
        c.suf = a.suf + b.len;
        return c;
    }
    c.pref = a.pref;
    c.suf = b.suf;
    if (a.suf + b.pref + 1 > d)
        c.f = 0;
    return c;
}

const int N = 3e5;
int t[N * 4];

void upd (int v, int tl, int tr, int i, int x) {
    if (tr - tl == 1) {
        t[v] = x;
    } else {
        int tm = (tl + tr) / 2;
        if (i < tm)
            upd(v << 1, tl, tm, i, x);
        else
            upd(v << 1 | 1, tm, tr, i, x);
        t[v] = max(t[v << 1], t[v << 1 | 1]);
    }
}

int get (int v, int tl, int tr, int l, int r) {
    if (tr <= l || r <= tl) return 0;
    if (l <= tl && tr <= r) return t[v];
    int tm = (tl + tr) / 2;
    return max(get(v << 1, tl, tm, l, r), get(v << 1 | 1, tm, tr, l, r));
}

void solve() {
    int n, huy;
    cin >> n >> d >> huy;
    vc <int> a(n);
    vc <int> ip(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; --a[i];
        ip[a[i]] = i;
    }
    vc <int> go(n);
    set <int> st;
    for (int i = 0; i < n; ++i) {
        int j = ip[i];
        st.insert(j);
        int l = ip[i] + 1, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            int t = get(1, 0, n, ip[i] + 1, ip[i] + m + 1);
            int lst = *prev(st.upper_bound(m));
            if (t <= d && m - lst <= d) {
                l = m;
            } else {
                r = m;
            }
        }
        go[ip[i]] = l;
        if (j != *st.rbegin()) {
            upd(1, 0, n, j, *st.rbegin() - j);
        }
        if (j != *st.begin()) {
            int k = *prev(st.find(j));
            upd(1, 0, n, k, j - k);
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int cmd, u, v;
        cin >> cmd >> u >> v; --u; --v;
        vc <int> dist(n, -1);
        dist[u] = 0;
        queue <int> q;
        q.push(u);
        while (!q.empty()) {
            int i = q.front(); q.pop();
            if (i == v)
                break;
            for (int j = i + 1; j <= go[i]; ++j) {
                if (a[j] > a[i] && dist[j] == -1) {
                    dist[j] = dist[i] + 1;
                    q.push(j);
                }
            }
        }
        cout << (dist[v] == -1 ? 0 : (cmd == 1 ? 1 : dist[v])) << '\n';
    }
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}