#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

int n, d, g;
vector<int> a;
vector<vector<int>> gr;
vector<vector<int>> gr2;
vector<vector<int>> gr3;
vector<vector<int>> ds;
vector<bool> used;

void bfs(int s) {
    ds[s][s] = 0;
    queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto v : gr3[u]) {
            if (ds[s][v] > ds[s][u] + 1) {
                ds[s][v] = ds[s][u] + 1;
                q.push(v);
            }
        }
    }
}

void dfs(int s, int u) {
    used[u] = true;
    for (auto v : gr[u]) {
        if (!used[v])
            dfs(s, v);
    }
    for (auto v : gr2[u]) {
        if (a[s] < a[v] && s < v)
            gr3[s].push_back(v);
    }
}

inline void solve() {
    cin >> n >> d >> g;
    a.resize(n);
    gr.resize(n);
    gr2.resize(n);
    used.resize(n);
    ds.resize(n, vector<int>(n, INF));
    for (auto& i : a)
        cin >> i;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j <= min(n - 1, i + d); ++j) {
            if (a[j] < a[i])
                gr[i].push_back(j);
            else
                gr2[i].push_back(j);
        }
    }
    gr3 = gr2;
    for (int i = 0; i < n; ++i) {
        used.assign(n, false);
        dfs(i, i);
    }
//    for (int i = 0; i < n; ++i) {
//        for (auto j : gr3[i])
//            cout << i + 1 << ' ' << j + 1 << '\n';
//    }
    for (int i = 0; i < n; ++i)
        bfs(i);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int t, u, v;
        cin >> t >> u >> v;
        if (t == 1)
            cout << (ds[u - 1][v - 1] != INF ? 1 : 0) << '\n';
        else
            cout << (ds[u - 1][v - 1] != INF ? ds[u - 1][v - 1] : 0) << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test)
        solve();
    return 0;
}
