#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

int n, d, g;
vector<int> a;
vector<set<int>> gr;
vector<set<int>> gr2;
vector<set<int>> gr_add;
vector<vector<int>> ds;
vector<bool> used;

void bfs(int s) {
    ds[s][s] = 0;
    queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto v : gr2[u]) {
            if (ds[s][v] > ds[s][u] + 1) {
                ds[s][v] = ds[s][u] + 1;
                q.push(v);
            }
        }
    }
}

void dfs(int s, int u) {
    used[u] = true;
    for (auto v : gr[u]) {
        if (v < n && !used[v] && a[s] > a[v])
            dfs(s, v);
        else if (v >= n && a[s] < a[v - n])
            gr_add[s].insert(v);
    }
}

int ans = INF;

void dfs2(int s, int u, int cd = 0, bool flag=false) {
    if (u == -1)
        return;
    if (u == n - 1) {
        if (cd && flag)
            ans = min(ans, cd);
        return;
    }
    used[u] = true;
    int lam = -1;
    int lama = -1;
    for (int i = min(n - 1, u + d); i >= u + 1; --i) {
        if (a[s] > a[i] && lam == -1)
            lam = i;
        else if (lama == -1)
            lama = i;
        else
            break;
    }
    dfs2(s, lam, cd, false);
    dfs2(lama, lama, cd + 1, true);
}

inline void solve() {
    cin >> n >> d >> g;
    if (g == 4) {
        a.resize(n);
        gr.resize(n * 2);
        gr2.resize(n);
        gr_add.resize(n);
        used.resize(n);
        ds.resize(n);
        for (auto &i: a)
            cin >> i;
        int q;
        cin >> q;
        for (int i = 0; i < q; ++i) {
            int t, u, v;
            cin >> t >> u >> v;
            dfs2(u - 1, u - 1);
            if (t == 1)
                cout << (ans == INF ? 0 : 1);
            else
                cout << (ans == INF ? 0 : ans);
        }
    }
    else {
        a.resize(n);
        gr.resize(n * 2);
        gr2.resize(n);
        gr_add.resize(n);
        used.resize(n);
        ds.resize(n);
        for (auto& i : a)
            cin >> i;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j <= min(n - 1, i + d); ++j) {
                gr[i].insert(j);
                if (a[i] < a[j]) {
                    gr[i].insert(n + j);
                    gr2[i].insert(j);
                }
            }
        }
        for (int i = n - 1; i >= 0; --i) {
            used.assign(n, false);
            dfs(i, i);
            for (auto j : gr_add[i]) {
                gr[i].insert(j);
                gr2[i].insert(j - n);
            }
        }
//    for (int i = 0; i < n; ++i) {
//        for (auto j : gr[i])
//            cout << i + 1 << ' ' << j + 1 << '\n';
//    }
        int q;
        cin >> q;
        for (int i = 0; i < q; ++i) {
            int t, u, v;
            cin >> t >> u >> v;
            if (ds[u - 1].empty()) {
                ds[u - 1].resize(n, INF);
                bfs(u - 1);
            }
            if (t == 1)
                cout << (ds[u - 1][v - 1] != INF ? 1 : 0) << '\n';
            else
                cout << (ds[u - 1][v - 1] != INF ? ds[u - 1][v - 1] : 0) << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test)
        solve();
    return 0;
}
