#include <bits/stdc++.h>

using namespace std;

using ll = int;

const ll N = 1e3, INF = 1e9;

vector<ll> gr[N];

void solve(){
    ll n, d, g;
    cin >> n >> d >> g;
    vector<ll> a(n);
    for(ll i = 0; i < n; i++){
        cin >> a[i];
    }
    for(ll i = 0; i < n; i++){
        ll uk = i;
        vector<ll> q;
        q.push_back(i);
        while(true){
            bool fl = false;
            for(ll j = uk + d; j > uk; j--){
                if(j < n){
                    if(a[j] < a[i]){
                        q.push_back(j);
                        fl = true;
                        uk = j;
                        break;
                    }
                }
            }
            if(!fl){
                break;
            }
        }
        ll ls = q.back();
        for(ll j = i + 1; j <= ls + d && j < n; j++){
            if(a[j] > a[i]){
                gr[i].push_back(j);
            }
        }
    }
    vector<vector<ll>> dp(n, vector<ll>(n, INF));
    for(ll s = 0; s < n; s++){
        dp[s][s] = 0;
        queue<ll> q;
        q.push(s);
        while(!q.empty()){
            ll f = q.front();
            q.pop();
            for(auto u : gr[f]){
                if(dp[s][u] == INF){
                    dp[s][u] = dp[s][f] + 1;
                    q.push(u);
                }
            }
        }
    }
    ll q;
    cin >> q;
    while(q--){
        ll type, u, v;
        cin >> type >> u >> v;
        u--, v--;
        if(dp[u][v] == INF){
            cout << 0 << '\n';
        } else if(type == 1){
            cout << 1 << '\n';
        } else {
            cout << dp[u][v] << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    while(t--){
        solve();
    }
}
