#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e9;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, d, gr;
    cin >> n >> d >> gr;
    vector<int> a(n);
    for (auto& el : a)
        cin >> el;
    vector<vector<int>> g(n);
    for (int u = 0; u < n; ++u) {
        int lastgood = u;
        int i = u + 1;
        while (i < n) {
            if (a[i] < a[u]) {
                lastgood = i;
                i += 1;
                continue;
            }
            if (i - lastgood <= d)
                g[u].push_back(i);
            else
                break;
            i += 1;
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        --u, --v;
        vector<int> dist(n, INF);
        dist[u] = 0;
        queue<int> q;
        q.push(u);
        while (!q.empty()) {
            int curv = q.front();
            q.pop();
            if (curv == v)
                break;
            for (auto to : g[curv]) {
                if (dist[to] > dist[curv] + 1) {
                    dist[to] = dist[curv] + 1;
                    q.push(to);
                }
            }
        }
        cout << (dist[v] == INF ? 0 : (t == 2 ? dist[v] : 1)) << '\n';
    }
}