#include <bits/stdc++.h>
#define int long long

using namespace std;

// c = C(2n,n)/(n+1)
// x = y' - (b/a) * x'
// y = x'
// ob[i] = (mod - (m / i) * ob[m % i] % mod + mod) % mod
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int n, d, _;
  cin >> n >> d >> _;
  vector<int> a(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  if (n <= 1000) {
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
      int last = i;
      for (int j = i + 1; j < n; j++) {
        if (abs(last - j) > d) {
          break;
        }
        if (a[j] < a[i]) {
          last = j;
        }
        if (a[j] > a[i]) {
          g[i].push_back(j);
        }
      }
    }
    vector<vector<int>> dp(n, vector<int>(n, n + 5));
    for (int i = 0; i < n; i++) {
      queue<int> q;
      q.push(i);
      dp[i][i] = 0;
      while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto& to : g[v]) {
          if (dp[i][v] + 1 < dp[i][to]) {
            dp[i][to] = dp[i][v] + 1;
            q.push(to);
          }
        }
      }
    }
    int q;
    cin >> q;
    while (q--) {
      int t, u, v;
      cin >> t >> u >> v;
      u--, v--;
      if (dp[u][v] == n + 5) {
        cout << 0 << '\n';
        continue;
      }
      if (t == 1) cout << 1 << '\n';
      else cout << dp[u][v] << '\n';
      /*
      dp[u] = 0;
      for (int i = u; i < v; i++) {
        if (dp[i] == n + 5) continue;
        int last = i;
        for (int j = i + 1; j <= v; j++) {
          if (abs(last - j) > d) {
            break;
          }
          if (a[j] < a[i]) {
            last = j;
          }
          if (a[j] > a[i]) {
            dp[j] = min(dp[j], dp[i] + 1);
          }
        }
      }
      if (dp[v] == n + 5) {
        cout << 0 << '\n';
        continue;
      }
      if (t == 2)
        cout << dp[v] << '\n';
      else
        cout << 1 << '\n';*/
    }
  }
}