#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>


typedef  unsigned long long ll;
using namespace std;



ll Buravchik(map<ll, ll>& a, ll u, ll v, ll d) {
	ll minimum = 1;
	ll prevpoint = u;
	ll prevpoint_by_last_stay = u;
	ll last_stay = u;
	ll last_u = u;
	for (ll i = u + 1; i <= v; i++) {
		if (i - prevpoint > d) {
			if (last_stay == prevpoint) {
				return 0;
			}
			minimum++;
			if (prevpoint_by_last_stay > last_stay) prevpoint = prevpoint_by_last_stay;
			else prevpoint = last_stay;
			last_u = last_stay;
		}
		if (a[last_u] < a[i] && a[i] < a[v]) {
			last_stay = i;
		}
		if (a[i] < a[last_u]) {
			prevpoint = i;
		}
		if (a[i] < a[last_stay]) {
			prevpoint_by_last_stay = i;
		}
	}
	return minimum;
}

int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr); cout.tie(nullptr);


	ll n, d, g;
	cin >> n >> d >> g;
	map<ll, ll> a;
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}

	ll q;
	cin >> q;
	for (ll i = 0; i < q; i++) {
		ll t, u, v;
		cin >> t >> u >> v;
		u--;
		v--;
		if (a[u] >= a[v] || u >= v) {
			cout << 0 << '\n';
			continue;
		}
		ll out = Buravchik(a, u, v, d);
		if (t == 1) cout << (out > 0 ? 1 : 0) << '\n';
		else cout << out << '\n';
	}
}
