#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>


typedef  unsigned long long ll;
using namespace std;



ll Buravchik(map<ll, ll>& a, ll u, ll v, ll d) {
	ll minimum = 1;
	ll prevpoint = u;
	ll prevpoint_by_last_stay = u;
	vector<ll> last_stays;
	ll last_u = u;
	for (ll i = u + 1; i <= v; i++) {
		if (i - prevpoint > d) {
			ll minimum_out = INT64_MAX;
			for (ll j = last_stays.size(); j > -1; j--) {
				if (last_stays[j] <= prevpoint) {
					break;
				}
				minimum++;
				ll out = Buravchik(a, last_stays[j], v, d);
				if (out != 0) minimum_out = min(out, minimum_out);
			}
			if (minimum_out == INT64_MAX) return 0;
			return minimum_out;
		}
		if (a[last_u] < a[i] && a[i] < a[v]) {
			last_stays.push_back(i);
		}
		if (a[i] < a[last_u]) {
			prevpoint = i;
		}
	}
	return minimum;
}

int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr); cout.tie(nullptr);


	ll n, d, g;
	cin >> n >> d >> g;
	map<ll, ll> a;
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}

	ll q;
	cin >> q;
	for (ll i = 0; i < q; i++) {
		ll t, u, v;
		cin >> t >> u >> v;
		u--;
		v--;
		if (a[u] >= a[v] || u >= v) {
			cout << 0 << '\n';
			continue;
		}
		ll out = Buravchik(a, u, v, d);
		if (t == 1) cout << (out > 0 ? 1 : 0) << '\n';
		else cout << out << '\n';
	}
}
