#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18;

void solve(int n, int d) {
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<int> t(n);
    set<pair<int, int>> s;
    for (int i = n - 1; i >= 0; --i) {
        if (s.lower_bound({a[i], i}) == s.begin()) {
            t[i] = i;
        } else {
            t[i] = t[prev(s.lower_bound({a[i], i}))->second];

        }
        s.insert({a[i], i});
        if (i + d < n) {
            s.erase({a[i + d], i + d});
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int qt, u, v;
        cin >> qt >> u >> v;
        u--, v--;
        if (a[v] < a[u]) {
            cout << "0\n";
            continue;
        }
        int ans = 0;
        while (true) {
            ans++;
            int tu = t[u];
            if (v <= tu + d) {
                break;
            }
            int dest = u;
            for (int j = tu + 1; j <= tu + d; ++j) {
                if (a[j] < a[v] && a[j] > a[dest]) {
                    dest = j;
                }
            }
            if (dest == u) {
                ans = -1;
                break;
            }
            u = dest;
        }
        if (ans == -1) {
            cout << 0 << "\n";
        } else if (qt == 1) {
            cout << "1\n";
        } else {
            cout << ans << "\n";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(16);

    int t = 1;
    // cin >> t;
    while (t--) {
        int n, d, g;
        cin >> n >> d >> g;
        solve(n, d);
    }
    return 0;
}
