#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

void solve1(int n, int d) {
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    int q;
    cin >> q;
    vector <int> dp(n);
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        u--; v--;

        if (a[u] > a[v]) {
            cout << 0 << "\n";
            continue;
        }

        dp[u] = 0;
        for (int i = u + 1; i <= v; i++) {
            dp[i] = INF;
            if (a[i] < a[u]) continue;
            int last = i;
            for (int j = i - 1; j >= u; j--) {
                if (a[j] < a[u]) {
                    last = j;
                    continue;
                } else if (a[j] < a[i]) {
                    dp[i] = min(dp[i], dp[j] + 1);
                }
                if (last - j == d) break;
            }
//            if (a[i] < a[u]) {
//                for (int j = 1; j <= d; j++) {
//                    if (i - j < u) break;
//                    int l = i - j;
//                    if (a[l] < a[u]) {
//                        dp[i] = min(dp[i], dp[l]);
//                    } else {
//                        dp[i] = min(dp[i], dp[l] + 1);
//                    }
//                }
//            } else {
//                for (int j = 1; j <= d; j++) {
//                    if (i - j < u) break;
//                    int l = i - j;
//                    if (a[l] < a[u]) {
//                        dp[i] = min(dp[i], dp[l]);
//                    } else if (a[l] < a[i]) {
//                        dp[i] = min(dp[i], dp[l] + 1);
//                    }
//                }
//            }
        }
        if (t == 1) {
            cout << (dp[v] == INF ? 0 : 1) << "\n";
        } else {
            cout << (dp[v] == INF ? 0 : dp[v]) << "\n";
        }
    }
}

void solve() {
    int n, d, g;
    cin >> n >> d >> g;

    if (g <= 1 || true) {
        solve1(n, d);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}