#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef __int128 lll;
const ll inf = 1e18 + 1, mod = 1e9 + 21;
const ld eps = 1e-9, pi = acos(-1);
#define all(a) a.begin(), a.end()

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, d, gg;
    cin >> n >> d >> gg;
    vector<ll> a(n);
    for (auto &i: a)
        cin >> i;
    vector<vector<ll>> g(n);
    for (ll i = 0; i < n; i++) {
        ll it = i;
        while (it < n) {
            ll sl = n;
            for (ll j = it + 1; j < n && j - it <= d; j++)
                if (a[j] > a[i])
                    g[i].push_back(j);
                else
                    sl = j;
            it = sl;
        }
    }
    vector<vector<ll>> ds(n, vector<ll>(n, inf));
    for (ll bg = 0; bg < n; bg++) {
        ds[bg][bg] = 0;
        queue<ll> q;
        q.push(bg);
        while (!q.empty()) {
            ll v = q.front();
            q.pop();
            for (auto i: g[v])
                if (ds[bg][i] == inf) {
                    ds[bg][i] = ds[bg][v] + 1;
                    q.push(i);
                }
        }
    }
    ll q;
    cin >> q;
    while (q--) {
        ll t, u, v;
        cin >> t >> u >> v;
        u--;
        v--;
        if (ds[u][v] == inf)
            cout << "0\n";
        else if (t == 1)
            cout << "1\n";
        else
            cout << ds[u][v] << '\n';
    }
}