#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vector deque

const int maxn = 3e5 + 100;
vector<int> a(maxn, 0);


void slow_solution(int n, int d) {
    vector<vector<int>> edges(n + 1, vector<int>());
    for (int i = 1; i <= n; i++) {
        int last_time_see_tranz = i;
        for (int j = i + 1; j <= n; j++) {
            if (j - last_time_see_tranz > d) {
                break;
            }
            if (a[i] < a[j]) {
                edges[i].push_back(j);
            } else {
                last_time_see_tranz = j;
            }
        }
    }
    vector<vector<int>> dist(n + 1, vector<int>(n + 1, 0));
    for (int i = 1; i <= n; i++) {
        vector<bool> used(n + 1, false);
        vector<int> look;
        look.push_back(i);
        used[i] = true;
        int h = 0;
        while (look.size() > 0) {
            vector<int> new_look;
            for (auto v : look) {
                dist[i][v] = h;
                for (auto u : edges[v]) {
                    if (!used[u]) {
                        used[u] = true;
                        new_look.push_back(u);
                    }
                }
            }
            look = new_look;
            h++;
        }
    }
    int q;
    cin >> q;
    int one = 1;
    for (; q > 0; --q) {
        int type, a, b;
        cin >> type >> a >> b;
        if (type == 2) {
            cout << dist[a][b] << '\n';
        } else {
            cout << min(dist[a][b], one) << '\n';
        }
    }
}



signed main() {
    cout.precision(15);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, d, g;
    cin >> n >> d >> g;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    slow_solution(n, d);
}

