#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>
#include <array>
using namespace std;
using ll = long long;
vector<vector<int>> g; const int inf = 1e9;
vector<vector<int>> dist;
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, d, gr; cin >> n >> d >> gr; vector<int> v(n);
	for (auto& i : v) cin >> i;
	vector<int> ln(n);
	for (int i = 0; i < n; i++) {
		int pos = i;
		for (int j = i + 1; j < n; j++) {
			if (v[j] < v[i]) {
				pos = j;
			}
			if (j - pos == d) break;
		}
		ln[i] = min(n - 1, pos + d);
		//cout << ln[i] << " ";
	}
	//cout << endl;
	g.resize(n);
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (v[i] < v[j] && j <= ln[i]) {
				//cout << i << " " << j << " edge" << endl;
				g[i].push_back(j);
			}
		}
	}
	dist.resize(n, vector<int>(n, inf));
	for (int st = 0; st < n; st++) {
		dist[st][st] = 0; queue<int> q; q.push(st);
		while (!q.empty()) {
			int u = q.front(); q.pop();
			for (auto to : g[u]) {
				if (dist[st][to] > dist[st][u] + 1) {
					dist[st][to] = dist[st][u] + 1; q.push(to);
				}
			}
		}
	}
	int q; cin >> q;
	while (q--) {
		int a, b, t; cin >> t >> a >> b; a--; b--;
		if (dist[a][b] != inf) {
			if (t == 1) {
				cout << "1\n";
			} else {
				cout << dist[a][b] << "\n";
			}
		} else {
			cout << "0\n";
		}
	}
	return 0;
}
