#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int S = 19, SS = 10;
int R = (1 << S);
vector<pii> t(R * 2, {-1, -1});

void update(int i, int x) {
    int v = R + i;
    t[v] = {x, i};
    v >>= 1;
    while (v > 0) {
        t[v] = max(t[v << 1], t[(v << 1) ^ 1]);
        v >>= 1;
    }
}

pii get_max(int ql, int qr, int v = 1, int l = 0, int r = R) {
    if (ql >= r || l >= qr)
        return {-1, -1};
    if (ql <= l && r <= qr)
        return t[v];
    int m = (l + r) / 2;
    return max(get_max(ql, qr, (v << 1), l, m), get_max(ql, qr, ((v << 1) ^ 1), m, r));
}

vi t1(R * 2, R);

void update1(int ql, int qr, int x, int v = 1, int l = 0, int r = R) {
    if (ql >= r || l >= qr)
        return;
    if (ql <= l && r <= qr) {
        t1[v] = min(t1[v], x);
        return;
    }
    int m = (l + r) / 2;
    update1(ql, qr, x, v * 2, l, m);
    update1(ql, qr, x, v * 2 + 1, m, r);
}

int get1(int i) {
    int ans = R, v = R + i;
    while (v > 0) {
        ans = min(ans, t1[v]);
        v >>= 1;
    }
    return ans;
}

int main() {
    fast;
    int n, d, gr;
    cin >> n >> d >> gr;
    vi a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        b[a[i]] = i;
    }
    vi jp(n);
    set<int> s;
    for (int i = n - d + 1; i < n; ++i) {
        s.insert(a[i]);
        jp[i] = i;
    }
    for (int i = n - d; i >= 0; --i) {
        s.insert(a[i]);
        jp[i] = get1(a[i]);
        update1(0, *s.begin(), i - 1);
        s.erase(a[i + d - 1]);
    }
    vi r(n);
    for (int i = 0; i < n; ++i)
        r[i] = min(jp[i] + d, n - 1);
    int q;
    cin >> q;
    if (gr >= 3 && gr <= 5) {
        vector<vi> up(n, vi(S));
        for (int i = a[n - 1]; i >= 0; --i) {
            update(b[i], r[b[i]]);
            up[b[i]][0] = get_max(b[i], r[b[i]] + 1).second;
        }
        for (int st = 1; st < S; ++st) {
            for (int i = 0; i < n; ++i)
                up[i][st] = up[up[i][st - 1]][st - 1];
        }
        while (q--) {
            int tp, u, v;
            cin >> tp >> u >> v;
            --u;
            --v;
            if (a[u] > a[v])
                cout << "0\n";
            else if (r[u] >= v)
                cout << "1\n";
            else {
                int x = 2;
                for (int st = S - 1; st >= 0; --st) {
                    if (r[up[u][st]] < v) {
                        x += (1 << st);
                        u = up[u][st];
                    }
                }
                u = up[u][0];
                if (r[u] < v)
                    cout << "0\n";
                else if (tp == 1)
                    cout << "1\n";
                else
                    cout << x << '\n';
            }
        }
    }
    else {
        R = (1 << SS);
        vector<vector<vi>> up(n, vector<vi>(n, vi(S)));
        for (int v = 0; v < n; ++v) {
            t.assign(R * 2, {-1, -1});
            for (int i = a[v]; i >= 0; --i) {
                update(b[i], r[b[i]]);
                up[v][b[i]][0] = get_max(b[i], r[b[i]] + 1).second;
            }
            for (int st = 1; st < S; ++st) {
                for (int i = 0; i < n; ++i)
                    up[v][i][st] = up[v][up[v][i][st - 1]][st - 1];
            }
        }
        while (q--) {
            int tp, u, v;
            cin >> tp >> u >> v;
            --u;
            --v;
            if (a[u] > a[v])
                cout << "0\n";
            else if (r[u] >= v)
                cout << "1\n";
            else {
                int x = 2;
                for (int st = S - 1; st >= 0; --st) {
                    if (r[up[v][u][st]] < v) {
                        x += (1 << st);
                        u = up[v][u][st];
                    }
                }
                u = up[v][u][0];
                if (r[u] < v)
                    cout << "0\n";
                else if (tp == 1)
                    cout << "1\n";
                else
                    cout << x << '\n';
            }
        }
    }
}
