//#define GLIBCXX_DEBUG
#include <bits/stdc++.h>

#define int long long
#define ld long double
#define F first
#define S second
using namespace std;
int n, d, G;
vector<vector<int>> g;
vector<vector<int>> ng;
const int inf = 1e18;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> d >> G;
    g.resize(n);
    vector<int> a(n);
    ng.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j <= min(n - 1, i + d); ++j) {
            if (a[j] < a[i]) {
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        queue<int> q;
        q.push(i);
        vector<int> dist(n, inf);
        dist[i] = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int u: g[v]) {
                if (dist[u] > dist[v] + 1) {
                    dist[u] = dist[v] + 1;
                    q.push(u);
                }
            }
        }
        for (int j = i + 1; j < n; ++j) {
            if (a[j] < a[i]) {
                continue;
            }
            for (int k = 0; k < j; ++k) {
                if (dist[k] != inf && j - k <= d) {
                    ng[i].push_back(j);
                    break;
                }
            }
        }
    }
    int _;
    cin >> _;
    while (_--) {
        int t, v, u;
        cin >> t >> v >> u;
        v--;
        u--;
        queue<int> q;
        vector<int> dist(n, inf);
        dist[v] = 0;
        q.push(v);
        while (!q.empty()) {
            int f = q.front();
            q.pop();
            for (int i: ng[f]) {
                if (dist[i] > dist[f] + 1) {
                    dist[i] = dist[f] + 1;
                    q.push(i);
                }
            }
        }
        if (dist[u] == inf) {
            cout << 0;
        } else {
            if (t == 1) {
                cout << 1;
            } else {
                cout << dist[u];
            }
        }
        cout << '\n';
    }
    return 0;
}
