#pragma gcc optimize("O3, unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
// #define int ll
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll mod = 1000000007;
const ll inf = 1e18;
const int mxn = 1e9 + 7;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << a << endl;
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;

void solve() {
    int n, d, g; cin >> n >> d >> g;
    if (g <= 2) {
        vector <int> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        int q; cin >> q;
        while (q--) {
            int t, u, v; cin >> t >> u >> v; --u; --v;
            int curr = u, ans = 0;
            while (curr != v) {
                if (v - curr <= d) {
                    curr = v;
                    ++ans; break;
                }
                else {
                    bool found = false;
                    for (int i = curr + d; i > curr; --curr) {
                        if (a[i] < a[u]) {
                            curr = i;
                            found = true;
                            ++ans;
                            break;
                        }
                    }
                    if (!found) {
                        break;
                    }
                }
            }
            if (t == 1) {
                cout << (curr == v ? 1 : 0) << '\n';
            }
            else {
                cout << (curr == v ? ans - 1 : 0) << '\n';
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> t;
    while (tt--) solve();
}