#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

const int OO = 1e18;

const int N = 3e5 + 10;
int mn[4 * N];

void upd(int idx, int val, int v, int tl, int tr) {
    if (tl == tr) {
        mn[v] = val;
        return;
    }

    int m = tl + tr >> 1;
    if (idx <= m) {
        upd(idx, val, 2 * v + 1, tl, m);
    } else {
        upd(idx, val, 2 * v + 2, m + 1, tr);
    }

    mn[v] = min(mn[2 * v + 1], mn[2 * v + 2]);
}

int get(int l, int r, int v, int tl, int tr) {
    if (tl > r || tr < l) return OO;
    if (tl >= l && tr <= r) {
        return mn[v];
    }

    int m = tl + tr >> 1;
    return min(get(l, r, 2 * v + 1, tl, m), get(l, r, 2 * v + 2, m + 1, tr));
}

int n, d, G;
set<pii> setik;

void solve() {
    cin >> n >> d >> G;

    vec<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    if (n <= 1100) {
        vec<vec<bool>> can(n + 1, vec<bool>(n + 1));
        for (int l = 1; l <= n; l++) {
            int last_less = l;

            for (int r = l; r <= n; r++) {
                if (r - last_less > d) break;

                if (a[r] < a[l]) {
                    last_less = r;
                } else {
                    can[l][r] = true;
                }
            }
        }

        vec<vec<int>> cnt(n + 1, vec<int>(n + 1, OO));
        for (int l = 1; l <= n; l++) {
            for (int r = l; r <= n; r++) {
                if (can[l][r]) {
                    cnt[l][r] = 1;
                }
            }
        }
        for (int k = 1; k <= n; k++) {
            for (int u = 1; u <= n; u++) {
                for (int v = u; v <= n; v++) {
                    if (cnt[u][k] + cnt[k][v] < cnt[u][v]) {
                        cnt[u][v] = cnt[u][k] + cnt[k][v];
                    }
                }
            }
        }

        int q;
        cin >> q;
        while (q--) {
            int t, u, v;
            cin >> t >> u >> v;

            if (t == 1) {
                cout << (cnt[u][v] == OO ? 0 : 1);
            } else {
                cout << (cnt[u][v] == OO ? 0 : cnt[u][v]);
            }

            cout << '\n';
        }

        return;
    }


    vec<int> r(n + 1, -1);
    vec<int> p(n + 1);
    for (int i = 1; i <= n; i++) {
        p[a[i]] = i;
    }

    for (int val = 1; val <= n; val++) {

    }



    vec<int> dp(n + 1, OO);
    dp[n] = 0;
    for (int i = n - 1; i >= 1; i--) {
        if (r[i] != -1) {
            dp[i] = 1 + get(i + 1, r[i], 0, 0, n);
        }

        upd(a[i], dp[i], 0, 0, n);
    }

    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;

        if (t == 1) {
            cout << (dp[u] == OO ? 0 : 1);
        } else {
            cout << (dp[u] == OO ? 0 : dp[u]);
        }

        cout << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
