#include <bits/stdc++.h>
using namespace std;

void create(vector<int>& tree, int n) {
    int x(1);
    while (x < n) {
        x *= 2;
    }
    tree.assign(2 * x, 0);
}

void add(vector<int>& tree, int k, int x) {
    while (k > 0) {
        tree[k] = max(tree[k], x);
        k /= 2;
    }
}

int get(vector<int>& tree, int x, int l, int r, int lq, int rq) {
    if ((l >= rq) || (r <= lq)) {
        return 0;
    }
    if ((l >= lq) && (r <= rq)) {
        return tree[x];
    }
    int m((l + r) / 2);
    return max(get(tree, 2 * x, l, m, lq, rq), get(tree, 2 * x + 1, m, r, lq, rq));
}

void ps(vector<int>& tree, int r) {
    return get(tree, 1, 0, tree.size() / 2, 0, r);
}

vector<int> invert(int n, vector<int>& a) {
    vector<int> b(n, -1);
    for (int i = 0; i < n; i++) {
        b[a[i]] = i;
    }
    return b;
}

vector<int> create_shovels(int n, int d, vector<int>& a) {
    vector<int> b(invert(n, a));
    vector<int> c(n, 0);
    for (int i = 0; i < n; i++) {
        c[i] = min(i + d, n - 1);
    }
    vector<int> ans(n, 0);
    set<int> initial_vals{};
    for (int i = 0; i < n; i++) {
        /*for (auto j : c) {
            cout << j << " ";
        }
        cout << endl;
        for (auto j : initial_vals) {
            cout << j << " ";
        }
        cout << endl;*/
        auto it(initial_vals.insert(b[i]).first);
        int s;
        if (it != initial_vals.begin()) {
            it--;
            if (c[*it] >= b[i]) {
                s = *it;
            } else {
                it++;
                s = b[i];
            }
        } else {
            s = b[i];
        }
        it++;
        while (it != initial_vals.end()) {
            if (*it <= c[s]) {
                c[s] = max(c[s], c[*it]);
                it = initial_vals.erase(it);
            } else {
                break;
            }
        }
        ans[b[i]] = min(c[s], n - 1);
    }
    return ans;
}

void g1(int n, int d, vector<int>& a, vector<tuple<int, int, int>>& q) {
    vector<int> sh(create_shovels(n, d, a));
    /*for (auto i : sh) {
        cout << i << " ";
    }*/
    for (auto i : q) {
        int s(get<1>(i)), t(a[get<2>(i)]);
        int k(0);
        while (a[s] < t) {
            //cout << s << " ";
            int msh(s);
            for (int j = s; j <= sh[s]; j++) {
                if ((a[j] > a[msh]) && (a[j] <= t)) {
                    msh = j;
                }
            }
            if (msh == s) {
                break;
            }
            s = msh;
            k++;
        }
        //cout << "!" << endl;
        if (a[s] != t) {
            cout << 0 << endl;
            continue;
        }
        if (get<0>(i) == 1) {
            cout << 1 << endl;
        } else {
            cout << k << endl;
        }
    }
}

void g3(int n, int d, vector<int>& a, vector<tuple<int, int, int>>& q) {
    vector<int> b(invert(n, a));
    vector<int> sh(create_shovels(n, d, a));
    /*for (auto i : sh) {
        cout << i << " ";
    }*/
    vector<int> tree;
    create(tree, n);
    for (int i = 0; i < n; i++) {
        add(tree, i, a[i]);
    }
    vector<int> u(n, 0);
    for (int i = 0; i < n; i++) {
        u[i] = b[get(tree, 1, 0, tree.size() / 2, i, sh[i] + 1)];
    }
    vector<int> w(n, 0);
    for (int i = n - 2; i >= 0; i--) {
        w[i] = w[u[i]] + 1;
    }
    for (auto i : q) {
        if (get<0>(i) == 1) {
            cout << 1 << endl;
        } else {
            cout << w[get<1>(i)] << endl;
        }
    }
}

void g4(int n, int d, vector<int>& a, vector<tuple<int, int, int>>& q) {
    vector<int> sh(create_shovels(n, d, a));
    /*for (auto i : sh) {
        cout << i << " ";
    }*/
    for (auto i : q) {
        int s(get<1>(i)), t(a[get<2>(i)]), u(s);
        int k(0);
        while (a[s] < t) {
            //cout << s << " ";
            int msh(s);
            for (int j = u; j <= sh[s]; j++) {
                if ((a[j] > a[msh]) && (a[j] <= t)) {
                    msh = j;
                }
            }
            if (msh == s) {
                break;
            }
            u = sh[s] + 1;
            s = msh;
            k++;
        }
        //cout << "!" << endl;
        if (a[s] != t) {
            cout << 0 << endl;
            continue;
        }
        if (get<0>(i) == 1) {
            cout << 1 << endl;
        } else {
            cout << k << endl;
        }
    }
}

void g8(int n, int d, vector<int>& a, vector<tuple<int, int, int>>& q) {
    reverse(a.begin(), a.end());
    vector<int> sh(create_shovels(n, d, a));
    for (auto i : q) {
        int v(n - 1 - get<2>(i)), u(n - 1 - get<1>(i));
        if ((sh[v] >= u) && (a[v] > a[u])) {
            cout << 1 << endl;
        } else {
            cout << 0 << endl;
        }
    }
}

int main() {
    int n, d, g, q, r, s, t;
    cin >> n >> d >> g;
    vector<int> v{};
    for (int i = 0; i < n; i++) {
        cin >> q;
        q--;
        v.push_back(q);
    }
    cin >> t;
    vector<tuple<int, int, int>> tup{};
    for (int i = 0; i < t; i++) {
        cin >> q >> r >> s;
        r--;
        s--;
        tup.push_back({q, r, s});
    }
    if (g <= 1) {
        g1(n, d, v, tup);
    } else if (g == 8) {
        g8(n, d, v, tup);
    } else if (g == 4) {
        g4(n, d, v, tup);
    } else if (g == 3) {
        g3(n, d, v, tup);
    }
}
