#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll N = 3e5 + 5;
ll a[N];

unordered_map<ll, ll> qp;
ll n, d, g;

ll dfs(ll v, ll u, ll e) {
    if (v == u) {
        return 0;
    }
    ll hash = v + u * N + e * N * N;
    if (qp.count(hash)) {
        return qp[hash];
    }
    ll mk = 1e9;
    for (int i = 1; i <= d && v + i <= u; ++i) {
        if (a[v + i] < e && u != v + i) {
            mk = min(mk, dfs(v + i, u, e));
        } else {
            mk = min(mk, dfs(v + i, u, a[v + i]) + 1);
        }
    }
    qp[hash] = mk;
    return mk;
}

void solve() {
    cin >> n >> d >> g;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    ll q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        ll t, v, u;
        cin >> t >> v >> u;
        ll o = dfs(v, u, a[v]);
        if (o == (ll) 1e9) {
            cout << 0 << '\n';
        } else {
            if (t == 1) {
                o = 1;
            }
            cout << o << '\n';
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}
