#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    cin >> a;
    vector<vector<ll>> dp(n, vector<ll>(n, INF));
    for (int i = 0; i < n; ++i) {
        int mx = -INF, lst = i;
        dp[i][i] = 0;
        for (int j = i + 1; j < n; ++j) {
            mx = max(mx, j - lst);
            if (a[j] > a[i] && mx <= d) {
                dp[i][j] = 1;
            }
            if (a[j] < a[i]) {
                lst = j;
            }
        }
    }
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                dp[i][j] = min(dp[i][j], dp[i][k] + dp[k][j]);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        --u; --v;
        ll res = (dp[u][v] == INF ? 0 : dp[u][v]);
        if (t == 1) {
            cout << min(res, 1ll) << "\n";
        } else {
            cout << res << "\n";
        }
    }
}
