#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#pragma pack(push, 1)

#define int long long

using namespace std;
//using namespace __gnu_pbds;

//using ordered_multiset = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;
using lll = __int128;
using lld = __float128;

mt19937_64 gen(time(nullptr));

bool check(int v, int u, int d, vector<int> &arr) {
    int steps = 0, vv = v, i;
    bool flag = true;
    if (arr[u] < arr[v]) {
        flag = false;
    }
    while (v != u && flag) {
        flag = false;
        for (i = min(v + d, u); i > v && !flag; i--) {
            if (arr[vv] > arr[i] || i == u) {
                flag = true;
                v = i;
                steps++;
            }
        }
    }
    return flag;
}

vector<int> bfs(int start, vector<vector<int>> &g) {
    int n = g.size(), i;
    vector<int> dist(n, 1e9);
    dist[start] = 0;
    deque<int> q = {start};
    while (!q.empty()) {
        int v = q[0];
        q.pop_front();
        for (int u : g[v]) {
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                q.push_back(u);
            }
        }
    }
    return dist;
}

signed main() {
#ifdef LOCAL
    freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, d, group, i, q, type, v, u, steps, j;
    cin >> n >> d >> group;
    vector<int> arr(n);
    for (i = 0; i < n; i++) {
        cin >> arr[i];
    }
    vector<vector<int>> g(n), dist(n);
    for (i = 0; i < n; i++) {
        for (j = i; j < n; j++) {
            if(check(i, j, d, arr)) {
                g[i].push_back(j);
            }
        }
    }
    for (i = 0; i < n; i++) {
        dist[i] = bfs(i, g);
    }
    cin >> q;
    while (q--) {
        cin >> type >> v >> u;
        v--, u--;
        if (dist[v][u] == 1e9) {
            cout << "0\n";
        } else if (type == 1) {
            cout << "1\n";
        } else {
            cout << dist[v][u] << '\n';
        }
    }
}