#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

const int MX = 1000;

int go[MX][MX], dst[MX][MX];

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (auto &i: a) {
        cin >> i, --i;
    }
    vector<int> lst(n, -1);
    for (int i = 0; i < MX; ++i) {
        for (int j = 0; j < MX; ++j) {
            go[i][j] = false;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (a[i] > a[j]) {
                go[i][j] = false;
                continue;
            }
            int last = i;
            bool f = true;
            for (int q = i + 1; q < j; ++q) {
                if (a[q] < a[i]) {
                    if (q - last > d) {
                        f = false;
                        break;
                    }
                    last = q;
                }
            }
            f &= j - last <= d;
            go[i][j] = f;
        }
    }
    const int INF = 1e9;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (go[i][j]) {
                dst[i][j] = 1;
            } else {
                dst[i][j] = INF;
            }
        }
        dst[i][i] = 0;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = i + 1; k < j; ++k) {
                if (max(dst[i][k], dst[k][j]) == INF) continue;
                dst[i][j] = min(dst[i][j], dst[i][k] + dst[k][j]);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        int u, v;
        cin >> u >> v;
        --u, --v;
        if (t == 1) {
            cout << (dst[u][v] != INF) << '\n';
        } else {
            if (dst[u][v] == INF) {
                cout << "0\n";
            } else {
                cout << dst[u][v] << '\n';
            }
        }
    }
}