/* In the name of GOD */

#pragma GCC optimize ("O3,unroll-loops")

#include <bits/stdc++.h>

#pragma GCC target ("avx2")

using namespace std;
#define F first
#define S second
#define mk make_pair
typedef long long ll;
typedef pair <int, int> pii;
const int N = 300002, INF = 1e9;
int a[N];
struct que {
	int t, u, v, ans;
} qu[N];
struct Node {
	bool f;
	int p, s, all;
} seg[N << 2];
int mn[N << 2], x[N];
vector <int> wv[N];
int w[N];

Node Merge (Node A, Node B) {
	Node x;
	x.f = A.f & B.f;
	x.all = max ({A.all, B.all, A.s + B.p});
	x.p = A.p + A.f * B.p;
	x.s = B.s + B.f * A.s;
	return x;
}

void upd (int i, int v = 1, int tl = 0, int tr = N - 1) {
	if (tl == tr) {
		seg[v].f = true;
		seg[v].p = seg[v].s = seg[v].all = 1;
		return;
	}
	int mid = (tl + tr) >> 1;
	if (i <= mid)
		upd (i, v << 1, tl, mid);
	else
		upd (i, v << 1 | 1, mid + 1, tr);
	seg[v] = Merge (seg[v << 1], seg[v << 1 | 1]);
}

Node get (int l, int r, int v = 1, int tl = 0, int tr = N - 1) {
	if (tl > r || l > tr) {
		Node x;
		x.f = true;
		x.p = x.s = x.all = 0;
		return x;
	}
	if (l <= tl && tr <= r)
		return seg[v];
	int mid = (tl + tr) >> 1;
	return Merge (get(l, r, v << 1, tl, mid), get (l, r, v << 1 | 1, mid + 1, tr));
}

void build (int v = 1, int tl = 0, int tr = N - 1) {
	mn[v] = INF;
	if (tl != tr) {
		int mid = (tl + tr) >> 1;
		build (v << 1, tl, mid);
		build (v << 1 | 1, mid + 1, tr);
	}
}

void upd2 (int i, int x, int v = 1, int tl = 0, int tr = N - 1) {
	if (tl == tr) {
		mn[v] = x;
		return;
	}
	int mid = (tl + tr) >> 1;
	if (i <= mid)
		upd2 (i, x, v << 1, tl, mid);
	else
		upd2 (i, x, v << 1 | 1, mid + 1, tr);
	mn[v] = min(mn[v << 1], mn[v << 1 | 1]);
}

int get2 (int l, int r, int v = 1, int tl = 0, int tr = N - 1) {
	if (tl > r || l > tr) {
		return INF;
	}
	if (l <= tl && tr <= r)
		return mn[v];
	int mid = (tl + tr) >> 1;
	return min (get2(l, r, v << 1, tl, mid), get2 (l, r, v << 1 | 1, mid + 1, tr));
}

void solve (int i) {
	build ();
	for (int j = a[i]; j >= 1; j--) {
		int dp = INF;
		if (j == a[i])
			dp = 0;
		else {
			dp = get2 (w[j] + 1, x[w[j]] + 1) + 1;
		}
		upd2 (w[j], dp);
	}
	for (int qi : wv[i]) {
		int kk = get2 (qu[qi].u, qu[qi].u);
		if (kk >= INF / 10)
			kk = 0;
		qu[qi].ans = kk;
	}
}

int32_t main() {
	int n, d, g;
	cin >> n >> d >> g;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		w[a[i]] = i;
	}
	int q;
	cin >> q;
	for (int i = 1; i <= q; i++) {
		cin >> qu[i].t >> qu[i].u >> qu[i].v;
		qu[i].ans = -1;
		if (a[qu[i].u] > a[qu[i].v])
			qu[i].ans = 0;
		wv[a[qu[i].v]].push_back(i);
	}
	for (int i = n; i >= 1; i--) {
		for (int qi : wv[i]) {
			if (get (qu[qi].u, qu[qi].v - 1).all >= d)
				qu[qi].ans = 0;
		}
		upd (w[i]);
		int l = w[i], r = n + 1;
		while (r - l > 1) {
			int mid = (l + r) >> 1;
			if (get (w[i] + 1, mid).all >= d) {
				r = mid;
			} else {
				l = mid;
			}
		}
		x[w[i]] = l;
	}
	if (g == 8) {
		for (int i = 1; i <= q; i++) {
			cout << abs(qu[i].ans) << '\n';
		}
		return 0;
	} 
	for (int i = 0; i <= n; i++)
		wv[i].clear();
	for (int i = 1; i <= q; i++) {
		if (qu[i].t == 1)
			qu[i].ans = abs(qu[i].ans);
		else {
			wv[qu[i].v].push_back(i);
		}
	}
	for (int i = 1; i <= n; i++) {
		if (wv[i].empty())
			continue;
		solve (i);
	}
	for (int i = 1; i <= q; i++) {
		cout << qu[i].ans << '\n';
	}
}
