#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 10 , M = 1e3 + 10;
int n , d , g , a[N] , r[N] , q , dis[M][M];
vector <int> adj[M];
bool marked[N];

void Bfs(int star)
{
	queue <int> q;
	q.push(star);
	for(int i = 0 ; i < n ; i++)
		marked[i] = false;
	marked[star] = true;
	while(!q.empty())
	{
		int v = q.front();  q.pop();
		for(auto u : adj[v])  if(!marked[u])
		{
			dis[star][u] = dis[star][v] + 1;
			marked[u] = true;
			q.push(u);
		}
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);  cout.tie(0);
	cin >> n >> d >> g;
	vector <int> vec;
	for(int i = 0 ; i < n ; i++)
	{
		cin >> a[i];
		vec.push_back(i);
	}
	for(int i = 0 ; i < n ; i++)
	{
		int cnt_bad = 0;
		for(int j = i + 1 ; j < n ; j++)
		{
			if(a[j] > a[i])
				cnt_bad++;
			else
				cnt_bad = 0;
			if(cnt_bad > d)
				break;
			if(a[j] > a[i])
				adj[i].push_back(j);
		}
	}
	if(g <= 2)
	{
		for(int i = 0 ; i < n ; i++)
			Bfs(i);
		cin >> q;
		while(q--)
		{
			int t , fr , to;  cin >> t >> fr >> to; fr--; to--;
			int ans = dis[fr][to];
			if(t == 1)
				ans = min(ans , 1);
			cout << ans << '\n';
		}
	}
	return 0;
}