// ormlis_wa.cpp
#include "bits/stdc++.h"

#define rep(i, n) for (int i = 0; i < (n); ++i)
#define rep1(i, n) for (int i = 1; i < (n); ++i)
#define rep1n(i, n) for (int i = 1; i <= (n); ++i)
#define repr(i, n) for (int i = (n) - 1; i >= 0; --i)
#define pb push_back
#define eb emplace_back
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define each(x, a) for (auto &x : a)
#define ar array
#define vec vector
#define range(i, n) rep(i, n)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;

using vi = vector<int>;
using vl = vector<ll>;
using vpl = vector<pl>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;

int Bit(int mask, int b) { return (mask >> b) & 1; }

template<class T>
bool ckmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<class T>
bool ckmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

const int INFi = 2e9;
const ll INF = 2e18;

void solve() {
    int n; cin >> n;
    vi a(n), b(n);
    rep(i, n) cin >> a[i];
    rep(i, n) cin >> b[i];
    // sum_a - sum_b = ans
    map<int, int> mp;
    int ans = 0;
    auto Add = [&] (int l, int r) {
        auto it = mp.lower_bound(l);
        while (it != mp.end() && it->first <= r) {
            ckmax(r, it->second);
            it = mp.erase(it);
        }
        if (it != mp.begin() && prev(it)->second >= l) {
            it--;
            ckmax(it->second, r);
        } else {
            mp[l] = r;
        }
    };
    ll sum_a = 0;
    ll sum_b = 0;
    rep(i, n) {
        Add(b[i], a[i]);
        sum_a += a[i];
        sum_b += b[i];
        ckmax(ans, a[i] - b[i]);
        auto it = mp.begin();
        rep(_, 200) {
            if (it == mp.end()) break;
            ckmax(ans, it->second - it->first);
            ++it;
        }
        it = mp.end();
        rep(_, 200) {
            if (it == mp.begin()) break;
            --it;
            ckmax(ans, it->second - it->first);
        }
        cout << sum_a - sum_b - ans << ' ';
    }
    cout << '\n';
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << setprecision(15) << fixed;
    int t = 1;
//    precalc();
    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}