#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <random>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    int suma = a[0], sumb = b[0];
    vector<int> A = {a[0]}, B = {b[0]};
    cout << "0 ";
    for (int i = 1; i < n; ++i) {
        suma += a[i];
        sumb += b[i];
        A.emplace_back(a[i]);
        for (int j = (int) A.size() - 2; j >= 0 && A[j] > A[j + 1]; --j) {
            swap(A[j], A[j + 1]);
        }
        B.emplace_back(b[i]);
        for (int j = (int) B.size() - 2; j >= 0 && B[j] > B[j + 1]; --j) {
            swap(B[j], B[j + 1]);
        }
        std::sort(A.begin(), A.end());
        std::sort(B.begin(), B.end());
        int pos = -1;
        int f = 0;
        for (int j = 0; j <= i; ++j) {
            if (j == i || A[j] < B[j + 1]) {
                f = max(f, A[j] - B[pos + 1]);
                pos = j;
            }
        }
        cout << suma - sumb - f << ' ';
    }
    cout << '\n';
}

signed main() {
    fast_in_out();
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
