#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <ctime>

#define int long long
#define x first
#define y second

std::mt19937 rnd(std::time(nullptr));
const int INF = 1e18;
const int MAXN = 1e5;
int MAXW = 0;

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> a(n), b(n);
    for (auto &e : a) {
        std::cin >> e;
    }
    for (auto &e : b) {
        std::cin >> e;
    }
    bool sorted = true;
    for (int i = 0; i + 1 < n; i++) {
        if (a[i] > a[i + 1] || b[i] > b[i + 1]) {
            sorted = false;
            break;
        }
    }
    if (sorted) {
        int sum = 0;
        int l = 0, r = 0;
        int d = 0;
        for (int i = 0; i < n; i++) {
            sum += a[i] - b[i];
            d = std::max(d, a[r] - b[l]);
            while (r < i) {
                while (r < i && a[r] >= b[r + 1]) {
                    r++;
                }
                d = std::max(d, a[r] - b[l]);
                if (r < i) {
                    l = r = r + 1;
                }
            }
            std::cout << sum - d << ' ';
        }
        std::cout << '\n';
        return;
    }
    int sum = 0;
    std::vector<int> p(n);
    for (int i = 0; i < n; i++) {
        sum += a[i] - b[i];
        std::sort(a.begin(), a.begin() + i + 1);
        std::sort(b.begin(), b.begin() + i + 1);
        int ans = sum;
        int l = 0, r = 0;
        while (r <= i) {
            while (r < i && a[r] >= b[r + 1]) {
                r++;
            }
            ans = std::min(ans, sum - a[r] + b[l]);
            l = r = r + 1;
        }
        std::cout << ans << ' ';
    }
    std::cout << '\n';
}

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    std::cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}
