#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>
#define int long long

using namespace std;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n), b(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> b[i];
        }
        bool group45 = true;
        for (int i = 0; i < n - 1; ++i) {
            if (!(a[i] <= a[i + 1] && b[i] <= b[i + 1])) {
                group45 = false;
                break;
            }
        }
        if (group45) {
            cout << 0 << " ";
            multiset<int> ans;
            int inf = 1e15;
            int dpn = 0;
            int dp0 = 0;
            int mn = 0;
            int prev = 0;
            for (int i = 1; i < n; ++i) {
                mn += a[i] - b[i];
                if (a[i] - b[i - 1] < 0) {
                    dpn = inf;
                } else {
                    dpn += a[i] - b[i - 1];
                }
                dpn = min(dpn, prev + a[i - 1] - b[i - 1]);
                if (a[i - 1] - b[i] < 0) {
                    dp0 = inf;
                } else {
                    dp0 += a[i - 1] - b[i];
                }
                dp0 = min(dp0, prev + a[i - 1] - b[i - 1]);
                prev += a[i - 1] - b[i - 1];
                mn = min(mn, min(dp0, dpn));
                cout << mn << " ";
            }
            cout << '\n';
        } else {
            vector<int> A, B;
            for (int len = 1; len <= n; ++len) {
                int cur = 1e15;
                A.push_back(a[len - 1]);
                B.push_back(b[len - 1]);
                sort(A.begin(), A.end());
                sort(B.begin(), B.end());
                for (int i = 0; i < len; ++i) {
                    vector<int> add(n);
                    for (int j = 0; j < len - 1; ++j) {
                        if (j < i) {
                            add[j] = A[j] - B[j];
                        } else {
                            add[j] = A[j + 1] - B[j];
                        }
                    }
                    int sum = 0;
                    int ban = 0;
                    for (int j = 0; j < len; ++j) {
                        sum += add[j];
                        ban += (add[j] < 0);
                    }
                    if (!ban) {
                        cur = min(cur, sum);
                    }
                    for (int j = len - 2; j >= 0; --j) {
                        sum -= add[j];
                        ban -= (add[j] < 0);
                        add[j + 1] = A[j + 1 - (j < i)] - B[j + 1];
                        sum += add[j + 1];
                        ban += (add[j + 1] < 0);
                        if (!ban) {
                            cur = min(cur, sum);
                        }
                    }
                }
                cout << cur << " ";
            }
            cout << '\n';
        }
    }
}
