#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve() {
    int n; cin >> n;
    vector <int> a(n), b(n);
    for (auto &x : a) cin >> x;
    for (auto &x : b) cin >> x;
    for (int i = 0; i < n; i++) {
        multiset <int> st1, st2;
        for (int j = 0; j <= i; j++) {
            st1.insert(a[j]);
        }
        st2 = st1;
        ll ans = 2e18;
        for (int j = 0; j <= i; j++) {
            ll res = 0;
            for (int p = 0; p <= i; p++) {
                if (p == j) continue;
                auto it = st1.lower_bound(b[p]);
                if (it == st1.end()) {
                    res = 2e18;
                    break;
                }
                res += *it - b[p];
                st1.erase(it);
            }
            ans = min(ans, res);
            st1 = st2;
        }
        cout << ans << " ";
    }
    cout << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int test; cin >> test;
    while (test--) solve();

    return 0;
}
