#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;


void solve() {
    ll n; cin >> n;
    vector <ll> a(n), b(n);
    bool f = true;
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        if (i && a[i - 1] >= a[i])
            f = false;
    }
    for (ll i = 0; i < n; i++) {
        cin >> b[i];
        if (i && b[i - 1] >= b[i])
            f = false;
    }
    vector <ll> q, w;
    ll sa = 0, sb = 0;
    if (!f) {
        for (ll it = 0; it < n; it++) {
            q.emplace_back(a[it]);
            sort(q.begin(), q.end());
            w.emplace_back(b[it]);
            sort(w.begin(), w.end());
            vector <ll> pref(it + 2);
            for (ll i = 0; i < it; i++)
                pref[i + 1] = pref[i] + bool(q[i] >= w[i + 1]);
            pref[it + 1] = pref[it];
            sa += a[it], sb += b[it];
            ll ans = INF;
            for (ll i = 0; i <= it; i++) {
                ll l = -1, r = i;
                while (r - l > 1) {
                    ll m = (r + l) / 2;
                    if (pref[i] - pref[m] == i - m)
                        r = m;
                    else
                        l = m;
                }
                ans = min(ans, (sa - q[i]) - (sb - w[r]));
            }
            cout << ans << ' ';
        }
    } else {
        ll mn = INF;
        for (ll it = 0; it < n; it++) {
            q.emplace_back(a[it]);
            w.emplace_back(b[it]);
            sa += a[it], sb += b[it];
            mn = min(mn, w[it] - q[it]);
            cout << sa - sb + mn << ' ';
        }
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
//    cin >> G;
    while (T--) {
        solve();
    }
    return 0;
}
