#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
#define int long long

istream &operator>>(istream&in, pair<int, int>&p) {
    return in >> p.first >> p.second;
}

istream &operator>>(istream&in, vector<int> &p) {
    for (int &i : p) in >> i;
    return in;
}

ostream &operator<<(ostream &out, pair<int, int> p) {
    return out << p.first << ' ' << p.second;
}

ostream &operator<<(ostream &out, vector<int> p) {
    for (int i : p) out << i << ' ';
    return out;
}

int get(vector<int> a, vector<int> b) {
    map<int, int> mp1, mp2;
    for (int i : a) mp1[i]++;
    for (int i : b) mp2[i]++;
    vector<int> c, d;
    for (auto it : mp1) {
        if (it.second == mp2[it.first]) continue;
        if (it.second > mp2[it.first]) {
            for (int i = 0; i < it.second - mp2[it.first]; ++i) c.push_back(it.first);
        } else {
            for (int i = 0; i < mp2[it.first] - it.second; ++i) d.push_back(it.first);
        }
    }
    for (auto it : mp2) {
        if (it.second == mp1[it.first]) continue;
        if (mp1[it.first] == 0) for (int i = 0; i < it.second; ++i) d.push_back(it.first);
    }
    sort(d.begin(), d.end());
    sort(c.begin(), c.end());
    a = c;
    b = d;
    int res = 0;
    for (int i : a) res += i;
    for (int i : b) res -= i;
    int mx = 0;
    int n = a.size();
    int l = 0;
    for (int r = 0; r < n; ++r) {
        if (l < r) l = r;
        while (l + 1 < n && a[l] >= b[l + 1]) l++;
        mx = max(mx, a[l] - b[r]);
    }
    res -= mx;
    return res;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    cin >> a >> b;
    vector<int> arr1, arr2;
    for (int i = 0; i < n; ++i) {
        arr1.push_back(a[i]);
        arr2.push_back(b[i]);
        cout << get(arr1, arr2) << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}
