#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
#define int long long

istream &operator>>(istream&in, pair<int, int>&p) {
    return in >> p.first >> p.second;
}

istream &operator>>(istream&in, vector<int> &p) {
    for (int &i : p) in >> i;
    return in;
}

ostream &operator<<(ostream &out, pair<int, int> p) {
    return out << p.first << ' ' << p.second;
}

ostream &operator<<(ostream &out, vector<int> p) {
    for (int i : p) out << i << ' ';
    return out;
}

int get(vector<int> &a, vector<int> &b) {
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    int mx = 0;
    int n = a.size();
    int l = 0;
    for (int r = 0; r < n; ++r) {
        if (l < r) l = r;
        while (l + 1 < n && a[l] >= b[l + 1]) l++;
        mx = max(mx, a[l] - b[r]);
    }
    return mx;
}

auto start = clock();

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    cin >> a >> b;
    vector<int> arr1, arr2;
    int sum = 0;
    vector<int> ans(n);
    int mx;
    int u = 2 * (int)sqrt(n);
    if (u >= n) u = n;
    if ((clock() - start) / CLOCKS_PER_SEC <= 0.5 && n <= 3000) u = n;
    for (int i = 0; i < u; ++i) {
        arr1.push_back(a[i]);
        arr2.push_back(b[i]);
        sum += a[i] - b[i];
        mx = get(arr1, arr2);
        ans[i] = sum - mx;
    }
    for (int i = u; i < n; ++i) {
        sum += a[i] - b[i];
        ans[i] = sum - mx;
    }
    for (int i : ans) cout << i << ' ';
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}
