#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
#define int long long

istream &operator>>(istream&in, pair<int, int>&p) {
    return in >> p.first >> p.second;
}

istream &operator>>(istream&in, vector<int> &p) {
    for (int &i : p) in >> i;
    return in;
}

ostream &operator<<(ostream &out, pair<int, int> p) {
    return out << p.first << ' ' << p.second;
}

ostream &operator<<(ostream &out, vector<int> p) {
    for (int i : p) out << i << ' ';
    return out;
}

int get(vector<int> &a, vector<int> &b) {
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    int mx = 0;
    int n = a.size();
    int l = 0;
    for (int r = 0; r < n; ++r) {
        if (l < r) l = r;
        while (l + 1 < n && a[l] >= b[l + 1]) l++;
        mx = max(mx, a[l] - b[r]);
    }
    return mx;
}

vector<pair<int, pair<vector<int>, vector<int>>>> queries;
int query = 0;

void solve1() {
    int n = queries[query].first;
    vector<int> a, b;
    tie(a, b) = queries[query++].second;
    vector<int> arr1, arr2;
    int sum = 0, mx = 0;
    for (int i = 0; i < n; ++i) {
        arr1.push_back(a[i]);
        arr2.push_back(b[i]);
        sum += a[i] - b[i];
        mx = max(mx, a[i] - b[i]);
        cout << sum - get(arr1, arr2) << ' ';
    }
    cout << '\n';
}

void solve2() {
    int n = queries[query].first;
    vector<int> a, b;
    tie(a, b) = queries[query++].second;
    int sum = 0, mx = 0;
    for (int i = 0; i < n; ++i) {
        sum += a[i] - b[i];
        mx = max(mx, a[i] - b[i]);
        cout << sum - mx << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests = 1;
    cin >> tests;
    int sum = 0;
    for (int i = 0; i < tests; ++i) {
        int n;
        cin >> n;
        vector<int> a(n), b(n);
        for (int &i : a) cin >> i;
        for (int &i : b) cin >> i;
        sum += n;
        queries.push_back({n, {a, b}});
    }
    for (int i = 0; i < tests; ++i) {
        if (sum <= 3000) solve1();
        else solve2();
    }
}
