#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <set>

using namespace std;

void sol1(int n, vector<long long> &a, vector<long long> &b) {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    multiset<int> st1;
    for (int i = 0; i < n; i++) {
        multiset<int> st2;
        long long ans = 0, mx = 0;
        st1.insert(a[i]);
        for (int j = 0; j <= i; j++) {
            st2.insert(b[j]);
        }
        for (auto x : st1) {
            auto it = st2.upper_bound(x);
            it--;
            int c = x - (*it);
            ans += c;
            if (c > mx) {
                mx = c;
            }
            st2.erase(it);
        }
        cout << ans - mx << " ";
    }
    cout << '\n';
}

void sol2(int n, vector<long long> &a, vector<long long> &b) {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    long long sum = 0, mx = 0, pr = 0;
    for (int i = 0; i < n; i++) {
        sum += a[i] - b[i];
        if (i != 0 && b[i] > a[i - 1]) {
            pr = i;
        }
        mx = max(mx, a[i] - b[pr]);
        cout << sum - mx << " ";
    }
    cout << '\n';
}

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        int n;
        cin >> n;
        vector<long long> a(n);
        vector<long long> b(n);
        for (int j = 0; j < n; j++) {
            cin >> a[j];
        }
        for (int j = 0; j < n; j++) {
            cin >> b[j];
        }
        bool fl = true;
        for (int j = 1; j < n; j++) {
            if (a[j] < a[j - 1] || b[j] < b[j - 1]) {
                fl = false;
                break;
            }
        }
        if (fl) {
            sol2(n, a, b);
        } else {
            sol1(n, a, b);
        }
    }
    return 0;
}
