#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <math.h>
#include <algorithm>
#include <queue>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

void solve() {
	ll n, i, p, j, mn;
	cin >> n;
	vector <ll> a(n);
	vector <ll> b(n);
	for (i = 0; i < n; i++) cin >> a[i];
	for (i = 0; i < n; i++) cin >> b[i];

	vector <ll> prefa(n);
	vector <ll> prefb(n);
	prefa[0] = a[0];
	for (i = 1; i < n; i++) prefa[i] = prefa[i - 1] + a[i];
	prefb[0] = b[0];
	for (i = 1; i < n; i++) prefb[i] = prefb[i - 1] + b[i];

	vector <ll> na;
	vector <ll> nb;
	vector <ll> ans(n);

	for (i = 0; i < n; i++) {
		na.push_back(a[i]);
		nb.push_back(b[i]);
		sort(na.begin(), na.end());
		sort(nb.begin(), nb.end());
		mn = -1;
		p = 0;
		for (j = 0; j < na.size(); j++) {
			p = j;
			while (p + 1 < na.size() && na[p] >= nb[p + 1]) p++;
			mn = max(mn, na[p] - nb[j]);
			j = p;
		}
		ans[i] = prefa[i] - prefb[i] - mn;
	}
	for (i = 0; i < n; i++) cout << ans[i] << " ";
	cout << endl;
}

int main() {
	ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
	ll t = 1;
	cin >> t;
	while (t--) solve();
}