#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 2e5 + 10;
const int INF = 2e9;
const int mod = 1e9 + 7;

void solve() {

    int n;
    cin >> n;
    vector<ll> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    ll sa = a[0], sb = b[0];
    ll mx = 0, idx = 0;
    cout << 0 << ' ';
    for (int i = 1; i < n; i++) {
        sa += a[i];
        sb += b[i];
        if (a[i - 1] < b[i]) {
            mx = max(mx, a[i - 1] - b[idx]);
            idx = i;
        }
        cout << sa - sb - max(mx, a[i] - b[idx]) << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
