#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;
//#define int long long
using pii = pair <int, int>;
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define ff first
#define ss second

template <typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
}

template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
};

struct Fenwick {
private:
    vector <int> d;
    int n;

public:
    explicit Fenwick(int n1) : n(n1) {
        d.resize(n1);
    }

    int get(int i) {
        int res = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            res += d[i];
        }
        return res;
    }

    void upd(int i, int x) {
        for (; i < n; i |= (i + 1)) {
            d[i] += x;
        }
    }
};

void solve123(int n, vector <int> a, vector <int> b) {
    long long sum = 0;
    vector <int> a0 = a, b0 = b;
    for (int i = 0; i < n; ++i) {
        sum += a0[i] - b0[i];
        sort(a.begin(), a.begin() + i + 1);
        sort(b.begin(), b.begin() + i + 1);
        int am = 0;
        int t = a[i];
        int mxd = 0;
        vector <int> bad(i + 1);
        for (int j = 0; j <= i; ++j) {
            while (am <= i && b[am] <= a[j]) {
                ++am;
            }
            mxr(mxd, a[j] - b[j]);
            if (am <= j + 1) {
                bad[j] = 1;
            }
        }
        for (int j = i - 1; j >= 0; --j) {
            if (bad[j]) {
                t = a[j];
            }
            mxr(mxd, t - b[j]);
        }
        cout << sum - mxd << " ";
    }
}

void solve45(int n, const vector <int>& a, const vector <int>& b) {
    long long sum = 0;
    int mxd = 0;
    for (int i = 0; i < n; ++i) {
        sum += a[i] - b[i];
        mxr(mxd, a[i] - b[i]);
        cout << sum - mxd << " ";
    }
}

void solve() {
    int n;
    cin >> n;
    vector <int> a(n), b(n);
    for (auto &i : a) {
        cin >> i;
    }
    for (auto &i : b) {
        cin >> i;
    }
    if (n <= 3000) {
        solve123(n, a, b);
    } else {
        solve45(n, a, b);
    }
}

signed main() {
    cout << setprecision(15) << fixed;
#ifdef BUY
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
#ifdef BUY
    cerr << "\n";
#endif
}