#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

const int INF = (int)(1e18) + 42;

int get(vector<int> a, vector<int> b) {
    int n = a.size();

    sort(all(a));
    sort(all(b));

    int ans = INF;
    for (int ba = 0; ba < n; ++ba)
        for (int bb = 0; bb < n; ++bb) {
            int cur = 0, it = n - 1;
            for (int i = n - 1; i > -1; --i) {
                if (i == ba)
                    continue;

                while (it > -1 && b[it] > a[i] || it == bb)
                    --it;
                if (it < 0) {
                    cur = INF;
                    break;
                }

                cur += a[i] - b[it];
                --it;
            }
            ans = min(ans, cur);
        }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (auto& i : a)
        cin >> i;
    for (auto& i : b)
        cin >> i;

    vector<int> a0, b0;
    for (int i = 0; i < n; ++i) {
        a0.push_back(a[i]);
        b0.push_back(b[i]);
        cout << get(a0, b0) << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
}