#include "bits/stdc++.h"

using namespace std;

using ll = long long;

void solve() {
    int n;
    cin >> n;

    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<ll> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    if (n <= 500) {
        multiset<int> A, B;
        for (int i = 1; i <= n; ++i) {
            A.insert(a[i - 1]);
            B.insert(b[i - 1]);

            vector<int> avals;
            vector<int> bvals;
            for (auto v: A) avals.push_back(v);
            for (auto v: B) bvals.push_back(v);

            vector<int> a1(avals.begin(), avals.end() - 1);
            vector<int> a2(avals.begin() + 1, avals.end());

            ll ans = 1e18;

            ll errs1 = 0, errs2 = 0;
            ll diff1 = 0, diff2 = 0;
            for (int j = 0; j < i - 1; ++j) {
                errs1 += a1[j] < bvals[j + 1];
                diff1 += a1[j] - bvals[j + 1];
                errs2 += a2[j] < bvals[j + 1];
                diff2 += a2[j] - bvals[j + 1];
            }

            if (errs1 == 0) ans = min(ans, diff1);
            if (errs2 == 0) ans = min(ans, diff2);

            for (int block = 1; block < i; ++block) {
                errs1 -= a1[block - 1] < bvals[block];
                errs2 -= a2[block - 1] < bvals[block];
                errs1 += a1[block - 1] < bvals[block - 1];
                errs2 += a2[block - 1] < bvals[block - 1];

                diff1 -= a1[block - 1] - bvals[block];
                diff2 -= a2[block - 1] - bvals[block];
                diff1 += a1[block - 1] - bvals[block - 1];
                diff2 += a2[block - 1] - bvals[block - 1];

                if (errs1 == 0) ans = min(ans, diff1);
                if (errs2 == 0) ans = min(ans, diff2);
            }

            cout << ans << " ";
        }
        cout << "\n";
    } else {
        ll diff = 0;
        ll maxdiff = 0;
        for (int i = 0; i < n; ++i) {
            diff += a[i] - b[i];
            maxdiff = max(maxdiff, a[i] - b[i]);
            cout << diff - maxdiff << " ";
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}