#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())
const ll INF = LLONG_MAX;

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> &a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

template<typename T>
void print(vector<T> &a, const string &s) {
    for (int i = 0; i < sz(a); ++i) {
        cout << a;
        if (i < sz(a) - 1) {
            cout << s;
        }
    }
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    cin >> a >> b;
    multiset<ll> f, s;
    vector<ll> prefa(n + 1), prefb(n + 1);
    for (int i = 1; i <= n; ++i) {
        prefa[i] = prefa[i - 1] + a[i - 1];
    }
    for (int i = 1; i <= n; ++i) {
        prefb[i] = prefb[i - 1] + b[i - 1];
    }
    bool flag = true;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] >= b[i + 1]) {
            flag = false;
        }
    }
    if (flag) {
        ll mx = a[0] - b[0];
        for (int i = 0; i < n; ++i) {
            mx = max(mx, a[i] - b[i]);
            cout << prefa[i + 1] - prefb[i + 1] - mx << ' ';
        }
        return;
    }
    for (int i = 0; i < n; ++i) {
        f.insert(a[i]);
        s.insert(b[i]);
        if (i == 0) {
            cout << 0 << ' ';
            continue;
        }
        vector<pair<ll, ll>> segs;
        auto it = --f.end();
        auto it2 = --s.end();
        segs.emplace_back(*it2, *it);
        ll amax = *it, bmin = *it2, ans = amax - bmin;
        --it;
        int j = n - 1;
        while (true) {
            --j;
            auto it3 = it2;
            --it3;
            if (*it >= *it2) {
                bmin = *it3;
                segs.back().first = *it3;
            } else {
                amax = *it;
                bmin = *it3;
                segs.emplace_back(*it3, *it);
            }
            ans = max(ans, amax - bmin);
//            for (auto )
            if (it == f.begin()) {
                break;
            }
            --it, --it2;
        }
        cout << prefa[i + 1] - prefb[i + 1] - ans << ' ';
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve(), cout << '\n';
    }
}
