#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

void insert(vector<int> &a, int x) {
    int l = -1, r = a.size();
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (a[m] >= x) {
            r = m;
        } else {
            l = m;
        }
    }
    a.emplace(a.begin() + r, x);
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), prec(n, -1e18);
    int suma = 0, sumb = 0;
    bool sorted = true;
    bool less = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (i > 0 && a[i - 1] > a[i]) {
            sorted = false;
        }
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        prec[i] = max((i > 0 ? prec[i - 1] : (int) -1e18), a[i] - b[i]);
        if (i > 0 && a[i - 1] >= b[i]) {
            less = false;
        }
        if (i > 0 && b[i - 1] > b[i]) {
            sorted = false;
        }
    }
    vector<int> bestprec(n, 1e18);
    vector<int> precc(n + 1, 0);
    if (!less && sorted && n > 3000) {
        int x = 0;
        while (x + 1 < n) {
            precc[x + 1] = (a[x] >= b[x + 1]);
            ++x;
        }
        int last = 0;
        for (int j = 0; j < n; j++) {
            suma += a[j];
            sumb += b[j];
            if (precc[j]) {
                last = last + 1;
            } else {
                last = 0;
            }
            bestprec[j] = min((j > 0 ? bestprec[j - 1] + a[j] - b[j] : (int) 1e18), suma - sumb - a[j] + b[j - last]);
        }
    }
    vector<int> nowa, nowb;
    for (int k = 0; k < n; k++) {
        suma += a[k];
        sumb += b[k];
        if (less) {
            cout << suma - sumb - prec[k] << ' ';
            continue;
        }
        if (sorted && n > 3000) {
            int otv = min(suma - sumb - prec[k], bestprec[k]);
            cout << otv << ' ';
            continue;
        }
        insert(nowa, a[k]);
        insert(nowb, b[k]);
        vector<int> c(k + 1, 0);
        auto x = nowa.begin();
        auto y = nowb.begin();
        y++;
        int p = 1;
        while (y != nowb.end()) {
            c[p] = (*x >= *y) + c[p - 1];
            ++x;
            ++y;
            ++p;
        }
        int otv = 1e18;
        for (int i = 0; i <= k; i++) {
            otv = min(otv, suma - sumb - nowa[i] + nowb[i]);
        }
//        otv = min(otv, suma - sumb - nowa[j] + nowb[i]);
//        if (c[j] - c[i] != j - i) {
//            continue;
//        }
        for (int j = 0; j <= k; j++) {
            int l = -1, r = j;
            while (r - l > 1) {
                int m = (r + l) / 2;
                if (c[j] - c[m] != j - m) {
                    l = m;
                } else {
                    r = m;
                }
            }
            otv = min(otv, suma - sumb - nowa[j] + nowb[r]);
        }
        cout << otv << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
}