#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

void solve() {
    ll n;
    cin >> n;
    ll a[n], b[n];
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> b[i];
    }
    ll suma = 0, sumb = 0;
    for (ll pref = 0; pref < n; ++pref) {
        suma += a[pref];
        sumb += b[pref];
        ll ans = suma - sumb;
        for (ll i = 0; i <= pref; ++i) {
            ans = min(ans, (suma - a[i]) - (sumb - b[i]));
        }
        vector<pair<ll, ll>> all;
        for (ll i = 0; i <= pref; ++i) {
            all.emplace_back(a[i], 1);
            all.emplace_back(b[i], 2);
        }
        sort(all.begin(), all.end(), [&](pair<ll, ll> a, pair<ll, ll> b) {
            if (a.first == b.first) {
                return a.second > b.second;
            }
            return a.first < b.first;
        });
        ll inda = -1, indb = -1;
        for (ll i = (ll) all.size() - 1; i > 0; --i) {
            if (all[i].second == 1 && all[i - 1].second == 1) {
                inda = i;
                break;
            }
        }
        for (ll i = 0; i + 1 < (ll) all.size(); ++i) {
            if (all[i].second == 2 && all[i + 1].second == 2) {
                indb = i;
                break;
            }
        }
        if (inda != -1 && indb != -1) {
            ans = min(ans, (suma - all[inda].first) - (sumb - all[indb].first));
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
