#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<queue>
#include<set>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<iomanip>
#include<cstring>
#include<map>

using namespace std;

// #pragma optimize("O3")
// #pragma optimize("unroll-loops")
// #pragma oprimize("avx2")

#define int long long

int inf = 1e9 + 5;

random_device rd;
mt19937 gen(239);

int a[200005];
int b[200005];

set<int>gr;
map<int, int>mval;
multiset<int>bval;
multiset<pair<int, int>>arr;

void add_gr(int x) {
    auto f2 = gr.lower_bound(x);
    auto f1 = f2;
    f1--;
    auto gh = bval.find(mval[*f2]);
    if (gh != bval.end())
        bval.erase(gh);
    mval[*f2] = *f2 - arr.lower_bound({ x + 1, 0 })->second;
    bval.insert(mval[*f2]);

    mval[x] = x - arr.lower_bound({ (*f1) + 1, 0 })->second;
    bval.insert(mval[x]);
    gr.insert(x);
}


void del_gr(int x) {
    auto gh = bval.find(mval[x]);
    if (gh != bval.end())
        bval.erase(gh);
    gr.erase(x);

    auto f2 = gr.lower_bound(x);
    auto f1 = f2;
    f1--;
    gh = bval.find(mval[*f2]);
    if (gh != bval.end())
        bval.erase(gh);
    mval[*f2] = *f2 - arr.lower_bound({ (*f1) + 1, 0 })->second;
    bval.insert(mval[*f2]);
}

void solve() {
    gr.clear();
    bval.clear();
    mval.clear();
    arr.clear();
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    int tans = 0;
    int mx = 0;
    arr.insert({ 0, 0 });
    arr.insert({ inf, inf });
    gr.insert(0);
    gr.insert(inf);
    for (int i = 0; i < n; i++) {
        tans += a[i] - b[i];
        auto f1 = arr.lower_bound({ a[i], b[i] });
        auto f2 = f1;
        f1--;
        if (f1 != arr.begin() && f1->first < f2->second) {
            del_gr(f1->first);
        }

        arr.insert({ a[i], b[i] });

        f2 = arr.lower_bound({ a[i], b[i] });
        f1 = f2;
        f1--; f2++;
        if (f1 != arr.begin() && f1->first < b[i]) {
            add_gr(f1->first);
        }
        if (a[i] < f2->second) {
            add_gr(a[i]);
        }
        cout << tans - (*bval.rbegin()) << " ";
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;

    for (int i = 0; i < t; i++) {
        solve();
    }
}