#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<queue>
#include<set>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<iomanip>
#include<cstring>
#include<map>

using namespace std;

#pragma optimize("O3")
#pragma optimize("unroll-loops")
#pragma oprimize("avx2")

#define int long long
int inf = 1e9 + 5;

struct Tree {
    int l, r;
    int val;
};

Tree tree[530005];
void build(int v, int left, int right) {
    if (left + 1 == right) {
        tree[v] = { left, right, inf };
        return;
    }
    build(2 * v, left, (left + right) / 2);
    build(2 * v + 1, (left + right) / 2, right);
    tree[v] = { left, right, inf };
}

void update(int v, int ind, int val) {
    if (tree[v].l + 1 == tree[v].r) {
        tree[v].val = min(tree[v].val, val);
        return;
    }
    if (ind < (tree[v].l + tree[v].r) / 2)
        update(2 * v, ind, val);
    else
        update(2 * v + 1, ind, val);
    tree[v].val = min(tree[2 * v].val, tree[2 * v + 1].val);
}

int minn(int v, int left, int right) {
    if (left >= tree[v].r || right <= tree[v].l)
        return inf;
    if (left <= tree[v].l && tree[v].r <= right)
        return tree[v].val;
    return min(minn(2 * v, left, right), minn(2 * v + 1, left, right));
}

random_device rd;
mt19937 gen(239);

int a[200005];
int b[200005];

set<int>gr;
unordered_map<int, int>mval;
multiset<int>bval;
multiset<pair<int, int>>arr;
unordered_map<int, int>ind;

void add_gr(int x) {
    auto f2 = gr.lower_bound(x);
    auto f1 = f2;
    f1--;
    auto gh = bval.find(mval[*f2]);
    if (gh != bval.end())
        bval.erase(gh);
    mval[*f2] = *f2 - minn(1, ind[x] + 1, *f2 + 1);
    //mval[*f2] = *f2 - arr.lower_bound({ x + 1, 0 })->second;
    bval.insert(mval[*f2]);

    mval[x] = x - minn(1, ind[*f1] + 1, x + 1);
    //mval[x] = x - arr.lower_bound({ (*f1) + 1, 0 })->second;
    bval.insert(mval[x]);
    gr.insert(x);
}


void del_gr(int x) {
    auto gh = bval.find(mval[x]);
    if (gh != bval.end())
        bval.erase(gh);
    gr.erase(x);

    auto f2 = gr.lower_bound(x);
    auto f1 = f2;
    f1--;
    gh = bval.find(mval[*f2]);
    if (gh != bval.end())
        bval.erase(gh);
    mval[*f2] = *f2 - minn(1, ind[*f1] + 1, *f2 + 1);
    //mval[*f2] = *f2 - arr.lower_bound({ (*f1) + 1, 0 })->second;
    bval.insert(mval[*f2]);
}



void solve() {
    gr.clear();
    bval.clear();
    mval.clear();
    arr.clear();
    mval.max_load_factor(0.15);
    ind.max_load_factor(0.15);
    int n;
    cin >> n;
    vector<int>xs;
    xs.push_back(-1);
    xs.push_back(0);
    xs.push_back(inf);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        xs.push_back(a[i]);
    }
    sort(xs.begin(), xs.end());
    xs.resize(unique(xs.begin(), xs.end()) - xs.begin());
    for (int i = 0; i < xs.size(); i++) {
        ind[xs[i]] = i;
    }

    int raz = 0;
    for (int i = 0; i < 25; i++) {
        if ((1 << i) > xs.size()) {
            raz = (1 << i);
            break;
        }
    }
    build(1, 0, raz);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    int tans = 0;
    int mx = 0;

    arr.insert({ -1, -1 });
    arr.insert({ 0, 0 });
    arr.insert({ inf, inf });
    gr.insert(-1);
    gr.insert(0);
    gr.insert(inf);
    for (int i = 0; i < n; i++) {
        bool bk = true;
        update(1, ind[a[i]], b[i]);
        tans += a[i] - b[i];
        auto f1 = arr.lower_bound({ a[i], b[i] });
        auto f2 = f1;
        f1--;
        if ((f1->first < f2->second)) {
            bk = false;
            del_gr(f1->first);
        }

        arr.insert({ a[i], b[i] });

        // f2 = arr.lower_bound({ a[i], b[i] });
        // f1 = f2;
        // f1--; f2++;
        if ((f1->first < b[i])) {
            bk = false;
            add_gr(f1->first);
        }
        if (a[i] < f2->second) {
            bk = false;
            add_gr(a[i]);
        }

        if (bk) {
            auto f2 = gr.lower_bound(a[i]);
            auto f1 = f2; f1--;
            auto gh = bval.find(mval[*f2]);
            if (gh != bval.end())
                bval.erase(gh);
            mval[*f2] = *f2 - minn(1, *f1 + 1, *f2 + 1);
            bval.insert(mval[*f2]);
        }
        cout << tans - (*bval.rbegin()) << " ";
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;

    for (int i = 0; i < t; i++) {
        solve();
    }
}