#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>

#include <random>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
//typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define all(a) a.begin(), a.end()
#define rd(a) for (auto &i: a) cin >> i;

ll INF = 1e13;
ll MOD = 1e9 + 7;

bool cmp(pair<ll, ll> l, pair<ll, ll> r) {
    tuple<ll, ll> ls = {l.first + l.second, max(l.first, l.second)};
    tuple<ll, ll> rs = {r.first + r.second, max(r.first, r.second)};
    return ls > rs;

}

void solve() {

    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    rd(a);
    rd(b);
    if (n <= 100) {
        ll sa = 0, sb = 0;
        for (int i = 0; i < n; i++) {
            sa += a[i];
            sb += b[i];
            ll ans = INF;
            for (int l = 0; l <= i; l++) {
                for (int r = 0; r <= i; r++) {
                    vector<ll> a1, b1;
                    for (int j = 0; j <= i; j++) {
                        if (j != l) {
                            a1.push_back(a[j]);
                        }
                        if (j != r) {
                            b1.push_back(b[j]);
                        }
                    }
                    sort(all(a1));
                    sort(all(b1));
                    bool f = true;
                    for (int j = 0; j < i; j++) {
                        if (a1[j] < b1[j]) {
                            f = false;
                            break;
                        }
                    }
                    if (f) {
                        ans = min(ans, sa - sb + b[r] - a[l]);
                    }
                }
            }
            cout << ans << " ";
        }
        cout << "\n";
        return;
    }
    ll sa = 0, sb = 0;
    ll mxa = -INF, mnb = INF, mnb2 = INF, mxa2 = -INF;
    set<pair<ll, ll>> smallest;
    set<pair<ll, ll>> biggest;
    ll mxdelta = -INF;
    for (int i = 0; i < n; i++) {
        sa += a[i];
        sb += b[i];
        while (!smallest.empty() && smallest.rbegin()->first >= b[i]) {
            auto [A, j] = *smallest.rbegin();
            smallest.erase({A, j});
            mnb = min(mnb, b[j]);
        }
        while (!biggest.empty() && biggest.begin()->first <= a[i]) {
            auto [B, j] = *biggest.rbegin();
            biggest.erase({B, j});
            mxa = max(mxa, a[j]);
        }
        mxdelta = max(mxdelta, a[i] - b[i]);
        if (a[i] < mnb2) {
            smallest.insert({a[i], i});
        } else {
            mnb = min(mnb, b[i]);
        }
        if (b[i] > mxa2) {
            biggest.insert({b[i], i});
        } else {
            mxa = max(mxa, a[i]);
        }
        mxa2 = max(mxa2, a[i]);
        mnb2 = min(mnb2, b[i]);
        cout << sa - sb - mxdelta << " ";

    }
    cout << "\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t; for (cin >> t; t--;) solve();
//    solve();

}

//void operator delete(void*) {};
//const int MAX_MEM = 3 * 1e8;
//int pos = 0;
//char buf[MAX_MEM];
//void* operator new(size_t x) {
//    void* pointer = (void*)(buf + pos);
//    pos += x;
//    if (pos >= MAX_MEM) {
//        pos = 1e6;
//    }
//    return pointer;
//
//}


