#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>

typedef long long ll;

using namespace std;

void solve(){
    ll n;
    cin >> n;
    vector <ll> a(n), b(n);
    for(int i = 0; i < n; i++) cin >> a[i];
    for(int i = 0; i < n; i++) cin >> b[i];
    if(n <= 500){
        vector <ll> cura, curb;
        cura.push_back(a[0]), curb.push_back(b[0]);
        cout << 0 << " ";
        for(int i = 1; i < n; i++){
            cura.push_back(a[i]), curb.push_back(b[i]);
            sort(cura.begin(), cura.end()), sort(curb.begin(), curb.end());
            ll ans = 1e18;
            for(int j = 0; j <= i; j++){
                ll pos = 0, cur = 0;
                for(int k = 0; k <= i; k++){
                    if(k == j)  continue;
                    if(cura[pos] < curb[k])pos++;
                    cur += (cura[pos] - curb[k]), pos++;
                }
                ans = min(ans, cur);
            }
            cout << ans << " ";
        }
        cout << "\n";
    }
    else{
        ll raz = a[0] - b[0], cnt = a[0] - b[0];
        cout << 0 << " ";
        for(int i = 1; i < n; i++){
            cnt += (a[i] - b[i]);
            raz = max(raz, a[i] - b[i]);
            cout << cnt - raz << " ";
        }
        cout << "\n";
    }
}

int main(){
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while(t--){
        solve();
    }
}