
// sleepwalker*_*ksu

#include <bits/stdc++.h>
#include <experimental/random>

using namespace std;

using ld = long double;
using ll = long long;
#define int long long
#define all(a) a.begin(), a.end()
using pii = pair<ll, ll>;
const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ld EPS = 1e-6;

int solve1(int n, vector<int> &a, vector<int> &b, vector<int> &c, int fir, int sec);

void solve2();

int solve3(int n, vector<int> &a, vector<int> &b, vector<int> &c, int fir, int sec);

void solve4();

void solve5();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll qwerty = 1;
    cin >> qwerty;
    while (qwerty--) {
        solve2();
    }
}

void solve5() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    int fir, sec;
    cin >> fir >> sec;
    cout << solve1(n, a, b, c, fir, sec);
}

void solve4() {
    for (int n = 1; n <= 15; n++) {
        for (int x = 0; x <= 10; x++) {
            for (int y = 0; y <= 10; y++) {
                vector<int> a(n, 0);
                vector<int> b(n), c(n);
                for (int i = 0; i < n; i++) {
                    a[i] = experimental::randint(1, 10);
                    b[i] = experimental::randint(1, 10);
                    c[i] = experimental::randint(1, 10);
                }
                cout << n << '\n';
                for (int i = 0; i < n; i++) {
                    cout << a[i] << ' ';
                }
                cout << '\n';
                for (int i = 0; i < n; i++) {
                    cout << b[i] << ' ';
                }
                cout << '\n';
                for (int i = 0; i < n; i++) {
                    cout << c[i] << ' ';
                }
                cout << '\n';
                cout << x << ' ' << y << '\n';
                int sec = solve3(n, a, b, c, x, y);
                cout << sec;
                cout << '\n';
                cout << '\n';
            }
        }
    }
}

int mmm = 0;
vector<int> q;
vector<int> an;

void f(int id, int n, vector<int> &a, vector<int> &b, vector<int> &c, int fir, int sec) {
    if (id == n) {
        mmm = max(mmm, fir + sec);
        an = q;
        return;
    }
    q[id] = 1;
    f(id + 1, n, a, b, c, min(fir + a[id], b[id]), sec + a[id]);
    q[id] = 2;
    f(id + 1, n, a, b, c, fir + a[id], min(sec + a[id], c[id]));
}

int solve3(int n, vector<int> &a, vector<int> &b, vector<int> &c, int fir, int sec) {
    mmm = 0;
    q.resize(n);
    f(0, n, a, b, c, fir, sec);
    for (int i = 0; i < n; i++) {
        cout << an[i] << ' ';
    }
    cout << '\n';
    return mmm;
}

void solve2() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    if (n > 100) {
        int sum1 = 0, sum2 = 0;
        int mx = 0;
        for (int i = 0; i < n; i++) {
            sum1 += a[i];
            sum2 += b[i];
            mx = max(mx, a[i] - b[i]);
            cout << sum1 - sum2 - mx << ' ';
        }
        return;
    }
    multiset<int> msta, mstb;
    int suma = 0, sumb = 0;
    for (int i = 0; i < n; i++) {
        suma += a[i];
        sumb += b[i];
        msta.insert(a[i]);
        mstb.insert(b[i]);
        int ans = INF;
        for (int j = 0; j <= i; j++) {
            for (int k = 0; k <= i; k++) {
                msta.erase(msta.find(a[j]));
                mstb.erase(mstb.find(b[k]));
                bool flag = true;
                auto x = msta.begin();
                auto y = mstb.begin();
                while (x != msta.end()) {
                    if (*x < *y) {
                        flag = false;
                        break;
                    }
                    ++x;
                    ++y;
                }
                if (flag) {
                    ans = min(ans, suma - a[j] - sumb + b[k]);
                }
                msta.insert(a[j]);
                mstb.insert(b[k]);
            }
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int solve1(int n, vector<int> &a, vector<int> &b, vector<int> &c, int fir, int sec) {
    for (int i = 0; i < n; i++) {
        fir += a[i];
        sec += a[i];
        if (fir > b[i] && sec > c[i]) {
            if (fir + c[i] > sec + b[i]) {
                sec = c[i];
            } else {
                fir = b[i];
            }
        }
    }
    return fir + sec;
}