#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
istream& operator >>(istream& in, pair<T, T1> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T, typename T1>
ostream& operator <<(ostream& out, pair<T, T1> &arr) {
    for (auto i : arr) out << i << " ";
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<T> &arr) {
    for (auto i : arr) out << i << " ";
    return out;
}

void solve() {
    int n; cin >> n;
    vector<int> s1(n), s2(n); cin >> s1 >> s2;

    if (n > 3000) {
        int sm1 = 0, sm2 = 0, pr = -1;

        int ans = 0;
        for (int i = 0; i < n; i++) {
            sm1 += s1[i], sm2 += s2[i];
            ans += s1[i] - s2[i];

            if (i == 0) {
                cout << "0 ";
                continue;
            }

            if (s1[i - 1] < s2[i])  pr = i - 1;
            ans = min(ans, (sm1 - s1[i]) - (sm2 - s2[pr + 1]));


            cout << ans << " ";
        }
        cout << "\n";
        return;
    }

    vector<int> a, b;
    int sm1 = 0, sm2 = 0;
    for (int i = 0; i < n; i++) {
        a.pb(s1[i]); b.pb(s2[i]);
        sm1 += s1[i], sm2 += s2[i];

        sort(all(a)); sort(all(b));
        int ch = i - 1;

        set<int> gr;
        for (; ch > -1; ch--) if (a[ch] < b[ch + 1]) gr.insert(ch);
        gr.insert(i + 1); gr.insert(-1);

        int ans = sm1 - sm2;
        for (int j = 0; j <= i; j++) {
            auto rt = gr.lower_bound(j);
            auto lt = rt;
            lt--;

            int i1 = (*lt) + 1;
            ans = min(ans, (sm1 - a[j]) - (sm2 - b[i1]));
        }

        cout << ans << " ";
    }
    cout << "\n";
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double time = clock();
#endif

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "---------------\n";
#endif
    }
#ifdef LOCAL
    cout << "time:" << (clock() - time) / CLOCKS_PER_SEC << "\n";
#endif
}