#define debug(x) cout<<(#x)<<" = "<<x;
#define all(x) (x).begin(),(x).end()
#include <cstring>
#include <random>
#include <chrono>
#include <cmath>
#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <numeric>
#include <cstdint>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
using namespace std;
using ll = int64_t;
using ull = uint64_t;

const int N = 2e5;
int a[N], b[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> b[i];
        }
        bool ok4 = true;
        for (int i = 0; i < n - 1; ++i) {
            ok4 &= a[i] < b[i + 1];
        }
        if (ok4) {
            multiset<int> difs;
            ll as = 0;
            for (int i = 0; i < n; ++i) {
                as += a[i] - b[i];
                difs.insert(a[i] - b[i]);
                cout << as - *difs.rbegin() << " ";
            }
            continue;
        }
        multiset<int> as, bs;
        ll asum = 0, bsum = 0;
        for (int i = 0; i < n; ++i) {
            as.insert(a[i]);
            asum += a[i];
            bs.insert(b[i]);
            bsum += b[i];
            if (bs.count(a[i])) {
                bs.erase(bs.find(a[i]));
                as.erase(as.find(a[i]));
                asum -= a[i];
                bsum -= a[i];
            }
            if (as.count(b[i])) {
                bs.erase(bs.find(b[i]));
                as.erase(as.find(b[i]));
                asum -= b[i];
                bsum -= a[i];
            }

        }
        cout << "\n";
    }
}
