#pragma GCC optimize ("O3")
#define debug(x) cout<<(#x)<<" = "<<x;
#define all(x) (x).begin(),(x).end()
#include <cstring>
#include <random>
#include <chrono>
#include <cmath>
#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <numeric>
#include <cstdint>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
using namespace std;
using ll = int64_t;
using ull = uint64_t;

const int N = 2e5;
int a[N], b[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> b[i];
        }
        bool ok4 = true;
        for (int i = 0; i < n - 1; ++i) {
            ok4 &= a[i] < b[i + 1];
        }
        if (ok4) {
            multiset<int> difs;
            ll as = 0;
            for (int i = 0; i < n; ++i) {
                as += a[i] - b[i];
                difs.insert(a[i] - b[i]);
                cout << as - *difs.rbegin() << " ";
            }
            continue;
        }
        for (int i = 1; i <= n; ++i) {
            vector<pair<int, int>> ts;
            ts.reserve(i * i);
            vector<bool> useda(i);
            vector<bool> usedb(i);
            for (int j = 0; j < i; ++j) {
                for (int k = 0; k < i; ++k) {
                    if (a[j] >= b[k]) {
                        ts.push_back({j, k});
                    }
                }
            }
            sort(all(ts), [&](const pair<int, int>& c, const pair<int, int>& d) {
                 return a[c.first] - b[c.second] < a[d.first] - b[d.second];
            });
            int cnt = 0;
            ll res = 0;
            for (auto& p : ts) {
                if (cnt >= i - 1)
                    break;
                if (!useda[p.first] && !usedb[p.second]) {
                    res += a[p.first] - b[p.second];
                    ++cnt;
                    useda[p.first] = usedb[p.second] = true;
                }
            }
            cout << res << " ";
        }
        cout << "\n";
    }
}
