#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>
#include <iomanip>
#include <stack>
#include <deque>
#include <algorithm>
#include <queue>
#include <random>

typedef long long ll;

using namespace std;

const ll INF = 1e9;
const ll MAXN = 1e5 + 5;

using t3 = tuple<int, int, int>;

int n;
vector<int> a, b;

void solve() {
    vector<int> c, d;
    for (int i = 0; i < n; ++i) {
        ll ans = 2e18;
        c.push_back(a[i]);
        d.push_back(b[i]);
        sort(c.begin(), c.end());
        sort(d.begin(), d.end());
        for (int j = 0; j <= i; ++j) {
            for (int k = 0; k <= i; ++k) {
                ll cur = 0;
                for (int it1 = 0, it2 = 0; max(it1, it2) <= i; ++it1, ++it2) {
                    if (it1 == j) {
                        ++it1;
                    }
                    if (it2 == k) {
                        ++it2;
                    }

                    if (max(it1, it2) > i) {
                        break;
                    }

                    if (c[it1] < d[it2]) {
                        cur = 2e18;
                        break;
                    }

                    cur += abs(c[it1] - d[it2]);
                }
                ans = min(ans, cur);
            }
        }
        cout << ans << ' ';
    }
}

void start() {
    cin >> n;
    a.assign(n, 0);
    b.assign(n, 0);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    solve();

    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("in", "r", stdin);
#endif

    ll T = 1;
    cin >> T;

    while (T --> 0) {
        start();
    }

    return 0;
}
