#include <bits/stdc++.h>
#define int long long

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    bool sorted = true;
    sorted &= is_sorted(a.begin(), a.end());
    sorted &= is_sorted(b.begin(), b.end());
    if (sorted) {
        vector<int> can(n);
        vector<int> val(n);
        for (int i = 1; i < n; ++i) {
            can[i] = a[i - 1] >= b[i];
            if (can[i]) {
                val[i] = a[i - 1] - b[i];
            }
        }
        vector<int> nxt(n);
        vector<int> valnxt(n);
        int prev = 0, cursum = 0;
        for (int i = 1; i < n; ++i) {
            if (can[i] == 0) {
                prev = i;
                cursum = 0;
            } else {
                cursum += val[i];
            }
            nxt[i] = prev;
            valnxt[i] = cursum;
        }
        vector<int> vt(n + 1);
        for (int j = 1; j <= n; ++j) {
            vt[j] = vt[j - 1] + a[j - 1] - b[j - 1];
        }
        int res = 1e18;
        for (int i = 0; i < n; ++i) {
            res = min(res + a[i] - b[i], vt[nxt[i]] + valnxt[i]);
            cout << res << " ";
        }
    } else {
        for (int i = 0; i < n; ++i) {
            vector<int> as(i + 1), bs(i + 1);
            for (int j = 0; j <= i; ++j) {
                as[j] = a[j];
                bs[j] = b[j];
            }
            sort(as.begin(), as.end());
            sort(bs.begin(), bs.end());
            int res = 1e18;
            vector<int> vt(i + 1);
            for (int j = 1; j <= i; ++j) {
                vt[j] = vt[j - 1] + as[j - 1] - bs[j - 1];
            }
            vector<int> vtsuf(i + 1);
            vtsuf[i] = as[i] - bs[i];
            for (int j = i - 1; j >= 0; --j) {
                vtsuf[j] = vtsuf[j + 1] + as[j] - bs[j];
            }
            int nc = 0;
            for (int j = i; j >= 0; --j) {
                if (j < i && as[j] >= bs[j + 1]) {
                    nc += as[j] - bs[j + 1];
                } else if (j < i) {
                    nc = vtsuf[j + 1];
                }
                res = min(res, vt[j] + nc);
            }
            cout << res << " ";
        }
    }
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
