#include <bits/stdc++.h>
using namespace std;

#define int long long
using ll = long long;
#define forn(i,n) for(int i=0;i<n;++i)
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];
#define pb push_back
#define all(x) x.begin(),x.end()
#define pi pair<int,int>
#define f first
#define s second

const ll inf = 1e18;

void insert(vector<int>&a, int x) {
	int i=0;
	while (i<a.size() && a[i]<=x) ++i;
	while (i<a.size()) {
		swap(a[i],x);
		++i;
	}
	a.pb(x);
}

int issorted(vector<int>&a) {
	int z=1;
	forn(i,a.size()-1) z&=a[i]<=a[i+1];
	return z;
}

int n;

void brut(vector<int>&a, vector<int>&b) {
	vector<int> f,s;

	forn(i,n) {
		insert(f,a[i]);
		insert(s,b[i]);
		int best=0;
		int bad=0;
		forn(j,i+1) best+=f[j]-s[j];

		vector<int> z;
		forn(j,i) z.pb(j+1);

		int ok=1;
		int cost=0;
		forn(k,i) cost+=f[z[k]]-s[k];

		int mx=-1;
		forn(k,i) if (f[z[k]]<s[k+1]) mx=k;

		forn(j,i+1) {
			if (j) {
				--z[j-1];
				ok&=f[z[j-1]]>=s[j-1];
				cost+=f[z[j-1]]-f[z[j-1]+1];
				if (f[z[j-1]]<s[j]) mx=max(mx,j-1);
			}
			if (!ok) break;
			best=min(best,cost);
			best=min(best,cost+s[mx+1]-s[i]);
		}
		cout<<best<<' ';
	}
	cout<<'\n';
}

struct BIT
{
	vector<int> t; int n;
	BIT(int n) {
		this->n = n; t.assign(n,0);
	}
	void add(int i, int x) {
		for(;i<n;i=i|(i+1)) t[i]+=x;
	}
	int sum(int r) {
		int q=0; for(;r>=0;r=(r&(r+1))-1) q+=t[r]; return q;
	}
};

void solve() {

	cin>>n;
	vii(a,n);
	vii(b,n);
	int z=1;
	forn(i,n-1) z&=a[i]<b[i+1];
	if (z) {
		int mx=0;
		int s=0;
		forn(i,n) {
			s+=a[i]-b[i];
			mx=max(mx,a[i]-b[i]);
			cout<<s-mx<<' ';
		}
		cout<<'\n';
		return;
	}
	z=1;
	forn(i,n-1) z&=a[i]<=a[i+1]&&b[i]<=b[i+1];
	if (z) {
		BIT ft(n);
		forn(i,n-1) ft.add(i,a[i]>=b[i+1]);
		int s=0,mx=0;
		forn(i,n) {
			s+=a[i]-b[i];
			int l=0, r=i;
			while (l<r) {
				int m=(l+r)>>1;
				int q=ft.sum(i-1)-ft.sum(m-1);
				//cout<<"> "<<l<<' '<<r<<' '<<q<<' '<<i<<' '<<m<<'\n';
				if (q==i-m) r=m;
				else l=m+1;
			}
			//cout<<"? "<<i<<' '<<r<<' '<<a[i]<<' '<<b[r]<<' '<<mx<<'\n';
			mx=max(mx,a[i]-b[r]);
			cout<<s-mx<<' ';
		}
		cout<<'\n';
		return;
	}
	if (n<=3000) {
		brut(a,b); return;
	}

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	cin>>t;
	while (t--) solve();
}