#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
#define int int64_t
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF = 1e18 + 117;

void solve() {
    int n; cin >> n;
    vector<int> a(n), b(n);
    for (auto& e : a) cin >> e;
    for (auto& e : b) cin >> e;
    for (int i = 1; i <= n; ++i) {
        vector<int> aa, bb;
        for (int j = 0; j < i; ++j) {
            aa.push_back(a[j]);
            bb.push_back(b[j]);
        }
        sort(aa.begin(), aa.end());
        sort(bb.begin(), bb.end());
        vector<int> pd(i + 1), pr(i + 1);
        for (int j = 1; j <= i; ++j) {
            pd[j] = pd[j - 1] + aa[j - 1] - bb[j - 1];
            if (j < i) pr[j] = pr[j - 1] + aa[j - 1] - bb[j];
        }
        int pred = -1;
        int ans = INF;
        for (int j = 0; j < i; ++j) {
            if (j == i - 1 || aa[j] < bb[j + 1]) {
                ans = min(ans, pd[pred + 1] + pr[j] - pr[pred + 1] + pd.back() - pd[j + 1]);
                pred = j;
            }
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int tt; cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
