#include <iostream>
#include <vector>
#include <random>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

mt19937 rnd(45);

const ll MOD = 1e9 + 7;
const ll inf = 1e18;
#define all(x) x.begin(), x.end()

inline void solve() {
    int n; cin >> n;
    vector<ll> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    bool y = true;
    for (int i = 0; i + 1 < n; ++i) {
        if (a[i] > a[i + 1] || b[i] > b[i + 1]) {
            y = false;
        }
    }
    if (y) {
        ll td = 0;
        cout << "0 ";
        int lst = 0;
        ll sm1 = a[0], sm2 = b[0];
        for (int i = 1; i < n; ++i) {
            sm1 += a[i];
            sm2 += b[i];
            if (a[i - 1] < b[i]) {
                td = max(td, a[i - 1] - b[lst]);
                lst = i;
            }
            cout << sm1 - sm2 - max(td, a[i] - b[lst]) << ' ';
        }
        cout << '\n';
        return;
    }
    vector<ll> st1, st2;
    ll sm1 = 0, sm2 = 0;
    for (int i = 0; i < n; ++i) {
        st1.push_back(a[i]);
        st2.push_back(b[i]);
        sm1 += a[i];
        sm2 += b[i];
        sort(all(st1));
        sort(all(st2));
        int bst = -1;
        ll td = 0;
        int wait = i;
        for (int j = i - 1; j >= 0; --j) {
            if (st1[j] < st2[j + 1]) {
                td = max(td, st1[wait] - st2[j + 1]);
                wait = j;
            }
        }
        td = max(td, st1[wait] - st2[0]);
        cout << sm1 - sm2 - td << ' ';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}