#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <random>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt; cin >> tt;
    while (tt--) {
        int n; cin >> n;
        vector<ll> a(n), b(n);
        for (int i = 0; i < n; i++) cin >> a[i];
        for (int i = 0; i < n; i++) cin >> b[i];
        vector<vector<ll> > dp(n, vector<ll> (2));
        dp[0][0] = a[0] - b[0];
        dp[0][1] = 0;
        for (int i = 1; i < n; i++) {
            dp[i][0] = dp[i - 1][0] + a[i] - b[i];
            if (a[i] == b[i]) dp[i][1] = dp[i - 1][1];
            else dp[i][1] = min(dp[i - 1][1] + a[i] - b[i], dp[i - 1][0]);
        }
        for (int i = 0; i < n; i++) cout << min(dp[i][0], dp[i][1]) << " "; cout << "\n";
    }
}