#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <random>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;


ll main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll tt; cin >> tt;
    while (tt--) {
        ll n; cin >> n;
        vector<ll> a(n), b(n);
        for (ll i = 0; i < n; i++) cin >> a[i];
        for (ll i = 0; i < n; i++) cin >> b[i];
       
        ll sumA = 0, sumB = 0, mx = 0;
        multiset<ll> A, B;
        vector<ll> cnt;
        for (ll i = 0; i < n; i++) {
            sumA += a[i];
            sumB += b[i];
            A.insert(a[i]);
            B.insert(b[i]);
            if (A.find(b[i]) != A.end()) {
                A.erase(A.find(b[i]));
                B.erase(B.find(b[i]));
                sumB -= b[i];
                sumA -= b[i];
            } 

            cnt.clear();
            auto it = B.begin(); 
            ll id = 0;
            for (auto j : A) {
                while (it != B.end() && j >= *it) it++, id++;
                cnt.pb(id);
            }

            ll sz = cnt.size();
            ll last = sz - 1;
            for (ll j = sz - 2; j >= 0; j--) {
                if (cnt[j] < j + 2) {
                    break;
                }
                last = j;
            }

            id = 0;
            for (auto j : B) {
                if (id == last) {
                    mx = max(mx, *A.rbegin() - j);
                    break;
                }
                id++;
            }
            
            cout << sumA - sumB - mx << " ";
        }
        cout << "\n";
    }
}