#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <random>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll tt; cin >> tt;
    while (tt--) {
        ll n; cin >> n;
        vector<ll> a(n), b(n);
        for (ll i = 0; i < n; i++) cin >> a[i];
        for (ll i = 0; i < n; i++) cin >> b[i];
       
        ll sumA = 0, sumB = 0, mx = 0;
        multiset<ll> A, B;
        vector<ll> cnt;
        for (ll i = 0; i < n; i++) {
            sumA += a[i];
            sumB += b[i];
            A.insert(a[i]);
            B.insert(b[i]);
            if (A.find(b[i]) != A.end()) {
                A.erase(A.find(b[i]));
                B.erase(B.find(b[i]));
                sumB -= b[i];
                sumA -= b[i];
            } 

            vector<ll> aa, bb;
            for (auto j : A) aa.pb(j);
            for (auto j : B) bb.pb(j);
            for (int j = 0; j < bb.size(); j++) {
                int ok = 1, j2 = 0;
                for (int k = 0; k < aa.size() - 1; k++) {
                    if (j2 == j) j2++;
                    if (aa[k] < bb[j2]) {
                        ok = 0;
                        break;
                    }
                    j2++;
                }
                if (ok) {
                    mx = max(mx, aa.back() - bb[j]);
                }
            }

            cout << sumA - sumB - mx << " ";
        }
        cout << "\n";
    }
}