#include <bits/stdc++.h>

#define int long long

#define fi first
#define se second

#define pb push_back
#define pw(x) (1ll << x)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn (T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx (T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pii = pair < int , int >;

const int N = 1e6 + 5;
const int inf = 2e9;
const ll INF = 4e18;

int n, a[N], b[N];
bool used[N];

ll calc (vector < int >& a, vector < int >& b) {
    ll res = 0, mn = inf;
    for (int i = 0; i < sz(a); ++ i) {
        for (int j = 0; j < sz(a); ++ j) used[j] = false;
        res = 0;
        for (int j = sz(a) - 1; j >= 0; -- j) {
            if (i == j) continue;
            if (j < sz(a) && !used[j + 1] && b[j + 1] <= a[j]) {
                res += a[j] - b[j + 1];
                used[j + 1] = true;
            } else {
                res += a[j] - b[j];
                used[j] = true;
            }
        }
        umn (mn, res);
    }
    return mn;
}

void solve () {

    vector < int > sta, stb;
    cin >> n;
    for (int i = 1; i <= n; ++ i) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++ i) {
        cin >> b[i];
    }

    for (int i = 1; i <= n; ++ i) {
        sta.pb (a[i]);
        stb.pb (b[i]);
        sort (all (sta));
        sort (all (stb));
        cout << calc (sta, stb) << " ";
    }
    cout << "\n";
}

signed main() {
#ifdef localy
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt;
    cin >> tt;
    while (tt --) {
        solve ();
    }

    return 0;
}
