#include <bits/stdc++.h>
using namespace std;

using ll = long long;

int n;
vector <int> a, b;

void solve1() {
    int prev = 0, ans = 0;
    ll s1 = 0, s2 = 0;
    for (int i = 0; i < n; ++i) {
        s1 += a[i];
        s2 += b[i];
        if (i > 0 && a[i - 1] >= b[i]) {
            ans = max(ans, a[i] - b[prev]);
        } else {
            ans = max(ans, a[i] - b[i]);
            prev = i;
        }
        cout << s1 - s2 - ans << " ";
    }
    cout << "\n";
}

void solve2() {
    for (int i = 0; i < n; ++i) {
        vector <int> x, y;
        for (int j = 0; j <= i; ++j) {
            x.push_back(a[j]);
            y.push_back(b[j]);
        }
        sort(x.begin(), x.end());
        sort(y.begin(), y.end());
        ll s1 = 0, s2 = 0;
        int ans = 0, prev = 0;
        for (int j = 0; j <= i; ++j) {
            s1 += x[j];
            s2 += y[j];
            if (j == 0 || x[j - 1] < y[j]) prev = j;
            ans = max(ans, x[j] - y[prev]);
        }
        cout << s1 - s2 - ans << " ";
    }
    cout << "\n";
}

int main() {
    int t;
    cin >> t;
    for (int j = 0; j < t; ++j) {
        cin >> n;
        int flag = 1;
        a.resize(n);
        b.resize(n);
        for (int i = 0; i < n; ++i) cin >> a[i];
        for (int i = 0; i < n; ++i) cin >> b[i];
        for (int i = 1; i < n; ++i) {
            if (a[i - 1] > a[i] || b[i - 1] > b[i]) flag = 0;
        }
        if (flag) solve1();
        else solve2();
    }
}

/*
3
4
2 4 5 12
1 3 4 10
4
3 5 8 20
1 2 6 7
4
4 4 4 4
1 2 3 4


4
2
3 4
1 2
2
3 4
1 3
3
11 17 14
1 13 10
4
100 11 50 42
30 1 20 5

 */
