//Alors on dance

#include<bits/stdc++.h>

const int N = 1e6;

int M;
long long wei[N];
long long tr[4 * N][4], sm[4 * N];
int upd[N];
void push(int node) {
    if (!upd[node]) return;
    for (int c = 0; c < 4; ++c) {
        tr[node][c] = sm[node];
    }
    upd[node << 1] = 1;
    upd[node << 1 | 1] = 1;
    upd[node] = 0;
}

void update(int ql, int qr, int node = 1, int l = 0, int r = M - 1) {
    push(node);
    if (r < ql || qr < l) return;
    if (ql <= l && r <= qr) {
        upd[node] = 1;
        push(node);
        return;
    }
    int m = (l + r) / 2;
    update(ql, qr, node << 1, l, m);
    update(ql, qr, node << 1 | 1, m + 1, r);
    tr[node][0] = std::max({tr[node << 1][0], tr[node << 1 | 1][0], tr[node << 1][2] + tr[node << 1 | 1][1]});
    tr[node][1] = std::max(tr[node << 1][1], tr[node << 1][3] + tr[node << 1 | 1][1]);
    tr[node][2] = std::max(tr[node << 1 | 1][2], tr[node << 1][2] + tr[node << 1 | 1][3]);
    tr[node][3] = tr[node << 1][3] + tr[node << 1 | 1][3];
}

void build(int node = 1, int l = 0, int r = M - 1) {
    if (l == r) {
        sm[node] = wei[l];
        return;
    }
    int m = (l + r) / 2;
    build(node << 1, l, m);
    build(node << 1 | 1, m + 1, r);
    sm[node] = sm[node << 1] + sm[node << 1 | 1];
}

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);

    int t;
    std::cin >> t;
    while (t--) {
        int n;
        std::cin >> n;
        std::vector<int> a(n), b(n);
        for (auto& i : a) std::cin >> i;
        for (auto& i : b) std::cin >> i;
        std::vector<int> val;
        for (auto i : a) val.push_back(i);
        for (auto i : b) val.push_back(i);
        std::sort(val.begin(), val.end());
        val.resize(std::unique(val.begin(), val.end()) - val.begin());
        M = val.size() - 1;
        for (int i = 0; i < M; ++i) wei[i] = val[i + 1] - val[i];
        for (int i = 0; i < 4 * M; ++i) {
            for (int c = 0; c < 4; ++c) {
                tr[i][c] = -1e9;
            }
            upd[i] = 0;
        }
        build();
        long long ss = 0;
        std::vector<int> cnt(M);
        for (int i = 0; i < n; ++i) {
            int l = std::lower_bound(val.begin(), val.end(), b[i]) - val.begin();
            int r = std::lower_bound(val.begin(), val.end(), a[i]) - val.begin() - 1;
            update(l, r);
            ss += a[i] - b[i];
            std::cout << ss - tr[1][0] << ' ';
        }
        std::cout << '\n';
//        std::cout << 111 << std::endl;
    }
}