#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
//#pragma GCC optimize("trapv")
#endif
#include <bits/stdc++.h>

const int MAX_N = (int)3e5+10;
const int INT_INF = (int)2e9;
const double pi = acos(-1);


using namespace std;
using ld = long double;
using ll = long long;
int n;


void fast_solve(){
    vector<int>a(n);
    vector<int>b(n);
    vector<int>buffera;
    vector<int>bufferb;
    for(int i = 0;i<n;++i){
        cin>>a[i];
    }
    for(int i = 0;i<n;++i){
        cin>>b[i];
    }
    set<int>st;
    map<int,int>open;
    ll sumsop = 0;
    ll sums_zakr = 0;
    int maxs = 0;
    for(int i = 0;i<n;++i){
        int pos_op = b[i];
        int pos_zakr = a[i];
        sumsop+=b[i];
        sums_zakr+=a[i];
        auto it = st.lower_bound(pos_op);
        if(it == st.end()){
            maxs = max(pos_zakr-pos_op,maxs);
            st.insert(pos_zakr);
            open[pos_zakr] = pos_op;
        }
        else{
            if(*it>pos_zakr){
                if(open[*it]>pos_op){
                    open[*it] = pos_op;
                    maxs = max(maxs,*it-pos_op);
                }
            }
            else{
                if(open[*it]>pos_op){
                    maxs = max(maxs,pos_zakr-pos_op);
                    open[pos_zakr] = pos_op;
                    st.erase(it);
                    st.insert(pos_zakr);
                }
                else{
                    maxs = max(maxs,pos_zakr-open[*it]);
                    open[pos_zakr] = open[*it];
                    st.erase(it);
                    st.insert(pos_zakr);
                }
            }
        }
        cout<<sums_zakr-sumsop-maxs<<" ";
    }
}

void slow_solve(){
    vector<int>a(n);
    vector<int>b(n);
    vector<int>buffera;
    vector<int>bufferb;
    for(int i = 0;i<n;++i){
        cin>>a[i];
    }
    for(int i = 0;i<n;++i){
        cin>>b[i];
    }
    for(int i = 0;i<n;++i){
        buffera.push_back(a[i]);
        bufferb.push_back(b[i]);
        int ind = i;
        while(ind>0 && buffera[ind]<buffera[ind-1]){
            swap(buffera[ind],buffera[ind-1]);
            ind--;
        }
        ind = i;
        while(ind>0 && bufferb[ind]<bufferb[ind-1]){
            swap(bufferb[ind],bufferb[ind-1]);
            ind--;
        }
        ll sums = 0;
        int maxs = 0;
        vector<int>st;
        int u1 = 0;
        int u2 = 0;
        while(u1<=i && u2<=i){
            if(buffera[u1]<bufferb[u2]){
                maxs = max(maxs,buffera[u1]-st.back());
                sums+=buffera[u1]-st.back();
                u1++;
                st.pop_back();
            }
            else{
                st.push_back(bufferb[u2]);
                u2++;
            }
        }
        while(u1<=i){
            maxs = max(maxs,buffera[u1]-st.back());
            sums+=buffera[u1]-st.back();
            u1++;
            st.pop_back();
        }
        cout<<sums-maxs<<" ";
    }
}

void solve(){
    cin>>n;
    if(n>3000){
        fast_solve();
    }
    else{
        slow_solve();
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
    int t;
    cin>>t;
    while(t--){
        solve();
        cout<<"\n";
    }
    return 0;
}
