#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <algorithm>
#include <deque>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
#define int ll

using namespace std;

mt19937 rnd(0);
vector<int> t;
void build(vector<int>& b, int v, int l, int r) {
	if (l == r - 1) {
		t[v] = b[l];
		return;
	}
	int m = (l + r) / 2;
	build(b, v * 2 + 1, l, m);
	build(b, v * 2 + 2, m, r);
	t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
}

int mi(int v, int l, int r, int lq, int rq) {
	if (lq <= l && r <= rq) {
		return t[v];
	}
	if (lq >= r || rq <= l) {
		return 1e18;
	}
	int m = (l + r) / 2;
	return min(mi(v * 2 + 1, l, m, lq, rq), mi(v * 2 + 2, m, r, lq, rq));
}

void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	vector<int> pa{ 0 }, pb{ 0 };
	vector<int> pma(n);
	for (int i = 0; i < n;i++) {
		cin >> a[i];
		pa.push_back(pa.back() + a[i]);
		pma[i] = max(i ? pma[i - 1] : 0, a[i]);
	}
	for (int i = 0; i < n;i++) {
		cin >> b[i];
		pb.push_back(pb.back() + b[i]);
	}
	vector<int> mi_l(n);
	for (int i = 0; i < n; i++) {
		if (i && a[i - 1] >= b[i]) {
			mi_l[i] = min(mi_l[i - 1], b[i]);
		}
		else {
			mi_l[i] = b[i];
		}
	}
	t.resize(n * 4);
	int maa = 0;
	for (int l = 0; l < n; l++) {
		maa = max(maa, pma[l] - b[l]);
		maa = max(maa, a[l] - mi_l[l]);
		cout << pa[l+1] - pb[l+1] - maa << ' ';
	}
	cout << '\n';

}


signed main() {
	cout.setf(ios_base::fixed);
	cout << fixed << std::setprecision(12);
	ios_base::sync_with_stdio(false);
	cin.tie(0);

#ifdef LOCAL
	auto f = freopen("input.txt", "r", stdin);
	auto f1 = freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}