#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9 + 1;
const int mod = inf + 6;
const ll infll = 1ll * (inf - 1) * (inf - 1);
mt19937_64 rnd(228);//time(0));
ll solve(vector<int> a, vector<int> b) {
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    int ptr = 0;
    multiset<int> st;
    vector<int> ord;
    int n = a.size();
    for (int i = 0; i < n; i++) {
        while (b[ptr] <= a[i] && ptr != n) st.insert(b[ptr++]);
        ord.push_back(*st.rbegin());
        st.extract(ord.back());
    }
    ll sum = 0, mxdiff = 0;
    for (int i = 0; i < n; i++) {
        sum += a[i] - b[i];
        chmax(mxdiff, a[i] - ord[i]);
    }
    return sum - mxdiff;
}
void solve_case() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    bool g4 = true;
    for (int i = 0; i + 1 < n; i++) g4 &= a[i] < b[i + 1];
    if (g4) {
        ll ans = 0, max_diff = 0;
        for (int i = 0; i < n; i++) {
            ans += a[i] - b[i];
            chmax(max_diff, a[i] - b[i]);
            cout << ans - max_diff << " \n"[i == n - 1];
        }
        return;
    }
    bool g5 = true;
    for (int i = 0; i + 1 < n; i++) {
        g5 &= a[i] <= a[i + 1];
        g5 &= b[i] <= b[i + 1];
    }
    if (g5) {
        ll sum = 0;
        vector<int> diff(n, 0);
        for (int i = 0; i < n; i++) chmax(diff[i], a[i] - b[i]);
        vector<int> can(n);
        for (int i = 0; i < n; i++) {
            can[i] = upper_bound(b.begin(), b.end(), a[i]) - b.begin() - 1;
        }
        vector<int> prv(n);
        for (int i = 1; i < n; i++) {
            if (can[i - 1] == i - 1) {
                prv[i] = i;
            } else {
                prv[i] = prv[i - 1];
            }
        }
        for (int i = 1; i < n; i++) {
            chmax(diff[i], a[i] - b[prv[i]]);
        }
        for (int i = 1; i < n; i++) chmax(diff[i], diff[i - 1]);
        for (int i = 0; i < n; i++) {
            sum += a[i] - b[i];
            cout << sum - diff[i] << " \n"[i == n - 1];
        }
        return;
    }
    vector<int> x, y;
    for (int i = 0; i < n; i++) {
        x.push_back(a[i]);
        y.push_back(b[i]);
        cout << solve(x, y) << " \n"[i == n - 1];
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve_case();
    }
}
