#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long

#ifdef LOCAL
constexpr int MAXN = 100, LG = 5;
#else
constexpr int MAXN = 300010, LG = 60;
#endif

ll solve_cum(vector<int> a, vector<int> b) {
    ll res = 0;
    int i = 0;
    for (; i < min(b.size(), a.size()); i++) {
        if (a[i] >= b[i])
            res += a[i] - b[i];
        else
            break;
    }
    for (i++; i < a.size(); i++) {
        res += a[i] - b[i - 1];
    }
    return res;
}

ll solve(vector<int> a, vector<int> b) {
    ll ans = 1e18, cur = 0;
    sort(all(a));
    sort(all(b));
    while (!b.empty()) {
        int was = b[0];
        b.erase(b.begin());
        ans = min(ans, solve_cum(a, b) + cur);

        cur += a[0] - was;
        a.erase(a.begin());
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n; i++) {
        vector<int> c = a, d = b;
        c.resize(i + 1);
        d.resize(i + 1);
        cout << solve(c, d) << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    
    return 0;
}
