#include "bits/stdc++.h"
using namespace std;

void solve() {
    int n;
    cin >> n;

    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }

    vector<int> b(n);
    for (int &i : b) {
        cin >> i;
    }

    cout << 0 << " ";
    for (int i = 1; i < n; i++) {
        multiset<int, less<>> as;
        multiset<int, greater<>> bs;
        for (int j = 0; j <= i; j++) {
            as.insert(a[j]);
            bs.insert(b[j]);
        }

        int maxdiff = 0;
        int res = 0;
        for (int ai : as) {
            auto bi = bs.lower_bound(ai);
            res += ai - *bi;
            maxdiff = max(maxdiff, ai - *bi);
            bs.erase(*bi);
        }

        cout << res - maxdiff << " ";
    }

    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef local
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}