#include "bits/stdc++.h"
using namespace std;

const int N = 300'000 + 228;
struct dsu {
    int p[N];
    
    dsu(int n) {
        iota(p, p + n + 1, 0);
    }

    int get(int x) {
        if (x == p[x]) {
            return x;
        } else {
            return p[x] = get(p[x]);
        }
    }

    void join(int a, int b) {
        a = get(a);
        b = get(b);

        if (a == b) {
            return;
        }

        p[a] = b;
    }

    bool jd(int a, int b) {
        return get(a) == get(b);
    }
};


int n, m1, m2;
vector<vector<bool>> g1, g2;
vector<vector<bool>> bridge;
int timer = 0;
int tin[N];
int fup[N];
void bridges(int u, int p = -1) {
    tin[u] = fup[u] = timer++;

    for (int to = 1; to <= n; to++) {
        if (!g2[u][to] || to == p) {
            continue;
        }

        if (tin[to] == -1) {
            bridges(to, u);
        }

        fup[u] = min(fup[u], fup[to]);
        if (fup[to] > tin[u]) {
            bridge[u][to] = bridge[to][u] = 1;
        }
    }
}

void gr() {
    cin >> n >> m1 >> m2;

    g1.assign(n + 1, vector<bool> (n + 1, 0));
    g2.assign(n + 1, vector<bool> (n + 1, 0));
    dsu d1(n);

    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;

        g1[u][v] = 1;
        g1[v][u] = 1;
        d1.join(u, v);
    }

    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;

        g2[u][v] = 1;
        g2[v][u];
    }

    vector<pair<int, int>> meow;
    for (int u = 1; u <= n; u++) {
        for (int v = 1; v < u; v++) {
            if (!d1.jd(u, v) && !g2[u][v]) {
                cout << "Yes\n";
                cout << 1 << "\n";
                cout << u << " " << v << "\n";
                return;
            } else if (!d1.jd(u, v)) {
                meow.emplace_back(u, v);
            }
        }
    }
    if (meow.size() > 1) {
        cout << "Yes\n1\n" << meow[0].first << " " << meow[0].second << "\n";
    } else {
        cout << "No\n";
    }
}

void solve() {
    int t, g;
    cin >> t >> g;

    while (t--) {
        gr();
    } 
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef local
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}