#ifndef LOCAL
#pragma GCC optimize("03")
#pragma GCC optimize("O3")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ld = long double;
using dd = double;
using uint = unsigned int;
using i128 = __int128;


void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    ll sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sum += a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        sum -= b[i];
    }
    multiset<pair<int, int>> st_a;
    multiset<pair<int, int>, greater<pair<int, int>>> st_b;
    for (int i = 0; i < n; ++i) {
        st_a.insert({a[i], i});
        st_b.insert({b[i], i});
    }
    vector<int> a_ans(n), b_ans(n);
    multiset<int, greater<int>> aans;
    while (!st_b.empty()) {
        pair<int, int> s = *st_b.begin();
        st_b.erase(st_b.begin());
        auto f = st_a.lower_bound({s.first, 0});
        a_ans[f->second] = s.second;
        b_ans[s.second] = f->second;
        aans.insert({f->first - s.first});
        st_a.erase(f);
    }
    vector<int> ans(n);
    for (int i = n - 1; i >= 0; --i) {
        ans[i] = sum - *aans.begin();
        int aa = a_ans[i], bb = b_ans[i];
        aans.erase(a[aa] - b[i]);
        aans.erase(a[i] - b[bb]);
        aans.insert(a[aa] - b[bb]);
        sum -= a[i];
        sum += b[i];
    }
    for (int i = 0; i < n; ++i) cout << ans[i] << " ";
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(4);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t--) solve();
}
