// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("D:\\work2\\input.txt", "r", stdin);
#define file_out freopen("D:\\work2\\output.txt", "w", stdout);
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define str string
#define pb push_back
#define ff first
#define sc second
#define all(a) a.begin(), a.end()
#define sz(a) (int(a.size()))
#define int ll

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2> istream& operator>>(istream &in, pair<T1, T2> &a) { in >> a.ff >> a.sc; return in; }
template<typename T1, typename T2> ostream& operator<<(ostream &out, const pair<T1, T2> &a) { out << a.ff << " " << a.sc; return out; }
template<typename T> istream& operator>>(istream &in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const set<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const multiset<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
mt19937_64 genom(mt_seed); ll randint(ll a, ll b) { uniform_int_distribution<ll> r(a, b); return r(genom); }
const int RANDOM = mt_seed; struct chash { int operator()(int x) const { return x ^ RANDOM; } };
struct pair_hash { ll operator()(pii x) const { return 1ll * x.ff * 31 + x.sc; } };

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    cin >> a >> b;

    bool check = 1;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] >= b[i + 1]) {
            check = 0;
        }
        // if (a[i] > a[i + 1]) {
        //     check = 0;
        // }
        // if (b[i] > b[i + 1]) {
        //     check = 0;
        // }
    }

    if (!check) {
        vector<int> cura, curb;
        int suma = 0, sumb = 0;
        for (int i = 0; i < n; ++i) {
            cura.pb(a[i]);
            curb.pb(b[i]);
            sort(all(cura));
            sort(all(curb));
            
            suma += a[i];
            sumb += b[i];

            int res = suma - sumb;

            // cout << endl;

            int k = 0;
            for (int j = 0; j < sz(cura); ++j) {
                k = max(k, j);
                while (k < sz(cura) - 1 && (cura[k] >= curb[k + 1]))
                    ++k;

                // cout << i << " | " << j << " " << k << endl;
                // cout << suma - sumb << " " << curb[j] << ' ' << cura[k] << endl;

                res = min(res, suma - sumb + curb[j] - cura[k]);
            }

            cout << res << ' ';
        }
        cout << '\n';
        return;
    }

    int suma = 0, sumb = 0;
    int mn = b[0] - a[0];
    for (int i = 0; i < n; ++i) {
        suma += a[i];
        sumb += b[i];

        mn = min(mn, b[i] - a[i]);

        int res = suma - sumb + mn;

        // int res = suma - sumb;
        // int k = 0;
        // for (int j = 0; j < sz(cura); ++j) {
        //     k = max(k, j);
        //     while (k < sz(cura) - 1 && (cura[k] >= curb[k + 1]))
        //         ++k;
        //     res = min(res, suma - sumb + curb[j] - cura[k]);
        // }

        cout << res << ' ';
    }
    cout << '\n';
}

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
