#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()

const ll INF = 1e18;

vector<ll> t;

void update(ll v, ll l, ll r, ll pos, ll x) {
    if (r - l == 1) {
        t[v] = x;
        return;
    }
    ll m = (l + r) / 2;
    if (pos < m) update(2 * v + 1, l, m, pos, x);
    else update(2 * v + 2, m, r, pos, x);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

ll query(ll v, ll l, ll r, ll ql, ll qr) {
    if (l >= qr || r <= ql) return -INF;
    if (l >= ql && r <= qr) return t[v];
    ll m = (l + r) / 2;
    return max(query(2 * v + 1, l, m, ql, qr), query(2 * v + 2, m, r, ql, qr));
}

void solve() {
    ll n;
    cin >> n;
    t.assign(4 * n, 0);
    vector<ll> a(n), b(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> b[i];
    }
    vector<ll> sa, sb;
    ll sum = 0;
    for (ll iter = 0; iter < n; ++iter) {
        sa.push_back(a[iter]);
        sb.push_back(b[iter]);
        for (ll i = sa.size() - 1; i > 0 && sa[i] < sa[i - 1]; --i) {
            swap(sa[i], sa[i - 1]);
        }
        for (ll i = sb.size() - 1; i > 0 && sb[i] < sb[i - 1]; --i) {
            swap(sb[i], sb[i - 1]);
        }
        sum += a[iter] - b[iter];
        ll ans = sa[0] - sb.back();
        ll j = sb.size() - 1;
        for (ll i = sa.size() - 1; i >= 0; --i) {
            ans = max(ans, sa[i] - sb[i]);
            //cout << ans << "\n";
            j = min(i, j);
            if (i == j) {
                while (j > 0 && sa[j - 1] >= sb[j]) --j;
            }
            //cout << j << " " << i << endl;
            ans = max(ans, sa[i] - sb[j]);
            //for (ll j = i; j > 0; --j) {
            //    if (sa[j - 1] < sb[j]) break;
            //    ans = max(ans, sa[i] - sb[j - 1]);
            //}
            //for (ll j = i; j + 1 < sa.size(); ++j) {
            //    if (sa[j + 1] < sb[j]) break;
            //    ans = max(ans, sa[i] - sb[j + 1]);
            //}
        }
        cout << sum - ans << " ";
    }
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll tests;
    cin >> tests;
    while (tests--) {
        solve();
    }
}
