#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

const int N = 5;

int dp[N][2][2];

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (auto& x : a) cin >> x;
    for (auto& x : b) cin >> x;
    for (int k = 1; k <= n; ++k) {
        for (int i = 0; i <= k; ++i) {
            for (int j = 0; j < 2; ++j) {
                for (int c = 0; c < 2; ++c) {
                    dp[i][j][c] = INF;
                }
            }
        }
        sort(a.begin(), a.begin() + k);
        sort(b.begin(), b.begin() + k);
        dp[0][0][0] = dp[0][1][1] = dp[0][0][1] = dp[0][1][0] = 0;
        for (int i = 0; i < k; ++i) {
            dp[i + 1][0][0] = dp[i][0][0] + a[i] - b[i];
            if (i + 1 < k) {
                if (a[i] - b[i + 1] >= 0)
                    dp[i + 1][0][1] = min(dp[i][0][0], dp[i][0][1]) + a[i] - b[i + 1];
                if (a[i + 1] - b[i] >= 0)
                    dp[i + 1][1][0] = min(dp[i][0][0], dp[i][1][0]) + a[i + 1] - b[i];
                if (a[i + 1] - b[i + 1] >= 0)
                    dp[i + 1][1][1] = min({dp[i][0][0], dp[i][0][1], dp[i][1][0], dp[i][1][1]}) + a[i + 1] - b[i + 1];
            }
        }
        int best = INF;
        for (int i = k - 1; i <= k; ++i) {
            for (int j = 0; j < 2; ++j) {
                for (int c = 0; c < 2; ++c) {
                    best = min(best, dp[i][j][c]);
                }
            }
        }
        cout << best << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
     cin >> t;
    while (t--) {
        solve();
    }
}
