#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops", "inline")
#pragma GCC target("popcnt")
using namespace std;
#define int long long

bool check(multiset<int> &a, multiset<int> &b, int x, int y) {
    bool skip1 = false, skip2 = false;
    auto it1 = a.begin(), it2 = b.begin();
    while (it1 != a.end()) {
        if (!skip1 && *it1 == x) {
            it1++;
            skip1 = true;
        }
        if (!skip2 && *it2 == y) {
            it2++;
            skip2 = true;
        }

        if (*it1 < *it2) {
            return false;
        }
        it1++;
        it2++;
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector<int> A(n), B(n);
    for (int &x: A) cin >> x;
    for (int &x: B) cin >> x;

    int sum1 = 0, sum2 = 0;
    multiset<int> a, b;
    set<int> S;
    for (int i = 0; i < n; i++) {
        sum1 += A[i];
        sum2 += B[i];
        if (n > 500) {
            S.insert(A[i] - B[i]);
            cout << sum1 - sum2 - *S.rbegin() << " ";
            continue;
        }

        a.insert(A[i]);
        b.insert(B[i]);
        int best = 1e18;
        auto it = b.begin();
        for (int x: a) {
            while (it != b.end() && !check(a, b, x, *it)) {
                it++;
            }
            if (it == b.end()) break;
            best = min(best, sum1 - sum2 - (x - *it));
        }
        cout << best << " ";
    }
    cout << "\n";
}


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}