#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll inf = 1e18;

vector<ll> pref;

ll get(ll l, ll r) {
    ll res = pref[r];
    if (l != 0) res -= pref[l - 1];
    return res;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t; cin >> t;
    while(t--) {
        ll n; cin >> n;
        vector<ll> a(n);
        vector<ll> b(n);
        for(int i = 0; i < n; i++) cin >> a[i];
        for(int i = 0; i < n; i++) cin >> b[i];
        vector<vector<ll>> r(n);
        for(int i = 0; i < n; i++) {
            r[i] = {a[i], b[i]};
        }
        sort(r.begin(), r.end());
        for(int i = 0; i < n; i++) {
            a[i] = r[i][0];
            b[i] = r[i][1];
        }
        pref = b;
        for(int i = 1; i < n; i++) pref[i] += pref[i - 1];
        ll sum = a[0], dp = 0, was = 1;
        cout << "0 ";
        for(int i = 1; i < n; i++) {
            ll k1 = dp + a[i] - b[i], k2 = -inf;
            if (b[i] > a[i - 1]) {
                was = 0;
            }
            if (was == 1) k2 = pref[i] - pref[0];
            dp = min(k1, sum - k2);
            sum += a[i];
            cout << dp << " ";
        }
        cout << "\n";
    }
    return 0;
}
