#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <random>
#include <unordered_map>
#define ll long long
#define vll vector <ll>
#define f(i, n) for(ll i = 0; i < (ll)n; i++)
#define pll pair <ll, ll>
using namespace std;
random_device rd;

bool check(multiset <ll> &a, multiset <ll> &b) {
	auto i = a.begin();
	auto j = b.begin();
	while(i != a.end()){
		if (*i < *j) {
			return false;
		}
		i++, j++;
	}
	return true;
}

void solve() {
	ll n;
	cin >> n;
	vll a(n), b(n);
	f(i, n) {
		cin >> a[i];
	}
	f(i, n) {
		cin >> b[i];
	}

	ll suma = 0, sumb = 0, ans = 1e18;

	multiset <ll> sta, stb;
	for (int i = 0; i < n; i++) {
		sta.insert(a[i]), stb.insert(b[i]);
		ans = 1e18;
		suma += a[i], sumb += b[i];
		for (int j = 0; j <= i; j++) {
			sta.erase(sta.find(a[j]));
			for (int k = 0; k <= i; k++) {
				stb.erase(stb.find(b[k]));
				if (check(sta, stb)) {
					ans = min(ans, suma - a[j] - sumb + b[k]);
				}
				stb.insert(b[k]);
			}
			sta.insert(a[j]);
		}
		cout << ans << " ";
	}
	cout << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	ll tt = 1;
	cin >> tt;
	while (tt--) {
		solve();
	}
}