#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const ll INF = ll(1e18);

void solve() {
  int n;
  cin >> n;
  vector<int> a(n), b(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  for (int i = 0; i < n; ++i) {
    cin >> b[i];
  }
  vector<int> aa, bb;
  for (int i = 0; i < n; ++i) {
    aa.push_back(a[i]);
    bb.push_back(b[i]);
    sort(aa.begin(), aa.end());
    sort(bb.begin(), bb.end());
    ll ans = INF;
    for (int j = 0; j <= i; ++j) {
      for (int k = 0; k <= i; ++k) {
        auto aaa = aa;
        auto bbb = bb;
        aaa.erase(aaa.begin() + j);
        bbb.erase(bbb.begin() + k);
        bool ok = true;
        ll sa = 0, sb = 0;
        for (int t = 0; t < i; ++t) {
          ok &= aaa[t] >= bbb[t];
          sa += aaa[t];
          sb += bbb[t];
        }
        if (ok) {
          ans = min(ans, sa - sb);
        }
      }
    }
    cout << ans << ' ';
  }
  cout << '\n';
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
