#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const ll INF = ll(1e18);

void solve() {
  int n;
  cin >> n;
  vector<ll> a(n), b(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  for (int i = 0; i < n; ++i) {
    cin >> b[i];
  }
  bool task4 = true;
  for (int i = 0; i < n - 1; ++i) {
    task4 &= a[i] < b[i + 1];
  }
  bool task5 = true;
  for (int i = 0; i < n - 1; ++i) {
    task5 &= a[i] <= a[i + 1] && b[i] <= b[i + 1];
  }
  if (task4) {
    ll mx = 0;
    ll sa = 0, sb = 0;
    for (int i = 0; i < n; ++i) {
      mx = max(mx, a[i] - b[i]);
      sa += a[i];
      sb += b[i];
      cout << sa - sb - mx << ' ';
    }
    cout << '\n';
    return;
  }
  if (task5) {
    ll sumA = a[0], sumB = b[0];
    ll ans = 0;
    cout << 0 << ' ';
    vector<int> bad;
    for (int i = 1; i < n; ++i) {
      ll cur = ans + a[i] - b[i];
      sumA += a[i];
      sumB += b[i];
      if (a[i - 1] < b[i]) {
        bad.emplace_back(i - 1);
      }
      cur = min(cur, sumA - sumB - a[i] + b[bad.empty() ? 0 : bad.back() + 1]);
      ans = cur;
      cout << ans << ' ';
    }
    cout << '\n';
    return;
  }
  vector<int> aa, bb;
  ll sumA = 0, sumB = 0;
  for (int i = 0; i < n; ++i) {
    sumA += a[i];
    sumB += b[i];
    aa.push_back(a[i]);
    bb.push_back(b[i]);
    sort(aa.begin(), aa.end());
    sort(bb.begin(), bb.end());
    ll ans = INF;
    vector<int> bad;
    for (int j = 0; j < i; ++j) {
      if (aa[j] < bb[j + 1]) {
        bad.emplace_back(j);
      }
    }
    for (int j1 = 0; j1 <= i; ++j1) {
      int id = lower_bound(bad.begin(), bad.end(), j1) - bad.begin();
      int i1 = (id == bad.size() ? i : bad[id]);
      ans = min(ans, (sumA - sumB) - (aa[i1] - bb[j1]));
    }
    cout << ans << ' ';
  }
  cout << '\n';

}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
