#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

void solve() {
    int n; cin >> n;
    vector<ll> a(n), b(n), c1(n), c2(n);
    for (auto &x : a) cin >> x;
    for (auto &x : b) cin >> x;

    sort(a.begin(), a.end());
    sort(b.begin(), b.end());

    for (int i = 0; i < n-1; i++) {
        if (a[i] >= b[i+1]) c1[i] = 1;
        if (c1[i] == 1) {
            c1[i] = (i > 0 ? c1[i - 1] : 0) + 1;
        } else {
            c1[i] = 0;
        }
    }

    for (int i = n-2; i >= 0; i--) {
        if (b[i] <= a[i+1]) c2[i] = 1;
    }

    for (int i = 1; i < n; i++) {
        if (c2[i]) c2[i] += c2[i-1];
    }

    ll dbest = 0, allSum = 0;
    for (int i = 0; i < n; i++) {
        allSum += a[i] - b[i];
        if (a[i] >= b[i]) dbest = max(dbest, a[i] - b[i]);

        if (i != 0) {
            int l = c1[i-1];
            ll mn = 1e18;
            for (int j = i-l; j <= i-1; j++) {
                mn = min(mn, b[j]);
            }
            dbest = max(dbest, a[i] - mn);

            l = c2[i-1];
            ll mx = 0;
            for (int j = i-l; j <= i-1; j++) {
                mx = max(mx, a[j]);
            }
            dbest = max(dbest, mx - b[i]);
        }

        cout << allSum - dbest << " ";
    }
    cout << '\n';
}

void fromFile() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0); cout.tie(0);

    //fromFile();

    int gg = 1;
    cin >> gg;

    while (gg--) {
        solve();
    }

    return 0;
}