#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")
//#pragma GCC optimize("unroll-loops")

using namespace std;

using ll = long long;
using ld = long double;
const char endc = '\n';

using namespace std;

ll MX = INTMAX_MAX / 100;

inline void work() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (auto& e : a) cin >> e;
    for (auto& e : b) cin >> e;
    bool group = true;
    for (int i = 0; i < n-1; ++i) group &= (a[i] < b[i+1]);
    if (!group) {
        vector<vector<ll>> bests(n, vector<ll>(n, MX));
        for (int i = 0; i < n; ++i) {
            bests.assign(n, vector<ll>(n, MX));
            for (int z = 0; z <= i; ++z) {
                for (int j = 0; j <= i; ++j) {
                    vector<ll> whatsB, whatsA;
                    whatsA.reserve(i);
                    whatsB.reserve(i);
                    for (int k = 0; k <= i; ++k) {
                        if (k == z) continue;
                        whatsA.push_back(a[k]);
                    }
                    for (int k = 0; k <= i; ++k) {
                        if (k == j) continue;
                        whatsB.push_back(b[k]);
                    }
                    sort(whatsA.begin(), whatsA.end());
                    sort(whatsB.begin(), whatsB.end());
                    bests[z][j] = 0;
                    for (int k = 0; k < i; ++k) {
                        ll delta = whatsA[k] - whatsB[k];
                        if (delta < 0) {
                            bests[z][j] = MX;
                            break;
                        }
                        bests[z][j] += delta;
                    }
                }
            }
            ll answer = INTMAX_MAX;
            for (int k = 0; k <= i; ++k) {
                for (int z = 0; z <= i; ++z) {
                    answer = min(answer, bests[k][z]);
                }
            }
            cout << answer << ' ';
        }
        cout << endc;
    } else {
        ll deltaSum = 0;
        ll deltaMX = INTMAX_MIN;
        for (int i = 0; i < n; ++i) {
            deltaSum += a[i] - b[i];
            deltaMX = max(deltaMX, ll(a[i] - b[i]));
            cout << deltaSum - deltaMX << ' ';
        }
        cout << endc;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    srand(int(time(nullptr)));
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t-- > 0) work();
}