#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdint>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <numbers>
#include <bit>

using namespace std;

#define int int64_t

using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;

const int MAXN = 3e5;

int tree[4 * MAXN];

void push(int v, int l, int r) {

}

int get(int v, int l, int r, int ql, int qr) {
    if (r <= ql || qr <= l) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    int m = (l + r) / 2;
    return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

void upd(int v, int l, int r, int ind, int x) {
    if (l == r - 1) {
        tree[v] = max(tree[v], x);
        return;
    }
    int m = (l + r) / 2;
    if (ind < m) {
        upd(2 * v + 1, l, m, ind, x);
    } else {
        upd(2 * v + 2, m, r, ind, x);
    }
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int T;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        vector<int> a(n), b(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        vector<int> eb;
        for (int i = 0; i < n; i++) {
            cin >> b[i];
            eb.push_back(b[i]);
        }
        sort(eb.begin(), eb.end());
        eb.erase(unique(eb.begin(), eb.end()), eb.end());

        vector<int> pref(n + 1, 0);
        for (int i = 1; i <= n; i++) {
            pref[i] = pref[i - 1] + a[i - 1] - b[i - 1];
        }

        for (int i = 0; i < 4 * MAXN; i++) {
            tree[i] = 0;
        }

        for (int i = 1; i <= n; i++) {
            int updb = lower_bound(eb.begin(), eb.end(), b[i - 1]) - eb.begin();
            int upda = upper_bound(eb.begin(), eb.end(), a[i - 1]) - eb.begin();
            int val = get(0, 0, MAXN, 0, upda);
            upd(0, 0, MAXN, updb, max(a[i - 1], val));
            int dif = 0;
            for (int j = 0; j < i; j++) {
                int cura = upper_bound(eb.begin(), eb.end(), a[j]) - eb.begin();
                dif = max(dif, get(0, 0, MAXN, 0, cura) - b[j]);
            }
            cout << pref[i] - dif << " ";
        }
        cout << "\n";



    }









    return 0;
}
