#include<bits/stdc++.h>
using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(rd());

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

void solve() {
	ll n;
	cin >> n;
	vector<ll> a(n), b(n);
	bool bb = true;
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
		if (i > 0 && a[i] < a[i - 1]) {
			bb = false;
		}
	}
	for (ll i = 0; i < n; i++) {
		cin >> b[i];
		if (i > 0 && b[i] < b[i - 1]) {
			bb = false;
		}
	}
	if (!bb) {
		for (ll i = 0; i < n; i++) {
			vector<ll> na, nb;
			for (ll j = 0; j <= i; j++) {
				na.push_back(a[j]);
				nb.push_back(b[j]);
			}
			sort(na.begin(), na.end());
			sort(nb.begin(), nb.end());
			ll ans = 0, as = 0, sv = 0;
			for (ll j = 0; j <= i; j++) {
				ans += na[j] - nb[j];
				if (j > 0) {
					if (na[j - 1] >= nb[j]) {
						as += na[j - 1] - nb[j];
					} else {
						as = sv;
					}
				}
				assign_min(ans, as);
				sv += na[j] - nb[j];
			}
			cout << ans << ' ';
		}
		cout << '\n';
		return;
	}
	ll ans = 0, as = 0, sv = 0;
	for (ll j = 0; j < n; j++) {
		ans += a[j] - b[j];
		if (j > 0) {
			if (a[j - 1] >= b[j]) {
				as += a[j - 1] - b[j];
			} else {
				as = sv;
			}
		}
		assign_min(ans, as);
		sv += a[j] - b[j];
		cout << ans << ' ';
	}
	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}
