#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <stack>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <string>
#include <random>

using namespace std;
typedef long long ll;
const ll inf = 1e18;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while (t--)
    {
        ll n;
        cin >> n;
        vector <ll> a(n), b(n);
        for (ll i = 0; i < n; i++) cin >> a[i];
        for (ll i = 0; i < n; i++) cin >> b[i];
        cout << 0 << " ";
        for (ll i = 1; i < n; i++)
        {
            vector <ll> at(i + 1), bt(i + 1);
            for (ll j = 0; j <= i; j++)
            {
                at[j] = a[j];
                bt[j] = b[j];
            }
            sort(at.begin(), at.end());
            sort(bt.begin(), bt.end());
            
            ll ANS = inf;
            for (ll j = 0; j <= i; j++) // ignore a
            {
                for (ll k = 0; k <= i; k++) // ignore b
                {
                    ll ans = 0;
                    ll inc = 0;
                    for (ll h = 0; h <= i; h++)
                    {
                        if (h == k && h != j) inc++;
                        if (h != j)
                        {
                            if (at[h] - bt[h + inc] >= 0)
                                ans += abs(at[h] - bt[h + inc]);
                            else ans = inf;
                            //if (j == 2 && k == 0) cout << h << " " << h + inc << " " << at[h] << " " << bt[h + inc] << endl;
                        }
                        if (h == j && h != k) inc--;
                        
                    }
                    //if (j == 2 && k == 0) cout << ans << endl;
                    //cout << j << " " << k << " " << ans << endl;
                    ANS = min(ANS, ans);
                }
            }
            cout << ANS << " ";
        }
        cout << '\n';
    }
}

