#include <bits/stdc++.h>

using ll = long long int;
using ull = unsigned long long int;
using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

const ll INF = 1e18;

void solve()
{
    int n;
    cin >> n;

    vector<ll> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    vector<ll> b(n);
    for (int i = 0; i < n; i++)
        cin >> b[i];

    ll diff = 0;
    for (int i = 1; i <= n; i++)
    {
        diff += a[i - 1] - b[i - 1];
        sort(a.begin(), a.begin() + i);
        sort(b.begin(), b.begin() + i);
        ll ans = INF;
        for (int j = 0; j < i; j++)
        {
            ll res = diff;
            res -= a[j] - b[j];
            for (int k = j - 1; k >= 0 && a[k] >= b[k + 1]; k--)
            {
                res -= a[k] - b[k];
                res += a[k] - b[k + 1];
            }
            ans = min(ans, res);
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("D:/olymp/Day 2/in.txt", "r", stdin);
    freopen("D:/olymp/Day 2/out.txt", "w", stdout);
    cin >> t;
#else
    cin >> t;
#endif
    while (t--)
        solve();
    return 0;
}