#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using ll = long long int;
using ull = unsigned long long int;
using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

const ll INF = 1e18;

void solve()
{
    int n;
    cin >> n;

    vector<ll> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    vector<ll> b(n);
    for (int i = 0; i < n; i++)
        cin >> b[i];

    if (!is_sorted(all(a)) || !is_sorted(all(b)))
    {
        ll diff = 0;
        for (int i = 1; i <= n; i++)
        {
            diff += a[i - 1] - b[i - 1];
            sort(a.begin(), a.begin() + i);
            sort(b.begin(), b.begin() + i);
            ll ans = INF;
            for (int j = i - 1; j >= 0;)
            {
                ll res = diff;
                res -= a[j] - b[j];
                --j;
                for (; j >= 0 && a[j] >= b[j + 1]; j--)
                {
                    res -= a[j] - b[j];
                    res += a[j] - b[j + 1];
                }
                ans = min(ans, res);
            }
            cout << ans << ' ';
        }
        cout << '\n';
    }
    else
    {
        vector<ll> bl(n);
        for (int j = n - 1; j >= 0;)
        {
            --j;
            int old_j = j;
            for (; j >= 0 && a[j] >= b[j + 1]; j--) {}
            ll s = 0;
            for (int k = j + 1; k <= old_j; k++)
            {
                bl[k] = (s += b[k] - b[k + 1]); 
            }
        }
        ll mn = INF;
        ll diff = 0;
        for (int i = 1; i <= n; i++)
        {
            diff += a[i - 1] - b[i - 1];
            if (i > 1)
                mn = min(mn, bl[i - 2] - (a[i - 1] - b[i - 1]));
            else
                mn = min(mn, -(a[i - 1] - b[i - 1]));
            cout << diff + mn << ' ';
        }
        cout << '\n';
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("D:/olymp/Day 2/in.txt", "r", stdin);
    freopen("D:/olymp/Day 2/out.txt", "w", stdout);
    cin >> t;
#else
    cin >> t;
#endif
    while (t--)
        solve();
    return 0;
}