#include <bits/stdc++.h>

using namespace std;

#define int long long
#define fi first
#define se second
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define pw(x) (1LL << x)
#define mp make_pair

constexpr int N = 2e5 + 5;

int n, a[N], b[N], suma, sumb, dp[N], wha[N], whb[N];
int used[2 * N], t[N * 2 * 4], lazy[N * 2 * 4];
vector<pair<int, int> > now;
set<int> open, clos;

void push(int v, int tl, int tr) {
    if (!lazy[v])
        return;
    t[v] += lazy[v];
    if (tl != tr) {
        lazy[v * 2] += lazy[v];
        lazy[v * 2 + 1] += lazy[v];
    }
    lazy[v] = 0;
}

void upd(int v, int tl, int tr, int l, int r, int delta) {
    push(v, tl, tr);
    if (l > r)
        return;
    if (tl == l && tr == r) {
        lazy[v] += delta;
        push(v, tl, tr);
        return;
    }
    int tm = (tl + tr) / 2;
    upd(v * 2, tl, tm, l, min(tm, r), delta);
    upd(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r, delta);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int get(int v, int tl, int tr, int pos) {
    push(v, tl, tr);
    if (pos < tl && tr < pos)
        return 0;
    if (tl == tr)
        return t[v];
    int tm = (tl + tr) / 2;
    if (pos <= tm)
        return get(v * 2, tl, tm, pos);
    else
        return get(v * 2 + 1, tm + 1, tr, pos);
}

void solve() {
    cin >> n;

    now.clear();
    fill_n(used, 2 * n, 0);
    open.clear();
    clos.clear();
    fill_n(t, n * 2 * 4, 0);
    fill_n(lazy, n * 2 * 4, 0);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        now.emplace_back(a[i], n + i);
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        now.emplace_back(b[i], i);
    }

    sort(all(now));
    for (int i = 0; i < n * 2; i++) {
        int ind = now[i].se % n;
        if (now[i].se < n)
            whb[ind] = i;
        else
            wha[ind] = i;
    }

    suma = sumb = 0;
    int ma = 0;
    for (int i = 0; i < n; i++) {
        suma += a[i];
        sumb += b[i];

        upd(1, 0, n * 2 - 1, whb[i], wha[i] - 1, 1);

        while(!open.empty() && open.lower_bound(whb[i]) != open.end() && (*open.lower_bound(whb[i])) < wha[i])
            open.erase(open.lower_bound(whb[i]));

        while(!clos.empty() && clos.lower_bound(whb[i]) != clos.end() &&  (*clos.lower_bound(whb[i])) < wha[i])
            clos.erase(clos.lower_bound(whb[i]));

        int pos_from, pos_to;
        if (get(1, 0, n * 2 - 1, whb[i]) == 1) {
            open.insert(whb[i]);
            pos_from = whb[i];
        } else {
            pos_from = *(-- open.lower_bound(whb[i]));
        }
        if (get(1, 0, n * 2 - 1, wha[i]) == 0) {
            clos.insert(wha[i]);
            pos_to = wha[i];
        } else {
            pos_to = *(clos.lower_bound(wha[i]));
        }

        ma = max(ma, now[pos_to].fi - now[pos_from].fi);

//        if (get(1, 0, n * 2 - 1, whb[i]) == 1) {
//            int pos = *clos.lower_bound(whb[i]);
//            ma = max(ma, now[pos].fi - now[whb[i]].fi);
//        }
//        if (get(1, 0, n * 2 - 1, wha[i]) == 0) {
//            auto pos = open.lower_bound(wha[i]);
//            assert(pos != open.begin());
//            ma = max(ma, now[wha[i]].fi - now[*(--pos)].fi);
//        }


        dp[i] = suma - sumb - ma;
    }

    for (int i = 0; i < n; i++)
        cout << dp[i] << ' ';
    cout << '\n';
}

int32_t main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);

    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }


    return 0;
}

/*

 */
