#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int INF = 1e9;

int get_diff(multiset<int>& curr_a, multiset<int>& curr_b) {
    int diff = 0;
    auto it_a = curr_a.begin(), it_b = curr_b.begin();
    while (it_a != curr_a.end()) {
        if (*it_a < *it_b) return INF;
        diff += abs(*it_a - *it_b);
        it_a++;
        it_b++;
    }
    return diff;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int& i : a) cin >> i;
    for (int& i : b) cin >> i;
    multiset<int> curr_a, curr_b;
    for (int i = 0; i < n; i++) {
        curr_a.insert(a[i]);
        curr_b.insert(b[i]);
        int min_diff = INF;
        auto ita = curr_a.begin();
        while (ita != curr_a.end()) {
            int vala = *ita;
            curr_a.erase(ita);
            auto itb = curr_b.begin();
            while (itb != curr_b.end()) {
                int valb = *itb;
                curr_b.erase(itb);
                min_diff = min(min_diff, get_diff(curr_a, curr_b));
                itb = next(curr_b.insert(valb));
            }
            ita = next(curr_a.insert(vala));
        }
        cout << min_diff << " ";
    }
    cout << "\n";
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}