#pragma GCC optimize("avx2")
#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
using namespace __gnu_pbds;

// #define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

typedef long long ll;

struct poly_hash {
    vector<int> p, h;
    string s;
    int n, mod;

    poly_hash(string s, int P, int mod) : s(s), mod(mod) {
        n = s.size();
        p.resize(n + 1);
        h.resize(n + 1);
        p[0] = 1;
        for (int i = 0; i < n; ++i) {
            p[i + 1] = p[i] * P;
            if (p[i + 1] >= mod) p[i + 1] %= mod;
            h[i + 1] = (h[i] * P + (s[i] - 'a' + 1)) % mod;
        }
    }

    int get(int ind, int len) {
        return ((h[ind + len] - h[ind] * p[len]) % mod + mod) % mod;
    }
};

struct Node {

};

struct SegTree {
    int sz;
    vector<Node> tr;
    Node def;

    SegTree(int n) {
        sz = (1 << (int)(log2(n) + 1));
        tr.resize(sz * 2, def);
    }

    Node merge(Node a, Node b) {

    }

    void push(int v) {

    }

    void update(int v, int l, int r, int ql, int qr, int x) {
        push(v);
        if (qr <= l || ql >= r) return;
        if (ql <= l && r <= qr) {

            push(v);
            return;
        }
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, ql, qr, x);
        update(2 * v + 2, m, r, ql, qr, x);
        tr[v] = merge(tr[2 * v + 1], tr[2 * v + 2]);
    }

    void update(int l, int r, int x) {
        update(0, 0, sz, l, r, x);
    }

    Node get(int v, int l, int r, int ql, int qr) {
        push(v);
        if (qr <= l || ql >= r) return def;
        if (ql <= l && r <= qr) {
            return tr[v];
        }
        int m = (l + r) / 2;
        return merge(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }

    Node get(int l, int r) {
        return get(0, 0, sz, l, r);
    }
};

struct BIT {
    int n;
    vector<int> a;

    BIT(int n) : n(n) {
        a.resize(n + 1);
    }

    void upd(int ind, int x) {
        for (; ind < n; ind = (ind | (ind + 1))) a[ind] += x;
    }

    int get(int ind) {
        int ans = 0;
        for (; ind >= 0; ind = (ind & (ind + 1)) - 1) ans += a[ind];
        return ans;
    }

    int get(int l, int r) { // [l; r]
        return get(r) - get(l - 1);
    }
};


void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    int suma = 0, sumb = 0;
    set<pair<int, int>> segs;
    int maxseg = 0;
    for (int i = 0; i < n; ++i) {
        suma += a[i];
        sumb += b[i];
        // segs.insert({b[i], a[i]});
        auto it = segs.find({b[i], a[i]});
        int l = b[i], r = a[i];
        while (1) {
            bool ok = 1;
            while (segs.size() && segs.lower_bound({b[i], 1e9 + 10}) != segs.begin()) {
                auto it = --segs.lower_bound({b[i], 1e9 + 10});
                if ((*it).second < l) break;
                ok = 0;
                l = min(l, (*it).first);
                r = max(r, (*it).second);
                segs.erase(it);
            }
            while (segs.size() && segs.upper_bound({b[i], 1e9 + 10}) != segs.end()) {
                auto it = segs.upper_bound({b[i], 1e9 + 10});
                if ((*it).first > r) break;
                ok = 0;
                r = max(r, (*it).second);
                l = min(l, (*it).first);
                segs.erase(it);
            }
            if (ok) break;
        }
        maxseg = max(maxseg, r - l);
        segs.insert({l, r});
        cout << suma - sumb - maxseg << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) solve();
}