//#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

using int64 = long long;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {
    int n; cin >> n;
    vector <int> a(n), b(n);
    for (auto& x : a) cin >> x;
    for (auto& x : b) cin >> x;

    set <pair <int, int>> st;
    multiset <int, greater <>> mx;
    int sm = 0;
    for (int i = 0; i < n; ++i) {
        sm += a[i] - b[i];

        auto it1 = st.lower_bound({b[i], (int)1e18});
        auto it2 = st.lower_bound({a[i], (int)1e18});

        if (it2 == st.begin()) {
            st.insert({b[i], a[i]});
            mx.insert(a[i] - b[i]);
        }
        else if (it1 == it2) {
            --it1;
            if (it1->second >= a[i]) {

            }
            else if (it1->second < b[i]) {
                st.insert({b[i], a[i]});
                mx.insert(a[i] - b[i]);
            }
            else {
                int l = it1->first;
                mx.extract({it1->second - it1->first});
                st.erase(it1);
                st.insert({l, a[i]});
                mx.insert(a[i] - l);
            }
        }
        else {
            --it2;
            {
                auto it = it1;
                vector <pair <int, int>> del;
                while (it != it2) {
                    del.push_back(*it);
                    ++it;
                }
                for (auto [l, r] : del) {
                    st.erase({l, r});
                    mx.extract(r - l);
                }
            }

            it2 = st.lower_bound({a[i], (int)1e18});
            --it2;

            int r = a[i];
            if (it2->second >= a[i]) {
                r = it2->second;
                mx.extract(it2->second - it2->first);
                st.erase(it2);
            }

            it1 = st.lower_bound({b[i], (int)1e18});
            if (it1 == st.begin()) {
                st.insert({b[i], r});
                mx.insert(r - b[i]);
            }
            else {
                --it1;
                int l = b[i];
                if (it1->second >= b[i]) {
                    l = it1->first;
                    mx.extract(it1->second - it1->first);
                    st.erase(it1);
                }

                mx.insert(r - l);
                st.insert({l, r});
            }
        }

        cout << sm - *mx.begin() << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }

    return 0;
}
