#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int &x: a) cin >> x;
    for (int &x: b) cin >> x;
    int sa = 0, sb = 0;
    multiset<int> badA, badB;
    int prev = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] == b[i]) {
            cout << prev << ' ';
            continue;
        }
        sa += a[i], sb += b[i];
        badA.insert(a[i]), badB.insert(b[i]);
        if (badB.find(a[i]) != badB.end()) {
            badB.erase(badB.find(a[i])), sb -= a[i];
            badA.erase(badA.find(a[i])), sa -= a[i];
        }
        if (badA.find(b[i]) != badA.end()) {
            badA.erase(badA.find(b[i])), sa -= b[i];
            badB.erase(badB.find(b[i])), sb -= b[i];
        }
        if (sz(badB) < 2) {
            cout << "0 ";
            prev = 0;
            continue;
        }
        auto ra = --badA.end();
        auto rb = --badB.end();
        auto wha = ra;
        prev = 0;
        while (true) {
            while (true) {
                if (wha == ra) wha--;
                if (*wha < *rb || rb == badB.begin()) break;
                wha--, rb--;
            }
            prev = max(prev, *ra - *rb);
            if (ra == badA.begin()) break;
            ra--;
        }
        prev = sa - sb - prev;
        cout << prev << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
