#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int &x: a) cin >> x;
    for (int &x: b) cin >> x;
    int sa = 0, sb = 0;
    multiset<int> badA, badB;
    int prev = 0;
    int ty1 = 1;
    for (int i = 1; i < n; i++) {
        if (a[i - 1] >= b[i]) {
            ty1 = 0;
            break;
        }
    }
    set<int>ty;
    for (int i = 0; i < n; i++) {
        if (a[i] == b[i]) {
            cout << prev << ' ';
            continue;
        }
        sa += a[i], sb += b[i];
        badA.insert(a[i]), badB.insert(b[i]);
        if (badB.find(a[i]) != badB.end()) {
            badB.erase(badB.find(a[i])), sb -= a[i];
            badA.erase(badA.find(a[i])), sa -= a[i];
        }
        if (badA.find(b[i]) != badA.end()) {
            badA.erase(badA.find(b[i])), sa -= b[i];
            badB.erase(badB.find(b[i])), sb -= b[i];
        }
        if (sz(badB) < 2) {
            cout << "0 ";
            prev = 0;
            continue;
        }
        if (ty1) {
            ty.insert(a[i] - b[i]);
            prev = sa - sb - *--ty.end();
            cout << prev << ' ';
            continue;
        }
        vector<int> aa, bb;
        for (int x: badA) aa.push_back(x);
        for (int x: badB) bb.push_back(x);
        int N = sz(aa);
        vector<int> bad;
        for (int I = 1; I < N; I++) {
            if (bb[I] > aa[I - 1]) bad.push_back(I);
        }
        if (bad.empty()) {
            prev = (sa - aa.back()) - (sb - bb[0]);
            cout << prev << ' ';
            continue;
        }
        prev = aa[bad[0] - 1] - bb[0];
        for (int ib = 0; ib < sz(bad); ib++) {
            int ra = N - 1;
            if (ib + 1 < sz(bad)) ra = bad[ib + 1] - 1;
            int lb = bad[ib];
            prev = max(prev, aa[ra] - bb[lb]);
        }
        prev = sa - sb - prev;
        cout << prev << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
