#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <cmath>
#include <unordered_map>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <iomanip>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using vi = vector <int>;
using vll = vector <ll>;
using vpii = vector <pii>;
using vvi = vector <vi>;

#define all(_x) _x.begin(), _x.end()
#define rall(_x) _x.rbegin(), _x.rend()
#define sz(_x) (int)_x.size()
#define ff first
#define ss second
#define pb push_back
#define display(_x) for (auto val : _x) cout << val << ' '; cout << '\n';
#define cin_arr(_x) for (auto &val : _x) cin >> val;
#define fast_input ios_base::sync_with_stdio(0); cin.tie(0);

const int INF = 1e9;
const ll INFLL = 1e18;
const int MOD = 1e9 + 7;
const double EPS = 1e-9;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int MAXN = 500;
int n;
int a[MAXN];
int b[MAXN];

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];
    map <int, int> q;
    for (int i = 1; i <= n; i++) {
        sort(a, a + i);
        q[b[i - 1]]++;
        ll ans = INFLL;
        for (int j = 0; j < i; j++) {
            ll cur = 0;
            vi del;
            for (int z = 0; z < j; z++) {
                auto it = q.upper_bound(a[z]);
                it--;
                int x = (*it).ff;
                cur += a[z] - x;
                del.pb(x);
                q[x]--;
                if (q[x] == 0)
                    q.erase(x);
            }
            for (int z = j + 1; z < i; z++) {
                auto it = q.upper_bound(a[z]);
                it--;
                int x = (*it).ff;
                cur += a[z] - x;
                del.pb(x);
                q[x]--;
                if (q[x] == 0)
                    q.erase(x);
            }
            for (int x : del)
                q[x]++;
            ans = min(ans, cur);
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int main() {
    fast_input;
    int t;
    cin >> t;
    while (t--)
        solve();
}