#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using ll = long long;
#define int long long
#define x first
#define y second
#define sz(a) (int)a.size()
using namespace __gnu_pbds;
gp_hash_table<int, int> table;
const int inf = 4e18;


void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    vector<int> pref(n);
    pref[0] = a[0] - b[0];
    for (int i = 1; i < n; ++i) {
        pref[i] = pref[i - 1] + a[i] - b[i];
    }
    if (n <= 3000) {
        vector<int> ans(n);
        vector<int> e = {a[0]}, f = {b[0]};
        for (int i = 1; i < n; ++i) {
            e.emplace_back(a[i]);
            f.emplace_back(b[i]);
            for (int j = i; j > 0; --j) {
                if (e[j] < e[j - 1]) swap(e[j], e[j - 1]);
                else break;
            }
            for (int j = i; j > 0; --j) {
                if (f[j] < f[j - 1]) swap(f[j], f[j - 1]);
                else break;
            }
            vector<int> last(i + 1);
            last[0] = f[0];
            for (int j = 1; j <= i; ++j) {
                if (f[j] <= e[j - 1]) {
                    last[j] = min(last[j - 1], f[j]);
                } else {
                    last[j] = f[j];
                }
            }
            for (int j = 0; j <= i; ++j) {
                ans[i] = max(ans[i], e[j] - last[j]);
            }
        }
        cout << 0 << " ";
        for (int i = 1; i < n; ++i) {
            cout << pref[i] - ans[i] << ' ';
        } cout << '\n';
    } else {
        vector<int> last(n, 0);
        last[0] = b[0];
        for (int i = 1; i < n; ++i) {
            if (b[i] <= a[i - 1]) {
                last[i] = min(last[i - 1], b[i]);
            } else {
                last[i] = b[i];
            }
        }
        vector<int> k(n);
        for (int i = 0; i < n; ++i) {
            k[i] = a[i] - last[i];
        }
        int mx = 0;
        for (int i = 0; i < n; ++i) {
            mx = max(mx, k[i]);
            cout << pref[i] - mx << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    int _o = 1;
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    iostream::ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> _o;
    while (_o--) {
        solve();
    }
    return 0;
}
