#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector
#define F first
#define S second

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

using ll = long long;
using uint64 = unsigned long long;
using pii = pair<int, int>;

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll infll = 1e18 + 10;

void solve() {
    int n;
    cin >> n;

    vector<int> a(n);
    vector<int> b(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    vector<int> ta, tb;

    int Sa = 0, Sb = 0;

    int ans = infll;

    int back = -1;

    for (int i = 0; i < n; i++) {

        ta.push_back(a[i]);
        tb.push_back(b[i]);
        Sa += a[i];
        Sb += b[i];

        ans += a[i] - b[i];

        if (back == -1) {
            ans = min(ans, (Sa - ta[i]) - (Sb - tb[i]));
        } else {
            ans = min(ans, (Sa - ta[i]) - (Sb - tb[back]));
        }

        if (i < sz(ta) - 1 && ta[i] >= tb[i + 1]) {
            if (back == -1) {
                back = i;
            }
        } else {
            back = -1;
        }

        cout << ans << " ";
    }
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}