#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,bmi,bmi2,lzcnt,popcnt")

// #define endl '\n'
#define F first
#define S second

typedef long long ll;
using namespace std;
using namespace __gnu_pbds;

mt19937 rng(time(nullptr));
mt19937_64 rngl(time(nullptr));

ll rnd(ll x) {
    uniform_int_distribution<ll> uid(0, x - 1);
    return uid(rngl);
}

int rnd(int x) {
    uniform_int_distribution<int> uid(0, x - 1);
    return uid(rng);
}

int R = 1;
struct segment_tree {
    vector <ll> t, add;
    segment_tree(int n) {
        R = 1;
        while (R <= n + 10)
            R *= 2;
        t.resize(R * 2 + 32);
        add.resize(R * 2 + 32);
    }
    void push(int node, int nl, int nr) {
        t[node] += add[node] * (nr - nl + 1);
        if (node < R) {
            add[node * 2] += add[node];
            add[node * 2 + 1] += add[node];
        }
        add[node] = 0;
    }
    void calc(int node) {
        if (node < R) {
            t[node] = t[node * 2] + t[node * 2 + 1];
        }
    }
    void modify(int ql, int qr, ll val, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return;
        if (qr <= nl && nr <= qr) {
            add[node] += val;
            push(node, nl, nr);
            return;
        }
        int nm = (nl + nr) / 2;
        modify(ql, qr, val, node * 2, nl, nm);
        modify(ql, qr, val, node * 2 + 1, nm + 1, nr);
        calc(node);
    }
    ll query(int ql, int qr, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return 0;
        if (qr <= nl && nr <= qr)
            return t[node];
        int nm = (nl + nr) / 2;
        return query(ql, qr, node * 2, nl, nm) +
               query(ql, qr, node * 2 + 1, nm + 1, nr);
    }
};

struct Point {
    ll x, y;

    explicit Point(ll x = 0, ll y = 0) : x(x), y(y) {}

    void in() {
        cin >> x >> y;
    }

    ll operator*(Point &other) {
        return x * other.x + y * other.y;
    }

    ll operator%(Point &other) {
        return x * other.y - y * other.x;
    }
};

ll get(int x, int y) {
    return (x << 10) ^ y;
}

void solve() {
    int n;
    cin >> n;
    vector <ll> a(n), b(n);
    for (auto& i : a)
        cin >> i;
    for (auto& i : b)
        cin >> i;
    for (int i = 0; i < n; i++) {
        sort(a.begin(), a.begin() + i + 1);
        sort(b.begin(), b.begin() + i + 1);
        ll ans = 1e15;
        for (int j = 0; j <= min(i, 60); j++) {
            for (int k = max(0, i - 60); k <= i; k++) {
                ll sum = 0;
                int i1 = -1, i2 = -1;
                for (int _ = 0; _ < i; _++) {
                    i1++, i2++;
                    while (i1 == j)
                        i1++;
                    while (i2 == k)
                        i2++;
                    sum += a[i1] - b[i2];
                    if (a[i1] - b[i2] < 0) {
                        sum = 1e15;
                        break;
                    }
                }
                ans = min(ans, sum);
            }
        }
        cout << ans << ' ';
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();
    cerr << "Ulyanovsk is the best!!!" << endl;
}
