#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct node{
    node * left = nullptr;
    node * right = nullptr;
    int sz = 1;
    int val = 0;

};

void update(node *v){
    if(v == nullptr) return;
    v->sz = 1;
    if(v->left) v->sz += v->left->sz;
    if(v->right) v->sz += v->right->sz;
}


node *merge(node * a, node * b){
    if(a == nullptr) return b;
    if(b == nullptr) return a;
    if(a->sz > b->sz){
        a->right = merge(a->right,b);
        update(a);
        return a;
    } else {
        b->left = merge(a, b->left);
        update(b);
        return b;
    }
}

pair<node *, node *> split(node *a, int val){
    if(a == nullptr){
        return {nullptr, nullptr};
    }
    if(a->val >= val){
        auto p = split(a->left, val);
        a->left = p.second;
        update(a);
        return {p.first, a};
    } else {
        auto p = split(a->right, val);
        a->right = p.first;
        update(a);
        return {a, p.second};
    }
}

node *add(int val, node* a){
    auto p = split(a, val);
    node *v = new node();
    v->val = val;
    a = merge(p.first,v);
    a = merge(a,p.second);
    return a;
}

//int get_k(node *a, int k){
//
//}
//
//int lb(node *a, int val){
//    if(a == nullptr) return 0;
//
//}

void solve(){
    int n;
    cin >> n;
    vector<ll> a(n), b(n);
    bool C = true;
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }for(int i = 0; i < n; i++){
        cin >> b[i];
    }
    for(int i = 1; i < n; i++){
        if(a[i - 1]>= b[i]) C = false;
    }
    ll md = 0;
    ll s = 0;
    ll s1 = 0;
    ll s2 = 0;
    for(int i = 0; i < n; i++){
        s1 += a[i];
        s2 += b[i];
        md = max(md, a[i]-b[i]);
        s += a[i] - b[i];
        sort(a.begin(), a.begin() + i + 1);
        sort(b.begin(), b.begin() + i + 1);
        ll mn= b[0];
        ll mx = a[0];
        ll mxd = mx - mn;
        if(C){
            mxd = md;
        } else {
            for(int j = 0; j < i; j++){
                if(a[j] < b[j + 1]){
                    mn = b[j + 1];
                    mx = a[j + 1];
                    mxd = max(mx - mn, mxd);
                } else {
                    mx = a[j + 1];
                    mxd = max(mx - mn, mxd);
                }
            }
        }
        cout << s1 - s2 - mxd << ' ';
    }
    cout << '\n';
}

void solve2(){
    int n;
    cin >> n;
    vector<ll> a(n), b(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }for(int i = 0; i < n; i++){
        cin >> b[i];
    }
    ll s1 = 0;
    ll s2 = 0;
//    ll mx = 0;
//    ll mn = 10000000000;
    multiset<ll> a1,b1;
    ll md = 0;
    for(int i = 0; i < n; i++){
        md = max(md, a[i]-b[i]);
        a1.insert(a[i]);
        b1.insert(b[i]);
        auto i1 = a1.begin();
        auto j1 = b1.begin();
        auto i2 = i1;
        i2++;
        ll mx = 0;

        if(i == 0){
            mx = *i1;
        }
        ll mi = 0;
        if(i > 0) j1++;
        for(int j = 0; j < i; j++){
            if(*i1 >= *j1){
                if(*i2 >= mx){
                    mi = j;
                }
                mx = max(mx, *i2);
            }
            i1++;
            j1++;
            i2++;
        }
        i1 = a1.begin();
        j1 = b1.begin();
        auto j2 = j1;
        ll mn = 100000000000;
        ll mni = 0;

        if(i == 0){
            mn = *j2;
        }
        if(i > 0) j1++;
        for(int j = 0; j < i; j++){
            if(j == mi){
                i1++;
            }
            if(*i1 >= *j1){
                if(*j2 <= mn){
                    mni = i;
                }
                mn = min(mn, *j2);
            }
            i1++;
            j1++;
            j2++;
        }


        s1 += a[i];
        s2 += b[i];
        cout << s1 - s2 - max(md, mx - mn)<< ' ';
    }
    cout << '\n';
}

int main(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t=1;
    cin >> t;
    while(t--){
        solve();

    }

}