#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <array>
using namespace std;

long long n;
const long long INF = 1e9;
array<long long, 200000> a;
array<long long, 200000> b;

void solve() {
    long long cnt, mb = INF, sa = 0, sb = 0, ans1, ans2 = INF, aa = 0;
    set<vector<long long>> ma;
    set<long long> bb;
    set<long long> dif;
    for (long long i = 0; i < n; i++) {
        if (!ma.empty() && -(*ma.begin())[0] >= b[i] && mb > b[i] && *bb.begin() <= a[i]) {
            auto it = ma.lower_bound({-b[i], 0});
            it--;
            mb = min(b[i], -(*it)[1]);
        }
        if (a[i] >= aa && (aa >= b[i] || (aa == 0 && mb != INF)))
            aa = a[i];
        bb.insert(b[i]);
        ma.insert({-a[i], -b[i]});
        dif.insert(-(a[i] - b[i]));
        sa += a[i];
        sb += b[i];
        ans1 = sa - sb + *dif.begin();
        if (mb != INF)
            ans2 = sa - sb - (aa - mb);
        cout << min(ans1, ans2) << ' ';
    }
    cout << '\n';
}

void solve1() {
    long long cnt, aa, bb, sa = 0, sb = 0, ba, ans;
    multiset<array<long long, 2>> v;
    for (long long i = 0; i < n; i++) {
        sa += a[i], sb += b[i];
        v.insert({-a[i], -1});
        v.insert({-b[i], 1});
        aa = INF, bb = INF, ans = sa - sb, ba = 0;
        for (auto i = v.begin(); i != v.end(); i++) {
            ba -= (*i)[1];
            if ((*i)[1] == -1 && ba == 1)
                aa = -(*i)[0];
            if ((*i)[1] == 1 && ba >= 0)
                bb = -(*i)[0];
            //cout << aa << ' ' << bb << '\n';
            ans = min(ans, sa - sb - (aa - bb));
            if (ans < sa - sb - aa)
                break;
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long t;
    cin >> t;
    for (long long i = 0; i < t; i++) {
        cin >> n;
        bool flag = true;
        for (long long i = 0; i < n; i++)
            cin >> a[i];
        for (long long i = 0; i < n; i++) {
            cin >> b[i];
            if (i > 0 && b[i] <= a[i - 1])
                flag = false;
        }
        if (n <= 3000 && !flag)
            solve1();
        else
            solve();
    }
}

