//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt,fma")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const long long RANDOM = chrono::high_resolution_clock::now().time_since_epoch().count();
constexpr int MAXN = 1 << 20;
constexpr long long mod = 1e9 + 7;
mt19937 rnd(RANDOM);

ll ans(vector<ll> &a, vector<ll> &b) {
    ll ans = 0;
    multiset<ll> st1, st2;
    for (auto i: a) {
        st1.insert(i);
    }
    for (auto i: b) {
        st2.insert(i);
    }
    while (st1.size() > 1) {
        ll mn = 1e18;
        ll cur = 0;
        for (auto i: st1) {
            auto in = st2.upper_bound(i);
            in--;
            if (i - *in < mn) {
                mn = i - *in;
                cur = i;
            }
        }
        st1.erase(st1.find(cur));
        auto in = st2.upper_bound(cur);
        in--;
        st2.erase(st2.find(*in));
        ans += mn;
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n), b(n);
    for (auto &i: a) {
        cin >> i;
    }
    for (auto &i: b) {
        cin >> i;
    }
    vector<ll> p1, p2;
    for (int i = 0; i < n; i++) {
        p1.push_back(a[i]);
        p2.push_back(b[i]);
        cout << ans(p1, p2) << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
    cin >> q;
    while (q--) {
        solve();
    }
}
