#include <bits/stdc++.h>

std::vector<int64_t> solve(std::vector<int> a, std::vector<int> b) {
    assert(std::is_sorted(a.begin(), a.end()));
    assert(std::is_sorted(b.begin(), b.end()));
    int n = a.size();

    int64_t sum = 0;
    int64_t max_dlt = 0;
    std::vector<int64_t> ans(n);
    int max_cum = 0;
    for (int i = 0; i < n; i++) {
        sum += a[i] - b[i];

        if (i > 0 && a[i - 1] >= b[i]) {
            max_cum++;
        } else {
            max_cum = 0;
        }
        max_dlt = std::max<int64_t>(max_dlt, a[i] - b[i - max_cum]);
        ans[i] = sum - max_dlt;
    }
    return ans;
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> a(n), b(n);
    for (auto& ptr : std::array{&a, &b}) {
        for (auto& i : *ptr) {
            std::cin >> i;
        }
    }

    std::vector<int64_t> ans(n);
    if (std::is_sorted(a.begin(), a.end()) && std::is_sorted(b.begin(), b.end())) {
        ans = solve(a, b);
    } else {
        for (int i = 0; i < n; i++) {
            std::sort(a.begin(), a.begin() + i + 1);
            std::sort(b.begin(), b.begin() + i + 1);
            ans[i] = solve(std::vector<int>(a.begin(), a.begin() + i + 1), std::vector<int>(b.begin(), b.begin() + i + 1)).back();
        }
    }
    for (int i = 0; i < n; i++) {
        std::cout << ans[i] << " \n"[i == n - 1];
    }
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
