#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

const int INF = 1e9 + 5;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    vector<int> b(n);
    for (int &i : b) {
        cin >> i;
    }
    set<pair<int, int>> s;
    ll sum_a = 0, sum_b = 0;
    int mx_dist = 0;
    int mn_b = INF, mx_a = -INF;
    for (int i = 0; i < n; ++i) {
        sum_a += a[i];
        sum_b += b[i];
        mx_dist = max(mx_dist, a[i] - b[i]);
        s.insert({a[i], 1});
        s.insert({b[i], 0});
        {
            auto it = s.find({a[i], 1});
            auto it1 = it, it2 = it;
            it1++;
            if (it1 != s.end() && it1->second == 1) {
                mx_a = max(mx_a, it1->first);
            }
            it2--;
            if (it2->second == 1) {
                mx_a = max(mx_a, a[i]);
            }
        }
        {
            auto it = s.find({b[i], 0});
            auto it1 = it, it2 = it;
            it1++;
            if (it1->second == 0) {
                mn_b = min(mn_b, b[i]);
            }
            if (it != s.begin()) {
                it2--;
                if (it2->second == 0) {
                    mn_b = min(mn_b, it2->first);
                }
            }
        }
        mx_dist = max(mx_dist, mx_a - mn_b);
        cout << sum_a - sum_b - mx_dist << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}