#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define dbg(a) cout << #a << " = " << a << endl;
#define dbg1(a) cout << #a << " = "; for (auto i : a) cout << i << ' '; cout << endl;
#define dbg2(a) cout << #a << " = "; for (auto [x, y] : a) cout << "{ " << x << ' ' << y << "} "; cout << endl;

const int INF = 1e9 + 7;
const int mod = 1e9 + 7;


void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (auto &i : a) cin >> i;
    for (auto &i : b) cin >> i;

    vector<int> x, y;
    ll sm1 = 0, sm2 = 0;
    for (int i = 0; i < n; i++) {
        x.emplace_back(a[i]);
        y.emplace_back(b[i]);

        sm1 += a[i];
        sm2 += b[i];

        sort(all(x));
        sort(all(y));
        int last = 0;
        int mx_del = 0;

        for (int j = 0; j <= i; j++) {
            mx_del = max(mx_del, x[j] - y[last]);
            if (j != i && x[j] >= y[j + 1])
                continue;
            else
                last = j + 1;
        }

        cout << sm1 - sm2 - mx_del << ' ';
    }
    cout << '\n';
}

int main() {
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
