#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (auto& el : a)
        cin >> el;
    for (auto& el : b)
        cin >> el;
    bool inccond = 1;
    for (int i = 1; i < n; ++i)
        inccond &= ((a[i] >= a[i - 1]) && (b[i] >= b[i - 1]));
    if (inccond) {
        multiset<int> as, bs;
        int asum = 0, bsum = 0;
        int prevmaxdif = 0;
        int lastb = 0;
        for (int i = 0; i < n; ++i) {
            asum += a[i];
            bsum += b[i];
            as.insert(a[i]);
            bs.insert(b[i]);
            if (i == 0) {
                cout << "0 ";
                lastb = b[i];
                continue;
            }
            assert(as.size() >= 2);
            auto ptra = as.end();
            --ptra;
            --ptra;
            auto ptrb = bs.end();
            --ptrb;
            int best = asum - bsum;
            while (ptrb != bs.end()) {
                if (*ptra >= *ptrb) {
                    ptra++, ptrb++;
                    continue;
                }
                prevmaxdif = max(prevmaxdif, (*ptra - lastb));
                lastb = *ptrb;
                ptra++, ptrb++;
            }
            prevmaxdif = max(prevmaxdif, (*ptra - lastb));
            cout << best - prevmaxdif << ' ';
        }
        cout << '\n';
        return;
    }
    multiset<int> as, bs;
    int asum = 0, bsum = 0;
    int prevmaxdif = 0;
    for (int i = 0; i < n; ++i) {
        asum += a[i];
        bsum += b[i];
        as.insert(a[i]);
        bs.insert(b[i]);
        auto ptra = as.begin(), ptrb = bs.begin();
        ptrb++;
        int lastb = *bs.begin();
        int best = asum - bsum;
        int curmxdif = 0;
        while (ptrb != bs.end()) {
            if (*ptra >= *ptrb) {
                ptra++, ptrb++;
                continue;
            }
            curmxdif = max(curmxdif, (*ptra - lastb));
            lastb = *ptrb;
            ptra++, ptrb++;
        }
        curmxdif = max(curmxdif, (*ptra - lastb));
        assert(curmxdif >= prevmaxdif);
        prevmaxdif = curmxdif;
        cout << best - curmxdif << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc;
    cin >> tc;
    while (tc--)
        solve();
}