#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using lll = __int128;
using ld = long double;
using vp = vector<pi>;
using vpl = vector<pl>;

vl getPref(const vi &v) {
    int n = v.size();
    vl v2 = {0};
    v2.reserve(n+1);
    for (int i : v)
        v2.push_back(v2.back() + i);
    return v2;
}

void solve() {
    int n; cin >> n;
    vi ai(n), bi(n);
    for (auto &i : bi) cin >> i;
    for (auto &i : ai) cin >> i;
    vl as = getPref(ai), bs = getPref(bi);

    vi can(n);
    multiset<pi, greater<>> ms;
    for (int i = 0; i < n; i++) {
        ll bad = bs[i+1] - as[i+1];
        ms.emplace(bi[i], 1);
        ms.emplace(ai[i], -1);

        ll sum = 0, mx = 0;
        vl stack;
        for (auto[x, d] : ms) {
            if (d == 1)
                stack.push_back(x);
            else {
                ll diff = stack.back() - x;
                stack.pop_back();
                sum += diff;
                mx = max(mx, diff);
            }
        }
        cout << sum - mx << " ";
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
