#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using lll = __int128;
using ld = long double;
using vp = vector<pi>;
using vpl = vector<pl>;

bool solve2(int n, vi &ai, vi &bi) {
    for (int i = 0; i < n-1; i++) {
        if (bi[i] >= ai[i+1])
            return false;
    }
    ll sum = 0, mx = 0;
    for (int i = 0; i < n; i++) {
        ll delta = bi[i] - ai[i];
        sum += delta;
        mx = max(mx, delta);
        cout << sum - mx << " ";
    }
    cout << "\n";
    return true;
}

void solve() {
    int n; cin >> n;
    vi ai(n), bi(n);
    for (auto &i : bi) cin >> i;
    for (auto &i : ai) cin >> i;
    if (solve2(n, ai, bi)) return;

    vi can(n);
    multiset<pi, greater<>> ms;
    for (int i = 0; i < n; i++) {
        ms.emplace(bi[i], 1);
        ms.emplace(ai[i], -1);

        ll sum = 0, mx = 0;
        vl stack;
        for (auto[x, d] : ms) {
            if (d == 1)
                stack.push_back(x);
            else {
                ll diff = stack.back() - x;
                stack.pop_back();
                sum += diff;
                mx = max(mx, diff);
            }
        }
        cout << sum - mx << " ";
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
