// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long ll;
typedef long double ld;

const long long INF = 1e18;
const int inf = 2e9;
const int MOD = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), dif(n);
    for (int& e : a) cin >> e;
    for (int& e : b) cin >> e;
    multiset<int> s1, s2;
    for (int i = 0; i < n; ++i) {
        sort(a.begin(), a.begin() + i + 1);
        sort(b.begin(), b.begin() + i + 1);
        int suma = 0, sumb = 0;
        for (int j = 0; j <= i; ++j) {
            suma += a[j];
            sumb += b[j];
            if (j < i)
                dif[j + 1] = dif[j] + (a[j] < b[j + 1] ? 1 : 0);
        }
        int ans = suma - sumb;
        for (int j = 0; j <= i; ++j) {
            for (int k = 0; k <= i; ++k) {
                if (dif[j] - dif[k] == 0) {
                    ans = min(ans, suma - a[j] - sumb + b[k]);
                }
            }
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

signed main() {
#ifdef erytw
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
