#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <random>
#include <ctime>
#include <set>
#include <map>
#include <cassert>
using namespace std;

typedef long long ll;

void solve()
{
    int n; cin >> n;
    vector<ll> A(n, 0), B(n, 0), PA(n + 1, 0), PB(n + 1, 0);
    for (int i = 0; i < n; i++)
    {
        cin >> A[i];
        PA[i + 1] = PA[i] + A[i];
    }
    for (int i = 0; i < n; i++)
    {
       cin >> B[i];
       PB[i + 1] = PB[i] + B[i];
    }
    vector<ll> pref_A, pref_B;
    ll max_r = 0;
    if (n <= 3000)
    {
        for (int i = 0; i < n; i++)
        {
            ll res = PA[i + 1] - PB[i + 1];
            pref_A.insert(lower_bound(pref_A.begin(), pref_A.end(), A[i]), A[i]);
            pref_B.insert(lower_bound(pref_B.begin(), pref_B.end(), B[i]), B[i]);
            max_r = max(max_r, pref_A[i] - pref_B[i]);
            max_r = pref_A.back() - pref_B.back();
            ll cur = pref_A[i];
            for (int j = i - 1; j >= 0; j--)
            {
                if (pref_A[j] >= pref_B[j + 1])
                {
                    max_r = max(max_r, cur - pref_B[j]);
                }else{
                    cur = pref_A[j];
                    max_r = max(max_r, pref_A[j] - pref_B[j]);
                }
            }
            cout << res - max_r << ' ';
        }
        cout << '\n';
    }
    else
    {
        ll max_r = 0;
        for (int i = 0; i < n; i++)
        {
            ll res = PA[i + 1] - PB[i + 1];
            max_r = max(max_r, A[i] - B[i]);
            cout << res - max_r << ' ';
        }
        cout << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../../input.txt", "r", stdin);
    freopen("../../output.txt", "w", stdout);
#endif
    int t; cin >> t;
    while (t--)
        solve();
    return 0;
}