//
// Created by olymp on 3/9/24.
//
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using oset = tree<
        ll,
        null_type,
        less<>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

const ll inf = 1e18;

void add(vector<ll> &a, ll x) {
    a.insert(upper_bound(a.begin(), a.end(), x), x);
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> A(n), B(n);
    for (auto &i : A) cin >> i;
    for (auto &i : B) cin >> i;
    vector<ll> a, b;
    for (ll i = 0; i < n; i++) {
        add(a, A[i]);
        add(b, B[i]);
//        a[i] = A[i], b[i] = B[i];
//        sort(a.begin(), a.begin() + i + 1), sort(b.begin(), b.begin() + i + 1);
        ll ans = inf;
        for (ll j = 0; j <= i; j++) { // chto iz a ne berem
            int l = -1, r = i + 1;
            while (l + 1 < r) {
                int w = (l + r) / 2;
                bool ok = true;
                ll s1 = 0, s2 = 0;
                ll u1 = 0, u2 = 0;
                for (ll z = 0; z < i; z++) {
                    if (u1 == j)
                        u1++;
                    if (u2 == w)
                        u2++;
                    if (a[u1] < b[u2]) {
                        ok = false;
                        break;
                    }
                    s1 += a[u1++];
                    s2 += b[u2++];
                }
                if (ok) {
                    ans = min(ans, s1 - s2);
                    r = w;
                }
                else
                    l = w;
            }
        }
        cout << ans << " ";
    }
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr),
            cout.tie(nullptr);
    ll t;
    cin >> t;
    while (t--)
        solve();
}
