#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<long long> a(n);
        vector<int> good(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        vector<long long> b(n);
        for (int i = 0; i < n; ++i) {
            cin >> b[i];
            if (i > 0 && a[i - 1] >= b[i]) {
                good[i - 1] = 1;
            }
        }
        for (int j = 1; j < n; ++j) {
            good[j] += good[j - 1];
        }
        int l = 0;
        long long sum = a[0] - b[0];
        long long best = b[0] - a[0];
        cout << 0 << " ";
        for (int r = 1; r < n; ++r) {
            sum += a[r] - b[r];
            while (good[r - 1] - good[l - 1] != r - l) {
                l++;
            }
            best = min(best, b[l] - a[r]);
            cout << sum + best << " ";
        }
        cout << '\n';
    }
}