#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<long long> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        vector<long long> b(n);
        bool fine = true;
        for (int i = 0; i < n; ++i) {
            cin >> b[i];
            if (i > 0 && (b[i - 1] > b[i] || a[i - 1] > a[i])) {
                fine = false;
            }
        }
        if (fine) {
            vector<int> good(n);
            for (int i = 0; i < n; ++i) {
                if (i > 0 && a[i - 1] >= b[i]) {
                    good[i - 1] = 1;
                }
            }
            for (int j = 1; j < n; ++j) {
                good[j] += good[j - 1];
            }
            int l = 0;
            long long sum = a[0] - b[0];
            long long best = b[0] - a[0];
            cout << 0 << " ";
            for (int r = 1; r < n; ++r) {
                sum += a[r] - b[r];
                while (good[r - 1] - good[l - 1] != r - l) {
                    l++;
                }
                best = min(best, b[l] - a[r]);
                cout << sum + best << " ";
            }
            cout << '\n';
        } else {
            vector<long long> c(n);
            vector<long long> d(n);
            vector<int> e(n);
            multiset<long long> p;
            multiset<long long> q;
            long long sum = 0;
            for (int i = 0; i < n; ++i) {
                p.insert(a[i]);
                q.insert(b[i]);
                sum += a[i];
                sum -= b[i];
                int cur = 0;
                for (auto &j : p) {
                    c[cur] = j;
                    cur++;
                }
                cur = 0;
                for (auto &j : q) {
                    d[cur] = j;
                    cur++;
                }
                for (int j = 0; j < i + 1; ++j) {
                    e[j] = 0;
                }
                for (int j = 0; j < i + 1; ++j) {
                    if (j > 0 && c[j - 1] >= d[j]) {
                        e[j - 1] = 1;
                    }
                }
                for (int j = 1; j < i + 1; ++j) {
                    e[j] += e[j - 1];
                }
                long long best = d[0] - c[0];
                int l = 1;
                for (int r = 1; r < i + 1; ++r) {
                    while (e[r - 1] - e[l - 1] != r - l) {
                        l++;
                    }
                    if (e[r - 1] == r) {
                        best = min(best, d[0] - c[r]);
                    }
                    best = min(best, d[l] - c[r]);
                }
                cout << best + sum << " ";
            }
            cout << '\n';
        }
    }
}
