#include <ext/pb_ds/assoc_container.hpp>

#ifdef Local

#include "debug.h"

#else
#include <bits/stdc++.h>
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

template<class A, class B>
bool smin(A &x, B &&y) {
        if (x > y) {
                x = y;
                return true;
        }
        return false;
}

template<class A, class B>
bool smax(A &x, B &&y) {
        if (x < y) {
                x = y;
                return true;
        }
        return false;
}

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

template<typename type, typename comp=less<>>
using pbds = __gnu_pbds::tree<type, __gnu_pbds::null_type, comp, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve() {
        int n;
        cin >> n;
        if (n <= 3000) {
                vector<int> a(n), b(n);
                for (int &i: a)
                        cin >> i;
                for (int &i: b)
                        cin >> i;
                vector<int> ans(n, 1e18);
                vector<int> ca = {a[0]}, cb = {b[0]};
                ans[0] = 0;
                for (int i = 1, sa = a[0], sb = b[0]; i < n; ++i) {
                        ca.emplace_back(a[i]);
                        cb.emplace_back(b[i]);
                        sort(all(ca));
                        sort(all(cb));
                        sa += a[i], sb += b[i];
                        for (int p = 0; p <= i; ++p) {
                                int x = p;
                                while (x > 0) {
                                        if (ca[x - 1] < cb[x])
                                                break;
                                        --x;
                                }
                                smin(ans[i], sa - sb - ca[p] + cb[x]);
                        }

                }
                for (int &i: ans)
                        cout << i << ' ';
                cout << endl;
                return;
        }
        vector<int> a(n), b(n);
        for (int &i: a)
                cin >> i;
        for (int &i: b)
                cin >> i;
        vector<int> ans(n), dp(n + 1);
        dp[n] = n;
        for (int i = n - 1, sa = accumulate(all(a), 0ll), sb = accumulate(all(b), 0ll); i >= 0; --i) {
                dp[i] = min(i, dp[i + 1]);
                while (dp[i] > 0) {
                        if (a[dp[i] - 1] < b[dp[i]])
                                break;
                        --dp[i];
                }
        }
        debug(dp);
        ans[0] = 0;
        for (int i = 1, mx = a[0] - b[0], sa = a[0], sb = b[0]; i < n; ++i) {
                smax(mx, a[i] - b[dp[i]]);
                sa += a[i], sb += b[i];
                ans[i] = sa - sb - mx;
        }
        for (int &i: ans)
                cout << i << ' ';
        cout << endl;
}

signed main() {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);

        int _t = 1;
        cin >> _t;
        while (_t--)
                solve();

        return 0;
}
