#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;
using ll = long long;

const ll mod = 1e9 + 7;

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    vector<ll> b(n);
    bool f = 1;
    for (auto& x : a) {
        cin >> x;
    }
    for (auto& x : b) {
        cin >> x;
    }
    for (ll i = 0; i < n - 1; i++) {
        if (a[i] > a[i + 1] || b[i] > b[i + 1]) {
            f = 0;
        }
    }
    if (f) {
        ll cur = 0;
        ll p = 0;
        ll last = 0;
        for (ll i = 0; i < n; i++) {
            cur += a[i] - b[i];
            if (i) {
                if (a[i - 1] >= b[i]) {
                    p = max(p, a[i] - b[last]);
                }
                else {
                    last = i;
                }
                cout << cur - p << "\n";
            }
            else {
                cout << 0 << "\n";
            }
        }
        return;
    }
    multiset<ll> s1;
    multiset<ll> s2;
    ll cur = 0;
    for (ll i = 0; i < n; i++) {
        s1.insert(a[i]);
        s2.insert(b[i]);
        cur += a[i] - b[i];
        vector<ll> new1;
        vector<ll> new2;
        for (auto x : s1) new1.push_back(x);
        for (auto x : s2) new2.push_back(x);
        ll ans = cur;
        ll last = 0;
        for (ll j = 0; j <= i; j++) {
            ans = min(ans, cur - (new1[j] - new2[last]));
            if (j + 1 <= i) {
                if (new1[j] < new2[j + 1]) {
                    last = j + 1;
                }
            }
        }
        cout << ans << "\n";
    }
}

int main()
{
    ll t;
    cin >> t;
    for (ll i = 0; i < t; i++) {
        solve();
    }
}