#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3", "unroll-loops", "fast-math")
//#pragma GCC target("avx2")

#define int long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pb push_back
#define f first
#define s second

using namespace std;
using namespace __gnu_pbds;

using pii = pair <int, int>;
using oset = tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 2e5 + 1337;
const int INF = 1e16 + 1337;

void solve() {
    int n;
    cin >> n;
    int a[n];
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int b[n];
    for (int i = 0; i < n; i++)
        cin >> b[i];

    bool g4 = true;
    for (int i = 0; i < n - 1; i++)
        g4 &= (a[i] <= b[i + 1]);

    if (g4) {
        int mx = 0, sa = 0, sb = 0;
        for (int i = 0; i < n; i++) {
            sa += a[i], sb += b[i];
            mx = max(mx, a[i] - b[i]);
            cout << sa - sb - mx << " ";
        }
        cout << "\n";
        return;
    }

    if (n <= 3000) {
        int sa = 0, sb = 0;
        multiset <int> sta;
        for (int i = 0; i < n; i++) {
            sa += a[i], sb += b[i];
            sta.insert(a[i]);
            multiset <int> stb;
            for (int j = 0; j <= i; j++)
                stb.insert(b[j]);

            int und = 0;
            for (auto& x : sta) {
                auto it = stb.upper_bound(x);
                it--;
                int y = *it;
                stb.erase(it);
                und = max(und, x - y);
            }

            cout << sa - sb - und << " ";
        }
        cout << "\n";
        return;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
