#include <iostream>

#include <vector>
#include <set>
#include <map>

#include <algorithm>
#include <cmath>
#include <numeric>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

const ll MD = 1e9 + 7;
const ll INF = MD * MD;


void solve(vector<int>x, vector<int>t) {
    int xs = x.size();
    vector<int>u, d;

    ll sm = 0;
    for (int p = 0; p < xs; p++) {
        u.push_back(x[p]);
        d.push_back(t[p]);
        sort(all(u));
        sort(all(d));
        sm += x[p] - t[p];

        int l = 0;
        ll mxd = u[l] - d[l];
        for (int r = 0; r < p; r++) {
            if (u[r] < d[r + 1])
                l = r + 1;
            mxd = max((ll)u[r + 1] - d[l], mxd);
        }

        cout << sm - mxd << ' ';
    }
}

void solvep(vector<int>x, vector<int>t) {
    int xs = x.size();
    ll sm = x[0] - t[0];
    ll di = x[0] - t[0];
    ll mxd = di;
    cout << 0 << ' ';
    for (int r = 1; r < xs; r++) {
        if (t[r] > x[r - 1])
            di = x[r] - t[r];
        else
            di += x[r] - x[r - 1];
        mxd = max(mxd, di);
        sm += x[r] - t[r];
        cout << sm - mxd << ' ';
    }
}


int main() {
    int qs;
    cin >> qs;
    while (qs--) {
        int xs;
        cin >> xs;
        vector<int>x(xs);
        for (int &i : x)
            cin >> i;
        vector<int>t(xs);
        for (int &i : t)
            cin >> i;
        bool ff = 1, fs = 1;
        for (int i = 0; i + 1 < xs; i++) {
            ff &= x[i] < t[i + 1];
            fs &= x[i] <= x[i + 1];
            fs &= t[i] <= t[i + 1];
        }
        if (ff || fs)
            solvep(x, t);
        else
            solve(x, t);
        cout << '\n';
    }
}