#include <iostream>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2,tune=native")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/hash_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define ll long long
#define vi vector <int>
#define pii pair <int, int>
#define endl '\n'
#define pb push_back
#define ft first
#define sd second
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define RFOR(i, a, b) for (int i = a; i >= b; --i)
#define EACH(e, a) for (auto& e : a)
using pbds = tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>;
using gp_hash = gp_hash_table <int, int>;
mt19937 rng(time(0));
//#define int long long
///
constexpr int MAX = 2e5 + 7, INF = 1e9 + 7, MOD = 1e9 + 7, LG = 18, R = 1 << LG, B = 320;
constexpr ll INFLL = 1e18 + 7;

int n;
int a[MAX], b[MAX];

void solve_n2() {
    ll sum = 0;
    vi sa, sb;
    FOR(i, 0, n) {
        sa.insert(lower_bound(all(sa), a[i]), a[i]);
        sb.insert(lower_bound(all(sb), b[i]), b[i]);
        sum += a[i] - b[i];
        int cntb = 0, pos = -1, mx = 0;
        FOR(j, 0, i + 1) {
            mx = max(mx, sa[j] - sb[j]);
            while (cntb < i + 1 && sb[cntb] <= sa[j]) ++cntb;
            if (j + 1 < cntb) {
                if (!~pos) pos = j;
            }
            else {
                if (~pos) mx = max(mx, sa[j] - sb[pos]);
                pos = -1;
            }
        }
        cout << sum - mx << ' ';
    }
    cout << endl;
}

void solve_mono() {
    ll sum = 0;
    int mx = 0;
    set <pii> segs;
    multiset <int> ws;
    vi sa;
    FOR(i, 0, n) {
        sum += a[i] - b[i], mx = max(mx, a[i] - b[i]);
        sa.pb(a[i]);
        int p = lower_bound(all(sa), b[i]) - sa.begin();
        if (p < i) {
            // add seg [p; i)
            auto it = segs.lower_bound({p, 0});
            while (it != segs.end()) {
                ws.erase(ws.find(a[it->sd] - b[it->ft]));
                it = segs.erase(it);
            }
            if (!segs.empty() && prev(segs.end())->sd == p) {
                p = prev(segs.end())->ft;
                ws.erase(ws.find(a[prev(segs.end())->sd] - b[prev(segs.end())->ft]));
                segs.erase(prev(segs.end()));
            }
            ws.insert(a[i] - b[p]);
            segs.insert({p, i});
        }
        cout << sum - max(mx, (ws.empty() ? 0 : *prev(ws.end()))) << ' ';
    }
    cout << endl;
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int tc = 1; cin >> tc;
    while (tc--) {
        cin >> n;
        FOR(i, 0, n) cin >> a[i];
        FOR(i, 0, n) cin >> b[i];
        bool f = 1;
        FOR(i, 1, n) f &= (a[i] >= a[i - 1]) & (b[i] >= b[i - 1]);
        if (!f) solve_n2();
        else solve_mono();
    }
}
