//#pragma GCC optimize("O3", "unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define eb emplace_back
#define F first
#define S second
#define vec vector
#define all(x) (x).begin(), (x).end()

//#pragma GCC target("avx2")

using vi = vector<int>;
using str = string;
using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template<typename A>
void print(A &a, str sep=" "){
    for(auto &i: a)cout << i << sep;
    cout << "\n";
}
template<typename A>
void read(A &a){
    for(auto &i: a)cin >> i;
}

multiset<int> dif;
multiset<pii> ca, cb;
vi cpa, cpb;

void solve(){
    int n; cin >> n;
    vi a(n); read(a);
    vi b(n); read(b);
    cpa = cpb = vi(n, -1);
    vi cnt(n, 0);
    if(n > 1)cnt[0] = a[0] >= b[1];
    for(int i = 1; i < n - 1; ++i){
        if(a[i] >= b[i + 1])
            cnt[i] = cnt[i - 1] + 1;
        else cnt[i] = 0;
    }
    int cd = 0;
    int best = a[0] - b[0];
    for(int i = 0; i < n; ++i){
        cd += a[i] - b[i];
        best = max(best, a[i] - b[i]);
        if(i != 0)
            best = max(best, a[i] - b[i - cnt[i - 1]]);
        cout << cd - best << " ";
    }
    cout << "\n";
}


signed main() {
#ifdef LOCAL
    freopen("inp", "r", stdin);
#else
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#endif

    //clock_t start = clock();
    int TT = 1;
    cin >> TT;
    while(TT--){
        solve();
    }
//    clock_t end = clock();
//    cout.precision(16);
//    cout << fixed;
//    cout << (ld)(end - start) / CLOCKS_PER_SEC << "\n";
    return 0;
}
