//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

//#define int long long
using ll = long long;
using ld = long double;
const ll INF = 2e9, MOD = 1e9 + 7, N = 200 + 5, K = 500 + 5;
mt19937 rnd(24246);
vector<int> a, b;

int check(int l1, int r1, int l2, int r2) {
    int res = 0;
    for (int i = 0; i < r1 - l1 + 1; i++) {
        if (a[l1 + i] < b[l2 + i]) return INF;
        res += a[l1 + i] - b[l2 + i];
    }
    return res;
}


void solve() {
    int n;
    cin >> n;
    a.assign(n, 0);
    b.assign(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    multiset<int> m, mm;
    for (int i = 0; i < n; i++) {
        m.insert(b[i]);
        mm.insert(a[i]);
        sort(a.begin(), a.begin() + i + 1);
        sort(b.begin(), b.begin() + i + 1);

        multiset<int> m1 = m, m2 = m;
        multiset<int> m3 = mm, m4 = mm;
        int ans1 = 0, ans2 = 0;
        int ans3 = 0, ans4 = 0;
        bool f1 = 1, f2 = 1;
        bool f3 = 1, f4 = 1;
        for (int j = 0; j < i; j++) {
            auto it = m1.upper_bound(a[j]);
            if (it == m1.begin()) {
                f1 = 0;
            } else {
                it--;
                ans1 += a[j] - *it;
                m1.erase(it);
            }
            auto it2 = m3.lower_bound(b[j]);
            if (it2 == m3.end()) {
                f3 = 0;
            } else {
                ans3 += *it2 - b[j];
                m3.erase(it2);
            }
        }
        for (int j = 1; j <= i; j++) {
            auto it = m2.upper_bound(a[j]);
            if (it == m2.begin()) {
                if (f2)
                    f2 = 0;
                else
                    f4 = 0;
            } else {
                it--;
                ans2 += a[j] - *it;
                m2.erase(it);
            }
            auto it2 = m4.lower_bound(b[j]);
            if (it2 == m4.end()) {
                f4 = 0;
            } else {
                ans4 += *it2 - b[j];
                m4.erase(it2);
            }
        }
        int ans = INF;
        if (f1)
            ans = min(ans, ans1);
        if (f2)
            ans = min(ans, ans2);
        if (f3)
            ans = min(ans, ans3);
        if (f4)
            ans = min(ans, ans4);
        cout << ans << " ";
    }
    cout << endl;

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
