#include <bits/stdc++.h>

#define int long long
using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    vector<int> a1, b1;
    for (int i = 0; i < n; ++i) {
        a1.push_back(a[i]);
        b1.push_back(b[i]);
        std::sort(a1.begin(), a1.end());
        std::sort(b1.begin(), b1.end());
        multiset<int> a2, b2;
        for (int j = 0; j <= i; ++j) {
            a2.insert(a[j]);
            b2.insert(b[j]);
        }
        vector<int> pref(i + 2, 0), suf(i + 2, 0);
        for (int j = 1; j < i + 2; ++j) {
            pref[j] = pref[j - 1] + a1[j - 1] - b1[j - 1];
        }
        int ans = pref[i];
        for (int j = i; j >= 0; --j) {
            suf[j] = suf[j + 1] + *a2.lower_bound(b1[j]) - b1[j];
            a2.erase(a2.lower_bound(b1[j]));
            auto z = a2.begin();
            int sum = 0;
            for (int k = 0; k < j - 1; ++k) {
                sum += *z - b1[k];
                z++;
            }
            ans = min(ans, sum + suf[j]);
        }
        cout << ans << " ";
    }
    cout << "\n";
}

signed main() {
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}