#include <bits/stdc++.h>
using namespace std;

void create(vector<int>& tree, int n) {
    int x(1);
    while (x < n) {
        x *= 2;
    }
    tree.assign(2 * x, 0);
}

void add(vector<int>& tree, int k) {
    while (k > 0) {
        tree[k]++;
        k /= 2;
    }
}

int get(vector<int>& tree, int x, int l, int r, int lq, int rq) {
    if ((l >= rq) || (r <= lq)) {
        return 0;
    }
    if ((l >= lq) && (r <= rq)) {
        return tree[x];
    }
    int m((l + r) / 2);
    return get(tree, 2 * x, l, m, lq, rq) + get(tree, 2 * x + 1, m, r, lq, rq);
}

void f() {
    int n, q;
    cin >> n;
    vector<long long> a{}, b{}, S{0}, m{0};
    for (int i = 0; i < n; i++) {
        cin >> q;
        a.push_back(q);
    }
    for (int i = 0; i < n; i++) {
        cin >> q;
        b.push_back(q);
        S.push_back(S.back() + a[i] - b[i]);
        m.push_back(max(m.back(), a[i] - b[i]));
    }
    for (int i = 0; i < n; i++) {
        cout << S[i + 1] - m[i + 1] << " ";
    }
    cout << endl;
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        f();
    }
}
