/* koshka >.< */

#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

using Int = long long;
using Int128 = __int128;

inline istream &operator>>(istream &in, Int128 &num) {
    Int t;
    in >> t;
    num = t;
    return in;
}

inline ostream &operator<<(ostream &out, const Int128 num) {
    out << num;
    return out;
}

template<typename T1, typename T2>
inline istream &operator>>(istream &in, pair<T1, T2> &p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T1, typename T2>
inline ostream &operator<<(ostream &out, const pair<T1, T2> &p) {
    out << p.first << ' ' << p.second;
    return out;
}

template<typename T>
inline istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &el : arr) {
        in >> el;
    }
    return in;
}

template<typename T>
inline ostream &operator<<(ostream &out, const vector<T> &arr) {
    for (auto el : arr) {
        out << el << ' ';
    }
    return out;
}

int main() {
    ios::sync_with_stdio(false), cin.tie(0);
    cout.setf(ios::fixed), cout.precision(20);
#define int Int
    int tc;
    cin >> tc;
    for (int ti = 0; ti < tc; ++ti) {
        int n;
        cin >> n;
        vector<int> a(n), b(n);
        cin >> a >> b;
        multiset<int> sta, stb;
        for (int i = 0; i < n; ++i) {
            sta.insert(a[i]), stb.insert(b[i]);
            if (i == 0) {
                cout << 0 << ' ';
                continue;
            }
            vector<int> va, vb;
            for (auto el : sta) {
                va.push_back(el);
            }
            for (auto el : stb) {
                vb.push_back(el);
            }
            int total = 2e9;
            for (int i1 = 0; i1 <= i; ++i1) {
                for (int j1 = 0; j1 <= i; ++j1) {
                    int cur = 0;
                    int p1 = 0, p2 = 0;
                    while (p1 <= i && p2 <= i) {
                        if (i1 == p1) {
                            ++p1;
                            continue;
                        }
                        if (j1 == p2) {
                            ++p2;
                            continue;
                        }
                        if (va[p1] < vb[p2]) {
                            goto nxt;
                        }
                        cur += va[p1] - vb[p2];
                        ++p1, ++p2;
                    }
                    total = min(total, cur);
nxt:;
                }
            }
            cout << total << ' ';
        }
        cout << '\n';
    }
    return 0;
}

