#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#pragma pack(push, 1)

#define int long long

using namespace std;
//using namespace __gnu_pbds;

//using ordered_multiset = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;
using lll = __int128;
using lld = __float128;

mt19937_64 gen(time(nullptr));

const int MAX_N = 4e5;

multiset<int> tree[4 * MAX_N];

void insert(int v, int tl, int tr, int pos, int val) {
    tree[v].insert(val);
    if (tl + 1 == tr) {
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos < tm) {
        insert(2 * v + 1, tl, tm, pos, val);
    } else {
        insert(2 * v + 2, tm, tr, pos, val);
    }
}

int get_min(int v, int tl, int tr, int l, int r) {
    if (l >= tr || r <= tl) {
        return 1e9 + 1;
    }
    if (l <= tl && r >= tr) {
        if (!tree[v].empty()) {
            return *tree[v].begin();
        }
        return 1e9 + 1;
    }
    int tm = (tl + tr) / 2;
    return min(get_min(2 * v + 1, tl, tm, l, r), get_min(2 * v + 2, tm, tr, l, r));
}

signed main() {
#ifdef LOCAL
    freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, i, sum = 0, ma = 0, m, mi;
        cin >> n;
        vector<int> a(n), b(n), ys(2 * n);
        unordered_map<int, int> to_ind;
        for (i = 0; i < n; i++) {
            cin >> a[i];
            ys[i] = a[i];
        }
        for (i = 0; i < n; i++) {
            cin >> b[i];
            ys[i + n] = b[i];
        }
        sort(ys.begin(), ys.end());
        for (i = 0; i < 2 * n; i++) {
            if (!to_ind.count(ys[i])) {
                to_ind[ys[i]] = to_ind.size();
            }
        }
        m = to_ind.size();
        for (i = 0; i < n; i++) {
            sum += a[i] - b[i];
            insert(0, 0, m, to_ind[a[i]], b[i]);
            mi = get_min(0, 0, m, to_ind[b[i]], m);
            ma = max(ma, a[i] - mi);
            cout << sum - ma << ' ';
        }
        cout << '\n';
        for (i = 0; i < 4 * n; i++) {
            tree[i].clear();
        }
    }
}