//#pragma GCC optimize("03")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> b[i];
    }
    i64 sa = 0, sb = 0;
    int min = 2e9;
    for (int p = 0; p < n; p++) {
        sa += a[p];
        sb += b[p];
        min = std::min(min, b[p] - a[p]);
        i64 res = sa - sb - min;
        std::cout << res << " \n"[p == n - 1];
    }
}

signed main() {
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);

    short t = 1;
    std::cin >> t;

    while (t--) {
        solve();
    }
}