#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
using namespace std;



#define int long long

const int inf = 1e15 + 1, N = 3e5;




struct node{
    int f, s, sum;
};

vector<int>t(N * 4, 0), t2(N * 4, inf);

void upd(int v, int tl, int tr, int pos, int x){
    if(tl == tr){
        t[v] = x;
        return;
    }
    int tm = (tl + tr) / 2;
    if(pos > tm) upd(2 * v + 2, tm + 1, tr, pos, x);
    else upd(2 * v + 1, tl, tm, pos, x);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);

}

void upd2(int v, int tl, int tr, int pos, int x){
    if(tl == tr){
        t2[v] = x;
        return;
    }
    int tm = (tl + tr) / 2;
    if(pos > tm) upd2(2 * v + 2, tm + 1, tr, pos, x);
    else upd2(2 * v + 1, tl, tm, pos, x);
    t2[v] = min(t2[2 * v + 1], t2[2 * v + 2]);
}

int get(int v, int tl, int tr, int l, int r){
    if(l <= tl && tr <= r) return t[v];
    if(l > tr || r < tl) return 0;
    int tm = (tl + tr) / 2;
    return max(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm + 1, tr, l, r));
}

int get2(int v, int tl, int tr, int l, int r){
    if(l <= tl && tr <= r) return t2[v];
    if(l > tr || r < tl) return inf;
    int tm = (tl + tr) / 2;
    return min(get2(2 * v + 1, tl, tm, l, r), get2(2 * v + 2, tm + 1, tr, l, r));
}

void solve(){
    int n;
    cin >> n;
    vector<int>a(n), b(n);
    set<int>h;
    for(int i = 0; i < n; ++i){
        cin >> a[i];
        h.insert(a[i]);
    }
    for(int i = 0; i < n; ++i){
        cin >> b[i];
        h.insert(b[i]);
    }
    map<int,int>help, obr;
    int rr = 1;
    for(auto &i : h){
        help[i] = rr;
        obr[rr] = i;
        ++rr;
    }


    int sum = 0, sum2 = 0;
    int diff = 0;
    int now = -1;
    for(int i = 0; i < n; ++i){
        now = max(now, a[i]);
        sum += a[i], sum2 += b[i];
        diff = max(diff, a[i] - b[i]);
        upd(0, 0, rr + 1, help[b[i]], a[i]);

        int mx = get(0, 0, rr + 1, 0,help[a[i]]);
        int mn = get2(0, 0, rr + 1, help[b[i]], rr);
        upd2(0, 0, rr + 1, help[a[i]], b[i]);
        diff = max(diff, mx - b[i]);
        diff = max(diff, now - mn);

        cout << sum - sum2 - diff << ' ';

    }

    cout << '\n';
    for(int i = 0; i < (rr + 1) * 4; ++i) t[i] = 0, t2[i] = inf;


}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while(tt--){
        solve();
    }
}
