#include <bits/stdc++.h>

using namespace std;

int solve(int a[], int b[], int n) {
    vector<pair<int, bool>> t;
    for (int i = 0; i < n; i++) t.push_back({a[i], 1});
    for (int i = 0; i < n; i++) t.push_back({b[i], 0});
    sort(t.begin(), t.end());
    
    int res = 0;
    stack<int> st;
    for (auto [x, type] : t) {
        if (!type) 
            st.push(x);
        else {
            assert (!st.empty());
            res = max(res, x - st.top());
            st.pop();
        }
    }
    return res;
}

void test_case() {
    int n;
    cin >> n;
    int a[n], b[n];
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];

    long long sum = 0;
    for (int i = 0; i < n; i++) {
        sum += a[i] - b[i];
        cout << sum - solve(a, b, i + 1) << ' ';
    }
}
//  3
//  4
//  2 4 5 12
//  1 3 4 10
//  4
//  3 5 8 20
//  1 2 6 7
//  4
//  4 4 4 4
//  1 2 3 4
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        test_case();
        cout << '\n';
    }   
}