#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx,avx2")

#include <bits/stdc++.h>
using namespace std;

#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    vector<int> ast, bst;
    for (int i = 0; i < n; i++) {
        ast.insert(lower_bound(ast.begin(), ast.end(), a[i]), a[i]);
        bst.insert(lower_bound(bst.begin(), bst.end(), b[i]), b[i]);
        vector<int> pref(i+3);
        for (int j = 0; j <= i; j++) {
            pref[j] = ast[j] - bst[j];
            if (j) pref[j] += pref[j-1];
        }

        vector<int> sufs(i+3);

        for (int j = i-1; j >= 0; j--) {
            if (ast[j] < bst[j+1] || sufs[j+1] == -1)
                sufs[j] = -1;
            else {
                sufs[j] = sufs[j+1] + ast[j] - bst[j+1];
            }
        }

        vector<int> suf(i+3);
        
        for (int j = i; j >= 0; j--) {
            suf[j] = suf[j+1] + ast[j] - bst[j];
        }

        vector<int> prefs(i+3);
        for (int j = 0; j < i; j++) {
            if (ast[j] < bst[j+1] || prefs[j-1] == -1) 
                prefs[j] = -1;
            else {
                prefs[j] = ast[j] - bst[j+1];
                if (j) prefs[j] += prefs[j-1];
            }
        }

        int ans = 1e18;
        if (sufs[0] != -1) ans = min(ans, sufs[0]);
        ans = min(ans, suf[1]);
        for (int j = 0; j < i; j++) {
            ans = min(ans, pref[j] + suf[j+2]);
            if (sufs[j+1] != -1) ans = min(ans, pref[j] + sufs[j+1]);
            if (prefs[j] != -1) ans = min(ans, prefs[j] + suf[j+2]);
        }

        cout << ans << ' ';
    }
}

signed main() {
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) solve(), cout << '\n';
}