// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx,avx2")

#include <bits/stdc++.h>
using namespace std;

#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    if (n > 3000) {
        int totdif = 0;
        int maxdif = 0;
        for (int i = 0; i < n; i++) {
            totdif += a[i] - b[i];
            maxdif = max(maxdif, a[i] - b[i]);
            cout << totdif - maxdif << ' ';
        }
        return;
    }

    vector<int> ast, bst;
    for (int i = 0; i < n; i++) {
        ast.push_back(a[i]);
        bst.push_back(b[i]);
        sort(ast.begin(), ast.end());
        sort(bst.begin(), bst.end());
        vector<int> pref(i+3);
        for (int j = 0; j <= i; j++) {
            pref[j] = ast[j] - bst[j];
            if (j) pref[j] += pref[j-1];
        }

        vector<int> suf(i+3);
        
        for (int j = i; j >= 0; j--) {
            suf[j] = suf[j+1] + ast[j] - bst[j];
        }

        vector<int> prefs(i+3);
        for (int j = 0; j < i; j++) {
            if (ast[j] < bst[j+1])
                prefs[j] = -1;
            else {
                prefs[j] = ast[j] - bst[j+1];
                if (j && prefs[j-1] != -1) prefs[j] += prefs[j-1];
                else if (j) prefs[j] += pref[j-1];
            }
        }

        int ans = 1e18;
        ans = min(ans, suf[1]);
        for (int j = 0; j < i; j++) {
            ans = min(ans, pref[j] + suf[j+2]);
            if (prefs[j] != -1) ans = min(ans, prefs[j] + suf[j+2]);
        }

        cout << ans << ' ';
    }
}

signed main() {
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--) solve(), cout << '\n';
}