//#pragma GCC optimize("03")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("no-online")
//#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <random>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>

using namespace std;

#define int long long
// #define double long double

using pii = pair<int, int>;
using ll = long long;
using pll = pair<ll, ll>;
using ld = long double;

ll inf = 1e18;

vector<int> split(vector<int> &v, int l, int r) {
    vector<int> res;
    for (int i = l; i < r; i++) {
        res.push_back(v[i]);
    }
    return res;
}

void solve() {
    int n; cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n; i++) {
        auto va = split(a, 0, i + 1);
        auto vb = split(b, 0, i + 1);
        int sz = i + 1;
        int res = inf;
        for (int j = 0; j < sz; j++) {
            for (int k = 0; k < sz; k++) {
                auto ca = va;
                swap(ca[j], ca.back());
                ca.pop_back();
                auto cb = vb;
                swap(cb[k], cb.back());
                cb.pop_back();
                int temp = 0;
                for (int x = 0; x < sz - 1; x++) {
                    temp += abs(ca[x] - cb[x]);
                }
                res = min(res, temp);
            }
        }
        cout << res << " ";
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
