#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
#define FOR(a, b, c) for (int a = (b); a < (c); ++a)
#pragma GCC target("avx2")
using namespace std;
using ar = array<int, 2>;
using ar3 = array<int, 3>;

const int N = 2e5 + 50;
const long long INF = 1e9 + 50;
int a[N], b[N], n;

unordered_map<int, array<int, 3>> S;

ar3 merge(ar3 A, ar3 B, int m1, int m2) {
	ar3 X = {max({A[0], B[0], A[2] + B[1]}), m1 == A[1] ? A[1] + B[1] : A[1], m2 == B[2] ? B[2] + A[2] : B[2]};
	return X;
}

void add(int v, int l, int r, int L, int R) {
	if (R <= l || r <= L) return;
	if (L <= l && r <= R) {
		S[v] = {r - l, r - l, r - l};
		return;
	}
	if (S.count(v) && (r - l) == S[v][0]) return;
	int m = l + r >> 1;
	add(v << 1, l, m, L, R);
	add(v << 1 | 1, m, r, L, R);
	S[v] = merge(S[v << 1], S[v << 1 | 1], m - l, r - m);
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);

	int tc;
	cin >> tc;
	while (tc--) {
		S.clear();

		cin >> n;
		FOR(i, 0, n) 
			cin >> a[i];
		FOR(i, 0, n)
			cin >> b[i];
		int ans = 0;
		FOR(i, 0, n) {
			//cout << "QUERY AT " << b[i] << ' ' << a[i] << endl;
			ans += a[i] - b[i];
			if (a[i] != b[i]) add(1, 0, INF, b[i], a[i]);
			cout << ans - S[1][0] << ' ';
			//cout << S[1][0] << endl;
		}
		cout << endl;
	}

	return 0;
}
