#include<iostream>
#include <random>
#include<vector>
#include<set>
#include<map>
#include<cassert>
#include<unordered_map>
#include<algorithm>
#include<iomanip>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define girlfriend friend

template<typename T>
bool assign_min(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream& out, std::pair<T, F> a) {
    return out << a.first << " " << a.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, b1 = 31, b2 = 29, MAXN = 1e5;
const long double eps = 1e-9;

struct Vector {
    int x, y;

    Vector() = default;

    Vector(int a, int b) : x(a), y(b) {}

    Vector(Vector a, Vector b) : x(b.x - a.x), y(b.y - a.y) {}

    girlfriend int operator*(Vector a, Vector b) {
        return a.x * b.x + a.y * b.y;
    }

    girlfriend int operator%(Vector a, Vector b) {
        return a.x * b.y - a.y * b.x;
    }

    girlfriend istream& operator>>(istream& in, Vector& a) {
        return in >> a.x >> a.y;
    }

    girlfriend ostream& operator<<(ostream& out, Vector a) {
        return out << a.x << " " << a.y;
    }

    girlfriend bool operator<(Vector &a, Vector &b) {
        return a.x < b.x;
    }
};

void solve1() {
    int n; cin >> n;
    vector<Vector> a(n); input(a);
    bool fl = true;
    for (int i = 0; i<n-1; ++i) {
        if (a[i+1].x < a[i].x || a[i+1].y < a[i].y) fl = false;
    }
    if (n <= 10) {
        vector<int> cur(n), res;
        int mx = -1;
        for (int i = 0; i<n; ++i) cur[i] = i; // gde blyat lezhit iota???
        do {
            int cnt = 0;
            for (int i = 1; i<n-1; ++i) {
                Vector b(a[cur[i]], a[cur[i-1]]), c(a[cur[i]], a[cur[i+1]]);
                cnt += b*c > 0;
            }
            if (assign_max(mx, cnt)) res = cur;
        } while (next_permutation(all(cur)));
        for (int i = 0; i<n; ++i) cout << res[i]+1 << " ";
        cout << '\n';
    } else if (fl) {
        for (int i = 0; i<n; ++i) {
            if (i&1) cout << (i/2)+1 << " ";
            else cout << n-i/2 << " ";
        }
        cout << '\n';
    } else {
        int mx = -1;
        vector<int> res;
        for (int it = 0; it <= 100000; ++it) {
            vector<int> ind(n);
            for (int i = 0; i<n; ++i) ind[i] = i;
            shuffle(all(ind), std::mt19937(std::random_device()()));
            int cnt = 0;
            for (int i = 1; i<n-1; ++i) {
                Vector b(a[ind[i]], a[ind[i-1]]), c(a[ind[i]], a[ind[i+1]]);
                cnt += b*c > 0;
            }
            if (assign_max(mx, cnt)) res = ind;
        }
        for (int i = 0; i<n; ++i) cout << res[i]+1 << " ";
        cout << '\n';
    }
}

void solve3() {
    int n; cin >> n;
    vector<Vector> a(n); input(a);
    sort(all(a));
    int c; cin >> c;
    int q; cin >> q;
    for (int j = 0; j<q; ++j) {
        int k; cin >> k;
        int cnt = k+1;
        vector<int> usd(n+2);
        usd[0] = usd[n+1] = 1;
        int lst = 0;
        for (int i = 0; i<n && cnt; ++i) {
            cnt--;
            if (i&1) {
                lst = (i/2)+1;
                usd[lst] = 1;
                cout << lst << " ";
            } else {
                lst = n-i/2;
                usd[lst] = 1;
                cout << lst << " ";
            }
        }
        if (!(k&1)) {
            for (int i = lst-1; usd[i] == 0; --i) {
                cout << i << " ";
            }
        } else {
            for (int i = lst+1; usd[i] == 0; ++i) {
                cout << i << " ";
            }
        }
        cout << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int task, group; cin >> task >> group;
    if (task == 1) solve1();
    else if (task == 3) solve3();
    return 0;
}

//fft