#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct Vect {
    ll x, y;

    Vect() = default;

    Vect(ll x, ll y) : x(x), y(y) {}

    Vect(Vect a, Vect b) : x(b.x - a.x), y(b.y - a.y) {}

    ll len2() {
        return x * x + y * y;
    }
};

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll task, group;
    cin >> task >> group;
    ll n;
    cin >> n;

    if (task == 1) {
        vector<pair<Vect, ll>> a(n);
        for (ll i = 0; i < n; ++i) {
            cin >> a[i].first.x >> a[i].first.y;
            a[i].second = i;
        }
        Vect cur = a.back().first;
        a.pop_back();
        cout << n << " ";
        while (!a.empty()) {
            for (ll i = 0; i < a.size(); ++i) {
                if (Vect(cur, a[i].first).len2() > Vect(cur, a.back().first).len2()) {
                    swap(a[i], a.back());
                }
            }
            cout << a.back().second + 1 << " ";
            cur = a.back().first;
            a.pop_back();
        }
        cout << endl;
        return 0;
    }
    ll c;
    cin >> c;
    if (task == 2) {
        vector<pair<Vect, ll>> a(n);
        for (ll i = 0; i < n; ++i) {
            cin >> a[i].first.x >> a[i].first.y;
            a[i].second = i;
        }
        Vect cur = a.back().first;
        a.pop_back();
        cout << n << " ";
        while (!a.empty()) {
            for (ll i = 0; i < a.size(); ++i) {
                if (Vect(cur, a[i].first).len2() < Vect(cur, a.back().first).len2()) {
                    swap(a[i], a.back());
                }
            }
            cout << a.back().second + 1 << " ";
            cur = a.back().first;
            a.pop_back();
        }
        cout << endl;
        return 0;
    }
    if (task == 3) {
        deque<pair<Vect, ll>> A(n);
        for (ll i = 0; i < n; ++i) {
            cin >> A[i].first.x >> A[i].first.y;
            A[i].second = i;
        }

        ll q;
        cin >> q;

        while (q--) {
            auto a = A;
            ll x;
            cin >> x;
            Vect cur = a.back().first;
            a.pop_back();
            cout << n << " ";
            while (a.size() > x) {
                cout << a.back().second + 1 << " ";
                cur = a.back().first;
                a.pop_back();
            }
            while (a.size() > 1) {
                cout << a[0].second + 1 << " ";
                a.pop_front();
                cout << a.back().second + 1 << " ";
                a.pop_back();
            }
            if (!a.empty()) cout << a.back().second + 1 << " ";
            a.pop_back();
            cout << endl;
        }
        return 0;
    }

    return 0;
}
