#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ordered_set = tree<ll, less<>, null_type, tree_tag, tree_order_statistics_node_update>;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    // cin >> t;
    while (t--)
        solve();
}

void solve() {
    int task, g, n;
    cin >> task >> g >> n;
    vector<pair<int, int>> v(n);
    for (auto &[x, y]: v)
        cin >> x >> y;
    if (n > 10) {
        sort(all(v));
        for (int i = 1; i <= n - i + 1; i++) {
            cout << i << ' ';
            if (n - i + 1 != i)
                cout << n - i + 1 << ' ';
        }
        return;
    }
    vector<int> ndx(n);
    for (int i = 0; i < n; i++)
        ndx[i] = i;
    vector<int> mx(n);
    int ans = 0;
    while (1) {
        int cnt = 0;
        for (int i = 1; i < n - 1; i++) {
            auto [x, y] = v[ndx[i]];
            auto [x1, y1] = v[ndx[i - 1]];
            auto [x2, y2] = v[ndx[i + 1]];

            ll l1 = (x - x1) * (x - x1) + (y - y1) * (y - y1);
            ll l2 = (x - x2) * (x - x2) + (y - y2) * (y - y2);
            ll l3 = (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
            if (l1 + l2 >= l3)
                cnt++;
        }
        if (ans < cnt) {
            ans = cnt;
            mx = ndx;
        }
        if (!next_permutation(all(ndx)))
            break;
    }
    for (int i:mx)
        cout << i + 1 << '\n';
}