#include<bits/stdc++.h>
#define TIME 1.0*clock()/CLOCKS_PER_SEC
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define F first
#define S second
#define pb push_back

typedef long long ll;
using namespace std;
const int N = 80100;

struct pt{
    ll x,y;
} a[N];

ll dst(pt a, pt b){
    return (a.y-b.y)*(a.y-b.y)+(a.x-b.x)*(a.x-b.x);
}
ll x[N],y[N];

bool ok(pt a, pt b, pt c)
{
    ll d1=dst(a,b);
    ll d2=dst(b,c);
    ll d3=dst(a,c);

    return (d1+d2>d3);
}

int get(vector< int > p)
{
    int ans=0;
    for(int i=0;i<p.size()-2;++i)
        ans+=ok(a[p[i]],a[p[i+1]],a[p[i+2]]);
    return ans;
}
mt19937 gen(time(0));


void solve2(int n)
{
    int l=1,r=n;
    for(int i=0;i<n;++i)
        if(i & 1)cout<<r--<<' ';
        else cout<<l++<<' ';
    return ;
}
void solve1()
{
    int n;
    cin>>n;

    for(int i=0;i<n;++i)
        cin>>a[i].x>>a[i].y;

    bool f=1;
    for(int i=1;i<n;++i)
        if(a[i].x<=a[i-1].x || a[i].y<=a[i-1].y)f=0;

    if(f)
    {
        solve2(n);
        return;
    }

    vector< int > p(n);
    iota(p.begin(),p.end(),0);
    shuffle(p.begin(),p.end(),gen);
    vector< int > ans=p;
    int mx=0;
    do{
        int kol=get(p);
        if(kol>mx)
        {
            mx=kol;
            ans=p;
        }
    }
    while(next_permutation(p.begin(),p.end()) && TIME<1.95);

    for(auto to : ans)
        cout<<to+1<<' ';
    return ;
}

bool used[N];
void solve3()
{
    int n;
    cin>>n;

    for(int i=0;i<n;++i)
        cin>>a[i].x>>a[i].y;

    vector< int > ans={0,1};
    used[0]=0; used[1]=1;
    for(int i=1;i<n;++i)
    {
        bool f=0;
        for(int j=0;j<n;++j)
            if(!used[j] && !ok(a[ans[i-2]],a[ans[i-1]],a[j])){
                ans.pb(j);
                f=1;
                break;
            }
        if(!f)
        {
            for(int j=0;j<n;++j)
                if(!used[j]){
                    ans.pb(j);
                    break;
                }
        }
    }
    for(auto to : ans)
        cout<<to+1<<' ';

}
int main()
{
    #ifdef ROADTOBELEGEND
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // ROADTOBELEGEND

    fast_io;

    int np,nt;
    cin>>np>>nt;

    if(np==1)
    {
        solve1();
        return 0;
    }
    if(np==2)
    {
        solve3();
        return 0;
    }



    return 0;
}

