#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxn = 2e5 + 10;
const int inf = 1e9 + 10;

struct Vect{
    ll x, y;
    Vect() {}
    Vect (ll x, ll y) : x(x), y(y) {}
};

istream& operator >> (istream& is, Vect& a) {
    is >> a.x >> a.y;
    return is;
}

Vect operator + (Vect a, Vect b) {
    return {a.x + b.x, a.y + b.y};
}

Vect operator - (Vect a, Vect b) {
    return {a.x - b.x, a.y - b.y};
}

ll operator % (Vect a, Vect b) {
    return a.x*b.x + a.y*b.y;
}

bool ok(Vect a, Vect b, Vect c) {
    return (c - b)%(a - b) > 0;
}



void solve() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<Vect> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (task == 1) {
        vector<int> b;
        b.push_back(0);
        b.push_back(1);
        for (int i = 2; i < n; i++) {
            b.push_back(i);
            if (!ok(a[b[b.size() - 3]], a[b[b.size() - 2]], a[b[b.size() - 1]])) {
                swap(b[b.size() - 1], b[b.size() - 2]);
            }
        }
        for (int i = 0; i < n; i++) {
            cout << b[i] + 1 << " ";
        }
    }
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
