#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);
const ld PI = acos(-1);

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define trace(x) cout << #x << " = " << x << endl;

mt19937 rnd(time(0));

using ordered_set = tree<pair<ll, ll>,
        null_type,
        less<pair<ll, ll>>,
        rb_tree_tag,
        tree_order_statistics_node_update>;

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

const ll MAXN = 2e5;
set<pair<ll, ll>> g[MAXN];

ll vec(pair<ll, ll> a, pair<ll, ll> b) {
    return a.first * b.second - a.second * b.first;
}

ll skal(pair<ll, ll> a, pair<ll, ll> b) {
    return a.first * b.first + a.second * b.second;
}

pair<ll, ll> diff(pair<ll, ll> a, pair<ll, ll> b) {
    return {a.first - b.first, a.second - b.second};
}

void solve() {
    ll n, task, group;
    cin >> task >> group >> n;

    vector<pair<ll, ll>> a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i].first >> a[i].second;

    if (task == 1) {
        if (group == 1) {
            for (ll i = 1; i <= n; ++i) {
                if (i % 2 == 1) {
                    cout << i / 2 + 1 << ' ';
                }
                else {
                    cout << n - i / 2 + 1 << ' ';
                }
            }
            return;
        }
        ll ans = -1;
        vector<ll> to_ans;

        vector<ll> por(n);
        for (ll i = 0; i < n; ++i) por[i] = i;

        for (ll qw = 0; qw < 30000; ++qw) {
            shuffle(all(por), rnd);

            ll local = 0;

            for (ll i = 0; i + 2 < n; ++i) {
                auto fir = diff(a[por[i]], a[por[i + 1]]);
                auto sec = diff(a[por[i + 2]], a[por[i + 1]]);

                if (2 * abs(atan2(vec(fir, sec), skal(fir, sec))) < PI) {
                    local++;
                }
            }

            if (ans < local) {
                ans = local;
                to_ans = por;
            }
        }

        for (auto i : to_ans) cout << i + 1 << ' ';
    }
}

int main() {
    fast_stream();

    int tests = 1;

    while (tests--) {
        solve();
    }
}
