#include <bits/extc++.h>

using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ordered_set = tree<int, null_type, std::less<>, rb_tree_tag, tree_order_statistics_node_update>;
std::mt19937 rnd(12307231);

#define ff first
#define ss second
#define int ll

struct point {
    int x, y;

    point operator-(const point p) {
        return {x - p.x, y - p.y};
    }
};

ll dot_pr(const point v, const point u) {
    return v.x * u.x + v.y * u.y;
}

ll dist(const point u, const point v) {
    return (u.x - v.x) * ll(u.x - v.x) + (u.y - v.y) * ll(u.y - v.y);
}

int test = 0;

void solve() {
    ++test;
    std::cerr << test << std::endl;
    int task = 1, g = 0;
//    std::cin >> task >> g;
    int n = 10;
//    std::cin >> n;
    if (task == 1) {
        std::vector<point>a(n);
        std::set<int>x_cor, y_cor;
//        for (int i = 0; i < n; ++i) std::cin >> a[i].x >> a[i].y;
        for (int i = 0; i < n; ++i) {
            a[i].x = rnd() % 500, a[i].y = rnd() % 500;
            if (x_cor.find(a[i].x) != x_cor.end() || y_cor.find(a[i].y) != y_cor.end()) return;
            x_cor.insert(a[i].x);
            y_cor.insert(a[i].y);
        }
        int cur = 0;
        std::vector<int>ans = {0};
//        std::cout << cur + 1 << ' ';
        std::vector<int>used(n);
        used[cur] = 1;
        for (int i = 0; i < n - 1; ++i) {
            int can = cur;
            for (int j = 0; j < n; ++j) {
                if (used[j]) continue;
                if (dist(a[can], a[cur]) < dist(a[j], a[cur])) {
                    can = j;
                }
            }
            used[can] = 1;
//            std::cout << can + 1 << ' ';
            ans.push_back(can);
            cur = can;
        }
//        std::cout << '\n';
        for (int i = 1; i < n - 1; ++i) {
            point v1 = a[ans[i - 1]] - a[ans[i]],
                  v2 = a[ans[i + 1]] - a[ans[i]];
            if (dot_pr(v1,v2) < 0) {
                std::cout << "!!!\n";
                for (const auto &item: a) std::cout << item.x << ' ' << item.y << '\n';
                std::cout << '\n';
                for (const auto &item: ans) std::cout << item << ' ';
                exit(0);
            }
        }
        return;

    }
    exit(1);
}

int32_t main() {
//    std::ios_base::sync_with_stdio(0);
//    std::cin.tie(0);
//    std::cout.tie(0);

    int T = 1;
//    std::cin >> T;
    while(true) {
        solve();
    }

    return 0;
}