#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#define int long long
using namespace std;


bool check(pair<int, int> &a, pair<int, int> &b, pair<int, int> &c) {
    pair<int, int> A = {a.first - b.first, a.second - b.second};
    pair<int, int> B = {c.first - b.first, c.second - b.second};
    return (A.first * B.first + A.second * B.second) > 0;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<pair<int, int>> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i].first >> c[i].second;
    }
    if (group == 1) {
        for (int i = 0; i < n; ++i) {
            if (i % 2 == 0) {
                cout << i / 2 + 1 << " ";
            } else {
                cout << n - (i / 2) << " ";
            }
        }
    } else if (group == 2) {
        vector<int> best;
        int cnt = -1;
        vector<int> cur(n);
        for (int i = 0; i < n; ++i) {
            cur[i] = i;
        }
        do {
            int count = 0;
            for (int i = 1; i < n - 1; ++i) {
                count += check(c[cur[i - 1]], c[cur[i]], c[cur[i + 1]]);
            }
            if (count > cnt) {
                cnt = count;
                best = cur;
            }
        } while(next_permutation(cur.begin(), cur.end()));
        for (int i = 0; i < n; ++i) {
            cout << best[i] + 1 << " ";
        }
        cout << endl;
    } else if (group == 7) {
        int C;
        cin >> C;
        int q;
        cin >> q;
        for (int z = 0; z < q; ++z) {
            int k;
            cin >> k;
            for (int i = 0; i < k + 1; ++i) {
                if (i % 2 == 0) {
                    cout << i / 2 + 1 << " ";
                } else {
                    cout << n - (i / 2) << " ";
                }
            }
            int cnt = 0;
            if (k % 2 == 0) {
                for (int i = (k + 1) / 2 + 1; cnt < n - k - 1; ++i) {
                    cout << i + 1 << " ";
                    cnt++;
                }
            } else {
                for (int i = n - (k + 2) / 2; cnt < n - k - 1; --i) {
                    cout << i << " ";
                    cnt++;
                }
            }
            cout << endl;
        }
    }
    return 0;
}
