#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>

using namespace std;

#define ALL(x) x.begin(), x.end()
#define int long long
typedef long long ll;
typedef long double ld;

struct Vec
{
	int x, y;
	int i;
	Vec() {}
	Vec(int a, int b, int ii)
	{
		x = a;
		y = b;
		i = ii;
	}
	
	Vec operator-(Vec x)
	{
		Vec* rt = this;
		rt->x -= x.x;
		rt->y -= x.y;
		return *rt;
	}
	int operator*(Vec a)
	{
		return x * a.x + y * a.y;
	}

};
bool operator<(Vec a, Vec b)
{
	pair<int, int> ff = { a.x, a.y };
	pair<int, int> ss = { b.x, b.y };
	return ff < ss;
}
void solve1(int n)
{
	vector<Vec> v;
	for (int i = 0; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		v.push_back({ x, y, i });
	}
	set<int> ost;
	for (int i = 0; i < n; i++)
	{
		ost.insert(i + 1);
	}
	int now = 1;
	while (ost.size())
	{
		cout << *(ost.begin()) << ' ';
		ost.erase(ost.begin());
		if (!ost.size())
		{
			break;
		}
		auto outer = ost.begin();
		outer++;
		if (outer == ost.end())
		{
			outer--;
		}
		auto dd = *outer;
		cout << dd << ' ';
		ost.erase(outer);

	}
}
void solve2(int n)
{
	vector<Vec> v;
	vector<Vec> v1;
	for (int i = 0; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		v.push_back({ x, y, i });
	}
	v1 = v;
	sort(ALL(v));
	int maxer = 0;
	do
	{
		int now = 0;
		for (int i = 0; i <= n - 3; i++)
		{
			if ((v[i] - v[i + 1]) * (v[i + 2] - v[i + 1]) > 0)
			{
				now++;
			}
		}
		maxer = max(maxer, now);
	} while (next_permutation(ALL(v)));
	v = v1;
	sort(ALL(v));
	do
	{
		int now = 0;
		for (int i = 0; i <= n - 3; i++)
		{
			if ((v[i] - v[i + 1]) * (v[i + 2] - v[i + 1]) > 0)
			{
				now++;
			}
		}
		if (now == maxer)
		{
			for (auto i : v)
			{
				cout << i.i + 1 << ' ';
			}
			return;
		}
		
	} while (next_permutation(ALL(v)));
}


void solve()
{
	int task, g;
	cin >> task >> g;
	int n;
	cin >> n;
	
	if (g == 1)
	{
		solve1(n);
	}
	else
	{
		solve2(n);
	}
	cout << endl;
}

int32_t main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	//cin.tie(0);
	//ios_base::sync_with_stdio(0);
	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}
}