#include<bits/stdc++.h>


using namespace std;

//#define ILOCAL
#ifdef ILOCAL
#define debug(x) cerr << (#x) << " = " << x << endl
#else
#define debug(x)
#endif


using ll = long long;
using vii = vector<int>;
using vll = vector<ll>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vpi = vector<pii>;
using vpl = vector<pll>;
using ull = unsigned long long;
using ld = long double;
using ql = __int128_t;
using uql = __uint128_t;

struct Point {
    int x, y;
    Point(): x(0), y(0){}
    Point(int xx, int yy): x(xx), y(yy){}
    Point operator-(const Point &other) {
        return Point(x - other.x, y - other.y);
    }
    int operator*(const Point &other) {
        return x * other.x + y * other.y;
    }
};


void solve() {
    int t, g;
    cin >> t >> g;
    if (g == 1 ) {
        int n;
        cin >> n;
        for(int i = 0; i < n; ++i) {
            int a, v;
            cin >> a >> v;
        }
        deque<int> d(n);
        iota(d.begin(), d.end(), 1);
        while(!d.empty()) {
            cout << d.front() << ' ';
            d.pop_front();
            if (!d.empty()) {
                cout << d.back() << ' ';
                d.pop_back();
            }
        }
        cout << endl;
        return;
    } else if (g == 2) {
        int n;
        cin >> n;
        Point a[n];
        for(int i = 0; i < n; ++i) {
            int x, y;
            cin >> x >> y;
            a[i] = {x, y};
        }
        vii p(n);
        iota(p.begin(), p.end(), 0);
        int maxi = 0;
        do {
            int cur = 0;
            for(int i = 1; i < n; ++i) {
                Point p1p0 = a[p[i - 1]] - a[p[i]];
                Point p2p1 = a[p[i + 1]] - a[p[i]];
                int pp = p1p0 * p2p1;
                if (pp > 0) {
                    ++cur;
                }
            }
            if (cur > maxi) {
                maxi = cur;
            }
        } while(next_permutation(p.begin(), p.end()));
        vii p1(n);
        iota(p1.begin(), p1.end(), 0);
        do {
            int cur = 0;
            for(int i = 1; i < n; ++i) {
                Point p1p0 = a[p1[i - 1]] - a[p1[i]];
                Point p2p1 = a[p1[i + 1]] - a[p1[i]];
                int pp = p1p0 * p2p1;
                if (pp > 0) {
                    ++cur;
                }
            }
            if (cur == maxi) {
                debug(maxi);
                for(auto &x: p1) {
                    cout << x  + 1 << ' ';
                }
                return;
            }
        } while(next_permutation(p1.begin(), p1.end()));
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef ILOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
}