#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_map>
#include <iomanip>
#include <queue>
#include <climits>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef long double ld;
#define mid (r + l) / 2
#define lv (2 * v + 1)
#define rv (2 * v + 2)
#define all(x) x.begin(), x.end()

struct t {
    ll x, y, i;
    t() {
        x = 0;
        y = 0;
        i = 0;
    }
    t(ll a, ll b, ll c) {
        x = a;
        y = b;
        i = c;
    }
    t operator-(t b) {
        return { x - b.x, y - b.y, i };
    }
};

vector<t> a;
vector<ll> ans;
bool used[20000];

ll dist(t x, t y) {
    x = y - x;
    return x.x * x.x + x.y * x.y;
}

void get(int v) {
    ans.push_back(a[v].i);
    if (ans.size() == a.size()) return;
    used[v] = true;
    int to = -1;
    for (int i = 0; i < a.size(); i++) {
        if (!used[i] && (to == -1 || dist(a[v], a[i]) > dist(a[v], a[to]))) {
            to = i;
        }
    }
    get(to);
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    int n, st = 0;
    cin >> n >> st;
    st = 0;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        if (a[i].x < a[st].x) st = i;
        a[i].i = i + 1;
    }
    get(st);
    for (auto i : ans) {
        cout << i << " ";
    }
    cout << endl;
    return 0;
}