#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 2e4 + 10;
const int INF = 2e9;
const int mod = 1e9 + 7;

struct Point {
    ll x, y;
};

vector<Point> p(N);

ll dist(Point& a, Point& b) {
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int task, group, n;
    cin >> task >> group >> n;
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }
    vector<int> used(n);
    vector<int> order;
    order.push_back(0);
    int i = 0;
    used[0] = 1;
    while (order.size() < n) {
        int ans = 0, mx = 0;
        for (int j = 0; j < n; j++) {
            if (used[j] == 0 && dist(p[i], p[j]) > mx) {
                ans = j;
                mx = dist(p[i], p[j]);
            }
        }
        used[ans] = 1;
        order.push_back(ans);
    }
    for (int a : order) {
        cout << a + 1 << ' ';
    }
    cout << endl;
}
