#include <bits/stdc++.h>

#define int long long
using namespace std;

struct Vector {
    int x, y;
    int id;
};

bool operator<(Vector a, Vector b) {
    return a.id < b.id;
}

int dist(Vector p1, Vector p2) {
    return (p1.x - p2.x) * (p1.x - p2.x) +
           (p1.y - p2.y) * (p1.y - p2.y);
}

void solve() {
    int task, group;
    cin >> task >> group;
    if (task != 1) {
        return;
    }
    int n;
    cin >> n;
    set<Vector> s;
    for (int i = 0; i < n; ++i) {
        Vector a{0, 0, i};
        cin >> a.x >> a.y;
        s.insert(a);
    }
    auto x = *s.begin();
    auto y = x;
    for (auto w: s) {
        if (dist(x, w) > dist(x, y)) {
            y = w;
        }
    }
    swap(x, y);
    vector<int> p{x.id};
    s.erase(x);
    while (!s.empty()) {
        y = x;
        for (auto w: s) {
            if (dist(x, w) > dist(x, y)) {
                y = w;
            }
        }
        s.erase(y);
        p.push_back(y.id);
        swap(x, y);
    }
    for (auto i: p) {
        cout << i + 1 << "\n";
    }
    cout << endl;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
