#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> &a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

template<typename T>
void print(vector<T> &a, const string &s) {
    for (int i = 0; i < sz(a); ++i) {
        cout << a;
        if (i < sz(a) - 1) {
            cout << s;
        }
    }
}

struct Vector {
    int x = 0, y = 0;
    Vector() {}
    Vector(int x, int y) : x(x), y(y) {}

    friend istream &operator>>(istream &in, Vector &a) {
        return in >> a.x >> a.y;
    }

    friend Vector operator-(Vector a, Vector b) {
        return {a.x - b.x, a.y - b.y};
    }

    friend Vector operator+(Vector a, Vector b) {
        return {a.x + b.x, a.y + b.y};
    }

    friend ll operator*(Vector a, Vector b) {
        return a.x * b.x + a.y * b.y;
    }

    friend ll operator%(Vector a, Vector b) {
        return a.x * b.y - a.y * b.x;
    }
};

void anneal() {
    mt19937 rnd(123);

}

void solve1() {
    int n;
    cin >> n;
    vector<Vector> a(n);
    cin >> a;
    vector<ll> p(n);
    iota(p.begin(), p.end(), 1);
    sort(p.begin(), p.end(), [&](int i, int j) {
        return a[i - 1].x < a[j - 1].x;
    });
    cout << p[0] << ' ';
    for (int i = 1; i + 1 < n; ++i) {
        swap(p[i], p[i + 1]);
    }
    cout << p;
}

void solve2() {
    int n;
    cin >> n;
    vector<Vector> a(n);
    cin >> a;

}

void solve3() {

}

void solve() {
    int task, group;
    cin >> task >> group;
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
