#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long


int q(int a) {
    return a * a;
}

int d(pair<int, int> a, pair<int, int> b) {
    return q(a.first - b.first) + q(a.second - b.second);
}

void solve1() {
    int n;
    cin >> n;
    vector<int> x(n), y(n);
    int s = 0;
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
        if (x[i] < x[s]) {
            s = i;
        }
    }
    vector<int> otv = {s};
    vector<int> used(n, false);
    used[s] = true;
    for (int i = 0; i < n; i++) {
        int dist = 0;
        int v = -1;
        for (int j = 0; j < n; j++) {
            if (!used[j]) {
                if (dist < q(x[otv.back()] - x[j]) + q(y[otv.back()] - y[j])) {
                    dist = q(x[otv.back()] - x[j]) + q(y[otv.back()] - y[j]);
                    v = j;
                }
            }
        }
        if (v == -1) {
            break;
        }
        used[v] = true;
        otv.push_back(v);
    }
    for (auto i: otv) {
        cout << i + 1 << ' ';
    }
}

mt19937 rnd(time(nullptr) + 10);

void solve3() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    vector<int> now(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        now[i] = i;
    }
    int c;
    cin >> c;
    int q;
    cin >> q;
    while (q--) {
        int k;
        cin >> k;
        while (true) {
            int tmp = 0;
            for (int i = 1; i < n - 1; i++) {
                if (d(a[now[i]], a[now[i - 1]]) + d(a[now[i]], a[now[i + 1]]) > d(a[now[i - 1]], a[now[i + 1]])) {
                    tmp++;
                }
            }
            if (tmp == k) {
                for (auto i: now) {
                    cout << i + 1 << ' ';
                }
                cout << endl;
                break;
            }
            shuffle(now.begin(), now.end(), rnd);
        }
    }
}

void solve2() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    vector<int> now(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        now[i] = i;
    }
    int c;
    cin >> c;
    while (true) {
        int tmp = 0;
        for (int i = 1; i < n - 1; i++) {
            if (d(a[now[i]], a[now[i - 1]]) + d(a[now[i]], a[now[i + 1]]) > d(a[now[i - 1]], a[now[i + 1]])) {
                tmp++;
            }
        }
        if (tmp <= c) {
            for (auto i: now) {
                cout << i + 1 << ' ';
            }
            cout << endl;
            return;
        }
        shuffle(now.begin(), now.end(), rnd);
    }
}

signed main() {
    int task, g;
    cin >> task >> g;
    if (task == 1) {
        solve1();
    }
    if (task == 2) {
        solve2();
    }
    if (task == 3) {
        solve3();
    }
}