//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
//typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define all(a) a.begin(), a.end()
#define rd(a) for (auto &i: a) cin >> i;

ll INF = 1e13;
ll MOD = 1e9 + 7;


ld angle(pair<ld, ld> x) {
    return atan2(x.second, x.first);
}

void solve() {

    ll task, group;
    cin >> task >> group;
    ll n;
    cin >> n;
    pair<ll, ll> l, r;
    vector<ll> ans;
    vector<pair<ld, ld>> w;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        w.push_back({x, y});
    }
    for (int i = 0; i < n; i++) {
        auto [x, y] = w[i];
        vector<ll> bad;
        while (ans.size() >= 2) {
            l = w[ans[ans.size() - 2]];
            r = w[ans[ans.size() - 1]];
            pair<ll, ll> BA = {l.first - r.first, l.second - r.second};
            pair<ll, ll> CB = {x - r.first, y - r.second};
            ld a1 = angle(BA);
            ld a2 = angle(CB);

            ld ang = a1 - a2;
            while (ang < 0) {
                ang += 2 * M_PI;
            }
            while (ang >= 2 * M_PI) {
                ang -= 2 * M_PI;
            }
            if (ang >= M_PI) {
                ang -= M_PI;
            }
            if (ang <= M_PI / 2.0) {
                break;
            } else {
                bad.push_back(ans.back());
                ans.pop_back();
            }
        }
        ans.push_back(i);
        for (auto c: bad) {
            ans.push_back(c);
        }
    }
    for (auto c: ans) {
        cout << c + 1 << " ";
    }
    cout << endl;

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	//ll t; for (cin >> t; t--;) solve();
	solve();

}

//void operator delete(void*) {};
//const int MAX_MEM = 3 * 1e8;
//int pos = 0;
//char buf[MAX_MEM];
//void* operator new(size_t x) {
//    void* pointer = (void*)(buf + pos);
//    pos += x;
//    if (pos >= MAX_MEM) {
//        pos = 1e6;
//    }
//    return pointer;
//
//}


