#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define klm ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define pb(a) push_back(a)

struct point{
    ll x, y;

    point(){}

    point(ll _x, ll _y){
        x = _x;
        y = _y;
    }

    point operator-=(point b){
        x -= b.x;
        y -= b.y;
    }

    point operator+=(point b){
        x += b.x;
        y += b.y;
    }
};

point operator-(point a, point b){
    return point(a.x - b.x, a.y - b.y);
}

point operator+(point a, point b){
    return point(a.x + b.x, a.y + b.y);
}

ll operator*(point a, point b){
    return a.x * b.x + a.y * b.y;
}

ll operator^(point a, point b){
    return a.x * b.y - a.y * b.x;
}

void solve(){
    ll tsk, gr, n;
    cin >> tsk >> gr;
    cin >> n;
    vector<point>v(n);
    for(int i = 0; i < n; ++i){
        cin >> v[i].x >> v[i].y;
    }
    if (gr == 1){
        for(int i = 1; i <= n / 2; ++i){
            cout << n - i + 1 << " " << i << " ";
        }
        cout << endl;
        return;
    }
    vector<ll>bro(n);
    for(int i = 0; i < n; ++i){
        bro[i] = i + 1;
    }
    if (tsk == 1){
        ll st = clock();
        vector<ll>ans = bro;
        ll ans_cnt = 0;
        while ((clock() - st) * CLOCKS_PER_SEC <= 2000000){
            random_shuffle(all(bro));
            ll cnt = 0;
            for(int i = 1; i < n - 1; ++i){
                cnt += (((v[bro[i]] - v[bro[i - 1]]) * (v[bro[i + 1]] - v[bro[i]])) > 0);
            }
            if (cnt > ans_cnt){
                ans_cnt = cnt;
                ans = bro;
            }
        }

        for(int i = 0; i < n; ++i){
            cout << ans[i] << " ";
        }
        cout << endl;
    } else{
        ll st = clock();
        vector<ll>ans = bro;
        ll ans_cnt = 0;
        while ((clock() - st) * CLOCKS_PER_SEC <= 2000000000){
            random_shuffle(all(bro));
            ll cnt = 0;
            for(int i = 1; i < n - 1; ++i){
                cnt += (((v[bro[i]] - v[bro[i - 1]]) * (v[bro[i + 1]] - v[bro[i]])) > 0);
            }
            if (cnt <= 800){
                ans_cnt = cnt;
                ans = bro;
            }
        }

        for(int i = 0; i < n; ++i){
            cout << ans[i] << " ";
        }
        cout << endl;
    }
}

int main(){
    ll t = 1;
    klm;
    //freopen("/home/olymp/Desktop/negr/input.txt", "r", stdin);
    //freopen("/home/olymp/Desktop/negr/output.txt", "w", stdout);

    //cin >> t;

    while(t--){
        solve();
    }
    return 0;
}