#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("popcnt")

//#define int long long
using ll = long long;
#define forn(i,n) for(int i=0; i<n; ++i)
#define pb push_back
#define all(x) x.begin(),x.end()
#define pi pair<int,int>
#define f first
#define s second
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];

const ll inf = 1e18;

struct point {
	int x,y,i;
};
bool foo(point a, point b) {
	return a.x < b.x;
}

struct BIT {
	vector<int> t,a; int n;
	BIT(int n) {
		this->n=n;
		a.assign(n,0);
		t.assign(n,0);
		forn(i,n) {
			for(int j=i; j<n; j=j|(j+1)) t[j]=i;
		}
	}
	int mrg(int i, int j) {
		if (a[i]>a[j]) return i;
		return j;
	}
	void upd(int i, int x) {
		a[i]=x;
		for(int j=i;j<n;j=j|(j+1)) t[j]=mrg(t[j],i);
	}
	int query(int r) {
		int ret=0;
		for(;r>=0;r=(r&(r+1))-1) ret=mrg(ret,t[r]);
		return ret;
	}
	void clear() {
		a.assign(n,0);
		forn(i,n) {
			for(int j=i; j<n; j=j|(j+1)) t[j]=i;
		}
	}
};

const int N=8e4+5;
bitset<N> vis;

void solve() {

	exit(0);
	int n; cin>>n;
	vector<point> a(n);
	map<int,int> cpx,cpy; int mx=0,my=0;
	set<int> sx,sy; sx.insert(-2e9); sy.insert(-2e9);
	forn(i,n) {
		cin>>a[i].x>>a[i].y; a[i].i=i;
		sx.insert(a[i].x);
		sy.insert(a[i].y);
	}
	int c; cin>>c;
	sort(all(a),foo);
	for(auto&x:sx) cpx[x]=mx++;
	for(auto&x:sy) cpy[x]=my++;
	forn(i,n) a[i].x=cpx[a[i].x], a[i].y=cpy[a[i].y];
	//forn(i,n) cout<<a[i].x<<' '<<a[i].y<<' '<<a[i].i<<'\n'; return;
	
	BIT ft(my+5),rft(my+5);
	vector<int> ans;
	vector<int> dp(my+5,0);
	vector<int> rdp(my+5,0);
	while (a.size()) {
		forn(i,my+5) dp[i]=rdp[i]=0;
		ft.clear(); rft.clear();
		n=a.size();
		forn(i,n) {
			int z=ft.query(a[i].y);
			dp[a[i].y]=dp[z]+1;
			ft.upd(a[i].y,dp[z]+1);
		}
		int z1 = ft.query(my);
		reverse(all(a));
		forn(i,n) {
			int z=rft.query(a[i].y);
			rdp[a[i].y]=rdp[z]+1;
			rft.upd(a[i].y,rdp[z]+1);
		}
		int z2 = rft.query(my);

		vector<point> b;

		if (dp[z1]>=rdp[z2]) {
			int zzz=dp[z1];
			for(int i=0; i<n; ++i) {
				if (dp[a[i].y]==zzz) {
					ans.pb(a[i].i);
					--zzz;
				} else b.pb(a[i]);
			}
		} else {
			int zzz=rdp[z2];
			for(int i=n-1; i>=0; --i) {
				if (rdp[a[i].y]==zzz) {
					ans.pb(a[i].i);
					--zzz;
				} else b.pb(a[i]);
			}
		}
		a=b;
	}

	for(auto&x:ans) cout<<x+1<<' '; cout.flush();

}

pi vec(pi a, pi b) {
	return {b.f-a.f,b.s-a.s};
}
int cross(pi a, pi b) {
	return a.f*b.s - a.s*b.f;
}
int sign(int x) {
	if (x<0) return -1;
	if (x==0) return 0;
	return 1;
}
int inside(pi f, pi s, pi t, pi x) {
	int s1 = sign(cross(vec(f,s),vec(f,x)));
	int s2 = sign(cross(vec(s,t),vec(s,x)));
	int s3 = sign(cross(vec(t,f),vec(t,x)));
	//cout<<"??? "<<f.f<<' '<<f.s<<"  "<<s.f<<' '<<s.s<<"  "<<t.f<<' '<<t.s<<"  "<<x.f<<' '<<x.s<<"\n"<<s1<<' '<<s2<<' '<<s3<<'\n';
	if (s1==0) return (s2==s3);
	//if (s2==0) return (s1==s3);
	if (s3==0) return (s2==s1);
	return s1==s2 && s2==s3;
}

int collinear(pi a, pi b, pi c) {
	int z = cross(vec(a,b),vec(a,c));
	return z==0;
}

int dst(pi a, pi b) {
	return (a.f-b.f)*(a.f-b.f) + (a.s-b.s)*(a.s-b.s);
}
int ugol(pi a, pi b, pi c) {
	//if (collinear(a,b,c)) return 1;
	int d1 = dst(a,b);
	int d2 = dst(b,c);
	if (d2 > d1) swap(a,c);
	int dx=b.f-a.f;
	int dy=b.s-a.s;
	pi c1 = {b.f+dy,b.s-dx};
	pi c2 = {b.f-dy,b.s+dx};
	return inside(a,b,c1,c)||inside(a,b,c2,c);
}
void erase(vector<int>&v,int i) {
	for(;i<v.size()-1;++i) {
		swap(v[i],v[i+1]);
	}
	v.pop_back();
}
void p1() {
	int n; cin>>n;
	if (n<=0) {
		vector<pi> a(n);
		forn(i,n) cin>>a[i].f>>a[i].s;
		int l=1; forn(i,n) l*=i+1;
		vector<int> b;
		int best=-1;
		vector<int> p; forn(i,n) p.pb(i);
		forn(it,l) {
			int score=0;
			for(int i=0; i+2<n; ++i) {
				score+=ugol(a[p[i]],a[p[i+1]],a[p[i+2]]);
			}
			if (score>best) {
				best=score;
				b=p;
			}
			next_permutation(all(p));
		}
		//cout<<"? "<<best<<'\n';
		forn(i,n) cout<<b[i]+1<<' '; cout<<'\n'; cout.flush();
		return;
	}
	if (n<=1000) {
		vector<pi> a(n);
		forn(i,n) cin>>a[i].f>>a[i].s;
		vector<int> b;
		mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
		vector<int> p={0,1+(rng()%(n-1))};
		forn(i,n) if (i && i!=p[1]) b.pb(i);
		int k=2;
		//cout<<"? "<<p[0]<<' '<<p[1]; cout.flush();
		while (b.size()) {
			int j=rng()%b.size();
			//cout<<"! "<<b.size()<<'\n';
			//cout<<"? "<<j<<' '<<b[j]<<"  "<<ugol(a[p[k-2]],a[p[k-1]],a[b[j]])<<'\n';
			if (ugol(a[p[k-2]],a[p[k-1]],a[b[j]])) {
				p.pb(b[j]);
				erase(b,j);
				++k;
			}
		}
		for(auto&x:p) cout<<x+1<<' '; cout<<'\n'; cout.flush();
	}
	int a,b;
	forn(i,n) cin>>a>>b;
	int l=1,r=n;
	while (l<r) {
		cout<<l<<' ';
		if (l!=r) cout<<r<<' ';
		++l, --r;
	}
	cout.flush();
}

void p3() {
	int n; cin>>n;
	int a,b;
	forn(i,n) cin>>a>>b;
	int c; cin>>c;
	int q; cin>>q;
	while (q--) {
		int k; cin>>k;
		int l=1, r=k+2-(k&1);
		while (l<r) {
			cout<<l<<' ';
			if (l!=r) cout<<r<<' ';
			++l, --r;
		}
		int z=k+2-(k&1)+1;
		for(int i=z; i<=n-2; ++i) cout<<i<<' ';
		if (k&1) cout<<n<<' '<<n-1<<'\n';
		else cout<<n-1<<' '<<n<<'\n';
		cout.flush();
	}
}
void p4() {
	exit(0);
	int n; cin>>n;
	int a,b;
	forn(i,n) cin>>a>>b;
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int p,g; cin>>p>>g;
	if (p==1) p1();
	if (p==3) p3();
	if (p==4) p4();
	if (p==2)
	solve();
}