#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <iomanip>
#include <random>
#include <deque>

using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

const ll MOD = 1e9 + 7;
const ll inf = 1e18;

mt19937 rnd(45);

int n, c;
vector<ll> x, y;

void slv11() {
	cout << "1 ";
	for (int i = 1; i + 1 < n; i += 2) {
		cout << i + 2 << ' ' << i + 1 << ' ';
	}
	if (n % 2 == 0) {
		cout << n << ' ';
	}
	cout << '\n'; cout.flush();
}

void slv1(int g) {
	if (g == 1) {
		slv11();
		return;
	}
}

void slv37() {
	int q; cin >> q;
	for (int _ = 0; _ < q; ++_) {
		int m; cin >> m;
		vector<int> ans;
		ans.push_back(0);
		for (int i = 1; i + 1 < m + 2; i += 2) {
			ans.push_back(i + 1);
			ans.push_back(i);
		}
		if (m % 2 == 0) {
			ans.push_back(m + 1);
		}
		for (int i = 0; i + m + 2 < n; ++i) {
			cout << i + 1 << ' ';
		}
		for (int i : ans) {
			cout << i + n - m - 1 << ' ';
		}
		cout << '\n'; cout.flush();
	}
}

void slv3(int g) {
	if (g == 7) {
		slv37();
	}
}

void solve() {
	int t, g; cin >> t >> g;
	cin >> n;
	x.resize(n);
	y.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> y[i];
	}
	if (t == 1) {
		slv1(g);
	} else if (t == 2) {
		cin >> c;
	} else if (t == 3) {
		cin >> c;
		slv3(g);
	} else {
		cin >> c;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}