#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

struct point {
    ll x, y;
    int idx;

    point() {
        x = y = 0;
    }
    point(ll _x, ll _y) {
        x = _x;
        y = _y;
    }
};

bool cmp(point a, point b) {
    return a.x < b.x;
}

void solve() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<point> pts;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        pts.push_back(point(x, y));
        pts.back().idx = i + 1;
    }
    sort(pts.begin(), pts.end(), cmp);
    if (task == 1) {
        vector<int> p;
        for (int i = 0; i < n + 1; i += 2) {
            if (i < n) {
                p.push_back(pts[i].idx);
            }
            if (i - 1 >= 0) {
                p.push_back(pts[i - 1].idx);
            }
        }
        for (auto e : p) {
            cout << e << ' ';
        }
        cout << '\n';
    } else if (task == 2) {
        int c;
        cin >> c;
        for (int i = 0; i < n; i++) {
            cout << pts[i].idx << ' ';
        }
        cout << '\n';
    } else {
        exit(1);
    }
}

int main() {
    int t = 1;
    for (int i = 0; i < t; i++) solve();
}
