#pragma optimize("Ofast,unroll-loops");
#pragma target("avx2");

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define endl '\n'
#define pint pair<int, int>
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

void solve() {
    srand(time(0));

    int task, group;
    cin >> task >> group;

    int n;
    cin >> n;
    vector<pair<double, double>> a(n);
    forn(i, 0, n) {
        cin >> a[i].first >> a[i].second;
    }

    auto cmp = [&](pair<double, double> f, pair<double, double> s, pair<double, double> curr) {
        double fa = atan2(curr.first * f.second - curr.second * f.first, curr.first * f.first + curr.second * f.second);
        double sa = atan2(curr.first * s.second - curr.second * s.first, curr.first * s.first + curr.second * s.second);
        return fabs(fa) < fabs(sa);
    };

    vector<int> verts(n);
    iota(all(verts), 0);
    vector<int> ord = { 1 };
    unordered_set<int> used = { 0 };
    int prev = 1;
    while(ord.size() != n) {
        sort(all(verts), [&](int f, int s) {
            return cmp(a[f], a[s], a[prev - 1]);
        });
        int nxt = -1;
        forn(i, 0, n) {
            if (!used.count(verts[i])) {
                nxt = verts[i];
                break;
            }
        }
        ord.push_back(nxt + 1);
        used.insert(nxt);
        prev = nxt + 1;
    }
    cout.flush();
    forn(i, 0, n) {
        cout << ord[i] << " ";
    }
    cout.flush();
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
