#include <bits/stdc++.h>
using namespace std;

using ll = long long;

/*
void add(int x, int pos) {
    for (int i = pos; i < n; i |= (i + 1)) {
        f[i] += x;
    }
}

int get(int pos) {
    int ans = 0;
    for (int i = pos; i > 0; i &= (i - 1)) {
        ans += f[i];
    }
    return ans;
}
 */

struct Vec {
    ll x, y;
    Vec(){}
    Vec (ll _x, ll _y) {
        x = _x;
        y = _y;
    }
    ll operator*(Vec a) {
        return x * a.x + y * a.y;
    }
    Vec operator-(Vec a) {
        return {x - a.x, y - a.y};
    }
};

Vec &operator>>(istream &in, Vec &a) {
    in >> a.x >> a.y;
    return a;
}

ostream &operator<<(ostream &out, Vec a) {
    out << a.x << " " << a.y;
    return out;
}

vector <Vec> a;

vector <int> ord, ans, vis;
int n, best = 0;

void find_best(int i, int cnt) {
    if (i == n) {
        if (cnt > best) {
            best = cnt;
            ans = ord;
        }
        return;
    }
    for (int nx = 0; nx < n; ++nx) {
        if (vis[nx]) continue;
        ord.push_back(nx);
        vis[nx] = 1;
        if (ord.size() > 2 && (a[ord[ord.size() - 2]] - a[ord[ord.size() - 3]]) * (a[ord[ord.size() - 2]] - a[nx]) > 0) {
            find_best(i + 1, cnt + 1);
        } else {
            find_best(i + 1, cnt);
        }
        ord.pop_back();
        vis[nx] = 0;
    }
}

int main() {
    int task, group, c;
    cin >> task >> group >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    if (task != 1) cin >> c;
    else c = n - 2;
    if (group != 2) {
        for (int i = 0; i < c - (n - 2); ++i) cout << i + 1 << " ";
        for (int i = c - n + 2; n - i - 1 > i; ++i) cout << i + 1 << " " << n - i << " ";
        if (n % 2) cout << n / 2 + 1 << endl;
    }
    if (group == 2) {
        vis.resize(n, 0);
        find_best(0, 0);
        for (auto x : ans) cout << x + 1 << " ";
        cout << endl;
    }
}
