#include <bits/stdc++.h>

#define int int64_t
#define ld long double
#define pii pair <int, int>
#define fi first
#define se second

using namespace std;

const int INF = 1e18;

ld len (pii a, pii b) {
    ld delta_x = abs(a.fi - b.fi) * abs(a.fi - b.fi);
    ld delta_y = abs(a.se - b.se) * abs(a.se - b.se);
    ld ans = (ld)sqrt(1.0 * delta_x + delta_y);
    return ans;
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int task, group;
    cin >> task >> group;
    if (task == 1) {
        int n;
        cin >> n;
        vector <pair <pii, int>> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i].fi.fi >> a[i].fi.se;
            a[i].se = i;
        }
        sort(a.begin(), a.end());
        ld pi = acosl(-1.0);
        auto f = [&] (vector <pair <pii, int>> lol) {
            int ans = 0;
            vector <pii> v;
            for (auto to : lol) {
                v.push_back(to.fi);
            }
            for (int i = 1; i < n - 1; ++i) {
                ld a = len(v[i - 1], v[i]);
                ld b = len(v[i], v[i + 1]);
                ld c = len(v[i - 1], v[i + 1]);
                ld cos_alpha = -(c * c - a * a - b * b) / (2 * a * b);
                ld y = acosl(cos_alpha);
                ld x = y * 180 / pi;
                if (x < 90.0) {
                    ans++;
                }
            }
            return ans;
        };
        vector <pair <pii, int>> bst = a;
        int mx = f(bst);
        do {
            int now = f(a);
            if (now > mx) {
                mx = now;
                bst = a;
            }
        } while (next_permutation(a.begin(), a.end()));
        for (auto to : bst) {
            cout << to.se + 1 << ' ';
        }
    }
    return 0;
}
