#include <bits/stdc++.h>

#define int int64_t
#define ld long double
#define TIME 1.0*clock()/CLOCKS_PER_SEC
#define pii pair <int, int>
#define fi first
#define se second

using namespace std;
mt19937 gen(52525252);

const int INF = 1e18;

ld len (pii a, pii b) {
    ld delta_x = abs(a.fi - b.fi) * abs(a.fi - b.fi);
    ld delta_y = abs(a.se - b.se) * abs(a.se - b.se);
    long double ans = (long double)sqrt(1.0 * delta_x + delta_y);
    return ans;
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int task, group;
    cin >> task >> group;
    if (task == 1) {
        int n;
        cin >> n;
        vector <pair <pii, int>> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i].fi.fi >> a[i].fi.se;
            a[i].se = i;
        }
        sort(a.begin(), a.end());
        ld pi = acosl(-1.0);
        auto f = [&] (vector <pair <pii, int>> lol) {
            int ans = 0;
            vector <pii> v;
            for (auto to : lol) {
                v.push_back(to.fi);
            }
            for (int i = 1; i < n - 1; ++i) {
                ld a = len(v[i - 1], v[i]);
                ld b = len(v[i], v[i + 1]);
                ld c = len(v[i - 1], v[i + 1]);
                ld cos_alpha = -(c * c - a * a - b * b) / (2 * a * b);
                ld y = acosl(cos_alpha);
                ld x = y * 180 / pi;
                if (x < 90.0) {
                    ans++;
                }
            }
            return ans;
        };
        shuffle(a.begin(), a.end(), gen);
        ld temp = 1.0;
        int was = f(a);
        uniform_real_distribution <ld> unif(0.0, 1.0);
        while (TIME < 1.94) {
            temp *= 0.995252;
            stack <pii> upd;
            for (int it = 0; it < 2 * (gen() % 3 + 1); ++it) {
                int i = gen() % n, j = gen() % n;
                upd.push({i, j});
                swap(a[i], a[j]);
            }
            int now = f(a);
            if (now >= was || (TIME < 0.7 && unif(gen) < exp((now - was) / temp))) {
                was = now;
                continue;
            }
            while (!upd.empty()) {
                int i = upd.top().fi, j = upd.top().se;
                upd.pop();
                swap(a[i], a[j]);
            }
        }
        for (auto to : a) {
            cout << to.se + 1 << ' ';
        }
    }
    if (task == 2) {
        int n;
        cin >> n;
        vector <pair <pii, int>> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i].fi.fi >> a[i].fi.se;
            a[i].se = i;
        }
        sort(a.begin(), a.end());
        int c;
        cin >> c;
        ld pi = acosl(-1.0);
        auto f = [&] (vector <pair <pii, int>> lol) {
            int ans = 0;
            vector <pii> v;
            for (auto to : lol) {
                v.push_back(to.fi);
            }
            for (int i = 1; i < n - 1; ++i) {
                ld a = len(v[i - 1], v[i]);
                ld b = len(v[i], v[i + 1]);
                ld c = len(v[i - 1], v[i + 1]);
                ld cos_alpha = -(c * c - a * a - b * b) / (2 * a * b);
                ld y = acosl(cos_alpha);
                ld x = y * 180 / pi;
                if (x < 90.0) {
                    ans++;
                }
            }
            return ans;
        };
        shuffle(a.begin(), a.end(), gen);
        ld temp = 1.0;
        int was = f(a);
        uniform_real_distribution <ld> unif(0.0, 1.0);
        while (TIME < 1.94) {
            temp *= 0.995252;
            int i = gen() % n, j = gen() % n;
            swap(a[i], a[j]);
            int now = f(a);
            if (now <= was || unif(gen) < exp((was - now) / temp)) {
                was = now;
                continue;
            }
            swap(a[i], a[j]);
        }
        for (auto to : a) {
            cout << to.se + 1 << ' ';
        }
    }
    return 0;
}
