//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
typedef long long ll;
typedef long double ld;
#define all(a) (a).begin(), (a).end()
#define pii pair<ll, ll>

using namespace std;
const ld PI = acosl(-1);
struct point{
    ld x, y;
    point(ld x_, ld y_) {
        x = x_;
        y = y_;
    }
    point() {

    }
    point operator-(point other) {
        return point(x - other.x, y - other.y);
    }
    ld operator%(point other) {
        return x * other.y - y  * other.x;
    }
    ld len() {
        return sqrtl(x * x + y * y);
    }
};
const ld inf = 2e13;

int main() {
#ifdef ZVEREV
    freopen("inputf.in", "r", stdin);
    freopen("outputf.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << fixed << setprecision(64);
    int task, group; cin >> task >> group;
    if (task == 1) {
        int n; cin >> n;
        vector<point> a;
        for (int i = 0; i < n; i++) {
            ld x, y; cin >> x >> y;
            a.push_back(point(x, y));
        }
        if (group == 1) {
            int start = 1;
            int last = n;
            while (start < last) {
                cout << start++ << ' ';
                if (last > start) {
                    cout << last-- << ' ';
                }
            }
            return 0;
        }
        vector<int> p(n); iota(all(p), 0);
        ld best = -1;
        int bper = 0;
        int per = 0;
        do {
            ld cur = 0;
            for (int i = 1; i < n-1; i++) {
                point ba = a[p[i-1]] - a[p[i]];
                point bc = a[p[i+1]] - a[p[i]];
                ld sin;
                if (ba%bc >= 0) {
                    sin = ((ba%bc)/ba.len())/bc.len();
                } else {
                    sin = ((bc%ba)/ba.len())/bc.len();
                }
                ld ang = asinl(sin);
                if (ang < 0) {
                    ang += PI * 2;
                }
                if (ang < PI/2) {
                    cur += ang;
                }
            }
            if (cur > best) {
                best = cur;
                bper = per;
            }
            per++;
        } while (next_permutation(all(p)));
        p.clear();
        p.resize(n);
        iota(all(p), 0);
        per = 0;
        do {
            if (per == bper) {
                for (int i = 0; i < n; i++) {
                    cout << p[i] + 1 << ' ';
                }
                return 0;
            }
            per++;
        } while (next_permutation(all(p)));
    }
}
