#ifndef LOCAL
#pragma GCC optimize("03")
#pragma GCC optimize("O3")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 generator(seed);

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ld = long double;
using dd = double;
using uint = unsigned int;
using i128 = __int128;

#define int ll

bool good(pair<int, int> a, pair<int, int> b, pair<int, int> c) {
    pair<int, int> ab = {a.first - b.first, a.second - b.second};
    pair<int, int> cb = {c.first - b.first, c.second - b.second};
    return (ab.first * cb.first + ab.second * cb.second) > 0;
}

void solve() {
    int t, g;
    cin >> t >> g;
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; ++i)cin >> v[i].first >> v[i].second;
    if (g == 1) {
        cout << 1 << " ";
        for (int i = 2; i < n; i += 2) {
            cout << i + 1 << " " << i << " ";
        }
        if (n % 2 == 0) cout << n;
        cout << endl;
    } else if (t == 1) {
        vector<pair<pair<int, int>, int>> p;
        for (int i = 0; i < n; ++i) p[i] = {v[i], i + 1};
        sort(v.begin(), v.end());
        cout << 1 << " ";
        int last = p[1].first.second;
        for (int i = 2; i < n; i += 2) {
            if (p[i].first.second > last) {
                cout << p[i].second << " " << p[i - 1].second << " ";
                last = p[i - 1].first.second;
            } else {
                cout << p[i - 1].second << " " << p[i].second;
                last = p[i].first.second;
            }
        }
        if (n % 2 == 0) cout << n;
        cout << endl;
    } else {
        vector<vector<int>> ans(2001);
        vector<int> p(n);
        for (int i = 0; i < n; ++i)p[i] = i;
        int bc = 0;
        for (int i = 1; i < n - 1; ++i) bc += good(v[p[i - 1]], v[p[i]], v[p[i + 1]]);
        if (bc <= 2000) ans[bc] = p;
        for (int i = 0; i < 1000; ++i) {
            shuffle(p.begin(), p.end(), generator);
            int cnt = 0;
            for (int j = 1; j < n - 1; ++j) cnt += good(v[p[j - 1]], v[p[j]], v[p[j + 1]]);
            if (cnt <= 2000) {
                ans[cnt] = p;
            }
        }
        int c;
        cin >> c;
        int q;
        cin >> q;
        while (q--) {
            int k;
            cin >> k;
            for (auto c: ans[k]) cout << c + 1 << " ";
            cout << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(4);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin>>t;
    while (t--) solve();
}
