#include<bits/stdc++.h>

using namespace std;

#define ll long long 
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

struct point {
	int x, y;
	point() {
		x = y = 0;
	}
	point(int x_, int y_) {
		x = x_;
		y = y_;
	}
};

ll dist(point p1, point p2) {
	return 1ll * (p1.x - p2.x) * (p1.x - p2.x) + 1ll * (p1.y - p2.y) * (p1.y - p2.y);
}
 
signed main () {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif 
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int task, group;
	cin >> task >> group;
	int n;
	cin >> n;
	vector<point> p(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i].x >> p[i].y;
	}
	if (task == 1) {
		int i = 0;
		for (int j = 1; j < n; j++) {
			if (p[j].x < p[i].x) {
				i = j;
			}
		}
		vector<bool> used(n);
		used[i] = 1;
		vector<int> ans{i};
		for (int _ = 0; _ < n - 1; _++) {
			int cur = -1;
			for (int j = 0; j < n; j++) {
				if (used[j]) continue;
				if (cur == -1 || dist(p[i], p[j]) > dist(p[i], p[cur])) {
					cur = j;
				}
			}
			used[cur] = 1;
			ans.pb(cur);
			i = cur;
		}
		cout << ans.size() << endl;
		for (int i : ans) {
			cout << i + 1 << ' ';
		}
		cout << endl;
	} else {
		assert(0);
	}
	return 0;
}