#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("D:\\work2\\input.txt", "r", stdin);
#define file_out freopen("D:\\work2\\output.txt", "w", stdout);
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define str string
#define pb push_back
#define ff first
#define sc second
#define all(a) a.begin(), a.end()
#define sz(a) (int(a.size()))
#define int ll

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2> istream& operator>>(istream &in, pair<T1, T2> &a) { in >> a.ff >> a.sc; return in; }
template<typename T1, typename T2> ostream& operator<<(ostream &out, const pair<T1, T2> &a) { out << a.ff << " " << a.sc; return out; }
template<typename T> istream& operator>>(istream &in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const set<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const multiset<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
mt19937_64 genom(mt_seed); ll randint(ll a, ll b) { uniform_int_distribution<ll> r(a, b); return r(genom); }
const int RANDOM = mt_seed; struct chash { int operator()(int x) const { return x ^ RANDOM; } };
struct pair_hash { ll operator()(pii x) const { return 1ll * x.ff * 31 + x.sc; } };

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    cin >> a;

    vector<int> c = a;
    sort(all(c));
    c.erase(unique(all(c)), c.end());

    if (sz(c) <= t) { cout << 1; return 0; }

    for (auto &el : a) el = lower_bound(all(c), el) - c.begin();

    vector<int> b;
    b.reserve(n * k);
    for (int i = 0; i < k; ++i)
        for (auto el : a)
            b.pb(el);

    int ans = 1, cur = 0;
    vector<bool> cnt(n);
    vector<int> del;
    del.reserve(n);

    for (int i = 0; i < n * k; ++i) {
        if (cnt[b[i]] == 0) {
            cnt[b[i]] = 1;
            del.pb(b[i]);
            ++cur;
        }
        if (cur > t) {
            cur = 1;
            for (auto el : del)
                cnt[el] = 0;
            cnt[b[i]] = 1;
            ++ans;
        }
    }
    cout << ans;

    return 0;
}
