#include <bits/stdc++.h>

signed main() {
    std::ios::sync_with_stdio(false);
    std::cout.tie();
    std::cin.tie();
    int task, gr;
    std::cin >> task >> gr;
    struct point {
        long long x, y;

        int operator*(const point other) const {
            return x * other.x + y * other.y;
        }
    };
    int n;
    std::cin >> n;
    std::vector<point> a(n);
    std::cin >> a[0].x >> a[0].y;
    bool f = true;
    for (int i = 1; i < n; ++i) {
        std::cin >> a[i].x >> a[i].y;
        f &= a[i - 1].x < a[i].x && a[i - 1].y < a[i].y;
    }
    if (f) {
        int l = 1, r = n;
        for (int i = 0; i < n; ++i) {
            if (i & 1) {
                std::cout << r-- << ' ';
            } else {
                std::cout << l++ << ' ';
            }
        }
        std::cout << '\n';
    } else {
        int ans = 0;
        std::vector<int> good_per;
        std::vector<int> per(n);
        std::iota(per.begin(), per.end(), 0);
        while (true) {
            int cur = 0;
            for (int i = 1; i < n - 1; ++i) {
                point ba = {a[per[i - 1]].x - a[per[i]].x, a[per[i - 1]].y - a[per[i]].y};
                point bc = {a[per[i + 1]].x - a[per[i]].x, a[per[i + 1]].y - a[per[i]].y};
                int s = ba * bc;
                if (s < 0) {
                    ++cur;
                }
            }
            if (cur > ans) {
                ans = cur;
                good_per = per;
            }
            if (!std::next_permutation(per.begin(), per.end())) {
                break;
            }
        }
        for (auto &i : good_per) {
            std::cout << i + 1 << ' ';
        }
    }
    return 0;
}
