#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long double ld;
typedef long long ll;
#define int long long
//#pragma GCC optnimize("Ofast")
//#pragma GCC target("avx2")

struct point {
    int x, y;
};

point operator-(point a, point b) {
    return {a.x - b.x, a.y - b.y};
}

int scl(point a, point b) {
    return a.x * b.x + a.y * b.y;
}

bool check(point a, point b, point c) {
    return scl(b - a, c - b) < 0;
}

mt19937 rnd(1);
vector<point> w;


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<int> p(n);
    w.resize(n);
    for (int i = 0; i < n; i++) cin >> w[i].x >> w[i].y, p[i] = i;
    if (group == 1) {
        cout << n << ' ';
        for (int i = 0; i < n - 1; i++) {
            cout << i + 1 << ' ';
        }
        return 0;
    }
    std::random_shuffle(p.begin(), p.end());
    std::random_shuffle(p.begin(), p.end());
    std::random_shuffle(p.begin(), p.end());
    vector<int> ans(n);
    int res = 0;
    for (int _ = 0; _ < 1000000; _++) {
        int cnt = 0;
        for (int i = 1; i < n - 1; i++) {
            if (check(w[p[i - 1]], w[p[i]], w[p[i + 1]])) cnt++;
        }
        if (cnt > res) {
            res = cnt;
            for (int i = 0; i < n; i++) {
                ans[i] = p[i];
            }
        }
        std::next_permutation(p.begin(), p.end());
    }
//    cout << res << '\n';
    for (int i = 0; i < n; i++) {
        cout << ans[i] + 1 << ' ';
    }
    cout << endl;
}