#include <bits/stdc++.h>

#define int long long

using namespace std;

struct point {
    int x, y;
    int operator*(point b) {
        return x * b.x + y * b.y;
    }
    int operator^(point b) {
        return x * b.y - y * b.x;
    }
    point operator-(point b) {
        return {x - b.x, y - b.y};
    }
};

int n;
vector<point> p;
int mx = -1;
vector<int> best, now;
set<int> ost;

void get(int ij) {
    if (ij == n) {
        int nowk = 0;
        for (int i = 1; i < n - 1; i++) {
            int s1 = ((p[now[i - 1]] - p[now[i]]) * (p[now[i + 1]] - p[now[i]])), s2 = ((p[now[i - 1]] - p[now[i]]) ^ (p[now[i + 1]] - p[now[i]]));
            if ((s1 > 0 && s2 > 0) || (s1 < 0 && s2 < 0)) {
                nowk++;
            }
        }
        if (nowk > mx) {
            mx = nowk;
            best = now;
        }
        return;
    }
    vector<int> ost1;
    for (auto x : ost) {
        ost1.push_back(x);
    }
    for (auto x : ost1) {
        ost.erase(x);
        now.push_back(x);
        get(ij + 1);
        ost.insert(x);
        now.pop_back();
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int task, group;
    cin >> task >> group;
    cin >> n;
    p.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> p[i].x >> p[i].y;
    }
    if (task == 1) {
        if (group == 1) {
            int l = 1, r = n;
            int x = 0;
            while (r >= l) {
                if (x == 0) {
                    cout << l << ' ';
                    l++;
                    x = 1;
                }
                else {
                    x = 0;
                    cout << r << ' ';
                    r--;
                }
            }
            cout << endl;
            exit(0);
        }
        else if (group == 2) {
            for (int i = 1; i <= n; i++) {
                ost.insert(i);
            }
            get(0);
            for (auto x : best) {
                cout << x << ' ';
            }
            cout << endl;
        } else {
            for (int i = 1; i <= n; i++) {
                now.push_back(i);
            }
            for (int t = 0; t < 1000; t++) {
                random_shuffle(now.begin(), now.end());
                int nowk = 0;
                for (int i = 1; i < n - 1; i++) {
                    int s1 = ((p[now[i - 1]] - p[now[i]]) * (p[now[i + 1]] - p[now[i]])),
                            s2 = ((p[now[i - 1]] - p[now[i]]) ^ (p[now[i + 1]] - p[now[i]]));
                    if ((s1 > 0 && s2 > 0)) {
                        nowk++;
                    }
                }
                if (nowk > mx) {
                    mx = nowk;
                    best = now;
                }
            }
            for (auto x : now) {
                cout << x << ' ';
            }
        }
    }
    if (task == 2) {
            int c;
            cin >> c;
            vector<int> now;
            for (int i = 1; i <= n; i++) {
                now.push_back(i);
            }
            for (int t = 0; t < 1000; t++) {
                random_shuffle(now.begin(), now.end());
                int nowk = 0;
                for (int i = 1; i < n - 1; i++) {
                    int s1 = ((p[now[i - 1]] - p[now[i]]) * (p[now[i + 1]] - p[now[i]])),
                    s2 = ((p[now[i - 1]] - p[now[i]]) ^ (p[now[i + 1]] - p[now[i]]));
                    if ((s1 > 0 && s2 > 0)) {
                        nowk++;
                    }
                }
                if (nowk < c) {
                    for (auto x : now) {
                        cout << x << ' ';
                    }
                    cout << endl;
                    exit(0);
                }
            }
    }
    if (task == 3) {
        if (group == 7) {
            int c, q;
            cin >> c >> q;
            while (q--) {
                int k;
                cin >> k;
                int l = 1, r = n;
                int x = 0;
                for (int i = 0; i < k + 1; i++) {
                    if (x == 0) {
                        cout << l << ' ';
                        l++;
                        x = 1;
                    } else {
                        x = 0;
                        cout << r << ' ';
                        r--;
                    }
                }
                if (x == 0) {
                    while (r >= l) {
                        cout << r << ' ';
                        r--;
                    }
                } else {
                    while (r >= l) {
                        cout << l << ' ';
                        l++;
                    }
                }
                cout << endl;
            }
            exit(0);

        }
    }
}
