//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <random>
#include <chrono>
#include <bits/stdc++.h>
using namespace std;




using ll = long long;



#define int ll
#define vec vector
#define endl "\n"
#define eb emplace_back
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define all(x) x.begin(), x.end()



int task, group;


struct Point {
    int x, y;
    Point() {}
    Point(int x, int y) : x(x), y(y) {}
    ll operator*(const Point& p) {
        return 1LL * x * p.x + 1LL * y * p.y;
    }
    Point operator-(const Point& p) const {
        return {x - p.x, y - p.y};
    }
};


int sign(ll x) { return x < 0 ? -1 : x > 0; }



const int N = 80010;


int n;
Point a[N];


void input() {
    cin >> task >> group >> n;
    for (int i = 1; i <= n; ++i)
        cin >> a[i].x >> a[i].y;
}




mt19937_64 rnd(228);

void g1() {
    for (int i = 0; i < n / 2; ++i) {
        cout << i + 1 << " " << n - i << " ";
    }
    if (n & 1) cout << n / 2 + 1 << endl;
    cout << endl;

    exit(0);
}



int best = -1;
vec<int> ans;


void tryPerm(const vec<int>& arr) {
    int val = 0;
    for (int i = 1; i + 1 < n; ++i) {
        Point e = a[arr[i - 1]], f = a[arr[i]], g = a[arr[i + 1]];
        int si = sign((e - f) * (g - f));
        if (si == 1) ++val;
    }

    if (val > best) {
        best = val;
        ans = arr;
    }
}


void n10() {
    vec<int> arr(n);
    for (int i = 0; i < n; ++i) arr[i] = i + 1;

    ans = arr;
    do {
        tryPerm(arr);
    } while (next_permutation(arr.begin(), arr.end()));

    for (auto& it : ans) cout << it << " "; cout << endl;
    exit(0);
}



void solve() {
    vec<int> arr(n);
    for (int i = 0; i < n; ++i) arr[i] = i + 1;

    for (int i = 0; i < 10000; ++i) {
        shuffle(all(arr), rnd);
        tryPerm(arr);
    }

    for (auto& it : ans) cout << it << " "; cout << endl;
    exit(0);
}


signed main() {
#ifdef RODYA
    freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\bigTest.in", "r", stdin);
#else
    cin.tie(0), ios_base::sync_with_stdio(false);
#endif



    input();
    if (group == 1) g1();
    if (n <= 10) n10();


    solve();


}
