#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")
//#pragma GCC optimize("unroll-loops")

using namespace std;

using ll = long long;
const char endc = '\n';

using namespace std;

int getType(int x, int y) {
    if (x >= 0) {
        if (y > 0) {
            return 1;
        } else {
            return 2;
        }
    } else {
        if (y >= 0) {
            return 3;
        } else {
            return 4;
        }
    }
}

bool sharp(pair<int, int> a, pair<int, int> b, pair<int, int> c) {
    a.first -= b.first;
    a.second -= b.second;
    c.first -= b.first;
    c.second -= b.second;
    return getType(a.first, a.second) != getType(c.first, c.second);
}

inline void work() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<pair<int, int>> dots(n);
    for (int i = 0; i < n; ++i) cin >> dots[i].first >> dots[i].second;
    vector<int> perm(n);
    iota(perm.begin(), perm.end(), 0);
    if (task == 1 && group == 1) {
        for (int i = 0; i + 1 < n; i += 2) swap(perm[i], perm[i + 1]);
    } else if (task == 1 && group == 2) {
        vector<vector<vector<bool>>> sharpness(n, vector<vector<bool>>(n, vector<bool>(n, false)));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                for (int k = 0; k < n; ++k) {
                    if (i == j || i == k || j == k) continue;
                    sharpness[i][j][k] = sharp(dots[i], dots[j], dots[k]);
                }
            }
        }
        pair<int, vector<int>> bestAnswer = {-1, {}};
        do {
            int sc = 0;
            for (int i = 1; i < n-1; ++i) sc += sharpness[perm[i-1]][perm[i]][perm[i+1]];
            bestAnswer = max(bestAnswer, {sc, perm});
        } while (next_permutation(perm.begin(), perm.end()));
    }
    for (int i = 0; i < n; ++i) cout << perm[i] + 1 << ' ';
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    srand(int(time(nullptr)));
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    while (t-- > 0) work();
}