#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")
//#pragma GCC optimize("unroll-loops")

using namespace std;

using ll = long long;
using ld = long double;
const char endc = '\n';

using namespace std;

int getType(int x, int y) {
    if (x >= 0) {
        if (y > 0) {
            return 1;
        } else {
            return 2;
        }
    } else {
        if (y >= 0) {
            return 3;
        } else {
            return 4;
        }
    }
}

ll mul1(pair<int, int> a, pair<int, int> b) {
    return ll(a.first) * ll(b.second) - ll(b.first) * ll(a.second);
}

ll mul2(pair<int, int> a, pair<int, int> b) {
    return a.first * b.first + a.second * b.second;
}

ld pi = acos(-1) / 2;

bool sharp(pair<int, int> a, pair<int, int> b, pair<int, int> c) {
    a.first -= b.first;
    a.second -= b.second;
    c.first -= b.first;
    c.second -= b.second;
    ld angle = atan2(mul1(a, c), mul2(a, c));
    //cout << angle << endc;
    return abs(angle) < pi;
}

inline void work() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<pair<int, int>> dots(n);
    for (int i = 0; i < n; ++i) cin >> dots[i].first >> dots[i].second;
    vector<int> perm(n);
    iota(perm.begin(), perm.end(), 0);
    if (task == 1 && group == 1) {
        for (int i = 0; i + 1 < n; i += 2) swap(perm[i], perm[i + 1]);
        for (int i = 0; i < n; ++i) cout << perm[i] + 1 << ' ';
        cout << endl;
    } else if (task == 1 && (group == 2 || group == 0)) {
        vector<vector<vector<bool>>> sharpness(n, vector<vector<bool>>(n, vector<bool>(n, false)));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                for (int k = 0; k < n; ++k) {
                    if (i == j || i == k || j == k) continue;
                    sharpness[i][j][k] = sharp(dots[i], dots[j], dots[k]);
                    //cout << i << ' ' << j << ' ' << k << ' ' << sharpness[i][j][k] << endc;
                }
            }
        }
        pair<int, vector<int>> bestAnswer = {-1, {}};
        do {
            int sc = 0;
            for (int i = 1; i < n-1; ++i) sc += sharpness[perm[i-1]][perm[i]][perm[i+1]];
            bestAnswer = max(bestAnswer, {sc, perm});
        } while (next_permutation(perm.begin(), perm.end()));
        for (int i = 0; i < n; ++i) cout << bestAnswer.second[i] + 1 << ' ';
        cout << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    srand(int(time(nullptr)));
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cout << sharp({0, 10}, {0, 0}, {10, 0}) << endc;
    while (t-- > 0) work();
}