#include <bits/stdc++.h>
using namespace std;

//#define endl '\n'
#define ff first
#define ss second
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;

const ll INF = 1e18 + 1;
const ll N = 5e4 + 1;
const ll MOD = 1e9 + 7;
vector <ll> ans;
ll best = 0;
vector <pair <ll, ll>> a;
ll n;

mt19937 rnd(24989142);

pair <ll, ll> vec(pair <ll, ll> a, pair <ll, ll> b){
    return {b.ff - a.ff, b.ss - a.ss};
}

ll operator * (pair <ll, ll> a, pair <ll, ll> b){
    return a.ff * b.ff + a.ss * b.ss;
}

void check(vector <ll> &p){
    ll cnt = 0;
    for (int i = 1; i < n - 1; i++){
        pair <ll, ll> v1 = vec(a[p[i]], a[p[i - 1]]);
        pair <ll, ll> v2 = vec(a[p[i]], a[p[i + 1]]);

        if (v1 * v2 > 0) cnt++;
    }

    if (cnt > best){
        ans = p;
        best = cnt;
    }
}

void solve(){
    ll task, group; cin >> task >> group;
    if (task != 1) return;

    cin >> n;
    a.assign(n, {0, 0});
    for (auto &x: a) cin >> x.ff >> x.ss;

    vector <ll> p(n);
    iota(all(p), 0);
    check(p);
    for (int i = 0; i < N; i++){
        random_shuffle(p.begin(), p.end());
        check(p);
    }

    //cout << best << endl;
    for (auto x: ans) cout << x + 1 << " "; cout << endl;
}

int main(){
    #ifdef LOCAL
        freopen("TASK.in", "r", stdin);
        freopen("TASK.out", "w", stdout);
    #endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
