#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdint>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <numbers>
#include <bit>
#include <random>

using namespace std;

#define int int64_t

using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;

struct pt {
    int x, y, ind;
    pt() {}
    pt(int _x, int _y) {
        x = _x, y = _y;
    }
    pt operator + (pt a) {
        return {a.x + x, a.y + y};
    }
    pt operator - (pt a) {
        return {x - a.x, y - a.y};
    }
    int operator * (pt a) {
        return x * a.x + y * a.y;
    }
};

mt19937 rnd(1);

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);




    int T, G;
    cin >> T >> G;
    int n;
    cin >> n;
    vector<pt> vec(n);
    for (int i = 0; i < n; i++) {
        cin >> vec[i].x >> vec[i].y;
        vec[i].ind = i;
    }


    if (n <= 10) {
        vector<int> p(n);
        for (int i = 0; i < n; i++) {
            p[i] = i;
        }
        int ans = 0;
        vector<int> ansp;
        do {
            vector<pt> cur;
            for (int i = 0; i < n; i++) {
                cur.push_back(vec[p[i]]);
            }
            int res = 0;
            for (int i = 1; i < n - 1; i++) {
                pt a = cur[i] - cur[i - 1], b = cur[i + 1] - cur[i];
                if (a * b < 0) {
                    res++;
                }
            }
            if (res > ans) {
                ansp = p;
                ans = res;
            }
        } while (next_permutation(p.begin(), p.end()));


        for (auto e: ansp) {
            cout << e + 1 << " ";
        }
        return 0;
    }
    if (G == 3 || G == 4) {
        sort(vec.begin(), vec.end(), [](auto a, auto b) {return a.x < b.x;});
        int st = rnd() % n;
        vector<pt> ans = {vec[st]};
        vec.erase(vec.begin() + st);
        st = rnd() % (n - 1);
        ans.push_back(vec[st]);
        vec.erase(vec.begin() + st);
        for (int i = 2; i < n; i++) {
            int cnt = 0, cur = -1;
            bool ok = false;
            do {
                cur = rnd() % vec.size();
                ok = (ans.back() - ans[ans.size() - 1]) * (vec[cur] - ans.back()) < 0;
                cnt++;
            } while (!ok && cnt < 1000);
            ans.push_back(vec[cur]);
            vec.erase(vec.begin() + cur);
        }
        for (auto e : ans) {
            cout << e.ind + 1 << " ";
        }
        return 0;
    }

    for (int i = 0; i < n / 2; i++) {
        cout << i + 1 << " " << n - i << " ";
    }
    if (n % 2 == 1) {
        cout << n / 2 + 1 << " ";
    }




    return 0;
}
