#include<bits/stdc++.h>
using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(rd());

const ll COL = 0;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

struct point {
	ll x, y, id;
	point(ll x = 0, ll y = 0): x(x), y(y) {}
	ll operator*(point p) {
		return x * p.x + y * p.y;
	}
	point operator-(point p) {
		return point(x - p.x, y - p.y);
	}
};

bool check(point p1, point p2) {
	return p1 * p2 > 0;
}

void solve() {
	ll t, g;
	cin >> t >> g;
	ll n;
	cin >> n;
	vector<point> arr(n);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i].x >> arr[i].y;
		arr[i].id = i;
	}
	shuffle(arr.begin(), arr.end(), rnd);
	if (t == 1) {
		ll vp = 2;
		while (vp < n) {
			bool b = false;
			for (ll j = vp; j < n; j++) {
				swap(arr[vp], arr[j]);
				if (check(arr[vp - 1] - arr[vp], arr[vp - 1] - arr[vp - 2])) {
					b = true;
					break;
				}
			}
			if (!b) {
				shuffle(arr.begin(), arr.end(), rnd);
				vp = 2;
				continue;
			}
			vp++;
		}
		for (auto i : arr) {
			cout << i.id + 1 << ' ';
		}
		cout << '\n';
		return;
	}
	ll c;
	cin >> c;
	ll q;
	ll nq;
	if (t == 2) {
		q = 1;
		nq = c;
	} else {
		cin >> q;
	}
	vector<point> best;
	ll cb = n;
	while (cb > c) {
		shuffle(arr.begin(), arr.end(), rnd);
		ll nc = 0;
		bool lt = false;
		for (ll i = 1; i + 1 < n; i++) {
			nc -= lt;
			lt = false;
			if (check(arr[i] - arr[i - 1], arr[i] - arr[i + 1])) {
				swap(arr[i], arr[i + 1]);
			}
			if (check(arr[i] - arr[i - 1], arr[i] - arr[i + 1])) {
				swap(arr[i], arr[i + 1]);
				lt = true;
				nc++;
			}
			if (i > 1 && check(arr[i - 1] - arr[i - 2], arr[i - 1] - arr[i])) {
				nc++;
			}
		}
		if (assign_min(cb, nc)) {
			best = arr;
		}
	}
	for (auto i : best) {
		cout << i.id + 1 << ' ';
	}
	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
