// #include <bits/stdc++.h>
#include <algorithm>
#include <cassert>
#include <cmath>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <unordered_map>
#include <vector>

using namespace std;
using ll = long long;


ll get(ll x, ll y, ll x1, ll y1){
    return (x - x1) * (x - x1) + (y - y1) * (y - y1);
}
bool check(ll a, ll b, ll c){
    return a + b - c > 0;
}

bool check(pair<ll, ll> a, pair<ll, ll> b, pair<ll, ll> c){
    ll a1 = get(a.first, a.second, b.first, b.second);
    ll b1 = get(c.first, c.second, b.first, b.second);
    ll c1 = get(a.first, a.second, c.first, c.second);
    return check(a1, b1, c1);
}

ll get(vector<pair<ll, ll>> &had, vector<ll> &p){
    ll ans = 0;
    for (int i = 1; i < p.size() - 1; i++){
        ans += check(had[p[i - 1]], had[p[i]], had[p[i + 1]]);
    }
    return ans;
}

mt19937  rd(228);
void solve() {
    ll t, g, n;
    cin >> t >> g >> n;
    vector<pair<ll, ll>> had(n);
    vector<ll> p ;
    for (int i = 0; i < n; i++){
        cin >> had[i].first >> had[i].second;
    }
    for (int i = 0; i < n / 2; i++){
        p.push_back(i);
        p.push_back(n - i  -1);
    }
    if (n % 2 == 1){
        p.push_back(n / 2);
    }
    pair<ll, vector<ll>> ans = {get(had, p), p};
    if (n <= 10){
        for (int j = 0; j < 1000000; j++){
            shuffle(p.begin(), p.end(), rd);
            ans = max(ans, {get(had, p), p});
        }
    }
    for (auto el : p){
        cout << el + 1 << " ";
    }
    cout << endl;
}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
