#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

using int64 = long long;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend

mt19937 rnd(228);
//mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct vec2 {
    int x, y;

    vec2(int x = 0, int y = 0) : x(x), y(y) {}

    vec2 operator-(const vec2& other) const {
        return vec2(x - other.x, y - other.y);
    }

    friend int dot(const vec2& a, const vec2& b) {
        return a.x * b.x + a.y * b.y;
    }
};

int group;

void solve1() {
    int n; cin >> n;
    vector <vec2> v(n);
    for (auto& [x, y] : v) cin >> x >> y;

    vector <int> ord;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= ord.size(); ++j) {
            bool flag = true;
            if (j >= 2 && dot(v[ord[j - 1]] - v[ord[j - 2]], v[i] - v[ord[j - 1]]) >= 0) flag = false;
            if (j >= 1 && j < ord.size() && dot(v[i] - v[ord[j - 1]], v[ord[j]] - v[i]) >= 0) flag = false;
            if (j + 1 < ord.size() && dot(v[ord[j]] - v[i], v[ord[j + 1]] - v[ord[j]]) >= 0) flag = false;

            if (flag) {
                ord.insert(ord.begin() + j, i);
                break;
            }
        }
    }

    for (auto x : ord) cout << x + 1 << ' ';
}

void solve2() {
    int n; cin >> n;
    vector <vec2> v(n);
    for (auto& [x, y] : v) cin >> x >> y;
    int c; cin >> c;

    vector <int> ord;
    for (int i = 0; i < n; ++i) {
        bool flag1 = false;
        for (int j = 0; j <= ord.size(); ++j) {
            bool flag = true;
            if (j >= 2 && dot(v[ord[j - 1]] - v[ord[j - 2]], v[i] - v[ord[j - 1]]) < 0) flag = false;
            if (j >= 1 && j < ord.size() && dot(v[i] - v[ord[j - 1]], v[ord[j]] - v[i]) < 0) flag = false;
            if (j + 1 < ord.size() && dot(v[ord[j]] - v[i], v[ord[j + 1]] - v[ord[j]]) < 0) flag = false;

            if (flag) {
                ord.insert(ord.begin() + j, i);
                flag1 = true;
                break;
            }
        }

        if (!flag1) ord.push_back(i);
    }

    for (auto x : ord) cout << x + 1 << ' ';
}

void solve3() {

}

void solve4() {

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int task; cin >> task >> group;

    if (task == 1) solve1();
    if (task == 2) solve2();
    if (task == 3) solve3();
    if (task == 4) solve4();

    return 0;
}
