#include <bits/stdc++.h>
#define int long long
typedef long long ll;
typedef __int128 ull;
using namespace std;

struct point{
    int x, y;

    point (int _x, int _y) {
        x = _x;
        y = _y;
    }

    int scal(point b) {
        return x * b.x + y * b.y;
    }
};

vector<point> v;
int n;

void task1() {
    vector<int> ord={0, 1};
    for (int i = 2; i < n; i++) {

        ord.push_back(i);
//       cout << v1.x << " " << v1.y << " " << v2.x << " " << v2.y << endl;
//       cout << v1.scal(v2) << endl;
        for (int j = i; j >= 2; j--) {
            int a = ord[j - 2];
            int b = ord[j - 1];
            int c = ord[j];
            point v1 = {v[c].x - v[b].x, v[c].y - v[b].y};
            point v2 = {v[a].x - v[b].x, v[a].y - v[b].y};
            if (v1.scal(v2) <= 0) {
                swap(ord[j], ord[j - 1]);
            }
        }

    }

    for (int i : ord) {
        cout << i + 1 << " ";
    }
    cout << endl;
}

mt19937 mt1(1329);

int check(int ind, vector<int> &ord) {
    if (ind <= 0 || ind >= n - 1) return 0;
    int a = ord[ind - 1];
    int b = ord[ind];
    int c = ord[ind + 1];
    point v1 = {v[c].x - v[b].x, v[c].y - v[b].y};
    point v2 = {v[a].x - v[b].x, v[a].y - v[b].y};
    return v1.scal(v2) > 0;
}

void task2() {
    int C;
    cin >> C;
    vector<int> ord;
    for (int i = 0; i < n; i++) {
        ord.push_back(i);
    }
    shuffle(ord.begin(), ord.end(), mt1);
    int cnt = 0;

    vector<int> res(n);
    for (int i = 0; i < n; i++) {
        res[i] = check(i, ord);
        cnt += res[i];
    }
    while (cnt > C) {
        int a = mt1() % n, b = mt1() % n;
        swap(ord[a], ord[b]);

        int new_cnt = cnt;
        for (int i = a - 1; i <= a + 1; i++) {
            if (i < 0 || i >= n) continue;
            new_cnt += check(i, ord) - res[i];
        }

        for (int i = b - 1; i <= b + 1; i++) {
            if (i < 0 || i >= n) continue;
            new_cnt += check(i, ord) - res[i];
        }
        int z = mt1() % 100;
        if (new_cnt < cnt || z % 20 == 0) {
            for (int i = a - 1; i <= a + 1; i++) {
                if (i < 0 || i >= n) continue;
                res[i] = check(i, ord);
            }

            for (int i = b - 1; i <= b + 1; i++) {
                if (i < 0 || i >= n) continue;
                res[i]= check(i, ord);
            }
            cnt = new_cnt;
        } else {
            swap(ord[a], ord[b]);
        }
    }

    for (int i : ord) {
        cout << i + 1 << " ";
    }
    cout << endl;
}

void solve() {
   int task, group;
   cin >> task >> group;

   cin >> n;
   v.resize(n, {0, 0});
   for (int i = 0; i < n; i++) {
       cin >> v[i].x >> v[i].y;
   }

   if (task == 1) task1();
   else if (task == 2) task2();
   else {
       exit(1);
   }

}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}
