#include <iostream>
#include <vector>

#pragma target('avx2')
#pragma target('O3')

#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

int n;
vector<pair<int, int>> A;

void solve() {
    int l = 1, r = n;
    for (int i = 0; i < n; i++) {
        if (i % 2 == 0) {
            cout << r << ' ';
            r--;
        } else {
            cout << l << ' ';
            l++;
        }
    }
    cout << endl;
}

void solve1(int c) {
    int l = 1, r = c + 2;
    for (int i = n; i >= c + 3; i--){
        cout << i << ' ';
    }
    for (int i = 0; i < c + 2; i++) {
        if (i % 2 == 0) {
            cout << r << ' ';
            r--;
        } else {
            cout << l << ' ';
            l++;
        }
    }
    cout << endl;
}

int main() {
    int task, group;
    cin >> task >> group;
    cin >> n;
    A.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i].first >> A[i].second;
    }
    if (task == 1 and group == 1) {
        solve();
    }else if (task == 3 and group == 7){
        int c;
        cin >> c;
        int q;
        cin >> q;
        for (int i = 0; i < q; i++){
            int k;
            cin >> k;
            solve1(k);
        }
    }
}
