//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <vector>
#include <deque>
#include <ctime>
#include <unordered_set>
#include <iomanip>
#include <algorithm>
using namespace std;
#define double long double
#define int long long
#define ll long long
#define debug(x) cerr << (#x) << ": " << x << endl;
#define get_time (double)(clock()) / (double)(CLOCKS_PER_SEC)
const int INF = 1e18 + 7;
const int mod = 1e9 + 7;
const int MAXN = 2e5 + 10;
//#pragma GCC optimize("avx2")
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
int make_add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
int mul(int a, int b) {
    return (a * b) % mod;
}
struct point {
    int x, y, i;
};
point make_vector_from_two_point(point a, point b) {
    return { b.x - a.x, b.y - a.y };
}
int scalar_mul(point a, point b) {
    return a.x * b.x + a.y * b.y;
}
const int B = 1000;
int best = -1;
int task, group, n, q;
vector<point> points;
vector<int> p, used(1e5, 0), out;
void ask(vector<int> x) {
    for (auto c : x) cout << c + 1 << " ";
    cout << endl;
}
int make_cnt(vector<int> p, int k) {
    int res = 0;
    for (int i = 1; i < n - 1; i++) {
        point ab = make_vector_from_two_point(points[p[i]], points[p[i - 1]]), ac = make_vector_from_two_point(points[p[i]], points[p[i + 1]]);
        int sc = scalar_mul(ab, ac);
        if (sc > 0) res++;
        if (res > k) return -1;
    }
    return res;
}
void perebor() {
    if (p.size() == n) {
        int res = make_cnt(p, INF);
        if (res > best) {
            best = res;
            out = p;
        }
    }
    else {
        for (int i = 0; i < n; i++) {
            if (used[i]) continue;
            p.push_back(i);
            used[i] = 1;
            perebor();
            used[i] = 0;
            p.pop_back();
        }
    }
}
void solve_task_1() {
    if (n <= 1) {
        perebor();
        ask(out);
        return;
    }
    while (true) {
        out.clear();
        random_shuffle(points.begin(), points.end());
        used = vector<int>(n, 0);
        out.push_back(0);
        out.push_back(1);
        used[0] = 1;
        used[1] = 1;
        for (int it = 2; it < n; it++) {
            for (int i = 0; i < n; i++) {
                if (used[i]) continue;
                point ab = make_vector_from_two_point(points[out.back()], points[out[out.size() - 2]]);
                point ac = make_vector_from_two_point(points[out.back()], points[i]);
                int sc = scalar_mul(ab, ac);
                if (sc > 0) {
                    used[i] = 1;
                    out.push_back(i);
                    break;
                }
            }
        }
        if (out.size() == n) break;
    }
    for (int i = 0; i < n; i++) {
        out[i] = points[out[i]].i;
    }
    if (task == 1) {
        ask(out);
        return;
    }
    int c, q;
    cin >> c >> q;
    for (int it = 0; it < q; it++) {
        int k;
        cin >> k;
        vector<int> lol, out;
        while (true) {
            out.clear();
            random_shuffle(points.begin(), points.end());
            used = vector<int>(n, 0);
            out.push_back(0);
            out.push_back(1);
            used[0] = 1;
            used[1] = 1;
            int cnt = 0, check_fl = 0;
            for (int it = 2; it < n; it++) {
                int fl = 0, fl_good = 0;
                for (int i = 0; i < n; i++) {
                    if (used[i]) continue;
                    point ab = make_vector_from_two_point(points[out.back()], points[out[out.size() - 2]]);
                    point ac = make_vector_from_two_point(points[out.back()], points[i]);
                    int sc = scalar_mul(ab, ac);
                    if (sc > 0 && cnt < k) {
                        used[i] = 1;
                        out.push_back(i);
                        cnt++;
                        fl_good = 1;
                        break;
                    } else if (sc <= 0 && cnt == k) {
                        used[i] = 1;
                        out.push_back(i); 
                        fl = 1;
                        break;
                    } 
                }
                if (check_fl && !fl) break;
                if (cnt < k && fl_good == 0) break;
                if (cnt == k) check_fl = 1;
            }
            if (out.size() == n) break;
        }
        for (int i = 0; i < n; i++) {
            out[i] = points[out[i]].i;
        }
        ask(out);
    }
}
void solve_g_1_7() {
    vector<int> ans;
    ans.push_back(0);
    int i = 1;
    while (i + 1 < n) {
        ans.push_back(i + 1);
        ans.push_back(i);
        i += 2;
    }
    if (n % 2 == 0) ans.push_back(n - 1);
    if (task == 1) {
        ask(ans);
        return;
    }
    int c;
    cin >> c;
    ans.clear(); for (int i = 0; i < n; i++) ans.push_back(i);
   // ask(ans); 
    cin >> q;
    for (int it = 0; it < q; it++) {
        int k;
        cin >> k;
        ans.clear();
        int ind = 0, must_p = n - k - 1;
        for (int i = 0; i < must_p; i++) {
            ans.push_back(i);
            ind++;
        }
        int i = ind;
        while (i + 1 < n) {
            ans.push_back(i + 1);
            ans.push_back(i);
            i += 2;
        }
        if (i == n - 1) ans.push_back(n - 1);
        ask(ans);
    }
}
void solve() {
    cin >> task >> group >> n;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        points.push_back({ x, y, i });
    }
    if (group == 1 || group == 7) {
        solve_g_1_7();
    } else {
        solve_task_1();
    }
}
signed main() {
    cout << fixed << setprecision(20);
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
/*
3 1 5
1 2
2 5
4 6
7 8
9 11
*/