#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,bmi,bmi2,lzcnt,popcnt")

#define endl '\n'
#define F first
#define S second

typedef long long ll;
using namespace std;
using namespace __gnu_pbds;

mt19937 rng(time(nullptr));
mt19937_64 rngl(time(nullptr));
ll rnd(ll x) {
    uniform_int_distribution<ll>uid(0, x - 1);
    return uid(rngl);
}
int rnd(int x) {
    uniform_int_distribution<int>uid(0, x - 1);
    return uid(rng);
}

struct Point {
    ll x, y;
    explicit Point(ll x = 0, ll y = 0) : x(x), y(y) {}
    void in() {
        cin >> x >> y;
    }
    ll operator*(Point& other) {
        return x * other.x + y * other.y;
    }
    ll operator%(Point& other) {
        return x * other.y - y * other.x;
    }
};

int n;
Point p[80010];

vector <int> ans, s;
int ans_c = -1;

bool f(Point& p1, Point& p2, Point& p3) {
    Point v1(p1.x - p2.x, p1.y - p2.y);
    Point v2(p3.x - p2.x, p3.y - p2.y);
    return v1 * v2 > 0;
}

bool get_f(int i) {
    if (i + 2 >= n || i < 0)
        return false;
    return f(p[s[i]], p[s[i + 1]], p[s[i + 2]]);
}

int get() {
    int cnt = 0;
    for (int i = 0; i + 2 < n; i++)
        cnt += get_f(i);
    return cnt;
}

void solve() {
    int test, group;
    cin >> test >> group;
    if (test == 1 || test == 2) {
        cin >> n;
        for (int i = 0; i < n; i++)
            p[i].in();
        for (int i = 0; i < n; i++)
            s.push_back(i);
        for (int _ = 0; _ < 50; _++) {
            shuffle(s.begin(), s.end(), rng);
            int now = get();
            for (int q = 0; q < 500000; q++) {
                int i1 = rnd(n - 1), i2 = rnd(n - 1);
                while (i1 == i2)
                    i2 = rnd(n - 1);
                if (i1 > i2)
                    swap(i1, i2);

                int now1 = now;

                int j = i1 - 2;
                for (; j <= i1; j++)
                    now1 -= get_f(j);
                for (j = max(j, i2 - 2); j <= i2; j++)
                    now1 -= get_f(j);

                swap(s[i1], s[i2]);

                j = i1 - 2;
                for (; j <= i1; j++)
                    now1 += get_f(j);
                for (j = max(j, i2 - 2); j <= i2; j++)
                    now1 += get_f(j);

                if (now1 > now)
                    now = now1;
                else
                    swap(s[i1], s[i2]);
                if (now > ans_c) {
                    ans_c = now;
                    ans = s;
                }
            }
        }
        for (auto &i: ans)
            cout << i + 1 << ' ';
        cout << endl;
        cerr << ans_c << endl;
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll start = time(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    ll end = time(nullptr);
    cerr << "Ulyanovsk is the best!!!" << endl;
    cerr << "Execution time: " << end - start << " ms" << endl;
}
