#include <bits/stdc++.h>

#define ll long long
#define all(x) x.begin(), x.end()
#define fi first
#define se second
#define ve vector

using namespace std;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int MAXN = 256, MAXW = 512, MAXN2 = 2048, MAXW2 = 3;

#pragma GCC optimize("Ofast")

ll dp[MAXN][MAXN][MAXW][2];
ll dp2[MAXN2][MAXN2][MAXW2][2];


struct point{
    ll x, y;
    int id;
};

ll dstsq(point p1, point p2){
    return (p1.x - p2.x)*(p1.x - p2.x) + (p1.y - p2.y)*(p1.y - p2.y);
}

bool prov(point a, point b, point c){
    ll la = dstsq(b, c);
    ll lb = dstsq(a, c);
    ll lc = dstsq(a, b);
    return la + lc > lb;
}

inline bool operator <(const point& p1, const point& p2){
    if(p1.x != p2.x)
        return p1.x < p2.x;
    if(p1.y != p2.y)
        return p1.y < p2.y;
    return p1.id < p2.id;
}

int main() {
    int task, group;
    cin >> task >> group;
    if(task == 1){
        int n;
        cin >> n;
        ve<point> v(n);
        for(int i = 0; i < n; i++){
            cin >> v[i].x >> v[i].y;
            v[i].id = i + 1;
        }
        if(group != 1)
            random_shuffle(all(v));
        ve<point> res;
        res = {v[0], v[1]};
        for(int i = 2; i < n; i++){
            if(prov(v[i], res[0], res[1])){
                res.insert(res.begin(), v[i]);
            }
            else if(prov(res[i - 2], res[i - 1], v[i]))
                res.push_back(v[i]);
            else{
                for(int j = 1; j < res.size(); j++)
                    if(prov(res[j - 1], v[i], res[j]) && (j == 1 || prov(res[j - 2], res[j - 1], v[i])) && (j == i - 1 || prov(v[i], res[j], res[j + 1]))){
                        res.insert(res.begin() + j, v[i]);
                        break;
                    }
            }
        }
        assert(res.size() == n);
        for(auto i : res)
            cout << i.id << " ";
    }
    if(task == 2){
        int n;
        cin >> n;
        ve<point> v(n);
        for(int i = 0; i < n; i++){
            cin >> v[i].x >> v[i].y;
            v[i].id = i + 1;
        }
        int c;
        cin >> c;
        sort(all(v));
        point cur = v[0], prev;
        cout << v[0].id << " ";
        ve<bool> del(n,0);
        del[0] = 1;
        while(del != ve<bool>(n, 1)){
            for(int i = 0; i < n; i++)
                if(!del[i]){
                    del[i] = 1;
                    cout << v[i].id << " ";
                    prev = cur;
                    cur = v[i];
                    break;
                }
            for(int i = 0; i < n; i++)
                if(!del[i] && !prov(prev, cur, v[i])){
                    del[i] = 1;
                    cout << v[i].id << " ";
                    prev = cur;
                    cur = v[i];
                }
        }
        for(int i = 0; i < n; i++)
            if(!del[i])
                return -1;
    }
    if(task == 3){
        int n;
        cin >> n;
        ve<point> v(n);
        for(int i = 0; i < n; i++){
            cin >> v[i].x >> v[i].y;
            v[i].id = i + 1;
        }
        int c;
        cin >> c;
        int q;
        cin >> q;
        while(q--){
            cin >> c;
            int cnt = 0;
            ve<point> res;
            while(cnt != c){
                random_shuffle(all(v));
                cnt = 0;
                for(int i = 2; i < n ;i++)
                    cnt += prov(v[i - 2], v[i - 1], v[i]);
            }
            for(auto i : v)
                cout << i.id << " ";
        }
        return 0;
    }
}
