#include <bits/stdc++.h>
#define int long long

/* Using libraries */
using namespace std;

using ld = long double;
template <class T>
using vc = vector <T>;
using pii = pair <int, int>;
using pint = pair <int, int>;
template <class T>
int sz(vc <T> &a) {
    return (int)a.size();
}
int sz(string &a) {
    return (int)a.size();
}

template<class T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e18;
template<class T>
bool chmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
const int N = 2e5 + 100;
vc <vc <int>> g[N];
vc <int> c[N];
pii top[N];
int pr[N];
int dfs (int u, int p = -1) {
    vc <pii> b;
    for (int i = 0; i < c[u].size(); ++i)
        b.push_back({c[u][i], i});
    sort(b.begin(), b.end());
    vc <pii> tt;
    for (auto e : g[u]) {
        int v = e[0], w = e[1], i = e[2];
        if (v == p)
            continue;
        pr[v] = u;
        int ost = dfs(v, u);
        tt.push_back({w - ost, v});
    }
    sort(tt.begin(), tt.end());
    int j = 0;
    vc <int> cur;
    vc <pii> ost;
    for (int i = 0; i < b.size(); ++i) {
        while (j < tt.size() && tt[j].first <= b[i].first) {
            cur.push_back(tt[j].second);
            ++j;
        }
        if (!cur.empty()) {
            top[cur.back()].first = b[i].second;
            cur.pop_back();
        } else {
            ost.push_back(b[i]);
        }
    }
    if (ost.size() > 1 - (u == 0)) {
        cout << "No\n";
        exit(0);
    }
    if (u != 0) {
        top[u].second = ost[0].second;
        return ost[0].first;
    }
    return -1;
}

void solve() {
    int n, task, group;
    cin >> task >> group >> n;
    assert(task <= 2);
    vc <pii> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    vc <int> p(n); iota(p.begin(), p.end(), 0);
    sort(p.begin(), p.end(), [&](int i, int j) {
        return a[i] < a[j];
    });
    vc <int> res = {p[0] + 1};
    int j = p[0];
    vc <int> used(n);
    set <int> in;
    for (int i = 0; i < n; ++i)
        in.insert(i);
    for (int len = 1; len < n; ++len) {
        in.erase(j);
        int dist = 0;
        int k = -1;
        for (int i : in) {
            int xx = a[j].first - a[i].first;
            int yy = a[j].second - a[i].second;
            if (chmax(dist, xx * xx + yy * yy))
                k = i;
        }
        res.push_back(p[k] + 1);
        j = k;
    }
    for (int i : res)
        cout << i << ' ';
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}
//set PATH=%PATH%;C:\mingw64\bin