//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt,fma")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const long long RANDOM = chrono::high_resolution_clock::now().time_since_epoch().count();
constexpr int MAXN = 1 << 20;
constexpr long long mod = 1e9 + 7;
mt19937 rnd(RANDOM);

struct point {
    ll x, y;

    point() {
        x = 0, y = 0;
    }

    point(ll _x, ll _y) {
        x = _x, y = _y;
    }

    const ll operator%(const point &other) {
        return x * other.y - y * other.x;
    }

    const ll operator*(const point &other) {
        return x * other.x + y * other.y;
    }
};

void solve() {
    int xr1, xr2;
    cin >> xr1 >> xr2;
    int n;
    cin >> n;
    vector<point> a(n);
    for (auto &i: a) {
        cin >> i.x >> i.y;
    }
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        p[i] = i;
    }
    ll mx = 0;
    vector<int> ans;
    for (int _ = 0; _ < 5000; _++) {
        ll cur = 0;
        for (int i = 1; i < n - 1; i++) {
            point p1 = point(a[p[i - 1]].x - a[p[i]].x, a[p[i - 1]].y - a[p[i]].y);
            point p2 = point(a[p[i + 1]].x - a[p[i]].x, a[p[i + 1]].y - a[p[i]].y);
            ld cur1 = atan2(abs(p1 % p2), p1 * p2);
            if (abs(cur1) < atan2(1, 0)) {
                cur++;
            }
        }
        if (cur > mx) {
            mx = cur;
            ans = p;
        }
        std::next_permutation(p.begin(), p.end());
    }
    for (auto i: ans) {
        cout << i + 1 << ' ';
    }
    cout << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
    //    cin>>q;
    while (q--) {
        solve();
    }
}
