#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
//#define endl '\n'

typedef long long ll;
typedef long double ld;

typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 1e18 + 1;
const int MOD = 1e9 + 7;

mt19937 rnd(time(0));

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector <vector <vector <int>>> sm;

int dist(pair <int, int> a, pair <int, int> b){
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

signed main() {
    //Fast();
    int task, g;
    cin >> task >> g;
    if (g < 6) {
        int n;
        cin >> n;
        vector <pair <int, int>> p(n);
        for (int i = 0; i < n; i++){
            cin >> p[i].first >> p[i].second;
        }
        int cur = 0;
        vector <bool> used(n);
        vector <int> ans;
        for (int _ = 0; _ < n - 1; _++){
            used[cur] = true;
            ans.push_back(cur + 1);
            int to = cur, h = 0;
            for (int i = 0; i < n; i++){
                if (dist(p[cur], p[i]) > h && !used[i]){
                    h = dist(p[cur], p[i]);
                    to = i;
                }
            }
            cur = to;
        }
        ans.push_back(cur + 1);
        for (int i = 0; i < n; i++){
            cout << ans[i] << " ";
        }
        cout.flush();
        return 0;
    }
    int n;
    cin >> n;
    vector <pair <int, int>> p(n);
    for (int i = 0; i < n; i++){
        cin >> p[i].first >> p[i].second;
    }
    int c;
    cin >> c;
    int cur = 0;
    vector <bool> used(n);
    vector <int> ans;
    for (int _ = 0; _ < n - 1; _++){
        used[cur] = true;
        ans.push_back(cur + 1);
        int to = cur, h = INF;
        for (int i = 0; i < n; i++){
            if (dist(p[cur], p[i]) < h && !used[i]){
                h = dist(p[cur], p[i]);
                to = i;
            }
        }
        cur = to;
    }
    ans.push_back(cur + 1);
    for (int i = 0; i < n; i++){
        cout << ans[i] << " ";
    }
    cout.flush();
    return 0;
}
