#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
//#define endl '\n'

typedef long long ll;
typedef long double ld;

typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 1e18 + 1;
const int MOD = 1e9 + 7;

mt19937 rnd(time(0));

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector <vector <vector <int>>> sm;

int dist(pair <int, int> a, pair <int, int> b){
    return (a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second);
}

signed main() {
    //Fast();
    int task, g;
    cin >> task >> g;
    if (g < 6) {
        int n;
        cin >> n;
        vector <pair <int, int>> p(n);
        for (int i = 0; i < n; i++){
            cin >> p[i].first >> p[i].second;
        }
        int cur = 0;
        vector <bool> used(n);
        vector <int> ans;
        for (int _ = 0; _ < n - 1; _++){
            used[cur] = true;
            ans.push_back(cur + 1);
            int to = cur, h = 0;
            for (int i = 0; i < n; i++){
                if (dist(p[cur], p[i]) > h && !used[i]){
                    h = dist(p[cur], p[i]);
                    to = i;
                }
            }
            cur = to;
        }
        ans.push_back(cur + 1);
        for (int i = 0; i < n; i++){
            cout << ans[i] << " ";
        }
        cout.flush();
        return 0;
    }
    int n;
    cin >> n;
    vector <pair <int, int>> p(n);
    for (int i = 0; i < n; i++){
        cin >> p[i].first >> p[i].second;
    }
    int c;
    cin >> c;
    vector <int> ans;
    int e = 0;
    for (int i = 0; i < n; i++){
        ans.push_back(i);
    }
    for (int i = 2; i < n - 1; i++){
        pair <int, int> a = {p[i - 1].first - p[i].first, p[i - 1].second - p[i].second};
        pair <int, int> b = {p[i + 1].first - p[i].first, p[i + 1].second - p[i].second};
        int k = a.first * b.first + b.second * a.second;
        if (k > 0)
            e++;
    }
    ld t = 1;
    for (int _ = 0; _ < 1000; _++){
        int l = rnd() % n;
        int r = rnd() % (n - l) + l;
        vector <int> g = ans;
        reverse(g.begin() + l, g.begin() + r);
        int o = 0;
        for (int i = 2; i < n - 1; i++){
            pair <int, int> a = {p[g[i - 1]].first - p[g[i]].first, p[g[i - 1]].second - p[i].second};
            pair <int, int> b = {p[g[i + 1]].first - p[g[i]].first, p[g[i + 1]].second - p[g[i]].second};
            int k = a.first * b.first + b.second * a.second;
            if (k > 0)
                o++;
        }
        if (o < e || exp(e - o) < ((ld)rand() / RAND_MAX) * t)
            swap(ans, g);
        t *= 0.1;
    }
//    cout << rand() << endl;
    for (auto i:ans)
        cout << i + 1 << " ";
    return 0;
}
