#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

struct Point {
    ll x, y;
    int id;

    Point(ll x, ll y, int id) : x(x), y(y), id(id) {}
};

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<Point> pts;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        pts.emplace_back(x, y, i);
    }
    if (task == 1 && group == 1) {
        for (int i = 0; i < n; ++i) {
            if (i % 2 == 0) {
                cout << min(n, i + 2) << ' ';
            } else {
                cout << i << ' ';
            }
        }
    } else if (task == 2 && group == 6) {
        /*int c;
        cin >> c;
        for (int i = 0; i < n; ++i) {
            cout << i + 1 << ' ';
        }
        cout.flush();*/
    } else if (task == 3 && group == 7) {
        int c;
        cin >> c;
        int q;
        cin >> q;
        while (q--) {
            int k;
            cin >> k;
            for (int i = 0; i < n - k - 1; ++i) {
                cout << i + 1 << ' ';
            }
            for (int i = n - k - 1; i < n; ++i) {
                if (i % 2 == (n - k - 1) % 2) {
                    cout << min(n, i + 2) << ' ';
                } else {
                    cout << i << ' ';
                }
            }
            cout << endl;
            cout.flush();
        }
    }
}