#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define dbg(a) cout << #a << " = " << a << endl;
#define dbg1(a) cout << #a << " = "; for (auto i : a) cout << i << ' '; cout << endl;
#define dbg2(a) cout << #a << " = "; for (auto [x, y] : a) cout << "{ " << x << ' ' << y << "} "; cout << endl;

const int INF = 1e9 + 7;
const int mod = 1e9 + 7;

int n;
const int N = 8e4 + 3;

struct Point {
    int x, y, ind;
};

Point pts[N];

void solve() {
    int task, gr;
    cin >> task >> gr >> n;

    for (int i = 0; i < n; i++) {
        cin >> pts[i].x >> pts[i].y;
        pts[i].ind = i;
    }

    sort(pts, pts + n, [&](Point a, Point b) {
        return a.x < b.x;
    });

    vector<int> p;
    int c = 0;
    int j = n - 1, i = 0;
    while (i <= j) {
        if (c == 0) p.emplace_back(pts[i++].ind);
        else p.emplace_back(pts[j--].ind);
        c ^= 1;
    }

    for (auto a : p) cout << a + 1 << ' ';
    cout << endl;
}

int main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
