#include <bits/stdc++.h>

using namespace std;

using ll = long long;

mt19937 rnd(time(0));

struct point {
    ll x, y;
};

ll dp(point a, point b){
    return a.x * b.x + a.y * b.y;
}

bool check(point a, point b, point c){
    point d = {a.x - b.x, a.y - b.y}, e = {c.x - b.x, c.y - b.y};
    if(dp(d, e) > 0){
        return true;
    } else {
        return false;
    }
}

ll cp(point a, point b){
    return a.x * b.y - a.y * b.x;
}

ll len(point a){
    return a.x * a.x + a.y * a.y;
}

point mn;

bool cmp(const point& a, const point& b){
    point c = {a.x - mn.x, a.y - mn.y};
    point d = {b.x - mn.x, b.y - mn.y};
    if(cp(c, d) == 0){
        return len(c) < len(d);
    }
    return cp(c, d) > 0;
}

void solve(){
    ll task, group;
    cin >> task >> group;
    ll n, fl = true;
    cin >> n;
    vector<point> a(n);
    for(ll i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        if(i > 0 && (a[i].x <= a[i - 1].x || a[i].y <= a[i - 1].y)){
            fl = false;
        }
    }
    if(fl && task == 1){
        ll l = 1, r = n;
        for(ll i = 1; i <= n; i++){
            if(i % 2){
                cout << l << ' ';
                l++;
            } else {
                cout << r << ' ';
                r--;
            }
        }
        return;
    }
    ll ans = 0;
    vector<ll> best;
    for(ll it = 0; it < (ll)1e2; it++){
        ll f = rnd() % n, s = rnd() % n;
        if(f != s){
            vector<ll> used(n);
            used[f] = true;
            used[s] = true;
            ll cnt = 0;
            vector<ll> cur;
            cur.push_back(f), cur.push_back(s);
            for(ll i = 0; i < n - 2; i++){
                bool flag = false;
                for(ll j = 0; j < n; j++){
                    if(!used[j] && check(a[f], a[s], a[j])){
                        cnt++;
                        f = s;
                        s = j;
                        cur.push_back(j);
                        flag = true;
                        break;
                    }
                }
                if(!flag){
                    for(ll j = 0; j < n; j++){
                        if(!used[j]){
                            f = s;
                            s = j;
                            cur.push_back(j);
                            break;
                        }
                    }
                }
            }
            if(cnt > ans){
                ans = cnt;
                best = cur;
            }
        }
    }
    for(auto u : best){
        cout << u + 1 << ' ';
    }

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
