#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Vector {
    int x, y;

    Vector operator-(const Vector& b) const {
        return { b.x - x, b.y - y };
    }

    int operator%(const Vector& b) const {
        return x * b.x + y * b.y;
    }

    bool operator<(const Vector& b) const {
        if (x == b.x)
            return y < b.y;
        return x < b.x;
    }
};

using Point = Vector;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int task, gr;
    cin >> task >> gr;
    int n;
    cin >> n;
    vector<Point> pts(n);
    for (auto& [x, y] : pts)
        cin >> x >> y;
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int a, int b) {
        return pts[a].x < pts[b].x;
        });
    if (task == 1) {
        for (int i = 0; i < n / 2; i++)
            cout << ord[i] + 1 << ' ' << ord[n - i - 1] + 1 << ' ';
        if (n % 2)
            cout << ord[n / 2] + 1;
        return 0;
    }
}