#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree < int, null_type, less < int >, rb_tree_tag, tree_order_statistics_node_update > oset;

mt19937 gen(time(0));

#define pb push_back
#define pii pair < int, int >
#define F first
#define S second
#define endl '\n'
#define int long long

const int N = 600001;
const int mod = 1000000007;
const int INF = 1e18+3;

int p[N], ans[N], best = -1, x[N], y[N], task, n;
int ans_task3[2001][2001];
bool fl[N];

double rnd_dbl()
{
    return (double)(gen() % INT_MAX) / (double)INT_MAX;
}

int cnt_ans()
{
    int cur = 0;
    for (int i = 2; i < n; i++)
    {
        int r1 = (x[p[i - 2]] - x[p[i - 1]]) * (x[p[i - 2]] - x[p[i - 1]]) + (y[p[i - 2]] - y[p[i - 1]]) * (y[p[i - 2]] - y[p[i - 1]]);
        int r2 = (x[p[i - 1]] - x[p[i]]) * (x[p[i - 1]] - x[p[i]]) + (y[p[i - 1]] - y[p[i]]) * (y[p[i - 1]] - y[p[i]]);
        int r3 = (x[p[i - 2]] - x[p[i]]) * (x[p[i - 2]] - x[p[i]]) + (y[p[i - 2]] - y[p[i]]) * (y[p[i - 2]] - y[p[i]]);
        if (r1 + r2 > r3) cur++;
    }
    if ((task == 1) == (best < cur))
    {
        cerr << cur << endl;
        best = cur;
        for (int i = 0; i < n; i++)
            ans[i] = p[i];
    }
    return cur;
}

void solve()
{
    int group, c;
    cin >> task >> group >> n;
    for (int i = 0; i < n; i++)
        cin >> x[i] >> y[i];
    if (group == 1)
    {
        for (int i = 0; i < (n + 1) / 2; i++)
        {
            cout << i + 1 << ' ';
            if (n - i != i + 1) cout << n - i << ' ';
        }
        exit(0);
    }
    if (group == 7)
    {
        cin >> c;
        int q;
        cin >> q;
        while (q--)
        {
            int k;
            cin >> k;
            int n1 = n - (n - 2 - k);
            for (int i = 0; i < (n1 + 1) / 2; i++)
            {
                cout << i + 1 << ' ';
                if (n1 - i != i + 1) cout << n1 - i << ' ';
                if (i == 0)
                {
                    for (int i = n1; i < n; i++)
                        cout << i + 1 << ' ';
                }
            }
            cout << endl;
        }
        return;
    }
    if (task <= 2)
    {
        if (task == 2) best = INF;
        for (int i = 0; i < n; i++)
            p[i] = i;
        int prev = cnt_ans();
        int timer = clock();
        double T = 1.0;
        while ((double)(clock() - timer) / (double)CLOCKS_PER_SEC < 1.9)
        {
            T *= 0.9999;
            random_shuffle(p, p + n);
            int nw = cnt_ans();
        }
        for (int i = 0; i < n; i++)
            cout << ans[i] + 1 << ' ';
        cout << endl;
    }
    if (task == 3)
    {
        for (int i = 0; i < n; i++)
            p[i] = i;
        int timer = clock();
        while ((double)(clock() - timer) / (double)CLOCKS_PER_SEC < 0.95)
        {
            random_shuffle(p, p + n);
            int nw = cnt_ans();
            if (fl[nw] == 0)
            {
                fl[nw] = 1;
                for (int i = 0; i < n; i++)
                    ans_task3[nw][i] = p[i];
            }
        }
        int q;
        cin >> c >> q;
        while (q--)
        {
            int k;
            cin >> k;
            for (int i = 0; i < n; i++)
                cout << ans_task3[k][i] + 1 << ' ';
            cout << endl;
        }
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int t;
    t = 1;
    while (t--)
        solve();
}
