#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18;

struct Point {
    ll x, y;

    Point() : x(0), y(0) {}

    Point(ll _x, ll _y) : x(_x), y(_y) {}

    Point operator+(const Point& other) {
        return Point(x + other.x, y + other.y);
    }

    ll operator*(const Point& other) {
        return x * other.x + y * other.y;
    }
};

void solve1() {
    int n;
    cin >> n;
    vector<Point> points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }
    for (int i = 0; i < n; ++i) {
        cout << i + 1 << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(16);

    int t = 1;
    // cin >> t;
    while (t--) {
        int task, g;
        cin >> task >> g;

        if (task == 1) {
            solve1();
        }
    }
    return 0;
}
