#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const ll INF = 1e18;

struct Point {
    ll x, y;

    Point() : x(0), y(0) {}

    Point(ll _x, ll _y) : x(_x), y(_y) {}

    Point operator+(const Point& other) {
        return Point(x + other.x, y + other.y);
    }

    ll operator*(const Point& other) {
        return x * other.x + y * other.y;
    }
};

void solve1() {
    int n;
    cin >> n;
    vector<Point> points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }
    for (int i = 0; i < n / 2; ++i) {
        cout << i + 1 << " " << (n - i) << " ";
    }
    if (n % 2 == 0) {
        cout << n / 2 + 1;
    }
    cout << endl;
}

void solve7() {
    int n;
    cin >> n;
    vector<Point> points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }
    int c;
    cin >> c;
    int q;
    cin >> q;
    while (q--) {
        int k;
        cin >> k;
        int l = 0, r = n;
        for (int i = 0; i <= k; ++i) {
            if (i % 2 == 0) {
                cout << i / 2 + 1 << " ";
                l = i / 2 + 1;
            } else {
                cout << (n - (i / 2)) << " ";
                r = n - (i / 2);
            }
        }
        if (k % 2 == 0) {
            for (int i = l + 1; i < r; ++i) {
                cout << i + 1 << " ";
            }
        } else {
            for (int i = r - 1; i > l; --i) {
                cout << i + 1 << " ";
            }
        }
        cout << endl;
    }
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cout << fixed << setprecision(16);

    int t = 1;
    // cin >> t;
    while (t--) {
        int task, g;
        cin >> task >> g;

        if (task == 1) {
            solve1();
        } else if (task == 3) {
            solve7();
        } else if (task == 4) {
//            solve
        }
    }
    return 0;
}
