#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
struct point {
    long long x, y;
    point() {
        x = 0, y = 0;
    }
    point(long long xx, long long yy) {
        x = xx, y = yy;
    }
};
struct vec {
    long long x, y;
    vec(long long xx, long long yy) {
        x = xx, y = yy;
    }
    vec(point a, point b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }
    long long operator*(vec b) {
        return this->x * b.x + this->y * b.y;
    }
    long long operator%(vec b) {
        return this->x * b.y - this->y * b.x;
    }
};
bool comp(pair<point, int> a, pair<point, int> b) {
    }
int main() {
    //cin.tie(0);
    //ios::sync_with_stdio(false);
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    if (task == 3) {
        vector<point> a(n);
        vector<int> b(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i].x >> a[i].y;
            b[i] = i;
        }
        int q;
        cin >> q;
        for (int i = 0; i < q; ++i) {
            int now;
            cin >> now;
            int trash = n - 2 - now;
            int leftt = n - trash;
            for (int i = 1; i <= trash; ++i) {
                cout << i << " ";
            }
            for (int i = 0; i < leftt / 2; ++i) {
                cout << i + 1 + trash << " " << leftt - i + trash;
                if (i + 2 == leftt - i) {
                    cout << endl;
                } else {
                    cout << " ";
                }
            }
            if (leftt % 2 == 1) {
                cout << leftt / 2 + 1 + trash << endl;
            }
        }
    } else if (n > 10) {
        vector<point> a(n);
        vector<int> b(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i].x >> a[i].y;
            b[i] = i;
        }
        for (int i = 0; i < n / 2; ++i) {
            cout << i + 1 << " " << n - i;
            if (i + 2 == n - i) {
                cout << endl;
            } else {
                cout << " ";
            }
        }
        if (n % 2 == 1) {
            cout << n / 2 + 1 << endl;
        }
    } else {
        vector<point> a(n);
        vector<int> b(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i].x >> a[i].y;
            b[i] = i;
        }
        vector<int> best;
        int maxcount = 0;
        do {
            int cnt = 0;
            for (int i = 1; i < n - 1; ++i) {
                if (vec(a[b[i]], a[b[i - 1]]) * vec(a[b[i]], a[b[i + 1]]) > 0) {
                    cnt++;
                }
            }
            if (cnt > maxcount) {
                maxcount = cnt;
                best = b;
            }
        } while (next_permutation(b.begin(), b.end()));
        for (auto &i : best) {
            cout << i + 1 << " ";
        }
        cout << endl;
    }
}
