#ifdef Local

#include "debug.h"

#else
#include <bits/stdc++.h>
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

template<class A, class B>
bool smin(A &x, B &&y) {
        if (x > y) {
                x = y;
                return true;
        }
        return false;
}

template<class A, class B>
bool smax(A &x, B &&y) {
        if (x < y) {
                x = y;
                return true;
        }
        return false;
}

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

struct Point {
        int x, y;

        Point() {
                x = y = 0;
        }
};

void solve() {
        int task, group;
        cin >> task >> group;
        if (task == 1) {
                int n;
                cin >> n;
                vector<Point> vp(n);
                for (auto &[x, y]: vp)
                        cin >> x >> y;
                vector<int> ind(n);
                iota(all(ind), 0ll);
                sort(all(ind), [&](int i, int j) {
                        return vp[i].x < vp[j].x;
                });
                for (int i = 0; i < n / 2; ++i)
                        cout << ind[i] + 1 << ' ' << ind[n - i - 1] + 1 << ' ';
                if (n % 2)
                        cout << ind[n / 2] + 1;
                cout << endl;
        }
}

signed main() {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);

        int _t = 1;
        // cin >> _t;
        while (_t--)
                solve();

        return 0;
}
