#include <bits/stdc++.h>
#define int long long
#define ld long double

using namespace std;

struct point{
    int x, y;
};

ld pi = atan2l(0.0, -1.0);

ld get_angle(point a, point b, point c){
    int x1 = a.x - c.x, y1 = a.y - c.y;
    int x2 = b.x - c.x, y2 = b.y - c.y;
    return abs(atan2l(x1*y2 - x2*y1, x1*x2 + y1*y2));
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int task, group;
    cin >> task >> group;
    if(task == 1) {
        int n;
        cin >> n;

        vector<point> a(n);
        vector<int> p(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i].x >> a[i].y;
            p[i] = i;
        }
        vector<int> ans;
        int kol = 0;
        if(group == 2) {
            do {
                int cnt = 0;
                for (int i = 2; i < n; i++) {
                    ld an = get_angle(a[p[i]], a[p[i - 2]], a[p[i - 1]]);
                    if (an < pi / 2) cnt++;
                }
                if (cnt > kol) {
                    kol = cnt;
                    ans = p;
                }
            } while (next_permutation(p.begin(), p.end()));
            for (auto &i: ans) {
                cout << i + 1 << ' ';
            }
            cout << endl;
        } else {
            int l = 1, r = n;
            for(int i = 0; i < n; i++){
                if(i % 2 == 0){
                    cout << l << ' ';
                    l++;
                } else {
                    cout << r << ' ';
                    r--;
                }
            }
        }
    }
    return 0;
}
