#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag,  tree_order_statistics_node_update>
#define int long long
mt19937_64 gen(time(nullptr));
struct st {
    int x, y;
};
const int inf = 1e9;
int sc(st a, st b, st c) {
    return (a.x-b.x)*(c.x-b.x) + (a.y-b.y)*(c.y-b.y);
}
int check(vector<int>& order, vector<st>& cord, int n) {
    int ans = 0;
    for (int i = 1; i < n-1; i++) {
        if (sc(cord[order[i]-1], cord[order[i]], cord[order[i+1]]) > 0) {
            ans++;
        }
    }
    return ans;
}
long double get_rnd() {
    int x = gen() %inf;
    return (long double)((long double)x/(long double)inf);
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<st> cord(n);
    for (int i = 0; i < n; i++) {
        cin >> cord[i].x >> cord[i].y;
    }
    vector<int> order(n);
    for (int i = 0; i < n; i++) {
        order[i] = i;
    }
    int ans = check(order, cord, n);
    if (task==1) {
        long double t = 1;
        for (int oper = 0; oper <= 600000; oper++) {
            t *= 0.9;
            int fst = gen() % n, scnd = gen() % n;
            vector<int> order_cp = order;
            if (fst > scnd) {
                swap(fst, scnd);
            }
            for (int i = fst; i <= (fst+scnd)/2; i++) {
                swap(order[i], order[scnd-(i-fst)]);
            }
            int ans2 = check(order, cord, n);
            if (ans2 > ans || exp((long double) ((long double) (ans2 - ans)) / (long double) t) > get_rnd()) {
                ans = ans2;
            } else {
                order = order_cp;
            }
        }
        for (int i = 0; i < n; i++) {
            cout << order[i] + 1 << " ";
        }
        cout << endl;
    } else {
        int c;
        cin >> c;
        long double t = 1;
        for (int oper = 0; oper <= min(n*n, 90000ll) && ans >= c; oper++) {
            t *= 0.9;
            int fst = gen() % n, scnd = gen() % n;
            vector<int> order_cp = order;
            if (fst > scnd) {
                swap(fst, scnd);
            }
            for (int i = fst; i <= (fst+scnd)/2; i++) {
                swap(order[i], order[scnd-(i-fst)]);
            }
            int ans2 = check(order, cord, n);
            if (ans2 < ans || exp((long double) ((long double) (ans - ans2)) / (long double) t) > get_rnd()) {
                ans = ans2;
            } else {
                order = order_cp;
            }
        }
        for (int i = 0; i < n; i++) {
            cout << order[i] + 1 << " ";
        }
        cout << endl;
    }
}