#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag,  tree_order_statistics_node_update>
#define int long long
mt19937_64 gen(time(nullptr));
struct st {
    int x, y;
};
const int inf = 1e9;
int sc(st a, st b, st c) {
    return (a.x-b.x)*(c.x-b.x) + (a.y-b.y)*(c.y-b.y);
}
int check(vector<int>& order, vector<st>& cord, int n) {
    int ans = 0;
    for (int i = 1; i < n-1; i++) {
        if (sc(cord[order[i]-1], cord[order[i]], cord[order[i+1]]) > 0) {
            ans++;
        }
    }
    return ans;
}
long double get_rnd() {
    int x = gen() %inf;
    return (long double)((long double)x/(long double)inf);
}
int mx = -1;
vector<int> ans;
void solve(vector<int>& order, vector<int>& used, vector<st>& cord, int n) {
    if ((int)order.size()==n) {
        int gt = check(order, cord, n);
        if (gt > mx) {
            mx = gt;
            ans = order;
        }
        return;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            order.push_back(i);
            used[i] = 1;
            solve(order, used, cord, n);
        }
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<st> cord(n);
    for (int i = 0; i < n; i++) {
        cin >> cord[i].x >> cord[i].y;
    }
    if (n==4) {
        cout << 1/0;
    }
    vector<int> order;
    vector<int> used(n, 0);
    solve(order, used, cord, n);
    for (auto elem: ans) {
        cout << elem+1 << endl;
    }
}