#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>
#include <array>
using namespace std;
using ll = long long;
struct point {
	int x, y;
	point operator -(point p) {
		return { x - p.x, y - p.y };
	}
};
ll scalar(point p1, point p2) {
	return p1.x * p2.x + p1.y * p2.y;
}
bool operator <(const point p1, const point p2) {
	return p1.x < p2.x;
}
int get(vector<point> v) {
	int cnt = 0, n = v.size();
	for (int i = 2; i < n; i++) {
		if (scalar(v[i - 2] - v[i - 1], v[i] - v[i - 1]) >= 0) cnt++;
	}
	return cnt;
}
vector<int> best; int res = 0;
set<int> st;
void rec(vector<point> v, vector<int>& ord) {
	int n = v.size();
	if (ord.size() == n) {
		vector<point> v1;
		for (auto i : ord) v1.push_back(v[i]);
		if (get(v1) > res) {
			res = get(v1); best = ord;
		}
		return;
	}
	for (int i = 0; i < n; i++) {
		if (st.find(i) == st.end()) {
			st.insert(i); ord.push_back(i); rec(v, ord);
			ord.pop_back(); st.erase(i);
		}
	}
}
const int mx = 1e7;
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tsk, gr, n; cin >> tsk >> gr >> n; vector<point> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i].x >> v[i].y; 
	}
	vector<int> ord;
	rec(v, ord);
	for (auto i : best) cout << i + 1 << " ";
	return 0;
}
