#include <bits/stdc++.h>

#define int int64_t
//#define endl '\n'

using namespace std;

const int MAXN = 4e5;
const int MAXX = 2e6;
const int MOD = 1e9 + 7;
const int INF = 1e9;
const long double EPS = 1e-6;
const long double EPS1 = 1e-7;
const int LG = 50;
const int BS = 100;
const int DIS = 2e8;

int bp(int v, int p){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp(v, p - 1) * v % MOD;
    }
    int k = bp(v, p / 2);
    return k * k % MOD;
}

int bp_md(int v, int p, int md){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp_md(v, p - 1, md) * v % md;
    }
    int k = bp_md(v, p / 2, md);
    return k * k % md;
}

int nok(int a, int b){
    return a / __gcd(a, b) * b;
}

bool is_prime(int a){
    for(int i = 2; i * i <= a; i++){
        if(a % i == 0){
            return 0;
        }
    }
    return 1;
}

mt19937 rnd(228);

const int B = 1e6 + 3;

void solve(){
    int task = 4, g = 16;
    cin >> task >> g;
    int n = 4;
    cin >> n;
    vector <pair<int, int>> vp;
    for(int i = 0; i < n; i++){
        int x = i + 1, y = i + 1;
        cin >> x >> y;
        vp.push_back({x, y});
    }
    int c;
    if(task != 1){
        cin >> c;
    }
    if(task == 1){
        if(g == 1){
            for(int i = 0; i < n; i++){
                if(i & 1){
                    cout << n - i / 2;
                }
                else{
                    cout << i / 2 + 1;
                }
                cout << ' ';
            }
            cout << endl;
        }
        else if(g == 2){
            int fact = 1;
            for(int i = 1; i <= n; i++){
                fact *= i;
            }
            int mx = 0;
            vector <int> best;
            vector <int> nw(n);
            iota(nw.begin(), nw.end(), 0);
            for(int i = 0; i < fact; i++){
                int nn = 0;
                for(int j = 2; j < n; j++){
                    if((vp[nw[j]].first - vp[nw[j - 1]].first) * (vp[nw[j - 1]].first - vp[nw[j - 2]].first) + (vp[nw[j]].second - vp[nw[j - 1]].second) * (vp[nw[j - 1]].second - vp[nw[j - 2]].second) < 0){
                        nn++;
                    }
                }
                if(nn > mx){
                    mx = nn;
                    best = nw;
                }
                next_permutation(nw.begin(), nw.end());
            }
            assert(n - 2 == mx);
            for(auto i:best){
                cout << i + 1 << ' ';
            }
            cout << endl;
        }
    }
    else if(task == 3){
        int q;
        cin >> q;
        if(g == 7){
            while(q--){
                int k;
                cin >> k;
                if(!(k & 1)){
                    int last = 0;
                    for(int i = 0; i < k + 1; i++){
                        if(i & 1){
                            cout << n - i / 2;
                        }
                        else{
                            cout << i / 2 + 1;
                            last = i / 2 + 1;
                        }
                        cout << ' ';
                    }
                    last++;
                    for(int j = 0; j < n - k - 1; j++){
                        cout << last++ << ' ';
                    }
                    cout << endl;
                }
                else{
                    int last = 0;
                    for(int i = 0; i < k + 1; i++){
                        if(!(i & 1)){
                            cout << n - i / 2;
                        }
                        else{
                            cout << i / 2 + 1;
                            last = i / 2 + 1;
                        }
                        cout << ' ';
                    }
                    last++;
                    for(int j = 0; j < n - k - 1; j++){
                        cout << last++ << ' ';
                    }
                    cout << endl;
                }
            }
        }
    }
    else if(task == 4){
        if(g == 16){
            vector <int> pref1, pref2, pref3;
            pref1.push_back(0);
            for(int i = 1; 2 * i - 1 <= n; i++){
                pref1.push_back((i * bp(B, 2 * i - 2) + pref1[i - 1]) % MOD);
            }
            pref2.push_back(0);
            for(int i = n; n <= 2 * i - 1; i--){
                    //cout << "NOWI: " << i << ' ' << bp(B, 2 * (n - i)) << ' ' << n - i << ' ' <<( + pref2[i - 1]) % MOD << endl;
                pref2.push_back((i * bp(B, 2 * (n - i)) + pref2[n - i]) % MOD);
            }
            pref3.push_back(0);
            for(int i = 1; i <= n; i++){
                pref3.push_back((pref3[i - 1] + i * bp(B, i - 1)) % MOD);
            }
            for(int k = c; k <= n - c; k++){
                if(k & 1){
                    int mdend = (pref3[n - 1 - k / 2] - pref3[k / 2] + MOD) % MOD * bp(B, k / 2 + 1) % MOD;
                    int en = pref2[k / 2 + 1];
                    int be = pref1[k / 2] * B % MOD;
                    cout << (mdend + en + be) % MOD;
                }
                else{
                    int mdend = (pref3[n - k / 2] - pref3[k / 2] + MOD) % MOD * bp(B, k / 2) % MOD;
                    int en = pref2[k / 2] * B % MOD;
                    int be = pref1[k / 2];
                    cout << (mdend + en + be) % MOD;
                }
                cout << ' ';
            }
            cout << endl;
            int q;
            cin >> q;
            while(q--){
                int k;
                cin >> k;
                if(!(k & 1)){
                    int last = 0;
                    for(int i = 0; i < k + 1; i++){
                        if(i & 1){
                            cout << n - i / 2;
                        }
                        else{
                            cout << i / 2 + 1;
                            last = i / 2 + 1;
                        }
                        cout << ' ';
                    }
                    last++;
                    for(int j = 0; j < n - k - 1; j++){
                        cout << last++ << ' ';
                    }
                    cout << endl;
                }
                else{
                    int last = 0;
                    for(int i = 0; i < k + 1; i++){
                        if(!(i & 1)){
                            cout << n - i / 2;
                        }
                        else{
                            cout << i / 2 + 1;
                            last = i / 2 + 1;
                        }
                        cout << ' ';
                    }
                    last++;
                    for(int j = 0; j < n - k - 1; j++){
                        cout << last++ << ' ';
                    }
                    cout << endl;
                }
            }
        }
    }

}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
        cout << endl;
    }
    return 0;
}
