#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

random_device rd;
mt19937 rnd(rd());

struct vect {
    ll x, y;

    vect(ll x = 0, ll y = 0): x(x), y(y) {}

    friend vect operator-(vect a, vect b) {
        return {a.x - b.x, a.y - b.y};
    }
};

ll scalar(vect a, vect b) {
    return a.x * b.x + a.y * b.y;
}

ll cross(vect a, vect b) {
    return a.x * b.y - a.y * b.x;
}

int main() {
    int task, group, n;
    cin >> task >> group >> n;
    vector<vect> d(n);
    for (int i = 0; i < n; ++i)
        cin >> d[i].x >> d[i].y;
    if (task == 1) {
        vi p(n);
        iota(all(p), 0);
        shuffle(all(p), rnd);
        for (int k = 0; k < 5000; ++k) {
            for (int i = 1; i < n - 1; ++i) {
                if (scalar(d[p[i]] - d[p[i - 1]], d[p[i + 1]] - d[p[i]]) >= 0)
                    swap(p[i], p[i + 1]);
            }
        }
        for (int i: p)
            cout << i + 1 << ' ';
        cout << endl;
    }
}
