
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

#define int long long
#define all(x) x.begin(), x.end()
using ll = long long;
using ld = long double;
const ll INF = 2e9, MOD = 1e9 + 7, N = 2e5 + 100, K = 26;
const ld Pi = acos(-1), eps = 1e-7;
mt19937 rnd(24246);


int sign(int x) {
    if (x > 0) return 1;
    if (x == 0) return 0;
    return -1;
}

struct pnt{
    int x, y;

    int operator%(pnt b) {
        return x * b.y - y * b.x;
    }

    int operator*(pnt b) {
        return x * b.x + y * b.y;
    }

    pnt operator+(pnt b) {
        return {x + b.x, y + b.y};
    }

    pnt operator-(pnt b) {
        return {x - b.x, y - b.y};
    }

};


void solve(int gr) {
    if (gr == 0)
        gr = 2;
    int n;
    cin >> n;
    vector<pnt> a;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a.push_back({x, y});
    }
    if (gr == 1) {
        int l = 1, r = n;
        while (l < r) {
            cout << l << " " << r << " ";
            l++;
            r--;
        }
        if (l == r) cout << l;
        cout << endl;
    } else if (gr == 2) {
        vector<int> p;
        for (int i = 0; i < n; i++)
            p.push_back(i);
        int mx = -1;
        vector<int> ans;
        do {
            int cnt = 0;
            for (int i = 1; i < n - 1; i++) {
                if ((a[p[i - 1]] - a[p[i]]) * (a[p[i + 1]] - a[p[i]]) > 0)
                    cnt++;
            }
            if (cnt > mx) {
                mx = cnt;
                ans = p;
            }

        } while (next_permutation(p.begin(), p.end()));
        for (auto to : ans)
            cout << to + 1 << " ";
        cout << endl;
    }

}


void solve2() {

}


void solve3(int gr) {
    int n;
    cin >> n;
    vector<pnt> a;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a.push_back({x, y});
    }
    int c;
    cin >> c;
    int q;
    cin >> q;
    if (gr == 7) {
        while (q--) {
            int k;
            cin >> k;
            cout << "1 " << n << " ";
            int l = 2, r = n - 1;
            for (int i = 0; i < k - 1; i++) {
                if (i % 2 == 0)
                    cout << l++ << " ";
                else
                    cout << r-- << " ";
            }
            if (k % 2 == 0) {
                while (l <= r) {
                    cout << l++ << " ";
                }
            } else {
                while (l <= r) {
                    cout << r-- << " ";
                }
            }
            cout << endl;
        }
    } else {
        vector<int> p;
        for (int i = 0; i < n; i++) {
            p.push_back(i);
        }
        while (q--) {
            int k;
            cin >> k;
            do {
                int cnt = 0;
                for (int i = 1; i < n - 1; i++) {
                    if ((a[p[i - 1]] - a[p[i]]) * (a[p[i + 1]] - a[p[i]]) > 0)
                        cnt++;
                }
                if (cnt == k) {
                    for (auto to : p) {
                        cout << to + 1 << " ";
                    }
                    cout << endl;
                    break;
                } else {
                    random_shuffle(p.begin(), p.end());
                }
            } while (1);
            cout << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        int task, gr;
        cin >> task >> gr;
        if (task == 1) {
            solve(gr);
        } else if (task == 3) {
            solve3(gr);
        } else if (task == 2) {
            solve2();
        }
    }
    return 0;
}
