#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct vec {

    vec() {}
    vec(int x, int y) : x(x), y(y) {}

    int x, y;

};

ll cross_prod(vec a, vec b) {
    return a.x * b.y - a.y * b.x;
}

vec operator-(vec a, vec b) {
    return {a.x - b.x, a.y - b.y};
}

void solve() {
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<vec> v(n);
    for (int i = 0; i < n; i++) cin >> v[i].x >> v[i].y;

    if (task == 1) {
        if (group == 1) {
            for (int i = 0; i < n / 2; i++) {
                cout << i + 1;
                if (i != n - i - 1) cout << " " << n - i << " ";
            }
            cout << endl;
        } else {
            vector<int> ord(n);
            iota(all(ord), 0);
            vector<int> ans = ord;
            int acnt = 0;
            for (int c = 0; c <= 100; c++) {
                shuffle(all(ord), rnd);
                int cnt = 0;
                for (int i = 1; i < n - 1; i++) {
                    if (cross_prod(v[ord[i - 1]] - v[ord[i]], v[ord[i + 1]] - v[ord[i]]) > 0) cnt++;
                }
                if (cnt > acnt) {
                    acnt = cnt;
                    ans = ord;
                }
            }

            for (int x : ans) cout << x + 1 << " ";
        }
    }
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) solve();
}