#include <bits/stdc++.h>
using namespace std;

bool sharp(int x1, int y1, int x2, int y2, int x3, int y3) {
  return 1LL * (x2 - x1) * (x3 - x2) + 1LL * (y2 - y1) * (y3 - y2) < 0;
}

int main() {
  int task, group;
  cin >> task >> group;
  mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());
  if (task == 1) {
    int n;
    cin >> n;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; i++) {
      cin >> x[i] >> y[i];
    }
    vector<int> order(n);
    iota(order.begin(), order.end(), 0);
    pair<int, vector<int>> answer = {-1, {}};
    while (1.0 * clock() / CLOCKS_PER_SEC < 1.9) {
      int cnt = 0;
      for (int i = 0; i < n - 2; i++) {
        cnt += sharp(x[order[i]], y[order[i]], x[order[i + 1]], y[order[i + 1]], x[order[i + 2]], y[order[i + 2]]);
      }
      if (cnt > answer.first) {
        answer = {cnt, order};
      }
      shuffle(order.begin(), order.end(), rng);
    }
    for (int i = 0; i < n; i++) {
      cout << 1 + answer.second[i] << " \n"[i + 1 == n];
    }
  } else if (task == 2) {
    int n;
    cin >> n;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; i++) {
      cin >> x[i] >> y[i];
    }
    int c;
    cin >> c;
    vector<int> order(n);
    iota(order.begin(), order.end(), 0);
    pair<int, vector<int>> answer = {INT_MAX, {}};
    while (1.0 * clock() / CLOCKS_PER_SEC < 1.9) {
      int cnt = 0;
      for (int i = 0; i < n - 2; i++) {
        cnt += sharp(x[order[i]], y[order[i]], x[order[i + 1]], y[order[i + 1]], x[order[i + 2]], y[order[i + 2]]);
      }
      if (cnt < answer.first) {
        answer = {cnt, order};
      }
      shuffle(order.begin(), order.end(), rng);
    }
    for (int i = 0; i < n; i++) {
      cout << 1 + answer.second[i] << " \n"[i + 1 == n];
    }
  } else if (task == 3) {
    int n;
    cin >> n;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; i++) {
      cin >> x[i] >> y[i];
    }
    int c;
    cin >> c;
    int q;
    cin >> q;
    while (q--) {
      int k;
      cin >> k;
      vector<int> order(n);
      iota(order.begin(), order.end(), 0);
      pair<int, vector<int>> answer = {INT_MAX, {}};
      while (1.0 * clock() / CLOCKS_PER_SEC < 1.9) {
        int cnt = 0;
        for (int i = 0; i < n - 2; i++) {
          cnt += sharp(x[order[i]], y[order[i]], x[order[i + 1]], y[order[i + 1]], x[order[i + 2]], y[order[i + 2]]);
        }
        if (cnt == k) {
          for (int i = 0; i < n; i++) {
            cout << 1 + answer.second[i];
            if (i + 1 < n) {
              cout << " ";
            }
          }
          cout << endl;
          exit(0);
        }
        shuffle(order.begin(), order.end(), rng);
      }
    }
  } else {
    assert(false);
  }
}
