#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct node {
    ll x, y, ind;
};

node best = {(ll) 1e9, (ll) 1e9};

bool cmp(node &a, node &b) {
    if (a.x != b.x) {
        return a.x < b.x;
    } else {
        return a.y < b.y;
    }
}

ll o(pair<ll, ll> &a, pair<ll, ll> &b) {
    return a.first * b.first - a.second * b.first;
}

bool cmp1(node &a, node &b) {
    pair<ll, ll> a1 = {a.x - best.x, a.y - best.y};
    pair<ll, ll> b1 = {b.x - best.x, b.y - best.y};
    if (o(a1, b1) == 0) {
        return (a1.first * a1.first) + (a1.second * a1.second) < (b1.first * b1.first) + (b1.second * b1.second);
    } else {
        if (o(a1, b1) > 0) {
            return 1;
        } else {
            return 0;
        }
    }
}

void solve() {
    ll task, group;
    cin >> task >> group;
    ll n;
    cin >> n;
    vector<node> p(n);
    for (int i = 0; i < n; ++i) {
        ll x, y;
        cin >> x >> y;
        p[i] = {x, y, i};
    }
    if (task == 1) {
        std::sort(p.begin(), p.end(), cmp);
        vector<ll> used(n);
        for (int i = 0; i < n; ++i) {
            if (used[i] == 0) {
                cout << p[i].ind + 1 << " ";
                used[i] = 1;
            }
            if (used[n - i - 1] == 0) {
                cout << p[n - i - 1].ind + 1 << " ";
                used[n - i - 1] = 1;
            }
        }
        cout << endl;
    } else if (task == 2) {
        for (int i = 0; i < n; ++i) {
            if (p[i].x < best.x || p[i].x == best.x && p[i].y < best.y) {
                best = p[i];
            }
        }
        std::sort(p.begin(), p.end(), cmp1);
        for (int i = 0; i < n; ++i) {
            cout << p[i].ind + 1 << " ";
        }
    } else {
        vector<ll> o(1202310223413);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
