#include <bits/stdc++.h>
#include <experimental/random>
using namespace std;
using ll = long long;
using ld = long double;
void solve();

int main() {
    ll q = 1;
    while (q--) {
        solve();
    }
}
struct p {
    ll x, y, ind;
};
bool comp1(p a, p b) {
    return a.y < b.y;
}
bool comp2(p a, p b) {
    return a.y > b.y;
}
struct vec {
    ll x, y;
    ll operator* (vec v) {
        return x * v.x + y * v.y;
    }
    ll operator% (vec v) {
        return x * v.y - y * v.x;
    }
};
ld angle(p a, p b, p c) {
    vec v1 = {b.x - a.x, b.y - a.y}, v2 = {b.x - c.x, b.y - c.y};
    return abs(atan2(v1 % v2, v1 * v2));
}
void solve() {
    ll task, group;
    cin >> task >> group;
    ll n;
    cin >> n;
    vector<p> c;
    vector<ll> ind;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        ind.push_back(i);
        c.push_back({x, y, i});
    }
    vector<ll> ans;
    ll cnt = -1;
    for (int i = 0; i < 1050; i++) {
        ll ct = 0;
        for (int j = 1; j < n - 1; j++) {
            ld ang = angle(c[ind[j - 1]], c[ind[j]], c[ind[j + 1]]);
            if (ang * 2 <= M_PI) {
                ct++;
            }
        }
        if (ct > cnt) {
            ans.clear();
            for (auto j : ind) {
                ans.push_back(j);
            }
            cnt = ct;
        }
        next_permutation(ind.begin(), ind.end());
    }
    for (auto i : ans) {
        cout << i + 1 << ' ';
    }
}