#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    assert(task == 1);
    vector<array<int, 3>> xy(n);
    for (int i = 0; i < n; ++i) {
        cin >> xy[i][0] >> xy[i][1];
        xy[i][2] = i;
    }
    sort(xy.begin(), xy.end());
    vector<int> ans{0};
    vector<bool> used(n);
    used[0] = 1;
    while (ans.size() < n) {
        int ii = ans.back();
        auto [xi, yi, _i] = xy[ii];
        ll cur = -INFLL;
        int jj = -1;
        for (int j = 0; j < n; ++j) {
            if (used[j]) {
                continue;
            }
            ll curr = (xy[j][0] - xi) * 1ll * (xy[j][0] - xi) + (xy[j][1] - yi) * 1ll * (xy[j][1] - yi);
            if (jj == -1 || cur < curr) {
                cur = curr;
                jj = j;
            }
        }
        auto [xj, yj, _j] = xy[jj];
        used[jj] = 1;
        ans.push_back(jj);
    }
    for (int i : ans) {
        cout << xy[i][2] + 1 << " ";
    }
}
