#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

mt19937 rng(228);

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int task, group;
    cin >> task >> group;
    int n;
    cin >> n;
    vector<array<int, 3>> xy(n);
    for (int i = 0; i < n; ++i) {
        cin >> xy[i][0] >> xy[i][1];
        xy[i][2] = i;
    }
    if (task == 1) {
        sort(xy.begin(), xy.end());
        vector<int> ans{0};
        vector<bool> used(n);
        used[0] = 1;
        while (ans.size() < n) {
            int ii = ans.back();
            auto [xi, yi, _i] = xy[ii];
            ll cur = -INFLL;
            int jj = -1;
            for (int j = 0; j < n; ++j) {
                if (used[j]) {
                    continue;
                }
                ll curr = (xy[j][0] - xi) * 1ll * (xy[j][0] - xi) + (xy[j][1] - yi) * 1ll * (xy[j][1] - yi);
                if (jj == -1 || cur < curr) {
                    cur = curr;
                    jj = j;
                }
            }
            auto [xj, yj, _j] = xy[jj];
            used[jj] = 1;
            ans.push_back(jj);
        }
        for (int i : ans) {
            cout << xy[i][2] + 1 << " ";
        }
    } else if (task == 2) {
        int c;
        cin >> c;
        while (true) {
            shuffle(xy.begin(), xy.end(), rng);
            int cnt = 0;
            for (int i = 1; i + 1 < n; ++i) {
                auto [x1, y1, _1] = xy[i - 1];
                auto [x2, y2, _2] = xy[i];
                auto [x3, y3, _3] = xy[i + 1];
                if ((x1 - x2) * 1ll * (x3 - x2) + (y1 - y2) * 1ll * (y2 - y3) < 0) {
                    ++cnt;
                }
            }
            if (cnt <= c) {
                for (int i = 0; i < n; ++i) {
                    cout << xy[i][2] + 1 << " ";
                }
                break;
            }
        }
        // sort(xy.begin(), xy.end());
        // vector<int> ans{0};
        // vector<bool> used(n);
        // used[0] = 1;
        // while (ans.size() < n) {
        //     int ii = ans.back();
        //     auto [xi, yi, _i] = xy[ii];
        //     ll cur = INFLL;
        //     int jj = -1;
        //     for (int j = 0; j < n; ++j) {
        //         if (used[j]) {
        //             continue;
        //         }
        //         ll curr = (xy[j][0] - xi) * 1ll * (xy[j][0] - xi) + (xy[j][1] - yi) * 1ll * (xy[j][1] - yi);
        //         if (jj == -1 || cur > curr) {
        //             cur = curr;
        //             jj = j;
        //         }
        //     }
        //     auto [xj, yj, _j] = xy[jj];
        //     used[jj] = 1;
        //     ans.push_back(jj);
        // }
        // for (int i : ans) {
        //     cout << xy[i][2] + 1 << " ";
        // }
    } else {
        assert(0);
    }
}
