#include<bits/stdc++.h>

#include <random>
using namespace std;
typedef long long ll;

#define int ll

struct Vector {
    int x, y;

    Vector operator+(const Vector &oth) const {
        return {x + oth.x, y + oth.y};
    }

    Vector operator-(const Vector &oth) const {
        return {x - oth.x, y - oth.y};
    }

    int dp(const Vector &oth) const {
        return x * oth.x + y * oth.y;
    }

    int cp(const Vector &oth) const {
        return x * oth.y - y * oth.x;
    }
};


void task1() {
    int n;
    cin >> n;
    vector<Vector> a(n);
    for (auto &[x, y] : a) {
        cin >> x >> y;
    }
    auto get = [&](vector<int> p) -> int {
        int ans = 0;
        for (int i = 1; i + 1 < n; ++i) {
            Vector t1 = a[p[i - 1]] - a[p[i]];
            Vector t2 = a[p[i + 1]] - a[p[i]];
            if (t1.dp(t2) > 0) {
                ++ans;
            }
        }
        return ans;
    };
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    auto ans = p;
    for (int q = 0; q < 5000; ++q) {
        shuffle(p.begin(), p.end(), std::mt19937(std::random_device()()));
        if (get(p) > get(ans)) ans = p;
    }
    for (auto &el : ans) cout << el + 1 << ' ';
}

void task2() {
    int n;
    cin >> n;
    vector<Vector> a(n);
    for (auto &[x, y] : a) {
        cin >> x >> y;
    }
    auto get = [&](vector<int> p) -> int {
        int ans = 0;
        for (int i = 1; i + 1 < n; ++i) {
            Vector t1 = a[p[i - 1]] - a[p[i]];
            Vector t2 = a[p[i + 1]] - a[p[i]];
            if (t1.dp(t2) > 0) {
                ++ans;
            }
        }
        return ans;
    };
    vector<int> p(n);
    int c;
    cin >> c;
    iota(p.begin(), p.end(), 0);
    for (; get(p) > c;) {
        shuffle(p.begin(), p.end(), std::mt19937(std::random_device()()));
    }
    for (auto &el : p) cout << el + 1 << ' ';
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int task, group;
    cin >> task >> group;
    if (task == 1) {
        task1();
    }
}