#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

//#define int long long
const int N = 2e5;
vector<pair<int, int>> order, f1[N];
vector<int> f[N];
multiset<int> h[N];
set<pair<int, int>> st, gt[N];
int g1[N];
vector<vector<int>> ans;
map<pair<int, int>, int> mp;
gp_hash_table<int, vector<int>> r[N];

inline void rec(int v, int pos) {
    if ((int) f[v].size() > pos + 1) {
        rec(v, pos + 1);
    }
    if (!order.empty() && order.back() == make_pair(v, pos)) {
        return;
    }
    auto [to, topos] = f1[v][pos];
    order.emplace_back(to, topos);
    rec(to, topos);
    cout << mp[{min(v, to), max(v, to)}] + 1 << ' ';
    order.pop_back();
    f[v].pop_back();
    f[to].pop_back();
}

signed main() {
    fast_in_out();
    int n, G;
    cin >> n >> G;
    for (int i = 0; i < n - 1; ++i) {
        int q, w, e;
        cin >> q >> w >> e;
        --q, --w;
        gt[q].insert({w, e});
        gt[w].insert({q, e});
        mp[{min(q, w), max(q, w)}] = i;
    }
    string s;
    getline(cin, s);
    for (int i = 0; i < n; ++i) {
        getline(cin, s);
        stringstream ss(s);
        int x;
        while (ss >> x) {
            f[i].emplace_back(x);
            h[i].insert(x);
        }
        f1[i].resize(f[i].size());
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < (int) f[i].size(); ++j) {
            r[i][f[i][j]].emplace_back(j);
        }
    }
    for (int i = 0; i < n; ++i) {
        g1[i] = (int) gt[i].size();
        st.insert({g1[i], i});
    }
    while (!st.empty()) {
        auto [deg, v] = *st.begin();
        if (deg != 1) {
            break;
        }
        auto [to, w] = *gt[v].begin();
        auto it = h[to].lower_bound(w - *h[v].begin());
        if (it == h[to].end()) {
            cout << "No";
            return 0;
        }
        ans.push_back({v, to, r[v][*h[v].begin()].back(), r[to][*it].back()});
        f1[v][r[v][*h[v].begin()].back()] = {to, r[to][*it].back()};
        f1[to][r[to][*it].back()] = {v, r[v][*h[v].begin()].back()};
        r[v][*h[v].begin()].pop_back();
        r[to][*it].pop_back();
        st.erase(st.begin());
        gt[v].clear();
        h[v].clear();
        h[to].extract(it);
        gt[to].erase({v, w});
        st.erase({g1[to], to});
        --g1[to];
        st.insert({g1[to], to});
    }
    cout << "Yes\n";
    for (int i = 0; i < n; ++i) {
        if (!f[i].empty()) {
            rec(i, 0);
        }
    }
//    while (!ans.empty()) {
//        for (int i = 0; i < (int) ans.size(); ++i) {
//            auto vec = ans[i];
//            if (f[vec[0]].back() == vec[3] && f[vec[1]].back() == vec[4]) {
//                f[vec[0]].pop_back();
//                f[vec[1]].pop_back();
//                cout << mp[{vec[0], vec[1], vec[2]}] + 1 << ' ';
//                swap(ans[i], ans.back());
//                ans.pop_back();
//                break;
//            }
//        }
//    }
    return 0;
}
