#include <bits/stdc++.h>

typedef long long ll;

using namespace std;


void solve() {
    int n, g;
    cin >> n >> g;
    vector<int> deg(n);
    vector<pair<int, int>> reb(n - 1);
    vector<set<int>> graph(n, set<int>());
    vector<int> ws(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        deg[a]++;
        deg[b]++;
        graph[a].insert(i);
        graph[b].insert(i);
        reb[i] = {a, b};
        ws[i] = w;
    }

    vector<set<int>> uliki(n, set<int>());
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < deg[i]; ++j) {
            int u;
            cin >> u;
            uliki[i].insert(u);
        }
    }

    set<pair<int, int>> q;
    for (int i = 0; i < n; ++i) {
        q.insert(make_pair(deg[i], i));
    }
    vector<int> ans;

    while(!q.empty()){

        int v = (*q.begin()).second;
        q.erase(q.begin());
        int a = *uliki[v].begin();
        int i = *graph[v].begin();
        int to = (reb[i].first != v ? reb[i].first : reb[i].second);
        graph[to].erase(i);
        int w = ws[i];
        // a + b >= w
        // b => w - a
//         uliki[to].lowerbound(w - a)
        auto b = uliki[to].lower_bound(w - a);
        if (b == uliki[to].end()){
            break;
        } else {
            uliki[to].erase(b);
            ans.push_back(i + 1);
            q.erase(make_pair(deg[to], to));
            q.erase(make_pair(deg[v], v));
            deg[to]--;
            deg[v]--;
            if (deg[to])
                q.insert(make_pair(deg[to], to));
        }
    }


    if ((int)ans.size() == n - 1){
        cout << "yes\n";
        for (auto i : ans)
            cout << i << ' ' ;
        cout << endl;
    } else {
        cout << "no\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    solve();
    return 0;
}
