    #include <iostream>
    #include <vector>
    #include <algorithm>
    #include <map>
    #include <set>
    #include <unordered_map>
    #include <unordered_set>
    #include <random>
    #include <queue>
    #include <deque>
    using namespace std;
    #define line cout << "\n"
    #define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
    #define pb push_back
    #define ppb pop_back
    #define all(a) a.begin(), a.end()
    #define rall(a) a.rbegin(), a.rend()
    #define ff first
    #define ss second
    #define pii pair<int, int>
    #define sz(a) (int) a.size()
    #define int long long
    const int MAXN = 2e5 + 10;


    bool cmp(pair<pii, pii> &a, pair<pii, pii> &b) {
        return a.second.first < b.second.first;
    }

    void solve() {
        int n, g;
        cin >> n >> g;
        vector<pair<pii, pii>> t;
        vector<int> deg(n);
        for (int i = 0; i < n - 1; i++) {
            int v, u, w;
            cin >> v >> u >> w;
            v--; u--;
            deg[v]++;
            deg[u]++;
            t.pb({{v, u}, {w, i}});
        }
        vector<vector<int>> b(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < deg[i]; j++) {
                int x;
                cin >> x;
                b[i].pb(x);
            }
            reverse(all(b[i]));
        }
        if (n > 10) {
            vector<int> cur(n), used(n - 1);
            vector<int> ans;
            for (int i = 0; i < n - 1; i++) {
                int mi = -1;
                for (int j = 0; j < n - 1; j++) {
                    if (used[j]) {
                        continue;
                    }
                    if (t[i].second.first <= b[t[i].first.first][cur[t[i].first.first]] + b[t[i].first.second][cur[t[i].first.second]]) {
                        if (mi == -1 || t[mi].second.first < t[i].second.first) {
                            mi = i;
                        }
                    }
                }
                if (mi == -1) {
                    cout << "No";
                    return;
                }
                used[mi] = true;
                cur[t[mi].first.first]++;
                cur[t[mi].first.second]++;
                ans.pb(mi);
            }
            cout << "Yes"; line;
            for (auto &u : ans) {
                cout << t[u].second.second + 1 << " ";
            }
            line;
            return;
        }
        int f = 1;
        for (int i = 1; i <= n; i++) {
            f *= i;
        }
        for (int j = 0; j < f; j++) {
            vector<int> cur(n);
            bool ch = true;
            for (int i = 0; i < n - 1; i++) {
                if (t[i].second.first <= b[t[i].first.first][cur[t[i].first.first]] + b[t[i].first.second][cur[t[i].first.second]]) {
                    cur[t[i].first.first]++;
                    cur[t[i].first.second]++;
                } else {
                    ch = false;
                    break;
                }
            }
            if (ch) {
                cout << "Yes"; line;
                for (auto &u : t) {
                    cout << u.second.second + 1 << ' ';
                }
                line;
                return;
            }
            next_permutation(all(t));
        }
        cout << "No"; line;
    }

    signed main() {
        fast;


        int t = 1;
        //cin >> t;
        while (t--) {
            solve();
        }
    }