#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<vector<pair<ll, ll>>> g;
vector<bool> used;
vector<vector<ll>> c;
vector<vector<ll>> ul;
vector<tuple<ll, ll, ll>> uls;
vector<set<pair<ll, ll>>> cs;
vector<ll> deg;

void dfs(ll v = 0, ll pr = -1, ll prv = -1) {
    used[v] = true;
    for (auto [to, it] : g[v]) {
        if (!used[to]) {
            dfs(to, v, it);
        }
    }
    if (v != 0) {
        ll last = 0;
        ll up = 0;
        for (ll i = 0; i < deg[v]; ++i) {
            if (ul[v][i] == -1) {
                last = i;
            }
            if (g[v][i].first == pr) {
                up = i;
            }
        }
        ul[v][last] = prv;
        cs[v].erase(cs[v].find({c[v][last], last}));

        if (cs[pr].empty() || (cs[pr].rbegin())->first < get<2>(uls[prv]) - c[v][last]) {
            cout << "No\n";
            exit(0);
        }

        auto sec = cs[pr].lower_bound({get<2>(uls[prv]) - c[v][last], 0});
        ll itpr = sec->second;

        ul[pr][itpr] = prv;
        cs[pr].erase(sec);
    }
}
vector<vector<ll>> g2;
vector<ll> ts;
void dfs2(ll v = 0, ll pr = -1) {
    for (ll i = 0; i < deg[v] - 1; ++i) {
        g2[ul[v][i + 1]].emplace_back(ul[v][i]);
    }
    for (auto [to, it] : g[v]) {
        if (to == pr) continue;
        dfs2(to, v);
    }
}

void topsort(ll v) {
    used[v] = true;
    for (auto to : g2[v]) {
        if (!used[to]) {
            topsort(to);
        }
    }
    ts.emplace_back(v);
}

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n, group;
    cin >> n >> group;
    used.assign(n, false);
    g.resize(n);
    g2.resize(n - 1);
    c.resize(n);
    ul.resize(n);
    uls.resize(n - 1);
    cs.resize(n);
    deg.assign(n, 0);
    for (ll i = 0; i < n - 1; ++i) {
        ll x, y, w;
        cin >> x >> y >> w;
        x--, y--;
        g[x].emplace_back(y, i);
        g[y].emplace_back(x, i);
        uls[i] = {x, y, w};
        deg[x]++;
        deg[y]++;
    }
    for (ll i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        ul[i].assign(deg[i], -1);
    }
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < deg[i]; ++j) {
            cin >> c[i][j];
            cs[i].insert({c[i][j], j});
        }
    }
    dfs(0);
    dfs2();
    used.assign(n - 1, false);
    for (ll i = 0; i < n - 1; ++i) {
        if (!used[i]) {
            topsort(i);
        }
    }
    std::reverse(ts.begin(), ts.end());
    for (auto el : ts) {
        cout << el + 1 << " ";
    }

    return 0;
}
