#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, less<>, null_type, tree_tag, tree_order_statistics_node_update>;
using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

void solve() {
    int n, g;
    cin >> n >> g;
    vector<tuple<int, int, int, int>> e(n - 1);
    vector<int> d(n);
    int cnt = 1;
    for (auto &[a, b, c, ndx]: e) {
        cin >> a >> b >> c;
        a--;
        b--;
        d[a]++;
        d[b]++;
        ndx = cnt++;
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        while (d[i]--) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
    }
    vector<int> ndx(n - 1);
    for (int i = 0; i < n - 1; i++)
        ndx[i] = i;
    while (1) {
        auto c1 = c;
        bool is = 1;
        for (int i: ndx) {
            auto [a, b, w, ind] = e[i];
            if (c1[a].back() + c1[b].back() < w)
                is = 0;
            c1[a].pop_back();
            c1[b].pop_back();
        }
        if (is) {
            cout << "Yes\n";
            for (int i: ndx) {
                cout << get<3>(e[i]) << ' ';
            }
            return;
        }
        if (!next_permutation(all(ndx)))
            break;
    }
    cout << "No\n";
}
