#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define watch(x) cout << #x << ": " << x << "\n";
#define watch_arr(arr) cout << #arr << ": "; \
for (auto x : arr) { \
    cout << x << " "; \
} \
cout << "\n";
#define all(arr) arr.begin(), arr.end()


struct Edge {
    int to, id, w;

    Edge(int _to, int _id, int _w) {
        to = _to, id = _id, w = _w;
    }
};


vector<vector<int>> arr;
vector<vector<Edge>> g;


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    
    int n, gr;
    cin >> n >> gr;
    arr.resize(n);
    g.resize(n);
    forn(i, n - 1) {
        int a, b, w;
        cin >> a >> b >> w;
        --a, --b;
        g[a].emplace_back(Edge(b, i + 1, w));
        g[b].emplace_back(Edge(a, i + 1, w));
    }
    forn(i, n) {
        int deg = g[i].size();
        arr[i].resize(deg);
        forn(j, deg) {
            cin >> arr[i][j];
        }
    }

    if (gr == 3) {
        sort(all(arr[0]));
        vector<pair<int, int>> add;
        for (int i = 1; i < n; ++i) {
            add.emplace_back(g[i][0].w - arr[i][0], g[i][0].id);
        }
        sort(all(add));

        vector<int> ans;
        forn(i, n - 1) {
            if (arr[0][i] < add[i].first) {
                cout << "No";
                return 0;
            }
            ans.emplace_back(add[i].second);
        }

        cout << "Yes\n";
        forn(i, n - 1) {
            cout << ans[i] << " ";
        }
    }

    return 0;
}