#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include <iomanip>
using namespace std;


#define int long long
struct edge {
	int v, u, cst;
};

vector <edge> e;
vector <vector<pair<int, int>>> gr;
vector < set<pair<int, int>>> c;
vector <vector <int>> cur;
vector <int> ans;

void dfs1(int v, int p = -1, int w=-1, int wi=-1) {
	for (auto u : gr[v]) {
		if (u.first != p) {
			dfs1(u.first, v, e[u.second].cst, u.second);
		}
	}
	if (p != -1) {
	pair<int, int> nw = *c[v].begin();
	auto it = c[p].lower_bound({ w - nw.first, -1 });
	if (it == c[p].end()) {
		cout << "No\n";
		exit(0);
	}
	
		cur[v][nw.second] = wi;
		cur[p][it->second] = wi;
		c[p].erase(it);
		c[v].erase(nw);
	}

}


void dfs2(int v, int p = -1, int wi=-1) {
	for (int i = cur[v].size() - 1; i >= 0; --i) {
		int u = cur[v][i];
	//for (int u:cur[v]){
		if (e[u].v != p and e[u].u != p) {
			dfs2(e[u].v+e[u].u-v, v, u);
		}
		else {
			ans.push_back(u);
		}
	}
}
void solve() {
	int n;
	cin >> n;
	int o;
	cin >> o;

	gr.resize(n);
	e.resize(n - 1);
	c.resize(n);
	cur.resize(n);
	for (int i = 0; i < n - 1; ++i) {
		edge nw;
		cin >> nw.v >> nw.u >> nw.cst;
		--nw.v;
		--nw.u;
		e[i] = nw;
		gr[nw.v].push_back({ nw.u, i });

		gr[nw.u].push_back({ nw.v, i });
	}

	
	for (int i = 0; i < n; ++i) {
		cur[i].resize(gr[i].size());
		for (int j = 0; j < gr[i].size(); ++j) {
			int nw;
			cin >> nw;
			c[i].insert({ nw, j });
		}
	}

	dfs1(0);
	dfs2(0);

	cout << "Yes\n";
	for (int i : ans) {
		cout << i + 1 << " ";
	}
}


int32_t main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}
}

