#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<iomanip>
#include<algorithm>
using namespace std;
using ll = long long;
vector<vector<tuple<int, ll, int>>>g;
vector<vector<int>>g_e;
vector<int>used;
vector<vector<pair<ll,int>>>sites;
int ww(int v, int pref,int ind) {
   
    used[v] = true;
    vector<pair<ll, int>>asks;
    for (auto [u, w, i] : g[v]) {
        if (used[u])continue;
        asks.push_back({ w - ww(u,v,i),i });
    }
    //cout << "now in " << v << "\n";
    sort(asks.begin(), asks.end());
    //cout << "asks "; for (auto c : asks)cout << "{" << c.first << " " << c.second << "} "; cout << "\n";
    //cout << "sites "; for (auto c : sites[v])cout << "{" << c.first << " " << c.second << "} "; cout << "\n";
    bool can_skip = v != pref;
    
    int lst = sites[v].size() - 1;
    if (!can_skip)lst = -1;
    int j = 0;
    vector<int>fell(sites[v].size());

    for (int i = 0; i < sites[v].size(); ++i) {
        if (j == asks.size())break;
        if (sites[v][i].first >= asks[j].first) {
            fell[sites[v][i].second] = asks[j].second;
            ++j;
        }
        else {
            if (can_skip) {
                can_skip = false;
                lst = i;
                continue;
            }
            else {
                cout << "No";
                exit(0);
            }
        }
    }
    if (v != pref) {
        //cout << "lst is " << lst << "\n";
        fell[sites[v][lst].second] = ind;
    }
    
    //cout << "fell "; for (auto c : fell)cout << c << " "; cout << "\n";
    for (int i = 0; i + 1 < fell.size(); ++i) {
        g_e[fell[i + 1]].push_back(fell[i]);
    }
    if (v == pref)return -1;
    //cout << sites[v][lst].first << "\n";
    return sites[v][lst].first;
}
vector<int>top_sort;
void dfs(int v) {
    used[v] = true;
    for (auto u : g_e[v]) {
        if (!used[u])dfs(u);
    }
    top_sort.push_back(v);
}
int main()
{
    //freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    cin.tie(0)->sync_with_stdio(0);
    cout.tie(0)->sync_with_stdio(0);
    int n, group; cin >> n >> group;
    g.resize(n);
    g_e.resize(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int v, u, w; cin >> v >> u >> w; --v, --u;
        g[v].push_back({ u,w,i });
        g[u].push_back({ v,w,i });
    }
    sites.resize(n);
    for (int i = 0; i < n; ++i) {
        sites[i].resize(g[i].size());
        for (int j = 0; j < g[i].size(); ++j) {
            cin >> sites[i][j].first;
            sites[i][j].second = j;
        }
        sort(sites[i].begin(), sites[i].end());
    }
   /* for (int v = 0; v < n; ++v) {
        cout << v << ": ";
        for (auto c : sites[v])cout << "{" << c.first << " " << c.second << "} "; cout << "\n";
    }*/
    used.assign(n, 0);
    ww(0, 0, 0);
    used.assign(n - 1, 0);
    for (int v = 0; v + 1 < n; ++v) {
        if (!used[v])dfs(v);
    }
    reverse(top_sort.begin(), top_sort.end());
    cout << "Yes\n";
    for (auto c : top_sort)cout << c + 1 << " ";
}