#include <bits/stdc++.h>
using namespace std;

void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}
vector<vector<pair<int, int>>> g;
vector<map<int, int>> used;
vector<set<pair<int, int>>> stic;
vector<vector<int>> gans;
map<pair<int, int>, int> edges;

vector<int> order;


void dfs(int v = 0, int p = 0) {
    for(auto to : gans[v]) {
        if(to == p) {
            order.push_back(edges[{v, p}]);
        } else {
            dfs(to, v);
        }
    }
}

signed main() {
    init();
    int n, group;
    cin >> n >> group;
    g.resize(n);
    used.resize(n);
    stic.resize(n);
    gans.resize(n);
    vector<int> wm(n - 1);
    for(int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w; --a; --b;
        g[a].emplace_back(b, w);
        g[b].emplace_back(a, w);
        wm[i] = w;
        edges[{a, b}] = edges[{b, a}] = i;
    }
    for(int i = 0; i < n; ++i) {
        gans[i].resize(g[i].size());
        for(size_t j = 0; j < g[i].size(); ++j) {
            int c;
            cin >> c;
            stic[i].emplace(c, j);
        }
    }
    set<pair<int, int>> s;
    vector<int> sz(n);
    for(int i = 0; i < n; ++i) {
        s.emplace(g[i].size(), i);
        sz[i] = g[i].size();
    }
    for(int i = 0; i < n; ++i) {
        auto [deg, v] = *s.begin();
        s.erase(s.begin());
        for(auto [to, w] : g[v]) {
            if(used[v][to]) continue;
            used[v][to] = 1;
            used[to][v] = 1;
            auto edge = *stic[v].begin(); // weight in v, num in v
            int necessary_w = wm[edges[{to, v}]] - edge.first; // weight
            s.erase({sz[to], to});
            sz[to]--;
            s.emplace(sz[to], to);
            auto idx = stic[to].upper_bound({necessary_w - 1, n});
            if(idx == stic[to].end()) {
                cout << "No\n";
                return 0;
            }
            auto res = *idx;
            stic[to].erase(idx);
            gans[v][edge.second] = to;
            gans[to][res.second] = v;
            stic[v].erase(stic[v].begin());
        } 
    }
    for(auto& i : gans) {
        reverse(i.begin(), i.end());
    }
    dfs();
    cout << "Yes\n";
    for(auto i : order) {
        cout << i + 1 << " ";
    }
}