#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define int ll
#define pii pair<int, int>
void fastios() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

struct edge {
    int u, v, w, id;
};

void solve() {
    int n, g;
    cin >> n >> g;
    vector<vector<int>> a(n - 1, vector<int>(4));
    vector<int> kk(n);
    for (int i = 0; i < n - 1; i++) {
        cin >> a[i][0] >> a[i][1] >> a[i][2];
        a[i][0]--;
        a[i][1]--;
        a[i][3] = i + 1;
        kk[a[i][0]]++;
        kk[a[i][1]]++;
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        int k = kk[i];
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
    }
    if (n <= 10) {
        sort(a.begin(), a.end());
        do {
            vector<vector<int>> d = c;
            bool f = true;
            for (int i = 0; i < n - 1; i++) {
                int u = a[i][0];
                int v = a[i][1];
                int w = a[i][2];
                if (w > d[u].back() + d[v].back()) {
                    f = false;
                    break;
                }
                d[u].pop_back();
                d[v].pop_back();
            }
            if (f) {
                cout << "Yes" << endl;
                for (auto to: a)
                    cout << to[3] << ' ';
                return;
            }
        } while (next_permutation(a.begin(), a.end()));
        cout << "No";
    } else {
        multiset<int> f;
        for (auto to : c[0])
            f.insert(to);
        vector<vector<int>> s(n - 1, vector<int>(4));
        for (int i = 0; i < n - 1; i++) {
            s[i] = {a[i][2], a[i][0], a[i][1], a[i][3]};
        }
        sort(s.begin(), s.end());
        vector<int> ans;
        while (!s.empty()) {
            vector<int> nw = s.back();
            s.pop_back();
            if (nw[1] != 0)
                swap(nw[1], nw[2]);
            int cb = c[nw[2]][0];
            if (lower_bound(f.begin(), f.end(), nw[0] - cb) == f.end()) {
                cout << "No";
                return;
            }
            f.erase(lower_bound(f.begin(), f.end(), nw[0] - cb));
            ans.push_back(nw[3]);
        }
        cout << "Yes" << endl;
        for (auto to : ans)
            cout << to << ' ';
    }
}


signed main() {
    int tt;
    tt = 1;
    fastios();
    //cin >> tt;
    while (tt--)
        solve();
}