#include <iostream>
#include <algorithm>
#include <numeric>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <cctype>
#include <iomanip>
#include <queue>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pri = pair<int, int>;
const int inf = 2e9 + 11;

istream& operator>>(istream& in, vector<int>& a) {
	for (auto& i : a) {
		in >> i;
	}
	return in;
}

ostream& operator >>(ostream& out, vector<int>& a) {
	for (auto& i : a) {
		out << i << ' ';
	}
	out << '\n';
	return out;
}

struct Edge {
	int a, b, w;
	int num;
	Edge() {}
};

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, g;
	cin >> n >> g;
	vector<Edge> vec(n - 1);
	vector < vector<pair<int, int>>> gr(n);
	for (int i = 0; i < n - 1; i++) {
		cin >> vec[i].a >> vec[i].b >> vec[i].w;
		--vec[i].a;
		--vec[i].b;
		vec[i].num = i;
		gr[vec[i].a].push_back({ vec[i].b, i});
		gr[vec[i].b].push_back({ vec[i].a, i });
	}
	vector<vector<int>> mat(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < gr[i].size(); j++) {
			int val;
			cin >> val;
			mat[i].push_back(val);
		}
	}
	vector<int> now(n);
	vector<int> ans;
	vector<bool>used(n - 1);
	for (int i = 0; i < n - 1; i++) {
		int reb = -1;
		for (auto& j : vec) {
			if (!used[j.num] && mat[j.a][now[j.a]] + mat[j.b][now[j.b]] - j.w >= 0) {
				if (reb == -1 || mat[j.a][now[j.a]] + mat[j.b][now[j.b]] - j.w < mat[vec[reb].a][now[vec[reb].a]] + mat[vec[reb].b][now[vec[reb].b]] - vec[reb].w) {
					reb = j.num;
				}
			}
		}
		if (reb == -1) {
			cout << "NO\n";
			exit(0);
		}
		used[reb] = true;
		ans.push_back(reb);
		now[vec[reb].a]++;
		now[vec[reb].b]++;
	}
	reverse(ans.begin(), ans.end());
	cout << "YES\n";
	for (int i : ans) {
		cout << i + 1 << ' ';
	}

}