#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, gr; cin >> n >> gr;
    vector <vector <pair <int, int>>> g(n);
    vector <int> u(n), v(n), w(n);
    for (int i = 0; i < n - 1; i++) {
        cin >> u[i] >> v[i] >> w[i], u[i]--, v[i]--;
        g[u[i]].push_back({v[i], w[i]});
        g[v[i]].push_back({u[i], w[i]});
    }

    vector <vector <int>> d(n);
    for (int i = 0; i < n; i++) {
        d[i].resize(g[i].size());
        for (auto &x : d[i]) cin >> x;
        reverse(d[i].begin(), d[i].end());
    }

    if (gr < 2) {
        vector <int> order(n - 1);
        iota(order.begin(), order.end(), 0);
        do {
            vector <int> ind(n, 0);
            bool bad = false;
            for (auto i : order) {
                if (d[u[i]][ind[u[i]]] + d[v[i]][ind[v[i]]] < w[i]) {
                    bad = true;
                    break;
                }
                ind[u[i]]++, ind[v[i]]++;
            }
            if (!bad) {
                cout << "Yes\n";
                for (auto x: order) cout << x + 1 << " ";
                cout << "\n";
                return 0;
            }
        } while(next_permutation(order.begin(), order.end()));
        cout << "No\n";
        return 0;
    }

    if (gr == 2) {

    }

    if (gr == 3) {
        vector <vector <int>> res(n - 1);
        vector <pair <int, int>> order(n - 1);
        for (int i = 0; i < n - 1; i++) {
            order[i] = {d[0][i], i};
        }
        sort(order.begin(), order.end());
        set <pair <int, int>> st;
        for (int i = 0; i < n - 1; i++) {
            st.insert({w[i] - d[v[i]][0], i});
        }
        for (auto x : order) {
            auto it = st.upper_bound({x.first, 1e9});
            if (it == st.begin()) {
                cout << "No\n";
                return 0;
            }
            it--;
            res[x.second].push_back((*it).second);
            st.erase(it);
        }
        vector <int> ans;
        for (int i = 0; i < n - 1; i++) {
            for (auto x : res[i]) ans.push_back(x);
        }
        cout << "Yes\n";
        for (auto x : ans) cout << x << " ";
        cout << "\n";
        return 0;
    }

    return 0;
}
