//#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 2e18;

void solve() {
    int n, g;
    cin >> n >> g;
    vector<vector<array<int, 3>>> gr(n);
    for (int i = 1, u, v, w; i < n; ++i) {
        cin >> u >> v >> w;
        --u, --v;
        gr[u].push_back({v, w, i});
        gr[v].push_back({u, w, i});
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(gr[i].size());
        for (auto &j : c[i])
            cin >> j;
        reverse(all(c[i]));
    }
    bool ok = true;
    vector<pair<int, int>> par(n);
    vector<vector<int>> where(n);
    auto dfs = [&](auto self, int v, int p) -> int {
        vector<pair<int, int>> now;
        for (auto [u, w, _] : gr[v])
            if (u != p) {
                par[u] = {v, _};
                now.push_back({w - self(self, u, v), u});
            }
        sort(all(now));
        where[v].resize(c[v].size());
        vector<pair<int, int>> need;
        for (int i = 0; i < c[v].size(); ++i)
            need.push_back({c[v][i], i});
        sort(all(need));
        int ind = -1;
        for (int i = 0; i < now.size(); ++i) {
            if (need[i].first >= now[i].first) {
                ind = i;
                where[v][need[i].second] = now[i].second;
            } else
                break;
        }
        if (v == 0) {
            if (ind != (int)now.size() - 1) {
                ok = false;
            }
            return -1;
        } else {
            for (int i = ind + 1; i < now.size(); ++i)
                if (need[i + 1].first < now[i].first) {
                    ok = false;
                    break;
                } else {
                    where[v][need[i + 1].second] = now[i].second;
                }
            where[v][need[ind + 1].second] = par[v].first;
            return need[ind + 1].first;
        }
    };
    dfs(dfs, 0, -1);
    cout << (ok ? "Yes" : "No") << '\n';
    if (ok) {
        vector<int> res;
        auto dfs2 = [&](auto self, int v, int p) -> void {
            for (int u : where[v])
                if (u == p) {
                    res.push_back(par[v].second);
                } else {
                    self(self, u, v);
                }
        };
        dfs2(dfs2, 0, -1);
        for (int i : res)
            cout << i << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
