#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;

struct Edge { int a, b, w; };

int n;
vector<set<pair<int, int>>> g;
vector<Edge> edges;
vector<vector<int>> add;

bool check(vector<int> perm) {
    vector<int> pointers(n);
    for (int i : perm) {
        int c1 = add[edges[i].a][pointers[edges[i].a]++];
        int c2 = add[edges[i].b][pointers[edges[i].b]++];
        if (c1 + c2 < edges[i].w) {
            return false;
        }
    }
    return true;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int _g;
    cin >> n >> _g;
    g.resize(n);
    add.resize(n);
    for (int i = 0; i + 1 < n; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        a--; b--;
        g[a].insert({b, w});
        g[b].insert({a, w});
        edges.push_back({a, b, w});
    }
    for (int i = 0; i < n; ++i) {
        string s;
        getline(cin, s);
        if (s.size() == 0) getline(cin, s);
        int num = 0;
        int was = 0;
        for (char c : s) {
            if (c == ' ') {
                add[i].push_back(num);
                was = 0;
                num = 0;
            } else {
                was = 1;
                num = 10 * num + (c - '0');
            }
        }
        if (was) {
            add[i].push_back(num);
        }
        reverse(add[i].begin(), add[i].end());
    }
    vector<int> perm(edges.size());
    iota(perm.begin(), perm.end(), 0);
    do {
        if (check(perm)) {
            cout << "Yes\n";
            for (int i : perm) cout << i + 1 << ' ';
            return 0;
        }
    } while (next_permutation(perm.begin(), perm.end()));
    cout << "No";
}
