#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

void solve() {
    int n, gr;
    cin >> n >> gr;
    vector<tii> ed(n - 1);
    vector<vector<pii>> g(n);
    for (auto& [u, v, w] : ed) {
        cin >> u >> v >> w, --u, --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        a[i].assign(g[i].size(), 0);
        for (auto& j : a[i])
            cin >> j;
    }

    vector<int> p(n - 1);
    iota(all(p), 0);

    int f = 1;
    for (int i = 1; i < n; ++i)
        f *= i;

    while (f--) {
        vector<int> it(n);
        for (int i = 0; i < n; ++i)
            it[i] = (int)a[i].size() - 1;

        bool flag = 1;
        for (int i = 0; flag && i < n - 1; ++i) {
            auto [u, v, w] = ed[p[i]];
            if (w > a[u][it[u]] + a[v][it[v]])
                flag = 0;
            --it[u], --it[v];
        }

        if (flag) {
            cout << "Yes" << endl;
            for (auto i : p)
                cout << i + 1 << " ";
            cout << endl;
            return;
        }

        next_permutation(all(p));

        //cout << f << endl;
    }

    cout << "No" << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}