#include "bits/stdc++.h"

using namespace std;

using ll = long long;

struct Edge {
    int u, v, pw, id;

    friend bool operator<(Edge L, Edge R) {
        if (L.u != R.u) return L.u < R.u;
        if (L.v != R.v) return L.v < R.v;
        if (L.pw != R.pw) return L.pw < R.pw;
        return false;
    }
};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n, group;
    cin >> n >> group;

    vector<Edge> edges;
    vector<int> count(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, pw;
        cin >> u >> v >> pw;

        count[u - 1]++;
        count[v - 1]++;
        edges.push_back({u - 1, v - 1, pw, i});
    }

    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < count[i]; ++j) {
            int num;
            cin >> num;

            a[i].push_back(num);
        }
    }

    if (group <= 1) {
        std::sort(edges.begin(), edges.end());

        do {
            vector<vector<int>> acopy = a;
            bool flag = true;
            for (auto [u, v, pw, id]: edges) {
                if (a[u].back() + a[v].back() < pw) {
                    flag = false;
                }
                a[u].pop_back();
                a[v].pop_back();
            }
            a = acopy;

            if (!flag) continue;
            cout << "Yes" << "\n";
            for (auto [u, v, pw, id]: edges) {
                cout << id + 1 << " ";
            }
            return 0;
        } while (std::next_permutation(edges.begin(), edges.end()));

        cout << "No" << "\n";
        return 0;
    } else if (group == 2) {
        bool flag = true;
        for (int i = 0; i < n - 1; ++i) {

        }
        return 0;
    } else if (group == 3) {
        vector<pair<int, int>> vals;
        for (int i = 0; i < n - 1; ++i) {
            vals.emplace_back(edges[i].pw - a[edges[i].v].back(), i);
        }
        std::sort(vals.begin(), vals.end());

        vector<pair<int, int>> vs;
        for (int i = 0; i < n - 1; ++i) vs.emplace_back(a[0][i], i);

        std::sort(vs.begin(), vs.end());

        vector<int> ans(n - 1);
        bool flag = true;
        for (int i = 0; i < n - 1; ++i) {
            if (vs[i].first < vals[i].first) flag = false;
            ans[vs[i].second] = vals[i].second;
        }
        
        cout << "No" << "\n";
        return 0;
        if (!flag){
            cout << "No" << '\n';
            assert(false);
            return 0;
        }
        cout << "Yes" << "\n";
        for (int i = 0; i < n - 1; ++i) {
            cout << ans[i] + 1 << " ";
        }
        
        return 0;
    }
}