#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 3e5;
const ld EPS = 1e-6;

void solve() {
    int n, group;
    cin >> n >> group;
    pair<pair<int, int>, int> edges[n - 1];
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        edges[i] = {{u, v}, w};
    }
    vector<int> have[n];
    for (int i = 0; i < n; ++i) {
        int x;
        while (cin >> x) {
            have[i].emplace_back(x);
        }
    }
    vector<bool> used(n - 1);
    vector<int> ord;
    for (int i = 0; i < n - 1; ++i) {
        if (!used[i] && edges[i].second <= have[i].back() + have[i + 1].back()) {
            ord.emplace_back(i);
            used[i] = true;
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        if (!used[i] && edges[i].second <= have[i].back() + have[i + 1].back()) {
            ord.emplace_back(i);
            used[i] = true;
        }
    }
    if ((int)ord.size() == n - 1) {
        cout << "Yes" << '\n';
        for (int x : ord) {
            cout << x + 1 << '\n';
        }
    } else {
        cout << "No" << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
