#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 1e9 + 100, MOD = 1e9 + 7, MAXN = 3e5;
const ld EPS = 1e-6;

void solve() {
    ll n, group;
    cin >> n >> group;
    vector<ll> deg(n);
    pair<pair<ll, ll>, pair<ll, ll>> edges[n - 1];
    for (ll i = 0; i < n - 1; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        deg[u]++, deg[v]++;
        edges[i] = {{u, v}, {w, i}};
    }
    vector<ll> have[n];
    for (ll i = 0; i < n; ++i) {
        have[i].resize(deg[i]);
        for (ll j = 0; j < deg[i]; ++j) {
            cin >> have[i][j];
        }
    }
    sort(edges, edges + n - 1, [&](pair<pair<ll, ll>, pair<ll, ll>> a, pair<pair<ll, ll>, pair<ll, ll>> b) {
        return a.first.second < b.first.second;
    });
    vector<bool> used(n - 1);
    vector<int> ord;
    for (int step = 0; step < n - 1; ++step) {
        for (int i = 0; i < n - 1; ++i) {
            int A = edges[i].first.first;
            int B = edges[i].first.second;
            int W = edges[i].second.first;
            int ind = edges[i].second.second;
            if (!used[ind] && have[A].back() + have[B].back() >= W) {
                have[A].pop_back();
                have[B].pop_back();
                used[ind] = true;
                ord.emplace_back(ind);
            }
        }
    }
    if ((int)ord.size() == n - 1) {
        cout << "Yes" << '\n';
        for (int i : ord) {
            cout << i + 1 << ' ';
        }
    } else {
        cout << "No" << '\n';
    }
//    int per[n - 1];
//    for (int i = 0; i < n - 1; ++i) {
//        per[i] = i;
//    }
//    int cor_ord[n - 1];
//    for (int i = 0; i < n - 1; ++i) {
//        cor_ord[i] = -1;
//    }
//    for (int step = 0; step < 400000 && cor_ord[0] == -1; ++step) {
//        vector<ll> probhave[n];
//        for (int i = 0; i < n; ++i) {
//            probhave[i] = have[i];
//        }
//        bool ok = true;
//        for (int id : per) {
//            if (probhave[edges[id].first.first].back() + probhave[edges[id].first.second].back() >= edges[id].second) {
//                probhave[edges[id].first.first].pop_back();
//                probhave[edges[id].first.second].pop_back();
//            } else {
//                ok = false;
//                break;
//            }
//        }
//        if (ok) {
//            for (int i = 0; i < n - 1; ++i) {
//                cor_ord[i] = per[i];
//            }
//        }
//        next_permutation(per, per + n - 1);
//    }
//    if (cor_ord[0] == -1) {
//        cout << "No" << '\n';
//    } else {
//        cout << "Yes" << '\n';
//        for (int i = 0; i < n - 1; ++i) {
//            cout << cor_ord[i] + 1 << ' ';
//        }
//    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
