//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
//typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define all(a) a.begin(), a.end()
#define rd(a) for (auto &i: a) cin >> i;

ll INF = 1e13;
ll MOD = 1e9 + 7;

vector<vector<tuple<ll, ll, ll>>> gr;
vector<vector<pair<ll, ll>>> c;
vector<vector<pair<ll, ll>>> ans;
vector<ll> not_used;
vector<ll> now_idx;

ll dfs(ll u, ll p = -1) {
    vector<tuple<ll, ll, ll>> can;
    for (auto [v, w, idx]: gr[u]) {
        if (v == p) continue;
        ll ost = dfs(v, u);
        if (ost == -INF) return ost;
        can.push_back({w - ost, v, idx});
    }
    sort(all(can));
    sort(all(c[u]));
    vector<bool> used(c.size(), false);
    ll l = 0;
    for (ll r = 0; r < can.size(); r++) {
        auto [s, d, idx] = can[r];
        while (l < c[u].size() && c[u][l].first < s) {
            l++;
        }
        if (l == c[u].size()) return -INF;
        used[c[u][l].second] = true;
        ans[u][c[u][l].second] = {d, idx};
        l++;

    }
    for (int i = 0; i < c[u].size(); i++) {
        if (!used[i]) {
            return c[u][i].first;
        }
    }
    return 0;

}


void answer(ll u, ll p = -1, bool f = true) {
    if (u == 0) {
        not_used[u] = ans[u].size();
    }
    if (f) {
        for (int i = 0; i < ans[u].size(); i++) {
            auto [v, idx] = ans[u][i];
            if (idx == -1) {
                not_used[u] = i;
                return;
            }
            if (v == p) continue;
            answer(v, u, true);
            cout << idx + 1 << " ";
            answer(v, u, false);
        }
    } else {
        for (int i = not_used[u] + 1; i < ans[u].size(); i++) {
            auto [v, idx] = ans[u][i];
            if (idx == -1) {
                not_used[u] = i;
                return;
            }
            if (v == p) continue;
            answer(v, u, true);
            cout << idx + 1 << " ";
            answer(v, u, false);
        }
    }
}

void solve() {
    ll n, g;
    cin >> n >> g;
    not_used.resize(n);
    gr.resize(n);
    now_idx.resize(n);
    ans.resize(n);
    for (int i = 0; i < n - 1; i++) {
        ll a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        gr[a].push_back({b, w, i});
        gr[b].push_back({a, w, i});
    }
    c.resize(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(gr[i].size());
        ans[i].resize(gr[i].size(), {-1, -1});
        for (int j = 0; j < c[i].size(); j++) {
            cin >> c[i][j].first;
            c[i][j].second = c[i].size() - j - 1;
        }
    }
    ll res = dfs(0);
    if (res == -INF) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    answer(0);




}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	//ll t; for (cin >> t; t--;) solve();
	solve();

}

//void operator delete(void*) {};
//const int MAX_MEM = 3 * 1e8;
//int pos = 0;
//char buf[MAX_MEM];
//void* operator new(size_t x) {
//    void* pointer = (void*)(buf + pos);
//    pos += x;
//    if (pos >= MAX_MEM) {
//        pos = 1e6;
//    }
//    return pointer;
//
//}


