// sleepwalker*_*ksu

#include <bits/stdc++.h>
#include <experimental/random>

using namespace std;

using ld = long double;
using ll = long long;
#define int long long
#define all(a) a.begin(), a.end()
using pii = pair<ll, ll>;
const ll N = 1e5 + 1;
const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ld EPS = 0.000001;

void solve1();

int solve2(int n, int k, int t, vector<int> &a);

void solve3();

void solve4();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve1();
    }
}

struct edge {
    int u, w, idx;
    int ans;
};

vector<vector<edge>> gr;
vector<set<int>> stc;
int now = 0;
vector<int> ans;

void dfs(int v, int p) {
    for (auto u: gr[v]) {
        if (u.u == p) continue;
        dfs(u.u, v);
        if (stc[u.u].size() != 1) {
            cout << "No";
            exit(0);
        }
        int need = u.w - *stc[u.u].begin();
        auto id = stc[v].lower_bound(need);
        if (id == stc[v].end()) {
            cout << "No";
            exit(0);
        }
        stc[v].erase(id);
        ans[now] = u.idx;
        now++;
    }
}

void solve1() {
    int n, q;
    cin >> n >> q;
    gr.resize(n);
    ans.resize(n - 1);
    stc.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        gr[v].push_back({u, w, i + 1});
        gr[u].push_back({v, w, i + 1});
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < gr[i].size(); j++) {
            int qq;
            cin >> qq;
            stc[i].insert(qq);
        }
    }
    dfs(0, -1);
    cout << "Yes\n";
    reverse(all(ans));
    for (int i: ans) {
        cout << i << ' ';
    }
}
