// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, gt;
    cin >> n >> gt;
    vector<pair<pair<int, int>, int>> edges(n - 1);
    vector<set<pair<int, int>>> g(n);
    map<pair<int, int>, int> ind;
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].first.first >> edges[i].first.second >> edges[i].second;
        edges[i].first.first--, edges[i].first.second--;
        ind[edges[i].first] = i;
        ind[make_pair(edges[i].first.second, edges[i].first.first)] = i;
        g[edges[i].first.first].emplace(edges[i].first.second, edges[i].second);
        g[edges[i].first.second].emplace(edges[i].first.first, edges[i].second);
    }
    vector<vector<int>> c(n);
    vector<set<pair<int, int>>> sc(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(g[i].size());
        for (int j = 0; j < (int)g[i].size(); ++j) {
            cin >> c[i][j];
            sc[i].emplace(c[i][j], j);
        }
        // reverse(c[i].begin(), c[i].end());
    }
    vector<pair<int, int>> vls(n - 1);
    set<pair<int, int>> vals;
    for (int i = 0; i < n; ++i) {
        if (g[i].size() == 1) {
            int vl = 0;
            for (int j = 0; j < (int)c[i].size(); ++j) {
                if (c[i][j] != -1) {
                    vl = c[i][j];
                }
            }
            vals.emplace(g[i].begin()->second - sc[i].begin()->first, i);
        }
    }
    for (int _ = 0; _ < n - 1; ++_) {
        while (!vals.empty() && g[vals.rbegin()->second].size() == 0) {
            vals.erase(*vals.rbegin());
        }
        if (vals.empty()) {
            cout << "No\n";
            return;
        }
        // sort(vals.rbegin(), vals.rend());
        int v = vals.rbegin()->second;
        int vl = vals.rbegin()->first;
        vals.erase(*vals.rbegin());
        int u = g[v].begin()->first;
        auto it = sc[u].lower_bound(make_pair(vl, -1));
        if (it == sc[u].end()) {
            cout << "No\n";
            return;
        }
        int id = it->second;
        int id2 = sc[v].begin()->second;
        // for (int j = 0; j < (int)c[v].size(); ++j) {
        //     if (c[v][j] != -1) {
        //         id2 = j;
        //     }
        // }
        // ans.emplace_back(max(id, id2), ind[make_pair(u, v)]);
        if (edges[ind[make_pair(u, v)]].first.first == v) {
            swap(u, v);
            swap(id, id2);
        }
        // cout << u << ' ' << v << ' ' << id << ' ' << id2 << ' ' << c[u].size() << ' ' << c[v].size() << endl;
        vls[ind[make_pair(u, v)]] = {id, id2};
        // cout << u << ' ' << v << ' ' << id << ' ' << id2 << '\n';
        sc[u].erase(make_pair(c[u][id], id));
        c[u][id] = -1;
        sc[v].erase(make_pair(c[v][id2], id2));
        c[v][id2] = -1;
        g[u].erase(g[u].lower_bound(make_pair(v, -1)));
        g[v].erase(g[v].lower_bound(make_pair(u, -1)));
        if (g[u].size() == 1) {
            vals.insert(make_pair(g[u].begin()->second - sc[u].begin()->first, u));
        }
        if (g[v].size() == 1) {
            vals.insert(make_pair(g[v].begin()->second - sc[v].begin()->first, v));
        }
        // cout << "!!!" << endl;
    }
    // sort(ans.rbegin(), ans.rend());
    vector<set<pair<int, int>>> st(n);
    for (int i = 0; i < n - 1; ++i) {
        st[edges[i].first.first].emplace(vls[i].first, i);
        st[edges[i].first.second].emplace(vls[i].second, i);
    }
    vector<int> cnt(n - 1);
    queue<int> q;
    for (int i = 0; i < n; ++i) {
        if (!st[i].empty()) {
            cnt[st[i].begin()->second]++;
            if (cnt[st[i].begin()->second] == 2) {
                q.push(st[i].begin()->second);
            }
        }
    }
    vector<int> ans;
    while (!q.empty()) {
        int id = q.front();
        q.pop();
        ans.push_back(id);
        st[edges[id].first.first].erase(make_pair(vls[id].first, id));
        if (!st[edges[id].first.first].empty()) {
            cnt[st[edges[id].first.first].begin()->second]++;
            if (cnt[st[edges[id].first.first].begin()->second] == 2) {
                q.push(st[edges[id].first.first].begin()->second);
            }
        }
        st[edges[id].first.second].erase(make_pair(vls[id].second, id));
        if (!st[edges[id].first.second].empty()) {
            cnt[st[edges[id].first.second].begin()->second]++;
            if (cnt[st[edges[id].first.second].begin()->second] == 2) {
                q.push(st[edges[id].first.second].begin()->second);
            }
        }
    }
    reverse(ans.begin(), ans.end());
    cout << "Yes\n";
    for (int i = 0; i < n - 1; ++i) {
        cout << ans[i] + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
