#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int inf = 2e9;

struct e
{
    int v, w, i;
};

struct par
{
    int x, i;
};

bool operator<(par a, par b)
{
    return a.x < b.x;
}

vector<e> *d;
vector<int> *c;
vector<par> *z;
int *q;

int dfs(int v, int p)
{
    z[v].resize(c[v].size());
    vector<par> a;
    for(e u : d[v]){
        if(u.v != p){
            int res = dfs(u.v, v);
            if(res == -1) return -1;
            a.push_back({u.w - res, u.v});
        }
        q[u.v] = u.i;
    }
    sort(a.begin(), a.end());
    vector<par> b;
    for(int i = 0; i < c[v].size(); ++i){
        b.push_back({c[v][i], (int)c[v].size() - i - 1});
    }
    sort(b.begin(), b.end());
    int l = a.size();
    int i = 0;
    for(; i < l; ++i){
        if(a[i].x > b[i].x) break;
        z[v][b[i].i] = {a[i].i, q[a[i].i]};
    }
    if(p != -1) z[v][b[i].i] = {p, q[p]};
    else z[v][b[i].i].x = p;
    int ans = b[i].x;
    for(; i < l; ++i){
        if(a[i].x > b[i + 1].x) break;
        z[v][b[i + 1].i] = {a[i].i, q[a[i].i]};
    }
    if(i == l) return ans;
    else return -1;
}

void print(int v, int p)
{
    for(par u : z[v]){
        if(u.x == -1) continue;
        if(u.x == p){
            cout << u.i + 1 << ' ';
        }
        else{
            print(u.x, v);
        }
    }
}

int main()
{
    int n, g;
    cin >> n >> g;
    d = new vector<e>[n];
    for(int i = 0; i < n - 1; ++i){
        int a, b, w;
        cin >> a >> b >> w;
        --a; --b;
        d[a].push_back({b, w, i});
        d[b].push_back({a, w, i});
    }
    c = new vector<int>[n];
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < d[i].size(); ++j){
            int ci;
            cin >> ci;
            c[i].push_back(ci);
        }
    }
    c[0].push_back(inf);
    z = new vector<par>[n];
    q = new int[n];
    if(dfs(0, -1) == inf){
        cout << "Yes" << endl;
        // for(int i = 0; i < n; ++i){
        //     for(par j : z[i]) cout << j.x << ' ' << j.i << "  ";
        //     cout << endl;
        // }
        print(0, -1);
        cout << endl;
    }
    else cout << "No" << endl;
    return 0;
}