#include <bits/stdc++.h>

using namespace std;
using ll = long long;


mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll mx_p = 50;

struct fast {
    ll n, group;
    vector<vector<tuple<ll, ll, ll>>> g;
    vector<vector<pair<ll, ll>>> ci;
    vector<vector<ll>> res;
    vector<vector<ll>> ribes;

    void dfs(ll v, ll p, ll p_id) {
        vector<pair<ll, ll>> ls;
        for (auto [w, to, id]: g[v]) {
            if (to == p) continue;
            dfs(to, v, id);
            ls.emplace_back(w - ci[to][0].first, id);
        }
        sort(ls.rbegin(), ls.rend());
        ll sz = ll(ci[v].size()) - 1;
        for (int i = 0; i < ll(ls.size()); i++) {
            if (sz - 1 >= 0 && ls[i].first <= ci[v][sz - 1].first) {
                res[v][ci[v][sz - 1].second] = ls[i].second;
                swap(ci[v].back(), ci[v][sz - 1]);
                ci[v].pop_back();
            } else if (ls[i].first <= ci[v][sz].first) {
                res[v][ci[v][sz].second] = ls[i].second;
                ci[v].pop_back();
            } else {
                cout << "No";
                exit(0);
            }
            sz--;
        }
        if (!ci[v].empty()) {
            res[v][ci[v][sz].second] = p_id;
        }
    }

    void print_res(ll v, ll p) {
        reverse(res[v].begin(), res[v].end());
        for (auto el: res[v]) {
            ll nxt = ribes[el][0] + ribes[el][1] - v;
            if (nxt == p) {
                cout << el + 1 << ' ';
            } else {
                print_res(nxt, v);
            }
        }
    }

    void solve() {
        cin >> n >> group;
        g.resize(n);
        ci.resize(n);
        res.resize(n);
        for (int i = 0; i < n - 1; i++) {
            ll f, s, w;
            cin >> f >> s >> w, f--, s--;
            g[f].push_back({w, s, i});
            g[s].push_back({w, f, i});
            ribes.push_back({f, s, w});
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < ll(g[i].size()); j++) {
                ll val;
                cin >> val;
                ci[i].push_back({val, j});
            }
            sort(ci[i].begin(), ci[i].end());
            res[i].resize(ll(g[i].size()));
        }
        dfs(0, -1, -1);
        cout << "Yes\n";
        print_res(0, -1);
    }

};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    bool stress = false;
    int times = 1;
//    cin >> times;
    if (stress) times = 1e9;
    while (times--) {
        fast f;
        f.solve();
    }
    return 0;
}
