#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("popcnt")

#define int long long
using ll = long long;
#define forn(i,n) for(int i=0; i<n; ++i)
#define pb push_back
#define all(x) x.begin(),x.end()
#define pi pair<int,int>
#define f first
#define s second
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];

const ll inf = 1e18;

int n,g;

const int N=2e5+5;
vector<pi> adj[N];
int w[N];
pi e[N];

vector<int> z[N];
multiset<int> s[N];

pi ok[N];

void dfs(int u, int p) {
	for(auto&e:adj[u]) {
		int v=e.f, i=e.s; int w=::w[i];
		if (v==p) continue;
		dfs(v,u);
		assert(s[v].size());
		int x = *s[v].begin();
		auto it = s[u].lower_bound(w-x);
		if (it==s[u].end()) {
			cout<<"No\n"; exit(0);
		}
		int y = *it;
		s[u].erase(it);
		::e[i] = {v,u};
		ok[i] = {x,y};
	}
}

vector<int> z2[N];
unordered_map<int,vector<int>> mp[N];

void solve() {

	forn(i,n-1) {
		int u,v; cin>>u>>v; --u, --v;
		e[i]={u,v};
		adj[u].pb({v,i});
		adj[v].pb({u,i});
		cin>>w[i];
	}
	forn(i,n) {
		int m=adj[i].size();
		vii(b,m);
		z[i]=b;
		for(auto&x:b) s[i].insert(x);
	}
	
	dfs(0,-1);
	forn(i,n-1) {
		int u=e[i].f, v=e[i].s;
		int x=ok[i].f, y=ok[i].s;
		//mp[u][x].pb(i);
		mp[v][y].pb(i);
	}
	forn(i,n-1) {
		int u=e[i].f, v=e[i].s;
		int x=ok[i].f, y=ok[i].s;
		mp[u][x].pb(i);
		//mp[v][y].pb(i);
	}
	forn(i,n) {
		for(auto&x:z[i]) {
			z2[i].pb(mp[i][x].back());
			mp[i][x].pop_back();
		}
	}
	//forn(i,n-1) cout<<e[i].f<<' '<<e[i].s<<":  "<<ok[i].f<<' '<<ok[i].s<<'\n';

	vector<int> cnt(n-1,0);
	vector<int> ans;
	queue<int> q;
	forn(i,n-1) {
		int u=e[i].f, v=e[i].s;
		//int x=ok[i].f, y=ok[i].s;
		//cnt[z2[u].back()]++;
		//cnt[z2[v].back()]++;
		if (z2[u].back()!=i) continue;
		if (z2[v].back()!=i) continue;
		q.push(i);
	}
	forn(i,n) ++cnt[z2[i].back()];
	forn(i,n) {
		//cout<<i<<": "; for(auto&x:z2[i]) cout<<x<<' '; cout<<'\n';
	}
	while (q.size()) {
		int i=q.front(); q.pop();
		//cout<<"? "<<i<<'\n';
		ans.pb(i);
		int u=e[i].f, v=e[i].s;
		z2[u].pop_back();
		z2[v].pop_back();
		if (z2[u].size()) {
			cnt[z2[u].back()]++;
			if (cnt[z2[u].back()]==2) q.push(z2[u].back());
		}
		if (z2[v].size()) {
			cnt[z2[v].back()]++;
			if (cnt[z2[v].back()]==2) q.push(z2[v].back());
		}
	}
	if (ans.size()<n-1) {
		cout<<"No\n"; return;
	}
	cout<<"Yes\n";
	for(auto&x:ans) cout<<x+1<<' '; cout<<'\n';

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cin>>n>>g;
	//if (g==1) brut();
	//if (g==2) p2();
	//else if (g==3) p3();
	//else
	//else if (g==4) p4();

	solve();
}