#pragma GCC optimize("Ofast,inline")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
#define fi first
#define se second

const int N = 2e5 + 12;
struct Edge{
    int a, b, w;
} e[N];
int deg[N], pr[2][N];
bool dp[2][N];
int c[N][2];

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, G;
    cin >> n >> G;
    for(int i = 0; i < n - 1; ++i) {
        cin >> e[i].a >> e[i].b >> e[i].w;
        deg[e[i].a]++;
        deg[e[i].b]++;
    }
    for(int i = 1; i <= n; ++i) {
        for(int j = 0; j < deg[i]; ++j) {
            cin >> c[i][j];
        }
    }
    dp[1][n] = 1;
    deg[n] = 2;
    for(int i = n - 1; i >= 1; --i) {
//        cerr << i << endl;
        int a = i, b = i + 1;
        for(int d1 = 0; d1 < deg[a]; ++d1) {
            for(int d2 = 0; d2 < deg[b]; ++d2) {
                if(!dp[d2][b])
                    continue;
                if(c[a][d1] + c[b][1-d2] <= e[i-1].w) {
                    dp[d1][a] = 1;
//                    cout << d1 << ' ' << a << '\n';
                    pr[d1][a] = 1 - d2;
                }
            }
        }
    }
    if(dp[0][1] == 0) {
        cout << "No";
        return 0;
    }
    vector <pair<int,int>> v;
    int i = 0, j = 1;
    while(true) {
        if(j > n)
            break;
        v.push_back({i, j});
        i = pr[i][j];
        j++;
    }
    vector <int> ans;
    for(i = 0; i + 1 < v.size(); ++i) {
        if(v[i].fi == 0 & v[i+1].fi == 0)
            ans.push_back(i + 1);
    }
    for(i = 0; i + 1 < v.size(); ++i) {
        if(v[i].fi == 1 & v[i+1].fi == 0)
            ans.push_back(i + 1);
    }
    for(i = v.size() - 2; i >= 0; --i) {
        if(v[i].fi == 0 && v[i+1].fi == 1)
            ans.push_back(i + 1);
    }
    for(i = v.size() - 2; i >= 0; --i) {
        if(v[i].fi == 1 && v[i+1].fi == 1)
            ans.push_back(i + 1);
    }
    cout << "Yes\n";
    for(auto to : ans) {
        cout << to << '\n';
    }
    return 0;
}
