#pragma GCC optimize("Ofast,inline")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
#define fi first
#define se second

const int N = 2e5 + 12;
struct Edge {
    int a, b, w;
} e[N];
int deg[N], pr[2][N];
bool dp[2][N];
vector <int> c[N];

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, G;
    cin >> n >> G;
    for(int i = 0; i < n - 1; ++i) {
        cin >> e[i].a >> e[i].b >> e[i].w;
        deg[e[i].a]++;
        deg[e[i].b]++;
    }
    for(int i = 1; i <= n; ++i) {
        c[i].resize(deg[i]);
//        cerr << i << ' ' << c[i].size() << ' ' << deg[i] << endl;
        for(int j = 0; j < deg[i]; ++j) {
            cin >> c[i][j];
        }
    }
//    cerr << G << endl;
//    return 0;
    if(G == 0 || G == 1) {
        int p[n];
        for(int i = 0; i < n - 1; ++i) {
            p[i] = i;
        }
//        p[0] = 0;
//        p[1] = 3;
//        p[2] = 1;
//        p[3] = 2;
//        cerr << "start" << endl;
//        return 0;
        int pos[n+1];
        do {
//            cerr << 1 << endl;
            for(int i = 1; i <= n; ++i) {
//                cerr << i << endl;
                pos[i] = deg[i] - 1;
            }
            bool f = 1;
            for(int id = 0; id < n - 1; ++id) {
//                cerr << id << endl;
                int i = p[id];
                int a = e[i].a, b = e[i].b;
                if(c[a][pos[a]] + c[b][pos[b]] >= e[i].w) {
                    pos[a]--;
                    pos[b]--;
                } else {
//                    cerr << c[a][pos[a]] << ' ' << c[b][pos[b]] << ' ' << e[i].w << endl;
//                    cout << id << '\n';
                    f = 0;
                    break;
                }
            }
            if(f) {
                cout << "Yes\n";
                for(int i = 0; i < n - 1; ++i) {
                    cout << p[i] + 1 << ' ';
                }
                return 0;
            }
        } while(next_permutation(p, p + n - 1));
        cout << "No";
        return 0;
    }
    if(G == 2) {
        dp[1][n] = 1;
        for(int i = n - 1; i >= 1; --i) {
//        cerr << i << endl;
            int a = i, b = i + 1;
            for(int d1 = 0; d1 < deg[a]; ++d1) {
                for(int d2 = 0; d2 < deg[b]; ++d2) {
                    if(!dp[1-d2][b])
                        continue;
                    if(c[a][d1] + c[b][d2] >= e[i-1].w) {
                        dp[d1][a] = 1;
//                    cout << d1 << ' ' << a << '\n';
                        pr[d1][a] = d2;
                    }
                }
            }
        }
        if(dp[0][1] == 0) {
            cout << "No";
            return 0;
        }
        struct node {
            int i, d1, d2;
        };
        vector <node> v;
        int i = 0, j = 1;
        while(true) {
            if(j >= n)
                break;
            v.push_back({j, i, pr[i][j]});
            i = 1 - pr[i][j];
            j++;
        }
        for(auto &to : v) {
            to.d1 = 1 - to.d1;
            to.d2 = 1 - to.d2;
//        cout << to.i << ' ' << to.d1 << ' ' << to.d2 << '\n';
        }
        vector <int> ans;
        for(i = 0; i < v.size(); ++i) {
            if(v[i].d1 == 0 && v[i].d2 == 0)
                ans.push_back(i + 1);
        }
        for(i = v.size() - 1; i >= 0; --i) {
            if(v[i].d1 == 0 && v[i].d2 == 1)
                ans.push_back(i + 1);
        }
        for(i = 0; i < v.size(); ++i) {
            if(v[i].d1 == 1 && v[i].d2 == 0)
                ans.push_back(i + 1);
        }
        for(i = v.size() - 1; i >= 0; --i) {
            if(v[i].d1 == 1 && v[i].d2 == 1)
                ans.push_back(i + 1);
        }
        cout << "Yes\n";
        for(auto to : ans) {
            cout << to << '\n';
        }
        return 0;
    }
    if(G == 3) {
        map <pair<int,int>,int> cost;
        for(int i = 0; i < n - 1; ++i) {
            cost[{e[i].a,e[i].b}] = cost[{e[i].b,e[i].a}] = e[i].w;
        }
        set <pair<int,int>> v;
        for(int i = 2; i <= n; ++i) {
            v.insert({cost[{1, i}], i});
        }
        vector <int> ans;
        for(int i = deg[1] - 1; i >= 0; --i) {
            int x = c[1][i];
            auto it = v.lower_bound({x, 1});
            if(it == v.end()) {
                cout << "No";
                return 0;
            }
            ans.push_back((*it).se);
            v.erase(it);
        }
        cout << "Yes\n";
        for(auto to : ans) {
            cout << to << ' ';
        }
        return 0;
    }
    return 0;
}
