#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
#define int int64_t
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF = 1e9 + 117;

int n, gg;
vector<vector<pair<int, int>>> g;
vector<vector<int>> vals, svals;
vector<map<int, vector<int>>> gd;
vector<int> gow;
map<pair<int, int>, int> inds;


void dfs_gow(int v, int p = -1) {
    vector<int> used(g[v].size(), 1);
    if (g[v].size() == 1) {
        gow[v] = vals[v].front();
        return;
    }
    for (auto& [e, w] : g[v]) {
        if (e == p) continue;
        dfs_gow(e, v);
        int ind = lower_bound(svals[v].begin(), svals[v].end(), w - gow[e]) - svals[v].begin();
        // ind = lower_bound(used.begin() + ind, used.end(), 0) - used.begin();
        while (used[ind] == -1 && ind < used.size()) ind++;
        if (ind == used.size()) {
            cout << "NO\n";
            exit(0);
        }
        used[ind] = -1;
        gd[v][svals[v][ind]].push_back(e);
    }
    for (int i = 0; i < g[v].size(); ++i) {
        if (used[i] == -1) continue;
        gow[v] = svals[v][i];
        break;
    }
}

vector<int> ans;

void draw(int v, int e) {

    for (auto& val : vals[e]) {
        if (gow[e] == val) break;
        int ee = gd[e][val].back();
        gd[e][val].pop_back();
        draw(e, ee);
    }

    ans.push_back(inds[{v, e}]);

    bool fl = false;
    for (auto& val : vals[e]) {
        if (gow[e] == val && !fl) {
            fl = true;
            continue;
        }
        if (!fl) continue;
        int ee = gd[e][val].back();
        gd[e][val].pop_back();
        draw(e, ee);
    }
}

void dfs_do(int e) {
    for (auto& val : vals[e]) {
        if (gow[e] == val) break;
        int ee = gd[e][val].back();
        gd[e][val].pop_back();
        draw(e, ee);
    }
}

void dfs_posle(int e) {
    bool fl = false;
    for (auto& val : vals[e]) {
        if (gow[e] == val && !fl) {
            fl = true;
            continue;
        }
        if (!fl) continue;
        int ee = gd[e][val].back();
        gd[e][val].pop_back();
        draw(e, ee);
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> gg;
    g.resize(n);
    vals.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w; cin >> u >> v >> w; --u; --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        inds[{u, v}] = i;
        inds[{v, u}] = i;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            int c; cin >> c;
            vals[i].push_back(c);
        }
    }
    svals = vals;
    for (auto& e : svals) sort(e.begin(), e.end());
    gow.resize(n);
    gd.resize(n);
    dfs_gow(0, -1);
    for (auto& val : vals[0]) {
        int e = gd[0][val].back();
        gd[0][val].pop_back();
        draw(0, e);
    }
    reverse(ans.begin(), ans.end());
    for (auto& e : ans) cout << e + 1 << ' ';
    return 0;
}
