#include <bits/stdc++.h>
#define forn(i, n) for (long long i = 0; i < n; i++)
#define ff first
#define ss second

using namespace std;
using ll = long long;

const ll N = 2e6 + 10;

struct edge{
    ll w;
    pair<ll, ll> a;
    pair<ll, ll> b;
    ll i;
};

edge e[N];
ll n, t;

vector<pair<ll, ll>> g[N];
vector<pair<ll, ll>> s[N];

ll dfs(ll v, ll p) {
    if (g[v].size() == 1 && v != 0) {
        e[g[v][0].ss].a = {v, 0};
        return s[v][0].ff;
    }
    //if (v == 2)
        //cout << 2;
    vector<pair<ll, ll>> d;
    ll par = 0;
    for (auto u : g[v]) {
        if (u.ff == p) {
            par = u.ss;
            continue;
        }
        d.push_back({e[u.ss].w - dfs(u.ff, v), u.ss});
    }
    sort(d.begin(), d.end());
    sort(s[v].begin(), s[v].end());
    ll j = 0, skip = -1;
    forn(i, d.size()) {
        if (d[i].ff > s[v][j].ff) {
            if (skip != -1 || v == 0) {
                cout << "NO";
                exit(0);
            }
            skip = j;
            j++;
            if(d[i].ff > s[v][j].ff) {
                cout << "NO";
                exit(0);
            }
        }
        e[d[i].ss].b = {v, s[v][j].ss};
        j++;
    }
    if (v == 0)
        return -1;
    e[par].a = {v, s[v][skip].ss};
    return s[v][skip].ff;
}

bool cmp(edge x, edge y) {
    if (x.a.ff == y.a.ff)
        return x.a.ss < y.a.ss;

    if (x.b.ff == y.a.ff)
        return x.b.ss < y.a.ss;

    if (x.b.ff == y.b.ff)
        return x.b.ss < y.b.ss;

    if (x.a.ff == y.b.ff)
        return x.a.ss < y.b.ss;
    return false;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef HOME_ZHEGLOV
    freopen("inp.txt", "r", stdin);
#endif
    cin >> n >> t;
    forn(i, n - 1) {
        ll x, y, z;
        cin >> x >> y >> z; x--; y--;
        e[i].w = z;
        e[i].i = i + 1;
        g[x].push_back({y, i});
        g[y].push_back({x, i});
    }
    forn(i, n) {
        forn(j, g[i].size()) {
            ll x;
            cin >> x;
            s[i].push_back({x, j}   );
        }
    }
    dfs(0, -1);
    sort(e, &e[n - 1], cmp);
    cout << "YES\n";
    forn(i, n - 1) {
        cout << e[i].i << " ";
    }
    return 0;
}