#include<bits/stdc++.h>
#include<bits/extc++.h>

#define int long long


using namespace std;
using namespace __gnu_pbds;

const int inf = 10000000000000000L;

struct Node {
    int a,b,w;
};
int n ;
vector<vector<pair<int,int>>> g;
vector<Node> edg(0);
vector<vector<int>> c;

vector<int> nperm = {0,3,1,2};

bool isOk(vector<int> perm){

    vector<int> it(n);
    for(int i=0;i<n;i++) it[i] = c[i].size() - 1;
    for(int i=0;i<perm.size();i++){
        int si = i;
        i = perm[i];
        int v = edg[i].a;
        int u = edg[i].b;
        if(it[v] < 0 || it[u] < 0) {

            return false;
        }
        if(c[v][it[v]] + c[u][it[u]] < edg[i].w) {

            return false;
        }
        it[v]--;
        it[u]--;
        i = si;
    }
    return true;

}



int32_t main(){

    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int tgg;
    cin >> n >> tgg;

    g = vector<vector<pair<int,int>>>(n);

    for(int i=0;i<n-1;i++){
        int a,b,ww;
        cin >> a >> b >> ww;
        a--;b--;
        g[a].push_back({b,ww});
        g[b].push_back({a,ww});
        edg.push_back({a,b,ww});
    }

    c = vector<vector<int>> (n);
    for(int i=0;i<n;i++){
        for(int j=0;j<g[i].size();j++){
            int vc;
            cin >> vc;
            c[i].push_back(vc);
        }
    }

    vector<int> perm(n-1);
    for(int i=0;i<n-1;i++){
        perm[i] = i;
    }
    bool gd = true;
    while(!isOk(perm)){
        if(!next_permutation(perm.begin(),perm.end())) {gd = false;break;}
    }
    if(gd){
        cout << "YES" << endl;
        for(int i=0;i<n-1;i++) cout << perm[i] + 1 << " ";
        cout << endl;
    }else{
        cout << "NO" << endl;
    }

    return 0;
}
