#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//template<class c, class cmp = less<c>> using ordered_set = tree<c,null_type,cmp,rb_tree_tag,tree_order_statistics_node_update>;

#define int long long
#define ll long long
#define str string
#define ff first
#define ss second
#define db double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()
mt19937 rnd(time(0));

const ll INF = 1e18;
const db EPS = 1e-6;
const int MOD = 1e9 + 7;
const int MAXN = 1e2 + 10;

void solve();

void fastios() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

signed main() {
    fastios();
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    double start = clock();
#endif
    int ttt = 1;
//    cin >> ttt;
    while (ttt--) {
        solve();
#ifdef LOCAL
        cout << "--------------------------\n";
#endif
    }
#ifdef LOCAL
    cerr << "Time: " << (clock() - start) / CLOCKS_PER_SEC << '\n';
#endif
}

struct Node {
    int a, b, w;
};

int n, G;
Node a[MAXN];
vector<int> c[MAXN];

bool check(vector<int> &p) {
    vector<int> cur(n);
    for (int i = 0; i < n - 1; ++i){
        int ai = a[p[i]].a;
        int bi = a[p[i]].b;
        int wi = a[p[i]].w;
        if (wi > c[ai][cur[ai]] + c[bi][cur[bi]])
            return false;
        cur[ai]++;
        cur[bi]++;
    }
    return true;
}

void solve() {
    cin >> n >> G;
    if (G > 1)
        return;
    for (int i = 0; i < n - 1; ++i) {
        cin >> a[i].a >> a[i].b >> a[i].w;
        a[i].a--;
        a[i].b--;
    }
    str s;
    getline(cin, s);
    for (int i = 0; i < n; ++i) {
        getline(cin, s);
        int tmp = 0;
        s += ' ';
        for (char x: s) {
            if ('0' <= x && x <= '9')
                tmp = tmp * 10 + (x - '0');
            else {
                c[i].push_back(tmp);
                tmp = 0;
            }
        }
        reverse(all(c[i]));
    }
    vector<int> p(n - 1);
    iota(all(p), 0);
    do {
        if (check(p)) {
            cout << "Yes\n";
            for (int i = 0; i < sz(p) - 1; ++i)
                cout << p[i] + 1 << ' ';
            cout << p.back() + 1 << '\n';
            return;
        }
    } while (next_permutation(all(p)));
    cout << "No\n";
}