#include <bits/stdc++.h>
using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t=1;
    //cin>>t;
    while(t--) {
        solve();
    }
    return 0;
}
// графы(dfs bfs djikstra) дп конструктивы геома жадник
// линалг бинпоиск

#define int long long
#define endl '\n'
const int N=2e5+10,INF=2e15,MOD=1e9+7;
struct Edge{
    int a,b,c;
};

vector<vector<int>> gr(N);
map<pair<int,int>,int> power;
void solve(){
    int n,g;
    cin>>n>>g;

    vector<Edge> e;
    for(int i=0;i<n-1;i++){
        int a,b,v;
        cin>>a>>b>>v;
        a--;b--;
        power[{a,b}]=v;
        power[{b,a}]=v;
        gr[a].emplace_back(b);
        gr[b].emplace_back(a);
        e.push_back({a,b,v});
    }
    vector<vector<int>> c(n);
    for(int i=0;i<n;i++){
        c[i].resize(gr[i].size());
        for(int j=0;j<gr[i].size();j++){
            cin>>c[i][j];
        }
    }
    vector<int> p(n-1);
    iota(p.begin(),p.end(),0);
    do{
        vector<vector<int>> nc=c;
        vector<int> pos(n,0);
        bool err=false;
        for(int i=0;i<n-1;i++){
            if(nc[e[p[i]].a].back()+nc[e[p[i]].b].back()<e[p[i]].c){
                err=true;
                break;
            }
            nc[e[p[i]].a].pop_back();
            nc[e[p[i]].b].pop_back();
        }
        if(!err){
            cout<<"Yes"<<endl;
            for(auto c:p){
                cout<<c+1<<" ";
            }cout<<endl;
            return;
        }
    }while(next_permutation(p.begin(),p.end()));
    cout<<"No"<<endl;
}