
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define endl '\n'
#define F first
#define S second
#define pii pair <int , int>
#define ve vector
#define pb push_back
#define all(x) x.begin() , x.end()
#define int ll


using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef __int128_t bll;

typedef tree <int , null_type , less <int> , rb_tree_tag , tree_order_statistics_node_update> oset;

const int N = int(3e5 + 100);

struct edge
{
    int x , y , cnt , A = -1 , B = -1;
    edge()
    {
        x = -1 , y = -1;
        cnt = 0;
    }
    edge(int _x , int _y , int _cnt)
    {
        x = _x;
        y = _y;
        cnt = _cnt;
    }
};


edge reb[N];
ve <int> c[N];
int deg[N];
map <pii , int> cost;
ve <int> top_sort;
int used[N];
ve <int> g_way[N];
bool ok = 1;

void dfs_top_sort(int v)
{
    used[v] = 1;
    for(auto to : g_way[v])
    {
        if(used[to] == 1)
        {
            continue;
        }
        dfs_top_sort(to);
    }
    top_sort.pb(v);
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt" , "r" , stdin);
        freopen("output.txt" , "w" , stdout);
    #endif // LOCAL
    int n , test_case;
    cin >> n >> test_case;
    for(int i = 0;i < n - 1;++ i)
    {
        cin >> reb[i].x >> reb[i].y >> reb[i].cnt;
        -- reb[i].x;
        -- reb[i].y;
        cost[{reb[i].x , reb[i].y}] = reb[i].cnt;
        cost[{reb[i].y , reb[i].x}] = reb[i].cnt;
        deg[reb[i].x] ++;
        deg[reb[i].y] ++;
    }
    for(int i = 0;i < n;++ i)
    {
        for(int j = 0;j < deg[i];++ j)
        {
            ll x;
            cin >> x;
            c[i].pb(x);
        }
    }
    if(test_case <= 1)
    {
        ve <int> nom;
        for(int i = 0;i < n - 1;++ i)
        {
            nom.pb(i);
        }
        do
        {
            ve <int> w[n];
            for(int i = 0;i < n;++ i)
            {
                w[i].clear();
            }
            bool fl = 1;
            for(int i = 0;i < n - 1;++ i)
            {
                //cerr<< nom[i] << ' ';
                ll pos1 = w[reb[nom[i]].x].size();
                ll pos2 = w[reb[nom[i]].y].size();
                ll v1 = reb[nom[i]].x;
                ll v2 = reb[nom[i]].y;
                w[reb[nom[i]].x].pb(reb[nom[i]].cnt);
                ///cerr << pos1 << ' ' << w[reb[nom[i]].x].size() << endl;
                w[reb[nom[i]].y].pb(reb[nom[i]].cnt);
                ///continue;
                if(c[v1][deg[v1] - 1 - pos1] + c[v2][deg[v2] - 1 - pos2] >= reb[nom[i]].cnt)
                {
                    continue;
                }
                else
                {
                    fl = 0;
                    break;
                }
            }
            if(fl)
            {
                cout << "Yes\n";
                for(auto to : nom)
                {
                    cout << to + 1 << ' ';
                }
                return 0;
            }
            ///cout << endl;
        }while(next_permutation(all(nom)));
        cout << "No";
        return 0;
    }
    if(test_case == 2)
    {
        ve <int> ans;
        if(n == 2)
        {
            cout << "Yes" << endl;
            cout << "1";
            return 0;
        }
        reb[0].A = c[0][0];
        ll i = 0;
        for(int i = 0;i < n;++ i)
        {
            g_way[i].clear();
        }
        while(i < n - 1)
        {
            ll lim = reb[i].cnt - reb[i].A;
            ll mn = 1e9;
            for(auto to : c[i + 1])
            {
                if(to >= lim)
                {
                    mn = min(mn , to);
                }
            }
            if(mn == 1e9)
            {
                cout << "No";
                return 0;
            }
            reb[i].B = mn;
            if(c[i + 1].size() == 2)
            {
                reb[i + 1].A = max(c[i + 1][0] , c[i + 1][1]);
                if(reb[i + 1].A == c[i + 1][0])
                {
                    g_way[i].pb(i + 1);
                    ///cout << "???" << reb[i].A << ' ' << reb[i].B << ' ' << i << ' ' << i + 1 << endl;
                }
                else
                {
                    g_way[i + 1].pb(i);
                    ///cout << "!!!" << reb[i].A << ' ' << reb[i].B << ' ' << i + 1 << ' ' << i << endl;
                }
            }
            ++ i;
        }
        for(int i = 0;i < n - 1;++ i)
        {
            if(!used[i])
            {
                dfs_top_sort(i);
            }
        }
        ///reverse(all(top_sort));
        if(!ok)
        {
            cout << "No";
            return 0;
        }
        cout << "Yes\n";
        for(auto to : top_sort)
        {
            cout << to + 1 << ' ';
        }
    }
}
