//Туры-пуры

#include<bits/stdc++.h>

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);

    int n, group;
    std::cin >> n >> group;
    std::vector<std::set<std::pair<int, int>>> g(n);
    std::map<std::pair<int, int>, int> id;
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        std::cin >> u >> v >> w;
        --u, --v;
        id[{u, v}] = i;
        id[{v, u}] = i;
        g[u].emplace(v, w);
        g[v].emplace(u, w);
    }
    std::vector<std::vector<int>> go(n);
    std::vector<std::set<std::pair<int, int>>> st(n);
    for (int i = 0; i < n; ++i) {
        for (int _ = 0; _ < g[i].size(); ++_) {
            int x;
            std::cin >> x;
            st[i].emplace(x, _);
            go[i].push_back(-1);
        }
    }
    std::queue<int> q;
    for (int i =0; i < n; ++i) {
        if (g[i].size() <= 1) q.push(i);
    }
    int root = 0;
    while (q.size()) {
        int u = q.front();
        q.pop();
        if (g[u].empty()) continue;
        int v = g[u].begin()->first;
        int w = g[u].begin()->second;
        int we = st[u].begin()->first;
        int id = st[u].begin()->second;
        g[u].clear();
        st[u].clear();
        auto o = st[v].lower_bound({w - we, -1e9});
        if (o == st[v].end()) {
            std::cout << "No\n";
            return 0;
        }
        st[v].erase(o);
        go[u][id] = v;
        go[v][o->second] = u;
        g[v].erase({u, w});
        if (g[v].size() == 1) {
            q.push(v);
        }
    }
    std::cout << "Yes\n";
    std::vector<std::deque<int>> res(n);
    auto dfs = [&](auto dfs, int u, int p) -> void {
        for (auto to : go[u]) {
            if (to == p) {
//                std::cout << u << ' ' << to << std::endl;
                res[u].push_front(id[{u, p}]);
            } else {
                dfs(dfs, to, u);
                if (res[u].size() >= res[to].size()) {
                    for (auto x : res[to]) res[u].push_front(x);
                    res[to].clear();
                } else {
                    for (auto x : res[u]) res[to].push_back(x);
                    res[u].clear();
                    std::swap(res[u], res[to]);
                }
            }
        }
    };
    dfs(dfs, 0, -1);
    for (auto x : res[0]) std::cout << x + 1 << ' ';
}