#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;

struct edge {
	int a, b, w;
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, g;
	cin >> n >> g;
	vector<edge> mas(n - 1);
	vector<int> deg(n, 0);
	for (int i = 0; i < n - 1; ++i) {
		cin >> mas[i].a >> mas[i].b >> mas[i].w;
		mas[i].a--; mas[i].b--;
		deg[mas[i].a]++;
		deg[mas[i].b]++;
	}
	vector<vector<int>> c(n);
	for (int i = 0; i < n; ++i) {
		c[i].resize(deg[i]);
		for (int j = 0; j < deg[i]; ++j)
			cin >> c[i][j];
	}
	vector<int> posl(n - 1);
	for (int i = 0; i < n - 1; ++i)
		posl[i] = i;
	do {
		vector<int> cur_ind(n);
		for (int i = 0; i < n; ++i)
			cur_ind[i] = deg[i] - 1;
		bool flag = true;
		for (int i : posl) {
			int u = mas[i].a, v = mas[i].b, w = mas[i].w;
			if (c[u][cur_ind[u]] + c[v][cur_ind[v]] < w) {
				flag = false;
				break;
			}
			cur_ind[u]--; cur_ind[v]--;
		}
		if (flag) {
			cout << "Yes\n";
			for (int el : posl) cout << el + 1 << " ";
			return 0;
		}
	} while (next_permutation(posl.begin(), posl.end()));
	cout << "No";

	return 0;
}