#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
//#pragma GCC optimize("trapv")
#endif
#include <bits/stdc++.h>

const int MAX_N = (int)3e5+10;
const int INT_INF = (int)2e9;
const double pi = acos(-1);


using namespace std;
using ld = long double;
using ll = long long;

struct Rebr{
    int a,b,w;
};
vector<vector<int>>stickers;
vector<Rebr>e;
vector<int>deg;
int n,g;

bool check_for_permut(vector<int> permut){
    vector<vector<int>>stick =stickers;
//    for(auto&c:stick){
//        reverse(c.begin(), c.end());
//    }
    for(int &c:permut) c--;
    for(int i = 0;i<n-1;++i){
        if(stick[e[permut[i]].a].back()+stick[e[permut[i]].b].back()<e[permut[i]].w){
            return false;
        }
        stick[e[permut[i]].a].pop_back();
        stick[e[permut[i]].b].pop_back();
    }
    return true;
}

void solve_for_1(){
    vector<int>per(n-1);
    for(int i = 1;i<n;++i){
        per[i-1] = i;
    }
    while(true){
        if(check_for_permut(per)){
            cout<<"Yes\n";
            for(int i = 0;i<n-1;++i){
                cout<<per[i]<<" ";
            }
            return;
        }
        if(!next_permutation(per.begin(), per.end())){
            break;
        }
    }
    cout<<"No";
}

int get_par(int ind, const vector<vector<pair<int,int>>>&graph){
    //0 сначала ind+1 потом ind-1
    //1 сначала ind-1 потом ind+1
    //-1 невозсожно
    Rebr left,right;
    left = e[graph[ind][0].second];
    right = e[graph[ind][1].second];
    if(stickers[ind].back()+stickers[ind-1].back()>=left.w &&
        stickers[ind][(int)stickers.size()-2]+stickers[ind+1].back()>=right.w){
        stickers[ind-1].pop_back();
        stickers[ind+1].pop_back();
        return 1;
    }
    else if(stickers[ind+1].back()+stickers[ind].back()>=right.w &&
            stickers[ind][(int)stickers.size()-2]+stickers[ind-1].back()>=left.w){
        stickers[ind-1].pop_back();
        stickers[ind+1].pop_back();
        return 0;
    }
    else return -1;

}

void solve_for_2(){
    for(auto &c:stickers){
        reverse(c.begin(), c.end());
    }
    vector<vector<pair<int,int>>>graph(n+1);
    vector<int>ans;
    vector<bool>isDel(n+1);
    for(int i = 0;i<n;++i){
        graph[e[i].a].emplace_back(e[i].b,i);
        graph[e[i].b].emplace_back(e[i].a,i);
    }
    for(int i = n-1;i>=2;i-=2){
        int res = get_par(i,graph);
        if(graph[i][0].first>graph[i][0].first){
            swap(graph[i][0],graph[i][1]);
        }
        if(res==-1){
            cout<<"No";
            return;
        }
        else if(res==0){
            ans.push_back(graph[i][1].second+1);
            ans.push_back(graph[i][0].second+1);
        }
        else{
            ans.push_back(graph[i][0].second+1);
            ans.push_back(graph[i][1].second+1);
        }
    }
    cout<<"Yes\n";
    for(auto c:ans){
        cout<<c<<" ";
    }
}

void input(){
    cin>>n>>g;
    stickers.resize(n+1);
    e.resize(n-1);
    deg.resize(n+1);
    for(int i = 0;i<n-1;++i){
        cin>>e[i].a>>e[i].b>>e[i].w;
        deg[e[i].a]++;
        deg[e[i].b]++;
    }
    for(int i = 1;i<=n;++i){
        int k = deg[i];
        stickers[i].resize(k);
        for(int j = 0;j<k;++j){
            cin>>stickers[i][j];
        }
    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
    input();
    if(g==1 || g==0) {
        solve_for_1();
    }
    if(g==2){
        solve_for_2();
    }
    return 0;
}
