//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ll = long long;
using ld = long double;

const ll INF = 2e18;
const int MOD = 1e9 + 7, N = 1e5 + 1, MAXN = 5e5 + 1, K = 26, INFi = 2e9;
const ld EPS = 1e-12, PI = acos(-1);

random_device rd;
mt19937_64 rnd(rd());

struct edge{
    int a, b, w;
    edge(){}
    edge(int a, int b, int w) {
        this->a = a, this->b = b, this->w = w;
    }
};

vector<int> st(N);

void solve() {
    int n, G;
    cin >> n >> G;
    vector<edge> ed;
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        st[a]++;
        st[b]++;
        ed.emplace_back(a, b, w);
    }
    vector<vector<int>> c(n + 1);
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < (int)st[i]; j++) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
    }
    vector<int> p(n - 1);
    iota(p.begin(), p.end(), 0);
    next_permutation(p.begin(), p.end());
    do {
        vector<vector<int>> c1 = c;
        bool fl = true;
        for (int i = 0; i < n - 1; i++) {
            auto [a, b, w] = ed[p[i]];
            if (c1[a].back() + c1[b].back() < w) {
//                for (int &e : p) {
//                    cout << e << ' ';
//                } cout << '\n';
//                cout << a << ' ' << c1[a].back() << ' ' << b << ' ' << c1[b].back() << endl;
                fl = false;
                break;
            }
            c1[a].pop_back(), c1[b].pop_back();
        }
        if (fl) {
            cout << "Yes\n";
            for (int &e : p) {
                cout << e + 1 << ' ';
            }
            return;
        }
    } while (next_permutation(p.begin(), p.end()));
    cout << "No";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
