#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <algorithm>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
//#define int ll

using namespace std;

mt19937 rnd(0);

vector<vector<int>> g;

void solve() {
    int n, group;
    cin >> n >> group;
    g.resize(n);
    vector<tuple<int, int, int>> ul(n - 1);
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
        ul[i] = { u, v, w };
    }
    vector<vector<int>> c(n);
    vector<vector<bool>> dp(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
        reverse(all(c[i]));
        dp[i].resize(c[i].size());
    }
    vector<int> per(n-1);
    for (int i = 0; i < n-1; i++) {
        per[i] = i;
    }
    bool f = 1;
    vector<int> cnt(n);
    for (int i = 0; i < n-1; i++) {
        auto [u, v, w] = ul[per[i]];
        if (c[u][cnt[u]] + c[v][cnt[v]] > w) {
            f = 0;
        }
        cnt[u]++;
        cnt[v]++;
    }
    if (f) {
        cout << "Yes\n";
        for (auto i : per) {
            cout << i + 1 << ' ';
        }
        return;
    }
    while (next_permutation(all(per))) {
        f = 1;
        cnt.assign(n, 0);
        for (int i = 0; i < n-1; i++) {
            auto [u, v, w] = ul[per[i]];
            if (c[u][cnt[u]] + c[v][cnt[v]] < w) {
                f = 0;
            }
            cnt[u]++;
            cnt[v]++;
        }
        if (f) {
            cout << "Yes\n";
            for (auto i : per) {
                cout << i + 1 << ' ';
            }
            return;
        }
    }
    cout << "No";
    vector<int> v(100000000);
    if (v[1]) {
        throw;
    }
}


signed main() {
    cout.setf(ios_base::fixed);
    cout << fixed << std::setprecision(12);
    ios_base::sync_with_stdio(false);
    cin.tie(0);


#ifdef LOCAL
    auto f = freopen("input.txt", "r", stdin);
    auto f1 = freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}