#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <algorithm>
#include <deque>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
//#define int ll

using namespace std;

mt19937 rnd(0);

vector<vector<tuple<int, int, int>>> g;

vector<vector<int>> dp, c;
vector<int> ma;
vector<vector<int>> vm;
vector<tuple<int, int, int>> ul;
map<pair<int, int>, int> mid;

void dfs(int v, int p) {
    vector<pair<int, int>> vv;
    sort(all(g[v]), [](tuple<int, int, int> a, tuple<int, int, int> b) {return get<1>(a) < get<1>(b);});
    for (auto [to, w, id] : g[v]) {
        if (to != p) {
            dfs(to, v);
            if (ma[to] == -1) {
                cout << "No";
                exit(0);
            }
            vv.push_back({ c[to][ma[to]], to });
        }
    }
    sort(all(vv));
    vector<pair<int, int>> vv1;
    for (int i = 0; i < c[v].size(); i++) {
        vv1.push_back({ c[v][i], i });
    }
    sort(all(vv1));
    if (v == 0) {
        bool f = 1;
        int i = 0;
        vector<int> mt(c[v].size());
        for (auto [to, w, id] : g[v]) {
            if (to != p) {
                if (vv[i].first + vv1[i].first < w) {
                    f = 0;
                }
                mt[vv1[i].second] = vv[i].second;
                i++;
            }
        }
        vm[v] = mt;
        dp[v][0] = f;
    }
    else {
        for (int up = 0; up < c[v].size(); up++) {
            vv1.erase(lower_bound(all(vv1), pair<int, int>{ c[v][up], up }));
            bool f = 1;
            int i = 0;
            vector<int> mt(c[v].size());
            for (auto [to, w, id] : g[v]) {
                if (to != p) {
                    if (vv[i].first + vv1[i].first < w) {
                        f = 0;
                    }
                    mt[vv1[i].second] = vv[i].second;
                    i++;
                }
            }
            dp[v][up] = f;
            if (dp[v][up] && (ma[v] == -1 || c[v][ma[v]] < c[v][up])) {
                ma[v] = up;
                vm[v] = mt;
            }
            vv1.insert(lower_bound(all(vv1), pair<int, int>{ c[v][up], up }), { c[v][up], up });
        }
    }
}

void dfs1(int v, int p, int last_id) {
    vector<pair<int, int>> vv1;
    for (int i = 0; i < c[v].size(); i++) {
        vv1.push_back({ c[v][i], i });
    }
    sort(all(vv1));
    for (int i = 0; i < ma[v]; i++) {
        int to = vm[v][i];
        if (to != p) {
            dfs1(to, v, mid[{to, v}]);
        }
    }
    if (v != 0) {
        cout << last_id + 1 << ' ';
    }
    for (int i = ma[v] + 1; i < c[v].size(); i++) {
        int to = vm[v][i];
        if (to != p) {
            dfs1(to, v, mid[{to, v}]);
        }
    }

}

void solve() {
    int n, group;
    cin >> n >> group;
    ma.resize(n, -1);
    vm.resize(n);
    g.resize(n);
    ul.resize(n - 1);
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].push_back({ v, w, i });
        g[v].push_back({ u, w, i });
        ul[i] = { u, v, w };
        mid[{u, v}] = i;
        mid[{v, u}] = i;
    }
    dp.resize(n);
    c.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int x;
            cin >> x;
            c[i].push_back(x);
        }
        reverse(all(c[i]));
        dp[i].resize(c[i].size());
    }
    dfs(0, -1);
    cout << (dp[0][0] ? "Yes\n" : "No\n");
    if (dp[0][0]) {
        dfs1(0, -1, -1);
    }
}


signed main() {
    cout.setf(ios_base::fixed);
    cout << fixed << std::setprecision(12);
    ios_base::sync_with_stdio(false);
    cin.tie(0);


#ifdef LOCAL
    auto f = freopen("input.txt", "r", stdin);
    auto f1 = freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}