#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>

using namespace std;

using ll = long long;
using pii = pair<int, int>;

struct edge {
    int u, v;
    int w;
};

vector<vector<edge>> g;
vector<vector<int>> c;

vector<int> por;
vector<int> used;
int n;
vector<edge> edges;
vector<int> cur_pos;

void gen() {
    if (por.size() == n - 1) {
        cout << "Yes\n";
        for (auto el : por) {
            cout << el + 1 << " ";
        }
        exit(0);
    }
    for (int el = 0; el < n - 1; ++el) {
        if (used[el]) continue;
        auto now = edges[el];
        if (c[now.u][cur_pos[now.u]] + c[now.v][cur_pos[now.v]] >= now.w) {
            cur_pos[now.u]++;
            cur_pos[now.v]++;
            used[el] = 1;
            por.push_back(el);
            gen();
            cur_pos[now.u]--;
            cur_pos[now.v]--;
            used[el] = 0;
            por.pop_back();
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int group;
    cin >> n >> group;
    g.resize(n);
    c.resize(n);
    edges.resize(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        edges[i].u--;
        edges[i].v--;
        g[edges[i].v].push_back(edges[i]);
        g[edges[i].u].push_back(edges[i]);
    }
    for (int i = 0; i < n; ++i) {
        int k = g[i].size();
        c[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> c[i][j];
        }
        std::reverse(c[i].begin(), c[i].end());
    }
    used.resize(n);
    cur_pos.resize(n);
    gen();
    cout << "No";
    return 0;
}
