#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <random>
#include <chrono>
#include <deque>


using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define MNOGO int __t; cin>>__t; while(__t--)
#define endl "\n"

struct Ul {
    int a, b, w;

    Ul(int _a, int _b, int _w) {
        a = _a;
        b = _b;
        w = _w;
    }
};

int n, g;
vector<Ul> a;
vector<vector<int>> c;

vector<int> used;

vector<int> posl;

bool ans = false;
vector<int> ansa = {};

void rec(int i) {
    if (i == n - 1) {
        auto wasc = c;
        bool lans = true;
        for (auto it: posl) {
            auto now = a[it];
            int sum = c[now.a].back() + c[now.b].back();
            c[now.a].pop_back();
            c[now.b].pop_back();
            if (sum < now.w) {
                lans = false;
            }
        }
        c = wasc;
        if (lans) {
            ans = true;
            ansa = posl;
        }
        return;
    }
    for (int j = 0; j < n - 1; j++) {
        if (!used[j]) {
            used[j] = 1;
            posl.push_back(j);
            rec(i + 1);
            posl.pop_back();
            used[j] = 0;
        }
    }
}

void solve1() {
    used.resize(n, 0);
    rec(0);
    if (ans) {
        cout << "YES" << endl;
        for (auto it: ansa) {
            cout << it + 1 << " ";
        }
    } else {
        cout << "NO" << endl;
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    mt19937 rng(std::chrono::steady_clock::now().time_since_epoch().count());

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> g;

    map<int, int> deg;

    for (int i = 0; i < n - 1; i++) {
        int aa, bb, ww;
        cin >> aa >> bb >> ww;
        a.push_back({aa, bb, ww});
        deg[aa]++;
        deg[bb]++;
    }

    c.push_back({});

    for (int i = 1; i <= n; i++) {
        c.push_back({});
        for (int kk = 0; kk < deg[i]; kk++) {
            int y;
            cin >> y;
            c[c.size() - 1].push_back(y);
        }
    }


    if (g == 0 || g == 1) {
        solve1();
    }

}
