#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9 + 1;
const int mod = inf + 6;
const ll infll = 1ll * (inf - 1) * (inf - 1);
mt19937_64 rnd(time(0));
const int N = 2e5 + 100;
vector<pair<int, int>> g[N];
void solve_case() {
    int n, G;
    cin >> n >> G;
    vector<array<int, 3>> edges;
    for (int i = 0; i < n - 1; i++) {
        int x, y, w;
        cin >> x >> y >> w;
        x--, y--;
        edges.push_back({x, y, w});
        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        c[i].resize(g[i].size());
        for (int x = 0; x < g[i].size(); x++) {
            cin >> c[i][x];
        }
    }
    vector<int> ans;
    vector<bool> us(n - 1);
    for (int step = 0; step < n - 1; step++) {
        int id = -1;
        int score = inf;
        for (int i = 0; i < n - 1; i++) {
            if (us[i]) continue;
            int a = edges[i][0], b = edges[i][1], w = edges[i][2];
            if (c[a].back() + c[b].back() < w) continue;
            int me = min(w - c[a].back(), w - c[b].back());
            if (id == -1) {
                id = i;
                score = me;
            } else if (score < me){
                score = me;
                id = i;
            }
        }
        if (id == -1) {
            cout << "No\n";
            return;
        }
        ans.push_back(id);
        c[edges[id][0]].pop_back();
        c[edges[id][1]].pop_back();
        us[id] = true;
    }
    cout << "Yes\n";
    for (int v : ans) cout << v + 1 << " ";
    cout << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve_case();
    }
}
