#include<bits/stdc++.h>


using namespace std;
typedef long long ll;
typedef pair<int, int> pii;


vector<vector<int>> uliki;
vector<int> ind;
vector<tuple<int, int, int>> r;
vector<int> r0;
vector<int> x;
int n, g;


bool dfs(vector<bool>& used, vector<int>& ans)
{
    if (ans.size() == n - 1)
    {
        return true;
    }
    for (int i = 0; i < n - 1; i++)
    {
        if (!used[i])
        {
            auto [a, b, c] = r[i];
            if (ind[a] < uliki[a].size() && ind[b] < uliki[b].size())
            {
                if (uliki[a][ind[a]] + uliki[b][ind[b]] >= c)
                {
                    ind[a]++;
                    ind[b]++;
                    used[i] = true;
                    ans.push_back(i);
                    if (dfs(used, ans))
                    {
                        return true;
                    }
                    ind[a]--;
                    ind[b]--;
                    used[i] = false;
                    ans.pop_back();
                }
            }
        }
    }
    return false;
}


void solve1()
{
    vector<int> cnt(n, 0);
    for (int i = 0; i < n - 1; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;
        r.push_back({a - 1, b - 1, c});
        cnt[a - 1]++;
        cnt[b - 1]++;
    }
    ind.resize(n, 0);
    uliki.resize(n);
    for (int i = 0; i < n; i++)
    {
        uliki[i].resize(cnt[i]);
        for (int j = 0; j < cnt[i]; j++)
        {
            cin >> uliki[i][j];
        }
    }
    vector<bool> used(n - 1, false);
    vector<int> ans;
    if (dfs(used, ans))
    {
        cout << "YES\n";
        reverse(ans.begin(), ans.end());
        for (auto el: ans)
        {
            cout << el + 1 << ' ';
        }
    }
    else
    {
        cout << "NO";
    }
    return;
}


bool cmp(int i, int j)
{
    return uliki[i][0] - r0[i] < uliki[j][0] - r0[j];
}


bool cmp1(int i, int j)
{
    return x[i] < x[j];
}


void solve3()
{
    vector<int> cnt(n, 0);
    r0.resize(n);
    x.resize(n);
    for (int i = 0; i < n - 1; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        if (a > b)
        {
            swap(a, b);
        }
        r.push_back({a, b, c});
        r0[b] = c;
        cnt[a]++;
        cnt[b]++;
    }
    ind.resize(n, 0);
    uliki.resize(n);
    for (int i = 0; i < n; i++)
    {
        uliki[i].resize(cnt[i]);
        for (int j = 0; j < cnt[i]; j++)
        {
            cin >> uliki[i][j];
            if (i == 0)
            {
                x[j] = uliki[i][j];
            }
        }
    }
    vector<int> ind(n - 1);
    vector<int> ind1(n - 1);
    for (int i = 1; i < n - 1; i++)
    {
        ind[i] = i;
        ind1[i] = i;
    }
    sort(ind.begin(), ind.end(), cmp);
    sort(ind1.rbegin(), ind1.rend(), cmp1);
    vector<int> ans(n - 1);
    for (int i = 0; i < n - 1; i++)
    {
        if (x[ind1[i]] + uliki[ind[i]][0] < r0[ind[i]])
        {
            cout << "NO";
            return;
        }
        ans[ind[i]] = ind1[i];
    }
    cout << "YES\n";
    for (auto el: ans)
    {
        cout << el + 1 << ' ';
    }
    return;
}


int main()
{
    if (0)
    {
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    }
    if (0)
    {
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    cin >> n >> g;
    if (g <= 1)
    {
        solve1();
    }
    else if (g == 3)
    {
        solve3();
    }
    return 0;
}
