// JafoNoksy's code
#include <bits/stdc++.h>
#pragma GCC optimize "O2"
using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define F first
#define S second
#define int ll
#define ve vector
mt19937 rnd(4732);
template <class A>
istream &operator >> (istream&in, ve<A> &x) {
    for (auto &c : x)
        in >> c;
    return in;
}
template <class A>
ostream &operator << (ostream&out, ve<A> &x) {
    for (auto &c : x)
        out << c << ' ';
    return out << '\n';
}
struct segtree {
    ve<int> t;
    int n = 0;

    void build(int v, int l, int r, ve<int> &a) {
        if (l +1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r)/2;
        build(2*v+1, l, m, a);
        build(2*v+2, m, r, a);
        t[v] = t[2*v+1] + t[2*v+2];
    }

    int get(int v, int l, int r, int _l, int _r) {
        if (l >= _r || _l >= r)
            return 0;
        if (_l <= l && r <= _r)
            return t[v];
        int m = (l + r)/2;
        return get(2*v+1, l, m, _l, _r) + get(2*v+2, m, r, _l, _r);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }

    segtree (ve<int> a = {1}) {
        n = a.size();
        t.resize(4*n);
        build(0, 0, n, a);
    }
};

ve<pll> ext(ve<pll> a, ve<pll> b) {
    int n = a.size();
    ve<pll> c(n);
    for (int i = 0; i < n; ++i) {
        c[i] = {a[b[i].F].F, a[b[i].F].S + b[i].S};
    }
    return c;
}

ve<pll> fpow(ve<pll> &a, int d) {
    if (d == 1)
        return a;
    if (d & 1)
        return ext(fpow(a, d-1), a);
    auto c = fpow(a, d/2);
    return ext(c, c);
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n; cin >> n;
    int test_group; cin >> test_group;
    ve<set<pll>> g(n);
    map<pll, int> mp;
    set<pll> lists;
    ve<set<pll>> c(n);
    for (int i = 1; i < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u-1].insert({v-1, w});
        g[v-1].insert({u-1, w});
        mp[{u-1, v-1}] = mp[{v-1, u-1}] = i;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            int m; cin >> m;
            c[i].insert({m, j});
        }
    }
    for (int i = 0; i < n; ++i) {
        if (g[i].size() == 1) {
            lists.insert({(*c[i].begin()).F, i});
        }
    }
    ve<pll> ans;
    while (!lists.empty()) {
        auto [c1, v] = *lists.begin();
        lists.erase(lists.begin());
        if (g[v].size() != 1)
            continue;
        auto [u, w] = *g[v].begin();
        auto it = c[u].lower_bound(pll{w-c1, 0});
        if (it == c[u].end()) {
            cout << "No";
            return 0;
        }
        ans.pb({(*it).S, mp[{u, v}]});
        g[u].erase({v, w});
        c[u].erase(it);
        if (g[u].size() == 1) {
            lists.insert({(*c[u].begin()).F, u});
        }
    }
    sort(all(ans));
    cout << "Yes\n";
    for (auto &&[cnt, i] : ans) {
        cout << i << ' ';
    }
}