// #pragma GCC optimize("O3")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("D:\\work2\\input.txt", "r", stdin);
#define file_out freopen("D:\\work2\\output.txt", "w", stdout);
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define str string
#define pb push_back
#define ff first
#define sc second
#define all(a) a.begin(), a.end()
#define sz(a) (int(a.size()))
#define int ll

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2> istream& operator>>(istream &in, pair<T1, T2> &a) { in >> a.ff >> a.sc; return in; }
template<typename T1, typename T2> ostream& operator<<(ostream &out, const pair<T1, T2> &a) { out << a.ff << " " << a.sc; return out; }
template<typename T> istream& operator>>(istream &in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const set<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const multiset<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
mt19937_64 genom(mt_seed); ll randint(ll a, ll b) { uniform_int_distribution<ll> r(a, b); return r(genom); }
const int RANDOM = mt_seed; struct chash { int operator()(int x) const { return x ^ RANDOM; } };
struct pair_hash { ll operator()(pii x) const { return 1ll * x.ff * 31 + x.sc; } };

gp_hash_table<pii, int, pair_hash> id;

vector<vector<pii>> g;
vector<vector<pii>> c;
vector<vector<int>> res;
vector<int> remain;
vector<bool> used;

void dfs(int v, int p) {
    // cout << "V: " << v << endl;

    if (sz(g[v]) == 1 && v != 0) { // лист
        remain[v] = c[v][0].ff;



        return;
    }
    vector<pii> wt;
    wt.reserve(sz(g[v]));
    for (auto [to, w] : g[v]) {
        if (to == p) continue;
        dfs(to, v);
        w -= remain[to];

        wt.pb({w, to});
    }
    sort(all(wt));

    int m = sz(g[v]);

    if (sz(g[v]) == sz(wt)) { // корень
        // cout << "ROOT_CHECK" << endl;
        
        for (int i = 0; i < m; ++i) {
            if (wt[i].ff > c[v][i].ff) {
                cout << "No";
                exit(0);
            }
        }



    } else {
        // cout << v << " CHECK" << endl;

        // cout << "C: ";
        // for (auto el : c[v])
        //     cout << el.ff << " ";
        // cout << endl;
        // cout << "WT: ";
        // for (auto el : wt)
        //     cout << el.ff << " ";
        // cout << endl;

        for (int i = 1; i < m; ++i) {
            if (wt[i - 1].ff > c[v][i].ff) {
                cout << "No";
                exit(0);
            }
        }

        int j = m - 1;
        for (int i = 0; i < m; ++i) {
            if (wt[i].ff > c[v][i].ff) {
                j = i;
                break;
            }
        }
        remain[v] = c[v][j].ff;



    }
}

bool cmp2(pii a, pii b) { return a.sc < b.sc; }

void answer1(int v, int p) {
    if (sz(g[v]) == 1 && p != 0) return;
    
    vector<pii> wt;
    wt.reserve(sz(g[v]));
    for (auto [to, w] : g[v]) {
        if (to == p) continue;
        answer1(to, v);

        w -= remain[to];

        wt.pb({w, to});
    }
    sort(all(wt));

    int m = sz(g[v]);

    sort(all(c[v]), cmp2);

    vector<pii> part1;

    int jj = 1e9;

    for (int i = 0; i < sz(c[v]); ++i) {
        if (c[v][i].ff == remain[v]) {
            jj = i;
            continue;
        }
        part1.pb({c[v][i].ff, i});
    }

    sort(all(part1));

    vector<pii> ord(sz(part1));

    for (int i = 0; i < sz(part1); ++i) {
        int to = wt[i].sc;

        ord[i] = {id[{v, to}] + 1, part1[i].sc};
        // cout << id[{v, to}] + 1 << ' ';
    }
    sort(all(ord), cmp2);

    for (auto el : ord) if (el.sc < jj) { cout << el.ff << " "; used[el.ff - 1] = 1; }
}

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int n, group;
    cin >> n >> group;
    vector<pii> edges(n - 1);

    g.resize(n);
    c.resize(n);
    res.resize(n);
    remain.resize(n, -1);

    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        --a; --b;
        edges.pb({a, b});
        id[{a, b}] = i;
        id[{b, a}] = i;
        g[a].pb({b, w});
        g[b].pb({a, w});
    }

    for (int i = 0; i < n; ++i) {
        c[i].resize(sz(g[i]));
        for (int j = 0; j < sz(g[i]); ++j) {
            cin >> c[i][j].ff;
            c[i][j].sc = j;
        }
        sort(all(c[i]));
    }

    dfs(0, 0);

    cout << "Yes\n";

    // for (int i = 0; i < n; ++i) {
    //     cout << remain[i] << ' ';
    // }
    // cout << endl;

    used.resize(n - 1);
    answer1(0, 0);
    for (int i = 0; i < n - 1; ++i)
        if (!used[i])
            cout << i + 1 << ' ';

    return 0;
}
