#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
#define all(a) a.begin(), a.end()

struct edge {
    int u = 0, v = 0, w = 0;
};

vector<vector<pii>> g;
vector<vector<int>> c;
vector<edge> edges;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, group;
    cin >> n >> group;
    g.resize(n);
    edges.resize(n - 1);
    c.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        --edges[i].u, --edges[i].v;
        g[edges[i].u].push_back({edges[i].v, edges[i].w});
        g[edges[i].v].push_back({edges[i].u, edges[i].w});
    }
    for (int i = 0; i < n; ++i) {
        c[i].resize(g[i].size());
        for (int j = 0; j < g[i].size(); ++j) {
            cin >> c[i][j];
        }
        reverse(all(c[i]));
    }
    vector<int> ans;
    vector<bool> used(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int mx = -1;
        for (int j = 0; j < n - 1; ++j) if (!used[j]) {
            if (edges[j].w <= c[edges[j].u].back() + c[edges[j].v].back()) {
                if (mx == -1 || edges[j].w > edges[mx].w) mx = j;
            }
        }
        if (mx == -1) {
            cout << "No\n";
            exit(0);
        }
        ans.push_back(mx);
        used[mx] = true;
        c[edges[mx].u].pop_back();
        c[edges[mx].v].pop_back();
    }
    cout << "Yes\n";
    reverse(all(ans));
    for (auto el : ans) {
        cout << el + 1 << " ";
    }
}
