#include <bits/stdc++.h>

using namespace std;

struct edge
{
    int a, b, w;
};

void resh(int mv, vector<edge> &v, vector<vector<int>> &g, vector<int> &pd, vector<bool> &used)
{
    int n = v.size() + 1;
    if(mv == n - 1)
    {
        bool flag = 1;
        vector<int> pos(n);
        for(int i = 0; i < n - 1; i++)
        {
            int z = v[pd[i]].a;
            int q = v[pd[i]].b;
            //cout << z << ' ' << q << ' ' << g[z][pos[z]] << ' ' << g[q][pos[q]] << endl;
            if(g[z][pos[z]] + g[q][pos[q]] < v[pd[i]].w)
            {
                flag = 0;
                break;
            }
            pos[z]++;
            pos[q]++;
        }
        if(flag)
        {
            cout << "YES" << "\n";
            for(int i = 0; i < n - 1; i++)
            {
                cout << pd[i] + 1 << ' ';
            }
            cout << endl;
            exit(0);
        }
        return;
    }
    for(int i = 0; i < n - 1; i++)
    {
        if(!used[i])
        {
            used[i] = 1;
            pd.push_back(i);
            resh(mv + 1, v, g, pd, used);
            pd.pop_back();
            used[i] = 0;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    long long n, g;
    cin >> n >> g;
    if(g == 1 || g == 0)
    {
        vector<edge> v(n - 1);
        vector<int> cnt(n);
        for(int i = 0; i < n - 1; i++)
        {
            cin >> v[i].a >> v[i].b >> v[i].w;
            v[i].a--;
            v[i].b--;
            cnt[v[i].a]++;
            cnt[v[i].b]++;
        }
        vector<vector<int>> g(n);
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < cnt[i]; j++)
            {
                int z;
                cin >> z;
                g[i].push_back(z);
            }
            reverse(g[i].begin(), g[i].end());
        }
        vector<int> pd;
        vector<bool> used(n - 1, 0);
        resh(0, v, g, pd, used);
        cout << "NO";
    }
    return 0;
}
