#include<bits/stdc++.h>

#define pii pair < int, int >
#define pb push_back
#define F first
#define S second
#define ins insert
#define int long long

using namespace std;


const int N = 2e5 + 10;
const int B = 50;


int n, group;

vector < pii > g[N];
int sz[N], s[N];
vector < int > c[N];



struct edge {
    int x, y, w;
    edge() {}
    edge(int x_, int y_, int w_) {
        x = x_, y = y_, w = w_;
    }
};
struct ver {
    int x, i, w;
    ver() {}
    ver(int x_, int i_, int w_) {
        x = x_, i = i_, w = w_;
    }
};

edge e[N];
vector < ver > ve[N];

bool check(vector < int > &p) {
          for(int i = 1; i <= n; i++) s[i] = sz[i] - 1;

              bool ok = 1;
              for(auto to : p) {
                  int i = e[to].x, j = e[to].y;

                  if(c[i][s[i]] + c[j][s[j]] < e[to].w) ok = 0;
                  s[i]--, s[j]--;
              }
              return ok;
}

void solve3() {
        sort(ve[1].begin(), ve[1].end(),
             [](const ver &a, const ver &b) {return a.w - c[a.x][0] < b.w - c[b.x][0];});

        vector < pii > d;

        for(int i = 0; i < n - 1; i++) d.pb({i, c[1][i]});

        sort(d.begin(), d.end(),
             [](const pii &a, const pii &b) {return a.S < b.S;});

        vector < int > p;

        for(int i = 0; i< n - 1; i++) d[i].S = ve[1][i].x;

                sort(d.begin(), d.end(),
             [](const pii &a, const pii &b) {return a.F > b.F;});

        for(auto to : d) p.pb(to.S - 1);

        if(check(p)) {
            cout << "Yes" << endl;
            for(auto to : p) cout << to << ' ';
        }
        else {
            cout << "No";
        }
}
void solve1() {
     vector < int > p;

        for(int i = 1; i <= n - 1; i++) p.pb(i);

        do {


              if(check(p)) {
                cout << "Yes" << endl;
                for(auto to : p) cout << to << ' ';
                return;
              }
        }
        while(next_permutation(p.begin(), p.end()));

        cout << "No";
        return;
}


void solve() {

     cin >> n >> group;

     for(int i = 1; i < n; i++) {
         int x, y, w;
         cin >> x >> y >> w;

         e[i] = edge(x, y, w);

         g[x].pb({y, w});
         g[y].pb({x, w});

         sz[x]++, sz[y]++;

         ve[x].pb(ver(y, i, w));
         ve[y].pb(ver(x, i, w));
     }



     for(int i = 1; i <= n; i++) {
         for(int j = 0; j < sz[i]; j++) {
             int x;
             cin >> x;

             c[i].pb(x);
         }
     }

     if(n <= 10) {
        solve1();
        return;
     }

     if(group == 3) {
        solve3();
        return;
     }


     vector < int > p;

     for(int i = 1; i < n; i += 2) p.pb(i);
     for(int i = 2; i < n; i += 2) p.pb(i);

     if(check(p)) {
        cout << "Yes" << endl;
        for(auto to : p) cout << to << ' ';
        return;
     }

     p.clear();

     for(int i = 1; i < n; i++) p.pb(i);

     if(check(p)) {
        cout << "Yes" << endl;
        for(auto to : p) cout << to << ' ';
        return;
     }
     cout << "No";






}
int32_t main() {


//    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
//    #else
//
//    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    solve();

    return 0;
}

