#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"

using namespace std;
using namespace __gnu_pbds;

//#define int long long

using indexed_set = tree<pair<int, int>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

//struct segtree {
//    struct node {
//
//    };
//
//    vector<node> tree;
//
//    void build(int l, int r, int ind) {
//        if (l == r - 1) {
//
//        }
//        int mid = (l + r) / 2;
//        build(l, mid,  ind * 2 + 1);
//        build(mid, r, ind * 2 + 2);
//
//    }
//
//    segtree (vector<int> &_a) {
//
//    }
//
//    void alloc() {
//
//    }
//
//    void push(int ind) {
//        alloc(ind * 2 + 1, tree[ind].upd);
//        alloc(ind * 2 + 2, tree[ind].upd);
//        tree[ind].upd = neutral_upd;
//    }
//
//    void upd() {
//
//    }
//
//    int ask(){
//
//    }
//
//    void Upd() {
//
//    }
//
//    int Ask() {
//
//    }
//};


vector<vector<pair<int, int>>> g;

void dfs(int i, int j, vector<vector<int>> &nums, vector<vector<bool>> &used, vector<int> &ans);

void Fast() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

signed main() {
    Fast();
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, gr;
    cin >> n >> gr;
    g.resize(n);
    vector<vector<int>> edges;
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
        edges.push_back({u, v, w});
    }
    vector<vector<int>> st(n);
    for (int i = 0; i < n; i++) {
        st[i].resize(g[i].size());
        for (int &j: st[i]) cin >> j;
        std::reverse(st[i].begin(), st[i].end());
    }
    if (n <= 10) {
        vector<int> perm(n - 1);
        iota(perm.begin(), perm.end(), 0);
        int cnt = 1;
        for (int i = 1; i <= n; i++) cnt *= i;
        for (int i = 0; i < cnt; i++) {
            vector<int> pos(n, 0);
            bool fl = true;
            for (int j: perm) {
                int u = edges[j][0], v = edges[j][1], w = edges[j][2];
                if (st[u][pos[u]++] + st[v][pos[v]++] < w) {
                    fl = false;
                    break;
                }
            }
            if (fl) {
                cout << "Yes" << '\n';
                for (int j: perm) cout << j + 1 << " ";
                return 0;
            }

            next_permutation(perm.begin(), perm.end());
        }

        cout << "No";
    } else if (gr == 2) {
        vector<vector<bool>> used(n);

        vector<vector<int>> nums(n);
        for (int i = 0; i < n; i++) {
            used[i].resize(st[i].size(), false);

            nums[i].resize(used[i].size(), -1);
        }
        for (int i = 0; i < n - 1; i++) {
            for (int j = 0; j < (int) st[i].size(); j++) {
                if (!used[i][j]) {
                    int x = st[i][j];

                    int mn = 2e9;
                    int pos = -1;
                    for (int k = 0; k < (int) st[i + 1].size(); k++) {
                        int y = st[i + 1][k];
                        if (x + y >= edges[i][2]) {
                            if (y < mn) {
                                mn = y;
                                pos = k;
                            }
                        }
                    }
                    if (pos == -1) {
                        cout << "No";
                        return 0;
                    }
                    used[i + 1][pos] = used[i][j] = true;
                    nums[i][j] = nums[i + 1][pos] = i;
                }
            }
        }

        for (int i = 0; i < n; i++) {
            for (auto &&j: used[i]) j = false;
        }
        cout << "Yes" << '\n';
        vector<int> ans;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < (int) used[i].size(); j++) {
                if (!used[i][j]) {

                    used[i][j] = true;
                    dfs(i, j, nums, used, ans);
                }
            }
        }
        for (int i : ans) cout << i + 1 << " ";
    } else if (gr == 3) {
        indexed_set vec;
        for (int i = 0; i < n - 1; i++) vec.insert({st[0][i], i});
        
        vector<int> ans(n - 1);
        for (int i = 1; i < n; i++) {

            pair<int, int> cur = {edges[i - 1][2] - st[i][0], -1};
            int ind = vec.order_of_key(cur);
            if (ind == vec.size()) {
                cout<< "No";
                return 0;
            }
            ans[vec.find_by_order(ind)->second] = i;
        }
        cout << "Yes" << '\n';
        for (int i : ans) cout << i << " ";
    }

}

void dfs(int i, int j, vector<vector<int>> &nums, vector<vector<bool>> &used, vector<int> &ans) {
    int n = (int) nums.size();
    if (i + 1 == n) return;
    int ps = -1;
    for (int k = 0; k < (int) nums[i + 1].size(); k++) {
        used[i + 1][k] = true;
        if (nums[i + 1][k] == nums[i][j]) {
            ans.push_back(nums[i][j]);
            break;
        }

        dfs(i + 1, k, nums, used, ans);
    }
//    ans.push_back(nums[i][j]);
//    for (int k = ps - 1; k > -1; k--) {
//        dfs(i + 1, k, nums, used, ans);
//    }
}