#include <bits/stdc++.h>

signed main() {
    std::ios::sync_with_stdio(false);
    std::cout.tie();
    std::cin.tie();
    int n, group;
    std::cin >> n >> group;
    struct edge {
        int x, y, w;
    };
    std::vector<int> deg(n);
    std::vector<edge> e(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int x, y, w;
        std::cin >> x >> y >> w;
        --x, --y;
        e[i] = {x, y, w};
        ++deg[x];
        ++deg[y];
    }
    std::vector<std::vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        a[i].resize(deg[i]);
        for (auto &j : a[i]) {
            std::cin >> j;
        }
        std::reverse(a[i].begin(), a[i].end());
    }
    std::vector<int> per(n - 1);
    std::iota(per.begin(), per.end(), 0);
    while (true) {
        bool f = true;
        std::vector<int> now(n);
        for (int i = 0; i < n - 1; ++i) {
            auto [u, v, w] = e[per[i]];
            if (a[u][now[u]] + a[v][now[v]] < w) {
                f = false;
                break;
            }
            ++now[u], ++now[v];
        }
        if (f) {
            std::cout << "Yes\n";
            for (auto &i : per) {
                std::cout << i + 1 << ' ';
            }
            std::cout << '\n';
            return 0;
        }
        if (!std::next_permutation(per.begin(), per.end())) {
            break;
        }
    }
    std::cout << "No\n";
    return 0;
}
