#include <bits/stdc++.h>
using namespace std;
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;
//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
using ll = long long;
using ld = long double;
#define int long long
vector<vector<int>>graph;
vector<vector<int>>c;
struct Edge{
    int a, b, w, i;
    Edge(int a, int b, int w, int i) : a(a), b(b), w(w), i(i) {};
    Edge() = default;
};
vector<Edge>edges;
signed main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int n, g; cin >> n >> g; graph.resize(n); c.resize(n);
    vector<int>deg(n);
    for(int i = 0; i < n - 1; i++){
        int a, b, w; cin >> a >> b >> w; a--; b--;
        deg[a]++; deg[b]++;
        graph[a].push_back(i); graph[b].push_back(i);
        edges.emplace_back(a, b, w, i);
    }
    for(int i = 0; i < n; i++){
        c[i].resize(deg[i]);
        for(int j = 0; j < deg[i]; j++) cin >> c[i][j];
    }
    if(n <= 10){
        vector<int>ind;
        for(int i = 0; i < n - 1; i++) ind.push_back(i);
        do{
            vector<int>num(n);
            for(int i = 0; i < n; i++) num[i] = (int)c[i].size() - 1;
            bool good = true;
            for(auto val: ind){
                auto e = edges[val];
                if(e.w > c[e.a][num[e.a]] + c[e.b][num[e.b]]){
                    good = false; break;
                }else{
                    num[e.a]--; num[e.b]--;
                }
            }
            if(good){
                cout << "Yes\n";
                for(auto val: ind) cout << val + 1 << " ";
                return 0;
            }
        }while(next_permutation(ind.begin(), ind.end()));
        cout << "No";
        return 0;
    }
    if(g == 2){
        vector<vector<bool>>pref(n, vector<bool>(2));
        vector<vector<int>>pred(n, vector<int>(2));
        pref[1][0] = (c[0][0] + c[1][0] >= edges[0].w);
        pref[1][1] = (c[0][0] + c[1][1] >= edges[0].w);
        for(int i = 2; i < n; i++){
            auto e = edges[i];
            for(int j = 0; j < c[i].size(); j++){
                for(int z = 0; z < 2; z++){
                    bool yes = ((c[i][j] + c[i - 1][z]) >= e.w) && pref[i - 1][1 - z];
                    if(yes) {
                        pref[i][j] = yes; pred[i][j] = z;
                    }
                }
            }
        }
        if(pref[n - 1][0]){
            int i = n - 2; int j = 1 - pred[n - 1][0];
            vector<int>stack; int cur = n - 2;
            vector<int>ind(n - 1);
            while(i >= 1){
                if(j == 0) {stack.push_back(i);}
                else{
                    stack.push_back(i);
                    while(!stack.empty()){
                        ind[cur--] = stack.back(); stack.pop_back();
                    }
                    ind[cur--] = i - 1;
                }
                j = 1 - pred[i][j]; i--;
            }
            cout << "Yes\n";
            for(auto val: ind) cout << val + 1 << " ";
        }else{
            cout << "No"; return 0;
        }
    }
    return 0;
}
