#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <deque>
#define int long long
#define vi vector<long long>
#define vvi vector<vector<long long>>
#define ld long double
#define pii pair<long long, long long>
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
using namespace std;
void wr(vi vec) {
    for (int i : vec) cout << i << ' ';
    cout << '\n';}
void wrp(vector<pii> vec) {
    for (pii i : vec) cout << i.first << ' ' << i.second << '\n';
    cout << '\n';
}
int divup(int a, int b) {
    if (a % b == 0) return a / b;
    return a / b + 1;}


int dfs(int u, int p, vector<vector<pii>>& graph, vi& deg, vvi& c1, vvi& ord1, vvi& ans) {
    //cout << u << '\n';
    vector<pii> ch1;
    vi c = c1[u], ord = ord1[u], ch, ind;
    for (pii v1 : graph[u]) {
        int v = v1.first, w = v1.second;
        if (v == p) continue;
        int mv = dfs(v, u, graph, deg, c1, ord1, ans);
        if (mv == -1) return -1;
        ch1.pb({ w - mv, v });
    }
    sort(all(ch1));
    ch.resize(ch1.size());
    ind.resize(ch1.size());
    for (int i = 0; i < ch1.size(); i++) {
        ch[i] = ch1[i].first;
        ind[i] = ch1[i].second;
    }
    //if (u == 2) {
    //    wr(c);
    //    wr(ch);
    //}
    int res = c.back(), it = 0, jt = 0;
    ans[u][ord.back()] = p;
    while (jt < ch.size()) {
        if (it >= c.size()) return -1;
        if (c[it] >= ch[jt]) {
            ans[u][ord[it]] = ind[jt];
            it++; jt++;
        }
        else {
            res = c[it];
            ans[u][ord[it]] = p;
            it++;
        }
    }
    //cout << "ret " << u << " is " << res << '\n';
    return res;
}


void dfs1(int u, int p, vector<vector<pii>>& graph, vvi& ans1, vector<pii>& res) {
    vi ans = ans1[u];
    for (int v : ans) {
        if (v == p) res.pb({ u, v });
        else dfs1(v, u, graph, ans1, res);
    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << fixed;
    cout.precision(12);
    int n, g;
    cin >> n >> g;
    vector<vector<pii>> graph(n);
    map<pii, int> mp;
    int u, v, w;
    for (int i = 0; i < n - 1; i++) {
        cin >> u >> v >> w;
        u--; v--;
        graph[u].pb({ v, w });
        graph[v].pb({ u, w });
        mp[{ u, v }] = i;
        mp[{v, u}] = i;
    }
    vi deg(n);
    for (int i = 0; i < n; i++) deg[i] = graph[i].size();
    vvi c(n), ord(n);
    vector<vector<pii>> c1(n);
    for (int i = 0; i < n; i++) {
        c1[i].resize(deg[i]);
        c[i].resize(deg[i]);
        ord[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; j++) {
            cin >> c1[i][j].fi;
            c1[i][j].second = deg[i] - j - 1;
        }
        sort(all(c1[i]));
        for (int j = 0; j < deg[i]; j++) {
            c[i][j] = c1[i][j].fi;
            ord[i][j] = c1[i][j].second;
        }
    }
    vvi ansb(n), ans(n);
    for (int i = 0; i < n; i++) {
        ans[i].resize(deg[i]);
        ansb[i].resize(deg[i]);
    }
    int ok = dfs(0, -1, graph, deg, c, ord, ans);
    if (ok == -1) {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    //for (int i = 0; i < n; i++) wr(ans[i]);
    vector<pii> res;
    dfs1(0, -1, graph, ans, res);
    //for (int i = 0; i < n - 1; i++) cout << res[i].first << ' ' << res[i].se << '\n';
    for (pii i : res) {
        cout << mp[i] + 1 << ' ';
    }
}