#include <bits/stdc++.h>
using namespace std;
#define int long long
struct Edge{
    int u, v, w, id;
    bool operator<(Edge mm){
        return w < mm.w;
    }
};
void solve(){
    int groop, n;
    cin >> n >> groop;
    vector <Edge> rb(n);
    vector <int> deg(n);
    for (int i = 0; i < n - 1; ++i){
        cin >> rb[i].u >> rb[i].v >> rb[i].w;
        --rb[i].u;
        --rb[i].v;
        rb[i].id = i;
        deg[rb[i].u]++;
        deg[rb[i].v]++;
    }
    vector <vector <int>> c(n);
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < deg[i]; ++j){
            int x;
            cin >> x;
            c[i].push_back(x);
        }
        reverse(c[i].begin(), c[i].end());
    }
    if (groop < 2){
        vector <int> v(n - 1), ans;
        iota(v.begin(), v.end(), 0);
        do{
            vector <int> cur(n, -1);
            bool f = 1;
            for (int i = 0; i < n - 1; ++i){
                int a = rb[v[i]].u;
                int b = rb[v[i]].v;
                cur[a]++;
                cur[b]++;
                if (c[a][cur[a]] + c[b][cur[b]] < rb[v[i]].w){
                    f = false;
                    break;
                }
            }
            if (f){
                cout << "Yes\n";
                for (auto elem: v){
                    cout << elem + 1 << " ";
                }
                cout << endl;
                return;
            }

        }while (next_permutation(v.begin(), v.end()));
        cout << "No";
    }
    else if(groop == 3){
        for (int i = 0; i < n - 1; ++i){
            if (rb[i].u == 0){
                rb[i].w -= c[rb[i].v][0];
            }
            else{
                rb[i].w -= c[rb[i].u][0];
            }
        }
        sort(rb.begin(), rb.end());
        vector <pair <int, int>> g(n - 1);
        vector <int> ans(n - 1);
        for (int i = 0; i < n - 1; ++i){
            g.push_back({c[0][i], i});
        }
        sort(g.begin(), g.end());
        bool f = 1;
        for (int i = 0; i < n - 1; ++i){
            if (g[i].first < rb[i].w){
                f = 0;
                break;
            }
            ans[g[i].second] = rb[i].id;
        }
        if (!f){
            cout << "No";
            return;
        }
        cout << "Yes\n";
        for (auto x: ans){
            cout << x + 1 << " ";
        }
        return;
    }
}
signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--){
        solve();
    }

}


