#include<bits/stdc++.h>
#define sz(a) (int)a.size()
#define int long long

using namespace std;

const int INF = 1e18;

struct edge{
    int u, v, c;
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, g;
    cin >> n >> g;
    vector<edge> e(n - 1);
    vector<int> deg(n);
    vector<bool> used(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        --u;
        --v;
        e[i].u = u;
        e[i].v = v;
        e[i].c = c;
        deg[u]++;
        deg[v]++;
    }
    vector<vector<int>> st(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < deg[i]; ++j) {
            int x;
            cin >> x;
            st[i].push_back(x);
        }
        reverse(st[i].begin(), st[i].end());
    }
    vector<int> ans;
    for (int i = 0; i < n - 1; ++i) {
        int id = -1, waste = INF;
        for (int j = 0; j < n - 1; ++j) {
            if (used[j]) continue;
            int A = e[j].u;
            int B = e[j].v;
            if (e[j].c > st[A].back() + st[B].back()) {
                continue;
            }
            if (waste > st[A].back() + st[B].back() - e[j].c) {
                waste = st[A].back() + st[B].back() - e[j].c;
                id = j;
            }
        }
        if (id == -1) {
            cout << "No" << '\n';
            return 0;
        }
        ans.push_back(id + 1);
        used[id] = 1;
        int A = e[id].u;
        int B = e[id].v;
        st[A].pop_back();
        st[B].pop_back();
    }
    reverse(ans.begin(), ans.end());
    cout << "Yes" << '\n';
    for (int i : ans) {
        cout << i << ' ';
    }
    cout << '\n';
}
