#include <bits/stdc++.h>
using namespace std;
using ll = long long;
struct Edge{
    int v, u, w, id;
};
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, G;
    cin >> n >> G;
    vector<Edge> edge(n-1);
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i  < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        edge[i] = {a-1, b-1, c, i};
        g[a-1].push_back({b-1, i});
        g[b-1].push_back({a-1, i});
    }
    set<pair<int, int>> order;
    vector<vector<pair<int, int>>> stickers(n);
    vector<set<pair<int, int>>> sorted(n);
    vector<set<int>> alive_edge(n);
    vector<pair<int, int>> stickers_from_edge(n-1);
    vector<vector<int>> edge_from_sticker(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int val;
            cin >> val;
            alive_edge[i].insert(g[i][j].second);
            stickers[i].push_back({val, j});
            sorted[i].insert({val, j});
            edge_from_sticker[i].push_back(0);
        }
        order.insert({g[i].size(), i});
    }
    for (int i = 0; i < n - 1; i++) {
        auto v = order.begin()->second;
//        assert(alive_edge[v].size() == 1);
        order.erase(order.begin());
        int id = *alive_edge[v].begin();
        alive_edge[v].erase(id);
        int c = sorted[v].begin()->first;
        int id_of_sticker = sorted[v].begin()->second;
        sorted[v].erase(sorted[v].begin());
        int u = (edge[id].v == v ? edge[id].u : edge[id].v);
        auto it = sorted[u].lower_bound(make_pair(edge[id].w - c, 0));
        if (it == sorted[u].end()) {
            cout << "No\n";
            return 0;
        }
        auto number_stick = it->second;
        edge_from_sticker[v][id_of_sticker] = id;
        stickers_from_edge[id] = {(edge[id].v == v ? make_pair(id_of_sticker, number_stick) : make_pair(number_stick, id_of_sticker))};
        order.erase(make_pair((int)sorted[u].size(), u));
        sorted[u].erase(it);
        alive_edge[u].erase(id);
        order.insert(make_pair(sorted[u].size(), u));
    }
    cout << "Yes\n";
    vector<int> out;
    set<pair<int, int>, greater<pair<int, int>>> st;
    vector<int> curent_sticker(n);
    for (int i = 0; i < n; i++) curent_sticker[i] = g[i].size() - 1;
    for (int i = 0; i < n - 1; i++) {
        st.insert({curent_sticker[edge[i].v] == stickers_from_edge[i].first + curent_sticker[edge[i].u] == stickers_from_edge[i].second, i});
    }
    for (int i = 0; i < n - 1; i++) {
        auto e = *st.begin();
//        assert(e.first == 2);
        int id = e.second;
        st.erase(st.begin());
        out.push_back(id + 1);
        int u = edge[id].u;
        int v = edge[id].v;
        curent_sticker[v]++;
        curent_sticker[u]++;
        if (curent_sticker[v] != g[v].size()) {
            int inte = edge_from_sticker[v][curent_sticker[v]];
            int curent = (edge[inte].v == v ? edge[inte].u : edge[inte].v);
            st.erase(st.find(make_pair(curent, inte)));
            st.insert(make_pair(curent + 1, inte));
        }
        if (curent_sticker[u] != g[u].size()) {
            int inte = edge_from_sticker[u][curent_sticker[u]];
            int curent = (edge[inte].u == u ? edge[inte].v : edge[inte].u);
            st.erase(st.find(make_pair(curent, inte)));
            st.insert(make_pair(curent + 1, inte));
        }
    }
    for (int i = 0; i < n - 1; i++) cout << out[i] << " ";
}
