#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;
using indexed_set = tree<pair<int, int>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long double ld;
typedef long long ll;

//#pragma GCC optnimize("Ofast")
#pragma GCC target("avx2")

//#define int long long

int n, ty;
vector<vector<pair<int, int>>> g;
vector<vector<int>> st;
vector<vector<int>> edg;

void solve1() {
    vector<vector<int>> t(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (auto [j, w]: g[i]) {
            t[i][j] = w;
        }
    }
    for (int _ = 0; _ < 2e6; _++) {
        vector<vector<int>> st1 = st;
        bool check = 0;
        for (int i = 0; i < n - 1; i++) {
            int x = edg[i][0], y = edg[i][1];
            if (st1[x].back() + st1[y].back() >= t[x][y]) {
                st1[x].pop_back();
                st1[y].pop_back();
            } else {
                check = 1;
                break;
            }
        }
        if (check) {
            std::next_permutation(edg.begin(), edg.end());
            continue;
        }
        cout << "YES\n";
        for (int i = 0; i < n - 1; i++) {
            cout << edg[n - 2 - i][2] + 1 << ' ';
        }
        exit(0);
    }
    cout << "NO";
    exit(0);
}

void solve3() {
    vector<int> val(n), ind(n);
    for (int i = 0; i < n - 1; i++) {
        int x = edg[i][1];
        val[x] += edg[i][3];
        ind[x] = edg[i][2];
    }
    for (int i = 1; i < n; i++) {
        val[i] -= st[i][0];
    }
    indexed_set s;
    for (int i = 1; i < n; i++) {
        s.insert({val[i], i});
    }
    vector<int> ans;
    for (int _ = 0; _ < n - 1; _++) {
        int pos = s.order_of_key({st[0].back(), -1});
        if (pos == s.size()) {
            cout << "NO";
            exit(0);
        }
        auto [x, t] = *s.find_by_order(pos);
        s.erase({x, t});
        ans.push_back(ind[x]);
    }
    cout << "YES\n";
    for (int i = n - 2; i >= 0; i--) {
        cout << ans[i] + 1 << ' ';
    }
    exit(0);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> ty;
    g.resize(n);
    st.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int x, y, w;
        cin >> x >> y >> w;
        g[x - 1].push_back({y - 1, w});
        g[y - 1].push_back({x - 1, w});
        edg.push_back({x - 1, y - 1, i, w});
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int x;
            cin >> x;
            st[i].push_back(x);
        }
        std::reverse(st[i].begin(), st[i].end());
    }
    if (ty <= 1) solve1();
    if (ty == 3) solve3();
}