
#include <bits/stdc++.h>
using namespace std;
vector<vector<pair<int, int>>> g;
vector<vector<int>> elem;
map<pair<int, int>, int> mp;

vector<int> solve(int v, vector<vector<int>>& edge) {
    vector<pair<int, int>> cost;
    for (int i = 0; i < edge.size(); i++) {
        auto u = edge[i];
        if (u[0] == v) {
            cost.push_back({-u[2] + elem[u[1]][0], i});
        } else {
            cost.push_back({-u[2] + elem[u[0]][0], i});
        }
    }
    sort(cost.begin(), cost.end());
    vector<pair<int, int>> num;
    for (int i = 0; i < elem[v].size(); i++) {
        num.push_back({elem[v][i], i});
    }
    sort(num.rbegin(), num.rend());
    vector<pair<int, int>> ans;
    for (int i = 0; i < edge.size(); i++) {
        if (num[i].first + cost[i].first < 0) {
            vector<int> t(1, -1);
            return t;
        }
        ans.push_back({num[i].second, cost[i].second});
    }
    sort(ans.begin(), ans.end());
    vector<int> ret;
    for (int i = 0; i < ans.size(); i++) ret[i] = ans[i].second;
    return ret;
}

vector<int> ts;
void dfs(int v, vector<bool>& used, vector<vector<int>>& tg) {
    used[v] = true;
    for (auto u : tg[v]) {
        if (!used[u]) dfs(u, used, tg);
    }
    ts.push_back(v);
}
signed main() {
    int n, T;
    cin >> n >> T;
    g.resize(n);
    vector<int> deg(n);

    vector<vector<int>> edge;
    for (int i = 0; i < n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        deg[a - 1]++;
        deg[b - 1]++;
        g[a - 1].push_back({b - 1, w});
        g[b - 1].push_back({a - 1, w});
        edge.push_back({a - 1, b - 1, w});
    }
    elem.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            int x;
            cin >> x;
            elem[i].push_back(x);
        }
    }
    for (int i = 0; i < n; i++) reverse(elem[i].begin(), elem[i].end());
    vector<vector<int>> t_g(n);
    for (int i = 0; i < n - 2; i++) {
        int w = 0;
        if (g[i][0].first == i + 1) w = g[i][0].second;
        else w = g[i][1].second;
        if (max(elem[i + 1][0], elem[i + 1][1]) + elem[i][0] < w) {
            cout << "No\n";
            exit(0);
        }
        if (elem[i + 1][0] < elem[i + 1][1] && elem[i][0] + elem[i + 1][0] >= w) {
            t_g[mp[{i, i + 1}]].push_back(mp[{i + 1, i + 2}]);
            swap(elem[i + 1][0], elem[i + 1][1]);
            elem[i + 1].pop_back();
        } else {
            t_g[mp[{i + 1, i + 2}]].push_back(mp[{i, i + 1}]);
            elem[i + 1].pop_back();
        }
    }
    if (elem[n - 2][0] + elem[n - 1][0] < g[n - 1][0].second) {
        cout << "No\n";
        exit(0);
    }
    vector<bool> used(n - 1);
    for (int i = 0; i < n - 1; i++) {
        if (!used[i]) dfs(i, used, t_g);
    }
    reverse(ts.begin(), ts.end());
    cout << "Yes\n";
    for (auto u : ts) cout << u + 1 << ' ';
    cout << '\n';
}

/*
3 10
1 2 5
2 3 6
1
4 5
1
 */