//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

#include <iostream>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <vector>
#include <bits/stdc++.h>
using namespace std;




using ll = long long;



#define int ll
#define vec vector
#define endl "\n"
#define eb emplace_back
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define all(x) x.begin(), x.end()



const int N = 2e5 + 10, INF = 1e9 + 10;

using pii = pair<int, int>;

int n, group;


struct Edge {
    int from, to, w;
    Edge() {}
    Edge(int f, int t, int w) : from(f), to(t), w(w) {}
};


vec<int> nums[N], cop[N];
vec<int> g[N];
vec<pii> g2[N];
vec<Edge> edges;
vec<int> ans[N];


void input() {
    cin >> n >> group;
    edges.resize(n);
    for (int i = 1; i <= n - 1; ++i) {
        int from, to, w;
        cin >> from >> to >> w;
        g[from].eb(to); g2[from].eb(to, i);
        g[to].eb(from); g2[to].eb(from, i);
        edges[i] = {from, to, w};
    }

    for (int i = 1; i <= n; ++i) {
        int siz = sz(g[i]);
        nums[i].resize(siz);
        //cout << i << " " << siz << endl;
        for (auto& it : nums[i]) cin >> it;
        cop[i] = nums[i];
    }
}

void no() {
    cout << "No" << endl;
    exit(0);
}





bool checkPerm(vec<int>& arr) {
    for (int i = 1; i <= n; ++i)
        nums[i] = cop[i];

    bool flag = true;
    for (auto& it : arr) {
        auto [from, to, w] = edges[it];
        int x = nums[from].back();
        int y = nums[to].back();
        nums[from].pop_back();
        nums[to].pop_back();
        // cout << x << " " << y << " w : " << w << endl;
        if (x + y < w) return false;
    }

    return flag;
}



void n10() {
    vec<int> arr(n - 1);
    for (int i = 0; i < n - 1; ++i)
        arr[i] = i;
    for (int i = 1; i <= n; ++i) cop[i] = nums[i];

    do {
//        cout << "arr : ";
//        for (auto& it : arr) cout << it << " "; cout << endl;
        for (int i = 1; i <= n; ++i) nums[i] = cop[i];

        // cout << "-------------------" << endl;

        bool flag = true;
        for (auto& it : arr) {
            auto [from, to, w] = edges[it];
            int x = nums[from].back();
            int y = nums[to].back();
            nums[from].pop_back();
            nums[to].pop_back();
            // cout << x << " " << y << " w : " << w << endl;
            if (x + y < w) {
                flag = false;
                break;
            }
        }

        if (flag) {
            cout << "Yes" << endl;
            for (auto &it: arr) cout << it + 1 << " ";
            cout << endl;
            exit(0);
        }
    } while (next_permutation(all(arr)));

    cout << "No" << endl;
    exit(0);
}




void dfs(int v, int pre, int preInd) {
    if (v != 1)
        g[v].erase(find(all(g[v]), pre));
    for (auto& [to, inde] : g2[v]) {
        if (to == pre) continue;
        dfs(to, v, inde);
    }


    if (g[v].empty()) {
        ans[v] = {preInd};
        return;
    }

    auto func = [&](const pii& it){
        auto [to, i] = it;
        assert(sz(nums[to]) == 1);
        int num = nums[to].back();
        nums[to].pop_back();
        int left = num - edges[i].w;
        return left;
    };

    vec<pii> be;
    for (auto& [to, i] : g2[v])
        if (to != pre)
            be.eb(-func(mp(to, i)), to);
    sort(all(be));



    vec<int> arr(sz(nums[v]));
    for (int i = 0; i < sz(arr); ++i) arr[i] = i;
    sort(all(arr), [&](int i, int j){
        return nums[v][i] > nums[v][j];
    });




    auto tryFindOrder = [&](vec<int> li){
        auto beCop = be;
        vec<int> order;
        while (!li.empty()) {
            int x = li.back(); li.pop_back();
            auto it = upper_bound(all(be), mp(x, (int) INF));
            if (it == be.begin()) {
                order.clear();
                be = beCop;
                return order;
            }
            --it;

            auto [_, to] = *it;
            order.eb(to);
            //cout << " bruh : " << to << " " << _ << " "<< endl;
            be.erase(find(all(be), *it));
        }

        be = beCop;
        return order;
    };


    vec<int> order;
    int moment = -1;
    for (auto& inde : arr) {
        vec<int> li = nums[v];
        int x = nums[v][inde];
        if (v != 1) li.erase(find(all(li), x));
        order = tryFindOrder(li);

        if (v == 1 || !order.empty()) {
            moment = sz(nums[v]) - inde - 1;
            if (v != 1) nums[v] = {x};
            else nums[v] = {};
            break;
        }
    }
    if (sz(order) != sz(g[v])) no();

    for (int i = 0; i < sz(order); ++i) {
        int to = order[i];
        if (i == moment && v != 1)
            ans[v].eb(preInd);
        for (auto& it : ans[to])
            ans[v].eb(it);
    }
    if (moment == sz(order) && v != 1) {
        ans[v].eb(preInd);
    }
//
//    cout << "v : " << v << endl;
//    cout << "moment : " << moment << endl;
//    cout << "order : "; for (auto& it : order) cout << it << " "; cout << endl;
//    cout << "ans[v] : "; for (auto& it : ans[v]) cout << it << " "; cout << endl;
//    cout << "nums : "; for (auto& it : nums[v]) cout << it << " "; cout << endl;
}



int maxHi = 0;

void dfsBam(int v, int pre, int hi = 0) {
    maxHi = max(maxHi, hi);
    for (auto& to : g[v]) {
        if (to == pre) continue;
        dfsBam(to, v, hi + 1);
    }
}



void bamb() {
    deque<int> res, st;
    for (int i = 1; i + 1 <= n; ++i) {
        assert(sz(nums[i]) == 1);
        int x = nums[i][0];
        int need = edges[i].w - x;
        //cout << "i : " << i << " x : " << x << endl;
        if (*max_element(all(nums[i + 1])) < need) no();
        if (i + 1 == n) {
            res.eb(i);
            break;
        }

        int e = nums[i + 1][0], f = nums[i + 1][1];
       // cout << e << " " << f << endl;
        if (e <= f) {
            if (e >= need) {
                st.push_front(i);
                nums[i + 1] = {f};
                continue;
            }
            res.eb(i);
            nums[i + 1] = {e};
        } else {
            if (f >= need) {
                res.eb(i);
                nums[i + 1] = {e};
                continue;
            }
            st.push_front(i);
            nums[i + 1] = {f};
        }
    }

    for (auto& it : st) res.eb(it);

    cout << "Yes" << endl;
    for (auto& it : res) cout << it << " "; cout << endl;
    exit(0);
}


signed main() {
#ifdef RODYA
    freopen("C:\\Users\\olymp\\CLionProjects\\untitled\\bigTest.in", "r", stdin);
#else
    cin.tie(0), ios_base::sync_with_stdio(false);
#endif


    input();
    dfsBam(1, -1);
    if (maxHi == n - 1) bamb();
    // if (n <= 10) n10();

//
    dfs(1, -1, -1);

    vec<int> res = ans[1];
    if (sz(res) != n - 1 || !checkPerm(res))
        no();


    cout << "Yes" << endl;
    for (auto& it : res)
        cout << it << " ";
    cout << endl;


}
