#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <unordered_map>
#include <set>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <cmath>
#include <random>

using namespace std;
typedef long long ll;
const ll inf = 1e18;
vector <vector <pair <ll, ll> > > g;
vector <bool> used;
vector <multiset <ll> > all;
vector <map <ll, vector <ll> > > vosst;
vector <vector <ll> > ans;
vector <vector <ll> > ansv;
unordered_map <ll, ll> num;
vector <ll> edp;

void dfs(ll cur)
{
    used[cur] = 1;
    ans[cur].resize(g[cur].size() - 1);
    for (auto i : g[cur])
    {
        if (!used[i.first])
        {
            dfs(i.first);
        }
    }
    for (auto p : g[cur])
    {
        ll add = p.second - *all[p.first].begin();
        auto it = lower_bound(all[cur].begin(), all[cur].end(), add);
        if (it == all[cur].end())
        {
            cout << "No";
            exit(0);
        }
        else
        {
            ll l = *it;
            ll ind = vosst[cur][l].back();
            vosst[cur][l].pop_back();
            all[cur].erase(all[cur].find(l));
            ans[cur][ans.size() - 1 - ind] = num[min(cur, p.first) * 2e5 + max(cur, p.first)];
            ansv[cur][ans.size() - 1 - ind] = p.first;
        }
    }

}

void print(ll cur)
{
    used[cur] = 1;
    for (auto i : ansv[cur])
    {
        print(i);
        cout << num[2e5 * min(cur, i) + max(cur, i)] + 1 << " ";
    }

}
int main()
{
    ios::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    ll n, gr;
    cin >> n >> gr;
    //unordered_map <ll , ll> num;
    g.resize(n);
    //vector < vector <pair <ll, ll> > > g(n);
    vector <ll> deg(n, 0);
    edp.resize(n);
    for (ll i = 0; i < n - 1; i++)
    {
        ll a, b, w;
        cin >> a >> b >> w;
        if (a > b) swap(a, b);
        a--; b--;
        g[a].push_back({ b, w });
        g[b].push_back({ a, w });
        num[a * 2e5 + b] = i;
        edp[i] = w;
        deg[a]++;
        deg[b]++;
    }
    vector <vector <ll> > stick(n);
    for (ll i = 0; i < n; i++)
    {
        for (ll j = 0; j < deg[i]; j++)
        {
            ll a;
            cin >> a;
            stick[i].push_back(a);
        }
    }
    used.assign(n, 0);
    all.resize(n);
    vosst.resize(n);
    for (ll i = 0; i < n; i++)
    {
        for (ll j = 0; j < stick[i].size(); j++)
        {
            all[i].insert(stick[i][j]);
            vosst[i][stick[i][j]].push_back(j);
        }
    }
    ans.resize(n);
    dfs(0);
    cout << "Yes";
    print(0);
}

 