//#pragma GCC optimized("O3")

#include <random>
#include <bits/stdc++.h>

using namespace std;
#define int long long
using ll = long long;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
const ll maxn = 2e5 + 1, inf = 1e18, mod = 1e9 + 7;

template <typename T>
int sz(T a){
    return (int)a.size();
}

map<pair<int, int>, pair<int, int>> ed;
vector<vector<int>> g;
vector<multiset<pair<int, int>>> p;
vector<vector<int>> ans;

void dfs(int v, int pred) {
    for (auto to: g[v]) {
        if (to != pred) {
            dfs(to, v);
        }
    }
    if (v != 0) {
        if(p[v].empty() || p[pred].empty()){
            cout << "No";
            exit(0);
        }
        int h = p[v].begin()->first;
        pair<int, int> k = {min(pred, v), max(pred, v)};
        auto it = p[pred].lower_bound({ed[k].first - h, -1});
        if (it == p[pred].end()) {
            cout << "No";
            exit(0);
        }
        ans[pred][it->second] = ed[k].second;
        ans[v][p[v].begin()->second] = ed[k].second;
        p[pred].erase(it);
        p[v].erase(p[v].begin());
    }
}

void solve() {
    int n, t;
    cin >> n >> t;
    vector<int> deg(n);
    g.resize(n);
    ans.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w, u--, v--;
        if (u > v)
            swap(u, v);
        ed[{u, v}] = {w, i};
        deg[u]++;
        deg[v]++;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        ans[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            int h;
            cin >> h;
            p[i].insert({h, j});
        }
    }
    dfs(0, -1);
    map<int, vector<int>> mp;
    vector<int> q;
    queue<int> d;
    for (int i = 0; i < n; ++i) {
        mp[ans[i].back()].push_back(i);
        if (sz(mp[ans[i].back()]) > 1)
            d.push(i);
    }
    while (!d.empty()) {
        int u = d.front();
        int s = ans[u].back();
        d.pop();
        q.push_back(s);
        ans[mp[s][0]].pop_back();
        if (!ans[mp[s][0]].empty())
            mp[ans[mp[s][0]].back()].push_back(mp[s][0]);
        if (sz(mp[ans[mp[s][0]].back()]) > 1)
            d.push(mp[s][0]);
        ans[mp[s][1]].pop_back();
        if (!ans[mp[s][1]].empty())
            mp[ans[mp[s][1]].back()].push_back(mp[s][1]);
        if (sz(mp[ans[mp[s][1]].back()]) > 1)
            d.push(mp[s][1]);
    }
    if (sz(q) < n - 1) {
        cout << "No";
        return;
    }
    cout << "Yes\n";
    for (auto i: q) {
        cout << i + 1 << " ";
    }

}

signed main() {
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
