#include <bits/stdc++.h>

using ll = long long int;
using ull = unsigned long long int;
using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector<vector<int>> gr;
vector<array<ll, 3>> edges;
bool check(vector<int> &p, vector<vector<ll>> c)
{
    for (int i : p)
    {
        auto [a, b, w] = edges[i];
        if (c[a].back() + c[b].back() < w)
            return false;
        c[a].pop_back();
        c[b].pop_back();
    }
    return true;
}

void solve()
{
    int n, g;
    cin >> n >> g;

    gr.resize(n);
    for (int i = 0; i < n - 1; i++)
    {
        int a, b, w;
        cin >> a >> b >> w;
        --a;
        --b;
        gr[a].push_back(b);
        gr[b].push_back(a);
        edges.push_back({a, b, w});
    }
    vector<vector<ll>> c(n);
    for (int i = 0; i < n; i++)
    {
        c[i].resize(gr[i].size());
        for (int j = 0; j < gr[i].size(); j++)
            cin >> c[i][j];
    }

    vector<int> p(n - 1);
    iota(all(p), 0);

    if (g <= 1)
    {
        do
        {
            if (check(p, c))
            {
                cout << "Yes\n";
                for (int i : p)
                    cout << i + 1 << ' ';
                cout << '\n';
                return;
            }
        } while (next_permutation(all(p)));
        cout << "No\n"; 
    }
    else
    {
        if (check(p, c))
        {
            cout << "Yes\n";
            for (int i : p)
                cout << i + 1 << ' ';
            cout << '\n';
            return;
        }
        cout << "No\n";
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("D:/olymp/Day 1/in.txt", "r", stdin);
    freopen("D:/olymp/Day 1/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif
    while (t--)
        solve();
    return 0;
}