#include <bits/stdc++.h>

using namespace std;

#define int long long
#define fi first
#define se second
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define pw(x) (1LL << x)
#define mp make_pair

constexpr int N = 2e5 + 2;

struct Edge {
    int v, u, w, i;
};

int n, group, deg[N], cnt[N];
Edge e[N];
vector<int> c[N], ans;
bool used[N];

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> group;
    for (int i = 0; i < n - 1; i ++) {
        cin >> e[i].v >> e[i].u >> e[i].w;
        e[i].v --; e[i].u --;
        deg[e[i].v] ++;
        deg[e[i].u] ++;
        e[i].i = i + 1;
    }

    for (int i = 0; i < n; i ++) {
        c[i].resize(deg[i]);
        for(int j = 0; j < deg[i]; j ++)
            cin >> c[i][j];
    }

    fill_n(cnt, n, 1);
    for (int rep = 0; rep < n - 1; rep ++) {
        int mi = 1e15, mik = -1;
        for (int i = 0; i < n - 1; i ++) {
            if (used[i])
                continue;
            int v = e[i].v, u = e[i].u, w = e[i].w;
            int need = c[v][deg[v] - cnt[v]] + c[u][deg[u] - cnt[u]] - w;
            if (need >= 0) {
                if (need < mi) {
                    mi = need;
                    mik = i;
                }
            }
        }
        if (mik == -1)
            break;
        ans.push_back(e[mik].i);
        cnt[e[mik].v] ++;
        cnt[e[mik].u] ++;
    }

    if (sz(ans) == n - 1) {
        cout << "Yes\n";
        for (int i : ans)
            cout << i << ' ';
    } else
        cout << "No";


    return 0;
}

/*

4 3
1 2 7
1 3 6
1 4 5
3 2 1
5
4
4



 */