#include <bits/stdc++.h>

using namespace std;

#define int long long
#define fi first
#define se second
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define pw(x) (1LL << x)
#define mp make_pair

constexpr int N = 2e5 + 2;

struct Edge {
    int v, u, w, i;
};

int n, group, deg[N], cnt[N];
Edge e[N];
vector<int> c[N], ans;
bool used[N], first_found, second_found;

mt19937 rnd((int)time(nullptr));

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

//    n = rnd() % 10 + 2;
    cin >> n >> group;
    for (int i = 0; i < n - 1; i ++) {
        cin >> e[i].v >> e[i].u >> e[i].w;
//        e[i].v = rnd() % n + 1;
//        e[i].u = rnd() % n + 1;
//        while (e[i].u == e[i].v)
//            e[i].u = rnd() % n + 1;
//        e[i].w = rnd() % 10 + 1;
        e[i].v --; e[i].u --;
        deg[e[i].v] ++;
        deg[e[i].u] ++;
        e[i].i = i + 1;
    }

    for (int i = 0; i < n; i ++) {
        c[i].resize(deg[i]);
        for(int j = 0; j < deg[i]; j ++) {
            cin >> c[i][j];
//            c[i][j] = rnd() % 8 + 1;
        }
    }

    if (group == 1) {
        vector<int> p(n - 1);
        iota(p.begin(), p.end(), 0);
        do {
            bool good = true;
            fill_n(cnt, n, 1);
            for (int i = 0; i < n - 1; i ++) {
                int v = e[p[i]].v, u = e[p[i]].u, w = e[p[i]].w;
                if (cnt[v] > deg[v] || cnt[u] > deg[u] || c[v][deg[v] - cnt[v]] + c[u][deg[u] - cnt[u]] < w) {
                    good = false;
                    break;
                }
                cnt[v] ++;
                cnt[u] ++;
            }

            if (good) {
                first_found = true;
                cout << "Yes\n";
                for (int i : p)
                    cout << e[i].i << ' ';
                return 0;
            }
        } while (next_permutation(all(p)));

        cout << "No";
        return 0;
    }

    if (group == 3) {
        set<pair<int, int> > need;
        for (int i = 0; i < n - 1; i ++)
            need.insert(mp(e[i].w - c[e[i].u][0], e[i].i));
        vector<int> ans;
        for (int i = n - 2; i >= 0; i --) {
            int now = c[0][i];
            auto it = need.upper_bound(mp(now, N));
            if (it == need.begin())
                continue;
            it --;
//            cout << (*it).fi << ' ' << (*it).se << '\n';
            if (it != need.end()) {
                ans.push_back((*it).se);
                need.erase(it);
            }
        }
        if (sz(ans) == n - 1) {
            cout << "Yes\n";
            for(int i : ans)
                cout << i << ' ';
        } else
            cout << "No";
        return 0;
    }

    fill_n(cnt, n, 1);
    for (int rep = 0; rep < n - 1; rep ++) {
        int mi = 1e15, mik = -1, miw = -1;
        for (int i = 0; i < n - 1; i ++) {
            if (used[i])
                continue;
            int v = e[i].v, u = e[i].u, w = e[i].w;
            int need = c[v][deg[v] - cnt[v]] + c[u][deg[u] - cnt[u]] - w;
//            cout << rep << " | " << i << ' ' << v << ' ' << u << ' ' << need << '\n';
            if (need >= 0) {
                if (need < mi) {
                    mi = need;
                    mik = i;
                    miw = w;
                } else if (need == mi && w > miw) {
                    mi = need;
                    mik = i;
                    miw = w;
                }
            }
        }
        if (mik == -1)
            break;
//        cout << mi << ' ' << mik << '\n';
        ans.push_back(e[mik].i);
        used[mik] = true;
        cnt[e[mik].v] ++;
        cnt[e[mik].u] ++;
    }

    if (sz(ans) == n - 1) {
        second_found = true;
        cout << "Yes\n";
        for (int i : ans)
            cout << i << ' ';
    } else
        cout << "No";

//    if (first_found != second_found) {
//        cerr << '\n' << n << '\n';
//        for (int i = 0; i < n - 1; i ++)
//            cout << e[i].v << ' ' << e[i].u << ' ' << e[i].w << '\n';
//        for (int i = 0; i < n; i ++) {
//            for (int j : c[i])
//                cout << j << ' ';
//            cout << '\n';
//        }
//        cout << first_found << ' ' << second_found << '\n';
//        for (int i : p)
//            cout << i + 1 << ' ';
//        cout << '\n';
//        for (int i : ans)
//            cout << i << ' ';
//        cout << '\n';
//    }


    return 0;
}

/*

 4 3
1 2 7
1 3 6
1 4 5
3 2 1
4
4
4

 */