#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

const int INF = 1e9;
const int N = 2005;
const int MOD = 1e9 + 7;
const int M = 10005; // !!!!!!!!!!!!!!!!!!!!!!!1

mt19937 gen(time(0));

void solve() {
    ll n, group; cin >> n >> group;
    vector<vector<pair<ll, ll>>> g(n);
    vector<ll> deg(n);
    vector<pair<pair<ll, ll>, pair<ll, ll>>> e;
    for (int i = 0; i < n - 1; i++) {
        ll u, v, w; cin >> u >> v >> w;
        u--; v--;
        e.push_back({{w, i}, {u, v}});
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        deg[u]++;
        deg[v]++;
    }
    vector<vector<ll>> a(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            ll x; cin >> x;
            a[i].push_back(x);
        }
    }
    sort(e.begin(), e.end());
    reverse(e.begin(), e.end());
    vector<ll> ans;
    for (int i = 0; i < n - 1; i++) {
        ll w = e[i].first.first;
        ll u = e[i].second.first, v = e[i].second.second;
        if (a[u].back() + a[v].back() < w) {
            cout << "No" << '\n';
            return;
        }
        a[u].pop_back();
        a[v].pop_back();
        ans.push_back(e[i].first.second);
    }
    cout << "Yes" << '\n';
    for (auto i : ans) cout << i + 1 << " ";
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    int tst = 1;
    while (tst--) {
        solve();
    }
}
