#include "bits/stdc++.h"

#define int long long
#define ull unsigned long long
#define ld long doublt
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

void solve() {
    int n, g;
    cin >> n >> g;
    if (g <= 1) {
        vector<int> cnt(n, 0);
        vector<tuple<int, int, int>> edges(n - 1);
        for (auto &[v, u, w] : edges) {
            cin >> v >> u >> w;
            --v, --u;
            ++cnt[v];
            ++cnt[u];
        }
        vector<vector<int>> a(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < cnt[i]; ++j) {
                int temp;
                cin >> temp;
                a[i].emplace_back(temp);
            }
        }
        vector<int> cur(n - 1);
        iota(all(cur), 0ll);
        do {
            bool flag = true;
            vector<vector<int>> b = a;
            for (int i = 0; i < n - 1; ++i) {
                auto [v, u, w] = edges[cur[i]];
                if (b[v].back() + b[u].back() < w) {
                    flag = false;
                    break;
                }
                b[v].pop_back();
                b[u].pop_back();
            }
            if (!flag) {
                continue;
            }
            cout << "Yes\n";
            for (int i : cur) {
                cout << i + 1 << ' ';
            }
            return;
        } while (next_permutation(all(cur)));
    }
    cout << "No";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}