#include "bits/stdc++.h"

#define int long long
#define ull unsigned long long
#define ld long doublt
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

void solve() {
    int n, g;
    cin >> n >> g;
    if (g <= 1 || n <= 10) {
        vector<int> cnt(n, 0);
        vector<tuple<int, int, int>> edges(n - 1);
        for (auto &[v, u, w] : edges) {
            cin >> v >> u >> w;
            --v, --u;
            ++cnt[v];
            ++cnt[u];
        }
        vector<vector<int>> a(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < cnt[i]; ++j) {
                int temp;
                cin >> temp;
                a[i].emplace_back(temp);
            }
        }
        vector<int> cur(n - 1);
        iota(all(cur), 0ll);
        do {
            bool flag = true;
            vector<vector<int>> b = a;
            for (int i = 0; i < n - 1; ++i) {
                auto [v, u, w] = edges[cur[i]];
                if (b[v].back() + b[u].back() < w) {
                    flag = false;
                    break;
                }
                b[v].pop_back();
                b[u].pop_back();
            }
            if (!flag) {
                continue;
            }
            cout << "Yes\n";
            for (int i : cur) {
                cout << i + 1 << ' ';
            }
            return;
        } while (next_permutation(all(cur)));
    } else if (g == 2) {
        vector<int> cnt(n, 0);
        vector<tuple<int, int, int>> edges(n - 1);
        for (auto &[v, u, w] : edges) {
            cin >> v >> u >> w;
            --v, --u;
            ++cnt[v];
            ++cnt[u];
        }
        vector<vector<int>> a(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < cnt[i]; ++j) {
                int temp;
                cin >> temp;
                a[i].emplace_back(temp);
            }
        }
        vector<int> b, e;
        for (int i = n - 1; i > 0; --i) {
            auto [v, u, w] = edges[i - 1];
            vector<int> good;
            for (int j = 0; j < cnt[i - 1]; ++j) {
                if (a[i].back() + a[i - 1][j] >= w) {
                    good.emplace_back(j);
                }
            }
            if (good.empty()) {
                cout << "No";
                return;
            }
            if (sz(good) == 2) {
                if (a[i - 1][0] < a[i - 1][1]) {
                    a[i - 1].erase(a[i - 1].begin());
                    e.emplace_back(i - 1);
                } else {
                    a[i - 1].erase(a[i - 1].begin() + 1);
                    b.emplace_back(i - 1);
                }
            } else if (good[0] == 0) {
                a[i - 1].erase(a[i - 1].begin());
                e.emplace_back(i - 1);
            } else {
                a[i - 1].erase(a[i - 1].begin() + 1);
                b.emplace_back(i - 1);
            }
        }
        reverse(all(e));
        cout << "Yes\n";
        for (int i : b) {
            cout << i + 1 << ' ';
        }
        for (int i : e) {
            cout << i + 1 << ' ';
        }
        return;
    } else if (g == 3) {
        vector<int> cnt(n, 0);
        vector<tuple<int, int, int>> edges(n - 1);
        for (auto &[v, u, w] : edges) {
            cin >> v >> u >> w;
            --v, --u;
            ++cnt[v];
            ++cnt[u];
        }
        vector<vector<int>> a(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < cnt[i]; ++j) {
                int temp;
                cin >> temp;
                a[i].emplace_back(temp);
            }
        }
        vector<int> cur = a[0];
        sort(all(cur));
        set<pair<int, int>> now;
        for (int i = 1; i < n; ++i) {
            auto [v, u, w] = edges[i - 1];
            int index = lower_bound(all(cur), w - a[i][0]) - cur.begin();
            if (index == sz(cur)) {
                cout << "No";
                return;
            }
            now.insert({cur[index], i});
        }
        vector<int> ans;
        for (int i = cnt[0] - 1; i >= 0; --i) {
            int t = a[0][i];
            auto it = now.upper_bound({t, 1e15});
            if (it == now.begin()) {
                cout << "No";
                return;
            }
            --it;
            auto [index, u] = *it;
            ans.emplace_back(u);
            now.erase({index, u});
        }
        cout << "Yes\n";
        for (int i : ans) {
            cout << i << ' ';
        }
        return;
    } else if (g == 5) {

        return;
    }
    cout << "No";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}