#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int n, group;
vector<pii > g[maxn];
set<pii > c[maxn];

void solve() {
    cin >> n >> group;
    vector<tuple<int, int, int>> e(n - 1);
    map<pii, pii > WWW;
    for (int i = 0; i < n - 1; ++i) {
        int a, b, w;
        cin >> a >> b >> w, a--, b--;
        if (a > b) swap(a, b);
        e[i] = {a, b, w};
        WWW[{a, b}] = {w, i};
        g[a].push_back({b, i});
        g[b].push_back({a, i});
    }
    for (int i = 0; i < n; i++) {
        int deg;
        cin >> deg;
        for (int j = 0; j < deg; j++) {
            int x;
            cin >> x;
            c[i].insert({x, j});
        }
    }
    if (group == 3) {
        vector<pii > so;
        for (int i = 0; i < n; i++) {
            int w = WWW[{0, i}].first;
            so.push_back({w - (c[i].begin())->first, i});
        }
        sort(all(so));
        vector<int> ord(n - 1);
        while (!so.empty()) {
            auto [nado, i] = so.back();
            so.pop_back();
            auto it = --c[0].end();
            if (it->first < nado) {
                cout << "No";
                return;
            }
            ord[it->second] = (WWW[{0, i}].second + 1);
            c[0].erase(it);
        }
        cout << "Yes\n";
        for (int i: ord) cout << i << ' ';
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
