#include<bits/stdc++.h>
#define int long long
using namespace std;

vector<pair<int, int>> P;
vector<vector<pair<int, int>>> G;
vector<vector<int>> slave;
vector<int> ans;
map<pair<int, int>, int> van;

void dfs(int v, int p, int w) {
    P[v] = {p, w};
    for (auto i : G[v]) {
        if (i.first != p) {
            dfs(i.first, v, i.second);
        }
    }
}

void dfs1(int v, int p) {
    for (auto i : slave[v]) {
        if (i != p) {
            dfs1(i, v);
        } else {
            ans.push_back(van[{v, i}]);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int a, b, c, d, k, t;
    cin >> a >> b;
    G.resize(a);
    P.resize(a);
    slave.resize(a);
    for (int i = 0; i < a - 1; ++i) {
        cin >> b >> c >> d;
        --b;
        --c;
        van[{b, c}] = i + 1;
        van[{c, b}] = i + 1;
        G[b].push_back({c, d});
        G[c].push_back({b, d});
    }
    vector<set<pair<int, int>>> X(a);
    set<pair<int, int>> S;
    vector<int> B(a);
    int cnt = 0;
    for (int i = 0; i < a; ++i) {
        if (i != 0) {
            S.insert({G[i].size(), i});
        }
        B[i] = cnt;
        for (int j = 0; j < G[i].size(); ++j) {
            cin >> b;
            X[i].insert({b, cnt});
            ++cnt;
        }
        slave[i].resize(G[i].size());
    }
    dfs(0, -1, -1);
    for (int i = 0; i < a - 1; ++i) {
        auto o = *S.begin();
        int pr = o.second;
        S.erase(S.begin());
        auto x1 = P[pr].first;
        int ned = P[pr].second - X[pr].begin()->first;
        if (X[x1].lower_bound({ned, 0}) == X[x1].end()) {
            cout << "NO";
            return 0;
        }
        if (x1 != 0) {
            S.erase({X[x1].size(), x1});
            S.insert({X[x1].size() - 1, x1});
        }
        slave[pr][X[pr].begin()->second - B[pr]] = x1;
        slave[x1][X[x1].lower_bound({ned, 0})->second - B[x1]] = pr;
        X[x1].erase(X[x1].lower_bound({ned, 0}));
    }
    dfs1(0, -1);
    cout << "YES" << endl;
    for (int i = ans.size() - 1; i >= 0; --i) {
        cout << ans[i] << ' ';
    }
}
