
#include <bits/stdc++.h>
#include "ext/pb_ds/tree_policy.hpp"
#include "ext/pb_ds/assoc_container.hpp"
using namespace __gnu_pbds;
using namespace std;
#define int long long
const int maxn = 2e5 + 10;
int n;
vector <int> c[maxn];
struct edge{
    int u, v, w;
};
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
vector <edge> sus;
int deg[maxn];
void solve_tup() {
    for (int i = 0; i<  n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        sus.push_back({a, b, w});
        deg[a]++, deg[b]++;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            int x; cin >> x;
            c[i].push_back(x);
        }
        std::reverse(c[i].begin(), c[i].end());
    }
    vector <int> s(n - 1);
    std::iota(s.begin(), s.end(), 0);
    do {
//        cout << " go next\n";
//        for (int i : s) cout << i + 1 << ' ';
//        cout << '\n';
        vector <int> ptrs(n + 1, 0);
        bool ok = 1;
        for (int i : s) {
            auto e = sus[i];
//            cout << e.w << ' ' << e.u << ' ' << e.v << '\n';
//            cout << c[e.u][ptrs[e.u]] << ' ' << c[e.v][ptrs[e.v]] << '\n';
//            cout << '\n';
            if (e.w > c[e.u][ptrs[e.u]] + c[e.v][ptrs[e.v]]) {
                ok = 0;
                break;
            }
            ptrs[e.u]++;
            ptrs[e.v]++;
        }
        if (ok) {
            cout << "Yes\n";
//            std::reverse(s.begin(), s.end());
            for (int i : s) cout << i + 1 << ' ';
            cout << '\n';
            return;
        }
    } while (std::next_permutation(s.begin(), s.end()));
    cout << "No\n";
}
void solve_ezh() {
    vector <int> vals(n + 1);
    vector <int> goes_to(n + 1);
    for (int i = 0; i<  n - 1; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        sus.push_back({a, b, w});
        if (a != 1) goes_to[a] = i;
        if (b != 1) goes_to[b] = i;
        deg[a]++, deg[b]++;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            int x; cin >> x;
            c[i].push_back(x);
        }
        std::reverse(c[i].begin(), c[i].end());
    }
    vector <pair<int, int>> vals_and_vertex;
    for (int i = 2; i <= n; i++) {
        vals_and_vertex.push_back({vals[i], i});
    }
    std::sort(vals_and_vertex.begin(), vals_and_vertex.end());
    ordered_set st;
    for (int i = 2; i <= n; i++) {
        st.insert(i);
    }

    vector <int> ans;
    for (int i = 0; i < c[1].size(); i++) {
        int f = c[1][i];

        if (vals_and_vertex[0].first > f) {
            cout << "No\n";
            return;
        }
        int l = 0;
        for (int j = 18; j >= 0; j--) {
            if (l + (1 << j) >= vals_and_vertex.size()) continue;
            if (vals_and_vertex[l + (1 << j)].first <= f) l += (1 << j);
        }

        if (st.find(l) != st.end()) {
            ans.push_back(goes_to[vals_and_vertex[l].second]);
            st.erase(l);
        } else {
            int s = st.order_of_key(l);
            if (s == 0) {
                cout << "No\n";
                return;
            }
            int num = *st.find_by_order(s - 1);
            st.erase(num);
            ans.push_back(goes_to[vals_and_vertex[num].second]);
        }
    }
    cout << "Yes\n";
    for (int i : ans) cout << i + 1 << ' ';
    cout << '\n';
}
signed main() {
    cin >> n;
    int _g; cin >> _g;
    if (_g == 0 || _g == 1) {
        solve_tup();
        return 0;
    }
    if (_g == 3) {
        solve_ezh();
        return 0;
    }

}