//#ifdef local
//#define _GLIBCXX_DEBUG
//#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define ve vector
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pb push_back
#define eb emplace_back
#define INF1 INT32_MAX
#define INF2 INT64_MAX
#define sz(a) (int)(a).size()

using namespace std;
using namespace __gnu_pbds;
random_device rd;
mt19937_64 rnd(rd());

template<typename key, typename cmp = less<key>>
using pbds = tree<key, null_type, cmp, rb_tree_tag, tree_order_statistics_node_update>;
const int maxn = (int)2*1e5+1;

struct node{
    int a, b, w;
};

ve<tuple<int, int, int>> g[maxn];
ve<int> c[maxn];
int n;
void rec(int i, int p, int &is, ve<int> &res) {
    auto[j, w, ind] = g[i][0];
    int val = w-c[i][p];
    if (i == n-1) {
        if (val > c[j][0]) is = 0;
        res.eb(ind);
        return;
    }
    if (c[j][0] < val && c[j][1] < val) {
        is = 0;
        return;
    }

    int f1 = (c[j][0] >= val ? c[j][0] : INF1);
    int f2 = (c[j][1] >= val ? c[j][1] : INF1);
    if (f1 < f2) {
        res.eb(ind);
        rec(i+1, 1, is, res);
    }
    else {
        rec(i+1, 0, is, res);
        res.eb(ind);
    }
}

void solve() {
    int t; cin >> n >> t;
    ve<tuple<int, int, int>> mas;
    int p12 = 0, ip1;
    for (int i = 0; i < n-1; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        g[a].eb(b, w, i);
        g[b].eb(a, w, i);
        mas.eb(a, b, w);
        if (min(a, b)==1 && max(a, b) == 2) p12 = w, ip1= i;
    }

    for (int i = 1; i <= n; ++i) sort(rall(g[i]));

    for (int i = 1; i <= n; ++i) {
        int k = sz(g[i]);
        while (k--) c[i].eb(),cin >> c[i].back();
        reverse(all(c[i]));
    }

    if (t<=1) {
        ve<int> v(n - 1);
        iota(all(v), 0);
        do {
            ve<int> ind(n+1);
            int is = 1;
            for (int i : v) {
                auto[a, b, w] = mas[i];
                if (c[a][ind[a]] + c[b][ind[b]] < w) {
                    is = 0;
                    break;
                }
                ++ind[a], ++ind[b];
            }
            if (is) {
                cout << "Yes\n";
                for (int i : v) cout << i+1 << " ";
                return;
            }
        } while (next_permutation(all(v)));
        cout << "No";
        return;
    }
    if (t==3) {
        ve<pair<int, int>> v;
        for (auto[i, w, ind] : g[1]) {
            v.eb(w-c[i][0], ind);
        }
        sort(all(v));
        ve<pair<int,int>> p;
        for (int i = 0; i < n-1; ++i) {
            p.eb(c[1][i], i);
        }
        sort(all(p));
        ve<int> res(n-1);

        for (int i = 0; i < n-1; ++i) {
            if (p[i].first < v[i].first) {
                cout << "No";
                return;
            }
            res[p[i].second] = v[i].second+1;
        }
        cout << "Yes\n";
        for (int i : res) cout << i << " ";
        return;
    }
    if (t==2) {
        int is=1;
        ve<int> res;
        rec(1, 0, is, res);
        if (!is) {
            cout << "No";
        }
        else {
            cout << "Yes\n";
            for (int i : res) cout << i+1 << " ";
        }
    }
    if (t == 4) {
        multiset<pair<int, int>> q1, q2;

        for (int i = 0; i < sz(c[1]); ++i) {
            q1.insert({c[1][i], i});
        }
        for (int i = 0; i < sz(c[2]); ++i) {
            q2.insert({c[2][i], i});
        }
        ve<int> res1(sz(g[1]), -1);
        ve<int> res2(sz(g[2]), -1);

        for (int i = 3; i <= n; ++i) {
            if (get<0>(g[i][0]) == 1) {
                auto it = q1.lower_bound(make_pair(get<1>(g[i][0]) - c[i][0], -1));
                if (it == q1.end()) {
                    cout << "No";
                    return;
                }
                res1[it->second] = get<2>(g[i][0]);
                q1.erase(it);
            }
        }
        if (q1.begin()->second == 0) {
            q1.clear();
            q2.clear();

            for (int i = 0; i < sz(c[1]); ++i) {
                q1.insert({c[1][i], i});
            }
            for (int i = 0; i < sz(c[2]); ++i) {
                q2.insert({c[2][i], i});
            }
            res1 = ve<int>(sz(g[1]), -1);
            res2 = ve<int>(sz(g[2]), -1);

            for (int i = 3; i <= n; ++i) {
                if (get<0>(g[i][0]) == 2) {
                    auto it = q2.lower_bound(make_pair(get<1>(g[i][0]) - c[i][0], -1));
                    if (it == q2.end()) {
                        cout << "No";
                        return;
                    }
                    res2[it->second] = get<2>(g[i][0]);
                    q2.erase(it);
                }
            }
            auto it = q1.lower_bound(make_pair(p12 - q2.begin()->first, -1));

            if (it == q1.end()) {
                cout << "No";
                return;
            }
            res1[it->second] = ip1;
            q1.erase(it);
            for (int i = 3; i <= n; ++i) {
                if (get<0>(g[i][0]) == 1) {
                    it = q1.lower_bound(make_pair(get<1>(g[i][0]) - c[i][0], -1));
                    if (it == q1.end()) {
                        cout << "No";
                        return;
                    }
                    res1[it->second] = get<2>(g[i][0]);
                    q1.erase(it);
                }
            }
            cout << "Yes\n";
            for (int i = 0; i < sz(g[2]); ++i) {
                if (res2[i] == -1) continue;
                cout << res2[i]+1 << " ";
            }
            for (int i = 0; i < sz(g[1]); ++i) {
                if (res1[i] == -1) continue;
                cout << res1[i]+1 << " ";
            }
            return;
        }
        auto it = q2.lower_bound(make_pair(p12 - q1.begin()->first, -1));

        if (it == q2.end()) {
            cout << "No";
            return;
        }
        res2[it->second] = ip1;
        q2.erase(it);
        for (int i = 3; i <= n; ++i) {
            if (get<0>(g[i][0]) == 2) {
                it = q2.lower_bound(make_pair(get<1>(g[i][0]) - c[i][0], -1));
                if (it == q2.end()) {
                    cout << "No";
                    return;
                }
                res2[it->second] = get<2>(g[i][0]);
                q2.erase(it);
            }
        }
        cout << "Yes\n";
        for (int i = 0; i < sz(g[1]); ++i) {
            if (res1[i] == -1) continue;
            cout << res1[i]+1 << " ";
        }
        for (int i = 0; i < sz(g[2]); ++i) {
            cout << res2[i]+1 << " ";
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--) solve();
}




