#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
#define ll long long
#define nl '\n'
#define emp emplace_back
#define all(x) x.begin(), x.end()
#define pll pair<ll, ll>
#define ff first
#define ss second

using namespace std;
//using namespace __gnu_pbds;
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto x : a) {
        out << x << ' ';
    }
    out << '\n';
    return out;
}

ll n, gr;
vector<vector<pll>> g;
vector<vector<ll>> c;
vector<ll> deg;
vector<ll> p, used;
vector<pair<pll, ll>> edges;

void gen(ll i) {
    if (i == n - 1) {
        bool fl = true;
        vector<ll> h(n);
        for (ll j = 0; j < n - 1; ++j) {
            auto [a, b] = edges[p[j] - 1].ff;
            if (c[a][h[a]] + c[b][h[b]] < edges[p[j] - 1].ss) {
                fl = false;
                break;
            }
            ++h[a];
            ++h[b];
        }
        if (fl) {
            cout << "Yes" << nl;
            cout << p;
            exit(0);
        }
        return;
    }
    for (ll j = 0; j < n - 1; ++j) {
        if (!used[j]) {
            p.emp(j + 1);
            used[j] = 1;
            gen(i + 1);
            p.pop_back();
            used[j] = 0;
        }
    }
}

void solve() {
    cin >> n >> gr;
    deg.resize(n);
    g.resize(n);
    c.resize(n);
    used.resize(n - 1);
    map<pll, ll> mp;
    for (ll i = 0; i < n - 1; ++i) {
        ll a, b, w;
        cin >> a >> b >> w;
        --a;
        --b;
        g[a].emp(b, w);
        g[b].emp(a, w);
        ++deg[a];
        ++deg[b];
        mp[{a, b}] = i;
        mp[{b, a}] = i;
        edges.push_back({{a, b}, w});
    }
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < deg[i]; ++j) {
            ll x;
            cin >> x;
            c[i].emp(x);
        }
    }
    for (auto &x : c) {
        reverse(all(x));
    }
    if (gr == 1) {
        gen(0);
        cout << "No";
        return;
    }
    sort(all(c[0]));
    vector<pll> st;
    for (ll i = 1; i < n; ++i) {
        ll d = g[i][0].ss - c[i][0];
        st.emp(lower_bound(all(c[0]), d) - c[0].begin(), i);
    }
    sort(all(st));
    vector<ll> ans;
    for (ll i = 0; i < n - 1; ++i) {
        if (st[i].ff > i) {
            cout << "No";
            return;
        }
        ans.emp(mp[{0, st[i].ss}] + 1);
    }
    cout << "Yes" << nl;
    cout << ans;
}

int main() {
#ifdef CLOCK
    ll time1 = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    cin >> tpk;
#endif

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef CLOCK
    cout << clock() - time1 << " ms";
#endif
}
