#include <iostream>
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
*/
#include <bits/stdc++.h>
using namespace std;

/*
#include <bits/extc++.h>
using namespace __gnu_pbds;
typedef tree<
        int,
        null_type,
        less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
 */

//#define int long long
#define ll long long
#define fi first
#define se second
#define eb emplace_back
#define lwb lower_bound
#define upb upper_bound
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define ld long double
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
const int INF = 1e18, N = 300300, K = 26, C = 700, P = 1e9 + 7;
const ld EPS = 1e-5, pi = 3.1415926535;

vector<vector<int>> g;
vector<vector<pair<int, int>>> tree;
vector<vector<int>> c;
vector<vector<int>> num;
vector<int> col, deg, ost, rev, muv;
vector<int> match, used;
int timer = 0;

void build(int v, int p = -1, int color = 0) {
    col[v] = color;
    for (auto [to, w] : tree[v]) {
        if (to == p)
            continue;
        for (int j1 = 0; j1 < deg[v]; j1++) {
            for (int j2 = 0; j2 < deg[to]; j2++) {
                if (c[v][j1] + c[to][j2] >= w) {
                    g[num[v][j1]].eb(num[to][j2]);
                    g[num[to][j2]].eb(num[v][j1]);
                }
            }
        }
        build(to, v, (color + 1) % 2);
    }
}

bool try_kuhn(int v) {
    used[v] = timer;
    for (auto to : g[v]) {
        if (match[to] == -1) {
            match[v] = to;
            match[to] = v;
            return true;
        }
        if (used[match[to]] == timer)
            continue;
        if (try_kuhn(match[to])) {
            match[v] = to;
            match[to] = v;
            return true;
        }
    }
    return false;
}

map<pair<int, int>, int> mp;
vector<int> ansik;

void dfs(int v) {
    used[v] = timer;
    int to = match[v];
    ost[v] = 0;
    if (ost[to] == 0 && used[to] != timer) {
        dfs(to);
    }
    else if (ost[to] == 0) {
        ansik.eb(mp[{rev[v], rev[to]}] + 1);
    }
    if (muv[v] < deg[rev[v]] - 1)
        dfs(num[rev[v]][muv[v] + 1]);
}


void solve() {
    int n, gg;
    cin >> n >> gg;
    deg.resize(n + 1);
    tree.resize(n + 1);
    col.resize(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        deg[v]++, deg[u]++;
        tree[v].eb(u, w);
        tree[u].eb(v, w);
        mp[{v, u}] = i;
        mp[{u, v}] = i;
    }
    c.resize(n + 1);
    num.resize(n + 1);
    int tmp = 0;
    for (int i = 1; i <= n; i++) {
        c[i].resize(deg[i]);
        num[i].resize(deg[i]);
        vector<int> inp(deg[i]);
        for (auto &it : inp)
            cin >> it;
        reverse(all(inp));
        for (int j = 0; j < deg[i]; j++) {
            c[i][j] = inp[j];
            num[i][j] = tmp++;
        }
    }

    ost.resize(tmp);
    rev.resize(tmp);
    muv.resize(tmp);
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            ost[num[i][j]] = j;
            rev[num[i][j]] = i;
            muv[num[i][j]] = j;
        }
    }

    g.resize(tmp);
    match.resize(tmp, -1);
    used.resize(tmp);
    build(1);
    bool fl = true;
    int res = 0;
    while (fl) {
        fl = false;
        timer++;
        for (int i = 0; i < tmp; i++) {
            if (col[i] == 1 || used[i] == timer || match[i] != -1)
                continue;
            if (try_kuhn(i)) {
                fl = true;
                res++;
            }
        }
    }
    if (res != n - 1) {
        cout << "No" << endl;
        return;
    }
    cout << "Yes" << endl;



    timer++;
    for (int j = 0; j < tmp; j++) {
        for (int i = 0; i < tmp; i++) {
            if (used[i] != timer)
                dfs(i);
        }
    }

    for (auto it : ansik) {
        cout << it << " ";
    }
    cout << endl;
}

signed main() {
    //cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    //cin >> T;
    while (T--)
        solve();
    return 0;
}