#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;

struct jet{
    ll to, cost;
};


void solve(){
    ll group;
    ll n, t1, t2, t3;
    cin >> n >> group;
    vector<jet> v(n);
    for (int i = 0; i < n - 1; ++i) {
        cin >> t1 >> t2 >> t3;
        t1--;
        t2--;
        v[t1].to = t2;
        v[t1].cost = t3;
    }
    vector<vll> s(n);
    for (int k = 0; k < n; ++k) {
        if (k == 0 || k == n - 1){
            cin >> t1;
            s[k].push_back(t1);
        }
        else{
            cin >> t1 >> t2;
            s[k].push_back(t1);
            s[k].push_back(t2);
        }
    }
    vll ans;
    for (int j = 0; j < n - 1; ++j) {
        if (s[j].size() != 0 && s[j + 1].size() != 0 && s[j].back() + s[j + 1].back() >= v[j].cost){
            ans.push_back(j);
            s[j].pop_back();
            s[j + 1].pop_back();
        }
    }
    for (int j = n - 1; j > 0; --j) {
        if (s[j].size() != 0 && s[j - 1].size() != 0 && s[j].back() + s[j - 1].back() >= v[j - 1].cost){
            ans.push_back(j - 1);
            s[j].pop_back();
            s[j - 1].pop_back();
        }
    }
    if (ans.size() == n - 1){
        cout << "YES\n";
        for (int i = 0; i < ans.size(); ++i) {
            cout << ans[i] << " ";
        }
        cout << "\n";
    }
    else{
        cout << "NO\n";
        /*cout << ans.size();
        for (int i = 0; i < s.size(); ++i) {
            for (int j = 0; j < s[i].size(); ++j) {
                cout << s[i][j] + 1 << " ";
            }
            cout << "\n";
        }*/
    }
}



int main(){
    /*ll task, group;
    cin >> task >> group;
    */
    solve();
}
