#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll INF = 1e18;

struct str {
    ll u, v, w;
};

void solve(){
    ll n, g;
    cin >> n >> g;
    vector<str> v(n - 1);
    vector<ll> step(n + 1);
    for(ll i = 0; i < n - 1; i++){
        cin >> v[i].u >> v[i].v >> v[i].w;
        step[v[i].u]++, step[v[i].v]++;
    }
    vector<stack<ll>> st(n + 1);
    for(ll i = 1; i <= n; i++){
        for(ll j = 0; j < step[i]; j++){
            ll x;
            cin >> x;
            st[i].push(x);
        }
    }
    vector<ll> used(n - 1), ans;
    for(ll it = 0; it < n - 1; it++){
        ll id, mn = INF;
        for(ll i = 0; i < n - 1; i++){
            if(!used[i]){
                ll x1 = st[v[i].u].top(), x2 = st[v[i].v].top();
                if(x1 + x2 >= v[i].w){
                    if(mn > x1 + x2 - v[i].w){
                        id = i;
                        mn = x1 + x2 - v[i].w;
                    }
                }
            }
        }
        if(mn == INF){
            cout << "No";
            return;
        } else {
            ans.push_back(id);
            used[id] = true;
            st[v[id].u].pop();
            st[v[id].v].pop();
        }
    }
    cout << "Yes" << '\n';
    for(auto u : ans){
        cout << u + 1 << ' ';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    while(t--){
        solve();
    }
}
