#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll INF = 1e18, N = 3e5 + 1;

struct str {
    ll u, w, id;
};

vector<str> gr[N];

vector<ll> step(N), ans, c[N], need(N), uk(N), pos[N];

void dfs(ll v, ll p = -1, ll wp = 0){
    vector<pair<ll, ll>> q;
    for(auto u : gr[v]){
        if(u.u != p){
            dfs(u.u, v, u.w);
            q.emplace_back(need[u.u], u.id);
        }
    }
    set<pair<ll, ll>> st;
    for(ll i = 0; i < step[v]; i++){
        st.insert({c[v][i], i});
    }
    pos[v].resize(step[v]);
    for(auto u : q){
        pair<ll, ll> k = {u.first, -1};
        if(st.lower_bound(k) == st.end()){
            cout << "No";
            exit(0);
        } else {
            auto f = *st.lower_bound(k);
            st.erase(f);
            pos[v][f.second] = u.second;
        }
    }
    if(v == 1){
        for(ll i = step[v] - 1; i >= 0; i--){
            ans.push_back(pos[v][i]);
        }
    } else {
        pair<ll, ll> k = *st.begin();
        need[v] = wp - k.first;
        uk[v] = k.second;
        for(ll i = step[v] - 1; i > uk[v]; i--){
            ans.push_back(pos[v][i]);
        }
    }
}

void dfs2(ll v, ll p = -1){
    for(auto u : gr[v]){
        if(p != u.u){
            dfs2(u.u, v);
        }
    }
    if(v != 1){
        for(ll i = uk[v] - 1; i >= 0; i--){
            ans.push_back(pos[v][i]);
        }
    }
}

void solve(){
    ll n, g;
    cin >> n >> g;
    for(ll i = 0; i < n - 1; i++){
        ll u, v, w;
        cin >> u >> v >> w;
        gr[u].push_back({v, w, i});
        gr[v].push_back({u, w, i});
        step[u]++, step[v]++;
    }
    for(ll i = 1; i <= n; i++){
        for(ll j = 0; j < step[i]; j++){
            ll x;
            cin >> x;
            c[i].push_back(x);
        }
    }
    dfs(1);

    dfs2(1);
    cout << "Yes" << '\n';
    for(auto u : ans){
        cout << u + 1 << ' ';
    }
}

int main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
    solve();
}
