#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using lll = __int128;
using ld = long double;

void badEnd() {
    cout << "No\n";
    exit(0);
}

int n, ggg;
vi sizes;
map<pi, int> edgess;
int getE(int a, int b) {
    return edgess[{a, b}];
}


void solve2(vector<pair<pi, pi>> &edges);

void solve() {
    vector<vector<pi>> g;
    vector<set<pi>> vs;
    // INPUT
    cin >> n >> ggg;
    g.resize(n);
    sizes.assign(n, 0);
    for (int i = 0; i < n-1; i++) {
        int a, b, w; cin >> a >> b >> w; a--, b--;
        edgess[{a, b}] = i + 1;
        edgess[{b, a}] = i + 1;
        g[a].emplace_back(b, w);
        g[b].emplace_back(a, w);
        sizes[a]++;
        sizes[b]++;
    }
    vs.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < sizes[i]; j++) {
            int x; cin >> x;
            vs[i].emplace(x, j);
        }
    }

    // SOLVING

    vector<pair<pi, pi>> edges2;
    vector<vector<pi>> g2(n);
    function<pi(int, int)> dfs0;
    dfs0 = [&](int v, int p) {
        for (auto[to, w] : g[v]) {
            if (to == p) continue;
            auto[toi, ind2] = dfs0(to, v);
            int need = w - toi;
            auto t = vs[v].lower_bound({need, -1});
            if (t == vs[v].end()) badEnd();
            int ind1 = t->second;
            vs[v].erase(t);
            edges2.emplace_back(pi(v, to), pi(ind1, ind2));
            // first in vs where vs[v].first > w-vi
        }
        return *vs[v].begin();
    };
    dfs0(0, 0);
    cout << "Yes\n";
    solve2(edges2);
}
void solve2(vector<pair<pi, pi>> &edges) {
    vector<vector<pi>> indes(n);
    for (int i = 0; i < n; i++) {
        indes[i].resize(sizes[i]);
    }
    for (auto [vv, toto] : edges) {
        auto[v1, v2] = vv;
        auto[ind1, ind2] = toto;
        indes[v1][ind1] = {v2, ind2};
        indes[v2][ind2] = {v1, ind1};
    }
    vi out;
    function<void(int, int)> dfs;
    dfs = [&] (int v, int p) {
        while (!indes[v].empty()) {
            auto[v2, ind2] = indes[v].back();
            if (indes[v2].size() != ind2+1) {
                dfs(v2, v);
                continue;
            }
            out.push_back(getE(v, v2));
            indes[v2].pop_back();
            indes[v].pop_back();
            if (v2 != p)
                dfs(v2, v);
        }
    };
    dfs(0, -1);
    for (int i : out)
        cout << i << " ";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    solve();
}
