#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;

struct st {
	int to, len;
};

struct e {
	int x, y, w;
};

int n, nmb;
vector <vector <st>> g;
vector <e> ed;
vector <vector <int>> c;
vector <int> ord;

bool comp(int a, int b) { return ed[a].w < ed[b].w; }

bool check() {
	vector <int> kol(n);
	for (int i = 0; i < n; i++) kol[i] = g[i].size() - 1;
	for (auto i : ord) {
		if (c[ed[i].x][kol[ed[i].x]] + c[ed[i].y][kol[ed[i].y]] < ed[i].w) return 0;
		kol[ed[i].x]--, kol[ed[i].y]--;
	}
	return 1;
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	cin >> n >> nmb;
	g.resize(n), c.resize(n), ed.resize(n - 1);
	for (int i = 0; i < n - 1; i++) {
		ord.push_back(i);
		int x, y, w; cin >> x >> y >> w; x--, y--;
		g[x].push_back({ y, w });
		g[y].push_back({ x, w });
		ed[i] = { x, y, w };
	}
	for (int i = 0; i < n; i++) {
		c[i].resize(g[i].size());
		for (int j = 0; j < c[i].size(); j++) cin >> c[i][j];
	}
	if (nmb == 0 || nmb == 1) {
		do {
			if (check()) {
				cout << "Yes\n";
				for (auto i : ord) cout << i + 1 << ' ';
				return 0;
			}
		} while (next_permutation(ord.begin(), ord.end()));
		cout << "No";
	}
	if (nmb == 5) {
		sort(ord.begin(), ord.end(), comp);
		if (check()) {
			cout << "Yes\n";
			for (auto i : ord) cout << i + 1 << ' ';
		}
		else cout << "No";
	}
	return 0;
}