#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;

struct st {
	int to, len;
};

struct e {
	int x, y, w;
};

int n, nmb;
vector <vector <st>> g;
vector <e> ed;
vector <vector <int>> c;
vector <int> ord;

bool check() {
	vector <int> kol(n);
	for (int i = 0; i < n; i++) kol[i] = g[i].size() - 1;
	for (auto i : ord) {
		if (c[ed[i].x][kol[ed[i].x]] + c[ed[i].y][kol[ed[i].y]] < ed[i].w) return 0;
		kol[ed[i].x]--, kol[ed[i].y]--;
	}
	return 1;
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	cin >> n >> nmb;
	g.resize(n), c.resize(n), ed.resize(n - 1);
	for (int i = 0; i < n - 1; i++) {
		ord.push_back(i);
		int x, y, w; cin >> x >> y >> w; x--, y--;
		g[x].push_back({ y, w });
		g[y].push_back({ x, w });
		ed[i] = { x, y, w };
	}
	for (int i = 0; i < n; i++) {
		c[i].resize(g[i].size());
		for (int j = 0; j < c[i].size(); j++) cin >> c[i][j];
	}
	if (nmb == 0 || nmb == 1) {
		do {
			if (check()) {
				cout << "Yes\n";
				for (auto i : ord) cout << i + 1 << ' ';
				return 0;
			}
		} while (next_permutation(ord.begin(), ord.end()));
		cout << "No";
	}
	if (nmb == 3) {
		vector <pair <int, int>> ost(n - 1);
		vector <pair <int, int>> c1(n - 1);
		for (int i = 0; i < n - 1; i++) {
			ost[i] = { ed[i].w - c[ed[i].y][0], i };
			c1[i] = { c[0][i], i };
		}
		sort(ost.begin(), ost.end());
		sort(c1.begin(), c1.end());
		vector <int> ord1(n - 1);
		for (int i = 0; i < n - 1; i++) {
			ord1[ost[i].second] = (n - 1 - c1[i].second);
		}
		for (int i = 0; i < n - 1; i++) ord[ord1[i]] = i;
		if (check()) {
			cout << "Yes\n";
			for (auto i : ord) cout << i + 1 << ' ';
		}
		else cout << "No";
	}
	return 0;
}