//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("avx,avx2,sse,sse2,sse3,ssse3")
#include <bits/stdc++.h>

using namespace std;

//#define int int_fast32_t
//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map
//#define mp make_pair

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;
typedef vector<si> vsi;
typedef vector<spi> vspi;
typedef tuple<int, int, int> ti;
typedef vector<ti> vti;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

mt19937 rnd(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());

const int MAXN = 2e5 + 10;

int n, G;

vti g[MAXN];
vpi g2[MAXN];
vi a[MAXN];
spi s[MAXN];
bool flag = true;

void dfs(int v, int p = -1, int pw = 0, int pid = 0) {
	for (auto [u, w, id] : g[v]) {
		if (u == p)
			continue;
		dfs(u, v, w, id);
	}
	if (!flag || p == -1)
		return;
	auto [y, j] = *s[v].begin();
	int x = pw - y;
	auto it = s[p].lower_bound({x, 0});
	if (it == s[p].end()) {
		flag = false;
		return;
	}
	g2[v][j] = {p, pid};
	auto [yp, jp] = *it;
	g2[p][jp] = {v, pid};
	s[p].erase(it);
	s[v].erase(s[v].begin());
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> G;
	for (int i = 0; i < n - 1; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		g[v].push_back({u, w, i + 1});
		g[u].push_back({v, w, i + 1});
	}
	for (int i = 1; i <= n; ++i) {
		g2[i].resize(g[i].size());
		a[i].resize(g[i].size());
		input(a[i]);
		for (int j = 0; j < a[i].size(); ++j)
			s[i].insert({a[i][j], j});
	}
	dfs(1);
	if (!flag) {
		cout << "No\n";
		return 0;
	}
	vi ans;
	queue<ti> q;
	for (int v = 1; v <= n; ++v) {
		if (g2[v].size()) {
			auto [u, id] = g2[v].back();
			if (g2[u].back().first == v) {
				q.push({u, v, id});
				g2[v].pop_back();
				g2[u].pop_back();
			}
		}
	}
	while (q.size()) {
		auto [u, v, id] = q.front();
		q.pop();
		ans.push_back(id);
		if (g2[v].size()) {
			auto [k, id] = g2[v].back();
			if (g2[k].back().first == v) {
				q.push({k, v, id});
				g2[v].pop_back();
				g2[k].pop_back();
			}
		}
		if (g2[u].size()) {
			auto [k, id] = g2[u].back();
			if (g2[k].back().first == u) {
				q.push({k, u, id});
				g2[u].pop_back();
				g2[k].pop_back();
			}
		}
	}
	cout << "Yes\n";
	for (auto i : ans)
		cout << i << ' ';


	return 0;
}