#include <bits/stdc++.h>

#pragma GCC optimize("unroll-loops,O3")
#pragma GCC target("lzcnt,popcnt,avx2,avx,sse4")

using namespace std;

#define all(vc) vc.begin(), vc.end()
#define fi first
#define se second
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void dfs(int v, vector <vector<tuple<int, int, int>>> &vc, vector<set<pii>> &arr,
         vector<tuple<int, int, int>> &ans, int p = -1, int deep = 0)
{
    int need_w = -1;
    int need_i = -1;
    for (auto [u, w, nm]: vc[v])
    {
        if (u == p)
        {
            need_w = w;
            need_i = nm;
            continue;
        }
        dfs(u, vc, arr, ans, v, deep + 1);
    }
    if (need_w != -1)
    {
        auto [vl1, n1] = *arr[v].begin();
        auto it = arr[p].lower_bound({need_w - vl1, -1});
        if (it == arr[p].end())
        {
            cout << "NO";
            exit(0);
        }
        auto [vl2, n2] = *it;
        arr[p].erase(it);
        ans.pb({max(vl1, vl2), vl1 + vl2, need_i});
        // cout << need_i << endl;
    }
}

void solve()
{
    int n, g;
    cin >> n >> g;
    vector <vector<tuple<int, int, int>>> vc(n);
    vector<bool> used(n);
    for (int i = 0; i < n - 1; i++)
    {
        int x, y, w;
        cin >> x >> y >> w;
        x--; y--;
        vc[x].pb({y, w, i});
        vc[y].pb({x, w, i});
    }
    vector<set<pii>> arr(n);
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < vc[i].size(); j++)
        {
            int x;
            cin >> x;
            arr[i].insert({x, j});
        }
    }
    vector<tuple<int, int, int>> ans;
    dfs(0, vc, arr, ans);
    sort(all(ans));
    for (auto [a, b, c]: ans)
    {
        cout << c + 1 << ' ';
    }
}

/**
5 0
1 2 3
1 3 1
3 4 12
3 5 6
0 4
2
6 1 3
8
3
*/

/**
4 0
1 2 7
1 3 6
1 4 5
3
2 1
5
4
3
*/

/**
7 0
1 2 4
2 3 4
3 4 4
4 5 4
5 6 4
6 7 4
2
1 2
2 3
1 2
3 2
1 2
179
*/

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1;
    // cin >> t;

    while (tt--)
    {
        solve();
    }
    return 0;
}
