#include <bits/stdc++.h>

#pragma GCC optimize("unroll-loops,O3")
#pragma GCC target("lzcnt,popcnt,avx2,avx,sse4")

using namespace std;

#define all(vc) vc.begin(), vc.end()
#define fi first
#define se second
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void dfs(int v, vector <vector<tuple<int, int, int>>> &vc, vector<set<pii>> &arr,
         vector<vector<int>> &ans, vector<pair<pii, pii>> &ans2, int p = -1, int deep = 0)
{
    int need_w = -1;
    int need_i = -1;
    for (auto [u, w, nm]: vc[v])
    {
        if (u == p)
        {
            need_w = w;
            need_i = nm;
            continue;
        }
        dfs(u, vc, arr, ans, ans2, v, deep + 1);
    }
    if (need_w != -1)
    {
        auto [vl1, n1] = *arr[v].begin();
        auto it = arr[p].lower_bound({need_w - vl1, -1});
        if (it == arr[p].end())
        {
            cout << "NO";
            exit(0);
        }
        auto [vl2, n2] = *it;
        arr[p].erase(it);
        ans[v][n1] = need_i;
        ans[p][n2] = need_i;
        ans2[need_i] = {{v, n1}, {p, n2}};
        // cout << need_i << endl;
    }
}

void dfs2(int v, vector<vector<int>> &ans, vector<pair<pii, pii>> &ans2, vector<int> &used, vector<int> &an,
          vector <int> &tmp)
{
    if (used[v] == 1)
    {
        cout << "LOL";
        // exit(0);
        cout << v / 0;
    }
    if (used[v]) return;
    used[v] = 1;
    auto [pr1, pr2] = ans2[v];
    auto [u1, n1] = pr1;
    auto [u2, n2] = pr2;
    /*cout << "VVVV\n";
    cout << v << endl;
    cout << u1 << ' ' << n1 << endl;
    cout << u2 << ' ' << n2 << endl;
    cout << "________" << endl;*/
    for (int i = tmp[u1]; i < n1; i++)
    {
        dfs2(ans[u1][i], ans, ans2, used, an, tmp);
    }
    tmp[u1] = max(tmp[u1], n1 - 1);
    for (int i = tmp[u2]; i < n2; i++)
    {
        dfs2(ans[u2][i], ans, ans2, used, an, tmp);
    }
    tmp[u2] = max(tmp[u2], n2 - 1);
    an.pb(v + 1);
    used[v] = 2;
}

void solve()
{
    int n, g;
    cin >> n >> g;
    vector <vector<tuple<int, int, int>>> vc(n);
    vector<int> used(n);
    for (int i = 0; i < n - 1; i++)
    {
        int x, y, w;
        cin >> x >> y >> w;
        x--; y--;
        vc[x].pb({y, w, i});
        vc[y].pb({x, w, i});
    }
    vector<set<pii>> arr(n);
    vector<vector<int>> ans(n);
    for (int i = 0; i < n; i++)
    {
        ans[i].resize(vc[i].size());
        for (int j = 0; j < vc[i].size(); j++)
        {
            int x;
            cin >> x;
            arr[i].insert({x, vc[i].size() - j - 1});
        }
    }
    vector<pair<pii, pii>> ans2(n - 1);
    vector <int> tmp(n);
    vector<int> an;
    dfs(0, vc, arr, ans, ans2);
    // sort(all(ans));
    cout << "YES\n";
    for (int i = 0; i < n - 1; i++)
    {
        if (!used[i])
        {
            dfs2(i, ans, ans2, used, an, tmp);
        }
    }
    for (auto el: an)
    {
        cout << el << ' ';
    }
}

/**
5 0
1 2 3
1 3 1
3 4 12
3 5 6
0 4
2
6 1 3
8
3
*/

/**
4 0
1 2 7
1 3 6
1 4 5
3
2 1
5
4
3
*/

/**
7 0
1 2 4
2 3 4
3 4 4
4 5 4
5 6 4
6 7 4
2
1 2
2 3
1 2
3 2
1 2
179
*/

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tt = 1;
    // cin >> t;

    while (tt--)
    {
        solve();
    }
    return 0;
}
