#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

signed main() {
    ll n, g;
    cin >> n >> g;
    if (g <= 1) {
        vector<pair<Pair, ll>> all;
        vector<ll> deg(n);
        map<Pair, ll> ind;
        for (ll i = 0; i < n - 1; i++) {
            ll u, v, w;
            cin >> u >> v >> w;
            u--, v--;
            deg[u]++, deg[v]++;
            ind[{u, v}] = i;
            all.push_back({{u, v}, w});
        }
        vector<vector<ll>> c(n);
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < deg[i]; j++) {
                ll cur;
                cin >> cur;
                c[i].push_back(cur);
            }
            reverse(c[i].begin(), c[i].end());
        }
        sort(all.begin(), all.end());
        do {
            bool flag = true;
            vector<vector<ll>> cost = c;
            for (pair<Pair, ll> cur : all) {
                auto[u, v] = cur.first;
                ll w = cur.second;
                if (w <= cost[u].back() + cost[v].back()) {
                    cost[u].pop_back(), cost[v].pop_back();
                } else {
                    flag = false;
                    break;
                }
            }
            if (flag) {
                cout << "Yes\n";
                reverse(all.begin(), all.end());
                for (pair<Pair, ll> cur : all) {
                    cout << ind[cur.first] + 1 << " ";
                }
                cout << endl;
                return 0;
            }
        } while (next_permutation(all.begin(), all.end()));
        cout << "No\n";
    }
    if (g == 2) {
        vector<ll> weights;
        for (ll i = 0; i < n - 1; i++) {
            ll u, v, w;
            cin >> u >> v >> w;
            weights.push_back(w);
        }
        vector<vector<ll>> c(n);
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < (i == 0 || i == n - 1 ? 1 : 2); j++) {
                ll cur;
                cin >> cur;
                c[i].push_back(cur);
            }
        }
        vector<vector<vector<bool>>> can(n, vector<vector<bool>> (2, vector<bool> (2, false)));
        can[0][0][0] = true;
        vector<vector<vector<vector<ll>>>> p(n, vector<vector<vector<ll>>> (2, vector<vector<ll>> (2)));
        for (ll i = 0; i < n - 1; i++) {
            for (ll from = 0; from <= (i ? 1 : 0); from++) {
                for (ll to = 0; to <= (i == n - 2 ? 0 : 1); to++) {
                    for (ll up = 0; up <= 1; up++) {
                        if (can[i][from][up] && weights[i] <= c[i][from] + c[i + 1][to]) {
                            can[i + 1][to][up | (from == 0 && to == 0)] = true;
                            p[i + 1][to][up | (from == 0 && to == 0)] = {i, from, up};
                        }
                    }
                }
            }
        }
        if (can[n - 1][0][1]) {
            cout << "Yes\n";
            vector<ll> cur = {n - 1, 0, 1};
            vector<bool> up(n - 1, false);
            vector<ll> need = {0, 0, 0};
            while (cur != need) {
                if (cur[1] == 0 && p[cur[0]][cur[1]][cur[2]][1] == 0) {
                    up[p[cur[0]][cur[1]][cur[2]][0]] = true;
                }
                cur = p[cur[0]][cur[1]][cur[2]];
            }
            vector<ll> ans;
            for (ll i = 0; i < n - 1; i++) {
                if (up[i]) ans.push_back(i + 1);
            }
            for (ll i = 0; i < n - 1; i++) {
                if (!up[i]) ans.push_back(i + 1);
            }
            for (ll index : ans) cout << index << " ";
            cout << endl;
        } else {
            cout << "No\n";
        }
    }
    return 0;
}
