#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
    ll n, gr;
    cin >> n >> gr;
    vector<vector<Pair>> g(n);
    vector<pair<Pair, ll>> all;
    vector<ll> deg(n, 0LL);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        if (u > v) swap(u, v);
        deg[u]++, deg[v]++;
        g[u].push_back({v, i});
        g[v].push_back({u, i});
        all.push_back({{u, v}, w});
    }
    vector<vector<ll>> c(n);
    for (ll v = 0; v < n; v++) {
        for (ll step = 0; step < deg[v]; step++) {
            ll cur;
            cin >> cur;
            c[v].push_back(cur);
        }
        reverse(c[v].begin(), c[v].end());
    }
    vector<ll> ans;
    set<pair<Pair, ll>> cur;
    for (ll i = 0; i < n - 1; i++) {
        cur.insert({{c[all[i].first.first].back() + c[all[i].first.second].back() - all[i].second, -all[i].second}, i});
    }
    vector<bool> used(n - 1, false);
    auto del = [&] (ll from) {
        for (auto[to, ind] : g[from]) {
            if (!used[ind]) {
                cur.erase({{c[from].back() + c[to].back() - all[ind].second, -all[ind].second}, ind});
            }
        }
    };
    auto add = [&] (ll from) {
        for (auto[to, ind] : g[from]) {
            if (!used[ind]) {
                cur.insert({{c[from].back() + c[to].back() - all[ind].second, -all[ind].second}, ind});
            }
        }
    };
    for (ll step = 0; step < n - 1; step++) {
        auto it = cur.lower_bound({{0, -INF}, -INF});
        if (it != cur.end()) {
            auto[val, ind] = *it;
            cur.erase(it);
            used[ind] = true;
            ans.push_back(ind + 1);
            del(all[ind].first.first);
            del(all[ind].first.second);
            c[all[ind].first.first].pop_back(), c[all[ind].first.second].pop_back();
            if (!c[all[ind].first.first].empty()) add(all[ind].first.first);
            if (!c[all[ind].first.second].empty()) add(all[ind].first.second);
        } else {
            cout << "No\n";
            return 0;
        }
//        for (auto now : cur) {
//            cout << now.first.first << " " << now.first.second << " " << now.second << endl;
//        }
    }
    cout << "Yes\n";
    reverse(ans.begin(), ans.end());
    for (ll index : ans) cout << index << " ";
    cout << endl;
    return 0;
}
