#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<int> ans;
vector<bool> used;
vector<int> indeg;

void dfs(int v = 0) {
    used[v] = true;
    for (int child : g[v]) {
        if (!used[child]) {
            dfs(child);
        }
    }
    ans.push_back(v);
}

signed main() {
    int n, gr;
    cin >> n >> gr;
    assert(gr == 2);
    vector<int> w(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int a, b, we;
        cin >> a >> b >> we;
        w[i] = we;
    }
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; ++i) {
        int a, b = INT_MIN;
        cin >> a;
        if (i != 0 && i != n - 1) {
            cin >> b;
        }
        v[i].first = a;
        v[i].second = b;
    }

    g.resize(n - 1);
    for (int i = 0; i < n - 2; ++i) {
        bool top = v[i].first + v[i + 1].first >= w[i] || v[i].second + v[i + 1].first >= w[i];
        bool bottom = v[i].first + v[i + 1].second >= w[i] || v[i].second + v[i + 1].second >= w[i];
        if (!top && !bottom) {
            cout << "No" << endl;
            return 0;
        }
        if (top && !bottom) {
            g[i].push_back(i + 1);
            ++indeg[i + 1];
        }
    }

    indeg.resize(n - 1);
    for (int i = 1; i < n - 1; ++i) {
        bool top = v[i].first + v[i - 1].first >= w[i] || v[i].second + v[i - 1].first >= w[i];
        bool bottom = v[i].first + v[i - 1].second >= w[i] || v[i].second + v[i - 1].second >= w[i];
        if (!top && !bottom) {
            cout << "No" << endl;
            return 0;
        }
        if (top && !bottom) {
            g[i].push_back(i - 1);
            ++indeg[i - 1];
        }
    }

    used.resize(n - 1);

    for (int i = 0; i < n - 1; ++i) {
        if (indeg[i] == 0) {
            dfs(i);
        }
    }
    reverse(ans.begin(), ans.end());
    for (int val : ans) {
        cout << val + 1 << ' ';
    }
    cout << endl;
}
