#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define st string
#define pb push_back
#define vec vector
#define all(a) a.begin(), a.end()
#define ff first
#define ss second
#define ll long long
#define ld long double

#define int long long

using namespace std;
using vl = vec<int>;
using vi = vec<int>;
using vvi = vec<vi>;
using pi = pair<int, int>;
using vpi = vec<pi>;
using vvvi = vec<vvi>;
using vvpi = vec<vec<pi>>;
using vvvpi = vec<vvpi>;
using vvvvi = vec<vvvi>;
using vppi = vec<pair<pair<int, int>, pair<int, int>>>;

using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 1e9 + 2;
const int M = 1e9 + 7;

vvpi g;
vvi g2;
vi ans;
vi used;

void dfs(int v) {
//    cout << v + 1 << endl;
    used[v] = 1;
    for (auto u : g2[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    ans.pb(v);
}

void solve() {
    int n, tt; cin >> n >> tt;
    g.resize(n);
    vvi gs;
    vpi cost(n - 1);
    for (int i = 0; i < n - 1; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        int c; cin >> c;
        cost[i] = {c, i};
        gs.pb({u, v, c});
        g[u].pb({v, c});
        g[v].pb({u, c});
    }
    vvi cs(n);
    for (int i = 0; i < n; i++) {
        int nn = g[i].size();
        for (int j = 0; j < nn; j++) {
            int nw; cin >> nw;
            cs[i].pb(nw);
        }
    }
    for (int i = 1; i < n; i++) {
        cost[i - 1].ff -= cs[i][0];
    }
    if (tt == 2) {
        // 1 -> 0, 0 -> 1
        vpi dp(n, {0, 0});
        dp[0] = {0, 1};
        vpi p(n, {-1, -1});
        for (int i = 1; i < n; i++) {
            pi now = dp[i - 1];
            pi nw = {0, 0};
            if (now.ss) {
                if (g[i][0].ss <= cs[i - 1][0] + cs[i][0]) {
                    nw.ff = 1;
                    p[i].ff = 0;
                }
                if (i != n - 1 && g[i][0].ss <= cs[i - 1][0] + cs[i][1]) {
                    nw.ss = 1;
                    p[i].ss = 0;
                }
            }
            if (now.ff) {
                if (g[i][0].ss <= cs[i - 1][1] + cs[i][0]) {
                    nw.ff = 1;
                    p[i].ff = 1;
                }
                if (i != n - 1 && g[i][0].ss <= cs[i - 1][1] + cs[i][1]) {
                    nw.ss = 1;
                    p[i].ss = 1;
                }
            }
            dp[i] = nw;
//            cout << i + 1 << " " << dp[i].ff << " " << dp[i].ss << " " << p[i].ff << " " << p[i].ss << endl;
        }
        if (!dp[n - 1].ff) {
            cout << "No" << endl;
            return;
        }
        g2.resize(n - 1);
        int now = 0;
        for (int i = n - 2; i >= 1; i--) {
            if (!now) {
                now = p[i + 1].ff;
            }
            else {
                now = p[i + 1].ss;
            }
//            cout << i + 1 << " " << now << endl;
            now ^= 1;
            if (now == 1) {
                g2[i].pb(i - 1);
            }
            else {
//                cout << i - 1 << " " << i << endl;
                g2[i - 1].pb(i);
            }
        }
        used.assign(n, 0);
        for (int i = 0; i < n - 1; i++) {
            if (!used[i]) {
                dfs(i);
            }
        }
        cout << "Yes" << endl;
        for (auto u : ans) {
            cout << u + 1 << " ";
        }
        cout << endl;
        return;
    }
    if (tt == 1 || tt == 0) {
        vi a(n - 1);
        for (int i = 0; i < n - 1; i++) a[i] = i;
        do {
            vvi cnow(n);
            for (int i = 0; i < n; i++) {
                for (auto u : cs[i]) {
                    cnow[i].pb(u);
                }
            }
            int okk = 1;
            for (int i = 0; i < n - 1; i++) {
                vi nw = gs[a[i]];
                int c1 = cnow[nw[0]][cnow[nw[0]].size() - 1];
                int c2 = cnow[nw[1]][cnow[nw[1]].size() - 1];
                if (nw[2] > c1 + c2) {
                    okk = 0;
                    break;
                }
                cnow[nw[0]].pop_back();
                cnow[nw[1]].pop_back();
            }
            if (okk) {
                cout << "Yes" << endl;
                for (auto u : a) {
                    cout << u + 1 << " ";
                }
                cout << endl;
                return;
            }
        } while(next_permutation(all(a)));
        cout << "No" << endl;
        return;
    }
    sort(all(cost));
    vpi gg;
    for (int i = 0; i < cs[0].size(); i++) {
        gg.pb({cs[0][i], n - i - 1});
    }
    sort(all(gg));
    vi anss(n - 1);
    int oke = 1;
    for (int i = 0; i < n - 1; i++) {
        if (cost[i].ff > gg[i].ff) {
            oke = 0;
            break;
        }
        anss[gg[i].ss] = cost[i].ss;
    }
    if (!oke) {
        cout << "No" << endl;
        return;
    }
    cout << "Yes" << endl;
    for (auto u : anss) {
        cout << u + 1 << " ";
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    solve();
}