#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve(){
    int n, G;
    cin >> n >> G;
    vector<pair<int, pair<int, int>>> edg;
    vector<int> deg(n, 0);
    for (int i = 1; i < n; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        a-- ;b--;
        edg.push_back({w, {a, b}});
        deg[a]++;
        deg[b]++;
    }
    vector<vector<int>> c(n);
    for (int i = 0; i < n; ++i) {
        c[i].resize(deg[i]);
        for (int j = 0; j < deg[i]; ++j) {
            cin >> c[i][j];
        }
    }

    vector<int> p(n-1);
    std::iota(p.begin(), p.end(), 0);
    do{
        for (int i = 0; i < n; ++i) {
            deg[i] = 0;
        }
        bool check = 1;
        for(auto i : p){
            int a = edg[i].second.first, b = edg[i].second.second, w = edg[i].first;
            if(c[a][deg[a]] + c[b][deg[b]] < w) {
                check = 0;
                break;
            }
            deg[a]++, deg[b]++;
        }
        if(check){
            cout << "Yes\n";
            for(auto i : p){
                cout << i+1 << ' ';
            }
            return;
        }
    }while(next_permutation(p.begin(), p.end()));
    cout << "No";
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while(_--){
        solve();
    }
    return 0;
}
/*


 */