#include <bits/stdc++.h>

#include <random>

using namespace std;
#define int long long

const int N = 2 * (int) 1e5;

vector<set<pair<int, int>>> g(N);
int a[N], b[N], w[N];

vector<int> c[N], to[N];
vector<set<pair<int, int>>> gr;
vector<int> ans;

void dfs(int v) {
    if (to[v].empty())
        return;
    int ind = to[v].back(), u = a[ind] + b[ind] - v;
    if (to[u].back() == ind) {
        to[u].pop_back();
        to[v].pop_back();
        ans.emplace_back(ind + 1);
        dfs(u);
        dfs(v);
        return;
    }
    dfs(u);
}

//void dfs(int v) {
//    int u = -1, ind;
//    for (int i = (int) gr[v].size() - 1; i >= 0; i--) {
//        if (to[v][i] != -1) {
//            u = a[to[v][i]] + b[to[v][i]] - v;
//            ind = to[v][i];
//            break;
//        }
//    }
//    if (u == -1) return;
//    bool f = false;
//    for (int i = (int) gr[u].size() - 1; i >= 0; i--) {
//        if (to[u][i] != -1) {
//            if (v != a[to[u][i]] + b[to[u][i]] - u)
//                f = true;
//            break;
//        }
//    }
//    if (!f) {
//        for (int i = (int) gr[v].size() - 1; i >= 0; i--) {
//            if (to[v][i] != -1) {
//                to[v][i] = -1;
//                break;
//            }
//        }
//        for (int i = (int) gr[u].size() - 1; i >= 0; i--) {
//            if (to[u][i] != -1) {
//                to[u][i] = -1;
//                break;
//            }
//        }
//        ans.emplace_back(ind + 1);
//        return;
//    }
//    dfs(u);
//}



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, G;
    cin >> n >> G;
    for (int i = 0; i < n - 1; i++) {
        cin >> a[i] >> b[i] >> w[i];
        a[i]--, b[i]--;
        g[a[i]].insert({b[i], i});
        g[b[i]].insert({a[i], i});
    }
    gr = g;
    for (int i = 0; i < n; i++) {
        c[i].resize((int) g[i].size());
        to[i].resize((int) g[i].size());
        for (int j = 0; j < (int) g[i].size(); j++)
            cin >> c[i][j], to[i][j] = -1;
    }
    set<pair<int, int>> st;
    for (int i = 0; i < n; i++)
        st.insert({(int) g[i].size(), i});
    while (!st.empty()) {
        int v = st.begin()->second, u = g[v].begin()->first, ind = g[v].begin()->second;
        st.erase(st.begin());
        if ((int) g[v].size() == 0)
            continue;
        st.erase({(int) g[u].size(), u});
        st.insert({(int) g[u].size() - 1, u});
        g[v].erase({u, ind}), g[u].erase({v, ind});
        int index = -1;
        for (int i = 0; i < (int) gr[v].size(); i++) {
            if (to[v][i] == -1) {
                index = i;
                break;
            }
        }
        int least = w[ind] - c[v][index], ii = -1;
        for (int i = 0; i < (int) gr[u].size(); i++) {
            if (to[u][i] == -1 && c[u][i] >= least && (ii == -1 || c[u][ii] > c[u][i]))
                ii = i;
        }
        if (ii == -1) {
            cout << "No";
            return 0;
        }
        to[v][index] = ind, to[u][ii] = ind;
    }
    cout << "Yes\n";
    dfs(0);
    for (int x: ans)
        cout << x << " ";
    return 0;
}