#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
#define pii pair <int, int>
#define x first
#define y second
#define mp make_pair
using namespace std;

const int maxn = 2e5 + 5, inf = 1e18, mod = 1e9 + 7;

vector < vector <pii> > g(maxn);

vector <vector <int> > st(maxn);

void solve1(int n) {
    st.resize(n + 1);
    g.resize(n + 1);
    map <pii, int> edge;
    vector < vector <int> > num(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        edge[{min(a, b), max(a, b)}] = c;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
        num[i + 1] = {a, b, c};
    }
    for (int i = 1; i < n + 1; i++) {
        for (int j = 0; j < sz(g[i]); j++) {
            int x;
            cin >> x;
            st[i].emplace_back(x);
        }
//        reverse(all(st[i]));
    }
    vector <int> prm(n - 1);
    iota(all(prm), 1ll);
    do {
        vector <vector <int> > st1 = st;
        int f = 1;
        for (int i = 0; i < n - 1; i++) {
            auto a = num[prm[i]][0], b = num[prm[i]][1], c = num[prm[i]][2];
            if (st1[a].back() + st1[b].back() >= c) {
                st1[a].pop_back();
                st1[b].pop_back();
            } else {
                f = 0;
            }
        }
        if (f) {
            cout << "Yes\n";
            for (auto & e : prm) {
                cout << e << " ";
            }
            return;
        }
    } while(next_permutation(all(prm)));
    cout << "No";
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, gg;
//    cout << 1ll * 2 * 3 * 4 * 5 * 6 * 7 * 8 * 9 * 10 << endl;


    cin >> n >> gg;
    if (gg == 1) {
        solve1(n);
        return 0;
    } else if (gg == 6) {
        map <pii, int> edge;
        int f = 1;
        vector < vector <int> > num(n);
        for (int i = 0; i < n - 1; i++) {
            int a, b, c;
            cin >> a >> b >> c;
            edge[{min(a, b), max(a, b)}] = c;
            g[a].emplace_back(b, c);
            g[b].emplace_back(a, c);
            if (c) {
                f = 0;
            }
            num[i + 1] = {a, b, c};
        }
        for (int i = 1; i < n + 1; i++) {
            for (int j = 0; j < sz(g[i]); j++) {
                int x;
                cin >> x;
                assert(x == 0);
                st[i].emplace_back(x);
            }
//        reverse(all(st[i]));
        }
        if (f) {
            cout << "Yes\n";
            for (int i = 1; i < n; i++) {
                cout << i << " ";
            }
        } else {
            cout << "No\n";
        }

        return 0;
    } else if (gg != 0){
        return 0;
    }
    map <pii, int> edge;
    vector < vector <int> > num(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        edge[{min(a, b), max(a, b)}] = c;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
        num[i + 1] = {a, b, c};
    }
    for (int i = 1; i < n + 1; i++) {
        for (int j = 0; j < sz(g[i]); j++) {
            int x;
            cin >> x;
            st[i].emplace_back(x);
        }
//        reverse(all(st[i]));
    }
    vector <int> prm(n - 1);
    iota(all(prm), 1ll);
    do {
        vector <vector <int> > st1 = st;
        int f = 1;
        for (int i = 0; i < n - 1; i++) {
            auto a = num[prm[i]][0], b = num[prm[i]][1], c = num[prm[i]][2];
            if (st1[a].back() + st1[b].back() >= c) {
                st1[a].pop_back();
                st1[b].pop_back();
            } else {
                f = 0;
            }
        }
        if (f) {
            cout << "Yes\n";
            for (auto & e : prm) {
                cout << e << " ";
            }
            return 0;
        }
    } while(next_permutation(all(prm)));
    cout << "No";
}
