#include <bits/stdc++.h>

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
#define pii pair <int, int>
#define x first
#define y second
#define mp make_pair
using namespace std;

const int maxn = 2e5 + 5, inf = 1e18, mod = 1e9 + 7;

vector < vector <pii> > g(maxn);

vector <vector <int> > st(maxn);

void solve1(int n) {
    st.resize(n + 1);
    g.resize(n + 1);
    map <pii, int> edge;
    vector < vector <int> > num(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        edge[{min(a, b), max(a, b)}] = c;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
        num[i + 1] = {a, b, c};
    }
    for (int i = 1; i < n + 1; i++) {
        for (int j = 0; j < sz(g[i]); j++) {
            int x;
            cin >> x;
            st[i].emplace_back(x);
        }
//        reverse(all(st[i]));
    }
    vector <int> prm(n - 1);
    iota(all(prm), 1ll);
    do {
        vector <vector <int> > st1 = st;
        int f = 1;
        for (int i = 0; i < n - 1; i++) {
            auto a = num[prm[i]][0], b = num[prm[i]][1], c = num[prm[i]][2];
            if (st1[a].back() + st1[b].back() >= c) {
                st1[a].pop_back();
                st1[b].pop_back();
            } else {
                f = 0;
            }
        }
        if (f) {
            cout << "Yes\n";
            for (auto & e : prm) {
                cout << e << " ";
            }
            return;
        }
    } while(next_permutation(all(prm)));
    cout << "No";
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, gg;
//    cout << 1ll * 2 * 3 * 4 * 5 * 6 * 7 * 8 * 9 * 10 << endl;


    cin >> n >> gg;
    if (gg == 1) {
        solve1(n);
        return 0;
    } else if (gg == 3) {
        map <pii, int> edge;
        map <pii, int> rev;
        int f = 1;
        vector < vector <int> > num(n);
        for (int i = 0; i < n - 1; i++) {
            int a, b, c;
            cin >> a >> b >> c;
            edge[{min(a, b), max(a, b)}] = c;
            rev[{min(a, b), max(a, b)}] = i + 1;
            g[a].emplace_back(b, c);
            g[b].emplace_back(a, c);

            num[i + 1] = {a, b, c};
        }
        for (int i = 1; i < n + 1; i++) {
            for (int j = 0; j < sz(g[i]); j++) {
                int x;
                cin >> x;
//                assert(x == 0);
                st[i].emplace_back(x);
            }
//        reverse(all(st[i]));
        }
        multiset <pii> ss;
        for (int i = 2; i < n + 1; i++) {
            int x = edge[{1, i}] - st[i][0];
            ss.insert({-x, rev[{1, i}]});
//            cout << x << endl;
        }
        vector <int> ans;
//        cout << sz(ss) << endl;
        while (!st[1].empty()) {
//            cout << " " << -st[1].back() << endl;
            auto p = ss.lower_bound({-st[1].back(), 0});
            if (p == ss.end()) {
                f = 0;
                break;
            } else {
                ans.emplace_back((*p).y);
                ss.erase(p);
                st[1].pop_back();
            }
        }

        if (f) {
            cout << "Yes\n";
            for (auto & e : ans) {
                cout << e << " ";
            }
        } else {
            cout << "No\n";
        }

        return 0;
    } else if (gg == 2) {
        map <pii, int> edge;
        map <pii, int> rev;
        int f = 1;
        vector < vector <int> > num(n);
        for (int i = 0; i < n - 1; i++) {
            int a, b, c;
            cin >> a >> b >> c;
            edge[{min(a, b), max(a, b)}] = c;
            rev[{min(a, b), max(a, b)}] = i + 1;
            g[a].emplace_back(b, c);
            g[b].emplace_back(a, c);

            num[i + 1] = {a, b, c};
        }
        for (int i = 1; i < n + 1; i++) {
            for (int j = 0; j < sz(g[i]); j++) {
                int x;
                cin >> x;
//                assert(x == 0);
                st[i].emplace_back(x);
            }
//        reverse(all(st[i]));
        }
        vector <int> ans;
        vector <int> stack;
        vector <vector <int> > can_use(n + 1, vector <int> (2, 1));
//        can_use[1] = 1;
        for (int i = 1; i < n; i++) {



            int w = num[i][2];



            if (i + 1 == n) {
                if (i == 1 || sz(st[i]) == 1) {
                    if (st[i].back() + st[i + 1].back() >= w) {
                        ans.emplace_back(i);
                        break;
                    } else {
                        f = 0;
                        break;
                    }
                }
                if (st[i][0] >= st[i][1]) {
                    if (st[i][1] + st[i + 1].back() >= w) {
                        ans.emplace_back(i);
                        st[i].pop_back();
                    } else if (!can_use[i][0] || st[i][0] + st[i + 1].back() < w) {
                        f = 0;
                        break;
                    } else {
                        while(!stack.empty()) {
                            ans.emplace_back(stack.back());
                        }
                        ans.emplace_back(i);
                    }
                } else {
                    if (can_use[i][1]) {
                        if (st[i][1] + st[i + 1].back() >= w) {
                            ans.emplace_back(i);
                            st[i].pop_back();
                            while(!stack.empty()) {
                                ans.emplace_back(stack.back());
                            }
                        } else {
                            f = 0;
                            break;
                        }
                    }
                }
                break;
            }
            if (i == 1) {
                if (st[i + 1][0] >= st[i + 1][1]) {
                    if (st[i + 1][1] + st[i][0] >= w) {
                        st[i + 1].pop_back();
                        can_use[i + 1][1] = 0;
                        ans.emplace_back(i);
                    } else if (st[i + 1][0] + st[i][0] >= w) {
                        stack.emplace_back(i);
                        can_use[i + 1][0] = 0;
                    } else {
                        f = 0;
                        break;
                    }
                } else {
                    if (st[i + 1][0] + st[i][0] >= w) {
                        can_use[i + 1][0] = 0;
                        stack.emplace_back(i);
                    } else if (st[i + 1][1] + st[i][0] >= w) {
                        ans.emplace_back(i);
                        can_use[i + 1][1] = 0;
                        st[i + 1].pop_back();
                    } else {
                        f = 0;
                        break;
                    }
                }
                continue;
            }
            if (can_use[i][1]) {
                if (st[i + 1][0] >= st[i + 1][1]) {
                    if (st[i][1] + st[i + 1][1] >= w) {
                        ans.emplace_back(i);
                        st[i + 1].pop_back();
                        can_use[i + 1][1] = 0;

                    } else if (st[i + 1][0] + st[i][1] >= w) {
                        stack.emplace_back(i);
                        can_use[i + 1][0] = 0;
                    } else {
                        f = 0;
                        break;
                    }
                } else {
                    if (st[i][1] + st[i + 1][0] >= w) {
                        stack.emplace_back(i);
                        can_use[i + 1][0] = 0;
                    } else if (st[i][1] + st[i + 1][1] >= w) {
                        ans.emplace_back(i);
                        st[i + 1].pop_back();
                        can_use[i + 1][1] = 0;
                    } else {
                        f = 0;
                        break;
                    }
                }
            } else {
                if (st[i + 1][0] >= st[i + 1][1]) {
                    if (st[i][0] + st[i + 1][1] >= w) {
                        ans.emplace_back(i);
                        st[i + 1].pop_back();
                        can_use[i + 1][1] = 0;

                    } else if (st[i + 1][0] + st[i][1] >= w) {
                        stack.emplace_back(i);
                        can_use[i + 1][0] = 0;
                    } else {
                        f = 0;
                        break;
                    }
                } else {
                    if (st[i][0] + st[i + 1][0] >= w) {
                        stack.emplace_back(i);
                        can_use[i + 1][0] = 0;
                    } else if (st[i][0] + st[i + 1][1] >= w) {
                        ans.emplace_back(i);
                        st[i + 1].pop_back();
                        can_use[i + 1][1] = 0;
                    } else {
                        f = 0;
                        break;
                    }
                }
            }

        }
        while (!stack.empty()) {
            ans.emplace_back(stack.back());
            stack.pop_back();
        }
        reverse(all(ans));
        if (f) {
            cout << "Yes\n";
            for (auto & e : ans) {
                cout << e << " ";
            }
        } else {
            cout << "N0";
        }
        return 0;
    }
    else if (gg != 0){
        return 0;
    }
    map <pii, int> edge;
    vector < vector <int> > num(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        edge[{min(a, b), max(a, b)}] = c;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
        num[i + 1] = {a, b, c};
    }
    for (int i = 1; i < n + 1; i++) {
        for (int j = 0; j < sz(g[i]); j++) {
            int x;
            cin >> x;
            st[i].emplace_back(x);
        }
//        reverse(all(st[i]));
    }
    vector <int> prm(n - 1);
    iota(all(prm), 1ll);
    do {
        vector <vector <int> > st1 = st;
        int f = 1;
        for (int i = 0; i < n - 1; i++) {
            auto a = num[prm[i]][0], b = num[prm[i]][1], c = num[prm[i]][2];
            if (st1[a].back() + st1[b].back() >= c) {
                st1[a].pop_back();
                st1[b].pop_back();
            } else {
                f = 0;
            }
        }
        if (f) {
            cout << "Yes\n";
            for (auto & e : prm) {
                cout << e << " ";
            }
            return 0;
        }
    } while(next_permutation(all(prm)));
    cout << "No";
}
