#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<stack>
#include<algorithm>
#include<deque>
#include<queue>
#include<iomanip>
#include<random>
using namespace std;
#define int long long
struct edge {
	int u, v, w;
};
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, g;
	cin >> n >> g;
	vector <edge> a(n - 1);
	vector <int> deg(n);
	for (int i = 0; i < n - 1; i++) {
		cin >> a[i].u >> a[i].v >> a[i].w;
		a[i].u--;
		a[i].v--;
		deg[a[i].u]++;
		deg[a[i].v]++;
	}
	vector <vector <int> > res(n);
	for (int i = 0; i < n; i++) {
		res[i].resize(deg[i]);
		for (int j = 0; j < deg[i]; j++) {
			cin >> res[i][j];
		}
		reverse(res[i].begin(), res[i].end());
	}
	vector <int> p(n - 1);
	for (int i = 0; i < n - 1; i++) {
		p[i] = i;
	}
	while (1) {
		vector <int> id(n, 0);
		bool check = true;
		for (auto i : p) {
			int x = a[i].u;
			int y = a[i].v;
			if (a[i].w > res[x][id[x]] + res[y][id[y]]) {
				check = false;
			}
			id[x]++;
			id[y]++;
		}
		if (check) {
			cout << "YES\n";
			for (int i = 0; i < n - 1; i++) {
				cout << p[i] + 1 << " ";
			}
			return 0;
		}
		if (!next_permutation(p.begin(), p.end())) break;
	}
	cout << "NO\n";
	return 0;
}