#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<stack>
#include<algorithm>
#include<deque>
#include<queue>
#include<iomanip>
#include<random>
using namespace std;
#define int long long
struct edge {
	int u, v, w;
};
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, g;
	cin >> n >> g;
	if (g <= 1) {
		vector <edge> a(n - 1);
		vector <int> deg(n);
		for (int i = 0; i < n - 1; i++) {
			cin >> a[i].u >> a[i].v >> a[i].w;
			a[i].u--;
			a[i].v--;
			deg[a[i].u]++;
			deg[a[i].v]++;
		}
		vector <vector <int> > res(n);
		for (int i = 0; i < n; i++) {
			res[i].resize(deg[i]);
			for (int j = 0; j < deg[i]; j++) {
				cin >> res[i][j];
			}
			reverse(res[i].begin(), res[i].end());
		}
		vector <int> p(n - 1);
		for (int i = 0; i < n - 1; i++) {
			p[i] = i;
		}
		while (1) {
			vector <int> id(n, 0);
			bool check = true;
			for (auto i : p) {
				int x = a[i].u;
				int y = a[i].v;
				if (a[i].w > res[x][id[x]] + res[y][id[y]]) {
					check = false;
				}
				id[x]++;
				id[y]++;
			}
			if (check) {
				cout << "YES\n";
				for (int i = 0; i < n - 1; i++) {
					cout << p[i] + 1 << " ";
				}
				return 0;
			}
			if (!next_permutation(p.begin(), p.end())) break;
		}
		cout << "NO\n";
		return 0;
	}
	if (g == 2) {
		vector <int> a(n - 1);
		int u, v;
		for (int i = 0; i < n - 1; i++) {
			cin >> u >> v >> a[i];
		}
		vector <vector <bool> > can(n, vector <bool>(2, false));
		vector <vector <int> > c(n, vector <int> (2));
		cin >> c[0][0];
		for (int i = 1; i < n - 1; i++) {
			cin >> c[i][0] >> c[i][1];
		}
		cin >> c[n - 1][0];
		if (c[n - 1][0] + c[n - 2][1] >= a[n - 2]) {
			can[n - 2][1] = true;
		}
		if (c[n - 1][0] + c[n - 2][0] >= a[n - 2]) {
			can[n - 2][0] = true;
		}
		for (int i = n - 3; i >= 1; i--) {
			if (can[i + 1][1] && c[i][0] + c[i + 1][0] >= a[i]) can[i][0] = true;
			if (can[i + 1][0] && c[i][0] + c[i + 1][1] >= a[i]) can[i][0] = true;
			if (can[i + 1][0] && c[i][1] + c[i + 1][1] >= a[i]) can[i][1] = true;
			if (can[i + 1][1] && c[i][1] + c[i + 1][0] >= a[i]) can[i][1] = true;
		}
		if (can[1][0] && c[1][1] + c[0][0] >= a[0]) can[0][0] = true;
		if (can[1][1] && c[1][0] + c[0][0] >= a[0]) can[0][0] = true;
		if (can[0][0]) {
			cout << "YES\n";
			vector <pair <int, int> > ans;
			int cur = 0;
			for (int i = 1; i < n - 1; i++) {
				if (can[i][1] && c[i][0] + c[i - 1][cur] >= a[i - 1]) {
					ans.push_back({ cur, 0 });
					cur = 1;
				}
				else {
					ans.push_back({ cur, 1 });
					cur = 0;
				}
			}
			ans.push_back({ cur, 0 });
			vector <int> otv;
			for (int i = 0; i < ans.size(); i++) {
				if (ans[i].first == 1 && ans[i].second == 1) otv.push_back(i);
			}
			
			for (int i = 0; i < ans.size(); i++) {
				if (ans[i].first == 0 && ans[i].second == 1) otv.push_back(i);
			}
			for (int i = ans.size() - 1; i >= 0; i--) {
				if (ans[i].first == 1 && ans[i].second == 0) otv.push_back(i);
			}
			for (int i = 0; i < ans.size(); i++) {
				if (ans[i].first == ans[i].second && ans[i].first == 0) otv.push_back(i);
			}
			for (int i = 0; i < n - 1; i++) {
				cout << otv[i] + 1 << " ";
			}
		}
		else {
			cout << "NO\n";
		}
	}
	else if (g == 3) {
		vector <int> a(n - 1);
		int u, v;
		for (int i = 0; i < n - 1; i++) {
			cin >> u >> v >> a[i];
		}
		vector <pair <int, int> > c1(n - 1);
		vector <int> c(n - 1);
		for (int i = 0; i < n - 1; i++) {
			cin >> c1[i].first;
			c1[i].second = (n - 2 - i);
			c[i] = c1[i].first;
		}
		vector <int> b(n - 1);
		for (int i = 0; i < n - 1; i++) {
			cin >> b[i];
		}
		sort(c1.begin(), c1.end());
		sort(c.begin(), c.end());
		vector <vector <int> > id(n - 1);
		bool check = true;
		for (int i = 0; i < n - 1; i++) {
			int d = lower_bound(c.begin(), c.end(), a[i] - b[i]) - c.begin();
			if (c[n - 2] + b[i] < a[i]) {
				check = false;
				break;
			}
			id[d].push_back(i);
		}
		if (!check) {
			cout << "NO\n";
			return 0;
		}
		vector <int> ans(n - 1);
		stack <int> s;
		for (int i = n - 2; i >= 0; i--) {
			s.push(c1[i].second);
			for (int j = 0; j < id[i].size(); j++) {
				if (s.empty()) {
					check = false;
					break;
				}
				ans[s.top()] = id[i][j];
				s.pop();
			}
		}
		if (!check) {
			cout << "NO\n";
		}
		else {
			cout << "YES\n";
			for (int i = 0; i < n - 1; i++) {
				cout << ans[i] + 1 << " ";
			}
		}
	}
	return 0;
}