#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e6+2;

ll n;

namespace brute
{
    tuple<ll,ll,ll> ed[N];
    ve<ll> v[N];
    ll deg[N],tp[N];

    void solve()
    {
        for(ll i=0;i<n-1;i++)
        {
            ll a,b,w;
            cin>>a>>b>>w;
            a--, b--;
            ed[i]={a,b,w};
            deg[a]++;
            deg[b]++;
        }

        for(ll i=0;i<n;i++)
        {
            for(ll j=0;j<deg[i];j++)
            {
                ll x;
                cin>>x;
                v[i].PB(x);
            }

            reverse(all(v[i]));
        }

        ll tl=1.9*CLOCKS_PER_SEC;
        ve<ll> p(n-1);
        iota(all(p),0);

        while(clock()<tl)
        {
            shuffle(all(p),gen);
            fill(tp,tp+n,0);
            bool ok=1;

            for(ll i:p)
            {
                ll a,b,w;
                tie(a,b,w)=ed[i];

                if(w>v[a][tp[a]]+v[b][tp[b]])
                {
                    ok=0;
                    break;
                }

                tp[a]++;
                tp[b]++;
            }

            if(ok)
            {
                cout<<"Yes"<<endl;

                for(ll i:p)
                    cout<<i+1<<' ';

                return;
            }
        }

        cout<<"No";
    }
}

void solve()
{
    ll g;
    cin>>n>>g;
    brute::solve();
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
