#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
vector<vector<vector<int>>>adj(200000);
vector<vector<int>>vals(200000);
vector<vector<int>>perm(200000);
bool ok=true;
vector<int>ans;
int calc_dfs(int x,int p)
{
    set<pair<int,int>>st;
    for(auto &y:adj[x])if(y[0]!=p)
    {
        int val=calc_dfs(y[0],x);
        st.insert({val-y[1],y[2]});
    }
    perm[x].resize(vals[x].size());
    vector<pair<int,int>>tmp;
    for(int i=0;i<vals[x].size();i++)tmp.push_back({vals[x][i],i});
    sort(tmp.begin(),tmp.end());
    int val=-1e9;
    for(auto &s:tmp)
    {
        auto y=st.lower_bound({-s.first,0});
        if(y==st.end())
        {
            if(val!=-1e9||!x)ok=false;
            val=s.first;
            perm[x][s.second]=-1;
        }
        else
        {
            perm[x][s.second]=y->second;
            st.erase(y);
        }
    }
    return val;
}
void dfs_ans(int x,int p,int run)
{
    if(run==0)
    {
        for(auto &y:adj[x])if(y[0]!=p)dfs_ans(y[0],x,0);
        for(int i=0;i<perm[x].size()&&perm[x][i]!=-1;i++)ans.push_back(perm[x][i]);
        if(x)return;
        for(auto &y:adj[x])if(y[0]!=p)dfs_ans(y[0],x,1);
    }
    if(run==1)
    {
        int i;
        for(i=0;perm[x][i]!=-1;i++);
        i++;
        for(;i<perm[x].size();i++)ans.push_back(perm[x][i]);
        for(auto &y:adj[x])if(y[0]!=p)dfs_ans(y[0],x,1);
    }
}
int main()
{
    int n,tmp;
    cin>>n>>tmp;
    for(int i=0;i<n-1;i++)
    {
        int u,v,c;
        cin>>u>>v>>c;
        u--,v--;
        adj[u].push_back({v,c,i+1});
        adj[v].push_back({u,c,i+1});
    }
    for(int i=0;i<n;i++)
    {
        int s=adj[i].size();
        while(s--)
        {
            int x;
            cin>>x;
            vals[i].push_back(x);
        }
    }
    calc_dfs(0,0);
    if(!ok)
    {
        cout<<"No";
        return 0;
    }
    cout<<"Yes"<<endl;
    dfs_ans(0,0,0);
    reverse(ans.begin(),ans.end());
    for(auto &x:ans)cout<<x<<" ";
    cout<<endl;
}