#ifdef Local

#include "debug.h"

#else
#include <bits/stdc++.h>
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

template<class A, class B>
bool smin(A &x, B &&y) {
        if (x > y) {
                x = y;
                return true;
        }
        return false;
}

template<class A, class B>
bool smax(A &x, B &&y) {
        if (x < y) {
                x = y;
                return true;
        }
        return false;
}

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

const int maxn = 2e5 + 10;
vector<tuple<int, int, int>> g[maxn];
deque<int> a[maxn];
int cnt[maxn], b[maxn];
vector<int> ansl, ansr;

void dfs(int v, int p) {
        if (sz(g[v]) == 1 && v != p) {
                b[v] = a[v].front();
                return;
        }
        vector<pair<int, int>> t;
        for (auto &[u, w, i]: g[v]) {
                if (u == p)
                        continue;
                dfs(u, v);
                t.emplace_back(max(0ll, w - b[u]), i);
        }
        sort(all(t));
        set<pair<int, int>> s;
        for (int i = 0; i < sz(a[v]); ++i)
                s.insert({a[v][i], i});
        vector<pair<int, int>> k;
        for (auto &[x, i]: t) {
                auto it = s.lower_bound({x, 0});
                if (it == s.end()) {
                        cout << "No" << endl;
                        exit(0);
                }
                k.emplace_back(it->second, i);
                s.erase(it);
        }
        sort(all(k));
        for (auto &[j, i]: k) {
                if (v != p && j > s.begin()->second)
                        break;
                ansl.emplace_back(i);
                a[v].pop_front();
        }
        if (v == p)
                return;
        reverse(all(k));
        for (auto &[j, i]: k) {
                if (j < s.begin()->second)
                        break;
                ansr.emplace_back(i);
                a[v].pop_back();
        }
        b[v] = a[v].front();
}

void solve() {
        int n, group;
        cin >> n >> group;
        for (int i = 0, v, u, w; i < n - 1; ++i) {
                cin >> v >> u >> w;
                g[v].emplace_back(u, w, i + 1);
                g[u].emplace_back(v, w, i + 1);
                ++cnt[v], ++cnt[u];
        }
        for (int v = 1; v <= n; ++v) {
                a[v].resize(cnt[v]);
                for (auto &u: a[v])
                        cin >> u;
        }
        int root = 1;
        while (cnt[root] == 1)
                ++root;
        dfs(root, root);
        cout << "Yes" << endl;
        for (int &i: ansl)
                cout << i << ' ';
        reverse(all(ansr));
        for (int &i: ansr)
                cout << i << ' ';
        cout << endl;
}

signed main() {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);

        int _t = 1;
        // cin >> _t;
        while (_t--)
                solve();

        return 0;
}
