//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx2,sse3,tune=native")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef __int128 lll;
const ll inf = 1e18 + 1, mod = 1e9 + 21;
const ld eps = 1e-9;
#define all(a) a.begin(), a.end()

vector<vector<vector<ll>>> g;
vector<vector<ll>> d;
vector<set<vector<ll>>> dg;
vector<ll> ans;
ll it = 0;

void dfs(ll v, ll pr) {
    for (auto i: g[v])
        if (i[0] != pr) {
            dfs(i[0], v);
            ll x = (*(dg[i[0]].begin()))[0];
            auto it = dg[v].lower_bound({i[1] - x, -1});
            if (it == dg[v].end()) {
                cout << "No";
                exit(0);
            }
            d[v][(*it)[1]] = i[0];
            d[i[0]][(*(dg[i[0]].begin()))[1]] = v;
            dg[v].erase(it);
        }
}

void dfs2(ll v, ll pr) {
    for (ll i = 0; i < g[v].size(); i++)
        if (g[v][i][0] == pr) {
            ans[it] = g[v][i][2];
            it++;
        } else
            dfs2(g[v][i][0], v);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, ggg;
    cin >> n >> ggg;
    g.resize(n);
    d.resize(n);
    dg.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].push_back({v, w, i});
        g[v].push_back({u, w, i});
        d[v].push_back(0);
        d[u].push_back(0);
    }
    for (ll i = 0; i < n; i++)
        for (ll j = 0; j < g[i].size(); j++) {
            ll x;
            cin >> x;
            dg[i].insert({x, (ll) g[i].size() - j - 1});
        }
    dfs(0, -1);
    ans.resize(n - 1);
    dfs2(0, -1);
    for (auto i: ans)
        cout << i + 1 << ' ';
}