#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3", "unroll-loops", "fast-math")
//#pragma GCC target("avx2")

#define int long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pb push_back
#define f first
#define s second

using namespace std;
using namespace __gnu_pbds;

using pii = pair <int, int>;
using oset = tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 2e5 + 1337;
const int INF = 1e16 + 1337;
map <int, vector <int>> ps[N];
multiset <int> st[N];
map <pii, int> id;
vector <pii> g[N];
int nm[N];

void dfs(int u, int p) {
    for (auto& [v, w] : g[u]) {
        if (v == p)
            continue;

        dfs(v, u);
    }

    for (auto& [v, w] : g[u]) {
        if (v == p)
            continue;

        int x = *st[v].begin();
        int nd = w - x;
        auto it = st[u].lower_bound(nd);
        if (it == st[u].end()) {
            cout << "NO";
            exit(0);
        }

        int y = *it;
        st[u].erase(it);
        int i = id[{u, v}];
        nm[i] = ps[u][y].back();
        ps[u][y].pop_back();
    }
}

vector <int> ans;

void set_ans(int u, int p) {
    vector <pii> vr;
    for (auto& [v, w] : g[u]) {
        int i = id[{u, v}];
        vr.pb({nm[i], v});
    }
    sort(all(vr));

    for (auto& [x, v] : vr) {
        if (v == p) {
            ans.pb(id[{u, v}] + 1);
            continue;
        }

        set_ans(v, u);
    }
}

void solve() {
    int n, gr;
    cin >> n >> gr;
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;

        id[{u, v}] = id[{v, u}] = i;
        g[u].pb({v, w});
        g[v].pb({u, w});
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < sz(g[i]); j++) {
            int c;
            cin >> c;
            st[i].insert(c);
            ps[i][c].pb(j);
//            ps[i][c].pb(sz(g[i]) - 1 - j);
        }
    }

    dfs(0, 0);
    set_ans(0, 0);
    cout << "YES\n";
    reverse(all(ans));
    for (auto& i : ans)
        cout << i << " ";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}
