#include <bits/stdc++.h>

using namespace std;

#define int long long


struct e{
    int next;
    int cost;
    int ind;
};


const int maxn = 2e5 + 100;
vector<vector<e>> edges(maxn, vector<e>());
vector<vector<int>> nacleiki(maxn, vector<int>());
vector<int> ans;


void dfs(int v, int first_nacl) {
    for (auto pai : edges[v]) {
        int u = pai.next, c = pai.cost, ind_add = pai.ind;
        if (u == v + 1) {
            int ind = 0;
            if (nacleiki[u].size() > 1 && nacleiki[u][0] > nacleiki[u][1]) {
                ind = 1;
            }
            if (first_nacl + nacleiki[u][ind] < c) {
                if (nacleiki[u].size() == 1) {
                    cout << "No";
                    exit(0);
                }
                ind = (ind + 1) % 2;
            }
            if (first_nacl + nacleiki[u][ind] < c) {
                cout << "No";
                exit(0);
            }
            if (ind == 0) {
                ans.push_back(ind_add);
            }
            if (nacleiki[u].size() == 2) {
                dfs(u, nacleiki[u][(ind + 1) % 2]);
            }
            if (ind == 1) {
                ans.push_back(ind_add);
            }
        }
    }
}


void sol_for_g_2(int n) {
    dfs(1, 0);
    cout <<  "Yes" << endl;
    for (auto v : ans) {
        cout << v << " ";
    }
    cout << endl;
    exit(0);
}



signed main() {
    cout.precision(15);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, g;
    cin >> n >> g;
    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        edges[a].push_back({b, c, i + 1});
        edges[b].push_back({a, c, i + 1});
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < edges[i].size(); j++) {
            int num;
            cin >> num;
            nacleiki[i].push_back(num);
        }
    }
    sol_for_g_2(n);
}

