#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>
#include <array>
using namespace std;
using ll = long long;
vector<vector<int>> g, c;
map<pair<int, int>, int> mp, w;
vector<int> dfs(int v, int pr) {
	vector<vector<int>> ch;
	for (auto to : g[v]) {
		if(to != pr) ch.push_back(dfs(to, v));
	}
	vector<pair<int, int>> edge;
	for (int i = 0; i < g[v].size(); i++) {
		int to = g[v][i];
		if (to != pr) edge.push_back({ w[{v, to}], i });
	}
	set<pair<int, int>> c1;
	for (int i = 0; i < c[v].size(); i++) {
		c1.insert({ c[v][i], c[v].size() - i });
	}
	vector<int> res; map<int, int> ord;
	for (int j = 0; j < edge.size(); j++) {
		pair<int, int> i = edge[j];
		if (prev(c1.end())->first < i.first) {
			cout << "No"; exit(0);
		}
		pair<int, int> fnd = { i.first, 0 };
		int pos = c1.lower_bound(fnd)->second; ord[pos] = j;
		c1.erase(c1.lower_bound(fnd));
	}
	if (pr != v) {
		w[{pr, v}] -= c1.begin()->first; ord[c1.begin()->second] = -1;
		w[{v, pr}] -= c1.begin()->first;
	}
	for (auto i : ord) {
		if (i.second == -1) {
			res.push_back(mp[{pr, v}]); continue;
		}
		for (auto j : ch[i.second]) res.push_back(j);
	}
	return res;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, gr; cin >> n >> gr; g.resize(n, {}); c.resize(n);
	for (int i = 1; i < n; i++) {
		int u, v, ww; cin >> u >> v >> ww; u--; v--;
		mp[{u, v}] = mp[{v, u}] = i; w[{u, v}] = w[{v, u}] = ww;
		g[u].push_back(v); g[v].push_back(u);
	}
	for (int i = 0; i < n; i++) {
		c[i].resize(g[i].size());
		for (auto& j : c[i]) cin >> j;
	}
	vector<int> res = dfs(0, 0); cout << "Yes\n";
	for (auto i : res) cout << i << " ";
	return 0;
}
