#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, g;
    cin >> n >> g;

    if (g <= 1) {
        vector<ll> deg(n);
        vector<array<ll, 4>> edges(n - 1);
        for (ll i = 0; i < n - 1; i++) {
            ll a, b, w;
            cin >> a >> b >> w;
            a--; b--;
            if (g == 1 && n == 4) {
                assert(a + 1 == b);
            }
            deg[a]++; deg[b]++;
            edges[i] = {a, b, w, i + 1};
        }

        vector<ll> wh(n);
        vector<vector<ll>> c(n);
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < deg[i]; j++) {
                ll in; cin >> in;
                c[i].push_back(in);
            }
            wh[i] = deg[i] - 1;
        }

        do {
            bool ok = true;
            vector<ll> cwh = wh;
            for (auto [a, b, w, cnt] : edges) {
                if (c[a][cwh[a]] + c[b][cwh[b]] < w) {
                    ok = false;
                    break;
                } else {
                    cwh[a]--; cwh[b]--;
                }
            }

            if (ok) {
                cout << "Yes\n";
                for (auto [a, b, w, cnt] : edges) {
                    cout << cnt << ' ';
                }
                return 0;
            }
        } while (next_permutation(edges.begin(), edges.end()));

        cout << "No\n";
    }

    return 0;
}
