#include <bits/stdc++.h>

using namespace std;

struct edge { int a, b, c; };
int n;
vector<edge> edges;
vector<vector<int>> cost;

bool norm(vector<int>& p) {
    vector<int> point(n);
    for (auto elem : p) {
        int a = edges[elem].a, b = edges[elem].b, c = edges[elem].c;
        if (c > cost[a][point[a]] + cost[b][point[b]]) return false;
        point[a]++, point[b]++;
    }
    return true;
}

signed main() {
    int group;
    cin >> n >> group;
    cost.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        edges.push_back({--a, --b, c});
        cost[a].push_back(0);
        cost[b].push_back(0);
    }
    for (int i = 0; i < n; i++) {
        for (int & j : cost[i])
            cin >> j;
        reverse(cost[i].begin(), cost[i].end());
    }
    if (group <= 1) {
        vector<int> p(n - 1);
        iota(p.begin(), p.end(), 0);
        do {
            if (norm(p)) {
                cout << "Yes\n";
                for (auto elem : p)
                    cout << elem + 1 << ' ';
                cout << '\n';
                return 0;
            }
        } while (next_permutation(p.begin(), p.end()));
        cout << "No\n";
    }
}
