#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define eb emplace_back
#define vec vector
#define read(x) for(auto &zu: (x))cin >> zu;
#define all(x) (x).begin(), (x).end()

using vi = vector<int>;
using str = string;
using ll = long long;
using pii = pair<int, int>;

template<typename A>
void print(A &a, str sep=" "){
    for(auto &i: a)cout << i << sep;
    cout << "\n";
}

vec<vec<array<int, 3>>> g;
vec<array<int, 3>> edg;
vec<vi> a;
int n;

void solve(){
    int T; cin >> n >> T;
    g.resize(n);
    a.resize(n);
    vi deg(n, 0);
    edg.resize(n - 1);
    for(int i = 0; i < n - 1; ++i){
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        deg[u]++;
        deg[v]++;
        g[u].pb({v, w, i});
        g[v].pb({u, w, i});
        edg[i] = {u, v, w};
    }
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < deg[i]; ++j){
            int x; cin >> x;
            a[i].pb(x);
        }
        reverse(all(a[i]));
    }

    if(T == 2){
        for(auto &i: a)
            reverse(all(i));

        vec<array<int, 2>> dp(n, {0, 0});
        dp[0][1] = 1;
        for(int i = 1; i < n; ++i){
            for(int j = 0; j < a[i].size(); ++j){
                for(int prev = 0; prev < a[i - 1].size(); ++prev){
                    if(a[i - 1][prev] + a[i][j] < g[i][0][1])
                        continue;
                    dp[i][j] |= dp[i - 1][1 - prev];
                }
            }
        }
        if(dp[n - 1][0] == 0){
            cout << "No\n";
        }else{
            cout << "Yes\n";
            // 0 -> first right
            // 1 -> first left
            vi way(1, 0);
            int cur = 0;
            for(int i = n - 1; i >= 1; --i){
                for(int j = 0; j < a[i - 1].size(); ++j){
                    if(dp[i - 1][1 - j] &&
                    a[i - 1][j] + a[i][cur] >= g[i][0][1]){
                        way.pb(j);
                        cur = 1 - j;
                        break;
                    }
                }
            }
            reverse(all(way));
            deque<int> res;
            for(int i = n - 1; i >= 1; i--){
                if(way[i] == 0){
                    res.push_front(g[i][0][2] + 1);
                }else{
                    res.push_back(g[i][0][2] + 1);
                }
            }
            print(res);
        }
        return;
    }else if(T == 3){
        for(auto &i: a)
            reverse(all(i));
        set<pii> best;
        for(int i = 1; i < n; ++i){
            best.insert({g[i][0][1] - a[i][0], i});
        }
        vi res;
        for(int i = 0; i < n - 1; ++i){
            int cur = a[0][i];
            auto it = best.upper_bound({cur, n + 1});
            if(it == best.begin()){
                cout << "No\n";
                return;
            }
            it--;
            auto [nd, v] = *it;
            res.pb(v);
            best.erase(it);
        }
        cout << "Yes\n";
        print(res);
        return;
    }

    bool ok = true;
    vi res;
    vi used(n - 1, 0);
    while(ok && res.size() < n - 1){
        int cur = -1;
        int best = 1e9+7;
        for(int i = 0; i < n - 1; ++i){
            if(used[i])continue;
            if(a[edg[i][0]].size() == 0 ||
                a[edg[i][1]].size() == 0){
                ok = false;
                break;
            }
            int dif = a[edg[i][0]].back() + a[edg[i][1]].back() - edg[i][2];
            if(dif >= 0 && dif < best){
                cur = i;
                best = dif;
            }
        }
        if(cur == -1)
            ok = false;
        else{
            res.pb(cur + 1);
            a[edg[cur][0]].pop_back();
            a[edg[cur][1]].pop_back();
            used[cur] = 1;
        }
    }
    if(!ok){
        cout << "No\n";
    }else{
        cout << "Yes\n";
        reverse(all(res));
        print(res);
    }
}


signed main() {
#ifdef LOCAL
    freopen("inp", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int TT = 1;
    //cin >> TT;
    while(TT--){
        solve();
    }
    return 0;
}
