#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

using ll = long long;
using lll = __int128_t;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using dui = pair<int, int>;
using dul = pair<long, long>;
using vi = vector<int>;
using vll = vector<long long>;
using ld = long double;

constexpr int MX = 2'000'000'000;
constexpr long long MXL = 4'000'000'000'000'000'000;

struct rebro {
    int u, v, w;
};

bool dfs(vi &ans, vi &used, vector<rebro> &r, vi &pos, vector<vi> &a) {
    if (count(used.begin(), used.end(), 1) == used.size()) {
        return 1;
    }
    for (int i = 0; i < used.size(); i++) {
        if (used[i])  continue;
        rebro cur = r[i];
        if (cur.w <= a[cur.u][pos[cur.u]] + a[cur.v][pos[cur.v]]) {
            pos[cur.u]++;
            pos[cur.v]++;
            used[i] = 1;
            ans.push_back(i + 1);
            if (dfs(ans, used, r, pos, a)) {
                return 1;
            }
            ans.pop_back();
            pos[cur.u]--;
            pos[cur.v]--;
            used[i] = 0;
        }
    }
    return 0;
}

void solve1(int n) {
    vector<rebro> r;
    vi sz(n + 1);
    for (int i=1;i<n;i++) {
        int u, v, w; cin >> u >> v >> w;
        sz[u]++;
        sz[v]++;
        r.push_back({u, v, w});
    }
    vector<vi> a(n + 1);
    for (int i=1;i<=n;i++) {
        for (int j=0;j<sz[i];j++) {
            int k;cin >> k;
            a[i].push_back(k);
        }
    }
    vi ans;
    vi used(n - 1);
    vi pos(n + 1);
    if (dfs(ans, used, r, pos, a)) {
        cout << "YES\n";
        for (auto i : ans) cout << i << ' ';
    }
    else {
        cout << "NO\n";
    }
}

void solve() {
    int n, g;
    cin >> n >> g;
    if (g == 1 or g == 0) {
        solve1(n);
    }
}

int main() {
#ifdef LOCAL
    freopen("inputf.txt", "r", stdin);
    freopen("outputf.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
