#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define ll int64_t
#define lol(a, val) memset(a, val, sizeof(a))
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld double
#define double long double
#define pb push_back
#define F first
#define S second

int mod = 1e9 + 7;
int const maxn = 5e5;
int const inf = 1e18;
int const LOG = 20;
ld const eps = 1e-9;
int const N = 2e3 + 10;


pair<int, int> best[maxn];
int w[maxn];
vector<pair<int, int>>
        g[maxn];
vector<pair<int, int>>
        a[maxn];
int fr[maxn];
int global = 0;

void dfs(int v, int p = -1) {
    if (g[v].size() == 1 && p != -1) {
        best[v] = a[v][0];
        return;
    }
    vector<pair<pair<int, int>, int >> t;
    for (auto [u, ind]: g[v]) {
        if (u == p) continue;
        dfs(u, v);
        t.pb({{w[ind] - best[u].F, best[u].S}, ind});
    }
    sort(all(t));
    int bst = t.size();
    if (p == -1) {
        for (int i = 0; i < t.size(); i++) {
            if (t[i].F.F > a[v][i].F) {
                global = 1;
            }
            fr[a[v][i].S] = t[i].S;
            fr[t[i].F.S] = t[i].S;
        }
        return;
    }

    for (int i = 0; i < t.size(); i++) {
        if (t[i].F.F > a[v][i + 1].F) {
            global = 1;
        }
    }

    for (int i = 0; i < t.size(); i++) {
        if (t[i].F.F <= a[v][i].F) {
            continue;
        }
        bst = i;
        break;
    }

    best[v] = a[v][bst];
    for (int i = 0; i < bst; i++) {
        fr[a[v][i].S] = t[i].S;
        fr[t[i].F.S] = t[i].S;
    }
    for (int i = bst; i < t.size(); i++) {
        fr[a[v][i + 1].S] = t[i].S;
        fr[t[i].F.S] = t[i].S;
    }
}

vector<int> order;
int to[maxn];
vector<int> ng[maxn];
int used[maxn];

void top_sort(int v) {
    used[v] = 1;
    for (int u: ng[v]) {
        if (used[u]) continue;
        top_sort(u);
    }
    order.pb(v);
}

void solve() {
    int n, gol;
    cin >> n >> gol;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v >> w[i];
        u--, v--;
        g[u].pb({v, i});
        g[v].pb({u, i});
    }
    int cur = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < g[i].size(); j++) {
            int x;
            cin >> x;
            a[i].pb({x, cur});
            to[cur] = -1;
            if (j > 0) {
                to[cur] = cur - 1;
            }
            cur++;
        }
        sort(all(a[i]));
    }


    dfs(0);
    for (int i = 0; i < 2 * (n - 1); i++) {
        if (to[i] != -1) {
            ng[fr[i]].pb(fr[to[i]]);
        }
    }

    for (int i = 0; i + 1 < n; i++) {
        if (!used[i]) top_sort(i);
    }
    reverse(all(order));
    if (global) {
        cout << "No\n";
        return;
    } else {
        cout << "Yes\n";
        for (int i = 0; i + 1 < n; i++) {
            cout << order[i] + 1 << ' ';
        }
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int tt;
    tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
