﻿#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
typedef long long ll;

const int maxn = 2e5;
vector<vector<ll>> e;
vector<vector<int>> gr(maxn);
vector<vector<ll>> c(maxn);
vector<bool> ud(maxn);

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, g;
	cin >> n >> g;

	set<pair<int, int>> st;
	for (int i = 0; i < n-1; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u;
		--v;
		e.push_back({ v, u, w });
		gr[u].push_back(i);
		gr[v].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < gr[i].size(); ++j) {
			ll cc;
			cin >> cc;
			c[i].push_back(cc);
		}
		reverse(c[i].begin(), c[i].end());
	}
	for (int i = 0; i < n - 1; ++i) {
		if (c[e[i][0]].back() + c[e[i][1]].back() >= e[i][2]) {
			st.insert({ -e[i][2], i });
		}
	}
	vector<int> r;
	while (!st.empty()) {
		auto y = *(st.begin());
		st.erase(st.begin());
		r.push_back(y.second);
		ud[y.second] = 1;
		c[e[y.second][0]].pop_back();
		c[e[y.second][1]].pop_back();
		for (auto u : gr[e[y.second][0]]) {
			if (st.find({ -e[u][2], u }) != st.end()) {
				st.erase({ -e[u][2], u });
			}
			if (ud[u]) continue;
			if (c[e[u][0]].back() + c[e[u][1]].back() >= e[u][2]) {
				st.insert({ -e[u][2], u });
			}
		}
		for (auto u : gr[e[y.second][1]]) {
			if (st.find({ -e[u][2], u }) != st.end()) {
				st.erase({ -e[u][2], u });
			}
			if (ud[u]) continue;
			if (c[e[u][0]].back() + c[e[u][1]].back() >= e[u][2]) {
				st.insert({ -e[u][2], u });
			}
		}
	}
	if (r.size() < n - 1) {
		cout << "NO";
	}
	else {
		reverse(r.begin(), r.end());
		cout << "YES\n";
		for (auto i : r) {
			cout << i + 1 << ' ';
		}
	}
	return 0;
}
