﻿#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <random>
#include <queue>

using namespace std;
typedef long long ll;

//mt19937 rng(1315);

const ll maxn = 2e5;
vector<vector<ll>> e(maxn);
vector<vector<ll>> gr(maxn);
vector<vector<pair<ll, ll>>> gg(maxn);
vector<vector<ll>> c(maxn);
ll n;
vector<ll> dp(maxn);
vector<vector<ll>> ff;

bool ch(vector<ll>& p) {
	vector<ll> cn(n);
	for (ll i = 0; i < n - 1; ++i) {
		ll jj = e[p[i]][0], pp = e[p[i]][1];
		if (e[p[i]][2] > c[jj][cn[jj]] + c[pp][cn[pp]]) return 0;
		++cn[jj];
		++cn[pp];
	}
	return 1;
}

void co(vector<ll>& p) {
	cout << "Yes\n";
	for (auto i : p) {
		cout << i + 1 << ' ';
	}
	exit(0);
}

void dfs(ll v, ll p = -1) {
	if (gr[v].size() == 1 && p != -1) {
		dp[v] = 0;
		return;
	}
	set<pair<ll, ll>> st;
	for (ll i = 0; i < gr[v].size(); ++i) {
		st.insert({ c[v][i], i });
	}
	for (auto u : gr[v]) {
		ll x = e[u][0];
		if (x == v) {
			x = e[u][1];
		}
		if (x == p) continue;
		dfs(x, v);
		if (st.lower_bound({ e[u][2] - c[x][dp[x]], -1 }) == st.end()) {
			cout << "No";
			exit(0);
		}
		ff.push_back({x, v, dp[x], (*st.lower_bound({ e[u][2] - c[x][dp[x]], -1 })).second, u });
		st.erase(st.lower_bound({ e[u][2] - c[x][dp[x]], -1 }));
	}
	if (p != -1) {
		dp[v] = (*st.begin()).second;
	}
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	ll g;
	cin >> n >> g;
	for (ll i = 0; i < n - 1; ++i) {
		ll u, v, w;
		cin >> u >> v >> w;
		--u;
		--v;
		e[i] = { u, v, w };
		gr[u].push_back(i);
		gr[v].push_back(i);
		gg[u].push_back({ v, i });
		gg[v].push_back({ u, i });
	}
	for (ll i = 0; i < n; ++i) {
		c[i].resize(gr[i].size());
		for (ll j = 0; j < c[i].size(); ++j) {
			cin >> c[i][j];
		}
		reverse(c[i].begin(), c[i].end());
	}
	if (n <= 10 && 0) {
		vector<ll> p(n-1);
		for (ll i = 0; i < n-1; ++i) {
			p[i] = i;
		}
		if (ch(p)) {
			co(p);
		}
		while (next_permutation(p.begin(), p.end())) {
			if (ch(p)) {
				co(p);
			}
		}
		cout << "No";
	}
	else {
		dfs(0);
		cout << "Yes\n";
		vector<ll> rs, ct(n);
		vector<vector<ll>> ui(n);
		for (ll i = 0; i < n; ++i) {
			ui[i].resize(gr[i].size());
			ct[i] = gr[i].size() - 1;
		}
		for (ll i = 0; i < n - 1; ++i) {
			ui[ff[i][0]][ff[i][2]] = ff[i][1];
			ui[ff[i][1]][ff[i][3]] = ff[i][0];
		}
		vector<pair<ll, ll>> pf;
		for (ll i = 0; i < n - 1; ++i) {
			if (ui[e[i][0]][ct[e[i][0]]] == e[i][1] && ui[e[i][1]][ct[e[i][1]]] == e[i][0]) {
				pf.push_back({ e[i][0], e[i][1] });
			}
		}
		for (ll i = 0; i < n - 1; ++i) {
			--ct[pf[i].first];
			--ct[pf[i].second];
			if (ct[pf[i].first] >= 0) {
				ll xx = ui[pf[i].first][ct[pf[i].first]];
				if (ui[xx][ct[xx]] == pf[i].first) {
					pf.push_back({ xx, pf[i].first });
				}
			}
			if (ct[pf[i].second] >= 0) {
				ll yy = ui[pf[i].second][ct[pf[i].second]];
				if (ui[yy][ct[yy]] == pf[i].second) {
					pf.push_back({ yy, pf[i].second });
				}
			}
		}
		map<pair<ll, ll>, ll> mpp;
		for (ll i = 0; i < n - 1; ++i) {
			mpp[{min(e[i][0], e[i][1]), max(e[i][0], e[i][1])}] = i + 1;
		}
		for (ll i = n-2; i >= 0; --i) {
			cout << mpp[{min(pf[i].first, pf[i].second), max(pf[i].first, pf[i].second)}] << ' ';
		}
	}

	return 0;
}
