#include <bits/stdc++.h>
using namespace std;

bool dfs(int x, int p, vector<vector<tuple<int, int, int>>>& g, vector<map<int, vector<int>>>& m, vector<pair<int, int>>& v) {
    for (auto i : g[x]) {
        if (get<0>(i) != p) {
            if (dfs(get<0>(i), x, g, m, v)) {
                return true;
            }
            auto mi(m[get<0>(i)].begin()); //the only sticker
            int t(mi->second[0]);
            int s(mi->first);
            s = get<2>(i) - s;
            //cout << s << endl;
            auto it(m[x].lower_bound(s));
            if (it == m[x].end()) {
                return true;
            }
            int t2(it->second.back());
            it->second.pop_back();
            if (it->second.size() == 0) {
                m[x].erase(it);
            }
            v[get<1>(i)] = {t, t2};
        }
    }
    return false;
}

int main() {
    int n, gg, q, r, s;
    cin >> n >> gg;
    vector<vector<tuple<int, int, int>>> g(n, vector<tuple<int, int, int>>(0));
    for (int i = 0; i < n - 1; i++) {
        cin >> q >> r >> s;
        q--;
        r--;
        g[q].push_back({r, i, s});
        g[r].push_back({q, i, s});
    }
    vector<map<int, vector<int>>> m(n, map<int, vector<int>>{});
    vector<pair<int, int>> v(n - 1, {-1, -1});
    int sn(0);
    vector<int> fn(n, 0), ln(n, 0), find_vertex(2 * (n - 1), 0);
    for (int i = 0; i < n; i++) {
        fn[i] = sn - 1;
        for (int j = 0; j < g[i].size(); j++) {
            cin >> q;
            find_vertex[sn] = i;
            m[i][q].push_back(sn);
            sn++;
        }
        ln[i] = sn - 1;
    }
    if (dfs(0, -1, g, m, v)) {
        cout << "No" << endl;
        return 0;
    }
    cout << "Yes" << endl;
    vector<int> what_edge(2 * (n - 1), -1);
    for (int i = 0; i < n - 1; i++) {
        //cout << v[i].first << " " << v[i].second << endl;
        what_edge[v[i].first] = i;
        what_edge[v[i].second] = i;
    }
    vector<int> is_open(n - 1, 0);
    vector<int> open_edges{};
    for (int i = 0; i < n; i++) {
        is_open[what_edge[ln[i]]]++;
        if (is_open[what_edge[ln[i]]] == 2) {
            open_edges.push_back(what_edge[ln[i]]);
        }
    }
    vector<int> res{};
    while (open_edges.size() > 0) {
        int dg(open_edges.back());
        res.push_back(dg);
        open_edges.pop_back();
        ln[find_vertex[v[dg].first]]--;
        if (ln[find_vertex[v[dg].first]] != fn[find_vertex[v[dg].first]]) {
            is_open[what_edge[ln[find_vertex[v[dg].first]]]]++;
            if (is_open[what_edge[ln[find_vertex[v[dg].first]]]] == 2) {
                open_edges.push_back(what_edge[ln[find_vertex[v[dg].first]]]);
            }
        }
        ln[find_vertex[v[dg].second]]--;
        if (ln[find_vertex[v[dg].second]] != fn[find_vertex[v[dg].second]]) {
            is_open[what_edge[ln[find_vertex[v[dg].second]]]]++;
            if (is_open[what_edge[ln[find_vertex[v[dg].second]]]] == 2) {
                open_edges.push_back(what_edge[ln[find_vertex[v[dg].second]]]);
            }
        }
    }
    for (auto i : res) {
        cout << i + 1 << " ";
    }
}
