//#pragma GCC optimize ("Ofast")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;
#define int long long
void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}
struct Edge {
    int w, ab;
    Edge(int a, int b, int _w) {
        ab = a + b;
        w = _w;
    }
    int to(int v) {
        return ab - v;
    }
};
vector<Edge> ed;
vector<vector<int>> gr;
vector<vector<int>> degs;
vector<int> deg;
vector<vector<int>> eds;

int _cnst_;
bool cmp(int a, int b) {
    return deg[ed[a].to(_cnst_)] > deg[ed[b].to(_cnst_)];
}
bool cmp2(int a, int b) {
    return degs[_cnst_][a] < degs[_cnst_][b];
}

void srt(int x, int p) {
    for (int e : gr[x]) {
        if (e == p) continue;
        srt(ed[e].to(x), e);
    }
    _cnst_ = x;
    sort(gr[x].begin(), gr[x].end(), cmp); if (p != -1) gr[x].pop_back();
    reverse(gr[x].begin(), gr[x].end());
    vector<int> dg = degs[x]; sort(dg.begin(), dg.end());
    int i = 0, j = 0;
    vector<int> shuf(dg.size(), -1);
    while (j < gr[x].size()) {
        while (i < dg.size() && dg[i] < deg[ed[gr[x][j]].to(x)]) {
            i++;
        }
        if (i > j + 1 || i == dg.size()) {
            cout << "No\n"; exit(0);
        }
        shuf[i] = gr[x][j]; 
        i++; j++;       
    }
    for (int i = 0; i < dg.size(); i++) {
        if (shuf[i] == -1) {deg[x] = ed[p].w - dg[i]; shuf[i] = p;}
    }
    vector<int> ord(dg.size());
    for (int i = 0; i < dg.size(); i++) ord[i] = i;
    sort(ord.begin(), ord.end(), cmp2);
    vector<int> tsh(dg.size());
    for (int i = 0; i < dg.size(); i++) {
        tsh[ord[i]] = shuf[i];
    }
    for (int i = 1; i < tsh.size(); i++) {
        eds[tsh[i - 1]].push_back(tsh[i]);
    }
    //for (int i : tsh) cout << i << ' '; cout << '\n'; 
}

vector<int> t_srt;
vector<int> used;
void dfs(int x) {
    if (used[x]) return;
    used[x] = 1;
    for (int u : eds[x]) dfs(u);
    t_srt.push_back(x + 1);
}

void solve() {
    int n, g; cin >> n >> g;
    degs.resize(n);
    deg.resize(n, -(int)1e10);
    eds.resize(n - 1);
    gr.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b, w; cin >> a >> b >> w; a--; b--;
        ed.push_back(Edge(a, b, w));
        gr[a].push_back(i);
        gr[b].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < gr[i].size(); j++) {
            int x; cin >> x;
            degs[i].push_back(x);
        }
        reverse(degs[i].begin(), degs[i].end());
        //for (int j : degs[i]) cout << j << ' '; cout << '\n';
    }
    srt(0, -1);
    used.resize(n);
    for (int i = 0; i < n - 1; i++) {
        if (!used[i]) dfs(i);
    }
    reverse(t_srt.begin(), t_srt.end());
    cout << "Yes\n";
    for (int i : t_srt) cout << i << ' ';
}

signed main() {
    speed();
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    //cout << fixed << setprecision(20);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}