#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

//#pragma ("OFast")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<vector<int>> ans;

void dfs(int v, int pr, int prw, int pri, vector<vector<array<int, 3>>> &g, vector<set<pair<int, int>>> &c){
    for (auto [to, w, i] : g[v]){
        if (to == pr){
            continue;
        }
        dfs(to, v, w, i, g, c);
    }
    if (!c[v].empty()){
        auto it = c[pr].lower_bound({prw - (*c[v].begin()).first, -1});
        if (it == c[pr].end()){
            cout << "No";
            exit(0);
        }
        auto [i, j] = *it;
        c[pr].erase(it);
        ans[j].push_back(pri + 1);
    }
}

void solve(){
    int n, gr;
    cin >> n >> gr;
    vector<vector<array<int, 3>>> g(n);
    vector<int> deg(n);
    for (int i = 0; i < n - 1; i++){
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        g[v].push_back({u, w, i});
        g[u].push_back({v, w, i});
        deg[v]++;
        deg[u]++;
    }
    vector<set<pair<int, int>>> c(n);
    for (int i = 0; i < n; i++){
        int degi = deg[i];
        for (int j = 0; j < degi; j++){
            int ci; cin >> ci;
            c[i].insert({ci, j});
        }
    }
    ans.resize(n);
    dfs(0, -1, -1, -1, g, c);
    cout << "Yes\n";
    for (auto &a : ans){
        for (auto el : a){
            cout << el << " ";
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin >> t;
    while (t--){
        solve();
    }
}
