#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <algorithm>
#include <map>
using namespace std;
using ll = long long;
const ll INF = 1e9;
vector<int>a;
int W;
int rec(int tA, int tB, int l, int r) {
	if (tA + tB == W) return tA;
	if (tA <= tB) {
		if (l == a.size()) return rec(tA + a[r], tB, l, r - 1);
		if (r == -1) return rec(tA + a[l], tB, l + 1, r);
		return max(rec(tA + a[l], tB, l + 1, r),
			rec(tA + a[r], tB , l, r - 1));
	}
	if (tA > tB) {
		if (l == a.size()) return rec(tA, tB + a[r], l, r - 1);
		if (r == -1) return rec(tA, tB + a[l], l + 1, r);
		return min(rec(tA, tB + a[l], l + 1, r),
			rec(tA, tB + a[r], l, r - 1));
	}
	
}
void solve() {
	int n;
	cin >> n;
	a.resize(n);
	bool is2 = true;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		W += a[i];
		if (a[i] > 2) is2 = false;
	}
	if (is2) {
		if (a[0] == 1) {
			cout << (W - 1) / 2 + 1 << ' ' << W / 2 << "\n";
		}
		else {
			cout << W / 2 + (W / 2 % 2) << ' ' << W / 2 - (W / 2 % 2);
		}
		return;
	}
	if (n == 3) {
		int x = rec(0, 0, 0, n - 1);
		cout << x << ' ' << W - x << "\n";
	}
	vector<vector<vector<int>>>dp(W + 1, vector<vector<int>>(W + 1, vector<int>(2, -1)));
	dp[0][0] = { 0, n - 1 };
	set<pair<int, int>>nxt;
	nxt.insert({ 0, 0 });
	while (!nxt.empty()) {
		auto [A, B] = *nxt.begin();
		if (dp[A][B] == vector<int>(2, -1)) continue;
		int l = dp[A][B][0];
		int r = dp[A][B][1];
		if (A + B == W || l == n && r == -1) break;
		if (A <= B) {
			if (l == n) {
				dp[A + a[r]][B] = { l, r - 1 };
				nxt.insert({ A + a[r], B });
			}
			else if (r == -1) {
				dp[A + a[l]][B] = { l + 1, r };
				nxt.insert({ A + a[l], B });
			}
			else {
				dp[A + a[r]][B] = { l, r - 1 };
				dp[A + a[l]][B] = { l + 1, r };
				nxt.insert({ A + a[r], B });
				nxt.insert({ A + a[l], B });
			}
		}
		if (A > B) {
			if (l == n) {
				dp[A][B + a[r]] = { l, r - 1 };
				nxt.insert({ A, B + a[r] });
				nxt.insert({ A , B + a[l] });
			}
			else if (r == -1) {
				nxt.insert({ A + a[r], B });
				nxt.insert({ A + a[l], B });
				dp[A][B + a[l]] = { l + 1, r };
			}
			else {
				dp[A][B + a[r]] = { l, r - 1 };
				dp[A][B + a[l]] = { l + 1, r };
				nxt.insert({ A, B + a[l] });
				nxt.insert({ A , B + a[r] });
			}
		}
	}
	for (int A = W; A >= 0; --A) {
		for (int B = W - A; B >= 0; --B) {
			if (dp[A][B] != vector<int>(2, -1)) {
				cout << A << ' ' << B << "\n";
				break;
			}
		}
	}
}

int main() {
	ll t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}


}