#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
constexpr int inf = 1e9 + 9;
constexpr ll infll = 1e18 + 9;
constexpr ld eps = 1e-6;
constexpr int N = 2e5 + 9;
constexpr int h = 262144;
int tree[h * 2];
int ans;
void get(int v, int l, int r, int tl, int tr){
    if (l > r)
        return;
    if (tl == l && tr == r){
        ans = max(ans, tree[v]);
        return;
    }
    int tm = (tl + tr) >> 1;
    get(v * 2, l, min(r, tm), tl, tm);
    get(v * 2 + 1, max(l, tm + 1), r, tm + 1, tr);
    return;
}
vector <pair <int, int>> g[N];
set <pair <int, int>> vertex[N];
vector <int> dp[N];
int ind[N];
bool f = 1;
bool proc[N];
void dfs(int v, int p, int w){
    proc[v] = 1;
    if (!f)
        return;
    for (const auto& i: g[v]){
        if (proc[i.first])
            continue;
        if (!f)
            return;
        dfs(i.first, v, i.second);
    }
    if (v) {
        auto it = vertex[p].lower_bound({w - (*vertex[v].begin()).first, 0});
        if (it == vertex[p].end()) {
            f = 0;
            return;
        }
        dp[v][(*vertex[v].begin()).second] = p;
        dp[p][(*it).second] = v;
        vertex[p].erase(it);
    }
    return;
}
queue <int> q[N];
void solve() {
    int n, g1; cin >> n >> g1;
    vector <vector <int>> edges;
    map <pair <int, int>, int> ex;
    for (int i = 0; i < n - 1; i++){
        int u, v, w; cin >> u >> v >> w; u--; v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        edges.push_back({u, v, i});
        ex[{u, v}] = i;
        ex[{v, u}] = i;
    }
    for (int i = 0; i < n; i++){
        for (int j = 0; j < g[i].size(); j++){
            int a; cin >> a;
            vertex[i].insert({a, g[i].size() - j - 1});
        }
        dp[i].resize(vertex[i].size());
    }
    sort(edges.begin(), edges.end());
    dfs(0, -1, -1);
    if (!f) {
        cout << "NO";
        return;
    }
    cout << "YES\n";
    vector <vector <int>> out;
    for (const auto& i: edges){
        if (dp[i[0]][ind[i[0]]] == i[1] && dp[i[1]][ind[i[1]]] == i[0]){
            out.push_back(i);
        }
    }
    while (!out.empty()){
        vector <int> elem = out.back();
        cout << elem.back() + 1 << " ";
        out.pop_back();
        ind[elem[0]]++;
        ind[elem[1]]++;
        if (dp[elem[0]].size() != ind[elem[0]] && dp[dp[elem[0]][ind[elem[0]]]].size() != ind[dp[elem[0]][ind[elem[0]]]] &&
                dp[dp[elem[0]][ind[elem[0]]]][ind[dp[elem[0]][ind[elem[0]]]]] == elem[0] &&
                ex.count({dp[elem[0]][ind[elem[0]]], elem[0]})){
            out.push_back({dp[elem[0]][ind[elem[0]]], elem[0], ex[{dp[elem[0]][ind[elem[0]]], elem[0]}]});
        }
        swap(elem[1], elem[0]);
        if (dp[elem[0]].size() != ind[elem[0]] && dp[dp[elem[0]][ind[elem[0]]]].size() != ind[dp[elem[0]][ind[elem[0]]]] &&
            dp[dp[elem[0]][ind[elem[0]]]][ind[dp[elem[0]][ind[elem[0]]]]] == elem[0] &&
            ex.count({dp[elem[0]][ind[elem[0]]], elem[0]})){
            out.push_back({dp[elem[0]][ind[elem[0]]], elem[0], ex[{dp[elem[0]][ind[elem[0]]], elem[0]}]});
        }
    }
    return;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
