#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll N = 2e5 + 5;

vector<pair<ll, ll>> g[N];
vector<ll> gp[N];
ll w[N];
vector<ll> c[N];
vector<ll> col[N];
multimap<ll, ll> qp[N];
ll dg[N];
ll used_r[N];
vector<ll> order;
ll used[N];

void dfs(ll v) {
    used[v] = 1;
    for (ll u: gp[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    order.push_back(v);
}

void solve() {
    ll n, G;
    cin >> n >> G;
    for (int i = 1; i <= n - 1; ++i) {
        ll v, u;
        cin >> v >> u >> w[i];
        g[v].emplace_back(u, i);
        g[u].emplace_back(v, i);
    }
    queue<ll> del;
    for (int i = 1; i <= n; ++i) {
        ll deg = (ll) g[i].size();
        dg[i] = deg;
        c[i].resize(deg);
        col[i].assign(deg, 0);
        for (int j = 0; j < deg; ++j) {
            ll o;
            cin >> o;
            c[i][j] = o;
            qp[i].insert({o, j});
        }
        if (deg == 1) {
            del.push(i);
        }
    }
    while (!del.empty()) {
        ll v = del.front();
        del.pop();
        if (dg[v] == 0) {
            continue;
        }
        ll wc;
        ll u;
        ll num;
        for (auto &[u1, num1]: g[v]) {
            if (!used_r[num1]) {
                used_r[num1] = 1;
                wc = w[num1];
                u = u1;
                num = num1;
            }
        }
        auto [wl, kl] = *qp[v].begin();
        qp[v].erase(qp[v].begin());
        auto r = qp[u].lower_bound(wc - wl);
        if (r == qp[u].end()) {
            cout << "No";
            return;
        }
        auto [wr, kr] = *r;
        qp[u].erase(r);
        col[v][kl] = num;
        col[u][kr] = num;
        dg[v]--;
        dg[u]--;
        if (dg[u] == 1) {
            del.push(u);
        }
    }
    for (int i = 1; i <= n; ++i) {
        ll deg = (ll) g[i].size();
        for (int j = 0; j < deg - 1; ++j) {
            gp[col[i][j]].push_back(col[i][j + 1]);
        }
    }
    cout << "Yes" << '\n';
    for (int i = 1; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    for (ll u: order) {
        cout << u << " ";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
