// #define __GLIBCXX_DEBUG
// #pragma target("avx,avx2,bmi,bmi2,lzcnt,popcnt")
// #pragma optimize("unroll-loops,O3")

#include <vector>
#include <set>
#include <map>
#include <functional>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <iostream>
#include <algorithm>
#include <array>
#include <string>
#include <tuple>
#include <random>
#include <numeric>
#include <mutex>
#include <memory>
#include <locale>
#include <list>
#include <limits>
#include <iterator>
#include <functional>
#include <format>
#include <exception>
#include <ctime>
#include <ctgmath>
#include <cwchar>
#include <complex>
#include <bit>
#include <bitset>
#include <cassert>
#include <chrono>

using namespace std;
mt19937_64 rnd(179);



int n, G;
vector<vector<int>> arr;
vector<vector<pair<int, int>>> ll;
vector<vector<pair<int, int>>> g;
vector<tuple<int, int, int>> edges;
vector<int> maxAv;
bool ext = false;
vector<vector<int>> histRecover;
vector<int> pred;

int vK;
int banInd;
vector<int> usK;
vector<int> ansK;
vector<int> avVals;
vector<int> ww;
vector<int> vertexs;

bool check(vector<int> p) {
    vector<vector<int>> aa = arr;
    for (int ind : p) {
        int a = get<0>(edges[ind]);
        int b = get<1>(edges[ind]);
        int c = get<2>(edges[ind]);
        if (aa[a].back() + aa[b].back() >= c) {
            aa[a].pop_back();
            aa[b].pop_back();
        } else return false;
    }
    return true;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> G;
    arr.resize(n);
    g.resize(n);
    edges.resize(n - 1);
    ll.resize(n);
    pred.resize(n, -1);

    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        g[a].emplace_back(b, i);
        g[b].emplace_back(a, i);
        edges[i] = {a, b, c};
    }

    for (int v = 0; v < n; v++) {
        arr[v].resize(g[v].size());
        for (int& j : arr[v]) cin >> j;
        // reverse(arr[v].begin(), arr[v].end());
        for (int j = 0; j < (int)g[v].size(); j++) ll[v].emplace_back(arr[v][j], j);
        sort(ll[v].rbegin(), ll[v].rend());
    }

    vector<int> p;
    for (int i = 0; i < n - 1; i++) p.push_back(i);
    if (check(p)) {
        cout << "Yes" << endl;
        for (int i : p) cout << i + 1 << " ";
        return 0;
    }

    while (next_permutation(p.begin(), p.end())) {
        if (check(p)) {
            cout << "Yes" << endl;
            for (int i : p) cout << i + 1 << " ";
            return 0;
        }
    }

    cout << "No";
    
}