#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx,avx2")

#include <bits/stdc++.h>
using namespace std;

#define int long long

void solve() {
    int n, g;
    cin >> n >> g;
    struct sus {
        int a, b, w;
    };
    vector<sus> vec(n-1);
    vector<int> deg(n);
    for (int i = 0; i < n-1; i++) {
        cin >> vec[i].a >> vec[i].b >> vec[i].w;
        vec[i].a--, vec[i].b--;
        deg[vec[i].a]++;
        deg[vec[i].b]++;
    }

    vector<vector<int>> c(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < deg[i]; j++) {
            int t;
            cin >> t;
            c[i].push_back(t);
        }
        reverse(c[i].begin(), c[i].end());
    }

    if (g == 3) {
        for (int i = 0; i < n-1; i++) {
            vec[i].w -= c[vec[i].b][0];
        }

        vector<int> perm(n-1);
        iota(perm.begin(), perm.end(), 0ll);

        sort(perm.begin(), perm.end(), [&](int a, int b) {
            return vec[a].w < vec[b].w;
        });

        vector<int> perm2(n-1);
        iota(perm2.begin(), perm2.end(), 0ll);
        sort(perm2.begin(), perm2.end(), [&](int a, int b) {
            return c[0][a] < c[0][b];
        });

        vector<int> ans(n-1);

        bool ok = true;
        for (int i = 0; i < n-1; i++) {
            if (vec[perm[i]].w > c[0][perm2[i]]) {
                ok = false;
                break;
            }
            ans[perm2[i]] = perm[i];
        }
        if (!ok) {
            cout << "No";
            return;
        }
        cout << "Yes\n";
        for (int i = 0; i < n-1; i++) {
            cout << ans[i] + 1 << ' ';
        }
        return;
    }

    vector<int> perm(n-1);
    iota(perm.begin(), perm.end(), 0ll);
    do {
        vector<int> p(n, 0);
        bool ok = true;
        for (int i : perm) {
            sus sus = vec[i];
            if (sus.w > c[sus.a][p[sus.a]] + c[sus.b][p[sus.b]]) {
                ok = false;
                break;
            } else {
                p[sus.a]++;
                p[sus.b]++;
            }
        }
        if (ok) {
            cout << "Yes\n";
            for (int i : perm) cout << i + 1 << ' ';
            return;
        } 
    } while (next_permutation(perm.begin(), perm.end()));
    cout << "No\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve(), cout << '\n';
}