#include <bits/stdc++.h>
using namespace std;
#define int ll

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

#define Sz(e)       (int(e.size()))
#define all(e)      e.begin(), e.end()
#define pb          push_back
#define fast_io     ios::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define endll       "\n"
#define S           second
#define F           first

const ll MAXN = 3e5 + 10;

int n, g, deg[MAXN];
set<pair<pii, pii>> cons[MAXN];
set<pii> nodeg;
set<pii> c[MAXN];
int deg2[MAXN], conbec[MAXN];
vector<int> adj[MAXN];
vector<int> ans;
bool vis[MAXN];
int ccc[MAXN];


void dfs(int v){
    vis[v] = 1;
    for (auto u : adj[v]){
        if (vis[u]) continue;
        dfs(u);
    }
    ans.pb(v);
}

void del(int v){
    int u = (*cons[v].begin()).S.F;
    if (u == v) u = (*cons[v].begin()).S.S;
    int w = (*cons[v].begin()).F.F;
    int ind = (*cons[v].begin()).F.S;
    cons[u].erase(*cons[v].begin());
    cons[v].erase(cons[v].begin());
    nodeg.erase({deg[u], u});
    deg[u]--;
    nodeg.insert({deg[u], u});
    deg[v]--;
    int cv = (*c[v].begin()).F;
    conbec[(*c[v].begin()).S] = ind;
    c[v].clear();
    int mn = max(0ll, w - cv);
    auto it = c[u].lower_bound({mn, 0});
    if (it == c[u].end()){
        cout << "No" << endll;
        exit(0);
    }
    int indc = (*it).S;
    c[u].erase(it);
    conbec[indc] = ind;
}

int32_t main(){
    cin >> n >> g;
    for (int i = 1; i < n; i++){
        int v, u, w;
        cin >> v >> u >> w;
        cons[v].insert({{w, i}, {v, u}});
        cons[u].insert({{w, i}, {v, u}});
        deg[v] ++;
        deg[u] ++;
    }
    int cnt = 1;
    for (int i = 1; i <= n; i++){
        deg2[i] = deg[i];
        for (int j = 0; j < deg[i]; j++){
            int ci;
            cin >> ci;
            c[i].insert({ci, cnt++});
        }
        nodeg.insert({deg[i], i});
    }
    for (int i = 0; i < n - 1; i++){
        int v = (*nodeg.begin()).S;
        nodeg.erase(nodeg.begin());
        del(v);
    }
    cnt = 1;
    for (int i = 1; i <= n; i++){
        for (int j = 0; j < deg2[i]; j++){
            if (j < deg2[i] - 1){
                adj[conbec[cnt]].pb(conbec[cnt + 1]);
                ccc[conbec[cnt + 1]]++;
            }
            cnt++;
        }
    }
    for (int i = 1; i < n; i++){
        if (ccc[i] == 0 && !vis[i]) dfs(i);
    }
    cout << "Yes" << endl;
    for (auto i : ans) cout << i << ' ';
    cout << endl;
}