#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <ctime>

std::mt19937 rnd(std::time(nullptr));
const int INF = 1e9;
const int MAXN = 1e5;

void solve() {
    int n, k, t;
    std::cin >> n >> k >> t;
    auto mod = [&](int x) {
        int r = x % n;
        return (r < 0 ? r + n : r);
    };
    std::vector<int> a(n);
    std::set<int> s1;
    for (auto &e : a) {
        std::cin >> e;
        s1.insert(e);
    }
    if (s1.size() <= t) {
        std::cout << 1 << '\n';
        return;
    }
    std::vector<int> nxt(n, -1);
    std::multiset<int> s;
    int cnt = 0;
    int l = 0, r = 0;
    for (; l < n; l++) {
        while (cnt + (s.find(a[r]) == s.end()) <= t) {
            if (s.find(a[r]) == s.end()) {
                cnt++;
            }
            s.insert(a[r]);
            r = mod(r + 1);
        }
        nxt[l] = r;
        s.erase(s.find(a[l]));
        if (s.find(a[l]) == s.end()) {
            cnt--;
        }
    }
    /*for (auto e : nxt) {
        std::cout << e << ' ';
    }*/
    std::vector<int> used(n, 0);
    std::vector<int> len(n, -1);
    cnt = 0;
    int i = 0;
    int x = 0;
    while (cnt < k) {
        used[i] = cnt;
        len[i] = x;
        int d = cnt - used[i];
        if (used[i] || cnt + d > k || d == 0) {
            if (nxt[i] < i) {
                cnt++;
            }
            i = nxt[i];
            x++;
        } else {
            cnt += (k / d) * d;
            x += (k / d) * (x - len[i]);
        }
    }
    std::cout << x << '\n';
}

int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
//    std::cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}
