#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define int long long

vector<int> CountNode(vector<int> &n1, vector<int> &n2) {
    vector<int> c = n1;
    for (auto i: n2) {
        c.push_back(i);
    }
    std::sort(c.begin(), c.end());
    return c;
}

int get(vector<vector<int>> &t, int ind, int l, int r, int ql, int qr, int x) {
    if (l >= ql and r <= qr) {
        return std::lower_bound(t[ind].begin(), t[ind].end(), x) - t[ind].begin();
    }
    if (l >= qr or r <= ql) {
        return 0;
    }
    int mid = (l + r) / 2;
    int ans1 = get(t, ind * 2, l, mid, ql, qr, x);
    int ans2 = get(t, ind * 2 + 1, mid, r, ql, qr, x);
    return ans1 + ans2;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    cout << fixed << setprecision(12);
    int n, k, t;
    cin >> n >> k >> t;
    if (t == 1 and n * k > 1e8) {
        return 0;
    }
    vector<int> a(n);
    set<int> s;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        s.insert(a[i]);
    }
    if (s.size() <= t) {
        cout << 1 << '\n';
        return 0;
    }
    vector<int> ids(n);
    vector<int> b = a;
    for (int i = 0; i < n; i++) {
        b.push_back(a[i]);
    }
    vector<int> last(2 * n);
    map<int, int> mp;
    for (int i = 0; i < 2 * n; i++) {
        if (mp.find(b[i]) != mp.end()) {
            last[i] = mp[b[i]];
        } else {
            last[i] = -1e18;
        }
        mp[b[i]] = i;
    }
    int h = 0;
    while (1 << (++h) < 2 * n);
    vector<vector<int>> tree(1 << (h + 1));
    for (int i = 0; i < 2 * n; i++) {
        tree[i + (1 << h)].push_back(last[i]);
    }
    for (int i = (1 << h) - 1; i > 0; i--) {
        tree[i] = CountNode(tree[i * 2], tree[i * 2 + 1]);
    }
    for (int i = 0; i < n; i++) {
        int l = 1, r = n + 1;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            int cnt = get(tree, 1, 0, 1 << h, i, i + mid, i);
            if (cnt <= t) {
                l = mid;
            } else {
                r = mid;
            }
        }
        ids[i] = l;
    }
    int ans = 1;
    int id_now = 0;
    vector<bool> used(n);
    vector<pair<int, int>> cnt(n);
    while (true) {
        if (id_now + ids[id_now % n] >= n * k) {
            break;
        }
        used[id_now % n] = true;
        cnt[id_now % n] = {id_now, ans - 1};
        id_now += ids[id_now % n];
        if (used[id_now % n]) {
            break;
        }
        ans++;
    }
    if (id_now + ids[id_now % n] >= n * k) {
        cout << ans;
        return 0;
    }
    int d = n * k;
    d -= cnt[id_now % n].first;
    int d2 = d / (id_now - cnt[id_now % n].first);
    int id_next = cnt[id_now % n].first + d2 * (id_now - cnt[id_now % n].first);
    int ans2 = cnt[id_now % n].second + d2 * (ans - cnt[id_now % n].second);
    id_now = id_next;
    if (id_now < n * k) {
        ans2++;
    }
    ans = ans2;
    while (true) {
        if (id_now + ids[id_now % n] >= n * k) {
            break;
        }
        id_now += ids[id_now % n];
        ans++;
    }
    cout << ans << '\n';
}

