#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <numeric>
#include <chrono>
#include <random>
#include <bitset>
#include <immintrin.h>
#include <assert.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

ll ceil(ll a, ll b) {
    return (a - 1) / b + 1;
}

inline void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    vector<int> c;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        c.push_back(a[i]);
    }
    sort(all(c));
    for (int& i : a)
        i = lower_bound(all(c), i) - c.begin();
    vector<int> b{ a[0] };
    for (int i = 1; i < n; i++)
        if (a[i] != a[i - 1])
            b.push_back(a[i]);
    ll ans;
    if (b[0] != b.back()) {
        ans = ceil(b.size() * k, t);
    }
    else {
        b.pop_back();
        ans = ceil(b.size() * k, t);
        if (ans * t == b.size() * k)
            ans++;
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("01.dat", "r", stdin);
#endif
    int tt = 1;
#ifdef DEBUG
    cin >> tt;
#endif
    while (tt--) {
#ifdef DEBUG
        cout << "Testcase#\n";
#endif
        solve();
    }
    return 0;
}
