#include <bits/stdc++.h>
using namespace std;
//#define int int64_t
//#define double long double
//#define MULTITASK
#define NO_INTERACTIVE
void solve();
int32_t main() {
#ifdef BIBIKOV
    clock_t tStart = clock();
#ifdef NO_INTERACTIVE
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
#endif
#ifdef NO_INTERACTIVE
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int32_t tt = 1;
#ifdef MULTITASK
    cin >> tt;
#endif
    while (tt--) {
        solve();
#ifdef NO_INTERACTIVE
        cout << '\n';
#endif
    }
#ifdef BIBIKOV
    fprintf(stderr, ">> Runtime: %.10fs\n", (double_t) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
const int64_t INF = 1e18, inf = 2e9, mod = 998244353;







void solve() {
    int n, k, t, sq = 50;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    a.resize(std::unique(a.begin(), a.end()) - a.begin());
    n = a.size();
    if (2e5 < n)
        exit(139);
    set<int, greater<>> s;
    vector<int> mp(n);
    map<int, int> to;
    for (int i = 0; i < n; i++) {
        if (!to.contains(a[i]))
            to[a[i]] = to.size();
        a[i] = to[a[i]];
    }
//    for (int i = 0; i < n; i++)
//        mp[a[i]] = inf;
    vector<int> dp(n * (sq + 2)), nxt(n * (sq + 1));
    for (int it = sq + 1, nx = n * it, cnt = 0; it; it--) {
        for (int j = n * it - 1, i = n - 1; i + 1; i--, j--) {
            if (nx < mp[a[i]] || (mp[a[i]] == 0 && cnt + 1 >= t)) {
                cnt += mp[a[i]] == 0;
                s.insert(j);
                s.erase(mp[a[i]]);
                if (nx == (sq + 1) * n)
                    nx = (sq + 1) * n - 1;
                else
                    nx = *s.lower_bound(nx) - 1;
                mp[a[i]] = j;
            } else {
                cnt += mp[a[i]] == 0;
                s.erase(mp[a[i]]);
                mp[a[i]] = j;
                s.insert(mp[a[i]]);
            }
            if (nx + 1 >= n * (sq + 1))
                nxt[j] = i, dp[j] = 0;
            else
                nxt[j] = nxt[nx + 1], dp[j] = dp[nx + 1] + 1;
        }
    }
    int64_t ans = 1, lst = 0;
    for (; (lst == 0) + sq <= k;) {
        k -= (lst == 0) + sq;
        ans += dp[lst];
        lst = nxt[lst];
    }
    ans += dp[(sq + 1) * n - (k + 1) * n + (lst ? lst : n)];
    cout << ans;
}
