#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxn = 2e5 + 10;
const int inf = 1e9 + 10;


void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> b = a;
    sort(b.begin(), b.end());
    b.resize(unique(b.begin(), b.end()) - b.begin());
    if (b.size() <= t) {
        cout << 1;
        return;
    }
    for (int i = 0; i < n; i++) {
        a[i] = lower_bound(b.begin(), b.end(), a[i]) - b.begin();
    }
    vector<ll> next(n), len(n);
    ll nxt = 0;
    vector<int> cnt(b.size(), 0);
    int x = 0;
    for (int i = 0; i < n; i++) {
        while (x <= t) {
            cnt[a[nxt]]++;
            if (cnt[a[nxt]] == 1) {
                if (x == t) {
                    cnt[a[nxt]]--;
                    break;
                }
                x++;
            }
            nxt = (nxt + 1)%n;
        }

        next[i] = nxt;

        cnt[a[i]]--;
        if (cnt[a[i]] == 0) {
            x--;
        }
    }
    for (int i = 0; i < n; i++) {
        len[i] = (next[i] - i + n)%n;
    }


    //next works

    vector<pll> pos(n, {-1, -1});
    nxt = 0;
    ll ksc = 0;
    pll per;
    while (nxt < k*n) {
        if (pos[nxt%n].first != -1) {
            per = {nxt - pos[nxt%n].first, ksc - pos[nxt%n].second};
            break;
        }
        pos[nxt%n].first = nxt;
        pos[nxt%n].second = ksc;
        ksc++;
        nxt += len[nxt%n];
    }

    if (nxt >= k*n) {
        cout << ksc;
        return;
    }

    ksc += ((k*n - nxt)/per.first)*per.second;
    nxt += ((k*n - nxt)/per.first)*per.first;

    while (nxt < k*n) {
        ksc++;
        nxt += len[nxt%n];
    }

    cout << ksc;
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
