#include <iostream>
#include <algorithm>
#include <numeric>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <cctype>
#include <iomanip>
#include <queue>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pri = pair<int, int>;

istream& operator>>(istream& in, vector<int>& a) {
	for (auto& i : a) {
		in >> i;
	}
	return in;
}

ostream& operator >>(ostream& out, vector<int>& a) {
	for (auto& i : a) {
		out << i << ' ';
	}
	out << '\n';
	return out;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	ll n, k, t;
	cin >> n >> k >> t;
	vector<int> a(n);
	cin >> a;
	map<int, int> mp;
	int cnt = 1;
	vector<int> vec(n);
	mp[a[0]] = 0;
	for (int i = 1; i < n; i++) {
		if (!mp.count(a[i])) {
			mp[a[i]] = cnt++;
		}
	}
	for (int i = 0; i < n; i++) {
		vec[i] = mp[a[i]];
	}
	if (cnt <= t) {
		cout << 1;
		exit(0);
	}
	vector<int> ended(n);
	vector<ll> lens(n);
	vector<ll> types(cnt);
	int rgt = 0;
	ll now_diff = 0;
	for (; now_diff <= t; ++rgt) {
		types[vec[rgt]]++;
		if (types[vec[rgt]] == 1) {
			now_diff++;
			if (now_diff > t) {
				--now_diff;
				types[vec[rgt]]--;
				break;
			}
		}
	}
	ll len = rgt;
	ended[0] = rgt;
	lens[0] = rgt;
	for (int i = 1; i < n; i++) {
		types[vec[i - 1]]--;
		--len;
		if (types[vec[i - 1]] == 0) {
			now_diff--;
		}
		for (; now_diff <= t; rgt = (rgt + 1) % n) {
			types[vec[rgt]]++;
			++len;
			if (types[vec[rgt]] == 1) {
				now_diff++;
				if (now_diff > t) {
					--now_diff;
					--len;
					types[vec[rgt]]--;
					break;
				}
			}
		}
		ended[i] = rgt;
		lens[i] = len;
	}
	vector<int> times(n, -1);
	vector<ll> l_bef(n, -1);
	times[0] = 0;
	l_bef[0] = 0;
	ll time = 1;
	ll now = 0;
	while (times[ended[now]] == -1) {
		l_bef[ended[now]] = l_bef[now] + lens[now];
		now = ended[now];
		times[now] = time++;
	}
	ll ans = times[ended[now]];
	ll was = l_bef[ended[now]];

	ll cnt_per = time - times[ended[now]];
	ll period = l_bef[now] + lens[now] - l_bef[ended[now]];
	ans += (1ll * k * n - was) / period * cnt_per;
	ll ost = (1ll * k * n - was) % period;
	now = ost % n;
	while (ost > 0) {
		++ans;
		ost -= lens[now];
		now = ended[now];
	}
	cout << ans;
}