#include <iostream>
#include <vector>
#include <set>
#include <map>

using ll = long long;
using ld = long double;

using namespace std;

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> v(n);
    for (int& x : v)
        cin >> x;
    vector<int> to(n);
    set<int> st;
    for (int x : v)
        st.insert(x);
    if (st.size() <= t) {
        cout << 1;
        return;
    }
    for (int i = 0; i < n; i++) {
        st.clear();
        int j = i;
        while (st.size() <= t) {
            st.insert(v[j]);
            j++;
            if (j == n)
                j = 0;
        }
        if (j)
            to[i] = j - 1;
        else
            to[i] = n - 1;
    }
    int i = 0;
    ll boxes = 1, cnt = 1;
    map<int, int> cost, b;
    while (cost.find(to[i]) == cost.end()) {
        cost[i] = (int)cnt - 1;
        b[i] = boxes;
        if (to[i] < i)
            boxes++;
        i = to[i];
        cnt++;
    }
    i = to[i];
    boxes -= b[i] - 1;
    ll ans = cost[i] + (ll)(k - 1) / boxes * (cnt - cost[i]);
    ll r = (ll)(k - 1) % boxes + 1;
    boxes = 0;
    while (boxes < r) {
        if (to[i] < i)
            boxes++;
        i = to[i];
        ans++;
    }
    cout << ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
