//#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int &i : a)
        cin >> i;
    if (set(all(a)).size() <= t) {
        cout << 1;
        return;
    }
    vector<int> b = a;
    for (int i : a)
        b.push_back(i);
    vector<pair<int, int>> next(n);
    map<int, int> cnt;
    int r = -1;
    for (int l = 0; l < n; ++l) {
        if (r < l) {
            r = l;
            cnt.clear();
            cnt[b[l]] = 1;
        }
        while (r + 1 < 2 * n) {
            if (cnt.count(b[r + 1])) {
                ++cnt[b[r + 1]];
                ++r;
                continue;
            }
            if (cnt.size() + 1 <= t) {
                ++cnt[b[r + 1]];
                ++r;
                continue;
            }
            break;
        }
        next[l] = {(r + 1) % n, r - l + 1};
        --cnt[b[l]];
        if (cnt[b[l]] == 0)
            cnt.erase(b[l]);
    }
    int now = 0, sum = 0, res = 0;
    while (sum < n * k) {
        sum += next[now].second;
        now = next[now].first;
        ++res;
    }
    cout << res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
