#include <bits/stdc++.h>
using namespace std;

template <typename T>
istream &operator>>(istream &in, vector <T> &vec) {
    for (auto &el : vec) {
        in >> el;
    }
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector <T> &vec) {
    for (auto el : vec) {
        out << el << ' ';
    }
    out << '\n';
    return out;
}

using ll = long long;
using pll = pair <long long, long long>;
using ull = unsigned long long;

#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

void solution() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector <ll> a(n);
    cin >> a;

    vector <ll> ac = a;
    sort(all(ac));
    ll dif = unique(all(ac)) - ac.begin();
    if (dif <= t) {
        cout << 1;
        return;
    }

    for (ll i = 0; i < n; ++i) {
        a.emplace_back(a[i]);
    }

    map <ll, ll> in;
    ll r = 0, cnt = 0;
    vector <ll> next(n);
    for (ll l = 0; l < n; ++l) {
        while (cnt <= t) {
            if (in[a[r]] == 0) {
                ++cnt;
            }
            ++in[a[r]], ++r;
        }

        if (in[a[l]] == 1) {
            --cnt;
        }
        --in[a[l]];

        next[l] = (r - 1) % n;
    }

    cnt = 0;
    ll act = 0, cyc_val, cyc_cnt, beg;
    vector <ll> dist(n, -1), loc(n, 0);
    for (ll i = 0; true; i = next[i], ++cnt) {
        if (dist[i] != -1) {
            beg = i;
            cyc_val = act - dist[i];
            cyc_cnt = cnt - loc[i];
            break;
        }

        ll tmp = next[i] - i;
        if (tmp < 0) {
            tmp += n;
        }
        loc[i] = cnt;
        dist[i] = act, act += tmp;
    }

    ll need = n * k, ans = 0;
    if (n * k > act) {
        ans += loc[beg];
        need -= dist[beg];

        ll tmp = need / cyc_val;
        ans += cyc_cnt * tmp;
        need -= cyc_val * tmp;
    }

    for (ll i = beg; need > 0; i = next[i], ++ans) {
        ll tmp = next[i] - i;
        if (tmp < 0) {
            tmp += n;
        }
        need -= tmp;
    }

    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solution();

    return 0;
}