#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <math.h>
#include <algorithm>
#include <queue>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

void solve() {
	ll n, k1, t, i, j, p, ans = 0;
	cin >> n >> k1 >> t;
	vector <ll> a(n);
	for (i = 0; i < n; i++) cin >> a[i];
	vector <ll> c;
	c.push_back(a[0]);
	for (i = 1; i < n; i++) if (a[i] != a[i - 1]) c.push_back(a[i]);

	set <ll> d;
	for (i = 0; i < c.size(); i++) d.insert(c[i]);

	if (d.size() <= t) {
		cout << 1;
		return;
	}

	vector <ll> b(c.size());
	map <ll, ll> k;
	p = 0;
	for (i = 0; i < c.size(); i++) {
		if (k[c[i]] > 0 || (k[c[i]] == 0 && p + 1 <= t)) {
			k[c[i]]++;
			if (k[c[i]] == 1) p++;
			j = i;
		}
		else {
			break;
		}
	}
	b[0] = j;
	j++;
	for (i = 1; i < c.size(); i++) {
		k[c[i - 1]]--;
		if (k[c[i - 1]] == 0) p--;
		while (k[c[j]] > 0 || (k[c[j]] == 0 && p < t)) {
			k[c[j]]++;
			if (k[c[j]] == 1) p++;
			j = (j + 1) % c.size();
		}
		b[i] = (j - 1 + c.size()) % c.size();
	}

	ll p1 = 0, p2 = 0, ni;
	vector <ll> used(c.size());
	vector <pair<ll, ll> > pref(c.size());
	pref[0] = { 0, 0 };
	i = 0;
	used[0] = 1;
	while (true) {
		ni = (b[i] + 1) % c.size();
		p1++;
		if (ni < i) p2++;

		if (p2 >= k1) {
			cout << p1;
			return;
		}

		if (used[ni] == 1) {
			p1 -= pref[ni].first;
			p2 -= pref[ni].second;
			break;
		}
		else {
			used[ni] = 1;
			pref[ni].first = pref[i].first + 1;
			pref[ni].second = pref[i].second;
			if (ni < i) pref[ni].second++;
			i = ni;
		}
	}

	p = (k1 - pref[ni].second - 1) / p2;
	ans = pref[ni].first + p * p1;
	p2 = 1 + pref[ni].second + p * p2;
	i = ni;
	while (true) {
		ni = (b[i] + 1) % c.size();
		ans++;
		if (ni < i) p2++;
		if (p2 > k1) {
			cout << ans;
			return;
		}
		i = ni;
	}
	cout << ans;
}

int main() {
	ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
	ll t = 1;
	//cin >> t;
	while (t--) solve();
}
