#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 2e5;
const int INF = 2e9;
const int mod = 1e9 + 7;



int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll n, k, t;
    cin >> n >> k >> t;
    vector<int> a(2 * n);
    set<int> s;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i + n] = a[i];
        s.insert(a[i]);
    }
    if (s.size() <= t) {
        cout << 1;
        return 0;
    }
    vector<int> next(n);
    map<int, int> cnt;
    int diff = 0;
    int j = 0;
    while (true) {
        cnt[a[j]]++;
        if (cnt[a[j]] == 1) {
            diff++;
        }
        if (diff > t) {
            cnt[a[j]]--;
            diff--;
            break;
        }
        j++;
    }
    for (int i = 0; i < n; i++) {
        next[i] = j;
        cnt[a[i]]--;
        if (cnt[a[i]] == 0) {
            diff--;
        }
        while (true) {
            cnt[a[j]]++;
            if (cnt[a[j]] == 1) {
                diff++;
            }
            if (diff > t) {
                cnt[a[j]]--;
                diff--;
                break;
            }
            j++;
        }
    }
    set<int> used;
    int i = 0;
    ll rem = k * n;
    ll ans = 0;
    while (rem > 0) {
        if (used.find(i) != used.end()) {
            break;
        }
        used.insert(i);
        rem -= next[i] - i;
        ans++;
        i = next[i] % n;
    }
    if (rem > 0) {
        ll p = 0;
        int i0 = i;
        ll ans1 = 0;
        while (true) {
            p += next[i] - i;
            ans1++;
            i = next[i] % n; 
            if (i0 == i) {
                break;
            }
        }
        ans += rem / p * ans1;
        rem %= p;
        while (rem > 0) {
            rem -= next[i] - i;
            ans++;
            i = next[i] % n;
        }
    }
    cout << ans;
}
