#ifndef SYSTY257
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

template<typename t1, typename t2>
void mnr(t1 &a, const t2 &b) {
    if (b < a) {
        a = b;
    }
}

template<typename t1, typename t2>
void mxr(t1 &a, const t2 &b) {
    if (b > a) {
        a = b;
    }
}

signed main() {
    cout << setprecision(15) << fixed;
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> v(n);
    for (auto &i: v) {
        cin >> i;
    }
    int m;
    {
        auto v2 = v;
        sort(all(v2));
        v2.resize(unique(all(v2)) - v2.begin());
        for (auto &i: v) {
            i = lower_bound(all(v2), i) - v2.begin();
        }
        m = sz(v2);
    }
    if (t >= m) {
        cout << 1;
        return 0;
    }
    auto v2 = v;
    v.insert(v.end(), all(v2));
    vector<int> maxr(n);
    int l = 0, r = -1;
    vector<int> cnt(m);
    int not0 = 0;
    auto add = [&](int i, int x) {
        if (x == -1) {
            if (cnt[i] == 1) {
                --not0;
            }
        } else {
            if (cnt[i] == 0) {
                ++not0;
            }
        }
        cnt[i] += x;
    };
    for (; l < n; ++l) {
        while (not0 <= t) {
            add(v[r + 1], 1);
            ++r;
        }
        maxr[l] = r;
        add(v[l], -1);
    }
    int cyclesize = 0;
    int i = 0;
    int width = 0;
    vector<int> cycle;
    vector <bool> used(n);
    do {
        used[i] = true;
        cycle.push_back(i);
        ++cyclesize;
        if (maxr[i] % n < i) {
            ++width;
        }
        i = maxr[i] % n;
    } while (!used[i]);
    if (k <= width) {
        int res = ((k - 1) / width) * cyclesize;
        int sum = 0;
        for (auto j: cycle) {
            if (sum >= k) {
                break;
            }
            ++res;
            if (maxr[j] % n < j) {
                ++sum;
            }
        }
        cout << res;
        return 0;
    }
    k -= width;
    int res = sz(cycle);
    vector <int> c2;
    int width2 = 0;
    bool f = false;
    for (auto j : cycle) {
        if (j == i) {
            f = true;
        }
        if (f) {
            if (maxr[j] % n < j) {
                ++width2;
            }
            c2.push_back(j);
        }
    }
    res += (k - 1) / width2 * sz(c2);
    k %= width2;
    if (!k) {
        k += width2;
    }
    int sum = 0;
    for (auto j : c2) {
        if (sum >= k) {
            break;
        }
        ++res;
        if (maxr[j] % n < j) {
            ++sum;
        }
    }
    cout << res;
}