#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;

    vector<int> c = a;
    sort(all(c));
    c.resize(unique(all(c)) - c.begin());
    for (auto& i : a)
        i = lower_bound(all(c), i) - c.begin();

    vector<int> tmp(n);
    for (auto i : a)
        ++tmp[i];
    int tmp_cnt = 0;
    for (auto i : tmp)
        tmp_cnt += i > 0;

    if (tmp_cnt <= t) {
        cout << 1 << endl;
        return;
    }

    vector<int> b = a;
    for (auto i : a)
        b.push_back(i);

    vector<int> to(2 * n);
    int r = 0, cnt = 0;
    vector<int> sc(n);
    for (int l = 0; l < 2 * n; ++l) {
        while (r < 2 * n && cnt <= t) {
            if (cnt + (sc[b[r]] == 0) <= t) {
                if (++sc[b[r]] == 1)
                    ++cnt;
                ++r;
            } else {
                break;
            }
        }

        to[l] = r;
        if (--sc[b[l]] == 0)
            --cnt;
    }

    //for (auto i : to)
    //    cout << i << " ";
    //cout << endl;

    for (int i = 0; i < n; ++i)
        to[i] = to[i] % n;

    int st = -1;
    vector<bool> used(n);
    for (int i = 0; ; i = to[i]) {
        if (used[i]) {
            st = i;
            break;
        }
        used[i] = 1;
    }

    auto dist = [&](int i)->int {
        return to[i] > i ? to[i] - i : n - (i - to[i]);
    };

    int tos = 0, tos_cnt = 0;
    for (int i = 0; i != st; i = to[i]) {
        ++tos_cnt;
        tos += dist(i);
    }

    int cyc = 0, cyc_cnt = 0;
    for (int i = st; ; i = to[i]) {
        cyc += dist(i);
        ++cyc_cnt;
        //cout << "! " << cyc << " " << i << endl;
        if (to[i] == st)
            break;
    }

    //cout << st << " " << tos << " " << cyc << endl;
    //cout << cyc_cnt << endl;
    /*
    int ans = 0;
    int curl = 0;
    for (int i = 0; curl < n * k; i = to[i]) {
        ans += 1;
        curl += dist(i);
    }
    cout << ans << endl;
    */

    int ans = 0;
    if (n * k <= tos) {
        int curl = 0;
        for (int i = 0; curl < n * k; i = to[i]) {
            ans += 1;
            curl += to[i] > i ? to[i] - i : n - (i - to[i]);
        }
    } else {
        ans = ((n * k - tos) / cyc) * cyc_cnt + tos_cnt;
        int curl = n * k - (((n * k - tos) / cyc) * cyc + tos);
        for (int i = st; curl > 0; i = to[i]) {
            curl -= to[i] > i ? to[i] - i : n - (i - to[i]);
            ++ans;
        }
    }
    cout << ans << endl;

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}
/*
4 3 100
1 2 3 4
 */