#include "bits/stdc++.h"

using namespace std;

const int LOG = 50;
using ll = long long;
using i128 = __int128;
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n, k, t;
    cin >> n >> k >> t;

    vector<int> a(n);
    vector<int> comp;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        comp.push_back(a[i]);
    }
    std::sort(comp.begin(), comp.end());
    comp.erase(std::unique(comp.begin(), comp.end()), comp.end());

    for (int i = 0; i < n; ++i) {
        a[i] = std::lower_bound(comp.begin(), comp.end(), a[i]) - comp.begin();
    }

    if (t == 1) {
        if (*std::min_element(a.begin(), a.end()) == *std::max_element(a.begin(), a.end())) {
            cout << 1 << "\n";
            return 0;
        }

        vector<int> da;
        for (int i = 0; i < 2 * n; ++i) da.push_back(a[i % n]);

        vector<int> step(2 * n, 1);
        for (int i = 2 * n - 2; i >= 0; --i) {
            if (da[i + 1] == da[i]) step[i] = step[i + 1] + 1;
            else step[i] = 1;
        }

        vector<vector<pair<ll, i128>>> bp(n, vector<pair<ll, i128>>(LOG));
        for (ll i = 0; i < n; ++i) {
            bp[i][0] = {(i + step[i]) % n, step[i]};
        }
        for (ll i = 1; i < LOG; ++i) {
            for (ll j = 0; j < n; ++j) {
                bp[j][i].first = bp[bp[j][i - 1].first][i - 1].first;
                bp[j][i].second = bp[j][i - 1].second + bp[bp[j][i - 1].first][i - 1].second;
            }
        }

        ll ost = n * k;
        int curr = 0;
        int ans = 0;
        for (ll pw = LOG - 1; pw >= 0; --pw) {
            if (bp[curr][pw].second < ost) {
                ans += (1ll << pw);
                ost -= bp[curr][pw].second;
                curr = bp[curr][pw].first;
            }
        }

        while (ost > 0) {
            ost -= step[curr];
            curr = (curr + step[curr]) % n;
            ans++;
        }

        cout << ans << "\n";
    } else {
        vector<int> b;
        for (int i = 0; i < k; ++i) {
            for (int j = 0; j < n; ++j) {
                b.push_back(a[j]);
            }
        }
        ll ans = 0;
        ll l = 0;
        ll curr = 0;
        vector<int> cnt(n);
        for (int i = 0; i < n * k; ++i) {
            if (cnt[b[i]] == 0 && curr + 1 > t) {
                ans++;
                for (int j = l; j < i; ++j) {
                    cnt[b[j]]--;
                }
                curr = 0;
                l = i;
            }
            curr += cnt[b[i]] == 0;
            cnt[b[i]]++;
        }
        cout << ans + 1 << "\n";
    }
}