#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int cur_bal = 0;
map <int, int> bal;
void add(int x) {
    if (bal[x] == 0) {
       cur_bal++;
    }
    bal[x]++;
}
void del(int x) {
    if (bal[x] == 1) {
        cur_bal--;
    }
    bal[x]--;
}

vector <int> used;
vector <int> dp;
vector <int> cost;
ll cost_cycle = 0;
ll len_cycle = 0;
ll cycle_v = 0;
ll cur_ans = 0;
ll cur_x = 0;
int fl = 0;

void dfs(int v) {
    used[v] = 1;
    int to = dp[v];
    if (!used[to]) {
        dfs(to);
    } else {
        used[to] = 2;
        cycle_v = to;
    }
}

void find_cost_path(int v) {
    int to = dp[v];
    ll c = cost[v];
    if (used[v] != 2) {
        if (cur_x - c > 0) {
            cur_x -= c;
            cur_ans++;
            find_cost_path(to);
        } else {
            fl = 1;
        }
    }
}

void find_cost_cycle(int v) {
    int to = dp[v];
    int c = cost[v];
    cost_cycle += c;
    len_cycle++;
    if (used[to] != 2) {
        find_cost_cycle(to);
    }
}

void find_ost_cycle(int v) {
    int to = dp[v];
    int c = cost[v];
    if (cur_x == 0) return;
    if (cur_x - c <= 0) {
        cur_ans++;
        cur_x = 0;
    } else {
        cur_x -= c;
        cur_ans++;
        find_ost_cycle(to);
    }
}

void find_ans(ll x) {
    dfs(0);
    cur_x = x;
    find_cost_cycle(cycle_v);
    if (used[0] != 2) {
        find_cost_path(0);
    }
    if (!fl) {
        cur_ans += ((cur_x) / cost_cycle) * len_cycle;
        cur_x %= cost_cycle;
    }
    find_ost_cycle(cycle_v);
}


void solve() {
    int n, k, t; cin >> n >> k >> t;
    vector <int> a(n, 0);
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        a[i] = x;
    }
    int j = 0;
    int last_len = 1;
    dp.assign(n, 0);
    cost.assign(n, 0);
    for (int i = 0; i < n; i++) {
        int len = last_len - 1;

        while (cur_bal <= t) {
            add(a[j]);
            j++;
            j %= n;
            len++;
            if (len == n + 1) {
                cout << 1 << endl;
                return;
            }
        }
        j--;
        j += n;
        j %= n;
        len--;
        dp[i] = j;
        cost[i] = len;
        del(a[j]);
        del(a[i]);
        last_len = len;
    }
    ll all_n = 1ll * n * k;
    find_ans(all_n);
    cout << cur_ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    while (test--) {
        solve();
    }
}
