#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define klm ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()

void solve(){
    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll>v(n), pos(n);
    gp_hash_table<ll, ll> mp;
    for(int i = 0; i < n; ++i){
        cin >> v[i];
        mp[v[i]]++;
    }
    if (t >= sz(mp)){
        cout << 1;
        return;
    }
    mp.clear();
    ll j = 0, cnt = 0;
    for(int i = 0; i < n; ++i){
        while(cnt <= t){
            ++mp[v[j]];
            cnt += (mp[v[j]] == 1);
            j = (j + 1) % n;
        }
        pos[i] = (j + n - 2) % n;
        --mp[v[i]];
        cnt -= (mp[v[i]] == 0);
    }

    ll logn = 31;

    vector<vector<pair<ll, ll>>>dp(logn, vector<pair<ll, ll>>(n));

    for(int i = n - 1; i >= 0; --i){
        if (pos[i] == n - 1 || pos[i] < i){
            dp[0][i] = {1, (pos[i] + 1) % n};
        } else{
            ll pos1 = pos[i] + 1;
            dp[0][i] = dp[0][pos1];
            ++dp[0][i].first;
        }
    }

    for(int j = 1; j < logn; ++j){
        for(int i = n - 1; i >= 0; --i){
            ll bro = dp[j - 1][i].second, gg = dp[j - 1][i].first + dp[j - 1][bro].first;
            dp[j][i].first = gg;
            dp[j][i].second = dp[j - 1][bro].second;
        }
    }
    ll ans = 0, pos1 = 0, cur = 0;
    for(int i = logn - 1; i >= 0; --i){
        if ((1 << i) + cur <= k){
            ans += dp[i][pos1].first;
            pos1 = dp[i][pos1].second;
            cur += (1 << i);
        }
    }
    cout << ans << '\n';
}

int main(){
    ll t = 1;
    klm;
    //freopen("/home/olymp/Desktop/negr/input.txt", "r", stdin);
    //freopen("/home/olymp/Desktop/negr/output.txt", "w", stdout);

    //cin >> t;

    while(t--){
        solve();
    }
    return 0;
}