#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
istream& operator >>(istream& in, pair<T, T1> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T, typename T1>
ostream& operator <<(ostream& out, pair<T, T1> &arr) {
    out << arr.ff << " " << arr.ss << " ";
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<T> &arr) {
    for (auto i : arr) out << i << " ";
    return out;
}

void solve() {
    int n, k, t; cin >> n >> k >> t;
    vector<int> s(n); cin >> s;

    vector<int> rz;
    for (int i = 0; i < n; i++) {
        if (i == 0 || rz.back() != s[i]) rz.pb(s[i]);
    }
    n = sz(rz);
    for (int i = 0; i < sz(s); i++) {
        if (rz.back() != s[i]) rz.pb(s[i]);
    }
    int dln = sz(rz) - n;
    if (t == 1) {
        cout << n + dln * (k - 1);
        return;
    }

    vector<int> z(n);
    map<int, int> d;

    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (d.count(rz[i]) == 0) cnt++;
        d[rz[i]] = i;

        if (cnt == t + 1) {
            z[0] = i - 1; break;
        }

        if (i == n - 1) {
            cout << "1\n";
            return;
        }
    }
    for (int i = 1; i < n; i++) {
        int r = max(i, z[i - 1]);

        int f = 0;
        while (r < sz(rz)) {
            int a = rz[r];
            if (d.count(a) == 0 || d[a] < i) {
                if (!f) f = 1;
                else break;
            }
            d[a] = r;

            r++;
        }
        z[i] = r;
    }

    //cout << rz << "\n";
    cout << z << "\n";


    vector<pii> sl(n + 1);
    sl[n] = {sz(rz) != 2 * n, 0};
    for (int i = n - 1; i > -1; i--) {
        if (z[i] >= n) sl[i] = {(z[i] + 1) - n + (sz(rz) != 2 * n), 0};
        else sl[i] = sl[z[i] + 1];

        sl[i].ss++;
    }
    //cout << sl << "\n";

    vector<int> used(n), pr(n + 1);
    int p = 0, sm = 0, dl = 0;
    for (int i = 0; i < n; i++) {
        used[p] = 1; sm += sl[p].ss;
        dl++;

        pr[dl] = sm;

        if (dl == k) {
            cout << sm << "\n";
            return;
        }

        p = sl[p].ff;
        if (used[p]) break;
    }

    cout << sm * (k / dl) + pr[k % dl] << "\n";
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double time = clock();
#endif

    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "---------------\n";
#endif
    }
#ifdef LOCAL
    cout << "time:" << (clock() - time) / CLOCKS_PER_SEC << "\n";
#endif
}