#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
istream& operator >>(istream& in, pair<T, T1> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T, typename T1>
ostream& operator <<(ostream& out, pair<T, T1> &arr) {
    for (auto i : arr) out << i << " ";
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<T> &arr) {
    for (auto i : arr) out << i << " ";
    return out;
}

void solve() {
    int n, k, t; cin >> n >> k >> t;
    vector<int> s(n); cin >> s;

    if (t == 1) {
        s.rs(unique(s.begin(), s.end()) - s.begin());
        cout << sz(s) * k - (k - 1) * (s[0] == s.back()) << "\n";
        return;
    }

    int cnt = 0, ans = 0;
    set<int> s1;
    for (int i = 0; i < n * k; i++) {
        if (s1.find(s[i % n]) == s1.end()) {
            cnt++;

            if (cnt == t + 1) {
                ans++; cnt = 1;
                s1.clear();
            }
            s1.insert(s[i % n]);
        }
    }

    cout << ans + (cnt > 0);
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double time = clock();
#endif

    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "---------------\n";
#endif
    }
#ifdef LOCAL
    cout << "time:" << (clock() - time) / CLOCKS_PER_SEC << "\n";
#endif
}