#define debug(x) cout<<(#x)<<" = "<<x;
#define all(x) (x).begin(),(x).end()
#include <iostream>
#include <cstdlib>
#include <cstdint>
#include <algorithm>
#include <numeric>
#include <cstdint>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
using namespace std;
using ll = int64_t;
using ull = uint64_t;

const int N = 3e5;
const int logc = 30;

struct to {
    int dest = -1;
    ll d = 0;
    ll cnt = 0;

    to() {}
    to(int dest, ll d, ll cnt) : dest(dest), d(d), cnt(cnt) {}
};

to up[logc][N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    ll k, t;
    cin >> n >> k >> t;
    int a[n];
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<int> acomp;
    acomp.reserve(n);
    for (int i = 0; i < n;) {
        int len = 1;
        while (i + len < n && a[i] == a[i + len]) ++len;
        acomp.push_back(a[i]);
        i += len;
    }
    acomp.shrink_to_fit();
    int r = acomp.size();
    // check full
    set<int> dif;
    for (int x : acomp) dif.insert(x);
    if (dif.size() <= t) {
        cout << 1;
        return 0;
    }
    int d[r];
    map<int, int> cnt;
    auto add = [&](int a) -> void {
        ++cnt[a];
    };
    auto del = [&](int a) -> void {
        --cnt[a];
        if (cnt[a] == 0) cnt.erase(a);
    };
    int fin = 1;
    auto dist = [&](int a, int b) -> int {
        if (a < b) return b - a;
        return r - abs(a - b);
    };
    add(acomp[0]);
    for (int i = 0; i < r; ++i) {
        d[i] = dist(i, fin);
        while (cnt.count(acomp[fin]) > 0 || cnt.size() + 1 <= t) {
            add(acomp[fin]);
            ++fin;
            if (fin == r) fin = 0;
            ++d[i];
        }
        d[i] = (i + d[i]) % r;
        del(acomp[i]);
    }
    for (int i = 0; i < n; ++i) {
        up[0][i] = to(d[i], dist(i, d[i]), 1);
    }
    for (int j = 1; j < logc; ++j) {
        for (int i = 0; i < n; ++i) {
            auto& cur = up[j - 1][i];
            auto& nxt = up[j - 1][cur.dest];
            up[j][i].dest = nxt.dest;
            up[j][i].d = cur.d + nxt.d;
            up[j][i].cnt = cur.cnt + nxt.cnt;
        }
    }
    ll sub = r * k;
    ll res = 0;
    int i = 0;
    for (int j = logc - 1; j > -1 && sub > 0; --j) {
        if (up[j][i].d <= sub) {
            auto& q = up[j][i];
            sub -= up[j][i].d;
            res += up[j][i].cnt;
            i = up[j][i].dest;
        }
    }
    if (sub > 0) {
        ++res;
    }
    cout << res;
}
