#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

struct grib
{
    vector<int> cnt;
    int ans;

    grib(int n)
    {
        cnt.resize(n);
        ans = 0;
    }

    void upd(int x, int d)
    {
        if(cnt[x] != 0)
        {
            --ans;
        }
        cnt[x] += d;
        if(cnt[x] != 0)
        {
            ++ans;
        }
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n, k, t;

    cin >> n >> k >> t;

    vector<int> a(n);
    vector<int> coord;

    for(int i = 0; i < n; ++i)
    {
        cin >> a[i];
        coord.push_back(a[i]);
    }

    sort(coord.begin(), coord.end());
    coord.resize(unique(coord.begin(), coord.end()) - coord.begin());
    for(int i = 0; i < n; ++i)
    {
        a[i] = lower_bound(coord.begin(), coord.end(), a[i]) - coord.begin();
    }

    if(coord.size() <= t)
    {
        cout << "1\n";
        return 0;
    }

    vector<pair<int, int>> link(n);


    {
        grib gg(coord.size());
        int r = 0;
        gg.upd(a[0], 1);
        for(int l = 0; l < n; ++l)
        {
            while(gg.ans <= t)
            {
                r += 1;
                r %= n;
                gg.upd(a[r], 1);
            }
            gg.upd(a[r], -1);
            r = r - 1 + n;
            r %= n;

            int dst = 0;

            if(l <= r)
            {
                dst = r - l + 1;
            } else {
                dst = r + n - l + 1;
            }


            link[l] = {r, dst};
            gg.upd(a[l], -1);
        }
    }

    vector<vector<pair<int, ll>>> binup(50, vector<pair<int, ll>>(n));

    for(int i = 0; i < n; ++i)
    {
        binup[0][i] = {(link[i].first + 1) % n, link[i].second};
    }

    for(int lvl = 1; lvl < binup.size(); ++lvl)
    {
        for(int i = 0; i < n; ++i)
        {
            binup[lvl][i].first = binup[lvl-1][binup[lvl-1][i].first].first;
            binup[lvl][i].second = binup[lvl-1][binup[lvl-1][i].first].second + binup[lvl-1][i].second;
        }
    }

    int v = 0;
    ll sz = n * k;

    ll ans = 0;

    for(int lvl = binup.size() - 1; lvl >= 0; --lvl)
    {
        if(binup[lvl][v].second <= sz)
        {
            sz -= binup[lvl][v].second;
            v = binup[lvl][v].first;
            ans += ((ll)1) << ((ll)lvl);
        }
    }

    if(sz > 0)
    {
        ++ans;
    }

    cout << ans << '\n';



}