#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <numeric>
#include <iomanip>
#include <stack>
#include <deque>
#include <random>

typedef long long ll;

using namespace std;

const ll INF = 2e9;
const ll MAXN = 1e5 + 5;

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    
    if (t >= 100) {
        exit(1);
    }
    
    vector<ll> a;
    for (ll i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        if (i == 0 || a.back() != x) {
            a.push_back(x);
        }
    }

    n = (ll)a.size();

    ll K = n * k;
    if (a[0] == a[n - 1]) {
        K = (n - 1) * (k - 1) + n;
    }

    cout << (K + t - 1) / t << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef WIN32
    freopen("in", "r", stdin);
#endif

    ll T = 1;
#ifdef WIN32
    cin >> T;
#endif
    while (T --> 0) {
        solve();
    }

    return 0;
}
