#include <bits/stdc++.h>
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...) 52
#endif
#define int long long
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k, t;
    cin >> n >> k >> t;

    vector<int> a(n);
    map<int, int> b;
    for (int i = 0; i < n; i++) {
        cin >> a[i];

        if (!b.contains(a[i])) {
            int j = (int)b.size();
            b[a[i]] = j;
        }
    }

    for (int i = 0; i < n; i++) {
        a[i] = b[a[i]];
    }

    if (b.size() <= t) {
        cout << 1 << '\n';
        return 0;
    }

    vector<int> c;

    for (int &i : a) {
        c.push_back(i);
    }

    for (int &i : a) {
        c.push_back(i);
    }

    int r = -1;

    map<int, int> cnt;

    vector<vector<int>> up(61, vector<int>(n));
    vector<vector<int>> vl(61, vector<int>(n));


    for (int l = 0; l < n; l++) {
        if (r < l) {
            r = l;
            cnt[c[l]]++;
        }

        while (cnt.contains(c[r + 1]) || cnt.size() < t) {
            r++;
            cnt[c[r]]++;
        }

        cnt[c[l]]--;
        if (cnt[c[l]] == 0) {
            cnt.erase(c[l]);
        }

        up[0][l] = (r + 1) % n;
        vl[0][l] = (r + 1) % n != (r + 1);
    }

    for (int i = 1; i <= 60; i++) {
        for (int j = 0; j < n; j++) {
            up[i][j] = up[i - 1][up[i - 1][j]];
            vl[i][j] = vl[i - 1][j] + vl[i - 1][up[i - 1][j]];
        }
    }

    int j = 0;
    int sum = 0;
    int ans = 0;
    for (int i = 5; i >= 0; i--) {
        if (sum + vl[i][j] < k) {
            sum += vl[i][j];
            j = up[i][j];
            ans += (1ll << i);
        }
    }

    cout << ans + 1 << '\n';
    return 0;
}
