#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
// #define int int64_t
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF = 1e9 + 117;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int64_t n, k, tt; cin >> n >> k >> tt;
    vector<int> a(n);
    for (auto& e : a) cin >> e;
    unordered_set<int> cur;
    for (auto& e : a) cur.insert(e);
    if (cur.size() <= tt) {
        cout << "1\n";
        return 0;
    }
    vector<int> pole;
    for (auto& e : a) pole.push_back(e);
    for (auto& e : a) pole.push_back(e);
    vector<pair<int, int>> gr;
    gr.push_back({0, INF});
    for (int i = 1; i < pole.size(); ++i) {
        if (pole[i] != pole[i - 1]) {
            gr.back().second = i;
            gr.push_back({i, INF});
        }
    }
    vector<int> pr(pole.size());
    int crg = 0;
    for (int i = 0; i < n; ++i) {
        if (gr[crg].second <= i) crg++;
        pr[i] = gr[crg + tt].first;
    }

    vector<int> p(n, INF);
    int64_t ind = 0;
    vector<int> answers(pole.size());
    for (int i = 0; i < n; ++i) {
        if (p[ind] != INF) break;
        /*int l = ind + tt - 1, r = gt(0, 0, pole.size(), ind, pole.size()) + 1, mid;
        while (r - l > 1) {
            mid = (l + r) / 2;
            if (cnt_diff(0, 0, pole.size(), ind, mid + 1) <= tt) l = mid;
            else r = mid;
        }*/
        p[ind] = pr[ind] % n;
        // upd(0, 0, pole.size(), ind, r);
        ind = pr[ind] % n;
    }
    unordered_set<int> used;
    ind = 0;
    int64_t tp = 0, ans = 0, ci = 0;
    while (!used.count(ind)) {
        used.insert(ind);
        ans++;
        if (p[ind] < ind) {
            tp++;
            if (tp == k) break;
        }
        if (p[ind] < ind) ci += n - ind + p[ind];
        else ci += p[ind] - ind;
        ind = p[ind];
    }
    if (tp == k) {
        cout << ans << '\n';
        return 0;
    }
    int64_t cycle = 0;
    used.clear();
    int64_t cc = 0;
    while (!used.count(ind)) {
        used.insert(ind);
        cycle++;
        if (p[ind] < ind) cc += n - ind + p[ind];
        else cc += p[ind] - ind;
        ind = p[ind];
    }
    ans = ans + ((n*k - ci) / cc) * cycle;
    ci = ci + cc * ((n*k - ci) / cc) ;
    while (ci < n*k) {
        ans++;
        if (p[ind] < ind) ci += n - ind + p[ind];
        else ci += p[ind] - ind;
        ind = p[ind];
    }
    cout << ans << '\n';
    return 0;
}
