#include <bits/stdc++.h>

using namespace std;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define endl '\n'
#define pint pair<int, int>
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    forn(i, 0, n) {
        cin >> a[i];
    }

    set<int> tmp_set(all(a));
    if (tmp_set.size() <= t) {
        cout << 1;
        return;
    }

    vector<int> dist(n, 0);
    auto f = [&](int start, int len) {
        set<int> bruh_st;
        forn(i, start, min(n, start + len)) {
            bruh_st.insert(a[i]);
        }
        forn(i, 0, start + len - n) {
            bruh_st.insert(a[i]);
        }
        return bruh_st.size() <= t;
    };

    forn(i, 0, n) {
        int L = 0, R = n, M;
        while (L < R - 1) {
            M = L + (R - L) / 2;
            if (f(i, M)) L = M;
            else R = M;
        }
        dist[i] = L;
    }
    int ans = 0;
    int p = 0, used = 0;
    while (used < n * k) {
        ++ans;
        used += dist[p];
        p = (p + dist[p]) % n;
    }
    cout << ans;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
