//#pragma optimize("Ofast,unroll-loops");
//#pragma target("avx2");

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define endl '\n'
#define pint pair<int, int>
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    forn(i, 0, n) {
        cin >> a[i];
    }

    set<int> tmp_set(all(a));
    if (tmp_set.size() <= t) {
        cout << 1;
        return;
    }

    vector<int> dist(n, 0);
    auto f = [&](int start, int len) {
        unordered_set<int> bruh_st;
        forn(i, start, min(n, start + len)) {
            bruh_st.insert(a[i]);
        }
        forn(i, 0, start + len - n) {
            bruh_st.insert(a[i]);
        }
        return bruh_st.size() <= t;
    };

    forn(i, 0, n) {
        int L = 0, R = n, M;
        while (L < R - 1) {
            M = L + (R - L) / 2;
            if (f(i, M)) L = M;
            else R = M;
        }
        dist[i] = L;
    }

    int p = 0;
    set<int> stupid = { 0 };
    vector<int> ord = { 0 };
    while (true) {
        p = (p + dist[p]) % n;
        if (stupid.count(p)) {
            break;
        }
        ord.push_back(p);
        stupid.insert(p);
    }
    int len = 0;
    forn(i, 0, ord.size()) {
        if (ord[i] == p) {
            len = ord.size() - i;
            break;
        }
    }
    int sum = 0;
    forn(i, ord.size() - len, ord.size()) {
        sum += dist[ord[i]];
    }

    int ans = 0, used = 0;
    int q = 0;

    while (used < n * k && q != p) {
        ++ans;
        used += dist[q];
        q = (q + dist[q]) % n;
    }
    if (used < n * k) {
        int c = (n * k - used) / sum;
        ans += c * len;
        used += c * sum;
    }
    while (used < n * k) {
        ++ans;
        used += dist[q];
        q = (q + dist[q]) % n;
    }
    cout << ans;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
