//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <random>
#include <cassert>

using namespace std;

#define F frist
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
typedef long long ll;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k, t; cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<int> l(n);
    multiset<int> d;
    int r = 0;
    while (r < n) {
        if (d.size() == t && d.find(a[r]) == d.end()) break;
        d.insert(a[r]);
        l[0] = r;
        r++;
    }
    if (r == n) {
        cout << 1;
        return 0;
    }
    for (int i = 1; i < n; i++) {
        d.erase(d.find(a[i - 1]));
        while (!(d.size() == t && d.find(a[r]) == d.end())) {
            d.insert(a[r]);
            l[i] = r;
            r++;
            if (r == n) r = 0;
        }
    }

    int people = 0, cur = 0;
    for (int i = 0; i < k; i++) {
        int last = cur;
        while (cur < n) {
            people++;
            if (l[cur] < cur) {
                cur = l[cur] + 1;
                break;
            }
            cur = l[cur] + 1;
        }
        cur %= n;
    }

    cout << people;
}