#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define sz(array) (ll)array.size()
#define all(array) array.begin(), array.end()
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    unordered_map<ll, ll> un;
    vector<ll> a(n);
    for (ll i =0; i < n; ++i) {
        ll x;
        cin >> x;
        if (un.find(x) == un.end()) un[x] = sz(un);
        a[i] = un[x];
    }
    if (sz(un) <= t) {
        cout << "1\n";
        return;
    }
    vector<ll> cnt(sz(un));
    vector<ll> ans(n);
    ll c = 0;
    ll l = 0;
    for (ll i = 0; i < n; ++i) {
        while (c <= t) {
            if (++cnt[a[(i+l) % n]] == 1) {
                ++c;
            }
            ++l;
        }
        --l;
        ans[i] = l;
        if (--cnt[a[i]] == 0) --c;
    }
    unordered_set<ll> cycle;
    ll now = 0;
    ll len = 0, left = 0, cnt1 = 0, cnt2 = 0;
    map<ll, pair<ll, ll>> f;
    while (true) {
        if (cycle.find(now) != cycle.end()) {
            left = f[now].first;
            cnt2 = cnt1 - f[now].second;
            cnt1 = f[now].second;
            len -= left;
            break;
        }
        cycle.insert(now);
        f[now].first = len;
        f[now].second = cnt1;
        len += ans[now];
        ++cnt1;
        now = (now + ans[now]) % n;
    }
    ll q = n * k;
    ll res = 0;
    if (q >= left) {
        q -= left;
        res += cnt1;
    }
    if (q <= 0) {
        cout << res;
        return;
    }
    res += q / len * cnt2;
    q %= len;
    while (q > 0) {
        ++res;
        q -= ans[now];
        now = (now + ans[now]) % n;
    }
    cout << res << '\n';
}

signed main() {
    ll tc = 1;
    #ifdef LOCAL
        freopen("a.in", "r", stdin);
        cin >> tc;
    #endif
    while (tc--) {
        solve();
    }
    return 0;
}
