#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <deque>
#include <queue>
#include <assert.h>
#include <random>
#include <math.h>
#include <bitset>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define all(a) a.begin(), a.end()
#define ff first
#define ss second
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

mt19937 rnd(time(0));
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

#define int long long
vi a;
int n, k, t;

void solve1() {
    vi b(n);
    unordered_set<int> s;
    for (auto& x : a) s.insert(x);
    if (s.size() <= t) {
        cout << 1;
        return;
    }
    for (int st = 0; st < n; ++st) {
        int r = st;
        s.clear();
        s.insert(a[st]);
        while (s.size() <= t) {
            r = (r + 1) % n;
            s.insert(a[r]);
        }

        b[st] = r;
    }

    vector<pii> next(n);
    for (int st = 0; st < n; ++st) {
        int r = b[st];
        int cnt = 1;
        while (true) {
            cnt++;
            if (b[r] < r) {
                r = b[r];
                break;
            }
            r = b[r];
        }
        next[st] = { r, cnt };
    }
    int ans = 0;
    int st = 0;
    for (int i = 0; i < k; ++i) {
        ans += next[st].ss;
        st = next[st].ff;
    }

    cout << ans;
}

signed main()
{
    fast;
    
    cin >> n >> k >> t;
    a.resize(n);
    for (auto& i : a) cin >> i;

    if (n <= 1500) solve1();
}
