#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
//#pragma GCC optimize("trapv")
#endif
#include <bits/stdc++.h>

const int MAX_N = (int)3e5+10;
const int INT_INF = (int)2e9;
const double pi = acos(-1);


using namespace std;
using ld = long double;
using ll = long long;

int bin[60][MAX_N];
__int128 cnt[60][MAX_N];

void build_bin(int n){
    for(int i = 1;i<60;++i){
        for(int j = 0;j<n;++j){
            bin[i][j] = bin[i-1][bin[i-1][j]];
            cnt[i][j] = cnt[i-1][j]+cnt[i-1][bin[i-1][j]];
        }
    }
}

__int128 calc(__int128 n){
    int ind = 0;
    __int128 ans = 0;
    for(int i = 60;i>=0;--i){
        if((1ll<<i)&n){
            ans+=cnt[i][ind];
            ind = bin[i][ind];
        }
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
    int n;
    ll k,t;
    cin>>n>>k>>t;
    vector<int>a(n);
    for(auto &c:a) cin>>c;
    vector<int>v(2*n);
    for(int i = 0;i<n;++i){
        v[i] = a[i];
        v[i+n] = a[i];
    }
    unordered_map<int,int>cntn;
    int cnt2 = 0;
    for(int i = 0;i<n;++i){
        if(cntn[a[i]]==0){
            cnt2++;
        }
        cntn[a[i]]++;
    }
    if(cnt2<=t){
        cout<<1;
        return 0;
    }
    cntn.clear();
    int u = 0;
    cnt2 = 0;
    for(int i = 0;i<n;++i){
        while(u<(int)v.size() && cnt2<=t){
            if(cntn[v[u]]==0){
                cnt2++;
            }
            cntn[v[u]]++;
            u++;
        }
        u--;
        cntn[v[u]]--;
        cnt2--;
        bin[0][i] = u%n;
        cnt[0][i] = u-i;
        if(cntn[v[i]]==1){
            cnt2--;
        }
        cntn[v[i]]--;
    }
    build_bin(n);
    __int128 l = 0;
    __int128 r = 1e18;
    while(l+1!=r){
        __int128 mid = (l+r)/2;
        __int128 c = calc(mid);
        if(c>=n*k){
            r=mid;
        }
        else l = mid;
    }
    cout<<(ll)r;
    return 0;
}
