#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <random>
#include <chrono>


using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define MNOGO int __t; cin>>__t; while(__t--)
#define endl "\n"


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    mt19937 rng(std::chrono::steady_clock::now().time_since_epoch().count());

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, k, t;
    cin >> n >> k >> t;

    vector<int> a(n, 0);

    set<int> st;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        st.insert(a[i]);
    }

    if (st.size() <= t) {
        cout << 1 << endl;
        return 0;
    }

    vector<int> next(n, 0);

    map<int, int> mp;

    int now = 0;

    for (int i = 0; i < n; i++) {
        if (i != 0) {
            mp[a[i - 1]]--;
            if (mp[a[i - 1]] == 0) {
                mp.erase(a[i - 1]);
            }
        }
        while (true) {
            if (mp.size() <= t - 1) {
                mp[a[now]]++;
                now = (now + 1) % n;
            } else if (mp.size() == t) {
                if (mp.count(a[now])) {
                    mp[a[now]]++;
                    now = (now + 1) % n;
                } else {
                    break;
                }
            }
        }
        next[i] = now;
    }

    vector<int> dist(n, -1);
    vector<int> count(n, -1);

    dist[0] = 0;
    count[0] = 0;

    int pos = 0;

    int cyc = -1;

    int cnt = 0;

    int sec_d = -1;
    int sec_c = -1;

    while (true) {
        if (dist[pos] >= n * k) {
            cout << cnt << endl;
            return 0;
        }
        cnt++;
        int nxt = next[pos];
        int dst = (nxt - pos + n) % n;
        //cerr << pos << " " << nxt << endl;
        if (dist[nxt] == -1) {
            dist[nxt] = dist[pos] + dst;
            count[nxt] = count[pos] + 1;
            pos = nxt;
        } else {
            cyc = nxt;
            sec_d = dist[pos] + dst;
            sec_c = count[pos] + 1;
            break;
        }
    }

    int precyc = dist[cyc];
    int cyc_d = sec_d - dist[cyc];

    //cout << cyc << endl;

    int need = n * k - precyc;

    int ans = count[cyc];

    int c_l = sec_c - count[cyc];

    ans += need / cyc_d * c_l;

    need = need % cyc_d;

    int new_d = 0;

    int nw = cyc;

    while (true) {
        if (new_d >= need) {
            break;
        }
        int nxt = next[nw];
        int dst = (nxt - nw + n) % n;
        new_d += dst;
        nw = nxt;
        ans++;
    }

    cout << ans << endl;

}
