#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

typedef long long ll;

const ll MOD = 1e9 + 7;
const ll INF = 1e18 + 9;

//#pragma GCC optimize("unroll-loops,inline,02,03,Ofast")
//#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,fma,mmx,sse,sse2,sse3,sse4,ssse3")

void solve() {

    ll n = 0, k = 0, t = 0;
    cin >> n >> k >> t;
    vector<ll> a, ans(n);
    set<ll> s;

    for (int i = 0; i < n; i++) {
        ll x = 0;
        cin >> x;
        s.insert(x);
        a.push_back(x);
    }

    if (s.size() <= t) {
        cout << 1;
        return;
    }

    unordered_map<ll, ll> cntType;
    ll ft = t;
    ll r = 0;

    for (int i = 0; i < n; i++) {
        if (i) {
            cntType[a[i - 1]]--;
            if (cntType[a[i - 1]] == 0) {
                ft++;
            }
        }
        while (ft > 0 && cntType[a[r]] == 0 || cntType[a[r]] > 0) {
            if (cntType[a[r]] == 0) {
                ft--;
            }
            cntType[a[r]]++;
            r++;
            r %= n;
        }
        ans[i] = r;
    }
    vector<ll> used(n + 1, 0), len(n + 1, 0), gift(n + 1, 0);
    ll v = 0, start = 0, finish = 0, pe = 0, gft = 0, clen = 0;
    ll gftc = 0;
    for (int i = 0; i < n; i++) {

        len[v] = pe;
        gift[v] = gft;
        pe++;

        used[v] = 1;
        ll nv = ans[v];

        if (v > nv) {
            gft += n + nv - v;
        }
        else {
            gft += nv - v;
        }

        if (gft >= n * k) {
            cout << pe;
            return;
        }

        if (used[nv]) {
            start = nv;
            finish = v;
            gftc = gft - gift[start];
            clen = pe - len[start];
            break;
        }
        v = nv;
    }
    ll mlt = (n * k - gft) / gftc;
    gft += gftc * mlt;
    pe += clen * mlt;

    ll l = start;
    while (gft < n * k) {
        pe++;
        ll l1 = l;
        l = ans[l];
        if (l1 > l) {
            gft += n + l - l1;
        }
        else {
            gft += l - l1;
        }
    }
    cout << pe;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}
