#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

const int N = 3e5 + 5;
const int lg = 50;
int a[N], nxt[N];
int up[N][lg + 1], sum[N][lg + 1];

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    for (int i = 0; i < n; ++i) cin >> a[i];
    unordered_map<int, int> cnt;
    int j = 0;
    for (int i = 0; i < n; ++i) {
        while (j < i + n) {
            if (cnt.size() == t && !cnt.count(a[j % n])) {
                break;
            }
            cnt[a[j % n]]++;
            ++j;
        }
        nxt[i] = j;
        cnt[a[i]]--;
        if (cnt[a[i]] == 0) {
            cnt.erase(a[i]);
        }
    }
    for (int i = 0; i < n; ++i) {
        up[i][0] = nxt[i] % n;
        sum[i][0] = (nxt[i] - i == n ? n*k : nxt[i] - i);
    }
    for (int l = 1; l <= lg; ++l) {
        for (int i = 0; i < n; ++i) {
            up[i][l] = up[up[i][l - 1]][l - 1];
            sum[i][l] = sum[up[i][l - 1]][l - 1] + sum[i][l - 1];
            if (sum[i][l] > n*k) sum[i][l] = n*k;
        }
    }
    int ans = 0, v = 0, cur = 0;
    for (int l = lg; l > -1; --l) {
        if (sum[v][l] + cur < n*k) {
            cur += sum[v][l];
            v = up[v][l];
            ans += (1ll << l);
        }
    }
    if (cur < n*k) {
        ++ans;
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
