#include <bits/stdc++.h>
#pragma GCC optimize("O3", "unroll-loops", "inline", "fast-math")
#pragma GCC target("avx", "avx2", "popcnt", "sse3", "ssse3", "sse4.2", "fma", "tune=native")
using namespace std;
int n, k, t;
vector<int> A;

bool check(int mid) {
    set<int> used;
    for (int x : A) {
        if (!used.contains(x) && used.size() + 1 > t) {
            mid--;
            used.clear();
        }
        used.insert(x);
    }
    return mid > 0;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> k >> t;
    A.resize(n * k);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    for (int i = n; i < n * k; i++) {
        A[i] = A[i - n];
    }

    int l = 0, r = 1e9;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (check(mid)) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cout << r;
    return 0;
}
/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7
*/