#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops", "inline", "fast-math")
#pragma GCC target("avx", "avx2", "popcnt", "sse3", "ssse3", "sse4.2", "fma", "tune=native")
using namespace std;
#define int long long

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, k, t;
    cin >> n >> k >> t;
    vector<int> A(n), next(n, -1);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    if (set<int>(A.begin(), A.end()).size() <= t) {
        cout << 1;
        return 0;
    }

    map<int, int> cnt = {{A[0], 1}};
    int r = 1;
    for (int l = 0; l < n; l++) {
        while (cnt.contains(A[r % n]) || cnt.size() + 1 <= t) {
            cnt[A[r]]++;
            r++;
        }
        next[l] = r - l;
        cnt[A[l]]--;
        if (cnt[A[l]] == 0) cnt.erase(A[l]);
    }

    vector<vector<int>> binup(n, vector<int>(30));
    for (int i = 0; i < n; i++) {
        binup[i][0] = next[i];
    }
    for (int d = 1; d < 30; d++) {
        for (int i = 0; i < n; i++) {
            binup[i][d] = binup[i][d - 1] + binup[(i + binup[i][d - 1]) % n][d - 1];
        }
    }

    int result = 0;
    int want = n * k, i = 0;
    while (want > 0) {
        for (int d = 29; d >= 0; d--) {
            if (d == 0 || binup[i][d] <= want) {
                result += 1ll << d;
                want -= binup[i][d];
                i = (i + binup[i][d]) % n;
                break;
            }
        }
    }

    cout << result;
    return 0;
}
/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7
*/