#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, k, t; cin >> n >> k >> t;
    vector<ll> a(n);
    for(int i = 0; i < n; i++) cin >> a[i];
    vector<ll> v;
    for(int i = 0; i < k; i++) {
        for(int j = 0; j < n; j++) {
            v.push_back(a[j]);
        }
    }
    map<ll, ll> mapa;
    ll col = 1, sum = 0;
    for(int i = 0; i < k * n; i++) {
        if (mapa[v[i]] == 0) {
            sum++;
            mapa[v[i]] = 1;
        }
        if (sum > t) {
            col++;
            mapa.clear();
            mapa[v[i]] = 1;
            sum = 1;
        }
    }
    cout << col;
    return 0;
}
