#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>


using namespace std;

#ifdef fastio
#define endl '\n'
#endif

#define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

int n, k, t;
vector<int> arr;

void solve2() {

    int unique_cnt = 1;
    for (int i = 1; i < arr.size(); ++i) {
        if (arr[i] != arr[i - 1]) ++unique_cnt;
    }
    int total_cnt = unique_cnt * k;
    if (arr[0] == arr[n - 1]) {
        total_cnt -= k - 1;
    }
    cout << total_cnt << endl;
}

void solve1() {
    vector<int> a(n * k);
    for (int j = 0; j < k; ++j) {
        for (int i = 0; i < n; ++i) {
            a[j * n + i] = arr[i];
        }
    }

    int ans = 0;
    int i = 0;
    while (i < n * k) {
        int l = i;
        int r = i;
        set<int> els;
        els.insert(a[l]);
        while (r < n * k - 1 && els.size() < t) {
            els.insert(a[r + 1]);
            ++r;
        }
        assert(els.size() == t || r == n * k - 1);
        i = r + 1;
        ++ans;
    }
    cout << ans << endl;
}

signed main() {
    cin >> n >> k >> t;

    arr.resize(n);
    for (int i = 0; i < n; ++i) cin >> arr[i];

    if (t == 1) {
        solve2();
    } else {
        solve1();
    }

    return 0;
}