#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cassert>
#include <climits>
#define _GLIBCXX_DEBUG

using namespace std;

#ifdef fastio
#define endl '\n'
#endif

#define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

int n, k, t;
vector<int> arr;

void solve2() {

    int unique_cnt = 1;
    for (int i = 1; i < arr.size(); ++i) {
        if (arr[i] != arr[i - 1]) ++unique_cnt;
    }
    int total_cnt = unique_cnt * k;
    if (arr[0] == arr[n - 1]) {
        total_cnt -= k - 1;
    }
    cout << total_cnt << endl;
}

void solve1() {
    vector<int> a(n * k);
    for (int j = 0; j < k; ++j) {
        for (int i = 0; i < n; ++i) {
            a[j * n + i] = arr[i];
        }
    }

    int ans = 0;
    int i = 0;
    while (i < a.size()) {
        set<int> els;
        els.insert(a[i]);
        while (i < a.size() && els.size() <= t) {
            if (i == a.size() - 1) {
                ++i;
            } else {
                els.insert(a[i + 1]);
                ++i;
            }
        }
        ++ans;
    }
    assert(ans != 0);
    cout << ans << endl;
}

signed main() {
    //   freopen("/mnt/commons/code/in.txt", "r", stdin);
    cin >> n >> k >> t;

    arr.resize(n);
    for (int i = 0; i < n; ++i) cin >> arr[i];

    if (t == 1) {
        solve2();
    } else {
        solve1();
    }

    return 0;
}