#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <queue>

using namespace std;

//#define int long long

struct node {
	int li, ri, val;
};

vector<node> t(3000000);
int maxNode = 0;
int newNode() {
	t[maxNode] = { -1, -1, 0 };
	return maxNode++;
}

void update(int now, int left, int right, int ind, int val) {
	if (left == right) {
		t[now].val = val;
		return;
	}
	if (t[now].li == -1) t[now].li = newNode();
	if (t[now].ri == -1) t[now].ri = newNode();
	int mid = (left + right) / 2;
	if (ind <= mid) {
		update(t[now].li, left, mid, ind, val);
	}
	else {
		update(t[now].ri, mid + 1, right, ind, val);
	}
	t[now].val = t[t[now].li].val + t[t[now].ri].val;
}
int n, k, m;

int sum(int now, int left, int right, int k2) {
	if (left == right) {
		return left;
	}
	if (t[now].li == -1) t[now].li = newNode();
	if (t[now].ri == -1) t[now].ri = newNode();
	int mid = (left + right) / 2;
	if (t[t[now].li].val >= k2) return sum(t[now].li, left, mid, k2);
	else return sum(t[now].ri, mid + 1, right, k2 - t[t[now].li].val);
}

int solve(vector<int> l) {
	//t.resize(0);
	//t.resize(3000000);
	maxNode = 0;
	set<int> s;
	vector<int> l2(n * 2);
	for (int i = 0; i < n; i++) {
		l.push_back(l[i]);
		s.insert(l[i]);
	}
	if (s.size() <= m) {
		return 1;
	}
	map<long long, long long> d;
	vector<long long> l3(n);
	newNode();
	for (int i = 0; i <= 2 * n; i++) {
		update(0, 0, n * 2, i, 0);
	}
	for (int i = n * 2 - 1; i >= 0; i--) {
		l2[d[l[i]]] = 0;
		update(0, 0, n * 2, d[l[i]], 0);
		l2[i] = 1;
		update(0, 0, n * 2, i, 1);
		if (i < n) {
			long long u = sum(0, 0, n * 2, m + 1);
			l3[i] = u % n;
		}
		d[l[i]] = i;
	}
	long long now = 0;
	long long pers = 0;
	long long ans = 0;
	map<long long, long long> d2;
	map<long long, long long> d3;
	long long timer = 0;
	long long prev = 0;
	long long k2 = k;
	while (d2.count(now) == 0 and k2 > 0) {
		//cout << now << " ehehe\n";
		ans++;
		d2[now] = timer++;
		prev = now;
		now = l3[now];
		if (now <= prev) {
			k2--;
			pers++;
		}
		if (d2.count(now) == 0) d3[now] = pers;
	}
	long long cycleStart = d2[now];
	long long cycleSize = timer - d2[now];
	long long pers2 = (pers - d3[now]);
	//cout << cycleStart << " " << ans << " " << k2 << " " << pers << " " << d3[now] << " hehe\n";
	if (pers2 != 0) {
		long long he = max(0ll, k2 / pers2 - 5);
		ans += (long long)cycleSize * he;
		k2 -= (long long)pers2 * he;
	}
	//cout << ans << " hehe\n";
	while (k2 > 0) {
		ans++;
		prev = now;
		now = l3[now];
		if (prev >= now) {
			k2--;
		}
	}
	return ans;
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> k >> m;
	vector<int> l(n);
	for (int i = 0; i < n; i++) cin >> l[i];
	cout << solve(l);






}

/*

5 4

4 2 2
9 3 9 1


*/
