#include <bits/stdc++.h>

#define fi first
#define se second  

#define pb push_back
#define sz(x) (int)x.size()

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, a) for(auto& x: a)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int N = 1e7;

int t[4 * N];

struct {
    int n;

    int sum(int r) {
        int sum = 0;
        for ( ; r >= 0; r = (r & (r + 1)) - 1) {
            sum += t[r];
        }
        return sum;
    }

    int sum(int l, int r) {
        return sum(r) - sum(l - 1);
    }

    void update(int v, int x) {
        for ( ; v < n; v |= v + 1) {
            t[v] += x;
        }
    }
} T;

map<int, int> pref;

int main() {
    int n, k, t;
    cin >> n >> k >> t;
    int qN = n;

    vector<int> a(n * k);
    fr (i, 0, n - 1) {
        cin >> a[i];
    }
    fr (i, n, k * n - 1) {
        a[i] = a[i % n];
    }

    n = sz(a);
    T.n = n;

    int cnt = 0;
    int st = 0;
    set<pii> otrezki;
    ll length1 = n * k;
    fr (i, 0, n - 1) {
        if(pref.count(a[i])) {
            T.update(pref[a[i]], -1);
        }
        
        T.update(i, 1);
        
        int cntO = T.sum(st, n - 1);
        if(cntO > t) {
            otrezki.insert({st, i - 1});
            length1 += i - st;
            st = i;
            cnt++;
        }

        pref[a[i]] = i;
    }

    cout << cnt + 1 << endl;

    return 0;
}