#include <bits/stdc++.h>

#define fi first
#define se second  

#define pb push_back
#define sz(x) (int)x.size()

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, a) for(auto& x: a)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int N = 1e7;

struct {
    int t[4 * N];

    void build(int v, int tl, int tr) {
        if(tl == tr) {
            t[v] = 0;
            return;
        }

        int tm = (tl + tr) >> 1;

        build(v << 1, tl, tm);
        build(v << 1 | 1, tm + 1, tr);
    }
    void update(int v, int tl, int tr, int pos) {
        if(tl == tr) {
            t[v] ^= 1;
            return;
        }

        int tm = (tl + tr) >> 1;

        if(pos <= tm) {
            update(v << 1, tl, tm, pos);
        } else {
            update(v << 1 | 1, tm + 1, tr, pos);
        }

        t[v] = t[v << 1] + t[v << 1 | 1];
    }
    int get(int v, int tl, int tr, int l, int r) {
        if(l > r) {
            return 0;
        }

        if(tl == l && tr == r) {
            return t[v];
        }

        int tm = (tl + tr) >> 1;

        int g1 = get(v << 1, tl, tm, l, min(tm, r));
        int g2 = get(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r);

        return g1 + g2;
    }
} T;

map<int, int> pref;

int main() {
    int n, k, t;
    cin >> n >> k >> t;

    int qN = n;

    vector<int> a(40000000);
    fr (i, 0, n - 1) {
        cin >> a[i];
    }

    if(t == 1) {
        int cnt = 0;
        int st = 0;
        fr (i, 0, qN - 1) {
            if(pref.count(a[i])) {
                T.update(1, 0, n - 1, pref[a[i]]);
            }
            
            T.update(1, 0, n - 1, i);
            
            int cntO = T.get(1, 0, n - 1, st, n - 1);
            if(cntO > t) {
                cnt++;
                st = i;
            }

            pref[a[i]] = i;
        }
        cnt++;

        if(a[0] == a[qN - 1]) {
            cout << (cnt - 1) * k + 1 << endl;
        } else {
            cout << cnt * k << endl;
        }

        return 0;
    }

    fr (i, n, k * n - 1) {
        a[i] = a[i % n];
    }

    n *= k;
    T.build(1, 0, n - 1);

    int cnt = 0;
    int st = 0;
    fr (i, 0, n - 1) {
        if(pref.count(a[i])) {
            T.update(1, 0, n - 1, pref[a[i]]);
        }
        
        T.update(1, 0, n - 1, i);
        
        int cntO = T.get(1, 0, n - 1, st, n - 1);
        if(cntO > t) {
            cnt++;
            st = i;
        }

        pref[a[i]] = i;
    }

    cout << cnt + 1 << endl;

    return 0;
}