#include <bits/stdc++.h>

#define fi first
#define se second  

#define pb push_back
#define sz(x) (int)x.size()

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, a) for(auto& x: a)

#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int N = 1e7;

struct {
    int t[4 * N];

    void build(int v, int tl, int tr) {
        if(tl == tr) {
            t[v] = 0;
            return;
        }

        int tm = (tl + tr) >> 1;

        build(v << 1, tl, tm);
        build(v << 1 | 1, tm + 1, tr);
    }
    void update(int v, int tl, int tr, int pos) {
        if(tl == tr) {
            t[v] ^= 1;
            return;
        }

        int tm = (tl + tr) >> 1;

        if(pos <= tm) {
            update(v << 1, tl, tm, pos);
        } else {
            update(v << 1 | 1, tm + 1, tr, pos);
        }

        t[v] = t[v << 1] + t[v << 1 | 1];
    }
    int get(int v, int tl, int tr, int l, int r) {
        if(l > r) {
            return 0;
        }

        if(tl == l && tr == r) {
            return t[v];
        }

        int tm = (tl + tr) >> 1;

        int g1 = get(v << 1, tl, tm, l, min(tm, r));
        int g2 = get(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r);

        return g1 + g2;
    }
} T;

map<int, int> pref;
map<int, int> vis;

int32_t main() {
    int n, k, t;
    cin >> n >> k >> t;

    int qN = n;

    vector<int> a(n);
    fr (i, 0, n - 1) {
        cin >> a[i];
        vis[a[i]]++;
    }

    if(sz(vis) < t) {
        cout << 1 << endl;
        return 0;
    }

    T.build(1, 0, n - 1);

    int st = 0;
    fr (i, 0, n - 1) {
        if(pref.count(a[i])) {
            T.update(1, 0, n - 1, pref[a[i]]);
        }

        T.update(1, 0, n - 1, i);

        int cnt = T.get(1, 0, n - 1, st, i);
        if(cnt > t) {
            st = i;
        }
    }

    int ans = 0;

    int cntC = n - st;
    vector<int> lst(cntC);

    fr (i, 0, n - 1) {
        if(pref.count(a[i])) {
            T.update(1, 0, n - 1, pref[a[i]]);
        }

        T.update(1, 0, n - 1, i);


        fr (j, 0, cntC) {
            int cnt = T.get(1, 0, n - 1, lst[j], i);
            if(cnt + j == t) {
                ans++;
                lst[j] = i;
            }
        }
    }

    cout << ans << endl;

    return 0;
}