#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<ll, ll>;
using ld = long double;

template<typename T, typename F>
istream &operator>>(istream &s, pair<T, F> &a) {
    s >> a.first >> a.second;
    return s;
}

template<typename T, typename F>
ostream &operator<<(ostream &s, pair<T, F> &a) {
    s << a.first << ' ' << a.second << '\n';
    return s;
}

template<typename T>
istream &operator>>(istream &s, vector<T> &a) {
    for (T &el: a) {
        s >> el;
    }
    return s;
}

template<typename T>
ostream &operator<<(ostream &s, vector<T> &a) {
    for (T el: a) {
        s << el << ' ';
    }
    s << '\n';
    return s;
}

ll dvup(ll a, ll b) {
    if (a % b == 0) {
        return a / b;
    }
    return a / b + 1;
}

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> tmp(n);
    cin >> tmp;
    vector<ll> arr;
    for (int i = 0; i < k; i++) {
        arr.insert(arr.end(), tmp.begin(), tmp.end());
    }
    set<int>st;
    st.insert(arr[0]);
    int ans = 1;
    for (int el:arr){
        if (st.find(el) == st.end() && st.size() == t){
            st.clear();
            ans++;
        }
        st.insert(el);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
