#include<bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define endl "\n"
typedef long long ll;
using namespace std;

map<int, vector<int>> id;

bool check(int l, int r, int x) {
    if (l <= r) {
        int tl = lower_bound(all(id[x]), l) - id[x].begin();
        int tr = upper_bound(all(id[x]), r) - id[x].begin();

        return tr - tl;
    }

    int tl = upper_bound(all(id[x]), r) - id[x].begin();
    int tr = lower_bound(all(id[x]), l) - id[x].begin();

    return id[x].size() - (tr - tl);
}

void solve() {
    int n, m, t;
    cin >> n >> m >> t;

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        id[a[i]].push_back(i);
    }

    int k = 0;
    map<int, int> u;

    vector<int> dp(n);
    dp[0] = -1;

    for (int i = 0; i < n; i++) {
        if (!u[a[i]]) k++;
        u[a[i]]++;

        if (k == t + 1) {
            u[a[i]]--;

            dp[0] = i - 1;
            break;
        }
    }

    if (dp[0] == -1) {
        cout << 1 << endl;
        return;
    }


    set<int> s;
    for (int j = dp[0] + 1; j < n; j++) {
        if (!u[a[j]]) s.insert(j);
    }

    //cout << s.size() << endl;
    //cout << 0 << " " << dp[0] << endl;

    for (int i = 1; i < n; i++) {
        if (!check(i, dp[i - 1], a[i - 1]) || dp[i - 1] == i - 1) {
            int w = upper_bound(all(id[a[i - 1]]), dp[i - 1]) - id[a[i - 1]].begin();
            if (w != id[a[i - 1]].size()) s.insert(id[a[i - 1]][w]);
            else s.insert(id[a[i - 1]][0] + n);

            dp[i] = (*++s.begin() + n - 1) % n;
            s.erase(s.begin());
        }

        else dp[i] = dp[i - 1];

        //cout << i << " " << dp[i] << endl;
    }

    int ans = 0;
    int i = 0;

    while (m > 0) {
        ans++;

        int j = (dp[i] + 1) % n;
        if (j < i) m--;

        //cout << ans << " " << i << " " << j << endl;
        i = j;
    }

    cout << ans << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    //cin >> t;

    while (t--) solve();
}
