#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

typedef long long ll;
#define in(a) a.begin(), a.end()

const int mxN = 3e5 + 500;
int n;
ll k, t;
vector<int> a;

struct FT {
    int sz;
    vector<int> ft;
    FT(int num) : sz(num) {
        ft.assign(sz + 1, 0);
    }
    void add(int i, int x) {
        for (; i <= sz; i += (i & -i)) {
            ft[i] += x;
        }
    }
    int pref(int i) {
        int res = 0;
        for (; i > 0; i-= (i & -i)) {
            res += ft[i];
        }
        return res;
    }
    int rsq(int l, int r) {
        return pref(r) - pref(l);
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> k >> t;
    a.resize(n);
    for (int i = 0 ; i < n; ++i) {
        cin >> a[i];
    }
    
    set<int> st(in(a));
    if (st.size() <= t) {
        cout << "1\n";
        return 0;
    }
    a.insert(a.end(), in(a));
    vector<int> jump(n);
    int beg = 0;

    vector<int> prev(2 * n, -1);
    {
        map<int, int> mp;
        for (int i = 0 ; i < 2 * n; ++i) {
            auto it = mp.find(a[i]) ;
            if (it != mp.end()) {
                prev[i] = it->second;
            }
            mp[a[i]] = i;
        }
    }
    
    FT ft(2 * n + 10);
    
    int end = 0;
    while (beg < n) {
        while (true) {
            assert(end < 2 * n + 1);
            ft.add(prev[end] + 2, 1);
            if (ft.pref(beg + 1) > t) {
                ft.add(prev[end] + 2, -1);
                break;
            }
            end += 1;
        }
        jump[beg] = end - beg;
        ft.add(prev[beg] + 2, -1);
        debug << beg << ' ' << end << endl;
        beg += 1;
    }
    for (int i = 0 ; i < n; ++i) {
        debug << jump[i] << ' ';
    }
    debug << endl;


    ll i = 0, j = 0;
    vector<bool> vis(n);
    
    while (i < n * k) {
        if (vis[i % n]) {
            break;
        }
        vis[i % n] = true;
        i = min(i + jump[i % n], n * k);
        j += 1;
    }
    ll times = (ll)n * k / i;
    i *= times;
    j *= times;
    debug << i << ' ' << times << endl;
    while (i < n * k) {
        vis[i % n] = true;
        i = min(i + jump[i % n], n * k);
        j += 1;
    }
    cout << j;
    return 0;
}