#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define ff first
#define ss second
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;

const ll INF = 1e18 + 1;
const ll N = 1e5 + 1;
const ll MOD = 1e9 + 7;

void solve(){
    ll n, k, t; cin >> n >> k >> t;
    vector <ll> a(n);
    for (auto &x: a) cin >> x;

    if (t == 1){
        ll cnt = 1;
        for (int i = 1; i < n; i++){
            if (a[i - 1] == a[i]) continue;
            else cnt++;
        }

        if (a[0] == a.back()){
            cout << cnt + (cnt - 1) * (k - 1);
        } else {
            cout << cnt * k;
        }
        return;
    }

    vector <ll> allp(n * k);
    for (int i = 0; i < k; i++){
        for (int j = 0; j < n; j++){
            allp[i * n + j] = a[j];
        }
    }

    ll ans = 0;
    for (int i = 0; i < n * k;){
        ans++;
        set <ll> st;
        while (i < n * k && sz(st) <= t){
            st.insert(allp[i]);
            i++;
        }

        if (sz(st) > t){
            i--;
            st.erase(allp[i]);
        }
    }

    cout << ans;
}

int main(){
    #ifdef LOCAL
        freopen("TASK.in", "r", stdin);
        freopen("TASK.out", "w", stdout);
    #endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

