#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define ff first
#define ss second
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;

const ll INF = 1e18 + 1;
const ll N = 2e3 + 1;
const ll MOD = 1e9 + 7;
pair <ll, ll> dp[N][N];

void solve(){
    ll n, k, t; cin >> n >> k >> t;
    vector <ll> a(n);
    for (auto &x: a) cin >> x;

    set <ll> block;
    for (auto x: a) block.insert(x);

    if (t >= sz(block)){
        cout << 1;
        return;
    }

    vector <ll> to(n);
    for (int i = 0; i < n; i++){
        set <ll> st;
        for (int j = 0; j < n; j++){
            st.insert(a[(i + j) % n]);

            if (sz(st) > t){
                to[i] = (i + j) % n;
                break;
            }
        }
    }

    ll ans = 0;
    ll now = 0;
    while (k > 0){
        ans++;

        if (now <= to[now]) now = to[now];
        else {
            now = to[now];
            k--;
        }
    }

    cout << ans;
}

int main(){
    #ifdef LOCAL
        freopen("TASK.in", "r", stdin);
        freopen("TASK.out", "w", stdout);
    #endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

