#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

long long sum(long long a, long long b, long long Mod) {
    if (a + b >= Mod) {
        return a + b - Mod;
    }
    return a + b;
}

long long sub(long long a, long long b, long long Mod) {
    if (a - b < 0) {
        return a - b + Mod;
    }
    return a - b;
}

void solve() {
    long long n, k, t;
    cin >> n >> k >> t;
    vector <long long> st(n);
    for (long long i = 0; i < n; ++i) {
        cin >> st[i];
    }
    vector <long long> cord = st;
    sort(cord.begin(), cord.end());
    cord.erase(unique(cord.begin(), cord.end()), cord.end());
    for (long long i = 0; i < n; ++i) {
        st[i] = lower_bound(cord.begin(), cord.end(), st[i]) - cord.begin();
    }
    long long ALL = 0;
    vector <long long> Used(cord.size(), 0);
    for (long long i = 0; i < n; ++i) {
        Used[st[i]] += 1;
        if (Used[st[i]] == 1) {
            ALL += 1;
        }
    }
    if (ALL <= t) {
        cout << 1;
        return;
    }
    vector <long long> dp(n);
    long long r = 0;
    vector <long long> used(cord.size() + 1, 0);
    long long cur = 0;
    for (long long i = 0; i < n; ++i) {
        while (cur <= t) {
            used[st[r]] += 1;
            if (used[st[r]] == 1) {
                cur += 1;
            }
            r = sum(r, 1, n);
            //cout << r << " r " << endl;
        }
        r = sub(r, 1, n);
        used[st[r]] -= 1;
        --cur;
        dp[i] = sub(r, 1, n);
        //cout << dp[i] << " dp " << i << endl;
        used[st[i]] -= 1;
        if (used[st[i]] == 0) {
            cur -= 1;
        }
    }
    vector <long long> Up(n);
    vector <long long> Cnt(n);
    for (long long i = n - 1; i >= 0; --i) {
        if (dp[i] < i || dp[i] == n - 1) {
            Up[i] = sum(dp[i], 1, n);
            Cnt[i] = 1;
        } else {
            Up[i] = Up[dp[i] + 1];
            Cnt[i] = Cnt[dp[i] + 1] + 1;
        }
        //cout << Up[i] << " Up " << Cnt[i] << " Cnt " << i << " i " << endl;
    }
    long long C = 0;
    long long CntC = 0;
    vector <long long> UsedC(n + 1, 0);
    long long v = 0;
    while (UsedC[v] != 1) {
        UsedC[v] = 1;
        C += Cnt[v];
        v = Up[v];
        CntC += 1;
    }
    long long u = 0;
    long long cntc = 0;
    long long c = 0;
    while (v != u) {
        C -= Cnt[u];
        c += Cnt[u];
        u = Up[u];
        CntC -= 1;
        cntc += 1;
    }
    long long ans = 0;
    if (k > cntc + CntC) {
        k -= cntc;
        ans += c;
        ans += k / CntC * C;
        k = k % CntC;
    } else {
        v = 0;
    }
    //cout << k << " k " << v << " v " << ans << " ans " << endl;
    for (; k > 1; --k) {
        ans += Cnt[v];
        v = Up[v];
    }
    //cout << ans << " after 1 " << endl;
    used = {};
    used.resize(cord.size(), 0);
    //cout << v << " v bef " << endl;
    if (k == 1) {
        while (true) {
            ans += 1;
            long long u = v;
            v = sum(dp[v], 1, n);
            if (v < u) {
                break;
            }
            //cout << v << " next " << endl;
        }
    }
    cout << ans;
}

int main() {
    solve();
}
