#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//using namespace __gnu_pbds;

#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target_tbl("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

using namespace std;

#define int long long
#define ll long long
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define line cout << '\n'

#define sz(v) ((int)(v).size())
const double pi = 3.1415926535897932384626433832795;

const long long mod = 1e9 + 7;
const long long inf = 1099999999999999999;
const long long nmax = 3e5 + 100;
const long long Q = 100;

random_device rd;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct segmenttreesum {

    int N;
    vector<int> tree;

    void upd(int v, int tl, int tr, int pos, int val) {
        if (tl + 1 == tr) {
            tree[v] = val;
            return;
        }
        int tm = (tl + tr) / 2;
        pos < tm ? upd(v * 2, tl, tm, pos, val) : upd(v * 2 + 1, tm, tr, pos, val);
        tree[v] = tree[v * 2] + tree[v * 2 + 1];
    }

    int get(int v, int tl, int tr, int ql, int qr) {
        if (qr <= tl || tr <= ql) return 0;
        if (ql <= tl && tr <= qr) return tree[v];
        int tm = (tl + tr) / 2;
        return get(v * 2, tl, tm, ql, qr) + get(v * 2 + 1, tm, tr, ql, qr);
    }

    void upd(int pos, int val) { upd(1, 1, N + 1, pos, val); }

    int get(int l, int r) { return get(1, 1, N + 1, l, r + 1); }

    segmenttreesum() {}

    segmenttreesum(int n) {
        N = n;
        tree.assign(4 * (N + 15), 0);
    }
};

void runtimeerror() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> arr(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> arr[i];
    for (int i = 1; i <= n; i++)
        arr.emplace_back(arr[i]);

    vector<int> dp(n + 2), cnt(n + 2);
    segmenttreesum tree(2 * n + 1);
    map<int, int> last_pos;
    for (int i = n + 1; i < sz(arr); i++) {
        if (last_pos.find(arr[i]) == last_pos.end())
            last_pos[arr[i]] = i, tree.upd(i, 1);
    }

    if (sz(last_pos) <= t) {
        cout << 1;
        return;
    }

    for (int i = n; i >= 1; i--) {
        if (last_pos.find(arr[i]) != last_pos.end())
            tree.upd(last_pos[arr[i]], 0);
        last_pos[arr[i]] = i;
        tree.upd(i, 1);

        int l = 1, r = n + 1;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (tree.get(i, min(n * 2, i + mid - 1)) <= t) l = mid;
            else r = mid;
        }

        if (i + l - 1 >= n) {
            dp[i] = i + l - 1;
            cnt[i] = 1;
        } else {
            dp[i] = dp[i + l];
            cnt[i] = cnt[i + l] + 1LL;
        }
    }

    int ans = 0, pos = 1, fl = 0;
    for (int i = 1; i <= k; ++i) {
        if (pos > n) pos -= n;
        ans += cnt[pos];
        pos = dp[pos] + 1;
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t_ = 1;
//    cin >> t_;
    while (t_--)
        runtimeerror();
    //  cout << "WINNER";
    //  I'm stupid man
}
