#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll inf = 1e18, mod = 1e9 + 7, maxn = 3e5 + 1, logn = 55;

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    map<int, int> ex;
    for (int &x: a) cin >> x, ex[x] = 0;
    if (sz(ex) <= t) {
        cout << 1;
        return;
    }
    int N = 0;
    for (auto &[x, i]: ex) i = N++;
    for (int &x: a) x = ex[x];
    ex.clear();
    vector<int> cnt(n);
    for (int l = 0, r = 0; l < n; l++) {
        while (true) {
            if (sz(ex) == t && ex.find(a[r]) == ex.end()) break;
            ex[a[r]]++;
            r = (r + 1) % n;
        }
        if (l <= r) {
            cnt[l] = r - l;
        } else {
            cnt[l] = r + n - l;
        }
        ex[a[l]]--;
        if (ex[a[l]] == 0) ex.erase(a[l]);
    }

    vector<vector<pii>> go(logn, vector<pii >(n));
    for (int i = 0; i < n; i++) {
        go[0][i] = {cnt[i], (i + cnt[i]) % n};
    }
    for (int l = 1; l < logn; l++) {
        for (int i = 0; i < n; i++) {
            auto [s1, v1] = go[l - 1][i];
            auto [s2, v2] = go[l - 1][v1];
            go[l][i] = {s1 + s2, v2};
        }
    }
    int ans = 0, st = 0, ost = n * k;
    while (ost > 0) {
        int was = 0;
        for (int l = logn - 1; l; l--) {
            auto [s, v] = go[l][st];
            if (ost >= s) {
                ost -= s;
                st = v;
                was = 1;
                ans += 1ll << l;
                break;
            }
        }
        if (!was) {
            auto [s, v] = go[0][st];
            ost -= s, st = v;
            ans++;
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
