#include <bits/stdc++.h>

#define ll long long

using namespace std;
ll n, k, t;
vector<ll> A;

void solvet1() {
    ll c = 0;
    for (ll i = 0; i < n - 1; i++) {
        if (A[i] != A[i + 1]) {
            c++;
        }
    }
    bool flag = (A[0] == A[n - 1]);
    if (flag) {
        cout << c * k + 1;
    } else {
        cout << (c + 1) * k;
    }
}

vector<vector<pair<ll, ll>>> Sp;
bool isone = false;

void generatebase();
void generateSp();
bool check(ll a){
    ll i=0;
    ll s=0;
    ll j=0;
    while(a!=0){
        if(a%2==1){
            s+=Sp[i][j].second;
            i=Sp[i][j].first;
        }
        a/=2;
        j++;
    }
    return s>=k;
}
void solveall() {
    Sp.resize(n);
    for (ll i = 0; i < n; i++) {
        Sp[i].resize(30);
    }
    generatebase();
    if(isone){
        cout<<1;
        return;
    }
    generateSp();
    ll l=0;
    ll r=300000000000;
    ll m;
    while(l+1!=r){
        m=(l+r)/2;
        if(check(m)){
            r=m;
        }
        else{
            l=m;
        }
    }
    cout<<l+1;
}
void generateSp(){
    for(ll i=1;i<30;i++){
        for(ll j=0;j<n;j++){
            Sp[j][i]=Sp[Sp[j][i-1].first][i-1];
            Sp[j][i].second+=Sp[j][i-1].second;
        }
    }
}
void generatebase() {
    vector<set<ll>> B(n);
    for (ll i = 0; i < n; i++) {
        B[A[i]].insert(i);
    }
    unordered_set<ll> C;
    ll i = 0;
    while (C.size() <= t and i < n) {
        C.insert(A[i]);
        if (C.size() <= t) {
            i++;
        }
    }
    if (i == n) {
        isone = true;
        return;
    }
    Sp[0][0] = {i, 0};
    for (ll j = 1; j < n; j++) {
        if (A[j] == A[j - 1]) {
            Sp[j][0] = Sp[j - 1][0];
            continue;
        }
        auto l = lower_bound(B[A[j - 1]].begin(), B[A[j - 1]].end(), j);
        if (i > j) {
            auto it=B[A[j-1]].end();
            it--;
            if ((*l) < i and *(it)>=j) {
                Sp[j][0] = Sp[j - 1][0];
                continue;
            }
        } else if(i<j) {
            auto it = B[A[j-1]].end();
            it--;
            if (*(B[A[j-1]].begin())<i or *(it) > j) {
                Sp[j][0] = Sp[j - 1][0];
                continue;
            }
        }
        C.erase(A[j - 1]);
        for (; i < n; i++) {
            C.insert(A[i]);
            if (C.size() > t) {
                Sp[j][0] = {i, i<j};
                break;
            }
        }
        if(C.size()<=t) {
            i = 0;
            for (; i < n; i++) {
                C.insert(A[i]);
                if (C.size() > t) {
                    Sp[j][0] = {i, 1};
                    break;
                }
            }
        }
    }

}

void makenormalA() {
    map<ll, ll> B;
    for (ll i = 0; i < n; i++) {
        if (B[A[i]] == 0) {
            B[A[i]] = B.size();
        }
    }
    for (ll i = 0; i < n; i++) {
        A[i] = B[A[i]] - 1;
    }
}

int main() {
    cin >> n >> k >> t;
    A.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> A[i];
    }
    makenormalA();
    if (t == 1) {
        solvet1();
        return 0;
    }
    solveall();
}
