#ifdef local
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define ve vector
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pb push_back
#define eb emplace_back
#define INF1 INT32_MAX
#define INF2 INT64_MAX
#define sz(a) (int)(a).size()

using namespace std;
using namespace __gnu_pbds;
random_device rd;
mt19937_64 rnd(rd());

template<typename key, typename cmp = less<key>>
using pbds = tree<key, null_type, cmp, rb_tree_tag, tree_order_statistics_node_update>;
const int maxn = (int)3*1e5+1;

int g[maxn];
int used[maxn];
int cont[maxn];
int cnt1[maxn];

int res = -1, n, k;
int c;


void dfs(int x, int cur=0, int cnt = 0) {
    if (used[x]) {
        int val = cur - cont[x];
        res = cnt1[x] + (k-cont[x])/val*(cnt-cnt1[x]);
        c = k - cont[x] - (k-cont[x])/val*val;
        int u = x, curp = 0;
        while (curp < c) {
            if (g[u] <= u) ++curp;
            ++res;
            u = g[u];
        }
        return;
    }
    used[x] = 1;
    cont[x] = cur;
    cnt1[x] = cnt;

    if (g[x] <= x) ++cur;
    if (cur == k) {
        res = cnt+1;
        return;
    }
    dfs(g[x], cur, cnt+1);
}

void solve() {
    int t; cin >> n >> k >> t;
    ve<int> a(n);
    set<int> ch;
    for (int &i : a) cin >> i, ch.insert(i);

    if (sz(ch) <= t) {
        cout << 1;
        return;
    }

    int j = -1;
    map<int, int> mp;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        while (true) {
            if (cnt < t || mp[a[(j+1)%n]]) {
                j = (j+1)%n;
                mp[a[j]]++;
                if(mp[a[j]] == 1) ++cnt;
            }
            else break;
        }
        g[i] = (j+1)%n;
        mp[a[i]]--;
        if (!mp[a[i]]) --cnt;
    }
    dfs(0);
    cout << res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--) solve();
}
