//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <vector>
#include <ctime>
#include <unordered_set>
#include <iomanip>
#include <algorithm>
using namespace std;
#define double long double
#define int long long
#define ll long long
#define debug(x) cerr << (#x) << ": " << x << endl;
#define get_time (double)(clock()) / (double)(CLOCKS_PER_SEC)
const int INF = 1e9 + 7;
const int mod = 1e9 + 7;
const int MAXN = 2e5 + 10;
//#pragma GCC optimize("avx2")
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
int make_add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
int mul(int a, int b) {
    return (ll(a) * b) % mod;
}
int n, k, t;
vector<int> a, next_pos;
void solve() {
    cin >> n >> k >> t;
    a = vector<int>(n);
    next_pos = vector<int>(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    set<int> all;
    for (auto c : a) {
        all.insert(c);
    }
    if (all.size() <= t) {
        cout << 1 << endl;
        return;
    }
    for (int i = 0; i < n; i++) a.push_back(a[i]);
    int r = 0;
    map<int, int> cnt;
    for (int l = 0; l < n; l++) {
        while (true) {
            int x = a[r];
            if (cnt.count(x) == 0 && cnt.size() + 1 > t) break;
            cnt[x]++;
            r++;
        }
        next_pos[l] = r - l;
        int x = a[l];
        cnt[x]--;
        if (cnt[x] == 0) cnt.erase(x);
    }
    int cur_pos = 0, circle = 0, ans = 0;
    for (int i = 0; i < INF; i++) {
        int next = next_pos[cur_pos];
        if (cur_pos + next >= n) circle++;
        if (circle == k) {
            ans = i;
            break;
        }
        cur_pos = (cur_pos + next) % n;
    }
    cout << ans + 1 << endl;
}
signed main() {
    cout << fixed << setprecision(20);
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
/*
2 1
*/