#include <bits/stdc++.h>
using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream& cin, ostream& cout);


int test_cnt = 1, group, cur_test;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    // cin >> test_cnt;
    // cin >> group;
    for (cur_test = 0; cur_test < test_cnt; ++cur_test)
        solve(cin, cout);
}


void solve(istream& cin, ostream& cout) {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> a(n);
    for (auto& t : a)
        cin >> t;


    vector<vector<ll>> dp(32, vector<ll>(n));
    for (ll i = 0; i < n; ++i) {
        set<ll> rzl;
        for (ll j = i; j < n * 3; ++j) {
            rzl.insert(a[j % n]);
            if (rzl.size() > t) {
                dp[0][i] = j - i;
                break;
            }
        }

        if (rzl.size() <= t) {
            cout << "1\n";
            return;
        }
    }


    for (ll ln = 1; ln < dp.size(); ++ln) {
        for (ll i = 0; i < n; ++i) {
            dp[ln][i] = dp[ln - 1][(i + dp[ln - 1][i]) % n] + dp[ln - 1][i];
        }
    }


    ll res = 0;
    ll i = 0, ln = dp.size() - 1;
    while (i < n * k && ln >= 0) {
        ll pos = dp[ln][i % n] + i;
        if (pos > n * k) {
            --ln;
        } else {
            i = pos;
            res += (1ll << ln);
        }
    }

    if(i != n * k)
        ++res;
    cout << res << '\n';
}
