#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,bmi,bmi2,lzcnt,popcnt")

#define endl '\n'
#define F first
#define S second

typedef long long ll;
using namespace std;
using namespace __gnu_pbds;

mt19937 rng(time(nullptr));
mt19937_64 rngl(time(nullptr));
ll rnd(ll x) {
    uniform_int_distribution<ll>uid(0, x - 1);
    return uid(rngl);
}
int rnd(int x) {
    uniform_int_distribution<int>uid(0, x - 1);
    return uid(rng);
}

int n, k, t;
int a[300010], nxt[300010], cnt[300010];
unordered_set <int> gl;

pair <int, int> get(int i) {
    if (i >= n)
        return {i, 0};
    if (nxt[i] >= n) {
        cnt[i] = 1;
        return {nxt[i], cnt[i]};
    }
    auto now = get(nxt[i]);
    nxt[i] = now.F;
    cnt[i] = now.S + 1;
    return {nxt[i], cnt[i]};
}

void solve() {
    cin >> n >> k >> t;
    gl.reserve(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        gl.insert(a[i]);
    }
    if (gl.size() <= t) {
        cout << 1 << endl;
        return;
    }
    unordered_map <int, int> st;
    st.reserve(t + 5);
    int si = -1;
    while (st.size() <= t) {
        si++;
        st[a[si % n]]++;
    }
    nxt[0] = si;
    for (int i = 1; i < n; i++) {
        st[a[i - 1]]--;
        if (st[a[i - 1]] == 0)
            st.erase(a[i - 1]);
        while (st.size() <= t) {
            si++;
            st[a[si % n]]++;
        }
        nxt[i] = si;
    }
    for (int i = 0; i < n; i++) {
        cnt[i] = 1;
        while (nxt[i] < n) {
            cnt[i]++;
            nxt[i] = nxt[nxt[i]];
        }
    }
    //for (int i = 0; i < n; i++)
    //    get(i);
    ll id = 0, ans = 0;
    while (k--) {
        ans += cnt[id];
        id = nxt[id] % n;
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll start = time(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    ll end = time(nullptr);
    cerr << "Ulyanovsk is the best!!!" << endl;
    cerr << "Execution time: " << end - start << " ms" << endl;
}
