#include <iostream>
#include <vector>
#include <set>
#include <map>
using namespace std;

int main() {
    long long n, k, t;
    cin >> n >> k >> t;
    vector<long long> v(2 * n);
    set<long long> a;
    for (long long i = 0; i < n; i++) {
        cin >> v[i];
        v[i + n] = v[i];
        a.insert(v[i]);
    }
    if (a.size() <= t) {
        cout << 1;
        return 0;
    }
    set<long long> s;
    map<long long, long long> cnt;
    vector<long long> m(n);
    long long r = -1;
    for (long long l = 0; l < n ; l++) {
        while (s.size() <= t && r < 2 * n) {
            r++;
            cnt[v[r]]++;
            s.insert(v[r]);
        }
        m[l] = r % n;
        cnt[v[l]]--;
        if (cnt[v[l]] == 0)
            s.erase(v[l]);
    }
    long long pos = 0, d = 0, g = 0, st, dc, gc;
    vector<long long> days(n, -1);
    vector<long long> gift(n, -1);
    while (true) {
        if (days[pos] != -1) {
            st = pos;
            dc = d - days[pos];
            gc = g - gift[pos];
            break;
        }
        days[pos] = d;
        gift[pos] = g;
        if (pos < m[pos]) {
            d += 1;
            g += m[pos] - pos;
        } else {
            d += 1;
            g += n - pos + m[pos];
        }
        pos = m[pos];
    }
    //cout << days[st] << ' ' << gift[st] << ' ' << st << ' ' << dc << ' ' << gc << endl;
    k = k * n - gift[st];
    long long ans = days[st] + (k / gc) * dc;
    k = k % gc;
    pos = st;
    while (k > 0) {
        ans++;
        if (pos < m[pos]) {
            k -= m[pos] - pos;
        } else {
            k -= n - pos + m[pos];
        }
        pos = m[pos];
    }
    cout << ans;
}
