#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
#define ll long long
#define nl '\n'
#define emp emplace_back
#define all(x) x.begin(), x.end()

using namespace std;
//using namespace __gnu_pbds;
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto x : a) {
        out << x << ' ';
    }
    out << '\n';
    return out;
}

mt19937 rnd(time(nullptr));

void solve() {
    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> a(n);
    cin >> a;
    vector<ll> p;
    set<ll> st;
    for (auto x : a) {
        st.insert(x);
    }
    if ((ll)st.size() <= t) {
        cout << 1;
        return;
    }
    if (t == 1) {
        ll cnt = 0;
        for (ll i = 0; i < n; ) {
            ll j = i + 1;
            while (j < n && a[j] == a[i]) {
                ++j;
            }
            ++cnt;
            i = j;
        }
        ll kol = cnt * k;
        if (a[0] == a[n - 1]) {
            kol -= (k - 1);
        }
        cout << (kol + t - 1) / t;
        return;
    }
    for (ll i = 0; i < n; ) {
        ll j = i + 1;
        while (j < n && a[j] == a[i]) {
            ++j;
        }
        p.emp(a[i]);
        i = j;
    }
    n = (ll)p.size();
    for (ll i = 0; i < n; ++i) {
        p.emp(p[i]);
    }
    ll u = 1;
    map<ll, ll> mp;
    for (ll i = 0; i < 2 * n; ++i) {
        if (mp[p[i]] == 0) {
            mp[p[i]] = u++;
        }
        p[i] = mp[p[i]];
    }
    vector<ll> nxt(n);
    ll last = 0;
    vector<ll> h(u);
    ll g = 0;
    for (ll i = 0; i < n; ++i) {
        while (g <= t) {
            ++h[p[last]];
            if (h[p[last]] == 1) {
                ++g;
            }
            ++last;
        }
        --last;
        --h[p[last]];
        --g;
        nxt[i] = last - i;
        --h[p[i]];
        if (h[p[i]] == 0) {
            --g;
        }
    }
    vector<ll> used(n);
    vector<ll> path;
    ll sum = 0;
    ll i = 0;
    ll cnt = 0;
    while (sum < n * k && !used[i]) {
        sum += nxt[i];
        path.emp(i);
        used[i] = 1;
        ++cnt;
        i += nxt[i];
        i %= n;
    }
    if (sum >= n * k) {
        cout << cnt;
        return;
    }
    sum = n * k;
    path.emp(i);
    ll x = 0;
    ll j = 0;
    ll ans = 0;
    for (; j < (ll)path.size(); ++j) {
        if (path[j] == i) {
            break;
        }
        x += nxt[path[j]];
        ++ans;
    }
    ll c = 0;
    ll m = (ll)path.size() - j - 1;
    vector<ll> d;
    for (; j < path.size() - 1; ++j) {
        c += nxt[path[j]];
        d.emp(nxt[path[j]]);
    }
    sum -= x;
    ll r = sum / c;
    sum %= c;
    ans += r * m;
    for (auto d1 : d) {
        if (sum <= 0) {
            break;
        }
        ++ans;
        sum -= d1;
    }
    cout << ans;
}

int main() {
#ifdef CLOCK
    ll time1 = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    cin >> tpk;
#endif

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef CLOCK
    cout << clock() - time1 << " ms";
#endif
}
