//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt,fma")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>


using namespace std;
using namespace __gnu_pbds;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const long long RANDOM = chrono::high_resolution_clock::now().time_since_epoch().count();
constexpr int MAXN = 1 << 20;
constexpr long long mod = 1e9 + 7;
mt19937 rnd(RANDOM);

void solve() {
    int n;
    ll k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    set<int> ch;
    for (auto &i: a) {
        cin >> i;
        ch.insert(i);
    }
    if (ch.size() <= t) {
        cout << 1;
        return;
    }
    for (int i = 0; i < n; i++) {
        a.push_back(a[i]);
    }
    vector<int> g(n, 2 * n - 1);
    for (int i = 0; i < n; i++) {
        set<int> st;
        for (int j = i; j < 2 * n; j++) {
            st.insert(a[j]);
            if (st.size() == t) {
                g[i] = j;
            }
        }
    }
    vector<int> b(n), cnt(n);
    for (int i = 0; i < n; i++) {
        int in = i;
        while (in < n) {
            in = g[in] + 1;
            cnt[i]++;
        }
        b[i] = in;
    }
    ll last = 0;
    ll ans = 0;
    while (last < k * n) {
        int in = b[last % n];
        ans += cnt[last % n];
        last += in - last % n;
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
//    cin>>q;
    while (q--) {
        solve();
    }
}
