//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt,fma")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>


using namespace std;
using namespace __gnu_pbds;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const long long RANDOM = chrono::high_resolution_clock::now().time_since_epoch().count();
constexpr int MAXN = 1 << 20;
constexpr long long mod = 1e9 + 7;
mt19937 rnd(RANDOM);

void solve() {
    int n;
    ll k, t;
    cin >> n >> k >> t;
    vector<int> a(n), zip;
    set<int> CHECK;
    for (auto &i: a) {
        cin >> i;
        CHECK.insert(i);
    }
    if (CHECK.size() <= t) {
        cout << 1;
        return;
    }
    zip = a;
    sort(zip.begin(), zip.end());
    zip.resize(unique(zip.begin(), zip.end()) - zip.begin());
    for (auto &i: a) {
        i = lower_bound(zip.begin(), zip.end(), i) - zip.begin();
    }
    for (int i = 0; i < n; i++) {
        a.push_back(a[i]);
    }
    vector<int> g(n, 2 * n);
    vector<int> ch(n);
    set<int> st;
    int l = 0;
    for (int i = 0; i < 2 * n; i++) {
        if (l >= n) {
            break;
        }
        st.insert(a[i]);
        ch[a[i]]++;
        while (st.size() > t && l < n) {
            g[l] = i;
            ch[a[l]]--;
            if (!ch[a[l]]) {
                st.erase(a[l]);
            }
            l++;
        }
    }
    vector<int> b(n), cnt(n);
    for (int i = n - 1; i >= 0; i--) {
        if (g[i] >= n) {
            b[i] = g[i];
            cnt[i] = 1;
        } else {
            cnt[i] = cnt[g[i]] + 1;
            b[i] = b[g[i]];
        }
    }
    ll last = 0;
    ll ans = 0;
    for (int i = 0; i < k; i++) {
        int in = b[last % n];
        ans += cnt[last % n];
        last += in - last % n;
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
//    cin>>q;
    while (q--) {
        solve();
    }
}
