#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <climits>

using namespace std;

typedef long long ll;
typedef vector<int> vint;
typedef pair<int, int> pint;

struct jet{
    int to, cost;
};
vint powers;
int p = 7;
int mod = 1e9 + 7;

int hashgen(vint& v){
    int res = 0;
    for (int i = 0; i < v.size(); ++i) {
        res += v[i] * powers[i];
        res %= mod;
    }
    return res;
}


void solve(){
    int n, k, t;
    cin >> n >> k >> t;
    vint v_44(n);
    powers.resize(n + 2);
    powers[0] = 1;
    for (int j = 1; j < powers.size(); ++j) {
        powers[j] = powers[j - 1] * p;
        powers[j] %= mod;
    }
    for (int i = 0; i < n; ++i) {
        cin >> v_44[i];
    }
    unordered_map<int, int> coord;
    for (int l = 0; l < n; ++l) {
        if (coord[v_44[l]] == 0) {
            coord[v_44[l]] = l + 1;
        }
    }
    vint v;
    for (int i = 0; i < n; ++i) {
        v.push_back(coord[v_44[i]]);
    }
    int last = v[0], ans = 0;
    for (int i = 0; i < n; ++i) {
        if (v[i] != last){
            ans++;
        }
        last = v[i];
    }
    int res = -1;
    if (last == v[0]){
        res = k * ans + 1;
    }
    else{
        ans++;
        res = k * ans;
    }
    if (t == 1) {
        cout << res;
        return;
    }
    int ind = 0, cnt = 0, ans2 = 0, open = 1, passed = 0, cycle_val = -1, cycle_ans = -1;
    unordered_map<int, int> m;
    unordered_map<int, int> remember;
    unordered_map<int, int> anshash;


    int hash = 0;

    while (k > 0){
        if (ind == 0){
            if (remember[hash] != 0){
                cycle_val = remember[hash];
                cycle_ans = anshash[hash];
                break;
            }
            remember[hash] = passed;
            anshash[hash] = ans2;
        }
        if (!m[v[ind]]){
            m[v[ind]] = 1;
            hash += v[ind] * powers[v[ind]];
            hash %= mod;
            cnt++;
        }
        if (cnt == t + 1){
            cnt = 1;
            ans2++;
            m.clear();
            m[v[ind]] = 1;
            hash = 0;
            hash += v[ind] * powers[v[ind]];
            hash %= mod;
        }
        ind++;
        if (ind >= n){
            ind %= n;
            k--;
        }
        passed++;
    }
    if (cycle_val != -1 && k != 0){
        int cycle_len = passed - cycle_val;
        ans2 += k / (cycle_len / n) * (ans2 - cycle_ans);
        k %= (cycle_len / n);
        while (k > 0){
            if (!m[v[ind]]){
                m[v[ind]] = 1;
                cnt++;
            }
            if (cnt == t + 1){
                cnt = 1;
                ans2++;
                m.clear();
                m[v[ind]] = 1;
            }
            ind++;
            if (ind >= n){
                ind %= n;
                k--;
            }
        }
    }
    if (cnt == t){
        open = 0;
        ans2++;
        m.clear();
    }
    cout << ans2 + open;
}



int main(){
    /*int task, group;
    cin >> task >> group;
    */
    solve();
}
