#include <iostream>
#include <vector>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    if (t == 1) {
        int l = 1;
        for (int i = 1; i < n; ++i) {
            if (a[i] != a[i - 1]) {
                l++;
            }
        }
        int p = l - (a[0] == a[n - 1]);
        cout << (ll) l + (ll) p * (k - 1);
        return 0;
    } else {
        vector<int> b(n * k);
        for (int i = 0; i < n * k; ++i) {
            b[i] = a[i % n];
        }
        set<int> st;
        int ans = 0;
        for (int x : b) {
            if (st.find(x) == st.end() && (int) st.size() == t) {
                st.clear();
            }
            if (st.empty()) {
                ans++;
            }
            st.insert(x);
        }
        cout << ans;
    }
}