#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define dbg(a) cout << #a << " = " << a << endl;
#define dbg1(a) cout << #a << " = "; for (auto i : a) cout << i << ' '; cout << endl;
#define dbg2(a) cout << #a << " = "; for (auto [x, y] : a) cout << "{ " << x << ' ' << y << "} "; cout << endl;

const int INF = 1e9 + 7;
const int mod = 1e9 + 7;


void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    set<int> st;
    for (auto &i : a) {
        cin >> i;
        st.insert(i);
    }

    if (st.size() <= t) {
        cout << 1 << '\n';
        return;
    }

    vector<int> a2(2 * n);
    for (int i = 0; i < n; i++)
        a2[i] = a2[i + n] = a[i];

    vector<int> mxr(2 * n);
    map<int, int> cnt;
    int cur = 0;
    int j = 2 * n - 1;
    for (int i = 2 * n - 1; i >= 0; i--) {
        if (cnt[a2[i]] == 0) {
            cur++;
        }
        cnt[a2[i]]++;
        while (cur > t) {
            if (cnt[a2[j]] == 1)
                cur--;
            cnt[a2[j]]--;
            j--;
        }

        mxr[i] = j - i + 1;
    }

    int ans = 0;
    ll cur_cnt = 0;
    int i = 0;
    while (cur_cnt < 1ll * n * k) {
        cur_cnt += mxr[i];
        i = (i + mxr[i]) % n;
        ans++;
    }

    cout << ans << '\n';
}

int main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
