#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define dbg(a) cout << #a << " = " << a << endl;
#define dbg1(a) cout << #a << " = "; for (auto i : a) cout << i << ' '; cout << endl;
#define dbg2(a) cout << #a << " = "; for (auto [x, y] : a) cout << "{ " << x << ' ' << y << "} "; cout << endl;
#define int long long

const int INF = 1e9 + 7;
const int mod = 1e9 + 7;


void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    set<int> st;
    for (auto &i : a) {
        cin >> i;
        st.insert(i);
    }

    if (st.size() <= t) {
        cout << 1 << '\n';
        return;
    }

    vector<int> a2(2 * n);
    for (int i = 0; i < n; i++)
        a2[i] = a2[i + n] = a[i];

    vector<int> mxr(2 * n);
    map<int, int> cnt;
    int cur = 0;
    int j = 2 * n - 1;
    for (int i = 2 * n - 1; i >= 0; i--) {
        if (cnt[a2[i]] == 0) {
            cur++;
        }
        cnt[a2[i]]++;
        while (cur > t) {
            if (cnt[a2[j]] == 1)
                cur--;
            cnt[a2[j]]--;
            j--;
        }

        mxr[i] = j - i + 1;
    }

    int ans = 0;
    ll cur_cnt = 0;
    vector<int> cnt_on_point(n, -1), ind_on_point(n, -1);
    cnt_on_point[0] = 0;
    ind_on_point[0] = 0;
    int i = 0;
    bool run = true;
    ll cycle_len = -1, cycle_cnt = -1;
    while (run) {
        cur_cnt += mxr[i];
        i = (i + mxr[i]) % n;
        ans++;
        if (cnt_on_point[i] != -1) {
            run = false;
            cycle_len = cur_cnt - cnt_on_point[i];
            cycle_cnt = ans - ind_on_point[i];
        } else {
            cnt_on_point[i] = cur_cnt;
            ind_on_point[i] = ans;
        }
    }

//    dbg(i);
//    dbg(cycle_len);
//    dbg(cycle_cnt);

    if (cycle_len + cur_cnt > 1ll * n * k) {
        ans = 0;
        cur_cnt = 0;
        i = 0;
    } else {
        ll cnt_cycles = (1ll * n * k - cur_cnt) / cycle_len;
        ans += cnt_cycles * cycle_cnt;
        cur_cnt += cnt_cycles * cycle_len;
    }

    //int i = 0;
    while (cur_cnt < 1ll * n * k) {
        cur_cnt += mxr[i];
        i = (i + mxr[i]) % n;
        ans++;
    }

    cout << ans << '\n';
}

signed main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
