#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using lll = __int128;
using ld = long double;

ll n, k, t;

ll next(const vi &v, ll start) {
    unordered_map<int, int> mp;

    while (mp.size() <= t) {
        int x = start % (v.size());
        mp[x] = 1;
        start++;
    }
    start--;
    return start;
}

void shiftR(vi &v, ll m) {
    while (v.size() > 1 && (v.front() == v.back()))
        v.pop_back();
    int n = (int)v.size();
    m %= n;
    vi v2(n);
    for (int i = 0; i < n; i++) {
        v2[(i-m+n)%n] = v[i];
    }
    v = v2;
}

int main() {
    cin >> n >> k >> t;

    vi v;
    for (int i = 0; i < n; i++) {
        int a; cin >> a;
        if (!v.empty() && v.back() == a) continue;
        v.push_back(a);
    }

    n = v.size();

    if (t >= n) {
        cout << 1;
        return 0;
    }

    // remove (front == end)
    ll c0 = next(v, 0);
    shiftR(v, c0);
    k--;
    c0 = n - c0;
    n = v.size();

    if (t == 1) {
        cout << 1 + n*k + c0;
        return 0;
    }

    ll delta = 0;
    ll c = 0;
    do {
        delta = next(v, delta);
        c++;
    } while ((delta % n) != 0);

    ll dk = delta/n;
    ll k0 = k % dk;
    k -= k0;
    ll ans = k / dk * c;
    k %= dk;

    ll now = 0;
    while (now < n*k0 + c0) {
        now = next(v, now);
        ans++;
    }
    cout << 1 + ans;
}
/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

 */