#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using lll = __int128;
using ld = long double;

ll n, k, t;

ll next(const vi &v, ll start) {
    unordered_map<int, int> mp;

    while (mp.size() <= t) {
        int x = start % n;
        mp[v[x]] = 1;
        start++;
    }
    start--;
    return start;
}

void shiftR(vi &v, ll m) {
    while (v.size() > 1 && (v.front() == v.back()))
        v.pop_back();
    n = (int)v.size();
    m %= n;
    vi v2(n);
    for (int i = 0; i < n; i++) {
        v2[(i-m+n)%n] = v[i];
    }
    v = v2;
}

int stupid(const vi &v) {
    int c = 0;
    ll now = 0;
    while (now < n*k) {
        now = next(v, now);
    }
    return c;
}

//ll calc(vi &v) {
ll calc() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k >> t;

    vi v;
    for (int i = 0; i < n; i++) {
        int a; cin >> a;
        if (!v.empty() && v.back() == a) continue;
        v.push_back(a);
    }

    n = v.size();

    if (t >= n) {
        return 1;
    }

    // remove (front == end)
    ll c1 = next(v, 0);
    ll c0 = n - c1;
    shiftR(v, c0);
    k--;

    if (t == 1) {
        return 1 + n*k + c0;
    }

    ll delta = 0;
    ll c = 0;
    do {
        delta = next(v, delta);
        c++;
    } while ((delta % n) != 0);

    ll dk = delta/n;
    ll k0 = k % dk;
    k -= k0;
    ll ans = k / dk * c;

    ll now = 0;
    while (now < n*k0 + c0) {
        now = next(v, now);
        ans++;
    }
    return 1 + ans;
}
int main() {
//    vi v = {1, 2, 1, 3, 4, 5};
//    n = v.size();
//    t = 4;
//    cout << next(v, 0) << "\n";
//    cout << next(v, next(v, 0)) << "\n";
    cout << calc();
}
