#include <iostream>
#include <set>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

vector <ll> g;
vector <bool> used;
vector <int> p;
int f, s;

bool dfs(int v) {
	used[v] = 1;
	if (!used[g[v]]) {
		p[g[v]] = v;
		return dfs(g[v]);
	}
	else {
		f = v, s = g[v];
		return 0;
	}
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	ll n, k, t; cin >> n >> k >> t;
	vector <ll> a(n), b(n * 2);
	g.resize(n), used.resize(n), p.resize(n, -1);
	set <int> c;
	for (int i = 0; i < n; i++) cin >> a[i], c.insert(a[i]);
	if (c.size() <= t) { cout << 1; return 0; }
	map <int, int> kol;
	ll cnt = 1, l = -1;
	kol[a.back()]++;
	while (cnt <= t) {
		l++;
		if (!kol[a[l]]) cnt++;
		kol[a[l]]++;
	}
	kol[a[l]]--;
	cnt--;
	l--;
	l = (l + n) % n;
	g[n - 1] = (l + 1) % n;
	for (int i = n - 2; i >= 0; i--) {
		if (!kol[a[i]]) cnt++;
		kol[a[i]]++;
		while (cnt > t) {
			kol[a[l]]--;
			if (!kol[a[l]]) cnt--;
			l--;
			l = (l + n) % n;
		}
		g[i] = (l + 1) % n;
	}
	dfs(0);
	vector <int> cycle;
	for (f; f != p[s]; f = p[f]) cycle.push_back(f);
	reverse(cycle.begin(), cycle.end());
	ll ccost = 0;
	for (int i = 0; i < cycle.size(); i++) {
		if (g[cycle[i]] > cycle[i]) ccost += g[cycle[i]] - cycle[i];
		else ccost += g[cycle[i]] + n - cycle[i];
	}
	cnt = 0;
	ll v = 0, ans = 0;
	while (cnt < n * k && v != s) {
		if (g[v] > v) cnt += g[v] - v;
		else cnt += g[v] + n - v;
		ans++;
		v = g[v];
	}
	if (cnt >= n * k) { cout << ans; return 0; }
	ll ost = n * k - cnt;
	ans += ost / ccost * ll(cycle.size());
	ost = ost - ost / ccost * ccost;
	v = s, cnt = 0;
	while (cnt < ost) {
		if (g[v] > v) cnt += g[v] - v;
		else cnt += g[v] + n - v;
		ans++;
		v = g[v];
	}
	cout << ans;
	return 0;
}