#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n, k, t;
    cin >> n >> k >> t;
    vector<ll> a(n);
    set<ll> types;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        types.insert(a[i]);
    }
    ll m = types.size();
    if (m <= t) {
        cout << "1\n";
        return 0;
    }

    set<ll> cur_types;
    vector<ll> one_person(n);
    unordered_map<ll, ll> type_cnt;
    one_person[0] = 0;
    cur_types.insert(a[0]);
    type_cnt[a[0]] = 1;

    while (cur_types.size() <= t) {
        if (++one_person[0] == n) {
            one_person[0] = 0;
        }
        if (++type_cnt[a[one_person[0]]] == 1) {
            cur_types.insert(a[one_person[0]]);
        }
    }

    for (ll i = 0; i < n;) {
        while (i < n && cur_types.size() > t) {
            i++;
            one_person[i] = one_person[i - 1];
            if (--type_cnt[a[i - 1]] == 0) {
                cur_types.erase(a[i - 1]);
            }
        }

        while (cur_types.size() <= t) {
            if (++one_person[i] == n) {
                one_person[i] = 0;
            }
            if (++type_cnt[a[one_person[i]]] == 1) {
                cur_types.insert(a[one_person[i]]);
            }
        }
    }

    ll cur_laps = 0, cur_start = 0, person_done = 0;
    vector<ll> laps(n, -1), person(n);
    while (cur_laps < k && laps[cur_start] == -1) {
        laps[cur_start] = cur_laps;
        person[cur_start] = person_done;
        if (cur_start >= one_person[cur_start]) {
            cur_laps++;
        }
        cur_start = one_person[cur_start];
        person_done++;
    }
    if (cur_laps == k) {
        cout << person_done << '\n';
        return 0;
    }

    ll cycle_skip = (k - cur_laps) / (cur_laps - laps[cur_start]);
    person_done += cycle_skip * (person_done - person[cur_start]);
    cur_laps += cycle_skip * (cur_laps - laps[cur_start]);
    while (cur_laps < k) {
        if (cur_start >= one_person[cur_start]) {
            cur_laps++;
        }
        cur_start = one_person[cur_start];
        person_done++;
    }
    cout << person_done << '\n';
}
