#ifndef LOCALEGOR
#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,sse2,bmi2")
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ld PI = acosl(-1.0);

mt19937 rnd(3105);

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    a.insert(a.end(), all(a));
    a.push_back(a[0]);
    set<int> s;
    map<int, int> mp;
    int r = n - 1;
    s.insert(a[n - 1]);
    mp[a[n - 1]]++;
    vector<int> jump(n);
    while (true) {
        if (mp[a[r+1]]||(!mp[a[r+1]]&&sz(s)<t)){
            ++r;
            mp[a[r]]++;
            s.insert(a[r]);
            if (r == 2 * n) {
                cout << 1;
                return;
            }
        } else {
            break;
        }
    }
    jump[n - 1] = (r + 1) % n;
    for (int l = n - 2; ~l; --l) {
        ++mp[a[l]];
        s.insert(a[l]);
        while (sz(s) > t) {
            --mp[a[r]];
            if (mp[a[r]] == 0) s.erase(a[r]);
            --r;
        }
        jump[l] = (r + 1) % n;
    }
    bool f = false;
    int cur = 0;
    int ans = 0;
    int it = 0;
    while (true) {
        if (f && cur == 0) break;
        if (cur == 0) f = true;
        ++ans;
        int tar = jump[cur];
        if (tar < cur) {
            --k;
            ++it;
        }
        cur = tar;
        if (k == 0) break;
    }
    ans += (k / it) * ans;
    k %= it;
    
    while (k) {
        ++ans;
        int tar = jump[cur];
        if (tar < cur) {
            --k;
        }
        cur = tar;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen(R"(C:\Users\olymp\CLionProjects\main\INPUT.txt)", "r", stdin);
#endif
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}