#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7, LOG = 50;

void solve()
{
	long long n, k, t;
	vector<long long> v;
	cin >> n >> k >> t;
	v.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
	}
	vector<long long> uv = v;
	sort(uv.begin(), uv.end());
	uv.erase(unique(uv.begin(), uv.end()), uv.end());
	for (auto& i : v)
	{
		i = lower_bound(uv.begin(), uv.end(), i) - uv.begin();
	}
	if (t >= uv.size())
	{
		cout << 1 << "\n";
		return;
	}

	vector<long long> dv = v;
	for (auto& i : v)
	{
		dv.push_back(i);
	}

	vector<long long> nxt(n), add(n);
	long long j = -1;
	vector<long long> cnt(n);
	long long dif = 0;
	for (long long i = 0; i < n; i++)
	{
		while (dif <= t)
		{
			j++;
			cnt[dv[j]]++;
			if (cnt[dv[j]] == 1)
			{
				dif++;
			}
		}
		nxt[i] = j % n;
		add[i] = j - i;

		cnt[dv[i]]--;
		if (cnt[dv[i]] == 0)
		{
			dif--;
		}
	}

	vector<vector<long long>> binup(n, vector<long long>(LOG)), binadd(n, vector<long long>(LOG));
	long long dist = n * k;
	for (long long i = 0; i < n; i++)
	{
		binup[i][0] = nxt[i];
		binadd[i][0] = min(add[i], dist + 1);
	}
	for (long long j = 1; j < LOG; j++)
	{
		for (long long i = 0; i < n; i++)
		{
			binup[i][j] = binup[binup[i][j - 1]][j - 1];
			binadd[i][j] = binadd[i][j - 1] + binadd[binup[i][j - 1]][j - 1];
			binadd[i][j] = min(binadd[i][j], dist + 1);
		}
	}

	long long ans = 0, cur = 0;
	for (long long i = LOG - 1; i > -1; i--)
	{
		if (binadd[cur][i] > dist)
		{
			continue;
		}

		dist -= binadd[cur][i];
		cur = binup[cur][i];
		ans += (1ll << i);
	}
	if (dist)
	{
		ans++;
	}
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
