#pragma GCC optimize("03")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("0fast")

#include <bits/stdc++.h>

//#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
#define pii pair <int, int>
#define x first
#define y second
using namespace std;

const ll maxn = 3e5 + 5, inf = 1e18, mod = 1e9 + 7;



struct node {
    int x = 0; ll y = 0, cnt = 0;
    node() {
        x = y = cnt = 0;
    }
};

const int ln1 = 20, ln2 = 20; //, ln3 = 20;

//vector <vector <pair <int, ll> > > sparse(30, vector <pair <int, ll> > (maxn));
pair <int, ll> sparse[ln1][maxn];
//pair <int, ll> sparse3[ln3][maxn];

//vector <vector <node > > sparse2(25, vector <node > (maxn));
node sparse2[ln2][maxn];
//node sparse3[ln3][maxn];

void build_sparse(int n, vector <int> & nxt) {
    for (int i = 0; i < n; i++) {
        sparse[0][i] = {nxt[i], (nxt[i] < i)};
    }
    for (int pw = 1; pw < ln1; pw++) {
        for (int i = 0; i < n; i++) {
            sparse[pw][i].x = sparse[pw - 1][sparse[pw - 1][i].x].x;
            sparse[pw][i].y = sparse[pw - 1][sparse[pw - 1][i].x].y + sparse[pw - 1][i].y;
        }
    }
}

//void build_sparse3(int n) {
//    for (int pw = 1; pw < ln3; pw++) {
//        for (int i = 0; i < n; i++) {
//            sparse3[pw][i].x = sparse3[pw - 1][sparse3[pw - 1][i].x].x;
//            sparse3[pw][i].y = sparse3[pw - 1][sparse3[pw - 1][i].x].y + sparse3[pw - 1][i].y;
//            sparse3[pw][i].cnt = sparse3[pw - 1][sparse3[pw - 1][i].x].cnt + sparse3[pw - 1][i].cnt;
//        }
//    }
//}

void build_sparse2(int n) {

    for (int pw = 1; pw < ln2; pw++) {
        for (int i = 0; i < n; i++) {
            sparse2[pw][i].x = sparse2[pw - 1][sparse2[pw - 1][i].x].x;
            sparse2[pw][i].y = sparse2[pw - 1][sparse2[pw - 1][i].x].y + sparse2[pw - 1][i].y;
            sparse2[pw][i].cnt = sparse2[pw - 1][sparse2[pw - 1][i].x].cnt + sparse2[pw - 1][i].cnt;
        }
    }
}

void solve1(int n, ll k, int t, vector <int> & a) {
    vector <int> st;
    for (auto & e : a) {
        if (st.empty() || st.back() != e) {
            st.emplace_back(e);
        }
    }
    ll col = sz(st);
    col = col * k - (k - 1) * (st.back() == st[0]);
    cout << col;

}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, k, t;
    cin >> n >> k >> t;
    vector <int> a(n);
    set <int> s;
    for (auto & e : a) {
        cin >> e;
        s.insert(e);
    }
    if (sz(s) <= t) {
//        assert(0);
        cout << "1\n";
        return 0;
    }
    if (t == 1) {


        solve1(n, k, t, a);
        return 0;
    }
    vector <int> tmp = a;
//    reverse(all(tmp));
    for (int i = 0; i < n; i++) {
        tmp.emplace_back(tmp[i]);
    }
    s.clear();
    int r = 0;
    vector <int> nxt(sz(tmp));
    map <int, int> cnt;
    for (int l = 0; l < sz(tmp); l++) {
        while (r < sz(tmp) && sz(s) <= t) {
            s.insert(tmp[r]);
            cnt[tmp[r]]++;
            r++;
        }
        if (l == n) break;
        nxt[l] = (r - 1) % n;
        cnt[tmp[l]]--;
        if (!cnt[tmp[l]]) {
            s.erase(tmp[l]);
        }

    }
//    for (int i = 0; i < n; i++) {
//        cout << nxt[i] << " ";
//    }
//    cout << "\n\n";
    build_sparse(n, nxt);

    ll ans = 0, h = 0;
    k--;
    for (int i = 0; i < n; i++) {
        node nd;
        nd.x = i;
        for (int pw = ln1 - 1; pw >= 0; pw--) {
            if (sparse[pw][nd.x].y == 0) {
                nd.cnt += (1ll << pw);
                nd.x = sparse[pw][nd.x].x;
//            cout << pw << " " << sparse[pw][h].y << "\n";
            }
        }
        nd.y = 1;
        nd.cnt += 1;
        nd.x = sparse[0][nd.x].x;
        sparse2[0][i] = nd;
//        cout << i << " " << nd.x << endl;
    }
    build_sparse2(n);

    for (int pw = ln2 - 1; pw >= 0; pw--) {
        if (sparse2[pw][h].y <= k) {
//            cout << pw << " " << sparse[pw][h].y << " " << k << "\n";

            k -= sparse2[pw][h].y;

            ans += sparse2[pw][h].cnt;
            h = sparse2[pw][h].x;
        }
    }
    for (int pw = ln1 - 1; pw >= 0; pw--) {
        if (sparse[pw][h].y <= k) {
//            cout << pw << " " << sparse[pw][h].y << " " << k << "\n";

            k -= sparse[pw][h].y;

            ans += (1ll << pw);
            h = sparse[pw][h].x;
        }
    }
    if (h) {
        ans++;
    }
    cout << ans;
//    TREE tree(sz(tmp));

}
