#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<
        T,
        null_type,
        less<T>,
        rb_tree_tag,
        tree_order_statistics_node_update
        >;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

//mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rng(117239);

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<int> srt = a;
    sort(all(srt));
    srt.resize(unique(all(srt)) - srt.begin());

    if (srt.size() <= t) {
        cout << 1 << '\n';
        return 0;
    }

    for (auto& el : a) el = lower_bound(all(srt), el) - srt.begin();

    for (int i = 0; i < n; i++) a.push_back(a[i]);

    vector<ll> mx(n);
    vector<int> cnt(n);
    int j = 0;
    int cur = 0;
    for (int i = 0; i < n; i++) {
        while (j < 2 * n) {
            int nxt = a[j];
            if (cnt[nxt] > 0 || cur < t && cnt[nxt] == 0) {
                if (cnt[nxt] == 0) cur++;
                cnt[nxt]++;
                j++;
            } else {
                break;
            }
        }

        mx[i] = j;

        if (cnt[a[i]] == 1) cur--;
        cnt[a[i]]--;
    }

    vector<array<ll, 2>> up[60];
    up[0].resize(n);
    for (int i = 0; i < n; i++) up[0][i] = {mx[i] % n, mx[i] - i};

    for (int i = 0; i + 1 < 60; i++) {
        up[i + 1].resize(n);
        for (int j = 0; j < n; j++) {
            int to = up[i][j][0];
            up[i + 1][j][0] = up[i][to][0];
            up[i + 1][j][1] = min(k * n, up[i][j][1] + up[i][to][1]);
        }
    }

    ll ans = 0;
    ll x = k * n;
    int id = 0;
    for (int i = 59; i >= 0; i--) {
        if (up[i][id][1] < x) {
            x -= up[i][id][1];
            ans += 1LL << i;
            id = up[i][id][0];
        }
    }
    ans++;

    cout << ans << '\n';

    return 0;
}
