#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n, k, t;
    cin >> n >> k >> t;

    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        a.push_back(a[i]);
    }

    map <int, int> mp;
    vector <int> mx(n);
    int l = 0, r = -1;
    int cur = 0;
    for (int i = 0; i < n; i++) {
        while ((r + 1) - l + 1 <= n && (mp[a[r + 1]] > 0 || cur < t)) {
            r++;
            mp[a[r]]++;
            if (mp[a[r]] == 1) {
                cur++;
            }
        }
        mx[i] = r - l + 1;
        mp[a[l]]--;
        if (mp[a[l]] == 0) {
            cur--;
        }
        l++;
    }
    if (mx[0] == n) {
        cout << 1 << "\n";
        return;
    }
    int cycle = 0, cnt_cycle = 0, end = 0;
    int done = 0, done_p = 0;
    {
        vector <int> pref(n);
        vector <int> tin(n, -1);
        int timer = 0;
        int i = 0;
        while (true) {
            if (tin[i] != -1) {
                cycle = done - pref[i];
                cnt_cycle = timer - tin[i];
                end = i;
                break;
            }
            pref[i] = done;
            tin[i] = timer++;
            done += mx[i];
            done_p++;
            i += mx[i];
            i %= n;
        }
    }
    int total = n * k;
    if (total < done) {
        int ans = 0;
        int i = 0;
        while (total > 0) {
            ans++;
            total -= mx[i];
            i += mx[i];
            i %= n;
        }
        cout << ans << "\n";
        return;
    }
    int ans = done_p;
    total -= done;
    ans += total / cycle * cnt_cycle;
    total %= cycle;
    while (total > 0) {
        ans++;
        total -= mx[end];
        end += mx[end];
        end %= n;
    }
    cout << ans << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}