#include<iostream>
#include<vector>
#include<string>
#include<sstream>
#include<cmath>
#include<algorithm>
#include<stdio.h>
#include<random>
#include<ctime>
#include<iomanip>
#include<memory.h>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<stack>
#include<deque>
#include<queue>
#define int long long
#define pii pair<int, int>
#define pb push_back
#define fir first
#define sec second
#define endl '\n'
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

mt19937 rnd(228);

int begcyc = -1;

void dfs(vector<int>& gr, int v, vector<int>& used) {
	used[v] = 1;
	if (used[gr[v]])
		begcyc = gr[v];
	else
		dfs(gr, gr[v], used);
	return;
}


int stress(int n, int k, int t, vector<int> vc) {
	int ans = 0;
	int id = 0;
	for (int i = 0; i < k - 1; i++) {
		for (int j = 0; j < n; j++)
			vc.pb(vc[j]);
	}
	while (id < vc.size()) {
		unordered_set<int> st;
		for (int i = id; i < vc.size(); i++) {
			st.insert(vc[i]);
			if (st.size() > t) {
				ans++;
				break;
			}
			id++;
		}
		if (st.size() > 0 && st.size() != t + 1)
			ans++;
	}
	return ans;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, k, t;
	cin >> n >> k >> t;
	//n = 13;
	//k = rnd() % 10 + 1;
	//t = rnd() % 10 + 1;
	int nn = n, kk = k, tt = t;


	vector<int> vc(n);
	for (int& i : vc) //i = rnd() % 10;
		cin >> i;

	unordered_set<int> rz;
	for (int i : vc) {
		rz.insert(i);
	}

	if (rz.size() <= t) {
		cout << 1;
		return 0;
	}

	//int str = stress(n, k, t, vc); // << '\n';

	for (int i = 0; i < n; i++)
		vc.pb(vc[i]);

	vector<int> gr(n, -1);
	int id = 0;
	while (gr[id] == -1) {
		int l = 0, r = n + 1;
		while (r - l > 1) {
			int m = (r + l) / 2;
			unordered_set<int> st;
			for (int i = id; i - id < m; i++) {
				st.insert(vc[i]);
			}
			if (st.size() > t)
				r = m;
			else
				l = m;
		}
		gr[id] = (id + l) % n;
		id = (id + l) % n;
	}
	vector<int> used(n);
	dfs(gr, 0, used);

	vector<int> cycle;
	int inv = 0;
	id = begcyc;

	do {
		cycle.pb(id);
		id = gr[id];
	} while (id != begcyc);

	for (int i = 0; i < cycle.size(); i++) {
		inv += (cycle[i] > cycle[(i + 1) % (int)(cycle.size())]);
		
	}

	int ans = 0;
	id = 0;
	while (id != begcyc && k > 0) {
		ans++;
		int nid = gr[id];
		if (nid < id) {
			k--;
		}
		id = nid;
	}
	if (begcyc != 0)
		k--;
	ans += k / inv * cycle.size();
	k -= k / inv * inv;

	id = begcyc;

	if (begcyc != 0)
		k++;
	while (k > 0) {
		ans++;
		int nid = gr[id];
		if (nid < id) {
			k--;
		}
		id = nid;
	}

	//if (ans != str) {
	//	int ko = 0;
	//}
	cout << ans; // << " " << str;
	return 0;
}

/*
15 1 3
1 1 2 3 2 1 4 1 5 6 4 4 1 3 7


7 2 3
1 2 3 4 5 6 7


10 10 4
2 7 2 1 5 5 2 9 3 5

13
4
7
5 7 8 6 1 5 4 7 0 5 0 2 3
*/