#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;
using ll = long long;
using ld = long double;

//#define int ll
#define all(x) x.begin(), x.end()
#pragma GCC optimize("Ofast")

const int N = 3e5 + 5;
int a[600005];
int to[N], sz[N], q[N];
pair<int, int> dp[N];
ll used[N];

//vector<int> t[1 << 23];
//
//void build(int v, int l, int r) {
//	if (l == r - 1) {
//		t[v] = { a[l] };
//		return;
//	}
//	int m = (l + r) / 2;
//	build(2 * v + 1, l, m);
//	build(2 * v + 2, m, r);
//	t[v].resize(r - l);
//	merge(all(t[2 * v + 1]), all(t[2 * v + 2]), t[v].begin());
//}
//
//int ask(int v, int l, int r, int askl, int askr, int x) {
//	if (r <= askl || askr <= l)return 0;
//	if (askl <= l && r <= askr)return upper_bound(all(t[v]), x) - t[v].begin();
//	int m = (l + r) / 2;
//	return ask(2 * v + 1, l, m, askl, askr, x) + ask(2 * v + 2, m, r, askl, askr, x);
//}

/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

17 6 7
13 7 11 10 13 14 4 13 1 12 1 1 10 5 8 4 6
12

5 5 2
5 5 3 3 1
8

8 4 3
8 2 1 3 2 8 6 1
9

*/

void solve() {
	int n, k, t;
	cin >> n >> k >> t;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	if (t == 1) {
		for (int i = 0; i < n; ++i)a[n + i] = (a[i]);
		ll r = 1;
		ll tmp = (a[0] == a[2 * n - 1]);
		for (int i = 1; i < 2 * n; ++i) {
			if (a[i] != a[i - 1]) {
				r++;
			}
		}
		ll w = 0;
		for (int i = n; i < 2 * n; ++i) {
			if (a[i] != a[i - 1]) {
				w++;
			}
		}
		cout << 1ll * (r - tmp) * 1ll * (k / 2) + (k % 2 ? w : 0) + tmp << '\n';
		return;
	}
	vector<int> b;
	for (int i = 0; i < n; ++i)b.push_back(a[i]);
	sort(b.begin(), b.end());
	b.resize(unique(b.begin(), b.end()) - b.begin());
	for (int& i : a) {
		i = lower_bound(b.begin(), b.end(), i) - b.begin();
	}
	if (b.size() <= t) {
		cout << "1\n";
		return;
	}
	multiset<int> s;
	int cnt = 0;
	int p = 0;
	int steps = 0;
	for (int i = 0; i < n && cnt <= t; ++i) {
		if (s.count(a[i]) == 0) {
			if (cnt + 1 > t)
				break;
			cnt++;
		}
		p = i;
		s.insert(a[i]);
		++steps;
	}
	to[0] = p + 1;
	sz[0] = s.size();
	for (int i = 1; i < n; ++i) {
		s.erase(s.find(a[i - 1]));
		if (s.count(a[i - 1]) == 0) {
			cnt--;
		}
		p = to[i - 1] - 1;
		for (int j = to[i - 1]; j < n && cnt <= t; ++j) {
			++steps;
			if (s.count(a[j]) == 0) {
				if (cnt + 1 > t)
					break;
				cnt++;
			}
			s.insert(a[j]);
			p = j;
		}
		assert(steps < 2 * n);
		to[i] = p + 1;
		sz[i] = s.size();
	}
	dp[n - 1] = { 1, 1 };
	for (int i = n - 2; i > -1; --i) {
		auto c = dp[to[i]];
		dp[i].first = c.first + 1;
		dp[i].second = c.second;
		if (to[i] == n) {
			dp[i].second += sz[i];
		}
	}
	 p = 0;
	for (int i = 0; i < n; ++i) {
		if (to[i] == n) {
			p = i;
			break;
		}
	}
	s.clear();
	cnt = 0;
	for (int i = p; i < n; ++i) {
		if (s.count(a[i]) == 0)
			cnt++;
		s.insert(a[i]);
	}
	int it = 0;
	vector<int> next(n);
	for (int i = p; i < n; ++i) {
		while (it < n) {
			int x = s.count(a[it]);
			if (x == 0 && cnt == t)
				break;
			if (x == 0) {
				cnt++;
			}
			s.insert(a[it]);
			++it;
		}
		next[i] = it;
		s.erase(s.find(a[i]));
		if (s.count(a[i]) == 0)
			cnt--;
	}
	for (int i = p - 1; i > -1; --i) {
		next[i] = next[to[i]];
	}
	ll ans = 0;
	int r = 0;
	q[0] = 0;
	used[0] = 0;
	int f = 1;
	for (int i = 1; i <= k; ++i) {
		ans += dp[r].first;
		r = next[r];
		if (q[r] && i - q[r] <= k - i) {
			ans = used[r] + (1 + (k - i) / (i - q[r])) * (ans - used[r]);
			i = max(i, k - (k - i) % (i - q[r]));
			f--;
		}
		used[r] = ans;
		q[r] = i;
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	//cin >> t;

	for (int _ = 0; _ < t; ++_) {
		solve();
	}

}
