#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>
#include <array>
using namespace std;
using ll = long long;
vector<int> g; vector<int> h, nxt; vector<bool> used;
void dfs(int v) {
	used[v] = 1;
	if (g[v] == -1) return;
	if (!used[g[v]]) dfs(g[v]);
	h[v] = h[g[v]] + 1; nxt[v] = nxt[g[v]];
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, k, t; cin >> n >> k >> t; vector<int> v(n);
	for (auto& i : v) cin >> i;
	vector<int> dp(n); map<int, int> mp; int ln = 0;
	int i = 0, j = 0;
	for (; i < n; i++) {
		for (; ; j++, j %= n) {
			mp[v[j]]++; ln++;
			if (mp.size() > t) {
				dp[i] = ln - 1; break;
			}
			if (ln == n) {
				cout << 1; exit(0);
			}
		}
		ln -= 2; mp[v[j]]--; mp[v[i]]--;
		if (mp[v[j]] == 0) mp.erase(v[j]);
		if (mp[v[i]] == 0) mp.erase(v[i]);
	}
	g.resize(n, -1); h.resize(n, 1); nxt.resize(n); used.resize(n, 0);
	for (int i = 0; i < n; i++) {
		if (i + dp[i] >= n) {
			nxt[i] = (i + dp[i]) % n;
		} else {
			g[i] = i + dp[i];
		}
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) dfs(i);
	}
	ll res = 0; ll pos = 0;
	set<int> st; vector<int> ord;
	while (st.find(pos) == st.end()) {
		ord.push_back(pos); res += h[pos];
		st.insert(pos); pos = nxt[pos];
	}
	ll ans = 0;
	for (int i = 0; ord[i] != pos; i++) {
		ans += h[ord[i]]; st.erase(ord[i]); k--; res -= h[ord[i]];
		if (!k) {
			cout << ans; exit(0);
		}
	}
	ans += res * (k / st.size());
	for (int i = 0; i < (k % st.size()); i++) {
		ans += h[ord[i]];
	}
	cout << ans;
	return 0;
}
