#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, k, t;
    cin >> n >> k >> t;

    if (t > n) {
        cout << 1 << '\n';
        return 0;
    }

    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<ll> nxt(n);
    for (ll i = 0; i < n; i++) {
        ll j = i;
        set<ll> lol;
        while ((ll)lol.size() <= t) {
            lol.insert(a[j]);
            j++;
            if (j == n) {
                j -= n;
            }
            if (j == i) {
                break;
            }
        }

        if (i == j && (ll)lol.size() <= t) {
            cout << 1 << '\n';
            return 0;
        }

        if (j - 1 < 0) {
            nxt[i] = n - 1;
        } else {
            nxt[i] = j - 1;
        }
    }

    ll LOGN = 40;
    vector<vector<array<ll, 3>>> up(LOGN, vector<array<ll, 3>> (n));
    for (ll i = 0; i < n; i++) {
        up[0][i][0] = nxt[i];
        up[0][i][1] = (nxt[i] - i) + (nxt[i] <= i ? n : 0);
        up[0][i][2] = 1;
    }

    for (ll i = 1; i < LOGN; i++) {
        for (ll j = 0; j < n; j++) {
            up[i][j][0] = up[i - 1][up[i - 1][j][0]][0];
            up[i][j][1] = up[i - 1][up[i - 1][j][0]][1] + up[i - 1][j][1];
            up[i][j][2] = up[i - 1][up[i - 1][j][0]][2] + up[i - 1][j][2];
        }
    }

    ll now = 0, ans = 0, c = 0;
    for (ll i = LOGN - 1; i >= 0; i--) {
        if (c + up[i][now][1] <= n * k) {
            ans += up[i][now][2];
            c += up[i][now][1];
            now = up[i][now][0];
        }
    }

    cout << ans + (c != n * k) << '\n';

    return 0;
}
