#include <iostream>

#include <vector>
#include <set>

#include <algorithm>
#include <cmath>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int vs, ks, mx;
    cin >> vs >> ks >> mx;
    vector<int> v(vs);
    for (int &i: v)
        cin >> i;

    vector<int>x;
    while (ks--) {
        for (int i : v) {
            x.push_back(i);
        }
    }

    ll ans = 0;
    set<int>p;
    for (int i : x) {
        p.insert(i);
        if (p.size() > mx) {
            ans++;
            p.clear();
            p.insert(i);
        }
    }
    cout << ans + !p.empty();
}