#include <iostream>

#include <vector>
#include <set>
#include <map>

#include <algorithm>
#include <cmath>

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int vs, ks, mx;
    cin >> vs >> ks >> mx;
    vector<int> v(vs);
    for (int &i: v)
        cin >> i;

    set<int>vx;
    for (int i : v)
        vx.insert(i);

    if (vx.size() <= mx) {
        cout << 1;
        return 0;
    }

    vector<int>ej(vs + 1);
    map<int, int>cnt;

    for (int i = 0; i < vs; i++) {
        cnt[v[i]]++;
        if (cnt.size() > mx) {
            cnt.erase(v[i]);
            ej[vs] = vs + i;
            break;
        }
    }


    for (int l = vs - 1; l >= 0; l--) {
        cnt[v[l]]++;
        ej[l] = ej[l + 1];
        while (cnt.size() > mx) {
            ej[l]--;
            cnt[v[ej[l] % vs]]--;
            if (!cnt[v[ej[l] % vs]])
                cnt.erase(v[ej[l] % vs]);
        }
    }

    vector<pair<int, int>>lej(vs);
    for (int l = vs - 1; l >= 0; l--) {
        if (ej[l] >= vs)
            lej[l] = {ej[l] % vs, 1};
        else
            lej[l] = {lej[ej[l]].first, lej[ej[l]].second + 1};
    }

    ll ans = 0;
    int pr = 0;
    for (int i = 0; i < ks; i++) {
        ans += lej[pr].second;
        pr = lej[pr].first;
    }
    cout << ans;
}