#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;

#define vec vector
#define read(x) for(auto &zu: (x))cin >> zu;

using vi = vector<int>;
using str = string;
using pii = pair<int, int>;

template<typename A>
void print(A &a, str sep=" "){
    for(auto &i: a)cout << i << sep;
    cout << "\n";
}

map<int, int> used;

void dec(int x){
    if(used[x] == 1)
        used.erase(x);
    else used[x]--;
}

void solve(){
    int n, k, t;
    cin >> n >> k >> t;
    vi a(n); read(a);
    for(auto &i: a){
        used[i]++;
    }
    if(used.size() <= t){
        cout << 1 << "\n";
        return;
    }

    vi nxt(n);
    for(int i = 0; i < n; ++i)
        a.push_back(a[i]);
    used.clear();
    int r = 0;
    for(int i = 0; i < n; ++i){
        while(r < 2 * n && used.size() <= t){
            used[a[r]]++;
            r++;
        }
        nxt[i] = (r - 1) % n;
        dec(a[i]);
    }
    int cnt = 0;
    int cur = 0;
    int pc = 0;
    while(pc < k){
        cnt++;
        if(nxt[cur] < cur)
            pc++;
        cur = nxt[cur];
    }
    cout << cnt << "\n";
}


signed main() {
#ifdef LOCAL
    freopen("inp", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int TT = 1;
    //cin >> TT;
    while(TT--){
        solve();
    }
    return 0;
}
