#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define int long long
#define debug(x) std::cerr << #x << ": " << x << '\n'

using namespace std;
typedef long long i64;

const int B = 20;

struct uniqueSet {
    set<int> s;
    multiset<int> ms;
    void add(int x) {
        s.insert(x);
        ms.insert(x);
    }
    void rem(int x) {
        ms.erase(ms.find(x));
        if (ms.find(x) == ms.end()) s.erase(x);
    }
    bool can(int x, int mxLen) {
        add(x);
        if (getLen() > mxLen) {
            rem(x);
            return false;
        }
        return true;
    }
    int getLen() {
        return (int)s.size();
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    i64 n, k, t;
    cin >> n >> k >> t;

    vector<int> a(2 * n);
    set<int> tmp;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        tmp.insert(a[i]);
        a[i + n] = a[i];
    }

    if (tmp.size() <= t) {
        cout << "1\n";
        return 0;
    }
    uniqueSet st;
    int ptr = 2 * n - 1;
    vector<pair<int, int>> go(n);
    for (int i = 2 * n - 1; i >= n; --i) {
        st.add(a[i]);
    }
    for (int i = n - 1; i > -1; --i) {
        ptr = max(ptr, i);
        st.add(a[i]);
        while (st.getLen() > t) st.rem(a[ptr--]);
        if (ptr + 1 >= n) {
            go[i] = {1, (ptr + 1) % n};
        } else {
            go[i] = {1 + go[ptr + 1].fi, go[ptr + 1].se};
        }
    }

    if (k <= n) {
        int s = 0;
        i64 ans = 0;
        for (int i = 0; i < k; ++i) {
            auto [cnt, where] = go[s];
            s = where;
            ans += cnt;
        }
        cout << ans << '\n';
        return 0;
    }

    vector<bool> vis(n, 0);
    vector<int> par(n, -1);
    int s = 0;
    i64 ans = 0, all = 0;
    while (!vis[s]) {
        vis[s] = 1;
        all += go[s].fi;
        par[go[s].se] = s;
        s = go[s].se;
    }
    vis.assign(n, 0);
    int x = s;
    vector<int> vs;
    while (!vis[x]) {
        vis[x] = 1;
        x = par[x];
        vs.pb(x);
    }
    for (int el : vs) {
        debug(el);
        ans += go[el].fi;
        all -= go[el].fi;
    }
    ans *= (k / (int)vs.size());
    ans += all;
    k %= (int)vs.size();
    for (int i = 0; i < k; ++i) {
        auto [cnt, where] = go[s];
        s = where;
        ans += cnt;
    }
    cout << ans << '\n';
}
