#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
#define int ll
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll mod = 998244353;
const ll inf = 1e18;
const int mxn = 1e9 + 7;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << a << endl;
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;

void insert (set <pll> &ms, int x) {
    auto t = ms.lower_bound(make_pair(x, -1));
    if (t != ms.end() && (*t).first == x) {
        auto p = *t;
        ms.erase(t);
        ms.insert({x, p.second + 1});
    }
    else {
        ms.insert({x, 1});
    }
}

void del (set <pll> &ms, int x) {
    auto t = ms.lower_bound(make_pair(x, -1));
    if (t != ms.end() && (*t).first == x) {
        auto p = *t;
        ms.erase(t);
        if (p.second - 1 > 0) ms.insert({x, p.second - 1});
    }
    else {
        exit(1);
    }
}

void solve() {
    int n, k, t; cin >> n >> k >> t;
    vector <int> a(n), jump(n);
    set <int> lal;
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; lal.insert(a[i]);
    }
    if (lal.size() <= t) {
        cout << 1 << endl;
        return;
    }
    for (int i = 0; i < n; ++i) {
        a.push_back(a[i]);
    }
    set <pll> ms;
    for (int i = 0; i < n; ++i) {
        insert(ms, a[i]);
    }
    for (int i = n - 1; i >= 0; --i) {
        if (i == n - 1) jump[i] = n + (n - 1);
        else jump[i] = jump[i + 1];

        insert(ms, a[i]);
        while (ms.size() > t) {
            del(ms, a[jump[i]]); --jump[i];
        }
        // cout << ms.size() << endl;
        // jump[i] = jump[i] + 1;
    }
    for (int i = 0; i < n; ++i) ++jump[i];
    while (true) {
        int curr = 0, len = 0;
        for (int i = 0; i < 3 * n; ++i) {
            len += jump[curr] - curr;
            curr = jump[curr] % n;
            if (len >= n * k) {
                cout << i + 1 << endl;
                return;
            }
        }
        break;
    }
    vector <int> pos(n, -1);
    int curr = 0, cnt = 0;
    pos[curr] = cnt;
    vector <int> pref {0};
    while (true) {
        pref.push_back(pref.back() + (jump[curr] - curr));
        curr = jump[curr] % n; ++cnt;
        if (pos[curr] == -1) {
            pos[curr] = cnt;
        }
        else {
            break;
        }
    }
    int pre_cnt = pos[curr], cyc_cnt = cnt - pos[curr];
    int pre_len = pref[pos[curr]], cyc_len = pref.back() - pref[pos[curr]];
    // debug(pre_cnt << ' ' << pre_len << ' ' << cyc_cnt << ' ' << cyc_len);
    int need = n * k, ans = 0;
    ans += pre_cnt; need -= pre_len;
    ans += need / cyc_len * cyc_cnt; need %= cyc_len;
    if (need <= 0) {
        cout << ans << endl; return;
    }
    for (int i = 0; i < 3 * n; ++i) {
        need -= (jump[curr] - curr);
        curr = jump[curr] % n;
        if (need <= 0) {
            cout << ans + i + 1 << endl;
            return;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> tt;
    while (tt--) solve();
}
