#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define int ll

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> v(n);
    for (int& x : v) cin >> x;

    {
        set<int> s;
        for (int x : v) s.insert(x);
        if (s.size() <= t) {
            cout << 1;
            return;
        }
    }

    vector<int> nx(n);
    int ptr = 0;
    map<int, int> m;
    m[v[0]] = 1;
    for (int i = 0; i < n; i++) {
        while (m.size() <= t) {
            ptr++;
            if (ptr == n) ptr = 0;
            m[v[ptr]]++;
        }
        nx[i] = ptr;
        m[v[i]]--;
        if (m[v[i]] == 0) m.erase(m.find(v[i]));
    }

//    for (int x : nx) cout << x << " ";
//    cout << "\n";

    vector<int> used(n);
    int pos = 0, cnt = 0, ans = 0;
    vector<pair<int, int>> path;
    while (!used[pos] && cnt < k) {
        used[pos] = 1;
        path.emplace_back(pos, (nx[pos] <= pos ? 1 : 0));
        if (nx[pos] <= pos) cnt++;
        ans++;
        pos = nx[pos];
    }

//    for (auto [a, b] : path) cout << a << " " << b << "\n";
//    cout << pos << "\n";

    if (cnt == k) cout << ans;
    else {
        reverse(all(path));
        while (path.back().first != pos) path.pop_back();
        reverse(all(path));

        int sum = 0;
        for (auto [a, b] : path) sum += b;

//        cout << cnt << " " << ans << " " << sum << "\n";

        ans += path.size() * ((k - cnt - 1) / sum);
        k -= cnt;
        k %= sum;
        for (int i = 0; i < path.size(); i++) {
            if (path[i].second == 1) {
                if (k == 1) break;
                k--;
            }
            ans++;
        }

        cout << ans;
    }
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) solve();
}