#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
using namespace std;

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, k, t;
  cin >> n >> k >> t;
  vector<int> a(n);
  for (int &value : a) {
    cin >> value;
  }
  vector<int> D = a;
  sort(D.begin(), D.end());
  D.resize(unique(D.begin(), D.end()) - D.begin());
  for (int &value : a) {
    value = lower_bound(D.begin(), D.end(), value) - D.begin();
  }
  vector<int> b;
  for (int i = 0; i < n; i++) {
    b.push_back(a[i]);
  }
  for (int i = 0; i < n; i++) {
    b.push_back(a[i]);
  }
  if ((int)D.size() <= t) {
    cout << 1 << "\n";
    exit(0);
  }
  int diff = 0;
  vector<int> cnt(n), to(n), weight(n);
  for (int i = 2 * n - 1, j = 2 * n - 1; i >= 0; i--) {
    diff += cnt[b[i]]++ == 0;
    while (diff > t) {
      diff -= --cnt[b[j--]] == 0;
    }
    if (i < n) {
      to[i] = (j + 1) % n;
      weight[i] = j - i + 1;
      assert(weight[i] > 0);
    }
  }
  vector<int> path;
  int cur = 0;
  vector<bool> used(n);
  while (!used[cur]) {
    used[cur] = true;
    path.push_back(cur);
    cur = to[cur];
  }
  long long sum = 1LL * n * k - 1, answer = 0;
  int pos = -1;
  for (int i = 0; i < (int)path.size(); i++) {
    if (path[i] == cur) {
      pos = i;
      break; 
    }
    answer++;
    sum -= weight[path[i]];
    if (sum < 0) {
      break;
    }
  }
  if (pos != -1) {
    long long cycle_weight = 0;
    for (int i = pos; i < (int)path.size(); i++) {
      cycle_weight += weight[path[i]];
    }
    long long count_cycles = sum / cycle_weight;
    answer += count_cycles * ((int)path.size() - pos);
    sum -= cycle_weight * count_cycles;
    while (sum >= 0) {
      for (int i = pos; i < (int)path.size(); i++) {
        sum -= weight[path[i]];
        answer++;
        if (sum < 0) {
          break;
        }
      }
    }
  }
  cout << answer << "\n";
}
