#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    cin >> a;
    set<int> aa(a.begin(), a.end());
    if (t >= aa.size()) {
        cout << "1\n";
        return 0;
    }
    vector<pair<int, int>> nxt(n);
    for (int i = 0; i < n; ++i) {
        int j = i;
        set<int> cur;
        while (true) {
            cur.insert(a[j]);
            if (cur.size() > t) {
                break;
            }
            ++j;
            j %= n;
        }
        if (j < i) {
            ++nxt[i].second;
        }
        nxt[i].first = j;
    }
    constexpr int K = 50;
    vector<vector<int>> up(K, vector<int>(n, -1));
    vector<vector<ll>> sumup(K, vector<ll>(n));
    for (int i = 0; i < n; ++i) {
        up[0][i] = nxt[i].first;
        sumup[0][i] = nxt[i].second;
    }
    for (int i = 1; i < K; ++i) {
        for (int j = 0; j < n; ++j) {
            int v = up[i - 1][j];
            if (v != -1) {
                up[i][j] = up[i - 1][v];
                sumup[i][j] = sumup[i - 1][j] + sumup[i - 1][v];
            }
        }
    }
    ll ans = 0;
    ll cur = 0;
    int v = 0;
    for (int i = K - 1; i >= 0; --i) {
        if (up[i][v] != -1 && cur + sumup[i][v] < k) {
            cur += sumup[i][v];
            ans += (1ll << i);
            v = up[i][v];
        }
    }
    assert(cur + sumup[0][v] == k);
    cout << ans + 1;
}
