#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#pragma pack(push, 1)

#define int long long

using namespace std;
//using namespace __gnu_pbds;

//using ordered_multiset = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;
using lll = __int128;
using lld = __float128;

mt19937_64 gen(time(nullptr));

const int MAX_N = 6e5;

vector<int> tree[4 * MAX_N];

void build(int v, int tl, int tr, vector<int> &arr) {
    if (tl + 1 == tr) {
        tree[v] = {arr[tl]};
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v + 1, tl, tm, arr), build(2 * v + 2, tm, tr, arr);
    tree[v].resize(tree[2 * v + 1].size() + tree[2 * v + 2].size());
    merge(tree[2 * v + 1].begin(), tree[2 * v + 1].end(), tree[2 * v + 2].begin(), tree[2 * v + 2].end(), tree[v].begin());
}

int get_cnt(int v, int tl, int tr, int l, int r) {
    if (l >= tr || r <= tl) {
        return 0;
    }
    if (l <= tl && r >= tr) {
        int ind = lower_bound(tree[v].begin(), tree[v].end(), r) - tree[v].begin();
        return (int)tree[v].size() - ind;
    }
    int tm = (tl + tr) / 2;
    return get_cnt(2 * v + 1, tl, tm, l, r) + get_cnt(2 * v + 2, tm, tr, l, r);
}

signed main() {
#ifdef LOCAL
    freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k, t, i, prev = 0, ans = 0;
    cin >> n >> k >> t;
    map<int, int> last;
    set<int> check;
    vector<int> arr(n), next(2 * n), next_step(2 * n), dp(2 * n, 0), next_block(2 * n);
    for (i = 0; i < n; i++) {
        cin >> arr[i];
        check.insert(arr[i]);
    }
    if (t >= check.size()) {
        cout << 1;
        return 0;
    }
    if (k == 1) {
        set<int> se;
        for (i = 0; i < n; i++) {
            if (se.size() == t && !se.count(arr[i])) {
                ans++;
                se.clear();
            }
            se.insert(arr[i]);
        }
        if (!se.empty()) {
            ans++;
        }
        cout << ans;
        return 0;
    }
    arr.resize(2 * n);
    for (i = n; i < 2 * n; i++) {
        arr[i] = arr[i - n];
        last[arr[i]] = 1e9;
    }
    for (i = 2 * n - 1; i >= 0; i--) {
        next[i] = last[arr[i]];
        last[arr[i]] = i;
    }
    build(0, 0, 2 * n, next);
    for (i = 0; i < n; i++) {
        int l = i + 1, r = 2 * n + 1, mid;
        while (l + 1 < r) {
            mid = (l + r) / 2;
            if (get_cnt(0, 0, 2 * n, i, mid) <= t) {
                l = mid;
            } else {
                r = mid;
            }
        }
        next_step[i] = l;
    }
    for (i = 2 * n - 1; i >= n; i--) {
        next_block[i] = i - n;
    }
    for (i = n - 1; i >= 0; i--) {
        dp[i] = dp[next_step[i]] + 1;
        next_block[i] = next_block[next_step[i]];
    }
    vector<bool> used(n, false);
    for (i = 1; i <= k; i++) {
        used[prev] = true;
        ans += dp[prev];
        prev = next_block[prev];
        if (used[prev]) {
            ans *= (k / i);
            k %= i;
            break;
        }
    }
    for (i = 0; i < k; i++) {
        ans += dp[prev];
        prev = next_block[prev];
    }
    cout << ans;
}