#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

void solve1(int n, int k, int t, vector<int> a) {
    auto na = a;
    for (int i = 1; i < k; ++i) {
        for (auto &el: na) a.push_back(el);
    }
    n = a.size();
    vector<int> go(n, -1);
    map<int, int> usd;
    for (int i = 0, j = 0; i < n; ++i) {
        while (j < n && usd.size() <= t) {
            if (!usd.contains(a[j]) && usd.size() == t) break;
            ++usd[a[j++]];
        }
        go[i] = j;
        --usd[a[i]];
        if (!usd[a[i]]) usd.erase(a[i]);
    }
    int ans = 0, i = 0;
    while (i < n) {
        i = go[i];
        ++ans;
    }
    cout << ans;
    exit(0);
}

const int MAXN = 6e5 + 10;

vector<int> g[MAXN];

long long add_ans[MAXN];
int hv[MAXN], go[MAXN];

int n;

void dfs(int v) {
    if (go[v] >= n / 2) {
        hv[v] = go[v] - n / 2;
        add_ans[v] = 1;
        return;
    }
    if (hv[go[v]] != -1) {
        hv[v] = hv[go[v]];
        add_ans[v] = add_ans[go[v]] + 1;
        return;
    } else {
        dfs(go[v]);
        hv[v] = hv[go[v]];
        add_ans[v] = add_ans[go[v]] + 1;
    }
}

const int K = 29;

int upi[K + 1][MAXN];
long long upans[K + 1][MAXN];

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    fill(hv, hv + MAXN, -1);
    int k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (auto &i: a) {
        cin >> i;
    }
    set<int> diff(a.begin(), a.end());
    if (diff.size() <= t) {
        cout << 1;
        return 0;
    }
    if (k == 1) {
        solve1(n, k, t, a);
    }
    auto na = a;
    for (int i = 1; i < 2; ++i) {
        for (auto &el: na) a.push_back(el);
    }
    n = a.size();
    unordered_map<int, int> usd;
    vector<int> in(n * 2, 0), out(n * 2, 0);
    for (int i = 0, j = 0; i < n; ++i) {
        while (j < n && usd.size() <= t) {
            if (!usd.contains(a[j]) && usd.size() == t) break;
            ++usd[a[j++]];
        }
        go[i] = j;
        g[i].push_back(j);
        --usd[a[i]];
        if (!usd[a[i]]) usd.erase(a[i]);
    }
    for (int i = 0; i < n / 2; ++i) {
        if (hv[i] == -1) {
            dfs(i);
        }
    }
    long long ans = 0;
    for (int i = 0; i < n / 2; ++i) {
        upi[0][i] = hv[i];
        upans[0][i] = add_ans[i];
    }
    for (int i = 0; i < K; ++i) {
        for (int j = 0; j < n; ++j) {
            int u1 = upi[i][j];
            upi[i + 1][j] = upi[i][u1];
            upans[i + 1][j] = upans[i][j] + upans[i][u1];
        }
    }
    int ni = 0;
    for (int i = 0; i <= K; ++i) {
        if (k >> i & 1) {
            ans += upans[i][ni];
            ni = upi[i][ni];
        }
    }
    cout << ans;
}