#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	ll k, t;
	cin >> n >> k >> t;
	if (t == 1) {
		ll one_box = 0;
		ll last_gift = -1;
		ll first_gift = -1;
		for (int i = 0; i < n; i++) {
			ll x;
			cin >> x;
			if (first_gift == -1) first_gift = x;
			if (last_gift != x) one_box++;
			last_gift = x;
		}
		if (one_box <= t) {
			cout << 1 << "\n";
			return 0;
		}
		ll total_types;
		if (first_gift == last_gift) {
			total_types = one_box + (k-1) * (one_box-1);
		}
		else {
			total_types = one_box * k;
		}
		cout << (total_types - 1) / t + 1;
	}
	else {
		vector<ll> a(n);
		for (ll &i: a) {
			cin >> i;
		}
		unordered_map<int, pair<ll, ll>> break_points;
		bool can_skip = true;
		set<ll> used;
		ll ans = 0;
		for (int i = 0; i < k; i++) {
			for (int j = 0; j < n; j++) {
				used.insert(a[j]);
				if (used.size() > t) {
					if (can_skip && break_points.find(j) != break_points.end()) {
						can_skip = false;
						auto [old_i, old_ans] = break_points[j];
						ll cycle_length = i - old_i;
						ll cycle_cost = ans - old_ans;
						ll cycles = (k - i - 1) / cycle_length;
						i += cycles * cycle_length;
						ans += cycles * cycle_cost;
					}
					if (can_skip) {
						break_points[j] = {i, ans};
					}
					ans += 1;
					used.clear();
					used.insert(a[j]);
				}
			}
			if (ans == 0) {
				cout << 1 << "\n";
				return 0;
			}
		}
		ans += 1;
		cout << ans << "\n";
	}
}