#include <iostream>
#include <vector>
using namespace std;

ostream& operator<< (ostream& stream, const vector<long long>& a) {
    for (auto to : a) {
        stream << to << " ";
    }
    return stream;
}

int n;
vector<long long> a;
pair<long long, long long> ans = {1e9, -1e9};

void rec(long long f, long long f_t, long long s, long long s_t, vector<long long> cur) {
    // cout << f << " " << f_t << " " << s << " " << s_t << "\n";
    // cout << cur << "\n";
    pair<long long, int> mn = {1e9, -1};
    pair<long long, int> mx = {-1e9, -1}; 
    for (int i = 0; i < n; i++) {
        if (cur[i] == -1) {
            continue;
        }
        if (a[i] < mn.first) {
            mn = {a[i], i};
        }
        if (a[i] > mx.first) {
            mx = {a[i], i};
        }
    }
    if (mn.second == -1) {
        if (abs(f - s) < abs(ans.first - ans.second)) {
            ans = {f, s};
        }
        return;
    }
    if (f_t == 0) {
        // cout << cur << "\n";
        // cout << "chose: " << mn.second << "\n\n";
        cur[mn.second] = -1;
        rec(f + mn.first, f_t + mn.first, s, s_t, cur);
        cur[mn.second] = mn.first;
        cur[mx.second] = -1;
        rec(f + mx.first, f_t + mx.first, s, s_t, cur);
        cur[mx.second] = mx.first;
        return;
    }
    if (s_t == 0) {
        cur[mn.second] = -1;
        rec(f, f_t, s + mn.first, s_t + mn.first, cur);
        cur[mn.second] = mn.first;
        cur[mx.second] = -1;
        rec(f, f_t, s + mx.first, s_t + mx.first, cur);
        cur[mx.second] = mx.first;
        return;
    }
    long long g = min(f_t, s_t);
    rec(f, f_t - g, s, s_t - g, cur);
}
int main() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    rec(0, 0, 0, 0, a);
    cout << ans.first << " " << ans.second;
    
}