#include <bits/stdc++.h>
      
using ld = long double;
using ll = long long;
using ull = unsigned long long;
      
#define int long long
#define double long double
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define repr(i, n) for (int i = (n) - 1; i >= 0; --i)
#define fir first
#define sec second
#define pb push_back
#define mp make_pair
#define ALL(v) begin(v), end(v)
#define current_time chrono::steady_clock::now().time_since_epoch().count()
   
ll TL = 1e9 / 15;
ll INF = 1e18;
ll MOD2 = 1e9 + 7;
ll MOD = 1e9 + 1000 - 7;
ll p2 = 101;
ll p = 593;
ld eps = 1e-10;
      
const double PI = 3.141592653589793238463;
const ll pw = 1e12;
      
using namespace std;
      
ll powmod(ll a, ll b, ll mod) {ll res = 1;a %= mod; assert(b >= 0); for(; b; b >>= 1){if(b & 1) res = res * a % mod;a = a * a % mod;}return res;}
ll gcd(ll a, ll b) {return b ? gcd(b,a % b):a;}
mt19937_64 rnd(current_time);
mt19937 rndd(rnd());
uniform_real_distribution <ld> rnddbl(0, 1);

const ll MAXN = 100000;

struct anso {
    int a = 0, b = 0;

    bool operator < (anso s) {
        if (s.a == a) return s.b < b;
        return s.a < a;
    }
};

void solve() {
    int n; cin >> n;
    vector <int> all(n);
    rep(i, n) cin >> all[i];
    vector <vector <pair <int, int>>> dp(n, vector <pair <int, int>> (n));
    for (int i = 0; i < n; ++i) {
        dp[i][i] = {all[i], 0};
    }
    for (int i = 0; i < n - 1; ++i) {
        dp[i][i + 1] = {max(all[i], all[i + 1]), min(all[i], all[i + 1])};
    }
    for (int sz = 3; sz <= n; ++sz) {
        for (int l = 0; l <= n - sz; ++l) {
            int r = l + sz - 1;
            // l, r - 2
            pair <int, int> p1 = {all[r], all[r - 1]};
            if (all[r] == all[r - 1]) {
                p1.fir += dp[l][r - 2].fir;
                p1.sec += dp[l][r - 2].sec;
            } else {
                p1.fir += dp[l][r - 2].sec;
                p1.sec += dp[l][r - 2].fir;
            }
            // l + 2, r
            pair <int, int> p2 = {all[l] + dp[l + 2][r].fir, all[l + 1] + dp[l + 2][r].sec};
            // l + 1, r - 1
            pair <int, int> p3 = {all[l] + dp[l + 1][r - 1].sec, all[r] + dp[l + 1][r - 1].fir};
            pair <int, int> p4 = {all[r] + dp[l + 1][r - 1].fir, all[l] + dp[l + 1][r - 1].sec};
            dp[l][r] = max({p1, p2, p3, p4});
        }
    }
    cout << dp[0][n - 1].fir << ' ' << dp[0][n - 1].sec << endl;
}
      
signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}