#ifdef DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <numeric>
#include <chrono>
#include <random>
#include <bitset>
#include <immintrin.h>
#include <assert.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pil = pair<int, long long>;
using pli = pair<long long, int>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#ifdef DEBUG
const int N = 100;
const int W = 101;
#else
const int N = 200;
const int W = 20001;
#endif

int dp[2][N][N][W];

void smin(int& a, int b) {
    a = min(a, b);
}

void smax(int& a, int b) {
    a = max(a, b);
}

inline void solve() {
    int n;
    cin >> n;
    vector<int> w(n);
    for (int i = 0; i < n; i++)
        cin >> w[i];
    for (int i = 0; i < n; i++)
        for (int t = 0; t < W; t++)
            dp[0][i][i][t] = w[i];
    for (int l = n - 1; l > -1; l--)
        for (int r = l + 1; r < n; r++) {
            int p;
            p = 0;
            {
                for (int t = 0; t < W; t++) {
                    int tp = t - w[l];
                    if (tp >= 0) {
                        if (tp < W)
                            smax(dp[0][l][r][t], dp[0][l + 1][r][tp] + w[l]);
                    }
                    else {
                        if (-tp < W)
                            smax(dp[0][l][r][t], dp[1][l + 1][r][-tp] + w[l]);
                    }
                    tp = t - w[r];
                    if (tp >= 0) {
                        if (tp < W)
                            smax(dp[0][l][r][t], dp[0][l][r - 1][tp] + w[r]);
                    }
                    else {
                        if (-tp < W)
                            smax(dp[0][l][r][t], dp[1][l][r - 1][-tp] + w[r]);
                    }
                }
            }
            p = 1;
            {
                for (int t = 1; t < W; t++) {
                    int tp = t - w[l];
                    dp[1][l][r][t] = 1e9;
                    if (tp > 0) {
                        if (tp < W)
                            smin(dp[1][l][r][t], dp[1][l + 1][r][tp]);
                    }
                    else {
                        if (-tp < W)
                            smin(dp[1][l][r][t], dp[0][l + 1][r][-tp]);
                    }
                    tp = t - w[r];
                    if (tp > 0) {
                        if (tp < W)
                            smin(dp[1][l][r][t], dp[1][l][r - 1][tp]);
                    }
                    else {
                        if (-tp < W)
                            smin(dp[1][l][r][t], dp[0][l][r - 1][-tp]);
                    }
                }
            }
        }
    int sum = accumulate(all(w), 0);
    cout << dp[0][0][n - 1][0] << ' ' << sum - dp[0][0][n - 1][0] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUG
    freopen("01.dat", "r", stdin);
#endif
    int tt = 1;
#ifdef DEBUG
    cin >> tt;
#endif
    while (tt--) {
#ifdef DEBUG
        cout << "Testcase#\n";
#endif
        solve();
    }
    return 0;
}
