#include <bits/stdc++.h>
using namespace std;
//#define int int64_t
//#define double long double
//#define MULTITASK
#define NO_INTERACTIVE
void solve();
int32_t main() {
#ifdef BIBIKOV
    clock_t tStart = clock();
#ifdef NO_INTERACTIVE
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
#endif
#ifdef NO_INTERACTIVE
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int32_t tt = 1;
#ifdef MULTITASK
    cin >> tt;
#endif
    while (tt--) {
        solve();
#ifdef NO_INTERACTIVE
        cout << '\n';
#endif
    }
#ifdef BIBIKOV
    fprintf(stderr, ">> Runtime: %.10fs\n", (double_t) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
const int64_t INF = 1e18, inf = 2e9, mod = 998244353;







vector<vector<unordered_map<int, int>>> mp;
vector<int> x;

int rec(int l, int r, int w) {
    if (mp[l][r].contains(w))
        return mp[l][r][w];
    if (l == r)
        return mp[l][r][w] = 0;
    if (w < 0) {
        mp[l][r][w] = min(rec(l + 1, r, w + x[l]),
                            rec(l, r - 1, w + x[r - 1]));
    } else {
        mp[l][r][w] = max(rec(l + 1, r, w - x[l]) + x[l],
                            rec(l, r - 1, w - x[r - 1]) + x[r - 1]);
    }
    return mp[l][r][w];
}

void solve() {
    int n;
    cin >> n;
    x.resize(n);
    mp.resize(n + 1, vector<unordered_map<int, int>>(n + 1));
    for (int i = 0; i < n; i++)
        cin >> x[i];
    int a = rec(0, n, 0), sm = accumulate(x.begin(), x.end(), 0ll);
    cout << a << ' ' << sm - a;
}
