#include <bits/stdc++.h>
using namespace std;

void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

map<array<int, 5>, vector<array<int, 5>>> g;

int dfs(array<int, 5> v) {
    int res;
    if(v[2] == 0) {
        res = v[4];
        for(auto to : g[v]) {
            res = max(res, dfs(to));
        }
    } else {
        res = 20001;
        for(auto to : g[v]) {
            res = min(res, dfs(to));
        }
        if(res == 20001) {
            return v[4];
        }
    }
    return res;
}

signed main() {
    init();
    int n, W = 0;
    cin >> n;
    vector<int> w(n);
    for(int i = 0; i < n; ++i) {
        cin >> w[i];
        W += w[i];
    }
    queue<array<int, 5>> q;
    q.push({0, n - 1, 0, 0, 0});
    while(!q.empty()) {
        auto v = q.front();
        q.pop();
        if(v[0] > v[1]) continue;
        if(v[2] == 0) {
            q.push({ v[0] + 1, v[1], max(w[v[0]] - v[3], 0), max(v[3] - w[v[0]], 0), v[4] + w[v[0]]});
            q.push({ v[0], v[1] - 1, max(w[v[1]] - v[3], 0), max(v[3] - w[v[1]], 0),  v[4] + w[v[1]]});
            g[v].push_back({ v[0] + 1, v[1], max(w[v[0]] - v[3], 0), max(v[3] - w[v[0]], 0), v[4] + w[v[0]] });
            g[v].push_back({ v[0], v[1] - 1, max(w[v[1]] - v[3], 0), max(v[3] - w[v[1]], 0), v[4] + w[v[1]] });
        } else {
            q.push({ v[0] + 1, v[1], max(v[2] - w[v[0]], 0), max(w[v[0]] - v[2], 0), v[4]});
            q.push({ v[0], v[1] - 1, max(v[2] - w[v[1]], 0), max(w[v[1]] - v[2], 0), v[4]});
            g[v].push_back({ v[0] + 1, v[1], max(v[2] - w[v[0]], 0), max(w[v[0]] - v[2], 0), v[4] });
            g[v].push_back({ v[0], v[1] - 1, max(v[2] - w[v[1]], 0), max(w[v[1]] - v[2], 0), v[4] });
        }
    }
    int res = dfs({0, n - 1, 0, 0});
    cout << res << " " << W - res << '\n';
}