#include "bits/stdc++.h"

using namespace std;
#define int long long

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> w(n);
    int W = 0;
    for (int &i: w) {
        cin >> i;
        W += i;
    }
    // dp[l][r][sum]
    // sum2
    vector<int> pref(n + 1);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + w[i];
    }
    vector<int> suf(n + 1);
    for (int i = 0; i < n; i++) {
        suf[i + 1] = suf[i] + w[n - i - 1];
    }
    vector<vector<vector<bool>>> dp(n + 1, vector<vector<bool>>(n + 1, vector<bool>(W + 1, false)));
    auto get = [&](int l, int r, int sum) {
        return pref[l] + suf[r] - sum;
    };
    dp[0][0][0] = true;
    for (int r = 0; r <= n; r++) {
        for (int l = 0; l <= n; l++) {
            for (int sum = 0; sum <= W; sum++) {
                int sum2 = get(l, r, sum);
                if (!dp[l][r][sum]) {
                    continue;
                }
                if (sum <= sum2) {
                    if (l + r + 1 <= n) {
                        if (sum + w[l] <= W && l + 1 <= n) {
                            dp[l + 1][r][sum + w[l]] = true;
                        }
                        if (sum + w[r] <= W && r + 1 <= n) {
                            dp[l][r + 1][sum + w[r]] = true;
                        }
                    }
                } else if (sum > sum2) {
                    if (l + r + 1 <= n) {
                        if (r + 1 <= n) {
                            dp[l][r + 1][sum] = true;
                        }
                        if (l + 1 <= n) {
                            dp[l + 1][r][sum] = true;
                        }
                    }
                }
            }
        }
    }

    int ans = 0;
    int s1 = 0;
    int s2 = 0;
    for (int l = 0; l <= n; l++) {
        for (int r = 0; r <= n; r++) {
            for (int sum = 0; sum <= W; sum++) {
                if (dp[l][r][sum]) {
                    int sum2 = get(l, r, sum);
                    if (sum + sum2 >= ans) {
                        ans = sum + sum2;
                        s1 = sum;
                        s2 = sum2;
                    }
                }
            }
        }
    }
    assert(ans == s1 + s2);
    cout << s1 << ' ' << s2 << '\n';
    return 0;
}
