#include "bits/stdc++.h"

using namespace std;
#define int long long

int n;
vector<int> w;
vector<int> pref;
vector<int> suf;

pair<int, int> rec(int l, int r, int sumAlice, int sumBob) {
    if (r + l == n) {
        return {sumAlice, sumBob};
    }
    if (sumAlice <= sumBob) {
        pair<int, int> mx = {-1, -1};
        if (l + 1 <= n) {
            auto mp = rec(l + 1, r, sumAlice + w[l], sumBob);
            if (mp.first > mx.first || mp.first == mx.first && mp.second < mx.second) {
                mx = mp;
            }
        }
        if (r + 1 <= n) {
            auto mp = rec(l, r + 1, sumAlice + w[n - 1 - r], sumBob);
            if (mp.first > mx.first || mp.first == mx.first && mp.second < mx.second) {
                mx = mp;
            }
        }
        return mx;
    } else {
        pair<int, int> mx = {-1, -1};
        if (l + 1 <= n) {
            auto mp = rec(l + 1, r, sumAlice, sumBob + w[l]);
            if (mp.second > mx.second || mp.second == mx.second && mp.first < mx.first) {
                mx = mp;
            }
        }
        if (r + 1 <= n) {
            auto mp = rec(l, r + 1, sumAlice, sumBob + w[n - 1 - r]);
            if (mp.second > mx.second || mp.second == mx.second && mp.first < mx.first) {
                mx = mp;
            }
        }
        return mx;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    w.resize(n);
    int W = 0;
    for (int &i: w) {
        cin >> i;
        W += i;
    }
    pref.resize(n + 1);
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + w[i];
    }
    suf.resize(n + 1);
    for (int i = 0; i < n; i++) {
        suf[i + 1] = suf[i] + w[n - i - 1];
    }
    int smAlice = rec(0, 0, 0, 0).first;
    int smBob = rec(0, 0, 0, 0).second;
    cout << smAlice << ' ' << smBob;
    return 0;
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n + 1, vector<int>(W + 1, false)));
    auto get = [&](int l, int r, int sum) {
        return pref[l] + suf[r] - sum;
    };
    dp[0][0][0] = true;



    for (int r = 0; r <= n; r++) {
        for (int l = 0; l <= n; l++) {
            for (int sum = 0; sum <= W; sum++) {
                int sum2 = get(l, r, sum);
                if (!dp[l][r][sum]) {
                    continue;
                }
                assert(sum2 >= 0);
                if (sum <= sum2) {
                    if (l + r + 1 <= n) {
                        if (sum + w[l] <= W && l + 1 <= n) {
                            dp[l + 1][r][sum + w[l]] = max(dp[l + 1][r][sum + w[l]], dp[l][r][sum]);
                        }
                        if (sum + w[r] <= W && r + 1 <= n) {
                            dp[l + 1][r][sum + w[l]] = max(dp[l + 1][r][sum + w[l]], dp[l][r][sum]);
                        }
                    }
                } else {
                    if (l + r + 1 <= n) {
                        if (r + 1 <= n) {
                            dp[l][r + 1][sum] = max(dp[l][r + 1][sum], dp[l][r][sum] + w[r]);
                        }
                        if (l + 1 <= n) {
                            dp[l + 1][r][sum] = max(dp[l + 1][r][sum], dp[l][r][sum] + w[l]);
                        }
                    }
                }
            }
        }
    }

    int ans = 0;
    int s1 = 0;
    int s2 = 0;
    for (int l = 0; l <= n; l++) {
        for (int r = 0; r <= n; r++) {
            for (int sum = 0; sum <= W; sum++) {
                if (dp[l][r][sum]) {
                    int sum2 = get(l, r, sum);
                    if (sum + sum2 >= ans) {
                        ans = sum + sum2;
                        s1 = sum;
                        s2 = sum2;
                        if (sum + sum2 == 15) {
                            cout << l << ' ' << r << '\n';
                        }
                    }
                }
            }
        }
    }
    assert(ans == s1 + s2);
    cout << s1 << ' ' << s2 << '\n';
    return 0;
}
/*
 5
1 1 3 4 6
 */