#include <iostream>
#include <algorithm>
#include <numeric>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <cctype>
#include <iomanip>
#include <queue>
#include <bitset>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using pri = pair<int, int>;

istream& operator>>(istream& in, vector<int>& a) {
	for (auto& i : a) {
		in >> i;
	}
	return in;
}

ostream& operator >>(ostream& out, vector<int>& a) {
	for (auto& i : a) {
		out << i << ' ';
	}
	out << '\n';
	return out;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;
	vector<int> w(n);
	cin >> w;
	if (w.back() <= 2) {
		int cnt1 = count(w.begin(), w.end(), 1);
		int cnt2 = count(w.begin(), w.end(), 2);
		int all = cnt2 * 2 + cnt1;
		if (cnt1 == 0) {
			if (cnt2 % 2) {
				cout << all / 2 + 1 << ' ' << all / 2 - 1;
			}
			else {
				cout << all / 2 << ' ' << all / 2;
			}
		}
		else {
			if (all % 2) {
				cout << all / 2 + 1 << ' ' << all / 2;
			}
			else {
				cout << all / 2 << ' ' << all / 2;
			}
		}
		exit(0);
	}
	const int W = 2e4;
	vector<vector<vector<array<int, 4>>>> dp(n, vector<vector<array<int, 4>>>(n, vector<array<int, 4>>(W + 1)));
	for (int i = 0; i < n; i++) {
		dp[i][i][0] = { w[i], 0, w[i], 0};
		for (int j = 1; j < W; j++) {
			dp[i][i][j] = { w[i], 0, w[i], 0};
		}
	}
	for (int len = 2; len <= n; len++) {
		for (int l = 0; l <= n - len; l++) {
			int r = l + len - 1;
			for (int j = 0; j < W; j++) {
				if (w[l] < j) {
					dp[l][r][j] = dp[l + 1][r][j - w[l]];
					dp[l][r][j][0] += w[l];
					dp[l][r][j][2] += w[l];
				}
				else if (w[l] == j) {
					dp[l][r][j] = dp[l + 1][r][w[l] - j];
					swap(dp[l][r][j][2], dp[l][r][j][3]);
					dp[l][r][j][0] += w[l];
					dp[l][r][j][2] += w[l];
				}
				else {
					dp[l][r][j] = dp[l + 1][r][w[l] - j];
					swap(dp[l][r][j][0], dp[l][r][j][1]);
					swap(dp[l][r][j][2], dp[l][r][j][3]);
					dp[l][r][j][0] += w[l];
					dp[l][r][j][2] += w[l];
				}

				if (w[r] < j) {
					auto mab = dp[l][r - 1][j - w[r]];
					mab[0] += w[r];
					mab[2] += w[r];
					if (mab[0] > dp[l][r][j][0]) {
						dp[l][r][j][0] = mab[0];
						dp[l][r][j][1] = mab[1];
					}
					if (mab[2] > dp[l][r][j][2]) {
						dp[l][r][j][2] = mab[2];
						dp[l][r][j][3] = mab[3];
					}
				} 
				else if (w[r] == j) {
					auto mab = dp[l][r - 1][w[r] - j];
					swap(mab[2], mab[3]);
					mab[0] += w[r];
					mab[2] += w[r];
					if (mab[0] > dp[l][r][j][0]) {
						dp[l][r][j][0] = mab[0];
						dp[l][r][j][1] = mab[1];
					}
					if (mab[2] > dp[l][r][j][2]) {
						dp[l][r][j][2] = mab[2];
						dp[l][r][j][3] = mab[3];
					}
				}
				else {
					auto mab = dp[l][r - 1][w[r] - j];

					swap(mab[0], mab[1]);
					swap(mab[2], mab[3]);
					mab[0] += w[r];
					mab[2] += w[r];
					if (mab[0] > dp[l][r][j][0]) {
						dp[l][r][j][0] = mab[0];
						dp[l][r][j][1] = mab[1];
					}
					if (mab[2] > dp[l][r][j][2]) {
						dp[l][r][j][2] = mab[2];
						dp[l][r][j][3] = mab[3];
					}
				}
			}
		}
	}
	cout << dp[0][n - 1][0][2] << ' ' << dp[0][n - 1][0][3];
}