#include <iostream>
#include <vector>
#include <set>
#include <map>

using ll = long long;
using ld = long double;

using namespace std;

vector<int> v, pref;
map<tuple<int, int, int, int>, int> dp;

int f(int p, int l, int r, int time) {
    if (l == r)
        return v[l];
    if (dp.find({p, l, r, time}) != dp.end())
        return dp[{p, l, r, time}];
    int res = 0;
    if ((v[l] <= time && !p) || v[l] < time)
        res = max(res, v[l] + f(p, l + 1, r, time - v[l]));
    else
        res = max(res, pref[r + 1] - pref[l] - f(!p, l + 1, r, v[l] - time));
    if ((v[r] <= time && !p) || v[r] < time)
        res = max(res, v[r] + f(p, l, r - 1, time - v[r]));
    else
        res = max(res, pref[r + 1] - pref[l] - f(!p, l, r - 1, v[r] - time));
    dp[{p, l, r, time}] = res;
    return res;
}

void solve() {
    int n;
    cin >> n;
    v.resize(n);
    pref.resize(n + 1, 0);
    for (int& x : v)
        cin >> x;
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + v[i];
    }
    int x = f(0, 0, n - 1, 0);
    cout << x << ' ' << pref[n] - x;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
