#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n; cin >> n;
    vector <int> a(n);
    int mx = 0, sum = 0;
    for (auto &x : a) cin >> x, mx = max(mx, x), sum += x;

    if (n == 3) {
        pair <ll, ll> ans = {-1, -1};
        sort(a.begin(), a.end());

        pair <ll, ll> res1 = {0LL, 0LL};
        res1.first += a[2];
        res1.second += a[1];
        if (a[2] != a[1]) res1.second += a[0];
        else res1.second += a[0];

        pair <ll, ll> res2 = {0LL, 0LL};
        res2.first += a[0];
        res2.second += a[2];
        res2.first += a[1];

        ans = max({ans, res1, res2});

        cout << ans.first << " " << ans.second << "\n";

        return 0;
    }

    if (mx <= 2) {
        int cnt1 = 0, cnt2 = 0;
        for (auto x : a) {
            cnt1 += x == 1;
            cnt2 += x == 2;
        }
        if ((cnt1 & 1)) cout << (cnt1 + 2 * cnt2 + 1) / 2 << " " << (cnt1 + 2 * cnt2) / 2 << "\n";
        else if ((cnt2 & 1)) cout << (cnt1 + 2 * cnt2) / 2 + 1 << " " << (cnt1 + 2 * cnt2) / 2 - 1 << "\n";
        else  cout << (cnt1 + 2 * cnt2) / 2 << " " << (cnt1 + 2 * cnt2) / 2 << "\n";
    }

    vector <vector <int>> dp(n + 1, vector <int> (2 * (sum + 5), -1e9));

    vector <int> pref(n, 0);
    for (int i = 0; i < n; i++) {
        pref[i] = a[i] + (i ? pref[i - 1] : 0);
    }

    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        vector <vector <int>> new_dp(n + 1, vector <int> (2 * (sum + 5), -1e9));
        for (int tA = 0; tA < sum; tA++) {
            for (int l = 0; l <= i; l++) {
                int r = n - i - 1 + l;
                if ((l + (n - r - 1)) % 2 == 0) {
                    new_dp[l + 1][tA + a[l]] = max(new_dp[l + 1][tA + a[l]], dp[l][tA]);
                    new_dp[l][tA + a[r]] = max(new_dp[l][tA + a[r]], dp[l][tA]);
                } else {
                    new_dp[l + 1][tA] = max(new_dp[l + 1][tA], dp[l][tA] + a[l]);
                    new_dp[l][tA] = max(new_dp[l][tA], dp[l][tA] + a[r]);
                }
            }
        }
        dp = new_dp;
    }

    pair <int, int> ans = {-1, -1};
    int mn = 1e9;

    for (int l = 0; l <= n; l++) {
        for (int tA = 0; tA <= sum; tA++) {
            if (abs(tA - dp[l][tA]) < mn) {
                mn = abs(tA - dp[l][tA]);
                ans = {tA, dp[l][tA]};
            }
        }
    }

    cout << ans.first << " " << ans.second << "\n";

    return 0;
}
