#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;

unordered_map<long long, pair<int, int>> mp;
vector<int> v;
vector<int> pref;

long long geth(int l, int r, int a, int b) {
    long long ans = l;
    ans = ans * 21000 + r;
    ans = ans * 21000 + a;
    ans = ans * 21000 + b;
    return ans;
}

pair<int, int> rec(int l, int r, int a, int b) {
    int c = min(a, b);
    a -= c;
    b -= c;
    if (mp.find(geth(l, r, a, b)) != mp.end()) {
        return mp[geth(l, r, a, b)];
    }
    if (r - l <= 0) {
        if (r - l == -1) {
            return {0, 0};
        }
        if (a == 0) {
            return {v[l], 0};
        } else {
            return {0, v[l]};
        }
    }


    if (a == 0) {
        if (pref[r + 1] - pref[l] <= b) {
             mp[geth(l, r, a, b)] = {pref[r + 1] - pref[l], 0};
        }
        pair<int, int> res1 = rec(l + 1, r, v[l], b);
        pair<int, int> res2 = rec(l, r - 1, v[r], b);
        if (res1.first + v[l] > res2.first + v[r]) {
            mp[geth(l, r, a, b)] = {res1.first + v[l], res1.second};
        } else {
            mp[geth(l, r, a, b)] = {res2.first + v[r], res2.second};
        }
    } else {
        if (pref[r + 1] - pref[l] <= a) {
             mp[geth(l, r, a, b)] = {0, pref[r + 1] - pref[l]};
        }
        pair<int, int> res1 = rec(l + 1, r, a, v[l]);
        pair<int, int> res2 = rec(l, r - 1, a, v[r]);
        if (res1.second + v[l] > res2.second + v[r]) {
            mp[geth(l, r, a, b)] = {res1.first, res1.second + v[l]};
        } else {
            mp[geth(l, r, a, b)] = {res2.first, res2.second + v[r]};
        }

    }

    return mp[geth(l, r, a, b)];
}

int main()
{
    int n;
    cin >> n;
    v.resize(n);
    pref.resize(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    pref[0] = 0;
    for (int i = 1; i < n + 1; i++) {
        pref[i] = pref[i - 1] + v[i - 1];
    }
    auto [a, b] = rec(0, n - 1, 0, 0);
    cout << a << " " << b << endl;
    return 0;
}
