#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define ll long long
#define int ll
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int maxn = 2010;

int n, a[maxn], pref[maxn];
unordered_map<int, int> dp[2][maxn][maxn];

void calc(int l, int r, int dop, char c) {
    if(dp[c == 'B'][l][r].find(dop) != dp[c == 'B'][l][r].end()) return;
    if(r == l) {
        dp[c == 'B'][l][r][dop] = a[l];
    } else {
        if(c == 'A') {
            if(dop - a[l] >= 0) {
                calc(l + 1, r, dop - a[l], 'A');
                dp[0][l][r][dop] = dp[0][l + 1][r][dop - a[l]] + a[l];
            } else {
                calc(l + 1, r, a[l] - dop, 'B');
                dp[0][l][r][dop] = pref[r] - pref[l] - dp[1][l + 1][r][a[l] - dop] + a[l];
            }
            if(dop - a[r] >= 0) {
                calc(l, r - 1, dop - a[r], 'A');
                dp[0][l][r][dop] = max(dp[0][l][r][dop], dp[0][l][r - 1][dop - a[r]] + a[r]);
            } else {
                calc(l, r - 1, a[r] - dop, 'B');
                dp[0][l][r][dop] = max(dp[0][l][r][dop], pref[r - 1] - pref[l - 1] - dp[1][l][r - 1][a[r] - dop] + a[r]);
            }
        } else {
            if(dop - a[l] > 0) {
                calc(l + 1, r, dop - a[l], 'B');
                dp[1][l][r][dop] = dp[1][l + 1][r][dop - a[l]] + a[l];
            } else {
                calc(l + 1, r, a[l] - dop, 'A');
                dp[1][l][r][dop] = pref[r] - pref[l] - dp[0][l + 1][r][dop - a[l]] + a[l];
            }
            if(dop - a[r] > 0) {
                calc(l, r - 1, dop - a[r], 'B');
                dp[1][l][r][dop] = max(dp[1][l][r][dop], dp[1][l][r - 1][dop - a[r]] + a[r]);
            } else {
                calc(l, r - 1, a[r] - dop, 'A');
                dp[1][l][r][dop] = max(dp[1][l][r][dop], pref[r - 1] - pref[l - 1] - dp[0][l][r - 1][a[r] - dop] + a[r]);
            }
        }
    }
}

void solve() {
    cin >> n;
    for(int i = 1; i <= n; ++i) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    calc(1, n, 0, 'A');
    cout << dp[0][1][n][0] << " " << pref[n] - dp[0][1][n][0];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
    return 0;
}
