#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_map>
#include <iomanip>
#include <queue>
#include <climits>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef long double ld;
#define mid (r + l) / 2
#define lv (2 * v + 1)
#define rv (2 * v + 2)
#define all(x) x.begin(), x.end()
int a[2100];

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    int n, sum = 0;
    int W;
    vector<vector<vector<int>>> alice, bob;
    cin >> n;
    if (n == 3) {
        alice.resize(10, vector<vector<int>>(10, vector<int>(30000)));
        bob.resize(10, vector<vector<int>>(10, vector<int>(30000)));
        W = 30000;
    }
    else if (n > 200) {
        alice.resize(2100, vector<vector<int>>(2100, vector<int>(5)));
        bob.resize(2100, vector<vector<int>>(2100, vector<int>(5)));
        W = 2;
    }
    else {
        alice.resize(300, vector<vector<int>>(300, vector<int>(501)));
        bob.resize(300, vector<vector<int>>(300, vector<int>(501)));
        W = 500;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sum += a[i];
    }
    for (int dist = 1; dist <= n; dist++) {
        for (int l = 0, r = l + dist; r <= n; l++, r++) {
            for (int time = 0; time <= W; time++) {
                bob[l][r][time] = INT_MAX;
                if (a[r - 1] > time) alice[l][r][time] = max(alice[l][r][time], bob[l][r - 1][a[r - 1] - time] + a[r - 1]);
                else alice[l][r][time] = max(alice[l][r][time], alice[l][r - 1][time - a[r - 1]] + a[r - 1]);
                if (a[l] > time) alice[l][r][time] = max(alice[l][r][time], bob[l + 1][r][a[l] - time] + a[l]);
                else alice[l][r][time] = max(alice[l][r][time], alice[l + 1][r][time - a[l]] + a[l]);
                if (a[r - 1] >= time) bob[l][r][time] = min(bob[l][r][time], alice[l][r - 1][a[r - 1] - time]);
                else bob[l][r][time] = min(bob[l][r][time], bob[l][r - 1][time - a[r - 1]]);
                if (a[l] >= time) bob[l][r][time] = min(bob[l][r][time], alice[l + 1][r][a[l] - time]);
                else bob[l][r][time] = min(bob[l][r][time], bob[l + 1][r][time - a[l]]);
            }
        }
    }
    cout << alice[0][n][0] << " " << sum - alice[0][n][0] << '\n';
    return 0;
}