#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_map>
#include <iomanip>
#include <queue>
#include <climits>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef long double ld;
#define mid (r + l) / 2
#define lv (2 * v + 1)
#define rv (2 * v + 2)
#define all(x) x.begin(), x.end()
int a[2100];

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    int n, sum = 0, maxW = 0;
    int W;
    vector<vector<vector<int>>> alice, bob;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        maxW = max(maxW, a[i]);
        sum += a[i];
    }
    if (n == 3) {
        alice.resize(10, vector<vector<int>>(2, vector<int>(30000)));
        bob.resize(10, vector<vector<int>>(2, vector<int>(30000)));
        W = 30000;
    }
    else if (n > 200) {
        alice.resize(n + 1, vector<vector<int>>(2, vector<int>(maxW + 1)));
        bob.resize(n + 1, vector<vector<int>>(2, vector<int>(maxW + 1)));
        W = maxW + 1;
    }
    else {
        alice.resize(300, vector<vector<int>>(300, vector<int>(501)));
        bob.resize(300, vector<vector<int>>(300, vector<int>(501)));
        W = 500;
    }
    for (int dist = 1, d = 0; dist <= n; dist++, d ^= 1) {
        for (int l = 0; l + dist <= n; l++) {
            for (int time = 0; time <= W; time++) {
                bob[l][d][time] = INT_MAX;
                if (a[l + dist - 1] > time) alice[l][d][time] = max(alice[l][d][time], bob[l][d ^ 1][a[l + dist - 1] - time] + a[l + dist - 1]);
                else alice[l][d][time] = max(alice[l][d][time], alice[l][d ^ 1][time - a[l + dist - 1]] + a[l + dist - 1]);
                if (a[l] > time) alice[l][d][time] = max(alice[l][d][time], bob[l + 1][d ^ 1][a[l] - time] + a[l]);
                else alice[l][d][time] = max(alice[l][d][time], alice[l + 1][d ^ 1][time - a[l]] + a[l]);
                if (a[l + dist - 1] >= time) bob[l][d][time] = min(bob[l][d][time], alice[l][d ^ 1][a[l + dist - 1] - time]);
                else bob[l][d][time] = min(bob[l][d][time], bob[l][d ^ 1][time - a[l + dist - 1]]);
                if (a[l] >= time) bob[l][d][time] = min(bob[l][d][time], alice[l + 1][d ^ 1][a[l] - time]);
                else bob[l][d][time] = min(bob[l][d][time], bob[l + 1][d ^ 1][time - a[l]]);
            }
        }
    }
    cout << alice[0][(n + 1) % 2][0] << " " << sum - alice[0][(n + 1) % 2][0] << '\n';
    return 0;
}