#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <math.h>
#include <algorithm>
#include <queue>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;
vector <ll> a;
vector <ll> pref;
map <pair<pair<ll, ll> , ll>, ll> dp1;
map <pair<pair<ll, ll> , ll>, ll> dp2;


void rdp(ll l, ll r, ll t, ll h) {
	ll p;
	if (h == 1) {
		if (l > r) return;
		if (l == r) {
			dp1[{{l, r}, t}] = a[l];
			return;
		}
		if (dp1[{{l, r}, t}] != 0) return;
		if (a[l] <= t) {
			rdp(l + 1, r, t - a[l], 1);
			dp1[{{l, r}, t}] = a[l] + dp1[{{l + 1, r}, t - a[l]}];
		}
		else {
			rdp(l + 1, r, a[l] - t, 2);
			p = (pref[r] - pref[l + 1] + a[l + 1]) - dp2[{{l + 1, r}, a[l] - t}];
			dp1[{{l, r}, t}] = a[l] + p;
		}
		if (a[r] <= t) {
			rdp(l, r - 1, t - a[r], 1);
			dp1[{{l, r}, t}] = a[r] + dp1[{{l, r - 1}, t - a[r]}];
		}
		else {
			rdp(l, r - 1, a[r] - t, 2);
			p = (pref[r] - pref[l] + a[l] - a[r]) - dp2[{{l, r - 1}, a[r] - t}];
			dp1[{{l, r}, t}] = a[r] + p;
		}
	}
	else {
		if (l > r) return;
		if (l == r) {
			dp2[{{l, r}, t}] = a[l];
			return;
		}
		if (dp2[{{l, r}, t}] != 0) return;
		if (a[l] < t) {
			rdp(l + 1, r, t - a[l], 2);
			dp2[{{l, r}, t}] = a[l] + dp1[{{l + 1, r}, t - a[l]}];
		}
		else {
			rdp(l + 1, r, a[l] - t, 1);
			p = (pref[r] - pref[l + 1] + a[l + 1]) - dp1[{{l + 1, r}, a[l] - t}];
			dp2[{{l, r}, t}] = a[l] + p;
		}
		if (a[r] < t) {
			rdp(l, r - 1, t - a[r], 2);
			dp2[{{l, r}, t}] = a[r] + dp2[{{l, r - 1}, t - a[r]}];
		}
		else {
			rdp(l, r - 1, a[r] - t, 1);
			p = (pref[r] - pref[l] + a[l] - a[r]) - dp1[{{l, r - 1}, a[r] - t}];
			dp2[{{l, r}, t}] = a[r] + p;
		}
	}
}

void solve() {
	ll n, i, s = 0, p;
	cin >> n;
	a.resize(n);
	pref.resize(n);
	for (i = 0; i < n; i++) cin >> a[i], s += a[i];
	pref[0] = a[0];
	for (i = 1; i < n; i++) pref[i] = pref[i - 1] + a[i];
	rdp(0, n - 1, 0, 1);
	p = dp1[{{0, n - 1}, 0}];
	s -= p;
	cout << p << " " << s;
}

int main() {
	ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
	ll t = 1;
	//cin >> t;
	while (t--) solve();
}