#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign
#define vec vector

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

const int INF = (int)(1e18) + 42;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;

    sort(all(a));

    vector<int> pr(n + 1);
    for (int i = 1; i <= n; ++i)
        pr[i] = pr[i - 1] + a[i - 1];

    int sw = 0;
    for (auto i : a)
        sw += i;

    vec<vec<vec<int>>> dp(n, vec<vec<int>>(n, vec<int>(sw + 1)));
    for (int len = 1; len <= n; ++len)
        for (int l = 0; l + len <= n; ++l) {
            int r = l + len - 1;
            for (int at = 0; at <= sw; ++at) {
                int bt = pr[l] + pr[n] - pr[r + 1] - at;
                if (bt < 0)
                    continue;

                if (at <= bt) {
                    if (len == 1) {
                        dp[l][r][at] = a[l];
                        continue;
                    }

                    dp[l][r][at] = -INF;
                    if (at + a[l] <= sw)
                        dp[l][r][at] = max(dp[l][r][at], dp[l + 1][r][at + a[l]] + a[l]);
                    if (at + a[r] <= sw)
                        dp[l][r][at] = max(dp[l][r][at], dp[l][r - 1][at + a[r]] + a[r]);
                } else {
                    if (len == 1) {
                        dp[l][r][at] = 0;
                        continue;
                    }

                    dp[l][r][at] = INF;
                    if (bt + a[l] <= sw)
                        dp[l][r][at] = min(dp[l][r][at], dp[l + 1][r][at]);
                    if (at + a[r] <= sw)
                        dp[l][r][at] = min(dp[l][r][at], dp[l][r - 1][at]);
                }
            }
        }
    /*
    for (int l = 0; l < n; ++l)
        for (int r = l; r < n; ++r) {
            cout << "! " << l << " " << r << ": ";
            for (int at = 0; at <= sw; ++at)
                cout << (dp[l][r][at] == -INF ? -1 : dp[l][r][at]) << " ";
            cout << endl;
        }
    */
    cout << dp[0][n - 1][0] << " " << pr[n] - dp[0][n - 1][0] << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}