#include <bits/extc++.h>

template<class t> using vc = std::vector<t>;

using namespace std;

typedef int ll;

vc<int> a;
__gnu_pbds::cc_hash_table<int, int> dp[2005][2005];
const int inf = 1e9;
ll pref[2005];

int get(int l, int r) { return pref[r + 1] - pref[l]; }

int gen(int l, int r, int b = 0) {
    if (b >= get(l, r)) return -get(l, r);
    if (abs(b) > get(l, r)) return get(l, r);
    if (l == r) {
        if (b <= 0) return a[l];
        return -a[l];
    }
    if (!dp[l][r].count(b)) dp[l][r][b] = inf;
    if (dp[l][r][b] != inf) return dp[l][r][b];
    if (b <= 0) {
        return dp[l][r][b] = max(gen(l + 1, r, b + a[l]) + a[l], gen(l, r - 1, b + a[r]) + a[r]);
    } else {
        return dp[l][r][b] = min(gen(l + 1, r, b - a[l]) - a[l], gen(l, r - 1, b - a[r]) - a[r]);
    }
}


int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    ll n;
    cin >> n;
    a.resize(n);
    for (auto &i: a) cin >> i;
    for (int i = 0; i < n; ++i) pref[i + 1] = pref[i] + a[i];
    ll sm = std::accumulate(a.begin(), a.end(), 0);
    ll a = (gen(0, n - 1) + sm) / 2, b = sm - a;
    cout << a << ' ' << b << '\n';
}