#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<queue>
#include<set>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<iomanip>
#include<cstring>
#include<map>

using namespace std;

// #pragma optimize("O3")
// #pragma optimize("unroll-loops")
// #pragma oprimize("avx2")

#define int long long

int arr[200005];
int cnt[3];
int dp[2005][2005][3][3];

int rek(int n1, int n2, int b1, int b2) {
    if (n1 < 0 || n2 < 0) {
        return -1e9;
    }
    if (dp[n1][n2][b1][b2] != -1) {
        return dp[n1][n2][b1][b2];
    }
    if (n1 == 0 && n2 == 0) {
        dp[n1][n2][b1][b2] = 0;
        return 0;
    }
    if (b1 > 0 && b2 > 0) {
        dp[n1][n2][b1][b2] = rek(n1, n2, b1 - 1, b2 - 1);
        return dp[n1][n2][b1][b2];
    }
    if (b1 == 0) {
        int ans = 0;
        if (n1 > 0) {
            ans = max(ans, rek(n1 - 1, n2, 1, b2) + 1);
        }
        if (n2 > 0) {
            ans = max(ans, rek(n1, n2 - 1, 2, b2) + 2);
        }
        dp[n1][n2][b1][b2] = ans;
        return ans;
    }
    if (b2 == 0) {
        int ans = 1e9;
        if (n1 > 0) {
            ans = min(ans, rek(n1 - 1, n2, b1, 1));
        }
        if (n2 > 0) {
            ans = min(ans, rek(n1, n2 - 1, b1, 2));
        }
        dp[n1][n2][b1][b2] = ans;
        return ans;
    }
}

int ndp[205][205][505][5];
int rek2(int n1, int n2, int b1, int b2) {
    if (n1 > n2) {
        return 0;
    }
    int order = -1;
    if (b1 > 0 && b2 > 0) {
        int gh = min(b1, b2);
        b1 -= gh; b2 -= gh;
    }
    if (b1 == 0) {
        order = 0;
    }
    else {
        order = 1;
    }
    if (b1 < 0 || b2 < 0 || n1 < 0 || n2 + 1 < 0 || order < 0 || order > 1 || max(b1, b2) < 0 || max(b1, b2) > 505) {
        cout << "III" << endl;
        exit(0);
    }
    if (ndp[n1][n2 + 1][max(b1, b2)][order] != -1) {
        return ndp[n1][n2 + 1][max(b1, b2)][order];
    }
    if (order == 0) {
        int ans = max(rek2(n1 + 1, n2, arr[n1], b2) + arr[n1], rek2(n1, n2 - 1, arr[n2], b2) + arr[n2]);
        ndp[n1][n2 + 1][max(b1, b2)][order] = ans;
        return ans;
    }
    else {
        int ans = min(rek2(n1 + 1, n2, b1, arr[n1]), rek2(n1, n2 - 1, b1, arr[n2]));
        ndp[n1][n2 + 1][max(b1, b2)][order] = ans;
        return ans;
    }
}

void solve() {
    for (int i = 0; i < 2001; i++) {
        for (int j = 0; j < 2001; j++) {
            for (int b1 = 0; b1 < 3; b1++) {
                for (int b2 = 0; b2 < 3; b2++) {
                    dp[i][j][b1][b2] = -1;
                }
            }
        }
    }
    for (int i = 0; i < 205; i++) {
        for (int j = 0; j < 205; j++) {
            for (int b1 = 0; b1 < 502; b1++) {
                for (int b2 = 0; b2 < 5; b2++) {
                    ndp[i][j][b1][b2] = -1;
                }
            }
        }
    }
    int n;
    cin >> n;
    if (n == 3) {
        cin >> arr[0] >> arr[1] >> arr[2];
        if (arr[0] == arr[2]) {
            cout << arr[0] * 2 << " " << arr[1] << '\n';
            return;
        }
        int ans = arr[2];
        ans = max(ans, arr[0] + arr[1]);
        cout << ans << " " << arr[0] + arr[1] + arr[2] - ans << '\n';
        return;
    }
    int s = 0;
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
        s += arr[i];
        cnt[arr[i]]++;
    }
    if (n > 200) {
        int ans1 = rek(cnt[1], cnt[2], 0, 0);
        cout << ans1 << " " << s - ans1 << '\n';
        return;
    }
    int ggk = rek2(0, n - 1, 0, 0);
    cout << ggk << " " << s - ggk << '\n';
    return;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;

    for (int i = 0; i < t; i++) {
        solve();
    }
}