#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

constexpr int maxn = 2005, inf = 1e9 + 7;

vector<int> diffs[maxn][maxn];

// int mx_diff[maxn][maxn];

unordered_map<int, int> dp[maxn][maxn];

void solve() {
    int n;
    cin >> n;
    vector<int> w(n);
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        sum += w[i];
    }
    // mx_diff[0][n] = 0;
    diffs[0][n] = {0};
    for (int len = n - 1; len >= 1; --len) {
        for (int l = 0; l + len <= n; ++l) {
            int r = l + len;
            if (l > 0) {
                for (auto diff : diffs[l - 1][r]) {
                    if (diff <= 0) {
                        diffs[l][r].push_back(diff + w[l - 1]);
                    } else {
                        diffs[l][r].push_back(diff - w[l - 1]);
                    }
                }
            }
            if (r < n) {
                for (auto diff : diffs[l][r + 1]) {
                    if (diff <= 0) {
                        diffs[l][r].push_back(diff + w[r]);
                    } else {
                        diffs[l][r].push_back(diff - w[r]);
                    }
                }
            }
            sort(diffs[l][r].begin(), diffs[l][r].end());
            diffs[l][r].resize(unique(diffs[l][r].begin(), diffs[l][r].end()) - diffs[l][r].begin());
        }
    }
    for (int l = 0; l < n; ++l) {
        for (int r = l + 1; r <= n; ++r) {
            for (auto vl : diffs[l][r]) {
                dp[l][r][vl] = inf;
            }
        }
    }
    // cout << dp[0][n][0] << '\n';
    for (int l = 0; l < n; ++l) {
        for (auto vl : diffs[l][l + 1]) {
            if (vl <= 0) {
                dp[l][l + 1][vl] = vl + w[l];
            } else {
                dp[l][l + 1][vl] = vl - w[l];
            }
        }
    }
    for (int len = 2; len <= n; ++len) {
        for (int l = 0; l + len <= n; ++l) {
            int r = l + len;
            for (auto vl : diffs[l][r]) {
                if (vl <= 0) {
                    dp[l][r][vl] = -inf;
                    if (dp[l + 1][r][vl + w[l]] != inf) {
                        dp[l][r][vl] = max(dp[l][r][vl], dp[l + 1][r][vl + w[l]]);
                    }
                    if (dp[l][r - 1][vl + w[r - 1]] != inf) {
                        dp[l][r][vl] = max(dp[l][r][vl], dp[l][r - 1][vl + w[r - 1]]);
                    }
                    if (dp[l][r][vl] == -inf) {
                        dp[l][r][vl] = inf;
                    }
                } else {
                    if (dp[l + 1][r][vl - w[l]] != inf) {
                        dp[l][r][vl] = min(dp[l][r][vl], dp[l + 1][r][vl - w[l]]);
                    }
                    if (dp[l][r - 1][vl - w[r - 1]] != inf) {
                        dp[l][r][vl] = min(dp[l][r][vl], dp[l][r - 1][vl - w[r - 1]]);
                    }
                }
            }
        }
    }
    cout << (sum + dp[0][n][0]) / 2 << ' ' << (sum - dp[0][n][0]) / 2 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
