#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

int INF = 1e9;

vector<int> w;
int wmx = 0;

vector<vector<vector<int>>> mat;
map<vector<int>, int> mp;

int dfs2(int l, int r, int d)
{
    if(l > r)
    {
        return d;
    }

    if(mp.find({l, r, d}) != mp.end())
    {
        return mp[{l, r, d}];
    }

    if(d <= 0)
    {
        int ans1 = dfs2(l + 1, r, d + w[l]);
        int ans2 = dfs2(l, r - 1, d + w[r]);
        mp[{l, r, d}] = max(ans1, ans2);
        return max(ans1, ans2);
    } else {
        int ans1 = dfs2(l + 1, r, d - w[l]);
        int ans2 = dfs2(l, r - 1, d - w[r]);
        mp[{l, r, d}] = min(ans1, ans2);
        return min(ans1, ans2);
    }
}

int dfs(int l, int r, int d)
{
    if(l > r)
    {
        return d;
    }

    if(mat[l][r][2 * wmx + d] != INF)
    {
        return mat[l][r][2 * wmx + d];
    }

    if(d <= 0)
    {
        int ans1 = dfs(l + 1, r, d + w[l]);
        int ans2 = dfs(l, r - 1, d + w[r]);
        mat[l][r][2 * wmx + d] = max(ans1, ans2);
        return max(ans1, ans2);
    } else {
        int ans1 = dfs(l + 1, r, d - w[l]);
        int ans2 = dfs(l, r - 1, d - w[r]);
        mat[l][r][2 * wmx + d] = min(ans1, ans2);
        return min(ans1, ans2);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;

    cin >> n;

    w.resize(n);

    int W = 0;
    

    for(int i = 0; i < n; ++i)
    {
        cin >> w[i];
        W += w[i];
        wmx = max(wmx, w[i]);
    }

    sort(w.begin(), w.end());

    int d = 0;
    if(n <= 500 && W <= 5000)
    {
        d = dfs2(0, n-1, 0);
    } else 
    {
        mat.resize(n, vector<vector<int>>(n, vector<int>(4 * wmx + 10, INF)));
        d = dfs(0, n-1, 0);
    }
    cout << (W + d) / 2 << ' ' << (W - d) / 2 << '\n';

}