#include <bits/stdc++.h>

#pragma GCC optimize("03")
#pragma GCC target("avx2")

using namespace std;

using ll = short;
using ld = long double;

using pld = pair<ld, ld>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using vin = vector<int>;
using vll = vector<ll>;
using vld = vector<ld>;
using vbo = vector<bool>;
using vpl = vector<pll>;
using vpi = vector<pii>;
using vpd = vector<pld>;

using vvi = vector<vin>;
using vvl = vector<vll>;
using vvo = vector<vbo>;

#define sz(a) (ll)a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for(int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for (auto &i : a)

#define fastio ios_base::sync_with_stdio(false);cin.tie(0)

int main() {
    fastio;
    ll n;
    cin >> n;
    vll weight(n);
    ll mx_w = 0;
    F0R(i, n){
        cin >> weight[i];
        mx_w = max(mx_w, weight[i]);
    }
    vector<vvl> dp_A(n, vvl(n, vll(mx_w + 1)));
    vector<vvl> dp_B(n, vvl(n, vll(mx_w + 1)));
    vll pred(n + 1, 0);
    F0R(i, n){
        pred[i + 1] = pred[i] + weight[i];
    }
    F0R(i, n){
        F0R(j, mx_w + 1){
            if (j == 0){
                dp_A[i][i][j] = weight[i];
                dp_B[i][i][j] = 0;
            } else {
                dp_A[i][i][j] = weight[i];
                dp_B[i][i][j] = weight[i];
            }
        }
    }
    FOR(d, 1, n){
        F0R(l, n - d){
            ll r = l + d;
            F0R(w, mx_w + 1){
                ll v1, v2;
                if (w == 0){
                    v1 = weight[l] + (pred[r + 1] - pred[l + 1]) - dp_B[l + 1][r][weight[l]];
                    v2 = weight[r] + (pred[r] - pred[l]) - dp_B[l][r - 1][weight[r]];
                    dp_A[l][r][w] = max(v1, v2);
                    dp_B[l][r][w] = pred[r + 1] - pred[l] - dp_A[l][r][w];
                } else {
                    if (w - weight[l] < 0) {
                        v1 = weight[l] + (pred[r + 1] - pred[l + 1]) - dp_B[l + 1][r][weight[l] - w];
                    } else {
                        v1 = weight[l] + dp_A[l + 1][r][w - weight[l]];
                    }
                    if (w - weight[r] < 0) {
                        v2 = weight[r] + (pred[r] - pred[l]) - dp_B[l][r - 1][weight[r] - w];
                    } else {
                        v2 = weight[r] + dp_A[l][r - 1][w - weight[r]];
                    }
                    dp_A[l][r][w] = max(v1, v2);
                    if (w - weight[l] <= 0) {
                        v1 = weight[l] + (pred[r + 1] - pred[l + 1]) - dp_A[l + 1][r][weight[l] - w];
                    } else {
                        v1 = weight[l] + dp_B[l + 1][r][w - weight[l]];
                    }
                    if (w - weight[r] <= 0) {
                        v2 = weight[r] + (pred[r] - pred[l]) - dp_A[l][r - 1][weight[r] - w];
                    } else {
                        v2 = weight[r] + dp_B[l][r - 1][w - weight[r]];
                    }
                    dp_B[l][r][w] = max(v1, v2);
                }
            }
        }
    }
    cout << dp_A[0][n - 1][0] << ' ' << dp_B[0][n - 1][0];
    return 0;
}
