#pragma GCC optimize("Ofast,O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define endl '\n'
#define pint pair<int, int>
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

map<pair<pint, int>, pint> mem;
vector<int> prefs, bruhsuffs;
int n;
vector<int> a;

void dfs(int s1, int pref, int suff) {
    if (mem.count(mp(mp(s1, pref), suff))) return;
    int s2 = prefs[pref] + bruhsuffs[suff] - s1;
    if (suff + pref == n) {
        mem[mp(mp(s1, pref), suff)] = mp(s1, s2);
        return;
    }
    if (n > 150 && abs(s2 - s1) > 200) {
        mem[mp(mp(s1, pref), suff)] = mp(-1, -1);
        return;
    }
    if (s1 <= s2) {
        dfs(s1 + a[pref], pref + 1, suff);
        dfs(s1 + a[n - suff - 1], pref, suff + 1);
        pint f = mem[mp(mp(s1 + a[pref], pref + 1), suff)], s = mem[mp(mp(s1 + a[n - suff - 1], pref), suff + 1)];
        if (f.first > s.first) {
            mem[mp(mp(s1, pref), suff)] = f;
        } else {
            mem[mp(mp(s1, pref), suff)] = s;
        }
    } else {
        dfs(s1, pref + 1, suff);
        dfs(s1, pref, suff + 1);
        pint f = mem[mp(mp(s1, pref + 1), suff)], s = mem[mp(mp(s1, pref), suff + 1)];
        if (f.second > s.second) {
            mem[mp(mp(s1, pref), suff)] = f;
        } else {
            mem[mp(mp(s1, pref), suff)] = s;
        }
    }
}

void solve() {
    cin >> n;
    a.resize(n);
    int sum = 0;
    forn(i, 0, n) {
        cin >> a[i];
        sum += a[i];
    }

    if (a.back() <= 2 && n >= 1000) {
        cout << (sum + 1) / 2 << " " << sum / 2;
        return;
    }

    int sm = 0;
    bruhsuffs.assign(n + 1, 0);
    forn(i, 0, n) {
        sm += a[n - i - 1];
        bruhsuffs[i + 1] = sm;
    }

    prefs.assign(n + 1, 0);
    forn(i, 0, n) {
        prefs[i + 1] = prefs[i] + a[i];
    }

    dfs(0, 0, 0);
    cout << mem[mp(mp(0, 0), 0)].first << " " << mem[mp(mp(0, 0), 0)].second;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) solve();

    return 0;
}
