#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <iomanip>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

const long long INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

vector<ll> w;

ll get(ll l, ll r, ll d) {
	if (l > r) return d;
	if (d <= 0) return max(get(l + 1, r, d + w[l]), get(l, r - 1, d + w[r]));
	else return min(get(l + 1, r, d - w[l]), get(l, r - 1, d - w[r]));
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll n;
	cin >> n;
	w.resize(n);
	ll s = 0;
	for (ll i = 0; i < n; i++) { cin >> w[i]; s += w[i]; }
	ll d = get(0, n - 1, 0);
	cout << (s + d) / 2 << " " << (s - d) / 2 << "\n";
	return 0;
}