#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <iomanip>
#include <queue>

using namespace std;
typedef int ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

const long long INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

vector<ll> w;

ll get(ll l, ll r, ll d, vector<vector<vector<int>>>& ans, int W) {
	if (l > r) return d;
	if (ans[l][r][d + W] != W + 1) return ans[l][r][d + W];
	if (d <= 0) {
		ans[l][r][d + W] = max(get(l + 1, r, d + w[l], ans, W), get(l, r - 1, d + w[r], ans, W));
	} else {
		ans[l][r][d + W] = min(get(l + 1, r, d - w[l], ans, W), get(l, r - 1, d - w[r], ans, W));
	}
	return ans[l][r][d + W];
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll n;
	cin >> n;
	w.resize(n);
	ll s = 0;
	for (ll i = 0; i < n; i++) { cin >> w[i]; s += w[i]; }
	vector<vector<vector<int>>> ans(n, vector<vector<int>>(n, vector<int>((s + 1) * 2, s + 1)));
	ll d = get(0, n - 1, 0, ans, s);
	cout << (s + d) / 2 << " " << (s - d) / 2 << "\n";
	return 0;
}