#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <array>
#include <cmath>
#include <iomanip>
#include <queue>

using namespace std;
typedef int ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

const long long INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

//ll get(ll l, ll r, ll d, vector<vector<vector<int>>>& ans, int W) {
//	if (l > r) return d;
//	if (ans[l][r][d + W] != W + 1) return ans[l][r][d + W];
//	if (d <= 0) {
//		ans[l][r][d + W] = max(get(l + 1, r, d + w[l], ans, W), get(l, r - 1, d + w[r], ans, W));
//	} else {
//		ans[l][r][d + W] = min(get(l + 1, r, d - w[l], ans, W), get(l, r - 1, d - w[r], ans, W));
//	}
//	return ans[l][r][d + W];
//}

bool ok(ll d, ll s) {
	return (-s <= d && d <= s);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll n;
	cin >> n;
	vector<ll> w(n);
	ll s = 0, sm = 0;
	for (ll i = 0; i < n; i++) { cin >> w[i]; sm += w[i]; }
	s = w[n - 1];
	vector<vector<ll>> ans(n + 1, vector<ll>(2 * s + 1));
	for (ll i = -s; i <= s; i++) {
		for (ll l = 0; l <= n; l++) ans[l][i + s] = i;
	}
	vector<vector<ll>> res(n + 1, vector<ll>(2 * s + 1));
	for (ll sh = 0; sh < n; sh++) {
		for (ll i = 0; i < n - sh; i++) {
			ll l = i, r = i + sh;
			for (ll d = -s; d <= s; d++) {
				if (sh == n - 1 && d == 0) {
					ll awoub = 0;
				}
				if (d <= 0)
					res[l][d + s] = max(ans[l + 1][d + w[l] + s], ans[l][d + w[r] + s]);
				else
					res[l][d + s] = min(ans[l + 1][d - w[l] + s], ans[l][d - w[r] + s]);
			}
		}
		res.swap(ans);
	}
	ll d = ans[0][s];
	cout << (sm + d) / 2 << " " << (sm - d) / 2 << "\n";
	return 0;
}