#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define sz(array) (int)array.size()
#define all(array) array.begin(), array.end()
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
int n;
vector<int> w;
vector<vector<vector<int>>> dp;
int rec(int l, int r, int time, int m, int sum_time) {
    if (r < l) return m;
    if (dp[l][r][time] != 0) return dp[l][r][time];
    if (time <= sum_time - time) {
        return dp[l][r][time] = max(rec(l+1, r, time+w[l], m+w[l], sum_time+w[l]), rec(l, r-1, time+w[r], m+w[r], sum_time+w[r]));
    }
    return dp[l][r][time] = min(rec(l+1, r, time, m-w[l], sum_time+w[l]), rec(l, r-1, time, m-w[r], sum_time+w[r]));
}
void solve() {
    cin >> n;
    w.resize(n);
    int s = 0;
    for (int i = 0; i < n; cin >> w[i++], s += w[i-1]);
    dp.assign(n, vector<vector<int>> (n, vector<int>(s+1, 0)));
    int l = rec(0, n-1, 0, 0, 0);
    cout << (s + l) / 2 << ' ' << (s - l) / 2 << '\n';
}

signed main() {
    int tc = 1;
    #ifdef LOCAL
        freopen("a.in", "r", stdin);
        cin >> tc;
    #endif
    while (tc--) {
        solve();
    }
    return 0;
}
