#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define pw(x) (1ll << x)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn (T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx (T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pii = pair < int , int >;

const int N = 1e6 + 5;
const int inf = 2e9;
const ll INF = 4e18;

int n;
int a[N];
ll pref[N];
ll suff[N];

int main() {
#ifdef localy
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for (int i = 1; i <= n; ++ i) cin >> a[i];

    if (n == 3) {
        if (a[n] >= a[1] + a[2]) {
            cout << a[n] << " " << a[1] + a[2] << "\n";
            return 0;
        }
        cout << a[1] + a[2] << " " << a[n] << "\n";
        return 0;
    }

    int sa = 0, sb = 0;
    int resa = 0, resb = 0;

    for (int i = 1; i <= n; ++ i) {
        int mn = min (sa, sb);
        sa -= mn;
        sb -= mn;

        if (!sa) resa += a[i], sa = a[i];
        else resb += a[i], sb = a[i];
    }
    sa = 0, sb = 0;
    int _resa = 0, _resb = 0;

    for (int i = n; i >= 1; -- i) {
        int mn = min (sa, sb);
        sa -= mn;
        sb -= mn;

        if (!sa) _resa += a[i], sa = a[i];
        else _resb += a[i], sb = a[i];
    }

    if (resa > _resa) cout << resa << " " << resb << "\n";
    else cout << _resa << " " << _resb << "\n";
    return 0;
}
