    #include <bits/stdc++.h>

    #define fi first
    #define se second

    #define pb push_back
    #define pw(x) (1ll << x)
    #define sz(x) (int)(x).size()
    #define all(x) (x).begin(), (x).end()

    using namespace std;

    template < typename T >
    bool umn (T& a, T b) {
        return a > b ? a = b, 1 : 0;
    }
    template < typename T >
    bool umx (T& a, T b) {
        return a < b ? a = b, 1 : 0;
    }

    using ll = long long;
    using ld = long double;
    using ull = unsigned long long;
    using pii = pair < int , int >;

    const int N = 1e6 + 5;
    const int inf = 2e9;
    const ll INF = 4e18;

    int n;
    int a[N];

    pii dp[2001][2001];
    int val (pii x) {
        return abs (x.fi - x.se);
    }

    bool comp (pii a, pii b) {
        int va = val (a);
        int vb = val (b);
        if (va == vb) return a < b;
        return va > vb;
    }

    int main() {
    #ifdef localy
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // localy
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);

        cin >> n;
        for (int i = 1; i <= n; ++ i) cin >> a[i];

        for (int i = 0; i <= n + 1; ++ i) {
            for (int j = 0; j <= n + 1; ++ j) dp[i][j] = {1, inf};
        }

        dp[0][n + 1] = {0, 0};

        for (int l = 0; l <= n; ++ l) {
            for (int r = n + 1; r >= 1; -- r) {
                if (l > r) continue;
                if (l != n) {
                    if (dp[l][r].fi <= dp[l][r].se && comp(dp[l + 1][r], make_pair (dp[l][r].fi + a[l + 1], dp[l][r].se))) {
                        dp[l + 1][r] = make_pair (dp[l][r].fi + a[l + 1], dp[l][r].se);
                    }
                    if (dp[l][r].fi >= dp[l][r].se && comp(dp[l + 1][r], make_pair (dp[l][r].fi, dp[l][r].se + a[l + 1]))) {
                        dp[l + 1][r] = make_pair(dp[l][r].fi, dp[l][r].se + a[l + 1]);
                    }
                }
                if (r != 1) {
                    if (dp[l][r].fi >= dp[l][r].se && comp(dp[l][r - 1], make_pair (dp[l][r].fi + a[r - 1], dp[l][r].se))) {
                        dp[l][r - 1] = make_pair (dp[l][r].fi + a[r - 1], dp[l][r].se);
                    }

                    if (dp[l][r].fi <= dp[l][r].se && comp(dp[l][r - 1], make_pair (dp[l][r].fi, dp[l][r].se + a[r - 1]))) {
                        dp[l][r - 1] = make_pair(dp[l][r].fi, dp[l][r].se + a[r - 1]);
                    }
                }
            }
        }

        int a = 1, b = inf;
        for (int i = 1; i < n; ++ i) {
            if (comp(make_pair(a, b), dp[i][i + 1])) {
                a = dp[i][i + 1].fi;
                b = dp[i][i + 1].se;
            }
        }

        cout << a << " " << b << "\n";
        return 0;
    }
