#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define int ll
typedef long long ll;
#define all(x) x.begin(), x.end()
#define vec vector

int n, W;
const int N = 200;
const int mW = 500;
vec<int> pr, v;
int dp[N + 1][N + 1][mW + 1];

int get(int l, int r) {
    return pr[r] - pr[l];
}

int w = 0;
int rec(int i, int j) {
    if (i > j)
        return w;
    if (dp[i][j][w] > -1)
        return dp[i][j][w];
    int claimed = W - get(i, j + 1);
    if (w * 2 <= claimed) {
        w += v[i];
        int a = rec(i + 1, j);
        w += v[j];
        w -= v[i];
        int b = rec(i, j - 1);
        w -= v[j];
        dp[i][j][w] = max(a, b);
        return dp[i][j][w];
    } else {
        int a = rec(i + 1, j);
        int b = rec(i, j - 1);
        dp[i][j][w] = min(a, b);
        return dp[i][j][w];
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;
    v.resize(n);
    int cn = 0;
    for (auto& it : v)
        cin >> it;

    pr.assign(n + 1, 0);
    for (int i = 0; i < n; i++)
        pr[i + 1] = pr[i] + v[i];

    W = 0;
    for (auto& it : v)
        W += it;

    for (int i = 0; i <= N; i++)
        for (int j = 0; j <= N; j++)
            for (int cw = 0; cw <= W; cw++)
                dp[i][j][cw] = -1;

    int a = rec(0, n - 1);
    cout << a << " " << W - a;
}