#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define int ll
typedef long long ll;
#define all(x) x.begin(), x.end()
#define vec vector

int n, W;
vec<int> pr, v;
map<vec<int>, int> dp;

inline int get(int l, int r) {
    return pr[r] - pr[l];
}

int w = 0;
int rec(int i, int j) {
    if (i > j)
        return w;
    if (dp.count({i, j, w}))
        return dp[{i, j, w}];
    int claimed = W - get(i, j + 1);
    if (w * 2 <= claimed) {
        w += v[i];
        int a = rec(i + 1, j);
        w += v[j];
        w -= v[i];
        int b = rec(i, j - 1);
        w -= v[j];
        dp[{i, j, w}] = max(a, b);
        return dp[{i, j, w}];
    } else {
        int a = rec(i + 1, j);
        int b = rec(i, j - 1);
        dp[{i, j, w}] = min(a, b);
        return dp[{i, j, w}];
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;
    v.resize(n);
    int cn = 0;
    for (auto& it : v)
        cin >> it;

    pr.assign(n + 1, 0);
    for (int i = 0; i < n; i++)
        pr[i + 1] = pr[i] + v[i];

    W = 0;
    for (auto& it : v)
        W += it;

    int a = rec(0, n - 1);
    cout << a << " " << W - a;
}