//Туры-пуры

#include<bits/stdc++.h>

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);

    int n;
    std::cin >> n;
    std::vector<int> w(n);
    for (auto& i : w) std::cin >> i;
    bool ok = true;
    for (int i = 0; i + 1 < n; ++i) {
        ok &= w[i + 1] <= 2 * w[i];
    }
    int W = std::accumulate(w.begin(), w.end(), 0);
    std::vector<std::vector<std::vector<int>>> dp(n, std::vector<std::vector<int>>(n));
    std::vector<std::vector<int>> bound(n, std::vector<int>(n));
    for (int l = 0; l < n; ++l) {
        for (int r = l; r < n; ++r) {
            if (l == 0 || r == n - 1) bound[l][r] = W;
            else bound[l][r] = std::max(w[l - 1], w[r + 1]) + 10;
            dp[l][r].resize(2 * bound[l][r] + 1);
        }
    }

    auto get = [&](int l, int r, int c) -> int {
        if (l > r) return c;
        if (c < -bound[l][r] || c > bound[l][r]) return (int)-1e9;
        return dp[l][r][c + bound[l][r]];
    };
    for (int d = 0; d < n; ++d) {
        for (int l = 0, r = d; r < n; ++l, ++r) {
            for (int c = -bound[l][r]; c <= bound[l][r]; ++c) {
                if (c <= 0) dp[l][r][c + bound[l][r]] = std::max(get(l + 1, r, c + w[l]), get(l, r - 1, c + w[r]));
                else dp[l][r][c + bound[l][r]] = std::min(get(l + 1, r, c - w[l]), get(l, r - 1, c - w[r]));
            }
        }
    }
    int bal = get(0, n - 1, 0);
    std::cout << (W + bal) / 2 << ' ' << (W - bal) / 2;
}