//Туры-пуры

#pragma GCC optimize("O3")
#pragma GCC target("avx2")

#include<bits/stdc++.h>

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);

    int n;
    std::cin >> n;
    std::vector<int> w(n);
    for (auto& i : w) std::cin >> i;
    bool ok = true;
    for (int i = 0; i + 1 < n; ++i) {
        ok &= w[i + 1] <= 2 * w[i];
    }
    int W = std::accumulate(w.begin(), w.end(), 0);
    std::vector<std::vector<std::vector<int>>> dp(n, std::vector<std::vector<int>>(n));
    std::vector<std::vector<int>> mn(n, std::vector<int>(n)), mx(n, std::vector<int>(n));

    mn[0][n - 1] = mx[0][n - 1] = 0;
    for (int d = n - 1; d; --d) {
        for (int l = 0, r = d; r < n; ++l, ++r) {
            for (auto x : {mn[l][r], mx[l][r], 0, 1}) {
                if (x < mn[l][r] || x > mx[l][r]) continue;
                if (x <= 0) {
                    mn[l + 1][r] = std::min(mn[l + 1][r], x + w[l]);
                    mx[l + 1][r] = std::max(mx[l + 1][r], x + w[l]);
                    mn[l][r - 1] = std::min(mn[l][r - 1], x + w[r]);
                    mx[l][r - 1] = std::max(mx[l][r - 1], x + w[r]);
                } else {
                    mn[l + 1][r] = std::min(mn[l + 1][r], x - w[l]);
                    mx[l + 1][r] = std::max(mx[l + 1][r], x - w[l]);
                    mn[l][r - 1] = std::min(mn[l][r - 1], x - w[r]);
                    mx[l][r - 1] = std::max(mx[l][r - 1], x - w[r]);
                }
            }
        }
    }
    auto get = [&](int l, int r, int c) -> int {
        if (l > r) return c;
        return dp[l][r][c - mn[l][r]];
    };
    for (int d = 0; d < n; ++d) {
        for (int l = 0, r = d; r < n; ++l, ++r) {
            dp[l][r].resize(mx[l][r] - mn[l][r] + 1);
            for (int c = mn[l][r]; c <= mx[l][r]; ++c) {
                if (c <= 0) dp[l][r][c - mn[l][r]] = std::max(get(l + 1, r, c + w[l]), get(l, r - 1, c + w[r]));
                else dp[l][r][c - mn[l][r]] = std::min(get(l + 1, r, c - w[l]), get(l, r - 1, c - w[r]));
            }
        }
    }
    int bal = get(0, n - 1, 0);
    std::cout << (W + bal) / 2 << ' ' << (W - bal) / 2;
}