//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
typedef long long ll;
typedef long double ld;
#define all(a) (a).begin(), (a).end()
#define pii pair<ll, ll>

using namespace std;
const ll inf = 2e13;

int main() {
#ifdef ZVEREV
    freopen("inputf.in", "r", stdin);
    freopen("outputf.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << fixed << setprecision(64);
    int n; cin >> n;
    deque<int> a(n); for (auto& i : a) cin >> i;
    int maxw = 0;
    int sum = 0;
    for (auto i : a) {
        maxw = max(maxw, i);
        sum += i;
    }
    if (n == 3) {
        if (a[2] > a[0] + a[1]) {
            cout << a[2] << ' ' << a[0] + a[1];
        } else {
            cout << a[0] + a[1] << ' ' << a[2];
        }
        return 0;
    }
    if (maxw <= 2) {
        int resa = 0;
        int resb = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            vector<int> p;
            int fir = 0;
            int last = n - 1;
            for (int i = 0; i < n; i++) {
                if ((1 << i) & mask) {
                    p.push_back(a[fir++]);
                } else {
                    p.push_back(a[last--]);
                }
            }
            int alice = 0;
            int bob = 0;
            int ansa = 0;
            int ansb = 0;
            for (int i = 0; i < n; i++) {
                if (alice == 0) {
                    alice += p[i];
                    ansa += p[i];
                } else if (bob == 0) {
                    bob += p[i];
                    ansb += p[i];
                }
                int mn = min(alice, bob);
                alice -= mn;
                bob -= mn;
            }
            if (ansa > resa) {
                resa = ansa;
                resb = ansb;
            }
        }
        cout << resa << ' ' << resb;
        return 0;
    }
    vector<ll> pref(n + 1, 0), suf(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i-1] + a[i-1];
    }
    for (int i = n-1; i >= 0; i--) {
        suf[i] = suf[i+1] + a[i];
    }
    vector<vector<vector<ll>>> dp(n + 1, vector<vector<ll>>(n + 1, vector<ll>(sum + 1, -inf)));
    dp[0][0][0] = 0;
    for (int len = n-1; len >= 0; len--) {
        for (int left = 0; left + len <= n; left++) {
            int right = n - left - len;
            for (int W = 0; W <= sum; W++) {
                ll alice = W;
                ll bob = pref[left] + suf[n - right] - alice;
                if (bob < 0) {
                    continue;
                }
                if (left && alice - a[left-1] <= bob && W >= a[left-1]) {
                    dp[left][right][W] = max(dp[left][right][W], dp[left-1][right][W - a[left-1]]);
                }
                if (right && alice - a[n-right] <= bob && W >= a[n - right]) {
                    dp[left][right][W] = max(dp[left][right][W], dp[left][right-1][W - a[n - right]]);
                }
                if (left && bob - a[left-1] < alice && bob - a[left-1] >= 0) {
                    dp[left][right][W] = max(dp[left][right][W], dp[left-1][right][W]);
                }
                if (right && bob - a[n-right] < alice && bob - a[n-right] >= 0) {
                    dp[left][right][W] = max(dp[left][right][W], dp[left][right-1][W]);
                }
            }
        }
    }
    ll mx = inf;
    ll suma = 0;
    ll sumb = 0;
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= n; j++) {
            for (int k = 0; k <= sum; k++) {
                if (dp[i][j][k] == 0) {
                    ll alice = k;
                    ll bob = pref[i] + suf[n - j] - alice;
                    if (k > mx) {
                        mx = k;
                        suma = alice;
                        sumb = bob;
                    }
                }
                //cout << i << ' ' << j << ' ' << k << ':' << dp[i][j][k] << endl;
            }
        }
    }
    cout << suma << ' ' << sumb;
}
