//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ll = long long;
using ld = long double;

const ll INF = 2e18;
const int MOD = 1e9 + 7, N = 1e5 + 1, MAXN = 5e5 + 1, K = 26, INFi = 2e9;
const ld EPS = 1e-12, PI = acos(-1);

random_device rd;
mt19937_64 rnd(rd());

void solve() {
    int n;
    cin >> n;
    vector<int> a(n + 2);
    int mxw = 0, s = 0;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        mxw = max(mxw, a[i]);
        s += a[i];
    }
    vector<vector<vector<int>>> dp(n + 2, vector<vector<int>>(n + 2, vector<int>(2 * mxw + 1, INF)));
    dp[0][n + 1][mxw] = 0;
    for (int len = n; len >= 1; len--) {
        for (int i = 0; i + len <= n; i++) {
            int j = i + len + 1;
            for (int k1 = 0; k1 <= 2 * mxw; k1++) {
                if (dp[i][j][k1] == INF) {
                    continue;
                }
                int k = k1 - mxw, time = abs(k);
                if (k <= 0) {
                    dp[i + 1][j][a[i + 1] - time + mxw] =
                            max(dp[i + 1][j][a[i + 1] - time + mxw] * (dp[i + 1][j][a[i + 1] - time + mxw] != INF),
                                                              dp[i][j][k1] + a[i + 1]);
                    dp[i][j - 1][a[j - 1] - time + mxw] =
                            max(dp[i][j - 1][a[j - 1] - time + mxw] * (dp[i][j - 1][a[j - 1] - time + mxw] != INF),
                                                              dp[i][j][k1] + a[j - 1]);
                } else {
                    dp[i + 1][j][time - a[i + 1] + mxw] = min(dp[i + 1][j][time - a[i + 1] + mxw],
                                                              dp[i][j][k1]);
                    dp[i][j - 1][time - a[j - 1] + mxw] = min(dp[i][j - 1][time - a[j - 1] + mxw],
                                                              dp[i][j][k1]);
                }
            }
        }
    }
    int ans = 0, cur = INF;
    for (int i = 0; i <= n; i++) {
        for (int k = 0; k <= 2 * mxw; k++) {
            if (dp[i][i + 1][k] == INF) {
                continue;
            }
            if (cur > max(dp[i][i + 1][k], s - dp[i][i + 1][k])) {
                ans = dp[i][i + 1][k];
                cur = max(dp[i][i + 1][k], s - dp[i][i + 1][k]);
            } else if (cur >= max(dp[i][i + 1][k], s - dp[i][i + 1][k]) && ans < dp[i][i + 1][k]) {
                ans = dp[i][i + 1][k];
            }
        }
    } 
    int ans1 = accumulate(a.begin(), a.end(), 0LL) - ans;
    cout << ans << ' ' << ans1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
