//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ll = long long;
using ld = long double;

const ll INF = 2e18;
const int MOD = 1e9 + 7, N = 1e5 + 1, MAXN = 5e5 + 1, K = 26, INFi = 2e9;
const ld EPS = 1e-12, PI = acos(-1);

random_device rd;
mt19937_64 rnd(rd());

void solve() {
    int n;
    cin >> n;
    vector<int> a(n + 2);
    int mxw = 0, s = 0;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        mxw = max(mxw, a[i]);
        s += a[i];
    }
    vector<vector<vector<vector<int>>>> dp(2,
                                           vector<vector<vector<int>>>(n + 2,vector<vector<int>>(n + 2, vector<int>(2 * mxw + 1, INF))));
    dp[0][0][n + 1][mxw] = dp[1][0][n + 1][mxw] = 0;
    for (int len = n; len >= 1; len--) {
        for (int i = 0; i + len <= n; i++) {
            int j = i + len + 1;
            for (int k1 = 0; k1 <= 2 * mxw; k1++) {
                for (int t = 0; t < 2; t++) {
                    if (dp[t][i][j][k1] == INF) {
                        continue;
                    }
                    int k = k1 - mxw, time = abs(k), t1;
                    if (k <= 0) {
                        t1 = 0;
                    } else {
                        t1 = 1;
                    }

                    dp[t1][i + 1][j][a[i + 1] - time + mxw] = min(dp[t1][i + 1][j][a[i + 1] - time + mxw],
                                                                 dp[t][i][j][k1] + max(0LL, a[i + 1] - time));
                    dp[t1][i][j - 1][a[j - 1] - time + mxw] = min(dp[t1][i][j - 1][a[j - 1] - time + mxw],
                                                                 dp[t][i][j][k1] + max(0LL, a[j - 1] - time));
                }
            }
        }
    }
    int ans = INF, fl = 0, cur = INF;
    for (int i = 0; i <= n; i++) {
        for (int k = 0; k <= 2 * mxw; k++) {
            for (int t = 0; t < 2; t++) {
                if (dp[t][i][i + 1][k] == INF) {
                    continue;
                }
                if (cur > max(s - (dp[t][i][i + 1][k] + max(0LL, -1LL * (k - mxw))), dp[t][i][i + 1][k] + max(0LL, -1LL * (k - mxw)))) {
                    ans = dp[t][i][i + 1][k] + max(0LL, -1LL * (k - mxw));
                    cur = max(s - (dp[t][i][i + 1][k] + max(0LL, -1LL * (k - mxw))), dp[t][i][i + 1][k] + max(0LL, -1LL * (k - mxw)));
                    fl = t;
                } else if (cur == max(s - (dp[t][i][i + 1][k] + max(0LL, -1LL * (k - mxw))),
                                      dp[t][i][i + 1][k] + max(0LL, -1LL * (k - mxw))) && ans < dp[t][i][i + 1][k] + max(0LL, -1LL * (k - mxw))) {
                    ans = dp[t][i][i + 1][k] + max(0LL, -1LL * (k - mxw));
                    fl = t;
                }
            }
        }
    }
    int ans1 = accumulate(a.begin(), a.end(), 0LL) - ans;
    if (fl) {
        swap(ans, ans1);
    }
    cout << ans << ' ' << ans1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
