#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long

#ifdef LOCAL
constexpr int MAXN = 100, LG = 5;
#else
constexpr int MAXN = 200010, LG = 60;
#endif

void solve() {
    int n, W;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    W = *max_element(all(a)) + 1;
    vector<vector<vector<array<pii, 2>>>> dp(n, vector<vector<array<pii, 2>>>(n, vector<array<pii, 2>>(W, array{ pair{ 0, 0 }, pair{ 0, 0 } })));
    for (int i = 0; i < n; i++) {
        dp[i][i][0][0] = { a[i], 0 };
        dp[i][i][0][1] = { 0, a[i] };
        for (int d = 1; d < W; d++) {
            dp[i][i][d][0] = dp[i][i][d][1] = { a[i], 0 };
        }
    }
    for (int len = 1; len < n; len++) {
        for (int l = 0; l < n - len; l++) {
            int r = l + len;
            for (int d = 0; d < W; d++) {
                // есть преимущество первого хода
                if (a[l] <= d) {
                    dp[l][r][d][0] = { dp[l + 1][r][d - a[l]][0].F + a[l], dp[l + 1][r][d - a[l]][0].S };
                } else {
                    dp[l][r][d][0] = { dp[l + 1][r][a[l] - d][1].S + a[l], dp[l + 1][r][a[l] - d][1].F };
                }
                if (a[r] <= d) {
                    dp[l][r][d][0] = max(dp[l][r][d][0], { dp[l][r - 1][d - a[r]][0].F + a[r], dp[l][r - 1][d - a[r]][0].S });
                } else {
                    dp[l][r][d][0] = max(dp[l][r][d][0], { dp[l][r - 1][a[r] - d][1].S + a[r], dp[l][r - 1][a[r] - d][1].F });
                }

                if (d == 0) {
                    dp[l][r][d][1] = { dp[l][r][d][0].F, dp[l][r][d][0].S };
                    continue;
                }
                if (a[l] < d) {
                    dp[l][r][d][1] = { dp[l + 1][r][d - a[l]][0].F + a[l], dp[l + 1][r][d - a[l]][0].S };
                } else {
                    dp[l][r][d][1] = { dp[l + 1][r][a[l] - d][0].S + a[l], dp[l + 1][r][a[l] - d][0].F };
                }
                if (a[r] < d) {
                    dp[l][r][d][1] = max(dp[l][r][d][1], { dp[l][r - 1][d - a[r]][0].F + a[r], dp[l][r - 1][d - a[r]][0].S });
                } else {
                    dp[l][r][d][1] = max(dp[l][r][d][1], { dp[l][r - 1][a[r] - d][0].S + a[r], dp[l][r - 1][a[r] - d][0].F });
                }
            }
        }
    }
    cout << dp[0][n - 1][0][0].F << ' ' << dp[0][n - 1][0][0].S;
}

int main() {
#ifdef LOCAL
    freopen("D:\\lion1\\input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
    return 0;
}
