// clang-format off
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")

using namespace std;
using namespace __gnu_pbds;

typedef int ll;
typedef long double ld;
typedef pair<ll, ll> pii;
typedef vector<ll> d1;
typedef vector<d1> d2;
typedef vector<pii> d1p;
typedef vector<d1p> d2p;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

ostream& operator<<(ostream&cout, const pii&a){cout<<a.first<<","<<a.second;return cout;}
pii min(const pii &a, const pii &b){if(a.first<b.first) return a;else return b;}
pii max(const pii &a, const pii &b){if(a.first>b.first) return a;else return b;}
template<typename T> T min(vector<T> &a){return *min_element(a.begin(), a.end());}
template<typename T> T max(vector<T> &a){return *max_element(a.begin(), a.end());}
template<typename T> T sum(vector<T>&a){T m=0;for(T&i:a)m+=i;return m;}
template<typename T> void print(vector<T>&a){for(T&i:a)cout<<i<<" ";cout<<"\n";}
template<typename T> void print(vector<vector<T>>&a){for(vector<T>&i:a)print(i);}

#define stuff ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define fori(x, n) for(ll i = x; i < n; ++i)
#define forj(x, n) for(ll j = x; j < n; ++j)
#define fork(x, n) for(ll k = x; k < n; ++k)
#define foru(p, t) for(ll i = p; i < t.size(); i+=i&-i)
#define ford(r, t) for(ll i = r; i > 0; i-=i&-i)
#define all(a) a.begin(), a.end()
#define sort(a) sort(all(a))
#define reverse(a) reverse(all(a))
#define unique(a) a.erase(unique(all(a)), a.end());
#define wt ll _t; cin>>_t; while(_t--)
#define __lg(x) 63ll - __builtin_clzll(x)
#define pb push_back
#define pob pop_back
#define endl "\n"
#define F first
#define S second
#define B back()

d1 a;
vector<d2p> mem;
ll W = 0;

void dfs(ll l, ll r, ll diff){
    if(mem[l][r][diff] != pii({-1e9, -1e9})) return;
    if(diff <= W){
        dfs(l+1, r, diff+a[l]);
        pii res1 = mem[l+1][r][diff+a[l]];
        res1.F+=a[l];
        dfs(l, r-1, diff+a[r]);
        pii res2 = mem[l][r-1][diff+a[l]];
        res2.F+=a[r];
        if(res1.F > res2.F){
            mem[l][r][diff] = res1;
        }
        else{
            mem[l][r][diff] = res2;
        }
    }
    else{
        dfs(l+1, r, diff-a[l]);
        pii res1 = mem[l+1][r][diff-a[l]];
        res1.S+=a[l];
        dfs(l, r-1, diff-a[r]);
        pii res2 = mem[l][r-1][diff-a[r]];
        res2.S+=a[r];
        if(res1.S > res2.S){
            mem[l][r][diff] = res1;
        }
        else{
            mem[l][r][diff] = res2;
        }
    }
}

signed main(){
    stuff;
    ll n;
    cin >> n;
    a = d1(n+1, 0);
    fori(1, n+1) cin >> a[i];
    W = sum(a);
    mem = vector<d2p>(n+2, d2p(n+2, d1p(2*W+1, {-1e9, -1e9})));
    fori(0, n+1){
        mem[i+1][i].assign(2*W+1, {0, 0});
    }
    dfs(1, n, W);
    cout << mem[1][n][W].F << " " << mem[1][n][W].S;
}