#include <bits/stdc++.h>

using namespace std;

const int N = 2100;

int16_t n, w[N], W;
bool val[N];
unordered_map<int16_t, int16_t> dp[N][N][2];
vector<int16_t> st[N][N][2];

int16_t ans(int16_t l, int16_t r, int16_t ab, int16_t k) {
	if (l > r) return -k;
	return dp[l][r][ab][k];
}

void addtr(int16_t l, int16_t r, int16_t ab, int16_t k) {
	st[l][r][ab].push_back(k);
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> w[i];
		W += w[i];
	}
	st[1][n][0].push_back(0);
	for (int sz = n; sz >= 1; sz--)
	for (int l = 1; l + sz - 1 <= n; l++)
	for (int ab = 0; ab < 2; ab++) {
		int r = l + sz - 1;
		for (int k : st[l][r][ab]) {
			if (val[k]) continue;
			val[k] = true;
			if (w[l] < k) addtr(l + 1, r, ab, k - w[l]);
			if (w[l] > k) addtr(l + 1, r, ab ^ 1, w[l] - k);
			if (w[l] == k) addtr(l + 1, r, 0, 0);
			if (w[r] < k) addtr(l, r - 1, ab, k - w[r]);
			if (w[r] > k) addtr(l, r - 1, ab ^ 1, w[r] - k);
			if (w[r] == k) addtr(l, r - 1, 0, 0);
		}
		for (int k : st[l][r][ab])
			val[k] = false;
	}
	for (int sz = 1; sz <= n; sz++)
	for (int l = 1; l + sz - 1 <= n; l++)
	for (int ab = 0; ab < 2; ab++) {
		int r = l + sz - 1;
		for (int k : st[l][r][ab]) {
			if (val[k]) continue;
			val[k] = true;
			int16_t cur = -20000;
			if (w[l] < k) cur = max(cur, ans(l + 1, r, ab, k - w[l]));
			if (w[l] > k) cur = max(cur, (int16_t) -ans(l + 1, r, ab ^ 1, w[l] - k));
			if (w[l] == k) cur = max(cur, (int16_t) (ab == 0 ? ans(l + 1, r, 0, 0) : -ans(l + 1, r, 0, 0)));
			if (w[r] < k) cur = max(cur, ans(l, r - 1, ab, k - w[r]));
			if (w[r] > k) cur = max(cur, (int16_t) -ans(l, r - 1, ab ^ 1, w[r] - k));
			if (w[r] == k) cur = max(cur, (int16_t) (ab == 0 ? ans(l, r - 1, 0, 0) : -ans(l, r - 1, 0, 0)));
			dp[l][r][ab][k] = cur;
		}
		for (int k : st[l][r][ab])
			val[k] = false;
	}
	int16_t res = ans(1, n, 0, 0);
	cout << (W + res) / 2 << ' ' << (W - res) / 2;
}
