#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& x : a) cin >> x;
    sort(a.begin(), a.end());
    if (n == 3) {
        if (a[2] > a[0] + a[1]) {
            cout << a[2] << ' ' << a[0] + a[1] << '\n';
        } else {
            cout << a[0] + a[1] << ' ' << a[2] << '\n';
        }
        return;
    }
    map<pair<int, int>, int> cnt;
    for (int k = 0; k < n; ++k) {
        int x = 0, y = 0;
        for (int i = 0; i < k; ++i) {
            if (x <= y) {
                x += a[i];
            } else {
                y += a[i];
            }
        }
        for (int i = n - 1; i >= k; --i) {
            if (x <= y) {
                x += a[i];
            } else {
                y += a[i];
            }
        }
        cnt[{x, y}]++;
//        cout << x << ' ' << y << '\n';
    }
    int x = 0, y = 0, mx = 0;
    for (auto& [p, c] : cnt) {
        if (c > mx || (c == mx && p.first > x)) {
            x = p.first;
            y = p.second;
            mx = c;
        }
    }
    cout << x << ' ' << y << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
