#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

map<vector<ll>, vector<ll>> dp;
map<vector<ll>, ll> was;
vector<ll> a;

vector<ll> f(ll i, ll j, ll r1, ll r2) {
    if (was[{i, j, r1, r2}] != 0) return dp[{i, j, r1, r2}];
    if (i > j) {
        return {r1, r2};
    }
    vector<ll> res3;
    if (r1 <= r2) {
        vector<ll> res1 = f(i + 1, j, r1 + a[i], r2);
        vector<ll> res2 = f(i, j - 1, r1 + a[j], r2);
        if (res1[0] > res2[0]) {
            res3 = res1;
        } else {
            res3 = res2;
        }
    } else {
        vector<ll> res1 = f(i + 1, j, r1, r2 + a[i]);
        vector<ll> res2 = f(i, j - 1, r1, r2 + a[j]);
        if (res1[1] > res2[1]) {
            res3 = res1;
        } else {
            res3 = res2;
        }
    }
    dp[{i, j, r1, r2}] = res3;
    was[{i, j, r1, r2}] = 1;
    return res3;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    a.resize(n);
    ll sum = 0;
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<ll> v = f(0, n - 1, 0, 0);
    cout << v[0] << " " << v[1];
    return 0;
}
