#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

map<vector<ll>,  ll> dp;
map<vector<ll>, ll> was;
vector<ll> a;
vector<ll> pref;

ll sum(ll i, ll j) {
    if (j < 0 || j >= a.size()) return 0;
    ll res = pref[j];
    if (i != 0) res -= pref[i - 1];
    return res;
}

vector<ll> ans2(ll sum, ll r1) {
    ll s = sum;
    ll x = (s - abs(r1)) / 2;
    ll k1 = x + (r1 >= 0) * abs(r1);
    ll k2 = x + (r1 <= 0) * abs(r1);
    return {k1, k2};
}

ll f(ll i, ll j) {
    if (was[{i, j}] != 0) return dp[{i, j}];
    if (i > j) return dp[{i, j}];
    ll res3;
    if (dp[{i, j}] <= 0) {
        ll dp1 = dp[{i + 1, j}], dp2 = dp[{i, j - 1}];
        if (was[{i + 1, j}] == 0) dp1 = 1e18;
        if (was[{i, j - 1}] == 0) dp2 = 1e18;
        dp[{i + 1, j}] = dp[{i, j}] + a[i];
        dp[{i, j - 1}] = dp[{i, j}] + a[j];
        ll res1 = f(i + 1, j);
        ll res2 = f(i, j - 1);
        dp[{i + 1, j}] = min(dp[{i + 1, j}], dp1);
        dp[{i, j - 1}] = min(dp[{i, j - 1}], dp2);
        vector<ll> ans1 = ans2(sum(0, i) + sum(j + 1, a.size() - 1), res1 + a[i]);
        vector<ll> ans11 = ans2(sum(0, i - 1) + sum(j, a.size() - 1), res2 + a[j]);
        if (ans1[0] > ans11[0]) {
            res3 = res1;
        } else {
            res3 = res2;
        }
    } else {
        ll dp1 = dp[{i + 1, j}], dp2 = dp[{i, j - 1}];
        if (was[{i + 1, j}] == 0) dp1 = -1e18;
        if (was[{i, j - 1}] == 0) dp2 = -1e18;
        dp[{i + 1, j}] = dp[{i, j}] - a[i];
        dp[{i, j - 1}] = dp[{i, j}] - a[j];
        ll res1 = f(i + 1, j);
        ll res2 = f(i, j - 1);
        dp[{i + 1, j}] = max(dp[{i + 1, j}], dp1);
        dp[{i, j - 1}] = max(dp[{i, j - 1}], dp2);
        vector<ll> ans1 = ans2(sum(0, i) + sum(j + 1, a.size() - 1), res1 - a[i]);
        vector<ll> ans11 = ans2(sum(0, i - 1) + sum(j, a.size() - 1), res2 - a[j]);
        if (ans1[1] > ans11[1]) {
            res3 = res1;
        } else {
            res3 = res2;
        }
    }
    dp[{i, j}] = res3;
    was[{i, j}] = 1;
    return res3;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    a.resize(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }
    pref.resize(n);
    for(int i = 0; i < n; i++) {
        pref[i] += a[i];
        if (i != 0) pref[i] += pref[i - 1];
    }
    ll r1 = f(0, n - 1);
    vector<ll> v2 = ans2(sum(0, n - 1), r1);
    cout << v2[0] << " " << v2[1];
    return 0;
}
