#include <iostream>
#include <vector>
#include <algorithm>
#define fastio
#define LOCAL

using namespace std;

#ifdef fastio
#define endl '\n'
#endif

// #define int long long
typedef pair<int, int> pii;
typedef long long ll;
#define all(x) x.begin(), x.end()

// (pref, suf, actor) -> out, their
vector<vector<vector<pii>>> dp;
vector<int> arr;

signed main() {
    #ifdef fastio
    cin.tie(0);
    ios::sync_with_stdio(0);
    #endif
    // #ifdef LOCAL
    // freopen("/mnt/commons/code/in.txt", "r", stdin);
    // #endif

    int n;
    cin >> n;
    dp.resize(n + 1, vector(n + 1, vector<pii>(2, {-1, -1})));
    arr.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }

    reverse(all(arr));

    int a = 0, b = 0;

    int i = 0;
    int alice_left = 0;
    int bob_left = 0;
    while (i != n) {
        int d = min(alice_left, bob_left);
        alice_left -= d;
        bob_left -= d;
        if (alice_left == 0) {
            a += arr[i];
            alice_left += arr[i];
        } else {
            b += arr[i];
            bob_left += arr[i];
        }
        ++i;
    }
    cout << a << " " << b << endl;

    return 0;
}