#include <bits/stdc++.h>
using namespace std;
using ll = long long;

void solve() {
  int n;
  cin >> n;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  vector<int> pref(n + 1);
  for (int i = 0; i < n; ++i) {
    pref[i + 1] = pref[i] + a[i];
  }

  auto Get = [&](int l, int r) {
    return pref[r + 1] - pref[l];
  };

  if (n == 1) {
    cout << a[0] << ' ' << 1;
    return;
  }
  if (a[n - 1] <= 2) {
    reverse(a.begin(), a.end());
    int la = 0, lb = 0;
    int aa = 0, ab = 0;
    for (int i = 0; i < n; ++i) {
      if (la <= lb) {
        aa += a[i];
        lb -= la;
        la = a[i];
      } else {
        ab += a[i];
        la -= lb;
        lb = a[i];
      }
    }
    cout << aa << ' ' << ab;
    return;
  }
  int dp[n][n][2][a[n - 1] + 1];
  memset(dp, -1, sizeof(dp));
  for (int i = 0; i < n; ++i) {
    for (int p = 0; p < 2; ++p) {
      for (int c = 0; c <= a[n - 1]; ++c) {
        if (p == 0) {
          dp[i][i][p][c] = a[i];
        } else {
          if (c == 0) {
            dp[i][i][p][c] = 0;
          } else {
            dp[i][i][p][c] = a[i];
          }
        }
      }
    }
  }
  for (int len = 2; len <= n; ++len) {
    for (int l = 0; l + len <= n; ++l) {
      int r = l + len - 1;
      for (int p = 0; p < 2; ++p) {
        for (int c = 0; c <= a[n - 1]; ++c) {
          if (p == 0) {
            if (a[l] <= c) {
              dp[l][r][p][c] = max(dp[l][r][p][c], a[l] + dp[l + 1][r][p][c - a[l]]);
            } else {
              dp[l][r][p][c] = max(dp[l][r][p][c], a[l] + Get(l + 1, r) - dp[l + 1][r][p ^ 1][a[l] - c]);
            }
            if (a[r] <= c) {
              dp[l][r][p][c] = max(dp[l][r][p][c], a[r] + dp[l][r - 1][p][c - a[r]]);
            } else {
              dp[l][r][p][c] = max(dp[l][r][p][c], a[r] + Get(l, r - 1) - dp[l][r - 1][p ^ 1][a[r] - c]);
            }
          } else {
            if (a[l] < c) {
              dp[l][r][p][c] = max(dp[l][r][p][c], a[l] + dp[l + 1][r][p][c - a[l]]);
            } else {
              dp[l][r][p][c] = max(dp[l][r][p][c], a[l] + Get(l + 1, r) - dp[l + 1][r][p ^ 1][a[l] - c]);
            }
            if (a[r] < c) {
              dp[l][r][p][c] = max(dp[l][r][p][c], a[r] + dp[l][r - 1][p][c - a[r]]);
            } else {
              dp[l][r][p][c] = max(dp[l][r][p][c], a[r] + Get(l, r - 1) - dp[l][r - 1][p ^ 1][a[r] - c]);
            }
          }
        }
      }
    }
  }
  cout << dp[0][n - 1][0][0] << ' ' << min(dp[1][n - 1][1][a[0]], dp[0][n - 2][1][a[n - 1]]);
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
