#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()

//#include <bits/extc++.h>
//using namespace __gnu_pbds;
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

mt19937_64 rd(chrono::steady_clock::now().time_since_epoch().count());

const int MAXN = 2e3 + 1;

map<int, int> dp[MAXN][MAXN];
vector<int> w;
int n;

int get_best(int l, int r, int delta) {
    if (r < l) return delta;
    if (dp[l][r].count(delta)) return dp[l][r][delta];
    if (delta >= 0)
        dp[l][r][delta] = min(get_best(l + 1, r, delta - w[l]), get_best(l, r - 1, delta - w[r]));
    else
        dp[l][r][delta] = max(get_best(l + 1, r, delta + w[l]), get_best(l, r - 1, delta + w[r]));
    return dp[l][r][delta];
}

void solve() {
    cin >> n;
    w.assign(n, 0);
    for (auto &it: w) cin >> it;
    if (n == 3) {
        cout << max(w[0] + w[1], w[2]) << " " << min(w[0] + w[1], w[2]) << '\n';
    } else if (w.back() <= 2) {
        int ans0 = 0, ans1 = 0;
        reverse(all(w));
        for (int i = 0; i < n; ++i) {
            if (i & 1) ans1 += w[i];
            else ans0 += w[i];
        }
        cout << ans0 << ' ' << ans1 << '\n';
    } else {
        int delta = get_best(0, n - 1, 0);
        int s = 0;
        for (auto it: w) s += it;
        cout << (s - delta) / 2 << " " << (s + delta) / 2 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
//    cin >> T;
    while (T--)
        solve();
}
