#include <bits/stdc++.h>

#define fi first
#define se second  

#define pb push_back
#define sz(x) (int)x.size()

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, a) for(auto& x: a)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

struct node {
    int diff;
    int sum1;
    int sum2;
};

node takeSuff(deque<int> deq, bool pref) {
    if(!pref) {
        int sum = deq.back();
        deq.pop_back();
        int sum1 = sum;
        int sum2 = 0;
        while(!deq.empty() && sum > 0) {
            sum -= deq.back();
            sum2 += deq.back();
            deq.pop_back();
        }

        node ret;
        ret.diff = sum - sum2;
        ret.sum1 = sum1;
        ret.sum2 = sum2;

        return ret;
    } else {
        int sum = deq.back();
        deq.pop_back();
        int sum1 = sum;
        int sum2 = 0;
        while(!deq.empty() && sum > 0) {
            sum -= deq.front();
            sum2 += deq.front();
            deq.pop_front();
        }

        node ret;
        ret.diff = sum - sum2;
        ret.sum1 = sum1;
        ret.sum2 = sum2;

        return ret;
    }
}

node takePref(deque<int> deq, bool pref) {
    if(pref) {
        int sum = deq.front();
        deq.pop_front();
        int sum1 = sum;
        int sum2 = 0;
        while(!deq.empty() && sum > 0) {
            sum -= deq.front();
            sum2 += deq.front();
            deq.pop_front();
        }

        node ret;
        ret.diff = sum - sum2;
        ret.sum1 = sum1;
        ret.sum2 = sum2;

        return ret;
    } else {
        int sum = deq.front();
        deq.pop_front();
        int sum1 = sum;
        int sum2 = 0;
        while(!deq.empty() && sum > 0) {
            sum -= deq.back();
            sum2 += deq.back();
            deq.pop_back();
        }

        node ret;
        ret.diff = sum - sum2;
        ret.sum1 = sum1;
        ret.sum2 = sum2;

        return ret;
    }
}

int main() {
    int n;
    cin >> n;

    vector<int> a(n + 1);
    vector<vector<int>> dp(n + 1, vector<int>(n + 1));

    int sum = 0;
    deque<int> deq;
    fr (i, 1, n) {
        cin >> a[i];
        deq.pb(a[i]);
    }

    int time = 0;
    int sum1 = 0, sum2 = 0;
    fr (i, 0, n - 1) {
        if(sum1 == sum2 || sum1 == time) {
            node pref;
            if(takePref(deq, 0).diff > takePref(deq, 1).diff) {
                pref = takePref(deq, 0);
            } else {
                pref = takePref(deq, 1);
            }

            node suff;
            if(takeSuff(deq, 0).diff > takeSuff(deq, 1).diff) {
                suff = takeSuff(deq, 0);
            } else {
                suff = takeSuff(deq, 1);
            }

            if(pref.diff > suff.diff) {
                node q = pref;
                sum1 += q.sum1;
                deq.pop_front();
            } else {
                node q = suff;
                sum1 += q.sum1;
                deq.pop_back();
            }
        } else {
            node pref;
            if(takePref(deq, 0).diff > takePref(deq, 1).diff) {
                pref = takePref(deq, 0);
            } else {
                pref = takePref(deq, 1);
            }

            node suff;
            if(takeSuff(deq, 0).diff > takeSuff(deq, 1).diff) {
                suff = takeSuff(deq, 0);
            } else {
                suff = takeSuff(deq, 1);
            }

            if(pref.diff > suff.diff) {
                node q = pref;
                sum2 += q.sum1;
                deq.pop_front();
            } else {
                node q = suff;
                sum2 += q.sum1;
                deq.pop_back();
            }
        }

        time = min(sum2, sum1);
    }

    cout << sum1 << " " << sum2 << endl;

    return 0;
}