#include <bits/stdc++.h>

using namespace std;
namespace rng = ranges;
namespace viu = views;

typedef int64_t ll;

#define INF ((int)1e9 + 1329)
#define INF_LL ((int64_t)1e18)

#ifndef ILKRAS
#define endl "\n"
#endif

struct Solution {
    int TEST = -1;

    int rec(int t1, int t2, multiset<int> elems) {
        if (elems.empty())
            return 0;
        int mn = min(t1, t2);
        t1 -= mn;
        t2 -= mn;
        if (t1 == 0) {
            int mx = 0;
            for (int it: {*elems.begin(), *elems.rbegin()}) {
                multiset<int> cp = elems;
                cp.extract(it);
                mx = max(mx, it + rec(it, t2, cp));
            }
            return mx;
        }
        mn = INF;
        for (int it: {*elems.begin(), *elems.rbegin()}) {
            multiset<int> cp = elems;
            cp.extract(it);
            mn = min(mn, rec(t1, it, cp));
        }
        return mn;
    }

    signed solve3() {
        int n = 3;
        multiset<int> ar;
        int sum = 0;
        for (int i = 0; i < n; ++i) {
            int x;
            cin >> x;
            ar.insert(x);
            sum += x;
        }
        int res = rec(0, 0, ar);
        cout << res << " " << sum - res << "\n";
        return 0;
    }

    vector<vector<vector<vector<int>>>> dp;
    // [L
    // R)
    // T
    // TURN
    vector<int> ar;

    int solve(int t1, int t2, int l, int r) {
        int mn = min(t1, t2);
        t1 -= mn;
        t2 -= mn;
        if (t1 == 0) {
            int turn = 0;
            if (dp[l][r][t2][turn] != -1)
                return dp[l][r][t2][turn];
            if (l == r)
                return dp[l][r][t2][turn] = 0;
            return dp[l][r][t2][turn] = max(
                    ar[l] + solve(ar[l], t2, l + 1, r),
                    ar[r - 1] + solve(ar[r - 1], t2, l, r - 1)
            );
        } else {
            int turn = 1;
            if (dp[l][r][t1][turn] != -1)
                return dp[l][r][t1][turn];
            if (l == r)
                return dp[l][r][t1][turn] = 0;
            return dp[l][r][t1][turn] = min(
                    solve(t1, ar[l], l + 1, r),
                    solve(t1, ar[r - 1], l, r - 1)
            );
        }
    }

    signed operator()() {
        int n;
        cin >> n;
        if (n == 3)
            return solve3();
        ar.resize(n);
        int sum = 0;
        for (auto &it: ar) {
            cin >> it;
            sum += it;
        }
        int sz = ar.back() + 1;
        dp.resize(n + 1,
                  vector<vector<vector<int>>>(
                          n + 1,
                          vector<vector<int>>(
                                  sz + 1,
                                  vector<int>(2, -1)
                          )
                  ));
        int res = solve(0, 0, 0, n);
        cout << res << " " << sum - res << "\n";
        return 0;
    }

    Solution(int TEST = -1) : TEST(TEST) {}
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    for (int TEST: viu::iota(1, t + 1)) {
        int res = Solution(TEST)();
        if (res != 0)
            return res;
    }
    return 0;
}