#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock::now().time_since_epoch().count()
//#define int long long

using namespace std;
typedef long double ld;

constexpr uint8_t STEP = 17;
constexpr uint32_t MAXN = 2E2, BL_SZ = 316, CNT_BL = (MAXN + BL_SZ - 1) / BL_SZ;
constexpr uint32_t MAXC = 5E2;
constexpr int32_t INF = 1E9;
constexpr int64_t INFl = 1E18;

constexpr uint32_t RND_SEED = 7200;
mt19937_64 rnd(RND_SEED);

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

short dp[MAXN + 1][MAXN + 1][MAXC + 1][2];

void solve()
{
	int n;
	cin >> n;
	vector <short> mas(n), pref(n + 1);
	for (int i = 0; i < n; i++)
	{
		cin >> mas[i];
		pref[i + 1] = pref[i] + mas[i];
	}

	for (int sum_len = n - 1; sum_len >= 0; sum_len--)
	{
		for (int len_pref = 0; len_pref <= sum_len; len_pref++)
		{
			int len_suf = sum_len - len_pref;

			for (int ost_tm = 0; ost_tm <= MAXC; ost_tm++)
			{
				if (mas[len_pref] <= ost_tm)
				{
					rmax(dp[len_pref][len_suf][ost_tm][0], mas[len_pref] + dp[len_pref + 1][len_suf][ost_tm - mas[len_pref]][0]);
				}
				else
				{
					rmax(dp[len_pref][len_suf][ost_tm][0], mas[len_pref] + ((pref[n - len_suf] - pref[len_pref + 1]) - dp[len_pref + 1][len_suf][mas[len_pref] - ost_tm][1]));
				}
				if (mas[n - len_suf - 1] <= ost_tm)
				{
					rmax(dp[len_pref][len_suf][ost_tm][0], mas[n - len_suf - 1] + dp[len_pref][len_suf + 1][ost_tm - mas[n - len_suf - 1]][0]);
				}
				else
				{
					rmax(dp[len_pref][len_suf][ost_tm][0], mas[n - len_suf - 1] + ((pref[n - len_suf - 1] - pref[len_pref]) - dp[len_pref][len_suf + 1][mas[n - len_suf - 1] - ost_tm][1]));
				}

				if (mas[len_pref] < ost_tm)
				{
					rmax(dp[len_pref][len_suf][ost_tm][1], mas[len_pref] + dp[len_pref + 1][len_suf][ost_tm - mas[len_pref]][1]);
				}
				else
				{
					rmax(dp[len_pref][len_suf][ost_tm][1], mas[len_pref] + ((pref[n - len_suf] - pref[len_pref + 1]) - dp[len_pref + 1][len_suf][mas[len_pref] - ost_tm][0]));
				}
				if (mas[n - len_suf - 1] < ost_tm)
				{
					rmax(dp[len_pref][len_suf][ost_tm][1], mas[n - len_suf - 1] + dp[len_pref][len_suf + 1][ost_tm - mas[n - len_suf - 1]][1]);
				}
				else
				{
					rmax(dp[len_pref][len_suf][ost_tm][1], mas[n - len_suf - 1] + ((pref[n - len_suf - 1] - pref[len_pref]) - dp[len_pref][len_suf + 1][mas[n - len_suf - 1] - ost_tm][0]));
				}
			}
		}
	}

	short win_al = dp[0][0][0][0];
	cout << win_al << ' ' << pref[n] - win_al;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
		cout << endl;
	}
}