#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pp = pair<ll, ll>;
using ld = long double;

template<typename T, typename F>
istream &operator>>(istream &s, pair<T, F> &a) {
    s >> a.first >> a.second;
    return s;
}

template<typename T, typename F>
ostream &operator<<(ostream &s, pair<T, F> &a) {
    s << a.first << ' ' << a.second << '\n';
    return s;
}

template<typename T>
istream &operator>>(istream &s, vector<T> &a) {
    for (T &el: a) {
        s >> el;
    }
    return s;
}

template<typename T>
ostream &operator<<(ostream &s, vector<T> &a) {
    for (T el: a) {
        s << el << ' ';
    }
    s << '\n';
    return s;
}

const int maxn = 211, maxval = 511, inf = 1e9;
int dp[maxn][maxn][maxval * 2];
int pref[maxn], suff[maxn], w[maxn];

int sum(int l, int r) {
    return pref[r] - (l > 0 ? pref[l - 1] : 0);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    pref[0] = w[0];
    for (int i = 1; i < n; i++) {
        pref[i] = pref[i - 1] + w[i];
    }
    suff[n - 1] = w[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        suff[i] = suff[i + 1] + w[i];
    }
    for (int lg = 1; lg <= n; lg++) {
        for (int l = 0; l + lg - 1 < n; l++) {
            int r = l + lg - 1;
            for (int delta = -500; delta <= 500; delta++) {
                if (delta <= 0) {
                    //first selects now
                    //use arr[l]
                    if (delta + w[l] > 0) {
                        //second selects then
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[l] + sum(l + 1, r) - dp[l + 1][r][(delta + w[l]) + maxval]);
                    } else {
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[l] + dp[l + 1][r][(delta + w[l]) + maxval]);
                    }
                    //use arr[r]
                    if (delta + w[r] > 0) {
                        //second selects then
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[r] + sum(l, r - 1) - dp[l][r - 1][(delta + w[r]) + maxval]);
                    } else {
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[r] + dp[l][r - 1][(delta + w[r]) + maxval]);
                    }
                } else {
                    //second selects now
                    //use arr[l]

                    if (delta - w[l] > 0) {
                        //second selects then
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[l] + dp[l + 1][r][(delta - w[l]) + maxval]);
                    } else {
                        //first selects then
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval], w[l] + sum(l + 1, r) - dp[l + 1][r][(delta - w[l]) + maxval]);
                    }

                    //use arr[r]
                    if (delta - w[r] > 0) {
                        //second selects then
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval],
                                                       w[r] + dp[l][r - 1][(delta + w[r]) + maxval]);
                    } else {
                        //first selects then
                        dp[l][r][delta + maxval] = max(dp[l][r][delta + maxval], w[r] + sum(l, r - 1) - dp[l][r - 1][(delta + w[r]) + maxval]);
                    }
                }

            }
        }
    }
    cout << dp[0][n - 1][0 + maxval] << ' ' << pref[n - 1] - dp[0][n - 1][0 + maxval];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
