#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

const int MAXN = 1 << 18, LOGN = 18, LOGV = 30;

const ll INF = 1ll << 30;


void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (auto &i: a) {
        cin >> i;
        i *= 2;
    }

    int C = a.back() + 1;
    vector<vector<vector<int>>> dp(n, vector<vector<int>>(n, vector<int>(C, -INF)));
    for (int l = 0; l < n; ++l)
        for (int sl = 0; sl < C; ++sl)
            dp[l][l][sl] = a[l] - sl;

    for (int len = 2; len <= n; ++len) {
        for (int l = 0; l <= n - len; ++l) {
            int r = l + len - 1;

            int al = a[l], ar = a[r];

            for (int sl = 0; sl < C; ++sl) {
                if (sl >= ar)
                    dp[l][r][sl] = max(dp[l][r][sl], dp[l][r - 1][sl - ar]);
                else
                    dp[l][r][sl] = max(dp[l][r][sl], -dp[l][r - 1][ar - sl]);

                if (sl >= al)
                    dp[l][r][sl] = max(dp[l][r][sl], dp[l + 1][r][sl - al]);
                else
                    dp[l][r][sl] = max(dp[l][r][sl], -dp[l + 1][r][al - sl]);

            }
        }
    }

    ll dif = dp[0][n - 1][1];
    dif = (dif + 1) / 2;
    ll sum = 0;
    for (auto i: a)
        sum += i;
    sum /= 2;
    ll ta = (dif + sum) / 2, tb = sum - ta;
    //cout << dif << endl;
    cout << ta << ' ' << tb << endl;


}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
