#ifdef LOCAL
#define GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int W = accumulate(a.begin(), a.end(), 0) + 1;
    vector<vector<vector<vector<int>>>> dp(2, vector<vector<vector<int>>> (n, vector<vector<int>> (n, vector<int> (W, -1e9))));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < W; j++) {
            dp[0][i][i][j] = j + a[i];
            dp[1][i][i][j] = j;
        }
    }
    vector<int> pref(n), suf(n);
    for (int i = 0; i < n; i++) pref[i] = a[i] + (i ? pref[i-1] : 0);
    for (int i = n-1; i >= 0; i--) suf[i] = a[i] + (i + 1 < n ? suf[i+1] : 0);
    for (int len = 2; len <= n; len++) {
        for (int i = 0; i + len <= n; i++) {
            int l = i;
            int r = i + len - 1;
            for (int j = 0; j < W; j++) {
                int alice = j;
                int bob = (l ? pref[l-1] : 0) + (r + 1 < n ? suf[r + 1] : 0) - j;
                dp[1][l][r][j] = min(dp[bob + a[l] < alice][l+1][r][j], dp[bob + a[r] < alice][l][r-1][j]);
                dp[0][l][r][j] = max((j + a[l] < W ? dp[alice + a[l] > bob][l+1][r][j + a[l]] : 0), (j + a[r] < W ? dp[alice + a[r] > bob][l][r-1][j + a[r]] : 0));
//                cout << "ALICE\n" << l << " " << r << " " << j << " " << dp[0][l][r][j] << "\n";
//                cout << "BOB\n" << l << " " << r << " " << j << " " << dp[1][l][r][j] << "\n";
            }
//            cout << "\n";
        }
    }
    cout << dp[0][0][n-1][0] << " " << pref.back() - dp[0][0][n-1][0] << "\n";
}
