#include <bits/stdc++.h>

#define x first
#define y second

using namespace std;

using ll = long long;

mt19937_64 mt(100);

void solve();

int main() {
#ifndef LOCAL
	cin.tie(nullptr)->sync_with_stdio(false);
#endif
	cout << fixed << setprecision(30);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

map<pair<pair<int, int>, pair<int, int>>, pair<int, int>> mem;

const int N = 2020;
int w[N];

pair<int, int> rec(int l, int r, int time, int f) {
	if (l > r) {
		return {0, 0};
	}
	pair<pair<int, int>, pair<int, int>> nw;
	nw.x.x = l;
	nw.x.y = r;
	nw.y.x = time;
	nw.y.y = f;
	if (mem.find(nw) != mem.end()) {
		return mem[nw];
	}
	pair<int, int> res = {0, 0};
	if (w[l] == w[r]) {
		int pr = min((time / w[l]) * w[l], w[l] * (r - l + 1));
		if (f) {
			res.x += pr;
			time -= pr;
			r -= pr / w[l];
		} else {
			res.y += pr;
			time -= pr;
			r -= pr / w[l];
		}
		if (time) {
			if (f) {
				res.x += ((r - l + 2) / 2) * w[l];
				res.y += ((r - l + 1) / 2) * w[l];
			} else {
				res.y += ((r - l + 2) / 2) * w[l];
				res.x += ((r - l + 1) / 2) * w[l];
			}
		} else {
			res.x += ((r - l + 2) / 2) * w[l];
			res.y += ((r - l + 1) / 2) * w[l];
		}
		mem[nw] = res;
		return res;
	}
	if (f) {
		pair<int, int> ll, rr;
		if (w[l] > time) {
			ll = rec(l + 1, r, w[l] - time, 0);
			ll.x += w[l];
		} else {
			ll = rec(l + 1, r, time - w[l], 1);
			ll.x += w[l];
		}
		if (w[r] > time) {
			rr = rec(l, r - 1, w[r] - time, 0);
			rr.x += w[r];
		} else {
			ll = rec(l, r - 1, time - w[r], 1);
			ll.x += w[r];
		}
		mem[nw] = max(ll, rr);
		return max(ll, rr);
	} else {
		pair<int, int> ll, rr;
		if (w[l] >= time) {
			ll = rec(l + 1, r, w[l] - time, 1);
			ll.y += w[l];
		} else {
			ll = rec(l + 1, r, time - w[l], 0);
			ll.y += w[l];
		}
		if (w[r] >= time) {
			rr = rec(l, r - 1, w[r] - time, 1);
			rr.y += w[r];
		} else {
			ll = rec(l, r - 1, time - w[r], 0);
			ll.y += w[r];
		}
		if (ll.y > rr.y) {
			mem[nw] = ll;
			return ll;
		}
		mem[nw] = ll;
		return rr;
	}
}

void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> w[i];
	}
	auto ans = rec(0, n - 1, 0, 1);
	cout << ans.x << ' ' << ans.y << '\n';
}