#ifdef LOCAl
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

#define x first
#define y second

using namespace std;

using ll = long long;

mt19937_64 mt(100);

void solve();

int main() {
#ifndef LOCAL
	cin.tie(nullptr)->sync_with_stdio(false);
#endif
	cout << fixed << setprecision(30);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}

const int N = 2020;
int w[N], pref[N];
unordered_map<int, pair<int, int>> mem[N][N][2];

int sum(int l, int r) {
	return pref[r + 1] - pref[l];
}

pair<int, int> rec(int l, int r, int time, int f) {
	// cout << l << ' ' << r << ' ' << time << ' ' << f << '\n';
	if (l > r) {
		return {0, 0};
	}
	pair<int, int> res = {0, 0};
	if (w[l] == w[r]) {
		int pr = min((time / w[l]) * w[l], w[l] * (r - l + 1)), rr = r;;
		if (f) {
			res.x += pr;
			time -= pr;
			r -= pr / w[l];
		} else {
			res.y += pr;
			time -= pr;
			r -= pr / w[l];
		}
		if (time) {
			if (f) {
				res.x += ((r - l + 2) / 2) * w[l];
				res.y += ((r - l + 1) / 2) * w[l];
			} else {
				res.y += ((r - l + 2) / 2) * w[l];
				res.x += ((r - l + 1) / 2) * w[l];
			}
		} else {
			res.x += ((r - l + 2) / 2) * w[l];
			res.y += ((r - l + 1) / 2) * w[l];
		}
		return res;
	}
	if (sum(l, r - 1) <= time) {
		if (f) {
			return {sum(l, r), 0};
		} else {
			return {0, sum(l, r)};
		}
	}
	int nw = time;
	if (mem[l][r][f].find(time) != mem[l][r][f].end()) {
		return mem[l][r][f][nw];
	}
	// cout << "!\n";
	if (f) {
		pair<int, int> ll, rr;
		if (w[l] > time) {
			ll = rec(l + 1, r, w[l] - time, 0);
			ll.x += w[l];
		} else {
			ll = rec(l + 1, r, time - w[l], 1);
			ll.x += w[l];
		}
		if (w[r] > time) {
			rr = rec(l, r - 1, w[r] - time, 0);
			rr.x += w[r];
		} else {
			rr = rec(l, r - 1, time - w[r], 1);
			rr.x += w[r];
		}
		mem[l][r][f][nw] = max(ll, rr);
		return max(ll, rr);
	} else {
		pair<int, int> ll, rr;
		if (w[l] >= time) {
			ll = rec(l + 1, r, w[l] - time, 1);
			ll.y += w[l];
		} else {
			ll = rec(l + 1, r, time - w[l], 0);
			ll.y += w[l];
		}
		if (w[r] >= time) {
			rr = rec(l, r - 1, w[r] - time, 1);
			rr.y += w[r];
		} else {
			rr = rec(l, r - 1, time - w[r], 0);
			rr.y += w[r];
		}
		if (ll.y > rr.y) {
			mem[l][r][f][nw] = ll;
			return ll;
		}
		mem[l][r][f][nw] = rr;
		return rr;
	}
}

void solve() {
	int n;
	cin >> n;
	pref[0] = 0;
	for (int i = 0; i < n; i++) {
		cin >> w[i];
		pref[i + 1] = pref[i] + w[i];
	}
	auto ans = rec(0, n - 1, 0, 1);
	// cout << "!!\n";
	cout << ans.x << ' ' << ans.y << '\n';
}