#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define all(a) a.begin(), a.end()
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/hash_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T>
//using ordered_set = tree<T, null_type, less<T>>;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

vector<int> w, wp;
vector<vector<vector<pair<int, int>>>> dp;

inline int get_dp_val(int i, int j, int mode, int val) {
    int player = mode;
    if (val == 0) player = 0;
    else if (val < 0) player = 1 - mode;
    val = abs(val);
    int ans = (player == 0) ? dp[i][j][val].first: dp[i][j][val].second;
    if (mode == player) return ans;
    return wp[j] - wp[i] - ans;
}

inline int calc_dp(int i, int j, int mode, int val) {
    return max(
        w[i] + get_dp_val(i + 1, j, mode, val - w[i]),
        w[j - 1] + get_dp_val(i, j - 1, mode, val - w[j - 1])
    );
}

void solve() {
    int n; cin >> n;
    w.resize(n); cin >> w;
    wp.assign(n + 1, 0);
    for (int i = 1; i <= n; ++i) wp[i] = wp[i - 1] + w[i - 1];
    int wmax = w.back() + 10;
    dp.assign(n + 1, vector<vector<pair<int, int>>>(n + 1, vector<pair<int, int>>(wmax, {0, 0})));
    for (int i = n - 1; i >= 0; --i) {
        for (int j = i + 1; j <= n; ++j) {
            for (int d = 0; d < wmax; ++d) {
                dp[i][j][d].first = calc_dp(i, j, 0, d);
                dp[i][j][d].second = calc_dp(i, j, 1, d);
            }
        }
    }
    int r = dp[0][n][0].first;
    cout << r << ' ' << wp[n] - r << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int _t = 1;
#ifdef LOCAL
    freopen("io/d.in", "r", stdin);
    freopen("io/main.out", "w", stdout);
    cin >> _t;
#endif
    while (_t--) solve();
}