#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")
//#pragma GCC optimize("unroll-loops")

using namespace std;

using ll = long long;
const char endc = '\n';

using namespace std;

int n;
vector<short> pieces, pref, suf;
unordered_map<ll, short> mem;

short fillDp(short left, short right, short aliceTime) {
    ll idd = ll(left) | (ll(right) << 16) | (ll(aliceTime) << 32);
    if (mem.count(idd)) return mem[idd];
    short summary = pref[left] + suf[right];
    short bobTime = summary - aliceTime;
    if (left + right == n) return aliceTime;
    if (aliceTime <= bobTime) {
        auto resA = fillDp(left+1, right, aliceTime + pieces[left]);
        auto resB = fillDp(left, right+1, aliceTime + pieces[n-right-1]);
        mem[idd] = max(resA, resB);
        return max(resA, resB);
    } else {
        auto resA = fillDp(left+1, right, aliceTime);
        auto resB = fillDp(left, right+1, aliceTime);
        mem[idd] = min(resA, resB);
        return min(resA, resB);
    }
}

inline ll get(short a, short b, short c) {
    return ll(a) | (ll(b) << 16) | (ll(c) << 32);
}

inline void work() {
    cin >> n;
    pieces.resize(n);
    for (auto& e : pieces) cin >> e;
    pref.resize(n+1, 0);
    suf.resize(n+1, 0);
    for (int i = 0; i < n; ++i) {
        int revInd = n-i-1;
        pref[i+1] = pref[i] + pieces[i];
        suf[i+1] = suf[i] + pieces[revInd];
    }
    stack<tuple<short, short, short>> vova;
    vova.push({0, 0, 0});
    while (vova.size() > 0) {
        auto [left, right, aliceTime] = vova.top();
        ll idd = get(left, right, aliceTime);
        if (mem.count(idd)) {
            vova.pop();
        } else if (left + right == n) {
            mem[idd] = aliceTime;
            vova.pop();
        } else {
            short summary = pref[left] + suf[right];
            short bobTime = summary - aliceTime;
            if (aliceTime <= bobTime) {
                bool allCount = 1;
                if (!mem.count(get(left + 1, right, aliceTime + pieces[left]))) {
                    allCount = 0;
                    vova.push({left + 1, right, aliceTime + pieces[left]});
                }
                if (!mem.count(get(left, right + 1, aliceTime + pieces[n - right - 1]))) {
                    allCount = 0;
                    vova.push({left, right + 1, aliceTime + pieces[n - right - 1]});
                }
                if (allCount) {
                    auto resA = mem[get(left + 1, right, aliceTime + pieces[left])];
                    auto resB = mem[get(left, right + 1, aliceTime + pieces[n - right - 1])];
                    mem[idd] = max(resA, resB);
                    vova.pop();
                }
            } else {
                bool allCount = 1;
                if (!mem.count(get(left + 1, right, aliceTime))) {
                    allCount = 0;
                    vova.push({left + 1, right, aliceTime});
                }
                if (!mem.count(get(left, right + 1, aliceTime))) {
                    allCount = 0;
                    vova.push({left, right + 1, aliceTime});
                }
                if (allCount) {
                    auto resA = fillDp(left + 1, right, aliceTime);
                    auto resB = fillDp(left, right + 1, aliceTime);
                    mem[idd] = min(resA, resB);
                    vova.pop();
                }
            }
        }
    }
    auto ans = mem[0];
    cout << ans << ' ' << pref.back() - ans << endc;
}

signed main() {
    ios_base::sync_with_stdio(false);
    srand(int(time(nullptr)));
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    while (t-- > 0) work();
}