//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("avx2")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct Point{
    ld x, y;

    Point() = default;

    Point(ld x, ld y): x(x), y(y){}

    ld sqr_len(){
        return x * x + y * y;
    }

    ld len(){
        return sqrtl(sqr_len());
    }
};

ld operator*(Point a, Point b){
    return a.x * b.x + a.y * b.y;
}

ld operator%(Point a, Point b){
    return a.x * b.y - a.y * b.x;
}

Point operator+(Point a, Point b){
    return Point(a.x + b.x, a.y + b.y);
}

Point operator-(Point a, Point b){
    return Point(a.x - b.x, a.y - b.y);
}

istream& operator>>(istream& in, Point& a){
    in >> a.x >> a.y;
    return in;
}

struct segtree{
    vector<ll> tree;
    int size;

    void push(int v, int vl, int vr){

    }


    void init(int n){
        size = 1;
        while(size < n)
            size++;
        tree.assign(size * 2 - 1, 0);
    }


};

struct dsu{
    vector<int> par, size;

    void init(int n){
        for(int i = 0; i < n; i++){
            par.push_back(i);
            size.push_back(1);
        }
    }

    bool get(int v) {
        if (v == par[v])
            return v;
        return par[v] = get(par[v]);
    }

    bool union_sets(int v, int u){
        v = get(v), u = get(u);
        if(v == u)
            return false;
        if(size[v] < size[u])
            swap(u,v);
        size[v] += size[u];
        par[u] = v;
        size[u] = 0;
    }
};

bool kuhn(int v){
    return false;
}

struct fenwick{
    vector<ll> tree, ar;
    int size;

    void init(vector<ll>& a){
        ar = a;
        size = a.size() + 1;
        tree.assign(a.size() + 1, 0);
    }

    void change(int i, ll x){
        for(int j = i; j < size; j += j & -j){
            tree[j] += x;
        }
    }

    void set(int i, ll x){
        change(i, ar[i - 1] - x);
        ar[i - 1] = x;
    }

    ll get(int i){
        ll res = 0;
        for(int j = i; j > 0; j -= j & -j)
            res += tree[j];
        return res;
    }

    ll get(int l, int r){
        return get(r) - get(l - 1);
    }
};

int n;
void solve1(){
    int w1, w2, w3;
    cin >> w1 >> w2 >> w3;
    cout<<w1 + w2 << ' ' << w3;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    cin >> n;
    if(n == 3){
        solve1();
        return 0;
    }
    return 0;
}
