#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> w(n);
    int s = 0;
    for (int i = 0; i < n; i++) {
         cin >> w[i];
         s += w[i];
    }
    if (n == 3) {
        int A = w[2];
        if (w[2] == w[1]) {
            A = max(A, w[0] + w[2]);
        }
        A = max(A, w[0] + w[1]);
        cout << A << ' ' << s - A << '\n';
        return 0;
    } else if (w[n - 1] <= 2) {
        int x = (int)count(w.begin(), w.end(), 2);
        int y = n - x;
        vector<vector<int>> dp(x + 1, vector<int>(y + 1));
        for (int j = 1; j <= y; j++) {
            dp[0][j] = 2 * ((j + 1) / 2);
        }
        for (int i = 1; i <= x; i++) {
            dp[i][0] = (i + 1) / 2;
        }
        for (int i = 1; i <= x; i++) {
            for (int j = 1; j <= y; j++) {
                if (j >= 2) {
                    dp[i][j] = max(dp[i][j], dp[i][j - 2] + 2);
                }
                dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] + 2);
                if (i >= 2) {
                    dp[i][j] = max(dp[i][j], dp[i - 2][j] + 1);
                }
            }
        }
        cout << dp[x][y] << '\n';
    }
    return 0;
}
