#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 2000;
map <int, int> dp[MAXN][MAXN];
vector <int> w(MAXN);
vector <int> pref(MAXN + 1);
int sum = 0;

int resh(int l, int r, int ost) {
    if (l == r) {
        if (ost >= 0) {
            return w[l];
        }
        return 0;
    }
    if (dp[l][r][ost] != 0) {
        return dp[l][r][ost];
    }
    if (ost >= 0) {
        if (pref[r + 1] - pref[l] <= ost) {
            return pref[r + 1] - pref[l];
        }
        dp[l][r][ost] = max(w[l] + resh(l + 1, r, ost - w[l]), w[r] + resh(l, r - 1, ost - w[r]));
    } else {
        if (pref[r + 1] - pref[l] < -ost) {
            return -ost;
        }
        dp[l][r][ost] = min(resh(l + 1, r, ost + w[l]), resh(l, r - 1, ost + w[r]));
    }
    return dp[l][r][ost];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + w[i];
        cin >> w[i];
        pref[i + 1] = pref[i] + w[i];
        sum += w[i];
    }
    int ans = resh(0, n - 1, 0);
    cout << ans << " " << sum - ans << "\n";
}
