#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 2000;
map <int, int> dp[MAXN][MAXN];
vector <int> w(MAXN);
vector <int> pref(MAXN + 1);
int sum = 0;

int resh(int l, int r, int ost) {
    if (l == r) {
        if (ost >= 0) {
            return w[l];
        }
        return 0;
    }
    if (dp[l][r][ost] != 0) {
        return dp[l][r][ost];
    }
    if (ost >= 0) {
        dp[l][r][ost] = max(w[l] + resh(l + 1, r, ost - w[l]), w[r] + resh(l, r - 1, ost - w[r]));
    } else {
        dp[l][r][ost] = min(resh(l + 1, r, ost + w[l]), resh(l, r - 1, ost + w[r]));
    }
    return dp[l][r][ost];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    bool ok = true;
    if (n > 500) {
        ok = false;
    }
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        sum += w[i];
        pref[i + 1] = sum;
    }
    if (n <= 500) {
        bool dp2[n][n][sum + 1];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                for (int k = 0; k <= sum; k++) {
                    dp2[i][j][k] = false;
                }
            }
        }
        dp2[0][n - 1][0] = true;
        int ans = 0;
        for (int len = n - 1; len >= 0; len--) {
            for (int l = 0; l + len < n; l++) {
                int r = l + len;
                for (int ss = 0; ss <= pref[r] - pref[l - 1]; ss++) {
                    if (dp2[l][r][ss]) {
                        if (l == r) {
                            ans = max(ans, ss);
                        } else if (ss <= pref[r] - pref[l] - ss) {
                            dp2[l + 1][r][ss + w[l]] = true;
                            dp2[l][r - 1][ss + w[r]] = true;
                        } else {
                            dp2[l + 1][r][ss] = true;
                            dp2[l][r - 1][ss] = true;
                        }
                    }
                }
            }
        }
        cout << ans << " " << sum - ans << "\n";
    } else {
        int ans = resh(0, n - 1, 0);
        cout << ans << " " << sum - ans << "\n";
    }

}
