#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector <int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    vector <vector <vector <pair <int, int>>>> dp(2, vector <vector <pair <int, int>>> (n, vector <pair <int, int>> (2 * w[n - 1] + 1, {0, 0})));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < w[n - 1]; ++j) {
            dp[0][i][j] = {w[i], 0};
        }
    }
    int t1 = 1;
    int t2 = 0;
    for (int len = 2; len <= n; ++len) {
        for (int l = 0; l < n - len + 1; ++l) {
            for (int j = 0; j <= w[n - 1]; ++j) {
                pair <int, int> d1;
                if (w[l] < j) {
                    d1 = {dp[t2][l + 1][j - w[l]].first + w[l], dp[t2][l + 1][j - w[l]].second};
                } else {
                    d1 = {dp[t2][l + 1][w[l] - j].second + w[l], dp[t2][l + 1][w[l] - j].first};
                }

                pair <int, int> d2;
                if (w[l + len - 1] <= j) {
                    d2 = {dp[t2][l][j - w[l + len - 1]].first + w[l + len - 1], dp[t2][l][j - w[l + len - 1]].second};
                } else {
                    d2 = {dp[t2][l][w[l + len - 1] - j].second + w[l + len - 1], dp[t2][l][w[l + len - 1] - j].first};
                }

                if (d1.first > d2.first) {
                    dp[t1][l][j] = d1;
                } else {
                    dp[t1][l][j] = d2;
                }
                //cout << len << " len " << l << " l " << j << " j " << dp[t1][l][j].first << " " << dp[t1][l][j].second << endl;
            }
        }
        swap(t1, t2);
    }
    cout << dp[t2][0][0].first << " " << dp[t2][0][0].second;
}

int main() {
    solve();
}
