// #include <bits/stdc++.h>
#include <algorithm>
#include <cassert>
#include <cmath>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <unordered_map>
#include <vector>

using namespace std;
using ll = long long;


void solve() {
    ll n;
    cin >> n;
    vector<ll> w(n);
    ll wm = 0;
    ll sum = 0;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        sum += w[i];
        wm = max(wm, w[i]);
    }
    vector<vector<vector<ll>>> dp(n + 1, vector<vector<ll>>(n + 1));
    vector<vector<ll>> nsz(n + 1, vector<ll> (n + 1));
    for (int len = 0; len <= n; len++){
        for (int i = 0; i + len <= n; i++){
            int r =  i + len;
            if (i - 1 >= 0){
                nsz[len][i] = w[i - 1];
            }
            if (r < n){
                nsz[len][i] = max(nsz[len][i], w[r + 1]);
            }
            dp[len][i].resize(2 * nsz[len][i] + 1);
        }
    }
    for (auto &el: dp[0]) {
        for (auto &el2: el) {
            el2 = 0;
        }
    }
    for (int len = 1; len <= n; len++) {
        for (int i = 0; i + len <= n; i++) {
            for (int j = 0; j <= 2 * nsz[len][i]; j++){
                int rb = j - nsz[len][i];
                int r = i + len - 1;
                if (rb >= 0){
                    dp[len][i][j]  = dp[len - 1][i + 1][rb - w[i] + nsz[len - 1][i + 1]] + w[i];
                    dp[len][i][j]  = max(dp[len][i][j], dp[len - 1][i][rb - w[r] + nsz[len - 1][i]] + w[r]);
                }
                else{
                    dp[len][i][j] = dp[len - 1][i + 1][rb + w[i] + nsz[len - 1][i + 1]];
                    dp[len][i][j]  = min(dp[len][i][j], dp[len - 1][i][rb + w[r] + nsz[len - 1][i]]);
                }
            }
        }
    }
    cout << dp[n][0][wm] << " " << sum - dp[n][0][wm] << "\n";
}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
