#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <bits/extc++.h>

using ll = long long int;
using ull = unsigned long long int;
using namespace std;
using namespace __gnu_pbds;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

struct Hasher
{
    ull operator()(const pair<int, int> &p) const
    {
        return (ull(p.first) << 32) | p.second;
    }
}

gp_hash_table<pair<int, int>, int, Hasher> dp[2000][2001];
vector<int> w;
vector<int> pref;
int f(int l, int r, int p, int t)
{
    if (l >= r)
        return 0;
    if (dp[l][r]{p, t}!= 0)
        return dp[l][r]{p, t};
    int s = pref[r] - pref[l];
    int op1 = -1;
    if (w[l] < t)
    {
        op1 = f(l + 1, r, p, t - w[l]) + w[l];
    }
    else if (w[l] > t)
    {
        op1 = s - f(l + 1, r, p ^ 1, w[l] - t);
    }
    else
    {
        if (p == 0)
            op1 = f(l + 1, r, 0, 0) + w[l];
        else
            op1 = s - f(l + 1, r, 0, 0);
    }

    int op2 = -1;
    if (w[r - 1] < t)
    {
        op2 = f(l, r - 1, p, t - w[r - 1]) + w[r - 1];
    }
    else if (w[r - 1] > t)
    {
        op2 = s - f(l, r - 1, p ^ 1, w[r - 1] - t);
    }
    else
    {
        if (p == 0)
            op2 = f(l, r - 1, 0, 0) + w[r - 1];
        else
            op2 = s - f(l, r - 1, 0, 0);
    }

    return dp[l][r]{p, t} = max(op1, op2);
}

void solve()
{
    int n;
    cin >> n;

    w.resize(n);
    pref.resize(n + 1);
    for (int i = 0; i < n; i++)
        cin >> w[i];
    partial_sum(all(w), pref.begin() + 1);

    cout << f(0, n, 0, 0) << ' ' << min(f(0, n - 1, 1, w[n - 1]), f(1, n, 1, w[0])) << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("D:/olymp/Day 1/in.txt", "r", stdin);
    freopen("D:/olymp/Day 1/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif
    while (t--)
        solve();
    return 0;
}