#include <iostream>
#include <set>
#include <vector>

using namespace std;
using ll = long long;

void solve() {
    ll n;
    cin >> n;
    vector<ll> src(n);
    ll maxW = 0;
    for (auto &item: src) {
        cin >> item;
        maxW = max(maxW, item);
    }

    if (n == 3) {
        cout << max(src[0] + src[1], src[2]) << ' ' << min(src[0] + src[1], src[2]) << '\n';
        return;
    }

    if (maxW == 2) {
        ll cnt2 = 0;
        ll cnt1 = 0;
        for (int i = 0; i < n; ++i) {
            cnt1 += src[i] == 1;
            cnt2 += src[i] == 2;
        }

        ll A = ((cnt2 + 1) / 2) * 2;
        ll B = (cnt2 / 2) * 2;
        if (cnt2 & 1) {
            if (cnt1 <= 2) {
                B += cnt1;
            } else {
                B += 2;
                cnt1 -= 2;
                A += (cnt1 + 1) / 2;
                B += cnt1 / 2;
            }
        } else {
            A += (cnt1 + 1) / 2;
            B += cnt1 / 2;
        }

        cout << A << ' ' << B << '\n';
        return;
    }

    ll sum = 0;
    for (const auto &item: src) {
        sum += item;
    }

    ll L = 0;
    ll R = n - 1;
    ll A = 0;
    ll B = 0;
    while (L <= R) {
        if (A <= B) {
            if (sum - src[R] > src[R]) {
                sum -= src[L];
                A += src[L];
                ++L;
            } else {
                sum -= src[R];
                A += src[R];
                --R;
            }
        } else {
            if (sum - src[R] > src[R] || B + src[R] == A) {
                sum -= src[L];
                B += src[L];
                ++L;
            } else {
                sum -= src[R];
                B += src[R];
                --R;
            }
        }
    }

    cout << A << ' ' << B << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
