#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e18;
const ll N = 505;
const ll MOD = 1e9 + 7;
const ll M = 5005; // !!!!!!!!!!!!!!!!!!!!!!!1

mt19937 gen(time(0));

ll n;
vector<ll> a;
map<ll, ll> dp[N][N];

ll dfs(ll i, ll j, ll w) {
    if (dp[i][j].find(w) != dp[i][j].end()) {
        return dp[i][j][w];
    }

    if (w < 0) {
        ll val = INF;
        if (w + a[i] <= M) {
            val = min(val, dfs(i + 1, j, w + a[i]));
        }
        if (w + a[j] <= M) {
            val = min(val, dfs(i, j - 1, w + a[j]));
        }
        dp[i][j][w] = val;
    } else {
        ll val = -INF;
        if (w - a[i] >= -M) {
            val = max(val, dfs(i + 1, j, w - a[i]) + a[i]);
        }
        if (w - a[j] >= -M) {
            val = max(val, dfs(i, j - 1, w - a[j]) + a[j]);
        }
        dp[i][j][w] = val;
    }
    return dp[i][j][w];
}

void solve() {
    cin >> n;
    a.resize(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    vector<ll> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i];
    }
    // vector<vector<vector<ll>>> dp(n + 1, vector<vector<ll>> (n + 1, vector<ll>(2 * M + 5, 0)));
    for (int i = 1; i <= n; i++) {
        for (int w = -M; w <= M; w++) {
            if (w < 0) {
                dp[i][i][w] = 0;
            } else {
                dp[i][i][w] = a[i];
            }
        }
    }
//    for (int len = 2; len <= n; len++) {
//        for (int i = 1; i + len - 1 <= n; i++) {
//            int j = i + len - 1;
//            for (int w = -M; w <= M; w++) {
//                if (w < 0) {
//                    ll val = INF;
//                    if (w + a[i] <= M) {
//                        val = min(val, dp[i + 1][j][w + a[i] + M]);
//                    }
//                    if (w + a[j] <= M) {
//                        val = min(val, dp[i][j - 1][w + a[j] + M]);
//                    }
//                    dp[i][j][w + M] = val;
//                } else {
//                    ll val = -INF;
//                    if (w - a[i] >= -M) {
//                        val = max(val, dp[i + 1][j][w - a[i] + M] + a[i]);
//                    }
//                    if (w - a[j] >= -M) {
//                        val = max(val, dp[i][j - 1][w - a[j] + M] + a[j]);
//                    }
//                    dp[i][j][w + M] = val;
//                }
//                // cout << i << " " << j << " " << w << " - " << dp[i][j][w + M] << '\n';
//            }
//
//
//        }
//    }
    ll ans = dfs(1, n, 0);
    cout << ans << " " << pref[n] - ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    ll tst = 1;
    while (tst--) {
        solve();
    }
}
