#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

const int INF = 1e9;
const int N = 2005;
const int MOD = 1e9 + 7;
const int M = 10005; // !!!!!!!!!!!!!!!!!!!!!!!1

mt19937 gen(time(0));

int n;
vector<int> a, pref;
unordered_map<int, int> dp[N][N];

int dfs(int i, int j, int w) {
    if (dp[i][j].find(w) != dp[i][j].end()) {
        return dp[i][j][w];
    }

    if (w < 0) {
        int val = INF;
        if (pref[j] - pref[i - 1] <= abs(w)) {
            val = 0;
        } else {
            if (w + a[i] <= M) {
                val = min(val, dfs(i + 1, j, w + a[i]));
            }
            if (w + a[j] <= M) {
                val = min(val, dfs(i, j - 1, w + a[j]));
            }
        }

        dp[i][j][w] = val;
    } else {
        int val = -INF;
        if (pref[j] - pref[i - 1] <= abs(w)) {
            val = pref[j] - pref[i - 1];
        } else {
            if (w - a[i] >= -M) {
                val = max(val, dfs(i + 1, j, w - a[i]) + a[i]);
            }
            if (w - a[j] >= -M) {
                val = max(val, dfs(i, j - 1, w - a[j]) + a[j]);
            }
        }

        dp[i][j][w] = val;
    }
    return dp[i][j][w];
}

void solve() {
    cin >> n;
    a.resize(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    pref.resize(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i];
    }
    // vector<vector<vector<int>>> dp(n + 1, vector<vector<int>> (n + 1, vector<int>(2 * M + 5, 0)));
    for (int i = 1; i <= n; i++) {
        for (int w = -M; w <= M; w++) {
            if (w < 0) {
                dp[i][i][w] = 0;
            } else {
                dp[i][i][w] = a[i];
            }
        }
    }
//    for (int len = 2; len <= n; len++) {
//        for (int i = 1; i + len - 1 <= n; i++) {
//            int j = i + len - 1;
//            for (int w = -M; w <= M; w++) {
//                if (w < 0) {
//                    int val = INF;
//                    if (w + a[i] <= M) {
//                        val = min(val, dp[i + 1][j][w + a[i] + M]);
//                    }
//                    if (w + a[j] <= M) {
//                        val = min(val, dp[i][j - 1][w + a[j] + M]);
//                    }
//                    dp[i][j][w + M] = val;
//                } else {
//                    int val = -INF;
//                    if (w - a[i] >= -M) {
//                        val = max(val, dp[i + 1][j][w - a[i] + M] + a[i]);
//                    }
//                    if (w - a[j] >= -M) {
//                        val = max(val, dp[i][j - 1][w - a[j] + M] + a[j]);
//                    }
//                    dp[i][j][w + M] = val;
//                }
//                // cout << i << " " << j << " " << w << " - " << dp[i][j][w + M] << '\n';
//            }
//
//
//        }
//    }
    int ans = dfs(1, n, 0);
    cout << ans << " " << pref[n] - ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    int tst = 1;
    while (tst--) {
        solve();
    }
}
