#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
using namespace __gnu_pbds;

#define map gp_hash_table

vector <vector <map <int, int>>> dp;
vector <int> a;
int n;
vector <int> pref;

int sum(int l, int r) {
    return pref[r + 1] - pref[l];
}

int rec(int l, int r, int rz) {
    if (l == r) {
        return dp[l][r][rz] = a[l];
    }

    if (dp[l][r].find(rz) != dp[l][r].end()) {
        return dp[l][r][rz];
    }

    if (rz <= 0) {
        int l1 = l + 1;
        int r1 = r;
        int rz1 = rz + a[l];
        int zn1 = a[l];
        if (rz1 > 0) {
            zn1 += sum(l1, r1) - rec(l1, r1, rz1);
        } else {
            zn1 += rec(l1, r1, rz1);
        }

        int l2 = l;
        int r2 = r - 1;
        int rz2 = rz + a[r];
        int zn2 = a[r];
        if (rz2 > 0) {
            zn2 += sum(l2, r2) - rec(l2, r2, rz2);
        } else {
            zn2 += rec(l2, r2, rz2);
        }

        dp[l][r][rz] = max(zn1, zn2);

    } else {
        int l1 = l + 1;
        int r1 = r;
        int rz1 = rz - a[l];
        int zn1 = a[l];
        if (rz1 <= 0) {
            zn1 += sum(l1, r1) - rec(l1, r1, rz1);
        } else {
            zn1 += rec(l1, r1, rz1);
        }

        int l2 = l;
        int r2 = r - 1;
        int rz2 = rz - a[r];
        int zn2 = a[r];
        if (rz2 <= 0) {
            zn2 += sum(l2, r2) - rec(l2, r2, rz2);
        } else {
            zn2 += rec(l2, r2, rz2);
        }

        dp[l][r][rz]= max(zn1, zn2);
    }
    return dp[l][r][rz];
}  

void solve() {
    cin >> n;
    a.assign(n, 0);
    for (int &i : a) {
        cin >> i;
    }
    pref.assign(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    int s = sum(0, n - 1);
    dp.assign(n, vector <map <int, int>> (n));

    int bro = rec(0, n - 1, 0);

    cout << bro << " " << sum(0, n - 1) - bro << '\n';

}

signed main() {
    #ifdef LOCAL
    freopen("C:/Users/olymp/ggbet/input.txt", "r", stdin);
    freopen("C:/Users/olymp/ggbet/output.txt", "w", stdout);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();    
    }
}