#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend


void solve() {
    int n; cin >> n;
    vector <int> v(n);
    for (auto& x : v) cin >> x;

    int sm = accumulate(all(v), 0ll);

    vector <vector <vector <int>>> dp(n + 1, vector <vector <int>>(n + 1, vector <int>(sm * 2 + 1, 0)));
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j < sm * 2 + 1; ++j) {
            dp[i][i][j] = j - sm;
        }
    }
    for (int len = 1; len <= n; ++len) {
        for (int l = 0; l + len <= n; ++l) {
            int r = l + len;
            for (int j = 0; j < sm * 2 + 1; ++j) {
                if (j <= sm && j + v[r - 1] <= sm * 2) {
                    dp[l][r][j] = max(dp[l + 1][r][j + v[l]], dp[l][r - 1][j + v[r - 1]]);
                }
                if (j > sm && j - v[r - 1] >= 0) {
                    dp[l][r][j] = min(dp[l + 1][r][j - v[l]], dp[l][r - 1][j - v[r - 1]]);
                }
            }
        }
    }

    if (dp[0][n][sm] >= 0) {
        int a = (sm - dp[0][n][sm]) / 2 + dp[0][n][sm];
        cout << a << ' ' << sm - a << '\n';
    }
    else {
        int a = (sm + dp[0][n][sm]) / 2;
        cout << a << ' ' << sm - a << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }

    return 0;
}
