#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend

int hs(int l, int r, int d) {
    d += 20000;
    return l * 2000 * 20000 + r * 20000 + d;
}

void solve() {
    int n; cin >> n;
    vector <int> v(n);
    for (auto& x : v) cin >> x;

    int sm = accumulate(all(v), 0ll);

    unordered_map <int, int> mp;
    function <int(int, int, int)> func = [&](int l, int r, int d) {
        if (r == l) return d;
        if (mp.count(hs(l, r, d))) return mp[hs(l, r, d)];

        if (d <= 0) {
            return mp[hs(l, r, d)] = max(
                    func(l + 1, r, d + v[l]),
                    func(l, r - 1, d + v[r - 1])
                    );
        }
        else {
            return mp[hs(l, r, d)] = min(
                    func(l + 1, r, d - v[l]),
                    func(l, r - 1, d - v[r - 1])
            );
        }
    };
    int ans = func(0, n, 0);

    if (ans >= 0) {
        int a = (sm - ans) / 2 + ans;
        cout << a << ' ' << sm - a << '\n';
    }
    else {
        int a = (sm + ans) / 2;
        cout << a << ' ' << sm - a << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }

    return 0;
}
