#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend

mt19937 rnd(228);
//mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int hs(int l, int r, int d) {
    d += 20000;
    return l * 2000 * 20000 + r * 20000 + d;
}

void solve() {
    int n; cin >> n;
    vector <int> v(n);
    for (auto& x : v) cin >> x;

    int sm = accumulate(all(v), 0ll);
    int mx = *max_element(all(v));


    int bl = -mx - 1, br = mx + 1;
    while (bl + 1 != br) {
        int m = (bl + br) / 2;

        unordered_map <int, bool> mp;
        function <bool(int, int, int)> func = [&](int l, int r, int d) {
            if (r == l) return (d >= m);
            if (mp.count(hs(l, r, d))) return mp[hs(l, r, d)];

            if (d <= 0) {
                if (rnd() % 2) {
                    if (func(l + 1, r, d + v[l])) return mp[hs(l, r, d)] = true;
                    if (func(l, r - 1, d + v[r - 1])) return mp[hs(l, r, d)] = true;
                    return mp[hs(l, r, d)] = false;
                }
                else {
                    if (func(l, r - 1, d + v[r - 1])) return mp[hs(l, r, d)] = true;
                    if (func(l + 1, r, d + v[l])) return mp[hs(l, r, d)] = true;
                    return mp[hs(l, r, d)] = false;
                }
            }
            else {
                if (rnd() % 2) {
                    if (!func(l + 1, r, d - v[l])) return mp[hs(l, r, d)] = false;
                    if (!func(l, r - 1, d - v[r - 1])) return mp[hs(l, r, d)] = false;
                    return mp[hs(l, r, d)] = true;
                }
                else {
                    if (!func(l, r - 1, d - v[r - 1])) return mp[hs(l, r, d)] = false;
                    if (!func(l + 1, r, d - v[l])) return mp[hs(l, r, d)] = false;
                    return mp[hs(l, r, d)] = true;
                }
            }
        };

        if (func(0, n, 0)) bl = m;
        else br = m;
    }
    int ans = bl;


    if (ans >= 0) {
        int a = (sm - ans) / 2 + ans;
        cout << a << ' ' << sm - a << '\n';
    }
    else {
        int a = (sm + ans) / 2;
        cout << a << ' ' << sm - a << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }

    return 0;
}
