#include "bits/stdc++.h"

#define int long long
#define ull unsigned long long
#define ld long doublt
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

pair<int, int> dp[200][200][1001];

void solve() {
    int n;
    cin >> n;
    vector<int> w(n);
    for (int &i: w) {
        cin >> i;
    }
    if (n == 1) {
        cout << w[0] << " 0";
        return;
    } else if (n == 2) {
        cout << w[1] << ' ' << w[0];
        return;
    } else if (n == 3) {
        int sum1 = w[2], sum2 = w[0] + w[1];
        if (w[2] == w[0]) {
            sum1 += w[0];
        }
        cout << max(sum1, sum2) << ' ' << accumulate(all(w), 0ll) - max(sum1, sum2);
        return;
    } else if (w[n - 1] <= 2) {
        if (w[n - 1] == 1) {
            cout << (n + 1) / 2 << ' ' << n / 2;
        } else if (w[0] == 2) {
            cout << (n + 1) / 2 * 2 << ' ' << n / 2 * 2;
        } else if (w[1] == 1) {
            int sum1 = 0, sum2 = 0;
            while (!w.empty()) {
                int q = w.back();
                sum1 += w.back();
                w.pop_back();

                if (!w.empty()) {
                    sum2 += w.back();
                    w.pop_back();
                }
            }
            cout << sum1 << ' ' << sum2;
        }
        return;
    } else if (n <= 200 && w[n - 1] <= 500) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                for (int k = 0; k <= w[n - 1] * 2; ++k) {
                    dp[i][j][k] = make_pair(1e18, 1e18);
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            for (int k = 0; k <= w[n - 1] * 2; ++k) {
                if (k < w[n - 1]) {
                    dp[i][i][k] = {0, w[i]};
                } else {
                    dp[i][i][k] = {w[i], 0};
                }
            }
        }
        for (int len = 2; len <= n; ++len) {
            for (int i = 0; i + len - 1 < n; ++i) {
                for (int k = 0; k <= w[n - 1] * 2; ++k) {
                    if (k < w[n - 1]) {
                        pair<int, int> A = dp[i + 1][i + len - 1][k + w[i]];
                        pair<int, int> B = dp[i][i + len - 2][k + w[i + len - 1]];
                        if (A.second > B.second) {
                            dp[i][i + len - 1][k] = {A.first, A.second + w[i]};
                        } else {
                            dp[i][i + len - 1][k] = {B.first, B.second + w[i + len - 1]};
                        }
                    } else {
                        pair<int, int> A = dp[i + 1][i + len - 1][k - w[i]];
                        pair<int, int> B = dp[i][i + len - 2][k - w[i + len - 1]];
                        if (A.first > B.first) {
                            dp[i][i + len - 1][k] = {A.first + w[i], A.second};
                        } else {
                            dp[i][i + len - 1][k] = {B.first + w[i + len - 1], B.second};
                        }
                    }
                }
            }
        }
        cout << dp[0][n - 1][w[n - 1]].first << ' ' << dp[0][n - 1][w[n - 1]].second;
        return;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}