#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
//set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined,bounds,address")
//#define int long long
#define ll long long
#define int short
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e3 + 1;
int n;
int w[maxn];
unordered_map<int, int> dp[maxn][maxn];
int p[maxn];

int f(int l, int r) {
    return p[l] + p[n] - p[r + 1];
}

int ans(int l = 0, int r = n - 1, int sa = 0) {
    if (l > r) return 0;
    if (dp[l][r].find(sa) != dp[l][r].end()) return dp[l][r][sa];
    int sb = f(l, r) - sa;
    if (sa <= sb) {
        int res = max(ans(l + 1, r, sa + w[l]) + w[l], ans(l, r - 1, sa + w[r]) + w[r]);
        dp[l][r][sa] = res;
    } else {
        int res = min(ans(l + 1, r, sa), ans(l, r - 1, sa));
        dp[l][r][sa] = res;
    }
    return dp[l][r][sa];
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        p[i + 1] = p[i] + w[i];
    }
    int sa = ans(), sb = p[n] - sa;
    cout << sa << ' ' << sb;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
