#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve()
{
    ll n;
    cin >> n;
    vector <ll> w(n);
    ll w_max = 0;
    for(ll i = 0; i < n; i++)
    {
        cin >> w[i];
        w_max = max(w_max, w[i]);
    }
    vector <vector <vector <ll> > > A(n, vector <vector <ll> > (n, vector <ll> (w_max + 1)));
    vector <ll> pref(n);
    pref[0] = w[0];
    for(ll i = 1; i < n; i++)
    {
        pref[i] = pref[i - 1] + w[i];
    }
    for(ll D = 0; D < n; D++)
    {
        for(ll l = 0; l + D < n; l++)
        {
            ll r = l + D;
            for(ll t = 0; t <= w_max; t++)
            {
                if(l == r)
                {
                    if(t == 0)
                    {
                        A[l][r][t] = w[l];
                    }
                    else
                    {
                        A[l][r][t] = 0;
                    }
                }
                else if(t == 0)
                {
                    ll ans1 = A[l + 1][r][w[l]] + w[l];
                    ll ans2 = A[l][r - 1][w[r]] + w[r];
                    A[l][r][t] = max(ans1, ans2);
                }
                else
                {
                    ll ans1;
                    if(w[l] <= t)
                    {
                        ans1 = A[l + 1][r][t - w[l]];
                    }
                    else
                    {
                        ans1 = (pref[r] - pref[l]) - A[l + 1][r][w[l] - t];
                    }
                    ll ans2;
                    if(w[r] <= t)
                    {
                        ans2 = A[l][r - 1][t - w[r]];
                    }
                    else
                    {
                        if(l == 0)
                        {
                            ans2 = (pref[r - 1]) - A[l][r - 1][w[r] - t];
                        }
                        else
                        {
                            ans2 = (pref[r - 1] - pref[l - 1]) - A[l][r - 1][w[r] - t];
                        }
                    }
                    A[l][r][t] = min(ans1, ans2);
                }
                //cout << l << ' ' << r << ' ' << t << ' ' << A[l][r][t] << endl;
            }
        }
    }
    cout << A[0][n - 1][0] << ' ' << pref[n - 1] - A[0][n - 1][0];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    ll t = 1;
    //cin >> t;
    for(ll i = 0; i < t; i++)
    {
        solve();
    }
    return 0;
}
