#include <bits/stdc++.h>
using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream& cin, ostream& cout);


int test_cnt = 1, group, cur_test;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    // cin >> test_cnt;
    // cin >> group;
    for (cur_test = 0; cur_test < test_cnt; ++cur_test)
        solve(cin, cout);
}


multiset<ll> a;
ll n, sum;


pair<ll, ll> dfs(const ll tm_a, const ll tm_b) {
    if (a.empty())
        return {tm_a, tm_b};
    ll w1 = *a.begin();
    ll w2 = *(--a.end());

    if (a.size() == 2)
        return (tm_a <= tm_b) ? make_pair(tm_a + w2, tm_b + w1) : make_pair(tm_a + w1, tm_b + w2);

    if (tm_a <= tm_b) {
        if (w2 >= sum - w2)
            return {tm_a + w2, tm_b + sum - w2};


        a.erase(a.begin());
        auto [a1, b1] = dfs(tm_a + w1, tm_b);
        a.insert(w1);

        a.erase(--a.end());
        auto [a2, b2] = dfs(tm_a + w2, tm_b);
        a.insert(w2);

        return (a1 >= a2) ? make_pair(a1, b1) : make_pair(a2, b2);
    } else {
        if (w2 >= sum - w2)
            return {tm_a + sum - w2, tm_b + w2};


        a.erase(a.begin());
        auto [a1, b1] = dfs(tm_a, tm_b + w1);
        a.insert(w1);

        a.erase(--a.end());
        auto [a2, b2] = dfs(tm_a, tm_b + w2);
        a.insert(w2);

        return (b1 >= b2) ? make_pair(a1, b1) : make_pair(a2, b2);
    }
}


void solve(istream& cin, ostream& cout) {
    cin >> n;
    for (ll i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        a.insert(x);
        sum += x;
    }


    auto [a1, b2] = dfs(0, 0);
    cout << a1 << ' ' << b2 << '\n';
}
