#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,bmi,bmi2,lzcnt,popcnt")

#define endl '\n'
#define F first
#define S second

typedef long long ll;
using namespace std;
using namespace __gnu_pbds;

mt19937 rng(time(nullptr));
mt19937_64 rngl(time(nullptr));
ll rnd(ll x) {
    uniform_int_distribution<ll>uid(0, x - 1);
    return uid(rngl);
}
int rnd(int x) {
    uniform_int_distribution<int>uid(0, x - 1);
    return uid(rng);
}

const int R = 21;
struct segment_tree {
    vector <ll> t, add;
    segment_tree() {
        t.resize(R * 2 + 32);
        add.resize(R * 2 + 32);
    }
    void push(int node, int nl, int nr) {
        t[node] += add[node] * (nr - nl + 1);
        if (node < R) {
            add[node * 2] += add[node];
            add[node * 2 + 1] += add[node];
        }
        add[node] = 0;
    }
    void calc(int node) {
        if (node < R) {
            t[node] = t[node * 2] + t[node * 2 + 1];
        }
    }
    void modify(int ql, int qr, ll val, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return;
        if (qr <= nl && nr <= qr) {
            add[node] += val;
            push(node, nl, nr);
            return;
        }
        int nm = (nl + nr) / 2;
        modify(ql, qr, val, node * 2, nl, nm);
        modify(ql, qr, val, node * 2 + 1, nm + 1, nr);
        calc(node);
    }
    ll query(int ql, int qr, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return 0;
        if (qr <= nl && nr <= qr)
            return t[node];
        int nm = (nl + nr) / 2;
        return query(ql, qr, node * 2, nl, nm) +
               query(ql, qr, node * 2 + 1, nm + 1, nr);
    }
};

int get(int a, int b) {
    return (a << 10) ^ b;
}

int w[2010];
unordered_map <int, pair <int, int>> dp[2010][2010];

pair <int, int> f(int l, int r, int ca, int cb) {
    int mn = min(ca, cb);
    ca -= mn;
    cb -= mn;
    if (l > r)
        return {0, 0};
    if (dp[l][r].empty())
        dp[l][r].reserve(40);
    if (dp[l][r].find(get(ca, cb)) != dp[l][r].end())
        return dp[l][r][get(ca, cb)];
    pair <int, int> ans;
    if (ca == 0) {
        if (w[r] < cb) {
            auto r2 = f(l, r - 1, w[r], cb);
            r2.F += w[r];
            ans = r2;
        }
        else if (w[l] < cb) {
            auto r1 = f(l + 1, r, w[l], cb);
            r1.F += w[l];
            ans = r1;
        }
        else {
            auto r1 = f(l + 1, r, w[l], cb);
            r1.F += w[l];
            auto r2 = f(l, r - 1, w[r], cb);
            r2.F += w[r];
            if (r1.F >= r2.F)
                ans = r1;
            else
                ans = r2;
        }
    }
    else {
        if (w[r] < ca) {
            auto r2 = f(l, r - 1, ca, w[r]);
            r2.S += w[r];
            ans = r2;
        }
        else if (w[l] < ca) {
            auto r1 = f(l + 1, r, ca, w[l]);
            r1.S += w[l];
            ans = r1;
        } else {
            auto r1 = f(l + 1, r, ca, w[l]);
            r1.S += w[l];
            auto r2 = f(l, r - 1, ca, w[r]);
            r2.S += w[r];
            if (r1.S >= r2.S)
                ans = r1;
            else
                ans = r2;
        }
    }
    return dp[l][r][get(ca, cb)] = ans;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> w[i];
    auto ans = f(0, n - 1, 0, 0);
    cout << ans.F << ' ' << ans.S << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll start = time(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    ll end = time(nullptr);
    cerr << "Ulyanovsk is the best!!!" << endl;
    cerr << "Execution time: " << end - start << " ms" << endl;
}
