#include <bits/stdc++.h>

/* Using libraries */
using namespace std;

using ld = long double;
template <class T>
using vc = vector <T>;
using pii = pair <int, int>;
using pint = pair <int, int>;
template <class T>
int sz(vc <T> &a) {
    return (int)a.size();
}
int sz(string &a) {
    return (int)a.size();
}

template<class T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e18;
template<class T>
bool chmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
const int N = 500;
const int K = 2000;
int p[N * 10], k;
int dp[N][N][K];
int w[N * 10];
int rec (int i, int l, int r) {
    if (r < l)
        return i;
    if (k - i - 1 < K && dp[l][r][k - i - 1] != -1)
        return dp[l][r][k - i - 1];

    int sum = k - (p[r + 1] - p[l]);
    int w1 = i;
    int w2 = sum - i;
    if (w1 <= w2) {
        int res = -inf;
        int s = 0;
        for (int j = l; j <= r; ++j) {
            s += w[j];
            if (w1 + s > w2 || j == r) {
                chmax(res, rec(i + s, j + 1, r));
                break;
            }
        }
        s = 0;
        for (int j = r; j >= l; --j) {
            s += w[j];
            if (w1 + s > w2 || j == l) {
                chmax(res, rec(i + s, l, j - 1));
                break;
            }
        }
        return dp[l][r][k - i - 1] = res;
    } else {
        int res = inf;
        int s = 0;
        for (int j = l; j <= r; ++j) {
            s += w[j];
            if (w2 + s >= w1 || r == j) {
                chmin(res, rec(i, j + 1, r));
                break;
            }
        }
        s = 0;
        for (int j = r; j >= l; --j) {
            s += w[j];
            if (w2 + s >= w1 || j == l) {
                chmin(res, rec(i, l, j - 1));
                break;
            }
        }
        return dp[l][r][k - i - 1] = res;
    }
}

void solve() {
    int n;
    cin >> n;
    int cnt1 = 0, cnt2 = 0;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        if (w[i] == 1)
            ++cnt1;
        else if (w[i] == 2)
            ++cnt2;
        p[i + 1] = p[i] + w[i];
        k += w[i];
    }
    if (cnt1 + cnt2 == n) {
        if (cnt2 == n) {
            cout << (n + 1) / 2 * 2 << ' ' << (n - (n + 1) / 2) * 2 << '\n';
        } else {
            cout << (k + 1) / 2 << ' ' << k - (k + 1) / 2 << '\n';
        }
        return;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            for (int q = 0; q < K; ++q)
                dp[i][j][q] = -1;
        }
    }
    int tt = rec(0, 0, n - 1);
    cout << tt << ' ' << k - tt << '\n';
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}
//set PATH=%PATH%;C:\mingw64\bin