#include <bits/stdc++.h>

//#pragma GCC optimize("O3", "unroll-loops")
//#pragma GCC target("avx2", "bmi", "bmi2", "lzcnt", "popcnt")

using namespace std;

#define all(a) (a).begin(), (a).end()
#define srt(a) sort((a).begin(), (a).end());
#define rsrt(a) sort((a).rbegin(), (a).rend());
#define lowb(a, x) (int)(lower_bound((a).begin(), (a).end(), x) - (a).begin())
#define uppb(a, x) (int)(upper_bound((a).begin(), (a).end(), x) - (a).begin())

#define eb emplace_back

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

const int N = 2001, W = 20001;

int n;
vector<int> w, s;
vector<vector<map<int, int>>> dp[2];

int calc(bool f, int l, int r, int t, int sm = 0, int alpha = INT32_MIN, int beta = INT32_MAX) {
    if (r < l)
        return 0;
    if (dp[f][l][r][t])
        return dp[f][l][r][t];
    if (f) {
        if (w[l] <= t) {
            dp[f][l][r][t] = max(dp[f][l][r][t], calc(f, l + 1, r, t - w[l], sm + w[l], alpha, beta) + w[l]);
        } else {
            dp[f][l][r][t] = max(dp[f][l][r][t], calc(!f, l + 1, r, w[l] - t,  sm + w[l], alpha, beta) + w[l]);
        }
        if (sm + dp[f][l][r][t] > beta)
            return dp[f][l][r][t];
        if (w[r] <= t) {
            dp[f][l][r][t] = max(dp[f][l][r][t], calc(f, l, r - 1, t - w[r], sm + w[r], max(alpha, dp[f][l][r][t]), beta) + w[r]);
        } else {
            dp[f][l][r][t] = max(dp[f][l][r][t], calc(!f, l, r - 1, w[r] - t,  sm + w[r],max(alpha, dp[f][l][r][t]), beta) + w[r]);
        }
    } else {
        dp[f][l][r][t] = INT32_MAX;
        if (w[l] < t) {
            dp[f][l][r][t] = min(dp[f][l][r][t], calc(f, l + 1, r, t - w[l], sm + w[l], alpha, beta));
        } else {
            dp[f][l][r][t] = min(dp[f][l][r][t], calc(!f, l + 1, r, w[l] - t, sm + w[l], alpha, beta));
        }
        if (sm + dp[f][l][r][t] < alpha)
            return dp[f][l][r][t];
        if (w[r] < t) {
            dp[f][l][r][t] = min(dp[f][l][r][t], calc(f, l, r - 1, t - w[r], sm , alpha, min(beta, dp[f][l][r][t])));
        } else {
            dp[f][l][r][t] = min(dp[f][l][r][t], calc(!f, l, r - 1, w[r] - t, sm, alpha, min(beta, dp[f][l][r][t])));
        }
    }
    return dp[f][l][r][t];
}

void solve() {
    cin >> n;
    w.resize(n);
    s.resize(n + 1);
    dp[0].assign(n, vector<map<int, int>> (n));
    dp[1].assign(n, vector<map<int, int>> (n));
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        s[i + 1] = s[i] + w[i];
    }
    calc(true, 0, n - 1, 0);
    cout << dp[1][0][n - 1][0] << ' ' << s[n] - dp[1][0][n - 1][0] << '\n';
}

int main() {
#ifdef LOCAL
    // cout << "YA GEY\n";
    freopen("C:\\Users\\olymp\\CLionProjects\\open\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
}