#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <climits>
#include <random>

using namespace std;

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;

struct jet{
    ll to, cost;
};

void solve(){
    ll n, k, t;
    cin >> n;
    vll v(n);
    ll mx = 0, sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        mx = max(mx, v[i]);
        sum += v[i];
    }
    if (n == 3){
        cout << max(v[0] + v[1], v[2]) << " " << min(v[0] + v[1], v[2]) << "\n";
        return;
    }
    if (mx == 2){
        if (sum == 2 && n == 1){
            cout << 2 << " " << 0;
            return;
        }
        cout << (sum + 1) / 2 << " " << sum / 2 << "\n";
        return;
    }
    ll ans_a = 0, ans_b = 0;
    ll busy_a = 0;
    ll busy_b = 0;
    ll pointer1 = 0, pointer2 = n - 1;
    for (int j = 0; j < 20000 && pointer1 <= pointer2; ++j) {
        if (busy_a <= j){
            busy_a = j + v[pointer2];
            ans_a += v[pointer2];
            pointer2--;
        }
        if (pointer1 > pointer2){
            break;
        }
        if (busy_b <= j){
            busy_b = j + v[pointer2];
            ans_b += v[pointer2];
            pointer2--;
        }
    }
    cout << ans_a << " " << ans_b << "\n";
}



int main(){
    /*ll task, group;
    cin >> task >> group;
    */
    solve();
}
