#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define endl '\n'

typedef long long ll;
typedef long double ld;

typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 2e9 + 1;
const int MOD = 1e9 + 7;

mt19937 rnd(time(0));

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

signed main() {
    Fast();
    int n;
    cin >> n;
    vector <int> w(n);
    int sum = 0;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        sum += w[i];
    }
    int k = w[n - 1];
    vector <vector <vector <int>>> dp(n, vector <vector <int>> (n, vector <int> (k * 2 + 1, INF)));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < 2 * k + 1; j++){
            int p = j - k;
            if (p > 0)
                dp[i][i][j] = -w[i];
            else
                dp[i][i][j] = w[i];
        }
    }
    for (int l = 2; l <= n; l++){
        for (int i = 0; i < n - l + 1; i++){
            for (int j = 0; j < 2 * k + 1; j++){
                int p = j - k;
                if (p > 0){
                    if (j - w[i] >= 0)
                        dp[i][i + l - 1][j] = dp[i + 1][i + l - 1][j - w[i]] - w[i];
                    if (j - w[i + l - 1] >= 0){
                        if (dp[i][i + l - 1][j] == INF)
                            dp[i][i + l - 1][j] = dp[i][i + l - 2][j - w[i + l - 1]] - w[i + l - 1];
                        else
                            dp[i][i + l - 1][j] = min(dp[i][i + l - 1][j], dp[i][i + l - 2][j - w[i + l - 1]] - w[i + l - 1]);
                    }
                }else{
                    if (j + w[i] < 2 * k + 1)
                        dp[i][i + l - 1][j] = dp[i + 1][i + l - 1][j + w[i]] + w[i];
                    if (j + w[i + l - 1] < 2 * k + 1){
                        if (dp[i][i + l - 1][j] == INF)
                            dp[i][i + l - 1][j] = dp[i][i + l - 2][j + w[i + l - 1]] + w[i + l - 1];
                        else
                            dp[i][i + l - 1][j] = max(dp[i][i + l - 1][j], dp[i][i + l - 2][j + w[i + l - 1]] + w[i + l - 1]);
                    }
                }
            }
        }
    }
    int d = dp[0][n - 1][k];
    if (d > 0)
        cout << (sum - d) / 2 + d << " " << (sum - d) / 2;
    else
        cout << (sum + d) / 2 << " " << (sum + d) / 2 - d;
    return 0;
}
