#include <iostream>
#include <vector>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }

    auto calc = [&] (auto self, int l, int r, int time_l, int time_r) -> pair<int, int> {
        //cout << l << ' ' << r << ' ' << time_l << ' ' << time_r << endl;
        if (l + 1 == r) {
            if (time_l <= time_r) {
                time_l += a[l];
            } else {
                time_r += a[l];
            }
            return {time_l, time_r};
        }
        if (time_l <= time_r) {
            auto [x1, y1] = self(self, l + 1, r, time_l + a[l], time_r);
            auto [x2, y2] = self(self, l, r - 1, time_l + a[r - 1], time_r);
            if (x1 > x2 || (x1 == x2 && y1 > y2)) {
                return {x1, y1};
            }
            return {x2, y2};
        } else {
            auto [x1, y1] = self(self, l + 1, r, time_l, time_r + a[l]);
            auto [x2, y2] = self(self, l, r - 1, time_l, time_r + a[r - 1]);
            if (y1 > y2 || (y1 == y2 && x1 > x2)) {
                return {x1, y1};
            }
            return {x2, y2};
        }
    };

    auto [x, y] = calc(calc, 0, n, 0, 0);
    cout << x << ' ' << y;
}