#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define dbg(a) cout << #a << " = " << a << endl;
#define dbg1(a) cout << #a << " = "; for (auto i : a) cout << i << ' '; cout << endl;
#define dbg2(a) cout << #a << " = "; for (auto [x, y] : a) cout << "{ " << x << ' ' << y << "} "; cout << endl;

const int INF = 1e9 + 7;
const int mod = 1e9 + 7;


const int N = 2e3 + 3, W = 2e4 + 3;

bool dp[N][W];
int w[N];

mt19937_64 rnd(time(0));

//gp_hash_table<ll, int> sv;
//
//int get(int l, int r, int slp, int fl) {
//    ll hash = ((1ll * l * N * W + r * W + slp) << 1) + fl;
//    if (sv[hash] != 0)
//        return sv[hash];
//
//    int ans = 0;
//    // take max
//    int sub = w[r - 1];
//
//}

void solve() {
    int n;
    cin >> n;
    int sm = 0;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        sm += w[i];
    }

    auto check = [&](int j){
        ll tmp = 0;
        for (int i = j; j < n - 1; j++) {
            tmp += w[i];
        }

        if (tmp < w[n - 1])
            return true;

        return false;
    };

    int f = -1;
    for (int i = 0; i < n; i++) {
        if (check(i)) {
            f = i;
            break;
        }
    }

    dp[0][0] = true;
    for (int i = 1; i <= n; i++) {
        for (int prev = 0; prev <= sm - w[i - 1]; prev++) {
            dp[i][prev + w[i - 1]] |= dp[i - 1][prev];
            dp[i][prev] |= dp[i - 1][prev];
        }
    }

    int mnd = INF;
    for (int i = 0; i <= sm; i++) {
        if (!dp[n][i]) continue;
        mnd = min(abs((sm - i) - i), mnd);
    }
    int a = (sm + mnd) / 2, b = (sm - mnd) / 2;

    if (f & 1) {
        cout << a << ' ' << b << '\n';
    } else {
        cout << b << ' ' << a << '\n';
    }
}

int main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
