#pragma GCC target("avx2")
#pragma GCC optimize("Ofast,unroll-loops,inline,fast-math")
#include <bits/stdc++.h>

using namespace std;

vector<vector<map<int, int>>> mem;
vector<int> w;

int calc(int l, int r, int timea, int timeb) {
    if (l > r)
        return 0;
    if (!mem[l][r].count(timea)) {
        if (timea <= timeb) {
            int var1 = w[l] + calc(l + 1, r, timea + w[l], timeb);
            int var2 = calc(l, r - 1, timea + w[r], timeb) + w[r];
            mem[l][r][timea] = max(var1, var2);
        } else {
            int var1 = calc(l + 1, r, timea, timeb + w[l]);
            int var2 = calc(l, r - 1, timea, timeb + w[r]);
            mem[l][r][timea] = min(var1, var2);
        }
    }
    return mem[l][r][timea];
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    w.resize(n);
    for (auto& el : w)
        cin >> el;
    if (n == 3) {
        if (w[0] + w[1] >= w[2])
            cout << w[0] + w[1] << ' ' << w[2];
        else
            cout << w[2] << ' ' << w[0] + w[1];
        return 0;
    }
    mem.resize(n, vector<map<int, int>>(n));
    int resa = calc(0, n - 1, 0, 0);
    cout << resa << ' ' << accumulate(w.begin(), w.end(), 0) - resa;
}