#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

const int INF = 1e9;

const int MAXN = 2001;
gp_hash_table<int, int> mem[MAXN][MAXN];
vector<int> w;

int calc(int l, int r, int timea, int timeb, int alpha, int beta) {
    if (l > r)
        return timea;
    if (mem[l][r].find(timea) == mem[l][r].end()) {
        if (timea <= timeb) {
            int var1 = calc(l + 1, r, timea + w[l], timeb, alpha, beta);
            int var2 = calc(l, r - 1, timea + w[r], timeb, max(alpha, var1), beta);
            mem[l][r][timea] = max(var1, var2);
        } else {
            int var1 = calc(l + 1, r, timea, timeb + w[l], alpha, beta);
            int var2 = calc(l, r - 1, timea, timeb + w[r], alpha, min(beta, var1));
            mem[l][r][timea] = min(var1, var2);
        }
    }
    return mem[l][r][timea];
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    w.resize(n);
    for (auto& el : w)
        cin >> el;
    if (n == 3) {
        if (w[0] + w[1] >= w[2])
            cout << w[0] + w[1] << ' ' << w[2];
        else
            cout << w[2] << ' ' << w[0] + w[1];
        return 0;
    }
    int resa = calc(0, n - 1, 0, 0, -INF, INF);
    cout << resa << ' ' << accumulate(w.begin(), w.end(), 0) - resa;
}