#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

const int MAXN = 2001;
int mem[MAXN][MAXN];
vector<int> w;

int calc(int l, int r, int timea, int timeb) {
    if (l > r)
        return timea;
    if (timea <= timeb && (mem[l][r] == 0 || mem[l][r] < timea)) {
        int var1 = w[l] + calc(l + 1, r, timea + w[l], timeb);
        int var2 = calc(l, r - 1, timea + w[r], timeb) + w[r];
        if (mem[l][r])
            mem[l][r] = max({ mem[l][r], var1, var2 });
        else
            mem[l][r] = max(var1, var2);
    } else if (mem[l][r] == 0 || mem[l][r] > timea) {
        int var1 = calc(l + 1, r, timea, timeb + w[l]);
        int var2 = calc(l, r - 1, timea, timeb + w[r]);
        if (mem[l][r])
            mem[l][r] = min({ mem[l][r], var1, var2 });
        else
            mem[l][r] = min(var1, var2);
    }
    return mem[l][r];
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    w.resize(n);
    for (auto& el : w)
        cin >> el;
    if (n == 3) {
        if (w[0] + w[1] >= w[2])
            cout << w[0] + w[1] << ' ' << w[2];
        else
            cout << w[2] << ' ' << w[0] + w[1];
        return 0;
    }
    for (int i = 0; i < n; ++i)
        fill(mem[i], mem[i] + n - i, 0);
    int resa = calc(0, n - 1, 0, 0);
    cout << resa << ' ' << accumulate(w.begin(), w.end(), 0) - resa;
}