#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;

short int dp[200][200][2][501];

struct st {
	short int l, r, ost;
	bool fl;
};

bool operator<(st a, st b) { return tie(a.l, a.r, a.ost, a.fl) < tie(b.l, b.r, b.ost, b.fl); }

map <st, int> anses;

int a[2000];
int n;

int f(int l, int r, bool fl, int ost) {
	if (l == r) {
		if (!fl) return a[l];
		else return -a[l];
	}
	if (anses.find({ l, r, ost, fl }) != anses.end()) return anses[{l, r, ost, fl}];
	if (!fl) {
		int x = -1e9, y = -1e9;
		if (a[l] <= ost) x = a[l] + f(l + 1, r, fl, ost - a[l]);
		else x = a[l] + f(l + 1, r, !fl, a[l] - ost);
		if (a[r] <= ost) y = a[r] + f(l, r - 1, fl, ost - a[r]);
		else y = a[r] + f(l, r - 1, !fl, a[r] - ost);
		anses[{l, r, ost, fl}] = max(x, y);
		return max(x, y);
	}
	else {
		int x = 1e9, y = 1e9;
		if (a[l] < ost) x = f(l + 1, r, fl, ost - a[l]) - a[l];
		else x = f(l + 1, r, !fl, a[l] - ost) - a[l];
		if (a[r] < ost) y = f(l, r - 1, fl, ost - a[r]) - a[r];
		else y = f(l, r - 1, !fl, a[r] - ost) - a[r];
		anses[{l, r, ost, fl}] = min(x, y);
		return min(x, y);
	}
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	cin >> n;
	int sum = 0;
	bool fl = 1;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		sum += a[i];
	}
	if (n == 3 || (n <= 500 && sum <= 5000)) {
		int ans = f(0, n - 1, 0, 0);
		cout << (sum + ans) / 2 << ' ' << sum - (sum + ans) / 2;
	}
	else {
		for (int i = 0; i < n; i++) {
			for (int x = 0; x <= 500; x++) dp[i][i][0][x] = a[i], dp[i][i][1][x] = -a[i];
		}
		for (int len = 2; len <= n; len++) {
			for (int l = 0; l <= n - len; l++) {
				int r = l + len - 1;
				for (int ost = 0; ost <= 500; ost++) {
					for (int fl = 0; fl < 2; fl++) {
						if (!fl) {
							int x = -1e9, y = -1e9;
							if (a[l] <= ost) x = a[l] + dp[l + 1][r][fl][ost - a[l]];
							else x = a[l] + dp[l + 1][r][!fl][a[l] - ost];
							if (a[r] <= ost) y = a[r] + dp[l][r - 1][fl][ost - a[r]];
							else y = a[r] + dp[l][r - 1][!fl][a[r] - ost];
							dp[l][r][fl][ost] = max(x, y);
						}
						else {
							int x = 1e9, y = 1e9;
							if (a[l] < ost) x = dp[l + 1][r][fl][ost - a[l]] - a[l];
							else x = dp[l + 1][r][!fl][a[l] - ost] - a[l];
							if (a[r] < ost) y = dp[l][r - 1][fl][ost - a[r]] - a[r];
							else y = dp[l][r - 1][!fl][a[r] - ost] - a[r];
							dp[l][r][fl][ost] = min(x, y);
						}
					}
				}
			}
		}
		int ans = dp[0][n - 1][0][0];
		cout << (sum + ans) / 2 << ' ' << sum - (sum + ans) / 2;
	}
	return 0;
}