// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long ll;
typedef long double ld;

const long long INF = 1e18;
const int inf = 2e9;
const int MOD = 1e9 + 7;

int MAXw = 0;

void solve() {
    int n, sum = 0;
    cin >> n;
    vector<int> w(n);
    for (int& e : w) { cin >> e; sum += e; MAXw = max(e + 1, MAXw); }
    vector<vector<vector<vector<int>>>> dp(2, vector<vector<vector<int>>>(n, vector<vector<int>>(n, vector<int>(MAXw, 0))));
    for (int i = 0; i < n; ++i) {
        for (int left = 0; left < MAXw; ++left) {
            dp[0][i][i][left] = w[i];
            dp[1][i][i][left] = 0;
        }
        dp[1][i][i][0] = dp[0][i][i][0];
    }
    for (int len = 2; len <= n; ++len) {
        for (int l = 0; l <= n - len; ++l) {
            int r = l + len - 1;
            for (int left = 0; left < MAXw; ++left) {
                // for Alice
                if (w[l] <= left) {
                    dp[0][l][r][left] = max(dp[0][l][r][left], dp[0][l + 1][r][left - w[l]] + w[l]);
                } else {
                    dp[0][l][r][left] = max(dp[0][l][r][left], dp[1][l + 1][r][w[l] - left] + w[l]);
                }
                if (w[r] <= left) {
                    dp[0][l][r][left] = max(dp[0][l][r][left], dp[0][l][r - 1][left - w[r]] + w[r]);
                } else {
                    dp[0][l][r][left] = max(dp[0][l][r][left], dp[1][l][r - 1][w[r] - left] + w[r]);
                }

                //for Bob
                dp[1][l][r][left] = INF;
                if (w[l] < left) {
                    dp[1][l][r][left] = min(dp[1][l][r][left], dp[1][l + 1][r][left - w[l]]);
                } else {
                    dp[1][l][r][left] = min(dp[1][l][r][left], dp[0][l + 1][r][w[l] - left]);
                }
                if (w[r] < left) {
                    dp[1][l][r][left] = min(dp[1][l][r][left], dp[1][l][r - 1][left - w[r]]);
                } else {
                    dp[1][l][r][left] = min(dp[1][l][r][left], dp[0][l][r - 1][w[r] - left]);
                }
            }
        }
    }
    cout << dp[0][0][n - 1][0] << ' ' << sum - dp[0][0][n - 1][0] << '\n';
}

signed main() {
#ifdef erytw
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
