#include <bits/stdc++.h>
using namespace std;

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

using ll = long long;

const int MAX = 3e5 + 7;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    int resa = 0, resb = 0;
    int l = 1, r = n;
    int timea = 0, timeb = 0;
    int bra = 0, brb = 0;
    while (l <= r) {
        if (bra == brb) {
            timea = bra;
            timeb = brb;
            bool optr = true;
            int suml = 0;
            for (int i = l; i < r; i++) {
                suml += a[i];
                if (suml >= a[r]) break;
            }
            if (suml >= a[r] + a[r - 1]) optr = false;
            if (optr) {
                bra = timea + a[r];
                resa += a[r];
                r--;
            } else {
                bra = timea + a[l];
                resa += a[l];
                l++;
            }
            optr = true;
            suml = 0;
            for (int i = l; i < r; i++) {
                suml += a[i];
                if (suml >= a[r]) break;
            }
            if (suml >= a[r] + a[r - 1]) optr = false;
            if (optr) {
                brb = timeb + a[r];
                resb += a[r];
                r--;
            } else {
                brb = timeb + a[l];
                resb += a[l];
                l++;
            }
        } else {
            if (bra < brb) {
                timea = bra;
                timeb = bra;
                bool optr = true;
                int suml = 0;
                for (int i = l; i < r; i++) {
                    suml += a[i];
                    if (suml >= a[r]) break;
                }
                if (suml >= a[r] + a[r - 1]) optr = false;
                if (optr) {
                    bra = timea + a[r];
                    resa += a[r];
                    r--;
                } else {
                    bra = timea + a[l];
                    resa += a[l];
                    l++;
                }
            } else {
                timeb = brb;
                timea = brb;
                bool optr = true;
                int suml = 0;
                for (int i = l; i < r; i++) {
                    suml += a[i];
                    if (suml >= a[r]) break;
                }
                if (suml >= a[r] + a[r - 1]) optr = false;
                if (optr) {
                    brb = timeb + a[r];
                    resb += a[r];
                    r--;
                } else {
                    brb = timeb + a[l];
                    resb += a[l];
                    l++;
                }
            }
        }
    }
    cout << resa << ' ' << resb;
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}