#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const int INF = 1e9, MOD = 1e9 + 7, LOG = 20;

int v[2005];
map<int, pair<int, int>> dp[2005][2005];

void calc(int l, int r, int dif)
{
	if (dp[l][r].find(dif) != dp[l][r].end())
	{
		return;
	}
	if (l == r)
	{
		if (dif <= 0)
		{
			dp[l][r][dif] = { v[l], 0 };
		}
		else
		{
			dp[l][r][dif] = { 0, v[l] };
		}
		return;
	}

	if (dif <= 0)
	{
		calc(l + 1, r, dif + v[l]);
		auto [a1, b1] = dp[l + 1][r][dif + v[l]];
		a1 += v[l];

		calc(l, r - 1, dif + v[r]);
		auto [a2, b2] = dp[l][r - 1][dif + v[r]];
		a2 += v[r];

		if (a1 >= a2)
		{
			dp[l][r][dif] = { a1, b1 };
		}
		else
		{
			dp[l][r][dif] = { a2, b2 };
		}
	}
	else
	{
		calc(l + 1, r, dif - v[l]);
		auto [a1, b1] = dp[l + 1][r][dif - v[l]];
		b1 += v[l];

		calc(l, r - 1, dif - v[r]);
		auto [a2, b2] = dp[l][r - 1][dif - v[r]];
		b2 += v[r];

		if (b1 >= b2)
		{
			dp[l][r][dif] = { a1, b1 };
		}
		else
		{
			dp[l][r][dif] = { a2, b2 };
		}
	}
}

void solve()
{
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> v[i];
	}

	/*
	int mxt = v[n - 1];

	vector<vector<vector<pair<int, int>>>> dp(n, vector<vector<pair<int, int>>>(n, vector<pair<int, int>>(mxt * 2 + 1)));
	for (int i = 0; i < n; i++)
	{
		for (int dt = 0; dt < mxt * 2 + 1; dt++)
		{
			int dif = dt - mxt;
			if (dif <= 0)
			{
				dp[i][i][dt] = { v[i], 0 };
			}
			else
			{
				dp[i][i][dt] = { 0, v[i] };
			}
		}
	}

	for (int len = 2; len <= n; len++)
	{
		for (int l = 0; l < n - len + 1; l++)
		{
			int r = l + len - 1;
			for (int dt = 0; dt < mxt * 2 + 1; dt++)
			{
				int dif = dt - mxt;
				if (dif <= 0)
				{
					int a1 = -INF, b1 = -INF;
					if (l + 1 <= r && dt + v[l] < dp[l][r].size())
					{
						a1 = dp[l + 1][r][dt + v[l]].first;
						b1 = dp[l + 1][r][dt + v[l]].second;
						a1 += v[l];
					}
					int a2 = -INF, b2 = -INF;
					if (l <= r - 1 && dt + v[r] < dp[l][r].size())
					{
						a2 = dp[l][r - 1][dt + v[r]].first;
						b2 = dp[l][r - 1][dt + v[r]].second;
						a2 += v[r];
					}

					if (a1 >= a2)
					{
						dp[l][r][dt] = { a1, b1 };
					}
					else
					{
						dp[l][r][dt] = { a2, b2 };
					}
				}
				else
				{
					int a1 = -INF, b1 = -INF;
					if (l + 1 <= r && dt - v[l] >= 0)
					{
						a1 = dp[l + 1][r][dt - v[l]].first;
						b1 = dp[l + 1][r][dt - v[l]].second;
						b1 += v[l];
					}
					int a2 = -INF, b2 = -INF;
					if (l <= r - 1 && dt - v[r] >= 0)
					{
						a2 = dp[l][r - 1][dt - v[r]].first;
						b2 = dp[l][r - 1][dt - v[r]].second;
						b2 += v[r];
					}

					if (b1 >= b2)
					{
						dp[l][r][dt] = { a1, b1 };
					}
					else
					{
						dp[l][r][dt] = { a2, b2 };
					}
				}
			}
		}
	}

	auto [a, b] = dp[0][n - 1][mxt];
	cout << a << " " << b << "\n";
	*/

	calc(0, n - 1, 0);
	auto [a, b] = dp[0][n - 1][0];
	cout << a << " " << b << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
