#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math,inline")
#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e6+2;

ll arr[N],pref[N];
ll n;

ll sum(ll l, ll r)
{
    if(l==0) return pref[n-1]-pref[r];
    return pref[n-1]-(pref[r]-pref[l-1]);
}

unordered_map<ll,ll> mp;

ll rec(ll l, ll r, ll x, ll mxg, ll mng)
{
    auto it=mp.find(l*N*N+r*N+x);
    if(it!=mp.end()) return (*it).S;
    ll y=sum(l,r)-x,res=0;

    if(x<=y)
    {
        if(l<r)
        {
            res=rec(l+1,r,x+arr[l],mxg,mng);
            if(res<mng) res=max(res,rec(l,r-1,x+arr[r],max(mxg,res),mng));
        }

        else res=x+arr[l];
    }

    else
    {
        if(l<r)
        {
            res=rec(l+1,r,x,mxg,mng);
            if(res>mxg) res=min(res,rec(l,r-1,x,mxg,min(mng,res)));
        }

        else res=x;
    }

    return mp[l*N*N+r*N+x]=res;
}

void solve()
{
    cin>>n;

    for(ll i=0;i<n;i++)
        cin>>arr[i];

    pref[0]=arr[0];

    for(ll i=1;i<n;i++)
        pref[i]=pref[i-1]+arr[i];

    ll x=rec(0,n-1,0,-INF,INF);
    cout<<x<<' '<<pref[n-1]-x;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
