#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math,inline")
#include <bits/stdc++.h>
#pragma GCC target("arch=skylake")

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=2002;

namespace hash_table
{
    const ll M=1e7+2;
    ve<pll> v[M];

    ll get_hash(ll x)
    {
        return x%M;
    }

    ll get(ll x)
    {
        ll h=get_hash(x);

        for(pll &i:v[h])
        {
            if(i.F==x)
                return i.S;
        }

        return -1;
    }

    void add(ll x, ll y)
    {
        v[get_hash(x)].PB({x,y});
    }
}

ll arr[N],pref[N];
ll n;

ll sum(ll l, ll r)
{
    if(l==0) return pref[n-1]-pref[r];
    return pref[n-1]-(pref[r]-pref[l-1]);
}

ll rec(ll l, ll r, ll x)
{
    ll val=hash_table::get(x*N*N+l*N+r);
    if(val!=-1) return val;
    ll y=sum(l,r)-x,res=0;

    if(x<=y)
    {
        if(l<r) res=max(rec(l+1,r,x+arr[l])+arr[l],rec(l,r-1,x+arr[r])+arr[r]);
        else res=arr[l];
    }

    else
    {
        if(l<r) res=min(rec(l+1,r,x),rec(l,r-1,x));
        else res=0;
    }

    hash_table::add(x*N*N+l*N+r,res);
    return res;
}

void solve()
{
    n=2000;
    cin>>n;

    for(ll i=0;i<n;i++)
    {
        arr[i]=gen()%10+1;
        cin>>arr[i];
    }

    sort(arr,arr+n);
    pref[0]=arr[0];

    for(ll i=1;i<n;i++)
        pref[i]=pref[i-1]+arr[i];

    ll x=rec(0,n-1,0);
    cout<<x<<' '<<pref[n-1]-x;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
