#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define p_b push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template<class T> using oset =
tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using pq =
priority_queue<T>;
template<class T> using pqg =
priority_queue<T, vector<T>, greater<T>>;

template<class T> void amin(T &a, T b) {a = a < b ? a : b;}
template<class T> void amax(T &a, T b) {a = a > b ? a : b;}

const int N = 2000 + 5;

int a[N];
int pref[N];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i] = a[i];
        if (i)
            pref[i] += pref[i - 1];
    }
    if (n == 1) {
        cout << a[0] << ' ' << 0;
        return;
    }
    int x = 0, y = 0;
    for (int i = 0; i < n; i++) {
        if (pref[n - 2] - (i ? pref[i - 1] : 0) < a[n - 1]) {
            if (i & 1)
                cout << x + pref[n - 2] - (i ? pref[i - 1] : 0) << ' ' << y + a[n - 1];
            else
                cout << x + a[n - 1] << ' ' << y + pref[n - 2] - (i ? pref[i - 1] : 0);
            return;
        }
        if (i & 1)
            y += a[i];
        else
            x += a[i];
    }
}

int32_t main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // LOCAL
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    #ifdef LOCAL
        cout << "\n===\n\n\nTime : " << clock() / CLOCKS_PER_SEC << '\n';
    #endif // LOCAL
}
