#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n;
    cin >> n;

    int suma = 0;
    vector <int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        suma += w[i];
    }

    int ans1 = 0, ans2 = 0;
    int l = 0, r = n - 1;
    while (l <= r) {
        if (ans1 <= ans2) {
            if (suma - w[r] <= w[r] || w.back() <= 2) {
                ans1 += w[r];
                suma -= w[r];
                r--;
            } else {
                ans1 += w[l];
                suma -= w[l];
                l++;
            }
        } else {
            if (suma - w[r] <= w[r] || w.back() <= 2) {
                ans2 += w[r];
                suma -= w[r];
                r--;
            } else {
                ans2 += w[l];
                suma -= w[l];
                l++;
            }
        }
    }
    cout << ans1 << " " << ans2 << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}