#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3,unroll-loops")

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

//#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n;
    cin >> n;

    int suma = 0;
    vector <int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        suma += w[i];
    }
    int mx_delta = 0;
    for (int i = 0; i + 1 < n; i++) {
        mx_delta = max(mx_delta, abs(w[i] - w[i + 1]));
    }

    if (n == 3 || w.back() <= 2) {
        int ans1 = 0, ans2 = 0;
        int l = 0, r = n - 1;
        while (l <= r) {
            if (ans1 <= ans2) {
                if (suma - w[r] <= w[r] || w.back() <= 2) {
                    ans1 += w[r];
                    suma -= w[r];
                    r--;
                } else {
                    ans1 += w[l];
                    suma -= w[l];
                    l++;
                }
            } else {
                if (suma - w[r] <= w[r] || w.back() <= 2) {
                    ans2 += w[r];
                    suma -= w[r];
                    r--;
                } else {
                    ans2 += w[l];
                    suma -= w[l];
                    l++;
                }
            }
        }
        cout << ans1 << " " << ans2 << "\n";
        return;
    }

    const int MAX = mx_delta + 10;

    vector <vector <pair <int, int>>> dp1(n, vector <pair <int, int>> (2 * MAX)), dp2(n, vector <pair <int, int>> (2 * MAX));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 2 * MAX; j++) {
            int otr = j - MAX;
            if (otr < 0) {
                dp1[i][j] = {0, w[i]};
            } else {
                dp1[i][j] = {w[i], 0};
            }
        }
    }
    for (int len = 2; len <= n; len++) {
        for (int l = 0; l + len - 1 < n; l++) {
            int r = l + len - 1;
            for (int j = 0; j < 2 * MAX; j++) {
                int otr = j - MAX;
                if (otr < 0) {
                    if (dp1[l + 1][j + w[l]].second + w[l] >= dp1[l][j + w[r]].second + w[r]) {
                        dp2[l][j] = {dp1[l + 1][j + w[l]].first, dp1[l + 1][j + w[l]].second + w[l]};
                    } else {
                        dp2[l][j] = {dp1[l][j + w[r]].first, dp1[l][j + w[r]].second + w[r]};
                    }
                } else {
                    if (dp1[l + 1][j - w[l]].first + w[l] >= dp1[l][j - w[r]].first + w[r]) {
                        dp2[l][j] = {dp1[l + 1][j - w[l]].first + w[l], dp1[l + 1][j - w[l]].second};
                    } else {
                        dp2[l][j] = {dp1[l][j - w[r]].first + w[r], dp1[l][j - w[r]].second};
                    }
                }
            }
        }
        swap(dp1, dp2);
    }
    cout << dp1[0][MAX].first << " " << dp1[0][MAX].second << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}