#include <bits/stdc++.h>
//#define int long long

using namespace std;

vector<int>w, pref, suf;
const int maxn = 2001;
unordered_map<int, int> dp[maxn][maxn];

int rec(int l, int r, int bal){//bal - баланс первого
    if(dp[l][r].find(bal) != dp[l][r].end()) return dp[l][r][bal];
    int bal1 = bal;
    int bal2 = pref[l-1] + suf[r+1] - bal;
    if(bal1 <= bal2){
        if(l == r) return bal+w[l];
        if(w[r] >= pref[r - 1] - pref[l - 1]) return dp[l][r][bal] = rec(l, r-1, bal+w[r]);
        if(l == r - 1) return dp[l][r][bal] = rec(l, r, bal+w[r]);
        int a1 = rec(l+1, r, bal+w[l]);
//        int a2 = rec(l, r-1, bal+w[r]);
        return dp[l][r][bal] = a1;
    } else {
        if(l == r) return bal;
        if(w[r] >= pref[r - 1] - pref[l - 1]) return dp[l][r][bal] = rec(l, r-1, bal);
        if(l == r - 1) return dp[l][r][bal] = rec(l, r, bal);
        int a1 = rec(l+1, r, bal);
//        int a2 = rec(l, r-1, bal);
        return dp[l][r][bal] = a1;
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    w.resize(n+1);
    pref.resize(n+1, 0ll);
    for(int i = 1; i <= n; i++){
        cin >> w[i];
        pref[i] = pref[i - 1] + w[i];
    }
    suf.resize(n+2, 0ll);
    for(int i = n; i >= 0; i--){
        suf[i] = suf[i + 1] + w[i];
    }
    int ans1 = rec(1, n, 0);
    int ans2 = pref[n] - ans1;
    cout << ans1 << ' ' << ans2 << '\n';
    return 0;
}
