#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <random>
#include <chrono>

using namespace std;
using ll = long long;
using ld = long double;

//#define int ll
#define all(x) x.begin(), x.end()
//#pragma GCC optimize("Ofast")
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int n;
int f(int step, deque<int>& q, set<vector<int>> s) {
	if (step == n) {
		return 0;
	}
	auto c = *s.begin();
	s.erase(s.begin());
	int ans1 = 0, ans2 = 0;
	int x = q.front();
	int y = q.back();
	q.pop_back();
	s.insert({ c[0] + y, c[1] });
	ans1 = f(step + 1, q, s);
	s.erase({ c[0] + y, c[1] });
	q.push_back(y);
	q.pop_front();
	s.insert({ c[0] + x, c[1] });
	ans2 = f(step + 1, q, s);
	s.erase({ c[0] + x, c[1] });
	q.push_front(x);
	if (c[1] == 0)
		return max(ans1 + y, ans2 + x);
	return min(ans1, ans2);
}

/*
5
1 1 3 4 6

4
1 1 2 2

4
1 7 7 9
*/

ll dp[105][505][505][2];

void smax(ll& a, ll b, ll x) {
	if (b < 0)
		return;
	if (a < b + x || a == -1) {
		a = b + x;
	}
}

void smin(ll& a, ll b) {
	if (b < 0)
		return;
	if (a > b || a == -1) {
		a = b;
	}
}

vector<int> a;

int so1() {
	deque<int> q;
	int sum = 0;
	for (int i = 0; i < n; ++i) {
		q.push_back(a[i]);
		sum += a[i];
	}
	set<vector<int>> s;
	s.insert({ 0, 0 });
	s.insert({ 0, 1 });
	int x = f(0, q, s);
	int y = sum - x;
	return x;
}

void solve() {
	cin >> n;
	int sum = 0;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		sum += a[i];
	}
	if (n == 1) {
		cout << sum << "0 ";
		return;
	}
	cout << (sum + 1) / 2 << ' ' << sum - (sum + 1) / 2;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	//cin >> t;

	for (int _ = 0; _ < t; ++_) {
		solve();
	}

}
