#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3", "unroll-loops", "fast-math")
//#pragma GCC target("avx2")

#define int long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pb push_back
#define f first
#define s second

using namespace std;
using namespace __gnu_pbds;

using pii = pair <int, int>;
using oset = tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 2e3 + 1337;
const int INF = 1e16 + 1337;
int a[N], pf[N], sf[N];
int n;

int get_ans(int i, int j, int x) {
    if (i == j - 1)
        return x;

    int wa = x, wb = pf[i] + sf[j] - x;
    if (wa <= wb)
        return max(get_ans(i + 1, j, x + a[i + 1]), get_ans(i, j - 1, x + a[j - 1]));
    return min(get_ans(i + 1, j, x), get_ans(i, j - 1, x));
}

void solve() {
    cin >> n;
    a[0] = a[n + 1] = 0;
    for (int i = 1; i <= n; i++)
        cin >> a[i];

    pf[0] = a[0];
    for (int i = 1; i <= n + 1; i++)
        pf[i] = pf[i - 1] + a[i];

    sf[n + 1] = a[n + 1];
    for (int i = n; i >= 0; i--)
        sf[i] = sf[i + 1] + a[i];

    if (n <= 10) {
        int x = get_ans(0, n + 1, 0);
        cout << x << " " << pf[n + 1] - x;
        return;
//        cout << "\n";
    }

    int sa = 0, sb = 0;
    int i = 0, j = n + 1;
    while (true) {
        bool is = (sa <= sb);
        if (a[j - 1] >= pf[j - 2] - pf[i]) {
            if (is)
                sa += a[j - 1], sb += pf[j - 2] - pf[i];
            else
                sb += a[j - 1], sa += pf[j - 2] - pf[i];
//            cout << i << "  " << j << "\n";
            break;
        } else {
            if (is)
                sa += a[++i];
            else
                sb += a[++i];
        }
    }

    cout << sa << " " << sb << "\n";
}

//5
//1 2 4 8 16

//5
//1 2 2 8 8

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}
