#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>
#include <array>
using namespace std;
using ll = long long;
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n; cin >> n; vector<int> v(n);
	for (auto& i : v) cin >> i;
	if (n == 3) {
		if (v[0] == v[2]) {
			cout << v[0] + v[2] << " " << v[1]; exit(0);
		}
		if (v[2] >= v[0] + v[1]) {
			cout << v[2] << " " << v[0] + v[1]; exit(0);
		}
		cout << v[0] + v[1] << " " << v[2]; exit(0);
	}
	int W = v.back();
	vector<vector<vector<pair<int, int>>>> dp(n,
	vector<vector<pair<int, int>>>(n, vector<pair<int, int>>(2 * W + 1)));
	for (int l = 0; l < n; l++) {
		int r = l;
		for (int i = 0; i <= 2 * W; i++) {
			if (i < W) {
				dp[l][r][i] = { 0, v[l] };
			} else {
				dp[l][r][i] = { v[l], 0 };
			}
		}
	}
	for (int ln = 1; ln < n; ln++) {
		for (int l = 0; ln + l < n; l++) {
			int r = ln + l;
			for (int i = 0; i <= 2 * W; i++) {
				if (i < W) {
					int i1 = v[l] + i, i2 = v[r] + i;
					int a = dp[l + 1][r][i1].second;
					int b = dp[l][r - 1][i2].second;
					if (a >= b) {
						dp[l][r][i] = { dp[l + 1][r][i1].first, a + v[l] };
					} else {
						dp[l][r][i] = { dp[l][r - 1][i2].first, b + v[r] };
					}
				} else {
					int i1 = i - v[l], i2 = i - v[r];
					int a = dp[l + 1][r][i1].first;
					int b = dp[l][r - 1][i2].first;
					if (a >= b) {
						dp[l][r][i] = { a + v[l], dp[l + 1][r][i1].second };
					} else {
						dp[l][r][i] = { b + v[r], dp[l][r - 1][i2].second };
					}
				}
			}
		}
	}
	cout << dp[0][n - 1][W].first << " " << dp[0][n - 1][W].second;
	return 0;
}
