#include <bits/stdc++.h>

//#define int int64_t
//#define endl '\n'

using namespace std;

const int MAXN = 4e5;
const int MAXX = 2e6;
const int MOD = 998244353;
const int INF = 1e17;
const long double EPS = 1e-6;
const long double EPS1 = 1e-7;
const int LG = 50;
const int BS = 100;
const int DIS = 2e8;

int bp(int v, int p){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp(v, p - 1) * v % MOD;
    }
    int k = bp(v, p / 2);
    return k * k % MOD;
}

int bp_md(int v, int p, int md){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp_md(v, p - 1, md) * v % md;
    }
    int k = bp_md(v, p / 2, md);
    return k * k % md;
}

int nok(int a, int b){
    return a / __gcd(a, b) * b;
}

bool is_prime(int a){
    for(int i = 2; i * i <= a; i++){
        if(a % i == 0){
            return 0;
        }
    }
    return 1;
}

mt19937 rnd(228);

vector <int> w;

map <pair<pair<int, int>, int>, int> mp;

int rec(int l, int r, int t){
    if(l > r){
        return 0;
    }
    if(mp.find({{l, r}, t}) != mp.end()){
        return mp[{{l, r}, t}];
    }
    if(t < 0){
        return mp[{{l, r}, t}] = min(rec(l + 1, r, t + w[l]) - w[l], rec(l, r - 1, t + w[r]) - w[r]);
    }
    else{
        return mp[{{l, r}, t}] = max(rec(l + 1, r, t - w[l]) + w[l], rec(l, r - 1, t - w[r]) + w[r]);
    }
}

void solve(){
    int n;
    cin >> n;
    int sm = 0;
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        sm += k;
        w.push_back(k);
    }
    int f = rec(0, n - 1, 0);
    cout << (f + sm) / 2 << ' ' << (sm - f) / 2;
}
/*
5
1 1 3 4 6

4
1 1 2 2

4
1 7 7 9
*/
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
        cout << endl;
    }
    return 0;
}
