#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int W = 20010;

int main() {
    fast;
    int n;
    cin >> n;
    vi w(n);
    for (int i = 0; i < n; ++i)
        cin >> w[i];
    vi r(n);
    r[n - 1] = w[n - 1];
    for (int i = n - 2; i >= 0; --i)
        r[i] = max(r[i + 1] - w[i + 1], w[i + 1]);
    vector<vector<vi>> a(n, vector<vi>(n)), b = a;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            a[i][j].assign(r[j] + 1, -W);
            b[i][j].assign(r[j] + 1, W);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= r[i]; ++j)
            a[i][i][j] = w[i];
        for (int j = 1; j <= r[i]; ++j)
            b[i][i][j] = 0;
    }
    for (int len = 2; len <= n; ++len) {
        for (int i = 0; i + len <= n; ++i) {
            int j = i + len - 1;
            for (int k = 0; k <= r[j]; ++k) {
                if (k >= w[i])
                    a[i][j][k] = w[i] + a[i + 1][j][k - w[i]];
                else
                    a[i][j][k] = w[i] + b[i + 1][j][w[i] - k];
                if (k >= w[j]) {
                    if (r[j - 1] >= k - w[j])
                        a[i][j][k] = max(a[i][j][k], w[j] + a[i][j - 1][k - w[j]]);
                }
                else
                    a[i][j][k] = max(a[i][j][k], w[j] + b[i][j - 1][w[j] - k]);
            }
            for (int k = 1; k <= w[j + 1]; ++k) {
                if (k > w[i])
                    b[i][j][k] = b[i + 1][j][k - w[i]];
                else
                    b[i][j][k] = a[i + 1][j][w[i] - k];
                if (k > w[j]) {
                    if (r[j - 1] >= k - w[j])
                        b[i][j][k] = min(b[i][j][k], b[i][j - 1][k - w[j]]);
                }
                else
                    b[i][j][k] = min(b[i][j][k], a[i][j - 1][w[j] - k]);
            }
        }
    }
    int sum = 0;
    for (int i = 0; i < n; ++i)
        sum += w[i];
    cout << a[0][n - 1][0] << ' ' << sum - a[0][n - 1][0] << '\n';
}
