#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

vector<int> w;
unordered_map<long long, pair<int, int>> m;

long long h(long long a, long long b, long long c) {
    return (a << 40) + (b << 20) + c;
}

void f(int l, int r, int t) {
    if (l == r) {
        if (t <= 0) m[h(l, r, t)] = {w[l], 0};
        else m[h(l, r, t)] = {0, w[l]};
        return;
    }
    if (t <= 0) {
        if (m.find(h(l + 1, r, t + w[l])) == m.end()) {
            f(l + 1, r, t + w[l]);
        }
        if (m.find(h(l, r - 1, t + w[r])) == m.end()) {
            f(l, r - 1, t + w[r]);
        }
        auto [x1, y1] = m[h(l + 1, r, t + w[l])];
        x1 += w[l];
        auto [x2, y2] = m[h(l, r - 1, t + w[r])];
        x2 += w[r];
        m[h(l, r, t)] = max(make_pair(x1, y1), {x2, y2});
    } else {
        if (m.find(h(l + 1, r, t - w[l])) == m.end()) {
            f(l + 1, r, t - w[l]);
        }
        if (m.find(h(l, r - 1, t - w[r])) == m.end()) {
            f(l, r - 1, t - w[r]);
        }
        auto [x1, y1] = m[h(l + 1, r, t - w[l])];
        y1 += w[l];
        auto [x2, y2] = m[h(l, r - 1, t - w[r])];
        y2 += w[r];
        m[h(l, r, t)] = min(make_pair(x1, y1), {x2, y2});
    }
}

int main() {
    int n;
    cin >> n;
    w.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    f(0, n - 1, 0);
    auto [x, y] = m[h(0, n - 1, 0)];
    cout << x << " " << y;
}
