//#pragma GCC optimize("Ofast, inline, unroll-loops")
#include <bits/stdc++.h>


using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

using ll = long long;

const int inf = 2e9 + 2000;
const ll infll = 2e18 + 2000;
const ll modll = 2286661337;
const int R = (1 << 19);

template<typename T>
void sort(T &s) {
    sort(all(s));
}

template<typename T>
void rsort(T &s) {
    sort(rall(s));
}

mt19937 rnd(124);

pair<int, int> max1(pair<int, int> a, pair<int, int> b) {
    if (a.first >= b.first) {
        return a;
    }
    return b;
}


pair<int, int> max2(pair<int, int> a, pair<int, int> b) {
    if (a.second >= b.second) {
        return a;
    }
    return b;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
//    cout << setprecision(20) << fixed;

    int n;
    cin >> n;

    vector<int> a(n);

    int ma = 0;

    for (auto &i : a) {
        cin >> i;
        ma = max(ma, i);
    }

    vector<vector<vector<vector<pair<int, int> > > > > dp(2, vector<vector<vector<pair<int, int> > > >(n + 1, vector<vector<pair<int, int> > > (n + 1, vector<pair<int, int> > (ma + 1))));

//    for (int i = 0; i <= n; ++i) {
//        for (int j = 0; j <= ma; ++j) {
//            dp[0][i][i][ma] = {0, 0};
//            dp[1][i][i][ma] = {0, 0};
//        }
//    }


    for (int le = 1; le <= n; ++le) {
        for (int l = 0; l < n - le + 1; ++l) {
            for (int o = 0; o <= ma; ++o) {
                int r = l + le;

                pair<int, int> pa1, pa2, pa3, pa4;

                if (a[l] > o) {
                    pa1 = dp[1][l + 1][r][a[l] - o];
                    pa1.first += a[l];
                } else {
                    pa1 = dp[0][l + 1][r][o - a[l]];
                    pa1.first += a[l];
                }

                if (a[r - 1] > o) {
                    pa2 = dp[1][l][r - 1][a[r - 1] - o];
                    pa2.first += a[r - 1];
                } else {
                    pa2 = dp[0][l][r - 1][o - a[r - 1]];
                    pa2.first += a[r - 1];
                }

                if (a[l] >= o) {
                    pa3 = dp[0][l + 1][r][a[l] - o];
                    pa3.second += a[l];
                } else {
                    pa3 = dp[1][l + 1][r][o - a[l]];
                    pa3.second += a[l];
                }

                if (a[r - 1] >= o) {
                    pa4 = dp[0][l][r - 1][a[r - 1] - o];
                    pa4.second += a[r - 1];
                } else {
                    pa4 = dp[1][l][r - 1][o - a[r - 1]];
                    pa4.second += a[r - 1];
                }


                dp[0][l][r][o] = max1(pa1, pa2);
                dp[1][l][r][o] = max2(pa3, pa4);

//                cout << dp[0][l][r][o].first << ' ' << dp[0][l][r][o].second << ' ' << dp[1][l][r][o].first << ' ' << dp[1][l][r][o].second << "\n";
            }
        }
    }

    cout << dp[0][0][n][0].first << ' ' << dp[0][0][n][0].second << "\n";
}
