#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef string str;
typedef long double ld;
mt19937 rnd(157);

#define all(a) a.begin(), a.end()
// #define int long long

vector<int> a;
unordered_map<pair<int, int>, pair<int, int>> mem;

pair<int, int> rec(int l, int r, int al, int bo) {
    if(r < l) {
        return {al, bo};
    }
    if(mem.find({l * al, r * bo}) != mem.end()) {
        return mem[{l * al, r * bo}];
    }
    if(al <= bo) {
        auto ans = max(rec(l + 1, r, al + a[l], bo), rec(l, r - 1, al + a[r], bo));
        mem[{l * al, r * bo}] = ans;
        return ans;
    } else {
        auto ans = min(rec(l + 1, r, al, bo + a[l]), rec(l, r - 1, al, bo + a[r]));
        mem[{l * al, r * bo}] = ans;
        return ans;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    a.resize(n);
    int sum1 = 0;
    for(int i = 0; i < n; i++) {
        cin >> a[i];
        sum1 += a[i];
    }
    auto ans = rec(0, n - 1, 0, 0);
    cout << ans.first << ' ' << ans.second;
}