#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>

using namespace std;

#define vec vector
#define read(x) for(auto &zu: (x))cin >> zu;
#define all(x) (x).begin(), (x).end()

using vi = vector<int>;
using str = string;
using ll = long long;
using pii = pair<int, int>;

template<typename A>
void print(A &a, str sep=" "){
    for(auto &i: a)cout << i << sep;
    cout << "\n";
}

void solve(){
    int n; cin >> n;
    vi a(n); read(a);
    int mxw = *max_element(all(a));
    vec<vi> dp(n, vi(mxw + 1, 0));
    vec<vi> pdp = dp;
    vi pref(n + 1, 0);
    for(int i = 1; i <= n; ++i)
        pref[i] = pref[i - 1] + a[i - 1];
    for(int i = 0; i < n; ++i){
        for(int j = 0; j <= mxw; ++j)
            pdp[i][j] = a[i];
    }
    for(int ln = 2; ln <= n; ++ln){
        for(int l = 0; l < n - ln + 1; ++l){
            for(int j = 0; j <= mxw; ++j){
                if(j >= a[l])
                    dp[l][j] = max(dp[l][j],
                                       a[l] + pdp[l + 1][j - a[l]]);
                else
                    dp[l][j] = max(dp[l][j],
                                       pref[l + ln] - pref[l] -
                                       pdp[l + 1][a[l] - j - 1]);
                if(j >= a[l + ln - 1])
                    dp[l][j] = max(dp[l][j],
                                       a[l + ln - 1] + pdp[l][j - a[l + ln - 1]]);
                else
                    dp[l][j] = max(dp[l][j],
                                       pref[l + ln] - pref[l]
                                       - pdp[l][a[l + ln - 1] - j - 1]);

            }

        }
        swap(pdp, dp);
    }
    cout << pdp[0][0] << " " << pref[n] - pdp[0][0] << "\n";
}


signed main() {
#ifdef LOCAL
    freopen("inp", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int TT = 1;
    //cin >> TT;
    while(TT--){
        solve();
    }
    return 0;
}
