//#pragma GCC optimize("Ofast", "unroll-loops")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;

#define vec vector
#define read(x) for(auto &zu: (x))cin >> zu;
#define all(x) (x).begin(), (x).end()

using vi = vector<int>;
using str = string;
using ll = long long;
using pii = pair<int, int>;

template<typename A>
void print(A &a, str sep=" "){
    for(auto &i: a)cout << i << sep;
    cout << "\n";
}

int n;
vi a, pref;

gp_hash_table<array<int, 3>, int> mem;

int calc(int l, int r, int j){
    if(l == r)
        return a[l];
    if(mem.find({l, r, j}) != mem.end())
        return mem[{l, r, j}];

    int res = 0;
    if(j >= a[l])
        res = max(res, a[l] + calc(l + 1, r, j - a[l]));
    else
        res = max(res, pref[r + 1] - pref[l] - calc(l + 1, r, a[l] - j - 1));
    if(j >= a[r])
        res = max(res, a[r] + calc(l, r - 1, j - a[r]));
    else
        res = max(res, pref[r + 1] - pref[l] - calc(l, r - 1, a[r] - j - 1));
    mem[{l, r, j}] = res;
    return res;
}

void solve(){
    cin >> n;
    a.resize(n); read(a);
    int mxw = *max_element(all(a));

    pref.resize(n + 1, 0);
    for(int i = 1; i <= n; ++i)
        pref[i] = pref[i - 1] + a[i - 1];

    int res = calc(0, n - 1, 0);
    cout << res << " " << pref[n] - res;
}


signed main() {
#ifdef LOCAL
    freopen("inp", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int TT = 1;
    //cin >> TT;
    while(TT--){
        solve();
    }
    return 0;
}
