#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;


//#define int long long
using ll = long long;
using ld = long double;
const ll INF = 2e9, MOD = 1e9 + 7, N = 200 + 5, K = 500 + 5;
mt19937 rnd(24246);
vector<int> a(N);
bool used[2][N][N][K];
int dp[2][N][N][K];

int rec(int p, int l, int r, int d) {
    if (used[p][l][r][d])
        return dp[p][l][r][d];
    if (p == 0) {
        int mx1 = 0, mx2 = 0;
        if (l != r) {
            if (a[l] <= d)
                mx1 = rec(0, l + 1, r, d - a[l]) + a[l];
            else
                mx1 = rec(1, l + 1, r, a[l] - d) + a[l];
            if (a[r] <= d)
                mx2 = rec(0, l, r - 1, d - a[r]) + a[r];
            else {
                mx2 = rec(1, l, r - 1, a[r] - d) + a[r];
            }
        } else {
            mx1 = a[l], mx2 = a[r];
        }
        dp[p][l][r][d] = max(mx1, mx2);
        return max(mx1, mx2);
    } else {
        int mn1 = 0, mn2 = 0;
        if (l != r) {
            if (a[l] < d)
                mn1 = rec(1, l + 1, r, d - a[l]) - a[l];
            else
                mn1 = rec(0, l + 1, r, a[l] - d) - a[l];
            if (a[r] <= d)
                mn2 = rec(1, l, r - 1, d - a[r]) - a[r];
            else {
                mn2 = rec(0, l, r - 1, a[r] - d) - a[r];
            }
        } else {
            mn1 = -a[l], mn2 = -a[r];
        }
        dp[p][l][r][d] = min(mn1, mn2);
        return min(mn1, mn2);
    }

}


void solve() {
    int n;
    cin >> n;
    a.assign(n, 0);
    int sum = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sum += a[i];
    }
    if (n == 3) {
        if (a[2] >= a[1] + a[0]) {
            cout << a[2] << " " << a[1] + a[0];
        } else {
            cout << a[0] + a[1] << " " << a[2];
        }
        return;
    } else if (a[n - 1] <= 2) {
        int al = 0, b = 0;
        while (a.size() >= 2) {
            int v = a.back();
            a.pop_back();
            int v2 = a.back();
            a.pop_back();
            if (v == v2) {
                al += v;
                b += v;
            } else {
                al += v;
                b += v2;
                if (a.size() > 0) {
                    b++;
                    a.pop_back();
                }
            }
        }
        if (!a.empty()) {
            al += a[0];
        }
        cout << al << " " << b;
    } else {
        for (int d = 0; d < n; d++) {
            for (int i = 0; i + d < n; i++) {
                for (int k = 0; k < K; k++) {
                    if (d == 0) {
                        dp[0][i][i][k] = a[i];
                        dp[1][i][i][k] = -a[i];
                    } else {
                        int mx1 = 0, mx2 = 0;
                        if (a[i] <= k)
                            mx1 = dp[0][i + 1][i + d][k - a[i]] + a[i];
                        else
                            mx1 =dp[1][i + 1][i + d][a[i] - k] + a[i];
                        if (a[i + d] <= k)
                            mx2 = dp[0][i][i + d - 1][k - a[i + d]] + a[i + d];
                        else {
                            mx2 = dp[1][i][i + d - 1][a[i + d] - k] + a[i + d];
                        }
                        int mn1 = 0, mn2 = 0;
                        if (a[i] < k)
                            mn1 = dp[1][i + 1][i + d][k - a[i]] - a[i];
                        else
                            mn1 = dp[0][i + 1][i + d][a[i] - k] - a[i];
                        if (a[i + d] < k)
                            mn2 = dp[1][i][i + d - 1][k - a[i + d]] - a[i + d];
                        else {
                            mn2 = dp[0][i][i + d - 1][a[i + d] - k] - a[i + d];
                        }
                        dp[0][i][i + d][k] = max(mx1, mx2);
                        dp[1][i][i + d][k] = min(mn1, mn2);
                    }
                }
            }
        }
        int val = dp[0][0][n - 1][0];
        cout << (sum + val) / 2 << " " << (sum - val) / 2;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
