#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

pair<int, int> cma(pair<int, int> a, pair<int, int> b) {
//    if (a.first == b.first) {
//        if (a.second < b.second) return a;
//        return b;
//    } else {
//        if (a.first > b.first) return a;
//        return b;
//    }
    if (a.first > b.first) return a;
    return b;
}

pair<int, int> cmb(pair<int, int> a, pair<int, int> b) {
//    if (a.second == b.second) {
//        if (a.first < b.first) return a;
//        return b;
//    } else {
//        if (a.second > b.second) return a;
//        return b;
//    }
    if (a.second > b.second) return a;
    return b;
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int& x : v) cin >> x;

    vector<int> pref(n + 1);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + v[i - 1];
    }

    int W = 0;
    for (int x : v) W += x;

    vector<int> suff(W + 1);
    {
        vector<int> t(1, 0);
        for (int i = n - 1; i >= 0; i--) {
            t.push_back(t.back() + v[i]);
        }
        t.push_back(W + 1);

        for (int i = 0; i <= n; i++) {
            for (int j = t[i]; j < t[i + 1]; j++) suff[j] = i;
        }
    }

    vector<vector<bool>> can(n + 1, vector<bool>(W + 1));
    can[0][0] = true;
    for (int i = 1; i <= n; i++) {
        for (int j = W; j >= 0; j--) {
            can[i][j] = can[i - 1][j] || (j >= v[i - 1] ? can[i - 1][j - v[i - 1]] : false);
        }
    }

//    for (int i = 0; i <= W; i++) cout << can[n][i] << " ";
//    cout << "\n";

    vector<vector<pair<int, int>>> dp(W + 1, vector<pair<int, int>>(n + 1, make_pair(-1e9, -1e9)));
    for (int i = 0; i <= n; i++) dp[W][i] = {W, 0};
    for (int c = W - 1; c >= 0; c--) {
        if (!can[n][c]) continue;
        for (int i = 0; i <= n; i++) {
            if (i > 0 && pref[i - 1] >= 2 * c) continue;
            if (2 * c >= W) {
                dp[c][i] = {c, W - c};
                continue;
            }
            int en = n - suff[max(0, 2 * c - pref[i])];
            if (en <= i) dp[c][i] = {c, W - c};
            else dp[c][i] = cma(dp[c + v[i]][i + 1], dp[c + v[en - 1]][i]);
        }
//        cout << c << ": ";
//        for (int i = 0; i <= n; i++) {
//            cout << dp[c][i].first << " " << dp[c][i].second << ", ";
//        }
//        cout << "\n";

        if (c != 0) {
            for (int i = n - 1; i >= 0; i--) {
                dp[c][i] = cmb(dp[c][i + 1], dp[c][i]);
            }
        }
    }

    cout << dp[0][0].first << " " << dp[0][0].second;
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) solve();
}