#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
constexpr int inf = 1e9 + 9;
constexpr ll infll = 1e18 + 9;
constexpr ld eps = 1e-6;
constexpr int N = 2e2 + 9, N1 = 5e2 + 9;
constexpr int h = 262144;
int tree[h * 2];
int ans;
void get(int v, int l, int r, int tl, int tr){
    if (l > r)
        return;
    if (tl == l && tr == r){
        ans = max(ans, tree[v]);
        return;
    }
    int tm = (tl + tr) >> 1;
    get(v * 2, l, min(r, tm), tl, tm);
    get(v * 2 + 1, max(l, tm + 1), r, tm + 1, tr);
    return;
}
int dp1[N][20009], dp2[N][20009];
int dp12[N1][5009], dp22[N1][5009];
int pref[N1];
int suf[N1];
int numb[N1];
void solve() {
    int n; cin >> n;
    int sum = 0;
    for (int i = 0; i < n; i++){
        cin >> numb[i];
        sum += numb[i];
    }
    if (n > 500) {
        cout << sum / 2 + sum % 2 << " " << sum / 2;
        return;
    }
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + numb[i - 1];
    }
    for (int i = n - 1; i >= 0; i--) {
        suf[i] = suf[i + 1] + numb[i];
    }
    if (n <= 200) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j <= 20000; j++) {
                if (suf[i + 1] + pref[i] - j >= j) {
                    dp1[i][j] = numb[i];
                }
            }
        }
        for (int it = 1; it < n; it++) {
            for (int i = 0; i < n - it; i++) {
                for (int j = 0; j <= 20000; j++) {
                    if (suf[i + it + 1] + pref[i] - j >= j) {
                        dp2[i][j] = max(dp1[i + 1][j + numb[i]] + numb[i], dp1[i][j + numb[i + it]] + numb[i + it]);
                    } else {
                        dp2[i][j] = min(dp1[i + 1][j], dp1[i][j]);
                    }
                }
            }
            swap(dp1, dp2);
        }
        cout << dp1[0][0] << " " << sum - dp1[0][0];
        return;
    }
    for (int i = 0; i < n; i++){
        for (int j = 0; j < 5009; j++){
            if (suf[i + 1] + pref[i] - j >= j){
                dp12[i][j] = numb[i];
            }
        }
    }
    for (int it = 1; it < n; it++){
        for (int i = 0; i < n - it; i++){
            for (int j = 0; j < 5009; j++){
                if (suf[i + it + 1] + pref[i] - j >= j){
                    dp22[i][j] = max(dp12[i + 1][j + numb[i]] + numb[i], dp12[i][j + numb[i + it]] + numb[i + it]);
                }
                else {
                    dp22[i][j] = min(dp12[i + 1][j], dp12[i][j]);
                }
            }
        }
        swap(dp12, dp22);
    }
    cout << dp12[0][0] << " " << sum - dp12[0][0];
    return;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
