//#pragma GCC optimize("03,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> w(n + 2);
    int sum = 0;
    for (int i = 1; i <= n; i++) {
        std::cin >> w[i];
        sum += w[i];
    }
    std::vector<std::vector<std::unordered_map<int, int>>> memo(n + 2, std::vector<std::unordered_map<int, int>>(n + 2));
    auto calc = [&](auto self, int l, int r, int t1, int t2, int turn) -> int {
        if (l > r) {
            memo[l][r][t1] = t1;
            return t1;
        }
        if (memo[l][r].find(t1) != memo[l][r].end()) {
            return memo[l][r][t1];
        }
        int res = 0;
        if (!turn) {
            res = 0;
            int t11 = w[l] + t1;
            if (t11 <= t2) {
                res = std::max(res, self(self, l + 1, r, t11, t2, 0));
            } else {
                res = std::max(res, self(self, l + 1, r, t11, t2, 1));
            }
            t11 = w[r] + t1;
            if (t11 <= t2) {
                res = std::max(res, self(self, l, r - 1, t11, t2, 0));
            } else {
                res = std::max(res, self(self, l, r - 1, t11, t2, 1));
            }
        } else {
            res = 1e9;
            int t22 = w[l] + t2;
            if (t22 < t1) {
                res = std::min(res, self(self, l + 1, r, t1, t22, 1));
            } else {
                res = std::min(res, self(self, l + 1, r, t1, t22, 0));
            }
            t22 = w[r] + t2;
            if (t22 < t1) {
                res = std::min(res, self(self, l, r - 1, t1, t22, 1));
            } else {
                res = std::min(res, self(self, l, r - 1, t1, t22, 0));
            }
        }
        memo[l][r][t1] = res;
        return res;
    };
    int f = calc(calc, 1, n, 0, 0, 0);
    int s = sum - f;
    std::cout << f << " " << s << "\n";
}

signed main() {
//    std::cin.tie(nullptr);
//    std::ios::sync_with_stdio(false);

    int t = 1;
//    std::cin >> t;

    while (t--) {
        solve();
    }
}