#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;
//--------------------------------------------------------------//
//#define int long long
#define trio pair< pair<int, int>, int>
#define td second
#define vv vector< vector<int> >
#define vvv vector< vv >
#define pii pair<int, int>
#define ft first.first
#define sd first.second
/*
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimization("Ofast")
*/
#define file_in freopen("input.txt", "r", stdin)
#define file_out freopen("output.txt", "w", stdout)
#define fast                      \
    ios_base::sync_with_stdio(0); \
    cin.tie(0);                   \
    cout.tie(0)
#define cout_float cout.setf(ios::fixed); cout.precision(15)
//-------------------------------------------------------------------//
typedef long long ll;
typedef long double ld;
typedef tree<int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update> ordered_set;
//--------------------------------------------------------------------//

const int MAXAM = 210;
const int MAXW = 510;
const int MW = 20'010;
const int MAW = 4'010;
const int INF = 1e9;

int ss;

trio make_trio(int a, int b, int c) {
    trio tr;
    tr.ft = a;
    tr.sd = b;
    tr.td = c;
    return tr;
}

vector<int> w;
map<trio, int> DP1, DP2;

int fnd(trio t, int V) {
    if (t.ft == t.sd) {
        if (V == 1) {
            DP1[t] = w[t.ft];
            return w[t.ft];
        } else {
            if (t.td > 0) {
                DP2[t] = w[t.ft];
                return w[t.ft];
            } else {
                DP2[t] = -1 * w[t.ft];
                return -1 * w[t.ft];
            }
        }
    }

    if (V == 1) {
        if (DP1.find(t) != DP1.end()) {
            return DP1[t];
        } else {
            int ans = -1 * INF;
            if (t.td >= w[t.ft]) ans = max(ans, w[t.ft] + fnd(make_trio(t.ft + 1, t.sd, t.td - w[t.ft]), 1));
            else ans = max(ans, w[t.ft] - fnd(make_trio(t.ft + 1, t.sd, w[t.ft] - t.td), 2));

            if (t.td >= w[t.sd]) ans = max(ans, w[t.sd] + fnd(make_trio(t.ft, t.sd - 1, t.td - w[t.sd]), 1));
            else ans = max(ans, w[t.sd] - fnd(make_trio(t.ft, t.sd - 1, w[t.sd] - t.td), 2));

            DP1[t] = ans;
            return ans;
        }
    } else {
        if (DP2.find(t) != DP2.end()) {
            return DP2[t];
        } else {
            int ans = -1 * INF;
            if (t.td > w[t.ft]) ans = max(ans, w[t.ft] + fnd(make_trio(t.ft + 1, t.sd, t.td - w[t.ft]), 2));
            else ans = max(ans, w[t.ft] - fnd(make_trio(t.ft + 1, t.sd, w[t.ft] - t.td), 1));

            if (t.td > w[t.sd]) ans = max(ans, w[t.sd] + fnd(make_trio(t.ft, t.sd - 1, t.td - w[t.sd]), 2));
            else ans = max(ans, w[t.sd] - fnd(make_trio(t.ft, t.sd - 1, w[t.sd] - t.td), 1));

            DP2[t] = ans;
            return ans;
        }
    }
}


signed main() {
    fast;
    int n;
    cin >> n;
    vvv dp1, dp2;
    vector<int> inner;
    bool decided = false;
    bool g2 = true;
    if (n == 3) {
        ss = MW;
        decided = true;
    }
    w.assign(n, 0);
    int W = 0;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        if (w[i] > 2) g2 = false;
        W += w[i];
    }
    if (g2 && !decided) {
        ss = 10;
        decided = true;
    }
    if (!g2 && !decided) {
        ss = MAXW;
        decided = true;
        if (n > 200) {
            int Win = fnd(make_trio(0, n - 1, 0), 1);
            cout << (W + Win) / 2 << " " << (W - Win) / 2 << "\n";
            return 0;
        }
    }

    inner.assign(ss, 0);
    dp1.assign(n, vv(n, inner));
    dp2.assign(n, vv(n, inner));


    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < ss; ++j) {
            dp1[i][i][j] = w[i];
            if (j == 0) dp2[i][i][j] = -1 * w[i];
            else dp2[i][i][j] = w[i];
        }
    }

    for (int len = 2; len <= n; ++len) {
        for (int i = 0; i <= n - len; ++i) {
            int right = i + len - 1;
            for (int extr = 0; extr < ss; ++extr) {
                dp1[i][right][extr] = -1 * INF;
                if (extr >= w[i]) dp1[i][right][extr] = max(dp1[i][right][extr], w[i] + dp1[i + 1][right][extr - w[i]]);
                else dp1[i][right][extr] = max(dp1[i][right][extr], w[i] - dp2[i + 1][right][w[i] - extr]);

                if (extr >= w[right]) dp1[i][right][extr] = max(dp1[i][right][extr], w[right] + dp1[i][right - 1][extr - w[right]]);
                else dp1[i][right][extr] = max(dp1[i][right][extr], w[right] - dp2[i][right - 1][w[right] - extr]);


                dp2[i][right][extr] = -1 * INF;
                if (extr > w[i]) dp2[i][right][extr] = max(dp2[i][right][extr], w[i] + dp2[i + 1][right][extr - w[i]]);
                else dp2[i][right][extr] = max(dp2[i][right][extr], w[i] - dp1[i + 1][right][w[i] - extr]);

                if (extr > w[right]) dp2[i][right][extr] = max(dp2[i][right][extr], w[right] + dp2[i][right - 1][extr - w[right]]);
                else dp2[i][right][extr] = max(dp2[i][right][extr], w[right] - dp1[i][right - 1][w[right] - extr]);
            }
        }
    }

    int Win = dp1[0][n - 1][0];
    cout << (W + Win) / 2 << " " << (W - Win) / 2 << "\n";
    return 0;
}
