// #define __GLIBCXX_DEBUG
// #pragma target("avx,avx2,bmi,bmi2,lzcnt,popcnt")
// #pragma optimize("unroll-loops,O3")

#include <vector>
#include <set>
#include <map>
#include <functional>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <iostream>
#include <algorithm>
#include <array>
#include <string>
#include <tuple>
#include <random>
#include <numeric>
#include <mutex>
#include <memory>
#include <locale>
#include <list>
#include <limits>
#include <iterator>
#include <functional>
#include <format>
#include <exception>
#include <ctime>
#include <ctgmath>
#include <cwchar>
#include <complex>
#include <bit>
#include <bitset>
#include <cassert>
#include <chrono>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
mt19937_64 rnd(179);

int n;
int ans1, ans2;
pair<int, int> pr;
vector<int> w;
map<tuple<int, int, int, bool>, pair<int, int>> mapa;

pair<int, int> calcDP(int l, int r, int t, bool pl) {
    if (mapa.count({l, r, t, pl})) return mapa[{l, r, t, pl}];
    pair<int, int> res = {0, 0};
    if (r >= l) {
        if (w[l] < t) {
            pr = calcDP(l + 1, r, t - w[l], pl);
        } else if (w[l] == t) {
            pr = calcDP(l + 1, r, 0, true);
        } else {
            pr = calcDP(l + 1, r, w[l] - t, !pl);
        }
        ans1 = pr.first;
        ans2 = pr.second;

        if (pl && ans1 + w[l] > res.first) {
            res = {ans1 + w[l], ans2};
        }
        if (!pl && ans2 + w[l] > res.second) {
            res = {ans1, ans2 + w[l]};
        }

        if (r != l) {
            if (w[r] < t) {
                pr = calcDP(l, r - 1, t - w[r], pl);
            } else if (w[r] == t) {
                pr = calcDP(l, r - 1, 0, true);
            } else {
                pr = calcDP(l, r - 1, w[r] - t, !pl);
            }
            ans1 = pr.first;
            ans2 = pr.second;

            if (pl && ans1 + w[r] > res.first) {
                res = {ans1 + w[r], ans2};
            }
            if (!pl && ans2 + w[r] > res.second) {
                res = {ans1, ans2 + w[r]};
            }
        }
    }
    mapa[{l, r, t, pl}] = res;
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    w.resize(n, 0);
    for (int& i : w) cin >> i;
    pr = calcDP(0, n - 1, 0, true);
    cout << pr.first << " " << pr.second << endl;
}