#include <bits/stdc++.h>
using namespace std;

vector<int> slices;
map<tuple<int, int, int, int>, pair<int, int>> dp;
pair<int, int> answer(int l, int r, int alice, int bob) {
	if (dp.find({l, r, alice, bob}) != dp.end()) return dp[{l, r, alice, bob}];
	if (r - l == 0) dp[{l, r, alice, bob}] = {0, 0};
	else if (alice == 0) {
		pair<int, int> var1 = answer(l+1, r, slices[l], bob);
		var1.first += slices[l];
		pair<int, int> var2 = {-1, -1};
		if (r - l > 1) {
			var2 = answer(l, r-1, slices[r-1], bob);
			var2.first += slices[r-1];
		}
		if (var1.first > var2.first) {
			dp[{l, r, alice, bob}] = var1;
		}
		else {
			dp[{l, r, alice, bob}] = var2;
		}
	}
	else if (bob == 0) {
		pair<int, int> var1 = answer(l+1, r, alice, slices[l]);
		var1.second += slices[l];
		pair<int, int> var2 = {-1, -1};
		if (r - l > 1) {
			var2 = answer(l, r-1, alice, slices[r-1]);
			var2.second += slices[r-1];
		}
		if (var1.second > var2.second) {
			dp[{l, r, alice, bob}] = var1;
		}
		else {
			dp[{l, r, alice, bob}] = var2;
		}
	}
	else {
		dp[{l, r, alice, bob}] = answer(l, r, alice - min(alice, bob), bob - min(alice, bob));
	}
	return dp[{l, r, alice, bob}];
}


int main() {
	int n;
	cin >> n;
	slices.resize(n);
	for (int &i: slices) {
		cin >> i;
	}
	cout << answer(0, n, 0, 0).first << " " << answer(0, n, 0, 0).second << "\n";
}