#include <bits/stdc++.h>
using namespace std;

struct h {
	size_t operator()(tuple<int, int, int, int> t) const {
		hash<int> hasher;
		auto [l, r, a, b] = t;
		return (hasher(l) << 24) ^ (hasher(r) << 16) ^ (hasher(a) << 8) ^ hasher(b);
	}
};

vector<int> slices;
unordered_map<tuple<int, int, int, int>, int, h> dp;
int answer(int l, int r, int alice, int bob) {
	if (r - l == 0) return 0;
	if (alice != 0 && bob != 0) return answer(l, r, alice - min(alice, bob), bob - min(alice, bob));
	if (dp.find({l, r, alice, bob}) != dp.end()) return dp[{l, r, alice, bob}];
	else if (alice == 0) {
		int var1 = answer(l+1, r, slices[l], bob);
		var1 += slices[l];
		if (r - l > 1) {
			int var2 = answer(l, r-1, slices[r-1], bob);
			var2 += slices[r-1];
			if (var1 < var2) {
				dp[{l, r, alice, bob}] = var2;
				return var2;
			}
		}
		dp[{l, r, alice, bob}] = var1;
		return var1;
	}
	else if (bob == 0) {
		int var1 = answer(l+1, r, alice, slices[l]);
		var1 -= slices[l];
		if (r - l > 1) {
			int var2 = answer(l, r-1, alice, slices[r-1]);
			var2 -= slices[r-1];
			if (var1 > var2) {
				dp[{l, r, alice, bob}] = var2;
				return var2;
			}
		}
		dp[{l, r, alice, bob}] = var1;
		return var1;
	}
	return dp[{l, r, alice, bob}];
}


int main() {
	int n;
	cin >> n;
	slices.resize(n);
	int s = 0;
	for (int &i: slices) {
		cin >> i;
		s += i;
	}
	int d = answer(0, n, 0, 0);
	int a = (s + d) / 2;
	int b = (s - d) / 2;
	cout << a << " " << b << "\n";
}