// In the name of Allah

#include <bits/stdc++.h>
using namespace std;

typedef		long long			ll;
typedef		long double			ld;
typedef		pair<int, int>		pii;
typedef		pair<ll, ll>		pll;

#define		endl				'\n'
#define		sep					' '
#define		all(x)				(x).begin(),(x).end()
#define		len(x)				((ll) (x).size())
#define		F					first
#define		S					second
#define		Mp					make_pair
#define		pb					push_back

int n;
const int maxn = 2000 + 4;
const int maxs = 2e4 + 4;
const int oo = 1e9 + 7;
vector<pii> dp1[maxn][maxn], dp2[maxn][maxn];
int a[maxn], sm[maxn]; int ind[maxn][maxs];

void cal1L(int l, int r, int j) {
	int w = a[l] - j;
	dp1[l][r][j].F = max(dp1[l][r][j].F, dp1[l + 1][r][w].S + a[l]);
	dp1[l][r][j].S = min(dp1[l][r][j].S, dp1[l + 1][r][w].F);
}

void cal1R(int l, int r, int j) {
	int w = a[r - 1] - j;
	dp1[l][r][j].F = max(dp1[l][r][j].F, dp2[l][r - 1][w].S + a[r - 1]);
	dp1[l][r][j].S = min(dp1[l][r][j].S, dp2[l][r - 1][w].F);
}

void cal2L(int l, int r, int j) {
	int w = a[l] - j;
	if (w >= 0) {
		dp2[l][r][j].F = max(dp2[l][r][j].F, dp1[l + 1][r][w].S + a[l]);
		dp2[l][r][j].S = min(dp2[l][r][j].S, dp1[l + 1][r][w].F);
	}
	else {
		w = abs(w);
		dp2[l][r][j].F = max(dp2[l][r][j].F, dp2[l + 1][r][w].F + a[l]);
		dp2[l][r][j].S = min(dp2[l][r][j].S, dp2[l + 1][r][w].S);
	}
}

void cal2R(int l, int r, int j) {
	if (ind[r][j] < l) return ;
	int x = ind[r][j], smx = sm[r - 1] - sm[x - 1];
	int w = smx - j;
	dp2[l][r][j].F = max(dp2[l][r][j].F, dp2[l][x][w].S + smx);
	dp2[l][r][j].S = min(dp2[l][r][j].S, dp2[l][x][w].F);
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	cin >> n; sm[0] = 0;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		sm[i] = sm[i - 1] + a[i];
	}
	a[0] = 0; a[n + 1] = a[n];

	for (int l = 1; l <= n + 1; l++) {
		for (int r = l; r <= n + 1; r++) {
			dp1[l][r].resize(a[l - 1] + 1);
			dp2[l][r].resize(a[r] + 1);
		}
	}

	for (int r = 1; r <= n + 1; r++) {
		for (int j = 0; j <= a[r]; j++) {
			ind[r][j] = 0;
			for (int x = r - 1; x >= 1; x--) {
				if (sm[r - 1] - sm[x - 1] >= j) {
					ind[r][j] = x;
					break;
				}
			}
		}
	}

	for (int ln = 0; ln <= n; ln++) {
		for (int l = 1, r = ln + 1; r <= n + 1; l++, r++) {
			for (int j = 0; j < len(dp1[l][r]); j++) {
				if (ln == 0) {
					dp1[l][r][j] = Mp(0, 0);
				}
				else {
					dp1[l][r][j] = Mp(-oo, oo);
					cal1L(l, r, j); cal1R(l, r, j);
				}
				if (j == 0) dp1[l][r][j].S = dp1[l][r][j].F;
			}
			for (int j = 0; j < len(dp2[l][r]); j++) {
				if (ln == 0) {
					dp2[l][r][j] = Mp(0, 0);
				}
				else {
					dp2[l][r][j] = Mp(-oo, oo);
					cal2L(l, r, j); cal2R(l, r, j);
				}
				if (j == 0) dp2[l][r][j].S = dp2[l][r][j].F;
			}
		}
	}
	
	int l = 1, r = n + 1;
	cout << dp1[l][r][0].F << sep << sm[n] - dp1[l][r][0].F << endl;

	return 0;
}