#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2")
#define F first
#define S second
using namespace std;

const int N = 2e3 + 10 , M = 2e4 + 10;
int n , a[N];
set <int> st[N][N];
vector <int> all[N][N];
vector <pair<int , int>> dp[N][N];

void Prep(int l , int r , int val)
{
	//cout << l << " " << r << " " << val << endl;
	if(r < l)
		return;
	if(st[l][r].find(val) != st[l][r].end())
		return;
	st[l][r].insert(val);
	if(val < 0)
	{
		Prep(l + 1 , r , val + a[l]);
		Prep(l , r - 1 , val + a[r]);
	}
	else
	{
		Prep(l + 1 , r, val - a[l]);
		Prep(l , r - 1 , val - a[r]);
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);  cout.tie(0);
	cin >> n;
	for(int i = 1 ; i <= n ; i++)
		cin >> a[i];
	Prep(1 , n , 0);
	for(int l = 1 ; l <= n ; l++)  for(int r = l ; r <= n ; r++)  for(auto u : st[l][r])
		all[l][r].push_back(u);
	for(int sz = 0 ; sz < n ; sz++)  for(int l = 1 ; l + sz <= n ; l++)
	{
		int r = l + sz;
		for(auto u : all[l][r])
		{
			if(sz == 0)
			{
				dp[l][r].push_back((u >= 0 ? make_pair(a[l] , 0) : make_pair(0 , a[l])));
				continue;
			}
			if(u < 0)
			{
				int p1 = lower_bound(all[l + 1][r].begin() , all[l + 1][r].end() , u + a[l]) - all[l + 1][r].begin();
				int p2 = lower_bound(all[l][r - 1].begin() , all[l][r - 1].end() , u + a[r]) - all[l][r - 1].begin();
				auto ans1 = dp[l + 1][r][p1];
				auto ans2 = dp[l][r - 1][p2];
				ans1.S += a[l];
				ans2.S += a[r];
				dp[l][r].push_back(min(ans1 , ans2));
			}
			else
			{
				int p1 = lower_bound(all[l + 1][r].begin() , all[l + 1][r].end() , u - a[l]) - all[l + 1][r].begin();
				int p2 = lower_bound(all[l][r - 1].begin() , all[l][r - 1].end() , u - a[r]) - all[l][r - 1].begin();
				auto ans1 = dp[l + 1][r][p1];
				auto ans2 = dp[l][r - 1][p2];
				ans1.F += a[l];
				ans2.F += a[r];
				dp[l][r].push_back(max(ans1 , ans2));
			}
		}
	}
	cout << dp[1][n].back().F << " " << dp[1][n].back().S << '\n';
	return 0;
}