#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g1, g2;
set<pair<int, int>> edges;
vector<pair<int, int>> tree_edges;
vector<int> used1;

void dfs1(int v, int n) {
    used1[v] = 1;
    for (int u = 1; u <= n; ++u) {
        if (!used1[u] && edges.find({v, u}) == edges.end()) {
            tree_edges.push_back({v, u});
            dfs1(u, n);
        }
    }
}

vector<int> used3;

void dfs3(int v) {
    used3[v] = 1;
    for (auto u : g2[v]) {
        if (!used3[u]) {
            edges.insert({v, u});
            edges.insert({u, v});
            dfs3(u);
        }
    }
}

vector<int> used, pred, r;

void dfs2(int v, int c) {
    used[v] = 1;
    pred[v] = c;
    r[c]++;
    for (auto u : g1[v]) {
        if (!used[u]) {
            dfs2(u, c);
        }
    }
}



int get(int v) {
    while (pred[v] != -1) {
        v = pred[v];
    }
    return v;
}

void merg(int v, int u) {
    v = get(v);
    u = get(u);
    if (r[v] < r[u]) {
        pred[v] = u;
        r[u] += r[v];
    } else {
        pred[u] = v;
        r[v] += r[u];
    }
}

int main() {
    int t, group;
    cin >> t >> group;
    for (int q = 0; q < t; ++q) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        g1.clear();
        g2.clear();
        g1.resize(n + 1);
        g2.resize(n + 1);
        edges.clear();
        for (int i = 0; i < m1; ++i) {
            int v, u; cin >> v >> u;
            g1[v].push_back(u);
            g1[u].push_back(v);
        }
        for (int i = 0; i < m2; ++i) {
            int v, u; cin >> v >> u;
            g2[v].push_back(u);
            g2[u].push_back(v);
        }
        used3.clear();
        used3.resize(n + 1);
        dfs3(1);
        tree_edges.clear();
        used1.clear();
        used1.resize(n + 1);
        dfs1(1, n);
       /* for (auto [v, u] : tree_edges) {
            cout << v << ' ' << u << '\n';
        }*/
        /*for (int i = 1; i <= n; ++i) {
            cout << pred[i] << ' ';
        }*/
       /* for (int i = 1; i <= n; ++i) {
            if (g2[i].size() == n - 1) {
                if (m2 == n - 1) {

                } else {
                    for (auto [v, u] : edges) {
                        if (i != v && i != u) {
                            if (v > u) {
                                swap(v, u);
                            }
                            if (u == v + 1) {
                                for (int j = 2; j <= n; ++j) {
                                    if (j == i + 1 && i - 1 >= 1) {
                                        tree_edges.push_back({j, j - 2});
                                    } else if (j != i) {
                                        tree_edges.push_back({j, j - 1});
                                    }
                                }
                                break;
                            } else {
                                for (int j = 2; j <= n; ++j) {
                                    if (j == i + 1 && i - 1 >= 1) {
                                        tree_edges.push_back({j, j - 2});
                                    } else if (j != i) {
                                        tree_edges.push_back({j, j - 1});
                                    }
                                }
                                break;
                            }
                        }
                    }
                }
            }
        }*/

        r.clear();
        used.clear();
        pred.clear();
        r.resize(n + 1);
        used.resize(n + 1);
        pred.resize(n + 1);
        for (int i = 1; i <= n; ++i) {
            if (!used[i]) {
                dfs2(i, i);
                pred[i] = -1;
            }
        }

        vector<pair<int, int>> ans;
        for (auto [v, u] : tree_edges) {
            if (get(v) != get(u)) {
                ans.push_back({v, u});
                merg(v, u);
            }
        }
        cout << "Yes" << '\n' << ans.size() << '\n';
        for (auto el : ans) {
            cout << el.first << ' ' << el.second << '\n';
        }
    }
}
