//#pragma GCC optimize("Ofast")


#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

using namespace std;
using ll = long long;
using ull = unsigned long long;

const int nMax = 3e5 + 228;


using dd = tree<pair<int, int>, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

struct dsu {
    int p[nMax], s[nMax];

    int getP(int v) {
        return (p[v] == v ? p[v] : p[v] = getP(p[v]));
    }

    void unite(int v, int u) {
        u = getP(u);
        v = getP(v);
        if (u == v)return;
        if (s[u] < s[v])swap(u, v);
        s[u] += s[v];
        p[v] = u;
    }
} d;

int g;
int n;
int m1, m2;
using num = ll;
vector<int> g1[nMax], g2[nMax];
bool gg1[3001][3001], gg2[3001][3001];

void solve2() {
    if (n == 3) {
        cout << "No\n";
        return;
    }
    for (int i = 1; i <= n; i++) {
        for (auto o: g1[i])d.unite(o, i);
    }
    vector<pair<int, int>> ans;
    for (int i = 1; i < n; i++) {
        if (d.getP(i + 1) != d.getP(i)) {
            d.unite(i, i + 1);
            ans.push_back({i, i + 1});
        }
    }
    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto o: ans)cout << o.first << ' ' << o.second << '\n';
}

void solveStar() {
    int st = -1;
    for (int i = 1; i <= n; i++) {
        if (g2[i].size() == n - 1)st = i;
    }
    if (st == -1)return;
    if (n == 3) {
        cout << "No\n";
        return;
    }
    vector<pair<int, int>> ans;
    if (st == 1) {
        ans.push_back({2, 3});
        ans.push_back({1, 2});
    } else if (st == n) {
        ans.push_back({n - 2, n - 1});
        ans.push_back({n - 1, n});
    } else {
        ans.push_back({st - 1, st + 1});
        ans.push_back({st - 1, st});
    }

    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto o: ans)cout << o.first << ' ' << o.second << '\n';
}

void solve7(int u, int v) {
    for (int i = 1; i <= n; i++) {
        for (auto o: g1[i])d.unite(o, i);
    }
    if (u > v)swap(u, v);
    set<int> k[2];
    set<int> good;
    for (auto o: g1[u])good.insert(o);
    for (auto o: g1[v])good.insert(o);
    vector<pair<int, int>> ans;
    if (count(g1[u].begin(), g1[u].end(), v) == 0)
        ans.emplace_back(u, v);
    d.unite(u, v);
    for (auto o: g2[u])k[0].insert(o);
    for (auto o: g2[v])k[1].insert(o);

    for (int i = 1; i <= n; i++) {
        if (i == u || i == v)continue;
        if (good.count(i))continue;
        if (k[0].count(i)) {
            ans.emplace_back(v, i);
        } else {
            ans.emplace_back(u, i);
        }
    }
    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto o: ans)cout << o.first << ' ' << o.second << '\n';
}

void solve() {

    cin >> n;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            gg1[i][j] = gg2[i][j] = 0;
        }
    }
    for (int i = 1; i <= n; i++) {
        g1[i].clear();
        g2[i].clear();
        d.p[i] = i;
        d.s[i] = 1;
    }
    cin >> m1 >> m2;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        gg1[u][v] = gg1[v][u] = 1;
        g1[u].push_back(v);
        g1[v].push_back(u);
    }

    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        gg2[u][v] = gg2[v][u] = 1;
        g2[u].push_back(v);
        g2[v].push_back(u);
    }
    if (m2 == (n * (n - 1)) / 2) {
        cout << "Yes\n" << n - 1 << '\n';
        for (int i = 1; i < n; i++) {
            cout << i << ' ' << i + 1 << '\n';
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (j == i)continue;
            if (gg1[i][j] == gg2[i][j]) {
                solve7(i, j);
                return;
            }
        }
    }
    int st = -1;
    for (int i = 1; i <= n; i++) {
        if (g2[i].size() == n - 1)st = i;
    }
    if (st != -1) {
        solveStar();
        return;
    }
    solve2();
}

int main() {
#ifdef VANT
    freopen("output.txt", "w", stdout);
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int q = 1;
    cin >> q >> g;
    while (q--) {
        solve();
        //    cout << '\n';
    }
}
