#include<bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define int long long
vector<pair<int,int>> prs;
void dfs1(vector<vector<int>> &g, vector<int> &colors, int u, int col) {
    colors[u] = col;
    for (auto v: g[u]) {
        if (colors[v] == 0) {
            dfs1(g, colors, v, -col);
        }else if(colors[v] != colors[u]){
            prs.push_back({u,v});
        }
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int q, g;
    cin >> q >> g;
    while (q--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        vector<vector<int>> g(n);
        vector<vector<int>> g2(n);
        vector<map<int,int>> mp1(n);
        vector<map<int,int>> mp2(n);
        for (int i = 0; i < m1; i++) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            g[u].push_back(v);
            g[v].push_back(u);
            mp1[u][v] = mp1[v][u] = true;
        }
        for (int i = 0; i < m2; i++) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            g2[u].push_back(v);
            g2[v].push_back(u);
            mp2[u][v] = mp2[v][u] = true;
        }
        prs.clear();
        vector<int> colors(n);
        dfs1(g2, colors, 0, 1);
        vector<pair<int, int>> edgs;
        vector<int> col1, col2;
        for (int i = 0; i < n; i++) {
            if (colors[i] == 1) {
                col1.push_back(i);
            } else {
                col2.push_back(i);
            }
        }
        for (int i = 1; i < col1.size(); i++) {
            if (!mp1[col1[i]][col1[i - 1]]) {
                edgs.push_back({col1[i], col1[i - 1]});
            }
        }
        for (int i = 1; i < col2.size(); i++) {
            if (!mp1[col2[i]][col2[i - 1]]) {
                edgs.push_back({col2[i], col2[i - 1]});
            }
        }
        bool check = false;
        for(int i = 0; i < n; i++){
            for(auto v : g[i]){
                if(colors[i] != colors[v]){
                    check = true;
                    break;
                }
            }
        }
        if(!check){
            if(prs.size() == 0){
                edgs.push_back({col1[0],col2[0]});
            }else{
                if(prs.size() > n - 1){
                    edgs.push_back(prs[0]);
                }else{
                    int oo = 0;
                    set<pair<int,int>> ss;
                    for(auto [u,v] : prs){
                        ss.insert({u,v});
                    }
                    for(auto i : col1){
                        for(auto j : col2){
                            pair<int,int> o = {i,j};
                            pair<int,int> o2 = {j,i};
                            if(ss.find(o) == ss.end() and ss.find(o2) == ss.end()){
                                edgs.push_back({i,j});
                                oo = 1;
                                break;
                            }
                        }
                        if(oo == 1){
                            break;
                        }
                    }
                }
            }
        }
        set<pair<int,int>> s;
        for(auto [u,v] : edgs){
            s.insert({u,v});
            s.insert({v,u});
        }
        vector<vector<int>> nwg(n),nwg2(n);
        for(int i = 0; i < n; i++){
            for(auto v : g[i]){
                if(s.find({i,v}) == s.end()){
                    nwg[i].push_back(v);
                    nwg[v].push_back(i);
                }
            }
        }
        for(int i = 0; i < n; i++){
            for(auto v : g2[i]){
                if(s.find({i,v}) == s.end()){
                    nwg2[i].push_back(v);
                    nwg2[v].push_back(i);
                }
            }
        }
        for(auto [u,v] : edgs){
            if(!mp1[u][v]){
                nwg[u].push_back(v);
                nwg[v].push_back(v);
            }
            if(!mp2[u][v]){
                nwg2[u].push_back(v);
                nwg2[v].push_back(v);
            }
        }
        vector<int> cl1(n),cl2(n);
        dfs1(nwg,cl1,0,1);
        dfs1(nwg2,cl2,0,1);
        bool ck = true;
        for(int i = 0; i < n; i++){
            if(cl1[i] == 0 or cl2[i] == 0) ck = false;
        }
        if(ck){
            cout << "Yes\n" << edgs.size() << '\n';
            for(auto [u,v] : edgs){
                cout << u + 1 << " " << v + 1 << '\n';
            }
        }else{
            cout << "No\n";
        }
    }
}