#pragma GCC optimize("O3,Ofast,inline,unroll-loops")

#include<bits/stdc++.h>
#define ft first
#define sc second
#define all(x) x.begin(),x.end()
using ll = long long;
using ld = long double;
using ul = unsigned long long;
using li = __int128;
using ui = unsigned;
using namespace std;
const ll inf = 1e18, mod = 1e9+7;
vector<int> dsu, sz;
int get(int i) {
    return (dsu[i] == i ? i : dsu[i] = get(dsu[i]));
}
map<int, vector<int>> mpv;
void merge(int i, int j) {
    i = get(i); j = get(j);
    if (i == j) return;
    if (sz[i] < sz[j]) swap(i, j);
    dsu[j] = i;
    for (auto x : mpv[j]) mpv[i].push_back(x);
    mpv[j].clear();
    sz[i] += sz[j];
}
void solve(int g) {
    int n, m1, m2, u, v;
    cin >> n >> m1 >> m2;
    mpv.clear(); dsu.clear(); sz.clear();
    dsu.resize(n); iota(all(dsu), 0); sz.assign(n, 1);
    //set<pair<int, int>> s1, s2, s3;
    int s1[n][n], s2[n][n], s3[n][n];
    for (int i = 0; i < n; i++) {for (int j = 0; j < n; j++) s1[i][j] = s2[i][j] = s3[i][j] = 0;}
    for (int i = 0; i < m1; i++) {
        cin >> u >> v; u--; v--;
        if (u > v) swap(u, v);
        s1[u][v] = 1;
        merge(u, v);
    }
    for (int i = 0; i < m2; i++) {
        cin >> u >> v; u--; v--;
        if (u > v) swap(u, v);
        s2[u][v] = 1;
    }
    if (n == 3) {
        if (m1 >= 2) {
            cout << "Yes\n0\n";
            return;
        }
        int x1, y1;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < i; j++) {
                if (s1[j][i]) {
                    x1 = j; y1 = i;
                }
            }
        }
        if (m2 == 3) {
            if (m1 == 0) {
                cout << "No\n";
                return;
            }
            cout << "Yes\n1\n" << (x1+1)%3+1 << " " << (y1+1)%3+1 << "\n";
            return;
        }
        int x, y;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < i; j++) {
                if (!s2[j][i]) {
                    x = j; y = i;
                }
            }
        }
        if (m1 == 0) {
            cout << "Yes\n2\n" << x+1 << " " << y+1 << "\n" << (x+1)%3+1 << " " << (y+1)%3+1 << "\n";
            return;
        }
        if (pair{x1, y1} == pair{x, y}) {
            cout << "No\n";
            return;
        }
        cout << "Yes\n1\n" << x+1 << " " << y+1 << "\n";
        return;
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        mpv[get(i)].push_back(i);
        for (int j = 0; j < i; j++) {
            if (!s2[j][i] && get(i) != get(j)) s3[j][i] = 1;
        }
    }
    for (int i2 = 0; i2 < n; i2++) {
        for (int j2 = 0; j2 < n; j2++) {
            if (!s3[i2][j2]) continue;
            int i = i2, j = j2;
            s2[j][i] = 1;
            s1[j][i] = 1;
            ans.push_back({j, i});
            j = get(j); i = get(i);
            for (auto x : mpv[j]) {
                for (auto y : mpv[i]) {
                    s3[min(x, y)][max(x, y)] = 1;
                }
            }
            merge(i, j);
        }
    }
    int last = -1;
    for (auto [i, mi] : mpv) {
        if (mi.size() >= 2) {
            if (last == -1) {
                last = i;
                continue;
            }
            ans.push_back({mi[0], mpv[last][0]});
            if (ans.back().ft > ans.back().sc) swap(ans.back().ft, ans.back().sc);
            s2[ans.back().ft][ans.back().sc] = 0;
            s1[ans.back().ft][ans.back().sc] = 1;
            for (auto x : mpv[last]) mpv[i].push_back(x);
            mpv[last].clear();
            last = i;
        }
    }
    vector<int> e;
    for (auto [i, mi] : mpv) {
        if (mi.size() == 1) e.push_back(i);
    }
    if (last == -1) {
        last = e.back();
        e.pop_back();
    }
    if (e.size() >= 3) {
        for (int i = 0; i < e.size()-1; i++) {
            ans.push_back({e[i], mpv[last][0]});
        }
        ans.push_back({e[e.size()-2], e.back()});
    } else if (e.size() == 2) {
        ans.push_back({e[0], mpv[last][0]});
        ans.push_back({e[1], mpv[last][1]});
    } else if (e.size() == 1) {
        int n2 = mpv[last].size();
        bool fl = 0;
        for (int i = 0; i < n2; i++) {
            if (fl) break;
            for (int j = 0; j < i; j++) {
                int i2 = mpv[last][i], j2 = mpv[last][j];
                if (i2 > j2) swap(i2, j2);
                if (s2[i2][j2]) {
                    ans.push_back({e[0], i2});
                    fl = 1;
                    break;
                }
            }
        }
        for (int i = 0; i < n2; i++) {
            if (fl) break;
            for (int j = 0; j < i; j++) {
                int i2 = mpv[last][i], j2 = mpv[last][j];
                if (i2 > j2) swap(i2, j2);
                if (!s1[i2][j2]) {
                    ans.push_back({j2, i2});
                    ans.push_back({e[0], i2});
                    fl = 1;
                    break;
                }
            }
        }
        if (!fl) {
            int i2 = mpv[last][0], j2 = mpv[last][1];
            if (i2 > j2) swap(i2, j2);
            ans.push_back({j2, i2});
            ans.push_back({e[0], i2});
        }
    }
    cout << "Yes\n" << ans.size() << "\n";
    for (auto [i, j] : ans) cout << i+1 << " " << j+1 << "\n";
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());
    //mt19937 rnd(53995);
    int t, g;
    cin >> t >> g;
    while (t--) {
        solve(g);
        cout << endl;
    }
}
