#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, less<>, null_type, tree_tag, tree_order_statistics_node_update>;
using ll = long long;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    int g;
    cin >> g;
    while (t--)
        solve();
}

void dfs(int s, vector<int> &u, vector<vector<int>> &g, vector<vector<int>> &g1) {
    u[s] = 1;
    for (int i: g[s]) {
        if (!u[i]) {
            g1[s].push_back(i);
            g1[i].push_back(s);
            dfs(i, u, g, g1);
        }
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g1(n), g2(n);
    set<pair<int, int>> f, s;

    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g1[a].push_back(b);
        g1[b].push_back(a);
        if (a > b)
            swap(a, b);
        f.insert({a, b});
        f.insert({b, a});
    }

    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g2[a].push_back(b);
        g2[b].push_back(a);
        s.insert({a, b});
        s.insert({b, a});
    }

    auto g1x = g1, g2x = g2;

    auto s1 = s;

    vector<vector<int>> gx(n);
    vector<int> u(n);

    dfs(0, u, g2, gx);

    swap(g2, gx);

    vector<pair<int, int>> v;
    for (int i = 0; i < n; i++) {
        v.push_back({g2[i].size(), i});
    }
    vector<pair<int, int>> ans;
    sort(all(v));
    reverse(all(v));
    if (v[0].first == n - 1 && n > 3) {
        int x = g2[v[0].second].back();
        g2[v[0].second].pop_back();
        int y = 0;
        while (y == v[0].second || y == x)
            y++;
        g2[x] = {y};
        if (s.find({x, y}) == s.end()) {
            ans.push_back({x, y});
            s.insert({x, y});
            s.insert({y, x});
            if (f.find({x, y}) != f.end()) {
                f.erase({x, y});
                f.erase({y, x});
            } else {
                f.insert({x, y});
                f.insert({y, x});
            }
        }
    }
    s.clear();
    for (int i = 0; i < n; i++) {
        for (int j: g2[i])
            s.insert({i, j});
    }

    vector<vector<int>> g3(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (s.find({i, j}) == s.end())
                g3[i].push_back(j);
        }
    }

    vector<vector<int>> g4(n);
    u.clear();
    u.resize(n);
    dfs(0, u, g3, g4);

    for (int i = 0; i < n; i++) {
        for (int j: g4[i]) {
            if (j > i && f.find({i, j}) == f.end())
                ans.push_back({i, j});
        }
    }


    for (auto [x, y]: ans) {
        f.insert({x, y});
        f.insert({y, x});
    }

    s = s1;

    for (auto [x, y]: ans) {
        if (s.find({x, y}) != s.end()) {
            s.erase({x, y});
            s.erase({y, x});
        } else {
            s.insert({x, y});
            s.insert({y, x});
        }
    }

    g1.clear();
    g1.resize(n);
    for (auto [x, y]: f) {
        g1[x].push_back(y);
    }

    u.clear();
    u.resize(n);

    dfs(0, u, g1, g4);

    if (*min_element(all(u)) == 0) {
        cout << "No\n";
        return;
    }

    dfs(0, u, g2, g4);

    g2.clear();
    g2.resize(n);
    for (auto [x, y]: s) {
        g2[x].push_back(y);
    }

    u.clear();
    u.resize(n);

    dfs(0, u, g2, g4);

    if (*min_element(all(u)) == 0) {
        cout << "No\n";
        return;
    }

    cout << "Yes\n";
    if (ans.size() > n)
        exit(1);
    cout << ans.size() << '\n';
    for (auto i: ans)
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
}
