#include <bits/stdc++.h>
using namespace std;
#define int int64_t
#define double long double
#define MULTITASK
#define NO_INTERACTIVE
void solve();
int32_t main() {
#ifdef BIBIKOV
    clock_t tStart = clock();
#ifdef NO_INTERACTIVE
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
#endif
#ifdef NO_INTERACTIVE
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int32_t tt = 1, g;
#ifdef MULTITASK
    cin >> tt >> g;
#endif
    while (tt--) {
        solve();
#ifdef NO_INTERACTIVE
        cout << '\n';
#endif
    }
#ifdef BIBIKOV
    fprintf(stderr, ">> Runtime: %.10fs\n", (double_t) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
const int64_t INF = 1e18, inf = 2e9, mod = 998244353;






vector<pair<int, int>> p;
vector<set<int>> g1, g2, o;
//set<pair<int, int>> s;
vector<int> c;

void dfs(int u) {
    c[u] = 1;
    for (int v : g2[u]) if (!c[v]) {
        o[u].insert(v);
        o[v].insert(u);
//        s.insert({u, v});
        dfs(v);
    }
}

void add(int u, int v) {
    p.push_back({u + 1, v + 1});
    if (g1[u].contains(v))
        g1[u].erase(v), g1[v].erase(v);
    else
        g1[u].insert(v), g1[v].insert(u);
    if (g2[u].contains(v))
        g2[u].erase(v), g2[v].erase(v);
    else
        g2[u].insert(v), g2[v].insert(u);
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g1.clear();
    g2.clear();
    p.clear();
    o.clear();
//    s.clear();
    c.clear();
    g1.resize(n);
    g2.resize(n);
    o.resize(n);
    c.resize(n);
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g1[u].insert(v);
        g1[v].insert(u);
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g2[u].insert(v);
        g2[v].insert(u);
    }
    if (n == 3) {
        int mx = 0;
        for (int i = 0; i < n; i++)
            mx = max(mx, (int) g1[i].size());
        if (mx == 2)
            cout << "Yes" << '\n' << 0;
        else
            cout << "No";
        return;
    }
    dfs(0);
    int mx = 0, h;
    for (int i = 0; i < n; i++)
        mx = max(mx, (int) o[i].size()), h = (mx == o[i].size() ? i : h);
    if (mx == n - 1) {
        for (int i = 0; i < n; i++) if (i != h) {
            if (g2[i].size() != 1) {
                o[h].erase(i);
                o[i].erase(h);
                g2[i].erase(h);
                int x = *g2[i].begin();
                g2[i].insert(h);
                o[i].insert(x);
                o[x].insert(i);
                mx--;
                break;
            }
        }
    }
    if (mx == n - 1) {
        int u = (h + 1) % n, v = (h + 2) % n;
        if (!g2[u].contains(v))
            add(u, v);
        o[u].insert(v);
        o[v].insert(u);
        o[h].erase(u);
        o[u].erase(h);
    }
    set<int> st = {0, n}, k = {n};
//    for (int i = 1; i < n; i++)
//        k.insert(i);
//    for (int i = 0; i < n; i++) if (st.contains(i)) {
//        int x = -1;
//        for (auto l = st.begin(); l != k.end() && o[i].contains(*l); l++)
//            x = *l;
//        x = *st.upper_bound(x);
//        if (x != n) {
//
//        }
//    }
    for (int i = 0; i < n; i++) if (!st.contains(i)) {
        int x = -1;
        for (auto l = st.begin(); l != st.end() && o[i].contains(*l); l++)
            x = *l;
        x = *st.upper_bound(x);
        if (x != n && (!o[i].contains(x) || g1[i].contains(x))) {
            st.insert(i);
            if (!g1[i].contains(x))
                add(i, x);
            for (x = *k.begin(); x < n; x = *k.upper_bound(x)) {
                if (!o[i].contains(x) || g1[i].contains(x)) {
                    if (!g1[i].contains(x))
                        add(i, x);
                    k.erase(x);
                }
            }
        } else {
            k.insert(i);
        }
    }
    if (n < p.size())
        exit(139);
    cout << "Yes" << '\n';
    cout << p.size() << '\n';
    for (auto [u, v] : p)
        cout << u << ' ' << v << '\n';
}
