#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define deb(x) cerr << #x << '\t' << x << '\n';

mt19937 rnd(time(nullptr));

constexpr ll INF = 1e18;

vector<vector<ll>>g;
vector<bool>used;

void dfs(ll v) {
	used[v] = true;
	for (auto to : g[v]) {
		if (!used[to]) {
			dfs(to);
		}
	}
}

void solve() {
	ll n, m1, m2; cin >> n >> m1 >> m2;
	g.assign(n, {});
	for (int i = 0; i < m1; i++) {
		ll a, b; cin >> a >> b;
		g[--a].emplace_back(--b);
	}
	used.assign(n, false);
	dfs(0);
	set<pair<ll, ll>>ed;
	for (int i = 0; i < m2; i++){
		ll u, v; cin >> u >> v;
		ed.insert({--u, --v});
		ed.insert({v, u});
	}
	pair<ll, ll>ans = {-1, -1};
	for (int v = 0; v < n; v++) {
		for (int u = v + 1; u < n; u++) {
			if ((used[v] && !used[u]) || (!used[v] && used[u])) {
				if (ed.find({v, u}) == ed.end()) {
					ans = {v, u};
				}
			}
		}
	}
	if (ans.first == -1) {
		cout << "No";
	} else {
		cout << "Yes\n";
		cout << 1 << '\n';
		cout << ans.first + 1 << ' ' << ans.second + 1;
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int T = 1, g;
	cin >> T >> g;
	while (T--)	{
		solve();
		cout << '\n';
	}
	return 0;
}
