#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define int ll
#define pii pair<int, int>
void fastios() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g1(n);
    vector<vector<int>> g2(n);
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g1[a].push_back(b);
        g1[b].push_back(a);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g2[a].push_back(b);
        g2[b].push_back(a);
    }
    if (m1 == 0) {
        cout << "Yes" << endl;
        cout << n - 1 << endl;
        for (int i = 1; i <= n - 1; i++)
            cout << i << ' ' << i + 1 << endl;
        return;
    }
    int gl = -1;
    for (int i = 0; i < n; i++) {
        if (!g1[i].empty()) {
            gl = i;
            break;
        }
    }
    vector<pii> ans;
    set<int> what;
    for (auto to : g1[gl])
        what.insert(to);
    for (int i = 0; i < n; i++) {
        if (i == gl || what.find(i) != what.end()) continue;
        ans.push_back({gl, i});
    }
    cout << "Yes" << endl;
    for (auto [x, y] : ans)
        cout << x + 1 << ' ' << y + 1 << endl;
}


signed main() {
    int tt, g;
    tt = 1;
    fastios();
    cin >> tt >> g;
    while (tt--)
        solve();
}