#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define int ll
#define pii pair<int, int>
void fastios() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void solve2() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g1(n);
    vector<vector<int>> g2(n);
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g1[a].push_back(b);
        g1[b].push_back(a);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g2[a].push_back(b);
        g2[b].push_back(a);
    }
    if (m1 == 0 && n >= 4) {
        cout << "Yes" << endl;
        cout << n - 1 << endl;
        for (int i = 1; i <= n - 1; i++)
            cout << i << ' ' << i + 1 << endl;
        return;
    } else if (m1 == 0) {
        cout << "No" << endl;
        return;
    }
    int gl = -1;
    for (int i = 0; i < n; i++) {
        if (!g1[i].empty()) {
            gl = i;
            break;
        }
    }
    vector<pii> ans;
    set<int> what;
    for (auto to : g1[gl])
        what.insert(to);
    for (int i = 0; i < n; i++) {
        if (i == gl || what.find(i) != what.end()) continue;
        ans.push_back({gl, i});
    }
    cout << "Yes" << endl;
    cout << ans.size() << endl;
    for (auto [x, y] : ans)
        cout << x + 1 << ' ' << y + 1 << endl;
}

void dfs(int v, vector<vector<int>> &g, vector<bool> &used, vector<int> &comp) {
    used[v] = true;
    for (auto to : g[v]) {
        if (used[to]) continue;
        dfs(to, g, used, comp);
    } 
    comp.push_back(v);
}

void solve3() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g1(n);
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g1[a].push_back(b);
        g1[b].push_back(a);
    }
    vector<vector<int>> g2(n);
    vector<vector<int>> m(n, vector<int>(n));
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g2[a].push_back(b);
        g2[b].push_back(a);
        m[a][b] = 1;
        m[b][a] = 1;
    }
    vector<bool> used(n, false);
    vector<int> cmp1;
    vector<int> cmp2;
    dfs(0, g1, used, cmp1);
    for (int i = 0; i < n; i++) {
        bool f1 = true;
        for (auto to : cmp1) {
            if (to == i) {
                f1 = false;
                break;
            }
        } 
        if (f1)
            cmp2.push_back(i);
    }
    for (auto v : cmp1) {
        for (auto to : cmp2) {
            if (m[v][to] == 0) {
                cout << "Yes" << endl;
                cout << 1 << endl;
                cout << v + 1 << ' ' << to + 1 << endl;
                return;
            }
        }
    }
    cout << "No" << endl;
    return;
}

signed main() {
    int tt, g;
    tt = 1;
    fastios();
    cin >> tt >> g;
    if (g == 2) {
        while (tt--)
            solve2();
    } else if (g == 3) {
        while (tt--)
            solve3();
    }
}