#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>

using namespace std;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t, group;
    cin >> t >> group;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        vector<unordered_set<int>> g1(n);
        vector<unordered_set<int>> g2(n);
        int u, v;
        for (int i = 0; i < m1; ++i) {
            cin >> u >> v;
            u--;
            v--;
            g1[u].insert(v);
            g1[v].insert(u);
        }
        for (int i = 0; i < m2; ++i) {
            cin >> u >> v;
            u--;
            v--;
            g2[u].insert(v);
            g2[v].insert(u);
        }
        int f = -1, s = -1;
        for (int i = 0; i < n; ++i) {
            bool find = false;
            for (auto q : g1[i]) {
                if (g2[i].find(q) != g2[i].end()) {
                    f = i;
                    s = q;
                    find = true;
                    break;
                }
            }
            if (find) {
                break;
            } else {
                if ((int)g1[i].size() + (int)g2[i].size() != n - 1) {
                    for (int q = 0; q < n; ++q) {
                        if (g1[i].find(q) == g1[i].end() && g2[i].find(q) == g2[i].end()) {
                            f = i;
                            s = q;
                            find = true;
                            break;
                        }
                    }
                    if (find) {
                        break;
                    }
                }
            }
        }
        if (f != -1) {
            cout << "Yes" << endl;
            vector<pair<int, int>> ans;
            for (int i = 0; i < n; ++i) {
                if (i != s && i != f) {
                    if (g1[s].find(i) == g1[s].end() || g1[f].find(i) == g1[f].end()) {
                        if (g2[s].find(i) == g2[s].end()) {
                            ans.push_back({s + 1, i + 1});
                        } else {
                            ans.push_back({f + 1, i + 1});
                        }
                    }
                }
            }
            cout << (int)ans.size() << '\n';
            for (auto [q, w] : ans) {
                cout << q << " " << w << '\n';
            }
        } else {
            cout << "soon" << '\n';
        }
    }
}
