#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

void sol2() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> st;
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if (a > b) {
            swap(a, b);
        }
        st.insert({a, b});
    }
    for (int i = 0; i < m2; i++)  {
        int a, b;
        cin >> a >> b;
    }
    if (n == 3) {
        if (m1 == 0) {
            cout << "No" << '\n';
            return;
        }
        cout << "Yes" << '\n';
        if (st.size() == 2) {
            cout << "0" << '\n';
            return;
        }
        auto [a, b] = *st.begin();
        a = (a + 1) % 3;
        b = (b + 1) % 3;
        cout << "1" << '\n' << a + 1 << " " << b + 1 << '\n';
        return;
    }

    vector<pair<int, int>> ans;
    for (int i = 0; i < n - 1; i++) {
        if (st.find({i, i + 1}) == st.end()) {
            ans.push_back({i, i + 1});
        }
    }
    cout << "Yes" << '\n';
    cout << ans.size() << '\n';
    for (auto [a, b] : ans) {
        cout << a + 1 << " " << b + 1 << '\n';
    }
}

int main()
{
    int t, g;
    cin >> t >> g;
    for (int i = 0; i < t; i++) {
        sol2();
    }
    return 0;
}
