#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
using namespace __gnu_pbds;

#define int long long


vector<vector<int>> g1;
vector<vector<int>> g2;
vector<int> p;
int comps = 0;

int led(int a) {
    if (p[a] == -1) {
        return a;
    }
    return p[a] = led(p[a]);
}

void unite(int a, int b) {
    a = led(a);
    b = led(b);
    if (a == b) {
        return;
    }
    p[a] = b;
    comps--;
}

void solve1() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    int c = n * (n - 1) / 2;
    g1.resize(n, vector<int>(n));
    g2.resize(n, vector<int>(n));
    p.clear();
    p.resize(n, -1);;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g1[u][v] = 1;
        g1[v][u] = 1;
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g2[u][v] = 1;
        g2[v][u] = 1;
    }
    vector<pair<int, int>> e;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            e.push_back({i, j});
        }
    }
    c = e.size();
    for (int mask = 0; mask < (1 << c); mask++) {
        int tmp = 0;
        for (int i = 0; i < c; i++) {
            if (mask & (1 << i)) {
                g1[e[i].first][e[i].second] ^= 1;
                g1[e[i].second][e[i].first] ^= 1;
                g2[e[i].first][e[i].second] ^= 1;
                g2[e[i].second][e[i].first] ^= 1;
                tmp++;
            }
        }
        if (tmp > n) {
            for (int i = 0; i < c; i++) {
                if (mask & (1 << i)) {
                    g1[e[i].first][e[i].second] ^= 1;
                    g1[e[i].second][e[i].first] ^= 1;
                    g2[e[i].first][e[i].second] ^= 1;
                    g2[e[i].second][e[i].first] ^= 1;
                }
            }
            continue;
        }
        comps = n;
        p.clear();
        p.resize(n, -1);
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (g1[i][j]) {
                    unite(i, j);
                }
            }
        }
        if (comps != 1) {
            for (int i = 0; i < c; i++) {
                if (mask & (1 << i)) {
                    g1[e[i].first][e[i].second] ^= 1;
                    g1[e[i].second][e[i].first] ^= 1;
                    g2[e[i].first][e[i].second] ^= 1;
                    g2[e[i].second][e[i].first] ^= 1;
                }
            }
            continue;
        }
        comps = n;
        p.clear();
        p.resize(n, -1);;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (g2[i][j]) {
                    unite(i, j);
                }
            }
        }
        if (comps != 1) {
            for (int i = 0; i < c; i++) {
                if (mask & (1 << i)) {
                    g1[e[i].first][e[i].second] ^= 1;
                    g1[e[i].second][e[i].first] ^= 1;
                    g2[e[i].first][e[i].second] ^= 1;
                    g2[e[i].second][e[i].first] ^= 1;
                }
            }
            continue;
        }
        cout << "Yes\n" << tmp << '\n';
        for (int i = 0; i < c; i++) {
            if (mask & (1 << i)) {
                cout << e[i].first + 1 << ' ' << e[i].second + 1 << '\n';
            }
        }
        return;
    }
    cout << "No\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1, G;
    cin >> tt >> G;
    while (tt--) {
        if (G == 1 || G == 0) {
            solve1();
            p.clear();
            g1.clear();
            g2.clear();
        }
        cout << '\n';
    }
}