#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
using namespace __gnu_pbds;

#define int long long


void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> tmp1(n, vector<int>(n));
    vector<vector<int>> tmp2(n, vector<int>(n));
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        tmp1[u][v] = 1;
        tmp1[v][u] = 1;
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        tmp2[u][v] = 1;
        tmp2[v][u] = 1;
    }
    vector<pair<int, int>> e;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            e.push_back({i, j});
        }
    }
    int c = e.size();
    for (int mask = 0; mask < (1 << c); mask++) {
        vector<vector<int>> g1 = tmp1;
        vector<vector<int>> g2 = tmp2;
        int tmp = 0;
        for (int i = 0; i < c; i++) {
            if (mask & (1 << i)) {
                tmp++;
                int u = e[i].first, v = e[i].second;
                g1[u][v] = 1 - g1[u][v];
                g1[v][u] = 1 - g1[v][u];
                g2[u][v] = 1 - g2[u][v];
                g2[v][u] = 1 - g2[v][u];
            }
        }
        vector<int> used(n, false);
        used[0] = 1;
        queue<int> q;
        q.push(0);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int i = 0; i < n; i++) {
                if (g1[v][i] && !used[i]) {
                    used[i] = true;
                    q.push(i);
                }
            }
        }
        bool ok = true;
        for (auto i: used) {
            if (!i) {
                ok = false;
                break;
            }
        }
        if (!ok) continue;
        used.clear();
        used.resize(n, false);
        used[0] = 1;
        q.push(0);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (int i = 0; i < n; i++) {
                if (g2[v][i] && !used[i]) {
                    used[i] = true;
                    q.push(i);
                }
            }
        }
        for (auto i: used) {
            if (!i) {
                ok = false;
                break;
            }
        }
        if (!ok) continue;
        cout << "Yes\n";
        vector<pair<int, int>> otv;
        for (int i = 0; i < c; i++) {
            if (mask & (1 << i)) {
                otv.push_back(e[i]);
            }
        }
        cout << otv.size() << '\n';
        for (auto i : otv) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
        return;
    }
    cout << "No\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1, G;
    cin >> tt >> G;
    while (tt--) {
        solve();
        cout << '\n';
    }
}