#include <bits/stdc++.h>

using namespace std;

#define int long long

struct pnt {
    int v, w;
//    const operator < (pnt b) {
//        return v < b.v;
//    }
};

const int N = 3e3 + 1;

vector<vector<int>> g1(N);
vector<vector<int>> g2(N);

vector<int> comp(N), first, sec;
int cur = 1;
int a, b;

void dfs(int v) {
    comp[v] = cur;
    if (cur == 1) first.push_back(v);
    else sec.push_back(v);
    for (auto u : g1[v]) {
        if (!comp[u]) {
            dfs(u);
        }
    }
}

vector<bool> used(N);

void check(int v) {
    used[v] = 1;
    for (auto u : g2[v]) {
        if ((v == a && u == b) || (v == b && u == a)) continue;
        if (!used[u]) {
            check(u);
        }
    }
}

void solve() {
    int n, g;
    cin >> n;
    int m1, m2;
    cin >> m1 >> m2;
    for (int i = 0; i < m1; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g1[u].push_back(v);
        g1[v].push_back(u);
    }
    for (int i = 0; i < m2; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g2[u].push_back(v);
        g2[v].push_back(u);
    }
    for (int i = 0; i < n; i++) {
        if (!comp[i]) {
            dfs(i);
            cur++;
        }
    }
    for (int i = 0; i < first.size(); i++) {
        for (int j = 0; j < sec.size(); j++) {
            a = first[i];
            b = sec[j];
            check(0);
            bool f = 1;
            for (int i = 0; i < n; i++) {
                if (!used[i]) {
                    f = 0;
                }
                used[i] = 0;
            }
            if (f) {
                cout << "YES\n1\n";
                cout << a + 1 << ' ' << b + 1 << '\n';
                return;
            }
        }
    }
    cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int z = 1, g;
    cin >> z >> g;
    if (g != 3) return 0;
    while (z--) {
        solve();
    }
}
