#include<bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

struct graph
{
    set<pair<int, int>> st;

    bool exi(int v, int u)
    {
        if(v > u)
        {
            swap(v, u);
        }

        if(st.find({v, u}) == st.end())
        {
            return false;
        }
        return true;
    }

    void add(int v, int u)
    {
        if(v > u)
        {
            swap(v, u);
        }
        if(exi(v, u))
        {
            st.erase({v, u});
        } else {
            st.insert({v, u});
        }
    }
};

vector<pair<int, int>> ANS;

void dfs(int v, vector<vector<int>> &mat, vector<bool> &used, set<int> &st)
{
    used[v] = true;
    st.insert(v);
    for(int i = 0; i < mat[v].size(); ++i)
    {
        if(mat[v][i] == 1 && !used[i])
        {
            dfs(i, mat, used, st);
        }
    }
}

set<int> dost(int v, vector<vector<int>> &mat)
{
    vector<bool> used(4);
    set<int> st;
    dfs(v, mat, used, st);
    return st;
}

bool podm(set<int> a, set<int> b)
{
    for(auto i : a)
    {
        if(b.find(i) == b.end())
        {
            return false;
        }
    }
    return true;
}

bool kek(vector<vector<int>> &m1, vector<vector<int>> &m2, vector<vector<int>> &m3, vector<vector<int>> m4)
{
    set<int> ful{0, 1, 2, 3};
    if(!podm(ful, dost(0, m3)))
    {
        return false;
    }
    for(int i = 0; i < 4; ++i)
    {
        if(!podm(dost(i, m2), dost(i, m4)))
        {
            return false;
        }
    }
    return true;

}

void add_reb(pair<int, int> a, vector<vector<int>> &m)
{
    m[a.first][a.second] *= -1;
    m[a.second][a.first] *= -1;
}

void fun(vector<int> vec, graph &g1, graph &g2)
{
    vector<vector<int>> m1(4, vector<int>(4, -1));
    vector<vector<int>> m2(4, vector<int>(4, -1));

    for(int i = 0; i < 4; ++i)
    {
        for(int j = 0; j < 4; ++j)
        {
            if(i == j || g1.exi(vec[i], vec[j]))
            {
                m1[i][j] = 1;
            }
            if(i == j || g2.exi(vec[i], vec[j]))
            {
                m2[i][j] = 1;
            }
        }
    }

    if(kek(m1, m2, m1, m2))
    {
        return;
    }

    vector<pair<int, int>> reb;
    for(int i = 0; i < 4; ++i)
    {
        for(int j = 1; j < 4; ++j)
        {
            if(i == 0 && j == 1)
            {
                continue;
            }
            reb.emplace_back(i, j);
        }
    }

    vector<vector<int>> m3 = m1;
    vector<vector<int>> m4 = m2;

    for(int i = 0; i < reb.size(); ++i)
    {
        add_reb(reb[i], m3);
        add_reb(reb[i], m4);

        if(kek(m1, m2, m3, m4))
        {
            ANS.emplace_back(vec[reb[i].first], vec[reb[i].second]);
            g1.add(vec[reb[i].first], vec[reb[i].second]);
            g2.add(vec[reb[i].first], vec[reb[i].second]);
            return;
        }

        add_reb(reb[i], m3);
        add_reb(reb[i], m4);
    }
    for(int i = 0; i < reb.size(); ++i)
    {
        for(int j = 0; j < reb.size(); ++j)
        {
            if(i == j)
            {
                continue;
            }
            add_reb(reb[i], m3);
            add_reb(reb[i], m4);
            add_reb(reb[j], m3);
            add_reb(reb[j], m4);

            if(kek(m1, m2, m3, m4))
            {
                ANS.emplace_back(vec[reb[i].first], vec[reb[i].second]);
                g1.add(vec[reb[i].first], vec[reb[i].second]);
                g2.add(vec[reb[i].first], vec[reb[i].second]);
                ANS.emplace_back(vec[reb[j].first], vec[reb[j].second]);
                g1.add(vec[reb[j].first], vec[reb[j].second]);
                g2.add(vec[reb[j].first], vec[reb[j].second]);
                return;
            }

            add_reb(reb[i], m3);
            add_reb(reb[i], m4);
            add_reb(reb[j], m3);
            add_reb(reb[j], m4);
        }
    }
}

bool podh(graph &g1, graph &g2)
{
    for(int i = 0; i < ANS.size(); ++i)
    {
        int v = ANS[i].first;
        int u = ANS[i].second;

        g1.add(v, u);
        g2.add(v, u);
    }

    int cnt1 = 0;
    int cnt2 = 0;

    if(g1.exi(0, 1))
    {
        ++cnt1;
    }
    if(g1.exi(0, 2))
    {
        ++cnt1;
    }
    if(g1.exi(2, 1))
    {
        ++cnt1;
    }

    if(g2.exi(0, 1))
    {
        ++cnt2;
    }
    if(g2.exi(0, 2))
    {
        ++cnt2;
    }
    if(g2.exi(2, 1))
    {
        ++cnt2;
    }

    if(cnt1 >= 2 && cnt2 >= 2)
    {
        return true;
    }

    for(int i = 0; i < ANS.size(); ++i)
    {
        int v = ANS[i].first;
        int u = ANS[i].second;

        g1.add(v, u);
        g2.add(v, u);
    }

    return false;



}


void solve()
{
    ANS.clear();

    int n, m1, m2;
    cin >> n >> m1 >> m2;

    if(n == 3)
    {
        graph g1, g2;
        for(int i = 0; i < m1; ++i)
        {
            int v, u;
            cin >> v >> u;
            --v;
            --u;
            g1.add(v, u);
        }
        for(int i = 0; i < m2; ++i)
        {
            int v, u;
            cin >> v >> u;
            --v;
            --u;
            g2.add(v, u);
        }

        ANS = {};
        if(podh(g1, g2))
        {
            cout << "Yes\n";
            cout << ANS.size() << '\n';
            for(int i = 0; i < ANS.size(); ++i)
            {
                cout << ANS[i].first + 1<< ' ' << ANS[i].second + 1 << '\n';
            }
            return;
        }

        ANS = {{0, 1}};
        if(podh(g1, g2))
        {
            cout << "Yes\n";
            cout << ANS.size() << '\n';
            for(int i = 0; i < ANS.size(); ++i)
            {
                cout << ANS[i].first + 1<< ' ' << ANS[i].second + 1 << '\n';
            }
            return;
        }

        ANS = {{0, 2}};
        if(podh(g1, g2))
        {
            cout << "Yes\n";
            cout << ANS.size() << '\n';
            for(int i = 0; i < ANS.size(); ++i)
            {
                cout << ANS[i].first + 1<< ' ' << ANS[i].second + 1 << '\n';
            }
            return;
        }

        ANS = {{1, 2}};
        if(podh(g1, g2))
        {
            cout << "Yes\n";
            cout << ANS.size() << '\n';
            for(int i = 0; i < ANS.size(); ++i)
            {
                cout << ANS[i].first + 1<< ' ' << ANS[i].second + 1 << '\n';
            }
            return;
        }

        ANS = {{0, 1}, {0, 2}};
        if(podh(g1, g2))
        {
            cout << "Yes\n";
            cout << ANS.size() << '\n';
            for(int i = 0; i < ANS.size(); ++i)
            {
                cout << ANS[i].first + 1<< ' ' << ANS[i].second + 1 << '\n';
            }
            return;
        }

        ANS = {{0, 1}, {1, 2}};
        if(podh(g1, g2))
        {
            cout << "Yes\n";
            cout << ANS.size() << '\n';
            for(int i = 0; i < ANS.size(); ++i)
            {
                cout << ANS[i].first + 1<< ' ' << ANS[i].second + 1 << '\n';
            }
            return;
        }

        ANS = {{1, 2}, {0, 2}};
        if(podh(g1, g2))
        {
            cout << "Yes\n";
            cout << ANS.size() << '\n';
            for(int i = 0; i < ANS.size(); ++i)
            {
                cout << ANS[i].first + 1<< ' ' << ANS[i].second + 1 << '\n';
            }
            return;
        }

        ANS = {{0, 1}, {0, 2}, {1, 2}};
        if(podh(g1, g2))
        {
            cout << "Yes\n";
            cout << ANS.size() << '\n';
            for(int i = 0; i < ANS.size(); ++i)
            {
                cout << ANS[i].first + 1<< ' ' << ANS[i].second + 1 << '\n';
            }
            return;
        }

        cout << "No\n";
        return; 

        
    }

    graph g1, g2;

    int A = -1, B = -1;

    for(int i = 0; i < m1; ++i)
    {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g1.add(v, u);

        A = v;
        B = u;
    }
    vector<int> deg(n);
    for(int i = 0; i < m2; ++i)
    {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g2.add(v, u);
        deg[v] += 1;
        deg[u] += 1;
    }

    if(m1 == 0)
    {
        if(m2 == n * (n - 1) / 2)
        {
            A = 0;
            B = 1;
            g1.add(0, 1);
            g2.add(0, 1);
            ANS.emplace_back(0, 1);
        } else {
            for(int i = 0; i < n; ++i)
            {
                if(deg[i] != n-1)
                {
                    if(A == -1)
                    {
                        A = i;
                    } else {
                        B = i;
                        break;
                    }
                }
            }
            g1.add(A, B);
            g2.add(A, B);
        }
    }

    vector<bool> used(n);
    used[A] = true;
    used[B] = true;

    int cnt = n -2;

    int x = 0, y = 0;

    while(cnt > 0)
    {
        if(cnt == 1)
        {
            while(used[x])
            {
                ++x;
            }

            fun(vector<int>{A, B, x, y}, g1, g2);
            --cnt;
            used[x] = true;
        } else {
            while(used[x])
            {
                ++x;
            }
            y = x + 1;
            while(used[y])
            {
                ++y;
            }

            fun(vector<int>{A, B, x, y}, g1, g2);
            used[x] = true;
            used[y] = true;
            cnt -= 2;
        }
    }

    cout << "Yes\n";
    cout << ANS.size() << '\n';
    for(int i = 0; i < ANS.size(); ++i)
    {
        cout << ANS[i].first + 1<< ' ' << ANS[i].second + 1 << '\n';
    }



}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);


    int t, g;
    cin >> t >> g;
    for(int i = 0; i < t; ++i)
    {
        solve();
    }
}