#include <bits/stdc++.h>
#define int long long

using namespace std;

void dfs(int u, vector<vector<int>>& g, vector<int>& was) {
    if (was[u]) return;
    was[u] = 1;
    for (int i = 0; i < g[u].size(); ++i) {
        if (g[u][i]) {
            dfs(i, g, was);
        }
    }
}

void solve1() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g(n, vector<int>(n));
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u][v] = g[v][u] = 1;
    }
    vector<vector<int>> g2(n, vector<int>(n));
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g2[u][v] = g2[v][u] = 1;
    }
    for (int mask = 0; mask < (1ll << (n * (n - 1) / 2)); ++mask) {
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (mask & (1ll << (i * n + j - i - 1))) {
                    g[i][j] = g[j][i] ^= 1;
                    g2[i][j] = g2[j][i] ^= 1;
                }
            }
        }
        vector<int> was1(n), was2(n);
        dfs(0, g, was1);
        dfs(0, g2, was2);
        if (min(*min_element(was1.begin(), was1.end()), *min_element(was2.begin(), was2.end())) == 1) {
            cout << "Yes\n";
            cout << __builtin_popcount(mask) << "\n";
            for (int i = 0; i < n; ++i) {
                for (int j = i + 1; j < n; ++j) {
                    if (mask & (1ll << (i * n + j - i - 1))) {
                        cout << i + 1 << " " << j + 1 << "\n";
                    }
                }
            }
            return;
        }
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (mask & (1ll << (i * n + j - i - 1))) {
                    g[i][j] = g[j][i] ^= 1;
                    g2[i][j] = g2[j][i] ^= 1;
                }
            }
        }
    }
    cout << "No\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, g;
    cin >> t >> g;
    while (t--) {
        if (g <= 1)
            solve1();
//        else if (g == 2)
//            sol
    }
}
