#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("03")
#pragma GCC target("avx2")
#endif

using namespace std;

using ll = long long;
using ld = long double;

using pld = pair<ld, ld>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using vin = vector<int>;
using vll = vector<ll>;
using vld = vector<ld>;
using vbo = vector<bool>;
using vpl = vector<pll>;
using vpi = vector<pii>;
using vpd = vector<pld>;

using vvi = vector<vin>;
using vvl = vector<vll>;
using vvo = vector<vbo>;

#define sz(a) (ll)a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for(int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for (auto &i : a)

#define fastio ios_base::sync_with_stdio(false);cin.tie(0)

ll n, m1, m2, g;
vll p;
vpl edges1, edges2;
vvl depth;
map<pll, bool> con1, con2, secured;
vbo contains;
vvl tree;
vpl ans;

ll get(ll v) {
    return p[v] < 0 ? v : p[v] = get(p[v]);
}

void join(ll v, ll u) {
    v = get(v);
    u = get(u);
    if (v == u) {
        return;
    }
    if (p[v] > p[u]) {
        swap(v, u);
    }
    p[v] += p[u];
    p[u] = v;
}

void add_ans(ll v, ll u) {
    if (!con1[{min(v, u), max(v, u)}]) {
        ans.pub({v, u});
        con1[{min(v, u), max(v, u)}] = true;
        if (con2[{min(v, u), max(v, u)}]){
            con2[{min(v, u), max(v, u)}] = false;
        } else {
            con2[{min(v, u), max(v, u)}] = true;
        }
    }
    secured[{min(v, u), max(v, u)}] = true;
}

bool add_ans_2(ll v, ll u){
    if (!con2[{min(v, u), max(v, u)}]){
        if (!secured[{min(v, u), max(v, u)}]){
            ans.pub({v, u});
            con2[{min(v, u), max(v, u)}] = true;
            return true;
        }
        return false;
    }
    return true;
}

void dfs(ll v, ll pv = -1, ll d = 0) {
    if (sz(depth) == d) {
        depth.emplace_back();
    }
    depth[d].pub(v);
    if (sz(depth) > 1 && sz(depth[1]) == 1) {
        contains[v] = true;
    }
    each(u, tree[v]) {
        if (u == pv) {
            continue;
        }
        dfs(u, v, d + 1);
    }
}

void solve() {
    cin >> n >> m1 >> m2;
    p.clear();
    depth.clear();
    edges1.clear();
    edges2.clear();
    contains.clear();
    con1.clear();
    con2.clear();
    ans.clear();
    tree.clear();
    secured.clear();
    p.resize(n, -1);
    edges1.resize(m1);
    edges2.resize(m2);
    tree.resize(n);
    contains.resize(n, false);
    F0R(i, m1) {
        ll v, u;
        cin >> v >> u;
        v--;
        u--;
        join(v, u);
        edges1[i] = {min(v, u), max(v, u)};
        con1[{min(v, u), max(v, u)}] = true;
    }
    F0R(i, m2) {
        ll v, u;
        cin >> v >> u;
        v--;
        u--;
        edges2[i] = {min(v, u), max(v, u)};
        con2[{min(v, u), max(v, u)}] = true;
    }
    bool good = true;
    F0R(i, n - 1){
        if (get(i) != get(i + 1)){
            good = false;
            break;
        }
    }
    if (good){
        cout << "Yes\n";
        cout << 0 << '\n';
        return;
    }
    p.assign(n, -1);
    sor(edges1);
    sor(edges2);
    F0R(i, m2) {
        if (get(edges2[i].first) != get(edges2[i].second)) {
            join(edges2[i].first, edges2[i].second);
            tree[edges2[i].first].pub(edges2[i].second);
            tree[edges2[i].second].pub(edges2[i].first);
        }
    }
    dfs(0);
    bool found = false;
    if (sz(depth) > 3) {
        FOR(i, 1, sz(depth)){
            F0R(j, sz(depth[i]) - 1){
                add_ans(depth[i][j], depth[i][j + 1]);
            }
        }
        add_ans(depth[1][0], depth[3][0]);
        FOR(i, 2, sz(depth)) {
            add_ans(depth[i][0], depth[0][0]);
        }
        found = true;
    } else {
        F0R(i, sz(depth[1])){
            if (con1[{0, depth[1][i]}] == con2[{0, depth[1][i]}]){
                add_ans(depth[1][i], depth[0][0]);
                found = true;

                break;
            }
        }
        if (!found){
            add_ans(depth[1][0], depth[0][0]);
        }
        FOR(i, 2, sz(depth)) {
            add_ans(depth[i][0], depth[0][0]);
        }
        FOR(i, 1, sz(depth)){
            F0R(j, sz(depth[i]) - 1){
                add_ans(depth[i][j], depth[i][j + 1]);
            }
        }
        vll l, r;
        F0R(i, sz(depth)){
            bool b1 = false, b2 = false;
            F0R(j, sz(depth[i])){
                if (contains[depth[i][j]]){
                    l.pub(depth[i][j]);
                }
                if (!contains[depth[i][j]]){
                    r.pub(depth[i][j]);
                }
            }
        }
        F0R(i, sz(depth)){
            if (found){
                break;
            }
            F0R(j, n){
                if (contains[j]){
                    F0R(k, sz(r)){
                        if (add_ans_2(j, r[k])){
                            found = true;
                            break;
                        }
                    }
                } else {
                    F0R(k, sz(l)){
                        if (add_ans_2(j, l[k])){
                            found = true;
                            break;
                        }
                    }
                }
                if (found){
                    break;
                }
            }
            if (found){
                break;
            }
        }
    }
    if (found){
        cout << "Yes\n";
        if (sz(ans) > n){
            exit(-1);
        }
        cout << sz(ans) << '\n';
        R0F(i, sz(ans)){
            cout << ans[i].first + 1 << ' ' << ans[i].second + 1 << '\n';
        }
    } else {
        cout << "No\n";
    }
}

int main() {
    fastio;
    ll t;
    cin >> t >> g;
    F0R(i, t) {
        solve();
    }
    return 0;
}
