#include <bits/stdc++.h>
using namespace std;

#define int long long
using ll = long long;
#define forn(i,n) for(int i=0;i<n;++i)
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];
#define pb push_back
#define all(x) x.begin(),x.end()
#define pi pair<int,int>
#define f first
#define s second

const ll inf = 1e18;

int n,g;

struct DSU {
	vector<int> p,sz;
	DSU(int n) {
		forn(i,n) p.pb(i),sz.pb(1);
	}
	int get(int u) {
		return p[u]==u?u:get(p[u]);
	}
	void uni(int u, int v) {
		u=get(u),v=get(v);
		if (u==v) return;
		if (sz[u]<sz[v]) swap(u,v);
		p[v]=u;
		sz[u]+=sz[v];
	}
};

const int N=5;
int g1[N][N];
int g2[N][N];
bitset<N> vis;

void f1(int u) {
	if (vis[u]) return;
	vis[u]=1;
	forn(i,N) {
		if (g1[u][i]) f1(i);
	}
}
void f2(int u) {
	if (vis[u]) return;
	vis[u]=1;
	forn(i,N) {
		if (g2[u][i]) f2(i);
	}
}



void solve() {

	cin>>n;
	int m1,m2; cin>>m1>>m2;
	if (n==3) {
		int x1=0,x2=0;
		forn(i,m1) {
			int u,v; cin>>u>>v; 
			int t=u+v-3;
			x1|=1<<t;
		}
		forn(i,m2) {
			int u,v; cin>>u>>v; 
			int t=u+v-3;
			x2|=1<<t;
		}
		if ((x1^x2)==7) {
			cout<<"No\n"; return;
		} 
		if (m1>=2) {
			cout<<"Yes\n0\n"; return;
		}
		if (m1==0) {
			cout<<"Yes\n";
			cout<<"2\n";
			if (x2==3) cout<<"2 3\n1 2\n";
			if (x2==5) cout<<"1 3\n1 2\n";
			if (x2==6) cout<<"1 2\n1 3\n";
			return;
		}
		if (x2==7) {
			cout<<"Yes\n";
			cout<<"1\n";
			if (x1==1) cout<<"2 3\n";
			if (x1==2) cout<<"2 3\n";
			if (x1==4) cout<<"1 2\n";
			return;
		}
		cout<<"Yes\n";
		cout<<"1\n";
		if (x2==3) cout<<"2 3\n";
		if (x2==5) cout<<"1 3\n";
		if (x2==6) cout<<"1 2\n";
		return;
	}
	if (g<=-1) {
		forn(i,n) forn(j,n) g1[i][j]=g2[i][j]=0;
		forn(i,m1) {
			int u,v; cin>>u>>v; --u, --v;
			g1[u][v]=g1[v][u]=1;
		}
		forn(i,m2) {
			int u,v; cin>>u>>v; --u, --v;
			g2[u][v]=g2[v][u]=1;
		}
		int m=(n-1)*n/2;
		vector<pi> e;
		forn(i,n) forn(j,i) e.pb({i,j});
		vector<int> ans;
		forn(mask,1<<m) {
			//cout<<"!!!!!!!????? "<<mask<<'\n';
			//forn(i,n) {
			//	forn(j,n) cout<<g2[i][j]; cout<<'\n';
			//}
			int bad=0;
			int cnt=0;
			forn(i,m) {
				if ((mask>>i)&1); else continue;
				++cnt;
				int u=e[i].f, v=e[i].s;
				g1[u][v]^=1;
				g1[v][u]^=1;
				g2[u][v]^=1;
				g2[v][u]^=1;
				vis.reset();
				f2(0);
				int z=0;
				forn(j,n) z+=vis[j];
				if (z<n) bad=1;
				//cout<<"????? "<<mask<<' '<<i<<' '<<z<<'\n';
				//forn(i,n) {
				//	forn(j,n) cout<<g2[i][j]; cout<<'\n';
				//}
			}
			vis.reset();
			f1(0);
			int z=0;
			forn(i,n) z+=vis[i];
			//cout<<"? "<<mask<<' '<<cnt<<' '<<z<<' '<<bad<<'\n';
			//forn(i,n) {
			//	forn(j,n) cout<<g1[i][j]; cout<<'\n';
			//}
			forn(i,m) {
				if ((mask>>i)&1); else continue;
				int u=e[i].f, v=e[i].s;
				g1[u][v]^=1;
				g1[v][u]^=1;
				g2[u][v]^=1;
				g2[v][u]^=1;
			}
			if (z<n) bad=1;
			if (bad) continue;
			if (cnt>n) continue;
			cout<<"Yes\n";
			vector<pi> ans;
			forn(i,m) if ((mask>>i)&1) ans.pb(e[i]);
			cout<<ans.size()<<'\n';
			for(auto&x:ans) cout<<x.f+1<<' '<<x.s+1<<'\n';
			return;
		}
		cout<<"No\n"; return;
	}
	if (g==2) {
		DSU dsu(n);
		forn(i,m1) {
			int u,v; cin>>u>>v; --u, --v;
			dsu.uni(u,v);
		}
		forn(i,m2) {
			int a,b; cin>>a>>b;
		}
		if (m1==0) {
			if (n==3) {
				cout<<"No\n"; return;
			}
			cout<<"Yes\n";
			cout<<n-1<<'\n';
			forn(i,n-2) cout<<1<<' '<<i+2<<'\n';
			cout<<2<<' '<<n<<'\n';
		} else {
			cout<<"Yes\n";
			vector<pi> ans;
			for(int i=1; i<n; ++i) {
				if (dsu.get(0)==dsu.get(i)) continue;
				dsu.uni(0,i);
				ans.pb({1,i+1});
			}
			cout<<ans.size()<<'\n';
			for(auto&x:ans) cout<<x.f<<' '<<x.s<<'\n';
		}
		return;
	}
	if (g==9) {
		map<pi,int> e;
		forn(i,m1) {
			int u,v; cin>>u>>v;
			if (u>v) swap(u,v);
			e[{u,v}]=1;
		}
		forn(i,m2) {
			int a,b; cin>>a>>b;
		}
		vector<pi> ans;
		forn(i,n-2) {
			if (!e[{i+1,n}]) ans.pb({i+1,n});
		}
		if (!e[{1,n-1}]) ans.pb({1,n-1});
		cout<<"Yes\n";
		cout<<ans.size()<<'\n';
		for(auto&x:ans) cout<<x.f<<' '<<x.s<<'\n';
		return;
	}
	if (g==5) {
		map<pi,int> e;
		forn(i,m1) {
			int u,v; cin>>u>>v;
			if (u>v) swap(u,v);
			e[{u,v}]=1;
		}
		forn(i,m2) {
			int a,b; cin>>a>>b;
		}
		vector<pi> ans;
		for(int i=2; i<n; ++i) {
			if (!e[{i,n}]) ans.pb({i,n});
		}
		if (ans.size()==0) {
			for (int i=2; i<n; ++i) {
				for(int j=i+1; j<n; ++j) {
					if (e[{i,j}]) continue;
					ans.pb({i,j});
					ans.pb({1,i});
					break;
				}
				if (ans.size()) break;
			}
			if (ans.size()==0) {
				if (e[{1,n}]) cout<<"Yes\n0\n";
				else cout<<"No\n"; return;
			}
			cout<<"Yes\n";
			cout<<ans.size()<<'\n';
			for(auto&x:ans) cout<<x.f<<' '<<x.s<<'\n';
		} else {
			if (!e[{1,n}]) ans.pb({1,n});
			cout<<"Yes\n";
			cout<<ans.size()<<'\n';
			for(auto&x:ans) cout<<x.f<<' '<<x.s<<'\n';
		}
		return;
	}

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	cin>>t>>g;
	while (t--) solve();
}