#include <bits/stdc++.h>

using namespace std;

#define int long long

set<pair<int, int>> st_m1, st_m2;
vector<int> used(300005);
vector<pair<int, int>> ans;

void dfs(int s) {
    used[s] = 1;
    for (int i = 0; i < used.size(); ++i) {
        if (used[i] == 0 && i != s && !(st_m2.find({min(s, i), max(s, i)}) != st_m2.end() && st_m1.find({min(s, i), max(s, i)}) == st_m1.end())) {
            if (st_m1.find({min(s, i), max(s, i)}) == st_m1.end()) {
                ans.emplace_back(min(s, i), max(s, i));
            }
            dfs(i);
        }
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    used.assign(n, 0);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        st_m1.insert({min(v, u), max(v, u)});
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        st_m2.insert({min(v, u), max(v, u)});
    }
    dfs(0);
    if (count(used.begin(), used.end(), 0) == 0) {
        cout << "Yes\n" << ans.size() << '\n';
        for (auto &i: ans) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
    } else {
        cout << "No\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int ttt = 1, group;
    cin >> ttt >> group;
    while (ttt--) {
        solve();
    }
    return 0;
}
