#pragma GCC optimize("Ofast,inline")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define fi first
#define se second
#define int ll
mt19937 gen(time(0));

bool min_ost(vector <int> &ve) {
    int n = ve.size();
    vector <int> p(n + 1), sz(n + 1);
    for(int i = 1; i <= n; ++i) {
        p[i] = i;
        sz[i] = 1;
    }
    auto pr = [&](int v) {
        while(v != p[v]) {
//            cerr << v << ' ' << p[v] << endl;
            v = p[v];
        }
//        cerr << v << endl;
        return v;
    };
    for(int i = 1; i < ve.size(); ++i) {
        int v = ve[i-1], u = ve[i];
//        cerr << v << ' ' << u << endl;
        if(pr(v) == pr(u))
            return 0;
        int V = pr(v), U = pr(u);
        if(sz[V] < sz[U])
            swap(V, U);
        sz[V] += sz[U];
        p[U] = V;
    }
    return 1;
}

int n;
map <pair<int,int>,bool> mp2;
bool check2() {
    vector <int> p(n + 1), sz(n + 1);
    for(int i = 1; i <= n; ++i) {
        p[i] = i;
        sz[i] = 1;
    }
    auto pr = [&](int v) {
        while(v != p[v]) {
//            cerr << v << ' ' << p[v] << endl;
            v = p[v];
        }
//        cerr << v << endl;
        return v;
    };
    for(auto to : mp2) {
        if(to.se == 0)
            continue;
        int v = to.fi.fi, u = to.fi.se;
//        cerr << v << ' ' << u << endl;
        if(pr(v) == pr(u))
            return 0;
        int V = pr(v), U = pr(u);
        if(sz[V] < sz[U])
            swap(V, U);
        sz[V] += sz[U];
        p[U] = V;
    }
    int boss = pr(1);
    if(sz[boss] != n)
        return 0;
    return 1;
}

const int N = 3e5 + 12;
int sz[N], p[N];
int get_p(int v) {
    if(p[v] == v)
        return v;
    return p[v] = get_p(p[v]);
}
bool merge(int a, int b) {
    int v = get_p(a), u = get_p(b);
    if(v == u)
        return 0;
    if(sz[v] < sz[u])
        swap(v, u);
    sz[v] += sz[u];
    p[u] = v;
    return 1;
}

void solve() {
    int m1, m2;
    cin >> n >> m1 >> m2;
    vector <pair<int,int>> e1;
    for(int i = 0; i < m1; ++i) {
        int v, u;
        cin >> v >> u;
        if(v > u)
            swap(v, u);
        e1.push_back({v, u});
    }
    mp2.clear();
    vector <pair<int,int>> e2;
    for(int i = 0; i < m2; ++i) {
        int v, u;
        cin >> v >> u;
        if(v > u)
            swap(v, u);
        mp2[ {v,u}] = 1;
        e2.push_back({v, u});
    }
    vector <int> ve;
    for(int i = 1; i <= n; ++i) {
        ve.push_back(i);
    }
    int it = 0;
    while(it < 1000) {
        it++;
        shuffle(ve.begin(), ve.end(), gen);
        if(!min_ost(ve))
            continue;
        bool ok = 1;
        for(int i = 1; i <= n; ++i) {
            p[i] = i;
            sz[i] = 1;
        }
        for(auto to : e1) {
            if(!merge(to.fi, to.se))
                continue;
        }
        vector <pair<int,int>> ans;
        vector <pair<int,int>> used;
        for(int i = 1; i < ve.size(); ++i) {
            int v = ve[i-1], u = ve[i];
            if(v > u)
                swap(v, u);
            if(!merge(v, u))
                continue;
            if(v > u)
                swap(v, u);
            mp2[{v,u}] ^= 1;
            used.push_back({v, u});
            if(!check2()) {
                ok = 0;
                break;
            }
            ans.push_back({v, u});
        }
        for(auto to : used) {
            mp2[to] ^= 1;
        }
        if(!ok)
            continue;
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for(auto to : ans) {
            cout << to.fi << ' ' << to.se << '\n';
        }
        return;
    }
    cout << "No\n";
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int qq, G;
    cin >> qq >> G;
    while(qq--) {
        solve();
    }
    return 0;
}


