//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>
#include <bits/extc++.h>


using namespace std;
using namespace __gnu_pbds;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define endl '\n'
#define pint pair<int, int>
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int group;

vector<bool> used;
void dfs(int v, vector<vector<int>>& g) {
    used[v] = true;
    for(auto& u : g[v]) {
        if (!used[u]) {
            dfs(u, g);
        }
    }
}

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    vector<vector<int>> g1(n + 1), g2(n + 1);
    set<int> used1, used2;
    map<pint, int> to;
    vector<pint> from;

    forn(i, 1, n + 1) {
        forn(j, i + 1, n + 1) {
            from.push_back(mp(i, j));
            to[mp(i, j)] = to[mp(j, i)] = from.size() - 1;
        }
    }

    forn(i, 0, m1) {
        int v, u;
        cin >> v >> u;
        g1[v].push_back(u);
        g1[u].push_back(v);
        used1.insert(to[mp(v, u)]);
    }

    forn(i, 0, m2) {
        int v, u;
        cin >> v >> u;
        g2[v].push_back(u);
        g2[u].push_back(v);
        used2.insert(to[mp(v, u)]);
    }

    if (group == 1) {
        forn(mask, 0, 1LL << (n * (n - 1) / 2)) {
            set<int> nxt1, nxt2;
            forn(i, 0, n * (n - 1) / 2) {
                if ((mask >> i) & 1) {
                    if (!used1.count(i)) nxt1.insert(i);
                    if (!used2.count(i)) nxt2.insert(i);
                } else {
                    if (used1.count(i)) nxt1.insert(i);
                    if (used2.count(i)) nxt2.insert(i);
                }
            }
            vector<vector<int>> gr1(n + 1), gr2(n + 1);
            for(auto& u : nxt1) {
                gr1[from[u].first].push_back(from[u].second);
                gr1[from[u].second].push_back(from[u].first);
            }
            bool ok = true;
            used.assign(n + 1, false);
            dfs(1, gr1);
            forn(i, 1, n + 1) {
                ok &= used[i];
            }
            for(auto& u : nxt2) {
                gr2[from[u].first].push_back(from[u].second);
                gr2[from[u].second].push_back(from[u].first);
            }
            used.assign(n + 1, false);
            dfs(1, gr1);
            forn(i, 1, n + 1) {
                ok &= used[i];
            }

            if (ok) {
                cout << "Yes\n";
                vector<pint> ans;
                forn(i, 0, n * (n - 1) / 2) {
                    if ((mask >> i) & 1) {
                        ans.push_back(mp(from[i].first, from[i].second));
                    }
                }
                cout << ans.size() << endl;
                forn(i, 0, ans.size()) {
                    cout << ans[i].first << " " << ans[i].second << endl;
                }
                return;
            }
        }
    }
    cout << "No\n";
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t >> group;
    while (t--) solve();

    return 0;
}
