#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(101);

vector<ll> lead, sz;

ll leader(ll u) {
    if (lead[u] == u)
        return u;
    else
        return lead[u] = leader(lead[u]);
}

bool merged;

void merge(ll a, ll b) {
    a = leader(a), b = leader(b);
    if (a == b)
        return;
    merged = 1;
    if (sz[a] < sz[b])
        swap(a, b);
    lead[b] = a;
    sz[a] += sz[b];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll _, gr, n, m1, m2, u, v;
    cin >> _ >> gr;
    while (_--) {
        cin >> n >> m1 >> m2;

        merged = 0;
        lead.resize(n);
        sz.assign(n, 1);
        iota(lead.begin(), lead.end(), 0);
        set<pair<ll, ll>> help;

        ll h = -1;
        for (int i = 0; i < m1; ++i) {
            cin >> u >> v, u--, v--;
            help.insert({min(u, v), max(u, v)});
            merge(u, v);
            h = u;
        }

        bool dubl = 0;
        set<pair<ll, ll>> g2;
        for (int i = 0; i < m2; ++i) {
            cin >> u >> v, u--, v--;
            if (help.count({min(u, v), max(u, v)}))
                dubl = 1;
            g2.insert({u, v});
            g2.insert({v, u});
        }

        vector<pair<ll, ll>> ans;

        for (ll i = 0; i < n && sz[leader(0)] < n; ++i)
            for (ll j = i + 1; j < n; ++j) {
                if (!g2.count({i, j}) && leader(i) != leader(j)) {
                    merge(i, j);
                    if (!help.count({i, j}))
                        ans.push_back({i, j});
                    h = i;
                }
            }

        if (n == 3 && !dubl) {
            cout << "No\n";
            continue;
        }

        if (h == -1) {
            cout << "Yes\n";
            cout << ans.size() << '\n';
            for (auto p: ans)
                cout << p.F + 1 << ' ' << p.S + 1 << '\n';
            continue;
        }

        for (int i = 0; i < n; ++i)
            if (leader(i) != leader(h)) {
                merge(i, h);
                if (!help.count({i, h}))
                    ans.push_back({i, h});
            }

        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto p: ans)
            cout << p.F + 1 << ' ' << p.S + 1 << '\n';
    }
}
/*
3 0
3 0 3
1 2
2 3
1 3
4 2 3
1 2
3 4
1 3
1 4
2 3
4 3 3
1 2
2 3
1 3
1 4
2 4
3 4

*/
/*

*/
/*

*/
/*
Есть два графа.
 Мы можем инвертировать наличие ребра между двумя вершинами в обоих графах за раз не более чем н раз.

Мы каждое ребро инвертируем не более раза.
Мы сначала инвертируем ребра которых нету во втором графе, а потом которые есть.
Мы не будем инвертировать ребра которые есть и там и там.

Скорее всего ответ есть всегда когда у нас более трех вершин.

Эх. Очень хочется лажу написать.

Первый граф можно представить пустым.
Жадно попытаемся соеденять СНМом вершины со следующими если они не соеденены во втором графе.
У нас получилось несколько компонент связности.
Каждая вершина каждой компоненты связанна с каждой вершиной каждой другой компоненты.
Допустим в двух компонентах хотя-бы по двум вершинам. Тогда мы можем объеденять эти компоненты любым способом так-как все кайфово.
 Если это не так, то одиночная вершина компоненты связанна со всеми остальными вершинами впринципе.
 Если есть какая-то другая не еденичная компонента, то можно соединять текущую вершину с любой вершиной той множественной компоненты.

Осталось разобрать вариант когда все компоненты еденичные.
 Здесь можно соеденить все вершины первого графа покругу.


*/
/*

*/
