#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(101);

vector<ll> lead, sz;

ll leader(ll u) {
    if (lead[u] == u)
        return u;
    else
        return lead[u] = leader(lead[u]);
}

void merge(ll a, ll b) {
    a = leader(a), b = leader(b);
    if (a == b)
        return;
    if (sz[a] < sz[b])
        swap(a, b);
    lead[b] = a;
    sz[a] += sz[b];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll _, gr;
    cin >> _ >> gr;
    while (_--) {
        ll n, m1, m2, u, v;
        cin >> n >> m1 >> m2;
        lead.resize(n);
        iota(lead.begin(), lead.end(), 0);
        sz.assign(n, 1);
        set<pair<ll, ll>> g1, g2;
        for (int i = 0; i < m1; ++i) {
            cin >> u >> v, u--, v--;
            g1.insert({u, v}), g1.insert({v, u});
        }
        for (int i = 0; i < m2; ++i) {
            cin >> u >> v, u--, v--;
            g2.insert({u, v}), g2.insert({v, u});
        }

        if (n == 3) {
            vector<pair<ll, ll>> ans;
            if (!g1.count({0, 1}) && !g2.count({0, 1}))
                ans.push_back({1, 2}), g1.insert({0, 1}), g2.insert({0, 1});
            if (!g1.count({0, 2}) && !g2.count({0, 2}))
                ans.push_back({1, 3}), g1.insert({0, 2}), g2.insert({0, 2});
            if (!g1.count({2, 1}) && !g2.count({2, 1}))
                ans.push_back({3, 2}), g1.insert({2, 1}), g2.insert({2, 1});

            for (auto p: g1)
                merge(p.F, p.S);
            bool b1 = sz[leader(0)] == 3;
            lead.resize(n);
            iota(lead.begin(), lead.end(), 0);
            sz.assign(n, 1);
            for (auto p: g2)
                merge(p.F, p.S);
            bool b2 = sz[leader(0)] == 3;
            if (!b1 || !b2) {
                cout << "No\n";
                continue;
            } else {
                cout << "Yes\n" << ans.size() << '\n';
                for (auto p: ans)
                    cout << p.F << ' ' << p.S << '\n';
                continue;
            }
        }

        vector<pair<ll, ll>> need1, need2, ans;
        set<pair<ll, ll>> bad;
        for (int i = 0; i + 1 < n; ++i)
            need1.push_back({i, i + 1}), bad.insert({i, i + 1}), bad.insert({i + 1, i});
        for (int i = 0; i < n && sz[leader(0)] < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (bad.count({i, j}) || leader(i) == leader(j))
                    continue;
                need2.push_back({i, j});
                merge(i, j);
            }
        }

        if (sz[leader(0)] < n) {
            cout << "No\n";
            continue;
        }

        for (auto p: need2)
            if (!g2.count({p.F, p.S}))
                ans.push_back({p.F + 1, p.S + 1});
        for (auto p: need1)
            if (!g1.count({p.F, p.S}))
                ans.push_back({p.F + 1, p.S + 1});

        cout << "Yes\n" << ans.size() << '\n';
        for (auto p: ans)
            cout << p.F << ' ' << p.S << '\n';
    }
}
/*
3 0
3 0 3
1 2
2 3
1 3
4 2 3
1 2
3 4
1 3
1 4
2 3
4 3 3
1 2
2 3
1 3
1 4
2 4
3 4

*/
/*
1 0
3 3 3
1 2
2 3
3 1
1 2
2 3
3 1

*/
/*

*/
/*
Рассмотрим два не пересекающихся дерева.
Построим их.
Мы победили.

Сначала добавляем отсутствующие ребра во втором графе, а потом в изначальном.

Как построить два таких дерева?
Первое - обход.
 Второе жадно фориком.
*/
/*

*/
