#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define pw(x) (1ll << x)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn (T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx (T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pii = pair < int , int >;

const int N = 1e6 + 5;
const int inf = 2e9;
const ll INF = 4e18;

int tt, gr;
int n, m1, m2;

set < int > g[N];

struct dsu {
    vector < int > par;
    vector < int > sz;

    void init (int _n) {
        par.resize(_n + 1);
        sz.resize(_n + 1, 1);
        iota(all (par), 0);
        fill(all (sz), 1);
    }

    int get (int x) { return x == par[x] ? x : par[x] = get (par[x]);}

    void uni (int a, int b) {
        a = get (a), b = get (b);
        if (a == b) return;

        if (sz[a] < sz[b]) swap (a, b);
        par[b] = a;
        sz[a] += sz[b];
    }
} t;

bool used [N];
void dfs (int v, int& cnt) {
    if (used[v]) return;
    used[v] = true;
    ++ cnt;
    for (auto& to : g[v]) dfs (to, cnt);
}
void solve () {

    cin >> n >> m1 >> m2;

    t.init (n);
    vector < pii > edge;

    for (int i = 1; i <= m1; ++ i) {
        int u, v;
        cin >> u >> v;

        t.uni (u, v);
    }

    for (int i = 1; i <= m2; ++ i) {
        int u, v;
        cin >> u >> v;

        g[v].insert (u);
        g[u].insert (v);
    }


    for (int i = 1; i <= n; ++ i) {
        for (int j = i + 1; j <= n; ++ j) {
            if (t.get (i) != t.get (j)) edge.pb ({i, j});
        }
    }

    vector < pii > answer;

    for (auto[a, b] : edge) {
        if (t.get (a) == t.get (b)) continue;

        if (g[a].find (b) != g[a].end()) g[a].erase (b), g[b].erase (a);
        else g[a].insert (b), g[b].insert (a);

        for (int i = 1; i <= n; ++ i) used[i] = false;

        int cnt = 0;
        dfs (1, cnt);
        if (cnt == n) {
            t.uni (a, b);
            answer.pb ({a, b});
        } else {
            if (g[a].find (b) != g[a].end()) g[a].erase (b), g[b].erase (a);
            else g[a].insert (b), g[b].insert (a);
        }
    }

    for (int i = 1; i <= n; ++ i) g[i].clear();

    if (t.sz[t.get(1)] == n) {
        cout << "Yes\n";
        cout << sz(answer) << "\n";
        for (auto [a, b]: answer) {
            cout << a << " " << b << "\n";
        }
        return;
    }
    cout << "No\n";
}

int main() {
#ifdef localy
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> tt >> gr;
    while (tt --) {
        solve ();
    }

    return 0;
}
