#include <bits/stdc++.h>
using namespace std;

using ll = long long;

vector<vector<int>> g1, g2;
vector <int> used;
int n, m1, m2;

void dfs1(int cur) {
    used[cur] = 1;
    for (auto x : g1[cur]) {
        if (!used[x]) dfs1(x);
    }
}

void solve() {
    cout << "Yes" << "\n";
    vector <int> ord;
    used.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs1(i);
            ord.push_back(i);
        }
    }
    cout << ord.size() - 1 << "\n";
    for (int i = 1; i < ord.size(); ++i) {
        cout << ord[i - 1] + 1 << " " << ord[i] + 1 << "\n";
    }
}

void solve1() {
    cout << "Yes\n";
    vector<pair<int, int>> ans;
    for (int i = 0; i < n - 2; ++i) {
        int flag = 0;
        for (auto x : g1[i]) {
            if (x == i + 2) flag = 1;
        }
        if (!flag) ans.emplace_back(i + 1, i + 3);
    }
    int k = n % 2, flag = 0;
    for (auto x : g1[n - 1]) {
        if (x == k) flag = 1;
    }
    if (!flag) ans.emplace_back(n, k + 1);
    cout << ans.size() << "\n";
    for (auto [x, y] : ans) cout << x << " " << y << "\n";
}

void solve3() {
    vector<vector<int>> b(n, vector<int> (n, 0));;
    for (int i = 0; i < n; ++i) {
        for (auto x : g2[i]) b[i][x] = 1;
    }
    cout << "Yes" << "\n";
    vector<vector<int>> ord(2);
    used.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs1(i);
            ord[0].push_back(i);
            ord[1].push_back(g1[i][0]);
        }
    }
    vector<pair<int, int>> ans;
    for (int i = 1; i < ord.size(); ++i) {
        if (!b[ord[0][i - 1]][ord[0][i]]) ans.emplace_back(ord[0][i - 1] + 1, ord[0][i] + 1);
        else if (!b[ord[1][i - 1]][ord[0][i]]) ans.emplace_back(ord[1][i - 1] + 1, ord[0][i] + 1);
        else if (!b[ord[0][i - 1]][ord[1][i]]) ans.emplace_back(ord[0][i - 1] + 1, ord[1][i] + 1);
        else ans.emplace_back(ord[1][i - 1] + 1, ord[1][i] + 1);
    }
    cout << ans.size() << "\n";
    for (auto [x, y] : ans) cout << x << " " << y << "\n";
}

int main() {
    int t, gr;
    cin >> t >> gr;
    for (int i = 0; i < t; ++i) {
        cin >> n >> m1 >> m2;
        g1.resize(n);
        g2.resize(n);
        for (int j = 0; j < m1; ++j) {
            int u, v;
            cin >> u >> v;
            g1[u - 1].push_back(v - 1);
            g1[v - 1].push_back(u - 1);
        }
        for (int j = 0; j < m2; ++j) {
            int u, v;
            cin >> u >> v;
            g2[u - 1].push_back(v - 1);
            g2[v - 1].push_back(u - 1);
        }
        if (n <= 3) cout << "No\n";
        else if (gr == 2) solve();
        else if (gr == 9) solve1();
        else if (gr == 4) solve3();
        g1.clear();
        g2.clear();
    }
}

/*
3 0
3 0 3
1 2
2 3
1 3
4 2 3
1 2
3 4
1 3
1 4
2 3
4 3 3
1 2
2 3
1 3
1 4
2 4
3 4
 */