#include <bits/stdc++.h>
#pragma GCC optimize("Ofast", "inline")
#pragma GCC target("avx2")

//#define int int64_t
#define endl '\n'
#define pb push_back
#define pii pair <int, int>
#define fi first
#define se second
#define pw(x) (int64_t(1)<<x)
#define TIME 1.0*clock()/CLOCKS_PER_SEC

using namespace std;

mt19937 gen(time(0));
const int INF = 1e9, N = 3e5 + 50;

vector <int> g1[N], g2[N];
int t, g;
int n, m1, m2;

struct Hash {
    size_t operator () (const pii &x) const {
        return x.fi ^ x.se;
    }
};

struct dsu {
    vector <int> p, sz;
    dsu (int n) {
        p.resize(n);
        sz.resize(n, 1);
        iota(p.begin(), p.end(), 0);
    }
    int get (int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = get(p[v]);
    }
    void unite (int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) {
            return;
        }
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        sz[a] += sz[b];
        p[b] = a;
    }
};

void solve1 () {
    cin >> n >> m1 >> m2;
    unordered_set <pii, Hash> used;
    for (int i = 0; i < m1; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        used.insert({x, y});
        used.insert({y, x});
    }
    unordered_set <pii, Hash> have;
    for (int i = 0; i < m2; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        have.insert({x, y});
        have.insert({y, x});
    }
    vector <pii> v;
    for (int x = 0; x < n; ++x) {
        for (int y = x + 1; y < n; ++y) {
            v.pb({x, y});
        }
    }
    sort(v.begin(), v.end());
    unordered_set <pii, Hash> was = have, lol = used;
    do {
        bool bad = 0;
        int it = 0;
        vector <pii> res;
        have = was;
        used = lol;
        for (auto to : v) {
            it++;
            if (it > n) {
                break;
            }
            res.pb({to.fi, to.se});
            int x = to.fi, y = to.se;
            bool ban = 0;
            if (have.count({x, y})) {
                ban = 1;
                have.erase({x, y});
                have.erase({y, x});
            } else {
                have.insert({x, y});
                have.insert({y, x});
            }
            dsu cur(n);
            for (auto to : have) {
                cur.unite(to.fi, to.se);
                if (cur.sz[cur.get(0)] == n) {
                    break;
                }
            }
            if (cur.sz[cur.get(0)] != n) {
                bad = 1;
                break;
            }
            ban = 0;
            if (used.count({x, y})) {
                ban = 1;
                used.erase({x, y});
                used.erase({y, x});
            } else {
                used.insert({x, y});
                used.insert({y, x});
            }
            dsu d(n);
            for (auto to : used) {
                d.unite(to.fi, to.se);
                if (d.sz[cur.get(0)] == n) {
                    break;
                }
            }
            if (n - d.sz[d.get(0)] < n - it) {
                break;
            }
            if (d.sz[d.get(0)] == n) {
                cout << "Yes" << endl;
                cout << res.size() << endl;
                for (auto to : res) {
                    cout << to.fi + 1 << ' ' << to.se + 1 << endl;
                }
                return;
            }
        }
    } while (next_permutation(v.begin(), v.end()));
    cout << "No" << endl;
}

void solve2 () {
    cin >> n >> m1 >> m2;
    set <pii> used;
    for (int i = 0; i < m1; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        used.insert({x, y});
        used.insert({y, x});
    }
    set <pii> have;
    for (int i = 0; i < m2; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        have.insert({x, y});
        have.insert({y, x});
    }
//    if (n >= 4) {
//        dsu d(n);
//        for (auto to : used) {
//            d.unite(to.fi, to.se);
//        }
//        vector <pii> e;
//        for (int i = 0; i < n - 1; ++i) {
//            if (d.get(i) != d.get(i + 1)) {
//                e.pb({i, i + 1});
//                d.unite(i, i + 1);
//            }
//        }
//        if (n >= 4) {
//            cout << "Yes" << endl;
//            cout << e.size() << endl;
//            for (auto to : e) {
//                cout << to.fi + 1 << ' ' << to.se + 1 << endl;
//            }
//            return;
//        }
//    }
    dsu d(n);
    for (auto to : used) {
        d.unite(to.fi, to.se);
    }
    bool CAN = 0;
    vector <pii> e;
    for (int x = 0; x < n && !CAN; ++x) {
        for (int y = x + 1; y < n; ++y) {
            if (d.get(x) != d.get(y) && !have.count({x, y})) {
                e.pb({x, y});
                CAN = 1;
                have.insert({x, y});
                have.insert({y, x});
                d.unite(x, y);
                break;
            }
        }
    }
    for (int x = 0; x < n && !CAN; ++x) {
        for (int y = x + 1; y < n; ++y) {
            if (!have.count({x, y})) {
                e.pb({x, y});
                CAN = 1;
                have.insert({x, y});
                have.insert({y, x});
                d.unite(x, y);
                break;
            }
        }
    }
    for (int it = 0; it < n - 1; ++it) {
        if (d.sz[d.get(0)] == n) {
            break;
        }
        pii val = {-1, -1};
        for (int x = 0; x < n && val.fi == -1; ++x) {
            for (int y = x + 1; y < n; ++y) {
                if (d.get(x) != d.get(y)) {
                    dsu cur(n);
                    bool ban = 0;
                    if (have.count({x, y})) {
                        ban = 1;
                        have.erase({x, y});
                        have.erase({y, x});
                    } else {
                        have.insert({x, y});
                        have.insert({y, x});
                    }
                    for (auto to : have) {
                        cur.unite(to.fi, to.se);
                    }
                    if (!ban) {
                        have.erase({x, y});
                        have.erase({y, x});
                    } else {
                        have.insert({x, y});
                        have.insert({y, x});
                    }
                    if (cur.sz[cur.get(0)] == n) {
                        val = {x, y};
                        break;
                    }
                }
            }
        }
        if (val.fi == -1) {
            cout << "No" << endl;
            return;
        }
        int x = val.fi;
        int y = val.se;
        if (have.count({x, y})) {
            have.erase({x, y});
            have.erase({y, x});
        } else {
            have.insert({x, y});
            have.insert({y, x});
        }
        e.pb({val.fi, val.se});
        d.unite(val.fi, val.se);
    }
    if (d.sz[d.get(0)] != n) {
        cout << "No" << endl;
    } else {
        cout << "Yes" << endl;
        cout << e.size() << endl;
        for (auto to : e) {
            cout << to.fi + 1 << ' ' << to.se + 1 << endl;
        }
    }
}

void solve3 () {
    cin >> n >> m1 >> m2;
    unordered_set <pii, Hash> used;
    for (int i = 0; i < m1; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        used.insert({x, y});
    }
    unordered_set <pii, Hash> have;
    for (int i = 0; i < m2; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        have.insert({x, y});
        have.insert({y, x});
    }
    dsu d(n);
    for (auto to : used) {
        d.unite(to.fi, to.se);
    }
    vector <int> G[n];
    for (auto i : used) {
        G[i.fi].pb(i.se);
        G[i.se].pb(i.fi);
    }
    for (int i = 0; i < n; ++i) {
        sort(G[i].begin(), G[i].end());
        G[i].erase(unique(G[i].begin(), G[i].end()), G[i].end());
    }
    map <vector <int>, set <int>> BAN;
    for (int i = 0; i < n; ++i) {
        BAN[G[i]].insert(i);
    }
    set <int> can;
    for (int i = 0; i < n; ++i) {
        can.insert(i);
    }
    for (int x = 0; x < n; ++x) {
        for (int y = x + 1; y < n; ++y) {
            if (d.get(x) != d.get(y)) {
                vector <int> A = {x, y};
                for (auto to : BAN[A]) {
                    can.erase(to);
                }
                A = {x};
                for (auto to : BAN[A]) {
                    can.erase(to);
                }
                A = {y};
                for (auto to : BAN[A]) {
                    can.erase(to);
                }
                int v = -1;
                for (auto to : can) {
                    if (to != x && to != y) {
                        v = to;
                        break;
                    }
                }
                if (v == -1) {
                    vector <int> A = {x, y};
                    for (auto to : BAN[A]) {
                        can.insert(to);
                    }
                    A = {x};
                    for (auto to : BAN[A]) {
                        can.insert(to);
                    }
                    A = {y};
                    for (auto to : BAN[A]) {
                        can.insert(to);
                    }
                    continue;
                }
                vector <pii> ans;
                if (!have.count({v, x})) {
                    ans.pb({v, x});
                }
                if (!have.count({v, y})) {
                    ans.pb({v, y});
                }
                ans.pb({x, y});
                assert(ans.size() <= n);
                cout << "Yes" << endl;
                cout << ans.size() << endl;
                for (auto to : ans) {
                    cout << to.fi + 1 << ' ' << to.se + 1 << endl;
                }
                return;
            }
        }
    }
    cout << "No" << endl;
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> t >> g;
    if (g <= 2) {
        while (t--) {
            solve2();
        }
        exit(0);
    }
    if (g == 3) {
        while (t--) solve3();
    } else {
        while (t--) solve2();
    }
}
