#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}
// графы(dfs bfs djikstra) дп конструктивы геома жадник
// линалг бинпоиск бинподьемы

#define int long long
#define endl '\n'
const int N = 2e5 + 10, INF = 2e18, MOD = 1e9 + 7;
bool used[N];

void dfs(int v, vector<vector<int>> &gr) {
    used[v] = true;
    for (auto to: gr[v]) {
        if (!used[to]) {
            dfs(to, gr);
        }
    }
}

bool checkgr(int n, vector<vector<int>> &gr) {
    fill(used, used + n, false);
    dfs(0, gr);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            return false;
        }
    }
    return true;
}

void solve() {
    int n, mber, mher;
    cin >> n >> mber >> mher;
    int cnt = n * (n - 1) / 2;
    vector<pair<int, int>> edges;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            edges.emplace_back(i, j);
        }
    }
    map<pair<int, int>, bool> ber, her;
    for (int i = 0; i < mber; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        ber[{u, v}] = true;
        ber[{v, u}] = true;
    }
    for (int i = 0; i < mher; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        her[{u, v}] = true;
        her[{v, u}] = true;
    }
    for (int mask = 0; mask < (1 << cnt); mask++) {
        vector<int> p(n);
        for (int i = 0; i < cnt; i++) {
            if ((mask >> i) & 1) {
                p.push_back(i);
            }
        }
        do {
            vector<vector<int>> grber(n), grher(n);
            vector<int> ch;
            map<pair<int, int>, int> delber, delher;
            bool ok = true;
            for (int iv = 0; iv < p.size(); iv++) {
                int i = p[iv];
                if (!ber.count(edges[i])) {
                    grber[edges[i].first].push_back(edges[i].second);
                    grber[edges[i].second].push_back(edges[i].first);
                } else {
                    delber[edges[i]] = true;
                    delber[{edges[i].second, edges[i].first}] = true;
                }
                if (!her.count(edges[i])) {
                    grher[edges[i].first].push_back(edges[i].second);
                    grher[edges[i].second].push_back(edges[i].first);
                } else {
                    vector<vector<int>> grherc = grher;
                    delher[edges[i]] = true;
                    delher[{edges[i].second, edges[i].first}] = true;
                    for (auto c: her) {
                        if (!delher.count(c.first)) {
                            grherc[c.first.first].push_back(c.first.second);
                            grherc[c.first.second].push_back(c.first.first);
                        }
                    }
                    if (!checkgr(n, grherc)) {
                        ok = false;
                        break;
                    }
                }
                ch.push_back(i);
            }
            if (!ok)continue;
            for (auto c: ber) {
                if (!delber.count(c.first)) {
                    grber[c.first.first].push_back(c.first.second);
                    grber[c.first.second].push_back(c.first.first);
                }
            }
            for (auto c: her) {
                if (!delher.count(c.first)) {
                    grher[c.first.first].push_back(c.first.second);
                    grher[c.first.second].push_back(c.first.first);
                }
            }
            if (checkgr(n, grber) && checkgr(n, grher) && ch.size() <= n) {
                cout << "Yes" << endl;
                cout << ch.size() << endl;
                for (auto c: ch) {
                    cout << edges[c].first + 1 << " " << edges[c].second + 1 << endl;
                }
                return;
            }
        } while (next_permutation(p.begin(), p.end()));
    }
    cout << "No" << endl;
}