//Alors on dance

#include<bits/stdc++.h>

void solve1() {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    std::vector<std::vector<bool>> g1(n, std::vector<bool>(n, false)), g2(n, std::vector<bool>(n, false));
    for (int i = 0; i < m1; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u, --v;
        g1[u][v] = g1[v][u] = true;
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u, --v;
        g2[u][v] = g2[v][u] = true;
    }
    for (int mask = 0; mask < (1 << (n * (n - 1) / 2)); ++mask) {
        if (__builtin_popcount(mask) > n) continue;
        std::vector<std::pair<int, int>> ee;
        {
            int ptr = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < i; ++j) {
                    if (mask >> ptr & 1) {
                        ee.emplace_back(i, j);
                    }
                    ptr++;
                }
            }
        }
        std::sort(ee.begin(), ee.end());
        do {
            bool ok = true;
            for (auto [x, y] : ee) {
                g2[x][y] = !g2[x][y];
                g2[y][x] = !g2[y][x];
                g1[x][y] = !g1[x][y];
                g1[y][x] = !g1[y][x];
                int cnt = 0;
                {
                    std::vector<bool> used(n, false);
                    auto dfs = [&](auto dfs, int u) -> void {
                        cnt++;
                        used[u] = true;
                        for (int to = 0; to < n; ++to) {
                            if (g2[u][to] && !used[to]) {
                                dfs(dfs, to);
                            }
                        }
                    };
                    dfs(dfs, 0);
                }
                ok &= cnt == n;
            }
            int cnt = 0;
            {
                std::vector<bool> used(n, false);
                auto dfs = [&](auto dfs, int u) -> void {
                    cnt++;
                    used[u] = true;
                    for (int to = 0; to < n; ++to) {
                        if (g1[u][to] && !used[to]) {
                            dfs(dfs, to);
                        }
                    }
                };
                dfs(dfs, 0);
            }
            ok &= cnt == n;
            if (ok) {
                std::cout << "Yes\n" << ee.size() << '\n';
                for (auto [x, y]: ee) std::cout << x + 1 << ' ' << y + 1 << '\n';
                return;
            }
            for (auto [x, y] : ee) {
                g2[x][y] = !g2[x][y];
                g2[y][x] = !g2[y][x];
                g1[x][y] = !g1[x][y];
                g1[y][x] = !g1[y][x];
            }
        } while (std::next_permutation(ee.begin(), ee.end()));
    }
    std::cout << "No\n";
}

struct DSU {
    int n;
    std::vector<int> p;
    
    DSU() = default;
    DSU(int n) : n(n), p(n, 0) {
        std::iota(p.begin(), p.end(), 0);
    }
    
    int get(int u) {
        while (u != p[u]) u = p[u] = p[p[u]];
        return u;
    }
    
    void unite(int u, int v) {
        p[get(u)] = get(v);
    }
};

void solve2() {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    DSU dsu(n);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u, --v;
        dsu.unite(u, v);
    }
    for (int i = 0; i < m2; ++i) {
        int u,v ;
        std::cin >> u >> v;
        --u, --v;
    }
    int prv = -1;
    std::vector<std::pair<int, int>> res;
    for (int i = 0; i < n; ++i) {
        if (dsu.get(i) == i) {
            if (prv != -1) res.emplace_back(prv, i);
            prv = i;
        }
    }
    std::cout << "Yes\n";
    std::cout << res.size() << '\n';
    for (auto [x, y] : res) std::cout << x + 1 << ' ' << y + 1 << '\n';
}

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);

    int t, group;
    std::cin >> t >> group;
    if (group == 1) {
        while (t--) {
            solve1();
        }
    } else {
        while (t--) {
            solve2();
        }
    }
}