//Alors on dance

#include<bits/stdc++.h>

void solve1() {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    std::vector<std::vector<bool>> g1(n, std::vector<bool>(n, false)), g2(n, std::vector<bool>(n, false));
    for (int i = 0; i < m1; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u, --v;
        g1[u][v] = g1[v][u] = true;
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u, --v;
        g2[u][v] = g2[v][u] = true;
    }
    for (int mask = 0; mask < (1 << (n * (n - 1) / 2)); ++mask) {
        if (__builtin_popcount(mask) > n) continue;
        std::vector<std::pair<int, int>> ee;
        {
            int ptr = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < i; ++j) {
                    if (mask >> ptr & 1) {
                        ee.emplace_back(i, j);
                    }
                    ptr++;
                }
            }
        }
        std::sort(ee.begin(), ee.end());
        do {
            bool ok = true;
            for (auto [x, y]: ee) {
                g2[x][y] = !g2[x][y];
                g2[y][x] = !g2[y][x];
                g1[x][y] = !g1[x][y];
                g1[y][x] = !g1[y][x];
                int cnt = 0;
                {
                    std::vector<bool> used(n, false);
                    auto dfs = [&](auto dfs, int u) -> void {
                        cnt++;
                        used[u] = true;
                        for (int to = 0; to < n; ++to) {
                            if (g2[u][to] && !used[to]) {
                                dfs(dfs, to);
                            }
                        }
                    };
                    dfs(dfs, 0);
                }
                ok &= cnt == n;
            }
            int cnt = 0;
            {
                std::vector<bool> used(n, false);
                auto dfs = [&](auto dfs, int u) -> void {
                    cnt++;
                    used[u] = true;
                    for (int to = 0; to < n; ++to) {
                        if (g1[u][to] && !used[to]) {
                            dfs(dfs, to);
                        }
                    }
                };
                dfs(dfs, 0);
            }
            ok &= cnt == n;
            if (ok) {
                std::cout << "Yes\n" << ee.size() << '\n';
                for (auto [x, y]: ee) std::cout << x + 1 << ' ' << y + 1 << '\n';
                return;
            }
            for (auto [x, y]: ee) {
                g2[x][y] = !g2[x][y];
                g2[y][x] = !g2[y][x];
                g1[x][y] = !g1[x][y];
                g1[y][x] = !g1[y][x];
            }
        } while (std::next_permutation(ee.begin(), ee.end()));
    }
    std::cout << "No\n";
}

struct DSU {
    int n;
    std::vector<int> p;

    DSU() = default;

    DSU(int n) : n(n), p(n, 0) {
        std::iota(p.begin(), p.end(), 0);
    }

    int get(int u) {
        while (u != p[u]) u = p[u] = p[p[u]];
        return u;
    }

    void unite(int u, int v) {
        p[get(u)] = get(v);
    }
};

void solve2() {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    DSU dsu(n);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u, --v;
        dsu.unite(u, v);
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u, --v;
    }
    std::vector<std::pair<int, int>> res;
    if (n == 3) {
        if (dsu.get(0) != dsu.get(1) && dsu.get(0) != dsu.get(2) && dsu.get(1) != dsu.get(2)) {
            std::cout << "No\n";
            return;
        }
    }
    for (int i = 1; i < n; ++i) {
        if (dsu.get(i) != dsu.get(i - 1)) {
            res.emplace_back(i - 1, i);
            dsu.unite(i - 1, i);
        }
    }
    std::cout << "Yes\n";
    std::cout << res.size() << '\n';
    for (auto [x, y]: res) std::cout << x + 1 << ' ' << y + 1 << '\n';
}

void solve9() {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    if (n == 3) {
        std::vector<std::vector<bool>> g1(n, std::vector<bool>(n, false)), g2(n, std::vector<bool>(n, false));
        for (int i = 0; i < m1; ++i) {
            int u, v;
            std::cin >> u >> v;
            --u, --v;
            g1[u][v] = g1[v][u] = true;
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            std::cin >> u >> v;
            --u, --v;
            g2[u][v] = g2[v][u] = true;
        }
        for (int mask = 0; mask < (1 << (n * (n - 1) / 2)); ++mask) {
            if (__builtin_popcount(mask) > n) continue;
            std::vector<std::pair<int, int>> ee;
            {
                int ptr = 0;
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < i; ++j) {
                        if (mask >> ptr & 1) {
                            ee.emplace_back(i, j);
                        }
                        ptr++;
                    }
                }
            }
            std::sort(ee.begin(), ee.end());
            do {
                bool ok = true;
                for (auto [x, y]: ee) {
                    g2[x][y] = !g2[x][y];
                    g2[y][x] = !g2[y][x];
                    g1[x][y] = !g1[x][y];
                    g1[y][x] = !g1[y][x];
                    int cnt = 0;
                    {
                        std::vector<bool> used(n, false);
                        auto dfs = [&](auto dfs, int u) -> void {
                            cnt++;
                            used[u] = true;
                            for (int to = 0; to < n; ++to) {
                                if (g2[u][to] && !used[to]) {
                                    dfs(dfs, to);
                                }
                            }
                        };
                        dfs(dfs, 0);
                    }
                    ok &= cnt == n;
                }
                int cnt = 0;
                {
                    std::vector<bool> used(n, false);
                    auto dfs = [&](auto dfs, int u) -> void {
                        cnt++;
                        used[u] = true;
                        for (int to = 0; to < n; ++to) {
                            if (g1[u][to] && !used[to]) {
                                dfs(dfs, to);
                            }
                        }
                    };
                    dfs(dfs, 0);
                }
                ok &= cnt == n;
                if (ok) {
                    std::cout << "Yes\n" << ee.size() << '\n';
                    for (auto [x, y]: ee) std::cout << x + 1 << ' ' << y + 1 << '\n';
                    return;
                }
                for (auto [x, y]: ee) {
                    g2[x][y] = !g2[x][y];
                    g2[y][x] = !g2[y][x];
                    g1[x][y] = !g1[x][y];
                    g1[y][x] = !g1[y][x];
                }
            } while (std::next_permutation(ee.begin(), ee.end()));
        }
        std::cout << "No\n";
        return;
    }
    DSU dsu(n);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u, --v;
        dsu.unite(u, v);
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u, --v;
    }
    std::vector<std::pair<int, int>> res;
    for (int i = 0; i + 2 < n; ++i) {
        if (dsu.get(i) != dsu.get(i + 2)) {
            res.emplace_back(i, i + 2);
            dsu.unite(i, i + 2);
        }
    }

    if (dsu.get(3) != dsu.get(0)) {
        res.emplace_back(0, 3);
        dsu.unite(0, 3);
    }
    std::cout << "Yes\n";
    std::cout << res.size() << '\n';
    for (auto [x, y]: res) std::cout << x + 1 << ' ' << y + 1 << '\n';
}

void solve4() {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    if (n <= 5) {
        std::vector<std::vector<bool>> g1(n, std::vector<bool>(n, false)), g2(n, std::vector<bool>(n, false));
        for (int i = 0; i < m1; ++i) {
            int u, v;
            std::cin >> u >> v;
            --u, --v;
            g1[u][v] = g1[v][u] = true;
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            std::cin >> u >> v;
            --u, --v;
            g2[u][v] = g2[v][u] = true;
        }
        for (int mask = 0; mask < (1 << (n * (n - 1) / 2)); ++mask) {
            if (__builtin_popcount(mask) > n) continue;
            std::vector<std::pair<int, int>> ee;
            {
                int ptr = 0;
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < i; ++j) {
                        if (mask >> ptr & 1) {
                            ee.emplace_back(i, j);
                        }
                        ptr++;
                    }
                }
            }
            std::sort(ee.begin(), ee.end());
            do {
                bool ok = true;
                for (auto [x, y]: ee) {
                    g2[x][y] = !g2[x][y];
                    g2[y][x] = !g2[y][x];
                    g1[x][y] = !g1[x][y];
                    g1[y][x] = !g1[y][x];
                    int cnt = 0;
                    {
                        std::vector<bool> used(n, false);
                        auto dfs = [&](auto dfs, int u) -> void {
                            cnt++;
                            used[u] = true;
                            for (int to = 0; to < n; ++to) {
                                if (g2[u][to] && !used[to]) {
                                    dfs(dfs, to);
                                }
                            }
                        };
                        dfs(dfs, 0);
                    }
                    ok &= cnt == n;
                }
                int cnt = 0;
                {
                    std::vector<bool> used(n, false);
                    auto dfs = [&](auto dfs, int u) -> void {
                        cnt++;
                        used[u] = true;
                        for (int to = 0; to < n; ++to) {
                            if (g1[u][to] && !used[to]) {
                                dfs(dfs, to);
                            }
                        }
                    };
                    dfs(dfs, 0);
                }
                ok &= cnt == n;
                if (ok) {
                    std::cout << "Yes\n" << ee.size() << '\n';
                    for (auto [x, y]: ee) std::cout << x + 1 << ' ' << y + 1 << '\n';
                    return;
                }
                for (auto [x, y]: ee) {
                    g2[x][y] = !g2[x][y];
                    g2[y][x] = !g2[y][x];
                    g1[x][y] = !g1[x][y];
                    g1[y][x] = !g1[y][x];
                }
            } while (std::next_permutation(ee.begin(), ee.end()));
        }
        std::cout << "No\n";
        return;
    }
    std::vector<std::vector<int>> gg(n), g(n);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u, --v;
        gg[u].push_back(v);
        gg[v].push_back(u);
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    std::set<std::pair<int, int>> forb;
    {
        std::vector<bool> used(n, false);
        auto dfs = [&](auto dfs, int u) -> void {
            used[u] = true;
            for (auto to: g[u]) {
                if (!used[to]) {
                    forb.emplace(u, to);
                    forb.emplace(to, u);
                    dfs(dfs, to);
                }
            }
        };
        dfs(dfs, 0);
    }
    std::vector<std::vector<int>> comp(n);
    std::vector<int> num(n);
    for (int i = 0; i < n; ++i) {
        comp[i] = {i};
        num[i] = i;
    }
    auto unite = [&](int x, int y) -> void {
        x = num[x];
        y = num[y];
        if (x == y) return;
        if (comp[x].size() < comp[y].size()) std::swap(x, y);
        for (auto u: comp[y]) {
            comp[x].push_back(u);
            num[u] = x;
        }
        comp[y].clear();
    };
    for (int i = 0; i < n; ++i) {
        for (auto j: gg[i]) {
            unite(i, j);
        }
    }
    std::vector<std::pair<int, int>> res;
    while (true) {
        std::vector<int> sheesh;
        bool ok = false;
        for (int i = 0; i < n && !ok; ++i) {
            if (comp[i].size()) {
                for (auto x: sheesh) {
                    for (auto u: comp[x]) {
                        for (auto v: comp[i]) {
                            if (forb.count({u, v})) continue;
                            ok = true;
                            g[u].push_back(v);
                            g[v].push_back(u);
                            res.emplace_back(u, v);
                            unite(u, v);
                            break;
                        }
                        if (ok) break;
                    }
                    if (ok) break;
                }
                sheesh.push_back(i);
            }
        }
        if (!ok) break;
    }
    std::vector<int> sheesh;
    for (int i = 0; i < n; ++i) {
        if (comp[i].size()) {
            sheesh.push_back(i);
        }
    }
    if (sheesh.size() == 1) {
        std::cout << "Yes\n";
        std::cout << res.size() << '\n';
        for (auto [x, y]: res) std::cout << x + 1 << ' ' << y + 1 << '\n';
    } else {
        if (comp[sheesh[0]].size() == 1) std::swap(sheesh[0], sheesh[1]);
        assert(comp[sheesh[1]].size() == 1);
        for (auto x : comp[sheesh[0]]) {
            for (auto y : comp[sheesh[0]]) {
                if (x == y) continue;
                int cnt = 0;
                std::vector<bool> used(n, false);
                auto dfs = [&](auto dfs, int u) -> void {
                    used[u] = true;
                    cnt++;
                    bool q = false;
                    for (auto to : g[u]) {
                        if (std::make_pair(x, y) == std::make_pair(u, to)) {
                            q = true;
                            continue;
                        }
                        if (std::make_pair(x, y) == std::make_pair(to, u)) {
                            q = true;
                            continue;
                        }
                        if (!used[to]) dfs(dfs, to);
                    }
                    if (!q && (u == x || u == y)) {
                        int to = u ^ x ^ y;
                        if (!used[to]) {
                            dfs(dfs, to);
                        }
                    }
                };
                dfs(dfs, x);
                if (cnt == n - 1) {
                    if (std::find(g[x].begin(), g[x].end(), y) != g[x].end()) {}
                    else res.emplace_back(x, y);
                    res.emplace_back(sheesh[1], x);
                    std::cout << "Yes\n";
                    std::cout << res.size() << '\n';
                    for (auto [x, y]: res) std::cout << x + 1 << ' ' << y + 1 << '\n';
                    return;
                }
            }
        }
        std::cout << "No\n";
        return;
    }
}

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);

    int t, group;
    std::cin >> t >> group;
    if (group == 9) {
        while (t--) {
            solve9();
        }
    } else {
        while (t--) {
            solve4();
        }
    }
}