#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <cmath>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;
const int INF = 1e9;

vector<vector<int>> comps;
vector<bool> vis;
vector<vector<pair<int, int>>> g1, g2;

void dfs(int u) {
	vis[u] = true;
	comps.back().push_back(u);
	for (auto el : g1[u]) {
		int v = el.first;
		if (!vis[v])
			dfs(v);
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t, g;
	cin >> t >> g;
	for (int _ = 0; _ < t; ++_) {
		int n, m1, m2;
		cin >> n >> m1 >> m2;
		g1.resize(n); g2.resize(n);
		for (int i = 0; i < m1; ++i) {
			int u, v;
			cin >> u >> v;
			u--; v--;
			g1[u].push_back({ v, i });
			g1[v].push_back({ u, i });
		}
		for (int i = 0; i < m2; ++i) {
			int u, v;
			cin >> u >> v;
			u--; v--;
			g2[u].push_back({ v, i });
			g2[v].push_back({ u, i });
		}
		vis.assign(n, false);
		bool flag = true;
		for (int u = 0; u < n; ++u) {
			if (!vis[u]) {
				comps.emplace_back();
				dfs(u);
				if (comps.back().size() == 1)
					flag = false;
			}
		}
		vector<pair<int, int>> ans;
		
		for (int i = 1; i < comps.size(); ++i) {
			ans.push_back({ comps[i - 1][0], comps[i][0] });
		}
		if (!flag) {
			cout << "No\n";
		}
		else {
			cout << "Yes\n";
			cout << ans.size() << "\n";
			for (auto el : ans)
				cout << el.first + 1 << " " << el.second + 1 << "\n";
			g1.clear(); g2.clear(); comps.clear();
		}
	}

	return 0;
}