

#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <stack>
#include <deque>
#include <assert.h>
#include <random>
#include <algorithm>
#include <string>
#include <iomanip>
#include <iostream>
#include <math.h>

using namespace std;

mt19937 rnd(0);
#define fast ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)

#define pii pair<int, int>
#define vi vector<int>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define ff first
#define ss second

#define int long long
const int MOD = 1e9 + 7, INF = 1e9 + 7;
int G;
vvi g1, g2;
vector<unordered_map<int, int>> e1, e2;
int n, m1, m2;

void solve0() {
    if (n == 3 && m1 >= 2) {
        cout << "Yes\n";
        cout << 0 << endl;
        return;
    }

    if (m2 == 3) {
        if (m1 == 0) {
            cout << "No\n";
            return;
        }

        if (e1[0][1] == 0) {
            cout << "Yes\n1\n1 2\n";
        }
        else if (e1[0][2] == 0) {
            cout << "Yes\n1\n1 3\n";
        }
        else {
            cout << "Yes\n1\n2 3\n";
        }
    }
    else {
        if (m1 == 0) {
            if (e2[0][1] == 0) {
                cout << "Yes\n2\n" << "1 2\n1 3\n";
            }
            else if (e2[0][2] == 0) {
                cout << "Yes\n2\n" << "1 3\n1 2\n";
            }
            else {
                cout << "Yes\n2\n" << "2 3\n1 2\n";
            }
        }
        else {
            if (e2[0][1] == 0) {
                if (e1[0][1] == 1) cout << "No\n";
                else cout << "Yes\n1\n" << "1 2\n";
            }
            else if (e2[0][2] == 0) {
                if (e1[0][2] == 1) cout << "No\n";
                else cout << "Yes\n1\n" << "1 3\n";
            }
            else if (e2[1][2] == 0) {
                if (e1[1][2] == 1) cout << "No\n";
                else cout << "Yes\n1\n" << "2 3\n";
            }
        }
    }
}

void solve1() {

}

void solve2() {
    vector<pii> ans;
    for (int i = 0; i < n - 1; ++i) {
        if (e1[i].find(i + 1) == e1[i].end()) {
            ans.push_back({ i, i + 1 });
        }
    }
    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto& el : ans) cout << el.ff + 1 << " " << el.ss + 1 << "\n";
}

void solve5() {
    vector<pii> ans;
    for (int i = 1; i < n - 1; ++i) {
        if (e2[i][i + 1]) assert(0);
        if (!e1[i][i + 1]) 
            ans.push_back({ i, i + 1 });
    }
    if (!e1[0][2]) ans.push_back({ 0, 2 });

    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto& el : ans) cout << el.ff + 1 << " " << el.ss + 1 << "\n";
}

void solve9() {
    vector<pii> ans;
    for (int i = 0; i < n - 2; ++i) {
        if (!e1[i][i + 2])
            ans.push_back({ i, i + 2 });
    }

    if (!e1[0][3]) ans.push_back({ 0, 3 });

    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto& el : ans) cout << el.ff + 1 << " " << el.ss + 1 << "\n";
}

void solve7() {
    vector<pii> ans;
    for (int i = 2; i < n; ++i) {
        if (e1[1][i] || e1[0][i]) continue;
        if (!e2[0][i]) {
            ans.push_back({ 0, i });
        }
        else {
            ans.push_back({ 1, i });
        }
    }
    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto& el : ans) cout << el.ff + 1 << " " << el.ss + 1 << "\n";
}


void solve() {
    cin >> n >> m1 >> m2;

    g1.clear();
    g1.resize(n);
    g2.clear();
    g2.resize(n);
    e1.clear();
    e1.resize(n);
    e2.clear();
    e2.resize(n);
    for (int i = 0; i < m1; ++i) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g1[v].push_back(u);
        g1[u].push_back(v);
        e1[v][u] = 1;
        e1[u][v] = 1;
    }

    for (int i = 0; i < m2; ++i) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        g2[v].push_back(u);
        g2[u].push_back(v);
        e2[v][u] = 1;
        e2[u][v] = 1;
    }

    if (n == 3) solve0();
    else if (G == 2) solve2();
    else if (G == 7) solve7();
    else if (G == 9) solve9();
    else if (G == 5) solve5();
}

signed main()
{
    fast;
    int t;
    cin >> t >> G;
    while (t--) solve();
}