//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ll = long long;
using ld = long double;

const ll INF = 2e18;
const int MOD = 1e9 + 7, N = 1e5 + 1, MAXN = 5e5 + 1, K = 26, INFi = 2e9;
const ld EPS = 1e-12, PI = acos(-1);

random_device rd;
mt19937_64 rnd(rd());

int n, m1, m2;
vector<int> g[N], g1[N];
vector<vector<int>> b1(6, vector<int>(6)), b2 = b1;
vector<bool> used(N);

void dfs(int v) {
    used[v] = true;
    for (int i = 1; i <= n; i++) {
        if (!used[i] && b2[v][i]) {
            dfs(i);
        }
    }
}
void dfs1(int v) {
    used[v] = true;
    for (int i = 1; i <= n; i++) {
        if (!used[i] && b1[v][i]) {
            dfs1(i);
        }
    }
}

void solve() {
    vector<pair<int, int>> ed;
    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            ed.emplace_back(i, j);
        }
    }
    int m = (int)ed.size();
    for (int mask = 0; mask < (1 << m); mask++) {
        int cnt = 0;
        bool fl = true;
        for (int j = 0; j < m && fl; j++) {
            if (mask & (1 << j)) {
                cnt++;
                auto [u, v] = ed[j];
                b1[u][v] ^= 1;
                b1[v][u] ^= 1;
                b2[u][v] ^= 1;
                b2[v][u] ^= 1;
                used.assign(n + 1, false);
                dfs(1);
                for (int i = 1; i <= n; i++) {
                    if (!used[i]) {
                        fl = false;
                        break;
                    }
                }
            }
        }
        used.assign(n + 1, false);
        dfs1(1);
        for (int i = 1; i <= n; i++) {
            if (!used[i]) {
                fl = false;
                break;
            }
        }
        if (cnt > n && fl) {
            fl = false;
        }
        if (fl) {
            cout << "Yes\n";
            vector<pair<int, int>> spell;
            cout << cnt << '\n';
            for (int j = 0; j < m; j++) {
                if (mask & (1 << j)) {
                    cout << ed[j].first << ' ' << ed[j].second << '\n';
                }
            }
            return;
        }
        for (int j = 0; j < m; j++) {
            if (mask & (1 << j)) {
                auto [u, v] = ed[j];
                b1[u][v] ^= 1;
                b1[v][u] ^= 1;
                b2[u][v] ^= 1;
                b2[v][u] ^= 1;
            }
        }
    }
    cout << "No\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int T = 1, G;
    cin >> T >> G;
    while (T--) {
        cin >> n >> m1 >> m2;
        if (n == 3 && G > 0) {
            assert(0);
        }
        for (int i = 1; i <= 5; i++) {
            for (int j = 1; j <= 5; j++) {
                b1[i][j] = b2[i][j] = 0;
            }
        }
        for (int i = 0; i <= n; i++) {
            g[i].clear();
        }
        for (int i = 0; i < m1; i++) {
            int u, v;
            cin >> u >> v;
            g[u].push_back(v);
            g[v].push_back(u);
            b1[u][v] = b1[v][u] = 1;
        }
        for (int i = 0; i <= n; i++) {
            g1[i].clear();
        }
        for (int i = 0; i < m2; i++) {
            int a, b;
            cin >> a >> b;
            g1[a].push_back(b);
            g1[b].push_back(a);
            b2[a][b] = b2[b][a] = 1;
        }
        if (G <= 1) {
            solve();
        } else if (G == 2) {

        }
    }
    return 0;
}
