#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <deque>

using namespace std;

using ll = long long;
using pii = pair<int, int>;


vector<vector<int>> g1, g2, g_gen;

int ans, n;
vector<vector<int>> ans_v;


int dfs_check(int v, vector<vector<int>>& g, vector<int>& used) {
    int sz = 1;
    used[v] = 1;
    for (int u = 0; u < n; ++u) {
        if (g[v][u] ^ g_gen[v][u]) {
            if (!used[u]) sz += dfs_check(u, g, used);
        }
    }
    return sz;
}

void gen(int i, int j, int cnt) {
    if (i == n) {
        vector<int> used1(n), used2(n);
        int cnt1 = dfs_check(0, g1, used1), cnt2 = dfs_check(0, g2, used2);
        if (cnt1 == n && cnt2 == n) {
            if (ans > cnt) {
                ans = cnt;
                ans_v = g_gen;
            }
        }
        return;
    }int i_nxt = i, j_nxt = j + 1;
    if (j == n - 1) {
        j_nxt = 0;
        i_nxt++;
    }
    if (i != j) {
        g_gen[i][j] = g_gen[j][i] = 1;
        gen(i_nxt, j_nxt, cnt + 1);
    }
    g_gen[i][j] = g_gen[j][i] = 0;
    gen(i_nxt, j_nxt, cnt);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, group;
    cin >> t >> group;
    for (int _ = 0; _ < t; ++_) {
        cin >> n;
        g1.assign(n, vector<int> (n, 0));
        g2.assign(n, vector<int> (n, 0));
        g_gen.assign(n, vector<int> (n, 0));
        int m1, m2;
        cin >> m1 >> m2;
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            --u; --v;
            g1[u][v] = 1;
            g1[v][u] = 1;
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            --u; --v;
            g2[u][v] = g2[v][u] = 1;
        }
        ans = 1e9;
        if (n <= 5) {
            gen(0, 0, 0);
            if (ans == 1e9) {
                cout << "No\n";
            } else {
                cout << "Yes\n";
                cout << ans << "\n";
                for (int i = 0; i < n; ++i) {
                    for (int j = i + 1; j < n; ++j) {
                        if (ans_v[i][j]) cout << i + 1 << " " << j + 1 << "\n";
                    }
                }
            }
            continue;
        }
    }
    return 0;
}
