#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <random>
#include <chrono>
#include <deque>


using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define MNOGO int __t; cin>>__t; while(__t--)
#define endl "\n"

vector<vector<int>> g1;
vector<vector<int>> g2;

vector<int> h;

int root;

vector<vector<int>> g;

void get_ost(int v) {
    if (h[v] >= h[root]) {
        root = v;
    }
    for (auto u: g2[v]) {
        if (!h[u]) {
            g[v].push_back(u);
            g[u].push_back(v);
            h[u] = h[v] + 1;
            get_ost(u);
        }
    }
}

vector<vector<int>> layers;

void get_l(int v, int p, int he) {
    layers[he].push_back(v);
    for (auto u: g[v]) {
        if (u == p) {
            continue;
        }
        get_l(u, v, he + 1);
    }
}

int max_h = 0;

void get_max(int v, int p, int he) {
    max_h = max(max_h, he);
    for (auto u: g[v]) {
        if (u != p) {
            get_max(u, v, he + 1);
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    mt19937 rng(std::chrono::steady_clock::now().time_since_epoch().count());

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cout << "No" << endl;

    int _t, gr;
    cin >> _t >> gr;

    while (_t--) {

        int n, m1, m2;
        cin >> n >> m1 >> m2;


        g1 = {};
        g2 = {};
        h = {};

        h.resize(n + 1);

        g1.resize(n + 1);
        g2.resize(n + 1);

        set<pair<int, int>> st1;
        set<pair<int, int>> st2;

        for (int i = 0; i < m1; i++) {
            int x, y;
            cin >> x >> y;
            if (x > y) {
                swap(x, y);
            }
            g1[x].push_back(y);
            g1[y].push_back(x);
            st1.insert({x, y});
        }

        for (int i = 0; i < m2; i++) {
            int x, y;
            cin >> x >> y;
            if (x > y) {
                swap(x, y);
            }
            g2[x].push_back(y);
            g2[y].push_back(x);
            st2.insert({x, y});
        }

        if (n == 3) {
            if (m1 >= 2) {
                cout << "Yes" << endl;
                cout << 0 << endl;
            } else if (m1 == 0) {
                cout << "No" << endl;
            } else {
                if (m2 == 3) {
                    cout << "Yes" << endl;
                    cout << 1 << endl;
                    if (g1[1].size() == 0) {
                        cout << 1 << " " << 2 << endl;
                    } else if (g1[2].size() == 0) {
                        cout << 2 << " " << 3 << endl;
                    } else if (g1[3].size() == 0) {
                        cout << 3 << " " << 1 << endl;
                    }
                } else {
                    if (!st2.count(*(st1.begin()))) {
                        cout << "No" << endl;
                    } else {
                        cout << "Yes" << endl;
                        cout << 1 << endl;
                        if (st2.count({1, 2})) {
                            cout << 1 << " " << 2 << endl;
                        } else if (st2.count({2, 3})) {
                            cout << 2 << " " << 3 << endl;
                        } else if (st2.count({1, 3})) {
                            cout << 1 << " " << 3 << endl;
                        }
                    }
                }
            }
            continue;
        }

        g = {};
        g.resize(n + 1);

        root = 1;
        h[1] = 1;
        get_ost(1);

        vector<pair<int, int>> ans;

        max_h = 0;
        get_max(root, 0, 0);

        if (max_h == 2) {
            vector<int> leafs;
            int center = -1;
            for (int i = 1; i <= n; i++) {
                if (g[i].size() == 1 && i != root) {
                    leafs.push_back(i);
                }
                if (g[i].size() > 1) {
                    center = i;
                }
            }
            int l1 = leafs[0];
            int l2 = leafs[1];
            g[l1] = {};
            g[center].erase(find(all(g[center]), l1));
            g[l2].push_back(l1);
            g[l1].push_back(l2);
            if (!st2.count({l1, l2})) {
                ans.push_back({l1, l2});
            }
        }

        h = {};
        h.resize(n + 1);

        layers = {};
        layers.resize(n + 1);

        get_l(root, -1, 0);

        for (int layer = 0; layer < n; layer++) {
            for (int j = 0; j < layers[layer].size() - 1; j++) {
                int q1 = layers[layer][j];
                int q2 = layers[layer][j + 1];
                if (q1 > q2) {
                    swap(q1, q2);
                }
                if (!st1.count({q1, q2})) {
                    ans.push_back({q1, q2});
                }
            }
        }

        for (int layer = 0; layer < n - 1; layer++) {
            if (layers[layer].size() && layers[layer + 2].size()) {
                int q1 = layers[layer][0];
                int q2 = layers[layer + 2][0];
                if (q1 > q2) {
                    swap(q1, q2);
                }
                if (!st1.count({q1, q2})) {
                    ans.push_back({q1, q2});
                }
            }
        }

        int q1 = layers[0][0];
        int q2 = layers[3][0];

        if (q1 > q2) {
            swap(q1, q2);
        }

        if (!st1.count({q1, q2})) {
            ans.push_back({q1, q2});
        }

        cout << "Yes" << endl;

        cout << ans.size() << endl;


        for (auto it: ans) {
            cout << it.ff << " " << it.ss << endl;
        }

        cout << endl;


    }

    cout << 1 / 0 << endl;

}