#include <bits/stdc++.h>
#define allv(x) (x).begin(), (x).end()
#define sz(x) ((int)(x).size())
using namespace std;
using ll = long long;

template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

#ifdef DEBUG
const ll MAXN = 20, INF = 1e5;
#else
const ll MAXN = 1e5 + 10, INF = 1e9 + 57;
#endif

int comp[MAXN];
vector<vector<int>> compvec;
set<pair<int, int>> e1, e2;
vector<int> g1[MAXN];
vector<int> g2[MAXN];
vector<pair<int, int>> ans;
int n;

void answer() {
    assert(sz(ans) <= n);
    cout << "Yes\n" << sz(ans) << '\n';
    for (auto [u, v] : ans) {
        cout << u << ' ' << v << '\n';
    }
    fill(comp, comp + n + 1, -1);
    compvec.clear();
    e1.clear();
    e2.clear();
    fill(g1, g1 + n + 1, vector<int>());
    fill(g2, g2 + n + 1, vector<int>());
    ans.clear();
    n = 0;
}
void answerNO() {
    cout << "No\n";
    fill(comp, comp + n + 1, -1);
    compvec.clear();
    e1.clear();
    e2.clear();
    fill(g1, g1 + n + 1, vector<int>());
    fill(g2, g2 + n + 1, vector<int>());
    ans.clear();
    n = 0;

}
bool ise1(int v, int u) {
    if (v > u) swap(v, u);
    return e1.find({v, u}) != e1.end();
}
bool ise2(int v, int u) {
    if (v > u) swap(v, u);
    return e2.find({v, u}) != e2.end();
}

void dfs1(int v) {
    for (int u : g1[v]) {
        if (comp[u] == -1) {
            comp[u] = comp[v];
            dfs1(u);
        }
    }
}

signed one() {
    int m1, m2;
    cin >> n >> m1 >> m2;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        g1[u].push_back(v);
        g1[v].push_back(u);
        e1.insert({min(v, u), max(v, u)});
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        e2.insert({min(v, u), max(v, u)});
        g2[u].push_back(v);
        g2[v].push_back(u);
    }
    for (int v = 1; v <= n; v++) {
        for (int u = v + 1; u <= n; u++) {
            if (u == v) continue;
            if (ise1(u, v) == ise2(u, v)) {
                if (!ise1(u, v)) {
                    ans.push_back({u, v});
                }
                for (int w = 1; w <= n; w++) {
                    if (w == u || w == v) continue;
                    if (ise1(u, w) || ise1(v, w)) continue;
                    if (!ise2(v, w)) {
                        ans.push_back({v, w});
                    } else {
                        ans.push_back({u, w});
                    }
                }
                answer();
                return 0;
            }
        }
    }
    int ncomp = 0;
    for (int v = 1; v <= n; v++) {
        if (comp[v] == -1) {
            comp[v] = ncomp;
            compvec.push_back({v});
            dfs1(v);
            if (sz(compvec.back()) == 1) {
                answerNO();
                return 0;
            }
            ncomp++;
        }
    }
    for (int c1 = 0; c1 < sz(compvec) - 1; c1++) {
        int c2 = c1 + 1;
        ans.push_back({compvec[c1].front(), compvec[c2].front()});
    }
    answer();
	return 0;
}


signed main() {
    int t, _;
    cin >> t >> _;
    fill(comp, comp + MAXN, -1);
    while (t--) {
        signed retcode = one();
        if (retcode) {
            return retcode;
        }
    }
    return 0;
}
