#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = 310000;

bool used[N];
int t, g, n, m1, m2, comp_cnt;
vector<int> g1[N], g2[N], comp[N];
set<pair<int, int>> st1, st2;
vector<pair<int, int>> ans;

void dfs(int v) {
	used[v] = true;
	comp[comp_cnt].push_back(v);
	for (int u : g1[v])
		if (!used[u])
			dfs(u);
}

void merge_comps(vector<int> &c1, vector<int>& c2) {
	bool good = false;
	for (int a : c1) {
		for (int b : c2) {
			if (st2.count({a, b})) continue;
			good = true;
			ans.push_back({a, b});
			break;
		}
		if (good) break;
	}
	if (!good) ans.push_back({c1[0], c2[0]});
}

void test_case() {
	cin >> n >> m1 >> m2;
	st1.clear();
	st2.clear();
	for (int i = 1; i <= n; i++) {
		g1[i].clear();
		g2[i].clear();
		comp[i].clear();
		used[i] = false;
	}
	for (int i = 1; i <= m1; i++) {
		int u, v; cin >> u >> v;
		g1[u].push_back(v);
		g1[v].push_back(u);
		st1.insert({u, v});
		st1.insert({v, u});
	}
	for (int i = 1; i <= m2; i++) {
		int u, v; cin >> u >> v;
		g2[u].push_back(v);
		g2[v].push_back(u);
		st2.insert({u, v});
		st2.insert({v, u});
	}
	comp_cnt = 0;
	for (int i = 1; i <= n; i++) {
		if (used[i]) continue;
		comp_cnt++;
		dfs(i);
	}
	ans.clear();
	for (int i = 1; i + 1 <= comp_cnt; i++)
		merge_comps(comp[i], comp[i + 1]);
	cout << "Yes\n";
	cout << (int) ans.size() << '\n';
	for (auto [x, y] : ans)
		cout << x << ' ' << y << '\n';
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> t >> g;
	while (t--) test_case();
}
