#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree< ll , null_type , less< ll > , rb_tree_tag , tree_order_statistics_node_update > oset;
typedef long double ld;
typedef pair< int , int > pii;
typedef pair< ll , ll > pll;


#define pb push_back
#define S second
#define F first
#define all(x) x.begin() , x.end()
#define sz(x) x.size()
#define int ll
#define itn int
#define ve vector

const int N = 3e5 + 123;
const int inf = 1e18 + 123;
const int mod = 1e9 + 7;
const int sqr = 500;

mt19937 gen( time( 0 ) );

ve< int > g1[N] , g2[N];

int n , m1 , m2;

int g;

int mg2[10][10];
int mg1[10][10];

bool check12()
{
    bool us[n];

    fill( us , us + n , 0 );

    us[0] = 1;

    queue< itn > q;

    q.push( 0 );

    while( sz( q ) )
    {
        int v = q.front();

        q.pop();

        for( int i = 0;i < n;++ i )
        {
            if( mg2[v][i] && !us[i] )
            {
                us[i] = 1;
                q.push( i );
            }
        }
    }

    bool f = 1;

    for( int i = 0;i < n;++ i )
    {
        f &= us[i];
    }

    return f;
}

bool check11()
{



    bool us[n];

    fill( us , us + n , 0 );

    us[0] = 1;

    queue< itn > q;

    q.push( 0 );

    while( sz( q ) )
    {
        int v = q.front();

//        cout << v << '\n';

        q.pop();

        for( int i = 0;i < n;++ i )
        {
            if( mg1[v][i] && !us[i] )
            {
                us[i] = 1;
                q.push( i );
            }
        }
    }

    bool f = 1;

    for( int i = 0;i < n;++ i )
    {
        f &= us[i];
    }

    return f;
}

void solve1()
{
    for( int i = 0;i < n;++ i )
    {
        for( itn j = 0;j < n;++ j )
        {
            mg1[i][j] = mg2[i][j] = 0;
        }
    }

    for( int i = 0;i < n;++ i )
    {
        for( auto to : g1[i] )
        {
            mg1[i][to] = mg1[to][i] = 1;
        }
    }

    for( int i = 0;i < n;++ i )
    {
        for( auto to : g2[i] )
        {
            mg2[i][to] = mg2[to][i] = 1;
        }
    }

    ve< pll > ed;

    for( int i = 0;i < n;++ i )
    {
        for( itn j = i + 1;j < n;++ j )
        {
            ed.pb( { i , j } );

//            cout << sz( ed ) - 1 << ' ' << i << ' ' << j << '\n';
        }
    }

    itn m = sz( ed );

    for( int mask = 0;mask < 64;++ mask )
    {

        bool F = 1;

        int kol = 0;

        for( int i = 0;i < m;++ i )
        {
            if( ( mask & ( 1ll << i ) ) > 0 )
            {

//                cout << i << '\n';

                ++ kol;

                mg1[ed[i].F][ed[i].S] ^= 1;
                mg1[ed[i].S][ed[i].F] ^= 1;

                mg2[ed[i].F][ed[i].S] ^= 1;
                mg2[ed[i].S][ed[i].F] ^= 1;

                F &= check12();

//                cout << F << '\n';
            }
        }

//        cout << check11() << '\n';

        if( F && check11() )
        {
            cout << "Yes\n";

//            cout << mask << '\n';

            cout << kol << '\n';

            for( int i = 0;i < m && F;++ i )
            {
                if( ( mask & ( 1ll << i ) ) > 0 )
                {
                    cout << ed[i].F + 1 << ' ' << ed[i].S+ 1 << '\n';
                }
            }

            return;
        }

        for( int i = 0;i < m;++ i )
        {
            if( ( mask & ( 1ll << i ) ) > 0 )
            {

//                cout << i << '\n';

                ++ kol;

                mg1[ed[i].F][ed[i].S] ^= 1;
                mg1[ed[i].S][ed[i].F] ^= 1;

                mg2[ed[i].F][ed[i].S] ^= 1;
                mg2[ed[i].S][ed[i].F] ^= 1;

                F &= check12();

//                cout << F << '\n';
            }
        }
    }

    cout << "No\n";
}

void solve2()
{
    map< int , bool > mp[n];

    for( int i = 0;i < n;++ i )
    {
        for( auto to : g1[i] )
        {
            mp[i][to] = 1;
        }
    }

    ve< pll > v;

    for( itn i = 0;i < n - 1;++ i )
    {
        if( !mp[i][i + 1] )
        {
            v.pb( { i , i + 1 } );
        }
    }

    cout << "Yes\n";
    cout << sz( v ) << '\n';

    for( auto to : v )
    {
        cout << to.F + 1 << ' ' << to.S + 1 << '\n';
    }

}



void solve()
{
    cin >> n >> m1 >> m2;

    for( int i = 0;i < n;++ i )
    {
        g1[i].clear();
        g2[i].clear();
    }

    for( int i = 0;i < m1;++ i )
    {
        int v , u;
        cin >> v >> u;

        -- v , -- u;

        g1[v].pb( u );
        g1[u].pb( v );
    }

    for( itn i = 0;i < m2;++ i )
    {
        int v , u;
        cin >> v >> u;

        -- v , -- u;

        g2[v].pb( u );
        g2[u].pb( v );
    }

    if( g == 1 || g == 0 )
    {
        solve1();
    }

    if( g == 2 )
    {
        solve2();
    }
}


int32_t main()
{
    #ifdef LOCAL
        freopen( "input.txt" , "r" , stdin );
        freopen( "output.txt" , "w" , stdout );
    #endif // LOCAL

    ios_base::sync_with_stdio( 0 );
    cin.tie( 0 );
    cout.tie( 0 );

    int t = 1;
    cin >> t >> g;

    while( t -- )
    {
        solve();
    }
}
