#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(12412415);

vector<vector<long long>> g;
vector<bool> used, is_lst;
map<pair<int, int>, int> usedd;
map<pair<int, int>, bool> mapp, mapp2;
int lst = -1, lst_p = -1, lst_cnt;


void dfs(int v, int p)
{
    used[v] = 1;
    int cnt = 0;
    for(auto num : g[v])
    {
        if(!used[num])
        {
            usedd[{num, v}] = 1;
            usedd[{v, num}] = 1;
            dfs(num, v);
            cnt++;
        }
    }
    if(cnt == 0)
    {
        lst_cnt++;
        is_lst[v] = 1;
        lst = v;
        lst_p = p;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    long long t, gg;
    cin >> t >> gg;
    while(t--)
    {
        long long n, m1, m2;
        cin >> n >> m1 >> m2;

        g.clear();
        is_lst.clear();
        used.clear();
        usedd.clear();
        mapp.clear();
        mapp2.clear();
        lst_cnt = 0;
        g.resize(n);
        is_lst.resize(n);
        used.resize(n);

        for(int i = 0; i < m1; i++)
        {
            int a, b;
            cin >> a >> b;
            a--, b--;
            mapp[{a, b}] = 1;
            mapp[{b, a}] = 1;
        }
        int root = 0;
        for(int i = 0; i < m2; i++)
        {
            int a, b;
            cin >> a >> b;
            a--, b--;
            mapp2[{a, b}] = 1;
            mapp2[{b, a}] = 1;
            g[a].push_back(b);
            g[b].push_back(a);
        }
        for(int i = 0; i < n; i++)
        {
            if(g[i].size() > 1)
            {
                root = i;
                break;
            }
        }
        dfs(root, root);


        vector<pair<int, int>> ans;
        for(int i = 0; i < n; i++)
        {
            if(lst != i && lst_p != i && !mapp[{lst, i}])
            {
                ans.push_back({i + 1, lst + 1});
            }
        }
        bool is_g = 0;
        for(int i = 0; i < n; i++)
        {
            if(lst_p != i && mapp[{lst_p, i}])
            {
                is_g = 1;
                break;
            }
        }
        if(is_g)
        {
            cout << "YES" << "\n";
            cout << ans.size() << "\n";
            for(int i = 0; i < ans.size(); i++)
            {
                cout << ans[i].first << ' ' << ans[i].second << '\n';
            }
            continue;
        }
        if(lst_cnt == n - 1)
        {
            is_g = 0;
            for(int i = 0; i < n; i++)
            {
                bool findd = 0;
                int lst2 = -1;
                if(!is_lst[i]){continue;}
                for(int j = 0; j < n; j++)
                {
                    if(j != i && is_lst[j])
                    {
                        lst2 = j;
                        findd = 1;
                        break;
                    }
                }
                if(findd)
                {
                    if(!mapp2[{i, lst2}])
                    {
                        ans.push_back({i + 1, lst2 + 1});
                    }
                    ans.push_back({i + 1, lst_p + 1});
                    is_g = 1;
                    break;
                }
            }
            if(!is_g)
            {
                cout << "NO" << "\n";
                continue;
            }
            cout << "YES" << "\n";
            cout << ans.size() << "\n";
            for(int i = 0; i < ans.size(); i++)
            {
                cout << ans[i].first << ' ' << ans[i].second << '\n';
            }
            continue;
        }
        bool flag = 0;
        for(int i = 0; i < n; i++)
        {
            if(lst_p != i && !usedd[{lst_p, i}] && lst != i)
            {
                flag = 1;
                if(mapp[{lst_p, i}])
                {
                    break;
                }
                ans.push_back({lst_p + 1, i + 1});
                break;
            }
        }
        if(!flag)
        {
            cout << "NO" << "\n";
            continue;
        }
        cout << "YES" << "\n";
        cout << ans.size() << "\n";
        for(int i = 0; i < ans.size(); i++)
        {
            cout << ans[i].first << ' ' << ans[i].second << '\n';
        }
    }
    return 0;
}
