#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <random>
#include <unordered_map>
#define ll long long
#define vll vector <ll>
#define f(i, n) for(ll i = 0; i < (ll)n; i++)
#define pll pair <ll, ll>
using namespace std;
random_device rd;



ll n, m1, m2, ui, vi;


void dfs(ll v, vector <set <ll>> &g, vector <bool> &used) {

	used[v] = true;
	for (auto it : g[v]) {
		if (!used[it]) {
			dfs(it, g, used);
		}
	}
}

bool check(vector <set <ll>> &g) {

	vector <bool> used(n);
	dfs(0, g, used);
	return (count(used.begin(), used.end(), true) == n);
}

void solve() {
	
	cin >> n >> m1 >> m2;

	vector <set <ll>> g(n), g1(n), startg(n), startg1(n);

	vector < pll > roads;

	f(i, n) {
		for (ll j = i + 1; j < n; j++) {
			roads.push_back({i, j});
		}
	}

	f(i, m1) {
		cin >> ui >> vi;
		ui--, vi--;

		g[ui].insert(vi);
		g[vi].insert(ui);
		startg[ui].insert(vi);
		startg[vi].insert(ui);
	}
	f(i, m2) {
		cin >> ui >> vi;
		ui--, vi--;
		g1[ui].insert(vi);
		g1[vi].insert(ui);
		startg1[ui].insert(vi);
		startg1[vi].insert(ui);
	}

	string s;
	vector <pll> answer;
	ll ans = 1e18;

	f(i, (1ll << (n * (n - 1) / 2))) {
		s = "";
		ll c = i;
		while (c > 0) {
			s += (c % 2) + '0';
			c /= 2;
		}
		reverse(s.begin(), s.end());
		while (s.size() < n * (n - 1) / 2) {
			s.insert(s.begin(), '0');
		}
		vector <pll> cur;
		cur.clear();

		f(j, roads.size()) {
			
			ll u = roads[j].first;
			ll v = roads[j].second;
			if (s[j] == '1') {
				cur.push_back({ u, v });
				if (g[u].find(v) == g[u].end()) {
					g[u].insert(v);
					g[v].insert(u);	
				}
				else {
					g[u].erase(v);
					g[v].erase(u);
				}

				if (g1[u].find(v) == g1[u].end()) {
					g1[u].insert(v);
					g1[v].insert(u);
				}
				else {
					g1[u].erase(v);
					g1[v].erase(u); 
				}
			}
		}

		if (cur.size() <= n && check(g) && check(g1)) {
			ans = cur.size();
			answer = cur;
			break;
		}
		g = startg;
		g1 = startg1;
	}

	if (ans == 1e18) {
		cout << "No\n";
		return;
	}
	else {
		cout << "Yes\n";
		cout << answer.size() << '\n';
		for (auto it : answer) {
			cout << it.first + 1 << " " << it.second + 1 << "\n";
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	ll tt = 1, g;
	cin >> tt >> g;
	while (tt--) {
		solve();
	}
}