//#pragma GCC ("03, unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second

const ll inf = 1e15;

void dfs(ll v, vector<ll> &used, vector<vector<ll>> &g) {
    used[v] = 1;
    for(auto u : g[v]) {
        if (!used[u]) {
            dfs(u, used, g);
        }
    }
}

void solve() {
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<ll>> gg(n, vector<ll> (n, 0));
    for(int i = 0; i < m1; ++i) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        gg[u][v] = 1;
        gg[v][u] = 1;
    }
    vector<vector<ll>> gg1(n, vector<ll> (n, 0));
    for(int i = 0; i < m2; ++i) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        gg1[u][v] = 1;
        gg1[v][u] = 1;
    }
    ll col = n * (n - 1) / 2;
    vector<pair<ll, ll>> reb(col);
    ll pos = 0;
    for(int i = 0; i < n; ++i) {
        for(int j = i + 1; j < n; ++j) {
            reb[pos] = {i, j};
            pos++;
        }
    }
    vector<ll> used(n, 0);
    vector<vector<ll>> g(n);
    for(int i = 0; i < (1 << col); ++i) {
        ll cnt = 0;
        used.assign(n, 0);
        for(int j = 0; j < n; ++j) {
            g[j].clear();
        }
        for(int j = 0; j < col; ++j) {
            ll u = reb[j].fi, v = reb[j].se;
            if ((i >> j) & 1) {
                cnt++;
                if (gg[u][v] == 0) {
                    g[u].push_back(v);
                    g[v].push_back(u);
                }
            } else if (gg[u][v]) {
                g[u].push_back(v);
                g[v].push_back(u);
            }
        }
        dfs(0, used, g);
        bool ok = 1;
        for(int j = 0; j < n; ++j) {
            ok &= used[j];
        }
        used.assign(n, 0);
        for(int j = 0; j < n; ++j) {
            g[j].clear();
        }
        for(int j = 0; j < col; ++j) {
            ll u = reb[j].fi, v = reb[j].se;
            if ((i >> j) & 1) {
                if (gg1[u][v] == 0) {
                    g[u].push_back(v);
                    g[v].push_back(u);
                }
            } else if (gg1[u][v]) {
                g[u].push_back(v);
                g[v].push_back(u);
            }
        }
        dfs(0, used, g);
        for(int j = 0; j < n; ++j) {
            ok &= used[j];
        }
        if (cnt <= n && ok) {
            cout << "Yes\n";
            cout << cnt << '\n';
            for(int j = 0; j < col; ++j) {
                ll u = reb[j].fi, v = reb[j].se;
                if ((i >> j) & 1) {
                    cout << u + 1 << ' ' << v + 1 << '\n';
                }
            }
            return;
        }
    }
    cout << "No\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T = 1;
    cin >> T;
    ll g;
    cin >> g;
    while(T--) {
        solve();
        // cout << '\n';
    }
    return 0;
}