//#pragma GCC ("03, unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second

const ll inf = 1e15;

void dfs(ll v, vector<ll> &used, vector<vector<ll>> &g) {
    used[v] = 1;
    for(auto u : g[v]) {
        if (!used[u]) {
            dfs(u, used, g);
        }
    }
}

void solve() {
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<ll>> gg(n, vector<ll> (n, 0));
    for(int i = 0; i < m1; ++i) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        gg[u][v] = 1;
        gg[v][u] = 1;
    }
    vector<vector<ll>> gg1(n, vector<ll> (n, 0));
    for(int i = 0; i < m2; ++i) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        gg1[u][v] = 1;
        gg1[v][u] = 1;
    }

    if (m2 == n * (n - 1) / 2ll) {
        vector<pair<ll, ll>> ans;
        if (n == 3) {
            if ((gg[0][1] && gg[0][2]) || (gg[0][1] && gg[1][2]) || (gg[2][1] && gg[0][2])) {
                cout << "Yes\n";
                cout << 0 << '\n';
                return;
            } else if (gg[0][1]) {
                cout << "Yes\n";
                cout << 1 << '\n';
                cout << "1 3\n";
                return;
            } else if (gg[0][2] || gg[1][2]) {
                cout << "Yes\n";
                cout << 1 << '\n';
                cout << "1 2\n";
                return;
            }
            cout << "No\n";
            return;
        }
        for(int i = 0; i < n - 1; ++i) {
            if (gg[i][i + 1] == 0) {
                ans.push_back({i + 1, i + 2});
            }
        }
        cout << "Yes\n";
        cout << (int)ans.size() << '\n';
        for(auto it : ans) {
            cout << it.fi + 1 << ' ' << it.se + 1 << '\n';
        }
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll T = 1;
    cin >> T;
    ll g;
    cin >> g;
    while(T--) {
        solve();
        // cout << '\n';
    }
    return 0;
}