#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <unordered_map>

using namespace std;

#define int long long
vector<vector<bool>> l1;
vector<vector<bool>> l2;

vector<int> p;
vector<int> p2;
void init(int n) {
	p2 = vector<int>(n, 1);
	p = vector<int>(n);
	for (int i = 0; i < n; i++) p[i] = i;
}

int pred(int a) {
	if (a == p[a]) return a;
	p[a] = pred(p[a]);
	return p[a];
}

void un(int a, int b) {
	a = pred(a);
	b = pred(b);
	if (p2[a] > p2[b]) swap(a, b);
	p[a] = b;
	p2[b] += p2[a];
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t, g;
	cin >> t >> g;
	for (; t > 0; t--) {
		int n, m1, m2;
		cin >> n >> m1 >> m2;
		if (g == 2) {
			int ha = 0;
			l1 = vector<vector<bool>>(n, vector<bool>(n));
			l2 = vector<vector<bool>>(n, vector<bool>(n));
			for (int i = 0; i < m1; i++) {
				int a, b;
				cin >> a >> b;
				a--; b--;
				l1[a][b] = true;
				l1[b][a] = true;
			}

			for (int i = 0; i < m2; i++) {
				int a, b;
				cin >> a >> b;
				a--; b--;
				l2[a][b] = true;
				l2[b][a] = true;
				ha++;
			}
			vector<pair<int, int>> ans;
			for (int i = 0; i < n - 1; i++) {
				if (!l1[i][i + 1]) {
					ans.push_back({ i, i + 1 });
					if (l2[i][i + 1]) ha--;
					else ha++;
				}
			}
			if (n == 3 and ha < 2) {
				if (l1[0][1] and l1[1][2]) cout << "Yes\n0\n";
				else if (l1[0][2] and l1[2][1]) cout << "Yes\n0\n";
				else if (l1[0][1] and l1[0][2]) cout << "Yes\n0\n";
				else if (l1[0][1]) cout << "Yes\n1\n2 3\n";
				else if (l1[0][2]) cout << "Yes\n1\n1 2\n";
				else if (l1[1][2]) cout << "Yes\n1\n2 1\n";
				else cout << "No\n";
				continue;
			}
			cout << "Yes\n";
			cout << ans.size() << "\n";
			for (auto i : ans) {
				cout << i.first + 1 << " " << i.second + 1 << "\n";
			}
		}
		else if (g == 3) {
			init(n);
			l1 = vector<vector<bool>>(n, vector<bool>(n));
			l2 = vector<vector<bool>>(n, vector<bool>(n));
			for (int i = 0; i < m1; i++) {
				int a, b;
				cin >> a >> b;
				a--; b--;
				l1[a][b] = true;
				l1[b][a] = true;
				if (pred(a) != pred(b)) un(a, b);
			}

			for (int i = 0; i < m2; i++) {
				int a, b;
				cin >> a >> b;
				a--; b--;
				l2[a][b] = true;
				l2[b][a] = true;
			}
			vector<pair<int, int>> ans;
			vector<int> u1;
			vector<int> u2;
			int he = -1;
			for (int i = 0; i < n; i++) {
				if (he == -1 or pred(i) == he) {
					he = pred(i);
					u1.push_back(i);
				}
				else {
					u2.push_back(i);
				}
			}
			for (int i = 0; i < u1.size(); i++) {
				for (int j = 0; j < u2.size(); j++) {

				}
			}
			cout << "Yes\n";
			cout << ans.size() << "\n";
			for (auto i : ans) {
				cout << i.first + 1 << " " << i.second + 1 << "\n";
			}
		}
		else if (g == 5 or g == 9) {
			vector<map<int, bool>> l1(n);
			vector<map<int, bool>> l2(n);
			for (int i = 0; i < m1; i++) {
				int a, b;
				cin >> a >> b;
				a--; b--;
				l1[a][b] = true;
				l1[b][a] = true;
			}
			for (int i = 0; i < m2; i++) {
				int a, b;
				cin >> a >> b;
				a--; b--;
				l2[a][b] = true;
				l2[b][a] = true;
			}
			if (n == 3) {
				if (l1[0][1] and l1[1][2]) cout << "Yes\n0\n";
				else if (l1[0][2] and l1[2][1]) cout << "Yes\n0\n";
				else if (l1[0][1] and l1[0][2]) cout << "Yes\n0\n";
				else if (l1[0][1]) cout << "Yes\n1\n1 3\n";
				else if (l1[1][2]) cout << "Yes\n1\n1 3\n";
				else if (l1[0][2]) cout << "No\n";
				else {
					cout << "Yes\n2\n1 3\n1 2\n";
				}
				continue;
			}
			vector<pair<int, int>> ans;
			for (int i = 0; i < n - 2; i++) {
				if (!l1[i][(i + 2) % n]) {
					l1[i][(i + 2) % n] = true;
					ans.push_back({ i, (i + 2) % n });
				}
			}
			if (!l1[0][3]) {
				l1[0][3] = true;
				ans.push_back({ 0, 3 });
			}
			cout << "Yes\n";
			cout << ans.size() << "\n";
			for (auto i : ans) {
				cout << i.first + 1 << " " << i.second + 1 << "\n";
			}
		}
	}

}

/*


*/
