#include <bits/stdc++.h>
using namespace std;
#define int long long
int groop;
vector <vector <int>> g1, g2;
vector <int> used1, used2, minup, depth;
void dfs1(int v){
    used1[v] = 1;
    for (int i = 0; i < g1[v].size(); ++i){
        if (g1[v][i] == 1 && !used1[i]){
            dfs1(i);
        }
    }
}
void dfs2(int v){
    used2[v] = 1;
    for (int i = 0; i < g2[v].size(); ++i){
        if (g2[v][i] == 1 && !used2[i]){
            dfs2(i);
        }
    }
}
set <pair <int, int>> bridge;
void br(int v, int dep, int p){
    used2[v] = 1;
    minup[v] = dep;
    depth[v] = dep;
    for (int i = 0; i < g2[v].size(); ++i){
        if (g2[v][i] == 1 && !used2[i]){
            br(i, dep + 1, v);
            minup[v] = min(minup[v], minup[i]);
            if (minup[i] > dep){
                bridge.insert({min(v, i), max(v, i)});
            }
        }
        else if(g2[v][i] == 1 && i != p){
            minup[v] = min(minup[v], depth[i]);
        }
    }
}
void solve(){
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g1.resize(n, vector <int> (n));
    g2.resize(n, vector <int> (n));
    used1.resize(n);
    used2.resize(n);
    vector <pair <int, int>> edges;
    for (int i = 0; i < n; ++i){
        for (int j = i + 1; j < n; ++j){
            edges.push_back({i, j});
        }
    }
    for (int i = 0; i < m1; ++i){
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g1[u][v] = 1;
        g1[v][u] = 1;
    }
    for (int i = 0; i < m2; ++i){
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g2[u][v] = 1;
        g2[v][u] = 1;
    }
    if (n <= 5){
        for (int mask = 0; mask < (1 << edges.size()); ++mask){
            vector <int> changes;
            for (int i = 0; i < edges.size(); ++i){
                if ((mask >> i) & 1){
                    changes.push_back(i);
                }
            }
            if (changes.size() > n){
                continue;
            }
            for (auto p : changes){
                g1[edges[p].first][edges[p].second] = 1 - g1[edges[p].first][edges[p].second];
                g1[edges[p].second][edges[p].first] = 1 - g1[edges[p].second][edges[p].first];
            }
            bool f = 1;
            used1.assign(n, 0);
            dfs1(0);
            for (auto x : used1){
                f &= x;
            }
            if (f){
                do{
                    f = 1;
                    for (auto p : changes){
                        g2[edges[p].second][edges[p].first] = 1 - g2[edges[p].second][edges[p].first];
                        g2[edges[p].first][edges[p].second] = 1 - g2[edges[p].first][edges[p].second];
                        used2.assign(n, 0);
                        dfs2(0);
                        for (auto x : used2){
                            f &= x;
                        }
                    }
                    if (f){
                        cout << "Yes\n";
                        cout << changes.size() << "\n";
                        for (auto p: changes){
                            cout << edges[p].first + 1 << " " << edges[p].second + 1 << "\n";
                        }
                        /*for (auto x: g2){
                            for (auto y : x){
                                cout << y << " ";
                            }
                            cout << "\n";
                        }*/
                        return;
                    }
                    for (auto p : changes){
                        g2[edges[p].second][edges[p].first] = 1 - g2[edges[p].second][edges[p].first];
                        g2[edges[p].first][edges[p].second] = 1 - g2[edges[p].first][edges[p].second];
                    }
                }while (next_permutation(changes.begin(), changes.end()));
            }
            for (auto p : changes){
                    //cout << p << " ";
                g1[edges[p].first][edges[p].second] = 1 - g1[edges[p].first][edges[p].second];
                g1[edges[p].second][edges[p].first] = 1 - g1[edges[p].second][edges[p].first];
                //g2[edges[p].second][edges[p].first] = 1 - g2[edges[p].second][edges[p].first];
                //g2[edges[p].first][edges[p].second] = 1 - g2[edges[p].first][edges[p].second];
               // g2[edges[p].first][edges[p].second] |= 1;
            }
        }
        cout << "No\n";
    }
    else{
        minup.resize(n);
        depth.resize(n);
        br(0, 1, -1);
        dfs1(0);
        vector <int> fs, sc;
        for (int i = 0; i < n; ++i){
            if (used1[i]){
                fs.push_back(i);
            }
            else{
                sc.push_back(i);
            }
        }
        if (fs.size() == n){
            cout << "Yes\n";
            cout << 0;
            return;
        }
        for (auto x: fs){
            for (auto y: sc){
                if (g2[x][y] == 0 || bridge.count({min(x, y), max(x, y)}) == 0){
                    cout << "Yes\n";
                    cout << 1 << "\n" << x + 1 << " " << y + 1 << "\n";
                    return;
                }
            }
        }
        cout << "No";
        exit(-1);
    }
}
signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tk = 1;
    cin >> tk >> groop;
    while (tk--){
        solve();
        g1.clear();
        used1.clear();
        g2.clear();
        used2.clear();
    }
}


