#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <deque>
#include <random>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e9 + 7;
const ll INFll = 1e18;
const ll M1 = 1e9 + 7, M2 = 1e9 + 9;
const ll P1 = 137, P2 = 239;
const ld PI = atan2(0, -1), EPS = 1e-10;

void dfs(int v, vector<int>& used, vector<set<int>>& g1, int i) {
	used[v] = i;
	for (auto u : g1[v]) {
		if (used[u] == 0) {
			dfs(u, used, g1, i);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	freopen("i.txt", "r", stdin), freopen("o.txt", "w", stdout);

	//cout << fixed << setprecision(20);

	int t, group;
	cin >> t >> group;
	while (t--) {
		cout << '\n';
		int n, m1, m2;
		cin >> n >> m1 >> m2;
		vector<set<int>> g1(n), g2(n);
		for (int i = 0; i < m1; ++i) {
			int x, y;
			cin >> x >> y;
			x--;
			y--;
			g1[x].insert(y);
			g1[y].insert(x);
		}
		for (int i = 0; i < m2; ++i) {
			int x, y;
			cin >> x >> y;
			x--;
			y--;
			g2[x].insert(y);
			g2[y].insert(x);
		}
		if (group <= 1) {

		}
		else if (group == 2) {
			if (n == 3) {
				if (m1 == 0) {
					cout << "No";
				}
				else {
					cout << "Yes" << '\n';
					if (m1 >= 2) {
						cout << 0;
					}
					else {
						cout << 1 << '\n';
						if (g1[0].size() == 0) {
							cout << 1 << " " << 2;
						}
						else if (g1[1].size() == 0) {
							cout << 2 << " " << 1;
						}
						else {
							cout << 1 << " " << 3;
						}
					}
				}
			}
			else {
				cout << "Yes" << '\n';
				vector<pair<int, int>> ans;
				for (int i = 0; i < n - 1; ++i) {
					if (g1[i].find(i + 1) == g1[i].end()) {
						ans.push_back({ i, i + 1 });
					}
				}
				cout << ans.size() << '\n';
				for (auto [x, y] : ans) {
					cout << x + 1 << " " << y + 1 << '\n';
				}
			}
		}
		else if (group == 3) {
			vector<int> used(n, 0);
			for (int i = 0; i < n; ++i) {
				if (used[i] == 0) {
					dfs(i, used, g1, i + 1);
				}
			}
			vector<int> a, b;
			for (int i = 0; i < n; ++i) {
				if (used[i] == 1) {
					a.push_back(i);
				}
				else {
					b.push_back(i);
				}
			}
			bool f = true;
			for (auto x : a) {
				for (auto y : b) {
					if (g2[x].find(y) == g2[x].end()) {
						f = false;
						cout << "Yes" << '\n' << 1 << '\n' << x + 1 << " " << y + 1;
						break;
					}
				}
				if (!f) {
					break;
				}
			}
			if (f) {
				if (a.size() == 1) {
					bool ans = true;
					for (int i = 0; i < b.size() - 1; ++i) {
						for (int j = i + 1; j < b.size(); ++j) {
							if (g2[b[i]].find(b[j]) != g2[b[i]].end()) {
								ans = false;
								cout << "Yes" << '\n' << 1 << '\n' << a[0] + 1 << " " << b[i] + 1;
								break;
							}
						}
						if (!ans) {
							break;
						}
					}
					if (ans) {
						for (int i = 0; i < b.size() - 1; ++i) {
							for (int j = i + 1; j < b.size(); ++j) {
								if (g1[b[i]].find(b[j]) == g1[b[i]].end()) {
									ans = false;
									cout << "Yes" << '\n' << 2 << '\n' << b[i] + 1 << " " << b[j] + 1 << '\n' << a[0] + 1 << b[i] + 1;
									break;
								}
							}
							if (!ans) {
								break;
							}
						}
						if (ans) {
							if (n == 3) {
								cout << "No";
							}
							else {
								cout << "Yes" << '\n' << 2 << '\n' << b[0] + 1 << " " << b[1] + 1 << '\n' << a[0] + 1 << b[0] + 1;
							}
						}
					}
				}
				else if (b.size() == 1) {
					bool ans = true;
					for (int i = 0; i < a.size() - 1; ++i) {
						for (int j = i + 1; j < a.size(); ++j) {
							if (g2[a[i]].find(a[j]) != g2[a[i]].end()) {
								ans = false;
								cout << "Yes" << '\n' << 1 << '\n' << b[0] + 1 << " " << a[i] + 1;
								break;
							}
						}
						if (!ans) {
							break;
						}
					}
					if (ans) {
						for (int i = 0; i < a.size() - 1; ++i) {
							for (int j = i + 1; j < a.size(); ++j) {
								if (g1[a[i]].find(a[j]) == g1[a[i]].end()) {
									ans = false;
									cout << "Yes" << '\n' << 2 << '\n' << a[i] + 1 << " " << a[j] + 1 << '\n' << b[0] + 1 << a[i] + 1;
									break;
								}
							}
							if (!ans) {
								break;
							}
						}
						if (ans) {
							if (n == 3) {
								cout << "No";
							}
							else {
								cout << "Yes" << '\n' << 2 << '\n' << a[0] + 1 << " " << a[1] + 1 << '\n' << a[0] + 1 << b[0] + 1;
							}
						}
					}
				}
				else {
					cout << "Yes" << '\n' << 1 << '\n' << a[0] + 1 << " " << b[0] + 1;
				}
			}
		}
		else if (group == 5) {

		}
		else if (group == 9) {
			if (n == 3) {
				if (g1[0].find(2) != g1[0].end() && m1 < 2) {
					cout << "No";
				}
				else if (m1 >= 2) {
					cout << "Yes" << '\n' << 0;
				}
				else {
					cout << "Yes" << '\n' << 1 << '\n' << 1 << " " << 3;
				}
			}
			else {
				vector<pair<int, int>> ans;
				for (int i = 2; i < n; ++i) {
					if (g1[0].find(i) == g1[0].end()) {
						ans.push_back({ 0, i });
					}
				}
				for (int i = 3; i < n; ++i) {
					if (g1[1].find(i) == g1[1].end()) {
						ans.push_back({ 1, i });
						break;
					}
				}
				cout << "Yes" << '\n' << ans.size() << '\n';
				for (auto [x, y] : ans) {
					cout << x + 1 << " " << y + 1 << '\n';
				}
			}
		}
		else {
			return 0;
		}
	}
}