#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long double ld;
typedef long long ll;

#define int long long

//#pragma GCC optnimize("Ofast")
//#pragma GCC target("avx2")

void solve2() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> s;
    for (int i = 0; i < m1; i++) {
        int x, y;
        cin >> x >> y;
        s.insert({x, y});
        s.insert({y, x});
    }
    for (int i = 0; i < m2; i++) {
        int x, y;
        cin >> x >> y;
    }
    if (n == 2) {
        if (m1 == 1) {
            cout << "Yes\n0\n";
            return;
        } else {
            cout << "No\n";
            return;
        }
    }
    if (n == 3) {
        if (m1 == 0) {
            cout << "No\n";
            return;
        }
        if (m1 >= 2) {
            cout << "Yes\n" << 0 << '\n';
            return;
        }
        cout << "Yes\n";
        cout << 1 << '\n';
        for (int i = 1; i <= n; i++) {
            for (int j = i + 1; j <= n; j++) {
                if (s.count({i, j}) == 0) {
                    cout << i << ' ' << j << '\n';
                    return;
                }
            }
        }
    }
    cout << "Yes\n";
    vector<pair<int, int>> ans;
    for (int i = 1; i < n; i++) {
        if (s.count({i, i + 1}) == 0) {
            ans.push_back({i, i + 1});
        }
    }
    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i].first << ' ' << ans[i].second << '\n';
    }
}

vector<set<int>> g1, g2;
vector<int> vis;

void dfs(int v, vector<set<int>> &q) {
    vis[v] = 1;
    for (int i: q[v]) {
        if (!vis[i]) dfs(i, q);
    }
}

void solve1() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> s;
    g1.resize(n);
    g2.resize(n);
    for (int i = 0; i < m1; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        g1[x].insert(y);
        g1[y].insert(x);
    }
    for (int i = 0; i < m2; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        g2[x].insert(y);
        g2[y].insert(x);
    }
    vector<pair<int, int>> p;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            p.push_back({i, j});
        }
    }
    for (int mask = 0; mask < (1 << (p.size())); mask++) {
        bool b = 0;
        auto q1 = g1, q2 = g2;
        for (int i = 0; i < p.size(); i++) {
            if ((mask & (1 << i)) == 0) continue;
            int x = p[i].first, y = p[i].second;
            if (q1[x].count(y)) {
                q1[x].erase(y);
                q1[y].erase(x);
            } else {
                q1[x].insert(y);
                q1[y].insert(x);
            }
            if (q2[x].count(y)) {
                q2[x].erase(y);
                q2[y].erase(x);
            } else {
                q2[x].insert(y);
                q2[y].insert(x);
            }
            vis.assign(n, 0);
            dfs(0, q2);
            for (int j = 0; j < n; j++) {
                if (!vis[j]) b = 1;
            }
        }
        vis.assign(n, 0);
        dfs(0, q1);
        for (int i = 0; i < n; i++) {
            if (!vis[i]) b = 1;
        }
        vis.assign(n, 0);
        dfs(0, q2);
        for (int i = 0; i < n; i++) {
            if (!vis[i]) b = 1;
        }
        if (b) continue;
        cout << "Yes\n";
        cout << __builtin_popcount(mask) << '\n';
        for (int i = 0; i < p.size(); i++) {
            if (mask & (1 << i)) {
                cout << p[i].first + 1 << ' ' << p[i].second + 1 << '\n';
            }
        }
        return;
    }
    cout << "No\n";
}

signed main() {
//    ios::sync_with_stdio(0);
//    cin.tie(0);
    int t, g;
    cin >> t >> g;
    while (t--) {
        if (g == 2) solve2();
        else solve1();
    }
}