#include <bits/stdc++.h>
using ll = long long;
using namespace std;
ll gg;
ll n, m1, m2;
vector <vector <ll > > g1, g2;
vector <ll > used;
void dfs(ll v, vector <vector <ll > > &g) {
    used[v] = 1;
    for (ll i = 0; i < n; i++) {
        if (!used[i] && g[v][i]) {
            dfs(i, g);
        }
    }
}
bool is_svz() {
    used.assign(n, 0);
    dfs(0, g1);
    for (auto e : used) {
        if (!e) {
            return 0;
        }
    }
    used.assign(n, 0);
    dfs(0, g2);
    for (auto e : used) {
        if (!e) {
            return 0;
        }
    }
    return 1;
}
ll fact(ll n) {
    ll res = 1;
    for (ll i = 1; i <= n; i++) {
        res *= i;
    }
    return res;
}
void solve() {
    cin >> n >> m1 >> m2;
    g1.assign(n, vector <ll > (n));
    g2.assign(n, vector <ll > (n));
    for (ll i = 0; i < m1; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        g1[u][v] = 1;
        g1[v][u] = 1;
    }
    for (ll i = 0; i < m2; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        g2[u][v] = 1;
        g2[v][u] = 1;
    }
    if (m2 == n * (n - 1) / 2) {
        vector <pair <ll, ll > > xp;
        for (ll i = 0; i < n; i++) {
            for (ll j = i + 1; j < n; j++) {
                if ((g1[i][j] & g2[i][j]) == 0)
                    xp.push_back({i, j});
            }
        }
        for (ll h = 0; h <= min((ll)xp.size(), n); h++) {
            sort(xp.begin(), xp.end());
            ll cnt = fact((ll)xp.size());
            while (cnt--) {
                next_permutation(xp.begin(), xp.end());
                for (ll i = 0; i < h; i++) {
                    auto [u, v] = xp[i];
                    g1[u][v] ^= 1;
                    g1[v][u] ^= 1;
                    g2[u][v] ^= 1;
                    g2[v][u] ^= 1;
                }
                if (is_svz()) {
                    cout << "Yes" << endl;
                    cout << h << endl;
                    for (ll i = 0; i < h; i++) {
                        auto [u, v] = xp[i];
                        cout << u + 1 << ' ' << v + 1 << endl;
                    }
                    /*
                    for (ll i = 0; i < n; i++) {
                        for (ll j = 0; j < n; j++) {
                            cout << g1[i][j];
                        }
                        cout << endl;
                    }
                    cout << endl;
                    for (ll i = 0; i < n; i++) {
                        for (ll j = 0; j < n; j++) {
                            cout << g2[i][j];
                        }
                        cout << endl;
                    }
                    cout << endl;
                    */
                    return;
                }
                for (ll i = 0; i < h; i++) {
                    auto [u, v] = xp[i];
                    g1[u][v] ^= 1;
                    g1[v][u] ^= 1;
                    g2[u][v] ^= 1;
                    g2[v][u] ^= 1;
                }
            }
        }
        cout << "No" << endl;
    } else {
        vector <ll > ans;
        for (ll i = 0; i < n - 1; i++) {
            if (g1[i][i + 1] == 0) {
                ans.push_back(i);
            }
        }
        cout << "Yes" << endl;
        cout << ans.size() << endl;
        for (auto e : ans) {
            cout << e + 1 << ' ' << e + 2 << endl;
        }
    }


}
int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll Z; cin >> Z >> gg; while(Z--)
    solve();
    return 0;
}
