#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")
//#pragma GCC optimize("unroll-loops")

using namespace std;

using ll = long long;
using ld = long double;
const char endc = '\n';

using namespace std;

int gr;

inline void work() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> borders1, borders2;
    vector<vector<int>> g1(n);
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        if (a > b) swap(a, b);
        g1[a].push_back(b);
        g1[b].push_back(a);
        borders1.insert({a, b});
    }
    for (int j = 0; j < m2; ++j) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        if (a > b) swap(a, b);
        borders2.insert({a, b});
    }
    vector<pair<int, int>> answer;
    for (int i = 1; i < n - 1; ++i) {
        if (!borders1.count({i, i + 1})) answer.push_back({i, i + 1});
    }
    if (g1[0].size() > 0) {
        cout << "Yes" << endc;
        cout << answer.size() << endc;
        for (int i = 0; i < answer.size(); ++i) {
            cout << answer[i].first + 1 << ' ' << answer[i].second + 1 << endc;
        }
    } else {
        if (answer.size() == 0) {
            if (n == 3) {
                cout << "No" << endc;
                return;
            } else {
                answer.push_back({0, 1});
                answer.push_back({1, 3});
            }
        } else {
            int connectedV = answer.front().first;
            answer.push_back({0, connectedV});
        }
        cout << "Yes" << endc;
        cout << answer.size() << endc;
        for (int i = 0; i < answer.size(); ++i) {
            cout << answer[i].first + 1 << ' ' << answer[i].second + 1 << endc;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    srand(int(time(nullptr)));
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t >> gr;
    while (t-- > 0) work();
}