#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t, group;
    cin >> t >> group;
    for (int _ = 0; _ < t; _++) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;

        vector<set<int>> g1(n + 1), g2(n + 1);

        for (int i = 0; i < m1; i++) {
            int a, b;
            cin >> a >> b;
            g1[a].insert(b);
            g1[b].insert(a);
        }
        for (int i = 0; i < m2; i++) {
            int a, b;
            cin >> a >> b;
            g2[a].insert(b);
            g2[b].insert(a);
        }

        if (n == 1) {
            cout << "Yes" << endl << 0 << endl;
        }
        if (n == 2) {
            if (g1[1].size() == 1) {
                cout << "Yes" << endl << 0 << endl;
            } else {
                cout << "No" << endl;
            }
        }

        bool flag;

        vector<int> pred(n + 1);
        vector<set<int>> g(n + 1);
        pred[1] = -1;
        vector<bool> pos(n + 1, false);
        pos[1] = true;
        deque<pair<int, int>> deq;

        int last = 1;
        for (auto u: g2[1]) {
            g[1].insert(u);
            g[u].insert(1);
            pos[u] = true;
            deq.emplace_back(u, 1);
            pred[u] = 1;
            last = u;
        }


        while (!deq.empty()) {
            auto [v, pr] = deq.front();
            deq.pop_front();
            last = v;
            for (auto u: g2[v]) {
                if (!pos[u]) {
                    g[u].insert(v);
                    g[v].insert(u);
                    pred[u] = v;
                    deq.emplace_back(u, v);
                    pos[u] = true;
                }
            }
        }


        vector<pair<int, int>> ans;

        if (g[pred[last]].size() == n - 1) { // предок - центр дерева (еще без изменений)
            if (m2 == n - 1) {
//                cout << "!";
                if (!g1[pred[last]].empty()) {
                    for (int i = 1; i <= n; i++) {
                        if (i != last && pred[last] != i) {
                            if (g1[last].find(i) == g1[last].end()) {
                                ans.emplace_back(last, i);
                            }
                        }
                    } // присоединили всех к листу, кроме его родителя
                } else {
                    if (n == 3) {
                        if (m1 == 0) {
                            ans.emplace_back(last, pred[last]);
                            for (int i = 1; i <= n; i++) {
                                if (i != last && i != pred[last]) {
                                    ans.emplace_back(i, last);
                                }
                            }
                        }else{
                            flag = false;
                        }
                    } else { // предок не свзяан в g1
                        flag = false;
                    }
                }
            } else {
                if (n == 3){
                    flag = false;
                }
                for (int i = 1; i <= n; i++) {
                    if (i != last && pred[last] != i) {
                        if (g1[last].find(i) == g1[last].end()) {
                            ans.emplace_back(last, i);
                        }
                    }
                } // присоединили всех к листу, кроме его родителя
                if (g1[pred[last]].empty()) {
                    for (int i = 1; i <= n; i++) {
                        if (g2[i].size() > 1 && i != pred[last]) {
                            ans.emplace_back(pred[last], i);
                            break;
                        }
                    }
                }
            }
        } else {
            for (int i = 1; i <= n; i++) {
                if (i != last && pred[last] != i) {
                    if (g1[last].find(i) == g1[last].end()) {
//                    cout << last << ' ' << i << '\n';
                        ans.emplace_back(last, i);
                    }
                }
            } // присоединили всех к листу, кроме его родителя
            flag = false;
            for (int i = 1; i <= n; i++) {
                if (g1[pred[last]].find(i) != g1[pred[last]].end()) {
                    flag = true;
                    break;
                }
            }

            if (!flag) { // предок листа в g1 ни с кем не связан
                for (int i = 1; i <= n; i++) {
                    if (g1[pred[last]].find(i) == g1[pred[last]].end()) {
                        if (g[pred[last]].find(i) == g[pred[last]].end()) {
                            ans.emplace_back(pred[last], i);
                        }
                    }
                }
            }
        }

//        cout << last << ' ' << pred[last] << endl;

        if (flag) {
            cout << "Yes\n" << ans.size() << '\n';
            for (auto [a, b]: ans) {
                cout << a << ' ' << b << '\n';
            }
        } else {
            cout << "No\n";
        }
    }
}