#include<bits/stdc++.h>
using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd(rd());

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

void dfs(ll v, vector<vector<ll>>& arr, vector<bool>& used, set<pair<ll, ll>>& o) {
	used[v] = true;
	for (auto j : arr[v]) {
		if (!used[j]) {
			o.emplace(v, j);
			o.emplace(j, v);
			dfs(j, arr, used, o);
		}
	}
}

void solve() {
	ll n, m1, m2;
	cin >> n >> m1 >> m2;
	set<pair<ll, ll>> g1, g2;
	vector<vector<ll>> arr1(n), arr2(n);
	for (ll i = 0; i < m1; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		g1.emplace(a, b);
		g1.emplace(b, a);
		arr1[a].emplace_back(b);
		arr1[b].emplace_back(a);
	}
	for (ll i = 0; i < m2; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		g2.emplace(a, b);
		g2.emplace(b, a);
		arr2[a].emplace_back(b);
		arr2[b].emplace_back(a);
	}
	for (ll i = 0; i < n; i++) {
		for (ll j = i + 1; j < n; j++) {
			if ((g1.find(make_pair(i, j)) == g1.end()) == (g2.find(make_pair(i, j)) == g2.end())) {
				cout << "Yes\n";
				vector<pair<ll, ll>> op;
				if (g1.find(make_pair(i, j)) == g1.end()) {
					op.emplace_back(i, j);
				}
				for (ll k = 0; k < n; k++) {
					if (k != i && k != j) {
						if ((g1.find(make_pair(i, k)) == g1.end()) && (g1.find(make_pair(j, k)) == g1.end())) {
							if (g2.find(make_pair(i, k)) == g2.end()) {
								op.emplace_back(i, k);
							} else {
								op.emplace_back(j, k);
							}
						}
					}
				}
				cout << op.size() << '\n';
				for (auto[a, b] : op) {
					cout << a + 1 << ' ' << b + 1 << '\n';
				}
				return;
			}
		}
	}
	if (n < 4) {
		cout << "No\n";
		return;
	}
	set<pair<ll, ll>> o2;
	vector<bool> used(n, false);
	for (ll i = 4; i < n; i++) {
		used[i] = true;
	}
	dfs(0, arr2, used, o2);
	if (o2.size() < 6) {
		o2.clear();
		swap(arr2, arr1);
		swap(g2, g1);
		for (ll i = 0; i < 4; i++) {
			used[i] = false;
		}
		dfs(0, arr2, used, o2);
	}
	cout << "Yes\n";
	vector<ll> col(n, 0);
	for (auto[a, b] : o2) {
		col[a]++;
		col[b]++;
	}
	bool b = true;
	vector<pair<ll, ll>> op;
	for (ll i = 0; i < 4; i++) {
		if (col[i] == 6) {
			ll i1 = i ^ 1;
			ll i2 = i ^ 2;
			op.emplace_back(i1, i2);
			op.emplace_back(i, i1);
			b = false;
		}
	}
	if (b) {
		for (ll i = 0; i < 4; i++) {
			for (ll j = i + 1; j < 4; j++) {
				if ((o2.find(make_pair(i, j)) == o2.end()) && (g1.find(make_pair(i, j)) == g1.end())) {
					op.emplace_back(i, j);
				}
			}
		}
	}
	for (ll i = 4; i < n; i++) {
		if ((g1.find(make_pair(0, i)) == g1.end()) == (g1.find(make_pair(1, i)) == g1.end())) {
			op.emplace_back(0, i);
		}
	}
	cout << op.size() << '\n';
	for (auto[a, b] : op) {
		cout << a + 1 << ' ' << b + 1 << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t, g;
	cin >> t >> g;
	while (t--) {
		solve();
	}
}
