#include <iostream>

#include <vector>

using namespace std;

void dfs(vector <int>& used, vector <vector <int>>& a, int v) {
    used[v] = 1;
    for (auto i : a[v]) {
        if (used[i] == 0) {
            dfs(used, a, i);
        }
    }
    return;
}

int main() {
    int t, g;
    cin >> t >> g;
    for (int ww = 0; ww < t; ww++) {
        int n, m1, m2, x, y;
        cin >> n >> m1 >> m2;
        vector <vector <int>> a1(n);
        vector <vector <int>> a2(n);
        vector <vector <int>> sm1(n, vector <int>(n, 0));
        vector <vector <int>> sm2(n, vector <int>(n, 0));
        for (int i = 0; i < m1; i++) {
            cin >> x >> y;
            a1[x - 1].push_back(y - 1);
            a1[y - 1].push_back(x - 1);
            sm1[x - 1][y - 1] = 1;
            sm1[y - 1][x - 1] = 1;
        }
        for (int i = 0; i < m2; i++) {
            cin >> x >> y;
            a2[x - 1].push_back(y - 1);
            a2[y - 1].push_back(x - 1);
            sm2[x - 1][y - 1] = 1;
            sm2[y - 1][x - 1] = 1;
        }
        if (g == 2) {
            if (m1 == 0) {
                if (n == 3) {
                    cout << "No\n";
                } else {
                    cout << "Yes\n" << n - 1 << '\n';
                    for (int i = 0; i < n - 1; i++) {
                        cout << i + 1 << ' ' << i + 2 << '\n';
                    }
                }
            } else {
                int v = 57;
                for (int i = 0; i < n; i++) {
                    if (a1[i].size()) {
                        v = i;
                        break;
                    }
                }
                cout << "Yes\n" << n - 1 - a1[v].size() << '\n';
                vector <int> used(n, 0);
                used[v] = 1;
                for (int i = 0; i < a1[v].size(); i++) {
                    used[a1[v][i]] = 1;
                }
                for (int i = 0; i < n; i++) {
                    if (!used[i]) {
                        cout << v + 1 << ' ' << i + 1 << '\n';
                    }
                }
            }
        }
        if (g == 3) {
            vector <int> used(n, 0);
            dfs(used, a1, 0);
            vector <int> aa1;
            vector <int> aa2;
            for (int i = 0; i < n; i++) {
                if (used[i]) {
                    aa1.push_back(i);
                } else {
                    aa2.push_back(i);
                }
            }
            if (aa1.size() == n) {
                cout << "Yes\n";
                cout << "0\n";
            } else {
                for (auto i : aa1) {
                    for (auto j : aa2) {
                        if (sm2[i][j] == 0) {
                            cout << "Yes\n";
                            cout << "1\n";
                            cout << i + 1 << ' ' << j + 1 << '\n';
                            return 0;
                        }
                    }
                }
                cout << "Yes\n";
                cout << "1\n";
                cout << aa1[0] + 1 << ' ' << aa2[0] + 1 << '\n';
            }
        }
    }
    return 0;
}
