#include <bits/stdc++.h>

using namespace std;

#define int long long
#define fi first
#define se second
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define pw(x) (1LL << x)
#define mp make_pair

constexpr int N = 3e5 + 2;
constexpr int NN = 5e3 + 2;

vector<pair<int, int> > ans;

int n, group, m1, m2;
vector<int> g1[N], g2[N];
map<pair<int, int>, bool > used;
bool gg1[10][10], gg2[10][10];
bool used_v[10];

void dfs2(int v) {
    used_v[v] = true;
    for (int i = 0; i < n; i ++) {
        if (!gg2[v][i] || used_v[i])
            continue;
        dfs2(i);
    }
}

int count_comp_2() {
    int ans = 0;
    fill_n(used_v, n, false);
    for (int i = 0; i < n; i ++) {
        if (used_v[i])
            continue;
        ans ++;
        dfs2(i);
    }
    return ans;
}

void dfs1(int v) {
    used_v[v] = true;
    for (int i = 0; i < n; i ++) {
        if (!gg1[v][i] || used_v[i])
            continue;
        dfs1(i);
    }
}

int count_comp_1() {
    int ans = 0;
    fill_n(used_v, n, false);
    for (int i = 0; i < n; i ++) {
        if (used_v[i])
            continue;
        ans ++;
        dfs1(i);
    }
    return ans;
}

bool found_epta;

void bin(int step = 0) {
    if (count_comp_1() == 1) {
        found_epta = true;
    }
    if (step == n || found_epta)
        return;
    for (int v = 0; v < n; v ++) {
        for (int u = v + 1; u < n; u ++) {
            gg1[v][u] = !gg1[v][u];
            gg1[u][v] = !gg1[u][v];
            gg2[v][u] = !gg2[v][u];
            gg2[u][v] = !gg2[u][v];
            if(count_comp_2() == 1) {
                ans.emplace_back(v, u);
                bin(step + 1);
                if (found_epta)
                    return;
                ans.pop_back();
            }
            gg1[v][u] = !gg1[v][u];
            gg1[u][v] = !gg1[u][v];
            gg2[v][u] = !gg2[v][u];
            gg2[u][v] = !gg2[u][v];
        }
    }
}

bool used2[N];

void dfs_aboba(int v) {
    used2[v] = true;
    for (int u : g1[v]) {
        if (!used2[u])
            dfs_aboba(u);
    }
}

int cnt_cmp(){
    int ans = 0;
    fill_n(used2, n, false);
    for (int i = 0; i < n; i ++) {
        if (used2[i])
            continue;
        ans ++;
        dfs_aboba(i);
    }
    return ans;
}

void solve() {
    cin >> n >> m1 >> m2;
    used.clear();
    ans.clear();
    for (int i = 0; i < n; i ++) {
        g1[i].clear();
        g2[i].clear();
    }
    for (int i = 0; i < m1; i ++) {
        int v, u;
        cin >> v >> u;
        v --; u --;
        if (v > u)
            swap(v, u);
        used[{v, u}] = true;
        g1[v].push_back(u);
        g1[u].push_back(v);
    }
    for (int i = 0; i < m2; i ++) {
        int v, u;
        cin >> v >> u;
        v --; u --;
        if (v > u)
            swap(v, u);
        g2[v].push_back(u);
        g2[u].push_back(v);
    }

    if (cnt_cmp() == 1) {
        cout << "Yes\n";
        cout << 0 << '\n';
        return;
    }

    if (n <= 5) {
        found_epta = false;
        for(int i = 0; i < n; i ++)
            for (int j = 0; j < n; j ++)
                gg1[i][j] = gg2[i][j] = false;
        for (int i = 0; i < n; i ++) {
            for (int j: g1[i])
                gg1[i][j] = gg1[j][i] = true;
            for (int j: g2[i])
                gg2[i][j] = gg2[j][i] = true;
        }
        bin(0);

        if (!found_epta)
            cout << "No\n";
        else {
            cout << "Yes\n";
            cout << ans.size() << '\n';
            for( int i = 0; i < ans.size(); i ++)
                cout << ans[i].fi + 1 << ' ' << ans[i].se + 1 << '\n';
        }
        return;
    }

//    if (group == 5 || group == 9) {
        for (int i = 2; i < n; i ++) {
            if (!used[{0, i}]) {
                ans.emplace_back(0, i);
                used[{0, i}] = true;
            }
        }

        bool con2 = used[{0, 1}];
        for (int i = 2; i < n; i ++)
            con2 |= used[{1, i}];
        if (!con2) {
            ans.emplace_back(1, 3);
        }

        cout << "Yes\n";
        cout << ans.size() << '\n';
        for( int i = 0; i < ans.size(); i ++)
            cout << ans[i].fi + 1 << ' ' << ans[i].se + 1 << '\n';

        return;
//    }
}


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt;
    cin >> tt >> group;
    while (tt --) {
        solve();
    }

    return 0;
}

/*

 1 5
 5 0 4
 1 2
 2 3
 3 4
 4 5

 */