#include <bits/stdc++.h>

using namespace std;

const int INF = (int)1e12 + 7;
int gr;
vector <vector <int>> comp;
vector <vector <int>> g;
vector <vector <int>> g1;
vector <vector <int>> g2;
vector <int> col1;
vector <pair <int, int>> e1;
vector <int> used;
map <pair <int, int>, int> ok;
int col = 1;

void dfs(int v) {
    comp.back().push_back(v);
    used[v] = col;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
}


void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g.assign(n, vector <int> ());
    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    e1.assign(m2, pair <int, int> ());
    col1.assign(m2, 0);
    g1.assign(n, vector <int> ());
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g1[a].push_back(b);
        g1[b].push_back(a);
        col1[i] = 1;
        e1[i] = {a, b};
        ok[{a, b}] = ok[{b, a}] = 1;
    }


    comp = {};
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            comp.emplace_back();
            dfs(i);
            col++;
        }
    }

    int c = -1;
    for (int i = 0; i < (int)comp.size(); i++) {
        if ((int)comp[i].size() > 1) {
            c = i;
            break;
        }
    }

    if (c != -1) {
        cout << "Yes\n";
        int z = comp[c][0];
        int v = comp[c][1];
        vector <pair <int, int>> ans = {};
        for (int i = 0; i < (int)comp.size(); i++){
            if (i != c) {
                if (!ok[make_pair(comp[i][0], z)])
                    ans.push_back(make_pair(comp[i][0], z));
                else
                    ans.push_back(make_pair(comp[i][0], v));
            }
        }

        cout << (int)ans.size() << '\n';
        for (auto &[u, v] : ans)
            cout << u + 1 << " " << v + 1 << '\n';

    } else {
        cout << "No\n";
    }

}  

signed main() {
    #ifdef LOCAL
    freopen("C:/Users/olymp/ggbet/input.txt", "r", stdin);
    freopen("C:/Users/olymp/ggbet/output.txt", "w", stdout);
    #endif
    int t = 1;
    cin >> t >> gr;
    while (t--) {
        solve();    
    }
}