#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define pb push_back
#define endl '\n'
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define vi vector<ll>
#define vii vector<vi>

vii g1, g2;

struct edge {
    ll a, b;
};

ll c1 = 0, c2 = 0;

void dfs(ll v, vii &ng, vi &us) {
    c1++;
    c2++;
    us[v] = 1;
    for (ll j = 0; j < us.size(); j++) {
        if (ng[v][j] && us[j] == 0) {
            dfs(j, ng, us);
        }
    }
}

void solve() {
    ll n, m1, m2;
    cin >> n >> m1 >> m2;
    g1.resize(n, vi(n));
    g2.resize(n, vi(n));
    for (ll i = 0; i < m1; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        g1[a][b] = 1;
        g1[b][a] = 1;
    }
    for (ll i = 0; i < m2; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        g2[a][b] = 1;
        g2[b][a] = 1;
    }
    vector<edge> e;
    for (ll i = 0; i < n; i++) {
        for (ll j = i + 1; j < n; j++) {
            e.pb({i, j});
        }
    }
    ll x = n * (n - 1) / 2;
    for (ll i = 0; i < (1 << x); i++) {
        vii ng1 = g1, ng2 = g2;
        vi res;
        for (ll j = 0; j < x; j++) {
            if ((i >> j) & 1) {
                res.pb(j);
                ng1[e[j].a][e[j].b] ^= 1;
                ng2[e[j].a][e[j].b] ^= 1;
                ng1[e[j].b][e[j].a] ^= 1;
                ng2[e[j].b][e[j].a] ^= 1;
            }
        }
        vi us1(n), us2(n);
        c1 = 0;
        dfs(0, ng1, us1);
        ll fl = c1;
        c2 = 0;
        dfs(0, ng2, us2);
        if (fl == n && c2 == n && res.size() <= n) {
            cout << "Yes" << endl;
            cout << res.size() << endl;
            for (auto y: res) {
                cout << e[y].a + 1 << " " << e[y].b + 1 << endl;
            }
            return;
        }
    }
    cout << "No" << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    clock_t timer = clock();
#endif
    ll t = 1, g;
    cin >> t >> g;
    while (t--) {
        c1 = 0, c2 =0;
        g1.clear(), g2.clear();
        solve();
    }
#ifdef LOCAL
    // cout << endl << "time: " << (ld) (clock() - timer) / CLOCKS_PER_SEC;
#endif
}
