#include <bits/stdc++.h>
#define ll long long
using namespace std;
ll n;
vector<unordered_set<ll>>G1;
vector<unordered_set<ll>>G2;
vector<vector<ll>>Tr;
vector<pair<ll,ll>>Ans;
vector<bool>used;
void makeAns(){
    cout<<"Yes"<<"\n";
    cout<<Ans.size()<<"\n";
    for(auto elem:Ans){
        cout<<elem.first+1<<" "<<elem.second+1<<"\n";
    }
    Ans.clear();
}
void dfs(ll v){
    used[v]=true;
    for(auto t:G2[v]){
        if(!used[t]){
            Tr[v].push_back(t);
            Tr[t].push_back(v);
            dfs(t);
        }
    }
}
bool checkez(){
    for(ll i=0;i<n;i++){
        if(Tr[i].size()!=1 and Tr[i].size()!=n-1){
            return false;
        }
    }
    return true;
}
void solveez(){
    ll st;
    for(ll i=0;i<n;i++){
        if(Tr[i].size()==n-1){
            st=i;
            break;
        }
    }
    for(ll i=0;i<n-1;i++){
        if(st==i){
            continue;
        }
        ll nxt=(i+1)%n;
        if(nxt==st){
            nxt=(nxt+1)%n;
        }
        if(!G1[i].count(nxt)) {
            Ans.push_back({i, nxt});
            if(G2[i].count(nxt)){
                G2[i].erase(nxt);
                G2[nxt].erase(i);
            }
            else{
                G2[i].insert(nxt);
                G2[nxt].insert(i);
            }
        }
    }
    ll k=(st==0);
    if(G2[k].size()==1){
        ll nxt=(k+1)%n;
        if(nxt==st){
            nxt=(nxt+1)%n;
        }
        nxt=(nxt+1)%n;
        if(nxt==st){
            nxt=(nxt+1)%n;
        }
        if(!G1[k].count(nxt)) {
            Ans.push_back({k, nxt});
        }
    }
    if(!G1[k].count(st)) {
        Ans.push_back({st,k});
    }
}
void solve3(){
    if(G2[0].size()==2 and G2[1].size()==2){
        if(G1[0].empty() and G1[1].empty()){
            cout<<"No"<<"\n";
            return;
        }
        else{
            if(G1[0].count(1)){
                if(!G1[0].count(2)){
                    cout<<"Yes"<<"\n";
                    cout<<"1 3";
                }
                else{
                    cout<<"Yes"<<"\n";
                }
            }
            else{
                cout<<"Yes"<<"\n";
                cout<<"1 2";
            }
        }
    }
    else{
        if(G2[0].size()==2 and G2[1].size()==1){
            if(!G1[1].count(2)) {
                G1[1].insert(2);
                G1[2].insert(1);
                Ans.push_back({1, 2});
            }
        }
        else if(G2[0].size()==1 and G2[1].size()==2){
            if(G1[0].count(2)) {
                G1[0].insert(2);
                G1[2].insert(0);
                Ans.push_back({0, 2});
            }
        }
        else if(G2[0].size()==1 and G2[1].size()==1){
            if(G1[0].count(1)) {
                G1[0].insert(1);
                G1[1].insert(0);
                Ans.push_back({0, 1});
            }
        }
        if(min(G1[0].size(),G1[1].size())){
            cout<<"Yes";
            makeAns();
        }
        else{
            cout<<"No";
            Ans.clear();
        }
    }
}
void solve(){
    ll m1,m2,a,b;
    cin>>n>>m1>>m2;
    G1.clear();
    G1.resize(n,{});
    G2.clear();
    G2.resize(n,{});
    Tr.clear();
    Tr.resize(n);
    used.clear();
    used.resize(n,false);
    for(ll i=0;i<m1;i++){
        cin>>a>>b;
        a--,b--;
        G1[a].insert(b);
        G1[b].insert(a);
    }
    for(ll i=0;i<m2;i++){
        cin>>a>>b;
        a--,b--;
        G2[a].insert(b);
        G2[b].insert(a);
    }
    if(n==3){
        solve3();
        return;
    }
    dfs(0);
    if(checkez()){
        solveez();
        makeAns();
        return;
    }
    ll list;
    for(ll i=0;i<n;i++){
        if(Tr[i].size()==1){
            list=i;
            break;
        }
    }
    ll bd=Tr[list][0];
    for(ll i=0;i<n;i++){
        if(i!=list and bd!=i){
            if(!G1[list].count(i)) {
                Ans.push_back({list, i});
            }
        }
    }
    vector<bool>A(n);
    for(auto elem:Tr[bd]){
        A[elem]=true;
    }
    for(ll i=0;i<n;i++){
        if(!A[i] and i!=bd){
            if(!G1[i].count(bd)){
                Ans.push_back({i,bd});
                break;
            }
        }
    }
    makeAns();
}
int main() {
    //freopen("in.txt","r",stdin);
    //freopen("out.txt","w",stdout);
    ll t,g;
    cin>>t>>g;
    for(ll i=0;i<t;i++){
        solve();
    }
}