#include <bits/stdc++.h>

#define ll long long
using namespace std;
ll n;
vector<set<ll>> G1;
vector<set<ll>> G2;
vector<set<ll>> Tr;
vector<pair<ll, ll>> Ans;
vector<pair<bool, vector<ll>>> megaAns;
vector<bool> used;

void makeAns() {
    megaAns.push_back({true, {}});
    megaAns[megaAns.size() - 1].second.push_back(Ans.size());
    for (auto elem: Ans) {
        megaAns[megaAns.size() - 1].second.push_back(elem.first + 1);
        megaAns[megaAns.size() - 1].second.push_back(elem.second + 1);
    }
    Ans.clear();
}

void dfs(ll v) {
    used[v] = true;
    for (auto t: G2[v]) {
        if (!used[t]) {
            Tr[v].insert(t);
            Tr[t].insert(v);
            dfs(t);
        }
    }
}

bool checkez() {
    for (ll i = 0; i < n; i++) {
        if (Tr[i].size() != 1 and Tr[i].size() != n - 1) {
            return false;
        }
    }
    return true;
}

void solve3() {
    if (G2[0].size() == 2 and G2[1].size() == 2) {
        if (G1[0].empty() and G1[1].empty()) {
            megaAns.push_back({false, {}});
            return;
        } else {
            if (G1[0].count(1)) {
                if (!G1[0].count(2)) {
                    megaAns.push_back({true, {1, 1, 3}});
                } else {
                    megaAns.push_back({true, {0}});
                }
            } else {
                megaAns.push_back({true, {1, 1, 2}});
            }
        }
    } else {
        if (G2[0].size() == 2 and G2[1].size() == 1) {
            if (!G1[1].count(2)) {
                G1[1].insert(2);
                G1[2].insert(1);
                Ans.push_back({1, 2});
            }
        } else if (G2[0].size() == 1 and G2[1].size() == 2) {
            if (G1[0].count(2)) {
                G1[0].insert(2);
                G1[2].insert(0);
                Ans.push_back({0, 2});
            }
        } else if (G2[0].size() == 1 and G2[1].size() == 1) {
            if (!G1[0].count(1)) {
                G1[0].insert(1);
                G1[1].insert(0);
                Ans.push_back({0, 1});
            }
        }
        if (min(G1[0].size(), G1[1].size()) and !G1[2].empty()) {
            makeAns();
        } else {
            megaAns.push_back({false, {}});
            Ans.clear();
        }
    }
}

void solve() {
    ll m1, m2, a, b;
    cin >> n >> m1 >> m2;;
    G1.resize(0);
    G1.resize(n, {});
    G2.resize(0);
    G2.resize(n, {});
    Tr.resize(0);
    Tr.resize(n, {});
    used.resize(0);
    used.resize(n, false);
    Ans.resize(0);
    for (ll i = 0; i < m1; i++) {
        cin >> a >> b;
        a--, b--;
        G1[a].insert(b);
        G1[b].insert(a);
    }
    for (ll i = 0; i < m2; i++) {
        cin >> a >> b;
        a--, b--;
        G2[a].insert(b);
        G2[b].insert(a);
    }
    if (n == 3) {
        solve3();
        return;
    }
    dfs(0);
    if (checkez()) {
        ll st;
        for (ll i = 0; i < n; i++) {
            if (Tr[i].size() == n - 1) {
                st = i;
                break;
            }
        }
        ll v = *(Tr[st].begin());
        ll t;
        if (G2[v].size() == 1) {
            for (ll i = 0; i < n; i++) {
                if (i != v and i != st) {
                    t = i;
                    Ans.push_back({v, t});
                    if (G1[v].count(t)) {
                        G1[v].erase(t);
                        G1[t].erase(v);
                    } else {
                        G1[v].insert(t);
                        G1[t].insert(v);
                    }
                    if (G2[v].count(t)) {
                        G2[v].erase(t);
                        G2[t].erase(v);
                    } else {
                        G2[v].insert(t);
                        G2[t].insert(v);
                    }
                    break;
                }
            }
        } else {
            for (ll elem: G2[v]) {
                if (elem != v and elem != st) {
                    t = elem;
                    break;
                }
            }
        }
        Tr[st].erase(v);
        Tr[v].insert(t);
        Tr[t].insert(v);
        Tr[v].erase(st);
    }
    ll list;
    for (ll i = 0; i < n; i++) {
        if (Tr[i].size() == 1) {
            list = i;
            break;
        }
    }
    ll bd = *Tr[list].begin();
    for (ll i = 0; i < n; i++) {
        if (i != list and bd != i) {
            if (!G1[list].count(i)) {
                Ans.push_back({list, i});
            }
        }
    }
    vector<bool> A(n, false);
    for (auto elem: Tr[bd]) {
        A[elem] = true;
    }
    for (ll i = 0; i < n; i++) {
        if (!A[i] and i != bd) {
            if (!G1[i].count(bd)) {
                Ans.push_back({i, bd});
                break;
            }
        }
    }
    makeAns();
}

int main() {
    //freopen("in.txt","r",stdin);
    //freopen("out.txt","w",stdout);
    ll t, g;
    cin >> t >> g;
    for (ll i = 0; i < t; i++) {
        solve();
    }
    for (auto elem: megaAns) {
        if (!elem.first) {
            cout << "No" << "\n";
            continue;
        }
        cout << "Yes" << "\n";
        cout << elem.second[0] << "\n";
        for (ll i = 1; i < elem.second.size(); i += 2) {
            cout << elem.second[i] << " " << elem.second[i + 1] << "\n";
        }
    }
}