#include<bits/stdc++.h>
#define int long long
using namespace std;

vector<int> P;
vector<int> P1;

int gp(int a, vector<int>&P) {
    if (P[a] != a) {
        int x = gp(P[a], P);
        P[a] = x;
    }
    return P[a];
}

bool mrg(int a, int b, vector<int>&P) {
    a = gp(a, P);
    b = gp(b, P);
    if (a == b) {
        return 0;
    }
    P[b] = a;
    return 1;
}

void solve() {
    int a, b, c, d, e;
    bool fl = 0;
    cin >> a >> b >> c;
    vector<set<int>> G(a), S(a), G1(a);
    P.assign(a, 0);
    P1.assign(a, 0);
    for (int i = 0; i < a; ++i) {
        P[i] = i;
        P1[i] = i;
    }
    for (int i = 0; i < b; ++i) {
        cin >> d >> e;
        --d;
        --e;
        S[e].insert(d);
        S[d].insert(e);
    }
    for (int i = 0; i < c; ++i) {
        cin >> d >> e;
        --d;
        --e;
        fl = mrg(d, e, P1);
        if (fl) {
            G[d].insert(e);
            G[e].insert(d);
        }
        G1[d].insert(e);
        G1[e].insert(d);
    }
    if (a == 3) {
        vector<pair<int, int>> ans;
        int st = -1;
        for (int i = 0; i < 3; ++i) {
            int nxt = (i + 1) % 3;
            if (S[i].find(nxt) != S[i].end() && G1[i].find(nxt) != G1[i].end()) {
                st = i;
                break;
            }
            if (S[i].find(nxt) == S[i].end() && G1[i].find(nxt) == G1[i].end()) {
                st = i;
                ans.push_back({i, nxt});
                break;
            }
        }
        if (st == -1) {
            cout << "No" << endl;
            return;
        }
        bool fl = 0;
        for (auto i : G1[st]) {
            if (i == (st + 2) % 3) {
                fl = 1;
            }
        }
        if (fl == 0) {
            ans.push_back({st, (st + 2) % 3});
        }
        for (auto i : S[(st + 1) % 3]) {
            if (i == (st + 2) % 3) {
                fl = 1;
            }
        }
        if (fl == 0) {
            ans.push_back({(st + 1) % 3, (st + 2) % 3});
        }
        cout << "YES" << '\n' << ans.size() << '\n';
        for (auto i : ans) {
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
        return;
    }
    int fi = -1;
    for (int i = 0; i < a; ++i) {
        if (G[i].size() == a - 1) {
            fi = i;
        }
    }
    vector<pair<int, int>> ans;
    if (fi != -1) {
        int cr = (fi + 1) % a, cr1 = (fi - 1 + a) % a;
        G[fi].erase(cr);
        G[cr].erase(fi);
        if (S[fi].find(cr) != S[fi].end()) {
            S[fi].erase(cr);
            S[cr].erase(fi);
        } else {
            S[cr].insert(fi);
            S[fi].insert(cr);
        }
        G[cr1].insert(cr);
        G[cr].insert(cr1);
        if (S[cr1].find(cr) != S[cr1].end()) {
            S[cr1].erase(cr);
            S[cr].erase(cr1);
        } else {
            S[cr1].insert(cr);
            S[cr].insert(cr1);
        }
        ans.push_back({cr, cr1});
        ans.push_back({fi, cr});
    }
    set<int> need, redy;
    redy.insert(0);
    for (int i = 1; i < a; ++i) {
        need.insert(i);
    }
    while (need.size() > 0) {
        int s = *redy.begin();
        redy.erase(redy.begin());
        vector<int> del;
        for (auto i : need) {
            if (G[s].find(i) == G[s].end()) {
                del.push_back(i);
                redy.insert(i);
                if (S[s].find(i) == S[s].end()) {
                    ans.push_back({s, i});
                }
            } else if (S[s].find(i) != S[s].end()) {
                del.push_back(i);
                redy.insert(i);
            }
        }
        for (auto i : del) {
            need.erase(i);
        }
    }
    cout << "Yes" << '\n' << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first + 1 << ' ' << i.second + 1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int a, b;
    cin >> a;
    cin >> b;
    for (int i = 0; i < a; ++i) {
        solve();
    }
}
