#include<bits/stdc++.h>
#define fi first
#define se second
#define ll long long
#define pii pair<int, int>
using namespace std;
const int N = 3e5 + 1;
const int Ns = 3e3 + 1;
int p[N];
int sz[N];
map<pii, bool> roads;
set<int> gr[N];
void ultra_clear(int n) {
    roads.clear();
    for (int i = 1; i <= n; ++i)
        gr[i].clear();
}
void init(int n) {
    for (int i = 1; i <= n; ++i)
        p[i] = i,
            sz[i] = 1;
}
int get(int u) {
    if (p[u] != u)
        p[u] = get(p[u]);
    return p[u];
}
void join(int u, int v) {
    u = get(u);
    v = get(v);
    if (u == v)
        return;
    if (sz[u] > sz[v])
        swap(u, v);
    sz[v] += sz[u];
    p[u] = v;
}
bool check(int u, int v) {
    u = get(u);
    v = get(v);
    return (u == v);
}
int cnt;
pii road;
bool flag;
int tin[N];
int tout[N];
bitset<N> us;
void clear_tin_tout(int n) {
    for (int i = 1; i <= n; ++i)
        tout[i] = tin[i] = us[i] = 0;
}
void dfs(int city, int pr) {
    us[city] = 1;
    tin[city] = tout[city] = ++cnt;
    for (int i : gr[city]) {
        if (i == pr)
            continue;
        if (us[i]) {
            tout[city] = min(tout[city], tin[i]);
            continue;
        }
        dfs(i, city);
        tout[city] = min(tout[city], tout[i]);
        if (tout[i] > tin[city]) {
            if (i == road.fi && city == road.se || i == road.se && city == road.fi)
                flag = 1;
        }
    }
}
void add_edge(int u, int v) {
    gr[u].insert(v);
    gr[v].insert(u);
    roads[{u, v}] = roads[{v, u}] = 1;
}
void del_edge(int u, int v) {
    gr[u].erase(v);
    gr[v].erase(u);
    roads[{u, v}] = roads[{v, u}] = 0;
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t, g;
    cin >> t >> g;
    while (t--) {
        bool can = 0;
        int n, m[2];
        cin >> n >> m[0] >> m[1];
        for (int i = 0; i < 2; ++i)
            for (int j = 1; j <= m[i]; ++j) {
                int u, v;
                cin >> u >> v;
                if (i)
                    add_edge(u, v);
                else
                    join(u, v);
            }
        init(n);
        vector<pii> ans;
        for (int u = 1; u < n; ++u)
            for (int v = u + 1; v <= n; ++v)
                if (!check(u, v)) {
                    if (!roads[{u, v}]) {
                        ans.push_back({u, v});
                        join(u, v);
                        add_edge(u, v);
                    } else {
                        cnt = 0;
                        flag = 0;
                        road = {u, v};
                        clear_tin_tout(n);
                        dfs(1, 0);
                        if (!flag) {
                            ans.push_back({u, v});
                            join(u, v);
                            del_edge(u, v);
                        }
                    }
                }
        if (sz[get(1)] == n) {
            cout << "Yes\n";
            cout << ans.size() << '\n';
            for (auto i : ans)
                cout << i.fi << ' ' << i.se << '\n';
        } else {
            cout << "No\n";
        }
        ultra_clear(n);
    }
    return 0;
}
