//#pragma GCC target("avx2", "avx")
//#pragma GCC optimize("Ofast", "inline", "unrool-loops", "sse", "sse2", "sse3", "ssse3", "sse4")

#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <unordered_map>
#include <set>
#include <string>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define int long long

static const int inf = 1e15 + 7, mod1 = 1e9 + 7;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin() (x).rend()

mt19937 rnd;

vector<set<int>> g1, g2;

vector<bool> ost;
int need = 0;
vector<bool> visited;
int minans;
vector<bool> out;

void dfs(int u, vector<vector<int>> &g) {
    visited[u] = true;
    for (auto &v: g[u]) {
        if (!visited[v]) {
            dfs(v, g);
        }
    }
}

void f(int lenn) {
    if (lenn == need) {
        if (need == 6) {
            int z = 0;
        }
        vector<vector<int>> gg1(g1.size());
        int cnt = 0;
        if (ost[0] == 0 && ost[1] == 0 && ost[2] == 0 && ost[3] == 0 && ost[4] == 1 && ost[5] == 0) {
            int z = 0;
        }
        for (int i = 1; i <= g1.size() - 1; i++) {
            for (int j = i + 1; j <= g1.size() - 1; j++) {
                if (!ost[cnt]) {
                    if (g1[i].find(j) != g1[i].end()) {
                        gg1[i].push_back(j);
                        gg1[j].push_back(i);
                    }
                } else {
                    if (g1[i].find(j) == g1[i].end()) {
                        gg1[i].push_back(j);
                        gg1[j].push_back(i);
                    }
                }
                cnt++;
            }
        }
        vector<vector<int>> gg2(g2.size());
        cnt = 0;
        for (int i = 1; i <= g1.size() - 1; i++) {
            for (int j = i + 1; j <= g1.size() - 1; j++) {
                if (!ost[cnt]) {
                    if (g2[i].find(j) != g2[i].end()) {
                        gg2[i].push_back(j);
                        gg2[j].push_back(i);
                    }
                } else {
                    if (g2[i].find(j) == g2[i].end()) {
                        gg2[i].push_back(j);
                        gg2[j].push_back(i);
                    }
                }
                cnt++;
            }
        }
        visited.assign(gg2.size(), false);
        dfs(1, gg1);
        for (int i = 1; i <= g1.size() - 1; i++) {
            if (!visited[i]) {
                return;
            }
        }
        visited.assign(gg2.size(), false);
        dfs(1, gg2);
        for (int i = 1; i <= g1.size() - 1; i++) {
            if (!visited[i]) {
                return;
            }
        }
//        cout << "YES\n";
        int ans = 0;
        for (int i = 0; i < ost.size(); i++) {
            ans += ost[i];
        }
        if (ans < minans) {
            minans = ans;
            out = ost;
        }
//        cout << ans << '\n';
//        cnt = 0;
//        for (int i = 1; i <= g1.size() - 1; i++) {
//            for (int j = i + 1; j <= g1.size() - 1; j++) {
//                if (ost[cnt]) {
//                    cout << i << " " << j << '\n';
//                }
//            }
//        }
        return;
    }
    ost[lenn] = true;
    f(lenn + 1);
    ost[lenn] = false;
    f(lenn + 1);
}

void solve() {
    int n, m1, m2;
    minans = inf;
    cin >> n >> m1 >> m2;
    g1.assign(n + 1, {});
    g2.assign(n + 1, {});
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        g1[u].insert(v);
        g1[v].insert(u);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        g2[a].insert(b);
        g2[b].insert(a);
    }
    cout << "YES\n";
    cout << n - 1 << '\n';
    for (int i = 1; i <= n - 1; i++) {
        cout << i << " " << i + 1 << '\n';
        return;
    }
    if (n <= 5) {
        need = n * (n - 1) / 2;
        ost.resize(need);
        f(0);
        if (minans == inf) {
            cout << "NO\n";
        } else {
            cout << "YES\n";
            cout << minans << '\n';
            int cnt = 0;
            for (int i = 1; i <= g1.size() - 1; i++) {
                for (int j = i + 1; j <= g1.size() - 1; j++) {
                    if (out[cnt]) {
                        cout << i << " " << j << '\n';
                    }
                    cnt++;
                }
            }
        }
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    cin >> tt;
    int gggg;
    cin >> gggg;
    while (tt--) {
        solve();
    }
    return 0;
}
