//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <vector>
#include <deque>
#include <ctime>
#include <unordered_set>
#include <iomanip>
#include <algorithm>
using namespace std;
#define double long double
//#define int long long
#define ll long long
#define debug(x) cerr << (#x) << ": " << x << endl;
#define get_time (double)(clock()) / (double)(CLOCKS_PER_SEC)
const int INF = 1e17 + 7;
const int mod = 1e9 + 7;
const int MAXN = 2e5 + 10;
//#pragma GCC optimize("avx2")
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
int make_add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int n, m1, m2, g;
vector<int> st_2;
set<pair<int, int> > edges, ed2;
vector<vector<int> > gr1, gr2;
vector<int> what_comp, used;
void dfs1(int u) {
    used[u] = 1;
    for (auto to : gr1[u]) {
        if (used[to]) continue;
        dfs1(to);
    }
}
void dfs2(int u) {
    used[u] = 1;
    for (auto to : gr2[u]) {
        if (used[to]) continue;
        dfs2(to);
    }
}
void solve_little() {
    vector<pair<int, int> > lol;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            lol.push_back({ i, j });
        }
    }
    int sz = st_2[lol.size()];
    for (int i = 0; i < sz; i++) {
        int cnt = 0;
        vector<pair<int, int> > may;
        set<pair<int, int> > e1 = edges, e2 = ed2;
        for (int j = 0; j < lol.size(); j++) {
            if ((i & st_2[j]) > 0) {
                int u = lol[j].first, v = lol[j].second;
                cnt++;
                may.push_back({ u, v });
                if (e1.count({ u, v })) {
                    e1.erase({ u, v });
                } else {
                    e1.insert({ u, v });
                }
                if (e2.count({ u, v })) {
                    e2.erase({ u, v });
                } else {
                    e2.insert({ u, v });
                }
            }
        }
        gr1 = vector<vector<int> >(n);
        gr2 = vector<vector<int> >(n);
        for (auto c : e1) gr1[c.first].push_back(c.second), gr1[c.second].push_back(c.first);
        for (auto c : e2) gr2[c.first].push_back(c.second), gr2[c.second].push_back(c.first);
        if (cnt > n) continue;
        used = vector<int>(n, 0);
        dfs1(0);
        int fl = 1;
        for (int j = 0; j < n; j++) {
            if (!used[j]) { fl = 0; break; }
        }
        used = vector<int>(n, 0);
        dfs2(0);
        for (int j = 0; j < n; j++) {
            if (!used[j]) { fl = 0; break; }
        }
        if (fl) {
            cout << "Yes" << '\n';
            cout << may.size() << '\n';
            for (auto c : may) cout << c.first + 1 << " " << c.second + 1 << '\n';
            return;
        }
    }
    cout << "No" << '\n';
}
void solve() {
    edges.clear();
    ed2.clear();
    cin >> n >> m1 >> m2;
    gr1 = vector<vector<int> >(n);
    gr2 = vector<vector<int> >(n);
    for (int i = 0; i < m1; i++) {
        int u, v;cin >> u >> v;u--;v--;
        edges.insert({ min(u, v), max(u, v) });
    }
    for (int i = 0; i < m2; i++) {
        int u, v;cin >> u >> v; u--; v--;
        ed2.insert({ min(u, v), max(u, v) });
    }
    solve_little();
    
    /*
    cout << "Yes" << endl;
    vector<pair<int, int> > ans;
    int fl = 0;
    for (int i = 1; i < n - 1; i++) {
        int u = i, v = i + 1;
        if (edges.count({ u, v }) == 0) {
            if (fl == 0) {
                ans.push_back({ 0, u });
                fl = 1;
            }
            ans.push_back({ u, v });
        }
    }
    cout << ans.size() << endl;
    for (auto c : ans) cout << c.first + 1 << " " << c.second + 1 << endl;
    */
}
signed main() {
    int cur = 1;
    for (int i = 0; i < 100; i++) {
        st_2.push_back(cur);
        cur *= 2;
    }
    cout << fixed << setprecision(20);
   // srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t >> g;
    while (t--) {
        solve();
    }
}
/*
4 1
5 4 0
1 2
1 3
1 4
4 5
*/