#include <bits/stdc++.h>

using namespace std;

/*#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,tune=native")
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());*/
typedef long long ll;
typedef long double ld;

vector<bool> col;
vector<vector<int>> g;

void painter(int v) {
    col[v] = true;
    for (auto u: g[v]) {
        if (!col[u]) {
            painter(u);
        }
    }
}

void solve() {
    g.clear();
    col.clear();
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    col.resize(n);
    g.resize(n);
    vector<int> sz(n);
    vector<pair<int, int>> a(m1);
    set<pair<int, int>> b;
    for (int i = 0; i < m1; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].first--;
        a[i].second--;
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        sz[u]++;
        sz[v]++;
        b.insert({min(u, v), max(u, v)});
    }
    if (m2 == (ll) n * (ll) (n - 1) / 2LL) {
        cout << "No\n";
        return;
    }
    int x, y;
    vector<pair<int, int>> ans;
    if (m1 == 0) {
        for (int i = 0; i < n; i++) {
            if (sz[i] != n) {
                x = i;
                break;
            }
        }
        set<int> dop;
        for (auto [u, v]: b) {
            if (u == x || v == x) dop.insert(u + v - x);
        }
        for (int i = 0; i < n; i++) {
            if (dop.find(i) == dop.end()) {
                y = i;
                break;
            }
        }
        a.push_back({x, y});
        ans.push_back({x, y});
    } else {
        x = a[0].first;
        y = a[0].second;
    }
    painter(x);
    for (int i = 0; i < n; i++) {
        if (col[i]) continue;
        if (b.find({min(x, i), max(x, i)}) != b.end()) {
            if (b.find({min(y, i), max(y, i)}) != b.end()) {
                ans.push_back({x, i});
            } else {
                ans.push_back({y, i});
            }
        } else {
            ans.push_back({x, i});
        }
        painter(i);
    }
    cout << "Yes\n" << ans.size() << '\n';
    for (auto dop: ans) cout << dop.first + 1 << " " << dop.second + 1 << '\n';
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}
