#include <bits/stdc++.h>

using namespace std;

/*#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,tune=native")
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());*/
typedef long long ll;
typedef long double ld;

vector<bool> col;
vector<vector<int>> g;

void painter(int v) {
    col[v] = true;
    for (auto u: g[v]) {
        if (!col[u]) {
            painter(u);
        }
    }
}

int n;

pair<int, int> no_road(vector<vector<int>> &tec) {
    int x = -1, y = -1;
    for (int i = 0; i < n; i++) {
        if (tec[i].size() != n) {
            x = i;
            break;
        }
    }
    if (x == -1) return {-1, -1};
    set<int> dop;
    for (auto u: tec[x]) {
        dop.insert(u);
    }
    for (int i = 0; i < n; i++) {
        if (dop.find(i) == dop.end()) {
            y = i;
            break;
        }
    }
    return {x, y};
}

void solve() {
    g.clear();
    col.clear();
    int m1, m2;
    cin >> n >> m1 >> m2;
    col.resize(n);
    g.resize(n);
    vector<int> sz(n);
    vector<pair<int, int>> a(m1);
    set<pair<int, int>> b;
    for (int i = 0; i < m1; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].first--;
        a[i].second--;
        g[a[i].first].push_back(a[i].second);
        g[a[i].second].push_back(a[i].first);
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        sz[u]++;
        sz[v]++;
        b.insert({min(u, v), max(u, v)});
    }
    if (m2 == (ll) n * (ll) (n - 1) / 2LL) {
        cout << "No\n";
        return;
    }
    int x = -1, y = -1;
    vector<pair<int, int>> ans;
    for (auto [u, v]: a) {
        if (b.find({min(u, v), max(u, v)}) != b.end()) {
            x = u;
            y = v;
        }
    }
    if (x == -1) {
        vector<vector<int>> new_g(n);
        for (auto [u, v]: a) {
            new_g[u].push_back(v);
            new_g[v].push_back(u);
        }
        for (auto [u, v]: b) {
            new_g[u].push_back(v);
            new_g[v].push_back(u);
        }
        auto tec = no_road(new_g);
        x = tec.first;
        y = tec.second;
        if (x == -1) {

        }
    }
    painter(x);
    for (int i = 0; i < n; i++) {
        if (col[i]) continue;
        if (b.find({min(x, i), max(x, i)}) != b.end()) {
            if (b.find({min(y, i), max(y, i)}) != b.end()) {
                ans.push_back({x, i});
            } else {
                ans.push_back({y, i});
            }
        } else {
            ans.push_back({x, i});
        }
        painter(i);
    }
    cout << "Yes\n" << ans.size() << '\n';
    for (auto dop: ans) cout << dop.first + 1 << " " << dop.second + 1 << '\n';
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}
