#include <bits/stdc++.h>

using namespace std;

/*#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,tune=native")
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());*/
typedef long long ll;
typedef long double ld;

vector<bool> col;
vector<vector<int>> g;

void painter(int v) {
    col[v] = true;
    for (auto u: g[v]) {
        if (!col[u]) {
            painter(u);
        }
    }
}

int n;

pair<int, int> no_road(vector<vector<int>> &tec) {
    int x = -1, y = -1;
    for (int i = 0; i < n; i++) {
        if (tec[i].size() != n - 1) {
            x = i;
            break;
        }
    }
    if (x == -1) return {-1, -1};
    set<int> dop;
    for (auto u: tec[x]) {
        dop.insert(u);
    }
    for (int i = 0; i < n; i++) {
        if (i == x) continue;
        if (dop.find(i) == dop.end()) {
            y = i;
            break;
        }
    }
    return {x, y};
}

void solve() {
    g.clear();
    col.clear();
    int m1, m2;
    cin >> n >> m1 >> m2;
    col.resize(n);
    g.resize(n);
    vector<int> sz(n);
    vector<pair<int, int>> a(m1);
    set<pair<int, int>> b;
    for (int i = 0; i < m1; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].first--;
        a[i].second--;
        g[a[i].first].push_back(a[i].second);
        g[a[i].second].push_back(a[i].first);
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        sz[u]++;
        sz[v]++;
        b.insert({min(u, v), max(u, v)});
    }
    int x = -1, y = -1;
    vector<pair<int, int>> ans;
    for (auto [u, v]: a) {
        if (b.find({min(u, v), max(u, v)}) != b.end()) {
            x = u;
            y = v;
        }
    }
    if (x == -1) {
        vector<vector<int>> new_g(n);
        for (auto [u, v]: a) {
            new_g[u].push_back(v);
            new_g[v].push_back(u);
        }
        for (auto [u, v]: b) {
            new_g[u].push_back(v);
            new_g[v].push_back(u);
        }
        auto tec = no_road(new_g);
        x = tec.first;
        y = tec.second;
        if (x == -1) {
            if (m2 == (ll) n * (ll) (n - 1) / 2LL) {
                if (n == 3) {
                    cout << "No\n";
                    return;
                }
                cout << "Yes\n";
                cout << n - 1 << '\n';
                for (int i = 1;i < n;i ++) {
                    cout << i << " " << i + 1 << '\n';
                }
                return;
            }
            ans.push_back({a[0].first, a[0].second});
            g[a[0].first].erase(std::find(g[a[0].first].begin(), g[a[0].first].end(),a[0].second));
            g[a[0].second].erase(std::find(g[a[0].second].begin(), g[a[0].second].end(),a[0].first));
            sz[a[0].first] ++;
            sz[a[0].second] ++;
            col[0] = true;
            painter(0);
            for (int i = 0; i < n; i++) {
                if (sz[i] != 1 && col[i]) {
                    for (int u = 0;u < n;u ++){
                        if (col[u]) continue;
                        if (sz[u] == 1) continue;
                        ans.push_back({i, u});
                        g[i].push_back(u);
                        g[u].push_back(i);
                        painter(u);
                    }
                }
            }
            bool fl = true;
            for (auto tttt : col) fl = fl && tttt;
            if (!fl || ans.size() > n) {
                cout << "No\n";
                return;
            }
            cout << "Yes\n" << ans.size() << '\n';
            for (auto dop: ans) cout << dop.first + 1 << " " << dop.second + 1 << '\n';
            return;
        }
        ans.push_back({x, y});
        g[x].push_back(y);
        g[y].push_back(x);
    }
    painter(x);
    for (int i = 0; i < n; i++) {
        if (col[i]) continue;
        if (b.find({min(x, i), max(x, i)}) != b.end()) {
            if (b.find({min(y, i), max(y, i)}) != b.end()) {
                ans.push_back({x, i});
            } else {
                ans.push_back({y, i});
            }
        } else {
            ans.push_back({x, i});
        }
        painter(i);
    }
    cout << "Yes\n" << ans.size() << '\n';
    for (auto dop: ans) cout << dop.first + 1 << " " << dop.second + 1 << '\n';
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}
