#include <bits/stdc++.h>
using namespace std;
#pragma GCC optimize("unroll-loops,O3")
#pragma GCC target("lzcnt,popcnt,sse2,sse3,sse4,sse4.2,avx,avx2")
#define dbg(x) cout << #x << ": " << x << endl;
#define dbga(x,l,r) cout << #x << ": "; for (int jjj=l;jjj<r;jjj++) cout << x[jjj] << " "; cout << endl;
#define ll long long
// #define int long long
#define pb push_back
#define pi pair<int, int>
#define fi first
#define se second
const int N = 3e5+9;
int n, m1, m2;
set<pi> st1, st2;
int p[N], tek;
int find(int x) {return p[x] = x == p[x] ? x : find(p[x]);}
void merge(int a, int b) {
	a = find(a);
	b = find(b);
	if (a == b) return;
	tek--;
	p[a] = b;
}
int sum() {
	for (int i = 0; i < n; i++) p[i] = i;
	int res = 0;
	tek = n;
	for (auto [a, b]: st1) {
		merge(a, b);
	}
	res += tek;
	tek = n;
	for (int i = 0; i < n; i++) p[i] = i;
	for (auto [a, b]: st2) merge(a, b);
	return res + tek;
}
bool go(int from, int to) {
	if (from >= to) return 1;
	return 0;
}
void solve() {
	cin >> n >> m1 >> m2;
	st1.clear();
	st2.clear();
	for (int i = 0; i < m1; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		if (a > b) swap(a, b);
		st1.insert({a, b});
	}
	for (int i = 0; i < m2; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		if (a > b) swap(a, b);
		st2.insert({a, b});
	}
	set<pi> mst = st1;
	int tek = sum();
	int T = clock() + CLOCKS_PER_SEC * 1.7 * (double)6000 / (m1 + m2);
	mt19937 rnd(228);
	while (tek > 2 && clock() < T) {
		int a = rnd() % n;
		int b = rnd() % n;
		if (a == b) continue;
		if (a > b) swap(a, b);
		pi pp = {a, b};
		bool c1 = st1.count(pp), c2 = st2.count(pp);
		if (c1 && c2) continue;
		if (!c1 && !c2) {
			st1.insert(pp);
			st2.insert(pp);
			tek = sum();
		} else {
			if (c1 && !c2) {
				st1.erase(pp);
				st2.insert(pp);
				int val = sum();
				if (go(tek, val)) {
					tek = val;
				} else {
					st1.insert(pp);
					st2.erase(pp);
				}
			} else {
				st2.erase(pp);
				st1.insert(pp);
				int val = sum();
				if (go(tek, val)) {
					tek = val;
				} else {
					st2.insert(pp);
					st1.erase(pp);
				}
			}
		}
	}
	if (tek > 2) {
		cout << "No";
		return;
	}
	cout << "Yes\n";
	set<pi> res;
	for (pi p: mst) {
		if (!st1.count(p)) res.insert(p);
	}
	for (pi p: st1) {
		if (!mst.count(p)) res.insert(p);
	}
	cout << res.size() << "\n";
	for (auto [a, b] : res) cout << a + 1 << " " << b + 1 << "\n";
}
signed main() {
	cin.tie(0); ios_base::sync_with_stdio(0);
	int t, g;
	cin >> t >> g;
	while (t--) {
		solve();
		cout << "\n";
	}
}