#include <iostream>
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
*/
#include <bits/stdc++.h>
using namespace std;

/*
#include <bits/extc++.h>
using namespace __gnu_pbds;
typedef tree<
        int,
        null_type,
        less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
 */

#define int long long
#define ll long long
#define fi first
#define se second
#define eb emplace_back
#define lwb lower_bound
#define upb upper_bound
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define ld long double
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
const int INF = 1e18, N = 300300, K = 26, C = 700, P = 1e9 + 7;
const ld EPS = 1e-5, pi = 3.1415926535;

struct dsu {
    vector<int> r, p;
    int cnt;

    void init(int n) {
        cnt = n - 1;
        r.assign(n + 1, 1);
        p.resize(n + 1);
        iota(all(p), 0);
    }

    int get(int v) {
        if (v == p[v])
            return v;
        return p[v] == get(p[v]);
    }

    void merge(int a, int b) {
        a = get(a), b = get(b);
        if (a == b)
            return;
        cnt--;
        p[b] = a;
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    dsu dsu;
    dsu.init(n);
    for (int i = 0; i < m1; i++) {
        int v, u;
        cin >> v >> u;
        dsu.merge(v, u);
    }
    for (int i = 0; i < m2; i++) {
        int v, u;
        cin >> v >> u;
    }
    if (n == 3 && dsu.cnt == n - 1) {
        cout << "No\n";
        return;
    }
    vector<int> sus;
    for (int i = 1; i <= n; i++) {
        if (dsu.get(i) == i)
            sus.eb(i);
    }
    cout << "Yes\n";
    cout << sus.size() - 1 << '\n';
    for (int i = 1; i < sus.size(); i++) {
        cout << sus[i - 1] << " " << sus[i] << '\n';
    }
}


void solve2() {
    cout << "No\n";
}

signed main() {
    //cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    int G;
    cin >> G;
    while (T--) {
        if (G == 2)
            solve();
        else
            solve2();
    }
    return 0;
}