//#pragma target("Ofast, unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long

using namespace std;

#define debug(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
const int N = 2e5 + 228;

map<pair<int, int>, bool> map1, map2;

vector<int> G1[N], G2[N];

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        G1[a].push_back(b);
        G1[b].push_back(a);
        if (a > b) swap(a, b);
        map1[{a, b}] = true;
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        G2[a].push_back(b);
        G2[b].push_back(a);
        if (a > b) swap(a, b);
        map2[{a, b}] = true;
    }
    int mn = 0;
    for (int i = 1; i < n; ++i) {
        if (G2[i].size() < G2[mn].size()) {
            mn = i;
        }
    }
    int left = n;
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; ++i) {
        if (i == mn) continue;
        if (!map1[{min(i, mn), max(i, mn)}]) {
            left--;
            ans.push_back({min(i, mn), max(i, mn)});
        }
    }
    cout << "Yes\n";
    cout << ans.size() << '\n';
    for (auto el : ans) {
        cout << el.first + 1 << ' ' << el.second + 1 << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
    return 0;
}
