#include <bits/stdc++.h>

void solve() {
    int n, m1, m2;
    std::cin >> n >> m1 >> m2;
    std::vector<std::pair<int, int>> edg1(m1), edg2(m2);
    std::vector<std::vector<int>> gr1(n), gr2(n);
    for (auto& [edg, gr] : std::array{std::pair{&edg1, &gr1}, std::pair{&edg2, &gr2}}) {
        for (auto& [u, v] : *edg) {
            std::cin >> u >> v;
            u--;
            v--;
            if (u > v) {
                std::swap(u, v);
            }
            gr->operator[](u).push_back(v);
            gr->operator[](v).push_back(u);
        }
    }
    assert(n >= 3);
    if (n <= 5) {
        std::vector<std::pair<int, int>> all;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                all.push_back({i, j});
            }
        }
        assert(std::is_sorted(all.begin(), all.end()));
        int m = all.size();
        assert(m >= n);
        std::vector<int> cum(m, 0);
        std::fill(cum.begin() + m - n, cum.end(), 1);
        assert(std::is_sorted(cum.begin(), cum.end()));

        std::vector<int> pr_1(m), pr_2(m);
        for (auto& p : edg1) {
            auto it = std::lower_bound(all.begin(), all.end(), p) - all.begin();
            assert(it != m);
            assert(all[it] == p);
            pr_1[it] = 1;
        }
        for (auto& p : edg2) {
            auto it = std::lower_bound(all.begin(), all.end(), p) - all.begin();
            assert(it != m);
            assert(all[it] == p);
            pr_2[it] = 1;
        }

        bool suc = false;
        do {
            auto check = [&](std::vector<int> ind) {
                auto conn = [&](const auto& pr) {
                    assert(pr.size() == m);
                    std::vector<int> prv(n, -1);
                    auto get = [&](auto get, int i) -> int {
                        return prv[i] == -1 ? i : prv[i] = get(get, prv[i]);
                    };
                    int cnt = 0;
                    for (int i = 0; i < m; i++) {
                        if (pr[i]) {
                            auto [u, v] = all[i];
                            u = get(get, u);
                            v = get(get, v);
                            if (u != v) {
                                cnt++;
                                prv[u] = v;
                            }
                        }
                    }
                    return cnt == n - 1;
                };
                assert(!suc);
                assert(ind.size() <= n);

                auto pr1 = pr_1;
                auto pr2 = pr_2;
                std::sort(ind.begin(), ind.end(), [&](auto a, auto b) { return pr2[a] < pr2[b]; });
                assert(conn(pr2));

                for (int i : ind) {
                    pr1[i] ^= 1;
                    pr2[i] ^= 1;
                }
                if (conn(pr1) && conn(pr2)) {
                    {
                        pr2 = pr_2;
                        for (int i : ind) {
                            pr2[i] ^= 1;
                            assert(conn(pr2));
                        }
                    }
                    std::cout << "Yes\n";
                    std::cout << ind.size() << "\n";
                    for (int i : ind) {
                        auto [u, v] = all[i];
                        v++;
                        u++;
                        std::cout << u << " " << v << "\n";
                    }
                    suc = true;
                }
            };

            std::vector<int> ind;
            for (int i = 0; i < m; i++) {
                if (cum[i]) {
                    ind.push_back(i);
                }
            }
            assert(ind.size() == n);
            for (int i = 0; i <= ind.size() && !suc; i++) {
                check(std::vector<int>(ind.begin(), ind.begin() + i));
            }
        } while (!suc && std::next_permutation(cum.begin(), cum.end()));

        if (!suc) {
            std::cout << "No\n";
            while (clock() * 1.0 / CLOCKS_PER_SEC < 0.1) {
                ;
            }
        }
        return;
    }
    assert(false);
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int t, g;
    std::cin >> t >> g;
    while (t--) {
        solve();
    }

    return 0;
}
