#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vi = vector<int>;
using vl = vector<ll>;
using lll = __int128;
using ld = long double;
using vp = vector<pi>;
using vpl = vector<pl>;

int n, m1, m2;
vector<vi> g1, g2;

void yes(vp &ans) {
    if (ans.size() > n) {
        while (true) {}
    }
    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto[a, b] : ans)
        cout << a+1 << " " << b+1 << "\n";
}
void no() {
    cout << "No\n";
}

void solve3() { // n = 3
    vi v1(3, 0), v2(3, 0);
    for (int i = 0; i < n; i++) {
        for (int to : g1[i]) {
            if (to < i) continue;
            v1[i+to-1]++;
        }
        for (int to : g2[i]) {
            if (to < i) continue;
            v2[i+to-1]++;
        }
    }
    bool b1 = false;
    bool b2 = false;
    vp ans;
    for (int i = 0; i < 3; i++) {
        if (v1[i] == 1 && v2[i] == 1) continue;
        if (v1[i] == 0 && v2[i] == 0) {
            ans.emplace_back(0, 1);
            continue;
        }
        if (v1[i] == 1) {
            if (b1 == false)
                b1 = true;
            else if (b2 == false) {
                b2 = true;
                ans.emplace_back(0, 1);
            } else {
                no(); return;
            }
        } else {
            if (b2 == false)
                b2 = true;
            else if (b1 == false) {
                b1 = true;
                ans.emplace_back(0, 1);
            } else {
                no(); return;
            }
        }
    }
    yes(ans);
}

void solve() {
    cin >> n >> m1 >> m2;
    g1.assign(n, vi());
    g2.assign(n, vi());
    map<pi, int> ed1, ed2;
    for (int i = 0; i < m1; i++) {
        int a, b; cin >> a >> b; a--, b--;
        g1[a].push_back(b);
        g1[b].push_back(a);
        ed1[{a, b}] = 1;
        ed1[{b, a}] = 1;
    }
    for (int i = 0; i < m2; i++) {
        int a, b; cin >> a >> b; a--, b--;
        g2[a].push_back(b);
        g2[b].push_back(a);
        ed2[{a, b}] = 1;
        ed2[{b, a}] = 1;
    }
    if (n == 3) { solve3(); return; }
    vp ans;
    // bad dot
    auto addEdge = [](vector<vi> &g, int i, int j, map<pi, int> &mp) {
        g[i].push_back(j);
        g[j].push_back(i);
        mp[{i, j}] = 1;
        mp[{j, i}] = 1;
    };
    auto remEdge = [](vector<vi> &g, int i, int j, map<pi, int> &mp) {
        g[i].erase(find(g[i].begin(), g[i].end(), j));
        g[j].erase(find(g[j].begin(), g[j].end(), i));
        mp.erase({i, j});
        mp.erase({j, i});
    };
    auto edgee = [&](int i, int j) {
        if (ed1.find({i, j}) == ed1.end())
            addEdge(g1, i, j, ed1);
        else
            remEdge(g1, i, j, ed1);
        if (ed2.find({i, j}) == ed2.end())
            addEdge(g2, i, j, ed2);
        else
            remEdge(g2, i, j, ed2);
        ans.emplace_back(i, j);
    };
    for (int i = 0; i < n; i++) {
        if (g2[i].size() == n-1) {
            if (!g1[i].empty())
                break;
            int j = g2[i].back();
            int j2 = g2[i].front();
            if (ed2.find({j, j2}) != ed2.end())
                break;
            edgee(j, j2);
            edgee(i, j);
            break;
        }
    }

    map<pi, int> mp2;
    vector<char> used2(n, 0);
    function<void(int)> dfs1;
    dfs1 = [&](int v) {
        used2[v] = 1;
        for (int to : g2[v]) {
            if (used2[to] == 1) continue;
            mp2[{v, to}] = 1;
            mp2[{to, v}] = 1;
            dfs1(to);
        }
    };
    dfs1(0);
    // mp2 = ostov from g2
    int vv0 = rand() % n;

    set<int> need;
    for (int i = 0; i < n; i++) need.insert(i);
    need.erase(vv0);

    set<int> stack;
    stack.insert(vv0);
    vi used(n, 0);
    while (!stack.empty()) {
        int v = *stack.begin();
        stack.erase(stack.begin());
        if (used[v]) continue;
        used[v] = 1;

        vi rem, add;
        for (int to : need) {
            if (ed1.find({v, to}) != ed1.end()) {
                rem.push_back(to);
                stack.insert(to);
            } else if (mp2.find({v, to}) == mp2.end()) {
                add.push_back(to);
                stack.insert(to);
            }
        }
        for (int i : rem)
            need.erase(i);
        for (int i : add) {
            need.erase(i);
            ans.emplace_back(v, i);
        }
    }
    yes(ans);
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);
    int t, g; cin >> t >> g;
    while (t--)
        solve();
}
