#include<bits/stdc++.h>
using namespace std;

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    vector<vector<int>> g1(n, vector<int>(n)), g2;
    g2 = g1;

    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;

        a--;
        b--;

        g1[a][b] = 1;
        g1[b][a] = 1;
    }

    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;

        a--;
        b--;

        g2[a][b] = 1;
        g2[b][a] = 1;
    }

    auto oper = [&](int a, int b) {
        g1[a][b] ^= 1;
        g1[b][a] ^= 1;
        g2[a][b] ^= 1;
        g2[b][a] ^= 1;
    };

    auto check3 = [&](vector<vector<int>> &g) {
        return (g[0][1] && g[1][2]) || (g[1][2] && g[2][0]) || (g[2][0] && g[0][1]);
    };

    if (n == 3) {
        vector<pair<int, int>> pr = {{0, 1}, {1, 2}, {2, 0}};
        if (check3(g1)) {
            cout << "YES\n0\n";
            return;
        }

        for (int i = 0; i < n; i++) {
            oper(pr[i].first, pr[i].second);
            if (!check3(g2)) {
                oper(pr[i].first, pr[i].second);
                continue;
            }

            if (check3(g1)) {
                cout << "YES\n1\n" << pr[i].first + 1 << ' ' << pr[i].second + 1 << "\n";
                return;
            }

            for (int j = 0; j < n; j++) {
                oper(pr[j].first, pr[j].second);
                if (!check3(g2)) {
                    oper(pr[j].first, pr[j].second);
                    continue;
                }

                if (check3(g1)) {
                    cout << "YES\n2\n" << pr[i].first + 1 << ' ' << pr[i].second + 1 << "\n" << pr[j].first + 1 << ' ' << pr[j].second + 1 << "\n";
                    return;
                }

                for (int k = 0; k < n; k++) {
                    oper(pr[k].first, pr[k].second);
                    if (!check3(g2)) {
                        oper(pr[k].first, pr[k].second);
                        continue;
                    }

                    if (check3(g1)) {
                        cout << "YES\n3\n" << pr[i].first + 1 << ' ' << pr[i].second + 1 << "\n" << pr[j].first + 1 << ' ' << pr[j].second + 1 << "\n" << pr[k].first + 1 << ' ' << pr[k].second + 1 << "\n";
                        return;
                    }

                    oper(pr[k].first, pr[k].second);
                }

                oper(pr[j].first, pr[j].second);
            }

            oper(pr[i].first, pr[i].second);
        }

        cout << "NO\n";
    }
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t, g;
    cin >> t >> g;

    while(t--) {
        solve();
    }
}

/*
1 0
3 1 2
1 3
1 2
1 3
*/