#include<bits/stdc++.h>
using namespace std;

int n;
vector<vector<int>> g1, g2, g3;
vector<int> used;
vector<pair<int, int>> good;
void dfs(int i, vector<vector<int>> &g) {
    used[i] = 1;
    for (int j = 0; j < n; j++) {
        if (!g[i][j] || used[j]) continue;
        good.push_back({i, j});
        dfs(j, g);
    }
}

void solve() {
    int m1, m2;
    cin >> n >> m1 >> m2;

    g1.assign(n, vector<int>(n));
    used.assign(n, 0);
    g2 = g1;

    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;

        a--;
        b--;

        g1[a][b] = 1;
        g1[b][a] = 1;
    }

    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;

        a--;
        b--;

        g2[a][b] = 1;
        g2[b][a] = 1;
    }

    auto oper = [&](int a, int b) {
        g1[a][b] ^= 1;
        g1[b][a] ^= 1;
        g2[a][b] ^= 1;
        g2[b][a] ^= 1;
    };

    auto check3 = [&](vector<vector<int>> &g) {
        return (g[0][1] && g[1][2]) || (g[1][2] && g[2][0]) || (g[2][0] && g[0][1]);
    };

    if (n == 3) {
        vector<pair<int, int>> pr = {{0, 1}, {1, 2}, {2, 0}};
        if (check3(g1)) {
            cout << "YES\n0\n";
            return;
        }

        for (int i = 0; i < n; i++) {
            oper(pr[i].first, pr[i].second);
            if (!check3(g2)) {
                oper(pr[i].first, pr[i].second);
                continue;
            }

            if (check3(g1)) {
                cout << "YES\n1\n" << pr[i].first + 1 << ' ' << pr[i].second + 1 << "\n";
                return;
            }

            for (int j = 0; j < n; j++) {
                oper(pr[j].first, pr[j].second);
                if (!check3(g2)) {
                    oper(pr[j].first, pr[j].second);
                    continue;
                }

                if (check3(g1)) {
                    cout << "YES\n2\n" << pr[i].first + 1 << ' ' << pr[i].second + 1 << "\n" << pr[j].first + 1 << ' ' << pr[j].second + 1 << "\n";
                    return;
                }

                for (int k = 0; k < n; k++) {
                    oper(pr[k].first, pr[k].second);
                    if (!check3(g2)) {
                        oper(pr[k].first, pr[k].second);
                        continue;
                    }

                    if (check3(g1)) {
                        cout << "YES\n3\n" << pr[i].first + 1 << ' ' << pr[i].second + 1 << "\n" << pr[j].first + 1 << ' ' << pr[j].second + 1 << "\n" << pr[k].first + 1 << ' ' << pr[k].second + 1 << "\n";
                        return;
                    }

                    oper(pr[k].first, pr[k].second);
                }

                oper(pr[j].first, pr[j].second);
            }

            oper(pr[i].first, pr[i].second);
        }

        cout << "NO\n";
    } else {
        dfs(0, g2);
        int ok = -1;
        map<int, int> mp;
        for (auto [a, b] : good) {
            mp[a]++;
            mp[b]++;
            if (mp[a] == n - 1 || mp[b] == n - 1) {
                ok = (mp[a] == n - 1 ? a : b);
            }
        }

        vector<pair<int, int>> ans;

        if (ok != -1) {
            auto [a, b] = good.back();
            good.pop_back();

            if (a != ok) swap(a, b);

            int k1 = ((b + 1) % n == ok ? (b + n - 1) % n : (b + 1) % n), k2 = b;
            if (g2[k1][k2] == 0) {
                oper(k1, k2);
                ans.push_back({k1, k2});
            }

            good.push_back({k1, k2});
        }

        
        g3.assign(n, vector<int>(n, 1));
        for (auto [a, b] : good) {
            g3[a][b] = 0;
            g3[b][a] = 0;
        }

        good.clear();
        used.assign(n, 0);
        dfs(0, g3);
        assert(good.size() == n - 1);

        cout << "YES\n";
        for (int i = 0; i < n - 1; i++) {
            if (!g1[good[i].first][good[i].second]) {
                ans.push_back(good[i]);
            }
        }

        cout << ans.size() << "\n";
        for (auto [a, b] : ans) {
            cout << a + 1 << ' ' << b + 1 << "\n";
        }

        good.clear();
    } 
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t, g;
    cin >> t >> g;

    while(t--) {
        solve();
    }
}

/*
1 0
3 1 2
1 3
1 2
1 3

3 0
3 0 3
1 2 
2 3
1 3
4 2 3
1 2
3 4
1 3
1 4
2 3
4 3 3
1 2
2 3
1 3
1 4
2 4
3 4
*/