//#pragma GCC optimize("o-fast", "unroll-loops", "fast-math")
//#pragma GCC target("avx", "avx2", "bmi", "bmi2")
#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define ld long double
#define sz(a) (int)a.size()

const int mod = 1e9-7;
const ld eps = 1e-12;

mt19937 rng(time(0));
int rnd(int n) {
    uniform_int_distribution<int> uid(0, n - 1);
    return uid(rng);
}
vector<map<int,int>> g;
vector<set<int>> ga,gb;
pair<int,int> e = {-1,-1};

void dfs(){
    int n = sz(ga);
    vector<pair<int,int>> ans;
    if(g[e.first][e.second]!=2){
        ans.push_back(e);
    }
    for(int i = 0 ; i < n; i++){
        if(e.first==i || e.second == i){
            continue;
        }
        if(ga[e.first].find(i) != ga[e.first].end()){
            continue;
        }
        if(ga[e.second].find(i) != ga[e.second].end()){
            continue;
        }
        if(gb[e.first].find(i) == gb[e.first].end()){
            ans.push_back({e.first, i});
        }
        else{
            ans.push_back({e.second, i});
        }
    }
    cout<<sz(ans)<<endl;
    for(int i = 0; i < sz(ans); i++){
        cout<<ans[i].first+1<<" "<<ans[i].second+1<<endl;
    }
}

void solve(){
    int n;
    int m1, m2;
    cin>>n>>m1>>m2;
    g.clear();
    ga.clear();
    gb.clear();
    e={-1,-1};
    g.resize(n);
    ga.resize(n);
    gb.resize(n);
    for(int i = 0; i < m1; i++){
        int a,b;
        cin>>a>>b;
        a--;
        b--;
        g[a][b]++;
        g[b][b]++;
        ga[a].insert(b);
        ga[b].insert(a);
    }
    for(int i = 0; i < m2; i++){
        int a,b;
        cin>>a>>b;
        a--;
        b--;
        g[a][b]++;
        g[b][a]++;
        if(g[a][b]==2){
            e={a,b};
        }
        gb[a].insert(b);
        gb[b].insert(a);
    }
    if(e.first != -1){
        cout<<"YES"<<endl;
        dfs();
        return;
    }
    for(int i = 0 ; i < n; i++){
        if(sz(g[i])==n-1){
            continue;
        }
        int cur = 0;
        for(auto key : g[i]){
            if(cur==i){
                cur++;
                continue;
            }
            if(key.first != cur){
                e = {i,cur};
                break;
            }
            cur++;
        }
        if(e.first==-1){
            e={i,cur};
        }
    }
    if(e.first != -1){
        cout<<"YES"<<endl;
        dfs();
        return;
    }
    if(n>3){
        cout<<"YES"<<endl;

        vector<pair<int,int>> dopa,dopb;
        for(int i = 0; i < 4; i++){
            if(ga[i].find((i+1)%4) != ga[i].end()){
                dopa.push_back({i,(i+1)%4});
            }
            else{
                dopb.push_back({i,(i+1)%4});
            }
        }
        if(sz(dopa)<=2){
            e=dopa[0];
            if(sz(dopa)==1){
                g[e.first][e.second]=2;
            }
            else{
                g[e.first][e.second]=0;
            }
        }
        else{
            e=dopb[0];

            if(sz(dopb)==1){
                g[e.first][e.second]=2;
            }
            else{
                g[e.first][e.second]=0;
            }
        }
        dfs();

    }
    else{
        cout<<"NO"<<endl;
    }
}
signed main() {
    cout.tie(nullptr);
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int n = 1;
    cin >> n;
    int gr;
    cin>>gr;
    while(n--){
        solve();
    }
}
