#include <bits/stdc++.h>

using namespace std;

struct Sp2 {
    int n, m1, m2;
    set<pair<int, int>> s1;

    Sp2() {
        cin >> n >> m1 >> m2;
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            --u; --v;
            if (u > v) swap(u, v);
            s1.emplace(u, v);
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
        }

        if (n == 3) {
            if (s1.size() == 0) {
                cout << "No" << endl;
                return;
            }
            if (s1.size() == 1) {
                int other = 3 - s1.begin()->first - s1.begin()->second;
                cout << "Yes" << endl;
                cout << "1" << endl;
                cout << s1.begin()->first + 1 << ' ' << other + 1 << endl;
                return;
            }
        }

        cout << "Yes" << endl;
        vector<pair<int, int>> ans;
        for (int i = 0; i < n - 1; ++i) {
            if (!s1.count({ i, i + 1 })) {
                ans.emplace_back(i + 1, i + 2);
            }
        }

        cout << ans.size() << endl;
        for (auto& val : ans) {
            cout << val.first << ' ' << val.second << endl;
        }
    }
};

struct Sp3 {
    int n, m1, m2;
    set<pair<int, int>> s1, s2;

    vector<bool> used;
    vector<vector<int>> g;
    vector<vector<int>> h;

    void dfs(int v, unordered_set<int>& comp) {
        used[v] = true;
        comp.insert(v);
        for (int child : g[v]) {
            if (!used[child]) {
                dfs(child, comp);
            }
        }
    }

    bool dfs2(int v, int banu, int banv, int to) {
        if (v == to) {
            return true;
        }
        used[v] = true;
        for (int child : g[v]) {
            if (!used[child] && !(v == banu && child == banv) && !(v == banv && child == banu)) {
                if (dfs2(child, banu, banv, to)) {
                    return true;
                }
            }
        }
        return false;
    }

    Sp3() {
        cin >> n >> m1 >> m2;
        g.resize(n);
        h.resize(n);
        for (int i = 0; i < m1; ++i) {
            int u, v;
            cin >> u >> v;
            --u; --v;
            if (u > v) swap(u, v);
            s1.emplace(u, v);
            g[u].push_back(v);
            g[v].push_back(u);
        }
        for (int i = 0; i < m2; ++i) {
            int u, v;
            cin >> u >> v;
            if (u > v) swap(u, v);
            s2.emplace(u, v);
            h[u].push_back(v);
            h[v].push_back(u);
        }
        used.resize(n);

        unordered_set<int> comp1, comp2;
        dfs(0, comp1);
        for (int i = 0; i < n; ++i) {
            if (!comp1.count(i)) {
                dfs(i, comp2);
                break;
            }
        }

        if (comp1.size() == 1 || comp2.size() == 1) {
            for (int u : comp1) {
                for (int v : comp2) {
                    if (u > v) swap(u, v);
                    if (!s2.count({ u, v })) {
                        cout << "Yes" << endl;
                        cout << "1" << endl;;
                        cout << u + 1 << ' ' << v + 1 << endl;
                        return;
                    } else {
                        used.clear();
                        used.resize(n);
                        if (dfs2(u, u, v, v)) {
                            cout << "Yes" << endl;
                            cout << "1" << endl;;
                            cout << u + 1 << ' ' << v + 1 << endl;
                            return;
                        }
                    }
                }
            }
            cout << "No" << endl;
            return;
        }

        cout << "Yes" << endl;
        cout << "1" << endl;;
        for (int u : comp1) {
            for (int v : comp2) {
                if (u > v) swap(u, v);
                if (!s2.count({ u, v })) {
                    cout << u + 1 << ' ' << v + 1 << endl;
                    return;
                }
            }
        }
        cout << *comp1.begin() + 1 << ' ' << *comp2.begin() + 1 << endl;
    }
};

signed main() {
    int t, g;
    cin >> t >> g;
    while (t--) {
        if (g == 2) {
            Sp2();
        } else if (g == 3) {
            Sp3();
        }
    }
}
