#include <bits/stdc++.h>
using namespace std;
using ll = long long;
vector<int> p1, p2;
int fp1(int a){
    if(p1[a] != a )
        return p1[a] = fp1(p1[a]);
    return a;
}
int fp2(int a){
    if(p2[a] != a )
        return p2[a] = fp2(p2[a]);
    return a;
}
void solve(){
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<pair<int, int>> edgf;
    set<pair<int, int>> edg1, edg2;
    for (int i = 0; i < m1; ++i) {
        int a, b;
        cin >> a >> b;
        if(a > b)
            swap(a, b);
        edg1.insert({--a, --b});
    }
    for (int i = 0; i < m2; ++i) {
        int a, b;
        cin >> a >> b;
        if(a > b)
            swap(a, b);
        edg2.insert({--a, --b});
    }
    for (int i = 0; i < n-1; ++i) {
        for (int j = i+1; j < n; ++j) {
            edgf.emplace_back(i, j);
        }
    }
    vector<int>  sz1(n, 1), sz2(n, 1);
    int k = edgf.size();

    auto unit1 = [&](int a, int b){
        a = fp1(a), b = fp1(b);
        if(a == b)
            return ;
        if(sz1[a] > sz1[b])
            swap(a, b);
        p1[a] = b;
        sz1[b] += sz1[a];
    };

    auto unit2 = [&](int a, int b){
        a = fp2(a), b = fp2(b);
        if(a == b)
            return ;
        if(sz2[a] > sz2[b])
            swap(a, b);
        p2[a] = b;
        sz2[b] += sz2[a];
    };
    vector<char> count1(k), count2(k);
    for (int i = 0; i < k; ++i) {
        count1[i] = (edg1.count(edgf[i]));
        count2[i] = (edg2.count(edgf[i]));
    }
    p1.resize(n), p2.resize(n);
    for (int i = 0; i < (1<<k); ++i) {
        for (int j = 0; j < n; ++j) {
            p1[j] = p2[j] = j;
            sz1[j] = sz2[j] = 1;
        }
        vector<pair<int, int>> ans;
        for (int j = 0; j < k; ++j) {
            if((1<<j) & i){
                ans.push_back(edgf[j]);
                if(!count1[j])
                    unit1(edgf[j].first, edgf[j].second);
                if(!count2[j])
                    unit2(edgf[j].first, edgf[j].second);
            }else{
                if(count1[j])
                    unit1(edgf[j].first, edgf[j].second);
                if(count2[j])
                    unit2(edgf[j].first, edgf[j].second);
            }
        }
        bool check = 1;
        for (int j = 1; j < n; ++j) {
            if(fp1(j) != fp1(j-1) || fp2(j) != fp2(j-1))
                check = 0;
        }
        if(check){
            cout << "Yes\n" ;
            cout << ans.size() << '\n';
            for (auto [x, y]: ans) {
                cout << x+1 << ' ' << y+1 << '\n';
            }
            return;
        }
    }
    cout << "No\n";
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1, _G;
    cin >> _ >> _G;
    while(_--){
        if(_G < 2)
            solve();
    }
    return 0;
}
/*

3 0
3 0 3
1 2
2 3
1 3
4 2 3
1 2
3 4
1 3
1 4
2 3
4 3 3
1 2
2 3
1 3
1 4
2 4
3 4
 */