#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define p_b push_back
#define pw(x) (1LL << (x))
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template<class T> void amin(T &a, T b) {a = a < b ? a : b;}
template<class T> void amax(T &a, T b) {a = a > b ? a : b;}

const int N = 3e5 + 5;

int group_name;

int p[N][2];
int rnk[N][2];
int comp[2];
bool bad[10][2];

int find_set(int v, int ind) {
    if (v == p[v][ind])
        return v;
    return find_set(p[v][ind], ind);
}

bool unite(int u, int v, int ind) {
    u = find_set(u, ind);
    v = find_set(v, ind);
    if (u == v)
        return 0;
    if (rnk[u][ind] > rnk[v][ind])
        swap(u, v);
    p[u][ind] = v;
    if (rnk[u][ind] == rnk[v][ind])
        rnk[v][ind]++;
    comp[ind]--;
    return 1;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 2; j++) {
            comp[j] = n;
            p[i][j] = i;
            rnk[i][j] = 0;
        }
    }
    int m1, m2;
    cin >> m1 >> m2;
    bool bamboo = 1;
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < 2; j++) {
//            g[i][j].clear();
//        }
//    }
    set<array<int, 2>> edg1, edg2;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        if (u > v)
            swap(u, v);
//        cout << '\t' << u << ' ' << v << '\n';
        unite(u, v, 0);
        edg1.insert({u, v});
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        if (u > v)
            swap(u, v);
        if (u != i || v != i + 1) {
            bamboo = 0;
        }
        unite(u, v, 1);
        edg2.insert({u, v});
    }
    if (n <= 5) {
        vector<array<int, 2>> edges;
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                edges.p_b({i, j});
            }
        }
        for (int i = 0; i < pw(sz(edges)); i++) {
            for (int j = 0; j < n; j++) {
                for (int ind = 0; ind < 2; ind++) {
                    p[j][ind] = j;
                    rnk[j][ind] = 0;
                    comp[ind] = n;
                }
            }
            int changed = 0;
            for (int j = 0; j < sz(edges); j++) {
                if (!(i & pw(j)))
                    continue;
                changed++;
                if (edg1.find(edges[j]) != edg1.end()) {
                    edg1.erase(edges[j]);
                } else {
                    edg1.insert(edges[j]);
                }
                if (edg2.find(edges[j]) != edg2.end()) {
                    edg2.erase(edges[j]);
                } else {
                    edg2.insert(edges[j]);
                }
            }
            for (auto [u, v] : edg1)
                unite(u, v, 0);
            for (auto [u, v] : edg2)
                unite(u, v, 1);
            if (changed <= n && comp[0] == comp[1] && comp[0] == 1) {
                cout << "Yes\n";
                cout << changed << '\n';
                for (int j = 0; j < sz(edges); j++) {
                    if (i & pw(j)) {
                        cout << edges[j][0] + 1 << ' ' << edges[j][1] + 1 << '\n';
                    }
                }
//                for (auto [u, v] : edg1)
//                    cout << '\t' << u << ' ' << v << '\n';
//                cout << '\n';
//                for (auto [u, v] : edg2)
//                    cout << '\t' << u << ' ' << v << '\n';
                return;
            }
            for (int j = 0; j < sz(edges); j++) {
                if (!(i & pw(j)))
                    continue;
                if (edg1.find(edges[j]) != edg1.end()) {
                    edg1.erase(edges[j]);
                } else {
                    edg1.insert(edges[j]);
                }
                if (edg2.find(edges[j]) != edg2.end()) {
                    edg2.erase(edges[j]);
                } else {
                    edg2.insert(edges[j]);
                }
            }
        }
        cout << "No\n";
        return;
    }
    vector<array<int, 2>> ans;
//    if (bamboo) {
//        for (int i = 0; i < n; i++) {
//            if (find_set(i) == find_set(0))
//                continue;
//            if (i == )
//        }
//    }
}

int32_t main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // LOCAL
    int t = 1;
    cin >> t;
    cin >> group_name;
    while (t--) {
        solve();
    }
    #ifdef LOCAL
        cout << "\n\n===\n\nTime : " << (long double)clock() / CLOCKS_PER_SEC << '\n';
    #endif // LOCAL
}
