#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
vector<bool> vis1;
vector<bool> vis2;
vector<vector<int>> graph1(4);
vector<vector<int>> graph2(4);
void dfs1(int x) {
    vis1[x] = true;
    for (auto &i : graph1[x]) {
        if (!vis1[i]) {
            dfs1(i);
        }
    }
}
void dfs2(int x) {
    vis2[x] = true;
    for (auto &i : graph2[x]) {
        if (!vis2[i]) {
            dfs2(i);
        }
    }
}
int main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t, g;
    cin >> t >> g;
    while (t--) {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        map<pair<int, int>, int> mp;
        for (int i = 0; i < m1; ++i) {
            int one, two;
            cin >> one >> two;
            one--;
            two--;
            if (one > two) {
                swap(one, two);
            }
            mp[{one, two}] ^= 1;
        }
        for (int i = 0; i < m2; ++i) {
            int one, two;
            cin >> one >> two;
            one--;
            two--;
            if (one > two) {
                swap(one, two);
            }
            mp[{one, two}] ^= 2;
        }
        if (n < 4) {
            cout << "No\n";
            continue;
        }
        vector<pair<int, int>> roads = {{0, 1}, {1, 2}, {2, 3}, {0, 2}, {0, 3}, {1, 3}};
        vector<pair<int, int>> ans;
        for (int i = 0; i < (1 << 6); ++i) {
            int cnt = 0;
            for (int j = 0; j < 6; ++j) {
                if (i & (1 << j)) {
                    cnt++;
                }
            }
            if (cnt > 4) {
                continue;
            }
            graph1.assign(4, {});
            graph2.assign(4, {});
            for (int j = 0; j < 6; ++j) {
                int num = mp[roads[j]];
                int cng = (3 * ((i >> j) & 1));
                if ((num ^ cng) & 1) {
                    graph1[roads[j].first].push_back(roads[j].second);
                    graph1[roads[j].second].push_back(roads[j].first);
                }
                if ((num ^ cng) & 2) {
                    graph2[roads[j].first].push_back(roads[j].second);
                    graph2[roads[j].second].push_back(roads[j].first);
                }
            }
            vis1.assign(4, false);
            vis2.assign(4, false);
            dfs1(0);
            dfs2(0);
            bool okay = true;
            for (int j = 0; j < 4; ++j) {
                if (!vis1[j] || !vis2[j]) {
                    okay = false;
                }
            }
            if (okay) {
                for (int j = 0; j < 6; ++j) {
                    if (i & (1 << j)) {
                        ans.push_back(roads[j]);
                    }
                }
                break;
            }
        }
        for (int i = 4; i < n; ++i) {
            int last = i - 1;
            int preflast = i - 2;
            if (mp[{last, i}] == 3 || mp[{preflast, i}] == 3) {

            } else if (mp[{last, i}] == 0) {
                ans.push_back({last, i});
            } else if (mp[{preflast, i}] == 0) {
                ans.push_back({preflast, i});
            } else if (mp[{last, i}] == mp[{preflast, i}]) {
                ans.push_back({last, i});
            }
        }
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto &i : ans) {
            cout << i.first + 1 << " " << i.second + 1 << '\n';
        }
    }
}
