#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

int group;

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    set<pair<int, int>> q1, q2;
    vector<vector<int>> g(n), g2(n);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        q1.insert({u, v});
        q1.insert({v, u});
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        q2.insert({u, v});
        q2.insert({v, u});
        g2[u].push_back(v);
        g2[v].push_back(u);
    }
    if (m2 == (ll) n * (n - 1) / 2) {
        if (m1 == 0 && n == 3) {
            cout << "No";
            return;
        }
        vector<pair<int, int>> ans;
        for (int i = 0; i < n; ++i) {
            if (q1.find({i, i + 1}) == q1.end()) {
                ans.emplace_back(i, i + 1);
            }
        }
        cout << "Yes\n" << ans.size() << '\n';
        for (auto &[i, j] : ans) cout << i << ' ' << j << '\n';
        return;
    }
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t >> group;
    while (t--) {
        solve();
    }
    return 0;
}
