#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
using namespace std;
vector<vector<int>> g1, g2;
vector<int>col;
int timer = 0;
void pokras(int v){
    col[v] = timer;
    for(auto& to : g1[v]){
        if(col[to] != -1) continue;
        pokras(to);
    }
}

vector<int>dp, tin;
set<pii>br;
void find_b(int v, int p){
    tin[v] = ++timer;
    dp[v] = tin[v];
    for(auto& to : g2[v]){
        if(to == p) continue;
        if(tin[to] != -1){
            dp[v] = min(dp[v], tin[to]);
            continue;
        }
        find_b(to, v);
        dp[v] = min(dp[v], dp[to]);
        if(dp[to] > tin[v]){
            br.insert({min(v, to), max(v, to)});
        }
    }
}

vector<int>p, sz;

int get(int a){
    if(a == p[a]) return a;
    return p[a] = get(p[a]);
}

void unite(int a, int b){
    a = get(a), b = get(b);
    if(a == b) return;
    if(sz[a] > sz[b]) swap(a, b);
    p[a] = b;
    sz[b] += sz[a];
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t, gr;
    cin >> t >> gr;

    while(t--){
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        g1.assign(n, {});
        g2.assign(n, {});

        p.assign(n, 0ll); sz.assign(n, 0ll);
        for(int i = 0; i < n; i++){
            p[i] = i; sz[i] = 1;
        }

        for(int i = 0; i < m1; i++){
            int u, v;
            cin >> u >> v;
            u--; v--;
            unite(u, v);
            g1[u].push_back(v);
            g1[v].push_back(u);
        }

        for(int i = 0; i < m2; i++){
            int u, v;
            cin >> u >> v;
            u--; v--;
            g2[u].push_back(v);
            g2[v].push_back(u);
        }
        cout << "Yes\n";
        vector<pii>ans;
        for(int i = 0; i < n; i++){
            int cnt = 0;
            for(int j = 0; j < n; j++){
                if(get(i) != get(j)){
                    cnt++;
                    if(cnt == 2) continue;
                    unite(i, j);
                    ans.push_back({i, j});
                }
            }
        }
        cout << (int)ans.size() << '\n';
        for(auto& i : ans){
            cout << i.first + 1 << ' ' << i.second + 1 << '\n';
        }
    }

    return 0;
}
