#include <bits/stdc++.h>
using namespace std;
#define int long long
const int INF = 1e18;

void solve();

vector <int> p;
vector <int> rnk;
int get(int a){
    if (p[a] == a){
        return a;
    }
    return get(p[a]);
}
void update(int a, int b){
    a = get(a);
    b = get(b);
    if (a != b){
        if (rnk[a] > rnk[b]){
            swap(a, b);
        }
        p[b] = p[a];
        rnk[a] += rnk[b];
    }
}
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t, g;
    cin >> t >> g;
    while (t--){
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        p.resize(n);
        rnk.resize(n);
        for (int i = 0; i < n; i++){
            p[i] = i;
            rnk[i] = 1;
        }
        vector <vector <int>> mat(n, vector <int> (n, 0));
        for (int i = 0; i < m1; i++){
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            update(a, b);
        }
        for (int i = 0; i < m2; i++){
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            mat[a][b] = 1;
            mat[b][a] = 1;
        }
        if (n == 3 && m1 == 0){
            cout << "No" << "\n";
            continue;
        }
        vector <pair <int, int>> ans;
        for (int i = 0; i < n - 1; i++){
            for (int j = i + 1; j < n; j++){
                if (!mat[i][j] && get(i) != get(j)){
                    ans.emplace_back(i + 1, j + 1);
                    update(i, j);
                }
            }
        }
        for (int i = 0; i < n - 1; i++){
            for (int j = i + 1; j < n; j++){
                if (get(i) != get(j)){
                    ans.emplace_back(i + 1, j + 1);
                    update(i, j);
                }
            }
        }
        cout << "Yes" << "\n";
        cout << ans.size() << "\n";
        for (auto x : ans){
            cout << x.first << " " << x.second << "\n";
        }
        p.clear();
        rnk.clear();
    }
}
