#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>
#include <array>
using namespace std;
using ll = long long;
vector<vector<int>> g1, g2;
vector<bool> used;
void dfs(int v) {
	used[v] = 1;
	for (int i = 0; i < g1[v].size(); i++) {
		if (g1[v][i] == 1 && !used[i]) dfs(i);
	}
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t, gr; cin >> t >> gr;
	while (t--) {
		int n, m1, m2; cin >> n >> m1 >> m2;
		g1.assign(n, vector<int>(n, 0));
		g2.assign(n, vector<int>(n, 0));
		for (int i = 0; i < m1; i++) {
			int u, v; cin >> u >> v; u--; v--;
			g1[u][v] = g1[v][u] = 1;
		}
		for (int i = 0; i < m2; i++) {
			int u, v; cin >> u >> v; u--; v--;
			g2[u][v] = g2[v][u] = 1;
		}
		vector<pair<int, int>> edge;
		if (gr == 2) {
			if (n == 3) {
				if (m1 == 0) {
					cout << "No\n"; continue;
				}
				if (m1 == 1 && g1[0][2]) {
					cout << "Yes\n1\n1 2\n"; continue;
				}
			}
			cout << "Yes\n";
			for (int i = 1; i < n - 1; i++) {
				if (!g1[0][i]) {
					edge.push_back({ 1, i + 1 });
				}
			}
			if (!g1[1][n - 1]) {
				edge.push_back({ 2, n });
			}
			cout << edge.size() << endl;
			for (auto i : edge) cout << i.first << " " << i.second << endl;
		}
		if (gr == 3) {
			used.assign(n, 0); dfs(0); int cnt = 0; bool byl = 0;
			for (int i = 0; i < n; i++) cnt += used[i];
			for (int i = 0; i < n; i++) {
				if (!used[i]) continue;
				for (int j = 0; j < n; j++) {
					if (used[j]) continue;
					if (!g1[i][j] && !g2[i][j]) {
						cout << "Yes\n1\n"; byl = 1;
						cout << i + 1 << " " << j + 1 << endl; break;
					}
				}
				if (byl) break;
			}
			if (byl) continue;
			vector<int> a, b;
			for (int i = 0; i < n; i++) {
				if (used[i]) a.push_back(i);
				if (!used[i]) b.push_back(i);
			}
			if (cnt != 1 && cnt != n - 1) {
				cout << "Yes\n1\n";
				cout << a[0] + 1 << " " << b[0] + 1 << endl;
				continue;
			}
			if (cnt == n - 1) {
				swap(a, b);
			}
			for (int i = 0; i < n - 1; i++) {
				for (int j = i + 1; j < n - 1; j++) {
					if (g2[b[i]][b[j]]) {
						cout << "Yes\n1\n";
						cout << a[0] + 1 << " " << b[i] + 1 << endl;
						byl = 1; break;
					}
					if (!g1[b[i]][b[j]] && !g2[b[i]][b[j]]) {
						cout << "Yes\n2\n";
						cout << b[i] + 1 << " " << b[j] + 1 << endl;
						cout << a[0] + 1 << " " << b[i] + 1 << endl;
						byl = 1; break;
					}
				}
				if (byl) break;
			}
			if (byl) continue;
			if (n == 3) {
				cout << "No\n"; continue;
			}
			cout << "Yes\n2\n";
			cout << b[0] + 1 << " " << b[1] + 1 << endl;
			cout << a[0] + 1 << " " << b[0] + 1 << endl;
		}
	}
	return 0;
}
