#include <iostream>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2,tune=native")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/hash_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define ll long long
#define vi vector <int>
#define pii pair <int, int>
#define endl '\n'
#define pb push_back
#define ft first
#define sd second
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define RFOR(i, a, b) for (int i = a; i >= b; --i)
#define EACH(e, a) for (auto& e : a)
using pbds = tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>;
using gp_hash = gp_hash_table <int, int>;
mt19937 rng(time(0));
#define int long long
///
constexpr int MAX = 2e5 + 7, INF = 1e9 + 7, MOD = 1e9 + 7, LG = 18, R = 1 << LG, B = 320;
constexpr ll INFLL = 1e18 + 7;

struct dsu {
    vi p, s;
    dsu() {}
    dsu(int n) {
        p.resize(n), iota(all(p), 0);
        s.assign(n, 1);
    }
    int get(int v) { return (v == p[v]) ? (v) : (p[v] = get(p[v])); }
    int unite(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return 0;
        if (s[u] < s[v]) swap(u, v);
        s[u] += s[v], p[v] = u;
        return 1;
    }
};

int n, m1, m2;

void solve3() { // for n = 3
    vector <char> ok1(n * n), ok2(n * n);
    FOR(i, 0, m1) {
        int u, v; cin >> u >> v, --u, --v;
        ok1[u * n + v] = ok1[v * n + u] = 1;
    }
    FOR(i, 0, m2) {
        int u, v; cin >> u >> v, --u, --v;
        ok2[u * n + v] = ok2[v * n + u] = 1;
    }
    int cnt = 0, cnta = 0;
    vector <pii> ans;
    FOR(i, 0, n) FOR(j, i + 1, n) {
        cnta += ok1[i * n + j];
        if (ok1[i * n + j] == ok2[i * n + j]) {
            cnt++;
            if (!ok1[i * n + j]) {
                ans.pb({i, j});
                cnta++;
            }
        }
    }
    if (!cnt) return void(cout << "No\n");
    cout << "Yes\n";
    if (cnta == 1) {
        FOR(i, 0, n) FOR(j, i + 1, n) if (!ok1[i * n + j]) {
            ans.pb({i, j});
            goto fuck;
        }
        fuck:;
    }
    cout << sz(ans) << endl;
    EACH(p, ans) cout << p.ft + 1 << ' ' << p.sd + 1 << endl;
}

void solve_clique() {
    vector <char> ok1(n * n), ok2(n * n);
    FOR(i, 0, m1) {
        int u, v; cin >> u >> v, --u, --v;
        ok1[u * n + v] = ok1[v * n + u] = 1;
    }
    FOR(i, 0, m2) {
        int u, v; cin >> u >> v, --u, --v;
        ok2[u * n + v] = ok2[v * n + u] = 1;
    }
    vector <pii> ans;
    FOR(i, 1, n - 1) if (!ok1[i]) {
        ans.pb({0, i});
    }
    if (!ok1[n + (n - 1)]) ans.pb({1, n - 1});
    cout << "Yes" << endl << sz(ans) << endl;
    EACH(p, ans) cout << p.ft + 1 << ' ' << p.sd + 1 << endl;
}

void solve_tree() {
    vector <char> ok1(n * n), ok2(n * n);
    vi deg(n);
    FOR(i, 0, m1) {
        int u, v; cin >> u >> v, --u, --v;
        ok1[u * n + v] = ok1[v * n + u] = 1;
    }
    FOR(i, 0, m2) {
        int u, v; cin >> u >> v, --u, --v;
        ++deg[u], ++deg[v];
        ok2[u * n + v] = ok2[v * n + u] = 1;
    }
    int star = -1;
    FOR(i, 0, n) if (deg[i] == n - 1) star = i;
    if (star >= 0) {
        assert(star == 0);
        vector <pii> ans;
        int kek = -1;
        FOR(i, 0, n) {
            int j = (i + 1) % n;
            if (i != star && j != star) {
                if (!ok1[i * n + j]) {
                    ans.pb({i, j});
                    kek = i;
                }
            }
        }
        bool already = 0;
        FOR(i, 0, n) if (ok1[star * n + i]) already = 1;
        if (!already) {
            if (kek < 0) {
                int u = (star + 1) % n, v = (star + 3) % n;
                ans.pb({u, v});
                ans.pb({u, star});
            }
            else {
                ans.pb({kek, star});
            }
        }
        cout << "Yes" << endl << sz(ans) << endl;
        EACH(p, ans) cout << p.ft + 1 << ' ' << p.sd + 1 << endl;
    }
    else {
        dsu U(n);
        int comps = n;
        vector <pii> ans;
        FOR(i, 0, n) FOR(j, i + 1, n) {
            if (ok1[i * n + j]) comps -= U.unite(i, j);
            else {
                if (!ok2[i * n + j]) {
                    bool f = U.unite(i, j);
                    if (f) ans.pb({i, j}), --comps;
                }
            }
        }
        assert(comps == 1);
        cout << "Yes" << endl << sz(ans) << endl;
        EACH(p, ans) cout << p.ft + 1 << ' ' << p.sd + 1 << endl;
    }
}

void solve_big() {
    unordered_map <int, int> ok1, ok2;
    vi deg(n);
    FOR(i, 0, m1) {
        int u, v; cin >> u >> v, --u, --v;
        ok1[u * n + v] = ok1[v * n + u] = 1;
    }
    FOR(i, 0, m2) {
        int u, v; cin >> u >> v, --u, --v;
        ++deg[u], ++deg[v];
        ok2[u * n + v] = ok2[v * n + u] = 1;
    }
    int star = -1;
    FOR(i, 0, n) if (deg[i] == n - 1) star = i;
    assert(star == 0);
        vector <pii> ans;
        int kek = -1;
        FOR(i, 0, n) {
            int j = (i + 1) % n;
            if (i != star && j != star) {
                if (!ok1[i * n + j]) {
                    ans.pb({i, j});
                    kek = i;
                }
            }
        }
        bool already = 0;
        FOR(i, 0, n) if (ok1[star * n + i]) already = 1;
        if (!already) {
            if (kek < 0) {
                int u = (star + 1) % n, v = (star + 3) % n;
                ans.pb({u, v});
                ans.pb({u, star});
            }
            else {
                ans.pb({kek, star});
            }
        }
        cout << "Yes" << endl << sz(ans) << endl;
        EACH(p, ans) cout << p.ft + 1 << ' ' << p.sd + 1 << endl;
}


void solve_goyda() {
    vector <char> ok1(n * n), ok2(n * n);
    vi deg(n);
    FOR(i, 0, m1) {
        int u, v; cin >> u >> v, --u, --v;
        ok1[u * n + v] = ok1[v * n + u] = 1;
    }
    FOR(i, 0, m2) {
        int u, v; cin >> u >> v, --u, --v;
        ++deg[u], ++deg[v];
        ok2[u * n + v] = ok2[v * n + u] = 1;
    }
    dsu U(n);
    int comps = n;
    vector <pii> ans;
        FOR(i, 0, n) FOR(j, i + 1, n) {
            if (ok1[i * n + j]) comps -= U.unite(i, j);
            else {
                if (!ok2[i * n + j]) {
                    bool f = U.unite(i, j);
                    if (f) ans.pb({i, j}), --comps;
                }
            }
        }
        if (comps == 1) {
            cout << "Yes" << endl << sz(ans) << endl;
            EACH(p, ans) cout << p.ft + 1 << ' ' << p.sd + 1 << endl;
        }
        else cout << "No\n";
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int tc = 1, group; cin >> tc >> group;
    while (tc--) {
        cin >> n >> m1 >> m2;
        if (n == 3) solve3();
        else if (group == 2) solve_clique();
        else if (group == 5 || group == 6) solve_tree();
        else if (group == 9) solve_big();
        else solve_goyda();
    }
}
