#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int n, m1, m2;
vector<vector<int>> g1, g2, gost;
vector<int> d;

void dfs1(int v) {
    for (int to : g2[v]) {
        if (d[to] == -1) {
            gost[v].push_back(to);
            gost[to].push_back(v);
            d[to] = d[v] + 1;
            dfs1(to);
        }
    }
}

void dfs2(int v) {
    for (int to : gost[v]) {
        if (d[to] == -1) {
            d[to] = d[v] + 1;
            dfs2(to);
        }
    }
}

void solve() {
    cin >> n >> m1 >> m2;
    g1.assign(n, vector<int>());
    g2.assign(n, vector<int>());
    set<pair<int, int>> s;

    for (int i = 0; i < m1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g1[a].push_back(b);
        g1[b].push_back(a);
        if (a > b) swap(a, b);
        s.emplace(a, b);
    }
    for (int i = 0; i < m2; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g2[a].push_back(b);
        g2[b].push_back(a);
    }

    if (n == 3) {

    } else {
        int pos = -1;
        for (int i = 0; i < n; i++) {
            if (g2[i].size() == n - 1) {
                pos = i;
                break;
            }
        }

        if (pos == -1) {
            d.assign(n, -1);
            gost.assign(n, vector<int>());
            d[0] = 0;
            dfs1(0);
            int good_v = -1;
            for (int i = 0; i < n; i++) {
                if (d[i] >= 3) good_v = i;
            }
            int root = 0;

            if (good_v == -1) {
                int mx = 0;
                for (int i = 0; i < n; i++) {
                    if (d[i] > d[mx]) mx = i;
                }
//                cout << "mx = " << mx << "\n";
                d.assign(n, -1);
                d[mx] = 0;
                dfs2(mx);
                for (int i = 0; i < n; i++) {
                    if (d[i] >= 3) good_v = i;
                }
                root = mx;
            }

//            cout << good_v << "\n";
//            for (int x : d) cout << x << " ";
//            cout << "\n";
//            for (int i = 0; i < n; i++) {
//                cout << i << ": ";
//                for (int x : gost[i]) cout << x << " ";
//                cout << "\n";
//            }

            vector<pair<int, int>> ans;
            auto add = [&](int a, int b) {
                if (a > b) swap(a, b);
                if (s.find(make_pair(a, b)) != s.end()) return;
                ans.emplace_back(a, b);
            };

            for (int i = 0; i < n; i++) {
                if (d[i] == 0) continue;
                if (d[i] >= 2) add(i, root);
                else add(i, good_v);
            }

            cout << "Yes\n";
            cout << ans.size() << "\n";
            for (auto [a, b] : ans) {
                cout << a + 1 << " " << b + 1 << "\n";
            }
        }
    }
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1, G;
    cin >> t >> G;
    while (t--) solve();
}