#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

//#pragma ("OFast")

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct Node{
    int v = -1, rg = 1, p = -1;
};

vector<Node> g;

int find_root(int v){
    if (g[v].p == g[v].v){
        return g[v].v;
    }
    return g[v].p = find_root(g[v].p);
}

bool unite(int v, int u){
    int pv = find_root(v);
    int pu = find_root(u);
    if (pv == pu){
        return false;
    }
    if (g[pv].rg < g[pu].rg){
        swap(pv, pu);
    }
    g[pu].p = pv;
    g[pv].rg += g[pu].rg;
    return true;
}

void solve(){
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    g.resize(n);
    vector<vector<int>> g1(n), g2(n);
    vector<array<int, 3>> all1(m1);
    vector<array<int, 2>> all2(m2);
    for (int i = 0; i < m1; i++){
        int v, u;
        cin >> v >> u;
        v--; u--;
        g1[v].push_back(u);
        g1[u].push_back(v);
        all1[i] = {v, u, 0};
    }
    for (int i = 0; i < m2; i++){
        int v, u;
        cin >> v >> u;
        v--; u--;
        g2[v].push_back(u);
        g2[u].push_back(v);
        all2[i] = {v, u};
    }
    int vv = -1;
    bool fl = true;
    for (int i = 0; i < n; i++){
        if (g2[i].size() == n - 1){
            if (vv == -1){
                vv = i;
                if (!g1[i].empty()){
                    fl = false;
                    break;
                }
            }
            else{
                fl = false;
                break;
            }
        }
        else if (g2[i].size() != 1){
            fl = false;
            break;
        }
    }
    if (fl){
        cout << "No\n";
        return;
    }
    for (int i = 0; i < n; i++){
        g[i].p = i;
        g[i].v = i;
        g[i].rg = 1;
    }
    set<pair<int, int>> st;
    for (auto [a, b] : all2){
        if (!unite(a, b)){
            all1.push_back({a, b, 1});
        }
        else{
            st.insert({a, b});
        }
    }
    for (int i = 0; i < n; i++){
        g[i].p = i;
        g[i].v = i;
        g[i].rg = 1;
    }
    vector<pair<int, int>> ans;
    int cnt = 0;
    for (auto [v, u, t] : all1){
        if (!unite(v, u) and t){
            ans.emplace_back(v + 1, u + 1);
            cnt++;
        }
    }
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            if (st.find({i, j}) == st.end() and unite(i, j)){
                cnt++;
                ans.emplace_back(i + 1, j + 1);
            }
            if (cnt == n - 1){
                break;
            }
        }
        if (cnt == n - 1){
            break;
        }
    }
    set<int> st2;
    for (int i = 0; i < n; i++){
        st2.insert(find_root(i));
    }
    if (st2.size() > 1){
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    cout << ans.size() << "\n";
    for (auto [a, b] : ans){
        cout << a << " " << b << "\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1, gr;
    cin >> t >> gr;
    while (t--){
        solve();
    }
}
