#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
constexpr int inf = 1e9 + 9;
constexpr ll infll = 1e18 + 9;
constexpr ld eps = 1e-6;
constexpr int N = 3e5 + 9;
constexpr int h = 262144;
int tree[h * 2];
int ans;
void get(int v, int l, int r, int tl, int tr){
    if (l > r)
        return;
    if (tl == l && tr == r){
        ans = max(ans, tree[v]);
        return;
    }
    int tm = (tl + tr) >> 1;
    get(v * 2, l, min(r, tm), tl, tm);
    get(v * 2 + 1, max(l, tm + 1), r, tm + 1, tr);
    return;
}
vector <int> g1[N], g2[N];
int comp[N];
int p[N];
int ind = 0;
void dfs(int v){
    comp[v] = ind;
    p[ind] = v;
    for (const auto& i: g1[v]){
        if (comp[i])
            continue;
        dfs(i);
    }
    return;
}
void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    for (int i = 0; i < m1; i++){
        int u, v; cin >> u >> v; u--; v--;
        g1[u].push_back(v);
        g1[v].push_back(u);
    }
    for (int i = 0; i < m2; i++){
        int u, v; cin >> u >> v; u--; v--;
        g2[u].push_back(v);
        g2[v].push_back(u);
    }
    for (int i = 0; i < n; i++){
        if (comp[i])
            continue;
        ind++;
        dfs(i);
    }
    if (ind - 1 > n || m1 == 1 && ind == 2 || m1 == 3 && ind == 3)
        cout << "NO\n";
    else {
        cout << "YES\n";
        cout << ind - 1 << "\n";
        for (int i = 2; i <= ind; i++){
            cout << p[i] + 1 << " " << p[i - 1] + 1 << "\n";
        }
    }
    for (int i = 0; i < n; i++){
        comp[i] = 0;
        p[i] = 0;
        g1[i].clear();
        g2[i].clear();
    }
    ind = 0;
    return;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t, g; cin >> t >> g;
    while (t--)
        solve();
    return 0;
}
