#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#pragma pack(push, 1)

using namespace std;
//using namespace __gnu_pbds;

//using ordered_multiset = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using lll = __int128;
using lld = __float128;

mt19937_64 gen(time(nullptr));

void dfs(int v, vector<bool> &used, vector<vector<int>> &g) {
    used[v] = true;
    for (int u : g[v]) {
        if (!used[u]) {
            dfs(u, used, g);
        }
    }
}

bool check(int n, set<pair<int, int>> &se) {
    vector<bool> used(n, false);
    vector<vector<int>> g(n);
    for (auto [v, u] : se) {
        g[v].push_back(u), g[u].push_back(v);
    }
    dfs(0, used, g);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            return false;
        }
    }
    return true;
}

signed main() {
#ifdef LOCAL
    freopen("text.in", "r", stdin), freopen("text.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t, group;
    cin >> t >> group;
    while (t--) {
        int n, m1, m2, i, v, u, j;
        cin >> n >> m1 >> m2;
        set<pair<int, int>> se_1, se_2;
        for (i = 0; i < m1; i++) {
            cin >> v >> u;
            if (v > u) {
                swap(v, u);
            }
            se_1.insert({v - 1, u - 1});
        }
        for (i = 0; i < m2; i++) {
            cin >> v >> u;
            if (v > u) {
                swap(v, u);
            }
            se_2.insert({v - 1, u - 1});
        }
        map<pair<int, int>, int> ma;
        for (i = 0; i < n; i++) {
            for (j = i + 1; j < n; j++) {
                ma[{i, j}] = ma.size();
            }
        }
        bool flag = false;
        for (int mask = 0; mask < (1 << (n * (n - 1) / 2)) && !flag; mask++) {
            set<pair<int, int>> one = se_1, two = se_2;
            vector<pair<int, int>> ans;
            if (__builtin_popcount(mask) > n) {
                continue;
            }
            for (i = 0; i < n; i++) {
                for (j = i + 1; j < n; j++) {
                    int now = ma[{i, j}];
                    if (!((mask >> now) & 1)) {
                        continue;
                    }
                    ans.push_back({i + 1, j + 1});
                    if (one.count({i, j})) {
                        one.erase({i, j});
                    } else {
                        one.insert({i, j});
                    }
                    if (two.count({i, j})) {
                        two.erase({i, j});
                    } else {
                        two.insert({i, j});
                    }
                }
            }
            if (check(n, one) && check(n, two)) {
                flag = true;
                cout << "Yes\n" << ans.size() << '\n';
                for (i = 0; i < ans.size(); i++) {
                    cout << ans[i].first << ' ' << ans[i].second << '\n';
                }
            }
        }
        if (!flag) {
            cout << "No\n";
        }
    }
}