#include <bits/stdc++.h>
using namespace std;
#define int long long
#define pii pair<int,int>
#define f first
#define s second
#define sort stable_sort
#define mp make_pair
#define pb push_back
const int maxn = 200001;
struct fenwick {
    int n;
    vector<int> t;

    void init() {
        t.resize(n + 1, 0);
    }

    void upd(int i, int x) {
        while (i <= n) {
            t[i] += x;
            i = i | (i + 1);
        }
    }

    int get(int i) {
        int ans = 0;
        while (i >= 0) {
            ans += t[i];
            i = (i & (i + 1)) - 1;
        }
        return ans;
    }
};
struct segtree {
    int size;
    vector<int> t;
    void init(){
        t.resize(size,0);
    }
    void upd(int i, int x, int tl=0, int tr = 131072, int n=0){
        if(tr-tl==1){
            t[n] = x;
            return;
        }
        if(i < (tl+tr)/2) upd(i,x,tl,(tl+tr)/2,2*n+1);
        else upd(i,x,(tl+tr)/2,tr,2*n+2);
        t[n] = t[2*n+1] + t[2*n+2];
    }
    int get(int l, int r, int tl=0, int tr=131072, int n=0){
        if(l>=tr || tl >= r) return 0;
        if(tl>=l && tr <= r) return t[n];
        return get(l,r,tl,(tl+tr)/2,2*n+1) + get(l,r,(tl+tr)/2,tr,2*n+2);
    }
};
int n;
bool f;
void out_ans(vector<pii>& ans){
    cout << ans.size() << '\n';
    for(pii p: ans){
        cout << p.f+1 << ' ' << p.s+1 << '\n';
    }
}
int dfs(int v, int pr, vector<bool>& used, vector<set<int>>& b, vector<set<int>>& ch){
    used[v] = true;
    int tmp = 1;
    if(f) return 0;
    for(int g: ch[v]){
        if(used[g]) continue;
       tmp += dfs(g,v,used,b,ch);
    }
    if(f) return 0;
    if(tmp == 1){
        vector<pii> ans;
        bool check = false;
        for(int i = 0; i < n; ++i){
            if(i != v && ((b[v].find(i) != b[v].end() && ch[v].find(i) != ch[v].end()) || (b[v].find(i) == b[v].end() && ch[v].find(i) == ch[v].end()))){
                check = true;
                break;
            }
        }
        if(check){
            for(int i = 0; i < n; ++i){
                if(i!=v && b[v].find(i) == b[v].end()){
                    ans.pb({i,v});
                }
            }
            out_ans(ans);
            f = true;
            return 0;
        }
        for(int i = 0; i < n; ++i){
            if(i==v || i == pr) continue;
            if(b[v].find(i) == b[v].end()){
                ans.pb({v,i});
                b[v].insert(i);
                if(ch[v].find(i) == ch[v].end()) ch[v].insert(i);
                else ch[v].erase(i);
            }
        }
        if(b[pr].size() > 0){
            out_ans(ans);
            f = true;
            return 0;
        }

    }
}
void solve(int g){
    f = false;
    cin >> n;
    int m1, m2;
    cin >> m1 >> m2;
    vector<set<int>> b(n);
    vector<set<int>> ch(n);
    for(int i= 0; i < m1; ++i){
        int u,v;
        cin >> u >> v;
        u--;v--;
        b[u].insert(v);
        b[v].insert(u);
    }
    for(int i = 0; i < m2; ++i){
        int u,v;
        cin >> u >>v;
        u--;v--;
        ch[u].insert(v);
        ch[v].insert(u);
    }
    vector<bool> used(n,false);

    if(!f) cout << "No\n";
}
signed main() {
#ifdef LOCAL

#else

#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int t,g;
    cin >> t >> g;
    while(t--){
        solve(g);
    }
}
