#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 10;

bool isPoss = true;
vector<pair<int, int>> res;

void change(int u, int v) {
    res.push_back({u, v});
}

int n;
vector<int> g[N];

set<pair<int, int>> e1;
set<pair<int, int>> e2;

void solve1(int u, int v) {
    if (!e1.count({u, v})) {
        change(u, v);
        e1.insert({u, v});
        e2.insert({u, v});
    }
    for (int i = 1; i <= n; i++) {
        if (i == u || i == v) continue;
        if (e1.count({i, u}) || e1.count({i, v})) continue;
        if (!e2.count({i, u})) {
            change(i, u);
            continue;
        }
        if (!e2.count({i, v})) {
            change(i, v);
            continue;
        }
        change(i, u);
    }
}

void test_case() {
    cin >> n;
    int m1, m2;
    cin >> m1 >> m2;
    for (int i = 0; i < m1; i++) {
        int u, v;
        cin >> u >> v;
        if (u == v) continue;
        e1.insert({u, v});
        e1.insert({v, u});
    }
    for (int i = 0; i < m2; i++) {
        int u, v;
        cin >> u >> v;
        if (u == v) continue;
        g[u].push_back(v);
        g[v].push_back(u);
        e2.insert({u, v});
        e2.insert({v, u});
    }
    // cout << "Here\n";
    // find an edge that both graphs contains
    for (auto c : e1) {
        if (e2.count(c)) {
            solve1(c.first, c.second);
            return;
        }
    }

    // find an edge that none of graphs contains
    int u = 1, v = 2;
    while (e1.count({u, v}) || e2.count({u, v})) {
        if (v < n) v++;
        else {
            u++;
            v = u + 1;
        }
    }
    if (u <= n) {
        solve1(u, v);
        return;
    }
    isPoss = false;
}   

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t, type;
    cin >> t >> type;
    while (t--) {
        test_case();
        if (!isPoss) cout << "No\n";
        else {
            cout << "Yes\n";
            cout << (int)res.size() << '\n';
            for (auto [x, y] : res) {
                cout << x << ' ' << y << '\n';
            }
        }
        res.clear();
        isPoss = true;
        cout << '\n';
    }
}