#include <bits/stdc++.h>

using namespace std;
#define int long long
int gr;

struct Fast {
    vector<set<int>> g1, g2;
    vector<int> p, sz;
    vector<vector<int>> t;
    set<int> roots;

    int find(int x) {
        if (p[x] == x) return x;
        return find(p[x]);
    }

    void add(int u, int v) {
        u = find(u);
        v = find(v);
        if (u == v) return;
        if (sz[u] > sz[v]) swap(u, v);
        p[u] = v;
        sz[v] += sz[u];
        for (auto x: t[u]) t[v].push_back(x);
        t[u].clear();
        roots.erase(u);
    }

    void solve() {
        int n, m1, m2;
        cin >> n >> m1 >> m2;
        g1.resize(n);
        g2.resize(n);
        set<pair<int, int>> e1, e2;
        for (int i = 0; i < m1; i++) {
            int x, y;
            cin >> x >> y;
            x--;
            y--;
            g1[x].insert(y);
            g1[y].insert(x);
            e1.insert({x, y});
            e1.insert({y, x});
        }
        for (int i = 0; i < m2; i++) {
            int x, y;
            cin >> x >> y;
            x--;
            y--;
            g2[x].insert(y);
            g2[y].insert(x);
            e2.insert({x, y});
            e2.insert({y, x});
        }
        for (auto x: e1) {
            if (e2.find(x) != e2.end()) {
                vector<pair<int, int>> ans;
                for (int v = 0; v < n; v++) {
                    if (v == x.first || v == x.second || g1[x.first].find(v) != g1[x.first].end() ||
                        g1[x.second].find(v) != g1[x.second].end())
                        continue;
                    if (e2.find({v, x.first}) == e2.end()) {
                        ans.push_back({v, x.first});
                    } else ans.push_back({v, x.second});
                }
                cout << "Yes\n";
                cout << ans.size() << '\n';
                for (auto [i, j]: ans) cout << i + 1 << ' ' << j + 1 << '\n';
                return;
            }
        }
        for (int i1 = 0; i1 < n; i1++) {
            for (int j1 = i1 + 1; j1 < n; j1++) {
                if (e1.find({i1, j1}) == e1.end() && e2.find({i1, j1}) == e2.end()) {
                    vector<pair<int, int>> ans;
                    pair<int, int> x = {i1, j1};
                    ans.push_back(x);
                    for (int v = 0; v < n; v++) {
                        if (v == x.first || v == x.second || g1[x.first].find(v) != g1[x.first].end() ||
                            g1[x.second].find(v) != g1[x.second].end())
                            continue;
                        if (e2.find({v, x.first}) == e2.end()) {
                            ans.push_back({v, x.first});
                        } else ans.push_back({v, x.second});
                    }
                    cout << "Yes\n";
                    cout << ans.size() << '\n';
                    for (auto [i, j]: ans) cout << i + 1 << ' ' << j + 1 << '\n';
                    return;
                }
            }
        }
        if (gr == 9) {
            cout << "No\n";
            return;
        }
        p.resize(n);
        sz.resize(n, 1);
        iota(p.begin(), p.end(), 0);
        t.resize(n);
        for (int i = 0; i < n; i++) t[i].push_back(i);
        for (int i = 0; i < n; i++) roots.insert(i);
        for (auto [x, y]: e1) add(x, y);
        vector<pair<int, int>> ans;
        while (roots.size() > 1) {
            int u = *roots.begin();
            int v = *(++roots.begin());
            add(u, v);
            if (e2.find({t[u][0], t[v][0]}) == e2.end()) {
                ans.emplace_back(t[u][0], t[v][0]);
            } else if (e2.find({t[u][0], t[v][1]}) == e2.end()) {
                ans.emplace_back(t[u][0], t[v][1]);
            } else if (e2.find({t[u][1], t[v][0]}) == e2.end()) {
                ans.emplace_back(t[u][1], t[v][0]);
            } else {
                ans.emplace_back(t[u][1], t[v][1]);
            }
        }
        cout << "Yes\n";
        cout << ans.size() << '\n';
        for (auto [i, j]: ans) cout << i + 1 << ' ' << j + 1 << '\n';
    }
};

signed main() {
    int __ = 1;
    cin >> __ >> gr;
    while (__--) {
        auto s1 = Fast();
        s1.solve();
    }
    return 0;
}
