#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> matrix;
vector<int> used;
int timer = 1;
int max_v;
int dfs(int v, int mask) {
	int cnt = 1;
	used[v] = timer;
	for (int u = 0; u < max_v; u++) {
		if (matrix[v][u] & mask) {
			if (used[u] < timer) cnt += dfs(u, mask);
		}
	}
	return cnt;
}

vector<pair<int, int>> answer;

bool gen(int v, int u, int remaining) {
	if (u == v) {
		return gen(v+1, 0, remaining);
	}
	if (v == max_v) {
		int cnt1 = dfs(0, 1);
		timer++;
		int cnt2 = dfs(0, 2);
		timer++;
		if (cnt1 == max_v && cnt2 == max_v) return true;
		return false;
	}
	if (gen(v, u+1, remaining)) return true;
	if (remaining == 0) return false;
	answer.emplace_back(v, u);
	matrix[v][u] = ~matrix[v][u] & 3;
	matrix[u][v] = ~matrix[u][v] & 3;
	if (gen(v, u+1, remaining - 1)) return true;
	answer.pop_back();
	matrix[v][u] = ~matrix[v][u] & 3;
	matrix[u][v] = ~matrix[u][v] & 3;
	return false;
} 

int main() {
	int t, g;
	cin >> t >> g;
	while (t--) {
		int n, m1, m2;
		cin >> n >> m1 >> m2;
		used.resize(n, 0);
		matrix.resize(n, vector<int>(n, 0));
		for (int i = 0; i < m1; i++) {
			int u, v;
			cin >> u >> v;
			u--, v--;
			matrix[u][v] |= 1;
			matrix[v][u] |= 1;
		}
		for (int i = 0; i < m2; i++) {
			int u, v;
			cin >> u >> v;
			u--, v--;
			matrix[u][v] |= 2;
			matrix[v][u] |= 2;
		}
		max_v = n;
		if (gen(0, 0, n)) {
			cout << "Yes\n";
			cout << answer.size() << "\n";
			for (auto [u, v]: answer) {
				cout << u + 1 << " " << v+1 << "\n";
			}
		}
		else {
			cout << "No\n";
		}
		answer.clear();
		matrix.clear();
		used.clear();
	}
}