#include <bits/stdc++.h>
#define pb push_back
#define fi first
#define se second
#define maxn 300050

using namespace std;

int tc, stt, n, m1, m2, x, y, ukdubina;
bool imaresenja=true;
vector<int> g1[maxn];
vector<int> g2[maxn];
vector<int> st[maxn];
int p[maxn];
bool bio[maxn];
int d[maxn];
int deg[maxn];
vector<pair<int,int>> res;
vector<pair<int,int>> ulaz;
int zamenjensa=1;
vector<int> v[maxn];

void dfs(int i)
{
    bio[i]=true;
    //cout << i << "... ";
    for(auto u:g2[i]){
        if(!bio[u]){
            st[i].pb(u);
            st[u].pb(i);
            p[u]=i;
            d[u]=d[i]+1;
            ukdubina=max(ukdubina,d[u]);
            dfs(u);
        }
    }
}

void dfs1(int i)
{
    bio[i]=true;
   // cout << i << "..... ";
    for(auto u:st[i]){
        if(!bio[u]){
            p[u]=i;
            d[u]=d[i]+1;
            ukdubina=max(ukdubina,d[u]);
            dfs1(u);
        }
    }
}

void zameni(int k)
{
    zamenjensa=k;
    //cout << k << "!!!\n";
    for(int i=0; i<=n; i++){
        g2[i].clear();
        p[i]=0;
        d[i]=0;
        deg[i]=0;
        bio[i]=false;
    }
    swap(st[1],st[k]);
    for(int i=1; i<=n; i++){
        for(int j=0; j<st[i].size(); j++){
            if(st[i][j]==1) st[i][j]=k;
            else if(st[i][j]==k) st[i][j]=1;
        }
    }
    for(int i=0; i<m2; i++){
        if(ulaz[i].fi==1) ulaz[i].fi=k;
        else if(ulaz[i].fi==k) ulaz[i].fi=1;
        if(ulaz[i].se==1) ulaz[i].se=k;
        else if(ulaz[i].se==k) ulaz[i].se=1;
        g2[ulaz[i].fi].pb(ulaz[i].se);
        g2[ulaz[i].se].pb(ulaz[i].fi);
        deg[ulaz[i].fi]++;
        deg[ulaz[i].se]++;
    }
    d[1]=0;
    ukdubina=0;
    dfs1(1);
}

int main()
{

    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> tc >> stt;
    while(tc--){

        imaresenja=true;
        res.clear();
        ulaz.clear();
        zamenjensa=1;
        for(int i=0; i<=n; i++){
            g1[i].clear();
            g2[i].clear();
            st[i].clear();
            v[i].clear();
            p[i]=0;
            bio[i]=false;
            d[i]=0;
            deg[i]=0;
        }


        cin >> n >> m1 >>m2;
        for(int i=0; i<m1; i++){
            cin >> x >> y;
            g1[x].pb(y);
            g1[y].pb(x);
        }
        for(int i=0; i<m2; i++){
            cin >> x >> y;
            ulaz.pb({x,y});
            g2[x].pb(y);
            g2[y].pb(x);
            deg[x]++;
            deg[y]++;
        }
        d[1]=0;
        ukdubina=0;
        dfs(1);



        if(ukdubina==2){
            bool bilazamena=false;
            for(auto u:st[1]){
                if(st[u].size()==1){
                    bilazamena=true;
                    zameni(u);
                }
            }
            if(!bilazamena) zameni(st[1][0]);
        }



        if(ukdubina==1){
            for(int i=2; i<n; i++){
                res.pb({i,i+1});
                bool imagrana=false;
                for(auto u:g2[i]){
                    if(u==i+1){
                        imagrana=true;
                        break;
                    }
                }
                if(imagrana){
                    deg[i]--;
                    deg[i+1]--;
                }
                else{
                    deg[i]++;
                    deg[i+1]++;
                }
            }
            bool imadegveciod1=false;
            for(int i=2; i<=n; i++){
                if(deg[i]>1){
                    res.pb({i,1});
                    imadegveciod1=true;
                    break;
                }
            }
            if(!imadegveciod1){

                if(n>=4){
                    res.pop_back();
                    res.pb({2,n});
                    res.pb({1,2});
                }
                else{
                    if(m1==0) imaresenja=false;
                    else{
                        res.clear();
                        if(m1==1){
                            if(g1[1].size()>0) res.pb({2,3});
                            else if(g1[2].size()>0) res.pb({1,3});
                            else res.pb({1,2});
                        }
                    }
                }
            }
        }

        if(ukdubina>=3){
            //for(int i=1; i<=n; i++) cout << d[i] << "\n";
            for(int i=1; i<=n; i++){
                v[d[i]].pb(i);
            }
            for(int i=0; i<=ukdubina; i++){
                for(int j=0; j<v[i].size()-1; j++){
                    res.pb({v[i][j],v[i][j+1]});
                }
            }
            for(int i=0; i+2<=ukdubina; i++){
                res.pb({v[i][0],v[i+2][0]});
            }
            if(ukdubina%2==0) res.pb({v[ukdubina][0],v[1][0]});
            else res.pb({v[ukdubina][0],v[0][0]});
        }

        for(int i=0; i<res.size(); i++){
            if(res[i].fi==1) res[i].fi=zamenjensa;
            else if(res[i].fi==zamenjensa) res[i].fi=1;
            if(res[i].se==zamenjensa) res[i].se=1;
            else if(res[i].se==1) res[i].se=zamenjensa;
        }

        if(imaresenja){
            cout << "Yes\n" << res.size() << "\n";
            for(auto u:res){
                cout << u.fi << " " << u.se << "\n";
            }
            cout << "\n";
        }
        else cout << "No\n";
    }
}
