#include<bits/stdc++.h>
using namespace std;
#define pb push_back
#define fi first
#define mp make_pair
#define se second
typedef long long ll;
const int N = 3e5 + 5;
int n, m1, m2;
vector<int> adj1[N], A[N];
vector<pair<int, int> > ans;
set<pair<int, int> > E1, E2;
bool vis[N];
int rt;

void dfs(int v) {
	A[rt].pb(v);
	vis[v] = true;
	for (auto u : adj1[v]) {
		if (!vis[u])
			dfs(u);
	}
}

void F(set<pair<int, int> >& st, int v, int u) {
	if (st.count(mp(v, u))) {
		st.erase(mp(v, u));
		st.erase(mp(u, v));
	}
	else {
		st.insert(mp(v, u));
		st.insert(mp(u, v));
	}
}

void xr(int v, int u) {
	ans.pb(mp(v, u));
	F(E1, v, u);
	F(E2, v, u);
}

void solve() {
	cin >> n >> m1 >> m2;
	for (int i = 1; i <= n; i++) {
		adj1[i].clear();
		A[i].clear();
		vis[i] = false;
	}
	E1.clear();
	E2.clear();
	ans.clear();
	for (int i = 0; i < m1; i++) {
		int v, u; cin >> v >> u;
		adj1[v].pb(u);
		adj1[u].pb(v);
		E1.insert(mp(v, u));
		E1.insert(mp(u, v));
	}
	for (int i = 0; i < m2; i++) {
		int v, u; cin >> v >> u;
		E2.insert(mp(v, u));
		E2.insert(mp(u, v));
	}
	int a = -1, b = -1;
	for (int v = 1; v <= n && a == -1; v++) {
		for (int u = 1; u <= n; u++) {
			if (v == u) continue;
			bool x = E1.count(mp(v, u));
			bool y = E2.count(mp(v, u));
			if (x == y) {
				if (!x) {
					xr(v, u);
				}
				a = v, b = u;
				break;
			}
		}
	}
	if (a != -1) {
		for (int i = 1; i <= n; i++) {
			if (i == a || i == b) continue;
			if (E1.count(mp(i, a)) || E1.count(mp(i, b))) continue;
			if (!E2.count(mp(i, a))) {
				xr(i, a);
			}
			else if (!E2.count(mp(i, b))) {
				xr(i, b);
			}
			else {
				xr(i, a);
			}
		}
		cout << "Yes" << '\n';
		cout << (int)ans.size() << endl;
		for (auto e : ans)
			cout << e.fi << ' ' << e.se << '\n';
		return;
	}
	// mokamel
	if (n == 3) {
		cout << "No" << endl;
		return;
	}
	vector<int> vec;
	for (int i = 1; i <= n; i++) {
		if (!vis[i]) {
			rt = i;
			dfs(i);
			vec.pb(i);
		}
	}
	if ((int)vec.size() == 1) {
		cout << "Yes" << '\n';
		cout << 0 << endl;
		return;
	}

	a = vec.front(), b = vec.back();
	for (int i = 1; i < (int)vec.size() - 1; i++) {
		xr(vec.front(), vec[i]);
		for (auto x : A[vec[i]])
			A[a].pb(x);
	}

	if ((int)A[a].size() >= 2 && (int)A[b].size() >= 2) {
		xr(a, b);
	}
	else {
		if ((int)A[b].size() == 1)
			swap(a, b);
		int x = -1, y = -1;
		for (auto v : A[b]) {
			if (x != -1) break;
			for (auto u : A[b]) {
				if (v != u && E2.count(mp(v, u))) {
					x = v, y = u;
					break;
				}
			}
		}
		if (x == -1) {
			x = A[b].front();
			y = A[b].back();
			xr(x, y);
		}
		xr(a, x);
	}
	cout << "Yes" << endl;
	cout << (int)ans.size() << endl;
	for (auto e : ans)
		cout << e.fi << ' ' << e.se << '\n';
}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int tc = 1; cin >> tc;
	int g; cin >> g;
	while (tc--) {
		solve();
	}
	return 0;
}
