// safonov_ok.cpp
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)

const ll INF = 1e18;

void solve() {
    int n;
    cin >> n;
    vector<ll> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 1; i < n; i++) {
        d[i] += d[i - 1];
    }
    vector<ll> l(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i];
        l[i] -= d[i];
    }
    vector<ll> r(n);
    for (int i = 0; i < n; i++) {
        cin >> r[i];
        r[i] -= d[i];
    }
    ll a0, b0;
    cin >> a0 >> b0;
    vector<pair<ll, ll>> tot;
    for (int i = 0; i < n; i++) {
        tot.emplace_back(l[i], r[i]);
    }
    sort(tot.begin(), tot.end());

    ll pm = INF;
    ll ans = -INF;
    tot.emplace_back(INF, INF);
    for (int i = 0; i <= n; i++) {
        ans = max(ans, min(a0, tot[i].first) + min(b0, pm));
        pm = min(pm, tot[i].second);
    }

    cout << ans + 2 * d.back() << "\n";
}

int main() {
#ifdef ONPC
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
