#include<iostream>
#include <random>
#include<vector>
#include<set>
#include<map>
#include<cassert>
#include<unordered_map>
#include<algorithm>
#include<iomanip>
#include<numeric>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define girlfriend friend

template<typename T>
bool assign_min(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream& out, std::pair<T, F> a) {
    return out << a.first << " " << a.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, b1 = 31, b2 = 29, MAXN = 1e5;
const long double eps = 1e-9;

void solve() {
    int n; cin >> n;
    vector<int> d(n), l(n), r(n);
    input(d); input(l); input(r);
    int a0, b0; cin >> a0 >> b0;
    vector<pair<int, int>> srt(n);
    for (int i = 0; i<n; ++i) srt[i] = {r[i], i};
    sort(rall(srt));
    multiset<int> m;
    m.insert(a0);
    for (auto elem : l) m.insert(elem);
    int res = b0 + *m.begin();
    for (auto [val, ind] : srt) {
        m.erase(m.find(l[ind]));
        assign_max(res, val + *m.begin());
    }
    cout << res << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}

//fft