#include <iostream>
#include <cstdint>
#include <vector>

using namespace std;

void sol() {
    int64_t n;
    cin >> n;
    vector<int64_t> d(n), l(n), r(n);
    for (auto &v: d) cin >> v;
    for (auto &v: l) cin >> v;
    for (auto &v: r) cin >> v;
    int64_t a0, b0;
    cin >> a0 >> b0;
    int64_t ai = a0, bi = b0;
    for (int32_t i = 1; i <= n; ++i) {
        ai += d[i - 1], bi += d[i - 1];
        if (ai - l[i - 1] < bi - r[i - 1]) ai = min(ai, l[i - 1]);
        else bi = min(bi, r[i - 1]);
    }
    cout << ai + bi;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    uint32_t t = 1;
#else
    uint32_t t = 1;
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    while (t--) {
        sol();
        cout << "\n";
    }
    return 0;
}
