#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n; cin >> n;
    vector<int> d(n + 1, 0);
    vector<int> l(n + 1, 0);
    vector<int> r(n + 1, 0);
    int a0, b0;
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> r[i];
    }
    cin >> a0 >> b0;
    vector<pair<int, int>> dp1(n + 1);
    vector<pair<int, int>> dp2(n + 1);
    dp1[0] = {a0, b0};
    dp2[0] = {a0, b0};
    for (int i = 1; i <= n; i++) {
        int a1 = dp1[i - 1].first, b1 = dp1[i - 1].second;
        int a2 = dp2[i - 1].first, b2 = dp2[i - 1].second;
        a1 += d[i];
        a2 += d[i];
        b1 += d[i];
        b2 += d[i];
        a1 = min(a1, l[i]);
        a2 = min(a1, l[i]);
        if (a1 + b1 > a2 + b2) {
            dp1[i] = {a1, b1};
        } else {
            dp1[i] = {a2, b2};
        }
        a1 = dp1[i - 1].first, b1 = dp1[i - 1].second;
        a2 = dp2[i - 1].first, b2 = dp2[i - 1].second;
        a1 += d[i];
        a2 += d[i];
        b1 += d[i];
        b2 += d[i];
        b1 = min(b1, r[i]);
        b2 = min(b2, r[i]);
        if (a1 + b1 > a2 + b2) {
            dp2[i] = {a1, b1};
        } else {
            dp2[i] = {a2, b2};
        }
    }
    cout << max(dp1[n].first + dp1[n].second, dp2[n].first + dp2[n].second);
    /*
    cout << "dp1" << '\n';
    for (int i = 0; i <= n; i++) {
        cout << i << " " << dp1[i].first << " " << dp1[i].second << '\n';
    }
    cout << "dp2" << '\n';
    for (int i = 0; i <= n; i++) {
        cout << i << " " << dp2[i].first << " " << dp2[i].second << '\n';
    }
    */

}
