#include <bits/stdc++.h>

using namespace std;
typedef long long ll;


int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n;
    cin >> n;
    vector<ll> d(n);
    for (ll i = 0; i < n; ++i) {
        cin >> d[i];
    }
    vector<ll> a(n), b(n);
    vector<pair<ll, ll>> ab(n), ba(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> b[i];
        ab[i] = {a[i], b[i]};
        ba[i] = {b[i], a[i]};
    }
    ll A, B;
    cin >> A >> B;
    if (accumulate(d.begin(), d.end(), 0) == 0) {
        std::sort(ab.begin(), ab.end());
        std::sort(ba.begin(), ba.end());
        ll ans = max(min(ab[0].first, A) + B, A + min(ba[0].first, B));
        ll minb = 1e9;
        for (ll i = 0; i < n - 1; ++i) {
            minb = min(minb, ab[i].second);
            ans = max(ans, min(minb, B) + min(A, ab[i + 1].first));
        }
        ll mina = 1e9;
        for (ll i = 0; i < n - 1; ++i) {
            mina = min(mina, ba[i].second);
            ans = max(ans, min(mina, A) + min(B, ba[i + 1].first));
        }
        cout << ans;
        return 0;
    }
    ll ans = 0;
    for (ll k = 0; k < (1 << n); ++k) {
        ll acur = A, bcur = B;
        for (ll i = 0; i < n; ++i) {
            acur += d[i];
            bcur += d[i];
            if (k & (1 << i)) {
                acur = min(acur, a[i]);
            } else {
                bcur = min(bcur, b[i]);
            }
        }
        ans = max(ans, acur + bcur);
    }
    cout << ans;

    return 0;
}
