#pragma GCC optimize("O3,Ofast,inline,unroll-loops")

#include<bits/stdc++.h>
#define ft first
#define sc second
#define all(x) x.begin(),x.end()
using ll = long long;
using ld = long double;
using ul = unsigned long long;
using li = __int128;
using ui = unsigned;
using namespace std;
const ll inf = 1e18, mod = 1e9+7;
struct node{
    array<ll, 3> val;
    int y, sz = 1;
    node *l = nullptr, *r = nullptr;
    node(int y_) {y = y_;}
};
void recalc(node *r) {
    r->sz = 1 + (r->l ? r->l->sz : 0) + (r->r ? r->r->sz : 0);
}
node* merge(node *l, node *r) {
    if (!l) return r;
    if (!r) return l;
    if (l->y < r->y) {
        r->l = merge(l, r->l);
        recalc(r);
        return r;
    } else {
        l->r = merge(l->r, r);
        recalc(l);
        return l;
    }
}
pair<node*, node*> split1(node *r, ll x) {
    if (!r) return {r, r};
    if (r->val[1] > x) {
        auto [a, b] = split1(r->l, x);
        r->l = b;
        recalc(r);
        return {a, r};
    } else {
        auto [a, b] = split1(r->r, x);
        r->r = a;
        recalc(r);
        return {r, b};
    }
}
pair<node*, node*> split2(node *r, ll y) {
    if (!r) return {r, r};
    if (r->val[2] < y) {
        auto [a, b] = split2(r->l, y);
        r->l = b;
        recalc(r);
        return {a, r};
    } else {
        auto [a, b] = split2(r->r, y);
        r->r = a;
        recalc(r);
        return {r, b};
    }
}
int len(node *r) {
    return (r ? r->sz : 0);
}
pair<node*, node*> split3(node *r, ll y) {
    if (!r) return {r, r};
    if (len(r->l) >= y) {
        auto [a, b] = split3(r->l, y);
        r->l = b;
        recalc(r);
        return {a, r};
    } else {
        auto [a, b] = split3(r->r, y-len(r->l)-1);
        r->r = a;
        recalc(r);
        return {r, b};
    }
}
ll lft(node *r) {
    return (r->l ? lft(r->l) : r->val[0]);
}
ll rght(node *r) {
    return (r->r ? rght(r->r) : r->val[1]);
}
ll ans(node *r) {
    if (!r) return -1e18;
    return max({r->val[1]+r->val[2], ans(r->l), ans(r->r)});
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());
    //mt19937 rnd(53995);
    ll n, a0, b0;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (int i = 0; i < n; i++) cin >> d[i];
    for (int i = 0; i < n; i++) cin >> l[i];
    for (int i = 0; i < n; i++) cin >> r[i];
    cin >> a0 >> b0;
    set<pair<ll, ll>> sl, sr;
    for (int i = 0; i < n; i++) {
        sl.insert({l[i], i});
        sr.insert({r[i], i});
    }
    ll ans = a0 + min(b0, sr.begin()->ft);
    while (sl.size() != 0) {
        auto [li, i] = *--sl.end();
        sl.erase(--sl.end());
        a0 = min(a0, li);
        sr.erase({r[i], i});
        ans = max(ans, a0 + min(b0, (sr.size() ? sr.begin()->ft : inf)));
    }
    cout << ans;
}
