#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ordered_set = tree<ll, less<>, null_type, tree_tag, tree_order_statistics_node_update>;
#define all(a) a.begin(), a.end()

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    // cin >> t;
    while (t--)
        solve();
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> l(n), r(n), d(n);
    for (ll &i: d)
        cin >> i;
    for (ll &i: l)
        cin >> i;
    for (ll &i: r)
        cin >> i;
    vector<ll> dp(n + 1, -1e18), dp1(n + 1, -1e18);
    ll a, b;
    cin >> a >> b;
    dp[0] = b;
    dp1[0] = a;
    reverse(all(l));
    reverse(all(r));
    l.push_back(a);
    r.push_back(b);
    reverse(all(l));
    reverse(all(r));
    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        ll s = d[i];
        ll j = i + 1;
        while (j <= n && (s + r[i] <= r[j] || s + dp1[i] <= l[j])) {
            if (j < n)
                s += d[j];
            j++;
        }
        if (dp1[i] > 0) {
            if (j <= n) {
                dp1[j] = max(dp1[j], s + dp1[i]);
                dp[j] = max(dp[j], s + r[i]);
            } else
                ans = max(ans, r[i] + dp1[i] + s * 2);
        }
        s = d[i];
        j = i + 1;
        while (j <= n && (s + l[i] <= l[j] || s + dp[i] <= r[j])) {
            if (j < n)
                s += d[j];
            j++;
        }
        if (dp[i] > 0) {
            if (j <= n) {
                dp[j] = max(dp[j], s + dp[i]);
                dp1[j] = max(dp1[j], s + l[i]);
            } else
                ans = max(ans, l[i] + dp[i] + s * 2);
        }
    }
//    cout << ans << '\n';
//    for (ll i: dp)
//        cout << i << ' ';
//    cout << '\n';
//    for (ll i: dp1)
//        cout << i << ' ';
//    cout << '\n';
    ans = max(ans, dp[n] + l[n]);
    ans = max(ans, dp1[n] + r[n]);
    cout << ans << '\n';
}