//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include <iomanip>
#include <queue>
#include <deque>
using namespace std;
#define int long long

void dfs1(int v, int col, vector <unordered_set <int>>& gr, vector <int>& used) {
	used[v] = col;
	for (int u : gr[v]) {
		if (used[u] == 0) {
			dfs1(u, col, gr, used);
		}
	}
}


void dfs2(int v, vector <unordered_set <int>>& gr, vector <int>& used, vector <unordered_set<int>>& d) {
	used[v] = true;

	for (int u:gr[v]) {
		if (!used[u]) {
			d[v].insert(u);
			d[u].insert(v);

			dfs2(u, gr, used, d);
		}
	}
}

void writeans(vector <pair<int, int>>& ans) {
	cout << "Yes\n";
	cout << ans.size() << "\n";
	for (auto i : ans) {
		cout << i.first + 1 << " " << i.second + 1 << " ";
	}
	
}


void dfs3(int v, int p, vector <unordered_set <int>>& gr, vector <int>& used, vector <int>& col, vector <pair<int, int>>& dop) {

	used[v] = true;

	for (int u : gr[v]) {
		if (used[u]) {
			if (p!=u and col[v] != col[u]) {
				dop.push_back({ v, u });
			}
		}
		else {
			dfs3(u,v, gr, used, col, dop);
		}
	}
}

void solve() {
	int n;
	cin >> n;
	vector <int> d(n), l(n), r(n);
	for (int i = 0; i < n; ++i) {
		cin >> d[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> r[i];
	}


	vector <int> a(n + 1), b(n + 1);

	cin >> a[0] >> b[0];
	for (int i = 0; i < n; ++i) {
		a[i + 1] = a[i] + d[i];
		b[i + 1] = b[i] + d[i];

		int m1 = min(a[i + 1], l[i]);
		int m2 = min(b[i + 1], r[i]);
		if (m1 + b[i + 1] < m2 + a[i + 1]) {
			b[i + 1] = m2;
		}
		else {
			a[i + 1] = m1;
		}
	}

	cout << a[n] + b[n];
}


int32_t main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}
	return 0;
}

