#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxn = 2e5 + 10;
const int inf = 1e9 + 10;

struct Vect{
    ll x, y;
    Vect() {}
    Vect (ll x, ll y) : x(x), y(y) {}
};

istream& operator >> (istream& is, Vect& a) {
    is >> a.x >> a.y;
    return is;
}

Vect operator + (Vect a, Vect b) {
    return {a.x + b.x, a.y + b.y};
}

Vect operator - (Vect a, Vect b) {
    return {a.x - b.x, a.y - b.y};
}

ll operator % (Vect a, Vect b) {
    return a.x*b.x + a.y*b.y;
}

bool ok(Vect a, Vect b, Vect c) {
    return (c - b)%(a - b) > 0;
}

struct ev{
    int a, b, w;
    int ind;
};

bool operator < (ev a, ev b) {
    return a.ind < b.ind;
}

struct comb{
    int l, r;
    int a, b;
};

bool operator < (comb a, comb b) {
    if (a.a != b.a) {
        return a.a < b.a;
    }
    if (a.b != b.b) {
        return a.b < b.b;
    }
    if (a.l != b.l) {
        return a.l < b.l;
    }
    //if (a.r != b.r) {
        return a.r < b.r;
    //}
    //return a.last < b.last;
}

void solve() {
    int n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    vector<ll> pref(n + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> r[i];
    }
    ll a, b;
    cin >> a >> b;
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + d[i];
    }
    vector<int> amin;
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        amin.clear();
        amin.resize(n, 0);
        if (pref[i + 1] < l[i]) continue;
        ll x = l[i] + pref[n] - pref[i + 1];
        for (int j = n - 1; j >= 0; j--) {
            if (x <= l[j]) {
                amin[j] = 1;
            } else {
                //x = l[i];
            }
            x -= d[j];
        }
        ll y = b;
        for (int j = 0; j < n; j++) {
            y += d[j];
            if (!amin[j]) {
                y = min(y, r[j]);
            }
        }
        x = l[i] + pref[n] - pref[i + 1];
        //cout << x << " " << y << '\n';
        ans = max(ans, x + y);
    }
    cout << ans;
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
    return 0;
}
