#include <bits/stdc++.h>
using namespace std;

void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

using ll = long long;
int n;
ll a0, b0;
vector<ll> D(n), L(n), R(n);

ll solve(int mask) {
    ll A = a0, B = b0;
    for(int i = 0; i < n; ++i) {
        A += D[i];
        B += D[i];
        if(mask & (1 << i)) {
            B = min(B, R[i]);
        } else {
            A = min(A, L[i]);
        }
    }
    return A + B;
}

signed main() {
    init();
    cin >> n;
    D.resize(n);
    L.resize(n);
    R.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> D[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> L[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> R[i];
    }
    cin >> a0 >> b0;
    ll ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        ans = max(ans, solve(mask));
    }
    cout << ans << '\n';
}