#include <bits/stdc++.h>
using namespace std;

void init() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

using ll = long long;

int n;
vector<ll> D, L, R;
vector<ll> S;


ll solve(int mask) {
    ll mnL = L[0] + S[0], mnR = R[0] + S[0];
    for(int i = 0; i < n; ++i) {
        if(mask & (1 << i)) {
            mnR = min(mnR, R[i + 1] + S[i + 1]);
        } else {
            mnL = min(mnL, L[i + 1] + S[i + 1]);
        }
    }
    return mnL + mnR;
}

signed main() {
    init();
    cin >> n;
    D.resize(n); L.resize(n + 1), R.resize(n + 1), S.resize(n + 1);
    for(int i = 0; i < n; ++i) {
        cin >> D[i];
    }
    for(int i = 1; i <= n; ++i) {
        cin >> L[i];
    }
    for(int i = 1; i <= n; ++i) {
        cin >> R[i];
    }
    cin >> L[0] >> R[0];
    for(int i = n - 1; i >= 0; --i) {
        S[i] = S[i + 1] + D[i];
    }
    ll ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        ans = max(ans, solve(mask));
    }
    cout << ans << '\n';
}