#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>
#define int long long

using namespace std;


bool comp(vector<int> &a, vector<int> &b) {
    return a[0] + a[1] < b[0] + b[1] || a[0] + a[1] == b[0] + b[1] && a[2] < b[2];
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, a, b;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    cin >> a >> b;
    int cur = 0;
    for (int i = 0; i < n; ++i) {
        cur += d[i];
        l[i] -= cur;
        r[i] -= cur;
    }
    vector<bool> used(n, false);
    for (int q = 0; q < n; ++q) {
        int cur = -1;
        int res = 0;
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                if (cur == -1 || res < max(min(a, l[i]) + b, a + min(b, r[i]))) {
                    cur = i;
                    res = max(min(a, l[i]) + b, a + min(b, r[i]));
                }
            }
        }
        if (min(a, l[cur]) + b >= a + min(b, r[cur])) {
            a = min(a, l[cur]);
        } else {
            b = min(b, r[cur]);
        }
        used[cur] = true;
    }
    cout << a + b + 2 * cur << endl;
}
