#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;


void solve() {
    ll n; cin >> n;
    vector <ll> d(n + 1), l(n + 1), r(n + 1), a(n + 1), b(n + 1);
    for (ll i = 1; i <= n; i++)
        cin >> d[i];
    ll mnl = INF;
    for (ll i = 1; i <= n; i++)
        cin >> l[i], mnl = min(mnl, l[i]);
    ll mnr = INF;
    for (ll i = 1; i <= n; i++)
        cin >> r[i], mnr = min(mnr, r[i]);
    cin >> a[0] >> b[0];
    vector <vector <pair <ll, ll>>> dp(n + 1, vector <pair <ll, ll>> (n + 1, pair <ll, ll> ({-INF, -INF})));
    dp[1][0] = {min(a[0] + d[1], l[1]), b[0] + d[1]};
    dp[0][1] = {a[0] + d[1], min(b[0] + d[1], r[1])};
    for (ll i = 2; i <= n; i++) {
        for (ll j = 0; j < i; j++) {
            if (j == i - 1) {
                auto [x1, y1] = dp[i - 2][j];
                dp[i][j] = {min(l[i], x1 + d[i]), y1 + d[i]};
                auto [x2, y2] = dp[j][i - 2];
                dp[j][i] = {x2 + d[i], min(r[i], y2 + d[i])};
            } else {
                auto [x1, y1] = dp[i - 1][j];
                dp[i][j] = {min(x1 + d[i], l[i]), y1 + d[i]};
                auto [x2, y2] = dp[j][i - 1];
                dp[j][i] = {x2 + d[i], min(y2 + d[i], r[i])};
            }
        }
    }
    ll ans = -INF;
    for (ll i = 0; i < n; i++)
        ans = max({ans, dp[i][n].first + dp[i][n].second, dp[n][i].first + dp[n][i].second});
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
//    cin >> T;
//    cin >> G;
    while (T--) {
        solve();
    }
    return 0;
}
