//#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 2e18;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int &i: d)
        cin >> i;
    for (int &i: l)
        cin >> i;
    for (int &i: r)
        cin >> i;
    int a0, b0;
    cin >> a0 >> b0;
    if (accumulate(all(d), 0ll) == 0) {
        int res = -1;
        vector<pair<int, int>> li(n);
        for (int i = 0; i < n; ++i)
            li[i] = {l[i], i};
        sort(all(li));
        int mn = inf;
        res = max(res, min(li.front().first, a0) + b0);
        for (int i = 0; i < n; ++i) {
            mn = min(mn, r[li[i].second]);
            if (i != n - 1)
                res = max(res, min(li[i + 1].first, a0) + min(mn, b0));
            else
                res = max(res, a0 + min(mn, b0));
        }
        cout << res;
        return;
    }
    vector<pair<int, int>> ok = {{a0, b0}};
    for (int i = 0; i < n; ++i) {
        vector<pair<int, int>> now;
        for (auto j: ok) {
            now.push_back({min(l[i], j.first + d[i]), j.second + d[i]});
            now.push_back({j.first + d[i], min(r[i], j.second + d[i])});
        }
        ok.clear();
        sort(all(now), [](auto a, auto b) {
            if (a.first != b.first)
                return a.first > b.first;
            return a.second > b.second;
        });
        int maxy = -1;
        for (auto j: now)
            if (j.second > maxy) {
                maxy = j.second;
                ok.push_back(j);
            }
        ok.resize(unique(all(ok)) - ok.begin());
    }
    pair<int, int> sum = {0, 0};
    for (auto j: ok)
        if (j.first + j.second >= sum.first + sum.second)
            sum = j;
    cout << sum.first + sum.second;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
