#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
#define int long long

istream &operator>>(istream&in, pair<int, int>&p) {
    return in >> p.first >> p.second;
}

istream &operator>>(istream&in, vector<int> &p) {
    for (int &i : p) in >> i;
    return in;
}

ostream &operator<<(ostream &out, pair<int, int> p) {
    return out << p.first << ' ' << p.second;
}

ostream &operator<<(ostream &out, vector<int> p) {
    for (int i : p) out << i << ' ';
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    cin >> d >> l >> r;
    int a0, b0;
    cin >> a0 >> b0;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        sum += d[i];
        l[i] -= sum;
        r[i] -= sum;
    }
    /*
     * 38 -> sum -4
     */
    int ans = LLONG_MIN;
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j){
        return r[i] < r[j] || (r[i] == r[j] && l[i] < l[j]);
    });
    int i = 0;
    int v1 = a0;
    while (i < n) {
        int id = ord[i];
        int pr = l[ord[i]];
        while (i + 1 < n && r[id] == r[ord[i + 1]]) {
            i++;
            pr = min(pr, l[ord[i]]);
        }
        int v2 = min(r[ord[i]], b0);
        ans = max(ans, v1 + v2);
        v1 = min(v1, pr);
        i++;
    }
    cout << ans + 2 * sum;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
}
