#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
#define int long long

istream &operator>>(istream&in, pair<int, int>&p) {
    return in >> p.first >> p.second;
}

istream &operator>>(istream&in, vector<int> &p) {
    for (int &i : p) in >> i;
    return in;
}

ostream &operator<<(ostream &out, pair<int, int> p) {
    return out << p.first << ' ' << p.second;
}

ostream &operator<<(ostream &out, vector<int> p) {
    for (int i : p) out << i << ' ';
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    cin >> d >> l >> r;
    int a0, b0;
    cin >> a0 >> b0;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        sum += d[i];
        l[i] -= sum;
        r[i] -= sum;
    }
    /*
     * 38 -> sum -4
     */
    int ans = LLONG_MIN;
    for (int val1 : l) {
        for (int val2 : r) {
            if (val1 > a0 || val2 > b0) continue;
            int check = 1;
            for (int i = 0; i < n; ++i) {
                if (val1 > l[i] && val2 > r[i]) {
                    check = 0;
                    break;
                }
            }
            if (check) ans = max(ans, val1 + val2);
        }
    }
    assert(ans > LLONG_MIN);
    cout << ans + 2 * sum;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);

    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
}
