#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <math.h>
#include <algorithm>
#include <queue>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;
const ll mod = 1000000007;
vector <ll> d;
vector <ll> l;
vector <ll> r;
ll ans = 0, n;

void rdp(ll i, ll ai, ll bi) {
	ll p, na, nb;
	if (i == n - 1) {
		na = min(ai + d[i], l[i]);
		nb = bi + d[i];
		ans = max(ans, na + nb);

		na = ai + d[i];
		nb = min(bi + d[i], r[i]);
		ans = max(ans, na + nb);

		return;
	}
	na = min(ai + d[i], l[i]);
	nb = bi + d[i];
	rdp(i + 1, na, nb);

	na = ai + d[i];
	nb = min(bi + d[i], r[i]);
	rdp(i + 1, na, nb);
}

void solve() {
	ll i, a0, b0;
	cin >> n;
	d.resize(n);
	l.resize(n);
	r.resize(n);
	for (i = 0; i < n; i++) cin >> d[i];
	for (i = 0; i < n; i++) cin >> l[i];
	for (i = 0; i < n; i++) cin >> r[i];
	cin >> a0 >> b0;
	rdp(0, a0, b0);
	cout << ans;
}

int main() {
	ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
	ll t = 1;
	//cin >> t;
	while (t--) solve();
}