#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

const int INF = (int)(1e18) + 42;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (auto& i : d)
        cin >> i;
    for (auto& i : l)
        cin >> i;
    for (auto& i : r)
        cin >> i;
    int a0, b0;
    cin >> a0 >> b0;

    vector<int> p(n);
    iota(all(p), 0);
    sort(all(p), [&](int i, int j)->bool {return l[i] < l[j];});

    int minr = b0;
    multiset<int> sr;
    for (auto i : r) {
        minr = min(minr, i);
        sr.insert(i);
    }

    int ans = minr + a0;
    for (int i = n - 1; i > -1; --i) {
        int an = min(a0, l[p[i]]);
        sr.erase(sr.find(r[p[i]]));
        
        int bn = min(b0, sr.empty() ? INF : *sr.begin());
        
        ans = max(ans, an + bn);
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}