#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define assing assign

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tuple<int, int, int> tii;

const int INF = (int)(1e18) + 42;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (auto& i : d)
        cin >> i;
    for (auto& i : l)
        cin >> i;
    for (auto& i : r)
        cin >> i;
    int a0, b0;
    cin >> a0 >> b0;

    vector<int> pr(n + 1);
    for (int i = 1; i <= n; ++i)
        pr[i] = pr[i - 1] + d[i - 1];

    vector<int> cl(n);
    for (int i = 0; i < n; ++i)
        cl[i] = l[i] + pr[n] - pr[i + 1];
    vector<int> cr(n);
    for (int i = 0; i < n; ++i)
        cr[i] = r[i] + pr[n] - pr[i + 1];

    vector<int> p(n);
    iota(all(p), 0);
    sort(all(p), [&](int i, int j)->bool {return cl[i] < cl[j];});

    int minr = b0;
    multiset<int> sr;
    for (auto i : cr) {
        minr = min(minr, i);
        sr.insert(i);
    }

    int ans = minr + a0;
    vector<bool> used(n);
    for (int i = n - 1; i > -1; --i) {
        sr.erase(sr.find(cr[p[i]]));
        used[p[i]] = 1;

        int an = a0, bn = b0;
        for (int i = 0; i < n; ++i) {
            an += d[i], bn += d[i];
            if (used[i])
                an = min(an, l[i]);
            else
                bn = min(bn, r[i]);
        }
        ans = max(ans, an + bn);
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(20);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}