#include <algorithm>
#include <iostream>
#include <cstdint>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n; cin >> n;
    vector<int64_t> D(n+1, 0);
    for (int i = 1; i <= n; ++i) {
        cin >> D[i];
        D[i] += D[i-1];
    }
    vector<int64_t> L(n), R(n);
    for (int i = 0; i < n; ++i) {
        cin >> L[i];
        L[i] -= D[i+1];
    }
    for (int i = 0; i < n; ++i) {
        cin >> R[i];
        R[i] -= D[i+1];
    }
    int64_t a0, b0;
    cin >> a0 >> b0;

    vector<pair<int64_t, int64_t>> lst;
    lst.emplace_back(0, 0);
    for (int i = 0; i < n; ++i) {
        L[i] -= a0;
        if (L[i] > 0) {
            L[i] = 0;
        }
        R[i] -= b0;
        if (R[i] > 0) {
            R[i] = 0;
        }
        lst.emplace_back(L[i], R[i]);
    }
    sort(lst.begin(), lst.end());
    int64_t ans = lst[0].first;
    int64_t m = 0;
    for (int64_t i = 0; i <= n; ++i) {
        if (lst[i].first+m >= ans) {
            ans = lst[i].first+m;
        }
        m = min(m, lst[i].second);
    }

    cout << ans+2*D[n]+a0+b0;

    return 0;
}