#include "bits/stdc++.h"

using namespace std;

using ll = long long;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n;
    cin >> n;

    vector<ll> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < n; ++i) cin >> l[i];
    for (int i = 0; i < n; ++i) cin >> r[i];

    vector<ll> a(n + 1), b(n + 1);
    cin >> a[0] >> b[0];

    ll best = -1e18;
    for (ll mask = 0; mask < (1<<n); ++mask) {
        for (int i = 0; i < n; ++i) {
            a[i + 1] = a[i] + d[i];
            b[i + 1] = b[i] + d[i];

            if ((mask>>i) & 1) a[i + 1] = min(a[i + 1], l[i]);
            else b[i + 1] = min(b[i + 1], r[i]);
        }
        best = max(best, a.back() + b.back());
    }

    cout << best << "\n";
}