#include "bits/stdc++.h"

using namespace std;

using ll = long long;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n;
    cin >> n;

    vector<ll> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < n; ++i) cin >> l[i];
    for (int i = 0; i < n; ++i) cin >> r[i];

    vector<ll> a(n + 1), b(n + 1);
    cin >> a[0] >> b[0];


    vector dp(n + 1, vector(n + 1, vector<pair<ll, ll>>(n + 1, {-1e18, -1e18})));
    dp[0][0][0] = {a[0], b[0]};

    for (int i = 0; i < n; ++i) {
        for (int cnta = 1; cnta <= i + 1; ++cnta) {
            int cntb = i - cnta + 1;
            dp[i + 1][cnta][cntb] = {
                    min(dp[i][cnta - 1][cntb].first + d[i], l[i]),
                    dp[i][cnta - 1][cntb].second + d[i],
            };
        }
        for (int cntb = 1; cntb <= i + 1; ++cntb) {
            int cnta = i - cntb + 1;
            dp[i + 1][cnta][cntb] = {
                    dp[i][cnta][cntb - 1].first + d[i],
                    min(dp[i][cnta][cntb - 1].second + d[i], r[i]),
            };
        }
    }

    ll ans = -1e18;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            ans = max(ans, dp[n][i][j].first + dp[n][i][j].second);
        }
    }

    cout << ans << "\n";
}