#include "bits/stdc++.h"

using namespace std;

using ll = long long;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll n;
    cin >> n;

    vector<ll> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < n; ++i) cin >> l[i];
    for (int i = 0; i < n; ++i) cin >> r[i];

    vector<ll> a(n + 1), b(n + 1);
    cin >> a[0] >> b[0];

    if (*std::max_element(d.begin(), d.end()) == 0) {
        set<pair<ll, ll>, greater<>> avals;
        set<pair<ll, ll>> bvals;
        set<pair<ll, ll>> gota;
        for (int i = 0; i < n; ++i) {
            avals.insert({l[i], i});
            bvals.insert({r[i], i});
        }

        ll ans = a[0] + min(b[0], bvals.begin()->first);
        for (auto [L, i]: avals) {
            gota.insert({L, i});
            bvals.erase({r[i], i});
            ans = max(ans,
                      min(a[0], gota.begin()->first) + min(b[0], (bvals.empty() ? (ll) 1e9 : bvals.begin()->first)));
        }
        cout << ans << "\n";
        return 0;
    }

    vector dpA(n + 1, vector<pair<ll, ll>>(n + 1, {-1e18, -1e18}));
    vector dpB(n + 1, vector<pair<ll, ll>>(n + 1, {-1e18, -1e18}));
    dpA[0][0] = {a[0], b[0]};
    dpB[0][0] = {a[0], b[0]};

    for (int i = 0; i < n; ++i) {
        for (int cnta = 0; cnta <= i + 1; ++cnta) {
            int cntb = i - cnta + 1;
            if (cnta > 0) {
                dpA[i + 1][cnta] = max(dpA[i + 1][cnta], {
                        min(dpA[i][cnta - 1].first + d[i], l[i]),
                        dpA[i][cnta - 1].second + d[i],
                });
                dpA[i + 1][cnta] = max(dpA[i + 1][cnta], {
                        min(dpB[i][cntb].first + d[i], l[i]),
                        dpB[i][cntb].second + d[i],
                });
            }
            if (cntb > 0) {
                dpB[i + 1][cntb] = max(dpB[i + 1][cntb], {
                        dpB[i][cntb - 1].first + d[i],
                        min(dpB[i][cntb - 1].second + d[i], r[i]),
                });
                dpB[i + 1][cntb] = max(dpB[i + 1][cntb], {
                        dpA[i][cnta].first + d[i],
                        min(dpA[i][cnta].second + d[i], r[i]),
                });
            }
        }
    }

    ll ans = -1e18;
    for (int i = 0; i <= n; ++i) {
        ans = max(ans, dpA[n][i].first + dpA[n][i].second);
        ans = max(ans, dpB[n][i].first + dpB[n][i].second);
    }

    cout << ans << "\n";
}