#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(x) ((ll) x.size())
const ll INF = LLONG_MAX;

template<typename T, typename Y>
istream &operator>>(istream &in, pair<T, Y> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename Y>
ostream &operator<<(ostream &out, pair<T, Y> &a) {
    return out << a.first << ' ' << a.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i : a) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    int n = a.size();
    for (int i = 1; i < n; ++i) {
        out << a[i];
        if (i < n - 1) {
            out << ' ';
        }
    }
    return out;
}

template<typename T>
void print(vector<T> &a, const string &s) {
    for (int i = 0; i < sz(a); ++i) {
        cout << a[i] << s;
    }
}

void fool() {

    ll n;
    cin >> n;
    vector<ll> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    ll a0, b0;
    cin >> a0 >> b0;
    ll sum = accumulate(d.begin(), d.end(), 0ll);
    if (sum != 0) {
        ll ans = 0;
        for (int i = 0; i < (1ll << n); ++i) {
            ll a = a0, b = b0;
            for (int j = 0; j < n; ++j) {
                if (i & (1ll << j)) {
#ifdef LOCAL
                    cout << 1;
#endif
                    a = min(a + d[j + 1], l[j + 1]);
                    b += d[j + 1];
                } else {
#ifdef LOCAL
                    cout << 0;
#endif
                    a += d[j + 1];
                    b = min(b + d[j + 1], r[j + 1]);
                }
            }
#ifdef LOCAL
            cout << ' ' << a + b << '\n';
#endif
            ans = max(ans, a + b);
        }
        cout << ans;
    } else {
        vector<pair<ll, ll>> now;
        for (int i = 1; i <= n; ++i) {
            now.push_back({l[i], r[i]});
        }
        sort(now.begin(), now.end());
        ll ans = 0, a = a0, b = b0;
        for (int i = 1; i <= n; ++i) {
            if (l[i] < a) {
                b = min(b, r[i]);
            }
        }
        ans = max(ans, a + b);
        a = a0, b = b0;
        for (int i = 1; i <= n; ++i) {
            if (r[i] < b) {
                a = min(a, l[i]);
            }
        }
        ans = max(ans, a + b);
        for (int i = 0; i < n; ++i) {
            a = a0, b = b0;
            for (int j = 0; j < i; ++j) {
                b = min(b, now[j].second);
            }
            for (int j = i; j < n; ++j) {
                a = min(a, now[j].first);
            }
            ans = max(ans, a + b);
        }

        vector<ll> suf_min(n + 1);
        for (int i = n - 1; i >= 0; --i) {
            suf_min[i] = min(suf_min[i + 1], now[i].first);
        }
        b = b0;
        for (int i = 0; i < n; ++i) {
            if (i > 0) {
                b = min(b, now[i - 1].second);
            }
            a = suf_min[i];
            ans = max(ans, a + b);
        }
        cout << ans;
    }
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    ll a0, b0;
    cin >> a0 >> b0;
    ll a = a0, b = b0;
    for (int i = 1; i <= n; ++i) {
        a += d[i];
        b += d[i];
        a = min(a, l[i]);
    }
    ll ans = a + b;
    a = a0, b = b0;
    for (int i = 1; i <= n; ++i) {
        a += d[i];
        b += d[i];
        b = min(b, r[i]);
    }
    ans = max(ans, a + b);
    for (int i = 0; i < n; ++i) {
        a = a0, b = b0;
        for (int j = 0; j < n; ++j) {
            if (b + d[j + 1] > r[j + 1] && (j <= i || a + d[j + 1] <= l[j + 1])) {
                a = min(a + d[j + 1], l[j + 1]);
                b += d[j + 1];
            } else {
                a += d[j + 1];
                b = min(b + d[j + 1], r[j + 1]);
            }
        }
        ans = max(ans, a + b);
        a = a0, b = b0;
        for (int j = 0; j < n; ++j) {
            if (b + d[j + 1] > r[j + 1] && (j > i || a + d[j + 1] <= l[j + 1])) {
                a = min(a + d[j + 1], l[j + 1]);
                b += d[j + 1];
            } else {
                a += d[j + 1];
                b = min(b + d[j + 1], r[j + 1]);
            }
        }
        ans = max(ans, a + b);
        a = a0, b = b0;
        for (int j = 0; j < n; ++j) {
            if (j == i) {
                a = min(a + d[j + 1], l[j + 1]);
                b += d[j + 1];
            } else {
                a += d[j + 1];
                b = min(b + d[j + 1], r[j + 1]);
            }
        }
        ans = max(ans, a + b);
        a = a0, b = b0;
        for (int j = 0; j < n; ++j) {
            if (j != i) {
                a = min(a + d[j + 1], l[j + 1]);
                b += d[j + 1];
            } else {
                a += d[j + 1];
                b = min(b + d[j + 1], r[j + 1]);
            }
        }
        ans = max(ans, a + b);
    }
    a = a0, b = b0;
    for (int i = 1; i <= n; ++i) {
        ll a1 = a + d[i], b1 = b + d[i];
        if (a1 + min(b1, r[i]) >= b1 + min(a1, l[i])) {
            a = a1;
            b = min(b1, r[i]);
        } else {
            b = b1;
            a = min(a1, l[i]);
        }
    }
    ans = max(ans, a + b);
    vector<ll> suf(n + 2), suf_min(n + 2, INF);
    for (int i = n; i >= 0; --i) {
        suf[i] = suf[i + 1] + d[i];
    }
    for (int i = n; i >= 0; --i) {
        suf_min[i] = min(suf_min[i + 1], r[i]);
    }
    cout << ans;
}

ll fool(ll n, vector<ll> d, vector<ll> l, vector<ll> r, ll a0, ll b0) {
    ll ans = 0;
    for (int i = 0; i < (1ll << n); ++i) {
        ll a = a0, b = b0;
        for (int j = 0; j < n; ++j) {
            if (i & (1ll << j)) {
                a = min(a + d[j + 1], l[j + 1]);
                b += d[j + 1];
            } else {
                a += d[j + 1];
                b = min(b + d[j + 1], r[j + 1]);
            }
        }
        ans = max(ans, a + b);
    }
    return ans;
}

ll solve(ll n, vector<ll> d, vector<ll> l, vector<ll> r, ll a0, ll b0) {
    ll a = a0, b = b0;
    for (int i = 1; i <= n; ++i) {
        a += d[i];
        b += d[i];
        a = min(a, l[i]);
    }
    ll ans = a + b;
    a = a0, b = b0;
    for (int i = 1; i <= n; ++i) {
        a += d[i];
        b += d[i];
        b = min(b, r[i]);
    }
    ans = max(ans, a + b);
    vector<ll> suf(n + 2), suf_min(n + 2, INF);
    for (int i = n; i >= 0; --i) {
        suf[i] = suf[i + 1] + d[i];
    }
    for (int i = n; i >= 0; --i) {
        suf_min[i] = min(suf_min[i + 1], r[i]);
    }
    for (int i = 0; i < n; ++i) {
        a = a0, b = b0;
        for (int j = 0; j < n; ++j) {
            if (b + d[j + 1] > r[j + 1] && (j <= i || a + d[j + 1] <= l[j + 1])) {
                a = min(a + d[j + 1], l[j + 1]);
                b += d[j + 1];
            } else {
                a += d[j + 1];
                b = min(b + d[j + 1], r[j + 1]);
            }
        }
        ans = max(ans, a + b);
        a = a0, b = b0;
        for (int j = 0; j < n; ++j) {
            if (b + d[j + 1] > r[j + 1] && (j > i || a + d[j + 1] <= l[j + 1])) {
                a = min(a + d[j + 1], l[j + 1]);
                b += d[j + 1];
            } else {
                a += d[j + 1];
                b = min(b + d[j + 1], r[j + 1]);
            }
        }
        ans = max(ans, a + b);
    }
    return ans;
}

void stress() {
    mt19937 rnd(123);
    int test = 1;
    while (true) {
        ll n = rnd() % 6 + 1;
        vector<ll> d(n + 1), l(n + 1), r(n + 1);
        for (int i = 1; i <= n; ++i) {
            d[i] = rnd() % 10 + 1;
            l[i] = rnd() % 10 + 1;
            r[i] = rnd() % 10 + 1;
        }
        ll a0 = rnd() % 10 + 1;
        ll b0 = rnd() % 10 + 1;
        ll my_ans = solve(n, d, l, r, a0, b0), need_ans = fool(n, d, l, r, a0, b0);
        if (my_ans != need_ans) {
            cout << "TEST " << test << " FAILED:\n" << n << '\n' << d << '\n' << l << '\n' << r << '\n' << a0 << ' ' << b0 << "\nNEED:\n" << need_ans << "\nMY:\n" << my_ans;
            return;
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    string s;
    cin >> s;
    if (s == "stress") {
        stress();
        return 0;
    } else if (s == "fool") {
        fool();
        return 0;
    }
#endif

    int t = 1;
//    cin >> t;
    while (t--) {
        fool();
    }
}
