#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

const ll INF = 100, MOD = 1e9 + 7, MAXN = 2e5;
const ld EPS = 1e-6;

void solve() {
    ll n;
    cin >> n;
    ll d[n + 1], l[n + 1], r[n + 1];
    for (ll i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    for (ll i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (ll i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    cin >> l[0] >> r[0];
    ll prefd[n + 1];
    prefd[0] = 0;
    for (ll i = 1; i <= n; ++i) {
        prefd[i] = prefd[i - 1] + d[i];
    }
    ll dp[n + 1][n + 1], ndp[n + 1][n + 1];
    for (ll i = 0; i <= n; ++i) {
        for (ll j = 0; j <= n; ++j) {
            dp[i][j] = -INF;
            ndp[i][j] = -INF;
        }
    }
    dp[0][0] = l[0] + r[0];
    for (ll step = 1; step <= n; ++step) {
        for (ll i = 0; i < step; ++i) {
            for (ll j = 0; j < step; ++j) {
                if (dp[i][j] != -INF) {
                    // dp[i][j] -> sum
                    ll cura = l[i] + (prefd[step] - prefd[i]);
                    ll curb = r[j] + (prefd[step] - prefd[j]);
                    if (cura >= l[step]) {
                        ndp[step][j] = max(ndp[step][j], l[step] + curb);
                    } else {
                        ndp[i][j] = max(ndp[i][j], cura + curb);
                    }
                    if (curb >= r[step]) {
                        ndp[i][step] = max(ndp[i][step], cura + r[step]);
                    } else {
                        ndp[i][j] = max(ndp[i][j], cura + curb);
                    }
                }
            }
        }
        for (ll i = 0; i <= n; ++i) {
            for (ll j = 0; j <= n; ++j) {
                dp[i][j] = ndp[i][j];
                ndp[i][j] = -INF;
            }
        }
    }
    ll mx = -INF;
    for (ll i = 0; i <= n; ++i) {
        for (ll j = 0; j <= n; ++j) {
            mx = max(mx, dp[i][j]);
        }
    }
    cout << mx << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
