#include <bits/extc++.h>

using namespace std;
template<class t> using vc = std::vector<t>;
typedef long long ll;

struct bibs {
    int ccr = 0;
    __gnu_pbds::tree<pair<int, int>, __gnu_pbds::null_type, less<>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update> bb;

    int get(int id) { return bb.find_by_order(id)->first; }

    void add(int x) { bb.insert({x, ccr += 1}); }
} x, y;

struct dist {
    int ans = 2e9;
    int l, r;
    int mn;
    int L, R;
};

mt19937 rnd(1337);
struct node {
    dist x;
    int c;
    int i;
    int sz = 0;
    int y = rnd();
    int add = 0, add2 = 0;
    int le{}, ri{};
};

int cur = 0;
node t[(int) 5e5 + 5];

dist clay(dist a, dist b) {
    if (a.ans == 2e9) return b;
    if (b.ans == 2e9) return a;
    dist ans = a;
    ans.R = b.R;
    if (b.mn == a.mn) ans.r = b.r;
    else if (b.mn < a.mn) ans.l = b.l, ans.r = b.r;
    ans.mn = min(ans.mn, b.mn);
    ans.ans = min(ans.ans, b.ans);
    int lf = a.mn <= b.mn ? a.r : a.L - 1;
    int rf = b.mn <= a.mn ? b.l : b.R;
    ans.ans = min(ans.ans, x.get(lf + 1) - y.get(rf));
    return ans;
}

void push(int v) {
    if (!v) return;
    t[v].x.mn += t[v].add;
    t[v].x.r += t[v].add2;
    t[v].x.R += t[v].add2;
    t[v].x.L += t[v].add2;
    t[v].x.l += t[v].add2;
    t[t[v].le].add += t[v].add;
    t[t[v].ri].add += t[v].add;
    t[t[v].le].add2 += t[v].add2;
    t[t[v].ri].add2 += t[v].add2;
    t[v].add = 0;
}

void relax(int v) {
    t[v].sz = 1 + t[t[v].le].sz + t[t[v].ri].sz;
    dist rick;
    rick.L = rick.R = rick.l = rick.r = t[v].i;
    rick.mn = t[v].c;
    rick.ans = x.get(t[v].i) - y.get(t[v].i);
    t[v].x = clay(clay(t[t[v].le].x, rick), t[t[v].ri].x);
}

int merge(int v, int u) {
    if (!v || !u) return push(v + u), v + u;
    push(v), push(u);
    if (t[v].y > t[u].y) {
        t[v].ri = merge(t[v].ri, u);
        return relax(v), v;
    } else {
        t[u].le = merge(v, t[u].le);
        return relax(u), u;
    }
}

pair<int, int> split(int v, int x) {
    if (!v) return {0, 0};
    push(v);
    if (t[v].sz <= x) {
        auto [a, b] = split(t[v].ri, x);
        t[v].ri = a, relax(v);
        return {v, b};
    } else {
        auto [a, b] = split(t[v].le, x - t[v].sz - 1);
        t[v].le = b, relax(v);
        return {a, v};
    }
}

int create(int i, int x, int y, int mn) {
    int v = ++cur;
    t[v].x.l = t[v].x.r = t[v].x.L = t[v].x.R = i;
    t[v].x.mn = mn;
    t[v].x.ans = x - y;
    t[v].c = mn;
    t[v].i = i;
    return v;
}

const int K = 300;

int dp[5005][5005];

int main() {
#ifndef _GLIBCXX_DEBUG
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int n;
    cin >> n;
    bool fl = true;
    vc<int> d(n), l(n), r(n);
    for (auto &i: d) cin >> i, fl &= !i;
    for (auto &i: l) cin >> i;
    for (auto &i: r) cin >> i;
    int a, b;
    cin >> a >> b;
    vc<int> o1(n), o2(n);
    iota(o1.begin(), o1.end(), 0);
    iota(o2.begin(), o2.end(), 0);
    sort(o1.begin(), o1.end(), [&](int i, int j) { return l[i] > l[j]; });
    sort(o2.begin(), o2.end(), [&](int i, int j) { return r[i] > r[j]; });
    if (fl) {
        multiset<int> x, y;
        x.insert(1e9 + 5);
        y.insert(1e9 + 5);
        for (auto i: o1) x.insert(r[i]);
        int ans = 0;
        for (auto i: o1) {
            ans = max(ans, min(*x.begin(), b) + min(a, *y.begin()));
            x.erase(x.find(r[i]));
            y.insert(l[i]);
            ans = max(ans, min(*x.begin(), b) + min(a, *y.begin()));
        }
        cout << ans << '\n';
        return 0;
    } else {
//        ++n;
//        d.insert(d.begin(), 0);
//        l.insert(l.begin(), a), r.insert(r.begin(), b);
//        {
//            ll h = 0;
//            bool fl = false;
//            for (int i = 1; i < n; ++i) {
//                h += d[i];
//                if (min(h, (ll)l[i]) == l[i]) {
//                    dp[0][i] =
//                }
//            }
//        }
        ll ans = 0;
        for (int ma = 0; ma < 1 << n; ++ma) {
            ll x = a, y = b;
            for (int j = 0; j < n; ++j) {
                x += d[j], y += d[j];
                if (ma >> j & 1) {
                    x = min(x, (ll)l[j]);
                } else {
                    y = min(y, (ll)r[j]);
                }
            }
            ans = max(ans, x + y);
        }
        cout << ans << '\n';
    }
}

