#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <deque>

typedef long long ll;

using namespace std;

int main(){
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    ll n, a, b;
    cin >> n;
    vector <ll> d(n), l(n), r(n);
    for(int i = 0; i < n; i++) cin >> d[i];
    for(int i = 0; i < n; i++) cin >> l[i];
    for(int i = 0; i < n; i++) cin >> r[i];
    cin >> a >> b;
    if(n <= 15){
        ll ans = 0;
        for(int mask = 0; mask < (1 << n); mask++){
            ll cura = a, curb = b;
            for(int i = 0; i < n; i++){
                cura += d[i], curb += d[i];
                if(mask & (1 << i)){
                    cura = min(cura, l[i]);
                }
                else{
                    curb = min(curb, r[i]);
                }
            }
            ans = max(ans, cura + curb);
        }
        cout << ans;
    }
    else{
        vector <pair <ll, ll>> c;
        for(int i = 0; i < n; i++){
            c.push_back({l[i], r[i]});
        }
        sort(c.begin(), c.end());
        ll mn = b, ans = mn + min(a, c[0].first);
        for(int i = 0; i < n; i++){
            mn = min(mn, c[i].second);
            if(i != n - 1){
                ans = max(ans, mn + min(a, c[i + 1].first));
            }
            else{
                ans = max(ans, mn + a);
            }
        }
        cout << ans;
    }
}