
// sleepwalker*_*ksu

#include <bits/stdc++.h>
#include <experimental/random>

using namespace std;

using ld = long double;
using ll = long long;
#define int long long
#define all(a) a.begin(), a.end()
using pii = pair<ll, ll>;
const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ld EPS = 1e-6;

int solve1(int n, vector<int> &a, vector<int> &b, vector<int> &c, int fir, int sec);

void solve2();

int solve3(int n, vector<int> &a, vector<int> &b, vector<int> &c, int fir, int sec);

void solve4();

void solve5();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll qwerty = 1;
    while (qwerty--) {
        solve5();
    }
}

void solve5() {
    int n;
    cin >> n;
    vector<int> a(n), b(n), c(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    int fir, sec;
    cin >> fir >> sec;
    cout << solve1(n, a, b, c, fir, sec);
}

void solve4() {
    for (int n = 1; n <= 15; n++) {
        for (int x = 0; x <= 10; x++) {
            for (int y = 0; y <= 10; y++) {
                vector<int> a(n, 0);
                vector<int> b(n), c(n);
                for (int i = 0; i < n; i++) {
                    a[i] = experimental::randint(1, 10);
                    b[i] = experimental::randint(1, 10);
                    c[i] = experimental::randint(1, 10);
                }
                cout << n << '\n';
                for (int i = 0; i < n; i++) {
                    cout << a[i] << ' ';
                }
                cout << '\n';
                for (int i = 0; i < n; i++) {
                    cout << b[i] << ' ';
                }
                cout << '\n';
                for (int i = 0; i < n; i++) {
                    cout << c[i] << ' ';
                }
                cout << '\n';
                cout << x << ' ' << y << '\n';
                int sec = solve3(n, a, b, c, x, y);
                cout << sec;
                cout << '\n';
                cout << '\n';
            }
        }
    }
}

int mmm = 0;
vector<int> q;
vector<int> an;

void f(int id, int n, vector<int> &a, vector<int> &b, vector<int> &c, int fir, int sec) {
    if (id == n) {
        mmm = max(mmm, fir + sec);
        an = q;
        return;
    }
    q[id] = 1;
    f(id + 1, n, a, b, c, min(fir + a[id], b[id]), sec + a[id]);
    q[id] = 2;
    f(id + 1, n, a, b, c, fir + a[id], min(sec + a[id], c[id]));
}

int solve3(int n, vector<int> &a, vector<int> &b, vector<int> &c, int fir, int sec) {
    mmm = 0;
    q.resize(n);
    f(0, n, a, b, c, fir, sec);
    for (int i = 0; i < n; i++) {
        cout << an[i] << ' ';
    }
    cout << '\n';
    return mmm;
}

void solve2() {

}

int solve1(int n, vector<int> &a, vector<int> &b, vector<int> &c, int fir, int sec) {
    for (int i = 0; i < n; i++) {
        fir += a[i];
        sec += a[i];
        if (fir > b[i] && sec > c[i]) {
            int kol1 = 0, kol2 = 0;
            for (int j = i + 1; j < n; j++) {
                if (b[j] < b[i] && c[j] < sec) {
                    kol1++;
                }
                if (b[j] < fir && c[j] < c[i]) {
                    kol2++;
                }
            }
            if (kol1 < kol2) {
                fir = b[i];
            } else {
                sec = c[i];
            }
        }
    }
    return fir + sec;
}