#include <bits/stdc++.h>

using namespace std;

constexpr int maxn = 305;

bool dp[maxn][maxn][maxn];  

void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1), l(n + 1), r(n + 1), pr(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
        pr[i + 1] = pr[i] + d[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    cin >> l[0] >> r[0];
    dp[0][0][0] = true;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= i; ++j) {
            for (int k = 0; k <= i; ++k) {
                if (l[j] + (pr[i + 1] - pr[j]) <= l[i + 1] || r[k] + (pr[i + 1] - pr[k]) <= r[i + 1]) {
                    dp[i + 1][j][k] |= dp[i][j][k];
                } else {
                    dp[i + 1][i + 1][k] |= dp[i][j][k];
                    dp[i + 1][j][i + 1] |= dp[i][j][k];
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            if (dp[n][i][j]) {
                ans = max(ans, l[i] + (pr[n] - pr[i]) + r[j] + (pr[n] - pr[j]));
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
