#include <bits/stdc++.h>

using namespace std;

constexpr long long inf = (long long)1e18 + 7;

constexpr int maxn = 5005;

long long dp[maxn][maxn];  

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            dp[i][j] = -inf;
        }
    }
    vector<long long> d(n + 1), l(n + 1), r(n + 1), pr(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
        pr[i + 1] = pr[i] + d[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    cin >> l[0] >> r[0];
    dp[0][0] = r[0];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= i; ++j) {
            if (l[j] + (pr[i + 1] - pr[j]) <= l[i + 1]) {
                dp[i + 1][j] = max(dp[i + 1][j], dp[i][j] + d[i]);
            } else {
                dp[i + 1][i + 1] = max(dp[i + 1][i + 1], dp[i][j] + d[i]);
            }
            if (dp[i][j] + d[i] <= r[i + 1]) {
                dp[i + 1][j] = max(dp[i + 1][j], dp[i][j] + d[i]);
            } else {
                dp[i + 1][j] = max(dp[i + 1][j], r[i + 1]);
            }
        }
    }
    long long ans = 0;
    for (int i = 0; i <= n; ++i) {
        ans = max(ans, l[i] + (pr[n] - pr[i]) + dp[n][i]);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
