#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
istream& operator >>(istream& in, pair<T, T1> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T, typename T1>
ostream& operator <<(ostream& out, pair<T, T1> &arr) {
    cout << arr.ff << " " << arr.ss << " ";
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<T> &arr) {
    for (auto i : arr) out << i << " ";
    return out;
}

const int T = 1048576;

int tree[2 * T], str[T];

void build(int l, int r, int tind) {
    if (l == r) {
        tree[tind] = str[l];
        return;
    }

    int md = (l + r) / 2;
    build(l, md, tind * 2);
    build(md + 1, r, tind * 2 + 1);

    tree[tind] = min(tree[tind * 2], tree[tind * 2 + 1]);
}

int get(int ql, int qr, int l, int r, int tind) {
    if (r < ql || qr < l) return 1e18;
    if (ql <= l && r <= qr) return tree[tind];

    int md = (l + r) / 2;
    return min(get(ql, qr, l, md, tind * 2), get(ql, qr, md + 1, r, tind * 2 + 1));
}

const int maxn = 1e5 + 10;
int d[maxn], l[maxn], r[maxn];

void solve() {
    int n; cin >> n;

    for (int i = 1; i <= n; i++) cin >> d[i];
    for (int i = 1; i <= n; i++) cin >> l[i];
    for (int i = 1; i <= n; i++) cin >> r[i];

    for (int i = 1; i <= n; i++) d[i] += d[i - 1];
    int a, b; cin >> a >> b;

    vector<pii> s;
    for (int i = 1; i <= n; i++) {
        s.pb({l[i] + d[n] - d[i], i});
    }

    sort(all(s));
    map<int, int> to;
    for (int i = 1; i <= n; i++) to[s[i].ss] = i;
    //cout << s << "\n\n";

    str[0] = 1e18;
    for (int i = 1; i <= n; i++) {
        str[to[i]] = r[i] + d[n] - d[i];
        //cout << str[to[i]] << " ";
    }
    for (int i = 1; i <= n; i++) if (s[i].ff == s[i - 1].ff) to[s[i].ss] = to[s[i - 1].ss];

    //cout << "\n";

    build(0, T - 1, 1);

    int ans = 0, mn = b, f1 = 1;
    for (int i = 1; i <= n; i++) {
        mn = min(mn + d[i] - d[i - 1], r[i]);
        a += d[i] - d[i - 1], b += d[i] - d[i - 1];

        f1 &= (a <= l[i]);

        int t1 = l[i] + d[n] - d[i], t2 = get(0, to[i] - 1, 0, T - 1, 1);
        t2 = min(t2, b + d[n] - d[i]);

        ans = max(ans, t1 + t2);

        //cout << i << " " << t1 << " " << t2  << " " << b << "\n";
    }

    if (f1) ans = max(a + b, ans);
    ans = max(ans, mn + a);

    cout << ans;
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double time = clock();
#endif

    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
#ifdef LOCAL
        cout << "---------------\n";
#endif
    }
#ifdef LOCAL
    cout << "time:" << (clock() - time) / CLOCKS_PER_SEC << "\n";
#endif
}