#include <bits/stdc++.h>
#define int long long

using namespace std;

int fast(int n, vector<int> d, vector<int> l, vector<int> r, int a, int b) {
    int res = 0;
    l.push_back(a);
    for (int i = 0; i <= n; ++i) {
        int cura = l[i], curb = b;
        for (int j = 0; j < n; ++j) {
            if (l[j] < l[i]) {
                curb = min(curb, r[j]);
            }
        }
        res = max(res, cura + curb);
    }
    return res;
}

int slow(int n, vector<int> d, vector<int> l, vector<int> r, int a, int b) {
    int res = 0;
    for (int mask = 0; mask < (1ll << n); ++mask) {
        int cura = a, curb = b;
        for (int i = 0; i < n; ++i) {
            cura += d[i];
            curb += d[i];
            if (mask & (1ll << i)) {
                cura = min(cura, l[i]);
            } else {
                curb = min(curb, r[i]);
            }
        }
        res = max(res, cura + curb);
    }
    return res;
}

signed main() {
    mt19937 rnd(time(nullptr));
//    while (true) {
//        int n = rnd();
//        n = abs(n) % 10 + 1;
//
//        int res1 = fast();
//        int res2 = slow();
//        if (res1 != res2) {
//            cout << "WA\n";
//
//            cout << res1 << " " << res2 << "\n";
//            break;
//        } else {
//            cout << "OK\n";
//        }
//    }
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    bool d0 = true;
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
        d0 &= !d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    int a, b;
    cin >> a >> b;
    cout << slow(n, d, l, r, a, b) << "\n";
}
