#include <bits/stdc++.h>
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...) 52
#endif
#define int long long

using ll = long long;
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }

    vector<int> l(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i];
    }

    vector<int> r(n);
    for (int i = 0; i < n; i++) {
        cin >> r[i];
    }

    map<int, int> p;
    int a0, b0;
    cin >> a0 >> b0;

    p[a0] = b0;

    for (int i = 0; i < n; i++) {
        map<int, int> t;
        for (const auto &[x, y] : p) {
            t[x + d[i]] = y + d[i];
        }
        p.swap(t);

        auto it = p.lower_bound(l[i]);
        int mx = LLONG_MIN;

        while (it != p.end()) {
            mx = max(mx, it->second);
            it->second = min(it->second, r[i]);
            it++;
        }

        if (mx != LLONG_MIN) {
            p[l[i]] = mx;
        }
    }

    int ans = LLONG_MIN;

    for (const auto &[x, y] : p) {
        ans = max(ans, x + y);
    }

    cout << ans << '\n';
    return 0;
}
