#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
#define int int64_t
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF = 1e9 + 117;


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n; cin >> n;
    vector<int> d(n), l(n), r(n);
    for (auto& e : d) cin >> e;
    for (auto& e : l) cin >> e;
    for (auto& e : r) cin >> e;
    int a, b; cin >> a >> b;
    vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>> (2, {-INF, -INF}));
    dp[0][0] = dp[0][1] = {a, b};
    for (int i = 1; i <= n; ++i) {
        // dp[i][0] min(ai, li)
        int sm = d[i - 1], mn = INF;
        for (int j = i - 1; j >= 0; --j) {
            if (dp[i][0].first + dp[i][0].second < min(dp[j][0].first + sm, l[i - 1]) + min(dp[j][0].second, mn) + d[i - 1]) {
                dp[i][0].first = min(dp[j][0].first + sm, l[i - 1]);
                dp[i][0].second = min(dp[j][0].second, mn) + d[i - 1];
            }
            if (j - 1 >= 0) {
                sm += d[j - 1];
                mn = min(mn, r[j - 1]);
            }
        }
        // dp[i][1] min(bi, ri)
        sm = d[i - 1]; mn = INF;
        for (int j = i - 1; j >= 0; --j) {
            if (dp[i][1].first + dp[i][1].second < min(dp[j][1].first, mn) + d[i - 1] + min(dp[j][1].second + sm, r[i - 1])) {
                dp[i][1].first = min(dp[j][1].first, mn) + d[i - 1];
                dp[i][1].second = min(dp[j][1].second + sm, r[i - 1]);
            }
            if (j - 1 >= 0) {
                sm += d[j - 1];
                mn = min(mn, l[j - 1]);
            }
        }
    }
    cout << max(dp[n][0].first + dp[n][0].second, dp[n][1].first + dp[n][1].second);
    return 0;
}
