#include <iostream>
#include <vector>
#include <random>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

mt19937 rnd(45);

const ll MOD = 1e9 + 7;
const ll inf = 1e18;
#define all(x) x.begin(), x.end()

inline void solve() {
    int n; cin >> n;
    vector<ll> d, l, r;
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    ll a, b; cin >> a >> b;
    for (int i = 0; i < n; ++i) {
        a += d[i];
        b += d[i];
        if (a - l[i] < b - r[i]) {
            a = min(a, l[i]);
        } else {
            b = min(b, r[i]);
        }
    }
    cout << a + b << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}