#include <iostream>
#include <vector>
#include <random>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

mt19937 rnd(45);

const ll MOD = 1e9 + 7;
const ll inf = 1e18;
#define all(x) x.begin(), x.end()

inline void solve() {
    int n; cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    ll A, B; cin >> A >> B;
    ll ans = 0;
    for (int cnt = 0; cnt <= n; ++cnt) {
        ll a = A;
        ll b = B;
        for (int i = 0; i < n; ++i) {
            a += d[i];
            b += d[i];
            if (i < cnt) {
                a = min(a, l[i]);
            } else {
                b = min(b, r[i]);
            }
        }
        ans = max(ans, a + b);
        a = A;
        b = B;
        for (int i = 0; i < n; ++i) {
            a += d[i];
            b += d[i];
            if (i < cnt) {
                b = min(b, r[i]);
            } else {
                a = min(a, l[i]);
            }
        }
        ans = max(ans, a + b);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}