#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(101);

ll n, a, b;
vector<ll> D, L, R;

ll solve() {
    ll a1 = a, b1 = b, ans;
    for (int i = 0; i < n; ++i) {
        a1 += D[i], b1 += D[i];
        if (a1 <= L[i] || b1 <= R[i])
            continue;
        a1 = min(a1, L[i]);
    }
    ans = a1 + b1;

    a1 = a, b1 = b;
    for (int i = 0; i < n; ++i) {
        a1 += D[i], b1 += D[i];
        if (a1 <= L[i] || b1 <= R[i])
            continue;
        b1 = min(b1, R[i]);
    }
    ans = max(ans, a1 + b1);

    // Мы учли случаи когда что-то не выбрали (хотя вроде проще было с основным решением учесть)

    auto L0 = L, R0 = R;

    ll sum = 0;
    for (int i = 0; i < n; ++i) {
        sum += D[i];
        L[i] = min(L[i], a + sum);
        R[i] = min(R[i], b + sum);
    }

    sum = 0;
    vector<pair<ll, ll>> arr0(n), arr;
    for (int i = n - 1; i > -1; --i) {
        L[i] += sum;
        R[i] += sum;
        arr0[i] = {L[i], R[i]};
        sum += D[i];
    }

    sort(arr0.begin(), arr0.end());
    arr.push_back(arr0[0]);
    for (int i = 1; i < n; ++i)
        if (arr0[i].S < arr.back().S && arr0[i].F > arr.back().F)
            arr.push_back(arr0[i]);

    for (int i = 0; i + 1 < arr.size(); ++i)
        ans = max(ans, min(a + sum, arr[i + 1].F) + min(b + sum, arr[i].S));

    L = L0, R = R0;
    return ans;
}

ll stup() {
    ll ans = 0;
    for (ll i = 0; i < 1 << n; ++i) {
        ll a1 = a, b1 = b;
        for (ll j = 0; j < n; ++j) {
            a1 += D[j], b1 += D[j];
            if (i >> j & 1)
                a1 = min(a1, L[j]);
            else
                b1 = min(b1, R[j]);
        }
        ans = max(ans, a1 + b1);
    }
    return ans;
}

void gen() {
    n = 3, a = 0, b = 0;
    L.resize(n), R.resize(n), D.resize(n);
    for (int i = 0; i < n; ++i)
        L[i] = rnd() % 10, R[i] = rnd() % 10, D[i] = rnd() % 5;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);


    cin >> n;
    D.resize(n);
    L.resize(n);
    R.resize(n);
    for (ll &i: D)
        cin >> i;
    for (ll &i: L)
        cin >> i;
    for (ll &i: R)
        cin >> i;
    cin >> a >> b;
    cout << solve();
    return 0;


    ll _ = 1;
    while (cout << (_++) << endl) {
        gen();
        ll a = solve();
        ll b = stup();
        if (a != b) {
            cout << n << '\n';
            for (ll i: D)
                cout << i << ' ';
            cout << '\n';
            for (ll i: L)
                cout << i << ' ';
            cout << '\n';
            for (ll i: R)
                cout << i << ' ';
            cout << "\n0 0" << "\n\n";
            cout << a << ' ' << b << endl;
            return 0;
        }
    }
}
/*
5
4 0 7 0 8
10 5 3 7 7
8 5 9 2 23
4 8

*/
/*
3
3 3 2
1 1 6
2 4 1
0 0

3 6 6
2 4 6

*/
/*

Возможно надо отдельно рассмотреть 4 варианта.
 И там и там уменьшающий сетмин был, и там и там небыло, было в Л, было в Р.
 Если было в одном месте, то можно действовать жадно.
 Если и там и там небыло, то тоже жадно.

Теперь можно думать что и там и там мы сделали сетмин.
 Это значит что на начальные значения нам пофиг.

К каждому сетмину прибавим все +Дшки после него.
 Теперь у нас прибавлений типо нету, но есть сетмины.
 Дан массив пар.
 Требуется из каждой пары выбрать первый элемент отправив его в первое множество, либо второй во второе так, чтобы
  сумма минимумов в разных множествах была максимальна.

Ну, можно удалить пары такие, что оба элемента одной пары больше обоих элементов другой.
  Теперь при увеличении одного из параметров падает другой.
  Вот, условно мы выбрали элемент во второе множество. Тогда все элементы у которых выбранный параметр больше, пихаем в его группу.
  Это значит что можно фориком перебрать границу и взять лучшую.

*/
/*

*/
/*

*/
