#include <bits/stdc++.h>


#define int long long

#define fi first
#define se second

#define pb push_back
#define pw(x) (1ll << x)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn (T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx (T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using pii = pair < int , int >;

const int N = 1e6 + 5;
const int inf = 2e9;
const ll INF = 1e18;

int n, d[N];
ll l[N], r[N];
ll a[N], b[N];
ll A[N], B[N];

int stn = 1;
map < ll , int > mp;

struct seg_tree {
    int t[4 * N];

    void update (int v, int tl, int tr, int pos, ll val) {
        if (tl == tr) {
            t[v] = val;
            return;
        }
        int tm = (tl + tr) >> 1;
        if (pos <= tm) update (v << 1, tl, tm, pos, val);
        else update (v << 1 | 1, tm + 1, tr, pos, val);

        t[v] = min (t[v << 1], t[v << 1 | 1]);
    }

    void update (int pos, ll val) {
        update (1, 1, N, pos, val);
    }

    int get (int v, int tl, int tr, int l, int r) {
        if (l > r) return INF;
        if (tl == l && tr == r) return t[v];

        int tm = (tl + tr) >> 1;
        return min (get (v << 1, tl, tm, l, min (r, tm)),
                    get (v << 1 | 1, tm + 1, tr, max (tm + 1, l), r));
    }
    int get (int l, int r) {
        return get (1, 1, N, l, r);
    }
} T;

int s[N];
signed main() {
#ifdef localy
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for (int i = 1; i <= n; ++ i) cin >> d[i];
    for (int i = 1; i <= n; ++ i) cin >> l[i];
    for (int i = 1; i <= n; ++ i) cin >> r[i];

    for (int i = n; i >= 1; -- i) {
        s[i] = s[i + 1] + d[i + 1];
    }

    for (int i = 1; i < 4 * N; ++ i) T.t[i] = INF;

    cin >> a[0] >> b[0];
    A[0] = a[0];
    B[0] = b[0];
    for (int i = 1; i <= n; ++ i) {
        A[i] = A[i - 1] + d[i];
        B[i] = B[i - 1] + d[i];
    }

    vector < ll > order;
    for (int i = 1; i <= n; ++ i) {
        order.pb (l[i] + s[i]);
        order.pb (A[i] + s[i]);
    }

    sort (all (order));
    for (int i = 1; i < sz(order); ++ i) {
        if (order[i] != order[i - 1]) mp[order[i - 1]] = stn ++;
    }
    mp[order.back()] = stn ++;

    for (int i = 1; i <= n; ++ i) {
        T.update (mp[l[i] + s[i]], r[i] + s[i]);
    }

    ll mx = 0;
    for (int i = 1; i <= n; ++ i) {
        umx (mx, A[i] + s[i] + min (B[n], T.get(1, mp[A[i] + s[i]] - 1)));
        if (A[i] < l[i]) continue;
        umx (mx, l[i] + s[i] + min (B[n], T.get(1, mp[l[i] + s[i]] - 1)));
    }

    cout << mx << "\n";
    return 0;
}
