#include<bits/stdc++.h>
#include<bits/extc++.h>

#define int long long


using namespace std;
using namespace __gnu_pbds;

const int inf = 10000000000000000L;

struct SegmentTree {

    vector<int> a;
    vector<int> d;

    int findAns(int v,int l,int r,int tl,int tr){

        if(l >= tl && r <= tr) {
            return d[v];
        }

        if(l >= tr || r <= tl){
            return inf;
        }

        int m = (l+r) / 2;

        return min(findAns(2*v+1,l,m,tl,tr),findAns(2*v+2,m,r,tl,tr));
    }

    void changeZ(int v,int l,int r,int i,int z){
        if(r - l == 1) {
            d[v] = z;
            a[l] = z;
            return;
        }

        int m = (l+r) /2;

        if(i <= m){
            changeZ(2*v+1,l,m,i,z);
        }else{
            changeZ(2*v+2,m,r,i,z);
        }

        d[v] = min(d[2*v+1],d[2*v+2]);
    }

};

int32_t main(){

    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int n;
    cin >> n;
    vector<int> d(n+1);
    vector<int> l(n+1);
    vector<int> r(n+1);

    for(int i=0;i<n;i++) cin >> d[i+1];
    for(int i=0;i<n;i++) cin >> l[i+1];
    for(int i=0;i<n;i++) cin >> r[i+1];

    int a0,b0;
    cin >> a0 >> b0;

    vector<int> a(n+1);
    vector<int> b(n+1);

    a[0] = a0;
    b[0] = b0;

    vector<pair<int,int>> rs(n);
    for(int i=1;i<=n;i++){
        rs[i] = {r[i],i};
    }

    sort(rs.begin(),rs.end());
    reverse(rs.begin(),rs.end());

    vector<bool> used(n+1,false);
    int ans = 0;
    int tb = b[0];
    for(int i=0;i<n;i++){
        tb += d[i];
        tb = min(tb,r[i]);
    }
    ans = tb;
    for(int i=0;i<n;i++){
        used[rs[i].second] = true;
        tb = b[0];
        for(int i=1;i<=n;i++){
            tb += d[i];
            if(!used[i]) tb = min(tb,r[i]);
        }
        int ta = a[0];
        for(int i=1;i<=n;i++){
            ta += d[i];
            if(used[i]) ta = min(ta,l[i]);
        }

        ans = max(ans,ta + tb);
    }

    cout << ans << endl;



    return 0;
}
