//#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define int ll
typedef long long ll;
#define all(x) x.begin(), x.end()
#define vec vector

vec<int> L, R;
vec<int> D;
pair<int, int> ans = {0, 0};

void rec(int a, int b, int l = 0) {
    if (l == D.size()) {
        if (ans.first + ans.second < a + b)
            ans = {a, b};
        return;
    }
    rec(min(a + D[l], L[l]), b + D[l], l + 1);
    rec(a + D[l], min(b + D[l], L[l]), l + 1);
}

void solve() {
    int n; cin >> n;
    D.resize(n);
    L.resize(n);
    R.resize(n);
    for (auto& it : D)
        cin >> it;
    for (auto& it : L)
        cin >> it;
    for (auto& it : R)
        cin >> it;
    int a, b;
    cin >> a >> b;

    rec(a, b);
    cout << ans.first + ans.second;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

//    auto start = std::chrono::steady_clock::now();

    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }

//    auto end = std::chrono::steady_clock::now();
//    std::chrono::duration<double> elapsed_seconds = end - start;
//    cout << endl << elapsed_seconds << endl;
}