#include <bits/stdc++.h>

#define int int64_t
#define endl '\n'
#define pb push_back
#define pw(x) (int64_t(1)<<x)
#define TIME 1.0*clock()/CLOCKS_PER_SEC

using namespace std;

const int INF = 1e9;
mt19937 gen(time(0));

void solve () {
    int n;
    cin >> n;
    vector <int> d(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
    }
    vector <int> l(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    vector <int> r(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    vector <int> a(n + 1), b(n + 1);
    cin >> a[0] >> b[0];
    if (*max_element(d.begin(), d.end()) == 0) {
        int ans = 0;
        // for L
        {
            vector <int> go;
            for (int i = 1; i <= n; ++i) {
                go.pb(l[i]);
            }
            sort(go.begin(), go.end());
            go.erase(unique(go.begin(), go.end()), go.end());
            reverse(go.begin(), go.end());
            map <int, vector <int>> pos;
            for (int i = 1; i <= n; ++i) {
                pos[l[i]].pb(i);
            }
            multiset <int> ban;
            ban.insert(b[0]);
            for (int i = 1; i <= n; ++i) {
                ban.insert(r[i]);
            }
            for (auto to : go) {
                for (auto i : pos[to]) {
                    ban.erase(ban.find(r[i]));
                }
                ans = max(ans, min(a[0], to) + *ban.begin());
            }
        }
        // for R
        {
            vector <int> go;
            for (int i = 1; i <= n; ++i) {
                go.pb(r[i]);
            }
            sort(go.begin(), go.end());
            go.erase(unique(go.begin(), go.end()), go.end());
            reverse(go.begin(), go.end());
            map <int, vector <int>> pos;
            for (int i = 1; i <= n; ++i) {
                pos[r[i]].pb(i);
            }
            multiset <int> ban;
            ban.insert(a[0]);
            for (int i = 1; i <= n; ++i) {
                ban.insert(l[i]);
            }
            for (auto to : go) {
                for (auto i : pos[to]) {
                    ban.erase(ban.find(l[i]));
                }
                ans = max(ans, min(b[0], to) + *ban.begin());
            }
        }
        cout << ans;
        return;
    }
    int ans = 0;
    if (n <= 300) {
        vector <int> color(n + 1);
        for (int i = 1; i <= n; ++i) {
            color[i] = gen() % 2;
        }
        auto func = [&] () {
            for (int i = 1; i <= n; ++i) {
                a[i] = a[i - 1] + d[i];
                b[i] = b[i - 1] + d[i];
                if (color[i]) {
                    a[i] = min(a[i], l[i]);
                } else {
                    b[i] = min(b[i], r[i]);
                }
            }
            return a[n] + b[n];
        };
        int cur = func();
        while (TIME < 0.95) {
            int i = gen() % n + 1;
            color[i] ^= 1;
            int now = func();
            if (now >= cur) {
                cur = now;
            } else {
                color[i] ^= 1;
            }
        }
        cout << cur;
        return;
    }
    for (int msk = 0; msk < pw(n); msk++) {
        for (int i = 1; i <= n; ++i) {
            a[i] = a[i - 1] + d[i];
            b[i] = b[i - 1] + d[i];
            if (msk & pw(i - 1)) {
                a[i] = min(a[i], l[i]);
            } else {
                b[i] = min(b[i], r[i]);
            }
        }
        ans = max(ans, a[n] + b[n]);
    }
    cout << ans << endl;
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int q = 1;
//    cin >> q;
    while (q--) {
        solve();
    }
}
