#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <cmath>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;
const ll INF = 1e18;
const int INF2 = 1e9;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n; cin >> n;
	vector<ll> d(n + 1), l(n + 1), r(n + 1);
	ll a0, b0;
	for (int i = 1; i <= n; ++i)
		cin >> d[i];
	for (int i = 1; i <= n; ++i)
		cin >> l[i];
	for (int i = 1; i <= n; ++i)
		cin >> r[i];
	cin >> a0 >> b0;
	if (n <= 15) {
		ll ans = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			ll a = a0, b = b0;
			for (int i = 1; i <= n; ++i) {
				a += d[i]; b += d[i];
				if ((mask >> (i - 1)) & 1) {
					a = min(a, l[i]);
				}
				else {
					b = min(b, r[i]);
				}
			}
			ans = max(ans, a + b);
		}
		cout << ans;
	}
	else {
		vector<map<int, int>> dp(n + 1);
		dp[0][a0] = b0;
		for (int i = 1; i <= n; ++i)
			dp[0][l[i]] = -INF2;
		vector<vector<int>> dp_min(n + 1, vector<int>(n + 1, INF2));
		for (int i = 1; i <= n; ++i) {
			int curmin = INF2;
			for (int j = i; j <= n; ++j) {
				curmin = min(curmin, (int)r[j]);
				dp_min[i][j] = curmin;
			}
		}
		for (int i = 1; i <= n; ++i) {
			int x = a0;
			int j = i;
			while (j >= 1 && l[j] < x)
				j--;
			if (j == i)
				dp[i][x] = dp[i - 1][x];
			else
				dp[i][x] = min(dp[j][x], dp_min[j + 1][i]);
			for (int ind = 1; ind <= n; ++ind) {
				int x = l[ind];
				int j = i;
				while (j >= 1 && l[j] < x)
					j--;
				if (j == i)
					dp[i][x] = dp[i - 1][x];
				else
					dp[i][x] = min(dp[j][x], dp_min[j + 1][i]);
			}
		}
		int x = a0;
		int ans = 0;
		if (dp[n][x] != -INF2)
			ans = max(ans, dp[n][x] + x);
		for (int i = 1; i <= n; ++i) {
			int x = l[i];
			if (dp[n][x] != -INF2)
				ans = max(ans, dp[n][x] + x);
		}
		cout << ans;
	}

	return 0;
}