#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <cmath>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;
const ll INF = 1e18;
const int INF2 = 1e9;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n; cin >> n;
	vector<ll> d(n + 1), l(n + 1), r(n + 1);
	ll a0, b0;
	for (int i = 1; i <= n; ++i)
		cin >> d[i];
	for (int i = 1; i <= n; ++i)
		cin >> l[i];
	for (int i = 1; i <= n; ++i)
		cin >> r[i];
	cin >> a0 >> b0;
	if (n <= 15) {
		ll ans = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			ll a = a0, b = b0;
			for (int i = 1; i <= n; ++i) {
				a += d[i]; b += d[i];
				if ((mask >> (i - 1)) & 1) {
					a = min(a, l[i]);
				}
				else {
					b = min(b, r[i]);
				}
			}
			ans = max(ans, a + b);
		}
		cout << ans;
	}
	else {
		vector<int> l2;
		l2.push_back(a0);
		for (int i = 1; i <= n; ++i)
			l2.push_back(l[i]);
		sort(l2.begin(), l2.end());
		l2.resize(unique(l2.begin(), l2.end()) - l2.begin());
		unordered_map<int, int> dict;
		for (int i = 0; i < l2.size(); ++i)
			dict[l2[i]] = i;
		vector<int> l12(n);
		for (int i = 1; i <= n; ++i)
			l12[i] = dict[l2[i]];
		vector<vector<int>> dp(n + 1);
		dp[0][dict[a0]] = b0;
		for (int i = 1; i <= n; ++i) {
			if (l[i] > a0)
				dp[0][l12[i]] = -INF2;
			else
				dp[0][l12[i]] = b0;
		}
		vector<vector<int>> dp_min(n + 1, vector<int>(n + 1, INF2));
		for (int i = 1; i <= n; ++i) {
			int curmin = INF2;
			for (int j = i; j <= n; ++j) {
				curmin = min(curmin, (int)r[j]);
				dp_min[i][j] = curmin;
			}
		}
		for (int i = 1; i <= n; ++i) {
			int x = a0;
			int j = i;
			while (j >= 1 && l[j] < x)
				j--;
			if (j == i)
				dp[i][dict[x]] = dp[i - 1][dict[x]];
			else
				dp[i][dict[x]] = min(dp[j][dict[x]], dp_min[j + 1][i]);
			for (int ind = 1; ind <= n; ++ind) {
				int x = l[ind];
				int xi = l12[ind];
				int j = i;
				while (j >= 1 && l[j] < x)
					j--;
				if (j == i)
					dp[i][xi] = dp[i - 1][xi];
				else
					dp[i][xi] = min(dp[j][xi], dp_min[j + 1][i]);
			}
		}
		int x = a0;
		int ans = 0;
		if (dp[n][dict[x]] != -INF2)
			ans = max(ans, dp[n][dict[x]] + x);
		for (int i = 1; i <= n; ++i) {
			int x = l[i];
			if (dp[n][dict[x]] != -INF2)
				ans = max(ans, dp[n][dict[x]] + x);
		}
		cout << ans;
	}

	return 0;
}