

#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <stack>
#include <deque>
#include <assert.h>
#include <random>
#include <algorithm>
#include <string>
#include <iomanip>
#include <iostream>
#include <math.h>

using namespace std;

mt19937 rnd(0);
#define fast ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)

#define pii pair<int, int>
#define vi vector<int>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define ff first
#define ss second
#define int long long 

vi D, L, R;
int a0, b0;
int n;

signed main()
{
    fast;
    cin >> n;
    D.resize(n);
    L.resize(n);
    R.resize(n);

    for (auto& i : D) cin >> i;
    for (auto& i : L) cin >> i;
    for (auto& i : R) cin >> i;

    cin >> a0 >> b0;

    int max_d = 0;
    for (auto& i : D) max_d = max(max_d, i);
    if (max_d == 0) {
        vector<pii> c(n);
        for (int i = 0; i < n; ++i) c[i] = { L[i], R[i] };
        sort(all(c));
        int ans = 0;
        int min_b = b0;
        int min_a = a0;
        for (int i = 0; i < n; ++i) {
            min_a = min(a0, c[i].ff);
            if (i > 0) min_b = min(min_b, c[i - 1].ss);
            ans = max(ans, min_a + min_b);
        }
        ans = max(ans, min_b + a0);
        cout << ans;
        return 0;
    }
    return 0;

    vector<unordered_map<int, int>> dp(n + 1);
    dp[0][a0] = b0;
    for (int i = 0; i < n; ++i) {
        int l = L[i], r = R[i], d = D[i];
        for (auto& el : dp[i]) {
            int ai = el.ff, bi = el.ss;
            dp[i + 1][ai + d] = max(dp[i + 1][ai + d], min(bi + d, r));
            dp[i + 1][min(ai + d, l)] = max(dp[i + 1][min(ai + d, l)], bi + d);
        }
    }

    int ans = 0;
    for (auto& el : dp[n]) ans = max(ans, el.ff + el.ss);
    cout << ans;
}