//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ll = long long;
using ld = long double;

const ll INF = 2e18;
const int MOD = 1e9 + 7, N = 1e5 + 1, MAXN = 5e5 + 1, K = 26, INFi = 2e9;
const ld EPS = 1e-12, PI = acos(-1);

random_device rd;
mt19937_64 rnd(rd());

struct lr{
    int l, r, id;
};

bool cmp(lr a, lr b) {
    return a.l > b.l;
}

void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }
    vector<lr> v(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> v[i].l;
    }
    for (int i = 1; i <= n; i++) {
        cin >> v[i].r;
        v[i].id = i;
    }
    sort(v.begin() + 1, v.end(), cmp);
    vector<int> a(n + 1), b(n + 1);
    cin >> a[0] >> b[0];
    int ans = 0;
    set<pair<int, int>> st;
    v[0] = {INF, INF, INF};
    for (int i = 0; i <= n; i++) {
        st.insert({v[i].r, v[i].id});
    }
    for (int i = 0; i < n; i++) {
        st.erase({v[i].r, v[i].id});
        auto it = st.begin();
        ans = max(ans, min(b[0], it->first) + min(a[0], v[i].l));
    }
    ans = max(ans, min(a[0], v[n].l) + b[0]);
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
