#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <algorithm>
#include <deque>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
#define int ll

using namespace std;

mt19937 rnd(0);

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n;i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n;i++) {
        cin >> l[i];
    }
    for (int i = 0; i < n;i++) {
        cin >> r[i];
    }
    int a0, b0;
    cin >> a0 >> b0;
    int a1 = a0, b1 = b0;
    for (int i = 0; i < n; i++) {
        a1 += d[i];
        b1 += d[i];
        a1 = min(a1, l[i]);
    }
    int a2 = a0, b2 = b0;
    for (int i = 0; i < n; i++) {
        a2 += d[i];
        b2 += d[i];
        b2 = min(b2, r[i]);
    }
    cout << max(a1 + b1, a2 + b2);
}


signed main() {
    cout.setf(ios_base::fixed);
    cout << fixed << std::setprecision(12);
    ios_base::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    auto f = freopen("input.txt", "r", stdin);
    auto f1 = freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}