#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <algorithm>
#include <deque>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
#define int ll

using namespace std;

mt19937 rnd(0);

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    vector<int> pd{ 0 };
    for (int i = 0; i < n;i++) {
        cin >> d[i];
        pd.push_back(pd.back() + d[i]);
    }
    for (int i = 0; i < n;i++) {
        cin >> l[i];
        l[i] += pd.back() - pd[i + 1];
    }
    for (int i = 0; i < n;i++) {
        cin >> r[i];
        r[i] += pd.back() - pd[i + 1];
    }
    int a0, b0;
    cin >> a0 >> b0;
    a0 += pd.back();
    b0 += pd.back();
    int s = 0;
    int a1 = a0, b1 = b0;
    for (int j = 0; j < n; j++) {
        if (l[j] < a1) {
            b1 = min(b1, r[j]);
        }
    }
    s = max(s, a1 + b1);
    for (int i = 0; i < n; i++) {
        a1 = min(a0, l[i]);
        b1 = b0;
        for (int j = 0; j < n; j++) {
            if (l[j] < a1) {
                b1 = min(b1, r[j]);
            }
        }
        s = max(s, a1 + b1);
    }
    cout << s;
}


signed main() {
    cout.setf(ios_base::fixed);
    cout << fixed << std::setprecision(12);
    ios_base::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    auto f = freopen("input.txt", "r", stdin);
    auto f1 = freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}