//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("inline")
//#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <deque>

using namespace std;

using ll = long long;
using pii = pair<ll, ll>;

ll ans = 0;
int n;

vector<ll> d, l, r;


void gen(int num, ll a, ll b) {
    if (num == n) {
        ans = max(ans, a + b);
        return;
    }
    a += d[num];
    b += d[num];
    gen(num + 1, min(a, l[num]), b);
    gen(num + 1, a, min(b, r[num]));
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    d.resize(n), l.resize(n), r.resize(n);
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < n; ++i) cin >> l[i];
    for (int i = 0; i < n; ++i) cin >> r[i];
    ll a0, b0;
    cin >> a0 >> b0;
    bool h = true;
    for (int i = 0; i < n; ++i) if (d[i] != 0) h = false;
    if (h && n > 15) {
        vector<pii> ab(n);
        for (int i = 0; i < n; ++i) {
            ab[i] = {l[i], r[i]};
        }
        std::sort(ab.begin(), ab.end());
        for (auto [a, b] : ab) {
            ans = max(ans, min(a, a0) + b0);
            b0 = min(b0, b);
        }
        cout << ans << "\n";
        return 0;
    }
    gen(0, a0, b0);
    cout << ans;
    return 0;
}
