#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("inline")
//#pragma GCC target("avx2")
#include <iostream>
#include <random>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <deque>

using namespace std;

using ll = long long;
using pii = pair<ll, ll>;

ll ans = 0;
int n;

vector<ll> d, l, r;

#define int ll


void gen(int num, ll a, ll b) {
    if (num == n) {
        ans = max(ans, a + b);
        return;
    }
    a += d[num];
    b += d[num];
    gen(num + 1, min(a, l[num]), b);
    gen(num + 1, a, min(b, r[num]));
}

bool comp(pii a, pii b) {
    if (a.second != b.second) return a.second < b.second;
    return a.first < b.first;
}

random_device rd;
mt19937 rng(23102007);

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    d.resize(n), l.resize(n), r.resize(n);
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < n; ++i) cin >> l[i];
    for (int i = 0; i < n; ++i) cin >> r[i];
    ll a0, b0;
    cin >> a0 >> b0;
    bool h = true;
    for (int i = 0; i < n; ++i) if (d[i] != 0) h = false;
    if (h) {
        vector<pii> ab(n);
        for (int i = 0; i < n; ++i) {
            ab[i] = {l[i], r[i]};
        }
        std::sort(ab.begin(), ab.end());
        for (auto [a, b] : ab) {
            ans = max(ans, min(a, a0) + b0);
            b0 = min(b0, b);
        }
        ans = max(ans, b0 + a0);
        cout << ans << "\n";
        return 0;
    }
    if (n <= 15) {
        gen(0, a0, b0);
        cout << ans;
        return 0;
    }
    vector<pii> ab(n);
    for (int i = 0; i < n; ++i) {
        ab[i] = {l[i], r[i]};
    }
    std::sort(ab.begin(), ab.end());
    for (int i = 0; i < n + 1; ++i) {
        ll now_a = a0, now_b = b0;
        for (int j = 0; j < n; ++j) {
            now_a += d[j];
            now_b += d[j];
            if (l[j] < now_a && (r[j] >= now_b || i == n || l[j] < ab[i].first)) {
                now_b = min(now_b, r[j]);
            } else {
                now_a = min(now_a, l[j]);
            }
        }
        ans = max(ans, now_a + now_b);
    }
    std::sort(ab.begin(), ab.end(), comp);
    for (int i = 0; i < n; ++i) {
        ll now_a = a0, now_b = b0;
        for (int j = 0; j < n; ++j) {
            now_a += d[j];
            now_b += d[j];
            if (l[j] < now_a && (r[j] >= ab[i].second || r[j] >= now_b)) {
                now_b = min(now_b, r[j]);
            } else {
                now_a = min(now_a, l[j]);
            }
        }
        ans = max(ans, now_a + now_b);
    }
    vector<char> used(n);
    for (int i = 0; i < n; ++i) {
        ll now_a = a0, now_b = b0;
        ll max_dif = -1e18;
        int id = -1;
        for (int j = 0; j < n; ++j) {
            now_a += d[j];
            now_b += d[j];
            if (l[j] < now_a && (used[j] || r[j] >= now_b)) {
                now_b = min(now_b, r[j]);
            } else {
                now_a = min(now_a, l[j]);
                if (max(now_a - l[j], 0ll) - max(now_b - r[j], 0ll) > max_dif) {
                    max_dif = max(now_a - l[j], 0ll) - max(now_b - r[j], 0ll);
                    id = j;
                }
            }
        }
        ans = max(ans, now_a + now_b);
        if (id != -1) used[id] = 1;
    }
    vector<int> ids(n);
    for (int i = 0; i < n; ++i) ids[i] = i;
    
    for (int _ = 0; _ < 105500; ++_) {
        std::shuffle(ids.begin(), ids.end(), std::mt19937(std::random_device()()));
        used.assign(n, 0);

        for (int i = 0; i < rng() % n + 1; ++i) {
            used[ids[i]]++;
        }

        ll now_a = a0, now_b = b0;
        for (int j = 0; j < n; ++j) {
            now_a += d[j];
            now_b += d[j];
            if (l[j] < now_a && (used[j] || r[j] >= now_b)) {
                now_b = min(now_b, r[j]);
            } else {
                now_a = min(now_a, l[j]);
            }
        }
        ans = max(ans, now_a + now_b);

    }
    cout << ans;
    return 0;
}
