#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9 + 1;
const int mod = inf + 6;
const ll infll = 1ll * (inf - 1) * (inf - 1);
mt19937_64 rnd(228);//time(0));

void solve_case() {
    int n; cin >> n;
    vector<int> d(n);
    for (int i = 0; i < n; i++) cin >> d[i];
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) cin >> l[i];
    for (int i = 0; i < n; i++) cin >> r[i];
    ll a0, b0;
    cin >> a0 >> b0;
    ll ans = 0;
    vector<ll> suf(n + 1);
    for (int i = n - 1; i >= 0; i--) suf[i] = suf[i + 1] + d[i];
    vector<ll> ma(n + 1), mb(n + 1);
    ma[0] = a0 + suf[0], mb[0] = b0 + suf[0];
    for (int i = 0; i < n; i++) {
        ma[i + 1] = l[i] + suf[i + 1];
        mb[i + 1] = r[i] + suf[i + 1];
    }
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 1);
    sort(ord.begin(), ord.end(), [&](int left, int right){
        return ma[left] > ma[right];
    });
    vector<ll> s2(n + 1);
    s2[n] = mb[0];
    for (int i = n - 1; i >= 0; i--) s2[i] = min(s2[i + 1], mb[ord[i]]);
    for (int i = 0; i < n; i++) {
        chmax(ans, min(ma[ord[i]], ma[0]) + s2[i + 1]);
    }
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve_case();
    }
}
