// JafoNoksy's code
#include <bits/stdc++.h>

#pragma GCC optimize "O2"
using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define F first
#define S second
#define int ll
#define ve vector
mt19937 rnd(4732);

template<class A>
istream &operator>>(istream &in, ve<A> &x) {
    for (auto &c: x)
        in >> c;
    return in;
}

template<class A>
ostream &operator<<(ostream &out, ve<A> &x) {
    for (auto &c: x)
        out << c << ' ';
    return out << '\n';
}

struct segtree {
    ve<int> t;
    int n = 0;

    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    int get(int v, int l, int r, int _l, int _r) {
        if (l >= _r || _l >= r)
            return 0;
        if (_l <= l && r <= _r)
            return t[v];
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, _l, _r) + get(2 * v + 2, m, r, _l, _r);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }

    segtree(ve<int> a = {1}) {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n, a);
    }
};

struct mst {
    ve<ve<int>> t;

    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = {a[l]};
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v].resize(t[2 * v + 1].size() + t[2 * v + 2].size());
        merge(t[2 * v + 1].begin(), t[2 * v + 1].end(), t[2 * v + 2].begin(), t[2 * v + 2].end(), t[v].begin());
    }

    void get(int v, int l, int r, int i, int s) {
        int m = (l + r) / 2;
    }
};


void sol(int test_group) {
    int n;
    cin >> n;
    int m1, m2;
    cin >> m1 >> m2;
    ve<pll> E1, E2;
    ve<ve<int>> g1(n), g2(n);
    for (int i = 0; i < m1; ++i) {
        int u, v;
        cin >> u >> v;
        g1[u - 1].pb(v - 1);
        g1[v - 1].pb(u - 1);
        E1.pb({min(u - 1, v - 1), max(u - 1, v - 1)});
    }
    for (int i = 0; i < m2; ++i) {
        int u, v;
        cin >> u >> v;
        g2[u - 1].pb(v - 1);
        g2[v - 1].pb(u - 1);
        E2.pb({min(u - 1, v - 1), max(u - 1, v - 1)});
    }
    sort(all(E1));
    sort(all(E2));  // Для поиска ребра в дереве
    auto find = [&](int u, int v) {
        return binary_search(all(E2), pll{min(u, v), max(u, v)});
    };
    if (n == 3 && m1 == 0 && find(0, 1) && find(1, 2) && find(0, 2)) {
        cout << "No\n";
        return;
    }


}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    ve<int> d(n + 1, 0), l(n + 1, 0), r(n + 1, 0);
    bool is_group = 1;
    for (int i = 1; i <= n; ++i) {
        cin >> d[i];
        if (d[i] != 0)
            is_group = false;
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> r[i];
    }
    cin >> l[0] >> r[0];
    if (is_group) {
        ve<pll> p1, p2;
        for (int i = 1; i <= n; ++i) {
            p1.pb({l[i], r[i]});
            p2.pb({r[i], l[i]});
        }
        sort(all(p1));
        sort(all(p2));
        int c = r[0];
        int ans = 0;
        for (int i = 0; i <= n; ++i) {
            ans = max(ans, min(l[0], p1[i].F) + c);
            c = min(c, p1[i].S);
        }
        c = l[0];
        for (int i = 0; i <= n; ++i) {
            ans = max(ans, min(r[0], p2[i].F) + c);
            c = min(c, p2[i].S);
        }
        cout << ans;
        return 0;
    }
}