// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("D:\\work2\\input.txt", "r", stdin);
#define file_out freopen("D:\\work2\\output.txt", "w", stdout);
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define str string
#define pb push_back
#define ff first
#define sc second
#define all(a) a.begin(), a.end()
#define sz(a) (int(a.size()))
#define int ll

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2> istream& operator>>(istream &in, pair<T1, T2> &a) { in >> a.ff >> a.sc; return in; }
template<typename T1, typename T2> ostream& operator<<(ostream &out, const pair<T1, T2> &a) { out << a.ff << " " << a.sc; return out; }
template<typename T> istream& operator>>(istream &in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const set<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const multiset<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
mt19937_64 genom(mt_seed); ll randint(ll a, ll b) { uniform_int_distribution<ll> r(a, b); return r(genom); }
const int RANDOM = mt_seed; struct chash { int operator()(int x) const { return x ^ RANDOM; } };
struct pair_hash { ll operator()(pii x) const { return 1ll * x.ff * 31 + x.sc; } };

struct vec {
    int x, y;
    vec() { x = y = 0; }
    vec(int _x, int _y) { x = _x, y = _y; }
    vec(vec a, vec b) { x = b.x - a.x; y = b.y - a.y; }

    bool operator==(vec a) { return x == a.x && y == a.y; } 
    vec operator+(vec a) { return {x + a.x, y + a.y}; }
    vec operator-(vec a) { return {x - a.x, y - a.y}; }
    int operator*(vec a) { return x * a.x + y * a.y; }
    int operator%(vec a) { return x * a.y - y * a.x; }
};
struct line {
    int A, B, C;
    line() { A = B = C = 0; }
    line(vec a, vec b) {
        vec v(a, b);
        A = v.y;
        B = -v.x;
        C = -(A * a.x + B * a.y);

        if (B < 0) {
            A = -A;
            B = -B;
            C = -C;
        } else if (B == 0 && A < 0) {
            A = -A;
            C = -C;
        }

        int g = gcd(gcd(abs(A), abs(B)), abs(C));
        if (g != 0) {
            A /= g;
            B /= g;
            C /= g;
        }
    }
};

ld PI = acos(-1);
ll len2(vec a) { return a * a; }
ll dist2(vec a, vec b) { return len2(a - b); }
ld angle(vec a, vec b) { return atan2(a % b, a * b); }
ld dist(vec a, line l) { return (l.A * a.x + l.B * a.y + l.C) / sqrtl(l.A * l.A + l.B * l.B); }

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int n;
    cin >> n;
    vector<int> D(n), L(n), R(n);
    cin >> D >> L >> R;

    int a0, b0;
    cin >> a0 >> b0;

    vector<int> sufd(n + 1);
    for (int i = n - 1; i >= 0; --i)
        sufd[i] = sufd[i + 1] + D[i];

    int ans = 0;
    vector<int> bad(n, -10);
    int mx = a0;

    for (int i = -1; i < n; ++i) {
        int x = min(mx, (i == -1 ? a0 : L[i])) + sufd[i + 1];
        if (i != n - 1)
           mx += D[i + 1];

        int An = x;

        for (int j = n - 1; j >= 0; --j) {
            if (x > L[j])
                bad[j] = i;
            x -= D[j];
        }
        int Bn = b0;
        for (int j = 0; j < n; ++j) {
            Bn += D[j];
            if (bad[j] == i) Bn = min(Bn, R[j]);
        }

        // cout << An << ": ";
        // for (auto el : bad) cout << (el == i) << ' ';
        // cout << "| " << Bn << endl;

        ans = max(ans, An + Bn);
    }
    cout << ans;

    return 0;
}
