#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree< ll , null_type , less< ll > , rb_tree_tag , tree_order_statistics_node_update > oset;
typedef long double ld;
typedef pair< int , int > pii;
typedef pair< ll , ll > pll;


#define pb push_back
#define S second
#define F first
#define all(x) x.begin() , x.end()
#define sz(x) x.size()
#define int ll
#define itn int
#define ve vector

const int N = 2e5 + 123;
const int inf = 1e18 + 123;
const int mod = 10;
const int sqr = 500;

mt19937 gen( time( 0 ) );

int n;

int l[N] , r[N] , d[N];

int a0 , b0;

int ansa()
{
    int a[n + 1] , b[n + 1];

    a[0] = a0 , b[0] = b0;

    for( int i = 1;i <= n;++ i )
    {
        a[i] = a[i - 1] + d[i];
        b[i] = b[i - 1] + d[i];

        int d1 = a[i] - min( a[i] , l[i] );
        int d2 = b[i] - min( b[i] , r[i] );

        if( d1 == 0 || d2 == 0 )
        {
            continue;
        }

        b[i] -= d2;
    }

    return a[n] + b[n];

}

int ansb()
{
    int a[n + 1] , b[n + 1];

    a[0] = a0 , b[0] = b0;

    for( int i = 1;i <= n;++ i )
    {
        a[i] = a[i - 1] + d[i];
        b[i] = b[i - 1] + d[i];

        int d1 = a[i] - min( a[i] , l[i] );
        int d2 = b[i] - min( b[i] , r[i] );

        if( d1 == 0 || d2 == 0 )
        {
            continue;
        }

        a[i] -= d1;
    }

    return a[n] + b[n];

}

int solve_mask()
{
    int a[n + 1] , b[n + 1];

    a[0] = a0 , b[0] = b0;

    int ans = 0;

    int msk;

    for( int mask = 0;mask < ( 1l << n );++ mask )
    {
        for( int i = 1;i <= n;++ i )
        {
            a[i] = a[i - 1] + d[i];
            b[i] = b[i - 1] + d[i];

            int d1 = a[i] - min( a[i] , l[i] );
            int d2 = b[i] - min( b[i] , r[i] );

            if( ( mask & ( 1ll << ( i - 1 ) ) ) == 0 )
            {
                a[i] -= d1;
            }
            else
            {
                b[i] -= d2;
            }
        }

        if( b[n] + a[n] > ans )
        {
            ans = max( ans , b[n] + a[n] );

            msk = mask;
        }
    }

    return ans;
}


void solve()
{
//    return;

    cin >> n;

    for( int i = 1;i <= n;++ i )
    {
        cin >> d[i];
    }

    for( int i = 1;i <= n;++ i )
    {
        cin >> l[i];
    }

    for( int i = 1;i <= n;++ i )
    {
        cin >> r[i];
    }

    cin >> a0 >> b0;

//    return;

    if( n < 20 )
    {
        cout << solve_mask();
    }
    else
    {
        cout << max( ansa() , ansb() );
    }
}


int32_t main()
{
    #ifdef LOCAL
        freopen( "input.txt" , "r" , stdin );
        freopen( "output.txt" , "w" , stdout );
    #endif // LOCAL

    ios_base::sync_with_stdio( 0 );
    cin.tie( 0 );
    cout.tie( 0 );

    int t = 1;
//    cin >> t;

    while( t -- )
    {
        solve();
    }
}
