#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()

const ll INF = 1e18;

ll n;
vector<ll> d, l, r;
ll a, b;

bool checkA(ll m, ll an) {
    ll bn = m - an;
    for (ll i = n - 1; i >= 0; --i) {
        if (an > l[i]) {
            if (bn > r[i]) return false;
            else if (bn == r[i]) bn = -1;
        } else if (an == l[i]) {
            an = -1;
        }
        if (an != -1) {
            an -= d[i];
        }
        if (bn != -1) {
            bn -= d[i];
        }
    }
    return an <= a && bn <= b;
}

bool checkB(ll m, ll bn) {
    ll an = m - bn;
    for (ll i = n - 1; i >= 0; --i) {
        if (an > l[i]) {
            if (bn > r[i]) return false;
            else if (bn == r[i]) bn = -1;
        } else if (an == l[i]) {
            an = -1;
        }
        if (an != -1) {
            an -= d[i];
        }
        if (bn != -1) {
            bn -= d[i];
        }
    }
    return an <= a && bn <= b;
}

bool check(ll m, ll mn) {
    return checkA(m, mn) || checkB(m, mn);
}

bool f(ll m) {
    ll lb = 0, rb = m + 1;
    while (rb - lb > 1) {
        ll md = (lb + rb) / 2;
        if (check(m, md)) {
            lb = md;
        } else {
            rb = md;
        }
    }
    return check(m, lb);
}

int main() {
    cin >> n;
    d.resize(n);
    l.resize(n);
    r.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> r[i];
    }
    cin >> a >> b;
    ll lb = 0, rb = INF;
    while (rb - lb > 1) {
        ll m = (lb + rb) / 2;
        if (f(m)) {
            lb = m;
        } else {
            rb = m;
        }
    }
    cout << lb;
}
