#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (auto& x : d) cin >> x;
    for (auto& x : l) cin >> x;
    for (auto& x : r) cin >> x;
    auto cx = [&](pair<int, int>& fx, pair<int, int>& state) -> bool {
        return fx.first < state.first || fx.first == state.first && state.second > fx.second;
    };
    auto cy = [&](pair<int, int>& s, pair<int, int>& state) -> bool {
        return s.second < state.second || s.second == state.second && state.first > s.first;
    };
    int stx, sty;
    cin >> stx >> sty;
    vector<unordered_map<int, int>> dp(n + 1);
    dp[0][stx] = sty;
    for (int i = 0; i < n; ++i) {
        pair<int, int> fx = {-1, 0}, sx = {-1, 0}, fy = {-1, 0}, sy = {-1, 0};
        for (auto& [x, y] : dp[i]) {
            pair<int, int> state = {x + d[i], min(y + d[i], r[i])};
            pair<int, int> state2 = {min(x + d[i], l[i]), y + d[i]};
//            dp[i + 1][x + d[i]] = max(dp[i + 1][x + d[i]], min(y + d[i], r[i]));
//            dp[i + 1][min(x + d[i], l[i])] = max(dp[i + 1][min(x + d[i], l[i])], y + d[i]);
            if (cx(fx, state)) {
                sx = fx;
                fx = state;
            } else if (cx(sx, state)) {
                sx = state;
            }
            if (cy(fy, state)) {
                sy = fy;
                fy = state;
            } else if (cy(sy, state)) {
                sy = state;
            }
            swap(state, state2);
            if (cx(fx, state)) {
                sx = fx;
                fx = state;
            } else if (cx(sx, state)) {
                sx = state;
            }
            if (cy(fy, state)) {
                sy = fy;
                fy = state;
            } else if (cy(sy, state)) {
                sy = state;
            }
        }
        dp[i + 1].insert(fx);
        dp[i + 1].insert(fy);
        if (sx.first != -1) dp[i + 1].insert(sx);
        if (sy.first != -1) dp[i + 1].insert(sy);
    }
    int ans = 0;
    for (auto& [x, y] : dp[n]) {
        ans = max(ans, x + y);
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
