#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (auto& x : d) cin >> x;
    for (auto& x : l) cin >> x;
    for (auto& x : r) cin >> x;
    auto cmpx = [&](pair<int, int>& f, pair<int, int>& s) -> bool {
        if (f.first + f.second == s.first + s.second) return f.first > s.first;
        return f.first + f.second > s.first + s.second;
    };
    auto cmpy = [&](pair<int, int>& f, pair<int, int>& s) -> bool {
        if (f.first + f.second == s.first + s.second) return f.first > s.first;
        return f.first + f.second > s.first + s.second;
    };
    int stx, sty;
    cin >> stx >> sty;
    vector<unordered_map<int, int>> dp1(n + 1), dp2(n + 1);
    dp1[0][stx] = sty;
    dp2[0][sty] = stx;
    for (int i = 0; i < n; ++i) {
        //    dp[i + 1][x + d[i]] = max(dp[i + 1][x + d[i]], min(y + d[i], r[i]));
//            dp[i + 1][min(x + d[i], l[i])] = max(dp[i + 1][min(x + d[i], l[i])], y + d[i]);
        vector<pair<int, int>> vx, vy;
        for (auto& [x, y] : dp1[i]) {
            vx.push_back({x + d[i], min(y + d[i], r[i])});
            vx.push_back({min(x + d[i], l[i]), y + d[i]});
            vy.push_back({y + d[i], min(x + d[i], l[i])});
            vy.push_back({min(y + d[i], r[i]), x + d[i]});
        }
        for (auto& [y, x] : dp2[i]) {
            vx.push_back({x + d[i], min(y + d[i], r[i])});
            vx.push_back({min(x + d[i], l[i]), y + d[i]});
            vy.push_back({y + d[i], min(x + d[i], l[i])});
            vy.push_back({min(y + d[i], r[i]), x + d[i]});
        }
        sort(vx.begin(), vx.end(), cmpx);
        for (int j = 0; j < 25 && j < vx.size(); ++j) {
            dp1[i + 1].insert(vx[j]);
        }
        sort(vy.begin(), vy.end(), cmpy);
        for (int j = 0; j < 25 && j < vy.size(); ++j) {
            dp2[i + 1].insert(vy[j]);
        }
    }
    int ans = 0;
    for (auto& [x, y] : dp1[n]) {
        ans = max(ans, x + y);
    }
    for (auto& [y, x] : dp2[n]) {
        ans = max(ans, y + x);
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
