#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int> p) {
    out << "| " << p.first << " " << p.second << " | ";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
constexpr long long N = 6e5 + 556;
constexpr long long T = 20;
constexpr long long A = 26;
constexpr double eps = 1e-9;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1, 0), l(n + 1, 0), r(n + 1, 0);
    for (int i = 1; i < n + 1; i++) cin >> d[i];
    for (int i = 1; i < n + 1; i++) cin >> l[i];
    for (int i = 1; i < n + 1; i++) cin >> r[i];
    vector<int> a(n + 1, 0), b(n + 1, 0);
    cin >> a[0] >> b[0];
    for (int i = 1; i < n + 1; i++) {
        a[i] = a[i - 1] + d[i];
        b[i] = b[i - 1] + d[i];

        if (a[i] > l[i] && b[i] > r[i]) {
            if (l[i] + b[i] > a[i] + r[i]) a[i] = l[i];
            else b[i] = r[i];
        }
    }
    // cout << a << endl << b << endl;
    cout << a[n] + b[n] << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}