#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <map>
#include <set>
#include <memory.h>
#include <random>
using namespace std;

#define int long long
#define endl "\n"

ostream& operator << (ostream& out, pair<int, int> p) {
    out << "| " << p.first << " " << p.second << " | ";
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& el : a) in >> el;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& el : a) out << el << " ";
    return out;
}

mt19937_64 rng(556);
constexpr long long N = 1e6;
constexpr long long T = 20;
constexpr long long A = 26;
constexpr double eps = 1e-9;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1, 0), l(n + 1, 0), r(n + 1, 0);
    for (int i = 1; i < n + 1; i++) cin >> d[i];
    for (int i = 1; i < n + 1; i++) cin >> l[i];
    for (int i = 1; i < n + 1; i++) cin >> r[i];

    int sa, sb; cin >> sa >> sb;

    int mx = 0;
    vector<vector<int>> bsts;

    for (int m = 0; m < (1 << n); m++) {
        vector<int> a(n + 1, sa), b(n + 1, sb);

        for (int i = 0; i < n; i++) {
            a[i + 1] = a[i] + d[i + 1];
            b[i + 1] = b[i] + d[i + 1];

            if (m & (1 << i)) a[i + 1] = min(a[i + 1], l[i + 1]);
            else b[i + 1] = min(b[i + 1], r[i + 1]);
        }

        // cout << a << "| " << b << "= ";
        // cout << a[n] + b[n] << endl;
        if (a[n] + b[n] > mx) {
            mx = a[n] + b[n];
            // bsts = {a};
        } else if (a[n] + b[n] == mx) {
            // bsts.push_back(a);
        }
    }

    cout << mx << endl;
    // for (auto el : bsts) cout << el << endl;
}

signed main() {
    int tests = 1;

#ifdef LOCALIC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    // cin >> tests;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
#endif

    while (tests --> 0) solve();
}