#include <bits/stdc++.h>

#pragma GCC optimize("O3", "unroll-loops", "inline")
#pragma GCC target("popcnt")
using namespace std;
#define int long long

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    auto start = clock();
    mt19937 rnd(42);
    bool d0 = true;

    int n, a0, b0;
    cin >> n;
    vector<int> D(n), L(n), R(n);
    for (int &x: D) {
        cin >> x;
        if (x) d0 = false;
    }
    for (int &x: L) cin >> x;
    for (int &x: R) cin >> x;
    cin >> a0 >> b0;

    int best = 0, a, b;
    a = a0, b = b0;
    for (int i = 0; i < n; i++) {
        a += D[i], b += D[i];
        if (R[i] >= b) continue;
        a = min(a, L[i]);
    }
    best = max(best, a + b);
    a = a0, b = b0;
    for (int i = 0; i < n; i++) {
        a += D[i], b += D[i];
        if (L[i] >= a) continue;
        b = min(b, R[i]);
    }
    best = max(best, a + b);

    if (d0) {
        vector<pair<int, int>> A(n);
        for (int i = 0; i < n; i++) {
            A[i] = {L[i], R[i]};
        }
        sort(A.begin(), A.end());
        a = a0, b = b0;
        for (int i = 0; i < n; i++) {
            best = max(best, min(a, A[i].first) + b);
            b = min(b, A[i].second);
        }
        sort(A.begin(), A.end(), [](auto f, auto s) {
            return tie(f.second, f.first) < tie(s.second, s.first);
        });
        a = a0, b = b0;
        for (int i = 0; i < n; i++) {
            best = max(best, a + min(b, A[i].second));
            a = min(a, A[i].first);
        }
        cout << best;
        return 0;
    }

    set<int> T;
    T.insert(L.begin(), L.end());
    T.insert(R.begin(), R.end());

    for (int lim: T) {
        a = a0, b = b0;
        for (int i = 0; i < n; i++) {
            if (L[i] >= lim) {
                a = min(a, L[i]);
            } else {
                b = min(b, R[i]);
            }
        }
        best = max(best, a + b);
    }
    for (int lim: T) {
        a = a0, b = b0;
        for (int i = 0; i < n; i++) {
            if (R[i] >= lim) {
                b = min(b, R[i]);
            } else {
                a = min(a, L[i]);
            }
        }
        best = max(best, a + b);
    }
    cout << best;
//    a = a0, b = b0;
//    for (int i = 0; i < n; i++) {
//        a += D[i], b += D[i];
//        if (L[i] >= a) continue;
//        if (R[i] >= b) continue;
//        if (a - min(a, L[i]) < b - min(b, R[i])) {
//            a = min(a, L[i]);
//        } else {
//            b = min(b, R[i]);
//        }
//    }
//    best = max(best, a + b);
//    while (clock() - start < 0.95 * CLOCKS_PER_SEC) {
//        a = a0, b = b0;
//        for (int i = 0; i < n; i++) {
//            a += D[i], b += D[i];
//            if (L[i] >= a) continue;
//            if (R[i] >= b) continue;
//            if (rnd() % 2) {
//                a = min(a, L[i]);
//            } else {
//                b = min(b, R[i]);
//            }
//        }
//        best = max(best, a + b);
//    }
//    cout << best;
    return 0;
}

/*
        for (int l: L) {
            a = a0, b = b0;
            for (int i = 0; i < n; i++) {
                if (L[i] >= l) {
                    a = min(a, L[i]);
                } else {
                    b = min(b, R[i]);
                }
            }
            best = max(best, a + b);
        }
        for (int r: R) {
            a = a0, b = b0;
            for (int i = 0; i < n; i++) {
                if (R[i] >= r) {
                    b = min(b, R[i]);
                } else {
                    a = min(a, L[i]);
                }
            }
            best = max(best, a + b);
        }
        cout << best;
 */