#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

mt19937 rnd(14);

typedef long long ll;
typedef long double ld;

const ll inf = 1e18;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    vector<ll> d(n + 1);
    vector<ll> l(n + 1);
    vector<ll> r(n + 1);
    for(int i = 0; i < n; i++) cin >> d[i];
    for(int i = 0; i < n; i++) cin >> l[i];
    for(int i = 0; i < n; i++) cin >> r[i];
    ll res1 = 0, res2 = 0;
    multiset<ll> l1;
    multiset<ll> r1;
    for(int i = 0; i < n; i++) {
        l1.insert(l[i]);
        r1.insert(r[i]);
    }
    ll a0, b0; cin >> a0 >> b0;
    for(int i = 0; i < n; i++) {
        if (a0 + d[i] <= l[i]) {
            a0 += d[i];
            b0 += d[i];
        } else {
            a0 += d[i];
            b0 = min(b0 + d[i], r[i]);
        }
    }
    cout << a0 + b0;
    return 0;
}
