#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <unordered_map>

using namespace std;

#define int long long


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vector<int> d(n);
	for (int i = 0; i < n; i++) cin >> d[i];
	vector<int> l(n);
	for (int i = 0; i < n; i++) cin >> l[i];
	vector<int> r(n);
	for (int i = 0; i < n; i++) cin >> r[i];
	int u = 0;
	for (int i = 0; i < n; i++) {
		u += d[i];
		l[i] -= u;
		r[i] -= u;
	}
	int a, b;
	cin >> a >> b;
	int a2 = a;
	int b2 = b;
	int ans = a + b;
	for (int i = 0; i < n; i++) {
		int ha = min(a, l[i]);
		b = b2;
		for (int j = 0; j < n; j++) {
			if (i == j) continue;
			if (l[j] >= ha) continue;
			b = min(b, r[j]);
		}
		ans = max(ans, u * 2 + b + ha);
	}
	cout << ans;


}

/*

Предположим, что мы на i ходе взяли минимум от a, какой результат?
1) Есть куча челов вида l[i], X. Среди них выбираем максимальный икс
2) Есть ещё челики, вида a < l[i], Y
Сразу выкидываем тех, у кого Y <= X
А с остальными что делать? Например:
l[i] - 1, X + 1
l[i] - 2, X + 2
l[i] - 3, X + 3
И тд

4 0 7 0 8
10 5 3 7 7
8 5 9 2 23

4 0 7 0 8
6 1 -8 -4 -12
4 1 -2 -9 4
4 8

В итоге убираем все d, теперь числа монотонно убывают
Можно перебрать первый минимум


*/
