#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)x.size()

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, a) for(auto& x: a)

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 1e5 + 1;

pii dp[N][2];

pii comp(const pii& a, const pii& b) {
    if(a.fi + a.se > b.fi + b.se) {
        return a;
    }
    return b;
}

int main() {
    int n;
    cin >> n;

    vector<ll> d(n), l(n), r(n);
    fe (x, d) {
        cin >> x;
    }
    fe (x, l) {
        cin >> x;
    }
    fe (x, r) {
        cin >> x;
    }
    
    ll a, b;
    cin >> a >> b;
    
    dp[0][0] = dp[0][1] = {a, b};

    fr (i, 1, n) {
        int curL = l[i - 1];
        int curR = r[i - 1];
        int curD = d[i - 1];

        dp[i][0] = comp({min(curL, dp[i - 1][0].fi + curD), dp[i - 1][0].se + curD}, 
                        {min(curL, dp[i - 1][1].fi + curD), dp[i - 1][1].se + curD});

        dp[i][1] = comp({dp[i - 1][0].fi + curD, min(curR, dp[i - 1][0].se + curD)}, 
                        {dp[i - 1][1].fi + curD, min(curR, dp[i - 1][1].se + curD)});
    }

    cout << max(dp[n][0].fi + dp[n][0].se, dp[n][1].fi + dp[n][1].se) << endl;

    return 0;
}