#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <deque>
#include <random>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e9 + 7;
const ll INFll = 1e18;
const ll M1 = 1e9 + 7, M2 = 1e9 + 9;
const ll P1 = 137, P2 = 239;
const ld PI = atan2(0, -1), EPS = 1e-10;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	freopen("i.txt", "r", stdin), freopen("o.txt", "w", stdout);

	//cout << fixed << setprecision(20);

	int n;
	cin >> n;
	vector<ll> d(n), l(n), r(n);
	for (int i = 0; i < n; ++i) {
		cin >> d[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> r[i];
	}
	ll a0, b0;
	cin >> a0 >> b0;
	vector<ll> a(n + 1), b(n + 1);
	a[0] = a0;
	b[0] = b0;
	for (int i = 1; i <= n; ++i) {
		a[i] = a[i - 1] + d[i - 1];
		b[i] = b[i - 1] + d[i - 1];
		if (a[i] <= l[i - 1]) {
			continue;
		}
		if (b[i] <= r[i - 1]) {
			continue;
		}
		if (a[i] - l[i - 1] <= b[i] - r[i - 1]) {
			a[i] = l[i - 1];
		}
		else {
			b[i] = r[i - 1];
		}
	}
	cout << a[n] + b[n];
}