#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
#include <bitset>
#include <deque>
#include <random>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e9 + 7;
const ll INFll = 1e18;
const ll M1 = 1e9 + 7, M2 = 1e9 + 9;
const ll P1 = 137, P2 = 239;
const ld PI = atan2(0, -1), EPS = 1e-10;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	//freopen("i.txt", "r", stdin), freopen("o.txt", "w", stdout);

	//cout << fixed << setprecision(20);

	int n;
	ll a0, b0;
	cin >> n;
	vector<ll> d(n), l(n), r(n);
	for (int i = 0; i < n; ++i) {
		cin >> d[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> r[i];
	}
	cin >> a0 >> b0;
	if (n <= 15) {
		ll ans = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			ll a1 = a0, b1 = b0;
			int mask1 = mask;
			for (int i = 0; i < n; ++i) {
				a1 += d[i];
				b1 += d[i];
				if (mask1 & 1) {
					a1 = min(a1, l[i]);
				}
				else {
					b1 = min(b1, r[i]);
				}
				mask1 >>= 1;
			}
			ans = max(ans, a1 + b1);
		}
		cout << ans;
	}
	else {
		ll min_r = INFll;
		for (auto x : r) {
			min_r = min(min_r, x);
		}
		vector<pair<ll, int>> l1;
		for (int i = 0; i < n; ++i) {
			l1.push_back({ l[i], i });
		}
		sort(l1.begin(), l1.end());
		ll answer = max(b0 + min(a0, l1[0].first), a0 + min(b0, min_r));
		multiset<ll> r1;
		for (auto x : r) {
			r1.insert(x);
		}
		for (int i = n - 1; i >= 1; --i) {
			r1.erase(r1.lower_bound(r[l1[i].second]));
			answer = max(answer, min(a0, l1[i].first) + min(b0, *r1.begin()));
		}
		cout << answer;
	}
}