#include <bits/stdc++.h>

using namespace std;
namespace rng = ranges;
namespace viu = views;

typedef int64_t ll;

#define INF ((int)1e9 + 1329)
#define INF_LL ((int64_t)1e18)

#ifndef ILKRAS
#define ent "\n"
#else
#define ent endl
#endif

struct Solution {
    int TEST = -1;

    signed operator()() {
        int n;
        cin >> n;
        vector<ll> dr(n);
        for (auto &it: dr) cin >> it;
        vector<ll> lr(n), rr(n);
        for (auto &it: lr) cin >> it;
        for (auto &it: rr) cin >> it;
        ll a, b;
        cin >> a >> b;
        ll l = 0, r = INF_LL;
        auto try_x = [&](ll x, ll resa, ll resb, vector<ll>& ar, vector<ll>& br) {
            for (int i = 0; i < n; ++i) {
                if (ar[i] >= x) {
                    resa = min(resa, ar[i]);
                } else {
                    resb = min(resb, br[i]);
                }
            }
            return resa + resb;
        };
        while (r - l > 1) {
            ll m = (l + r) / 2;
            ll x = (m + 1) / 2;
            if (try_x(x, a, b, lr, rr) >= m | try_x(x, b, a, rr, lr) >= m) {
                l = m;
            } else {
                r = m;
            }
        }
        cout << l << "\n";
        return 0;
    }

    Solution(int TEST = -1) : TEST(TEST) {}
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    for (int TEST: viu::iota(1, t + 1)) {
        int res = Solution(TEST)();
        if (res != 0)
            return res;
    }
    return 0;
}