#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <random>
#include <chrono>
#define endl '\n'
#define ALL(v) v.begin(), v.end()
#define current_time chrono::steady_clock::now().time_since_epoch().count()
//#define int long long

using namespace std;

typedef long double ld;

template <typename T1, typename T2>
bool rmin(T1& x, const T2& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T1, typename T2>
bool rmax(T1& x, const T2& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

constexpr uint8_t STEP = 17;
constexpr uint32_t MAXN = 1E5, BL_SZ = 316, CNT_BL = (MAXN + BL_SZ - 1) / BL_SZ;

constexpr uint32_t MOD = 998244353, MOD_phi = MOD - 1;
struct Mod_int
{
	uint32_t val;
	Mod_int(uint64_t val = 0) :val(val% MOD) {}
	Mod_int operator+ (const Mod_int m) const
	{
		return val + m.val;
	}
	Mod_int operator+= (const Mod_int m)
	{
		return *this = *this + m;
	}
	Mod_int operator- (const Mod_int m) const
	{
		return MOD - m.val + val;
	}
	Mod_int operator-= (const Mod_int m)
	{
		return *this = *this - m;
	}
	Mod_int operator* (const Mod_int m) const
	{
		return uint64_t(val) * m.val;
	}
	Mod_int operator*= (const Mod_int m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step_val) const
	{
		Mod_int ans = 1, cur = *this;
		while (step_val > 0)
		{
			if (step_val & 1)
			{
				ans *= cur;
			}
			step_val >>= 1;
			cur *= cur;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int m) const
	{
		return *this * m.step(MOD_phi - 1);
	}
	Mod_int operator/= (const Mod_int m)
	{
		return *this = *this / m;
	}
};

void solve()
{
	int n;
	cin >> n;
	vector <int> d(n), l(n), r(n);
	for (int i = 0; i < n; i++)
	{
		cin >> d[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> l[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> r[i];
	}
	int a0, b0;
	cin >> a0 >> b0;
	
	int64_t sum_d = 0, cur_a = a0, cur_b = b0;
	for (int i = 0; i < n; i++)
	{
		sum_d += d[i];
		cur_a = min(int64_t(l[i]), cur_a + d[i]);
		cur_b = min(int64_t(r[i]), cur_b + d[i]);
	}
	cout << max(cur_a + b0 + sum_d, a0 + sum_d + cur_b);
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}
}