#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e9 + 7;

ll n;
vector<ll> d, l, r;

ll solve(ll a, ll b) {
    for (ll i = 0; i < n; i++) {
        a += d[i];
        b += d[i];

        if (l[i] >= a or r[i] >= b) continue;

        if (a - l[i] < b - r[i]) a = l[i];
        else if (a - l[i] == b - r[i]) {
            if (a < b) a = l[i];
            else b = r[i];
        }
        else b = r[i];
    }

    return a + b;
}

ll rec(ll a, ll b, ll ind) {
    if (ind == n) return a + b;

    a += d[ind];
    b += d[ind];

    return max(rec(min(a, l[ind]), b, ind + 1), rec(a, min(b, r[ind]), ind + 1));
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n;

    d.resize(n);
    l.resize(n);
    r.resize(n);

    for (ll i = 0; i < n; i++) cin >> d[i];
    for (ll i = 0; i < n; i++) cin >> l[i];
    for (ll i = 0; i < n; i++) cin >> r[i];

    ll a, b; cin >> a >> b;

    cout << rec(a, b, 0) << endl;
}
