#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if (false) cerr
#endif

#define int long long
typedef long long ll;
#define in(x) x.begin(), x.end()

template<typename T>
bool cmin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

main() {
    cin.tie(0)->sync_with_stdio(0);

    int n;
    cin >> n;
    vector<int> D(n + 1), L(n + 1), R(n + 1);
    int a0, b0;
    for (int i = 1; i <= n; ++i) {
        cin >> D[i];
    }
    
    for (int i = 1; i <= n; ++i) {
        cin >> L[i];
    }
    
    for (int i = 1; i <= n; ++i) {
        cin >> R[i];
    }
    cin >> a0 >> b0;
    debug<< a0 << ' ' << b0 << endl;

    vector<ll> pref(n + 1);
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + D[i + 1];
    }
    ll ans = 0;
    // if (D == vector<int>(n + 1, 0)) {
    //     ans = max(min(a0, *min_element(1 + in(L))) + b0, ans);
    //     debug << *min_element(1 + in(L)) << endl;
    //     swap(a0, b0);
    //     swap(L, R);
    //     ans = max(min(a0, *min_element(1 + in(L))) + b0, ans);
    //     debug << *min_element(1 + in(L)) << endl;

    //     cout << ans << '\n';
    //     return 0;
    // }

    vector<ll> to_chk;

    auto Chk = [&](ll An) {
        if (An - pref[n] <= a0) {
            to_chk.push_back(An);
            /*ll A = a0, B = b0;
            for (int i = 1; i <= n; ++i) {
                if (An <= L[i] - pref[i] + pref[n]) A = min(A, (ll)L[i] - pref[i]);
                else B = min(B, (ll)R[i] - pref[i]);
            }
            ans = max(ans, A + pref[n] + B + pref[n]);*/
        }
    };
    
    const int oo = 2e9;
    auto Solve = [&](){
        to_chk.clear();
        Chk(a0 + pref[n]);
        for (int i = n; i >= 1; --i) {
            Chk(L[i] + pref[n] - pref[i]);
        }
        sort(in(to_chk));
        vector<ll> upda(to_chk.size(), oo), updb(to_chk.size(), oo);
        for (int i = 1; i <= n; ++i) {
            int ind = (upper_bound(in(to_chk), L[i] - pref[i] + pref[n]) - to_chk.begin()) - 1;
            if (ind >= 0) {
                cmin(upda[ind], (ll)L[i] - pref[i]);
            }
            if (ind + 1 < (int)to_chk.size()) {
                cmin(updb[ind], (ll)R[i] - pref[i]);
            }
        }
        for (int i = 1; i < (int)to_chk.size(); ++i) {
            cmin(updb[i], updb[i - 1]);
        }
        for (int i = (int)to_chk.size() - 2; i >= 0; --i) {
            cmin(upda[i], upda[i + 1]);
        }
        for (int i = 0; i < (int)to_chk.size(); ++i) {
            ll A = a0, B = b0;
            A = min(A, upda[i]);
            B = min(B, updb[i]);
            ans = max(ans, A + pref[n] + B + pref[n]);
        }
    };
    Solve();
    swap(L, R);
    swap(a0, b0);
    Solve();
    cout << ans;
    return 0;
}