#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstdint>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <numbers>
#include <bit>

using namespace std;

#define int int64_t

using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);



    int n;
    cin >> n;
    vector<int> D(n + 1, 0), L(n + 1, 0), R(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> D[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> L[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> R[i];
    }
    int a0, b0;
    cin >> a0 >> b0;

    vector<int> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + D[i];
    }
    L[0] = a0, R[0] = b0;

    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>> (n + 1, vector<int> (n + 1, -1e18)));
    dp[0][0][0] = a0 + b0;
    for (int i = 0; i < n; i++) {
        for (int l = 0; l <= i; l++) {
            for (int r = 0; r <= i; r++) {
                if (dp[i][l][r] < -1e17) {
                    continue;
                }
                if (L[l] + pref[i + 1] - pref[l] < L[i + 1]) {
                    dp[i + 1][l][r] = max(dp[i + 1][l][r], L[l] + pref[i + 1] - pref[l] + R[r] + pref[i + 1] - pref[r]);
                } else {
                    dp[i + 1][i + 1][r] = max(dp[i + 1][i + 1][r], L[i + 1] + R[r] + pref[i + 1] - pref[r]);
                }
                if (R[l] + pref[i + 1] - pref[r] < R[i + 1]) {
                    dp[i + 1][l][r] = max(dp[i + 1][l][r], L[l] + pref[i + 1] - pref[l] + R[r] + pref[i + 1] - pref[r]);
                } else {
                    dp[i + 1][l][i + 1] = max(dp[i + 1][l][i + 1], R[i + 1] + L[l] + pref[i + 1] - pref[l]);
                }
            }
        }
    }

    int ans = 0;
    for (int l = 0; l <= n; l++) {
        for (int r = 0; r <= n; r++) {
            ans = max(ans, dp[n][l][r]);
        }
    }

    cout << ans << "\n";






    return 0;
}
