#include <bits/stdc++.h>

using ll = long long int;
using ull = unsigned long long int;
using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void solve()
{
    int n;
    cin >> n;

    vector<ll> d(n), l(n), r(n);
    for (int i = 0; i < n; i++)
        cin >> d[i];
    for (int i = 0; i < n; i++)
        cin >> l[i];
    for (int i = 0; i < n; i++)
        cin >> r[i];
    
    vector<ll> a(n + 1), b(n + 1);
    cin >> a[0] >> b[0];

    for (int i = 1; i <= n; i++)
    {
        a[i] = a[i - 1] + d[i - 1];
        b[i] = b[i - 1] + d[i - 1];
        ll min_l = min(a[i], l[i - 1]);
        ll min_r = min(b[i], r[i - 1]);
        if (a[i] - min_l < b[i] - min_r)
            a[i] = min_l;
        else
            b[i] = min_r;
    }

    cout << a.back() + b.back() << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("D:/olymp/Day 2/in.txt", "r", stdin);
    freopen("D:/olymp/Day 2/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif
    while (t--)
        solve();
    return 0;
}