#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;

void solve() {
    ll n;
    cin >> n;
    vector<ll> D(n);
    vector<ll> L(n);
    vector<ll> R(n);
    for (auto &item: D) {
        cin >> item;
    }

    for (auto &item: L) {
        cin >> item;
    }

    for ( auto &item: R) {
        cin >> item;
    }

    ll a0, b0;
    cin >> a0 >> b0;
    for (ll i = 0; i < n; ++i) {
        if (a0 + min(b0, R[i]) >= min(a0, L[i]) + b0) {
            b0 = min(b0, R[i]);
        } else {
            a0 = min(a0, L[i]);
        }
    }

    cout << a0 + b0 << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
