#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

void solve() {
    ll n;
    cin >> n;
    vector<ll> D(n);
    vector<ll> L(n);
    vector<ll> R(n);
    vector<ll> aVal;
    for (auto &item: D) {
        cin >> item;
    }

    for (auto &item: L) {
        cin >> item;
        aVal.push_back(item);
    }

    for (auto &item: R) {
        cin >> item;
    }

    ll a0, b0;
    cin >> a0 >> b0;

    aVal.push_back(a0);
    sort(aVal.begin(), aVal.end());
    vector<ll> dp(n + 1);
    for (ll i = 0; i < n + 1; ++i) {
        if (aVal[i] <= a0) {
            dp[i] = b0;
        }
    }

    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n + 1; ++j) {
            if (aVal[j] > L[i]) {
                dp[j] = min(dp[j], R[i]);
            }
        }
    }

    ll res = 0;
    for (ll i = 0; i < n + 1; ++i) {
        res = max(res, i + dp[i]);
    }

    cout << res << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
