#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const ll INF = 1e9;
const ll N = 2005;
const ll MOD = 1e9 + 7;
const ll M = 10005; // !!!!!!!!!!!!!!!!!!!!!!!1

mt19937 gen(time(0));

void solve() {
    ll n; cin >> n;
    vector<ll> d(n + 1, 0), l(n + 1, 0), r(n + 1, 0);
    for (int i = 1; i <= n; i++) cin >> d[i];
    for (int i = 1; i <= n; i++) cin >> l[i];
    for (int i = 1; i <= n; i++) cin >> r[i];
    ll a0, b0; cin >> a0 >> b0;

    vector<ll> down_l(n + 1, 0), down_r(n + 1, 0);
    ll cur_l = a0, cur_r = b0;
    for (int i = 1; i <= n; i++) {
        cur_l += d[i];
        down_l[i] = cur_l - l[i];

        cur_r += d[i];
        down_r[i] = cur_r - r[i];
    }
    ll lst_l = cur_l, lst_r = cur_r;

    vector<pair<ll, ll>> all_l;
    for (int i = 1; i <= n; i++) {
        all_l.push_back({down_l[i], i});
    }
    set<pair<ll, ll>> all_r;
    all_r.insert({0, -1});
    for (int i = 1; i <= n; i++) {
        all_r.insert({down_r[i], i});
    }

    ll ans = lst_l + (lst_r - max(0ll, (*all_r.rbegin()).first));
    sort(all_l.begin(), all_l.end());
    for (int i = 0; i < n; i++) {
        ll idx = all_l[i].second;
        all_r.erase({down_r[idx], idx});

        ans = max(ans, (lst_l - max(0ll, all_l[i].first)) + (lst_r - max(0ll, (*all_r.rbegin()).first)));
    }

    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    ll tst = 1;
    while (tst--) {
        solve();
    }
}