#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <complex>
#include <assert.h>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <immintrin.h>
using namespace std;

///*
#define int long long
#define INTLONGLONG
//*/

#define pi pair<int, int>
#define vi vector<int>
#define vvi vector<vector<int>>
#define vpi vector<pair<int, int>>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ff first
#define ss second

int INF = 1e18;

struct str {
	int n2;
	vi vec;
	str(int n) {
		n2 = 1;
		while (n2 < n) n2 *= 2;
		vec.assign(2 * n2, INF);
	}
	int get(int l, int r, int ql, int qr, int v) {
		if (l <= ql && qr <= r) {
			return vec[v];
		}
		if (l >= qr) return INF;
		if (ql >= r) return INF;
		int m = (ql + qr) / 2;
		return min(get(l, r, ql, m, 2 * v + 1), get(l, r, m, qr, 2 * v + 2));
	}
	void set(int i, int x, int ql, int qr, int v) {
		if (i == ql && ql + 1 == qr) {
			vec[v] = x;
			return;
		}
		int m = (ql + qr) / 2;
		if (i < m) {
			set(i, x, ql, m, 2 * v + 1);
		}
		else {
			set(i, x, m, qr, 2 * v + 2);
		}
		vec[v] = min(vec[2 * v + 1], vec[2 * v + 2]);
	}
};

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vi d(n);
	vi l(n);
	vi r(n);
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}
	vi pref(n + 1);
	for (int i = 0; i < n; i++) {
		pref[i + 1] = pref[i] + d[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> l[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> r[i];
	}
	int a, b;
	cin >> a >> b;
	for (int i = 0; i < n; i++) {
		l[i] = min(l[i], a + pref[i + 1]);
		r[i] = min(r[i], b + pref[i + 1]);
	}
	INF = pref[n] + b;
	int ans = 0;
	int tb = b;
	int ta = a;
	for (int i = 0; i < n; i++) {
		ta += d[i];
		tb += d[i];
		tb = min(tb, r[i]);
	}
	ans = ta + tb;
	
	vpi ogr_a(n);
	vi ogr_b(n);
	for (int i = 0; i < n; i++) {
		ogr_a[i] = {l[i] + pref[n] - pref[i + 1], i};
		ogr_b[i] = r[i] + pref[n] - pref[i + 1];
	}
	sort(all(ogr_a));
	str tr(n);
	vi tvec(n);
	for (int i = 0; i < n; i++) {
		tvec[i] = ogr_b[ogr_a[i].ss];
		tr.set(i, ogr_b[ogr_a[i].ss], 0, tr.n2, 0);
	}
	for (int i = 0; i < n; i++) {
		ans = max(ans, ogr_a[i].ff + tr.get(0, i, 0, tr.n2, 0));
	}
	cout << ans << endl;
};