#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using ll = long long;
#define int long long
#define x first
#define y second
#define sz(a) (int)a.size()
using namespace __gnu_pbds;
gp_hash_table<int, int> table;
const int inf = 1e18;
int n = 1e5;
vector<int> d(n + 1), l(n + 1), r(n + 1), a(n + 1), b(n + 1);

//int check(int c) {
//    vector<int> suf(n + 2);
//    for (int i = n; i >= 1; --i) {
//        suf[i] = suf[i + 1] + d[i];
//    }
//    for (int i = 1; i <= n; ++i) {
//        a[i] = a[i - 1] + d[i];
//        b[i] = b[i - 1] + d[i];
//        if (a[i] < l[i] && b[i] < r[i]) {
//            continue;
//        } else if (suf[i + 1] + l[i] >= c) {
//            a[i] = min(a[i], l[i]);
//        } else {
//            b[i] = min(b[i], r[i]);
//        }
//    }
//    if (a[n] < c) return -inf;
//    return a[n] + b[n];
//}

void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> d[i + 1];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i + 1];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i + 1];
    }
    cin >> a[0] >> b[0];
    vector<int> as, bs;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        as.emplace_back(l[i + 1]);
        bs.emplace_back(r[i + 1]);
    }
    bs.emplace_back(0);
    bs.emplace_back(0);
    bs.emplace_back(inf);
    as.emplace_back(0);
    as.emplace_back(0);
    as.emplace_back(inf);
    std::sort(as.begin(), as.end());
    std::sort(bs.begin(), bs.end());
//    int u1 = -1, u2 = (int)as.size();
//    while (u1 != u2 - 1) {
//        int mid = (u1 + u2) / 2;
//        if (check(mid - 1) > check(mid)) {
//            ;
//        }
//    }
    vector<int> suf(n + 2);
    for (int i = n; i >= 1; --i) {
        suf[i] = suf[i + 1] + d[i];
    }
    for (auto c: as) {
        for (int j = 1; j <= n; ++j) {
            a[j] = a[j - 1] + d[j];
            b[j] = b[j - 1] + d[j];
            if (l[j] >= a[j]) a[j] = min(a[j], l[j]);
            else if (r[j] >= b[j]) b[j] = min(b[j], r[j]);
            else if (l[j] + suf[j + 1] >= c) a[j] = min(a[j], l[j]);
            else b[j] = min(b[j], r[j]);
        }
        ans = max(ans, a[n] + b[n]);
    }
    for (auto c: bs) {
        for (int j = 1; j <= n; ++j) {
            a[j] = a[j - 1] + d[j];
            b[j] = b[j - 1] + d[j];
            if (l[j] >= a[j]) a[j] = min(a[j], l[j]);
            else if (r[j] >= b[j]) b[j] = min(b[j], r[j]);
            else if (r[j] + suf[j + 1] >= c) b[j] = min(b[j], r[j]);
            else a[j] = min(a[j], l[j]);
        }
        ans = max(ans, a[n] + b[n]);
    }
    for (auto c: as) {
        for (int j = 1; j <= n; ++j) {
            a[j] = a[j - 1] + d[j];
            b[j] = b[j - 1] + d[j];
            if (l[j] >= a[j]) a[j] = min(a[j], l[j]);
            else if (r[j] >= b[j]) b[j] = min(b[j], r[j]);
            else if (l[j] >= c) a[j] = min(a[j], l[j]);
            else b[j] = min(b[j], r[j]);
        }
        ans = max(ans, a[n] + b[n]);
    }
    for (auto c: bs) {
        for (int j = 1; j <= n; ++j) {
            a[j] = a[j - 1] + d[j];
            b[j] = b[j - 1] + d[j];
            if (l[j] >= a[j]) a[j] = min(a[j], l[j]);
            else if (r[j] >= b[j]) b[j] = min(b[j], r[j]);
            else if (r[j] >= c) b[j] = min(b[j], r[j]);
            else a[j] = min(a[j], l[j]);
        }
        ans = max(ans, a[n] + b[n]);
    }
    for (int i = 1; i <= n; ++i) {
        a[i] = a[i - 1] + d[i];
        b[i] = b[i - 1] + d[i];
        if (a[i] <= l[i] || b[i] <= r[i]) continue;
        b[i] = min(b[i], r[i]);
    }
    ans = max(ans, a[n] + b[n]);
    for (int i = 1; i <= n; ++i) {
        a[i] = a[i - 1] + d[i];
        b[i] = b[i - 1] + d[i];
        if (a[i] <= l[i] || b[i] <= r[i]) continue;
        a[i] = min(a[i], l[i]);
    }
    ans = max(ans, a[n] + b[n]);
    cout << ans << '\n';
}

signed main() {
    int _o = 1, _g;
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    iostream::ios_base::sync_with_stdio(0);
    cin.tie(0);
//    cin >> _o;
    while (_o--) {
        solve();
    }
    return 0;
}
