//#pragma GCC target("avx2", "avx")
//#pragma GCC optimize("Ofast", "inline", "unrool-loops", "sse", "sse2", "sse3", "ssse3", "sse4")

#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <unordered_map>
#include <set>
#include <string>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define int long long

static const int inf = 1e15 + 7, mod1 = 1e9 + 7;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin() (x).rend()

mt19937 rnd;

void solve() {
    int n;
    cin >> n;
    vector<int> d(n);
    for (auto &c : d) {
        cin >> c;
    }
    vector<int> l(n);
    for (auto &c : l) {
        cin >> c;
    }
    vector<int> r(n);
    for (auto &c : r) {
        cin >> c;
    }
    int a, b;
    cin >> a >> b;
    vector<int> A(n + 1), B(n + 1);
    A[0] = a, B[0] = b;
    for (int i = 1; i <= n; i++) {
        A[i] = A[i - 1] + d[i - 1];
        B[i] = B[i - 1] + d[i - 1];
        if (min(A[i], l[i - 1]) + B[i] < A[i] + min(B[i], r[i - 1])) {
            B[i] = min(B[i], r[i - 1]);
        } else {
            A[i] = min(A[i], l[i - 1]);
        }
    }
    cout << A[n] + B[n];
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
