//#pragma GCC target("avx2", "avx")
//#pragma GCC optimize("Ofast", "inline", "unrool-loops", "sse", "sse2", "sse3", "ssse3", "sse4")

#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <unordered_map>
#include <set>
#include <string>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define int long long

static const int inf = 1e15 + 7, mod1 = 1e9 + 7;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin() (x).rend()

mt19937 rnd;

string s;
int n;
vector<int> d;
vector<int> l;
vector<int> r;
int a, b;
int ans = 0;


void solve() {
    cin >> n;
    d.resize(n);
    for (auto &c: d) {
        cin >> c;
    }
    l.resize(n);
    for (auto &c: l) {
        cin >> c;
    }
    r.resize(n);
    for (auto &c: r) {
        cin >> c;
    }
    cin >> a >> b;
    vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>>(3));
    dp[0][0] = {a, b};
    dp[0][1] = {a, b};
    dp[0][2] = {a, b};
    for (int i = 1; i <= n; i++) {
        a = dp[i - 1][0].first, b = dp[i - 1][1].second;
        a += d[i - 1], b += d[i - 1];
        if (a < l[i - 1] && b < r[i - 1]) {
            if (a + b >= dp[i][0].first + dp[i][1].second) {
                dp[i][0] = {a, b};
            }
        }
        if (a >= l[i - 1] && a + min(b, r[i - 1]) >= dp[i][1].first + dp[i][1].first) {
            dp[i][1].first = a;
            dp[i][1].second = min(b, r[i - 1]);
        }
        if (b >= r[i - 1] && min(a, l[i - 1]) + b >= dp[i][2].second + dp[i][2].first) {
            dp[i][2].first = min(a, l[i - 1]);
            dp[i][2].second = b;
        }
        a = dp[i - 1][1].first, b = dp[i - 1][1].second;
        a += d[i - 1], b += d[i - 1];
        if (a < l[i - 1] && b < r[i - 1]) {
            if (a + b >= dp[i][0].first + dp[i][1].second) {
                dp[i][0] = {a, b};
            }
        }
        if (a >= l[i - 1] && a + min(b, r[i - 1]) >= dp[i][1].first + dp[i][1].first) {
            dp[i][1].first = a;
            dp[i][1].second = min(b, r[i - 1]);
        }
        if (b >= r[i - 1] && min(a, l[i - 1]) + b >= dp[i][2].second + dp[i][2].first) {
            dp[i][2].first = min(a, l[i - 1]);
            dp[i][2].second = b;
        }
        a = dp[i - 1][2].first, b = dp[i - 1][2].second;
        a += d[i - 1], b += d[i - 1];
        if (a < l[i - 1] && b < r[i - 1]) {
            if (a + b >= dp[i][0].first + dp[i][1].second) {
                dp[i][0] = {a, b};
            }
        }
        if (a >= l[i - 1] && a + min(b, r[i - 1]) >= dp[i][1].first + dp[i][1].first) {
            dp[i][1].first = a;
            dp[i][1].second = min(b, r[i - 1]);
        }
        if (b >= r[i - 1] && min(a, l[i - 1]) + b >= dp[i][2].second + dp[i][2].first) {
            dp[i][2].first = min(a, l[i - 1]);
            dp[i][2].second = b;
        }
    }
    cout << max(dp[n][0].first + dp[n][0].second,
                max(dp[n][1].first + dp[n][1].second, dp[n][2].first + dp[n][2].second));
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
