#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define vec vector
#define F first
#define S second

#ifdef home
#define dbg(x) cout << #x << " = " << x << endl
#else
#define dbg(x) 57
#endif

using ll = long long;
using uint64 = unsigned long long;
using pii = pair<int, int>;

template<typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) {
        is >> x;
    }
    return is;
}

template<typename T>
ostream& operator << (ostream &os, vector<T> &v) {
    for (auto &x : v) {
        os << x << " ";
    }
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream &is, pair<T1, T2> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T1, typename T2>
ostream& operator << (ostream &os, pair<T1, T2> &v) {
    os << "{" << v.first << ", " << v.second << "}";
    return os;
}

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

int getRng (int l, int r) {
    return rng() % (r - l + 1) + l;
}

void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1, 0), l(n + 1), r(n + 1);

    for (int i = 1; i <= n; i++) {
        cin >> d[i];
    }

    for (int i = 1; i <= n; i++) {
        cin >> l[i];
    }

    for (int i = 1; i <= n; i++) {
        cin >> r[i];
    }

    cin >> l[0] >> r[0];

    int ans = -1e18;

    for (int last = 0; last <= n; last++) {
        // последний для a - l[last]

        vector<int> operations(last + 1, 0);

        int a = l[last];

        operations[last] = 0;

        for (int i = last - 1; i >= 0; i--) {
            a -= d[i + 1];
            if (l[i] < a) {
                operations[i] = 1;
            } else {
                operations[i] = 0;
            }
        }

        if (a > l[0]) {
            continue;
        }

        int b = r[0];

        for (int j = 1; j <= last; j++) {
            b += d[j];
            if (operations[j] == 1) {
                b = min(b, r[j]);
            }
        }

        a = l[last];

        for (int j = last + 1; j <= n; j++) {
            a += d[j];
            b += d[j];

            if (a <= l[j]) {
                // nothing
            } else {
                b = min(b, r[j]);
            }
        }

        ans = max(ans, a + b);

//        cout << last << " " << ans << endl;
    }

    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef home
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}