//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <vector>
#include <deque>
#include <ctime>
#include <unordered_set>
#include <iomanip>
#include <algorithm>
using namespace std;
#define double long double
#define int long long
#define ll long long
#define debug(x) cerr << (#x) << ": " << x << endl;
#define get_time (double)(clock()) / (double)(CLOCKS_PER_SEC)
const int INF = 1e18 + 7;
const int mod = 1e9 + 7;
const int MAXN = 2e5 + 10;
//#pragma GCC optimize("avx2")
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
int make_add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int n;
vector<int> d, a, b;
vector<int> pref_sum;
int a0, b0;
int ans = -INF;
void calc() {
    vector<pair<int, int> > all;
    for (int i = 0; i < n; i++) {
        all.push_back({ a[i] - pref_sum[i + 1], i });
    }
    sort(all.begin(), all.end());
    vector<int> can(n, 1);
    for (int i = 0; i < n; i++) {
        int ind = all[i].second;
        int may = a[ind] + pref_sum[n] - pref_sum[ind + 1];
        can = vector<int>(n, 1);
        for (int j = 0; j < i; j++) {
            if (all[j].first <= all[i].first) can[all[j].second] = 0;
        }
        int next = b0;
        for (int j = 0; j < n; j++) {
            int p = INF;
            if (can[j] == 0) p = b[j];
            next = min(next + d[j], p);
        }
        int s = pref_sum[ind + 1];
        may += next;
        if (a0 + s >= a[ind]) ans = max(ans, may);
        can[ind] = 0;
    }
}
/*
void calc() {
    for (int i = 0; i < n; i++) {
        int s = pref_sum[i + 1];
        if (a0 + s < a[i]) continue;
        int next = a[i];
        vector<int> can(n, 1);
        for (int j = i + 1; j < n; j++) {
            next = next + d[j];
            if (next > a[j]) can[j] = 0;

        }
        int may = next;
        next = a0;
        for (int j = 0; j < i; j++) {
            next = next + d[j];
            if (next <= a[j]) continue;
            int op = a[j] + pref_sum[i + 1] - pref_sum[j + 1];
            if (op < a[i]) {
                can[j] = 0;
                continue;
            }
            next = min(a[j], next);
        }
        next = b0;
        for (int j = 0; j < n; j++) {
            int p = INF;
            if (can[j] == 0) p = b[j];
            next = min(next + d[j], p);
        }
        may += next;
        ans = max(ans, may);
    }
}
*/
void solve() {
    cin >> n;
    d = vector<int>(n);
    a = vector<int>(n);
    b = vector<int>(n);
    pref_sum = vector<int>(n + 1);
    for (int i = 0; i < n; i++) cin >> d[i];
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    cin >> a0 >> b0;
    for (int i = 0; i < n; i++) {
        pref_sum[i + 1] = pref_sum[i] + d[i];
    }
    calc();
    swap(a, b);
    swap(a0, b0);
    calc();
    cout << ans << endl;
}
signed main() {
    cout << fixed << setprecision(20);
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
/*
3 1 5
1 2
2 5
4 6
7 8
9 11
*/