#include <bits/stdc++.h>
#define int long long

using namespace std;
using ll = long long;
using db = double;

struct Input {
    int n;
    vector<int> d, l, r;
    int a0, b0;
};

Input input() {
    int n; cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) cin >> d[i];
    for (int i = 0; i < n; ++i) cin >> l[i];
    for (int i = 0; i < n; ++i) cin >> r[i];
    int a0, b0; cin >> a0 >> b0;
    return {n, d, l, r, a0, b0};
}

int smartSolve(Input inp) {
    auto [n, d, l, r, a0, b0] = std::move(inp);
    int aNow = a0, bNow = b0;
    for (int i = 0; i < n; ++i) {
        aNow += d[i];
        bNow += d[i];
        int ra = aNow - min(aNow, l[i]);
        int rb = bNow - min(bNow, r[i]);
        if (ra < rb) {
            aNow = min(aNow, l[i]);
        } else {
            bNow = min(bNow, r[i]);
        }
    }
    return aNow + bNow;
}

int stupidSolve(Input inp) {
    auto [n, d, l, r, a0, b0] = std::move(inp);
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int aNow = a0, bNow = b0;
        for (int i = 0; i < n; ++i) {
            aNow += d[i];
            bNow += d[i];
            if (mask & (1 << i)) {
                bNow = min(bNow, r[i]);
            } else {
                aNow = min(aNow, l[i]);
            }
        }
        ans = max(ans, aNow + bNow);
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cout << stupidSolve(input());
    return 0;
}
