#include <bits/stdc++.h>
using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream& cin, ostream& cout);


int test_cnt = 1, group, cur_test;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    // cin >> test_cnt;
    // cin >> group;
    for (cur_test = 0; cur_test < test_cnt; ++cur_test)
        solve(cin, cout);
}


vector<ll> d, l, r;
ll n, a0, b0;
ll res = -INF;


void dfs(const ll i, ll a, ll b) {
    if (i == n) {
        res = max(res, a + b);
        return;
    }
    a += d[i];
    b += d[i];
    dfs(i + 1, min(a, l[i]), b);
    dfs(i + 1, a, min(b, r[i]));
}


void solve(istream& cin, ostream& cout) {
    cin >> n;
    d.resize(n);
    l.resize(n);
    r.resize(n);
    for (auto& t : d)
        cin >> t;
    for (auto& t : l)
        cin >> t;
    for (auto& t : r)
        cin >> t;
    cin >> a0 >> b0;

    dfs(0, a0, b0);
    cout << res << '\n';
}
