#include<iostream>
#include<vector>
#include<string>
#include<map>
#include<set>
#include<deque>
#include<stack>
#include<queue>
#include<bitset>
#include<iomanip>
#include<cmath>
#include<algorithm>
using namespace std;

const int INF = 1e9;

struct DP {
	int a, b;

	DP operator+(const int& x) const {
		return { a + x, b + x };
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	//B Vito Corleone

	int n, a0, b0;
	cin >> n;

	vector<int> d(n), l(n), r(n);

	for (int i = 0; i < n; ++i) {
		cin >> d[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> r[i];
	}
	cin >> a0 >> b0;

	if (n <= 15) {
		long long ans = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			long long a = a0, b = b0;
			for (int i = 0; i < n; ++i) {
				a += d[i];
				b += d[i];
				if (mask & (1 << i)) {
					a = min(a, 1ll * l[i]);
				}
				else {
					b = min(b, 1ll * r[i]);
				}
			}
			ans = max(ans, a + b);
		}

		cout << ans;

		return 0;
	}
	if (d[0] == 0) {
		
		vector<pair<int, int>> ll(n), rr(n);

		for (int i = 0; i < n; ++i) {
			ll[i] = { l[i], i };
			rr[i] = { r[i], i };
		}
		ll.push_back({ a0, -1 });
		rr.push_back({ b0, -1 });

		sort(ll.begin(), ll.end());
		sort(rr.begin(), rr.end());


		int ans = 0;
		for (int i = 0; i <= n; ++i) {
			for (int j = 0; j < n; ++j) {
				if (rr[j].second) {
					ans = max(ans, ll[i].first + rr[j].first);
				}
			}
			if (ll[i].second <= 0) {
				break;
			}
		}

		for (int i = 0; i <= n; ++i) {
			for (int j = 0; j < n; ++j) {
				if (ll[j].second) {
					ans = max(ans, ll[j].first + rr[i].first);
				}
			}
			if (rr[i].second <= 0) {
				break;
			}
		}

		cout << ans;

		return 0;
	}

	return 0;
}