#include<iostream>
#include<vector>
#include<string>
#include<map>
#include<set>
#include<deque>
#include<stack>
#include<queue>
#include<bitset>
#include<iomanip>
#include<cmath>
#include<algorithm>
using namespace std;

const int INF = 1e9;

struct edge {

	int a, b;

	bool operator<(const edge& other) const {
		if (a == other.a) {
			return b < other.b;
		}
		return a < other.a;
	}
};

set<edge> g1, g2;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	//A Peter Parker

	int t, group;
	cin >> t >> group;

	while (t--) {
		int n, m1, m2;
		cin >> n >> m1 >> m2;

		for (int i = 0; i < m1; ++i) {
			int a, b;
			cin >> a >> b;
			g1.insert({ a, b });
		}
		for (int i = 0; i < m2; ++i) {
			int a, b;
			cin >> a >> b;
			g2.insert({ a, b });
		}

		cout << "Yes\n";
		vector<pair<int, int>> ans;
		for (int i = 1; i < n; ++i) {
			if (g1.find({ i, i + 1 }) == g1.end() && g1.find({i + 1, i}) == g1.end()) {
				ans.push_back({ i, i + 1 });
			}
		}
		cout << ans.size() << '\n';
		for (auto e: ans) {
			cout << e.first << ' ' << e.second << '\n';
		}
	}

	return 0;
}