#include <iostream>
#include <vector>
#include <map>
using namespace std;

long long n;
vector<long long> d;
vector<long long> l;
vector<long long> r;
map<vector<long long>, long long> mem;

long long f(long long id, long long a, long long b) {
    if (id == n)
        return a + b;
    if (mem.find({a, b, id}) != mem.end())
        return mem[{a, b, id}];
    if (a + d <= l[i])
        return mem[{id, a, b}] = f(id + 1, a + d, b);
    else if (b + d <= r[i])
        return mem[{id, a, b}] = f(id + 1, a, b + d);
    return mem[{id, a, b}] = max(f(id + 1, a + d, b), f(id + 1, a, b + d));
}

int main() {
    long long a0, b0;
    cin >> n;
    d.resize(n);
    l.resize(n);
    r.resize(n);
    for (long long i = 0; i < n; i++)
        cin >> d[i];
    for (long long i = 0; i < n; i++)
        cin >> l[i];
    for (long long i = 0; i < n; i++)
        cin >> r[i];
    cin >> a0 >> b0;
    cout << f(0, a0, b0);
}
