#include <bits/stdc++.h>
#define int long long

/* Using libraries */
using namespace std;

using ld = long double;
template <class T>
using vc = vector <T>;
using pii = pair <int, int>;
using pint = pair <int, int>;
template <class T>
int sz(vc <T> &a) {
    return (int)a.size();
}
int sz(string &a) {
    return (int)a.size();
}

template<class T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9;
template<class T>
bool chmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

struct node {
    int suf = 0, pref = 0;
    int f = 1, sum = 0, len = 0;
    node () {}
};
int d;

node merge (node a, node b) {
    node c;
    c.sum = a.sum + b.sum;
    c.len = a.len + b.len;
    c.f = a.f && b.f;
    if (c.sum == 0) {
        c.pref = c.suf = c.len;
        return c;
    }
    if (a.sum == 0) {
        c.pref = b.pref + a.len;
        c.suf = b.suf;
        return c;
    }
    if (b.sum == 0) {
        c.pref = a.pref;
        c.suf = a.suf + b.len;
        return c;
    }
    c.pref = a.pref;
    c.suf = b.suf;
    if (a.suf + b.pref + 1 > d)
        c.f = 0;
    return c;
}

const int N = 3e5;
int t[N * 4];

void upd (int v, int tl, int tr, int i, int x) {
    if (tr - tl == 1) {
        t[v] = x;
    } else {
        int tm = (tl + tr) / 2;
        if (i < tm)
            upd(v << 1, tl, tm, i, x);
        else
            upd(v << 1 | 1, tm, tr, i, x);
        t[v] = max(t[v << 1], t[v << 1 | 1]);
    }
}

int get (int v, int tl, int tr, int l, int r) {
    if (tr <= l || r <= tl) return 0;
    if (l <= tl && tr <= r) return t[v];
    int tm = (tl + tr) / 2;
    return max(get(v << 1, tl, tm, l, r), get(v << 1 | 1, tm, tr, l, r));
}

void solve() {
    int n;
    cin >> n;
    vc <int> d(n), l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    int a0, b0;
    cin >> a0 >> b0;
    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            if (i == j)
                continue;
            int a = (i == 0 ? a0 : min(a0, l[i - 1]));
            int b = (j == 0 ? b0 : min(b0, r[j - 1]));
            int f = 0;
            for (int k = max(i, j); k < n; ++k) {
                if (a > l[k] && b > r[k]) {
                    f = 1;
                    break;
                }
            }
            if (!f) {
                chmax(ans, a + b);
            }
        }
    }
    cout << ans << '\n';
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}