//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt,fma")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const long long RANDOM = chrono::high_resolution_clock::now().time_since_epoch().count();
constexpr int MAXN = 1 << 20;
constexpr long long mod = 1e9 + 7;
mt19937 rnd(RANDOM);

ll sum(pair<ll, ll> &a) {
    return a.first + a.second;
}

void solve() {
    int n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (auto &i: d) {
        cin >> i;
    }
    for (auto &i: l) {
        cin >> i;
    }
    for (auto &i: r) {
        cin >> i;
    }
    std::reverse(d.begin(), d.end());
    d.push_back(0);
    std::reverse(d.begin(), d.end());
    std::reverse(l.begin(), l.end());
    l.push_back(0);
    std::reverse(l.begin(), l.end());
    std::reverse(r.begin(), r.end());
    r.push_back(0);
    std::reverse(r.begin(), r.end());
    ll a0, b0;
    cin >> a0 >> b0;
    ll ans = -1;
    for (int i = 0; i < (1 << n); i++) {
        ll a = a0, b = b0;
        for (int j = 1; j <= n; j++) {
            if ((1 << (j - 1)) & i) {
                a = min(a + d[j], l[j]);
                b = b + d[j];
            } else {
                a = a + d[j];
                b = min(b + d[j], r[j]);
            }
        }
        ans = max(ans, a + b);
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
//    cin>>q;
    while (q--) {
        solve();
    }
}
