//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt,fma")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const long long RANDOM = chrono::high_resolution_clock::now().time_since_epoch().count();
constexpr int MAXN = 1 << 20;
constexpr long long mod = 1e9 + 7;
mt19937 rnd(RANDOM);

void tl(int n) {
//    int n;
//    cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (auto &i: d) {
        cin >> i;
    }
    for (auto &i: l) {
        cin >> i;
    }
    for (auto &i: r) {
        cin >> i;
    }
    std::reverse(d.begin(), d.end());
    d.push_back(0);
    std::reverse(d.begin(), d.end());
    std::reverse(l.begin(), l.end());
    l.push_back(0);
    std::reverse(l.begin(), l.end());
    std::reverse(r.begin(), r.end());
    r.push_back(0);
    std::reverse(r.begin(), r.end());
    ll a0, b0;
    cin >> a0 >> b0;
    ll ans = -1;
    ll way = 0;
    for (int i = 0; i < (1 << n); i++) {
        ll a = a0, b = b0;
        for (int j = 1; j <= n; j++) {
            if ((1 << (j - 1)) & i) {
                a = min(a + d[j], l[j]);
                b = b + d[j];
            } else {
                a = a + d[j];
                b = min(b + d[j], r[j]);
            }
        }
        if (a + b > ans) {
            way = i;
            ans = a + b;
        }
    }
    cout << ans;
}


void solve() {
    int n;
//    n = N;
    cin >> n;
    if (n < 20) {
        tl(n);
        return;
    }
    vector<ll> d(n), l(n), r(n);
//    d = D, l = L, r = R;
    for (auto &i: d) {
        cin >> i;
    }
    for (auto &i: l) {
        cin >> i;
    }
    for (auto &i: r) {
        cin >> i;
    }
    vector<pair<ll, ll>> arr(n);
    for (int i = 0; i < n; i++) {
        arr[i] = {r[i], l[i]};
    }
    std::sort(arr.begin(), arr.end());
    vector<ll> p = {(ll) 1e18};
    for (auto i: arr) {
        p.push_back(min(p.back(), i.second));
    }
    ll a, b;
//    a = A0, b = B0;
    cin >> a >> b;
    ll ans = min(a, p.back()) + b;
    for (int i = 0; i < n; i++) {
        ll a1 = a, b1 = b;
        b1 = min(b1, arr[i].first);
        a1 = min(a1, p[i + 1]);
        ans = max(ans, a1 + b1);
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
//    cin>>q;
    while (q--) {
        solve();
    }
}
