#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl '\n'

typedef long long ll;
typedef long double ld;

typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 2e15 + 1;
const int MOD = 1e9 + 7;

mt19937 rnd(time(0));

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int n;
vector <int> l, r, d1;
int a, b;
vector <int> t1, t2;
int R = 1;

void build(vector <int> &t){
    for (int i = R - 1; i > 0; i--){
        t[i] = min(t[i * 2], t[i * 2 + 1]);
    }
}

int get(int ql, int qr, int nl, int nr, int node, vector <int> &t){
    if (ql >= nr || nl >= qr)
        return INF;
    if (nl >= ql && nr <= qr)
        return t[node];
    int nm = (nl + nr) / 2;
    return min(get(ql, qr, nl, nm, node * 2, t), get(ql, qr, nm, nr, node * 2 + 1, t));
}

void height(int n){
    while (R < n)
        R *= 2;
}

void gen(){
    for (int i = 1; i <= 3; i++)
        d1[i] = rnd() % 10, l[i] = rnd() % 10, r[i] = rnd() % 10;
    a = rnd() % 10, b = rnd() % 10;
}

int stupid(){
    int sum = 0;
    vector <int> d = d1;
    for (int mask = 0; mask < (1 << 3); mask++){
        int a1 = a, b1 = b;
        for (int i = 0; i < n; i++){
            a1 += d[i + 1], b1 += d[i + 1];
            if ((mask >> i) & 1)
                a1 = min(a1, l[i + 1]);
            else
                b1 = min(b1, r[i + 1]);
        }
        sum = max(sum, a1 + b1);
    }
    return sum;
}

int smart(){
    l[0] = a, r[0] = b;
    vector <int> d = d1;
    height(n + 1);
    t1.assign(2 * R, INF);
    t2.assign(2 * R, INF);
    for (int i = 1; i <= n; i++){
        d[i] += d[i - 1];
        t1[i + R] = l[i] - d[i];
        t2[i + R] = r[i] - d[i];
    }
    build(t1);
    build(t2);
    vector <pair <int, int>> dp(n + 1, {-INF, -INF});
    dp[0] = {b, a};
    int sum = 0;
//    for (int i = 1; i <= n; i++)
//        cout << t1[i + R] << " ";
//    cout << endl;
//    for (int i = 1; i <= n; i++)
//        cout << t2[i + R] << " ";
//    cout << endl;
//    for (int i = 1; i <= n; i++)
//        cout << d[i] << " ";
//    cout << endl;
    for (int i = 0; i <= n; i++){
        int a1 = l[i], b1 = dp[i].first;
//        cout << i << endl;
        if (b1 != -INF){
            a1 -= d[i];
            b1 -= d[i];
            int l1 = i, r1 = n + 1;
            for (int j = i + 1; j <= n; j++){
                if (l[j] - d[j] < a1 && r[j] - d[j] < b1)
                    break;
                l1 = j;
            }
//            if (l1 == 1) {
//                cout << 1 << " " << a + d[i] << " " << b + d[i] << " " << l1 << endl;
//                cout << get(i + 1, l1 + 1, 0, R, 1, t1) << " " << get(i + 1, l1 + 1, 0, R, 1, t2) << endl;
//            }
            if (l1 + 1 <= n){
                dp[l1 + 1].first = max(dp[l1 + 1].first, b1 + d[l1 + 1]);
                dp[l1 + 1].second = max(dp[l1 + 1].second, a1 + d[l1 + 1]);
            }
            if (l1 == n)
                sum = max(sum, a1 + b1 + 2 * d[n]);
        }
        a1 = dp[i].second, b1 = r[i];
        if (a1 != -INF){
            a1 -= d[i];
            b1 -= d[i];
            int l1 = i;
            for (int j = i + 1; j <= n; j++){
                if (l[j] - d[j] < a1 && r[j] - d[j] < b1)
                    break;
                l1 = j;
            }
//            if (l1 == 1) {
//                cout << 2 << " " << a + d[i] << " " << b + d[i] << " " << l1 << endl;
//                cout << get(i + 1, l1 + 2, 0, R, 1, t1) << " " << get(i + 1, l1 + 2, 0, R, 1, t2) << endl;
//            }
            if (l1 + 1 <= n){
                dp[l1 + 1].first = max(dp[l1 + 1].first, b1 + d[l1 + 1]);
                dp[l1 + 1].second = max(dp[l1 + 1].second, a1 + d[l1 + 1]);
            }
            if (l1 == n)
                sum = max(sum, a1 + b1 + 2 * d[n]);
        }
    }
//    for (auto i:dp)
//        cout << i.first << " " << i.second << endl;
//    cout << endl;
    return max({sum, l[n] + dp[n].first, r[n] + dp[n].second});
}

signed main() {
    Fast();
    cin >> n;
    d1.resize(n + 1);
    l.resize(n + 1);
    r.resize(n + 1);
    for (int i = 1; i <= n; i++)
            cin >> d1[i];
    for (int i = 1; i <= n; i++)
        cin >> l[i];
    for (int i = 1; i <= n; i++)
        cin >> r[i];
    cin >> a >> b;
    cout << smart();
//    n = 3;
//    d1.resize(4), l.resize(4), r.resize(4);
//    while (true){
//        gen();
//        int ans1 = stupid();
//        int ans2 = smart();
//        if (ans1 != ans2){
//            for (auto i:d1)
//                cout << i << " ";
//            cout << endl;
//            for (auto i:l)
//                cout << i << " ";
//            cout << endl;
//            for (auto i:r)
//                cout << i << " ";
//            cout << endl;
//            cout << a << " " << b << endl;
//            cout << ans1 << " " << ans2 << endl;
//            return 0;
//        }
//    }
    return 0;
}

/*
3
0 5 5
0 9 3
5 9 8
2 5
 */
