#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (ll &i : d) {
        cin >> i;
    }
    for (ll &i : l) {
        cin >> i;
    }
    for (ll &i : r) {
        cin >> i;
    }
    vector<ll> a(n + 1), b(n + 1);
    cin >> a[0] >> b[0];
    vector<vector<pair<ll, ll>>> dp(n + 1, vector<pair<ll, ll>> (2));
    dp[0][0] = {a[0], b[0]};
    dp[0][1] = {a[0], b[0]};
    for (int i = 0; i < n; ++i) {
        auto [a1, b1] = dp[i][0];
        auto [a2, b2] = dp[i][1];
        if (min(a1 + d[i], l[i]) + b1 + d[i] >
                           min(a2 + d[i], l[i]) + b2 + d[i]) {
            dp[i + 1][0] = {min(a1 + d[i], l[i]), b1 + d[i]};
        } else {
            dp[i + 1][0] = {min(a2 + d[i], l[i]), b2 + d[i]};
        }
        if (min(b1 + d[i], r[i]) + a1 + d[i] >
            min(b2 + d[i], r[i]) + a2 + d[i]) {
            dp[i + 1][1] = {a1 + d[i], min(b1 + d[i], r[i])};
        } else {
            dp[i + 1][1] = {a2 + d[i], min(b2 + d[i], r[i])};
        }
    }
    auto [a1, b1] = dp[n][0];
    auto [a2, b2] = dp[n][1];
    cout << max(a1 + b1, a2 + b2);
}