#include <iostream>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (ll &i : d) {
        cin >> i;
    }
    for (ll &i : l) {
        cin >> i;
    }
    for (ll &i : r) {
        cin >> i;
    }
    int a, b;
    cin >> a >> b;
    ll ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        ll x = a, y = b;
        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {
                x = min(x + d[i], l[i]);
                y += d[i];
            } else {
                x += d[i];
                y = min(y + d[i], r[i]);
            }
        }
        ans = max(ans, x + y);
    }
    cout << ans;
}