#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ordered_set = tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update>;

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define dbg(a) cout << #a << " = " << a << endl;
#define dbg1(a) cout << #a << " = "; for (auto i : a) cout << i << ' '; cout << endl;
#define dbg2(a) cout << #a << " = "; for (auto [x, y] : a) cout << "{ " << x << ' ' << y << "} "; cout << endl;

const int INF = 1e9 + 7;
const int mod = 1e9 + 7;

const int N = 1e5 + 3;
ll L[N], R[N], D[N], pref[N];
ll dp[2][N];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> D[i];
    for (int i = 1; i <= n; i++)
        cin >> L[i];
    for (int i = 1; i <= n; i++)
        cin >> R[i];

    int a0, b0;
    cin >> a0 >> b0;
    L[0] = a0;
    R[0] = b0;
    dp[0][0] = b0;

    for (int i = 1; i <= n; i++)
        pref[i] = pref[i - 1] + D[i - 1];

    for (int i = 1; i <= n; i++) {
        int ci = i & 1, pri = ci ^ 1;
        fill(dp[ci], dp[ci] + n, 0);
        for (int j = 0; j < i; j++) {
            if (pref[i + 1] - pref[j] + L[j] <= L[i - 1])
                dp[ci][j] = dp[pri][j];
            else
                dp[ci][j] = max(dp[ci][j], min(dp[pri][j] + D[i - 1], R[i - 1]));

            dp[ci][i] = max(dp[ci][i], dp[pri][j] + D[i - 1]);
        }
    }

    ll ans = 0;
    ll smD = 0;
    for (int prev = n; prev >= 0; prev--) {
        //dbg(dp[n & 1][prev]);
        ans = max(ans, dp[n & 1][prev] + smD + L[prev]);
        if (prev != 0)
            smD += D[prev - 1];
    }

    cout << ans << '\n';
}

int main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
