// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <numeric>
#include <bitset>
#include <utility>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ld = long double;
#define int ll

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n;
    cin >> n;
    vector <int>d(n), l(n), r(n);
    for (auto& i : d)
    {
        cin >> i;
    }
    for (auto& i : l)
    {
        cin >> i;
    }
    for (auto& i : r)
    {
        cin >> i;
    }
    int a0, b0;
    cin >> a0 >> b0;
    //l.insert(l.begin(), a0);
    //r.insert(r.begin(), b0);
    //d.insert(d.begin(), 0);
    set<pair<int, int>> oper; // {a0,id}
    vector <int> pref(n);
    partial_sum(d.begin(), d.end(), pref.begin());
    for (size_t i = 0; i < n; i++)
    {
        oper.emplace(l[i] - pref[i], i);
    }
    int best = 0;
    int curb = b0;
    while (!oper.empty())
    {
        int cura = min(oper.begin()->first, a0);
        best = max(best, cura + pref.back() + curb + pref.back());
        curb = min(curb, r[oper.begin()->second] - pref[oper.begin()->second]);
        oper.erase(oper.begin());
    }
    best = max(best, a0 + curb + pref.back() * 2ll);
    cout << best << '\n';
    return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
