#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll INF = 1e18, N = 1e5 + 1;

struct str {
    ll d, l, r;
};

vector<str> v(N);

ll a, b, n;

ll get(ll x){
    vector<ll> d(n);
    for(ll i = n - 1; i >= 0; i--){
        if(x <= v[i].l){
            d[i] = 1;
        }
        x -= v[i].d;
    }
    ll c = b;
    for(ll i = 0; i < n; i++){
        c += v[i].d;
        if(!d[i]){
            c = min(c, v[i].r);
        }
    }
    return c;
}

void solve(){
    ll s = 0;
    cin >> n;
    for(ll i = 0; i < n; i++){
        cin >> v[i].d;
        s += v[i].d;
    }
    for(ll i = 0; i < n; i++){
        cin >> v[i].l;
    }
    for(ll i = 0; i < n; i++){
        cin >> v[i].r;
    }
    cin >> a >> b;
    ll l = 0, r = a + s;
    while(r - l > 2){
        ll m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
        if(get(m1) + m1 < get(m2) + m2){
            l = m1;
        } else {
            r = m2;
        }
    }
    ll ans = 0;
    for(ll i = l; i <= r; i++){
        ans = max(ans, i + get(i));
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    while(t--){
        solve();
    }
}
