#include <bits/stdc++.h>
#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (auto& el : d)
        cin >> el;
    for (auto& el : l)
        cin >> el;
    for (auto& el : r)
        cin >> el;
    int cura, curb;
    cin >> cura >> curb;
    vector<int> prefsum(n);
    for (int i = 0; i < n; ++i)
        prefsum[i] = d[i] + (i ? prefsum[i - 1] : 0);
    if (prefsum.back() == 0) {
        vector<pair<int, int>> tmp(n);
        for (int i = 0; i < n; ++i)
            tmp[i] = { l[i], r[i] };
        sort(tmp.begin(), tmp.end());
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            ans = max(ans, min(cura, tmp[i].first) + curb);
            curb = min(curb, tmp[i].second);
        }
        ans = max(ans, cura + curb);
        cout << ans;
        return 0;
    }
    auto get = [&](int l, int r) {
        if (l > r)
            return 0ll;
        return prefsum[r] - (l ? prefsum[l - 1] : 0);
        };
    int ans = 0;
    int tmpa = cura, tmpb = curb;
    for (int i = 0; i < n; ++i) {
        tmpa += d[i], tmpb += d[i];
        if (tmpa > l[i])
            tmpb = min(tmpb, r[i]);
    }
    ans = max(ans, tmpa + tmpb);
    for (int lasta = 0; lasta < n; ++lasta) {
        if (cura + get(0, lasta) < l[lasta])
            continue;
        vector<int> lasts;
        lasts.push_back(lasta);
        vector<int> mustb(n);
        for (int i = lasta - 1; i >= 0; --i) {
            bool flag = false;
            for (auto el : lasts) {
                if (l[i] + get(i + 1, el) >= l[el]) {
                    flag = true;
                    break;
                }
            }
            if (!flag)
                mustb[i] = true;
            else
                lasts.push_back(i);
        }
        int b = curb;
        for (int i = 0; i < lasta; ++i) {
            b += d[i];
            if (mustb[i])
                b = min(b, r[i]);
        }
        int a = l[lasta];
        b += d[lasta];
        for (int i = lasta + 1; i < n; ++i) {
            a += d[i], b += d[i];
            if (a > l[i])
                b = min(b, r[i]);
        }
        ans = max(ans, a + b);
    }
    cout << ans;
}