#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (ll i = 0; i < n; ++i) {
        cin >> d[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> r[i];
    }
    ll a0, b0;
    cin >> a0 >> b0;

    ll cur_sum = 0;
    for (ll i = 0; i < n; ++i) {
        cur_sum += d[i];
        l[i] -= cur_sum + a0;
        r[i] -= cur_sum + b0;
        //cout << l[i] << ' ' << r[i] << '\n';
    }
    vector<pair<ll, ll>> lr(n);
    for (ll i = 0; i < n; ++i) {
        lr[i] = {l[i], r[i]};
    }
    sort(lr.begin(), lr.end());

    //cout << '\n';
    //for (auto p : lr) {
    //    cout << p.first << ' ' << p.second << '\n';
    //}
    //cout << '\n';

    ll max_sum = lr[0].first, cur_min_l, cur_min_r = 0;
    for (ll i = 0; i < n; ++i) {
        if (i == n - 1) {
            cur_min_l = 0;
        } else {
            cur_min_l = min(0ll, lr[i + 1].first);
        }
        cur_min_r = min(cur_min_r, lr[i].second);
        max_sum = max(max_sum, cur_min_l + cur_min_r);
        //cout << i << ' ' << max_sum << ' ' << cur_min_l << ' ' << cur_min_r << '\n';
    }

    cout << a0 + b0 + 2 * cur_sum + max_sum << '\n';
}
