//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("avx,avx2,sse,sse2,sse3,ssse3")
#include <bits/stdc++.h>

using namespace std;

//#define int int_fast32_t
#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map
//#define mp make_pair

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;
typedef vector<si> vsi;
typedef vector<spi> vspi;
typedef tuple<int, int, int> ti;
typedef vector<ti> vti;
typedef vector<bool> vb;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

mt19937 rnd(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());

const int MAXN = 2e5 + 10;


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	vi d(n + 1), l(n + 1), r(n + 1);
	input(d, 1);
	input(l, 1);
	input(r, 1);
	int a0, b0;
	cin >> a0 >> b0;
	vi suf(n + 2);
	suf[n + 1] = 0;
	for (int i = n; i >= 1; --i)
		suf[i] = suf[i + 1] + d[i];
	b0 += suf[1];
	vpi c;
	c.push_back({a0 + suf[1], 0});
	for (int i = 1; i <= n; ++i)
		c.push_back({l[i] + suf[i + 1], i});
	sort(all(c));
	int ans = c[0].first + b0;
	for (int i = 1; i <= n; ++i) {
		int j = c[i - 1].second;
		if (j == 0)
			break;
		minravno(b0, r[j] + suf[j + 1]);
		maxravno(ans, b0 + c[i].first);
	}
	cout << ans;

	return 0;
}