#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <random>

using namespace std;
using ll = long long;
const ll INF = 3e18;
#define endl "\n"
mt19937 rnd(3);

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll n; cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (ll i = 0; i < n; i++) cin >> d[i];
    for (ll i = 0; i < n; i++) cin >> l[i];
    for (ll i = 0; i < n; i++) cin >> r[i];
    ll a, b; cin >> a >> b;
    vector<ll> suf(n + 1, 0);
    for (ll i = n - 1; i >= 0; i--) {
        suf[i] = suf[i + 1] + d[i];
    }
    ll ma = suf[0] + a, mb = suf[0] + b;
    for (ll i = 0; i < n; i++) {
        l[i] = min(ma, l[i] + suf[i + 1]);
        r[i] = min(mb, r[i] + suf[i + 1]);
    }
    vector<pair<ll, ll>> vv;
    for (ll i = 0; i < n; i++) {
        vv.push_back({ l[i], r[i] });
    }
    sort(vv.rbegin(), vv.rend());
    ll ans = max(ma, mb);
    multiset<ll> st;
    for (auto p : r) st.insert(p);
    for (ll i = 0; i < n - 1; i++) {
        st.erase(st.find(vv[i].second));
        ll lans = vv[i].first + *st.begin();
        ans = max(ans, lans);
    }
    cout << ans << endl;
}