#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7, LOG = 20;

void solve()
{
	long long n;
	vector<long long> d, l, r;
	cin >> n;
	n++;
	d.resize(n);
	d[0] = 0;
	for (long long i = 1; i < n; i++)
	{
		cin >> d[i];
	}
	l.resize(n);
	l[0] = INF;
	for (long long i = 1; i < n; i++)
	{
		cin >> l[i];
	}
	r.resize(n);
	r[0] = INF;
	for (long long i = 1; i < n; i++)
	{
		cin >> r[i];
	}
	vector<long long> a(n), b(n);
	cin >> a[0] >> b[0];
	
	for (long long i = 1; i < n; i++)
	{
		a[i] = a[i - 1] + d[i];
		b[i] = b[i - 1] + d[i];
		if (a[i] <= l[i])
		{
			continue;
		}
		if (b[i] <= r[i])
		{
			continue;
		}

		long long dfa = a[i] - l[i];
		long long dfb = b[i] - r[i];
		if (dfa <= dfb)
		{
			a[i] = l[i];
		}
		else
		{
			b[i] = r[i];
		}
	}
	cout << a[n - 1] + b[n - 1] << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
