#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7, LOG = 20;

void solve()
{
	long long n;
	vector<long long> d, l, r;
	cin >> n;
	n++;
	d.resize(n);
	d[0] = 0;
	for (long long i = 1; i < n; i++)
	{
		cin >> d[i];
	}
	l.resize(n);
	l[0] = INF;
	for (long long i = 1; i < n; i++)
	{
		cin >> l[i];
	}
	r.resize(n);
	r[0] = INF;
	for (long long i = 1; i < n; i++)
	{
		cin >> r[i];
	}
	vector<long long> a(n), b(n);
	cin >> a[0] >> b[0];
	l[0] = a[0]; r[0] = b[0];

	vector<pair<long long, long long>> cur = { { a[0], b[0] } };
	for (long long i = 1; i < n; i++)
	{
		vector<pair<long long, long long>> nxt;
		long long mxb = -1;
		for (auto& j : cur)
		{
			long long aa = j.first + d[i], bb = j.second + d[i];
			if (aa <= l[i])
			{
				nxt.push_back({ aa, bb });
			}
			else
			{
				nxt.push_back({ aa, min(bb, r[i]) });
				mxb = max(mxb, bb);
			}
		}
		if (mxb > -1)
		{
			nxt.push_back({ l[i], mxb });
		}
		swap(cur, nxt);
	}

	long long ans = 0;
	for (auto& i : cur)
	{
		ans = max(ans, i.first + i.second);
	}
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
