#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<stack>
#include<algorithm>
#include<deque>
#include<queue>
#include<iomanip>
#include<random>
using namespace std;
#define int long long
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	cin >> n;
	int otv = 0;
	
	vector <int> d(n);
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}
	vector <int> l(n);
	vector <int> r(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> r[i];
	}
	int a0, b0;
	cin >> a0 >> b0;
	if (n <= 15) {
		for (int mask = 0; mask < (1ll << n); mask++) {
			int x = a0;
			int y = b0;
			for (int i = 0; i < n; i++) {
				if ((mask >> i) & 1) {
					x = min(x + d[i], l[i]);
					y += d[i];
				}
				else {
					y = min(y + d[i], r[i]);
					x += d[i];
				}
			}
			otv = max(otv, x + y);
		}
		cout << otv << "\n";
		return 0;
	}
	vector <int> suf(n + 1);
	vector <int> pref(n);
	pref[0] = d[0];
	for (int i = 1; i < n; i++) {
		pref[i] = pref[i - 1] + d[i];
	}
	suf[n] = 0;
	suf[n - 1] = d[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		suf[i] = (suf[i + 1] + d[i]);
	}
	int ans = 0;
	int can = a0;
	for (int i = 2; i < n - 1; i++) {
		int t = b0 + suf[0];
		can += d[i];
		for (int j = 0; j < i; j++) {
			if (l[j] + pref[i] - pref[j] < l[i]) {
				t = min(t, r[j] + suf[j + 1]);
			}
		}
		for (int j = i + 1; j < n; j++) {
			if (l[j] < l[i] + pref[j] - pref[i]) {
				t = min(t, r[j] + suf[j + 1]);
			}
		}
		if(l[i] <= can) ans = max(ans, t + l[i] + suf[i + 1]);

	}
	can = b0;
	for (int i = 0; i < n - 1; i++) {
		int t = a0 + suf[0];
		can += d[i];
		for (int j = 0; j < i; j++) {
			if (r[j] + pref[i] - pref[j] < r[i]) {
				t = min(t, l[j] + suf[j + 1]);
			}
		}
		for (int j = i + 1; j < n; j++) {
			if (r[j] < r[i] + pref[j] - pref[i]) {
				t = min(t, l[j] + suf[j + 1]);
			}
		}
		if(r[i] <= can) ans = max(ans, t + r[i] + suf[i + 1]);
	}
	cout << ans << "\n";
	return 0;
}