#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>


typedef __int128_t ll;
using namespace std;


int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr); cout.tie(nullptr);

	
	int n;
	cin >> n;
	vector<ll> d, l, r;
	d = l = r = vector<ll>(n);
	for (ll i = 0; i < n; i++) {
		long long b;
		cin >> b;
		d[i] = b;
	}
	for (ll i = 0; i < n; i++) {
		long long b;
		cin >> b;
		l[i] = b;
	}
	for (ll i = 0; i < n; i++) {
		long long b;
		cin >> b;
		r[i] = b;
	}
	vector<ll> a, b;
	a = b = vector<ll>(n + 1);
	cin >> a[0] >> b[0];
	for (ll i = 1; i < n + 1; i++) {
		ll j = i - 1;
		a[i] = a[j] + d[j];
		b[i] = b[j] + d[j];
		ll sum = a[i] + b[i];

		ll newa = min(a[i], l[j]);
		ll newb = min(b[i], r[j]);

		if (sum - a[i] + newa > sum - b[i] + newb) {
			a[i] = newa;
		}
		else {
			b[i] = newb;
		}
	}

	cout << (a[n] + b[n]) << endl;

}
