#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <random>
#include <ctime>
#include <set>
#include <map>
#include <cassert>
using namespace std;

typedef long long ll;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("../../input.txt", "r", stdin);
    freopen("../../output.txt", "w", stdout);
#endif
    int n; cin >> n;
    vector<ll> L(n, 0), D(n, 0), R(n, 0);
    for (int i = 0; i < n; i++)
        cin >> D[i];
    for (int i = 0; i < n; i++)
        cin >> L[i];
    for (int i = 0; i < n; i++)
        cin >> R[i];
    ll a, b; cin >> a >> b;
    if (n <= 15)
    {
        ll res = 0;
        for (int i = 0; i < (1 << n); i++)
        {
            vector<ll> A(n + 1, a), B(n + 1, b);
            for (int j = 0; j < n; j++)
            {
                A[j + 1] = A[j] + D[j];
                B[j + 1] = B[j] + D[j];
                if (i & (1 << j))
                    A[j + 1] = min(A[j + 1], L[j]);
                else
                    B[j + 1] = min(B[j + 1], R[j]);
            }
            res = max(res, A[n] + B[n]);
        }
        cout << res << '\n';
    }else
    {
        bool flag = true;
        for (int i = 0; i < n; i++)
        {
            if (D[i])
            {
                flag = false;
                break;
            }
        }
        if (flag)
        {
            vector<pair<ll, ll>> L_i(n), R_i(n);
            for (int i = 0; i < n; i++)
            {
                L_i[i] = {L[i], i};
                R_i[i] = {R[i], i};
            }
            sort(L_i.begin(), L_i.end());
            sort(R_i.begin(), R_i.end());
            ll res = max(a + min(R_i[0].first, b), b + min(L_i[0].first, a));
            int j = 0;
            while (j < n && R[L_i[j].second] >= b)
            {
                j++;
            }
            if (j == n)
            {
                cout << a + b << '\n';
                return 0;
            }
            res = max(res, b + min(a, L_i[j].first));j = 0;
            while (j < n && L[R_i[j].second] >= a)
            {
                j++;
            }
            if (j == n)
            {
                cout << a + b << '\n';
                return 0;
            }
            res = max(res, a + min(b, R_i[j].first));
            cout << res << '\n';
        }else
        {

        }
    }
    return 0;
}