#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define p_b push_back
#define pw(x) (1LL << (x))
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template<class T> void amin(T &a, T b) {a = a < b ? a : b;}
template<class T> void amax(T &a, T b) {a = a > b ? a : b;}

const int N = 1e5 + 5;

ll D[N], L[N], R[N];
bool here[N];

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> D[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> L[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> R[i];
    }
    cin >> L[0] >> R[0];
    ll ans = 0;
    ll a = L[0], b = R[0];
    for (int i = 0; i <= n + 1; i++) {
        ll mn = L[i];
        for (int j = i - 1; j > 0; j--) {
            if (L[j] + D[j] >= mn) {
                here[j] = 1;
                amin(mn, L[j]);
            } else {
                here[j] = 0;
            }
        }
//        if (L[0] >= mn)
//            continue;
        a = L[0], b = R[0];
        for (int j = 1; j <= n; j++) {
            a += D[j];
            b += D[j];
            if (here[j])
                amin(a, L[j]);
            else
                amin(b, R[j]);
        }
        amax(ans, a + b);
    }
    cout << ans;
}

int32_t main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // LOCAL
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    #ifdef LOCAL
        cout << "\n\n===\n\nTime : " << (long double)clock() / CLOCKS_PER_SEC << '\n';
    #endif // LOCAL
}
