#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define f first
#define s second
#define p_b push_back
#define pw(x) (1LL << (x))
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template<class T> void amin(T &a, T b) {a = a < b ? a : b;}
template<class T> void amax(T &a, T b) {a = a > b ? a : b;}

const int N = 1e5 + 5;

mt19937 rnd(time(0));

ll D[N], L[N], R[N];
array<ll, 3> dp[N][2];
bool here[N];

void solve() {
    int n;
    cin >> n;
    int cnt = 0;
    for (int i = 1; i <= n; i++) {
        cin >> D[i];
        cnt += (D[i] == 0);
    }
    for (int i = 1; i <= n; i++) {
        cin >> L[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> R[i];
    }
    cin >> L[0] >> R[0];
    auto get = [&](ll mn) {
        ll a = L[0], b = R[0];
        for (int i = 1; i <= n; i++) {
            a += D[i];
            b += D[i];
            if (min(a, L[i]) >= mn)
                amin(a, L[i]);
            else
                amin(b, R[i]);
        }
        return a + b;
    };
    ll ans = 0;
    ll l = 0, r = L[0] + accumulate(D + 1, D + n + 1, 0);
    while (l < r - 100) {
        ll m1 = l + (r - l) / 3;
        ll m2 = r - (r - l) / 3;
        if (get(m1) < get(m2))
            l = m1;
        else
            r = m2;
    }
    for (ll i = l; i <= r; i++) {
//        cout << i << ' ' << get(i) << '\n';
        amax(ans, get(i));
    }
    cout << ans;
    return;
    if (n <= 15) {
        for (int i = 0; i < pw(n); i++) {
            ll a = L[0], b = R[0];
            for (int j = 1; j <= n; j++) {
                a += D[j];
                b += D[j];
                if (pw(j - 1) & i)
                    amin(a, L[j]);
                else
                    amin(b, R[j]);
            }
            amax(ans, a + b);
        }
        cout << ans;
        return;
    }
    if (cnt == n) {
        L[n + 1] = 1e18;
        if (n <= 5000) {
            for (int i = 0; i <= n + 1; i++) {
                ll a = L[0], b = R[0];
                for (int j = 1; j <= n; j++) {
                    a += D[j];
                    b += D[j];
                    if (min(L[j], a) >= L[i])
                        amin(a, L[j]);
                    else
                        amin(b, R[j]);
                }
                amax(ans, a + b);
            }
        }
        cout << ans;
    }
}

int32_t main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // LOCAL
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    #ifdef LOCAL
        cout << "\n\n===\n\nTime : " << (long double)clock() / CLOCKS_PER_SEC << '\n';
    #endif // LOCAL
}
