#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n;
    cin >> n;

    vector <int> d(n), l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> r[i];
    }

    int a0, b0;
    cin >> a0 >> b0;

    if (n <= 15) {
        int ans = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            int cura = a0, curb = b0;
            for (int i = 0; i < n; i++) {
                cura += d[i];
                curb += d[i];
                if (mask & (1 << i)) {
                    cura = min(cura, l[i]);
                } else {
                    curb = min(curb, r[i]);
                }
            }
            ans = max(ans, cura + curb);
        }
        cout << ans << "\n";
        return;
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}