#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;
using ll = long long;

const ll mod = 1e9 + 7;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n;
    cin >> n;
    vector<ll> d(n);
    vector<pair<ll, ll>> m(n);
    for (auto& x : d) cin >> x;
    for (auto& x : m) cin >> x.first >> x.second;
    ll a, b;
    cin >> a >> b;
    m.push_back({ a, b });
    sort(m.begin(), m.end());
    ll sec = b;
    ll ans = 0;
    for (ll i = 0; i <= n && m[i].first <= a; i++) {
        sec = min(sec, m[i].second);
        ans = max(ans, sec + m[i].first);
    }
    cout << ans;
}