#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;
using ll = long long;

const ll mod = 1e9 + 7;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n;
    cin >> n;
    vector<ll> d(n);
    vector<pair<ll, ll>> m(n);
    for (auto& x : d) cin >> x;
    for (ll i = 0; i < n; i++) {
        cin >> m[i].first;
    }
    for (ll i = 0; i < n; i++) {
        cin >> m[i].second;
    }
    ll a, b;
    cin >> a >> b;
    if (n <= 15) {
        ll ans = 0;
        for (ll mask = 0; mask < (1 << n); mask++) {
            ll c1 = a, c2 = b;
            ll copy = mask;
            for (ll j = 1; j <= n; j++) {
                c1 += d[j - 1];
                c2 += d[j - 1];
                if (copy % 2 == 1) {
                    c1 = min(c1, m[j - 1].first);
                }
                else {
                    c2 = min(c2, m[j - 1].second);
                }
                copy /= 2;
            }
            ans = max(ans, c1 + c2);
        }
        cout << ans;
        return 0;
    }
    m.push_back({ a, b });
    sort(m.begin(), m.end());
    ll sec = b;
    ll ans = 0;
    for (ll i = 0; i <= n && m[i].first <= a; i++) {
        if (i) sec = min(sec, m[i - 1].second);
        ans = max(ans, sec + m[i].first);
    }
    cout << ans;
}