#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vector deque

const int maxn = 1e5 + 100;
vector<int> d(maxn, 0);
vector<int> left_lst(maxn, 0);
vector<int> right_lst(maxn, 0);



void slow_sol(int a, int b, int n) {
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        int ans_a = a + 1 - 1;
        int ans_b = b + 1 - 1;
        for (int i = 0; i < n; i++) {
            ans_a += d[i + 1];
            ans_b += d[i + 1];
            if ((mask >> i) & 1) {
                ans_a = min(ans_a, left_lst[i + 1]);
            } else {
                ans_b = min(ans_b, right_lst[i + 1]);
            }
        }
        ans = max(ans, ans_a + ans_b);
    }
    cout << ans << endl;
    exit(0);
}


void slow_d_equal_0(int a, int b, int n) {
    int ans = 0;
    left_lst[0] = a;
    right_lst[0] = b;
    for (int i = 0; i <= n; i++) {
        if (left_lst[i] <= left_lst[0]) {
            int must_be_left = left_lst[i];
            int ans_a = left_lst[0], ans_b = right_lst[0];
            for (int j = 1; j <= n; j++) {
                if (left_lst[j] < must_be_left) {
                    ans_b = min(ans_b, right_lst[j]);
                }
            }
            ans = max(ans, must_be_left + ans_b);
        }
    }
    cout << ans << endl;
    exit(0);
}


void sol_for_d_0(int a, int b, int n) {
    vector<pair<int, int>> lst;
    lst.push_back({a, b});
    for (int i = 1; i <= n; i++) {
        lst.push_back({left_lst[i], right_lst[i]});
    }
    sort(lst.begin(), lst.end());
    int ans = 0;
    int minn_right = b;
    for (int i = 0; i < lst.size(); i++) {
        if (lst[i].first <= a) {
            if (i > 0) {
                minn_right = min(minn_right, lst[i - 1].second);
            }
            ans = max(ans, lst[i].first + minn_right);
        }
    }
    cout << ans << endl;
    exit(0);
}


signed main() {
    cout.precision(15);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int max_d = 0;
    for (int i = 1; i <= n; i++) {
        cin >> d[i];
        max_d = max(max_d, d[i]);
    }
    for (int i = 1; i <= n; i++) {
        cin >> left_lst[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> right_lst[i];
    }
    int a, b;
    cin >> a >> b;
    if (max_d == 0) {
        sol_for_d_0(a, b, n);
    }
    slow_sol(a, b, n);
}
