#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <iomanip>
#include <numeric>
#include <fstream>
#include <unordered_map>
#include <random>

using namespace std;

#define int long long

void solve();


signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif


	solve();
}

using ll = long long;
using pint = pair<int, int>;

random_device rd;
mt19937 rnd(rd());

void solve() {
	int n;
	cin >> n;
	vector<int> d(n), l(n), r(n);
	for (int i = 0; i < n; i++) {
		cin >> d[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> l[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> r[i];
	}

	int ans = 0;
	int a0, b0;
	cin >> a0 >> b0;

	for (int k = 0; k < 2000000; k++) {
		vector<int> cur(n);
		for (int i = 0; i < n; i++) {
			cur[i] = rnd() % 2;
		}
		vector<int> a(n + 1), b(n + 1);
		a[0] = a0;
		b[0] = b0;
		for (int i = 0; i < n; i++) {
			a[i + 1] = a[i] + d[i];
			b[i + 1] = b[i] + d[i];
			if (cur[i]) {
				a[i + 1] = min(a[i + 1], l[i]);
			}
			else {
				b[i + 1] = min(b[i + 1], r[i]);
			}
		}
		ans = max(ans, a[n] + b[n]);
	}
	cout << ans;
}