#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <iomanip>
#include <numeric>
#include <fstream>
#include <unordered_map>
#include <random>

using namespace std;

#define int long long

void solve();


signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif

	solve();
}

using ll = long long;
using pint = pair<int, int>;

#define fi first
#define se second

random_device rd;
mt19937 rnd(rd());

const int maxn = 100100;

int a[maxn], b[maxn];
int d[maxn], l[maxn], r[maxn];
pint dp[maxn][2];

void solve() {
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> d[i];
	}
	for (int i = 1; i <= n; i++) {
		cin >> l[i];
	}
	for (int i = 1; i <= n; i++) {
		cin >> r[i];
	}

	int ans = 0;
	int a0, b0;
	cin >> a0 >> b0;
	a[0] = a0;
	b[0] = b0;
	dp[0][0] = { a[0], b[0] };
	dp[0][1] = { a[0], b[0] };
	for (int i = 1; i <= n; i++) {

		
		dp[i][0] = { min(dp[i - 1][0].fi + d[i], l[i]), dp[i - 1][0].se + d[i] };
		if (min(dp[i - 1][1].fi + d[i], l[i]) + dp[i - 1][1].se + d[i] > dp[i][0].fi + dp[i][0].se) {
			dp[i][0] = { min(dp[i - 1][1].fi + d[i], l[i]), dp[i - 1][1].se + d[i] };
		}
		dp[i][1] = { dp[i - 1][0].fi + d[i], min(dp[i - 1][0].se + d[i], r[i]) };
		if (dp[i - 1][1].fi + d[i] + min(dp[i - 1][1].se + d[i], r[i]) > dp[i][1].fi + dp[i][1].se) {
			dp[i][1] = { dp[i - 1][1].fi + d[i], min(dp[i - 1][1].se + d[i], r[i]) };
		}
	}
	cout << max(dp[n][0].fi + dp[n][0].se, dp[n][1].fi + dp[n][1].se);
}