#include <bits/stdc++.h>

#define int int64_t
//#define endl '\n'

using namespace std;

const int MAXN = 4e5;
const int MAXX = 20;
const int MOD = 998244353;
const int INF = 1e17;
const long double EPS = 1e-6;
const long double EPS1 = 1e-7;
const int LG = 50;
const int BS = 100;
const int DIS = 2e8;

int bp(int v, int p){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp(v, p - 1) * v % MOD;
    }
    int k = bp(v, p / 2);
    return k * k % MOD;
}

int bp_md(int v, int p, int md){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp_md(v, p - 1, md) * v % md;
    }
    int k = bp_md(v, p / 2, md);
    return k * k % md;
}

int nok(int a, int b){
    return a / __gcd(a, b) * b;
}

bool is_prime(int a){
    for(int i = 2; i * i <= a; i++){
        if(a % i == 0){
            return 0;
        }
    }
    return 1;
}

mt19937 rnd(121);

void solve(){
    int n = 15;
    cin >> n;
    vector <int> l, r, d;
    for(int i = 0; i < n; i++){
        int k = rnd() % MAXX;
        cin >> k;
        d.push_back(k);
    }
    for(int i = 0; i < n; i++){
        int k = rnd() % MAXX;
        cin >> k;
        l.push_back(k);
    }
    for(int i = 0; i < n; i++){
        int k = rnd() % MAXX;
        cin >> k;
        r.push_back(k);
    }
    int a = rnd() % MAXX, b = rnd() % MAXX;
    cin >> a >> b;
    vector <int> used(n);
    int mx = 0;
    for(int i = 0; i < n; i++){
        int aa = a, bb = b;
        pair<int, int> mnm = {INF, 0};
        for(int j = 0; j < n; j++){
            aa += d[j];
            bb += d[j];
            if(used[j]){
                aa = min(aa, l[j]);
            }
            else{
                mnm = min(mnm, {aa - l[j], j});
                bb = min(bb, r[j]);
            }
        }
        mx = max(mx, aa + bb);
        used[mnm.second] = 1;
    }
    int aa = a, bb = b;
    for(int j = 0; j < n; j++){
        aa += d[j];
        bb += d[j];
        if(used[j]){
            aa = min(aa, l[j]);
        }
        else{
            bb = min(bb, r[j]);
        }
    }
    mx = max(mx, aa + bb);
    cout << mx;
}
/*
5
4 0 7 0 8
10 5 3 7 7
8 5 9 2 23
4 8
*/
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
        cout << endl;
    }
    return 0;
}
