#include <bits/stdc++.h>

#define int int64_t
//#define endl '\n'

using namespace std;

const int MAXN = 4e5;
const int MAXX = 20;
const int MOD = 998244353;
const int INF = 1e17;
const long double EPS = 1e-6;
const long double EPS1 = 1e-7;
const int LG = 50;
const int BS = 100;
const int DIS = 2e8;

int bp(int v, int p){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp(v, p - 1) * v % MOD;
    }
    int k = bp(v, p / 2);
    return k * k % MOD;
}

int bp_md(int v, int p, int md){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp_md(v, p - 1, md) * v % md;
    }
    int k = bp_md(v, p / 2, md);
    return k * k % md;
}

int nok(int a, int b){
    return a / __gcd(a, b) * b;
}

bool is_prime(int a){
    for(int i = 2; i * i <= a; i++){
        if(a % i == 0){
            return 0;
        }
    }
    return 1;
}

mt19937 rnd(121);
/*
int n;
    cin >> n;
    vector <int> a, b;
    bool flag = 1;
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        a.push_back(k);
    }
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        b.push_back(k);
    }
    for(int i = 0; i < n - 1; i++){
        flag = flag && b[i + 1] >= b[i];
        flag = flag && a[i + 1] >= a[i];
    }
    if(flag){
        vector <int> a1, b1;
        multiset <int> ms;
        int sm = 0;
        int mx = 0;
        int lst = -1;
        for(int i = 0; i < n; i++){
            sm += a[i];
            sm -= b[i];
            mx = max(mx, a[i] - b[i]);
            if(a1.size() && a1.back() >= b[i]){
                if(lst == -1){
                    lst = b1.back();
                }
            }
            a1.push_back(a[i]);
            b1.push_back(b[i]);
            if(lst != -1){
                mx = max(mx, a1.back() - lst);
            }
            if(i != n - 1 && a1.size() && a1.back() < b[i + 1]){
                lst = -1;
            }
            cout << sm - mx << ' ';
        }
        return;
    }
    multiset <int> a1, b1;
    int sm = 0;
    for(int i = 0; i < n; i++){
        a1.insert(a[i]);
        b1.insert(b[i]);
        sm += a[i];
        sm -= b[i];
        auto i1 = a1.begin();
        auto i2 = b1.begin();
        int mx = 0;
        int lst = -1;
        while(i1 != a1.end()){
            if(lst != -1){
                if(i1 == (--a1.end()) || *i1 < *(next(i2, 1))){
                    mx = max(mx, *i1 - lst);
                    lst = -1;
                }
            }
            else{
                if(i1 != (--a1.end())){
                    if(*(next(i2, 1)) <= *i1){
                        lst = *i2;
                    }
                }
            }
            mx = max(mx, *i1 - *i2);
            i1++;
            i2++;
        }
        cout << sm - mx << ' ';
    }
*/


void solve(){
    int n;
    cin >> n;
    vector <int> d, l, r;
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        d.push_back(k);
    }
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        l.push_back(k);
    }
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        r.push_back(k);
    }
    int a, b;
    cin >> a >> b;
    multiset <pair<int, int>> msb;
    int ans = 0;
    for(int i = 0; i < n; i++){
        msb.insert({r[i], i});
    }
    for(int i = 0; i < n - 1; i++){
        ans = max(ans, a + min(b, (*msb.begin()).first));
        auto it = msb.begin();
        a = min(a, l[(*it).second]);
        msb.erase(msb.begin());
    }
    ans = max(ans, a + b);
    cout << ans;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while(t--){
        solve();
        cout << endl;
    }
    return 0;
}
