//#pragma GCC optimize("O3", "unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define eb emplace_back
#define F first
#define S second
#define vec vector
#define all(x) (x).begin(), (x).end()

//#pragma GCC target("avx2")

using vi = vector<int>;
using str = string;
using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template<typename A>
void print(A &a, str sep=" "){
    for(auto &i: a)cout << i << sep;
    cout << "\n";
}
template<typename A>
void read(A &a){
    for(auto &i: a)cin >> i;
}

void solve(){
    int n; cin >> n;
    vi d(n); read(d);
    vi l(n); read(l);
    vi r(n); read(r);
    vi a(n), b(n);
    cin >> a[0] >> b[0];
    
    multiset<int> lu;
    lu.insert(a[0]);
    for(int i: l)lu.insert(i);
    
    vec<pii> rp(n);
    for(int i = 0; i < n; ++i)
        rp[i] = {r[i], i};
    
    sort(all(rp));
    int res = b[0] + min(a[0], *lu.begin());
    for(int i = n - 1; i >= 0; ++i){
        int bn = min(b[0], rp[i].F);
        lu.erase(lu.find(l[rp[i].S]));
        int an = min(a[0], *lu.begin());
        res = max(res, an + bn);
    }
    cout << res << "\n";
}


signed main() {
#ifdef LOCAL
    freopen("inp", "r", stdin);
#else
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#endif

    //clock_t start = clock();
    int TT = 1;
    //cin >> TT;
    while(TT--){
        solve();
    }
//    clock_t end = clock();
//    cout.precision(16);
//    cout << fixed;
//    cout << (ld)(end - start) / CLOCKS_PER_SEC << "\n";
    return 0;
}
