#include <bits/stdc++.h>
using namespace std;
#define int long long
#define pii pair < int, int >
#define F first
#define S second
int tree[3000000];
void update(int idx, int val, int v, int tl, int tr) {
    if (tl == tr && tr == idx) {
        tree[v] = min(tree[v], val);
        return;
    }
    if (tl > idx || tr < idx) return;
    int tm = (tl + tr) / 2;
    update(idx, val, v * 2, tl, tm);
    update(idx, val, v * 2 + 1, tm + 1, tr);
    tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
}
int get(int l, int r, int v, int tl, int tr) {
    if (tl >= l && tr <= r) return tree[v];
    if (tl > r || tr < l) return 1e18;
    int tm = (tl + tr) / 2;
    return min(get(l, r, v * 2, tl, tm), get(l, r, v * 2 + 1, tm + 1, tr));
}
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    int d[n + 2], l[n + 2], r[n + 2];
    for (int i = 1; i <= n; i++) cin >> d[i];
    for (int i = 1; i <= n; i++) cin >> l[i];
    for (int i = 1; i <= n; i++) cin >> r[i];
    bool is = 0;
    for (int i = 1; i <= n; i++) {
        if (d[i] != 0) is = 1;
    }
    int a0, b0;
    cin >> a0 >> b0;
    /*if (n <= 15) {
        int ans = 0;
        for (int mask = 0; mask < (1ll << n); mask++) {
            int a1 = a0, b1 = b0;
            for (int bit = 0; bit < n; bit++) {
                if ((1ll << bit) & mask) {
                    a1 = min(l[bit + 1], a1 + d[bit + 1]);
                    b1 = b1 + d[bit + 1];
                }
                else {
                    b1 = min(r[bit + 1], b1 + d[bit + 1]);
                    a1 = a1 + d[bit + 1];
                }
            }
            ans = max(ans, a1 + b1);
            if (ans == 37) {
                for (int bit = 0; bit < n; bit++) {
                    if ((1ll << bit) & mask) cout << 1;
                    else cout << 0;
                }
                return 0;
            }
        }
        cout << ans;
    }*/
   if (!is) {
        int ans = 0;
        int a1 = a0, b1 = b0;
        for (int i = 1; i <= n; i++) {
            if (l[i] < a0) {
                b1 = min(b1, r[i]);
            }
            else continue;
        }
        set < int > st;
        map < int, int > mp;
        for (int i = 1; i <= n; i++) {
            st.insert(l[i]);
            st.insert(l[i] - 1);
        }
        int idx = 0;
        for (auto to : st) {
            mp[to] = idx;
            idx++;
        }
        for (int i = 0; i < 4 * idx; i++) {
            tree[i] = 1e18;
        }
        for (int i = 1; i <= n; i++) {
            update(mp[l[i]], r[i], 1, 0, idx - 1);
        }
        ans = a1 + b1;
        for (int pos = 1; pos <= n; pos++) {
            if (l[pos] >= a0) continue;
            ans = max(ans, l[pos] + min(b0, get(0, mp[l[pos] - 1], 1, 0, idx - 1)));
        }
        cout << ans;
    }
    else {
        int ans = 0;
        int a1 = a0, b1 = b0;
        for (int i = 1; i <= n; i++) {
            a1 += d[i];
            b1 = min(b1 + d[i], r[i]);
        }
        ans = a1 + b1;
        for (int pos = 1; pos <= n; pos++) {
            a1 = a0, b1 = b0;
            for (int i = 1; i < pos; i++) {
                if (l[i] < l[pos]) {
                    b1 = min(b1 + d[i], r[i]);
                    a1 += d[i];
                }
                else {
                    a1 = min(a1 + d[i], l[i]);
                    b1 += d[i];
                }
            }
            //if (pos == 3) cout << a1 << " " << b1 << " ";
            if (a1 + d[pos] < l[pos]) continue;
            a1 = l[pos];
            b1 += d[pos];
            for (int i = pos + 1; i <= n; i++) {
                if (a1 + d[i] < l[i]) {
                    b1 += d[i];
                    a1 += d[i];
                }
                else {
                    b1 = min(b1 + d[i], r[i]);
                    a1 += d[i];
                }
            }
            ans = max(ans, a1 + b1);
        }
        cout << ans;
    }
    return 0;
}
