//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
using ll = long long;
using ld = long double;
const ll INF = 2e9, MOD = 1e9 + 7, N = 200 + 5, K = 500 + 5;
mt19937 rnd(24246);


pair<int, int> operator+(pair<int, int> a, int d) {
    return {a.first + d, a.second + d};
}
void solve() {
    int n;
    cin >> n;
    vector<int> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 1; i <= n; i++) cin >> d[i];
    for (int i = 1; i <= n; i++) cin >> l[i];
    for (int i = 1; i <= n; i++) cin >> r[i];
    int a0, b0;
    cin >> a0 >> b0;
    vector<pair<int, int>> mxa(n + 1), mxb(n + 1);
    mxa[0] = {a0, b0};
    mxb[0] = {b0, a0};
    for (int i = 1; i <= n; i++) {
        pair<int, int> p1 = mxa[i - 1] + d[i];
        p1 = max(make_pair(p1.first, min(p1.second, r[i])), make_pair(min(p1.first, l[i]), p1.second));
        pair<int, int> p2 = make_pair(mxb[i - 1].second, mxb[i - 1].first) + d[i];
        p2 = max(make_pair(p2.first, min(p2.second, r[i])), make_pair(min(p2.first, l[i]), p2.second));
        mxa[i] = max(p1, p2);

        pair<int, int> p3 = mxb[i - 1] + d[i];
        p3 = max(make_pair(p3.first, min(p3.second, l[i])), make_pair(min(p3.first, r[i]), p3.second));
        pair<int, int> p4 = make_pair(mxa[i - 1].second, mxa[i - 1].first) + d[i];
        p4 = max(make_pair(p4.first, min(p4.second, l[i])), make_pair(min(p4.first, r[i]), p4.second));
        mxb[i] = max(p3, p4);
    }
    vector<pair<int, int>> dp(n + 1);
    dp[0] = {a0, b0};
    for (int i = 1; i <= n; i++) {
        pair<int, int> p = dp[i - 1] + d[i], p2 = {min(p.first, l[i]), p.second}, p3 = {p.first, min(p.second, r[i])};
        if (p2.first + p2.second > p3.first + p3.second)
            dp[i] = p2;
        else
            dp[i] = p3;
    }
    cout << max(mxa[n].first + mxa[n].second, max(mxb[n].first + mxb[n].second, dp[n].first + dp[n].second));

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
