//#define GLIBCXX_DEBUG
#include <bits/stdc++.h>

#define int long long
#define ld long double
#define F first
#define S second
using namespace std;
const int inf = 1e18;

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> d[i + 1];
    }
    vector<int> pref(n + 2);
    for (int i = 0; i < n + 1; ++i) {
        pref[i + 1] = pref[i] + d[i + 1];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i + 1];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i + 1];
    }
    int a0, b0;
    cin >> a0 >> b0;
    l[0] = a0;
    r[0] = b0;
    map<vector<int>, int> dp;
    dp[{0, 0}] = a0 + b0;
    queue<vector<int>> q;
    q.push({0, 0});
    int ans = 0;
    while (!q.empty()) {
        auto sost = q.front();
        q.pop();
        if (sost[0] == n) {
            ans = max(ans, dp[sost]);
            continue;
        }
        int fir = l[sost[1]] + pref[sost[0]];
        fir -= pref[sost[1]];
        int sec = dp[sost] - fir;
        map<vector<int>, int> add;
        if (fir + d[sost[0] + 1] <= l[sost[0] + 1]) {
            add[{sost[0] + 1, sost[1]}] = max(add[{sost[0] + 1, sost[1]}],
                                              sec + fir + d[sost[0] + 1] * 2);
        }
        if (sec + d[sost[0] + 1] <= r[sost[0] + 1]) {
            add[{sost[0] + 1, sost[1]}] = max(add[{sost[0] + 1, sost[1]}],
                                              sec + fir + d[sost[0] + 1] * 2);
        }
        if (fir + d[sost[0] + 1] > l[sost[0] + 1]) {
            add[{sost[0] + 1, sost[0] + 1}] = max(add[{sost[0] + 1, sost[0] + 1}],
                                                  sec + d[sost[0] + 1] + l[sost[0] + 1]);
        }
        if (sec + d[sost[0] + 1] > r[sost[0] + 1]) {
            add[{sost[0] + 1, sost[1]}] = max(add[{sost[0] + 1, sost[1]}],
                                              fir + d[sost[0] + 1] + r[sost[0] + 1]);
        }
        for (auto &[k, v]: add) {
            dp[k] = max(dp[k], v);
            q.push(k);
        }
    }
    cout << ans;
    return 0;
}
