//#define GLIBCXX_DEBUG
#include <bits/stdc++.h>

#define int long long
#define ld long double
#define F first
#define S second
using namespace std;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> d(n + 1), l(n + 1), r(n + 1);
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        cin >> d[i + 1];
        sum += d[i + 1];
    }
    vector<int> pref(n + 2);
    for (int i = 0; i < n + 1; ++i) {
        pref[i + 1] = pref[i] + d[i + 1];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i + 1];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i + 1];
    }
    int a0, b0;
    cin >> a0 >> b0;
    l[0] = a0;
    r[0] = b0;
    if (sum) {
        vector<vector<int>> dp(1, vector<int>(n + 1));
        vector<vector<bool>> used(1, vector<bool>(n + 1));
        dp[0][0] = a0 + b0;
        queue<vector<int>> q;
        q.push({0, 0});
        int ans = 0;
        while (!q.empty()) {
            auto sost = q.front();
            if (dp.size() != sost[0] + 2) {
                dp.push_back({});
                dp.back().resize(n + 1, 0);
                used.push_back({});
                used.back().resize(n + 1, 0);
            }
            if (sost[0] > 0) {
                dp[sost[0] - 1].clear();
                dp[sost[0] - 1].shrink_to_fit();
                used[sost[0] - 1].clear();
                used[sost[0] - 1].shrink_to_fit();
            }
            q.pop();
            if (sost[0] == n) {
                ans = max(ans, dp[sost[0]][sost[1]]);
                continue;
            }
            int fir = l[sost[1]] + pref[sost[0]];
            fir -= pref[sost[1]];
            int sec = dp[sost[0]][sost[1]] - fir;
            map<vector<int>, int> add;
            if (fir + d[sost[0] + 1] <= l[sost[0] + 1]) {
                add[{sost[0] + 1, sost[1]}] = max(add[{sost[0] + 1, sost[1]}],
                                                  dp[sost[0]][sost[1]] + d[sost[0] + 1] * 2);
            }
            if (sec + d[sost[0] + 1] <= r[sost[0] + 1]) {
                add[{sost[0] + 1, sost[1]}] = max(add[{sost[0] + 1, sost[1]}],
                                                  dp[sost[0]][sost[1]] + d[sost[0] + 1] * 2);
            }
            if (fir + d[sost[0] + 1] > l[sost[0] + 1]) {
                add[{sost[0] + 1, sost[0] + 1}] = max(add[{sost[0] + 1, sost[0] + 1}],
                                                      sec + d[sost[0] + 1] + l[sost[0] + 1]);
            }
            if (sec + d[sost[0] + 1] > r[sost[0] + 1]) {
                add[{sost[0] + 1, sost[1]}] = max(add[{sost[0] + 1, sost[1]}],
                                                  fir + d[sost[0] + 1] + r[sost[0] + 1]);
            }
            for (auto &[k, v]: add) {
                dp[k[0]][k[1]] = max(dp[k[0]][k[1]], v);
                if (!used[k[0]][k[1]]) {
                    q.push(k);
                    used[k[0]][k[1]] = 1;
                }
            }
        }

        cout << ans;
    } else {
        int ans = 0;
        set<pair<int, int>> ll, rr;
        vector<int> o;
        for (int i = 0; i < n + 1; ++i) {
            ll.insert({l[i], i});
            o.push_back(l[i]);
            rr.insert({r[i], i});
        }
        sort(o.rbegin(), o.rend());
        for (int i = 0; i < o.size(); ++i) {
            while (!ll.empty() && (--ll.end())->F >= o[i]) {
                auto it = --ll.end();
                rr.erase({r[it->S], it->S});
                ll.erase(it);
            }
            if (rr.empty()) {
                ans = max(ans, min(a0, o[i]) + b0);
            } else {
                ans = max(ans, min(a0, o[i]) + min(b0, rr.begin()->F));
            }
        }
        cout << ans;
    }
    return 0;
}
