#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define int long long

using namespace std;
typedef long long i64;
const i64 inf = 1e18;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> D(n + 1), L(n + 1), R(n + 1);
    vector<int> a(n + 1), b(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> D[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> L[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> R[i];
    }
    i64 res = 0, md = inf;
    cin >> a[0] >> b[0];
    for (int i = 1; i <= n; ++i) {
        a[i] = a[i - 1] + D[i];
        b[i] = b[i - 1] + D[i];
    }
    res = a[n] + b[n];
    vector<pair<int, int>> dp(n + 1, {0, 0});

    for (int i = 1; i <= n; ++i) {
        auto [a1, a2] = dp[i - 1];
        pair<int, int> r1 = dp[i - 1], r2 = dp[i - 1];
        r1.fi = max(r1.fi, a[i] - L[i]);
        r2.se = max(r2.se, b[i] - R[i]);
        if (r1.fi + r1.se < r2.fi + r2.se) dp[i] = r1;
        else dp[i] = r2;
    }
//    for (int msk = 0; msk < (1 << n); ++msk) {
//        i64 mxa = 0, mxb = 0;
//        for (int j = 0; j < n; ++j) {
//            if (msk & (1 << j)) {
//                mxa = max(mxa, a[j + 1] - L[j + 1]);
//            } else {
//                mxb = max(mxb, b[j + 1] - R[j + 1]);
//            }
//        }
//        md = min(md, mxa + mxb);
//    }
    cout << res - dp[n].fi - dp[n].se << '\n';
}
