#pragma gcc optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
// #define int ll
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll mod = 1000000007;
const ll inf = 1e18;
const int mxn = 1e9 + 7;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << a << endl;
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;

void solve() {
    int n; cin >> n;
    vector <ll> d(n), l(n), r(n), pref(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        cin >> d[i];
        pref[i + 1] = pref[i] + d[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> r[i];
    }
    ll a0, b0; cin >> a0 >> b0;
    for (int i = 0; i < n; ++i) {
        l[i] = min(l[i], a0 + pref[i + 1]);
        r[i] = min(r[i], b0 + pref[i + 1]);
    }
    vector <ll> v1(n, 0), v2(n, 0);
    for (int i = 0; i < n; ++i) {
        v1[i] = l[i] + (pref[n] - pref[i + 1]);
        v2[i] = r[i] + (pref[n] - pref[i + 1]);
    }
    // vout(v1); vout(v2);
    vector <pll> t;
    multiset <ll> lal;
    for (int i = 0; i < n; ++i) {
        t.push_back({v2[i], i});
        lal.insert(v1[i]);
    }
//    vout(l); vout(r);
    sort(rall(t));
    ll ans = 0;
    for (auto i : t) {
        lal.extract(v1[i.second]);
        if (!lal.empty()) ans = max(ans, i.first + *lal.begin());
        // vout(lal);
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; // cin >> tt;
    while (tt--) solve();
}