#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (ll& x : d) cin >> x;
    for (ll& x : l) cin >> x;
    for (ll& x : r) cin >> x;
    ll a0, b0;
    cin >> a0 >> b0;
    
    bool is0 = true;
    for (ll x : d) {
        if (x != 0) is0 = false;
    }
    
    if (is0) {
        vector<pair<ll, ll>> v(n);
        for (int i = 0; i < n; i++) {
            v[i] = {l[i], r[i]};
        }
        vector<ll> pref(n);
        for (int i = 0; i < n; i++) {
            pref[i] = v[i].second;
            if (i > 0) pref[i] = min(pref[i], pref[i - 1]);
        }
        
        sort(all(v));
        ll mx = max(a0 + min(b0, pref.back()), min(a0, *min_element(all(l))) + b0);
        for (int i = 0; i < n; i++) {
            mx = max(mx, min(a0, v[i].first) + min(b0, (i == 0 ? (int)1e9 : pref[i - 1])));
        }
        cout << mx;
    } else {
        set<pair<ll, ll>> s;
        s.emplace(a0, b0);
        for (int i = 0; i < n; i++) {
            set<pair<ll, ll>> ns;
            ll mx = 0;
            for (auto [a, b] : s) {
//            ll sm = a + d[i] + min(b + d[i], r[i]);
//            if (sm > mx) {
//                ns.clear();
//                mx = sm;
//            }
//            if (sm == mx)
                ns.emplace(a + d[i], min(b + d[i], r[i]));

//            sm = min(a + d[i], l[i]) + b + d[i];
//            if (sm > mx) {
//                ns.clear();
//                mx = sm;
//            }
//            if (sm == mx)
                ns.emplace(min(a + d[i], l[i]), b + d[i]);
            }
            s = ns;
            cout << i << ":\n";
            for (auto [a, b] : s) {
                cout << a << " " << b << "\n";
            }
        }

        ll mx = 0;
        for (auto [a, b] : s) {
            mx = max(mx, a + b);
        }

        cout << mx;
    }
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) solve();
}