#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    for (ll& x : d) cin >> x;
    for (ll& x : l) cin >> x;
    for (ll& x : r) cin >> x;
    ll a0, b0;
    cin >> a0 >> b0;

    bool is0 = true;
    for (ll x : d) {
        if (x != 0) is0 = false;
    }

    if (is0) {
        vector<pair<ll, ll>> v(n);
        for (int i = 0; i < n; i++) {
            v[i] = {l[i], r[i]};
        }
        sort(all(v));

        vector<ll> pref(n);
        for (int i = 0; i < n; i++) {
            pref[i] = v[i].second;
            if (i > 0) pref[i] = min(pref[i], pref[i - 1]);
        }

        ll mx = max(a0 + min(b0, pref.back()), min(a0, *min_element(all(l))) + b0);
        for (int i = 0; i < n; i++) {
            mx = max(mx, min(a0, v[i].first) + min(b0, (i == 0 ? (int)1e9 : pref[i - 1])));
        }
        cout << mx;
    } else {
//        vector<pair<ll, ll>> v;
//        v.emplace_back(a0, b0);
//        for (int i = 0; i < n; i++) {
//            vector<pair<ll, ll>> nv;
//            for (auto [a, b] : v) {
//                nv.emplace_back(a + d[i], min(b + d[i], r[i]));
//                nv.emplace_back(min(a + d[i], l[i]), b + d[i]);
//            }
//            v = nv;
//        }
//        ll mx = 0;
//        for (auto [a, b] : v) {
//            mx = max(mx, a + b);
//        }
//        cout << mx;
        vector<ll> pref(n);
        for (int i = 0; i < n; i++) {
            pref[i] = d[i];
            if (i > 0) pref[i] += pref[i - 1];
        }

        vector<ll> dp(n + 1);
        dp[0] = b0;
        for (int i = 0; i < n; i++) {
            dp[i + 1] = -1e9;
            for (int j = 0; j <= i; j++) dp[j] += d[i];
            if (a0 + pref[i] > l[i]) {
                dp[i + 1] = max(dp[i + 1], dp[0]);
                dp[0] = min(dp[0], r[i]);
            }
            for (int j = 0; j < i; j++) {
                if (l[j] + pref[i] - pref[j] > l[i]) {
                    dp[i + 1] = max(dp[i + 1], dp[j + 1]);
                    dp[j + 1] = min(dp[j + 1], r[i]);
                }
            }
        }

        ll mx = 0;
        for (int i = 0; i <= n; i++) {
            mx = max(mx, (i == 0 ? a0 : l[i - 1] - pref[i - 1]) + pref[n - 1] + dp[i]);
        }

        cout << mx;
    }
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) solve();
}