#include <iostream>
#include <vector>
using namespace std;
using ll = long long;

const ll INF = 1e18 + 177013;
const int MAXN = 1e5 + 123;
int d[MAXN];
ll dsm[MAXN];
ll l[MAXN];
ll r[MAXN];

signed main() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> d[i];
    for (int i = 1; i <= n; ++i)
        dsm[i] = dsm[i - 1] + d[i];
    for (int i = 1; i <= n; ++i)
        cin >> l[i];
    for (int i = 1; i <= n; ++i)
        cin >> r[i];
    ll a0, b0;
    cin >> a0 >> b0;
    l[0] = a0;
    r[0] = b0;

    vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, -INF));
    dp[0][0] = b0;
    for (int i = 0; i < n; ++i) for (int j = 0; j <= i; ++j) {
        // choose a[i + 1] mineq l[i + 1]
        if (l[j] + dsm[i + 1] - dsm[j] <= l[i + 1])
            dp[i + 1][j] = max(dp[i + 1][j], dp[i][j] + d[i + 1]);
        else
            dp[i + 1][i + 1] = max(dp[i + 1][i + 1], dp[i][j] + d[i + 1]);
        dp[i + 1][j] = max(dp[i + 1][j], min(dp[i][j] + d[i + 1], r[i + 1]));
    }
    //for (int i = 0; i <= n; ++i) {
        //for (int j = 0; j <= i; ++j) {
            //if (dp[i][j] < -INF / 2)
                //cout << "- ";
            //else
                //cout << dp[i][j] << ' ';
        //}
        //cout << endl;
    //}
    ll ans = -INF;
    for (int i = 0; i <= n; ++i) {
        ans = max(ans, dp[n][i] + l[i] + dsm[n] - dsm[i]);
    }
    cout << ans << endl;
}
