#include <iostream>
#include <vector>
using namespace std;
using ll = long long;

const ll INF = 1e18 + 177013;
const int MAXN = 1e5 + 123;
int d[MAXN];
ll dsm[MAXN];
ll l[MAXN];
ll r[MAXN];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> d[i];
    for (int i = 1; i <= n; ++i)
        dsm[i] = dsm[i - 1] + d[i];
    for (int i = 1; i <= n; ++i)
        cin >> l[i];
    for (int i = 1; i <= n; ++i)
        cin >> r[i];
    ll a0, b0;
    cin >> a0 >> b0;
    l[0] = a0;
    r[0] = b0;

    vector<ll> dp = {b0};
    for (int i = 0; i < n; ++i) {
        vector<ll> ndp(i + 2, -INF);
        for (int j = 0; j <= i; ++j) {
            if (l[j] + dsm[i + 1] - dsm[j] <= l[i + 1])
                ndp[j] = max(ndp[j], dp[j] + d[i + 1]);
            else
                ndp[i + 1] = max(ndp[i + 1], dp[j] + d[i + 1]);
            ndp[j] = max(ndp[j], min(dp[j] + d[i + 1], r[i + 1]));
        }
        dp = ndp;
    }
    ll ans = -INF;
    for (int i = 0; i <= n; ++i) {
        ans = max(ans, dp[i] + l[i] + dsm[n] - dsm[i]);
    }
    cout << ans << endl;
}
