/* koshka >.< */

#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

using Int = long long;
using Int128 = __int128;

inline istream &operator>>(istream &in, Int128 &num) {
    Int t;
    in >> t;
    num = t;
    return in;
}

inline ostream &operator<<(ostream &out, const Int128 num) {
    out << num;
    return out;
}

template<typename T1, typename T2>
inline istream &operator>>(istream &in, pair<T1, T2> &p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T1, typename T2>
inline ostream &operator<<(ostream &out, const pair<T1, T2> &p) {
    out << p.first << ' ' << p.second;
    return out;
}

template<typename T>
inline istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &el : arr) {
        in >> el;
    }
    return in;
}

template<typename T>
inline ostream &operator<<(ostream &out, const vector<T> &arr) {
    for (auto el : arr) {
        out << el << ' ';
    }
    return out;
}

int main() {
    ios::sync_with_stdio(false), cin.tie(0);
    cout.setf(ios::fixed), cout.precision(20);
#define int Int
    int n, a0, b0;
    cin >> n;
    vector<int> d(n), le(n), ri(n);
    cin >> d >> le >> ri >> a0 >> b0;
    int answ = 0;
    if (count(d.begin(), d.end(), 0) == n) {
        vector<int> can = le;
        can.push_back(a0);
        for (auto aa : can) {
            if (aa > a0) {
                continue;
            }
            int cur = aa;
            int bb = b0;
            for (int j = 0; j < n; ++j) {
                if (le[j] < aa) {
                    bb = min(bb, ri[j]);
                }
            }
            answ = max(answ, aa + bb);
        }
        cout << answ << '\n';
        return 0;
    }
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> a = {a0};
        vector<int> b = {b0};
        for (int i = 0; i < n; ++i) {
            int ca = a.back() + d[i], cb = b.back() + d[i];
            if ((mask >> i) & 1) {
                a.push_back(min(ca, le[i]));
                b.push_back(cb);
            } else {
                a.push_back(ca);
                b.push_back(min(cb, ri[i]));
            }
        }
        answ = max(answ, a.back() + b.back());
    }
    cout << answ << '\n';
    return 0;
}

