#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    cin >> d >> l >> r;
    ll a0, b0;
    cin >> a0 >> b0;
    ll ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        ll cura = a0, curb = b0;
        for (int i = 0; i < n; ++i) {
            cura += d[i];
            curb += d[i];
            if ((mask >> i) & 1) {
                cura = min(cura, l[i]);
            } else {
                curb = min(curb, r[i]);
            }
        }
        ans = max(ans, cura + curb);
    }
    cout << ans << "\n";
}
