//#pragma GCC optimize("03,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n; i++) {
        std::cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> l[i];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> r[i];
    }
    i64 a, b;
    std::cin >> a >> b;
    for (int i = 0; i < n; i++) {
        a += d[i];
        b += d[i];
        i64 da = std::max(0LL, a - l[i]);
        i64 db = std::max(0LL, b - r[i]);
        if (da < db) {
            a = std::min(a, (i64) l[i]);
        } else {
            b = std::min(b, (i64) r[i]);
        }
    }
    std::cout << a + b << "\n";
}

signed main() {
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);

    int t = 1;
//    std::cin >> t;

    while (t--) {
        solve();
    }
}