//#pragma GCC optimize("03,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 0; i < n; i++) {
        std::cin >> d[i + 1];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> l[i + 1];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> r[i + 1];
    }
    i64 a, b;
    std::cin >> a >> b;
    l[0] = (int) a;
    r[0] = (int) b;
    std::vector<std::vector<i64>> dp(n + 1, std::vector<i64>(2, -1e15));
    i64 res = 0;
    dp[0][0] = b;
    dp[0][1] = a;
    for (int i = 0; i <= n; i++) {
        i64 sa = l[i], sb = dp[i][0];
        for (int j = i + 1; j <= n + 1 && j - i <= 500; j++) {
            if (j == n + 1) {
                res = std::max(res, sa + sb);
            } else {
                sa += d[j];
                sb += d[j];
                sb = std::min(sb, (i64) r[j]);
                if (sb == r[j]) {
                    dp[j][1] = std::max(dp[j][1], sa);
                }
            }
        }
        sa = dp[i][1], sb = r[i];
        for (int j = i + 1; j <= n + 1 && j - i <= 500; j++) {
            if (j == n + 1) {
                res = std::max(res, sa + sb);
//                std::cout << sa << " " << sb << "\n";
            } else {
                sa += d[j];
                sb += d[j];
                sa = std::min(sa, (i64) l[j]);
                if (sa == l[j]) {
                    dp[j][0] = std::max(dp[j][0], sb);
                }
            }
        }
    }
    std::cout << res << "\n";
}

signed main() {
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);

    int t = 1;
//    std::cin >> t;

    while (t--) {
        solve();
    }
}