//#pragma GCC optimize("03,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> d(n + 1), l(n + 1), r(n + 1);
    for (int i = 0; i < n; i++) {
        std::cin >> d[i + 1];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> l[i + 1];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> r[i + 1];
    }
    i64 a, b;
    std::cin >> a >> b;
    l[0] = (int) a;
    r[0] = (int) b;
    std::vector<int> p(n);
    std::iota(p.begin(), p.end(), 1);
    std::sort(p.begin(), p.end(), [&](int i, int j) {
        return l[i] > l[j];
    });
    i64 res = 0;
    std::multiset<int> left;
    for (int i = 1; i <= n; i++) {
        left.insert(r[i]);
    }
    res = std::max(res, std::min(b, (i64) *left.begin()) + a);
    for (int i : p) {
        left.extract(r[i]);
        i64 t = (left.empty() ? 1e9 : *left.begin());
        res = std::max(res, std::min((i64) l[i], a) + std::min(t, b));
    }
    std::cout << res << "\n";
}

signed main() {
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);

    int t = 1;
//    std::cin >> t;

    while (t--) {
        solve();
    }
}