#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
const int INF = INT_MAX;
const ld PI = atan2(0, -1);
mt19937_64 rnd(179);

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);

    int n;
    cin >> n;
    vector<ll> d(n), l(n + 1), r(n + 1);
    for (ll& i : d) cin >> i;
    for (int i = 1; i <= n; i++) cin >> l[i];
    for (int i = 1; i <= n; i++) cin >> r[i];
    ll a0, b0;
    cin >> a0 >> b0;
    l[0] = a0;
    r[0] = b0;


    vector<ll> suf(n + 1, 0);
    for (int i = n - 1; i >= 0; i--) suf[i] = suf[i + 1] + d[i];
    vector<ll> pref(n + 1, 0);
    for (int i = 0; i < n; i++) pref[i + 1] = pref[i] + d[i];
    for (int i = 1; i <= n; i++) {
        l[i] = min(l[i], a0 + pref[i]);
        r[i] = min(r[i], b0 + pref[i]);
    }
    vector<ll> l1(n + 1), r1(n + 1);

    ll ans = 0;
    ll val1 = a0, val2 = b0;
    for (int i = 0; i < n; i++) {
        val1 += d[i];
        val2 += d[i];
        if (r[i + 1] >= val2) continue;
        val1 = min(val1, l[i + 1]);
    }
    ans = max(ans, val1 + val2);
    val1 = a0;
    val2 = b0;
    for (int i = 0; i < n; i++) {
        val1 += d[i];
        val2 += d[i];
        if (l[i + 1] >= val1) continue;
        val2 = min(val2, r[i + 1]);
    }
    ans = max(ans, val1 + val2);
    cout << ans;

//    for (int i = n; i >= 0; i--) {
//        l1[i] = l[i];
//        r1[i] = r[i];
//        for (int j = i + 1; j <= n; j++) {
//            l1[i] += d[j - 1];
//            r1[i] += d[j - 1];
//            l1[i] = min(l1[i], l[j]);
//            r1[i] = min(r1[i], r[j]);
//        }
//    }
//
//    for (int i = 0; i <= n; i++) cout << l1[i] << " ";
//    cout << endl;
//    for (int i = 0; i <= n; i++) cout << r1[i] << " ";
//    cout << endl;

//    ll ans = 0;
//    for (int i = 0; i <= n; i++) {
//        ans = max(ans, max(a0 + suf[0] + l1[i]))
//    }
}