#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
const int INF = INT_MAX;
const ld PI = atan2(0, -1);
mt19937_64 rnd(179);

int n;
vector<ll> d, l, r;
ll a0, b0;

ll solve1() {
    ll ans = 0;
    ll val1 = a0, val2 = b0;
    for (int i = 0; i < n; i++) {
        val1 += d[i];
        val2 += d[i];
        if (r[i] >= val2) continue;
        val1 = min(val1, l[i]);
    }
    ans = max(ans, val1 + val2);
    val1 = a0;
    val2 = b0;
    for (int i = 0; i < n; i++) {
        val1 += d[i];
        val2 += d[i];
        if (l[i] >= val1) continue;
        val2 = min(val2, r[i]);
    }
    ans = max(ans, val1 + val2);
    return ans;
}

ll solve2() {
    ll ans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        ll val1 = a0, val2 = b0;
        for (int i = 0; i < n; i++) {
            val1 += d[i];
            val2 += d[i];
            if (mask & (1 << i)) val1 = min(val1, l[i]);
            else val2 = min(val2, r[i]);
        }
        if (val1 + val2 > ans) ans = val1 + val2;
    }
    return ans;
}

void gen() {
    n = 4;
    a0 = rnd() % 10 + 1;
    b0 = rnd() % 10 + 1;
    d.assign(n, 0);
    l.assign(n, 0);
    r.assign(n, 0);
    for (int i = 0; i < n; i++) {
        d[i] = rnd() % 6;
        l[i] = rnd() % 21;
        r[i] = rnd() % 21;
    }
}

vector<vector<pair<ll, ll>>> dp;

void recalc(int i, int j, pair<ll, ll> pr) {
    if (dp[i][j].first + dp[i][j].second < pr.first + pr.second) {
        dp[i][j] = pr;
    }
}

ll solve() {
    ll ans = 0;

    for (int i = -1; i < n; i++) {
        ll val1 = a0, val2 = b0;
        for (int j = 0; j < n; j++) {
            val1 += d[j];
            val2 += d[j];
            if (l[j] >= val1 || r[j] >= val2) continue;
            if ((j <= i && l[j] >= l[i])) val1 = min(val1, l[j]);
            else val2 = min(val2, r[j]);
        }
        ans = max(ans, val1 + val2);
    }

//    for (int i = 0; i <= n; i++) {
//        ll val1 = a0, val2 = b0;
//        for (int j = 0; j < i; j++) {
//            val1 += d[j];
//            val2 += d[j];
//            if (l[j] >= L[i] || l[j] >= val1) {
//                val1 = min(val1, l[j]);
//            } else {
//                val2 = min(val2, r[j]);
//            }
//        }
//        for (int j = i; j < n; j++) {
//            val1 += d[j];
//            val2 += d[j];
//            if (l[j] >= val1) continue;
//            else val2 = min(val2, r[j]);
//        }
//        ans = max(ans, val1 + val2);
//    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);

//    for (int it = 0; it < 100; it++) {
//        cout << "TEST " << it << endl;
//        gen();
//        ll ans1 = solve1();
//        ll ans2 = solve2();
//        cout << n << endl;
//        for (ll el : d) cout << el << " ";
//        cout << endl;
//        for (ll el : l) cout << el << " ";
//        cout << endl;
//        for (ll el : r) cout << el << " ";
//        cout << endl;
//        cout << a0 << " " << b0 << endl;
//        cout << ans1 << " " << ans2 << endl << endl;
//        if (ans1 != ans2) break;
//    }
//    return 0;
    cin >> n;
    d.assign(n, 0);
    l.assign(n, 0);
    r.assign(n, 0);
    for (ll& i : d) cin >> i;
    for (ll& i : l) cin >> i;
    for (ll& i : r) cin >> i;
    cin >> a0 >> b0;
    ll ans = solve();
    swap(a0, b0);
    swap(l, r);
    ans = max(ans, solve());
    cout << ans;
}