#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx,avx2")

#include <bits/stdc++.h>
using namespace std;

#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> d(n), l(n), r(n);
    for (int i = 0; i < n; i++) cin >> d[i];
    for (int i = 0; i < n; i++) cin >> l[i];
    for (int i = 0; i < n; i++) cin >> r[i];
    int a0, b0;
    cin >> a0 >> b0;

    if (false) {
        int ans = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            int a = a0, b = b0;
            for (int i = 0; i < n; i++) {
                a += d[i];
                b += d[i];
                if (mask & (1 << i)) {
                    a = min(a, l[i]);
                } else {
                    b = min(b, r[i]);
                }
            }
            ans = max(ans, a + b);
        }
        cout << ans;
        return;
    }

    vector<int> prefd(n+1);
    for (int i = 1; i <= n; i++) {
        prefd[i] = prefd[i-1] + d[i-1];
    }

    int ans = 0;

    for (int lst = 0; lst < n; lst++) {
        int a = a0, b = b0;
        for (int i = 0; i < n; i++) {
            a += d[i];
            b += d[i];
            if (min(b, r[i]) == b)
                b = min(b, r[i]);
            else if (min(a, l[i]) == a)
                a = min(a, l[i]);
            else if (i <= lst && l[i] + prefd[lst+1] - prefd[i] >= l[lst])
                a = min(a, l[i]);
            else
                b = min(b, r[i]); 
        }

        ans = max(ans, a + b);
    }
    int a = a0, b = b0;
    for (int i = 0; i < n; i++) {
        a += d[i];
        b += d[i];
        b = min(b, r[i]);
    }
    ans = max(ans, a + b);
    cout << ans;
}

signed main() {
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--) solve(), cout << '\n';
}