#include<iostream>
#include <random>
#include<vector>
#include<set>
#include<map>
#include<cassert>
#include<unordered_map>
#include<algorithm>
#include<iomanip>
#include<numeric>
#include<deque>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define girlfriend friend

template<typename T>
bool assign_min(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream& out, std::pair<T, F> a) {
    return out << a.first << " " << a.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, b1 = 31, b2 = 29, MAXN = 1e5, MAXC = 1e9;
const long double eps = 1e-9;

void solve() {
    int n, d, G; cin >> n >> d >> G;
    vector<int> a(n); input(a);
    if (n <= 1000) {
        vector<vector<int>> g(n);
        for (int i = 0; i<n; ++i) {
            int dst = 0;
            for (int j = i+1; j<n; ++j) {
                dst++;
                if (dst > d) break;
                if (a[j] < a[i]) dst = 0;
                else {
                    g[i].emplace_back(j);
                }
            }
        }
        vector<vector<int>> dst(n, vector<int> (n, inf));
        for (int i = 0; i<n; ++i) {
            dst[i][i] = 0;
            set<pair<int, int>> q;
            q.insert({0, i});
            while (!q.empty()) {
                auto u = q.begin()->second;
                q.erase(q.begin());
                for (auto v : g[u]) {
                    if (dst[i][v] > dst[i][u] + 1) {
                        q.erase({dst[i][v], v});
                        dst[i][v] = dst[i][u] + 1;
                        q.insert({dst[i][v], v});
                    }
                }
            }
        }
        int q; cin >> q;
        for (int i = 0; i<q; ++i) {
            int t, u, v; cin >> t >> u >> v; u--; v--;
            if (t == 1) {
                cout << (dst[u][v] == inf ? 0 : 1) << '\n';
            } else {
                cout << (dst[u][v] == inf ? 0 : dst[u][v]) << '\n';
            }
        }
        return;
    }
    int q; cin >> q;
    for (int i = 0; i<q; ++i) {
        int t, u, v; cin >> t >> u >> v; u--; v--;
        if (t == 1) {
            cout << (a[u] < a[v] ? 1 : 0) << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}

//fft