#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <random>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
const int N = 3e5, LG = 20;
vector<int> a, b;
//int st[N][LG];

signed main() {
    fast_in_out();
    int n, d, G;
    cin >> n >> d >> G;
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    map<int, int> mp;
    for (int i = n - 1; i >= 0; --i) {
        if (mp.lower_bound(a[i]) == mp.end()) {
            b[i] = n;
        } else {
            b[i] = mp.lower_bound(a[i])->second;
        }
        mp[a[i]] = i;
    }
//    for (int i = 0; i < n; ++i) {
//        st[i][0] = a[i];
//    }
//    for (int l = 1; l < LG; ++l) {
//        for (int i = 0; i + (1 << l) <= n; ++i) {
//            st[i][l] = max(st[i][l - 1], st[i + (1 << (l - 1))][l - 1]);
//        }
//    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        --u, --v;
        if (u > v || a[u] > a[v]) {
            cout << "0\n";
            continue;
        }
        int ok = 1, g = 0;
        while (ok == 1) {
            if (t == 1) {
                if (u == v) {
                    ok = 2;
                    break;
                }
                if (b[u] <= v && a[b[u]] <= a[v]) {
                    ++g;
                    u = b[u];
                }
            }
            int mx = -1, pox = -1, pos = u;
            for (int i = u; i <= v; ++i) {
                if (i == v) {
                    ok = 2;
                    ++g;
                    break;
                }
                if (a[i] > mx && a[i] < a[v]) {
                    mx = a[i];
                    pox = i;
                }
                if (a[i] < a[u]) {
                    pos = i;
                }
                if (i - pos == d) {
                    if (u != pox) {
                        u = pox;
                        ++g;
                        break;
                    } else {
                        ok = 0;
                        break;
                    }
                }
            }
        }
        if (ok == 0) {
            cout << "0\n";
            continue;
        }
        if (t == 1) {
            cout << "1\n";
        } else {
            cout << g << '\n';
        }
    }
    return 0;
}
