#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <queue>
#include <deque>
#include <cassert>
using namespace std;
#define line cout << "\n"
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff first
#define ss second
#define pii pair<int, int>
#define sz(a) (int) a.size()
#define int long long
const int MAXN = 2e5 + 10;
vector<vector<int>> g(MAXN);
vector<int> used(MAXN);
int calcu = 1;

void dfs(int v) {
    used[v] = calcu;
    for (auto &u : g[v]) {
        if (used[u] != calcu) {
            dfs(u);
        }
    }
}

void solve() {
    int n, d, gr;
    cin >> n >> d >> gr;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int l = 0; l < n; l++) {
        for (int r = l + 1; r < n; r++) {
            if (a[l] >= a[r]) {
                continue;
            }
            int cur = l;
            while (cur + d < r) {
                int pos = -1;
                for (int j = cur + 1; j <= cur + d; j++) {
                    if (a[j] < a[l]) {
                        pos = j;
                    }
                }
                if (pos == -1) {
                    cur = -1;
                    break;
                } 
                cur = pos;
            }
            if (cur != -1) {
                g[l].pb(r);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, l, r;
        cin >> t >> l >> r;
        l--; r--;
        if (t == 1) {
            calcu++;
            dfs(l);
            if (used[r] == calcu) {
                cout << 1; line;
            } else {
                cout << 0; line;
            }
        } else {
            vector<int> d(n, 1e9);
            d[l] = 0;
            queue<int> q;
            q.push(l);
            calcu++;
            while (sz(q)) {
                int v = q.front();
                q.pop();
                for (auto &u : g[v]) {
                    if (used[u] != calcu) {
                        q.push(u);
                        used[u] = calcu;
                        d[u] = d[v] + 1;
                    }
                }
            }
            if (d[r] == 1e9) {
                cout << 0; line;
            } else {
                cout << d[r]; line;
            }
        }
    }
}

signed main() {
    fast;


    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}