#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <queue>
#include <deque>
#include <cassert>
using namespace std;
#define line cout << "\n"
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff first
#define ss second
#define pii pair<int, int>
#define sz(a) (int) a.size()
#define int long long
const int MAXN = 3e5 + 10;
vector<vector<int>> g(MAXN);

void solve() {
    int n, d, gr;
    cin >> n >> d >> gr;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int l = 0; l < n; l++) {
        int cur = l;
        while (cur < n) {
            for (int j = cur + 1; j <= min(n - 1, cur + d); j++) {
                if (a[j] > a[l]) {
                    g[l].pb(j);
                }
            }
            if (cur + d >= n - 1) {
                break;
            }
            int pos = -1;
            for (int j = cur + 1; j <= cur + d; j++) {
                if (a[j] < a[l]) {
                    pos = j;
                }
            }
            if (pos == -1) {
                break;
            }
            cur = pos;
        }
    }
    vector<vector<int>> dist(n, vector<int>(n, 1e9));
    for (int i = 0; i < n; i++) {
        dist[i][i] = 0;
        queue<int> q;
        q.push(i);
        while (sz(q)) {
            int v = q.front();
            if (gr == 6 && dist[i][v] > 10) {
                break;
            }
            q.pop();
            for (auto &u : g[v]) {
                if (dist[i][u] == 1e9) {
                    q.push(u);
                    dist[i][u] = dist[i][v] + 1;
                }
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, l, r;
        cin >> t >> l >> r;
        l--; r--;
        if (t == 1) {
            if (dist[l][r] != 1e9) {
                cout << 1;
            } else {
                cout << 0;
            }
            line;
        } else {
            if (dist[l][r] != 1e9) {
                cout << dist[l][r];
            } else {
                cout << 0;
            }
            line;
        }
    }
}

signed main() {
    fast;


    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}