#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxn = 2e5 + 10;
const ll inf = 1e9 + 10;
/*
struct Vect{
    ll x, y;
    Vect() {}
    Vect (ll x, ll y) : x(x), y(y) {}
};

istream& operator >> (istream& is, Vect& a) {
    is >> a.x >> a.y;
    return is;
}

Vect operator + (Vect a, Vect b) {
    return {a.x + b.x, a.y + b.y};
}

Vect operator - (Vect a, Vect b) {
    return {a.x - b.x, a.y - b.y};
}

ll operator % (Vect a, Vect b) {
    return a.x*b.x + a.y*b.y;
}

bool ok(Vect a, Vect b, Vect c) {
    return (c - b)%(a - b) > 0;
}

struct ev{
    int a, b, w;
    int ind;
};

bool operator < (ev a, ev b) {
    return a.ind < b.ind;
}

struct comb{
    int l, r;
    int a, b;
};

bool operator < (comb a, comb b) {
    if (a.a != b.a) {
        return a.a < b.a;
    }
    if (a.b != b.b) {
        return a.b < b.b;
    }
    if (a.l != b.l) {
        return a.l < b.l;
    }
    //if (a.r != b.r) {
        return a.r < b.r;
    //}
    //return a.last < b.last;
}

void solve() {
    int n;
    cin >> n;
    vector<ll> d(n), l(n), r(n);
    vector<ll> pref(n + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> r[i];
    }
    ll a, b;
    cin >> a >> b;
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + d[i];
    }
    vector<int> amin;
    ll ans = b;


    for (int i = 0; i < n; i++) {
        ans += d[i];
        ans = min(ans, r[i]);
    }
    ans += a + pref[n];

    for (int i = 0; i < n; i++) {
        amin.clear();
        amin.resize(n, 0);
        if (a + pref[i + 1] < l[i]) continue;
        ll x = l[i] + pref[n] - pref[i + 1];
        for (int j = n - 1; j >= 0; j--) {
            if (x <= l[j]) {
                amin[j] = 1;
            } else {
                //x = l[i];
            }
            x -= d[j];
        }
        ll y = b;
        for (int j = 0; j < n; j++) {
            y += d[j];
            if (!amin[j]) {
                y = min(y, r[j]);
            }
        }
        x = l[i] + pref[n] - pref[i + 1];
        //cout << x << " " << y << '\n';
        ans = max(ans, x + y);
    }
    cout << ans;
}

struct Node{
    ll l, r, x;
    Node() {}
};

struct segm_tree{
    vector<Node> tree;

    void upd(int v) {
        tree[v].x = max(tree[2*v].x, tree[2*v + 1].x);
    }

    void build(int v, int l, int r) {
        tree[v].l = l;
        tree[v].r = r;
        tree[v].x = -inf;
        if (r - l == 1) return;
        int m = (l + r)/2;
        build(2*v, l, m);
        build(2*v + 1, m, r);
    }

    segm_tree(int sz) {
        tree.resize(4*sz);
        build(1, 0, sz);
    }

    void st(int v, int ind, int x) {
        if (ind < tree[v].l || tree[v].r <= ind) {
            return;
        }
        if (tree[v].r - tree[v].l == 1) {
            tree[v].x = x;
            return;
        }
        st(2*v, ind, x);
        st(2*v +  1, ind, x);
        upd(v);
    }


    ll get(int v, int l, int r) {
        if (r <= tree[v].l || tree[v].r <= l) return -inf;
        if (l <= tree[v].l && tree[v].r <= r) return tree[v].x;
        return max(get(2*v, l, r), get(2*v + 1, l, r));
    }

};*/

vector<vector<int>> dist;

void solvec() {
    int n, d, gr;
    cin >> n >> d >> gr;
    dist.resize(n, vector<int>(n, inf));
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> b = a;
    sort(b.begin(), b.end());
    b.resize(unique(b.begin(), b.end()) - b.begin());
    for (int i = 0; i < n; i++) {
        a[i] = lower_bound(b.begin(), b.end(), a[i]) - b.begin();
    }
    vector<int> g[n];
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (a[i] > a[j]) continue;
            if (g[a[i]].size() >= d && g[a[i]][g[a[i]].size() - d] == a[j - d]) {
                break;
            }
            if (g[a[i]].size() < d || g[a[i]][g[a[i]].size() - d] != a[j - d]) {
                g[a[i]].push_back(a[j]);
                dist[a[i]][a[j]] = 1;
            }
        }
    }

    for (int i = n - 1; i >= 0; i--) {
        for (auto v : g[i]) {
            for (int u = v + 1; u < n; u++) {
                if (dist[i][u] > dist[i][v] + dist[v][u]) {
                    dist[i][u] = dist[i][v] + dist[v][u];
                }
            }
        }
    }

    int q;
    cin >> q;
    int t, u, v;
    for (int i = 0; i < q; i++) {
        cin >> t >> u >> v;
        u--, v--;
        u = a[u], v = a[v];
        if (dist[u][v] == inf) {
            cout << 0 << '\n';
            continue;
        }
        if (t == 1) {
            cout << 1 << '\n';
            continue;
        }
        cout << dist[u][v] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solvec();
        cout << '\n';
    }
    return 0;
}
