#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <deque>
#define int long long

using namespace std;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<bool>> gr(n, vector<bool>(n, false));
    for (int i = 0; i < n; ++i) {
        int last = i;
        for (int j = i + 1; j < n; ++j) {
            if (a[i] < a[j]) {
                if (j - last <= d) {
                    gr[i][j] = true;
                }
            }
            if (a[j] < a[i] && j - last <= d) {
                last = j;
            }
        }
    }
    int inf = 1e9;

    vector<vector<int>> cnt(n, vector<int>(n, inf));

    for (int i = 0; i < n; ++i) {
        deque<int> q;
        q.push_back(i);
        cnt[i][i] = 0;
        while (!q.empty()) {
            int u = q.front();
            q.pop_front();
            for (int v = 0; v < n; ++v) {
                if (cnt[i][v] == inf && gr[u][v]) {
                    cnt[i][v] = cnt[i][u] + 1;
                    q.push_back(v);
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (cnt[i][j] == inf) {
                cnt[i][j] = 0;
            }
        }
    }
    int q, t, u, v;
    cin >> q;
    for (int z = 0; z < q; ++z) {
        cin >> t >> u >> v;
        u--;
        v--;
        if (t == 1) {
            cout << min(1ll, cnt[u][v]) << '\n';
        } else {
            cout << cnt[u][v] << '\n';
        }
    }
}
