#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>


using namespace std;
using namespace __gnu_pbds;

#define int long long


vector<vector<int>> g;

void solve() {
    int n, d, G;
    cin >> n >> d >> G;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    g.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int streak = 1;
            int max_streak = 1;
            for (int k = i + 1; k < j; k++) {
                if (a[k] < a[i]) {
                    streak = 1;
                } else {
                    streak++;
                }
                max_streak = max(max_streak, streak);
            }
            if (max_streak <= d && a[i] < a[j]) {
                g[i].push_back(j);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        --u;
        --v;
        vector<int> dist(n, 1e18);
        dist[u] = 0;
        set<pair<int, int>> s;
        s.insert({0, u});
        while (!s.empty()) {
            int i = s.begin()->second;
            s.erase(s.begin());
            for (auto j: g[i]) {
                if (dist[j] > dist[i] + 1) {
                    if (s.find({dist[j], j}) != s.end()) {
                        s.erase(s.find({dist[j], j}));
                    }
                    dist[j] = dist[i] + 1;
                    s.insert({dist[j], j});
                }
            }
        }
        if (dist[v] == (int) 1e18) {
            cout << "0\n";
        } else {
            if (t == 1) {
                cout << 1 << '\n';
            } else {
                cout << dist[v] << "\n";
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1, G;
//    cin >> tt >> G;
    while (tt--) {
        solve();
        cout << '\n';
    }
}