//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>

#include <random>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
//typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define all(a) a.begin(), a.end()
#define rd(a) for (auto &i: a) cin >> i;

ll INF = 1e13;
ll MOD = 1e9 + 7;

bool cmp(pair<ll, ll> l, pair<ll, ll> r) {
    tuple<ll, ll> ls = {l.first + l.second, max(l.first, l.second)};
    tuple<ll, ll> rs = {r.first + r.second, max(r.first, r.second)};
    return ls > rs;

}

void solve() {

    ll n, d, g;
    cin >> n >> d >> g;
    vector<ll> a(n);
    rd(a);
    vector<ll> dr(n);
    vector<pair<ll, ll>> w;
    for (int i = 0; i < n; i++) {
        w.push_back({a[i], i});
    }
    sort(all(w));
    for (auto [A, i]: w) {
        ll l = i;
        ll r = i;
        dr[i] = i;
        while (r < n) {
            if (a[r] < a[i]) {
                l = r;
            }
            if (r - l > d) break;
            r++;

        }
        dr[i] = r;
    }
    vector<vector<ll>> dp(n, vector<ll>(n, INF));
    for (int i = 0; i < n; i++) {
        dp[i][i] = 0;
        for (int j = i + 1; j < dr[i]; j++) {
            if (a[j] > a[i]) {
                dp[i][j] = 1;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int k = 0; k < n; k++) {
            for (int j = 0; j < n; j++) {
                if (a[i] < a[k] && a[k] < a[j] && i < k && k < j) {
                    dp[i][j] = min(dp[i][j], dp[i][k] + dp[k][j]);
                }
            }
        }
    }

    ll q;
    cin >> q;
    while (q--) {
        ll t, u, v;
        cin >> t >> u >> v;
        u--;
        v--;
        if (dp[u][v] >= INF) {
            cout << "0\n";
        } else {
            if (t == 1) {
                cout << "1\n";
            } else {
                cout << dp[u][v] << "\n";
            }
        }

    }


}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

//    ll t; for (cin >> t; t--;) solve();
    solve();

}

//void operator delete(void*) {};
//const int MAX_MEM = 3 * 1e8;
//int pos = 0;
//char buf[MAX_MEM];
//void* operator new(size_t x) {
//    void* pointer = (void*)(buf + pos);
//    pos += x;
//    if (pos >= MAX_MEM) {
//        pos = 1e6;
//    }
//    return pointer;
//
//}


