#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <deque>

typedef long long ll;

using namespace std;

int main(){
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    ll n, d, g;
    cin >> n >> d >> g;
    vector <ll> a(n), b(n);
    for(int i = 0; i < n; i++){
       cin >> a[i];
       b[a[i] - 1] = i;
    } 
    ll q;
    cin >> q;
    if(n <= 1000){
        vector <vector <ll>> ans(n, vector <ll> (n, 1e9));
        for(int i = 0; i < n; i++){
            for(int j = i + 1; j <= i + d && j < n; j++){
                if(b[i] < b[j]){
                    ans[i][j] = 1;
                }
                if(b[a[i] - 1] < b[a[j] - 1]) ans[a[i] - 1][a[j] - 1] = 1;
            }
        }
        for(int i = 0; i < n; i++){
            for(int j = i + 1; j < n; j++){
                for(int k = i + 1; k < j; k++){
                    ans[i][j] = min(ans[i][j], ans[i][k] + ans[k][j]);
                }
            }
        }
        for(int i = 0; i < q; i++){
            ll t, v, u;
            cin >> t >> v >> u;
            if(ans[v - 1][u - 1] == 1e9){
                cout << 0 << "\n";
            }
            else if(t == 1){
                cout << 1 << "\n";
            }
            else{
                cout << ans[b[v - 1]][b[u - 1]] << "\n";
            }
        }
    }
}