#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 7;

int main() {
    ios::sync_with_stdio();
    cin.tie();
    cout.tie();
    int n, d, group; cin >> n >> d >> group;
    vector <int> a(n);
    for (int i=0; i < n; ++i) {
        cin >> a[i];
    }
    vector <vector <int>> dp(n, vector <int> (n));
    for (int i=0; i < n; ++i) {
        deque <pair <int, int>> window;
        window.push_back({0, i});
        for (int j=i+1; j < n; ++j) {
            dp[i][j] = window.front().first + 1;
            if (window.front().second + d == j) {
                window.pop_front();
            }
            int to_add = dp[i][j];
            if (a[j] >= a[i]) {
                to_add = INF;
            }
            while (!window.empty() && window.back().first >= to_add) {
                window.pop_back();
            }
            window.push_back({to_add, j});
        }
    }
    vector <vector <int>> g(n + 1);
    for (int i=0; i < n; ++i) {
        for (int j=0; j < n; ++j) {
            if (a[i] >= a[j] || i >= j) {
                dp[i][j] = INF;
            }
            if (dp[i][j] <= INF) {
                g[i+1].push_back(j+1);
            }
        }
    }
    vector <vector <int>> ans(n + 1, vector <int> (n + 1, INF));
    for (int i=n; i > 1; --i) {
        ans[i][i] = 0;
        for (int j=i-1; j >= 1; --j) {
            for (auto e : g[j]) {
                ans[j][i] = min(ans[j][i], ans[e][i] + 1);
            }
        }
    }
    int q; cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        if (ans[u][v] == INF) {
            cout << "0\n";
        } else {
            cout << ans[u][v] << "\n";
        }
    }
    return 0;
}
