#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = 1e18;

mt19937_64 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

struct Fast {

    void solve() {
        ll n, d, gr;
        cin >> n >> d >> gr;
        vector<ll> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        vector<vector<ll>> g(n);
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j <= min(n - 1, i + d); j++) {
                if (a[j] > a[i]) g[i].push_back(j);
            }
        }
        ll qs;
        cin >> qs;
        while (qs--) {
            ll t, u, v;
            cin >> t >> u >> v, u--, v--;
            vector<ll> dist(n, inf);
            deque<ll> q;
            q.push_back(u);
            dist[u] = 0;
            while (!q.empty()) {
                ll vм = q.front();
                q.pop_front();
                for (auto to: g[vм]) {
                    if (dist[to] == inf) {
                        dist[to] = dist[vм] + 1;
                        q.push_back(to);
                    }
                }
            }
            if (dist[v] == inf) {
                cout << 0 << '\n';
            } else if (t == 1) cout << 1 << '\n';
            else cout << dist[v] << '\n';
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll times = 1;
    bool stres = false;
    if (stres) times = 1e9;
//    else cin >> times;
    while (times--) {
        if (!stres) {
            Fast f;
            f.solve();
        }
    }
    return 0;
}
