#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//#define int long long

signed solve12(int n, int d) {
    vector<int> a(n);
    for (int &now : a) cin >> now;
    vector<int> max_to(n);
    std::iota(max_to.begin(), max_to.end(), 0);
    for (int i = 0; i < n; ++i) {
        int last_hop = i;
        for (int j = i + 1; j < n; ++j) {
            if (j - last_hop > d) break;
            if (a[j] < a[i]) last_hop = j;
        }
        max_to[i] = last_hop;
    }
    int q;
    cin >> q;

    vector graph(n, vector<int>());
    vector dist(n, vector<int>(n, n + 57));

    for (int i = 0; i < n; ++i) {
        dist[i][i] = 0;
        for (int j = i + 1; j < min(n, d + 1 + max_to[i]); ++j) {
            if (a[i] < a[j]) {
                graph[i].push_back(j);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        queue<int> nya{{i}};
        while (!nya.empty()) {
            int v = nya.front();
            nya.pop();
            for (int ch : graph[v]) {
                if (dist[i][ch] > dist[i][v] + 1) {
                    dist[i][ch] = dist[i][v] + 1;
                    nya.push(ch);
                }
            }
        }
    }

    while (q --> 0) {
        int t, u, v;
        cin >> t >> u >> v;
        --u, --v;
        if (dist[u][v] == n + 57) {
            cout << "0\n";
        } else if (t == 1) {
            cout << "1\n";
        } else {
            cout << dist[u][v] << '\n';
        }
    }
    return 0;
}

signed solve(int n, int d) {
    vector<int> a(n);
    for (int &now : a) cin >> now;
    vector<int> max_to(n);
    std::iota(max_to.begin(), max_to.end(), 0);
    vector graph(n, vector<int>());
    for (int i = 0; i < n; ++i) {
        int last_hop = i;
        for (int j = i + 1; j < n; ++j) {
            if (j - last_hop > d) break;
            if (a[j] < a[i]) last_hop = j;
            else {
                graph[i].push_back(j);
                if (graph[i].size() == 15) break;
            }
        }
        max_to[i] = last_hop;
    }

    int q;
    cin >> q;

    vector comp(n, 0);
    int xd = 1;

    for (int i = 0; i < n; ++i) {
        if (comp[i] == 0) {
            comp[i] = xd++;
            queue<int> nya{{i}};
            while (!nya.empty()) {
                int v = nya.front();
                nya.pop();
                for (int ch : graph[v]) {
                    if (comp[ch] == 0) {
                        comp[ch] = comp[v];
                        nya.push(ch);
                    }
                }
            }
        }
    }

    while (q --> 0) {
        int t, u, v;
        cin >> t >> u >> v;
        --u, --v;
        if (a[u] > a[v] || comp[u] != comp[v]) {
            cout << "0\n";
        } else if (t == 1) {
            cout << "1\n";
        } else {
            cout << 1 << '\n';
        }
    }
    return 0;
}

signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, d, g;
    cin >> n >> d >> g;
    if (g == 1 || g == 2) {
        return solve12(n, d);
    }
    return solve(n, d);
//    return 0;
}
