#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int inf = 1e9;

void solve() {
    int n, d, gr;
    cin >> n >> d >> gr;
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i];
        p[i]--;
    }
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < n; i++) {
        deque<int> pq;
        pq.push_back(i);
        vector<int> dist(n, inf);
        dist[i] = 0;
        while (!pq.empty()) {
            auto u = pq.front();
            pq.pop_front();
            for (int j = u + 1; j < min(n, u + d + 1); j++) {
                if (p[j] < p[i] && dist[j] > 0) {
                    dist[j] = 0;
                    pq.push_back(j);
                }
            }
            for (int j = u + 1; j < min(n, u + d + 1); j++) {
                if (p[j] > p[i] && dist[j] == inf) {
                    dist[j] = 1;
                }
            }
        }
        //cout << "ones of " << i + 1 << '\n';
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (dist[j] == 1) {
                //cout << j + 1 << ' ';
                g[j].push_back({i, 1});
                //g[i].push_back({j, 1});
            }
        }
        //cout << '\n';
    }
    vector<vector<int>> dists(n, vector<int> (n, inf));
    for (int i = 0; i < n; i++) {
        dists[i][i] = 0;
        deque<int> pq;
        pq.push_back(i);
        while (!pq.empty()) {
            auto un = pq.front();
            pq.pop_front();
            for (auto [vn, w] : g[un]) {
                if (dists[i][vn] > dists[i][un] + w) {
                    dists[i][vn] = dists[i][un] + w;
                    pq.push_back(vn);
                }
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int t, u, v;
        cin >> t >> u >> v;
        u--;
        v--;
        if (p[u] > p[v]) {
            cout << 0 << '\n';
            continue;
        }
        //cout << "kek\n";
        if (dists[v][u] == inf) {
            cout << "0\n";
            continue;
        }
        if (t == 1) {
            cout << 1 << '\n';
        } else {
            cout << dists[v][u] << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; i++) solve();
}
