#include<bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1031, INF = 1e9;

int dist[MAXN][MAXN];

vector<int> g[MAXN];
int n, d, gr;
int a[MAXN];

void check(int a, int b){
    for(int i = 0; i < n; i++) dist[a][i] = INF;
    dist[a][a] = 0;
    deque<int> q;
    q.push_back(a);
    while (!q.empty()){
        int now = q.front();
        q.pop_front();
        for(auto to : g[now]){
            if(to == now) continue;
            if(dist[a][to] <= dist[a][now]+1) continue;
            dist[a][to] = dist[a][now]+1;
            q.push_back(to);
        }
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> d >> gr;
    for(int i = 0; i < n; i++) cin >> a[i];
    for(int i = 0; i < n; i++){
        int last = i;
        for(int j = i+1; j < n; j++){
            if(j - last > d) break;
            if(a[j] > a[i]){
                g[i].push_back(j);
            }
            else{
                last = j;
            }
        }
    }
    for(int i = 0; i < n; i++) check(i, i);
    int q;
    cin >> q;
    while(q--){
        int t, a, b;
        cin >> t >> a >> b;
        a--; b--;
        if(t == 1){
            int res = dist[a][b];
            if(res >= INF) cout << 0 << "\n";
            else cout << 1 << "\n";
        }
        if(t == 2){
            int res = dist[a][b];
            if(res >= INF) cout << 0 << "\n";
            else cout << res << "\n";
        }
    }
}
