#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <iomanip>
#include <math.h>
#include <queue>

//#pragma target("ofast, o3, avx2")

using namespace std;

#define INF ((ll)1e18)
#define ll long long
#define db double
#define str string
#define vc vector
#define its(a) (a).begin(),(a).end()
#define itsr(a) (a).rbegin(),(a).rend()
#define sz(a) (a).size()
ll n, d, g;
void stup() {
	vc<ll> a(n);
	for (auto& i : a) cin >> i;
	vc<vc<ll>> g(n);
	//vc<vc<ll>> dist(n, vc<ll>(n));
	for (int i = 0; i < n; ++i) {
		ll lst = i;
		for (int j = i + 1; j < n; ++j) {
			if (a[j] < a[i]) lst = j;
			if (j - lst > d) break;
			if (a[j] > a[i]) g[i].push_back(j);
		}
	}
	vc<vc<ll>> dist(n, vc<ll>(n, -1));
	auto bfs = [&](int s) -> void {
		queue<ll> q;
		dist[s][s] = 0;
		q.push(s);
		while (sz(q)) {
			auto u = q.front();
			q.pop();
			for (auto v : g[u]) {
				if (dist[s][v] == -1) {
					dist[s][v] = dist[s][u] + 1;
					q.push(v);
				}
			}
		}
		};
	for (int i = 0; i < n; ++i) {
		bfs(i);
	}
	ll q; cin >> q;
	while (q--) {
		ll t, u, v;
		cin >> t >> u >> v;
		--u, --v;
		if (t == 1) {
			if (dist[u][v] == -1) cout << "0\n";
			else cout << "1\n";
		}
		else {
			if (dist[u][v] == -1) cout << "0\n";
			else cout << dist[u][v] << '\n';
		}
	}
}
void solve() {
	cin >> n >> d >> g;
	if (g <= 2) {
		stup();
	}

}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll _t = 1;
	//cin >> _t;
	while (_t--) solve();
}
