#include <bits/stdc++.h>

#define int int64_t
#define endl '\n'
#define pb push_back
#define pw(x) (int64_t(1)<<x)
#define TIME 1.0*clock()/CLOCKS_PER_SEC

using namespace std;

const int INF = 1e9;
mt19937 gen(time(0));

const int N = 100;

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, d, g;
    cin >> n >> d >> g;
    int a[n];
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    vector <vector <bool>> can(n, vector <bool> (n, 0));
    for (int i = 0; i < n; ++i) {
        vector <bool> have(n);
        have[i] = 1;
        can[i][i] = 1;
        for (int j = i; j < n; ++j) {
            for (int ps = j - 1; ps >= i; --ps) {
                if (a[ps] < a[i] || ps == i) {
                    if (j - ps <= d && have[ps]) {
                        if (a[j] > a[i]) can[i][j] = 1;
                        if (a[j] < a[i]) {
                            have[j] = 1;
                        }
                    }
                }
            }
            if (a[j] > a[i] && j - i <= d) {
                can[i][j] = 1;
            }
        }
    }
    int it = 0;
    while (q--) {
        it++;
        int t, x, y;
        cin >> t >> x >> y;
        x--;
        y--;
        if (a[x] >= a[y]) {
            cout << 0 << endl;
            continue;
        }
        vector <int> dp(n, INF);
        dp[x] = 0;
        for (int i = x; i < y; ++i) {
            for (int j = i + 1; j <= y; ++j) {
                if (can[i][j]) {
                    dp[j] = min(dp[j], dp[i] + 1);
                }
            }
        }
//        cerr << it << endl;
//        for (auto to : dp) {
//            cerr << to << ' ';
//        }
//        cerr << endl;
        if (t == 1) {
            if (dp[y] == INF) {
                cout << 0 << endl;
            } else {
                cout << 1 << endl;
            }
        } else {
            if (dp[y] == INF) {
                cout << 0 << endl;
            } else {
                cout << dp[y] << endl;
            }
        }
    }
}
