//Alors on dance

#include<bits/stdc++.h>

const int N = 3e5;
const int B = 500;

int n, d;
struct sqrt_array {
    int tim = 0;
    int val_block[B], tim_block[B];
    int val_elem[N], tim_elem[N];

    void set(int l, int r, int x) {
        tim++;
        for (; l <= r; ++l) {
            if (l % B == 0 && l + B - 1 <= r) {
                val_block[l / B] = x;
                tim_block[l / B] = tim;
                l += B - 1;
            } else {
                val_elem[l] = x;
                tim_elem[l] = tim;
            }
        }
    }

    void set(int k, int x) {
        set(k, k, x);
    }

    int& operator[](int i) {
        if (tim_block[i / B] > tim_elem[i]) {
            tim_elem[i] = tim_block[i / B];
            val_elem[i] = val_block[i / B];
        }
        return val_elem[i];
    }
} moves, nxt, jump;

void update(int block) {
    int l = block * B;
    int r = std::min(block * B + B, n);
    for (int i = r - 1; i >= l; --i) {
        if (jump[i] == -1) {
            nxt[i] = -1;
            moves[i] = 0;
            continue;
        }
        if (jump[i] >= r) {
            nxt[i] = jump[i];
            moves[i] = 1;
        } else {
            nxt[i] = nxt[jump[i]];
            moves[i] = moves[jump[i]] + 1;
        }
    }
}

std::vector<int> calc(std::vector<int> a) {
    std::vector<int> pos(n), rb(n);
    for (int i = 0; i < n; ++i) pos[a[i]] = i;
    {
        std::set<std::pair<int, int>> st = {{n, n}};
        st.emplace(0, n - 1);
        for (int i = 0; i < n; ++i) {
            int k = pos[i];
            if (st.upper_bound({k, n + 1}) != st.begin()) {
                auto [l, r] = *--st.upper_bound({k, n + 1});
                if (l <= k && k <= r) {
                    st.erase({l, r});
                    if (k - l >= d) {
                        st.emplace(l, k - 1);
                    }
                    if (r - k >= d) {
                        st.emplace(k + 1, r);
                    }
                }
            }
//            std::cout << i << ' ' << k << std::endl;
//            for (auto [l, r] : st) std::cout << l << ' ' << r << ' ' << ' ';
//            std::cout << std::endl;
            rb[i] = st.lower_bound({k, -1})->first + d - 1;
            rb[i] = std::min(rb[i], n - 1);
        }
    }
//    for (auto i : rb) std::cout << i << ' ';
//    std::cout << std::endl;
    return rb;
}

std::vector<int> calc2(std::vector<int> a) {
    std::vector<int> pos(n), rb(n);
    for (int i=  0; i < n; ++i) pos[a[i]] = i;
    {
        for (int i = 0; i < n; ++i) {
            int lst = i;
            rb[i] = n - 1;
            for (int j = i + 1; j < n; ++j) {
                if (j - lst > d) {
                    rb[i] = j - 1;
                    break;
                }
                if (a[j] < a[i]) {
                    lst = j;
                }
            }
        }
    }
    return rb;
}

std::mt19937 rnd(252);

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);

//    int n = 20;
//    std::vector<int> p(n);
//    std::iota(p.begin(), p.end(), 0);
//    while (true) {
//        std::shuffle(p.begin(), p.end(), rnd);
//        if (calc(p) != calc2(p)) {
//            for (auto i : p) std::cout << i << ' ';
//            std::cout << std::endl;
//            for (auto i : calc(p)) std::cout << i << ' ';
//            std::cout << std::endl;
//            for (auto i : calc2(p)) std::cout << i << ' ';
//            std::cout << std::endl;
//            break;
//        }
//        std::cout << "OK" << std::endl;
//        for (auto i : p) std::cout << i << ' ';
//        std::cout << std::endl;
//    }

    int group;
    std::cin >> n >> d >> group;
    std::vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
        --a[i];
    }
    auto rb = calc2(a);
    int q;
    std::cin >> q;
    while (q--) {
        int t, u, v;
        std::cin >> t >> u >> v;
        --u, --v;
        if (a[u] > a[v]) {
            std::cout << "0\n";
            continue;
        }
        int mx = u;
        int res = 0;
        for (int i = u; i < v; ++i) {
            if (a[i] <= a[v] && a[mx] < a[i]) mx = i;
            if (i == rb[u]) {
                u = mx;
                res++;
            }
            if (i == rb[u]) {
                res = 0;
                break;
            }
        }
        if (v > rb[u]) res = 0;
        else res++;
        if (t == 1) std::cout << std::min(1, res) << "\n";
        else std::cout << res << '\n';
    }
    return 0;
//    std::vector<std::vector<std::pair<int, int>>> qq(n);
//    int q;
//    std::cin >> q;
//    std::vector<int> ans(q), t(q);
//    for (int i = 0; i < q; ++i) {
//        int u, v;
//        std::cin >> t[i] >> u >> v;
//        --u, --v;
//        qq[a[u]].emplace_back(v, i);
//    }
//    jump.set(0, n - 1, -1);
//    nxt.set(0, n - 1, -1);
//    std::set<int> st = {(int)1e9};
//    for (int _ = 0; _ < n; ++_) {
//        int k = pos[_];
//        {
//            int i = st.upper_bound(k + d) == st.begin() ? -1 : *--st.upper_bound(k + d);
//            if (i > k) jump.set(k, i);
//            else jump.set(k, -1);
//            update(k / B);
//            int j = *st.upper_bound(k);
//            int l = k - d, r = j - d - 1;
//            l = std::max(l, 0);
//            r = std::min(r, k - 1);
//            if (l <= r) {
//                jump.set(l, r, k);
//                for (auto b: {l / B, r / B}) {
//                    update(b);
//                }
//                int l_ = (l / B) * B + B, r_ = (r / B) * B;
//                nxt.set(l_, r_ - 1, k);
//                moves.set(l_, r_ - 1, 1);
//            }
//            st.insert(k);
//        }
//        std::cout << _ << ' ' << k << std::endl;
//        for (int i = 0; i < n; ++i) {
//            std::cout << jump[i] << ' ';
//        }
//        std::cout << std::endl;
//        for (int i = 0; i < n; ++i) {
//            std::cout << moves[i] << ' ';
//        }
//        std::cout << std::endl;
//        for (int i = 0; i < n; ++i) {
//            std::cout << nxt[i] << ' ';
//        }
//        std::cout << std::endl;
//        for (auto [r, id] : qq[_]) {
//            r--;
//            int l = k;
//            int res = 0;
//            while (l <= r) {
//                if (nxt[l] != -1 && nxt[l] <= r) {
//                    res += moves[l];
//                    l = nxt[l];
//                } else if (jump[l] != -1 && jump[l] <= r) {
//                    res++;
//                    l = jump[l];
//                } else {
//                    break;
//                }
//            }
//            std::cout << k << ' ' << r << ' ' << id << ' ' << res << ' ' << l << std::endl;
//            if (r - l > d) res = 0;
//            ans[id] = res;
//        }
//    }
//    for (int i = 0; i < q; ++i) {
//        if (t[i] == 1) std::cout << std::min(ans[i], 1) << '\n';
//        else std::cout << ans[i] << '\n';
//    }
}