//Alors on dance

#include<bits/stdc++.h>

const int N = 3e5;
const int B = 500;

int n, d;
struct sqrt_array {
    int tim = 0;
    int val_block[B], tim_block[B];
    int val_elem[N], tim_elem[N];

    void set(int l, int r, int x) {
        tim++;
        for (; l <= r; ++l) {
            if (l % B == 0 && l + B - 1 <= r) {
                val_block[l / B] = x;
                tim_block[l / B] = tim;
                l += B - 1;
            } else {
                val_elem[l] = x;
                tim_elem[l] = tim;
            }
        }
    }

    void set(int k, int x) {
        set(k, k, x);
    }

    int& operator[](int i) {
        if (tim_block[i / B] > tim_elem[i]) {
            tim_elem[i] = tim_block[i / B];
            val_elem[i] = val_block[i / B];
        }
        return val_elem[i];
    }
} moves, nxt, jump;

void update(int block) {
    int l = block * B;
    int r = std::min(block * B + B, n);
    for (int i = r - 1; i >= l; --i) {
        if (jump[i] == -1) {
            nxt[i] = -1;
            moves[i] = 0;
            continue;
        }
        if (jump[i] >= r) {
            nxt[i] = jump[i];
            moves[i] = 1;
        } else {
            nxt[i] = nxt[jump[i]];
            moves[i] = moves[jump[i]] + 1;
        }
    }
}

std::vector<int> calc(std::vector<int> a) {
    std::vector<int> pos(n), rb(n);
    for (int i = 0; i < n; ++i) pos[a[i]] = i;
    {
        std::set<std::pair<int, int>> st = {{n, n}};
        st.emplace(0, n - 1);
        for (int i = 0; i < n; ++i) {
            int k = pos[i];
            if (st.upper_bound({k, n + 1}) != st.begin()) {
                auto [l, r] = *--st.upper_bound({k, n + 1});
                if (l <= k && k <= r) {
                    st.erase({l, r});
                    if (k - l >= d) {
                        st.emplace(l, k - 1);
                    }
                    if (r - k >= d) {
                        st.emplace(k + 1, r);
                    }
                }
            }
            rb[k] = st.lower_bound({k, -1})->first + d - 1;
            rb[k] = std::min(rb[k], n - 1);
        }
    }
    return rb;
}
struct sparse {
    int n;
    std::vector<std::vector<std::pair<int, int>>> spt;
    std::vector<int> lg;;

    sparse() = default;
    sparse(std::vector<std::pair<int, int>> ss) {
        n = ss.size();
        spt.resize(n, std::vector<std::pair<int, int>>(20));
        for (int i = 0; i < n; ++i) {
            spt[i][0] = ss[i];
        }
        for (int k = 0; k < 20; ++k) {
            for (int i = 0; i + (1 << k) < n; ++i) {
                spt[i][k + 1] = std::max(spt[i][k], spt[i + (1 << k)][k]);
            }
        }
        lg.assign(n + 1, 0);
        for (int i = 2; i <= n; ++i) lg[i] = lg[i >> 1] + 1;
    }

    std::pair<int, int> get(int l, int r) {
        int k = lg[r - l + 1];
        return std::max(spt[l][k], spt[r - (1 << k) + 1][k]);
    }
};

struct segtree {
    int n;
    std::vector<std::pair<int, int>> tr;

    segtree() = default;
    segtree(int n) : n(n), tr(2 * n, {-1e9, -1e9}) {}

    void upd(int k, std::pair<int, int> x) {
        for (tr[k += n] = x; k > 1; k >>= 1, tr[k] = std::max(tr[k << 1], tr[k << 1 | 1]));
    }

    std::pair<int, int> get(int l, int r) {
        std::pair<int, int> res = {-1e9, -1e9};
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1) res = std::max(res, tr[l++]);
            if (~r & 1) res = std::max(res, tr[r--]);
        }
        return res;
    }
};

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);


    int group;
    std::cin >> n >> d >> group;
    std::vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
        --a[i];
    }
    auto rb = calc(a);
    if (3 <= group && group <= 5) {
        sparse spt;
        {
            std::vector<std::pair<int, int>> aboba;
            for (int i = 0; i < n; ++i)
                if (a[i] <= a.back()) aboba.emplace_back(a[i], i);
                else aboba.emplace_back(-1e9, i);
            spt = sparse(aboba);
        }
        std::vector<int> dp(n, 1e9);
        dp[n - 1] = 0;
        for (int i = n - 2; i >= 0; --i) {
            if (a[i] > a.back()) continue;
            int mx = spt.get(i, rb[i]).second;
            dp[i] = std::min(dp[i], dp[mx] + 1);
        }
        int q;
        std::cin >> q;
        while (q--) {
            int t, u, v;
            std::cin >> t >> u >> v;
            --u, --v;
            int res = 0;
            if (dp[u] == 1e9) res = 0;
            else res = dp[u];
            if (t == 1) std::cout << std::min(1, res) << "\n";
            else std::cout << res << '\n';
        }
    } else if (group <= 7) {
        int q;
        std::cin >> q;
        std::vector<int> ans(q, 0), type(q);
        std::vector<std::vector<std::pair<int,int>>> qq(n);
        segtree tr(n);
        for (int i = 0; i < q; ++i) {
            int u, v;
            std::cin >> type[i] >> u >> v;
            --u, --v;
            if (a[u] > a[v]) {
                continue;
            }
            qq[a[v]].emplace_back(u, i);
        }
        std::vector<int> pos(n);
        for (int i = 0; i < n; ++i) pos[a[i]] = i;
        for (int i = 0; i < n; ++i) {
            int k = pos[i];
            tr.upd(k, {a[k], k});
            for (auto [u, id] : qq[i]) {
                int res = 0;
                while (rb[u] < k) {
                    int mx = tr.get(u, rb[u]).second;
                    if (mx == u) {
                        break;
                    }
                    res++;
                    u = mx;
                }
                if (k > rb[u]) res = 0;
                else res++;
                if (type[id] == 1) ans[id] = std::min(1, res);
                else ans[id] = res;
            }
        }
        for (int i = 0; i < q; ++i) std::cout << ans[i] << '\n';
    } else {
        int q;
        std::cin >> q;
        std::vector<int> ans(q, 0), type(q);
        std::vector<std::vector<std::pair<int,int>>> qq(n);
        for (int i = 0; i < q; ++i) {
            int u, v;
            std::cin >> type[i] >> u >> v;
            --u, --v;
            if (a[u] > a[v]) {
                continue;
            }
            qq[a[v]].emplace_back(u, i);
        }
        std::vector<int> pos(n);
        std::set<std::pair<int, int>> seg;
        for (int i = 0; i < n; ++i) pos[a[i]] = i;
        for (int i = 0; i < n; ++i) {
            int k = pos[i];
            int l = k, r = rb[k];
            while (seg.lower_bound({l, -1}) != seg.end() && seg.lower_bound({l, -1})->first <= r) {
                auto o = seg.lower_bound({l, -1});
                l = std::min(l, o->first);
                r = std::max(r, o->second);
                seg.erase(o);
            }
            while (seg.upper_bound({r, n + 1}) != seg.begin() && (--seg.upper_bound({r, n + 1}))->second >= l) {
                auto o = (--seg.upper_bound({r, n + 1}));
                l = std::min(l, o->first);
                r = std::max(r, o->second);
                seg.erase(o);
            }
            seg.emplace(l, r);
            for (auto [u, id] : qq[i]) {
                if (l <= u && u <= r) {
                    ans[id] = 1;
                } else {
                    ans[id] = 0;
                }
            }
        }
        for (int i = 0; i < q; ++i) std::cout << ans[i] << '\n';
    }
    return 0;
//    std::vector<std::vector<std::pair<int, int>>> qq(n);
//    int q;
//    std::cin >> q;
//    std::vector<int> ans(q), t(q);
//    for (int i = 0; i < q; ++i) {
//        int u, v;
//        std::cin >> t[i] >> u >> v;
//        --u, --v;
//        qq[a[u]].emplace_back(v, i);
//    }
//    jump.set(0, n - 1, -1);
//    nxt.set(0, n - 1, -1);
//    std::set<int> st = {(int)1e9};
//    for (int _ = 0; _ < n; ++_) {
//        int k = pos[_];
//        {
//            int i = st.upper_bound(k + d) == st.begin() ? -1 : *--st.upper_bound(k + d);
//            if (i > k) jump.set(k, i);
//            else jump.set(k, -1);
//            update(k / B);
//            int j = *st.upper_bound(k);
//            int l = k - d, r = j - d - 1;
//            l = std::max(l, 0);
//            r = std::min(r, k - 1);
//            if (l <= r) {
//                jump.set(l, r, k);
//                for (auto b: {l / B, r / B}) {
//                    update(b);
//                }
//                int l_ = (l / B) * B + B, r_ = (r / B) * B;
//                nxt.set(l_, r_ - 1, k);
//                moves.set(l_, r_ - 1, 1);
//            }
//            st.insert(k);
//        }
//        std::cout << _ << ' ' << k << std::endl;
//        for (int i = 0; i < n; ++i) {
//            std::cout << jump[i] << ' ';
//        }
//        std::cout << std::endl;
//        for (int i = 0; i < n; ++i) {
//            std::cout << moves[i] << ' ';
//        }
//        std::cout << std::endl;
//        for (int i = 0; i < n; ++i) {
//            std::cout << nxt[i] << ' ';
//        }
//        std::cout << std::endl;
//        for (auto [r, id] : qq[_]) {
//            r--;
//            int l = k;
//            int res = 0;
//            while (l <= r) {
//                if (nxt[l] != -1 && nxt[l] <= r) {
//                    res += moves[l];
//                    l = nxt[l];
//                } else if (jump[l] != -1 && jump[l] <= r) {
//                    res++;
//                    l = jump[l];
//                } else {
//                    break;
//                }
//            }
//            std::cout << k << ' ' << r << ' ' << id << ' ' << res << ' ' << l << std::endl;
//            if (r - l > d) res = 0;
//            ans[id] = res;
//        }
//    }
//    for (int i = 0; i < q; ++i) {
//        if (t[i] == 1) std::cout << std::min(ans[i], 1) << '\n';
//        else std::cout << ans[i] << '\n';
//    }
}