#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <cmath>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;
const int INF = 1e9;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, d, g;
	cin >> n >> d >> g;
	vector<int> a(n);
	vector<int> que(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		a[i]--;
		que[a[i]] = i;
	}
	vector<vector<int>> gr(n);
	for (int start = 0; start < n; ++start) {
		vector<int> ost_ind;
		for (int j = 0; j < n; ++j) {
			if (a[j] < a[start])
				ost_ind.push_back(j);
		}
		ost_ind.push_back(start);
		sort(ost_ind.begin(), ost_ind.end());
		int j = distance(ost_ind.begin(), lower_bound(ost_ind.begin(), ost_ind.end(), start));
		int k = j;
		set<int> dost;
		while (k + 1 < ost_ind.size() && ost_ind[k + 1] - start <= d) {
			k++;
			dost.insert(k);
		}
		k = j;
		while (k - 1 >= 0 && start - ost_ind[k - 1] <= d) {
			k--;
			dost.insert(k);
		}
		for (int fin = start + 1; fin < n; ++fin) {
			if (a[fin] < a[start]) continue;
			if (fin - start <= d) {
				gr[start].push_back(fin);
				continue;
			}
			if (dost.lower_bound(fin) != dost.begin()) {
				int lst = *prev(dost.lower_bound(fin));
				if (fin - lst <= d) {
					gr[start].push_back(fin);
				}
			}
		}
	}
	vector<vector<int>> dist(n, vector<int>(n, INF));
	for (int u = 0; u < n; ++u) {
		dist[u][u] = 0;
		deque<int> queue;
		queue.push_back(u);
		while (!queue.empty()) {
			int v = queue.front();
			queue.pop_front();
			for (int w : gr[v]) {
				if (dist[u][w] > dist[u][v] + 1) {
					queue.push_back(w);
					dist[u][w] = dist[u][v] + 1;
				}
			}
		}
	}
	int q; cin >> q;
	for (int _ = 0; _ < q; ++_) {
		int t, u, v;
		cin >> t >> u >> v;
		u--; v--;
		cout << "     ";
		if (dist[u][v] == INF)
			cout << 0 << "\n";
		else if (t == 1)
			cout << 1 << "\n";
		else
			cout << dist[u][v] << "\n";
	}

	return 0;
}