#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9 + 1;
const int mod = inf + 6;
const ll infll = 1ll * (inf - 1) * (inf - 1);
mt19937_64 rnd(228);//time(0));
const int N = 3e5 + 1;
void solve_case() {
    int n, d, G;
    cin >> n >> d >> G;
    vector<int> a(n);
    d = min(d, n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    vector<int> ad(n - d + 1);
    {
        set<int> st;
        for (int i = 0; i < d; i++) st.insert(a[i]);
        for (int i = 0; i + d <= n; i++) {
            ad[i] = *st.begin();
            st.erase(a[i]);
            if (i + d != n) st.insert(a[i + d]);
        }
    }
    vector<int> maxR(n);
    {
        vector<int> stk;
        for (int i = n - 1; i >= 0; i--) {
            maxR[i] = min(n - 1, i + d);
            while (maxR[i] != n - 1 && ad[maxR[i] + 1 - d] <= a[i]) maxR[i]++;
        }
    }
    int q;
    cin >> q;
    for (int iq = 0; iq < q; iq++) {
        int t, l, r;
        cin >> t >> l >> r;
        l--, r--;
        vector<int> dp(n, inf);
        dp[l] = 0;
        for (int i = l; i < n; i++) {
            for (int j = i + 1; j <= maxR[i]; j++) {
                if (a[j] > a[i]) {
                    chmin(dp[j], dp[i] + 1);
                }
            }
        }
        bool zero = false;
        for (int i = l; i < n; i++) {
            if (a[i] >= a[l]) {
                if (dp[i] == inf) {
                    zero = true;
                } else {
                    assert(!zero);
                }
            }
        }
        int ans = dp[r];
        if (ans == inf) ans = 0;
        if (t == 1 && ans != 0) ans = 1;
        cout << ans << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    //cin >> T;
    while (T--) {
        solve_case();
    }
}
