#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()

const int INF = 1e9;

vector<vector<int>> g;
vector<vector<int>> dist;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, d, group;
    cin >> n >> d >> group;
    g.resize(n);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        int lastLess = i;
        for (int j = i + 1; j < n; ++j) {
            if (a[j] < a[i]) {
                if (j - lastLess > d) break;
                lastLess = j;
            } else if (a[j] > a[i]) {
                if (j - lastLess <= d) g[i].push_back(j);
            }
        }
    }
    dist.resize(n, vector<int>(n, INF));
    for (int i = 0; i < n; ++i) {
        dist[i][i] = 0;
        for (auto to : g[i]) dist[i][to] = 1;
    }
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int tp, u, v;
        cin >> tp >> u >> v;
        --u; --v;
        if (tp == 1) {
            cout << (int)(dist[u][v] != INF) << "\n";
        } else {
            cout << (dist[u][v] != INF ? dist[u][v] : 0) << "\n";
        }
    }
}

