#include<bits/stdc++.h>

using namespace std;

using ll = long long;

vector<vector<int>> g;

int const INF = 1e9;

void bfs(int s, vector<int> &dist) {
    deque<int> q;
    q.push_back(s);
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (auto u : g[v]) {
            if (dist[v] + 1 < dist[u]) {
                dist[u] = dist[v] + 1;
                q.push_back(u);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, d, x;
    cin >> n >> d >> x;
    vector<int> a(n);
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        int f = 1, last = i;
        for (int j = i + 1; j < n; ++j) {
            if (a[j] < a[i])
                last = j;
            if (j - last > d)
                f = 0;
            if (a[i] < a[j] && f)
                g[i].push_back(j);
            if (f == 0)
                break;
        }
    }
//    for (int i = 0; i < n; ++i) {
//        cout << i + 1 << ": ";
//        for (auto el : g[i])
//            cout << el + 1 << " ";
//        cout << endl;
//    }
    int q;
    cin >> q;
    while (q--) {
        int t, v, u;
        cin >> t >> v >> u;
        v--; u--;
        vector<int> dist(n, INF);
        dist[v] = 0;
        bfs(v, dist);
        if (dist[u] == INF)
            cout << "0\n";
        else if (t == 2)
            cout << dist[u] << "\n";
        else
            cout << "1\n";
    }
}


