#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const int INF = (int)1e9;

void solve() {
  int n, d, group;
  cin >> n >> d >> group;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    --a[i];
  }
  if (group == 4) {
    int foo, type, from, to;
    cin >> foo >> type >> from >> to;
    --from, --to;
    if (a[from] > a[to]) {
      cout << 0;
      return;
    }
    int ans = 0;
    while (true) {
      int prv = from;
      for (int cur = from + 1; cur <= to; ++cur) {
        if (a[cur] < a[from] && cur - prv <= d) {
          prv = cur;
        }
      }
      if (prv + d >= to) {
        cout << ans + 1;
        return;
      }
      int id = -1;
      for (int i = from + 1; i <= prv + d; ++i) {
        if (a[i] > a[from] && a[i] < a[to] && (id == -1 || a[i] > a[id])) {
          id = i;
        }
      }
      if (id == -1) {
        cout << 0;
        return;
      }
      from = id;
      ans += 1;
    }
  }
  if (group == 8) {
    vector<int> suff(n);
    suff[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; --i) {
      suff[i] = min(suff[i + 1], a[i]);
    }
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) {
      pos[a[i]] = i;
    }
    int max_log = 32 - __builtin_clz(n);
    vector<vector<int>> jmp(max_log, vector<int>(n));
    jmp[0][n - 1] = n - 1;
    for (int i = n - 2; i >= 0; --i) {
      if (suff[i + 1] < a[i]) {
        jmp[0][i] = i;
      } else {
        jmp[0][i] = pos[suff[i + 1]];
      }
    }
    for (int lg = 1; lg < max_log; ++lg) {
      for (int v = 0; v < n; ++v) {
        jmp[lg][v] = jmp[lg - 1][jmp[lg - 1][v]];
      }
    }
    int q;
    cin >> q;
    while (q--) {
      int type, from, to;
      cin >> type >> from >> to;
      --from, --to;
      if (a[from] > a[to]) {
        cout << 0 << '\n';
        continue;
      }
      int cur = from;
      for (int lg = max_log - 1; lg >= 0; --lg) {
        if (jmp[lg][cur] <= to && a[jmp[lg][cur]] <= a[to]) {
          cur = jmp[lg][cur];
        }
      }
      if (cur == to || a[cur] < a[to]) {
        cout << 1 << '\n';
      } else {
        cout << 0 << '\n';
      }
    }
  }
  if (group <= 2) {
    vector<vector<int>> g(n, vector<int>(n, INF));
    for (int i = 0; i < n; ++i) {
      g[i][i] = 0;
    }
    for (int i = 0; i < n; ++i) {
      for (int j = i + 1; j < n; ++j) {
        if (a[i] > a[j]) {
          continue;
        }
        if (j - i <= d) {
          g[i][j] = 1;
          continue;
        }
        int prv = i;
        bool ok = true;
        for (int k = i + 1; k < j; ++k) {
          if (a[k] < a[i]) {
            if (k - prv > d) {
              ok = false;
              break;
            }
            prv = k;
          }
        }
        if (ok && j - prv <= d) {
          g[i][j] = 1;
        }
      }
    }
    for (int k = 0; k < n; ++k) {
      for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
          g[i][j] = min(g[i][j], g[i][k] + g[k][j]);
        }
      }
    }
    int q;
    cin >> q;
    while (q--) {
      int type, from, to;
      cin >> type >> from >> to;
      --from, --to;
      if (type == 1) {
        cout << (g[from][to] != INF) << '\n';
      } else {
        cout << (g[from][to] == INF ? 0 : g[from][to]) << '\n';
      }
    }
    return;
  }

}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
