#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)x.size()

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, a) for(auto& x: a)

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 3e5 + 1;

vector<pii> id;
vector<vector<int>> g(N);

int main() {
    int n, d, g;
    cin >> n >> d >> g;

    fr (i, 0, n - 1) {
        int x;
        cin >> x;

        id.pb({x, i});
    }
    sort(id.begin(), id.end(), [&](const pii& a, const pii& b){ return a.fi < b.fi; });

    int q;
    cin >> q;

    if(g <= 2) {
        while(q--) {
            int t, u, v;
            cin >> t >> u >> v;

            pii x;
            fe (y, id) {
                if(y.se == u - 1) {
                    x = y;
                    break;
                }
            }

            vector<int> vis(n);
            vis[x.se] = 1;

            queue<pii> q;
            q.push(x);

            bool cn = 0;
            while(!q.empty()) {
                int curId = q.back().fi;
                int curIndex = q.back().se;
                q.pop();

                fe (y, id) {
                    if(!vis[y.se] && curId < y.fi && y.fi - curId <= d) {
                        vis[y.se] = vis[curIndex] + 1;
                        q.push(y);

                        if(y.se == v - 1) {
                            cn = 1;
                            if(t == 1) {
                                cout << 1 << endl;
                            } else {
                                cout << vis[y.se] - 1 << endl;
                            }
                        }
                    }
                }
            }

            if(!cn) {
                cout << 0 << endl;
            }
        }
    }
    
    return 0;
}