#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define ff first
#define ss second
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;

const ll INF = 1e18 + 1;
const ll N = 1e3 + 10;
const ll MOD = 1e9 + 7;
vector <ll> gr[N];
vector <ll> a;
ll n, d, g;
ll dist[N][N];

void bfs(ll s){
    dist[s][s] = 0;
    queue <ll> q;
    q.push(s);

    while (!q.empty()){
        ll v = q.front();
        q.pop();

        for (auto to: gr[v]){
            if (dist[s][v] + 1 < dist[s][to]){
                dist[s][to] = dist[s][v] + 1;
                q.push(to);
            }
        }
    }
}

void solve1(){
    for (int i = 0; i < n; i++){
        ll last = i;
        for (int j = i + 1; j < n; j++){
            if (a[j] > a[i]){
                if (j - last <= d) gr[i].push_back(j);
            } else {
                if (j - last <= d) last = j;
            }
        }
    }

    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            dist[i][j] = INF;
        }
    }

    for (int i = 0; i < n; i++) bfs(i);

    ll q; cin >> q;
    while (q--){
        ll t, u, v; cin >> t >> u >> v; u--, v--;
        if (dist[u][v] == INF) cout << 0;
        else {
            if (t == 1) cout << 1;
            else cout << dist[u][v];
        }
        cout << endl;
    }
}

void start(){
    cin >> n >> d >> g;
    a.assign(n, 0);
    for (auto &x: a) cin >> x;

    if (g == 0 || g == 1 || g == 2) solve1();
}

int main(){
    #ifdef LOCAL
        freopen("TASK.in", "r", stdin);
        freopen("TASK.out", "w", stdout);
    #endif // LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    start();
    return 0;
}


