#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const ll INF = 1e9;
const ll N = 2005;
const ll MOD = 1e9 + 7;
const ll M = 10005; // !!!!!!!!!!!!!!!!!!!!!!!1

mt19937 gen(time(0));

vector<ll> bfs(ll start, vector<vector<ll>>& g) {
    ll n = g.size();
    vector<ll> dst(n, INF);
    dst[start] = 0;
    queue<ll> q;
    q.push(start);
    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        for (auto to : g[v]) {
            if (dst[to] > dst[v] + 1) {
                dst[to] = dst[v] + 1;
                q.push(to);
            }
        }
    }
    return dst;
}
void solve() {
    ll n, d, group; cin >> n >> d >> group;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<vector<ll>> g(n);
    for (int i = 0; i < n; i++) {
        ll lst = i;
        while (lst < n) {
            ll nxt_lst = n;
            for (ll j = lst + 1; j <= min(n - 1, lst + d); j++) {
                if (a[j] > a[i]) {
                    g[i].push_back(j);
                } else {
                    nxt_lst = j;
                }
            }
            lst = nxt_lst;
        }
    }
    vector<vector<ll>> dst(n);
    for (int i = 0; i < n; i++) {
        dst[i] = bfs(i, g);
    }
    ll q; cin >> q;
    while (q--) {
        ll t, u, v; cin >> t >> u >> v;
        u--; v--;
        if (t == 1) {
            if (dst[u][v] != INF) {
                cout << 1 << '\n';
            } else {
                cout << 0 << '\n';
            }
        } else {
            if (dst[u][v] != INF) {
                cout << dst[u][v] << '\n';
            } else {
                cout << 0 << '\n';
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    ll tst = 1;
    while (tst--) {
        solve();
    }
}