#include <iostream>
#include <vector>

#pragma target('avx2')

#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

int main() {
    int n, d, g;
    cin >> n >> d >> g;
    vector<int> A(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    vector<int> st(n);
    for (int i = 0; i < n; i++) {
        vector<int> q = {i};
        st[i] = n - 1;
        for (int j = i + 1; j < n; j++) {
            if (j - q.back() > d) {
                st[i] = j - 1;
                break;
            }
            if (A[j] < A[i]) {
                while (q.size() >= 2 and j - q[q.size() - 2] <= d) {
                    q.pop_back();
                }
                q.push_back(j);
            }
        }
    }
    int q;
    cin >> q;
    for (int _ = 0; _ < q; _++) {
        int t, a, b;
        cin >> t >> a >> b;
        a--;
        b--;
        if (b > a and A[b] > A[a]) {
            int ind = a, cnt = 0;
            while (ind < b) {
                ind = st[ind];
                cnt++;
            }
            if (ind == b) {
                if (t == 1)
                    cout << 1 << '\n';
                else{
                    cout << cnt << '\n';
                }
            }else{
                cout << 0 << '\n';
            }
        } else {
            cout << 0 << '\n';
        }
    }
}
