#include <bits/stdc++.h>

#pragma GCC optimize("O3")

using ll = long long;

ll n, d, gg;
std::vector<ll> a;

ll BFS(ll u, ll v) {
    std::vector<ll> ds(n, -1);
    ds[u] = 0;
    std::deque<ll> st = {u};
    while (!st.empty() && ds[v] == -1) {
        ll i = st.front();
        st.pop_front();
        ll dist = ds[i], cnt = 0;
        if (gg == 6 && dist > 9) continue;
        for (ll j = i + 1; j < n; j++) {
            if (cnt == d) break;
            if (a[i] < a[j]) {
                cnt++;
                if (ds[j] == -1) {
                    ds[j] = dist + 1;
                    st.push_back(j);
                }
            } else cnt = 0;
        }
    }
    return ds[v];
}

void s1nm() {
    std::cin >> n >> d >> gg;
    a.resize(n);
    for (auto &item: a) std::cin >> item;
    ll q;
    std::cin >> q;
    while (q--) {
        ll t, u, v;
        std::cin >> t >> u >> v;
        u--, v--;
        ll ans = BFS(u, v);
        if (ans == -1) {
            std::cout << "0\n";
        } else {
            if (t == 1) std::cout << "1\n";
            else std::cout << ans << '\n';
        }
    }
}

signed main() {
    std::cin.tie(nullptr)->std::ios::sync_with_stdio(false);
    std::freopen("input.txt", "r", stdin);
    ll T = 1;
//    std::cin >> T;
    while (T--) {
        s1nm();
        std::cout << '\n';
    }
}
