#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
//set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined,bounds,address")
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll inf = 1e7, mod = 1e9 + 7, maxn = 2e5 + 1;

void solve() {
    int n, d, group;
    cin >> n >> d >> group;
    vector<int> a(n);
    for (int &x: a) cin >> x, x--;
    int Q;
    cin >> Q;
    if (group < 3) {
        vector<vector<int>> g(n);
        for (int l = 0; l < n; l++) {
            int last = l;
            for (int r = l + 1; r < n && r - last <= d; r++) {
                if (a[r] < a[l]) {
                    last = r;
                    continue;
                }
                g[l].push_back(r);
            }
        }
        vector<vector<int>> dist(n, vector<int>(n, inf));
        for (int i = 0; i < n; i++) {
            dist[i][i] = 0;
            set<pii > q;
            q.insert({0, i});
            while (!q.empty()) {
                int v = q.begin()->second;
                q.erase(q.begin());
                for (int u: g[v]) {
                    if (dist[i][u] <= dist[i][v] + 1) continue;
                    q.erase({dist[i][u], u});
                    dist[i][u] = dist[i][v] + 1;
                    q.insert({dist[i][u], u});
                }
            }
        }
        while (Q--) {
            int t, l, r;
            cin >> t >> l >> r, t--, l--, r--;
            if (dist[l][r] == inf) {
                cout << "0\n";
                continue;
            }
            if (!t) {
                cout << "1\n";
                continue;
            }
            cout << dist[l][r] << '\n';
        }
        return;
    }
    if (group == 6 || group == 7) {
        const int lim = 500;
        vector<vector<int>> g(n);
        for (int l = 0; l < n; l++) {
            int last = l;
            int op = lim;
            for (int r = l + 1; r < n && op-- && r - last <= d; r++) {
                if (a[r] < a[l]) {
                    last = r;
                    continue;
                }
                g[l].push_back(r);
            }
        }
        while (Q--) {
            int t, l, r;
            cin >> t >> l >> r, t--, l--, r--;
            unordered_map<int, int> dist;
            set<pii > q;
            q.insert({0, l});
            while (!q.empty()) {
                int v = q.begin()->second;
                q.erase(q.begin());
                if (dist[v] > 150) continue;
                for (int u: g[v]) {
                    if (u > r || dist.find(u) != dist.end() && dist[u] <= dist[v] + 1) continue;
                    q.erase({dist[u], u});
                    dist[u] = dist[v] + 1;
                    q.insert({dist[u], u});
                }
            }
            if (dist.find(r) == dist.end()) {
                cout << "0\n";
                continue;
            }
            if (!t) {
                cout << "1\n";
                continue;
            }
            cout << dist[r] << '\n';
        }
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}

