#include "bits/stdc++.h"
using namespace std;
#define int long long
const int maxn = 1005 + 10;
int d;
vector <int> g[maxn];
int a[maxn];

const int inf = maxn;
int dist[maxn][maxn];
void dij(int s) {
    fill(dist[s], dist[s] + maxn, inf);
    dist[s][s] = 0;
    queue<int> q;
    q.push(s);

    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i : g[v]) {
            if (dist[s][i] == inf) {
                dist[s][i] = dist[s][v] + 1;
                q.push(i);
            }
        }
    }
}
signed main() {
    int n, _g;
    cin >> n >> d >> _g;
    for (int i = 1; i <= n; i++) cin >> a[i];


    for (int from = 1; from <= n; from++) {
        int lst = from;
        for (int j = from + 1; j <= n; j++) {
            if (lst + d < j) break;
            if (a[from] < a[j]) g[from].push_back(j);
            else lst = j;
        }
    }

    for (int i = 1; i <= n; i++) {
        dij(i);
    }

    int q; cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        if (t == 1) {
            if (dist[u][v] != inf) cout << 1 << '\n';
            else cout << 0 << '\n';
        } else {
            if (dist[u][v] == inf) cout << 0 << '\n';
            else cout << dist[u][v] << '\n';

        }
    }
}