#include <bits/stdc++.h>
using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream& cin, ostream& cout);


int test_cnt = 1, group, cur_test;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    // cin >> test_cnt;
    // cin >> group;
    for (cur_test = 0; cur_test < test_cnt; ++cur_test)
        solve(cin, cout);
}


vector<ll> a, mxr;
ll n, d;


void init_transit() {
    set<pair<ll, ll>> s;
    ll i = 0, max_right = 0;
    while (i < n) {
        if (s.empty())
            s.emplace(a[i], i);
        max_right = max(max_right, min(s.begin()->second + d + 1, n));
        for (; i < max_right && i < n; ++i) {
            s.emplace(a[i], i);
            max_right = max(max_right, min(s.begin()->second + d + 1, n));
        }
        mxr[s.begin()->second] = max_right;
        s.erase(s.begin());
    }
    for (auto& [q, j] : s)
        mxr[j] = max_right;
}


vector<vector<tuple<ll, ll, ll>>> zpr;
vector<ll> res;


vector<map<ll, ll>> dl;
vector<bool> used;
bool dfs(const ll i) {
    if (used[i])
        return true;
    used[i] = true;
    dl[i][i] = 0;

    for (ll j = i - 1; j >= 0; --j) {
        if (a[i] > a[j] && i < mxr[j] && dfs(j)) {
            // if (dl[i].size() < dl[j].size())
            //     swap(dl[i], dl[j]);
            for (auto& [a, b] : dl[j]) {
                if (dl[i].find(a) == dl[i].end())
                    dl[i][a] = b;
                dl[i][a] = min(dl[i][a], b);
            }
        }
    }

    for (auto& [v, type, id] : zpr[i]) {
        if (type == 1) {
            res[id] = (dl[i].find(v) != dl[i].end()) ? 1 : 0;
        } else {
            res[id] = (dl[i].find(v) != dl[i].end()) ? dl[i][v] : 0;
        }
    }

    for (auto& [a, b] : dl[i])
        ++b;
    return true;
}


void solve(istream& cin, ostream& cout) {
    cin >> n >> d >> group;
    a.resize(n);
    mxr.resize(n);
    for (auto& t : a)
        cin >> t;
    init_transit();


    dl.resize(n);
    used.resize(n);
    zpr.resize(n);

    ll q;
    cin >> q;
    res.resize(q);
    for (ll i = 0; i < q; ++i) {
        ll a, b, t;
        cin >> t >> a >> b;
        --a, --b;
        zpr[b].emplace_back(a, t, i);
    }


    for (ll i = n - 1; i >= 0; --i)
        dfs(i);

    for (auto& t : res)
        cout << t << '\n';
}
