#include <iostream>
#include <vector>
#include <set>
using namespace std;

int n, d, u, m;
const int INF = 1e9;
vector<int> v;

int way(int s, int id, int f) {
    //cout << id << '\n';
    for (int i = 1; i <= d; i++) {
        if (id + i >= n)
            return INF;
        if (id + i == f)
            return 1;
        if (v[id + i] < v[s])
            return way(s, id + i, f);
        if (v[id + i] < v[f] && v[id + i] > m) {
            m = v[id + i];
            u = id + i;
        }
    }
    if (u == -1)
        return INF;
    return way(u, u, f) + 1;
}

int main() {
    int g, q, x, t, u1, u2;
    cin >> n >> d >> g;
    v.resize(n);
    for (int i = 0; i < n; i++)
        cin >> v[i];
    cin >> q;
    for (int i = 0; i < q; i++) {
        cin >> t >> u1 >> u2;
        if (v[u1 - 1] > v[u2 - 1])
            cout << 0 << '\n';
        else {
            u = -1, m = -1;
            x = way(u1 - 1, u1 - 1, u2 - 1);
            if (x >= INF)
                x = 0;
            if (t == 1 && x != 0)
                x = 1;
            cout << x << '\n';
        }
    }
}

