#include <iostream>
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
*/
#include <bits/stdc++.h>
using namespace std;

/*
#include <bits/extc++.h>
using namespace __gnu_pbds;
typedef tree<
        int,
        null_type,
        less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
 */

#define int long long
#define ll long long
#define fi first
#define se second
#define eb emplace_back
#define lwb lower_bound
#define upb upper_bound
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define ld long double
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
const int INF = 1e18, N = 300300, K = 26, C = 700, P = 1e9 + 7;
const ld EPS = 1e-5, pi = 3.1415926535;

vector<bool> used;
vector<int> order;
vector<vector<int>> g;

void topsort(int v) {
    used[v] = true;
    for (auto to : g[v]) {
        if (used[to])
            continue;
        topsort(to);
    }
    order.eb(v);
}



void solve() {
    int n, d, gr;
    cin >> n >> d >> gr;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    g.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        int last = i;
        for (int j = i + 1; j <= n; j++) {
            if (j - last > d)
                break;
            if (a[j] < a[i])
                last = j;
            else
                g[i].eb(j);
        }
    }
    used.resize(n + 1, false);
    for (int i = 1; i <= n; i++) {
        if (!used[i])
            topsort(i);
    }
    int q;
    cin >> q;
    vector<int> ans(q);
    vector<int> tin(n + 1);
    int timer = 0;
    while (q--) {
        int type, v, to;
        cin >> type >> v >> to;
        vector<int> di(n + 1, INF);
        di[v] = 0;
        deque<int> st;
        st.eb(v);
        timer++;
        tin[v] = timer;
        while (!st.empty()) {
            auto u = st.front();
            st.pop_front();
            for (auto it : g[u]) {
                if (tin[it] != timer) {
                    di[it] = di[u] + 1;
                    st.eb(it);
                    tin[it] = timer;
                }
            }
        }
        if (di[to] == INF) {
            cout << 0 << '\n';
            continue;
        }
        if (type == 1) {
            di[to] = 1;
        }
        cout << di[to] << '\n';
    }
}

signed main() {
    //cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    //cin >> T;
    while (T--)
        solve();
    return 0;
}