//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt,fma")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const long long RANDOM = chrono::high_resolution_clock::now().time_since_epoch().count();
constexpr int MAXN = 1 << 20;
constexpr long long mod = 1e9 + 7;
mt19937 rnd(RANDOM);


void solve() {
    int n, d, xr;
    cin >> n >> d >> xr;
    vector<int> a(n);
    for (auto &i: a) {
        cin >> i;
    }
    vector<vector<int>> g(n, vector<int>(n, 0));
    vector<vector<int>> g1(n);
    for (int i = 0; i < n; i++) {
        int l = i;
        for (int j = i + 1; j < n; j++) {
            if (a[j] > a[i] && j - l <= d) {
                g[i][j] = 1;
                g1[i].push_back(j);
            }
            if (a[j] < a[i] && j - l <= d) {
                l = j;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        vector<int> dp(n, -1);
        dp[i] = 0;
        queue<int> q;
        q.push(i);
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (auto u: g1[v]) {
                if (dp[u] == -1) {
                    dp[u] = dp[v] + 1;
                    q.push(u);
                }
            }
        }
        for (int j = 0; j < n; j++) {
            g[i][j] = max(0, dp[j]);
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        if (t == 1) {
            cout << min(1, g[u - 1][v - 1]) << '\n';
        } else {
            cout << g[u - 1][v - 1] << '\n';
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
//    cin>>q;
    while (q--) {
        solve();
    }
}
