#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl '\n'

typedef long long ll;
typedef long double ld;

typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 2e15 + 1;
const int MOD = 1e9 + 7;

mt19937 rnd(time(0));

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector <int> l, sz;

int find(int a){
    if (a == l[a])
        return a;
    return l[a] = find(l[a]);
}

bool same(int a, int b){
    return find(a) == find(b);
}

void unite(int a, int b){
    a = find(a), b = find(b);
    if (same(a, b))
        return;
    if (sz[a] < sz[b])
        swap(a, b);
    l[b] = a;
    sz[a] += sz[b];
}

signed main() {
    Fast();
    int n, d, g;
    cin >> n >> d >> g;
    vector <int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    vector <vector <int>> sm(n);
    if (g == 4){
        int q;
        cin >> q;
        int t, u, v;
        cin >> t >> u >> v;
        u--, v--;
        for (int i = u; i < u + 1; i++){
            int last = i;
            for (int j = i + 1; j < n; j++) {
                if (j - last > d)
                    break;
                if (a[j] < a[i])
                    last = j;
                if (a[j] > a[i])
                    sm[i].push_back(j);
            }
        }
        vector <int> dist(n, INF);
        deque <int> h = {u};
        dist[u] = 0;
        while (!h.empty()){
            int v = h.front();
            h.pop_front();
            for (int to:sm[v]){
                if (dist[to] > dist[v] + 1){
                    dist[to] = dist[v] + 1;
                    h.push_back(to);
                }
            }
        }
        int ans = dist[v];
        if (ans == INF)
            ans = 0;
        if (t == 1)
            ans = min(ans, 1ll);
        cout << ans;
        return 0;
    }
    for (int i = 0; i < n; i++) {
        int last = i;
        for (int j = i + 1; j < n; j++) {
            if (j - last > d)
                break;
            if (a[j] < a[i])
                last = j;
            if (a[j] > a[i])
                sm[i].push_back(j);
        }
    }
    vector <vector <int>> dist(n, vector <int> (n, INF));
    for (int i = 0; i < n; i++){
        deque <int> q = {i};
        dist[i][i] = 0;
        while (!q.empty()){
            int v = q.front();
            q.pop_front();
            for (int to:sm[v]){
                if (dist[i][to] > dist[i][v] + 1){
                    dist[i][to] = dist[i][v] + 1;
                    q.push_back(to);
                }
            }
        }
    }
    int q;
    cin >> q;
    while (q--){
        int t, u, v;
        cin >> t >> u >> v;
        u--, v--;
        int k = dist[u][v];
        if (t == 1)
            k = min(k, 1ll);
        if (k == INF)
            k = 0;
        cout << k << endl;
    }
    return 0;
}

/*
3
0 5 5
0 9 3
5 9 8
2 5
 */