// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <numeric>
#include <bitset>
#include <utility>
#include <map>
#include <set>
#include <queue>

using namespace std;
using ll = long long;
using ld = long double;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n, d, g;
    cin >> n >> d >> g;
    vector <int>a(n);
    for (auto& i : a)
    {
        cin >> i;
    }
    vector <vector <int>> gr(n);
    for (size_t i = 0; i < n; i++)
    {
        int k = i + 1;
        int lst = i;
        while (k < n && k - lst <= d)
        {
            if (a[k] > a[i])
                gr[i].push_back(k);
            else
                lst = k;
            k++;
        }
    }
    vector <vector<int>>dst(n);
    for (size_t i = 0; i < n; i++)
    {
        dst[i].assign(n, 1e9);
        dst[i][i] = 0;
        queue<int> q;
        q.push(i);
        while (!q.empty())
        {
            int v = q.front(); q.pop();
            for (auto& u : gr[v])
            {
                if (dst[i][u] > dst[i][v] + 1)
                {
                    dst[i][u] = dst[i][v] + 1;
                    q.push(u);
                }
            }
        }
    }
    const int INF = 1e9;
    int q;
    cin >> q;
    for (size_t i = 0; i < q; i++)
    {
        int t, u, v;
        cin >> t >> u >> v;
        u--; v--;
        cout << (dst[u][v] == INF ? 0 : (t == 1 ? 1 : dst[u][v])) << '\n';
    }
    return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
