#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const int MAX = 1e5 + 7;
const int mod = 1e9 + 7;

vector<int> g[MAX];

void solve() {
    int n, d, gru;
    cin >> n >> d >> gru;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) {
        int canl = i + d;
        for (int j = i + 1; j <= n; j++) {
            if (a[j] > a[i]) {
                if (canl >= j) {
                    g[i].push_back(j);
                }
            } else {
                if (canl >= j) {
                    canl = max(canl, j + d);
                }
            }
        }
    }
    int dist[n + 1][n + 1];
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            dist[i][j] = 1e9;
        }
        dist[i][i] = 0;
    }
    for (int i = 1; i <= n; i++) {
        queue<int> q;
        q.push(i);
        while (q.size()) {
            int v = q.front();
            q.pop();
            for (auto to : g[v]) {
                if (dist[i][to] > dist[i][v] + 1) {
                    dist[i][to] = dist[i][v] + 1;
                    q.push(to);
                }
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int type, v, u;
        cin >> type >> v >> u;
        int res = dist[v][u];
        if (type == 1) {
            if (res == 1e9) {
                res = 0;
            } else {
                res = 1;
            }
        } else {
            if (res == 1e9) {
                res = 0;
            }
        }
        cout << res << '\n';
    }
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}