//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("avx,avx2,sse,sse2,sse3,ssse3")
#include <bits/stdc++.h>

using namespace std;

//#define int int_fast32_t
//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map
//#define mp make_pair

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;
typedef vector<si> vsi;
typedef vector<spi> vspi;
typedef tuple<int, int, int> ti;
typedef vector<ti> vti;
typedef vector<bool> vb;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

mt19937 rnd(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());

const int MAXN = 1000 + 10, INF = 1e9;

vi g[MAXN];

void solve1(int n, int d, vi a) {
	for (int i = 1; i <= n; ++i) {
		vi b = {i};
		for (int j = i + 1; j <= n; ++j)
			if (a[j] < a[i])
				b.push_back(j);
		int j = 0;
		for (j = 1; j < b.size(); ++j) {
			if (b[j] - b[j - 1] > d)
				break;
		}
		j--;
		int x = b[j] + d;
		for (int j = i + 1; j <= min(x, n); ++j)
			if (a[j] > a[i])
				g[i].push_back(j);
	}
	vvi dist(n + 1, vi(n + 1, INF));
	for (int i = 1; i <= n; ++i) {
		dist[i][i] = 0;
		queue<int> q;
		q.push(i);
		while (q.size()) {
			int u = q.front();
			q.pop();
			for (auto v : g[u]) {
				if (minravno(dist[i][v], dist[i][u] + 1))
					q.push(v);
			}
		}
	}
	int q;
	cin >> q;
	while (q--) {
		int t, u, v;
		cin >> t >> u >> v;
		if (t == 1)
			cout << (dist[u][v] < INF) << '\n';
		else
			cout << (dist[u][v] < INF ? dist[u][v] : 0) << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, d, g;
	cin >> n >> d >> g;
	vi a(n + 1);
	input(a, 1);
	if (n <= 1000)
		solve1(n, d, a);

	return 0;
}