//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("avx,avx2,sse,sse2,sse3,ssse3")
#include <bits/stdc++.h>

using namespace std;

//#define int int_fast32_t
//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map
//#define mp make_pair

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;
typedef vector<si> vsi;
typedef vector<spi> vspi;
typedef tuple<int, int, int> ti;
typedef vector<ti> vti;
typedef vector<bool> vb;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

mt19937 rnd(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());

const int MAXN = 1000 + 10, INF = 1e9;

vi g[MAXN];

void solve1(int n, int d, vi a) {
	for (int i = 1; i <= n; ++i) {
		vi b = {i};
		for (int j = i + 1; j <= n; ++j)
			if (a[j] < a[i])
				b.push_back(j);
		int j = 0;
		for (j = 1; j < b.size(); ++j) {
			if (b[j] - b[j - 1] > d)
				break;
		}
		j--;
		int x = b[j] + d;
		for (int j = i + 1; j <= min(x, n); ++j)
			if (a[j] > a[i])
				g[i].push_back(j);
	}
	vvi dist(n + 1, vi(n + 1, INF));
	for (int i = 1; i <= n; ++i) {
		dist[i][i] = 0;
		queue<int> q;
		q.push(i);
		while (q.size()) {
			int u = q.front();
			q.pop();
			for (auto v : g[u]) {
				if (minravno(dist[i][v], dist[i][u] + 1))
					q.push(v);
			}
		}
	}
	int q;
	cin >> q;
	while (q--) {
		int t, u, v;
		cin >> t >> u >> v;
		if (t == 1)
			cout << (dist[u][v] < INF) << '\n';
		else
			cout << (dist[u][v] < INF ? dist[u][v] : 0) << '\n';
	}
}

const int MAXN2 = 3e5 + 10;

vpi t[4 * MAXN2];

vpi merge(vpi a, vpi b) {
	vpi c;
	int i = 0, j = 0;
	while (i < a.size() && j < b.size()) {
		if (a[i] < b[j])
			c.push_back(a[i++]);
		else
			c.push_back(b[j++]);
	}
	while (i < a.size())
		c.push_back(a[i++]);
	while (j < b.size())
		c.push_back(b[j++]);
	return c;
}

void build(vi& a, int v, int tl, int tr) {
	if (tr - tl == 1)
		t[v] = {{a[tl], tl}};
	else {
		int m = (tr + tl) / 2;
		build(a, v * 2, tl, m);
		build(a, v * 2 + 1, m, tr);
		t[v] = merge(t[v * 2], t[v * 2 + 1]);
	}
}

pi get(int v, int tl, int tr, int l, int r, int x = INF) {
	if (tr <= l || r <= tl)
		return {0, 0};
	if (l <= tl && r >= tr) {
		auto it = upper_bound(all(t[v]), make_pair(x, INF));
		if (it == t[v].begin())
			return {0, 0};
		--it;
		return *it;
	}
	int m = (tr + tl) / 2;
	return max(get(v * 2, tl, m, l, r, x), get(v * 2 + 1, m, tr, l, r, x));
}

void solve2(int n, int d, vi a) {
	vpi b;
	for (int i = 1; i <= n; ++i) {
		b.push_back({a[i], i});
	}
	sort(all(b));
	si s, s2;
	vi r(n + 1, 0), x(n + 1, 0);
	build(a, 1, 1, n + 1);
	for (auto [tmp, i] : b) {
		s.insert(i);
		auto it1 = s.upper_bound(i);
		if (it1 == s.end() || *it1 - i > d)
			s2.insert(i);
		auto it = s.find(i);
		if (it != s.begin()) {
			it--;
			if (i - *it <= d)
				s2.erase(*it);
		}
		auto it2 = s2.lower_bound(i);
		x[i] = n;
		if (it2 != s2.end())
			minravno(x[i], *it2 + d);
		auto[mx, pos] = get(1, 1, n + 1, i + 1, x[i] + 1);
		r[i] = pos;
		if (a[r[i]] < a[i])
			r[i] = 0;
	}
	vi dist(n + 1, 0);
	for (int i = n - 1; i >= 1; --i) {
		if (!r[i])
			dist[i] = -1;
		else
			dist[i] = dist[r[i]] + 1;
	}
	int q;
	cin >> q;
	while (q--) {
		int t, u, v;
		cin >> t >> u >> v;
		if (v == n && a[n] == n) {
			if (t == 1)
				cout << (dist[u] != -1) << '\n';
			else
				cout << (dist[u] == -1 ? 0 : dist[u]) << '\n';
		}
		else {
			int ans = 0;
			bool flag =  true;
			while (u != v) {
				auto [mx, pos] = get(1, 1, n + 1, u + 1, x[u] + 1, a[v]);
				if (mx <= a[u]) {
					flag = false;
					break;
				}
				u = pos;
				ans++;
			}
			if (!flag)
				cout << "0\n";
			else if (t == 1)
				cout << "1\n";
			else
				cout << ans << '\n';
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, d, g;
	cin >> n >> d >> g;
	vi a(n + 1);
	input(a, 1);
	if (n <= 1000)
		solve1(n, d, a);
	else
		solve2(n, d, a);

	return 0;
}