#include <bits/stdc++.h>
#define int long long

using namespace std;

// c = C(2n,n)/(n+1)
// x = y' - (b/a) * x'
// y = x'
// ob[i] = (mod - (m / i) * ob[m % i] % mod + mod) % mod
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int MAX = 3333;
bool g1[MAX][MAX], g2[MAX][MAX];

void solve() {
  int n, m1, m2;
  cin >> n >> m1 >> m2;
  memset(g1, 0, sizeof g1);
  memset(g2, 0, sizeof g2);
  for (int i = 0; i < m1; i++) {
    int u, v;
    cin >> u >> v;
    u--, v--;
    g1[u][v] = g1[v][u] = true;
  }
  for (int i = 0; i < m2; i++) {
    int u, v;
    cin >> u >> v;
    u--, v--;
    g2[v][u] = g2[u][v] = true;
  }
  vector<pair<int, int>> e;
  for (int i = 0; i < n; i++) {
    for (int j = i + 1; j < n; j++) {
      e.emplace_back(i, j);
    }
  }
  for (int mask = 0; mask < (1 << (int) e.size()); mask++) {
    if (__builtin_popcount(mask) <= n) continue;
    for (int i = 0; i < (int) e.size(); i++) {
      if ((mask >> i) & 1) {
        g1[e[i].first][e[i].second] ^= 1;
        g1[e[i].second][e[i].first] ^= 1;
        g2[e[i].first][e[i].second] ^= 1;
        g2[e[i].second][e[i].first] ^= 1;
      }
    }
    vector<bool> used1(n);
    vector<bool> used2(n);
    function<void(int)> dfs1 = [&](int v) {
      used1[v] = true;
      for (int to = 0; to < n; to++) {
        if (g1[v][to] && !used1[to]) {
          dfs1(to);
        }
      }
    };
    function<void(int)> dfs2 = [&](int v) {
      used2[v] = true;
      for (int to = 0; to < n; to++) {
        if (g2[v][to] && !used2[to]) {
          dfs2(to);
        }
      }
    };
    for (int i = 0; i < n; i++) {
      if (!used1[i]) {
        dfs1(i);
      }
    }
    for (int i = 0; i < n; i++) {
      if (!used2[i]) {
        dfs2(i);
      }
    }
    if (count(used1.begin(), used1.end(), false) == 0 &&
        count(used2.begin(), used2.end(), false) == 0) {
      cout << "Yes\n";
      for (int i = 0; i < (int) e.size(); i++) {
        if ((mask >> i) & 1) {
          cout << e[i].first+1 << ' ' << e[i].second+1 << '\n';
        }
      }
      return;
    }
    for (int i = 0; i < (int) e.size(); i++) {
      if ((mask >> i) & 1) {
        g1[e[i].first][e[i].second] ^= 1;
        g1[e[i].second][e[i].first] ^= 1;
        g2[e[i].first][e[i].second] ^= 1;
        g2[e[i].second][e[i].first] ^= 1;
      }
    }
  }
  cout << "No\n";
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int tt,g;
  cin >> tt >> g;
  while (tt--) {
    solve();
  }
}