#include <iostream>
#include <vector>
#include <fstream>
#include <cmath>
#include <cstdint>
#include <list>
#include <set>
#include <map>
#include <string>
#include <algorithm>


typedef  unsigned long long ll;
using namespace std;


ll Buravchik(vector<ll>& a, vector<ll>& b, vector<ll>& d, vector<ll>& l, vector<ll>& r, ll i, ll n) {
	ll j = i - 1;
	if (i == n + 1) {
		return a[j] + b[j];
	}

	a[i] = a[j] + d[j];
	b[i] = b[j] + d[j];

	ll newa = min(a[i], l[j]);
	ll newb = min(b[i], r[j]);

	ll sa = a[i];
	ll sb = b[i];

	a[i] = newa;
	ll sum1 = Buravchik(a, b, d, l, r, i + 1, n);

	a[i] = sa;
	b[i] = newb;
	ll sum2 = Buravchik(a, b, d, l, r, i + 1, n);
	b[i] = sb;

	return max(sum1, sum2);
}

int main() {
	ios_base::sync_with_stdio(true);
	cin.tie(nullptr); cout.tie(nullptr);


	ll n, d, g;
	cin >> n >> d >> g;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}
	ll q;
	cin >> q;
	for (ll i = 0; i < q; i++) {
		ll t, u, v;
		cin >> t >> u >> v;
		u--;
		v--;
		if (a[u] >= a[v]) {
			cout << 0 << endl;
		}
		else {
			cout << 1 << endl;
		}
	}
}

