#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define p_b push_back
#define pw(x) (1LL << (x))
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template<class T> void amin(T &a, T b) {a = a < b ? a : b;}
template<class T> void amax(T &a, T b) {a = a > b ? a : b;}

const int N = 3e5 + 5;

int a[N];
int d[1000][1000];
int t[1000][1000];
vector<int> g[N];

void solve() {
    int group_name;
    int n, D;
    cin >> n >> D >> group_name;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (n <= 1000) {
        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                d[i][j] = t[i][j] = 1e9;
        queue<array<int, 2>> q;
        for (int i = 0; i < n; i++) {
            d[i][i] = 0;
            t[i][i] = 0;
            q.push({i, i});
            cout << '\t' << i << '\n';
            while (sz(q)) {
                auto [v, fr] = q.front();
                q.pop();
//                cout << v << ' ' << fr << ' ' << d[i][v] << '\n';
                int cur = 0;
                for (int j = v + 1; j < n && j - v <= D; j++) {
                    if (a[j] < a[fr] && t[i][j] > t[i][fr]) {
                        t[i][j] = t[i][fr];
                        q.push({j, fr});
                        break;
                    }
                    if (a[j] > a[fr] && d[i][j] > t[i][fr] + 1) {
                        d[i][j] = t[i][fr] + 1;
                        t[i][j] = t[i][fr] + 1;
                        q.push({j, j});
                    }
                }
            }
        }
        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                if (d[i][j] == 1e9)
                    d[i][j] = 0;
    }
    int q;
    cin >> q;
    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        l--, r--;
        if (type == 1)
            cout << (bool)d[l][r] << '\n';
        else
            cout << d[l][r] << '\n';
    }
}

int32_t main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif // LOCAL
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    #ifdef LOCAL
        cout << "\n\n===\n\nTime : " << (long double)clock() / CLOCKS_PER_SEC << '\n';
    #endif // LOCAL
}
