#include <bits/stdc++.h>
//#define int long long
#define pii pair<int, int>

using namespace std;
const int inf = 1e17;

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, d, g1;
    cin >> n >> d >> g1;

    vector<int>a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }

    vector<vector<int>>g(n);

    for(int i = 0; i < n; i++){
        int lst = i;
        for(int j = i+1; j < n; j++){
            if(j - lst > d) break;
            if(a[j] > a[i] && j - lst <= d){
                g[i].push_back(j);
            } else if (a[j] < a[i]){
                lst = j;
            }
            if(j - lst > d) break;
        }
    }



    int q;
    cin >> q;
    vector<int>dist(n, inf);
    while(q--){
        int t, u, v;
        cin >> t >> u >> v;
        u--; v--;
        if(a[v] < a[u] || v < u) {
            cout << 0 << '\n';
            continue;
        }
        queue<int>qu;
        qu.push(u);
        for(int i = 0; i < n; i++) dist[i] = inf;
        dist[u] = 0;
        while(!qu.empty()){
            int a = qu.front();
            qu.pop();
            for(auto& to : g[a]){
                if(dist[to] != inf) continue;
                dist[to] = dist[a] + 1;
                if(to == v) break;
                qu.push(to);
            }
        }
        if(dist[v] == inf){
            cout << 0 << '\n';
            continue;
        }
        if(t == 1) {
            cout << 1 << '\n';
        } else {
            cout << dist[v] << '\n';
        }
    }

    return 0;
}
