#include <bits/stdc++.h>

#define int int64_t
#define endl '\n'

using namespace std;

const int MAXN = 4e5;
const int MAXX = 2e6;
const int MOD = 998244353;
const int INF = 1e17;
const long double EPS = 1e-6;
const long double EPS1 = 1e-7;
const int LG = 50;
const int BS = 100;
const int DIS = 2e8;

int bp(int v, int p){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp(v, p - 1) * v % MOD;
    }
    int k = bp(v, p / 2);
    return k * k % MOD;
}

int bp_md(int v, int p, int md){
    if(!p){
        return 1;
    }
    if(p & 1){
        return bp_md(v, p - 1, md) * v % md;
    }
    int k = bp_md(v, p / 2, md);
    return k * k % md;
}

int nok(int a, int b){
    return a / __gcd(a, b) * b;
}

bool is_prime(int a){
    for(int i = 2; i * i <= a; i++){
        if(a % i == 0){
            return 0;
        }
    }
    return 1;
}

mt19937 rnd(121);
/*
int n;
    cin >> n;
    vector <int> a, b;
    bool flag = 1;
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        a.push_back(k);
    }
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        b.push_back(k);
    }
    for(int i = 0; i < n - 1; i++){
        flag = flag && b[i + 1] >= b[i];
        flag = flag && a[i + 1] >= a[i];
    }
    if(flag){
        vector <int> a1, b1;
        multiset <int> ms;
        int sm = 0;
        int mx = 0;
        int lst = -1;
        for(int i = 0; i < n; i++){
            sm += a[i];
            sm -= b[i];
            mx = max(mx, a[i] - b[i]);
            if(a1.size() && a1.back() >= b[i]){
                if(lst == -1){
                    lst = b1.back();
                }
            }
            a1.push_back(a[i]);
            b1.push_back(b[i]);
            if(lst != -1){
                mx = max(mx, a1.back() - lst);
            }
            if(i != n - 1 && a1.size() && a1.back() < b[i + 1]){
                lst = -1;
            }
            cout << sm - mx << ' ';
        }
        return;
    }
    multiset <int> a1, b1;
    int sm = 0;
    for(int i = 0; i < n; i++){
        a1.insert(a[i]);
        b1.insert(b[i]);
        sm += a[i];
        sm -= b[i];
        auto i1 = a1.begin();
        auto i2 = b1.begin();
        int mx = 0;
        int lst = -1;
        while(i1 != a1.end()){
            if(lst != -1){
                if(i1 == (--a1.end()) || *i1 < *(next(i2, 1))){
                    mx = max(mx, *i1 - lst);
                    lst = -1;
                }
            }
            else{
                if(i1 != (--a1.end())){
                    if(*(next(i2, 1)) <= *i1){
                        lst = *i2;
                    }
                }
            }
            mx = max(mx, *i1 - *i2);
            i1++;
            i2++;
        }
        cout << sm - mx << ' ';
    }
*/

int tr[MAXX];

int get(int v, int l, int r, int ll, int rr){
    if(r <= ll || l >= rr){
        return INF;
    }
    if(l >= ll && r <= rr){
        return tr[v];
    }
    return min(get(2 * v, l, l + r >> 1, ll, rr), get(2 * v + 1, l + r >> 1, r, ll, rr));
}

void upd(int v, int l, int r, int ll, int rr, int x){
    //cout << "IN: " << v << ' ' << l << ' ' << r << ' ' << ll << ' ' << rr << ' ' << x << endl;
    if(r <= ll || l >= rr){
        return;
    }
    if(l >= ll && r <= rr){
        tr[v] = x;
        return;
    }
    upd(2 * v, l, l + r >> 1, ll, rr, x);
    upd(2 * v + 1, l + r >> 1, r, ll, rr, x);
    tr[v] = min(tr[2 * v], tr[2 * v + 1]);
}

void solve(){
    int n, d, g;
    cin >> n >> d >> g;
    for(int i = 0; i <= 4 * n; i++){
        tr[i] = INF;
    }
    vector <int> a;
    vector <pair<int, int>> vp;
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        vp.push_back({k, i});
        a.push_back(k);
    }
    sort(vp.begin(), vp.end());
    vector <int> mn_r(n, n);
    stack <int> st;
    for(int i = 0; i < n; i++){
        while(st.size() && a[st.top()] > a[i]){
            mn_r[st.top()] = i;
            st.pop();
        }
        st.push(i);
    }
    vector <int> r(n);
    vector <int> en[n];
    for(auto [aa, b]:vp){
        int nw = min(n - 1, b + d);
        for(int i = b; i <= nw; i++){
            if(a[i] < aa){
                nw = min(n - 1, i + d);
            }
        }
        r[b] = nw;
        en[r[b]].push_back(b);
    }
    if(g <= 2){
        vector <vector <int>> dst(n, vector <int> (n, INF));
        for(int i = 0; i < n; i++){
            dst[i][i] = 0;
            for(int j = 0; j <= 5 * n; j++){
                tr[j] = INF;
            }
            upd(1, 0, n, a[i] - 1, a[i], 0);
            for(int j = i + 1; j < n; j++){
                dst[i][j] = min(dst[i][j], get(1, 0, n, 0, a[j]) + 1);
                upd(1, 0, n, a[j] - 1, a[j], dst[i][j]);
                for(auto k:en[j]){
                    upd(1, 0, n, a[k] - 1, a[k], INF);
                }
            }
        }
        int q;
        cin >> q;
        while(q--){
            int t, a, b;
            cin >> t >> a >> b;
            a--;
            b--;
            if(t == 1){
                cout << (dst[a][b] == INF ? 0 : 1) << endl;
            }
            else{
                cout << (dst[a][b] == INF ? 0 : dst[a][b]) << endl;
            }
        }
    }
}
/*
6 1 1
2 1 3 4 5 6
6
2 1 3
2 1 2
1 1 4
2 1 5
2 1 6
1 2 6
*/
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
        //cout << endl;
    }
    return 0;
}
