#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int S = 19, R = (1 << S);
vector<pii> t(R * 2, {-1, -1});

void update(int i, int x) {
    int v = R + i;
    t[v] = {x, i};
    v >>= 1;
    while (v > 0) {
        t[v] = max(t[v << 1], t[(v << 1) ^ 1]);
        v >>= 1;
    }
}

pii get_max(int ql, int qr, int v = 1, int l = 0, int r = R) {
    if (ql >= r || l >= qr)
        return {-1, -1};
    if (ql <= l && r <= qr)
        return t[v];
    int m = (l + r) / 2;
    return max(get_max(ql, qr, (v << 1), l, m), get_max(ql, qr, ((v << 1) ^ 1), m, r));
}

int main() {
    fast;
    int n, d, gr;
    cin >> n >> d >> gr;
    vi a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        b[a[i]] = i;
    }
    vi r(n);
//    set<int> s, ss;
//    s.insert(-d - 1);
//    for (int i = 0; i < n; ++i) {
//        auto it = s.lower_bound(b[i]);
//        if (it == s.end() || ss.lower_bound(b[i]) == ss.end())
//            r[b[i]] = b[i] + d;
//        else
//            r[b[i]] = *it + d;
//        if (it == s.end() || *it - b[i] > d) {
//            it = prev(it);
//            if (b[i] - *it <= d)
//                s.erase(it);
//            s.insert(b[i]);
//        }
//        ss.insert(b[i]);
//    }
    for (int i = 0; i < n; ++i) {
        int x = 0;
        r[i] = -1;
        for (int j = i + 1; j < n; ++j) {
            if (a[j] >= a[i])
                ++x;
            else
                x = 0;
            if (x == d) {
                r[i] = j;
                break;
            }
        }
        if (r[i] == -1)
            r[i] = n - 1;
    }
    int q;
    cin >> q;
    while (q--) {
        int tp, u, v;
        cin >> tp >> u >> v;
        --u;
        --v;
        if (a[u] > a[v])
            cout << "0\n";
        else if (r[u] >= v)
            cout << "1\n";
        else {
            vector<vi> up(n, vi(S));
            t.assign(R * 2, {-1, -1});
            for (int i = a[v]; i >= 0; --i) {
                update(b[i], r[b[i]]);
                up[b[i]][0] = get_max(b[i], r[b[i]] + 1).second;
            }
            for (int st = 1; st < S; ++st) {
                for (int i = 0; i < n; ++i)
                    up[i][st] = up[up[i][st - 1]][st - 1];
            }
            int x = 2;
            for (int st = S - 1; st >= 0; --st) {
                if (r[up[u][st]] < v) {
                    x += (1 << st);
                    u = up[u][st];
                }
            }
            u = up[u][0];
            if (r[u] < v)
                cout << "0\n";
            else if (tp == 1)
                cout << "1\n";
            else
                cout << x << '\n';
        }
    }
}
