//#pragma GCC optimize("O3", "unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define eb emplace_back
#define F first
#define S second
#define vec vector
#define all(x) (x).begin(), (x).end()

//#pragma GCC target("avx2")

using vi = vector<int>;
using str = string;
using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template<typename A>
void print(A &a, str sep=" "){
    for(auto &i: a)cout << i << sep;
    cout << "\n";
}
template<typename A>
void read(A &a){
    for(auto &i: a)cin >> i;
}

const int bs = 320;
const int inf = 1e18;


void solve(){
    int n, d, T; cin >> n >> d >> T;
    vi a(n); read(a);

    if(n <= 1000){
        vec<vi> dist(n, vi(n, inf));
        for(int u = 0; u < n; ++u){
            deque<int> q_min;
            for(int i = u + 1; i < n; ++i){
                if(!q_min.empty() && i - q_min.front() > d)
                    q_min.pop_front();
                if(a[i] > a[u]){
                    if(!q_min.empty())
                        dist[u][i] = dist[u][q_min.front()] + 1;
                    if(i - u <= d)dist[u][i] = 1;
                    continue;
                }
                if(a[i] < a[u] && i - u <= d){
                    dist[u][i] = 1;
                }
                if(!q_min.empty())
                    dist[u][i] = min(dist[u][i], dist[u][q_min.front()] + 1);
                while (!q_min.empty() && dist[u][q_min.back()] >= dist[u][i])
                    q_min.pop_back();
                if(dist[u][i] != inf)
                    q_min.pb(i);
            }
            for(int j = u + 1; j < n; ++j)
                if(a[j] < a[u])dist[u][j] = inf;
        }
        for(int i = 0; i < n; ++i){
            set<pii> cur;
            vi cd(n, inf);
            cd[i] = 0;
            cur.emplace(0, i);
            while (!cur.empty()){
                auto [dd, u] = *cur.begin();
                cur.erase(cur.begin());
                for(int j = 0; j < n; ++j){
                    if(dist[u][j] == inf)continue;
                    if(cd[j] > cd[u] + dist[u][j]){
                        cur.erase({cd[j], j});
                        cd[j] = cd[u] + dist[u][j];
                        cur.insert({cd[j], j});
                    }
                }
            }
            for(int j = 0; j < n; ++j)
                dist[i][j] = min(dist[i][j], cd[j]);
        }
        int q; cin >> q;
        while(q--){
            int t, u, v; cin >> t >> u >> v;
            u--; v--;
            if(dist[u][v] == inf){
                cout << 0 << "\n";
                continue;
            }
            if(t == 1)cout << 1 << "\n";
            else cout << dist[u][v] - 1 << "\n";
        }
        return;
    }

    int q; cin >> q;
    while(q--){
        int t, u, v; cin >> t >> u >> v;
        u--; v--;

    }
}


signed main() {
#ifdef LOCAL
    freopen("inp", "r", stdin);
#else
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#endif

    //clock_t start = clock();
    int TT = 1;
    //cin >> TT;
    while(TT--){
        solve();
    }
//    clock_t end = clock();
//    cout.precision(16);
//    cout << fixed;
//    cout << (ld)(end - start) / CLOCKS_PER_SEC << "\n";
    return 0;
}
