#include <vector>
#include <algorithm>
#include <iostream>
#include <map>

using namespace std;

#define ll long long

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, d, g;
	cin >> n >> d >> g;
	vector<int>a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int q;
	cin >> q;
	if (d >= n) {
		for (int i = 0; i < q; i++) {
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			if (u < v && a[u] < a[v]) {
				cout << 1 << "\n";
			}
			else {
				cout << 0 << "\n";
			}
		}
		return 0;
	}
	vector<ll>mem(n);
	for (int i = 0; i < n; i++) {
		mem[i] = -1;
	}
	for (int i = n-1; i >=0; i--) {
		for (int j = i + 1; j < min(n, i + d + 1); j++) {
			if (a[j] < a[i]) {
				mem[i] = j;
			}
		}
	}
	vector<vector<int>>ans(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (a[j] > a[i]) {
				if (j - i <= d) {
					ans[i][j] = 1;
				}
				else {
					if (mem[i] != -1) {
						if (ans[mem[i]][j] == 0) {
							ans[i][j] = 0;
						}
						else {
							ans[i][j] = 1 + ans[mem[i]][j];
						}
					}
					else {
						ans[i][j] = 0;
					}
				}
			}
		}
	}
	for (int i = 0; i < q; i++) {
		int t, u, v;
		cin >> t >> u >> v;
		u--;
		v--;
		if (t == 2) {
			cout << ans[u][v] << "\n";
		}
		if (t == 1) {
			cout << min(1, ans[u][v]) << "\n";
		}
	}
}