#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define ld long double
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

int const maxn = 5e5;
int const inf = 1e18;
ld const eps = 1e-12;
int const LOG = 20;
int const N = 2e3;

int n, d;
int group;
vector<int> g[maxn];

vector<int> bfs(int s) {
    vector<int> dist(n, inf);
    dist[s] = 0;
    queue<int> q;
    q.push(s);
    vector<int> used(n);
    while (q.size() > 0) {
        int v = q.front();
        q.pop();
        for (int u: g[v]) {
            if (!used[u]) {
                used[u] = 1;
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
    return dist;
}

inline void solve() {
    cin >> n >> d >> group;
    vector<int> a(n);
    for (int &i: a) cin >> i;
    for (int i = 0; i < n; i++) {
        int last = i;
        for (int j = i + 1; j < n; j++) {
            if (last + d < j) {
                break;
            }
            if (a[i] < a[j]) {
                g[i].pb(j);
            }
            if (a[i] > a[j]) {
                last = j;
            }
        }
    }

    int e;
    cin >> e;
    if (e == 1) {
        int t, u, v;
        cin >> t >> u >> v;
        u--, v--;
        int last = u;
        for (int j = u + 1; j < n; j++) {
            if (last + d < j) {
                break;
            }
            if (a[u] < a[j]) {
                g[u].pb(j);
            }
            if (a[u] > a[j]) {
                last = j;
            }
        }
        vector<int> dist = bfs(u);
        if (t == 1) {
            cout << (dist[v] != inf) << '\n';
        } else {
            cout << (dist[v] == inf ? 0 : dist[v]) << '\n';
        }
        return;
    }
    for (int i = 0; i < n; i++) {
        int last = i;
        for (int j = i + 1; j < n; j++) {
            if (last + d < j) {
                break;
            }
            if (a[i] < a[j]) {
                g[i].pb(j);
            }
            if (a[i] > a[j]) {
                last = j;
            }
        }
    }
    vector<vector<int>> dist(n);
    for (int i = 0; i < n; i++) {
        dist[i] = bfs(i);
    }
    while (e--) {
        int t, u, v;
        cin >> t >> u >> v;
        u--, v--;
        if (t == 1) {
            cout << (dist[u][v] != inf) << '\n';
        } else {
            cout << (dist[u][v] == inf ? 0 : dist[u][v]) << '\n';
        }
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
