#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

#define pb push_back
#define fi first
#define se second
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define int long long

using namespace std;
typedef long long i64;

const int inf = 1e18;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, d, g;
    cin >> n >> d >> g;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    vector<vector<int>> dist(n + 1, vector<int> (n + 1, inf));
    for (int r = n; r >= 1; --r) {
        dist[r][r] = 0;
        for (int l = r - 1; l >= 1; --l) {
            int prv = l;
            for (int m = l; m <= r; ++m) {
                if (a[m] <= a[l]) prv = m;
                if (m - prv <= d && a[l] <= a[m]) {
                    dist[l][r] = min(dist[l][r], dist[m][r] + 1);
                }
            }
        }
    }

    int q; cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;
        if (dist[u][v] == inf) { cout << "0\n"; continue;}
        if (t == 1) cout << 1;
        else cout << dist[u][v];
        cout << '\n';
    }
}
