#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

const int OO = 1e18;

void solve() {
    int n, d, G;
    cin >> n >> d >> G;

    vec<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    vec<vec<bool>> can(n + 1, vec<bool>(n + 1));
    for (int l = 1; l <= n; l++) {
        int last_less = l;

        for (int r = l; r <= n; r++) {
            if (r - last_less > d) break;

            if (a[r] < a[l]) {
                last_less = r;
            } else {
                can[l][r] = true;
            }
        }
    }

    vec<vec<int>> cnt(n + 1, vec<int>(n + 1, OO));
    for (int l = 1; l <= n; l++) {
        for (int r = l; r <= n; r++) {
            if (can[l][r]) {
                cnt[l][r] = 1;
            }
        }
    }
    for (int k = 1; k <= n; k++) {
        for (int u = 1; u <= n; u++) {
            for (int v = u; v <= n; v++) {
                if (cnt[u][k] + cnt[k][v] < cnt[u][v]) {
                    cnt[u][v] = cnt[u][k] + cnt[k][v];
                }
            }
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int t, u, v;
        cin >> t >> u >> v;

        if (t == 1) {
            cout << (cnt[u][v] == OO ? 0 : 1);
        } else {
            cout << (cnt[u][v] == OO ? 0 : cnt[u][v]);
        }

        cout << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
