﻿#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    
    int n, d, g, q;
    cin >> n >> d >> g;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (g <= 2) {
        vector<vector<int>> g(n, vector<int>(n, 0));
        for (int i = 0; i < n; ++i) {
            int lt = i;
            for (int j = i + 1; j < n; ++j) {
                if (j - lt > d) break;
                if (a[i] < a[j]) {
                    g[i][j] = 1;
                }
                else {
                    lt = j;
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            for (int k = i + 1; k < n; ++k) {
                for (int j = k + 1; j < n; ++j) {
                    if (g[i][k] != 0 && g[k][j] != 0) {
                        if (g[i][j] != 0) {
                            g[i][j] = min(g[i][j], g[i][k] + g[k][j]);
                        }
                        else {
                            g[i][j] = g[i][k] + g[k][j];
                        }
                    }
                }
            }
        }
        cin >> q;
        for (int i = 0; i < q; ++i) {
            int t, u, v;
            cin >> t >> u >> v;
            --u;
            --v;
            if (g[u][v] == 0) {
                cout << "0\n";
            }
            else {
                if (t == 1) {
                    cout << "1\n";
                }
                else {
                    cout << g[u][v] << '\n';
                }
            }
        }
    }
    else if (g == 4) {
        cin >> q;
        int u, v;
        cin >> u >> v;
        --u;
        set<pair<int, int>> st;
        st.insert({ a[u], 0 });
        vector<int> ds(n);
        for (int i = u+1; i < n; ++i) {
            ds[i] = min((*st.begin()).second + 1, (*st.upper_bound({ a[i], 0 })).second);
            st.insert({ a[i], ds[i] });
            if (i - u >= d) {
                st.erase({ a[i - d], ds[i - d] });
            }
        }
        cout << ds[n - 1];
    }

    return 0;
}