#include <bits/stdc++.h>
#include <experimental/random>
using namespace std;
using ll = long long;
using ld = long double;
void solve();

int main() {
    ll q = 1;
    while (q--) {
        solve();
    }
}
struct vec {
    ll x, y;
    ll operator* (vec v) {
        return x * v.x + y * v.y;
    };
    ll operator% (vec v) {
        return x * v.y - y * v.x;
    }
};
struct st {

};
vector<vector<ll>> g;
vector<ll> used;
vector<map<ll, ll>> can;
void dfs(ll v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u] == 0) {
            dfs(u);
        }
        can[v][u] = 1;
        for (auto z : can[u]) {
            if (can[v].find(z.first) != can[v].end()) {
                can[v][z.first] = min(can[v][z.first], z.second + 1);
            } else {
                can[v][z.first] = z.second + 1;
            }
        }
    }
}
void solve() {
    ll n, d, gr;
    cin >> n >> d >> gr;
    vector<ll> a(n);
    g.resize(n);
    can.resize(n);
    used.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        ll last = i;
        for (int j = i + 1; j < n; j++) {
            if (j - last > d) {
                break;
            }
            if (a[j] < a[i]) {
                last = j;
            } else {
                g[i].push_back(j);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i);
        }
    }
    ll q;
    cin >> q;
    while (q--) {
        ll t, v, u;
        cin >> t >> v >> u;
        v--, u--;
        if (can[v].find(u) == can[v].end()) {
            cout << 0 << '\n';
            continue;
        }
        if (t == 1) {
            cout << 1 << '\n';
        } else {
            cout << can[v][u] << '\n';
        }
    }
}
