#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <set>
#include <random>
#include <ctime>
#include <queue>
#include <unordered_map>

#define Cout cout << fixed << setprecision(15) 

using namespace std;

using ll = long long;
using ld = long double;

mt19937 gen(time(0));
const ll INF = 2e18, M = 1e9 + 7;

void solve() {
	ll n;
	cin >> n;
	vector<ll> a(n);
	for (ll& elem : a) {
		cin >> elem;
	}
	vector<ll> b(n);
	for (ll& elem : b) {
		cin >> elem;
	}
	vector<ll> x, y;
	vector<ll> x2, y2;
	for (int i = 0; i < n; i++) {
		ll ans = 0;
		
		x = {}; y = {};

		int ind0 = 0;
		while (ind0 < int(x2.size()) && x2[ind0] < a[i]) {
			x.push_back(x2[ind0]);
			ind0++;
		}
		x.push_back(a[i]);
		while (ind0 < int(x2.size())) {
			x.push_back(x2[ind0]);
			ind0++;
		}


		ind0 = 0;
		while (ind0 < int(y2.size()) && y2[ind0] < b[i]) {
			y.push_back(y2[ind0]);
			ind0++;
		}
		y.push_back(b[i]);
		while (ind0 < int(y2.size())) {
			y.push_back(y2[ind0]);
			ind0++;
		}
		
		x2 = x;
		y2 = y;
		for (int q = 0; q <= i; q++) {
			ans += x[q] - y[q];
		}

		ll cur_sum2 = 0;
		int cnt_bad2 = 0;
		for (int q = 1; q <= i; q++) {
			if (x[q] - y[q] < 0) {
				cnt_bad2++;
			}
			cur_sum2 += x[q] - y[q];
		}
		ll cur_sum;
		int cnt_bad;

		for (int j = 0; j <= i; j++) {
			cnt_bad = cnt_bad2;
			cur_sum = cur_sum2;

			if (cnt_bad == 0) {
				ans = min(ans, cur_sum);
			}

			for (int k = 0; k <= i - 1; k++) {
				if (j <= k) {
					if (x[k + 1] - y[k + 1] < 0) {
						cnt_bad--;
					}
					cur_sum -= x[k + 1] - y[k + 1];

					if (x[k + 1] - y[k] < 0) {
						cnt_bad++;
					}
					cur_sum += x[k + 1] - y[k];
				}
				else {
					if (x[k] - y[k + 1] < 0) {
						cnt_bad--;
					}
					cur_sum -= x[k] - y[k + 1];

					if (x[k] - y[k] < 0) {
						cnt_bad++;
					}
					cur_sum += x[k] - y[k];
				}
				if (cnt_bad == 0) {
					ans = min(ans, cur_sum);
				}
			}
			if (j < i) {
				if (x[j + 1] - y[j + 1] < 0) {
					cnt_bad2--;
				}
				cur_sum2 -= x[j + 1] - y[j + 1];

				if (x[j] - y[j + 1] < 0) {
					cnt_bad2++;
				}
				cur_sum2 += x[j] - y[j + 1];
			}
		}
		cout << ans << " ";
	}
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}

/*
2 4 1
1 2

4 3 1
1 1 2 1

7 2 3
1 2 3 4 5 6 7

60

*/