#include<iostream>
#include <random>
#include<vector>
#include<set>
#include<map>
#include<cassert>
#include<unordered_map>
#include<algorithm>
#include<iomanip>
#include<numeric>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define girlfriend friend

template<typename T>
bool assign_min(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> &a) {
    return in >> a.first >> a.second;
}

template<typename T, typename F>
std::ostream& operator<<(std::ostream& out, std::pair<T, F> a) {
    return out << a.first << " " << a.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011, b1 = 31, b2 = 29, MAXN = 1e5;
const long double eps = 1e-9;

void solve() {
    int n; cin >> n;
    vector<int> a(n); input(a);
    vector<int> b(n); input(b);
    int suma = 0, sumb = 0, d = 0, mx = 0, mn = inf;
    multiset<int> ma, mb, bb;
    multiset<pair<int, int>> m;
    for (int i = 0; i<n; ++i) {
        suma += a[i];
        sumb += b[i];
        assign_max(mx, a[i]);
        assign_min(mn, b[i]);
        assign_min(d, b[i]-a[i]);
        if (mb.lower_bound(a[i]) != mb.end()) assign_min(d, *mb.lower_bound(a[i])-a[i]);
        auto it = ma.upper_bound(b[i]);
        if (it != ma.begin()) {
            it--;
            assign_min(d, b[i]-*it);
        }
        auto it1 = m.lower_bound({a[i], b[i]});
        if (it1 == m.end() && it1 == m.begin()) {

        } else if (it1 == m.end()) {
            auto it2 = it1; it2--;
            if (it2->first < b[i]) bb.insert(b[i]);
        } else if (it1 == m.begin()) {
            if (a[i] < it1->second) bb.insert(it1->second);
        } else {
            auto it2 = it1; it2--;
            if (it2->first < it1->second) bb.erase(bb.find(it1->second));
            if (a[i] < it1->second) bb.insert(it1->second);
            if (it2->first < b[i]) bb.insert(b[i]);
        }
        auto it3 = bb.end();
        if (it3 != bb.begin()) {
            it3--;
            assign_min(d, *it3-mx);
        } else {
            assign_min(d, mn-mx);
        }
        auto it4 = bb.upper_bound(b[i]);
        if (it4 != bb.begin()) {
            it4--;
            assign_min(d, *it4-a[i]);
        }
        ma.insert(a[i]);
        mb.insert(b[i]);
        m.insert({a[i], b[i]});
        cout << suma - sumb + d << " ";
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; cin >> t;
    while (t--) solve();
    return 0;
}

//fft