#include <iostream>
#include <cstdint>
#include <vector>
#include <set>

using namespace std;

void sol() {
    uint64_t t;
    cin >> t;
    vector<int64_t> arr_a(2e5 + 1), arr_b(2e5 + 1);
    multiset<int64_t> a, b, b2;
    while (t--) {
        int64_t n;
        cin >> n;
        a.clear();
        b.clear();
        b2.clear();
        for (int64_t i = 0; i < n; ++i) cin >> arr_a[i];
        for (int64_t i = 0; i < n; ++i) cin >> arr_b[i];
        for (int64_t i = 0; i < n; ++i) {
            a.insert(arr_a[i]);
            b.insert(arr_b[i]);
            int64_t max_dif = 0, sum_dif = 0;
            for (auto a_v: a) {
                auto b_it = prev(b.upper_bound(a_v));
                auto dif = a_v - *b_it;
                if (dif > max_dif) max_dif = dif;
                sum_dif += dif;
                b2.insert(*b_it);
                b.erase(b_it);
            }
            swap(b, b2);
            cout << sum_dif - max_dif << " ";
        }
        cout << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    uint64_t t = 2;
#else
    uint64_t t = 1;
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    while (t--) {
        sol();
        cout << "\n";
    }
    return 0;
}
