#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <ctime>

#define int long long
#define x first
#define y second

std::mt19937 rnd(std::time(nullptr));
const int INF = 1e18;
const int MAXN = 1e5;
int MAXW = 0;

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> a(n), b(n);
    for (auto &e : a) {
        std::cin >> e;
    }
    for (auto &e : b) {
        std::cin >> e;
    }
    std::vector<int> dp[4];
    for (auto &e : dp) {
        e.resize(n + 1, +INF);
    }
    dp[0][0] = 0;
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < 4; j++) {
            if (j == 0) {
                dp[0][i] = dp[0][i - 1] + (a[i] - b[i]);
            }
            if (j == 1) {
                if (b[i] > a[i - 1]) {
                    continue;
                }
                dp[1][i] = std::min(dp[1][i - 1], (i > 1 ? dp[1][i - 2] : 0)) + (a[i - 1] - b[i]);
            }
            if (j == 2) {
                if (a[i] < b[i - 1]) {
                    continue;
                }
                dp[2][i] = std::min(dp[2][i - 1], (i > 1 ? dp[2][i - 2] : 0)) + (a[i] - b[i - 1]);
            }
            if (j == 3) {
                dp[3][i] = std::min(dp[3][i - 1], std::min(dp[1][i - 1], dp[2][i - 1])) + (a[i] - b[i]);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        std::cout << std::min(std::min(dp[0][i], dp[1][i]),
                              std::min(dp[2][i], dp[3][i])) << ' ';
    }
    std::cout << '\n';
}

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    std::cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}
