#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ordered_set = tree<ll, less<>, null_type, tree_tag, tree_order_statistics_node_update>;
#define all(a) a.begin, a.end()

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
     cin >> t;
    while (t--)
        solve();
}

int get(multiset<int> &a, multiset<int> &b) {
    int ans = 0;
    auto it = a.begin(), it1 = b.begin();
    for (; it != a.end(); it++, it1++) {
        ans += (*it - *it1);
        if (*it1 > *it)
            return 1e9;
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int &i: a)
        cin >> i;
    for (int &i: b)
        cin >> i;
    multiset<int> a1, b1;
    for (int i = 0; i < n; i++) {
        a1.insert(a[i]);
        b1.insert(b[i]);
        int mn = 1e9, ndx1 = 0, ndx2 = 0;
        for (int j = 0; j <= i; j++) {
            for (int j1 = 0; j1 <= i; j1++) {
                a1.erase(a1.find(a[j]));
                b1.erase(b1.find(b[j1]));
                int x = get(a1, b1);
                if (x < mn) {
                    mn = x;
                    ndx1 = j;
                    ndx2 = j1;
                }
                a1.insert(a[j]);
                b1.insert(b[j1]);
            }
        }
        cout << mn << ' ' << ndx1 << ' ' << ndx2 << '\n';
    }
    cout << "------------\n";
}