#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ordered_set = tree<ll, less<>, null_type, tree_tag, tree_order_statistics_node_update>;
#define all(a) a.begin, a.end()

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
     cin >> t;
    while (t--)
        solve();
}

ll get(multiset<ll> &a, multiset<ll> &b) {
    ll ans = 0;
    auto it = a.begin(), it1 = b.begin();
    for (; it != a.end(); it++, it1++) {
        ans += (*it - *it1);
        if (*it1 > *it)
            return 1e18;
    }
    return ans;
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    for (ll &i: a)
        cin >> i;
    for (ll &i: b)
        cin >> i;
    multiset<ll> a1, b1;
    for (ll i = 0; i < n; i++) {
        a1.insert(a[i]);
        b1.insert(b[i]);
        int x = *a1.begin();
        int y = *b1.begin();
        a1.erase(a1.begin());
        b1.erase(b1.begin());
        cout << get(a1, b1) << ' ';
        a1.insert(x);
        b1.insert(y);
    }
    cout << "\n";
}