#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define deb(x) cerr << #x << '\t' << x << '\n';

constexpr ll INF = 1e18;

void solve() {
	ll n; cin >> n;
	vector<ll>a(n);
	vector<ll>b(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
	}
	bool fl = true;
	for (int i = 0; i < n - 1; i++) {
		if (a[i] >= b[i + 1]) {
			fl = false;
		}
	}
	if (fl) {
		ll sm = 0;
		ll mx = 0;
		for (int i = 0; i < n; i++) {
			sm += a[i] - b[i];
			mx = max(mx, a[i] - b[i]);
			cout << sm - mx << ' ';
		}
		return;
	}
	for (int i = 0; i < n; i++) {
		sort(a.begin(), a.begin() + i + 1);
		sort(b.begin(), b.begin() + i + 1);
		vector<vector<ll>>dp(i + 1, vector<ll>(3, INF));
		if (i == 0) {
			cout << 0 << ' ';
			continue;
		}
		dp[0][0] = a[0] - b[0];
		dp[1][0] = dp[0][0] + a[1] - b[1];
		if (a[0] - b[1] >= 0) {
			dp[1][1] = a[0] - b[1];
		}
		if (a[1] - b[0] >= 0) {
			dp[1][2] = a[1] - b[0];
		}
		for (int j = 2; j <= i; j++) {
			if (a[j] - b[j - 1] >= 0) {
				dp[j][2] = min(dp[j - 1][2] + a[j] - b[j - 1], dp[j - 2][0] + a[j] - b[j - 1]);
			}
			if (a[j - 1] - b[j] >= 0) {
				dp[j][1] = min(dp[j - 1][1] + a[j - 1] - b[j], dp[j - 2][0] + a[j - 1] - b[j]);
			}
			dp[j][0] = dp[j - 1][0] + a[j] - b[j];
		}
		multiset<ll>p;
		vector<ll>suf(i + 2);
		for (int j = i; j >= 0; j--) {
			suf[j] = suf[j + 1] + a[j] - b[j];
			p.insert(a[j] - b[j]);
		}
		ll ans = suf[0] - *(--p.end());
		for (int j = 1; j <= i; j++) {
			ans = min(ans, min(dp[j][1], dp[j][2]) + suf[j + 1]);
		}
		cout << ans << ' ';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll T = 1;
	cin >> T;
	while (T--)	{
		solve();
		cout << '\n';
	}
	return 0;
}
