#include <iostream>
#include <vector>
#include <set>

using ll = long long;
using ld = long double;

using namespace std;

bool cmp(pair<int, int> a, pair<int, int> b) {
    if (a.first == b.first) {
        return a.second > b.second;
    } else {
        return a < b;
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int& x : a)
        cin >> x;
    for (int& x : b)
        cin >> x;
    multiset<int> s1, s2;
    vector<int> v1, v2;
    for (int i = 0; i < n; i++) {
        s1.insert(a[i]);
        s2.insert(b[i]);
        v1.push_back(a[i]);
        v2.push_back(b[i]);
        ll ans = 1e18;
        int p = *s1.rbegin();
        s1.erase(--s1.end());
        for (int y : v2) {
            s2.erase(s2.find(y));
            bool good = true;
            ll cnt = 0;
            auto it = s2.begin();
            for (int e : s1) {
                if (e < *it) {
                    good = false;
                    break;
                }
                cnt += e - *it;
                it++;
            }
            if (good)
                ans = min(ans, cnt);
            s2.insert(y);
        }
        s1.insert(p);
        p = *s1.begin();
        s1.erase(s1.begin());
        for (int y : v2) {
            s2.erase(s2.find(y));
            bool good = true;
            ll cnt = 0;
            auto it = s2.begin();
            for (int e : s1) {
                if (e < *it) {
                    good = false;
                    break;
                }
                cnt += e - *it;
                it++;
            }
            if (good)
                ans = min(ans, cnt);
            s2.insert(y);
        }
        s1.insert(p);
        p = *s2.begin();
        s2.erase(s2.begin());
        for (int x : v1) {
            s1.erase(s1.find(x));
            bool good = true;
            ll cnt = 0;
            auto it = s2.begin();
            for (int e : s1) {
                if (e < *it) {
                    good = false;
                    break;
                }
                cnt += e - *it;
                it++;
            }
            if (good)
                ans = min(ans, cnt);
            s1.insert(x);
        }
        s2.insert(p);
        p = *s2.rbegin();
        s2.erase(--s2.end());
        for (int x : v1) {
            s1.erase(s1.find(x));
            bool good = true;
            ll cnt = 0;
            auto it = s2.begin();
            for (int e : s1) {
                if (e < *it) {
                    good = false;
                    break;
                }
                cnt += e - *it;
                it++;
            }
            if (good)
                ans = min(ans, cnt);
            s1.insert(x);
        }
        s2.insert(p);
        cout << ans << ' ';
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
