#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;


using ll = long long;
using ld = long double;

using namespace std;

typedef tree<
        int,
        null_type,
        less_equal<int>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int& x : a)
        cin >> x;
    for (int& x : b)
        cin >> x;
    ordered_set s1, s2;
    vector<int> v1, v2;
    for (int i = 0; i < n; i++) {
        s1.insert(a[i]);
        s2.insert(b[i]);
        v1.push_back(a[i]);
        v2.push_back(b[i]);
        ll ans = 1e18;
        for (int j = 0; j < s1.size(); j++) {
            ll cnt = 0;
            int k = j;
            while (k < s1.size() - 1 && *s1.find_by_order(k) >= *s2.find_by_order(k + 1)) {
                cnt += *s1.find_by_order(k) - *s2.find_by_order(k + 1);
                k++;
            }
            for (int p = 0; p < j; p++)
                cnt += *s1.find_by_order(p) - *s2.find_by_order(p);
            for (int p = k + 1; p < s1.size(); p++)
                cnt += *s1.find_by_order(p) - *s2.find_by_order(p);
            ans = min(ans, cnt);
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
