//#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native") // bitset

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp> // ordered_set
#include <ext/pb_ds/tree_policy.hpp> // gp_hash_table, cc_hash_table

using namespace std;
using namespace __gnu_pbds;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long
#define all(a) a.begin(), a.end()

constexpr int inf = 2e18;

void solve() {
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int &i : a)
            cin >> i;
        vector<int> b(n);
        for (int &i : b)
            cin >> i;
        int suma = a[0], sumb = b[0];
        multiset<int> diff = {a[0] - b[0]};
        set<pair<int, int>> segs = {{b[0], a[0]}};
        cout << 0 << ' ';
        for (int i = 1; i < n; ++i) {
            suma += a[i], sumb += b[i];
            auto it = segs.upper_bound({b[i], -1});
            auto old = it;
            vector<pair<int, int>> to_del;
            while (it != segs.end() && ((it->second >= a[i] && it->first <= a[i]) || (it->second >= b[i] && it->first <= b[i]))) {
                to_del.push_back(*it);
                ++it;
            }
            it = old;
            if (it != segs.begin()) {
                --it;
                if ((it->second >= a[i] && it->first <= a[i]) || (it->second >= b[i] && it->first <= b[i]))
                    to_del.push_back(*it);
            }
            int mn = b[i], mx = a[i];
            for (auto i : to_del) {
                segs.erase(i);
                diff.extract(i.second - i.first);
                mx = max(mx, i.second);
                mn = min(mn, i.first);
            }
            diff.insert(mx - mn);
            segs.insert({mn, mx});
            cout << suma - sumb - *diff.rbegin() << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
