#include <iostream>
#include <vector>
#include <set>

using namespace std;

void sol() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    vector<int> cnt(n, 0);
    for (int i = 0; i < n; i++) {
        multiset<int> st1;
        multiset<int> st2;
        long long ans = 0, mx = 0;
        for (int j = 0; j <= i; j++) {
            st1.insert(a[j]);
            st2.insert(b[j]);
        }
        for (auto x : st1) {
            auto it = st2.upper_bound(x);
            it--;
            int c = x - (*it);
            ans += c;
            if (c > mx) {
                mx = c;
            }
            st2.erase(it);
        }
        cout << ans - mx << " ";
    }
    cout << '\n';
}

int main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        sol();
    }
    return 0;
}
