#include <bits/stdc++.h>

using namespace std;
#define pb push_back
#define ll long long
#define int ll
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
//typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int MOD = 1e9 + 7;
const int INF = 1e18 + 7;
const int maxn = 2e5 + 10;

int n, a[maxn], b[maxn], d[maxn * 8];
pii tree[maxn * 8];

void build(int tind, int l, int r) {
    if(r - l == 1) {
        tree[tind] = {0, -l};
        return;
    }
    int m = (r + l) >> 1;
    build(tind * 2 + 1, l, m);
    build(tind * 2 + 2, m, r);
    tree[tind] = min(tree[tind * 2 + 1], tree[tind * 2 + 2]);
}

void push(int tind, int l, int r) {
    if(r - l != 1) {
        d[tind * 2 + 1] += d[tind];
        d[tind * 2 + 2] += d[tind];
    }
    tree[tind].X += d[tind];
    d[tind] = 0;
}

void upd(int tind, int l, int r, int ql, int qr, int x) {
    push(tind, l, r);
    if(ql <= l && r <= qr) {
        d[tind] += x;
        push(tind, l, r);
        return;
    }
    if(ql >= r || l >= qr) return;
    int m = (r + l) >> 1;
    upd(tind * 2 + 1, l, m, ql, qr, x);
    upd(tind * 2 + 2, m, r, ql, qr, x);
    tree[tind] = min(tree[tind * 2 + 1], tree[tind * 2 + 2]);
}

pii get(int tind, int l, int r, int ql, int qr) {
    push(tind, l, r);
    if(ql <= l && r <= qr) return tree[tind];
    if(ql >= r || l >= qr) return {INF, INF};
    int m = (r + l) >> 1;
    return min(get(tind * 2 + 1, l, m, ql, qr), get(tind * 2 + 2, m, r, ql, qr));
}

void solve() {
    cin >> n;
    for(int i = 1; i <= n; ++i) cin >> a[i];
    for(int i = 1; i <= n; ++i) cin >> b[i];
    bool f = true;
    for(int i = 1; i < n; ++i) if(a[i] >= b[i + 1]) f = false;
    if(f) {
        vector<int> aa, bb;
        int sma = 0, smb = 0, ans = 0;
        for(int i = 1; i <= n; ++i) {
            sma += a[i], smb += b[i];
            ans = max(ans, a[i] - b[i]);
            cout << sma - smb - ans << ' ';
        }
        cout << '\n';
    } else if(n <= 100) {
        int sma = 0, smb = 0;
        for(int i = 1; i <= n; ++i) {
            int res = sma - smb;
            sma += a[i];
            smb += b[i];
            for(int da = 1; da <= i; ++da) {
                for(int db = 1; db <= i; ++db) {
                    vector<int> a1, b1;
                    for(int j = 1; j <= i; ++j) if(j != da) a1.pb(a[j]);
                    for(int j = 1; j <= i; ++j) if(j != db) b1.pb(b[j]);
                    sort(all(a1));
                    sort(all(b1));
                    int ans = 0;
                    for(int j = 0; j < (int)a1.size(); ++j) {
                        if(b1[j] > a1[j]) {
                            ans = INF;
                            break;
                        }
                        ans += a1[j] - b1[j];
                    }
                    res = min(res, ans);
                }
            }
            cout << res << " ";
        }
    } else {
        map<int, int> szh, obr;
        vector<int> all;
        for(int i = 1; i <= n; ++i) {
            all.pb(a[i]);
            all.pb(b[i]);
        }
        sort(all(all));
        for(int i : all) {
            if(szh.find(i) == szh.end()) {
                szh[i] = (int)szh.size();
                obr[szh[i]] = i;
            }
        }
        int ts = (int)szh.size();
        build(0, 0, ts);
        multiset<int> bb;
        int sma = 0, smb = 0;
        for(int i = 1; i <= n; ++i) {
            sma += a[i];
            smb += b[i];
            upd(0, 0, ts, 0, szh[a[i]] + 1, 1);
            upd(0, 0, ts, 0, szh[b[i]] + 1, -1);
            int ans = 0;
            bb.insert(b[i]);
            for(int da = 1; da <= i; ++da) {
               upd(0, 0, ts, 0, szh[a[da]] + 1, -1);
               pii tmr = get(0, 0, ts, 0, ts);
               ans = max(ans, a[da] - *bb.lower_bound(obr[-tmr.Y]));
               upd(0, 0, ts, 0, szh[a[da]] + 1, 1);
            }
            cout << sma - smb - ans << " ";
        }
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int ttt;
    cin >> ttt;
    while(ttt--) {
        solve();
    }
}
