#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <math.h>
#include <algorithm>
#include <queue>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

void solve() {
	ll n, i, p, j, sa, sb, mn = -1, amx, bmn;
	cin >> n;
	vector <ll> a(n);
	vector <ll> b(n);
	for (i = 0; i < n; i++) cin >> a[i];
	for (i = 0; i < n; i++) cin >> b[i];
	vector <ll> prefa(n);
	vector <ll> prefb(n);
	prefa[0] = a[0];
	for (i = 1; i < n; i++) prefa[i] = prefa[i - 1] + a[i];
	prefb[0] = b[0];
	for (i = 1; i < n; i++) prefb[i] = prefb[i - 1] + b[i];

	vector <ll> c(n);
	c[n - 1] = 1;
	for (i = 0; i < n - 1; i++) if (a[i] < b[i + 1]) c[i] = 1;

	j = 0;
	vector <ll> mp(n, -1);
	for (i = 0; i < n; i++) {
		while (c[j] == 0 || j < i) j++;
		p = a[j] - b[i];
		mp[j] = max(mp[j], p);
	}
	vector <ll> ans(n);
	amx = -1, bmn = 1e18;
	for (i = 0; i < n; i++) {
		if (mp[i] != -1) {
			if (mn == -1) mn = mp[i];
			else mn = max(mn, mp[i]);
		}
		amx = max(amx, a[i]);
		bmn = min(bmn, b[i]);
		if (mn == -1) p = bmn - amx;
		else p = -mn;
		ans[i] = prefa[i] - prefb[i] + p;
	}

	for (i = 0; i < n; i++) cout << ans[i] << " ";
	cout << endl;
}

int main() {
	ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
	ll t = 1;
	cin >> t;
	while (t--) solve();
}