#include<bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;
//
typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;
typedef long long ll;
typedef long double ld;
//
#define int ll
#define double ld
//
#define inf INT_MAX
#define sz(a) (int)a.size()
// #define clear(arr) memset(arr, 0, sizeof(arr))
#define contain(el, arr) (arr.find(el) != arr.end())
#define all(a) a.begin(), a.end()
#define ceil(a) (int)ceil((double)a) // (num + del-1)/del*del
#define round(a) (int)round((double)a)
#define trunc(a) (int)trunc((double)a)
#define pb push_back
#define ff first
#define ss second
#define cin_arr(arr) for (auto& _ : arr) cin >> _
#define cout_arr(arr) for (auto& _ : arr) cout << _ << " "
#define endl '\n'

ll mod = 1e9 + 7;
// mt19937 mt(time(nullptr));

//int n, t[4*MAXN];
//
//void build (int a[], int v, int tl, int tr) {
//    if (tl == tr)
//        t[v] = a[tl];
//    else {
//        int tm = (tl + tr) / 2;
//        build (a, v*2, tl, tm);
//        build (a, v*2+1, tm+1, tr);
//        t[v] = t[v*2] + t[v*2+1];
//    }
//}
//
//int sum (int v, int tl, int tr, int l, int r) {
//    if (l > r)
//        return 0;
//    if (l == tl && r == tr)
//        return t[v];
//    int tm = (tl + tr) / 2;
//    return sum (v*2, tl, tm, l, min(r,tm))
//           + sum (v*2+1, tm+1, tr, max(l,tm+1), r);
//}
//
//void update (int v, int tl, int tr, int pos, int new_val) {
//    if (tl == tr)
//        t[v] = new_val;
//    else {
//        int tm = (tl + tr) / 2;
//        if (pos <= tm)
//            update (v*2, tl, tm, pos, new_val);
//        else
//            update (v*2+1, tm+1, tr, pos, new_val);
//        t[v] = t[v*2] + t[v*2+1];
//    }
//}
//
//int find_kth (int v, int tl, int tr, int k) {
//    if (k > t[v])
//        return -1;
//    if (tl == tr)
//        return tl;
//    int tm = (tl + tr) / 2;
//    if (t[v*2] >= k)
//        return find_kth (v*2, tl, tm, k);
//    else
//        return find_kth (v*2+1, tm+1, tr, k - t[v*2]);
//}
//
//struct foo {
//    int bar;
//    foo() : bar(3) {}   //look, a constructor
//    int getBar()
//    {
//        return bar;
//    }
//};
//
//foo f;
//int y = f.getBar(); // y is 3


int gcd(int a, int b){
    if (a < b) return gcd(b, a);
    if (b == 0) return a;
    return  gcd(b, a%b);
}

vector<vector<int>> graph1;
vector<set<int>> graph2;

vector<int> used1;
vector<int> used2;



void dfs1(int v, int c){
    for (int u : graph1[v]){
        if (!used1[u]){
            used1[u] = c;
            dfs1(u, c);
        }
    }
}

void dfs2(int v, int c){
    for (int u : graph2[v]){
        if (!used2[u]){
            used2[u] = c;
            dfs2(u, c);
        }
    }
}


void solve1() {
    int g; cin >> g;
    int n; cin >> n;
    int m1, m2; cin >> m1 >> m2;
    graph1.resize(n+1);
    used1.resize(n+1);
    used2.resize(n+1);
    graph2.resize(n+1);

    int a, b;
    for (int i = 0; i < m1; i++){
        cin >> a >> b;
        graph1[a].pb(b);
        graph1[b].pb(a);
    }
    for (int i = 0; i < m2; i++){
        cin >> a >> b;
        graph2[a].insert(b);
        graph2[b].insert(a);
    }

    int color = 1;
    for (int i = 1; i < n; i++){
        if (!used1[i]){
            dfs1(i, color);
            color++;
        }
    }
    if (color-1 == 1){
        cout << "Yes\n0\n";
        return;
    }
    map<int, set<int>> group;
    for (int i = 1; i < n+1; i++){
        group[used1[i]].insert(i);
    }
    vector<pair<int, int>> ans;
    for (int c = 1; c < color-1; c++){
        if (group[c].empty()) continue;
        for (int ver : group[c]){
            for (int ver1 : group[c+1]){
                if (graph2[ver1].find(ver) == graph2[ver1].end()){
                    ans.pb({ver1, ver});
                    graph2[ver1].insert(ver);
                    graph2[ver].insert(ver1);
                    graph1[ver1].pb(ver);
                    graph1[ver].pb(ver1);
                    //group[c] + group[c+1];
                    if (sz(group[c]) < sz(group[c+1])){
                        for (int u:group[c]) {
                            group[c + 1].insert(u);
                            group[c].clear();
                        }
                    }else{
                        for (int u:group[c+1])
                            group[c].insert(u);
                            group[c+1].clear();
                    }
                    c--;
                    break;
                }//else
            }
        }
    }
    int cnt = 0;
    for (int c = 1; c < color-1; c++){
        if (group[c].empty()) continue;
        cnt++;
    }
    if (cnt > 1){
        cout << "No\n";
    }else{
        cout << "Yes\n";
        cout << sz(ans) << endl;
        for (pair<int, int> p : ans)
            cout << p.ff << " " << p.ss << endl;
    }

}

void solve2(){
    int n; cin >> n;
    vector<int> d(n), l(n), r(n);
    cin_arr(d);cin_arr(l);cin_arr(r);
    vector<int> a(n+1, 0), b(n+1, 0);
    cin >> a[0] >> b[0];
    int sum = 0;
    for (int i = 0; i < n; i++){
        sum += d[i];
        a[i+1] += d[i];
        b[i+1] += d[i];
    }

}

void solve3(){
    int n; cin >> n;
    vector<int> a(n), b(n);
    cin_arr(a);cin_arr(b);
    sort(all(a)); sort(all(b));

    vector<vector<int>> dp(2, vector<int> (n+1));
    dp[0][1] = 0;
    dp[1][1] = a[0]-b[0];
    for (int i = 2; i < n+1;i++){
        dp[0][i] = min(dp[1][i-1], dp[0][i-1]+a[i-1]-b[i-1]);
        dp[1][i] = dp[1][i-1] + a[i-1] - b[i-1];
    }

    for (int i = 1; i < n+1; i++){
        cout << dp[0][i] << " ";
    }
    cout << endl;
}



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); // ifstream cin(input.txt);
    cout.tie(nullptr); // ofstream cout(output.txt);

//    solve2();
    int t; cin >> t;
    while (t--){
        solve3();
        // cout << "__________" << endl;
    }

    cout << fixed << setprecision(10);
    // cerr << "Time:" << 1000*((double)clock())/(double)CLOCKS_PER_SEC << "ms\n";

    return 0;
}