#include "bits/stdc++.h"

using namespace std;

using ll = long long;

void solve() {
    int n;
    cin >> n;

    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<ll> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    if (n <= 500) {
        multiset<int> A, B;
        for (int i = 1; i <= n; ++i) {
            A.insert(a[i - 1]);
            B.insert(b[i - 1]);

            vector<int> avals;
            vector<int> bvals;
            for (auto v: A) avals.push_back(v);
            for (auto v: B) bvals.push_back(v);

            ll ans = 1e18;
            for (int block = 0; block < i; ++block) {
                vector<int> newb = bvals;
                newb.erase(newb.begin() + block);

                ll suml = 0, sumr = 0;
                ll lerrs = 0, rerrs = 0;
                for (int j = 1; j < i; ++j) {
                    sumr += avals[j] - newb[j - 1];
                    rerrs += avals[j] < newb[j - 1];
                }
                if (rerrs == 0) ans = min(ans, sumr);
                for (int j = 0; j < i - 1; ++j) {
                    suml += avals[j] - newb[j];
                    sumr -= avals[j + 1] - newb[j];
                    lerrs += avals[j] < newb[j];
                    rerrs -= avals[j + 1] < newb[j];

                    if (lerrs == 0 && rerrs == 0) ans = min(ans, suml + sumr);
                }
            }

            cout << ans << " ";
        }
        cout << "\n";
    } else {
        ll diff = 0;
        ll maxdiff = 0;
        for (int i = 0; i < n; ++i) {
            diff += a[i] - b[i];
            maxdiff = max(maxdiff, a[i] - b[i]);
            cout << diff - maxdiff << " ";
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}