#include <bits/stdc++.h>


using namespace std;


const long long inf = 1e18 + 7;


struct cmp {
    bool operator()(int a, int b) {
        return a > b;
    }
};


void solve() {
    int n;
    cin >> n;
    vector<long long> a(n);
    vector<long long> b(n);
    for (int i = 0; i < n; i++) {
        cin >> a.at(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> b.at(i);
    }
    vector<long long> sa(n);
    vector<long long> sb(n);
    vector<long long> val(n);
    val.at(0) = 0;
    sa.at(0) = a.at(0);
    sb.at(0) = b.at(0);
    for (int i = 1; i < n; i++) {
        long long mn = inf;
        sa.at(i) = sa.at(i - 1) + a.at(i);
        sb.at(i) = sb.at(i - 1) + b.at(i);
        for (int j = 0; j <= i; j++) {
            for (int k = 0; k <= i; k++) {
                vector<long long> b1;
                vector<long long> b2;
                for (int l = 0; l <= i; l++) {
                    if (l != j) {
                        b1.push_back(a.at(l));
                    }
                    if (l != k) {
                        b2.push_back(b.at(l));
                    }
                }
                sort(b1.begin(), b1.end());
                sort(b2.begin(), b2.end());
                bool can = 1;
                long long op = 0;
                for (int l = 0; l < int(b1.size()); l++) {
                    if (b1.at(l) < b2.at(l)) {
                        can = 0;
                        break;
                    }
                    op += b1.at(l) - b2.at(l);
                }
                if (can) {
                    mn = min(mn, op);
                }
            }
        }
        val.at(i) = mn;
    }
    for (int i = 0; i < n; i++) {
        cout << val.at(i) << " ";
    }
    cout << '\n';
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}