#include <bits/stdc++.h>


using namespace std;


const long long inf = 1e18 + 7;


struct cmp {
    bool operator()(int a, int b) {
        return a > b;
    }
};


void solve() {
    int n;
    cin >> n;
    vector<long long> a(n);
    vector<long long> b(n);
    for (int i = 0; i < n; i++) {
        cin >> a.at(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> b.at(i);
    }
    vector<long long> sa(n);
    vector<long long> sb(n);
    vector<long long> val(n);
    val.at(0) = 0;
    sa.at(0) = a.at(0);
    sb.at(0) = b.at(0);
    set<pair<long long, int>> b1;
    set<pair<long long, int>> b2;
    for (int i = 1; i < n; i++) {
        long long mn = inf;
        sa.at(i) = sa.at(i - 1) + a.at(i);
        sb.at(i) = sb.at(i - 1) + b.at(i);
        b1.insert({a.at(i), i});
        b2.insert({b.at(i), i});
        for (int j = 0; j <= i; j++) {
            for (int k = 0; k <= i; k++) {
                b1.erase(make_pair(a.at(j), j));
                b2.erase(make_pair(b.at(k), k));
                auto it1 = b1.begin();
                auto it2 = b2.begin();
                bool can = 1;
                long long op = 0;
                while (it1 != b1.end()) {
                    if (it1 -> first < it2 -> first) {
                        can = 0;
                        break;
                    }
                    op += it1 -> first - it2 -> first;
                    it1++;
                    it2++;
                }
                if (can) {
                    mn = min(mn, op);
                }
                b1.insert(make_pair(a.at(j), j));
                b2.insert(make_pair(b.at(k), k));
            }
        }
        val.at(i) = mn;
    }
    for (int i = 0; i < n; i++) {
        cout << val.at(i) << " ";
    }
    cout << '\n';
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}