#include <bits/stdc++.h>


using namespace std;


const long long inf = 1e18 + 7;


struct cmp {
    bool operator()(int a, int b) {
        return a > b;
    }
};


void solve() {
    int n;
    cin >> n;
    vector<long long> a(n);
    vector<long long> b(n);
    for (int i = 0; i < n; i++) {
        cin >> a.at(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> b.at(i);
    }
    vector<long long> val(n);
    val.at(0) = 0;
    vector<long long> b1;
    vector<long long> b2;
    b1.push_back(a.at(0));
    b2.push_back(b.at(0));
    for (int i = 1; i < n; i++) {
        long long mn = val.at(i - 1) + a.at(i) - b.at(i);
        b1.push_back(a.at(i));
        b2.push_back(b.at(i));
        sort(b1.begin(), b1.end());
        sort(b2.begin(), b2.end());
        for (int j = 0; j <= i; j++) {
            int p1 = 0, p2 = 0, k = i;
            bool can1 = 1, can2 = 1;
            long long op1 = 0, op2 = 0;
            while (p1 < int(b1.size()) && p2 < int(b2.size())) {
                if (p1 == j || p2 == k) {
                    if (p1 == j) {
                        p1++;
                    }
                    if (p2 == k) {
                        p2++;
                    }
                    continue;
                }
                if (b1.at(p2) < b2.at(p1)) {
                    can2 = 0;
                }
                if (b1.at(p1) < b2.at(p2)) {
                    can1 = 0;
                }
                op1 += b1.at(p1) - b2.at(p2);
                op2 += b1.at(p2) - b2.at(p1);
                p1++;
                p2++;
            }
            if (can1) {
                mn = min(mn, op1);
            }
            if (can2) {
                mn = min(mn, op2);
            }
        }
        val.at(i) = mn;
    }
    for (int i = 0; i < n; i++) {
        cout << val.at(i) << " ";
    }
    cout << '\n';
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
