#include <bits/stdc++.h>

using namespace std;

constexpr long long inf = (long long)1e18 + 7;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int pr = 1; pr <= n; ++pr) {
        long long ans = inf;
        vector<int> a_nw, b_nw;
        for (int i = 0; i < pr; ++i) {
            a_nw.push_back(a[i]);
            b_nw.push_back(b[i]);
        }
        sort(a_nw.begin(), a_nw.end());
        sort(b_nw.begin(), b_nw.end());
        for (int pos = 0; pos < pr; ++pos) {
            long long ans_nw = 0;
            int p = pr - 1;
            for (int i = pr - 1; i >= 0; --i) {
                if (i == pos) {
                    continue;
                }
                while (a_nw[i] < b_nw[p]) {
                    p--;
                }
                ans_nw += a_nw[i] - b_nw[p];
                p--;
            }
            ans = min(ans, ans_nw);
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
