#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...) 52
#endif

using ll = long long;
using namespace std;

void solve() {
    int n;
    cin >> n;

    vector<int> a(n);
    vector<int> b(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    bool group4 = true;

    for (int i = 0; i + 1 < n; i++) {
        if (a[i] >= b[i + 1]) {
            group4 = false;
        }
    }
    
    bool group5 = true;

    for (int i = 0; i + 1 < n; i++) {
        if (a[i] > a[i + 1] || b[i] > b[i + 1]) {
            group5 = false;
        }
    }

    if (!group4 && !group5) {
        for (int i = 1; i <= n; i++) {
            vector<int> A(a.begin(), a.begin() + i);
            vector<int> B(b.begin(), b.begin() + i);
            ranges::sort(A);
            ranges::sort(B);

            ll ans = 0;
            int mx = 0;
            int prev = i;

            for (int j = i - 1; j >= 0; j--) {
                ans += A[j] - B[j];
                if (j == 0 || B[j] > A[j - 1]) {
                    mx = max(mx, A[prev - 1] - B[j]);
                    prev = j;
                }
            }

            cout << ans - mx << ' ';
        }
        cout << '\n';
    } else if (group5 || group4) {
        ll ans = 0;
        int mx = 0;
        int prev;
        for (int i = 0; i < n; i++) {
            ans += a[i] - b[i];
            if (i == 0 || b[i] > a[i - 1]) {
                prev = i;
            }
            mx = max(mx, a[i] - b[prev]);
            cout << ans - mx << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}
