#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("03")
#pragma GCC target("avx2")
#endif

using namespace std;

using ll = long long;
using ld = long double;

using pld = pair<ld, ld>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using vin = vector<int>;
using vll = vector<ll>;
using vld = vector<ld>;
using vbo = vector<bool>;
using vpl = vector<pll>;
using vpi = vector<pii>;
using vpd = vector<pld>;

using vvi = vector<vin>;
using vvl = vector<vll>;
using vvo = vector<vbo>;

#define sz(a) (ll)a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define FOR(i, a, b) for(int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for(int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for (auto &i : a)

#define fastio ios_base::sync_with_stdio(false);cin.tie(0)

ll n;
vll a, b;

void solve0(){
    ll sma = 0, smb = 0;
    vll ca;
    vll cb;
    F0R(temp, n){
        sma += a[temp];
        smb += b[temp];
        ca.pub(a[temp]);
        cb.pub(b[temp]);
        sor(ca);
        sor(cb);
        ll k = 0;
        ll mn = 1e16;
        F0R(i, temp + 1){
            if (i > 0){
                if (ca[i - 1] < cb[i]){
                    k = i;
                }
            }
            mn = min(mn, sma - smb - ca[i] + cb[k]);
        }
        cout << mn << ' ';
    }
    cout << '\n';
}

void solve1(){
    ll mx = 0;
    ll sm_a = 0, sm_b = 0;
    F0R(i, n){
        mx = max(mx, a[i] - b[i]);
        sm_a += a[i];
        sm_b += b[i];
        cout << sm_a - sm_b - mx << ' ';
    }
    cout << '\n';
}

void solve2(){
    ll sma = 0, smb = 0;
    ll lst = 0;
    ll mx = 0;
    F0R(temp, n){
        sma += a[temp];
        smb += b[temp];
        if (temp == 0){
            cout << 0 << ' ';
            continue;
        }
        if (b[temp] > a[temp - 1]){
            lst = temp;
        }
        mx = max(mx, a[temp] - b[lst]);
        cout << sma - smb - mx << '\n';
    }
    cout << '\n';
}

void solve(){
    cin >> n;
    a.resize(n);
    b.resize(n);
    F0R(i, n){
        cin >> a[i];
    }
    F0R(i, n){
        cin >> b[i];
    }
    bool check1 = true;
    F0R(i, n - 1){
        if (b[i + 1] <= a[i]){
            check1 = false;
            break;
        }
    }
    if (n <= 3000){
        solve0();
        return;
    }
    if (check1){
        solve1();
        return;
    }
    solve2();
}

int main() {
    fastio;
    ll t;
    cin >> t;
    F0R(i, t){
        solve();
    }
    return 0;
}
