#include <bits/stdc++.h>

using namespace std;
using ll = long long;

mt19937_64 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

struct Fast {
    void solve() {
        ll n;
        cin >> n;
        vector<ll> a(n), b(n);
        for (auto &i: a) cin >> i;
        for (auto &j: b) cin >> j;
        bool four_group = true;
        for (int i = 1; i < n; i++) {
            if (b[i] <= a[i - 1]) {
                four_group = false;
            }
        }
        vector<ll> f;
        vector<ll> s;
        if (!four_group) {
            for (int i = 0; i < n; i++) {
                f.push_back(a[i]);
                s.push_back(b[i]);
                sort(f.begin(), f.end());
                sort(s.begin(), s.end());
                ll sum = 0;
                for (int j = 0; j <= i; j++) {
                    sum += f[j] - s[j];
                }
                ll mn_j = 0;
                ll best_res = sum;
                for (int j = 0; j <= i; j++) {
                    ll nw = sum - (f[j] - s[j]) + (s[mn_j] - s[j]);
                    best_res = min(best_res, nw);
                    if (j < n - 1 && s[j + 1] > f[j]) mn_j = j + 1;
                }
                cout << best_res << ' ';
            }
            cout << '\n';
        } else {
            ll sum = 0;
            ll mx_diff = 0;
            for (int i = 0; i < n; i++) {
                sum += a[i] - b[i];
                mx_diff = max(mx_diff, a[i] - b[i]);
                cout << sum - mx_diff << ' ';
            }
            cout << '\n';
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll times = 1;
    bool stres = false;
    if (stres) times = 1e9;
    else cin >> times;
    while (times--) {
        if (!stres) {
            Fast f;
            f.solve();
        }
    }
    return 0;
}
