#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
#define int int64_t
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF = 1e9 + 117;

void solve() {
    int n; cin >> n;
    vector<int> a(n), b(n);
    for (auto& e : a) cin >> e;
    for (auto& e : b) cin >> e;
    for (int i = 0; i < n; ++i) {
        vector<int> aa, bb;
        for (int j = 0; j <= i; ++j) {
            aa.push_back(a[j]);
            bb.push_back(b[j]);
        }
        sort(aa.begin(), aa.end());
        sort(bb.begin(), bb.end());
        int lst = -1;
        for (int j = 0; j < i; ++j) {
            int ind = upper_bound(bb.begin(), bb.end(), aa[j]) - 1 - bb.begin();
            if (ind == j) lst = j;
        }
        int ans = 0;
        for (int j = 0; j <= lst; ++j) ans += aa[j] - bb[j];
        for (int j = lst + 1; j <= i - 1; ++j) {
            ans += aa[j] - bb[j + 1];
        }
        int sm = 0;
        for (int j = 0; j <= i; ++j) {
            if (j == lst) continue;
            sm += aa[j] - bb[j];
        }
        cout << min(sm, ans) << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int tt; cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
