#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>
#include <bits/extc++.h>


using namespace std;
using namespace __gnu_pbds;

#define int long long
#define forn(i, a, b) for(int i = (a); i < (b); ++i)
#define fornn(i, a, b) for(int i = (a); i > (b); --i)
#define endl '\n'
#define pint pair<int, int>
#define mp(a, b) make_pair(a, b)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve() {
    auto calc = [&](vector<int>& a, vector<int>& b, int n) {
        vector<int> ans(n, -1);
        ans[0] = 0;

        int s1 = a[0], s2 = b[0];
        multiset<int> d;
        d.insert(s1 - s2);
        vector<int> best(n), revbest(n);
        best[0] = revbest[0] = 0;
        int sm = s1 - s2;

        forn(i, 1, n) {
            if (b[i] <= a[i - 1]) {
                int _d = a[i - 1] - b[best[i - 1]];
                d.erase(d.find(_d));
                sm -= _d;
                d.insert(a[i - 1] - b[i]);
                sm += a[i - 1] - b[i];
                d.insert(a[i] - b[best[i - 1]]);
                sm += a[i] - b[best[i - 1]];
                best[i] = best[i - 1];
                revbest[best[i - 1]] = i;
                best[i - 1] = i;
                revbest[i] = i - 1;
            } else {
                d.insert(a[i] - b[i]);
                sm += a[i] - b[i];
                best[i] = i;
                revbest[i] = i;
            }
            ans[i] = sm - *d.rbegin();
        }
        return ans;
    };

    int n;
    cin >> n;

    vector<int> a(n), b(n);
    forn(i, 0, n) {
        cin >> a[i];
    }
    forn(i, 0, n) {
        cin >> b[i];
    }

    vector<int> sorted = a, sb = b;
    sort(all(sorted));
    sort(all(sb));

    if (a == sorted && b == sb) {
        auto res = calc(a, b, n);
        forn(i, 0, n) {
            cout << res[i] << " " ;
        }
        cout << endl;
        return;
    }

    vector<int> ra = { a[0] }, rb = { b[0] };

    vector<int> ans(n, -1);
    ans[0] = 0;

    int s1 = a[0], s2 = b[0];
    multiset<int> d;
    d.insert(s1 - s2);
    vector<int> best(n), revbest(n);
    best[0] = revbest[0] = 0;
    int sm = s1 - s2;

    forn(i, 1, n) {
        ra.push_back(a[i]);
        rb.push_back(b[i]);
        sort(all(ra));
        sort(all(rb));

        vector<int> res = calc(ra, rb, i + 1);
        ans[i] = res.back();
    }

    forn(i, 0, n) {
        cout << ans[i] << " ";
    }
    cout << endl;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;
    while (t--) solve();

    return 0;
}
