#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(101);


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll _;
    cin >> _;
    while (_--) {
        ll n;
        cin >> n;
        vector<ll> a0(n), b0(n);
        for (ll &i: a0)
            cin >> i;
        for (ll &i: b0)
            cin >> i;

        ll sumA = 0, sumB = 0;
        for (int i = 1; i <= n; ++i) {
            sumA += a0[i - 1], sumB += b0[i - 1];
            vector<ll> a(i), b(i);
            for (int j = 0; j < i; ++j)
                a[j] = a0[j], b[j] = b0[j];
            sort(a.begin(), a.end());
            sort(b.begin(), b.end());

            ll ans = LLONG_MAX;
            for (int j = 0; j < i; ++j) {
                int pos = j;
                for (int k = j - 1; k >= 0; --k)
                    if (a[k] >= b[k + 1])
                        pos = k;
                    else
                        break;
                ans = min(ans, sumA - sumB - (a[j] - b[pos]));
            }

            cout << ans << ' ';
        }
        cout << '\n';
    }
}
/*
4
2
3 4
1 2
2
3 4
1 3
3
11 17 14
1 13 10
4
100 11 50 42
30 1 20 5

3
4
2 4 5 12
1 3 4 10
4
3 5 8 20
1 2 6 7
4
4 4 4 4
1 2 3 4

*/
/*

*/
/*

*/
/*
Сначала решим задачу с полным массивом.
 Отсортируем оба массива.
 Очевидно что можно уменьшить элементы первого массива так, чтобы он остался отсортированным.
 Рассмотрим элемент который не будет равным (Ну, если он есть). Его мы менять впринципе не будем.

Мы выбираем из первого и второго массива по элементу так,
  чтобы сумма в первом массиве минус сумма во втором массиве была минимальна и при этом ответ все еще существовал.
  Что требуется для того, чтобы ответ существовал?
  В отсортированном первом массиве без выбранного элемента каждый айтый элемент должен быть не меньше такого-же элемента из второго массива.


a1 a2 a3 a4 a5 a6
b1 b2 b3 b4 b5 b6

a1 __ a3 a4 a5 a6
b1 b2 b3 b4 __ b6

a1 a3 a4 a5 a6
b1 b2 b3 b4 b6

________________________

a1 a2 a3 a4 a5 a6
b1 b2 b3 b4 b5 b6

a1 a2 a3 a4 __ a6
b1 __ b3 b4 b5 b6

a1 a2 a3 a4 a6
b1 b3 b4 b5 b6


Для каждого элемента из первого массива как пара для удаления подходят сколько-то последних элементов второго массива.
 Из них нужно взять самый левый.

Решение за куб:
    Решаем задачу отдельно для каждого преффикса.
    Перебираем элемент из верхнего массива который мы удалим.
    Элемент из нижнего не левее нашего.
    Двигаемся нижним налево пока не найдем первый момент когда элемент на предыдущем индексе верхнего массива
        не станет меньше элемента на текущем индексе второго массива.



*/
/*

*/
