#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <iomanip>
#include <math.h>

#pragma target("ofast, o3, avx2")

using namespace std;

#define INF ((ll)1e18)
#define ll long long
#define db double
#define str string
#define vc vector
#define its(a) (a).begin(),(a).end()
#define itsr(a) (a).rbegin(),(a).rend()
#define sz(a) (a).size()


void solve() {
	ll n; cin >> n;
	vc<ll> a(n);
	vc<ll> b(n);
	for (auto& i : a) cin >> i;
	for (auto& i : b) cin >> i;
	bool f = 1;
	for (int i = 0; i < n - 1; ++i) {
		f &= (a[i] < b[i + 1]);
	}
	if (f) {
		ll cur = 0;
		ll mx = 0;
		for (int i = 0; i < n; ++i) {
			cur += a[i] - b[i];
			mx = max(mx, a[i] - b[i]);
			cout << cur - mx << " ";
		}
		cout << '\n';
		return;
	}

	for (int i = 1; i <= n; ++i) {
		vc<ll> ca, cb;
		for (int j = 0; j < i; ++j) ca.push_back(a[j]), cb.push_back(b[j]);
		sort(its(ca));
		sort(its(cb));

		multiset<ll> ms(its(ca));
		ll ans = 0;
		ll mx = -INF;
		for (int j = i - 1; j >= 0; --j) {
			auto it = ms.lower_bound(cb[j]);
			ll pr = *it;
			ms.erase(it);
			mx = max(mx, pr - cb[j]);
			ans += pr - cb[j];
		}
		ans -= mx;
		cout << ans << ' ';
	}
	cout << '\n';

}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll _t = 1;
	cin >> _t;
	while (_t--) solve();
}
