#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define int ll
typedef long long ll;
#define all(x) x.begin(), x.end()
#define vec vector

void solve() {
    int n; cin >> n;
    vec<int> a(n), b(n);
    for (auto& it : a)
        cin >> it;
    for (auto& it : b)
        cin >> it;
    vec<int> v(n, 2e18);
    for (n = 1; n <= v.size(); n++) {
        sort(a.begin(), a.begin() + n);
        sort(b.begin(), b.begin() + n);
        for (int e = 0; e <= n; e++) {
            int pos = n - 1;
            int ans = 0;
            for (int i = n - 1; i >= 0; i--) {
                if (i == e)
                    continue;
                pos = min(pos, ll(upper_bound(all(b), a[i]) - b.begin() - 1));
                if (pos == -1) {
                    ans = 2e18;
                    continue;
                }
                ans += a[i] - b[pos];
                pos--;
            }
            if (v[n - 1] > ans)
                v[n - 1] = ans;
        }
    }
    for (auto& it : v)
        cout << it << " ";
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

//    auto start = std::chrono::steady_clock::now();

    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }

//    auto end = std::chrono::steady_clock::now();
//    std::chrono::duration<double> elapsed_seconds = end - start;
//    cout << endl << elapsed_seconds << endl;
}