#include <bits/stdc++.h>

#define int int64_t
#define endl '\n'
#define pb push_back

using namespace std;

const int INF = 2e18;

void solve () {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector <int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int k = 1; k <= n; ++k) {
        vector <int> A, B;
        for (int i = 0; i < k; ++i) {
            A.push_back(a[i]);
            B.push_back(b[i]);
        }
        sort(A.begin(), A.end());
        sort(B.begin(), B.end());
        int s1 = 0, s2 = 0;
        for (auto to : A) {
            s1 += to;
        }
        for (auto to : B) {
            s2 += to;
        }
        int ans = INF;
        for (int i = 0; i < k; ++i) {
            for (int j = 0; j <= i; ++j) {
                vector <int> newA, newB;
                for (int id = 0; id < k; ++id) {
                    if (id != i) {
                        newA.pb(A[id]);
                    }
                    if (id != j) {
                        newB.pb(B[id]);
                    }
                }
                bool ok = 1;
                int s = 0;
                for (int id = 0; id < k - 1; ++id) {
                    if (newA[id] < newB[id]) {
                        ok = 0;
                        break;
                    }
                    s += newA[id] - newB[id];
                }
                if (ok) {
                    ans = min(ans, s1 - s2 - A[i] + B[j]);
                }
            }
        }
        cout << ans << ' ';
    }
    cout << endl;
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
}
