#include <bits/stdc++.h>

#define int int64_t
#define endl '\n'
#define pb push_back

using namespace std;

const int INF = 2e18;

void solve () {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector <int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    bool F = 1;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] >= b[i + 1]) {
            F = 0;
            break;
        }
    }
    if (F) {
        vector <int> ok(n);
        auto OK = [&] (int l, int r) -> bool {
            if (l > r) {
                return 1;
            }
            int sum = ok[r];
            if (l) {
                sum -= ok[l - 1];
            }
            return (sum == r - l + 1);
        };
        function <void (int, int)> upd = [&] (int i, int k) {
            if (i + 1 > k) {
                ok[i] = 1;
            } else {
                ok[i] = (a[i] >= b[i + 1]);
            }
            if (i) {
                ok[i] += ok[i - 1];
            }
        };
        int total = 0, mx = 0, s1 = 0, s2 = 0;
        vector <int> ans(n, INF);
        for (int i = 0; i < n; ++i) {
            total += a[i] - b[i];
            s1 += a[i]; s2 += b[i];
            mx = max(mx, a[i] - b[i]);
            ans[i] = min(ans[i], total - mx);
            upd(i, i);
            int l = 0, r = i, res = -1;
            while (l <= r) {
                int mid = (l + r) / 2;
                if (OK(mid, i - 1)) {
                    res = mid;
                    r = mid - 1;
                } else {
                    l = mid + 1;
                }
            }
            int j = res;
            if (j != -1 && OK(j, i - 1)) {
                ans[i] = min(ans[i], s1 - s2 - a[i] + b[j]);
            }
            upd(i, n - 1);
            cout << ans[i] << ' ';
        }
        cout << endl;
        return;
    }
    for (int k = 1; k <= n; ++k) {
        vector <int> A, B;
        for (int i = 0; i < k; ++i) {
            A.push_back(a[i]);
            B.push_back(b[i]);
        }
        sort(A.begin(), A.end());
        sort(B.begin(), B.end());
        int s1 = 0, s2 = 0;
        for (auto to : A) {
            s1 += to;
        }
        for (auto to : B) {
            s2 += to;
        }
        int ok[k];
        for (int i = 0; i < k; ++i) {
            if (i + 1 < k) {
                if (A[i] >= B[i + 1]) {
                    ok[i] = 1;
                } else {
                    ok[i] = 0;
                }
            } else {
                ok[i] = 1;
            }
            if (i) {
                ok[i] += ok[i - 1];
            }
        }
        auto OK = [&] (int l, int r) -> bool {
            if (l > r) {
                return 1;
            }
            int sum = ok[r];
            if (l) {
                sum -= ok[l - 1];
            }
            return (sum == r - l + 1);
        };
        int total = 0, mx = 0;
        for (int i = 0; i < k; ++i) {
            total += A[i] - B[i];
            mx = max(mx, A[i] - B[i]);
        }
        int ans = total - mx;
        for (int i = 0; i < k; ++i) {
            int l = 0, r = i, res = -1;
            while (l <= r) {
                int mid = (l + r) / 2;
                if (OK(mid, i - 1)) {
                    res = mid;
                    r = mid - 1;
                } else {
                    l = mid + 1;
                }
            }
            int j = res;
            if (j != -1 && OK(j, i - 1)) {
                ans = min(ans, s1 - s2 - A[i] + B[j]);
            }
        }
        cout << ans << ' ';
    }
    cout << endl;
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
}
