#include <bits/stdc++.h>

#define int int64_t
#define endl '\n'
#define pb push_back

using namespace std;

const int INF = 2e18, N = 5e5 + 50;

int t[4 * N], ps[4 * N];

void push (int v, int vl, int vr) {
    if (ps[v] != 0 && vl < vr) {
        ps[v * 2] += ps[v];
        ps[v * 2 + 1] += ps[v];
        t[v * 2] += ps[v];
        t[v * 2 + 1] += ps[v];
        ps[v] = 0;
    }
}

void upd (int v, int vl, int vr, int l, int r, int x) {
    push(v, vl, vr);
    if (vl > vr || vl > r || l > vr) {
        return;
    }
    if (vl >= l && vr <= r) {
        t[v] += x;
        ps[v] += x;
        return;
    }
    int mid = (vl + vr) / 2;
    upd(v * 2, vl, mid, l, r, x);
    upd(v * 2 + 1, mid + 1, vr, l, r, x);
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}

int get (int v, int vl, int vr, int l, int r) {
    push(v, vl, vr);
    if (vl > vr || vl > r || l > vr) {
        return INF;
    }
    if (vl >= l && vr <= r) {
        return t[v];
    }
    int mid = (vl + vr) / 2;
    return min(get(v * 2, vl, mid, l, r), get(v * 2 + 1, mid + 1, vr, l, r));
}

void solve () {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector <int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    vector <int> all;
    for (int i : a) {
        all.pb(i);
    }
    for (int i : b) {
        all.pb(i);
    }
    sort(all.begin(), all.end());
    all.erase(unique(all.begin(), all.end()), all.end());
    auto f = [&] (int x) {
        return lower_bound(all.begin(), all.end(), x) - all.begin();
    };
    for (int &i : a) {
        i = f(i);
    }
    for (int &i : b) {
        i = f(i);
    }
//    for (int i : a) {
//        cerr << i << ' ';
//    }
//    cerr << endl;
//    for (int i : b) {
//        cerr << i << ' ';
//    }
//    cerr << endl;
    fill(t, t + 4 * all.size() + 10, 0);
    fill(ps, ps + 4 * all.size() + 10, 0);
    int s1 = 0, s2 = 0, best = INF;
    for (int i = 0; i < n; ++i) {
        upd(1, 0, all.size() - 1, 0, a[i], 1);
        upd(1, 0, all.size() - 1, 0, b[i], -1);
        s1 += all[a[i]];
        s2 += all[b[i]];
        {
            // for A
            int l = 0, r = a[i], res = -1;
            while (l <= r) {
                int mid = (l + r) / 2;
                upd(1, 0, all.size() - 1, 0, a[i], -1);
                upd(1, 0, all.size() - 1, 0, mid, 1);
                if (t[1] >= 0) {
                    res = mid;
                    r = mid - 1;
                } else {
                    l = mid + 1;
                }
                upd(1, 0, all.size() - 1, 0, a[i], 1);
                upd(1, 0, all.size() - 1, 0, mid, -1);
            }
            assert(res != -1);
            best = min(best, -all[a[i]] + all[res]);
        }
        {
            // for B
            int cl = 0, cr = all.size() - 1, Res = -1;
            while (cl <= cr) {
                int Mid = (cl + cr) / 2;
                b[i] = Mid;
                int l = b[i], r = all.size() - 1, res = -1;
                while (l <= r) {
                    int mid = (l + r) / 2;
                    upd(1, 0, all.size() - 1, 0, mid, -1);
                    upd(1, 0, all.size() - 1, 0, b[i], 1);
                    if (t[1] >= 0) {
                        res = mid;
                        l = mid + 1;
                    } else {
                        r = mid - 1;
                    }
                    upd(1, 0, all.size() - 1, 0, mid, 1);
                    upd(1, 0, all.size() - 1, 0, b[i], -1);
                }
                best = min(best, all[b[i]] - all[res]);
                if (res == b[i]) {
                    cl = Mid + 1;
                } else {
                    cr = Mid - 1;
                }
            }
        }
        cout << s1 - s2 + best << ' ';
    }
    cout << endl;
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
}

