#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <cmath>
#include <iomanip>
#include <random>
using namespace std;
using ll = long long;
const ll INF = 1e18;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t; cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n; cin >> n;
		vector<ll> a(n), b(n);
		bool flag = true;
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
			if (i > 0 && a[i] < a[i - 1])
				flag = false;
		}
		for (int i = 0; i < n; ++i) {
			cin >> b[i];
			if (i > 0 && b[i] < b[i - 1])
				flag = false;
		}
		if (flag) {
			ll cur_sum = 0, max_a = 0, max_razn = 0;
			ll ans2 = 0;
			ll minb = INF;
			for (int i = 0; i < n; ++i) {
				max_a = max(max_a, a[i]);
				if (i > 0 && a[i - 1] < b[i])
					minb = INF;
				minb = min(minb, b[i]);
				max_razn = max(max_razn, max_a - b[i]);
				cur_sum += a[i] - b[i];
				ll ans1 = cur_sum - max_razn;
				ans2 += a[i] - b[i];
				ans2 = min(ans2, cur_sum - (a[i] - minb));
				cout << min(ans1, ans2) << " ";
			}
			cout << "\n";
		}
		else if (n <= 3000) {
			vector<ll> sort_a, sort_b;
			for (int j = 0; j < n; ++j) {
				sort_a.push_back(a[j]);
				sort_b.push_back(b[j]);
				sort(sort_a.begin(), sort_a.end());
				sort(sort_b.begin(), sort_b.end());
				ll cur_sum = 0, max_a = 0, max_razn = 0;
				ll ans2 = 0, ans1;
				ll minb = INF;
				for (int i = 0; i <= j; ++i) {
					max_a = max(max_a, sort_a[i]);
					if (i > 0 && sort_a[i - 1] < sort_b[i])
						minb = INF;
					minb = min(minb, sort_b[i]);
					max_razn = max(max_razn, max_a - sort_b[i]);
					cur_sum += sort_a[i] - sort_b[i];
					ans1 = cur_sum - max_razn;
					ans2 += sort_a[i] - sort_b[i];
					ans2 = min(ans2, cur_sum - (sort_a[i] - minb));
				}
				cout << min(ans1, ans2) << " ";
			}
			cout << "\n";
		}
		else {
			ll cur_sum = 0, max_a = 0, max_razn = 0;
			for (int i = 0; i < n; ++i) {
				max_a = max(max_a, a[i]);
				max_razn = max(max_razn, max_a - b[i]);
				cur_sum += a[i] - b[i];
				cout << cur_sum - max_razn << " ";
			}
			cout << "\n";
		}
	}

	return 0;
}