//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
using ll = long long;
using ld = long double;

const ll INF = 2e18;
const int MOD = 1e9 + 7, N = 2e5 + 1, MAXN = 5e5 + 1, K = 26, INFi = 2e9;
const ld EPS = 1e-12, PI = acos(-1);

random_device rd;
mt19937_64 rnd(rd());

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int &e : a) {
        cin >> e;
    }
    for (int &e : b) {
        cin >> e;
    }
    bool fl = true;
    for (int i = 0; i < n - 1; i++) {
        if (a[i] > a[i + 1] || b[i] > b[i + 1]) {
            fl = false;
            break;
        }
    }
    cout << "0 ";
    if (fl) {
        int mx = a[0] - b[0], sum = a[0] - b[0];
        for (int i = 1; i < n; i++) {
            mx = max(mx, a[i] - b[i]);
            sum += a[i] - b[i];
            cout << sum - mx << ' ';
        }
    } else {
        vector<int> va = {a[0]}, vb = {b[0]};
        int sum = a[0] - b[0];
        for (int i = 1; i < n; i++) {
            va.push_back(a[i]), vb.push_back(b[i]);
            stack<int> st;
            sort(va.begin(), va.end());
            sort(vb.begin(), vb.end());
            int yk1 = 0, yk2 = 0, ans = 0;
            while (yk1 <= i && yk2 <= i) {
                if (va[yk1] < vb[yk2]) {
                    if (!st.empty() && st.top() < 0) {
                        ans = max(ans, va[yk1] + st.top());
                        st.pop();
                    } else {
                        st.push(va[yk1]);
                    }
                    yk1++;
                } else if (va[yk1] == vb[yk2]) {
                    yk1++, yk2++;
                } else {
                    if (!st.empty() && st.top() > 0) {
                        ans = max(ans, st.top() - vb[yk2]);
                        st.pop();
                    } else {
                        st.push(-vb[yk2]);
                    }
                    yk2++;
                }
            }
            while (!st.empty() && yk1 <= i) {
                ans = max(ans, va[yk1] + st.top());
                st.pop();
                yk1++;
            }
            while (!st.empty() && yk2 <= i) {
                ans = max(ans, st.top() - vb[yk2]);
                st.pop();
                yk2++;
            }
            sum += a[i] - b[i];
            cout << sum - ans << ' ';
        }
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
