#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <algorithm>
#include <deque>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
#define int ll

using namespace std;

mt19937 rnd(0);
int N = 0;

void fast(int n) {
	vector<int> a(n), b(n);
	vector<int> pa{ 0 }, pb{ 0 };
	vector<int> pma(n);
	for (int i = 0; i < n;i++) {
		cin >> a[i];
		pa.push_back(pa.back() + a[i]);
		pma[i] = max(i ? pma[i - 1] : 0, a[i]);
	}
	for (int i = 0; i < n;i++) {
		cin >> b[i];
		pb.push_back(pb.back() + b[i]);
	}
	vector<int> mi_l(n);
	for (int i = 0; i < n; i++) {
		if (i && a[i - 1] >= b[i]) {
			mi_l[i] = min(mi_l[i - 1], b[i]);
		}
		else {
			mi_l[i] = b[i];
		}
	}
	int maa = 0;
	for (int l = 0; l < n; l++) {
		maa = max(maa, pma[l] - b[l]);
		maa = max(maa, a[l] - mi_l[l]);
		cout << pa[l + 1] - pb[l + 1] - maa << ' ';
	}
	cout << '\n';
}

void slow(int n) {
	vector<int> a(n), b(n);
	for (int i = 0; i < n;i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n;i++) {
		cin >> b[i];
	}
	
	for (int l = 0; l < n; l++) {
		sort(a.begin(), a.begin() + l + 1);
		sort(b.begin(), b.begin() + l + 1);
		vector<int> pa{ 0 }, pb{ 0 };
		vector<int> pma(n);
		for (int i = 0; i < n;i++) {
			pa.push_back(pa.back() + a[i]);
			pma[i] = max(i ? pma[i - 1] : 0, a[i]);
		}
		for (int i = 0; i < n;i++) {
			pb.push_back(pb.back() + b[i]);
		}
		vector<int> mi_l(n);
		for (int i = 0; i < n; i++) {
			if (i && a[i - 1] >= b[i]) {
				mi_l[i] = min(mi_l[i - 1], b[i]);
			}
			else {
				mi_l[i] = b[i];
			}
		}
		int maa = 0;
		for (int l1 = 0; l1 <= l; l1++) {
			maa = max(maa, pma[l1] - b[l1]);
			maa = max(maa, a[l1] - mi_l[l1]);
		}
		cout << pa[l + 1] - pb[l + 1] - maa << ' ';
	}
	cout << '\n';
}

void solve() {
	int n;
	cin >> n;
	N += n;
	if (N > 3000) {
		fast(n);
	}
	else {
		slow(n);
	}
}


signed main() {
	cout.setf(ios_base::fixed);
	cout << fixed << std::setprecision(12);
	ios_base::sync_with_stdio(false);
	cin.tie(0);

#ifdef LOCAL
	auto f = freopen("input.txt", "r", stdin);
	auto f1 = freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}