#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <random>
#include <algorithm>
#include <deque>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using ll = long long;
#define all(a) a.begin(), a.end()
#define int ll

using namespace std;

mt19937 rnd(0);


void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	vector<int> pa{ 0 }, pb{ 0 };
	for (int i = 0; i < n;i++) {
		cin >> a[i];
		pa.push_back(pa.back() + a[i]);
	}
	for (int i = 0; i < n;i++) {
		cin >> b[i];
		pb.push_back(pb.back() + b[i]);
	}
	int maa = 0;
	vector<int> mi_l(n);
	for (int l = 0; l < n; l++) {
		int al = a[l];
		a.erase(a.begin() + l);
		a.insert(lower_bound(a.begin(), a.begin() + l, al), al);
		int bl = b[l];
		b.erase(b.begin() + l);
		b.insert(lower_bound(b.begin(), b.begin() + l, bl), bl);

		for (int i = 0; i <= l; i++) {
			if (i && a[i - 1] >= b[i]) {
				mi_l[i] = min(mi_l[i - 1], b[i]);
			}
			else {
				mi_l[i] = b[i];
			}
		}

		for (int l1 = 0; l1 <= l; l1++) {
			maa = max(maa, a[l1] - mi_l[l1]);
		}
		cout << pa[l + 1] - pb[l + 1] - maa << ' ';
	}
	cout << '\n';
}


signed main() {
	cout.setf(ios_base::fixed);
	cout << fixed << std::setprecision(12);
	ios_base::sync_with_stdio(false);
	cin.tie(0);

#ifdef LOCAL
	auto f = freopen("input.txt", "r", stdin);
	auto f1 = freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}