// JafoNoksy's code
#include <bits/stdc++.h>

#pragma GCC optimize "O2"
using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define F first
#define S second
#define int ll
#define ve vector
mt19937 rnd(4732);

template<class A>
istream &operator>>(istream &in, ve<A> &x) {
    for (auto &c: x)
        in >> c;
    return in;
}

template<class A>
ostream &operator<<(ostream &out, ve<A> &x) {
    for (auto &c: x)
        out << c << ' ';
    return out << '\n';
}

struct segtree {
    ve<int> t;
    int n = 0;

    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    int get(int v, int l, int r, int _l, int _r) {
        if (l >= _r || _l >= r)
            return 0;
        if (_l <= l && r <= _r)
            return t[v];
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, _l, _r) + get(2 * v + 2, m, r, _l, _r);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r);
    }

    segtree(ve<int> a = {1}) {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n, a);
    }
};

struct mst {
    ve<ve<int>> t;

    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = {a[l]};
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v].resize(t[2 * v + 1].size() + t[2 * v + 2].size());
        merge(t[2 * v + 1].begin(), t[2 * v + 1].end(), t[2 * v + 2].begin(), t[2 * v + 2].end(), t[v].begin());
    }

    void get(int v, int l, int r, int i, int s) {
        int m = (l + r) / 2;
    }
};


void sol() {
    int n;
    cin >> n;
    ve<int> a(n), b(n);
    cin >> a >> b;
    bool is_group = 1;
    for (int i = 1; i < n; ++i) {
        if (a[i] < a[i - 1] || b[i] < b[i - 1])
            is_group = 0;
    }
    if (is_group) {
        b.pb(0);
        a.pb(0);
        ve<int> c(n);
        for (int i = 0; i < n; ++i)
            c[i] = a[i] - b[i + 1];
        int last_b = b[0];
        int sum = 0;
        int best = 0;
        for (int k = 0; k < n; ++k) {
            sum += a[k] - b[k];
            best = max(best, a[k] - b[k]);
            cout << sum - best << ' ';
            if (a[k] >= b[k + 1]) {
                if (last_b == -1)
                    last_b = b[k+1];
                else
                    best = max(best, a[k+1] - last_b);
            } else
                last_b = -1;
        }
        cout << '\n';
        return;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--)
        sol();
}