#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define int int64_t

typedef int64_t ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int M = 1e9 + 7;
const int INF = 1e17 + 9;
const int inf = 1234567891;

mt19937 rnd(time(0));

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (auto& x : a) cin >> x;
    for (auto& x : b) cin >> x;
    for (int k = 1; k <= n; ++k) {
        int best = INF;
        sort(a.begin(), a.begin() + k);
        sort(b.begin(), b.begin() + k);
        for (int ban = 0; ban < k; ++ban) {
            vector<vector<int>> dp(k + 1, vector<int>(2, INF));
            dp[0][0] = dp[0][1] = 0;
            for (int i = 0; i < k; ++i) {
                if (i == ban) {
                    dp[i + 1][1] = dp[i][1];
                    dp[i + 1][0] = dp[i][0];
                    continue;
                }
                if (i > ban) {
                    dp[i + 1][1] = min(dp[i][1] + a[i] - b[i], dp[i][0] + a[i] - b[i]);
                    dp[i + 1][0] = dp[i][0] + a[i] - b[i - 1];
                } else {
                    if (a[i] - b[i + 1] >= 0) {
                        dp[i + 1][1] = min(dp[i][1], dp[i][0]) + a[i] - b[i + 1];
                    }
                    dp[i + 1][0] = dp[i][0] + a[i] - b[i];
                }
            }
            best = min({best, dp[k][0], dp[k][1]});
        }
        cout << best << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef kiquxd
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
     cin >> t;
    while (t--) {
        solve();
    }
}
