#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll inf = 1e18;

int main() {
//    ios::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
    ll t; cin >> t;
    while(t--) {
        ll n; cin >> n;
        vector<ll> a(n);
        vector<ll> b(n);
        for(int i = 0; i < n; i++) cin >> a[i];
        for(int i = 0; i < n; i++) cin >> b[i];
        for(int i = 0; i < n; i++) {
            vector<ll> v1;
            vector<ll> v2;
            for(int j = 0; j <= i; j++) {
                v1.push_back(a[j]);
                v2.push_back(b[j]);
            }
            sort(v1.begin(), v1.end());
            sort(v2.begin(), v2.end());
            ll ans = 0, res = inf, mx = -inf;
            for(int k = i; k >= 0; k--) {
                ll ok = 1, ans1 = ans;
                for(int j = k - 1; j >= 0; j--) {
                    if (v1[j] < v2[j + 1] || ok == 0) {
                        ans1 += v1[j] - v2[j];
                        ok = 0;
                        continue;
                    }
                    ans1 += v1[j] - v2[j + 1];
                }
                res = min(res, ans1);
                ans += v1[k] - v2[k];
                mx = max(mx, v1[k] - v2[k]);
            }
            res = min(res, ans - mx);
            cout << res << " ";
        }
        cout << "\n";
    }
    return 0;
}
