#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const ll INF = ll(1e18);

void solve() {
  int n;
  cin >> n;
  vector<int> a(n), b(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  for (int i = 0; i < n; ++i) {
    cin >> b[i];
  }
  vector<int> aa, bb;
  ll sumA = 0, sumB = 0;
  for (int i = 0; i < n; ++i) {
    sumA += a[i];
    sumB += b[i];
    aa.push_back(a[i]);
    bb.push_back(b[i]);
    sort(aa.begin(), aa.end());
    sort(bb.begin(), bb.end());
    ll ans = INF;

    vector<int> bad;
    for (int j = 0; j < i; ++j) {
      if (aa[j] < bb[j + 1]) {
        bad.emplace_back(j);
      }
    }

    auto Check = [&](int ia, int ib) {
      int id = lower_bound(bad.begin(), bad.end(), ib) - bad.begin();
      return id == bad.size() || bad[id] >= ia;
    };

    for (int j1 = 0; j1 <= i; ++j1) {
      int id = lower_bound(bad.begin(), bad.end(), j1) - bad.begin();
      int i1 = (id == bad.size() ? i : bad[id]);
      ans = min(ans, (sumA - sumB) - (aa[i1] - bb[j1]));
    }
    /*for (int i1 = 0; i1 <= i; ++i1) {
      int j1 = i1;
      for (int lg = 20; lg >= 0; --lg) {
        if (j1 - (1 << lg) >= 0 && Check(i1, j1 - (1 << lg))) {
          j1 -= 1 << lg;
        }
      }
      ans = min(ans, (sumA - sumB) - (aa[i1] - bb[j1]));
    }*/
    cout << ans << ' ';
  }
  cout << '\n';
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
