#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)x.size()

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, a) for(auto& x: a)

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    int t;
    cin >> t;

    while(t--) {
        int n;
        cin >> n;

        vector<pii> a(n);
        fr (i, 0, n - 1) {
            cin >> a[i].fi;
        }
        fr (i, 0, n - 1) {
            cin >> a[i].se;
        }

        set<pii> ls1;
        set<pii> ls2;
        fr (i, 0, n - 1) {
            ls1.insert({a[i].fi, i});
            ls2.insert({a[i].se, i});

            set<int> dist;
            vector<bool> used(n);
            int sum = 0;
            fe (x, ls1) {
                int mn = 1e9;
                int mni = -1;
                fe (y, ls2) {
                    if(!used[y.se]) {
                        if(x.fi - y.fi < mn && x.fi - y.fi >= 0) {
                            mn = x.fi - y.fi;
                            mni = y.se;
                        }
                    }
                }
                sum += mn;
                used[mni] = 1;
                dist.insert(mn);
            }

            cout << sum - *--dist.end() << " \n"[i == n - 1];
        }
    }    
    
    return 0;
}