#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

using namespace __gnu_pbds;

template < typename T >
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
bool umx(T& a, T b) {
    return (a < b ? a = b, 1 : 0);
}

template<typename T>
bool umn(T& a, T b) {
    return (a > b ? a = b, 1 : 0);
}

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int N = 3e5 + 222;
const int mod = 1e9 + 7;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int T;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        vector<int> a(n + 1), b(n + 1);
        bool gr = 1;
        bool gr2 = 1;
        for (int i = 1; i <= n; ++i) cin >> a[i];
        for (int i = 1; i <= n; ++i) cin >> b[i];
        for (int i = 1; i < n; ++i) if (a[i] >= b[i + 1]) gr = 0;
        for (int i = 1; i < n; ++i) if (a[i] > a[i + 1] || b[i] > b[i + 1]) gr2 = 0;
        if (gr2) {
            ll sa = 0, sb = 0;
            int mx = 0;
            int w = 0;
            for (int i = 1; i <= n; ++i) {
                sa += a[i], sb += b[i];
                w = (b[i] > a[i - 1] ? b[i] : w);
                mx = max(mx, a[i] - w);
                cout << sa - sb - mx << ' ';
            }
            cout << '\n';
            continue;
        }
        if (gr) {
            ll sa = 0, sb = 0;
            multiset<ll> st;
            for (int i = 1; i <= n; ++i) {
                sa += a[i], sb += b[i];
                st.insert(a[i] - b[i]);
                cout << sa - sb - (*--st.end()) << ' ';
            }
            cout << '\n';
            continue;
        }
        ll sum = 0;
        ll sa = 0, sb = 0;
        for (int i = 1; i <= n; ++i) {
            sa += a[i], sb += b[i];
            multiset<int> fb;
            deque<int> fa;
            for (int j = 1; j <= i; ++j) {
                fb.insert(b[j]);
                fa.push_back(a[j]);
            }
            sort(begin(fa), end(fa));
            ll mx = 0;
            while ((int)fa.size()) {
                ll p = fa.front();
                auto it = fb.upper_bound(p);
                if (it == fb.begin()) assert(0);
                --it;
                mx = max(mx, p - *it);
                fa.pop_front();
                fb.erase(it);
            }
            cout << sa - sb - mx << ' ';
        }
        cout << '\n';
    }


    return 0;
}
