//#include <bits/stdc++.h>
//#define int long long
//using namespace std;
//auto sd = chrono::high_resolution_clock::now().time_since_epoch().count();
//mt19937 rnd(sd);
//
//


#include <bits/stdc++.h>
#define int long long
using namespace std;
auto sd = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(sd);

void SOLVE(int n, vector<int> a, vector<int> b) {
    int sum = 0, maxdiff = 0;
    for (int i = 0; i < n; i++) {
//        maxdiff = max(maxdiff, a[i] - b[i]);
        cout << sum + min(maxdiff, a[i] - b[i]) << ' ';
        sum += min(a[i] - b[i], maxdiff);
        maxdiff = max(maxdiff, a[i] - b[i]);
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    if (n > 3000) {
        SOLVE(n, a, b);
        return;
    }
    vector<int> dp(n, 1e15);
    dp[0] = 0;
    vector<int> prefa(n), prefb(n), prefd(n);
    vector<int> good(n, 0);
    prefa[0] = a[0];
    prefb[0] = b[0];
    vector<int> ca = {a[0]}, cb = {b[0]};
    for (int i = 1; i < n; i++) {
        prefa[i] = prefa[i - 1] + a[i];
        prefb[i] = prefb[i - 1] + b[i];
        int prev = a[i], j = 0;
        while (j < ca.size() && ca[j] < a[i]) j++;
        for (int k = j; k < ca.size(); k++) {
            swap(prev, ca[k]);
        }
        ca.push_back(prev);
        prev = b[i], j = 0;
        while (j < cb.size() && cb[j] < b[i]) j++;
        for (int k = j; k < cb.size(); k++) {
            swap(prev, cb[k]);
        }
        cb.push_back(prev);
        for (j = 0; j < i; j++) {
            good[j] = (ca[j] >= cb[j + 1]);
        }
        prefd[0] = good[0];
        for (j = 1; j < i; j++) {
            prefd[j] = prefd[j - 1] + good[j];
        }
        for (j = 0; j <= i; j++) {
            int l = j - 1, r = i;
            while (r - l > 1) {
                int m = (r + l) / 2;
                if (j != 0) {
                    if (prefd[m] - prefd[j - 1] == m - j + 1) {
                        l = m;
                    } else {
                        r = m;
                    }
                } else {
                    if (prefd[m] == m + 1) {
                        l = m;
                    } else {
                        r = m;
                    }
                }
            }
            dp[i] = min(dp[i], prefa[i] - prefb[i] + cb[j] - ca[l + 1]);
        }
    }
    for (auto e : dp) cout << e << ' ';
    cout << '\n';
}


//void solve() {
//    int n;
//    cin >> n;
//    vector<int> a(n), b(n);
//    for (int i = 0; i < n; i++) cin >> a[i];
//    for (int i = 0; i < n; i++) cin >> b[i];
//    vector<int> ca, cb, prefa(n), prefb(n), dp(n, 1e15);
//    for (int i = 0; i < n; i++) {
//        if (i == 0) {
//            prefa[0] = a[0];
//            prefb[0] = b[0];
//        } else {
//            prefa[i] = prefa[i - 1] + a[i];
//            prefb[i] = prefb[i - 1] + b[i];
//        }
//        ca.push_back(a[i]);
//        cb.push_back(b[i]);
//        sort(ca.begin(), ca.end());
//        sort(cb.begin(), cb.end());
//        for (int j = 0; j <= i; j++) {
//            for (int k = 0; k <= j; k++) {
//                bool flag = true;
//                if (j > k) {
//                    for (int kk = k; kk < j; kk++) {
//                        if (ca[kk] < cb[kk + 1]) {
//                            flag = false;
//                            break;
//                        }
//                    }
//                }
//                if (flag) {
//                    int sum = 0;
//                    if (j <= k) {
//                        for (int kk = 0; kk < j; kk++) {
//                            sum += ca[kk] - cb[kk];
//                        }
//                        for (int kk = j + 1; kk <= k; kk++) {
//                            sum += ca[kk] - cb[kk - 1];
//                        }
//                        for (int kk = k + 1; kk <= i; kk++) {
//                            sum += ca[kk] - cb[kk];
//                        }
//                    } else {
//                        for (int kk = 0; kk < k; kk++) {
//                            sum += ca[kk] - cb[kk];
//                        }
//                        for (int kk = k; kk < j; kk++) {
//                            sum += ca[kk] - cb[kk + 1];
//                        }
//                        for (int kk = j + 1; kk <= i; kk++) {
//                            sum += ca[kk] - cb[kk];
//                        }
//                    }
//                    dp[i] = min(dp[i], sum);
//                }
//            }
//        }
//    }
//    for (auto e : dp) cout << e << ' ';
//    cout << '\n';
//
//}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
