#ifdef LOCAL
#define GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
struct Node{
    int ans, left, right, full;
};
Node merge(Node a, Node b) {
    Node ans;
    ans.ans = max(a.ans, b.ans);
    ans.ans = max(ans.ans, a.right + b.left);
    if (a.full) ans.left = a.left + b.left;
    else ans.left = a.left;
    if (b.full) ans.right = b.right + a.right;
    else ans.right = b.right;
    ans.full = a.full * b.full;
    return ans;
}
void solve() {
    int n;
    cin >> n;
    vector<int> d;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i], d.push_back(a[i]);
    vector<int> b(n);
    for (int i = 0; i < n; i++) cin >> b[i], d.push_back(b[i]);
    sort(d.begin(), d.end());
    d.resize(unique(d.begin(), d.end()) - d.begin());
    for (int i = 0; i < n; i++) a[i] = lower_bound(d.begin(), d.end(), a[i]) - d.begin();
    for (int i = 0; i < n; i++) b[i] = lower_bound(d.begin(), d.end(), b[i]) - d.begin();
    int G = (1 << (__lg(2 * d.size())));
    vector<Node> t(2 * G);
    vector<int> sz(2 * G, 1);
    for (int i = G; i < G + d.size() - 1; i++) sz[i] = d[i+1 - G] - d[i - G];
    for (int i = G - 1; i >= 1; i--) sz[i] = sz[i << 1] + sz[i << 1 | 1];
    auto change = [&] (auto self, int ql, int qr, int node, int l, int r) {
        if (t[node].full) return ;
        if (ql <= l && r <= qr) {
            t[node].ans = t[node].left = t[node].right = sz[node];
            t[node].full = 1;
            return ;
        }
        if (ql >= r || l >= qr) return ;
        int mid = l + r >> 1;
        self(self, ql, qr, node << 1, l, mid);
        self(self, ql, qr, node << 1 | 1, mid, r);
        t[node] = merge(t[node << 1], t[node << 1 | 1]);
    };
    ll sum = 0;
    int res = 0;
    for (int i = 0; i < n; i++) {
        sum += d[a[i]] - d[b[i]];
        if (a[i] != b[i]) change(change, b[i], a[i], 1, 0, G);
        cout << sum - t[1].ans << " ";
    }
    cout << "\n";
}
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int T;
    cin >> T;
    for (int i = 0; i < T; i++) {
        solve();
    }
}