#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma")
//#pragma GCC optimize("unroll-loops")

using namespace std;

using ll = long long;
using ld = long double;
const char endc = '\n';

using namespace std;

ll MX = INTMAX_MAX / 100;

inline void work() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (auto& e : a) cin >> e;
    for (auto& e : b) cin >> e;
    bool group = true;
    for (int i = 0; i < n-1; ++i) group &= (a[i] < b[i+1]);
    if (!group) {
        cout << 0 << ' ';
        for (int i = 1; i < n; ++i) {
            ll answer = INTMAX_MAX;
            for (int z = 0; z <= i; ++z) {
                vector<ll> whatsA, whatsB;
                whatsA.reserve(i);
                whatsA.reserve(i+1);
                for (int k = 0; k <= i; ++k) {
                    if (k == z) continue;
                    whatsA.push_back(a[k]);
                }
                for (int k = 0; k <= i; ++k) whatsB.push_back(b[k]);
                sort(whatsA.begin(), whatsA.end());
                sort(whatsB.begin(), whatsB.end());
                vector<ll> prefix(i);
                vector<ll> suffix(i);
                int toPref = n, toSuf = -1;
                for (int j = 0; j < i; ++j) {
                    if (whatsA[j] - whatsB[j] < 0) {
                        toPref = j;
                        break;
                    } else {
                        prefix[j] = (j > 0 ? prefix[j - 1] : 0) + whatsA[j] - whatsB[j];
                    }
                }
                for (int j = i-1; j >= 0; --j) {
                    if (whatsA[j] - whatsB[j+1] < 0) {
                        toSuf = j;
                        break
                    } else {
                        suffix[j] = (j < i - 1 ? suffix[j + 1] : 0) + whatsA[j] - whatsB[j + 1];
                    }
                }
                ll best = min(suffix.front(), prefix.back());
                for (int j = 0; j < i-1; ++j) {
                    if (j < toPref && j+1 > toSuf) {
                        best = min(best, prefix[j] + suffix[j + 1]);
                    }
                }
                answer = min(answer, best);
            }
            cout << answer << ' ';
        }
        cout << endc;
    } else {
        ll deltaSum = 0;
        ll deltaMX = INTMAX_MIN;
        for (int i = 0; i < n; ++i) {
            deltaSum += a[i] - b[i];
            deltaMX = max(deltaMX, ll(a[i] - b[i]));
            cout << deltaSum - deltaMX << ' ';
        }
        cout << endc;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    srand(int(time(nullptr)));
    cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t-- > 0) work();
}