// #include <bits/stdc++.h>
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
vector<multiset<ll>> our;
struct otres{
    ll l, r;
    ll ind;
    otres( ll a, ll i){
        ind = i;
        l = a;
        r = a;
    }

    bool operator <(const otres &b) const{
        if (l == b.l){
            return r < b.r;
        }
        return l < b.l;
    }
};

otres merge(otres a, otres b){
    otres ans(0, 0);
    ans.l = min(a.l, b.l);
    ans.r = max(a.r, b.r);
    ans.ind = a.ind;
    if (our[ans.ind].size() < our[b.ind].size()){
        swap(ans.ind, b.ind);
    }
    for (auto el : our[b.ind]){
        our[ans.ind].insert(el);
    }
    return ans;
}

bool check(otres a, otres b){
    if (a.r >= *our[b.ind].begin()){
        return true;
    }
    return false;
}

struct xui{
    ll sum = 0;
    ll mx = 0;
    multiset<otres> can;
    void add(ll a , ll b, ll i){
        sum += (a - b);
        our[i].insert(b);
        otres z(a, i);
        while (!can.empty()){
            auto it = can.lower_bound(z);
            if (it == can.begin()){
                break;
            }
            it--;
            if (!check(*it, z)){
                break;
            }
            otres g = *it;
            can.erase(it);
            z = merge(g, z);
        }
        while (!can.empty()){
            auto it = can.lower_bound(z);
            if (it == can.end()){
                break;
            }
            if (!check(z, *it)){
                break;
            }
            otres g = *it;
            can.erase(it);
            z = merge(g, z);
        }
        can.insert(z);
        mx = max(mx, z.r - *our[z.ind].begin());
    }
};
void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    vector<ll> b(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    for (int i = 0; i < n; i++){
        cin >> b[i];
    }
    xui mach;
    our.clear();
    our.resize(n);
    for (int i  = 0; i < n; i++){
        mach.add(a[i], b[i], i);
        cout << mach.sum - mach.mx << " ";
//        cout << endl;
    }
    cout << "\n";



}

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
