#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <stack>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <string>
#include <random>

using namespace std;
typedef long long ll;
const ll inf = 1e18;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while (t--)
    {
        ll n;
        cin >> n;
        vector <ll> a(n), b(n);
        bool good = 1;
        for (ll i = 0; i < n; i++) cin >> a[i];
        for (ll i = 0; i < n; i++) cin >> b[i];
        for (ll i = 0; i < n - 1; i++)
        {
            if (!(a[i] < b[i + 1])) good = 0; 
        }
        if (good)
        {
            ll inc = 0;
            ll ans = 0;
            ll maxdif = 0;
            for (ll i = 0; i < n; i++)
            {
                ans += (a[i] - b[i]);
                maxdif = max(a[i] - b[i], maxdif);
                if (i == 0) cout << 0 << " ";
                else cout << ans - maxdif << " ";
            }
            cout << '\n';
            continue;
        }
        cout << 0 << " ";
        for (ll i = 1; i < n; i++)
        {
            vector <ll> at(i + 1), bt(i + 1);
            for (ll j = 0; j <= i; j++)
            {
                at[j] = a[j];
                bt[j] = b[j];
            }
            sort(at.begin(), at.end());
            sort(bt.begin(), bt.end());
            
            ll ANS = inf;
            for (ll j = 0; j <= i; j++) // ignore a
            {
                //for (ll k = 0; k <= i; k++) // ignore b
                //{
                ll minsdv = -1;
                ll inc0 = 0;
                for (ll k = 0; k <= i; k++)
                {
                    if (k == j) inc0--;
                    if (at[k] < bt[k + inc0 + 1]) minsdv = k + 1;
                }
                    ll ans = 0;
                    ll inc = 0;
                    bool flag = 0;
                    for (ll h = 0; h <= i; h++)
                    {
                        if (h == j) inc--;
                        if (h != j)
                        {
                            if (at[h] < bt[h + inc]) ans = inf;
                            else if (!flag && at[h] >= bt[h + inc + 1] && h >= minsdv)
                            {
                                flag = 1;
                                inc++;
                            }
                            ans += abs(at[h] - bt[h + inc]);
                        }
                    }
                    //if (j == 2 && k == 0) cout << ans << endl;
                    //cout << j << " " << k << " " << ans << endl;
                    ANS = min(ANS, ans);
                //}
            }
            cout << ANS << " ";
        }
        cout << '\n';
    }
}

