#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <stack>
using namespace std;
long long n, t;
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> t;
	for (long long h = 0; h < t; h++) {
		long long x3 = 0;
		cin >> n;
		vector<long long> a(n), b(n);
		for (long long i = 0; i < n; i++) {
			cin >> a[i];
			if (i > 0 && a[i - 1] <= a[i])
				x3++;
		}
		for (long long i = 0; i < n; i++) {
			cin >> b[i];
			if (i > 0 && b[i - 1] <= b[i])
				x3++;
		}
		if (x3 == 2 * n - 2) {
			long long sum = 0, mm = 0, last = b[0];
			for (long long i = 0; i < n; i++) {
				sum += a[i] - b[i];
				mm = max(mm, a[i] - last);
				cout << sum - mm << ' ';
				if (i < n - 1 && a[i] < b[i + 1])
					last = b[i + 1];
			}
			cout << "\n";
			continue;
		}
		multiset<pair<long long, long long>> st;
		for (long long i = 0; i < n; i++) {
			st.insert({ a[i], 1 });
			st.insert({ b[i], 0 });
			stack<long long> sta;
			long long sum = 0, mm = 0;
			for (auto j = st.begin(); j != st.end(); j++) {
				if ((*j).second == 0)
					sta.push((*j).first);
				else {
					sum += (*j).first - sta.top();
					mm = max(mm, (*j).first - sta.top());
					sta.pop();
				}
			}
			cout << sum - mm << ' ';
		}
		cout << "\n";
	}
	return 0;
}
