#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e9;
const ll N = 2005;
const ll MOD = 1e9 + 7;
const ll M = 10005; // !!!!!!!!!!!!!!!!!!!!!!!1

mt19937 gen(time(0));

void solve() {
    ll n; cin >> n;
    vector<ll> a(n + 1), b(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) cin >> b[i];

    vector<ll> dp(n + 1);
    for (int i = 1; i <= n; i++) {
        if (a[i - 1] >= b[i]) {
            dp[i] = dp[i - 1];
        } else {
            dp[i] = b[i];
        }
    }
    vector<ll> ans(n + 1);
    for (int i = 1; i <= n; i++) {
        ans[i] = max(ans[i - 1], a[i] - dp[i]);
    }

    vector<ll> dif(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        dif[i] = dif[i - 1] + (a[i] - b[i]);
    }

    for (int i = 1; i <= n; i++) {
        cout << dif[i] - ans[i] << " ";
    }
    cout << '\n';

}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    ll tst = 1; cin >> tst;
    while (tst--) {
        solve();
    }
}