#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e16;

ll get_diff(multiset<ll>& curr_a, multiset<ll>& curr_b) {
    ll diff = 0;
    auto it_a = curr_a.begin(), it_b = curr_b.begin();
    while (it_a != curr_a.end()) {
        if (*it_a < *it_b) return INF;
        diff += abs(*it_a - *it_b);
        it_a++;
        it_b++;
    }
    return diff;
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    for (ll& i : a) cin >> i;
    for (ll& i : b) cin >> i;
    multiset<ll> curr_a, curr_b;
    for (ll i = 0; i < n; i++) {
        curr_a.insert(a[i]);
        curr_b.insert(b[i]);
        ll min_diff = INF;
        auto itb = curr_b.begin();
        while (itb != curr_b.end()) {
            ll valb = *itb;
            curr_b.erase(itb);
            auto ita = curr_a.begin();
            auto curr_itb = curr_b.begin();
            while (curr_itb != curr_b.end() && *ita >= *curr_itb) {
                ita++;
                curr_itb++;
            }
            int a_erased = *ita;
            curr_a.erase(ita);
            min_diff = min(min_diff, get_diff(curr_a, curr_b));
            itb = next(curr_b.insert(valb));
            curr_a.insert(a_erased);
        }
        cout << min_diff << " ";
    }
    cout << "\n";
}

int main() {
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}