#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e16;

ll get_diff(multiset<ll>& curr_a, multiset<ll>& curr_b) {
    ll diff = 0;
    auto it_a = curr_a.begin(), it_b = curr_b.begin();
    while (it_a != curr_a.end()) {
        if (*it_a < *it_b) return INF;
        diff += abs(*it_a - *it_b);
        it_a++;
        it_b++;
    }
    return diff;
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    for (ll& i : a) cin >> i;
    for (ll& i : b) cin >> i;
    multiset<ll> as, bs;
    for (ll i = 0; i < n; i++) {
        as.insert(a[i]);
        bs.insert(b[i]);
        if (i == 0) {
            cout << 0 << " ";
            continue;
        }
        multiset<ll> curr_a = as, curr_b = bs;
        ll max_pair_diff = 0;
        auto ita2 = as.begin(), itb2 = bs.begin();
        int diff = get_diff(as, bs);
        ll min_diff = diff;
        auto itb = curr_b.begin();
        auto ita = as.begin(), curr_itb = next(bs.begin());
        int bad_diffs = 0;
        auto ita1 = next(as.begin()), itb1 = next(curr_itb);
        while (ita1 != as.end() && itb1 != bs.end()) {
            if (*ita1 < *itb1) bad_diffs++;
            ita1++;
            itb1++;
        }
        while (itb != curr_b.end()) {
            if (curr_itb != bs.end() && *curr_itb == *itb) {
                if (*next(ita) < *curr_itb) bad_diffs--;
                ita++;
                curr_itb++;
            }
            ll valb = *itb;
            curr_b.erase(itb);
            while (curr_itb != bs.end() && *ita >= *curr_itb) {
                ita++;
                curr_itb++;
            }
            int a_erased = *ita;
            curr_a.erase(curr_a.find(a_erased));
            // min_diff = min(min_diff, get_diff(curr_a, curr_b));
            if (bad_diffs <= 1) {
                min_diff = min(min_diff, diff + valb - *ita);
            }
            itb = next(curr_b.insert(valb));
            curr_a.insert(a_erased);
        }
        cout << min_diff << " ";
    }
    cout << "\n";
}

int main() {
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}