#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define pb push_back
#define endl '\n'
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define vi vector<ll>

bool prov(pair<ll, ll> a, pair<ll, ll> b) {
    if (a.first < b.first || (a.second == 2 && b.second == 1 && a.first == b.first)) {
        return true;
    }
    return false;
}

void solve() {
    ll n;
    cin >> n;
    vi a(n), b(n);
    ll fl = 0;
    vi pref_a(n + 1), pref_b(n + 1);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        if (i > 0 && a[i] < a[i-1]) {
            fl = 1;
        }
        pref_a[i + 1] = pref_a[i] + a[i];
    }
    for (ll i = 0; i < n; i++) {
        cin >> b[i];
        if (i > 0 && b[i] < b[i-1]) {
            fl = 1;
        }
        pref_b[i + 1] = pref_b[i] + b[i];
    }
    if (fl == 0 && n > 3000) {
        ll mx = 0;
        for (ll i = 0; i < n; i++) {
            ll j = lower_bound(a.begin(), a.begin() + i, b[i]) - a.begin();
            mx = max(mx, a[i] - b[j]);
            cout << pref_a[i+1] - pref_b[i+1] - mx << ' ';
        }
        cout << endl;
        return;
    }
    if (n > 3000) {
        ll mx = 0;
        ll ans = 0;
        for (ll i = 0; i < n; i++) {
            ans += a[i] - b[i];
            mx = max(a[i] - b[i], mx);
            cout << ans - mx << " ";
        }
        cout << endl;
        return;
    }
    vector<pair<ll, ll>> s;
    for (ll i = 0; i < n; i++) {
        s.pb({a[i], 1});
        ll j = (ll) s.size() - 1;
        while (j > 0 && prov(s[j], s[j - 1])) {
            swap(s[j], s[j - 1]);
            j--;
        }
        s.pb({b[i], 2});
        j = (ll) s.size() - 1;
        while (j > 0 && prov(s[j], s[j - 1])) {
            swap(s[j], s[j - 1]);
            j--;
        }
        vector<ll> suf(2 * (i + 1) + 1);
        ll cnt_a = 0, cnt_b = 0;
        ll ans = pref_a[i + 1] - pref_b[i + 1];
        stack<ll> st;
        ll mx = 0;
        for (ll u = 2 * i + 1; u >= 0; u--) {
            if (s[u].second == 1) {
                if (cnt_b > 0) {
                    ll b_val = s[u + 1].first;
                    ll a_val;
                    while (cnt_b > 0) {
                        a_val = st.top();
                        cnt_b--;
                        st.pop();
                    }
                    mx = max(mx, a_val - b_val);
                }
                cnt_b = 0;
                st.push(s[u].first);
                cnt_a++;
            } else {
                cnt_a = 0;
                cnt_b++;
            }
        }
        if (cnt_b > 0) {
            ll b_val = s[0].first;
            ll a_val;
            while (cnt_b > 0) {
                a_val = st.top();
                cnt_b--;
                st.pop();
            }
            mx = max(mx, a_val - b_val);
        }
        cout << ans - mx << " ";
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    clock_t timer = clock();
#endif
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
#ifdef LOCAL
    // cout << endl << "time: " << (ld) (clock() - timer) / CLOCKS_PER_SEC;
#endif
}