#include <iostream>
#include <vector>

#pragma target('avx2')

#include <set>
#include <map>
#include <algorithm>
#include <numeric>

using namespace std;

#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> A(n), B(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> B[i];
    }
    vector<int> As, Bs;
    int ans = A[0] - B[0], sum = A[0] - B[0];
    As.push_back(A[0]);
    Bs.push_back(B[0]);
    cout << sum - ans << ' ';
    for (int i = 1; i < n; i++) {
        As.insert(std::lower_bound(As.begin(), As.end(), A[i]), A[i]);
        Bs.insert(std::lower_bound(Bs.begin(), Bs.end(), B[i]), B[i]);
        sum += A[i] - B[i];
        ans = As.back() - Bs.back();
        int top = As.back();
        for (int j = i - 1; j >= 0; j--) {
            if (As[j] < Bs[j + 1]) {
                top = As[j];
            }
            ans = max(ans, top - Bs[j]);
        }
        cout << sum - ans << ' ';
    }
    cout << '\n';
}

signed main() {
    int t;
    cin >> t;
    for (int _ = 0; _ < t; _++) {
        solve();
    }
}
