#ifdef LOCAL
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#define _GLIBCXX_DEBUG
#else
#define debug(x) ;
#endif

#include<iostream>
#include<vector>
#include<array>
#include<algorithm>
#include<set>
#include<map>

using namespace std;

typedef long long ll;

const ll INF=1e17+9;

void solve() {
	ll n;
	cin>>n;
	vector<ll> a(n),b(n);
	for(auto &i:a) {cin>>i;}
	for(auto &i:b) {cin>>i;}
	ll sum=0;
	ll mnb=INF,mxa=-INF;
	for(int sz=1;sz<=n;sz++) {
		sum+=a[sz-1]-b[sz-1];
		ll res=0;
		mnb=min(mnb,b[sz-1]);
		mxa=min(mxa,a[sz-1]);
		if(n<=3000) {
			sort(a.begin(),a.begin()+sz);
			sort(b.begin(),b.begin()+sz);
			int j=0;
			for(int i=0;i<sz;i++) {
				j=max(j,i);
				while(j<sz-1 && a[j]>=b[j+1]) {j++;}
				//debug(i)
				//debug(j)
				res=max(res,a[j]-b[i]);
			}
		} else {
			res=a[sz-1]-b[0];
		}
		//debug(sum)
		//debug(res)
		//debug("")
		cout<<sum-res<<' ';
	}
	cout<<'\n';
}

signed main() {
	ll group,n;
	ll t=1;
	cin>>t;
	while(t--) {solve();}
	return 0;
}




