#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve1(ll n, vector <ll> a, vector <ll> b)
{
    vector <ll> pref_a(n + 1, 0);
    vector <ll> pref_b(n + 1, 0);
    pref_a[1] = a[0];
    pref_b[1] = b[0];
    vector <ll> max_cnt(n);
    max_cnt[0] = a[0] - b[0];
    ll cnt = max_cnt[0];
    cout << 0 << ' ';
    for(ll i = 1; i < n; i++)
    {
        pref_a[i + 1] = pref_a[i] + a[i];
        pref_b[i + 1] = pref_b[i] + b[i];
        if(a[i - 1] >= b[i])
        {
            cnt += a[i] - a[i - 1];
        }
        else
        {
            cnt = a[i] - b[i];
        }
        max_cnt[i] = max(cnt, max_cnt[i - 1]);
        cout << pref_a[i + 1] - pref_b[i + 1] - max_cnt[i] << ' ';
    }
    cout << endl;
}

void solve2(ll n, vector <ll> a, vector <ll> b)
{
    vector <ll> sort_a = {a[0]};
    vector <ll> sort_b = {b[0]};
    cout << 0 << ' ';
    for(ll i = 1; i < n; i++)
    {
        vector <ll> new_sort(i + 1);
        ll flag = 0;
        for(ll j = 0; j < i; j++)
        {
            if(a[i] < sort_a[j] && flag == 0)
            {
                new_sort[j + flag] = a[i];
                flag++;
            }
            new_sort[j + flag] = sort_a[j];
        }
        if(flag == 0)
        {
            new_sort[i] = a[i];
        }
        sort_a.resize(0);
        for(ll j = 0; j <= i; j++)
        {
            sort_a.push_back(new_sort[j]);
        }
        flag = 0;
        for(ll j = 0; j < i; j++)
        {
            if(b[i] < sort_b[j] && flag == 0)
            {
                new_sort[j + flag] = b[i];
                flag++;
            }
            new_sort[j + flag] = sort_b[j];
        }
        if(flag == 0)
        {
            new_sort[i] = b[i];
        }
        sort_b.resize(0);
        for(ll j = 0; j <= i; j++)
        {
            sort_b.push_back(new_sort[j]);
        }
        vector <ll> pref_a(i + 2);
        vector <ll> pref_b(i + 2);
        pref_a[1] = sort_a[0];
        pref_b[1] = sort_b[0];
        vector <ll> max_cnt(i + 1);
        ll cnt = sort_a[0] - sort_b[0];
        max_cnt[0] = cnt;
        for(ll j = 1; j <= i; j++)
        {
            pref_a[j + 1] = pref_a[j] + sort_a[j];
            pref_b[j + 1] = pref_b[j] + sort_b[j];
            if(sort_a[j - 1] >= sort_b[j])
            {
                cnt += sort_a[j] - sort_a[j - 1];
            }
            else
            {
                cnt = sort_a[j] - sort_b[j];
            }
            max_cnt[j] = max(cnt, max_cnt[j - 1]);
        }
        cout << pref_a[i + 1] - pref_b[i + 1] - max_cnt[i] << ' ';
    }
    cout << endl;
}

void solve()
{
    ll n;
    cin >> n;
    vector <ll> a(n);
    vector <ll> b(n);
    bool flag = false;
    for(ll i = 0; i < n; i++)
    {
        cin >> a[i];
        if(i > 0 && a[i] < a[i - 1])
        {
            flag = false;
        }
    }
    for(ll i = 0; i < n; i++)
    {
        cin >> b[i];
        if(i > 0 && b[i] < b[i - 1])
        {
            flag = false;
        }
    }
    if(flag)
    {
        solve1(n, a, b);
    }
    else
    {
        solve2(n, a, b);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    ll t = 1;
    cin >> t;
    for(ll i = 0; i < t; i++)
    {
        solve();
    }
    return 0;
}
