//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <vector>
#include <deque>
#include <ctime>
#include <unordered_set>
#include <iomanip>
#include <algorithm>
using namespace std;
#define double long double
#define int long long
#define ll long long
#define debug(x) cerr << (#x) << ": " << x << endl;
#define get_time (double)(clock()) / (double)(CLOCKS_PER_SEC)
const int INF = 1e17 + 7;
const int mod = 1e9 + 7;
const int MAXN = 2e5 + 10;
//#pragma GCC optimize("avx2")
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
int make_add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int n;
vector<int> sta, stb;
void get() {
    int sum_a = 0, sum_b = 0;
    for (int i = 0; i < n; i++) {
        sum_a += sta[i];
        sum_b += stb[i];
        vector<int> a, b;
        for (int j = 0; j <= i; j++) {
            a.push_back(sta[j]);
            b.push_back(stb[j]);
        }
        sort(a.begin(), a.end());
        sort(b.begin(), b.end());
        vector<int> bad;
        for (int j = 0; j < i; j++) {
            if (a[j] < b[j + 1]) bad.push_back(j);
        }
        int cur_pos = bad.size() - 1, ans = -INF;
        for (int j = i; j >= 0; j--) {
            int add = 0;
            if (cur_pos == -1) {
                add = b[0];
            } else {
                add = b[bad[cur_pos] + 1];
            }
            if (cur_pos >= 0 && bad[cur_pos] + 1 == j) cur_pos--;
            ans = max(ans, -add + a[j]);
        }
        cout << sum_a - sum_b - ans << endl;
        
    }
}
void stupid() {
    int mx = -INF, mn = INF, sum_a = 0, sum_b = 0;
    int res = INF, del = -INF;
    for (int i = 0; i < n; i++) {
        sum_a += sta[i];
        sum_b += stb[i];
        del = max(del, sta[i] - stb[i]);
        cout << sum_a - sum_b - del << endl;
    }
}
void solve_g_5() {
    vector<int> a, b;
    int last = -1, del = -INF;
    int sum_a = 0, sum_b = 0;
    for (int i = 0; i < n; i++) {
        if (a.size() > 0) {
            if (a.back() < stb[i]) last = i - 1;
        }
        sum_a += sta[i];
        sum_b += stb[i];
        int pos = last + 1;
        del = max(del, sta[i] - stb[pos]);
        a.push_back(sta[i]);
        b.push_back(stb[i]);
        cout << sum_a - sum_b - del << '\n';
    }
}
void solve() {
    cin >> n;
    sta = vector<int>(n);
    stb = vector<int>(n);
    for (int i = 0; i < n; i++)  cin >> sta[i];
    for (int i = 0; i < n; i++)  cin >> stb[i];
    int fl = 0;
    for (int i = 0; i < n - 1; i++) {
        if (sta[i] >= stb[i + 1]) fl = 1;
        if (sta[i + 1] < sta[i]) fl = 1;
        if (stb[i + 1] < stb[i]) fl = 1;
    }
    if (fl) {
        get();
        return;
    }
    solve_g_5();
}
signed main() {
    cout << fixed << setprecision(20);
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;   
    while (t--) {
        solve();
    }
}
/*
4
3
11 17 14
1 13 10

*/