#include <bits/stdc++.h>
using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream& cin, ostream& cout);


int test_cnt = 1, group, cur_test;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> test_cnt;
    // cin >> group;
    for (cur_test = 0; cur_test < test_cnt; ++cur_test)
        solve(cin, cout);
}


void solve(istream& cin, ostream& cout) {
    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    for (auto& t : a)
        cin >> t;
    for (auto& t : b)
        cin >> t;


    ll sum_a = 0, sum_b = 0;
    for (ll pref = 1; pref <= n; ++pref) {
        sum_a += a[pref - 1];
        sum_b += b[pref - 1];
        sort(a.begin(), a.begin() + pref);
        sort(b.begin(), b.begin() + pref);

        ll res = INF;
        for (ll i = 0; i < pref; ++i) {
            for (ll j = 0; j < pref; ++j) {
                if (b[j] > a[i])
                    continue;
                if (sum_a - a[i] + b[j] >= sum_b) {
                    bool ok = true;
                    ll v = 0, u = 0;
                    for (; v < pref && u < pref && ok; ++v, ++u) {
                        if (v == i)
                            ++v;
                        if (u == j)
                            ++u;
                        if (a[v] < b[u])
                            ok = false;
                    }
                    if (ok)
                        res = min(res, sum_a - a[i] + b[j] - sum_b);
                }
            }
        }

        cout << res << ' ';
    }
    cout << '\n';
}
