#include <bits/stdc++.h>
using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(2e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9l;


void solve(istream& cin, ostream& cout);


int test_cnt = 1, group, cur_test;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> test_cnt;
    // cin >> group;
    for (cur_test = 0; cur_test < test_cnt; ++cur_test)
        solve(cin, cout);
}


ll n;
void solve1(istream& cin, ostream& cout) {
    vector<ll> a(n), b(n);
    for (auto& t : a)
        cin >> t;
    for (auto& t : b)
        cin >> t;


    ll sum_a = 0, sum_b = 0;
    ll max_a = -INF, min_b = INF;
    for (ll pref = 1; pref <= n; ++pref) {
        sum_a += a[pref - 1];
        sum_b += b[pref - 1];
        max_a = max(max_a, a[pref - 1]);
        min_b = min(min_b, b[pref - 1]);

        cout << (sum_a - max_a + min_b - sum_b) << ' ';
    }
    cout << '\n';
}


void solve(istream& cin, ostream& cout) {
    cin >> n;
    if (n > 3000) {
        solve1(cin, cout);
        return;
    }
    vector<ll> a(n), b(n);
    for (auto& t : a)
        cin >> t;
    for (auto& t : b)
        cin >> t;


    ll sum_a = 0, sum_b = 0;
    for (ll pref = 1; pref <= n; ++pref) {
        sum_a += a[pref - 1];
        sum_b += b[pref - 1];
        sort(a.begin(), a.begin() + pref);
        sort(b.begin(), b.begin() + pref);


        ll res = sum_a - sum_b;
        ll cnt = 0;
        for (ll i = 0; i + 1 < pref; ++i) {
            if (a[i] >= b[i + 1]) {
                res = min(res, sum_a - a[i + 1] + b[i - cnt] - sum_b);
                ++cnt;
            } else {
                cnt = 0;
            }
        }
        for (ll i = 0; i < pref; ++i)
            res = min(res, sum_a - a[i] + b[i] - sum_b);

        cout << res << ' ';
    }
    cout << '\n';
}
