#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define ll long long
#define all(x) x.begin(), x.end()
#define fi first
#define se second
#define ve vector

using namespace std;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#pragma GCC optimize("Ofast")

void solve() {
    int n;
    cin >> n;
    ve<int> a(n), b(n);
    for (auto& i : a)
        cin >> i;
    for (auto& i : b)
        cin >> i;
    for (int it = 1; it <= n; it++) {
        ve<int> ca(it);
        ve<int> cb(it);
        for (int i = 0; i < it; i++)
            ca[i] = a[i];
        for (int i = 0; i < it; i++)
            cb[i] = b[i];
        sort(all(ca));
        sort(all(cb));
        ll sa = 0;
        for (auto i : ca)   
            sa += i;
        ll sb = 0;
        for (auto i : cb)
            sb += i;
        ll res = sa - sb;
        int l = 0, r = 0;
        while (r < ca.size() - 1 || l < ca.size() - 1) {
            res = min(res, sa - sb - ca[r] + cb[l]);
            if (r != ca.size() - 1 && ca[r] >= cb[r + 1])
                r++;
            else {
                l++;
                r = max(r, l);
            }
        }
        res = min(res, sa - sb - ca[r] + cb[l]);
        cout << res << " ";
    }
    cout << "\n";

}

int main() {
    int T;
    cin >> T;
    while (T--) {
        solve();
    }
}
