#include <bits/stdc++.h>

/* Using libraries */
using namespace std;

using ld = long double;
template <class T>
using vc = vector <T>;
using pii = pair <int, int>;
using pint = pair <int, int>;
template <class T>
int sz(vc <T> &a) {
    return (int)a.size();
}
int sz(string &a) {
    return (int)a.size();
}

template<class T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int inf = 1e9;
template<class T>
bool chmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

struct dsu {
    vc <int> p;
    vc <int> mx, mn;
    int best = 0, sum = 0;
    dsu (int n) {
        p.resize(n); iota(p.begin(), p.end(), 0);
        mx.resize(n);
        mn.resize(n);
    };
    int find (int u) {
        return u == p[u] ? u : p[u] = find(p[u]);
    }
    int unite (int u, int v) {
        u = find(u);
        v = find(v);
        if (u == v) return 0;
        mx[u] = max(mx[u], mx[v]);
        mn[u] = min(mn[u], mn[v]);
        best = max(best, mx[u] - mn[u]);
        p[v] = u;
        return 1;
    }
    void add (int i, int x, int y) {
        mn[i] = y;
        mx[i] = x;
        sum += x - y;
        best = max(best, x - y);
    }
};

void solve() {
    int n;
    cin >> n;
    vc <int> a(n), b(n);
    int f = 1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        if (i > 0)
            f &= b[i] > a[i - 1];
    }
    multiset<pii> s1, s2;
    dsu t(n);
    for (int i = 0; i < n; ++i) {
        s1.insert({a[i], i});
        s2.insert({b[i], i});
        auto r = prev(s2.lower_bound({a[i] + 1, -1}));
        auto l = s1.lower_bound({b[i], -1});
        t.add(i, a[i], b[i]);
        for (auto x = l;; --x) {
            t.unite(x->second, i);
            if (x == s1.begin())
                break;
        }
        for (auto x = r; x != s2.end(); ++x) {
            t.unite(x->second, i);
        }
        cout << t.sum - t.best << ' ';
    }
    cout << '\n';
}


signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
}