#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
#define ll long long
#define nl '\n'
#define emp emplace_back
#define all(x) x.begin(), x.end()
#define pll pair<ll, ll>
#define ff first
#define ss second

using namespace std;
//using namespace __gnu_pbds;
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto x : a) {
        out << x << ' ';
    }
    out << '\n';
    return out;
}

const ll INF = 1e18;

mt19937 rnd(time(nullptr));

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    cin >> a >> b;
    set<pll> st;
    for (ll i = 0; i < n; ++i) {
        st.insert({a[i], b[i]});
        ll mn = INF;
        for (ll i1 = 0; i1 <= i; ++i1) {
            for (ll i2 = 0; i2 <= i; ++i2) {
                vector<ll> p1, p2;
                ll j = 0;
                for (auto [h, g] : st) {
                    if (i1 != j) {
                        p1.emp(h);
                    }
                    if (i2 != j) {
                        p2.emp(g);
                    }
                    ++j;
                }
                sort(all(p2));
                ll ans = 0;
                for (j = 0; j < (ll)p1.size(); ++j) {
                    if (p1[j] < p2[j]) {
                        ans = INF;
                        break;
                    }
                    ans += p1[j] - p2[j];
                }
                mn = min(mn, ans);
            }
        }
        cout << mn << ' ';
    }
}

int main() {
#ifdef CLOCK
    ll time1 = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    cin >> tpk;
#endif

    cin >> tpk;

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef CLOCK
    cout << clock() - time1 << " ms";
#endif
}