#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
#define ll long long
#define nl '\n'
#define emp emplace_back
#define all(x) x.begin(), x.end()
#define pll pair<ll, ll>
#define ff first
#define ss second

using namespace std;
//using namespace __gnu_pbds;
//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto x : a) {
        out << x << ' ';
    }
    out << '\n';
    return out;
}

const ll INF = 1e18;

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    cin >> a >> b;
    vector<ll> p1;
    vector<ll> p2;
    ll sum1 = 0;
    ll sum2 = 0;
    for (ll i = 0; i < n; ++i) {
        p1.emp(a[i]);
        p2.emp(b[i]);
        sort(all(p1));
        sort(all(p2));
        sum1 += a[i];
        sum2 += b[i];
        ll ans = INF;
        for (ll j = 0; j <= i; ++j) {
            ans = min(ans, sum1 - sum2 + (p2[j] - p1[j]));
        }
        vector<ll> used(i + 1);
        used.back() = 1;
        for (ll j = 0; j < i; ++j) {
            used[j] = (p1[j] >= p2[j + 1]);
        }
        ll last = -1;
        for (ll j = 0; j <= i; ++j) {
            ll ind = last + 1;
            ans = min(ans, sum1 - sum2 + (p2[ind] - p1[j]));
            if (used[j] == 0) {
                last = j;
            }
        }
        cout << ans << ' ';
    }
}

int main() {
#ifdef CLOCK
    ll time1 = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
    cin >> tpk;
#endif

    cin >> tpk;

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef CLOCK
    cout << clock() - time1 << " ms";
#endif
}