#include <iostream>
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
*/
#include <bits/stdc++.h>
using namespace std;

/*
#include <bits/extc++.h>
using namespace __gnu_pbds;
typedef tree<
        int,
        null_type,
        less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;
 */

#define int long long
#define ll long long
#define fi first
#define se second
#define eb emplace_back
#define lwb lower_bound
#define upb upper_bound
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define ld long double
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
const int INF = 1e9, N = 300300, K = 26, C = 700, P = 1e9 + 7;
const ld EPS = 1e-5, pi = 3.1415926535;

struct dsu {
    vector<int> r, p, mini, maxi;
    int res = 0;

    void init(int n) {
        r.assign(n + 1, 1);
        p.resize(n + 1);
        iota(all(p), 0);
        mini.assign(n + 1, INF);
        maxi.assign(n + 1, 0);
    }

    int get(int v) {
        if (v == p[v])
            return v;
        return p[v] = get(p[v]);
    }

    void merge(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b)
            return;
        if (r[a] < r[b])
            swap(a, b);
        p[b] = a;
        r[a] += r[b];
        mini[a] = min(mini[a], mini[b]);
        maxi[a] = max(maxi[a], maxi[b]);
        res = max(res, maxi[a] - mini[a]);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    vector<int> ansik(n);
    for (int i = 0; i < n; i++) {
        ansik[i] += a[i] - b[i];
        if (i > 0)
            ansik[i] += ansik[i - 1];
    }
    dsu dsu;
    dsu.init(n);
    for (int i = 0; i < n; i++) {
        dsu.mini[i] = b[i];
        dsu.maxi[i] = a[i];
    }
    int sus = 0;
    set<pair<int, int>> r, l;
    r.insert({-INF, -1});
    l.insert({-INF, -1});
    for (int i = 0; i < n; i++) {
        sus = max(sus, a[i] - b[i]);
        auto it = r.lwb({b[i], -INF});
        if (it != r.end() && it->fi <= a[i]) {
            dsu.merge(i, it->se);
        }
        it = l.upb({a[i], -INF});
        it--;
        if (it != l.begin() && it->fi >= b[i]) {
            dsu.merge(i, it->se);
        }
        sus = max(sus, dsu.res);
        ansik[i] -= sus;
        r.insert({a[i], i});
        l.insert({b[i], i});
    }
    for (auto it : ansik) {
        cout << it << " ";
    }
    cout << "\n";
}

signed main() {
    //cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--)
        solve();
    return 0;
}