//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt,fma")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const long long RANDOM = chrono::high_resolution_clock::now().time_since_epoch().count();
constexpr int MAXN = 1 << 20;
constexpr long long mod = 1e9 + 7;
mt19937 rnd(RANDOM);

ll ans(vector<ll> &a, vector<ll> &b) {
    ll ans = 0;
    std::sort(a.begin(), a.end());
    std::sort(b.begin(), b.end());
    vector<pair<ll, ll>> arr;
    multiset<ll> st;
    for (int i = 0; i < a.size(); i++) {
        int l = -1, r = b.size();
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (b[m] <= a[i]) {
                l = m;
            } else {
                r = m;
            }
        }
        arr.push_back({a[i] - b[l], a[i]});
        st.insert(b[i]);
    }
    std::sort(arr.begin(), arr.end());
    for (int i = 0; i < (int) arr.size() - 1; i++) {
        auto in = st.upper_bound(arr[i].second);
        in--;
        ans += arr[i].second - *in;
        st.erase(st.find(*in));
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n), b(n);
    for (auto &i: a) {
        cin >> i;
    }
    for (auto &i: b) {
        cin >> i;
    }
    vector<ll> p1, p2;
    for (int i = 0; i < n; i++) {
        p1.push_back(a[i]);
        p2.push_back(b[i]);
        cout << ans(p1, p2) << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q = 1;
    cin >> q;
    while (q--) {
        solve();
    }
}
