#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl '\n'

typedef long long ll;
typedef long double ld;

typedef tree<int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 2e15 + 1;
const int MOD = 1e9 + 7;

mt19937 rnd(time(0));

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector <vector <int>> sm;
vector <int> l, sz;

int find(int a){
    if (a == l[a])
        return a;
    return l[a] = find(l[a]);
}

bool same(int a, int b){
    return find(a) == find(b);
}

void unite(int a, int b){
    a = find(a), b = find(b);
    if (same(a, b))
        return;
    if (sz[a] < sz[b])
        swap(a, b);
    l[b] = a;
    sz[a] += sz[b];
}

signed main() {
    Fast();
    int t;
    cin >> t;
    while (t--){
        int n;
        cin >> n;
        vector <int> a(n);
        vector <int> b(n);
        for (int i = 0; i < n; i++)
            cin >> a[i];
        for (int i = 0; i < n; i++)
            cin >> b[i];
        vector <int> c, d;
        vector <int> ans(n);
        ans[0] = 0;
        c.push_back(a[0]);
        d.push_back(b[0]);
        for (int i = 1; i < n; i++){
            c.push_back(a[i]);
            d.push_back(b[i]);
            sort(c.begin(), c.end());
            sort(d.begin(), d.end());
            int an = INF;
//            cout << i << endl;
            for (int y = 0; y < i + 1; y++){
                int l = 0, r = 0;
                int cnt = 0;
                int sum = 0;
                while (cnt < i && r < n){
                    while (r == y)
                        r++;
                    while (l < n && c[l] < d[r])
                        l++;
                    if (l < n) {
                        sum += (c[l] - d[r]);
                        cnt++;
                    }
                    l++, r++;
                }
                if (cnt == i)
                    an = min(an, sum);
            }
            ans[i] = an;
        }
        for (auto i:ans)
            cout << i << " ";
        cout << endl;
    }
    return 0;
}

/*
3
0 5 5
0 9 3
5 9 8
2 5
 */