#include<bits/stdc++.h>
using namespace std;

#define int long long

void solve() {
    int n;
    cin >> n;

    vector<int> a(n), b(n);
    for (auto &i : a) {
        cin >> i;
    }

    for (auto &i : b) {
        cin >> i;
    }

    // swap(a, b);

    vector<int> pr = {0};
    for (int i = 0; i < n; i++) {
        pr.push_back(pr.back() - b[i] + a[i]);
    }

    vector<int> ans(n, 1e18);
    ans[0] = 0;
    set<int> st = {-pr[1]};
    multiset<int> fa = {a[0]}, fb = {b[0]};

    for (int i = 1; i < n; i++) {
        fa.insert(a[i]);
        fb.insert(b[i]);
        ans[i] = min(pr[i], pr[i + 1] + (*st.begin()));
        // if a last
        int cur = 0;
        auto it1 = prev(prev(fa.end())), it2 = prev(fb.end());

        int j = i - 1;
        for (; j >= 0; j--) {
            if ((*it1) < (*it2)) {
                break;
            }

            cur += (*it1) - (*it2);
            it1 = prev(it1);
            it2 = prev(it2);
        }

        int sumall = 0;
        it1 = fa.begin(), it2 = fb.begin();
        for (int i = 0; i < j + 1; i++) {
            sumall += ((*it1) - (*it2));
            it2 = next(it2);
            it1 = next(it1);
        }

        ans[i] = min(ans[i], cur + sumall);

        // if b last
        cur = 0;
        it1 = prev(fa.end()), it2 = prev(prev(fb.end()));
        j = i - 1;
        for (; j >= 0; j--) {
            if ((*it1) < (*it2)) {
                break;
            }

            cur += (*it1) - (*it2);
            it1 = prev(it1);
            it2 = prev(it2);
        }

        sumall = 0;
        it1 = fa.begin(), it2 = fb.begin();
        for (int i = 0; i < j + 1; i++) {
            sumall += ((*it1) - (*it2));
            it2 = next(it2);
            it1 = next(it1);
        }


        ans[i] = min(ans[i], cur + pr[j + 1]);
        st.insert(ans[i] - pr[i + 1]);
    }

    for (auto i : ans) {
        cout << i << ' ';
    }

    cout << "\n";
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}

/*
4
2 
3 4
1 2
2
3 4
1 3
3
11 17 14
1 13 10
4
100 11 50 42
30 1 20 5

3
4
2 4 5 12
1 3 4 10
4
3 5 8 20
1 2 6 7
4
4 4 4 4
1 2 3 4
*/