#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define gen(a, b) uniform_int_distribution<int>(a, b)(rnd)
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
struct Do{
    vector<int> T;
    int n;
    Do(int N) {
        T.assign(N * 2 + 1, {});
        n = N;
    }
    void add(int x, int val) {
        x += n;
        T[x] = val;
        while (x > 0) {
            x >>= 1;
            T[x] = max(T[x * 2], T[x * 2 + 1]);
        }
    }
    int query(int l, int r) {
        int ans = 0;
        l += n;
        r += n;
        while(l < r) {
            if(l&1) {
                ans = max(ans, T[l++]);
            }
            if(r&1) {
                ans = max(ans, T[--r]);
            }
            l>>=1;
            r>>=1;
        }
        return ans;
    }
};
struct fenv {
    vector<int> T;
    fenv(int N) {
        T.assign(N + 1, {});
    }
    void add(int x, int val) {
        for(x++;x < T.size();x += (x & -x)) {
            T[x - 1] += val;
        }
    }
    int sum(int x) {
        int sum = 0;
        for(x++;x > 0;x -= (x & -x)) {
            sum += T[x - 1];
        }
        return sum;
    }
    int sum(int l, int r) {
        return sum(r) - sum(l - 1);
    }
};
void solve() {
int n;
    cin >> n;
    vector<int>a(n),b(n);
    for(auto &x:a)cin>>x;
    for(auto &x:b)cin>>x;
    set<int> S;
    fenv f(n * 2 + 1);
    Do T(n * 2 + 1);
    vector<pair<int,int>> idx;
    for(int i = 0; i < n; i++) {
        idx.push_back({a[i], i});
        idx.push_back({b[i], n + i});
    }
    sort(all(idx), [&](auto a, auto b) {
        if(a.first != b.first) {
            return a.first < b.first;
        } else {
            return a.second > b.second;
        }
    });
    vector<int> Ma(n);
    vector<int>  Mb(n);
    vector<int> getB(n * 2 + 1);
    vector<int> getA(n * 2 + 1);
    for(int i = 0; i < idx.size(); i++) {
        if(idx[i].second < n) {
            Ma[idx[i].second] = i;
            getA[i] = idx[i].first;
        } else {
            Mb[idx[i].second - n] = i;
            getB[i] = idx[i].first;
        }
    }
    int maxn = 2 * n;
    multiset<int> maxAns;
    vector<int> curAn(maxn);
    auto add = [&] (int x) {
        S.insert(x);
        auto tt = S.lower_bound(x);
        if(tt != S.begin()) {
            tt--;
            maxAns.extract(curAn[*tt]);
            curAn[*tt] = -getB[*tt] + T.query(*tt, x);
            maxAns.insert(curAn[*tt]);
            tt++;
        }
        tt++;
        int rside = maxn;
        if(tt != S.end()) {
            rside = *tt;
        }
        maxAns.insert(-getB[x] + T.query(x, rside));
        curAn[x] = -getB[x] + T.query(x, rside);
    };
    auto del = [&](int x) {
        auto tt = S.lower_bound(x);
        if(tt != S.begin()) {
           int pr = *prev(tt);
            tt++;
            int rside = maxn;
            if(tt != S.end()) {
                rside = *tt;
            }
            maxAns.extract(curAn[pr]);
            curAn[pr] = -getB[pr] + T.query(pr, rside);
            maxAns.insert(curAn[pr]);
        }
        S.erase(x);
        maxAns.extract(curAn[x]);
        curAn[x] = 0;
    };
    ll Sa = 0;
    ll Sb = 0;
    auto get = [&]() {
        if(maxAns.empty()) return (int)0;
        else return *maxAns.rbegin();
    };
    for(int i = 0; i < n; i++) {
        T.add(Ma[i], a[i]);
        f.add(Ma[i], 1);
        f.add(Mb[i], -1);

        auto lb = S.lower_bound(Ma[i]);
        if(lb != S.begin()) {
            lb--;
            int val =  *lb;
            del(val);
            add(val);
        }
        Sa += a[i];
        Sb += b[i];
        if(!S.empty()) {
            auto tt = S.lower_bound(Mb[i]);
            vector<int> todel;
            while(tt != S.end() && *tt < Ma[i]) {
                todel.push_back(*tt);
                tt++;
            }
            for(auto x : todel) {
                del(x);
            }
        }
        if(f.sum(Mb[i], maxn) == 0) {
            add(Mb[i]);
        }
        cout << Sa - Sb - get() << " ";
    }
    cout << endl;
}
signed main() {
#ifdef LOCAL
    freopen("test.txt", "r", stdin);
#endif
    int tt;
    cin >> tt;
    while(tt--) {
        solve();
    }
}