#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define pb push_back
#define pii pair < int, int >
#define F first
#define S second
#define endl '\n'
#define int long long

typedef tree < int, null_type, less < int >, rb_tree_tag, tree_order_statistics_node_update > oset;

const int INF = 2e18+3;
const int mod = 1000000007;

void solve()
{
    int n;
    cin >> n;
    int a[n], b[n];
    bool fl = 1;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];
    for (int i = 1; i < n; i++)
    {
        if (a[i] < a[i - 1]) fl = 0;
        if (b[i] < b[i - 1]) fl = 0;
    }
    if (n <= 3000)
    {
        vector < int > x, y;
        for (int i = 0; i < n; i++)
        {
            x.pb(a[i]);
            y.pb(b[i]);
            sort(x.begin(), x.end());
            sort(y.begin(), y.end());
            int sz = i + 1;
            int prefx[sz], prefy[sz];
            for (int i = 0; i < sz; i++)
            {
                prefx[i] = (i > 0) * prefx[i - 1] + x[i];
                prefy[i] = (i > 0) * prefy[i - 1] + y[i];
            }
            int r = 0, ans = INF;
            for (int l = 0; l < sz; l++)
            {
                r = max(r, l);
                while (r + 1 < sz && x[r] >= y[r + 1])
                    r++;
                ans = min(ans, prefx[sz - 1] - prefy[sz - 1] - x[r] + y[l]);
            }
            cout << ans << ' ';
        }
        cout << endl;
        return;
    }
    if (fl == 0)
    {
        int mx = 0, mn = INF, s = 0;
        for (int i = 0; i < n; i++)
        {
            s += a[i] - b[i];
            mx = max(mx, a[i]);
            mn = min(mn, b[i]);
            cout << s - mx + mn << ' ';
        }
        cout << endl;
        return;
    }
    else
    {
        int s = 0;
        vector < int > x, y;
        int ans = INF, curl = 0;
        for (int i = 0; i < n; i++)
        {
            x.pb(a[i]);
            y.pb(b[i]);
            s += a[i] - b[i];
            if (i > 0 && a[i - 1] < b[i]) curl = i;
            ans = min(ans, -a[i] + b[curl]);
            cout << s + ans << ' ';
        }
        cout << endl;
    }
}

int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
}
