#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const int MAX = 1e5 + 7;
const int mod = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n + 1);
    vector<ll> b(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) cin >> b[i];
    vector<pair<ll, int>> st;
    ll res = 0;
    for (int i = 1; i <= n; i++) {
        res += a[i] - b[i];
        st.push_back({a[i], -1});
        st.push_back({b[i], 1});
        sort(st.begin(), st.end(), [&](auto p1, auto p2) {
            return (p1.first == p2.first ? p1.second > p2.second : p1.first < p2.first);
        });
        ll del = 0;
        multiset<ll> setik;
        for (auto [x, y] : st) {
            if (y == 1) {
                setik.insert(x);
            } else {
                del = max(del, x - *setik.begin());
                setik.erase(--setik.end());
            }
        }
        cout << res - del << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
     cin >> t;
    while (t--) {
        solve();
    }
}