#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

void solve() {
    ll n1;
    cin >> n1;
    vector<ll> a(n1), b(n1);
    bool sigma = true;
    for (ll i = 0; i < n1; ++i) {
        cin >> a[i];
        if (i > 0 && a[i] < a[i - 1]) {
            sigma = false;
        }
    }
    for (ll i = 0; i < n1; ++i) {
        cin >> b[i];
        if (i > 0 && b[i] < b[i - 1]) {
            sigma = false;
        }
    }

    if (!sigma) {
        for (ll n = 1; n <= n1; ++n) {
            sort(a.begin(), a.begin() + n);
            sort(b.begin(), b.begin() + n);
            vector<ll> dif(n), pref_dif(n + 1);
            pref_dif[0] = 0;
            for (ll i = 0; i < n; ++i) {
                dif[i] = a[i] - b[i];
                pref_dif[i + 1] = pref_dif[i] + dif[i];
            }

            vector<ll> dp(n);
            dp[0] = pref_dif[n] - pref_dif[1];
            ll minn = dp[0];
            for (ll i = 1; i < n; ++i) {
                if (a[i - 1] >= b[i]) {
                    dp[i] = dp[i - 1] - (a[i] - a[i - 1]);
                } else {
                    dp[i] = pref_dif[n] - dif[i];
                }
                minn = min(minn, dp[i]);
            }
            cout << minn << ' ';
        }
        cout << '\n';
        return;
    }

    ll n = n1;
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    vector<ll> dif(n), pref_dif(n + 1);
    pref_dif[0] = 0;
    for (ll i = 0; i < n; ++i) {
        dif[i] = a[i] - b[i];
        pref_dif[i + 1] = pref_dif[i] + dif[i];
    }

    vector<ll> dp(n);
    dp[0] = pref_dif[n] - pref_dif[1];
    for (ll i = 1; i < n; ++i) {
        if (a[i - 1] >= b[i]) {
            dp[i] = dp[i - 1] - (a[i] - a[i - 1]);
        } else {
            dp[i] = pref_dif[n] - dif[i];
        }
    }

    ll cur_min = INF;
    for (ll i = 0; i < n; ++i) {
        cur_min = min(cur_min, dp[i]);
        cout << cur_min - (pref_dif[n] - pref_dif[i + 1]) << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll t;
    cin >> t;
    for (ll i = 0; i < t; ++i) {
        solve();
    }
}
