#include <bits/stdc++.h>
#define int long long

using namespace std;

// c = C(2n,n)/(n+1)
// x = y' - (b/a) * x'
// y = x'
// ob[i] = (mod - (m / i) * ob[m % i] % mod + mod) % mod
// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
  int n;
  cin >> n;
  vector<int> a(n);
  for (auto& x : a) cin >> x;
  vector<int> b(n);
  for (auto& x : b) cin >> x;
  for (int i = 0; i < n; i++) {
    sort(a.begin(), a.begin() + i + 1);
    sort(b.begin(), b.begin() + i + 1);
    vector<bool> can(n);
    for (int j = 0; j + 1 <= i; j++) {
      if (a[j] >= b[j + 1]) {
        can[j] = true;
      }
    }
    int sum = 0;
    for (int j = 0; j <= i; j++) sum += a[j] - b[j];
    int del = 0;
    for (int j = 0; j <= i; j++) {
      int l = j;
      while (l && can[l - 1]) {
        l--;
      }
      del = min(del, - a[j] + b[l]);
    }
    cout << sum + del << ' ';
  }
  cout << '\n';
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}