#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
    ll t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        vector<ll> a(n), b(n);
        for (ll i = 0; i < n; i++) cin >> a[i];
        for (ll i = 0; i < n; i++) cin >> b[i];
        vector<pair<ll, Pair>> all;
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < n; j++) {
                if (a[i] >= b[j]) all.push_back({a[i] - b[j], {i, j}});
            }
        }
        sort(all.begin(), all.end());
        for (ll i = 0; i < n; i++) {
            vector<bool> used_a(n, false), used_b(n, false);
            ll was = 0, ans = 0;
            for (auto[val, ind] : all) {
                auto[ind_a, ind_b] = ind;
                if (ind_a <= i && ind_b <= i && !used_a[ind_a] && !used_b[ind_b]) {
                    was++;
                    if (was > i) break;
                    ans += val;
                    used_a[ind_a] = used_b[ind_b] = true;
                }
            }
            cout << ans << " ";
        }
        cout << endl;
    }
    return 0;
}
