#ifndef LOCALEGOR
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ld PI = acosl(-1.0);

mt19937 rnd(3105);

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& i : a) cin >> i;
    vector<int> b(n);
    for (int &i:b) cin >> i;
    for (int i = 1; i <= n; ++i) {
        vector<int> v1(a.begin(), a.begin() + i);
        vector<int> v2(b.begin(), b.begin() + i);
        sort(all(v1));
        sort(all(v2));
        int s = 0;
        for (int j = 0; j < i; ++j) {
            s += v1[j] - v2[j];
        }
        int l = 0;
        int ans = INF;
        for (int r = 0; r < i; ++r) {
            if (r && v1[r - 1] < v2[r]) l = r;
            ans = min(ans, s + v2[l] - v1[r]);
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCALEGOR
    freopen(R"(C:\Users\olymp\CLionProjects\main\INPUT.txt)", "r", stdin);
#endif
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}