#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7, LOG = 20;

void solve()
{
	long long n;
	vector<long long> a, b;
	cin >> n;
	a.resize(n);
	b.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	for (long long i = 0; i < n; i++)
	{
		cin >> b[i];
	}

	long long ans = 0;
	multiset<pair<long long, bool>> ev;
	for (long long i = 0; i < n; i++)
	{
		ans += a[i] - b[i];
		ev.insert({ b[i], false });
		ev.insert({ a[i], true });

		long long del = 0;
		long long cnt = 0;
		long long prev = -1;
		for (auto& j : ev)
		{
			if (prev == -1)
			{
				prev = j.first;
			}

			if (!j.second)
			{
				cnt++;
			}
			else
			{
				cnt--;
			}
			if (!cnt)
			{
				del = max(del, j.first - prev);
				prev = -1;
			}
		}
		cout << ans - del << " ";
	}
	cout << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst;
	cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*

























*/
