#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <chrono>
#include <ctime>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7, LOG = 20;

void solve()
{
	long long n;
	vector<long long> a, b;
	cin >> n;
	a.resize(n);
	b.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	for (long long i = 0; i < n; i++)
	{
		cin >> b[i];
	}

	long long ans = 0, del = 0;
	set<pair<long long, long long>> st = { { -INF, -INF }, { INF, INF } };
	for (long long i = 0; i < n; i++)
	{
		ans += a[i] - b[i];
		long long l = b[i], r = a[i];
		auto it = st.lower_bound(pair(l, -INF));
		it--;
		vector<pair<long long, long long>> aft;
		if (l <= it->second)
		{
			aft.push_back(*it);
		}
		it++;
		while (it->first <= r)
		{
			aft.push_back(*it);
			it++;
		}
		if (aft.size())
		{
			l = min(l, aft[0].first);
			r = max(r, aft.back().second);
			for (auto& j : aft)
			{
				st.erase(j);
			}
		}
		st.insert({ l, r });
		del = max(del, r - l);

		cout << ans - del << " ";
	}
	cout << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst;
	cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*

























*/
