#include<iostream>
#include<vector>
#include<string>
#include<sstream>
#include<cmath>
#include<algorithm>
#include<stdio.h>
#include<random>
#include<ctime>
#include<memory.h>
#define int long long
#define pii pair<int, int>
#define pb push_back
#define fir first
#define sec second
#define endl '\n'
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

mt19937 rnd(228);

int get(vector<int>& pref, int l, int r) {
	if (l == 0)
		return pref[r];
	return pref[r] - pref[l - 1];
}

void solve() {
	int n;
	cin >> n;

	int sa = 0, sb = 0;
	vector<int> a(n), b(n);
	for (int& i : a) {
		cin >> i;
		//sa += i;
	}
	for (int& i : b) {
		cin >> i;
		//sb += i;
	}

	if (n <= 3000) {
		vector<int> aa, bb;

		for (int p = 0; p < n; p++) {
			aa.pb(a[p]);
			bb.pb(b[p]);
			sort(all(aa));
			sort(all(bb));
			sa += a[p];
			sb += b[p];
			vector<int> mark(aa.size());
			for (int i = 0; i < p; i++) {
				if (aa[i] >= bb[i + 1])
					mark[i] = 1;
			}
			vector<int> pref(aa.size());
			pref[0] = mark[0];
			for (int i = 1; i < p; i++)
				pref[i] = pref[i - 1] + mark[i];
			int ans = 1e18;
			for (int i = 0; i <= p; i++) {
				if (i == 0) {
					ans = min(ans, sa - aa[i] - (sb - bb[i]));
					continue;
				}
				int l = -1, r = i + 1;
				while (r - l > 1) {
					int m = (r + l) / 2;
					if (get(pref, m, i - 1) == i - m)
						r = m;
					else
						l = m;
				}
				if (r == i + 1)
					continue;
				ans = min(ans, sa - aa[i] - (sb - bb[r]));
			}

			cout << ans << " ";
		}
		cout << endl;
		return;
	}
	else {
		vector<int> aa, bb;
		vector<int> mark(n);
		vector<int> pref(n);
		int ans = 1e18;
		for (int p = 0; p < n; p++) {
			aa.pb(a[p]);
			bb.pb(b[p]);
			sa += a[p];
			sb += b[p];
			/*mark.push_back(0);
			pref.pb(0);*/

			if (p == 0) {
				cout << 0 << " ";
				ans = 0;
				continue;
			}
			mark[p - 1] = (aa[p - 1] >= bb[p]);

			//for (int i = 0; i < p; i++) {
			//	if (aa[i] >= bb[i + 1])
			//		mark[i] = 1;
			//}
			if (pref.size() == 2)
				pref[0] = mark[0];
			else
				pref[p - 1] = pref[p - 2] + mark[p - 1];

			//pref[0] = mark[0];
			//for (int i = 1; i < p; i++)
			//	pref[i] = pref[i - 1] + mark[i];

			int l = -1, r = p + 1;
			while (r - l > 1) {
				int m = (r + l) / 2;
				if (get(pref, m, p - 1) == p - m)
					r = m;
				else
					l = m;
			}
			if (r != p + 1)
				ans = min(ans, -aa[p] + bb[r]);

			cout << sa - sb + ans << " ";
		}
		cout << endl;
		return;
	}
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) 
		solve();
	return 0;
}
