#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <chrono>

using namespace std;
using ll = long long;
using ld = long double;

#define int ll
#define all(x) x.begin(), x.end()
#pragma GCC optimize("Ofast")
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

/*
4
2
3 4
1 2
2
3 4
1 3
3
11 17 14
1 13 10
4
100 11 50 42
30 1 20 5

3
4
2 4 5 12
1 3 4 10
4
3 5 8 20
1 2 6 7
4
4 4 4 4
1 2 3 4
*/

void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (int& i : a)cin >> i;
	for (int& i : b)cin >> i;
	set<ll> s;
	for (int i = 0; i < n; ++i) {
		vector<int> x, y;
		x.reserve(i + 1);
		y.reserve(i + 1);
		for (int j = 0; j <= i; ++j) {
			x.push_back(a[j]);
			y.push_back(b[j]);
		}
		sort(all(x));
		sort(all(y));
		ll mn = 1e18;
		for (int it1 = 0; it1 <= i; ++it1)for (int it2 = 0; it2 <= i; ++it2) {
			ll sum = 0;
			int k1 = 0, k2 = 0;
			for (int j = 0; j <= i - 1; ++j, k1++, k2++) {
				if (k1 == it1)k1++;
				if (k2 == it2)k2++;
				if (x[k1] < y[k2])sum = 1e15;
				sum += x[k1] - y[k2];
			}
			mn = min(mn, sum);
		}
		cout << mn << ' ';
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	cin >> t;

	for (int _ = 0; _ < t; ++_) {
		solve();
	}

}
