#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>

using namespace std;
using ll = long long;

const ll mod = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    for (auto& x : a) {
        cin >> x;
    }
    for (auto& x : b) {
        cin >> x;
    }
    multiset<int> s1;
    multiset<int> s2;
    int cur = 0;
    for (int i = 0; i < n; i++) {
        s1.insert(a[i]);
        s2.insert(b[i]);
        cur += a[i] - b[i];
        vector<int> new1;
        vector<int> new2;
        for (auto x : s1) new1.push_back(x);
        for (auto x : s2) new2.push_back(x);
        int ans = cur;
        int last = 0;
        for (int j = 0; j <= i; j++) {
            ans = min(ans, cur - (new1[j] - new2[last]));
            if (j + 1 <= i) {
                if (new1[j] < new2[j + 1]) {
                    last = j + 1;
                }
            }
        }
        cout << ans << "\n";
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}