#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void dfsc(int v, vector<bool> &used, vector<set<int>> &g) {
    used[v] = true;

    for (int i : g[v]) {
        if (!used[i]) {
            dfsc(i, used, g);
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        int n;
        cin >> n;

        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }

        vector<int> b(n);
        for (int i = 0; i < n; i++) {
            cin >> b[i];
        }

        ll sum = 0;
        set<int> x, y;
        vector<int> nxt(n);
        for (int i = 0; i < n; i++) {
            x.insert(a[i]);
            y.insert(b[i]);
            sum += a[i] - b[i];

            for (int j = 0; j <= i; j++) {
                if (a[j] >= b[i]) {
                    nxt[j] = i;
                }
            }

            ll lol = LONG_LONG_MAX;
            for (int j = 0; j <= i; j++) {
                lol = min(lol, sum + b[j] - a[nxt[j]]);
            }

            cout << lol << ' ';
        }
        cout << '\n';
    }

    return 0;
}
