#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        int n;
        cin >> n;

        vector<ll> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }

        vector<ll> b(n);
        for (int i = 0; i < n; i++) {
            cin >> b[i];
        }

        vector<vector<int>> g(n);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (i == j) {
                    continue;
                }

                if (a[j] >= b[i] && b[j] <= a[i]) {
                    g[i].push_back(j);
                }
            }
        }

        ll sum = 0;
        set<ll> st, x, y;
        vector<bool> used(n, false);
        for (int i = 0; i < n; i++) {
            sum += a[i] - b[i];
            st.insert(b[i] - a[i]);

            for (int v : g[i]) {
                if (!used[v]) {
                    used[v] = true;
                    x.insert(a[v]);
                    y.insert(b[v]);
                }
            }

            ll ans = sum + *st.begin();
            if (!x.empty()) {
                ans = min(ans, sum + *y.begin() - *x.rbegin());
            }
            cout << ans << ' ';
        }
        cout << '\n';
    }

    return 0;
}
