#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <iomanip>
#include <numeric>
#include <fstream>
#include <unordered_map>
#include <random>

using namespace std;

#define int long long

void solve();


signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif


	solve();
}

using ll = long long;
using pint = pair<int, int>;

random_device rd;
mt19937 rnd(rd());

void solve() {
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
		}
		vector<int> b(n);
		for (int i = 0; i < n; i++) {
			cin >> b[i];
		}

		bool isg4 = true;
		bool isg5 = true;
		for (int i = 0; i < n - 1; i++) {
			if (a[i] >= b[i + 1]) isg4 = false;
			if (i > 0 && (a[i] < a[i - 1] || b[i] < b[i - 1])) isg5 = false;
		}

		if (isg4 || isg5) {
			int ans = 0;
			int mx = 0;
			for (int i = 0; i < n; i++) {
				mx = max(mx, a[i] - b[i]);
				ans += a[i] - b[i];
				cout << ans - mx << ' ';
			}
			cout << '\n';
			continue;
		}

		multiset<int> cura, curb;
		for (int i = 0; i < n; i++) {
			int ans = 0;
			cura.insert(a[i]);
			curb.insert(b[i]);
			multiset<int> ca = cura, cb = curb;
			while (ca.size() >= 2) {
				auto pos1 = (--cb.end());
				auto f1 = ca.lower_bound(*pos1);
				auto pos2 = (--(--cb.end()));
				auto f2 = ca.lower_bound(*pos2);
				if (*f2 - *pos2 < *f1 - *pos1) {
					ans += *f2 - *pos2;
					ca.erase(f2);
					cb.erase(pos2);
				}
				else {
					ans += *f1 - *pos1;
					ca.erase(f1);
					cb.erase(pos1);
				}
			}

			cout << ans << ' ';
		}
		cout << '\n';
	}
}