#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

using ll = long long;
using lll = __int128_t;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using dui = pair<int, int>;
using dul = pair<long, long>;
using vi = vector<int>;
using vll = vector<long long>;
using ld = long double;

constexpr int MX = 2'000'000'000;
constexpr long long MXL = 4'000'000'000'000'000'000;

struct segtree_min {
    vi t;
    int n;

    segtree_min(int _n, vi &a) {
        n = _n;
        t.resize(n * 4);
        build(a, 0, n);
    }

    void build(vi &a, int l, int r, int p = 0) {
        if (l + 1 == r) {
            t[p] = a[l];
            return;
        }
        int m = (r + l) >> 1;
        build(a, l, m, p * 2 + 1);
        build(a, m, r, p * 2 + 2);
    }

    int get(int lx, int rx, int l, int r, int p = 0) {
        if (l >= rx or r <= lx) return MX;
        if (lx <= l and r <= rx) return t[p];
        int m = (r + l) >> 1;
        return min(get(lx, rx, l, m, p * 2 + 1),
                   get(lx, rx, m, r, p * 2 + 2));
    }
};

void solve() {
    int n;
    cin >> n;
    vi a(n), b(n);
    bool Ok = 0;
    for (auto &i: a) cin >> i;
    for (auto &i: b) cin >> i;
    Ok = is_sorted(a.begin(), a.end()) and is_sorted(b.begin(),b.end());
    cout << 0 << ' ';
    vi sa, sb;
    ll suma = a[0], sumb = b[0];
    sa.push_back(a[0]), sb.push_back(b[0]);
    int Mx = a[0] - b[0];
    if (Ok) {
        bool ok = 0;
        int cur = 0;
        int mx = 0;
        for (int j=0;j<a.size() - 1; j++) {
            suma += a[j + 1], sumb += b[j + 1];
            if (a[j] >= sb[j + 1]) {
                if (!ok)
                    cur = sb[j];
                ok = 1;
            }
            else {
                if (ok) {
                    mx = max(mx, a[j] - cur);
                }
                ok = 0;
            }
            mx = max(mx, a[j] - b[j]);
            mx = max(mx, a[j + 1] - b[j + 1]);
            if (ok) {
                mx = max(mx, a[j + 1] - cur);
            }
            cout << suma - sumb - mx << ' ';
        }
        cout << '\n';
        return;
    }
    for (int i = 1; i < n; i++) {
        suma += a[i], sumb += b[i];
        sa.push_back(a[i]), sb.push_back(b[i]);
        sort(sa.begin(), sa.end());
        sort(sb.begin(),sb.end());
        bool ok = 0;
        int cur = 0;
        int mx = 0;
        for (int j=0;j<sa.size() - 1; j++) {
            if (sa[j] >= sb[j + 1]) {
                if (!ok)
                    cur = sb[j];
                ok = 1;
            }
            else {
                if (ok) {
                    mx = max(mx, sa[j] - cur);
                }
                ok = 0;
            }
            mx = max(mx, sa[j] - sb[j]);
        }
        mx = max(mx, *prev(sa.end()) - *prev(sb.end()));
        if (ok) {
            mx = max(mx, *prev(sa.end()) - cur);
        }
        cout << suma - sumb - mx << ' ';
    }
    cout << '\n';
}

int32_t main() {
#ifdef LOCAL
    freopen("inputf.txt", "r", stdin);
    freopen("outputf.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
