#pragma gcc optimize("O3, unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
// #define int ll
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll mod = 1000000007;
const ll inf = 1e18;
const int mxn = 1e9 + 7;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define debug(a) cerr << a << endl;
#define vout(a) for (auto ug : a) {cout << ug << ' ';}; cout << endl;

struct node {
    int mi = 0, add = 0, ind1 = 0, ind2 = 0, val = 0, l = -1, r = -1;
};

const int N = 5e6;
node t[N];
int curr = 1;

inline void init () {
    // t.emplace_back();
    t[0].ind1 = 0; t[0].ind2 = mxn - 1;
    t[0].val = 1;
}

inline void build (int x, int lx, int rx) {
    t[x].ind1 = lx; t[x].ind2 = rx - 1;
    if (rx - lx > 1) t[x].val = 1;
}

inline void push (int x, int lx, int rx) {
    if (rx - lx == 1 || !t[x].add) return;
    t[t[x].l].mi += t[x].add; t[t[x].r].mi += t[x].add;
    t[t[x].l].add += t[x].add; t[t[x].r].add += t[x].add;
    t[x].add = 0;
}

inline void update (int l, int r, int v, int x, int lx, int rx) {
    if (lx >= r || l >= rx) return;
    if (lx >= l && rx <= r) {
        t[x].mi += v; t[x].add += v;
        return;
    }
    int m = (lx + rx) >> 1;
    if (t[x].l == -1) {
        t[x].l = curr++;
        // t.emplace_back();
        build(t[x].l, lx, m);
    }
    if (t[x].r == -1) {
        t[x].r = curr++;
        // t.emplace_back();
        build(t[x].r, m, rx);
    }
    push(x, lx, rx);
    update(l, r, v, t[x].l, lx, m); update(l, r, v, t[x].r, m, rx);
    t[x].mi = min(t[t[x].l].mi, t[t[x].r].mi);
    if (t[t[x].l].mi == t[t[x].r].mi) {
        t[x].val = max(max(t[t[x].l].val, t[t[x].r].val), t[t[x].r].ind1 - t[t[x].l].ind2);
        t[x].ind2 = t[t[x].r].ind2;
        t[x].ind1 = t[t[x].l].ind1;
    }
    else if (t[t[x].l].mi < t[t[x].r].mi) {
        t[x].val = t[t[x].l].val;
        t[x].mi = t[t[x].l].mi;
        t[x].ind1 = t[t[x].l].ind1;
        t[x].ind2 = t[t[x].l].ind2;
    }
    else {
        t[x].val = t[t[x].r].val;
        t[x].mi = t[t[x].r].mi;
        t[x].ind1 = t[t[x].r].ind1;
        t[x].ind2 = t[t[x].r].ind2;
    }
}

inline void solve() {
    int n; cin >> n;
    vector <ll> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    init();
    vector <ll> ans(n, 0);
    ll s1 = 0, s2 = 0;
    for (int i = 0; i < n; ++i) {
        s1 += a[i]; s2 += b[i];
        update(b[i], mxn, 1, 0, 0, mxn);
        update(a[i], mxn, -1, 0, 0, mxn);
        ans[i] = s1 - s2 - t[0].val + 1;
    }
    vout(ans);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1; cin >> tt;
    while (tt--) solve();
}