#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;

const ll OO = 1e18;

void solve() {
    int n;
    cin >> n;
    vec<int> a(n + 1), b(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> b[i];
    }

    if (n <= 3000) {
        int A = 0, B = 0;
        vec<int> c(n + 2);

        for (int i = 1; i <= n; i++) {
            A += a[i];
            B += b[i];
            sort(a.begin() + 1, a.begin() + i + 1);
            sort(b.begin() + 1, b.begin() + i + 1);
            for (int j = i; j >= 1; j--) {
                c[j] = j;
                if (j < i && a[j] >= b[j + 1]) {
                    c[j] = c[j + 1];
                }
            }

            int maxi = 0;
            for (int p1 = 1; p1 <= i; p1++) {
                for (int p2 = p1; p2 >= 1; p2--) {
                    if (c[p2] < p1) break;
                    if (a[p1] < b[p2]) continue;

                    maxi = max(maxi, a[p1] - b[p2]);
                }
            }

            cout << (A - B) - maxi << ' ';
        }
        cout << '\n';

        return;
    }

    int A = 0, B = 0;
    int maxi = -OO;
    for (int i = 1; i <= n; i++) {
        A += a[i];
        B += b[i];
        maxi = max(maxi, a[i] - b[i]);

        cout << (A - B) - maxi << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--)
        solve();

    return 0;
}
