#include <iostream>
#include <set>
using namespace std;
using ll = long long;

const int INF = 1e9 + 177013;
const int MAXN = 2e5 + 123;
int a[MAXN];
ll psma[MAXN];
int b[MAXN];
ll psmb[MAXN];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int j = 0; j < n; ++j)
        cin >> b[j];
    for (int i = 0; i < n; ++i)
        psma[i] = (i > 0 ? psma[i - 1] : 0) + a[i];
    for (int i = 0; i < n; ++i)
        psmb[i] = (i > 0 ? psmb[i - 1] : 0) + b[i];
    multiset<int> sta;
    multiset<int> stb;
    for (int i = 0; i < n; ++i) {
        ll ans = psma[i] - psmb[i] - a[i] + b[i];
        sta.insert(a[i]);
        stb.insert(b[i]);
        int minbdel = *stb.begin();
        auto bit = stb.begin();
        for (auto avl : sta) {
            ans = min(ans, psma[i] - psmb[i] - avl + minbdel);
            bit = next(bit);
            if (bit != stb.end() && *bit > avl) {
                minbdel = *bit;
            }
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
