﻿#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<ll> a(n), b(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> b[i];
        }
        ll s = 0;
        for (int i = 0; i < n; ++i) {
            s += a[i] - b[i];
            sort(a.begin(), a.begin() + i + 1);
            sort(b.begin(), b.begin() + i + 1);
            vector<int> nw(i + 1);
            for (int j = 0; j <= i; ++j) {
                if (j > 0) {
                    nw[j] = nw[j - 1];
                }
                while (nw[j] < i + 1 && a[j] >= b[nw[j]]) {
                    ++nw[j];
                }
                if (j > 0) {
                    nw[j] -= 1;
                }
            }
            ll x = 0, p = 0;
            for (int j = 0; j <= i; ++j) {
                while (p < i && nw[p] - (a[p] >= b[j]) > 0) {
                    ++p;
                }
                x = max(x, a[p] - b[j]);
            }
            cout << s - x << ' ';
        }
        cout << '\n';
    }

    return 0;
}