#include <iostream>
#include <vector>
#include <iomanip>
#include <set>
#include <algorithm>
#include <map>
using namespace std;
using ll = long long;
const ll INF = 1e9;

void solve() {
	int n;
	cin >> n;
	vector<ll>d(n + 1), l(n + 1), r(n + 1);
	for (int i = 1; i <= n; ++i) {
		cin >> d[i];
	}
	for (int i = 1; i <= n; ++i) {
		cin >> l[i];
	}
	for (int i = 1; i <= n; ++i) {
		cin >> r[i];
	}
	ll a0, b0;
	cin >> a0 >> b0;
	if (n <= 15) {
		ll ans = 0;
		for (int i = 0; i < (1 << n); ++i) {
			ll a = a0, b = b0;
			for (int j = 0; j < n; ++j) {
				a += d[j + 1];
				b += d[j + 1];
				if ((i >> j) & 1) {
					a = min(a, l[j + 1]);
				}
				else {
					b = min(b, r[j + 1]);
				}
			}
			ans = max(ans, a + b);
		}
		cout << ans << "\n";
	}
	l[0] = a0;
	r[0] = b0;
	vector<vector<pair<ll,ll>>>dp(n + 1, vector<pair<ll,ll>>(2));
	dp[0][0] = dp[0][1] = { a0, b0 };
	for (int i = 1; i <= n; ++i) {
		ll b = r[i];
		ll a = l[i];
		for (int j = i - 1; j >= 0; --j) {
			if (dp[i][0].first + dp[i][0].second < dp[j][1].first + min(b, dp[j][1].second)) {
				dp[i][0] = { dp[j][1].first , min(b, dp[j][1].second) };
			}
			b = min(b, r[j]);
			if (dp[i][1].first + dp[i][1].second < dp[j][0].second + min(a, dp[j][0].first)) {
				dp[i][1] = { min(a, dp[j][0].first), dp[j][0].second };
			}
			a = min(a, l[j]);
		}
	}
	/*for (auto x : dp) {
		cout << x[0].first << ' ' << x[0].second << "   " << x[1].first << ' ' << x[1].second << "\n";
	}*/
	cout << max(dp[n][0].first + dp[n][0].second, dp[n][1].first + dp[n][1].second);
	
	
}

int main() {
	ll t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}


}