#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll inf = 1e18;

void solve() {
    int n;
    cin >> n;
    
    vector<int> a(n), b(n);
    for (auto &i : a) cin >> i;
    for (auto &i : b) cin >> i;
    
    if (is_sorted(a.begin(), a.end()) && is_sorted(b.begin(), b.end())) {
        ll ans = 0, cur = 0;
        ll prefa = 0, prefb = 0;
        for (int k = 1; k <= n; k++) {
            if (k - 2 >= 0 && a[k - 2] >= b[k - 1]) {
                cur += a[k - 2] - b[k - 1];
            } else {
                cur = prefa - prefb;
            }
            ans = min(ans + (a[k - 1] - b[k - 1]), cur);
            prefa += a[k - 1];
            prefb += b[k - 1];
            cout << ans << ' ';
        }
        cout << '\n';
        return; 
    }
    
    vector<int> sa, sb;
    for (int k = 1; k <= n; k++) {
        sa.push_back(a[k - 1]);
        for (int i = k - 2; i >= 0; i--) {
            if (sa[i] > sa[i + 1]) {
                swap(sa[i], sa[i + 1]);
            }
        }
        sb.push_back(b[k - 1]);
        for (int i = k - 2; i >= 0; i--) {
            if (sb[i] > sb[i + 1]) {
                swap(sb[i], sb[i + 1]);
            }
        }
        ll prefa = 0, sufa = 0;
        for (int i = 0; i < k; i++) {
            sufa += sa[i];
        }
        ll prefb = 0, sufb = 0;
        for (int i = 0; i < k; i++) {
            sufb += sb[i];
        }
        ll ans = inf, cur = 0;
        for (int i = 0; i < k; i++) {
            sufa -= sa[i];
            sufb -= sb[i];
            ans = min(ans, cur + (sufa - sufb));
            prefa += sa[i];
            prefb += sb[i];
            if (i + 1 < k && sa[i] >= sb[i + 1]) {
                cur += sa[i] - sb[i + 1];
            } else {
                cur = prefa - prefb;
            }
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin.tie(0)->sync_with_stdio(0);
    
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    
    return 0;
}