#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int32_t main() {
#ifdef LOCAL
    freopen("D:\\input.txt", "r", stdin);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<ll> a(n), b(n);
        cin >> a >> b;
        auto get = [&](vector<ll> a, vector<ll> b) {
            sort(a.begin(), a.end());
            ll ans = infll;
            for (int i = 0; i < a.size(); ++i) {
                for (int j = 0; j < b.size(); ++j) {
                    set<int> s;
                    for (int k = 0; k < b.size(); ++k) {
                        if (k != j) {
                            s.insert(b[k]);
                        }
                    }
                    ll cur = 0;
                    for (int k = 0; k < a.size(); ++k) {
                        if (k != i) {
                            auto it = s.upper_bound(a[k]);
                            if (it == s.begin()) {
                                cur = inf;
                                break;
                            }
                            --it;
                            cur += a[k] - *it;
                            s.erase(it);
                        }
                    }
                    ans = min(ans, cur);
                }
            }
            return ans;
        };
        vector<ll> p, q;
        for (int i = 0; i < n; ++i) {
            p.push_back(a[i]);
            q.push_back(b[i]);
            cout << get(p, q) << " ";
        }
        cout << "\n";
    }
    return 0;
}