//#pragma GCC optimize("03")
//#pragma GCC target("avx,avx2,sse3,ssse3,sse4.2,popcnt,fma,bmi,tune=native")
#include <bits/extc++.h>

using i64 = long long;

template<class Info>
using ordered_set = __gnu_pbds::tree<Info, __gnu_pbds::null_type, std::less<Info>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

i64 solve(std::vector<int> a, std::vector<int> b) {
    std::sort(a.begin(), a.end());
    std::sort(b.begin(), b.end());
    i64 base = std::accumulate(a.begin(), a.end(), 0LL) - std::accumulate(b.begin(), b.end(), 0LL);
    int max = 0;
    int n = a.size();
    for (int i = 0; i < n; i++) {
        max = std::max(max, a[i] - b[i]);
    }
    i64 res = base - max;
    for (int i = 0; i < n; i++) {
        bool breaked = false;
        for (int cnt = 0; i + 1 + cnt < n; cnt++) {
            if (b[i + 1 + cnt] > a[i + cnt]) {
                res = std::min(res, base - a[i + cnt] + b[i]);
                breaked = true;
                break;
            }
        }
        if (!breaked) {
            res = std::min(res, base - a[n - 1] + b[i]);
        }
    }
    return res;
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        std::cin >> b[i];
    }
    std::vector<int> a_, b_;
    for (int p = 0; p < n; p++) {
        a_.emplace_back(a[p]);
        b_.emplace_back(b[p]);
        std::cout << solve(a_, b_) << " \n"[p == n - 1];
    }
}

signed main() {
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);

    short t = 1;
    std::cin >> t;

    while (t--) {
        solve();
    }
}