#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 10;

void test_case() {
    int n;
    cin >> n;
    int a[n], b[n];
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++)
        cin >> b[i];

    set<pair<int, int>> st;
    set<pair<int, pair<int, int>>> mx_len; 

    long long sum = 0;
    
    auto update = [&](int a, int b) {
        if (st.empty()) {
            st.insert({b, a});
            mx_len.insert({a - b, {b, a}});
        }
        else {
            auto rb = st.upper_bound({b, INF});
            auto lb = rb; lb--;
            if (rb != st.begin() && lb->first <= b && lb->second >= a) 
                return;
            if (rb != st.begin() && lb->second >= b) {
                b = lb->first;
                st.erase(lb);
                mx_len.erase({lb->second - lb->first, *lb});
            }
            while (rb != st.end() && rb->first <= a) {
                a = max(a, rb->second);
                st.erase(rb);
                mx_len.erase({rb->second - rb->first, *rb});
                rb = st.upper_bound({b, INF});
            }
            st.insert({b, a});
            mx_len.insert({a - b, {b, a}});
        }
    };

    for (int i = 0; i < n; i++) {
        sum += a[i] - b[i]; 
        update(a[i], b[i]);
        cout << sum - (--mx_len.end())->first << ' ';
    }
}
//  3
//  4
//  2 4 5 12
//  1 3 4 10
//  4
//  3 5 8 20
//  1 2 6 7
//  4
//  4 4 4 4
//  1 2 3 4
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        test_case();
        cout << '\n';
    }   
}