//#pragma target("avx,avx2,bmi,bmi2,lzcnt,popcnt")
//#pragma optimize("unroll-loops,O3")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
const int INF = INT_MAX;
const ld PI = atan2(0, -1);
mt19937_64 rnd(179);

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int &i: a) cin >> i;
    for (int &i: b) cin >> i;
    ll sm1 = 0, sm2 = 0;

    if (n <= 3000) {
        for (int i = 0; i < n; i++) {
            sm1 += a[i];
            sm2 += b[i];
            ll ans = sm1 - sm2;
            vector<int> d;
            for (int j = 0; j <= i; j++) d.push_back(b[j]);
            sort(d.begin(), d.end());
            vector<int> pr(i + 1, 0);
            for (int j = 0; j <= i; j++) {
                int ind = upper_bound(d.begin(), d.end(), a[j]) - d.begin();
                pr[ind - 1]++;
            }
            pr[i]--;
            for (int j = i - 1; j >= 0; j--) pr[j] += pr[j + 1] - 1;
//            for (int j = 0; j <= i; j++) pr[i - j] -= j + 1;

            vector<int> c;
            for (int j = 0; j <= i; j++) c.push_back(a[j]);
            sort(c.begin(), c.end());

            int last = i;
            for (int j = i; j >= 0; j--) {
                if (pr[j]) continue;
//            cout << "rec " << i + 1 << "  " <<  last << " " << j << "  " << c[last] - d[j] << endl;
                ans = min(ans, sm1 - sm2 - c[last] + d[j]);
                last = j - 1;
            }
            cout << ans << " ";
        }
    } else {
        for (int i = 0; i < n; i++) {
            sm1 += a[i];
            sm2 += b[i];
            cout << sm1 - sm2 - a[i] + b[i] << " ";
        }
    }


    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}