//#pragma target("avx,avx2,bmi,bmi2,lzcnt,popcnt")
//#pragma optimize("unroll-loops,O3")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using uint = unsigned int;
const int INF = INT_MAX;
const ld PI = atan2(0, -1);
mt19937_64 rnd(179);

int smN = 0;

void solve() {
    int n;
    cin >> n;
    smN += n;
    vector<int> a(n), b(n);
    for (int &i: a) cin >> i;
    for (int &i: b) cin >> i;
    ll sm1 = 0, sm2 = 0;

    if (smN <= 3000) {
        vector<int> d, c;
        for (int i = 0; i < n; i++) {
            sm1 += a[i];
            sm2 += b[i];
            ll ans = sm1 - sm2;
            d.push_back(b[i]);
            sort(d.begin(), d.end());
            vector<int> pr(i + 1, 0);
            for (int j = 0; j <= i; j++) {
                int ind = upper_bound(d.begin(), d.end(), a[j]) - d.begin();
                pr[ind - 1]++;
            }
            pr[i]--;
            for (int j = i - 1; j >= 0; j--) pr[j] += pr[j + 1] - 1;
//            for (int j = 0; j <= i; j++) pr[i - j] -= j + 1;

            c.push_back(a[i]);
            sort(c.begin(), c.end());

            int last = i;
            for (int j = i; j >= 0; j--) {
                if (pr[j]) continue;
//            cout << "rec " << i + 1 << "  " <<  last << " " << j << "  " << c[last] - d[j] << endl;
                ans = min(ans, sm1 - sm2 - c[last] + d[j]);
                last = j - 1;
            }
            cout << ans << " ";
        }
        return;
    }
    bool check = true;
    for (int i = 0; i < n - 1; i++) if (a[i] >= b[i + 1]) check = false;
    if (check) {
        int maxDif = 0;
        for (int i = 0; i < n; i++) {
            sm1 += a[i];
            sm2 += b[i];
            maxDif = max(maxDif, a[i] - b[i]);
            cout << sm1 - sm2 - maxDif << " ";
        }
    }

    int ind = 0;
    sm1 = a[0];
    sm2 = b[0];
    int mDif = a[0] - b[0];
    cout << 0 << " ";
    for (int i = 1; i < n; i++) {
        if (b[i] > a[i - 1]) {
            ind = i;
        }
        mDif = max(mDif, a[i] - b[ind]);
        cout << sm1 - sm2 - mDif << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);

    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}